module and_(
  input   clock,
  input   reset,
  input   io_in_0,
  output  io_out
);
  assign io_out = io_in_0; // @[adder.scala 78:16]
endmodule
module and_2(
  input   clock,
  input   reset,
  input   io_in_0,
  input   io_in_1,
  output  io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  and__clock; // @[adder.scala 66:32]
  wire  and__reset; // @[adder.scala 66:32]
  wire  and__io_in_0; // @[adder.scala 66:32]
  wire  and__io_out; // @[adder.scala 66:32]
  wire  and_1_clock; // @[adder.scala 67:32]
  wire  and_1_reset; // @[adder.scala 67:32]
  wire  and_1_io_in_0; // @[adder.scala 67:32]
  wire  and_1_io_out; // @[adder.scala 67:32]
  reg  _T; // @[adder.scala 72:26]
  wire  _T_1 = and__io_out & and_1_io_out; // @[adder.scala 73:34]
  and_ and_ ( // @[adder.scala 66:32]
    .clock(and__clock),
    .reset(and__reset),
    .io_in_0(and__io_in_0),
    .io_out(and__io_out)
  );
  and_ and_1 ( // @[adder.scala 67:32]
    .clock(and_1_clock),
    .reset(and_1_reset),
    .io_in_0(and_1_io_in_0),
    .io_out(and_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 75:16]
  assign and__clock = clock;
  assign and__reset = reset;
  assign and__io_in_0 = io_in_0; // @[adder.scala 69:33]
  assign and_1_clock = clock;
  assign and_1_reset = reset;
  assign and_1_io_in_0 = io_in_1; // @[adder.scala 70:33]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 1'h0;
    end else begin
      _T <= _T_1;
    end
  end
endmodule
module and_6(
  input   clock,
  input   reset,
  input   io_in_0,
  input   io_in_1,
  input   io_in_2,
  input   io_in_3,
  output  io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  and__clock; // @[adder.scala 66:32]
  wire  and__reset; // @[adder.scala 66:32]
  wire  and__io_in_0; // @[adder.scala 66:32]
  wire  and__io_in_1; // @[adder.scala 66:32]
  wire  and__io_out; // @[adder.scala 66:32]
  wire  and_1_clock; // @[adder.scala 67:32]
  wire  and_1_reset; // @[adder.scala 67:32]
  wire  and_1_io_in_0; // @[adder.scala 67:32]
  wire  and_1_io_in_1; // @[adder.scala 67:32]
  wire  and_1_io_out; // @[adder.scala 67:32]
  reg  _T; // @[adder.scala 72:26]
  wire  _T_1 = and__io_out & and_1_io_out; // @[adder.scala 73:34]
  and_2 and_ ( // @[adder.scala 66:32]
    .clock(and__clock),
    .reset(and__reset),
    .io_in_0(and__io_in_0),
    .io_in_1(and__io_in_1),
    .io_out(and__io_out)
  );
  and_2 and_1 ( // @[adder.scala 67:32]
    .clock(and_1_clock),
    .reset(and_1_reset),
    .io_in_0(and_1_io_in_0),
    .io_in_1(and_1_io_in_1),
    .io_out(and_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 75:16]
  assign and__clock = clock;
  assign and__reset = reset;
  assign and__io_in_0 = io_in_0; // @[adder.scala 69:33]
  assign and__io_in_1 = io_in_1; // @[adder.scala 69:33]
  assign and_1_clock = clock;
  assign and_1_reset = reset;
  assign and_1_io_in_0 = io_in_2; // @[adder.scala 70:33]
  assign and_1_io_in_1 = io_in_3; // @[adder.scala 70:33]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 1'h0;
    end else begin
      _T <= _T_1;
    end
  end
endmodule
module and_14(
  input   clock,
  input   reset,
  input   io_in_0,
  input   io_in_1,
  input   io_in_2,
  input   io_in_3,
  input   io_in_4,
  input   io_in_5,
  input   io_in_6,
  input   io_in_7,
  output  io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  and__clock; // @[adder.scala 66:32]
  wire  and__reset; // @[adder.scala 66:32]
  wire  and__io_in_0; // @[adder.scala 66:32]
  wire  and__io_in_1; // @[adder.scala 66:32]
  wire  and__io_in_2; // @[adder.scala 66:32]
  wire  and__io_in_3; // @[adder.scala 66:32]
  wire  and__io_out; // @[adder.scala 66:32]
  wire  and_1_clock; // @[adder.scala 67:32]
  wire  and_1_reset; // @[adder.scala 67:32]
  wire  and_1_io_in_0; // @[adder.scala 67:32]
  wire  and_1_io_in_1; // @[adder.scala 67:32]
  wire  and_1_io_in_2; // @[adder.scala 67:32]
  wire  and_1_io_in_3; // @[adder.scala 67:32]
  wire  and_1_io_out; // @[adder.scala 67:32]
  reg  _T; // @[adder.scala 72:26]
  wire  _T_1 = and__io_out & and_1_io_out; // @[adder.scala 73:34]
  and_6 and_ ( // @[adder.scala 66:32]
    .clock(and__clock),
    .reset(and__reset),
    .io_in_0(and__io_in_0),
    .io_in_1(and__io_in_1),
    .io_in_2(and__io_in_2),
    .io_in_3(and__io_in_3),
    .io_out(and__io_out)
  );
  and_6 and_1 ( // @[adder.scala 67:32]
    .clock(and_1_clock),
    .reset(and_1_reset),
    .io_in_0(and_1_io_in_0),
    .io_in_1(and_1_io_in_1),
    .io_in_2(and_1_io_in_2),
    .io_in_3(and_1_io_in_3),
    .io_out(and_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 75:16]
  assign and__clock = clock;
  assign and__reset = reset;
  assign and__io_in_0 = io_in_0; // @[adder.scala 69:33]
  assign and__io_in_1 = io_in_1; // @[adder.scala 69:33]
  assign and__io_in_2 = io_in_2; // @[adder.scala 69:33]
  assign and__io_in_3 = io_in_3; // @[adder.scala 69:33]
  assign and_1_clock = clock;
  assign and_1_reset = reset;
  assign and_1_io_in_0 = io_in_4; // @[adder.scala 70:33]
  assign and_1_io_in_1 = io_in_5; // @[adder.scala 70:33]
  assign and_1_io_in_2 = io_in_6; // @[adder.scala 70:33]
  assign and_1_io_in_3 = io_in_7; // @[adder.scala 70:33]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 1'h0;
    end else begin
      _T <= _T_1;
    end
  end
endmodule
module and_30(
  input   clock,
  input   reset,
  input   io_in_0,
  input   io_in_1,
  input   io_in_2,
  input   io_in_3,
  input   io_in_4,
  input   io_in_5,
  input   io_in_6,
  input   io_in_7,
  input   io_in_8,
  input   io_in_9,
  input   io_in_10,
  input   io_in_11,
  input   io_in_12,
  input   io_in_13,
  input   io_in_14,
  input   io_in_15,
  output  io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  and__clock; // @[adder.scala 66:32]
  wire  and__reset; // @[adder.scala 66:32]
  wire  and__io_in_0; // @[adder.scala 66:32]
  wire  and__io_in_1; // @[adder.scala 66:32]
  wire  and__io_in_2; // @[adder.scala 66:32]
  wire  and__io_in_3; // @[adder.scala 66:32]
  wire  and__io_in_4; // @[adder.scala 66:32]
  wire  and__io_in_5; // @[adder.scala 66:32]
  wire  and__io_in_6; // @[adder.scala 66:32]
  wire  and__io_in_7; // @[adder.scala 66:32]
  wire  and__io_out; // @[adder.scala 66:32]
  wire  and_1_clock; // @[adder.scala 67:32]
  wire  and_1_reset; // @[adder.scala 67:32]
  wire  and_1_io_in_0; // @[adder.scala 67:32]
  wire  and_1_io_in_1; // @[adder.scala 67:32]
  wire  and_1_io_in_2; // @[adder.scala 67:32]
  wire  and_1_io_in_3; // @[adder.scala 67:32]
  wire  and_1_io_in_4; // @[adder.scala 67:32]
  wire  and_1_io_in_5; // @[adder.scala 67:32]
  wire  and_1_io_in_6; // @[adder.scala 67:32]
  wire  and_1_io_in_7; // @[adder.scala 67:32]
  wire  and_1_io_out; // @[adder.scala 67:32]
  reg  _T; // @[adder.scala 72:26]
  wire  _T_1 = and__io_out & and_1_io_out; // @[adder.scala 73:34]
  and_14 and_ ( // @[adder.scala 66:32]
    .clock(and__clock),
    .reset(and__reset),
    .io_in_0(and__io_in_0),
    .io_in_1(and__io_in_1),
    .io_in_2(and__io_in_2),
    .io_in_3(and__io_in_3),
    .io_in_4(and__io_in_4),
    .io_in_5(and__io_in_5),
    .io_in_6(and__io_in_6),
    .io_in_7(and__io_in_7),
    .io_out(and__io_out)
  );
  and_14 and_1 ( // @[adder.scala 67:32]
    .clock(and_1_clock),
    .reset(and_1_reset),
    .io_in_0(and_1_io_in_0),
    .io_in_1(and_1_io_in_1),
    .io_in_2(and_1_io_in_2),
    .io_in_3(and_1_io_in_3),
    .io_in_4(and_1_io_in_4),
    .io_in_5(and_1_io_in_5),
    .io_in_6(and_1_io_in_6),
    .io_in_7(and_1_io_in_7),
    .io_out(and_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 75:16]
  assign and__clock = clock;
  assign and__reset = reset;
  assign and__io_in_0 = io_in_0; // @[adder.scala 69:33]
  assign and__io_in_1 = io_in_1; // @[adder.scala 69:33]
  assign and__io_in_2 = io_in_2; // @[adder.scala 69:33]
  assign and__io_in_3 = io_in_3; // @[adder.scala 69:33]
  assign and__io_in_4 = io_in_4; // @[adder.scala 69:33]
  assign and__io_in_5 = io_in_5; // @[adder.scala 69:33]
  assign and__io_in_6 = io_in_6; // @[adder.scala 69:33]
  assign and__io_in_7 = io_in_7; // @[adder.scala 69:33]
  assign and_1_clock = clock;
  assign and_1_reset = reset;
  assign and_1_io_in_0 = io_in_8; // @[adder.scala 70:33]
  assign and_1_io_in_1 = io_in_9; // @[adder.scala 70:33]
  assign and_1_io_in_2 = io_in_10; // @[adder.scala 70:33]
  assign and_1_io_in_3 = io_in_11; // @[adder.scala 70:33]
  assign and_1_io_in_4 = io_in_12; // @[adder.scala 70:33]
  assign and_1_io_in_5 = io_in_13; // @[adder.scala 70:33]
  assign and_1_io_in_6 = io_in_14; // @[adder.scala 70:33]
  assign and_1_io_in_7 = io_in_15; // @[adder.scala 70:33]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 1'h0;
    end else begin
      _T <= _T_1;
    end
  end
endmodule
module and_62(
  input   clock,
  input   reset,
  input   io_in_0,
  input   io_in_1,
  input   io_in_2,
  input   io_in_3,
  input   io_in_4,
  input   io_in_5,
  input   io_in_6,
  input   io_in_7,
  input   io_in_8,
  input   io_in_9,
  input   io_in_10,
  input   io_in_11,
  input   io_in_12,
  input   io_in_13,
  input   io_in_14,
  input   io_in_15,
  input   io_in_16,
  input   io_in_17,
  input   io_in_18,
  input   io_in_19,
  input   io_in_20,
  input   io_in_21,
  input   io_in_22,
  input   io_in_23,
  input   io_in_24,
  input   io_in_25,
  input   io_in_26,
  input   io_in_27,
  input   io_in_28,
  input   io_in_29,
  input   io_in_30,
  input   io_in_31,
  output  io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  and__clock; // @[adder.scala 66:32]
  wire  and__reset; // @[adder.scala 66:32]
  wire  and__io_in_0; // @[adder.scala 66:32]
  wire  and__io_in_1; // @[adder.scala 66:32]
  wire  and__io_in_2; // @[adder.scala 66:32]
  wire  and__io_in_3; // @[adder.scala 66:32]
  wire  and__io_in_4; // @[adder.scala 66:32]
  wire  and__io_in_5; // @[adder.scala 66:32]
  wire  and__io_in_6; // @[adder.scala 66:32]
  wire  and__io_in_7; // @[adder.scala 66:32]
  wire  and__io_in_8; // @[adder.scala 66:32]
  wire  and__io_in_9; // @[adder.scala 66:32]
  wire  and__io_in_10; // @[adder.scala 66:32]
  wire  and__io_in_11; // @[adder.scala 66:32]
  wire  and__io_in_12; // @[adder.scala 66:32]
  wire  and__io_in_13; // @[adder.scala 66:32]
  wire  and__io_in_14; // @[adder.scala 66:32]
  wire  and__io_in_15; // @[adder.scala 66:32]
  wire  and__io_out; // @[adder.scala 66:32]
  wire  and_1_clock; // @[adder.scala 67:32]
  wire  and_1_reset; // @[adder.scala 67:32]
  wire  and_1_io_in_0; // @[adder.scala 67:32]
  wire  and_1_io_in_1; // @[adder.scala 67:32]
  wire  and_1_io_in_2; // @[adder.scala 67:32]
  wire  and_1_io_in_3; // @[adder.scala 67:32]
  wire  and_1_io_in_4; // @[adder.scala 67:32]
  wire  and_1_io_in_5; // @[adder.scala 67:32]
  wire  and_1_io_in_6; // @[adder.scala 67:32]
  wire  and_1_io_in_7; // @[adder.scala 67:32]
  wire  and_1_io_in_8; // @[adder.scala 67:32]
  wire  and_1_io_in_9; // @[adder.scala 67:32]
  wire  and_1_io_in_10; // @[adder.scala 67:32]
  wire  and_1_io_in_11; // @[adder.scala 67:32]
  wire  and_1_io_in_12; // @[adder.scala 67:32]
  wire  and_1_io_in_13; // @[adder.scala 67:32]
  wire  and_1_io_in_14; // @[adder.scala 67:32]
  wire  and_1_io_in_15; // @[adder.scala 67:32]
  wire  and_1_io_out; // @[adder.scala 67:32]
  reg  _T; // @[adder.scala 72:26]
  wire  _T_1 = and__io_out & and_1_io_out; // @[adder.scala 73:34]
  and_30 and_ ( // @[adder.scala 66:32]
    .clock(and__clock),
    .reset(and__reset),
    .io_in_0(and__io_in_0),
    .io_in_1(and__io_in_1),
    .io_in_2(and__io_in_2),
    .io_in_3(and__io_in_3),
    .io_in_4(and__io_in_4),
    .io_in_5(and__io_in_5),
    .io_in_6(and__io_in_6),
    .io_in_7(and__io_in_7),
    .io_in_8(and__io_in_8),
    .io_in_9(and__io_in_9),
    .io_in_10(and__io_in_10),
    .io_in_11(and__io_in_11),
    .io_in_12(and__io_in_12),
    .io_in_13(and__io_in_13),
    .io_in_14(and__io_in_14),
    .io_in_15(and__io_in_15),
    .io_out(and__io_out)
  );
  and_30 and_1 ( // @[adder.scala 67:32]
    .clock(and_1_clock),
    .reset(and_1_reset),
    .io_in_0(and_1_io_in_0),
    .io_in_1(and_1_io_in_1),
    .io_in_2(and_1_io_in_2),
    .io_in_3(and_1_io_in_3),
    .io_in_4(and_1_io_in_4),
    .io_in_5(and_1_io_in_5),
    .io_in_6(and_1_io_in_6),
    .io_in_7(and_1_io_in_7),
    .io_in_8(and_1_io_in_8),
    .io_in_9(and_1_io_in_9),
    .io_in_10(and_1_io_in_10),
    .io_in_11(and_1_io_in_11),
    .io_in_12(and_1_io_in_12),
    .io_in_13(and_1_io_in_13),
    .io_in_14(and_1_io_in_14),
    .io_in_15(and_1_io_in_15),
    .io_out(and_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 75:16]
  assign and__clock = clock;
  assign and__reset = reset;
  assign and__io_in_0 = io_in_0; // @[adder.scala 69:33]
  assign and__io_in_1 = io_in_1; // @[adder.scala 69:33]
  assign and__io_in_2 = io_in_2; // @[adder.scala 69:33]
  assign and__io_in_3 = io_in_3; // @[adder.scala 69:33]
  assign and__io_in_4 = io_in_4; // @[adder.scala 69:33]
  assign and__io_in_5 = io_in_5; // @[adder.scala 69:33]
  assign and__io_in_6 = io_in_6; // @[adder.scala 69:33]
  assign and__io_in_7 = io_in_7; // @[adder.scala 69:33]
  assign and__io_in_8 = io_in_8; // @[adder.scala 69:33]
  assign and__io_in_9 = io_in_9; // @[adder.scala 69:33]
  assign and__io_in_10 = io_in_10; // @[adder.scala 69:33]
  assign and__io_in_11 = io_in_11; // @[adder.scala 69:33]
  assign and__io_in_12 = io_in_12; // @[adder.scala 69:33]
  assign and__io_in_13 = io_in_13; // @[adder.scala 69:33]
  assign and__io_in_14 = io_in_14; // @[adder.scala 69:33]
  assign and__io_in_15 = io_in_15; // @[adder.scala 69:33]
  assign and_1_clock = clock;
  assign and_1_reset = reset;
  assign and_1_io_in_0 = io_in_16; // @[adder.scala 70:33]
  assign and_1_io_in_1 = io_in_17; // @[adder.scala 70:33]
  assign and_1_io_in_2 = io_in_18; // @[adder.scala 70:33]
  assign and_1_io_in_3 = io_in_19; // @[adder.scala 70:33]
  assign and_1_io_in_4 = io_in_20; // @[adder.scala 70:33]
  assign and_1_io_in_5 = io_in_21; // @[adder.scala 70:33]
  assign and_1_io_in_6 = io_in_22; // @[adder.scala 70:33]
  assign and_1_io_in_7 = io_in_23; // @[adder.scala 70:33]
  assign and_1_io_in_8 = io_in_24; // @[adder.scala 70:33]
  assign and_1_io_in_9 = io_in_25; // @[adder.scala 70:33]
  assign and_1_io_in_10 = io_in_26; // @[adder.scala 70:33]
  assign and_1_io_in_11 = io_in_27; // @[adder.scala 70:33]
  assign and_1_io_in_12 = io_in_28; // @[adder.scala 70:33]
  assign and_1_io_in_13 = io_in_29; // @[adder.scala 70:33]
  assign and_1_io_in_14 = io_in_30; // @[adder.scala 70:33]
  assign and_1_io_in_15 = io_in_31; // @[adder.scala 70:33]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 1'h0;
    end else begin
      _T <= _T_1;
    end
  end
endmodule
module adder(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  output [31:0] io_out
);
  assign io_out = io_in_0; // @[adder.scala 26:16]
endmodule
module adder_2(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  input  [31:0] io_in_1,
  output [31:0] io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  adder_clock; // @[adder.scala 14:34]
  wire  adder_reset; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_0; // @[adder.scala 14:34]
  wire [31:0] adder_io_out; // @[adder.scala 14:34]
  wire  adder_1_clock; // @[adder.scala 15:34]
  wire  adder_1_reset; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_0; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_out; // @[adder.scala 15:34]
  reg [31:0] _T; // @[adder.scala 20:26]
  wire [32:0] _T_1 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  wire [31:0] _T_2 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  adder adder ( // @[adder.scala 14:34]
    .clock(adder_clock),
    .reset(adder_reset),
    .io_in_0(adder_io_in_0),
    .io_out(adder_io_out)
  );
  adder adder_1 ( // @[adder.scala 15:34]
    .clock(adder_1_clock),
    .reset(adder_1_reset),
    .io_in_0(adder_1_io_in_0),
    .io_out(adder_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 23:16]
  assign adder_clock = clock;
  assign adder_reset = reset;
  assign adder_io_in_0 = io_in_0; // @[adder.scala 17:35]
  assign adder_1_clock = clock;
  assign adder_1_reset = reset;
  assign adder_1_io_in_0 = io_in_1; // @[adder.scala 18:35]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 32'h0;
    end else begin
      _T <= _T_2;
    end
  end
endmodule
module adder_6(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  input  [31:0] io_in_1,
  input  [31:0] io_in_2,
  input  [31:0] io_in_3,
  output [31:0] io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  adder_clock; // @[adder.scala 14:34]
  wire  adder_reset; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_0; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_1; // @[adder.scala 14:34]
  wire [31:0] adder_io_out; // @[adder.scala 14:34]
  wire  adder_1_clock; // @[adder.scala 15:34]
  wire  adder_1_reset; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_0; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_1; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_out; // @[adder.scala 15:34]
  reg [31:0] _T; // @[adder.scala 20:26]
  wire [32:0] _T_1 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  wire [31:0] _T_2 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  adder_2 adder ( // @[adder.scala 14:34]
    .clock(adder_clock),
    .reset(adder_reset),
    .io_in_0(adder_io_in_0),
    .io_in_1(adder_io_in_1),
    .io_out(adder_io_out)
  );
  adder_2 adder_1 ( // @[adder.scala 15:34]
    .clock(adder_1_clock),
    .reset(adder_1_reset),
    .io_in_0(adder_1_io_in_0),
    .io_in_1(adder_1_io_in_1),
    .io_out(adder_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 23:16]
  assign adder_clock = clock;
  assign adder_reset = reset;
  assign adder_io_in_0 = io_in_0; // @[adder.scala 17:35]
  assign adder_io_in_1 = io_in_1; // @[adder.scala 17:35]
  assign adder_1_clock = clock;
  assign adder_1_reset = reset;
  assign adder_1_io_in_0 = io_in_2; // @[adder.scala 18:35]
  assign adder_1_io_in_1 = io_in_3; // @[adder.scala 18:35]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 32'h0;
    end else begin
      _T <= _T_2;
    end
  end
endmodule
module adder_14(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  input  [31:0] io_in_1,
  input  [31:0] io_in_2,
  input  [31:0] io_in_3,
  input  [31:0] io_in_4,
  input  [31:0] io_in_5,
  input  [31:0] io_in_6,
  input  [31:0] io_in_7,
  output [31:0] io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  adder_clock; // @[adder.scala 14:34]
  wire  adder_reset; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_0; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_1; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_2; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_3; // @[adder.scala 14:34]
  wire [31:0] adder_io_out; // @[adder.scala 14:34]
  wire  adder_1_clock; // @[adder.scala 15:34]
  wire  adder_1_reset; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_0; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_1; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_2; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_3; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_out; // @[adder.scala 15:34]
  reg [31:0] _T; // @[adder.scala 20:26]
  wire [32:0] _T_1 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  wire [31:0] _T_2 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  adder_6 adder ( // @[adder.scala 14:34]
    .clock(adder_clock),
    .reset(adder_reset),
    .io_in_0(adder_io_in_0),
    .io_in_1(adder_io_in_1),
    .io_in_2(adder_io_in_2),
    .io_in_3(adder_io_in_3),
    .io_out(adder_io_out)
  );
  adder_6 adder_1 ( // @[adder.scala 15:34]
    .clock(adder_1_clock),
    .reset(adder_1_reset),
    .io_in_0(adder_1_io_in_0),
    .io_in_1(adder_1_io_in_1),
    .io_in_2(adder_1_io_in_2),
    .io_in_3(adder_1_io_in_3),
    .io_out(adder_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 23:16]
  assign adder_clock = clock;
  assign adder_reset = reset;
  assign adder_io_in_0 = io_in_0; // @[adder.scala 17:35]
  assign adder_io_in_1 = io_in_1; // @[adder.scala 17:35]
  assign adder_io_in_2 = io_in_2; // @[adder.scala 17:35]
  assign adder_io_in_3 = io_in_3; // @[adder.scala 17:35]
  assign adder_1_clock = clock;
  assign adder_1_reset = reset;
  assign adder_1_io_in_0 = io_in_4; // @[adder.scala 18:35]
  assign adder_1_io_in_1 = io_in_5; // @[adder.scala 18:35]
  assign adder_1_io_in_2 = io_in_6; // @[adder.scala 18:35]
  assign adder_1_io_in_3 = io_in_7; // @[adder.scala 18:35]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 32'h0;
    end else begin
      _T <= _T_2;
    end
  end
endmodule
module adder_30(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  input  [31:0] io_in_1,
  input  [31:0] io_in_2,
  input  [31:0] io_in_3,
  input  [31:0] io_in_4,
  input  [31:0] io_in_5,
  input  [31:0] io_in_6,
  input  [31:0] io_in_7,
  input  [31:0] io_in_8,
  input  [31:0] io_in_9,
  input  [31:0] io_in_10,
  input  [31:0] io_in_11,
  input  [31:0] io_in_12,
  input  [31:0] io_in_13,
  input  [31:0] io_in_14,
  input  [31:0] io_in_15,
  output [31:0] io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  adder_clock; // @[adder.scala 14:34]
  wire  adder_reset; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_0; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_1; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_2; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_3; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_4; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_5; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_6; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_7; // @[adder.scala 14:34]
  wire [31:0] adder_io_out; // @[adder.scala 14:34]
  wire  adder_1_clock; // @[adder.scala 15:34]
  wire  adder_1_reset; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_0; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_1; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_2; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_3; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_4; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_5; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_6; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_7; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_out; // @[adder.scala 15:34]
  reg [31:0] _T; // @[adder.scala 20:26]
  wire [32:0] _T_1 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  wire [31:0] _T_2 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  adder_14 adder ( // @[adder.scala 14:34]
    .clock(adder_clock),
    .reset(adder_reset),
    .io_in_0(adder_io_in_0),
    .io_in_1(adder_io_in_1),
    .io_in_2(adder_io_in_2),
    .io_in_3(adder_io_in_3),
    .io_in_4(adder_io_in_4),
    .io_in_5(adder_io_in_5),
    .io_in_6(adder_io_in_6),
    .io_in_7(adder_io_in_7),
    .io_out(adder_io_out)
  );
  adder_14 adder_1 ( // @[adder.scala 15:34]
    .clock(adder_1_clock),
    .reset(adder_1_reset),
    .io_in_0(adder_1_io_in_0),
    .io_in_1(adder_1_io_in_1),
    .io_in_2(adder_1_io_in_2),
    .io_in_3(adder_1_io_in_3),
    .io_in_4(adder_1_io_in_4),
    .io_in_5(adder_1_io_in_5),
    .io_in_6(adder_1_io_in_6),
    .io_in_7(adder_1_io_in_7),
    .io_out(adder_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 23:16]
  assign adder_clock = clock;
  assign adder_reset = reset;
  assign adder_io_in_0 = io_in_0; // @[adder.scala 17:35]
  assign adder_io_in_1 = io_in_1; // @[adder.scala 17:35]
  assign adder_io_in_2 = io_in_2; // @[adder.scala 17:35]
  assign adder_io_in_3 = io_in_3; // @[adder.scala 17:35]
  assign adder_io_in_4 = io_in_4; // @[adder.scala 17:35]
  assign adder_io_in_5 = io_in_5; // @[adder.scala 17:35]
  assign adder_io_in_6 = io_in_6; // @[adder.scala 17:35]
  assign adder_io_in_7 = io_in_7; // @[adder.scala 17:35]
  assign adder_1_clock = clock;
  assign adder_1_reset = reset;
  assign adder_1_io_in_0 = io_in_8; // @[adder.scala 18:35]
  assign adder_1_io_in_1 = io_in_9; // @[adder.scala 18:35]
  assign adder_1_io_in_2 = io_in_10; // @[adder.scala 18:35]
  assign adder_1_io_in_3 = io_in_11; // @[adder.scala 18:35]
  assign adder_1_io_in_4 = io_in_12; // @[adder.scala 18:35]
  assign adder_1_io_in_5 = io_in_13; // @[adder.scala 18:35]
  assign adder_1_io_in_6 = io_in_14; // @[adder.scala 18:35]
  assign adder_1_io_in_7 = io_in_15; // @[adder.scala 18:35]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 32'h0;
    end else begin
      _T <= _T_2;
    end
  end
endmodule
module adder_62(
  input         clock,
  input         reset,
  input  [31:0] io_in_0,
  input  [31:0] io_in_1,
  input  [31:0] io_in_2,
  input  [31:0] io_in_3,
  input  [31:0] io_in_4,
  input  [31:0] io_in_5,
  input  [31:0] io_in_6,
  input  [31:0] io_in_7,
  input  [31:0] io_in_8,
  input  [31:0] io_in_9,
  input  [31:0] io_in_10,
  input  [31:0] io_in_11,
  input  [31:0] io_in_12,
  input  [31:0] io_in_13,
  input  [31:0] io_in_14,
  input  [31:0] io_in_15,
  input  [31:0] io_in_16,
  input  [31:0] io_in_17,
  input  [31:0] io_in_18,
  input  [31:0] io_in_19,
  input  [31:0] io_in_20,
  input  [31:0] io_in_21,
  input  [31:0] io_in_22,
  input  [31:0] io_in_23,
  input  [31:0] io_in_24,
  input  [31:0] io_in_25,
  input  [31:0] io_in_26,
  input  [31:0] io_in_27,
  input  [31:0] io_in_28,
  input  [31:0] io_in_29,
  input  [31:0] io_in_30,
  input  [31:0] io_in_31,
  output [31:0] io_out
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  adder_clock; // @[adder.scala 14:34]
  wire  adder_reset; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_0; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_1; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_2; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_3; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_4; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_5; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_6; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_7; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_8; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_9; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_10; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_11; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_12; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_13; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_14; // @[adder.scala 14:34]
  wire [31:0] adder_io_in_15; // @[adder.scala 14:34]
  wire [31:0] adder_io_out; // @[adder.scala 14:34]
  wire  adder_1_clock; // @[adder.scala 15:34]
  wire  adder_1_reset; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_0; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_1; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_2; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_3; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_4; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_5; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_6; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_7; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_8; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_9; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_10; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_11; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_12; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_13; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_14; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_in_15; // @[adder.scala 15:34]
  wire [31:0] adder_1_io_out; // @[adder.scala 15:34]
  reg [31:0] _T; // @[adder.scala 20:26]
  wire [32:0] _T_1 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  wire [31:0] _T_2 = adder_io_out + adder_1_io_out; // @[adder.scala 21:36]
  adder_30 adder ( // @[adder.scala 14:34]
    .clock(adder_clock),
    .reset(adder_reset),
    .io_in_0(adder_io_in_0),
    .io_in_1(adder_io_in_1),
    .io_in_2(adder_io_in_2),
    .io_in_3(adder_io_in_3),
    .io_in_4(adder_io_in_4),
    .io_in_5(adder_io_in_5),
    .io_in_6(adder_io_in_6),
    .io_in_7(adder_io_in_7),
    .io_in_8(adder_io_in_8),
    .io_in_9(adder_io_in_9),
    .io_in_10(adder_io_in_10),
    .io_in_11(adder_io_in_11),
    .io_in_12(adder_io_in_12),
    .io_in_13(adder_io_in_13),
    .io_in_14(adder_io_in_14),
    .io_in_15(adder_io_in_15),
    .io_out(adder_io_out)
  );
  adder_30 adder_1 ( // @[adder.scala 15:34]
    .clock(adder_1_clock),
    .reset(adder_1_reset),
    .io_in_0(adder_1_io_in_0),
    .io_in_1(adder_1_io_in_1),
    .io_in_2(adder_1_io_in_2),
    .io_in_3(adder_1_io_in_3),
    .io_in_4(adder_1_io_in_4),
    .io_in_5(adder_1_io_in_5),
    .io_in_6(adder_1_io_in_6),
    .io_in_7(adder_1_io_in_7),
    .io_in_8(adder_1_io_in_8),
    .io_in_9(adder_1_io_in_9),
    .io_in_10(adder_1_io_in_10),
    .io_in_11(adder_1_io_in_11),
    .io_in_12(adder_1_io_in_12),
    .io_in_13(adder_1_io_in_13),
    .io_in_14(adder_1_io_in_14),
    .io_in_15(adder_1_io_in_15),
    .io_out(adder_1_io_out)
  );
  assign io_out = _T; // @[adder.scala 23:16]
  assign adder_clock = clock;
  assign adder_reset = reset;
  assign adder_io_in_0 = io_in_0; // @[adder.scala 17:35]
  assign adder_io_in_1 = io_in_1; // @[adder.scala 17:35]
  assign adder_io_in_2 = io_in_2; // @[adder.scala 17:35]
  assign adder_io_in_3 = io_in_3; // @[adder.scala 17:35]
  assign adder_io_in_4 = io_in_4; // @[adder.scala 17:35]
  assign adder_io_in_5 = io_in_5; // @[adder.scala 17:35]
  assign adder_io_in_6 = io_in_6; // @[adder.scala 17:35]
  assign adder_io_in_7 = io_in_7; // @[adder.scala 17:35]
  assign adder_io_in_8 = io_in_8; // @[adder.scala 17:35]
  assign adder_io_in_9 = io_in_9; // @[adder.scala 17:35]
  assign adder_io_in_10 = io_in_10; // @[adder.scala 17:35]
  assign adder_io_in_11 = io_in_11; // @[adder.scala 17:35]
  assign adder_io_in_12 = io_in_12; // @[adder.scala 17:35]
  assign adder_io_in_13 = io_in_13; // @[adder.scala 17:35]
  assign adder_io_in_14 = io_in_14; // @[adder.scala 17:35]
  assign adder_io_in_15 = io_in_15; // @[adder.scala 17:35]
  assign adder_1_clock = clock;
  assign adder_1_reset = reset;
  assign adder_1_io_in_0 = io_in_16; // @[adder.scala 18:35]
  assign adder_1_io_in_1 = io_in_17; // @[adder.scala 18:35]
  assign adder_1_io_in_2 = io_in_18; // @[adder.scala 18:35]
  assign adder_1_io_in_3 = io_in_19; // @[adder.scala 18:35]
  assign adder_1_io_in_4 = io_in_20; // @[adder.scala 18:35]
  assign adder_1_io_in_5 = io_in_21; // @[adder.scala 18:35]
  assign adder_1_io_in_6 = io_in_22; // @[adder.scala 18:35]
  assign adder_1_io_in_7 = io_in_23; // @[adder.scala 18:35]
  assign adder_1_io_in_8 = io_in_24; // @[adder.scala 18:35]
  assign adder_1_io_in_9 = io_in_25; // @[adder.scala 18:35]
  assign adder_1_io_in_10 = io_in_26; // @[adder.scala 18:35]
  assign adder_1_io_in_11 = io_in_27; // @[adder.scala 18:35]
  assign adder_1_io_in_12 = io_in_28; // @[adder.scala 18:35]
  assign adder_1_io_in_13 = io_in_29; // @[adder.scala 18:35]
  assign adder_1_io_in_14 = io_in_30; // @[adder.scala 18:35]
  assign adder_1_io_in_15 = io_in_31; // @[adder.scala 18:35]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      _T <= 32'h0;
    end else begin
      _T <= _T_2;
    end
  end
endmodule
module master(
  input         clock,
  input         reset,
  input         io_global_start,
  output        io_global_finish,
  output        io_start,
  output        io_frontier_flag,
  output [31:0] io_current_level,
  input         io_mem_end_0,
  input         io_mem_end_1,
  input         io_mem_end_2,
  input         io_mem_end_3,
  input         io_mem_end_4,
  input         io_mem_end_5,
  input         io_mem_end_6,
  input         io_mem_end_7,
  input         io_mem_end_8,
  input         io_mem_end_9,
  input         io_mem_end_10,
  input         io_mem_end_11,
  input         io_mem_end_12,
  input         io_mem_end_13,
  input         io_mem_end_14,
  input         io_mem_end_15,
  input         io_mem_end_16,
  input         io_mem_end_17,
  input         io_mem_end_18,
  input         io_mem_end_19,
  input         io_mem_end_20,
  input         io_mem_end_21,
  input         io_mem_end_22,
  input         io_mem_end_23,
  input         io_mem_end_24,
  input         io_mem_end_25,
  input         io_mem_end_26,
  input         io_mem_end_27,
  input         io_mem_end_28,
  input         io_mem_end_29,
  input         io_mem_end_30,
  input         io_mem_end_31,
  output        io_p2_end,
  input         io_end_0,
  input         io_end_1,
  input         io_end_2,
  input         io_end_3,
  input         io_end_4,
  input         io_end_5,
  input         io_end_6,
  input         io_end_7,
  input         io_end_8,
  input         io_end_9,
  input         io_end_10,
  input         io_end_11,
  input         io_end_12,
  input         io_end_13,
  input         io_end_14,
  input         io_end_15,
  input         io_end_16,
  input         io_end_17,
  input         io_end_18,
  input         io_end_19,
  input         io_end_20,
  input         io_end_21,
  input         io_end_22,
  input         io_end_23,
  input         io_end_24,
  input         io_end_25,
  input         io_end_26,
  input         io_end_27,
  input         io_end_28,
  input         io_end_29,
  input         io_end_30,
  input         io_end_31,
  input  [31:0] io_p2_count_0,
  input  [31:0] io_p2_count_1,
  input  [31:0] io_p2_count_2,
  input  [31:0] io_p2_count_3,
  input  [31:0] io_p2_count_4,
  input  [31:0] io_p2_count_5,
  input  [31:0] io_p2_count_6,
  input  [31:0] io_p2_count_7,
  input  [31:0] io_p2_count_8,
  input  [31:0] io_p2_count_9,
  input  [31:0] io_p2_count_10,
  input  [31:0] io_p2_count_11,
  input  [31:0] io_p2_count_12,
  input  [31:0] io_p2_count_13,
  input  [31:0] io_p2_count_14,
  input  [31:0] io_p2_count_15,
  input  [31:0] io_p2_count_16,
  input  [31:0] io_p2_count_17,
  input  [31:0] io_p2_count_18,
  input  [31:0] io_p2_count_19,
  input  [31:0] io_p2_count_20,
  input  [31:0] io_p2_count_21,
  input  [31:0] io_p2_count_22,
  input  [31:0] io_p2_count_23,
  input  [31:0] io_p2_count_24,
  input  [31:0] io_p2_count_25,
  input  [31:0] io_p2_count_26,
  input  [31:0] io_p2_count_27,
  input  [31:0] io_p2_count_28,
  input  [31:0] io_p2_count_29,
  input  [31:0] io_p2_count_30,
  input  [31:0] io_p2_count_31,
  input  [31:0] io_mem_count_0,
  input  [31:0] io_mem_count_1,
  input  [31:0] io_mem_count_2,
  input  [31:0] io_mem_count_3,
  input  [31:0] io_mem_count_4,
  input  [31:0] io_mem_count_5,
  input  [31:0] io_mem_count_6,
  input  [31:0] io_mem_count_7,
  input  [31:0] io_mem_count_8,
  input  [31:0] io_mem_count_9,
  input  [31:0] io_mem_count_10,
  input  [31:0] io_mem_count_11,
  input  [31:0] io_mem_count_12,
  input  [31:0] io_mem_count_13,
  input  [31:0] io_mem_count_14,
  input  [31:0] io_mem_count_15,
  input  [31:0] io_mem_count_16,
  input  [31:0] io_mem_count_17,
  input  [31:0] io_mem_count_18,
  input  [31:0] io_mem_count_19,
  input  [31:0] io_mem_count_20,
  input  [31:0] io_mem_count_21,
  input  [31:0] io_mem_count_22,
  input  [31:0] io_mem_count_23,
  input  [31:0] io_mem_count_24,
  input  [31:0] io_mem_count_25,
  input  [31:0] io_mem_count_26,
  input  [31:0] io_mem_count_27,
  input  [31:0] io_mem_count_28,
  input  [31:0] io_mem_count_29,
  input  [31:0] io_mem_count_30,
  input  [31:0] io_mem_count_31,
  input  [31:0] io_frontier_pull_count_0,
  input  [31:0] io_frontier_pull_count_1,
  input  [31:0] io_frontier_pull_count_2,
  input  [31:0] io_frontier_pull_count_3,
  input  [31:0] io_frontier_pull_count_4,
  input  [31:0] io_frontier_pull_count_5,
  input  [31:0] io_frontier_pull_count_6,
  input  [31:0] io_frontier_pull_count_7,
  input  [31:0] io_frontier_pull_count_8,
  input  [31:0] io_frontier_pull_count_9,
  input  [31:0] io_frontier_pull_count_10,
  input  [31:0] io_frontier_pull_count_11,
  input  [31:0] io_frontier_pull_count_12,
  input  [31:0] io_frontier_pull_count_13,
  input  [31:0] io_frontier_pull_count_14,
  input  [31:0] io_frontier_pull_count_15,
  input  [31:0] io_frontier_pull_count_16,
  input  [31:0] io_frontier_pull_count_17,
  input  [31:0] io_frontier_pull_count_18,
  input  [31:0] io_frontier_pull_count_19,
  input  [31:0] io_frontier_pull_count_20,
  input  [31:0] io_frontier_pull_count_21,
  input  [31:0] io_frontier_pull_count_22,
  input  [31:0] io_frontier_pull_count_23,
  input  [31:0] io_frontier_pull_count_24,
  input  [31:0] io_frontier_pull_count_25,
  input  [31:0] io_frontier_pull_count_26,
  input  [31:0] io_frontier_pull_count_27,
  input  [31:0] io_frontier_pull_count_28,
  input  [31:0] io_frontier_pull_count_29,
  input  [31:0] io_frontier_pull_count_30,
  input  [31:0] io_frontier_pull_count_31,
  input  [31:0] io_p2_pull_count_0,
  input  [31:0] io_p2_pull_count_1,
  input  [31:0] io_p2_pull_count_2,
  input  [31:0] io_p2_pull_count_3,
  input  [31:0] io_p2_pull_count_4,
  input  [31:0] io_p2_pull_count_5,
  input  [31:0] io_p2_pull_count_6,
  input  [31:0] io_p2_pull_count_7,
  input  [31:0] io_p2_pull_count_8,
  input  [31:0] io_p2_pull_count_9,
  input  [31:0] io_p2_pull_count_10,
  input  [31:0] io_p2_pull_count_11,
  input  [31:0] io_p2_pull_count_12,
  input  [31:0] io_p2_pull_count_13,
  input  [31:0] io_p2_pull_count_14,
  input  [31:0] io_p2_pull_count_15,
  input  [31:0] io_p2_pull_count_16,
  input  [31:0] io_p2_pull_count_17,
  input  [31:0] io_p2_pull_count_18,
  input  [31:0] io_p2_pull_count_19,
  input  [31:0] io_p2_pull_count_20,
  input  [31:0] io_p2_pull_count_21,
  input  [31:0] io_p2_pull_count_22,
  input  [31:0] io_p2_pull_count_23,
  input  [31:0] io_p2_pull_count_24,
  input  [31:0] io_p2_pull_count_25,
  input  [31:0] io_p2_pull_count_26,
  input  [31:0] io_p2_pull_count_27,
  input  [31:0] io_p2_pull_count_28,
  input  [31:0] io_p2_pull_count_29,
  input  [31:0] io_p2_pull_count_30,
  input  [31:0] io_p2_pull_count_31,
  input         io_last_iteration_state_0,
  input         io_last_iteration_state_1,
  input         io_last_iteration_state_2,
  input         io_last_iteration_state_3,
  input         io_last_iteration_state_4,
  input         io_last_iteration_state_5,
  input         io_last_iteration_state_6,
  input         io_last_iteration_state_7,
  input         io_last_iteration_state_8,
  input         io_last_iteration_state_9,
  input         io_last_iteration_state_10,
  input         io_last_iteration_state_11,
  input         io_last_iteration_state_12,
  input         io_last_iteration_state_13,
  input         io_last_iteration_state_14,
  input         io_last_iteration_state_15,
  input         io_last_iteration_state_16,
  input         io_last_iteration_state_17,
  input         io_last_iteration_state_18,
  input         io_last_iteration_state_19,
  input         io_last_iteration_state_20,
  input         io_last_iteration_state_21,
  input         io_last_iteration_state_22,
  input         io_last_iteration_state_23,
  input         io_last_iteration_state_24,
  input         io_last_iteration_state_25,
  input         io_last_iteration_state_26,
  input         io_last_iteration_state_27,
  input         io_last_iteration_state_28,
  input         io_last_iteration_state_29,
  input         io_last_iteration_state_30,
  input         io_last_iteration_state_31,
  input  [31:0] io_levels_push_to_pull_level,
  input  [31:0] io_levels_pull_to_push_level,
  output        io_push_or_pull,
  input         io_init_bram_0,
  input         io_init_bram_1,
  input         io_init_bram_2,
  input         io_init_bram_3,
  input         io_init_bram_4,
  input         io_init_bram_5,
  input         io_init_bram_6,
  input         io_init_bram_7,
  input         io_init_bram_8,
  input         io_init_bram_9,
  input         io_init_bram_10,
  input         io_init_bram_11,
  input         io_init_bram_12,
  input         io_init_bram_13,
  input         io_init_bram_14,
  input         io_init_bram_15,
  input         io_init_bram_16,
  input         io_init_bram_17,
  input         io_init_bram_18,
  input         io_init_bram_19,
  input         io_init_bram_20,
  input         io_init_bram_21,
  input         io_init_bram_22,
  input         io_init_bram_23,
  input         io_init_bram_24,
  input         io_init_bram_25,
  input         io_init_bram_26,
  input         io_init_bram_27,
  input         io_init_bram_28,
  input         io_init_bram_29,
  input         io_init_bram_30,
  input         io_init_bram_31
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
`endif // RANDOMIZE_REG_INIT
  wire  and_last_iteration_state_clock; // @[master.scala 43:41]
  wire  and_last_iteration_state_reset; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_0; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_1; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_2; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_3; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_4; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_5; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_6; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_7; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_8; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_9; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_10; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_11; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_12; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_13; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_14; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_15; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_16; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_17; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_18; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_19; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_20; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_21; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_22; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_23; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_24; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_25; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_26; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_27; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_28; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_29; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_30; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_in_31; // @[master.scala 43:41]
  wire  and_last_iteration_state_io_out; // @[master.scala 43:41]
  wire  and_mem_end_state_clock; // @[master.scala 44:41]
  wire  and_mem_end_state_reset; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_0; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_1; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_2; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_3; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_4; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_5; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_6; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_7; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_8; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_9; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_10; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_11; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_12; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_13; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_14; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_15; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_16; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_17; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_18; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_19; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_20; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_21; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_22; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_23; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_24; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_25; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_26; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_27; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_28; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_29; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_30; // @[master.scala 44:41]
  wire  and_mem_end_state_io_in_31; // @[master.scala 44:41]
  wire  and_mem_end_state_io_out; // @[master.scala 44:41]
  wire  and_end_state_clock; // @[master.scala 45:41]
  wire  and_end_state_reset; // @[master.scala 45:41]
  wire  and_end_state_io_in_0; // @[master.scala 45:41]
  wire  and_end_state_io_in_1; // @[master.scala 45:41]
  wire  and_end_state_io_in_2; // @[master.scala 45:41]
  wire  and_end_state_io_in_3; // @[master.scala 45:41]
  wire  and_end_state_io_in_4; // @[master.scala 45:41]
  wire  and_end_state_io_in_5; // @[master.scala 45:41]
  wire  and_end_state_io_in_6; // @[master.scala 45:41]
  wire  and_end_state_io_in_7; // @[master.scala 45:41]
  wire  and_end_state_io_in_8; // @[master.scala 45:41]
  wire  and_end_state_io_in_9; // @[master.scala 45:41]
  wire  and_end_state_io_in_10; // @[master.scala 45:41]
  wire  and_end_state_io_in_11; // @[master.scala 45:41]
  wire  and_end_state_io_in_12; // @[master.scala 45:41]
  wire  and_end_state_io_in_13; // @[master.scala 45:41]
  wire  and_end_state_io_in_14; // @[master.scala 45:41]
  wire  and_end_state_io_in_15; // @[master.scala 45:41]
  wire  and_end_state_io_in_16; // @[master.scala 45:41]
  wire  and_end_state_io_in_17; // @[master.scala 45:41]
  wire  and_end_state_io_in_18; // @[master.scala 45:41]
  wire  and_end_state_io_in_19; // @[master.scala 45:41]
  wire  and_end_state_io_in_20; // @[master.scala 45:41]
  wire  and_end_state_io_in_21; // @[master.scala 45:41]
  wire  and_end_state_io_in_22; // @[master.scala 45:41]
  wire  and_end_state_io_in_23; // @[master.scala 45:41]
  wire  and_end_state_io_in_24; // @[master.scala 45:41]
  wire  and_end_state_io_in_25; // @[master.scala 45:41]
  wire  and_end_state_io_in_26; // @[master.scala 45:41]
  wire  and_end_state_io_in_27; // @[master.scala 45:41]
  wire  and_end_state_io_in_28; // @[master.scala 45:41]
  wire  and_end_state_io_in_29; // @[master.scala 45:41]
  wire  and_end_state_io_in_30; // @[master.scala 45:41]
  wire  and_end_state_io_in_31; // @[master.scala 45:41]
  wire  and_end_state_io_out; // @[master.scala 45:41]
  wire  adder_p2_cnt_clock; // @[master.scala 76:28]
  wire  adder_p2_cnt_reset; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_0; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_1; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_2; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_3; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_4; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_5; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_6; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_7; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_8; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_9; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_10; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_11; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_12; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_13; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_14; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_15; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_16; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_17; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_18; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_19; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_20; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_21; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_22; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_23; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_24; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_25; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_26; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_27; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_28; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_29; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_30; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_in_31; // @[master.scala 76:28]
  wire [31:0] adder_p2_cnt_io_out; // @[master.scala 76:28]
  wire  adder_mem_cnt_clock; // @[master.scala 77:29]
  wire  adder_mem_cnt_reset; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_0; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_1; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_2; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_3; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_4; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_5; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_6; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_7; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_8; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_9; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_10; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_11; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_12; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_13; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_14; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_15; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_16; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_17; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_18; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_19; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_20; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_21; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_22; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_23; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_24; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_25; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_26; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_27; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_28; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_29; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_30; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_in_31; // @[master.scala 77:29]
  wire [31:0] adder_mem_cnt_io_out; // @[master.scala 77:29]
  wire  adder_p2_pull_count_clock; // @[master.scala 78:35]
  wire  adder_p2_pull_count_reset; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_0; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_1; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_2; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_3; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_4; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_5; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_6; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_7; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_8; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_9; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_10; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_11; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_12; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_13; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_14; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_15; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_16; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_17; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_18; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_19; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_20; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_21; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_22; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_23; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_24; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_25; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_26; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_27; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_28; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_29; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_30; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_in_31; // @[master.scala 78:35]
  wire [31:0] adder_p2_pull_count_io_out; // @[master.scala 78:35]
  wire  adder_frontier_pull_count_clock; // @[master.scala 79:41]
  wire  adder_frontier_pull_count_reset; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_0; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_1; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_2; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_3; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_4; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_5; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_6; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_7; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_8; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_9; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_10; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_11; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_12; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_13; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_14; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_15; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_16; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_17; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_18; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_19; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_20; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_21; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_22; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_23; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_24; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_25; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_26; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_27; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_28; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_29; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_30; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_in_31; // @[master.scala 79:41]
  wire [31:0] adder_frontier_pull_count_io_out; // @[master.scala 79:41]
  reg  last_iteration_state; // @[master.scala 39:37]
  reg  mem_end_state; // @[master.scala 40:30]
  reg  end_state; // @[master.scala 41:26]
  wire  _T = io_init_bram_0 | io_init_bram_1; // @[master.scala 60:49]
  wire  _T_1 = _T | io_init_bram_2; // @[master.scala 60:49]
  wire  _T_2 = _T_1 | io_init_bram_3; // @[master.scala 60:49]
  wire  _T_3 = _T_2 | io_init_bram_4; // @[master.scala 60:49]
  wire  _T_4 = _T_3 | io_init_bram_5; // @[master.scala 60:49]
  wire  _T_5 = _T_4 | io_init_bram_6; // @[master.scala 60:49]
  wire  _T_6 = _T_5 | io_init_bram_7; // @[master.scala 60:49]
  wire  _T_7 = _T_6 | io_init_bram_8; // @[master.scala 60:49]
  wire  _T_8 = _T_7 | io_init_bram_9; // @[master.scala 60:49]
  wire  _T_9 = _T_8 | io_init_bram_10; // @[master.scala 60:49]
  wire  _T_10 = _T_9 | io_init_bram_11; // @[master.scala 60:49]
  wire  _T_11 = _T_10 | io_init_bram_12; // @[master.scala 60:49]
  wire  _T_12 = _T_11 | io_init_bram_13; // @[master.scala 60:49]
  wire  _T_13 = _T_12 | io_init_bram_14; // @[master.scala 60:49]
  wire  _T_14 = _T_13 | io_init_bram_15; // @[master.scala 60:49]
  wire  _T_15 = _T_14 | io_init_bram_16; // @[master.scala 60:49]
  wire  _T_16 = _T_15 | io_init_bram_17; // @[master.scala 60:49]
  wire  _T_17 = _T_16 | io_init_bram_18; // @[master.scala 60:49]
  wire  _T_18 = _T_17 | io_init_bram_19; // @[master.scala 60:49]
  wire  _T_19 = _T_18 | io_init_bram_20; // @[master.scala 60:49]
  wire  _T_20 = _T_19 | io_init_bram_21; // @[master.scala 60:49]
  wire  _T_21 = _T_20 | io_init_bram_22; // @[master.scala 60:49]
  wire  _T_22 = _T_21 | io_init_bram_23; // @[master.scala 60:49]
  wire  _T_23 = _T_22 | io_init_bram_24; // @[master.scala 60:49]
  wire  _T_24 = _T_23 | io_init_bram_25; // @[master.scala 60:49]
  wire  _T_25 = _T_24 | io_init_bram_26; // @[master.scala 60:49]
  wire  _T_26 = _T_25 | io_init_bram_27; // @[master.scala 60:49]
  wire  _T_27 = _T_26 | io_init_bram_28; // @[master.scala 60:49]
  wire  _T_28 = _T_27 | io_init_bram_29; // @[master.scala 60:49]
  wire  _T_29 = _T_28 | io_init_bram_30; // @[master.scala 60:49]
  wire  _T_30 = _T_29 | io_init_bram_31; // @[master.scala 60:49]
  reg  init_state; // @[master.scala 60:27]
  reg  global_finish_state; // @[master.scala 62:36]
  reg [31:0] p2_cnt_total; // @[master.scala 71:29]
  reg [31:0] mem_cnt_total; // @[master.scala 72:30]
  reg [31:0] p2_pull_count_total; // @[master.scala 73:36]
  reg [31:0] frontier_pull_count_total; // @[master.scala 74:42]
  reg  push_or_pull_state; // @[master.scala 95:35]
  reg [31:0] level; // @[master.scala 98:22]
  reg  frontier_flag; // @[master.scala 99:30]
  reg [4:0] count_for_start; // @[master.scala 104:32]
  reg  stateReg; // @[master.scala 110:25]
  wire  _T_31 = ~stateReg; // @[Conditional.scala 37:30]
  wire  _T_32 = end_state & io_global_start; // @[master.scala 115:22]
  wire  _T_33 = _T_32 & init_state; // @[master.scala 115:41]
  wire [1:0] _T_34 = frontier_flag + 1'h1; // @[master.scala 117:40]
  wire  _T_35 = frontier_flag + 1'h1; // @[master.scala 117:40]
  wire  _T_36 = level == io_levels_push_to_pull_level; // @[master.scala 120:20]
  wire  _T_37 = level == io_levels_pull_to_push_level; // @[master.scala 122:26]
  wire  _GEN_0 = _T_37 ? 1'h0 : push_or_pull_state; // @[master.scala 122:59]
  wire  _GEN_1 = _T_36 | _GEN_0; // @[master.scala 120:53]
  wire [32:0] _T_38 = level + 32'h1; // @[master.scala 130:26]
  wire [31:0] _T_39 = level + 32'h1; // @[master.scala 130:26]
  wire  _GEN_2 = last_iteration_state | global_finish_state; // @[master.scala 126:35]
  wire  _GEN_3 = last_iteration_state ? 1'h0 : 1'h1; // @[master.scala 126:35]
  wire [31:0] _GEN_4 = last_iteration_state ? level : _T_39; // @[master.scala 126:35]
  wire  _GEN_5 = _T_33 ? _GEN_3 : stateReg; // @[master.scala 115:55]
  wire  _GEN_6 = _T_33 ? _T_35 : frontier_flag; // @[master.scala 115:55]
  wire  _GEN_7 = _T_33 ? _GEN_1 : push_or_pull_state; // @[master.scala 115:55]
  wire  _GEN_8 = _T_33 ? _GEN_2 : global_finish_state; // @[master.scala 115:55]
  wire [31:0] _GEN_9 = _T_33 ? _GEN_4 : level; // @[master.scala 115:55]
  wire  _T_40 = stateReg; // @[Conditional.scala 37:30]
  wire [5:0] _T_41 = count_for_start + 5'h1; // @[master.scala 135:42]
  wire [4:0] _T_42 = count_for_start + 5'h1; // @[master.scala 135:42]
  reg  _T_43; // @[master.scala 136:26]
  wire  _T_44 = count_for_start == 5'h14; // @[master.scala 137:28]
  wire  _GEN_10 = _T_44 ? 1'h0 : stateReg; // @[master.scala 137:37]
  wire [4:0] _GEN_11 = _T_44 ? 5'h0 : _T_42; // @[master.scala 137:37]
  wire [4:0] _GEN_12 = stateReg ? _GEN_11 : 5'h0; // @[Conditional.scala 39:67]
  wire  _GEN_13 = stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_14 = stateReg ? _GEN_10 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_15 = _T_31 ? 1'h0 : stateReg; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_16 = _T_31 ? 5'h0 : _GEN_12; // @[Conditional.scala 40:58]
  wire  _GEN_17 = _T_31 ? _GEN_5 : _GEN_14; // @[Conditional.scala 40:58]
  wire  _GEN_18 = _T_31 ? _GEN_6 : frontier_flag; // @[Conditional.scala 40:58]
  wire  _GEN_19 = _T_31 ? _GEN_7 : push_or_pull_state; // @[Conditional.scala 40:58]
  wire  _GEN_20 = _T_31 ? _GEN_8 : global_finish_state; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_21 = _T_31 ? _GEN_9 : level; // @[Conditional.scala 40:58]
  wire  _T_45 = mem_cnt_total == p2_cnt_total; // @[master.scala 145:38]
  wire  _T_46 = mem_end_state & _T_45; // @[master.scala 145:22]
  wire  _T_47 = p2_pull_count_total == frontier_pull_count_total; // @[master.scala 145:76]
  wire  _T_48 = _T_46 & _T_47; // @[master.scala 145:54]
  wire  _GEN_22 = _T_48; // @[master.scala 145:105]
  and_62 and_last_iteration_state ( // @[master.scala 43:41]
    .clock(and_last_iteration_state_clock),
    .reset(and_last_iteration_state_reset),
    .io_in_0(and_last_iteration_state_io_in_0),
    .io_in_1(and_last_iteration_state_io_in_1),
    .io_in_2(and_last_iteration_state_io_in_2),
    .io_in_3(and_last_iteration_state_io_in_3),
    .io_in_4(and_last_iteration_state_io_in_4),
    .io_in_5(and_last_iteration_state_io_in_5),
    .io_in_6(and_last_iteration_state_io_in_6),
    .io_in_7(and_last_iteration_state_io_in_7),
    .io_in_8(and_last_iteration_state_io_in_8),
    .io_in_9(and_last_iteration_state_io_in_9),
    .io_in_10(and_last_iteration_state_io_in_10),
    .io_in_11(and_last_iteration_state_io_in_11),
    .io_in_12(and_last_iteration_state_io_in_12),
    .io_in_13(and_last_iteration_state_io_in_13),
    .io_in_14(and_last_iteration_state_io_in_14),
    .io_in_15(and_last_iteration_state_io_in_15),
    .io_in_16(and_last_iteration_state_io_in_16),
    .io_in_17(and_last_iteration_state_io_in_17),
    .io_in_18(and_last_iteration_state_io_in_18),
    .io_in_19(and_last_iteration_state_io_in_19),
    .io_in_20(and_last_iteration_state_io_in_20),
    .io_in_21(and_last_iteration_state_io_in_21),
    .io_in_22(and_last_iteration_state_io_in_22),
    .io_in_23(and_last_iteration_state_io_in_23),
    .io_in_24(and_last_iteration_state_io_in_24),
    .io_in_25(and_last_iteration_state_io_in_25),
    .io_in_26(and_last_iteration_state_io_in_26),
    .io_in_27(and_last_iteration_state_io_in_27),
    .io_in_28(and_last_iteration_state_io_in_28),
    .io_in_29(and_last_iteration_state_io_in_29),
    .io_in_30(and_last_iteration_state_io_in_30),
    .io_in_31(and_last_iteration_state_io_in_31),
    .io_out(and_last_iteration_state_io_out)
  );
  and_62 and_mem_end_state ( // @[master.scala 44:41]
    .clock(and_mem_end_state_clock),
    .reset(and_mem_end_state_reset),
    .io_in_0(and_mem_end_state_io_in_0),
    .io_in_1(and_mem_end_state_io_in_1),
    .io_in_2(and_mem_end_state_io_in_2),
    .io_in_3(and_mem_end_state_io_in_3),
    .io_in_4(and_mem_end_state_io_in_4),
    .io_in_5(and_mem_end_state_io_in_5),
    .io_in_6(and_mem_end_state_io_in_6),
    .io_in_7(and_mem_end_state_io_in_7),
    .io_in_8(and_mem_end_state_io_in_8),
    .io_in_9(and_mem_end_state_io_in_9),
    .io_in_10(and_mem_end_state_io_in_10),
    .io_in_11(and_mem_end_state_io_in_11),
    .io_in_12(and_mem_end_state_io_in_12),
    .io_in_13(and_mem_end_state_io_in_13),
    .io_in_14(and_mem_end_state_io_in_14),
    .io_in_15(and_mem_end_state_io_in_15),
    .io_in_16(and_mem_end_state_io_in_16),
    .io_in_17(and_mem_end_state_io_in_17),
    .io_in_18(and_mem_end_state_io_in_18),
    .io_in_19(and_mem_end_state_io_in_19),
    .io_in_20(and_mem_end_state_io_in_20),
    .io_in_21(and_mem_end_state_io_in_21),
    .io_in_22(and_mem_end_state_io_in_22),
    .io_in_23(and_mem_end_state_io_in_23),
    .io_in_24(and_mem_end_state_io_in_24),
    .io_in_25(and_mem_end_state_io_in_25),
    .io_in_26(and_mem_end_state_io_in_26),
    .io_in_27(and_mem_end_state_io_in_27),
    .io_in_28(and_mem_end_state_io_in_28),
    .io_in_29(and_mem_end_state_io_in_29),
    .io_in_30(and_mem_end_state_io_in_30),
    .io_in_31(and_mem_end_state_io_in_31),
    .io_out(and_mem_end_state_io_out)
  );
  and_62 and_end_state ( // @[master.scala 45:41]
    .clock(and_end_state_clock),
    .reset(and_end_state_reset),
    .io_in_0(and_end_state_io_in_0),
    .io_in_1(and_end_state_io_in_1),
    .io_in_2(and_end_state_io_in_2),
    .io_in_3(and_end_state_io_in_3),
    .io_in_4(and_end_state_io_in_4),
    .io_in_5(and_end_state_io_in_5),
    .io_in_6(and_end_state_io_in_6),
    .io_in_7(and_end_state_io_in_7),
    .io_in_8(and_end_state_io_in_8),
    .io_in_9(and_end_state_io_in_9),
    .io_in_10(and_end_state_io_in_10),
    .io_in_11(and_end_state_io_in_11),
    .io_in_12(and_end_state_io_in_12),
    .io_in_13(and_end_state_io_in_13),
    .io_in_14(and_end_state_io_in_14),
    .io_in_15(and_end_state_io_in_15),
    .io_in_16(and_end_state_io_in_16),
    .io_in_17(and_end_state_io_in_17),
    .io_in_18(and_end_state_io_in_18),
    .io_in_19(and_end_state_io_in_19),
    .io_in_20(and_end_state_io_in_20),
    .io_in_21(and_end_state_io_in_21),
    .io_in_22(and_end_state_io_in_22),
    .io_in_23(and_end_state_io_in_23),
    .io_in_24(and_end_state_io_in_24),
    .io_in_25(and_end_state_io_in_25),
    .io_in_26(and_end_state_io_in_26),
    .io_in_27(and_end_state_io_in_27),
    .io_in_28(and_end_state_io_in_28),
    .io_in_29(and_end_state_io_in_29),
    .io_in_30(and_end_state_io_in_30),
    .io_in_31(and_end_state_io_in_31),
    .io_out(and_end_state_io_out)
  );
  adder_62 adder_p2_cnt ( // @[master.scala 76:28]
    .clock(adder_p2_cnt_clock),
    .reset(adder_p2_cnt_reset),
    .io_in_0(adder_p2_cnt_io_in_0),
    .io_in_1(adder_p2_cnt_io_in_1),
    .io_in_2(adder_p2_cnt_io_in_2),
    .io_in_3(adder_p2_cnt_io_in_3),
    .io_in_4(adder_p2_cnt_io_in_4),
    .io_in_5(adder_p2_cnt_io_in_5),
    .io_in_6(adder_p2_cnt_io_in_6),
    .io_in_7(adder_p2_cnt_io_in_7),
    .io_in_8(adder_p2_cnt_io_in_8),
    .io_in_9(adder_p2_cnt_io_in_9),
    .io_in_10(adder_p2_cnt_io_in_10),
    .io_in_11(adder_p2_cnt_io_in_11),
    .io_in_12(adder_p2_cnt_io_in_12),
    .io_in_13(adder_p2_cnt_io_in_13),
    .io_in_14(adder_p2_cnt_io_in_14),
    .io_in_15(adder_p2_cnt_io_in_15),
    .io_in_16(adder_p2_cnt_io_in_16),
    .io_in_17(adder_p2_cnt_io_in_17),
    .io_in_18(adder_p2_cnt_io_in_18),
    .io_in_19(adder_p2_cnt_io_in_19),
    .io_in_20(adder_p2_cnt_io_in_20),
    .io_in_21(adder_p2_cnt_io_in_21),
    .io_in_22(adder_p2_cnt_io_in_22),
    .io_in_23(adder_p2_cnt_io_in_23),
    .io_in_24(adder_p2_cnt_io_in_24),
    .io_in_25(adder_p2_cnt_io_in_25),
    .io_in_26(adder_p2_cnt_io_in_26),
    .io_in_27(adder_p2_cnt_io_in_27),
    .io_in_28(adder_p2_cnt_io_in_28),
    .io_in_29(adder_p2_cnt_io_in_29),
    .io_in_30(adder_p2_cnt_io_in_30),
    .io_in_31(adder_p2_cnt_io_in_31),
    .io_out(adder_p2_cnt_io_out)
  );
  adder_62 adder_mem_cnt ( // @[master.scala 77:29]
    .clock(adder_mem_cnt_clock),
    .reset(adder_mem_cnt_reset),
    .io_in_0(adder_mem_cnt_io_in_0),
    .io_in_1(adder_mem_cnt_io_in_1),
    .io_in_2(adder_mem_cnt_io_in_2),
    .io_in_3(adder_mem_cnt_io_in_3),
    .io_in_4(adder_mem_cnt_io_in_4),
    .io_in_5(adder_mem_cnt_io_in_5),
    .io_in_6(adder_mem_cnt_io_in_6),
    .io_in_7(adder_mem_cnt_io_in_7),
    .io_in_8(adder_mem_cnt_io_in_8),
    .io_in_9(adder_mem_cnt_io_in_9),
    .io_in_10(adder_mem_cnt_io_in_10),
    .io_in_11(adder_mem_cnt_io_in_11),
    .io_in_12(adder_mem_cnt_io_in_12),
    .io_in_13(adder_mem_cnt_io_in_13),
    .io_in_14(adder_mem_cnt_io_in_14),
    .io_in_15(adder_mem_cnt_io_in_15),
    .io_in_16(adder_mem_cnt_io_in_16),
    .io_in_17(adder_mem_cnt_io_in_17),
    .io_in_18(adder_mem_cnt_io_in_18),
    .io_in_19(adder_mem_cnt_io_in_19),
    .io_in_20(adder_mem_cnt_io_in_20),
    .io_in_21(adder_mem_cnt_io_in_21),
    .io_in_22(adder_mem_cnt_io_in_22),
    .io_in_23(adder_mem_cnt_io_in_23),
    .io_in_24(adder_mem_cnt_io_in_24),
    .io_in_25(adder_mem_cnt_io_in_25),
    .io_in_26(adder_mem_cnt_io_in_26),
    .io_in_27(adder_mem_cnt_io_in_27),
    .io_in_28(adder_mem_cnt_io_in_28),
    .io_in_29(adder_mem_cnt_io_in_29),
    .io_in_30(adder_mem_cnt_io_in_30),
    .io_in_31(adder_mem_cnt_io_in_31),
    .io_out(adder_mem_cnt_io_out)
  );
  adder_62 adder_p2_pull_count ( // @[master.scala 78:35]
    .clock(adder_p2_pull_count_clock),
    .reset(adder_p2_pull_count_reset),
    .io_in_0(adder_p2_pull_count_io_in_0),
    .io_in_1(adder_p2_pull_count_io_in_1),
    .io_in_2(adder_p2_pull_count_io_in_2),
    .io_in_3(adder_p2_pull_count_io_in_3),
    .io_in_4(adder_p2_pull_count_io_in_4),
    .io_in_5(adder_p2_pull_count_io_in_5),
    .io_in_6(adder_p2_pull_count_io_in_6),
    .io_in_7(adder_p2_pull_count_io_in_7),
    .io_in_8(adder_p2_pull_count_io_in_8),
    .io_in_9(adder_p2_pull_count_io_in_9),
    .io_in_10(adder_p2_pull_count_io_in_10),
    .io_in_11(adder_p2_pull_count_io_in_11),
    .io_in_12(adder_p2_pull_count_io_in_12),
    .io_in_13(adder_p2_pull_count_io_in_13),
    .io_in_14(adder_p2_pull_count_io_in_14),
    .io_in_15(adder_p2_pull_count_io_in_15),
    .io_in_16(adder_p2_pull_count_io_in_16),
    .io_in_17(adder_p2_pull_count_io_in_17),
    .io_in_18(adder_p2_pull_count_io_in_18),
    .io_in_19(adder_p2_pull_count_io_in_19),
    .io_in_20(adder_p2_pull_count_io_in_20),
    .io_in_21(adder_p2_pull_count_io_in_21),
    .io_in_22(adder_p2_pull_count_io_in_22),
    .io_in_23(adder_p2_pull_count_io_in_23),
    .io_in_24(adder_p2_pull_count_io_in_24),
    .io_in_25(adder_p2_pull_count_io_in_25),
    .io_in_26(adder_p2_pull_count_io_in_26),
    .io_in_27(adder_p2_pull_count_io_in_27),
    .io_in_28(adder_p2_pull_count_io_in_28),
    .io_in_29(adder_p2_pull_count_io_in_29),
    .io_in_30(adder_p2_pull_count_io_in_30),
    .io_in_31(adder_p2_pull_count_io_in_31),
    .io_out(adder_p2_pull_count_io_out)
  );
  adder_62 adder_frontier_pull_count ( // @[master.scala 79:41]
    .clock(adder_frontier_pull_count_clock),
    .reset(adder_frontier_pull_count_reset),
    .io_in_0(adder_frontier_pull_count_io_in_0),
    .io_in_1(adder_frontier_pull_count_io_in_1),
    .io_in_2(adder_frontier_pull_count_io_in_2),
    .io_in_3(adder_frontier_pull_count_io_in_3),
    .io_in_4(adder_frontier_pull_count_io_in_4),
    .io_in_5(adder_frontier_pull_count_io_in_5),
    .io_in_6(adder_frontier_pull_count_io_in_6),
    .io_in_7(adder_frontier_pull_count_io_in_7),
    .io_in_8(adder_frontier_pull_count_io_in_8),
    .io_in_9(adder_frontier_pull_count_io_in_9),
    .io_in_10(adder_frontier_pull_count_io_in_10),
    .io_in_11(adder_frontier_pull_count_io_in_11),
    .io_in_12(adder_frontier_pull_count_io_in_12),
    .io_in_13(adder_frontier_pull_count_io_in_13),
    .io_in_14(adder_frontier_pull_count_io_in_14),
    .io_in_15(adder_frontier_pull_count_io_in_15),
    .io_in_16(adder_frontier_pull_count_io_in_16),
    .io_in_17(adder_frontier_pull_count_io_in_17),
    .io_in_18(adder_frontier_pull_count_io_in_18),
    .io_in_19(adder_frontier_pull_count_io_in_19),
    .io_in_20(adder_frontier_pull_count_io_in_20),
    .io_in_21(adder_frontier_pull_count_io_in_21),
    .io_in_22(adder_frontier_pull_count_io_in_22),
    .io_in_23(adder_frontier_pull_count_io_in_23),
    .io_in_24(adder_frontier_pull_count_io_in_24),
    .io_in_25(adder_frontier_pull_count_io_in_25),
    .io_in_26(adder_frontier_pull_count_io_in_26),
    .io_in_27(adder_frontier_pull_count_io_in_27),
    .io_in_28(adder_frontier_pull_count_io_in_28),
    .io_in_29(adder_frontier_pull_count_io_in_29),
    .io_in_30(adder_frontier_pull_count_io_in_30),
    .io_in_31(adder_frontier_pull_count_io_in_31),
    .io_out(adder_frontier_pull_count_io_out)
  );
  assign io_global_finish = global_finish_state; // @[master.scala 63:20]
  assign io_start = _T_31 ? 1'h0 : stateReg; // @[master.scala 102:12 master.scala 113:16 master.scala 136:16]
  assign io_frontier_flag = frontier_flag; // @[master.scala 101:20]
  assign io_current_level = level; // @[master.scala 100:20]
  assign io_p2_end = _T_46 & _T_47; // @[master.scala 146:19 master.scala 148:19]
  assign io_push_or_pull = push_or_pull_state; // @[master.scala 96:19]
  assign and_last_iteration_state_clock = clock;
  assign and_last_iteration_state_reset = reset;
  assign and_last_iteration_state_io_in_0 = io_last_iteration_state_0; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_1 = io_last_iteration_state_1; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_2 = io_last_iteration_state_2; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_3 = io_last_iteration_state_3; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_4 = io_last_iteration_state_4; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_5 = io_last_iteration_state_5; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_6 = io_last_iteration_state_6; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_7 = io_last_iteration_state_7; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_8 = io_last_iteration_state_8; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_9 = io_last_iteration_state_9; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_10 = io_last_iteration_state_10; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_11 = io_last_iteration_state_11; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_12 = io_last_iteration_state_12; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_13 = io_last_iteration_state_13; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_14 = io_last_iteration_state_14; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_15 = io_last_iteration_state_15; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_16 = io_last_iteration_state_16; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_17 = io_last_iteration_state_17; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_18 = io_last_iteration_state_18; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_19 = io_last_iteration_state_19; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_20 = io_last_iteration_state_20; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_21 = io_last_iteration_state_21; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_22 = io_last_iteration_state_22; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_23 = io_last_iteration_state_23; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_24 = io_last_iteration_state_24; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_25 = io_last_iteration_state_25; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_26 = io_last_iteration_state_26; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_27 = io_last_iteration_state_27; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_28 = io_last_iteration_state_28; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_29 = io_last_iteration_state_29; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_30 = io_last_iteration_state_30; // @[master.scala 47:41]
  assign and_last_iteration_state_io_in_31 = io_last_iteration_state_31; // @[master.scala 47:41]
  assign and_mem_end_state_clock = clock;
  assign and_mem_end_state_reset = reset;
  assign and_mem_end_state_io_in_0 = io_mem_end_0; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_1 = io_mem_end_1; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_2 = io_mem_end_2; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_3 = io_mem_end_3; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_4 = io_mem_end_4; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_5 = io_mem_end_5; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_6 = io_mem_end_6; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_7 = io_mem_end_7; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_8 = io_mem_end_8; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_9 = io_mem_end_9; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_10 = io_mem_end_10; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_11 = io_mem_end_11; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_12 = io_mem_end_12; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_13 = io_mem_end_13; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_14 = io_mem_end_14; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_15 = io_mem_end_15; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_16 = io_mem_end_16; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_17 = io_mem_end_17; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_18 = io_mem_end_18; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_19 = io_mem_end_19; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_20 = io_mem_end_20; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_21 = io_mem_end_21; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_22 = io_mem_end_22; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_23 = io_mem_end_23; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_24 = io_mem_end_24; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_25 = io_mem_end_25; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_26 = io_mem_end_26; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_27 = io_mem_end_27; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_28 = io_mem_end_28; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_29 = io_mem_end_29; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_30 = io_mem_end_30; // @[master.scala 48:41]
  assign and_mem_end_state_io_in_31 = io_mem_end_31; // @[master.scala 48:41]
  assign and_end_state_clock = clock;
  assign and_end_state_reset = reset;
  assign and_end_state_io_in_0 = io_end_0; // @[master.scala 49:41]
  assign and_end_state_io_in_1 = io_end_1; // @[master.scala 49:41]
  assign and_end_state_io_in_2 = io_end_2; // @[master.scala 49:41]
  assign and_end_state_io_in_3 = io_end_3; // @[master.scala 49:41]
  assign and_end_state_io_in_4 = io_end_4; // @[master.scala 49:41]
  assign and_end_state_io_in_5 = io_end_5; // @[master.scala 49:41]
  assign and_end_state_io_in_6 = io_end_6; // @[master.scala 49:41]
  assign and_end_state_io_in_7 = io_end_7; // @[master.scala 49:41]
  assign and_end_state_io_in_8 = io_end_8; // @[master.scala 49:41]
  assign and_end_state_io_in_9 = io_end_9; // @[master.scala 49:41]
  assign and_end_state_io_in_10 = io_end_10; // @[master.scala 49:41]
  assign and_end_state_io_in_11 = io_end_11; // @[master.scala 49:41]
  assign and_end_state_io_in_12 = io_end_12; // @[master.scala 49:41]
  assign and_end_state_io_in_13 = io_end_13; // @[master.scala 49:41]
  assign and_end_state_io_in_14 = io_end_14; // @[master.scala 49:41]
  assign and_end_state_io_in_15 = io_end_15; // @[master.scala 49:41]
  assign and_end_state_io_in_16 = io_end_16; // @[master.scala 49:41]
  assign and_end_state_io_in_17 = io_end_17; // @[master.scala 49:41]
  assign and_end_state_io_in_18 = io_end_18; // @[master.scala 49:41]
  assign and_end_state_io_in_19 = io_end_19; // @[master.scala 49:41]
  assign and_end_state_io_in_20 = io_end_20; // @[master.scala 49:41]
  assign and_end_state_io_in_21 = io_end_21; // @[master.scala 49:41]
  assign and_end_state_io_in_22 = io_end_22; // @[master.scala 49:41]
  assign and_end_state_io_in_23 = io_end_23; // @[master.scala 49:41]
  assign and_end_state_io_in_24 = io_end_24; // @[master.scala 49:41]
  assign and_end_state_io_in_25 = io_end_25; // @[master.scala 49:41]
  assign and_end_state_io_in_26 = io_end_26; // @[master.scala 49:41]
  assign and_end_state_io_in_27 = io_end_27; // @[master.scala 49:41]
  assign and_end_state_io_in_28 = io_end_28; // @[master.scala 49:41]
  assign and_end_state_io_in_29 = io_end_29; // @[master.scala 49:41]
  assign and_end_state_io_in_30 = io_end_30; // @[master.scala 49:41]
  assign and_end_state_io_in_31 = io_end_31; // @[master.scala 49:41]
  assign adder_p2_cnt_clock = clock;
  assign adder_p2_cnt_reset = reset;
  assign adder_p2_cnt_io_in_0 = io_p2_count_0; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_1 = io_p2_count_1; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_2 = io_p2_count_2; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_3 = io_p2_count_3; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_4 = io_p2_count_4; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_5 = io_p2_count_5; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_6 = io_p2_count_6; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_7 = io_p2_count_7; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_8 = io_p2_count_8; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_9 = io_p2_count_9; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_10 = io_p2_count_10; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_11 = io_p2_count_11; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_12 = io_p2_count_12; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_13 = io_p2_count_13; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_14 = io_p2_count_14; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_15 = io_p2_count_15; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_16 = io_p2_count_16; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_17 = io_p2_count_17; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_18 = io_p2_count_18; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_19 = io_p2_count_19; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_20 = io_p2_count_20; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_21 = io_p2_count_21; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_22 = io_p2_count_22; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_23 = io_p2_count_23; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_24 = io_p2_count_24; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_25 = io_p2_count_25; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_26 = io_p2_count_26; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_27 = io_p2_count_27; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_28 = io_p2_count_28; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_29 = io_p2_count_29; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_30 = io_p2_count_30; // @[master.scala 83:41]
  assign adder_p2_cnt_io_in_31 = io_p2_count_31; // @[master.scala 83:41]
  assign adder_mem_cnt_clock = clock;
  assign adder_mem_cnt_reset = reset;
  assign adder_mem_cnt_io_in_0 = io_mem_count_0; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_1 = io_mem_count_1; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_2 = io_mem_count_2; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_3 = io_mem_count_3; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_4 = io_mem_count_4; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_5 = io_mem_count_5; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_6 = io_mem_count_6; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_7 = io_mem_count_7; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_8 = io_mem_count_8; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_9 = io_mem_count_9; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_10 = io_mem_count_10; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_11 = io_mem_count_11; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_12 = io_mem_count_12; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_13 = io_mem_count_13; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_14 = io_mem_count_14; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_15 = io_mem_count_15; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_16 = io_mem_count_16; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_17 = io_mem_count_17; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_18 = io_mem_count_18; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_19 = io_mem_count_19; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_20 = io_mem_count_20; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_21 = io_mem_count_21; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_22 = io_mem_count_22; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_23 = io_mem_count_23; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_24 = io_mem_count_24; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_25 = io_mem_count_25; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_26 = io_mem_count_26; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_27 = io_mem_count_27; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_28 = io_mem_count_28; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_29 = io_mem_count_29; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_30 = io_mem_count_30; // @[master.scala 84:41]
  assign adder_mem_cnt_io_in_31 = io_mem_count_31; // @[master.scala 84:41]
  assign adder_p2_pull_count_clock = clock;
  assign adder_p2_pull_count_reset = reset;
  assign adder_p2_pull_count_io_in_0 = io_p2_pull_count_0; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_1 = io_p2_pull_count_1; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_2 = io_p2_pull_count_2; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_3 = io_p2_pull_count_3; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_4 = io_p2_pull_count_4; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_5 = io_p2_pull_count_5; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_6 = io_p2_pull_count_6; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_7 = io_p2_pull_count_7; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_8 = io_p2_pull_count_8; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_9 = io_p2_pull_count_9; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_10 = io_p2_pull_count_10; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_11 = io_p2_pull_count_11; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_12 = io_p2_pull_count_12; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_13 = io_p2_pull_count_13; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_14 = io_p2_pull_count_14; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_15 = io_p2_pull_count_15; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_16 = io_p2_pull_count_16; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_17 = io_p2_pull_count_17; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_18 = io_p2_pull_count_18; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_19 = io_p2_pull_count_19; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_20 = io_p2_pull_count_20; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_21 = io_p2_pull_count_21; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_22 = io_p2_pull_count_22; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_23 = io_p2_pull_count_23; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_24 = io_p2_pull_count_24; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_25 = io_p2_pull_count_25; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_26 = io_p2_pull_count_26; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_27 = io_p2_pull_count_27; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_28 = io_p2_pull_count_28; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_29 = io_p2_pull_count_29; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_30 = io_p2_pull_count_30; // @[master.scala 85:41]
  assign adder_p2_pull_count_io_in_31 = io_p2_pull_count_31; // @[master.scala 85:41]
  assign adder_frontier_pull_count_clock = clock;
  assign adder_frontier_pull_count_reset = reset;
  assign adder_frontier_pull_count_io_in_0 = io_frontier_pull_count_0; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_1 = io_frontier_pull_count_1; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_2 = io_frontier_pull_count_2; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_3 = io_frontier_pull_count_3; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_4 = io_frontier_pull_count_4; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_5 = io_frontier_pull_count_5; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_6 = io_frontier_pull_count_6; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_7 = io_frontier_pull_count_7; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_8 = io_frontier_pull_count_8; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_9 = io_frontier_pull_count_9; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_10 = io_frontier_pull_count_10; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_11 = io_frontier_pull_count_11; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_12 = io_frontier_pull_count_12; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_13 = io_frontier_pull_count_13; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_14 = io_frontier_pull_count_14; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_15 = io_frontier_pull_count_15; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_16 = io_frontier_pull_count_16; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_17 = io_frontier_pull_count_17; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_18 = io_frontier_pull_count_18; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_19 = io_frontier_pull_count_19; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_20 = io_frontier_pull_count_20; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_21 = io_frontier_pull_count_21; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_22 = io_frontier_pull_count_22; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_23 = io_frontier_pull_count_23; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_24 = io_frontier_pull_count_24; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_25 = io_frontier_pull_count_25; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_26 = io_frontier_pull_count_26; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_27 = io_frontier_pull_count_27; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_28 = io_frontier_pull_count_28; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_29 = io_frontier_pull_count_29; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_30 = io_frontier_pull_count_30; // @[master.scala 86:41]
  assign adder_frontier_pull_count_io_in_31 = io_frontier_pull_count_31; // @[master.scala 86:41]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  last_iteration_state = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  mem_end_state = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  end_state = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  init_state = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  global_finish_state = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  p2_cnt_total = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  mem_cnt_total = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  p2_pull_count_total = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  frontier_pull_count_total = _RAND_8[31:0];
  _RAND_9 = {1{`RANDOM}};
  push_or_pull_state = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  level = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  frontier_flag = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  count_for_start = _RAND_12[4:0];
  _RAND_13 = {1{`RANDOM}};
  stateReg = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_43 = _RAND_14[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      last_iteration_state <= 1'h0;
    end else begin
      last_iteration_state <= and_last_iteration_state_io_out;
    end
    if (reset) begin
      mem_end_state <= 1'h0;
    end else begin
      mem_end_state <= and_mem_end_state_io_out;
    end
    if (reset) begin
      end_state <= 1'h0;
    end else begin
      end_state <= and_end_state_io_out;
    end
    init_state <= _T_29 | io_init_bram_31;
    if (reset) begin
      global_finish_state <= 1'h0;
    end else if (_T_31) begin
      if (_T_33) begin
        global_finish_state <= _GEN_2;
      end
    end
    if (reset) begin
      p2_cnt_total <= 32'h0;
    end else begin
      p2_cnt_total <= adder_p2_cnt_io_out;
    end
    if (reset) begin
      mem_cnt_total <= 32'h0;
    end else begin
      mem_cnt_total <= adder_mem_cnt_io_out;
    end
    if (reset) begin
      p2_pull_count_total <= 32'h0;
    end else begin
      p2_pull_count_total <= adder_p2_pull_count_io_out;
    end
    if (reset) begin
      frontier_pull_count_total <= 32'h0;
    end else begin
      frontier_pull_count_total <= adder_frontier_pull_count_io_out;
    end
    if (reset) begin
      push_or_pull_state <= 1'h0;
    end else if (_T_31) begin
      if (_T_33) begin
        push_or_pull_state <= _GEN_1;
      end
    end
    if (reset) begin
      level <= 32'h0;
    end else if (_T_31) begin
      if (_T_33) begin
        if (!(last_iteration_state)) begin
          level <= _T_39;
        end
      end
    end
    frontier_flag <= reset | _GEN_18;
    if (reset) begin
      count_for_start <= 5'h0;
    end else if (_T_31) begin
      count_for_start <= 5'h0;
    end else if (stateReg) begin
      if (_T_44) begin
        count_for_start <= 5'h0;
      end else begin
        count_for_start <= _T_42;
      end
    end else begin
      count_for_start <= 5'h0;
    end
    if (reset) begin
      stateReg <= 1'h0;
    end else if (_T_31) begin
      if (_T_33) begin
        if (last_iteration_state) begin
          stateReg <= 1'h0;
        end else begin
          stateReg <= 1'h1;
        end
      end
    end else if (stateReg) begin
      if (_T_44) begin
        stateReg <= 1'h0;
      end
    end
    _T_43 <= 1'h1;
  end
endmodule
module RRArbiter(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [63:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [63:0] io_in_1_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [63:0] io_out_bits,
  output        io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [63:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [63:0] _GEN_5 = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg  lastGrant; // @[Reg.scala 15:16]
  wire  _GEN_6 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 1'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_3 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_4 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_5 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_6 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_7 = _T_4; // @[Arbiter.scala 72:50]
  wire  _T_8 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_9 = grantMask_1 | _T_5; // @[Arbiter.scala 72:50]
  wire  _T_10 = _T_4 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_11 = _T_9 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _GEN_7 = io_in_0_valid ? 1'h0 : 1'h1; // @[Arbiter.scala 77:27]
  wire  choice = validMask_1 | _GEN_7; // @[Arbiter.scala 79:25]
  wire  _GEN_8 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_3; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_4; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [63:0] _io_in_io_chosen_bits = _GEN_5; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_3; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_4; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [63:0] _io_in_io_chosen_0_bits = _GEN_5; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_4 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_9 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  assign io_out_bits = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 | _GEN_7; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module Queue(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [1:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:1]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire  ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire  ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg  enq_ptr_value; // @[Counter.scala 29:33]
  reg  deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_4 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_5 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire  _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_6 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_7 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire  _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_14 = _T_13 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 1'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 1'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_2(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [6:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:63]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [5:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [5:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [5:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [5:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 6'h3f; // @[Counter.scala 38:24]
  wire [6:0] _T_4 = enq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire [5:0] _T_5 = enq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [5:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [5:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 6'h3f; // @[Counter.scala 38:24]
  wire [6:0] _T_6 = deq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire [5:0] _T_7 = deq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [5:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [6:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [5:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [6:0] _T_14 = _T_13 ? 7'h40 : 7'h0; // @[Decoupled.scala 259:20]
  wire [6:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [6:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [6:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 64; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[5:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[5:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 6'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 6'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module HBM_reader(
  input          clock,
  input          reset,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  output         io_interface_to_pe_writeAddr_ready,
  input          io_interface_to_pe_writeAddr_valid,
  input  [63:0]  io_interface_to_pe_writeAddr_bits_addr,
  input  [7:0]   io_interface_to_pe_writeAddr_bits_len,
  input  [5:0]   io_interface_to_pe_writeAddr_bits_id,
  output         io_interface_to_pe_writeData_ready,
  input          io_interface_to_pe_writeData_valid,
  input  [255:0] io_interface_to_pe_writeData_bits_data,
  input  [31:0]  io_interface_to_pe_writeData_bits_strb,
  input          io_interface_to_pe_writeData_bits_last,
  input          io_interface_to_pe_writeResp_ready,
  output         io_interface_to_pe_writeResp_valid,
  output [5:0]   io_interface_to_pe_writeResp_bits_id,
  output [1:0]   io_interface_to_pe_writeResp_bits_resp,
  output         io_interface_to_pe_readAddr_ready,
  input          io_interface_to_pe_readAddr_valid,
  input  [63:0]  io_interface_to_pe_readAddr_bits_addr,
  input  [7:0]   io_interface_to_pe_readAddr_bits_len,
  input  [5:0]   io_interface_to_pe_readAddr_bits_id,
  input          io_interface_to_pe_readData_array_0_ready,
  output         io_interface_to_pe_readData_array_0_valid,
  output [63:0]  io_interface_to_pe_readData_array_0_bits_data,
  input          io_interface_to_pe_readData_array_1_ready,
  output         io_interface_to_pe_readData_array_1_valid,
  output [63:0]  io_interface_to_pe_readData_array_1_bits_data,
  input          io_interface_to_pe_readData_array_2_ready,
  output         io_interface_to_pe_readData_array_2_valid,
  output [63:0]  io_interface_to_pe_readData_array_2_bits_data,
  input          io_interface_to_pe_readData_array_3_ready,
  output         io_interface_to_pe_readData_array_3_valid,
  output [63:0]  io_interface_to_pe_readData_array_3_bits_data,
  input          io_interface_to_pe_readData_offset_ready,
  output         io_interface_to_pe_readData_offset_valid,
  output [63:0]  io_interface_to_pe_readData_offset_bits_data,
  input          io_sysclock,
  output         io_src_ready,
  input          io_src_valid,
  input  [31:0]  io_src_bits,
  output [31:0]  io_burst_cnt,
  output [31:0]  io_neighbour_cnt
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
  reg [31:0] _RAND_32;
  reg [31:0] _RAND_33;
  reg [31:0] _RAND_34;
  reg [31:0] _RAND_35;
  reg [31:0] _RAND_36;
  reg [31:0] _RAND_37;
  reg [31:0] _RAND_38;
  reg [31:0] _RAND_39;
  reg [31:0] _RAND_40;
  reg [31:0] _RAND_41;
  reg [31:0] _RAND_42;
  reg [31:0] _RAND_43;
  reg [31:0] _RAND_44;
  reg [31:0] _RAND_45;
  reg [31:0] _RAND_46;
`endif // RANDOMIZE_REG_INIT
  wire  writeAddr_rst; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_wr_clk; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_rd_clk; // @[hbm_reader_double_fifo.scala 81:27]
  wire [77:0] writeAddr_din; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_wr_en; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_rd_en; // @[hbm_reader_double_fifo.scala 81:27]
  wire [77:0] writeAddr_dout; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_full; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeAddr_empty; // @[hbm_reader_double_fifo.scala 81:27]
  wire  writeData_rst; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_wr_clk; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_rd_clk; // @[hbm_reader_double_fifo.scala 82:27]
  wire [288:0] writeData_din; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_wr_en; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_rd_en; // @[hbm_reader_double_fifo.scala 82:27]
  wire [288:0] writeData_dout; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_full; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeData_empty; // @[hbm_reader_double_fifo.scala 82:27]
  wire  writeResp_rst; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_wr_clk; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_rd_clk; // @[hbm_reader_double_fifo.scala 83:27]
  wire [7:0] writeResp_din; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_wr_en; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_rd_en; // @[hbm_reader_double_fifo.scala 83:27]
  wire [7:0] writeResp_dout; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_full; // @[hbm_reader_double_fifo.scala 83:27]
  wire  writeResp_empty; // @[hbm_reader_double_fifo.scala 83:27]
  wire  readAddr_rst; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_wr_clk; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_rd_clk; // @[hbm_reader_double_fifo.scala 84:26]
  wire [77:0] readAddr_din; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_wr_en; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_rd_en; // @[hbm_reader_double_fifo.scala 84:26]
  wire [77:0] readAddr_dout; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_full; // @[hbm_reader_double_fifo.scala 84:26]
  wire  readAddr_empty; // @[hbm_reader_double_fifo.scala 84:26]
  wire  fifo_generator_readData_syn_rst; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_clk; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_din; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_wr_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_rd_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_dout; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_full; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_empty; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_rst; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_clk; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_1_din; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_wr_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_rd_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_1_dout; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_full; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_1_empty; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_rst; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_clk; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_2_din; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_wr_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_rd_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_2_dout; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_full; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_2_empty; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_rst; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_clk; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_3_din; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_wr_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_rd_en; // @[hbm_reader_double_fifo.scala 92:63]
  wire [63:0] fifo_generator_readData_syn_3_dout; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_full; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_3_empty; // @[hbm_reader_double_fifo.scala 92:63]
  wire  fifo_generator_readData_syn_4_rst; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_4_clk; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_4_din; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_4_wr_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_4_rd_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_4_dout; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_4_full; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_4_empty; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_rst; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_clk; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_5_din; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_wr_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_rd_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_5_dout; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_full; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_5_empty; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_rst; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_clk; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_6_din; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_wr_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_rd_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_6_dout; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_full; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_6_empty; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_rst; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_clk; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_7_din; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_wr_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_rd_en; // @[hbm_reader_double_fifo.scala 93:63]
  wire [63:0] fifo_generator_readData_syn_7_dout; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_full; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_syn_7_empty; // @[hbm_reader_double_fifo.scala 93:63]
  wire  fifo_generator_readData_rst; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_wr_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_rd_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_din; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_wr_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_rd_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_dout; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_full; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_empty; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_rst; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_wr_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_rd_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_1_din; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_wr_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_rd_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_1_dout; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_full; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_1_empty; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_rst; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_wr_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_rd_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_2_din; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_wr_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_rd_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_2_dout; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_full; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_2_empty; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_rst; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_wr_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_rd_clk; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_3_din; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_wr_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_rd_en; // @[hbm_reader_double_fifo.scala 94:65]
  wire [63:0] fifo_generator_readData_3_dout; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_full; // @[hbm_reader_double_fifo.scala 94:65]
  wire  fifo_generator_readData_3_empty; // @[hbm_reader_double_fifo.scala 94:65]
  wire  RRArbiter_clock; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_reset; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_in_0_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_in_0_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_io_in_0_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_in_1_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_in_1_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_io_in_1_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_out_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_out_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_io_out_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_io_chosen; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_clock; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_reset; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_in_0_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_in_0_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_1_io_in_0_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_in_1_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_in_1_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_1_io_in_1_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_out_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_out_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_1_io_out_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_1_io_chosen; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_clock; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_reset; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_in_0_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_in_0_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_2_io_in_0_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_in_1_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_in_1_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_2_io_in_1_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_out_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_out_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_2_io_out_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_2_io_chosen; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_clock; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_reset; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_in_0_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_in_0_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_3_io_in_0_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_in_1_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_in_1_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_3_io_in_1_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_out_ready; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_out_valid; // @[hbm_reader_double_fifo.scala 99:34]
  wire [63:0] RRArbiter_3_io_out_bits; // @[hbm_reader_double_fifo.scala 99:34]
  wire  RRArbiter_3_io_chosen; // @[hbm_reader_double_fifo.scala 99:34]
  wire  readData_offset_rst; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_wr_clk; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_rd_clk; // @[hbm_reader_double_fifo.scala 116:33]
  wire [63:0] readData_offset_din; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_wr_en; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_rd_en; // @[hbm_reader_double_fifo.scala 116:33]
  wire [63:0] readData_offset_dout; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_full; // @[hbm_reader_double_fifo.scala 116:33]
  wire  readData_offset_empty; // @[hbm_reader_double_fifo.scala 116:33]
  wire  src_index_queue_asyn_rst; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_wr_clk; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_rd_clk; // @[hbm_reader_double_fifo.scala 118:38]
  wire [31:0] src_index_queue_asyn_din; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_wr_en; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_rd_en; // @[hbm_reader_double_fifo.scala 118:38]
  wire [31:0] src_index_queue_asyn_dout; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_full; // @[hbm_reader_double_fifo.scala 118:38]
  wire  src_index_queue_asyn_empty; // @[hbm_reader_double_fifo.scala 118:38]
  wire  burst_cnt_rst; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_wr_clk; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_rd_clk; // @[hbm_reader_double_fifo.scala 121:27]
  wire [31:0] burst_cnt_din; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_wr_en; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_rd_en; // @[hbm_reader_double_fifo.scala 121:27]
  wire [31:0] burst_cnt_dout; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_full; // @[hbm_reader_double_fifo.scala 121:27]
  wire  burst_cnt_empty; // @[hbm_reader_double_fifo.scala 121:27]
  wire  neighbour_cnt_rst; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_wr_clk; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_rd_clk; // @[hbm_reader_double_fifo.scala 122:31]
  wire [31:0] neighbour_cnt_din; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_wr_en; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_rd_en; // @[hbm_reader_double_fifo.scala 122:31]
  wire [31:0] neighbour_cnt_dout; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_full; // @[hbm_reader_double_fifo.scala 122:31]
  wire  neighbour_cnt_empty; // @[hbm_reader_double_fifo.scala 122:31]
  wire  src_index_queue_l1_clock; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l1_reset; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l1_io_enq_ready; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l1_io_enq_valid; // @[hbm_reader_double_fifo.scala 247:36]
  wire [31:0] src_index_queue_l1_io_enq_bits; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l1_io_deq_ready; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l1_io_deq_valid; // @[hbm_reader_double_fifo.scala 247:36]
  wire [31:0] src_index_queue_l1_io_deq_bits; // @[hbm_reader_double_fifo.scala 247:36]
  wire [1:0] src_index_queue_l1_io_count; // @[hbm_reader_double_fifo.scala 247:36]
  wire  src_index_queue_l2_clock; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_l2_reset; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_l2_io_enq_ready; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_l2_io_enq_valid; // @[hbm_reader_double_fifo.scala 248:36]
  wire [31:0] src_index_queue_l2_io_enq_bits; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_l2_io_deq_ready; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_l2_io_deq_valid; // @[hbm_reader_double_fifo.scala 248:36]
  wire [31:0] src_index_queue_l2_io_deq_bits; // @[hbm_reader_double_fifo.scala 248:36]
  wire [1:0] src_index_queue_l2_io_count; // @[hbm_reader_double_fifo.scala 248:36]
  wire  src_index_queue_clock; // @[hbm_reader_double_fifo.scala 249:33]
  wire  src_index_queue_reset; // @[hbm_reader_double_fifo.scala 249:33]
  wire  src_index_queue_io_enq_ready; // @[hbm_reader_double_fifo.scala 249:33]
  wire  src_index_queue_io_enq_valid; // @[hbm_reader_double_fifo.scala 249:33]
  wire [31:0] src_index_queue_io_enq_bits; // @[hbm_reader_double_fifo.scala 249:33]
  wire  src_index_queue_io_deq_ready; // @[hbm_reader_double_fifo.scala 249:33]
  wire  src_index_queue_io_deq_valid; // @[hbm_reader_double_fifo.scala 249:33]
  wire [31:0] src_index_queue_io_deq_bits; // @[hbm_reader_double_fifo.scala 249:33]
  wire [6:0] src_index_queue_io_count; // @[hbm_reader_double_fifo.scala 249:33]
  reg  stateReg; // @[hbm_reader_double_fifo.scala 68:27]
  wire  readData_vec_0_0_empty = fifo_generator_readData_syn_empty; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T = ~readData_vec_0_0_empty; // @[hbm_reader_double_fifo.scala 102:44]
  wire [63:0] readData_vec_0_0_dout = fifo_generator_readData_syn_dout; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire [63:0] _T_1 = ~readData_vec_0_0_dout; // @[hbm_reader_double_fifo.scala 103:46]
  wire [63:0] _T_2 = ~_T_1; // @[hbm_reader_double_fifo.scala 103:44]
  wire  readData_vec_1_0_empty = fifo_generator_readData_syn_4_empty; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_3 = ~readData_vec_1_0_empty; // @[hbm_reader_double_fifo.scala 105:44]
  wire [63:0] readData_vec_1_0_dout = fifo_generator_readData_syn_4_dout; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire [63:0] _T_4 = ~readData_vec_1_0_dout; // @[hbm_reader_double_fifo.scala 106:46]
  wire [63:0] _T_5 = ~_T_4; // @[hbm_reader_double_fifo.scala 106:44]
  wire  readData_vec_0_1_empty = fifo_generator_readData_syn_1_empty; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_6 = ~readData_vec_0_1_empty; // @[hbm_reader_double_fifo.scala 102:44]
  wire [63:0] readData_vec_0_1_dout = fifo_generator_readData_syn_1_dout; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire [63:0] _T_7 = ~readData_vec_0_1_dout; // @[hbm_reader_double_fifo.scala 103:46]
  wire [63:0] _T_8 = ~_T_7; // @[hbm_reader_double_fifo.scala 103:44]
  wire  readData_vec_1_1_empty = fifo_generator_readData_syn_5_empty; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_9 = ~readData_vec_1_1_empty; // @[hbm_reader_double_fifo.scala 105:44]
  wire [63:0] readData_vec_1_1_dout = fifo_generator_readData_syn_5_dout; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire [63:0] _T_10 = ~readData_vec_1_1_dout; // @[hbm_reader_double_fifo.scala 106:46]
  wire [63:0] _T_11 = ~_T_10; // @[hbm_reader_double_fifo.scala 106:44]
  wire  readData_vec_0_2_empty = fifo_generator_readData_syn_2_empty; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_12 = ~readData_vec_0_2_empty; // @[hbm_reader_double_fifo.scala 102:44]
  wire [63:0] readData_vec_0_2_dout = fifo_generator_readData_syn_2_dout; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire [63:0] _T_13 = ~readData_vec_0_2_dout; // @[hbm_reader_double_fifo.scala 103:46]
  wire [63:0] _T_14 = ~_T_13; // @[hbm_reader_double_fifo.scala 103:44]
  wire  readData_vec_1_2_empty = fifo_generator_readData_syn_6_empty; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_15 = ~readData_vec_1_2_empty; // @[hbm_reader_double_fifo.scala 105:44]
  wire [63:0] readData_vec_1_2_dout = fifo_generator_readData_syn_6_dout; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire [63:0] _T_16 = ~readData_vec_1_2_dout; // @[hbm_reader_double_fifo.scala 106:46]
  wire [63:0] _T_17 = ~_T_16; // @[hbm_reader_double_fifo.scala 106:44]
  wire  readData_vec_0_3_empty = fifo_generator_readData_syn_3_empty; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_18 = ~readData_vec_0_3_empty; // @[hbm_reader_double_fifo.scala 102:44]
  wire [63:0] readData_vec_0_3_dout = fifo_generator_readData_syn_3_dout; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire [63:0] _T_19 = ~readData_vec_0_3_dout; // @[hbm_reader_double_fifo.scala 103:46]
  wire [63:0] _T_20 = ~_T_19; // @[hbm_reader_double_fifo.scala 103:44]
  wire  readData_vec_1_3_empty = fifo_generator_readData_syn_7_empty; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_21 = ~readData_vec_1_3_empty; // @[hbm_reader_double_fifo.scala 105:44]
  wire [63:0] readData_vec_1_3_dout = fifo_generator_readData_syn_7_dout; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire [63:0] _T_22 = ~readData_vec_1_3_dout; // @[hbm_reader_double_fifo.scala 106:46]
  wire [63:0] _T_23 = ~_T_22; // @[hbm_reader_double_fifo.scala 106:44]
  wire [71:0] _T_24 = {io_interface_to_pe_writeAddr_bits_addr,io_interface_to_pe_writeAddr_bits_len}; // @[Cat.scala 29:58]
  wire [77:0] _T_25 = {io_interface_to_pe_writeAddr_bits_addr,io_interface_to_pe_writeAddr_bits_len,io_interface_to_pe_writeAddr_bits_id}; // @[Cat.scala 29:58]
  wire [77:0] _T_27 = writeAddr_dout;
  wire [5:0] _T_28 = _T_27[5:0]; // @[hbm_reader_double_fifo.scala 135:31]
  wire [7:0] _T_29 = _T_27[13:6]; // @[hbm_reader_double_fifo.scala 135:31]
  wire [63:0] _T_30 = _T_27[77:14]; // @[hbm_reader_double_fifo.scala 135:31]
  wire  _T_31 = ~writeAddr_full; // @[hbm_reader_double_fifo.scala 136:5]
  wire  _T_32 = ~writeAddr_empty; // @[hbm_reader_double_fifo.scala 137:5]
  wire [287:0] _T_33 = {io_interface_to_pe_writeData_bits_data,io_interface_to_pe_writeData_bits_strb}; // @[Cat.scala 29:58]
  wire [288:0] _T_34 = {io_interface_to_pe_writeData_bits_data,io_interface_to_pe_writeData_bits_strb,io_interface_to_pe_writeData_bits_last}; // @[Cat.scala 29:58]
  wire [288:0] _T_36 = writeData_dout;
  wire  _T_37 = _T_36[0]; // @[hbm_reader_double_fifo.scala 148:31]
  wire [31:0] _T_38 = _T_36[32:1]; // @[hbm_reader_double_fifo.scala 148:31]
  wire [255:0] _T_39 = _T_36[288:33]; // @[hbm_reader_double_fifo.scala 148:31]
  wire  _T_40 = ~writeData_full; // @[hbm_reader_double_fifo.scala 149:5]
  wire  _T_41 = ~writeData_empty; // @[hbm_reader_double_fifo.scala 150:5]
  wire [71:0] _T_42 = {io_interface_to_pe_readAddr_bits_addr,io_interface_to_pe_readAddr_bits_len}; // @[Cat.scala 29:58]
  wire [77:0] _T_43 = {io_interface_to_pe_readAddr_bits_addr,io_interface_to_pe_readAddr_bits_len,io_interface_to_pe_readAddr_bits_id}; // @[Cat.scala 29:58]
  wire [77:0] _T_45 = readAddr_dout;
  wire [5:0] _T_46 = _T_45[5:0]; // @[hbm_reader_double_fifo.scala 161:30]
  wire [7:0] _T_47 = _T_45[13:6]; // @[hbm_reader_double_fifo.scala 161:30]
  wire [63:0] _T_48 = _T_45[77:14]; // @[hbm_reader_double_fifo.scala 161:30]
  wire  _T_49 = ~readAddr_full; // @[hbm_reader_double_fifo.scala 162:5]
  wire  _T_50 = ~readAddr_empty; // @[hbm_reader_double_fifo.scala 163:5]
  wire [7:0] _T_51 = {io_HBM_interface_writeResp_bits_id,io_HBM_interface_writeResp_bits_resp}; // @[Cat.scala 29:58]
  wire [7:0] _T_53 = writeResp_dout;
  wire [1:0] _T_54 = _T_53[1:0]; // @[hbm_reader_double_fifo.scala 174:31]
  wire [5:0] _T_55 = _T_53[7:2]; // @[hbm_reader_double_fifo.scala 174:31]
  wire  _T_56 = ~writeResp_full; // @[hbm_reader_double_fifo.scala 175:5]
  wire  _T_57 = ~writeResp_empty; // @[hbm_reader_double_fifo.scala 176:5]
  wire  readData_vec_asy_0_wr_en = RRArbiter_io_out_valid & RRArbiter_io_out_ready; // @[hbm_reader_double_fifo.scala 198:69]
  wire [63:0] readData_vec_asy_0_dout = fifo_generator_readData_dout; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire [255:0] _T_60 = {{192'd0}, readData_vec_asy_0_dout};
  wire [255:0] _T_61 = _T_60; // @[hbm_reader_double_fifo.scala 200:38]
  wire  readData_vec_asy_0_full = fifo_generator_readData_full; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_62 = ~readData_vec_asy_0_full; // @[hbm_reader_double_fifo.scala 201:5]
  wire  readData_vec_asy_0_empty = fifo_generator_readData_empty; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_63 = ~readData_vec_asy_0_empty; // @[hbm_reader_double_fifo.scala 202:5]
  wire  readData_vec_asy_1_wr_en = RRArbiter_1_io_out_valid & RRArbiter_1_io_out_ready; // @[hbm_reader_double_fifo.scala 198:69]
  wire [63:0] readData_vec_asy_1_dout = fifo_generator_readData_1_dout; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire [255:0] _T_66 = {{192'd0}, readData_vec_asy_1_dout};
  wire [255:0] _T_67 = _T_66; // @[hbm_reader_double_fifo.scala 200:38]
  wire  readData_vec_asy_1_full = fifo_generator_readData_1_full; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_68 = ~readData_vec_asy_1_full; // @[hbm_reader_double_fifo.scala 201:5]
  wire  readData_vec_asy_1_empty = fifo_generator_readData_1_empty; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_69 = ~readData_vec_asy_1_empty; // @[hbm_reader_double_fifo.scala 202:5]
  wire  readData_vec_asy_2_wr_en = RRArbiter_2_io_out_valid & RRArbiter_2_io_out_ready; // @[hbm_reader_double_fifo.scala 198:69]
  wire [63:0] readData_vec_asy_2_dout = fifo_generator_readData_2_dout; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire [255:0] _T_72 = {{192'd0}, readData_vec_asy_2_dout};
  wire [255:0] _T_73 = _T_72; // @[hbm_reader_double_fifo.scala 200:38]
  wire  readData_vec_asy_2_full = fifo_generator_readData_2_full; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_74 = ~readData_vec_asy_2_full; // @[hbm_reader_double_fifo.scala 201:5]
  wire  readData_vec_asy_2_empty = fifo_generator_readData_2_empty; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_75 = ~readData_vec_asy_2_empty; // @[hbm_reader_double_fifo.scala 202:5]
  wire  readData_vec_asy_3_wr_en = RRArbiter_3_io_out_valid & RRArbiter_3_io_out_ready; // @[hbm_reader_double_fifo.scala 198:69]
  wire [63:0] readData_vec_asy_3_dout = fifo_generator_readData_3_dout; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire [255:0] _T_78 = {{192'd0}, readData_vec_asy_3_dout};
  wire [255:0] _T_79 = _T_78; // @[hbm_reader_double_fifo.scala 200:38]
  wire  readData_vec_asy_3_full = fifo_generator_readData_3_full; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_80 = ~readData_vec_asy_3_full; // @[hbm_reader_double_fifo.scala 201:5]
  wire  readData_vec_asy_3_empty = fifo_generator_readData_3_empty; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 94:35]
  wire  _T_81 = ~readData_vec_asy_3_empty; // @[hbm_reader_double_fifo.scala 202:5]
  wire [63:0] _T_82 = io_HBM_interface_readData_bits_data[63:0]; // @[hbm_reader_double_fifo.scala 237:73]
  wire [63:0] _T_84 = readData_offset_dout;
  wire [63:0] _T_85 = _T_84; // @[hbm_reader_double_fifo.scala 240:37]
  wire  _T_86 = ~readData_offset_empty; // @[hbm_reader_double_fifo.scala 243:5]
  wire [31:0] _T_87 = ~io_src_bits; // @[hbm_reader_double_fifo.scala 254:45]
  wire [31:0] _T_88 = ~_T_87; // @[hbm_reader_double_fifo.scala 254:43]
  wire  _T_89 = ~io_src_valid; // @[hbm_reader_double_fifo.scala 255:45]
  wire  _T_90 = ~_T_89; // @[hbm_reader_double_fifo.scala 255:43]
  wire  _T_91 = ~src_index_queue_l1_io_enq_ready; // @[hbm_reader_double_fifo.scala 258:45]
  wire  _T_92 = ~_T_91; // @[hbm_reader_double_fifo.scala 258:43]
  wire [31:0] _T_93 = ~src_index_queue_asyn_dout; // @[hbm_reader_double_fifo.scala 259:7]
  wire [31:0] _T_94 = ~_T_93; // @[hbm_reader_double_fifo.scala 259:5]
  wire  _T_95 = ~src_index_queue_asyn_full; // @[hbm_reader_double_fifo.scala 260:9]
  wire  _T_96 = ~_T_95; // @[hbm_reader_double_fifo.scala 260:7]
  wire  _T_97 = ~_T_96; // @[hbm_reader_double_fifo.scala 260:5]
  wire  _T_98 = ~src_index_queue_asyn_empty; // @[hbm_reader_double_fifo.scala 262:9]
  wire  _T_99 = ~_T_98; // @[hbm_reader_double_fifo.scala 262:7]
  wire  _T_100 = ~_T_99; // @[hbm_reader_double_fifo.scala 262:5]
  wire  _T_101 = io_HBM_interface_readData_ready & io_HBM_interface_readData_valid; // @[hbm_reader_double_fifo.scala 269:84]
  wire  _T_102 = io_HBM_interface_readData_bits_id == 6'h1; // @[hbm_reader_double_fifo.scala 269:156]
  wire  _T_103 = _T_101 & _T_102; // @[hbm_reader_double_fifo.scala 269:119]
  reg [30:0] count_burst_i0; // @[Counter.scala 29:33]
  wire  _T_104 = count_burst_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_105 = count_burst_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_106 = count_burst_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_104 ? 31'h0 : _T_106; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_103 ? _GEN_0 : count_burst_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_103 & _T_104; // @[Counter.scala 67:17]
  wire  _T_58 = readData_vec_asy_0_wr_en; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 198:36]
  wire  _T_107 = ~readData_vec_asy_0_wr_en; // @[hbm_reader_double_fifo.scala 279:39]
  wire  _T_108 = ~_T_107; // @[hbm_reader_double_fifo.scala 279:37]
  wire  _T_109 = _T_108; // @[hbm_reader_double_fifo.scala 279:67]
  reg [30:0] _T_110; // @[Counter.scala 29:33]
  wire  _T_112 = _T_110 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_113 = _T_110 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_114 = _T_110 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_112 ? 31'h0 : _T_114; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_108 ? _GEN_3 : _T_110; // @[Counter.scala 67:17]
  wire  _GEN_5 = _T_108 & _T_112; // @[Counter.scala 67:17]
  wire  _T_64 = readData_vec_asy_1_wr_en; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 198:36]
  wire  _T_115 = ~readData_vec_asy_1_wr_en; // @[hbm_reader_double_fifo.scala 279:39]
  wire  _T_116 = ~_T_115; // @[hbm_reader_double_fifo.scala 279:37]
  wire  _T_117 = _T_116; // @[hbm_reader_double_fifo.scala 279:67]
  reg [30:0] _T_118; // @[Counter.scala 29:33]
  wire  _T_120 = _T_118 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_121 = _T_118 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_122 = _T_118 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_120 ? 31'h0 : _T_122; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_116 ? _GEN_6 : _T_118; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_116 & _T_120; // @[Counter.scala 67:17]
  wire  _T_70 = readData_vec_asy_2_wr_en; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 198:36]
  wire  _T_123 = ~readData_vec_asy_2_wr_en; // @[hbm_reader_double_fifo.scala 279:39]
  wire  _T_124 = ~_T_123; // @[hbm_reader_double_fifo.scala 279:37]
  wire  _T_125 = _T_124; // @[hbm_reader_double_fifo.scala 279:67]
  reg [30:0] _T_126; // @[Counter.scala 29:33]
  wire  _T_128 = _T_126 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_129 = _T_126 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_130 = _T_126 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_128 ? 31'h0 : _T_130; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_124 ? _GEN_9 : _T_126; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_124 & _T_128; // @[Counter.scala 67:17]
  wire  _T_76 = readData_vec_asy_3_wr_en; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 198:36]
  wire  _T_131 = ~readData_vec_asy_3_wr_en; // @[hbm_reader_double_fifo.scala 279:39]
  wire  _T_132 = ~_T_131; // @[hbm_reader_double_fifo.scala 279:37]
  wire  _T_133 = _T_132; // @[hbm_reader_double_fifo.scala 279:67]
  reg [30:0] _T_134; // @[Counter.scala 29:33]
  wire  _T_136 = _T_134 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_137 = _T_134 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_138 = _T_134 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_136 ? 31'h0 : _T_138; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_132 ? _GEN_12 : _T_134; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_132 & _T_136; // @[Counter.scala 67:17]
  reg [30:0] _T_139; // @[hbm_reader_double_fifo.scala 290:39]
  wire [31:0] _T_140 = _T_110 + _T_118; // @[hbm_reader_double_fifo.scala 298:65]
  wire [30:0] _T_141 = _T_110 + _T_118; // @[hbm_reader_double_fifo.scala 298:65]
  wire [31:0] _T_142 = _T_141 + _T_126; // @[hbm_reader_double_fifo.scala 298:65]
  wire [30:0] _T_143 = _T_141 + _T_126; // @[hbm_reader_double_fifo.scala 298:65]
  wire [31:0] _T_144 = _T_143 + _T_134; // @[hbm_reader_double_fifo.scala 298:65]
  wire [30:0] _T_145 = _T_143 + _T_134; // @[hbm_reader_double_fifo.scala 298:65]
  reg [30:0] _T_146; // @[hbm_reader_double_fifo.scala 298:43]
  wire  _T_147 = io_HBM_interface_readData_bits_last & io_HBM_interface_readData_valid; // @[hbm_reader_double_fifo.scala 318:73]
  wire  _T_148 = _T_147 & io_HBM_interface_readData_ready; // @[hbm_reader_double_fifo.scala 318:108]
  wire  _T_149 = io_HBM_interface_readData_bits_id == 6'h1; // @[hbm_reader_double_fifo.scala 318:181]
  wire  _T_150 = _T_148 & _T_102; // @[hbm_reader_double_fifo.scala 318:143]
  wire  _T_215 = ~stateReg; // @[Conditional.scala 37:30]
  wire  _T_216 = io_HBM_interface_readData_valid; // @[hbm_reader_double_fifo.scala 421:54]
  wire  _T_354 = io_HBM_interface_readData_bits_id == 6'h1; // @[hbm_reader_double_fifo.scala 491:64]
  wire  readData_vec_1_0_full = fifo_generator_readData_syn_4_full; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  readData_vec_1_1_full = fifo_generator_readData_syn_5_full; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_165 = readData_vec_1_0_full | readData_vec_1_1_full; // @[hbm_reader_double_fifo.scala 349:39]
  wire  readData_vec_1_2_full = fifo_generator_readData_syn_6_full; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_166 = _T_165 | readData_vec_1_2_full; // @[hbm_reader_double_fifo.scala 349:39]
  wire  readData_vec_1_3_full = fifo_generator_readData_syn_7_full; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 93:33]
  wire  _T_167 = _T_166 | readData_vec_1_3_full; // @[hbm_reader_double_fifo.scala 349:39]
  wire  not_full_1 = ~_T_167; // @[hbm_reader_double_fifo.scala 349:19]
  wire  _T_168 = not_full_1; // @[hbm_reader_double_fifo.scala 348:26 hbm_reader_double_fifo.scala 349:16]
  wire  _T_355 = _T_102 & not_full_1; // @[hbm_reader_double_fifo.scala 491:72]
  wire  _T_356 = _T_355 & src_index_queue_io_deq_valid; // @[hbm_reader_double_fifo.scala 491:86]
  reg  flag_readData_vec; // @[hbm_reader_double_fifo.scala 368:36]
  wire  _T_357 = flag_readData_vec; // @[hbm_reader_double_fifo.scala 491:139]
  wire  _T_358 = _T_356 & flag_readData_vec; // @[hbm_reader_double_fifo.scala 491:118]
  wire [255:0] _T_152 = io_HBM_interface_readData_bits_data;
  wire [31:0] unpacked_readData_0 = io_HBM_interface_readData_bits_data[31:0]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_153 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_169 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_170 = unpacked_readData_0 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_171 = ~_T_170; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_172 = {7'h0,_T_171}; // @[Cat.scala 29:58]
  wire [31:0] unpacked_readData_1 = io_HBM_interface_readData_bits_data[63:32]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_154 = unpacked_readData_1; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_173 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_174 = unpacked_readData_1 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_175 = ~_T_174; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_176 = {7'h0,_T_175}; // @[Cat.scala 29:58]
  wire [8:0] _T_201 = _T_172 + _T_176; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_202 = _T_172 + _T_176; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_2 = io_HBM_interface_readData_bits_data[95:64]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_155 = unpacked_readData_2; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_177 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_178 = unpacked_readData_2 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_179 = ~_T_178; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_180 = {7'h0,_T_179}; // @[Cat.scala 29:58]
  wire [8:0] _T_203 = _T_202 + _T_180; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_204 = _T_202 + _T_180; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_3 = io_HBM_interface_readData_bits_data[127:96]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_156 = unpacked_readData_3; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_181 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_182 = unpacked_readData_3 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_183 = ~_T_182; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_184 = {7'h0,_T_183}; // @[Cat.scala 29:58]
  wire [8:0] _T_205 = _T_204 + _T_184; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_206 = _T_204 + _T_184; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_4 = io_HBM_interface_readData_bits_data[159:128]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_157 = unpacked_readData_4; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_185 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_186 = unpacked_readData_4 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_187 = ~_T_186; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_188 = {7'h0,_T_187}; // @[Cat.scala 29:58]
  wire [8:0] _T_207 = _T_206 + _T_188; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_208 = _T_206 + _T_188; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_5 = io_HBM_interface_readData_bits_data[191:160]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_158 = unpacked_readData_5; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_189 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_190 = unpacked_readData_5 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_191 = ~_T_190; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_192 = {7'h0,_T_191}; // @[Cat.scala 29:58]
  wire [8:0] _T_209 = _T_208 + _T_192; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_210 = _T_208 + _T_192; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_6 = io_HBM_interface_readData_bits_data[223:192]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_159 = unpacked_readData_6; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_193 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_194 = unpacked_readData_6 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_195 = ~_T_194; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_196 = {7'h0,_T_195}; // @[Cat.scala 29:58]
  wire [8:0] _T_211 = _T_210 + _T_196; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_212 = _T_210 + _T_196; // @[hbm_reader_double_fifo.scala 357:37]
  wire [31:0] unpacked_readData_7 = io_HBM_interface_readData_bits_data[255:224]; // @[hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_160 = unpacked_readData_7; // @[hbm_reader_double_fifo.scala 322:73 hbm_reader_double_fifo.scala 322:73]
  wire [31:0] _T_197 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:65]
  wire  _T_198 = unpacked_readData_7 == 32'hffffffff; // @[hbm_reader_double_fifo.scala 354:61]
  wire  _T_199 = ~_T_198; // @[hbm_reader_double_fifo.scala 354:38]
  wire [7:0] _T_200 = {7'h0,_T_199}; // @[Cat.scala 29:58]
  wire [8:0] _T_213 = _T_212 + _T_200; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] valid_data = _T_212 + _T_200; // @[hbm_reader_double_fifo.scala 357:37]
  wire [7:0] _T_214 = valid_data; // @[hbm_reader_double_fifo.scala 356:26 hbm_reader_double_fifo.scala 357:16]
  wire  _T_484 = valid_data <= 8'h4; // @[hbm_reader_double_fifo.scala 510:45]
  wire  _T_479 = valid_data > 8'h4; // @[hbm_reader_double_fifo.scala 498:45]
  wire  _T_220 = io_HBM_interface_readData_bits_id == 6'h1; // @[hbm_reader_double_fifo.scala 456:64]
  wire  readData_vec_0_0_full = fifo_generator_readData_syn_full; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  readData_vec_0_1_full = fifo_generator_readData_syn_1_full; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_161 = readData_vec_0_0_full | readData_vec_0_1_full; // @[hbm_reader_double_fifo.scala 346:39]
  wire  readData_vec_0_2_full = fifo_generator_readData_syn_2_full; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_162 = _T_161 | readData_vec_0_2_full; // @[hbm_reader_double_fifo.scala 346:39]
  wire  readData_vec_0_3_full = fifo_generator_readData_syn_3_full; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 92:33]
  wire  _T_163 = _T_162 | readData_vec_0_3_full; // @[hbm_reader_double_fifo.scala 346:39]
  wire  not_full_0 = ~_T_163; // @[hbm_reader_double_fifo.scala 346:19]
  wire  _T_164 = not_full_0; // @[hbm_reader_double_fifo.scala 345:26 hbm_reader_double_fifo.scala 346:16]
  wire  _T_221 = _T_102 & not_full_0; // @[hbm_reader_double_fifo.scala 456:72]
  wire  _T_222 = _T_221 & src_index_queue_io_deq_valid; // @[hbm_reader_double_fifo.scala 456:86]
  wire  _T_223 = ~flag_readData_vec; // @[hbm_reader_double_fifo.scala 456:139]
  wire  _T_224 = _T_222 & _T_223; // @[hbm_reader_double_fifo.scala 456:118]
  wire  _T_350 = valid_data <= 8'h4; // @[hbm_reader_double_fifo.scala 475:45]
  wire  _T_345 = valid_data > 8'h4; // @[hbm_reader_double_fifo.scala 463:45]
  wire  _GEN_131 = 1'h0; // @[hbm_reader_double_fifo.scala 463:62]
  wire  _GEN_136 = _T_484; // @[hbm_reader_double_fifo.scala 475:63]
  wire  _GEN_150 = _T_224 & _T_484; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_269 = _T_479 ? 1'h0 : _GEN_150; // @[hbm_reader_double_fifo.scala 498:62]
  wire  _GEN_274 = _T_484 | _GEN_269; // @[hbm_reader_double_fifo.scala 510:63]
  wire  _GEN_288 = _T_358 ? _GEN_274 : _GEN_150; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_304 = io_HBM_interface_readData_valid & _GEN_288; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _T_488 = stateReg; // @[Conditional.scala 37:30]
  wire  _T_620 = flag_readData_vec; // @[hbm_reader_double_fifo.scala 567:54]
  wire  _T_621 = not_full_1 & flag_readData_vec; // @[hbm_reader_double_fifo.scala 567:33]
  reg [7:0] valid_data_num; // @[hbm_reader_double_fifo.scala 358:33]
  wire  _T_747 = valid_data_num <= 8'h4; // @[hbm_reader_double_fifo.scala 587:41]
  wire  _T_742 = valid_data_num > 8'h4; // @[hbm_reader_double_fifo.scala 574:41]
  wire  _T_489 = ~flag_readData_vec; // @[hbm_reader_double_fifo.scala 531:54]
  wire  _T_490 = not_full_0 & _T_223; // @[hbm_reader_double_fifo.scala 531:33]
  wire  _T_616 = valid_data_num <= 8'h4; // @[hbm_reader_double_fifo.scala 551:41]
  wire  _T_611 = valid_data_num > 8'h4; // @[hbm_reader_double_fifo.scala 538:41]
  wire  _GEN_430 = 1'h0; // @[hbm_reader_double_fifo.scala 538:58]
  wire  _GEN_434 = _T_747; // @[hbm_reader_double_fifo.scala 551:59]
  wire  _GEN_439 = _T_490 & _T_747; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_568 = _T_742 ? 1'h0 : _GEN_439; // @[hbm_reader_double_fifo.scala 574:58]
  wire  _GEN_573 = _T_747 | _GEN_568; // @[hbm_reader_double_fifo.scala 587:59]
  wire  _GEN_587 = _T_621 ? _GEN_573 : _GEN_439; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_602 = stateReg & _GEN_587; // @[Conditional.scala 39:67]
  wire  process_src_all = _T_215 ? _GEN_304 : _GEN_602; // @[Conditional.scala 40:58]
  wire  _GEN_616 = process_src_all; // @[hbm_reader_double_fifo.scala 315:31 hbm_reader_double_fifo.scala 316:21 hbm_reader_double_fifo.scala 419:33 hbm_reader_double_fifo.scala 472:49 hbm_reader_double_fifo.scala 484:49 hbm_reader_double_fifo.scala 507:49 hbm_reader_double_fifo.scala 519:49 hbm_reader_double_fifo.scala 548:41 hbm_reader_double_fifo.scala 560:41 hbm_reader_double_fifo.scala 584:41 hbm_reader_double_fifo.scala 596:41]
  wire  _T_151 = _T_150 & process_src_all; // @[hbm_reader_double_fifo.scala 318:190]
  reg [7:0] loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 330:34]
  reg [7:0] loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 331:34]
  reg [7:0] loc_flag_data_0; // @[hbm_reader_double_fifo.scala 333:34]
  reg [7:0] loc_flag_data_1; // @[hbm_reader_double_fifo.scala 334:34]
  reg [7:0] used; // @[hbm_reader_double_fifo.scala 335:23]
  wire  _T_217 = io_HBM_interface_readData_bits_id == 6'h0; // @[hbm_reader_double_fifo.scala 423:60]
  wire  _T_218 = ~readData_offset_full; // @[hbm_reader_double_fifo.scala 423:71]
  wire  _T_219 = _T_217 & _T_218; // @[hbm_reader_double_fifo.scala 423:68]
  wire  _GEN_15 = _T_219; // @[hbm_reader_double_fifo.scala 423:96]
  reg [7:0] _T_225; // @[hbm_reader_double_fifo.scala 459:65]
  wire [8:0] _T_226 = {{1'd0}, _T_225}; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _T_227 = _T_226[7:0]; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _GEN_658 = _T_226[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_228 = _GEN_658[2:0]; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_229 = _T_228;
  wire [1:0] _T_230 = _T_228[1:0];
  wire [8:0] _T_231 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 459:140]
  wire [7:0] _T_232 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 459:140]
  wire [2:0] _T_233 = _T_231[2:0];
  wire [31:0] _T_234 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:163]
  wire [31:0] _GEN_16 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_17 = 3'h1 == _T_231[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_18 = 3'h2 == _T_231[2:0] ? unpacked_readData_2 : _GEN_17; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_19 = 3'h3 == _T_231[2:0] ? unpacked_readData_3 : _GEN_18; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_20 = 3'h4 == _T_231[2:0] ? unpacked_readData_4 : _GEN_19; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_21 = 3'h5 == _T_231[2:0] ? unpacked_readData_5 : _GEN_20; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_22 = 3'h6 == _T_231[2:0] ? unpacked_readData_6 : _GEN_21; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_23 = 3'h7 == _T_231[2:0] ? unpacked_readData_7 : _GEN_22; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _unpacked_readData_T_233 = _GEN_23; // @[hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159]
  wire  _T_235 = _GEN_23 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:159]
  wire  _T_236 = ~_T_235; // @[hbm_reader_double_fifo.scala 459:113]
  wire  _T_237 = ~_T_236; // @[hbm_reader_double_fifo.scala 459:111]
  wire  _readData_vec_0_T_230_wr_en = _T_237; // @[hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_642 = 2'h0 == _T_228[1:0]; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_24 = _GEN_642 & _T_237; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_643 = 2'h1 == _T_228[1:0]; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_25 = _GEN_643 & _T_237; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_644 = 2'h2 == _T_228[1:0]; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_26 = _GEN_644 & _T_237; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_645 = 2'h3 == _T_228[1:0]; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_27 = _GEN_645 & _T_237; // @[hbm_reader_double_fifo.scala 459:108]
  reg [7:0] _T_238; // @[hbm_reader_double_fifo.scala 460:65]
  wire [8:0] _T_239 = {{1'd0}, _T_238}; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _T_240 = _T_239[7:0]; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _GEN_659 = _T_239[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_241 = _GEN_659[2:0]; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_242 = _T_241;
  wire [1:0] _T_243 = _T_241[1:0];
  wire [15:0] _T_244 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_245 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 460:200]
  wire [7:0] _T_246 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 460:200]
  wire [2:0] _T_247 = _T_231[2:0];
  wire [8:0] _T_248 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 460:231]
  wire [7:0] _T_249 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 460:231]
  wire [1:0] _T_250 = _T_231[1:0];
  wire [23:0] neighbour_0 = unpacked_readData_0[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_28 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] neighbour_1 = unpacked_readData_1[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_29 = 3'h1 == _T_231[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] neighbour_2 = unpacked_readData_2[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_30 = 3'h2 == _T_231[2:0] ? neighbour_2 : _GEN_29; // @[Cat.scala 29:58]
  wire [23:0] neighbour_3 = unpacked_readData_3[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_31 = 3'h3 == _T_231[2:0] ? neighbour_3 : _GEN_30; // @[Cat.scala 29:58]
  wire [23:0] neighbour_4 = unpacked_readData_4[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_32 = 3'h4 == _T_231[2:0] ? neighbour_4 : _GEN_31; // @[Cat.scala 29:58]
  wire [23:0] neighbour_5 = unpacked_readData_5[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_33 = 3'h5 == _T_231[2:0] ? neighbour_5 : _GEN_32; // @[Cat.scala 29:58]
  wire [23:0] neighbour_6 = unpacked_readData_6[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_34 = 3'h6 == _T_231[2:0] ? neighbour_6 : _GEN_33; // @[Cat.scala 29:58]
  wire [23:0] neighbour_7 = unpacked_readData_7[23:0]; // @[hbm_reader_double_fifo.scala 361:25 hbm_reader_double_fifo.scala 363:22]
  wire [23:0] _GEN_35 = 3'h7 == _T_231[2:0] ? neighbour_7 : _GEN_34; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_247 = _GEN_35; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_251 = {16'h0,_GEN_35}; // @[Cat.scala 29:58]
  wire [23:0] src_0 = src_index_queue_io_deq_bits[23:0]; // @[hbm_reader_double_fifo.scala 321:19 hbm_reader_double_fifo.scala 327:19]
  wire [23:0] _GEN_36 = src_0; // @[Cat.scala 29:58]
  wire [23:0] src_1 = src_index_queue_io_deq_bits[23:0]; // @[hbm_reader_double_fifo.scala 321:19 hbm_reader_double_fifo.scala 327:19]
  wire [23:0] _GEN_37 = 2'h1 == _T_231[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] src_2 = src_index_queue_io_deq_bits[23:0]; // @[hbm_reader_double_fifo.scala 321:19 hbm_reader_double_fifo.scala 327:19]
  wire [23:0] _GEN_38 = 2'h2 == _T_231[1:0] ? src_0 : _GEN_37; // @[Cat.scala 29:58]
  wire [23:0] src_3 = src_index_queue_io_deq_bits[23:0]; // @[hbm_reader_double_fifo.scala 321:19 hbm_reader_double_fifo.scala 327:19]
  wire [23:0] _GEN_39 = 2'h3 == _T_231[1:0] ? src_0 : _GEN_38; // @[Cat.scala 29:58]
  wire [23:0] _src_T_250 = _GEN_39; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_252 = {16'h0,_GEN_35,_GEN_39}; // @[Cat.scala 29:58]
  wire [63:0] _T_253 = ~_T_252; // @[hbm_reader_double_fifo.scala 460:111]
  wire [63:0] _T_254 = ~_T_253; // @[hbm_reader_double_fifo.scala 460:109]
  wire [63:0] _readData_vec_0_T_243_din = _T_254; // @[hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_40 = _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_41 = _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_42 = _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_43 = _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  reg [7:0] _T_255; // @[hbm_reader_double_fifo.scala 459:65]
  wire [8:0] _T_256 = 8'h1 + _T_255; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _T_257 = 8'h1 + _T_255; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _GEN_660 = _T_257 % 8'h4; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_258 = _GEN_660[2:0]; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_259 = _T_258;
  wire [1:0] _T_260 = _T_258[1:0];
  wire [8:0] _T_261 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [7:0] _T_262 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [2:0] _T_263 = _T_262[2:0];
  wire [31:0] _T_264 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:163]
  wire [31:0] _GEN_44 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_45 = 3'h1 == _T_262[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_46 = 3'h2 == _T_262[2:0] ? unpacked_readData_2 : _GEN_45; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_47 = 3'h3 == _T_262[2:0] ? unpacked_readData_3 : _GEN_46; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_48 = 3'h4 == _T_262[2:0] ? unpacked_readData_4 : _GEN_47; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_49 = 3'h5 == _T_262[2:0] ? unpacked_readData_5 : _GEN_48; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_50 = 3'h6 == _T_262[2:0] ? unpacked_readData_6 : _GEN_49; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_51 = 3'h7 == _T_262[2:0] ? unpacked_readData_7 : _GEN_50; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _unpacked_readData_T_263 = _GEN_51; // @[hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159]
  wire  _T_265 = _GEN_51 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:159]
  wire  _T_266 = ~_T_265; // @[hbm_reader_double_fifo.scala 459:113]
  wire  _T_267 = ~_T_266; // @[hbm_reader_double_fifo.scala 459:111]
  wire  _readData_vec_0_T_260_wr_en = _T_267; // @[hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_52 = 2'h0 == _T_258[1:0] ? _T_267 : _GEN_24; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_53 = 2'h1 == _T_258[1:0] ? _T_267 : _GEN_25; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_54 = 2'h2 == _T_258[1:0] ? _T_267 : _GEN_26; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_55 = 2'h3 == _T_258[1:0] ? _T_267 : _GEN_27; // @[hbm_reader_double_fifo.scala 459:108]
  reg [7:0] _T_268; // @[hbm_reader_double_fifo.scala 460:65]
  wire [8:0] _T_269 = 8'h1 + _T_268; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _T_270 = 8'h1 + _T_268; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _GEN_661 = _T_270 % 8'h4; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_271 = _GEN_661[2:0]; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_272 = _T_271;
  wire [1:0] _T_273 = _T_271[1:0];
  wire [15:0] _T_274 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_275 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [7:0] _T_276 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [2:0] _T_277 = _T_262[2:0];
  wire [8:0] _T_278 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [7:0] _T_279 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [1:0] _T_280 = _T_262[1:0];
  wire [23:0] _GEN_56 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_57 = 3'h1 == _T_262[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_58 = 3'h2 == _T_262[2:0] ? neighbour_2 : _GEN_57; // @[Cat.scala 29:58]
  wire [23:0] _GEN_59 = 3'h3 == _T_262[2:0] ? neighbour_3 : _GEN_58; // @[Cat.scala 29:58]
  wire [23:0] _GEN_60 = 3'h4 == _T_262[2:0] ? neighbour_4 : _GEN_59; // @[Cat.scala 29:58]
  wire [23:0] _GEN_61 = 3'h5 == _T_262[2:0] ? neighbour_5 : _GEN_60; // @[Cat.scala 29:58]
  wire [23:0] _GEN_62 = 3'h6 == _T_262[2:0] ? neighbour_6 : _GEN_61; // @[Cat.scala 29:58]
  wire [23:0] _GEN_63 = 3'h7 == _T_262[2:0] ? neighbour_7 : _GEN_62; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_277 = _GEN_63; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_281 = {16'h0,_GEN_63}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_64 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_65 = 2'h1 == _T_262[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_66 = 2'h2 == _T_262[1:0] ? src_0 : _GEN_65; // @[Cat.scala 29:58]
  wire [23:0] _GEN_67 = 2'h3 == _T_262[1:0] ? src_0 : _GEN_66; // @[Cat.scala 29:58]
  wire [23:0] _src_T_280 = _GEN_67; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_282 = {16'h0,_GEN_63,_GEN_67}; // @[Cat.scala 29:58]
  wire [63:0] _T_283 = ~_T_282; // @[hbm_reader_double_fifo.scala 460:111]
  wire [63:0] _T_284 = ~_T_283; // @[hbm_reader_double_fifo.scala 460:109]
  wire [63:0] _readData_vec_0_T_273_din = _T_284; // @[hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_68 = 2'h0 == _T_271[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_69 = 2'h1 == _T_271[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_70 = 2'h2 == _T_271[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_71 = 2'h3 == _T_271[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 460:106]
  reg [7:0] _T_285; // @[hbm_reader_double_fifo.scala 459:65]
  wire [8:0] _T_286 = 8'h2 + _T_285; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _T_287 = 8'h2 + _T_285; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _GEN_662 = _T_287 % 8'h4; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_288 = _GEN_662[2:0]; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_289 = _T_288;
  wire [1:0] _T_290 = _T_288[1:0];
  wire [8:0] _T_291 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [7:0] _T_292 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [2:0] _T_293 = _T_292[2:0];
  wire [31:0] _T_294 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:163]
  wire [31:0] _GEN_72 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_73 = 3'h1 == _T_292[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_74 = 3'h2 == _T_292[2:0] ? unpacked_readData_2 : _GEN_73; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_75 = 3'h3 == _T_292[2:0] ? unpacked_readData_3 : _GEN_74; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_76 = 3'h4 == _T_292[2:0] ? unpacked_readData_4 : _GEN_75; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_77 = 3'h5 == _T_292[2:0] ? unpacked_readData_5 : _GEN_76; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_78 = 3'h6 == _T_292[2:0] ? unpacked_readData_6 : _GEN_77; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_79 = 3'h7 == _T_292[2:0] ? unpacked_readData_7 : _GEN_78; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _unpacked_readData_T_293 = _GEN_79; // @[hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159]
  wire  _T_295 = _GEN_79 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:159]
  wire  _T_296 = ~_T_295; // @[hbm_reader_double_fifo.scala 459:113]
  wire  _T_297 = ~_T_296; // @[hbm_reader_double_fifo.scala 459:111]
  wire  _readData_vec_0_T_290_wr_en = _T_297; // @[hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_80 = 2'h0 == _T_288[1:0] ? _T_297 : _GEN_52; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_81 = 2'h1 == _T_288[1:0] ? _T_297 : _GEN_53; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_82 = 2'h2 == _T_288[1:0] ? _T_297 : _GEN_54; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_83 = 2'h3 == _T_288[1:0] ? _T_297 : _GEN_55; // @[hbm_reader_double_fifo.scala 459:108]
  reg [7:0] _T_298; // @[hbm_reader_double_fifo.scala 460:65]
  wire [8:0] _T_299 = 8'h2 + _T_298; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _T_300 = 8'h2 + _T_298; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _GEN_663 = _T_300 % 8'h4; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_301 = _GEN_663[2:0]; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_302 = _T_301;
  wire [1:0] _T_303 = _T_301[1:0];
  wire [15:0] _T_304 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_305 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [7:0] _T_306 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [2:0] _T_307 = _T_292[2:0];
  wire [8:0] _T_308 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [7:0] _T_309 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [1:0] _T_310 = _T_292[1:0];
  wire [23:0] _GEN_84 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_85 = 3'h1 == _T_292[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_86 = 3'h2 == _T_292[2:0] ? neighbour_2 : _GEN_85; // @[Cat.scala 29:58]
  wire [23:0] _GEN_87 = 3'h3 == _T_292[2:0] ? neighbour_3 : _GEN_86; // @[Cat.scala 29:58]
  wire [23:0] _GEN_88 = 3'h4 == _T_292[2:0] ? neighbour_4 : _GEN_87; // @[Cat.scala 29:58]
  wire [23:0] _GEN_89 = 3'h5 == _T_292[2:0] ? neighbour_5 : _GEN_88; // @[Cat.scala 29:58]
  wire [23:0] _GEN_90 = 3'h6 == _T_292[2:0] ? neighbour_6 : _GEN_89; // @[Cat.scala 29:58]
  wire [23:0] _GEN_91 = 3'h7 == _T_292[2:0] ? neighbour_7 : _GEN_90; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_307 = _GEN_91; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_311 = {16'h0,_GEN_91}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_92 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_93 = 2'h1 == _T_292[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_94 = 2'h2 == _T_292[1:0] ? src_0 : _GEN_93; // @[Cat.scala 29:58]
  wire [23:0] _GEN_95 = 2'h3 == _T_292[1:0] ? src_0 : _GEN_94; // @[Cat.scala 29:58]
  wire [23:0] _src_T_310 = _GEN_95; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_312 = {16'h0,_GEN_91,_GEN_95}; // @[Cat.scala 29:58]
  wire [63:0] _T_313 = ~_T_312; // @[hbm_reader_double_fifo.scala 460:111]
  wire [63:0] _T_314 = ~_T_313; // @[hbm_reader_double_fifo.scala 460:109]
  wire [63:0] _readData_vec_0_T_303_din = _T_314; // @[hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_96 = 2'h0 == _T_301[1:0] ? _T_314 : _GEN_68; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_97 = 2'h1 == _T_301[1:0] ? _T_314 : _GEN_69; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_98 = 2'h2 == _T_301[1:0] ? _T_314 : _GEN_70; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_99 = 2'h3 == _T_301[1:0] ? _T_314 : _GEN_71; // @[hbm_reader_double_fifo.scala 460:106]
  reg [7:0] _T_315; // @[hbm_reader_double_fifo.scala 459:65]
  wire [8:0] _T_316 = 8'h3 + _T_315; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _T_317 = 8'h3 + _T_315; // @[hbm_reader_double_fifo.scala 459:56]
  wire [7:0] _GEN_664 = _T_317 % 8'h4; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_318 = _GEN_664[2:0]; // @[hbm_reader_double_fifo.scala 459:84]
  wire [2:0] _T_319 = _T_318;
  wire [1:0] _T_320 = _T_318[1:0];
  wire [8:0] _T_321 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [7:0] _T_322 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 459:140]
  wire [2:0] _T_323 = _T_322[2:0];
  wire [31:0] _T_324 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:163]
  wire [31:0] _GEN_100 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_101 = 3'h1 == _T_322[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_102 = 3'h2 == _T_322[2:0] ? unpacked_readData_2 : _GEN_101; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_103 = 3'h3 == _T_322[2:0] ? unpacked_readData_3 : _GEN_102; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_104 = 3'h4 == _T_322[2:0] ? unpacked_readData_4 : _GEN_103; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_105 = 3'h5 == _T_322[2:0] ? unpacked_readData_5 : _GEN_104; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_106 = 3'h6 == _T_322[2:0] ? unpacked_readData_6 : _GEN_105; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _GEN_107 = 3'h7 == _T_322[2:0] ? unpacked_readData_7 : _GEN_106; // @[hbm_reader_double_fifo.scala 459:159]
  wire [31:0] _unpacked_readData_T_323 = _GEN_107; // @[hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159 hbm_reader_double_fifo.scala 459:159]
  wire  _T_325 = _GEN_107 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 459:159]
  wire  _T_326 = ~_T_325; // @[hbm_reader_double_fifo.scala 459:113]
  wire  _T_327 = ~_T_326; // @[hbm_reader_double_fifo.scala 459:111]
  wire  _readData_vec_0_T_320_wr_en = _T_327; // @[hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_108 = 2'h0 == _T_318[1:0] ? _T_327 : _GEN_80; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_109 = 2'h1 == _T_318[1:0] ? _T_327 : _GEN_81; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_110 = 2'h2 == _T_318[1:0] ? _T_327 : _GEN_82; // @[hbm_reader_double_fifo.scala 459:108]
  wire  _GEN_111 = 2'h3 == _T_318[1:0] ? _T_327 : _GEN_83; // @[hbm_reader_double_fifo.scala 459:108]
  reg [7:0] _T_328; // @[hbm_reader_double_fifo.scala 460:65]
  wire [8:0] _T_329 = 8'h3 + _T_328; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _T_330 = 8'h3 + _T_328; // @[hbm_reader_double_fifo.scala 460:56]
  wire [7:0] _GEN_665 = _T_330 % 8'h4; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_331 = _GEN_665[2:0]; // @[hbm_reader_double_fifo.scala 460:84]
  wire [2:0] _T_332 = _T_331;
  wire [1:0] _T_333 = _T_331[1:0];
  wire [15:0] _T_334 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_335 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [7:0] _T_336 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:200]
  wire [2:0] _T_337 = _T_322[2:0];
  wire [8:0] _T_338 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [7:0] _T_339 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 460:231]
  wire [1:0] _T_340 = _T_322[1:0];
  wire [23:0] _GEN_112 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_113 = 3'h1 == _T_322[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_114 = 3'h2 == _T_322[2:0] ? neighbour_2 : _GEN_113; // @[Cat.scala 29:58]
  wire [23:0] _GEN_115 = 3'h3 == _T_322[2:0] ? neighbour_3 : _GEN_114; // @[Cat.scala 29:58]
  wire [23:0] _GEN_116 = 3'h4 == _T_322[2:0] ? neighbour_4 : _GEN_115; // @[Cat.scala 29:58]
  wire [23:0] _GEN_117 = 3'h5 == _T_322[2:0] ? neighbour_5 : _GEN_116; // @[Cat.scala 29:58]
  wire [23:0] _GEN_118 = 3'h6 == _T_322[2:0] ? neighbour_6 : _GEN_117; // @[Cat.scala 29:58]
  wire [23:0] _GEN_119 = 3'h7 == _T_322[2:0] ? neighbour_7 : _GEN_118; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_337 = _GEN_119; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_341 = {16'h0,_GEN_119}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_120 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_121 = 2'h1 == _T_322[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_122 = 2'h2 == _T_322[1:0] ? src_0 : _GEN_121; // @[Cat.scala 29:58]
  wire [23:0] _GEN_123 = 2'h3 == _T_322[1:0] ? src_0 : _GEN_122; // @[Cat.scala 29:58]
  wire [23:0] _src_T_340 = _GEN_123; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_342 = {16'h0,_GEN_119,_GEN_123}; // @[Cat.scala 29:58]
  wire [63:0] _T_343 = ~_T_342; // @[hbm_reader_double_fifo.scala 460:111]
  wire [63:0] _T_344 = ~_T_343; // @[hbm_reader_double_fifo.scala 460:109]
  wire [63:0] _readData_vec_0_T_333_din = _T_344; // @[hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_124 = 2'h0 == _T_331[1:0] ? _T_344 : _GEN_96; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_125 = 2'h1 == _T_331[1:0] ? _T_344 : _GEN_97; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_126 = 2'h2 == _T_331[1:0] ? _T_344 : _GEN_98; // @[hbm_reader_double_fifo.scala 460:106]
  wire [63:0] _GEN_127 = 2'h3 == _T_331[1:0] ? _T_344 : _GEN_99; // @[hbm_reader_double_fifo.scala 460:106]
  wire [8:0] _T_346 = valid_data - 8'h4; // @[hbm_reader_double_fifo.scala 470:62]
  wire [7:0] _T_347 = valid_data - 8'h4; // @[hbm_reader_double_fifo.scala 470:62]
  wire [8:0] _T_348 = loc_flag_data_0 + 8'h4; // @[hbm_reader_double_fifo.scala 471:68]
  wire [7:0] _T_349 = loc_flag_data_0 + 8'h4; // @[hbm_reader_double_fifo.scala 471:68]
  wire  _GEN_128 = _T_479 ? 1'h0 : _T_219; // @[hbm_reader_double_fifo.scala 463:62]
  wire [7:0] _GEN_129 = _T_479 ? _T_347 : valid_data_num; // @[hbm_reader_double_fifo.scala 463:62]
  wire [7:0] _GEN_130 = _T_479 ? _T_349 : loc_flag_data_0; // @[hbm_reader_double_fifo.scala 463:62]
  wire  _GEN_132 = _T_479 | stateReg; // @[hbm_reader_double_fifo.scala 463:62]
  wire [8:0] _T_351 = loc_flag_fifo_0 + valid_data; // @[hbm_reader_double_fifo.scala 482:69]
  wire [7:0] _T_352 = loc_flag_fifo_0 + valid_data; // @[hbm_reader_double_fifo.scala 482:69]
  wire [7:0] _GEN_666 = _T_352 % 8'h4; // @[hbm_reader_double_fifo.scala 482:83]
  wire [2:0] _T_353 = _GEN_666[2:0]; // @[hbm_reader_double_fifo.scala 482:83]
  wire  _GEN_133 = _T_484 | _GEN_128; // @[hbm_reader_double_fifo.scala 475:63]
  wire [7:0] _GEN_134 = _T_484 ? {{5'd0}, _T_353} : loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 475:63]
  wire [7:0] _GEN_135 = _T_484 ? 8'h0 : _GEN_130; // @[hbm_reader_double_fifo.scala 475:63]
  wire  _GEN_137 = _T_484 | flag_readData_vec; // @[hbm_reader_double_fifo.scala 475:63]
  wire  _GEN_138 = _T_484 ? 1'h0 : _GEN_132; // @[hbm_reader_double_fifo.scala 475:63]
  wire  _GEN_139 = _T_224 & _GEN_108; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_140 = _T_224 & _GEN_109; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_141 = _T_224 & _GEN_110; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_142 = _T_224 & _GEN_111; // @[hbm_reader_double_fifo.scala 456:147]
  wire [63:0] _GEN_143 = _GEN_124; // @[hbm_reader_double_fifo.scala 456:147]
  wire [63:0] _GEN_144 = _GEN_125; // @[hbm_reader_double_fifo.scala 456:147]
  wire [63:0] _GEN_145 = _GEN_126; // @[hbm_reader_double_fifo.scala 456:147]
  wire [63:0] _GEN_146 = _GEN_127; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_147 = _T_224 ? _GEN_133 : _T_219; // @[hbm_reader_double_fifo.scala 456:147]
  wire [7:0] _GEN_148 = _T_224 ? _GEN_129 : valid_data_num; // @[hbm_reader_double_fifo.scala 456:147]
  wire [7:0] _GEN_149 = _T_224 ? _GEN_135 : loc_flag_data_0; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_151 = _T_224 ? _GEN_138 : stateReg; // @[hbm_reader_double_fifo.scala 456:147]
  wire [7:0] _GEN_152 = _T_224 ? _GEN_134 : loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 456:147]
  wire  _GEN_153 = _T_224 ? _GEN_137 : flag_readData_vec; // @[hbm_reader_double_fifo.scala 456:147]
  reg [7:0] _T_359; // @[hbm_reader_double_fifo.scala 494:65]
  wire [8:0] _T_360 = {{1'd0}, _T_359}; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _T_361 = _T_360[7:0]; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _GEN_667 = _T_360[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_362 = _GEN_667[2:0]; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_363 = _T_362;
  wire [1:0] _T_364 = _T_362[1:0];
  wire [8:0] _T_365 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 494:140]
  wire [7:0] _T_366 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 494:140]
  wire [2:0] _T_367 = _T_365[2:0];
  wire [31:0] _T_368 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:163]
  wire [31:0] _GEN_154 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_155 = 3'h1 == _T_365[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_156 = 3'h2 == _T_365[2:0] ? unpacked_readData_2 : _GEN_155; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_157 = 3'h3 == _T_365[2:0] ? unpacked_readData_3 : _GEN_156; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_158 = 3'h4 == _T_365[2:0] ? unpacked_readData_4 : _GEN_157; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_159 = 3'h5 == _T_365[2:0] ? unpacked_readData_5 : _GEN_158; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_160 = 3'h6 == _T_365[2:0] ? unpacked_readData_6 : _GEN_159; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_161 = 3'h7 == _T_365[2:0] ? unpacked_readData_7 : _GEN_160; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _unpacked_readData_T_367 = _GEN_161; // @[hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159]
  wire  _T_369 = _GEN_161 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:159]
  wire  _T_370 = ~_T_369; // @[hbm_reader_double_fifo.scala 494:113]
  wire  _T_371 = ~_T_370; // @[hbm_reader_double_fifo.scala 494:111]
  wire  _readData_vec_1_T_364_wr_en = _T_371; // @[hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_646 = 2'h0 == _T_362[1:0]; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_162 = _GEN_646 & _T_371; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_647 = 2'h1 == _T_362[1:0]; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_163 = _GEN_647 & _T_371; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_648 = 2'h2 == _T_362[1:0]; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_164 = _GEN_648 & _T_371; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_649 = 2'h3 == _T_362[1:0]; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_165 = _GEN_649 & _T_371; // @[hbm_reader_double_fifo.scala 494:108]
  reg [7:0] _T_372; // @[hbm_reader_double_fifo.scala 495:65]
  wire [8:0] _T_373 = {{1'd0}, _T_372}; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _T_374 = _T_373[7:0]; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _GEN_668 = _T_373[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_375 = _GEN_668[2:0]; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_376 = _T_375;
  wire [1:0] _T_377 = _T_375[1:0];
  wire [15:0] _T_378 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_379 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 495:200]
  wire [7:0] _T_380 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 495:200]
  wire [2:0] _T_381 = _T_365[2:0];
  wire [8:0] _T_382 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 495:231]
  wire [7:0] _T_383 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 495:231]
  wire [1:0] _T_384 = _T_365[1:0];
  wire [23:0] _GEN_166 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_167 = 3'h1 == _T_365[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_168 = 3'h2 == _T_365[2:0] ? neighbour_2 : _GEN_167; // @[Cat.scala 29:58]
  wire [23:0] _GEN_169 = 3'h3 == _T_365[2:0] ? neighbour_3 : _GEN_168; // @[Cat.scala 29:58]
  wire [23:0] _GEN_170 = 3'h4 == _T_365[2:0] ? neighbour_4 : _GEN_169; // @[Cat.scala 29:58]
  wire [23:0] _GEN_171 = 3'h5 == _T_365[2:0] ? neighbour_5 : _GEN_170; // @[Cat.scala 29:58]
  wire [23:0] _GEN_172 = 3'h6 == _T_365[2:0] ? neighbour_6 : _GEN_171; // @[Cat.scala 29:58]
  wire [23:0] _GEN_173 = 3'h7 == _T_365[2:0] ? neighbour_7 : _GEN_172; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_381 = _GEN_173; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_385 = {16'h0,_GEN_173}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_174 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_175 = 2'h1 == _T_365[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_176 = 2'h2 == _T_365[1:0] ? src_0 : _GEN_175; // @[Cat.scala 29:58]
  wire [23:0] _GEN_177 = 2'h3 == _T_365[1:0] ? src_0 : _GEN_176; // @[Cat.scala 29:58]
  wire [23:0] _src_T_384 = _GEN_177; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_386 = {16'h0,_GEN_173,_GEN_177}; // @[Cat.scala 29:58]
  wire [63:0] _T_387 = ~_T_386; // @[hbm_reader_double_fifo.scala 495:111]
  wire [63:0] _T_388 = ~_T_387; // @[hbm_reader_double_fifo.scala 495:109]
  wire [63:0] _readData_vec_1_T_377_din = _T_388; // @[hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_178 = _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_179 = _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_180 = _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_181 = _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  reg [7:0] _T_389; // @[hbm_reader_double_fifo.scala 494:65]
  wire [8:0] _T_390 = 8'h1 + _T_389; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _T_391 = 8'h1 + _T_389; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _GEN_669 = _T_391 % 8'h4; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_392 = _GEN_669[2:0]; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_393 = _T_392;
  wire [1:0] _T_394 = _T_392[1:0];
  wire [8:0] _T_395 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [7:0] _T_396 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [2:0] _T_397 = _T_396[2:0];
  wire [31:0] _T_398 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:163]
  wire [31:0] _GEN_182 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_183 = 3'h1 == _T_396[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_184 = 3'h2 == _T_396[2:0] ? unpacked_readData_2 : _GEN_183; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_185 = 3'h3 == _T_396[2:0] ? unpacked_readData_3 : _GEN_184; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_186 = 3'h4 == _T_396[2:0] ? unpacked_readData_4 : _GEN_185; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_187 = 3'h5 == _T_396[2:0] ? unpacked_readData_5 : _GEN_186; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_188 = 3'h6 == _T_396[2:0] ? unpacked_readData_6 : _GEN_187; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_189 = 3'h7 == _T_396[2:0] ? unpacked_readData_7 : _GEN_188; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _unpacked_readData_T_397 = _GEN_189; // @[hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159]
  wire  _T_399 = _GEN_189 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:159]
  wire  _T_400 = ~_T_399; // @[hbm_reader_double_fifo.scala 494:113]
  wire  _T_401 = ~_T_400; // @[hbm_reader_double_fifo.scala 494:111]
  wire  _readData_vec_1_T_394_wr_en = _T_401; // @[hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_190 = 2'h0 == _T_392[1:0] ? _T_401 : _GEN_162; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_191 = 2'h1 == _T_392[1:0] ? _T_401 : _GEN_163; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_192 = 2'h2 == _T_392[1:0] ? _T_401 : _GEN_164; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_193 = 2'h3 == _T_392[1:0] ? _T_401 : _GEN_165; // @[hbm_reader_double_fifo.scala 494:108]
  reg [7:0] _T_402; // @[hbm_reader_double_fifo.scala 495:65]
  wire [8:0] _T_403 = 8'h1 + _T_402; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _T_404 = 8'h1 + _T_402; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _GEN_670 = _T_404 % 8'h4; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_405 = _GEN_670[2:0]; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_406 = _T_405;
  wire [1:0] _T_407 = _T_405[1:0];
  wire [15:0] _T_408 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_409 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [7:0] _T_410 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [2:0] _T_411 = _T_396[2:0];
  wire [8:0] _T_412 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [7:0] _T_413 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [1:0] _T_414 = _T_396[1:0];
  wire [23:0] _GEN_194 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_195 = 3'h1 == _T_396[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_196 = 3'h2 == _T_396[2:0] ? neighbour_2 : _GEN_195; // @[Cat.scala 29:58]
  wire [23:0] _GEN_197 = 3'h3 == _T_396[2:0] ? neighbour_3 : _GEN_196; // @[Cat.scala 29:58]
  wire [23:0] _GEN_198 = 3'h4 == _T_396[2:0] ? neighbour_4 : _GEN_197; // @[Cat.scala 29:58]
  wire [23:0] _GEN_199 = 3'h5 == _T_396[2:0] ? neighbour_5 : _GEN_198; // @[Cat.scala 29:58]
  wire [23:0] _GEN_200 = 3'h6 == _T_396[2:0] ? neighbour_6 : _GEN_199; // @[Cat.scala 29:58]
  wire [23:0] _GEN_201 = 3'h7 == _T_396[2:0] ? neighbour_7 : _GEN_200; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_411 = _GEN_201; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_415 = {16'h0,_GEN_201}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_202 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_203 = 2'h1 == _T_396[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_204 = 2'h2 == _T_396[1:0] ? src_0 : _GEN_203; // @[Cat.scala 29:58]
  wire [23:0] _GEN_205 = 2'h3 == _T_396[1:0] ? src_0 : _GEN_204; // @[Cat.scala 29:58]
  wire [23:0] _src_T_414 = _GEN_205; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_416 = {16'h0,_GEN_201,_GEN_205}; // @[Cat.scala 29:58]
  wire [63:0] _T_417 = ~_T_416; // @[hbm_reader_double_fifo.scala 495:111]
  wire [63:0] _T_418 = ~_T_417; // @[hbm_reader_double_fifo.scala 495:109]
  wire [63:0] _readData_vec_1_T_407_din = _T_418; // @[hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_206 = 2'h0 == _T_405[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_207 = 2'h1 == _T_405[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_208 = 2'h2 == _T_405[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_209 = 2'h3 == _T_405[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 495:106]
  reg [7:0] _T_419; // @[hbm_reader_double_fifo.scala 494:65]
  wire [8:0] _T_420 = 8'h2 + _T_419; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _T_421 = 8'h2 + _T_419; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _GEN_671 = _T_421 % 8'h4; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_422 = _GEN_671[2:0]; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_423 = _T_422;
  wire [1:0] _T_424 = _T_422[1:0];
  wire [8:0] _T_425 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [7:0] _T_426 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [2:0] _T_427 = _T_426[2:0];
  wire [31:0] _T_428 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:163]
  wire [31:0] _GEN_210 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_211 = 3'h1 == _T_426[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_212 = 3'h2 == _T_426[2:0] ? unpacked_readData_2 : _GEN_211; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_213 = 3'h3 == _T_426[2:0] ? unpacked_readData_3 : _GEN_212; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_214 = 3'h4 == _T_426[2:0] ? unpacked_readData_4 : _GEN_213; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_215 = 3'h5 == _T_426[2:0] ? unpacked_readData_5 : _GEN_214; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_216 = 3'h6 == _T_426[2:0] ? unpacked_readData_6 : _GEN_215; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_217 = 3'h7 == _T_426[2:0] ? unpacked_readData_7 : _GEN_216; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _unpacked_readData_T_427 = _GEN_217; // @[hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159]
  wire  _T_429 = _GEN_217 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:159]
  wire  _T_430 = ~_T_429; // @[hbm_reader_double_fifo.scala 494:113]
  wire  _T_431 = ~_T_430; // @[hbm_reader_double_fifo.scala 494:111]
  wire  _readData_vec_1_T_424_wr_en = _T_431; // @[hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_218 = 2'h0 == _T_422[1:0] ? _T_431 : _GEN_190; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_219 = 2'h1 == _T_422[1:0] ? _T_431 : _GEN_191; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_220 = 2'h2 == _T_422[1:0] ? _T_431 : _GEN_192; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_221 = 2'h3 == _T_422[1:0] ? _T_431 : _GEN_193; // @[hbm_reader_double_fifo.scala 494:108]
  reg [7:0] _T_432; // @[hbm_reader_double_fifo.scala 495:65]
  wire [8:0] _T_433 = 8'h2 + _T_432; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _T_434 = 8'h2 + _T_432; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _GEN_672 = _T_434 % 8'h4; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_435 = _GEN_672[2:0]; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_436 = _T_435;
  wire [1:0] _T_437 = _T_435[1:0];
  wire [15:0] _T_438 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_439 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [7:0] _T_440 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [2:0] _T_441 = _T_426[2:0];
  wire [8:0] _T_442 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [7:0] _T_443 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [1:0] _T_444 = _T_426[1:0];
  wire [23:0] _GEN_222 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_223 = 3'h1 == _T_426[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_224 = 3'h2 == _T_426[2:0] ? neighbour_2 : _GEN_223; // @[Cat.scala 29:58]
  wire [23:0] _GEN_225 = 3'h3 == _T_426[2:0] ? neighbour_3 : _GEN_224; // @[Cat.scala 29:58]
  wire [23:0] _GEN_226 = 3'h4 == _T_426[2:0] ? neighbour_4 : _GEN_225; // @[Cat.scala 29:58]
  wire [23:0] _GEN_227 = 3'h5 == _T_426[2:0] ? neighbour_5 : _GEN_226; // @[Cat.scala 29:58]
  wire [23:0] _GEN_228 = 3'h6 == _T_426[2:0] ? neighbour_6 : _GEN_227; // @[Cat.scala 29:58]
  wire [23:0] _GEN_229 = 3'h7 == _T_426[2:0] ? neighbour_7 : _GEN_228; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_441 = _GEN_229; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_445 = {16'h0,_GEN_229}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_230 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_231 = 2'h1 == _T_426[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_232 = 2'h2 == _T_426[1:0] ? src_0 : _GEN_231; // @[Cat.scala 29:58]
  wire [23:0] _GEN_233 = 2'h3 == _T_426[1:0] ? src_0 : _GEN_232; // @[Cat.scala 29:58]
  wire [23:0] _src_T_444 = _GEN_233; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_446 = {16'h0,_GEN_229,_GEN_233}; // @[Cat.scala 29:58]
  wire [63:0] _T_447 = ~_T_446; // @[hbm_reader_double_fifo.scala 495:111]
  wire [63:0] _T_448 = ~_T_447; // @[hbm_reader_double_fifo.scala 495:109]
  wire [63:0] _readData_vec_1_T_437_din = _T_448; // @[hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_234 = 2'h0 == _T_435[1:0] ? _T_448 : _GEN_206; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_235 = 2'h1 == _T_435[1:0] ? _T_448 : _GEN_207; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_236 = 2'h2 == _T_435[1:0] ? _T_448 : _GEN_208; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_237 = 2'h3 == _T_435[1:0] ? _T_448 : _GEN_209; // @[hbm_reader_double_fifo.scala 495:106]
  reg [7:0] _T_449; // @[hbm_reader_double_fifo.scala 494:65]
  wire [8:0] _T_450 = 8'h3 + _T_449; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _T_451 = 8'h3 + _T_449; // @[hbm_reader_double_fifo.scala 494:56]
  wire [7:0] _GEN_673 = _T_451 % 8'h4; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_452 = _GEN_673[2:0]; // @[hbm_reader_double_fifo.scala 494:84]
  wire [2:0] _T_453 = _T_452;
  wire [1:0] _T_454 = _T_452[1:0];
  wire [8:0] _T_455 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [7:0] _T_456 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 494:140]
  wire [2:0] _T_457 = _T_456[2:0];
  wire [31:0] _T_458 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:163]
  wire [31:0] _GEN_238 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_239 = 3'h1 == _T_456[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_240 = 3'h2 == _T_456[2:0] ? unpacked_readData_2 : _GEN_239; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_241 = 3'h3 == _T_456[2:0] ? unpacked_readData_3 : _GEN_240; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_242 = 3'h4 == _T_456[2:0] ? unpacked_readData_4 : _GEN_241; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_243 = 3'h5 == _T_456[2:0] ? unpacked_readData_5 : _GEN_242; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_244 = 3'h6 == _T_456[2:0] ? unpacked_readData_6 : _GEN_243; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _GEN_245 = 3'h7 == _T_456[2:0] ? unpacked_readData_7 : _GEN_244; // @[hbm_reader_double_fifo.scala 494:159]
  wire [31:0] _unpacked_readData_T_457 = _GEN_245; // @[hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159 hbm_reader_double_fifo.scala 494:159]
  wire  _T_459 = _GEN_245 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 494:159]
  wire  _T_460 = ~_T_459; // @[hbm_reader_double_fifo.scala 494:113]
  wire  _T_461 = ~_T_460; // @[hbm_reader_double_fifo.scala 494:111]
  wire  _readData_vec_1_T_454_wr_en = _T_461; // @[hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_246 = 2'h0 == _T_452[1:0] ? _T_461 : _GEN_218; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_247 = 2'h1 == _T_452[1:0] ? _T_461 : _GEN_219; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_248 = 2'h2 == _T_452[1:0] ? _T_461 : _GEN_220; // @[hbm_reader_double_fifo.scala 494:108]
  wire  _GEN_249 = 2'h3 == _T_452[1:0] ? _T_461 : _GEN_221; // @[hbm_reader_double_fifo.scala 494:108]
  reg [7:0] _T_462; // @[hbm_reader_double_fifo.scala 495:65]
  wire [8:0] _T_463 = 8'h3 + _T_462; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _T_464 = 8'h3 + _T_462; // @[hbm_reader_double_fifo.scala 495:56]
  wire [7:0] _GEN_674 = _T_464 % 8'h4; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_465 = _GEN_674[2:0]; // @[hbm_reader_double_fifo.scala 495:84]
  wire [2:0] _T_466 = _T_465;
  wire [1:0] _T_467 = _T_465[1:0];
  wire [15:0] _T_468 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_469 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [7:0] _T_470 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:200]
  wire [2:0] _T_471 = _T_456[2:0];
  wire [8:0] _T_472 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [7:0] _T_473 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 495:231]
  wire [1:0] _T_474 = _T_456[1:0];
  wire [23:0] _GEN_250 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_251 = 3'h1 == _T_456[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_252 = 3'h2 == _T_456[2:0] ? neighbour_2 : _GEN_251; // @[Cat.scala 29:58]
  wire [23:0] _GEN_253 = 3'h3 == _T_456[2:0] ? neighbour_3 : _GEN_252; // @[Cat.scala 29:58]
  wire [23:0] _GEN_254 = 3'h4 == _T_456[2:0] ? neighbour_4 : _GEN_253; // @[Cat.scala 29:58]
  wire [23:0] _GEN_255 = 3'h5 == _T_456[2:0] ? neighbour_5 : _GEN_254; // @[Cat.scala 29:58]
  wire [23:0] _GEN_256 = 3'h6 == _T_456[2:0] ? neighbour_6 : _GEN_255; // @[Cat.scala 29:58]
  wire [23:0] _GEN_257 = 3'h7 == _T_456[2:0] ? neighbour_7 : _GEN_256; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_471 = _GEN_257; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_475 = {16'h0,_GEN_257}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_258 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_259 = 2'h1 == _T_456[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_260 = 2'h2 == _T_456[1:0] ? src_0 : _GEN_259; // @[Cat.scala 29:58]
  wire [23:0] _GEN_261 = 2'h3 == _T_456[1:0] ? src_0 : _GEN_260; // @[Cat.scala 29:58]
  wire [23:0] _src_T_474 = _GEN_261; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_476 = {16'h0,_GEN_257,_GEN_261}; // @[Cat.scala 29:58]
  wire [63:0] _T_477 = ~_T_476; // @[hbm_reader_double_fifo.scala 495:111]
  wire [63:0] _T_478 = ~_T_477; // @[hbm_reader_double_fifo.scala 495:109]
  wire [63:0] _readData_vec_1_T_467_din = _T_478; // @[hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_262 = 2'h0 == _T_465[1:0] ? _T_478 : _GEN_234; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_263 = 2'h1 == _T_465[1:0] ? _T_478 : _GEN_235; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_264 = 2'h2 == _T_465[1:0] ? _T_478 : _GEN_236; // @[hbm_reader_double_fifo.scala 495:106]
  wire [63:0] _GEN_265 = 2'h3 == _T_465[1:0] ? _T_478 : _GEN_237; // @[hbm_reader_double_fifo.scala 495:106]
  wire [8:0] _T_480 = valid_data - 8'h4; // @[hbm_reader_double_fifo.scala 505:62]
  wire [7:0] _T_481 = valid_data - 8'h4; // @[hbm_reader_double_fifo.scala 505:62]
  wire [8:0] _T_482 = loc_flag_data_1 + 8'h4; // @[hbm_reader_double_fifo.scala 506:68]
  wire [7:0] _T_483 = loc_flag_data_1 + 8'h4; // @[hbm_reader_double_fifo.scala 506:68]
  wire  _GEN_266 = _T_479 ? 1'h0 : _GEN_147; // @[hbm_reader_double_fifo.scala 498:62]
  wire [7:0] _GEN_267 = _T_479 ? _T_347 : _GEN_148; // @[hbm_reader_double_fifo.scala 498:62]
  wire [7:0] _GEN_268 = _T_479 ? _T_483 : loc_flag_data_1; // @[hbm_reader_double_fifo.scala 498:62]
  wire  _GEN_270 = _T_479 | _GEN_151; // @[hbm_reader_double_fifo.scala 498:62]
  wire [8:0] _T_485 = loc_flag_fifo_1 + valid_data; // @[hbm_reader_double_fifo.scala 517:69]
  wire [7:0] _T_486 = loc_flag_fifo_1 + valid_data; // @[hbm_reader_double_fifo.scala 517:69]
  wire [7:0] _GEN_675 = _T_486 % 8'h4; // @[hbm_reader_double_fifo.scala 517:83]
  wire [2:0] _T_487 = _GEN_675[2:0]; // @[hbm_reader_double_fifo.scala 517:83]
  wire  _GEN_271 = _T_484 | _GEN_266; // @[hbm_reader_double_fifo.scala 510:63]
  wire [7:0] _GEN_272 = _T_484 ? {{5'd0}, _T_487} : loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 510:63]
  wire [7:0] _GEN_273 = _T_484 ? 8'h0 : _GEN_268; // @[hbm_reader_double_fifo.scala 510:63]
  wire  _GEN_275 = _T_484 ? 1'h0 : _GEN_153; // @[hbm_reader_double_fifo.scala 510:63]
  wire  _GEN_276 = _T_484 ? 1'h0 : _GEN_270; // @[hbm_reader_double_fifo.scala 510:63]
  wire  _GEN_277 = _T_358 & _GEN_246; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_278 = _T_358 & _GEN_247; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_279 = _T_358 & _GEN_248; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_280 = _T_358 & _GEN_249; // @[hbm_reader_double_fifo.scala 491:147]
  wire [63:0] _GEN_281 = _GEN_262; // @[hbm_reader_double_fifo.scala 491:147]
  wire [63:0] _GEN_282 = _GEN_263; // @[hbm_reader_double_fifo.scala 491:147]
  wire [63:0] _GEN_283 = _GEN_264; // @[hbm_reader_double_fifo.scala 491:147]
  wire [63:0] _GEN_284 = _GEN_265; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_285 = _T_358 ? _GEN_271 : _GEN_147; // @[hbm_reader_double_fifo.scala 491:147]
  wire [7:0] _GEN_286 = _T_358 ? _GEN_267 : _GEN_148; // @[hbm_reader_double_fifo.scala 491:147]
  wire [7:0] _GEN_287 = _T_358 ? _GEN_273 : loc_flag_data_1; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_289 = _T_358 ? _GEN_276 : _GEN_151; // @[hbm_reader_double_fifo.scala 491:147]
  wire [7:0] _GEN_290 = _T_358 ? _GEN_272 : loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_291 = _T_358 ? _GEN_275 : _GEN_153; // @[hbm_reader_double_fifo.scala 491:147]
  wire  _GEN_292 = io_HBM_interface_readData_valid & _GEN_285; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_293 = io_HBM_interface_readData_valid & _T_219; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_294 = io_HBM_interface_readData_valid & _GEN_139; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_295 = io_HBM_interface_readData_valid & _GEN_140; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_296 = io_HBM_interface_readData_valid & _GEN_141; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_297 = io_HBM_interface_readData_valid & _GEN_142; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_298 = _GEN_124; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_299 = _GEN_125; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_300 = _GEN_126; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_301 = _GEN_127; // @[hbm_reader_double_fifo.scala 421:65]
  wire [7:0] _GEN_302 = io_HBM_interface_readData_valid ? _GEN_286 : valid_data_num; // @[hbm_reader_double_fifo.scala 421:65]
  wire [7:0] _GEN_303 = io_HBM_interface_readData_valid ? _GEN_149 : loc_flag_data_0; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_305 = io_HBM_interface_readData_valid ? _GEN_289 : stateReg; // @[hbm_reader_double_fifo.scala 421:65]
  wire [7:0] _GEN_306 = io_HBM_interface_readData_valid ? _GEN_152 : loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_307 = io_HBM_interface_readData_valid ? _GEN_291 : flag_readData_vec; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_308 = io_HBM_interface_readData_valid & _GEN_277; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_309 = io_HBM_interface_readData_valid & _GEN_278; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_310 = io_HBM_interface_readData_valid & _GEN_279; // @[hbm_reader_double_fifo.scala 421:65]
  wire  _GEN_311 = io_HBM_interface_readData_valid & _GEN_280; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_312 = _GEN_262; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_313 = _GEN_263; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_314 = _GEN_264; // @[hbm_reader_double_fifo.scala 421:65]
  wire [63:0] _GEN_315 = _GEN_265; // @[hbm_reader_double_fifo.scala 421:65]
  wire [7:0] _GEN_316 = io_HBM_interface_readData_valid ? _GEN_287 : loc_flag_data_1; // @[hbm_reader_double_fifo.scala 421:65]
  wire [7:0] _GEN_317 = io_HBM_interface_readData_valid ? _GEN_290 : loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 421:65]
  reg [7:0] _T_491; // @[hbm_reader_double_fifo.scala 534:57]
  wire [8:0] _T_492 = {{1'd0}, _T_491}; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _T_493 = _T_492[7:0]; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _GEN_676 = _T_492[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_494 = _GEN_676[2:0]; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_495 = _T_494;
  wire [1:0] _T_496 = _T_494[1:0];
  wire [8:0] _T_497 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 534:132]
  wire [7:0] _T_498 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 534:132]
  wire [2:0] _T_499 = _T_231[2:0];
  wire [31:0] _T_500 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:155]
  wire [31:0] _GEN_318 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_319 = 3'h1 == _T_231[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_320 = 3'h2 == _T_231[2:0] ? unpacked_readData_2 : _GEN_17; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_321 = 3'h3 == _T_231[2:0] ? unpacked_readData_3 : _GEN_18; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_322 = 3'h4 == _T_231[2:0] ? unpacked_readData_4 : _GEN_19; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_323 = 3'h5 == _T_231[2:0] ? unpacked_readData_5 : _GEN_20; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_324 = 3'h6 == _T_231[2:0] ? unpacked_readData_6 : _GEN_21; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_325 = 3'h7 == _T_231[2:0] ? unpacked_readData_7 : _GEN_22; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _unpacked_readData_T_499 = _GEN_23; // @[hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151]
  wire  _T_501 = _GEN_23 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:151]
  wire  _T_502 = ~_T_235; // @[hbm_reader_double_fifo.scala 534:105]
  wire  _T_503 = ~_T_236; // @[hbm_reader_double_fifo.scala 534:103]
  wire  _readData_vec_0_T_496_wr_en = _T_237; // @[hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_650 = 2'h0 == _T_494[1:0]; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_326 = _GEN_650 & _T_237; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_651 = 2'h1 == _T_494[1:0]; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_327 = _GEN_651 & _T_237; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_652 = 2'h2 == _T_494[1:0]; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_328 = _GEN_652 & _T_237; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_653 = 2'h3 == _T_494[1:0]; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_329 = _GEN_653 & _T_237; // @[hbm_reader_double_fifo.scala 534:100]
  reg [7:0] _T_504; // @[hbm_reader_double_fifo.scala 535:57]
  wire [8:0] _T_505 = {{1'd0}, _T_504}; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _T_506 = _T_505[7:0]; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _GEN_677 = _T_505[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_507 = _GEN_677[2:0]; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_508 = _T_507;
  wire [1:0] _T_509 = _T_507[1:0];
  wire [15:0] _T_510 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_511 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 535:192]
  wire [7:0] _T_512 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 535:192]
  wire [2:0] _T_513 = _T_231[2:0];
  wire [8:0] _T_514 = {{1'd0}, loc_flag_data_0}; // @[hbm_reader_double_fifo.scala 535:223]
  wire [7:0] _T_515 = _T_231[7:0]; // @[hbm_reader_double_fifo.scala 535:223]
  wire [1:0] _T_516 = _T_231[1:0];
  wire [23:0] _GEN_330 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_331 = 3'h1 == _T_231[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_332 = 3'h2 == _T_231[2:0] ? neighbour_2 : _GEN_29; // @[Cat.scala 29:58]
  wire [23:0] _GEN_333 = 3'h3 == _T_231[2:0] ? neighbour_3 : _GEN_30; // @[Cat.scala 29:58]
  wire [23:0] _GEN_334 = 3'h4 == _T_231[2:0] ? neighbour_4 : _GEN_31; // @[Cat.scala 29:58]
  wire [23:0] _GEN_335 = 3'h5 == _T_231[2:0] ? neighbour_5 : _GEN_32; // @[Cat.scala 29:58]
  wire [23:0] _GEN_336 = 3'h6 == _T_231[2:0] ? neighbour_6 : _GEN_33; // @[Cat.scala 29:58]
  wire [23:0] _GEN_337 = 3'h7 == _T_231[2:0] ? neighbour_7 : _GEN_34; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_513 = _GEN_35; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_517 = {16'h0,_GEN_35}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_338 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_339 = 2'h1 == _T_231[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_340 = 2'h2 == _T_231[1:0] ? src_0 : _GEN_37; // @[Cat.scala 29:58]
  wire [23:0] _GEN_341 = 2'h3 == _T_231[1:0] ? src_0 : _GEN_38; // @[Cat.scala 29:58]
  wire [23:0] _src_T_516 = _GEN_39; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_518 = {16'h0,_GEN_35,_GEN_39}; // @[Cat.scala 29:58]
  wire [63:0] _T_519 = ~_T_252; // @[hbm_reader_double_fifo.scala 535:103]
  wire [63:0] _T_520 = ~_T_253; // @[hbm_reader_double_fifo.scala 535:101]
  wire [63:0] _readData_vec_0_T_509_din = _T_254; // @[hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_342 = _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_343 = _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_344 = _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_345 = _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  reg [7:0] _T_521; // @[hbm_reader_double_fifo.scala 534:57]
  wire [8:0] _T_522 = 8'h1 + _T_521; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _T_523 = 8'h1 + _T_521; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _GEN_678 = _T_523 % 8'h4; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_524 = _GEN_678[2:0]; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_525 = _T_524;
  wire [1:0] _T_526 = _T_524[1:0];
  wire [8:0] _T_527 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [7:0] _T_528 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [2:0] _T_529 = _T_262[2:0];
  wire [31:0] _T_530 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:155]
  wire [31:0] _GEN_346 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_347 = 3'h1 == _T_262[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_348 = 3'h2 == _T_262[2:0] ? unpacked_readData_2 : _GEN_45; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_349 = 3'h3 == _T_262[2:0] ? unpacked_readData_3 : _GEN_46; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_350 = 3'h4 == _T_262[2:0] ? unpacked_readData_4 : _GEN_47; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_351 = 3'h5 == _T_262[2:0] ? unpacked_readData_5 : _GEN_48; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_352 = 3'h6 == _T_262[2:0] ? unpacked_readData_6 : _GEN_49; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_353 = 3'h7 == _T_262[2:0] ? unpacked_readData_7 : _GEN_50; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _unpacked_readData_T_529 = _GEN_51; // @[hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151]
  wire  _T_531 = _GEN_51 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:151]
  wire  _T_532 = ~_T_265; // @[hbm_reader_double_fifo.scala 534:105]
  wire  _T_533 = ~_T_266; // @[hbm_reader_double_fifo.scala 534:103]
  wire  _readData_vec_0_T_526_wr_en = _T_267; // @[hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_354 = 2'h0 == _T_524[1:0] ? _T_267 : _GEN_326; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_355 = 2'h1 == _T_524[1:0] ? _T_267 : _GEN_327; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_356 = 2'h2 == _T_524[1:0] ? _T_267 : _GEN_328; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_357 = 2'h3 == _T_524[1:0] ? _T_267 : _GEN_329; // @[hbm_reader_double_fifo.scala 534:100]
  reg [7:0] _T_534; // @[hbm_reader_double_fifo.scala 535:57]
  wire [8:0] _T_535 = 8'h1 + _T_534; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _T_536 = 8'h1 + _T_534; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _GEN_679 = _T_536 % 8'h4; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_537 = _GEN_679[2:0]; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_538 = _T_537;
  wire [1:0] _T_539 = _T_537[1:0];
  wire [15:0] _T_540 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_541 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [7:0] _T_542 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [2:0] _T_543 = _T_262[2:0];
  wire [8:0] _T_544 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [7:0] _T_545 = 8'h1 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [1:0] _T_546 = _T_262[1:0];
  wire [23:0] _GEN_358 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_359 = 3'h1 == _T_262[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_360 = 3'h2 == _T_262[2:0] ? neighbour_2 : _GEN_57; // @[Cat.scala 29:58]
  wire [23:0] _GEN_361 = 3'h3 == _T_262[2:0] ? neighbour_3 : _GEN_58; // @[Cat.scala 29:58]
  wire [23:0] _GEN_362 = 3'h4 == _T_262[2:0] ? neighbour_4 : _GEN_59; // @[Cat.scala 29:58]
  wire [23:0] _GEN_363 = 3'h5 == _T_262[2:0] ? neighbour_5 : _GEN_60; // @[Cat.scala 29:58]
  wire [23:0] _GEN_364 = 3'h6 == _T_262[2:0] ? neighbour_6 : _GEN_61; // @[Cat.scala 29:58]
  wire [23:0] _GEN_365 = 3'h7 == _T_262[2:0] ? neighbour_7 : _GEN_62; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_543 = _GEN_63; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_547 = {16'h0,_GEN_63}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_366 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_367 = 2'h1 == _T_262[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_368 = 2'h2 == _T_262[1:0] ? src_0 : _GEN_65; // @[Cat.scala 29:58]
  wire [23:0] _GEN_369 = 2'h3 == _T_262[1:0] ? src_0 : _GEN_66; // @[Cat.scala 29:58]
  wire [23:0] _src_T_546 = _GEN_67; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_548 = {16'h0,_GEN_63,_GEN_67}; // @[Cat.scala 29:58]
  wire [63:0] _T_549 = ~_T_282; // @[hbm_reader_double_fifo.scala 535:103]
  wire [63:0] _T_550 = ~_T_283; // @[hbm_reader_double_fifo.scala 535:101]
  wire [63:0] _readData_vec_0_T_539_din = _T_284; // @[hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_370 = 2'h0 == _T_537[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_371 = 2'h1 == _T_537[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_372 = 2'h2 == _T_537[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_373 = 2'h3 == _T_537[1:0] ? _T_284 : _T_254; // @[hbm_reader_double_fifo.scala 535:98]
  reg [7:0] _T_551; // @[hbm_reader_double_fifo.scala 534:57]
  wire [8:0] _T_552 = 8'h2 + _T_551; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _T_553 = 8'h2 + _T_551; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _GEN_680 = _T_553 % 8'h4; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_554 = _GEN_680[2:0]; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_555 = _T_554;
  wire [1:0] _T_556 = _T_554[1:0];
  wire [8:0] _T_557 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [7:0] _T_558 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [2:0] _T_559 = _T_292[2:0];
  wire [31:0] _T_560 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:155]
  wire [31:0] _GEN_374 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_375 = 3'h1 == _T_292[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_376 = 3'h2 == _T_292[2:0] ? unpacked_readData_2 : _GEN_73; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_377 = 3'h3 == _T_292[2:0] ? unpacked_readData_3 : _GEN_74; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_378 = 3'h4 == _T_292[2:0] ? unpacked_readData_4 : _GEN_75; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_379 = 3'h5 == _T_292[2:0] ? unpacked_readData_5 : _GEN_76; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_380 = 3'h6 == _T_292[2:0] ? unpacked_readData_6 : _GEN_77; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_381 = 3'h7 == _T_292[2:0] ? unpacked_readData_7 : _GEN_78; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _unpacked_readData_T_559 = _GEN_79; // @[hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151]
  wire  _T_561 = _GEN_79 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:151]
  wire  _T_562 = ~_T_295; // @[hbm_reader_double_fifo.scala 534:105]
  wire  _T_563 = ~_T_296; // @[hbm_reader_double_fifo.scala 534:103]
  wire  _readData_vec_0_T_556_wr_en = _T_297; // @[hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_382 = 2'h0 == _T_554[1:0] ? _T_297 : _GEN_354; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_383 = 2'h1 == _T_554[1:0] ? _T_297 : _GEN_355; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_384 = 2'h2 == _T_554[1:0] ? _T_297 : _GEN_356; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_385 = 2'h3 == _T_554[1:0] ? _T_297 : _GEN_357; // @[hbm_reader_double_fifo.scala 534:100]
  reg [7:0] _T_564; // @[hbm_reader_double_fifo.scala 535:57]
  wire [8:0] _T_565 = 8'h2 + _T_564; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _T_566 = 8'h2 + _T_564; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _GEN_681 = _T_566 % 8'h4; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_567 = _GEN_681[2:0]; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_568 = _T_567;
  wire [1:0] _T_569 = _T_567[1:0];
  wire [15:0] _T_570 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_571 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [7:0] _T_572 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [2:0] _T_573 = _T_292[2:0];
  wire [8:0] _T_574 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [7:0] _T_575 = 8'h2 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [1:0] _T_576 = _T_292[1:0];
  wire [23:0] _GEN_386 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_387 = 3'h1 == _T_292[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_388 = 3'h2 == _T_292[2:0] ? neighbour_2 : _GEN_85; // @[Cat.scala 29:58]
  wire [23:0] _GEN_389 = 3'h3 == _T_292[2:0] ? neighbour_3 : _GEN_86; // @[Cat.scala 29:58]
  wire [23:0] _GEN_390 = 3'h4 == _T_292[2:0] ? neighbour_4 : _GEN_87; // @[Cat.scala 29:58]
  wire [23:0] _GEN_391 = 3'h5 == _T_292[2:0] ? neighbour_5 : _GEN_88; // @[Cat.scala 29:58]
  wire [23:0] _GEN_392 = 3'h6 == _T_292[2:0] ? neighbour_6 : _GEN_89; // @[Cat.scala 29:58]
  wire [23:0] _GEN_393 = 3'h7 == _T_292[2:0] ? neighbour_7 : _GEN_90; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_573 = _GEN_91; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_577 = {16'h0,_GEN_91}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_394 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_395 = 2'h1 == _T_292[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_396 = 2'h2 == _T_292[1:0] ? src_0 : _GEN_93; // @[Cat.scala 29:58]
  wire [23:0] _GEN_397 = 2'h3 == _T_292[1:0] ? src_0 : _GEN_94; // @[Cat.scala 29:58]
  wire [23:0] _src_T_576 = _GEN_95; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_578 = {16'h0,_GEN_91,_GEN_95}; // @[Cat.scala 29:58]
  wire [63:0] _T_579 = ~_T_312; // @[hbm_reader_double_fifo.scala 535:103]
  wire [63:0] _T_580 = ~_T_313; // @[hbm_reader_double_fifo.scala 535:101]
  wire [63:0] _readData_vec_0_T_569_din = _T_314; // @[hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_398 = 2'h0 == _T_567[1:0] ? _T_314 : _GEN_370; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_399 = 2'h1 == _T_567[1:0] ? _T_314 : _GEN_371; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_400 = 2'h2 == _T_567[1:0] ? _T_314 : _GEN_372; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_401 = 2'h3 == _T_567[1:0] ? _T_314 : _GEN_373; // @[hbm_reader_double_fifo.scala 535:98]
  reg [7:0] _T_581; // @[hbm_reader_double_fifo.scala 534:57]
  wire [8:0] _T_582 = 8'h3 + _T_581; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _T_583 = 8'h3 + _T_581; // @[hbm_reader_double_fifo.scala 534:48]
  wire [7:0] _GEN_682 = _T_583 % 8'h4; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_584 = _GEN_682[2:0]; // @[hbm_reader_double_fifo.scala 534:76]
  wire [2:0] _T_585 = _T_584;
  wire [1:0] _T_586 = _T_584[1:0];
  wire [8:0] _T_587 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [7:0] _T_588 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 534:132]
  wire [2:0] _T_589 = _T_322[2:0];
  wire [31:0] _T_590 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:155]
  wire [31:0] _GEN_402 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_403 = 3'h1 == _T_322[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_404 = 3'h2 == _T_322[2:0] ? unpacked_readData_2 : _GEN_101; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_405 = 3'h3 == _T_322[2:0] ? unpacked_readData_3 : _GEN_102; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_406 = 3'h4 == _T_322[2:0] ? unpacked_readData_4 : _GEN_103; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_407 = 3'h5 == _T_322[2:0] ? unpacked_readData_5 : _GEN_104; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_408 = 3'h6 == _T_322[2:0] ? unpacked_readData_6 : _GEN_105; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _GEN_409 = 3'h7 == _T_322[2:0] ? unpacked_readData_7 : _GEN_106; // @[hbm_reader_double_fifo.scala 534:151]
  wire [31:0] _unpacked_readData_T_589 = _GEN_107; // @[hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151 hbm_reader_double_fifo.scala 534:151]
  wire  _T_591 = _GEN_107 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 534:151]
  wire  _T_592 = ~_T_325; // @[hbm_reader_double_fifo.scala 534:105]
  wire  _T_593 = ~_T_326; // @[hbm_reader_double_fifo.scala 534:103]
  wire  _readData_vec_0_T_586_wr_en = _T_327; // @[hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_410 = 2'h0 == _T_584[1:0] ? _T_327 : _GEN_382; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_411 = 2'h1 == _T_584[1:0] ? _T_327 : _GEN_383; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_412 = 2'h2 == _T_584[1:0] ? _T_327 : _GEN_384; // @[hbm_reader_double_fifo.scala 534:100]
  wire  _GEN_413 = 2'h3 == _T_584[1:0] ? _T_327 : _GEN_385; // @[hbm_reader_double_fifo.scala 534:100]
  reg [7:0] _T_594; // @[hbm_reader_double_fifo.scala 535:57]
  wire [8:0] _T_595 = 8'h3 + _T_594; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _T_596 = 8'h3 + _T_594; // @[hbm_reader_double_fifo.scala 535:48]
  wire [7:0] _GEN_683 = _T_596 % 8'h4; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_597 = _GEN_683[2:0]; // @[hbm_reader_double_fifo.scala 535:76]
  wire [2:0] _T_598 = _T_597;
  wire [1:0] _T_599 = _T_597[1:0];
  wire [15:0] _T_600 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_601 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [7:0] _T_602 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:192]
  wire [2:0] _T_603 = _T_322[2:0];
  wire [8:0] _T_604 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [7:0] _T_605 = 8'h3 + loc_flag_data_0; // @[hbm_reader_double_fifo.scala 535:223]
  wire [1:0] _T_606 = _T_322[1:0];
  wire [23:0] _GEN_414 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_415 = 3'h1 == _T_322[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_416 = 3'h2 == _T_322[2:0] ? neighbour_2 : _GEN_113; // @[Cat.scala 29:58]
  wire [23:0] _GEN_417 = 3'h3 == _T_322[2:0] ? neighbour_3 : _GEN_114; // @[Cat.scala 29:58]
  wire [23:0] _GEN_418 = 3'h4 == _T_322[2:0] ? neighbour_4 : _GEN_115; // @[Cat.scala 29:58]
  wire [23:0] _GEN_419 = 3'h5 == _T_322[2:0] ? neighbour_5 : _GEN_116; // @[Cat.scala 29:58]
  wire [23:0] _GEN_420 = 3'h6 == _T_322[2:0] ? neighbour_6 : _GEN_117; // @[Cat.scala 29:58]
  wire [23:0] _GEN_421 = 3'h7 == _T_322[2:0] ? neighbour_7 : _GEN_118; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_603 = _GEN_119; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_607 = {16'h0,_GEN_119}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_422 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_423 = 2'h1 == _T_322[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_424 = 2'h2 == _T_322[1:0] ? src_0 : _GEN_121; // @[Cat.scala 29:58]
  wire [23:0] _GEN_425 = 2'h3 == _T_322[1:0] ? src_0 : _GEN_122; // @[Cat.scala 29:58]
  wire [23:0] _src_T_606 = _GEN_123; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_608 = {16'h0,_GEN_119,_GEN_123}; // @[Cat.scala 29:58]
  wire [63:0] _T_609 = ~_T_342; // @[hbm_reader_double_fifo.scala 535:103]
  wire [63:0] _T_610 = ~_T_343; // @[hbm_reader_double_fifo.scala 535:101]
  wire [63:0] _readData_vec_0_T_599_din = _T_344; // @[hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_426 = 2'h0 == _T_597[1:0] ? _T_344 : _GEN_398; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_427 = 2'h1 == _T_597[1:0] ? _T_344 : _GEN_399; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_428 = 2'h2 == _T_597[1:0] ? _T_344 : _GEN_400; // @[hbm_reader_double_fifo.scala 535:98]
  wire [63:0] _GEN_429 = 2'h3 == _T_597[1:0] ? _T_344 : _GEN_401; // @[hbm_reader_double_fifo.scala 535:98]
  wire [8:0] _T_612 = valid_data_num - 8'h4; // @[hbm_reader_double_fifo.scala 546:58]
  wire [7:0] _T_613 = valid_data_num - 8'h4; // @[hbm_reader_double_fifo.scala 546:58]
  wire [8:0] _T_614 = loc_flag_data_0 + 8'h4; // @[hbm_reader_double_fifo.scala 547:60]
  wire [7:0] _T_615 = loc_flag_data_0 + 8'h4; // @[hbm_reader_double_fifo.scala 547:60]
  wire [7:0] _GEN_431 = _T_742 ? _T_613 : valid_data_num; // @[hbm_reader_double_fifo.scala 538:58]
  wire [7:0] _GEN_432 = _T_742 ? _T_349 : loc_flag_data_0; // @[hbm_reader_double_fifo.scala 538:58]
  wire  _GEN_433 = _T_742 | stateReg; // @[hbm_reader_double_fifo.scala 538:58]
  wire [8:0] _T_617 = loc_flag_fifo_0 + valid_data_num; // @[hbm_reader_double_fifo.scala 558:61]
  wire [7:0] _T_618 = loc_flag_fifo_0 + valid_data_num; // @[hbm_reader_double_fifo.scala 558:61]
  wire [7:0] _GEN_684 = _T_618 % 8'h4; // @[hbm_reader_double_fifo.scala 558:79]
  wire [2:0] _T_619 = _GEN_684[2:0]; // @[hbm_reader_double_fifo.scala 558:79]
  wire [7:0] _GEN_435 = _T_747 ? {{5'd0}, _T_619} : loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 551:59]
  wire [7:0] _GEN_436 = _T_747 ? 8'h0 : _GEN_432; // @[hbm_reader_double_fifo.scala 551:59]
  wire  _GEN_437 = _T_747 | flag_readData_vec; // @[hbm_reader_double_fifo.scala 551:59]
  wire  _GEN_438 = _T_747 ? 1'h0 : _GEN_433; // @[hbm_reader_double_fifo.scala 551:59]
  wire  _GEN_440 = _T_490 & _GEN_410; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_441 = _T_490 & _GEN_411; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_442 = _T_490 & _GEN_412; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_443 = _T_490 & _GEN_413; // @[hbm_reader_double_fifo.scala 531:62]
  wire [63:0] _GEN_444 = _GEN_426; // @[hbm_reader_double_fifo.scala 531:62]
  wire [63:0] _GEN_445 = _GEN_427; // @[hbm_reader_double_fifo.scala 531:62]
  wire [63:0] _GEN_446 = _GEN_428; // @[hbm_reader_double_fifo.scala 531:62]
  wire [63:0] _GEN_447 = _GEN_429; // @[hbm_reader_double_fifo.scala 531:62]
  wire [7:0] _GEN_448 = _T_490 ? _GEN_431 : valid_data_num; // @[hbm_reader_double_fifo.scala 531:62]
  wire [7:0] _GEN_449 = _T_490 ? _GEN_436 : loc_flag_data_0; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_450 = _T_490 ? _GEN_438 : stateReg; // @[hbm_reader_double_fifo.scala 531:62]
  wire [7:0] _GEN_451 = _T_490 ? _GEN_435 : loc_flag_fifo_0; // @[hbm_reader_double_fifo.scala 531:62]
  wire  _GEN_452 = _T_490 ? _GEN_437 : flag_readData_vec; // @[hbm_reader_double_fifo.scala 531:62]
  reg [7:0] _T_622; // @[hbm_reader_double_fifo.scala 570:57]
  wire [8:0] _T_623 = {{1'd0}, _T_622}; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _T_624 = _T_623[7:0]; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _GEN_685 = _T_623[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_625 = _GEN_685[2:0]; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_626 = _T_625;
  wire [1:0] _T_627 = _T_625[1:0];
  wire [8:0] _T_628 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 570:132]
  wire [7:0] _T_629 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 570:132]
  wire [2:0] _T_630 = _T_365[2:0];
  wire [31:0] _T_631 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:155]
  wire [31:0] _GEN_453 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_454 = 3'h1 == _T_365[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_455 = 3'h2 == _T_365[2:0] ? unpacked_readData_2 : _GEN_155; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_456 = 3'h3 == _T_365[2:0] ? unpacked_readData_3 : _GEN_156; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_457 = 3'h4 == _T_365[2:0] ? unpacked_readData_4 : _GEN_157; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_458 = 3'h5 == _T_365[2:0] ? unpacked_readData_5 : _GEN_158; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_459 = 3'h6 == _T_365[2:0] ? unpacked_readData_6 : _GEN_159; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_460 = 3'h7 == _T_365[2:0] ? unpacked_readData_7 : _GEN_160; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _unpacked_readData_T_630 = _GEN_161; // @[hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151]
  wire  _T_632 = _GEN_161 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:151]
  wire  _T_633 = ~_T_369; // @[hbm_reader_double_fifo.scala 570:105]
  wire  _T_634 = ~_T_370; // @[hbm_reader_double_fifo.scala 570:103]
  wire  _readData_vec_1_T_627_wr_en = _T_371; // @[hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_654 = 2'h0 == _T_625[1:0]; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_461 = _GEN_654 & _T_371; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_655 = 2'h1 == _T_625[1:0]; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_462 = _GEN_655 & _T_371; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_656 = 2'h2 == _T_625[1:0]; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_463 = _GEN_656 & _T_371; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_657 = 2'h3 == _T_625[1:0]; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_464 = _GEN_657 & _T_371; // @[hbm_reader_double_fifo.scala 570:100]
  reg [7:0] _T_635; // @[hbm_reader_double_fifo.scala 571:57]
  wire [8:0] _T_636 = {{1'd0}, _T_635}; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _T_637 = _T_636[7:0]; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _GEN_686 = _T_636[7:0] % 8'h4; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_638 = _GEN_686[2:0]; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_639 = _T_638;
  wire [1:0] _T_640 = _T_638[1:0];
  wire [15:0] _T_641 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_642 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 571:192]
  wire [7:0] _T_643 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 571:192]
  wire [2:0] _T_644 = _T_365[2:0];
  wire [8:0] _T_645 = {{1'd0}, loc_flag_data_1}; // @[hbm_reader_double_fifo.scala 571:223]
  wire [7:0] _T_646 = _T_365[7:0]; // @[hbm_reader_double_fifo.scala 571:223]
  wire [1:0] _T_647 = _T_365[1:0];
  wire [23:0] _GEN_465 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_466 = 3'h1 == _T_365[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_467 = 3'h2 == _T_365[2:0] ? neighbour_2 : _GEN_167; // @[Cat.scala 29:58]
  wire [23:0] _GEN_468 = 3'h3 == _T_365[2:0] ? neighbour_3 : _GEN_168; // @[Cat.scala 29:58]
  wire [23:0] _GEN_469 = 3'h4 == _T_365[2:0] ? neighbour_4 : _GEN_169; // @[Cat.scala 29:58]
  wire [23:0] _GEN_470 = 3'h5 == _T_365[2:0] ? neighbour_5 : _GEN_170; // @[Cat.scala 29:58]
  wire [23:0] _GEN_471 = 3'h6 == _T_365[2:0] ? neighbour_6 : _GEN_171; // @[Cat.scala 29:58]
  wire [23:0] _GEN_472 = 3'h7 == _T_365[2:0] ? neighbour_7 : _GEN_172; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_644 = _GEN_173; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_648 = {16'h0,_GEN_173}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_473 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_474 = 2'h1 == _T_365[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_475 = 2'h2 == _T_365[1:0] ? src_0 : _GEN_175; // @[Cat.scala 29:58]
  wire [23:0] _GEN_476 = 2'h3 == _T_365[1:0] ? src_0 : _GEN_176; // @[Cat.scala 29:58]
  wire [23:0] _src_T_647 = _GEN_177; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_649 = {16'h0,_GEN_173,_GEN_177}; // @[Cat.scala 29:58]
  wire [63:0] _T_650 = ~_T_386; // @[hbm_reader_double_fifo.scala 571:103]
  wire [63:0] _T_651 = ~_T_387; // @[hbm_reader_double_fifo.scala 571:101]
  wire [63:0] _readData_vec_1_T_640_din = _T_388; // @[hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_477 = _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_478 = _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_479 = _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_480 = _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  reg [7:0] _T_652; // @[hbm_reader_double_fifo.scala 570:57]
  wire [8:0] _T_653 = 8'h1 + _T_652; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _T_654 = 8'h1 + _T_652; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _GEN_687 = _T_654 % 8'h4; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_655 = _GEN_687[2:0]; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_656 = _T_655;
  wire [1:0] _T_657 = _T_655[1:0];
  wire [8:0] _T_658 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [7:0] _T_659 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [2:0] _T_660 = _T_396[2:0];
  wire [31:0] _T_661 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:155]
  wire [31:0] _GEN_481 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_482 = 3'h1 == _T_396[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_483 = 3'h2 == _T_396[2:0] ? unpacked_readData_2 : _GEN_183; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_484 = 3'h3 == _T_396[2:0] ? unpacked_readData_3 : _GEN_184; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_485 = 3'h4 == _T_396[2:0] ? unpacked_readData_4 : _GEN_185; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_486 = 3'h5 == _T_396[2:0] ? unpacked_readData_5 : _GEN_186; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_487 = 3'h6 == _T_396[2:0] ? unpacked_readData_6 : _GEN_187; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_488 = 3'h7 == _T_396[2:0] ? unpacked_readData_7 : _GEN_188; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _unpacked_readData_T_660 = _GEN_189; // @[hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151]
  wire  _T_662 = _GEN_189 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:151]
  wire  _T_663 = ~_T_399; // @[hbm_reader_double_fifo.scala 570:105]
  wire  _T_664 = ~_T_400; // @[hbm_reader_double_fifo.scala 570:103]
  wire  _readData_vec_1_T_657_wr_en = _T_401; // @[hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_489 = 2'h0 == _T_655[1:0] ? _T_401 : _GEN_461; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_490 = 2'h1 == _T_655[1:0] ? _T_401 : _GEN_462; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_491 = 2'h2 == _T_655[1:0] ? _T_401 : _GEN_463; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_492 = 2'h3 == _T_655[1:0] ? _T_401 : _GEN_464; // @[hbm_reader_double_fifo.scala 570:100]
  reg [7:0] _T_665; // @[hbm_reader_double_fifo.scala 571:57]
  wire [8:0] _T_666 = 8'h1 + _T_665; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _T_667 = 8'h1 + _T_665; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _GEN_688 = _T_667 % 8'h4; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_668 = _GEN_688[2:0]; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_669 = _T_668;
  wire [1:0] _T_670 = _T_668[1:0];
  wire [15:0] _T_671 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_672 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [7:0] _T_673 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [2:0] _T_674 = _T_396[2:0];
  wire [8:0] _T_675 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [7:0] _T_676 = 8'h1 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [1:0] _T_677 = _T_396[1:0];
  wire [23:0] _GEN_493 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_494 = 3'h1 == _T_396[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_495 = 3'h2 == _T_396[2:0] ? neighbour_2 : _GEN_195; // @[Cat.scala 29:58]
  wire [23:0] _GEN_496 = 3'h3 == _T_396[2:0] ? neighbour_3 : _GEN_196; // @[Cat.scala 29:58]
  wire [23:0] _GEN_497 = 3'h4 == _T_396[2:0] ? neighbour_4 : _GEN_197; // @[Cat.scala 29:58]
  wire [23:0] _GEN_498 = 3'h5 == _T_396[2:0] ? neighbour_5 : _GEN_198; // @[Cat.scala 29:58]
  wire [23:0] _GEN_499 = 3'h6 == _T_396[2:0] ? neighbour_6 : _GEN_199; // @[Cat.scala 29:58]
  wire [23:0] _GEN_500 = 3'h7 == _T_396[2:0] ? neighbour_7 : _GEN_200; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_674 = _GEN_201; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_678 = {16'h0,_GEN_201}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_501 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_502 = 2'h1 == _T_396[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_503 = 2'h2 == _T_396[1:0] ? src_0 : _GEN_203; // @[Cat.scala 29:58]
  wire [23:0] _GEN_504 = 2'h3 == _T_396[1:0] ? src_0 : _GEN_204; // @[Cat.scala 29:58]
  wire [23:0] _src_T_677 = _GEN_205; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_679 = {16'h0,_GEN_201,_GEN_205}; // @[Cat.scala 29:58]
  wire [63:0] _T_680 = ~_T_416; // @[hbm_reader_double_fifo.scala 571:103]
  wire [63:0] _T_681 = ~_T_417; // @[hbm_reader_double_fifo.scala 571:101]
  wire [63:0] _readData_vec_1_T_670_din = _T_418; // @[hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_505 = 2'h0 == _T_668[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_506 = 2'h1 == _T_668[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_507 = 2'h2 == _T_668[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_508 = 2'h3 == _T_668[1:0] ? _T_418 : _T_388; // @[hbm_reader_double_fifo.scala 571:98]
  reg [7:0] _T_682; // @[hbm_reader_double_fifo.scala 570:57]
  wire [8:0] _T_683 = 8'h2 + _T_682; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _T_684 = 8'h2 + _T_682; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _GEN_689 = _T_684 % 8'h4; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_685 = _GEN_689[2:0]; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_686 = _T_685;
  wire [1:0] _T_687 = _T_685[1:0];
  wire [8:0] _T_688 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [7:0] _T_689 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [2:0] _T_690 = _T_426[2:0];
  wire [31:0] _T_691 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:155]
  wire [31:0] _GEN_509 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_510 = 3'h1 == _T_426[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_511 = 3'h2 == _T_426[2:0] ? unpacked_readData_2 : _GEN_211; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_512 = 3'h3 == _T_426[2:0] ? unpacked_readData_3 : _GEN_212; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_513 = 3'h4 == _T_426[2:0] ? unpacked_readData_4 : _GEN_213; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_514 = 3'h5 == _T_426[2:0] ? unpacked_readData_5 : _GEN_214; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_515 = 3'h6 == _T_426[2:0] ? unpacked_readData_6 : _GEN_215; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_516 = 3'h7 == _T_426[2:0] ? unpacked_readData_7 : _GEN_216; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _unpacked_readData_T_690 = _GEN_217; // @[hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151]
  wire  _T_692 = _GEN_217 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:151]
  wire  _T_693 = ~_T_429; // @[hbm_reader_double_fifo.scala 570:105]
  wire  _T_694 = ~_T_430; // @[hbm_reader_double_fifo.scala 570:103]
  wire  _readData_vec_1_T_687_wr_en = _T_431; // @[hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_517 = 2'h0 == _T_685[1:0] ? _T_431 : _GEN_489; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_518 = 2'h1 == _T_685[1:0] ? _T_431 : _GEN_490; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_519 = 2'h2 == _T_685[1:0] ? _T_431 : _GEN_491; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_520 = 2'h3 == _T_685[1:0] ? _T_431 : _GEN_492; // @[hbm_reader_double_fifo.scala 570:100]
  reg [7:0] _T_695; // @[hbm_reader_double_fifo.scala 571:57]
  wire [8:0] _T_696 = 8'h2 + _T_695; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _T_697 = 8'h2 + _T_695; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _GEN_690 = _T_697 % 8'h4; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_698 = _GEN_690[2:0]; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_699 = _T_698;
  wire [1:0] _T_700 = _T_698[1:0];
  wire [15:0] _T_701 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_702 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [7:0] _T_703 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [2:0] _T_704 = _T_426[2:0];
  wire [8:0] _T_705 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [7:0] _T_706 = 8'h2 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [1:0] _T_707 = _T_426[1:0];
  wire [23:0] _GEN_521 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_522 = 3'h1 == _T_426[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_523 = 3'h2 == _T_426[2:0] ? neighbour_2 : _GEN_223; // @[Cat.scala 29:58]
  wire [23:0] _GEN_524 = 3'h3 == _T_426[2:0] ? neighbour_3 : _GEN_224; // @[Cat.scala 29:58]
  wire [23:0] _GEN_525 = 3'h4 == _T_426[2:0] ? neighbour_4 : _GEN_225; // @[Cat.scala 29:58]
  wire [23:0] _GEN_526 = 3'h5 == _T_426[2:0] ? neighbour_5 : _GEN_226; // @[Cat.scala 29:58]
  wire [23:0] _GEN_527 = 3'h6 == _T_426[2:0] ? neighbour_6 : _GEN_227; // @[Cat.scala 29:58]
  wire [23:0] _GEN_528 = 3'h7 == _T_426[2:0] ? neighbour_7 : _GEN_228; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_704 = _GEN_229; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_708 = {16'h0,_GEN_229}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_529 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_530 = 2'h1 == _T_426[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_531 = 2'h2 == _T_426[1:0] ? src_0 : _GEN_231; // @[Cat.scala 29:58]
  wire [23:0] _GEN_532 = 2'h3 == _T_426[1:0] ? src_0 : _GEN_232; // @[Cat.scala 29:58]
  wire [23:0] _src_T_707 = _GEN_233; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_709 = {16'h0,_GEN_229,_GEN_233}; // @[Cat.scala 29:58]
  wire [63:0] _T_710 = ~_T_446; // @[hbm_reader_double_fifo.scala 571:103]
  wire [63:0] _T_711 = ~_T_447; // @[hbm_reader_double_fifo.scala 571:101]
  wire [63:0] _readData_vec_1_T_700_din = _T_448; // @[hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_533 = 2'h0 == _T_698[1:0] ? _T_448 : _GEN_505; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_534 = 2'h1 == _T_698[1:0] ? _T_448 : _GEN_506; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_535 = 2'h2 == _T_698[1:0] ? _T_448 : _GEN_507; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_536 = 2'h3 == _T_698[1:0] ? _T_448 : _GEN_508; // @[hbm_reader_double_fifo.scala 571:98]
  reg [7:0] _T_712; // @[hbm_reader_double_fifo.scala 570:57]
  wire [8:0] _T_713 = 8'h3 + _T_712; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _T_714 = 8'h3 + _T_712; // @[hbm_reader_double_fifo.scala 570:48]
  wire [7:0] _GEN_691 = _T_714 % 8'h4; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_715 = _GEN_691[2:0]; // @[hbm_reader_double_fifo.scala 570:76]
  wire [2:0] _T_716 = _T_715;
  wire [1:0] _T_717 = _T_715[1:0];
  wire [8:0] _T_718 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [7:0] _T_719 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 570:132]
  wire [2:0] _T_720 = _T_456[2:0];
  wire [31:0] _T_721 = 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:155]
  wire [31:0] _GEN_537 = unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_538 = 3'h1 == _T_456[2:0] ? unpacked_readData_1 : unpacked_readData_0; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_539 = 3'h2 == _T_456[2:0] ? unpacked_readData_2 : _GEN_239; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_540 = 3'h3 == _T_456[2:0] ? unpacked_readData_3 : _GEN_240; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_541 = 3'h4 == _T_456[2:0] ? unpacked_readData_4 : _GEN_241; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_542 = 3'h5 == _T_456[2:0] ? unpacked_readData_5 : _GEN_242; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_543 = 3'h6 == _T_456[2:0] ? unpacked_readData_6 : _GEN_243; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _GEN_544 = 3'h7 == _T_456[2:0] ? unpacked_readData_7 : _GEN_244; // @[hbm_reader_double_fifo.scala 570:151]
  wire [31:0] _unpacked_readData_T_720 = _GEN_245; // @[hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151 hbm_reader_double_fifo.scala 570:151]
  wire  _T_722 = _GEN_245 != 32'hffffffff; // @[hbm_reader_double_fifo.scala 570:151]
  wire  _T_723 = ~_T_459; // @[hbm_reader_double_fifo.scala 570:105]
  wire  _T_724 = ~_T_460; // @[hbm_reader_double_fifo.scala 570:103]
  wire  _readData_vec_1_T_717_wr_en = _T_461; // @[hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_545 = 2'h0 == _T_715[1:0] ? _T_461 : _GEN_517; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_546 = 2'h1 == _T_715[1:0] ? _T_461 : _GEN_518; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_547 = 2'h2 == _T_715[1:0] ? _T_461 : _GEN_519; // @[hbm_reader_double_fifo.scala 570:100]
  wire  _GEN_548 = 2'h3 == _T_715[1:0] ? _T_461 : _GEN_520; // @[hbm_reader_double_fifo.scala 570:100]
  reg [7:0] _T_725; // @[hbm_reader_double_fifo.scala 571:57]
  wire [8:0] _T_726 = 8'h3 + _T_725; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _T_727 = 8'h3 + _T_725; // @[hbm_reader_double_fifo.scala 571:48]
  wire [7:0] _GEN_692 = _T_727 % 8'h4; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_728 = _GEN_692[2:0]; // @[hbm_reader_double_fifo.scala 571:76]
  wire [2:0] _T_729 = _T_728;
  wire [1:0] _T_730 = _T_728[1:0];
  wire [15:0] _T_731 = 16'h0; // @[Bitwise.scala 72:12]
  wire [8:0] _T_732 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [7:0] _T_733 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:192]
  wire [2:0] _T_734 = _T_456[2:0];
  wire [8:0] _T_735 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [7:0] _T_736 = 8'h3 + loc_flag_data_1; // @[hbm_reader_double_fifo.scala 571:223]
  wire [1:0] _T_737 = _T_456[1:0];
  wire [23:0] _GEN_549 = neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_550 = 3'h1 == _T_456[2:0] ? neighbour_1 : neighbour_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_551 = 3'h2 == _T_456[2:0] ? neighbour_2 : _GEN_251; // @[Cat.scala 29:58]
  wire [23:0] _GEN_552 = 3'h3 == _T_456[2:0] ? neighbour_3 : _GEN_252; // @[Cat.scala 29:58]
  wire [23:0] _GEN_553 = 3'h4 == _T_456[2:0] ? neighbour_4 : _GEN_253; // @[Cat.scala 29:58]
  wire [23:0] _GEN_554 = 3'h5 == _T_456[2:0] ? neighbour_5 : _GEN_254; // @[Cat.scala 29:58]
  wire [23:0] _GEN_555 = 3'h6 == _T_456[2:0] ? neighbour_6 : _GEN_255; // @[Cat.scala 29:58]
  wire [23:0] _GEN_556 = 3'h7 == _T_456[2:0] ? neighbour_7 : _GEN_256; // @[Cat.scala 29:58]
  wire [23:0] _neighbour_T_734 = _GEN_257; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [39:0] _T_738 = {16'h0,_GEN_257}; // @[Cat.scala 29:58]
  wire [23:0] _GEN_557 = src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_558 = 2'h1 == _T_456[1:0] ? src_0 : src_0; // @[Cat.scala 29:58]
  wire [23:0] _GEN_559 = 2'h2 == _T_456[1:0] ? src_0 : _GEN_259; // @[Cat.scala 29:58]
  wire [23:0] _GEN_560 = 2'h3 == _T_456[1:0] ? src_0 : _GEN_260; // @[Cat.scala 29:58]
  wire [23:0] _src_T_737 = _GEN_261; // @[Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58 Cat.scala 29:58]
  wire [63:0] _T_739 = {16'h0,_GEN_257,_GEN_261}; // @[Cat.scala 29:58]
  wire [63:0] _T_740 = ~_T_476; // @[hbm_reader_double_fifo.scala 571:103]
  wire [63:0] _T_741 = ~_T_477; // @[hbm_reader_double_fifo.scala 571:101]
  wire [63:0] _readData_vec_1_T_730_din = _T_478; // @[hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_561 = 2'h0 == _T_728[1:0] ? _T_478 : _GEN_533; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_562 = 2'h1 == _T_728[1:0] ? _T_478 : _GEN_534; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_563 = 2'h2 == _T_728[1:0] ? _T_478 : _GEN_535; // @[hbm_reader_double_fifo.scala 571:98]
  wire [63:0] _GEN_564 = 2'h3 == _T_728[1:0] ? _T_478 : _GEN_536; // @[hbm_reader_double_fifo.scala 571:98]
  wire [8:0] _T_743 = valid_data_num - 8'h4; // @[hbm_reader_double_fifo.scala 582:58]
  wire [7:0] _T_744 = valid_data_num - 8'h4; // @[hbm_reader_double_fifo.scala 582:58]
  wire [8:0] _T_745 = loc_flag_data_1 + 8'h4; // @[hbm_reader_double_fifo.scala 583:60]
  wire [7:0] _T_746 = loc_flag_data_1 + 8'h4; // @[hbm_reader_double_fifo.scala 583:60]
  wire  _GEN_565 = 1'h0; // @[hbm_reader_double_fifo.scala 574:58]
  wire [7:0] _GEN_566 = _T_742 ? _T_613 : _GEN_448; // @[hbm_reader_double_fifo.scala 574:58]
  wire [7:0] _GEN_567 = _T_742 ? _T_483 : loc_flag_data_1; // @[hbm_reader_double_fifo.scala 574:58]
  wire  _GEN_569 = _T_742 | _GEN_450; // @[hbm_reader_double_fifo.scala 574:58]
  wire [8:0] _T_748 = loc_flag_fifo_1 + valid_data_num; // @[hbm_reader_double_fifo.scala 594:61]
  wire [7:0] _T_749 = loc_flag_fifo_1 + valid_data_num; // @[hbm_reader_double_fifo.scala 594:61]
  wire [7:0] _GEN_693 = _T_749 % 8'h4; // @[hbm_reader_double_fifo.scala 594:79]
  wire [2:0] _T_750 = _GEN_693[2:0]; // @[hbm_reader_double_fifo.scala 594:79]
  wire  _GEN_570 = _T_747; // @[hbm_reader_double_fifo.scala 587:59]
  wire [7:0] _GEN_571 = _T_747 ? {{5'd0}, _T_750} : loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 587:59]
  wire [7:0] _GEN_572 = _T_747 ? 8'h0 : _GEN_567; // @[hbm_reader_double_fifo.scala 587:59]
  wire  _GEN_574 = _T_747 ? 1'h0 : _GEN_452; // @[hbm_reader_double_fifo.scala 587:59]
  wire  _GEN_575 = _T_747 ? 1'h0 : _GEN_569; // @[hbm_reader_double_fifo.scala 587:59]
  wire  _GEN_576 = _T_621 ? _T_747 : _GEN_439; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_577 = _T_621 & _GEN_545; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_578 = _T_621 & _GEN_546; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_579 = _T_621 & _GEN_547; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_580 = _T_621 & _GEN_548; // @[hbm_reader_double_fifo.scala 567:62]
  wire [63:0] _GEN_581 = _GEN_561; // @[hbm_reader_double_fifo.scala 567:62]
  wire [63:0] _GEN_582 = _GEN_562; // @[hbm_reader_double_fifo.scala 567:62]
  wire [63:0] _GEN_583 = _GEN_563; // @[hbm_reader_double_fifo.scala 567:62]
  wire [63:0] _GEN_584 = _GEN_564; // @[hbm_reader_double_fifo.scala 567:62]
  wire [7:0] _GEN_585 = _T_621 ? _GEN_566 : _GEN_448; // @[hbm_reader_double_fifo.scala 567:62]
  wire [7:0] _GEN_586 = _T_621 ? _GEN_572 : loc_flag_data_1; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_588 = _T_621 ? _GEN_575 : _GEN_450; // @[hbm_reader_double_fifo.scala 567:62]
  wire [7:0] _GEN_589 = _T_621 ? _GEN_571 : loc_flag_fifo_1; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_590 = _T_621 ? _GEN_574 : _GEN_452; // @[hbm_reader_double_fifo.scala 567:62]
  wire  _GEN_591 = stateReg & _GEN_576; // @[Conditional.scala 39:67]
  wire  _GEN_592 = stateReg & _GEN_440; // @[Conditional.scala 39:67]
  wire  _GEN_593 = stateReg & _GEN_441; // @[Conditional.scala 39:67]
  wire  _GEN_594 = stateReg & _GEN_442; // @[Conditional.scala 39:67]
  wire  _GEN_595 = stateReg & _GEN_443; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_596 = _GEN_426; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_597 = _GEN_427; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_598 = _GEN_428; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_599 = _GEN_429; // @[Conditional.scala 39:67]
  wire [7:0] _GEN_600 = stateReg ? _GEN_585 : valid_data_num; // @[Conditional.scala 39:67]
  wire [7:0] _GEN_601 = stateReg ? _GEN_449 : loc_flag_data_0; // @[Conditional.scala 39:67]
  wire  _GEN_603 = stateReg ? _GEN_588 : stateReg; // @[Conditional.scala 39:67]
  wire [7:0] _GEN_604 = stateReg ? _GEN_451 : loc_flag_fifo_0; // @[Conditional.scala 39:67]
  wire  _GEN_605 = stateReg ? _GEN_590 : flag_readData_vec; // @[Conditional.scala 39:67]
  wire  _GEN_606 = stateReg & _GEN_577; // @[Conditional.scala 39:67]
  wire  _GEN_607 = stateReg & _GEN_578; // @[Conditional.scala 39:67]
  wire  _GEN_608 = stateReg & _GEN_579; // @[Conditional.scala 39:67]
  wire  _GEN_609 = stateReg & _GEN_580; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_610 = _GEN_561; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_611 = _GEN_562; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_612 = _GEN_563; // @[Conditional.scala 39:67]
  wire [63:0] _GEN_613 = _GEN_564; // @[Conditional.scala 39:67]
  wire [7:0] _GEN_614 = stateReg ? _GEN_586 : loc_flag_data_1; // @[Conditional.scala 39:67]
  wire [7:0] _GEN_615 = stateReg ? _GEN_589 : loc_flag_fifo_1; // @[Conditional.scala 39:67]
  wire  _GEN_617 = _T_215 ? _GEN_292 : _GEN_591; // @[Conditional.scala 40:58]
  wire  _GEN_618 = _T_215 & _GEN_293; // @[Conditional.scala 40:58]
  wire  readData_vec_0_0_wr_en = _T_215 ? _GEN_294 : _GEN_592; // @[Conditional.scala 40:58]
  wire  readData_vec_0_1_wr_en = _T_215 ? _GEN_295 : _GEN_593; // @[Conditional.scala 40:58]
  wire  readData_vec_0_2_wr_en = _T_215 ? _GEN_296 : _GEN_594; // @[Conditional.scala 40:58]
  wire  readData_vec_0_3_wr_en = _T_215 ? _GEN_297 : _GEN_595; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_0_0_din = _T_215 ? _GEN_124 : _GEN_426; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_0_1_din = _T_215 ? _GEN_125 : _GEN_427; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_0_2_din = _T_215 ? _GEN_126 : _GEN_428; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_0_3_din = _T_215 ? _GEN_127 : _GEN_429; // @[Conditional.scala 40:58]
  wire [7:0] _GEN_627 = _T_215 ? _GEN_302 : _GEN_600; // @[Conditional.scala 40:58]
  wire [7:0] _GEN_628 = _T_215 ? _GEN_303 : _GEN_601; // @[Conditional.scala 40:58]
  wire  _GEN_629 = _T_215 ? _GEN_305 : _GEN_603; // @[Conditional.scala 40:58]
  wire [7:0] _GEN_630 = _T_215 ? _GEN_306 : _GEN_604; // @[Conditional.scala 40:58]
  wire  _GEN_631 = _T_215 ? _GEN_307 : _GEN_605; // @[Conditional.scala 40:58]
  wire  readData_vec_1_0_wr_en = _T_215 ? _GEN_308 : _GEN_606; // @[Conditional.scala 40:58]
  wire  readData_vec_1_1_wr_en = _T_215 ? _GEN_309 : _GEN_607; // @[Conditional.scala 40:58]
  wire  readData_vec_1_2_wr_en = _T_215 ? _GEN_310 : _GEN_608; // @[Conditional.scala 40:58]
  wire  readData_vec_1_3_wr_en = _T_215 ? _GEN_311 : _GEN_609; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_1_0_din = _T_215 ? _GEN_262 : _GEN_561; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_1_1_din = _T_215 ? _GEN_263 : _GEN_562; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_1_2_din = _T_215 ? _GEN_264 : _GEN_563; // @[Conditional.scala 40:58]
  wire [63:0] readData_vec_1_3_din = _T_215 ? _GEN_265 : _GEN_564; // @[Conditional.scala 40:58]
  wire [7:0] _GEN_640 = _T_215 ? _GEN_316 : _GEN_614; // @[Conditional.scala 40:58]
  wire [7:0] _GEN_641 = _T_215 ? _GEN_317 : _GEN_615; // @[Conditional.scala 40:58]
  wire  readData_vec_0_0_rst = reset; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 207:34]
  wire  readData_vec_0_0_clk = clock; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 208:31]
  wire [63:0] _GEN_623 = readData_vec_0_0_din; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire  _GEN_619 = readData_vec_0_0_wr_en; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 212:34 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  readData_vec_0_0_rd_en = RRArbiter_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 104:41]
  wire  readData_vec_0_1_rst = reset; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 207:34]
  wire  readData_vec_0_1_clk = clock; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 208:31]
  wire [63:0] _GEN_624 = readData_vec_0_1_din; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire  _GEN_620 = readData_vec_0_1_wr_en; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 212:34 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  readData_vec_0_1_rd_en = RRArbiter_1_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 104:41]
  wire  readData_vec_0_2_rst = reset; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 207:34]
  wire  readData_vec_0_2_clk = clock; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 208:31]
  wire [63:0] _GEN_625 = readData_vec_0_2_din; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire  _GEN_621 = readData_vec_0_2_wr_en; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 212:34 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  readData_vec_0_2_rd_en = RRArbiter_2_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 104:41]
  wire  readData_vec_0_3_rst = reset; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 207:34]
  wire  readData_vec_0_3_clk = clock; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 208:31]
  wire [63:0] _GEN_626 = readData_vec_0_3_din; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 460:106 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98 hbm_reader_double_fifo.scala 535:98]
  wire  _GEN_622 = readData_vec_0_3_wr_en; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 212:34 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 459:108 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100 hbm_reader_double_fifo.scala 534:100]
  wire  readData_vec_0_3_rd_en = RRArbiter_3_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33 hbm_reader_double_fifo.scala 104:41]
  wire  readData_vec_1_0_rst = reset; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 220:34]
  wire  readData_vec_1_0_clk = clock; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 221:31]
  wire [63:0] _GEN_636 = readData_vec_1_0_din; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire  _GEN_632 = readData_vec_1_0_wr_en; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 225:34 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  readData_vec_1_0_rd_en = RRArbiter_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 107:41]
  wire  readData_vec_1_1_rst = reset; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 220:34]
  wire  readData_vec_1_1_clk = clock; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 221:31]
  wire [63:0] _GEN_637 = readData_vec_1_1_din; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire  _GEN_633 = readData_vec_1_1_wr_en; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 225:34 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  readData_vec_1_1_rd_en = RRArbiter_1_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 107:41]
  wire  readData_vec_1_2_rst = reset; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 220:34]
  wire  readData_vec_1_2_clk = clock; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 221:31]
  wire [63:0] _GEN_638 = readData_vec_1_2_din; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire  _GEN_634 = readData_vec_1_2_wr_en; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 225:34 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  readData_vec_1_2_rd_en = RRArbiter_2_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 107:41]
  wire  readData_vec_1_3_rst = reset; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 220:34]
  wire  readData_vec_1_3_clk = clock; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 221:31]
  wire [63:0] _GEN_639 = readData_vec_1_3_din; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 495:106 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98 hbm_reader_double_fifo.scala 571:98]
  wire  _GEN_635 = readData_vec_1_3_wr_en; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 225:34 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 494:108 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100 hbm_reader_double_fifo.scala 570:100]
  wire  readData_vec_1_3_rd_en = RRArbiter_3_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33 hbm_reader_double_fifo.scala 107:41]
  wire  readData_vec_asy_0_rst = reset; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 194:36]
  wire  readData_vec_asy_0_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 195:36]
  wire  readData_vec_asy_0_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 196:36]
  wire [63:0] readData_vec_asy_0_din = RRArbiter_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 197:36]
  wire  readData_vec_asy_0_rd_en = io_interface_to_pe_readData_array_0_ready; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 199:36]
  wire  readData_vec_asy_1_rst = reset; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 194:36]
  wire  readData_vec_asy_1_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 195:36]
  wire  readData_vec_asy_1_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 196:36]
  wire [63:0] readData_vec_asy_1_din = RRArbiter_1_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 197:36]
  wire  readData_vec_asy_1_rd_en = io_interface_to_pe_readData_array_1_ready; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 199:36]
  wire  readData_vec_asy_2_rst = reset; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 194:36]
  wire  readData_vec_asy_2_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 195:36]
  wire  readData_vec_asy_2_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 196:36]
  wire [63:0] readData_vec_asy_2_din = RRArbiter_2_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 197:36]
  wire  readData_vec_asy_2_rd_en = io_interface_to_pe_readData_array_2_ready; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 199:36]
  wire  readData_vec_asy_3_rst = reset; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 194:36]
  wire  readData_vec_asy_3_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 195:36]
  wire  readData_vec_asy_3_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 196:36]
  wire [63:0] readData_vec_asy_3_din = RRArbiter_3_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 197:36]
  wire  readData_vec_asy_3_rd_en = io_interface_to_pe_readData_array_3_ready; // @[hbm_reader_double_fifo.scala 94:35 hbm_reader_double_fifo.scala 199:36]
  wire [63:0] _T_26_addr = _T_27[77:14]; // @[hbm_reader_double_fifo.scala 135:31 hbm_reader_double_fifo.scala 135:31]
  wire [7:0] _T_26_len = _T_27[13:6]; // @[hbm_reader_double_fifo.scala 135:31 hbm_reader_double_fifo.scala 135:31]
  wire [5:0] _T_26_id = _T_27[5:0]; // @[hbm_reader_double_fifo.scala 135:31 hbm_reader_double_fifo.scala 135:31]
  wire [255:0] _T_35_data = _T_36[288:33]; // @[hbm_reader_double_fifo.scala 148:31 hbm_reader_double_fifo.scala 148:31]
  wire [31:0] _T_35_strb = _T_36[32:1]; // @[hbm_reader_double_fifo.scala 148:31 hbm_reader_double_fifo.scala 148:31]
  wire  _T_35_last = _T_36[0]; // @[hbm_reader_double_fifo.scala 148:31 hbm_reader_double_fifo.scala 148:31]
  wire [63:0] _T_44_addr = _T_45[77:14]; // @[hbm_reader_double_fifo.scala 161:30 hbm_reader_double_fifo.scala 161:30]
  wire [7:0] _T_44_len = _T_45[13:6]; // @[hbm_reader_double_fifo.scala 161:30 hbm_reader_double_fifo.scala 161:30]
  wire [5:0] _T_44_id = _T_45[5:0]; // @[hbm_reader_double_fifo.scala 161:30 hbm_reader_double_fifo.scala 161:30]
  wire [5:0] _T_52_id = _T_53[7:2]; // @[hbm_reader_double_fifo.scala 174:31 hbm_reader_double_fifo.scala 174:31]
  wire [1:0] _T_52_resp = _T_53[1:0]; // @[hbm_reader_double_fifo.scala 174:31 hbm_reader_double_fifo.scala 174:31]
  wire [255:0] _T_59_data = _T_60; // @[hbm_reader_double_fifo.scala 200:38 hbm_reader_double_fifo.scala 200:38]
  wire [255:0] _T_65_data = _T_66; // @[hbm_reader_double_fifo.scala 200:38 hbm_reader_double_fifo.scala 200:38]
  wire [255:0] _T_71_data = _T_72; // @[hbm_reader_double_fifo.scala 200:38 hbm_reader_double_fifo.scala 200:38]
  wire [255:0] _T_77_data = _T_78; // @[hbm_reader_double_fifo.scala 200:38 hbm_reader_double_fifo.scala 200:38]
  wire [63:0] _T_83_data = _T_84; // @[hbm_reader_double_fifo.scala 240:37 hbm_reader_double_fifo.scala 240:37]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _T_111 = _GEN_5; // @[Counter.scala 67:24]
  wire  _T_119 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_127 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_135 = _GEN_14; // @[Counter.scala 67:24]
  fifo_generator_writeAddr writeAddr ( // @[hbm_reader_double_fifo.scala 81:27]
    .rst(writeAddr_rst),
    .wr_clk(writeAddr_wr_clk),
    .rd_clk(writeAddr_rd_clk),
    .din(writeAddr_din),
    .wr_en(writeAddr_wr_en),
    .rd_en(writeAddr_rd_en),
    .dout(writeAddr_dout),
    .full(writeAddr_full),
    .empty(writeAddr_empty)
  );
  fifo_generator_writeData writeData ( // @[hbm_reader_double_fifo.scala 82:27]
    .rst(writeData_rst),
    .wr_clk(writeData_wr_clk),
    .rd_clk(writeData_rd_clk),
    .din(writeData_din),
    .wr_en(writeData_wr_en),
    .rd_en(writeData_rd_en),
    .dout(writeData_dout),
    .full(writeData_full),
    .empty(writeData_empty)
  );
  fifo_generator_writeResp writeResp ( // @[hbm_reader_double_fifo.scala 83:27]
    .rst(writeResp_rst),
    .wr_clk(writeResp_wr_clk),
    .rd_clk(writeResp_rd_clk),
    .din(writeResp_din),
    .wr_en(writeResp_wr_en),
    .rd_en(writeResp_rd_en),
    .dout(writeResp_dout),
    .full(writeResp_full),
    .empty(writeResp_empty)
  );
  fifo_generator_readAddr readAddr ( // @[hbm_reader_double_fifo.scala 84:26]
    .rst(readAddr_rst),
    .wr_clk(readAddr_wr_clk),
    .rd_clk(readAddr_rd_clk),
    .din(readAddr_din),
    .wr_en(readAddr_wr_en),
    .rd_en(readAddr_rd_en),
    .dout(readAddr_dout),
    .full(readAddr_full),
    .empty(readAddr_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn ( // @[hbm_reader_double_fifo.scala 92:63]
    .rst(fifo_generator_readData_syn_rst),
    .clk(fifo_generator_readData_syn_clk),
    .din(fifo_generator_readData_syn_din),
    .wr_en(fifo_generator_readData_syn_wr_en),
    .rd_en(fifo_generator_readData_syn_rd_en),
    .dout(fifo_generator_readData_syn_dout),
    .full(fifo_generator_readData_syn_full),
    .empty(fifo_generator_readData_syn_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_1 ( // @[hbm_reader_double_fifo.scala 92:63]
    .rst(fifo_generator_readData_syn_1_rst),
    .clk(fifo_generator_readData_syn_1_clk),
    .din(fifo_generator_readData_syn_1_din),
    .wr_en(fifo_generator_readData_syn_1_wr_en),
    .rd_en(fifo_generator_readData_syn_1_rd_en),
    .dout(fifo_generator_readData_syn_1_dout),
    .full(fifo_generator_readData_syn_1_full),
    .empty(fifo_generator_readData_syn_1_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_2 ( // @[hbm_reader_double_fifo.scala 92:63]
    .rst(fifo_generator_readData_syn_2_rst),
    .clk(fifo_generator_readData_syn_2_clk),
    .din(fifo_generator_readData_syn_2_din),
    .wr_en(fifo_generator_readData_syn_2_wr_en),
    .rd_en(fifo_generator_readData_syn_2_rd_en),
    .dout(fifo_generator_readData_syn_2_dout),
    .full(fifo_generator_readData_syn_2_full),
    .empty(fifo_generator_readData_syn_2_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_3 ( // @[hbm_reader_double_fifo.scala 92:63]
    .rst(fifo_generator_readData_syn_3_rst),
    .clk(fifo_generator_readData_syn_3_clk),
    .din(fifo_generator_readData_syn_3_din),
    .wr_en(fifo_generator_readData_syn_3_wr_en),
    .rd_en(fifo_generator_readData_syn_3_rd_en),
    .dout(fifo_generator_readData_syn_3_dout),
    .full(fifo_generator_readData_syn_3_full),
    .empty(fifo_generator_readData_syn_3_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_4 ( // @[hbm_reader_double_fifo.scala 93:63]
    .rst(fifo_generator_readData_syn_4_rst),
    .clk(fifo_generator_readData_syn_4_clk),
    .din(fifo_generator_readData_syn_4_din),
    .wr_en(fifo_generator_readData_syn_4_wr_en),
    .rd_en(fifo_generator_readData_syn_4_rd_en),
    .dout(fifo_generator_readData_syn_4_dout),
    .full(fifo_generator_readData_syn_4_full),
    .empty(fifo_generator_readData_syn_4_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_5 ( // @[hbm_reader_double_fifo.scala 93:63]
    .rst(fifo_generator_readData_syn_5_rst),
    .clk(fifo_generator_readData_syn_5_clk),
    .din(fifo_generator_readData_syn_5_din),
    .wr_en(fifo_generator_readData_syn_5_wr_en),
    .rd_en(fifo_generator_readData_syn_5_rd_en),
    .dout(fifo_generator_readData_syn_5_dout),
    .full(fifo_generator_readData_syn_5_full),
    .empty(fifo_generator_readData_syn_5_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_6 ( // @[hbm_reader_double_fifo.scala 93:63]
    .rst(fifo_generator_readData_syn_6_rst),
    .clk(fifo_generator_readData_syn_6_clk),
    .din(fifo_generator_readData_syn_6_din),
    .wr_en(fifo_generator_readData_syn_6_wr_en),
    .rd_en(fifo_generator_readData_syn_6_rd_en),
    .dout(fifo_generator_readData_syn_6_dout),
    .full(fifo_generator_readData_syn_6_full),
    .empty(fifo_generator_readData_syn_6_empty)
  );
  fifo_generator_readData_syn fifo_generator_readData_syn_7 ( // @[hbm_reader_double_fifo.scala 93:63]
    .rst(fifo_generator_readData_syn_7_rst),
    .clk(fifo_generator_readData_syn_7_clk),
    .din(fifo_generator_readData_syn_7_din),
    .wr_en(fifo_generator_readData_syn_7_wr_en),
    .rd_en(fifo_generator_readData_syn_7_rd_en),
    .dout(fifo_generator_readData_syn_7_dout),
    .full(fifo_generator_readData_syn_7_full),
    .empty(fifo_generator_readData_syn_7_empty)
  );
  fifo_generator_readData fifo_generator_readData ( // @[hbm_reader_double_fifo.scala 94:65]
    .rst(fifo_generator_readData_rst),
    .wr_clk(fifo_generator_readData_wr_clk),
    .rd_clk(fifo_generator_readData_rd_clk),
    .din(fifo_generator_readData_din),
    .wr_en(fifo_generator_readData_wr_en),
    .rd_en(fifo_generator_readData_rd_en),
    .dout(fifo_generator_readData_dout),
    .full(fifo_generator_readData_full),
    .empty(fifo_generator_readData_empty)
  );
  fifo_generator_readData fifo_generator_readData_1 ( // @[hbm_reader_double_fifo.scala 94:65]
    .rst(fifo_generator_readData_1_rst),
    .wr_clk(fifo_generator_readData_1_wr_clk),
    .rd_clk(fifo_generator_readData_1_rd_clk),
    .din(fifo_generator_readData_1_din),
    .wr_en(fifo_generator_readData_1_wr_en),
    .rd_en(fifo_generator_readData_1_rd_en),
    .dout(fifo_generator_readData_1_dout),
    .full(fifo_generator_readData_1_full),
    .empty(fifo_generator_readData_1_empty)
  );
  fifo_generator_readData fifo_generator_readData_2 ( // @[hbm_reader_double_fifo.scala 94:65]
    .rst(fifo_generator_readData_2_rst),
    .wr_clk(fifo_generator_readData_2_wr_clk),
    .rd_clk(fifo_generator_readData_2_rd_clk),
    .din(fifo_generator_readData_2_din),
    .wr_en(fifo_generator_readData_2_wr_en),
    .rd_en(fifo_generator_readData_2_rd_en),
    .dout(fifo_generator_readData_2_dout),
    .full(fifo_generator_readData_2_full),
    .empty(fifo_generator_readData_2_empty)
  );
  fifo_generator_readData fifo_generator_readData_3 ( // @[hbm_reader_double_fifo.scala 94:65]
    .rst(fifo_generator_readData_3_rst),
    .wr_clk(fifo_generator_readData_3_wr_clk),
    .rd_clk(fifo_generator_readData_3_rd_clk),
    .din(fifo_generator_readData_3_din),
    .wr_en(fifo_generator_readData_3_wr_en),
    .rd_en(fifo_generator_readData_3_rd_en),
    .dout(fifo_generator_readData_3_dout),
    .full(fifo_generator_readData_3_full),
    .empty(fifo_generator_readData_3_empty)
  );
  RRArbiter RRArbiter ( // @[hbm_reader_double_fifo.scala 99:34]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  RRArbiter RRArbiter_1 ( // @[hbm_reader_double_fifo.scala 99:34]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  RRArbiter RRArbiter_2 ( // @[hbm_reader_double_fifo.scala 99:34]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  RRArbiter RRArbiter_3 ( // @[hbm_reader_double_fifo.scala 99:34]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_generator_readData readData_offset ( // @[hbm_reader_double_fifo.scala 116:33]
    .rst(readData_offset_rst),
    .wr_clk(readData_offset_wr_clk),
    .rd_clk(readData_offset_rd_clk),
    .din(readData_offset_din),
    .wr_en(readData_offset_wr_en),
    .rd_en(readData_offset_rd_en),
    .dout(readData_offset_dout),
    .full(readData_offset_full),
    .empty(readData_offset_empty)
  );
  fifo_generator_src src_index_queue_asyn ( // @[hbm_reader_double_fifo.scala 118:38]
    .rst(src_index_queue_asyn_rst),
    .wr_clk(src_index_queue_asyn_wr_clk),
    .rd_clk(src_index_queue_asyn_rd_clk),
    .din(src_index_queue_asyn_din),
    .wr_en(src_index_queue_asyn_wr_en),
    .rd_en(src_index_queue_asyn_rd_en),
    .dout(src_index_queue_asyn_dout),
    .full(src_index_queue_asyn_full),
    .empty(src_index_queue_asyn_empty)
  );
  fifo_generator_src burst_cnt ( // @[hbm_reader_double_fifo.scala 121:27]
    .rst(burst_cnt_rst),
    .wr_clk(burst_cnt_wr_clk),
    .rd_clk(burst_cnt_rd_clk),
    .din(burst_cnt_din),
    .wr_en(burst_cnt_wr_en),
    .rd_en(burst_cnt_rd_en),
    .dout(burst_cnt_dout),
    .full(burst_cnt_full),
    .empty(burst_cnt_empty)
  );
  fifo_generator_src neighbour_cnt ( // @[hbm_reader_double_fifo.scala 122:31]
    .rst(neighbour_cnt_rst),
    .wr_clk(neighbour_cnt_wr_clk),
    .rd_clk(neighbour_cnt_rd_clk),
    .din(neighbour_cnt_din),
    .wr_en(neighbour_cnt_wr_en),
    .rd_en(neighbour_cnt_rd_en),
    .dout(neighbour_cnt_dout),
    .full(neighbour_cnt_full),
    .empty(neighbour_cnt_empty)
  );
  Queue src_index_queue_l1 ( // @[hbm_reader_double_fifo.scala 247:36]
    .clock(src_index_queue_l1_clock),
    .reset(src_index_queue_l1_reset),
    .io_enq_ready(src_index_queue_l1_io_enq_ready),
    .io_enq_valid(src_index_queue_l1_io_enq_valid),
    .io_enq_bits(src_index_queue_l1_io_enq_bits),
    .io_deq_ready(src_index_queue_l1_io_deq_ready),
    .io_deq_valid(src_index_queue_l1_io_deq_valid),
    .io_deq_bits(src_index_queue_l1_io_deq_bits),
    .io_count(src_index_queue_l1_io_count)
  );
  Queue src_index_queue_l2 ( // @[hbm_reader_double_fifo.scala 248:36]
    .clock(src_index_queue_l2_clock),
    .reset(src_index_queue_l2_reset),
    .io_enq_ready(src_index_queue_l2_io_enq_ready),
    .io_enq_valid(src_index_queue_l2_io_enq_valid),
    .io_enq_bits(src_index_queue_l2_io_enq_bits),
    .io_deq_ready(src_index_queue_l2_io_deq_ready),
    .io_deq_valid(src_index_queue_l2_io_deq_valid),
    .io_deq_bits(src_index_queue_l2_io_deq_bits),
    .io_count(src_index_queue_l2_io_count)
  );
  Queue_2 src_index_queue ( // @[hbm_reader_double_fifo.scala 249:33]
    .clock(src_index_queue_clock),
    .reset(src_index_queue_reset),
    .io_enq_ready(src_index_queue_io_enq_ready),
    .io_enq_valid(src_index_queue_io_enq_valid),
    .io_enq_bits(src_index_queue_io_enq_bits),
    .io_deq_ready(src_index_queue_io_deq_ready),
    .io_deq_valid(src_index_queue_io_deq_valid),
    .io_deq_bits(src_index_queue_io_deq_bits),
    .io_count(src_index_queue_io_count)
  );
  assign io_HBM_interface_writeAddr_valid = ~writeAddr_empty; // @[hbm_reader_double_fifo.scala 137:29]
  assign io_HBM_interface_writeAddr_bits_addr = _T_27[77:14]; // @[hbm_reader_double_fifo.scala 135:91]
  assign io_HBM_interface_writeAddr_bits_len = _T_27[13:6]; // @[hbm_reader_double_fifo.scala 135:91]
  assign io_HBM_interface_writeAddr_bits_id = _T_27[5:0]; // @[hbm_reader_double_fifo.scala 135:91]
  assign io_HBM_interface_writeData_valid = ~writeData_empty; // @[hbm_reader_double_fifo.scala 150:29]
  assign io_HBM_interface_writeData_bits_data = _T_36[288:33]; // @[hbm_reader_double_fifo.scala 148:87]
  assign io_HBM_interface_writeData_bits_strb = _T_36[32:1]; // @[hbm_reader_double_fifo.scala 148:87]
  assign io_HBM_interface_writeData_bits_last = _T_36[0]; // @[hbm_reader_double_fifo.scala 148:87]
  assign io_HBM_interface_writeResp_ready = ~writeResp_full; // @[hbm_reader_double_fifo.scala 175:29]
  assign io_HBM_interface_readAddr_valid = ~readAddr_empty; // @[hbm_reader_double_fifo.scala 163:28]
  assign io_HBM_interface_readAddr_bits_addr = _T_45[77:14]; // @[hbm_reader_double_fifo.scala 161:90]
  assign io_HBM_interface_readAddr_bits_len = _T_45[13:6]; // @[hbm_reader_double_fifo.scala 161:90]
  assign io_HBM_interface_readAddr_bits_id = _T_45[5:0]; // @[hbm_reader_double_fifo.scala 161:90]
  assign io_HBM_interface_readData_ready = _T_215 ? _GEN_292 : _GEN_591; // @[hbm_reader_double_fifo.scala 366:37 hbm_reader_double_fifo.scala 420:49 hbm_reader_double_fifo.scala 424:57 hbm_reader_double_fifo.scala 469:65 hbm_reader_double_fifo.scala 481:65 hbm_reader_double_fifo.scala 504:65 hbm_reader_double_fifo.scala 516:65 hbm_reader_double_fifo.scala 529:49 hbm_reader_double_fifo.scala 532:53 hbm_reader_double_fifo.scala 545:57 hbm_reader_double_fifo.scala 557:57 hbm_reader_double_fifo.scala 568:53 hbm_reader_double_fifo.scala 581:57 hbm_reader_double_fifo.scala 593:57]
  assign io_interface_to_pe_writeAddr_ready = ~writeAddr_full; // @[hbm_reader_double_fifo.scala 136:29]
  assign io_interface_to_pe_writeData_ready = ~writeData_full; // @[hbm_reader_double_fifo.scala 149:29]
  assign io_interface_to_pe_writeResp_valid = ~writeResp_empty; // @[hbm_reader_double_fifo.scala 176:29]
  assign io_interface_to_pe_writeResp_bits_id = _T_53[7:2]; // @[hbm_reader_double_fifo.scala 174:76]
  assign io_interface_to_pe_writeResp_bits_resp = _T_53[1:0]; // @[hbm_reader_double_fifo.scala 174:76]
  assign io_interface_to_pe_readAddr_ready = ~readAddr_full; // @[hbm_reader_double_fifo.scala 162:28]
  assign io_interface_to_pe_readData_array_0_valid = ~readData_vec_asy_0_empty; // @[hbm_reader_double_fifo.scala 202:36]
  assign io_interface_to_pe_readData_array_0_bits_data = _T_60[63:0]; // @[hbm_reader_double_fifo.scala 200:106]
  assign io_interface_to_pe_readData_array_1_valid = ~readData_vec_asy_1_empty; // @[hbm_reader_double_fifo.scala 202:36]
  assign io_interface_to_pe_readData_array_1_bits_data = _T_66[63:0]; // @[hbm_reader_double_fifo.scala 200:106]
  assign io_interface_to_pe_readData_array_2_valid = ~readData_vec_asy_2_empty; // @[hbm_reader_double_fifo.scala 202:36]
  assign io_interface_to_pe_readData_array_2_bits_data = _T_72[63:0]; // @[hbm_reader_double_fifo.scala 200:106]
  assign io_interface_to_pe_readData_array_3_valid = ~readData_vec_asy_3_empty; // @[hbm_reader_double_fifo.scala 202:36]
  assign io_interface_to_pe_readData_array_3_bits_data = _T_78[63:0]; // @[hbm_reader_double_fifo.scala 200:106]
  assign io_interface_to_pe_readData_offset_valid = ~readData_offset_empty; // @[hbm_reader_double_fifo.scala 243:35]
  assign io_interface_to_pe_readData_offset_bits_data = readData_offset_dout; // @[hbm_reader_double_fifo.scala 240:94]
  assign io_src_ready = ~_T_96; // @[hbm_reader_double_fifo.scala 260:46]
  assign io_burst_cnt = burst_cnt_dout; // @[hbm_reader_double_fifo.scala 293:29]
  assign io_neighbour_cnt = neighbour_cnt_dout; // @[hbm_reader_double_fifo.scala 301:33]
  assign writeAddr_rst = reset; // @[hbm_reader_double_fifo.scala 128:29]
  assign writeAddr_wr_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 129:29]
  assign writeAddr_rd_clk = clock; // @[hbm_reader_double_fifo.scala 130:29]
  assign writeAddr_din = {_T_24,io_interface_to_pe_writeAddr_bits_id}; // @[hbm_reader_double_fifo.scala 132:29]
  assign writeAddr_wr_en = io_interface_to_pe_writeAddr_valid; // @[hbm_reader_double_fifo.scala 133:29]
  assign writeAddr_rd_en = io_HBM_interface_writeAddr_ready; // @[hbm_reader_double_fifo.scala 134:29]
  assign writeData_rst = reset; // @[hbm_reader_double_fifo.scala 141:29]
  assign writeData_wr_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 142:29]
  assign writeData_rd_clk = clock; // @[hbm_reader_double_fifo.scala 143:29]
  assign writeData_din = {_T_33,io_interface_to_pe_writeData_bits_last}; // @[hbm_reader_double_fifo.scala 145:29]
  assign writeData_wr_en = io_interface_to_pe_writeData_valid; // @[hbm_reader_double_fifo.scala 146:29]
  assign writeData_rd_en = io_HBM_interface_writeData_ready; // @[hbm_reader_double_fifo.scala 147:29]
  assign writeResp_rst = reset; // @[hbm_reader_double_fifo.scala 167:29]
  assign writeResp_wr_clk = clock; // @[hbm_reader_double_fifo.scala 168:29]
  assign writeResp_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 169:29]
  assign writeResp_din = {io_HBM_interface_writeResp_bits_id,io_HBM_interface_writeResp_bits_resp}; // @[hbm_reader_double_fifo.scala 171:29]
  assign writeResp_wr_en = io_HBM_interface_writeResp_valid; // @[hbm_reader_double_fifo.scala 172:29]
  assign writeResp_rd_en = io_interface_to_pe_writeResp_ready; // @[hbm_reader_double_fifo.scala 173:29]
  assign readAddr_rst = reset; // @[hbm_reader_double_fifo.scala 154:28]
  assign readAddr_wr_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 155:28]
  assign readAddr_rd_clk = clock; // @[hbm_reader_double_fifo.scala 156:28]
  assign readAddr_din = {_T_42,io_interface_to_pe_readAddr_bits_id}; // @[hbm_reader_double_fifo.scala 158:28]
  assign readAddr_wr_en = io_interface_to_pe_readAddr_valid; // @[hbm_reader_double_fifo.scala 159:28]
  assign readAddr_rd_en = io_HBM_interface_readAddr_ready; // @[hbm_reader_double_fifo.scala 160:28]
  assign fifo_generator_readData_syn_rst = reset; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_clk = clock; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_din = _T_215 ? _GEN_124 : _GEN_426; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_wr_en = _T_215 ? _GEN_294 : _GEN_592; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_rd_en = RRArbiter_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_1_rst = reset; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_1_clk = clock; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_1_din = _T_215 ? _GEN_125 : _GEN_427; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_1_wr_en = _T_215 ? _GEN_295 : _GEN_593; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_1_rd_en = RRArbiter_1_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_2_rst = reset; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_2_clk = clock; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_2_din = _T_215 ? _GEN_126 : _GEN_428; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_2_wr_en = _T_215 ? _GEN_296 : _GEN_594; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_2_rd_en = RRArbiter_2_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_3_rst = reset; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_3_clk = clock; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_3_din = _T_215 ? _GEN_127 : _GEN_429; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_3_wr_en = _T_215 ? _GEN_297 : _GEN_595; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_3_rd_en = RRArbiter_3_io_in_0_ready; // @[hbm_reader_double_fifo.scala 92:33]
  assign fifo_generator_readData_syn_4_rst = reset; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_4_clk = clock; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_4_din = _T_215 ? _GEN_262 : _GEN_561; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_4_wr_en = _T_215 ? _GEN_308 : _GEN_606; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_4_rd_en = RRArbiter_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_5_rst = reset; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_5_clk = clock; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_5_din = _T_215 ? _GEN_263 : _GEN_562; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_5_wr_en = _T_215 ? _GEN_309 : _GEN_607; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_5_rd_en = RRArbiter_1_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_6_rst = reset; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_6_clk = clock; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_6_din = _T_215 ? _GEN_264 : _GEN_563; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_6_wr_en = _T_215 ? _GEN_310 : _GEN_608; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_6_rd_en = RRArbiter_2_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_7_rst = reset; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_7_clk = clock; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_7_din = _T_215 ? _GEN_265 : _GEN_564; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_7_wr_en = _T_215 ? _GEN_311 : _GEN_609; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_syn_7_rd_en = RRArbiter_3_io_in_1_ready; // @[hbm_reader_double_fifo.scala 93:33]
  assign fifo_generator_readData_rst = reset; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_din = RRArbiter_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_wr_en = RRArbiter_io_out_valid & RRArbiter_io_out_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_rd_en = io_interface_to_pe_readData_array_0_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_rst = reset; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_din = RRArbiter_1_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_wr_en = RRArbiter_1_io_out_valid & RRArbiter_1_io_out_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_1_rd_en = io_interface_to_pe_readData_array_1_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_rst = reset; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_din = RRArbiter_2_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_wr_en = RRArbiter_2_io_out_valid & RRArbiter_2_io_out_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_2_rd_en = io_interface_to_pe_readData_array_2_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_rst = reset; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_wr_clk = clock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_din = RRArbiter_3_io_out_bits; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_wr_en = RRArbiter_3_io_out_valid & RRArbiter_3_io_out_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign fifo_generator_readData_3_rd_en = io_interface_to_pe_readData_array_3_ready; // @[hbm_reader_double_fifo.scala 94:35]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~readData_vec_0_0_empty; // @[hbm_reader_double_fifo.scala 102:41]
  assign RRArbiter_io_in_0_bits = ~_T_1; // @[hbm_reader_double_fifo.scala 103:41]
  assign RRArbiter_io_in_1_valid = ~readData_vec_1_0_empty; // @[hbm_reader_double_fifo.scala 105:41]
  assign RRArbiter_io_in_1_bits = ~_T_4; // @[hbm_reader_double_fifo.scala 106:41]
  assign RRArbiter_io_out_ready = ~readData_vec_asy_0_full; // @[hbm_reader_double_fifo.scala 201:36]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~readData_vec_0_1_empty; // @[hbm_reader_double_fifo.scala 102:41]
  assign RRArbiter_1_io_in_0_bits = ~_T_7; // @[hbm_reader_double_fifo.scala 103:41]
  assign RRArbiter_1_io_in_1_valid = ~readData_vec_1_1_empty; // @[hbm_reader_double_fifo.scala 105:41]
  assign RRArbiter_1_io_in_1_bits = ~_T_10; // @[hbm_reader_double_fifo.scala 106:41]
  assign RRArbiter_1_io_out_ready = ~readData_vec_asy_1_full; // @[hbm_reader_double_fifo.scala 201:36]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~readData_vec_0_2_empty; // @[hbm_reader_double_fifo.scala 102:41]
  assign RRArbiter_2_io_in_0_bits = ~_T_13; // @[hbm_reader_double_fifo.scala 103:41]
  assign RRArbiter_2_io_in_1_valid = ~readData_vec_1_2_empty; // @[hbm_reader_double_fifo.scala 105:41]
  assign RRArbiter_2_io_in_1_bits = ~_T_16; // @[hbm_reader_double_fifo.scala 106:41]
  assign RRArbiter_2_io_out_ready = ~readData_vec_asy_2_full; // @[hbm_reader_double_fifo.scala 201:36]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~readData_vec_0_3_empty; // @[hbm_reader_double_fifo.scala 102:41]
  assign RRArbiter_3_io_in_0_bits = ~_T_19; // @[hbm_reader_double_fifo.scala 103:41]
  assign RRArbiter_3_io_in_1_valid = ~readData_vec_1_3_empty; // @[hbm_reader_double_fifo.scala 105:41]
  assign RRArbiter_3_io_in_1_bits = ~_T_22; // @[hbm_reader_double_fifo.scala 106:41]
  assign RRArbiter_3_io_out_ready = ~readData_vec_asy_3_full; // @[hbm_reader_double_fifo.scala 201:36]
  assign readData_offset_rst = reset; // @[hbm_reader_double_fifo.scala 234:35]
  assign readData_offset_wr_clk = clock; // @[hbm_reader_double_fifo.scala 235:35]
  assign readData_offset_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 236:35]
  assign readData_offset_din = io_HBM_interface_readData_bits_data[63:0]; // @[hbm_reader_double_fifo.scala 237:35]
  assign readData_offset_wr_en = _T_215 & _GEN_293; // @[hbm_reader_double_fifo.scala 238:35 hbm_reader_double_fifo.scala 425:50]
  assign readData_offset_rd_en = io_interface_to_pe_readData_offset_ready; // @[hbm_reader_double_fifo.scala 239:35]
  assign src_index_queue_asyn_rst = reset; // @[hbm_reader_double_fifo.scala 251:40]
  assign src_index_queue_asyn_wr_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 252:40]
  assign src_index_queue_asyn_rd_clk = clock; // @[hbm_reader_double_fifo.scala 253:40]
  assign src_index_queue_asyn_din = ~_T_87; // @[hbm_reader_double_fifo.scala 254:40]
  assign src_index_queue_asyn_wr_en = ~_T_89; // @[hbm_reader_double_fifo.scala 255:40]
  assign src_index_queue_asyn_rd_en = ~_T_91; // @[hbm_reader_double_fifo.scala 258:40]
  assign burst_cnt_rst = reset; // @[hbm_reader_double_fifo.scala 287:29]
  assign burst_cnt_wr_clk = clock; // @[hbm_reader_double_fifo.scala 288:29]
  assign burst_cnt_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 289:29]
  assign burst_cnt_din = {{1'd0}, _T_139}; // @[hbm_reader_double_fifo.scala 290:29]
  assign burst_cnt_wr_en = 1'h1; // @[hbm_reader_double_fifo.scala 291:29]
  assign burst_cnt_rd_en = 1'h1; // @[hbm_reader_double_fifo.scala 292:29]
  assign neighbour_cnt_rst = reset; // @[hbm_reader_double_fifo.scala 295:33]
  assign neighbour_cnt_wr_clk = clock; // @[hbm_reader_double_fifo.scala 296:33]
  assign neighbour_cnt_rd_clk = io_sysclock; // @[hbm_reader_double_fifo.scala 297:33]
  assign neighbour_cnt_din = {{1'd0}, _T_146}; // @[hbm_reader_double_fifo.scala 298:33]
  assign neighbour_cnt_wr_en = 1'h1; // @[hbm_reader_double_fifo.scala 299:33]
  assign neighbour_cnt_rd_en = 1'h1; // @[hbm_reader_double_fifo.scala 300:33]
  assign src_index_queue_l1_clock = clock;
  assign src_index_queue_l1_reset = reset;
  assign src_index_queue_l1_io_enq_valid = ~_T_99; // @[hbm_reader_double_fifo.scala 262:46]
  assign src_index_queue_l1_io_enq_bits = ~_T_93; // @[hbm_reader_double_fifo.scala 259:44]
  assign src_index_queue_l1_io_deq_ready = src_index_queue_l2_io_enq_ready; // @[hbm_reader_double_fifo.scala 264:31]
  assign src_index_queue_l2_clock = clock;
  assign src_index_queue_l2_reset = reset;
  assign src_index_queue_l2_io_enq_valid = src_index_queue_l1_io_deq_valid; // @[hbm_reader_double_fifo.scala 264:31]
  assign src_index_queue_l2_io_enq_bits = src_index_queue_l1_io_deq_bits; // @[hbm_reader_double_fifo.scala 264:31]
  assign src_index_queue_l2_io_deq_ready = src_index_queue_io_enq_ready; // @[hbm_reader_double_fifo.scala 265:31]
  assign src_index_queue_clock = clock;
  assign src_index_queue_reset = reset;
  assign src_index_queue_io_enq_valid = src_index_queue_l2_io_deq_valid; // @[hbm_reader_double_fifo.scala 265:31]
  assign src_index_queue_io_enq_bits = src_index_queue_l2_io_deq_bits; // @[hbm_reader_double_fifo.scala 265:31]
  assign src_index_queue_io_deq_ready = _T_150 & process_src_all; // @[hbm_reader_double_fifo.scala 318:34]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  count_burst_i0 = _RAND_1[30:0];
  _RAND_2 = {1{`RANDOM}};
  _T_110 = _RAND_2[30:0];
  _RAND_3 = {1{`RANDOM}};
  _T_118 = _RAND_3[30:0];
  _RAND_4 = {1{`RANDOM}};
  _T_126 = _RAND_4[30:0];
  _RAND_5 = {1{`RANDOM}};
  _T_134 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  _T_139 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  _T_146 = _RAND_7[30:0];
  _RAND_8 = {1{`RANDOM}};
  flag_readData_vec = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  valid_data_num = _RAND_9[7:0];
  _RAND_10 = {1{`RANDOM}};
  loc_flag_fifo_0 = _RAND_10[7:0];
  _RAND_11 = {1{`RANDOM}};
  loc_flag_fifo_1 = _RAND_11[7:0];
  _RAND_12 = {1{`RANDOM}};
  loc_flag_data_0 = _RAND_12[7:0];
  _RAND_13 = {1{`RANDOM}};
  loc_flag_data_1 = _RAND_13[7:0];
  _RAND_14 = {1{`RANDOM}};
  used = _RAND_14[7:0];
  _RAND_15 = {1{`RANDOM}};
  _T_225 = _RAND_15[7:0];
  _RAND_16 = {1{`RANDOM}};
  _T_238 = _RAND_16[7:0];
  _RAND_17 = {1{`RANDOM}};
  _T_255 = _RAND_17[7:0];
  _RAND_18 = {1{`RANDOM}};
  _T_268 = _RAND_18[7:0];
  _RAND_19 = {1{`RANDOM}};
  _T_285 = _RAND_19[7:0];
  _RAND_20 = {1{`RANDOM}};
  _T_298 = _RAND_20[7:0];
  _RAND_21 = {1{`RANDOM}};
  _T_315 = _RAND_21[7:0];
  _RAND_22 = {1{`RANDOM}};
  _T_328 = _RAND_22[7:0];
  _RAND_23 = {1{`RANDOM}};
  _T_359 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_372 = _RAND_24[7:0];
  _RAND_25 = {1{`RANDOM}};
  _T_389 = _RAND_25[7:0];
  _RAND_26 = {1{`RANDOM}};
  _T_402 = _RAND_26[7:0];
  _RAND_27 = {1{`RANDOM}};
  _T_419 = _RAND_27[7:0];
  _RAND_28 = {1{`RANDOM}};
  _T_432 = _RAND_28[7:0];
  _RAND_29 = {1{`RANDOM}};
  _T_449 = _RAND_29[7:0];
  _RAND_30 = {1{`RANDOM}};
  _T_462 = _RAND_30[7:0];
  _RAND_31 = {1{`RANDOM}};
  _T_491 = _RAND_31[7:0];
  _RAND_32 = {1{`RANDOM}};
  _T_504 = _RAND_32[7:0];
  _RAND_33 = {1{`RANDOM}};
  _T_521 = _RAND_33[7:0];
  _RAND_34 = {1{`RANDOM}};
  _T_534 = _RAND_34[7:0];
  _RAND_35 = {1{`RANDOM}};
  _T_551 = _RAND_35[7:0];
  _RAND_36 = {1{`RANDOM}};
  _T_564 = _RAND_36[7:0];
  _RAND_37 = {1{`RANDOM}};
  _T_581 = _RAND_37[7:0];
  _RAND_38 = {1{`RANDOM}};
  _T_594 = _RAND_38[7:0];
  _RAND_39 = {1{`RANDOM}};
  _T_622 = _RAND_39[7:0];
  _RAND_40 = {1{`RANDOM}};
  _T_635 = _RAND_40[7:0];
  _RAND_41 = {1{`RANDOM}};
  _T_652 = _RAND_41[7:0];
  _RAND_42 = {1{`RANDOM}};
  _T_665 = _RAND_42[7:0];
  _RAND_43 = {1{`RANDOM}};
  _T_682 = _RAND_43[7:0];
  _RAND_44 = {1{`RANDOM}};
  _T_695 = _RAND_44[7:0];
  _RAND_45 = {1{`RANDOM}};
  _T_712 = _RAND_45[7:0];
  _RAND_46 = {1{`RANDOM}};
  _T_725 = _RAND_46[7:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 1'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_358) begin
          if (_T_484) begin
            stateReg <= 1'h0;
          end else begin
            stateReg <= _GEN_270;
          end
        end else if (_T_224) begin
          if (_T_484) begin
            stateReg <= 1'h0;
          end else begin
            stateReg <= _GEN_132;
          end
        end
      end
    end else if (stateReg) begin
      if (_T_621) begin
        if (_T_747) begin
          stateReg <= 1'h0;
        end else begin
          stateReg <= _GEN_569;
        end
      end else if (_T_490) begin
        if (_T_747) begin
          stateReg <= 1'h0;
        end else begin
          stateReg <= _GEN_433;
        end
      end
    end
    if (reset) begin
      count_burst_i0 <= 31'h0;
    end else if (_T_103) begin
      if (_T_104) begin
        count_burst_i0 <= 31'h0;
      end else begin
        count_burst_i0 <= _T_106;
      end
    end
    if (reset) begin
      _T_110 <= 31'h0;
    end else if (_T_108) begin
      if (_T_112) begin
        _T_110 <= 31'h0;
      end else begin
        _T_110 <= _T_114;
      end
    end
    if (reset) begin
      _T_118 <= 31'h0;
    end else if (_T_116) begin
      if (_T_120) begin
        _T_118 <= 31'h0;
      end else begin
        _T_118 <= _T_122;
      end
    end
    if (reset) begin
      _T_126 <= 31'h0;
    end else if (_T_124) begin
      if (_T_128) begin
        _T_126 <= 31'h0;
      end else begin
        _T_126 <= _T_130;
      end
    end
    if (reset) begin
      _T_134 <= 31'h0;
    end else if (_T_132) begin
      if (_T_136) begin
        _T_134 <= 31'h0;
      end else begin
        _T_134 <= _T_138;
      end
    end
    _T_139 <= count_burst_i0;
    _T_146 <= _T_143 + _T_134;
    if (reset) begin
      flag_readData_vec <= 1'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_358) begin
          if (_T_484) begin
            flag_readData_vec <= 1'h0;
          end else if (_T_224) begin
            flag_readData_vec <= _GEN_137;
          end
        end else if (_T_224) begin
          flag_readData_vec <= _GEN_137;
        end
      end
    end else if (stateReg) begin
      if (_T_621) begin
        if (_T_747) begin
          flag_readData_vec <= 1'h0;
        end else if (_T_490) begin
          flag_readData_vec <= _GEN_437;
        end
      end else if (_T_490) begin
        flag_readData_vec <= _GEN_437;
      end
    end
    if (reset) begin
      valid_data_num <= 8'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_358) begin
          if (_T_479) begin
            valid_data_num <= _T_347;
          end else if (_T_224) begin
            if (_T_479) begin
              valid_data_num <= _T_347;
            end
          end
        end else if (_T_224) begin
          if (_T_479) begin
            valid_data_num <= _T_347;
          end
        end
      end
    end else if (stateReg) begin
      if (_T_621) begin
        if (_T_742) begin
          valid_data_num <= _T_613;
        end else if (_T_490) begin
          if (_T_742) begin
            valid_data_num <= _T_613;
          end
        end
      end else if (_T_490) begin
        if (_T_742) begin
          valid_data_num <= _T_613;
        end
      end
    end
    if (reset) begin
      loc_flag_fifo_0 <= 8'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_224) begin
          if (_T_484) begin
            loc_flag_fifo_0 <= {{5'd0}, _T_353};
          end
        end
      end
    end else if (stateReg) begin
      if (_T_490) begin
        if (_T_747) begin
          loc_flag_fifo_0 <= {{5'd0}, _T_619};
        end
      end
    end
    if (reset) begin
      loc_flag_fifo_1 <= 8'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_358) begin
          if (_T_484) begin
            loc_flag_fifo_1 <= {{5'd0}, _T_487};
          end
        end
      end
    end else if (stateReg) begin
      if (_T_621) begin
        if (_T_747) begin
          loc_flag_fifo_1 <= {{5'd0}, _T_750};
        end
      end
    end
    if (reset) begin
      loc_flag_data_0 <= 8'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_224) begin
          if (_T_484) begin
            loc_flag_data_0 <= 8'h0;
          end else if (_T_479) begin
            loc_flag_data_0 <= _T_349;
          end
        end
      end
    end else if (stateReg) begin
      if (_T_490) begin
        if (_T_747) begin
          loc_flag_data_0 <= 8'h0;
        end else if (_T_742) begin
          loc_flag_data_0 <= _T_349;
        end
      end
    end
    if (reset) begin
      loc_flag_data_1 <= 8'h0;
    end else if (_T_215) begin
      if (io_HBM_interface_readData_valid) begin
        if (_T_358) begin
          if (_T_484) begin
            loc_flag_data_1 <= 8'h0;
          end else if (_T_479) begin
            loc_flag_data_1 <= _T_483;
          end
        end
      end
    end else if (stateReg) begin
      if (_T_621) begin
        if (_T_747) begin
          loc_flag_data_1 <= 8'h0;
        end else if (_T_742) begin
          loc_flag_data_1 <= _T_483;
        end
      end
    end
    used <= 8'h0;
    _T_225 <= loc_flag_fifo_0;
    _T_238 <= loc_flag_fifo_0;
    _T_255 <= loc_flag_fifo_0;
    _T_268 <= loc_flag_fifo_0;
    _T_285 <= loc_flag_fifo_0;
    _T_298 <= loc_flag_fifo_0;
    _T_315 <= loc_flag_fifo_0;
    _T_328 <= loc_flag_fifo_0;
    _T_359 <= loc_flag_fifo_1;
    _T_372 <= loc_flag_fifo_1;
    _T_389 <= loc_flag_fifo_1;
    _T_402 <= loc_flag_fifo_1;
    _T_419 <= loc_flag_fifo_1;
    _T_432 <= loc_flag_fifo_1;
    _T_449 <= loc_flag_fifo_1;
    _T_462 <= loc_flag_fifo_1;
    _T_491 <= loc_flag_fifo_0;
    _T_504 <= loc_flag_fifo_0;
    _T_521 <= loc_flag_fifo_0;
    _T_534 <= loc_flag_fifo_0;
    _T_551 <= loc_flag_fifo_0;
    _T_564 <= loc_flag_fifo_0;
    _T_581 <= loc_flag_fifo_0;
    _T_594 <= loc_flag_fifo_0;
    _T_622 <= loc_flag_fifo_1;
    _T_635 <= loc_flag_fifo_1;
    _T_652 <= loc_flag_fifo_1;
    _T_665 <= loc_flag_fifo_1;
    _T_682 <= loc_flag_fifo_1;
    _T_695 <= loc_flag_fifo_1;
    _T_712 <= loc_flag_fifo_1;
    _T_725 <= loc_flag_fifo_1;
  end
endmodule
module Queue_3(
  input        clock,
  input        reset,
  output       io_enq_ready,
  input        io_enq_valid,
  input  [7:0] io_enq_bits,
  input        io_deq_ready,
  output       io_deq_valid,
  output [7:0] io_deq_bits,
  output [4:0] io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [7:0] ram [0:15]; // @[Decoupled.scala 218:16]
  wire [7:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [7:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [3:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [3:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_4 = enq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_5 = enq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [3:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [7:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [3:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_6 = deq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_7 = deq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire  _T_2 = io_deq_valid;
  wire [3:0] _GEN_6 = io_deq_valid ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != io_deq_valid; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [4:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [3:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [4:0] _T_14 = _T_13 ? 5'h10 : 5'h0; // @[Decoupled.scala 259:20]
  wire [4:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [4:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [4:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 16; initvar = initvar+1)
    ram[initvar] = _RAND_0[7:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[3:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[3:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 4'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 4'h0;
    end else if (io_deq_valid) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_4(
  input        clock,
  input        reset,
  output       io_enq_ready,
  input        io_enq_valid,
  input  [7:0] io_enq_bits,
  input        io_deq_ready,
  output       io_deq_valid,
  output [7:0] io_deq_bits,
  output [1:0] io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [7:0] ram [0:1]; // @[Decoupled.scala 218:16]
  wire [7:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire  ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [7:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire  ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg  enq_ptr_value; // @[Counter.scala 29:33]
  reg  deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_4 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_5 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire  _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [7:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_6 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_7 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire  _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_14 = _T_13 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram[initvar] = _RAND_0[7:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 1'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 1'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Memory_write(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [29:0] _T_45 = 29'h10000000 * 29'h0; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [29:0] _T_51 = 29'h10000000 * 29'h0; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{11'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{11'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{11'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Arbiter(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [31:0] io_in_0_bits_index,
  input  [7:0]  io_in_0_bits_burst_len,
  input  [1:0]  io_in_0_bits_id,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [31:0] io_in_1_bits_index,
  input  [7:0]  io_in_1_bits_burst_len,
  input  [1:0]  io_in_1_bits_id,
  input         io_out_ready,
  output        io_out_valid,
  output [31:0] io_out_bits_index,
  output [7:0]  io_out_bits_burst_len,
  output [1:0]  io_out_bits_id,
  output        io_chosen
);
  wire  _GEN_0 = io_in_0_valid ? 1'h0 : 1'h1; // @[Arbiter.scala 126:27]
  wire [1:0] _GEN_1 = io_in_0_valid ? 2'h1 : 2'h0; // @[Arbiter.scala 126:27]
  wire [7:0] _GEN_2 = io_in_0_valid ? io_in_0_bits_burst_len : 8'h0; // @[Arbiter.scala 126:27]
  wire [31:0] _GEN_3 = io_in_0_valid ? io_in_0_bits_index : io_in_1_bits_index; // @[Arbiter.scala 126:27]
  wire  grant_1 = ~io_in_0_valid; // @[Arbiter.scala 31:78]
  wire  _T = io_out_ready; // @[Arbiter.scala 134:19]
  wire  _T_1 = grant_1 & io_out_ready; // @[Arbiter.scala 134:19]
  wire  _T_2 = ~grant_1; // @[Arbiter.scala 135:19]
  wire  _T_3 = _T_2 | io_in_1_valid; // @[Arbiter.scala 135:31]
  assign io_in_0_ready = io_out_ready; // @[Arbiter.scala 134:14]
  assign io_in_1_ready = grant_1 & io_out_ready; // @[Arbiter.scala 134:14]
  assign io_out_valid = _T_2 | io_in_1_valid; // @[Arbiter.scala 135:16]
  assign io_out_bits_index = io_in_0_valid ? io_in_0_bits_index : io_in_1_bits_index; // @[Arbiter.scala 124:15 Arbiter.scala 128:19]
  assign io_out_bits_burst_len = io_in_0_valid ? io_in_0_bits_burst_len : 8'h0; // @[Arbiter.scala 124:15 Arbiter.scala 128:19]
  assign io_out_bits_id = io_in_0_valid ? 2'h1 : 2'h0; // @[Arbiter.scala 124:15 Arbiter.scala 128:19]
  assign io_chosen = io_in_0_valid ? 1'h0 : 1'h1; // @[Arbiter.scala 123:13 Arbiter.scala 127:17]
endmodule
module Queue_8(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [4:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:15]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [3:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [3:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_4 = enq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_5 = enq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [3:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [3:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_6 = deq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_7 = deq_ptr_value + 4'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [3:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [4:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [3:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [4:0] _T_14 = _T_13 ? 5'h10 : 5'h0; // @[Decoupled.scala 259:20]
  wire [4:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [4:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [4:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 16; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[3:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[3:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 4'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 4'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_10(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [63:0] io_enq_bits_data,
  input         io_deq_ready,
  output        io_deq_valid,
  output [63:0] io_deq_bits_data,
  output [1:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [63:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [63:0] ram_data [0:1]; // @[Decoupled.scala 218:16]
  wire [63:0] ram_data__T_11_data; // @[Decoupled.scala 218:16]
  wire  ram_data__T_11_addr; // @[Decoupled.scala 218:16]
  wire [63:0] ram_data__T_3_data; // @[Decoupled.scala 218:16]
  wire  ram_data__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram_data__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram_data__T_3_en; // @[Decoupled.scala 218:16]
  reg  enq_ptr_value; // @[Counter.scala 29:33]
  reg  deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_4 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_5 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire  _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [63:0] _GEN_4 = io_enq_bits_data; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_6 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_7 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire  _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_14 = _T_13 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram_data__T_11_addr = deq_ptr_value;
  assign ram_data__T_11_data = ram_data[ram_data__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram_data__T_3_data = io_enq_bits_data;
  assign ram_data__T_3_addr = enq_ptr_value;
  assign ram_data__T_3_mask = 1'h1;
  assign ram_data__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits_data = ram_data__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {2{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram_data[initvar] = _RAND_0[63:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram_data__T_3_en & ram_data__T_3_mask) begin
      ram_data[ram_data__T_3_addr] <= ram_data__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 1'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 1'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_12(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [63:0] io_enq_bits_data,
  input         io_deq_ready,
  output        io_deq_valid,
  output [63:0] io_deq_bits_data,
  output [6:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [63:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [63:0] ram_data [0:63]; // @[Decoupled.scala 218:16]
  wire [63:0] ram_data__T_11_data; // @[Decoupled.scala 218:16]
  wire [5:0] ram_data__T_11_addr; // @[Decoupled.scala 218:16]
  wire [63:0] ram_data__T_3_data; // @[Decoupled.scala 218:16]
  wire [5:0] ram_data__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram_data__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram_data__T_3_en; // @[Decoupled.scala 218:16]
  reg [5:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [5:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 6'h3f; // @[Counter.scala 38:24]
  wire [6:0] _T_4 = enq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire [5:0] _T_5 = enq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [5:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [63:0] _GEN_4 = io_enq_bits_data; // @[Decoupled.scala 229:17]
  wire [5:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 6'h3f; // @[Counter.scala 38:24]
  wire [6:0] _T_6 = deq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire [5:0] _T_7 = deq_ptr_value + 6'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [5:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [6:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [5:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [6:0] _T_14 = _T_13 ? 7'h40 : 7'h0; // @[Decoupled.scala 259:20]
  wire [6:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [6:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [6:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram_data__T_11_addr = deq_ptr_value;
  assign ram_data__T_11_data = ram_data[ram_data__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram_data__T_3_data = io_enq_bits_data;
  assign ram_data__T_3_addr = enq_ptr_value;
  assign ram_data__T_3_mask = 1'h1;
  assign ram_data__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits_data = ram_data__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {2{`RANDOM}};
  for (initvar = 0; initvar < 64; initvar = initvar+1)
    ram_data[initvar] = _RAND_0[63:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[5:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[5:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram_data__T_3_en & ram_data__T_3_mask) begin
      ram_data[ram_data__T_3_addr] <= ram_data__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 6'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 6'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Read_neighbour(
  input         clock,
  input         reset,
  output        io_readData_ready,
  input         io_readData_valid,
  input  [63:0] io_readData_bits_data,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  input         io_push_or_pull_state,
  input         io_to_arbiter_ready,
  output        io_to_arbiter_valid,
  output [31:0] io_to_arbiter_bits_index,
  output [7:0]  io_to_arbiter_bits_burst_len,
  output [5:0]  io_to_arbiter_bits_id,
  output [31:0] io_count_val_n0,
  output        io_queue_ready,
  output        io_queue_valid,
  output        io_src_q0_deq_ready,
  input         io_src_q0_deq_valid,
  input  [31:0] io_src_q0_deq_bits,
  input         io_src_q1_enq_ready,
  output        io_src_q1_enq_valid,
  output [31:0] io_src_q1_enq_bits
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
`endif // RANDOMIZE_REG_INIT
  wire  queue_readData_l1_clock; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l1_reset; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l1_io_enq_ready; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l1_io_enq_valid; // @[Decoupled_Mem.scala 96:35]
  wire [63:0] queue_readData_l1_io_enq_bits_data; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l1_io_deq_ready; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l1_io_deq_valid; // @[Decoupled_Mem.scala 96:35]
  wire [63:0] queue_readData_l1_io_deq_bits_data; // @[Decoupled_Mem.scala 96:35]
  wire [1:0] queue_readData_l1_io_count; // @[Decoupled_Mem.scala 96:35]
  wire  queue_readData_l2_clock; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_l2_reset; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_l2_io_enq_ready; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_l2_io_enq_valid; // @[Decoupled_Mem.scala 97:35]
  wire [63:0] queue_readData_l2_io_enq_bits_data; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_l2_io_deq_ready; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_l2_io_deq_valid; // @[Decoupled_Mem.scala 97:35]
  wire [63:0] queue_readData_l2_io_deq_bits_data; // @[Decoupled_Mem.scala 97:35]
  wire [1:0] queue_readData_l2_io_count; // @[Decoupled_Mem.scala 97:35]
  wire  queue_readData_clock; // @[Decoupled_Mem.scala 98:32]
  wire  queue_readData_reset; // @[Decoupled_Mem.scala 98:32]
  wire  queue_readData_io_enq_ready; // @[Decoupled_Mem.scala 98:32]
  wire  queue_readData_io_enq_valid; // @[Decoupled_Mem.scala 98:32]
  wire [63:0] queue_readData_io_enq_bits_data; // @[Decoupled_Mem.scala 98:32]
  wire  queue_readData_io_deq_ready; // @[Decoupled_Mem.scala 98:32]
  wire  queue_readData_io_deq_valid; // @[Decoupled_Mem.scala 98:32]
  wire [63:0] queue_readData_io_deq_bits_data; // @[Decoupled_Mem.scala 98:32]
  wire [6:0] queue_readData_io_count; // @[Decoupled_Mem.scala 98:32]
  reg  state; // @[Decoupled_Mem.scala 92:24]
  reg [31:0] neighbour_count; // @[Decoupled_Mem.scala 93:34]
  reg [31:0] temp_index; // @[Decoupled_Mem.scala 94:29]
  reg [31:0] burst_sum; // @[Decoupled_Mem.scala 99:28]
  wire [31:0] C_offset = io_push_or_pull_state ? io_offsets_CSC_C_offset : io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 103:23]
  reg  _T; // @[Decoupled_Mem.scala 126:30]
  reg  _T_1; // @[Decoupled_Mem.scala 127:30]
  wire [63:0] _T_2 = queue_readData_io_deq_bits_data;
  wire [31:0] unpacked_readData_0 = _T_2[31:0]; // @[Decoupled_Mem.scala 128:69]
  wire [31:0] unpacked_readData_1 = _T_2[63:32]; // @[Decoupled_Mem.scala 128:69]
  wire [31:0] _T_4 = unpacked_readData_1; // @[Decoupled_Mem.scala 128:69 Decoupled_Mem.scala 128:69]
  wire [32:0] _T_5 = unpacked_readData_1 + C_offset; // @[Decoupled_Mem.scala 137:42]
  wire [31:0] start_loc = unpacked_readData_1 + C_offset; // @[Decoupled_Mem.scala 137:42]
  wire [37:0] start_addr = start_loc * 32'h20; // @[Decoupled_Mem.scala 138:32]
  wire [32:0] _T_6 = temp_index + C_offset; // @[Decoupled_Mem.scala 140:37]
  wire [31:0] start_loc_loop = temp_index + C_offset; // @[Decoupled_Mem.scala 140:37]
  wire [37:0] start_addr_loop = start_loc_loop * 32'h20; // @[Decoupled_Mem.scala 141:42]
  wire  _T_7 = ~state; // @[Conditional.scala 37:30]
  wire  _T_8 = io_to_arbiter_ready & queue_readData_io_deq_valid; // @[Decoupled_Mem.scala 148:38]
  wire  _T_9 = _T_8 & io_src_q0_deq_valid; // @[Decoupled_Mem.scala 148:69]
  wire  _T_10 = _T_9 & io_src_q1_enq_ready; // @[Decoupled_Mem.scala 148:92]
  wire [31:0] _T_3 = unpacked_readData_0; // @[Decoupled_Mem.scala 128:69 Decoupled_Mem.scala 128:69]
  wire  _T_11 = unpacked_readData_0 > 32'h100; // @[Decoupled_Mem.scala 150:43]
  wire  _T_12 = start_addr[12]; // @[Decoupled_Mem.scala 153:36]
  wire [38:0] _T_13 = start_addr + 38'h1fff; // @[Decoupled_Mem.scala 153:57]
  wire [37:0] _T_14 = start_addr + 38'h1fff; // @[Decoupled_Mem.scala 153:57]
  wire  _T_15 = _T_14[12]; // @[Decoupled_Mem.scala 153:84]
  wire  _T_16 = start_addr[12] != _T_14[12]; // @[Decoupled_Mem.scala 153:41]
  wire [11:0] _T_17 = start_addr[11:0]; // @[Decoupled_Mem.scala 156:72]
  wire [12:0] _GEN_108 = {{1'd0}, start_addr[11:0]}; // @[Decoupled_Mem.scala 156:60]
  wire [13:0] _T_18 = 13'h1000 - _GEN_108; // @[Decoupled_Mem.scala 156:60]
  wire [12:0] _T_19 = 13'h1000 - _GEN_108; // @[Decoupled_Mem.scala 156:60]
  wire [7:0] _GEN_109 = _T_19[12:5]; // @[Decoupled_Mem.scala 156:80]
  wire [12:0] _T_20 = {{5'd0}, _T_19[12:5]}; // @[Decoupled_Mem.scala 156:80]
  wire [12:0] _GEN_0 = _T_20; // @[Decoupled_Mem.scala 153:89]
  wire  _T_35 = unpacked_readData_0 != 32'h0; // @[Decoupled_Mem.scala 181:49]
  wire  _T_36 = start_addr[12]; // @[Decoupled_Mem.scala 184:36]
  wire [37:0] _T_37 = unpacked_readData_0 * 32'h20; // @[Decoupled_Mem.scala 184:81]
  wire [38:0] _T_38 = start_addr + _T_37; // @[Decoupled_Mem.scala 184:57]
  wire [37:0] _T_39 = start_addr + _T_37; // @[Decoupled_Mem.scala 184:57]
  wire [38:0] _T_40 = _T_39 - 38'h1; // @[Decoupled_Mem.scala 184:122]
  wire [37:0] _T_41 = _T_39 - 38'h1; // @[Decoupled_Mem.scala 184:122]
  wire  _T_42 = _T_41[12]; // @[Decoupled_Mem.scala 184:127]
  wire  _T_43 = start_addr[12] != _T_41[12]; // @[Decoupled_Mem.scala 184:41]
  wire [11:0] _T_44 = start_addr[11:0]; // @[Decoupled_Mem.scala 187:72]
  wire [12:0] _GEN_110 = {{1'd0}, start_addr[11:0]}; // @[Decoupled_Mem.scala 187:60]
  wire [13:0] _T_45 = 13'h1000 - _GEN_108; // @[Decoupled_Mem.scala 187:60]
  wire [12:0] _T_46 = 13'h1000 - _GEN_108; // @[Decoupled_Mem.scala 187:60]
  wire [7:0] _GEN_111 = _T_19[12:5]; // @[Decoupled_Mem.scala 187:80]
  wire [12:0] _T_47 = {{5'd0}, _T_19[12:5]}; // @[Decoupled_Mem.scala 187:80]
  wire [12:0] _GEN_9 = _T_20; // @[Decoupled_Mem.scala 184:132]
  wire [12:0] _GEN_19 = _T_20; // @[Decoupled_Mem.scala 181:57]
  wire [12:0] _GEN_29 = _T_11 ? _T_20 : _T_20; // @[Decoupled_Mem.scala 150:51]
  wire [12:0] _GEN_39 = _GEN_29; // @[Decoupled_Mem.scala 148:115]
  wire  _T_60 = state; // @[Conditional.scala 37:30]
  wire  _T_61 = io_to_arbiter_ready & io_src_q0_deq_valid; // @[Decoupled_Mem.scala 219:38]
  wire  _T_62 = _T_61 & io_src_q1_enq_ready; // @[Decoupled_Mem.scala 219:61]
  wire  _T_63 = neighbour_count > 32'h100; // @[Decoupled_Mem.scala 220:38]
  wire  _T_64 = start_addr_loop[12]; // @[Decoupled_Mem.scala 222:41]
  wire [38:0] _T_65 = start_addr_loop + 38'h2000; // @[Decoupled_Mem.scala 222:67]
  wire [37:0] _T_66 = start_addr_loop + 38'h2000; // @[Decoupled_Mem.scala 222:67]
  wire [38:0] _T_67 = _T_66 - 38'h1; // @[Decoupled_Mem.scala 222:113]
  wire [37:0] _T_68 = _T_66 - 38'h1; // @[Decoupled_Mem.scala 222:113]
  wire  _T_69 = _T_68[12]; // @[Decoupled_Mem.scala 222:118]
  wire  _T_70 = start_addr_loop[12] != _T_68[12]; // @[Decoupled_Mem.scala 222:46]
  wire [11:0] _T_71 = start_addr_loop[11:0]; // @[Decoupled_Mem.scala 225:77]
  wire [12:0] _GEN_112 = {{1'd0}, start_addr_loop[11:0]}; // @[Decoupled_Mem.scala 225:60]
  wire [13:0] _T_72 = 13'h1000 - _GEN_112; // @[Decoupled_Mem.scala 225:60]
  wire [12:0] _T_73 = 13'h1000 - _GEN_112; // @[Decoupled_Mem.scala 225:60]
  wire [7:0] _GEN_113 = _T_73[12:5]; // @[Decoupled_Mem.scala 225:85]
  wire [12:0] _T_74 = {{5'd0}, _T_73[12:5]}; // @[Decoupled_Mem.scala 225:85]
  wire [12:0] _GEN_49 = _T_74; // @[Decoupled_Mem.scala 222:123]
  wire  _T_89 = start_addr_loop[12]; // @[Decoupled_Mem.scala 251:41]
  wire [37:0] _T_90 = neighbour_count * 32'h20; // @[Decoupled_Mem.scala 251:84]
  wire [38:0] _T_91 = start_addr_loop + _T_90; // @[Decoupled_Mem.scala 251:66]
  wire [37:0] _T_92 = start_addr_loop + _T_90; // @[Decoupled_Mem.scala 251:66]
  wire [38:0] _T_93 = _T_92 - 38'h1; // @[Decoupled_Mem.scala 251:125]
  wire [37:0] _T_94 = _T_92 - 38'h1; // @[Decoupled_Mem.scala 251:125]
  wire  _T_95 = _T_94[12]; // @[Decoupled_Mem.scala 251:130]
  wire  _T_96 = start_addr_loop[12] != _T_94[12]; // @[Decoupled_Mem.scala 251:46]
  wire [11:0] _T_97 = start_addr_loop[11:0]; // @[Decoupled_Mem.scala 254:77]
  wire [12:0] _GEN_114 = {{1'd0}, start_addr_loop[11:0]}; // @[Decoupled_Mem.scala 254:60]
  wire [13:0] _T_98 = 13'h1000 - _GEN_112; // @[Decoupled_Mem.scala 254:60]
  wire [12:0] _T_99 = 13'h1000 - _GEN_112; // @[Decoupled_Mem.scala 254:60]
  wire [7:0] _GEN_115 = _T_73[12:5]; // @[Decoupled_Mem.scala 254:85]
  wire [12:0] _T_100 = {{5'd0}, _T_73[12:5]}; // @[Decoupled_Mem.scala 254:85]
  wire [12:0] _GEN_58 = _T_74; // @[Decoupled_Mem.scala 251:135]
  wire [12:0] _GEN_68 = _T_63 ? _T_74 : _T_74; // @[Decoupled_Mem.scala 220:46]
  wire [12:0] _GEN_78 = _GEN_68; // @[Decoupled_Mem.scala 219:84]
  wire [12:0] _GEN_88 = _GEN_68; // @[Conditional.scala 39:67]
  wire [12:0] _GEN_98 = _T_7 ? _GEN_29 : _GEN_68; // @[Conditional.scala 40:58]
  wire [31:0] before_4k_bound_count = {{19'd0}, _GEN_98}; // @[Decoupled_Mem.scala 101:37 Decoupled_Mem.scala 156:47 Decoupled_Mem.scala 187:47 Decoupled_Mem.scala 225:47 Decoupled_Mem.scala 254:47]
  wire [32:0] _T_21 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 159:79]
  wire [31:0] _T_22 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 159:79]
  wire [32:0] _T_23 = unpacked_readData_0 - before_4k_bound_count; // @[Decoupled_Mem.scala 160:65]
  wire [31:0] _T_24 = unpacked_readData_0 - before_4k_bound_count; // @[Decoupled_Mem.scala 160:65]
  wire [32:0] _T_25 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 161:48]
  wire [31:0] _T_26 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 161:48]
  wire [32:0] _T_27 = unpacked_readData_1 + before_4k_bound_count; // @[Decoupled_Mem.scala 162:60]
  wire [31:0] _T_28 = unpacked_readData_1 + before_4k_bound_count; // @[Decoupled_Mem.scala 162:60]
  wire [32:0] _T_29 = unpacked_readData_0 - 32'h100; // @[Decoupled_Mem.scala 172:65]
  wire [31:0] _T_30 = unpacked_readData_0 - 32'h100; // @[Decoupled_Mem.scala 172:65]
  wire [32:0] _T_31 = burst_sum + 32'h100; // @[Decoupled_Mem.scala 173:48]
  wire [31:0] _T_32 = burst_sum + 32'h100; // @[Decoupled_Mem.scala 173:48]
  wire [32:0] _T_33 = unpacked_readData_1 + 32'h100; // @[Decoupled_Mem.scala 174:60]
  wire [31:0] _T_34 = unpacked_readData_1 + 32'h100; // @[Decoupled_Mem.scala 174:60]
  wire [5:0] _GEN_1 = 6'h1; // @[Decoupled_Mem.scala 153:89]
  wire [31:0] _GEN_2 = start_loc; // @[Decoupled_Mem.scala 153:89]
  wire [31:0] _GEN_3 = _T_16 ? _T_22 : 32'hff; // @[Decoupled_Mem.scala 153:89]
  wire [31:0] _GEN_4 = _T_16 ? _T_24 : _T_30; // @[Decoupled_Mem.scala 153:89]
  wire [31:0] _GEN_5 = _T_16 ? _T_26 : _T_32; // @[Decoupled_Mem.scala 153:89]
  wire [31:0] _GEN_6 = _T_16 ? _T_28 : _T_34; // @[Decoupled_Mem.scala 153:89]
  wire  _GEN_7 = 1'h0; // @[Decoupled_Mem.scala 153:89]
  wire  _GEN_8 = 1'h1; // @[Decoupled_Mem.scala 153:89]
  wire [32:0] _T_48 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 190:79]
  wire [31:0] _T_49 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 190:79]
  wire [32:0] _T_50 = unpacked_readData_0 - before_4k_bound_count; // @[Decoupled_Mem.scala 191:65]
  wire [31:0] _T_51 = unpacked_readData_0 - before_4k_bound_count; // @[Decoupled_Mem.scala 191:65]
  wire [32:0] _T_52 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 192:48]
  wire [31:0] _T_53 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 192:48]
  wire [32:0] _T_54 = unpacked_readData_1 + before_4k_bound_count; // @[Decoupled_Mem.scala 193:60]
  wire [31:0] _T_55 = unpacked_readData_1 + before_4k_bound_count; // @[Decoupled_Mem.scala 193:60]
  wire [32:0] _T_56 = unpacked_readData_0 - 32'h1; // @[Decoupled_Mem.scala 201:78]
  wire [31:0] _T_57 = unpacked_readData_0 - 32'h1; // @[Decoupled_Mem.scala 201:78]
  wire [32:0] _T_58 = burst_sum + unpacked_readData_0; // @[Decoupled_Mem.scala 203:48]
  wire [31:0] _T_59 = burst_sum + unpacked_readData_0; // @[Decoupled_Mem.scala 203:48]
  wire [5:0] _GEN_10 = 6'h1; // @[Decoupled_Mem.scala 184:132]
  wire [31:0] _GEN_11 = start_loc; // @[Decoupled_Mem.scala 184:132]
  wire [31:0] _GEN_12 = _T_43 ? _T_22 : _T_57; // @[Decoupled_Mem.scala 184:132]
  wire [31:0] _GEN_13 = _T_43 ? _T_24 : neighbour_count; // @[Decoupled_Mem.scala 184:132]
  wire [31:0] _GEN_14 = _T_43 ? _T_26 : _T_59; // @[Decoupled_Mem.scala 184:132]
  wire [31:0] _GEN_15 = _T_43 ? _T_28 : temp_index; // @[Decoupled_Mem.scala 184:132]
  wire  _GEN_16 = _T_43 ? 1'h0 : 1'h1; // @[Decoupled_Mem.scala 184:132]
  wire  _GEN_17 = 1'h1; // @[Decoupled_Mem.scala 184:132]
  wire  _GEN_18 = _T_43 | state; // @[Decoupled_Mem.scala 184:132]
  wire [5:0] _GEN_20 = 6'h1; // @[Decoupled_Mem.scala 181:57]
  wire [31:0] _GEN_21 = start_loc; // @[Decoupled_Mem.scala 181:57]
  wire [31:0] _GEN_22 = _GEN_12; // @[Decoupled_Mem.scala 181:57]
  wire [31:0] _GEN_23 = _T_35 ? _GEN_13 : neighbour_count; // @[Decoupled_Mem.scala 181:57]
  wire [31:0] _GEN_24 = _T_35 ? _GEN_14 : burst_sum; // @[Decoupled_Mem.scala 181:57]
  wire [31:0] _GEN_25 = _T_35 ? _GEN_15 : temp_index; // @[Decoupled_Mem.scala 181:57]
  wire  _GEN_26 = _T_35 ? _GEN_16 : 1'h1; // @[Decoupled_Mem.scala 181:57]
  wire  _GEN_27 = _T_35; // @[Decoupled_Mem.scala 181:57]
  wire  _GEN_28 = _T_35 ? _GEN_18 : state; // @[Decoupled_Mem.scala 181:57]
  wire [5:0] _GEN_30 = 6'h1; // @[Decoupled_Mem.scala 150:51]
  wire [31:0] _GEN_31 = start_loc; // @[Decoupled_Mem.scala 150:51]
  wire [31:0] _GEN_32 = _T_11 ? _GEN_3 : _GEN_12; // @[Decoupled_Mem.scala 150:51]
  wire [31:0] _GEN_33 = _T_11 ? _GEN_4 : _GEN_23; // @[Decoupled_Mem.scala 150:51]
  wire [31:0] _GEN_34 = _T_11 ? _GEN_5 : _GEN_24; // @[Decoupled_Mem.scala 150:51]
  wire [31:0] _GEN_35 = _T_11 ? _GEN_6 : _GEN_25; // @[Decoupled_Mem.scala 150:51]
  wire  _GEN_36 = _T_11 ? 1'h0 : _GEN_26; // @[Decoupled_Mem.scala 150:51]
  wire  _GEN_37 = _T_11 | _T_35; // @[Decoupled_Mem.scala 150:51]
  wire  _GEN_38 = _T_11 | _GEN_28; // @[Decoupled_Mem.scala 150:51]
  wire [5:0] _GEN_40 = 6'h1; // @[Decoupled_Mem.scala 148:115]
  wire [31:0] _GEN_41 = start_loc; // @[Decoupled_Mem.scala 148:115]
  wire [31:0] _GEN_42 = _GEN_32; // @[Decoupled_Mem.scala 148:115]
  wire [31:0] _GEN_43 = _T_10 ? _GEN_33 : neighbour_count; // @[Decoupled_Mem.scala 148:115]
  wire [31:0] _GEN_44 = _T_10 ? _GEN_34 : burst_sum; // @[Decoupled_Mem.scala 148:115]
  wire [31:0] _GEN_45 = _T_10 ? _GEN_35 : temp_index; // @[Decoupled_Mem.scala 148:115]
  wire  _GEN_46 = _T_10 & _GEN_36; // @[Decoupled_Mem.scala 148:115]
  wire  _GEN_47 = _T_10 & _GEN_37; // @[Decoupled_Mem.scala 148:115]
  wire  _GEN_48 = _T_10 ? _GEN_38 : state; // @[Decoupled_Mem.scala 148:115]
  wire [32:0] _T_75 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 228:79]
  wire [31:0] _T_76 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 228:79]
  wire [32:0] _T_77 = neighbour_count - before_4k_bound_count; // @[Decoupled_Mem.scala 229:60]
  wire [31:0] _T_78 = neighbour_count - before_4k_bound_count; // @[Decoupled_Mem.scala 229:60]
  wire [32:0] _T_79 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 230:48]
  wire [31:0] _T_80 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 230:48]
  wire [32:0] _T_81 = temp_index + before_4k_bound_count; // @[Decoupled_Mem.scala 231:50]
  wire [31:0] _T_82 = temp_index + before_4k_bound_count; // @[Decoupled_Mem.scala 231:50]
  wire [32:0] _T_83 = temp_index + 32'h100; // @[Decoupled_Mem.scala 240:50]
  wire [31:0] _T_84 = temp_index + 32'h100; // @[Decoupled_Mem.scala 240:50]
  wire [32:0] _T_85 = burst_sum + 32'h100; // @[Decoupled_Mem.scala 241:48]
  wire [31:0] _T_86 = burst_sum + 32'h100; // @[Decoupled_Mem.scala 241:48]
  wire [32:0] _T_87 = neighbour_count - 32'h100; // @[Decoupled_Mem.scala 242:60]
  wire [31:0] _T_88 = neighbour_count - 32'h100; // @[Decoupled_Mem.scala 242:60]
  wire [5:0] _GEN_50 = 6'h1; // @[Decoupled_Mem.scala 222:123]
  wire [31:0] _GEN_51 = start_loc_loop; // @[Decoupled_Mem.scala 222:123]
  wire [31:0] _GEN_52 = _T_70 ? _T_22 : 32'hff; // @[Decoupled_Mem.scala 222:123]
  wire [31:0] _GEN_53 = _T_70 ? _T_78 : _T_88; // @[Decoupled_Mem.scala 222:123]
  wire [31:0] _GEN_54 = _T_70 ? _T_26 : _T_32; // @[Decoupled_Mem.scala 222:123]
  wire [31:0] _GEN_55 = _T_70 ? _T_82 : _T_84; // @[Decoupled_Mem.scala 222:123]
  wire  _GEN_56 = 1'h0; // @[Decoupled_Mem.scala 222:123]
  wire  _GEN_57 = 1'h1; // @[Decoupled_Mem.scala 222:123]
  wire [32:0] _T_101 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 257:79]
  wire [31:0] _T_102 = before_4k_bound_count - 32'h1; // @[Decoupled_Mem.scala 257:79]
  wire [32:0] _T_103 = neighbour_count - before_4k_bound_count; // @[Decoupled_Mem.scala 258:60]
  wire [31:0] _T_104 = neighbour_count - before_4k_bound_count; // @[Decoupled_Mem.scala 258:60]
  wire [32:0] _T_105 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 259:48]
  wire [31:0] _T_106 = burst_sum + before_4k_bound_count; // @[Decoupled_Mem.scala 259:48]
  wire [32:0] _T_107 = temp_index + before_4k_bound_count; // @[Decoupled_Mem.scala 260:50]
  wire [31:0] _T_108 = temp_index + before_4k_bound_count; // @[Decoupled_Mem.scala 260:50]
  wire [32:0] _T_109 = neighbour_count - 32'h1; // @[Decoupled_Mem.scala 268:73]
  wire [31:0] _T_110 = neighbour_count - 32'h1; // @[Decoupled_Mem.scala 268:73]
  wire [32:0] _T_111 = burst_sum + neighbour_count; // @[Decoupled_Mem.scala 270:48]
  wire [31:0] _T_112 = burst_sum + neighbour_count; // @[Decoupled_Mem.scala 270:48]
  wire [5:0] _GEN_59 = 6'h1; // @[Decoupled_Mem.scala 251:135]
  wire [31:0] _GEN_60 = start_loc_loop; // @[Decoupled_Mem.scala 251:135]
  wire [31:0] _GEN_61 = _T_96 ? _T_22 : _T_110; // @[Decoupled_Mem.scala 251:135]
  wire [31:0] _GEN_62 = _T_96 ? _T_78 : 32'h0; // @[Decoupled_Mem.scala 251:135]
  wire [31:0] _GEN_63 = _T_96 ? _T_26 : _T_112; // @[Decoupled_Mem.scala 251:135]
  wire [31:0] _GEN_64 = _T_96 ? _T_82 : 32'h0; // @[Decoupled_Mem.scala 251:135]
  wire  _GEN_65 = _T_96 ? 1'h0 : 1'h1; // @[Decoupled_Mem.scala 251:135]
  wire  _GEN_66 = 1'h1; // @[Decoupled_Mem.scala 251:135]
  wire  _GEN_67 = _T_96; // @[Decoupled_Mem.scala 251:135]
  wire [5:0] _GEN_69 = 6'h1; // @[Decoupled_Mem.scala 220:46]
  wire [31:0] _GEN_70 = start_loc_loop; // @[Decoupled_Mem.scala 220:46]
  wire [31:0] _GEN_71 = _T_63 ? _GEN_52 : _GEN_61; // @[Decoupled_Mem.scala 220:46]
  wire [31:0] _GEN_72 = _T_63 ? _GEN_53 : _GEN_62; // @[Decoupled_Mem.scala 220:46]
  wire [31:0] _GEN_73 = _T_63 ? _GEN_54 : _GEN_63; // @[Decoupled_Mem.scala 220:46]
  wire [31:0] _GEN_74 = _T_63 ? _GEN_55 : _GEN_64; // @[Decoupled_Mem.scala 220:46]
  wire  _GEN_75 = _T_63 ? 1'h0 : _GEN_65; // @[Decoupled_Mem.scala 220:46]
  wire  _GEN_76 = 1'h1; // @[Decoupled_Mem.scala 220:46]
  wire  _GEN_77 = _T_63 ? state : _T_96; // @[Decoupled_Mem.scala 220:46]
  wire [5:0] _GEN_79 = 6'h1; // @[Decoupled_Mem.scala 219:84]
  wire [31:0] _GEN_80 = start_loc_loop; // @[Decoupled_Mem.scala 219:84]
  wire [31:0] _GEN_81 = _GEN_71; // @[Decoupled_Mem.scala 219:84]
  wire [31:0] _GEN_82 = _T_62 ? _GEN_72 : neighbour_count; // @[Decoupled_Mem.scala 219:84]
  wire [31:0] _GEN_83 = _T_62 ? _GEN_73 : burst_sum; // @[Decoupled_Mem.scala 219:84]
  wire [31:0] _GEN_84 = _T_62 ? _GEN_74 : temp_index; // @[Decoupled_Mem.scala 219:84]
  wire  _GEN_85 = _T_62 & _GEN_75; // @[Decoupled_Mem.scala 219:84]
  wire  _GEN_86 = _T_62; // @[Decoupled_Mem.scala 219:84]
  wire  _GEN_87 = _T_62 ? _GEN_77 : state; // @[Decoupled_Mem.scala 219:84]
  wire [5:0] _GEN_89 = 6'h1; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_90 = start_loc_loop; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_91 = _GEN_71; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_92 = state ? _GEN_82 : neighbour_count; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_93 = state ? _GEN_83 : burst_sum; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_94 = state ? _GEN_84 : temp_index; // @[Conditional.scala 39:67]
  wire  _GEN_95 = state & _GEN_85; // @[Conditional.scala 39:67]
  wire  _GEN_96 = state & _T_62; // @[Conditional.scala 39:67]
  wire  _GEN_97 = state ? _GEN_87 : state; // @[Conditional.scala 39:67]
  wire [5:0] _GEN_99 = 6'h1; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_100 = _T_7 ? start_loc : start_loc_loop; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_101 = _T_7 ? _GEN_32 : _GEN_71; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_102 = _T_7 ? _GEN_43 : _GEN_92; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_103 = _T_7 ? _GEN_44 : _GEN_93; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_104 = _T_7 ? _GEN_45 : _GEN_94; // @[Conditional.scala 40:58]
  wire  _GEN_105 = _T_7 ? _GEN_46 : _GEN_95; // @[Conditional.scala 40:58]
  wire  _GEN_106 = _T_7 ? _GEN_47 : _GEN_96; // @[Conditional.scala 40:58]
  wire  _GEN_107 = _T_7 ? _GEN_48 : _GEN_97; // @[Conditional.scala 40:58]
  Queue_10 queue_readData_l1 ( // @[Decoupled_Mem.scala 96:35]
    .clock(queue_readData_l1_clock),
    .reset(queue_readData_l1_reset),
    .io_enq_ready(queue_readData_l1_io_enq_ready),
    .io_enq_valid(queue_readData_l1_io_enq_valid),
    .io_enq_bits_data(queue_readData_l1_io_enq_bits_data),
    .io_deq_ready(queue_readData_l1_io_deq_ready),
    .io_deq_valid(queue_readData_l1_io_deq_valid),
    .io_deq_bits_data(queue_readData_l1_io_deq_bits_data),
    .io_count(queue_readData_l1_io_count)
  );
  Queue_10 queue_readData_l2 ( // @[Decoupled_Mem.scala 97:35]
    .clock(queue_readData_l2_clock),
    .reset(queue_readData_l2_reset),
    .io_enq_ready(queue_readData_l2_io_enq_ready),
    .io_enq_valid(queue_readData_l2_io_enq_valid),
    .io_enq_bits_data(queue_readData_l2_io_enq_bits_data),
    .io_deq_ready(queue_readData_l2_io_deq_ready),
    .io_deq_valid(queue_readData_l2_io_deq_valid),
    .io_deq_bits_data(queue_readData_l2_io_deq_bits_data),
    .io_count(queue_readData_l2_io_count)
  );
  Queue_12 queue_readData ( // @[Decoupled_Mem.scala 98:32]
    .clock(queue_readData_clock),
    .reset(queue_readData_reset),
    .io_enq_ready(queue_readData_io_enq_ready),
    .io_enq_valid(queue_readData_io_enq_valid),
    .io_enq_bits_data(queue_readData_io_enq_bits_data),
    .io_deq_ready(queue_readData_io_deq_ready),
    .io_deq_valid(queue_readData_io_deq_valid),
    .io_deq_bits_data(queue_readData_io_deq_bits_data),
    .io_count(queue_readData_io_count)
  );
  assign io_readData_ready = queue_readData_l1_io_enq_ready; // @[Decoupled_Mem.scala 117:30]
  assign io_to_arbiter_valid = _T_7 ? _GEN_47 : _GEN_96; // @[Decoupled_Mem.scala 123:25 Decoupled_Mem.scala 166:45 Decoupled_Mem.scala 178:45 Decoupled_Mem.scala 197:45 Decoupled_Mem.scala 208:45 Decoupled_Mem.scala 214:41 Decoupled_Mem.scala 235:45 Decoupled_Mem.scala 246:45 Decoupled_Mem.scala 264:45 Decoupled_Mem.scala 277:45]
  assign io_to_arbiter_bits_index = _T_7 ? start_loc : start_loc_loop; // @[Decoupled_Mem.scala 158:50 Decoupled_Mem.scala 169:50 Decoupled_Mem.scala 189:50 Decoupled_Mem.scala 200:50 Decoupled_Mem.scala 227:50 Decoupled_Mem.scala 237:50 Decoupled_Mem.scala 256:50 Decoupled_Mem.scala 267:50]
  assign io_to_arbiter_bits_burst_len = _GEN_101[7:0]; // @[Decoupled_Mem.scala 159:54 Decoupled_Mem.scala 170:54 Decoupled_Mem.scala 190:54 Decoupled_Mem.scala 201:54 Decoupled_Mem.scala 228:54 Decoupled_Mem.scala 238:54 Decoupled_Mem.scala 257:54 Decoupled_Mem.scala 268:54]
  assign io_to_arbiter_bits_id = 6'h1; // @[Decoupled_Mem.scala 157:47 Decoupled_Mem.scala 171:47 Decoupled_Mem.scala 188:47 Decoupled_Mem.scala 202:47 Decoupled_Mem.scala 226:47 Decoupled_Mem.scala 239:47 Decoupled_Mem.scala 255:47 Decoupled_Mem.scala 269:47]
  assign io_count_val_n0 = burst_sum; // @[Decoupled_Mem.scala 106:15]
  assign io_queue_ready = _T; // @[Decoupled_Mem.scala 126:20]
  assign io_queue_valid = _T_1; // @[Decoupled_Mem.scala 127:20]
  assign io_src_q0_deq_ready = _T_7 ? _GEN_46 : _GEN_95; // @[Decoupled_Mem.scala 134:25 Decoupled_Mem.scala 163:45 Decoupled_Mem.scala 175:45 Decoupled_Mem.scala 194:45 Decoupled_Mem.scala 204:45 Decoupled_Mem.scala 211:41 Decoupled_Mem.scala 232:45 Decoupled_Mem.scala 243:45 Decoupled_Mem.scala 261:45 Decoupled_Mem.scala 273:45]
  assign io_src_q1_enq_valid = _T_7 ? _GEN_47 : _GEN_96; // @[Decoupled_Mem.scala 135:25 Decoupled_Mem.scala 164:45 Decoupled_Mem.scala 176:45 Decoupled_Mem.scala 195:45 Decoupled_Mem.scala 205:45 Decoupled_Mem.scala 212:41 Decoupled_Mem.scala 233:45 Decoupled_Mem.scala 244:45 Decoupled_Mem.scala 262:45 Decoupled_Mem.scala 274:45]
  assign io_src_q1_enq_bits = io_src_q0_deq_bits; // @[Decoupled_Mem.scala 133:25]
  assign queue_readData_l1_clock = clock;
  assign queue_readData_l1_reset = reset;
  assign queue_readData_l1_io_enq_valid = io_readData_valid; // @[Decoupled_Mem.scala 117:30]
  assign queue_readData_l1_io_enq_bits_data = io_readData_bits_data; // @[Decoupled_Mem.scala 117:30]
  assign queue_readData_l1_io_deq_ready = queue_readData_l2_io_enq_ready; // @[Decoupled_Mem.scala 118:30]
  assign queue_readData_l2_clock = clock;
  assign queue_readData_l2_reset = reset;
  assign queue_readData_l2_io_enq_valid = queue_readData_l1_io_deq_valid; // @[Decoupled_Mem.scala 118:30]
  assign queue_readData_l2_io_enq_bits_data = queue_readData_l1_io_deq_bits_data; // @[Decoupled_Mem.scala 118:30]
  assign queue_readData_l2_io_deq_ready = queue_readData_io_enq_ready; // @[Decoupled_Mem.scala 119:27]
  assign queue_readData_clock = clock;
  assign queue_readData_reset = reset;
  assign queue_readData_io_enq_valid = queue_readData_l2_io_deq_valid; // @[Decoupled_Mem.scala 119:27]
  assign queue_readData_io_enq_bits_data = queue_readData_l2_io_deq_bits_data; // @[Decoupled_Mem.scala 119:27]
  assign queue_readData_io_deq_ready = _T_7 ? _GEN_46 : _GEN_95; // @[Decoupled_Mem.scala 122:33 Decoupled_Mem.scala 165:53 Decoupled_Mem.scala 177:53 Decoupled_Mem.scala 196:53 Decoupled_Mem.scala 206:53 Decoupled_Mem.scala 213:49 Decoupled_Mem.scala 234:53 Decoupled_Mem.scala 245:53 Decoupled_Mem.scala 263:53 Decoupled_Mem.scala 275:53]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  state = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  neighbour_count = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  temp_index = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  burst_sum = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_1 = _RAND_5[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      state <= 1'h0;
    end else if (_T_7) begin
      if (_T_10) begin
        state <= _GEN_38;
      end
    end else if (state) begin
      if (_T_62) begin
        if (!(_T_63)) begin
          state <= _T_96;
        end
      end
    end
    if (reset) begin
      neighbour_count <= 32'h0;
    end else if (_T_7) begin
      if (_T_10) begin
        if (_T_11) begin
          if (_T_16) begin
            neighbour_count <= _T_24;
          end else begin
            neighbour_count <= _T_30;
          end
        end else if (_T_35) begin
          if (_T_43) begin
            neighbour_count <= _T_24;
          end
        end
      end
    end else if (state) begin
      if (_T_62) begin
        if (_T_63) begin
          if (_T_70) begin
            neighbour_count <= _T_78;
          end else begin
            neighbour_count <= _T_88;
          end
        end else if (_T_96) begin
          neighbour_count <= _T_78;
        end else begin
          neighbour_count <= 32'h0;
        end
      end
    end
    if (reset) begin
      temp_index <= 32'h0;
    end else if (_T_7) begin
      if (_T_10) begin
        if (_T_11) begin
          if (_T_16) begin
            temp_index <= _T_28;
          end else begin
            temp_index <= _T_34;
          end
        end else if (_T_35) begin
          if (_T_43) begin
            temp_index <= _T_28;
          end
        end
      end
    end else if (state) begin
      if (_T_62) begin
        if (_T_63) begin
          if (_T_70) begin
            temp_index <= _T_82;
          end else begin
            temp_index <= _T_84;
          end
        end else if (_T_96) begin
          temp_index <= _T_82;
        end else begin
          temp_index <= 32'h0;
        end
      end
    end
    if (reset) begin
      burst_sum <= 32'h0;
    end else if (_T_7) begin
      if (_T_10) begin
        if (_T_11) begin
          if (_T_16) begin
            burst_sum <= _T_26;
          end else begin
            burst_sum <= _T_32;
          end
        end else if (_T_35) begin
          if (_T_43) begin
            burst_sum <= _T_26;
          end else begin
            burst_sum <= _T_59;
          end
        end
      end
    end else if (state) begin
      if (_T_62) begin
        if (_T_63) begin
          if (_T_70) begin
            burst_sum <= _T_26;
          end else begin
            burst_sum <= _T_32;
          end
        end else if (_T_96) begin
          burst_sum <= _T_26;
        end else begin
          burst_sum <= _T_112;
        end
      end
    end
    _T <= queue_readData_io_deq_ready;
    _T_1 <= queue_readData_io_deq_valid;
  end
endmodule
module RRArbiter_4(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [31:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [31:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [31:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [31:0] io_in_3_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [31:0] io_out_bits,
  output [1:0]  io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [31:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = 2'h1 == io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = 2'h1 == io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [31:0] _GEN_5 = 2'h1 == io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_6 = 2'h2 == io_chosen ? io_in_2_ready : _GEN_3; // @[Arbiter.scala 41:16]
  wire  _GEN_7 = 2'h2 == io_chosen ? io_in_2_valid : _GEN_4; // @[Arbiter.scala 41:16]
  wire [31:0] _GEN_8 = 2'h2 == io_chosen ? io_in_2_bits : _GEN_5; // @[Arbiter.scala 41:16]
  wire  _GEN_9 = 2'h3 == io_chosen ? io_in_3_ready : _GEN_6; // @[Arbiter.scala 41:16]
  wire  _GEN_10 = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  wire [31:0] _GEN_11 = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg [1:0] lastGrant; // @[Reg.scala 15:16]
  wire [1:0] _GEN_12 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 2'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_2 = 2'h2 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_3 = 2'h3 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  validMask_2 = io_in_2_valid & grantMask_2; // @[Arbiter.scala 68:75]
  wire  validMask_3 = io_in_3_valid & grantMask_3; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | validMask_2; // @[Arbiter.scala 31:68]
  wire  _T_3 = _T_2 | validMask_3; // @[Arbiter.scala 31:68]
  wire  _T_4 = _T_3 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_5 = _T_4 | io_in_1_valid; // @[Arbiter.scala 31:68]
  wire  _T_6 = _T_5 | io_in_2_valid; // @[Arbiter.scala 31:68]
  wire  _T_7 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_8 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_9 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_10 = ~_T_3; // @[Arbiter.scala 31:78]
  wire  _T_11 = ~_T_4; // @[Arbiter.scala 31:78]
  wire  _T_12 = ~_T_5; // @[Arbiter.scala 31:78]
  wire  _T_13 = ~_T_6; // @[Arbiter.scala 31:78]
  wire  _T_14 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_15 = _T_10; // @[Arbiter.scala 72:50]
  wire  _T_16 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_17 = grantMask_1 | _T_11; // @[Arbiter.scala 72:50]
  wire  _T_18 = _T_8 & grantMask_2; // @[Arbiter.scala 72:34]
  wire  _T_19 = _T_18 | _T_12; // @[Arbiter.scala 72:50]
  wire  _T_20 = _T_9 & grantMask_3; // @[Arbiter.scala 72:34]
  wire  _T_21 = _T_20 | _T_13; // @[Arbiter.scala 72:50]
  wire  _T_22 = _T_10 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_23 = _T_17 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_24 = _T_19 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_25 = _T_21 & io_out_ready; // @[Arbiter.scala 60:21]
  wire [1:0] _GEN_13 = io_in_2_valid ? 2'h2 : 2'h3; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_14 = io_in_1_valid ? 2'h1 : _GEN_13; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_15 = io_in_0_valid ? 2'h0 : _GEN_14; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_16 = validMask_3 ? 2'h3 : _GEN_15; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_17 = validMask_2 ? 2'h2 : _GEN_16; // @[Arbiter.scala 79:25]
  wire [1:0] choice = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_18 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 79:34 Arbiter.scala 79:34 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_9; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_10; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [31:0] _io_in_io_chosen_bits = _GEN_11; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_9; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_10; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [31:0] _io_in_io_chosen_0_bits = _GEN_11; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_10 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_17 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_2_ready = _T_19 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_3_ready = _T_21 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  assign io_out_bits = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[1:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module Queue_13(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits_index,
  input  [7:0]  io_enq_bits_burst_len,
  input  [1:0]  io_enq_bits_id,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits_index,
  output [7:0]  io_deq_bits_burst_len,
  output [1:0]  io_deq_bits_id,
  output [4:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram_index [0:15]; // @[Decoupled.scala 218:16]
  wire [31:0] ram_index__T_15_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_index__T_15_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram_index__T_5_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_index__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram_index__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram_index__T_5_en; // @[Decoupled.scala 218:16]
  reg [7:0] ram_burst_len [0:15]; // @[Decoupled.scala 218:16]
  wire [7:0] ram_burst_len__T_15_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_burst_len__T_15_addr; // @[Decoupled.scala 218:16]
  wire [7:0] ram_burst_len__T_5_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_burst_len__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram_burst_len__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram_burst_len__T_5_en; // @[Decoupled.scala 218:16]
  reg [1:0] ram_id [0:15]; // @[Decoupled.scala 218:16]
  wire [1:0] ram_id__T_15_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_id__T_15_addr; // @[Decoupled.scala 218:16]
  wire [1:0] ram_id__T_5_data; // @[Decoupled.scala 218:16]
  wire [3:0] ram_id__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram_id__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram_id__T_5_en; // @[Decoupled.scala 218:16]
  reg [3:0] _T; // @[Counter.scala 29:33]
  reg [3:0] _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_7 = _T + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_8 = _T + 4'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire [3:0] _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [1:0] _GEN_4 = io_enq_bits_id; // @[Decoupled.scala 229:17]
  wire [7:0] _GEN_5 = io_enq_bits_burst_len; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_6 = io_enq_bits_index; // @[Decoupled.scala 229:17]
  wire [3:0] _GEN_7 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1 == 4'hf; // @[Counter.scala 38:24]
  wire [4:0] _T_10 = _T_1 + 4'h1; // @[Counter.scala 39:22]
  wire [3:0] _T_11 = _T_1 + 4'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire [3:0] _GEN_8 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_9 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [4:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire [3:0] ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [4:0] _T_18 = _T_17 ? 5'h10 : 5'h0; // @[Decoupled.scala 259:20]
  wire [4:0] _GEN_10 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [4:0] _T_19 = _T_18 | _GEN_10; // @[Decoupled.scala 259:62]
  wire [4:0] _GEN_11 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram_index__T_15_addr = _T_1;
  assign ram_index__T_15_data = ram_index[ram_index__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram_index__T_5_data = io_enq_bits_index;
  assign ram_index__T_5_addr = _T;
  assign ram_index__T_5_mask = 1'h1;
  assign ram_index__T_5_en = io_enq_ready & io_enq_valid;
  assign ram_burst_len__T_15_addr = _T_1;
  assign ram_burst_len__T_15_data = ram_burst_len[ram_burst_len__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram_burst_len__T_5_data = io_enq_bits_burst_len;
  assign ram_burst_len__T_5_addr = _T;
  assign ram_burst_len__T_5_mask = 1'h1;
  assign ram_burst_len__T_5_en = io_enq_ready & io_enq_valid;
  assign ram_id__T_15_addr = _T_1;
  assign ram_id__T_15_data = ram_id[ram_id__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram_id__T_5_data = io_enq_bits_id;
  assign ram_id__T_5_addr = _T;
  assign ram_id__T_5_mask = 1'h1;
  assign ram_id__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits_index = ram_index__T_15_data; // @[Decoupled.scala 242:15]
  assign io_deq_bits_burst_len = ram_burst_len__T_15_data; // @[Decoupled.scala 242:15]
  assign io_deq_bits_id = ram_id__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_10; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 16; initvar = initvar+1)
    ram_index[initvar] = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  for (initvar = 0; initvar < 16; initvar = initvar+1)
    ram_burst_len[initvar] = _RAND_1[7:0];
  _RAND_2 = {1{`RANDOM}};
  for (initvar = 0; initvar < 16; initvar = initvar+1)
    ram_id[initvar] = _RAND_2[1:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_3 = {1{`RANDOM}};
  _T = _RAND_3[3:0];
  _RAND_4 = {1{`RANDOM}};
  _T_1 = _RAND_4[3:0];
  _RAND_5 = {1{`RANDOM}};
  maybe_full = _RAND_5[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram_index__T_5_en & ram_index__T_5_mask) begin
      ram_index[ram_index__T_5_addr] <= ram_index__T_5_data; // @[Decoupled.scala 218:16]
    end
    if(ram_burst_len__T_5_en & ram_burst_len__T_5_mask) begin
      ram_burst_len[ram_burst_len__T_5_addr] <= ram_burst_len__T_5_data; // @[Decoupled.scala 218:16]
    end
    if(ram_id__T_5_en & ram_id__T_5_mask) begin
      ram_id[ram_id__T_5_addr] <= ram_id__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 4'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 4'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Memory(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [29:0] _T_69 = 29'h10000000 * 29'h0; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{34'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_1(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [29:0] _T_45 = 29'h10000000 * 29'h1; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [29:0] _T_51 = 29'h10000000 * 29'h1; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{11'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{11'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{11'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_1(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [29:0] _T_69 = 29'h10000000 * 29'h1; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{34'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_1 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_2(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [30:0] _T_45 = 29'h10000000 * 29'h2; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [30:0] _T_51 = 29'h10000000 * 29'h2; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{10'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{10'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{10'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_2(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [30:0] _T_69 = 29'h10000000 * 29'h2; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{33'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_2 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_3(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [30:0] _T_45 = 29'h10000000 * 29'h3; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [30:0] _T_51 = 29'h10000000 * 29'h3; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{10'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{10'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{10'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_3(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [30:0] _T_69 = 29'h10000000 * 29'h3; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{33'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_3 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_4(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [31:0] _T_45 = 29'h10000000 * 29'h4; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [31:0] _T_51 = 29'h10000000 * 29'h4; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{9'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_4(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [31:0] _T_69 = 29'h10000000 * 29'h4; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{32'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_4 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_5(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [31:0] _T_45 = 29'h10000000 * 29'h5; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [31:0] _T_51 = 29'h10000000 * 29'h5; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{9'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_5(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [31:0] _T_69 = 29'h10000000 * 29'h5; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{32'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_5 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_6(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [31:0] _T_45 = 29'h10000000 * 29'h6; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [31:0] _T_51 = 29'h10000000 * 29'h6; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{9'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_6(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [31:0] _T_69 = 29'h10000000 * 29'h6; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{32'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_6 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_7(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [31:0] _T_45 = 29'h10000000 * 29'h7; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [31:0] _T_51 = 29'h10000000 * 29'h7; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{9'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{9'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_7(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [31:0] _T_69 = 29'h10000000 * 29'h7; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{32'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_7 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_8(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'h8; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'h8; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_8(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'h8; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_8 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_9(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'h9; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'h9; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_9(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'h9; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_9 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_10(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'ha; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'ha; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_10(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'ha; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_10 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_11(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'hb; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'hb; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_11(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'hb; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_11 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_12(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'hc; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'hc; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_12(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'hc; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_12 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_13(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'hd; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'hd; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_13(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'hd; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_13 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_14(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'he; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'he; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_14(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'he; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_14 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_15(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [32:0] _T_45 = 29'h10000000 * 29'hf; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [32:0] _T_51 = 29'h10000000 * 29'hf; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{8'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{8'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_15(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [32:0] _T_69 = 29'h10000000 * 29'hf; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{31'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_15 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_16(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h10; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h10; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_16(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h10; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_16 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_17(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h11; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h11; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_17(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h11; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_17 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_18(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h12; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h12; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_18(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h12; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_18 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_19(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h13; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h13; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_19(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h13; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_19 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_20(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h14; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h14; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_20(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h14; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_20 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_21(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h15; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h15; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_21(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h15; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_21 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_22(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h16; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h16; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_22(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h16; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_22 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_23(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h17; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h17; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_23(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h17; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_23 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_24(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h18; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h18; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_24(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h18; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_24 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_25(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h19; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h19; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_25(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h19; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_25 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_26(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1a; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1a; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_26(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1a; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_26 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_27(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1b; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1b; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_27(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1b; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_27 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_28(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1c; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1c; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_28(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1c; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_28 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_29(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1d; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1d; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_29(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1d; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_29 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_30(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1e; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1e; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_30(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1e; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_30 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module Memory_write_31(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_node_num,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input          io_HBM_write_interface_writeAddr_ready,
  output         io_HBM_write_interface_writeAddr_valid,
  output [63:0]  io_HBM_write_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_write_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_write_interface_writeAddr_bits_id,
  input          io_HBM_write_interface_writeData_ready,
  output         io_HBM_write_interface_writeData_valid,
  output [255:0] io_HBM_write_interface_writeData_bits_data,
  output [31:0]  io_HBM_write_interface_writeData_bits_strb,
  output         io_HBM_write_interface_writeData_bits_last,
  output         io_HBM_write_interface_writeResp_ready,
  input          io_HBM_write_interface_writeResp_valid,
  input  [5:0]   io_HBM_write_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_write_interface_writeResp_bits_resp,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  wire  uram_out_q_clock; // @[Mem_write.scala 58:28]
  wire  uram_out_q_reset; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_enq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_enq_bits; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_ready; // @[Mem_write.scala 58:28]
  wire  uram_out_q_io_deq_valid; // @[Mem_write.scala 58:28]
  wire [7:0] uram_out_q_io_deq_bits; // @[Mem_write.scala 58:28]
  wire [4:0] uram_out_q_io_count; // @[Mem_write.scala 58:28]
  wire  uram_out_q_l1_clock; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_reset; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_enq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_enq_bits; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_ready; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 59:31]
  wire [7:0] uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 59:31]
  wire [1:0] uram_out_q_l1_io_count; // @[Mem_write.scala 59:31]
  wire  uram_out_q_l2_clock; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_reset; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_enq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_enq_bits; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_ready; // @[Mem_write.scala 60:31]
  wire  uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 60:31]
  wire [7:0] uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 60:31]
  wire [1:0] uram_out_q_l2_io_count; // @[Mem_write.scala 60:31]
  reg [1:0] valid_state_addr; // @[Mem_write.scala 52:35]
  reg [1:0] valid_state_data; // @[Mem_write.scala 53:35]
  wire  _T = valid_state_addr == 2'h1; // @[Mem_write.scala 54:81]
  wire  _T_1 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 54:101]
  wire  _T_2 = _T_1 & io_HBM_write_interface_writeAddr_valid; // @[Mem_write.scala 54:121]
  reg [24:0] count_val_node_addr; // @[Counter.scala 29:33]
  wire  _T_3 = count_val_node_addr == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_4 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_5 = count_val_node_addr + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_0 = _T_3 ? 25'h0 : _T_5; // @[Counter.scala 41:21]
  wire [24:0] _GEN_1 = _T_2 ? _GEN_0 : count_val_node_addr; // @[Counter.scala 67:17]
  wire  counterWrap_node_addr = _T_2 & _T_3; // @[Counter.scala 67:17]
  wire  _T_6 = valid_state_data == 2'h1; // @[Mem_write.scala 55:81]
  wire  _T_7 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 55:101]
  wire  _T_8 = _T_7 & io_HBM_write_interface_writeData_valid; // @[Mem_write.scala 55:121]
  reg [24:0] count_val_node_data; // @[Counter.scala 29:33]
  wire  _T_9 = count_val_node_data == 25'h103663f; // @[Counter.scala 38:24]
  wire [25:0] _T_10 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _T_11 = count_val_node_data + 25'h1; // @[Counter.scala 39:22]
  wire [24:0] _GEN_3 = _T_9 ? 25'h0 : _T_11; // @[Counter.scala 41:21]
  wire [24:0] _GEN_4 = _T_8 ? _GEN_3 : count_val_node_data; // @[Counter.scala 67:17]
  wire  counterWrap_node_data = _T_8 & _T_9; // @[Counter.scala 67:17]
  wire  _T_12 = valid_state_addr == 2'h1; // @[Mem_write.scala 61:45]
  wire  _T_13 = _T & io_HBM_write_interface_writeAddr_ready; // @[Mem_write.scala 61:67]
  wire  _T_14 = uram_out_q_io_count < 5'he; // @[Mem_write.scala 61:109]
  wire  write_addr_flag = _T_1 & _T_14; // @[Mem_write.scala 61:87]
  reg  _T_15; // @[Reg.scala 15:16]
  wire  _GEN_6 = write_addr_flag; // @[Reg.scala 16:19]
  reg  _T_16; // @[Reg.scala 15:16]
  wire  _GEN_7 = _T_15; // @[Reg.scala 16:19]
  reg  _T_17; // @[Reg.scala 15:16]
  wire  _GEN_8 = _T_16; // @[Reg.scala 16:19]
  reg  _T_18; // @[Reg.scala 15:16]
  wire  _GEN_9 = _T_17; // @[Reg.scala 16:19]
  reg  _T_19; // @[Reg.scala 15:16]
  wire  _GEN_10 = _T_18; // @[Reg.scala 16:19]
  reg  _T_20; // @[Reg.scala 15:16]
  wire  _GEN_11 = _T_19; // @[Reg.scala 16:19]
  reg  _T_21; // @[Reg.scala 15:16]
  wire  _GEN_12 = _T_20; // @[Reg.scala 16:19]
  reg  _T_22; // @[Reg.scala 15:16]
  wire  _GEN_13 = _T_21; // @[Reg.scala 16:19]
  reg  _T_23; // @[Reg.scala 15:16]
  wire  _GEN_14 = _T_22; // @[Reg.scala 16:19]
  reg  _T_24; // @[Reg.scala 15:16]
  wire  _GEN_15 = _T_23; // @[Reg.scala 16:19]
  reg  _T_25; // @[Reg.scala 15:16]
  wire  _GEN_16 = _T_24; // @[Reg.scala 16:19]
  reg  shift_write_addr_flag; // @[Reg.scala 15:16]
  wire  _GEN_17 = _T_25; // @[Reg.scala 16:19]
  reg [24:0] _T_26; // @[Reg.scala 15:16]
  wire [24:0] _GEN_18 = count_val_node_addr; // @[Reg.scala 16:19]
  reg [24:0] _T_27; // @[Reg.scala 15:16]
  wire [24:0] _GEN_19 = _T_26; // @[Reg.scala 16:19]
  reg [24:0] _T_28; // @[Reg.scala 15:16]
  wire [24:0] _GEN_20 = _T_27; // @[Reg.scala 16:19]
  reg [24:0] _T_29; // @[Reg.scala 15:16]
  wire [24:0] _GEN_21 = _T_28; // @[Reg.scala 16:19]
  reg [24:0] _T_30; // @[Reg.scala 15:16]
  wire [24:0] _GEN_22 = _T_29; // @[Reg.scala 16:19]
  reg [24:0] _T_31; // @[Reg.scala 15:16]
  wire [24:0] _GEN_23 = _T_30; // @[Reg.scala 16:19]
  reg [24:0] _T_32; // @[Reg.scala 15:16]
  wire [24:0] _GEN_24 = _T_31; // @[Reg.scala 16:19]
  reg [24:0] _T_33; // @[Reg.scala 15:16]
  wire [24:0] _GEN_25 = _T_32; // @[Reg.scala 16:19]
  reg [24:0] _T_34; // @[Reg.scala 15:16]
  wire [24:0] _GEN_26 = _T_33; // @[Reg.scala 16:19]
  reg [24:0] _T_35; // @[Reg.scala 15:16]
  wire [24:0] _GEN_27 = _T_34; // @[Reg.scala 16:19]
  reg [24:0] _T_36; // @[Reg.scala 15:16]
  wire [24:0] _GEN_28 = _T_35; // @[Reg.scala 16:19]
  reg [24:0] shift_count_val_node_addr; // @[Reg.scala 15:16]
  wire [24:0] _GEN_29 = _T_36; // @[Reg.scala 16:19]
  wire [24:0] _GEN_75 = shift_count_val_node_addr % 25'h4; // @[Mem_write.scala 69:74]
  wire [2:0] _T_37 = _GEN_75[2:0]; // @[Mem_write.scala 69:74]
  wire [1:0] _T_38 = _T_37[1:0];
  wire [22:0] _GEN_65 = shift_count_val_node_addr[24:2]; // @[Mem_write.scala 69:136]
  wire [24:0] _T_39 = {{2'd0}, shift_count_val_node_addr[24:2]}; // @[Mem_write.scala 69:136]
  wire [24:0] _GEN_76 = _T_39 % 25'h8; // @[Mem_write.scala 69:157]
  wire [3:0] _T_40 = _GEN_76[3:0]; // @[Mem_write.scala 69:157]
  wire [7:0] _T_41 = _T_40 * 4'h8; // @[Mem_write.scala 69:182]
  wire [63:0] _GEN_30 = io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_31 = 2'h1 == _T_37[1:0] ? io_uram_out_a_1 : io_uram_out_a_0; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_32 = 2'h2 == _T_37[1:0] ? io_uram_out_a_2 : _GEN_31; // @[Mem_write.scala 69:105]
  wire [63:0] _GEN_33 = 2'h3 == _T_37[1:0] ? io_uram_out_a_3 : _GEN_32; // @[Mem_write.scala 69:105]
  wire [63:0] _io_uram_out_a_T_38 = _GEN_33; // @[Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105 Mem_write.scala 69:105]
  wire [63:0] _T_42 = _GEN_33 >> _T_41; // @[Mem_write.scala 69:105]
  wire  _T_43 = valid_state_addr == 2'h0; // @[Mem_write.scala 83:46]
  wire  _T_44 = io_master_finish & _T_43; // @[Mem_write.scala 83:27]
  wire [33:0] _T_45 = 29'h10000000 * 29'h1f; // @[Mem_write.scala 91:52]
  wire [19:0] _GEN_66 = count_val_node_addr[24:5]; // @[Mem_write.scala 94:55]
  wire [24:0] _T_46 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 94:55]
  wire [31:0] _GEN_67 = {{7'd0}, _T_46}; // @[Mem_write.scala 94:82]
  wire [32:0] _T_47 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [31:0] _T_48 = _GEN_67 + io_offsets_level_offset; // @[Mem_write.scala 94:82]
  wire [8:0] _T_49 = 9'h20; // @[Mem_write.scala 94:144]
  wire [40:0] _T_50 = _T_48 * 32'h20; // @[Mem_write.scala 94:109]
  wire [33:0] _T_51 = 29'h10000000 * 29'h1f; // @[Mem_write.scala 94:173]
  wire [40:0] _GEN_68 = {{7'd0}, _T_45}; // @[Mem_write.scala 94:152]
  wire [41:0] _T_52 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [40:0] _T_53 = _T_50 + _GEN_68; // @[Mem_write.scala 94:152]
  wire [24:0] _GEN_77 = count_val_node_addr % 25'h4; // @[Mem_write.scala 96:44]
  wire [2:0] _T_54 = _GEN_77[2:0]; // @[Mem_write.scala 96:44]
  wire [1:0] _T_55 = _T_54[1:0];
  wire [19:0] _GEN_69 = count_val_node_addr[24:5]; // @[Mem_write.scala 96:98]
  wire [24:0] _T_56 = {{5'd0}, count_val_node_addr[24:5]}; // @[Mem_write.scala 96:98]
  wire [19:0] _io_uram_addr_a_T_55 = _T_46[19:0]; // @[Mem_write.scala 96:75 Mem_write.scala 96:75]
  wire [19:0] _GEN_34 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_35 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_36 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [19:0] _GEN_37 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  wire [40:0] _GEN_38 = _T_53; // @[Mem_write.scala 93:32]
  wire  _GEN_39 = write_addr_flag; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_40 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_41 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_42 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [19:0] _GEN_43 = _T_46[19:0]; // @[Mem_write.scala 93:32]
  wire [1:0] _GEN_44 = _T_44 ? 2'h2 : valid_state_addr; // @[Mem_write.scala 83:70]
  wire [40:0] _GEN_45 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 83:70]
  wire  _GEN_46 = _T_44 | write_addr_flag; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_47 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_48 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_49 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire [19:0] _GEN_50 = _T_46[19:0]; // @[Mem_write.scala 83:70]
  wire  _T_57 = valid_state_data == 2'h0; // @[Mem_write.scala 104:48]
  wire  _T_58 = io_master_finish & _T_57; // @[Mem_write.scala 104:27]
  wire  _T_59 = _T_58 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 104:73]
  reg  _T_60; // @[Mem_write.scala 109:39]
  wire [63:0] _T_61 = {io_level, 32'h0}; // @[Mem_write.scala 111:62]
  wire [63:0] _GEN_70 = {{32'd0}, io_kernel_count}; // @[Mem_write.scala 111:50]
  wire [63:0] _T_62 = _GEN_70 | _T_61; // @[Mem_write.scala 111:50]
  wire  _T_63 = valid_state_data == 2'h1; // @[Mem_write.scala 113:33]
  wire  _T_64 = _T_6 & io_HBM_write_interface_writeData_ready; // @[Mem_write.scala 113:53]
  wire  _T_65 = _T_7 & uram_out_q_io_deq_valid; // @[Mem_write.scala 113:73]
  wire [8:0] _T_66 = 9'h20; // @[Mem_write.scala 116:103]
  wire [24:0] _GEN_78 = count_val_node_data % 25'h20; // @[Mem_write.scala 116:68]
  wire [8:0] _T_67 = _GEN_78[8:0]; // @[Mem_write.scala 116:68]
  wire [12:0] _T_68 = _T_67 * 9'h8; // @[Mem_write.scala 116:111]
  wire [8198:0] _GEN_71 = {{8191'd0}, uram_out_q_io_deq_bits}; // @[Mem_write.scala 116:44]
  wire [8198:0] _T_69 = _GEN_71 << _T_68; // @[Mem_write.scala 116:44]
  wire [8:0] _T_70 = 9'h20; // @[Mem_write.scala 117:96]
  wire [24:0] _GEN_79 = count_val_node_data % 25'h20; // @[Mem_write.scala 117:61]
  wire [8:0] _T_71 = _GEN_79[8:0]; // @[Mem_write.scala 117:61]
  wire [511:0] _T_72 = 512'h1 << _T_67; // @[Mem_write.scala 117:37]
  wire [8198:0] _GEN_51 = _T_69; // @[Mem_write.scala 113:100]
  wire [511:0] _GEN_52 = _T_65 ? _T_72 : 512'hffffffffffffffffffffffffffffffff; // @[Mem_write.scala 113:100]
  wire  _GEN_53 = _T_65; // @[Mem_write.scala 113:100]
  wire  _GEN_54 = 1'h1; // @[Mem_write.scala 113:100]
  wire [1:0] _GEN_55 = _T_59 ? 2'h2 : valid_state_data; // @[Mem_write.scala 104:93]
  wire  _GEN_56 = _T_59; // @[Mem_write.scala 104:93]
  wire [8198:0] _GEN_57 = _T_59 ? {{8135'd0}, _T_62} : _T_69; // @[Mem_write.scala 104:93]
  wire  _GEN_58 = _T_59 | _T_65; // @[Mem_write.scala 104:93]
  wire [511:0] _GEN_59 = _T_59 ? 512'hffffffffffffffffffffffffffffffff : _GEN_52; // @[Mem_write.scala 104:93]
  wire  _GEN_60 = 1'h1; // @[Mem_write.scala 104:93]
  wire [32:0] _T_73 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  wire [31:0] _T_74 = io_node_num + 32'h1; // @[Mem_write.scala 126:52]
  reg [31:0] _T_75; // @[Mem_write.scala 126:40]
  wire [31:0] _GEN_72 = {{7'd0}, count_val_node_addr}; // @[Mem_write.scala 126:30]
  wire  _T_76 = _GEN_72 >= _T_75; // @[Mem_write.scala 126:30]
  wire [1:0] _GEN_61 = _T_76 ? 2'h2 : _GEN_44; // @[Mem_write.scala 126:58]
  wire [32:0] _T_77 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  wire [31:0] _T_78 = io_node_num + 32'h1; // @[Mem_write.scala 129:52]
  reg [31:0] _T_79; // @[Mem_write.scala 129:40]
  wire [31:0] _GEN_73 = {{7'd0}, count_val_node_data}; // @[Mem_write.scala 129:30]
  wire  _T_80 = _GEN_73 >= _T_79; // @[Mem_write.scala 129:30]
  reg  _T_81; // @[Mem_write.scala 131:35]
  wire [1:0] _GEN_62 = _T_80 ? 2'h2 : _GEN_55; // @[Mem_write.scala 129:58]
  wire  _GEN_63 = _T_80 | _T_59; // @[Mem_write.scala 129:58]
  wire  _T_82 = valid_state_data == 2'h2; // @[Mem_write.scala 134:31]
  wire  _GEN_64 = _T_82 | _GEN_63; // @[Mem_write.scala 134:46]
  wire  _GEN_2 = counterWrap_node_addr; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_node_data; // @[Counter.scala 67:24]
  wire [40:0] _GEN_74 = _T_44 ? {{7'd0}, _T_45} : _T_53; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  Queue_3 uram_out_q ( // @[Mem_write.scala 58:28]
    .clock(uram_out_q_clock),
    .reset(uram_out_q_reset),
    .io_enq_ready(uram_out_q_io_enq_ready),
    .io_enq_valid(uram_out_q_io_enq_valid),
    .io_enq_bits(uram_out_q_io_enq_bits),
    .io_deq_ready(uram_out_q_io_deq_ready),
    .io_deq_valid(uram_out_q_io_deq_valid),
    .io_deq_bits(uram_out_q_io_deq_bits),
    .io_count(uram_out_q_io_count)
  );
  Queue_4 uram_out_q_l1 ( // @[Mem_write.scala 59:31]
    .clock(uram_out_q_l1_clock),
    .reset(uram_out_q_l1_reset),
    .io_enq_ready(uram_out_q_l1_io_enq_ready),
    .io_enq_valid(uram_out_q_l1_io_enq_valid),
    .io_enq_bits(uram_out_q_l1_io_enq_bits),
    .io_deq_ready(uram_out_q_l1_io_deq_ready),
    .io_deq_valid(uram_out_q_l1_io_deq_valid),
    .io_deq_bits(uram_out_q_l1_io_deq_bits),
    .io_count(uram_out_q_l1_io_count)
  );
  Queue_4 uram_out_q_l2 ( // @[Mem_write.scala 60:31]
    .clock(uram_out_q_l2_clock),
    .reset(uram_out_q_l2_reset),
    .io_enq_ready(uram_out_q_l2_io_enq_ready),
    .io_enq_valid(uram_out_q_l2_io_enq_valid),
    .io_enq_bits(uram_out_q_l2_io_enq_bits),
    .io_deq_ready(uram_out_q_l2_io_deq_ready),
    .io_deq_valid(uram_out_q_l2_io_deq_valid),
    .io_deq_bits(uram_out_q_l2_io_deq_bits),
    .io_count(uram_out_q_l2_io_count)
  );
  assign io_HBM_write_interface_writeAddr_valid = _T_44 | write_addr_flag; // @[Mem_write.scala 92:26 Mem_write.scala 95:26 Mem_write.scala 99:26]
  assign io_HBM_write_interface_writeAddr_bits_addr = {{23'd0}, _GEN_45}; // @[Mem_write.scala 91:30 Mem_write.scala 94:30]
  assign io_HBM_write_interface_writeAddr_bits_len = 8'h0; // @[Mem_write.scala 39:25]
  assign io_HBM_write_interface_writeAddr_bits_id = 6'h0; // @[Mem_write.scala 37:24]
  assign io_HBM_write_interface_writeData_valid = _T_59 | _T_65; // @[Mem_write.scala 112:26 Mem_write.scala 118:26 Mem_write.scala 122:26]
  assign io_HBM_write_interface_writeData_bits_data = _GEN_57[255:0]; // @[Mem_write.scala 111:30 Mem_write.scala 116:30]
  assign io_HBM_write_interface_writeData_bits_strb = _GEN_59[31:0]; // @[Mem_write.scala 42:30 Mem_write.scala 117:30]
  assign io_HBM_write_interface_writeData_bits_last = 1'h1; // @[Mem_write.scala 43:26]
  assign io_HBM_write_interface_writeResp_ready = 1'h1; // @[Mem_write.scala 36:44]
  assign io_uram_addr_a_0 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_1 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_2 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_uram_addr_a_3 = _T_46[19:0]; // @[Mem_write.scala 96:75]
  assign io_write_finish = _T_82 | _GEN_63; // @[Mem_write.scala 44:21 Mem_write.scala 109:29 Mem_write.scala 131:25 Mem_write.scala 135:29]
  assign uram_out_q_clock = clock;
  assign uram_out_q_reset = reset;
  assign uram_out_q_io_enq_valid = uram_out_q_l2_io_deq_valid; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_enq_bits = uram_out_q_l2_io_deq_bits; // @[Mem_write.scala 77:26]
  assign uram_out_q_io_deq_ready = 1'h1; // @[Mem_write.scala 119:33]
  assign uram_out_q_l1_clock = clock;
  assign uram_out_q_l1_reset = reset;
  assign uram_out_q_l1_io_enq_valid = shift_write_addr_flag; // @[Mem_write.scala 68:32]
  assign uram_out_q_l1_io_enq_bits = _T_42[7:0]; // @[Mem_write.scala 69:31]
  assign uram_out_q_l1_io_deq_ready = uram_out_q_l2_io_enq_ready; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_clock = clock;
  assign uram_out_q_l2_reset = reset;
  assign uram_out_q_l2_io_enq_valid = uram_out_q_l1_io_deq_valid; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_enq_bits = uram_out_q_l1_io_deq_bits; // @[Mem_write.scala 76:26]
  assign uram_out_q_l2_io_deq_ready = uram_out_q_io_enq_ready; // @[Mem_write.scala 77:26]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  valid_state_addr = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  valid_state_data = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  count_val_node_addr = _RAND_2[24:0];
  _RAND_3 = {1{`RANDOM}};
  count_val_node_data = _RAND_3[24:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  _T_16 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  _T_17 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  _T_18 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_19 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_21 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  _T_22 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  _T_23 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  _T_24 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  _T_25 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  shift_write_addr_flag = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  _T_26 = _RAND_16[24:0];
  _RAND_17 = {1{`RANDOM}};
  _T_27 = _RAND_17[24:0];
  _RAND_18 = {1{`RANDOM}};
  _T_28 = _RAND_18[24:0];
  _RAND_19 = {1{`RANDOM}};
  _T_29 = _RAND_19[24:0];
  _RAND_20 = {1{`RANDOM}};
  _T_30 = _RAND_20[24:0];
  _RAND_21 = {1{`RANDOM}};
  _T_31 = _RAND_21[24:0];
  _RAND_22 = {1{`RANDOM}};
  _T_32 = _RAND_22[24:0];
  _RAND_23 = {1{`RANDOM}};
  _T_33 = _RAND_23[24:0];
  _RAND_24 = {1{`RANDOM}};
  _T_34 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_35 = _RAND_25[24:0];
  _RAND_26 = {1{`RANDOM}};
  _T_36 = _RAND_26[24:0];
  _RAND_27 = {1{`RANDOM}};
  shift_count_val_node_addr = _RAND_27[24:0];
  _RAND_28 = {1{`RANDOM}};
  _T_60 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  _T_75 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  _T_79 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  _T_81 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      valid_state_addr <= 2'h0;
    end else if (_T_76) begin
      valid_state_addr <= 2'h2;
    end else if (_T_44) begin
      valid_state_addr <= 2'h2;
    end
    if (reset) begin
      valid_state_data <= 2'h0;
    end else if (_T_80) begin
      valid_state_data <= 2'h2;
    end else if (_T_59) begin
      valid_state_data <= 2'h2;
    end
    if (reset) begin
      count_val_node_addr <= 25'h0;
    end else if (_T_2) begin
      if (_T_3) begin
        count_val_node_addr <= 25'h0;
      end else begin
        count_val_node_addr <= _T_5;
      end
    end
    if (reset) begin
      count_val_node_data <= 25'h0;
    end else if (_T_8) begin
      if (_T_9) begin
        count_val_node_data <= 25'h0;
      end else begin
        count_val_node_data <= _T_11;
      end
    end
    _T_15 <= _T_1 & _T_14;
    _T_16 <= _T_15;
    _T_17 <= _T_16;
    _T_18 <= _T_17;
    _T_19 <= _T_18;
    _T_20 <= _T_19;
    _T_21 <= _T_20;
    _T_22 <= _T_21;
    _T_23 <= _T_22;
    _T_24 <= _T_23;
    _T_25 <= _T_24;
    shift_write_addr_flag <= _T_25;
    _T_26 <= count_val_node_addr;
    _T_27 <= _T_26;
    _T_28 <= _T_27;
    _T_29 <= _T_28;
    _T_30 <= _T_29;
    _T_31 <= _T_30;
    _T_32 <= _T_31;
    _T_33 <= _T_32;
    _T_34 <= _T_33;
    _T_35 <= _T_34;
    _T_36 <= _T_35;
    shift_count_val_node_addr <= _T_36;
    _T_60 <= 1'h1;
    _T_75 <= io_node_num + 32'h1;
    _T_79 <= io_node_num + 32'h1;
    _T_81 <= 1'h1;
  end
endmodule
module Memory_31(
  input          clock,
  input          reset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  input          io_p1_end,
  input  [31:0]  io_level,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [31:0]  io_kernel_count,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  output [31:0]  io_neighbour_cnt,
  output         io_mem_end,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output         io_write_finish,
  input          io_HBM_interface_writeAddr_ready,
  output         io_HBM_interface_writeAddr_valid,
  output [63:0]  io_HBM_interface_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_writeAddr_bits_id,
  input          io_HBM_interface_writeData_ready,
  output         io_HBM_interface_writeData_valid,
  output [255:0] io_HBM_interface_writeData_bits_data,
  output [31:0]  io_HBM_interface_writeData_bits_strb,
  output         io_HBM_interface_writeData_bits_last,
  output         io_HBM_interface_writeResp_ready,
  input          io_HBM_interface_writeResp_valid,
  input  [5:0]   io_HBM_interface_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_writeResp_bits_resp,
  input          io_HBM_interface_readAddr_ready,
  output         io_HBM_interface_readAddr_valid,
  output [63:0]  io_HBM_interface_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_readAddr_bits_len,
  output [5:0]   io_HBM_interface_readAddr_bits_id,
  output         io_HBM_interface_readData_ready,
  input          io_HBM_interface_readData_valid,
  input  [255:0] io_HBM_interface_readData_bits_data,
  input  [5:0]   io_HBM_interface_readData_bits_id,
  input          io_HBM_interface_readData_bits_last,
  input  [1:0]   io_HBM_interface_readData_bits_resp,
  input          io_mem_clock,
  input          io_reset_h
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  wire  HBM_reader_clock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_reset; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_writeAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_writeAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 331:72]
  wire [255:0] HBM_reader_io_interface_to_pe_writeData_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_interface_to_pe_writeData_bits_strb; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeData_bits_last; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire [1:0] HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readAddr_bits_addr; // @[Decoupled_Mem.scala 331:72]
  wire [7:0] HBM_reader_io_interface_to_pe_readAddr_bits_len; // @[Decoupled_Mem.scala 331:72]
  wire [5:0] HBM_reader_io_interface_to_pe_readAddr_bits_id; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_0_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_1_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_2_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_array_3_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 331:72]
  wire [63:0] HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_sysclock; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 331:72]
  wire  HBM_reader_io_src_valid; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_src_bits; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 331:72]
  wire [31:0] HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 331:72]
  wire  write_channel_clock; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_reset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_level; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_offsets_level_offset; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_node_num; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_uram_out_a_3; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_kernel_count; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_master_finish; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 334:31]
  wire [63:0] write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 334:31]
  wire [7:0] write_channel_io_HBM_write_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 334:31]
  wire [255:0] write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 334:31]
  wire [31:0] write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeData_bits_last; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_ready; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_HBM_write_interface_writeResp_valid; // @[Decoupled_Mem.scala 334:31]
  wire [5:0] write_channel_io_HBM_write_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 334:31]
  wire [1:0] write_channel_io_HBM_write_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 334:31]
  wire [19:0] write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 334:31]
  wire  write_channel_io_write_finish; // @[Decoupled_Mem.scala 334:31]
  wire  arb_clock; // @[Decoupled_Mem.scala 360:21]
  wire  arb_reset; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_0_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_0_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_0_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_0_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_in_1_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_in_1_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_in_1_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_in_1_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_ready; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_out_valid; // @[Decoupled_Mem.scala 360:21]
  wire [31:0] arb_io_out_bits_index; // @[Decoupled_Mem.scala 360:21]
  wire [7:0] arb_io_out_bits_burst_len; // @[Decoupled_Mem.scala 360:21]
  wire [1:0] arb_io_out_bits_id; // @[Decoupled_Mem.scala 360:21]
  wire  arb_io_chosen; // @[Decoupled_Mem.scala 360:21]
  wire  R_array_index_queue_l1_clock; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_reset; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_enq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_enq_bits; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_ready; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 361:40]
  wire [31:0] R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 361:40]
  wire [1:0] R_array_index_queue_l1_io_count; // @[Decoupled_Mem.scala 361:40]
  wire  R_array_index_queue_l2_clock; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_reset; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_enq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_enq_bits; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_ready; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 362:40]
  wire [31:0] R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 362:40]
  wire [1:0] R_array_index_queue_l2_io_count; // @[Decoupled_Mem.scala 362:40]
  wire  R_array_index_queue_clock; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_reset; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_enq_bits; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_ready; // @[Decoupled_Mem.scala 363:37]
  wire  R_array_index_queue_io_deq_valid; // @[Decoupled_Mem.scala 363:37]
  wire [31:0] R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 363:37]
  wire [4:0] R_array_index_queue_io_count; // @[Decoupled_Mem.scala 363:37]
  wire  src_index_queue0_clock; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_reset; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_enq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_enq_bits; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_ready; // @[Decoupled_Mem.scala 364:34]
  wire  src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 364:34]
  wire [31:0] src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 364:34]
  wire [6:0] src_index_queue0_io_count; // @[Decoupled_Mem.scala 364:34]
  wire  read_neighbour_clock; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_reset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_readData_valid; // @[Decoupled_Mem.scala 366:32]
  wire [63:0] read_neighbour_io_readData_bits_data; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_offsets_level_offset; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_push_or_pull_state; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 366:32]
  wire [7:0] read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 366:32]
  wire [5:0] read_neighbour_io_to_arbiter_bits_id; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_count_val_n0; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q0_deq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q0_deq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_ready; // @[Decoupled_Mem.scala 366:32]
  wire  read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 366:32]
  wire [31:0] read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 366:32]
  wire  R_array_index_arb_clock; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_reset; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_0_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_0_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_1_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_1_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_2_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_2_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_in_3_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_in_3_bits; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_ready; // @[Decoupled_Mem.scala 435:35]
  wire  R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 435:35]
  wire [31:0] R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 435:35]
  wire [1:0] R_array_index_arb_io_chosen; // @[Decoupled_Mem.scala 435:35]
  wire  to_readAddr_queue_clock; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_reset; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_enq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_enq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_enq_bits_id; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  to_readAddr_queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] to_readAddr_queue_io_deq_bits_index; // @[Decoupled.scala 296:21]
  wire [7:0] to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled.scala 296:21]
  wire [1:0] to_readAddr_queue_io_deq_bits_id; // @[Decoupled.scala 296:21]
  wire [4:0] to_readAddr_queue_io_count; // @[Decoupled.scala 296:21]
  reg [31:0] _T; // @[Decoupled_Mem.scala 349:38]
  reg [31:0] _T_1; // @[Decoupled_Mem.scala 355:45]
  reg  _T_2; // @[Decoupled_Mem.scala 356:46]
  reg  _T_3; // @[Decoupled_Mem.scala 357:12]
  reg [31:0] _T_4; // @[Decoupled_Mem.scala 358:45]
  wire  _T_5 = R_array_index_queue_io_enq_ready & R_array_index_queue_io_enq_valid; // @[Decoupled_Mem.scala 383:83]
  reg [30:0] count_val_i0; // @[Counter.scala 29:33]
  wire  _T_6 = count_val_i0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_7 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_8 = count_val_i0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_6 ? 31'h0 : _T_8; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T_5 ? _GEN_0 : count_val_i0; // @[Counter.scala 67:17]
  wire  counterWrap_i0 = _T_5 & _T_6; // @[Counter.scala 67:17]
  wire  _T_9 = read_neighbour_io_queue_ready & read_neighbour_io_queue_valid; // @[Decoupled_Mem.scala 384:80]
  reg [30:0] count_val_i1; // @[Counter.scala 29:33]
  wire  _T_10 = count_val_i1 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_11 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_12 = count_val_i1 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_3 = _T_10 ? 31'h0 : _T_12; // @[Counter.scala 41:21]
  wire [30:0] _GEN_4 = _T_9 ? _GEN_3 : count_val_i1; // @[Counter.scala 67:17]
  wire  counterWrap_i1 = _T_9 & _T_10; // @[Counter.scala 67:17]
  reg [31:0] count_val_n0; // @[Decoupled_Mem.scala 385:31]
  wire  _T_13 = io_neighbours_0_ready & io_neighbours_0_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_14; // @[Counter.scala 29:33]
  wire  _T_16 = _T_14 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_17 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_18 = _T_14 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_6 = _T_16 ? 31'h0 : _T_18; // @[Counter.scala 41:21]
  wire [30:0] _GEN_7 = _T_13 ? _GEN_6 : _T_14; // @[Counter.scala 67:17]
  wire  _GEN_8 = _T_13 & _T_16; // @[Counter.scala 67:17]
  wire  _T_19 = io_neighbours_1_ready & io_neighbours_1_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_20; // @[Counter.scala 29:33]
  wire  _T_22 = _T_20 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_23 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_24 = _T_20 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_9 = _T_22 ? 31'h0 : _T_24; // @[Counter.scala 41:21]
  wire [30:0] _GEN_10 = _T_19 ? _GEN_9 : _T_20; // @[Counter.scala 67:17]
  wire  _GEN_11 = _T_19 & _T_22; // @[Counter.scala 67:17]
  wire  _T_25 = io_neighbours_2_ready & io_neighbours_2_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_26; // @[Counter.scala 29:33]
  wire  _T_28 = _T_26 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_29 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_30 = _T_26 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_12 = _T_28 ? 31'h0 : _T_30; // @[Counter.scala 41:21]
  wire [30:0] _GEN_13 = _T_25 ? _GEN_12 : _T_26; // @[Counter.scala 67:17]
  wire  _GEN_14 = _T_25 & _T_28; // @[Counter.scala 67:17]
  wire  _T_31 = io_neighbours_3_ready & io_neighbours_3_valid; // @[Decoupled_Mem.scala 394:63]
  reg [30:0] _T_32; // @[Counter.scala 29:33]
  wire  _T_34 = _T_32 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_35 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_36 = _T_32 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_15 = _T_34 ? 31'h0 : _T_36; // @[Counter.scala 41:21]
  wire [30:0] _GEN_16 = _T_31 ? _GEN_15 : _T_32; // @[Counter.scala 67:17]
  wire  _GEN_17 = _T_31 & _T_34; // @[Counter.scala 67:17]
  wire [31:0] _T_37 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_38 = _T_14 + _T_20; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_39 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_40 = _T_38 + _T_26; // @[Decoupled_Mem.scala 408:54]
  wire [31:0] _T_41 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  wire [30:0] _T_42 = _T_40 + _T_32; // @[Decoupled_Mem.scala 408:54]
  reg [30:0] _T_43; // @[Decoupled_Mem.scala 408:32]
  wire  _T_44 = count_val_i0 == count_val_i1; // @[Decoupled_Mem.scala 426:40]
  wire  _T_45 = count_val_n0 == HBM_reader_io_burst_cnt; // @[Decoupled_Mem.scala 426:73]
  wire  _T_46 = _T_44 & _T_45; // @[Decoupled_Mem.scala 426:57]
  wire  _T_47 = io_neighbour_cnt == HBM_reader_io_neighbour_cnt; // @[Decoupled_Mem.scala 426:121]
  wire  _T_48 = _T_46 & _T_47; // @[Decoupled_Mem.scala 426:101]
  wire  _T_49 = _T_48 & io_p1_end; // @[Decoupled_Mem.scala 426:153]
  wire  _T_50 = ~HBM_reader_io_interface_to_pe_writeAddr_valid; // @[Decoupled_Mem.scala 427:58]
  wire  _T_51 = _T_49 & _T_50; // @[Decoupled_Mem.scala 427:9]
  wire  _T_52 = ~HBM_reader_io_interface_to_pe_writeData_valid; // @[Decoupled_Mem.scala 427:119]
  wire  _T_53 = _T_51 & _T_52; // @[Decoupled_Mem.scala 427:70]
  wire  _T_54 = ~HBM_reader_io_interface_to_pe_readAddr_valid; // @[Decoupled_Mem.scala 428:57]
  wire  _T_55 = _T_53 & _T_54; // @[Decoupled_Mem.scala 428:9]
  reg  _T_56; // @[Decoupled_Mem.scala 426:26]
  wire [31:0] _T_57 = ~R_array_index_queue_l1_io_deq_bits; // @[Decoupled_Mem.scala 447:47]
  wire [31:0] _T_58 = ~_T_57; // @[Decoupled_Mem.scala 447:45]
  wire  _T_59 = ~R_array_index_queue_l1_io_deq_valid; // @[Decoupled_Mem.scala 448:48]
  wire  _T_60 = ~_T_59; // @[Decoupled_Mem.scala 448:46]
  wire [26:0] _GEN_18 = R_array_index_queue_io_deq_bits[31:5]; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_61 = {{5'd0}, R_array_index_queue_io_deq_bits[31:5]}; // @[Decoupled_Mem.scala 453:65]
  wire [31:0] _T_62 = io_push_or_pull_state ? io_offsets_CSC_R_offset : io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 453:104]
  wire [32:0] _T_63 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire [31:0] _T_64 = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:99]
  wire  _T_65 = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:60]
  wire  _T_66 = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:71]
  wire  _T_67 = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:60]
  wire [63:0] _T_68 = to_readAddr_queue_io_deq_bits_index * 32'h20; // @[Decoupled_Mem.scala 466:88]
  wire [33:0] _T_69 = 29'h10000000 * 29'h1f; // @[Decoupled_Mem.scala 466:174]
  wire [63:0] _GEN_19 = {{30'd0}, _T_69}; // @[Decoupled_Mem.scala 466:153]
  wire [64:0] _T_70 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire [63:0] _T_71 = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:153]
  wire  _T_72 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_73 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_74 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_75 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:95]
  wire  _T_76 = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:93]
  wire  _T_77 = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_78 = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_79 = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _T_80 = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:126]
  wire  _GEN_2 = counterWrap_i0; // @[Counter.scala 67:24]
  wire  _GEN_5 = counterWrap_i1; // @[Counter.scala 67:24]
  wire  _T_15 = _GEN_8; // @[Counter.scala 67:24]
  wire  _T_21 = _GEN_11; // @[Counter.scala 67:24]
  wire  _T_27 = _GEN_14; // @[Counter.scala 67:24]
  wire  _T_33 = _GEN_17; // @[Counter.scala 67:24]
  HBM_reader HBM_reader ( // @[Decoupled_Mem.scala 331:72]
    .clock(HBM_reader_clock),
    .reset(HBM_reader_reset),
    .io_HBM_interface_writeAddr_ready(HBM_reader_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(HBM_reader_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(HBM_reader_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(HBM_reader_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(HBM_reader_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(HBM_reader_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(HBM_reader_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(HBM_reader_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(HBM_reader_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(HBM_reader_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(HBM_reader_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(HBM_reader_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(HBM_reader_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(HBM_reader_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(HBM_reader_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(HBM_reader_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(HBM_reader_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(HBM_reader_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(HBM_reader_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(HBM_reader_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(HBM_reader_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(HBM_reader_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(HBM_reader_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(HBM_reader_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(HBM_reader_io_HBM_interface_readData_bits_resp),
    .io_interface_to_pe_writeAddr_ready(HBM_reader_io_interface_to_pe_writeAddr_ready),
    .io_interface_to_pe_writeAddr_valid(HBM_reader_io_interface_to_pe_writeAddr_valid),
    .io_interface_to_pe_writeAddr_bits_addr(HBM_reader_io_interface_to_pe_writeAddr_bits_addr),
    .io_interface_to_pe_writeAddr_bits_len(HBM_reader_io_interface_to_pe_writeAddr_bits_len),
    .io_interface_to_pe_writeAddr_bits_id(HBM_reader_io_interface_to_pe_writeAddr_bits_id),
    .io_interface_to_pe_writeData_ready(HBM_reader_io_interface_to_pe_writeData_ready),
    .io_interface_to_pe_writeData_valid(HBM_reader_io_interface_to_pe_writeData_valid),
    .io_interface_to_pe_writeData_bits_data(HBM_reader_io_interface_to_pe_writeData_bits_data),
    .io_interface_to_pe_writeData_bits_strb(HBM_reader_io_interface_to_pe_writeData_bits_strb),
    .io_interface_to_pe_writeData_bits_last(HBM_reader_io_interface_to_pe_writeData_bits_last),
    .io_interface_to_pe_writeResp_ready(HBM_reader_io_interface_to_pe_writeResp_ready),
    .io_interface_to_pe_writeResp_valid(HBM_reader_io_interface_to_pe_writeResp_valid),
    .io_interface_to_pe_writeResp_bits_id(HBM_reader_io_interface_to_pe_writeResp_bits_id),
    .io_interface_to_pe_writeResp_bits_resp(HBM_reader_io_interface_to_pe_writeResp_bits_resp),
    .io_interface_to_pe_readAddr_ready(HBM_reader_io_interface_to_pe_readAddr_ready),
    .io_interface_to_pe_readAddr_valid(HBM_reader_io_interface_to_pe_readAddr_valid),
    .io_interface_to_pe_readAddr_bits_addr(HBM_reader_io_interface_to_pe_readAddr_bits_addr),
    .io_interface_to_pe_readAddr_bits_len(HBM_reader_io_interface_to_pe_readAddr_bits_len),
    .io_interface_to_pe_readAddr_bits_id(HBM_reader_io_interface_to_pe_readAddr_bits_id),
    .io_interface_to_pe_readData_array_0_ready(HBM_reader_io_interface_to_pe_readData_array_0_ready),
    .io_interface_to_pe_readData_array_0_valid(HBM_reader_io_interface_to_pe_readData_array_0_valid),
    .io_interface_to_pe_readData_array_0_bits_data(HBM_reader_io_interface_to_pe_readData_array_0_bits_data),
    .io_interface_to_pe_readData_array_1_ready(HBM_reader_io_interface_to_pe_readData_array_1_ready),
    .io_interface_to_pe_readData_array_1_valid(HBM_reader_io_interface_to_pe_readData_array_1_valid),
    .io_interface_to_pe_readData_array_1_bits_data(HBM_reader_io_interface_to_pe_readData_array_1_bits_data),
    .io_interface_to_pe_readData_array_2_ready(HBM_reader_io_interface_to_pe_readData_array_2_ready),
    .io_interface_to_pe_readData_array_2_valid(HBM_reader_io_interface_to_pe_readData_array_2_valid),
    .io_interface_to_pe_readData_array_2_bits_data(HBM_reader_io_interface_to_pe_readData_array_2_bits_data),
    .io_interface_to_pe_readData_array_3_ready(HBM_reader_io_interface_to_pe_readData_array_3_ready),
    .io_interface_to_pe_readData_array_3_valid(HBM_reader_io_interface_to_pe_readData_array_3_valid),
    .io_interface_to_pe_readData_array_3_bits_data(HBM_reader_io_interface_to_pe_readData_array_3_bits_data),
    .io_interface_to_pe_readData_offset_ready(HBM_reader_io_interface_to_pe_readData_offset_ready),
    .io_interface_to_pe_readData_offset_valid(HBM_reader_io_interface_to_pe_readData_offset_valid),
    .io_interface_to_pe_readData_offset_bits_data(HBM_reader_io_interface_to_pe_readData_offset_bits_data),
    .io_sysclock(HBM_reader_io_sysclock),
    .io_src_ready(HBM_reader_io_src_ready),
    .io_src_valid(HBM_reader_io_src_valid),
    .io_src_bits(HBM_reader_io_src_bits),
    .io_burst_cnt(HBM_reader_io_burst_cnt),
    .io_neighbour_cnt(HBM_reader_io_neighbour_cnt)
  );
  Memory_write_31 write_channel ( // @[Decoupled_Mem.scala 334:31]
    .clock(write_channel_clock),
    .reset(write_channel_reset),
    .io_level(write_channel_io_level),
    .io_offsets_CSR_R_offset(write_channel_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(write_channel_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(write_channel_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(write_channel_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(write_channel_io_offsets_level_offset),
    .io_node_num(write_channel_io_node_num),
    .io_uram_out_a_0(write_channel_io_uram_out_a_0),
    .io_uram_out_a_1(write_channel_io_uram_out_a_1),
    .io_uram_out_a_2(write_channel_io_uram_out_a_2),
    .io_uram_out_a_3(write_channel_io_uram_out_a_3),
    .io_kernel_count(write_channel_io_kernel_count),
    .io_master_finish(write_channel_io_master_finish),
    .io_HBM_write_interface_writeAddr_ready(write_channel_io_HBM_write_interface_writeAddr_ready),
    .io_HBM_write_interface_writeAddr_valid(write_channel_io_HBM_write_interface_writeAddr_valid),
    .io_HBM_write_interface_writeAddr_bits_addr(write_channel_io_HBM_write_interface_writeAddr_bits_addr),
    .io_HBM_write_interface_writeAddr_bits_len(write_channel_io_HBM_write_interface_writeAddr_bits_len),
    .io_HBM_write_interface_writeAddr_bits_id(write_channel_io_HBM_write_interface_writeAddr_bits_id),
    .io_HBM_write_interface_writeData_ready(write_channel_io_HBM_write_interface_writeData_ready),
    .io_HBM_write_interface_writeData_valid(write_channel_io_HBM_write_interface_writeData_valid),
    .io_HBM_write_interface_writeData_bits_data(write_channel_io_HBM_write_interface_writeData_bits_data),
    .io_HBM_write_interface_writeData_bits_strb(write_channel_io_HBM_write_interface_writeData_bits_strb),
    .io_HBM_write_interface_writeData_bits_last(write_channel_io_HBM_write_interface_writeData_bits_last),
    .io_HBM_write_interface_writeResp_ready(write_channel_io_HBM_write_interface_writeResp_ready),
    .io_HBM_write_interface_writeResp_valid(write_channel_io_HBM_write_interface_writeResp_valid),
    .io_HBM_write_interface_writeResp_bits_id(write_channel_io_HBM_write_interface_writeResp_bits_id),
    .io_HBM_write_interface_writeResp_bits_resp(write_channel_io_HBM_write_interface_writeResp_bits_resp),
    .io_uram_addr_a_0(write_channel_io_uram_addr_a_0),
    .io_uram_addr_a_1(write_channel_io_uram_addr_a_1),
    .io_uram_addr_a_2(write_channel_io_uram_addr_a_2),
    .io_uram_addr_a_3(write_channel_io_uram_addr_a_3),
    .io_write_finish(write_channel_io_write_finish)
  );
  Arbiter arb ( // @[Decoupled_Mem.scala 360:21]
    .clock(arb_clock),
    .reset(arb_reset),
    .io_in_0_ready(arb_io_in_0_ready),
    .io_in_0_valid(arb_io_in_0_valid),
    .io_in_0_bits_index(arb_io_in_0_bits_index),
    .io_in_0_bits_burst_len(arb_io_in_0_bits_burst_len),
    .io_in_0_bits_id(arb_io_in_0_bits_id),
    .io_in_1_ready(arb_io_in_1_ready),
    .io_in_1_valid(arb_io_in_1_valid),
    .io_in_1_bits_index(arb_io_in_1_bits_index),
    .io_in_1_bits_burst_len(arb_io_in_1_bits_burst_len),
    .io_in_1_bits_id(arb_io_in_1_bits_id),
    .io_out_ready(arb_io_out_ready),
    .io_out_valid(arb_io_out_valid),
    .io_out_bits_index(arb_io_out_bits_index),
    .io_out_bits_burst_len(arb_io_out_bits_burst_len),
    .io_out_bits_id(arb_io_out_bits_id),
    .io_chosen(arb_io_chosen)
  );
  Queue R_array_index_queue_l1 ( // @[Decoupled_Mem.scala 361:40]
    .clock(R_array_index_queue_l1_clock),
    .reset(R_array_index_queue_l1_reset),
    .io_enq_ready(R_array_index_queue_l1_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l1_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l1_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l1_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l1_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l1_io_deq_bits),
    .io_count(R_array_index_queue_l1_io_count)
  );
  Queue R_array_index_queue_l2 ( // @[Decoupled_Mem.scala 362:40]
    .clock(R_array_index_queue_l2_clock),
    .reset(R_array_index_queue_l2_reset),
    .io_enq_ready(R_array_index_queue_l2_io_enq_ready),
    .io_enq_valid(R_array_index_queue_l2_io_enq_valid),
    .io_enq_bits(R_array_index_queue_l2_io_enq_bits),
    .io_deq_ready(R_array_index_queue_l2_io_deq_ready),
    .io_deq_valid(R_array_index_queue_l2_io_deq_valid),
    .io_deq_bits(R_array_index_queue_l2_io_deq_bits),
    .io_count(R_array_index_queue_l2_io_count)
  );
  Queue_8 R_array_index_queue ( // @[Decoupled_Mem.scala 363:37]
    .clock(R_array_index_queue_clock),
    .reset(R_array_index_queue_reset),
    .io_enq_ready(R_array_index_queue_io_enq_ready),
    .io_enq_valid(R_array_index_queue_io_enq_valid),
    .io_enq_bits(R_array_index_queue_io_enq_bits),
    .io_deq_ready(R_array_index_queue_io_deq_ready),
    .io_deq_valid(R_array_index_queue_io_deq_valid),
    .io_deq_bits(R_array_index_queue_io_deq_bits),
    .io_count(R_array_index_queue_io_count)
  );
  Queue_2 src_index_queue0 ( // @[Decoupled_Mem.scala 364:34]
    .clock(src_index_queue0_clock),
    .reset(src_index_queue0_reset),
    .io_enq_ready(src_index_queue0_io_enq_ready),
    .io_enq_valid(src_index_queue0_io_enq_valid),
    .io_enq_bits(src_index_queue0_io_enq_bits),
    .io_deq_ready(src_index_queue0_io_deq_ready),
    .io_deq_valid(src_index_queue0_io_deq_valid),
    .io_deq_bits(src_index_queue0_io_deq_bits),
    .io_count(src_index_queue0_io_count)
  );
  Read_neighbour read_neighbour ( // @[Decoupled_Mem.scala 366:32]
    .clock(read_neighbour_clock),
    .reset(read_neighbour_reset),
    .io_readData_ready(read_neighbour_io_readData_ready),
    .io_readData_valid(read_neighbour_io_readData_valid),
    .io_readData_bits_data(read_neighbour_io_readData_bits_data),
    .io_offsets_CSR_R_offset(read_neighbour_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(read_neighbour_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(read_neighbour_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(read_neighbour_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(read_neighbour_io_offsets_level_offset),
    .io_push_or_pull_state(read_neighbour_io_push_or_pull_state),
    .io_to_arbiter_ready(read_neighbour_io_to_arbiter_ready),
    .io_to_arbiter_valid(read_neighbour_io_to_arbiter_valid),
    .io_to_arbiter_bits_index(read_neighbour_io_to_arbiter_bits_index),
    .io_to_arbiter_bits_burst_len(read_neighbour_io_to_arbiter_bits_burst_len),
    .io_to_arbiter_bits_id(read_neighbour_io_to_arbiter_bits_id),
    .io_count_val_n0(read_neighbour_io_count_val_n0),
    .io_queue_ready(read_neighbour_io_queue_ready),
    .io_queue_valid(read_neighbour_io_queue_valid),
    .io_src_q0_deq_ready(read_neighbour_io_src_q0_deq_ready),
    .io_src_q0_deq_valid(read_neighbour_io_src_q0_deq_valid),
    .io_src_q0_deq_bits(read_neighbour_io_src_q0_deq_bits),
    .io_src_q1_enq_ready(read_neighbour_io_src_q1_enq_ready),
    .io_src_q1_enq_valid(read_neighbour_io_src_q1_enq_valid),
    .io_src_q1_enq_bits(read_neighbour_io_src_q1_enq_bits)
  );
  RRArbiter_4 R_array_index_arb ( // @[Decoupled_Mem.scala 435:35]
    .clock(R_array_index_arb_clock),
    .reset(R_array_index_arb_reset),
    .io_in_0_ready(R_array_index_arb_io_in_0_ready),
    .io_in_0_valid(R_array_index_arb_io_in_0_valid),
    .io_in_0_bits(R_array_index_arb_io_in_0_bits),
    .io_in_1_ready(R_array_index_arb_io_in_1_ready),
    .io_in_1_valid(R_array_index_arb_io_in_1_valid),
    .io_in_1_bits(R_array_index_arb_io_in_1_bits),
    .io_in_2_ready(R_array_index_arb_io_in_2_ready),
    .io_in_2_valid(R_array_index_arb_io_in_2_valid),
    .io_in_2_bits(R_array_index_arb_io_in_2_bits),
    .io_in_3_ready(R_array_index_arb_io_in_3_ready),
    .io_in_3_valid(R_array_index_arb_io_in_3_valid),
    .io_in_3_bits(R_array_index_arb_io_in_3_bits),
    .io_out_ready(R_array_index_arb_io_out_ready),
    .io_out_valid(R_array_index_arb_io_out_valid),
    .io_out_bits(R_array_index_arb_io_out_bits),
    .io_chosen(R_array_index_arb_io_chosen)
  );
  Queue_13 to_readAddr_queue ( // @[Decoupled.scala 296:21]
    .clock(to_readAddr_queue_clock),
    .reset(to_readAddr_queue_reset),
    .io_enq_ready(to_readAddr_queue_io_enq_ready),
    .io_enq_valid(to_readAddr_queue_io_enq_valid),
    .io_enq_bits_index(to_readAddr_queue_io_enq_bits_index),
    .io_enq_bits_burst_len(to_readAddr_queue_io_enq_bits_burst_len),
    .io_enq_bits_id(to_readAddr_queue_io_enq_bits_id),
    .io_deq_ready(to_readAddr_queue_io_deq_ready),
    .io_deq_valid(to_readAddr_queue_io_deq_valid),
    .io_deq_bits_index(to_readAddr_queue_io_deq_bits_index),
    .io_deq_bits_burst_len(to_readAddr_queue_io_deq_bits_burst_len),
    .io_deq_bits_id(to_readAddr_queue_io_deq_bits_id),
    .io_count(to_readAddr_queue_io_count)
  );
  assign io_R_array_index_0_ready = R_array_index_arb_io_in_0_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_1_ready = R_array_index_arb_io_in_1_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_2_ready = R_array_index_arb_io_in_2_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_R_array_index_3_ready = R_array_index_arb_io_in_3_ready; // @[Decoupled_Mem.scala 439:33]
  assign io_neighbour_cnt = {{1'd0}, _T_43}; // @[Decoupled_Mem.scala 408:22]
  assign io_mem_end = _T_56; // @[Decoupled_Mem.scala 426:16]
  assign io_neighbours_0_valid = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_0_bits = HBM_reader_io_interface_to_pe_readData_array_0_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_1_valid = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_1_bits = HBM_reader_io_interface_to_pe_readData_array_1_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_2_valid = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_2_bits = HBM_reader_io_interface_to_pe_readData_array_2_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_neighbours_3_valid = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 501:35]
  assign io_neighbours_3_bits = HBM_reader_io_interface_to_pe_readData_array_3_bits_data; // @[Decoupled_Mem.scala 404:31]
  assign io_uram_addr_a_0 = write_channel_io_uram_addr_a_0; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_1 = write_channel_io_uram_addr_a_1; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_2 = write_channel_io_uram_addr_a_2; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_uram_addr_a_3 = write_channel_io_uram_addr_a_3; // @[Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24 Decoupled_Mem.scala 343:24]
  assign io_write_finish = _T_3; // @[Decoupled_Mem.scala 357:44]
  assign io_HBM_interface_writeAddr_valid = HBM_reader_io_HBM_interface_writeAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_addr = HBM_reader_io_HBM_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_len = HBM_reader_io_HBM_interface_writeAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeAddr_bits_id = HBM_reader_io_HBM_interface_writeAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_valid = HBM_reader_io_HBM_interface_writeData_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_data = HBM_reader_io_HBM_interface_writeData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_strb = HBM_reader_io_HBM_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeData_bits_last = HBM_reader_io_HBM_interface_writeData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_writeResp_ready = HBM_reader_io_HBM_interface_writeResp_ready; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_valid = HBM_reader_io_HBM_interface_readAddr_valid; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_addr = HBM_reader_io_HBM_interface_readAddr_bits_addr; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_len = HBM_reader_io_HBM_interface_readAddr_bits_len; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readAddr_bits_id = HBM_reader_io_HBM_interface_readAddr_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign io_HBM_interface_readData_ready = HBM_reader_io_HBM_interface_readData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_clock = io_mem_clock;
  assign HBM_reader_reset = io_reset_h;
  assign HBM_reader_io_HBM_interface_writeAddr_ready = io_HBM_interface_writeAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeData_ready = io_HBM_interface_writeData_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_valid = io_HBM_interface_writeResp_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_id = io_HBM_interface_writeResp_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_writeResp_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readAddr_ready = io_HBM_interface_readAddr_ready; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_valid = io_HBM_interface_readData_valid; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_data = io_HBM_interface_readData_bits_data; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_id = io_HBM_interface_readData_bits_id; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_last = io_HBM_interface_readData_bits_last; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_HBM_interface_readData_bits_resp = io_HBM_interface_readData_bits_resp; // @[Decoupled_Mem.scala 374:33]
  assign HBM_reader_io_interface_to_pe_writeAddr_valid = write_channel_io_HBM_write_interface_writeAddr_valid; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_addr = write_channel_io_HBM_write_interface_writeAddr_bits_addr; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_len = 8'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeAddr_bits_id = 6'h0; // @[Decoupled_Mem.scala 352:52]
  assign HBM_reader_io_interface_to_pe_writeData_valid = write_channel_io_HBM_write_interface_writeData_valid; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_data = write_channel_io_HBM_write_interface_writeData_bits_data; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_strb = write_channel_io_HBM_write_interface_writeData_bits_strb; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeData_bits_last = 1'h1; // @[Decoupled_Mem.scala 353:52]
  assign HBM_reader_io_interface_to_pe_writeResp_ready = 1'h1; // @[Decoupled_Mem.scala 354:52]
  assign HBM_reader_io_interface_to_pe_readAddr_valid = to_readAddr_queue_io_deq_valid; // @[Decoupled_Mem.scala 470:50]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_addr = _T_68 + _GEN_19; // @[Decoupled_Mem.scala 466:54]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_len = to_readAddr_queue_io_deq_bits_burst_len; // @[Decoupled_Mem.scala 467:53]
  assign HBM_reader_io_interface_to_pe_readAddr_bits_id = {{4'd0}, to_readAddr_queue_io_deq_bits_id}; // @[Decoupled_Mem.scala 468:52]
  assign HBM_reader_io_interface_to_pe_readData_array_0_ready = HBM_reader_io_interface_to_pe_readData_array_0_valid & io_neighbours_0_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_1_ready = HBM_reader_io_interface_to_pe_readData_array_1_valid & io_neighbours_1_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_2_ready = HBM_reader_io_interface_to_pe_readData_array_2_valid & io_neighbours_2_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_array_3_ready = HBM_reader_io_interface_to_pe_readData_array_3_valid & io_neighbours_3_ready; // @[Decoupled_Mem.scala 509:66]
  assign HBM_reader_io_interface_to_pe_readData_offset_ready = read_neighbour_io_readData_ready & HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 507:57]
  assign HBM_reader_io_sysclock = clock; // @[Decoupled_Mem.scala 375:28]
  assign HBM_reader_io_src_valid = read_neighbour_io_src_q1_enq_valid; // @[Decoupled_Mem.scala 376:23]
  assign HBM_reader_io_src_bits = read_neighbour_io_src_q1_enq_bits; // @[Decoupled_Mem.scala 376:23]
  assign write_channel_clock = clock;
  assign write_channel_reset = reset;
  assign write_channel_io_level = _T; // @[Decoupled_Mem.scala 349:28]
  assign write_channel_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 350:30]
  assign write_channel_io_node_num = _T_4; // @[Decoupled_Mem.scala 358:35]
  assign write_channel_io_uram_out_a_0 = io_uram_out_a_0; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_1 = io_uram_out_a_1; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_2 = io_uram_out_a_2; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_uram_out_a_3 = io_uram_out_a_3; // @[Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23 Decoupled_Mem.scala 345:23]
  assign write_channel_io_kernel_count = _T_1; // @[Decoupled_Mem.scala 355:35]
  assign write_channel_io_master_finish = _T_2; // @[Decoupled_Mem.scala 356:36]
  assign write_channel_io_HBM_write_interface_writeAddr_ready = HBM_reader_io_interface_to_pe_writeAddr_ready; // @[Decoupled_Mem.scala 352:52]
  assign write_channel_io_HBM_write_interface_writeData_ready = HBM_reader_io_interface_to_pe_writeData_ready; // @[Decoupled_Mem.scala 353:52]
  assign write_channel_io_HBM_write_interface_writeResp_valid = HBM_reader_io_interface_to_pe_writeResp_valid; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_id = HBM_reader_io_interface_to_pe_writeResp_bits_id; // @[Decoupled_Mem.scala 354:52]
  assign write_channel_io_HBM_write_interface_writeResp_bits_resp = HBM_reader_io_interface_to_pe_writeResp_bits_resp; // @[Decoupled_Mem.scala 354:52]
  assign arb_clock = clock;
  assign arb_reset = reset;
  assign arb_io_in_0_valid = read_neighbour_io_to_arbiter_valid; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_index = read_neighbour_io_to_arbiter_bits_index; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_burst_len = read_neighbour_io_to_arbiter_bits_burst_len; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_0_bits_id = 2'h1; // @[Decoupled_Mem.scala 513:18]
  assign arb_io_in_1_valid = R_array_index_queue_io_deq_valid & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 456:24]
  assign arb_io_in_1_bits_index = _T_61 + _T_62; // @[Decoupled_Mem.scala 453:29]
  assign arb_io_in_1_bits_burst_len = 8'h0; // @[Decoupled_Mem.scala 454:33]
  assign arb_io_in_1_bits_id = 2'h0; // @[Decoupled_Mem.scala 455:26]
  assign arb_io_out_ready = to_readAddr_queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign R_array_index_queue_l1_clock = clock;
  assign R_array_index_queue_l1_reset = reset;
  assign R_array_index_queue_l1_io_enq_valid = R_array_index_arb_io_out_valid; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_enq_bits = R_array_index_arb_io_out_bits; // @[Decoupled_Mem.scala 444:30]
  assign R_array_index_queue_l1_io_deq_ready = R_array_index_queue_l2_io_enq_ready; // @[Decoupled_Mem.scala 449:43]
  assign R_array_index_queue_l2_clock = clock;
  assign R_array_index_queue_l2_reset = reset;
  assign R_array_index_queue_l2_io_enq_valid = ~_T_59; // @[Decoupled_Mem.scala 448:43]
  assign R_array_index_queue_l2_io_enq_bits = ~_T_57; // @[Decoupled_Mem.scala 447:42]
  assign R_array_index_queue_l2_io_deq_ready = R_array_index_queue_io_enq_ready; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_clock = clock;
  assign R_array_index_queue_reset = reset;
  assign R_array_index_queue_io_enq_valid = R_array_index_queue_l2_io_deq_valid; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_enq_bits = R_array_index_queue_l2_io_deq_bits; // @[Decoupled_Mem.scala 450:37]
  assign R_array_index_queue_io_deq_ready = arb_io_in_1_ready & src_index_queue0_io_enq_ready; // @[Decoupled_Mem.scala 460:38]
  assign src_index_queue0_clock = clock;
  assign src_index_queue0_reset = reset;
  assign src_index_queue0_io_enq_valid = R_array_index_queue_io_deq_valid & arb_io_in_1_ready; // @[Decoupled_Mem.scala 457:35]
  assign src_index_queue0_io_enq_bits = R_array_index_queue_io_deq_bits; // @[Decoupled_Mem.scala 458:34]
  assign src_index_queue0_io_deq_ready = read_neighbour_io_src_q0_deq_ready; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_clock = clock;
  assign read_neighbour_reset = reset;
  assign read_neighbour_io_readData_valid = HBM_reader_io_interface_to_pe_readData_offset_valid; // @[Decoupled_Mem.scala 478:60]
  assign read_neighbour_io_readData_bits_data = HBM_reader_io_interface_to_pe_readData_offset_bits_data; // @[Decoupled_Mem.scala 477:60]
  assign read_neighbour_io_offsets_CSR_R_offset = io_offsets_CSR_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSR_C_offset = io_offsets_CSR_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_R_offset = io_offsets_CSC_R_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_CSC_C_offset = io_offsets_CSC_C_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_offsets_level_offset = io_offsets_level_offset; // @[Decoupled_Mem.scala 516:16]
  assign read_neighbour_io_push_or_pull_state = io_push_or_pull_state; // @[Decoupled_Mem.scala 517:27]
  assign read_neighbour_io_to_arbiter_ready = arb_io_in_0_ready; // @[Decoupled_Mem.scala 513:18]
  assign read_neighbour_io_src_q0_deq_valid = src_index_queue0_io_deq_valid; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q0_deq_bits = src_index_queue0_io_deq_bits; // @[Decoupled_Mem.scala 473:29]
  assign read_neighbour_io_src_q1_enq_ready = HBM_reader_io_src_ready; // @[Decoupled_Mem.scala 376:23]
  assign R_array_index_arb_clock = clock;
  assign R_array_index_arb_reset = reset;
  assign R_array_index_arb_io_in_0_valid = io_R_array_index_0_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_0_bits = io_R_array_index_0_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_valid = io_R_array_index_1_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_1_bits = io_R_array_index_1_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_valid = io_R_array_index_2_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_2_bits = io_R_array_index_2_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_valid = io_R_array_index_3_valid; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_in_3_bits = io_R_array_index_3_bits; // @[Decoupled_Mem.scala 439:33]
  assign R_array_index_arb_io_out_ready = R_array_index_queue_l1_io_enq_ready; // @[Decoupled_Mem.scala 444:30]
  assign to_readAddr_queue_clock = clock;
  assign to_readAddr_queue_reset = reset;
  assign to_readAddr_queue_io_enq_valid = arb_io_out_valid; // @[Decoupled.scala 297:22]
  assign to_readAddr_queue_io_enq_bits_index = arb_io_out_bits_index; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_burst_len = arb_io_out_bits_burst_len; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_enq_bits_id = arb_io_out_bits_id; // @[Decoupled.scala 298:21]
  assign to_readAddr_queue_io_deq_ready = HBM_reader_io_interface_to_pe_readAddr_ready; // @[Decoupled_Mem.scala 469:50]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  count_val_i0 = _RAND_5[30:0];
  _RAND_6 = {1{`RANDOM}};
  count_val_i1 = _RAND_6[30:0];
  _RAND_7 = {1{`RANDOM}};
  count_val_n0 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_14 = _RAND_8[30:0];
  _RAND_9 = {1{`RANDOM}};
  _T_20 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  _T_26 = _RAND_10[30:0];
  _RAND_11 = {1{`RANDOM}};
  _T_32 = _RAND_11[30:0];
  _RAND_12 = {1{`RANDOM}};
  _T_43 = _RAND_12[30:0];
  _RAND_13 = {1{`RANDOM}};
  _T_56 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_level;
    _T_1 <= io_kernel_count;
    _T_2 <= io_master_finish;
    _T_3 <= write_channel_io_write_finish;
    _T_4 <= io_node_num;
    if (reset) begin
      count_val_i0 <= 31'h0;
    end else if (_T_5) begin
      if (_T_6) begin
        count_val_i0 <= 31'h0;
      end else begin
        count_val_i0 <= _T_8;
      end
    end
    if (reset) begin
      count_val_i1 <= 31'h0;
    end else if (_T_9) begin
      if (_T_10) begin
        count_val_i1 <= 31'h0;
      end else begin
        count_val_i1 <= _T_12;
      end
    end
    count_val_n0 <= read_neighbour_io_count_val_n0;
    if (reset) begin
      _T_14 <= 31'h0;
    end else if (_T_13) begin
      if (_T_16) begin
        _T_14 <= 31'h0;
      end else begin
        _T_14 <= _T_18;
      end
    end
    if (reset) begin
      _T_20 <= 31'h0;
    end else if (_T_19) begin
      if (_T_22) begin
        _T_20 <= 31'h0;
      end else begin
        _T_20 <= _T_24;
      end
    end
    if (reset) begin
      _T_26 <= 31'h0;
    end else if (_T_25) begin
      if (_T_28) begin
        _T_26 <= 31'h0;
      end else begin
        _T_26 <= _T_30;
      end
    end
    if (reset) begin
      _T_32 <= 31'h0;
    end else if (_T_31) begin
      if (_T_34) begin
        _T_32 <= 31'h0;
      end else begin
        _T_32 <= _T_36;
      end
    end
    _T_43 <= _T_40 + _T_32;
    _T_56 <= _T_53 & _T_54;
  end
endmodule
module copy(
  input         clock,
  input         reset,
  input  [31:0] io_in,
  output [31:0] io_out_0,
  output [31:0] io_out_1,
  output [31:0] io_out_2,
  output [31:0] io_out_3,
  output [31:0] io_out_4,
  output [31:0] io_out_5,
  output [31:0] io_out_6,
  output [31:0] io_out_7,
  output [31:0] io_out_8,
  output [31:0] io_out_9,
  output [31:0] io_out_10,
  output [31:0] io_out_11,
  output [31:0] io_out_12,
  output [31:0] io_out_13,
  output [31:0] io_out_14,
  output [31:0] io_out_15,
  output [31:0] io_out_16,
  output [31:0] io_out_17,
  output [31:0] io_out_18,
  output [31:0] io_out_19,
  output [31:0] io_out_20,
  output [31:0] io_out_21,
  output [31:0] io_out_22,
  output [31:0] io_out_23,
  output [31:0] io_out_24,
  output [31:0] io_out_25,
  output [31:0] io_out_26,
  output [31:0] io_out_27,
  output [31:0] io_out_28,
  output [31:0] io_out_29,
  output [31:0] io_out_30,
  output [31:0] io_out_31
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] out_reg_0; // @[master.scala 176:24]
  reg [31:0] out_reg_1; // @[master.scala 176:24]
  reg [31:0] out_reg_2; // @[master.scala 176:24]
  reg [31:0] out_reg_3; // @[master.scala 176:24]
  reg [31:0] out_reg_4; // @[master.scala 176:24]
  reg [31:0] out_reg_5; // @[master.scala 176:24]
  reg [31:0] out_reg_6; // @[master.scala 176:24]
  reg [31:0] out_reg_7; // @[master.scala 176:24]
  reg [31:0] out_reg_8; // @[master.scala 176:24]
  reg [31:0] out_reg_9; // @[master.scala 176:24]
  reg [31:0] out_reg_10; // @[master.scala 176:24]
  reg [31:0] out_reg_11; // @[master.scala 176:24]
  reg [31:0] out_reg_12; // @[master.scala 176:24]
  reg [31:0] out_reg_13; // @[master.scala 176:24]
  reg [31:0] out_reg_14; // @[master.scala 176:24]
  reg [31:0] out_reg_15; // @[master.scala 176:24]
  reg [31:0] out_reg_16; // @[master.scala 176:24]
  reg [31:0] out_reg_17; // @[master.scala 176:24]
  reg [31:0] out_reg_18; // @[master.scala 176:24]
  reg [31:0] out_reg_19; // @[master.scala 176:24]
  reg [31:0] out_reg_20; // @[master.scala 176:24]
  reg [31:0] out_reg_21; // @[master.scala 176:24]
  reg [31:0] out_reg_22; // @[master.scala 176:24]
  reg [31:0] out_reg_23; // @[master.scala 176:24]
  reg [31:0] out_reg_24; // @[master.scala 176:24]
  reg [31:0] out_reg_25; // @[master.scala 176:24]
  reg [31:0] out_reg_26; // @[master.scala 176:24]
  reg [31:0] out_reg_27; // @[master.scala 176:24]
  reg [31:0] out_reg_28; // @[master.scala 176:24]
  reg [31:0] out_reg_29; // @[master.scala 176:24]
  reg [31:0] out_reg_30; // @[master.scala 176:24]
  reg [31:0] out_reg_31; // @[master.scala 176:24]
  wire [31:0] _T_0 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_1 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_2 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_3 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_4 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_5 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_6 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_7 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_8 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_9 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_10 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_11 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_12 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_13 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_14 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_15 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_16 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_17 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_18 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_19 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_20 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_21 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_22 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_23 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_24 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_25 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_26 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_27 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_28 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_29 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_30 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  wire [31:0] _T_31 = 32'h0; // @[master.scala 176:32 master.scala 176:32]
  assign io_out_0 = out_reg_0; // @[master.scala 181:10]
  assign io_out_1 = out_reg_1; // @[master.scala 181:10]
  assign io_out_2 = out_reg_2; // @[master.scala 181:10]
  assign io_out_3 = out_reg_3; // @[master.scala 181:10]
  assign io_out_4 = out_reg_4; // @[master.scala 181:10]
  assign io_out_5 = out_reg_5; // @[master.scala 181:10]
  assign io_out_6 = out_reg_6; // @[master.scala 181:10]
  assign io_out_7 = out_reg_7; // @[master.scala 181:10]
  assign io_out_8 = out_reg_8; // @[master.scala 181:10]
  assign io_out_9 = out_reg_9; // @[master.scala 181:10]
  assign io_out_10 = out_reg_10; // @[master.scala 181:10]
  assign io_out_11 = out_reg_11; // @[master.scala 181:10]
  assign io_out_12 = out_reg_12; // @[master.scala 181:10]
  assign io_out_13 = out_reg_13; // @[master.scala 181:10]
  assign io_out_14 = out_reg_14; // @[master.scala 181:10]
  assign io_out_15 = out_reg_15; // @[master.scala 181:10]
  assign io_out_16 = out_reg_16; // @[master.scala 181:10]
  assign io_out_17 = out_reg_17; // @[master.scala 181:10]
  assign io_out_18 = out_reg_18; // @[master.scala 181:10]
  assign io_out_19 = out_reg_19; // @[master.scala 181:10]
  assign io_out_20 = out_reg_20; // @[master.scala 181:10]
  assign io_out_21 = out_reg_21; // @[master.scala 181:10]
  assign io_out_22 = out_reg_22; // @[master.scala 181:10]
  assign io_out_23 = out_reg_23; // @[master.scala 181:10]
  assign io_out_24 = out_reg_24; // @[master.scala 181:10]
  assign io_out_25 = out_reg_25; // @[master.scala 181:10]
  assign io_out_26 = out_reg_26; // @[master.scala 181:10]
  assign io_out_27 = out_reg_27; // @[master.scala 181:10]
  assign io_out_28 = out_reg_28; // @[master.scala 181:10]
  assign io_out_29 = out_reg_29; // @[master.scala 181:10]
  assign io_out_30 = out_reg_30; // @[master.scala 181:10]
  assign io_out_31 = out_reg_31; // @[master.scala 181:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[31:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  out_reg_14 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  out_reg_15 = _RAND_15[31:0];
  _RAND_16 = {1{`RANDOM}};
  out_reg_16 = _RAND_16[31:0];
  _RAND_17 = {1{`RANDOM}};
  out_reg_17 = _RAND_17[31:0];
  _RAND_18 = {1{`RANDOM}};
  out_reg_18 = _RAND_18[31:0];
  _RAND_19 = {1{`RANDOM}};
  out_reg_19 = _RAND_19[31:0];
  _RAND_20 = {1{`RANDOM}};
  out_reg_20 = _RAND_20[31:0];
  _RAND_21 = {1{`RANDOM}};
  out_reg_21 = _RAND_21[31:0];
  _RAND_22 = {1{`RANDOM}};
  out_reg_22 = _RAND_22[31:0];
  _RAND_23 = {1{`RANDOM}};
  out_reg_23 = _RAND_23[31:0];
  _RAND_24 = {1{`RANDOM}};
  out_reg_24 = _RAND_24[31:0];
  _RAND_25 = {1{`RANDOM}};
  out_reg_25 = _RAND_25[31:0];
  _RAND_26 = {1{`RANDOM}};
  out_reg_26 = _RAND_26[31:0];
  _RAND_27 = {1{`RANDOM}};
  out_reg_27 = _RAND_27[31:0];
  _RAND_28 = {1{`RANDOM}};
  out_reg_28 = _RAND_28[31:0];
  _RAND_29 = {1{`RANDOM}};
  out_reg_29 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  out_reg_30 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  out_reg_31 = _RAND_31[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 32'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 32'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 32'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 32'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 32'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 32'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 32'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 32'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 32'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 32'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 32'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 32'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 32'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 32'h0;
    end else begin
      out_reg_13 <= io_in;
    end
    if (reset) begin
      out_reg_14 <= 32'h0;
    end else begin
      out_reg_14 <= io_in;
    end
    if (reset) begin
      out_reg_15 <= 32'h0;
    end else begin
      out_reg_15 <= io_in;
    end
    if (reset) begin
      out_reg_16 <= 32'h0;
    end else begin
      out_reg_16 <= io_in;
    end
    if (reset) begin
      out_reg_17 <= 32'h0;
    end else begin
      out_reg_17 <= io_in;
    end
    if (reset) begin
      out_reg_18 <= 32'h0;
    end else begin
      out_reg_18 <= io_in;
    end
    if (reset) begin
      out_reg_19 <= 32'h0;
    end else begin
      out_reg_19 <= io_in;
    end
    if (reset) begin
      out_reg_20 <= 32'h0;
    end else begin
      out_reg_20 <= io_in;
    end
    if (reset) begin
      out_reg_21 <= 32'h0;
    end else begin
      out_reg_21 <= io_in;
    end
    if (reset) begin
      out_reg_22 <= 32'h0;
    end else begin
      out_reg_22 <= io_in;
    end
    if (reset) begin
      out_reg_23 <= 32'h0;
    end else begin
      out_reg_23 <= io_in;
    end
    if (reset) begin
      out_reg_24 <= 32'h0;
    end else begin
      out_reg_24 <= io_in;
    end
    if (reset) begin
      out_reg_25 <= 32'h0;
    end else begin
      out_reg_25 <= io_in;
    end
    if (reset) begin
      out_reg_26 <= 32'h0;
    end else begin
      out_reg_26 <= io_in;
    end
    if (reset) begin
      out_reg_27 <= 32'h0;
    end else begin
      out_reg_27 <= io_in;
    end
    if (reset) begin
      out_reg_28 <= 32'h0;
    end else begin
      out_reg_28 <= io_in;
    end
    if (reset) begin
      out_reg_29 <= 32'h0;
    end else begin
      out_reg_29 <= io_in;
    end
    if (reset) begin
      out_reg_30 <= 32'h0;
    end else begin
      out_reg_30 <= io_in;
    end
    if (reset) begin
      out_reg_31 <= 32'h0;
    end else begin
      out_reg_31 <= io_in;
    end
  end
endmodule
module copy_2(
  input   clock,
  input   reset,
  input   io_in,
  output  io_out_0,
  output  io_out_1,
  output  io_out_2,
  output  io_out_3,
  output  io_out_4,
  output  io_out_5,
  output  io_out_6,
  output  io_out_7,
  output  io_out_8,
  output  io_out_9,
  output  io_out_10,
  output  io_out_11,
  output  io_out_12,
  output  io_out_13,
  output  io_out_14,
  output  io_out_15,
  output  io_out_16,
  output  io_out_17,
  output  io_out_18,
  output  io_out_19,
  output  io_out_20,
  output  io_out_21,
  output  io_out_22,
  output  io_out_23,
  output  io_out_24,
  output  io_out_25,
  output  io_out_26,
  output  io_out_27,
  output  io_out_28,
  output  io_out_29,
  output  io_out_30,
  output  io_out_31
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
`endif // RANDOMIZE_REG_INIT
  reg  out_reg_0; // @[master.scala 176:24]
  reg  out_reg_1; // @[master.scala 176:24]
  reg  out_reg_2; // @[master.scala 176:24]
  reg  out_reg_3; // @[master.scala 176:24]
  reg  out_reg_4; // @[master.scala 176:24]
  reg  out_reg_5; // @[master.scala 176:24]
  reg  out_reg_6; // @[master.scala 176:24]
  reg  out_reg_7; // @[master.scala 176:24]
  reg  out_reg_8; // @[master.scala 176:24]
  reg  out_reg_9; // @[master.scala 176:24]
  reg  out_reg_10; // @[master.scala 176:24]
  reg  out_reg_11; // @[master.scala 176:24]
  reg  out_reg_12; // @[master.scala 176:24]
  reg  out_reg_13; // @[master.scala 176:24]
  reg  out_reg_14; // @[master.scala 176:24]
  reg  out_reg_15; // @[master.scala 176:24]
  reg  out_reg_16; // @[master.scala 176:24]
  reg  out_reg_17; // @[master.scala 176:24]
  reg  out_reg_18; // @[master.scala 176:24]
  reg  out_reg_19; // @[master.scala 176:24]
  reg  out_reg_20; // @[master.scala 176:24]
  reg  out_reg_21; // @[master.scala 176:24]
  reg  out_reg_22; // @[master.scala 176:24]
  reg  out_reg_23; // @[master.scala 176:24]
  reg  out_reg_24; // @[master.scala 176:24]
  reg  out_reg_25; // @[master.scala 176:24]
  reg  out_reg_26; // @[master.scala 176:24]
  reg  out_reg_27; // @[master.scala 176:24]
  reg  out_reg_28; // @[master.scala 176:24]
  reg  out_reg_29; // @[master.scala 176:24]
  reg  out_reg_30; // @[master.scala 176:24]
  reg  out_reg_31; // @[master.scala 176:24]
  wire  _T_0 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_1 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_2 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_3 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_4 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_5 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_6 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_7 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_8 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_9 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_10 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_11 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_12 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_13 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_14 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_15 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_16 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_17 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_18 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_19 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_20 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_21 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_22 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_23 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_24 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_25 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_26 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_27 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_28 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_29 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_30 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  wire  _T_31 = 1'h0; // @[master.scala 176:32 master.scala 176:32]
  assign io_out_0 = out_reg_0; // @[master.scala 181:10]
  assign io_out_1 = out_reg_1; // @[master.scala 181:10]
  assign io_out_2 = out_reg_2; // @[master.scala 181:10]
  assign io_out_3 = out_reg_3; // @[master.scala 181:10]
  assign io_out_4 = out_reg_4; // @[master.scala 181:10]
  assign io_out_5 = out_reg_5; // @[master.scala 181:10]
  assign io_out_6 = out_reg_6; // @[master.scala 181:10]
  assign io_out_7 = out_reg_7; // @[master.scala 181:10]
  assign io_out_8 = out_reg_8; // @[master.scala 181:10]
  assign io_out_9 = out_reg_9; // @[master.scala 181:10]
  assign io_out_10 = out_reg_10; // @[master.scala 181:10]
  assign io_out_11 = out_reg_11; // @[master.scala 181:10]
  assign io_out_12 = out_reg_12; // @[master.scala 181:10]
  assign io_out_13 = out_reg_13; // @[master.scala 181:10]
  assign io_out_14 = out_reg_14; // @[master.scala 181:10]
  assign io_out_15 = out_reg_15; // @[master.scala 181:10]
  assign io_out_16 = out_reg_16; // @[master.scala 181:10]
  assign io_out_17 = out_reg_17; // @[master.scala 181:10]
  assign io_out_18 = out_reg_18; // @[master.scala 181:10]
  assign io_out_19 = out_reg_19; // @[master.scala 181:10]
  assign io_out_20 = out_reg_20; // @[master.scala 181:10]
  assign io_out_21 = out_reg_21; // @[master.scala 181:10]
  assign io_out_22 = out_reg_22; // @[master.scala 181:10]
  assign io_out_23 = out_reg_23; // @[master.scala 181:10]
  assign io_out_24 = out_reg_24; // @[master.scala 181:10]
  assign io_out_25 = out_reg_25; // @[master.scala 181:10]
  assign io_out_26 = out_reg_26; // @[master.scala 181:10]
  assign io_out_27 = out_reg_27; // @[master.scala 181:10]
  assign io_out_28 = out_reg_28; // @[master.scala 181:10]
  assign io_out_29 = out_reg_29; // @[master.scala 181:10]
  assign io_out_30 = out_reg_30; // @[master.scala 181:10]
  assign io_out_31 = out_reg_31; // @[master.scala 181:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  out_reg_14 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  out_reg_15 = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  out_reg_16 = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  out_reg_17 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  out_reg_18 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  out_reg_19 = _RAND_19[0:0];
  _RAND_20 = {1{`RANDOM}};
  out_reg_20 = _RAND_20[0:0];
  _RAND_21 = {1{`RANDOM}};
  out_reg_21 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  out_reg_22 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  out_reg_23 = _RAND_23[0:0];
  _RAND_24 = {1{`RANDOM}};
  out_reg_24 = _RAND_24[0:0];
  _RAND_25 = {1{`RANDOM}};
  out_reg_25 = _RAND_25[0:0];
  _RAND_26 = {1{`RANDOM}};
  out_reg_26 = _RAND_26[0:0];
  _RAND_27 = {1{`RANDOM}};
  out_reg_27 = _RAND_27[0:0];
  _RAND_28 = {1{`RANDOM}};
  out_reg_28 = _RAND_28[0:0];
  _RAND_29 = {1{`RANDOM}};
  out_reg_29 = _RAND_29[0:0];
  _RAND_30 = {1{`RANDOM}};
  out_reg_30 = _RAND_30[0:0];
  _RAND_31 = {1{`RANDOM}};
  out_reg_31 = _RAND_31[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 1'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 1'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 1'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 1'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 1'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 1'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 1'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 1'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 1'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 1'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 1'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 1'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 1'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 1'h0;
    end else begin
      out_reg_13 <= io_in;
    end
    if (reset) begin
      out_reg_14 <= 1'h0;
    end else begin
      out_reg_14 <= io_in;
    end
    if (reset) begin
      out_reg_15 <= 1'h0;
    end else begin
      out_reg_15 <= io_in;
    end
    if (reset) begin
      out_reg_16 <= 1'h0;
    end else begin
      out_reg_16 <= io_in;
    end
    if (reset) begin
      out_reg_17 <= 1'h0;
    end else begin
      out_reg_17 <= io_in;
    end
    if (reset) begin
      out_reg_18 <= 1'h0;
    end else begin
      out_reg_18 <= io_in;
    end
    if (reset) begin
      out_reg_19 <= 1'h0;
    end else begin
      out_reg_19 <= io_in;
    end
    if (reset) begin
      out_reg_20 <= 1'h0;
    end else begin
      out_reg_20 <= io_in;
    end
    if (reset) begin
      out_reg_21 <= 1'h0;
    end else begin
      out_reg_21 <= io_in;
    end
    if (reset) begin
      out_reg_22 <= 1'h0;
    end else begin
      out_reg_22 <= io_in;
    end
    if (reset) begin
      out_reg_23 <= 1'h0;
    end else begin
      out_reg_23 <= io_in;
    end
    if (reset) begin
      out_reg_24 <= 1'h0;
    end else begin
      out_reg_24 <= io_in;
    end
    if (reset) begin
      out_reg_25 <= 1'h0;
    end else begin
      out_reg_25 <= io_in;
    end
    if (reset) begin
      out_reg_26 <= 1'h0;
    end else begin
      out_reg_26 <= io_in;
    end
    if (reset) begin
      out_reg_27 <= 1'h0;
    end else begin
      out_reg_27 <= io_in;
    end
    if (reset) begin
      out_reg_28 <= 1'h0;
    end else begin
      out_reg_28 <= io_in;
    end
    if (reset) begin
      out_reg_29 <= 1'h0;
    end else begin
      out_reg_29 <= io_in;
    end
    if (reset) begin
      out_reg_30 <= 1'h0;
    end else begin
      out_reg_30 <= io_in;
    end
    if (reset) begin
      out_reg_31 <= 1'h0;
    end else begin
      out_reg_31 <= io_in;
    end
  end
endmodule
module SLR0_Mem(
  input          clock,
  input          reset,
  input  [31:0]  io_level,
  input  [31:0]  io_kernel_count,
  input          io_mem_clock,
  input          io_reset_h,
  input          io_master_finish,
  input  [31:0]  io_node_num,
  input          io_push_or_pull_state,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  output         io_R_array_index_0_ready,
  input          io_R_array_index_0_valid,
  input  [31:0]  io_R_array_index_0_bits,
  output         io_R_array_index_1_ready,
  input          io_R_array_index_1_valid,
  input  [31:0]  io_R_array_index_1_bits,
  output         io_R_array_index_2_ready,
  input          io_R_array_index_2_valid,
  input  [31:0]  io_R_array_index_2_bits,
  output         io_R_array_index_3_ready,
  input          io_R_array_index_3_valid,
  input  [31:0]  io_R_array_index_3_bits,
  output         io_R_array_index_4_ready,
  input          io_R_array_index_4_valid,
  input  [31:0]  io_R_array_index_4_bits,
  output         io_R_array_index_5_ready,
  input          io_R_array_index_5_valid,
  input  [31:0]  io_R_array_index_5_bits,
  output         io_R_array_index_6_ready,
  input          io_R_array_index_6_valid,
  input  [31:0]  io_R_array_index_6_bits,
  output         io_R_array_index_7_ready,
  input          io_R_array_index_7_valid,
  input  [31:0]  io_R_array_index_7_bits,
  output         io_R_array_index_8_ready,
  input          io_R_array_index_8_valid,
  input  [31:0]  io_R_array_index_8_bits,
  output         io_R_array_index_9_ready,
  input          io_R_array_index_9_valid,
  input  [31:0]  io_R_array_index_9_bits,
  output         io_R_array_index_10_ready,
  input          io_R_array_index_10_valid,
  input  [31:0]  io_R_array_index_10_bits,
  output         io_R_array_index_11_ready,
  input          io_R_array_index_11_valid,
  input  [31:0]  io_R_array_index_11_bits,
  output         io_R_array_index_12_ready,
  input          io_R_array_index_12_valid,
  input  [31:0]  io_R_array_index_12_bits,
  output         io_R_array_index_13_ready,
  input          io_R_array_index_13_valid,
  input  [31:0]  io_R_array_index_13_bits,
  output         io_R_array_index_14_ready,
  input          io_R_array_index_14_valid,
  input  [31:0]  io_R_array_index_14_bits,
  output         io_R_array_index_15_ready,
  input          io_R_array_index_15_valid,
  input  [31:0]  io_R_array_index_15_bits,
  output         io_R_array_index_16_ready,
  input          io_R_array_index_16_valid,
  input  [31:0]  io_R_array_index_16_bits,
  output         io_R_array_index_17_ready,
  input          io_R_array_index_17_valid,
  input  [31:0]  io_R_array_index_17_bits,
  output         io_R_array_index_18_ready,
  input          io_R_array_index_18_valid,
  input  [31:0]  io_R_array_index_18_bits,
  output         io_R_array_index_19_ready,
  input          io_R_array_index_19_valid,
  input  [31:0]  io_R_array_index_19_bits,
  output         io_R_array_index_20_ready,
  input          io_R_array_index_20_valid,
  input  [31:0]  io_R_array_index_20_bits,
  output         io_R_array_index_21_ready,
  input          io_R_array_index_21_valid,
  input  [31:0]  io_R_array_index_21_bits,
  output         io_R_array_index_22_ready,
  input          io_R_array_index_22_valid,
  input  [31:0]  io_R_array_index_22_bits,
  output         io_R_array_index_23_ready,
  input          io_R_array_index_23_valid,
  input  [31:0]  io_R_array_index_23_bits,
  output         io_R_array_index_24_ready,
  input          io_R_array_index_24_valid,
  input  [31:0]  io_R_array_index_24_bits,
  output         io_R_array_index_25_ready,
  input          io_R_array_index_25_valid,
  input  [31:0]  io_R_array_index_25_bits,
  output         io_R_array_index_26_ready,
  input          io_R_array_index_26_valid,
  input  [31:0]  io_R_array_index_26_bits,
  output         io_R_array_index_27_ready,
  input          io_R_array_index_27_valid,
  input  [31:0]  io_R_array_index_27_bits,
  output         io_R_array_index_28_ready,
  input          io_R_array_index_28_valid,
  input  [31:0]  io_R_array_index_28_bits,
  output         io_R_array_index_29_ready,
  input          io_R_array_index_29_valid,
  input  [31:0]  io_R_array_index_29_bits,
  output         io_R_array_index_30_ready,
  input          io_R_array_index_30_valid,
  input  [31:0]  io_R_array_index_30_bits,
  output         io_R_array_index_31_ready,
  input          io_R_array_index_31_valid,
  input  [31:0]  io_R_array_index_31_bits,
  output         io_R_array_index_32_ready,
  input          io_R_array_index_32_valid,
  input  [31:0]  io_R_array_index_32_bits,
  output         io_R_array_index_33_ready,
  input          io_R_array_index_33_valid,
  input  [31:0]  io_R_array_index_33_bits,
  output         io_R_array_index_34_ready,
  input          io_R_array_index_34_valid,
  input  [31:0]  io_R_array_index_34_bits,
  output         io_R_array_index_35_ready,
  input          io_R_array_index_35_valid,
  input  [31:0]  io_R_array_index_35_bits,
  output         io_R_array_index_36_ready,
  input          io_R_array_index_36_valid,
  input  [31:0]  io_R_array_index_36_bits,
  output         io_R_array_index_37_ready,
  input          io_R_array_index_37_valid,
  input  [31:0]  io_R_array_index_37_bits,
  output         io_R_array_index_38_ready,
  input          io_R_array_index_38_valid,
  input  [31:0]  io_R_array_index_38_bits,
  output         io_R_array_index_39_ready,
  input          io_R_array_index_39_valid,
  input  [31:0]  io_R_array_index_39_bits,
  output         io_R_array_index_40_ready,
  input          io_R_array_index_40_valid,
  input  [31:0]  io_R_array_index_40_bits,
  output         io_R_array_index_41_ready,
  input          io_R_array_index_41_valid,
  input  [31:0]  io_R_array_index_41_bits,
  output         io_R_array_index_42_ready,
  input          io_R_array_index_42_valid,
  input  [31:0]  io_R_array_index_42_bits,
  output         io_R_array_index_43_ready,
  input          io_R_array_index_43_valid,
  input  [31:0]  io_R_array_index_43_bits,
  output         io_R_array_index_44_ready,
  input          io_R_array_index_44_valid,
  input  [31:0]  io_R_array_index_44_bits,
  output         io_R_array_index_45_ready,
  input          io_R_array_index_45_valid,
  input  [31:0]  io_R_array_index_45_bits,
  output         io_R_array_index_46_ready,
  input          io_R_array_index_46_valid,
  input  [31:0]  io_R_array_index_46_bits,
  output         io_R_array_index_47_ready,
  input          io_R_array_index_47_valid,
  input  [31:0]  io_R_array_index_47_bits,
  output         io_R_array_index_48_ready,
  input          io_R_array_index_48_valid,
  input  [31:0]  io_R_array_index_48_bits,
  output         io_R_array_index_49_ready,
  input          io_R_array_index_49_valid,
  input  [31:0]  io_R_array_index_49_bits,
  output         io_R_array_index_50_ready,
  input          io_R_array_index_50_valid,
  input  [31:0]  io_R_array_index_50_bits,
  output         io_R_array_index_51_ready,
  input          io_R_array_index_51_valid,
  input  [31:0]  io_R_array_index_51_bits,
  output         io_R_array_index_52_ready,
  input          io_R_array_index_52_valid,
  input  [31:0]  io_R_array_index_52_bits,
  output         io_R_array_index_53_ready,
  input          io_R_array_index_53_valid,
  input  [31:0]  io_R_array_index_53_bits,
  output         io_R_array_index_54_ready,
  input          io_R_array_index_54_valid,
  input  [31:0]  io_R_array_index_54_bits,
  output         io_R_array_index_55_ready,
  input          io_R_array_index_55_valid,
  input  [31:0]  io_R_array_index_55_bits,
  output         io_R_array_index_56_ready,
  input          io_R_array_index_56_valid,
  input  [31:0]  io_R_array_index_56_bits,
  output         io_R_array_index_57_ready,
  input          io_R_array_index_57_valid,
  input  [31:0]  io_R_array_index_57_bits,
  output         io_R_array_index_58_ready,
  input          io_R_array_index_58_valid,
  input  [31:0]  io_R_array_index_58_bits,
  output         io_R_array_index_59_ready,
  input          io_R_array_index_59_valid,
  input  [31:0]  io_R_array_index_59_bits,
  output         io_R_array_index_60_ready,
  input          io_R_array_index_60_valid,
  input  [31:0]  io_R_array_index_60_bits,
  output         io_R_array_index_61_ready,
  input          io_R_array_index_61_valid,
  input  [31:0]  io_R_array_index_61_bits,
  output         io_R_array_index_62_ready,
  input          io_R_array_index_62_valid,
  input  [31:0]  io_R_array_index_62_bits,
  output         io_R_array_index_63_ready,
  input          io_R_array_index_63_valid,
  input  [31:0]  io_R_array_index_63_bits,
  output         io_R_array_index_64_ready,
  input          io_R_array_index_64_valid,
  input  [31:0]  io_R_array_index_64_bits,
  output         io_R_array_index_65_ready,
  input          io_R_array_index_65_valid,
  input  [31:0]  io_R_array_index_65_bits,
  output         io_R_array_index_66_ready,
  input          io_R_array_index_66_valid,
  input  [31:0]  io_R_array_index_66_bits,
  output         io_R_array_index_67_ready,
  input          io_R_array_index_67_valid,
  input  [31:0]  io_R_array_index_67_bits,
  output         io_R_array_index_68_ready,
  input          io_R_array_index_68_valid,
  input  [31:0]  io_R_array_index_68_bits,
  output         io_R_array_index_69_ready,
  input          io_R_array_index_69_valid,
  input  [31:0]  io_R_array_index_69_bits,
  output         io_R_array_index_70_ready,
  input          io_R_array_index_70_valid,
  input  [31:0]  io_R_array_index_70_bits,
  output         io_R_array_index_71_ready,
  input          io_R_array_index_71_valid,
  input  [31:0]  io_R_array_index_71_bits,
  output         io_R_array_index_72_ready,
  input          io_R_array_index_72_valid,
  input  [31:0]  io_R_array_index_72_bits,
  output         io_R_array_index_73_ready,
  input          io_R_array_index_73_valid,
  input  [31:0]  io_R_array_index_73_bits,
  output         io_R_array_index_74_ready,
  input          io_R_array_index_74_valid,
  input  [31:0]  io_R_array_index_74_bits,
  output         io_R_array_index_75_ready,
  input          io_R_array_index_75_valid,
  input  [31:0]  io_R_array_index_75_bits,
  output         io_R_array_index_76_ready,
  input          io_R_array_index_76_valid,
  input  [31:0]  io_R_array_index_76_bits,
  output         io_R_array_index_77_ready,
  input          io_R_array_index_77_valid,
  input  [31:0]  io_R_array_index_77_bits,
  output         io_R_array_index_78_ready,
  input          io_R_array_index_78_valid,
  input  [31:0]  io_R_array_index_78_bits,
  output         io_R_array_index_79_ready,
  input          io_R_array_index_79_valid,
  input  [31:0]  io_R_array_index_79_bits,
  output         io_R_array_index_80_ready,
  input          io_R_array_index_80_valid,
  input  [31:0]  io_R_array_index_80_bits,
  output         io_R_array_index_81_ready,
  input          io_R_array_index_81_valid,
  input  [31:0]  io_R_array_index_81_bits,
  output         io_R_array_index_82_ready,
  input          io_R_array_index_82_valid,
  input  [31:0]  io_R_array_index_82_bits,
  output         io_R_array_index_83_ready,
  input          io_R_array_index_83_valid,
  input  [31:0]  io_R_array_index_83_bits,
  output         io_R_array_index_84_ready,
  input          io_R_array_index_84_valid,
  input  [31:0]  io_R_array_index_84_bits,
  output         io_R_array_index_85_ready,
  input          io_R_array_index_85_valid,
  input  [31:0]  io_R_array_index_85_bits,
  output         io_R_array_index_86_ready,
  input          io_R_array_index_86_valid,
  input  [31:0]  io_R_array_index_86_bits,
  output         io_R_array_index_87_ready,
  input          io_R_array_index_87_valid,
  input  [31:0]  io_R_array_index_87_bits,
  output         io_R_array_index_88_ready,
  input          io_R_array_index_88_valid,
  input  [31:0]  io_R_array_index_88_bits,
  output         io_R_array_index_89_ready,
  input          io_R_array_index_89_valid,
  input  [31:0]  io_R_array_index_89_bits,
  output         io_R_array_index_90_ready,
  input          io_R_array_index_90_valid,
  input  [31:0]  io_R_array_index_90_bits,
  output         io_R_array_index_91_ready,
  input          io_R_array_index_91_valid,
  input  [31:0]  io_R_array_index_91_bits,
  output         io_R_array_index_92_ready,
  input          io_R_array_index_92_valid,
  input  [31:0]  io_R_array_index_92_bits,
  output         io_R_array_index_93_ready,
  input          io_R_array_index_93_valid,
  input  [31:0]  io_R_array_index_93_bits,
  output         io_R_array_index_94_ready,
  input          io_R_array_index_94_valid,
  input  [31:0]  io_R_array_index_94_bits,
  output         io_R_array_index_95_ready,
  input          io_R_array_index_95_valid,
  input  [31:0]  io_R_array_index_95_bits,
  output         io_R_array_index_96_ready,
  input          io_R_array_index_96_valid,
  input  [31:0]  io_R_array_index_96_bits,
  output         io_R_array_index_97_ready,
  input          io_R_array_index_97_valid,
  input  [31:0]  io_R_array_index_97_bits,
  output         io_R_array_index_98_ready,
  input          io_R_array_index_98_valid,
  input  [31:0]  io_R_array_index_98_bits,
  output         io_R_array_index_99_ready,
  input          io_R_array_index_99_valid,
  input  [31:0]  io_R_array_index_99_bits,
  output         io_R_array_index_100_ready,
  input          io_R_array_index_100_valid,
  input  [31:0]  io_R_array_index_100_bits,
  output         io_R_array_index_101_ready,
  input          io_R_array_index_101_valid,
  input  [31:0]  io_R_array_index_101_bits,
  output         io_R_array_index_102_ready,
  input          io_R_array_index_102_valid,
  input  [31:0]  io_R_array_index_102_bits,
  output         io_R_array_index_103_ready,
  input          io_R_array_index_103_valid,
  input  [31:0]  io_R_array_index_103_bits,
  output         io_R_array_index_104_ready,
  input          io_R_array_index_104_valid,
  input  [31:0]  io_R_array_index_104_bits,
  output         io_R_array_index_105_ready,
  input          io_R_array_index_105_valid,
  input  [31:0]  io_R_array_index_105_bits,
  output         io_R_array_index_106_ready,
  input          io_R_array_index_106_valid,
  input  [31:0]  io_R_array_index_106_bits,
  output         io_R_array_index_107_ready,
  input          io_R_array_index_107_valid,
  input  [31:0]  io_R_array_index_107_bits,
  output         io_R_array_index_108_ready,
  input          io_R_array_index_108_valid,
  input  [31:0]  io_R_array_index_108_bits,
  output         io_R_array_index_109_ready,
  input          io_R_array_index_109_valid,
  input  [31:0]  io_R_array_index_109_bits,
  output         io_R_array_index_110_ready,
  input          io_R_array_index_110_valid,
  input  [31:0]  io_R_array_index_110_bits,
  output         io_R_array_index_111_ready,
  input          io_R_array_index_111_valid,
  input  [31:0]  io_R_array_index_111_bits,
  output         io_R_array_index_112_ready,
  input          io_R_array_index_112_valid,
  input  [31:0]  io_R_array_index_112_bits,
  output         io_R_array_index_113_ready,
  input          io_R_array_index_113_valid,
  input  [31:0]  io_R_array_index_113_bits,
  output         io_R_array_index_114_ready,
  input          io_R_array_index_114_valid,
  input  [31:0]  io_R_array_index_114_bits,
  output         io_R_array_index_115_ready,
  input          io_R_array_index_115_valid,
  input  [31:0]  io_R_array_index_115_bits,
  output         io_R_array_index_116_ready,
  input          io_R_array_index_116_valid,
  input  [31:0]  io_R_array_index_116_bits,
  output         io_R_array_index_117_ready,
  input          io_R_array_index_117_valid,
  input  [31:0]  io_R_array_index_117_bits,
  output         io_R_array_index_118_ready,
  input          io_R_array_index_118_valid,
  input  [31:0]  io_R_array_index_118_bits,
  output         io_R_array_index_119_ready,
  input          io_R_array_index_119_valid,
  input  [31:0]  io_R_array_index_119_bits,
  output         io_R_array_index_120_ready,
  input          io_R_array_index_120_valid,
  input  [31:0]  io_R_array_index_120_bits,
  output         io_R_array_index_121_ready,
  input          io_R_array_index_121_valid,
  input  [31:0]  io_R_array_index_121_bits,
  output         io_R_array_index_122_ready,
  input          io_R_array_index_122_valid,
  input  [31:0]  io_R_array_index_122_bits,
  output         io_R_array_index_123_ready,
  input          io_R_array_index_123_valid,
  input  [31:0]  io_R_array_index_123_bits,
  output         io_R_array_index_124_ready,
  input          io_R_array_index_124_valid,
  input  [31:0]  io_R_array_index_124_bits,
  output         io_R_array_index_125_ready,
  input          io_R_array_index_125_valid,
  input  [31:0]  io_R_array_index_125_bits,
  output         io_R_array_index_126_ready,
  input          io_R_array_index_126_valid,
  input  [31:0]  io_R_array_index_126_bits,
  output         io_R_array_index_127_ready,
  input          io_R_array_index_127_valid,
  input  [31:0]  io_R_array_index_127_bits,
  input          io_p1_end_0,
  input          io_p1_end_1,
  input          io_p1_end_2,
  input          io_p1_end_3,
  input          io_p1_end_4,
  input          io_p1_end_5,
  input          io_p1_end_6,
  input          io_p1_end_7,
  input          io_p1_end_8,
  input          io_p1_end_9,
  input          io_p1_end_10,
  input          io_p1_end_11,
  input          io_p1_end_12,
  input          io_p1_end_13,
  input          io_p1_end_14,
  input          io_p1_end_15,
  input          io_p1_end_16,
  input          io_p1_end_17,
  input          io_p1_end_18,
  input          io_p1_end_19,
  input          io_p1_end_20,
  input          io_p1_end_21,
  input          io_p1_end_22,
  input          io_p1_end_23,
  input          io_p1_end_24,
  input          io_p1_end_25,
  input          io_p1_end_26,
  input          io_p1_end_27,
  input          io_p1_end_28,
  input          io_p1_end_29,
  input          io_p1_end_30,
  input          io_p1_end_31,
  input  [63:0]  io_uram_out_a_0,
  input  [63:0]  io_uram_out_a_1,
  input  [63:0]  io_uram_out_a_2,
  input  [63:0]  io_uram_out_a_3,
  input  [63:0]  io_uram_out_a_4,
  input  [63:0]  io_uram_out_a_5,
  input  [63:0]  io_uram_out_a_6,
  input  [63:0]  io_uram_out_a_7,
  input  [63:0]  io_uram_out_a_8,
  input  [63:0]  io_uram_out_a_9,
  input  [63:0]  io_uram_out_a_10,
  input  [63:0]  io_uram_out_a_11,
  input  [63:0]  io_uram_out_a_12,
  input  [63:0]  io_uram_out_a_13,
  input  [63:0]  io_uram_out_a_14,
  input  [63:0]  io_uram_out_a_15,
  input  [63:0]  io_uram_out_a_16,
  input  [63:0]  io_uram_out_a_17,
  input  [63:0]  io_uram_out_a_18,
  input  [63:0]  io_uram_out_a_19,
  input  [63:0]  io_uram_out_a_20,
  input  [63:0]  io_uram_out_a_21,
  input  [63:0]  io_uram_out_a_22,
  input  [63:0]  io_uram_out_a_23,
  input  [63:0]  io_uram_out_a_24,
  input  [63:0]  io_uram_out_a_25,
  input  [63:0]  io_uram_out_a_26,
  input  [63:0]  io_uram_out_a_27,
  input  [63:0]  io_uram_out_a_28,
  input  [63:0]  io_uram_out_a_29,
  input  [63:0]  io_uram_out_a_30,
  input  [63:0]  io_uram_out_a_31,
  input  [63:0]  io_uram_out_a_32,
  input  [63:0]  io_uram_out_a_33,
  input  [63:0]  io_uram_out_a_34,
  input  [63:0]  io_uram_out_a_35,
  input  [63:0]  io_uram_out_a_36,
  input  [63:0]  io_uram_out_a_37,
  input  [63:0]  io_uram_out_a_38,
  input  [63:0]  io_uram_out_a_39,
  input  [63:0]  io_uram_out_a_40,
  input  [63:0]  io_uram_out_a_41,
  input  [63:0]  io_uram_out_a_42,
  input  [63:0]  io_uram_out_a_43,
  input  [63:0]  io_uram_out_a_44,
  input  [63:0]  io_uram_out_a_45,
  input  [63:0]  io_uram_out_a_46,
  input  [63:0]  io_uram_out_a_47,
  input  [63:0]  io_uram_out_a_48,
  input  [63:0]  io_uram_out_a_49,
  input  [63:0]  io_uram_out_a_50,
  input  [63:0]  io_uram_out_a_51,
  input  [63:0]  io_uram_out_a_52,
  input  [63:0]  io_uram_out_a_53,
  input  [63:0]  io_uram_out_a_54,
  input  [63:0]  io_uram_out_a_55,
  input  [63:0]  io_uram_out_a_56,
  input  [63:0]  io_uram_out_a_57,
  input  [63:0]  io_uram_out_a_58,
  input  [63:0]  io_uram_out_a_59,
  input  [63:0]  io_uram_out_a_60,
  input  [63:0]  io_uram_out_a_61,
  input  [63:0]  io_uram_out_a_62,
  input  [63:0]  io_uram_out_a_63,
  input  [63:0]  io_uram_out_a_64,
  input  [63:0]  io_uram_out_a_65,
  input  [63:0]  io_uram_out_a_66,
  input  [63:0]  io_uram_out_a_67,
  input  [63:0]  io_uram_out_a_68,
  input  [63:0]  io_uram_out_a_69,
  input  [63:0]  io_uram_out_a_70,
  input  [63:0]  io_uram_out_a_71,
  input  [63:0]  io_uram_out_a_72,
  input  [63:0]  io_uram_out_a_73,
  input  [63:0]  io_uram_out_a_74,
  input  [63:0]  io_uram_out_a_75,
  input  [63:0]  io_uram_out_a_76,
  input  [63:0]  io_uram_out_a_77,
  input  [63:0]  io_uram_out_a_78,
  input  [63:0]  io_uram_out_a_79,
  input  [63:0]  io_uram_out_a_80,
  input  [63:0]  io_uram_out_a_81,
  input  [63:0]  io_uram_out_a_82,
  input  [63:0]  io_uram_out_a_83,
  input  [63:0]  io_uram_out_a_84,
  input  [63:0]  io_uram_out_a_85,
  input  [63:0]  io_uram_out_a_86,
  input  [63:0]  io_uram_out_a_87,
  input  [63:0]  io_uram_out_a_88,
  input  [63:0]  io_uram_out_a_89,
  input  [63:0]  io_uram_out_a_90,
  input  [63:0]  io_uram_out_a_91,
  input  [63:0]  io_uram_out_a_92,
  input  [63:0]  io_uram_out_a_93,
  input  [63:0]  io_uram_out_a_94,
  input  [63:0]  io_uram_out_a_95,
  input  [63:0]  io_uram_out_a_96,
  input  [63:0]  io_uram_out_a_97,
  input  [63:0]  io_uram_out_a_98,
  input  [63:0]  io_uram_out_a_99,
  input  [63:0]  io_uram_out_a_100,
  input  [63:0]  io_uram_out_a_101,
  input  [63:0]  io_uram_out_a_102,
  input  [63:0]  io_uram_out_a_103,
  input  [63:0]  io_uram_out_a_104,
  input  [63:0]  io_uram_out_a_105,
  input  [63:0]  io_uram_out_a_106,
  input  [63:0]  io_uram_out_a_107,
  input  [63:0]  io_uram_out_a_108,
  input  [63:0]  io_uram_out_a_109,
  input  [63:0]  io_uram_out_a_110,
  input  [63:0]  io_uram_out_a_111,
  input  [63:0]  io_uram_out_a_112,
  input  [63:0]  io_uram_out_a_113,
  input  [63:0]  io_uram_out_a_114,
  input  [63:0]  io_uram_out_a_115,
  input  [63:0]  io_uram_out_a_116,
  input  [63:0]  io_uram_out_a_117,
  input  [63:0]  io_uram_out_a_118,
  input  [63:0]  io_uram_out_a_119,
  input  [63:0]  io_uram_out_a_120,
  input  [63:0]  io_uram_out_a_121,
  input  [63:0]  io_uram_out_a_122,
  input  [63:0]  io_uram_out_a_123,
  input  [63:0]  io_uram_out_a_124,
  input  [63:0]  io_uram_out_a_125,
  input  [63:0]  io_uram_out_a_126,
  input  [63:0]  io_uram_out_a_127,
  output [31:0]  io_neighbour_cnt_0,
  output [31:0]  io_neighbour_cnt_1,
  output [31:0]  io_neighbour_cnt_2,
  output [31:0]  io_neighbour_cnt_3,
  output [31:0]  io_neighbour_cnt_4,
  output [31:0]  io_neighbour_cnt_5,
  output [31:0]  io_neighbour_cnt_6,
  output [31:0]  io_neighbour_cnt_7,
  output [31:0]  io_neighbour_cnt_8,
  output [31:0]  io_neighbour_cnt_9,
  output [31:0]  io_neighbour_cnt_10,
  output [31:0]  io_neighbour_cnt_11,
  output [31:0]  io_neighbour_cnt_12,
  output [31:0]  io_neighbour_cnt_13,
  output [31:0]  io_neighbour_cnt_14,
  output [31:0]  io_neighbour_cnt_15,
  output [31:0]  io_neighbour_cnt_16,
  output [31:0]  io_neighbour_cnt_17,
  output [31:0]  io_neighbour_cnt_18,
  output [31:0]  io_neighbour_cnt_19,
  output [31:0]  io_neighbour_cnt_20,
  output [31:0]  io_neighbour_cnt_21,
  output [31:0]  io_neighbour_cnt_22,
  output [31:0]  io_neighbour_cnt_23,
  output [31:0]  io_neighbour_cnt_24,
  output [31:0]  io_neighbour_cnt_25,
  output [31:0]  io_neighbour_cnt_26,
  output [31:0]  io_neighbour_cnt_27,
  output [31:0]  io_neighbour_cnt_28,
  output [31:0]  io_neighbour_cnt_29,
  output [31:0]  io_neighbour_cnt_30,
  output [31:0]  io_neighbour_cnt_31,
  output         io_mem_end_0,
  output         io_mem_end_1,
  output         io_mem_end_2,
  output         io_mem_end_3,
  output         io_mem_end_4,
  output         io_mem_end_5,
  output         io_mem_end_6,
  output         io_mem_end_7,
  output         io_mem_end_8,
  output         io_mem_end_9,
  output         io_mem_end_10,
  output         io_mem_end_11,
  output         io_mem_end_12,
  output         io_mem_end_13,
  output         io_mem_end_14,
  output         io_mem_end_15,
  output         io_mem_end_16,
  output         io_mem_end_17,
  output         io_mem_end_18,
  output         io_mem_end_19,
  output         io_mem_end_20,
  output         io_mem_end_21,
  output         io_mem_end_22,
  output         io_mem_end_23,
  output         io_mem_end_24,
  output         io_mem_end_25,
  output         io_mem_end_26,
  output         io_mem_end_27,
  output         io_mem_end_28,
  output         io_mem_end_29,
  output         io_mem_end_30,
  output         io_mem_end_31,
  input          io_neighbours_0_ready,
  output         io_neighbours_0_valid,
  output [63:0]  io_neighbours_0_bits,
  input          io_neighbours_1_ready,
  output         io_neighbours_1_valid,
  output [63:0]  io_neighbours_1_bits,
  input          io_neighbours_2_ready,
  output         io_neighbours_2_valid,
  output [63:0]  io_neighbours_2_bits,
  input          io_neighbours_3_ready,
  output         io_neighbours_3_valid,
  output [63:0]  io_neighbours_3_bits,
  input          io_neighbours_4_ready,
  output         io_neighbours_4_valid,
  output [63:0]  io_neighbours_4_bits,
  input          io_neighbours_5_ready,
  output         io_neighbours_5_valid,
  output [63:0]  io_neighbours_5_bits,
  input          io_neighbours_6_ready,
  output         io_neighbours_6_valid,
  output [63:0]  io_neighbours_6_bits,
  input          io_neighbours_7_ready,
  output         io_neighbours_7_valid,
  output [63:0]  io_neighbours_7_bits,
  input          io_neighbours_8_ready,
  output         io_neighbours_8_valid,
  output [63:0]  io_neighbours_8_bits,
  input          io_neighbours_9_ready,
  output         io_neighbours_9_valid,
  output [63:0]  io_neighbours_9_bits,
  input          io_neighbours_10_ready,
  output         io_neighbours_10_valid,
  output [63:0]  io_neighbours_10_bits,
  input          io_neighbours_11_ready,
  output         io_neighbours_11_valid,
  output [63:0]  io_neighbours_11_bits,
  input          io_neighbours_12_ready,
  output         io_neighbours_12_valid,
  output [63:0]  io_neighbours_12_bits,
  input          io_neighbours_13_ready,
  output         io_neighbours_13_valid,
  output [63:0]  io_neighbours_13_bits,
  input          io_neighbours_14_ready,
  output         io_neighbours_14_valid,
  output [63:0]  io_neighbours_14_bits,
  input          io_neighbours_15_ready,
  output         io_neighbours_15_valid,
  output [63:0]  io_neighbours_15_bits,
  input          io_neighbours_16_ready,
  output         io_neighbours_16_valid,
  output [63:0]  io_neighbours_16_bits,
  input          io_neighbours_17_ready,
  output         io_neighbours_17_valid,
  output [63:0]  io_neighbours_17_bits,
  input          io_neighbours_18_ready,
  output         io_neighbours_18_valid,
  output [63:0]  io_neighbours_18_bits,
  input          io_neighbours_19_ready,
  output         io_neighbours_19_valid,
  output [63:0]  io_neighbours_19_bits,
  input          io_neighbours_20_ready,
  output         io_neighbours_20_valid,
  output [63:0]  io_neighbours_20_bits,
  input          io_neighbours_21_ready,
  output         io_neighbours_21_valid,
  output [63:0]  io_neighbours_21_bits,
  input          io_neighbours_22_ready,
  output         io_neighbours_22_valid,
  output [63:0]  io_neighbours_22_bits,
  input          io_neighbours_23_ready,
  output         io_neighbours_23_valid,
  output [63:0]  io_neighbours_23_bits,
  input          io_neighbours_24_ready,
  output         io_neighbours_24_valid,
  output [63:0]  io_neighbours_24_bits,
  input          io_neighbours_25_ready,
  output         io_neighbours_25_valid,
  output [63:0]  io_neighbours_25_bits,
  input          io_neighbours_26_ready,
  output         io_neighbours_26_valid,
  output [63:0]  io_neighbours_26_bits,
  input          io_neighbours_27_ready,
  output         io_neighbours_27_valid,
  output [63:0]  io_neighbours_27_bits,
  input          io_neighbours_28_ready,
  output         io_neighbours_28_valid,
  output [63:0]  io_neighbours_28_bits,
  input          io_neighbours_29_ready,
  output         io_neighbours_29_valid,
  output [63:0]  io_neighbours_29_bits,
  input          io_neighbours_30_ready,
  output         io_neighbours_30_valid,
  output [63:0]  io_neighbours_30_bits,
  input          io_neighbours_31_ready,
  output         io_neighbours_31_valid,
  output [63:0]  io_neighbours_31_bits,
  input          io_neighbours_32_ready,
  output         io_neighbours_32_valid,
  output [63:0]  io_neighbours_32_bits,
  input          io_neighbours_33_ready,
  output         io_neighbours_33_valid,
  output [63:0]  io_neighbours_33_bits,
  input          io_neighbours_34_ready,
  output         io_neighbours_34_valid,
  output [63:0]  io_neighbours_34_bits,
  input          io_neighbours_35_ready,
  output         io_neighbours_35_valid,
  output [63:0]  io_neighbours_35_bits,
  input          io_neighbours_36_ready,
  output         io_neighbours_36_valid,
  output [63:0]  io_neighbours_36_bits,
  input          io_neighbours_37_ready,
  output         io_neighbours_37_valid,
  output [63:0]  io_neighbours_37_bits,
  input          io_neighbours_38_ready,
  output         io_neighbours_38_valid,
  output [63:0]  io_neighbours_38_bits,
  input          io_neighbours_39_ready,
  output         io_neighbours_39_valid,
  output [63:0]  io_neighbours_39_bits,
  input          io_neighbours_40_ready,
  output         io_neighbours_40_valid,
  output [63:0]  io_neighbours_40_bits,
  input          io_neighbours_41_ready,
  output         io_neighbours_41_valid,
  output [63:0]  io_neighbours_41_bits,
  input          io_neighbours_42_ready,
  output         io_neighbours_42_valid,
  output [63:0]  io_neighbours_42_bits,
  input          io_neighbours_43_ready,
  output         io_neighbours_43_valid,
  output [63:0]  io_neighbours_43_bits,
  input          io_neighbours_44_ready,
  output         io_neighbours_44_valid,
  output [63:0]  io_neighbours_44_bits,
  input          io_neighbours_45_ready,
  output         io_neighbours_45_valid,
  output [63:0]  io_neighbours_45_bits,
  input          io_neighbours_46_ready,
  output         io_neighbours_46_valid,
  output [63:0]  io_neighbours_46_bits,
  input          io_neighbours_47_ready,
  output         io_neighbours_47_valid,
  output [63:0]  io_neighbours_47_bits,
  input          io_neighbours_48_ready,
  output         io_neighbours_48_valid,
  output [63:0]  io_neighbours_48_bits,
  input          io_neighbours_49_ready,
  output         io_neighbours_49_valid,
  output [63:0]  io_neighbours_49_bits,
  input          io_neighbours_50_ready,
  output         io_neighbours_50_valid,
  output [63:0]  io_neighbours_50_bits,
  input          io_neighbours_51_ready,
  output         io_neighbours_51_valid,
  output [63:0]  io_neighbours_51_bits,
  input          io_neighbours_52_ready,
  output         io_neighbours_52_valid,
  output [63:0]  io_neighbours_52_bits,
  input          io_neighbours_53_ready,
  output         io_neighbours_53_valid,
  output [63:0]  io_neighbours_53_bits,
  input          io_neighbours_54_ready,
  output         io_neighbours_54_valid,
  output [63:0]  io_neighbours_54_bits,
  input          io_neighbours_55_ready,
  output         io_neighbours_55_valid,
  output [63:0]  io_neighbours_55_bits,
  input          io_neighbours_56_ready,
  output         io_neighbours_56_valid,
  output [63:0]  io_neighbours_56_bits,
  input          io_neighbours_57_ready,
  output         io_neighbours_57_valid,
  output [63:0]  io_neighbours_57_bits,
  input          io_neighbours_58_ready,
  output         io_neighbours_58_valid,
  output [63:0]  io_neighbours_58_bits,
  input          io_neighbours_59_ready,
  output         io_neighbours_59_valid,
  output [63:0]  io_neighbours_59_bits,
  input          io_neighbours_60_ready,
  output         io_neighbours_60_valid,
  output [63:0]  io_neighbours_60_bits,
  input          io_neighbours_61_ready,
  output         io_neighbours_61_valid,
  output [63:0]  io_neighbours_61_bits,
  input          io_neighbours_62_ready,
  output         io_neighbours_62_valid,
  output [63:0]  io_neighbours_62_bits,
  input          io_neighbours_63_ready,
  output         io_neighbours_63_valid,
  output [63:0]  io_neighbours_63_bits,
  input          io_neighbours_64_ready,
  output         io_neighbours_64_valid,
  output [63:0]  io_neighbours_64_bits,
  input          io_neighbours_65_ready,
  output         io_neighbours_65_valid,
  output [63:0]  io_neighbours_65_bits,
  input          io_neighbours_66_ready,
  output         io_neighbours_66_valid,
  output [63:0]  io_neighbours_66_bits,
  input          io_neighbours_67_ready,
  output         io_neighbours_67_valid,
  output [63:0]  io_neighbours_67_bits,
  input          io_neighbours_68_ready,
  output         io_neighbours_68_valid,
  output [63:0]  io_neighbours_68_bits,
  input          io_neighbours_69_ready,
  output         io_neighbours_69_valid,
  output [63:0]  io_neighbours_69_bits,
  input          io_neighbours_70_ready,
  output         io_neighbours_70_valid,
  output [63:0]  io_neighbours_70_bits,
  input          io_neighbours_71_ready,
  output         io_neighbours_71_valid,
  output [63:0]  io_neighbours_71_bits,
  input          io_neighbours_72_ready,
  output         io_neighbours_72_valid,
  output [63:0]  io_neighbours_72_bits,
  input          io_neighbours_73_ready,
  output         io_neighbours_73_valid,
  output [63:0]  io_neighbours_73_bits,
  input          io_neighbours_74_ready,
  output         io_neighbours_74_valid,
  output [63:0]  io_neighbours_74_bits,
  input          io_neighbours_75_ready,
  output         io_neighbours_75_valid,
  output [63:0]  io_neighbours_75_bits,
  input          io_neighbours_76_ready,
  output         io_neighbours_76_valid,
  output [63:0]  io_neighbours_76_bits,
  input          io_neighbours_77_ready,
  output         io_neighbours_77_valid,
  output [63:0]  io_neighbours_77_bits,
  input          io_neighbours_78_ready,
  output         io_neighbours_78_valid,
  output [63:0]  io_neighbours_78_bits,
  input          io_neighbours_79_ready,
  output         io_neighbours_79_valid,
  output [63:0]  io_neighbours_79_bits,
  input          io_neighbours_80_ready,
  output         io_neighbours_80_valid,
  output [63:0]  io_neighbours_80_bits,
  input          io_neighbours_81_ready,
  output         io_neighbours_81_valid,
  output [63:0]  io_neighbours_81_bits,
  input          io_neighbours_82_ready,
  output         io_neighbours_82_valid,
  output [63:0]  io_neighbours_82_bits,
  input          io_neighbours_83_ready,
  output         io_neighbours_83_valid,
  output [63:0]  io_neighbours_83_bits,
  input          io_neighbours_84_ready,
  output         io_neighbours_84_valid,
  output [63:0]  io_neighbours_84_bits,
  input          io_neighbours_85_ready,
  output         io_neighbours_85_valid,
  output [63:0]  io_neighbours_85_bits,
  input          io_neighbours_86_ready,
  output         io_neighbours_86_valid,
  output [63:0]  io_neighbours_86_bits,
  input          io_neighbours_87_ready,
  output         io_neighbours_87_valid,
  output [63:0]  io_neighbours_87_bits,
  input          io_neighbours_88_ready,
  output         io_neighbours_88_valid,
  output [63:0]  io_neighbours_88_bits,
  input          io_neighbours_89_ready,
  output         io_neighbours_89_valid,
  output [63:0]  io_neighbours_89_bits,
  input          io_neighbours_90_ready,
  output         io_neighbours_90_valid,
  output [63:0]  io_neighbours_90_bits,
  input          io_neighbours_91_ready,
  output         io_neighbours_91_valid,
  output [63:0]  io_neighbours_91_bits,
  input          io_neighbours_92_ready,
  output         io_neighbours_92_valid,
  output [63:0]  io_neighbours_92_bits,
  input          io_neighbours_93_ready,
  output         io_neighbours_93_valid,
  output [63:0]  io_neighbours_93_bits,
  input          io_neighbours_94_ready,
  output         io_neighbours_94_valid,
  output [63:0]  io_neighbours_94_bits,
  input          io_neighbours_95_ready,
  output         io_neighbours_95_valid,
  output [63:0]  io_neighbours_95_bits,
  input          io_neighbours_96_ready,
  output         io_neighbours_96_valid,
  output [63:0]  io_neighbours_96_bits,
  input          io_neighbours_97_ready,
  output         io_neighbours_97_valid,
  output [63:0]  io_neighbours_97_bits,
  input          io_neighbours_98_ready,
  output         io_neighbours_98_valid,
  output [63:0]  io_neighbours_98_bits,
  input          io_neighbours_99_ready,
  output         io_neighbours_99_valid,
  output [63:0]  io_neighbours_99_bits,
  input          io_neighbours_100_ready,
  output         io_neighbours_100_valid,
  output [63:0]  io_neighbours_100_bits,
  input          io_neighbours_101_ready,
  output         io_neighbours_101_valid,
  output [63:0]  io_neighbours_101_bits,
  input          io_neighbours_102_ready,
  output         io_neighbours_102_valid,
  output [63:0]  io_neighbours_102_bits,
  input          io_neighbours_103_ready,
  output         io_neighbours_103_valid,
  output [63:0]  io_neighbours_103_bits,
  input          io_neighbours_104_ready,
  output         io_neighbours_104_valid,
  output [63:0]  io_neighbours_104_bits,
  input          io_neighbours_105_ready,
  output         io_neighbours_105_valid,
  output [63:0]  io_neighbours_105_bits,
  input          io_neighbours_106_ready,
  output         io_neighbours_106_valid,
  output [63:0]  io_neighbours_106_bits,
  input          io_neighbours_107_ready,
  output         io_neighbours_107_valid,
  output [63:0]  io_neighbours_107_bits,
  input          io_neighbours_108_ready,
  output         io_neighbours_108_valid,
  output [63:0]  io_neighbours_108_bits,
  input          io_neighbours_109_ready,
  output         io_neighbours_109_valid,
  output [63:0]  io_neighbours_109_bits,
  input          io_neighbours_110_ready,
  output         io_neighbours_110_valid,
  output [63:0]  io_neighbours_110_bits,
  input          io_neighbours_111_ready,
  output         io_neighbours_111_valid,
  output [63:0]  io_neighbours_111_bits,
  input          io_neighbours_112_ready,
  output         io_neighbours_112_valid,
  output [63:0]  io_neighbours_112_bits,
  input          io_neighbours_113_ready,
  output         io_neighbours_113_valid,
  output [63:0]  io_neighbours_113_bits,
  input          io_neighbours_114_ready,
  output         io_neighbours_114_valid,
  output [63:0]  io_neighbours_114_bits,
  input          io_neighbours_115_ready,
  output         io_neighbours_115_valid,
  output [63:0]  io_neighbours_115_bits,
  input          io_neighbours_116_ready,
  output         io_neighbours_116_valid,
  output [63:0]  io_neighbours_116_bits,
  input          io_neighbours_117_ready,
  output         io_neighbours_117_valid,
  output [63:0]  io_neighbours_117_bits,
  input          io_neighbours_118_ready,
  output         io_neighbours_118_valid,
  output [63:0]  io_neighbours_118_bits,
  input          io_neighbours_119_ready,
  output         io_neighbours_119_valid,
  output [63:0]  io_neighbours_119_bits,
  input          io_neighbours_120_ready,
  output         io_neighbours_120_valid,
  output [63:0]  io_neighbours_120_bits,
  input          io_neighbours_121_ready,
  output         io_neighbours_121_valid,
  output [63:0]  io_neighbours_121_bits,
  input          io_neighbours_122_ready,
  output         io_neighbours_122_valid,
  output [63:0]  io_neighbours_122_bits,
  input          io_neighbours_123_ready,
  output         io_neighbours_123_valid,
  output [63:0]  io_neighbours_123_bits,
  input          io_neighbours_124_ready,
  output         io_neighbours_124_valid,
  output [63:0]  io_neighbours_124_bits,
  input          io_neighbours_125_ready,
  output         io_neighbours_125_valid,
  output [63:0]  io_neighbours_125_bits,
  input          io_neighbours_126_ready,
  output         io_neighbours_126_valid,
  output [63:0]  io_neighbours_126_bits,
  input          io_neighbours_127_ready,
  output         io_neighbours_127_valid,
  output [63:0]  io_neighbours_127_bits,
  output [19:0]  io_uram_addr_a_0,
  output [19:0]  io_uram_addr_a_1,
  output [19:0]  io_uram_addr_a_2,
  output [19:0]  io_uram_addr_a_3,
  output [19:0]  io_uram_addr_a_4,
  output [19:0]  io_uram_addr_a_5,
  output [19:0]  io_uram_addr_a_6,
  output [19:0]  io_uram_addr_a_7,
  output [19:0]  io_uram_addr_a_8,
  output [19:0]  io_uram_addr_a_9,
  output [19:0]  io_uram_addr_a_10,
  output [19:0]  io_uram_addr_a_11,
  output [19:0]  io_uram_addr_a_12,
  output [19:0]  io_uram_addr_a_13,
  output [19:0]  io_uram_addr_a_14,
  output [19:0]  io_uram_addr_a_15,
  output [19:0]  io_uram_addr_a_16,
  output [19:0]  io_uram_addr_a_17,
  output [19:0]  io_uram_addr_a_18,
  output [19:0]  io_uram_addr_a_19,
  output [19:0]  io_uram_addr_a_20,
  output [19:0]  io_uram_addr_a_21,
  output [19:0]  io_uram_addr_a_22,
  output [19:0]  io_uram_addr_a_23,
  output [19:0]  io_uram_addr_a_24,
  output [19:0]  io_uram_addr_a_25,
  output [19:0]  io_uram_addr_a_26,
  output [19:0]  io_uram_addr_a_27,
  output [19:0]  io_uram_addr_a_28,
  output [19:0]  io_uram_addr_a_29,
  output [19:0]  io_uram_addr_a_30,
  output [19:0]  io_uram_addr_a_31,
  output [19:0]  io_uram_addr_a_32,
  output [19:0]  io_uram_addr_a_33,
  output [19:0]  io_uram_addr_a_34,
  output [19:0]  io_uram_addr_a_35,
  output [19:0]  io_uram_addr_a_36,
  output [19:0]  io_uram_addr_a_37,
  output [19:0]  io_uram_addr_a_38,
  output [19:0]  io_uram_addr_a_39,
  output [19:0]  io_uram_addr_a_40,
  output [19:0]  io_uram_addr_a_41,
  output [19:0]  io_uram_addr_a_42,
  output [19:0]  io_uram_addr_a_43,
  output [19:0]  io_uram_addr_a_44,
  output [19:0]  io_uram_addr_a_45,
  output [19:0]  io_uram_addr_a_46,
  output [19:0]  io_uram_addr_a_47,
  output [19:0]  io_uram_addr_a_48,
  output [19:0]  io_uram_addr_a_49,
  output [19:0]  io_uram_addr_a_50,
  output [19:0]  io_uram_addr_a_51,
  output [19:0]  io_uram_addr_a_52,
  output [19:0]  io_uram_addr_a_53,
  output [19:0]  io_uram_addr_a_54,
  output [19:0]  io_uram_addr_a_55,
  output [19:0]  io_uram_addr_a_56,
  output [19:0]  io_uram_addr_a_57,
  output [19:0]  io_uram_addr_a_58,
  output [19:0]  io_uram_addr_a_59,
  output [19:0]  io_uram_addr_a_60,
  output [19:0]  io_uram_addr_a_61,
  output [19:0]  io_uram_addr_a_62,
  output [19:0]  io_uram_addr_a_63,
  output [19:0]  io_uram_addr_a_64,
  output [19:0]  io_uram_addr_a_65,
  output [19:0]  io_uram_addr_a_66,
  output [19:0]  io_uram_addr_a_67,
  output [19:0]  io_uram_addr_a_68,
  output [19:0]  io_uram_addr_a_69,
  output [19:0]  io_uram_addr_a_70,
  output [19:0]  io_uram_addr_a_71,
  output [19:0]  io_uram_addr_a_72,
  output [19:0]  io_uram_addr_a_73,
  output [19:0]  io_uram_addr_a_74,
  output [19:0]  io_uram_addr_a_75,
  output [19:0]  io_uram_addr_a_76,
  output [19:0]  io_uram_addr_a_77,
  output [19:0]  io_uram_addr_a_78,
  output [19:0]  io_uram_addr_a_79,
  output [19:0]  io_uram_addr_a_80,
  output [19:0]  io_uram_addr_a_81,
  output [19:0]  io_uram_addr_a_82,
  output [19:0]  io_uram_addr_a_83,
  output [19:0]  io_uram_addr_a_84,
  output [19:0]  io_uram_addr_a_85,
  output [19:0]  io_uram_addr_a_86,
  output [19:0]  io_uram_addr_a_87,
  output [19:0]  io_uram_addr_a_88,
  output [19:0]  io_uram_addr_a_89,
  output [19:0]  io_uram_addr_a_90,
  output [19:0]  io_uram_addr_a_91,
  output [19:0]  io_uram_addr_a_92,
  output [19:0]  io_uram_addr_a_93,
  output [19:0]  io_uram_addr_a_94,
  output [19:0]  io_uram_addr_a_95,
  output [19:0]  io_uram_addr_a_96,
  output [19:0]  io_uram_addr_a_97,
  output [19:0]  io_uram_addr_a_98,
  output [19:0]  io_uram_addr_a_99,
  output [19:0]  io_uram_addr_a_100,
  output [19:0]  io_uram_addr_a_101,
  output [19:0]  io_uram_addr_a_102,
  output [19:0]  io_uram_addr_a_103,
  output [19:0]  io_uram_addr_a_104,
  output [19:0]  io_uram_addr_a_105,
  output [19:0]  io_uram_addr_a_106,
  output [19:0]  io_uram_addr_a_107,
  output [19:0]  io_uram_addr_a_108,
  output [19:0]  io_uram_addr_a_109,
  output [19:0]  io_uram_addr_a_110,
  output [19:0]  io_uram_addr_a_111,
  output [19:0]  io_uram_addr_a_112,
  output [19:0]  io_uram_addr_a_113,
  output [19:0]  io_uram_addr_a_114,
  output [19:0]  io_uram_addr_a_115,
  output [19:0]  io_uram_addr_a_116,
  output [19:0]  io_uram_addr_a_117,
  output [19:0]  io_uram_addr_a_118,
  output [19:0]  io_uram_addr_a_119,
  output [19:0]  io_uram_addr_a_120,
  output [19:0]  io_uram_addr_a_121,
  output [19:0]  io_uram_addr_a_122,
  output [19:0]  io_uram_addr_a_123,
  output [19:0]  io_uram_addr_a_124,
  output [19:0]  io_uram_addr_a_125,
  output [19:0]  io_uram_addr_a_126,
  output [19:0]  io_uram_addr_a_127,
  output         io_write_finish_0,
  output         io_write_finish_1,
  output         io_write_finish_2,
  output         io_write_finish_3,
  output         io_write_finish_4,
  output         io_write_finish_5,
  output         io_write_finish_6,
  output         io_write_finish_7,
  output         io_write_finish_8,
  output         io_write_finish_9,
  output         io_write_finish_10,
  output         io_write_finish_11,
  output         io_write_finish_12,
  output         io_write_finish_13,
  output         io_write_finish_14,
  output         io_write_finish_15,
  output         io_write_finish_16,
  output         io_write_finish_17,
  output         io_write_finish_18,
  output         io_write_finish_19,
  output         io_write_finish_20,
  output         io_write_finish_21,
  output         io_write_finish_22,
  output         io_write_finish_23,
  output         io_write_finish_24,
  output         io_write_finish_25,
  output         io_write_finish_26,
  output         io_write_finish_27,
  output         io_write_finish_28,
  output         io_write_finish_29,
  output         io_write_finish_30,
  output         io_write_finish_31,
  input          io_HBM_interface_0_writeAddr_ready,
  output         io_HBM_interface_0_writeAddr_valid,
  output [63:0]  io_HBM_interface_0_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_0_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_0_writeAddr_bits_id,
  input          io_HBM_interface_0_writeData_ready,
  output         io_HBM_interface_0_writeData_valid,
  output [255:0] io_HBM_interface_0_writeData_bits_data,
  output [31:0]  io_HBM_interface_0_writeData_bits_strb,
  output         io_HBM_interface_0_writeData_bits_last,
  output         io_HBM_interface_0_writeResp_ready,
  input          io_HBM_interface_0_writeResp_valid,
  input  [5:0]   io_HBM_interface_0_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_0_writeResp_bits_resp,
  input          io_HBM_interface_0_readAddr_ready,
  output         io_HBM_interface_0_readAddr_valid,
  output [63:0]  io_HBM_interface_0_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_0_readAddr_bits_len,
  output [5:0]   io_HBM_interface_0_readAddr_bits_id,
  output         io_HBM_interface_0_readData_ready,
  input          io_HBM_interface_0_readData_valid,
  input  [255:0] io_HBM_interface_0_readData_bits_data,
  input  [5:0]   io_HBM_interface_0_readData_bits_id,
  input          io_HBM_interface_0_readData_bits_last,
  input  [1:0]   io_HBM_interface_0_readData_bits_resp,
  input          io_HBM_interface_1_writeAddr_ready,
  output         io_HBM_interface_1_writeAddr_valid,
  output [63:0]  io_HBM_interface_1_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_1_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_1_writeAddr_bits_id,
  input          io_HBM_interface_1_writeData_ready,
  output         io_HBM_interface_1_writeData_valid,
  output [255:0] io_HBM_interface_1_writeData_bits_data,
  output [31:0]  io_HBM_interface_1_writeData_bits_strb,
  output         io_HBM_interface_1_writeData_bits_last,
  output         io_HBM_interface_1_writeResp_ready,
  input          io_HBM_interface_1_writeResp_valid,
  input  [5:0]   io_HBM_interface_1_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_1_writeResp_bits_resp,
  input          io_HBM_interface_1_readAddr_ready,
  output         io_HBM_interface_1_readAddr_valid,
  output [63:0]  io_HBM_interface_1_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_1_readAddr_bits_len,
  output [5:0]   io_HBM_interface_1_readAddr_bits_id,
  output         io_HBM_interface_1_readData_ready,
  input          io_HBM_interface_1_readData_valid,
  input  [255:0] io_HBM_interface_1_readData_bits_data,
  input  [5:0]   io_HBM_interface_1_readData_bits_id,
  input          io_HBM_interface_1_readData_bits_last,
  input  [1:0]   io_HBM_interface_1_readData_bits_resp,
  input          io_HBM_interface_2_writeAddr_ready,
  output         io_HBM_interface_2_writeAddr_valid,
  output [63:0]  io_HBM_interface_2_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_2_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_2_writeAddr_bits_id,
  input          io_HBM_interface_2_writeData_ready,
  output         io_HBM_interface_2_writeData_valid,
  output [255:0] io_HBM_interface_2_writeData_bits_data,
  output [31:0]  io_HBM_interface_2_writeData_bits_strb,
  output         io_HBM_interface_2_writeData_bits_last,
  output         io_HBM_interface_2_writeResp_ready,
  input          io_HBM_interface_2_writeResp_valid,
  input  [5:0]   io_HBM_interface_2_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_2_writeResp_bits_resp,
  input          io_HBM_interface_2_readAddr_ready,
  output         io_HBM_interface_2_readAddr_valid,
  output [63:0]  io_HBM_interface_2_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_2_readAddr_bits_len,
  output [5:0]   io_HBM_interface_2_readAddr_bits_id,
  output         io_HBM_interface_2_readData_ready,
  input          io_HBM_interface_2_readData_valid,
  input  [255:0] io_HBM_interface_2_readData_bits_data,
  input  [5:0]   io_HBM_interface_2_readData_bits_id,
  input          io_HBM_interface_2_readData_bits_last,
  input  [1:0]   io_HBM_interface_2_readData_bits_resp,
  input          io_HBM_interface_3_writeAddr_ready,
  output         io_HBM_interface_3_writeAddr_valid,
  output [63:0]  io_HBM_interface_3_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_3_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_3_writeAddr_bits_id,
  input          io_HBM_interface_3_writeData_ready,
  output         io_HBM_interface_3_writeData_valid,
  output [255:0] io_HBM_interface_3_writeData_bits_data,
  output [31:0]  io_HBM_interface_3_writeData_bits_strb,
  output         io_HBM_interface_3_writeData_bits_last,
  output         io_HBM_interface_3_writeResp_ready,
  input          io_HBM_interface_3_writeResp_valid,
  input  [5:0]   io_HBM_interface_3_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_3_writeResp_bits_resp,
  input          io_HBM_interface_3_readAddr_ready,
  output         io_HBM_interface_3_readAddr_valid,
  output [63:0]  io_HBM_interface_3_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_3_readAddr_bits_len,
  output [5:0]   io_HBM_interface_3_readAddr_bits_id,
  output         io_HBM_interface_3_readData_ready,
  input          io_HBM_interface_3_readData_valid,
  input  [255:0] io_HBM_interface_3_readData_bits_data,
  input  [5:0]   io_HBM_interface_3_readData_bits_id,
  input          io_HBM_interface_3_readData_bits_last,
  input  [1:0]   io_HBM_interface_3_readData_bits_resp,
  input          io_HBM_interface_4_writeAddr_ready,
  output         io_HBM_interface_4_writeAddr_valid,
  output [63:0]  io_HBM_interface_4_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_4_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_4_writeAddr_bits_id,
  input          io_HBM_interface_4_writeData_ready,
  output         io_HBM_interface_4_writeData_valid,
  output [255:0] io_HBM_interface_4_writeData_bits_data,
  output [31:0]  io_HBM_interface_4_writeData_bits_strb,
  output         io_HBM_interface_4_writeData_bits_last,
  output         io_HBM_interface_4_writeResp_ready,
  input          io_HBM_interface_4_writeResp_valid,
  input  [5:0]   io_HBM_interface_4_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_4_writeResp_bits_resp,
  input          io_HBM_interface_4_readAddr_ready,
  output         io_HBM_interface_4_readAddr_valid,
  output [63:0]  io_HBM_interface_4_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_4_readAddr_bits_len,
  output [5:0]   io_HBM_interface_4_readAddr_bits_id,
  output         io_HBM_interface_4_readData_ready,
  input          io_HBM_interface_4_readData_valid,
  input  [255:0] io_HBM_interface_4_readData_bits_data,
  input  [5:0]   io_HBM_interface_4_readData_bits_id,
  input          io_HBM_interface_4_readData_bits_last,
  input  [1:0]   io_HBM_interface_4_readData_bits_resp,
  input          io_HBM_interface_5_writeAddr_ready,
  output         io_HBM_interface_5_writeAddr_valid,
  output [63:0]  io_HBM_interface_5_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_5_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_5_writeAddr_bits_id,
  input          io_HBM_interface_5_writeData_ready,
  output         io_HBM_interface_5_writeData_valid,
  output [255:0] io_HBM_interface_5_writeData_bits_data,
  output [31:0]  io_HBM_interface_5_writeData_bits_strb,
  output         io_HBM_interface_5_writeData_bits_last,
  output         io_HBM_interface_5_writeResp_ready,
  input          io_HBM_interface_5_writeResp_valid,
  input  [5:0]   io_HBM_interface_5_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_5_writeResp_bits_resp,
  input          io_HBM_interface_5_readAddr_ready,
  output         io_HBM_interface_5_readAddr_valid,
  output [63:0]  io_HBM_interface_5_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_5_readAddr_bits_len,
  output [5:0]   io_HBM_interface_5_readAddr_bits_id,
  output         io_HBM_interface_5_readData_ready,
  input          io_HBM_interface_5_readData_valid,
  input  [255:0] io_HBM_interface_5_readData_bits_data,
  input  [5:0]   io_HBM_interface_5_readData_bits_id,
  input          io_HBM_interface_5_readData_bits_last,
  input  [1:0]   io_HBM_interface_5_readData_bits_resp,
  input          io_HBM_interface_6_writeAddr_ready,
  output         io_HBM_interface_6_writeAddr_valid,
  output [63:0]  io_HBM_interface_6_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_6_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_6_writeAddr_bits_id,
  input          io_HBM_interface_6_writeData_ready,
  output         io_HBM_interface_6_writeData_valid,
  output [255:0] io_HBM_interface_6_writeData_bits_data,
  output [31:0]  io_HBM_interface_6_writeData_bits_strb,
  output         io_HBM_interface_6_writeData_bits_last,
  output         io_HBM_interface_6_writeResp_ready,
  input          io_HBM_interface_6_writeResp_valid,
  input  [5:0]   io_HBM_interface_6_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_6_writeResp_bits_resp,
  input          io_HBM_interface_6_readAddr_ready,
  output         io_HBM_interface_6_readAddr_valid,
  output [63:0]  io_HBM_interface_6_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_6_readAddr_bits_len,
  output [5:0]   io_HBM_interface_6_readAddr_bits_id,
  output         io_HBM_interface_6_readData_ready,
  input          io_HBM_interface_6_readData_valid,
  input  [255:0] io_HBM_interface_6_readData_bits_data,
  input  [5:0]   io_HBM_interface_6_readData_bits_id,
  input          io_HBM_interface_6_readData_bits_last,
  input  [1:0]   io_HBM_interface_6_readData_bits_resp,
  input          io_HBM_interface_7_writeAddr_ready,
  output         io_HBM_interface_7_writeAddr_valid,
  output [63:0]  io_HBM_interface_7_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_7_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_7_writeAddr_bits_id,
  input          io_HBM_interface_7_writeData_ready,
  output         io_HBM_interface_7_writeData_valid,
  output [255:0] io_HBM_interface_7_writeData_bits_data,
  output [31:0]  io_HBM_interface_7_writeData_bits_strb,
  output         io_HBM_interface_7_writeData_bits_last,
  output         io_HBM_interface_7_writeResp_ready,
  input          io_HBM_interface_7_writeResp_valid,
  input  [5:0]   io_HBM_interface_7_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_7_writeResp_bits_resp,
  input          io_HBM_interface_7_readAddr_ready,
  output         io_HBM_interface_7_readAddr_valid,
  output [63:0]  io_HBM_interface_7_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_7_readAddr_bits_len,
  output [5:0]   io_HBM_interface_7_readAddr_bits_id,
  output         io_HBM_interface_7_readData_ready,
  input          io_HBM_interface_7_readData_valid,
  input  [255:0] io_HBM_interface_7_readData_bits_data,
  input  [5:0]   io_HBM_interface_7_readData_bits_id,
  input          io_HBM_interface_7_readData_bits_last,
  input  [1:0]   io_HBM_interface_7_readData_bits_resp,
  input          io_HBM_interface_8_writeAddr_ready,
  output         io_HBM_interface_8_writeAddr_valid,
  output [63:0]  io_HBM_interface_8_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_8_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_8_writeAddr_bits_id,
  input          io_HBM_interface_8_writeData_ready,
  output         io_HBM_interface_8_writeData_valid,
  output [255:0] io_HBM_interface_8_writeData_bits_data,
  output [31:0]  io_HBM_interface_8_writeData_bits_strb,
  output         io_HBM_interface_8_writeData_bits_last,
  output         io_HBM_interface_8_writeResp_ready,
  input          io_HBM_interface_8_writeResp_valid,
  input  [5:0]   io_HBM_interface_8_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_8_writeResp_bits_resp,
  input          io_HBM_interface_8_readAddr_ready,
  output         io_HBM_interface_8_readAddr_valid,
  output [63:0]  io_HBM_interface_8_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_8_readAddr_bits_len,
  output [5:0]   io_HBM_interface_8_readAddr_bits_id,
  output         io_HBM_interface_8_readData_ready,
  input          io_HBM_interface_8_readData_valid,
  input  [255:0] io_HBM_interface_8_readData_bits_data,
  input  [5:0]   io_HBM_interface_8_readData_bits_id,
  input          io_HBM_interface_8_readData_bits_last,
  input  [1:0]   io_HBM_interface_8_readData_bits_resp,
  input          io_HBM_interface_9_writeAddr_ready,
  output         io_HBM_interface_9_writeAddr_valid,
  output [63:0]  io_HBM_interface_9_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_9_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_9_writeAddr_bits_id,
  input          io_HBM_interface_9_writeData_ready,
  output         io_HBM_interface_9_writeData_valid,
  output [255:0] io_HBM_interface_9_writeData_bits_data,
  output [31:0]  io_HBM_interface_9_writeData_bits_strb,
  output         io_HBM_interface_9_writeData_bits_last,
  output         io_HBM_interface_9_writeResp_ready,
  input          io_HBM_interface_9_writeResp_valid,
  input  [5:0]   io_HBM_interface_9_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_9_writeResp_bits_resp,
  input          io_HBM_interface_9_readAddr_ready,
  output         io_HBM_interface_9_readAddr_valid,
  output [63:0]  io_HBM_interface_9_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_9_readAddr_bits_len,
  output [5:0]   io_HBM_interface_9_readAddr_bits_id,
  output         io_HBM_interface_9_readData_ready,
  input          io_HBM_interface_9_readData_valid,
  input  [255:0] io_HBM_interface_9_readData_bits_data,
  input  [5:0]   io_HBM_interface_9_readData_bits_id,
  input          io_HBM_interface_9_readData_bits_last,
  input  [1:0]   io_HBM_interface_9_readData_bits_resp,
  input          io_HBM_interface_10_writeAddr_ready,
  output         io_HBM_interface_10_writeAddr_valid,
  output [63:0]  io_HBM_interface_10_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_10_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_10_writeAddr_bits_id,
  input          io_HBM_interface_10_writeData_ready,
  output         io_HBM_interface_10_writeData_valid,
  output [255:0] io_HBM_interface_10_writeData_bits_data,
  output [31:0]  io_HBM_interface_10_writeData_bits_strb,
  output         io_HBM_interface_10_writeData_bits_last,
  output         io_HBM_interface_10_writeResp_ready,
  input          io_HBM_interface_10_writeResp_valid,
  input  [5:0]   io_HBM_interface_10_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_10_writeResp_bits_resp,
  input          io_HBM_interface_10_readAddr_ready,
  output         io_HBM_interface_10_readAddr_valid,
  output [63:0]  io_HBM_interface_10_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_10_readAddr_bits_len,
  output [5:0]   io_HBM_interface_10_readAddr_bits_id,
  output         io_HBM_interface_10_readData_ready,
  input          io_HBM_interface_10_readData_valid,
  input  [255:0] io_HBM_interface_10_readData_bits_data,
  input  [5:0]   io_HBM_interface_10_readData_bits_id,
  input          io_HBM_interface_10_readData_bits_last,
  input  [1:0]   io_HBM_interface_10_readData_bits_resp,
  input          io_HBM_interface_11_writeAddr_ready,
  output         io_HBM_interface_11_writeAddr_valid,
  output [63:0]  io_HBM_interface_11_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_11_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_11_writeAddr_bits_id,
  input          io_HBM_interface_11_writeData_ready,
  output         io_HBM_interface_11_writeData_valid,
  output [255:0] io_HBM_interface_11_writeData_bits_data,
  output [31:0]  io_HBM_interface_11_writeData_bits_strb,
  output         io_HBM_interface_11_writeData_bits_last,
  output         io_HBM_interface_11_writeResp_ready,
  input          io_HBM_interface_11_writeResp_valid,
  input  [5:0]   io_HBM_interface_11_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_11_writeResp_bits_resp,
  input          io_HBM_interface_11_readAddr_ready,
  output         io_HBM_interface_11_readAddr_valid,
  output [63:0]  io_HBM_interface_11_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_11_readAddr_bits_len,
  output [5:0]   io_HBM_interface_11_readAddr_bits_id,
  output         io_HBM_interface_11_readData_ready,
  input          io_HBM_interface_11_readData_valid,
  input  [255:0] io_HBM_interface_11_readData_bits_data,
  input  [5:0]   io_HBM_interface_11_readData_bits_id,
  input          io_HBM_interface_11_readData_bits_last,
  input  [1:0]   io_HBM_interface_11_readData_bits_resp,
  input          io_HBM_interface_12_writeAddr_ready,
  output         io_HBM_interface_12_writeAddr_valid,
  output [63:0]  io_HBM_interface_12_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_12_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_12_writeAddr_bits_id,
  input          io_HBM_interface_12_writeData_ready,
  output         io_HBM_interface_12_writeData_valid,
  output [255:0] io_HBM_interface_12_writeData_bits_data,
  output [31:0]  io_HBM_interface_12_writeData_bits_strb,
  output         io_HBM_interface_12_writeData_bits_last,
  output         io_HBM_interface_12_writeResp_ready,
  input          io_HBM_interface_12_writeResp_valid,
  input  [5:0]   io_HBM_interface_12_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_12_writeResp_bits_resp,
  input          io_HBM_interface_12_readAddr_ready,
  output         io_HBM_interface_12_readAddr_valid,
  output [63:0]  io_HBM_interface_12_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_12_readAddr_bits_len,
  output [5:0]   io_HBM_interface_12_readAddr_bits_id,
  output         io_HBM_interface_12_readData_ready,
  input          io_HBM_interface_12_readData_valid,
  input  [255:0] io_HBM_interface_12_readData_bits_data,
  input  [5:0]   io_HBM_interface_12_readData_bits_id,
  input          io_HBM_interface_12_readData_bits_last,
  input  [1:0]   io_HBM_interface_12_readData_bits_resp,
  input          io_HBM_interface_13_writeAddr_ready,
  output         io_HBM_interface_13_writeAddr_valid,
  output [63:0]  io_HBM_interface_13_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_13_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_13_writeAddr_bits_id,
  input          io_HBM_interface_13_writeData_ready,
  output         io_HBM_interface_13_writeData_valid,
  output [255:0] io_HBM_interface_13_writeData_bits_data,
  output [31:0]  io_HBM_interface_13_writeData_bits_strb,
  output         io_HBM_interface_13_writeData_bits_last,
  output         io_HBM_interface_13_writeResp_ready,
  input          io_HBM_interface_13_writeResp_valid,
  input  [5:0]   io_HBM_interface_13_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_13_writeResp_bits_resp,
  input          io_HBM_interface_13_readAddr_ready,
  output         io_HBM_interface_13_readAddr_valid,
  output [63:0]  io_HBM_interface_13_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_13_readAddr_bits_len,
  output [5:0]   io_HBM_interface_13_readAddr_bits_id,
  output         io_HBM_interface_13_readData_ready,
  input          io_HBM_interface_13_readData_valid,
  input  [255:0] io_HBM_interface_13_readData_bits_data,
  input  [5:0]   io_HBM_interface_13_readData_bits_id,
  input          io_HBM_interface_13_readData_bits_last,
  input  [1:0]   io_HBM_interface_13_readData_bits_resp,
  input          io_HBM_interface_14_writeAddr_ready,
  output         io_HBM_interface_14_writeAddr_valid,
  output [63:0]  io_HBM_interface_14_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_14_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_14_writeAddr_bits_id,
  input          io_HBM_interface_14_writeData_ready,
  output         io_HBM_interface_14_writeData_valid,
  output [255:0] io_HBM_interface_14_writeData_bits_data,
  output [31:0]  io_HBM_interface_14_writeData_bits_strb,
  output         io_HBM_interface_14_writeData_bits_last,
  output         io_HBM_interface_14_writeResp_ready,
  input          io_HBM_interface_14_writeResp_valid,
  input  [5:0]   io_HBM_interface_14_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_14_writeResp_bits_resp,
  input          io_HBM_interface_14_readAddr_ready,
  output         io_HBM_interface_14_readAddr_valid,
  output [63:0]  io_HBM_interface_14_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_14_readAddr_bits_len,
  output [5:0]   io_HBM_interface_14_readAddr_bits_id,
  output         io_HBM_interface_14_readData_ready,
  input          io_HBM_interface_14_readData_valid,
  input  [255:0] io_HBM_interface_14_readData_bits_data,
  input  [5:0]   io_HBM_interface_14_readData_bits_id,
  input          io_HBM_interface_14_readData_bits_last,
  input  [1:0]   io_HBM_interface_14_readData_bits_resp,
  input          io_HBM_interface_15_writeAddr_ready,
  output         io_HBM_interface_15_writeAddr_valid,
  output [63:0]  io_HBM_interface_15_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_15_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_15_writeAddr_bits_id,
  input          io_HBM_interface_15_writeData_ready,
  output         io_HBM_interface_15_writeData_valid,
  output [255:0] io_HBM_interface_15_writeData_bits_data,
  output [31:0]  io_HBM_interface_15_writeData_bits_strb,
  output         io_HBM_interface_15_writeData_bits_last,
  output         io_HBM_interface_15_writeResp_ready,
  input          io_HBM_interface_15_writeResp_valid,
  input  [5:0]   io_HBM_interface_15_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_15_writeResp_bits_resp,
  input          io_HBM_interface_15_readAddr_ready,
  output         io_HBM_interface_15_readAddr_valid,
  output [63:0]  io_HBM_interface_15_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_15_readAddr_bits_len,
  output [5:0]   io_HBM_interface_15_readAddr_bits_id,
  output         io_HBM_interface_15_readData_ready,
  input          io_HBM_interface_15_readData_valid,
  input  [255:0] io_HBM_interface_15_readData_bits_data,
  input  [5:0]   io_HBM_interface_15_readData_bits_id,
  input          io_HBM_interface_15_readData_bits_last,
  input  [1:0]   io_HBM_interface_15_readData_bits_resp,
  input          io_HBM_interface_16_writeAddr_ready,
  output         io_HBM_interface_16_writeAddr_valid,
  output [63:0]  io_HBM_interface_16_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_16_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_16_writeAddr_bits_id,
  input          io_HBM_interface_16_writeData_ready,
  output         io_HBM_interface_16_writeData_valid,
  output [255:0] io_HBM_interface_16_writeData_bits_data,
  output [31:0]  io_HBM_interface_16_writeData_bits_strb,
  output         io_HBM_interface_16_writeData_bits_last,
  output         io_HBM_interface_16_writeResp_ready,
  input          io_HBM_interface_16_writeResp_valid,
  input  [5:0]   io_HBM_interface_16_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_16_writeResp_bits_resp,
  input          io_HBM_interface_16_readAddr_ready,
  output         io_HBM_interface_16_readAddr_valid,
  output [63:0]  io_HBM_interface_16_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_16_readAddr_bits_len,
  output [5:0]   io_HBM_interface_16_readAddr_bits_id,
  output         io_HBM_interface_16_readData_ready,
  input          io_HBM_interface_16_readData_valid,
  input  [255:0] io_HBM_interface_16_readData_bits_data,
  input  [5:0]   io_HBM_interface_16_readData_bits_id,
  input          io_HBM_interface_16_readData_bits_last,
  input  [1:0]   io_HBM_interface_16_readData_bits_resp,
  input          io_HBM_interface_17_writeAddr_ready,
  output         io_HBM_interface_17_writeAddr_valid,
  output [63:0]  io_HBM_interface_17_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_17_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_17_writeAddr_bits_id,
  input          io_HBM_interface_17_writeData_ready,
  output         io_HBM_interface_17_writeData_valid,
  output [255:0] io_HBM_interface_17_writeData_bits_data,
  output [31:0]  io_HBM_interface_17_writeData_bits_strb,
  output         io_HBM_interface_17_writeData_bits_last,
  output         io_HBM_interface_17_writeResp_ready,
  input          io_HBM_interface_17_writeResp_valid,
  input  [5:0]   io_HBM_interface_17_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_17_writeResp_bits_resp,
  input          io_HBM_interface_17_readAddr_ready,
  output         io_HBM_interface_17_readAddr_valid,
  output [63:0]  io_HBM_interface_17_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_17_readAddr_bits_len,
  output [5:0]   io_HBM_interface_17_readAddr_bits_id,
  output         io_HBM_interface_17_readData_ready,
  input          io_HBM_interface_17_readData_valid,
  input  [255:0] io_HBM_interface_17_readData_bits_data,
  input  [5:0]   io_HBM_interface_17_readData_bits_id,
  input          io_HBM_interface_17_readData_bits_last,
  input  [1:0]   io_HBM_interface_17_readData_bits_resp,
  input          io_HBM_interface_18_writeAddr_ready,
  output         io_HBM_interface_18_writeAddr_valid,
  output [63:0]  io_HBM_interface_18_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_18_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_18_writeAddr_bits_id,
  input          io_HBM_interface_18_writeData_ready,
  output         io_HBM_interface_18_writeData_valid,
  output [255:0] io_HBM_interface_18_writeData_bits_data,
  output [31:0]  io_HBM_interface_18_writeData_bits_strb,
  output         io_HBM_interface_18_writeData_bits_last,
  output         io_HBM_interface_18_writeResp_ready,
  input          io_HBM_interface_18_writeResp_valid,
  input  [5:0]   io_HBM_interface_18_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_18_writeResp_bits_resp,
  input          io_HBM_interface_18_readAddr_ready,
  output         io_HBM_interface_18_readAddr_valid,
  output [63:0]  io_HBM_interface_18_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_18_readAddr_bits_len,
  output [5:0]   io_HBM_interface_18_readAddr_bits_id,
  output         io_HBM_interface_18_readData_ready,
  input          io_HBM_interface_18_readData_valid,
  input  [255:0] io_HBM_interface_18_readData_bits_data,
  input  [5:0]   io_HBM_interface_18_readData_bits_id,
  input          io_HBM_interface_18_readData_bits_last,
  input  [1:0]   io_HBM_interface_18_readData_bits_resp,
  input          io_HBM_interface_19_writeAddr_ready,
  output         io_HBM_interface_19_writeAddr_valid,
  output [63:0]  io_HBM_interface_19_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_19_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_19_writeAddr_bits_id,
  input          io_HBM_interface_19_writeData_ready,
  output         io_HBM_interface_19_writeData_valid,
  output [255:0] io_HBM_interface_19_writeData_bits_data,
  output [31:0]  io_HBM_interface_19_writeData_bits_strb,
  output         io_HBM_interface_19_writeData_bits_last,
  output         io_HBM_interface_19_writeResp_ready,
  input          io_HBM_interface_19_writeResp_valid,
  input  [5:0]   io_HBM_interface_19_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_19_writeResp_bits_resp,
  input          io_HBM_interface_19_readAddr_ready,
  output         io_HBM_interface_19_readAddr_valid,
  output [63:0]  io_HBM_interface_19_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_19_readAddr_bits_len,
  output [5:0]   io_HBM_interface_19_readAddr_bits_id,
  output         io_HBM_interface_19_readData_ready,
  input          io_HBM_interface_19_readData_valid,
  input  [255:0] io_HBM_interface_19_readData_bits_data,
  input  [5:0]   io_HBM_interface_19_readData_bits_id,
  input          io_HBM_interface_19_readData_bits_last,
  input  [1:0]   io_HBM_interface_19_readData_bits_resp,
  input          io_HBM_interface_20_writeAddr_ready,
  output         io_HBM_interface_20_writeAddr_valid,
  output [63:0]  io_HBM_interface_20_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_20_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_20_writeAddr_bits_id,
  input          io_HBM_interface_20_writeData_ready,
  output         io_HBM_interface_20_writeData_valid,
  output [255:0] io_HBM_interface_20_writeData_bits_data,
  output [31:0]  io_HBM_interface_20_writeData_bits_strb,
  output         io_HBM_interface_20_writeData_bits_last,
  output         io_HBM_interface_20_writeResp_ready,
  input          io_HBM_interface_20_writeResp_valid,
  input  [5:0]   io_HBM_interface_20_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_20_writeResp_bits_resp,
  input          io_HBM_interface_20_readAddr_ready,
  output         io_HBM_interface_20_readAddr_valid,
  output [63:0]  io_HBM_interface_20_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_20_readAddr_bits_len,
  output [5:0]   io_HBM_interface_20_readAddr_bits_id,
  output         io_HBM_interface_20_readData_ready,
  input          io_HBM_interface_20_readData_valid,
  input  [255:0] io_HBM_interface_20_readData_bits_data,
  input  [5:0]   io_HBM_interface_20_readData_bits_id,
  input          io_HBM_interface_20_readData_bits_last,
  input  [1:0]   io_HBM_interface_20_readData_bits_resp,
  input          io_HBM_interface_21_writeAddr_ready,
  output         io_HBM_interface_21_writeAddr_valid,
  output [63:0]  io_HBM_interface_21_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_21_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_21_writeAddr_bits_id,
  input          io_HBM_interface_21_writeData_ready,
  output         io_HBM_interface_21_writeData_valid,
  output [255:0] io_HBM_interface_21_writeData_bits_data,
  output [31:0]  io_HBM_interface_21_writeData_bits_strb,
  output         io_HBM_interface_21_writeData_bits_last,
  output         io_HBM_interface_21_writeResp_ready,
  input          io_HBM_interface_21_writeResp_valid,
  input  [5:0]   io_HBM_interface_21_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_21_writeResp_bits_resp,
  input          io_HBM_interface_21_readAddr_ready,
  output         io_HBM_interface_21_readAddr_valid,
  output [63:0]  io_HBM_interface_21_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_21_readAddr_bits_len,
  output [5:0]   io_HBM_interface_21_readAddr_bits_id,
  output         io_HBM_interface_21_readData_ready,
  input          io_HBM_interface_21_readData_valid,
  input  [255:0] io_HBM_interface_21_readData_bits_data,
  input  [5:0]   io_HBM_interface_21_readData_bits_id,
  input          io_HBM_interface_21_readData_bits_last,
  input  [1:0]   io_HBM_interface_21_readData_bits_resp,
  input          io_HBM_interface_22_writeAddr_ready,
  output         io_HBM_interface_22_writeAddr_valid,
  output [63:0]  io_HBM_interface_22_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_22_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_22_writeAddr_bits_id,
  input          io_HBM_interface_22_writeData_ready,
  output         io_HBM_interface_22_writeData_valid,
  output [255:0] io_HBM_interface_22_writeData_bits_data,
  output [31:0]  io_HBM_interface_22_writeData_bits_strb,
  output         io_HBM_interface_22_writeData_bits_last,
  output         io_HBM_interface_22_writeResp_ready,
  input          io_HBM_interface_22_writeResp_valid,
  input  [5:0]   io_HBM_interface_22_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_22_writeResp_bits_resp,
  input          io_HBM_interface_22_readAddr_ready,
  output         io_HBM_interface_22_readAddr_valid,
  output [63:0]  io_HBM_interface_22_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_22_readAddr_bits_len,
  output [5:0]   io_HBM_interface_22_readAddr_bits_id,
  output         io_HBM_interface_22_readData_ready,
  input          io_HBM_interface_22_readData_valid,
  input  [255:0] io_HBM_interface_22_readData_bits_data,
  input  [5:0]   io_HBM_interface_22_readData_bits_id,
  input          io_HBM_interface_22_readData_bits_last,
  input  [1:0]   io_HBM_interface_22_readData_bits_resp,
  input          io_HBM_interface_23_writeAddr_ready,
  output         io_HBM_interface_23_writeAddr_valid,
  output [63:0]  io_HBM_interface_23_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_23_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_23_writeAddr_bits_id,
  input          io_HBM_interface_23_writeData_ready,
  output         io_HBM_interface_23_writeData_valid,
  output [255:0] io_HBM_interface_23_writeData_bits_data,
  output [31:0]  io_HBM_interface_23_writeData_bits_strb,
  output         io_HBM_interface_23_writeData_bits_last,
  output         io_HBM_interface_23_writeResp_ready,
  input          io_HBM_interface_23_writeResp_valid,
  input  [5:0]   io_HBM_interface_23_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_23_writeResp_bits_resp,
  input          io_HBM_interface_23_readAddr_ready,
  output         io_HBM_interface_23_readAddr_valid,
  output [63:0]  io_HBM_interface_23_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_23_readAddr_bits_len,
  output [5:0]   io_HBM_interface_23_readAddr_bits_id,
  output         io_HBM_interface_23_readData_ready,
  input          io_HBM_interface_23_readData_valid,
  input  [255:0] io_HBM_interface_23_readData_bits_data,
  input  [5:0]   io_HBM_interface_23_readData_bits_id,
  input          io_HBM_interface_23_readData_bits_last,
  input  [1:0]   io_HBM_interface_23_readData_bits_resp,
  input          io_HBM_interface_24_writeAddr_ready,
  output         io_HBM_interface_24_writeAddr_valid,
  output [63:0]  io_HBM_interface_24_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_24_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_24_writeAddr_bits_id,
  input          io_HBM_interface_24_writeData_ready,
  output         io_HBM_interface_24_writeData_valid,
  output [255:0] io_HBM_interface_24_writeData_bits_data,
  output [31:0]  io_HBM_interface_24_writeData_bits_strb,
  output         io_HBM_interface_24_writeData_bits_last,
  output         io_HBM_interface_24_writeResp_ready,
  input          io_HBM_interface_24_writeResp_valid,
  input  [5:0]   io_HBM_interface_24_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_24_writeResp_bits_resp,
  input          io_HBM_interface_24_readAddr_ready,
  output         io_HBM_interface_24_readAddr_valid,
  output [63:0]  io_HBM_interface_24_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_24_readAddr_bits_len,
  output [5:0]   io_HBM_interface_24_readAddr_bits_id,
  output         io_HBM_interface_24_readData_ready,
  input          io_HBM_interface_24_readData_valid,
  input  [255:0] io_HBM_interface_24_readData_bits_data,
  input  [5:0]   io_HBM_interface_24_readData_bits_id,
  input          io_HBM_interface_24_readData_bits_last,
  input  [1:0]   io_HBM_interface_24_readData_bits_resp,
  input          io_HBM_interface_25_writeAddr_ready,
  output         io_HBM_interface_25_writeAddr_valid,
  output [63:0]  io_HBM_interface_25_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_25_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_25_writeAddr_bits_id,
  input          io_HBM_interface_25_writeData_ready,
  output         io_HBM_interface_25_writeData_valid,
  output [255:0] io_HBM_interface_25_writeData_bits_data,
  output [31:0]  io_HBM_interface_25_writeData_bits_strb,
  output         io_HBM_interface_25_writeData_bits_last,
  output         io_HBM_interface_25_writeResp_ready,
  input          io_HBM_interface_25_writeResp_valid,
  input  [5:0]   io_HBM_interface_25_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_25_writeResp_bits_resp,
  input          io_HBM_interface_25_readAddr_ready,
  output         io_HBM_interface_25_readAddr_valid,
  output [63:0]  io_HBM_interface_25_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_25_readAddr_bits_len,
  output [5:0]   io_HBM_interface_25_readAddr_bits_id,
  output         io_HBM_interface_25_readData_ready,
  input          io_HBM_interface_25_readData_valid,
  input  [255:0] io_HBM_interface_25_readData_bits_data,
  input  [5:0]   io_HBM_interface_25_readData_bits_id,
  input          io_HBM_interface_25_readData_bits_last,
  input  [1:0]   io_HBM_interface_25_readData_bits_resp,
  input          io_HBM_interface_26_writeAddr_ready,
  output         io_HBM_interface_26_writeAddr_valid,
  output [63:0]  io_HBM_interface_26_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_26_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_26_writeAddr_bits_id,
  input          io_HBM_interface_26_writeData_ready,
  output         io_HBM_interface_26_writeData_valid,
  output [255:0] io_HBM_interface_26_writeData_bits_data,
  output [31:0]  io_HBM_interface_26_writeData_bits_strb,
  output         io_HBM_interface_26_writeData_bits_last,
  output         io_HBM_interface_26_writeResp_ready,
  input          io_HBM_interface_26_writeResp_valid,
  input  [5:0]   io_HBM_interface_26_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_26_writeResp_bits_resp,
  input          io_HBM_interface_26_readAddr_ready,
  output         io_HBM_interface_26_readAddr_valid,
  output [63:0]  io_HBM_interface_26_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_26_readAddr_bits_len,
  output [5:0]   io_HBM_interface_26_readAddr_bits_id,
  output         io_HBM_interface_26_readData_ready,
  input          io_HBM_interface_26_readData_valid,
  input  [255:0] io_HBM_interface_26_readData_bits_data,
  input  [5:0]   io_HBM_interface_26_readData_bits_id,
  input          io_HBM_interface_26_readData_bits_last,
  input  [1:0]   io_HBM_interface_26_readData_bits_resp,
  input          io_HBM_interface_27_writeAddr_ready,
  output         io_HBM_interface_27_writeAddr_valid,
  output [63:0]  io_HBM_interface_27_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_27_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_27_writeAddr_bits_id,
  input          io_HBM_interface_27_writeData_ready,
  output         io_HBM_interface_27_writeData_valid,
  output [255:0] io_HBM_interface_27_writeData_bits_data,
  output [31:0]  io_HBM_interface_27_writeData_bits_strb,
  output         io_HBM_interface_27_writeData_bits_last,
  output         io_HBM_interface_27_writeResp_ready,
  input          io_HBM_interface_27_writeResp_valid,
  input  [5:0]   io_HBM_interface_27_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_27_writeResp_bits_resp,
  input          io_HBM_interface_27_readAddr_ready,
  output         io_HBM_interface_27_readAddr_valid,
  output [63:0]  io_HBM_interface_27_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_27_readAddr_bits_len,
  output [5:0]   io_HBM_interface_27_readAddr_bits_id,
  output         io_HBM_interface_27_readData_ready,
  input          io_HBM_interface_27_readData_valid,
  input  [255:0] io_HBM_interface_27_readData_bits_data,
  input  [5:0]   io_HBM_interface_27_readData_bits_id,
  input          io_HBM_interface_27_readData_bits_last,
  input  [1:0]   io_HBM_interface_27_readData_bits_resp,
  input          io_HBM_interface_28_writeAddr_ready,
  output         io_HBM_interface_28_writeAddr_valid,
  output [63:0]  io_HBM_interface_28_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_28_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_28_writeAddr_bits_id,
  input          io_HBM_interface_28_writeData_ready,
  output         io_HBM_interface_28_writeData_valid,
  output [255:0] io_HBM_interface_28_writeData_bits_data,
  output [31:0]  io_HBM_interface_28_writeData_bits_strb,
  output         io_HBM_interface_28_writeData_bits_last,
  output         io_HBM_interface_28_writeResp_ready,
  input          io_HBM_interface_28_writeResp_valid,
  input  [5:0]   io_HBM_interface_28_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_28_writeResp_bits_resp,
  input          io_HBM_interface_28_readAddr_ready,
  output         io_HBM_interface_28_readAddr_valid,
  output [63:0]  io_HBM_interface_28_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_28_readAddr_bits_len,
  output [5:0]   io_HBM_interface_28_readAddr_bits_id,
  output         io_HBM_interface_28_readData_ready,
  input          io_HBM_interface_28_readData_valid,
  input  [255:0] io_HBM_interface_28_readData_bits_data,
  input  [5:0]   io_HBM_interface_28_readData_bits_id,
  input          io_HBM_interface_28_readData_bits_last,
  input  [1:0]   io_HBM_interface_28_readData_bits_resp,
  input          io_HBM_interface_29_writeAddr_ready,
  output         io_HBM_interface_29_writeAddr_valid,
  output [63:0]  io_HBM_interface_29_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_29_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_29_writeAddr_bits_id,
  input          io_HBM_interface_29_writeData_ready,
  output         io_HBM_interface_29_writeData_valid,
  output [255:0] io_HBM_interface_29_writeData_bits_data,
  output [31:0]  io_HBM_interface_29_writeData_bits_strb,
  output         io_HBM_interface_29_writeData_bits_last,
  output         io_HBM_interface_29_writeResp_ready,
  input          io_HBM_interface_29_writeResp_valid,
  input  [5:0]   io_HBM_interface_29_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_29_writeResp_bits_resp,
  input          io_HBM_interface_29_readAddr_ready,
  output         io_HBM_interface_29_readAddr_valid,
  output [63:0]  io_HBM_interface_29_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_29_readAddr_bits_len,
  output [5:0]   io_HBM_interface_29_readAddr_bits_id,
  output         io_HBM_interface_29_readData_ready,
  input          io_HBM_interface_29_readData_valid,
  input  [255:0] io_HBM_interface_29_readData_bits_data,
  input  [5:0]   io_HBM_interface_29_readData_bits_id,
  input          io_HBM_interface_29_readData_bits_last,
  input  [1:0]   io_HBM_interface_29_readData_bits_resp,
  input          io_HBM_interface_30_writeAddr_ready,
  output         io_HBM_interface_30_writeAddr_valid,
  output [63:0]  io_HBM_interface_30_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_30_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_30_writeAddr_bits_id,
  input          io_HBM_interface_30_writeData_ready,
  output         io_HBM_interface_30_writeData_valid,
  output [255:0] io_HBM_interface_30_writeData_bits_data,
  output [31:0]  io_HBM_interface_30_writeData_bits_strb,
  output         io_HBM_interface_30_writeData_bits_last,
  output         io_HBM_interface_30_writeResp_ready,
  input          io_HBM_interface_30_writeResp_valid,
  input  [5:0]   io_HBM_interface_30_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_30_writeResp_bits_resp,
  input          io_HBM_interface_30_readAddr_ready,
  output         io_HBM_interface_30_readAddr_valid,
  output [63:0]  io_HBM_interface_30_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_30_readAddr_bits_len,
  output [5:0]   io_HBM_interface_30_readAddr_bits_id,
  output         io_HBM_interface_30_readData_ready,
  input          io_HBM_interface_30_readData_valid,
  input  [255:0] io_HBM_interface_30_readData_bits_data,
  input  [5:0]   io_HBM_interface_30_readData_bits_id,
  input          io_HBM_interface_30_readData_bits_last,
  input  [1:0]   io_HBM_interface_30_readData_bits_resp,
  input          io_HBM_interface_31_writeAddr_ready,
  output         io_HBM_interface_31_writeAddr_valid,
  output [63:0]  io_HBM_interface_31_writeAddr_bits_addr,
  output [7:0]   io_HBM_interface_31_writeAddr_bits_len,
  output [5:0]   io_HBM_interface_31_writeAddr_bits_id,
  input          io_HBM_interface_31_writeData_ready,
  output         io_HBM_interface_31_writeData_valid,
  output [255:0] io_HBM_interface_31_writeData_bits_data,
  output [31:0]  io_HBM_interface_31_writeData_bits_strb,
  output         io_HBM_interface_31_writeData_bits_last,
  output         io_HBM_interface_31_writeResp_ready,
  input          io_HBM_interface_31_writeResp_valid,
  input  [5:0]   io_HBM_interface_31_writeResp_bits_id,
  input  [1:0]   io_HBM_interface_31_writeResp_bits_resp,
  input          io_HBM_interface_31_readAddr_ready,
  output         io_HBM_interface_31_readAddr_valid,
  output [63:0]  io_HBM_interface_31_readAddr_bits_addr,
  output [7:0]   io_HBM_interface_31_readAddr_bits_len,
  output [5:0]   io_HBM_interface_31_readAddr_bits_id,
  output         io_HBM_interface_31_readData_ready,
  input          io_HBM_interface_31_readData_valid,
  input  [255:0] io_HBM_interface_31_readData_bits_data,
  input  [5:0]   io_HBM_interface_31_readData_bits_id,
  input          io_HBM_interface_31_readData_bits_last,
  input  [1:0]   io_HBM_interface_31_readData_bits_resp
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  Memory_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_1_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_1_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_1_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_1_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_1_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_1_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_1_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_1_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_1_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_1_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_1_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_1_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_1_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_1_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_1_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_1_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_1_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_2_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_2_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_2_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_2_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_2_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_2_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_2_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_2_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_2_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_2_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_2_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_2_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_2_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_2_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_2_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_2_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_2_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_3_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_3_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_3_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_3_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_3_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_3_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_3_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_3_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_3_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_3_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_3_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_3_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_3_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_3_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_3_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_3_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_3_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_4_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_4_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_4_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_4_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_4_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_4_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_4_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_4_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_4_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_4_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_4_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_4_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_4_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_4_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_4_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_4_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_4_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_5_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_5_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_5_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_5_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_5_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_5_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_5_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_5_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_5_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_5_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_5_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_5_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_5_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_5_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_5_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_5_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_5_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_6_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_6_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_6_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_6_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_6_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_6_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_6_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_6_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_6_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_6_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_6_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_6_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_6_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_6_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_6_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_6_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_6_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_7_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_7_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_7_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_7_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_7_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_7_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_7_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_7_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_7_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_7_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_7_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_7_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_7_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_7_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_7_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_7_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_7_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_8_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_8_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_8_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_8_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_8_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_8_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_8_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_8_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_8_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_8_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_8_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_8_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_8_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_8_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_8_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_8_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_8_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_9_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_9_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_9_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_9_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_9_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_9_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_9_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_9_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_9_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_9_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_9_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_9_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_9_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_9_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_9_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_9_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_9_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_10_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_10_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_10_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_10_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_10_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_10_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_10_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_10_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_10_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_10_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_10_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_10_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_10_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_10_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_10_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_10_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_10_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_11_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_11_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_11_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_11_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_11_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_11_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_11_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_11_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_11_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_11_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_11_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_11_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_11_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_11_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_11_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_11_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_11_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_12_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_12_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_12_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_12_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_12_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_12_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_12_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_12_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_12_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_12_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_12_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_12_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_12_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_12_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_12_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_12_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_12_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_13_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_13_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_13_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_13_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_13_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_13_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_13_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_13_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_13_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_13_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_13_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_13_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_13_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_13_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_13_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_13_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_13_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_14_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_14_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_14_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_14_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_14_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_14_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_14_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_14_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_14_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_14_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_14_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_14_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_14_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_14_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_14_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_14_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_14_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_15_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_15_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_15_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_15_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_15_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_15_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_15_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_15_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_15_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_15_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_15_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_15_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_15_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_15_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_15_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_15_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_15_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_16_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_16_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_16_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_16_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_16_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_16_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_16_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_16_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_16_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_16_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_16_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_16_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_16_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_16_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_16_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_16_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_16_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_17_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_17_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_17_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_17_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_17_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_17_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_17_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_17_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_17_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_17_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_17_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_17_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_17_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_17_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_17_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_17_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_17_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_18_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_18_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_18_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_18_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_18_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_18_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_18_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_18_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_18_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_18_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_18_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_18_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_18_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_18_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_18_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_18_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_18_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_19_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_19_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_19_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_19_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_19_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_19_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_19_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_19_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_19_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_19_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_19_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_19_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_19_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_19_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_19_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_19_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_19_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_20_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_20_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_20_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_20_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_20_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_20_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_20_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_20_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_20_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_20_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_20_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_20_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_20_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_20_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_20_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_20_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_20_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_21_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_21_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_21_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_21_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_21_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_21_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_21_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_21_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_21_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_21_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_21_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_21_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_21_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_21_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_21_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_21_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_21_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_22_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_22_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_22_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_22_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_22_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_22_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_22_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_22_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_22_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_22_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_22_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_22_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_22_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_22_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_22_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_22_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_22_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_23_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_23_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_23_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_23_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_23_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_23_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_23_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_23_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_23_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_23_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_23_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_23_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_23_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_23_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_23_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_23_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_23_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_24_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_24_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_24_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_24_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_24_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_24_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_24_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_24_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_24_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_24_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_24_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_24_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_24_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_24_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_24_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_24_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_24_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_25_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_25_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_25_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_25_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_25_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_25_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_25_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_25_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_25_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_25_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_25_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_25_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_25_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_25_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_25_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_25_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_25_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_26_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_26_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_26_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_26_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_26_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_26_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_26_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_26_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_26_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_26_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_26_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_26_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_26_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_26_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_26_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_26_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_26_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_27_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_27_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_27_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_27_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_27_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_27_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_27_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_27_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_27_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_27_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_27_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_27_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_27_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_27_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_27_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_27_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_27_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_28_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_28_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_28_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_28_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_28_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_28_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_28_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_28_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_28_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_28_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_28_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_28_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_28_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_28_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_28_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_28_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_28_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_29_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_29_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_29_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_29_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_29_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_29_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_29_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_29_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_29_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_29_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_29_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_29_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_29_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_29_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_29_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_29_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_29_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_30_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_30_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_30_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_30_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_30_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_30_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_30_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_30_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_30_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_30_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_30_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_30_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_30_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_30_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_30_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_30_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_30_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_reset; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_R_array_index_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_R_array_index_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_R_array_index_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_R_array_index_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_R_array_index_3_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_p1_end; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_level; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_push_or_pull_state; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_offsets_CSR_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_offsets_CSR_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_offsets_CSC_R_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_offsets_CSC_C_offset; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_offsets_level_offset; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_uram_out_a_0; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_uram_out_a_1; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_uram_out_a_2; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_uram_out_a_3; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_kernel_count; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_master_finish; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_node_num; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_neighbour_cnt; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_mem_end; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_0_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_0_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_neighbours_0_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_1_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_1_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_neighbours_1_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_2_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_2_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_neighbours_2_bits; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_3_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_neighbours_3_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_neighbours_3_bits; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_31_io_uram_addr_a_0; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_31_io_uram_addr_a_1; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_31_io_uram_addr_a_2; // @[SLR0_Mem.scala 43:27]
  wire [19:0] Memory_31_io_uram_addr_a_3; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_write_finish; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_31_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_31_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_31_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [31:0] Memory_31_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_writeResp_valid; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_31_io_HBM_interface_writeResp_bits_id; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_31_io_HBM_interface_writeResp_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_readAddr_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 43:27]
  wire [63:0] Memory_31_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 43:27]
  wire [7:0] Memory_31_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_31_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_readData_valid; // @[SLR0_Mem.scala 43:27]
  wire [255:0] Memory_31_io_HBM_interface_readData_bits_data; // @[SLR0_Mem.scala 43:27]
  wire [5:0] Memory_31_io_HBM_interface_readData_bits_id; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_HBM_interface_readData_bits_last; // @[SLR0_Mem.scala 43:27]
  wire [1:0] Memory_31_io_HBM_interface_readData_bits_resp; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_mem_clock; // @[SLR0_Mem.scala 43:27]
  wire  Memory_31_io_reset_h; // @[SLR0_Mem.scala 43:27]
  wire  copy_level_clock; // @[SLR0_Mem.scala 46:28]
  wire  copy_level_reset; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_in; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_0; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_1; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_2; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_3; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_4; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_5; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_6; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_7; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_8; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_9; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_10; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_11; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_12; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_13; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_14; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_15; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_16; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_17; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_18; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_19; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_20; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_21; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_22; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_23; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_24; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_25; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_26; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_27; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_28; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_29; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_30; // @[SLR0_Mem.scala 46:28]
  wire [31:0] copy_level_io_out_31; // @[SLR0_Mem.scala 46:28]
  wire  copy_kernel_count_clock; // @[SLR0_Mem.scala 47:35]
  wire  copy_kernel_count_reset; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_in; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_0; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_1; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_2; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_3; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_4; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_5; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_6; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_7; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_8; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_9; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_10; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_11; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_12; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_13; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_14; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_15; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_16; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_17; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_18; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_19; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_20; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_21; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_22; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_23; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_24; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_25; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_26; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_27; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_28; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_29; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_30; // @[SLR0_Mem.scala 47:35]
  wire [31:0] copy_kernel_count_io_out_31; // @[SLR0_Mem.scala 47:35]
  wire  copy_master_finish_clock; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_reset; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_in; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_0; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_1; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_2; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_3; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_4; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_5; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_6; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_7; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_8; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_9; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_10; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_11; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_12; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_13; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_14; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_15; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_16; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_17; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_18; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_19; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_20; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_21; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_22; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_23; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_24; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_25; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_26; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_27; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_28; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_29; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_30; // @[SLR0_Mem.scala 48:36]
  wire  copy_master_finish_io_out_31; // @[SLR0_Mem.scala 48:36]
  wire  copy_node_num_clock; // @[SLR0_Mem.scala 49:31]
  wire  copy_node_num_reset; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_in; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_0; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_1; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_2; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_3; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_4; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_5; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_6; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_7; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_8; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_9; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_10; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_11; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_12; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_13; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_14; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_15; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_16; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_17; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_18; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_19; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_20; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_21; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_22; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_23; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_24; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_25; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_26; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_27; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_28; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_29; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_30; // @[SLR0_Mem.scala 49:31]
  wire [31:0] copy_node_num_io_out_31; // @[SLR0_Mem.scala 49:31]
  wire  copy_push_or_pull_clock; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_reset; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_in; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_0; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_1; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_2; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_3; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_4; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_5; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_6; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_7; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_8; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_9; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_10; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_11; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_12; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_13; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_14; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_15; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_16; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_17; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_18; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_19; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_20; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_21; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_22; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_23; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_24; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_25; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_26; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_27; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_28; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_29; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_30; // @[SLR0_Mem.scala 50:35]
  wire  copy_push_or_pull_io_out_31; // @[SLR0_Mem.scala 50:35]
  wire  copy_offset_CSR_R_offset_clock; // @[SLR0_Mem.scala 51:42]
  wire  copy_offset_CSR_R_offset_reset; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_in; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_0; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_1; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_2; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_3; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_4; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_5; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_6; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_7; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_8; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_9; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_10; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_11; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_12; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_13; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_14; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_15; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_16; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_17; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_18; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_19; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_20; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_21; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_22; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_23; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_24; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_25; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_26; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_27; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_28; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_29; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_30; // @[SLR0_Mem.scala 51:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_31; // @[SLR0_Mem.scala 51:42]
  wire  copy_offset_CSR_C_offset_clock; // @[SLR0_Mem.scala 52:42]
  wire  copy_offset_CSR_C_offset_reset; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_in; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_0; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_1; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_2; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_3; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_4; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_5; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_6; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_7; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_8; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_9; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_10; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_11; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_12; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_13; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_14; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_15; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_16; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_17; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_18; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_19; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_20; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_21; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_22; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_23; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_24; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_25; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_26; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_27; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_28; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_29; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_30; // @[SLR0_Mem.scala 52:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_31; // @[SLR0_Mem.scala 52:42]
  wire  copy_offset_CSC_R_offset_clock; // @[SLR0_Mem.scala 53:42]
  wire  copy_offset_CSC_R_offset_reset; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_in; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_0; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_1; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_2; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_3; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_4; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_5; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_6; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_7; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_8; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_9; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_10; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_11; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_12; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_13; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_14; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_15; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_16; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_17; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_18; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_19; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_20; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_21; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_22; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_23; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_24; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_25; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_26; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_27; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_28; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_29; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_30; // @[SLR0_Mem.scala 53:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_31; // @[SLR0_Mem.scala 53:42]
  wire  copy_offset_CSC_C_offset_clock; // @[SLR0_Mem.scala 54:42]
  wire  copy_offset_CSC_C_offset_reset; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_in; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_0; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_1; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_2; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_3; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_4; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_5; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_6; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_7; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_8; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_9; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_10; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_11; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_12; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_13; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_14; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_15; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_16; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_17; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_18; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_19; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_20; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_21; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_22; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_23; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_24; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_25; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_26; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_27; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_28; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_29; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_30; // @[SLR0_Mem.scala 54:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_31; // @[SLR0_Mem.scala 54:42]
  wire  copy_offset_level_offset_clock; // @[SLR0_Mem.scala 55:42]
  wire  copy_offset_level_offset_reset; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_in; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_0; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_1; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_2; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_3; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_4; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_5; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_6; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_7; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_8; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_9; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_10; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_11; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_12; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_13; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_14; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_15; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_16; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_17; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_18; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_19; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_20; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_21; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_22; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_23; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_24; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_25; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_26; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_27; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_28; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_29; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_30; // @[SLR0_Mem.scala 55:42]
  wire [31:0] copy_offset_level_offset_io_out_31; // @[SLR0_Mem.scala 55:42]
  reg [31:0] _T; // @[SLR0_Mem.scala 64:46]
  reg [31:0] _T_1; // @[SLR0_Mem.scala 65:46]
  reg [31:0] _T_2; // @[SLR0_Mem.scala 66:46]
  reg [31:0] _T_3; // @[SLR0_Mem.scala 67:46]
  reg [31:0] _T_4; // @[SLR0_Mem.scala 68:46]
  wire [32:0] _T_5 = copy_node_num_io_out_0 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_6 = copy_node_num_io_out_0 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_7 = _T_6 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_8 = _T_6 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_9 = _T_8 - 32'h0; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_10 = _T_8 - 32'h0; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_0 = _T_10[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_11 = {{5'd0}, _T_10[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_12 = copy_node_num_io_out_1 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_13 = copy_node_num_io_out_1 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_14 = _T_13 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_15 = _T_13 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_16 = _T_15 - 32'h1; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_17 = _T_15 - 32'h1; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_1 = _T_17[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_18 = {{5'd0}, _T_17[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_19 = copy_node_num_io_out_2 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_20 = copy_node_num_io_out_2 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_21 = _T_20 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_22 = _T_20 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_23 = _T_22 - 32'h2; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_24 = _T_22 - 32'h2; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_2 = _T_24[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_25 = {{5'd0}, _T_24[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_26 = copy_node_num_io_out_3 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_27 = copy_node_num_io_out_3 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_28 = _T_27 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_29 = _T_27 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_30 = _T_29 - 32'h3; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_31 = _T_29 - 32'h3; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_3 = _T_31[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_32 = {{5'd0}, _T_31[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_33 = copy_node_num_io_out_4 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_34 = copy_node_num_io_out_4 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_35 = _T_34 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_36 = _T_34 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_37 = _T_36 - 32'h4; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_38 = _T_36 - 32'h4; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_4 = _T_38[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_39 = {{5'd0}, _T_38[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_40 = copy_node_num_io_out_5 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_41 = copy_node_num_io_out_5 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_42 = _T_41 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_43 = _T_41 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_44 = _T_43 - 32'h5; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_45 = _T_43 - 32'h5; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_5 = _T_45[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_46 = {{5'd0}, _T_45[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_47 = copy_node_num_io_out_6 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_48 = copy_node_num_io_out_6 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_49 = _T_48 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_50 = _T_48 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_51 = _T_50 - 32'h6; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_52 = _T_50 - 32'h6; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_6 = _T_52[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_53 = {{5'd0}, _T_52[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_54 = copy_node_num_io_out_7 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_55 = copy_node_num_io_out_7 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_56 = _T_55 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_57 = _T_55 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_58 = _T_57 - 32'h7; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_59 = _T_57 - 32'h7; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_7 = _T_59[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_60 = {{5'd0}, _T_59[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_61 = copy_node_num_io_out_8 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_62 = copy_node_num_io_out_8 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_63 = _T_62 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_64 = _T_62 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_65 = _T_64 - 32'h8; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_66 = _T_64 - 32'h8; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_8 = _T_66[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_67 = {{5'd0}, _T_66[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_68 = copy_node_num_io_out_9 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_69 = copy_node_num_io_out_9 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_70 = _T_69 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_71 = _T_69 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_72 = _T_71 - 32'h9; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_73 = _T_71 - 32'h9; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_9 = _T_73[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_74 = {{5'd0}, _T_73[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_75 = copy_node_num_io_out_10 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_76 = copy_node_num_io_out_10 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_77 = _T_76 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_78 = _T_76 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_79 = _T_78 - 32'ha; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_80 = _T_78 - 32'ha; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_10 = _T_80[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_81 = {{5'd0}, _T_80[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_82 = copy_node_num_io_out_11 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_83 = copy_node_num_io_out_11 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_84 = _T_83 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_85 = _T_83 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_86 = _T_85 - 32'hb; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_87 = _T_85 - 32'hb; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_11 = _T_87[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_88 = {{5'd0}, _T_87[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_89 = copy_node_num_io_out_12 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_90 = copy_node_num_io_out_12 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_91 = _T_90 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_92 = _T_90 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_93 = _T_92 - 32'hc; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_94 = _T_92 - 32'hc; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_12 = _T_94[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_95 = {{5'd0}, _T_94[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_96 = copy_node_num_io_out_13 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_97 = copy_node_num_io_out_13 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_98 = _T_97 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_99 = _T_97 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_100 = _T_99 - 32'hd; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_101 = _T_99 - 32'hd; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_13 = _T_101[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_102 = {{5'd0}, _T_101[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_103 = copy_node_num_io_out_14 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_104 = copy_node_num_io_out_14 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_105 = _T_104 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_106 = _T_104 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_107 = _T_106 - 32'he; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_108 = _T_106 - 32'he; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_14 = _T_108[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_109 = {{5'd0}, _T_108[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_110 = copy_node_num_io_out_15 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_111 = copy_node_num_io_out_15 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_112 = _T_111 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_113 = _T_111 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_114 = _T_113 - 32'hf; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_115 = _T_113 - 32'hf; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_15 = _T_115[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_116 = {{5'd0}, _T_115[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_117 = copy_node_num_io_out_16 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_118 = copy_node_num_io_out_16 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_119 = _T_118 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_120 = _T_118 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_121 = _T_120 - 32'h10; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_122 = _T_120 - 32'h10; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_16 = _T_122[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_123 = {{5'd0}, _T_122[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_124 = copy_node_num_io_out_17 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_125 = copy_node_num_io_out_17 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_126 = _T_125 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_127 = _T_125 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_128 = _T_127 - 32'h11; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_129 = _T_127 - 32'h11; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_17 = _T_129[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_130 = {{5'd0}, _T_129[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_131 = copy_node_num_io_out_18 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_132 = copy_node_num_io_out_18 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_133 = _T_132 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_134 = _T_132 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_135 = _T_134 - 32'h12; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_136 = _T_134 - 32'h12; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_18 = _T_136[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_137 = {{5'd0}, _T_136[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_138 = copy_node_num_io_out_19 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_139 = copy_node_num_io_out_19 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_140 = _T_139 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_141 = _T_139 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_142 = _T_141 - 32'h13; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_143 = _T_141 - 32'h13; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_19 = _T_143[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_144 = {{5'd0}, _T_143[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_145 = copy_node_num_io_out_20 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_146 = copy_node_num_io_out_20 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_147 = _T_146 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_148 = _T_146 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_149 = _T_148 - 32'h14; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_150 = _T_148 - 32'h14; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_20 = _T_150[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_151 = {{5'd0}, _T_150[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_152 = copy_node_num_io_out_21 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_153 = copy_node_num_io_out_21 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_154 = _T_153 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_155 = _T_153 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_156 = _T_155 - 32'h15; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_157 = _T_155 - 32'h15; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_21 = _T_157[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_158 = {{5'd0}, _T_157[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_159 = copy_node_num_io_out_22 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_160 = copy_node_num_io_out_22 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_161 = _T_160 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_162 = _T_160 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_163 = _T_162 - 32'h16; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_164 = _T_162 - 32'h16; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_22 = _T_164[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_165 = {{5'd0}, _T_164[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_166 = copy_node_num_io_out_23 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_167 = copy_node_num_io_out_23 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_168 = _T_167 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_169 = _T_167 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_170 = _T_169 - 32'h17; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_171 = _T_169 - 32'h17; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_23 = _T_171[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_172 = {{5'd0}, _T_171[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_173 = copy_node_num_io_out_24 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_174 = copy_node_num_io_out_24 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_175 = _T_174 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_176 = _T_174 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_177 = _T_176 - 32'h18; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_178 = _T_176 - 32'h18; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_24 = _T_178[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_179 = {{5'd0}, _T_178[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_180 = copy_node_num_io_out_25 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_181 = copy_node_num_io_out_25 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_182 = _T_181 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_183 = _T_181 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_184 = _T_183 - 32'h19; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_185 = _T_183 - 32'h19; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_25 = _T_185[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_186 = {{5'd0}, _T_185[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_187 = copy_node_num_io_out_26 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_188 = copy_node_num_io_out_26 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_189 = _T_188 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_190 = _T_188 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_191 = _T_190 - 32'h1a; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_192 = _T_190 - 32'h1a; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_26 = _T_192[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_193 = {{5'd0}, _T_192[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_194 = copy_node_num_io_out_27 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_195 = copy_node_num_io_out_27 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_196 = _T_195 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_197 = _T_195 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_198 = _T_197 - 32'h1b; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_199 = _T_197 - 32'h1b; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_27 = _T_199[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_200 = {{5'd0}, _T_199[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_201 = copy_node_num_io_out_28 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_202 = copy_node_num_io_out_28 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_203 = _T_202 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_204 = _T_202 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_205 = _T_204 - 32'h1c; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_206 = _T_204 - 32'h1c; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_28 = _T_206[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_207 = {{5'd0}, _T_206[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_208 = copy_node_num_io_out_29 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_209 = copy_node_num_io_out_29 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_210 = _T_209 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_211 = _T_209 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_212 = _T_211 - 32'h1d; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_213 = _T_211 - 32'h1d; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_29 = _T_213[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_214 = {{5'd0}, _T_213[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_215 = copy_node_num_io_out_30 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_216 = copy_node_num_io_out_30 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_217 = _T_216 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_218 = _T_216 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_219 = _T_218 - 32'h1e; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_220 = _T_218 - 32'h1e; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_30 = _T_220[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_221 = {{5'd0}, _T_220[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [32:0] _T_222 = copy_node_num_io_out_31 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [31:0] _T_223 = copy_node_num_io_out_31 + 32'h20; // @[SLR0_Mem.scala 76:71]
  wire [32:0] _T_224 = _T_223 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [31:0] _T_225 = _T_223 - 32'h1; // @[SLR0_Mem.scala 76:92]
  wire [32:0] _T_226 = _T_225 - 32'h1f; // @[SLR0_Mem.scala 76:98]
  wire [31:0] _T_227 = _T_225 - 32'h1f; // @[SLR0_Mem.scala 76:98]
  wire [26:0] _GEN_31 = _T_227[31:5]; // @[SLR0_Mem.scala 76:105]
  wire [31:0] _T_228 = {{5'd0}, _T_227[31:5]}; // @[SLR0_Mem.scala 76:105]
  wire [26:0] _GEN_32 = _T_10[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_33 = _T_17[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_34 = _T_24[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_35 = _T_31[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_36 = _T_38[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_37 = _T_45[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_38 = _T_52[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_39 = _T_59[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_40 = _T_66[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_41 = _T_73[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_42 = _T_80[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_43 = _T_87[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_44 = _T_94[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_45 = _T_101[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_46 = _T_108[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_47 = _T_115[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_48 = _T_122[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_49 = _T_129[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_50 = _T_136[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_51 = _T_143[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_52 = _T_150[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_53 = _T_157[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_54 = _T_164[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_55 = _T_171[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_56 = _T_178[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_57 = _T_185[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_58 = _T_192[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_59 = _T_199[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_60 = _T_206[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_61 = _T_213[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_62 = _T_220[31:5]; // @[SLR0_Mem.scala 76:42]
  wire [26:0] _GEN_63 = _T_227[31:5]; // @[SLR0_Mem.scala 76:42]
  Memory Memory ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_clock),
    .reset(Memory_reset),
    .io_R_array_index_0_ready(Memory_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_io_R_array_index_3_bits),
    .io_p1_end(Memory_io_p1_end),
    .io_level(Memory_io_level),
    .io_push_or_pull_state(Memory_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_io_uram_out_a_3),
    .io_kernel_count(Memory_io_kernel_count),
    .io_master_finish(Memory_io_master_finish),
    .io_node_num(Memory_io_node_num),
    .io_neighbour_cnt(Memory_io_neighbour_cnt),
    .io_mem_end(Memory_io_mem_end),
    .io_neighbours_0_ready(Memory_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_io_uram_addr_a_3),
    .io_write_finish(Memory_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_io_mem_clock),
    .io_reset_h(Memory_io_reset_h)
  );
  Memory_1 Memory_1 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_1_clock),
    .reset(Memory_1_reset),
    .io_R_array_index_0_ready(Memory_1_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_1_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_1_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_1_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_1_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_1_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_1_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_1_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_1_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_1_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_1_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_1_io_R_array_index_3_bits),
    .io_p1_end(Memory_1_io_p1_end),
    .io_level(Memory_1_io_level),
    .io_push_or_pull_state(Memory_1_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_1_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_1_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_1_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_1_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_1_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_1_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_1_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_1_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_1_io_uram_out_a_3),
    .io_kernel_count(Memory_1_io_kernel_count),
    .io_master_finish(Memory_1_io_master_finish),
    .io_node_num(Memory_1_io_node_num),
    .io_neighbour_cnt(Memory_1_io_neighbour_cnt),
    .io_mem_end(Memory_1_io_mem_end),
    .io_neighbours_0_ready(Memory_1_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_1_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_1_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_1_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_1_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_1_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_1_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_1_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_1_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_1_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_1_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_1_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_1_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_1_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_1_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_1_io_uram_addr_a_3),
    .io_write_finish(Memory_1_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_1_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_1_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_1_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_1_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_1_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_1_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_1_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_1_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_1_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_1_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_1_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_1_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_1_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_1_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_1_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_1_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_1_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_1_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_1_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_1_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_1_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_1_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_1_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_1_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_1_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_1_io_mem_clock),
    .io_reset_h(Memory_1_io_reset_h)
  );
  Memory_2 Memory_2 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_2_clock),
    .reset(Memory_2_reset),
    .io_R_array_index_0_ready(Memory_2_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_2_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_2_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_2_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_2_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_2_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_2_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_2_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_2_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_2_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_2_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_2_io_R_array_index_3_bits),
    .io_p1_end(Memory_2_io_p1_end),
    .io_level(Memory_2_io_level),
    .io_push_or_pull_state(Memory_2_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_2_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_2_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_2_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_2_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_2_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_2_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_2_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_2_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_2_io_uram_out_a_3),
    .io_kernel_count(Memory_2_io_kernel_count),
    .io_master_finish(Memory_2_io_master_finish),
    .io_node_num(Memory_2_io_node_num),
    .io_neighbour_cnt(Memory_2_io_neighbour_cnt),
    .io_mem_end(Memory_2_io_mem_end),
    .io_neighbours_0_ready(Memory_2_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_2_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_2_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_2_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_2_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_2_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_2_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_2_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_2_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_2_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_2_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_2_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_2_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_2_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_2_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_2_io_uram_addr_a_3),
    .io_write_finish(Memory_2_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_2_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_2_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_2_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_2_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_2_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_2_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_2_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_2_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_2_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_2_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_2_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_2_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_2_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_2_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_2_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_2_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_2_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_2_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_2_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_2_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_2_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_2_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_2_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_2_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_2_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_2_io_mem_clock),
    .io_reset_h(Memory_2_io_reset_h)
  );
  Memory_3 Memory_3 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_3_clock),
    .reset(Memory_3_reset),
    .io_R_array_index_0_ready(Memory_3_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_3_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_3_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_3_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_3_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_3_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_3_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_3_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_3_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_3_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_3_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_3_io_R_array_index_3_bits),
    .io_p1_end(Memory_3_io_p1_end),
    .io_level(Memory_3_io_level),
    .io_push_or_pull_state(Memory_3_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_3_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_3_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_3_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_3_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_3_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_3_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_3_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_3_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_3_io_uram_out_a_3),
    .io_kernel_count(Memory_3_io_kernel_count),
    .io_master_finish(Memory_3_io_master_finish),
    .io_node_num(Memory_3_io_node_num),
    .io_neighbour_cnt(Memory_3_io_neighbour_cnt),
    .io_mem_end(Memory_3_io_mem_end),
    .io_neighbours_0_ready(Memory_3_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_3_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_3_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_3_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_3_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_3_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_3_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_3_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_3_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_3_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_3_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_3_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_3_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_3_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_3_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_3_io_uram_addr_a_3),
    .io_write_finish(Memory_3_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_3_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_3_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_3_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_3_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_3_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_3_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_3_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_3_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_3_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_3_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_3_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_3_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_3_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_3_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_3_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_3_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_3_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_3_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_3_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_3_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_3_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_3_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_3_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_3_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_3_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_3_io_mem_clock),
    .io_reset_h(Memory_3_io_reset_h)
  );
  Memory_4 Memory_4 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_4_clock),
    .reset(Memory_4_reset),
    .io_R_array_index_0_ready(Memory_4_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_4_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_4_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_4_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_4_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_4_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_4_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_4_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_4_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_4_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_4_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_4_io_R_array_index_3_bits),
    .io_p1_end(Memory_4_io_p1_end),
    .io_level(Memory_4_io_level),
    .io_push_or_pull_state(Memory_4_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_4_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_4_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_4_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_4_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_4_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_4_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_4_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_4_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_4_io_uram_out_a_3),
    .io_kernel_count(Memory_4_io_kernel_count),
    .io_master_finish(Memory_4_io_master_finish),
    .io_node_num(Memory_4_io_node_num),
    .io_neighbour_cnt(Memory_4_io_neighbour_cnt),
    .io_mem_end(Memory_4_io_mem_end),
    .io_neighbours_0_ready(Memory_4_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_4_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_4_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_4_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_4_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_4_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_4_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_4_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_4_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_4_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_4_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_4_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_4_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_4_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_4_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_4_io_uram_addr_a_3),
    .io_write_finish(Memory_4_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_4_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_4_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_4_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_4_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_4_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_4_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_4_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_4_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_4_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_4_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_4_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_4_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_4_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_4_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_4_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_4_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_4_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_4_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_4_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_4_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_4_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_4_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_4_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_4_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_4_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_4_io_mem_clock),
    .io_reset_h(Memory_4_io_reset_h)
  );
  Memory_5 Memory_5 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_5_clock),
    .reset(Memory_5_reset),
    .io_R_array_index_0_ready(Memory_5_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_5_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_5_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_5_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_5_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_5_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_5_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_5_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_5_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_5_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_5_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_5_io_R_array_index_3_bits),
    .io_p1_end(Memory_5_io_p1_end),
    .io_level(Memory_5_io_level),
    .io_push_or_pull_state(Memory_5_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_5_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_5_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_5_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_5_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_5_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_5_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_5_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_5_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_5_io_uram_out_a_3),
    .io_kernel_count(Memory_5_io_kernel_count),
    .io_master_finish(Memory_5_io_master_finish),
    .io_node_num(Memory_5_io_node_num),
    .io_neighbour_cnt(Memory_5_io_neighbour_cnt),
    .io_mem_end(Memory_5_io_mem_end),
    .io_neighbours_0_ready(Memory_5_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_5_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_5_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_5_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_5_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_5_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_5_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_5_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_5_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_5_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_5_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_5_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_5_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_5_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_5_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_5_io_uram_addr_a_3),
    .io_write_finish(Memory_5_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_5_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_5_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_5_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_5_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_5_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_5_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_5_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_5_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_5_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_5_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_5_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_5_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_5_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_5_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_5_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_5_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_5_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_5_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_5_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_5_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_5_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_5_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_5_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_5_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_5_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_5_io_mem_clock),
    .io_reset_h(Memory_5_io_reset_h)
  );
  Memory_6 Memory_6 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_6_clock),
    .reset(Memory_6_reset),
    .io_R_array_index_0_ready(Memory_6_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_6_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_6_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_6_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_6_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_6_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_6_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_6_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_6_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_6_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_6_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_6_io_R_array_index_3_bits),
    .io_p1_end(Memory_6_io_p1_end),
    .io_level(Memory_6_io_level),
    .io_push_or_pull_state(Memory_6_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_6_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_6_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_6_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_6_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_6_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_6_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_6_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_6_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_6_io_uram_out_a_3),
    .io_kernel_count(Memory_6_io_kernel_count),
    .io_master_finish(Memory_6_io_master_finish),
    .io_node_num(Memory_6_io_node_num),
    .io_neighbour_cnt(Memory_6_io_neighbour_cnt),
    .io_mem_end(Memory_6_io_mem_end),
    .io_neighbours_0_ready(Memory_6_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_6_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_6_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_6_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_6_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_6_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_6_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_6_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_6_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_6_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_6_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_6_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_6_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_6_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_6_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_6_io_uram_addr_a_3),
    .io_write_finish(Memory_6_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_6_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_6_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_6_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_6_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_6_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_6_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_6_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_6_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_6_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_6_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_6_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_6_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_6_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_6_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_6_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_6_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_6_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_6_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_6_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_6_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_6_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_6_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_6_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_6_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_6_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_6_io_mem_clock),
    .io_reset_h(Memory_6_io_reset_h)
  );
  Memory_7 Memory_7 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_7_clock),
    .reset(Memory_7_reset),
    .io_R_array_index_0_ready(Memory_7_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_7_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_7_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_7_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_7_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_7_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_7_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_7_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_7_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_7_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_7_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_7_io_R_array_index_3_bits),
    .io_p1_end(Memory_7_io_p1_end),
    .io_level(Memory_7_io_level),
    .io_push_or_pull_state(Memory_7_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_7_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_7_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_7_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_7_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_7_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_7_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_7_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_7_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_7_io_uram_out_a_3),
    .io_kernel_count(Memory_7_io_kernel_count),
    .io_master_finish(Memory_7_io_master_finish),
    .io_node_num(Memory_7_io_node_num),
    .io_neighbour_cnt(Memory_7_io_neighbour_cnt),
    .io_mem_end(Memory_7_io_mem_end),
    .io_neighbours_0_ready(Memory_7_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_7_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_7_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_7_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_7_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_7_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_7_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_7_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_7_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_7_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_7_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_7_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_7_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_7_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_7_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_7_io_uram_addr_a_3),
    .io_write_finish(Memory_7_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_7_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_7_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_7_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_7_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_7_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_7_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_7_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_7_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_7_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_7_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_7_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_7_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_7_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_7_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_7_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_7_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_7_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_7_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_7_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_7_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_7_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_7_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_7_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_7_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_7_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_7_io_mem_clock),
    .io_reset_h(Memory_7_io_reset_h)
  );
  Memory_8 Memory_8 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_8_clock),
    .reset(Memory_8_reset),
    .io_R_array_index_0_ready(Memory_8_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_8_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_8_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_8_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_8_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_8_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_8_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_8_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_8_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_8_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_8_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_8_io_R_array_index_3_bits),
    .io_p1_end(Memory_8_io_p1_end),
    .io_level(Memory_8_io_level),
    .io_push_or_pull_state(Memory_8_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_8_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_8_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_8_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_8_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_8_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_8_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_8_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_8_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_8_io_uram_out_a_3),
    .io_kernel_count(Memory_8_io_kernel_count),
    .io_master_finish(Memory_8_io_master_finish),
    .io_node_num(Memory_8_io_node_num),
    .io_neighbour_cnt(Memory_8_io_neighbour_cnt),
    .io_mem_end(Memory_8_io_mem_end),
    .io_neighbours_0_ready(Memory_8_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_8_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_8_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_8_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_8_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_8_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_8_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_8_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_8_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_8_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_8_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_8_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_8_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_8_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_8_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_8_io_uram_addr_a_3),
    .io_write_finish(Memory_8_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_8_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_8_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_8_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_8_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_8_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_8_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_8_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_8_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_8_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_8_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_8_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_8_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_8_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_8_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_8_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_8_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_8_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_8_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_8_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_8_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_8_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_8_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_8_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_8_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_8_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_8_io_mem_clock),
    .io_reset_h(Memory_8_io_reset_h)
  );
  Memory_9 Memory_9 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_9_clock),
    .reset(Memory_9_reset),
    .io_R_array_index_0_ready(Memory_9_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_9_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_9_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_9_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_9_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_9_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_9_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_9_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_9_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_9_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_9_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_9_io_R_array_index_3_bits),
    .io_p1_end(Memory_9_io_p1_end),
    .io_level(Memory_9_io_level),
    .io_push_or_pull_state(Memory_9_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_9_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_9_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_9_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_9_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_9_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_9_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_9_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_9_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_9_io_uram_out_a_3),
    .io_kernel_count(Memory_9_io_kernel_count),
    .io_master_finish(Memory_9_io_master_finish),
    .io_node_num(Memory_9_io_node_num),
    .io_neighbour_cnt(Memory_9_io_neighbour_cnt),
    .io_mem_end(Memory_9_io_mem_end),
    .io_neighbours_0_ready(Memory_9_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_9_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_9_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_9_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_9_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_9_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_9_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_9_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_9_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_9_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_9_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_9_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_9_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_9_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_9_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_9_io_uram_addr_a_3),
    .io_write_finish(Memory_9_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_9_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_9_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_9_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_9_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_9_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_9_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_9_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_9_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_9_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_9_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_9_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_9_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_9_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_9_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_9_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_9_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_9_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_9_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_9_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_9_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_9_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_9_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_9_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_9_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_9_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_9_io_mem_clock),
    .io_reset_h(Memory_9_io_reset_h)
  );
  Memory_10 Memory_10 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_10_clock),
    .reset(Memory_10_reset),
    .io_R_array_index_0_ready(Memory_10_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_10_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_10_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_10_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_10_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_10_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_10_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_10_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_10_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_10_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_10_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_10_io_R_array_index_3_bits),
    .io_p1_end(Memory_10_io_p1_end),
    .io_level(Memory_10_io_level),
    .io_push_or_pull_state(Memory_10_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_10_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_10_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_10_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_10_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_10_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_10_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_10_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_10_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_10_io_uram_out_a_3),
    .io_kernel_count(Memory_10_io_kernel_count),
    .io_master_finish(Memory_10_io_master_finish),
    .io_node_num(Memory_10_io_node_num),
    .io_neighbour_cnt(Memory_10_io_neighbour_cnt),
    .io_mem_end(Memory_10_io_mem_end),
    .io_neighbours_0_ready(Memory_10_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_10_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_10_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_10_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_10_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_10_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_10_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_10_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_10_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_10_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_10_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_10_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_10_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_10_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_10_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_10_io_uram_addr_a_3),
    .io_write_finish(Memory_10_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_10_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_10_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_10_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_10_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_10_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_10_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_10_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_10_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_10_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_10_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_10_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_10_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_10_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_10_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_10_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_10_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_10_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_10_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_10_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_10_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_10_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_10_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_10_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_10_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_10_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_10_io_mem_clock),
    .io_reset_h(Memory_10_io_reset_h)
  );
  Memory_11 Memory_11 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_11_clock),
    .reset(Memory_11_reset),
    .io_R_array_index_0_ready(Memory_11_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_11_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_11_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_11_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_11_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_11_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_11_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_11_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_11_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_11_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_11_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_11_io_R_array_index_3_bits),
    .io_p1_end(Memory_11_io_p1_end),
    .io_level(Memory_11_io_level),
    .io_push_or_pull_state(Memory_11_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_11_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_11_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_11_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_11_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_11_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_11_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_11_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_11_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_11_io_uram_out_a_3),
    .io_kernel_count(Memory_11_io_kernel_count),
    .io_master_finish(Memory_11_io_master_finish),
    .io_node_num(Memory_11_io_node_num),
    .io_neighbour_cnt(Memory_11_io_neighbour_cnt),
    .io_mem_end(Memory_11_io_mem_end),
    .io_neighbours_0_ready(Memory_11_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_11_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_11_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_11_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_11_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_11_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_11_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_11_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_11_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_11_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_11_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_11_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_11_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_11_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_11_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_11_io_uram_addr_a_3),
    .io_write_finish(Memory_11_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_11_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_11_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_11_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_11_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_11_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_11_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_11_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_11_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_11_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_11_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_11_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_11_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_11_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_11_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_11_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_11_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_11_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_11_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_11_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_11_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_11_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_11_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_11_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_11_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_11_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_11_io_mem_clock),
    .io_reset_h(Memory_11_io_reset_h)
  );
  Memory_12 Memory_12 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_12_clock),
    .reset(Memory_12_reset),
    .io_R_array_index_0_ready(Memory_12_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_12_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_12_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_12_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_12_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_12_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_12_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_12_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_12_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_12_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_12_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_12_io_R_array_index_3_bits),
    .io_p1_end(Memory_12_io_p1_end),
    .io_level(Memory_12_io_level),
    .io_push_or_pull_state(Memory_12_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_12_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_12_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_12_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_12_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_12_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_12_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_12_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_12_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_12_io_uram_out_a_3),
    .io_kernel_count(Memory_12_io_kernel_count),
    .io_master_finish(Memory_12_io_master_finish),
    .io_node_num(Memory_12_io_node_num),
    .io_neighbour_cnt(Memory_12_io_neighbour_cnt),
    .io_mem_end(Memory_12_io_mem_end),
    .io_neighbours_0_ready(Memory_12_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_12_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_12_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_12_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_12_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_12_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_12_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_12_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_12_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_12_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_12_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_12_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_12_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_12_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_12_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_12_io_uram_addr_a_3),
    .io_write_finish(Memory_12_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_12_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_12_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_12_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_12_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_12_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_12_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_12_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_12_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_12_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_12_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_12_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_12_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_12_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_12_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_12_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_12_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_12_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_12_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_12_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_12_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_12_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_12_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_12_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_12_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_12_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_12_io_mem_clock),
    .io_reset_h(Memory_12_io_reset_h)
  );
  Memory_13 Memory_13 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_13_clock),
    .reset(Memory_13_reset),
    .io_R_array_index_0_ready(Memory_13_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_13_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_13_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_13_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_13_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_13_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_13_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_13_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_13_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_13_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_13_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_13_io_R_array_index_3_bits),
    .io_p1_end(Memory_13_io_p1_end),
    .io_level(Memory_13_io_level),
    .io_push_or_pull_state(Memory_13_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_13_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_13_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_13_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_13_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_13_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_13_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_13_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_13_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_13_io_uram_out_a_3),
    .io_kernel_count(Memory_13_io_kernel_count),
    .io_master_finish(Memory_13_io_master_finish),
    .io_node_num(Memory_13_io_node_num),
    .io_neighbour_cnt(Memory_13_io_neighbour_cnt),
    .io_mem_end(Memory_13_io_mem_end),
    .io_neighbours_0_ready(Memory_13_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_13_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_13_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_13_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_13_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_13_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_13_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_13_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_13_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_13_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_13_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_13_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_13_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_13_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_13_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_13_io_uram_addr_a_3),
    .io_write_finish(Memory_13_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_13_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_13_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_13_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_13_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_13_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_13_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_13_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_13_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_13_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_13_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_13_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_13_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_13_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_13_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_13_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_13_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_13_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_13_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_13_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_13_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_13_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_13_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_13_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_13_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_13_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_13_io_mem_clock),
    .io_reset_h(Memory_13_io_reset_h)
  );
  Memory_14 Memory_14 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_14_clock),
    .reset(Memory_14_reset),
    .io_R_array_index_0_ready(Memory_14_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_14_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_14_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_14_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_14_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_14_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_14_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_14_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_14_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_14_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_14_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_14_io_R_array_index_3_bits),
    .io_p1_end(Memory_14_io_p1_end),
    .io_level(Memory_14_io_level),
    .io_push_or_pull_state(Memory_14_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_14_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_14_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_14_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_14_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_14_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_14_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_14_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_14_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_14_io_uram_out_a_3),
    .io_kernel_count(Memory_14_io_kernel_count),
    .io_master_finish(Memory_14_io_master_finish),
    .io_node_num(Memory_14_io_node_num),
    .io_neighbour_cnt(Memory_14_io_neighbour_cnt),
    .io_mem_end(Memory_14_io_mem_end),
    .io_neighbours_0_ready(Memory_14_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_14_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_14_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_14_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_14_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_14_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_14_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_14_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_14_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_14_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_14_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_14_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_14_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_14_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_14_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_14_io_uram_addr_a_3),
    .io_write_finish(Memory_14_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_14_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_14_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_14_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_14_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_14_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_14_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_14_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_14_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_14_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_14_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_14_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_14_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_14_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_14_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_14_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_14_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_14_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_14_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_14_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_14_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_14_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_14_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_14_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_14_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_14_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_14_io_mem_clock),
    .io_reset_h(Memory_14_io_reset_h)
  );
  Memory_15 Memory_15 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_15_clock),
    .reset(Memory_15_reset),
    .io_R_array_index_0_ready(Memory_15_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_15_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_15_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_15_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_15_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_15_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_15_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_15_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_15_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_15_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_15_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_15_io_R_array_index_3_bits),
    .io_p1_end(Memory_15_io_p1_end),
    .io_level(Memory_15_io_level),
    .io_push_or_pull_state(Memory_15_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_15_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_15_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_15_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_15_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_15_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_15_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_15_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_15_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_15_io_uram_out_a_3),
    .io_kernel_count(Memory_15_io_kernel_count),
    .io_master_finish(Memory_15_io_master_finish),
    .io_node_num(Memory_15_io_node_num),
    .io_neighbour_cnt(Memory_15_io_neighbour_cnt),
    .io_mem_end(Memory_15_io_mem_end),
    .io_neighbours_0_ready(Memory_15_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_15_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_15_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_15_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_15_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_15_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_15_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_15_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_15_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_15_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_15_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_15_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_15_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_15_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_15_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_15_io_uram_addr_a_3),
    .io_write_finish(Memory_15_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_15_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_15_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_15_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_15_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_15_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_15_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_15_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_15_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_15_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_15_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_15_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_15_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_15_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_15_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_15_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_15_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_15_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_15_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_15_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_15_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_15_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_15_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_15_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_15_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_15_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_15_io_mem_clock),
    .io_reset_h(Memory_15_io_reset_h)
  );
  Memory_16 Memory_16 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_16_clock),
    .reset(Memory_16_reset),
    .io_R_array_index_0_ready(Memory_16_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_16_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_16_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_16_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_16_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_16_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_16_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_16_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_16_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_16_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_16_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_16_io_R_array_index_3_bits),
    .io_p1_end(Memory_16_io_p1_end),
    .io_level(Memory_16_io_level),
    .io_push_or_pull_state(Memory_16_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_16_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_16_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_16_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_16_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_16_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_16_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_16_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_16_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_16_io_uram_out_a_3),
    .io_kernel_count(Memory_16_io_kernel_count),
    .io_master_finish(Memory_16_io_master_finish),
    .io_node_num(Memory_16_io_node_num),
    .io_neighbour_cnt(Memory_16_io_neighbour_cnt),
    .io_mem_end(Memory_16_io_mem_end),
    .io_neighbours_0_ready(Memory_16_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_16_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_16_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_16_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_16_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_16_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_16_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_16_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_16_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_16_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_16_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_16_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_16_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_16_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_16_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_16_io_uram_addr_a_3),
    .io_write_finish(Memory_16_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_16_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_16_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_16_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_16_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_16_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_16_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_16_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_16_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_16_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_16_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_16_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_16_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_16_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_16_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_16_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_16_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_16_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_16_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_16_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_16_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_16_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_16_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_16_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_16_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_16_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_16_io_mem_clock),
    .io_reset_h(Memory_16_io_reset_h)
  );
  Memory_17 Memory_17 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_17_clock),
    .reset(Memory_17_reset),
    .io_R_array_index_0_ready(Memory_17_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_17_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_17_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_17_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_17_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_17_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_17_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_17_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_17_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_17_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_17_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_17_io_R_array_index_3_bits),
    .io_p1_end(Memory_17_io_p1_end),
    .io_level(Memory_17_io_level),
    .io_push_or_pull_state(Memory_17_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_17_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_17_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_17_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_17_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_17_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_17_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_17_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_17_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_17_io_uram_out_a_3),
    .io_kernel_count(Memory_17_io_kernel_count),
    .io_master_finish(Memory_17_io_master_finish),
    .io_node_num(Memory_17_io_node_num),
    .io_neighbour_cnt(Memory_17_io_neighbour_cnt),
    .io_mem_end(Memory_17_io_mem_end),
    .io_neighbours_0_ready(Memory_17_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_17_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_17_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_17_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_17_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_17_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_17_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_17_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_17_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_17_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_17_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_17_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_17_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_17_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_17_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_17_io_uram_addr_a_3),
    .io_write_finish(Memory_17_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_17_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_17_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_17_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_17_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_17_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_17_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_17_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_17_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_17_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_17_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_17_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_17_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_17_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_17_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_17_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_17_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_17_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_17_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_17_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_17_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_17_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_17_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_17_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_17_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_17_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_17_io_mem_clock),
    .io_reset_h(Memory_17_io_reset_h)
  );
  Memory_18 Memory_18 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_18_clock),
    .reset(Memory_18_reset),
    .io_R_array_index_0_ready(Memory_18_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_18_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_18_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_18_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_18_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_18_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_18_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_18_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_18_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_18_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_18_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_18_io_R_array_index_3_bits),
    .io_p1_end(Memory_18_io_p1_end),
    .io_level(Memory_18_io_level),
    .io_push_or_pull_state(Memory_18_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_18_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_18_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_18_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_18_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_18_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_18_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_18_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_18_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_18_io_uram_out_a_3),
    .io_kernel_count(Memory_18_io_kernel_count),
    .io_master_finish(Memory_18_io_master_finish),
    .io_node_num(Memory_18_io_node_num),
    .io_neighbour_cnt(Memory_18_io_neighbour_cnt),
    .io_mem_end(Memory_18_io_mem_end),
    .io_neighbours_0_ready(Memory_18_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_18_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_18_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_18_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_18_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_18_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_18_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_18_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_18_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_18_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_18_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_18_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_18_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_18_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_18_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_18_io_uram_addr_a_3),
    .io_write_finish(Memory_18_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_18_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_18_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_18_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_18_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_18_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_18_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_18_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_18_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_18_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_18_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_18_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_18_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_18_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_18_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_18_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_18_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_18_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_18_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_18_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_18_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_18_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_18_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_18_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_18_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_18_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_18_io_mem_clock),
    .io_reset_h(Memory_18_io_reset_h)
  );
  Memory_19 Memory_19 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_19_clock),
    .reset(Memory_19_reset),
    .io_R_array_index_0_ready(Memory_19_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_19_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_19_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_19_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_19_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_19_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_19_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_19_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_19_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_19_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_19_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_19_io_R_array_index_3_bits),
    .io_p1_end(Memory_19_io_p1_end),
    .io_level(Memory_19_io_level),
    .io_push_or_pull_state(Memory_19_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_19_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_19_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_19_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_19_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_19_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_19_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_19_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_19_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_19_io_uram_out_a_3),
    .io_kernel_count(Memory_19_io_kernel_count),
    .io_master_finish(Memory_19_io_master_finish),
    .io_node_num(Memory_19_io_node_num),
    .io_neighbour_cnt(Memory_19_io_neighbour_cnt),
    .io_mem_end(Memory_19_io_mem_end),
    .io_neighbours_0_ready(Memory_19_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_19_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_19_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_19_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_19_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_19_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_19_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_19_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_19_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_19_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_19_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_19_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_19_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_19_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_19_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_19_io_uram_addr_a_3),
    .io_write_finish(Memory_19_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_19_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_19_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_19_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_19_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_19_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_19_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_19_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_19_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_19_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_19_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_19_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_19_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_19_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_19_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_19_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_19_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_19_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_19_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_19_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_19_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_19_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_19_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_19_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_19_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_19_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_19_io_mem_clock),
    .io_reset_h(Memory_19_io_reset_h)
  );
  Memory_20 Memory_20 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_20_clock),
    .reset(Memory_20_reset),
    .io_R_array_index_0_ready(Memory_20_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_20_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_20_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_20_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_20_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_20_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_20_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_20_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_20_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_20_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_20_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_20_io_R_array_index_3_bits),
    .io_p1_end(Memory_20_io_p1_end),
    .io_level(Memory_20_io_level),
    .io_push_or_pull_state(Memory_20_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_20_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_20_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_20_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_20_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_20_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_20_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_20_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_20_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_20_io_uram_out_a_3),
    .io_kernel_count(Memory_20_io_kernel_count),
    .io_master_finish(Memory_20_io_master_finish),
    .io_node_num(Memory_20_io_node_num),
    .io_neighbour_cnt(Memory_20_io_neighbour_cnt),
    .io_mem_end(Memory_20_io_mem_end),
    .io_neighbours_0_ready(Memory_20_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_20_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_20_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_20_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_20_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_20_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_20_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_20_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_20_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_20_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_20_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_20_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_20_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_20_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_20_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_20_io_uram_addr_a_3),
    .io_write_finish(Memory_20_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_20_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_20_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_20_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_20_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_20_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_20_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_20_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_20_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_20_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_20_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_20_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_20_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_20_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_20_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_20_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_20_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_20_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_20_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_20_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_20_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_20_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_20_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_20_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_20_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_20_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_20_io_mem_clock),
    .io_reset_h(Memory_20_io_reset_h)
  );
  Memory_21 Memory_21 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_21_clock),
    .reset(Memory_21_reset),
    .io_R_array_index_0_ready(Memory_21_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_21_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_21_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_21_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_21_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_21_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_21_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_21_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_21_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_21_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_21_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_21_io_R_array_index_3_bits),
    .io_p1_end(Memory_21_io_p1_end),
    .io_level(Memory_21_io_level),
    .io_push_or_pull_state(Memory_21_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_21_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_21_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_21_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_21_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_21_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_21_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_21_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_21_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_21_io_uram_out_a_3),
    .io_kernel_count(Memory_21_io_kernel_count),
    .io_master_finish(Memory_21_io_master_finish),
    .io_node_num(Memory_21_io_node_num),
    .io_neighbour_cnt(Memory_21_io_neighbour_cnt),
    .io_mem_end(Memory_21_io_mem_end),
    .io_neighbours_0_ready(Memory_21_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_21_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_21_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_21_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_21_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_21_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_21_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_21_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_21_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_21_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_21_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_21_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_21_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_21_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_21_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_21_io_uram_addr_a_3),
    .io_write_finish(Memory_21_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_21_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_21_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_21_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_21_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_21_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_21_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_21_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_21_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_21_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_21_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_21_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_21_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_21_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_21_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_21_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_21_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_21_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_21_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_21_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_21_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_21_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_21_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_21_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_21_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_21_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_21_io_mem_clock),
    .io_reset_h(Memory_21_io_reset_h)
  );
  Memory_22 Memory_22 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_22_clock),
    .reset(Memory_22_reset),
    .io_R_array_index_0_ready(Memory_22_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_22_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_22_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_22_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_22_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_22_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_22_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_22_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_22_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_22_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_22_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_22_io_R_array_index_3_bits),
    .io_p1_end(Memory_22_io_p1_end),
    .io_level(Memory_22_io_level),
    .io_push_or_pull_state(Memory_22_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_22_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_22_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_22_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_22_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_22_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_22_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_22_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_22_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_22_io_uram_out_a_3),
    .io_kernel_count(Memory_22_io_kernel_count),
    .io_master_finish(Memory_22_io_master_finish),
    .io_node_num(Memory_22_io_node_num),
    .io_neighbour_cnt(Memory_22_io_neighbour_cnt),
    .io_mem_end(Memory_22_io_mem_end),
    .io_neighbours_0_ready(Memory_22_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_22_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_22_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_22_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_22_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_22_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_22_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_22_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_22_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_22_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_22_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_22_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_22_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_22_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_22_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_22_io_uram_addr_a_3),
    .io_write_finish(Memory_22_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_22_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_22_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_22_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_22_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_22_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_22_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_22_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_22_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_22_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_22_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_22_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_22_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_22_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_22_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_22_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_22_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_22_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_22_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_22_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_22_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_22_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_22_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_22_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_22_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_22_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_22_io_mem_clock),
    .io_reset_h(Memory_22_io_reset_h)
  );
  Memory_23 Memory_23 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_23_clock),
    .reset(Memory_23_reset),
    .io_R_array_index_0_ready(Memory_23_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_23_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_23_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_23_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_23_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_23_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_23_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_23_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_23_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_23_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_23_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_23_io_R_array_index_3_bits),
    .io_p1_end(Memory_23_io_p1_end),
    .io_level(Memory_23_io_level),
    .io_push_or_pull_state(Memory_23_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_23_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_23_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_23_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_23_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_23_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_23_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_23_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_23_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_23_io_uram_out_a_3),
    .io_kernel_count(Memory_23_io_kernel_count),
    .io_master_finish(Memory_23_io_master_finish),
    .io_node_num(Memory_23_io_node_num),
    .io_neighbour_cnt(Memory_23_io_neighbour_cnt),
    .io_mem_end(Memory_23_io_mem_end),
    .io_neighbours_0_ready(Memory_23_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_23_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_23_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_23_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_23_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_23_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_23_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_23_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_23_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_23_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_23_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_23_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_23_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_23_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_23_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_23_io_uram_addr_a_3),
    .io_write_finish(Memory_23_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_23_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_23_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_23_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_23_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_23_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_23_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_23_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_23_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_23_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_23_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_23_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_23_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_23_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_23_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_23_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_23_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_23_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_23_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_23_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_23_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_23_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_23_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_23_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_23_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_23_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_23_io_mem_clock),
    .io_reset_h(Memory_23_io_reset_h)
  );
  Memory_24 Memory_24 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_24_clock),
    .reset(Memory_24_reset),
    .io_R_array_index_0_ready(Memory_24_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_24_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_24_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_24_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_24_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_24_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_24_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_24_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_24_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_24_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_24_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_24_io_R_array_index_3_bits),
    .io_p1_end(Memory_24_io_p1_end),
    .io_level(Memory_24_io_level),
    .io_push_or_pull_state(Memory_24_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_24_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_24_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_24_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_24_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_24_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_24_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_24_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_24_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_24_io_uram_out_a_3),
    .io_kernel_count(Memory_24_io_kernel_count),
    .io_master_finish(Memory_24_io_master_finish),
    .io_node_num(Memory_24_io_node_num),
    .io_neighbour_cnt(Memory_24_io_neighbour_cnt),
    .io_mem_end(Memory_24_io_mem_end),
    .io_neighbours_0_ready(Memory_24_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_24_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_24_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_24_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_24_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_24_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_24_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_24_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_24_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_24_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_24_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_24_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_24_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_24_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_24_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_24_io_uram_addr_a_3),
    .io_write_finish(Memory_24_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_24_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_24_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_24_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_24_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_24_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_24_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_24_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_24_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_24_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_24_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_24_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_24_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_24_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_24_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_24_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_24_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_24_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_24_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_24_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_24_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_24_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_24_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_24_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_24_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_24_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_24_io_mem_clock),
    .io_reset_h(Memory_24_io_reset_h)
  );
  Memory_25 Memory_25 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_25_clock),
    .reset(Memory_25_reset),
    .io_R_array_index_0_ready(Memory_25_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_25_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_25_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_25_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_25_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_25_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_25_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_25_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_25_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_25_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_25_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_25_io_R_array_index_3_bits),
    .io_p1_end(Memory_25_io_p1_end),
    .io_level(Memory_25_io_level),
    .io_push_or_pull_state(Memory_25_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_25_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_25_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_25_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_25_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_25_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_25_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_25_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_25_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_25_io_uram_out_a_3),
    .io_kernel_count(Memory_25_io_kernel_count),
    .io_master_finish(Memory_25_io_master_finish),
    .io_node_num(Memory_25_io_node_num),
    .io_neighbour_cnt(Memory_25_io_neighbour_cnt),
    .io_mem_end(Memory_25_io_mem_end),
    .io_neighbours_0_ready(Memory_25_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_25_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_25_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_25_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_25_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_25_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_25_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_25_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_25_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_25_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_25_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_25_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_25_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_25_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_25_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_25_io_uram_addr_a_3),
    .io_write_finish(Memory_25_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_25_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_25_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_25_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_25_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_25_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_25_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_25_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_25_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_25_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_25_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_25_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_25_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_25_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_25_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_25_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_25_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_25_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_25_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_25_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_25_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_25_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_25_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_25_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_25_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_25_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_25_io_mem_clock),
    .io_reset_h(Memory_25_io_reset_h)
  );
  Memory_26 Memory_26 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_26_clock),
    .reset(Memory_26_reset),
    .io_R_array_index_0_ready(Memory_26_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_26_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_26_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_26_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_26_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_26_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_26_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_26_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_26_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_26_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_26_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_26_io_R_array_index_3_bits),
    .io_p1_end(Memory_26_io_p1_end),
    .io_level(Memory_26_io_level),
    .io_push_or_pull_state(Memory_26_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_26_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_26_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_26_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_26_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_26_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_26_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_26_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_26_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_26_io_uram_out_a_3),
    .io_kernel_count(Memory_26_io_kernel_count),
    .io_master_finish(Memory_26_io_master_finish),
    .io_node_num(Memory_26_io_node_num),
    .io_neighbour_cnt(Memory_26_io_neighbour_cnt),
    .io_mem_end(Memory_26_io_mem_end),
    .io_neighbours_0_ready(Memory_26_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_26_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_26_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_26_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_26_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_26_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_26_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_26_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_26_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_26_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_26_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_26_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_26_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_26_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_26_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_26_io_uram_addr_a_3),
    .io_write_finish(Memory_26_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_26_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_26_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_26_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_26_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_26_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_26_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_26_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_26_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_26_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_26_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_26_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_26_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_26_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_26_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_26_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_26_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_26_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_26_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_26_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_26_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_26_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_26_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_26_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_26_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_26_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_26_io_mem_clock),
    .io_reset_h(Memory_26_io_reset_h)
  );
  Memory_27 Memory_27 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_27_clock),
    .reset(Memory_27_reset),
    .io_R_array_index_0_ready(Memory_27_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_27_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_27_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_27_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_27_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_27_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_27_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_27_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_27_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_27_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_27_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_27_io_R_array_index_3_bits),
    .io_p1_end(Memory_27_io_p1_end),
    .io_level(Memory_27_io_level),
    .io_push_or_pull_state(Memory_27_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_27_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_27_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_27_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_27_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_27_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_27_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_27_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_27_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_27_io_uram_out_a_3),
    .io_kernel_count(Memory_27_io_kernel_count),
    .io_master_finish(Memory_27_io_master_finish),
    .io_node_num(Memory_27_io_node_num),
    .io_neighbour_cnt(Memory_27_io_neighbour_cnt),
    .io_mem_end(Memory_27_io_mem_end),
    .io_neighbours_0_ready(Memory_27_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_27_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_27_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_27_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_27_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_27_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_27_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_27_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_27_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_27_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_27_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_27_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_27_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_27_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_27_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_27_io_uram_addr_a_3),
    .io_write_finish(Memory_27_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_27_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_27_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_27_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_27_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_27_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_27_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_27_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_27_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_27_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_27_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_27_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_27_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_27_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_27_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_27_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_27_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_27_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_27_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_27_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_27_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_27_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_27_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_27_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_27_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_27_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_27_io_mem_clock),
    .io_reset_h(Memory_27_io_reset_h)
  );
  Memory_28 Memory_28 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_28_clock),
    .reset(Memory_28_reset),
    .io_R_array_index_0_ready(Memory_28_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_28_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_28_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_28_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_28_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_28_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_28_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_28_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_28_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_28_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_28_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_28_io_R_array_index_3_bits),
    .io_p1_end(Memory_28_io_p1_end),
    .io_level(Memory_28_io_level),
    .io_push_or_pull_state(Memory_28_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_28_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_28_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_28_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_28_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_28_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_28_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_28_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_28_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_28_io_uram_out_a_3),
    .io_kernel_count(Memory_28_io_kernel_count),
    .io_master_finish(Memory_28_io_master_finish),
    .io_node_num(Memory_28_io_node_num),
    .io_neighbour_cnt(Memory_28_io_neighbour_cnt),
    .io_mem_end(Memory_28_io_mem_end),
    .io_neighbours_0_ready(Memory_28_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_28_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_28_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_28_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_28_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_28_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_28_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_28_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_28_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_28_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_28_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_28_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_28_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_28_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_28_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_28_io_uram_addr_a_3),
    .io_write_finish(Memory_28_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_28_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_28_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_28_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_28_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_28_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_28_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_28_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_28_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_28_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_28_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_28_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_28_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_28_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_28_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_28_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_28_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_28_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_28_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_28_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_28_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_28_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_28_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_28_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_28_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_28_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_28_io_mem_clock),
    .io_reset_h(Memory_28_io_reset_h)
  );
  Memory_29 Memory_29 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_29_clock),
    .reset(Memory_29_reset),
    .io_R_array_index_0_ready(Memory_29_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_29_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_29_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_29_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_29_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_29_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_29_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_29_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_29_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_29_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_29_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_29_io_R_array_index_3_bits),
    .io_p1_end(Memory_29_io_p1_end),
    .io_level(Memory_29_io_level),
    .io_push_or_pull_state(Memory_29_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_29_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_29_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_29_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_29_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_29_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_29_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_29_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_29_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_29_io_uram_out_a_3),
    .io_kernel_count(Memory_29_io_kernel_count),
    .io_master_finish(Memory_29_io_master_finish),
    .io_node_num(Memory_29_io_node_num),
    .io_neighbour_cnt(Memory_29_io_neighbour_cnt),
    .io_mem_end(Memory_29_io_mem_end),
    .io_neighbours_0_ready(Memory_29_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_29_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_29_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_29_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_29_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_29_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_29_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_29_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_29_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_29_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_29_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_29_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_29_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_29_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_29_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_29_io_uram_addr_a_3),
    .io_write_finish(Memory_29_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_29_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_29_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_29_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_29_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_29_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_29_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_29_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_29_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_29_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_29_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_29_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_29_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_29_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_29_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_29_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_29_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_29_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_29_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_29_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_29_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_29_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_29_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_29_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_29_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_29_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_29_io_mem_clock),
    .io_reset_h(Memory_29_io_reset_h)
  );
  Memory_30 Memory_30 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_30_clock),
    .reset(Memory_30_reset),
    .io_R_array_index_0_ready(Memory_30_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_30_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_30_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_30_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_30_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_30_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_30_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_30_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_30_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_30_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_30_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_30_io_R_array_index_3_bits),
    .io_p1_end(Memory_30_io_p1_end),
    .io_level(Memory_30_io_level),
    .io_push_or_pull_state(Memory_30_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_30_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_30_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_30_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_30_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_30_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_30_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_30_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_30_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_30_io_uram_out_a_3),
    .io_kernel_count(Memory_30_io_kernel_count),
    .io_master_finish(Memory_30_io_master_finish),
    .io_node_num(Memory_30_io_node_num),
    .io_neighbour_cnt(Memory_30_io_neighbour_cnt),
    .io_mem_end(Memory_30_io_mem_end),
    .io_neighbours_0_ready(Memory_30_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_30_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_30_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_30_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_30_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_30_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_30_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_30_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_30_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_30_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_30_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_30_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_30_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_30_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_30_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_30_io_uram_addr_a_3),
    .io_write_finish(Memory_30_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_30_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_30_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_30_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_30_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_30_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_30_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_30_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_30_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_30_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_30_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_30_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_30_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_30_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_30_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_30_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_30_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_30_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_30_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_30_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_30_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_30_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_30_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_30_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_30_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_30_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_30_io_mem_clock),
    .io_reset_h(Memory_30_io_reset_h)
  );
  Memory_31 Memory_31 ( // @[SLR0_Mem.scala 43:27]
    .clock(Memory_31_clock),
    .reset(Memory_31_reset),
    .io_R_array_index_0_ready(Memory_31_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(Memory_31_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(Memory_31_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(Memory_31_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(Memory_31_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(Memory_31_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(Memory_31_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(Memory_31_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(Memory_31_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(Memory_31_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(Memory_31_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(Memory_31_io_R_array_index_3_bits),
    .io_p1_end(Memory_31_io_p1_end),
    .io_level(Memory_31_io_level),
    .io_push_or_pull_state(Memory_31_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(Memory_31_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(Memory_31_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(Memory_31_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(Memory_31_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(Memory_31_io_offsets_level_offset),
    .io_uram_out_a_0(Memory_31_io_uram_out_a_0),
    .io_uram_out_a_1(Memory_31_io_uram_out_a_1),
    .io_uram_out_a_2(Memory_31_io_uram_out_a_2),
    .io_uram_out_a_3(Memory_31_io_uram_out_a_3),
    .io_kernel_count(Memory_31_io_kernel_count),
    .io_master_finish(Memory_31_io_master_finish),
    .io_node_num(Memory_31_io_node_num),
    .io_neighbour_cnt(Memory_31_io_neighbour_cnt),
    .io_mem_end(Memory_31_io_mem_end),
    .io_neighbours_0_ready(Memory_31_io_neighbours_0_ready),
    .io_neighbours_0_valid(Memory_31_io_neighbours_0_valid),
    .io_neighbours_0_bits(Memory_31_io_neighbours_0_bits),
    .io_neighbours_1_ready(Memory_31_io_neighbours_1_ready),
    .io_neighbours_1_valid(Memory_31_io_neighbours_1_valid),
    .io_neighbours_1_bits(Memory_31_io_neighbours_1_bits),
    .io_neighbours_2_ready(Memory_31_io_neighbours_2_ready),
    .io_neighbours_2_valid(Memory_31_io_neighbours_2_valid),
    .io_neighbours_2_bits(Memory_31_io_neighbours_2_bits),
    .io_neighbours_3_ready(Memory_31_io_neighbours_3_ready),
    .io_neighbours_3_valid(Memory_31_io_neighbours_3_valid),
    .io_neighbours_3_bits(Memory_31_io_neighbours_3_bits),
    .io_uram_addr_a_0(Memory_31_io_uram_addr_a_0),
    .io_uram_addr_a_1(Memory_31_io_uram_addr_a_1),
    .io_uram_addr_a_2(Memory_31_io_uram_addr_a_2),
    .io_uram_addr_a_3(Memory_31_io_uram_addr_a_3),
    .io_write_finish(Memory_31_io_write_finish),
    .io_HBM_interface_writeAddr_ready(Memory_31_io_HBM_interface_writeAddr_ready),
    .io_HBM_interface_writeAddr_valid(Memory_31_io_HBM_interface_writeAddr_valid),
    .io_HBM_interface_writeAddr_bits_addr(Memory_31_io_HBM_interface_writeAddr_bits_addr),
    .io_HBM_interface_writeAddr_bits_len(Memory_31_io_HBM_interface_writeAddr_bits_len),
    .io_HBM_interface_writeAddr_bits_id(Memory_31_io_HBM_interface_writeAddr_bits_id),
    .io_HBM_interface_writeData_ready(Memory_31_io_HBM_interface_writeData_ready),
    .io_HBM_interface_writeData_valid(Memory_31_io_HBM_interface_writeData_valid),
    .io_HBM_interface_writeData_bits_data(Memory_31_io_HBM_interface_writeData_bits_data),
    .io_HBM_interface_writeData_bits_strb(Memory_31_io_HBM_interface_writeData_bits_strb),
    .io_HBM_interface_writeData_bits_last(Memory_31_io_HBM_interface_writeData_bits_last),
    .io_HBM_interface_writeResp_ready(Memory_31_io_HBM_interface_writeResp_ready),
    .io_HBM_interface_writeResp_valid(Memory_31_io_HBM_interface_writeResp_valid),
    .io_HBM_interface_writeResp_bits_id(Memory_31_io_HBM_interface_writeResp_bits_id),
    .io_HBM_interface_writeResp_bits_resp(Memory_31_io_HBM_interface_writeResp_bits_resp),
    .io_HBM_interface_readAddr_ready(Memory_31_io_HBM_interface_readAddr_ready),
    .io_HBM_interface_readAddr_valid(Memory_31_io_HBM_interface_readAddr_valid),
    .io_HBM_interface_readAddr_bits_addr(Memory_31_io_HBM_interface_readAddr_bits_addr),
    .io_HBM_interface_readAddr_bits_len(Memory_31_io_HBM_interface_readAddr_bits_len),
    .io_HBM_interface_readAddr_bits_id(Memory_31_io_HBM_interface_readAddr_bits_id),
    .io_HBM_interface_readData_ready(Memory_31_io_HBM_interface_readData_ready),
    .io_HBM_interface_readData_valid(Memory_31_io_HBM_interface_readData_valid),
    .io_HBM_interface_readData_bits_data(Memory_31_io_HBM_interface_readData_bits_data),
    .io_HBM_interface_readData_bits_id(Memory_31_io_HBM_interface_readData_bits_id),
    .io_HBM_interface_readData_bits_last(Memory_31_io_HBM_interface_readData_bits_last),
    .io_HBM_interface_readData_bits_resp(Memory_31_io_HBM_interface_readData_bits_resp),
    .io_mem_clock(Memory_31_io_mem_clock),
    .io_reset_h(Memory_31_io_reset_h)
  );
  copy copy_level ( // @[SLR0_Mem.scala 46:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3),
    .io_out_4(copy_level_io_out_4),
    .io_out_5(copy_level_io_out_5),
    .io_out_6(copy_level_io_out_6),
    .io_out_7(copy_level_io_out_7),
    .io_out_8(copy_level_io_out_8),
    .io_out_9(copy_level_io_out_9),
    .io_out_10(copy_level_io_out_10),
    .io_out_11(copy_level_io_out_11),
    .io_out_12(copy_level_io_out_12),
    .io_out_13(copy_level_io_out_13),
    .io_out_14(copy_level_io_out_14),
    .io_out_15(copy_level_io_out_15),
    .io_out_16(copy_level_io_out_16),
    .io_out_17(copy_level_io_out_17),
    .io_out_18(copy_level_io_out_18),
    .io_out_19(copy_level_io_out_19),
    .io_out_20(copy_level_io_out_20),
    .io_out_21(copy_level_io_out_21),
    .io_out_22(copy_level_io_out_22),
    .io_out_23(copy_level_io_out_23),
    .io_out_24(copy_level_io_out_24),
    .io_out_25(copy_level_io_out_25),
    .io_out_26(copy_level_io_out_26),
    .io_out_27(copy_level_io_out_27),
    .io_out_28(copy_level_io_out_28),
    .io_out_29(copy_level_io_out_29),
    .io_out_30(copy_level_io_out_30),
    .io_out_31(copy_level_io_out_31)
  );
  copy copy_kernel_count ( // @[SLR0_Mem.scala 47:35]
    .clock(copy_kernel_count_clock),
    .reset(copy_kernel_count_reset),
    .io_in(copy_kernel_count_io_in),
    .io_out_0(copy_kernel_count_io_out_0),
    .io_out_1(copy_kernel_count_io_out_1),
    .io_out_2(copy_kernel_count_io_out_2),
    .io_out_3(copy_kernel_count_io_out_3),
    .io_out_4(copy_kernel_count_io_out_4),
    .io_out_5(copy_kernel_count_io_out_5),
    .io_out_6(copy_kernel_count_io_out_6),
    .io_out_7(copy_kernel_count_io_out_7),
    .io_out_8(copy_kernel_count_io_out_8),
    .io_out_9(copy_kernel_count_io_out_9),
    .io_out_10(copy_kernel_count_io_out_10),
    .io_out_11(copy_kernel_count_io_out_11),
    .io_out_12(copy_kernel_count_io_out_12),
    .io_out_13(copy_kernel_count_io_out_13),
    .io_out_14(copy_kernel_count_io_out_14),
    .io_out_15(copy_kernel_count_io_out_15),
    .io_out_16(copy_kernel_count_io_out_16),
    .io_out_17(copy_kernel_count_io_out_17),
    .io_out_18(copy_kernel_count_io_out_18),
    .io_out_19(copy_kernel_count_io_out_19),
    .io_out_20(copy_kernel_count_io_out_20),
    .io_out_21(copy_kernel_count_io_out_21),
    .io_out_22(copy_kernel_count_io_out_22),
    .io_out_23(copy_kernel_count_io_out_23),
    .io_out_24(copy_kernel_count_io_out_24),
    .io_out_25(copy_kernel_count_io_out_25),
    .io_out_26(copy_kernel_count_io_out_26),
    .io_out_27(copy_kernel_count_io_out_27),
    .io_out_28(copy_kernel_count_io_out_28),
    .io_out_29(copy_kernel_count_io_out_29),
    .io_out_30(copy_kernel_count_io_out_30),
    .io_out_31(copy_kernel_count_io_out_31)
  );
  copy_2 copy_master_finish ( // @[SLR0_Mem.scala 48:36]
    .clock(copy_master_finish_clock),
    .reset(copy_master_finish_reset),
    .io_in(copy_master_finish_io_in),
    .io_out_0(copy_master_finish_io_out_0),
    .io_out_1(copy_master_finish_io_out_1),
    .io_out_2(copy_master_finish_io_out_2),
    .io_out_3(copy_master_finish_io_out_3),
    .io_out_4(copy_master_finish_io_out_4),
    .io_out_5(copy_master_finish_io_out_5),
    .io_out_6(copy_master_finish_io_out_6),
    .io_out_7(copy_master_finish_io_out_7),
    .io_out_8(copy_master_finish_io_out_8),
    .io_out_9(copy_master_finish_io_out_9),
    .io_out_10(copy_master_finish_io_out_10),
    .io_out_11(copy_master_finish_io_out_11),
    .io_out_12(copy_master_finish_io_out_12),
    .io_out_13(copy_master_finish_io_out_13),
    .io_out_14(copy_master_finish_io_out_14),
    .io_out_15(copy_master_finish_io_out_15),
    .io_out_16(copy_master_finish_io_out_16),
    .io_out_17(copy_master_finish_io_out_17),
    .io_out_18(copy_master_finish_io_out_18),
    .io_out_19(copy_master_finish_io_out_19),
    .io_out_20(copy_master_finish_io_out_20),
    .io_out_21(copy_master_finish_io_out_21),
    .io_out_22(copy_master_finish_io_out_22),
    .io_out_23(copy_master_finish_io_out_23),
    .io_out_24(copy_master_finish_io_out_24),
    .io_out_25(copy_master_finish_io_out_25),
    .io_out_26(copy_master_finish_io_out_26),
    .io_out_27(copy_master_finish_io_out_27),
    .io_out_28(copy_master_finish_io_out_28),
    .io_out_29(copy_master_finish_io_out_29),
    .io_out_30(copy_master_finish_io_out_30),
    .io_out_31(copy_master_finish_io_out_31)
  );
  copy copy_node_num ( // @[SLR0_Mem.scala 49:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3),
    .io_out_4(copy_node_num_io_out_4),
    .io_out_5(copy_node_num_io_out_5),
    .io_out_6(copy_node_num_io_out_6),
    .io_out_7(copy_node_num_io_out_7),
    .io_out_8(copy_node_num_io_out_8),
    .io_out_9(copy_node_num_io_out_9),
    .io_out_10(copy_node_num_io_out_10),
    .io_out_11(copy_node_num_io_out_11),
    .io_out_12(copy_node_num_io_out_12),
    .io_out_13(copy_node_num_io_out_13),
    .io_out_14(copy_node_num_io_out_14),
    .io_out_15(copy_node_num_io_out_15),
    .io_out_16(copy_node_num_io_out_16),
    .io_out_17(copy_node_num_io_out_17),
    .io_out_18(copy_node_num_io_out_18),
    .io_out_19(copy_node_num_io_out_19),
    .io_out_20(copy_node_num_io_out_20),
    .io_out_21(copy_node_num_io_out_21),
    .io_out_22(copy_node_num_io_out_22),
    .io_out_23(copy_node_num_io_out_23),
    .io_out_24(copy_node_num_io_out_24),
    .io_out_25(copy_node_num_io_out_25),
    .io_out_26(copy_node_num_io_out_26),
    .io_out_27(copy_node_num_io_out_27),
    .io_out_28(copy_node_num_io_out_28),
    .io_out_29(copy_node_num_io_out_29),
    .io_out_30(copy_node_num_io_out_30),
    .io_out_31(copy_node_num_io_out_31)
  );
  copy_2 copy_push_or_pull ( // @[SLR0_Mem.scala 50:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3),
    .io_out_4(copy_push_or_pull_io_out_4),
    .io_out_5(copy_push_or_pull_io_out_5),
    .io_out_6(copy_push_or_pull_io_out_6),
    .io_out_7(copy_push_or_pull_io_out_7),
    .io_out_8(copy_push_or_pull_io_out_8),
    .io_out_9(copy_push_or_pull_io_out_9),
    .io_out_10(copy_push_or_pull_io_out_10),
    .io_out_11(copy_push_or_pull_io_out_11),
    .io_out_12(copy_push_or_pull_io_out_12),
    .io_out_13(copy_push_or_pull_io_out_13),
    .io_out_14(copy_push_or_pull_io_out_14),
    .io_out_15(copy_push_or_pull_io_out_15),
    .io_out_16(copy_push_or_pull_io_out_16),
    .io_out_17(copy_push_or_pull_io_out_17),
    .io_out_18(copy_push_or_pull_io_out_18),
    .io_out_19(copy_push_or_pull_io_out_19),
    .io_out_20(copy_push_or_pull_io_out_20),
    .io_out_21(copy_push_or_pull_io_out_21),
    .io_out_22(copy_push_or_pull_io_out_22),
    .io_out_23(copy_push_or_pull_io_out_23),
    .io_out_24(copy_push_or_pull_io_out_24),
    .io_out_25(copy_push_or_pull_io_out_25),
    .io_out_26(copy_push_or_pull_io_out_26),
    .io_out_27(copy_push_or_pull_io_out_27),
    .io_out_28(copy_push_or_pull_io_out_28),
    .io_out_29(copy_push_or_pull_io_out_29),
    .io_out_30(copy_push_or_pull_io_out_30),
    .io_out_31(copy_push_or_pull_io_out_31)
  );
  copy copy_offset_CSR_R_offset ( // @[SLR0_Mem.scala 51:42]
    .clock(copy_offset_CSR_R_offset_clock),
    .reset(copy_offset_CSR_R_offset_reset),
    .io_in(copy_offset_CSR_R_offset_io_in),
    .io_out_0(copy_offset_CSR_R_offset_io_out_0),
    .io_out_1(copy_offset_CSR_R_offset_io_out_1),
    .io_out_2(copy_offset_CSR_R_offset_io_out_2),
    .io_out_3(copy_offset_CSR_R_offset_io_out_3),
    .io_out_4(copy_offset_CSR_R_offset_io_out_4),
    .io_out_5(copy_offset_CSR_R_offset_io_out_5),
    .io_out_6(copy_offset_CSR_R_offset_io_out_6),
    .io_out_7(copy_offset_CSR_R_offset_io_out_7),
    .io_out_8(copy_offset_CSR_R_offset_io_out_8),
    .io_out_9(copy_offset_CSR_R_offset_io_out_9),
    .io_out_10(copy_offset_CSR_R_offset_io_out_10),
    .io_out_11(copy_offset_CSR_R_offset_io_out_11),
    .io_out_12(copy_offset_CSR_R_offset_io_out_12),
    .io_out_13(copy_offset_CSR_R_offset_io_out_13),
    .io_out_14(copy_offset_CSR_R_offset_io_out_14),
    .io_out_15(copy_offset_CSR_R_offset_io_out_15),
    .io_out_16(copy_offset_CSR_R_offset_io_out_16),
    .io_out_17(copy_offset_CSR_R_offset_io_out_17),
    .io_out_18(copy_offset_CSR_R_offset_io_out_18),
    .io_out_19(copy_offset_CSR_R_offset_io_out_19),
    .io_out_20(copy_offset_CSR_R_offset_io_out_20),
    .io_out_21(copy_offset_CSR_R_offset_io_out_21),
    .io_out_22(copy_offset_CSR_R_offset_io_out_22),
    .io_out_23(copy_offset_CSR_R_offset_io_out_23),
    .io_out_24(copy_offset_CSR_R_offset_io_out_24),
    .io_out_25(copy_offset_CSR_R_offset_io_out_25),
    .io_out_26(copy_offset_CSR_R_offset_io_out_26),
    .io_out_27(copy_offset_CSR_R_offset_io_out_27),
    .io_out_28(copy_offset_CSR_R_offset_io_out_28),
    .io_out_29(copy_offset_CSR_R_offset_io_out_29),
    .io_out_30(copy_offset_CSR_R_offset_io_out_30),
    .io_out_31(copy_offset_CSR_R_offset_io_out_31)
  );
  copy copy_offset_CSR_C_offset ( // @[SLR0_Mem.scala 52:42]
    .clock(copy_offset_CSR_C_offset_clock),
    .reset(copy_offset_CSR_C_offset_reset),
    .io_in(copy_offset_CSR_C_offset_io_in),
    .io_out_0(copy_offset_CSR_C_offset_io_out_0),
    .io_out_1(copy_offset_CSR_C_offset_io_out_1),
    .io_out_2(copy_offset_CSR_C_offset_io_out_2),
    .io_out_3(copy_offset_CSR_C_offset_io_out_3),
    .io_out_4(copy_offset_CSR_C_offset_io_out_4),
    .io_out_5(copy_offset_CSR_C_offset_io_out_5),
    .io_out_6(copy_offset_CSR_C_offset_io_out_6),
    .io_out_7(copy_offset_CSR_C_offset_io_out_7),
    .io_out_8(copy_offset_CSR_C_offset_io_out_8),
    .io_out_9(copy_offset_CSR_C_offset_io_out_9),
    .io_out_10(copy_offset_CSR_C_offset_io_out_10),
    .io_out_11(copy_offset_CSR_C_offset_io_out_11),
    .io_out_12(copy_offset_CSR_C_offset_io_out_12),
    .io_out_13(copy_offset_CSR_C_offset_io_out_13),
    .io_out_14(copy_offset_CSR_C_offset_io_out_14),
    .io_out_15(copy_offset_CSR_C_offset_io_out_15),
    .io_out_16(copy_offset_CSR_C_offset_io_out_16),
    .io_out_17(copy_offset_CSR_C_offset_io_out_17),
    .io_out_18(copy_offset_CSR_C_offset_io_out_18),
    .io_out_19(copy_offset_CSR_C_offset_io_out_19),
    .io_out_20(copy_offset_CSR_C_offset_io_out_20),
    .io_out_21(copy_offset_CSR_C_offset_io_out_21),
    .io_out_22(copy_offset_CSR_C_offset_io_out_22),
    .io_out_23(copy_offset_CSR_C_offset_io_out_23),
    .io_out_24(copy_offset_CSR_C_offset_io_out_24),
    .io_out_25(copy_offset_CSR_C_offset_io_out_25),
    .io_out_26(copy_offset_CSR_C_offset_io_out_26),
    .io_out_27(copy_offset_CSR_C_offset_io_out_27),
    .io_out_28(copy_offset_CSR_C_offset_io_out_28),
    .io_out_29(copy_offset_CSR_C_offset_io_out_29),
    .io_out_30(copy_offset_CSR_C_offset_io_out_30),
    .io_out_31(copy_offset_CSR_C_offset_io_out_31)
  );
  copy copy_offset_CSC_R_offset ( // @[SLR0_Mem.scala 53:42]
    .clock(copy_offset_CSC_R_offset_clock),
    .reset(copy_offset_CSC_R_offset_reset),
    .io_in(copy_offset_CSC_R_offset_io_in),
    .io_out_0(copy_offset_CSC_R_offset_io_out_0),
    .io_out_1(copy_offset_CSC_R_offset_io_out_1),
    .io_out_2(copy_offset_CSC_R_offset_io_out_2),
    .io_out_3(copy_offset_CSC_R_offset_io_out_3),
    .io_out_4(copy_offset_CSC_R_offset_io_out_4),
    .io_out_5(copy_offset_CSC_R_offset_io_out_5),
    .io_out_6(copy_offset_CSC_R_offset_io_out_6),
    .io_out_7(copy_offset_CSC_R_offset_io_out_7),
    .io_out_8(copy_offset_CSC_R_offset_io_out_8),
    .io_out_9(copy_offset_CSC_R_offset_io_out_9),
    .io_out_10(copy_offset_CSC_R_offset_io_out_10),
    .io_out_11(copy_offset_CSC_R_offset_io_out_11),
    .io_out_12(copy_offset_CSC_R_offset_io_out_12),
    .io_out_13(copy_offset_CSC_R_offset_io_out_13),
    .io_out_14(copy_offset_CSC_R_offset_io_out_14),
    .io_out_15(copy_offset_CSC_R_offset_io_out_15),
    .io_out_16(copy_offset_CSC_R_offset_io_out_16),
    .io_out_17(copy_offset_CSC_R_offset_io_out_17),
    .io_out_18(copy_offset_CSC_R_offset_io_out_18),
    .io_out_19(copy_offset_CSC_R_offset_io_out_19),
    .io_out_20(copy_offset_CSC_R_offset_io_out_20),
    .io_out_21(copy_offset_CSC_R_offset_io_out_21),
    .io_out_22(copy_offset_CSC_R_offset_io_out_22),
    .io_out_23(copy_offset_CSC_R_offset_io_out_23),
    .io_out_24(copy_offset_CSC_R_offset_io_out_24),
    .io_out_25(copy_offset_CSC_R_offset_io_out_25),
    .io_out_26(copy_offset_CSC_R_offset_io_out_26),
    .io_out_27(copy_offset_CSC_R_offset_io_out_27),
    .io_out_28(copy_offset_CSC_R_offset_io_out_28),
    .io_out_29(copy_offset_CSC_R_offset_io_out_29),
    .io_out_30(copy_offset_CSC_R_offset_io_out_30),
    .io_out_31(copy_offset_CSC_R_offset_io_out_31)
  );
  copy copy_offset_CSC_C_offset ( // @[SLR0_Mem.scala 54:42]
    .clock(copy_offset_CSC_C_offset_clock),
    .reset(copy_offset_CSC_C_offset_reset),
    .io_in(copy_offset_CSC_C_offset_io_in),
    .io_out_0(copy_offset_CSC_C_offset_io_out_0),
    .io_out_1(copy_offset_CSC_C_offset_io_out_1),
    .io_out_2(copy_offset_CSC_C_offset_io_out_2),
    .io_out_3(copy_offset_CSC_C_offset_io_out_3),
    .io_out_4(copy_offset_CSC_C_offset_io_out_4),
    .io_out_5(copy_offset_CSC_C_offset_io_out_5),
    .io_out_6(copy_offset_CSC_C_offset_io_out_6),
    .io_out_7(copy_offset_CSC_C_offset_io_out_7),
    .io_out_8(copy_offset_CSC_C_offset_io_out_8),
    .io_out_9(copy_offset_CSC_C_offset_io_out_9),
    .io_out_10(copy_offset_CSC_C_offset_io_out_10),
    .io_out_11(copy_offset_CSC_C_offset_io_out_11),
    .io_out_12(copy_offset_CSC_C_offset_io_out_12),
    .io_out_13(copy_offset_CSC_C_offset_io_out_13),
    .io_out_14(copy_offset_CSC_C_offset_io_out_14),
    .io_out_15(copy_offset_CSC_C_offset_io_out_15),
    .io_out_16(copy_offset_CSC_C_offset_io_out_16),
    .io_out_17(copy_offset_CSC_C_offset_io_out_17),
    .io_out_18(copy_offset_CSC_C_offset_io_out_18),
    .io_out_19(copy_offset_CSC_C_offset_io_out_19),
    .io_out_20(copy_offset_CSC_C_offset_io_out_20),
    .io_out_21(copy_offset_CSC_C_offset_io_out_21),
    .io_out_22(copy_offset_CSC_C_offset_io_out_22),
    .io_out_23(copy_offset_CSC_C_offset_io_out_23),
    .io_out_24(copy_offset_CSC_C_offset_io_out_24),
    .io_out_25(copy_offset_CSC_C_offset_io_out_25),
    .io_out_26(copy_offset_CSC_C_offset_io_out_26),
    .io_out_27(copy_offset_CSC_C_offset_io_out_27),
    .io_out_28(copy_offset_CSC_C_offset_io_out_28),
    .io_out_29(copy_offset_CSC_C_offset_io_out_29),
    .io_out_30(copy_offset_CSC_C_offset_io_out_30),
    .io_out_31(copy_offset_CSC_C_offset_io_out_31)
  );
  copy copy_offset_level_offset ( // @[SLR0_Mem.scala 55:42]
    .clock(copy_offset_level_offset_clock),
    .reset(copy_offset_level_offset_reset),
    .io_in(copy_offset_level_offset_io_in),
    .io_out_0(copy_offset_level_offset_io_out_0),
    .io_out_1(copy_offset_level_offset_io_out_1),
    .io_out_2(copy_offset_level_offset_io_out_2),
    .io_out_3(copy_offset_level_offset_io_out_3),
    .io_out_4(copy_offset_level_offset_io_out_4),
    .io_out_5(copy_offset_level_offset_io_out_5),
    .io_out_6(copy_offset_level_offset_io_out_6),
    .io_out_7(copy_offset_level_offset_io_out_7),
    .io_out_8(copy_offset_level_offset_io_out_8),
    .io_out_9(copy_offset_level_offset_io_out_9),
    .io_out_10(copy_offset_level_offset_io_out_10),
    .io_out_11(copy_offset_level_offset_io_out_11),
    .io_out_12(copy_offset_level_offset_io_out_12),
    .io_out_13(copy_offset_level_offset_io_out_13),
    .io_out_14(copy_offset_level_offset_io_out_14),
    .io_out_15(copy_offset_level_offset_io_out_15),
    .io_out_16(copy_offset_level_offset_io_out_16),
    .io_out_17(copy_offset_level_offset_io_out_17),
    .io_out_18(copy_offset_level_offset_io_out_18),
    .io_out_19(copy_offset_level_offset_io_out_19),
    .io_out_20(copy_offset_level_offset_io_out_20),
    .io_out_21(copy_offset_level_offset_io_out_21),
    .io_out_22(copy_offset_level_offset_io_out_22),
    .io_out_23(copy_offset_level_offset_io_out_23),
    .io_out_24(copy_offset_level_offset_io_out_24),
    .io_out_25(copy_offset_level_offset_io_out_25),
    .io_out_26(copy_offset_level_offset_io_out_26),
    .io_out_27(copy_offset_level_offset_io_out_27),
    .io_out_28(copy_offset_level_offset_io_out_28),
    .io_out_29(copy_offset_level_offset_io_out_29),
    .io_out_30(copy_offset_level_offset_io_out_30),
    .io_out_31(copy_offset_level_offset_io_out_31)
  );
  assign io_R_array_index_0_ready = Memory_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_1_ready = Memory_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_2_ready = Memory_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_3_ready = Memory_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_4_ready = Memory_1_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_5_ready = Memory_1_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_6_ready = Memory_1_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_7_ready = Memory_1_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_8_ready = Memory_2_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_9_ready = Memory_2_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_10_ready = Memory_2_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_11_ready = Memory_2_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_12_ready = Memory_3_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_13_ready = Memory_3_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_14_ready = Memory_3_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_15_ready = Memory_3_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_16_ready = Memory_4_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_17_ready = Memory_4_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_18_ready = Memory_4_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_19_ready = Memory_4_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_20_ready = Memory_5_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_21_ready = Memory_5_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_22_ready = Memory_5_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_23_ready = Memory_5_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_24_ready = Memory_6_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_25_ready = Memory_6_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_26_ready = Memory_6_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_27_ready = Memory_6_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_28_ready = Memory_7_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_29_ready = Memory_7_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_30_ready = Memory_7_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_31_ready = Memory_7_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_32_ready = Memory_8_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_33_ready = Memory_8_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_34_ready = Memory_8_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_35_ready = Memory_8_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_36_ready = Memory_9_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_37_ready = Memory_9_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_38_ready = Memory_9_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_39_ready = Memory_9_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_40_ready = Memory_10_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_41_ready = Memory_10_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_42_ready = Memory_10_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_43_ready = Memory_10_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_44_ready = Memory_11_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_45_ready = Memory_11_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_46_ready = Memory_11_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_47_ready = Memory_11_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_48_ready = Memory_12_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_49_ready = Memory_12_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_50_ready = Memory_12_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_51_ready = Memory_12_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_52_ready = Memory_13_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_53_ready = Memory_13_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_54_ready = Memory_13_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_55_ready = Memory_13_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_56_ready = Memory_14_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_57_ready = Memory_14_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_58_ready = Memory_14_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_59_ready = Memory_14_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_60_ready = Memory_15_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_61_ready = Memory_15_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_62_ready = Memory_15_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_63_ready = Memory_15_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_64_ready = Memory_16_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_65_ready = Memory_16_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_66_ready = Memory_16_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_67_ready = Memory_16_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_68_ready = Memory_17_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_69_ready = Memory_17_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_70_ready = Memory_17_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_71_ready = Memory_17_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_72_ready = Memory_18_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_73_ready = Memory_18_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_74_ready = Memory_18_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_75_ready = Memory_18_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_76_ready = Memory_19_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_77_ready = Memory_19_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_78_ready = Memory_19_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_79_ready = Memory_19_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_80_ready = Memory_20_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_81_ready = Memory_20_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_82_ready = Memory_20_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_83_ready = Memory_20_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_84_ready = Memory_21_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_85_ready = Memory_21_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_86_ready = Memory_21_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_87_ready = Memory_21_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_88_ready = Memory_22_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_89_ready = Memory_22_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_90_ready = Memory_22_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_91_ready = Memory_22_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_92_ready = Memory_23_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_93_ready = Memory_23_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_94_ready = Memory_23_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_95_ready = Memory_23_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_96_ready = Memory_24_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_97_ready = Memory_24_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_98_ready = Memory_24_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_99_ready = Memory_24_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_100_ready = Memory_25_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_101_ready = Memory_25_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_102_ready = Memory_25_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_103_ready = Memory_25_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_104_ready = Memory_26_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_105_ready = Memory_26_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_106_ready = Memory_26_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_107_ready = Memory_26_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_108_ready = Memory_27_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_109_ready = Memory_27_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_110_ready = Memory_27_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_111_ready = Memory_27_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_112_ready = Memory_28_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_113_ready = Memory_28_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_114_ready = Memory_28_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_115_ready = Memory_28_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_116_ready = Memory_29_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_117_ready = Memory_29_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_118_ready = Memory_29_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_119_ready = Memory_29_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_120_ready = Memory_30_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_121_ready = Memory_30_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_122_ready = Memory_30_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_123_ready = Memory_30_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_124_ready = Memory_31_io_R_array_index_0_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_125_ready = Memory_31_io_R_array_index_1_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_126_ready = Memory_31_io_R_array_index_2_ready; // @[SLR0_Mem.scala 96:49]
  assign io_R_array_index_127_ready = Memory_31_io_R_array_index_3_ready; // @[SLR0_Mem.scala 96:49]
  assign io_neighbour_cnt_0 = Memory_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_1 = Memory_1_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_2 = Memory_2_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_3 = Memory_3_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_4 = Memory_4_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_5 = Memory_5_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_6 = Memory_6_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_7 = Memory_7_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_8 = Memory_8_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_9 = Memory_9_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_10 = Memory_10_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_11 = Memory_11_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_12 = Memory_12_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_13 = Memory_13_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_14 = Memory_14_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_15 = Memory_15_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_16 = Memory_16_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_17 = Memory_17_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_18 = Memory_18_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_19 = Memory_19_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_20 = Memory_20_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_21 = Memory_21_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_22 = Memory_22_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_23 = Memory_23_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_24 = Memory_24_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_25 = Memory_25_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_26 = Memory_26_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_27 = Memory_27_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_28 = Memory_28_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_29 = Memory_29_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_30 = Memory_30_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_neighbour_cnt_31 = Memory_31_io_neighbour_cnt; // @[SLR0_Mem.scala 89:42]
  assign io_mem_end_0 = Memory_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_1 = Memory_1_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_2 = Memory_2_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_3 = Memory_3_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_4 = Memory_4_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_5 = Memory_5_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_6 = Memory_6_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_7 = Memory_7_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_8 = Memory_8_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_9 = Memory_9_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_10 = Memory_10_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_11 = Memory_11_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_12 = Memory_12_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_13 = Memory_13_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_14 = Memory_14_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_15 = Memory_15_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_16 = Memory_16_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_17 = Memory_17_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_18 = Memory_18_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_19 = Memory_19_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_20 = Memory_20_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_21 = Memory_21_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_22 = Memory_22_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_23 = Memory_23_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_24 = Memory_24_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_25 = Memory_25_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_26 = Memory_26_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_27 = Memory_27_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_28 = Memory_28_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_29 = Memory_29_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_30 = Memory_30_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_mem_end_31 = Memory_31_io_mem_end; // @[SLR0_Mem.scala 90:42]
  assign io_neighbours_0_valid = Memory_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_0_bits = Memory_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_1_valid = Memory_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_1_bits = Memory_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_2_valid = Memory_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_2_bits = Memory_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_3_valid = Memory_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_3_bits = Memory_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_4_valid = Memory_1_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_4_bits = Memory_1_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_5_valid = Memory_1_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_5_bits = Memory_1_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_6_valid = Memory_1_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_6_bits = Memory_1_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_7_valid = Memory_1_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_7_bits = Memory_1_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_8_valid = Memory_2_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_8_bits = Memory_2_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_9_valid = Memory_2_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_9_bits = Memory_2_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_10_valid = Memory_2_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_10_bits = Memory_2_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_11_valid = Memory_2_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_11_bits = Memory_2_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_12_valid = Memory_3_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_12_bits = Memory_3_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_13_valid = Memory_3_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_13_bits = Memory_3_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_14_valid = Memory_3_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_14_bits = Memory_3_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_15_valid = Memory_3_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_15_bits = Memory_3_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_16_valid = Memory_4_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_16_bits = Memory_4_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_17_valid = Memory_4_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_17_bits = Memory_4_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_18_valid = Memory_4_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_18_bits = Memory_4_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_19_valid = Memory_4_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_19_bits = Memory_4_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_20_valid = Memory_5_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_20_bits = Memory_5_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_21_valid = Memory_5_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_21_bits = Memory_5_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_22_valid = Memory_5_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_22_bits = Memory_5_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_23_valid = Memory_5_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_23_bits = Memory_5_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_24_valid = Memory_6_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_24_bits = Memory_6_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_25_valid = Memory_6_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_25_bits = Memory_6_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_26_valid = Memory_6_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_26_bits = Memory_6_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_27_valid = Memory_6_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_27_bits = Memory_6_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_28_valid = Memory_7_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_28_bits = Memory_7_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_29_valid = Memory_7_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_29_bits = Memory_7_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_30_valid = Memory_7_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_30_bits = Memory_7_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_31_valid = Memory_7_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_31_bits = Memory_7_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_32_valid = Memory_8_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_32_bits = Memory_8_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_33_valid = Memory_8_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_33_bits = Memory_8_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_34_valid = Memory_8_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_34_bits = Memory_8_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_35_valid = Memory_8_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_35_bits = Memory_8_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_36_valid = Memory_9_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_36_bits = Memory_9_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_37_valid = Memory_9_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_37_bits = Memory_9_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_38_valid = Memory_9_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_38_bits = Memory_9_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_39_valid = Memory_9_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_39_bits = Memory_9_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_40_valid = Memory_10_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_40_bits = Memory_10_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_41_valid = Memory_10_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_41_bits = Memory_10_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_42_valid = Memory_10_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_42_bits = Memory_10_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_43_valid = Memory_10_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_43_bits = Memory_10_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_44_valid = Memory_11_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_44_bits = Memory_11_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_45_valid = Memory_11_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_45_bits = Memory_11_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_46_valid = Memory_11_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_46_bits = Memory_11_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_47_valid = Memory_11_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_47_bits = Memory_11_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_48_valid = Memory_12_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_48_bits = Memory_12_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_49_valid = Memory_12_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_49_bits = Memory_12_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_50_valid = Memory_12_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_50_bits = Memory_12_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_51_valid = Memory_12_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_51_bits = Memory_12_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_52_valid = Memory_13_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_52_bits = Memory_13_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_53_valid = Memory_13_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_53_bits = Memory_13_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_54_valid = Memory_13_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_54_bits = Memory_13_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_55_valid = Memory_13_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_55_bits = Memory_13_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_56_valid = Memory_14_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_56_bits = Memory_14_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_57_valid = Memory_14_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_57_bits = Memory_14_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_58_valid = Memory_14_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_58_bits = Memory_14_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_59_valid = Memory_14_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_59_bits = Memory_14_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_60_valid = Memory_15_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_60_bits = Memory_15_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_61_valid = Memory_15_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_61_bits = Memory_15_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_62_valid = Memory_15_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_62_bits = Memory_15_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_63_valid = Memory_15_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_63_bits = Memory_15_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_64_valid = Memory_16_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_64_bits = Memory_16_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_65_valid = Memory_16_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_65_bits = Memory_16_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_66_valid = Memory_16_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_66_bits = Memory_16_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_67_valid = Memory_16_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_67_bits = Memory_16_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_68_valid = Memory_17_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_68_bits = Memory_17_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_69_valid = Memory_17_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_69_bits = Memory_17_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_70_valid = Memory_17_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_70_bits = Memory_17_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_71_valid = Memory_17_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_71_bits = Memory_17_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_72_valid = Memory_18_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_72_bits = Memory_18_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_73_valid = Memory_18_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_73_bits = Memory_18_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_74_valid = Memory_18_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_74_bits = Memory_18_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_75_valid = Memory_18_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_75_bits = Memory_18_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_76_valid = Memory_19_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_76_bits = Memory_19_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_77_valid = Memory_19_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_77_bits = Memory_19_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_78_valid = Memory_19_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_78_bits = Memory_19_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_79_valid = Memory_19_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_79_bits = Memory_19_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_80_valid = Memory_20_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_80_bits = Memory_20_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_81_valid = Memory_20_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_81_bits = Memory_20_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_82_valid = Memory_20_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_82_bits = Memory_20_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_83_valid = Memory_20_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_83_bits = Memory_20_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_84_valid = Memory_21_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_84_bits = Memory_21_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_85_valid = Memory_21_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_85_bits = Memory_21_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_86_valid = Memory_21_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_86_bits = Memory_21_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_87_valid = Memory_21_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_87_bits = Memory_21_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_88_valid = Memory_22_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_88_bits = Memory_22_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_89_valid = Memory_22_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_89_bits = Memory_22_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_90_valid = Memory_22_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_90_bits = Memory_22_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_91_valid = Memory_22_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_91_bits = Memory_22_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_92_valid = Memory_23_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_92_bits = Memory_23_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_93_valid = Memory_23_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_93_bits = Memory_23_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_94_valid = Memory_23_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_94_bits = Memory_23_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_95_valid = Memory_23_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_95_bits = Memory_23_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_96_valid = Memory_24_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_96_bits = Memory_24_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_97_valid = Memory_24_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_97_bits = Memory_24_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_98_valid = Memory_24_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_98_bits = Memory_24_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_99_valid = Memory_24_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_99_bits = Memory_24_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_100_valid = Memory_25_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_100_bits = Memory_25_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_101_valid = Memory_25_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_101_bits = Memory_25_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_102_valid = Memory_25_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_102_bits = Memory_25_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_103_valid = Memory_25_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_103_bits = Memory_25_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_104_valid = Memory_26_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_104_bits = Memory_26_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_105_valid = Memory_26_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_105_bits = Memory_26_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_106_valid = Memory_26_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_106_bits = Memory_26_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_107_valid = Memory_26_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_107_bits = Memory_26_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_108_valid = Memory_27_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_108_bits = Memory_27_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_109_valid = Memory_27_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_109_bits = Memory_27_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_110_valid = Memory_27_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_110_bits = Memory_27_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_111_valid = Memory_27_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_111_bits = Memory_27_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_112_valid = Memory_28_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_112_bits = Memory_28_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_113_valid = Memory_28_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_113_bits = Memory_28_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_114_valid = Memory_28_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_114_bits = Memory_28_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_115_valid = Memory_28_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_115_bits = Memory_28_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_116_valid = Memory_29_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_116_bits = Memory_29_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_117_valid = Memory_29_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_117_bits = Memory_29_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_118_valid = Memory_29_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_118_bits = Memory_29_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_119_valid = Memory_29_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_119_bits = Memory_29_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_120_valid = Memory_30_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_120_bits = Memory_30_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_121_valid = Memory_30_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_121_bits = Memory_30_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_122_valid = Memory_30_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_122_bits = Memory_30_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_123_valid = Memory_30_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_123_bits = Memory_30_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_124_valid = Memory_31_io_neighbours_0_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_124_bits = Memory_31_io_neighbours_0_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_125_valid = Memory_31_io_neighbours_1_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_125_bits = Memory_31_io_neighbours_1_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_126_valid = Memory_31_io_neighbours_2_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_126_bits = Memory_31_io_neighbours_2_bits; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_127_valid = Memory_31_io_neighbours_3_valid; // @[SLR0_Mem.scala 98:49]
  assign io_neighbours_127_bits = Memory_31_io_neighbours_3_bits; // @[SLR0_Mem.scala 98:49]
  assign io_uram_addr_a_0 = Memory_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_1 = Memory_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_2 = Memory_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_3 = Memory_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_4 = Memory_1_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_5 = Memory_1_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_6 = Memory_1_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_7 = Memory_1_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_8 = Memory_2_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_9 = Memory_2_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_10 = Memory_2_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_11 = Memory_2_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_12 = Memory_3_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_13 = Memory_3_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_14 = Memory_3_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_15 = Memory_3_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_16 = Memory_4_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_17 = Memory_4_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_18 = Memory_4_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_19 = Memory_4_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_20 = Memory_5_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_21 = Memory_5_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_22 = Memory_5_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_23 = Memory_5_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_24 = Memory_6_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_25 = Memory_6_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_26 = Memory_6_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_27 = Memory_6_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_28 = Memory_7_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_29 = Memory_7_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_30 = Memory_7_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_31 = Memory_7_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_32 = Memory_8_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_33 = Memory_8_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_34 = Memory_8_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_35 = Memory_8_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_36 = Memory_9_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_37 = Memory_9_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_38 = Memory_9_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_39 = Memory_9_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_40 = Memory_10_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_41 = Memory_10_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_42 = Memory_10_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_43 = Memory_10_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_44 = Memory_11_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_45 = Memory_11_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_46 = Memory_11_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_47 = Memory_11_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_48 = Memory_12_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_49 = Memory_12_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_50 = Memory_12_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_51 = Memory_12_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_52 = Memory_13_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_53 = Memory_13_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_54 = Memory_13_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_55 = Memory_13_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_56 = Memory_14_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_57 = Memory_14_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_58 = Memory_14_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_59 = Memory_14_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_60 = Memory_15_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_61 = Memory_15_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_62 = Memory_15_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_63 = Memory_15_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_64 = Memory_16_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_65 = Memory_16_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_66 = Memory_16_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_67 = Memory_16_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_68 = Memory_17_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_69 = Memory_17_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_70 = Memory_17_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_71 = Memory_17_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_72 = Memory_18_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_73 = Memory_18_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_74 = Memory_18_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_75 = Memory_18_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_76 = Memory_19_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_77 = Memory_19_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_78 = Memory_19_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_79 = Memory_19_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_80 = Memory_20_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_81 = Memory_20_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_82 = Memory_20_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_83 = Memory_20_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_84 = Memory_21_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_85 = Memory_21_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_86 = Memory_21_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_87 = Memory_21_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_88 = Memory_22_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_89 = Memory_22_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_90 = Memory_22_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_91 = Memory_22_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_92 = Memory_23_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_93 = Memory_23_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_94 = Memory_23_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_95 = Memory_23_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_96 = Memory_24_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_97 = Memory_24_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_98 = Memory_24_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_99 = Memory_24_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_100 = Memory_25_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_101 = Memory_25_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_102 = Memory_25_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_103 = Memory_25_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_104 = Memory_26_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_105 = Memory_26_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_106 = Memory_26_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_107 = Memory_26_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_108 = Memory_27_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_109 = Memory_27_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_110 = Memory_27_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_111 = Memory_27_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_112 = Memory_28_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_113 = Memory_28_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_114 = Memory_28_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_115 = Memory_28_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_116 = Memory_29_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_117 = Memory_29_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_118 = Memory_29_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_119 = Memory_29_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_120 = Memory_30_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_121 = Memory_30_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_122 = Memory_30_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_123 = Memory_30_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_124 = Memory_31_io_uram_addr_a_0; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_125 = Memory_31_io_uram_addr_a_1; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_126 = Memory_31_io_uram_addr_a_2; // @[SLR0_Mem.scala 99:49]
  assign io_uram_addr_a_127 = Memory_31_io_uram_addr_a_3; // @[SLR0_Mem.scala 99:49]
  assign io_write_finish_0 = Memory_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_1 = Memory_1_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_2 = Memory_2_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_3 = Memory_3_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_4 = Memory_4_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_5 = Memory_5_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_6 = Memory_6_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_7 = Memory_7_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_8 = Memory_8_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_9 = Memory_9_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_10 = Memory_10_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_11 = Memory_11_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_12 = Memory_12_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_13 = Memory_13_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_14 = Memory_14_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_15 = Memory_15_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_16 = Memory_16_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_17 = Memory_17_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_18 = Memory_18_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_19 = Memory_19_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_20 = Memory_20_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_21 = Memory_21_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_22 = Memory_22_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_23 = Memory_23_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_24 = Memory_24_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_25 = Memory_25_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_26 = Memory_26_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_27 = Memory_27_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_28 = Memory_28_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_29 = Memory_29_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_30 = Memory_30_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_write_finish_31 = Memory_31_io_write_finish; // @[SLR0_Mem.scala 91:42]
  assign io_HBM_interface_0_writeAddr_valid = Memory_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeAddr_bits_addr = Memory_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeAddr_bits_len = Memory_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeAddr_bits_id = Memory_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeData_valid = Memory_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeData_bits_data = Memory_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeData_bits_strb = Memory_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeData_bits_last = Memory_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_writeResp_ready = Memory_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_readAddr_valid = Memory_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_readAddr_bits_addr = Memory_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_readAddr_bits_len = Memory_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_readAddr_bits_id = Memory_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_0_readData_ready = Memory_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeAddr_valid = Memory_1_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeAddr_bits_addr = Memory_1_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeAddr_bits_len = Memory_1_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeAddr_bits_id = Memory_1_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeData_valid = Memory_1_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeData_bits_data = Memory_1_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeData_bits_strb = Memory_1_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeData_bits_last = Memory_1_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_writeResp_ready = Memory_1_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_readAddr_valid = Memory_1_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_readAddr_bits_addr = Memory_1_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_readAddr_bits_len = Memory_1_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_readAddr_bits_id = Memory_1_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_1_readData_ready = Memory_1_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeAddr_valid = Memory_2_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeAddr_bits_addr = Memory_2_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeAddr_bits_len = Memory_2_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeAddr_bits_id = Memory_2_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeData_valid = Memory_2_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeData_bits_data = Memory_2_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeData_bits_strb = Memory_2_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeData_bits_last = Memory_2_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_writeResp_ready = Memory_2_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_readAddr_valid = Memory_2_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_readAddr_bits_addr = Memory_2_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_readAddr_bits_len = Memory_2_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_readAddr_bits_id = Memory_2_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_2_readData_ready = Memory_2_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeAddr_valid = Memory_3_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeAddr_bits_addr = Memory_3_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeAddr_bits_len = Memory_3_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeAddr_bits_id = Memory_3_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeData_valid = Memory_3_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeData_bits_data = Memory_3_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeData_bits_strb = Memory_3_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeData_bits_last = Memory_3_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_writeResp_ready = Memory_3_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_readAddr_valid = Memory_3_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_readAddr_bits_addr = Memory_3_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_readAddr_bits_len = Memory_3_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_readAddr_bits_id = Memory_3_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_3_readData_ready = Memory_3_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeAddr_valid = Memory_4_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeAddr_bits_addr = Memory_4_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeAddr_bits_len = Memory_4_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeAddr_bits_id = Memory_4_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeData_valid = Memory_4_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeData_bits_data = Memory_4_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeData_bits_strb = Memory_4_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeData_bits_last = Memory_4_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_writeResp_ready = Memory_4_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_readAddr_valid = Memory_4_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_readAddr_bits_addr = Memory_4_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_readAddr_bits_len = Memory_4_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_readAddr_bits_id = Memory_4_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_4_readData_ready = Memory_4_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeAddr_valid = Memory_5_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeAddr_bits_addr = Memory_5_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeAddr_bits_len = Memory_5_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeAddr_bits_id = Memory_5_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeData_valid = Memory_5_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeData_bits_data = Memory_5_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeData_bits_strb = Memory_5_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeData_bits_last = Memory_5_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_writeResp_ready = Memory_5_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_readAddr_valid = Memory_5_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_readAddr_bits_addr = Memory_5_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_readAddr_bits_len = Memory_5_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_readAddr_bits_id = Memory_5_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_5_readData_ready = Memory_5_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeAddr_valid = Memory_6_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeAddr_bits_addr = Memory_6_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeAddr_bits_len = Memory_6_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeAddr_bits_id = Memory_6_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeData_valid = Memory_6_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeData_bits_data = Memory_6_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeData_bits_strb = Memory_6_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeData_bits_last = Memory_6_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_writeResp_ready = Memory_6_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_readAddr_valid = Memory_6_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_readAddr_bits_addr = Memory_6_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_readAddr_bits_len = Memory_6_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_readAddr_bits_id = Memory_6_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_6_readData_ready = Memory_6_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeAddr_valid = Memory_7_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeAddr_bits_addr = Memory_7_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeAddr_bits_len = Memory_7_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeAddr_bits_id = Memory_7_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeData_valid = Memory_7_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeData_bits_data = Memory_7_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeData_bits_strb = Memory_7_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeData_bits_last = Memory_7_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_writeResp_ready = Memory_7_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_readAddr_valid = Memory_7_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_readAddr_bits_addr = Memory_7_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_readAddr_bits_len = Memory_7_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_readAddr_bits_id = Memory_7_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_7_readData_ready = Memory_7_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeAddr_valid = Memory_8_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeAddr_bits_addr = Memory_8_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeAddr_bits_len = Memory_8_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeAddr_bits_id = Memory_8_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeData_valid = Memory_8_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeData_bits_data = Memory_8_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeData_bits_strb = Memory_8_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeData_bits_last = Memory_8_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_writeResp_ready = Memory_8_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_readAddr_valid = Memory_8_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_readAddr_bits_addr = Memory_8_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_readAddr_bits_len = Memory_8_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_readAddr_bits_id = Memory_8_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_8_readData_ready = Memory_8_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeAddr_valid = Memory_9_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeAddr_bits_addr = Memory_9_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeAddr_bits_len = Memory_9_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeAddr_bits_id = Memory_9_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeData_valid = Memory_9_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeData_bits_data = Memory_9_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeData_bits_strb = Memory_9_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeData_bits_last = Memory_9_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_writeResp_ready = Memory_9_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_readAddr_valid = Memory_9_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_readAddr_bits_addr = Memory_9_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_readAddr_bits_len = Memory_9_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_readAddr_bits_id = Memory_9_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_9_readData_ready = Memory_9_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeAddr_valid = Memory_10_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeAddr_bits_addr = Memory_10_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeAddr_bits_len = Memory_10_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeAddr_bits_id = Memory_10_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeData_valid = Memory_10_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeData_bits_data = Memory_10_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeData_bits_strb = Memory_10_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeData_bits_last = Memory_10_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_writeResp_ready = Memory_10_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_readAddr_valid = Memory_10_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_readAddr_bits_addr = Memory_10_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_readAddr_bits_len = Memory_10_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_readAddr_bits_id = Memory_10_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_10_readData_ready = Memory_10_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeAddr_valid = Memory_11_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeAddr_bits_addr = Memory_11_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeAddr_bits_len = Memory_11_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeAddr_bits_id = Memory_11_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeData_valid = Memory_11_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeData_bits_data = Memory_11_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeData_bits_strb = Memory_11_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeData_bits_last = Memory_11_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_writeResp_ready = Memory_11_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_readAddr_valid = Memory_11_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_readAddr_bits_addr = Memory_11_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_readAddr_bits_len = Memory_11_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_readAddr_bits_id = Memory_11_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_11_readData_ready = Memory_11_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeAddr_valid = Memory_12_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeAddr_bits_addr = Memory_12_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeAddr_bits_len = Memory_12_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeAddr_bits_id = Memory_12_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeData_valid = Memory_12_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeData_bits_data = Memory_12_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeData_bits_strb = Memory_12_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeData_bits_last = Memory_12_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_writeResp_ready = Memory_12_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_readAddr_valid = Memory_12_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_readAddr_bits_addr = Memory_12_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_readAddr_bits_len = Memory_12_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_readAddr_bits_id = Memory_12_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_12_readData_ready = Memory_12_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeAddr_valid = Memory_13_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeAddr_bits_addr = Memory_13_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeAddr_bits_len = Memory_13_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeAddr_bits_id = Memory_13_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeData_valid = Memory_13_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeData_bits_data = Memory_13_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeData_bits_strb = Memory_13_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeData_bits_last = Memory_13_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_writeResp_ready = Memory_13_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_readAddr_valid = Memory_13_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_readAddr_bits_addr = Memory_13_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_readAddr_bits_len = Memory_13_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_readAddr_bits_id = Memory_13_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_13_readData_ready = Memory_13_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeAddr_valid = Memory_14_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeAddr_bits_addr = Memory_14_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeAddr_bits_len = Memory_14_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeAddr_bits_id = Memory_14_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeData_valid = Memory_14_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeData_bits_data = Memory_14_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeData_bits_strb = Memory_14_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeData_bits_last = Memory_14_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_writeResp_ready = Memory_14_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_readAddr_valid = Memory_14_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_readAddr_bits_addr = Memory_14_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_readAddr_bits_len = Memory_14_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_readAddr_bits_id = Memory_14_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_14_readData_ready = Memory_14_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeAddr_valid = Memory_15_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeAddr_bits_addr = Memory_15_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeAddr_bits_len = Memory_15_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeAddr_bits_id = Memory_15_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeData_valid = Memory_15_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeData_bits_data = Memory_15_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeData_bits_strb = Memory_15_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeData_bits_last = Memory_15_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_writeResp_ready = Memory_15_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_readAddr_valid = Memory_15_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_readAddr_bits_addr = Memory_15_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_readAddr_bits_len = Memory_15_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_readAddr_bits_id = Memory_15_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_15_readData_ready = Memory_15_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeAddr_valid = Memory_16_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeAddr_bits_addr = Memory_16_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeAddr_bits_len = Memory_16_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeAddr_bits_id = Memory_16_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeData_valid = Memory_16_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeData_bits_data = Memory_16_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeData_bits_strb = Memory_16_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeData_bits_last = Memory_16_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_writeResp_ready = Memory_16_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_readAddr_valid = Memory_16_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_readAddr_bits_addr = Memory_16_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_readAddr_bits_len = Memory_16_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_readAddr_bits_id = Memory_16_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_16_readData_ready = Memory_16_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeAddr_valid = Memory_17_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeAddr_bits_addr = Memory_17_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeAddr_bits_len = Memory_17_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeAddr_bits_id = Memory_17_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeData_valid = Memory_17_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeData_bits_data = Memory_17_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeData_bits_strb = Memory_17_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeData_bits_last = Memory_17_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_writeResp_ready = Memory_17_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_readAddr_valid = Memory_17_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_readAddr_bits_addr = Memory_17_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_readAddr_bits_len = Memory_17_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_readAddr_bits_id = Memory_17_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_17_readData_ready = Memory_17_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeAddr_valid = Memory_18_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeAddr_bits_addr = Memory_18_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeAddr_bits_len = Memory_18_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeAddr_bits_id = Memory_18_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeData_valid = Memory_18_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeData_bits_data = Memory_18_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeData_bits_strb = Memory_18_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeData_bits_last = Memory_18_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_writeResp_ready = Memory_18_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_readAddr_valid = Memory_18_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_readAddr_bits_addr = Memory_18_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_readAddr_bits_len = Memory_18_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_readAddr_bits_id = Memory_18_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_18_readData_ready = Memory_18_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeAddr_valid = Memory_19_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeAddr_bits_addr = Memory_19_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeAddr_bits_len = Memory_19_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeAddr_bits_id = Memory_19_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeData_valid = Memory_19_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeData_bits_data = Memory_19_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeData_bits_strb = Memory_19_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeData_bits_last = Memory_19_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_writeResp_ready = Memory_19_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_readAddr_valid = Memory_19_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_readAddr_bits_addr = Memory_19_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_readAddr_bits_len = Memory_19_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_readAddr_bits_id = Memory_19_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_19_readData_ready = Memory_19_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeAddr_valid = Memory_20_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeAddr_bits_addr = Memory_20_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeAddr_bits_len = Memory_20_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeAddr_bits_id = Memory_20_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeData_valid = Memory_20_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeData_bits_data = Memory_20_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeData_bits_strb = Memory_20_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeData_bits_last = Memory_20_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_writeResp_ready = Memory_20_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_readAddr_valid = Memory_20_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_readAddr_bits_addr = Memory_20_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_readAddr_bits_len = Memory_20_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_readAddr_bits_id = Memory_20_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_20_readData_ready = Memory_20_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeAddr_valid = Memory_21_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeAddr_bits_addr = Memory_21_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeAddr_bits_len = Memory_21_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeAddr_bits_id = Memory_21_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeData_valid = Memory_21_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeData_bits_data = Memory_21_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeData_bits_strb = Memory_21_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeData_bits_last = Memory_21_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_writeResp_ready = Memory_21_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_readAddr_valid = Memory_21_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_readAddr_bits_addr = Memory_21_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_readAddr_bits_len = Memory_21_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_readAddr_bits_id = Memory_21_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_21_readData_ready = Memory_21_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeAddr_valid = Memory_22_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeAddr_bits_addr = Memory_22_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeAddr_bits_len = Memory_22_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeAddr_bits_id = Memory_22_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeData_valid = Memory_22_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeData_bits_data = Memory_22_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeData_bits_strb = Memory_22_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeData_bits_last = Memory_22_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_writeResp_ready = Memory_22_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_readAddr_valid = Memory_22_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_readAddr_bits_addr = Memory_22_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_readAddr_bits_len = Memory_22_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_readAddr_bits_id = Memory_22_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_22_readData_ready = Memory_22_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeAddr_valid = Memory_23_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeAddr_bits_addr = Memory_23_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeAddr_bits_len = Memory_23_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeAddr_bits_id = Memory_23_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeData_valid = Memory_23_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeData_bits_data = Memory_23_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeData_bits_strb = Memory_23_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeData_bits_last = Memory_23_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_writeResp_ready = Memory_23_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_readAddr_valid = Memory_23_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_readAddr_bits_addr = Memory_23_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_readAddr_bits_len = Memory_23_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_readAddr_bits_id = Memory_23_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_23_readData_ready = Memory_23_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeAddr_valid = Memory_24_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeAddr_bits_addr = Memory_24_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeAddr_bits_len = Memory_24_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeAddr_bits_id = Memory_24_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeData_valid = Memory_24_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeData_bits_data = Memory_24_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeData_bits_strb = Memory_24_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeData_bits_last = Memory_24_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_writeResp_ready = Memory_24_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_readAddr_valid = Memory_24_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_readAddr_bits_addr = Memory_24_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_readAddr_bits_len = Memory_24_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_readAddr_bits_id = Memory_24_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_24_readData_ready = Memory_24_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeAddr_valid = Memory_25_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeAddr_bits_addr = Memory_25_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeAddr_bits_len = Memory_25_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeAddr_bits_id = Memory_25_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeData_valid = Memory_25_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeData_bits_data = Memory_25_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeData_bits_strb = Memory_25_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeData_bits_last = Memory_25_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_writeResp_ready = Memory_25_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_readAddr_valid = Memory_25_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_readAddr_bits_addr = Memory_25_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_readAddr_bits_len = Memory_25_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_readAddr_bits_id = Memory_25_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_25_readData_ready = Memory_25_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeAddr_valid = Memory_26_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeAddr_bits_addr = Memory_26_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeAddr_bits_len = Memory_26_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeAddr_bits_id = Memory_26_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeData_valid = Memory_26_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeData_bits_data = Memory_26_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeData_bits_strb = Memory_26_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeData_bits_last = Memory_26_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_writeResp_ready = Memory_26_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_readAddr_valid = Memory_26_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_readAddr_bits_addr = Memory_26_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_readAddr_bits_len = Memory_26_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_readAddr_bits_id = Memory_26_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_26_readData_ready = Memory_26_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeAddr_valid = Memory_27_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeAddr_bits_addr = Memory_27_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeAddr_bits_len = Memory_27_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeAddr_bits_id = Memory_27_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeData_valid = Memory_27_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeData_bits_data = Memory_27_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeData_bits_strb = Memory_27_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeData_bits_last = Memory_27_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_writeResp_ready = Memory_27_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_readAddr_valid = Memory_27_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_readAddr_bits_addr = Memory_27_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_readAddr_bits_len = Memory_27_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_readAddr_bits_id = Memory_27_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_27_readData_ready = Memory_27_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeAddr_valid = Memory_28_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeAddr_bits_addr = Memory_28_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeAddr_bits_len = Memory_28_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeAddr_bits_id = Memory_28_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeData_valid = Memory_28_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeData_bits_data = Memory_28_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeData_bits_strb = Memory_28_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeData_bits_last = Memory_28_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_writeResp_ready = Memory_28_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_readAddr_valid = Memory_28_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_readAddr_bits_addr = Memory_28_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_readAddr_bits_len = Memory_28_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_readAddr_bits_id = Memory_28_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_28_readData_ready = Memory_28_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeAddr_valid = Memory_29_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeAddr_bits_addr = Memory_29_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeAddr_bits_len = Memory_29_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeAddr_bits_id = Memory_29_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeData_valid = Memory_29_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeData_bits_data = Memory_29_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeData_bits_strb = Memory_29_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeData_bits_last = Memory_29_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_writeResp_ready = Memory_29_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_readAddr_valid = Memory_29_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_readAddr_bits_addr = Memory_29_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_readAddr_bits_len = Memory_29_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_readAddr_bits_id = Memory_29_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_29_readData_ready = Memory_29_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeAddr_valid = Memory_30_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeAddr_bits_addr = Memory_30_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeAddr_bits_len = Memory_30_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeAddr_bits_id = Memory_30_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeData_valid = Memory_30_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeData_bits_data = Memory_30_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeData_bits_strb = Memory_30_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeData_bits_last = Memory_30_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_writeResp_ready = Memory_30_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_readAddr_valid = Memory_30_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_readAddr_bits_addr = Memory_30_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_readAddr_bits_len = Memory_30_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_readAddr_bits_id = Memory_30_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_30_readData_ready = Memory_30_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeAddr_valid = Memory_31_io_HBM_interface_writeAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeAddr_bits_addr = Memory_31_io_HBM_interface_writeAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeAddr_bits_len = Memory_31_io_HBM_interface_writeAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeAddr_bits_id = Memory_31_io_HBM_interface_writeAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeData_valid = Memory_31_io_HBM_interface_writeData_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeData_bits_data = Memory_31_io_HBM_interface_writeData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeData_bits_strb = Memory_31_io_HBM_interface_writeData_bits_strb; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeData_bits_last = Memory_31_io_HBM_interface_writeData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_writeResp_ready = Memory_31_io_HBM_interface_writeResp_ready; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_readAddr_valid = Memory_31_io_HBM_interface_readAddr_valid; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_readAddr_bits_addr = Memory_31_io_HBM_interface_readAddr_bits_addr; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_readAddr_bits_len = Memory_31_io_HBM_interface_readAddr_bits_len; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_readAddr_bits_id = Memory_31_io_HBM_interface_readAddr_bits_id; // @[SLR0_Mem.scala 84:42]
  assign io_HBM_interface_31_readData_ready = Memory_31_io_HBM_interface_readData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_clock = clock;
  assign Memory_reset = reset;
  assign Memory_io_R_array_index_0_valid = io_R_array_index_0_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_0_bits = io_R_array_index_0_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_1_valid = io_R_array_index_1_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_1_bits = io_R_array_index_1_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_2_valid = io_R_array_index_2_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_2_bits = io_R_array_index_2_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_3_valid = io_R_array_index_3_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_R_array_index_3_bits = io_R_array_index_3_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_io_p1_end = io_p1_end_0; // @[SLR0_Mem.scala 88:42]
  assign Memory_io_level = copy_level_io_out_0; // @[SLR0_Mem.scala 71:42]
  assign Memory_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[SLR0_Mem.scala 77:42]
  assign Memory_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_0; // @[SLR0_Mem.scala 78:55]
  assign Memory_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_0; // @[SLR0_Mem.scala 79:55]
  assign Memory_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_0; // @[SLR0_Mem.scala 80:55]
  assign Memory_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_0; // @[SLR0_Mem.scala 81:55]
  assign Memory_io_offsets_level_offset = copy_offset_level_offset_io_out_0; // @[SLR0_Mem.scala 82:55]
  assign Memory_io_uram_out_a_0 = io_uram_out_a_0; // @[SLR0_Mem.scala 97:49]
  assign Memory_io_uram_out_a_1 = io_uram_out_a_1; // @[SLR0_Mem.scala 97:49]
  assign Memory_io_uram_out_a_2 = io_uram_out_a_2; // @[SLR0_Mem.scala 97:49]
  assign Memory_io_uram_out_a_3 = io_uram_out_a_3; // @[SLR0_Mem.scala 97:49]
  assign Memory_io_kernel_count = copy_kernel_count_io_out_0; // @[SLR0_Mem.scala 72:42]
  assign Memory_io_master_finish = copy_master_finish_io_out_0; // @[SLR0_Mem.scala 75:42]
  assign Memory_io_node_num = {{5'd0}, _T_10[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_io_neighbours_0_ready = io_neighbours_0_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_io_neighbours_1_ready = io_neighbours_1_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_io_neighbours_2_ready = io_neighbours_2_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_io_neighbours_3_ready = io_neighbours_3_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_io_HBM_interface_writeAddr_ready = io_HBM_interface_0_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_writeData_ready = io_HBM_interface_0_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_writeResp_valid = io_HBM_interface_0_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_writeResp_bits_id = io_HBM_interface_0_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_0_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readAddr_ready = io_HBM_interface_0_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readData_valid = io_HBM_interface_0_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readData_bits_data = io_HBM_interface_0_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readData_bits_id = io_HBM_interface_0_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readData_bits_last = io_HBM_interface_0_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_HBM_interface_readData_bits_resp = io_HBM_interface_0_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_1_clock = clock;
  assign Memory_1_reset = reset;
  assign Memory_1_io_R_array_index_0_valid = io_R_array_index_4_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_0_bits = io_R_array_index_4_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_1_valid = io_R_array_index_5_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_1_bits = io_R_array_index_5_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_2_valid = io_R_array_index_6_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_2_bits = io_R_array_index_6_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_3_valid = io_R_array_index_7_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_R_array_index_3_bits = io_R_array_index_7_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_1_io_p1_end = io_p1_end_1; // @[SLR0_Mem.scala 88:42]
  assign Memory_1_io_level = copy_level_io_out_1; // @[SLR0_Mem.scala 71:42]
  assign Memory_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[SLR0_Mem.scala 77:42]
  assign Memory_1_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_1; // @[SLR0_Mem.scala 78:55]
  assign Memory_1_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_1; // @[SLR0_Mem.scala 79:55]
  assign Memory_1_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_1; // @[SLR0_Mem.scala 80:55]
  assign Memory_1_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_1; // @[SLR0_Mem.scala 81:55]
  assign Memory_1_io_offsets_level_offset = copy_offset_level_offset_io_out_1; // @[SLR0_Mem.scala 82:55]
  assign Memory_1_io_uram_out_a_0 = io_uram_out_a_4; // @[SLR0_Mem.scala 97:49]
  assign Memory_1_io_uram_out_a_1 = io_uram_out_a_5; // @[SLR0_Mem.scala 97:49]
  assign Memory_1_io_uram_out_a_2 = io_uram_out_a_6; // @[SLR0_Mem.scala 97:49]
  assign Memory_1_io_uram_out_a_3 = io_uram_out_a_7; // @[SLR0_Mem.scala 97:49]
  assign Memory_1_io_kernel_count = copy_kernel_count_io_out_1; // @[SLR0_Mem.scala 72:42]
  assign Memory_1_io_master_finish = copy_master_finish_io_out_1; // @[SLR0_Mem.scala 75:42]
  assign Memory_1_io_node_num = {{5'd0}, _T_17[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_1_io_neighbours_0_ready = io_neighbours_4_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_1_io_neighbours_1_ready = io_neighbours_5_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_1_io_neighbours_2_ready = io_neighbours_6_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_1_io_neighbours_3_ready = io_neighbours_7_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_1_io_HBM_interface_writeAddr_ready = io_HBM_interface_1_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_writeData_ready = io_HBM_interface_1_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_writeResp_valid = io_HBM_interface_1_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_writeResp_bits_id = io_HBM_interface_1_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_1_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readAddr_ready = io_HBM_interface_1_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readData_valid = io_HBM_interface_1_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readData_bits_data = io_HBM_interface_1_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readData_bits_id = io_HBM_interface_1_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readData_bits_last = io_HBM_interface_1_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_HBM_interface_readData_bits_resp = io_HBM_interface_1_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_1_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_1_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_2_clock = clock;
  assign Memory_2_reset = reset;
  assign Memory_2_io_R_array_index_0_valid = io_R_array_index_8_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_0_bits = io_R_array_index_8_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_1_valid = io_R_array_index_9_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_1_bits = io_R_array_index_9_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_2_valid = io_R_array_index_10_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_2_bits = io_R_array_index_10_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_3_valid = io_R_array_index_11_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_R_array_index_3_bits = io_R_array_index_11_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_2_io_p1_end = io_p1_end_2; // @[SLR0_Mem.scala 88:42]
  assign Memory_2_io_level = copy_level_io_out_2; // @[SLR0_Mem.scala 71:42]
  assign Memory_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[SLR0_Mem.scala 77:42]
  assign Memory_2_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_2; // @[SLR0_Mem.scala 78:55]
  assign Memory_2_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_2; // @[SLR0_Mem.scala 79:55]
  assign Memory_2_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_2; // @[SLR0_Mem.scala 80:55]
  assign Memory_2_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_2; // @[SLR0_Mem.scala 81:55]
  assign Memory_2_io_offsets_level_offset = copy_offset_level_offset_io_out_2; // @[SLR0_Mem.scala 82:55]
  assign Memory_2_io_uram_out_a_0 = io_uram_out_a_8; // @[SLR0_Mem.scala 97:49]
  assign Memory_2_io_uram_out_a_1 = io_uram_out_a_9; // @[SLR0_Mem.scala 97:49]
  assign Memory_2_io_uram_out_a_2 = io_uram_out_a_10; // @[SLR0_Mem.scala 97:49]
  assign Memory_2_io_uram_out_a_3 = io_uram_out_a_11; // @[SLR0_Mem.scala 97:49]
  assign Memory_2_io_kernel_count = copy_kernel_count_io_out_2; // @[SLR0_Mem.scala 72:42]
  assign Memory_2_io_master_finish = copy_master_finish_io_out_2; // @[SLR0_Mem.scala 75:42]
  assign Memory_2_io_node_num = {{5'd0}, _T_24[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_2_io_neighbours_0_ready = io_neighbours_8_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_2_io_neighbours_1_ready = io_neighbours_9_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_2_io_neighbours_2_ready = io_neighbours_10_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_2_io_neighbours_3_ready = io_neighbours_11_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_2_io_HBM_interface_writeAddr_ready = io_HBM_interface_2_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_writeData_ready = io_HBM_interface_2_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_writeResp_valid = io_HBM_interface_2_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_writeResp_bits_id = io_HBM_interface_2_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_2_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readAddr_ready = io_HBM_interface_2_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readData_valid = io_HBM_interface_2_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readData_bits_data = io_HBM_interface_2_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readData_bits_id = io_HBM_interface_2_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readData_bits_last = io_HBM_interface_2_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_HBM_interface_readData_bits_resp = io_HBM_interface_2_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_2_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_2_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_3_clock = clock;
  assign Memory_3_reset = reset;
  assign Memory_3_io_R_array_index_0_valid = io_R_array_index_12_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_0_bits = io_R_array_index_12_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_1_valid = io_R_array_index_13_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_1_bits = io_R_array_index_13_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_2_valid = io_R_array_index_14_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_2_bits = io_R_array_index_14_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_3_valid = io_R_array_index_15_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_R_array_index_3_bits = io_R_array_index_15_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_3_io_p1_end = io_p1_end_3; // @[SLR0_Mem.scala 88:42]
  assign Memory_3_io_level = copy_level_io_out_3; // @[SLR0_Mem.scala 71:42]
  assign Memory_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[SLR0_Mem.scala 77:42]
  assign Memory_3_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_3; // @[SLR0_Mem.scala 78:55]
  assign Memory_3_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_3; // @[SLR0_Mem.scala 79:55]
  assign Memory_3_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_3; // @[SLR0_Mem.scala 80:55]
  assign Memory_3_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_3; // @[SLR0_Mem.scala 81:55]
  assign Memory_3_io_offsets_level_offset = copy_offset_level_offset_io_out_3; // @[SLR0_Mem.scala 82:55]
  assign Memory_3_io_uram_out_a_0 = io_uram_out_a_12; // @[SLR0_Mem.scala 97:49]
  assign Memory_3_io_uram_out_a_1 = io_uram_out_a_13; // @[SLR0_Mem.scala 97:49]
  assign Memory_3_io_uram_out_a_2 = io_uram_out_a_14; // @[SLR0_Mem.scala 97:49]
  assign Memory_3_io_uram_out_a_3 = io_uram_out_a_15; // @[SLR0_Mem.scala 97:49]
  assign Memory_3_io_kernel_count = copy_kernel_count_io_out_3; // @[SLR0_Mem.scala 72:42]
  assign Memory_3_io_master_finish = copy_master_finish_io_out_3; // @[SLR0_Mem.scala 75:42]
  assign Memory_3_io_node_num = {{5'd0}, _T_31[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_3_io_neighbours_0_ready = io_neighbours_12_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_3_io_neighbours_1_ready = io_neighbours_13_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_3_io_neighbours_2_ready = io_neighbours_14_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_3_io_neighbours_3_ready = io_neighbours_15_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_3_io_HBM_interface_writeAddr_ready = io_HBM_interface_3_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_writeData_ready = io_HBM_interface_3_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_writeResp_valid = io_HBM_interface_3_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_writeResp_bits_id = io_HBM_interface_3_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_3_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readAddr_ready = io_HBM_interface_3_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readData_valid = io_HBM_interface_3_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readData_bits_data = io_HBM_interface_3_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readData_bits_id = io_HBM_interface_3_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readData_bits_last = io_HBM_interface_3_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_HBM_interface_readData_bits_resp = io_HBM_interface_3_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_3_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_3_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_4_clock = clock;
  assign Memory_4_reset = reset;
  assign Memory_4_io_R_array_index_0_valid = io_R_array_index_16_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_0_bits = io_R_array_index_16_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_1_valid = io_R_array_index_17_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_1_bits = io_R_array_index_17_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_2_valid = io_R_array_index_18_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_2_bits = io_R_array_index_18_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_3_valid = io_R_array_index_19_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_R_array_index_3_bits = io_R_array_index_19_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_4_io_p1_end = io_p1_end_4; // @[SLR0_Mem.scala 88:42]
  assign Memory_4_io_level = copy_level_io_out_4; // @[SLR0_Mem.scala 71:42]
  assign Memory_4_io_push_or_pull_state = copy_push_or_pull_io_out_4; // @[SLR0_Mem.scala 77:42]
  assign Memory_4_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_4; // @[SLR0_Mem.scala 78:55]
  assign Memory_4_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_4; // @[SLR0_Mem.scala 79:55]
  assign Memory_4_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_4; // @[SLR0_Mem.scala 80:55]
  assign Memory_4_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_4; // @[SLR0_Mem.scala 81:55]
  assign Memory_4_io_offsets_level_offset = copy_offset_level_offset_io_out_4; // @[SLR0_Mem.scala 82:55]
  assign Memory_4_io_uram_out_a_0 = io_uram_out_a_16; // @[SLR0_Mem.scala 97:49]
  assign Memory_4_io_uram_out_a_1 = io_uram_out_a_17; // @[SLR0_Mem.scala 97:49]
  assign Memory_4_io_uram_out_a_2 = io_uram_out_a_18; // @[SLR0_Mem.scala 97:49]
  assign Memory_4_io_uram_out_a_3 = io_uram_out_a_19; // @[SLR0_Mem.scala 97:49]
  assign Memory_4_io_kernel_count = copy_kernel_count_io_out_4; // @[SLR0_Mem.scala 72:42]
  assign Memory_4_io_master_finish = copy_master_finish_io_out_4; // @[SLR0_Mem.scala 75:42]
  assign Memory_4_io_node_num = {{5'd0}, _T_38[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_4_io_neighbours_0_ready = io_neighbours_16_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_4_io_neighbours_1_ready = io_neighbours_17_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_4_io_neighbours_2_ready = io_neighbours_18_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_4_io_neighbours_3_ready = io_neighbours_19_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_4_io_HBM_interface_writeAddr_ready = io_HBM_interface_4_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_writeData_ready = io_HBM_interface_4_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_writeResp_valid = io_HBM_interface_4_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_writeResp_bits_id = io_HBM_interface_4_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_4_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readAddr_ready = io_HBM_interface_4_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readData_valid = io_HBM_interface_4_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readData_bits_data = io_HBM_interface_4_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readData_bits_id = io_HBM_interface_4_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readData_bits_last = io_HBM_interface_4_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_HBM_interface_readData_bits_resp = io_HBM_interface_4_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_4_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_4_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_5_clock = clock;
  assign Memory_5_reset = reset;
  assign Memory_5_io_R_array_index_0_valid = io_R_array_index_20_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_0_bits = io_R_array_index_20_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_1_valid = io_R_array_index_21_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_1_bits = io_R_array_index_21_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_2_valid = io_R_array_index_22_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_2_bits = io_R_array_index_22_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_3_valid = io_R_array_index_23_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_R_array_index_3_bits = io_R_array_index_23_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_5_io_p1_end = io_p1_end_5; // @[SLR0_Mem.scala 88:42]
  assign Memory_5_io_level = copy_level_io_out_5; // @[SLR0_Mem.scala 71:42]
  assign Memory_5_io_push_or_pull_state = copy_push_or_pull_io_out_5; // @[SLR0_Mem.scala 77:42]
  assign Memory_5_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_5; // @[SLR0_Mem.scala 78:55]
  assign Memory_5_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_5; // @[SLR0_Mem.scala 79:55]
  assign Memory_5_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_5; // @[SLR0_Mem.scala 80:55]
  assign Memory_5_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_5; // @[SLR0_Mem.scala 81:55]
  assign Memory_5_io_offsets_level_offset = copy_offset_level_offset_io_out_5; // @[SLR0_Mem.scala 82:55]
  assign Memory_5_io_uram_out_a_0 = io_uram_out_a_20; // @[SLR0_Mem.scala 97:49]
  assign Memory_5_io_uram_out_a_1 = io_uram_out_a_21; // @[SLR0_Mem.scala 97:49]
  assign Memory_5_io_uram_out_a_2 = io_uram_out_a_22; // @[SLR0_Mem.scala 97:49]
  assign Memory_5_io_uram_out_a_3 = io_uram_out_a_23; // @[SLR0_Mem.scala 97:49]
  assign Memory_5_io_kernel_count = copy_kernel_count_io_out_5; // @[SLR0_Mem.scala 72:42]
  assign Memory_5_io_master_finish = copy_master_finish_io_out_5; // @[SLR0_Mem.scala 75:42]
  assign Memory_5_io_node_num = {{5'd0}, _T_45[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_5_io_neighbours_0_ready = io_neighbours_20_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_5_io_neighbours_1_ready = io_neighbours_21_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_5_io_neighbours_2_ready = io_neighbours_22_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_5_io_neighbours_3_ready = io_neighbours_23_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_5_io_HBM_interface_writeAddr_ready = io_HBM_interface_5_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_writeData_ready = io_HBM_interface_5_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_writeResp_valid = io_HBM_interface_5_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_writeResp_bits_id = io_HBM_interface_5_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_5_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readAddr_ready = io_HBM_interface_5_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readData_valid = io_HBM_interface_5_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readData_bits_data = io_HBM_interface_5_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readData_bits_id = io_HBM_interface_5_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readData_bits_last = io_HBM_interface_5_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_HBM_interface_readData_bits_resp = io_HBM_interface_5_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_5_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_5_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_6_clock = clock;
  assign Memory_6_reset = reset;
  assign Memory_6_io_R_array_index_0_valid = io_R_array_index_24_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_0_bits = io_R_array_index_24_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_1_valid = io_R_array_index_25_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_1_bits = io_R_array_index_25_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_2_valid = io_R_array_index_26_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_2_bits = io_R_array_index_26_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_3_valid = io_R_array_index_27_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_R_array_index_3_bits = io_R_array_index_27_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_6_io_p1_end = io_p1_end_6; // @[SLR0_Mem.scala 88:42]
  assign Memory_6_io_level = copy_level_io_out_6; // @[SLR0_Mem.scala 71:42]
  assign Memory_6_io_push_or_pull_state = copy_push_or_pull_io_out_6; // @[SLR0_Mem.scala 77:42]
  assign Memory_6_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_6; // @[SLR0_Mem.scala 78:55]
  assign Memory_6_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_6; // @[SLR0_Mem.scala 79:55]
  assign Memory_6_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_6; // @[SLR0_Mem.scala 80:55]
  assign Memory_6_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_6; // @[SLR0_Mem.scala 81:55]
  assign Memory_6_io_offsets_level_offset = copy_offset_level_offset_io_out_6; // @[SLR0_Mem.scala 82:55]
  assign Memory_6_io_uram_out_a_0 = io_uram_out_a_24; // @[SLR0_Mem.scala 97:49]
  assign Memory_6_io_uram_out_a_1 = io_uram_out_a_25; // @[SLR0_Mem.scala 97:49]
  assign Memory_6_io_uram_out_a_2 = io_uram_out_a_26; // @[SLR0_Mem.scala 97:49]
  assign Memory_6_io_uram_out_a_3 = io_uram_out_a_27; // @[SLR0_Mem.scala 97:49]
  assign Memory_6_io_kernel_count = copy_kernel_count_io_out_6; // @[SLR0_Mem.scala 72:42]
  assign Memory_6_io_master_finish = copy_master_finish_io_out_6; // @[SLR0_Mem.scala 75:42]
  assign Memory_6_io_node_num = {{5'd0}, _T_52[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_6_io_neighbours_0_ready = io_neighbours_24_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_6_io_neighbours_1_ready = io_neighbours_25_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_6_io_neighbours_2_ready = io_neighbours_26_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_6_io_neighbours_3_ready = io_neighbours_27_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_6_io_HBM_interface_writeAddr_ready = io_HBM_interface_6_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_writeData_ready = io_HBM_interface_6_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_writeResp_valid = io_HBM_interface_6_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_writeResp_bits_id = io_HBM_interface_6_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_6_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readAddr_ready = io_HBM_interface_6_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readData_valid = io_HBM_interface_6_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readData_bits_data = io_HBM_interface_6_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readData_bits_id = io_HBM_interface_6_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readData_bits_last = io_HBM_interface_6_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_HBM_interface_readData_bits_resp = io_HBM_interface_6_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_6_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_6_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_7_clock = clock;
  assign Memory_7_reset = reset;
  assign Memory_7_io_R_array_index_0_valid = io_R_array_index_28_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_0_bits = io_R_array_index_28_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_1_valid = io_R_array_index_29_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_1_bits = io_R_array_index_29_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_2_valid = io_R_array_index_30_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_2_bits = io_R_array_index_30_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_3_valid = io_R_array_index_31_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_R_array_index_3_bits = io_R_array_index_31_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_7_io_p1_end = io_p1_end_7; // @[SLR0_Mem.scala 88:42]
  assign Memory_7_io_level = copy_level_io_out_7; // @[SLR0_Mem.scala 71:42]
  assign Memory_7_io_push_or_pull_state = copy_push_or_pull_io_out_7; // @[SLR0_Mem.scala 77:42]
  assign Memory_7_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_7; // @[SLR0_Mem.scala 78:55]
  assign Memory_7_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_7; // @[SLR0_Mem.scala 79:55]
  assign Memory_7_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_7; // @[SLR0_Mem.scala 80:55]
  assign Memory_7_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_7; // @[SLR0_Mem.scala 81:55]
  assign Memory_7_io_offsets_level_offset = copy_offset_level_offset_io_out_7; // @[SLR0_Mem.scala 82:55]
  assign Memory_7_io_uram_out_a_0 = io_uram_out_a_28; // @[SLR0_Mem.scala 97:49]
  assign Memory_7_io_uram_out_a_1 = io_uram_out_a_29; // @[SLR0_Mem.scala 97:49]
  assign Memory_7_io_uram_out_a_2 = io_uram_out_a_30; // @[SLR0_Mem.scala 97:49]
  assign Memory_7_io_uram_out_a_3 = io_uram_out_a_31; // @[SLR0_Mem.scala 97:49]
  assign Memory_7_io_kernel_count = copy_kernel_count_io_out_7; // @[SLR0_Mem.scala 72:42]
  assign Memory_7_io_master_finish = copy_master_finish_io_out_7; // @[SLR0_Mem.scala 75:42]
  assign Memory_7_io_node_num = {{5'd0}, _T_59[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_7_io_neighbours_0_ready = io_neighbours_28_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_7_io_neighbours_1_ready = io_neighbours_29_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_7_io_neighbours_2_ready = io_neighbours_30_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_7_io_neighbours_3_ready = io_neighbours_31_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_7_io_HBM_interface_writeAddr_ready = io_HBM_interface_7_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_writeData_ready = io_HBM_interface_7_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_writeResp_valid = io_HBM_interface_7_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_writeResp_bits_id = io_HBM_interface_7_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_7_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readAddr_ready = io_HBM_interface_7_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readData_valid = io_HBM_interface_7_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readData_bits_data = io_HBM_interface_7_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readData_bits_id = io_HBM_interface_7_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readData_bits_last = io_HBM_interface_7_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_HBM_interface_readData_bits_resp = io_HBM_interface_7_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_7_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_7_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_8_clock = clock;
  assign Memory_8_reset = reset;
  assign Memory_8_io_R_array_index_0_valid = io_R_array_index_32_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_0_bits = io_R_array_index_32_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_1_valid = io_R_array_index_33_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_1_bits = io_R_array_index_33_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_2_valid = io_R_array_index_34_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_2_bits = io_R_array_index_34_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_3_valid = io_R_array_index_35_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_R_array_index_3_bits = io_R_array_index_35_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_8_io_p1_end = io_p1_end_8; // @[SLR0_Mem.scala 88:42]
  assign Memory_8_io_level = copy_level_io_out_8; // @[SLR0_Mem.scala 71:42]
  assign Memory_8_io_push_or_pull_state = copy_push_or_pull_io_out_8; // @[SLR0_Mem.scala 77:42]
  assign Memory_8_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_8; // @[SLR0_Mem.scala 78:55]
  assign Memory_8_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_8; // @[SLR0_Mem.scala 79:55]
  assign Memory_8_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_8; // @[SLR0_Mem.scala 80:55]
  assign Memory_8_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_8; // @[SLR0_Mem.scala 81:55]
  assign Memory_8_io_offsets_level_offset = copy_offset_level_offset_io_out_8; // @[SLR0_Mem.scala 82:55]
  assign Memory_8_io_uram_out_a_0 = io_uram_out_a_32; // @[SLR0_Mem.scala 97:49]
  assign Memory_8_io_uram_out_a_1 = io_uram_out_a_33; // @[SLR0_Mem.scala 97:49]
  assign Memory_8_io_uram_out_a_2 = io_uram_out_a_34; // @[SLR0_Mem.scala 97:49]
  assign Memory_8_io_uram_out_a_3 = io_uram_out_a_35; // @[SLR0_Mem.scala 97:49]
  assign Memory_8_io_kernel_count = copy_kernel_count_io_out_8; // @[SLR0_Mem.scala 72:42]
  assign Memory_8_io_master_finish = copy_master_finish_io_out_8; // @[SLR0_Mem.scala 75:42]
  assign Memory_8_io_node_num = {{5'd0}, _T_66[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_8_io_neighbours_0_ready = io_neighbours_32_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_8_io_neighbours_1_ready = io_neighbours_33_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_8_io_neighbours_2_ready = io_neighbours_34_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_8_io_neighbours_3_ready = io_neighbours_35_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_8_io_HBM_interface_writeAddr_ready = io_HBM_interface_8_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_writeData_ready = io_HBM_interface_8_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_writeResp_valid = io_HBM_interface_8_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_writeResp_bits_id = io_HBM_interface_8_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_8_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readAddr_ready = io_HBM_interface_8_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readData_valid = io_HBM_interface_8_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readData_bits_data = io_HBM_interface_8_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readData_bits_id = io_HBM_interface_8_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readData_bits_last = io_HBM_interface_8_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_HBM_interface_readData_bits_resp = io_HBM_interface_8_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_8_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_8_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_9_clock = clock;
  assign Memory_9_reset = reset;
  assign Memory_9_io_R_array_index_0_valid = io_R_array_index_36_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_0_bits = io_R_array_index_36_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_1_valid = io_R_array_index_37_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_1_bits = io_R_array_index_37_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_2_valid = io_R_array_index_38_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_2_bits = io_R_array_index_38_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_3_valid = io_R_array_index_39_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_R_array_index_3_bits = io_R_array_index_39_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_9_io_p1_end = io_p1_end_9; // @[SLR0_Mem.scala 88:42]
  assign Memory_9_io_level = copy_level_io_out_9; // @[SLR0_Mem.scala 71:42]
  assign Memory_9_io_push_or_pull_state = copy_push_or_pull_io_out_9; // @[SLR0_Mem.scala 77:42]
  assign Memory_9_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_9; // @[SLR0_Mem.scala 78:55]
  assign Memory_9_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_9; // @[SLR0_Mem.scala 79:55]
  assign Memory_9_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_9; // @[SLR0_Mem.scala 80:55]
  assign Memory_9_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_9; // @[SLR0_Mem.scala 81:55]
  assign Memory_9_io_offsets_level_offset = copy_offset_level_offset_io_out_9; // @[SLR0_Mem.scala 82:55]
  assign Memory_9_io_uram_out_a_0 = io_uram_out_a_36; // @[SLR0_Mem.scala 97:49]
  assign Memory_9_io_uram_out_a_1 = io_uram_out_a_37; // @[SLR0_Mem.scala 97:49]
  assign Memory_9_io_uram_out_a_2 = io_uram_out_a_38; // @[SLR0_Mem.scala 97:49]
  assign Memory_9_io_uram_out_a_3 = io_uram_out_a_39; // @[SLR0_Mem.scala 97:49]
  assign Memory_9_io_kernel_count = copy_kernel_count_io_out_9; // @[SLR0_Mem.scala 72:42]
  assign Memory_9_io_master_finish = copy_master_finish_io_out_9; // @[SLR0_Mem.scala 75:42]
  assign Memory_9_io_node_num = {{5'd0}, _T_73[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_9_io_neighbours_0_ready = io_neighbours_36_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_9_io_neighbours_1_ready = io_neighbours_37_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_9_io_neighbours_2_ready = io_neighbours_38_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_9_io_neighbours_3_ready = io_neighbours_39_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_9_io_HBM_interface_writeAddr_ready = io_HBM_interface_9_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_writeData_ready = io_HBM_interface_9_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_writeResp_valid = io_HBM_interface_9_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_writeResp_bits_id = io_HBM_interface_9_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_9_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readAddr_ready = io_HBM_interface_9_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readData_valid = io_HBM_interface_9_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readData_bits_data = io_HBM_interface_9_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readData_bits_id = io_HBM_interface_9_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readData_bits_last = io_HBM_interface_9_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_HBM_interface_readData_bits_resp = io_HBM_interface_9_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_9_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_9_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_10_clock = clock;
  assign Memory_10_reset = reset;
  assign Memory_10_io_R_array_index_0_valid = io_R_array_index_40_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_0_bits = io_R_array_index_40_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_1_valid = io_R_array_index_41_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_1_bits = io_R_array_index_41_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_2_valid = io_R_array_index_42_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_2_bits = io_R_array_index_42_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_3_valid = io_R_array_index_43_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_R_array_index_3_bits = io_R_array_index_43_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_10_io_p1_end = io_p1_end_10; // @[SLR0_Mem.scala 88:42]
  assign Memory_10_io_level = copy_level_io_out_10; // @[SLR0_Mem.scala 71:42]
  assign Memory_10_io_push_or_pull_state = copy_push_or_pull_io_out_10; // @[SLR0_Mem.scala 77:42]
  assign Memory_10_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_10; // @[SLR0_Mem.scala 78:55]
  assign Memory_10_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_10; // @[SLR0_Mem.scala 79:55]
  assign Memory_10_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_10; // @[SLR0_Mem.scala 80:55]
  assign Memory_10_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_10; // @[SLR0_Mem.scala 81:55]
  assign Memory_10_io_offsets_level_offset = copy_offset_level_offset_io_out_10; // @[SLR0_Mem.scala 82:55]
  assign Memory_10_io_uram_out_a_0 = io_uram_out_a_40; // @[SLR0_Mem.scala 97:49]
  assign Memory_10_io_uram_out_a_1 = io_uram_out_a_41; // @[SLR0_Mem.scala 97:49]
  assign Memory_10_io_uram_out_a_2 = io_uram_out_a_42; // @[SLR0_Mem.scala 97:49]
  assign Memory_10_io_uram_out_a_3 = io_uram_out_a_43; // @[SLR0_Mem.scala 97:49]
  assign Memory_10_io_kernel_count = copy_kernel_count_io_out_10; // @[SLR0_Mem.scala 72:42]
  assign Memory_10_io_master_finish = copy_master_finish_io_out_10; // @[SLR0_Mem.scala 75:42]
  assign Memory_10_io_node_num = {{5'd0}, _T_80[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_10_io_neighbours_0_ready = io_neighbours_40_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_10_io_neighbours_1_ready = io_neighbours_41_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_10_io_neighbours_2_ready = io_neighbours_42_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_10_io_neighbours_3_ready = io_neighbours_43_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_10_io_HBM_interface_writeAddr_ready = io_HBM_interface_10_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_writeData_ready = io_HBM_interface_10_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_writeResp_valid = io_HBM_interface_10_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_writeResp_bits_id = io_HBM_interface_10_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_10_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readAddr_ready = io_HBM_interface_10_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readData_valid = io_HBM_interface_10_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readData_bits_data = io_HBM_interface_10_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readData_bits_id = io_HBM_interface_10_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readData_bits_last = io_HBM_interface_10_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_HBM_interface_readData_bits_resp = io_HBM_interface_10_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_10_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_10_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_11_clock = clock;
  assign Memory_11_reset = reset;
  assign Memory_11_io_R_array_index_0_valid = io_R_array_index_44_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_0_bits = io_R_array_index_44_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_1_valid = io_R_array_index_45_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_1_bits = io_R_array_index_45_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_2_valid = io_R_array_index_46_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_2_bits = io_R_array_index_46_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_3_valid = io_R_array_index_47_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_R_array_index_3_bits = io_R_array_index_47_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_11_io_p1_end = io_p1_end_11; // @[SLR0_Mem.scala 88:42]
  assign Memory_11_io_level = copy_level_io_out_11; // @[SLR0_Mem.scala 71:42]
  assign Memory_11_io_push_or_pull_state = copy_push_or_pull_io_out_11; // @[SLR0_Mem.scala 77:42]
  assign Memory_11_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_11; // @[SLR0_Mem.scala 78:55]
  assign Memory_11_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_11; // @[SLR0_Mem.scala 79:55]
  assign Memory_11_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_11; // @[SLR0_Mem.scala 80:55]
  assign Memory_11_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_11; // @[SLR0_Mem.scala 81:55]
  assign Memory_11_io_offsets_level_offset = copy_offset_level_offset_io_out_11; // @[SLR0_Mem.scala 82:55]
  assign Memory_11_io_uram_out_a_0 = io_uram_out_a_44; // @[SLR0_Mem.scala 97:49]
  assign Memory_11_io_uram_out_a_1 = io_uram_out_a_45; // @[SLR0_Mem.scala 97:49]
  assign Memory_11_io_uram_out_a_2 = io_uram_out_a_46; // @[SLR0_Mem.scala 97:49]
  assign Memory_11_io_uram_out_a_3 = io_uram_out_a_47; // @[SLR0_Mem.scala 97:49]
  assign Memory_11_io_kernel_count = copy_kernel_count_io_out_11; // @[SLR0_Mem.scala 72:42]
  assign Memory_11_io_master_finish = copy_master_finish_io_out_11; // @[SLR0_Mem.scala 75:42]
  assign Memory_11_io_node_num = {{5'd0}, _T_87[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_11_io_neighbours_0_ready = io_neighbours_44_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_11_io_neighbours_1_ready = io_neighbours_45_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_11_io_neighbours_2_ready = io_neighbours_46_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_11_io_neighbours_3_ready = io_neighbours_47_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_11_io_HBM_interface_writeAddr_ready = io_HBM_interface_11_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_writeData_ready = io_HBM_interface_11_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_writeResp_valid = io_HBM_interface_11_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_writeResp_bits_id = io_HBM_interface_11_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_11_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readAddr_ready = io_HBM_interface_11_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readData_valid = io_HBM_interface_11_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readData_bits_data = io_HBM_interface_11_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readData_bits_id = io_HBM_interface_11_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readData_bits_last = io_HBM_interface_11_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_HBM_interface_readData_bits_resp = io_HBM_interface_11_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_11_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_11_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_12_clock = clock;
  assign Memory_12_reset = reset;
  assign Memory_12_io_R_array_index_0_valid = io_R_array_index_48_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_0_bits = io_R_array_index_48_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_1_valid = io_R_array_index_49_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_1_bits = io_R_array_index_49_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_2_valid = io_R_array_index_50_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_2_bits = io_R_array_index_50_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_3_valid = io_R_array_index_51_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_R_array_index_3_bits = io_R_array_index_51_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_12_io_p1_end = io_p1_end_12; // @[SLR0_Mem.scala 88:42]
  assign Memory_12_io_level = copy_level_io_out_12; // @[SLR0_Mem.scala 71:42]
  assign Memory_12_io_push_or_pull_state = copy_push_or_pull_io_out_12; // @[SLR0_Mem.scala 77:42]
  assign Memory_12_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_12; // @[SLR0_Mem.scala 78:55]
  assign Memory_12_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_12; // @[SLR0_Mem.scala 79:55]
  assign Memory_12_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_12; // @[SLR0_Mem.scala 80:55]
  assign Memory_12_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_12; // @[SLR0_Mem.scala 81:55]
  assign Memory_12_io_offsets_level_offset = copy_offset_level_offset_io_out_12; // @[SLR0_Mem.scala 82:55]
  assign Memory_12_io_uram_out_a_0 = io_uram_out_a_48; // @[SLR0_Mem.scala 97:49]
  assign Memory_12_io_uram_out_a_1 = io_uram_out_a_49; // @[SLR0_Mem.scala 97:49]
  assign Memory_12_io_uram_out_a_2 = io_uram_out_a_50; // @[SLR0_Mem.scala 97:49]
  assign Memory_12_io_uram_out_a_3 = io_uram_out_a_51; // @[SLR0_Mem.scala 97:49]
  assign Memory_12_io_kernel_count = copy_kernel_count_io_out_12; // @[SLR0_Mem.scala 72:42]
  assign Memory_12_io_master_finish = copy_master_finish_io_out_12; // @[SLR0_Mem.scala 75:42]
  assign Memory_12_io_node_num = {{5'd0}, _T_94[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_12_io_neighbours_0_ready = io_neighbours_48_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_12_io_neighbours_1_ready = io_neighbours_49_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_12_io_neighbours_2_ready = io_neighbours_50_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_12_io_neighbours_3_ready = io_neighbours_51_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_12_io_HBM_interface_writeAddr_ready = io_HBM_interface_12_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_writeData_ready = io_HBM_interface_12_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_writeResp_valid = io_HBM_interface_12_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_writeResp_bits_id = io_HBM_interface_12_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_12_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readAddr_ready = io_HBM_interface_12_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readData_valid = io_HBM_interface_12_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readData_bits_data = io_HBM_interface_12_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readData_bits_id = io_HBM_interface_12_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readData_bits_last = io_HBM_interface_12_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_HBM_interface_readData_bits_resp = io_HBM_interface_12_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_12_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_12_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_13_clock = clock;
  assign Memory_13_reset = reset;
  assign Memory_13_io_R_array_index_0_valid = io_R_array_index_52_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_0_bits = io_R_array_index_52_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_1_valid = io_R_array_index_53_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_1_bits = io_R_array_index_53_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_2_valid = io_R_array_index_54_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_2_bits = io_R_array_index_54_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_3_valid = io_R_array_index_55_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_R_array_index_3_bits = io_R_array_index_55_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_13_io_p1_end = io_p1_end_13; // @[SLR0_Mem.scala 88:42]
  assign Memory_13_io_level = copy_level_io_out_13; // @[SLR0_Mem.scala 71:42]
  assign Memory_13_io_push_or_pull_state = copy_push_or_pull_io_out_13; // @[SLR0_Mem.scala 77:42]
  assign Memory_13_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_13; // @[SLR0_Mem.scala 78:55]
  assign Memory_13_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_13; // @[SLR0_Mem.scala 79:55]
  assign Memory_13_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_13; // @[SLR0_Mem.scala 80:55]
  assign Memory_13_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_13; // @[SLR0_Mem.scala 81:55]
  assign Memory_13_io_offsets_level_offset = copy_offset_level_offset_io_out_13; // @[SLR0_Mem.scala 82:55]
  assign Memory_13_io_uram_out_a_0 = io_uram_out_a_52; // @[SLR0_Mem.scala 97:49]
  assign Memory_13_io_uram_out_a_1 = io_uram_out_a_53; // @[SLR0_Mem.scala 97:49]
  assign Memory_13_io_uram_out_a_2 = io_uram_out_a_54; // @[SLR0_Mem.scala 97:49]
  assign Memory_13_io_uram_out_a_3 = io_uram_out_a_55; // @[SLR0_Mem.scala 97:49]
  assign Memory_13_io_kernel_count = copy_kernel_count_io_out_13; // @[SLR0_Mem.scala 72:42]
  assign Memory_13_io_master_finish = copy_master_finish_io_out_13; // @[SLR0_Mem.scala 75:42]
  assign Memory_13_io_node_num = {{5'd0}, _T_101[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_13_io_neighbours_0_ready = io_neighbours_52_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_13_io_neighbours_1_ready = io_neighbours_53_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_13_io_neighbours_2_ready = io_neighbours_54_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_13_io_neighbours_3_ready = io_neighbours_55_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_13_io_HBM_interface_writeAddr_ready = io_HBM_interface_13_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_writeData_ready = io_HBM_interface_13_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_writeResp_valid = io_HBM_interface_13_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_writeResp_bits_id = io_HBM_interface_13_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_13_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readAddr_ready = io_HBM_interface_13_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readData_valid = io_HBM_interface_13_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readData_bits_data = io_HBM_interface_13_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readData_bits_id = io_HBM_interface_13_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readData_bits_last = io_HBM_interface_13_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_HBM_interface_readData_bits_resp = io_HBM_interface_13_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_13_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_13_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_14_clock = clock;
  assign Memory_14_reset = reset;
  assign Memory_14_io_R_array_index_0_valid = io_R_array_index_56_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_0_bits = io_R_array_index_56_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_1_valid = io_R_array_index_57_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_1_bits = io_R_array_index_57_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_2_valid = io_R_array_index_58_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_2_bits = io_R_array_index_58_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_3_valid = io_R_array_index_59_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_R_array_index_3_bits = io_R_array_index_59_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_14_io_p1_end = io_p1_end_14; // @[SLR0_Mem.scala 88:42]
  assign Memory_14_io_level = copy_level_io_out_14; // @[SLR0_Mem.scala 71:42]
  assign Memory_14_io_push_or_pull_state = copy_push_or_pull_io_out_14; // @[SLR0_Mem.scala 77:42]
  assign Memory_14_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_14; // @[SLR0_Mem.scala 78:55]
  assign Memory_14_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_14; // @[SLR0_Mem.scala 79:55]
  assign Memory_14_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_14; // @[SLR0_Mem.scala 80:55]
  assign Memory_14_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_14; // @[SLR0_Mem.scala 81:55]
  assign Memory_14_io_offsets_level_offset = copy_offset_level_offset_io_out_14; // @[SLR0_Mem.scala 82:55]
  assign Memory_14_io_uram_out_a_0 = io_uram_out_a_56; // @[SLR0_Mem.scala 97:49]
  assign Memory_14_io_uram_out_a_1 = io_uram_out_a_57; // @[SLR0_Mem.scala 97:49]
  assign Memory_14_io_uram_out_a_2 = io_uram_out_a_58; // @[SLR0_Mem.scala 97:49]
  assign Memory_14_io_uram_out_a_3 = io_uram_out_a_59; // @[SLR0_Mem.scala 97:49]
  assign Memory_14_io_kernel_count = copy_kernel_count_io_out_14; // @[SLR0_Mem.scala 72:42]
  assign Memory_14_io_master_finish = copy_master_finish_io_out_14; // @[SLR0_Mem.scala 75:42]
  assign Memory_14_io_node_num = {{5'd0}, _T_108[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_14_io_neighbours_0_ready = io_neighbours_56_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_14_io_neighbours_1_ready = io_neighbours_57_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_14_io_neighbours_2_ready = io_neighbours_58_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_14_io_neighbours_3_ready = io_neighbours_59_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_14_io_HBM_interface_writeAddr_ready = io_HBM_interface_14_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_writeData_ready = io_HBM_interface_14_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_writeResp_valid = io_HBM_interface_14_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_writeResp_bits_id = io_HBM_interface_14_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_14_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readAddr_ready = io_HBM_interface_14_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readData_valid = io_HBM_interface_14_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readData_bits_data = io_HBM_interface_14_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readData_bits_id = io_HBM_interface_14_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readData_bits_last = io_HBM_interface_14_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_HBM_interface_readData_bits_resp = io_HBM_interface_14_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_14_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_14_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_15_clock = clock;
  assign Memory_15_reset = reset;
  assign Memory_15_io_R_array_index_0_valid = io_R_array_index_60_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_0_bits = io_R_array_index_60_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_1_valid = io_R_array_index_61_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_1_bits = io_R_array_index_61_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_2_valid = io_R_array_index_62_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_2_bits = io_R_array_index_62_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_3_valid = io_R_array_index_63_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_R_array_index_3_bits = io_R_array_index_63_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_15_io_p1_end = io_p1_end_15; // @[SLR0_Mem.scala 88:42]
  assign Memory_15_io_level = copy_level_io_out_15; // @[SLR0_Mem.scala 71:42]
  assign Memory_15_io_push_or_pull_state = copy_push_or_pull_io_out_15; // @[SLR0_Mem.scala 77:42]
  assign Memory_15_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_15; // @[SLR0_Mem.scala 78:55]
  assign Memory_15_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_15; // @[SLR0_Mem.scala 79:55]
  assign Memory_15_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_15; // @[SLR0_Mem.scala 80:55]
  assign Memory_15_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_15; // @[SLR0_Mem.scala 81:55]
  assign Memory_15_io_offsets_level_offset = copy_offset_level_offset_io_out_15; // @[SLR0_Mem.scala 82:55]
  assign Memory_15_io_uram_out_a_0 = io_uram_out_a_60; // @[SLR0_Mem.scala 97:49]
  assign Memory_15_io_uram_out_a_1 = io_uram_out_a_61; // @[SLR0_Mem.scala 97:49]
  assign Memory_15_io_uram_out_a_2 = io_uram_out_a_62; // @[SLR0_Mem.scala 97:49]
  assign Memory_15_io_uram_out_a_3 = io_uram_out_a_63; // @[SLR0_Mem.scala 97:49]
  assign Memory_15_io_kernel_count = copy_kernel_count_io_out_15; // @[SLR0_Mem.scala 72:42]
  assign Memory_15_io_master_finish = copy_master_finish_io_out_15; // @[SLR0_Mem.scala 75:42]
  assign Memory_15_io_node_num = {{5'd0}, _T_115[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_15_io_neighbours_0_ready = io_neighbours_60_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_15_io_neighbours_1_ready = io_neighbours_61_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_15_io_neighbours_2_ready = io_neighbours_62_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_15_io_neighbours_3_ready = io_neighbours_63_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_15_io_HBM_interface_writeAddr_ready = io_HBM_interface_15_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_writeData_ready = io_HBM_interface_15_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_writeResp_valid = io_HBM_interface_15_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_writeResp_bits_id = io_HBM_interface_15_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_15_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readAddr_ready = io_HBM_interface_15_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readData_valid = io_HBM_interface_15_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readData_bits_data = io_HBM_interface_15_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readData_bits_id = io_HBM_interface_15_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readData_bits_last = io_HBM_interface_15_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_HBM_interface_readData_bits_resp = io_HBM_interface_15_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_15_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_15_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_16_clock = clock;
  assign Memory_16_reset = reset;
  assign Memory_16_io_R_array_index_0_valid = io_R_array_index_64_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_0_bits = io_R_array_index_64_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_1_valid = io_R_array_index_65_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_1_bits = io_R_array_index_65_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_2_valid = io_R_array_index_66_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_2_bits = io_R_array_index_66_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_3_valid = io_R_array_index_67_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_R_array_index_3_bits = io_R_array_index_67_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_16_io_p1_end = io_p1_end_16; // @[SLR0_Mem.scala 88:42]
  assign Memory_16_io_level = copy_level_io_out_16; // @[SLR0_Mem.scala 71:42]
  assign Memory_16_io_push_or_pull_state = copy_push_or_pull_io_out_16; // @[SLR0_Mem.scala 77:42]
  assign Memory_16_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_16; // @[SLR0_Mem.scala 78:55]
  assign Memory_16_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_16; // @[SLR0_Mem.scala 79:55]
  assign Memory_16_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_16; // @[SLR0_Mem.scala 80:55]
  assign Memory_16_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_16; // @[SLR0_Mem.scala 81:55]
  assign Memory_16_io_offsets_level_offset = copy_offset_level_offset_io_out_16; // @[SLR0_Mem.scala 82:55]
  assign Memory_16_io_uram_out_a_0 = io_uram_out_a_64; // @[SLR0_Mem.scala 97:49]
  assign Memory_16_io_uram_out_a_1 = io_uram_out_a_65; // @[SLR0_Mem.scala 97:49]
  assign Memory_16_io_uram_out_a_2 = io_uram_out_a_66; // @[SLR0_Mem.scala 97:49]
  assign Memory_16_io_uram_out_a_3 = io_uram_out_a_67; // @[SLR0_Mem.scala 97:49]
  assign Memory_16_io_kernel_count = copy_kernel_count_io_out_16; // @[SLR0_Mem.scala 72:42]
  assign Memory_16_io_master_finish = copy_master_finish_io_out_16; // @[SLR0_Mem.scala 75:42]
  assign Memory_16_io_node_num = {{5'd0}, _T_122[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_16_io_neighbours_0_ready = io_neighbours_64_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_16_io_neighbours_1_ready = io_neighbours_65_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_16_io_neighbours_2_ready = io_neighbours_66_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_16_io_neighbours_3_ready = io_neighbours_67_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_16_io_HBM_interface_writeAddr_ready = io_HBM_interface_16_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_writeData_ready = io_HBM_interface_16_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_writeResp_valid = io_HBM_interface_16_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_writeResp_bits_id = io_HBM_interface_16_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_16_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readAddr_ready = io_HBM_interface_16_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readData_valid = io_HBM_interface_16_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readData_bits_data = io_HBM_interface_16_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readData_bits_id = io_HBM_interface_16_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readData_bits_last = io_HBM_interface_16_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_HBM_interface_readData_bits_resp = io_HBM_interface_16_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_16_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_16_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_17_clock = clock;
  assign Memory_17_reset = reset;
  assign Memory_17_io_R_array_index_0_valid = io_R_array_index_68_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_0_bits = io_R_array_index_68_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_1_valid = io_R_array_index_69_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_1_bits = io_R_array_index_69_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_2_valid = io_R_array_index_70_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_2_bits = io_R_array_index_70_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_3_valid = io_R_array_index_71_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_R_array_index_3_bits = io_R_array_index_71_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_17_io_p1_end = io_p1_end_17; // @[SLR0_Mem.scala 88:42]
  assign Memory_17_io_level = copy_level_io_out_17; // @[SLR0_Mem.scala 71:42]
  assign Memory_17_io_push_or_pull_state = copy_push_or_pull_io_out_17; // @[SLR0_Mem.scala 77:42]
  assign Memory_17_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_17; // @[SLR0_Mem.scala 78:55]
  assign Memory_17_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_17; // @[SLR0_Mem.scala 79:55]
  assign Memory_17_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_17; // @[SLR0_Mem.scala 80:55]
  assign Memory_17_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_17; // @[SLR0_Mem.scala 81:55]
  assign Memory_17_io_offsets_level_offset = copy_offset_level_offset_io_out_17; // @[SLR0_Mem.scala 82:55]
  assign Memory_17_io_uram_out_a_0 = io_uram_out_a_68; // @[SLR0_Mem.scala 97:49]
  assign Memory_17_io_uram_out_a_1 = io_uram_out_a_69; // @[SLR0_Mem.scala 97:49]
  assign Memory_17_io_uram_out_a_2 = io_uram_out_a_70; // @[SLR0_Mem.scala 97:49]
  assign Memory_17_io_uram_out_a_3 = io_uram_out_a_71; // @[SLR0_Mem.scala 97:49]
  assign Memory_17_io_kernel_count = copy_kernel_count_io_out_17; // @[SLR0_Mem.scala 72:42]
  assign Memory_17_io_master_finish = copy_master_finish_io_out_17; // @[SLR0_Mem.scala 75:42]
  assign Memory_17_io_node_num = {{5'd0}, _T_129[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_17_io_neighbours_0_ready = io_neighbours_68_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_17_io_neighbours_1_ready = io_neighbours_69_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_17_io_neighbours_2_ready = io_neighbours_70_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_17_io_neighbours_3_ready = io_neighbours_71_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_17_io_HBM_interface_writeAddr_ready = io_HBM_interface_17_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_writeData_ready = io_HBM_interface_17_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_writeResp_valid = io_HBM_interface_17_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_writeResp_bits_id = io_HBM_interface_17_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_17_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readAddr_ready = io_HBM_interface_17_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readData_valid = io_HBM_interface_17_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readData_bits_data = io_HBM_interface_17_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readData_bits_id = io_HBM_interface_17_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readData_bits_last = io_HBM_interface_17_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_HBM_interface_readData_bits_resp = io_HBM_interface_17_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_17_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_17_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_18_clock = clock;
  assign Memory_18_reset = reset;
  assign Memory_18_io_R_array_index_0_valid = io_R_array_index_72_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_0_bits = io_R_array_index_72_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_1_valid = io_R_array_index_73_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_1_bits = io_R_array_index_73_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_2_valid = io_R_array_index_74_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_2_bits = io_R_array_index_74_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_3_valid = io_R_array_index_75_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_R_array_index_3_bits = io_R_array_index_75_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_18_io_p1_end = io_p1_end_18; // @[SLR0_Mem.scala 88:42]
  assign Memory_18_io_level = copy_level_io_out_18; // @[SLR0_Mem.scala 71:42]
  assign Memory_18_io_push_or_pull_state = copy_push_or_pull_io_out_18; // @[SLR0_Mem.scala 77:42]
  assign Memory_18_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_18; // @[SLR0_Mem.scala 78:55]
  assign Memory_18_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_18; // @[SLR0_Mem.scala 79:55]
  assign Memory_18_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_18; // @[SLR0_Mem.scala 80:55]
  assign Memory_18_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_18; // @[SLR0_Mem.scala 81:55]
  assign Memory_18_io_offsets_level_offset = copy_offset_level_offset_io_out_18; // @[SLR0_Mem.scala 82:55]
  assign Memory_18_io_uram_out_a_0 = io_uram_out_a_72; // @[SLR0_Mem.scala 97:49]
  assign Memory_18_io_uram_out_a_1 = io_uram_out_a_73; // @[SLR0_Mem.scala 97:49]
  assign Memory_18_io_uram_out_a_2 = io_uram_out_a_74; // @[SLR0_Mem.scala 97:49]
  assign Memory_18_io_uram_out_a_3 = io_uram_out_a_75; // @[SLR0_Mem.scala 97:49]
  assign Memory_18_io_kernel_count = copy_kernel_count_io_out_18; // @[SLR0_Mem.scala 72:42]
  assign Memory_18_io_master_finish = copy_master_finish_io_out_18; // @[SLR0_Mem.scala 75:42]
  assign Memory_18_io_node_num = {{5'd0}, _T_136[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_18_io_neighbours_0_ready = io_neighbours_72_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_18_io_neighbours_1_ready = io_neighbours_73_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_18_io_neighbours_2_ready = io_neighbours_74_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_18_io_neighbours_3_ready = io_neighbours_75_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_18_io_HBM_interface_writeAddr_ready = io_HBM_interface_18_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_writeData_ready = io_HBM_interface_18_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_writeResp_valid = io_HBM_interface_18_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_writeResp_bits_id = io_HBM_interface_18_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_18_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readAddr_ready = io_HBM_interface_18_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readData_valid = io_HBM_interface_18_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readData_bits_data = io_HBM_interface_18_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readData_bits_id = io_HBM_interface_18_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readData_bits_last = io_HBM_interface_18_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_HBM_interface_readData_bits_resp = io_HBM_interface_18_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_18_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_18_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_19_clock = clock;
  assign Memory_19_reset = reset;
  assign Memory_19_io_R_array_index_0_valid = io_R_array_index_76_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_0_bits = io_R_array_index_76_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_1_valid = io_R_array_index_77_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_1_bits = io_R_array_index_77_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_2_valid = io_R_array_index_78_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_2_bits = io_R_array_index_78_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_3_valid = io_R_array_index_79_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_R_array_index_3_bits = io_R_array_index_79_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_19_io_p1_end = io_p1_end_19; // @[SLR0_Mem.scala 88:42]
  assign Memory_19_io_level = copy_level_io_out_19; // @[SLR0_Mem.scala 71:42]
  assign Memory_19_io_push_or_pull_state = copy_push_or_pull_io_out_19; // @[SLR0_Mem.scala 77:42]
  assign Memory_19_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_19; // @[SLR0_Mem.scala 78:55]
  assign Memory_19_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_19; // @[SLR0_Mem.scala 79:55]
  assign Memory_19_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_19; // @[SLR0_Mem.scala 80:55]
  assign Memory_19_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_19; // @[SLR0_Mem.scala 81:55]
  assign Memory_19_io_offsets_level_offset = copy_offset_level_offset_io_out_19; // @[SLR0_Mem.scala 82:55]
  assign Memory_19_io_uram_out_a_0 = io_uram_out_a_76; // @[SLR0_Mem.scala 97:49]
  assign Memory_19_io_uram_out_a_1 = io_uram_out_a_77; // @[SLR0_Mem.scala 97:49]
  assign Memory_19_io_uram_out_a_2 = io_uram_out_a_78; // @[SLR0_Mem.scala 97:49]
  assign Memory_19_io_uram_out_a_3 = io_uram_out_a_79; // @[SLR0_Mem.scala 97:49]
  assign Memory_19_io_kernel_count = copy_kernel_count_io_out_19; // @[SLR0_Mem.scala 72:42]
  assign Memory_19_io_master_finish = copy_master_finish_io_out_19; // @[SLR0_Mem.scala 75:42]
  assign Memory_19_io_node_num = {{5'd0}, _T_143[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_19_io_neighbours_0_ready = io_neighbours_76_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_19_io_neighbours_1_ready = io_neighbours_77_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_19_io_neighbours_2_ready = io_neighbours_78_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_19_io_neighbours_3_ready = io_neighbours_79_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_19_io_HBM_interface_writeAddr_ready = io_HBM_interface_19_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_writeData_ready = io_HBM_interface_19_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_writeResp_valid = io_HBM_interface_19_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_writeResp_bits_id = io_HBM_interface_19_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_19_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readAddr_ready = io_HBM_interface_19_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readData_valid = io_HBM_interface_19_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readData_bits_data = io_HBM_interface_19_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readData_bits_id = io_HBM_interface_19_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readData_bits_last = io_HBM_interface_19_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_HBM_interface_readData_bits_resp = io_HBM_interface_19_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_19_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_19_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_20_clock = clock;
  assign Memory_20_reset = reset;
  assign Memory_20_io_R_array_index_0_valid = io_R_array_index_80_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_0_bits = io_R_array_index_80_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_1_valid = io_R_array_index_81_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_1_bits = io_R_array_index_81_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_2_valid = io_R_array_index_82_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_2_bits = io_R_array_index_82_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_3_valid = io_R_array_index_83_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_R_array_index_3_bits = io_R_array_index_83_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_20_io_p1_end = io_p1_end_20; // @[SLR0_Mem.scala 88:42]
  assign Memory_20_io_level = copy_level_io_out_20; // @[SLR0_Mem.scala 71:42]
  assign Memory_20_io_push_or_pull_state = copy_push_or_pull_io_out_20; // @[SLR0_Mem.scala 77:42]
  assign Memory_20_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_20; // @[SLR0_Mem.scala 78:55]
  assign Memory_20_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_20; // @[SLR0_Mem.scala 79:55]
  assign Memory_20_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_20; // @[SLR0_Mem.scala 80:55]
  assign Memory_20_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_20; // @[SLR0_Mem.scala 81:55]
  assign Memory_20_io_offsets_level_offset = copy_offset_level_offset_io_out_20; // @[SLR0_Mem.scala 82:55]
  assign Memory_20_io_uram_out_a_0 = io_uram_out_a_80; // @[SLR0_Mem.scala 97:49]
  assign Memory_20_io_uram_out_a_1 = io_uram_out_a_81; // @[SLR0_Mem.scala 97:49]
  assign Memory_20_io_uram_out_a_2 = io_uram_out_a_82; // @[SLR0_Mem.scala 97:49]
  assign Memory_20_io_uram_out_a_3 = io_uram_out_a_83; // @[SLR0_Mem.scala 97:49]
  assign Memory_20_io_kernel_count = copy_kernel_count_io_out_20; // @[SLR0_Mem.scala 72:42]
  assign Memory_20_io_master_finish = copy_master_finish_io_out_20; // @[SLR0_Mem.scala 75:42]
  assign Memory_20_io_node_num = {{5'd0}, _T_150[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_20_io_neighbours_0_ready = io_neighbours_80_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_20_io_neighbours_1_ready = io_neighbours_81_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_20_io_neighbours_2_ready = io_neighbours_82_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_20_io_neighbours_3_ready = io_neighbours_83_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_20_io_HBM_interface_writeAddr_ready = io_HBM_interface_20_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_writeData_ready = io_HBM_interface_20_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_writeResp_valid = io_HBM_interface_20_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_writeResp_bits_id = io_HBM_interface_20_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_20_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readAddr_ready = io_HBM_interface_20_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readData_valid = io_HBM_interface_20_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readData_bits_data = io_HBM_interface_20_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readData_bits_id = io_HBM_interface_20_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readData_bits_last = io_HBM_interface_20_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_HBM_interface_readData_bits_resp = io_HBM_interface_20_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_20_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_20_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_21_clock = clock;
  assign Memory_21_reset = reset;
  assign Memory_21_io_R_array_index_0_valid = io_R_array_index_84_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_0_bits = io_R_array_index_84_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_1_valid = io_R_array_index_85_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_1_bits = io_R_array_index_85_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_2_valid = io_R_array_index_86_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_2_bits = io_R_array_index_86_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_3_valid = io_R_array_index_87_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_R_array_index_3_bits = io_R_array_index_87_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_21_io_p1_end = io_p1_end_21; // @[SLR0_Mem.scala 88:42]
  assign Memory_21_io_level = copy_level_io_out_21; // @[SLR0_Mem.scala 71:42]
  assign Memory_21_io_push_or_pull_state = copy_push_or_pull_io_out_21; // @[SLR0_Mem.scala 77:42]
  assign Memory_21_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_21; // @[SLR0_Mem.scala 78:55]
  assign Memory_21_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_21; // @[SLR0_Mem.scala 79:55]
  assign Memory_21_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_21; // @[SLR0_Mem.scala 80:55]
  assign Memory_21_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_21; // @[SLR0_Mem.scala 81:55]
  assign Memory_21_io_offsets_level_offset = copy_offset_level_offset_io_out_21; // @[SLR0_Mem.scala 82:55]
  assign Memory_21_io_uram_out_a_0 = io_uram_out_a_84; // @[SLR0_Mem.scala 97:49]
  assign Memory_21_io_uram_out_a_1 = io_uram_out_a_85; // @[SLR0_Mem.scala 97:49]
  assign Memory_21_io_uram_out_a_2 = io_uram_out_a_86; // @[SLR0_Mem.scala 97:49]
  assign Memory_21_io_uram_out_a_3 = io_uram_out_a_87; // @[SLR0_Mem.scala 97:49]
  assign Memory_21_io_kernel_count = copy_kernel_count_io_out_21; // @[SLR0_Mem.scala 72:42]
  assign Memory_21_io_master_finish = copy_master_finish_io_out_21; // @[SLR0_Mem.scala 75:42]
  assign Memory_21_io_node_num = {{5'd0}, _T_157[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_21_io_neighbours_0_ready = io_neighbours_84_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_21_io_neighbours_1_ready = io_neighbours_85_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_21_io_neighbours_2_ready = io_neighbours_86_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_21_io_neighbours_3_ready = io_neighbours_87_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_21_io_HBM_interface_writeAddr_ready = io_HBM_interface_21_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_writeData_ready = io_HBM_interface_21_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_writeResp_valid = io_HBM_interface_21_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_writeResp_bits_id = io_HBM_interface_21_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_21_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readAddr_ready = io_HBM_interface_21_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readData_valid = io_HBM_interface_21_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readData_bits_data = io_HBM_interface_21_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readData_bits_id = io_HBM_interface_21_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readData_bits_last = io_HBM_interface_21_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_HBM_interface_readData_bits_resp = io_HBM_interface_21_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_21_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_21_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_22_clock = clock;
  assign Memory_22_reset = reset;
  assign Memory_22_io_R_array_index_0_valid = io_R_array_index_88_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_0_bits = io_R_array_index_88_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_1_valid = io_R_array_index_89_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_1_bits = io_R_array_index_89_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_2_valid = io_R_array_index_90_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_2_bits = io_R_array_index_90_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_3_valid = io_R_array_index_91_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_R_array_index_3_bits = io_R_array_index_91_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_22_io_p1_end = io_p1_end_22; // @[SLR0_Mem.scala 88:42]
  assign Memory_22_io_level = copy_level_io_out_22; // @[SLR0_Mem.scala 71:42]
  assign Memory_22_io_push_or_pull_state = copy_push_or_pull_io_out_22; // @[SLR0_Mem.scala 77:42]
  assign Memory_22_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_22; // @[SLR0_Mem.scala 78:55]
  assign Memory_22_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_22; // @[SLR0_Mem.scala 79:55]
  assign Memory_22_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_22; // @[SLR0_Mem.scala 80:55]
  assign Memory_22_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_22; // @[SLR0_Mem.scala 81:55]
  assign Memory_22_io_offsets_level_offset = copy_offset_level_offset_io_out_22; // @[SLR0_Mem.scala 82:55]
  assign Memory_22_io_uram_out_a_0 = io_uram_out_a_88; // @[SLR0_Mem.scala 97:49]
  assign Memory_22_io_uram_out_a_1 = io_uram_out_a_89; // @[SLR0_Mem.scala 97:49]
  assign Memory_22_io_uram_out_a_2 = io_uram_out_a_90; // @[SLR0_Mem.scala 97:49]
  assign Memory_22_io_uram_out_a_3 = io_uram_out_a_91; // @[SLR0_Mem.scala 97:49]
  assign Memory_22_io_kernel_count = copy_kernel_count_io_out_22; // @[SLR0_Mem.scala 72:42]
  assign Memory_22_io_master_finish = copy_master_finish_io_out_22; // @[SLR0_Mem.scala 75:42]
  assign Memory_22_io_node_num = {{5'd0}, _T_164[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_22_io_neighbours_0_ready = io_neighbours_88_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_22_io_neighbours_1_ready = io_neighbours_89_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_22_io_neighbours_2_ready = io_neighbours_90_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_22_io_neighbours_3_ready = io_neighbours_91_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_22_io_HBM_interface_writeAddr_ready = io_HBM_interface_22_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_writeData_ready = io_HBM_interface_22_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_writeResp_valid = io_HBM_interface_22_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_writeResp_bits_id = io_HBM_interface_22_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_22_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readAddr_ready = io_HBM_interface_22_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readData_valid = io_HBM_interface_22_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readData_bits_data = io_HBM_interface_22_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readData_bits_id = io_HBM_interface_22_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readData_bits_last = io_HBM_interface_22_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_HBM_interface_readData_bits_resp = io_HBM_interface_22_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_22_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_22_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_23_clock = clock;
  assign Memory_23_reset = reset;
  assign Memory_23_io_R_array_index_0_valid = io_R_array_index_92_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_0_bits = io_R_array_index_92_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_1_valid = io_R_array_index_93_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_1_bits = io_R_array_index_93_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_2_valid = io_R_array_index_94_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_2_bits = io_R_array_index_94_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_3_valid = io_R_array_index_95_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_R_array_index_3_bits = io_R_array_index_95_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_23_io_p1_end = io_p1_end_23; // @[SLR0_Mem.scala 88:42]
  assign Memory_23_io_level = copy_level_io_out_23; // @[SLR0_Mem.scala 71:42]
  assign Memory_23_io_push_or_pull_state = copy_push_or_pull_io_out_23; // @[SLR0_Mem.scala 77:42]
  assign Memory_23_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_23; // @[SLR0_Mem.scala 78:55]
  assign Memory_23_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_23; // @[SLR0_Mem.scala 79:55]
  assign Memory_23_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_23; // @[SLR0_Mem.scala 80:55]
  assign Memory_23_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_23; // @[SLR0_Mem.scala 81:55]
  assign Memory_23_io_offsets_level_offset = copy_offset_level_offset_io_out_23; // @[SLR0_Mem.scala 82:55]
  assign Memory_23_io_uram_out_a_0 = io_uram_out_a_92; // @[SLR0_Mem.scala 97:49]
  assign Memory_23_io_uram_out_a_1 = io_uram_out_a_93; // @[SLR0_Mem.scala 97:49]
  assign Memory_23_io_uram_out_a_2 = io_uram_out_a_94; // @[SLR0_Mem.scala 97:49]
  assign Memory_23_io_uram_out_a_3 = io_uram_out_a_95; // @[SLR0_Mem.scala 97:49]
  assign Memory_23_io_kernel_count = copy_kernel_count_io_out_23; // @[SLR0_Mem.scala 72:42]
  assign Memory_23_io_master_finish = copy_master_finish_io_out_23; // @[SLR0_Mem.scala 75:42]
  assign Memory_23_io_node_num = {{5'd0}, _T_171[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_23_io_neighbours_0_ready = io_neighbours_92_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_23_io_neighbours_1_ready = io_neighbours_93_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_23_io_neighbours_2_ready = io_neighbours_94_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_23_io_neighbours_3_ready = io_neighbours_95_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_23_io_HBM_interface_writeAddr_ready = io_HBM_interface_23_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_writeData_ready = io_HBM_interface_23_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_writeResp_valid = io_HBM_interface_23_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_writeResp_bits_id = io_HBM_interface_23_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_23_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readAddr_ready = io_HBM_interface_23_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readData_valid = io_HBM_interface_23_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readData_bits_data = io_HBM_interface_23_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readData_bits_id = io_HBM_interface_23_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readData_bits_last = io_HBM_interface_23_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_HBM_interface_readData_bits_resp = io_HBM_interface_23_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_23_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_23_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_24_clock = clock;
  assign Memory_24_reset = reset;
  assign Memory_24_io_R_array_index_0_valid = io_R_array_index_96_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_0_bits = io_R_array_index_96_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_1_valid = io_R_array_index_97_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_1_bits = io_R_array_index_97_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_2_valid = io_R_array_index_98_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_2_bits = io_R_array_index_98_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_3_valid = io_R_array_index_99_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_R_array_index_3_bits = io_R_array_index_99_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_24_io_p1_end = io_p1_end_24; // @[SLR0_Mem.scala 88:42]
  assign Memory_24_io_level = copy_level_io_out_24; // @[SLR0_Mem.scala 71:42]
  assign Memory_24_io_push_or_pull_state = copy_push_or_pull_io_out_24; // @[SLR0_Mem.scala 77:42]
  assign Memory_24_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_24; // @[SLR0_Mem.scala 78:55]
  assign Memory_24_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_24; // @[SLR0_Mem.scala 79:55]
  assign Memory_24_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_24; // @[SLR0_Mem.scala 80:55]
  assign Memory_24_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_24; // @[SLR0_Mem.scala 81:55]
  assign Memory_24_io_offsets_level_offset = copy_offset_level_offset_io_out_24; // @[SLR0_Mem.scala 82:55]
  assign Memory_24_io_uram_out_a_0 = io_uram_out_a_96; // @[SLR0_Mem.scala 97:49]
  assign Memory_24_io_uram_out_a_1 = io_uram_out_a_97; // @[SLR0_Mem.scala 97:49]
  assign Memory_24_io_uram_out_a_2 = io_uram_out_a_98; // @[SLR0_Mem.scala 97:49]
  assign Memory_24_io_uram_out_a_3 = io_uram_out_a_99; // @[SLR0_Mem.scala 97:49]
  assign Memory_24_io_kernel_count = copy_kernel_count_io_out_24; // @[SLR0_Mem.scala 72:42]
  assign Memory_24_io_master_finish = copy_master_finish_io_out_24; // @[SLR0_Mem.scala 75:42]
  assign Memory_24_io_node_num = {{5'd0}, _T_178[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_24_io_neighbours_0_ready = io_neighbours_96_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_24_io_neighbours_1_ready = io_neighbours_97_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_24_io_neighbours_2_ready = io_neighbours_98_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_24_io_neighbours_3_ready = io_neighbours_99_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_24_io_HBM_interface_writeAddr_ready = io_HBM_interface_24_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_writeData_ready = io_HBM_interface_24_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_writeResp_valid = io_HBM_interface_24_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_writeResp_bits_id = io_HBM_interface_24_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_24_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readAddr_ready = io_HBM_interface_24_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readData_valid = io_HBM_interface_24_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readData_bits_data = io_HBM_interface_24_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readData_bits_id = io_HBM_interface_24_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readData_bits_last = io_HBM_interface_24_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_HBM_interface_readData_bits_resp = io_HBM_interface_24_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_24_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_24_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_25_clock = clock;
  assign Memory_25_reset = reset;
  assign Memory_25_io_R_array_index_0_valid = io_R_array_index_100_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_0_bits = io_R_array_index_100_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_1_valid = io_R_array_index_101_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_1_bits = io_R_array_index_101_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_2_valid = io_R_array_index_102_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_2_bits = io_R_array_index_102_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_3_valid = io_R_array_index_103_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_R_array_index_3_bits = io_R_array_index_103_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_25_io_p1_end = io_p1_end_25; // @[SLR0_Mem.scala 88:42]
  assign Memory_25_io_level = copy_level_io_out_25; // @[SLR0_Mem.scala 71:42]
  assign Memory_25_io_push_or_pull_state = copy_push_or_pull_io_out_25; // @[SLR0_Mem.scala 77:42]
  assign Memory_25_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_25; // @[SLR0_Mem.scala 78:55]
  assign Memory_25_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_25; // @[SLR0_Mem.scala 79:55]
  assign Memory_25_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_25; // @[SLR0_Mem.scala 80:55]
  assign Memory_25_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_25; // @[SLR0_Mem.scala 81:55]
  assign Memory_25_io_offsets_level_offset = copy_offset_level_offset_io_out_25; // @[SLR0_Mem.scala 82:55]
  assign Memory_25_io_uram_out_a_0 = io_uram_out_a_100; // @[SLR0_Mem.scala 97:49]
  assign Memory_25_io_uram_out_a_1 = io_uram_out_a_101; // @[SLR0_Mem.scala 97:49]
  assign Memory_25_io_uram_out_a_2 = io_uram_out_a_102; // @[SLR0_Mem.scala 97:49]
  assign Memory_25_io_uram_out_a_3 = io_uram_out_a_103; // @[SLR0_Mem.scala 97:49]
  assign Memory_25_io_kernel_count = copy_kernel_count_io_out_25; // @[SLR0_Mem.scala 72:42]
  assign Memory_25_io_master_finish = copy_master_finish_io_out_25; // @[SLR0_Mem.scala 75:42]
  assign Memory_25_io_node_num = {{5'd0}, _T_185[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_25_io_neighbours_0_ready = io_neighbours_100_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_25_io_neighbours_1_ready = io_neighbours_101_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_25_io_neighbours_2_ready = io_neighbours_102_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_25_io_neighbours_3_ready = io_neighbours_103_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_25_io_HBM_interface_writeAddr_ready = io_HBM_interface_25_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_writeData_ready = io_HBM_interface_25_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_writeResp_valid = io_HBM_interface_25_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_writeResp_bits_id = io_HBM_interface_25_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_25_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readAddr_ready = io_HBM_interface_25_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readData_valid = io_HBM_interface_25_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readData_bits_data = io_HBM_interface_25_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readData_bits_id = io_HBM_interface_25_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readData_bits_last = io_HBM_interface_25_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_HBM_interface_readData_bits_resp = io_HBM_interface_25_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_25_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_25_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_26_clock = clock;
  assign Memory_26_reset = reset;
  assign Memory_26_io_R_array_index_0_valid = io_R_array_index_104_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_0_bits = io_R_array_index_104_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_1_valid = io_R_array_index_105_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_1_bits = io_R_array_index_105_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_2_valid = io_R_array_index_106_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_2_bits = io_R_array_index_106_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_3_valid = io_R_array_index_107_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_R_array_index_3_bits = io_R_array_index_107_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_26_io_p1_end = io_p1_end_26; // @[SLR0_Mem.scala 88:42]
  assign Memory_26_io_level = copy_level_io_out_26; // @[SLR0_Mem.scala 71:42]
  assign Memory_26_io_push_or_pull_state = copy_push_or_pull_io_out_26; // @[SLR0_Mem.scala 77:42]
  assign Memory_26_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_26; // @[SLR0_Mem.scala 78:55]
  assign Memory_26_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_26; // @[SLR0_Mem.scala 79:55]
  assign Memory_26_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_26; // @[SLR0_Mem.scala 80:55]
  assign Memory_26_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_26; // @[SLR0_Mem.scala 81:55]
  assign Memory_26_io_offsets_level_offset = copy_offset_level_offset_io_out_26; // @[SLR0_Mem.scala 82:55]
  assign Memory_26_io_uram_out_a_0 = io_uram_out_a_104; // @[SLR0_Mem.scala 97:49]
  assign Memory_26_io_uram_out_a_1 = io_uram_out_a_105; // @[SLR0_Mem.scala 97:49]
  assign Memory_26_io_uram_out_a_2 = io_uram_out_a_106; // @[SLR0_Mem.scala 97:49]
  assign Memory_26_io_uram_out_a_3 = io_uram_out_a_107; // @[SLR0_Mem.scala 97:49]
  assign Memory_26_io_kernel_count = copy_kernel_count_io_out_26; // @[SLR0_Mem.scala 72:42]
  assign Memory_26_io_master_finish = copy_master_finish_io_out_26; // @[SLR0_Mem.scala 75:42]
  assign Memory_26_io_node_num = {{5'd0}, _T_192[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_26_io_neighbours_0_ready = io_neighbours_104_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_26_io_neighbours_1_ready = io_neighbours_105_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_26_io_neighbours_2_ready = io_neighbours_106_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_26_io_neighbours_3_ready = io_neighbours_107_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_26_io_HBM_interface_writeAddr_ready = io_HBM_interface_26_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_writeData_ready = io_HBM_interface_26_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_writeResp_valid = io_HBM_interface_26_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_writeResp_bits_id = io_HBM_interface_26_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_26_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readAddr_ready = io_HBM_interface_26_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readData_valid = io_HBM_interface_26_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readData_bits_data = io_HBM_interface_26_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readData_bits_id = io_HBM_interface_26_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readData_bits_last = io_HBM_interface_26_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_HBM_interface_readData_bits_resp = io_HBM_interface_26_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_26_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_26_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_27_clock = clock;
  assign Memory_27_reset = reset;
  assign Memory_27_io_R_array_index_0_valid = io_R_array_index_108_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_0_bits = io_R_array_index_108_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_1_valid = io_R_array_index_109_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_1_bits = io_R_array_index_109_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_2_valid = io_R_array_index_110_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_2_bits = io_R_array_index_110_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_3_valid = io_R_array_index_111_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_R_array_index_3_bits = io_R_array_index_111_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_27_io_p1_end = io_p1_end_27; // @[SLR0_Mem.scala 88:42]
  assign Memory_27_io_level = copy_level_io_out_27; // @[SLR0_Mem.scala 71:42]
  assign Memory_27_io_push_or_pull_state = copy_push_or_pull_io_out_27; // @[SLR0_Mem.scala 77:42]
  assign Memory_27_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_27; // @[SLR0_Mem.scala 78:55]
  assign Memory_27_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_27; // @[SLR0_Mem.scala 79:55]
  assign Memory_27_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_27; // @[SLR0_Mem.scala 80:55]
  assign Memory_27_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_27; // @[SLR0_Mem.scala 81:55]
  assign Memory_27_io_offsets_level_offset = copy_offset_level_offset_io_out_27; // @[SLR0_Mem.scala 82:55]
  assign Memory_27_io_uram_out_a_0 = io_uram_out_a_108; // @[SLR0_Mem.scala 97:49]
  assign Memory_27_io_uram_out_a_1 = io_uram_out_a_109; // @[SLR0_Mem.scala 97:49]
  assign Memory_27_io_uram_out_a_2 = io_uram_out_a_110; // @[SLR0_Mem.scala 97:49]
  assign Memory_27_io_uram_out_a_3 = io_uram_out_a_111; // @[SLR0_Mem.scala 97:49]
  assign Memory_27_io_kernel_count = copy_kernel_count_io_out_27; // @[SLR0_Mem.scala 72:42]
  assign Memory_27_io_master_finish = copy_master_finish_io_out_27; // @[SLR0_Mem.scala 75:42]
  assign Memory_27_io_node_num = {{5'd0}, _T_199[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_27_io_neighbours_0_ready = io_neighbours_108_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_27_io_neighbours_1_ready = io_neighbours_109_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_27_io_neighbours_2_ready = io_neighbours_110_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_27_io_neighbours_3_ready = io_neighbours_111_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_27_io_HBM_interface_writeAddr_ready = io_HBM_interface_27_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_writeData_ready = io_HBM_interface_27_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_writeResp_valid = io_HBM_interface_27_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_writeResp_bits_id = io_HBM_interface_27_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_27_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readAddr_ready = io_HBM_interface_27_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readData_valid = io_HBM_interface_27_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readData_bits_data = io_HBM_interface_27_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readData_bits_id = io_HBM_interface_27_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readData_bits_last = io_HBM_interface_27_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_HBM_interface_readData_bits_resp = io_HBM_interface_27_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_27_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_27_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_28_clock = clock;
  assign Memory_28_reset = reset;
  assign Memory_28_io_R_array_index_0_valid = io_R_array_index_112_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_0_bits = io_R_array_index_112_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_1_valid = io_R_array_index_113_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_1_bits = io_R_array_index_113_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_2_valid = io_R_array_index_114_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_2_bits = io_R_array_index_114_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_3_valid = io_R_array_index_115_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_R_array_index_3_bits = io_R_array_index_115_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_28_io_p1_end = io_p1_end_28; // @[SLR0_Mem.scala 88:42]
  assign Memory_28_io_level = copy_level_io_out_28; // @[SLR0_Mem.scala 71:42]
  assign Memory_28_io_push_or_pull_state = copy_push_or_pull_io_out_28; // @[SLR0_Mem.scala 77:42]
  assign Memory_28_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_28; // @[SLR0_Mem.scala 78:55]
  assign Memory_28_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_28; // @[SLR0_Mem.scala 79:55]
  assign Memory_28_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_28; // @[SLR0_Mem.scala 80:55]
  assign Memory_28_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_28; // @[SLR0_Mem.scala 81:55]
  assign Memory_28_io_offsets_level_offset = copy_offset_level_offset_io_out_28; // @[SLR0_Mem.scala 82:55]
  assign Memory_28_io_uram_out_a_0 = io_uram_out_a_112; // @[SLR0_Mem.scala 97:49]
  assign Memory_28_io_uram_out_a_1 = io_uram_out_a_113; // @[SLR0_Mem.scala 97:49]
  assign Memory_28_io_uram_out_a_2 = io_uram_out_a_114; // @[SLR0_Mem.scala 97:49]
  assign Memory_28_io_uram_out_a_3 = io_uram_out_a_115; // @[SLR0_Mem.scala 97:49]
  assign Memory_28_io_kernel_count = copy_kernel_count_io_out_28; // @[SLR0_Mem.scala 72:42]
  assign Memory_28_io_master_finish = copy_master_finish_io_out_28; // @[SLR0_Mem.scala 75:42]
  assign Memory_28_io_node_num = {{5'd0}, _T_206[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_28_io_neighbours_0_ready = io_neighbours_112_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_28_io_neighbours_1_ready = io_neighbours_113_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_28_io_neighbours_2_ready = io_neighbours_114_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_28_io_neighbours_3_ready = io_neighbours_115_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_28_io_HBM_interface_writeAddr_ready = io_HBM_interface_28_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_writeData_ready = io_HBM_interface_28_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_writeResp_valid = io_HBM_interface_28_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_writeResp_bits_id = io_HBM_interface_28_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_28_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readAddr_ready = io_HBM_interface_28_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readData_valid = io_HBM_interface_28_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readData_bits_data = io_HBM_interface_28_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readData_bits_id = io_HBM_interface_28_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readData_bits_last = io_HBM_interface_28_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_HBM_interface_readData_bits_resp = io_HBM_interface_28_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_28_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_28_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_29_clock = clock;
  assign Memory_29_reset = reset;
  assign Memory_29_io_R_array_index_0_valid = io_R_array_index_116_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_0_bits = io_R_array_index_116_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_1_valid = io_R_array_index_117_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_1_bits = io_R_array_index_117_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_2_valid = io_R_array_index_118_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_2_bits = io_R_array_index_118_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_3_valid = io_R_array_index_119_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_R_array_index_3_bits = io_R_array_index_119_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_29_io_p1_end = io_p1_end_29; // @[SLR0_Mem.scala 88:42]
  assign Memory_29_io_level = copy_level_io_out_29; // @[SLR0_Mem.scala 71:42]
  assign Memory_29_io_push_or_pull_state = copy_push_or_pull_io_out_29; // @[SLR0_Mem.scala 77:42]
  assign Memory_29_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_29; // @[SLR0_Mem.scala 78:55]
  assign Memory_29_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_29; // @[SLR0_Mem.scala 79:55]
  assign Memory_29_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_29; // @[SLR0_Mem.scala 80:55]
  assign Memory_29_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_29; // @[SLR0_Mem.scala 81:55]
  assign Memory_29_io_offsets_level_offset = copy_offset_level_offset_io_out_29; // @[SLR0_Mem.scala 82:55]
  assign Memory_29_io_uram_out_a_0 = io_uram_out_a_116; // @[SLR0_Mem.scala 97:49]
  assign Memory_29_io_uram_out_a_1 = io_uram_out_a_117; // @[SLR0_Mem.scala 97:49]
  assign Memory_29_io_uram_out_a_2 = io_uram_out_a_118; // @[SLR0_Mem.scala 97:49]
  assign Memory_29_io_uram_out_a_3 = io_uram_out_a_119; // @[SLR0_Mem.scala 97:49]
  assign Memory_29_io_kernel_count = copy_kernel_count_io_out_29; // @[SLR0_Mem.scala 72:42]
  assign Memory_29_io_master_finish = copy_master_finish_io_out_29; // @[SLR0_Mem.scala 75:42]
  assign Memory_29_io_node_num = {{5'd0}, _T_213[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_29_io_neighbours_0_ready = io_neighbours_116_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_29_io_neighbours_1_ready = io_neighbours_117_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_29_io_neighbours_2_ready = io_neighbours_118_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_29_io_neighbours_3_ready = io_neighbours_119_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_29_io_HBM_interface_writeAddr_ready = io_HBM_interface_29_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_writeData_ready = io_HBM_interface_29_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_writeResp_valid = io_HBM_interface_29_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_writeResp_bits_id = io_HBM_interface_29_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_29_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readAddr_ready = io_HBM_interface_29_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readData_valid = io_HBM_interface_29_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readData_bits_data = io_HBM_interface_29_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readData_bits_id = io_HBM_interface_29_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readData_bits_last = io_HBM_interface_29_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_HBM_interface_readData_bits_resp = io_HBM_interface_29_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_29_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_29_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_30_clock = clock;
  assign Memory_30_reset = reset;
  assign Memory_30_io_R_array_index_0_valid = io_R_array_index_120_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_0_bits = io_R_array_index_120_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_1_valid = io_R_array_index_121_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_1_bits = io_R_array_index_121_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_2_valid = io_R_array_index_122_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_2_bits = io_R_array_index_122_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_3_valid = io_R_array_index_123_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_R_array_index_3_bits = io_R_array_index_123_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_30_io_p1_end = io_p1_end_30; // @[SLR0_Mem.scala 88:42]
  assign Memory_30_io_level = copy_level_io_out_30; // @[SLR0_Mem.scala 71:42]
  assign Memory_30_io_push_or_pull_state = copy_push_or_pull_io_out_30; // @[SLR0_Mem.scala 77:42]
  assign Memory_30_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_30; // @[SLR0_Mem.scala 78:55]
  assign Memory_30_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_30; // @[SLR0_Mem.scala 79:55]
  assign Memory_30_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_30; // @[SLR0_Mem.scala 80:55]
  assign Memory_30_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_30; // @[SLR0_Mem.scala 81:55]
  assign Memory_30_io_offsets_level_offset = copy_offset_level_offset_io_out_30; // @[SLR0_Mem.scala 82:55]
  assign Memory_30_io_uram_out_a_0 = io_uram_out_a_120; // @[SLR0_Mem.scala 97:49]
  assign Memory_30_io_uram_out_a_1 = io_uram_out_a_121; // @[SLR0_Mem.scala 97:49]
  assign Memory_30_io_uram_out_a_2 = io_uram_out_a_122; // @[SLR0_Mem.scala 97:49]
  assign Memory_30_io_uram_out_a_3 = io_uram_out_a_123; // @[SLR0_Mem.scala 97:49]
  assign Memory_30_io_kernel_count = copy_kernel_count_io_out_30; // @[SLR0_Mem.scala 72:42]
  assign Memory_30_io_master_finish = copy_master_finish_io_out_30; // @[SLR0_Mem.scala 75:42]
  assign Memory_30_io_node_num = {{5'd0}, _T_220[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_30_io_neighbours_0_ready = io_neighbours_120_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_30_io_neighbours_1_ready = io_neighbours_121_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_30_io_neighbours_2_ready = io_neighbours_122_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_30_io_neighbours_3_ready = io_neighbours_123_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_30_io_HBM_interface_writeAddr_ready = io_HBM_interface_30_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_writeData_ready = io_HBM_interface_30_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_writeResp_valid = io_HBM_interface_30_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_writeResp_bits_id = io_HBM_interface_30_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_30_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readAddr_ready = io_HBM_interface_30_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readData_valid = io_HBM_interface_30_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readData_bits_data = io_HBM_interface_30_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readData_bits_id = io_HBM_interface_30_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readData_bits_last = io_HBM_interface_30_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_HBM_interface_readData_bits_resp = io_HBM_interface_30_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_30_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_30_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign Memory_31_clock = clock;
  assign Memory_31_reset = reset;
  assign Memory_31_io_R_array_index_0_valid = io_R_array_index_124_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_0_bits = io_R_array_index_124_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_1_valid = io_R_array_index_125_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_1_bits = io_R_array_index_125_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_2_valid = io_R_array_index_126_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_2_bits = io_R_array_index_126_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_3_valid = io_R_array_index_127_valid; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_R_array_index_3_bits = io_R_array_index_127_bits; // @[SLR0_Mem.scala 96:49]
  assign Memory_31_io_p1_end = io_p1_end_31; // @[SLR0_Mem.scala 88:42]
  assign Memory_31_io_level = copy_level_io_out_31; // @[SLR0_Mem.scala 71:42]
  assign Memory_31_io_push_or_pull_state = copy_push_or_pull_io_out_31; // @[SLR0_Mem.scala 77:42]
  assign Memory_31_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_31; // @[SLR0_Mem.scala 78:55]
  assign Memory_31_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_31; // @[SLR0_Mem.scala 79:55]
  assign Memory_31_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_31; // @[SLR0_Mem.scala 80:55]
  assign Memory_31_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_31; // @[SLR0_Mem.scala 81:55]
  assign Memory_31_io_offsets_level_offset = copy_offset_level_offset_io_out_31; // @[SLR0_Mem.scala 82:55]
  assign Memory_31_io_uram_out_a_0 = io_uram_out_a_124; // @[SLR0_Mem.scala 97:49]
  assign Memory_31_io_uram_out_a_1 = io_uram_out_a_125; // @[SLR0_Mem.scala 97:49]
  assign Memory_31_io_uram_out_a_2 = io_uram_out_a_126; // @[SLR0_Mem.scala 97:49]
  assign Memory_31_io_uram_out_a_3 = io_uram_out_a_127; // @[SLR0_Mem.scala 97:49]
  assign Memory_31_io_kernel_count = copy_kernel_count_io_out_31; // @[SLR0_Mem.scala 72:42]
  assign Memory_31_io_master_finish = copy_master_finish_io_out_31; // @[SLR0_Mem.scala 75:42]
  assign Memory_31_io_node_num = {{5'd0}, _T_227[31:5]}; // @[SLR0_Mem.scala 76:42]
  assign Memory_31_io_neighbours_0_ready = io_neighbours_124_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_31_io_neighbours_1_ready = io_neighbours_125_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_31_io_neighbours_2_ready = io_neighbours_126_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_31_io_neighbours_3_ready = io_neighbours_127_ready; // @[SLR0_Mem.scala 98:49]
  assign Memory_31_io_HBM_interface_writeAddr_ready = io_HBM_interface_31_writeAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_writeData_ready = io_HBM_interface_31_writeData_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_writeResp_valid = io_HBM_interface_31_writeResp_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_writeResp_bits_id = io_HBM_interface_31_writeResp_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_writeResp_bits_resp = io_HBM_interface_31_writeResp_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readAddr_ready = io_HBM_interface_31_readAddr_ready; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readData_valid = io_HBM_interface_31_readData_valid; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readData_bits_data = io_HBM_interface_31_readData_bits_data; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readData_bits_id = io_HBM_interface_31_readData_bits_id; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readData_bits_last = io_HBM_interface_31_readData_bits_last; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_HBM_interface_readData_bits_resp = io_HBM_interface_31_readData_bits_resp; // @[SLR0_Mem.scala 84:42]
  assign Memory_31_io_mem_clock = io_mem_clock; // @[SLR0_Mem.scala 73:42]
  assign Memory_31_io_reset_h = io_reset_h; // @[SLR0_Mem.scala 74:42]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[SLR0_Mem.scala 58:33]
  assign copy_kernel_count_clock = clock;
  assign copy_kernel_count_reset = reset;
  assign copy_kernel_count_io_in = io_kernel_count; // @[SLR0_Mem.scala 59:33]
  assign copy_master_finish_clock = clock;
  assign copy_master_finish_reset = reset;
  assign copy_master_finish_io_in = io_master_finish; // @[SLR0_Mem.scala 60:33]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = io_node_num; // @[SLR0_Mem.scala 61:33]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull_state; // @[SLR0_Mem.scala 62:33]
  assign copy_offset_CSR_R_offset_clock = clock;
  assign copy_offset_CSR_R_offset_reset = reset;
  assign copy_offset_CSR_R_offset_io_in = _T; // @[SLR0_Mem.scala 64:36]
  assign copy_offset_CSR_C_offset_clock = clock;
  assign copy_offset_CSR_C_offset_reset = reset;
  assign copy_offset_CSR_C_offset_io_in = _T_1; // @[SLR0_Mem.scala 65:36]
  assign copy_offset_CSC_R_offset_clock = clock;
  assign copy_offset_CSC_R_offset_reset = reset;
  assign copy_offset_CSC_R_offset_io_in = _T_2; // @[SLR0_Mem.scala 66:36]
  assign copy_offset_CSC_C_offset_clock = clock;
  assign copy_offset_CSC_C_offset_reset = reset;
  assign copy_offset_CSC_C_offset_io_in = _T_3; // @[SLR0_Mem.scala 67:36]
  assign copy_offset_level_offset_clock = clock;
  assign copy_offset_level_offset_reset = reset;
  assign copy_offset_level_offset_io_in = _T_4; // @[SLR0_Mem.scala 68:36]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_offsets_CSR_R_offset;
    _T_1 <= io_offsets_CSR_C_offset;
    _T_2 <= io_offsets_CSC_R_offset;
    _T_3 <= io_offsets_CSC_C_offset;
    _T_4 <= io_offsets_level_offset;
  end
endmodule
module copy_pipe(
  input   clock,
  input   reset,
  input   io_in,
  output  io_out_0,
  output  io_out_1,
  output  io_out_2,
  output  io_out_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg  out_reg_0; // @[master.scala 189:24]
  reg  out_reg_1; // @[master.scala 189:24]
  reg  out_reg_2; // @[master.scala 189:24]
  reg  out_reg_3; // @[master.scala 189:24]
  wire  _T_0 = 1'h0; // @[master.scala 189:32 master.scala 189:32]
  wire  _T_1 = 1'h0; // @[master.scala 189:32 master.scala 189:32]
  wire  _T_2 = 1'h0; // @[master.scala 189:32 master.scala 189:32]
  wire  _T_3 = 1'h0; // @[master.scala 189:32 master.scala 189:32]
  assign io_out_0 = out_reg_0; // @[master.scala 194:10]
  assign io_out_1 = out_reg_1; // @[master.scala 194:10]
  assign io_out_2 = out_reg_2; // @[master.scala 194:10]
  assign io_out_3 = out_reg_3; // @[master.scala 194:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 1'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 1'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 1'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 1'h0;
    end else begin
      out_reg_3 <= io_in;
    end
  end
endmodule
module copy_pipe_3(
  input         clock,
  input         reset,
  input  [31:0] io_in,
  output [31:0] io_out_0,
  output [31:0] io_out_1,
  output [31:0] io_out_2,
  output [31:0] io_out_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] out_reg_0; // @[master.scala 189:24]
  reg [31:0] out_reg_1; // @[master.scala 189:24]
  reg [31:0] out_reg_2; // @[master.scala 189:24]
  reg [31:0] out_reg_3; // @[master.scala 189:24]
  wire [31:0] _T_0 = 32'h0; // @[master.scala 189:32 master.scala 189:32]
  wire [31:0] _T_1 = 32'h0; // @[master.scala 189:32 master.scala 189:32]
  wire [31:0] _T_2 = 32'h0; // @[master.scala 189:32 master.scala 189:32]
  wire [31:0] _T_3 = 32'h0; // @[master.scala 189:32 master.scala 189:32]
  assign io_out_0 = out_reg_0; // @[master.scala 194:10]
  assign io_out_1 = out_reg_1; // @[master.scala 194:10]
  assign io_out_2 = out_reg_2; // @[master.scala 194:10]
  assign io_out_3 = out_reg_3; // @[master.scala 194:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 32'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 32'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 32'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 32'h0;
    end else begin
      out_reg_3 <= io_in;
    end
  end
endmodule
module p1_read_frontier_or_visited_map(
  input         clock,
  input         reset,
  input         io_start,
  input  [31:0] io_node_num,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  reg [1:0] stateReg; // @[p1.scala 66:27]
  reg [31:0] count; // @[p1.scala 69:24]
  reg [31:0] _T; // @[p1.scala 70:34]
  wire [32:0] _T_1 = _T - 32'h1; // @[p1.scala 70:48]
  wire [31:0] _T_2 = _T - 32'h1; // @[p1.scala 70:48]
  wire [26:0] _GEN_19 = _T_2[31:5]; // @[p1.scala 70:55]
  wire [31:0] _T_3 = {{5'd0}, _T_2[31:5]}; // @[p1.scala 70:55]
  wire [32:0] _T_4 = _T_3 + 32'h1; // @[p1.scala 70:77]
  wire [31:0] _T_5 = _T_3 + 32'h1; // @[p1.scala 70:77]
  reg [31:0] size; // @[p1.scala 70:24]
  reg [4:0] delay_for_end; // @[p1.scala 72:32]
  wire  _T_6 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_0 = io_start ? 32'h0 : count; // @[p1.scala 80:27]
  wire [1:0] _GEN_1 = io_start ? 2'h1 : stateReg; // @[p1.scala 80:27]
  wire  _T_7 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_8 = count + 32'h1; // @[p1.scala 91:32]
  wire [31:0] _T_9 = count + 32'h1; // @[p1.scala 91:32]
  wire [32:0] _T_10 = size - 32'h1; // @[p1.scala 92:37]
  wire [31:0] _T_11 = size - 32'h1; // @[p1.scala 92:37]
  wire  _T_12 = count == _T_11; // @[p1.scala 92:28]
  wire [1:0] _GEN_2 = _T_12 ? 2'h2 : 2'h1; // @[p1.scala 92:43]
  wire [31:0] _GEN_3 = io_frontier_count_ready ? _T_9 : count; // @[p1.scala 90:42]
  wire [1:0] _GEN_4 = io_frontier_count_ready ? _GEN_2 : stateReg; // @[p1.scala 90:42]
  wire  _T_13 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [5:0] _T_14 = delay_for_end + 5'h1; // @[p1.scala 104:44]
  wire [4:0] _T_15 = delay_for_end + 5'h1; // @[p1.scala 104:44]
  wire  _T_16 = delay_for_end == 5'ha; // @[p1.scala 105:32]
  wire [4:0] _GEN_5 = _T_16 ? 5'h0 : _T_15; // @[p1.scala 105:41]
  wire [1:0] _GEN_6 = _T_16 ? 2'h0 : stateReg; // @[p1.scala 105:41]
  wire [4:0] _GEN_7 = _T_13 ? _GEN_5 : delay_for_end; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_8 = _T_13 ? _GEN_6 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_9 = _T_7; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_10 = count; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_11 = _T_7 ? _GEN_3 : count; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_12 = _T_7 ? _GEN_4 : _GEN_8; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_13 = _T_7 ? delay_for_end : _GEN_7; // @[Conditional.scala 39:67]
  wire  _GEN_14 = _T_6 ? 1'h0 : _T_7; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_15 = count; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_16 = _T_6 ? 5'h0 : _GEN_13; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_17 = _T_6 ? _GEN_0 : _GEN_11; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_18 = _T_6 ? _GEN_1 : _GEN_12; // @[Conditional.scala 40:58]
  assign io_frontier_count_valid = _T_6 ? 1'h0 : _T_7; // @[p1.scala 59:29 p1.scala 77:37 p1.scala 88:37]
  assign io_frontier_count_bits = count; // @[p1.scala 89:36]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  count = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  size = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  delay_for_end = _RAND_4[4:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_6) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_7) begin
      if (io_frontier_count_ready) begin
        if (_T_12) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h1;
        end
      end
    end else if (_T_13) begin
      if (_T_16) begin
        stateReg <= 2'h0;
      end
    end
    if (reset) begin
      count <= 32'h0;
    end else if (_T_6) begin
      if (io_start) begin
        count <= 32'h0;
      end
    end else if (_T_7) begin
      if (io_frontier_count_ready) begin
        count <= _T_9;
      end
    end
    _T <= io_node_num;
    size <= _T_3 + 32'h1;
    if (reset) begin
      delay_for_end <= 5'h0;
    end else if (_T_6) begin
      delay_for_end <= 5'h0;
    end else if (!(_T_7)) begin
      if (_T_13) begin
        if (_T_16) begin
          delay_for_end <= 5'h0;
        end else begin
          delay_for_end <= _T_15;
        end
      end
    end
  end
endmodule
module Queue_448(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [1:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:1]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire  ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire  ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg  _T; // @[Counter.scala 29:33]
  reg  _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T; // @[Counter.scala 38:24]
  wire [1:0] _T_7 = _T + 1'h1; // @[Counter.scala 39:22]
  wire  _T_8 = _T + 1'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire  _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1; // @[Counter.scala 38:24]
  wire [1:0] _T_10 = _T_1 + 1'h1; // @[Counter.scala 39:22]
  wire  _T_11 = _T_1 + 1'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire  _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_18 = _T_17 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 1'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 1'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_450(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [5:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:31]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg [4:0] _T; // @[Counter.scala 29:33]
  reg [4:0] _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_7 = _T + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_8 = _T + 5'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire [4:0] _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [4:0] _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1 == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_10 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_11 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire [4:0] _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [5:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire [4:0] ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [5:0] _T_18 = _T_17 ? 6'h20 : 6'h0; // @[Decoupled.scala 259:20]
  wire [5:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [5:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [5:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 32; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[4:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[4:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 5'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 5'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module find_one_8(
  input        clock,
  input        reset,
  input  [7:0] io_data,
  output [2:0] io_loc
);
  wire [3:0] _T = io_data[3:0]; // @[find_one.scala 53:26]
  wire  loc_2 = io_data[3:0] == 4'h0; // @[find_one.scala 53:17]
  wire [3:0] _T_1 = io_data[7:4]; // @[find_one.scala 54:33]
  wire [3:0] _T_2 = io_data[3:0]; // @[find_one.scala 54:47]
  wire [3:0] data_4 = loc_2 ? io_data[7:4] : io_data[3:0]; // @[find_one.scala 54:18]
  wire [3:0] _T_3 = data_4; // @[find_one.scala 49:22 find_one.scala 54:12]
  wire [1:0] _T_4 = data_4[1:0]; // @[find_one.scala 56:24]
  wire  loc_1 = data_4[1:0] == 2'h0; // @[find_one.scala 56:17]
  wire [1:0] _T_5 = data_4[3:2]; // @[find_one.scala 57:32]
  wire [1:0] _T_6 = data_4[1:0]; // @[find_one.scala 57:45]
  wire [1:0] data_2 = loc_1 ? data_4[3:2] : data_4[1:0]; // @[find_one.scala 57:18]
  wire [1:0] _T_7 = data_2; // @[find_one.scala 50:22 find_one.scala 57:12]
  wire  _T_8 = data_2[0]; // @[find_one.scala 58:24]
  wire  loc_0 = ~data_2[0]; // @[find_one.scala 58:17]
  wire [1:0] _T_9 = {loc_2,loc_1}; // @[Cat.scala 29:58]
  wire [2:0] _T_10 = {loc_2,loc_1,loc_0}; // @[Cat.scala 29:58]
  assign io_loc = {_T_9,loc_0}; // @[find_one.scala 59:12]
endmodule
module find_one_16(
  input         clock,
  input         reset,
  input  [15:0] io_data,
  output [3:0]  io_loc
);
  wire  one_0_clock; // @[find_one.scala 70:23]
  wire  one_0_reset; // @[find_one.scala 70:23]
  wire [7:0] one_0_io_data; // @[find_one.scala 70:23]
  wire [2:0] one_0_io_loc; // @[find_one.scala 70:23]
  wire  one_1_clock; // @[find_one.scala 71:23]
  wire  one_1_reset; // @[find_one.scala 71:23]
  wire [7:0] one_1_io_data; // @[find_one.scala 71:23]
  wire [2:0] one_1_io_loc; // @[find_one.scala 71:23]
  wire [7:0] _T = io_data[7:0]; // @[find_one.scala 73:29]
  wire [7:0] _T_1 = io_data[15:8]; // @[find_one.scala 74:29]
  wire [7:0] _T_2 = io_data[7:0]; // @[find_one.scala 76:27]
  wire  _T_3 = io_data[7:0] == 8'h0; // @[find_one.scala 76:19]
  wire [3:0] _T_4 = {1'h1,one_1_io_loc}; // @[Cat.scala 29:58]
  wire [3:0] _T_5 = {1'h0,one_0_io_loc}; // @[Cat.scala 29:58]
  wire [3:0] _T_6 = _T_3 ? _T_4 : _T_5; // @[find_one.scala 76:18]
  find_one_8 one_0 ( // @[find_one.scala 70:23]
    .clock(one_0_clock),
    .reset(one_0_reset),
    .io_data(one_0_io_data),
    .io_loc(one_0_io_loc)
  );
  find_one_8 one_1 ( // @[find_one.scala 71:23]
    .clock(one_1_clock),
    .reset(one_1_reset),
    .io_data(one_1_io_data),
    .io_loc(one_1_io_loc)
  );
  assign io_loc = _T_3 ? _T_4 : _T_5; // @[find_one.scala 76:12]
  assign one_0_clock = clock;
  assign one_0_reset = reset;
  assign one_0_io_data = io_data[7:0]; // @[find_one.scala 73:19]
  assign one_1_clock = clock;
  assign one_1_reset = reset;
  assign one_1_io_data = io_data[15:8]; // @[find_one.scala 74:19]
endmodule
module find_one_32(
  input         clock,
  input         reset,
  input  [31:0] io_data,
  output [4:0]  io_loc
);
  wire  one_0_clock; // @[find_one.scala 86:23]
  wire  one_0_reset; // @[find_one.scala 86:23]
  wire [15:0] one_0_io_data; // @[find_one.scala 86:23]
  wire [3:0] one_0_io_loc; // @[find_one.scala 86:23]
  wire  one_1_clock; // @[find_one.scala 87:23]
  wire  one_1_reset; // @[find_one.scala 87:23]
  wire [15:0] one_1_io_data; // @[find_one.scala 87:23]
  wire [3:0] one_1_io_loc; // @[find_one.scala 87:23]
  wire [15:0] _T = io_data[15:0]; // @[find_one.scala 89:29]
  wire [15:0] _T_1 = io_data[31:16]; // @[find_one.scala 90:29]
  wire [15:0] _T_2 = io_data[15:0]; // @[find_one.scala 92:27]
  wire  _T_3 = io_data[15:0] == 16'h0; // @[find_one.scala 92:19]
  wire [4:0] _T_4 = {1'h1,one_1_io_loc}; // @[Cat.scala 29:58]
  wire [4:0] _T_5 = {1'h0,one_0_io_loc}; // @[Cat.scala 29:58]
  wire [4:0] _T_6 = _T_3 ? _T_4 : _T_5; // @[find_one.scala 92:18]
  find_one_16 one_0 ( // @[find_one.scala 86:23]
    .clock(one_0_clock),
    .reset(one_0_reset),
    .io_data(one_0_io_data),
    .io_loc(one_0_io_loc)
  );
  find_one_16 one_1 ( // @[find_one.scala 87:23]
    .clock(one_1_clock),
    .reset(one_1_reset),
    .io_data(one_1_io_data),
    .io_loc(one_1_io_loc)
  );
  assign io_loc = _T_3 ? _T_4 : _T_5; // @[find_one.scala 92:12]
  assign one_0_clock = clock;
  assign one_0_reset = reset;
  assign one_0_io_data = io_data[15:0]; // @[find_one.scala 89:19]
  assign one_1_clock = clock;
  assign one_1_reset = reset;
  assign one_1_io_data = io_data[31:16]; // @[find_one.scala 90:19]
endmodule
module read_R_array_index(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = {{1'd0}, _T_232}; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_233[38:0]; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_233[38:0]; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_233[38:0]; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_233[38:0]; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_233[38:0]; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_233[38:0]; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_233[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Queue_453(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [63:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [63:0] io_deq_bits,
  output [5:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [63:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [63:0] ram [0:31]; // @[Decoupled.scala 218:16]
  wire [63:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [63:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [4:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [4:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_4 = enq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_5 = enq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [4:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [63:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [4:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_6 = deq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_7 = deq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [4:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [5:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [4:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [5:0] _T_14 = _T_13 ? 6'h20 : 6'h0; // @[Decoupled.scala 259:20]
  wire [5:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [5:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [5:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {2{`RANDOM}};
  for (initvar = 0; initvar < 32; initvar = initvar+1)
    ram[initvar] = _RAND_0[63:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[4:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[4:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 5'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 5'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module p2_read_visited_map_or_frontier(
  input         clock,
  input         reset,
  output        io_neighbours_ready,
  input         io_neighbours_valid,
  input  [63:0] io_neighbours_bits,
  input         io_push_or_pull_state,
  input         io_neighbours_out_ready,
  output        io_neighbours_out_valid,
  output [63:0] io_neighbours_out_bits,
  input         io_bram_to_frontier_ready,
  output        io_bram_to_frontier_valid,
  output [18:0] io_bram_to_frontier_bits
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  q_neighbour_clock; // @[p2.scala 155:29]
  wire  q_neighbour_reset; // @[p2.scala 155:29]
  wire  q_neighbour_io_enq_ready; // @[p2.scala 155:29]
  wire  q_neighbour_io_enq_valid; // @[p2.scala 155:29]
  wire [63:0] q_neighbour_io_enq_bits; // @[p2.scala 155:29]
  wire  q_neighbour_io_deq_ready; // @[p2.scala 155:29]
  wire  q_neighbour_io_deq_valid; // @[p2.scala 155:29]
  wire [63:0] q_neighbour_io_deq_bits; // @[p2.scala 155:29]
  wire [5:0] q_neighbour_io_count; // @[p2.scala 155:29]
  wire  q_neighbours_out_clock; // @[p2.scala 160:34]
  wire  q_neighbours_out_reset; // @[p2.scala 160:34]
  wire  q_neighbours_out_io_enq_ready; // @[p2.scala 160:34]
  wire  q_neighbours_out_io_enq_valid; // @[p2.scala 160:34]
  wire [63:0] q_neighbours_out_io_enq_bits; // @[p2.scala 160:34]
  wire  q_neighbours_out_io_deq_ready; // @[p2.scala 160:34]
  wire  q_neighbours_out_io_deq_valid; // @[p2.scala 160:34]
  wire [63:0] q_neighbours_out_io_deq_bits; // @[p2.scala 160:34]
  wire [5:0] q_neighbours_out_io_count; // @[p2.scala 160:34]
  reg [31:0] count0; // @[p2.scala 149:25]
  wire  _T = q_neighbour_io_enq_ready & q_neighbours_out_io_enq_ready; // @[p2.scala 163:53]
  wire  _T_1 = io_neighbours_valid & q_neighbours_out_io_enq_ready; // @[p2.scala 164:53]
  wire  _T_2 = io_neighbours_valid & q_neighbour_io_enq_ready; // @[p2.scala 176:58]
  wire  _T_4 = io_bram_to_frontier_ready & q_neighbour_io_deq_valid; // @[p2.scala 244:36]
  wire [23:0] _T_7 = q_neighbour_io_deq_bits[47:24]; // @[p2.scala 425:10]
  wire [16:0] _T_8 = q_neighbour_io_deq_bits[47:31]; // @[p2.scala 254:87]
  wire [16:0] _GEN_2 = _T_4 ? q_neighbour_io_deq_bits[47:31] : 17'h0; // @[p2.scala 244:64]
  wire [17:0] bram_to_frontier_addra = {{1'd0}, _GEN_2}; // @[p2.scala 207:38 p2.scala 221:28 p2.scala 254:36]
  wire  _T_5 = ~io_push_or_pull_state; // @[p2.scala 248:70]
  wire  _T_6 = _T_5; // @[p2.scala 248:44]
  wire  bram_to_frontier_wea = _T_4 & _T_5; // @[p2.scala 244:64]
  wire  _GEN_1 = bram_to_frontier_wea; // @[p2.scala 209:36 p2.scala 219:26 p2.scala 248:34]
  wire [18:0] bram_to_frontier = {bram_to_frontier_addra,bram_to_frontier_wea}; // @[Cat.scala 29:58]
  wire  _GEN_0 = _T_4; // @[p2.scala 244:64]
  wire [18:0] _T_3 = bram_to_frontier; // @[p2.scala 215:32 p2.scala 228:22]
  Queue_453 q_neighbour ( // @[p2.scala 155:29]
    .clock(q_neighbour_clock),
    .reset(q_neighbour_reset),
    .io_enq_ready(q_neighbour_io_enq_ready),
    .io_enq_valid(q_neighbour_io_enq_valid),
    .io_enq_bits(q_neighbour_io_enq_bits),
    .io_deq_ready(q_neighbour_io_deq_ready),
    .io_deq_valid(q_neighbour_io_deq_valid),
    .io_deq_bits(q_neighbour_io_deq_bits),
    .io_count(q_neighbour_io_count)
  );
  Queue_453 q_neighbours_out ( // @[p2.scala 160:34]
    .clock(q_neighbours_out_clock),
    .reset(q_neighbours_out_reset),
    .io_enq_ready(q_neighbours_out_io_enq_ready),
    .io_enq_valid(q_neighbours_out_io_enq_valid),
    .io_enq_bits(q_neighbours_out_io_enq_bits),
    .io_deq_ready(q_neighbours_out_io_deq_ready),
    .io_deq_valid(q_neighbours_out_io_deq_valid),
    .io_deq_bits(q_neighbours_out_io_deq_bits),
    .io_count(q_neighbours_out_io_count)
  );
  assign io_neighbours_ready = q_neighbour_io_enq_ready & q_neighbours_out_io_enq_ready; // @[p2.scala 163:25]
  assign io_neighbours_out_valid = q_neighbours_out_io_deq_valid; // @[p2.scala 178:23]
  assign io_neighbours_out_bits = q_neighbours_out_io_deq_bits; // @[p2.scala 178:23]
  assign io_bram_to_frontier_valid = io_bram_to_frontier_ready & q_neighbour_io_deq_valid; // @[p2.scala 231:31 p2.scala 246:39 p2.scala 257:35]
  assign io_bram_to_frontier_bits = {bram_to_frontier_addra,bram_to_frontier_wea}; // @[p2.scala 230:30]
  assign q_neighbour_clock = clock;
  assign q_neighbour_reset = reset;
  assign q_neighbour_io_enq_valid = io_neighbours_valid & q_neighbours_out_io_enq_ready; // @[p2.scala 164:30]
  assign q_neighbour_io_enq_bits = io_neighbours_bits; // @[p2.scala 165:29]
  assign q_neighbour_io_deq_ready = io_bram_to_frontier_ready & q_neighbour_io_deq_valid; // @[p2.scala 172:30 p2.scala 245:38]
  assign q_neighbours_out_clock = clock;
  assign q_neighbours_out_reset = reset;
  assign q_neighbours_out_io_enq_valid = io_neighbours_valid & q_neighbour_io_enq_ready; // @[p2.scala 176:35]
  assign q_neighbours_out_io_enq_bits = io_neighbours_bits; // @[p2.scala 177:34]
  assign q_neighbours_out_io_deq_ready = io_neighbours_out_ready; // @[p2.scala 178:23]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  count0 = _RAND_0[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    count0 <= 32'h0;
  end
endmodule
module write_frontier_and_level(
  input         clock,
  input         reset,
  output        io_visited_map_or_frontier_ready,
  input         io_visited_map_or_frontier_valid,
  input         io_visited_map_or_frontier_bits,
  output        io_neighbours_ready,
  input         io_neighbours_valid,
  input  [63:0] io_neighbours_bits,
  input         io_push_or_pull_state,
  input         io_write_frontier_ready,
  output        io_write_frontier_valid,
  output [31:0] io_write_frontier_bits,
  output [31:0] io_p2_count,
  output [31:0] io_p2_pull_count
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] count0; // @[p2.scala 337:25]
  wire  _T = io_write_frontier_ready & io_write_frontier_valid; // @[p2.scala 339:58]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  wire  _T_5 = io_neighbours_valid & io_write_frontier_ready; // @[p2.scala 363:31]
  wire  _T_6 = ~io_visited_map_or_frontier_bits; // @[p2.scala 369:50]
  wire  _T_7 = ~io_push_or_pull_state; // @[p2.scala 369:83]
  wire  _T_8 = _T_6 & _T_7; // @[p2.scala 369:58]
  wire [23:0] _T_9 = io_neighbours_bits[47:24]; // @[p2.scala 425:10]
  wire  _GEN_3 = _T_8; // @[p2.scala 369:91]
  wire [23:0] _GEN_4 = io_neighbours_bits[47:24]; // @[p2.scala 369:91]
  wire  _T_10 = io_visited_map_or_frontier_bits; // @[p2.scala 378:50]
  wire  _T_11 = io_push_or_pull_state; // @[p2.scala 378:83]
  wire  _T_12 = io_visited_map_or_frontier_bits & io_push_or_pull_state; // @[p2.scala 378:58]
  wire [23:0] _T_13 = io_neighbours_bits[23:0]; // @[p2.scala 428:10]
  wire  _GEN_5 = _T_12 | _T_8; // @[p2.scala 378:91]
  wire [23:0] _GEN_6 = _T_12 ? io_neighbours_bits[23:0] : io_neighbours_bits[47:24]; // @[p2.scala 378:91]
  wire [32:0] _T_14 = count0 + 32'h1; // @[p2.scala 386:30]
  wire [31:0] _T_15 = count0 + 32'h1; // @[p2.scala 386:30]
  wire  _GEN_7 = io_visited_map_or_frontier_valid; // @[p2.scala 365:47]
  wire  _GEN_8 = io_visited_map_or_frontier_valid & _GEN_5; // @[p2.scala 365:47]
  wire [23:0] _GEN_9 = _GEN_6; // @[p2.scala 365:47]
  wire [31:0] _GEN_10 = io_visited_map_or_frontier_valid ? _T_15 : count0; // @[p2.scala 365:47]
  wire  _GEN_11 = _T_5; // @[p2.scala 363:58]
  wire  _GEN_12 = _T_5 & io_visited_map_or_frontier_valid; // @[p2.scala 363:58]
  wire  _GEN_13 = _T_5 & _GEN_8; // @[p2.scala 363:58]
  wire [23:0] _GEN_14 = _GEN_6; // @[p2.scala 363:58]
  wire [31:0] _GEN_15 = _T_5 ? _GEN_10 : count0; // @[p2.scala 363:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [23:0] _GEN_16 = _T_12 ? io_neighbours_bits[23:0] : io_neighbours_bits[47:24]; // @[p2.scala 375:40 p2.scala 384:40]
  assign io_visited_map_or_frontier_ready = io_neighbours_valid & io_write_frontier_ready; // @[p2.scala 327:38 p2.scala 364:42]
  assign io_neighbours_ready = _T_5 & io_visited_map_or_frontier_valid; // @[p2.scala 329:25 p2.scala 367:33]
  assign io_write_frontier_valid = _T_5 & _GEN_8; // @[p2.scala 331:29 p2.scala 373:41 p2.scala 382:41]
  assign io_write_frontier_bits = {{8'd0}, _GEN_6}; // @[p2.scala 375:40 p2.scala 384:40]
  assign io_p2_count = count0; // @[p2.scala 341:17]
  assign io_p2_pull_count = {{1'd0}, count_wf0}; // @[p2.scala 342:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  count0 = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  count_wf0 = _RAND_1[30:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      count0 <= 32'h0;
    end else if (_T_5) begin
      if (io_visited_map_or_frontier_valid) begin
        count0 <= _T_15;
      end
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
  end
endmodule
module Queue_455(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [18:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [18:0] io_deq_bits,
  output [1:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [18:0] ram [0:1]; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire  ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire  ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg  _T; // @[Counter.scala 29:33]
  reg  _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T; // @[Counter.scala 38:24]
  wire [1:0] _T_7 = _T + 1'h1; // @[Counter.scala 39:22]
  wire  _T_8 = _T + 1'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire  _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [18:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1; // @[Counter.scala 38:24]
  wire [1:0] _T_10 = _T_1 + 1'h1; // @[Counter.scala 39:22]
  wire  _T_11 = _T_1 + 1'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire  _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_18 = _T_17 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram[initvar] = _RAND_0[18:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 1'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 1'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_457(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [18:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [18:0] io_deq_bits,
  output [2:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [18:0] ram [0:3]; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire [1:0] ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire [1:0] ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg [1:0] _T; // @[Counter.scala 29:33]
  reg [1:0] _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T == 2'h3; // @[Counter.scala 38:24]
  wire [2:0] _T_7 = _T + 2'h1; // @[Counter.scala 39:22]
  wire [1:0] _T_8 = _T + 2'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire [1:0] _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [18:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [1:0] _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1 == 2'h3; // @[Counter.scala 38:24]
  wire [2:0] _T_10 = _T_1 + 2'h1; // @[Counter.scala 39:22]
  wire [1:0] _T_11 = _T_1 + 2'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire [1:0] _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [2:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire [1:0] ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [2:0] _T_18 = _T_17 ? 3'h4 : 3'h0; // @[Decoupled.scala 259:20]
  wire [2:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [2:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [2:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 4; initvar = initvar+1)
    ram[initvar] = _RAND_0[18:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[1:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[1:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 2'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 2'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_458(
  input        clock,
  input        reset,
  output       io_enq_ready,
  input        io_enq_valid,
  input        io_enq_bits,
  input        io_deq_ready,
  output       io_deq_valid,
  output       io_deq_bits,
  output [1:0] io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg  ram [0:1]; // @[Decoupled.scala 218:16]
  wire  ram__T_11_data; // @[Decoupled.scala 218:16]
  wire  ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_data; // @[Decoupled.scala 218:16]
  wire  ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg  enq_ptr_value; // @[Counter.scala 29:33]
  reg  deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_4 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_5 = enq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire  _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire  _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire  _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value; // @[Counter.scala 38:24]
  wire [1:0] _T_6 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_7 = deq_ptr_value + 1'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire  _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [1:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [1:0] _T_14 = _T_13 ? 2'h2 : 2'h0; // @[Decoupled.scala 259:20]
  wire [1:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [1:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [1:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 2; initvar = initvar+1)
    ram[initvar] = _RAND_0[0:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 1'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 1'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_460(
  input        clock,
  input        reset,
  output       io_enq_ready,
  input        io_enq_valid,
  input        io_enq_bits,
  input        io_deq_ready,
  output       io_deq_valid,
  output       io_deq_bits,
  output [5:0] io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg  ram [0:31]; // @[Decoupled.scala 218:16]
  wire  ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [4:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [4:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_4 = enq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_5 = enq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [4:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire  _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [4:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_6 = deq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_7 = deq_ptr_value + 5'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [4:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [5:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [4:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [5:0] _T_14 = _T_13 ? 6'h20 : 6'h0; // @[Decoupled.scala 259:20]
  wire [5:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [5:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [5:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 32; initvar = initvar+1)
    ram[initvar] = _RAND_0[0:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[4:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[4:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 5'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 5'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Queue_461(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [63:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [63:0] io_deq_bits,
  output [5:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [63:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [63:0] ram [0:31]; // @[Decoupled.scala 218:16]
  wire [63:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [63:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg [4:0] _T; // @[Counter.scala 29:33]
  reg [4:0] _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_7 = _T + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_8 = _T + 5'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire [4:0] _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [63:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [4:0] _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1 == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_10 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_11 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire [4:0] _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [5:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire [4:0] ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [5:0] _T_18 = _T_17 ? 6'h20 : 6'h0; // @[Decoupled.scala 259:20]
  wire [5:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [5:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [5:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {2{`RANDOM}};
  for (initvar = 0; initvar < 32; initvar = initvar+1)
    ram[initvar] = _RAND_0[63:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[4:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[4:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 5'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 5'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module P2(
  input         clock,
  input         reset,
  output        io_neighbours_ready,
  input         io_neighbours_valid,
  input  [63:0] io_neighbours_bits,
  input         io_push_or_pull_state,
  output        io_visited_map_or_frontier_ready,
  input         io_visited_map_or_frontier_valid,
  input         io_visited_map_or_frontier_bits,
  output [31:0] io_p2_count,
  output [31:0] io_p2_pull_count,
  input         io_write_frontier_ready,
  output        io_write_frontier_valid,
  output [31:0] io_write_frontier_bits,
  input         io_bram_to_frontier_ready,
  output        io_bram_to_frontier_valid,
  output [18:0] io_bram_to_frontier_bits
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
`endif // RANDOMIZE_REG_INIT
  wire  p2_read_visited_map_or_frontier_clock; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_reset; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_neighbours_ready; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_neighbours_valid; // @[p2.scala 33:49]
  wire [63:0] p2_read_visited_map_or_frontier_io_neighbours_bits; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_push_or_pull_state; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_neighbours_out_ready; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_neighbours_out_valid; // @[p2.scala 33:49]
  wire [63:0] p2_read_visited_map_or_frontier_io_neighbours_out_bits; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_bram_to_frontier_ready; // @[p2.scala 33:49]
  wire  p2_read_visited_map_or_frontier_io_bram_to_frontier_valid; // @[p2.scala 33:49]
  wire [18:0] p2_read_visited_map_or_frontier_io_bram_to_frontier_bits; // @[p2.scala 33:49]
  wire  write_frontier_and_level_clock; // @[p2.scala 34:42]
  wire  write_frontier_and_level_reset; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_visited_map_or_frontier_ready; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_visited_map_or_frontier_valid; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_visited_map_or_frontier_bits; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_neighbours_ready; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_neighbours_valid; // @[p2.scala 34:42]
  wire [63:0] write_frontier_and_level_io_neighbours_bits; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_push_or_pull_state; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_write_frontier_ready; // @[p2.scala 34:42]
  wire  write_frontier_and_level_io_write_frontier_valid; // @[p2.scala 34:42]
  wire [31:0] write_frontier_and_level_io_write_frontier_bits; // @[p2.scala 34:42]
  wire [31:0] write_frontier_and_level_io_p2_count; // @[p2.scala 34:42]
  wire [31:0] write_frontier_and_level_io_p2_pull_count; // @[p2.scala 34:42]
  wire  q_bram_to_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] q_bram_to_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] q_bram_to_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_bram_to_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] q_bram_to_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_bram_to_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] q_bram_to_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_bram_to_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  Queue_clock; // @[Decoupled.scala 296:21]
  wire  Queue_reset; // @[Decoupled.scala 296:21]
  wire  Queue_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  Queue_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] Queue_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  Queue_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  Queue_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] Queue_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [2:0] Queue_io_count; // @[Decoupled.scala 296:21]
  wire  q_visited_map_or_frontier_l1_clock; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_reset; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_enq_ready; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_enq_valid; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_enq_bits; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_deq_ready; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_deq_valid; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l1_io_deq_bits; // @[p2.scala 82:46]
  wire [1:0] q_visited_map_or_frontier_l1_io_count; // @[p2.scala 82:46]
  wire  q_visited_map_or_frontier_l2_clock; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_reset; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_enq_ready; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_enq_valid; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_enq_bits; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_deq_ready; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_deq_valid; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_l2_io_deq_bits; // @[p2.scala 83:46]
  wire [1:0] q_visited_map_or_frontier_l2_io_count; // @[p2.scala 83:46]
  wire  q_visited_map_or_frontier_clock; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_reset; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_enq_ready; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_enq_valid; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_enq_bits; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_deq_ready; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_deq_valid; // @[p2.scala 88:43]
  wire  q_visited_map_or_frontier_io_deq_bits; // @[p2.scala 88:43]
  wire [5:0] q_visited_map_or_frontier_io_count; // @[p2.scala 88:43]
  wire  Queue_1_clock; // @[Decoupled.scala 296:21]
  wire  Queue_1_reset; // @[Decoupled.scala 296:21]
  wire  Queue_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  Queue_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [63:0] Queue_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  Queue_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  Queue_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [63:0] Queue_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] Queue_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p2.scala 53:69]
  wire  _T_1 = ~write_frontier_and_level_io_visited_map_or_frontier_ready; // @[p2.scala 99:7]
  wire  _T_2 = ~_T_1; // @[p2.scala 99:5]
  wire  _T_3 = ~q_visited_map_or_frontier_io_deq_valid; // @[p2.scala 100:68]
  wire  _T_4 = ~_T_3; // @[p2.scala 100:66]
  reg  _T_5; // @[p2.scala 118:62]
  p2_read_visited_map_or_frontier p2_read_visited_map_or_frontier ( // @[p2.scala 33:49]
    .clock(p2_read_visited_map_or_frontier_clock),
    .reset(p2_read_visited_map_or_frontier_reset),
    .io_neighbours_ready(p2_read_visited_map_or_frontier_io_neighbours_ready),
    .io_neighbours_valid(p2_read_visited_map_or_frontier_io_neighbours_valid),
    .io_neighbours_bits(p2_read_visited_map_or_frontier_io_neighbours_bits),
    .io_push_or_pull_state(p2_read_visited_map_or_frontier_io_push_or_pull_state),
    .io_neighbours_out_ready(p2_read_visited_map_or_frontier_io_neighbours_out_ready),
    .io_neighbours_out_valid(p2_read_visited_map_or_frontier_io_neighbours_out_valid),
    .io_neighbours_out_bits(p2_read_visited_map_or_frontier_io_neighbours_out_bits),
    .io_bram_to_frontier_ready(p2_read_visited_map_or_frontier_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(p2_read_visited_map_or_frontier_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(p2_read_visited_map_or_frontier_io_bram_to_frontier_bits)
  );
  write_frontier_and_level write_frontier_and_level ( // @[p2.scala 34:42]
    .clock(write_frontier_and_level_clock),
    .reset(write_frontier_and_level_reset),
    .io_visited_map_or_frontier_ready(write_frontier_and_level_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(write_frontier_and_level_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(write_frontier_and_level_io_visited_map_or_frontier_bits),
    .io_neighbours_ready(write_frontier_and_level_io_neighbours_ready),
    .io_neighbours_valid(write_frontier_and_level_io_neighbours_valid),
    .io_neighbours_bits(write_frontier_and_level_io_neighbours_bits),
    .io_push_or_pull_state(write_frontier_and_level_io_push_or_pull_state),
    .io_write_frontier_ready(write_frontier_and_level_io_write_frontier_ready),
    .io_write_frontier_valid(write_frontier_and_level_io_write_frontier_valid),
    .io_write_frontier_bits(write_frontier_and_level_io_write_frontier_bits),
    .io_p2_count(write_frontier_and_level_io_p2_count),
    .io_p2_pull_count(write_frontier_and_level_io_p2_pull_count)
  );
  Queue_455 q_bram_to_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_bram_to_frontier_l1_clock),
    .reset(q_bram_to_frontier_l1_reset),
    .io_enq_ready(q_bram_to_frontier_l1_io_enq_ready),
    .io_enq_valid(q_bram_to_frontier_l1_io_enq_valid),
    .io_enq_bits(q_bram_to_frontier_l1_io_enq_bits),
    .io_deq_ready(q_bram_to_frontier_l1_io_deq_ready),
    .io_deq_valid(q_bram_to_frontier_l1_io_deq_valid),
    .io_deq_bits(q_bram_to_frontier_l1_io_deq_bits),
    .io_count(q_bram_to_frontier_l1_io_count)
  );
  Queue_455 q_bram_to_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_bram_to_frontier_l2_clock),
    .reset(q_bram_to_frontier_l2_reset),
    .io_enq_ready(q_bram_to_frontier_l2_io_enq_ready),
    .io_enq_valid(q_bram_to_frontier_l2_io_enq_valid),
    .io_enq_bits(q_bram_to_frontier_l2_io_enq_bits),
    .io_deq_ready(q_bram_to_frontier_l2_io_deq_ready),
    .io_deq_valid(q_bram_to_frontier_l2_io_deq_valid),
    .io_deq_bits(q_bram_to_frontier_l2_io_deq_bits),
    .io_count(q_bram_to_frontier_l2_io_count)
  );
  Queue_457 Queue ( // @[Decoupled.scala 296:21]
    .clock(Queue_clock),
    .reset(Queue_reset),
    .io_enq_ready(Queue_io_enq_ready),
    .io_enq_valid(Queue_io_enq_valid),
    .io_enq_bits(Queue_io_enq_bits),
    .io_deq_ready(Queue_io_deq_ready),
    .io_deq_valid(Queue_io_deq_valid),
    .io_deq_bits(Queue_io_deq_bits),
    .io_count(Queue_io_count)
  );
  Queue_458 q_visited_map_or_frontier_l1 ( // @[p2.scala 82:46]
    .clock(q_visited_map_or_frontier_l1_clock),
    .reset(q_visited_map_or_frontier_l1_reset),
    .io_enq_ready(q_visited_map_or_frontier_l1_io_enq_ready),
    .io_enq_valid(q_visited_map_or_frontier_l1_io_enq_valid),
    .io_enq_bits(q_visited_map_or_frontier_l1_io_enq_bits),
    .io_deq_ready(q_visited_map_or_frontier_l1_io_deq_ready),
    .io_deq_valid(q_visited_map_or_frontier_l1_io_deq_valid),
    .io_deq_bits(q_visited_map_or_frontier_l1_io_deq_bits),
    .io_count(q_visited_map_or_frontier_l1_io_count)
  );
  Queue_458 q_visited_map_or_frontier_l2 ( // @[p2.scala 83:46]
    .clock(q_visited_map_or_frontier_l2_clock),
    .reset(q_visited_map_or_frontier_l2_reset),
    .io_enq_ready(q_visited_map_or_frontier_l2_io_enq_ready),
    .io_enq_valid(q_visited_map_or_frontier_l2_io_enq_valid),
    .io_enq_bits(q_visited_map_or_frontier_l2_io_enq_bits),
    .io_deq_ready(q_visited_map_or_frontier_l2_io_deq_ready),
    .io_deq_valid(q_visited_map_or_frontier_l2_io_deq_valid),
    .io_deq_bits(q_visited_map_or_frontier_l2_io_deq_bits),
    .io_count(q_visited_map_or_frontier_l2_io_count)
  );
  Queue_460 q_visited_map_or_frontier ( // @[p2.scala 88:43]
    .clock(q_visited_map_or_frontier_clock),
    .reset(q_visited_map_or_frontier_reset),
    .io_enq_ready(q_visited_map_or_frontier_io_enq_ready),
    .io_enq_valid(q_visited_map_or_frontier_io_enq_valid),
    .io_enq_bits(q_visited_map_or_frontier_io_enq_bits),
    .io_deq_ready(q_visited_map_or_frontier_io_deq_ready),
    .io_deq_valid(q_visited_map_or_frontier_io_deq_valid),
    .io_deq_bits(q_visited_map_or_frontier_io_deq_bits),
    .io_count(q_visited_map_or_frontier_io_count)
  );
  Queue_461 Queue_1 ( // @[Decoupled.scala 296:21]
    .clock(Queue_1_clock),
    .reset(Queue_1_reset),
    .io_enq_ready(Queue_1_io_enq_ready),
    .io_enq_valid(Queue_1_io_enq_valid),
    .io_enq_bits(Queue_1_io_enq_bits),
    .io_deq_ready(Queue_1_io_deq_ready),
    .io_deq_valid(Queue_1_io_deq_valid),
    .io_deq_bits(Queue_1_io_deq_bits),
    .io_count(Queue_1_io_count)
  );
  assign io_neighbours_ready = p2_read_visited_map_or_frontier_io_neighbours_ready; // @[p2.scala 39:51]
  assign io_visited_map_or_frontier_ready = q_visited_map_or_frontier_l1_io_enq_ready; // @[p2.scala 91:43]
  assign io_p2_count = write_frontier_and_level_io_p2_count; // @[p2.scala 113:17]
  assign io_p2_pull_count = write_frontier_and_level_io_p2_pull_count; // @[p2.scala 114:22]
  assign io_write_frontier_valid = write_frontier_and_level_io_write_frontier_valid; // @[p2.scala 116:23]
  assign io_write_frontier_bits = write_frontier_and_level_io_write_frontier_bits; // @[p2.scala 116:23]
  assign io_bram_to_frontier_valid = Queue_io_deq_valid; // @[p2.scala 50:37]
  assign io_bram_to_frontier_bits = Queue_io_deq_bits; // @[p2.scala 50:37]
  assign p2_read_visited_map_or_frontier_clock = clock;
  assign p2_read_visited_map_or_frontier_reset = reset;
  assign p2_read_visited_map_or_frontier_io_neighbours_valid = io_neighbours_valid; // @[p2.scala 39:51]
  assign p2_read_visited_map_or_frontier_io_neighbours_bits = io_neighbours_bits; // @[p2.scala 39:51]
  assign p2_read_visited_map_or_frontier_io_push_or_pull_state = _T; // @[p2.scala 53:59]
  assign p2_read_visited_map_or_frontier_io_neighbours_out_ready = Queue_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign p2_read_visited_map_or_frontier_io_bram_to_frontier_ready = q_bram_to_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign write_frontier_and_level_clock = clock;
  assign write_frontier_and_level_reset = reset;
  assign write_frontier_and_level_io_visited_map_or_frontier_valid = ~_T_3; // @[p2.scala 100:63]
  assign write_frontier_and_level_io_visited_map_or_frontier_bits = q_visited_map_or_frontier_io_deq_bits; // @[p2.scala 101:62]
  assign write_frontier_and_level_io_neighbours_valid = Queue_1_io_deq_valid; // @[p2.scala 108:44]
  assign write_frontier_and_level_io_neighbours_bits = Queue_1_io_deq_bits; // @[p2.scala 108:44]
  assign write_frontier_and_level_io_push_or_pull_state = _T_5; // @[p2.scala 118:52]
  assign write_frontier_and_level_io_write_frontier_ready = io_write_frontier_ready; // @[p2.scala 116:23]
  assign q_bram_to_frontier_l1_clock = clock;
  assign q_bram_to_frontier_l1_reset = reset;
  assign q_bram_to_frontier_l1_io_enq_valid = p2_read_visited_map_or_frontier_io_bram_to_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_bram_to_frontier_l1_io_enq_bits = p2_read_visited_map_or_frontier_io_bram_to_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_bram_to_frontier_l1_io_deq_ready = q_bram_to_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_bram_to_frontier_l2_clock = clock;
  assign q_bram_to_frontier_l2_reset = reset;
  assign q_bram_to_frontier_l2_io_enq_valid = q_bram_to_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_bram_to_frontier_l2_io_enq_bits = q_bram_to_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_bram_to_frontier_l2_io_deq_ready = Queue_io_enq_ready; // @[Decoupled.scala 299:17]
  assign Queue_clock = clock;
  assign Queue_reset = reset;
  assign Queue_io_enq_valid = q_bram_to_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign Queue_io_enq_bits = q_bram_to_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign Queue_io_deq_ready = io_bram_to_frontier_ready; // @[p2.scala 50:37]
  assign q_visited_map_or_frontier_l1_clock = clock;
  assign q_visited_map_or_frontier_l1_reset = reset;
  assign q_visited_map_or_frontier_l1_io_enq_valid = io_visited_map_or_frontier_valid; // @[p2.scala 91:43]
  assign q_visited_map_or_frontier_l1_io_enq_bits = io_visited_map_or_frontier_bits; // @[p2.scala 91:43]
  assign q_visited_map_or_frontier_l1_io_deq_ready = q_visited_map_or_frontier_l2_io_enq_ready; // @[p2.scala 92:43]
  assign q_visited_map_or_frontier_l2_clock = clock;
  assign q_visited_map_or_frontier_l2_reset = reset;
  assign q_visited_map_or_frontier_l2_io_enq_valid = q_visited_map_or_frontier_l1_io_deq_valid; // @[p2.scala 92:43]
  assign q_visited_map_or_frontier_l2_io_enq_bits = q_visited_map_or_frontier_l1_io_deq_bits; // @[p2.scala 92:43]
  assign q_visited_map_or_frontier_l2_io_deq_ready = q_visited_map_or_frontier_io_enq_ready; // @[p2.scala 93:43]
  assign q_visited_map_or_frontier_clock = clock;
  assign q_visited_map_or_frontier_reset = reset;
  assign q_visited_map_or_frontier_io_enq_valid = q_visited_map_or_frontier_l2_io_deq_valid; // @[p2.scala 93:43]
  assign q_visited_map_or_frontier_io_enq_bits = q_visited_map_or_frontier_l2_io_deq_bits; // @[p2.scala 93:43]
  assign q_visited_map_or_frontier_io_deq_ready = ~_T_1; // @[p2.scala 99:67]
  assign Queue_1_clock = clock;
  assign Queue_1_reset = reset;
  assign Queue_1_io_enq_valid = p2_read_visited_map_or_frontier_io_neighbours_out_valid; // @[Decoupled.scala 297:22]
  assign Queue_1_io_enq_bits = p2_read_visited_map_or_frontier_io_neighbours_out_bits; // @[Decoupled.scala 298:21]
  assign Queue_1_io_deq_ready = write_frontier_and_level_io_neighbours_ready; // @[p2.scala 108:44]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_5 = _RAND_1[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_push_or_pull_state;
    _T_5 <= io_push_or_pull_state;
  end
endmodule
module Queue_462(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [3:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:7]; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_11_data; // @[Decoupled.scala 218:16]
  wire [2:0] ram__T_11_addr; // @[Decoupled.scala 218:16]
  wire [31:0] ram__T_3_data; // @[Decoupled.scala 218:16]
  wire [2:0] ram__T_3_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_3_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_3_en; // @[Decoupled.scala 218:16]
  reg [2:0] enq_ptr_value; // @[Counter.scala 29:33]
  reg [2:0] deq_ptr_value; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = enq_ptr_value == deq_ptr_value; // @[Decoupled.scala 223:33]
  wire  _T = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  wrap = enq_ptr_value == 3'h7; // @[Counter.scala 38:24]
  wire [3:0] _T_4 = enq_ptr_value + 3'h1; // @[Counter.scala 39:22]
  wire [2:0] _T_5 = enq_ptr_value + 3'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [2:0] _GEN_0 = enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [2:0] _GEN_5 = do_enq ? _T_5 : enq_ptr_value; // @[Decoupled.scala 229:17]
  wire  wrap_1 = deq_ptr_value == 3'h7; // @[Counter.scala 38:24]
  wire [3:0] _T_6 = deq_ptr_value + 3'h1; // @[Counter.scala 39:22]
  wire [2:0] _T_7 = deq_ptr_value + 3'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [2:0] _GEN_6 = do_deq ? _T_7 : deq_ptr_value; // @[Decoupled.scala 233:17]
  wire  _T_8 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_8 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_9 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_10 = ~full; // @[Decoupled.scala 241:19]
  wire [3:0] _T_12 = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire [2:0] ptr_diff = enq_ptr_value - deq_ptr_value; // @[Decoupled.scala 257:32]
  wire  _T_13 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [3:0] _T_14 = _T_13 ? 4'h8 : 4'h0; // @[Decoupled.scala 259:20]
  wire [3:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [3:0] _T_15 = _T_14 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [3:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_11_addr = deq_ptr_value;
  assign ram__T_11_data = ram[ram__T_11_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = enq_ptr_value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_11_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_14 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 8; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  enq_ptr_value = _RAND_1[2:0];
  _RAND_2 = {1{`RANDOM}};
  deq_ptr_value = _RAND_2[2:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      enq_ptr_value <= 3'h0;
    end else if (do_enq) begin
      enq_ptr_value <= _T_5;
    end
    if (reset) begin
      deq_ptr_value <= 3'h0;
    end else if (do_deq) begin
      deq_ptr_value <= _T_7;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_8) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module bram_controller(
  input         clock,
  input         reset,
  input         io_ena,
  input  [17:0] io_addra,
  input         io_clka,
  input         io_dina,
  input         io_wea,
  output        io_douta,
  input         io_enb,
  input  [17:0] io_addrb,
  input         io_clkb,
  input  [31:0] io_dinb,
  input         io_web,
  output [31:0] io_doutb
);
  wire  ram_ena; // @[bram.scala 84:21]
  wire [17:0] ram_addra; // @[bram.scala 84:21]
  wire  ram_clka; // @[bram.scala 84:21]
  wire  ram_dina; // @[bram.scala 84:21]
  wire  ram_wea; // @[bram.scala 84:21]
  wire  ram_douta; // @[bram.scala 84:21]
  wire  ram_enb; // @[bram.scala 84:21]
  wire [17:0] ram_addrb; // @[bram.scala 84:21]
  wire  ram_clkb; // @[bram.scala 84:21]
  wire [31:0] ram_dinb; // @[bram.scala 84:21]
  wire  ram_web; // @[bram.scala 84:21]
  wire [31:0] ram_doutb; // @[bram.scala 84:21]
  bram ram ( // @[bram.scala 84:21]
    .ena(ram_ena),
    .addra(ram_addra),
    .clka(ram_clka),
    .dina(ram_dina),
    .wea(ram_wea),
    .douta(ram_douta),
    .enb(ram_enb),
    .addrb(ram_addrb),
    .clkb(ram_clkb),
    .dinb(ram_dinb),
    .web(ram_web),
    .doutb(ram_doutb)
  );
  assign io_douta = ram_douta; // @[bram.scala 95:14]
  assign io_doutb = ram_doutb; // @[bram.scala 96:14]
  assign ram_ena = io_ena; // @[bram.scala 85:16]
  assign ram_addra = io_addra; // @[bram.scala 87:22]
  assign ram_clka = io_clka; // @[bram.scala 89:21]
  assign ram_dina = io_dina; // @[bram.scala 93:17]
  assign ram_wea = io_wea; // @[bram.scala 91:20]
  assign ram_enb = io_enb; // @[bram.scala 86:16]
  assign ram_addrb = io_addrb; // @[bram.scala 88:22]
  assign ram_clkb = io_clkb; // @[bram.scala 90:21]
  assign ram_dinb = io_dinb; // @[bram.scala 94:21]
  assign ram_web = io_web; // @[bram.scala 92:20]
endmodule
module uram_controller(
  input         clock,
  input         reset,
  input         io_clka,
  input         io_clkb,
  input  [19:0] io_addra,
  input  [63:0] io_dina,
  input  [7:0]  io_wea,
  output [63:0] io_douta,
  input  [19:0] io_addrb,
  input  [63:0] io_dinb,
  input  [7:0]  io_web,
  output [63:0] io_doutb
);
  wire  ram_ena; // @[bram.scala 118:21]
  wire [19:0] ram_addra; // @[bram.scala 118:21]
  wire  ram_clka; // @[bram.scala 118:21]
  wire [71:0] ram_dina; // @[bram.scala 118:21]
  wire [8:0] ram_wea; // @[bram.scala 118:21]
  wire [71:0] ram_douta; // @[bram.scala 118:21]
  wire  ram_enb; // @[bram.scala 118:21]
  wire [19:0] ram_addrb; // @[bram.scala 118:21]
  wire  ram_clkb; // @[bram.scala 118:21]
  wire [71:0] ram_dinb; // @[bram.scala 118:21]
  wire [8:0] ram_web; // @[bram.scala 118:21]
  wire [71:0] ram_doutb; // @[bram.scala 118:21]
  wire [8:0] _T = {1'h0,io_wea}; // @[Cat.scala 29:58]
  wire [8:0] _T_1 = {1'h0,io_web}; // @[Cat.scala 29:58]
  wire [71:0] _T_2 = {8'h0,io_dina}; // @[Cat.scala 29:58]
  wire [71:0] _T_3 = {8'h0,io_dinb}; // @[Cat.scala 29:58]
  wire [63:0] _T_4 = ram_douta[63:0]; // @[bram.scala 130:29]
  wire [63:0] _T_5 = ram_doutb[63:0]; // @[bram.scala 131:29]
  uram ram ( // @[bram.scala 118:21]
    .ena(ram_ena),
    .addra(ram_addra),
    .clka(ram_clka),
    .dina(ram_dina),
    .wea(ram_wea),
    .douta(ram_douta),
    .enb(ram_enb),
    .addrb(ram_addrb),
    .clkb(ram_clkb),
    .dinb(ram_dinb),
    .web(ram_web),
    .doutb(ram_doutb)
  );
  assign io_douta = ram_douta[63:0]; // @[bram.scala 130:14]
  assign io_doutb = ram_doutb[63:0]; // @[bram.scala 131:14]
  assign ram_ena = 1'h1; // @[bram.scala 120:16]
  assign ram_addra = io_addra; // @[bram.scala 122:22]
  assign ram_clka = io_clka; // @[bram.scala 124:21]
  assign ram_dina = {8'h0,io_dina}; // @[bram.scala 128:17]
  assign ram_wea = {1'h0,io_wea}; // @[bram.scala 126:20]
  assign ram_enb = 1'h1; // @[bram.scala 121:20]
  assign ram_addrb = io_addrb; // @[bram.scala 123:22]
  assign ram_clkb = io_clkb; // @[bram.scala 125:21]
  assign ram_dinb = {8'h0,io_dinb}; // @[bram.scala 129:21]
  assign ram_web = {1'h0,io_web}; // @[bram.scala 127:20]
endmodule
module Queue_468(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [18:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [18:0] io_deq_bits,
  output [5:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
`endif // RANDOMIZE_REG_INIT
  reg [18:0] ram [0:31]; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_15_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_15_addr; // @[Decoupled.scala 218:16]
  wire [18:0] ram__T_5_data; // @[Decoupled.scala 218:16]
  wire [4:0] ram__T_5_addr; // @[Decoupled.scala 218:16]
  wire  ram__T_5_mask; // @[Decoupled.scala 218:16]
  wire  ram__T_5_en; // @[Decoupled.scala 218:16]
  reg [4:0] _T; // @[Counter.scala 29:33]
  reg [4:0] _T_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Decoupled.scala 221:27]
  wire  ptr_match = _T == _T_1; // @[Decoupled.scala 223:33]
  wire  _T_2 = ~maybe_full; // @[Decoupled.scala 224:28]
  wire  empty = ptr_match & _T_2; // @[Decoupled.scala 224:25]
  wire  full = ptr_match & maybe_full; // @[Decoupled.scala 225:24]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_6 = _T == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_7 = _T + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_8 = _T + 5'h1; // @[Counter.scala 39:22]
  wire  _T_3 = do_enq;
  wire [4:0] _GEN_0 = _T; // @[Decoupled.scala 229:17]
  wire  _GEN_1 = clock; // @[Decoupled.scala 229:17]
  wire  _GEN_2 = do_enq; // @[Decoupled.scala 229:17]
  wire  _GEN_3 = 1'h1; // @[Decoupled.scala 229:17]
  wire [18:0] _GEN_4 = io_enq_bits; // @[Decoupled.scala 229:17]
  wire [4:0] _GEN_5 = do_enq ? _T_8 : _T; // @[Decoupled.scala 229:17]
  wire  _T_9 = _T_1 == 5'h1f; // @[Counter.scala 38:24]
  wire [5:0] _T_10 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire [4:0] _T_11 = _T_1 + 5'h1; // @[Counter.scala 39:22]
  wire  _T_4 = do_deq;
  wire [4:0] _GEN_6 = do_deq ? _T_11 : _T_1; // @[Decoupled.scala 233:17]
  wire  _T_12 = do_enq != do_deq; // @[Decoupled.scala 236:16]
  wire  _GEN_7 = _T_12 ? do_enq : maybe_full; // @[Decoupled.scala 236:28]
  wire  _T_13 = ~empty; // @[Decoupled.scala 240:19]
  wire  _T_14 = ~full; // @[Decoupled.scala 241:19]
  wire [5:0] _T_16 = _T - _T_1; // @[Decoupled.scala 257:32]
  wire [4:0] ptr_diff = _T - _T_1; // @[Decoupled.scala 257:32]
  wire  _T_17 = maybe_full & ptr_match; // @[Decoupled.scala 259:32]
  wire [5:0] _T_18 = _T_17 ? 6'h20 : 6'h0; // @[Decoupled.scala 259:20]
  wire [5:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:62]
  wire [5:0] _T_19 = _T_18 | _GEN_8; // @[Decoupled.scala 259:62]
  wire [5:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Decoupled.scala 259:14]
  assign ram__T_15_addr = _T_1;
  assign ram__T_15_data = ram[ram__T_15_addr]; // @[Decoupled.scala 218:16]
  assign ram__T_5_data = io_enq_bits;
  assign ram__T_5_addr = _T;
  assign ram__T_5_mask = 1'h1;
  assign ram__T_5_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = ~full; // @[Decoupled.scala 241:16]
  assign io_deq_valid = ~empty; // @[Decoupled.scala 240:16]
  assign io_deq_bits = ram__T_15_data; // @[Decoupled.scala 242:15]
  assign io_count = _T_18 | _GEN_8; // @[Decoupled.scala 259:14]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 32; initvar = initvar+1)
    ram[initvar] = _RAND_0[18:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  _T = _RAND_1[4:0];
  _RAND_2 = {1{`RANDOM}};
  _T_1 = _RAND_2[4:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_5_en & ram__T_5_mask) begin
      ram[ram__T_5_addr] <= ram__T_5_data; // @[Decoupled.scala 218:16]
    end
    if (reset) begin
      _T <= 5'h0;
    end else if (do_enq) begin
      _T <= _T_8;
    end
    if (reset) begin
      _T_1 <= 5'h0;
    end else if (do_deq) begin
      _T_1 <= _T_11;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_12) begin
      maybe_full <= do_enq;
    end
  end
endmodule
module Frontier(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h0; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_1(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h20; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h20; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_1(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_1 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_1(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h20; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_2(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h40; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h40; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_2(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_2 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_2(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h40; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_3(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h60; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h60; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_3(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_3 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_3(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h60; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = {{1'd0}, _T_6}; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_7[6:0]; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_7[6:0]}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = {{1'd0}, _T_17}; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_18[6:0]; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_18[6:0]}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = {{1'd0}, _T_28}; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_29[7:0]; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_29[7:0]}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = {{1'd0}, _T_39}; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_40[7:0]; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_40[7:0]}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = {{1'd0}, _T_6}; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_7[6:0]; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_7[6:0]}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = {{1'd0}, _T_17}; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_18[6:0]; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_18[6:0]}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = {{1'd0}, _T_28}; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_29[7:0]; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_29[7:0]}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = {{1'd0}, _T_39}; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_40[7:0]; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_40[7:0]}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_1 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_1 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_2 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_2 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_3 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_3 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_4(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_4(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_4 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_4(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_5(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h21; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h21; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_5(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_5 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_5(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h21; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_6(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h41; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h41; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_6(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_6 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_6(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h41; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_7(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h61; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h61; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_7(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_7 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_7(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h61; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_1(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_4 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_4 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_5 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_5 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_6 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_6 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_7 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_7 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_8(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_8(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_8 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_8(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_9(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h22; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h22; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_9(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_9 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_9(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h22; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_10(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h42; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h42; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_10(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_10 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_10(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h42; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_11(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h62; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h62; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_11(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_11 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_11(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h62; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_2(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h2; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h2; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h2; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h2; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h2; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h2; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h2; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h2; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h2; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h2; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h2; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h2; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h2; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h2; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h2; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h2; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_8 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_8 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_9 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_9 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_10 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_10 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_11 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_11 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_12(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_12(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_12 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_12(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_13(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h23; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h23; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_13(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_13 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_13(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h23; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_14(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h43; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h43; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_14(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_14 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_14(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h43; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_15(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h63; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h63; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_15(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_15 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_15(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h63; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_3(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h3; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h3; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h3; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h3; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h3; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h3; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h3; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h3; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h3; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h3; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h3; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h3; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h3; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h3; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h3; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h3; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_12 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_12 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_13 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_13 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_14 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_14 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_15 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_15 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_16(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_16(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_16 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_16(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_17(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h24; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h24; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_17(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_17 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_17(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h24; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_18(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h44; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h44; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_18(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_18 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_18(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h44; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_19(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h64; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h64; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_19(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_19 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_19(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h64; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_4(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h4; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h4; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h4; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h4; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h4; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h4; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h4; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h4; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h4; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h4; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h4; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h4; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h4; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h4; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h4; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h4; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_16 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_16 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_17 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_17 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_18 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_18 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_19 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_19 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_20(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_20(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_20 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_20(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_21(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h25; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h25; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_21(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_21 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_21(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h25; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_22(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h45; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h45; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_22(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_22 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_22(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h45; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_23(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h65; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h65; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_23(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_23 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_23(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h65; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_5(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h5; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h5; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h5; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h5; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h5; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h5; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h5; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h5; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h5; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h5; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h5; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h5; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h5; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h5; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h5; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h5; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_20 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_20 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_21 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_21 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_22 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_22 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_23 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_23 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_24(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_24(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_24 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_24(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_25(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h26; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h26; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_25(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_25 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_25(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h26; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_26(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h46; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h46; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_26(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_26 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_26(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h46; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_27(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h66; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h66; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_27(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_27 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_27(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h66; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_6(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h6; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h6; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h6; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h6; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h6; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h6; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h6; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h6; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h6; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h6; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h6; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h6; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h6; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h6; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h6; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h6; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_24 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_24 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_25 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_25 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_26 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_26 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_27 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_27 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_28(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_28(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_28 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_28(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_29(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h27; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h27; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_29(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_29 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_29(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h27; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_30(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h47; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h47; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_30(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_30 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_30(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h47; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_31(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h67; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h67; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_31(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_31 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_31(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h67; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_7(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h7; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h7; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h7; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h7; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h7; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h7; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h7; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h7; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h7; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h7; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h7; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h7; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h7; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h7; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h7; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h7; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_28 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_28 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_29 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_29 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_30 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_30 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_31 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_31 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_32(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h8; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h8; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_32(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_32 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_32(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h8; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_33(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h28; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h28; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_33(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_33 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_33(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h28; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_34(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h48; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h48; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_34(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_34 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_34(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h48; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_35(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h68; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h68; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_35(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_35 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_35(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h68; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_8(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h8; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h8; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h8; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h8; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h8; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h8; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h8; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h8; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h8; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h8; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h8; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h8; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h8; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h8; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h8; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h8; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_32 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_32 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_33 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_33 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_34 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_34 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_35 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_35 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_36(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h9; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h9; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_36(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_36 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_36(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h9; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_37(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h29; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h29; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_37(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_37 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_37(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h29; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_38(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h49; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h49; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_38(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_38 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_38(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h49; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_39(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h69; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h69; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_39(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_39 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_39(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h69; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_9(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h9; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h9; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h9; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h9; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h9; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h9; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h9; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h9; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h9; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h9; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h9; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h9; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h9; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h9; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h9; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h9; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_36 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_36 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_37 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_37 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_38 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_38 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_39 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_39 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_40(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'ha; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'ha; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_40(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_40 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_40(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'ha; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_41(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_41(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_41 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_41(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_42(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_42(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_42 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_42(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_43(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_43(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_43 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_43(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_10(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'ha; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'ha; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'ha; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'ha; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'ha; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'ha; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'ha; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'ha; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'ha; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'ha; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'ha; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'ha; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'ha; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'ha; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'ha; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'ha; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_40 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_40 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_41 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_41 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_42 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_42 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_43 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_43 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_44(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'hb; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'hb; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_44(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_44 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_44(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'hb; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_45(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_45(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_45 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_45(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_46(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_46(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_46 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_46(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_47(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_47(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_47 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_47(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_11(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'hb; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'hb; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'hb; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'hb; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'hb; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'hb; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'hb; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'hb; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'hb; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'hb; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'hb; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'hb; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'hb; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'hb; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'hb; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'hb; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_44 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_44 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_45 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_45 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_46 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_46 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_47 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_47 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_48(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'hc; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'hc; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_48(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_48 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_48(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'hc; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_49(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_49(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_49 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_49(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_50(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_50(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_50 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_50(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_51(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_51(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_51 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_51(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_12(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'hc; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'hc; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'hc; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'hc; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'hc; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'hc; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'hc; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'hc; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'hc; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'hc; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'hc; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'hc; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'hc; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'hc; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'hc; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'hc; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_48 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_48 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_49 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_49 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_50 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_50 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_51 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_51 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_52(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'hd; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'hd; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_52(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_52 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_52(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'hd; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_53(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_53(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_53 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_53(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_54(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_54(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_54 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_54(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_55(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_55(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_55 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_55(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_13(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'hd; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'hd; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'hd; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'hd; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'hd; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'hd; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'hd; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'hd; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'hd; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'hd; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'hd; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'hd; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'hd; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'hd; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'hd; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'hd; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_52 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_52 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_53 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_53 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_54 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_54 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_55 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_55 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module copy_slr1(
  input   clock,
  input   reset,
  input   io_in,
  output  io_out_0,
  output  io_out_1,
  output  io_out_2,
  output  io_out_3,
  output  io_out_4,
  output  io_out_5,
  output  io_out_6,
  output  io_out_7,
  output  io_out_8,
  output  io_out_9,
  output  io_out_10,
  output  io_out_11,
  output  io_out_12,
  output  io_out_13
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  reg  out_reg_0; // @[master.scala 215:24]
  reg  out_reg_1; // @[master.scala 215:24]
  reg  out_reg_2; // @[master.scala 215:24]
  reg  out_reg_3; // @[master.scala 215:24]
  reg  out_reg_4; // @[master.scala 215:24]
  reg  out_reg_5; // @[master.scala 215:24]
  reg  out_reg_6; // @[master.scala 215:24]
  reg  out_reg_7; // @[master.scala 215:24]
  reg  out_reg_8; // @[master.scala 215:24]
  reg  out_reg_9; // @[master.scala 215:24]
  reg  out_reg_10; // @[master.scala 215:24]
  reg  out_reg_11; // @[master.scala 215:24]
  reg  out_reg_12; // @[master.scala 215:24]
  reg  out_reg_13; // @[master.scala 215:24]
  wire  _T_0 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_1 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_2 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_3 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_4 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_5 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_6 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_7 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_8 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_9 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_10 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_11 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_12 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  wire  _T_13 = 1'h0; // @[master.scala 215:32 master.scala 215:32]
  assign io_out_0 = out_reg_0; // @[master.scala 220:10]
  assign io_out_1 = out_reg_1; // @[master.scala 220:10]
  assign io_out_2 = out_reg_2; // @[master.scala 220:10]
  assign io_out_3 = out_reg_3; // @[master.scala 220:10]
  assign io_out_4 = out_reg_4; // @[master.scala 220:10]
  assign io_out_5 = out_reg_5; // @[master.scala 220:10]
  assign io_out_6 = out_reg_6; // @[master.scala 220:10]
  assign io_out_7 = out_reg_7; // @[master.scala 220:10]
  assign io_out_8 = out_reg_8; // @[master.scala 220:10]
  assign io_out_9 = out_reg_9; // @[master.scala 220:10]
  assign io_out_10 = out_reg_10; // @[master.scala 220:10]
  assign io_out_11 = out_reg_11; // @[master.scala 220:10]
  assign io_out_12 = out_reg_12; // @[master.scala 220:10]
  assign io_out_13 = out_reg_13; // @[master.scala 220:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 1'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 1'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 1'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 1'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 1'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 1'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 1'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 1'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 1'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 1'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 1'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 1'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 1'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 1'h0;
    end else begin
      out_reg_13 <= io_in;
    end
  end
endmodule
module copy_slr1_2(
  input         clock,
  input         reset,
  input  [31:0] io_in,
  output [31:0] io_out_0,
  output [31:0] io_out_1,
  output [31:0] io_out_2,
  output [31:0] io_out_3,
  output [31:0] io_out_4,
  output [31:0] io_out_5,
  output [31:0] io_out_6,
  output [31:0] io_out_7,
  output [31:0] io_out_8,
  output [31:0] io_out_9,
  output [31:0] io_out_10,
  output [31:0] io_out_11,
  output [31:0] io_out_12,
  output [31:0] io_out_13
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] out_reg_0; // @[master.scala 215:24]
  reg [31:0] out_reg_1; // @[master.scala 215:24]
  reg [31:0] out_reg_2; // @[master.scala 215:24]
  reg [31:0] out_reg_3; // @[master.scala 215:24]
  reg [31:0] out_reg_4; // @[master.scala 215:24]
  reg [31:0] out_reg_5; // @[master.scala 215:24]
  reg [31:0] out_reg_6; // @[master.scala 215:24]
  reg [31:0] out_reg_7; // @[master.scala 215:24]
  reg [31:0] out_reg_8; // @[master.scala 215:24]
  reg [31:0] out_reg_9; // @[master.scala 215:24]
  reg [31:0] out_reg_10; // @[master.scala 215:24]
  reg [31:0] out_reg_11; // @[master.scala 215:24]
  reg [31:0] out_reg_12; // @[master.scala 215:24]
  reg [31:0] out_reg_13; // @[master.scala 215:24]
  wire [31:0] _T_0 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_1 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_2 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_3 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_4 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_5 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_6 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_7 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_8 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_9 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_10 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_11 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_12 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  wire [31:0] _T_13 = 32'h0; // @[master.scala 215:32 master.scala 215:32]
  assign io_out_0 = out_reg_0; // @[master.scala 220:10]
  assign io_out_1 = out_reg_1; // @[master.scala 220:10]
  assign io_out_2 = out_reg_2; // @[master.scala 220:10]
  assign io_out_3 = out_reg_3; // @[master.scala 220:10]
  assign io_out_4 = out_reg_4; // @[master.scala 220:10]
  assign io_out_5 = out_reg_5; // @[master.scala 220:10]
  assign io_out_6 = out_reg_6; // @[master.scala 220:10]
  assign io_out_7 = out_reg_7; // @[master.scala 220:10]
  assign io_out_8 = out_reg_8; // @[master.scala 220:10]
  assign io_out_9 = out_reg_9; // @[master.scala 220:10]
  assign io_out_10 = out_reg_10; // @[master.scala 220:10]
  assign io_out_11 = out_reg_11; // @[master.scala 220:10]
  assign io_out_12 = out_reg_12; // @[master.scala 220:10]
  assign io_out_13 = out_reg_13; // @[master.scala 220:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[31:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 32'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 32'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 32'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 32'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 32'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 32'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 32'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 32'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 32'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 32'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 32'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 32'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 32'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 32'h0;
    end else begin
      out_reg_13 <= io_in;
    end
  end
endmodule
module SLR1(
  input         clock,
  input         reset,
  input         io_p2_end,
  input         io_start,
  input         io_frontier_flag,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  input  [31:0] io_node_num,
  input  [31:0] io_root,
  input         io_push_or_pull,
  input         io_start_init,
  output        io_end_0,
  output        io_end_1,
  output        io_end_2,
  output        io_end_3,
  output        io_end_4,
  output        io_end_5,
  output        io_end_6,
  output        io_end_7,
  output        io_end_8,
  output        io_end_9,
  output        io_end_10,
  output        io_end_11,
  output        io_end_12,
  output        io_end_13,
  output [31:0] io_p2_count_0,
  output [31:0] io_p2_count_1,
  output [31:0] io_p2_count_2,
  output [31:0] io_p2_count_3,
  output [31:0] io_p2_count_4,
  output [31:0] io_p2_count_5,
  output [31:0] io_p2_count_6,
  output [31:0] io_p2_count_7,
  output [31:0] io_p2_count_8,
  output [31:0] io_p2_count_9,
  output [31:0] io_p2_count_10,
  output [31:0] io_p2_count_11,
  output [31:0] io_p2_count_12,
  output [31:0] io_p2_count_13,
  output [31:0] io_p2_pull_count_0,
  output [31:0] io_p2_pull_count_1,
  output [31:0] io_p2_pull_count_2,
  output [31:0] io_p2_pull_count_3,
  output [31:0] io_p2_pull_count_4,
  output [31:0] io_p2_pull_count_5,
  output [31:0] io_p2_pull_count_6,
  output [31:0] io_p2_pull_count_7,
  output [31:0] io_p2_pull_count_8,
  output [31:0] io_p2_pull_count_9,
  output [31:0] io_p2_pull_count_10,
  output [31:0] io_p2_pull_count_11,
  output [31:0] io_p2_pull_count_12,
  output [31:0] io_p2_pull_count_13,
  output [31:0] io_frontier_pull_count_0,
  output [31:0] io_frontier_pull_count_1,
  output [31:0] io_frontier_pull_count_2,
  output [31:0] io_frontier_pull_count_3,
  output [31:0] io_frontier_pull_count_4,
  output [31:0] io_frontier_pull_count_5,
  output [31:0] io_frontier_pull_count_6,
  output [31:0] io_frontier_pull_count_7,
  output [31:0] io_frontier_pull_count_8,
  output [31:0] io_frontier_pull_count_9,
  output [31:0] io_frontier_pull_count_10,
  output [31:0] io_frontier_pull_count_11,
  output [31:0] io_frontier_pull_count_12,
  output [31:0] io_frontier_pull_count_13,
  output        io_last_iteration_0,
  output        io_last_iteration_1,
  output        io_last_iteration_2,
  output        io_last_iteration_3,
  output        io_last_iteration_4,
  output        io_last_iteration_5,
  output        io_last_iteration_6,
  output        io_last_iteration_7,
  output        io_last_iteration_8,
  output        io_last_iteration_9,
  output        io_last_iteration_10,
  output        io_last_iteration_11,
  output        io_last_iteration_12,
  output        io_last_iteration_13,
  output        io_init_bram_0,
  output        io_init_bram_1,
  output        io_init_bram_2,
  output        io_init_bram_3,
  output        io_init_bram_4,
  output        io_init_bram_5,
  output        io_init_bram_6,
  output        io_init_bram_7,
  output        io_init_bram_8,
  output        io_init_bram_9,
  output        io_init_bram_10,
  output        io_init_bram_11,
  output        io_init_bram_12,
  output        io_init_bram_13,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_p2_in_4_ready,
  input         io_p2_in_4_valid,
  input  [63:0] io_p2_in_4_bits,
  output        io_p2_in_5_ready,
  input         io_p2_in_5_valid,
  input  [63:0] io_p2_in_5_bits,
  output        io_p2_in_6_ready,
  input         io_p2_in_6_valid,
  input  [63:0] io_p2_in_6_bits,
  output        io_p2_in_7_ready,
  input         io_p2_in_7_valid,
  input  [63:0] io_p2_in_7_bits,
  output        io_p2_in_8_ready,
  input         io_p2_in_8_valid,
  input  [63:0] io_p2_in_8_bits,
  output        io_p2_in_9_ready,
  input         io_p2_in_9_valid,
  input  [63:0] io_p2_in_9_bits,
  output        io_p2_in_10_ready,
  input         io_p2_in_10_valid,
  input  [63:0] io_p2_in_10_bits,
  output        io_p2_in_11_ready,
  input         io_p2_in_11_valid,
  input  [63:0] io_p2_in_11_bits,
  output        io_p2_in_12_ready,
  input         io_p2_in_12_valid,
  input  [63:0] io_p2_in_12_bits,
  output        io_p2_in_13_ready,
  input         io_p2_in_13_valid,
  input  [63:0] io_p2_in_13_bits,
  output        io_p2_in_14_ready,
  input         io_p2_in_14_valid,
  input  [63:0] io_p2_in_14_bits,
  output        io_p2_in_15_ready,
  input         io_p2_in_15_valid,
  input  [63:0] io_p2_in_15_bits,
  output        io_p2_in_16_ready,
  input         io_p2_in_16_valid,
  input  [63:0] io_p2_in_16_bits,
  output        io_p2_in_17_ready,
  input         io_p2_in_17_valid,
  input  [63:0] io_p2_in_17_bits,
  output        io_p2_in_18_ready,
  input         io_p2_in_18_valid,
  input  [63:0] io_p2_in_18_bits,
  output        io_p2_in_19_ready,
  input         io_p2_in_19_valid,
  input  [63:0] io_p2_in_19_bits,
  output        io_p2_in_20_ready,
  input         io_p2_in_20_valid,
  input  [63:0] io_p2_in_20_bits,
  output        io_p2_in_21_ready,
  input         io_p2_in_21_valid,
  input  [63:0] io_p2_in_21_bits,
  output        io_p2_in_22_ready,
  input         io_p2_in_22_valid,
  input  [63:0] io_p2_in_22_bits,
  output        io_p2_in_23_ready,
  input         io_p2_in_23_valid,
  input  [63:0] io_p2_in_23_bits,
  output        io_p2_in_24_ready,
  input         io_p2_in_24_valid,
  input  [63:0] io_p2_in_24_bits,
  output        io_p2_in_25_ready,
  input         io_p2_in_25_valid,
  input  [63:0] io_p2_in_25_bits,
  output        io_p2_in_26_ready,
  input         io_p2_in_26_valid,
  input  [63:0] io_p2_in_26_bits,
  output        io_p2_in_27_ready,
  input         io_p2_in_27_valid,
  input  [63:0] io_p2_in_27_bits,
  output        io_p2_in_28_ready,
  input         io_p2_in_28_valid,
  input  [63:0] io_p2_in_28_bits,
  output        io_p2_in_29_ready,
  input         io_p2_in_29_valid,
  input  [63:0] io_p2_in_29_bits,
  output        io_p2_in_30_ready,
  input         io_p2_in_30_valid,
  input  [63:0] io_p2_in_30_bits,
  output        io_p2_in_31_ready,
  input         io_p2_in_31_valid,
  input  [63:0] io_p2_in_31_bits,
  output        io_p2_in_32_ready,
  input         io_p2_in_32_valid,
  input  [63:0] io_p2_in_32_bits,
  output        io_p2_in_33_ready,
  input         io_p2_in_33_valid,
  input  [63:0] io_p2_in_33_bits,
  output        io_p2_in_34_ready,
  input         io_p2_in_34_valid,
  input  [63:0] io_p2_in_34_bits,
  output        io_p2_in_35_ready,
  input         io_p2_in_35_valid,
  input  [63:0] io_p2_in_35_bits,
  output        io_p2_in_36_ready,
  input         io_p2_in_36_valid,
  input  [63:0] io_p2_in_36_bits,
  output        io_p2_in_37_ready,
  input         io_p2_in_37_valid,
  input  [63:0] io_p2_in_37_bits,
  output        io_p2_in_38_ready,
  input         io_p2_in_38_valid,
  input  [63:0] io_p2_in_38_bits,
  output        io_p2_in_39_ready,
  input         io_p2_in_39_valid,
  input  [63:0] io_p2_in_39_bits,
  output        io_p2_in_40_ready,
  input         io_p2_in_40_valid,
  input  [63:0] io_p2_in_40_bits,
  output        io_p2_in_41_ready,
  input         io_p2_in_41_valid,
  input  [63:0] io_p2_in_41_bits,
  output        io_p2_in_42_ready,
  input         io_p2_in_42_valid,
  input  [63:0] io_p2_in_42_bits,
  output        io_p2_in_43_ready,
  input         io_p2_in_43_valid,
  input  [63:0] io_p2_in_43_bits,
  output        io_p2_in_44_ready,
  input         io_p2_in_44_valid,
  input  [63:0] io_p2_in_44_bits,
  output        io_p2_in_45_ready,
  input         io_p2_in_45_valid,
  input  [63:0] io_p2_in_45_bits,
  output        io_p2_in_46_ready,
  input         io_p2_in_46_valid,
  input  [63:0] io_p2_in_46_bits,
  output        io_p2_in_47_ready,
  input         io_p2_in_47_valid,
  input  [63:0] io_p2_in_47_bits,
  output        io_p2_in_48_ready,
  input         io_p2_in_48_valid,
  input  [63:0] io_p2_in_48_bits,
  output        io_p2_in_49_ready,
  input         io_p2_in_49_valid,
  input  [63:0] io_p2_in_49_bits,
  output        io_p2_in_50_ready,
  input         io_p2_in_50_valid,
  input  [63:0] io_p2_in_50_bits,
  output        io_p2_in_51_ready,
  input         io_p2_in_51_valid,
  input  [63:0] io_p2_in_51_bits,
  output        io_p2_in_52_ready,
  input         io_p2_in_52_valid,
  input  [63:0] io_p2_in_52_bits,
  output        io_p2_in_53_ready,
  input         io_p2_in_53_valid,
  input  [63:0] io_p2_in_53_bits,
  output        io_p2_in_54_ready,
  input         io_p2_in_54_valid,
  input  [63:0] io_p2_in_54_bits,
  output        io_p2_in_55_ready,
  input         io_p2_in_55_valid,
  input  [63:0] io_p2_in_55_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  output        io_frontier_in_4_ready,
  input         io_frontier_in_4_valid,
  input  [31:0] io_frontier_in_4_bits,
  output        io_frontier_in_5_ready,
  input         io_frontier_in_5_valid,
  input  [31:0] io_frontier_in_5_bits,
  output        io_frontier_in_6_ready,
  input         io_frontier_in_6_valid,
  input  [31:0] io_frontier_in_6_bits,
  output        io_frontier_in_7_ready,
  input         io_frontier_in_7_valid,
  input  [31:0] io_frontier_in_7_bits,
  output        io_frontier_in_8_ready,
  input         io_frontier_in_8_valid,
  input  [31:0] io_frontier_in_8_bits,
  output        io_frontier_in_9_ready,
  input         io_frontier_in_9_valid,
  input  [31:0] io_frontier_in_9_bits,
  output        io_frontier_in_10_ready,
  input         io_frontier_in_10_valid,
  input  [31:0] io_frontier_in_10_bits,
  output        io_frontier_in_11_ready,
  input         io_frontier_in_11_valid,
  input  [31:0] io_frontier_in_11_bits,
  output        io_frontier_in_12_ready,
  input         io_frontier_in_12_valid,
  input  [31:0] io_frontier_in_12_bits,
  output        io_frontier_in_13_ready,
  input         io_frontier_in_13_valid,
  input  [31:0] io_frontier_in_13_bits,
  output        io_frontier_in_14_ready,
  input         io_frontier_in_14_valid,
  input  [31:0] io_frontier_in_14_bits,
  output        io_frontier_in_15_ready,
  input         io_frontier_in_15_valid,
  input  [31:0] io_frontier_in_15_bits,
  output        io_frontier_in_16_ready,
  input         io_frontier_in_16_valid,
  input  [31:0] io_frontier_in_16_bits,
  output        io_frontier_in_17_ready,
  input         io_frontier_in_17_valid,
  input  [31:0] io_frontier_in_17_bits,
  output        io_frontier_in_18_ready,
  input         io_frontier_in_18_valid,
  input  [31:0] io_frontier_in_18_bits,
  output        io_frontier_in_19_ready,
  input         io_frontier_in_19_valid,
  input  [31:0] io_frontier_in_19_bits,
  output        io_frontier_in_20_ready,
  input         io_frontier_in_20_valid,
  input  [31:0] io_frontier_in_20_bits,
  output        io_frontier_in_21_ready,
  input         io_frontier_in_21_valid,
  input  [31:0] io_frontier_in_21_bits,
  output        io_frontier_in_22_ready,
  input         io_frontier_in_22_valid,
  input  [31:0] io_frontier_in_22_bits,
  output        io_frontier_in_23_ready,
  input         io_frontier_in_23_valid,
  input  [31:0] io_frontier_in_23_bits,
  output        io_frontier_in_24_ready,
  input         io_frontier_in_24_valid,
  input  [31:0] io_frontier_in_24_bits,
  output        io_frontier_in_25_ready,
  input         io_frontier_in_25_valid,
  input  [31:0] io_frontier_in_25_bits,
  output        io_frontier_in_26_ready,
  input         io_frontier_in_26_valid,
  input  [31:0] io_frontier_in_26_bits,
  output        io_frontier_in_27_ready,
  input         io_frontier_in_27_valid,
  input  [31:0] io_frontier_in_27_bits,
  output        io_frontier_in_28_ready,
  input         io_frontier_in_28_valid,
  input  [31:0] io_frontier_in_28_bits,
  output        io_frontier_in_29_ready,
  input         io_frontier_in_29_valid,
  input  [31:0] io_frontier_in_29_bits,
  output        io_frontier_in_30_ready,
  input         io_frontier_in_30_valid,
  input  [31:0] io_frontier_in_30_bits,
  output        io_frontier_in_31_ready,
  input         io_frontier_in_31_valid,
  input  [31:0] io_frontier_in_31_bits,
  output        io_frontier_in_32_ready,
  input         io_frontier_in_32_valid,
  input  [31:0] io_frontier_in_32_bits,
  output        io_frontier_in_33_ready,
  input         io_frontier_in_33_valid,
  input  [31:0] io_frontier_in_33_bits,
  output        io_frontier_in_34_ready,
  input         io_frontier_in_34_valid,
  input  [31:0] io_frontier_in_34_bits,
  output        io_frontier_in_35_ready,
  input         io_frontier_in_35_valid,
  input  [31:0] io_frontier_in_35_bits,
  output        io_frontier_in_36_ready,
  input         io_frontier_in_36_valid,
  input  [31:0] io_frontier_in_36_bits,
  output        io_frontier_in_37_ready,
  input         io_frontier_in_37_valid,
  input  [31:0] io_frontier_in_37_bits,
  output        io_frontier_in_38_ready,
  input         io_frontier_in_38_valid,
  input  [31:0] io_frontier_in_38_bits,
  output        io_frontier_in_39_ready,
  input         io_frontier_in_39_valid,
  input  [31:0] io_frontier_in_39_bits,
  output        io_frontier_in_40_ready,
  input         io_frontier_in_40_valid,
  input  [31:0] io_frontier_in_40_bits,
  output        io_frontier_in_41_ready,
  input         io_frontier_in_41_valid,
  input  [31:0] io_frontier_in_41_bits,
  output        io_frontier_in_42_ready,
  input         io_frontier_in_42_valid,
  input  [31:0] io_frontier_in_42_bits,
  output        io_frontier_in_43_ready,
  input         io_frontier_in_43_valid,
  input  [31:0] io_frontier_in_43_bits,
  output        io_frontier_in_44_ready,
  input         io_frontier_in_44_valid,
  input  [31:0] io_frontier_in_44_bits,
  output        io_frontier_in_45_ready,
  input         io_frontier_in_45_valid,
  input  [31:0] io_frontier_in_45_bits,
  output        io_frontier_in_46_ready,
  input         io_frontier_in_46_valid,
  input  [31:0] io_frontier_in_46_bits,
  output        io_frontier_in_47_ready,
  input         io_frontier_in_47_valid,
  input  [31:0] io_frontier_in_47_bits,
  output        io_frontier_in_48_ready,
  input         io_frontier_in_48_valid,
  input  [31:0] io_frontier_in_48_bits,
  output        io_frontier_in_49_ready,
  input         io_frontier_in_49_valid,
  input  [31:0] io_frontier_in_49_bits,
  output        io_frontier_in_50_ready,
  input         io_frontier_in_50_valid,
  input  [31:0] io_frontier_in_50_bits,
  output        io_frontier_in_51_ready,
  input         io_frontier_in_51_valid,
  input  [31:0] io_frontier_in_51_bits,
  output        io_frontier_in_52_ready,
  input         io_frontier_in_52_valid,
  input  [31:0] io_frontier_in_52_bits,
  output        io_frontier_in_53_ready,
  input         io_frontier_in_53_valid,
  input  [31:0] io_frontier_in_53_bits,
  output        io_frontier_in_54_ready,
  input         io_frontier_in_54_valid,
  input  [31:0] io_frontier_in_54_bits,
  output        io_frontier_in_55_ready,
  input         io_frontier_in_55_valid,
  input  [31:0] io_frontier_in_55_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input         io_p2_out_4_ready,
  output        io_p2_out_4_valid,
  output [31:0] io_p2_out_4_bits,
  input         io_p2_out_5_ready,
  output        io_p2_out_5_valid,
  output [31:0] io_p2_out_5_bits,
  input         io_p2_out_6_ready,
  output        io_p2_out_6_valid,
  output [31:0] io_p2_out_6_bits,
  input         io_p2_out_7_ready,
  output        io_p2_out_7_valid,
  output [31:0] io_p2_out_7_bits,
  input         io_p2_out_8_ready,
  output        io_p2_out_8_valid,
  output [31:0] io_p2_out_8_bits,
  input         io_p2_out_9_ready,
  output        io_p2_out_9_valid,
  output [31:0] io_p2_out_9_bits,
  input         io_p2_out_10_ready,
  output        io_p2_out_10_valid,
  output [31:0] io_p2_out_10_bits,
  input         io_p2_out_11_ready,
  output        io_p2_out_11_valid,
  output [31:0] io_p2_out_11_bits,
  input         io_p2_out_12_ready,
  output        io_p2_out_12_valid,
  output [31:0] io_p2_out_12_bits,
  input         io_p2_out_13_ready,
  output        io_p2_out_13_valid,
  output [31:0] io_p2_out_13_bits,
  input         io_p2_out_14_ready,
  output        io_p2_out_14_valid,
  output [31:0] io_p2_out_14_bits,
  input         io_p2_out_15_ready,
  output        io_p2_out_15_valid,
  output [31:0] io_p2_out_15_bits,
  input         io_p2_out_16_ready,
  output        io_p2_out_16_valid,
  output [31:0] io_p2_out_16_bits,
  input         io_p2_out_17_ready,
  output        io_p2_out_17_valid,
  output [31:0] io_p2_out_17_bits,
  input         io_p2_out_18_ready,
  output        io_p2_out_18_valid,
  output [31:0] io_p2_out_18_bits,
  input         io_p2_out_19_ready,
  output        io_p2_out_19_valid,
  output [31:0] io_p2_out_19_bits,
  input         io_p2_out_20_ready,
  output        io_p2_out_20_valid,
  output [31:0] io_p2_out_20_bits,
  input         io_p2_out_21_ready,
  output        io_p2_out_21_valid,
  output [31:0] io_p2_out_21_bits,
  input         io_p2_out_22_ready,
  output        io_p2_out_22_valid,
  output [31:0] io_p2_out_22_bits,
  input         io_p2_out_23_ready,
  output        io_p2_out_23_valid,
  output [31:0] io_p2_out_23_bits,
  input         io_p2_out_24_ready,
  output        io_p2_out_24_valid,
  output [31:0] io_p2_out_24_bits,
  input         io_p2_out_25_ready,
  output        io_p2_out_25_valid,
  output [31:0] io_p2_out_25_bits,
  input         io_p2_out_26_ready,
  output        io_p2_out_26_valid,
  output [31:0] io_p2_out_26_bits,
  input         io_p2_out_27_ready,
  output        io_p2_out_27_valid,
  output [31:0] io_p2_out_27_bits,
  input         io_p2_out_28_ready,
  output        io_p2_out_28_valid,
  output [31:0] io_p2_out_28_bits,
  input         io_p2_out_29_ready,
  output        io_p2_out_29_valid,
  output [31:0] io_p2_out_29_bits,
  input         io_p2_out_30_ready,
  output        io_p2_out_30_valid,
  output [31:0] io_p2_out_30_bits,
  input         io_p2_out_31_ready,
  output        io_p2_out_31_valid,
  output [31:0] io_p2_out_31_bits,
  input         io_p2_out_32_ready,
  output        io_p2_out_32_valid,
  output [31:0] io_p2_out_32_bits,
  input         io_p2_out_33_ready,
  output        io_p2_out_33_valid,
  output [31:0] io_p2_out_33_bits,
  input         io_p2_out_34_ready,
  output        io_p2_out_34_valid,
  output [31:0] io_p2_out_34_bits,
  input         io_p2_out_35_ready,
  output        io_p2_out_35_valid,
  output [31:0] io_p2_out_35_bits,
  input         io_p2_out_36_ready,
  output        io_p2_out_36_valid,
  output [31:0] io_p2_out_36_bits,
  input         io_p2_out_37_ready,
  output        io_p2_out_37_valid,
  output [31:0] io_p2_out_37_bits,
  input         io_p2_out_38_ready,
  output        io_p2_out_38_valid,
  output [31:0] io_p2_out_38_bits,
  input         io_p2_out_39_ready,
  output        io_p2_out_39_valid,
  output [31:0] io_p2_out_39_bits,
  input         io_p2_out_40_ready,
  output        io_p2_out_40_valid,
  output [31:0] io_p2_out_40_bits,
  input         io_p2_out_41_ready,
  output        io_p2_out_41_valid,
  output [31:0] io_p2_out_41_bits,
  input         io_p2_out_42_ready,
  output        io_p2_out_42_valid,
  output [31:0] io_p2_out_42_bits,
  input         io_p2_out_43_ready,
  output        io_p2_out_43_valid,
  output [31:0] io_p2_out_43_bits,
  input         io_p2_out_44_ready,
  output        io_p2_out_44_valid,
  output [31:0] io_p2_out_44_bits,
  input         io_p2_out_45_ready,
  output        io_p2_out_45_valid,
  output [31:0] io_p2_out_45_bits,
  input         io_p2_out_46_ready,
  output        io_p2_out_46_valid,
  output [31:0] io_p2_out_46_bits,
  input         io_p2_out_47_ready,
  output        io_p2_out_47_valid,
  output [31:0] io_p2_out_47_bits,
  input         io_p2_out_48_ready,
  output        io_p2_out_48_valid,
  output [31:0] io_p2_out_48_bits,
  input         io_p2_out_49_ready,
  output        io_p2_out_49_valid,
  output [31:0] io_p2_out_49_bits,
  input         io_p2_out_50_ready,
  output        io_p2_out_50_valid,
  output [31:0] io_p2_out_50_bits,
  input         io_p2_out_51_ready,
  output        io_p2_out_51_valid,
  output [31:0] io_p2_out_51_bits,
  input         io_p2_out_52_ready,
  output        io_p2_out_52_valid,
  output [31:0] io_p2_out_52_bits,
  input         io_p2_out_53_ready,
  output        io_p2_out_53_valid,
  output [31:0] io_p2_out_53_bits,
  input         io_p2_out_54_ready,
  output        io_p2_out_54_valid,
  output [31:0] io_p2_out_54_bits,
  input         io_p2_out_55_ready,
  output        io_p2_out_55_valid,
  output [31:0] io_p2_out_55_bits,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  input         io_R_array_index_4_ready,
  output        io_R_array_index_4_valid,
  output [31:0] io_R_array_index_4_bits,
  input         io_R_array_index_5_ready,
  output        io_R_array_index_5_valid,
  output [31:0] io_R_array_index_5_bits,
  input         io_R_array_index_6_ready,
  output        io_R_array_index_6_valid,
  output [31:0] io_R_array_index_6_bits,
  input         io_R_array_index_7_ready,
  output        io_R_array_index_7_valid,
  output [31:0] io_R_array_index_7_bits,
  input         io_R_array_index_8_ready,
  output        io_R_array_index_8_valid,
  output [31:0] io_R_array_index_8_bits,
  input         io_R_array_index_9_ready,
  output        io_R_array_index_9_valid,
  output [31:0] io_R_array_index_9_bits,
  input         io_R_array_index_10_ready,
  output        io_R_array_index_10_valid,
  output [31:0] io_R_array_index_10_bits,
  input         io_R_array_index_11_ready,
  output        io_R_array_index_11_valid,
  output [31:0] io_R_array_index_11_bits,
  input         io_R_array_index_12_ready,
  output        io_R_array_index_12_valid,
  output [31:0] io_R_array_index_12_bits,
  input         io_R_array_index_13_ready,
  output        io_R_array_index_13_valid,
  output [31:0] io_R_array_index_13_bits,
  input         io_R_array_index_14_ready,
  output        io_R_array_index_14_valid,
  output [31:0] io_R_array_index_14_bits,
  input         io_R_array_index_15_ready,
  output        io_R_array_index_15_valid,
  output [31:0] io_R_array_index_15_bits,
  input         io_R_array_index_16_ready,
  output        io_R_array_index_16_valid,
  output [31:0] io_R_array_index_16_bits,
  input         io_R_array_index_17_ready,
  output        io_R_array_index_17_valid,
  output [31:0] io_R_array_index_17_bits,
  input         io_R_array_index_18_ready,
  output        io_R_array_index_18_valid,
  output [31:0] io_R_array_index_18_bits,
  input         io_R_array_index_19_ready,
  output        io_R_array_index_19_valid,
  output [31:0] io_R_array_index_19_bits,
  input         io_R_array_index_20_ready,
  output        io_R_array_index_20_valid,
  output [31:0] io_R_array_index_20_bits,
  input         io_R_array_index_21_ready,
  output        io_R_array_index_21_valid,
  output [31:0] io_R_array_index_21_bits,
  input         io_R_array_index_22_ready,
  output        io_R_array_index_22_valid,
  output [31:0] io_R_array_index_22_bits,
  input         io_R_array_index_23_ready,
  output        io_R_array_index_23_valid,
  output [31:0] io_R_array_index_23_bits,
  input         io_R_array_index_24_ready,
  output        io_R_array_index_24_valid,
  output [31:0] io_R_array_index_24_bits,
  input         io_R_array_index_25_ready,
  output        io_R_array_index_25_valid,
  output [31:0] io_R_array_index_25_bits,
  input         io_R_array_index_26_ready,
  output        io_R_array_index_26_valid,
  output [31:0] io_R_array_index_26_bits,
  input         io_R_array_index_27_ready,
  output        io_R_array_index_27_valid,
  output [31:0] io_R_array_index_27_bits,
  input         io_R_array_index_28_ready,
  output        io_R_array_index_28_valid,
  output [31:0] io_R_array_index_28_bits,
  input         io_R_array_index_29_ready,
  output        io_R_array_index_29_valid,
  output [31:0] io_R_array_index_29_bits,
  input         io_R_array_index_30_ready,
  output        io_R_array_index_30_valid,
  output [31:0] io_R_array_index_30_bits,
  input         io_R_array_index_31_ready,
  output        io_R_array_index_31_valid,
  output [31:0] io_R_array_index_31_bits,
  input         io_R_array_index_32_ready,
  output        io_R_array_index_32_valid,
  output [31:0] io_R_array_index_32_bits,
  input         io_R_array_index_33_ready,
  output        io_R_array_index_33_valid,
  output [31:0] io_R_array_index_33_bits,
  input         io_R_array_index_34_ready,
  output        io_R_array_index_34_valid,
  output [31:0] io_R_array_index_34_bits,
  input         io_R_array_index_35_ready,
  output        io_R_array_index_35_valid,
  output [31:0] io_R_array_index_35_bits,
  input         io_R_array_index_36_ready,
  output        io_R_array_index_36_valid,
  output [31:0] io_R_array_index_36_bits,
  input         io_R_array_index_37_ready,
  output        io_R_array_index_37_valid,
  output [31:0] io_R_array_index_37_bits,
  input         io_R_array_index_38_ready,
  output        io_R_array_index_38_valid,
  output [31:0] io_R_array_index_38_bits,
  input         io_R_array_index_39_ready,
  output        io_R_array_index_39_valid,
  output [31:0] io_R_array_index_39_bits,
  input         io_R_array_index_40_ready,
  output        io_R_array_index_40_valid,
  output [31:0] io_R_array_index_40_bits,
  input         io_R_array_index_41_ready,
  output        io_R_array_index_41_valid,
  output [31:0] io_R_array_index_41_bits,
  input         io_R_array_index_42_ready,
  output        io_R_array_index_42_valid,
  output [31:0] io_R_array_index_42_bits,
  input         io_R_array_index_43_ready,
  output        io_R_array_index_43_valid,
  output [31:0] io_R_array_index_43_bits,
  input         io_R_array_index_44_ready,
  output        io_R_array_index_44_valid,
  output [31:0] io_R_array_index_44_bits,
  input         io_R_array_index_45_ready,
  output        io_R_array_index_45_valid,
  output [31:0] io_R_array_index_45_bits,
  input         io_R_array_index_46_ready,
  output        io_R_array_index_46_valid,
  output [31:0] io_R_array_index_46_bits,
  input         io_R_array_index_47_ready,
  output        io_R_array_index_47_valid,
  output [31:0] io_R_array_index_47_bits,
  input         io_R_array_index_48_ready,
  output        io_R_array_index_48_valid,
  output [31:0] io_R_array_index_48_bits,
  input         io_R_array_index_49_ready,
  output        io_R_array_index_49_valid,
  output [31:0] io_R_array_index_49_bits,
  input         io_R_array_index_50_ready,
  output        io_R_array_index_50_valid,
  output [31:0] io_R_array_index_50_bits,
  input         io_R_array_index_51_ready,
  output        io_R_array_index_51_valid,
  output [31:0] io_R_array_index_51_bits,
  input         io_R_array_index_52_ready,
  output        io_R_array_index_52_valid,
  output [31:0] io_R_array_index_52_bits,
  input         io_R_array_index_53_ready,
  output        io_R_array_index_53_valid,
  output [31:0] io_R_array_index_53_bits,
  input         io_R_array_index_54_ready,
  output        io_R_array_index_54_valid,
  output [31:0] io_R_array_index_54_bits,
  input         io_R_array_index_55_ready,
  output        io_R_array_index_55_valid,
  output [31:0] io_R_array_index_55_bits,
  output        io_p1_end_0,
  output        io_p1_end_1,
  output        io_p1_end_2,
  output        io_p1_end_3,
  output        io_p1_end_4,
  output        io_p1_end_5,
  output        io_p1_end_6,
  output        io_p1_end_7,
  output        io_p1_end_8,
  output        io_p1_end_9,
  output        io_p1_end_10,
  output        io_p1_end_11,
  output        io_p1_end_12,
  output        io_p1_end_13,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  output [63:0] io_uram_out_a_4,
  output [63:0] io_uram_out_a_5,
  output [63:0] io_uram_out_a_6,
  output [63:0] io_uram_out_a_7,
  output [63:0] io_uram_out_a_8,
  output [63:0] io_uram_out_a_9,
  output [63:0] io_uram_out_a_10,
  output [63:0] io_uram_out_a_11,
  output [63:0] io_uram_out_a_12,
  output [63:0] io_uram_out_a_13,
  output [63:0] io_uram_out_a_14,
  output [63:0] io_uram_out_a_15,
  output [63:0] io_uram_out_a_16,
  output [63:0] io_uram_out_a_17,
  output [63:0] io_uram_out_a_18,
  output [63:0] io_uram_out_a_19,
  output [63:0] io_uram_out_a_20,
  output [63:0] io_uram_out_a_21,
  output [63:0] io_uram_out_a_22,
  output [63:0] io_uram_out_a_23,
  output [63:0] io_uram_out_a_24,
  output [63:0] io_uram_out_a_25,
  output [63:0] io_uram_out_a_26,
  output [63:0] io_uram_out_a_27,
  output [63:0] io_uram_out_a_28,
  output [63:0] io_uram_out_a_29,
  output [63:0] io_uram_out_a_30,
  output [63:0] io_uram_out_a_31,
  output [63:0] io_uram_out_a_32,
  output [63:0] io_uram_out_a_33,
  output [63:0] io_uram_out_a_34,
  output [63:0] io_uram_out_a_35,
  output [63:0] io_uram_out_a_36,
  output [63:0] io_uram_out_a_37,
  output [63:0] io_uram_out_a_38,
  output [63:0] io_uram_out_a_39,
  output [63:0] io_uram_out_a_40,
  output [63:0] io_uram_out_a_41,
  output [63:0] io_uram_out_a_42,
  output [63:0] io_uram_out_a_43,
  output [63:0] io_uram_out_a_44,
  output [63:0] io_uram_out_a_45,
  output [63:0] io_uram_out_a_46,
  output [63:0] io_uram_out_a_47,
  output [63:0] io_uram_out_a_48,
  output [63:0] io_uram_out_a_49,
  output [63:0] io_uram_out_a_50,
  output [63:0] io_uram_out_a_51,
  output [63:0] io_uram_out_a_52,
  output [63:0] io_uram_out_a_53,
  output [63:0] io_uram_out_a_54,
  output [63:0] io_uram_out_a_55,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3,
  input  [19:0] io_uram_addr_a_4,
  input  [19:0] io_uram_addr_a_5,
  input  [19:0] io_uram_addr_a_6,
  input  [19:0] io_uram_addr_a_7,
  input  [19:0] io_uram_addr_a_8,
  input  [19:0] io_uram_addr_a_9,
  input  [19:0] io_uram_addr_a_10,
  input  [19:0] io_uram_addr_a_11,
  input  [19:0] io_uram_addr_a_12,
  input  [19:0] io_uram_addr_a_13,
  input  [19:0] io_uram_addr_a_14,
  input  [19:0] io_uram_addr_a_15,
  input  [19:0] io_uram_addr_a_16,
  input  [19:0] io_uram_addr_a_17,
  input  [19:0] io_uram_addr_a_18,
  input  [19:0] io_uram_addr_a_19,
  input  [19:0] io_uram_addr_a_20,
  input  [19:0] io_uram_addr_a_21,
  input  [19:0] io_uram_addr_a_22,
  input  [19:0] io_uram_addr_a_23,
  input  [19:0] io_uram_addr_a_24,
  input  [19:0] io_uram_addr_a_25,
  input  [19:0] io_uram_addr_a_26,
  input  [19:0] io_uram_addr_a_27,
  input  [19:0] io_uram_addr_a_28,
  input  [19:0] io_uram_addr_a_29,
  input  [19:0] io_uram_addr_a_30,
  input  [19:0] io_uram_addr_a_31,
  input  [19:0] io_uram_addr_a_32,
  input  [19:0] io_uram_addr_a_33,
  input  [19:0] io_uram_addr_a_34,
  input  [19:0] io_uram_addr_a_35,
  input  [19:0] io_uram_addr_a_36,
  input  [19:0] io_uram_addr_a_37,
  input  [19:0] io_uram_addr_a_38,
  input  [19:0] io_uram_addr_a_39,
  input  [19:0] io_uram_addr_a_40,
  input  [19:0] io_uram_addr_a_41,
  input  [19:0] io_uram_addr_a_42,
  input  [19:0] io_uram_addr_a_43,
  input  [19:0] io_uram_addr_a_44,
  input  [19:0] io_uram_addr_a_45,
  input  [19:0] io_uram_addr_a_46,
  input  [19:0] io_uram_addr_a_47,
  input  [19:0] io_uram_addr_a_48,
  input  [19:0] io_uram_addr_a_49,
  input  [19:0] io_uram_addr_a_50,
  input  [19:0] io_uram_addr_a_51,
  input  [19:0] io_uram_addr_a_52,
  input  [19:0] io_uram_addr_a_53,
  input  [19:0] io_uram_addr_a_54,
  input  [19:0] io_uram_addr_a_55
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
  reg [31:0] _RAND_32;
  reg [31:0] _RAND_33;
  reg [31:0] _RAND_34;
  reg [31:0] _RAND_35;
  reg [31:0] _RAND_36;
  reg [31:0] _RAND_37;
  reg [31:0] _RAND_38;
  reg [31:0] _RAND_39;
  reg [31:0] _RAND_40;
  reg [31:0] _RAND_41;
  reg [31:0] _RAND_42;
  reg [31:0] _RAND_43;
  reg [31:0] _RAND_44;
  reg [31:0] _RAND_45;
  reg [31:0] _RAND_46;
  reg [31:0] _RAND_47;
  reg [31:0] _RAND_48;
  reg [31:0] _RAND_49;
  reg [31:0] _RAND_50;
  reg [31:0] _RAND_51;
  reg [31:0] _RAND_52;
  reg [31:0] _RAND_53;
  reg [31:0] _RAND_54;
  reg [31:0] _RAND_55;
  reg [31:0] _RAND_56;
  reg [31:0] _RAND_57;
  reg [31:0] _RAND_58;
  reg [31:0] _RAND_59;
  reg [31:0] _RAND_60;
  reg [31:0] _RAND_61;
  reg [31:0] _RAND_62;
  reg [31:0] _RAND_63;
  reg [31:0] _RAND_64;
  reg [31:0] _RAND_65;
  reg [31:0] _RAND_66;
  reg [31:0] _RAND_67;
  reg [31:0] _RAND_68;
  reg [31:0] _RAND_69;
  reg [31:0] _RAND_70;
  reg [31:0] _RAND_71;
  reg [31:0] _RAND_72;
  reg [31:0] _RAND_73;
  reg [31:0] _RAND_74;
  reg [31:0] _RAND_75;
  reg [31:0] _RAND_76;
  reg [31:0] _RAND_77;
  reg [31:0] _RAND_78;
  reg [63:0] _RAND_79;
  reg [31:0] _RAND_80;
  reg [63:0] _RAND_81;
  reg [31:0] _RAND_82;
  reg [63:0] _RAND_83;
  reg [31:0] _RAND_84;
  reg [63:0] _RAND_85;
  reg [31:0] _RAND_86;
  reg [31:0] _RAND_87;
  reg [63:0] _RAND_88;
  reg [31:0] _RAND_89;
  reg [63:0] _RAND_90;
  reg [31:0] _RAND_91;
  reg [63:0] _RAND_92;
  reg [31:0] _RAND_93;
  reg [63:0] _RAND_94;
  reg [31:0] _RAND_95;
  reg [31:0] _RAND_96;
  reg [63:0] _RAND_97;
  reg [31:0] _RAND_98;
  reg [63:0] _RAND_99;
  reg [31:0] _RAND_100;
  reg [63:0] _RAND_101;
  reg [31:0] _RAND_102;
  reg [63:0] _RAND_103;
  reg [31:0] _RAND_104;
  reg [31:0] _RAND_105;
  reg [63:0] _RAND_106;
  reg [31:0] _RAND_107;
  reg [63:0] _RAND_108;
  reg [31:0] _RAND_109;
  reg [63:0] _RAND_110;
  reg [31:0] _RAND_111;
  reg [63:0] _RAND_112;
  reg [31:0] _RAND_113;
  reg [31:0] _RAND_114;
  reg [63:0] _RAND_115;
  reg [31:0] _RAND_116;
  reg [63:0] _RAND_117;
  reg [31:0] _RAND_118;
  reg [63:0] _RAND_119;
  reg [31:0] _RAND_120;
  reg [63:0] _RAND_121;
  reg [31:0] _RAND_122;
  reg [31:0] _RAND_123;
  reg [63:0] _RAND_124;
  reg [31:0] _RAND_125;
  reg [63:0] _RAND_126;
  reg [31:0] _RAND_127;
  reg [63:0] _RAND_128;
  reg [31:0] _RAND_129;
  reg [63:0] _RAND_130;
  reg [31:0] _RAND_131;
  reg [31:0] _RAND_132;
  reg [63:0] _RAND_133;
  reg [31:0] _RAND_134;
  reg [63:0] _RAND_135;
  reg [31:0] _RAND_136;
  reg [63:0] _RAND_137;
  reg [31:0] _RAND_138;
  reg [63:0] _RAND_139;
  reg [31:0] _RAND_140;
  reg [31:0] _RAND_141;
  reg [63:0] _RAND_142;
  reg [31:0] _RAND_143;
  reg [63:0] _RAND_144;
  reg [31:0] _RAND_145;
  reg [63:0] _RAND_146;
  reg [31:0] _RAND_147;
  reg [63:0] _RAND_148;
  reg [31:0] _RAND_149;
  reg [31:0] _RAND_150;
  reg [63:0] _RAND_151;
  reg [31:0] _RAND_152;
  reg [63:0] _RAND_153;
  reg [31:0] _RAND_154;
  reg [63:0] _RAND_155;
  reg [31:0] _RAND_156;
  reg [63:0] _RAND_157;
  reg [31:0] _RAND_158;
  reg [31:0] _RAND_159;
  reg [63:0] _RAND_160;
  reg [31:0] _RAND_161;
  reg [63:0] _RAND_162;
  reg [31:0] _RAND_163;
  reg [63:0] _RAND_164;
  reg [31:0] _RAND_165;
  reg [63:0] _RAND_166;
  reg [31:0] _RAND_167;
  reg [31:0] _RAND_168;
  reg [63:0] _RAND_169;
  reg [31:0] _RAND_170;
  reg [63:0] _RAND_171;
  reg [31:0] _RAND_172;
  reg [63:0] _RAND_173;
  reg [31:0] _RAND_174;
  reg [63:0] _RAND_175;
  reg [31:0] _RAND_176;
  reg [31:0] _RAND_177;
  reg [63:0] _RAND_178;
  reg [31:0] _RAND_179;
  reg [63:0] _RAND_180;
  reg [31:0] _RAND_181;
  reg [63:0] _RAND_182;
  reg [31:0] _RAND_183;
  reg [63:0] _RAND_184;
  reg [31:0] _RAND_185;
  reg [31:0] _RAND_186;
  reg [63:0] _RAND_187;
  reg [31:0] _RAND_188;
  reg [63:0] _RAND_189;
  reg [31:0] _RAND_190;
  reg [63:0] _RAND_191;
  reg [31:0] _RAND_192;
  reg [63:0] _RAND_193;
  reg [31:0] _RAND_194;
  reg [31:0] _RAND_195;
  reg [63:0] _RAND_196;
  reg [31:0] _RAND_197;
  reg [63:0] _RAND_198;
  reg [31:0] _RAND_199;
  reg [63:0] _RAND_200;
  reg [31:0] _RAND_201;
  reg [63:0] _RAND_202;
  reg [31:0] _RAND_203;
`endif // RANDOMIZE_REG_INIT
  wire  pipeline_clock; // @[SLR1.scala 51:65]
  wire  pipeline_reset; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_1_clock; // @[SLR1.scala 51:65]
  wire  pipeline_1_reset; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_1_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_2_clock; // @[SLR1.scala 51:65]
  wire  pipeline_2_reset; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_2_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_3_clock; // @[SLR1.scala 51:65]
  wire  pipeline_3_reset; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_3_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_4_clock; // @[SLR1.scala 51:65]
  wire  pipeline_4_reset; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_4_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_5_clock; // @[SLR1.scala 51:65]
  wire  pipeline_5_reset; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_5_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_6_clock; // @[SLR1.scala 51:65]
  wire  pipeline_6_reset; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_6_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_7_clock; // @[SLR1.scala 51:65]
  wire  pipeline_7_reset; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_7_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_8_clock; // @[SLR1.scala 51:65]
  wire  pipeline_8_reset; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_8_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_9_clock; // @[SLR1.scala 51:65]
  wire  pipeline_9_reset; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_9_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_10_clock; // @[SLR1.scala 51:65]
  wire  pipeline_10_reset; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_10_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_11_clock; // @[SLR1.scala 51:65]
  wire  pipeline_11_reset; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_11_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_12_clock; // @[SLR1.scala 51:65]
  wire  pipeline_12_reset; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_12_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  pipeline_13_clock; // @[SLR1.scala 51:65]
  wire  pipeline_13_reset; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_flag; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_end; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_start; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_start_init; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_end; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_last_iteration; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_init_bram; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_pull_count; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_level; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSR_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSR_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSC_R_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSC_C_offset; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_level_offset; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_0_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_1_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_2_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_in_3_valid; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_frontier_in_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p2_out_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_3_bits; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_node_num; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_push_or_pull; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_root; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_0_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_0_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_0_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_1_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_1_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_1_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_2_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_2_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_2_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_3_ready; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_R_array_index_3_valid; // @[SLR1.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_3_bits; // @[SLR1.scala 51:65]
  wire  pipeline_13_io_p1_end; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_0; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_1; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_2; // @[SLR1.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_3; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_0; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_1; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_2; // @[SLR1.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_3; // @[SLR1.scala 51:65]
  wire  copy_start_clock; // @[SLR1.scala 54:28]
  wire  copy_start_reset; // @[SLR1.scala 54:28]
  wire  copy_start_io_in; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_0; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_1; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_2; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_3; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_4; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_5; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_6; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_7; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_8; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_9; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_10; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_11; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_12; // @[SLR1.scala 54:28]
  wire  copy_start_io_out_13; // @[SLR1.scala 54:28]
  wire  copy_frontier_flag_clock; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_reset; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_in; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_0; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_1; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_2; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_3; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_4; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_5; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_6; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_7; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_8; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_9; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_10; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_11; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_12; // @[SLR1.scala 56:36]
  wire  copy_frontier_flag_io_out_13; // @[SLR1.scala 56:36]
  wire  copy_current_level_clock; // @[SLR1.scala 57:36]
  wire  copy_current_level_reset; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_in; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_0; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_1; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_2; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_3; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_4; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_5; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_6; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_7; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_8; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_9; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_10; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_11; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_12; // @[SLR1.scala 57:36]
  wire [31:0] copy_current_level_io_out_13; // @[SLR1.scala 57:36]
  wire  copy_p2_end_clock; // @[SLR1.scala 58:29]
  wire  copy_p2_end_reset; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_in; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_0; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_1; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_2; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_3; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_4; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_5; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_6; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_7; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_8; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_9; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_10; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_11; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_12; // @[SLR1.scala 58:29]
  wire  copy_p2_end_io_out_13; // @[SLR1.scala 58:29]
  wire  copy_push_or_pull_clock; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_reset; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_in; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_0; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_1; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_2; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_3; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_4; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_5; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_6; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_7; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_8; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_9; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_10; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_11; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_12; // @[SLR1.scala 59:35]
  wire  copy_push_or_pull_io_out_13; // @[SLR1.scala 59:35]
  wire  copy_node_num_clock; // @[SLR1.scala 60:31]
  wire  copy_node_num_reset; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_in; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_0; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_1; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_2; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_3; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_4; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_5; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_6; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_7; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_8; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_9; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_10; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_11; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_12; // @[SLR1.scala 60:31]
  wire [31:0] copy_node_num_io_out_13; // @[SLR1.scala 60:31]
  wire  copy_root_clock; // @[SLR1.scala 61:27]
  wire  copy_root_reset; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_in; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_0; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_1; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_2; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_3; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_4; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_5; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_6; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_7; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_8; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_9; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_10; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_11; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_12; // @[SLR1.scala 61:27]
  wire [31:0] copy_root_io_out_13; // @[SLR1.scala 61:27]
  wire  copy_offset_CSR_R_offset_clock; // @[SLR1.scala 72:42]
  wire  copy_offset_CSR_R_offset_reset; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_in; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_0; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_1; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_2; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_3; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_4; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_5; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_6; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_7; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_8; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_9; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_10; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_11; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_12; // @[SLR1.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_13; // @[SLR1.scala 72:42]
  wire  copy_offset_CSR_C_offset_clock; // @[SLR1.scala 73:42]
  wire  copy_offset_CSR_C_offset_reset; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_in; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_0; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_1; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_2; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_3; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_4; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_5; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_6; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_7; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_8; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_9; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_10; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_11; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_12; // @[SLR1.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_13; // @[SLR1.scala 73:42]
  wire  copy_offset_CSC_R_offset_clock; // @[SLR1.scala 74:42]
  wire  copy_offset_CSC_R_offset_reset; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_in; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_0; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_1; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_2; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_3; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_4; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_5; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_6; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_7; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_8; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_9; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_10; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_11; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_12; // @[SLR1.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_13; // @[SLR1.scala 74:42]
  wire  copy_offset_CSC_C_offset_clock; // @[SLR1.scala 75:42]
  wire  copy_offset_CSC_C_offset_reset; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_in; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_0; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_1; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_2; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_3; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_4; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_5; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_6; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_7; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_8; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_9; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_10; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_11; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_12; // @[SLR1.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_13; // @[SLR1.scala 75:42]
  wire  copy_offset_level_offset_clock; // @[SLR1.scala 76:42]
  wire  copy_offset_level_offset_reset; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_in; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_0; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_1; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_2; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_3; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_4; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_5; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_6; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_7; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_8; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_9; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_10; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_11; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_12; // @[SLR1.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_13; // @[SLR1.scala 76:42]
  reg  reset_reg; // @[SLR1.scala 46:28]
  reg  reset_reg_array_0; // @[SLR1.scala 47:74]
  reg  reset_reg_array_1; // @[SLR1.scala 47:74]
  reg  reset_reg_array_2; // @[SLR1.scala 47:74]
  reg  reset_reg_array_3; // @[SLR1.scala 47:74]
  reg  reset_reg_array_4; // @[SLR1.scala 47:74]
  reg  reset_reg_array_5; // @[SLR1.scala 47:74]
  reg  reset_reg_array_6; // @[SLR1.scala 47:74]
  reg  reset_reg_array_7; // @[SLR1.scala 47:74]
  reg  reset_reg_array_8; // @[SLR1.scala 47:74]
  reg  reset_reg_array_9; // @[SLR1.scala 47:74]
  reg  reset_reg_array_10; // @[SLR1.scala 47:74]
  reg  reset_reg_array_11; // @[SLR1.scala 47:74]
  reg  reset_reg_array_12; // @[SLR1.scala 47:74]
  reg  reset_reg_array_13; // @[SLR1.scala 47:74]
  reg [31:0] _T_14; // @[SLR1.scala 69:35]
  reg [31:0] _T_15; // @[SLR1.scala 70:31]
  reg [31:0] _T_16; // @[SLR1.scala 77:46]
  reg [31:0] _T_17; // @[SLR1.scala 78:46]
  reg [31:0] _T_18; // @[SLR1.scala 79:46]
  reg [31:0] _T_19; // @[SLR1.scala 80:46]
  reg [31:0] _T_20; // @[SLR1.scala 81:46]
  reg [31:0] r_array_count_0; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_1; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_2; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_3; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_4; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_5; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_6; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_7; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_8; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_9; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_10; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_11; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_12; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_13; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_14; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_15; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_16; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_17; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_18; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_19; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_20; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_21; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_22; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_23; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_24; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_25; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_26; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_27; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_28; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_29; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_30; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_31; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_32; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_33; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_34; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_35; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_36; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_37; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_38; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_39; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_40; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_41; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_42; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_43; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_44; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_45; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_46; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_47; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_48; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_49; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_50; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_51; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_52; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_53; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_54; // @[SLR1.scala 83:32]
  reg [31:0] r_array_count_55; // @[SLR1.scala 83:32]
  wire [32:0] _T_22 = r_array_count_0 + r_array_count_1; // @[SLR1.scala 84:53]
  wire [31:0] _T_23 = r_array_count_0 + r_array_count_1; // @[SLR1.scala 84:53]
  wire [32:0] _T_24 = _T_23 + r_array_count_2; // @[SLR1.scala 84:53]
  wire [31:0] _T_25 = _T_23 + r_array_count_2; // @[SLR1.scala 84:53]
  wire [32:0] _T_26 = _T_25 + r_array_count_3; // @[SLR1.scala 84:53]
  wire [31:0] _T_27 = _T_25 + r_array_count_3; // @[SLR1.scala 84:53]
  wire [32:0] _T_28 = _T_27 + r_array_count_4; // @[SLR1.scala 84:53]
  wire [31:0] _T_29 = _T_27 + r_array_count_4; // @[SLR1.scala 84:53]
  wire [32:0] _T_30 = _T_29 + r_array_count_5; // @[SLR1.scala 84:53]
  wire [31:0] _T_31 = _T_29 + r_array_count_5; // @[SLR1.scala 84:53]
  wire [32:0] _T_32 = _T_31 + r_array_count_6; // @[SLR1.scala 84:53]
  wire [31:0] _T_33 = _T_31 + r_array_count_6; // @[SLR1.scala 84:53]
  wire [32:0] _T_34 = _T_33 + r_array_count_7; // @[SLR1.scala 84:53]
  wire [31:0] _T_35 = _T_33 + r_array_count_7; // @[SLR1.scala 84:53]
  wire [32:0] _T_36 = _T_35 + r_array_count_8; // @[SLR1.scala 84:53]
  wire [31:0] _T_37 = _T_35 + r_array_count_8; // @[SLR1.scala 84:53]
  wire [32:0] _T_38 = _T_37 + r_array_count_9; // @[SLR1.scala 84:53]
  wire [31:0] _T_39 = _T_37 + r_array_count_9; // @[SLR1.scala 84:53]
  wire [32:0] _T_40 = _T_39 + r_array_count_10; // @[SLR1.scala 84:53]
  wire [31:0] _T_41 = _T_39 + r_array_count_10; // @[SLR1.scala 84:53]
  wire [32:0] _T_42 = _T_41 + r_array_count_11; // @[SLR1.scala 84:53]
  wire [31:0] _T_43 = _T_41 + r_array_count_11; // @[SLR1.scala 84:53]
  wire [32:0] _T_44 = _T_43 + r_array_count_12; // @[SLR1.scala 84:53]
  wire [31:0] _T_45 = _T_43 + r_array_count_12; // @[SLR1.scala 84:53]
  wire [32:0] _T_46 = _T_45 + r_array_count_13; // @[SLR1.scala 84:53]
  wire [31:0] _T_47 = _T_45 + r_array_count_13; // @[SLR1.scala 84:53]
  wire [32:0] _T_48 = _T_47 + r_array_count_14; // @[SLR1.scala 84:53]
  wire [31:0] _T_49 = _T_47 + r_array_count_14; // @[SLR1.scala 84:53]
  wire [32:0] _T_50 = _T_49 + r_array_count_15; // @[SLR1.scala 84:53]
  wire [31:0] _T_51 = _T_49 + r_array_count_15; // @[SLR1.scala 84:53]
  wire [32:0] _T_52 = _T_51 + r_array_count_16; // @[SLR1.scala 84:53]
  wire [31:0] _T_53 = _T_51 + r_array_count_16; // @[SLR1.scala 84:53]
  wire [32:0] _T_54 = _T_53 + r_array_count_17; // @[SLR1.scala 84:53]
  wire [31:0] _T_55 = _T_53 + r_array_count_17; // @[SLR1.scala 84:53]
  wire [32:0] _T_56 = _T_55 + r_array_count_18; // @[SLR1.scala 84:53]
  wire [31:0] _T_57 = _T_55 + r_array_count_18; // @[SLR1.scala 84:53]
  wire [32:0] _T_58 = _T_57 + r_array_count_19; // @[SLR1.scala 84:53]
  wire [31:0] _T_59 = _T_57 + r_array_count_19; // @[SLR1.scala 84:53]
  wire [32:0] _T_60 = _T_59 + r_array_count_20; // @[SLR1.scala 84:53]
  wire [31:0] _T_61 = _T_59 + r_array_count_20; // @[SLR1.scala 84:53]
  wire [32:0] _T_62 = _T_61 + r_array_count_21; // @[SLR1.scala 84:53]
  wire [31:0] _T_63 = _T_61 + r_array_count_21; // @[SLR1.scala 84:53]
  wire [32:0] _T_64 = _T_63 + r_array_count_22; // @[SLR1.scala 84:53]
  wire [31:0] _T_65 = _T_63 + r_array_count_22; // @[SLR1.scala 84:53]
  wire [32:0] _T_66 = _T_65 + r_array_count_23; // @[SLR1.scala 84:53]
  wire [31:0] _T_67 = _T_65 + r_array_count_23; // @[SLR1.scala 84:53]
  wire [32:0] _T_68 = _T_67 + r_array_count_24; // @[SLR1.scala 84:53]
  wire [31:0] _T_69 = _T_67 + r_array_count_24; // @[SLR1.scala 84:53]
  wire [32:0] _T_70 = _T_69 + r_array_count_25; // @[SLR1.scala 84:53]
  wire [31:0] _T_71 = _T_69 + r_array_count_25; // @[SLR1.scala 84:53]
  wire [32:0] _T_72 = _T_71 + r_array_count_26; // @[SLR1.scala 84:53]
  wire [31:0] _T_73 = _T_71 + r_array_count_26; // @[SLR1.scala 84:53]
  wire [32:0] _T_74 = _T_73 + r_array_count_27; // @[SLR1.scala 84:53]
  wire [31:0] _T_75 = _T_73 + r_array_count_27; // @[SLR1.scala 84:53]
  wire [32:0] _T_76 = _T_75 + r_array_count_28; // @[SLR1.scala 84:53]
  wire [31:0] _T_77 = _T_75 + r_array_count_28; // @[SLR1.scala 84:53]
  wire [32:0] _T_78 = _T_77 + r_array_count_29; // @[SLR1.scala 84:53]
  wire [31:0] _T_79 = _T_77 + r_array_count_29; // @[SLR1.scala 84:53]
  wire [32:0] _T_80 = _T_79 + r_array_count_30; // @[SLR1.scala 84:53]
  wire [31:0] _T_81 = _T_79 + r_array_count_30; // @[SLR1.scala 84:53]
  wire [32:0] _T_82 = _T_81 + r_array_count_31; // @[SLR1.scala 84:53]
  wire [31:0] _T_83 = _T_81 + r_array_count_31; // @[SLR1.scala 84:53]
  wire [32:0] _T_84 = _T_83 + r_array_count_32; // @[SLR1.scala 84:53]
  wire [31:0] _T_85 = _T_83 + r_array_count_32; // @[SLR1.scala 84:53]
  wire [32:0] _T_86 = _T_85 + r_array_count_33; // @[SLR1.scala 84:53]
  wire [31:0] _T_87 = _T_85 + r_array_count_33; // @[SLR1.scala 84:53]
  wire [32:0] _T_88 = _T_87 + r_array_count_34; // @[SLR1.scala 84:53]
  wire [31:0] _T_89 = _T_87 + r_array_count_34; // @[SLR1.scala 84:53]
  wire [32:0] _T_90 = _T_89 + r_array_count_35; // @[SLR1.scala 84:53]
  wire [31:0] _T_91 = _T_89 + r_array_count_35; // @[SLR1.scala 84:53]
  wire [32:0] _T_92 = _T_91 + r_array_count_36; // @[SLR1.scala 84:53]
  wire [31:0] _T_93 = _T_91 + r_array_count_36; // @[SLR1.scala 84:53]
  wire [32:0] _T_94 = _T_93 + r_array_count_37; // @[SLR1.scala 84:53]
  wire [31:0] _T_95 = _T_93 + r_array_count_37; // @[SLR1.scala 84:53]
  wire [32:0] _T_96 = _T_95 + r_array_count_38; // @[SLR1.scala 84:53]
  wire [31:0] _T_97 = _T_95 + r_array_count_38; // @[SLR1.scala 84:53]
  wire [32:0] _T_98 = _T_97 + r_array_count_39; // @[SLR1.scala 84:53]
  wire [31:0] _T_99 = _T_97 + r_array_count_39; // @[SLR1.scala 84:53]
  wire [32:0] _T_100 = _T_99 + r_array_count_40; // @[SLR1.scala 84:53]
  wire [31:0] _T_101 = _T_99 + r_array_count_40; // @[SLR1.scala 84:53]
  wire [32:0] _T_102 = _T_101 + r_array_count_41; // @[SLR1.scala 84:53]
  wire [31:0] _T_103 = _T_101 + r_array_count_41; // @[SLR1.scala 84:53]
  wire [32:0] _T_104 = _T_103 + r_array_count_42; // @[SLR1.scala 84:53]
  wire [31:0] _T_105 = _T_103 + r_array_count_42; // @[SLR1.scala 84:53]
  wire [32:0] _T_106 = _T_105 + r_array_count_43; // @[SLR1.scala 84:53]
  wire [31:0] _T_107 = _T_105 + r_array_count_43; // @[SLR1.scala 84:53]
  wire [32:0] _T_108 = _T_107 + r_array_count_44; // @[SLR1.scala 84:53]
  wire [31:0] _T_109 = _T_107 + r_array_count_44; // @[SLR1.scala 84:53]
  wire [32:0] _T_110 = _T_109 + r_array_count_45; // @[SLR1.scala 84:53]
  wire [31:0] _T_111 = _T_109 + r_array_count_45; // @[SLR1.scala 84:53]
  wire [32:0] _T_112 = _T_111 + r_array_count_46; // @[SLR1.scala 84:53]
  wire [31:0] _T_113 = _T_111 + r_array_count_46; // @[SLR1.scala 84:53]
  wire [32:0] _T_114 = _T_113 + r_array_count_47; // @[SLR1.scala 84:53]
  wire [31:0] _T_115 = _T_113 + r_array_count_47; // @[SLR1.scala 84:53]
  wire [32:0] _T_116 = _T_115 + r_array_count_48; // @[SLR1.scala 84:53]
  wire [31:0] _T_117 = _T_115 + r_array_count_48; // @[SLR1.scala 84:53]
  wire [32:0] _T_118 = _T_117 + r_array_count_49; // @[SLR1.scala 84:53]
  wire [31:0] _T_119 = _T_117 + r_array_count_49; // @[SLR1.scala 84:53]
  wire [32:0] _T_120 = _T_119 + r_array_count_50; // @[SLR1.scala 84:53]
  wire [31:0] _T_121 = _T_119 + r_array_count_50; // @[SLR1.scala 84:53]
  wire [32:0] _T_122 = _T_121 + r_array_count_51; // @[SLR1.scala 84:53]
  wire [31:0] _T_123 = _T_121 + r_array_count_51; // @[SLR1.scala 84:53]
  wire [32:0] _T_124 = _T_123 + r_array_count_52; // @[SLR1.scala 84:53]
  wire [31:0] _T_125 = _T_123 + r_array_count_52; // @[SLR1.scala 84:53]
  wire [32:0] _T_126 = _T_125 + r_array_count_53; // @[SLR1.scala 84:53]
  wire [31:0] _T_127 = _T_125 + r_array_count_53; // @[SLR1.scala 84:53]
  wire [32:0] _T_128 = _T_127 + r_array_count_54; // @[SLR1.scala 84:53]
  wire [31:0] _T_129 = _T_127 + r_array_count_54; // @[SLR1.scala 84:53]
  wire [32:0] _T_130 = _T_129 + r_array_count_55; // @[SLR1.scala 84:53]
  wire [31:0] r_array_count_total = _T_129 + r_array_count_55; // @[SLR1.scala 84:53]
  reg  _T_131; // @[SLR1.scala 115:51]
  reg [63:0] _T_132; // @[SLR1.scala 125:20]
  reg [19:0] _T_133; // @[SLR1.scala 126:62]
  wire  _T_134 = io_R_array_index_0_valid & io_R_array_index_0_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_135 = r_array_count_0 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_136 = r_array_count_0 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_0 = _T_134 ? _T_136 : r_array_count_0; // @[SLR1.scala 127:137]
  reg [63:0] _T_137; // @[SLR1.scala 125:20]
  reg [19:0] _T_138; // @[SLR1.scala 126:62]
  wire  _T_139 = io_R_array_index_1_valid & io_R_array_index_1_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_140 = r_array_count_1 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_141 = r_array_count_1 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_1 = _T_139 ? _T_141 : r_array_count_1; // @[SLR1.scala 127:137]
  reg [63:0] _T_142; // @[SLR1.scala 125:20]
  reg [19:0] _T_143; // @[SLR1.scala 126:62]
  wire  _T_144 = io_R_array_index_2_valid & io_R_array_index_2_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_145 = r_array_count_2 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_146 = r_array_count_2 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_2 = _T_144 ? _T_146 : r_array_count_2; // @[SLR1.scala 127:137]
  reg [63:0] _T_147; // @[SLR1.scala 125:20]
  reg [19:0] _T_148; // @[SLR1.scala 126:62]
  wire  _T_149 = io_R_array_index_3_valid & io_R_array_index_3_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_150 = r_array_count_3 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_151 = r_array_count_3 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_3 = _T_149 ? _T_151 : r_array_count_3; // @[SLR1.scala 127:137]
  reg  _T_152; // @[SLR1.scala 115:51]
  reg [63:0] _T_153; // @[SLR1.scala 125:20]
  reg [19:0] _T_154; // @[SLR1.scala 126:62]
  wire  _T_155 = io_R_array_index_4_valid & io_R_array_index_4_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_156 = r_array_count_4 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_157 = r_array_count_4 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_4 = _T_155 ? _T_157 : r_array_count_4; // @[SLR1.scala 127:137]
  reg [63:0] _T_158; // @[SLR1.scala 125:20]
  reg [19:0] _T_159; // @[SLR1.scala 126:62]
  wire  _T_160 = io_R_array_index_5_valid & io_R_array_index_5_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_161 = r_array_count_5 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_162 = r_array_count_5 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_5 = _T_160 ? _T_162 : r_array_count_5; // @[SLR1.scala 127:137]
  reg [63:0] _T_163; // @[SLR1.scala 125:20]
  reg [19:0] _T_164; // @[SLR1.scala 126:62]
  wire  _T_165 = io_R_array_index_6_valid & io_R_array_index_6_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_166 = r_array_count_6 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_167 = r_array_count_6 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_6 = _T_165 ? _T_167 : r_array_count_6; // @[SLR1.scala 127:137]
  reg [63:0] _T_168; // @[SLR1.scala 125:20]
  reg [19:0] _T_169; // @[SLR1.scala 126:62]
  wire  _T_170 = io_R_array_index_7_valid & io_R_array_index_7_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_171 = r_array_count_7 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_172 = r_array_count_7 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_7 = _T_170 ? _T_172 : r_array_count_7; // @[SLR1.scala 127:137]
  reg  _T_173; // @[SLR1.scala 115:51]
  reg [63:0] _T_174; // @[SLR1.scala 125:20]
  reg [19:0] _T_175; // @[SLR1.scala 126:62]
  wire  _T_176 = io_R_array_index_8_valid & io_R_array_index_8_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_177 = r_array_count_8 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_178 = r_array_count_8 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_8 = _T_176 ? _T_178 : r_array_count_8; // @[SLR1.scala 127:137]
  reg [63:0] _T_179; // @[SLR1.scala 125:20]
  reg [19:0] _T_180; // @[SLR1.scala 126:62]
  wire  _T_181 = io_R_array_index_9_valid & io_R_array_index_9_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_182 = r_array_count_9 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_183 = r_array_count_9 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_9 = _T_181 ? _T_183 : r_array_count_9; // @[SLR1.scala 127:137]
  reg [63:0] _T_184; // @[SLR1.scala 125:20]
  reg [19:0] _T_185; // @[SLR1.scala 126:62]
  wire  _T_186 = io_R_array_index_10_valid & io_R_array_index_10_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_187 = r_array_count_10 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_188 = r_array_count_10 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_10 = _T_186 ? _T_188 : r_array_count_10; // @[SLR1.scala 127:137]
  reg [63:0] _T_189; // @[SLR1.scala 125:20]
  reg [19:0] _T_190; // @[SLR1.scala 126:62]
  wire  _T_191 = io_R_array_index_11_valid & io_R_array_index_11_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_192 = r_array_count_11 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_193 = r_array_count_11 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_11 = _T_191 ? _T_193 : r_array_count_11; // @[SLR1.scala 127:137]
  reg  _T_194; // @[SLR1.scala 115:51]
  reg [63:0] _T_195; // @[SLR1.scala 125:20]
  reg [19:0] _T_196; // @[SLR1.scala 126:62]
  wire  _T_197 = io_R_array_index_12_valid & io_R_array_index_12_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_198 = r_array_count_12 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_199 = r_array_count_12 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_12 = _T_197 ? _T_199 : r_array_count_12; // @[SLR1.scala 127:137]
  reg [63:0] _T_200; // @[SLR1.scala 125:20]
  reg [19:0] _T_201; // @[SLR1.scala 126:62]
  wire  _T_202 = io_R_array_index_13_valid & io_R_array_index_13_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_203 = r_array_count_13 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_204 = r_array_count_13 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_13 = _T_202 ? _T_204 : r_array_count_13; // @[SLR1.scala 127:137]
  reg [63:0] _T_205; // @[SLR1.scala 125:20]
  reg [19:0] _T_206; // @[SLR1.scala 126:62]
  wire  _T_207 = io_R_array_index_14_valid & io_R_array_index_14_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_208 = r_array_count_14 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_209 = r_array_count_14 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_14 = _T_207 ? _T_209 : r_array_count_14; // @[SLR1.scala 127:137]
  reg [63:0] _T_210; // @[SLR1.scala 125:20]
  reg [19:0] _T_211; // @[SLR1.scala 126:62]
  wire  _T_212 = io_R_array_index_15_valid & io_R_array_index_15_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_213 = r_array_count_15 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_214 = r_array_count_15 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_15 = _T_212 ? _T_214 : r_array_count_15; // @[SLR1.scala 127:137]
  reg  _T_215; // @[SLR1.scala 115:51]
  reg [63:0] _T_216; // @[SLR1.scala 125:20]
  reg [19:0] _T_217; // @[SLR1.scala 126:62]
  wire  _T_218 = io_R_array_index_16_valid & io_R_array_index_16_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_219 = r_array_count_16 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_220 = r_array_count_16 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_16 = _T_218 ? _T_220 : r_array_count_16; // @[SLR1.scala 127:137]
  reg [63:0] _T_221; // @[SLR1.scala 125:20]
  reg [19:0] _T_222; // @[SLR1.scala 126:62]
  wire  _T_223 = io_R_array_index_17_valid & io_R_array_index_17_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_224 = r_array_count_17 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_225 = r_array_count_17 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_17 = _T_223 ? _T_225 : r_array_count_17; // @[SLR1.scala 127:137]
  reg [63:0] _T_226; // @[SLR1.scala 125:20]
  reg [19:0] _T_227; // @[SLR1.scala 126:62]
  wire  _T_228 = io_R_array_index_18_valid & io_R_array_index_18_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_229 = r_array_count_18 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_230 = r_array_count_18 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_18 = _T_228 ? _T_230 : r_array_count_18; // @[SLR1.scala 127:137]
  reg [63:0] _T_231; // @[SLR1.scala 125:20]
  reg [19:0] _T_232; // @[SLR1.scala 126:62]
  wire  _T_233 = io_R_array_index_19_valid & io_R_array_index_19_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_234 = r_array_count_19 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_235 = r_array_count_19 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_19 = _T_233 ? _T_235 : r_array_count_19; // @[SLR1.scala 127:137]
  reg  _T_236; // @[SLR1.scala 115:51]
  reg [63:0] _T_237; // @[SLR1.scala 125:20]
  reg [19:0] _T_238; // @[SLR1.scala 126:62]
  wire  _T_239 = io_R_array_index_20_valid & io_R_array_index_20_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_240 = r_array_count_20 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_241 = r_array_count_20 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_20 = _T_239 ? _T_241 : r_array_count_20; // @[SLR1.scala 127:137]
  reg [63:0] _T_242; // @[SLR1.scala 125:20]
  reg [19:0] _T_243; // @[SLR1.scala 126:62]
  wire  _T_244 = io_R_array_index_21_valid & io_R_array_index_21_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_245 = r_array_count_21 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_246 = r_array_count_21 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_21 = _T_244 ? _T_246 : r_array_count_21; // @[SLR1.scala 127:137]
  reg [63:0] _T_247; // @[SLR1.scala 125:20]
  reg [19:0] _T_248; // @[SLR1.scala 126:62]
  wire  _T_249 = io_R_array_index_22_valid & io_R_array_index_22_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_250 = r_array_count_22 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_251 = r_array_count_22 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_22 = _T_249 ? _T_251 : r_array_count_22; // @[SLR1.scala 127:137]
  reg [63:0] _T_252; // @[SLR1.scala 125:20]
  reg [19:0] _T_253; // @[SLR1.scala 126:62]
  wire  _T_254 = io_R_array_index_23_valid & io_R_array_index_23_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_255 = r_array_count_23 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_256 = r_array_count_23 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_23 = _T_254 ? _T_256 : r_array_count_23; // @[SLR1.scala 127:137]
  reg  _T_257; // @[SLR1.scala 115:51]
  reg [63:0] _T_258; // @[SLR1.scala 125:20]
  reg [19:0] _T_259; // @[SLR1.scala 126:62]
  wire  _T_260 = io_R_array_index_24_valid & io_R_array_index_24_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_261 = r_array_count_24 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_262 = r_array_count_24 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_24 = _T_260 ? _T_262 : r_array_count_24; // @[SLR1.scala 127:137]
  reg [63:0] _T_263; // @[SLR1.scala 125:20]
  reg [19:0] _T_264; // @[SLR1.scala 126:62]
  wire  _T_265 = io_R_array_index_25_valid & io_R_array_index_25_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_266 = r_array_count_25 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_267 = r_array_count_25 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_25 = _T_265 ? _T_267 : r_array_count_25; // @[SLR1.scala 127:137]
  reg [63:0] _T_268; // @[SLR1.scala 125:20]
  reg [19:0] _T_269; // @[SLR1.scala 126:62]
  wire  _T_270 = io_R_array_index_26_valid & io_R_array_index_26_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_271 = r_array_count_26 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_272 = r_array_count_26 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_26 = _T_270 ? _T_272 : r_array_count_26; // @[SLR1.scala 127:137]
  reg [63:0] _T_273; // @[SLR1.scala 125:20]
  reg [19:0] _T_274; // @[SLR1.scala 126:62]
  wire  _T_275 = io_R_array_index_27_valid & io_R_array_index_27_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_276 = r_array_count_27 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_277 = r_array_count_27 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_27 = _T_275 ? _T_277 : r_array_count_27; // @[SLR1.scala 127:137]
  reg  _T_278; // @[SLR1.scala 115:51]
  reg [63:0] _T_279; // @[SLR1.scala 125:20]
  reg [19:0] _T_280; // @[SLR1.scala 126:62]
  wire  _T_281 = io_R_array_index_28_valid & io_R_array_index_28_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_282 = r_array_count_28 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_283 = r_array_count_28 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_28 = _T_281 ? _T_283 : r_array_count_28; // @[SLR1.scala 127:137]
  reg [63:0] _T_284; // @[SLR1.scala 125:20]
  reg [19:0] _T_285; // @[SLR1.scala 126:62]
  wire  _T_286 = io_R_array_index_29_valid & io_R_array_index_29_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_287 = r_array_count_29 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_288 = r_array_count_29 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_29 = _T_286 ? _T_288 : r_array_count_29; // @[SLR1.scala 127:137]
  reg [63:0] _T_289; // @[SLR1.scala 125:20]
  reg [19:0] _T_290; // @[SLR1.scala 126:62]
  wire  _T_291 = io_R_array_index_30_valid & io_R_array_index_30_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_292 = r_array_count_30 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_293 = r_array_count_30 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_30 = _T_291 ? _T_293 : r_array_count_30; // @[SLR1.scala 127:137]
  reg [63:0] _T_294; // @[SLR1.scala 125:20]
  reg [19:0] _T_295; // @[SLR1.scala 126:62]
  wire  _T_296 = io_R_array_index_31_valid & io_R_array_index_31_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_297 = r_array_count_31 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_298 = r_array_count_31 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_31 = _T_296 ? _T_298 : r_array_count_31; // @[SLR1.scala 127:137]
  reg  _T_299; // @[SLR1.scala 115:51]
  reg [63:0] _T_300; // @[SLR1.scala 125:20]
  reg [19:0] _T_301; // @[SLR1.scala 126:62]
  wire  _T_302 = io_R_array_index_32_valid & io_R_array_index_32_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_303 = r_array_count_32 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_304 = r_array_count_32 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_32 = _T_302 ? _T_304 : r_array_count_32; // @[SLR1.scala 127:137]
  reg [63:0] _T_305; // @[SLR1.scala 125:20]
  reg [19:0] _T_306; // @[SLR1.scala 126:62]
  wire  _T_307 = io_R_array_index_33_valid & io_R_array_index_33_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_308 = r_array_count_33 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_309 = r_array_count_33 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_33 = _T_307 ? _T_309 : r_array_count_33; // @[SLR1.scala 127:137]
  reg [63:0] _T_310; // @[SLR1.scala 125:20]
  reg [19:0] _T_311; // @[SLR1.scala 126:62]
  wire  _T_312 = io_R_array_index_34_valid & io_R_array_index_34_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_313 = r_array_count_34 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_314 = r_array_count_34 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_34 = _T_312 ? _T_314 : r_array_count_34; // @[SLR1.scala 127:137]
  reg [63:0] _T_315; // @[SLR1.scala 125:20]
  reg [19:0] _T_316; // @[SLR1.scala 126:62]
  wire  _T_317 = io_R_array_index_35_valid & io_R_array_index_35_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_318 = r_array_count_35 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_319 = r_array_count_35 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_35 = _T_317 ? _T_319 : r_array_count_35; // @[SLR1.scala 127:137]
  reg  _T_320; // @[SLR1.scala 115:51]
  reg [63:0] _T_321; // @[SLR1.scala 125:20]
  reg [19:0] _T_322; // @[SLR1.scala 126:62]
  wire  _T_323 = io_R_array_index_36_valid & io_R_array_index_36_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_324 = r_array_count_36 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_325 = r_array_count_36 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_36 = _T_323 ? _T_325 : r_array_count_36; // @[SLR1.scala 127:137]
  reg [63:0] _T_326; // @[SLR1.scala 125:20]
  reg [19:0] _T_327; // @[SLR1.scala 126:62]
  wire  _T_328 = io_R_array_index_37_valid & io_R_array_index_37_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_329 = r_array_count_37 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_330 = r_array_count_37 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_37 = _T_328 ? _T_330 : r_array_count_37; // @[SLR1.scala 127:137]
  reg [63:0] _T_331; // @[SLR1.scala 125:20]
  reg [19:0] _T_332; // @[SLR1.scala 126:62]
  wire  _T_333 = io_R_array_index_38_valid & io_R_array_index_38_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_334 = r_array_count_38 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_335 = r_array_count_38 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_38 = _T_333 ? _T_335 : r_array_count_38; // @[SLR1.scala 127:137]
  reg [63:0] _T_336; // @[SLR1.scala 125:20]
  reg [19:0] _T_337; // @[SLR1.scala 126:62]
  wire  _T_338 = io_R_array_index_39_valid & io_R_array_index_39_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_339 = r_array_count_39 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_340 = r_array_count_39 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_39 = _T_338 ? _T_340 : r_array_count_39; // @[SLR1.scala 127:137]
  reg  _T_341; // @[SLR1.scala 115:51]
  reg [63:0] _T_342; // @[SLR1.scala 125:20]
  reg [19:0] _T_343; // @[SLR1.scala 126:62]
  wire  _T_344 = io_R_array_index_40_valid & io_R_array_index_40_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_345 = r_array_count_40 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_346 = r_array_count_40 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_40 = _T_344 ? _T_346 : r_array_count_40; // @[SLR1.scala 127:137]
  reg [63:0] _T_347; // @[SLR1.scala 125:20]
  reg [19:0] _T_348; // @[SLR1.scala 126:62]
  wire  _T_349 = io_R_array_index_41_valid & io_R_array_index_41_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_350 = r_array_count_41 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_351 = r_array_count_41 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_41 = _T_349 ? _T_351 : r_array_count_41; // @[SLR1.scala 127:137]
  reg [63:0] _T_352; // @[SLR1.scala 125:20]
  reg [19:0] _T_353; // @[SLR1.scala 126:62]
  wire  _T_354 = io_R_array_index_42_valid & io_R_array_index_42_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_355 = r_array_count_42 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_356 = r_array_count_42 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_42 = _T_354 ? _T_356 : r_array_count_42; // @[SLR1.scala 127:137]
  reg [63:0] _T_357; // @[SLR1.scala 125:20]
  reg [19:0] _T_358; // @[SLR1.scala 126:62]
  wire  _T_359 = io_R_array_index_43_valid & io_R_array_index_43_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_360 = r_array_count_43 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_361 = r_array_count_43 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_43 = _T_359 ? _T_361 : r_array_count_43; // @[SLR1.scala 127:137]
  reg  _T_362; // @[SLR1.scala 115:51]
  reg [63:0] _T_363; // @[SLR1.scala 125:20]
  reg [19:0] _T_364; // @[SLR1.scala 126:62]
  wire  _T_365 = io_R_array_index_44_valid & io_R_array_index_44_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_366 = r_array_count_44 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_367 = r_array_count_44 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_44 = _T_365 ? _T_367 : r_array_count_44; // @[SLR1.scala 127:137]
  reg [63:0] _T_368; // @[SLR1.scala 125:20]
  reg [19:0] _T_369; // @[SLR1.scala 126:62]
  wire  _T_370 = io_R_array_index_45_valid & io_R_array_index_45_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_371 = r_array_count_45 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_372 = r_array_count_45 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_45 = _T_370 ? _T_372 : r_array_count_45; // @[SLR1.scala 127:137]
  reg [63:0] _T_373; // @[SLR1.scala 125:20]
  reg [19:0] _T_374; // @[SLR1.scala 126:62]
  wire  _T_375 = io_R_array_index_46_valid & io_R_array_index_46_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_376 = r_array_count_46 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_377 = r_array_count_46 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_46 = _T_375 ? _T_377 : r_array_count_46; // @[SLR1.scala 127:137]
  reg [63:0] _T_378; // @[SLR1.scala 125:20]
  reg [19:0] _T_379; // @[SLR1.scala 126:62]
  wire  _T_380 = io_R_array_index_47_valid & io_R_array_index_47_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_381 = r_array_count_47 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_382 = r_array_count_47 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_47 = _T_380 ? _T_382 : r_array_count_47; // @[SLR1.scala 127:137]
  reg  _T_383; // @[SLR1.scala 115:51]
  reg [63:0] _T_384; // @[SLR1.scala 125:20]
  reg [19:0] _T_385; // @[SLR1.scala 126:62]
  wire  _T_386 = io_R_array_index_48_valid & io_R_array_index_48_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_387 = r_array_count_48 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_388 = r_array_count_48 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_48 = _T_386 ? _T_388 : r_array_count_48; // @[SLR1.scala 127:137]
  reg [63:0] _T_389; // @[SLR1.scala 125:20]
  reg [19:0] _T_390; // @[SLR1.scala 126:62]
  wire  _T_391 = io_R_array_index_49_valid & io_R_array_index_49_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_392 = r_array_count_49 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_393 = r_array_count_49 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_49 = _T_391 ? _T_393 : r_array_count_49; // @[SLR1.scala 127:137]
  reg [63:0] _T_394; // @[SLR1.scala 125:20]
  reg [19:0] _T_395; // @[SLR1.scala 126:62]
  wire  _T_396 = io_R_array_index_50_valid & io_R_array_index_50_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_397 = r_array_count_50 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_398 = r_array_count_50 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_50 = _T_396 ? _T_398 : r_array_count_50; // @[SLR1.scala 127:137]
  reg [63:0] _T_399; // @[SLR1.scala 125:20]
  reg [19:0] _T_400; // @[SLR1.scala 126:62]
  wire  _T_401 = io_R_array_index_51_valid & io_R_array_index_51_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_402 = r_array_count_51 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_403 = r_array_count_51 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_51 = _T_401 ? _T_403 : r_array_count_51; // @[SLR1.scala 127:137]
  reg  _T_404; // @[SLR1.scala 115:51]
  reg [63:0] _T_405; // @[SLR1.scala 125:20]
  reg [19:0] _T_406; // @[SLR1.scala 126:62]
  wire  _T_407 = io_R_array_index_52_valid & io_R_array_index_52_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_408 = r_array_count_52 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_409 = r_array_count_52 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_52 = _T_407 ? _T_409 : r_array_count_52; // @[SLR1.scala 127:137]
  reg [63:0] _T_410; // @[SLR1.scala 125:20]
  reg [19:0] _T_411; // @[SLR1.scala 126:62]
  wire  _T_412 = io_R_array_index_53_valid & io_R_array_index_53_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_413 = r_array_count_53 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_414 = r_array_count_53 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_53 = _T_412 ? _T_414 : r_array_count_53; // @[SLR1.scala 127:137]
  reg [63:0] _T_415; // @[SLR1.scala 125:20]
  reg [19:0] _T_416; // @[SLR1.scala 126:62]
  wire  _T_417 = io_R_array_index_54_valid & io_R_array_index_54_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_418 = r_array_count_54 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_419 = r_array_count_54 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_54 = _T_417 ? _T_419 : r_array_count_54; // @[SLR1.scala 127:137]
  reg [63:0] _T_420; // @[SLR1.scala 125:20]
  reg [19:0] _T_421; // @[SLR1.scala 126:62]
  wire  _T_422 = io_R_array_index_55_valid & io_R_array_index_55_ready; // @[SLR1.scala 127:76]
  wire [32:0] _T_423 = r_array_count_55 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _T_424 = r_array_count_55 + 32'h1; // @[SLR1.scala 127:239]
  wire [31:0] _GEN_55 = _T_422 ? _T_424 : r_array_count_55; // @[SLR1.scala 127:137]
  wire  _T = reset_reg_array_0; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_1 = reset_reg_array_1; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_2 = reset_reg_array_2; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_3 = reset_reg_array_3; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_4 = reset_reg_array_4; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_5 = reset_reg_array_5; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_6 = reset_reg_array_6; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_7 = reset_reg_array_7; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_8 = reset_reg_array_8; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_9 = reset_reg_array_9; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_10 = reset_reg_array_10; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_11 = reset_reg_array_11; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_12 = reset_reg_array_12; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire  _T_13 = reset_reg_array_13; // @[SLR1.scala 47:34 SLR1.scala 47:34]
  wire [31:0] _T_21_0 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_1 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_2 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_3 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_4 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_5 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_6 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_7 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_8 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_9 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_10 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_11 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_12 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_13 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_14 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_15 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_16 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_17 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_18 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_19 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_20 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_21 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_22 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_23 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_24 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_25 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_26 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_27 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_28 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_29 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_30 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_31 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_32 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_33 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_34 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_35 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_36 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_37 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_38 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_39 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_40 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_41 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_42 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_43 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_44 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_45 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_46 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_47 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_48 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_49 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_50 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_51 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_52 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_53 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_54 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  wire [31:0] _T_21_55 = 32'h0; // @[SLR1.scala 83:40 SLR1.scala 83:40]
  pipeline pipeline ( // @[SLR1.scala 51:65]
    .clock(pipeline_clock),
    .reset(pipeline_reset),
    .io_frontier_flag(pipeline_io_frontier_flag),
    .io_p2_end(pipeline_io_p2_end),
    .io_start(pipeline_io_start),
    .io_start_init(pipeline_io_start_init),
    .io_end(pipeline_io_end),
    .io_last_iteration(pipeline_io_last_iteration),
    .io_init_bram(pipeline_io_init_bram),
    .io_p2_count(pipeline_io_p2_count),
    .io_frontier_pull_count(pipeline_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_io_p2_pull_count),
    .io_level(pipeline_io_level),
    .io_offsets_CSR_R_offset(pipeline_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_io_p2_out_3_bits),
    .io_node_num(pipeline_io_node_num),
    .io_push_or_pull(pipeline_io_push_or_pull),
    .io_root(pipeline_io_root),
    .io_R_array_index_0_ready(pipeline_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_io_R_array_index_3_bits),
    .io_p1_end(pipeline_io_p1_end),
    .io_uram_out_a_0(pipeline_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_io_uram_addr_a_3)
  );
  pipeline_1 pipeline_1 ( // @[SLR1.scala 51:65]
    .clock(pipeline_1_clock),
    .reset(pipeline_1_reset),
    .io_frontier_flag(pipeline_1_io_frontier_flag),
    .io_p2_end(pipeline_1_io_p2_end),
    .io_start(pipeline_1_io_start),
    .io_start_init(pipeline_1_io_start_init),
    .io_end(pipeline_1_io_end),
    .io_last_iteration(pipeline_1_io_last_iteration),
    .io_init_bram(pipeline_1_io_init_bram),
    .io_p2_count(pipeline_1_io_p2_count),
    .io_frontier_pull_count(pipeline_1_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_1_io_p2_pull_count),
    .io_level(pipeline_1_io_level),
    .io_offsets_CSR_R_offset(pipeline_1_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_1_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_1_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_1_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_1_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_1_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_1_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_1_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_1_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_1_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_1_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_1_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_1_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_1_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_1_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_1_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_1_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_1_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_1_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_1_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_1_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_1_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_1_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_1_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_1_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_1_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_1_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_1_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_1_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_1_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_1_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_1_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_1_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_1_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_1_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_1_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_1_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_1_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_1_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_1_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_1_io_p2_out_3_bits),
    .io_node_num(pipeline_1_io_node_num),
    .io_push_or_pull(pipeline_1_io_push_or_pull),
    .io_root(pipeline_1_io_root),
    .io_R_array_index_0_ready(pipeline_1_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_1_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_1_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_1_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_1_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_1_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_1_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_1_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_1_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_1_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_1_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_1_io_R_array_index_3_bits),
    .io_p1_end(pipeline_1_io_p1_end),
    .io_uram_out_a_0(pipeline_1_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_1_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_1_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_1_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_1_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_1_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_1_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_1_io_uram_addr_a_3)
  );
  pipeline_2 pipeline_2 ( // @[SLR1.scala 51:65]
    .clock(pipeline_2_clock),
    .reset(pipeline_2_reset),
    .io_frontier_flag(pipeline_2_io_frontier_flag),
    .io_p2_end(pipeline_2_io_p2_end),
    .io_start(pipeline_2_io_start),
    .io_start_init(pipeline_2_io_start_init),
    .io_end(pipeline_2_io_end),
    .io_last_iteration(pipeline_2_io_last_iteration),
    .io_init_bram(pipeline_2_io_init_bram),
    .io_p2_count(pipeline_2_io_p2_count),
    .io_frontier_pull_count(pipeline_2_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_2_io_p2_pull_count),
    .io_level(pipeline_2_io_level),
    .io_offsets_CSR_R_offset(pipeline_2_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_2_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_2_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_2_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_2_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_2_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_2_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_2_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_2_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_2_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_2_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_2_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_2_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_2_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_2_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_2_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_2_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_2_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_2_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_2_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_2_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_2_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_2_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_2_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_2_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_2_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_2_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_2_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_2_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_2_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_2_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_2_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_2_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_2_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_2_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_2_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_2_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_2_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_2_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_2_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_2_io_p2_out_3_bits),
    .io_node_num(pipeline_2_io_node_num),
    .io_push_or_pull(pipeline_2_io_push_or_pull),
    .io_root(pipeline_2_io_root),
    .io_R_array_index_0_ready(pipeline_2_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_2_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_2_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_2_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_2_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_2_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_2_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_2_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_2_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_2_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_2_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_2_io_R_array_index_3_bits),
    .io_p1_end(pipeline_2_io_p1_end),
    .io_uram_out_a_0(pipeline_2_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_2_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_2_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_2_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_2_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_2_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_2_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_2_io_uram_addr_a_3)
  );
  pipeline_3 pipeline_3 ( // @[SLR1.scala 51:65]
    .clock(pipeline_3_clock),
    .reset(pipeline_3_reset),
    .io_frontier_flag(pipeline_3_io_frontier_flag),
    .io_p2_end(pipeline_3_io_p2_end),
    .io_start(pipeline_3_io_start),
    .io_start_init(pipeline_3_io_start_init),
    .io_end(pipeline_3_io_end),
    .io_last_iteration(pipeline_3_io_last_iteration),
    .io_init_bram(pipeline_3_io_init_bram),
    .io_p2_count(pipeline_3_io_p2_count),
    .io_frontier_pull_count(pipeline_3_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_3_io_p2_pull_count),
    .io_level(pipeline_3_io_level),
    .io_offsets_CSR_R_offset(pipeline_3_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_3_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_3_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_3_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_3_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_3_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_3_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_3_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_3_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_3_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_3_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_3_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_3_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_3_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_3_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_3_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_3_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_3_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_3_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_3_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_3_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_3_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_3_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_3_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_3_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_3_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_3_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_3_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_3_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_3_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_3_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_3_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_3_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_3_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_3_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_3_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_3_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_3_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_3_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_3_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_3_io_p2_out_3_bits),
    .io_node_num(pipeline_3_io_node_num),
    .io_push_or_pull(pipeline_3_io_push_or_pull),
    .io_root(pipeline_3_io_root),
    .io_R_array_index_0_ready(pipeline_3_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_3_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_3_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_3_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_3_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_3_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_3_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_3_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_3_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_3_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_3_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_3_io_R_array_index_3_bits),
    .io_p1_end(pipeline_3_io_p1_end),
    .io_uram_out_a_0(pipeline_3_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_3_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_3_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_3_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_3_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_3_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_3_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_3_io_uram_addr_a_3)
  );
  pipeline_4 pipeline_4 ( // @[SLR1.scala 51:65]
    .clock(pipeline_4_clock),
    .reset(pipeline_4_reset),
    .io_frontier_flag(pipeline_4_io_frontier_flag),
    .io_p2_end(pipeline_4_io_p2_end),
    .io_start(pipeline_4_io_start),
    .io_start_init(pipeline_4_io_start_init),
    .io_end(pipeline_4_io_end),
    .io_last_iteration(pipeline_4_io_last_iteration),
    .io_init_bram(pipeline_4_io_init_bram),
    .io_p2_count(pipeline_4_io_p2_count),
    .io_frontier_pull_count(pipeline_4_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_4_io_p2_pull_count),
    .io_level(pipeline_4_io_level),
    .io_offsets_CSR_R_offset(pipeline_4_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_4_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_4_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_4_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_4_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_4_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_4_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_4_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_4_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_4_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_4_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_4_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_4_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_4_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_4_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_4_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_4_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_4_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_4_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_4_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_4_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_4_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_4_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_4_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_4_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_4_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_4_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_4_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_4_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_4_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_4_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_4_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_4_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_4_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_4_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_4_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_4_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_4_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_4_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_4_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_4_io_p2_out_3_bits),
    .io_node_num(pipeline_4_io_node_num),
    .io_push_or_pull(pipeline_4_io_push_or_pull),
    .io_root(pipeline_4_io_root),
    .io_R_array_index_0_ready(pipeline_4_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_4_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_4_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_4_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_4_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_4_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_4_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_4_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_4_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_4_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_4_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_4_io_R_array_index_3_bits),
    .io_p1_end(pipeline_4_io_p1_end),
    .io_uram_out_a_0(pipeline_4_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_4_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_4_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_4_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_4_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_4_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_4_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_4_io_uram_addr_a_3)
  );
  pipeline_5 pipeline_5 ( // @[SLR1.scala 51:65]
    .clock(pipeline_5_clock),
    .reset(pipeline_5_reset),
    .io_frontier_flag(pipeline_5_io_frontier_flag),
    .io_p2_end(pipeline_5_io_p2_end),
    .io_start(pipeline_5_io_start),
    .io_start_init(pipeline_5_io_start_init),
    .io_end(pipeline_5_io_end),
    .io_last_iteration(pipeline_5_io_last_iteration),
    .io_init_bram(pipeline_5_io_init_bram),
    .io_p2_count(pipeline_5_io_p2_count),
    .io_frontier_pull_count(pipeline_5_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_5_io_p2_pull_count),
    .io_level(pipeline_5_io_level),
    .io_offsets_CSR_R_offset(pipeline_5_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_5_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_5_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_5_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_5_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_5_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_5_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_5_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_5_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_5_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_5_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_5_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_5_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_5_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_5_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_5_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_5_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_5_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_5_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_5_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_5_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_5_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_5_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_5_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_5_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_5_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_5_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_5_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_5_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_5_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_5_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_5_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_5_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_5_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_5_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_5_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_5_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_5_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_5_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_5_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_5_io_p2_out_3_bits),
    .io_node_num(pipeline_5_io_node_num),
    .io_push_or_pull(pipeline_5_io_push_or_pull),
    .io_root(pipeline_5_io_root),
    .io_R_array_index_0_ready(pipeline_5_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_5_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_5_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_5_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_5_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_5_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_5_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_5_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_5_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_5_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_5_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_5_io_R_array_index_3_bits),
    .io_p1_end(pipeline_5_io_p1_end),
    .io_uram_out_a_0(pipeline_5_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_5_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_5_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_5_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_5_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_5_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_5_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_5_io_uram_addr_a_3)
  );
  pipeline_6 pipeline_6 ( // @[SLR1.scala 51:65]
    .clock(pipeline_6_clock),
    .reset(pipeline_6_reset),
    .io_frontier_flag(pipeline_6_io_frontier_flag),
    .io_p2_end(pipeline_6_io_p2_end),
    .io_start(pipeline_6_io_start),
    .io_start_init(pipeline_6_io_start_init),
    .io_end(pipeline_6_io_end),
    .io_last_iteration(pipeline_6_io_last_iteration),
    .io_init_bram(pipeline_6_io_init_bram),
    .io_p2_count(pipeline_6_io_p2_count),
    .io_frontier_pull_count(pipeline_6_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_6_io_p2_pull_count),
    .io_level(pipeline_6_io_level),
    .io_offsets_CSR_R_offset(pipeline_6_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_6_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_6_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_6_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_6_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_6_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_6_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_6_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_6_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_6_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_6_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_6_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_6_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_6_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_6_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_6_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_6_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_6_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_6_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_6_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_6_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_6_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_6_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_6_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_6_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_6_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_6_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_6_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_6_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_6_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_6_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_6_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_6_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_6_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_6_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_6_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_6_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_6_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_6_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_6_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_6_io_p2_out_3_bits),
    .io_node_num(pipeline_6_io_node_num),
    .io_push_or_pull(pipeline_6_io_push_or_pull),
    .io_root(pipeline_6_io_root),
    .io_R_array_index_0_ready(pipeline_6_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_6_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_6_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_6_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_6_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_6_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_6_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_6_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_6_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_6_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_6_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_6_io_R_array_index_3_bits),
    .io_p1_end(pipeline_6_io_p1_end),
    .io_uram_out_a_0(pipeline_6_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_6_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_6_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_6_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_6_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_6_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_6_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_6_io_uram_addr_a_3)
  );
  pipeline_7 pipeline_7 ( // @[SLR1.scala 51:65]
    .clock(pipeline_7_clock),
    .reset(pipeline_7_reset),
    .io_frontier_flag(pipeline_7_io_frontier_flag),
    .io_p2_end(pipeline_7_io_p2_end),
    .io_start(pipeline_7_io_start),
    .io_start_init(pipeline_7_io_start_init),
    .io_end(pipeline_7_io_end),
    .io_last_iteration(pipeline_7_io_last_iteration),
    .io_init_bram(pipeline_7_io_init_bram),
    .io_p2_count(pipeline_7_io_p2_count),
    .io_frontier_pull_count(pipeline_7_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_7_io_p2_pull_count),
    .io_level(pipeline_7_io_level),
    .io_offsets_CSR_R_offset(pipeline_7_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_7_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_7_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_7_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_7_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_7_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_7_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_7_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_7_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_7_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_7_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_7_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_7_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_7_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_7_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_7_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_7_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_7_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_7_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_7_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_7_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_7_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_7_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_7_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_7_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_7_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_7_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_7_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_7_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_7_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_7_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_7_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_7_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_7_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_7_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_7_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_7_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_7_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_7_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_7_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_7_io_p2_out_3_bits),
    .io_node_num(pipeline_7_io_node_num),
    .io_push_or_pull(pipeline_7_io_push_or_pull),
    .io_root(pipeline_7_io_root),
    .io_R_array_index_0_ready(pipeline_7_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_7_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_7_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_7_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_7_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_7_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_7_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_7_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_7_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_7_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_7_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_7_io_R_array_index_3_bits),
    .io_p1_end(pipeline_7_io_p1_end),
    .io_uram_out_a_0(pipeline_7_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_7_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_7_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_7_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_7_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_7_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_7_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_7_io_uram_addr_a_3)
  );
  pipeline_8 pipeline_8 ( // @[SLR1.scala 51:65]
    .clock(pipeline_8_clock),
    .reset(pipeline_8_reset),
    .io_frontier_flag(pipeline_8_io_frontier_flag),
    .io_p2_end(pipeline_8_io_p2_end),
    .io_start(pipeline_8_io_start),
    .io_start_init(pipeline_8_io_start_init),
    .io_end(pipeline_8_io_end),
    .io_last_iteration(pipeline_8_io_last_iteration),
    .io_init_bram(pipeline_8_io_init_bram),
    .io_p2_count(pipeline_8_io_p2_count),
    .io_frontier_pull_count(pipeline_8_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_8_io_p2_pull_count),
    .io_level(pipeline_8_io_level),
    .io_offsets_CSR_R_offset(pipeline_8_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_8_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_8_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_8_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_8_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_8_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_8_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_8_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_8_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_8_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_8_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_8_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_8_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_8_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_8_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_8_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_8_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_8_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_8_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_8_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_8_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_8_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_8_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_8_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_8_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_8_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_8_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_8_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_8_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_8_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_8_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_8_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_8_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_8_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_8_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_8_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_8_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_8_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_8_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_8_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_8_io_p2_out_3_bits),
    .io_node_num(pipeline_8_io_node_num),
    .io_push_or_pull(pipeline_8_io_push_or_pull),
    .io_root(pipeline_8_io_root),
    .io_R_array_index_0_ready(pipeline_8_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_8_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_8_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_8_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_8_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_8_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_8_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_8_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_8_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_8_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_8_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_8_io_R_array_index_3_bits),
    .io_p1_end(pipeline_8_io_p1_end),
    .io_uram_out_a_0(pipeline_8_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_8_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_8_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_8_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_8_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_8_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_8_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_8_io_uram_addr_a_3)
  );
  pipeline_9 pipeline_9 ( // @[SLR1.scala 51:65]
    .clock(pipeline_9_clock),
    .reset(pipeline_9_reset),
    .io_frontier_flag(pipeline_9_io_frontier_flag),
    .io_p2_end(pipeline_9_io_p2_end),
    .io_start(pipeline_9_io_start),
    .io_start_init(pipeline_9_io_start_init),
    .io_end(pipeline_9_io_end),
    .io_last_iteration(pipeline_9_io_last_iteration),
    .io_init_bram(pipeline_9_io_init_bram),
    .io_p2_count(pipeline_9_io_p2_count),
    .io_frontier_pull_count(pipeline_9_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_9_io_p2_pull_count),
    .io_level(pipeline_9_io_level),
    .io_offsets_CSR_R_offset(pipeline_9_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_9_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_9_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_9_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_9_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_9_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_9_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_9_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_9_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_9_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_9_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_9_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_9_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_9_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_9_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_9_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_9_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_9_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_9_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_9_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_9_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_9_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_9_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_9_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_9_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_9_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_9_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_9_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_9_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_9_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_9_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_9_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_9_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_9_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_9_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_9_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_9_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_9_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_9_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_9_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_9_io_p2_out_3_bits),
    .io_node_num(pipeline_9_io_node_num),
    .io_push_or_pull(pipeline_9_io_push_or_pull),
    .io_root(pipeline_9_io_root),
    .io_R_array_index_0_ready(pipeline_9_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_9_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_9_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_9_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_9_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_9_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_9_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_9_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_9_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_9_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_9_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_9_io_R_array_index_3_bits),
    .io_p1_end(pipeline_9_io_p1_end),
    .io_uram_out_a_0(pipeline_9_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_9_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_9_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_9_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_9_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_9_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_9_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_9_io_uram_addr_a_3)
  );
  pipeline_10 pipeline_10 ( // @[SLR1.scala 51:65]
    .clock(pipeline_10_clock),
    .reset(pipeline_10_reset),
    .io_frontier_flag(pipeline_10_io_frontier_flag),
    .io_p2_end(pipeline_10_io_p2_end),
    .io_start(pipeline_10_io_start),
    .io_start_init(pipeline_10_io_start_init),
    .io_end(pipeline_10_io_end),
    .io_last_iteration(pipeline_10_io_last_iteration),
    .io_init_bram(pipeline_10_io_init_bram),
    .io_p2_count(pipeline_10_io_p2_count),
    .io_frontier_pull_count(pipeline_10_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_10_io_p2_pull_count),
    .io_level(pipeline_10_io_level),
    .io_offsets_CSR_R_offset(pipeline_10_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_10_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_10_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_10_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_10_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_10_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_10_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_10_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_10_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_10_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_10_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_10_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_10_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_10_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_10_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_10_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_10_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_10_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_10_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_10_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_10_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_10_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_10_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_10_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_10_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_10_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_10_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_10_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_10_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_10_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_10_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_10_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_10_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_10_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_10_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_10_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_10_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_10_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_10_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_10_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_10_io_p2_out_3_bits),
    .io_node_num(pipeline_10_io_node_num),
    .io_push_or_pull(pipeline_10_io_push_or_pull),
    .io_root(pipeline_10_io_root),
    .io_R_array_index_0_ready(pipeline_10_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_10_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_10_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_10_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_10_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_10_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_10_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_10_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_10_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_10_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_10_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_10_io_R_array_index_3_bits),
    .io_p1_end(pipeline_10_io_p1_end),
    .io_uram_out_a_0(pipeline_10_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_10_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_10_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_10_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_10_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_10_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_10_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_10_io_uram_addr_a_3)
  );
  pipeline_11 pipeline_11 ( // @[SLR1.scala 51:65]
    .clock(pipeline_11_clock),
    .reset(pipeline_11_reset),
    .io_frontier_flag(pipeline_11_io_frontier_flag),
    .io_p2_end(pipeline_11_io_p2_end),
    .io_start(pipeline_11_io_start),
    .io_start_init(pipeline_11_io_start_init),
    .io_end(pipeline_11_io_end),
    .io_last_iteration(pipeline_11_io_last_iteration),
    .io_init_bram(pipeline_11_io_init_bram),
    .io_p2_count(pipeline_11_io_p2_count),
    .io_frontier_pull_count(pipeline_11_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_11_io_p2_pull_count),
    .io_level(pipeline_11_io_level),
    .io_offsets_CSR_R_offset(pipeline_11_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_11_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_11_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_11_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_11_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_11_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_11_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_11_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_11_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_11_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_11_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_11_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_11_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_11_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_11_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_11_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_11_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_11_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_11_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_11_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_11_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_11_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_11_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_11_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_11_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_11_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_11_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_11_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_11_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_11_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_11_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_11_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_11_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_11_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_11_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_11_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_11_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_11_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_11_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_11_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_11_io_p2_out_3_bits),
    .io_node_num(pipeline_11_io_node_num),
    .io_push_or_pull(pipeline_11_io_push_or_pull),
    .io_root(pipeline_11_io_root),
    .io_R_array_index_0_ready(pipeline_11_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_11_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_11_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_11_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_11_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_11_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_11_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_11_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_11_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_11_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_11_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_11_io_R_array_index_3_bits),
    .io_p1_end(pipeline_11_io_p1_end),
    .io_uram_out_a_0(pipeline_11_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_11_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_11_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_11_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_11_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_11_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_11_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_11_io_uram_addr_a_3)
  );
  pipeline_12 pipeline_12 ( // @[SLR1.scala 51:65]
    .clock(pipeline_12_clock),
    .reset(pipeline_12_reset),
    .io_frontier_flag(pipeline_12_io_frontier_flag),
    .io_p2_end(pipeline_12_io_p2_end),
    .io_start(pipeline_12_io_start),
    .io_start_init(pipeline_12_io_start_init),
    .io_end(pipeline_12_io_end),
    .io_last_iteration(pipeline_12_io_last_iteration),
    .io_init_bram(pipeline_12_io_init_bram),
    .io_p2_count(pipeline_12_io_p2_count),
    .io_frontier_pull_count(pipeline_12_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_12_io_p2_pull_count),
    .io_level(pipeline_12_io_level),
    .io_offsets_CSR_R_offset(pipeline_12_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_12_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_12_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_12_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_12_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_12_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_12_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_12_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_12_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_12_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_12_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_12_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_12_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_12_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_12_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_12_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_12_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_12_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_12_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_12_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_12_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_12_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_12_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_12_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_12_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_12_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_12_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_12_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_12_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_12_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_12_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_12_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_12_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_12_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_12_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_12_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_12_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_12_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_12_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_12_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_12_io_p2_out_3_bits),
    .io_node_num(pipeline_12_io_node_num),
    .io_push_or_pull(pipeline_12_io_push_or_pull),
    .io_root(pipeline_12_io_root),
    .io_R_array_index_0_ready(pipeline_12_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_12_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_12_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_12_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_12_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_12_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_12_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_12_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_12_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_12_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_12_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_12_io_R_array_index_3_bits),
    .io_p1_end(pipeline_12_io_p1_end),
    .io_uram_out_a_0(pipeline_12_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_12_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_12_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_12_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_12_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_12_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_12_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_12_io_uram_addr_a_3)
  );
  pipeline_13 pipeline_13 ( // @[SLR1.scala 51:65]
    .clock(pipeline_13_clock),
    .reset(pipeline_13_reset),
    .io_frontier_flag(pipeline_13_io_frontier_flag),
    .io_p2_end(pipeline_13_io_p2_end),
    .io_start(pipeline_13_io_start),
    .io_start_init(pipeline_13_io_start_init),
    .io_end(pipeline_13_io_end),
    .io_last_iteration(pipeline_13_io_last_iteration),
    .io_init_bram(pipeline_13_io_init_bram),
    .io_p2_count(pipeline_13_io_p2_count),
    .io_frontier_pull_count(pipeline_13_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_13_io_p2_pull_count),
    .io_level(pipeline_13_io_level),
    .io_offsets_CSR_R_offset(pipeline_13_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_13_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_13_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_13_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_13_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_13_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_13_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_13_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_13_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_13_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_13_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_13_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_13_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_13_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_13_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_13_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_13_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_13_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_13_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_13_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_13_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_13_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_13_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_13_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_13_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_13_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_13_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_13_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_13_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_13_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_13_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_13_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_13_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_13_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_13_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_13_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_13_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_13_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_13_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_13_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_13_io_p2_out_3_bits),
    .io_node_num(pipeline_13_io_node_num),
    .io_push_or_pull(pipeline_13_io_push_or_pull),
    .io_root(pipeline_13_io_root),
    .io_R_array_index_0_ready(pipeline_13_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_13_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_13_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_13_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_13_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_13_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_13_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_13_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_13_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_13_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_13_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_13_io_R_array_index_3_bits),
    .io_p1_end(pipeline_13_io_p1_end),
    .io_uram_out_a_0(pipeline_13_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_13_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_13_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_13_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_13_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_13_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_13_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_13_io_uram_addr_a_3)
  );
  copy_slr1 copy_start ( // @[SLR1.scala 54:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3),
    .io_out_4(copy_start_io_out_4),
    .io_out_5(copy_start_io_out_5),
    .io_out_6(copy_start_io_out_6),
    .io_out_7(copy_start_io_out_7),
    .io_out_8(copy_start_io_out_8),
    .io_out_9(copy_start_io_out_9),
    .io_out_10(copy_start_io_out_10),
    .io_out_11(copy_start_io_out_11),
    .io_out_12(copy_start_io_out_12),
    .io_out_13(copy_start_io_out_13)
  );
  copy_slr1 copy_frontier_flag ( // @[SLR1.scala 56:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3),
    .io_out_4(copy_frontier_flag_io_out_4),
    .io_out_5(copy_frontier_flag_io_out_5),
    .io_out_6(copy_frontier_flag_io_out_6),
    .io_out_7(copy_frontier_flag_io_out_7),
    .io_out_8(copy_frontier_flag_io_out_8),
    .io_out_9(copy_frontier_flag_io_out_9),
    .io_out_10(copy_frontier_flag_io_out_10),
    .io_out_11(copy_frontier_flag_io_out_11),
    .io_out_12(copy_frontier_flag_io_out_12),
    .io_out_13(copy_frontier_flag_io_out_13)
  );
  copy_slr1_2 copy_current_level ( // @[SLR1.scala 57:36]
    .clock(copy_current_level_clock),
    .reset(copy_current_level_reset),
    .io_in(copy_current_level_io_in),
    .io_out_0(copy_current_level_io_out_0),
    .io_out_1(copy_current_level_io_out_1),
    .io_out_2(copy_current_level_io_out_2),
    .io_out_3(copy_current_level_io_out_3),
    .io_out_4(copy_current_level_io_out_4),
    .io_out_5(copy_current_level_io_out_5),
    .io_out_6(copy_current_level_io_out_6),
    .io_out_7(copy_current_level_io_out_7),
    .io_out_8(copy_current_level_io_out_8),
    .io_out_9(copy_current_level_io_out_9),
    .io_out_10(copy_current_level_io_out_10),
    .io_out_11(copy_current_level_io_out_11),
    .io_out_12(copy_current_level_io_out_12),
    .io_out_13(copy_current_level_io_out_13)
  );
  copy_slr1 copy_p2_end ( // @[SLR1.scala 58:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3),
    .io_out_4(copy_p2_end_io_out_4),
    .io_out_5(copy_p2_end_io_out_5),
    .io_out_6(copy_p2_end_io_out_6),
    .io_out_7(copy_p2_end_io_out_7),
    .io_out_8(copy_p2_end_io_out_8),
    .io_out_9(copy_p2_end_io_out_9),
    .io_out_10(copy_p2_end_io_out_10),
    .io_out_11(copy_p2_end_io_out_11),
    .io_out_12(copy_p2_end_io_out_12),
    .io_out_13(copy_p2_end_io_out_13)
  );
  copy_slr1 copy_push_or_pull ( // @[SLR1.scala 59:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3),
    .io_out_4(copy_push_or_pull_io_out_4),
    .io_out_5(copy_push_or_pull_io_out_5),
    .io_out_6(copy_push_or_pull_io_out_6),
    .io_out_7(copy_push_or_pull_io_out_7),
    .io_out_8(copy_push_or_pull_io_out_8),
    .io_out_9(copy_push_or_pull_io_out_9),
    .io_out_10(copy_push_or_pull_io_out_10),
    .io_out_11(copy_push_or_pull_io_out_11),
    .io_out_12(copy_push_or_pull_io_out_12),
    .io_out_13(copy_push_or_pull_io_out_13)
  );
  copy_slr1_2 copy_node_num ( // @[SLR1.scala 60:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3),
    .io_out_4(copy_node_num_io_out_4),
    .io_out_5(copy_node_num_io_out_5),
    .io_out_6(copy_node_num_io_out_6),
    .io_out_7(copy_node_num_io_out_7),
    .io_out_8(copy_node_num_io_out_8),
    .io_out_9(copy_node_num_io_out_9),
    .io_out_10(copy_node_num_io_out_10),
    .io_out_11(copy_node_num_io_out_11),
    .io_out_12(copy_node_num_io_out_12),
    .io_out_13(copy_node_num_io_out_13)
  );
  copy_slr1_2 copy_root ( // @[SLR1.scala 61:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3),
    .io_out_4(copy_root_io_out_4),
    .io_out_5(copy_root_io_out_5),
    .io_out_6(copy_root_io_out_6),
    .io_out_7(copy_root_io_out_7),
    .io_out_8(copy_root_io_out_8),
    .io_out_9(copy_root_io_out_9),
    .io_out_10(copy_root_io_out_10),
    .io_out_11(copy_root_io_out_11),
    .io_out_12(copy_root_io_out_12),
    .io_out_13(copy_root_io_out_13)
  );
  copy_slr1_2 copy_offset_CSR_R_offset ( // @[SLR1.scala 72:42]
    .clock(copy_offset_CSR_R_offset_clock),
    .reset(copy_offset_CSR_R_offset_reset),
    .io_in(copy_offset_CSR_R_offset_io_in),
    .io_out_0(copy_offset_CSR_R_offset_io_out_0),
    .io_out_1(copy_offset_CSR_R_offset_io_out_1),
    .io_out_2(copy_offset_CSR_R_offset_io_out_2),
    .io_out_3(copy_offset_CSR_R_offset_io_out_3),
    .io_out_4(copy_offset_CSR_R_offset_io_out_4),
    .io_out_5(copy_offset_CSR_R_offset_io_out_5),
    .io_out_6(copy_offset_CSR_R_offset_io_out_6),
    .io_out_7(copy_offset_CSR_R_offset_io_out_7),
    .io_out_8(copy_offset_CSR_R_offset_io_out_8),
    .io_out_9(copy_offset_CSR_R_offset_io_out_9),
    .io_out_10(copy_offset_CSR_R_offset_io_out_10),
    .io_out_11(copy_offset_CSR_R_offset_io_out_11),
    .io_out_12(copy_offset_CSR_R_offset_io_out_12),
    .io_out_13(copy_offset_CSR_R_offset_io_out_13)
  );
  copy_slr1_2 copy_offset_CSR_C_offset ( // @[SLR1.scala 73:42]
    .clock(copy_offset_CSR_C_offset_clock),
    .reset(copy_offset_CSR_C_offset_reset),
    .io_in(copy_offset_CSR_C_offset_io_in),
    .io_out_0(copy_offset_CSR_C_offset_io_out_0),
    .io_out_1(copy_offset_CSR_C_offset_io_out_1),
    .io_out_2(copy_offset_CSR_C_offset_io_out_2),
    .io_out_3(copy_offset_CSR_C_offset_io_out_3),
    .io_out_4(copy_offset_CSR_C_offset_io_out_4),
    .io_out_5(copy_offset_CSR_C_offset_io_out_5),
    .io_out_6(copy_offset_CSR_C_offset_io_out_6),
    .io_out_7(copy_offset_CSR_C_offset_io_out_7),
    .io_out_8(copy_offset_CSR_C_offset_io_out_8),
    .io_out_9(copy_offset_CSR_C_offset_io_out_9),
    .io_out_10(copy_offset_CSR_C_offset_io_out_10),
    .io_out_11(copy_offset_CSR_C_offset_io_out_11),
    .io_out_12(copy_offset_CSR_C_offset_io_out_12),
    .io_out_13(copy_offset_CSR_C_offset_io_out_13)
  );
  copy_slr1_2 copy_offset_CSC_R_offset ( // @[SLR1.scala 74:42]
    .clock(copy_offset_CSC_R_offset_clock),
    .reset(copy_offset_CSC_R_offset_reset),
    .io_in(copy_offset_CSC_R_offset_io_in),
    .io_out_0(copy_offset_CSC_R_offset_io_out_0),
    .io_out_1(copy_offset_CSC_R_offset_io_out_1),
    .io_out_2(copy_offset_CSC_R_offset_io_out_2),
    .io_out_3(copy_offset_CSC_R_offset_io_out_3),
    .io_out_4(copy_offset_CSC_R_offset_io_out_4),
    .io_out_5(copy_offset_CSC_R_offset_io_out_5),
    .io_out_6(copy_offset_CSC_R_offset_io_out_6),
    .io_out_7(copy_offset_CSC_R_offset_io_out_7),
    .io_out_8(copy_offset_CSC_R_offset_io_out_8),
    .io_out_9(copy_offset_CSC_R_offset_io_out_9),
    .io_out_10(copy_offset_CSC_R_offset_io_out_10),
    .io_out_11(copy_offset_CSC_R_offset_io_out_11),
    .io_out_12(copy_offset_CSC_R_offset_io_out_12),
    .io_out_13(copy_offset_CSC_R_offset_io_out_13)
  );
  copy_slr1_2 copy_offset_CSC_C_offset ( // @[SLR1.scala 75:42]
    .clock(copy_offset_CSC_C_offset_clock),
    .reset(copy_offset_CSC_C_offset_reset),
    .io_in(copy_offset_CSC_C_offset_io_in),
    .io_out_0(copy_offset_CSC_C_offset_io_out_0),
    .io_out_1(copy_offset_CSC_C_offset_io_out_1),
    .io_out_2(copy_offset_CSC_C_offset_io_out_2),
    .io_out_3(copy_offset_CSC_C_offset_io_out_3),
    .io_out_4(copy_offset_CSC_C_offset_io_out_4),
    .io_out_5(copy_offset_CSC_C_offset_io_out_5),
    .io_out_6(copy_offset_CSC_C_offset_io_out_6),
    .io_out_7(copy_offset_CSC_C_offset_io_out_7),
    .io_out_8(copy_offset_CSC_C_offset_io_out_8),
    .io_out_9(copy_offset_CSC_C_offset_io_out_9),
    .io_out_10(copy_offset_CSC_C_offset_io_out_10),
    .io_out_11(copy_offset_CSC_C_offset_io_out_11),
    .io_out_12(copy_offset_CSC_C_offset_io_out_12),
    .io_out_13(copy_offset_CSC_C_offset_io_out_13)
  );
  copy_slr1_2 copy_offset_level_offset ( // @[SLR1.scala 76:42]
    .clock(copy_offset_level_offset_clock),
    .reset(copy_offset_level_offset_reset),
    .io_in(copy_offset_level_offset_io_in),
    .io_out_0(copy_offset_level_offset_io_out_0),
    .io_out_1(copy_offset_level_offset_io_out_1),
    .io_out_2(copy_offset_level_offset_io_out_2),
    .io_out_3(copy_offset_level_offset_io_out_3),
    .io_out_4(copy_offset_level_offset_io_out_4),
    .io_out_5(copy_offset_level_offset_io_out_5),
    .io_out_6(copy_offset_level_offset_io_out_6),
    .io_out_7(copy_offset_level_offset_io_out_7),
    .io_out_8(copy_offset_level_offset_io_out_8),
    .io_out_9(copy_offset_level_offset_io_out_9),
    .io_out_10(copy_offset_level_offset_io_out_10),
    .io_out_11(copy_offset_level_offset_io_out_11),
    .io_out_12(copy_offset_level_offset_io_out_12),
    .io_out_13(copy_offset_level_offset_io_out_13)
  );
  assign io_end_0 = pipeline_io_end; // @[SLR1.scala 89:19]
  assign io_end_1 = pipeline_1_io_end; // @[SLR1.scala 89:19]
  assign io_end_2 = pipeline_2_io_end; // @[SLR1.scala 89:19]
  assign io_end_3 = pipeline_3_io_end; // @[SLR1.scala 89:19]
  assign io_end_4 = pipeline_4_io_end; // @[SLR1.scala 89:19]
  assign io_end_5 = pipeline_5_io_end; // @[SLR1.scala 89:19]
  assign io_end_6 = pipeline_6_io_end; // @[SLR1.scala 89:19]
  assign io_end_7 = pipeline_7_io_end; // @[SLR1.scala 89:19]
  assign io_end_8 = pipeline_8_io_end; // @[SLR1.scala 89:19]
  assign io_end_9 = pipeline_9_io_end; // @[SLR1.scala 89:19]
  assign io_end_10 = pipeline_10_io_end; // @[SLR1.scala 89:19]
  assign io_end_11 = pipeline_11_io_end; // @[SLR1.scala 89:19]
  assign io_end_12 = pipeline_12_io_end; // @[SLR1.scala 89:19]
  assign io_end_13 = pipeline_13_io_end; // @[SLR1.scala 89:19]
  assign io_p2_count_0 = pipeline_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_1 = pipeline_1_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_2 = pipeline_2_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_3 = pipeline_3_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_4 = pipeline_4_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_5 = pipeline_5_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_6 = pipeline_6_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_7 = pipeline_7_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_8 = pipeline_8_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_9 = pipeline_9_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_10 = pipeline_10_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_11 = pipeline_11_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_12 = pipeline_12_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_count_13 = pipeline_13_io_p2_count; // @[SLR1.scala 90:24]
  assign io_p2_pull_count_0 = pipeline_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_1 = pipeline_1_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_2 = pipeline_2_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_3 = pipeline_3_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_4 = pipeline_4_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_5 = pipeline_5_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_6 = pipeline_6_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_7 = pipeline_7_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_8 = pipeline_8_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_9 = pipeline_9_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_10 = pipeline_10_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_11 = pipeline_11_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_12 = pipeline_12_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_p2_pull_count_13 = pipeline_13_io_p2_pull_count; // @[SLR1.scala 92:29]
  assign io_frontier_pull_count_0 = pipeline_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_1 = pipeline_1_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_2 = pipeline_2_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_3 = pipeline_3_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_4 = pipeline_4_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_5 = pipeline_5_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_6 = pipeline_6_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_7 = pipeline_7_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_8 = pipeline_8_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_9 = pipeline_9_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_10 = pipeline_10_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_11 = pipeline_11_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_12 = pipeline_12_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_frontier_pull_count_13 = pipeline_13_io_frontier_pull_count; // @[SLR1.scala 93:35]
  assign io_last_iteration_0 = pipeline_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_1 = pipeline_1_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_2 = pipeline_2_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_3 = pipeline_3_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_4 = pipeline_4_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_5 = pipeline_5_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_6 = pipeline_6_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_7 = pipeline_7_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_8 = pipeline_8_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_9 = pipeline_9_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_10 = pipeline_10_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_11 = pipeline_11_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_12 = pipeline_12_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_last_iteration_13 = pipeline_13_io_last_iteration; // @[SLR1.scala 94:30]
  assign io_init_bram_0 = pipeline_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_1 = pipeline_1_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_2 = pipeline_2_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_3 = pipeline_3_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_4 = pipeline_4_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_5 = pipeline_5_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_6 = pipeline_6_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_7 = pipeline_7_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_8 = pipeline_8_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_9 = pipeline_9_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_10 = pipeline_10_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_11 = pipeline_11_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_12 = pipeline_12_io_init_bram; // @[SLR1.scala 95:25]
  assign io_init_bram_13 = pipeline_13_io_init_bram; // @[SLR1.scala 95:25]
  assign io_p2_in_0_ready = pipeline_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_1_ready = pipeline_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_2_ready = pipeline_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_3_ready = pipeline_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_4_ready = pipeline_1_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_5_ready = pipeline_1_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_6_ready = pipeline_1_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_7_ready = pipeline_1_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_8_ready = pipeline_2_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_9_ready = pipeline_2_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_10_ready = pipeline_2_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_11_ready = pipeline_2_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_12_ready = pipeline_3_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_13_ready = pipeline_3_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_14_ready = pipeline_3_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_15_ready = pipeline_3_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_16_ready = pipeline_4_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_17_ready = pipeline_4_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_18_ready = pipeline_4_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_19_ready = pipeline_4_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_20_ready = pipeline_5_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_21_ready = pipeline_5_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_22_ready = pipeline_5_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_23_ready = pipeline_5_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_24_ready = pipeline_6_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_25_ready = pipeline_6_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_26_ready = pipeline_6_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_27_ready = pipeline_6_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_28_ready = pipeline_7_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_29_ready = pipeline_7_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_30_ready = pipeline_7_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_31_ready = pipeline_7_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_32_ready = pipeline_8_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_33_ready = pipeline_8_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_34_ready = pipeline_8_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_35_ready = pipeline_8_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_36_ready = pipeline_9_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_37_ready = pipeline_9_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_38_ready = pipeline_9_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_39_ready = pipeline_9_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_40_ready = pipeline_10_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_41_ready = pipeline_10_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_42_ready = pipeline_10_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_43_ready = pipeline_10_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_44_ready = pipeline_11_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_45_ready = pipeline_11_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_46_ready = pipeline_11_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_47_ready = pipeline_11_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_48_ready = pipeline_12_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_49_ready = pipeline_12_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_50_ready = pipeline_12_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_51_ready = pipeline_12_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_52_ready = pipeline_13_io_p2_in_0_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_53_ready = pipeline_13_io_p2_in_1_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_54_ready = pipeline_13_io_p2_in_2_ready; // @[SLR1.scala 120:52]
  assign io_p2_in_55_ready = pipeline_13_io_p2_in_3_ready; // @[SLR1.scala 120:52]
  assign io_frontier_in_0_ready = pipeline_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_1_ready = pipeline_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_2_ready = pipeline_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_3_ready = pipeline_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_4_ready = pipeline_1_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_5_ready = pipeline_1_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_6_ready = pipeline_1_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_7_ready = pipeline_1_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_8_ready = pipeline_2_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_9_ready = pipeline_2_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_10_ready = pipeline_2_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_11_ready = pipeline_2_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_12_ready = pipeline_3_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_13_ready = pipeline_3_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_14_ready = pipeline_3_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_15_ready = pipeline_3_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_16_ready = pipeline_4_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_17_ready = pipeline_4_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_18_ready = pipeline_4_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_19_ready = pipeline_4_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_20_ready = pipeline_5_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_21_ready = pipeline_5_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_22_ready = pipeline_5_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_23_ready = pipeline_5_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_24_ready = pipeline_6_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_25_ready = pipeline_6_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_26_ready = pipeline_6_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_27_ready = pipeline_6_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_28_ready = pipeline_7_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_29_ready = pipeline_7_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_30_ready = pipeline_7_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_31_ready = pipeline_7_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_32_ready = pipeline_8_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_33_ready = pipeline_8_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_34_ready = pipeline_8_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_35_ready = pipeline_8_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_36_ready = pipeline_9_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_37_ready = pipeline_9_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_38_ready = pipeline_9_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_39_ready = pipeline_9_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_40_ready = pipeline_10_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_41_ready = pipeline_10_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_42_ready = pipeline_10_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_43_ready = pipeline_10_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_44_ready = pipeline_11_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_45_ready = pipeline_11_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_46_ready = pipeline_11_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_47_ready = pipeline_11_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_48_ready = pipeline_12_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_49_ready = pipeline_12_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_50_ready = pipeline_12_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_51_ready = pipeline_12_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_52_ready = pipeline_13_io_frontier_in_0_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_53_ready = pipeline_13_io_frontier_in_1_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_54_ready = pipeline_13_io_frontier_in_2_ready; // @[SLR1.scala 122:52]
  assign io_frontier_in_55_ready = pipeline_13_io_frontier_in_3_ready; // @[SLR1.scala 122:52]
  assign io_p2_out_0_valid = pipeline_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_0_bits = pipeline_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_1_valid = pipeline_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_1_bits = pipeline_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_2_valid = pipeline_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_2_bits = pipeline_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_3_valid = pipeline_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_3_bits = pipeline_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_4_valid = pipeline_1_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_4_bits = pipeline_1_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_5_valid = pipeline_1_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_5_bits = pipeline_1_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_6_valid = pipeline_1_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_6_bits = pipeline_1_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_7_valid = pipeline_1_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_7_bits = pipeline_1_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_8_valid = pipeline_2_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_8_bits = pipeline_2_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_9_valid = pipeline_2_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_9_bits = pipeline_2_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_10_valid = pipeline_2_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_10_bits = pipeline_2_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_11_valid = pipeline_2_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_11_bits = pipeline_2_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_12_valid = pipeline_3_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_12_bits = pipeline_3_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_13_valid = pipeline_3_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_13_bits = pipeline_3_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_14_valid = pipeline_3_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_14_bits = pipeline_3_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_15_valid = pipeline_3_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_15_bits = pipeline_3_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_16_valid = pipeline_4_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_16_bits = pipeline_4_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_17_valid = pipeline_4_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_17_bits = pipeline_4_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_18_valid = pipeline_4_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_18_bits = pipeline_4_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_19_valid = pipeline_4_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_19_bits = pipeline_4_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_20_valid = pipeline_5_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_20_bits = pipeline_5_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_21_valid = pipeline_5_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_21_bits = pipeline_5_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_22_valid = pipeline_5_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_22_bits = pipeline_5_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_23_valid = pipeline_5_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_23_bits = pipeline_5_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_24_valid = pipeline_6_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_24_bits = pipeline_6_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_25_valid = pipeline_6_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_25_bits = pipeline_6_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_26_valid = pipeline_6_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_26_bits = pipeline_6_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_27_valid = pipeline_6_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_27_bits = pipeline_6_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_28_valid = pipeline_7_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_28_bits = pipeline_7_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_29_valid = pipeline_7_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_29_bits = pipeline_7_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_30_valid = pipeline_7_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_30_bits = pipeline_7_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_31_valid = pipeline_7_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_31_bits = pipeline_7_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_32_valid = pipeline_8_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_32_bits = pipeline_8_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_33_valid = pipeline_8_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_33_bits = pipeline_8_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_34_valid = pipeline_8_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_34_bits = pipeline_8_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_35_valid = pipeline_8_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_35_bits = pipeline_8_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_36_valid = pipeline_9_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_36_bits = pipeline_9_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_37_valid = pipeline_9_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_37_bits = pipeline_9_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_38_valid = pipeline_9_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_38_bits = pipeline_9_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_39_valid = pipeline_9_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_39_bits = pipeline_9_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_40_valid = pipeline_10_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_40_bits = pipeline_10_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_41_valid = pipeline_10_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_41_bits = pipeline_10_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_42_valid = pipeline_10_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_42_bits = pipeline_10_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_43_valid = pipeline_10_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_43_bits = pipeline_10_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_44_valid = pipeline_11_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_44_bits = pipeline_11_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_45_valid = pipeline_11_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_45_bits = pipeline_11_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_46_valid = pipeline_11_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_46_bits = pipeline_11_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_47_valid = pipeline_11_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_47_bits = pipeline_11_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_48_valid = pipeline_12_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_48_bits = pipeline_12_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_49_valid = pipeline_12_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_49_bits = pipeline_12_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_50_valid = pipeline_12_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_50_bits = pipeline_12_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_51_valid = pipeline_12_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_51_bits = pipeline_12_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_52_valid = pipeline_13_io_p2_out_0_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_52_bits = pipeline_13_io_p2_out_0_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_53_valid = pipeline_13_io_p2_out_1_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_53_bits = pipeline_13_io_p2_out_1_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_54_valid = pipeline_13_io_p2_out_2_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_54_bits = pipeline_13_io_p2_out_2_bits; // @[SLR1.scala 123:52]
  assign io_p2_out_55_valid = pipeline_13_io_p2_out_3_valid; // @[SLR1.scala 123:52]
  assign io_p2_out_55_bits = pipeline_13_io_p2_out_3_bits; // @[SLR1.scala 123:52]
  assign io_R_array_index_0_valid = pipeline_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_0_bits = pipeline_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_1_valid = pipeline_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_1_bits = pipeline_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_2_valid = pipeline_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_2_bits = pipeline_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_3_valid = pipeline_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_3_bits = pipeline_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_4_valid = pipeline_1_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_4_bits = pipeline_1_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_5_valid = pipeline_1_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_5_bits = pipeline_1_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_6_valid = pipeline_1_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_6_bits = pipeline_1_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_7_valid = pipeline_1_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_7_bits = pipeline_1_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_8_valid = pipeline_2_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_8_bits = pipeline_2_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_9_valid = pipeline_2_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_9_bits = pipeline_2_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_10_valid = pipeline_2_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_10_bits = pipeline_2_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_11_valid = pipeline_2_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_11_bits = pipeline_2_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_12_valid = pipeline_3_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_12_bits = pipeline_3_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_13_valid = pipeline_3_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_13_bits = pipeline_3_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_14_valid = pipeline_3_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_14_bits = pipeline_3_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_15_valid = pipeline_3_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_15_bits = pipeline_3_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_16_valid = pipeline_4_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_16_bits = pipeline_4_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_17_valid = pipeline_4_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_17_bits = pipeline_4_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_18_valid = pipeline_4_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_18_bits = pipeline_4_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_19_valid = pipeline_4_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_19_bits = pipeline_4_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_20_valid = pipeline_5_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_20_bits = pipeline_5_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_21_valid = pipeline_5_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_21_bits = pipeline_5_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_22_valid = pipeline_5_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_22_bits = pipeline_5_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_23_valid = pipeline_5_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_23_bits = pipeline_5_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_24_valid = pipeline_6_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_24_bits = pipeline_6_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_25_valid = pipeline_6_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_25_bits = pipeline_6_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_26_valid = pipeline_6_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_26_bits = pipeline_6_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_27_valid = pipeline_6_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_27_bits = pipeline_6_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_28_valid = pipeline_7_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_28_bits = pipeline_7_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_29_valid = pipeline_7_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_29_bits = pipeline_7_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_30_valid = pipeline_7_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_30_bits = pipeline_7_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_31_valid = pipeline_7_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_31_bits = pipeline_7_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_32_valid = pipeline_8_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_32_bits = pipeline_8_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_33_valid = pipeline_8_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_33_bits = pipeline_8_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_34_valid = pipeline_8_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_34_bits = pipeline_8_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_35_valid = pipeline_8_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_35_bits = pipeline_8_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_36_valid = pipeline_9_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_36_bits = pipeline_9_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_37_valid = pipeline_9_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_37_bits = pipeline_9_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_38_valid = pipeline_9_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_38_bits = pipeline_9_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_39_valid = pipeline_9_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_39_bits = pipeline_9_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_40_valid = pipeline_10_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_40_bits = pipeline_10_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_41_valid = pipeline_10_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_41_bits = pipeline_10_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_42_valid = pipeline_10_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_42_bits = pipeline_10_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_43_valid = pipeline_10_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_43_bits = pipeline_10_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_44_valid = pipeline_11_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_44_bits = pipeline_11_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_45_valid = pipeline_11_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_45_bits = pipeline_11_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_46_valid = pipeline_11_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_46_bits = pipeline_11_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_47_valid = pipeline_11_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_47_bits = pipeline_11_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_48_valid = pipeline_12_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_48_bits = pipeline_12_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_49_valid = pipeline_12_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_49_bits = pipeline_12_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_50_valid = pipeline_12_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_50_bits = pipeline_12_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_51_valid = pipeline_12_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_51_bits = pipeline_12_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_52_valid = pipeline_13_io_R_array_index_0_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_52_bits = pipeline_13_io_R_array_index_0_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_53_valid = pipeline_13_io_R_array_index_1_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_53_bits = pipeline_13_io_R_array_index_1_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_54_valid = pipeline_13_io_R_array_index_2_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_54_bits = pipeline_13_io_R_array_index_2_bits; // @[SLR1.scala 124:52]
  assign io_R_array_index_55_valid = pipeline_13_io_R_array_index_3_valid; // @[SLR1.scala 124:52]
  assign io_R_array_index_55_bits = pipeline_13_io_R_array_index_3_bits; // @[SLR1.scala 124:52]
  assign io_p1_end_0 = pipeline_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_1 = pipeline_1_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_2 = pipeline_2_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_3 = pipeline_3_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_4 = pipeline_4_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_5 = pipeline_5_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_6 = pipeline_6_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_7 = pipeline_7_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_8 = pipeline_8_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_9 = pipeline_9_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_10 = pipeline_10_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_11 = pipeline_11_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_12 = pipeline_12_io_p1_end; // @[SLR1.scala 116:37]
  assign io_p1_end_13 = pipeline_13_io_p1_end; // @[SLR1.scala 116:37]
  assign io_uram_out_a_0 = _T_132; // @[SLR1.scala 125:61]
  assign io_uram_out_a_1 = _T_137; // @[SLR1.scala 125:61]
  assign io_uram_out_a_2 = _T_142; // @[SLR1.scala 125:61]
  assign io_uram_out_a_3 = _T_147; // @[SLR1.scala 125:61]
  assign io_uram_out_a_4 = _T_153; // @[SLR1.scala 125:61]
  assign io_uram_out_a_5 = _T_158; // @[SLR1.scala 125:61]
  assign io_uram_out_a_6 = _T_163; // @[SLR1.scala 125:61]
  assign io_uram_out_a_7 = _T_168; // @[SLR1.scala 125:61]
  assign io_uram_out_a_8 = _T_174; // @[SLR1.scala 125:61]
  assign io_uram_out_a_9 = _T_179; // @[SLR1.scala 125:61]
  assign io_uram_out_a_10 = _T_184; // @[SLR1.scala 125:61]
  assign io_uram_out_a_11 = _T_189; // @[SLR1.scala 125:61]
  assign io_uram_out_a_12 = _T_195; // @[SLR1.scala 125:61]
  assign io_uram_out_a_13 = _T_200; // @[SLR1.scala 125:61]
  assign io_uram_out_a_14 = _T_205; // @[SLR1.scala 125:61]
  assign io_uram_out_a_15 = _T_210; // @[SLR1.scala 125:61]
  assign io_uram_out_a_16 = _T_216; // @[SLR1.scala 125:61]
  assign io_uram_out_a_17 = _T_221; // @[SLR1.scala 125:61]
  assign io_uram_out_a_18 = _T_226; // @[SLR1.scala 125:61]
  assign io_uram_out_a_19 = _T_231; // @[SLR1.scala 125:61]
  assign io_uram_out_a_20 = _T_237; // @[SLR1.scala 125:61]
  assign io_uram_out_a_21 = _T_242; // @[SLR1.scala 125:61]
  assign io_uram_out_a_22 = _T_247; // @[SLR1.scala 125:61]
  assign io_uram_out_a_23 = _T_252; // @[SLR1.scala 125:61]
  assign io_uram_out_a_24 = _T_258; // @[SLR1.scala 125:61]
  assign io_uram_out_a_25 = _T_263; // @[SLR1.scala 125:61]
  assign io_uram_out_a_26 = _T_268; // @[SLR1.scala 125:61]
  assign io_uram_out_a_27 = _T_273; // @[SLR1.scala 125:61]
  assign io_uram_out_a_28 = _T_279; // @[SLR1.scala 125:61]
  assign io_uram_out_a_29 = _T_284; // @[SLR1.scala 125:61]
  assign io_uram_out_a_30 = _T_289; // @[SLR1.scala 125:61]
  assign io_uram_out_a_31 = _T_294; // @[SLR1.scala 125:61]
  assign io_uram_out_a_32 = _T_300; // @[SLR1.scala 125:61]
  assign io_uram_out_a_33 = _T_305; // @[SLR1.scala 125:61]
  assign io_uram_out_a_34 = _T_310; // @[SLR1.scala 125:61]
  assign io_uram_out_a_35 = _T_315; // @[SLR1.scala 125:61]
  assign io_uram_out_a_36 = _T_321; // @[SLR1.scala 125:61]
  assign io_uram_out_a_37 = _T_326; // @[SLR1.scala 125:61]
  assign io_uram_out_a_38 = _T_331; // @[SLR1.scala 125:61]
  assign io_uram_out_a_39 = _T_336; // @[SLR1.scala 125:61]
  assign io_uram_out_a_40 = _T_342; // @[SLR1.scala 125:61]
  assign io_uram_out_a_41 = _T_347; // @[SLR1.scala 125:61]
  assign io_uram_out_a_42 = _T_352; // @[SLR1.scala 125:61]
  assign io_uram_out_a_43 = _T_357; // @[SLR1.scala 125:61]
  assign io_uram_out_a_44 = _T_363; // @[SLR1.scala 125:61]
  assign io_uram_out_a_45 = _T_368; // @[SLR1.scala 125:61]
  assign io_uram_out_a_46 = _T_373; // @[SLR1.scala 125:61]
  assign io_uram_out_a_47 = _T_378; // @[SLR1.scala 125:61]
  assign io_uram_out_a_48 = _T_384; // @[SLR1.scala 125:61]
  assign io_uram_out_a_49 = _T_389; // @[SLR1.scala 125:61]
  assign io_uram_out_a_50 = _T_394; // @[SLR1.scala 125:61]
  assign io_uram_out_a_51 = _T_399; // @[SLR1.scala 125:61]
  assign io_uram_out_a_52 = _T_405; // @[SLR1.scala 125:61]
  assign io_uram_out_a_53 = _T_410; // @[SLR1.scala 125:61]
  assign io_uram_out_a_54 = _T_415; // @[SLR1.scala 125:61]
  assign io_uram_out_a_55 = _T_420; // @[SLR1.scala 125:61]
  assign pipeline_clock = clock;
  assign pipeline_reset = reset_reg_array_0;
  assign pipeline_io_frontier_flag = copy_frontier_flag_io_out_0; // @[SLR1.scala 102:44]
  assign pipeline_io_p2_end = copy_p2_end_io_out_0; // @[SLR1.scala 100:37]
  assign pipeline_io_start = copy_start_io_out_0; // @[SLR1.scala 101:36]
  assign pipeline_io_start_init = _T_131; // @[SLR1.scala 115:41]
  assign pipeline_io_level = copy_current_level_io_out_0; // @[SLR1.scala 103:36]
  assign pipeline_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_0; // @[SLR1.scala 104:51]
  assign pipeline_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_0; // @[SLR1.scala 105:51]
  assign pipeline_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_0; // @[SLR1.scala 106:51]
  assign pipeline_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_0; // @[SLR1.scala 107:51]
  assign pipeline_io_offsets_level_offset = copy_offset_level_offset_io_out_0; // @[SLR1.scala 108:51]
  assign pipeline_io_p2_in_0_valid = io_p2_in_0_valid; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_0_bits = io_p2_in_0_bits; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_1_valid = io_p2_in_1_valid; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_1_bits = io_p2_in_1_bits; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_2_valid = io_p2_in_2_valid; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_2_bits = io_p2_in_2_bits; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_3_valid = io_p2_in_3_valid; // @[SLR1.scala 120:52]
  assign pipeline_io_p2_in_3_bits = io_p2_in_3_bits; // @[SLR1.scala 120:52]
  assign pipeline_io_frontier_in_0_valid = io_frontier_in_0_valid; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_0_bits = io_frontier_in_0_bits; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_1_valid = io_frontier_in_1_valid; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_1_bits = io_frontier_in_1_bits; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_2_valid = io_frontier_in_2_valid; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_2_bits = io_frontier_in_2_bits; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_3_valid = io_frontier_in_3_valid; // @[SLR1.scala 122:52]
  assign pipeline_io_frontier_in_3_bits = io_frontier_in_3_bits; // @[SLR1.scala 122:52]
  assign pipeline_io_p2_out_0_ready = io_p2_out_0_ready; // @[SLR1.scala 123:52]
  assign pipeline_io_p2_out_1_ready = io_p2_out_1_ready; // @[SLR1.scala 123:52]
  assign pipeline_io_p2_out_2_ready = io_p2_out_2_ready; // @[SLR1.scala 123:52]
  assign pipeline_io_p2_out_3_ready = io_p2_out_3_ready; // @[SLR1.scala 123:52]
  assign pipeline_io_node_num = copy_node_num_io_out_0; // @[SLR1.scala 110:39]
  assign pipeline_io_push_or_pull = copy_push_or_pull_io_out_0; // @[SLR1.scala 112:43]
  assign pipeline_io_root = copy_root_io_out_0; // @[SLR1.scala 111:39]
  assign pipeline_io_R_array_index_0_ready = io_R_array_index_0_ready; // @[SLR1.scala 124:52]
  assign pipeline_io_R_array_index_1_ready = io_R_array_index_1_ready; // @[SLR1.scala 124:52]
  assign pipeline_io_R_array_index_2_ready = io_R_array_index_2_ready; // @[SLR1.scala 124:52]
  assign pipeline_io_R_array_index_3_ready = io_R_array_index_3_ready; // @[SLR1.scala 124:52]
  assign pipeline_io_uram_addr_a_0 = _T_133; // @[SLR1.scala 126:52]
  assign pipeline_io_uram_addr_a_1 = _T_138; // @[SLR1.scala 126:52]
  assign pipeline_io_uram_addr_a_2 = _T_143; // @[SLR1.scala 126:52]
  assign pipeline_io_uram_addr_a_3 = _T_148; // @[SLR1.scala 126:52]
  assign pipeline_1_clock = clock;
  assign pipeline_1_reset = reset_reg_array_1;
  assign pipeline_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[SLR1.scala 102:44]
  assign pipeline_1_io_p2_end = copy_p2_end_io_out_1; // @[SLR1.scala 100:37]
  assign pipeline_1_io_start = copy_start_io_out_1; // @[SLR1.scala 101:36]
  assign pipeline_1_io_start_init = _T_152; // @[SLR1.scala 115:41]
  assign pipeline_1_io_level = copy_current_level_io_out_1; // @[SLR1.scala 103:36]
  assign pipeline_1_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_1; // @[SLR1.scala 104:51]
  assign pipeline_1_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_1; // @[SLR1.scala 105:51]
  assign pipeline_1_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_1; // @[SLR1.scala 106:51]
  assign pipeline_1_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_1; // @[SLR1.scala 107:51]
  assign pipeline_1_io_offsets_level_offset = copy_offset_level_offset_io_out_1; // @[SLR1.scala 108:51]
  assign pipeline_1_io_p2_in_0_valid = io_p2_in_4_valid; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_0_bits = io_p2_in_4_bits; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_1_valid = io_p2_in_5_valid; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_1_bits = io_p2_in_5_bits; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_2_valid = io_p2_in_6_valid; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_2_bits = io_p2_in_6_bits; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_3_valid = io_p2_in_7_valid; // @[SLR1.scala 120:52]
  assign pipeline_1_io_p2_in_3_bits = io_p2_in_7_bits; // @[SLR1.scala 120:52]
  assign pipeline_1_io_frontier_in_0_valid = io_frontier_in_4_valid; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_0_bits = io_frontier_in_4_bits; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_1_valid = io_frontier_in_5_valid; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_1_bits = io_frontier_in_5_bits; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_2_valid = io_frontier_in_6_valid; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_2_bits = io_frontier_in_6_bits; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_3_valid = io_frontier_in_7_valid; // @[SLR1.scala 122:52]
  assign pipeline_1_io_frontier_in_3_bits = io_frontier_in_7_bits; // @[SLR1.scala 122:52]
  assign pipeline_1_io_p2_out_0_ready = io_p2_out_4_ready; // @[SLR1.scala 123:52]
  assign pipeline_1_io_p2_out_1_ready = io_p2_out_5_ready; // @[SLR1.scala 123:52]
  assign pipeline_1_io_p2_out_2_ready = io_p2_out_6_ready; // @[SLR1.scala 123:52]
  assign pipeline_1_io_p2_out_3_ready = io_p2_out_7_ready; // @[SLR1.scala 123:52]
  assign pipeline_1_io_node_num = copy_node_num_io_out_1; // @[SLR1.scala 110:39]
  assign pipeline_1_io_push_or_pull = copy_push_or_pull_io_out_1; // @[SLR1.scala 112:43]
  assign pipeline_1_io_root = copy_root_io_out_1; // @[SLR1.scala 111:39]
  assign pipeline_1_io_R_array_index_0_ready = io_R_array_index_4_ready; // @[SLR1.scala 124:52]
  assign pipeline_1_io_R_array_index_1_ready = io_R_array_index_5_ready; // @[SLR1.scala 124:52]
  assign pipeline_1_io_R_array_index_2_ready = io_R_array_index_6_ready; // @[SLR1.scala 124:52]
  assign pipeline_1_io_R_array_index_3_ready = io_R_array_index_7_ready; // @[SLR1.scala 124:52]
  assign pipeline_1_io_uram_addr_a_0 = _T_154; // @[SLR1.scala 126:52]
  assign pipeline_1_io_uram_addr_a_1 = _T_159; // @[SLR1.scala 126:52]
  assign pipeline_1_io_uram_addr_a_2 = _T_164; // @[SLR1.scala 126:52]
  assign pipeline_1_io_uram_addr_a_3 = _T_169; // @[SLR1.scala 126:52]
  assign pipeline_2_clock = clock;
  assign pipeline_2_reset = reset_reg_array_2;
  assign pipeline_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[SLR1.scala 102:44]
  assign pipeline_2_io_p2_end = copy_p2_end_io_out_2; // @[SLR1.scala 100:37]
  assign pipeline_2_io_start = copy_start_io_out_2; // @[SLR1.scala 101:36]
  assign pipeline_2_io_start_init = _T_173; // @[SLR1.scala 115:41]
  assign pipeline_2_io_level = copy_current_level_io_out_2; // @[SLR1.scala 103:36]
  assign pipeline_2_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_2; // @[SLR1.scala 104:51]
  assign pipeline_2_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_2; // @[SLR1.scala 105:51]
  assign pipeline_2_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_2; // @[SLR1.scala 106:51]
  assign pipeline_2_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_2; // @[SLR1.scala 107:51]
  assign pipeline_2_io_offsets_level_offset = copy_offset_level_offset_io_out_2; // @[SLR1.scala 108:51]
  assign pipeline_2_io_p2_in_0_valid = io_p2_in_8_valid; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_0_bits = io_p2_in_8_bits; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_1_valid = io_p2_in_9_valid; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_1_bits = io_p2_in_9_bits; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_2_valid = io_p2_in_10_valid; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_2_bits = io_p2_in_10_bits; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_3_valid = io_p2_in_11_valid; // @[SLR1.scala 120:52]
  assign pipeline_2_io_p2_in_3_bits = io_p2_in_11_bits; // @[SLR1.scala 120:52]
  assign pipeline_2_io_frontier_in_0_valid = io_frontier_in_8_valid; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_0_bits = io_frontier_in_8_bits; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_1_valid = io_frontier_in_9_valid; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_1_bits = io_frontier_in_9_bits; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_2_valid = io_frontier_in_10_valid; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_2_bits = io_frontier_in_10_bits; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_3_valid = io_frontier_in_11_valid; // @[SLR1.scala 122:52]
  assign pipeline_2_io_frontier_in_3_bits = io_frontier_in_11_bits; // @[SLR1.scala 122:52]
  assign pipeline_2_io_p2_out_0_ready = io_p2_out_8_ready; // @[SLR1.scala 123:52]
  assign pipeline_2_io_p2_out_1_ready = io_p2_out_9_ready; // @[SLR1.scala 123:52]
  assign pipeline_2_io_p2_out_2_ready = io_p2_out_10_ready; // @[SLR1.scala 123:52]
  assign pipeline_2_io_p2_out_3_ready = io_p2_out_11_ready; // @[SLR1.scala 123:52]
  assign pipeline_2_io_node_num = copy_node_num_io_out_2; // @[SLR1.scala 110:39]
  assign pipeline_2_io_push_or_pull = copy_push_or_pull_io_out_2; // @[SLR1.scala 112:43]
  assign pipeline_2_io_root = copy_root_io_out_2; // @[SLR1.scala 111:39]
  assign pipeline_2_io_R_array_index_0_ready = io_R_array_index_8_ready; // @[SLR1.scala 124:52]
  assign pipeline_2_io_R_array_index_1_ready = io_R_array_index_9_ready; // @[SLR1.scala 124:52]
  assign pipeline_2_io_R_array_index_2_ready = io_R_array_index_10_ready; // @[SLR1.scala 124:52]
  assign pipeline_2_io_R_array_index_3_ready = io_R_array_index_11_ready; // @[SLR1.scala 124:52]
  assign pipeline_2_io_uram_addr_a_0 = _T_175; // @[SLR1.scala 126:52]
  assign pipeline_2_io_uram_addr_a_1 = _T_180; // @[SLR1.scala 126:52]
  assign pipeline_2_io_uram_addr_a_2 = _T_185; // @[SLR1.scala 126:52]
  assign pipeline_2_io_uram_addr_a_3 = _T_190; // @[SLR1.scala 126:52]
  assign pipeline_3_clock = clock;
  assign pipeline_3_reset = reset_reg_array_3;
  assign pipeline_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[SLR1.scala 102:44]
  assign pipeline_3_io_p2_end = copy_p2_end_io_out_3; // @[SLR1.scala 100:37]
  assign pipeline_3_io_start = copy_start_io_out_3; // @[SLR1.scala 101:36]
  assign pipeline_3_io_start_init = _T_194; // @[SLR1.scala 115:41]
  assign pipeline_3_io_level = copy_current_level_io_out_3; // @[SLR1.scala 103:36]
  assign pipeline_3_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_3; // @[SLR1.scala 104:51]
  assign pipeline_3_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_3; // @[SLR1.scala 105:51]
  assign pipeline_3_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_3; // @[SLR1.scala 106:51]
  assign pipeline_3_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_3; // @[SLR1.scala 107:51]
  assign pipeline_3_io_offsets_level_offset = copy_offset_level_offset_io_out_3; // @[SLR1.scala 108:51]
  assign pipeline_3_io_p2_in_0_valid = io_p2_in_12_valid; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_0_bits = io_p2_in_12_bits; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_1_valid = io_p2_in_13_valid; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_1_bits = io_p2_in_13_bits; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_2_valid = io_p2_in_14_valid; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_2_bits = io_p2_in_14_bits; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_3_valid = io_p2_in_15_valid; // @[SLR1.scala 120:52]
  assign pipeline_3_io_p2_in_3_bits = io_p2_in_15_bits; // @[SLR1.scala 120:52]
  assign pipeline_3_io_frontier_in_0_valid = io_frontier_in_12_valid; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_0_bits = io_frontier_in_12_bits; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_1_valid = io_frontier_in_13_valid; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_1_bits = io_frontier_in_13_bits; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_2_valid = io_frontier_in_14_valid; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_2_bits = io_frontier_in_14_bits; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_3_valid = io_frontier_in_15_valid; // @[SLR1.scala 122:52]
  assign pipeline_3_io_frontier_in_3_bits = io_frontier_in_15_bits; // @[SLR1.scala 122:52]
  assign pipeline_3_io_p2_out_0_ready = io_p2_out_12_ready; // @[SLR1.scala 123:52]
  assign pipeline_3_io_p2_out_1_ready = io_p2_out_13_ready; // @[SLR1.scala 123:52]
  assign pipeline_3_io_p2_out_2_ready = io_p2_out_14_ready; // @[SLR1.scala 123:52]
  assign pipeline_3_io_p2_out_3_ready = io_p2_out_15_ready; // @[SLR1.scala 123:52]
  assign pipeline_3_io_node_num = copy_node_num_io_out_3; // @[SLR1.scala 110:39]
  assign pipeline_3_io_push_or_pull = copy_push_or_pull_io_out_3; // @[SLR1.scala 112:43]
  assign pipeline_3_io_root = copy_root_io_out_3; // @[SLR1.scala 111:39]
  assign pipeline_3_io_R_array_index_0_ready = io_R_array_index_12_ready; // @[SLR1.scala 124:52]
  assign pipeline_3_io_R_array_index_1_ready = io_R_array_index_13_ready; // @[SLR1.scala 124:52]
  assign pipeline_3_io_R_array_index_2_ready = io_R_array_index_14_ready; // @[SLR1.scala 124:52]
  assign pipeline_3_io_R_array_index_3_ready = io_R_array_index_15_ready; // @[SLR1.scala 124:52]
  assign pipeline_3_io_uram_addr_a_0 = _T_196; // @[SLR1.scala 126:52]
  assign pipeline_3_io_uram_addr_a_1 = _T_201; // @[SLR1.scala 126:52]
  assign pipeline_3_io_uram_addr_a_2 = _T_206; // @[SLR1.scala 126:52]
  assign pipeline_3_io_uram_addr_a_3 = _T_211; // @[SLR1.scala 126:52]
  assign pipeline_4_clock = clock;
  assign pipeline_4_reset = reset_reg_array_4;
  assign pipeline_4_io_frontier_flag = copy_frontier_flag_io_out_4; // @[SLR1.scala 102:44]
  assign pipeline_4_io_p2_end = copy_p2_end_io_out_4; // @[SLR1.scala 100:37]
  assign pipeline_4_io_start = copy_start_io_out_4; // @[SLR1.scala 101:36]
  assign pipeline_4_io_start_init = _T_215; // @[SLR1.scala 115:41]
  assign pipeline_4_io_level = copy_current_level_io_out_4; // @[SLR1.scala 103:36]
  assign pipeline_4_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_4; // @[SLR1.scala 104:51]
  assign pipeline_4_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_4; // @[SLR1.scala 105:51]
  assign pipeline_4_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_4; // @[SLR1.scala 106:51]
  assign pipeline_4_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_4; // @[SLR1.scala 107:51]
  assign pipeline_4_io_offsets_level_offset = copy_offset_level_offset_io_out_4; // @[SLR1.scala 108:51]
  assign pipeline_4_io_p2_in_0_valid = io_p2_in_16_valid; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_0_bits = io_p2_in_16_bits; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_1_valid = io_p2_in_17_valid; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_1_bits = io_p2_in_17_bits; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_2_valid = io_p2_in_18_valid; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_2_bits = io_p2_in_18_bits; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_3_valid = io_p2_in_19_valid; // @[SLR1.scala 120:52]
  assign pipeline_4_io_p2_in_3_bits = io_p2_in_19_bits; // @[SLR1.scala 120:52]
  assign pipeline_4_io_frontier_in_0_valid = io_frontier_in_16_valid; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_0_bits = io_frontier_in_16_bits; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_1_valid = io_frontier_in_17_valid; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_1_bits = io_frontier_in_17_bits; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_2_valid = io_frontier_in_18_valid; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_2_bits = io_frontier_in_18_bits; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_3_valid = io_frontier_in_19_valid; // @[SLR1.scala 122:52]
  assign pipeline_4_io_frontier_in_3_bits = io_frontier_in_19_bits; // @[SLR1.scala 122:52]
  assign pipeline_4_io_p2_out_0_ready = io_p2_out_16_ready; // @[SLR1.scala 123:52]
  assign pipeline_4_io_p2_out_1_ready = io_p2_out_17_ready; // @[SLR1.scala 123:52]
  assign pipeline_4_io_p2_out_2_ready = io_p2_out_18_ready; // @[SLR1.scala 123:52]
  assign pipeline_4_io_p2_out_3_ready = io_p2_out_19_ready; // @[SLR1.scala 123:52]
  assign pipeline_4_io_node_num = copy_node_num_io_out_4; // @[SLR1.scala 110:39]
  assign pipeline_4_io_push_or_pull = copy_push_or_pull_io_out_4; // @[SLR1.scala 112:43]
  assign pipeline_4_io_root = copy_root_io_out_4; // @[SLR1.scala 111:39]
  assign pipeline_4_io_R_array_index_0_ready = io_R_array_index_16_ready; // @[SLR1.scala 124:52]
  assign pipeline_4_io_R_array_index_1_ready = io_R_array_index_17_ready; // @[SLR1.scala 124:52]
  assign pipeline_4_io_R_array_index_2_ready = io_R_array_index_18_ready; // @[SLR1.scala 124:52]
  assign pipeline_4_io_R_array_index_3_ready = io_R_array_index_19_ready; // @[SLR1.scala 124:52]
  assign pipeline_4_io_uram_addr_a_0 = _T_217; // @[SLR1.scala 126:52]
  assign pipeline_4_io_uram_addr_a_1 = _T_222; // @[SLR1.scala 126:52]
  assign pipeline_4_io_uram_addr_a_2 = _T_227; // @[SLR1.scala 126:52]
  assign pipeline_4_io_uram_addr_a_3 = _T_232; // @[SLR1.scala 126:52]
  assign pipeline_5_clock = clock;
  assign pipeline_5_reset = reset_reg_array_5;
  assign pipeline_5_io_frontier_flag = copy_frontier_flag_io_out_5; // @[SLR1.scala 102:44]
  assign pipeline_5_io_p2_end = copy_p2_end_io_out_5; // @[SLR1.scala 100:37]
  assign pipeline_5_io_start = copy_start_io_out_5; // @[SLR1.scala 101:36]
  assign pipeline_5_io_start_init = _T_236; // @[SLR1.scala 115:41]
  assign pipeline_5_io_level = copy_current_level_io_out_5; // @[SLR1.scala 103:36]
  assign pipeline_5_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_5; // @[SLR1.scala 104:51]
  assign pipeline_5_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_5; // @[SLR1.scala 105:51]
  assign pipeline_5_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_5; // @[SLR1.scala 106:51]
  assign pipeline_5_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_5; // @[SLR1.scala 107:51]
  assign pipeline_5_io_offsets_level_offset = copy_offset_level_offset_io_out_5; // @[SLR1.scala 108:51]
  assign pipeline_5_io_p2_in_0_valid = io_p2_in_20_valid; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_0_bits = io_p2_in_20_bits; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_1_valid = io_p2_in_21_valid; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_1_bits = io_p2_in_21_bits; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_2_valid = io_p2_in_22_valid; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_2_bits = io_p2_in_22_bits; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_3_valid = io_p2_in_23_valid; // @[SLR1.scala 120:52]
  assign pipeline_5_io_p2_in_3_bits = io_p2_in_23_bits; // @[SLR1.scala 120:52]
  assign pipeline_5_io_frontier_in_0_valid = io_frontier_in_20_valid; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_0_bits = io_frontier_in_20_bits; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_1_valid = io_frontier_in_21_valid; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_1_bits = io_frontier_in_21_bits; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_2_valid = io_frontier_in_22_valid; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_2_bits = io_frontier_in_22_bits; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_3_valid = io_frontier_in_23_valid; // @[SLR1.scala 122:52]
  assign pipeline_5_io_frontier_in_3_bits = io_frontier_in_23_bits; // @[SLR1.scala 122:52]
  assign pipeline_5_io_p2_out_0_ready = io_p2_out_20_ready; // @[SLR1.scala 123:52]
  assign pipeline_5_io_p2_out_1_ready = io_p2_out_21_ready; // @[SLR1.scala 123:52]
  assign pipeline_5_io_p2_out_2_ready = io_p2_out_22_ready; // @[SLR1.scala 123:52]
  assign pipeline_5_io_p2_out_3_ready = io_p2_out_23_ready; // @[SLR1.scala 123:52]
  assign pipeline_5_io_node_num = copy_node_num_io_out_5; // @[SLR1.scala 110:39]
  assign pipeline_5_io_push_or_pull = copy_push_or_pull_io_out_5; // @[SLR1.scala 112:43]
  assign pipeline_5_io_root = copy_root_io_out_5; // @[SLR1.scala 111:39]
  assign pipeline_5_io_R_array_index_0_ready = io_R_array_index_20_ready; // @[SLR1.scala 124:52]
  assign pipeline_5_io_R_array_index_1_ready = io_R_array_index_21_ready; // @[SLR1.scala 124:52]
  assign pipeline_5_io_R_array_index_2_ready = io_R_array_index_22_ready; // @[SLR1.scala 124:52]
  assign pipeline_5_io_R_array_index_3_ready = io_R_array_index_23_ready; // @[SLR1.scala 124:52]
  assign pipeline_5_io_uram_addr_a_0 = _T_238; // @[SLR1.scala 126:52]
  assign pipeline_5_io_uram_addr_a_1 = _T_243; // @[SLR1.scala 126:52]
  assign pipeline_5_io_uram_addr_a_2 = _T_248; // @[SLR1.scala 126:52]
  assign pipeline_5_io_uram_addr_a_3 = _T_253; // @[SLR1.scala 126:52]
  assign pipeline_6_clock = clock;
  assign pipeline_6_reset = reset_reg_array_6;
  assign pipeline_6_io_frontier_flag = copy_frontier_flag_io_out_6; // @[SLR1.scala 102:44]
  assign pipeline_6_io_p2_end = copy_p2_end_io_out_6; // @[SLR1.scala 100:37]
  assign pipeline_6_io_start = copy_start_io_out_6; // @[SLR1.scala 101:36]
  assign pipeline_6_io_start_init = _T_257; // @[SLR1.scala 115:41]
  assign pipeline_6_io_level = copy_current_level_io_out_6; // @[SLR1.scala 103:36]
  assign pipeline_6_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_6; // @[SLR1.scala 104:51]
  assign pipeline_6_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_6; // @[SLR1.scala 105:51]
  assign pipeline_6_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_6; // @[SLR1.scala 106:51]
  assign pipeline_6_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_6; // @[SLR1.scala 107:51]
  assign pipeline_6_io_offsets_level_offset = copy_offset_level_offset_io_out_6; // @[SLR1.scala 108:51]
  assign pipeline_6_io_p2_in_0_valid = io_p2_in_24_valid; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_0_bits = io_p2_in_24_bits; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_1_valid = io_p2_in_25_valid; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_1_bits = io_p2_in_25_bits; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_2_valid = io_p2_in_26_valid; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_2_bits = io_p2_in_26_bits; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_3_valid = io_p2_in_27_valid; // @[SLR1.scala 120:52]
  assign pipeline_6_io_p2_in_3_bits = io_p2_in_27_bits; // @[SLR1.scala 120:52]
  assign pipeline_6_io_frontier_in_0_valid = io_frontier_in_24_valid; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_0_bits = io_frontier_in_24_bits; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_1_valid = io_frontier_in_25_valid; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_1_bits = io_frontier_in_25_bits; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_2_valid = io_frontier_in_26_valid; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_2_bits = io_frontier_in_26_bits; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_3_valid = io_frontier_in_27_valid; // @[SLR1.scala 122:52]
  assign pipeline_6_io_frontier_in_3_bits = io_frontier_in_27_bits; // @[SLR1.scala 122:52]
  assign pipeline_6_io_p2_out_0_ready = io_p2_out_24_ready; // @[SLR1.scala 123:52]
  assign pipeline_6_io_p2_out_1_ready = io_p2_out_25_ready; // @[SLR1.scala 123:52]
  assign pipeline_6_io_p2_out_2_ready = io_p2_out_26_ready; // @[SLR1.scala 123:52]
  assign pipeline_6_io_p2_out_3_ready = io_p2_out_27_ready; // @[SLR1.scala 123:52]
  assign pipeline_6_io_node_num = copy_node_num_io_out_6; // @[SLR1.scala 110:39]
  assign pipeline_6_io_push_or_pull = copy_push_or_pull_io_out_6; // @[SLR1.scala 112:43]
  assign pipeline_6_io_root = copy_root_io_out_6; // @[SLR1.scala 111:39]
  assign pipeline_6_io_R_array_index_0_ready = io_R_array_index_24_ready; // @[SLR1.scala 124:52]
  assign pipeline_6_io_R_array_index_1_ready = io_R_array_index_25_ready; // @[SLR1.scala 124:52]
  assign pipeline_6_io_R_array_index_2_ready = io_R_array_index_26_ready; // @[SLR1.scala 124:52]
  assign pipeline_6_io_R_array_index_3_ready = io_R_array_index_27_ready; // @[SLR1.scala 124:52]
  assign pipeline_6_io_uram_addr_a_0 = _T_259; // @[SLR1.scala 126:52]
  assign pipeline_6_io_uram_addr_a_1 = _T_264; // @[SLR1.scala 126:52]
  assign pipeline_6_io_uram_addr_a_2 = _T_269; // @[SLR1.scala 126:52]
  assign pipeline_6_io_uram_addr_a_3 = _T_274; // @[SLR1.scala 126:52]
  assign pipeline_7_clock = clock;
  assign pipeline_7_reset = reset_reg_array_7;
  assign pipeline_7_io_frontier_flag = copy_frontier_flag_io_out_7; // @[SLR1.scala 102:44]
  assign pipeline_7_io_p2_end = copy_p2_end_io_out_7; // @[SLR1.scala 100:37]
  assign pipeline_7_io_start = copy_start_io_out_7; // @[SLR1.scala 101:36]
  assign pipeline_7_io_start_init = _T_278; // @[SLR1.scala 115:41]
  assign pipeline_7_io_level = copy_current_level_io_out_7; // @[SLR1.scala 103:36]
  assign pipeline_7_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_7; // @[SLR1.scala 104:51]
  assign pipeline_7_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_7; // @[SLR1.scala 105:51]
  assign pipeline_7_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_7; // @[SLR1.scala 106:51]
  assign pipeline_7_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_7; // @[SLR1.scala 107:51]
  assign pipeline_7_io_offsets_level_offset = copy_offset_level_offset_io_out_7; // @[SLR1.scala 108:51]
  assign pipeline_7_io_p2_in_0_valid = io_p2_in_28_valid; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_0_bits = io_p2_in_28_bits; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_1_valid = io_p2_in_29_valid; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_1_bits = io_p2_in_29_bits; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_2_valid = io_p2_in_30_valid; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_2_bits = io_p2_in_30_bits; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_3_valid = io_p2_in_31_valid; // @[SLR1.scala 120:52]
  assign pipeline_7_io_p2_in_3_bits = io_p2_in_31_bits; // @[SLR1.scala 120:52]
  assign pipeline_7_io_frontier_in_0_valid = io_frontier_in_28_valid; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_0_bits = io_frontier_in_28_bits; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_1_valid = io_frontier_in_29_valid; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_1_bits = io_frontier_in_29_bits; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_2_valid = io_frontier_in_30_valid; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_2_bits = io_frontier_in_30_bits; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_3_valid = io_frontier_in_31_valid; // @[SLR1.scala 122:52]
  assign pipeline_7_io_frontier_in_3_bits = io_frontier_in_31_bits; // @[SLR1.scala 122:52]
  assign pipeline_7_io_p2_out_0_ready = io_p2_out_28_ready; // @[SLR1.scala 123:52]
  assign pipeline_7_io_p2_out_1_ready = io_p2_out_29_ready; // @[SLR1.scala 123:52]
  assign pipeline_7_io_p2_out_2_ready = io_p2_out_30_ready; // @[SLR1.scala 123:52]
  assign pipeline_7_io_p2_out_3_ready = io_p2_out_31_ready; // @[SLR1.scala 123:52]
  assign pipeline_7_io_node_num = copy_node_num_io_out_7; // @[SLR1.scala 110:39]
  assign pipeline_7_io_push_or_pull = copy_push_or_pull_io_out_7; // @[SLR1.scala 112:43]
  assign pipeline_7_io_root = copy_root_io_out_7; // @[SLR1.scala 111:39]
  assign pipeline_7_io_R_array_index_0_ready = io_R_array_index_28_ready; // @[SLR1.scala 124:52]
  assign pipeline_7_io_R_array_index_1_ready = io_R_array_index_29_ready; // @[SLR1.scala 124:52]
  assign pipeline_7_io_R_array_index_2_ready = io_R_array_index_30_ready; // @[SLR1.scala 124:52]
  assign pipeline_7_io_R_array_index_3_ready = io_R_array_index_31_ready; // @[SLR1.scala 124:52]
  assign pipeline_7_io_uram_addr_a_0 = _T_280; // @[SLR1.scala 126:52]
  assign pipeline_7_io_uram_addr_a_1 = _T_285; // @[SLR1.scala 126:52]
  assign pipeline_7_io_uram_addr_a_2 = _T_290; // @[SLR1.scala 126:52]
  assign pipeline_7_io_uram_addr_a_3 = _T_295; // @[SLR1.scala 126:52]
  assign pipeline_8_clock = clock;
  assign pipeline_8_reset = reset_reg_array_8;
  assign pipeline_8_io_frontier_flag = copy_frontier_flag_io_out_8; // @[SLR1.scala 102:44]
  assign pipeline_8_io_p2_end = copy_p2_end_io_out_8; // @[SLR1.scala 100:37]
  assign pipeline_8_io_start = copy_start_io_out_8; // @[SLR1.scala 101:36]
  assign pipeline_8_io_start_init = _T_299; // @[SLR1.scala 115:41]
  assign pipeline_8_io_level = copy_current_level_io_out_8; // @[SLR1.scala 103:36]
  assign pipeline_8_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_8; // @[SLR1.scala 104:51]
  assign pipeline_8_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_8; // @[SLR1.scala 105:51]
  assign pipeline_8_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_8; // @[SLR1.scala 106:51]
  assign pipeline_8_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_8; // @[SLR1.scala 107:51]
  assign pipeline_8_io_offsets_level_offset = copy_offset_level_offset_io_out_8; // @[SLR1.scala 108:51]
  assign pipeline_8_io_p2_in_0_valid = io_p2_in_32_valid; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_0_bits = io_p2_in_32_bits; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_1_valid = io_p2_in_33_valid; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_1_bits = io_p2_in_33_bits; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_2_valid = io_p2_in_34_valid; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_2_bits = io_p2_in_34_bits; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_3_valid = io_p2_in_35_valid; // @[SLR1.scala 120:52]
  assign pipeline_8_io_p2_in_3_bits = io_p2_in_35_bits; // @[SLR1.scala 120:52]
  assign pipeline_8_io_frontier_in_0_valid = io_frontier_in_32_valid; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_0_bits = io_frontier_in_32_bits; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_1_valid = io_frontier_in_33_valid; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_1_bits = io_frontier_in_33_bits; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_2_valid = io_frontier_in_34_valid; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_2_bits = io_frontier_in_34_bits; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_3_valid = io_frontier_in_35_valid; // @[SLR1.scala 122:52]
  assign pipeline_8_io_frontier_in_3_bits = io_frontier_in_35_bits; // @[SLR1.scala 122:52]
  assign pipeline_8_io_p2_out_0_ready = io_p2_out_32_ready; // @[SLR1.scala 123:52]
  assign pipeline_8_io_p2_out_1_ready = io_p2_out_33_ready; // @[SLR1.scala 123:52]
  assign pipeline_8_io_p2_out_2_ready = io_p2_out_34_ready; // @[SLR1.scala 123:52]
  assign pipeline_8_io_p2_out_3_ready = io_p2_out_35_ready; // @[SLR1.scala 123:52]
  assign pipeline_8_io_node_num = copy_node_num_io_out_8; // @[SLR1.scala 110:39]
  assign pipeline_8_io_push_or_pull = copy_push_or_pull_io_out_8; // @[SLR1.scala 112:43]
  assign pipeline_8_io_root = copy_root_io_out_8; // @[SLR1.scala 111:39]
  assign pipeline_8_io_R_array_index_0_ready = io_R_array_index_32_ready; // @[SLR1.scala 124:52]
  assign pipeline_8_io_R_array_index_1_ready = io_R_array_index_33_ready; // @[SLR1.scala 124:52]
  assign pipeline_8_io_R_array_index_2_ready = io_R_array_index_34_ready; // @[SLR1.scala 124:52]
  assign pipeline_8_io_R_array_index_3_ready = io_R_array_index_35_ready; // @[SLR1.scala 124:52]
  assign pipeline_8_io_uram_addr_a_0 = _T_301; // @[SLR1.scala 126:52]
  assign pipeline_8_io_uram_addr_a_1 = _T_306; // @[SLR1.scala 126:52]
  assign pipeline_8_io_uram_addr_a_2 = _T_311; // @[SLR1.scala 126:52]
  assign pipeline_8_io_uram_addr_a_3 = _T_316; // @[SLR1.scala 126:52]
  assign pipeline_9_clock = clock;
  assign pipeline_9_reset = reset_reg_array_9;
  assign pipeline_9_io_frontier_flag = copy_frontier_flag_io_out_9; // @[SLR1.scala 102:44]
  assign pipeline_9_io_p2_end = copy_p2_end_io_out_9; // @[SLR1.scala 100:37]
  assign pipeline_9_io_start = copy_start_io_out_9; // @[SLR1.scala 101:36]
  assign pipeline_9_io_start_init = _T_320; // @[SLR1.scala 115:41]
  assign pipeline_9_io_level = copy_current_level_io_out_9; // @[SLR1.scala 103:36]
  assign pipeline_9_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_9; // @[SLR1.scala 104:51]
  assign pipeline_9_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_9; // @[SLR1.scala 105:51]
  assign pipeline_9_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_9; // @[SLR1.scala 106:51]
  assign pipeline_9_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_9; // @[SLR1.scala 107:51]
  assign pipeline_9_io_offsets_level_offset = copy_offset_level_offset_io_out_9; // @[SLR1.scala 108:51]
  assign pipeline_9_io_p2_in_0_valid = io_p2_in_36_valid; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_0_bits = io_p2_in_36_bits; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_1_valid = io_p2_in_37_valid; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_1_bits = io_p2_in_37_bits; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_2_valid = io_p2_in_38_valid; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_2_bits = io_p2_in_38_bits; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_3_valid = io_p2_in_39_valid; // @[SLR1.scala 120:52]
  assign pipeline_9_io_p2_in_3_bits = io_p2_in_39_bits; // @[SLR1.scala 120:52]
  assign pipeline_9_io_frontier_in_0_valid = io_frontier_in_36_valid; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_0_bits = io_frontier_in_36_bits; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_1_valid = io_frontier_in_37_valid; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_1_bits = io_frontier_in_37_bits; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_2_valid = io_frontier_in_38_valid; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_2_bits = io_frontier_in_38_bits; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_3_valid = io_frontier_in_39_valid; // @[SLR1.scala 122:52]
  assign pipeline_9_io_frontier_in_3_bits = io_frontier_in_39_bits; // @[SLR1.scala 122:52]
  assign pipeline_9_io_p2_out_0_ready = io_p2_out_36_ready; // @[SLR1.scala 123:52]
  assign pipeline_9_io_p2_out_1_ready = io_p2_out_37_ready; // @[SLR1.scala 123:52]
  assign pipeline_9_io_p2_out_2_ready = io_p2_out_38_ready; // @[SLR1.scala 123:52]
  assign pipeline_9_io_p2_out_3_ready = io_p2_out_39_ready; // @[SLR1.scala 123:52]
  assign pipeline_9_io_node_num = copy_node_num_io_out_9; // @[SLR1.scala 110:39]
  assign pipeline_9_io_push_or_pull = copy_push_or_pull_io_out_9; // @[SLR1.scala 112:43]
  assign pipeline_9_io_root = copy_root_io_out_9; // @[SLR1.scala 111:39]
  assign pipeline_9_io_R_array_index_0_ready = io_R_array_index_36_ready; // @[SLR1.scala 124:52]
  assign pipeline_9_io_R_array_index_1_ready = io_R_array_index_37_ready; // @[SLR1.scala 124:52]
  assign pipeline_9_io_R_array_index_2_ready = io_R_array_index_38_ready; // @[SLR1.scala 124:52]
  assign pipeline_9_io_R_array_index_3_ready = io_R_array_index_39_ready; // @[SLR1.scala 124:52]
  assign pipeline_9_io_uram_addr_a_0 = _T_322; // @[SLR1.scala 126:52]
  assign pipeline_9_io_uram_addr_a_1 = _T_327; // @[SLR1.scala 126:52]
  assign pipeline_9_io_uram_addr_a_2 = _T_332; // @[SLR1.scala 126:52]
  assign pipeline_9_io_uram_addr_a_3 = _T_337; // @[SLR1.scala 126:52]
  assign pipeline_10_clock = clock;
  assign pipeline_10_reset = reset_reg_array_10;
  assign pipeline_10_io_frontier_flag = copy_frontier_flag_io_out_10; // @[SLR1.scala 102:44]
  assign pipeline_10_io_p2_end = copy_p2_end_io_out_10; // @[SLR1.scala 100:37]
  assign pipeline_10_io_start = copy_start_io_out_10; // @[SLR1.scala 101:36]
  assign pipeline_10_io_start_init = _T_341; // @[SLR1.scala 115:41]
  assign pipeline_10_io_level = copy_current_level_io_out_10; // @[SLR1.scala 103:36]
  assign pipeline_10_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_10; // @[SLR1.scala 104:51]
  assign pipeline_10_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_10; // @[SLR1.scala 105:51]
  assign pipeline_10_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_10; // @[SLR1.scala 106:51]
  assign pipeline_10_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_10; // @[SLR1.scala 107:51]
  assign pipeline_10_io_offsets_level_offset = copy_offset_level_offset_io_out_10; // @[SLR1.scala 108:51]
  assign pipeline_10_io_p2_in_0_valid = io_p2_in_40_valid; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_0_bits = io_p2_in_40_bits; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_1_valid = io_p2_in_41_valid; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_1_bits = io_p2_in_41_bits; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_2_valid = io_p2_in_42_valid; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_2_bits = io_p2_in_42_bits; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_3_valid = io_p2_in_43_valid; // @[SLR1.scala 120:52]
  assign pipeline_10_io_p2_in_3_bits = io_p2_in_43_bits; // @[SLR1.scala 120:52]
  assign pipeline_10_io_frontier_in_0_valid = io_frontier_in_40_valid; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_0_bits = io_frontier_in_40_bits; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_1_valid = io_frontier_in_41_valid; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_1_bits = io_frontier_in_41_bits; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_2_valid = io_frontier_in_42_valid; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_2_bits = io_frontier_in_42_bits; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_3_valid = io_frontier_in_43_valid; // @[SLR1.scala 122:52]
  assign pipeline_10_io_frontier_in_3_bits = io_frontier_in_43_bits; // @[SLR1.scala 122:52]
  assign pipeline_10_io_p2_out_0_ready = io_p2_out_40_ready; // @[SLR1.scala 123:52]
  assign pipeline_10_io_p2_out_1_ready = io_p2_out_41_ready; // @[SLR1.scala 123:52]
  assign pipeline_10_io_p2_out_2_ready = io_p2_out_42_ready; // @[SLR1.scala 123:52]
  assign pipeline_10_io_p2_out_3_ready = io_p2_out_43_ready; // @[SLR1.scala 123:52]
  assign pipeline_10_io_node_num = copy_node_num_io_out_10; // @[SLR1.scala 110:39]
  assign pipeline_10_io_push_or_pull = copy_push_or_pull_io_out_10; // @[SLR1.scala 112:43]
  assign pipeline_10_io_root = copy_root_io_out_10; // @[SLR1.scala 111:39]
  assign pipeline_10_io_R_array_index_0_ready = io_R_array_index_40_ready; // @[SLR1.scala 124:52]
  assign pipeline_10_io_R_array_index_1_ready = io_R_array_index_41_ready; // @[SLR1.scala 124:52]
  assign pipeline_10_io_R_array_index_2_ready = io_R_array_index_42_ready; // @[SLR1.scala 124:52]
  assign pipeline_10_io_R_array_index_3_ready = io_R_array_index_43_ready; // @[SLR1.scala 124:52]
  assign pipeline_10_io_uram_addr_a_0 = _T_343; // @[SLR1.scala 126:52]
  assign pipeline_10_io_uram_addr_a_1 = _T_348; // @[SLR1.scala 126:52]
  assign pipeline_10_io_uram_addr_a_2 = _T_353; // @[SLR1.scala 126:52]
  assign pipeline_10_io_uram_addr_a_3 = _T_358; // @[SLR1.scala 126:52]
  assign pipeline_11_clock = clock;
  assign pipeline_11_reset = reset_reg_array_11;
  assign pipeline_11_io_frontier_flag = copy_frontier_flag_io_out_11; // @[SLR1.scala 102:44]
  assign pipeline_11_io_p2_end = copy_p2_end_io_out_11; // @[SLR1.scala 100:37]
  assign pipeline_11_io_start = copy_start_io_out_11; // @[SLR1.scala 101:36]
  assign pipeline_11_io_start_init = _T_362; // @[SLR1.scala 115:41]
  assign pipeline_11_io_level = copy_current_level_io_out_11; // @[SLR1.scala 103:36]
  assign pipeline_11_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_11; // @[SLR1.scala 104:51]
  assign pipeline_11_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_11; // @[SLR1.scala 105:51]
  assign pipeline_11_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_11; // @[SLR1.scala 106:51]
  assign pipeline_11_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_11; // @[SLR1.scala 107:51]
  assign pipeline_11_io_offsets_level_offset = copy_offset_level_offset_io_out_11; // @[SLR1.scala 108:51]
  assign pipeline_11_io_p2_in_0_valid = io_p2_in_44_valid; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_0_bits = io_p2_in_44_bits; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_1_valid = io_p2_in_45_valid; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_1_bits = io_p2_in_45_bits; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_2_valid = io_p2_in_46_valid; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_2_bits = io_p2_in_46_bits; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_3_valid = io_p2_in_47_valid; // @[SLR1.scala 120:52]
  assign pipeline_11_io_p2_in_3_bits = io_p2_in_47_bits; // @[SLR1.scala 120:52]
  assign pipeline_11_io_frontier_in_0_valid = io_frontier_in_44_valid; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_0_bits = io_frontier_in_44_bits; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_1_valid = io_frontier_in_45_valid; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_1_bits = io_frontier_in_45_bits; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_2_valid = io_frontier_in_46_valid; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_2_bits = io_frontier_in_46_bits; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_3_valid = io_frontier_in_47_valid; // @[SLR1.scala 122:52]
  assign pipeline_11_io_frontier_in_3_bits = io_frontier_in_47_bits; // @[SLR1.scala 122:52]
  assign pipeline_11_io_p2_out_0_ready = io_p2_out_44_ready; // @[SLR1.scala 123:52]
  assign pipeline_11_io_p2_out_1_ready = io_p2_out_45_ready; // @[SLR1.scala 123:52]
  assign pipeline_11_io_p2_out_2_ready = io_p2_out_46_ready; // @[SLR1.scala 123:52]
  assign pipeline_11_io_p2_out_3_ready = io_p2_out_47_ready; // @[SLR1.scala 123:52]
  assign pipeline_11_io_node_num = copy_node_num_io_out_11; // @[SLR1.scala 110:39]
  assign pipeline_11_io_push_or_pull = copy_push_or_pull_io_out_11; // @[SLR1.scala 112:43]
  assign pipeline_11_io_root = copy_root_io_out_11; // @[SLR1.scala 111:39]
  assign pipeline_11_io_R_array_index_0_ready = io_R_array_index_44_ready; // @[SLR1.scala 124:52]
  assign pipeline_11_io_R_array_index_1_ready = io_R_array_index_45_ready; // @[SLR1.scala 124:52]
  assign pipeline_11_io_R_array_index_2_ready = io_R_array_index_46_ready; // @[SLR1.scala 124:52]
  assign pipeline_11_io_R_array_index_3_ready = io_R_array_index_47_ready; // @[SLR1.scala 124:52]
  assign pipeline_11_io_uram_addr_a_0 = _T_364; // @[SLR1.scala 126:52]
  assign pipeline_11_io_uram_addr_a_1 = _T_369; // @[SLR1.scala 126:52]
  assign pipeline_11_io_uram_addr_a_2 = _T_374; // @[SLR1.scala 126:52]
  assign pipeline_11_io_uram_addr_a_3 = _T_379; // @[SLR1.scala 126:52]
  assign pipeline_12_clock = clock;
  assign pipeline_12_reset = reset_reg_array_12;
  assign pipeline_12_io_frontier_flag = copy_frontier_flag_io_out_12; // @[SLR1.scala 102:44]
  assign pipeline_12_io_p2_end = copy_p2_end_io_out_12; // @[SLR1.scala 100:37]
  assign pipeline_12_io_start = copy_start_io_out_12; // @[SLR1.scala 101:36]
  assign pipeline_12_io_start_init = _T_383; // @[SLR1.scala 115:41]
  assign pipeline_12_io_level = copy_current_level_io_out_12; // @[SLR1.scala 103:36]
  assign pipeline_12_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_12; // @[SLR1.scala 104:51]
  assign pipeline_12_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_12; // @[SLR1.scala 105:51]
  assign pipeline_12_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_12; // @[SLR1.scala 106:51]
  assign pipeline_12_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_12; // @[SLR1.scala 107:51]
  assign pipeline_12_io_offsets_level_offset = copy_offset_level_offset_io_out_12; // @[SLR1.scala 108:51]
  assign pipeline_12_io_p2_in_0_valid = io_p2_in_48_valid; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_0_bits = io_p2_in_48_bits; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_1_valid = io_p2_in_49_valid; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_1_bits = io_p2_in_49_bits; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_2_valid = io_p2_in_50_valid; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_2_bits = io_p2_in_50_bits; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_3_valid = io_p2_in_51_valid; // @[SLR1.scala 120:52]
  assign pipeline_12_io_p2_in_3_bits = io_p2_in_51_bits; // @[SLR1.scala 120:52]
  assign pipeline_12_io_frontier_in_0_valid = io_frontier_in_48_valid; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_0_bits = io_frontier_in_48_bits; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_1_valid = io_frontier_in_49_valid; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_1_bits = io_frontier_in_49_bits; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_2_valid = io_frontier_in_50_valid; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_2_bits = io_frontier_in_50_bits; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_3_valid = io_frontier_in_51_valid; // @[SLR1.scala 122:52]
  assign pipeline_12_io_frontier_in_3_bits = io_frontier_in_51_bits; // @[SLR1.scala 122:52]
  assign pipeline_12_io_p2_out_0_ready = io_p2_out_48_ready; // @[SLR1.scala 123:52]
  assign pipeline_12_io_p2_out_1_ready = io_p2_out_49_ready; // @[SLR1.scala 123:52]
  assign pipeline_12_io_p2_out_2_ready = io_p2_out_50_ready; // @[SLR1.scala 123:52]
  assign pipeline_12_io_p2_out_3_ready = io_p2_out_51_ready; // @[SLR1.scala 123:52]
  assign pipeline_12_io_node_num = copy_node_num_io_out_12; // @[SLR1.scala 110:39]
  assign pipeline_12_io_push_or_pull = copy_push_or_pull_io_out_12; // @[SLR1.scala 112:43]
  assign pipeline_12_io_root = copy_root_io_out_12; // @[SLR1.scala 111:39]
  assign pipeline_12_io_R_array_index_0_ready = io_R_array_index_48_ready; // @[SLR1.scala 124:52]
  assign pipeline_12_io_R_array_index_1_ready = io_R_array_index_49_ready; // @[SLR1.scala 124:52]
  assign pipeline_12_io_R_array_index_2_ready = io_R_array_index_50_ready; // @[SLR1.scala 124:52]
  assign pipeline_12_io_R_array_index_3_ready = io_R_array_index_51_ready; // @[SLR1.scala 124:52]
  assign pipeline_12_io_uram_addr_a_0 = _T_385; // @[SLR1.scala 126:52]
  assign pipeline_12_io_uram_addr_a_1 = _T_390; // @[SLR1.scala 126:52]
  assign pipeline_12_io_uram_addr_a_2 = _T_395; // @[SLR1.scala 126:52]
  assign pipeline_12_io_uram_addr_a_3 = _T_400; // @[SLR1.scala 126:52]
  assign pipeline_13_clock = clock;
  assign pipeline_13_reset = reset_reg_array_13;
  assign pipeline_13_io_frontier_flag = copy_frontier_flag_io_out_13; // @[SLR1.scala 102:44]
  assign pipeline_13_io_p2_end = copy_p2_end_io_out_13; // @[SLR1.scala 100:37]
  assign pipeline_13_io_start = copy_start_io_out_13; // @[SLR1.scala 101:36]
  assign pipeline_13_io_start_init = _T_404; // @[SLR1.scala 115:41]
  assign pipeline_13_io_level = copy_current_level_io_out_13; // @[SLR1.scala 103:36]
  assign pipeline_13_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_13; // @[SLR1.scala 104:51]
  assign pipeline_13_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_13; // @[SLR1.scala 105:51]
  assign pipeline_13_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_13; // @[SLR1.scala 106:51]
  assign pipeline_13_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_13; // @[SLR1.scala 107:51]
  assign pipeline_13_io_offsets_level_offset = copy_offset_level_offset_io_out_13; // @[SLR1.scala 108:51]
  assign pipeline_13_io_p2_in_0_valid = io_p2_in_52_valid; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_0_bits = io_p2_in_52_bits; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_1_valid = io_p2_in_53_valid; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_1_bits = io_p2_in_53_bits; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_2_valid = io_p2_in_54_valid; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_2_bits = io_p2_in_54_bits; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_3_valid = io_p2_in_55_valid; // @[SLR1.scala 120:52]
  assign pipeline_13_io_p2_in_3_bits = io_p2_in_55_bits; // @[SLR1.scala 120:52]
  assign pipeline_13_io_frontier_in_0_valid = io_frontier_in_52_valid; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_0_bits = io_frontier_in_52_bits; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_1_valid = io_frontier_in_53_valid; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_1_bits = io_frontier_in_53_bits; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_2_valid = io_frontier_in_54_valid; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_2_bits = io_frontier_in_54_bits; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_3_valid = io_frontier_in_55_valid; // @[SLR1.scala 122:52]
  assign pipeline_13_io_frontier_in_3_bits = io_frontier_in_55_bits; // @[SLR1.scala 122:52]
  assign pipeline_13_io_p2_out_0_ready = io_p2_out_52_ready; // @[SLR1.scala 123:52]
  assign pipeline_13_io_p2_out_1_ready = io_p2_out_53_ready; // @[SLR1.scala 123:52]
  assign pipeline_13_io_p2_out_2_ready = io_p2_out_54_ready; // @[SLR1.scala 123:52]
  assign pipeline_13_io_p2_out_3_ready = io_p2_out_55_ready; // @[SLR1.scala 123:52]
  assign pipeline_13_io_node_num = copy_node_num_io_out_13; // @[SLR1.scala 110:39]
  assign pipeline_13_io_push_or_pull = copy_push_or_pull_io_out_13; // @[SLR1.scala 112:43]
  assign pipeline_13_io_root = copy_root_io_out_13; // @[SLR1.scala 111:39]
  assign pipeline_13_io_R_array_index_0_ready = io_R_array_index_52_ready; // @[SLR1.scala 124:52]
  assign pipeline_13_io_R_array_index_1_ready = io_R_array_index_53_ready; // @[SLR1.scala 124:52]
  assign pipeline_13_io_R_array_index_2_ready = io_R_array_index_54_ready; // @[SLR1.scala 124:52]
  assign pipeline_13_io_R_array_index_3_ready = io_R_array_index_55_ready; // @[SLR1.scala 124:52]
  assign pipeline_13_io_uram_addr_a_0 = _T_406; // @[SLR1.scala 126:52]
  assign pipeline_13_io_uram_addr_a_1 = _T_411; // @[SLR1.scala 126:52]
  assign pipeline_13_io_uram_addr_a_2 = _T_416; // @[SLR1.scala 126:52]
  assign pipeline_13_io_uram_addr_a_3 = _T_421; // @[SLR1.scala 126:52]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[SLR1.scala 63:22]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[SLR1.scala 65:30]
  assign copy_current_level_clock = clock;
  assign copy_current_level_reset = reset;
  assign copy_current_level_io_in = io_level; // @[SLR1.scala 66:30]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[SLR1.scala 67:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[SLR1.scala 68:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T_14; // @[SLR1.scala 69:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_15; // @[SLR1.scala 70:21]
  assign copy_offset_CSR_R_offset_clock = clock;
  assign copy_offset_CSR_R_offset_reset = reset;
  assign copy_offset_CSR_R_offset_io_in = _T_16; // @[SLR1.scala 77:36]
  assign copy_offset_CSR_C_offset_clock = clock;
  assign copy_offset_CSR_C_offset_reset = reset;
  assign copy_offset_CSR_C_offset_io_in = _T_17; // @[SLR1.scala 78:36]
  assign copy_offset_CSC_R_offset_clock = clock;
  assign copy_offset_CSC_R_offset_reset = reset;
  assign copy_offset_CSC_R_offset_io_in = _T_18; // @[SLR1.scala 79:36]
  assign copy_offset_CSC_C_offset_clock = clock;
  assign copy_offset_CSC_C_offset_reset = reset;
  assign copy_offset_CSC_C_offset_io_in = _T_19; // @[SLR1.scala 80:36]
  assign copy_offset_level_offset_clock = clock;
  assign copy_offset_level_offset_reset = reset;
  assign copy_offset_level_offset_io_in = _T_20; // @[SLR1.scala 81:36]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  reset_reg = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  reset_reg_array_0 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  reset_reg_array_1 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  reset_reg_array_2 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  reset_reg_array_3 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  reset_reg_array_4 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  reset_reg_array_5 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  reset_reg_array_6 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  reset_reg_array_7 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  reset_reg_array_8 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  reset_reg_array_9 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  reset_reg_array_10 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  reset_reg_array_11 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  reset_reg_array_12 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  reset_reg_array_13 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  _T_14 = _RAND_15[31:0];
  _RAND_16 = {1{`RANDOM}};
  _T_15 = _RAND_16[31:0];
  _RAND_17 = {1{`RANDOM}};
  _T_16 = _RAND_17[31:0];
  _RAND_18 = {1{`RANDOM}};
  _T_17 = _RAND_18[31:0];
  _RAND_19 = {1{`RANDOM}};
  _T_18 = _RAND_19[31:0];
  _RAND_20 = {1{`RANDOM}};
  _T_19 = _RAND_20[31:0];
  _RAND_21 = {1{`RANDOM}};
  _T_20 = _RAND_21[31:0];
  _RAND_22 = {1{`RANDOM}};
  r_array_count_0 = _RAND_22[31:0];
  _RAND_23 = {1{`RANDOM}};
  r_array_count_1 = _RAND_23[31:0];
  _RAND_24 = {1{`RANDOM}};
  r_array_count_2 = _RAND_24[31:0];
  _RAND_25 = {1{`RANDOM}};
  r_array_count_3 = _RAND_25[31:0];
  _RAND_26 = {1{`RANDOM}};
  r_array_count_4 = _RAND_26[31:0];
  _RAND_27 = {1{`RANDOM}};
  r_array_count_5 = _RAND_27[31:0];
  _RAND_28 = {1{`RANDOM}};
  r_array_count_6 = _RAND_28[31:0];
  _RAND_29 = {1{`RANDOM}};
  r_array_count_7 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  r_array_count_8 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  r_array_count_9 = _RAND_31[31:0];
  _RAND_32 = {1{`RANDOM}};
  r_array_count_10 = _RAND_32[31:0];
  _RAND_33 = {1{`RANDOM}};
  r_array_count_11 = _RAND_33[31:0];
  _RAND_34 = {1{`RANDOM}};
  r_array_count_12 = _RAND_34[31:0];
  _RAND_35 = {1{`RANDOM}};
  r_array_count_13 = _RAND_35[31:0];
  _RAND_36 = {1{`RANDOM}};
  r_array_count_14 = _RAND_36[31:0];
  _RAND_37 = {1{`RANDOM}};
  r_array_count_15 = _RAND_37[31:0];
  _RAND_38 = {1{`RANDOM}};
  r_array_count_16 = _RAND_38[31:0];
  _RAND_39 = {1{`RANDOM}};
  r_array_count_17 = _RAND_39[31:0];
  _RAND_40 = {1{`RANDOM}};
  r_array_count_18 = _RAND_40[31:0];
  _RAND_41 = {1{`RANDOM}};
  r_array_count_19 = _RAND_41[31:0];
  _RAND_42 = {1{`RANDOM}};
  r_array_count_20 = _RAND_42[31:0];
  _RAND_43 = {1{`RANDOM}};
  r_array_count_21 = _RAND_43[31:0];
  _RAND_44 = {1{`RANDOM}};
  r_array_count_22 = _RAND_44[31:0];
  _RAND_45 = {1{`RANDOM}};
  r_array_count_23 = _RAND_45[31:0];
  _RAND_46 = {1{`RANDOM}};
  r_array_count_24 = _RAND_46[31:0];
  _RAND_47 = {1{`RANDOM}};
  r_array_count_25 = _RAND_47[31:0];
  _RAND_48 = {1{`RANDOM}};
  r_array_count_26 = _RAND_48[31:0];
  _RAND_49 = {1{`RANDOM}};
  r_array_count_27 = _RAND_49[31:0];
  _RAND_50 = {1{`RANDOM}};
  r_array_count_28 = _RAND_50[31:0];
  _RAND_51 = {1{`RANDOM}};
  r_array_count_29 = _RAND_51[31:0];
  _RAND_52 = {1{`RANDOM}};
  r_array_count_30 = _RAND_52[31:0];
  _RAND_53 = {1{`RANDOM}};
  r_array_count_31 = _RAND_53[31:0];
  _RAND_54 = {1{`RANDOM}};
  r_array_count_32 = _RAND_54[31:0];
  _RAND_55 = {1{`RANDOM}};
  r_array_count_33 = _RAND_55[31:0];
  _RAND_56 = {1{`RANDOM}};
  r_array_count_34 = _RAND_56[31:0];
  _RAND_57 = {1{`RANDOM}};
  r_array_count_35 = _RAND_57[31:0];
  _RAND_58 = {1{`RANDOM}};
  r_array_count_36 = _RAND_58[31:0];
  _RAND_59 = {1{`RANDOM}};
  r_array_count_37 = _RAND_59[31:0];
  _RAND_60 = {1{`RANDOM}};
  r_array_count_38 = _RAND_60[31:0];
  _RAND_61 = {1{`RANDOM}};
  r_array_count_39 = _RAND_61[31:0];
  _RAND_62 = {1{`RANDOM}};
  r_array_count_40 = _RAND_62[31:0];
  _RAND_63 = {1{`RANDOM}};
  r_array_count_41 = _RAND_63[31:0];
  _RAND_64 = {1{`RANDOM}};
  r_array_count_42 = _RAND_64[31:0];
  _RAND_65 = {1{`RANDOM}};
  r_array_count_43 = _RAND_65[31:0];
  _RAND_66 = {1{`RANDOM}};
  r_array_count_44 = _RAND_66[31:0];
  _RAND_67 = {1{`RANDOM}};
  r_array_count_45 = _RAND_67[31:0];
  _RAND_68 = {1{`RANDOM}};
  r_array_count_46 = _RAND_68[31:0];
  _RAND_69 = {1{`RANDOM}};
  r_array_count_47 = _RAND_69[31:0];
  _RAND_70 = {1{`RANDOM}};
  r_array_count_48 = _RAND_70[31:0];
  _RAND_71 = {1{`RANDOM}};
  r_array_count_49 = _RAND_71[31:0];
  _RAND_72 = {1{`RANDOM}};
  r_array_count_50 = _RAND_72[31:0];
  _RAND_73 = {1{`RANDOM}};
  r_array_count_51 = _RAND_73[31:0];
  _RAND_74 = {1{`RANDOM}};
  r_array_count_52 = _RAND_74[31:0];
  _RAND_75 = {1{`RANDOM}};
  r_array_count_53 = _RAND_75[31:0];
  _RAND_76 = {1{`RANDOM}};
  r_array_count_54 = _RAND_76[31:0];
  _RAND_77 = {1{`RANDOM}};
  r_array_count_55 = _RAND_77[31:0];
  _RAND_78 = {1{`RANDOM}};
  _T_131 = _RAND_78[0:0];
  _RAND_79 = {2{`RANDOM}};
  _T_132 = _RAND_79[63:0];
  _RAND_80 = {1{`RANDOM}};
  _T_133 = _RAND_80[19:0];
  _RAND_81 = {2{`RANDOM}};
  _T_137 = _RAND_81[63:0];
  _RAND_82 = {1{`RANDOM}};
  _T_138 = _RAND_82[19:0];
  _RAND_83 = {2{`RANDOM}};
  _T_142 = _RAND_83[63:0];
  _RAND_84 = {1{`RANDOM}};
  _T_143 = _RAND_84[19:0];
  _RAND_85 = {2{`RANDOM}};
  _T_147 = _RAND_85[63:0];
  _RAND_86 = {1{`RANDOM}};
  _T_148 = _RAND_86[19:0];
  _RAND_87 = {1{`RANDOM}};
  _T_152 = _RAND_87[0:0];
  _RAND_88 = {2{`RANDOM}};
  _T_153 = _RAND_88[63:0];
  _RAND_89 = {1{`RANDOM}};
  _T_154 = _RAND_89[19:0];
  _RAND_90 = {2{`RANDOM}};
  _T_158 = _RAND_90[63:0];
  _RAND_91 = {1{`RANDOM}};
  _T_159 = _RAND_91[19:0];
  _RAND_92 = {2{`RANDOM}};
  _T_163 = _RAND_92[63:0];
  _RAND_93 = {1{`RANDOM}};
  _T_164 = _RAND_93[19:0];
  _RAND_94 = {2{`RANDOM}};
  _T_168 = _RAND_94[63:0];
  _RAND_95 = {1{`RANDOM}};
  _T_169 = _RAND_95[19:0];
  _RAND_96 = {1{`RANDOM}};
  _T_173 = _RAND_96[0:0];
  _RAND_97 = {2{`RANDOM}};
  _T_174 = _RAND_97[63:0];
  _RAND_98 = {1{`RANDOM}};
  _T_175 = _RAND_98[19:0];
  _RAND_99 = {2{`RANDOM}};
  _T_179 = _RAND_99[63:0];
  _RAND_100 = {1{`RANDOM}};
  _T_180 = _RAND_100[19:0];
  _RAND_101 = {2{`RANDOM}};
  _T_184 = _RAND_101[63:0];
  _RAND_102 = {1{`RANDOM}};
  _T_185 = _RAND_102[19:0];
  _RAND_103 = {2{`RANDOM}};
  _T_189 = _RAND_103[63:0];
  _RAND_104 = {1{`RANDOM}};
  _T_190 = _RAND_104[19:0];
  _RAND_105 = {1{`RANDOM}};
  _T_194 = _RAND_105[0:0];
  _RAND_106 = {2{`RANDOM}};
  _T_195 = _RAND_106[63:0];
  _RAND_107 = {1{`RANDOM}};
  _T_196 = _RAND_107[19:0];
  _RAND_108 = {2{`RANDOM}};
  _T_200 = _RAND_108[63:0];
  _RAND_109 = {1{`RANDOM}};
  _T_201 = _RAND_109[19:0];
  _RAND_110 = {2{`RANDOM}};
  _T_205 = _RAND_110[63:0];
  _RAND_111 = {1{`RANDOM}};
  _T_206 = _RAND_111[19:0];
  _RAND_112 = {2{`RANDOM}};
  _T_210 = _RAND_112[63:0];
  _RAND_113 = {1{`RANDOM}};
  _T_211 = _RAND_113[19:0];
  _RAND_114 = {1{`RANDOM}};
  _T_215 = _RAND_114[0:0];
  _RAND_115 = {2{`RANDOM}};
  _T_216 = _RAND_115[63:0];
  _RAND_116 = {1{`RANDOM}};
  _T_217 = _RAND_116[19:0];
  _RAND_117 = {2{`RANDOM}};
  _T_221 = _RAND_117[63:0];
  _RAND_118 = {1{`RANDOM}};
  _T_222 = _RAND_118[19:0];
  _RAND_119 = {2{`RANDOM}};
  _T_226 = _RAND_119[63:0];
  _RAND_120 = {1{`RANDOM}};
  _T_227 = _RAND_120[19:0];
  _RAND_121 = {2{`RANDOM}};
  _T_231 = _RAND_121[63:0];
  _RAND_122 = {1{`RANDOM}};
  _T_232 = _RAND_122[19:0];
  _RAND_123 = {1{`RANDOM}};
  _T_236 = _RAND_123[0:0];
  _RAND_124 = {2{`RANDOM}};
  _T_237 = _RAND_124[63:0];
  _RAND_125 = {1{`RANDOM}};
  _T_238 = _RAND_125[19:0];
  _RAND_126 = {2{`RANDOM}};
  _T_242 = _RAND_126[63:0];
  _RAND_127 = {1{`RANDOM}};
  _T_243 = _RAND_127[19:0];
  _RAND_128 = {2{`RANDOM}};
  _T_247 = _RAND_128[63:0];
  _RAND_129 = {1{`RANDOM}};
  _T_248 = _RAND_129[19:0];
  _RAND_130 = {2{`RANDOM}};
  _T_252 = _RAND_130[63:0];
  _RAND_131 = {1{`RANDOM}};
  _T_253 = _RAND_131[19:0];
  _RAND_132 = {1{`RANDOM}};
  _T_257 = _RAND_132[0:0];
  _RAND_133 = {2{`RANDOM}};
  _T_258 = _RAND_133[63:0];
  _RAND_134 = {1{`RANDOM}};
  _T_259 = _RAND_134[19:0];
  _RAND_135 = {2{`RANDOM}};
  _T_263 = _RAND_135[63:0];
  _RAND_136 = {1{`RANDOM}};
  _T_264 = _RAND_136[19:0];
  _RAND_137 = {2{`RANDOM}};
  _T_268 = _RAND_137[63:0];
  _RAND_138 = {1{`RANDOM}};
  _T_269 = _RAND_138[19:0];
  _RAND_139 = {2{`RANDOM}};
  _T_273 = _RAND_139[63:0];
  _RAND_140 = {1{`RANDOM}};
  _T_274 = _RAND_140[19:0];
  _RAND_141 = {1{`RANDOM}};
  _T_278 = _RAND_141[0:0];
  _RAND_142 = {2{`RANDOM}};
  _T_279 = _RAND_142[63:0];
  _RAND_143 = {1{`RANDOM}};
  _T_280 = _RAND_143[19:0];
  _RAND_144 = {2{`RANDOM}};
  _T_284 = _RAND_144[63:0];
  _RAND_145 = {1{`RANDOM}};
  _T_285 = _RAND_145[19:0];
  _RAND_146 = {2{`RANDOM}};
  _T_289 = _RAND_146[63:0];
  _RAND_147 = {1{`RANDOM}};
  _T_290 = _RAND_147[19:0];
  _RAND_148 = {2{`RANDOM}};
  _T_294 = _RAND_148[63:0];
  _RAND_149 = {1{`RANDOM}};
  _T_295 = _RAND_149[19:0];
  _RAND_150 = {1{`RANDOM}};
  _T_299 = _RAND_150[0:0];
  _RAND_151 = {2{`RANDOM}};
  _T_300 = _RAND_151[63:0];
  _RAND_152 = {1{`RANDOM}};
  _T_301 = _RAND_152[19:0];
  _RAND_153 = {2{`RANDOM}};
  _T_305 = _RAND_153[63:0];
  _RAND_154 = {1{`RANDOM}};
  _T_306 = _RAND_154[19:0];
  _RAND_155 = {2{`RANDOM}};
  _T_310 = _RAND_155[63:0];
  _RAND_156 = {1{`RANDOM}};
  _T_311 = _RAND_156[19:0];
  _RAND_157 = {2{`RANDOM}};
  _T_315 = _RAND_157[63:0];
  _RAND_158 = {1{`RANDOM}};
  _T_316 = _RAND_158[19:0];
  _RAND_159 = {1{`RANDOM}};
  _T_320 = _RAND_159[0:0];
  _RAND_160 = {2{`RANDOM}};
  _T_321 = _RAND_160[63:0];
  _RAND_161 = {1{`RANDOM}};
  _T_322 = _RAND_161[19:0];
  _RAND_162 = {2{`RANDOM}};
  _T_326 = _RAND_162[63:0];
  _RAND_163 = {1{`RANDOM}};
  _T_327 = _RAND_163[19:0];
  _RAND_164 = {2{`RANDOM}};
  _T_331 = _RAND_164[63:0];
  _RAND_165 = {1{`RANDOM}};
  _T_332 = _RAND_165[19:0];
  _RAND_166 = {2{`RANDOM}};
  _T_336 = _RAND_166[63:0];
  _RAND_167 = {1{`RANDOM}};
  _T_337 = _RAND_167[19:0];
  _RAND_168 = {1{`RANDOM}};
  _T_341 = _RAND_168[0:0];
  _RAND_169 = {2{`RANDOM}};
  _T_342 = _RAND_169[63:0];
  _RAND_170 = {1{`RANDOM}};
  _T_343 = _RAND_170[19:0];
  _RAND_171 = {2{`RANDOM}};
  _T_347 = _RAND_171[63:0];
  _RAND_172 = {1{`RANDOM}};
  _T_348 = _RAND_172[19:0];
  _RAND_173 = {2{`RANDOM}};
  _T_352 = _RAND_173[63:0];
  _RAND_174 = {1{`RANDOM}};
  _T_353 = _RAND_174[19:0];
  _RAND_175 = {2{`RANDOM}};
  _T_357 = _RAND_175[63:0];
  _RAND_176 = {1{`RANDOM}};
  _T_358 = _RAND_176[19:0];
  _RAND_177 = {1{`RANDOM}};
  _T_362 = _RAND_177[0:0];
  _RAND_178 = {2{`RANDOM}};
  _T_363 = _RAND_178[63:0];
  _RAND_179 = {1{`RANDOM}};
  _T_364 = _RAND_179[19:0];
  _RAND_180 = {2{`RANDOM}};
  _T_368 = _RAND_180[63:0];
  _RAND_181 = {1{`RANDOM}};
  _T_369 = _RAND_181[19:0];
  _RAND_182 = {2{`RANDOM}};
  _T_373 = _RAND_182[63:0];
  _RAND_183 = {1{`RANDOM}};
  _T_374 = _RAND_183[19:0];
  _RAND_184 = {2{`RANDOM}};
  _T_378 = _RAND_184[63:0];
  _RAND_185 = {1{`RANDOM}};
  _T_379 = _RAND_185[19:0];
  _RAND_186 = {1{`RANDOM}};
  _T_383 = _RAND_186[0:0];
  _RAND_187 = {2{`RANDOM}};
  _T_384 = _RAND_187[63:0];
  _RAND_188 = {1{`RANDOM}};
  _T_385 = _RAND_188[19:0];
  _RAND_189 = {2{`RANDOM}};
  _T_389 = _RAND_189[63:0];
  _RAND_190 = {1{`RANDOM}};
  _T_390 = _RAND_190[19:0];
  _RAND_191 = {2{`RANDOM}};
  _T_394 = _RAND_191[63:0];
  _RAND_192 = {1{`RANDOM}};
  _T_395 = _RAND_192[19:0];
  _RAND_193 = {2{`RANDOM}};
  _T_399 = _RAND_193[63:0];
  _RAND_194 = {1{`RANDOM}};
  _T_400 = _RAND_194[19:0];
  _RAND_195 = {1{`RANDOM}};
  _T_404 = _RAND_195[0:0];
  _RAND_196 = {2{`RANDOM}};
  _T_405 = _RAND_196[63:0];
  _RAND_197 = {1{`RANDOM}};
  _T_406 = _RAND_197[19:0];
  _RAND_198 = {2{`RANDOM}};
  _T_410 = _RAND_198[63:0];
  _RAND_199 = {1{`RANDOM}};
  _T_411 = _RAND_199[19:0];
  _RAND_200 = {2{`RANDOM}};
  _T_415 = _RAND_200[63:0];
  _RAND_201 = {1{`RANDOM}};
  _T_416 = _RAND_201[19:0];
  _RAND_202 = {2{`RANDOM}};
  _T_420 = _RAND_202[63:0];
  _RAND_203 = {1{`RANDOM}};
  _T_421 = _RAND_203[19:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    reset_reg <= reset;
    reset_reg_array_0 <= reset;
    reset_reg_array_1 <= reset;
    reset_reg_array_2 <= reset;
    reset_reg_array_3 <= reset;
    reset_reg_array_4 <= reset;
    reset_reg_array_5 <= reset;
    reset_reg_array_6 <= reset;
    reset_reg_array_7 <= reset;
    reset_reg_array_8 <= reset;
    reset_reg_array_9 <= reset;
    reset_reg_array_10 <= reset;
    reset_reg_array_11 <= reset;
    reset_reg_array_12 <= reset;
    reset_reg_array_13 <= reset;
    _T_14 <= io_node_num;
    _T_15 <= io_root;
    _T_16 <= io_offsets_CSR_R_offset;
    _T_17 <= io_offsets_CSR_C_offset;
    _T_18 <= io_offsets_CSC_R_offset;
    _T_19 <= io_offsets_CSC_C_offset;
    _T_20 <= io_offsets_level_offset;
    if (reset) begin
      r_array_count_0 <= 32'h0;
    end else if (_T_134) begin
      r_array_count_0 <= _T_136;
    end
    if (reset) begin
      r_array_count_1 <= 32'h0;
    end else if (_T_139) begin
      r_array_count_1 <= _T_141;
    end
    if (reset) begin
      r_array_count_2 <= 32'h0;
    end else if (_T_144) begin
      r_array_count_2 <= _T_146;
    end
    if (reset) begin
      r_array_count_3 <= 32'h0;
    end else if (_T_149) begin
      r_array_count_3 <= _T_151;
    end
    if (reset) begin
      r_array_count_4 <= 32'h0;
    end else if (_T_155) begin
      r_array_count_4 <= _T_157;
    end
    if (reset) begin
      r_array_count_5 <= 32'h0;
    end else if (_T_160) begin
      r_array_count_5 <= _T_162;
    end
    if (reset) begin
      r_array_count_6 <= 32'h0;
    end else if (_T_165) begin
      r_array_count_6 <= _T_167;
    end
    if (reset) begin
      r_array_count_7 <= 32'h0;
    end else if (_T_170) begin
      r_array_count_7 <= _T_172;
    end
    if (reset) begin
      r_array_count_8 <= 32'h0;
    end else if (_T_176) begin
      r_array_count_8 <= _T_178;
    end
    if (reset) begin
      r_array_count_9 <= 32'h0;
    end else if (_T_181) begin
      r_array_count_9 <= _T_183;
    end
    if (reset) begin
      r_array_count_10 <= 32'h0;
    end else if (_T_186) begin
      r_array_count_10 <= _T_188;
    end
    if (reset) begin
      r_array_count_11 <= 32'h0;
    end else if (_T_191) begin
      r_array_count_11 <= _T_193;
    end
    if (reset) begin
      r_array_count_12 <= 32'h0;
    end else if (_T_197) begin
      r_array_count_12 <= _T_199;
    end
    if (reset) begin
      r_array_count_13 <= 32'h0;
    end else if (_T_202) begin
      r_array_count_13 <= _T_204;
    end
    if (reset) begin
      r_array_count_14 <= 32'h0;
    end else if (_T_207) begin
      r_array_count_14 <= _T_209;
    end
    if (reset) begin
      r_array_count_15 <= 32'h0;
    end else if (_T_212) begin
      r_array_count_15 <= _T_214;
    end
    if (reset) begin
      r_array_count_16 <= 32'h0;
    end else if (_T_218) begin
      r_array_count_16 <= _T_220;
    end
    if (reset) begin
      r_array_count_17 <= 32'h0;
    end else if (_T_223) begin
      r_array_count_17 <= _T_225;
    end
    if (reset) begin
      r_array_count_18 <= 32'h0;
    end else if (_T_228) begin
      r_array_count_18 <= _T_230;
    end
    if (reset) begin
      r_array_count_19 <= 32'h0;
    end else if (_T_233) begin
      r_array_count_19 <= _T_235;
    end
    if (reset) begin
      r_array_count_20 <= 32'h0;
    end else if (_T_239) begin
      r_array_count_20 <= _T_241;
    end
    if (reset) begin
      r_array_count_21 <= 32'h0;
    end else if (_T_244) begin
      r_array_count_21 <= _T_246;
    end
    if (reset) begin
      r_array_count_22 <= 32'h0;
    end else if (_T_249) begin
      r_array_count_22 <= _T_251;
    end
    if (reset) begin
      r_array_count_23 <= 32'h0;
    end else if (_T_254) begin
      r_array_count_23 <= _T_256;
    end
    if (reset) begin
      r_array_count_24 <= 32'h0;
    end else if (_T_260) begin
      r_array_count_24 <= _T_262;
    end
    if (reset) begin
      r_array_count_25 <= 32'h0;
    end else if (_T_265) begin
      r_array_count_25 <= _T_267;
    end
    if (reset) begin
      r_array_count_26 <= 32'h0;
    end else if (_T_270) begin
      r_array_count_26 <= _T_272;
    end
    if (reset) begin
      r_array_count_27 <= 32'h0;
    end else if (_T_275) begin
      r_array_count_27 <= _T_277;
    end
    if (reset) begin
      r_array_count_28 <= 32'h0;
    end else if (_T_281) begin
      r_array_count_28 <= _T_283;
    end
    if (reset) begin
      r_array_count_29 <= 32'h0;
    end else if (_T_286) begin
      r_array_count_29 <= _T_288;
    end
    if (reset) begin
      r_array_count_30 <= 32'h0;
    end else if (_T_291) begin
      r_array_count_30 <= _T_293;
    end
    if (reset) begin
      r_array_count_31 <= 32'h0;
    end else if (_T_296) begin
      r_array_count_31 <= _T_298;
    end
    if (reset) begin
      r_array_count_32 <= 32'h0;
    end else if (_T_302) begin
      r_array_count_32 <= _T_304;
    end
    if (reset) begin
      r_array_count_33 <= 32'h0;
    end else if (_T_307) begin
      r_array_count_33 <= _T_309;
    end
    if (reset) begin
      r_array_count_34 <= 32'h0;
    end else if (_T_312) begin
      r_array_count_34 <= _T_314;
    end
    if (reset) begin
      r_array_count_35 <= 32'h0;
    end else if (_T_317) begin
      r_array_count_35 <= _T_319;
    end
    if (reset) begin
      r_array_count_36 <= 32'h0;
    end else if (_T_323) begin
      r_array_count_36 <= _T_325;
    end
    if (reset) begin
      r_array_count_37 <= 32'h0;
    end else if (_T_328) begin
      r_array_count_37 <= _T_330;
    end
    if (reset) begin
      r_array_count_38 <= 32'h0;
    end else if (_T_333) begin
      r_array_count_38 <= _T_335;
    end
    if (reset) begin
      r_array_count_39 <= 32'h0;
    end else if (_T_338) begin
      r_array_count_39 <= _T_340;
    end
    if (reset) begin
      r_array_count_40 <= 32'h0;
    end else if (_T_344) begin
      r_array_count_40 <= _T_346;
    end
    if (reset) begin
      r_array_count_41 <= 32'h0;
    end else if (_T_349) begin
      r_array_count_41 <= _T_351;
    end
    if (reset) begin
      r_array_count_42 <= 32'h0;
    end else if (_T_354) begin
      r_array_count_42 <= _T_356;
    end
    if (reset) begin
      r_array_count_43 <= 32'h0;
    end else if (_T_359) begin
      r_array_count_43 <= _T_361;
    end
    if (reset) begin
      r_array_count_44 <= 32'h0;
    end else if (_T_365) begin
      r_array_count_44 <= _T_367;
    end
    if (reset) begin
      r_array_count_45 <= 32'h0;
    end else if (_T_370) begin
      r_array_count_45 <= _T_372;
    end
    if (reset) begin
      r_array_count_46 <= 32'h0;
    end else if (_T_375) begin
      r_array_count_46 <= _T_377;
    end
    if (reset) begin
      r_array_count_47 <= 32'h0;
    end else if (_T_380) begin
      r_array_count_47 <= _T_382;
    end
    if (reset) begin
      r_array_count_48 <= 32'h0;
    end else if (_T_386) begin
      r_array_count_48 <= _T_388;
    end
    if (reset) begin
      r_array_count_49 <= 32'h0;
    end else if (_T_391) begin
      r_array_count_49 <= _T_393;
    end
    if (reset) begin
      r_array_count_50 <= 32'h0;
    end else if (_T_396) begin
      r_array_count_50 <= _T_398;
    end
    if (reset) begin
      r_array_count_51 <= 32'h0;
    end else if (_T_401) begin
      r_array_count_51 <= _T_403;
    end
    if (reset) begin
      r_array_count_52 <= 32'h0;
    end else if (_T_407) begin
      r_array_count_52 <= _T_409;
    end
    if (reset) begin
      r_array_count_53 <= 32'h0;
    end else if (_T_412) begin
      r_array_count_53 <= _T_414;
    end
    if (reset) begin
      r_array_count_54 <= 32'h0;
    end else if (_T_417) begin
      r_array_count_54 <= _T_419;
    end
    if (reset) begin
      r_array_count_55 <= 32'h0;
    end else if (_T_422) begin
      r_array_count_55 <= _T_424;
    end
    _T_131 <= io_start_init;
    _T_132 <= pipeline_io_uram_out_a_0;
    _T_133 <= io_uram_addr_a_0;
    _T_137 <= pipeline_io_uram_out_a_1;
    _T_138 <= io_uram_addr_a_1;
    _T_142 <= pipeline_io_uram_out_a_2;
    _T_143 <= io_uram_addr_a_2;
    _T_147 <= pipeline_io_uram_out_a_3;
    _T_148 <= io_uram_addr_a_3;
    _T_152 <= io_start_init;
    _T_153 <= pipeline_1_io_uram_out_a_0;
    _T_154 <= io_uram_addr_a_4;
    _T_158 <= pipeline_1_io_uram_out_a_1;
    _T_159 <= io_uram_addr_a_5;
    _T_163 <= pipeline_1_io_uram_out_a_2;
    _T_164 <= io_uram_addr_a_6;
    _T_168 <= pipeline_1_io_uram_out_a_3;
    _T_169 <= io_uram_addr_a_7;
    _T_173 <= io_start_init;
    _T_174 <= pipeline_2_io_uram_out_a_0;
    _T_175 <= io_uram_addr_a_8;
    _T_179 <= pipeline_2_io_uram_out_a_1;
    _T_180 <= io_uram_addr_a_9;
    _T_184 <= pipeline_2_io_uram_out_a_2;
    _T_185 <= io_uram_addr_a_10;
    _T_189 <= pipeline_2_io_uram_out_a_3;
    _T_190 <= io_uram_addr_a_11;
    _T_194 <= io_start_init;
    _T_195 <= pipeline_3_io_uram_out_a_0;
    _T_196 <= io_uram_addr_a_12;
    _T_200 <= pipeline_3_io_uram_out_a_1;
    _T_201 <= io_uram_addr_a_13;
    _T_205 <= pipeline_3_io_uram_out_a_2;
    _T_206 <= io_uram_addr_a_14;
    _T_210 <= pipeline_3_io_uram_out_a_3;
    _T_211 <= io_uram_addr_a_15;
    _T_215 <= io_start_init;
    _T_216 <= pipeline_4_io_uram_out_a_0;
    _T_217 <= io_uram_addr_a_16;
    _T_221 <= pipeline_4_io_uram_out_a_1;
    _T_222 <= io_uram_addr_a_17;
    _T_226 <= pipeline_4_io_uram_out_a_2;
    _T_227 <= io_uram_addr_a_18;
    _T_231 <= pipeline_4_io_uram_out_a_3;
    _T_232 <= io_uram_addr_a_19;
    _T_236 <= io_start_init;
    _T_237 <= pipeline_5_io_uram_out_a_0;
    _T_238 <= io_uram_addr_a_20;
    _T_242 <= pipeline_5_io_uram_out_a_1;
    _T_243 <= io_uram_addr_a_21;
    _T_247 <= pipeline_5_io_uram_out_a_2;
    _T_248 <= io_uram_addr_a_22;
    _T_252 <= pipeline_5_io_uram_out_a_3;
    _T_253 <= io_uram_addr_a_23;
    _T_257 <= io_start_init;
    _T_258 <= pipeline_6_io_uram_out_a_0;
    _T_259 <= io_uram_addr_a_24;
    _T_263 <= pipeline_6_io_uram_out_a_1;
    _T_264 <= io_uram_addr_a_25;
    _T_268 <= pipeline_6_io_uram_out_a_2;
    _T_269 <= io_uram_addr_a_26;
    _T_273 <= pipeline_6_io_uram_out_a_3;
    _T_274 <= io_uram_addr_a_27;
    _T_278 <= io_start_init;
    _T_279 <= pipeline_7_io_uram_out_a_0;
    _T_280 <= io_uram_addr_a_28;
    _T_284 <= pipeline_7_io_uram_out_a_1;
    _T_285 <= io_uram_addr_a_29;
    _T_289 <= pipeline_7_io_uram_out_a_2;
    _T_290 <= io_uram_addr_a_30;
    _T_294 <= pipeline_7_io_uram_out_a_3;
    _T_295 <= io_uram_addr_a_31;
    _T_299 <= io_start_init;
    _T_300 <= pipeline_8_io_uram_out_a_0;
    _T_301 <= io_uram_addr_a_32;
    _T_305 <= pipeline_8_io_uram_out_a_1;
    _T_306 <= io_uram_addr_a_33;
    _T_310 <= pipeline_8_io_uram_out_a_2;
    _T_311 <= io_uram_addr_a_34;
    _T_315 <= pipeline_8_io_uram_out_a_3;
    _T_316 <= io_uram_addr_a_35;
    _T_320 <= io_start_init;
    _T_321 <= pipeline_9_io_uram_out_a_0;
    _T_322 <= io_uram_addr_a_36;
    _T_326 <= pipeline_9_io_uram_out_a_1;
    _T_327 <= io_uram_addr_a_37;
    _T_331 <= pipeline_9_io_uram_out_a_2;
    _T_332 <= io_uram_addr_a_38;
    _T_336 <= pipeline_9_io_uram_out_a_3;
    _T_337 <= io_uram_addr_a_39;
    _T_341 <= io_start_init;
    _T_342 <= pipeline_10_io_uram_out_a_0;
    _T_343 <= io_uram_addr_a_40;
    _T_347 <= pipeline_10_io_uram_out_a_1;
    _T_348 <= io_uram_addr_a_41;
    _T_352 <= pipeline_10_io_uram_out_a_2;
    _T_353 <= io_uram_addr_a_42;
    _T_357 <= pipeline_10_io_uram_out_a_3;
    _T_358 <= io_uram_addr_a_43;
    _T_362 <= io_start_init;
    _T_363 <= pipeline_11_io_uram_out_a_0;
    _T_364 <= io_uram_addr_a_44;
    _T_368 <= pipeline_11_io_uram_out_a_1;
    _T_369 <= io_uram_addr_a_45;
    _T_373 <= pipeline_11_io_uram_out_a_2;
    _T_374 <= io_uram_addr_a_46;
    _T_378 <= pipeline_11_io_uram_out_a_3;
    _T_379 <= io_uram_addr_a_47;
    _T_383 <= io_start_init;
    _T_384 <= pipeline_12_io_uram_out_a_0;
    _T_385 <= io_uram_addr_a_48;
    _T_389 <= pipeline_12_io_uram_out_a_1;
    _T_390 <= io_uram_addr_a_49;
    _T_394 <= pipeline_12_io_uram_out_a_2;
    _T_395 <= io_uram_addr_a_50;
    _T_399 <= pipeline_12_io_uram_out_a_3;
    _T_400 <= io_uram_addr_a_51;
    _T_404 <= io_start_init;
    _T_405 <= pipeline_13_io_uram_out_a_0;
    _T_406 <= io_uram_addr_a_52;
    _T_410 <= pipeline_13_io_uram_out_a_1;
    _T_411 <= io_uram_addr_a_53;
    _T_415 <= pipeline_13_io_uram_out_a_2;
    _T_416 <= io_uram_addr_a_54;
    _T_420 <= pipeline_13_io_uram_out_a_3;
    _T_421 <= io_uram_addr_a_55;
  end
endmodule
module read_R_array_index_56(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'he; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'he; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_56(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_56 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_56(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'he; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_57(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_57(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_57 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_57(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_58(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_58(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_58 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_58(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_59(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_59(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_59 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_59(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_14(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'he; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'he; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'he; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'he; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'he; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'he; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'he; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'he; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'he; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'he; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'he; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'he; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'he; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'he; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'he; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'he; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_56 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_56 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_57 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_57 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_58 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_58 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_59 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_59 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_60(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'hf; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'hf; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_60(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_60 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_60(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'hf; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_61(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h2f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h2f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_61(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_61 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_61(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h2f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_62(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h4f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h4f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_62(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_62 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_62(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h4f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_63(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h6f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h6f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_63(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_63 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_63(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h6f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_15(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'hf; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'hf; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'hf; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'hf; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'hf; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'hf; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'hf; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'hf; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'hf; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'hf; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'hf; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'hf; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'hf; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'hf; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'hf; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'hf; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_60 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_60 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_61 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_61 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_62 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_62 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_63 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_63 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_64(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h10; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h10; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_64(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_64 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_64(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h10; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_65(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h30; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h30; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_65(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_65 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_65(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h30; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_66(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h50; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h50; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_66(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_66 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_66(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h50; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_67(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h70; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h70; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_67(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_67 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_67(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h70; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_16(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h10; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h10; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h10; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h10; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h10; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h10; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h10; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h10; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h10; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h10; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h10; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h10; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h10; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h10; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h10; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h10; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_64 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_64 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_65 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_65 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_66 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_66 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_67 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_67 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_68(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h11; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h11; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_68(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_68 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_68(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h11; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_69(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h31; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h31; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_69(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_69 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_69(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h31; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_70(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h51; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h51; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_70(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_70 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_70(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h51; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_71(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h71; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h71; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_71(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_71 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_71(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h71; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_17(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h11; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h11; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h11; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h11; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h11; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h11; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h11; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h11; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h11; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h11; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h11; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h11; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h11; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h11; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h11; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h11; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_68 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_68 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_69 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_69 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_70 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_70 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_71 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_71 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_72(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h12; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h12; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_72(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_72 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_72(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h12; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_73(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h32; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h32; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_73(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_73 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_73(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h32; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_74(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h52; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h52; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_74(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_74 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_74(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h52; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_75(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h72; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h72; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_75(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_75 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_75(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h72; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_18(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h12; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h12; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h12; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h12; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h12; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h12; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h12; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h12; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h12; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h12; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h12; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h12; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h12; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h12; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h12; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h12; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_72 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_72 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_73 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_73 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_74 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_74 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_75 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_75 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_76(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h13; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h13; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_76(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_76 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_76(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h13; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_77(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h33; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h33; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_77(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_77 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_77(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h33; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_78(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h53; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h53; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_78(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_78 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_78(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h53; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_79(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h73; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h73; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_79(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_79 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_79(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h73; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_19(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h13; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h13; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h13; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h13; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h13; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h13; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h13; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h13; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h13; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h13; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h13; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h13; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h13; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h13; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h13; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h13; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_76 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_76 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_77 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_77 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_78 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_78 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_79 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_79 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_80(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h14; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h14; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_80(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_80 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_80(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h14; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_81(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h34; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h34; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_81(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_81 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_81(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h34; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_82(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h54; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h54; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_82(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_82 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_82(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h54; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_83(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h74; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h74; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_83(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_83 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_83(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h74; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_20(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h14; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h14; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h14; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h14; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h14; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h14; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h14; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h14; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h14; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h14; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h14; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h14; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h14; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h14; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h14; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h14; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_80 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_80 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_81 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_81 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_82 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_82 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_83 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_83 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_84(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h15; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h15; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_84(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_84 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_84(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h15; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_85(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h35; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h35; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_85(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_85 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_85(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h35; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_86(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h55; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h55; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_86(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_86 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_86(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h55; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_87(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h75; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h75; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_87(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_87 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_87(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h75; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_21(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h15; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h15; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h15; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h15; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h15; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h15; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h15; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h15; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h15; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h15; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h15; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h15; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h15; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h15; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h15; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h15; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_84 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_84 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_85 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_85 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_86 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_86 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_87 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_87 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_88(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h16; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h16; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_88(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_88 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_88(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h16; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_89(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h36; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h36; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_89(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_89 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_89(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h36; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_90(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h56; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h56; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_90(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_90 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_90(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h56; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_91(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h76; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h76; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_91(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_91 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_91(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h76; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_22(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h16; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h16; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h16; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h16; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h16; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h16; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h16; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h16; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h16; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h16; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h16; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h16; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h16; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h16; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h16; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h16; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_88 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_88 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_89 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_89 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_90 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_90 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_91 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_91 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_92(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h17; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h17; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_92(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_92 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_92(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h17; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_93(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h37; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h37; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_93(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_93 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_93(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h37; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_94(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h57; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h57; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_94(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_94 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_94(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h57; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_95(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h77; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h77; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_95(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_95 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_95(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h77; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_23(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h17; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h17; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h17; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h17; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h17; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h17; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h17; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h17; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h17; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h17; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h17; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h17; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h17; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h17; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h17; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h17; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_92 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_92 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_93 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_93 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_94 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_94 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_95 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_95 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_96(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h18; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h18; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_96(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_96 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_96(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h18; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_97(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h38; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h38; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_97(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_97 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_97(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h38; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_98(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h58; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h58; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_98(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_98 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_98(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h58; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_99(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h78; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h78; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_99(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_99 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_99(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h78; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_24(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h18; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h18; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h18; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h18; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h18; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h18; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h18; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h18; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h18; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h18; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h18; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h18; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h18; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h18; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h18; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h18; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_96 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_96 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_97 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_97 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_98 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_98 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_99 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_99 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_100(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h19; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h19; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_100(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_100 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_100(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h19; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_101(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h39; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h39; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_101(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_101 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_101(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h39; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_102(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h59; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h59; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_102(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_102 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_102(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h59; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_103(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h79; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h79; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_103(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_103 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_103(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h79; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_25(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h19; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h19; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h19; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h19; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h19; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h19; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h19; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h19; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h19; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h19; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h19; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h19; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h19; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h19; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h19; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h19; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_100 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_100 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_101 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_101 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_102 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_102 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_103 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_103 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_104(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_104(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_104 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_104(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_105(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_105(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_105 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_105(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_106(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_106(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_106 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_106(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_107(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7a; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7a; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_107(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_107 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_107(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7a; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_26(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1a; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1a; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1a; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1a; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1a; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1a; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1a; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1a; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1a; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1a; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1a; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1a; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1a; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1a; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1a; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1a; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_104 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_104 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_105 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_105 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_106 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_106 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_107 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_107 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_108(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_108(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_108 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_108(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_109(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_109(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_109 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_109(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_110(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_110(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_110 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_110(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_111(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7b; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7b; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_111(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_111 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_111(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7b; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_27(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1b; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1b; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1b; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1b; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1b; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1b; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1b; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1b; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1b; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1b; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1b; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1b; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1b; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1b; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1b; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1b; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_108 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_108 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_109 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_109 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_110 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_110 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_111 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_111 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_112(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_112(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_112 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_112(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_113(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_113(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_113 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_113(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_114(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_114(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_114 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_114(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_115(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7c; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7c; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_115(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_115 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_115(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7c; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_28(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1c; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1c; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1c; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1c; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1c; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1c; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1c; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1c; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1c; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1c; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1c; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1c; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1c; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1c; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1c; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1c; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_112 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_112 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_113 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_113 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_114 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_114 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_115 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_115 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_116(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_116(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_116 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_116(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_117(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_117(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_117 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_117(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_118(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_118(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_118 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_118(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_119(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7d; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7d; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_119(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_119 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_119(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7d; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_29(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1d; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1d; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1d; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1d; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1d; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1d; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1d; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1d; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1d; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1d; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1d; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1d; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1d; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1d; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1d; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1d; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_116 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_116 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_117 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_117 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_118 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_118 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_119 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_119 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_120(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_120(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_120 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_120(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_121(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_121(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_121 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_121(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_122(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_122(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_122 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_122(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_123(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7e; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7e; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_123(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_123 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_123(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7e; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_30(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1e; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1e; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1e; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1e; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1e; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1e; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1e; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1e; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1e; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1e; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1e; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1e; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1e; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1e; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1e; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1e; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_120 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_120 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_121 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_121 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_122 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_122 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_123 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_123 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module read_R_array_index_124(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h1f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h1f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_124(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_124 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_124(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h1f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_125(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h3f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h3f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_125(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_125 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_125(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h3f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_126(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h5f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h5f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_126(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_126 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_126(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h5f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module read_R_array_index_127(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_value_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_l2_clock; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_reset; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_enq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_enq_bits; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_ready; // @[p1.scala 140:37]
  wire  q_frontier_value_l2_io_deq_valid; // @[p1.scala 140:37]
  wire [31:0] q_frontier_value_l2_io_deq_bits; // @[p1.scala 140:37]
  wire [1:0] q_frontier_value_l2_io_count; // @[p1.scala 140:37]
  wire  q_frontier_value_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_value_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_value_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_value_io_count; // @[Decoupled.scala 296:21]
  wire  find_one_clock; // @[p1.scala 162:27]
  wire  find_one_reset; // @[p1.scala 162:27]
  wire [31:0] find_one_io_data; // @[p1.scala 162:27]
  wire [4:0] find_one_io_loc; // @[p1.scala 162:27]
  reg [1:0] stateReg; // @[p1.scala 134:27]
  wire [31:0] _T = ~q_frontier_value_l1_io_deq_bits; // @[p1.scala 143:42]
  wire [31:0] _T_1 = ~_T; // @[p1.scala 143:40]
  wire  _T_2 = ~q_frontier_value_l1_io_deq_valid; // @[p1.scala 144:43]
  wire  _T_3 = ~_T_2; // @[p1.scala 144:41]
  reg [31:0] _T_4; // @[p1.scala 154:34]
  wire [32:0] _T_5 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [31:0] _T_6 = _T_4 - 32'h1; // @[p1.scala 154:48]
  wire [26:0] _GEN_72 = _T_6[31:5]; // @[p1.scala 154:55]
  wire [31:0] _T_7 = {{5'd0}, _T_6[31:5]}; // @[p1.scala 154:55]
  wire [32:0] _T_8 = _T_7 + 32'h1; // @[p1.scala 154:77]
  wire [31:0] _T_9 = _T_7 + 32'h1; // @[p1.scala 154:77]
  reg [31:0] size; // @[p1.scala 154:24]
  reg [31:0] count_f; // @[p1.scala 155:26]
  reg [31:0] frontier; // @[p1.scala 156:27]
  reg [31:0] node; // @[p1.scala 157:23]
  reg [31:0] node_num_in_frontier; // @[p1.scala 158:39]
  reg [31:0] count_node_in_frontier; // @[p1.scala 159:41]
  wire  _T_10 = 2'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _GEN_0 = io_start ? 1'h0 : 1'h1; // @[p1.scala 173:27]
  wire [31:0] _GEN_1 = io_start ? 32'h0 : count_f; // @[p1.scala 173:27]
  wire [1:0] _GEN_2 = io_start ? 2'h1 : stateReg; // @[p1.scala 173:27]
  wire  _T_11 = 2'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_12 = count_f + 32'h1; // @[p1.scala 186:36]
  wire [31:0] _T_13 = count_f + 32'h1; // @[p1.scala 186:36]
  wire  _T_14 = ~io_push_or_pull_state; // @[p1.scala 188:67]
  wire  _T_15 = q_frontier_value_io_deq_bits[0]; // @[Bitwise.scala 49:65]
  wire  _T_16 = q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 49:65]
  wire  _T_17 = q_frontier_value_io_deq_bits[2]; // @[Bitwise.scala 49:65]
  wire  _T_18 = q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 49:65]
  wire  _T_19 = q_frontier_value_io_deq_bits[4]; // @[Bitwise.scala 49:65]
  wire  _T_20 = q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 49:65]
  wire  _T_21 = q_frontier_value_io_deq_bits[6]; // @[Bitwise.scala 49:65]
  wire  _T_22 = q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 49:65]
  wire  _T_23 = q_frontier_value_io_deq_bits[8]; // @[Bitwise.scala 49:65]
  wire  _T_24 = q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 49:65]
  wire  _T_25 = q_frontier_value_io_deq_bits[10]; // @[Bitwise.scala 49:65]
  wire  _T_26 = q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 49:65]
  wire  _T_27 = q_frontier_value_io_deq_bits[12]; // @[Bitwise.scala 49:65]
  wire  _T_28 = q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 49:65]
  wire  _T_29 = q_frontier_value_io_deq_bits[14]; // @[Bitwise.scala 49:65]
  wire  _T_30 = q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 49:65]
  wire  _T_31 = q_frontier_value_io_deq_bits[16]; // @[Bitwise.scala 49:65]
  wire  _T_32 = q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 49:65]
  wire  _T_33 = q_frontier_value_io_deq_bits[18]; // @[Bitwise.scala 49:65]
  wire  _T_34 = q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 49:65]
  wire  _T_35 = q_frontier_value_io_deq_bits[20]; // @[Bitwise.scala 49:65]
  wire  _T_36 = q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 49:65]
  wire  _T_37 = q_frontier_value_io_deq_bits[22]; // @[Bitwise.scala 49:65]
  wire  _T_38 = q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 49:65]
  wire  _T_39 = q_frontier_value_io_deq_bits[24]; // @[Bitwise.scala 49:65]
  wire  _T_40 = q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 49:65]
  wire  _T_41 = q_frontier_value_io_deq_bits[26]; // @[Bitwise.scala 49:65]
  wire  _T_42 = q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 49:65]
  wire  _T_43 = q_frontier_value_io_deq_bits[28]; // @[Bitwise.scala 49:65]
  wire  _T_44 = q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 49:65]
  wire  _T_45 = q_frontier_value_io_deq_bits[30]; // @[Bitwise.scala 49:65]
  wire  _T_46 = q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_47 = q_frontier_value_io_deq_bits[0] + q_frontier_value_io_deq_bits[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_48 = _T_47; // @[Bitwise.scala 47:55]
  wire [1:0] _T_49 = q_frontier_value_io_deq_bits[2] + q_frontier_value_io_deq_bits[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_50 = _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_51 = _T_47 + _T_49; // @[Bitwise.scala 47:55]
  wire [2:0] _T_52 = _T_51; // @[Bitwise.scala 47:55]
  wire [1:0] _T_53 = q_frontier_value_io_deq_bits[4] + q_frontier_value_io_deq_bits[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_54 = _T_53; // @[Bitwise.scala 47:55]
  wire [1:0] _T_55 = q_frontier_value_io_deq_bits[6] + q_frontier_value_io_deq_bits[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_56 = _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_57 = _T_53 + _T_55; // @[Bitwise.scala 47:55]
  wire [2:0] _T_58 = _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_59 = _T_51 + _T_57; // @[Bitwise.scala 47:55]
  wire [3:0] _T_60 = _T_59; // @[Bitwise.scala 47:55]
  wire [1:0] _T_61 = q_frontier_value_io_deq_bits[8] + q_frontier_value_io_deq_bits[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_62 = _T_61; // @[Bitwise.scala 47:55]
  wire [1:0] _T_63 = q_frontier_value_io_deq_bits[10] + q_frontier_value_io_deq_bits[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_64 = _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_65 = _T_61 + _T_63; // @[Bitwise.scala 47:55]
  wire [2:0] _T_66 = _T_65; // @[Bitwise.scala 47:55]
  wire [1:0] _T_67 = q_frontier_value_io_deq_bits[12] + q_frontier_value_io_deq_bits[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_68 = _T_67; // @[Bitwise.scala 47:55]
  wire [1:0] _T_69 = q_frontier_value_io_deq_bits[14] + q_frontier_value_io_deq_bits[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_70 = _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_71 = _T_67 + _T_69; // @[Bitwise.scala 47:55]
  wire [2:0] _T_72 = _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_73 = _T_65 + _T_71; // @[Bitwise.scala 47:55]
  wire [3:0] _T_74 = _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_75 = _T_59 + _T_73; // @[Bitwise.scala 47:55]
  wire [4:0] _T_76 = _T_75; // @[Bitwise.scala 47:55]
  wire [1:0] _T_77 = q_frontier_value_io_deq_bits[16] + q_frontier_value_io_deq_bits[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_78 = _T_77; // @[Bitwise.scala 47:55]
  wire [1:0] _T_79 = q_frontier_value_io_deq_bits[18] + q_frontier_value_io_deq_bits[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_80 = _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_81 = _T_77 + _T_79; // @[Bitwise.scala 47:55]
  wire [2:0] _T_82 = _T_81; // @[Bitwise.scala 47:55]
  wire [1:0] _T_83 = q_frontier_value_io_deq_bits[20] + q_frontier_value_io_deq_bits[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_84 = _T_83; // @[Bitwise.scala 47:55]
  wire [1:0] _T_85 = q_frontier_value_io_deq_bits[22] + q_frontier_value_io_deq_bits[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_86 = _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_87 = _T_83 + _T_85; // @[Bitwise.scala 47:55]
  wire [2:0] _T_88 = _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_89 = _T_81 + _T_87; // @[Bitwise.scala 47:55]
  wire [3:0] _T_90 = _T_89; // @[Bitwise.scala 47:55]
  wire [1:0] _T_91 = q_frontier_value_io_deq_bits[24] + q_frontier_value_io_deq_bits[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_92 = _T_91; // @[Bitwise.scala 47:55]
  wire [1:0] _T_93 = q_frontier_value_io_deq_bits[26] + q_frontier_value_io_deq_bits[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_94 = _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_95 = _T_91 + _T_93; // @[Bitwise.scala 47:55]
  wire [2:0] _T_96 = _T_95; // @[Bitwise.scala 47:55]
  wire [1:0] _T_97 = q_frontier_value_io_deq_bits[28] + q_frontier_value_io_deq_bits[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_98 = _T_97; // @[Bitwise.scala 47:55]
  wire [1:0] _T_99 = q_frontier_value_io_deq_bits[30] + q_frontier_value_io_deq_bits[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_100 = _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_101 = _T_97 + _T_99; // @[Bitwise.scala 47:55]
  wire [2:0] _T_102 = _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_103 = _T_95 + _T_101; // @[Bitwise.scala 47:55]
  wire [3:0] _T_104 = _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_105 = _T_89 + _T_103; // @[Bitwise.scala 47:55]
  wire [4:0] _T_106 = _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_107 = _T_75 + _T_105; // @[Bitwise.scala 47:55]
  wire [5:0] _T_108 = _T_107; // @[Bitwise.scala 47:55]
  wire [31:0] _T_109 = ~q_frontier_value_io_deq_bits; // @[p1.scala 188:118]
  wire  _T_110 = _T_109[0]; // @[Bitwise.scala 49:65]
  wire  _T_111 = _T_109[1]; // @[Bitwise.scala 49:65]
  wire  _T_112 = _T_109[2]; // @[Bitwise.scala 49:65]
  wire  _T_113 = _T_109[3]; // @[Bitwise.scala 49:65]
  wire  _T_114 = _T_109[4]; // @[Bitwise.scala 49:65]
  wire  _T_115 = _T_109[5]; // @[Bitwise.scala 49:65]
  wire  _T_116 = _T_109[6]; // @[Bitwise.scala 49:65]
  wire  _T_117 = _T_109[7]; // @[Bitwise.scala 49:65]
  wire  _T_118 = _T_109[8]; // @[Bitwise.scala 49:65]
  wire  _T_119 = _T_109[9]; // @[Bitwise.scala 49:65]
  wire  _T_120 = _T_109[10]; // @[Bitwise.scala 49:65]
  wire  _T_121 = _T_109[11]; // @[Bitwise.scala 49:65]
  wire  _T_122 = _T_109[12]; // @[Bitwise.scala 49:65]
  wire  _T_123 = _T_109[13]; // @[Bitwise.scala 49:65]
  wire  _T_124 = _T_109[14]; // @[Bitwise.scala 49:65]
  wire  _T_125 = _T_109[15]; // @[Bitwise.scala 49:65]
  wire  _T_126 = _T_109[16]; // @[Bitwise.scala 49:65]
  wire  _T_127 = _T_109[17]; // @[Bitwise.scala 49:65]
  wire  _T_128 = _T_109[18]; // @[Bitwise.scala 49:65]
  wire  _T_129 = _T_109[19]; // @[Bitwise.scala 49:65]
  wire  _T_130 = _T_109[20]; // @[Bitwise.scala 49:65]
  wire  _T_131 = _T_109[21]; // @[Bitwise.scala 49:65]
  wire  _T_132 = _T_109[22]; // @[Bitwise.scala 49:65]
  wire  _T_133 = _T_109[23]; // @[Bitwise.scala 49:65]
  wire  _T_134 = _T_109[24]; // @[Bitwise.scala 49:65]
  wire  _T_135 = _T_109[25]; // @[Bitwise.scala 49:65]
  wire  _T_136 = _T_109[26]; // @[Bitwise.scala 49:65]
  wire  _T_137 = _T_109[27]; // @[Bitwise.scala 49:65]
  wire  _T_138 = _T_109[28]; // @[Bitwise.scala 49:65]
  wire  _T_139 = _T_109[29]; // @[Bitwise.scala 49:65]
  wire  _T_140 = _T_109[30]; // @[Bitwise.scala 49:65]
  wire  _T_141 = _T_109[31]; // @[Bitwise.scala 49:65]
  wire [1:0] _T_142 = _T_109[0] + _T_109[1]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_143 = _T_142; // @[Bitwise.scala 47:55]
  wire [1:0] _T_144 = _T_109[2] + _T_109[3]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_145 = _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_146 = _T_142 + _T_144; // @[Bitwise.scala 47:55]
  wire [2:0] _T_147 = _T_146; // @[Bitwise.scala 47:55]
  wire [1:0] _T_148 = _T_109[4] + _T_109[5]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_149 = _T_148; // @[Bitwise.scala 47:55]
  wire [1:0] _T_150 = _T_109[6] + _T_109[7]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_151 = _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_152 = _T_148 + _T_150; // @[Bitwise.scala 47:55]
  wire [2:0] _T_153 = _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_154 = _T_146 + _T_152; // @[Bitwise.scala 47:55]
  wire [3:0] _T_155 = _T_154; // @[Bitwise.scala 47:55]
  wire [1:0] _T_156 = _T_109[8] + _T_109[9]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_157 = _T_156; // @[Bitwise.scala 47:55]
  wire [1:0] _T_158 = _T_109[10] + _T_109[11]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_159 = _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_160 = _T_156 + _T_158; // @[Bitwise.scala 47:55]
  wire [2:0] _T_161 = _T_160; // @[Bitwise.scala 47:55]
  wire [1:0] _T_162 = _T_109[12] + _T_109[13]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_163 = _T_162; // @[Bitwise.scala 47:55]
  wire [1:0] _T_164 = _T_109[14] + _T_109[15]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_165 = _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_166 = _T_162 + _T_164; // @[Bitwise.scala 47:55]
  wire [2:0] _T_167 = _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_168 = _T_160 + _T_166; // @[Bitwise.scala 47:55]
  wire [3:0] _T_169 = _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_170 = _T_154 + _T_168; // @[Bitwise.scala 47:55]
  wire [4:0] _T_171 = _T_170; // @[Bitwise.scala 47:55]
  wire [1:0] _T_172 = _T_109[16] + _T_109[17]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_173 = _T_172; // @[Bitwise.scala 47:55]
  wire [1:0] _T_174 = _T_109[18] + _T_109[19]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_175 = _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_176 = _T_172 + _T_174; // @[Bitwise.scala 47:55]
  wire [2:0] _T_177 = _T_176; // @[Bitwise.scala 47:55]
  wire [1:0] _T_178 = _T_109[20] + _T_109[21]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_179 = _T_178; // @[Bitwise.scala 47:55]
  wire [1:0] _T_180 = _T_109[22] + _T_109[23]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_181 = _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_182 = _T_178 + _T_180; // @[Bitwise.scala 47:55]
  wire [2:0] _T_183 = _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_184 = _T_176 + _T_182; // @[Bitwise.scala 47:55]
  wire [3:0] _T_185 = _T_184; // @[Bitwise.scala 47:55]
  wire [1:0] _T_186 = _T_109[24] + _T_109[25]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_187 = _T_186; // @[Bitwise.scala 47:55]
  wire [1:0] _T_188 = _T_109[26] + _T_109[27]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_189 = _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_190 = _T_186 + _T_188; // @[Bitwise.scala 47:55]
  wire [2:0] _T_191 = _T_190; // @[Bitwise.scala 47:55]
  wire [1:0] _T_192 = _T_109[28] + _T_109[29]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_193 = _T_192; // @[Bitwise.scala 47:55]
  wire [1:0] _T_194 = _T_109[30] + _T_109[31]; // @[Bitwise.scala 47:55]
  wire [1:0] _T_195 = _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_196 = _T_192 + _T_194; // @[Bitwise.scala 47:55]
  wire [2:0] _T_197 = _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_198 = _T_190 + _T_196; // @[Bitwise.scala 47:55]
  wire [3:0] _T_199 = _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_200 = _T_184 + _T_198; // @[Bitwise.scala 47:55]
  wire [4:0] _T_201 = _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_202 = _T_170 + _T_200; // @[Bitwise.scala 47:55]
  wire [5:0] _T_203 = _T_202; // @[Bitwise.scala 47:55]
  wire [5:0] _T_204 = _T_14 ? _T_107 : _T_202; // @[p1.scala 188:44]
  wire  _T_205 = q_frontier_value_io_deq_bits != 32'h0; // @[p1.scala 190:44]
  wire  _T_206 = ~io_push_or_pull_state; // @[p1.scala 190:77]
  wire  _T_207 = _T_205 & _T_14; // @[p1.scala 190:52]
  wire [37:0] _T_208 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_73 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_209 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_210 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [32:0] _T_211 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_212 = q_frontier_value_io_deq_bits - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_213 = q_frontier_value_io_deq_bits & _T_212; // @[p1.scala 267:11]
  wire [31:0] _T_214 = ~q_frontier_value_io_deq_bits; // @[p1.scala 202:28]
  wire  _T_215 = _T_109 != 32'h0; // @[p1.scala 202:52]
  wire  _T_216 = io_push_or_pull_state; // @[p1.scala 202:85]
  wire  _T_217 = _T_215 & io_push_or_pull_state; // @[p1.scala 202:60]
  wire [31:0] _T_218 = ~q_frontier_value_io_deq_bits; // @[p1.scala 204:41]
  wire [37:0] _T_219 = 32'h20 * count_f; // @[p1.scala 263:26]
  wire [37:0] _GEN_74 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_220 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [37:0] _T_221 = _GEN_73 + _T_208; // @[p1.scala 263:11]
  wire [31:0] _T_222 = ~q_frontier_value_io_deq_bits; // @[p1.scala 208:60]
  wire [32:0] _T_223 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_224 = _T_109 - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_225 = _T_109 & _T_224; // @[p1.scala 267:11]
  wire [31:0] _GEN_3 = _T_109; // @[p1.scala 202:93]
  wire [37:0] _GEN_4 = _T_217 ? _T_210 : {{6'd0}, node}; // @[p1.scala 202:93]
  wire [31:0] _GEN_5 = _T_217 ? _T_225 : frontier; // @[p1.scala 202:93]
  wire [31:0] _GEN_6 = _T_217 ? 32'h0 : count_node_in_frontier; // @[p1.scala 202:93]
  wire [1:0] _GEN_7 = _T_217 ? 2'h2 : 2'h3; // @[p1.scala 202:93]
  wire [31:0] _GEN_8 = _T_207 ? q_frontier_value_io_deq_bits : _T_109; // @[p1.scala 190:85]
  wire [37:0] _GEN_9 = _T_207 ? _T_210 : _GEN_4; // @[p1.scala 190:85]
  wire [31:0] _GEN_10 = _T_207 ? _T_213 : _GEN_5; // @[p1.scala 190:85]
  wire [31:0] _GEN_11 = _T_207 ? 32'h0 : _GEN_6; // @[p1.scala 190:85]
  wire [1:0] _GEN_12 = _T_207 ? 2'h2 : _GEN_7; // @[p1.scala 190:85]
  wire [1:0] _GEN_13 = q_frontier_value_io_deq_valid ? _GEN_12 : stateReg; // @[p1.scala 184:41]
  wire [31:0] _GEN_14 = q_frontier_value_io_deq_valid ? _T_13 : count_f; // @[p1.scala 184:41]
  wire [31:0] _GEN_15 = q_frontier_value_io_deq_valid ? {{26'd0}, _T_204} : node_num_in_frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_16 = _GEN_8; // @[p1.scala 184:41]
  wire [37:0] _GEN_17 = q_frontier_value_io_deq_valid ? _GEN_9 : {{6'd0}, node}; // @[p1.scala 184:41]
  wire [31:0] _GEN_18 = q_frontier_value_io_deq_valid ? _GEN_10 : frontier; // @[p1.scala 184:41]
  wire [31:0] _GEN_19 = q_frontier_value_io_deq_valid ? _GEN_11 : count_node_in_frontier; // @[p1.scala 184:41]
  wire  _T_226 = 2'h2 == stateReg; // @[Conditional.scala 37:30]
  wire [32:0] _T_227 = io_node_num - 32'h1; // @[p1.scala 220:45]
  wire [31:0] _T_228 = io_node_num - 32'h1; // @[p1.scala 220:45]
  reg [31:0] _T_229; // @[p1.scala 220:32]
  wire  _T_230 = node > _T_229; // @[p1.scala 220:23]
  wire  _T_231 = count_node_in_frontier == node_num_in_frontier; // @[p1.scala 224:46]
  wire [38:0] _T_232 = {node, 7'h0}; // @[p1.scala 230:48]
  wire [39:0] _T_233 = _T_232 + 39'h7f; // @[p1.scala 230:65]
  wire [38:0] _T_234 = _T_232 + 39'h7f; // @[p1.scala 230:65]
  wire [32:0] _T_235 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [31:0] _T_236 = count_node_in_frontier + 32'h1; // @[p1.scala 232:70]
  wire [32:0] _T_237 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_238 = frontier - 32'h1; // @[p1.scala 267:16]
  wire [31:0] _T_239 = frontier & _T_238; // @[p1.scala 267:11]
  wire [32:0] _T_240 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [31:0] _T_241 = count_f - 32'h1; // @[p1.scala 237:102]
  wire [37:0] _T_242 = 32'h20 * _T_241; // @[p1.scala 263:26]
  wire [37:0] _GEN_75 = {{33'd0}, find_one_io_loc}; // @[p1.scala 263:11]
  wire [38:0] _T_243 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [37:0] _T_244 = _GEN_73 + _T_242; // @[p1.scala 263:11]
  wire [31:0] _GEN_20 = io_R_array_index_ready ? _T_236 : count_node_in_frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_21 = io_R_array_index_ready ? _T_239 : frontier; // @[p1.scala 231:45]
  wire [31:0] _GEN_22 = frontier; // @[p1.scala 231:45]
  wire [37:0] _GEN_23 = io_R_array_index_ready ? _T_244 : {{6'd0}, node}; // @[p1.scala 231:45]
  wire [1:0] _GEN_24 = io_R_array_index_ready ? 2'h2 : stateReg; // @[p1.scala 231:45]
  wire [1:0] _GEN_25 = _T_231 ? 2'h3 : _GEN_24; // @[p1.scala 224:71]
  wire  _GEN_26 = _T_231 ? 1'h0 : 1'h1; // @[p1.scala 224:71]
  wire [38:0] _GEN_27 = _T_234; // @[p1.scala 224:71]
  wire [31:0] _GEN_28 = _T_231 ? count_node_in_frontier : _GEN_20; // @[p1.scala 224:71]
  wire [31:0] _GEN_29 = _T_231 ? frontier : _GEN_21; // @[p1.scala 224:71]
  wire [31:0] _GEN_30 = frontier; // @[p1.scala 224:71]
  wire [37:0] _GEN_31 = _T_231 ? {{6'd0}, node} : _GEN_23; // @[p1.scala 224:71]
  wire [1:0] _GEN_32 = _T_230 ? 2'h0 : _GEN_25; // @[p1.scala 220:52]
  wire  _GEN_33 = _T_230 ? 1'h0 : _GEN_26; // @[p1.scala 220:52]
  wire [38:0] _GEN_34 = _T_234; // @[p1.scala 220:52]
  wire [31:0] _GEN_35 = _T_230 ? count_node_in_frontier : _GEN_28; // @[p1.scala 220:52]
  wire [31:0] _GEN_36 = _T_230 ? frontier : _GEN_29; // @[p1.scala 220:52]
  wire [31:0] _GEN_37 = frontier; // @[p1.scala 220:52]
  wire [37:0] _GEN_38 = _T_230 ? {{6'd0}, node} : _GEN_31; // @[p1.scala 220:52]
  wire  _T_245 = 2'h3 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_246 = count_f == size; // @[p1.scala 246:26]
  wire [1:0] _GEN_39 = _T_246 ? 2'h0 : 2'h1; // @[p1.scala 246:35]
  wire  _GEN_40 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_41 = _T_245 ? _GEN_39 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_42 = 1'h0; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_43 = _T_226 ? _GEN_32 : _GEN_41; // @[Conditional.scala 39:67]
  wire  _GEN_44 = _T_226 & _GEN_33; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_45 = _T_234; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_46 = _T_226 ? _GEN_35 : count_node_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_47 = _T_226 ? _GEN_36 : frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_48 = frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_49 = _T_226 ? _GEN_38 : {{6'd0}, node}; // @[Conditional.scala 39:67]
  wire  _GEN_50 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_51 = _T_11; // @[Conditional.scala 39:67]
  wire  _GEN_52 = _T_11 ? 1'h0 : _GEN_44; // @[Conditional.scala 39:67]
  wire [1:0] _GEN_53 = _T_11 ? _GEN_13 : _GEN_43; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_54 = _T_11 ? _GEN_14 : count_f; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_55 = _T_11 ? _GEN_15 : node_num_in_frontier; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_56 = _T_11 ? _GEN_8 : frontier; // @[Conditional.scala 39:67]
  wire [37:0] _GEN_57 = _T_11 ? _GEN_17 : _GEN_49; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_58 = _T_11 ? _GEN_18 : _GEN_47; // @[Conditional.scala 39:67]
  wire [31:0] _GEN_59 = _T_11 ? _GEN_19 : _GEN_46; // @[Conditional.scala 39:67]
  wire [38:0] _GEN_60 = _T_234; // @[Conditional.scala 39:67]
  wire  _GEN_61 = _T_10 & _GEN_0; // @[Conditional.scala 40:58]
  wire  _GEN_62 = _T_10 ? 1'h0 : _T_11; // @[Conditional.scala 40:58]
  wire  _GEN_63 = _T_10 ? 1'h0 : _GEN_52; // @[Conditional.scala 40:58]
  wire [38:0] _GEN_64 = _T_234; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_65 = _T_10 ? _GEN_1 : _GEN_54; // @[Conditional.scala 40:58]
  wire [1:0] _GEN_66 = _T_10 ? _GEN_2 : _GEN_53; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_67 = _T_10 ? node_num_in_frontier : _GEN_55; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_68 = _GEN_56; // @[Conditional.scala 40:58]
  wire [37:0] _GEN_69 = _T_10 ? {{6'd0}, node} : _GEN_57; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_70 = _T_10 ? frontier : _GEN_58; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_71 = _T_10 ? count_node_in_frontier : _GEN_59; // @[Conditional.scala 40:58]
  Queue_448 q_frontier_value_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_l1_clock),
    .reset(q_frontier_value_l1_reset),
    .io_enq_ready(q_frontier_value_l1_io_enq_ready),
    .io_enq_valid(q_frontier_value_l1_io_enq_valid),
    .io_enq_bits(q_frontier_value_l1_io_enq_bits),
    .io_deq_ready(q_frontier_value_l1_io_deq_ready),
    .io_deq_valid(q_frontier_value_l1_io_deq_valid),
    .io_deq_bits(q_frontier_value_l1_io_deq_bits),
    .io_count(q_frontier_value_l1_io_count)
  );
  Queue q_frontier_value_l2 ( // @[p1.scala 140:37]
    .clock(q_frontier_value_l2_clock),
    .reset(q_frontier_value_l2_reset),
    .io_enq_ready(q_frontier_value_l2_io_enq_ready),
    .io_enq_valid(q_frontier_value_l2_io_enq_valid),
    .io_enq_bits(q_frontier_value_l2_io_enq_bits),
    .io_deq_ready(q_frontier_value_l2_io_deq_ready),
    .io_deq_valid(q_frontier_value_l2_io_deq_valid),
    .io_deq_bits(q_frontier_value_l2_io_deq_bits),
    .io_count(q_frontier_value_l2_io_count)
  );
  Queue_450 q_frontier_value ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  find_one_32 find_one ( // @[p1.scala 162:27]
    .clock(find_one_clock),
    .reset(find_one_reset),
    .io_data(find_one_io_data),
    .io_loc(find_one_io_loc)
  );
  assign io_frontier_value_ready = q_frontier_value_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_R_array_index_valid = _T_10 ? 1'h0 : _GEN_52; // @[p1.scala 128:28 p1.scala 170:36 p1.scala 183:36 p1.scala 228:40 p1.scala 245:36]
  assign io_R_array_index_bits = _T_234[31:0]; // @[p1.scala 230:39]
  assign io_p1_end = _T_10 & _GEN_0; // @[p1.scala 130:15 p1.scala 168:23 p1.scala 174:27 p1.scala 181:23]
  assign q_frontier_value_l1_clock = clock;
  assign q_frontier_value_l1_reset = reset;
  assign q_frontier_value_l1_io_enq_valid = io_frontier_value_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_l1_io_enq_bits = io_frontier_value_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_l1_io_deq_ready = q_frontier_value_l2_io_enq_ready; // @[p1.scala 141:32 p1.scala 145:38]
  assign q_frontier_value_l2_clock = clock;
  assign q_frontier_value_l2_reset = reset;
  assign q_frontier_value_l2_io_enq_valid = ~_T_2; // @[p1.scala 141:32 p1.scala 144:38]
  assign q_frontier_value_l2_io_enq_bits = ~_T; // @[p1.scala 141:32 p1.scala 143:37]
  assign q_frontier_value_l2_io_deq_ready = q_frontier_value_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = q_frontier_value_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_value_io_enq_bits = q_frontier_value_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_value_io_deq_ready = _T_10 ? 1'h0 : _T_11; // @[p1.scala 160:28 p1.scala 169:36 p1.scala 172:36 p1.scala 182:36 p1.scala 219:36 p1.scala 244:36]
  assign find_one_clock = clock;
  assign find_one_reset = reset;
  assign find_one_io_data = _T_11 ? _GEN_8 : frontier; // @[p1.scala 193:38 p1.scala 204:38 p1.scala 236:38]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  stateReg = _RAND_0[1:0];
  _RAND_1 = {1{`RANDOM}};
  _T_4 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  size = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  count_f = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  frontier = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  node = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_in_frontier = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  count_node_in_frontier = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  _T_229 = _RAND_8[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      stateReg <= 2'h0;
    end else if (_T_10) begin
      if (io_start) begin
        stateReg <= 2'h1;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        if (_T_207) begin
          stateReg <= 2'h2;
        end else if (_T_217) begin
          stateReg <= 2'h2;
        end else begin
          stateReg <= 2'h3;
        end
      end
    end else if (_T_226) begin
      if (_T_230) begin
        stateReg <= 2'h0;
      end else if (_T_231) begin
        stateReg <= 2'h3;
      end else if (io_R_array_index_ready) begin
        stateReg <= 2'h2;
      end
    end else if (_T_245) begin
      if (_T_246) begin
        stateReg <= 2'h0;
      end else begin
        stateReg <= 2'h1;
      end
    end
    _T_4 <= io_node_num;
    size <= _T_7 + 32'h1;
    if (reset) begin
      count_f <= 32'h0;
    end else if (_T_10) begin
      if (io_start) begin
        count_f <= 32'h0;
      end
    end else if (_T_11) begin
      if (q_frontier_value_io_deq_valid) begin
        count_f <= _T_13;
      end
    end
    if (reset) begin
      frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            frontier <= _T_213;
          end else if (_T_217) begin
            frontier <= _T_225;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              frontier <= _T_239;
            end
          end
        end
      end
    end
    if (reset) begin
      node <= 32'h0;
    end else begin
      node <= _GEN_69[31:0];
    end
    if (reset) begin
      node_num_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          node_num_in_frontier <= {{26'd0}, _T_204};
        end
      end
    end
    if (reset) begin
      count_node_in_frontier <= 32'h0;
    end else if (!(_T_10)) begin
      if (_T_11) begin
        if (q_frontier_value_io_deq_valid) begin
          if (_T_207) begin
            count_node_in_frontier <= 32'h0;
          end else if (_T_217) begin
            count_node_in_frontier <= 32'h0;
          end
        end
      end else if (_T_226) begin
        if (!(_T_230)) begin
          if (!(_T_231)) begin
            if (io_R_array_index_ready) begin
              count_node_in_frontier <= _T_236;
            end
          end
        end
      end
    end
    _T_229 <= io_node_num - 32'h1;
  end
endmodule
module P1_127(
  input         clock,
  input         reset,
  input         io_start,
  output        io_frontier_value_ready,
  input         io_frontier_value_valid,
  input  [31:0] io_frontier_value_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input         io_frontier_count_ready,
  output        io_frontier_count_valid,
  output [31:0] io_frontier_count_bits,
  input         io_R_array_index_ready,
  output        io_R_array_index_valid,
  output [31:0] io_R_array_index_bits,
  output        io_p1_end
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  wire  p1_read_frontier_or_visited_map_clock; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_reset; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_start; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_node_num; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_ready; // @[p1.scala 24:49]
  wire  p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 24:49]
  wire [31:0] p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 24:49]
  wire  read_R_array_index_clock; // @[p1.scala 25:36]
  wire  read_R_array_index_reset; // @[p1.scala 25:36]
  wire  read_R_array_index_io_start; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_frontier_value_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_frontier_value_bits; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_node_num; // @[p1.scala 25:36]
  wire  read_R_array_index_io_push_or_pull_state; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_ready; // @[p1.scala 25:36]
  wire  read_R_array_index_io_R_array_index_valid; // @[p1.scala 25:36]
  wire [31:0] read_R_array_index_io_R_array_index_bits; // @[p1.scala 25:36]
  wire  read_R_array_index_io_p1_end; // @[p1.scala 25:36]
  wire  q_R_array_index_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_io_count; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_clock; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_reset; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_R_array_index_1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_R_array_index_1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_R_array_index_1_io_count; // @[Decoupled.scala 296:21]
  reg  _T; // @[p1.scala 28:56]
  reg [31:0] _T_1; // @[p1.scala 30:59]
  reg [31:0] _T_2; // @[p1.scala 33:46]
  reg  _T_3; // @[p1.scala 34:43]
  reg  _T_4; // @[p1.scala 36:56]
  p1_read_frontier_or_visited_map p1_read_frontier_or_visited_map ( // @[p1.scala 24:49]
    .clock(p1_read_frontier_or_visited_map_clock),
    .reset(p1_read_frontier_or_visited_map_reset),
    .io_start(p1_read_frontier_or_visited_map_io_start),
    .io_node_num(p1_read_frontier_or_visited_map_io_node_num),
    .io_frontier_count_ready(p1_read_frontier_or_visited_map_io_frontier_count_ready),
    .io_frontier_count_valid(p1_read_frontier_or_visited_map_io_frontier_count_valid),
    .io_frontier_count_bits(p1_read_frontier_or_visited_map_io_frontier_count_bits)
  );
  read_R_array_index_127 read_R_array_index ( // @[p1.scala 25:36]
    .clock(read_R_array_index_clock),
    .reset(read_R_array_index_reset),
    .io_start(read_R_array_index_io_start),
    .io_frontier_value_ready(read_R_array_index_io_frontier_value_ready),
    .io_frontier_value_valid(read_R_array_index_io_frontier_value_valid),
    .io_frontier_value_bits(read_R_array_index_io_frontier_value_bits),
    .io_node_num(read_R_array_index_io_node_num),
    .io_push_or_pull_state(read_R_array_index_io_push_or_pull_state),
    .io_R_array_index_ready(read_R_array_index_io_R_array_index_ready),
    .io_R_array_index_valid(read_R_array_index_io_R_array_index_valid),
    .io_R_array_index_bits(read_R_array_index_io_R_array_index_bits),
    .io_p1_end(read_R_array_index_io_p1_end)
  );
  Queue_448 q_R_array_index ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_clock),
    .reset(q_R_array_index_reset),
    .io_enq_ready(q_R_array_index_io_enq_ready),
    .io_enq_valid(q_R_array_index_io_enq_valid),
    .io_enq_bits(q_R_array_index_io_enq_bits),
    .io_deq_ready(q_R_array_index_io_deq_ready),
    .io_deq_valid(q_R_array_index_io_deq_valid),
    .io_deq_bits(q_R_array_index_io_deq_bits),
    .io_count(q_R_array_index_io_count)
  );
  Queue_448 q_R_array_index_1 ( // @[Decoupled.scala 296:21]
    .clock(q_R_array_index_1_clock),
    .reset(q_R_array_index_1_reset),
    .io_enq_ready(q_R_array_index_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_1_io_deq_bits),
    .io_count(q_R_array_index_1_io_count)
  );
  assign io_frontier_value_ready = read_R_array_index_io_frontier_value_ready; // @[p1.scala 35:42]
  assign io_frontier_count_valid = p1_read_frontier_or_visited_map_io_frontier_count_valid; // @[p1.scala 29:23]
  assign io_frontier_count_bits = p1_read_frontier_or_visited_map_io_frontier_count_bits; // @[p1.scala 29:23]
  assign io_R_array_index_valid = q_R_array_index_1_io_deq_valid; // @[p1.scala 40:22]
  assign io_R_array_index_bits = q_R_array_index_1_io_deq_bits; // @[p1.scala 40:22]
  assign io_p1_end = read_R_array_index_io_p1_end; // @[p1.scala 42:15]
  assign p1_read_frontier_or_visited_map_clock = clock;
  assign p1_read_frontier_or_visited_map_reset = reset;
  assign p1_read_frontier_or_visited_map_io_start = _T; // @[p1.scala 28:46]
  assign p1_read_frontier_or_visited_map_io_node_num = _T_1; // @[p1.scala 30:49]
  assign p1_read_frontier_or_visited_map_io_frontier_count_ready = io_frontier_count_ready; // @[p1.scala 29:23]
  assign read_R_array_index_clock = clock;
  assign read_R_array_index_reset = reset;
  assign read_R_array_index_io_start = _T_3; // @[p1.scala 34:33]
  assign read_R_array_index_io_frontier_value_valid = io_frontier_value_valid; // @[p1.scala 35:42]
  assign read_R_array_index_io_frontier_value_bits = io_frontier_value_bits; // @[p1.scala 35:42]
  assign read_R_array_index_io_node_num = _T_2; // @[p1.scala 33:36]
  assign read_R_array_index_io_push_or_pull_state = _T_4; // @[p1.scala 36:46]
  assign read_R_array_index_io_R_array_index_ready = q_R_array_index_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_clock = clock;
  assign q_R_array_index_reset = reset;
  assign q_R_array_index_io_enq_valid = read_R_array_index_io_R_array_index_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_io_enq_bits = read_R_array_index_io_R_array_index_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_io_deq_ready = q_R_array_index_1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_R_array_index_1_clock = clock;
  assign q_R_array_index_1_reset = reset;
  assign q_R_array_index_1_io_enq_valid = q_R_array_index_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_R_array_index_1_io_enq_bits = q_R_array_index_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_R_array_index_1_io_deq_ready = io_R_array_index_ready; // @[p1.scala 40:22]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_4 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_start;
    _T_1 <= io_node_num;
    _T_2 <= io_node_num;
    _T_3 <= io_start;
    _T_4 <= io_push_or_pull_state;
  end
endmodule
module Frontier_127(
  input         clock,
  input         reset,
  output        io_frontier_count_ready,
  input         io_frontier_count_valid,
  input  [31:0] io_frontier_count_bits,
  output        io_write_frontier_ready,
  input         io_write_frontier_valid,
  input  [31:0] io_write_frontier_bits,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  input  [31:0] io_node_num,
  input         io_push_or_pull_state,
  input  [31:0] io_level,
  input  [19:0] io_uram_addr_a,
  output        io_bram_from_p2_ready,
  input         io_bram_from_p2_valid,
  input  [18:0] io_bram_from_p2_bits,
  input  [31:0] io_root,
  input         io_frontier_value_ready,
  output        io_frontier_value_valid,
  output [31:0] io_frontier_value_bits,
  output        io_end,
  output        io_last_iteration,
  output [63:0] io_uram_out_a,
  output [31:0] io_frontier_pull_count,
  input         io_frontier_to_p2_ready,
  output        io_frontier_to_p2_valid,
  output        io_frontier_to_p2_bits,
  output        io_init_bram
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [63:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [63:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [63:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
`endif // RANDOMIZE_REG_INIT
  wire  q_frontier_value_clock; // @[frontier.scala 68:34]
  wire  q_frontier_value_reset; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_enq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_enq_bits; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_ready; // @[frontier.scala 68:34]
  wire  q_frontier_value_io_deq_valid; // @[frontier.scala 68:34]
  wire [31:0] q_frontier_value_io_deq_bits; // @[frontier.scala 68:34]
  wire [3:0] q_frontier_value_io_count; // @[frontier.scala 68:34]
  wire  frontier_0_clock; // @[frontier.scala 92:28]
  wire  frontier_0_reset; // @[frontier.scala 92:28]
  wire  frontier_0_io_ena; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addra; // @[frontier.scala 92:28]
  wire  frontier_0_io_clka; // @[frontier.scala 92:28]
  wire  frontier_0_io_dina; // @[frontier.scala 92:28]
  wire  frontier_0_io_wea; // @[frontier.scala 92:28]
  wire  frontier_0_io_douta; // @[frontier.scala 92:28]
  wire  frontier_0_io_enb; // @[frontier.scala 92:28]
  wire [17:0] frontier_0_io_addrb; // @[frontier.scala 92:28]
  wire  frontier_0_io_clkb; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_dinb; // @[frontier.scala 92:28]
  wire  frontier_0_io_web; // @[frontier.scala 92:28]
  wire [31:0] frontier_0_io_doutb; // @[frontier.scala 92:28]
  wire  frontier_1_clock; // @[frontier.scala 93:28]
  wire  frontier_1_reset; // @[frontier.scala 93:28]
  wire  frontier_1_io_ena; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addra; // @[frontier.scala 93:28]
  wire  frontier_1_io_clka; // @[frontier.scala 93:28]
  wire  frontier_1_io_dina; // @[frontier.scala 93:28]
  wire  frontier_1_io_wea; // @[frontier.scala 93:28]
  wire  frontier_1_io_douta; // @[frontier.scala 93:28]
  wire  frontier_1_io_enb; // @[frontier.scala 93:28]
  wire [17:0] frontier_1_io_addrb; // @[frontier.scala 93:28]
  wire  frontier_1_io_clkb; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_dinb; // @[frontier.scala 93:28]
  wire  frontier_1_io_web; // @[frontier.scala 93:28]
  wire [31:0] frontier_1_io_doutb; // @[frontier.scala 93:28]
  wire  uram_clock; // @[frontier.scala 94:22]
  wire  uram_reset; // @[frontier.scala 94:22]
  wire  uram_io_clka; // @[frontier.scala 94:22]
  wire  uram_io_clkb; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addra; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dina; // @[frontier.scala 94:22]
  wire [7:0] uram_io_wea; // @[frontier.scala 94:22]
  wire [63:0] uram_io_douta; // @[frontier.scala 94:22]
  wire [19:0] uram_io_addrb; // @[frontier.scala 94:22]
  wire [63:0] uram_io_dinb; // @[frontier.scala 94:22]
  wire [7:0] uram_io_web; // @[frontier.scala 94:22]
  wire [63:0] uram_io_doutb; // @[frontier.scala 94:22]
  wire  q_frontier_count_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_frontier_count_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_clock; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_reset; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_frontier_count_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_frontier_count_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_frontier_count_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l1_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] bram_from_p2_l2_io_count; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_clock; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_reset; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  bram_from_p2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [18:0] bram_from_p2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] bram_from_p2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l1_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [1:0] q_write_frontier_l2_io_count; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_clock; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_reset; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_enq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_enq_bits; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_ready; // @[Decoupled.scala 296:21]
  wire  q_write_frontier_io_deq_valid; // @[Decoupled.scala 296:21]
  wire [31:0] q_write_frontier_io_deq_bits; // @[Decoupled.scala 296:21]
  wire [5:0] q_write_frontier_io_count; // @[Decoupled.scala 296:21]
  wire  read_queue_clock; // @[frontier.scala 226:28]
  wire  read_queue_reset; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_enq_bits; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_ready; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_valid; // @[frontier.scala 226:28]
  wire  read_queue_io_deq_bits; // @[frontier.scala 226:28]
  wire [5:0] read_queue_io_count; // @[frontier.scala 226:28]
  wire  visited_map_clock; // @[frontier.scala 250:29]
  wire  visited_map_reset; // @[frontier.scala 250:29]
  wire  visited_map_io_ena; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addra; // @[frontier.scala 250:29]
  wire  visited_map_io_clka; // @[frontier.scala 250:29]
  wire  visited_map_io_dina; // @[frontier.scala 250:29]
  wire  visited_map_io_wea; // @[frontier.scala 250:29]
  wire  visited_map_io_douta; // @[frontier.scala 250:29]
  wire  visited_map_io_enb; // @[frontier.scala 250:29]
  wire [17:0] visited_map_io_addrb; // @[frontier.scala 250:29]
  wire  visited_map_io_clkb; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_dinb; // @[frontier.scala 250:29]
  wire  visited_map_io_web; // @[frontier.scala 250:29]
  wire [31:0] visited_map_io_doutb; // @[frontier.scala 250:29]
  reg [7:0] level; // @[frontier.scala 62:24]
  reg  last_iteration_reg; // @[frontier.scala 65:37]
  reg [19:0] uram_addra; // @[frontier.scala 125:29]
  reg [63:0] uram_dina; // @[frontier.scala 126:29]
  reg [7:0] uram_wea; // @[frontier.scala 127:29]
  reg [19:0] uram_addrb; // @[frontier.scala 128:29]
  reg [63:0] uram_dinb; // @[frontier.scala 129:29]
  reg [7:0] uram_web; // @[frontier.scala 130:29]
  reg [63:0] uram_douta; // @[frontier.scala 131:31]
  wire  _T = q_write_frontier_io_deq_ready & q_write_frontier_io_deq_valid; // @[frontier.scala 213:57]
  reg [30:0] count_wf0; // @[Counter.scala 29:33]
  wire  _T_2 = count_wf0 == 31'h7ffffffe; // @[Counter.scala 38:24]
  wire [31:0] _T_3 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _T_4 = count_wf0 + 31'h1; // @[Counter.scala 39:22]
  wire [30:0] _GEN_0 = _T_2 ? 31'h0 : _T_4; // @[Counter.scala 41:21]
  wire [30:0] _GEN_1 = _T ? _GEN_0 : count_wf0; // @[Counter.scala 67:17]
  wire  _GEN_2 = _T & _T_2; // @[Counter.scala 67:17]
  reg  p2_end_flag; // @[frontier.scala 218:30]
  wire  _T_5 = ~io_p2_end; // @[frontier.scala 219:20]
  wire  _GEN_3 = _T_5 | p2_end_flag; // @[frontier.scala 219:32]
  reg [17:0] clear_addr; // @[frontier.scala 221:29]
  reg [2:0] stateReg; // @[frontier.scala 223:27]
  wire  _T_6 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 269:54]
  reg  _T_7; // @[Reg.scala 15:16]
  wire  _GEN_4 = _T_6; // @[Reg.scala 16:19]
  reg  flag_read; // @[Reg.scala 15:16]
  wire  _GEN_5 = _T_7; // @[Reg.scala 16:19]
  wire  _T_8 = ~io_push_or_pull_state; // @[frontier.scala 270:32]
  wire  _T_9 = flag_read; // @[frontier.scala 276:24]
  wire  _T_10 = read_queue_io_enq_ready; // @[frontier.scala 277:42]
  wire  _GEN_6 = _T_10; // @[frontier.scala 277:53]
  wire  _GEN_7 = visited_map_io_douta; // @[frontier.scala 277:53]
  wire  _GEN_8 = flag_read & _T_10; // @[frontier.scala 276:35]
  wire  _GEN_9 = _GEN_7; // @[frontier.scala 276:35]
  wire [6:0] _T_11 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire [5:0] _T_12 = 6'h20 - 6'h2; // @[frontier.scala 284:77]
  wire  _T_13 = read_queue_io_count < _T_12; // @[frontier.scala 284:51]
  wire  _T_14 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 285:33]
  wire [17:0] _T_15 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _T_16 = bram_from_p2_io_deq_bits[0]; // @[configuration.scala 178:10]
  wire  _GEN_10 = _T_6; // @[frontier.scala 285:55]
  wire [17:0] _GEN_11 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 285:55]
  wire  _GEN_12 = _T_6 & bram_from_p2_io_deq_bits[0]; // @[frontier.scala 285:55]
  wire  _GEN_13 = 1'h1; // @[frontier.scala 285:55]
  wire  _T_17 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 303:38]
  wire  _GEN_14 = _T_17; // @[frontier.scala 303:65]
  wire  _GEN_15 = read_queue_io_deq_bits; // @[frontier.scala 303:65]
  wire  _GEN_16 = _T_8 & _GEN_8; // @[frontier.scala 270:40]
  wire  _GEN_17 = _GEN_7; // @[frontier.scala 270:40]
  wire  _GEN_18 = _T_8 & _T_13; // @[frontier.scala 270:40]
  wire  _GEN_19 = _T_8 & _T_6; // @[frontier.scala 270:40]
  wire [17:0] _GEN_20 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 270:40]
  wire  _GEN_21 = _T_8 & _GEN_12; // @[frontier.scala 270:40]
  wire  _GEN_22 = 1'h1; // @[frontier.scala 270:40]
  wire  _GEN_23 = _T_8 & _T_17; // @[frontier.scala 270:40]
  wire  _GEN_24 = _GEN_15; // @[frontier.scala 270:40]
  wire  _T_18 = io_push_or_pull_state; // @[frontier.scala 313:32]
  wire  _T_19 = ~io_frontier_flag; // @[frontier.scala 313:60]
  wire  _T_20 = io_push_or_pull_state & _T_19; // @[frontier.scala 313:40]
  wire  _T_21 = flag_read; // @[frontier.scala 317:24]
  wire  _T_22 = read_queue_io_enq_ready; // @[frontier.scala 318:42]
  wire  _GEN_25 = _T_10 | _GEN_16; // @[frontier.scala 318:53]
  wire  _GEN_26 = _T_10 ? frontier_0_io_douta : _GEN_7; // @[frontier.scala 318:53]
  wire  _GEN_27 = flag_read ? _GEN_25 : _GEN_16; // @[frontier.scala 317:35]
  wire  _GEN_28 = flag_read ? _GEN_26 : _GEN_7; // @[frontier.scala 317:35]
  wire [6:0] _T_23 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire [5:0] _T_24 = 6'h20 - 6'h2; // @[frontier.scala 325:77]
  wire  _T_25 = read_queue_io_count < _T_12; // @[frontier.scala 325:51]
  wire  _T_26 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 326:33]
  wire [17:0] _T_27 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_29 = _T_6; // @[frontier.scala 326:55]
  wire [17:0] _GEN_30 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 326:55]
  wire  _T_28 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 340:38]
  wire  _GEN_31 = _T_17 | _GEN_23; // @[frontier.scala 340:65]
  wire  _GEN_32 = _T_17 ? read_queue_io_deq_bits : _GEN_15; // @[frontier.scala 340:65]
  wire  _GEN_33 = _T_20 ? _GEN_27 : _GEN_16; // @[frontier.scala 313:68]
  wire  _GEN_34 = _T_20 ? _GEN_28 : _GEN_7; // @[frontier.scala 313:68]
  wire  _GEN_35 = _T_20 ? _T_13 : _GEN_18; // @[frontier.scala 313:68]
  wire  _GEN_36 = _T_20 & _T_6; // @[frontier.scala 313:68]
  wire [17:0] _GEN_37 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 313:68]
  wire  _GEN_38 = _T_20 ? _GEN_31 : _GEN_23; // @[frontier.scala 313:68]
  wire  _GEN_39 = _T_20 ? _GEN_32 : _GEN_15; // @[frontier.scala 313:68]
  wire  _T_29 = io_push_or_pull_state; // @[frontier.scala 361:32]
  wire  _T_30 = io_frontier_flag; // @[frontier.scala 361:60]
  wire  _T_31 = io_push_or_pull_state & io_frontier_flag; // @[frontier.scala 361:40]
  wire  _T_32 = flag_read; // @[frontier.scala 365:24]
  wire  _T_33 = read_queue_io_enq_ready; // @[frontier.scala 366:42]
  wire  _GEN_40 = _T_10 | _GEN_33; // @[frontier.scala 366:53]
  wire  _GEN_41 = _T_10 ? frontier_1_io_douta : _GEN_34; // @[frontier.scala 366:53]
  wire  _GEN_42 = flag_read ? _GEN_40 : _GEN_33; // @[frontier.scala 365:35]
  wire  _GEN_43 = flag_read ? _GEN_41 : _GEN_34; // @[frontier.scala 365:35]
  wire [6:0] _T_34 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire [5:0] _T_35 = 6'h20 - 6'h2; // @[frontier.scala 373:77]
  wire  _T_36 = read_queue_io_count < _T_12; // @[frontier.scala 373:51]
  wire  _T_37 = bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready; // @[frontier.scala 374:33]
  wire [17:0] _T_38 = bram_from_p2_io_deq_bits[18:1]; // @[configuration.scala 176:10]
  wire  _GEN_44 = _T_6; // @[frontier.scala 374:55]
  wire [17:0] _GEN_45 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 374:55]
  wire  _T_39 = io_frontier_to_p2_ready & read_queue_io_deq_valid; // @[frontier.scala 387:38]
  wire  _GEN_46 = _T_17 | _GEN_38; // @[frontier.scala 387:65]
  wire  _GEN_47 = _T_17 ? read_queue_io_deq_bits : _GEN_39; // @[frontier.scala 387:65]
  wire  _GEN_48 = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 361:68]
  wire  _GEN_49 = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 361:68]
  wire  _GEN_50 = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 361:68]
  wire  _GEN_51 = _T_31 & _T_6; // @[frontier.scala 361:68]
  wire [17:0] _GEN_52 = bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 361:68]
  wire  _GEN_53 = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 361:68]
  wire  _GEN_54 = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 361:68]
  reg [4:0] delay_for_clear; // @[frontier.scala 429:34]
  wire  cond1 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 431:17]
  wire  _T_40 = ~io_push_or_pull_state; // @[frontier.scala 432:48]
  wire  cond2 = cond1 | _T_8; // @[frontier.scala 432:23]
  reg  init_bram; // @[frontier.scala 434:28]
  wire  _T_41 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 437:66]
  reg  _T_42; // @[Reg.scala 15:16]
  wire  _GEN_55 = _T_41; // @[Reg.scala 16:19]
  reg  flag_read_from_p1; // @[Reg.scala 15:16]
  wire  _GEN_56 = _T_42; // @[Reg.scala 16:19]
  wire  _T_43 = 3'h0 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_44 = flag_read_from_p1; // @[frontier.scala 452:36]
  wire  _T_45 = io_push_or_pull_state; // @[frontier.scala 459:48]
  wire  _GEN_57 = io_push_or_pull_state; // @[frontier.scala 459:56]
  wire [31:0] _GEN_58 = visited_map_io_doutb; // @[frontier.scala 459:56]
  wire  _T_46 = ~io_push_or_pull_state; // @[frontier.scala 469:48]
  wire  _T_47 = ~io_frontier_flag; // @[frontier.scala 470:47]
  wire  _GEN_59 = _T_19 | io_push_or_pull_state; // @[frontier.scala 470:55]
  wire [31:0] _GEN_60 = _T_19 ? frontier_0_io_doutb : _GEN_58; // @[frontier.scala 470:55]
  wire  _T_48 = io_frontier_flag; // @[frontier.scala 477:47]
  wire  _GEN_61 = io_frontier_flag | _GEN_59; // @[frontier.scala 477:55]
  wire [31:0] _GEN_62 = io_frontier_flag ? frontier_1_io_doutb : _GEN_60; // @[frontier.scala 477:55]
  wire  _GEN_63 = _T_8 ? _GEN_61 : io_push_or_pull_state; // @[frontier.scala 469:57]
  wire [31:0] _GEN_64 = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 469:57]
  wire  _GEN_65 = q_frontier_value_io_enq_ready & _GEN_63; // @[frontier.scala 455:52]
  wire [31:0] _GEN_66 = _GEN_64; // @[frontier.scala 455:52]
  wire  _GEN_67 = flag_read_from_p1 & _GEN_65; // @[frontier.scala 452:47]
  wire [31:0] _GEN_68 = _GEN_64; // @[frontier.scala 452:47]
  wire [4:0] _T_49 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire [3:0] _T_50 = 4'h8 - 4'h2; // @[frontier.scala 491:80]
  wire  _T_51 = q_frontier_value_io_count < _T_50; // @[frontier.scala 491:65]
  wire  _T_52 = q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready; // @[frontier.scala 492:41]
  wire  _T_53 = io_push_or_pull_state; // @[frontier.scala 496:44]
  wire  _GEN_69 = io_push_or_pull_state; // @[frontier.scala 496:52]
  wire [31:0] _GEN_70 = q_frontier_count_io_deq_bits; // @[frontier.scala 496:52]
  wire  _T_54 = ~io_push_or_pull_state; // @[frontier.scala 508:44]
  wire  _T_55 = ~io_frontier_flag; // @[frontier.scala 509:43]
  wire  _GEN_71 = _T_19; // @[frontier.scala 509:51]
  wire [31:0] _GEN_72 = q_frontier_count_io_deq_bits; // @[frontier.scala 509:51]
  wire  _T_56 = io_frontier_flag; // @[frontier.scala 516:43]
  wire  _GEN_73 = io_frontier_flag; // @[frontier.scala 516:51]
  wire [31:0] _GEN_74 = q_frontier_count_io_deq_bits; // @[frontier.scala 516:51]
  wire  _GEN_75 = _T_8 & _T_19; // @[frontier.scala 508:53]
  wire [31:0] _GEN_76 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_77 = _T_8 & io_frontier_flag; // @[frontier.scala 508:53]
  wire [31:0] _GEN_78 = _GEN_70; // @[frontier.scala 508:53]
  wire  _GEN_79 = _T_41 & io_push_or_pull_state; // @[frontier.scala 492:67]
  wire [31:0] _GEN_80 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_81 = _T_41 & _GEN_75; // @[frontier.scala 492:67]
  wire [31:0] _GEN_82 = _GEN_70; // @[frontier.scala 492:67]
  wire  _GEN_83 = _T_41 & _GEN_77; // @[frontier.scala 492:67]
  wire [31:0] _GEN_84 = _GEN_70; // @[frontier.scala 492:67]
  wire  _T_57 = io_push_or_pull_state; // @[frontier.scala 554:44]
  wire [23:0] _T_58 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_59 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 557:89]
  wire  _GEN_85 = io_push_or_pull_state | _GEN_19; // @[frontier.scala 554:52]
  wire  _GEN_86 = io_push_or_pull_state | _GEN_21; // @[frontier.scala 554:52]
  wire [17:0] _GEN_87 = io_push_or_pull_state ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 554:52]
  wire  _GEN_88 = 1'h1; // @[frontier.scala 554:52]
  wire  _T_60 = ~io_frontier_flag; // @[frontier.scala 567:39]
  wire [23:0] _T_61 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_62 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 571:88]
  wire  _GEN_89 = _T_19 | _GEN_51; // @[frontier.scala 567:47]
  wire  _GEN_90 = _T_19; // @[frontier.scala 567:47]
  wire [17:0] _GEN_91 = _T_19 ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 567:47]
  wire  _GEN_92 = 1'h1; // @[frontier.scala 567:47]
  wire  _T_63 = io_frontier_flag; // @[frontier.scala 577:39]
  wire [23:0] _T_64 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_65 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 581:88]
  wire  _GEN_93 = io_frontier_flag | _GEN_36; // @[frontier.scala 577:47]
  wire  _GEN_94 = io_frontier_flag; // @[frontier.scala 577:47]
  wire [17:0] _GEN_95 = io_frontier_flag ? {{1'd0}, q_write_frontier_io_deq_bits[23:7]} : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 577:47]
  wire  _GEN_96 = 1'h1; // @[frontier.scala 577:47]
  wire [23:0] _T_66 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_67 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 587:82]
  wire [16:0] _GEN_243 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 587:97]
  wire [3:0] _T_68 = _GEN_243[3:0]; // @[frontier.scala 587:97]
  wire [15:0] _T_69 = 16'h1 << _T_68; // @[frontier.scala 587:33]
  wire [23:0] _T_70 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [16:0] _T_71 = q_write_frontier_io_deq_bits[23:7]; // @[frontier.scala 588:92]
  wire [16:0] _GEN_244 = q_write_frontier_io_deq_bits[23:7] % 17'h8; // @[frontier.scala 588:107]
  wire [3:0] _T_72 = _GEN_244[3:0]; // @[frontier.scala 588:107]
  wire [7:0] _T_73 = 4'h8 * _T_68; // @[frontier.scala 588:44]
  wire [262:0] _GEN_240 = {{255'd0}, level}; // @[frontier.scala 588:36]
  wire [262:0] _T_74 = _GEN_240 << _T_73; // @[frontier.scala 588:36]
  wire [23:0] _T_75 = q_write_frontier_io_deq_bits[23:0]; // @[frontier.scala 768:10]
  wire [13:0] _T_76 = q_write_frontier_io_deq_bits[23:10]; // @[frontier.scala 589:75]
  wire  _GEN_97 = q_write_frontier_io_deq_valid ? 1'h0 : last_iteration_reg; // @[frontier.scala 550:41]
  wire  _GEN_98 = q_write_frontier_io_deq_valid ? _GEN_85 : _GEN_19; // @[frontier.scala 550:41]
  wire  _GEN_99 = q_write_frontier_io_deq_valid ? _GEN_86 : _GEN_21; // @[frontier.scala 550:41]
  wire [17:0] _GEN_100 = q_write_frontier_io_deq_valid ? _GEN_87 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_101 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_102 = q_write_frontier_io_deq_valid ? _GEN_89 : _GEN_51; // @[frontier.scala 550:41]
  wire  _GEN_103 = q_write_frontier_io_deq_valid & _T_19; // @[frontier.scala 550:41]
  wire [17:0] _GEN_104 = q_write_frontier_io_deq_valid ? _GEN_91 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_105 = 1'h1; // @[frontier.scala 550:41]
  wire  _GEN_106 = q_write_frontier_io_deq_valid ? _GEN_93 : _GEN_36; // @[frontier.scala 550:41]
  wire  _GEN_107 = q_write_frontier_io_deq_valid & io_frontier_flag; // @[frontier.scala 550:41]
  wire [17:0] _GEN_108 = q_write_frontier_io_deq_valid ? _GEN_95 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 550:41]
  wire  _GEN_109 = 1'h1; // @[frontier.scala 550:41]
  wire [15:0] _GEN_110 = q_write_frontier_io_deq_valid ? _T_69 : 16'h0; // @[frontier.scala 550:41]
  wire [262:0] _GEN_111 = q_write_frontier_io_deq_valid ? _T_74 : 263'h0; // @[frontier.scala 550:41]
  wire [19:0] _GEN_112 = q_write_frontier_io_deq_valid ? {{6'd0}, q_write_frontier_io_deq_bits[23:10]} : io_uram_addr_a; // @[frontier.scala 550:41]
  wire  _T_77 = p2_end_flag; // @[frontier.scala 624:43]
  wire  _T_78 = io_p2_end & p2_end_flag; // @[frontier.scala 624:28]
  wire  _T_79 = ~q_frontier_count_io_deq_valid; // @[frontier.scala 624:54]
  wire  _T_80 = _T_78 & _T_79; // @[frontier.scala 624:51]
  wire  _T_81 = ~q_write_frontier_io_deq_valid; // @[frontier.scala 624:81]
  wire  _T_82 = _T_80 & cond1; // @[frontier.scala 624:78]
  wire [2:0] _GEN_113 = _T_82 ? 3'h1 : stateReg; // @[frontier.scala 624:106]
  wire [17:0] _GEN_114 = _T_82 ? 18'h0 : clear_addr; // @[frontier.scala 624:106]
  wire  _T_83 = 3'h1 == stateReg; // @[Conditional.scala 37:30]
  wire [18:0] _T_84 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire [17:0] _T_85 = clear_addr + 18'h1; // @[frontier.scala 649:38]
  wire  _T_86 = ~io_frontier_flag; // @[frontier.scala 650:35]
  wire [26:0] _T_87 = io_node_num[31:5]; // @[frontier.scala 661:56]
  reg [26:0] _T_88; // @[frontier.scala 661:43]
  wire [26:0] _GEN_241 = {{9'd0}, clear_addr}; // @[frontier.scala 661:33]
  wire  _T_89 = _GEN_241 >= _T_88; // @[frontier.scala 661:33]
  wire [2:0] _GEN_115 = _T_89 ? 3'h2 : stateReg; // @[frontier.scala 661:76]
  wire  _GEN_116 = _T_19; // @[frontier.scala 650:43]
  wire  _GEN_117 = 1'h0; // @[frontier.scala 650:43]
  wire [17:0] _GEN_118 = clear_addr; // @[frontier.scala 650:43]
  wire [2:0] _GEN_119 = _T_19 ? _GEN_115 : stateReg; // @[frontier.scala 650:43]
  wire  _T_90 = io_frontier_flag; // @[frontier.scala 667:35]
  wire [26:0] _T_91 = io_node_num[31:5]; // @[frontier.scala 678:56]
  reg [26:0] _T_92; // @[frontier.scala 678:43]
  wire [26:0] _GEN_242 = {{9'd0}, clear_addr}; // @[frontier.scala 678:33]
  wire  _T_93 = _GEN_241 >= _T_92; // @[frontier.scala 678:33]
  wire [2:0] _GEN_120 = _T_93 ? 3'h2 : _GEN_119; // @[frontier.scala 678:76]
  wire  _GEN_121 = io_frontier_flag; // @[frontier.scala 667:43]
  wire  _GEN_122 = 1'h0; // @[frontier.scala 667:43]
  wire [17:0] _GEN_123 = clear_addr; // @[frontier.scala 667:43]
  wire [2:0] _GEN_124 = io_frontier_flag ? _GEN_120 : _GEN_119; // @[frontier.scala 667:43]
  wire  _T_94 = 3'h2 == stateReg; // @[Conditional.scala 37:30]
  wire  _T_95 = delay_for_clear < 5'h14; // @[frontier.scala 686:34]
  wire [5:0] _T_96 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _T_97 = delay_for_clear + 5'h1; // @[frontier.scala 687:52]
  wire [4:0] _GEN_125 = _T_95 ? _T_97 : delay_for_clear; // @[frontier.scala 686:41]
  wire  _T_98 = delay_for_clear == 5'h14; // @[frontier.scala 692:43]
  wire  _T_99 = _T_98; // @[frontier.scala 692:26]
  reg  _T_100; // @[frontier.scala 705:25]
  wire  _GEN_126 = _T_100 ? 1'h0 : _T_98; // @[frontier.scala 705:36]
  wire [2:0] _GEN_127 = _T_100 ? 3'h0 : stateReg; // @[frontier.scala 705:36]
  wire  _GEN_128 = _T_100 | last_iteration_reg; // @[frontier.scala 705:36]
  wire [4:0] _GEN_129 = _T_100 ? 5'h0 : _GEN_125; // @[frontier.scala 705:36]
  wire  _GEN_130 = _T_100 ? 1'h0 : _GEN_3; // @[frontier.scala 705:36]
  wire  _T_101 = 3'h3 == stateReg; // @[Conditional.scala 37:30]
  reg  _T_102; // @[frontier.scala 723:25]
  wire [2:0] _GEN_131 = _T_102 ? 3'h4 : stateReg; // @[frontier.scala 723:41]
  wire  _T_103 = 3'h4 == stateReg; // @[Conditional.scala 37:30]
  wire [31:0] _GEN_245 = io_root % 32'h80; // @[frontier.scala 739:34]
  wire [7:0] _T_104 = _GEN_245[7:0]; // @[frontier.scala 739:34]
  reg [7:0] _T_105; // @[frontier.scala 739:25]
  wire  _T_106 = _T_105 == 8'h7f; // @[frontier.scala 739:57]
  wire [24:0] _T_107 = io_root[31:7]; // @[frontier.scala 746:56]
  reg [24:0] _T_108; // @[frontier.scala 746:47]
  wire [24:0] _T_109 = io_root[31:7]; // @[frontier.scala 755:57]
  reg [24:0] _T_110; // @[frontier.scala 755:48]
  wire  _GEN_132 = _T_106 | _GEN_36; // @[frontier.scala 739:67]
  wire  _GEN_133 = _T_106; // @[frontier.scala 739:67]
  wire  _GEN_134 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_135 = _T_106 ? _T_108 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_136 = _T_106 | _GEN_19; // @[frontier.scala 739:67]
  wire  _GEN_137 = _T_106 | _GEN_21; // @[frontier.scala 739:67]
  wire  _GEN_138 = 1'h1; // @[frontier.scala 739:67]
  wire [24:0] _GEN_139 = _T_106 ? _T_110 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[frontier.scala 739:67]
  wire  _GEN_140 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_141 = _T_103 & _T_106; // @[Conditional.scala 39:67]
  wire  _GEN_142 = _T_103 ? _GEN_132 : _GEN_36; // @[Conditional.scala 39:67]
  wire  _GEN_143 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_144 = _T_103 ? _GEN_135 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_145 = _T_103 ? _GEN_136 : _GEN_19; // @[Conditional.scala 39:67]
  wire  _GEN_146 = _T_103 ? _GEN_137 : _GEN_21; // @[Conditional.scala 39:67]
  wire  _GEN_147 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_148 = _T_103 ? _GEN_139 : {{7'd0}, bram_from_p2_io_deq_bits[18:1]}; // @[Conditional.scala 39:67]
  wire  _GEN_149 = _T_103 | init_bram; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_150 = _T_103 ? 3'h2 : stateReg; // @[Conditional.scala 39:67]
  wire  _GEN_151 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_152 = _T_101 ? 1'h0 : _GEN_141; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_153 = _T_101 ? _GEN_131 : _GEN_150; // @[Conditional.scala 39:67]
  wire  _GEN_154 = _T_101 ? _GEN_36 : _GEN_142; // @[Conditional.scala 39:67]
  wire  _GEN_155 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_156 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_144; // @[Conditional.scala 39:67]
  wire  _GEN_157 = _T_101 ? _GEN_19 : _GEN_145; // @[Conditional.scala 39:67]
  wire  _GEN_158 = _T_101 ? _GEN_21 : _GEN_146; // @[Conditional.scala 39:67]
  wire  _GEN_159 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_160 = _T_101 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_148; // @[Conditional.scala 39:67]
  wire  _GEN_161 = _T_101 ? init_bram : _GEN_149; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_162 = _T_94 ? _GEN_129 : delay_for_clear; // @[Conditional.scala 39:67]
  wire  _GEN_163 = _T_94 ? _GEN_126 : 1'h1; // @[Conditional.scala 39:67]
  wire  _GEN_164 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_165 = _T_94 ? 1'h0 : _GEN_152; // @[Conditional.scala 39:67]
  wire  _GEN_166 = _T_94 ? 1'h0 : _GEN_158; // @[Conditional.scala 39:67]
  wire  _GEN_167 = 1'h0; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_168 = _T_94 ? _GEN_127 : _GEN_153; // @[Conditional.scala 39:67]
  wire  _GEN_169 = _T_94 ? _GEN_128 : last_iteration_reg; // @[Conditional.scala 39:67]
  wire  _GEN_170 = _T_94 ? _GEN_130 : _GEN_3; // @[Conditional.scala 39:67]
  wire  _GEN_171 = _T_94 ? _GEN_36 : _GEN_154; // @[Conditional.scala 39:67]
  wire  _GEN_172 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_173 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_156; // @[Conditional.scala 39:67]
  wire  _GEN_174 = _T_94 ? _GEN_19 : _GEN_157; // @[Conditional.scala 39:67]
  wire  _GEN_175 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_176 = _T_94 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_160; // @[Conditional.scala 39:67]
  wire  _GEN_177 = _T_94 ? init_bram : _GEN_161; // @[Conditional.scala 39:67]
  wire  _GEN_178 = _T_83 ? 1'h0 : _GEN_163; // @[Conditional.scala 39:67]
  wire  _GEN_179 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_180 = _T_83 ? 1'h0 : _GEN_165; // @[Conditional.scala 39:67]
  wire  _GEN_181 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire  _GEN_182 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_183 = _T_83 ? _T_85 : clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_184 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_185 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_186 = _T_83 & _T_19; // @[Conditional.scala 39:67]
  wire [2:0] _GEN_187 = _T_83 ? _GEN_124 : _GEN_168; // @[Conditional.scala 39:67]
  wire  _GEN_188 = 1'h0; // @[Conditional.scala 39:67]
  wire [17:0] _GEN_189 = clear_addr; // @[Conditional.scala 39:67]
  wire  _GEN_190 = _T_83 & io_frontier_flag; // @[Conditional.scala 39:67]
  wire [4:0] _GEN_191 = _T_83 ? delay_for_clear : _GEN_162; // @[Conditional.scala 39:67]
  wire  _GEN_192 = _T_83 ? _GEN_21 : _GEN_166; // @[Conditional.scala 39:67]
  wire  _GEN_193 = 1'h0; // @[Conditional.scala 39:67]
  wire  _GEN_194 = _T_83 ? last_iteration_reg : _GEN_169; // @[Conditional.scala 39:67]
  wire  _GEN_195 = _T_83 ? _GEN_3 : _GEN_170; // @[Conditional.scala 39:67]
  wire  _GEN_196 = _T_83 ? _GEN_36 : _GEN_171; // @[Conditional.scala 39:67]
  wire  _GEN_197 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_198 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_173; // @[Conditional.scala 39:67]
  wire  _GEN_199 = _T_83 ? _GEN_19 : _GEN_174; // @[Conditional.scala 39:67]
  wire  _GEN_200 = 1'h1; // @[Conditional.scala 39:67]
  wire [24:0] _GEN_201 = _T_83 ? {{7'd0}, bram_from_p2_io_deq_bits[18:1]} : _GEN_176; // @[Conditional.scala 39:67]
  wire  _GEN_202 = _T_83 ? init_bram : _GEN_177; // @[Conditional.scala 39:67]
  wire  _GEN_203 = _T_43 ? 1'h0 : _GEN_178; // @[Conditional.scala 40:58]
  wire  _GEN_204 = _T_43 & _T_51; // @[Conditional.scala 40:58]
  wire  _GEN_205 = _T_43; // @[Conditional.scala 40:58]
  wire  _GEN_206 = _T_43 ? _GEN_107 : _GEN_180; // @[Conditional.scala 40:58]
  wire  _GEN_207 = _T_43 ? 1'h0 : _GEN_181; // @[Conditional.scala 40:58]
  wire  _GEN_208 = _T_43 & _GEN_103; // @[Conditional.scala 40:58]
  wire  _GEN_209 = _T_43 ? 1'h0 : _GEN_182; // @[Conditional.scala 40:58]
  wire [15:0] _GEN_210 = _T_43 ? _GEN_110 : 16'h0; // @[Conditional.scala 40:58]
  wire [262:0] _GEN_211 = _T_43 ? _GEN_111 : 263'h0; // @[Conditional.scala 40:58]
  wire  _GEN_212 = _T_43 & _GEN_67; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_213 = _GEN_64; // @[Conditional.scala 40:58]
  wire  _GEN_214 = _T_43 & _GEN_79; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_215 = _GEN_70; // @[Conditional.scala 40:58]
  wire  _GEN_216 = _T_43 ? _GEN_81 : _GEN_181; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_217 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_218 = _T_43 ? _GEN_83 : _GEN_182; // @[Conditional.scala 40:58]
  wire [31:0] _GEN_219 = _T_43 ? _GEN_70 : {{14'd0}, clear_addr}; // @[Conditional.scala 40:58]
  wire  _GEN_220 = _T_43 ? _GEN_97 : _GEN_194; // @[Conditional.scala 40:58]
  wire  _GEN_221 = _T_43 ? _GEN_98 : _GEN_199; // @[Conditional.scala 40:58]
  wire  _GEN_222 = _T_43 ? _GEN_99 : _GEN_192; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_223 = _T_43 ? {{7'd0}, _GEN_100} : _GEN_201; // @[Conditional.scala 40:58]
  wire  _GEN_224 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_225 = _T_43 ? _GEN_102 : _GEN_51; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_226 = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[Conditional.scala 40:58]
  wire  _GEN_227 = 1'h1; // @[Conditional.scala 40:58]
  wire  _GEN_228 = _T_43 ? _GEN_106 : _GEN_196; // @[Conditional.scala 40:58]
  wire [24:0] _GEN_229 = _T_43 ? {{7'd0}, _GEN_108} : _GEN_198; // @[Conditional.scala 40:58]
  wire  _GEN_230 = 1'h1; // @[Conditional.scala 40:58]
  wire [19:0] _GEN_231 = _T_43 ? _GEN_112 : io_uram_addr_a; // @[Conditional.scala 40:58]
  wire [2:0] _GEN_232 = _T_43 ? _GEN_113 : _GEN_187; // @[Conditional.scala 40:58]
  wire [17:0] _GEN_233 = _T_43 ? _GEN_114 : _GEN_183; // @[Conditional.scala 40:58]
  wire  _GEN_234 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_235 = 1'h0; // @[Conditional.scala 40:58]
  wire [4:0] _GEN_236 = _T_43 ? delay_for_clear : _GEN_191; // @[Conditional.scala 40:58]
  wire  _GEN_237 = 1'h0; // @[Conditional.scala 40:58]
  wire  _GEN_238 = _T_43 ? _GEN_3 : _GEN_195; // @[Conditional.scala 40:58]
  wire  _GEN_239 = _T_43 ? init_bram : _GEN_202; // @[Conditional.scala 40:58]
  wire  _T_1 = _GEN_2; // @[Counter.scala 67:24]
  wire [31:0] _GEN_246 = io_root % 32'h80;
  Queue_462 q_frontier_value ( // @[frontier.scala 68:34]
    .clock(q_frontier_value_clock),
    .reset(q_frontier_value_reset),
    .io_enq_ready(q_frontier_value_io_enq_ready),
    .io_enq_valid(q_frontier_value_io_enq_valid),
    .io_enq_bits(q_frontier_value_io_enq_bits),
    .io_deq_ready(q_frontier_value_io_deq_ready),
    .io_deq_valid(q_frontier_value_io_deq_valid),
    .io_deq_bits(q_frontier_value_io_deq_bits),
    .io_count(q_frontier_value_io_count)
  );
  bram_controller frontier_0 ( // @[frontier.scala 92:28]
    .clock(frontier_0_clock),
    .reset(frontier_0_reset),
    .io_ena(frontier_0_io_ena),
    .io_addra(frontier_0_io_addra),
    .io_clka(frontier_0_io_clka),
    .io_dina(frontier_0_io_dina),
    .io_wea(frontier_0_io_wea),
    .io_douta(frontier_0_io_douta),
    .io_enb(frontier_0_io_enb),
    .io_addrb(frontier_0_io_addrb),
    .io_clkb(frontier_0_io_clkb),
    .io_dinb(frontier_0_io_dinb),
    .io_web(frontier_0_io_web),
    .io_doutb(frontier_0_io_doutb)
  );
  bram_controller frontier_1 ( // @[frontier.scala 93:28]
    .clock(frontier_1_clock),
    .reset(frontier_1_reset),
    .io_ena(frontier_1_io_ena),
    .io_addra(frontier_1_io_addra),
    .io_clka(frontier_1_io_clka),
    .io_dina(frontier_1_io_dina),
    .io_wea(frontier_1_io_wea),
    .io_douta(frontier_1_io_douta),
    .io_enb(frontier_1_io_enb),
    .io_addrb(frontier_1_io_addrb),
    .io_clkb(frontier_1_io_clkb),
    .io_dinb(frontier_1_io_dinb),
    .io_web(frontier_1_io_web),
    .io_doutb(frontier_1_io_doutb)
  );
  uram_controller uram ( // @[frontier.scala 94:22]
    .clock(uram_clock),
    .reset(uram_reset),
    .io_clka(uram_io_clka),
    .io_clkb(uram_io_clkb),
    .io_addra(uram_io_addra),
    .io_dina(uram_io_dina),
    .io_wea(uram_io_wea),
    .io_douta(uram_io_douta),
    .io_addrb(uram_io_addrb),
    .io_dinb(uram_io_dinb),
    .io_web(uram_io_web),
    .io_doutb(uram_io_doutb)
  );
  Queue_448 q_frontier_count_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l1_clock),
    .reset(q_frontier_count_l1_reset),
    .io_enq_ready(q_frontier_count_l1_io_enq_ready),
    .io_enq_valid(q_frontier_count_l1_io_enq_valid),
    .io_enq_bits(q_frontier_count_l1_io_enq_bits),
    .io_deq_ready(q_frontier_count_l1_io_deq_ready),
    .io_deq_valid(q_frontier_count_l1_io_deq_valid),
    .io_deq_bits(q_frontier_count_l1_io_deq_bits),
    .io_count(q_frontier_count_l1_io_count)
  );
  Queue_448 q_frontier_count_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_l2_clock),
    .reset(q_frontier_count_l2_reset),
    .io_enq_ready(q_frontier_count_l2_io_enq_ready),
    .io_enq_valid(q_frontier_count_l2_io_enq_valid),
    .io_enq_bits(q_frontier_count_l2_io_enq_bits),
    .io_deq_ready(q_frontier_count_l2_io_deq_ready),
    .io_deq_valid(q_frontier_count_l2_io_deq_valid),
    .io_deq_bits(q_frontier_count_l2_io_deq_bits),
    .io_count(q_frontier_count_l2_io_count)
  );
  Queue_450 q_frontier_count ( // @[Decoupled.scala 296:21]
    .clock(q_frontier_count_clock),
    .reset(q_frontier_count_reset),
    .io_enq_ready(q_frontier_count_io_enq_ready),
    .io_enq_valid(q_frontier_count_io_enq_valid),
    .io_enq_bits(q_frontier_count_io_enq_bits),
    .io_deq_ready(q_frontier_count_io_deq_ready),
    .io_deq_valid(q_frontier_count_io_deq_valid),
    .io_deq_bits(q_frontier_count_io_deq_bits),
    .io_count(q_frontier_count_io_count)
  );
  Queue_455 bram_from_p2_l1 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l1_clock),
    .reset(bram_from_p2_l1_reset),
    .io_enq_ready(bram_from_p2_l1_io_enq_ready),
    .io_enq_valid(bram_from_p2_l1_io_enq_valid),
    .io_enq_bits(bram_from_p2_l1_io_enq_bits),
    .io_deq_ready(bram_from_p2_l1_io_deq_ready),
    .io_deq_valid(bram_from_p2_l1_io_deq_valid),
    .io_deq_bits(bram_from_p2_l1_io_deq_bits),
    .io_count(bram_from_p2_l1_io_count)
  );
  Queue_455 bram_from_p2_l2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_l2_clock),
    .reset(bram_from_p2_l2_reset),
    .io_enq_ready(bram_from_p2_l2_io_enq_ready),
    .io_enq_valid(bram_from_p2_l2_io_enq_valid),
    .io_enq_bits(bram_from_p2_l2_io_enq_bits),
    .io_deq_ready(bram_from_p2_l2_io_deq_ready),
    .io_deq_valid(bram_from_p2_l2_io_deq_valid),
    .io_deq_bits(bram_from_p2_l2_io_deq_bits),
    .io_count(bram_from_p2_l2_io_count)
  );
  Queue_468 bram_from_p2 ( // @[Decoupled.scala 296:21]
    .clock(bram_from_p2_clock),
    .reset(bram_from_p2_reset),
    .io_enq_ready(bram_from_p2_io_enq_ready),
    .io_enq_valid(bram_from_p2_io_enq_valid),
    .io_enq_bits(bram_from_p2_io_enq_bits),
    .io_deq_ready(bram_from_p2_io_deq_ready),
    .io_deq_valid(bram_from_p2_io_deq_valid),
    .io_deq_bits(bram_from_p2_io_deq_bits),
    .io_count(bram_from_p2_io_count)
  );
  Queue_448 q_write_frontier_l1 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l1_clock),
    .reset(q_write_frontier_l1_reset),
    .io_enq_ready(q_write_frontier_l1_io_enq_ready),
    .io_enq_valid(q_write_frontier_l1_io_enq_valid),
    .io_enq_bits(q_write_frontier_l1_io_enq_bits),
    .io_deq_ready(q_write_frontier_l1_io_deq_ready),
    .io_deq_valid(q_write_frontier_l1_io_deq_valid),
    .io_deq_bits(q_write_frontier_l1_io_deq_bits),
    .io_count(q_write_frontier_l1_io_count)
  );
  Queue_448 q_write_frontier_l2 ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_l2_clock),
    .reset(q_write_frontier_l2_reset),
    .io_enq_ready(q_write_frontier_l2_io_enq_ready),
    .io_enq_valid(q_write_frontier_l2_io_enq_valid),
    .io_enq_bits(q_write_frontier_l2_io_enq_bits),
    .io_deq_ready(q_write_frontier_l2_io_deq_ready),
    .io_deq_valid(q_write_frontier_l2_io_deq_valid),
    .io_deq_bits(q_write_frontier_l2_io_deq_bits),
    .io_count(q_write_frontier_l2_io_count)
  );
  Queue_450 q_write_frontier ( // @[Decoupled.scala 296:21]
    .clock(q_write_frontier_clock),
    .reset(q_write_frontier_reset),
    .io_enq_ready(q_write_frontier_io_enq_ready),
    .io_enq_valid(q_write_frontier_io_enq_valid),
    .io_enq_bits(q_write_frontier_io_enq_bits),
    .io_deq_ready(q_write_frontier_io_deq_ready),
    .io_deq_valid(q_write_frontier_io_deq_valid),
    .io_deq_bits(q_write_frontier_io_deq_bits),
    .io_count(q_write_frontier_io_count)
  );
  Queue_460 read_queue ( // @[frontier.scala 226:28]
    .clock(read_queue_clock),
    .reset(read_queue_reset),
    .io_enq_ready(read_queue_io_enq_ready),
    .io_enq_valid(read_queue_io_enq_valid),
    .io_enq_bits(read_queue_io_enq_bits),
    .io_deq_ready(read_queue_io_deq_ready),
    .io_deq_valid(read_queue_io_deq_valid),
    .io_deq_bits(read_queue_io_deq_bits),
    .io_count(read_queue_io_count)
  );
  bram_controller visited_map ( // @[frontier.scala 250:29]
    .clock(visited_map_clock),
    .reset(visited_map_reset),
    .io_ena(visited_map_io_ena),
    .io_addra(visited_map_io_addra),
    .io_clka(visited_map_io_clka),
    .io_dina(visited_map_io_dina),
    .io_wea(visited_map_io_wea),
    .io_douta(visited_map_io_douta),
    .io_enb(visited_map_io_enb),
    .io_addrb(visited_map_io_addrb),
    .io_clkb(visited_map_io_clkb),
    .io_dinb(visited_map_io_dinb),
    .io_web(visited_map_io_web),
    .io_doutb(visited_map_io_doutb)
  );
  assign io_frontier_count_ready = q_frontier_count_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_write_frontier_ready = q_write_frontier_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_bram_from_p2_ready = bram_from_p2_l1_io_enq_ready; // @[Decoupled.scala 299:17]
  assign io_frontier_value_valid = q_frontier_value_io_deq_valid; // @[frontier.scala 69:29]
  assign io_frontier_value_bits = q_frontier_value_io_deq_bits; // @[frontier.scala 70:28]
  assign io_end = _T_43 ? 1'h0 : _GEN_178; // @[frontier.scala 61:12 frontier.scala 440:20 frontier.scala 630:20 frontier.scala 692:20 frontier.scala 706:24]
  assign io_last_iteration = last_iteration_reg; // @[frontier.scala 66:23]
  assign io_uram_out_a = uram_douta; // @[frontier.scala 173:19]
  assign io_frontier_pull_count = {{1'd0}, count_wf0}; // @[frontier.scala 215:28]
  assign io_frontier_to_p2_valid = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 57:29 frontier.scala 307:37 frontier.scala 344:37 frontier.scala 391:37]
  assign io_frontier_to_p2_bits = _T_31 ? _GEN_47 : _GEN_39; // @[frontier.scala 308:36 frontier.scala 345:36 frontier.scala 392:36]
  assign io_init_bram = init_bram; // @[frontier.scala 435:18]
  assign q_frontier_value_clock = clock;
  assign q_frontier_value_reset = reset;
  assign q_frontier_value_io_enq_valid = _T_43 & _GEN_67; // @[frontier.scala 72:35 frontier.scala 463:59 frontier.scala 472:59 frontier.scala 479:59]
  assign q_frontier_value_io_enq_bits = _T_8 ? _GEN_62 : _GEN_58; // @[frontier.scala 464:58 frontier.scala 473:58 frontier.scala 480:58]
  assign q_frontier_value_io_deq_ready = io_frontier_value_ready; // @[frontier.scala 71:35]
  assign frontier_0_clock = clock;
  assign frontier_0_reset = reset;
  assign frontier_0_io_ena = _T_43 ? _GEN_106 : _GEN_196; // @[frontier.scala 97:23 frontier.scala 327:31 frontier.scala 579:39 frontier.scala 741:35]
  assign frontier_0_io_addra = _GEN_229[17:0]; // @[frontier.scala 328:33 frontier.scala 581:41 frontier.scala 746:37]
  assign frontier_0_io_clka = clock; // @[frontier.scala 99:24]
  assign frontier_0_io_dina = 1'h1; // @[frontier.scala 582:40 frontier.scala 744:36]
  assign frontier_0_io_wea = _T_43 ? _GEN_107 : _GEN_180; // @[frontier.scala 101:23 frontier.scala 445:31 frontier.scala 580:39 frontier.scala 634:31 frontier.scala 696:31 frontier.scala 717:31 frontier.scala 731:31 frontier.scala 742:35]
  assign frontier_0_io_enb = _T_43 ? _GEN_81 : _GEN_181; // @[frontier.scala 98:23 frontier.scala 511:43 frontier.scala 659:35]
  assign frontier_0_io_addrb = _GEN_217[17:0]; // @[frontier.scala 512:45 frontier.scala 657:37]
  assign frontier_0_io_clkb = clock; // @[frontier.scala 100:24]
  assign frontier_0_io_dinb = 32'h0; // @[frontier.scala 655:36]
  assign frontier_0_io_web = _T_43 ? 1'h0 : _GEN_181; // @[frontier.scala 102:23 frontier.scala 446:31 frontier.scala 635:31 frontier.scala 653:35 frontier.scala 697:31 frontier.scala 718:31 frontier.scala 732:31]
  assign frontier_1_clock = clock;
  assign frontier_1_reset = reset;
  assign frontier_1_io_ena = _T_43 ? _GEN_102 : _GEN_51; // @[frontier.scala 111:23 frontier.scala 375:31 frontier.scala 569:39]
  assign frontier_1_io_addra = _T_43 ? _GEN_104 : bram_from_p2_io_deq_bits[18:1]; // @[frontier.scala 376:33 frontier.scala 571:41]
  assign frontier_1_io_clka = clock; // @[frontier.scala 113:24]
  assign frontier_1_io_dina = 1'h1; // @[frontier.scala 572:40]
  assign frontier_1_io_wea = _T_43 & _GEN_103; // @[frontier.scala 115:23 frontier.scala 447:31 frontier.scala 570:39 frontier.scala 636:31 frontier.scala 698:31 frontier.scala 719:31 frontier.scala 733:31]
  assign frontier_1_io_enb = _T_43 ? _GEN_83 : _GEN_182; // @[frontier.scala 112:23 frontier.scala 518:43 frontier.scala 676:35]
  assign frontier_1_io_addrb = _GEN_217[17:0]; // @[frontier.scala 519:45 frontier.scala 674:37]
  assign frontier_1_io_clkb = clock; // @[frontier.scala 114:24]
  assign frontier_1_io_dinb = 32'h0; // @[frontier.scala 672:36]
  assign frontier_1_io_web = _T_43 ? 1'h0 : _GEN_182; // @[frontier.scala 116:23 frontier.scala 448:31 frontier.scala 637:31 frontier.scala 670:35 frontier.scala 699:31 frontier.scala 720:31 frontier.scala 734:31]
  assign uram_clock = clock;
  assign uram_reset = reset;
  assign uram_io_clka = clock; // @[frontier.scala 135:18]
  assign uram_io_clkb = clock; // @[frontier.scala 136:18]
  assign uram_io_addra = uram_addra; // @[frontier.scala 155:20]
  assign uram_io_dina = uram_dina; // @[frontier.scala 156:20]
  assign uram_io_wea = uram_wea; // @[frontier.scala 153:20]
  assign uram_io_addrb = 20'h0; // @[frontier.scala 157:20]
  assign uram_io_dinb = 64'h0; // @[frontier.scala 158:20]
  assign uram_io_web = 8'h0; // @[frontier.scala 154:20]
  assign q_frontier_count_l1_clock = clock;
  assign q_frontier_count_l1_reset = reset;
  assign q_frontier_count_l1_io_enq_valid = io_frontier_count_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l1_io_enq_bits = io_frontier_count_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l1_io_deq_ready = q_frontier_count_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_l2_clock = clock;
  assign q_frontier_count_l2_reset = reset;
  assign q_frontier_count_l2_io_enq_valid = q_frontier_count_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_l2_io_enq_bits = q_frontier_count_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_l2_io_deq_ready = q_frontier_count_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_frontier_count_clock = clock;
  assign q_frontier_count_reset = reset;
  assign q_frontier_count_io_enq_valid = q_frontier_count_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_frontier_count_io_enq_bits = q_frontier_count_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_frontier_count_io_deq_ready = _T_43 & _T_51; // @[frontier.scala 207:28 frontier.scala 442:36 frontier.scala 491:36 frontier.scala 631:36 frontier.scala 693:36 frontier.scala 714:36 frontier.scala 728:36]
  assign bram_from_p2_l1_clock = clock;
  assign bram_from_p2_l1_reset = reset;
  assign bram_from_p2_l1_io_enq_valid = io_bram_from_p2_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l1_io_enq_bits = io_bram_from_p2_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l1_io_deq_ready = bram_from_p2_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_l2_clock = clock;
  assign bram_from_p2_l2_reset = reset;
  assign bram_from_p2_l2_io_enq_valid = bram_from_p2_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_l2_io_enq_bits = bram_from_p2_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_l2_io_deq_ready = bram_from_p2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign bram_from_p2_clock = clock;
  assign bram_from_p2_reset = reset;
  assign bram_from_p2_io_enq_valid = bram_from_p2_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign bram_from_p2_io_enq_bits = bram_from_p2_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign bram_from_p2_io_deq_ready = _T_31 ? _T_13 : _GEN_35; // @[frontier.scala 243:24 frontier.scala 284:28 frontier.scala 325:28 frontier.scala 373:28]
  assign q_write_frontier_l1_clock = clock;
  assign q_write_frontier_l1_reset = reset;
  assign q_write_frontier_l1_io_enq_valid = io_write_frontier_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l1_io_enq_bits = io_write_frontier_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l1_io_deq_ready = q_write_frontier_l2_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_l2_clock = clock;
  assign q_write_frontier_l2_reset = reset;
  assign q_write_frontier_l2_io_enq_valid = q_write_frontier_l1_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_l2_io_enq_bits = q_write_frontier_l1_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_l2_io_deq_ready = q_write_frontier_io_enq_ready; // @[Decoupled.scala 299:17]
  assign q_write_frontier_clock = clock;
  assign q_write_frontier_reset = reset;
  assign q_write_frontier_io_enq_valid = q_write_frontier_l2_io_deq_valid; // @[Decoupled.scala 297:22]
  assign q_write_frontier_io_enq_bits = q_write_frontier_l2_io_deq_bits; // @[Decoupled.scala 298:21]
  assign q_write_frontier_io_deq_ready = 3'h0 == stateReg; // @[frontier.scala 208:28 frontier.scala 443:36 frontier.scala 548:36 frontier.scala 632:36 frontier.scala 694:36 frontier.scala 715:36 frontier.scala 729:36]
  assign read_queue_clock = clock;
  assign read_queue_reset = reset;
  assign read_queue_io_enq_valid = _T_31 ? _GEN_42 : _GEN_33; // @[frontier.scala 227:29 frontier.scala 278:41 frontier.scala 319:41 frontier.scala 367:41]
  assign read_queue_io_enq_bits = _T_31 ? _GEN_43 : _GEN_34; // @[frontier.scala 279:40 frontier.scala 320:40 frontier.scala 368:40]
  assign read_queue_io_deq_ready = _T_31 ? _GEN_46 : _GEN_38; // @[frontier.scala 229:29 frontier.scala 306:37 frontier.scala 343:37 frontier.scala 390:37]
  assign visited_map_clock = clock;
  assign visited_map_reset = reset;
  assign visited_map_io_ena = _T_43 ? _GEN_98 : _GEN_199; // @[frontier.scala 255:24 frontier.scala 286:32 frontier.scala 555:40 frontier.scala 750:36]
  assign visited_map_io_addra = _GEN_223[17:0]; // @[frontier.scala 287:34 frontier.scala 557:42 frontier.scala 755:38]
  assign visited_map_io_clka = clock; // @[frontier.scala 253:25]
  assign visited_map_io_dina = 1'h1; // @[frontier.scala 289:33 frontier.scala 558:41 frontier.scala 753:37]
  assign visited_map_io_wea = _T_43 ? _GEN_99 : _GEN_192; // @[frontier.scala 257:24 frontier.scala 288:32 frontier.scala 556:40 frontier.scala 702:32 frontier.scala 751:36]
  assign visited_map_io_enb = _T_43 & _GEN_79; // @[frontier.scala 256:24 frontier.scala 500:44]
  assign visited_map_io_addrb = _GEN_70[17:0]; // @[frontier.scala 501:46]
  assign visited_map_io_clkb = clock; // @[frontier.scala 254:25]
  assign visited_map_io_dinb = 32'h0;
  assign visited_map_io_web = 1'h0; // @[frontier.scala 258:24 frontier.scala 703:32]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  level = _RAND_0[7:0];
  _RAND_1 = {1{`RANDOM}};
  last_iteration_reg = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  uram_addra = _RAND_2[19:0];
  _RAND_3 = {2{`RANDOM}};
  uram_dina = _RAND_3[63:0];
  _RAND_4 = {1{`RANDOM}};
  uram_wea = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  uram_addrb = _RAND_5[19:0];
  _RAND_6 = {2{`RANDOM}};
  uram_dinb = _RAND_6[63:0];
  _RAND_7 = {1{`RANDOM}};
  uram_web = _RAND_7[7:0];
  _RAND_8 = {2{`RANDOM}};
  uram_douta = _RAND_8[63:0];
  _RAND_9 = {1{`RANDOM}};
  count_wf0 = _RAND_9[30:0];
  _RAND_10 = {1{`RANDOM}};
  p2_end_flag = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  clear_addr = _RAND_11[17:0];
  _RAND_12 = {1{`RANDOM}};
  stateReg = _RAND_12[2:0];
  _RAND_13 = {1{`RANDOM}};
  _T_7 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  flag_read = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  delay_for_clear = _RAND_15[4:0];
  _RAND_16 = {1{`RANDOM}};
  init_bram = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  _T_42 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  flag_read_from_p1 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_88 = _RAND_19[26:0];
  _RAND_20 = {1{`RANDOM}};
  _T_92 = _RAND_20[26:0];
  _RAND_21 = {1{`RANDOM}};
  _T_100 = _RAND_21[0:0];
  _RAND_22 = {1{`RANDOM}};
  _T_102 = _RAND_22[0:0];
  _RAND_23 = {1{`RANDOM}};
  _T_105 = _RAND_23[7:0];
  _RAND_24 = {1{`RANDOM}};
  _T_108 = _RAND_24[24:0];
  _RAND_25 = {1{`RANDOM}};
  _T_110 = _RAND_25[24:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      level <= 8'h0;
    end else begin
      level <= io_level[7:0];
    end
    if (reset) begin
      last_iteration_reg <= 1'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        last_iteration_reg <= 1'h0;
      end
    end else if (!(_T_83)) begin
      if (_T_94) begin
        last_iteration_reg <= _GEN_128;
      end
    end
    if (reset) begin
      uram_addra <= 20'h0;
    end else if (_T_43) begin
      if (q_write_frontier_io_deq_valid) begin
        uram_addra <= {{6'd0}, q_write_frontier_io_deq_bits[23:10]};
      end else begin
        uram_addra <= io_uram_addr_a;
      end
    end else begin
      uram_addra <= io_uram_addr_a;
    end
    if (reset) begin
      uram_dina <= 64'h0;
    end else begin
      uram_dina <= _GEN_211[63:0];
    end
    if (reset) begin
      uram_wea <= 8'h0;
    end else begin
      uram_wea <= _GEN_210[7:0];
    end
    uram_addrb <= 20'h0;
    uram_dinb <= 64'h0;
    uram_web <= 8'h0;
    if (reset) begin
      uram_douta <= 64'h0;
    end else begin
      uram_douta <= uram_io_douta;
    end
    if (reset) begin
      count_wf0 <= 31'h0;
    end else if (_T) begin
      if (_T_2) begin
        count_wf0 <= 31'h0;
      end else begin
        count_wf0 <= _T_4;
      end
    end
    if (reset) begin
      p2_end_flag <= 1'h0;
    end else if (_T_43) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_83) begin
      p2_end_flag <= _GEN_3;
    end else if (_T_94) begin
      if (_T_100) begin
        p2_end_flag <= 1'h0;
      end else begin
        p2_end_flag <= _GEN_3;
      end
    end else begin
      p2_end_flag <= _GEN_3;
    end
    if (reset) begin
      clear_addr <= 18'h0;
    end else if (_T_43) begin
      if (_T_82) begin
        clear_addr <= 18'h0;
      end
    end else if (_T_83) begin
      clear_addr <= _T_85;
    end
    if (reset) begin
      stateReg <= 3'h3;
    end else if (_T_43) begin
      if (_T_82) begin
        stateReg <= 3'h1;
      end
    end else if (_T_83) begin
      if (io_frontier_flag) begin
        if (_T_93) begin
          stateReg <= 3'h2;
        end else if (_T_19) begin
          if (_T_89) begin
            stateReg <= 3'h2;
          end
        end
      end else if (_T_19) begin
        if (_T_89) begin
          stateReg <= 3'h2;
        end
      end
    end else if (_T_94) begin
      if (_T_100) begin
        stateReg <= 3'h0;
      end
    end else if (_T_101) begin
      if (_T_102) begin
        stateReg <= 3'h4;
      end
    end else if (_T_103) begin
      stateReg <= 3'h2;
    end
    _T_7 <= bram_from_p2_io_deq_valid & bram_from_p2_io_deq_ready;
    flag_read <= _T_7;
    if (reset) begin
      delay_for_clear <= 5'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (_T_94) begin
          if (_T_100) begin
            delay_for_clear <= 5'h0;
          end else if (_T_95) begin
            delay_for_clear <= _T_97;
          end
        end
      end
    end
    if (reset) begin
      init_bram <= 1'h0;
    end else if (!(_T_43)) begin
      if (!(_T_83)) begin
        if (!(_T_94)) begin
          if (!(_T_101)) begin
            init_bram <= _GEN_149;
          end
        end
      end
    end
    _T_42 <= q_frontier_count_io_deq_valid & q_frontier_count_io_deq_ready;
    flag_read_from_p1 <= _T_42;
    _T_88 <= io_node_num[31:5];
    _T_92 <= io_node_num[31:5];
    _T_100 <= io_start;
    _T_102 <= io_start_init;
    _T_105 <= _GEN_246[7:0];
    _T_108 <= io_root[31:7];
    _T_110 <= io_root[31:7];
  end
endmodule
module pipeline_31(
  input         clock,
  input         reset,
  input         io_frontier_flag,
  input         io_p2_end,
  input         io_start,
  input         io_start_init,
  output        io_end,
  output        io_last_iteration,
  output        io_init_bram,
  output [31:0] io_p2_count,
  output [31:0] io_frontier_pull_count,
  output [31:0] io_p2_pull_count,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input  [31:0] io_node_num,
  input         io_push_or_pull,
  input  [31:0] io_root,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  output        io_p1_end,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
`endif // RANDOMIZE_REG_INIT
  wire  copy_start_clock; // @[pipeline.scala 80:28]
  wire  copy_start_reset; // @[pipeline.scala 80:28]
  wire  copy_start_io_in; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_0; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_1; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_2; // @[pipeline.scala 80:28]
  wire  copy_start_io_out_3; // @[pipeline.scala 80:28]
  wire  copy_start_init_clock; // @[pipeline.scala 81:33]
  wire  copy_start_init_reset; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_in; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_0; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_1; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_2; // @[pipeline.scala 81:33]
  wire  copy_start_init_io_out_3; // @[pipeline.scala 81:33]
  wire  copy_frontier_flag_clock; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_reset; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_in; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_0; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_1; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_2; // @[pipeline.scala 83:36]
  wire  copy_frontier_flag_io_out_3; // @[pipeline.scala 83:36]
  wire  copy_level_clock; // @[pipeline.scala 84:28]
  wire  copy_level_reset; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_in; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_0; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_1; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_2; // @[pipeline.scala 84:28]
  wire [31:0] copy_level_io_out_3; // @[pipeline.scala 84:28]
  wire  copy_p2_end_clock; // @[pipeline.scala 85:29]
  wire  copy_p2_end_reset; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_in; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_0; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_1; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_2; // @[pipeline.scala 85:29]
  wire  copy_p2_end_io_out_3; // @[pipeline.scala 85:29]
  wire  copy_push_or_pull_clock; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_reset; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_in; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_0; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_1; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_2; // @[pipeline.scala 86:35]
  wire  copy_push_or_pull_io_out_3; // @[pipeline.scala 86:35]
  wire  copy_node_num_clock; // @[pipeline.scala 87:31]
  wire  copy_node_num_reset; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_in; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_0; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_1; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_2; // @[pipeline.scala 87:31]
  wire [31:0] copy_node_num_io_out_3; // @[pipeline.scala 87:31]
  wire  copy_root_clock; // @[pipeline.scala 88:27]
  wire  copy_root_reset; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_in; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_0; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_1; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_2; // @[pipeline.scala 88:27]
  wire [31:0] copy_root_io_out_3; // @[pipeline.scala 88:27]
  wire  P1_clock; // @[pipeline.scala 114:23]
  wire  P1_reset; // @[pipeline.scala 114:23]
  wire  P1_io_start; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_clock; // @[pipeline.scala 115:23]
  wire  P2_reset; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_clock; // @[pipeline.scala 116:29]
  wire  Frontier_reset; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_1_clock; // @[pipeline.scala 114:23]
  wire  P1_1_reset; // @[pipeline.scala 114:23]
  wire  P1_1_io_start; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_1_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_1_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_1_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_1_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_1_clock; // @[pipeline.scala 115:23]
  wire  P2_1_reset; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_1_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_1_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_1_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_1_clock; // @[pipeline.scala 116:29]
  wire  Frontier_1_reset; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_1_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_1_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_1_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_1_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_1_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_2_clock; // @[pipeline.scala 114:23]
  wire  P1_2_reset; // @[pipeline.scala 114:23]
  wire  P1_2_io_start; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_2_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_2_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_2_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_2_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_2_clock; // @[pipeline.scala 115:23]
  wire  P2_2_reset; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_2_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_2_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_2_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_2_clock; // @[pipeline.scala 116:29]
  wire  Frontier_2_reset; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_2_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_2_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_2_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_2_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_2_io_init_bram; // @[pipeline.scala 116:29]
  wire  P1_3_clock; // @[pipeline.scala 114:23]
  wire  P1_3_reset; // @[pipeline.scala 114:23]
  wire  P1_3_io_start; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_value_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_value_bits; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_node_num; // @[pipeline.scala 114:23]
  wire  P1_3_io_push_or_pull_state; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_frontier_count_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_frontier_count_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_ready; // @[pipeline.scala 114:23]
  wire  P1_3_io_R_array_index_valid; // @[pipeline.scala 114:23]
  wire [31:0] P1_3_io_R_array_index_bits; // @[pipeline.scala 114:23]
  wire  P1_3_io_p1_end; // @[pipeline.scala 114:23]
  wire  P2_3_clock; // @[pipeline.scala 115:23]
  wire  P2_3_reset; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_neighbours_valid; // @[pipeline.scala 115:23]
  wire [63:0] P2_3_io_neighbours_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_push_or_pull_state; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_valid; // @[pipeline.scala 115:23]
  wire  P2_3_io_visited_map_or_frontier_bits; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_count; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_p2_pull_count; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_write_frontier_valid; // @[pipeline.scala 115:23]
  wire [31:0] P2_3_io_write_frontier_bits; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_ready; // @[pipeline.scala 115:23]
  wire  P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 115:23]
  wire [18:0] P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 115:23]
  wire  Frontier_3_clock; // @[pipeline.scala 116:29]
  wire  Frontier_3_reset; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_count_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_count_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_write_frontier_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_write_frontier_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_flag; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_p2_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_start_init; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_node_num; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_push_or_pull_state; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_level; // @[pipeline.scala 116:29]
  wire [19:0] Frontier_3_io_uram_addr_a; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_bram_from_p2_valid; // @[pipeline.scala 116:29]
  wire [18:0] Frontier_3_io_bram_from_p2_bits; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_root; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_value_valid; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_value_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_end; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_last_iteration; // @[pipeline.scala 116:29]
  wire [63:0] Frontier_3_io_uram_out_a; // @[pipeline.scala 116:29]
  wire [31:0] Frontier_3_io_frontier_pull_count; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_ready; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 116:29]
  wire  Frontier_3_io_init_bram; // @[pipeline.scala 116:29]
  reg [31:0] _T; // @[pipeline.scala 98:35]
  reg [31:0] _T_1; // @[pipeline.scala 99:31]
  wire [32:0] _T_2 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_3 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_4 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_5 = _T_3 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_6 = 6'h0 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_7 = _T_6 + 7'h1f; // @[pipeline.scala 130:125]
  wire [6:0] _T_8 = _T_6 + 7'h1f; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_0 = {{25'd0}, _T_8}; // @[pipeline.scala 130:97]
  wire [32:0] _T_9 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [31:0] _T_10 = _T_5 - _GEN_0; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_1 = _T_10[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_11 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_12; // @[pipeline.scala 130:43]
  wire [32:0] _T_13 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_14 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_15 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_16 = _T_14 - 32'h1; // @[pipeline.scala 130:91]
  wire [6:0] _T_17 = 6'h1 * 6'h20; // @[pipeline.scala 130:104]
  wire [7:0] _T_18 = _T_17 + 7'h1f; // @[pipeline.scala 130:125]
  wire [6:0] _T_19 = _T_17 + 7'h1f; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_2 = {{25'd0}, _T_19}; // @[pipeline.scala 130:97]
  wire [32:0] _T_20 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [31:0] _T_21 = _T_16 - _GEN_2; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_3 = _T_21[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_22 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_23; // @[pipeline.scala 130:43]
  wire [32:0] _T_24 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_25 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_26 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_27 = _T_25 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_28 = 6'h2 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_29 = _T_28 + 8'h1f; // @[pipeline.scala 130:125]
  wire [7:0] _T_30 = _T_28 + 8'h1f; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_4 = {{24'd0}, _T_30}; // @[pipeline.scala 130:97]
  wire [32:0] _T_31 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [31:0] _T_32 = _T_27 - _GEN_4; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_5 = _T_32[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_33 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_34; // @[pipeline.scala 130:43]
  wire [32:0] _T_35 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [31:0] _T_36 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 130:69]
  wire [32:0] _T_37 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [31:0] _T_38 = _T_36 - 32'h1; // @[pipeline.scala 130:91]
  wire [7:0] _T_39 = 6'h3 * 6'h20; // @[pipeline.scala 130:104]
  wire [8:0] _T_40 = _T_39 + 8'h1f; // @[pipeline.scala 130:125]
  wire [7:0] _T_41 = _T_39 + 8'h1f; // @[pipeline.scala 130:125]
  wire [31:0] _GEN_6 = {{24'd0}, _T_41}; // @[pipeline.scala 130:97]
  wire [32:0] _T_42 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [31:0] _T_43 = _T_38 - _GEN_6; // @[pipeline.scala 130:97]
  wire [24:0] _GEN_7 = _T_43[31:7]; // @[pipeline.scala 130:135]
  wire [31:0] _T_44 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 130:135]
  reg [31:0] _T_45; // @[pipeline.scala 130:43]
  wire [32:0] _T_46 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_47 = Frontier_io_frontier_pull_count + Frontier_1_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_48 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_49 = _T_47 + Frontier_2_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [32:0] _T_50 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  wire [31:0] _T_51 = _T_49 + Frontier_3_io_frontier_pull_count; // @[pipeline.scala 136:71]
  reg [31:0] _T_52; // @[pipeline.scala 136:38]
  wire  _T_53 = Frontier_io_end & Frontier_1_io_end; // @[pipeline.scala 138:48]
  wire  _T_54 = _T_53 & Frontier_2_io_end; // @[pipeline.scala 138:48]
  wire  _T_55 = _T_54 & Frontier_3_io_end; // @[pipeline.scala 138:48]
  reg  _T_56; // @[pipeline.scala 138:22]
  wire  _T_57 = Frontier_io_last_iteration & Frontier_1_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_58 = _T_57 & Frontier_2_io_last_iteration; // @[pipeline.scala 140:61]
  wire  _T_59 = _T_58 & Frontier_3_io_last_iteration; // @[pipeline.scala 140:61]
  reg  _T_60; // @[pipeline.scala 140:33]
  wire [32:0] _T_61 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_62 = P2_io_p2_count + P2_1_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_63 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_64 = _T_62 + P2_2_io_p2_count; // @[pipeline.scala 154:49]
  wire [32:0] _T_65 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  wire [31:0] _T_66 = _T_64 + P2_3_io_p2_count; // @[pipeline.scala 154:49]
  reg [31:0] _T_67; // @[pipeline.scala 154:27]
  wire [32:0] _T_68 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_69 = P2_io_p2_pull_count + P2_1_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_70 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_71 = _T_69 + P2_2_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [32:0] _T_72 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  wire [31:0] _T_73 = _T_71 + P2_3_io_p2_pull_count; // @[pipeline.scala 155:59]
  reg [31:0] _T_74; // @[pipeline.scala 155:32]
  wire [32:0] _T_75 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_76 = copy_node_num_io_out_0 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_77 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_78 = _T_3 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_79 = 6'h0 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_80 = _T_6 + 7'h1f; // @[pipeline.scala 162:119]
  wire [6:0] _T_81 = _T_6 + 7'h1f; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_8 = {{25'd0}, _T_8}; // @[pipeline.scala 162:91]
  wire [32:0] _T_82 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [31:0] _T_83 = _T_5 - _GEN_0; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_9 = _T_10[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_84 = {{7'd0}, _T_10[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_85; // @[pipeline.scala 162:37]
  wire [32:0] _T_86 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_87 = copy_node_num_io_out_1 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_88 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_89 = _T_14 - 32'h1; // @[pipeline.scala 162:85]
  wire [6:0] _T_90 = 6'h1 * 6'h20; // @[pipeline.scala 162:98]
  wire [7:0] _T_91 = _T_17 + 7'h1f; // @[pipeline.scala 162:119]
  wire [6:0] _T_92 = _T_17 + 7'h1f; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_10 = {{25'd0}, _T_19}; // @[pipeline.scala 162:91]
  wire [32:0] _T_93 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [31:0] _T_94 = _T_16 - _GEN_2; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_11 = _T_21[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_95 = {{7'd0}, _T_21[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_96; // @[pipeline.scala 162:37]
  wire [32:0] _T_97 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_98 = copy_node_num_io_out_2 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_99 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_100 = _T_25 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_101 = 6'h2 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_102 = _T_28 + 8'h1f; // @[pipeline.scala 162:119]
  wire [7:0] _T_103 = _T_28 + 8'h1f; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_12 = {{24'd0}, _T_30}; // @[pipeline.scala 162:91]
  wire [32:0] _T_104 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [31:0] _T_105 = _T_27 - _GEN_4; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_13 = _T_32[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_106 = {{7'd0}, _T_32[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_107; // @[pipeline.scala 162:37]
  wire [32:0] _T_108 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [31:0] _T_109 = copy_node_num_io_out_3 + 32'h80; // @[pipeline.scala 162:63]
  wire [32:0] _T_110 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [31:0] _T_111 = _T_36 - 32'h1; // @[pipeline.scala 162:85]
  wire [7:0] _T_112 = 6'h3 * 6'h20; // @[pipeline.scala 162:98]
  wire [8:0] _T_113 = _T_39 + 8'h1f; // @[pipeline.scala 162:119]
  wire [7:0] _T_114 = _T_39 + 8'h1f; // @[pipeline.scala 162:119]
  wire [31:0] _GEN_14 = {{24'd0}, _T_41}; // @[pipeline.scala 162:91]
  wire [32:0] _T_115 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [31:0] _T_116 = _T_38 - _GEN_6; // @[pipeline.scala 162:91]
  wire [24:0] _GEN_15 = _T_43[31:7]; // @[pipeline.scala 162:129]
  wire [31:0] _T_117 = {{7'd0}, _T_43[31:7]}; // @[pipeline.scala 162:129]
  reg [31:0] _T_118; // @[pipeline.scala 162:37]
  wire  _T_119 = P1_io_p1_end & P1_1_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_120 = _T_119 & P1_2_io_p1_end; // @[pipeline.scala 194:48]
  wire  _T_121 = _T_120 & P1_3_io_p1_end; // @[pipeline.scala 194:48]
  reg  _T_122; // @[pipeline.scala 194:28]
  wire [24:0] _GEN_16 = _T_10[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_17 = _T_21[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_18 = _T_32[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_19 = _T_43[31:7]; // @[pipeline.scala 130:43]
  wire [24:0] _GEN_20 = _T_10[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_21 = _T_21[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_22 = _T_32[31:7]; // @[pipeline.scala 162:37]
  wire [24:0] _GEN_23 = _T_43[31:7]; // @[pipeline.scala 162:37]
  copy_pipe copy_start ( // @[pipeline.scala 80:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3)
  );
  copy_pipe copy_start_init ( // @[pipeline.scala 81:33]
    .clock(copy_start_init_clock),
    .reset(copy_start_init_reset),
    .io_in(copy_start_init_io_in),
    .io_out_0(copy_start_init_io_out_0),
    .io_out_1(copy_start_init_io_out_1),
    .io_out_2(copy_start_init_io_out_2),
    .io_out_3(copy_start_init_io_out_3)
  );
  copy_pipe copy_frontier_flag ( // @[pipeline.scala 83:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3)
  );
  copy_pipe_3 copy_level ( // @[pipeline.scala 84:28]
    .clock(copy_level_clock),
    .reset(copy_level_reset),
    .io_in(copy_level_io_in),
    .io_out_0(copy_level_io_out_0),
    .io_out_1(copy_level_io_out_1),
    .io_out_2(copy_level_io_out_2),
    .io_out_3(copy_level_io_out_3)
  );
  copy_pipe copy_p2_end ( // @[pipeline.scala 85:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3)
  );
  copy_pipe copy_push_or_pull ( // @[pipeline.scala 86:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3)
  );
  copy_pipe_3 copy_node_num ( // @[pipeline.scala 87:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3)
  );
  copy_pipe_3 copy_root ( // @[pipeline.scala 88:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3)
  );
  P1_124 P1 ( // @[pipeline.scala 114:23]
    .clock(P1_clock),
    .reset(P1_reset),
    .io_start(P1_io_start),
    .io_frontier_value_ready(P1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_io_frontier_value_bits),
    .io_node_num(P1_io_node_num),
    .io_push_or_pull_state(P1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_io_R_array_index_bits),
    .io_p1_end(P1_io_p1_end)
  );
  P2 P2 ( // @[pipeline.scala 115:23]
    .clock(P2_clock),
    .reset(P2_reset),
    .io_neighbours_ready(P2_io_neighbours_ready),
    .io_neighbours_valid(P2_io_neighbours_valid),
    .io_neighbours_bits(P2_io_neighbours_bits),
    .io_push_or_pull_state(P2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_io_p2_count),
    .io_p2_pull_count(P2_io_p2_pull_count),
    .io_write_frontier_ready(P2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_io_bram_to_frontier_bits)
  );
  Frontier_124 Frontier ( // @[pipeline.scala 116:29]
    .clock(Frontier_clock),
    .reset(Frontier_reset),
    .io_frontier_count_ready(Frontier_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_io_write_frontier_bits),
    .io_frontier_flag(Frontier_io_frontier_flag),
    .io_p2_end(Frontier_io_p2_end),
    .io_start(Frontier_io_start),
    .io_start_init(Frontier_io_start_init),
    .io_node_num(Frontier_io_node_num),
    .io_push_or_pull_state(Frontier_io_push_or_pull_state),
    .io_level(Frontier_io_level),
    .io_uram_addr_a(Frontier_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_io_bram_from_p2_bits),
    .io_root(Frontier_io_root),
    .io_frontier_value_ready(Frontier_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_io_frontier_value_bits),
    .io_end(Frontier_io_end),
    .io_last_iteration(Frontier_io_last_iteration),
    .io_uram_out_a(Frontier_io_uram_out_a),
    .io_frontier_pull_count(Frontier_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_io_init_bram)
  );
  P1_125 P1_1 ( // @[pipeline.scala 114:23]
    .clock(P1_1_clock),
    .reset(P1_1_reset),
    .io_start(P1_1_io_start),
    .io_frontier_value_ready(P1_1_io_frontier_value_ready),
    .io_frontier_value_valid(P1_1_io_frontier_value_valid),
    .io_frontier_value_bits(P1_1_io_frontier_value_bits),
    .io_node_num(P1_1_io_node_num),
    .io_push_or_pull_state(P1_1_io_push_or_pull_state),
    .io_frontier_count_ready(P1_1_io_frontier_count_ready),
    .io_frontier_count_valid(P1_1_io_frontier_count_valid),
    .io_frontier_count_bits(P1_1_io_frontier_count_bits),
    .io_R_array_index_ready(P1_1_io_R_array_index_ready),
    .io_R_array_index_valid(P1_1_io_R_array_index_valid),
    .io_R_array_index_bits(P1_1_io_R_array_index_bits),
    .io_p1_end(P1_1_io_p1_end)
  );
  P2 P2_1 ( // @[pipeline.scala 115:23]
    .clock(P2_1_clock),
    .reset(P2_1_reset),
    .io_neighbours_ready(P2_1_io_neighbours_ready),
    .io_neighbours_valid(P2_1_io_neighbours_valid),
    .io_neighbours_bits(P2_1_io_neighbours_bits),
    .io_push_or_pull_state(P2_1_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_1_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_1_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_1_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_1_io_p2_count),
    .io_p2_pull_count(P2_1_io_p2_pull_count),
    .io_write_frontier_ready(P2_1_io_write_frontier_ready),
    .io_write_frontier_valid(P2_1_io_write_frontier_valid),
    .io_write_frontier_bits(P2_1_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_1_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_1_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_1_io_bram_to_frontier_bits)
  );
  Frontier_125 Frontier_1 ( // @[pipeline.scala 116:29]
    .clock(Frontier_1_clock),
    .reset(Frontier_1_reset),
    .io_frontier_count_ready(Frontier_1_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_1_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_1_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_1_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_1_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_1_io_write_frontier_bits),
    .io_frontier_flag(Frontier_1_io_frontier_flag),
    .io_p2_end(Frontier_1_io_p2_end),
    .io_start(Frontier_1_io_start),
    .io_start_init(Frontier_1_io_start_init),
    .io_node_num(Frontier_1_io_node_num),
    .io_push_or_pull_state(Frontier_1_io_push_or_pull_state),
    .io_level(Frontier_1_io_level),
    .io_uram_addr_a(Frontier_1_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_1_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_1_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_1_io_bram_from_p2_bits),
    .io_root(Frontier_1_io_root),
    .io_frontier_value_ready(Frontier_1_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_1_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_1_io_frontier_value_bits),
    .io_end(Frontier_1_io_end),
    .io_last_iteration(Frontier_1_io_last_iteration),
    .io_uram_out_a(Frontier_1_io_uram_out_a),
    .io_frontier_pull_count(Frontier_1_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_1_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_1_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_1_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_1_io_init_bram)
  );
  P1_126 P1_2 ( // @[pipeline.scala 114:23]
    .clock(P1_2_clock),
    .reset(P1_2_reset),
    .io_start(P1_2_io_start),
    .io_frontier_value_ready(P1_2_io_frontier_value_ready),
    .io_frontier_value_valid(P1_2_io_frontier_value_valid),
    .io_frontier_value_bits(P1_2_io_frontier_value_bits),
    .io_node_num(P1_2_io_node_num),
    .io_push_or_pull_state(P1_2_io_push_or_pull_state),
    .io_frontier_count_ready(P1_2_io_frontier_count_ready),
    .io_frontier_count_valid(P1_2_io_frontier_count_valid),
    .io_frontier_count_bits(P1_2_io_frontier_count_bits),
    .io_R_array_index_ready(P1_2_io_R_array_index_ready),
    .io_R_array_index_valid(P1_2_io_R_array_index_valid),
    .io_R_array_index_bits(P1_2_io_R_array_index_bits),
    .io_p1_end(P1_2_io_p1_end)
  );
  P2 P2_2 ( // @[pipeline.scala 115:23]
    .clock(P2_2_clock),
    .reset(P2_2_reset),
    .io_neighbours_ready(P2_2_io_neighbours_ready),
    .io_neighbours_valid(P2_2_io_neighbours_valid),
    .io_neighbours_bits(P2_2_io_neighbours_bits),
    .io_push_or_pull_state(P2_2_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_2_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_2_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_2_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_2_io_p2_count),
    .io_p2_pull_count(P2_2_io_p2_pull_count),
    .io_write_frontier_ready(P2_2_io_write_frontier_ready),
    .io_write_frontier_valid(P2_2_io_write_frontier_valid),
    .io_write_frontier_bits(P2_2_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_2_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_2_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_2_io_bram_to_frontier_bits)
  );
  Frontier_126 Frontier_2 ( // @[pipeline.scala 116:29]
    .clock(Frontier_2_clock),
    .reset(Frontier_2_reset),
    .io_frontier_count_ready(Frontier_2_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_2_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_2_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_2_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_2_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_2_io_write_frontier_bits),
    .io_frontier_flag(Frontier_2_io_frontier_flag),
    .io_p2_end(Frontier_2_io_p2_end),
    .io_start(Frontier_2_io_start),
    .io_start_init(Frontier_2_io_start_init),
    .io_node_num(Frontier_2_io_node_num),
    .io_push_or_pull_state(Frontier_2_io_push_or_pull_state),
    .io_level(Frontier_2_io_level),
    .io_uram_addr_a(Frontier_2_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_2_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_2_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_2_io_bram_from_p2_bits),
    .io_root(Frontier_2_io_root),
    .io_frontier_value_ready(Frontier_2_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_2_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_2_io_frontier_value_bits),
    .io_end(Frontier_2_io_end),
    .io_last_iteration(Frontier_2_io_last_iteration),
    .io_uram_out_a(Frontier_2_io_uram_out_a),
    .io_frontier_pull_count(Frontier_2_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_2_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_2_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_2_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_2_io_init_bram)
  );
  P1_127 P1_3 ( // @[pipeline.scala 114:23]
    .clock(P1_3_clock),
    .reset(P1_3_reset),
    .io_start(P1_3_io_start),
    .io_frontier_value_ready(P1_3_io_frontier_value_ready),
    .io_frontier_value_valid(P1_3_io_frontier_value_valid),
    .io_frontier_value_bits(P1_3_io_frontier_value_bits),
    .io_node_num(P1_3_io_node_num),
    .io_push_or_pull_state(P1_3_io_push_or_pull_state),
    .io_frontier_count_ready(P1_3_io_frontier_count_ready),
    .io_frontier_count_valid(P1_3_io_frontier_count_valid),
    .io_frontier_count_bits(P1_3_io_frontier_count_bits),
    .io_R_array_index_ready(P1_3_io_R_array_index_ready),
    .io_R_array_index_valid(P1_3_io_R_array_index_valid),
    .io_R_array_index_bits(P1_3_io_R_array_index_bits),
    .io_p1_end(P1_3_io_p1_end)
  );
  P2 P2_3 ( // @[pipeline.scala 115:23]
    .clock(P2_3_clock),
    .reset(P2_3_reset),
    .io_neighbours_ready(P2_3_io_neighbours_ready),
    .io_neighbours_valid(P2_3_io_neighbours_valid),
    .io_neighbours_bits(P2_3_io_neighbours_bits),
    .io_push_or_pull_state(P2_3_io_push_or_pull_state),
    .io_visited_map_or_frontier_ready(P2_3_io_visited_map_or_frontier_ready),
    .io_visited_map_or_frontier_valid(P2_3_io_visited_map_or_frontier_valid),
    .io_visited_map_or_frontier_bits(P2_3_io_visited_map_or_frontier_bits),
    .io_p2_count(P2_3_io_p2_count),
    .io_p2_pull_count(P2_3_io_p2_pull_count),
    .io_write_frontier_ready(P2_3_io_write_frontier_ready),
    .io_write_frontier_valid(P2_3_io_write_frontier_valid),
    .io_write_frontier_bits(P2_3_io_write_frontier_bits),
    .io_bram_to_frontier_ready(P2_3_io_bram_to_frontier_ready),
    .io_bram_to_frontier_valid(P2_3_io_bram_to_frontier_valid),
    .io_bram_to_frontier_bits(P2_3_io_bram_to_frontier_bits)
  );
  Frontier_127 Frontier_3 ( // @[pipeline.scala 116:29]
    .clock(Frontier_3_clock),
    .reset(Frontier_3_reset),
    .io_frontier_count_ready(Frontier_3_io_frontier_count_ready),
    .io_frontier_count_valid(Frontier_3_io_frontier_count_valid),
    .io_frontier_count_bits(Frontier_3_io_frontier_count_bits),
    .io_write_frontier_ready(Frontier_3_io_write_frontier_ready),
    .io_write_frontier_valid(Frontier_3_io_write_frontier_valid),
    .io_write_frontier_bits(Frontier_3_io_write_frontier_bits),
    .io_frontier_flag(Frontier_3_io_frontier_flag),
    .io_p2_end(Frontier_3_io_p2_end),
    .io_start(Frontier_3_io_start),
    .io_start_init(Frontier_3_io_start_init),
    .io_node_num(Frontier_3_io_node_num),
    .io_push_or_pull_state(Frontier_3_io_push_or_pull_state),
    .io_level(Frontier_3_io_level),
    .io_uram_addr_a(Frontier_3_io_uram_addr_a),
    .io_bram_from_p2_ready(Frontier_3_io_bram_from_p2_ready),
    .io_bram_from_p2_valid(Frontier_3_io_bram_from_p2_valid),
    .io_bram_from_p2_bits(Frontier_3_io_bram_from_p2_bits),
    .io_root(Frontier_3_io_root),
    .io_frontier_value_ready(Frontier_3_io_frontier_value_ready),
    .io_frontier_value_valid(Frontier_3_io_frontier_value_valid),
    .io_frontier_value_bits(Frontier_3_io_frontier_value_bits),
    .io_end(Frontier_3_io_end),
    .io_last_iteration(Frontier_3_io_last_iteration),
    .io_uram_out_a(Frontier_3_io_uram_out_a),
    .io_frontier_pull_count(Frontier_3_io_frontier_pull_count),
    .io_frontier_to_p2_ready(Frontier_3_io_frontier_to_p2_ready),
    .io_frontier_to_p2_valid(Frontier_3_io_frontier_to_p2_valid),
    .io_frontier_to_p2_bits(Frontier_3_io_frontier_to_p2_bits),
    .io_init_bram(Frontier_3_io_init_bram)
  );
  assign io_end = _T_56; // @[pipeline.scala 138:12]
  assign io_last_iteration = _T_60; // @[pipeline.scala 140:23]
  assign io_init_bram = Frontier_3_io_init_bram; // @[pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37 pipeline.scala 133:37]
  assign io_p2_count = _T_67; // @[pipeline.scala 154:17]
  assign io_frontier_pull_count = _T_52; // @[pipeline.scala 136:28]
  assign io_p2_pull_count = _T_74; // @[pipeline.scala 155:22]
  assign io_p2_in_0_ready = P2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_1_ready = P2_1_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_2_ready = P2_2_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_p2_in_3_ready = P2_3_io_neighbours_ready; // @[pipeline.scala 200:29]
  assign io_frontier_in_0_ready = Frontier_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_1_ready = Frontier_1_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_2_ready = Frontier_2_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_frontier_in_3_ready = Frontier_3_io_write_frontier_ready; // @[pipeline.scala 212:39]
  assign io_p2_out_0_valid = P2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_0_bits = P2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_1_valid = P2_1_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_1_bits = P2_1_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_2_valid = P2_2_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_2_bits = P2_2_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_p2_out_3_valid = P2_3_io_write_frontier_valid; // @[pipeline.scala 210:39]
  assign io_p2_out_3_bits = P2_3_io_write_frontier_bits; // @[pipeline.scala 210:39]
  assign io_R_array_index_0_valid = P1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_0_bits = P1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_valid = P1_1_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_1_bits = P1_1_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_valid = P1_2_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_2_bits = P1_2_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_valid = P1_3_io_R_array_index_valid; // @[pipeline.scala 191:32]
  assign io_R_array_index_3_bits = P1_3_io_R_array_index_bits; // @[pipeline.scala 191:32]
  assign io_p1_end = _T_122; // @[pipeline.scala 194:18]
  assign io_uram_out_a_0 = Frontier_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_1 = Frontier_1_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_2 = Frontier_2_io_uram_out_a; // @[pipeline.scala 225:35]
  assign io_uram_out_a_3 = Frontier_3_io_uram_out_a; // @[pipeline.scala 225:35]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[pipeline.scala 91:22]
  assign copy_start_init_clock = clock;
  assign copy_start_init_reset = reset;
  assign copy_start_init_io_in = io_start_init; // @[pipeline.scala 92:27]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[pipeline.scala 94:30]
  assign copy_level_clock = clock;
  assign copy_level_reset = reset;
  assign copy_level_io_in = io_level; // @[pipeline.scala 95:22]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[pipeline.scala 96:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[pipeline.scala 97:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T; // @[pipeline.scala 98:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_1; // @[pipeline.scala 99:21]
  assign P1_clock = clock;
  assign P1_reset = reset;
  assign P1_io_start = copy_start_io_out_0; // @[pipeline.scala 160:39]
  assign P1_io_frontier_value_valid = Frontier_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_io_frontier_value_bits = Frontier_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_io_node_num = _T_85; // @[pipeline.scala 162:27]
  assign P1_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 161:39]
  assign P1_io_frontier_count_ready = Frontier_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_io_R_array_index_ready = io_R_array_index_0_ready; // @[pipeline.scala 191:32]
  assign P2_clock = clock;
  assign P2_reset = reset;
  assign P2_io_neighbours_valid = io_p2_in_0_valid; // @[pipeline.scala 200:29]
  assign P2_io_neighbours_bits = io_p2_in_0_bits; // @[pipeline.scala 200:29]
  assign P2_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 149:39]
  assign P2_io_visited_map_or_frontier_valid = Frontier_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_io_visited_map_or_frontier_bits = Frontier_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_io_write_frontier_ready = io_p2_out_0_ready; // @[pipeline.scala 210:39]
  assign P2_io_bram_to_frontier_ready = Frontier_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_clock = clock;
  assign Frontier_reset = reset;
  assign Frontier_io_frontier_count_valid = P1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_io_frontier_count_bits = P1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_io_write_frontier_valid = io_frontier_in_0_valid; // @[pipeline.scala 212:39]
  assign Frontier_io_write_frontier_bits = io_frontier_in_0_bits; // @[pipeline.scala 212:39]
  assign Frontier_io_frontier_flag = copy_frontier_flag_io_out_0; // @[pipeline.scala 120:39]
  assign Frontier_io_p2_end = copy_p2_end_io_out_0; // @[pipeline.scala 121:39]
  assign Frontier_io_start = copy_start_io_out_0; // @[pipeline.scala 122:39]
  assign Frontier_io_start_init = copy_start_init_io_out_0; // @[pipeline.scala 123:39]
  assign Frontier_io_node_num = _T_12; // @[pipeline.scala 130:33]
  assign Frontier_io_push_or_pull_state = copy_push_or_pull_io_out_0; // @[pipeline.scala 129:39]
  assign Frontier_io_level = copy_level_io_out_0; // @[pipeline.scala 124:39]
  assign Frontier_io_uram_addr_a = io_uram_addr_a_0; // @[pipeline.scala 223:36]
  assign Frontier_io_bram_from_p2_valid = P2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_io_bram_from_p2_bits = P2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_io_root = copy_root_io_out_0; // @[pipeline.scala 132:31]
  assign Frontier_io_frontier_value_ready = P1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_io_frontier_to_p2_ready = P2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_1_clock = clock;
  assign P1_1_reset = reset;
  assign P1_1_io_start = copy_start_io_out_1; // @[pipeline.scala 160:39]
  assign P1_1_io_frontier_value_valid = Frontier_1_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_1_io_frontier_value_bits = Frontier_1_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_1_io_node_num = _T_96; // @[pipeline.scala 162:27]
  assign P1_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 161:39]
  assign P1_1_io_frontier_count_ready = Frontier_1_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_1_io_R_array_index_ready = io_R_array_index_1_ready; // @[pipeline.scala 191:32]
  assign P2_1_clock = clock;
  assign P2_1_reset = reset;
  assign P2_1_io_neighbours_valid = io_p2_in_1_valid; // @[pipeline.scala 200:29]
  assign P2_1_io_neighbours_bits = io_p2_in_1_bits; // @[pipeline.scala 200:29]
  assign P2_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 149:39]
  assign P2_1_io_visited_map_or_frontier_valid = Frontier_1_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_1_io_visited_map_or_frontier_bits = Frontier_1_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_1_io_write_frontier_ready = io_p2_out_1_ready; // @[pipeline.scala 210:39]
  assign P2_1_io_bram_to_frontier_ready = Frontier_1_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_1_clock = clock;
  assign Frontier_1_reset = reset;
  assign Frontier_1_io_frontier_count_valid = P1_1_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_1_io_frontier_count_bits = P1_1_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_1_io_write_frontier_valid = io_frontier_in_1_valid; // @[pipeline.scala 212:39]
  assign Frontier_1_io_write_frontier_bits = io_frontier_in_1_bits; // @[pipeline.scala 212:39]
  assign Frontier_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[pipeline.scala 120:39]
  assign Frontier_1_io_p2_end = copy_p2_end_io_out_1; // @[pipeline.scala 121:39]
  assign Frontier_1_io_start = copy_start_io_out_1; // @[pipeline.scala 122:39]
  assign Frontier_1_io_start_init = copy_start_init_io_out_1; // @[pipeline.scala 123:39]
  assign Frontier_1_io_node_num = _T_23; // @[pipeline.scala 130:33]
  assign Frontier_1_io_push_or_pull_state = copy_push_or_pull_io_out_1; // @[pipeline.scala 129:39]
  assign Frontier_1_io_level = copy_level_io_out_1; // @[pipeline.scala 124:39]
  assign Frontier_1_io_uram_addr_a = io_uram_addr_a_1; // @[pipeline.scala 223:36]
  assign Frontier_1_io_bram_from_p2_valid = P2_1_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_1_io_bram_from_p2_bits = P2_1_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_1_io_root = copy_root_io_out_1; // @[pipeline.scala 132:31]
  assign Frontier_1_io_frontier_value_ready = P1_1_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_1_io_frontier_to_p2_ready = P2_1_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_2_clock = clock;
  assign P1_2_reset = reset;
  assign P1_2_io_start = copy_start_io_out_2; // @[pipeline.scala 160:39]
  assign P1_2_io_frontier_value_valid = Frontier_2_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_2_io_frontier_value_bits = Frontier_2_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_2_io_node_num = _T_107; // @[pipeline.scala 162:27]
  assign P1_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 161:39]
  assign P1_2_io_frontier_count_ready = Frontier_2_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_2_io_R_array_index_ready = io_R_array_index_2_ready; // @[pipeline.scala 191:32]
  assign P2_2_clock = clock;
  assign P2_2_reset = reset;
  assign P2_2_io_neighbours_valid = io_p2_in_2_valid; // @[pipeline.scala 200:29]
  assign P2_2_io_neighbours_bits = io_p2_in_2_bits; // @[pipeline.scala 200:29]
  assign P2_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 149:39]
  assign P2_2_io_visited_map_or_frontier_valid = Frontier_2_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_2_io_visited_map_or_frontier_bits = Frontier_2_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_2_io_write_frontier_ready = io_p2_out_2_ready; // @[pipeline.scala 210:39]
  assign P2_2_io_bram_to_frontier_ready = Frontier_2_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_2_clock = clock;
  assign Frontier_2_reset = reset;
  assign Frontier_2_io_frontier_count_valid = P1_2_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_2_io_frontier_count_bits = P1_2_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_2_io_write_frontier_valid = io_frontier_in_2_valid; // @[pipeline.scala 212:39]
  assign Frontier_2_io_write_frontier_bits = io_frontier_in_2_bits; // @[pipeline.scala 212:39]
  assign Frontier_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[pipeline.scala 120:39]
  assign Frontier_2_io_p2_end = copy_p2_end_io_out_2; // @[pipeline.scala 121:39]
  assign Frontier_2_io_start = copy_start_io_out_2; // @[pipeline.scala 122:39]
  assign Frontier_2_io_start_init = copy_start_init_io_out_2; // @[pipeline.scala 123:39]
  assign Frontier_2_io_node_num = _T_34; // @[pipeline.scala 130:33]
  assign Frontier_2_io_push_or_pull_state = copy_push_or_pull_io_out_2; // @[pipeline.scala 129:39]
  assign Frontier_2_io_level = copy_level_io_out_2; // @[pipeline.scala 124:39]
  assign Frontier_2_io_uram_addr_a = io_uram_addr_a_2; // @[pipeline.scala 223:36]
  assign Frontier_2_io_bram_from_p2_valid = P2_2_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_2_io_bram_from_p2_bits = P2_2_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_2_io_root = copy_root_io_out_2; // @[pipeline.scala 132:31]
  assign Frontier_2_io_frontier_value_ready = P1_2_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_2_io_frontier_to_p2_ready = P2_2_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
  assign P1_3_clock = clock;
  assign P1_3_reset = reset;
  assign P1_3_io_start = copy_start_io_out_3; // @[pipeline.scala 160:39]
  assign P1_3_io_frontier_value_valid = Frontier_3_io_frontier_value_valid; // @[pipeline.scala 185:33]
  assign P1_3_io_frontier_value_bits = Frontier_3_io_frontier_value_bits; // @[pipeline.scala 185:33]
  assign P1_3_io_node_num = _T_118; // @[pipeline.scala 162:27]
  assign P1_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 161:39]
  assign P1_3_io_frontier_count_ready = Frontier_3_io_frontier_count_ready; // @[pipeline.scala 186:33]
  assign P1_3_io_R_array_index_ready = io_R_array_index_3_ready; // @[pipeline.scala 191:32]
  assign P2_3_clock = clock;
  assign P2_3_reset = reset;
  assign P2_3_io_neighbours_valid = io_p2_in_3_valid; // @[pipeline.scala 200:29]
  assign P2_3_io_neighbours_bits = io_p2_in_3_bits; // @[pipeline.scala 200:29]
  assign P2_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 149:39]
  assign P2_3_io_visited_map_or_frontier_valid = Frontier_3_io_frontier_to_p2_valid; // @[pipeline.scala 216:42]
  assign P2_3_io_visited_map_or_frontier_bits = Frontier_3_io_frontier_to_p2_bits; // @[pipeline.scala 216:42]
  assign P2_3_io_write_frontier_ready = io_p2_out_3_ready; // @[pipeline.scala 210:39]
  assign P2_3_io_bram_to_frontier_ready = Frontier_3_io_bram_from_p2_ready; // @[pipeline.scala 215:39]
  assign Frontier_3_clock = clock;
  assign Frontier_3_reset = reset;
  assign Frontier_3_io_frontier_count_valid = P1_3_io_frontier_count_valid; // @[pipeline.scala 186:33]
  assign Frontier_3_io_frontier_count_bits = P1_3_io_frontier_count_bits; // @[pipeline.scala 186:33]
  assign Frontier_3_io_write_frontier_valid = io_frontier_in_3_valid; // @[pipeline.scala 212:39]
  assign Frontier_3_io_write_frontier_bits = io_frontier_in_3_bits; // @[pipeline.scala 212:39]
  assign Frontier_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[pipeline.scala 120:39]
  assign Frontier_3_io_p2_end = copy_p2_end_io_out_3; // @[pipeline.scala 121:39]
  assign Frontier_3_io_start = copy_start_io_out_3; // @[pipeline.scala 122:39]
  assign Frontier_3_io_start_init = copy_start_init_io_out_3; // @[pipeline.scala 123:39]
  assign Frontier_3_io_node_num = _T_45; // @[pipeline.scala 130:33]
  assign Frontier_3_io_push_or_pull_state = copy_push_or_pull_io_out_3; // @[pipeline.scala 129:39]
  assign Frontier_3_io_level = copy_level_io_out_3; // @[pipeline.scala 124:39]
  assign Frontier_3_io_uram_addr_a = io_uram_addr_a_3; // @[pipeline.scala 223:36]
  assign Frontier_3_io_bram_from_p2_valid = P2_3_io_bram_to_frontier_valid; // @[pipeline.scala 215:39]
  assign Frontier_3_io_bram_from_p2_bits = P2_3_io_bram_to_frontier_bits; // @[pipeline.scala 215:39]
  assign Frontier_3_io_root = copy_root_io_out_3; // @[pipeline.scala 132:31]
  assign Frontier_3_io_frontier_value_ready = P1_3_io_frontier_value_ready; // @[pipeline.scala 185:33]
  assign Frontier_3_io_frontier_to_p2_ready = P2_3_io_visited_map_or_frontier_ready; // @[pipeline.scala 216:42]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  _T = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  _T_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  _T_12 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  _T_23 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  _T_34 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  _T_45 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  _T_52 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  _T_56 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  _T_60 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_67 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  _T_74 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_85 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_96 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_107 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_118 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  _T_122 = _RAND_15[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    _T <= io_node_num;
    _T_1 <= io_root;
    _T_12 <= {{7'd0}, _T_10[31:7]};
    _T_23 <= {{7'd0}, _T_21[31:7]};
    _T_34 <= {{7'd0}, _T_32[31:7]};
    _T_45 <= {{7'd0}, _T_43[31:7]};
    _T_52 <= _T_49 + Frontier_3_io_frontier_pull_count;
    _T_56 <= _T_54 & Frontier_3_io_end;
    _T_60 <= _T_58 & Frontier_3_io_last_iteration;
    _T_67 <= _T_64 + P2_3_io_p2_count;
    _T_74 <= _T_71 + P2_3_io_p2_pull_count;
    _T_85 <= {{7'd0}, _T_10[31:7]};
    _T_96 <= {{7'd0}, _T_21[31:7]};
    _T_107 <= {{7'd0}, _T_32[31:7]};
    _T_118 <= {{7'd0}, _T_43[31:7]};
    _T_122 <= _T_120 & P1_3_io_p1_end;
  end
endmodule
module copy_slr2(
  input   clock,
  input   reset,
  input   io_in,
  output  io_out_0,
  output  io_out_1,
  output  io_out_2,
  output  io_out_3,
  output  io_out_4,
  output  io_out_5,
  output  io_out_6,
  output  io_out_7,
  output  io_out_8,
  output  io_out_9,
  output  io_out_10,
  output  io_out_11,
  output  io_out_12,
  output  io_out_13,
  output  io_out_14,
  output  io_out_15,
  output  io_out_16,
  output  io_out_17
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
`endif // RANDOMIZE_REG_INIT
  reg  out_reg_0; // @[master.scala 228:24]
  reg  out_reg_1; // @[master.scala 228:24]
  reg  out_reg_2; // @[master.scala 228:24]
  reg  out_reg_3; // @[master.scala 228:24]
  reg  out_reg_4; // @[master.scala 228:24]
  reg  out_reg_5; // @[master.scala 228:24]
  reg  out_reg_6; // @[master.scala 228:24]
  reg  out_reg_7; // @[master.scala 228:24]
  reg  out_reg_8; // @[master.scala 228:24]
  reg  out_reg_9; // @[master.scala 228:24]
  reg  out_reg_10; // @[master.scala 228:24]
  reg  out_reg_11; // @[master.scala 228:24]
  reg  out_reg_12; // @[master.scala 228:24]
  reg  out_reg_13; // @[master.scala 228:24]
  reg  out_reg_14; // @[master.scala 228:24]
  reg  out_reg_15; // @[master.scala 228:24]
  reg  out_reg_16; // @[master.scala 228:24]
  reg  out_reg_17; // @[master.scala 228:24]
  wire  _T_0 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_1 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_2 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_3 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_4 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_5 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_6 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_7 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_8 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_9 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_10 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_11 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_12 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_13 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_14 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_15 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_16 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  wire  _T_17 = 1'h0; // @[master.scala 228:32 master.scala 228:32]
  assign io_out_0 = out_reg_0; // @[master.scala 233:10]
  assign io_out_1 = out_reg_1; // @[master.scala 233:10]
  assign io_out_2 = out_reg_2; // @[master.scala 233:10]
  assign io_out_3 = out_reg_3; // @[master.scala 233:10]
  assign io_out_4 = out_reg_4; // @[master.scala 233:10]
  assign io_out_5 = out_reg_5; // @[master.scala 233:10]
  assign io_out_6 = out_reg_6; // @[master.scala 233:10]
  assign io_out_7 = out_reg_7; // @[master.scala 233:10]
  assign io_out_8 = out_reg_8; // @[master.scala 233:10]
  assign io_out_9 = out_reg_9; // @[master.scala 233:10]
  assign io_out_10 = out_reg_10; // @[master.scala 233:10]
  assign io_out_11 = out_reg_11; // @[master.scala 233:10]
  assign io_out_12 = out_reg_12; // @[master.scala 233:10]
  assign io_out_13 = out_reg_13; // @[master.scala 233:10]
  assign io_out_14 = out_reg_14; // @[master.scala 233:10]
  assign io_out_15 = out_reg_15; // @[master.scala 233:10]
  assign io_out_16 = out_reg_16; // @[master.scala 233:10]
  assign io_out_17 = out_reg_17; // @[master.scala 233:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  out_reg_14 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  out_reg_15 = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  out_reg_16 = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  out_reg_17 = _RAND_17[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 1'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 1'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 1'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 1'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 1'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 1'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 1'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 1'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 1'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 1'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 1'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 1'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 1'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 1'h0;
    end else begin
      out_reg_13 <= io_in;
    end
    if (reset) begin
      out_reg_14 <= 1'h0;
    end else begin
      out_reg_14 <= io_in;
    end
    if (reset) begin
      out_reg_15 <= 1'h0;
    end else begin
      out_reg_15 <= io_in;
    end
    if (reset) begin
      out_reg_16 <= 1'h0;
    end else begin
      out_reg_16 <= io_in;
    end
    if (reset) begin
      out_reg_17 <= 1'h0;
    end else begin
      out_reg_17 <= io_in;
    end
  end
endmodule
module copy_slr2_2(
  input         clock,
  input         reset,
  input  [31:0] io_in,
  output [31:0] io_out_0,
  output [31:0] io_out_1,
  output [31:0] io_out_2,
  output [31:0] io_out_3,
  output [31:0] io_out_4,
  output [31:0] io_out_5,
  output [31:0] io_out_6,
  output [31:0] io_out_7,
  output [31:0] io_out_8,
  output [31:0] io_out_9,
  output [31:0] io_out_10,
  output [31:0] io_out_11,
  output [31:0] io_out_12,
  output [31:0] io_out_13,
  output [31:0] io_out_14,
  output [31:0] io_out_15,
  output [31:0] io_out_16,
  output [31:0] io_out_17
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] out_reg_0; // @[master.scala 228:24]
  reg [31:0] out_reg_1; // @[master.scala 228:24]
  reg [31:0] out_reg_2; // @[master.scala 228:24]
  reg [31:0] out_reg_3; // @[master.scala 228:24]
  reg [31:0] out_reg_4; // @[master.scala 228:24]
  reg [31:0] out_reg_5; // @[master.scala 228:24]
  reg [31:0] out_reg_6; // @[master.scala 228:24]
  reg [31:0] out_reg_7; // @[master.scala 228:24]
  reg [31:0] out_reg_8; // @[master.scala 228:24]
  reg [31:0] out_reg_9; // @[master.scala 228:24]
  reg [31:0] out_reg_10; // @[master.scala 228:24]
  reg [31:0] out_reg_11; // @[master.scala 228:24]
  reg [31:0] out_reg_12; // @[master.scala 228:24]
  reg [31:0] out_reg_13; // @[master.scala 228:24]
  reg [31:0] out_reg_14; // @[master.scala 228:24]
  reg [31:0] out_reg_15; // @[master.scala 228:24]
  reg [31:0] out_reg_16; // @[master.scala 228:24]
  reg [31:0] out_reg_17; // @[master.scala 228:24]
  wire [31:0] _T_0 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_1 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_2 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_3 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_4 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_5 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_6 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_7 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_8 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_9 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_10 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_11 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_12 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_13 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_14 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_15 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_16 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  wire [31:0] _T_17 = 32'h0; // @[master.scala 228:32 master.scala 228:32]
  assign io_out_0 = out_reg_0; // @[master.scala 233:10]
  assign io_out_1 = out_reg_1; // @[master.scala 233:10]
  assign io_out_2 = out_reg_2; // @[master.scala 233:10]
  assign io_out_3 = out_reg_3; // @[master.scala 233:10]
  assign io_out_4 = out_reg_4; // @[master.scala 233:10]
  assign io_out_5 = out_reg_5; // @[master.scala 233:10]
  assign io_out_6 = out_reg_6; // @[master.scala 233:10]
  assign io_out_7 = out_reg_7; // @[master.scala 233:10]
  assign io_out_8 = out_reg_8; // @[master.scala 233:10]
  assign io_out_9 = out_reg_9; // @[master.scala 233:10]
  assign io_out_10 = out_reg_10; // @[master.scala 233:10]
  assign io_out_11 = out_reg_11; // @[master.scala 233:10]
  assign io_out_12 = out_reg_12; // @[master.scala 233:10]
  assign io_out_13 = out_reg_13; // @[master.scala 233:10]
  assign io_out_14 = out_reg_14; // @[master.scala 233:10]
  assign io_out_15 = out_reg_15; // @[master.scala 233:10]
  assign io_out_16 = out_reg_16; // @[master.scala 233:10]
  assign io_out_17 = out_reg_17; // @[master.scala 233:10]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  out_reg_0 = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  out_reg_1 = _RAND_1[31:0];
  _RAND_2 = {1{`RANDOM}};
  out_reg_2 = _RAND_2[31:0];
  _RAND_3 = {1{`RANDOM}};
  out_reg_3 = _RAND_3[31:0];
  _RAND_4 = {1{`RANDOM}};
  out_reg_4 = _RAND_4[31:0];
  _RAND_5 = {1{`RANDOM}};
  out_reg_5 = _RAND_5[31:0];
  _RAND_6 = {1{`RANDOM}};
  out_reg_6 = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  out_reg_7 = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  out_reg_8 = _RAND_8[31:0];
  _RAND_9 = {1{`RANDOM}};
  out_reg_9 = _RAND_9[31:0];
  _RAND_10 = {1{`RANDOM}};
  out_reg_10 = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  out_reg_11 = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  out_reg_12 = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  out_reg_13 = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  out_reg_14 = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  out_reg_15 = _RAND_15[31:0];
  _RAND_16 = {1{`RANDOM}};
  out_reg_16 = _RAND_16[31:0];
  _RAND_17 = {1{`RANDOM}};
  out_reg_17 = _RAND_17[31:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      out_reg_0 <= 32'h0;
    end else begin
      out_reg_0 <= io_in;
    end
    if (reset) begin
      out_reg_1 <= 32'h0;
    end else begin
      out_reg_1 <= io_in;
    end
    if (reset) begin
      out_reg_2 <= 32'h0;
    end else begin
      out_reg_2 <= io_in;
    end
    if (reset) begin
      out_reg_3 <= 32'h0;
    end else begin
      out_reg_3 <= io_in;
    end
    if (reset) begin
      out_reg_4 <= 32'h0;
    end else begin
      out_reg_4 <= io_in;
    end
    if (reset) begin
      out_reg_5 <= 32'h0;
    end else begin
      out_reg_5 <= io_in;
    end
    if (reset) begin
      out_reg_6 <= 32'h0;
    end else begin
      out_reg_6 <= io_in;
    end
    if (reset) begin
      out_reg_7 <= 32'h0;
    end else begin
      out_reg_7 <= io_in;
    end
    if (reset) begin
      out_reg_8 <= 32'h0;
    end else begin
      out_reg_8 <= io_in;
    end
    if (reset) begin
      out_reg_9 <= 32'h0;
    end else begin
      out_reg_9 <= io_in;
    end
    if (reset) begin
      out_reg_10 <= 32'h0;
    end else begin
      out_reg_10 <= io_in;
    end
    if (reset) begin
      out_reg_11 <= 32'h0;
    end else begin
      out_reg_11 <= io_in;
    end
    if (reset) begin
      out_reg_12 <= 32'h0;
    end else begin
      out_reg_12 <= io_in;
    end
    if (reset) begin
      out_reg_13 <= 32'h0;
    end else begin
      out_reg_13 <= io_in;
    end
    if (reset) begin
      out_reg_14 <= 32'h0;
    end else begin
      out_reg_14 <= io_in;
    end
    if (reset) begin
      out_reg_15 <= 32'h0;
    end else begin
      out_reg_15 <= io_in;
    end
    if (reset) begin
      out_reg_16 <= 32'h0;
    end else begin
      out_reg_16 <= io_in;
    end
    if (reset) begin
      out_reg_17 <= 32'h0;
    end else begin
      out_reg_17 <= io_in;
    end
  end
endmodule
module SLR2(
  input         clock,
  input         reset,
  input         io_p2_end,
  input         io_start,
  input         io_frontier_flag,
  input  [31:0] io_level,
  input  [31:0] io_offsets_CSR_R_offset,
  input  [31:0] io_offsets_CSR_C_offset,
  input  [31:0] io_offsets_CSC_R_offset,
  input  [31:0] io_offsets_CSC_C_offset,
  input  [31:0] io_offsets_level_offset,
  input  [31:0] io_node_num,
  input  [31:0] io_root,
  input         io_push_or_pull,
  input         io_start_init,
  output        io_end_0,
  output        io_end_1,
  output        io_end_2,
  output        io_end_3,
  output        io_end_4,
  output        io_end_5,
  output        io_end_6,
  output        io_end_7,
  output        io_end_8,
  output        io_end_9,
  output        io_end_10,
  output        io_end_11,
  output        io_end_12,
  output        io_end_13,
  output        io_end_14,
  output        io_end_15,
  output        io_end_16,
  output        io_end_17,
  output [31:0] io_p2_count_0,
  output [31:0] io_p2_count_1,
  output [31:0] io_p2_count_2,
  output [31:0] io_p2_count_3,
  output [31:0] io_p2_count_4,
  output [31:0] io_p2_count_5,
  output [31:0] io_p2_count_6,
  output [31:0] io_p2_count_7,
  output [31:0] io_p2_count_8,
  output [31:0] io_p2_count_9,
  output [31:0] io_p2_count_10,
  output [31:0] io_p2_count_11,
  output [31:0] io_p2_count_12,
  output [31:0] io_p2_count_13,
  output [31:0] io_p2_count_14,
  output [31:0] io_p2_count_15,
  output [31:0] io_p2_count_16,
  output [31:0] io_p2_count_17,
  output [31:0] io_p2_pull_count_0,
  output [31:0] io_p2_pull_count_1,
  output [31:0] io_p2_pull_count_2,
  output [31:0] io_p2_pull_count_3,
  output [31:0] io_p2_pull_count_4,
  output [31:0] io_p2_pull_count_5,
  output [31:0] io_p2_pull_count_6,
  output [31:0] io_p2_pull_count_7,
  output [31:0] io_p2_pull_count_8,
  output [31:0] io_p2_pull_count_9,
  output [31:0] io_p2_pull_count_10,
  output [31:0] io_p2_pull_count_11,
  output [31:0] io_p2_pull_count_12,
  output [31:0] io_p2_pull_count_13,
  output [31:0] io_p2_pull_count_14,
  output [31:0] io_p2_pull_count_15,
  output [31:0] io_p2_pull_count_16,
  output [31:0] io_p2_pull_count_17,
  output [31:0] io_frontier_pull_count_0,
  output [31:0] io_frontier_pull_count_1,
  output [31:0] io_frontier_pull_count_2,
  output [31:0] io_frontier_pull_count_3,
  output [31:0] io_frontier_pull_count_4,
  output [31:0] io_frontier_pull_count_5,
  output [31:0] io_frontier_pull_count_6,
  output [31:0] io_frontier_pull_count_7,
  output [31:0] io_frontier_pull_count_8,
  output [31:0] io_frontier_pull_count_9,
  output [31:0] io_frontier_pull_count_10,
  output [31:0] io_frontier_pull_count_11,
  output [31:0] io_frontier_pull_count_12,
  output [31:0] io_frontier_pull_count_13,
  output [31:0] io_frontier_pull_count_14,
  output [31:0] io_frontier_pull_count_15,
  output [31:0] io_frontier_pull_count_16,
  output [31:0] io_frontier_pull_count_17,
  output        io_last_iteration_0,
  output        io_last_iteration_1,
  output        io_last_iteration_2,
  output        io_last_iteration_3,
  output        io_last_iteration_4,
  output        io_last_iteration_5,
  output        io_last_iteration_6,
  output        io_last_iteration_7,
  output        io_last_iteration_8,
  output        io_last_iteration_9,
  output        io_last_iteration_10,
  output        io_last_iteration_11,
  output        io_last_iteration_12,
  output        io_last_iteration_13,
  output        io_last_iteration_14,
  output        io_last_iteration_15,
  output        io_last_iteration_16,
  output        io_last_iteration_17,
  output        io_init_bram_0,
  output        io_init_bram_1,
  output        io_init_bram_2,
  output        io_init_bram_3,
  output        io_init_bram_4,
  output        io_init_bram_5,
  output        io_init_bram_6,
  output        io_init_bram_7,
  output        io_init_bram_8,
  output        io_init_bram_9,
  output        io_init_bram_10,
  output        io_init_bram_11,
  output        io_init_bram_12,
  output        io_init_bram_13,
  output        io_init_bram_14,
  output        io_init_bram_15,
  output        io_init_bram_16,
  output        io_init_bram_17,
  output        io_p2_in_0_ready,
  input         io_p2_in_0_valid,
  input  [63:0] io_p2_in_0_bits,
  output        io_p2_in_1_ready,
  input         io_p2_in_1_valid,
  input  [63:0] io_p2_in_1_bits,
  output        io_p2_in_2_ready,
  input         io_p2_in_2_valid,
  input  [63:0] io_p2_in_2_bits,
  output        io_p2_in_3_ready,
  input         io_p2_in_3_valid,
  input  [63:0] io_p2_in_3_bits,
  output        io_p2_in_4_ready,
  input         io_p2_in_4_valid,
  input  [63:0] io_p2_in_4_bits,
  output        io_p2_in_5_ready,
  input         io_p2_in_5_valid,
  input  [63:0] io_p2_in_5_bits,
  output        io_p2_in_6_ready,
  input         io_p2_in_6_valid,
  input  [63:0] io_p2_in_6_bits,
  output        io_p2_in_7_ready,
  input         io_p2_in_7_valid,
  input  [63:0] io_p2_in_7_bits,
  output        io_p2_in_8_ready,
  input         io_p2_in_8_valid,
  input  [63:0] io_p2_in_8_bits,
  output        io_p2_in_9_ready,
  input         io_p2_in_9_valid,
  input  [63:0] io_p2_in_9_bits,
  output        io_p2_in_10_ready,
  input         io_p2_in_10_valid,
  input  [63:0] io_p2_in_10_bits,
  output        io_p2_in_11_ready,
  input         io_p2_in_11_valid,
  input  [63:0] io_p2_in_11_bits,
  output        io_p2_in_12_ready,
  input         io_p2_in_12_valid,
  input  [63:0] io_p2_in_12_bits,
  output        io_p2_in_13_ready,
  input         io_p2_in_13_valid,
  input  [63:0] io_p2_in_13_bits,
  output        io_p2_in_14_ready,
  input         io_p2_in_14_valid,
  input  [63:0] io_p2_in_14_bits,
  output        io_p2_in_15_ready,
  input         io_p2_in_15_valid,
  input  [63:0] io_p2_in_15_bits,
  output        io_p2_in_16_ready,
  input         io_p2_in_16_valid,
  input  [63:0] io_p2_in_16_bits,
  output        io_p2_in_17_ready,
  input         io_p2_in_17_valid,
  input  [63:0] io_p2_in_17_bits,
  output        io_p2_in_18_ready,
  input         io_p2_in_18_valid,
  input  [63:0] io_p2_in_18_bits,
  output        io_p2_in_19_ready,
  input         io_p2_in_19_valid,
  input  [63:0] io_p2_in_19_bits,
  output        io_p2_in_20_ready,
  input         io_p2_in_20_valid,
  input  [63:0] io_p2_in_20_bits,
  output        io_p2_in_21_ready,
  input         io_p2_in_21_valid,
  input  [63:0] io_p2_in_21_bits,
  output        io_p2_in_22_ready,
  input         io_p2_in_22_valid,
  input  [63:0] io_p2_in_22_bits,
  output        io_p2_in_23_ready,
  input         io_p2_in_23_valid,
  input  [63:0] io_p2_in_23_bits,
  output        io_p2_in_24_ready,
  input         io_p2_in_24_valid,
  input  [63:0] io_p2_in_24_bits,
  output        io_p2_in_25_ready,
  input         io_p2_in_25_valid,
  input  [63:0] io_p2_in_25_bits,
  output        io_p2_in_26_ready,
  input         io_p2_in_26_valid,
  input  [63:0] io_p2_in_26_bits,
  output        io_p2_in_27_ready,
  input         io_p2_in_27_valid,
  input  [63:0] io_p2_in_27_bits,
  output        io_p2_in_28_ready,
  input         io_p2_in_28_valid,
  input  [63:0] io_p2_in_28_bits,
  output        io_p2_in_29_ready,
  input         io_p2_in_29_valid,
  input  [63:0] io_p2_in_29_bits,
  output        io_p2_in_30_ready,
  input         io_p2_in_30_valid,
  input  [63:0] io_p2_in_30_bits,
  output        io_p2_in_31_ready,
  input         io_p2_in_31_valid,
  input  [63:0] io_p2_in_31_bits,
  output        io_p2_in_32_ready,
  input         io_p2_in_32_valid,
  input  [63:0] io_p2_in_32_bits,
  output        io_p2_in_33_ready,
  input         io_p2_in_33_valid,
  input  [63:0] io_p2_in_33_bits,
  output        io_p2_in_34_ready,
  input         io_p2_in_34_valid,
  input  [63:0] io_p2_in_34_bits,
  output        io_p2_in_35_ready,
  input         io_p2_in_35_valid,
  input  [63:0] io_p2_in_35_bits,
  output        io_p2_in_36_ready,
  input         io_p2_in_36_valid,
  input  [63:0] io_p2_in_36_bits,
  output        io_p2_in_37_ready,
  input         io_p2_in_37_valid,
  input  [63:0] io_p2_in_37_bits,
  output        io_p2_in_38_ready,
  input         io_p2_in_38_valid,
  input  [63:0] io_p2_in_38_bits,
  output        io_p2_in_39_ready,
  input         io_p2_in_39_valid,
  input  [63:0] io_p2_in_39_bits,
  output        io_p2_in_40_ready,
  input         io_p2_in_40_valid,
  input  [63:0] io_p2_in_40_bits,
  output        io_p2_in_41_ready,
  input         io_p2_in_41_valid,
  input  [63:0] io_p2_in_41_bits,
  output        io_p2_in_42_ready,
  input         io_p2_in_42_valid,
  input  [63:0] io_p2_in_42_bits,
  output        io_p2_in_43_ready,
  input         io_p2_in_43_valid,
  input  [63:0] io_p2_in_43_bits,
  output        io_p2_in_44_ready,
  input         io_p2_in_44_valid,
  input  [63:0] io_p2_in_44_bits,
  output        io_p2_in_45_ready,
  input         io_p2_in_45_valid,
  input  [63:0] io_p2_in_45_bits,
  output        io_p2_in_46_ready,
  input         io_p2_in_46_valid,
  input  [63:0] io_p2_in_46_bits,
  output        io_p2_in_47_ready,
  input         io_p2_in_47_valid,
  input  [63:0] io_p2_in_47_bits,
  output        io_p2_in_48_ready,
  input         io_p2_in_48_valid,
  input  [63:0] io_p2_in_48_bits,
  output        io_p2_in_49_ready,
  input         io_p2_in_49_valid,
  input  [63:0] io_p2_in_49_bits,
  output        io_p2_in_50_ready,
  input         io_p2_in_50_valid,
  input  [63:0] io_p2_in_50_bits,
  output        io_p2_in_51_ready,
  input         io_p2_in_51_valid,
  input  [63:0] io_p2_in_51_bits,
  output        io_p2_in_52_ready,
  input         io_p2_in_52_valid,
  input  [63:0] io_p2_in_52_bits,
  output        io_p2_in_53_ready,
  input         io_p2_in_53_valid,
  input  [63:0] io_p2_in_53_bits,
  output        io_p2_in_54_ready,
  input         io_p2_in_54_valid,
  input  [63:0] io_p2_in_54_bits,
  output        io_p2_in_55_ready,
  input         io_p2_in_55_valid,
  input  [63:0] io_p2_in_55_bits,
  output        io_p2_in_56_ready,
  input         io_p2_in_56_valid,
  input  [63:0] io_p2_in_56_bits,
  output        io_p2_in_57_ready,
  input         io_p2_in_57_valid,
  input  [63:0] io_p2_in_57_bits,
  output        io_p2_in_58_ready,
  input         io_p2_in_58_valid,
  input  [63:0] io_p2_in_58_bits,
  output        io_p2_in_59_ready,
  input         io_p2_in_59_valid,
  input  [63:0] io_p2_in_59_bits,
  output        io_p2_in_60_ready,
  input         io_p2_in_60_valid,
  input  [63:0] io_p2_in_60_bits,
  output        io_p2_in_61_ready,
  input         io_p2_in_61_valid,
  input  [63:0] io_p2_in_61_bits,
  output        io_p2_in_62_ready,
  input         io_p2_in_62_valid,
  input  [63:0] io_p2_in_62_bits,
  output        io_p2_in_63_ready,
  input         io_p2_in_63_valid,
  input  [63:0] io_p2_in_63_bits,
  output        io_p2_in_64_ready,
  input         io_p2_in_64_valid,
  input  [63:0] io_p2_in_64_bits,
  output        io_p2_in_65_ready,
  input         io_p2_in_65_valid,
  input  [63:0] io_p2_in_65_bits,
  output        io_p2_in_66_ready,
  input         io_p2_in_66_valid,
  input  [63:0] io_p2_in_66_bits,
  output        io_p2_in_67_ready,
  input         io_p2_in_67_valid,
  input  [63:0] io_p2_in_67_bits,
  output        io_p2_in_68_ready,
  input         io_p2_in_68_valid,
  input  [63:0] io_p2_in_68_bits,
  output        io_p2_in_69_ready,
  input         io_p2_in_69_valid,
  input  [63:0] io_p2_in_69_bits,
  output        io_p2_in_70_ready,
  input         io_p2_in_70_valid,
  input  [63:0] io_p2_in_70_bits,
  output        io_p2_in_71_ready,
  input         io_p2_in_71_valid,
  input  [63:0] io_p2_in_71_bits,
  output        io_frontier_in_0_ready,
  input         io_frontier_in_0_valid,
  input  [31:0] io_frontier_in_0_bits,
  output        io_frontier_in_1_ready,
  input         io_frontier_in_1_valid,
  input  [31:0] io_frontier_in_1_bits,
  output        io_frontier_in_2_ready,
  input         io_frontier_in_2_valid,
  input  [31:0] io_frontier_in_2_bits,
  output        io_frontier_in_3_ready,
  input         io_frontier_in_3_valid,
  input  [31:0] io_frontier_in_3_bits,
  output        io_frontier_in_4_ready,
  input         io_frontier_in_4_valid,
  input  [31:0] io_frontier_in_4_bits,
  output        io_frontier_in_5_ready,
  input         io_frontier_in_5_valid,
  input  [31:0] io_frontier_in_5_bits,
  output        io_frontier_in_6_ready,
  input         io_frontier_in_6_valid,
  input  [31:0] io_frontier_in_6_bits,
  output        io_frontier_in_7_ready,
  input         io_frontier_in_7_valid,
  input  [31:0] io_frontier_in_7_bits,
  output        io_frontier_in_8_ready,
  input         io_frontier_in_8_valid,
  input  [31:0] io_frontier_in_8_bits,
  output        io_frontier_in_9_ready,
  input         io_frontier_in_9_valid,
  input  [31:0] io_frontier_in_9_bits,
  output        io_frontier_in_10_ready,
  input         io_frontier_in_10_valid,
  input  [31:0] io_frontier_in_10_bits,
  output        io_frontier_in_11_ready,
  input         io_frontier_in_11_valid,
  input  [31:0] io_frontier_in_11_bits,
  output        io_frontier_in_12_ready,
  input         io_frontier_in_12_valid,
  input  [31:0] io_frontier_in_12_bits,
  output        io_frontier_in_13_ready,
  input         io_frontier_in_13_valid,
  input  [31:0] io_frontier_in_13_bits,
  output        io_frontier_in_14_ready,
  input         io_frontier_in_14_valid,
  input  [31:0] io_frontier_in_14_bits,
  output        io_frontier_in_15_ready,
  input         io_frontier_in_15_valid,
  input  [31:0] io_frontier_in_15_bits,
  output        io_frontier_in_16_ready,
  input         io_frontier_in_16_valid,
  input  [31:0] io_frontier_in_16_bits,
  output        io_frontier_in_17_ready,
  input         io_frontier_in_17_valid,
  input  [31:0] io_frontier_in_17_bits,
  output        io_frontier_in_18_ready,
  input         io_frontier_in_18_valid,
  input  [31:0] io_frontier_in_18_bits,
  output        io_frontier_in_19_ready,
  input         io_frontier_in_19_valid,
  input  [31:0] io_frontier_in_19_bits,
  output        io_frontier_in_20_ready,
  input         io_frontier_in_20_valid,
  input  [31:0] io_frontier_in_20_bits,
  output        io_frontier_in_21_ready,
  input         io_frontier_in_21_valid,
  input  [31:0] io_frontier_in_21_bits,
  output        io_frontier_in_22_ready,
  input         io_frontier_in_22_valid,
  input  [31:0] io_frontier_in_22_bits,
  output        io_frontier_in_23_ready,
  input         io_frontier_in_23_valid,
  input  [31:0] io_frontier_in_23_bits,
  output        io_frontier_in_24_ready,
  input         io_frontier_in_24_valid,
  input  [31:0] io_frontier_in_24_bits,
  output        io_frontier_in_25_ready,
  input         io_frontier_in_25_valid,
  input  [31:0] io_frontier_in_25_bits,
  output        io_frontier_in_26_ready,
  input         io_frontier_in_26_valid,
  input  [31:0] io_frontier_in_26_bits,
  output        io_frontier_in_27_ready,
  input         io_frontier_in_27_valid,
  input  [31:0] io_frontier_in_27_bits,
  output        io_frontier_in_28_ready,
  input         io_frontier_in_28_valid,
  input  [31:0] io_frontier_in_28_bits,
  output        io_frontier_in_29_ready,
  input         io_frontier_in_29_valid,
  input  [31:0] io_frontier_in_29_bits,
  output        io_frontier_in_30_ready,
  input         io_frontier_in_30_valid,
  input  [31:0] io_frontier_in_30_bits,
  output        io_frontier_in_31_ready,
  input         io_frontier_in_31_valid,
  input  [31:0] io_frontier_in_31_bits,
  output        io_frontier_in_32_ready,
  input         io_frontier_in_32_valid,
  input  [31:0] io_frontier_in_32_bits,
  output        io_frontier_in_33_ready,
  input         io_frontier_in_33_valid,
  input  [31:0] io_frontier_in_33_bits,
  output        io_frontier_in_34_ready,
  input         io_frontier_in_34_valid,
  input  [31:0] io_frontier_in_34_bits,
  output        io_frontier_in_35_ready,
  input         io_frontier_in_35_valid,
  input  [31:0] io_frontier_in_35_bits,
  output        io_frontier_in_36_ready,
  input         io_frontier_in_36_valid,
  input  [31:0] io_frontier_in_36_bits,
  output        io_frontier_in_37_ready,
  input         io_frontier_in_37_valid,
  input  [31:0] io_frontier_in_37_bits,
  output        io_frontier_in_38_ready,
  input         io_frontier_in_38_valid,
  input  [31:0] io_frontier_in_38_bits,
  output        io_frontier_in_39_ready,
  input         io_frontier_in_39_valid,
  input  [31:0] io_frontier_in_39_bits,
  output        io_frontier_in_40_ready,
  input         io_frontier_in_40_valid,
  input  [31:0] io_frontier_in_40_bits,
  output        io_frontier_in_41_ready,
  input         io_frontier_in_41_valid,
  input  [31:0] io_frontier_in_41_bits,
  output        io_frontier_in_42_ready,
  input         io_frontier_in_42_valid,
  input  [31:0] io_frontier_in_42_bits,
  output        io_frontier_in_43_ready,
  input         io_frontier_in_43_valid,
  input  [31:0] io_frontier_in_43_bits,
  output        io_frontier_in_44_ready,
  input         io_frontier_in_44_valid,
  input  [31:0] io_frontier_in_44_bits,
  output        io_frontier_in_45_ready,
  input         io_frontier_in_45_valid,
  input  [31:0] io_frontier_in_45_bits,
  output        io_frontier_in_46_ready,
  input         io_frontier_in_46_valid,
  input  [31:0] io_frontier_in_46_bits,
  output        io_frontier_in_47_ready,
  input         io_frontier_in_47_valid,
  input  [31:0] io_frontier_in_47_bits,
  output        io_frontier_in_48_ready,
  input         io_frontier_in_48_valid,
  input  [31:0] io_frontier_in_48_bits,
  output        io_frontier_in_49_ready,
  input         io_frontier_in_49_valid,
  input  [31:0] io_frontier_in_49_bits,
  output        io_frontier_in_50_ready,
  input         io_frontier_in_50_valid,
  input  [31:0] io_frontier_in_50_bits,
  output        io_frontier_in_51_ready,
  input         io_frontier_in_51_valid,
  input  [31:0] io_frontier_in_51_bits,
  output        io_frontier_in_52_ready,
  input         io_frontier_in_52_valid,
  input  [31:0] io_frontier_in_52_bits,
  output        io_frontier_in_53_ready,
  input         io_frontier_in_53_valid,
  input  [31:0] io_frontier_in_53_bits,
  output        io_frontier_in_54_ready,
  input         io_frontier_in_54_valid,
  input  [31:0] io_frontier_in_54_bits,
  output        io_frontier_in_55_ready,
  input         io_frontier_in_55_valid,
  input  [31:0] io_frontier_in_55_bits,
  output        io_frontier_in_56_ready,
  input         io_frontier_in_56_valid,
  input  [31:0] io_frontier_in_56_bits,
  output        io_frontier_in_57_ready,
  input         io_frontier_in_57_valid,
  input  [31:0] io_frontier_in_57_bits,
  output        io_frontier_in_58_ready,
  input         io_frontier_in_58_valid,
  input  [31:0] io_frontier_in_58_bits,
  output        io_frontier_in_59_ready,
  input         io_frontier_in_59_valid,
  input  [31:0] io_frontier_in_59_bits,
  output        io_frontier_in_60_ready,
  input         io_frontier_in_60_valid,
  input  [31:0] io_frontier_in_60_bits,
  output        io_frontier_in_61_ready,
  input         io_frontier_in_61_valid,
  input  [31:0] io_frontier_in_61_bits,
  output        io_frontier_in_62_ready,
  input         io_frontier_in_62_valid,
  input  [31:0] io_frontier_in_62_bits,
  output        io_frontier_in_63_ready,
  input         io_frontier_in_63_valid,
  input  [31:0] io_frontier_in_63_bits,
  output        io_frontier_in_64_ready,
  input         io_frontier_in_64_valid,
  input  [31:0] io_frontier_in_64_bits,
  output        io_frontier_in_65_ready,
  input         io_frontier_in_65_valid,
  input  [31:0] io_frontier_in_65_bits,
  output        io_frontier_in_66_ready,
  input         io_frontier_in_66_valid,
  input  [31:0] io_frontier_in_66_bits,
  output        io_frontier_in_67_ready,
  input         io_frontier_in_67_valid,
  input  [31:0] io_frontier_in_67_bits,
  output        io_frontier_in_68_ready,
  input         io_frontier_in_68_valid,
  input  [31:0] io_frontier_in_68_bits,
  output        io_frontier_in_69_ready,
  input         io_frontier_in_69_valid,
  input  [31:0] io_frontier_in_69_bits,
  output        io_frontier_in_70_ready,
  input         io_frontier_in_70_valid,
  input  [31:0] io_frontier_in_70_bits,
  output        io_frontier_in_71_ready,
  input         io_frontier_in_71_valid,
  input  [31:0] io_frontier_in_71_bits,
  input         io_p2_out_0_ready,
  output        io_p2_out_0_valid,
  output [31:0] io_p2_out_0_bits,
  input         io_p2_out_1_ready,
  output        io_p2_out_1_valid,
  output [31:0] io_p2_out_1_bits,
  input         io_p2_out_2_ready,
  output        io_p2_out_2_valid,
  output [31:0] io_p2_out_2_bits,
  input         io_p2_out_3_ready,
  output        io_p2_out_3_valid,
  output [31:0] io_p2_out_3_bits,
  input         io_p2_out_4_ready,
  output        io_p2_out_4_valid,
  output [31:0] io_p2_out_4_bits,
  input         io_p2_out_5_ready,
  output        io_p2_out_5_valid,
  output [31:0] io_p2_out_5_bits,
  input         io_p2_out_6_ready,
  output        io_p2_out_6_valid,
  output [31:0] io_p2_out_6_bits,
  input         io_p2_out_7_ready,
  output        io_p2_out_7_valid,
  output [31:0] io_p2_out_7_bits,
  input         io_p2_out_8_ready,
  output        io_p2_out_8_valid,
  output [31:0] io_p2_out_8_bits,
  input         io_p2_out_9_ready,
  output        io_p2_out_9_valid,
  output [31:0] io_p2_out_9_bits,
  input         io_p2_out_10_ready,
  output        io_p2_out_10_valid,
  output [31:0] io_p2_out_10_bits,
  input         io_p2_out_11_ready,
  output        io_p2_out_11_valid,
  output [31:0] io_p2_out_11_bits,
  input         io_p2_out_12_ready,
  output        io_p2_out_12_valid,
  output [31:0] io_p2_out_12_bits,
  input         io_p2_out_13_ready,
  output        io_p2_out_13_valid,
  output [31:0] io_p2_out_13_bits,
  input         io_p2_out_14_ready,
  output        io_p2_out_14_valid,
  output [31:0] io_p2_out_14_bits,
  input         io_p2_out_15_ready,
  output        io_p2_out_15_valid,
  output [31:0] io_p2_out_15_bits,
  input         io_p2_out_16_ready,
  output        io_p2_out_16_valid,
  output [31:0] io_p2_out_16_bits,
  input         io_p2_out_17_ready,
  output        io_p2_out_17_valid,
  output [31:0] io_p2_out_17_bits,
  input         io_p2_out_18_ready,
  output        io_p2_out_18_valid,
  output [31:0] io_p2_out_18_bits,
  input         io_p2_out_19_ready,
  output        io_p2_out_19_valid,
  output [31:0] io_p2_out_19_bits,
  input         io_p2_out_20_ready,
  output        io_p2_out_20_valid,
  output [31:0] io_p2_out_20_bits,
  input         io_p2_out_21_ready,
  output        io_p2_out_21_valid,
  output [31:0] io_p2_out_21_bits,
  input         io_p2_out_22_ready,
  output        io_p2_out_22_valid,
  output [31:0] io_p2_out_22_bits,
  input         io_p2_out_23_ready,
  output        io_p2_out_23_valid,
  output [31:0] io_p2_out_23_bits,
  input         io_p2_out_24_ready,
  output        io_p2_out_24_valid,
  output [31:0] io_p2_out_24_bits,
  input         io_p2_out_25_ready,
  output        io_p2_out_25_valid,
  output [31:0] io_p2_out_25_bits,
  input         io_p2_out_26_ready,
  output        io_p2_out_26_valid,
  output [31:0] io_p2_out_26_bits,
  input         io_p2_out_27_ready,
  output        io_p2_out_27_valid,
  output [31:0] io_p2_out_27_bits,
  input         io_p2_out_28_ready,
  output        io_p2_out_28_valid,
  output [31:0] io_p2_out_28_bits,
  input         io_p2_out_29_ready,
  output        io_p2_out_29_valid,
  output [31:0] io_p2_out_29_bits,
  input         io_p2_out_30_ready,
  output        io_p2_out_30_valid,
  output [31:0] io_p2_out_30_bits,
  input         io_p2_out_31_ready,
  output        io_p2_out_31_valid,
  output [31:0] io_p2_out_31_bits,
  input         io_p2_out_32_ready,
  output        io_p2_out_32_valid,
  output [31:0] io_p2_out_32_bits,
  input         io_p2_out_33_ready,
  output        io_p2_out_33_valid,
  output [31:0] io_p2_out_33_bits,
  input         io_p2_out_34_ready,
  output        io_p2_out_34_valid,
  output [31:0] io_p2_out_34_bits,
  input         io_p2_out_35_ready,
  output        io_p2_out_35_valid,
  output [31:0] io_p2_out_35_bits,
  input         io_p2_out_36_ready,
  output        io_p2_out_36_valid,
  output [31:0] io_p2_out_36_bits,
  input         io_p2_out_37_ready,
  output        io_p2_out_37_valid,
  output [31:0] io_p2_out_37_bits,
  input         io_p2_out_38_ready,
  output        io_p2_out_38_valid,
  output [31:0] io_p2_out_38_bits,
  input         io_p2_out_39_ready,
  output        io_p2_out_39_valid,
  output [31:0] io_p2_out_39_bits,
  input         io_p2_out_40_ready,
  output        io_p2_out_40_valid,
  output [31:0] io_p2_out_40_bits,
  input         io_p2_out_41_ready,
  output        io_p2_out_41_valid,
  output [31:0] io_p2_out_41_bits,
  input         io_p2_out_42_ready,
  output        io_p2_out_42_valid,
  output [31:0] io_p2_out_42_bits,
  input         io_p2_out_43_ready,
  output        io_p2_out_43_valid,
  output [31:0] io_p2_out_43_bits,
  input         io_p2_out_44_ready,
  output        io_p2_out_44_valid,
  output [31:0] io_p2_out_44_bits,
  input         io_p2_out_45_ready,
  output        io_p2_out_45_valid,
  output [31:0] io_p2_out_45_bits,
  input         io_p2_out_46_ready,
  output        io_p2_out_46_valid,
  output [31:0] io_p2_out_46_bits,
  input         io_p2_out_47_ready,
  output        io_p2_out_47_valid,
  output [31:0] io_p2_out_47_bits,
  input         io_p2_out_48_ready,
  output        io_p2_out_48_valid,
  output [31:0] io_p2_out_48_bits,
  input         io_p2_out_49_ready,
  output        io_p2_out_49_valid,
  output [31:0] io_p2_out_49_bits,
  input         io_p2_out_50_ready,
  output        io_p2_out_50_valid,
  output [31:0] io_p2_out_50_bits,
  input         io_p2_out_51_ready,
  output        io_p2_out_51_valid,
  output [31:0] io_p2_out_51_bits,
  input         io_p2_out_52_ready,
  output        io_p2_out_52_valid,
  output [31:0] io_p2_out_52_bits,
  input         io_p2_out_53_ready,
  output        io_p2_out_53_valid,
  output [31:0] io_p2_out_53_bits,
  input         io_p2_out_54_ready,
  output        io_p2_out_54_valid,
  output [31:0] io_p2_out_54_bits,
  input         io_p2_out_55_ready,
  output        io_p2_out_55_valid,
  output [31:0] io_p2_out_55_bits,
  input         io_p2_out_56_ready,
  output        io_p2_out_56_valid,
  output [31:0] io_p2_out_56_bits,
  input         io_p2_out_57_ready,
  output        io_p2_out_57_valid,
  output [31:0] io_p2_out_57_bits,
  input         io_p2_out_58_ready,
  output        io_p2_out_58_valid,
  output [31:0] io_p2_out_58_bits,
  input         io_p2_out_59_ready,
  output        io_p2_out_59_valid,
  output [31:0] io_p2_out_59_bits,
  input         io_p2_out_60_ready,
  output        io_p2_out_60_valid,
  output [31:0] io_p2_out_60_bits,
  input         io_p2_out_61_ready,
  output        io_p2_out_61_valid,
  output [31:0] io_p2_out_61_bits,
  input         io_p2_out_62_ready,
  output        io_p2_out_62_valid,
  output [31:0] io_p2_out_62_bits,
  input         io_p2_out_63_ready,
  output        io_p2_out_63_valid,
  output [31:0] io_p2_out_63_bits,
  input         io_p2_out_64_ready,
  output        io_p2_out_64_valid,
  output [31:0] io_p2_out_64_bits,
  input         io_p2_out_65_ready,
  output        io_p2_out_65_valid,
  output [31:0] io_p2_out_65_bits,
  input         io_p2_out_66_ready,
  output        io_p2_out_66_valid,
  output [31:0] io_p2_out_66_bits,
  input         io_p2_out_67_ready,
  output        io_p2_out_67_valid,
  output [31:0] io_p2_out_67_bits,
  input         io_p2_out_68_ready,
  output        io_p2_out_68_valid,
  output [31:0] io_p2_out_68_bits,
  input         io_p2_out_69_ready,
  output        io_p2_out_69_valid,
  output [31:0] io_p2_out_69_bits,
  input         io_p2_out_70_ready,
  output        io_p2_out_70_valid,
  output [31:0] io_p2_out_70_bits,
  input         io_p2_out_71_ready,
  output        io_p2_out_71_valid,
  output [31:0] io_p2_out_71_bits,
  input         io_R_array_index_0_ready,
  output        io_R_array_index_0_valid,
  output [31:0] io_R_array_index_0_bits,
  input         io_R_array_index_1_ready,
  output        io_R_array_index_1_valid,
  output [31:0] io_R_array_index_1_bits,
  input         io_R_array_index_2_ready,
  output        io_R_array_index_2_valid,
  output [31:0] io_R_array_index_2_bits,
  input         io_R_array_index_3_ready,
  output        io_R_array_index_3_valid,
  output [31:0] io_R_array_index_3_bits,
  input         io_R_array_index_4_ready,
  output        io_R_array_index_4_valid,
  output [31:0] io_R_array_index_4_bits,
  input         io_R_array_index_5_ready,
  output        io_R_array_index_5_valid,
  output [31:0] io_R_array_index_5_bits,
  input         io_R_array_index_6_ready,
  output        io_R_array_index_6_valid,
  output [31:0] io_R_array_index_6_bits,
  input         io_R_array_index_7_ready,
  output        io_R_array_index_7_valid,
  output [31:0] io_R_array_index_7_bits,
  input         io_R_array_index_8_ready,
  output        io_R_array_index_8_valid,
  output [31:0] io_R_array_index_8_bits,
  input         io_R_array_index_9_ready,
  output        io_R_array_index_9_valid,
  output [31:0] io_R_array_index_9_bits,
  input         io_R_array_index_10_ready,
  output        io_R_array_index_10_valid,
  output [31:0] io_R_array_index_10_bits,
  input         io_R_array_index_11_ready,
  output        io_R_array_index_11_valid,
  output [31:0] io_R_array_index_11_bits,
  input         io_R_array_index_12_ready,
  output        io_R_array_index_12_valid,
  output [31:0] io_R_array_index_12_bits,
  input         io_R_array_index_13_ready,
  output        io_R_array_index_13_valid,
  output [31:0] io_R_array_index_13_bits,
  input         io_R_array_index_14_ready,
  output        io_R_array_index_14_valid,
  output [31:0] io_R_array_index_14_bits,
  input         io_R_array_index_15_ready,
  output        io_R_array_index_15_valid,
  output [31:0] io_R_array_index_15_bits,
  input         io_R_array_index_16_ready,
  output        io_R_array_index_16_valid,
  output [31:0] io_R_array_index_16_bits,
  input         io_R_array_index_17_ready,
  output        io_R_array_index_17_valid,
  output [31:0] io_R_array_index_17_bits,
  input         io_R_array_index_18_ready,
  output        io_R_array_index_18_valid,
  output [31:0] io_R_array_index_18_bits,
  input         io_R_array_index_19_ready,
  output        io_R_array_index_19_valid,
  output [31:0] io_R_array_index_19_bits,
  input         io_R_array_index_20_ready,
  output        io_R_array_index_20_valid,
  output [31:0] io_R_array_index_20_bits,
  input         io_R_array_index_21_ready,
  output        io_R_array_index_21_valid,
  output [31:0] io_R_array_index_21_bits,
  input         io_R_array_index_22_ready,
  output        io_R_array_index_22_valid,
  output [31:0] io_R_array_index_22_bits,
  input         io_R_array_index_23_ready,
  output        io_R_array_index_23_valid,
  output [31:0] io_R_array_index_23_bits,
  input         io_R_array_index_24_ready,
  output        io_R_array_index_24_valid,
  output [31:0] io_R_array_index_24_bits,
  input         io_R_array_index_25_ready,
  output        io_R_array_index_25_valid,
  output [31:0] io_R_array_index_25_bits,
  input         io_R_array_index_26_ready,
  output        io_R_array_index_26_valid,
  output [31:0] io_R_array_index_26_bits,
  input         io_R_array_index_27_ready,
  output        io_R_array_index_27_valid,
  output [31:0] io_R_array_index_27_bits,
  input         io_R_array_index_28_ready,
  output        io_R_array_index_28_valid,
  output [31:0] io_R_array_index_28_bits,
  input         io_R_array_index_29_ready,
  output        io_R_array_index_29_valid,
  output [31:0] io_R_array_index_29_bits,
  input         io_R_array_index_30_ready,
  output        io_R_array_index_30_valid,
  output [31:0] io_R_array_index_30_bits,
  input         io_R_array_index_31_ready,
  output        io_R_array_index_31_valid,
  output [31:0] io_R_array_index_31_bits,
  input         io_R_array_index_32_ready,
  output        io_R_array_index_32_valid,
  output [31:0] io_R_array_index_32_bits,
  input         io_R_array_index_33_ready,
  output        io_R_array_index_33_valid,
  output [31:0] io_R_array_index_33_bits,
  input         io_R_array_index_34_ready,
  output        io_R_array_index_34_valid,
  output [31:0] io_R_array_index_34_bits,
  input         io_R_array_index_35_ready,
  output        io_R_array_index_35_valid,
  output [31:0] io_R_array_index_35_bits,
  input         io_R_array_index_36_ready,
  output        io_R_array_index_36_valid,
  output [31:0] io_R_array_index_36_bits,
  input         io_R_array_index_37_ready,
  output        io_R_array_index_37_valid,
  output [31:0] io_R_array_index_37_bits,
  input         io_R_array_index_38_ready,
  output        io_R_array_index_38_valid,
  output [31:0] io_R_array_index_38_bits,
  input         io_R_array_index_39_ready,
  output        io_R_array_index_39_valid,
  output [31:0] io_R_array_index_39_bits,
  input         io_R_array_index_40_ready,
  output        io_R_array_index_40_valid,
  output [31:0] io_R_array_index_40_bits,
  input         io_R_array_index_41_ready,
  output        io_R_array_index_41_valid,
  output [31:0] io_R_array_index_41_bits,
  input         io_R_array_index_42_ready,
  output        io_R_array_index_42_valid,
  output [31:0] io_R_array_index_42_bits,
  input         io_R_array_index_43_ready,
  output        io_R_array_index_43_valid,
  output [31:0] io_R_array_index_43_bits,
  input         io_R_array_index_44_ready,
  output        io_R_array_index_44_valid,
  output [31:0] io_R_array_index_44_bits,
  input         io_R_array_index_45_ready,
  output        io_R_array_index_45_valid,
  output [31:0] io_R_array_index_45_bits,
  input         io_R_array_index_46_ready,
  output        io_R_array_index_46_valid,
  output [31:0] io_R_array_index_46_bits,
  input         io_R_array_index_47_ready,
  output        io_R_array_index_47_valid,
  output [31:0] io_R_array_index_47_bits,
  input         io_R_array_index_48_ready,
  output        io_R_array_index_48_valid,
  output [31:0] io_R_array_index_48_bits,
  input         io_R_array_index_49_ready,
  output        io_R_array_index_49_valid,
  output [31:0] io_R_array_index_49_bits,
  input         io_R_array_index_50_ready,
  output        io_R_array_index_50_valid,
  output [31:0] io_R_array_index_50_bits,
  input         io_R_array_index_51_ready,
  output        io_R_array_index_51_valid,
  output [31:0] io_R_array_index_51_bits,
  input         io_R_array_index_52_ready,
  output        io_R_array_index_52_valid,
  output [31:0] io_R_array_index_52_bits,
  input         io_R_array_index_53_ready,
  output        io_R_array_index_53_valid,
  output [31:0] io_R_array_index_53_bits,
  input         io_R_array_index_54_ready,
  output        io_R_array_index_54_valid,
  output [31:0] io_R_array_index_54_bits,
  input         io_R_array_index_55_ready,
  output        io_R_array_index_55_valid,
  output [31:0] io_R_array_index_55_bits,
  input         io_R_array_index_56_ready,
  output        io_R_array_index_56_valid,
  output [31:0] io_R_array_index_56_bits,
  input         io_R_array_index_57_ready,
  output        io_R_array_index_57_valid,
  output [31:0] io_R_array_index_57_bits,
  input         io_R_array_index_58_ready,
  output        io_R_array_index_58_valid,
  output [31:0] io_R_array_index_58_bits,
  input         io_R_array_index_59_ready,
  output        io_R_array_index_59_valid,
  output [31:0] io_R_array_index_59_bits,
  input         io_R_array_index_60_ready,
  output        io_R_array_index_60_valid,
  output [31:0] io_R_array_index_60_bits,
  input         io_R_array_index_61_ready,
  output        io_R_array_index_61_valid,
  output [31:0] io_R_array_index_61_bits,
  input         io_R_array_index_62_ready,
  output        io_R_array_index_62_valid,
  output [31:0] io_R_array_index_62_bits,
  input         io_R_array_index_63_ready,
  output        io_R_array_index_63_valid,
  output [31:0] io_R_array_index_63_bits,
  input         io_R_array_index_64_ready,
  output        io_R_array_index_64_valid,
  output [31:0] io_R_array_index_64_bits,
  input         io_R_array_index_65_ready,
  output        io_R_array_index_65_valid,
  output [31:0] io_R_array_index_65_bits,
  input         io_R_array_index_66_ready,
  output        io_R_array_index_66_valid,
  output [31:0] io_R_array_index_66_bits,
  input         io_R_array_index_67_ready,
  output        io_R_array_index_67_valid,
  output [31:0] io_R_array_index_67_bits,
  input         io_R_array_index_68_ready,
  output        io_R_array_index_68_valid,
  output [31:0] io_R_array_index_68_bits,
  input         io_R_array_index_69_ready,
  output        io_R_array_index_69_valid,
  output [31:0] io_R_array_index_69_bits,
  input         io_R_array_index_70_ready,
  output        io_R_array_index_70_valid,
  output [31:0] io_R_array_index_70_bits,
  input         io_R_array_index_71_ready,
  output        io_R_array_index_71_valid,
  output [31:0] io_R_array_index_71_bits,
  output        io_p1_end_0,
  output        io_p1_end_1,
  output        io_p1_end_2,
  output        io_p1_end_3,
  output        io_p1_end_4,
  output        io_p1_end_5,
  output        io_p1_end_6,
  output        io_p1_end_7,
  output        io_p1_end_8,
  output        io_p1_end_9,
  output        io_p1_end_10,
  output        io_p1_end_11,
  output        io_p1_end_12,
  output        io_p1_end_13,
  output        io_p1_end_14,
  output        io_p1_end_15,
  output        io_p1_end_16,
  output        io_p1_end_17,
  output [63:0] io_uram_out_a_0,
  output [63:0] io_uram_out_a_1,
  output [63:0] io_uram_out_a_2,
  output [63:0] io_uram_out_a_3,
  output [63:0] io_uram_out_a_4,
  output [63:0] io_uram_out_a_5,
  output [63:0] io_uram_out_a_6,
  output [63:0] io_uram_out_a_7,
  output [63:0] io_uram_out_a_8,
  output [63:0] io_uram_out_a_9,
  output [63:0] io_uram_out_a_10,
  output [63:0] io_uram_out_a_11,
  output [63:0] io_uram_out_a_12,
  output [63:0] io_uram_out_a_13,
  output [63:0] io_uram_out_a_14,
  output [63:0] io_uram_out_a_15,
  output [63:0] io_uram_out_a_16,
  output [63:0] io_uram_out_a_17,
  output [63:0] io_uram_out_a_18,
  output [63:0] io_uram_out_a_19,
  output [63:0] io_uram_out_a_20,
  output [63:0] io_uram_out_a_21,
  output [63:0] io_uram_out_a_22,
  output [63:0] io_uram_out_a_23,
  output [63:0] io_uram_out_a_24,
  output [63:0] io_uram_out_a_25,
  output [63:0] io_uram_out_a_26,
  output [63:0] io_uram_out_a_27,
  output [63:0] io_uram_out_a_28,
  output [63:0] io_uram_out_a_29,
  output [63:0] io_uram_out_a_30,
  output [63:0] io_uram_out_a_31,
  output [63:0] io_uram_out_a_32,
  output [63:0] io_uram_out_a_33,
  output [63:0] io_uram_out_a_34,
  output [63:0] io_uram_out_a_35,
  output [63:0] io_uram_out_a_36,
  output [63:0] io_uram_out_a_37,
  output [63:0] io_uram_out_a_38,
  output [63:0] io_uram_out_a_39,
  output [63:0] io_uram_out_a_40,
  output [63:0] io_uram_out_a_41,
  output [63:0] io_uram_out_a_42,
  output [63:0] io_uram_out_a_43,
  output [63:0] io_uram_out_a_44,
  output [63:0] io_uram_out_a_45,
  output [63:0] io_uram_out_a_46,
  output [63:0] io_uram_out_a_47,
  output [63:0] io_uram_out_a_48,
  output [63:0] io_uram_out_a_49,
  output [63:0] io_uram_out_a_50,
  output [63:0] io_uram_out_a_51,
  output [63:0] io_uram_out_a_52,
  output [63:0] io_uram_out_a_53,
  output [63:0] io_uram_out_a_54,
  output [63:0] io_uram_out_a_55,
  output [63:0] io_uram_out_a_56,
  output [63:0] io_uram_out_a_57,
  output [63:0] io_uram_out_a_58,
  output [63:0] io_uram_out_a_59,
  output [63:0] io_uram_out_a_60,
  output [63:0] io_uram_out_a_61,
  output [63:0] io_uram_out_a_62,
  output [63:0] io_uram_out_a_63,
  output [63:0] io_uram_out_a_64,
  output [63:0] io_uram_out_a_65,
  output [63:0] io_uram_out_a_66,
  output [63:0] io_uram_out_a_67,
  output [63:0] io_uram_out_a_68,
  output [63:0] io_uram_out_a_69,
  output [63:0] io_uram_out_a_70,
  output [63:0] io_uram_out_a_71,
  input  [19:0] io_uram_addr_a_0,
  input  [19:0] io_uram_addr_a_1,
  input  [19:0] io_uram_addr_a_2,
  input  [19:0] io_uram_addr_a_3,
  input  [19:0] io_uram_addr_a_4,
  input  [19:0] io_uram_addr_a_5,
  input  [19:0] io_uram_addr_a_6,
  input  [19:0] io_uram_addr_a_7,
  input  [19:0] io_uram_addr_a_8,
  input  [19:0] io_uram_addr_a_9,
  input  [19:0] io_uram_addr_a_10,
  input  [19:0] io_uram_addr_a_11,
  input  [19:0] io_uram_addr_a_12,
  input  [19:0] io_uram_addr_a_13,
  input  [19:0] io_uram_addr_a_14,
  input  [19:0] io_uram_addr_a_15,
  input  [19:0] io_uram_addr_a_16,
  input  [19:0] io_uram_addr_a_17,
  input  [19:0] io_uram_addr_a_18,
  input  [19:0] io_uram_addr_a_19,
  input  [19:0] io_uram_addr_a_20,
  input  [19:0] io_uram_addr_a_21,
  input  [19:0] io_uram_addr_a_22,
  input  [19:0] io_uram_addr_a_23,
  input  [19:0] io_uram_addr_a_24,
  input  [19:0] io_uram_addr_a_25,
  input  [19:0] io_uram_addr_a_26,
  input  [19:0] io_uram_addr_a_27,
  input  [19:0] io_uram_addr_a_28,
  input  [19:0] io_uram_addr_a_29,
  input  [19:0] io_uram_addr_a_30,
  input  [19:0] io_uram_addr_a_31,
  input  [19:0] io_uram_addr_a_32,
  input  [19:0] io_uram_addr_a_33,
  input  [19:0] io_uram_addr_a_34,
  input  [19:0] io_uram_addr_a_35,
  input  [19:0] io_uram_addr_a_36,
  input  [19:0] io_uram_addr_a_37,
  input  [19:0] io_uram_addr_a_38,
  input  [19:0] io_uram_addr_a_39,
  input  [19:0] io_uram_addr_a_40,
  input  [19:0] io_uram_addr_a_41,
  input  [19:0] io_uram_addr_a_42,
  input  [19:0] io_uram_addr_a_43,
  input  [19:0] io_uram_addr_a_44,
  input  [19:0] io_uram_addr_a_45,
  input  [19:0] io_uram_addr_a_46,
  input  [19:0] io_uram_addr_a_47,
  input  [19:0] io_uram_addr_a_48,
  input  [19:0] io_uram_addr_a_49,
  input  [19:0] io_uram_addr_a_50,
  input  [19:0] io_uram_addr_a_51,
  input  [19:0] io_uram_addr_a_52,
  input  [19:0] io_uram_addr_a_53,
  input  [19:0] io_uram_addr_a_54,
  input  [19:0] io_uram_addr_a_55,
  input  [19:0] io_uram_addr_a_56,
  input  [19:0] io_uram_addr_a_57,
  input  [19:0] io_uram_addr_a_58,
  input  [19:0] io_uram_addr_a_59,
  input  [19:0] io_uram_addr_a_60,
  input  [19:0] io_uram_addr_a_61,
  input  [19:0] io_uram_addr_a_62,
  input  [19:0] io_uram_addr_a_63,
  input  [19:0] io_uram_addr_a_64,
  input  [19:0] io_uram_addr_a_65,
  input  [19:0] io_uram_addr_a_66,
  input  [19:0] io_uram_addr_a_67,
  input  [19:0] io_uram_addr_a_68,
  input  [19:0] io_uram_addr_a_69,
  input  [19:0] io_uram_addr_a_70,
  input  [19:0] io_uram_addr_a_71
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
  reg [31:0] _RAND_32;
  reg [31:0] _RAND_33;
  reg [31:0] _RAND_34;
  reg [31:0] _RAND_35;
  reg [31:0] _RAND_36;
  reg [31:0] _RAND_37;
  reg [31:0] _RAND_38;
  reg [31:0] _RAND_39;
  reg [31:0] _RAND_40;
  reg [31:0] _RAND_41;
  reg [31:0] _RAND_42;
  reg [31:0] _RAND_43;
  reg [31:0] _RAND_44;
  reg [31:0] _RAND_45;
  reg [31:0] _RAND_46;
  reg [31:0] _RAND_47;
  reg [31:0] _RAND_48;
  reg [31:0] _RAND_49;
  reg [31:0] _RAND_50;
  reg [31:0] _RAND_51;
  reg [31:0] _RAND_52;
  reg [31:0] _RAND_53;
  reg [31:0] _RAND_54;
  reg [31:0] _RAND_55;
  reg [31:0] _RAND_56;
  reg [31:0] _RAND_57;
  reg [31:0] _RAND_58;
  reg [31:0] _RAND_59;
  reg [31:0] _RAND_60;
  reg [31:0] _RAND_61;
  reg [31:0] _RAND_62;
  reg [31:0] _RAND_63;
  reg [31:0] _RAND_64;
  reg [31:0] _RAND_65;
  reg [31:0] _RAND_66;
  reg [31:0] _RAND_67;
  reg [31:0] _RAND_68;
  reg [31:0] _RAND_69;
  reg [31:0] _RAND_70;
  reg [31:0] _RAND_71;
  reg [31:0] _RAND_72;
  reg [31:0] _RAND_73;
  reg [31:0] _RAND_74;
  reg [31:0] _RAND_75;
  reg [31:0] _RAND_76;
  reg [31:0] _RAND_77;
  reg [31:0] _RAND_78;
  reg [31:0] _RAND_79;
  reg [31:0] _RAND_80;
  reg [31:0] _RAND_81;
  reg [31:0] _RAND_82;
  reg [31:0] _RAND_83;
  reg [31:0] _RAND_84;
  reg [31:0] _RAND_85;
  reg [31:0] _RAND_86;
  reg [31:0] _RAND_87;
  reg [31:0] _RAND_88;
  reg [31:0] _RAND_89;
  reg [31:0] _RAND_90;
  reg [31:0] _RAND_91;
  reg [31:0] _RAND_92;
  reg [31:0] _RAND_93;
  reg [31:0] _RAND_94;
  reg [31:0] _RAND_95;
  reg [31:0] _RAND_96;
  reg [31:0] _RAND_97;
  reg [63:0] _RAND_98;
  reg [31:0] _RAND_99;
  reg [63:0] _RAND_100;
  reg [31:0] _RAND_101;
  reg [63:0] _RAND_102;
  reg [31:0] _RAND_103;
  reg [63:0] _RAND_104;
  reg [31:0] _RAND_105;
  reg [63:0] _RAND_106;
  reg [31:0] _RAND_107;
  reg [63:0] _RAND_108;
  reg [31:0] _RAND_109;
  reg [63:0] _RAND_110;
  reg [31:0] _RAND_111;
  reg [63:0] _RAND_112;
  reg [31:0] _RAND_113;
  reg [63:0] _RAND_114;
  reg [31:0] _RAND_115;
  reg [63:0] _RAND_116;
  reg [31:0] _RAND_117;
  reg [63:0] _RAND_118;
  reg [31:0] _RAND_119;
  reg [63:0] _RAND_120;
  reg [31:0] _RAND_121;
  reg [63:0] _RAND_122;
  reg [31:0] _RAND_123;
  reg [63:0] _RAND_124;
  reg [31:0] _RAND_125;
  reg [63:0] _RAND_126;
  reg [31:0] _RAND_127;
  reg [63:0] _RAND_128;
  reg [31:0] _RAND_129;
  reg [63:0] _RAND_130;
  reg [31:0] _RAND_131;
  reg [63:0] _RAND_132;
  reg [31:0] _RAND_133;
  reg [63:0] _RAND_134;
  reg [31:0] _RAND_135;
  reg [63:0] _RAND_136;
  reg [31:0] _RAND_137;
  reg [63:0] _RAND_138;
  reg [31:0] _RAND_139;
  reg [63:0] _RAND_140;
  reg [31:0] _RAND_141;
  reg [63:0] _RAND_142;
  reg [31:0] _RAND_143;
  reg [63:0] _RAND_144;
  reg [31:0] _RAND_145;
  reg [63:0] _RAND_146;
  reg [31:0] _RAND_147;
  reg [63:0] _RAND_148;
  reg [31:0] _RAND_149;
  reg [63:0] _RAND_150;
  reg [31:0] _RAND_151;
  reg [63:0] _RAND_152;
  reg [31:0] _RAND_153;
  reg [63:0] _RAND_154;
  reg [31:0] _RAND_155;
  reg [63:0] _RAND_156;
  reg [31:0] _RAND_157;
  reg [63:0] _RAND_158;
  reg [31:0] _RAND_159;
  reg [63:0] _RAND_160;
  reg [31:0] _RAND_161;
  reg [63:0] _RAND_162;
  reg [31:0] _RAND_163;
  reg [63:0] _RAND_164;
  reg [31:0] _RAND_165;
  reg [63:0] _RAND_166;
  reg [31:0] _RAND_167;
  reg [63:0] _RAND_168;
  reg [31:0] _RAND_169;
  reg [63:0] _RAND_170;
  reg [31:0] _RAND_171;
  reg [63:0] _RAND_172;
  reg [31:0] _RAND_173;
  reg [63:0] _RAND_174;
  reg [31:0] _RAND_175;
  reg [63:0] _RAND_176;
  reg [31:0] _RAND_177;
  reg [63:0] _RAND_178;
  reg [31:0] _RAND_179;
  reg [63:0] _RAND_180;
  reg [31:0] _RAND_181;
  reg [63:0] _RAND_182;
  reg [31:0] _RAND_183;
  reg [63:0] _RAND_184;
  reg [31:0] _RAND_185;
  reg [63:0] _RAND_186;
  reg [31:0] _RAND_187;
  reg [63:0] _RAND_188;
  reg [31:0] _RAND_189;
  reg [63:0] _RAND_190;
  reg [31:0] _RAND_191;
  reg [63:0] _RAND_192;
  reg [31:0] _RAND_193;
  reg [63:0] _RAND_194;
  reg [31:0] _RAND_195;
  reg [63:0] _RAND_196;
  reg [31:0] _RAND_197;
  reg [63:0] _RAND_198;
  reg [31:0] _RAND_199;
  reg [63:0] _RAND_200;
  reg [31:0] _RAND_201;
  reg [63:0] _RAND_202;
  reg [31:0] _RAND_203;
  reg [63:0] _RAND_204;
  reg [31:0] _RAND_205;
  reg [63:0] _RAND_206;
  reg [31:0] _RAND_207;
  reg [63:0] _RAND_208;
  reg [31:0] _RAND_209;
  reg [63:0] _RAND_210;
  reg [31:0] _RAND_211;
  reg [63:0] _RAND_212;
  reg [31:0] _RAND_213;
  reg [63:0] _RAND_214;
  reg [31:0] _RAND_215;
  reg [63:0] _RAND_216;
  reg [31:0] _RAND_217;
  reg [63:0] _RAND_218;
  reg [31:0] _RAND_219;
  reg [63:0] _RAND_220;
  reg [31:0] _RAND_221;
  reg [63:0] _RAND_222;
  reg [31:0] _RAND_223;
  reg [63:0] _RAND_224;
  reg [31:0] _RAND_225;
  reg [63:0] _RAND_226;
  reg [31:0] _RAND_227;
  reg [63:0] _RAND_228;
  reg [31:0] _RAND_229;
  reg [63:0] _RAND_230;
  reg [31:0] _RAND_231;
  reg [63:0] _RAND_232;
  reg [31:0] _RAND_233;
  reg [63:0] _RAND_234;
  reg [31:0] _RAND_235;
  reg [63:0] _RAND_236;
  reg [31:0] _RAND_237;
  reg [63:0] _RAND_238;
  reg [31:0] _RAND_239;
  reg [63:0] _RAND_240;
  reg [31:0] _RAND_241;
`endif // RANDOMIZE_REG_INIT
  wire  pipeline_clock; // @[SLR2.scala 51:65]
  wire  pipeline_reset; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_1_clock; // @[SLR2.scala 51:65]
  wire  pipeline_1_reset; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_1_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_1_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_1_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_1_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_2_clock; // @[SLR2.scala 51:65]
  wire  pipeline_2_reset; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_2_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_2_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_2_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_2_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_3_clock; // @[SLR2.scala 51:65]
  wire  pipeline_3_reset; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_3_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_3_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_3_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_3_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_4_clock; // @[SLR2.scala 51:65]
  wire  pipeline_4_reset; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_4_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_4_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_4_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_4_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_5_clock; // @[SLR2.scala 51:65]
  wire  pipeline_5_reset; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_5_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_5_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_5_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_5_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_6_clock; // @[SLR2.scala 51:65]
  wire  pipeline_6_reset; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_6_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_6_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_6_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_6_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_7_clock; // @[SLR2.scala 51:65]
  wire  pipeline_7_reset; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_7_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_7_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_7_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_7_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_8_clock; // @[SLR2.scala 51:65]
  wire  pipeline_8_reset; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_8_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_8_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_8_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_8_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_9_clock; // @[SLR2.scala 51:65]
  wire  pipeline_9_reset; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_9_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_9_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_9_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_9_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_10_clock; // @[SLR2.scala 51:65]
  wire  pipeline_10_reset; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_10_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_10_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_10_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_10_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_11_clock; // @[SLR2.scala 51:65]
  wire  pipeline_11_reset; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_11_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_11_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_11_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_11_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_12_clock; // @[SLR2.scala 51:65]
  wire  pipeline_12_reset; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_12_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_12_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_12_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_12_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_13_clock; // @[SLR2.scala 51:65]
  wire  pipeline_13_reset; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_13_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_13_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_13_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_13_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_14_clock; // @[SLR2.scala 51:65]
  wire  pipeline_14_reset; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_14_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_14_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_14_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_14_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_14_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_14_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_14_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_15_clock; // @[SLR2.scala 51:65]
  wire  pipeline_15_reset; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_15_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_15_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_15_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_15_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_15_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_15_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_15_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_16_clock; // @[SLR2.scala 51:65]
  wire  pipeline_16_reset; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_16_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_16_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_16_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_16_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_16_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_16_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_16_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  pipeline_17_clock; // @[SLR2.scala 51:65]
  wire  pipeline_17_reset; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_flag; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_end; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_start; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_start_init; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_end; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_last_iteration; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_init_bram; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_frontier_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_pull_count; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_level; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_offsets_CSR_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_offsets_CSR_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_offsets_CSC_R_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_offsets_CSC_C_offset; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_offsets_level_offset; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_0_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_p2_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_1_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_p2_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_2_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_p2_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_in_3_valid; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_p2_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_frontier_in_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_frontier_in_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_frontier_in_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_frontier_in_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_frontier_in_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_out_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_out_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_out_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p2_out_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_p2_out_3_bits; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_node_num; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_push_or_pull; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_root; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_0_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_0_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_R_array_index_0_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_1_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_1_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_R_array_index_1_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_2_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_2_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_R_array_index_2_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_3_ready; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_R_array_index_3_valid; // @[SLR2.scala 51:65]
  wire [31:0] pipeline_17_io_R_array_index_3_bits; // @[SLR2.scala 51:65]
  wire  pipeline_17_io_p1_end; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_uram_out_a_0; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_uram_out_a_1; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_uram_out_a_2; // @[SLR2.scala 51:65]
  wire [63:0] pipeline_17_io_uram_out_a_3; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_17_io_uram_addr_a_0; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_17_io_uram_addr_a_1; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_17_io_uram_addr_a_2; // @[SLR2.scala 51:65]
  wire [19:0] pipeline_17_io_uram_addr_a_3; // @[SLR2.scala 51:65]
  wire  copy_start_clock; // @[SLR2.scala 54:28]
  wire  copy_start_reset; // @[SLR2.scala 54:28]
  wire  copy_start_io_in; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_0; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_1; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_2; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_3; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_4; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_5; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_6; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_7; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_8; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_9; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_10; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_11; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_12; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_13; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_14; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_15; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_16; // @[SLR2.scala 54:28]
  wire  copy_start_io_out_17; // @[SLR2.scala 54:28]
  wire  copy_frontier_flag_clock; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_reset; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_in; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_0; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_1; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_2; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_3; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_4; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_5; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_6; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_7; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_8; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_9; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_10; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_11; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_12; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_13; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_14; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_15; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_16; // @[SLR2.scala 56:36]
  wire  copy_frontier_flag_io_out_17; // @[SLR2.scala 56:36]
  wire  copy_current_level_clock; // @[SLR2.scala 57:36]
  wire  copy_current_level_reset; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_in; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_0; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_1; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_2; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_3; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_4; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_5; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_6; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_7; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_8; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_9; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_10; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_11; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_12; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_13; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_14; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_15; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_16; // @[SLR2.scala 57:36]
  wire [31:0] copy_current_level_io_out_17; // @[SLR2.scala 57:36]
  wire  copy_p2_end_clock; // @[SLR2.scala 58:29]
  wire  copy_p2_end_reset; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_in; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_0; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_1; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_2; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_3; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_4; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_5; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_6; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_7; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_8; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_9; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_10; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_11; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_12; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_13; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_14; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_15; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_16; // @[SLR2.scala 58:29]
  wire  copy_p2_end_io_out_17; // @[SLR2.scala 58:29]
  wire  copy_push_or_pull_clock; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_reset; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_in; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_0; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_1; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_2; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_3; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_4; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_5; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_6; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_7; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_8; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_9; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_10; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_11; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_12; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_13; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_14; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_15; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_16; // @[SLR2.scala 59:35]
  wire  copy_push_or_pull_io_out_17; // @[SLR2.scala 59:35]
  wire  copy_node_num_clock; // @[SLR2.scala 60:31]
  wire  copy_node_num_reset; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_in; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_0; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_1; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_2; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_3; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_4; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_5; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_6; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_7; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_8; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_9; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_10; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_11; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_12; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_13; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_14; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_15; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_16; // @[SLR2.scala 60:31]
  wire [31:0] copy_node_num_io_out_17; // @[SLR2.scala 60:31]
  wire  copy_root_clock; // @[SLR2.scala 61:27]
  wire  copy_root_reset; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_in; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_0; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_1; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_2; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_3; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_4; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_5; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_6; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_7; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_8; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_9; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_10; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_11; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_12; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_13; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_14; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_15; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_16; // @[SLR2.scala 61:27]
  wire [31:0] copy_root_io_out_17; // @[SLR2.scala 61:27]
  wire  copy_offset_CSR_R_offset_clock; // @[SLR2.scala 72:42]
  wire  copy_offset_CSR_R_offset_reset; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_in; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_0; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_1; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_2; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_3; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_4; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_5; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_6; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_7; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_8; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_9; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_10; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_11; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_12; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_13; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_14; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_15; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_16; // @[SLR2.scala 72:42]
  wire [31:0] copy_offset_CSR_R_offset_io_out_17; // @[SLR2.scala 72:42]
  wire  copy_offset_CSR_C_offset_clock; // @[SLR2.scala 73:42]
  wire  copy_offset_CSR_C_offset_reset; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_in; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_0; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_1; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_2; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_3; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_4; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_5; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_6; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_7; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_8; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_9; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_10; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_11; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_12; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_13; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_14; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_15; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_16; // @[SLR2.scala 73:42]
  wire [31:0] copy_offset_CSR_C_offset_io_out_17; // @[SLR2.scala 73:42]
  wire  copy_offset_CSC_R_offset_clock; // @[SLR2.scala 74:42]
  wire  copy_offset_CSC_R_offset_reset; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_in; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_0; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_1; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_2; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_3; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_4; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_5; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_6; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_7; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_8; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_9; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_10; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_11; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_12; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_13; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_14; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_15; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_16; // @[SLR2.scala 74:42]
  wire [31:0] copy_offset_CSC_R_offset_io_out_17; // @[SLR2.scala 74:42]
  wire  copy_offset_CSC_C_offset_clock; // @[SLR2.scala 75:42]
  wire  copy_offset_CSC_C_offset_reset; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_in; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_0; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_1; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_2; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_3; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_4; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_5; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_6; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_7; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_8; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_9; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_10; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_11; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_12; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_13; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_14; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_15; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_16; // @[SLR2.scala 75:42]
  wire [31:0] copy_offset_CSC_C_offset_io_out_17; // @[SLR2.scala 75:42]
  wire  copy_offset_level_offset_clock; // @[SLR2.scala 76:42]
  wire  copy_offset_level_offset_reset; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_in; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_0; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_1; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_2; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_3; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_4; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_5; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_6; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_7; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_8; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_9; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_10; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_11; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_12; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_13; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_14; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_15; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_16; // @[SLR2.scala 76:42]
  wire [31:0] copy_offset_level_offset_io_out_17; // @[SLR2.scala 76:42]
  reg  reset_reg; // @[SLR2.scala 46:28]
  reg  reset_reg_array_0; // @[SLR2.scala 47:74]
  reg  reset_reg_array_1; // @[SLR2.scala 47:74]
  reg  reset_reg_array_2; // @[SLR2.scala 47:74]
  reg  reset_reg_array_3; // @[SLR2.scala 47:74]
  reg  reset_reg_array_4; // @[SLR2.scala 47:74]
  reg  reset_reg_array_5; // @[SLR2.scala 47:74]
  reg  reset_reg_array_6; // @[SLR2.scala 47:74]
  reg  reset_reg_array_7; // @[SLR2.scala 47:74]
  reg  reset_reg_array_8; // @[SLR2.scala 47:74]
  reg  reset_reg_array_9; // @[SLR2.scala 47:74]
  reg  reset_reg_array_10; // @[SLR2.scala 47:74]
  reg  reset_reg_array_11; // @[SLR2.scala 47:74]
  reg  reset_reg_array_12; // @[SLR2.scala 47:74]
  reg  reset_reg_array_13; // @[SLR2.scala 47:74]
  reg  reset_reg_array_14; // @[SLR2.scala 47:74]
  reg  reset_reg_array_15; // @[SLR2.scala 47:74]
  reg  reset_reg_array_16; // @[SLR2.scala 47:74]
  reg  reset_reg_array_17; // @[SLR2.scala 47:74]
  reg [31:0] _T_18; // @[SLR2.scala 69:35]
  reg [31:0] _T_19; // @[SLR2.scala 70:31]
  reg [31:0] _T_20; // @[SLR2.scala 77:46]
  reg [31:0] _T_21; // @[SLR2.scala 78:46]
  reg [31:0] _T_22; // @[SLR2.scala 79:46]
  reg [31:0] _T_23; // @[SLR2.scala 80:46]
  reg [31:0] _T_24; // @[SLR2.scala 81:46]
  reg [31:0] r_array_count_0; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_1; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_2; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_3; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_4; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_5; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_6; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_7; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_8; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_9; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_10; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_11; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_12; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_13; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_14; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_15; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_16; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_17; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_18; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_19; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_20; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_21; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_22; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_23; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_24; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_25; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_26; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_27; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_28; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_29; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_30; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_31; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_32; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_33; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_34; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_35; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_36; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_37; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_38; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_39; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_40; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_41; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_42; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_43; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_44; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_45; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_46; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_47; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_48; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_49; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_50; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_51; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_52; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_53; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_54; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_55; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_56; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_57; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_58; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_59; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_60; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_61; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_62; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_63; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_64; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_65; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_66; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_67; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_68; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_69; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_70; // @[SLR2.scala 83:32]
  reg [31:0] r_array_count_71; // @[SLR2.scala 83:32]
  wire [32:0] _T_26 = r_array_count_0 + r_array_count_1; // @[SLR2.scala 84:53]
  wire [31:0] _T_27 = r_array_count_0 + r_array_count_1; // @[SLR2.scala 84:53]
  wire [32:0] _T_28 = _T_27 + r_array_count_2; // @[SLR2.scala 84:53]
  wire [31:0] _T_29 = _T_27 + r_array_count_2; // @[SLR2.scala 84:53]
  wire [32:0] _T_30 = _T_29 + r_array_count_3; // @[SLR2.scala 84:53]
  wire [31:0] _T_31 = _T_29 + r_array_count_3; // @[SLR2.scala 84:53]
  wire [32:0] _T_32 = _T_31 + r_array_count_4; // @[SLR2.scala 84:53]
  wire [31:0] _T_33 = _T_31 + r_array_count_4; // @[SLR2.scala 84:53]
  wire [32:0] _T_34 = _T_33 + r_array_count_5; // @[SLR2.scala 84:53]
  wire [31:0] _T_35 = _T_33 + r_array_count_5; // @[SLR2.scala 84:53]
  wire [32:0] _T_36 = _T_35 + r_array_count_6; // @[SLR2.scala 84:53]
  wire [31:0] _T_37 = _T_35 + r_array_count_6; // @[SLR2.scala 84:53]
  wire [32:0] _T_38 = _T_37 + r_array_count_7; // @[SLR2.scala 84:53]
  wire [31:0] _T_39 = _T_37 + r_array_count_7; // @[SLR2.scala 84:53]
  wire [32:0] _T_40 = _T_39 + r_array_count_8; // @[SLR2.scala 84:53]
  wire [31:0] _T_41 = _T_39 + r_array_count_8; // @[SLR2.scala 84:53]
  wire [32:0] _T_42 = _T_41 + r_array_count_9; // @[SLR2.scala 84:53]
  wire [31:0] _T_43 = _T_41 + r_array_count_9; // @[SLR2.scala 84:53]
  wire [32:0] _T_44 = _T_43 + r_array_count_10; // @[SLR2.scala 84:53]
  wire [31:0] _T_45 = _T_43 + r_array_count_10; // @[SLR2.scala 84:53]
  wire [32:0] _T_46 = _T_45 + r_array_count_11; // @[SLR2.scala 84:53]
  wire [31:0] _T_47 = _T_45 + r_array_count_11; // @[SLR2.scala 84:53]
  wire [32:0] _T_48 = _T_47 + r_array_count_12; // @[SLR2.scala 84:53]
  wire [31:0] _T_49 = _T_47 + r_array_count_12; // @[SLR2.scala 84:53]
  wire [32:0] _T_50 = _T_49 + r_array_count_13; // @[SLR2.scala 84:53]
  wire [31:0] _T_51 = _T_49 + r_array_count_13; // @[SLR2.scala 84:53]
  wire [32:0] _T_52 = _T_51 + r_array_count_14; // @[SLR2.scala 84:53]
  wire [31:0] _T_53 = _T_51 + r_array_count_14; // @[SLR2.scala 84:53]
  wire [32:0] _T_54 = _T_53 + r_array_count_15; // @[SLR2.scala 84:53]
  wire [31:0] _T_55 = _T_53 + r_array_count_15; // @[SLR2.scala 84:53]
  wire [32:0] _T_56 = _T_55 + r_array_count_16; // @[SLR2.scala 84:53]
  wire [31:0] _T_57 = _T_55 + r_array_count_16; // @[SLR2.scala 84:53]
  wire [32:0] _T_58 = _T_57 + r_array_count_17; // @[SLR2.scala 84:53]
  wire [31:0] _T_59 = _T_57 + r_array_count_17; // @[SLR2.scala 84:53]
  wire [32:0] _T_60 = _T_59 + r_array_count_18; // @[SLR2.scala 84:53]
  wire [31:0] _T_61 = _T_59 + r_array_count_18; // @[SLR2.scala 84:53]
  wire [32:0] _T_62 = _T_61 + r_array_count_19; // @[SLR2.scala 84:53]
  wire [31:0] _T_63 = _T_61 + r_array_count_19; // @[SLR2.scala 84:53]
  wire [32:0] _T_64 = _T_63 + r_array_count_20; // @[SLR2.scala 84:53]
  wire [31:0] _T_65 = _T_63 + r_array_count_20; // @[SLR2.scala 84:53]
  wire [32:0] _T_66 = _T_65 + r_array_count_21; // @[SLR2.scala 84:53]
  wire [31:0] _T_67 = _T_65 + r_array_count_21; // @[SLR2.scala 84:53]
  wire [32:0] _T_68 = _T_67 + r_array_count_22; // @[SLR2.scala 84:53]
  wire [31:0] _T_69 = _T_67 + r_array_count_22; // @[SLR2.scala 84:53]
  wire [32:0] _T_70 = _T_69 + r_array_count_23; // @[SLR2.scala 84:53]
  wire [31:0] _T_71 = _T_69 + r_array_count_23; // @[SLR2.scala 84:53]
  wire [32:0] _T_72 = _T_71 + r_array_count_24; // @[SLR2.scala 84:53]
  wire [31:0] _T_73 = _T_71 + r_array_count_24; // @[SLR2.scala 84:53]
  wire [32:0] _T_74 = _T_73 + r_array_count_25; // @[SLR2.scala 84:53]
  wire [31:0] _T_75 = _T_73 + r_array_count_25; // @[SLR2.scala 84:53]
  wire [32:0] _T_76 = _T_75 + r_array_count_26; // @[SLR2.scala 84:53]
  wire [31:0] _T_77 = _T_75 + r_array_count_26; // @[SLR2.scala 84:53]
  wire [32:0] _T_78 = _T_77 + r_array_count_27; // @[SLR2.scala 84:53]
  wire [31:0] _T_79 = _T_77 + r_array_count_27; // @[SLR2.scala 84:53]
  wire [32:0] _T_80 = _T_79 + r_array_count_28; // @[SLR2.scala 84:53]
  wire [31:0] _T_81 = _T_79 + r_array_count_28; // @[SLR2.scala 84:53]
  wire [32:0] _T_82 = _T_81 + r_array_count_29; // @[SLR2.scala 84:53]
  wire [31:0] _T_83 = _T_81 + r_array_count_29; // @[SLR2.scala 84:53]
  wire [32:0] _T_84 = _T_83 + r_array_count_30; // @[SLR2.scala 84:53]
  wire [31:0] _T_85 = _T_83 + r_array_count_30; // @[SLR2.scala 84:53]
  wire [32:0] _T_86 = _T_85 + r_array_count_31; // @[SLR2.scala 84:53]
  wire [31:0] _T_87 = _T_85 + r_array_count_31; // @[SLR2.scala 84:53]
  wire [32:0] _T_88 = _T_87 + r_array_count_32; // @[SLR2.scala 84:53]
  wire [31:0] _T_89 = _T_87 + r_array_count_32; // @[SLR2.scala 84:53]
  wire [32:0] _T_90 = _T_89 + r_array_count_33; // @[SLR2.scala 84:53]
  wire [31:0] _T_91 = _T_89 + r_array_count_33; // @[SLR2.scala 84:53]
  wire [32:0] _T_92 = _T_91 + r_array_count_34; // @[SLR2.scala 84:53]
  wire [31:0] _T_93 = _T_91 + r_array_count_34; // @[SLR2.scala 84:53]
  wire [32:0] _T_94 = _T_93 + r_array_count_35; // @[SLR2.scala 84:53]
  wire [31:0] _T_95 = _T_93 + r_array_count_35; // @[SLR2.scala 84:53]
  wire [32:0] _T_96 = _T_95 + r_array_count_36; // @[SLR2.scala 84:53]
  wire [31:0] _T_97 = _T_95 + r_array_count_36; // @[SLR2.scala 84:53]
  wire [32:0] _T_98 = _T_97 + r_array_count_37; // @[SLR2.scala 84:53]
  wire [31:0] _T_99 = _T_97 + r_array_count_37; // @[SLR2.scala 84:53]
  wire [32:0] _T_100 = _T_99 + r_array_count_38; // @[SLR2.scala 84:53]
  wire [31:0] _T_101 = _T_99 + r_array_count_38; // @[SLR2.scala 84:53]
  wire [32:0] _T_102 = _T_101 + r_array_count_39; // @[SLR2.scala 84:53]
  wire [31:0] _T_103 = _T_101 + r_array_count_39; // @[SLR2.scala 84:53]
  wire [32:0] _T_104 = _T_103 + r_array_count_40; // @[SLR2.scala 84:53]
  wire [31:0] _T_105 = _T_103 + r_array_count_40; // @[SLR2.scala 84:53]
  wire [32:0] _T_106 = _T_105 + r_array_count_41; // @[SLR2.scala 84:53]
  wire [31:0] _T_107 = _T_105 + r_array_count_41; // @[SLR2.scala 84:53]
  wire [32:0] _T_108 = _T_107 + r_array_count_42; // @[SLR2.scala 84:53]
  wire [31:0] _T_109 = _T_107 + r_array_count_42; // @[SLR2.scala 84:53]
  wire [32:0] _T_110 = _T_109 + r_array_count_43; // @[SLR2.scala 84:53]
  wire [31:0] _T_111 = _T_109 + r_array_count_43; // @[SLR2.scala 84:53]
  wire [32:0] _T_112 = _T_111 + r_array_count_44; // @[SLR2.scala 84:53]
  wire [31:0] _T_113 = _T_111 + r_array_count_44; // @[SLR2.scala 84:53]
  wire [32:0] _T_114 = _T_113 + r_array_count_45; // @[SLR2.scala 84:53]
  wire [31:0] _T_115 = _T_113 + r_array_count_45; // @[SLR2.scala 84:53]
  wire [32:0] _T_116 = _T_115 + r_array_count_46; // @[SLR2.scala 84:53]
  wire [31:0] _T_117 = _T_115 + r_array_count_46; // @[SLR2.scala 84:53]
  wire [32:0] _T_118 = _T_117 + r_array_count_47; // @[SLR2.scala 84:53]
  wire [31:0] _T_119 = _T_117 + r_array_count_47; // @[SLR2.scala 84:53]
  wire [32:0] _T_120 = _T_119 + r_array_count_48; // @[SLR2.scala 84:53]
  wire [31:0] _T_121 = _T_119 + r_array_count_48; // @[SLR2.scala 84:53]
  wire [32:0] _T_122 = _T_121 + r_array_count_49; // @[SLR2.scala 84:53]
  wire [31:0] _T_123 = _T_121 + r_array_count_49; // @[SLR2.scala 84:53]
  wire [32:0] _T_124 = _T_123 + r_array_count_50; // @[SLR2.scala 84:53]
  wire [31:0] _T_125 = _T_123 + r_array_count_50; // @[SLR2.scala 84:53]
  wire [32:0] _T_126 = _T_125 + r_array_count_51; // @[SLR2.scala 84:53]
  wire [31:0] _T_127 = _T_125 + r_array_count_51; // @[SLR2.scala 84:53]
  wire [32:0] _T_128 = _T_127 + r_array_count_52; // @[SLR2.scala 84:53]
  wire [31:0] _T_129 = _T_127 + r_array_count_52; // @[SLR2.scala 84:53]
  wire [32:0] _T_130 = _T_129 + r_array_count_53; // @[SLR2.scala 84:53]
  wire [31:0] _T_131 = _T_129 + r_array_count_53; // @[SLR2.scala 84:53]
  wire [32:0] _T_132 = _T_131 + r_array_count_54; // @[SLR2.scala 84:53]
  wire [31:0] _T_133 = _T_131 + r_array_count_54; // @[SLR2.scala 84:53]
  wire [32:0] _T_134 = _T_133 + r_array_count_55; // @[SLR2.scala 84:53]
  wire [31:0] _T_135 = _T_133 + r_array_count_55; // @[SLR2.scala 84:53]
  wire [32:0] _T_136 = _T_135 + r_array_count_56; // @[SLR2.scala 84:53]
  wire [31:0] _T_137 = _T_135 + r_array_count_56; // @[SLR2.scala 84:53]
  wire [32:0] _T_138 = _T_137 + r_array_count_57; // @[SLR2.scala 84:53]
  wire [31:0] _T_139 = _T_137 + r_array_count_57; // @[SLR2.scala 84:53]
  wire [32:0] _T_140 = _T_139 + r_array_count_58; // @[SLR2.scala 84:53]
  wire [31:0] _T_141 = _T_139 + r_array_count_58; // @[SLR2.scala 84:53]
  wire [32:0] _T_142 = _T_141 + r_array_count_59; // @[SLR2.scala 84:53]
  wire [31:0] _T_143 = _T_141 + r_array_count_59; // @[SLR2.scala 84:53]
  wire [32:0] _T_144 = _T_143 + r_array_count_60; // @[SLR2.scala 84:53]
  wire [31:0] _T_145 = _T_143 + r_array_count_60; // @[SLR2.scala 84:53]
  wire [32:0] _T_146 = _T_145 + r_array_count_61; // @[SLR2.scala 84:53]
  wire [31:0] _T_147 = _T_145 + r_array_count_61; // @[SLR2.scala 84:53]
  wire [32:0] _T_148 = _T_147 + r_array_count_62; // @[SLR2.scala 84:53]
  wire [31:0] _T_149 = _T_147 + r_array_count_62; // @[SLR2.scala 84:53]
  wire [32:0] _T_150 = _T_149 + r_array_count_63; // @[SLR2.scala 84:53]
  wire [31:0] _T_151 = _T_149 + r_array_count_63; // @[SLR2.scala 84:53]
  wire [32:0] _T_152 = _T_151 + r_array_count_64; // @[SLR2.scala 84:53]
  wire [31:0] _T_153 = _T_151 + r_array_count_64; // @[SLR2.scala 84:53]
  wire [32:0] _T_154 = _T_153 + r_array_count_65; // @[SLR2.scala 84:53]
  wire [31:0] _T_155 = _T_153 + r_array_count_65; // @[SLR2.scala 84:53]
  wire [32:0] _T_156 = _T_155 + r_array_count_66; // @[SLR2.scala 84:53]
  wire [31:0] _T_157 = _T_155 + r_array_count_66; // @[SLR2.scala 84:53]
  wire [32:0] _T_158 = _T_157 + r_array_count_67; // @[SLR2.scala 84:53]
  wire [31:0] _T_159 = _T_157 + r_array_count_67; // @[SLR2.scala 84:53]
  wire [32:0] _T_160 = _T_159 + r_array_count_68; // @[SLR2.scala 84:53]
  wire [31:0] _T_161 = _T_159 + r_array_count_68; // @[SLR2.scala 84:53]
  wire [32:0] _T_162 = _T_161 + r_array_count_69; // @[SLR2.scala 84:53]
  wire [31:0] _T_163 = _T_161 + r_array_count_69; // @[SLR2.scala 84:53]
  wire [32:0] _T_164 = _T_163 + r_array_count_70; // @[SLR2.scala 84:53]
  wire [31:0] _T_165 = _T_163 + r_array_count_70; // @[SLR2.scala 84:53]
  wire [32:0] _T_166 = _T_165 + r_array_count_71; // @[SLR2.scala 84:53]
  wire [31:0] r_array_count_total = _T_165 + r_array_count_71; // @[SLR2.scala 84:53]
  reg [63:0] _T_167; // @[SLR2.scala 125:20]
  reg [19:0] _T_168; // @[SLR2.scala 126:62]
  wire  _T_169 = io_R_array_index_0_valid & io_R_array_index_0_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_170 = r_array_count_0 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_171 = r_array_count_0 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_0 = _T_169 ? _T_171 : r_array_count_0; // @[SLR2.scala 127:137]
  reg [63:0] _T_172; // @[SLR2.scala 125:20]
  reg [19:0] _T_173; // @[SLR2.scala 126:62]
  wire  _T_174 = io_R_array_index_1_valid & io_R_array_index_1_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_175 = r_array_count_1 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_176 = r_array_count_1 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_1 = _T_174 ? _T_176 : r_array_count_1; // @[SLR2.scala 127:137]
  reg [63:0] _T_177; // @[SLR2.scala 125:20]
  reg [19:0] _T_178; // @[SLR2.scala 126:62]
  wire  _T_179 = io_R_array_index_2_valid & io_R_array_index_2_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_180 = r_array_count_2 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_181 = r_array_count_2 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_2 = _T_179 ? _T_181 : r_array_count_2; // @[SLR2.scala 127:137]
  reg [63:0] _T_182; // @[SLR2.scala 125:20]
  reg [19:0] _T_183; // @[SLR2.scala 126:62]
  wire  _T_184 = io_R_array_index_3_valid & io_R_array_index_3_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_185 = r_array_count_3 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_186 = r_array_count_3 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_3 = _T_184 ? _T_186 : r_array_count_3; // @[SLR2.scala 127:137]
  reg [63:0] _T_187; // @[SLR2.scala 125:20]
  reg [19:0] _T_188; // @[SLR2.scala 126:62]
  wire  _T_189 = io_R_array_index_4_valid & io_R_array_index_4_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_190 = r_array_count_4 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_191 = r_array_count_4 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_4 = _T_189 ? _T_191 : r_array_count_4; // @[SLR2.scala 127:137]
  reg [63:0] _T_192; // @[SLR2.scala 125:20]
  reg [19:0] _T_193; // @[SLR2.scala 126:62]
  wire  _T_194 = io_R_array_index_5_valid & io_R_array_index_5_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_195 = r_array_count_5 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_196 = r_array_count_5 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_5 = _T_194 ? _T_196 : r_array_count_5; // @[SLR2.scala 127:137]
  reg [63:0] _T_197; // @[SLR2.scala 125:20]
  reg [19:0] _T_198; // @[SLR2.scala 126:62]
  wire  _T_199 = io_R_array_index_6_valid & io_R_array_index_6_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_200 = r_array_count_6 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_201 = r_array_count_6 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_6 = _T_199 ? _T_201 : r_array_count_6; // @[SLR2.scala 127:137]
  reg [63:0] _T_202; // @[SLR2.scala 125:20]
  reg [19:0] _T_203; // @[SLR2.scala 126:62]
  wire  _T_204 = io_R_array_index_7_valid & io_R_array_index_7_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_205 = r_array_count_7 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_206 = r_array_count_7 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_7 = _T_204 ? _T_206 : r_array_count_7; // @[SLR2.scala 127:137]
  reg [63:0] _T_207; // @[SLR2.scala 125:20]
  reg [19:0] _T_208; // @[SLR2.scala 126:62]
  wire  _T_209 = io_R_array_index_8_valid & io_R_array_index_8_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_210 = r_array_count_8 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_211 = r_array_count_8 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_8 = _T_209 ? _T_211 : r_array_count_8; // @[SLR2.scala 127:137]
  reg [63:0] _T_212; // @[SLR2.scala 125:20]
  reg [19:0] _T_213; // @[SLR2.scala 126:62]
  wire  _T_214 = io_R_array_index_9_valid & io_R_array_index_9_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_215 = r_array_count_9 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_216 = r_array_count_9 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_9 = _T_214 ? _T_216 : r_array_count_9; // @[SLR2.scala 127:137]
  reg [63:0] _T_217; // @[SLR2.scala 125:20]
  reg [19:0] _T_218; // @[SLR2.scala 126:62]
  wire  _T_219 = io_R_array_index_10_valid & io_R_array_index_10_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_220 = r_array_count_10 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_221 = r_array_count_10 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_10 = _T_219 ? _T_221 : r_array_count_10; // @[SLR2.scala 127:137]
  reg [63:0] _T_222; // @[SLR2.scala 125:20]
  reg [19:0] _T_223; // @[SLR2.scala 126:62]
  wire  _T_224 = io_R_array_index_11_valid & io_R_array_index_11_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_225 = r_array_count_11 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_226 = r_array_count_11 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_11 = _T_224 ? _T_226 : r_array_count_11; // @[SLR2.scala 127:137]
  reg [63:0] _T_227; // @[SLR2.scala 125:20]
  reg [19:0] _T_228; // @[SLR2.scala 126:62]
  wire  _T_229 = io_R_array_index_12_valid & io_R_array_index_12_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_230 = r_array_count_12 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_231 = r_array_count_12 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_12 = _T_229 ? _T_231 : r_array_count_12; // @[SLR2.scala 127:137]
  reg [63:0] _T_232; // @[SLR2.scala 125:20]
  reg [19:0] _T_233; // @[SLR2.scala 126:62]
  wire  _T_234 = io_R_array_index_13_valid & io_R_array_index_13_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_235 = r_array_count_13 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_236 = r_array_count_13 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_13 = _T_234 ? _T_236 : r_array_count_13; // @[SLR2.scala 127:137]
  reg [63:0] _T_237; // @[SLR2.scala 125:20]
  reg [19:0] _T_238; // @[SLR2.scala 126:62]
  wire  _T_239 = io_R_array_index_14_valid & io_R_array_index_14_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_240 = r_array_count_14 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_241 = r_array_count_14 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_14 = _T_239 ? _T_241 : r_array_count_14; // @[SLR2.scala 127:137]
  reg [63:0] _T_242; // @[SLR2.scala 125:20]
  reg [19:0] _T_243; // @[SLR2.scala 126:62]
  wire  _T_244 = io_R_array_index_15_valid & io_R_array_index_15_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_245 = r_array_count_15 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_246 = r_array_count_15 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_15 = _T_244 ? _T_246 : r_array_count_15; // @[SLR2.scala 127:137]
  reg [63:0] _T_247; // @[SLR2.scala 125:20]
  reg [19:0] _T_248; // @[SLR2.scala 126:62]
  wire  _T_249 = io_R_array_index_16_valid & io_R_array_index_16_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_250 = r_array_count_16 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_251 = r_array_count_16 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_16 = _T_249 ? _T_251 : r_array_count_16; // @[SLR2.scala 127:137]
  reg [63:0] _T_252; // @[SLR2.scala 125:20]
  reg [19:0] _T_253; // @[SLR2.scala 126:62]
  wire  _T_254 = io_R_array_index_17_valid & io_R_array_index_17_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_255 = r_array_count_17 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_256 = r_array_count_17 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_17 = _T_254 ? _T_256 : r_array_count_17; // @[SLR2.scala 127:137]
  reg [63:0] _T_257; // @[SLR2.scala 125:20]
  reg [19:0] _T_258; // @[SLR2.scala 126:62]
  wire  _T_259 = io_R_array_index_18_valid & io_R_array_index_18_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_260 = r_array_count_18 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_261 = r_array_count_18 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_18 = _T_259 ? _T_261 : r_array_count_18; // @[SLR2.scala 127:137]
  reg [63:0] _T_262; // @[SLR2.scala 125:20]
  reg [19:0] _T_263; // @[SLR2.scala 126:62]
  wire  _T_264 = io_R_array_index_19_valid & io_R_array_index_19_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_265 = r_array_count_19 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_266 = r_array_count_19 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_19 = _T_264 ? _T_266 : r_array_count_19; // @[SLR2.scala 127:137]
  reg [63:0] _T_267; // @[SLR2.scala 125:20]
  reg [19:0] _T_268; // @[SLR2.scala 126:62]
  wire  _T_269 = io_R_array_index_20_valid & io_R_array_index_20_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_270 = r_array_count_20 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_271 = r_array_count_20 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_20 = _T_269 ? _T_271 : r_array_count_20; // @[SLR2.scala 127:137]
  reg [63:0] _T_272; // @[SLR2.scala 125:20]
  reg [19:0] _T_273; // @[SLR2.scala 126:62]
  wire  _T_274 = io_R_array_index_21_valid & io_R_array_index_21_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_275 = r_array_count_21 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_276 = r_array_count_21 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_21 = _T_274 ? _T_276 : r_array_count_21; // @[SLR2.scala 127:137]
  reg [63:0] _T_277; // @[SLR2.scala 125:20]
  reg [19:0] _T_278; // @[SLR2.scala 126:62]
  wire  _T_279 = io_R_array_index_22_valid & io_R_array_index_22_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_280 = r_array_count_22 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_281 = r_array_count_22 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_22 = _T_279 ? _T_281 : r_array_count_22; // @[SLR2.scala 127:137]
  reg [63:0] _T_282; // @[SLR2.scala 125:20]
  reg [19:0] _T_283; // @[SLR2.scala 126:62]
  wire  _T_284 = io_R_array_index_23_valid & io_R_array_index_23_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_285 = r_array_count_23 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_286 = r_array_count_23 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_23 = _T_284 ? _T_286 : r_array_count_23; // @[SLR2.scala 127:137]
  reg [63:0] _T_287; // @[SLR2.scala 125:20]
  reg [19:0] _T_288; // @[SLR2.scala 126:62]
  wire  _T_289 = io_R_array_index_24_valid & io_R_array_index_24_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_290 = r_array_count_24 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_291 = r_array_count_24 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_24 = _T_289 ? _T_291 : r_array_count_24; // @[SLR2.scala 127:137]
  reg [63:0] _T_292; // @[SLR2.scala 125:20]
  reg [19:0] _T_293; // @[SLR2.scala 126:62]
  wire  _T_294 = io_R_array_index_25_valid & io_R_array_index_25_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_295 = r_array_count_25 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_296 = r_array_count_25 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_25 = _T_294 ? _T_296 : r_array_count_25; // @[SLR2.scala 127:137]
  reg [63:0] _T_297; // @[SLR2.scala 125:20]
  reg [19:0] _T_298; // @[SLR2.scala 126:62]
  wire  _T_299 = io_R_array_index_26_valid & io_R_array_index_26_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_300 = r_array_count_26 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_301 = r_array_count_26 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_26 = _T_299 ? _T_301 : r_array_count_26; // @[SLR2.scala 127:137]
  reg [63:0] _T_302; // @[SLR2.scala 125:20]
  reg [19:0] _T_303; // @[SLR2.scala 126:62]
  wire  _T_304 = io_R_array_index_27_valid & io_R_array_index_27_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_305 = r_array_count_27 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_306 = r_array_count_27 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_27 = _T_304 ? _T_306 : r_array_count_27; // @[SLR2.scala 127:137]
  reg [63:0] _T_307; // @[SLR2.scala 125:20]
  reg [19:0] _T_308; // @[SLR2.scala 126:62]
  wire  _T_309 = io_R_array_index_28_valid & io_R_array_index_28_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_310 = r_array_count_28 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_311 = r_array_count_28 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_28 = _T_309 ? _T_311 : r_array_count_28; // @[SLR2.scala 127:137]
  reg [63:0] _T_312; // @[SLR2.scala 125:20]
  reg [19:0] _T_313; // @[SLR2.scala 126:62]
  wire  _T_314 = io_R_array_index_29_valid & io_R_array_index_29_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_315 = r_array_count_29 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_316 = r_array_count_29 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_29 = _T_314 ? _T_316 : r_array_count_29; // @[SLR2.scala 127:137]
  reg [63:0] _T_317; // @[SLR2.scala 125:20]
  reg [19:0] _T_318; // @[SLR2.scala 126:62]
  wire  _T_319 = io_R_array_index_30_valid & io_R_array_index_30_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_320 = r_array_count_30 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_321 = r_array_count_30 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_30 = _T_319 ? _T_321 : r_array_count_30; // @[SLR2.scala 127:137]
  reg [63:0] _T_322; // @[SLR2.scala 125:20]
  reg [19:0] _T_323; // @[SLR2.scala 126:62]
  wire  _T_324 = io_R_array_index_31_valid & io_R_array_index_31_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_325 = r_array_count_31 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_326 = r_array_count_31 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_31 = _T_324 ? _T_326 : r_array_count_31; // @[SLR2.scala 127:137]
  reg [63:0] _T_327; // @[SLR2.scala 125:20]
  reg [19:0] _T_328; // @[SLR2.scala 126:62]
  wire  _T_329 = io_R_array_index_32_valid & io_R_array_index_32_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_330 = r_array_count_32 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_331 = r_array_count_32 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_32 = _T_329 ? _T_331 : r_array_count_32; // @[SLR2.scala 127:137]
  reg [63:0] _T_332; // @[SLR2.scala 125:20]
  reg [19:0] _T_333; // @[SLR2.scala 126:62]
  wire  _T_334 = io_R_array_index_33_valid & io_R_array_index_33_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_335 = r_array_count_33 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_336 = r_array_count_33 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_33 = _T_334 ? _T_336 : r_array_count_33; // @[SLR2.scala 127:137]
  reg [63:0] _T_337; // @[SLR2.scala 125:20]
  reg [19:0] _T_338; // @[SLR2.scala 126:62]
  wire  _T_339 = io_R_array_index_34_valid & io_R_array_index_34_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_340 = r_array_count_34 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_341 = r_array_count_34 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_34 = _T_339 ? _T_341 : r_array_count_34; // @[SLR2.scala 127:137]
  reg [63:0] _T_342; // @[SLR2.scala 125:20]
  reg [19:0] _T_343; // @[SLR2.scala 126:62]
  wire  _T_344 = io_R_array_index_35_valid & io_R_array_index_35_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_345 = r_array_count_35 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_346 = r_array_count_35 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_35 = _T_344 ? _T_346 : r_array_count_35; // @[SLR2.scala 127:137]
  reg [63:0] _T_347; // @[SLR2.scala 125:20]
  reg [19:0] _T_348; // @[SLR2.scala 126:62]
  wire  _T_349 = io_R_array_index_36_valid & io_R_array_index_36_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_350 = r_array_count_36 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_351 = r_array_count_36 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_36 = _T_349 ? _T_351 : r_array_count_36; // @[SLR2.scala 127:137]
  reg [63:0] _T_352; // @[SLR2.scala 125:20]
  reg [19:0] _T_353; // @[SLR2.scala 126:62]
  wire  _T_354 = io_R_array_index_37_valid & io_R_array_index_37_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_355 = r_array_count_37 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_356 = r_array_count_37 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_37 = _T_354 ? _T_356 : r_array_count_37; // @[SLR2.scala 127:137]
  reg [63:0] _T_357; // @[SLR2.scala 125:20]
  reg [19:0] _T_358; // @[SLR2.scala 126:62]
  wire  _T_359 = io_R_array_index_38_valid & io_R_array_index_38_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_360 = r_array_count_38 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_361 = r_array_count_38 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_38 = _T_359 ? _T_361 : r_array_count_38; // @[SLR2.scala 127:137]
  reg [63:0] _T_362; // @[SLR2.scala 125:20]
  reg [19:0] _T_363; // @[SLR2.scala 126:62]
  wire  _T_364 = io_R_array_index_39_valid & io_R_array_index_39_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_365 = r_array_count_39 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_366 = r_array_count_39 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_39 = _T_364 ? _T_366 : r_array_count_39; // @[SLR2.scala 127:137]
  reg [63:0] _T_367; // @[SLR2.scala 125:20]
  reg [19:0] _T_368; // @[SLR2.scala 126:62]
  wire  _T_369 = io_R_array_index_40_valid & io_R_array_index_40_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_370 = r_array_count_40 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_371 = r_array_count_40 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_40 = _T_369 ? _T_371 : r_array_count_40; // @[SLR2.scala 127:137]
  reg [63:0] _T_372; // @[SLR2.scala 125:20]
  reg [19:0] _T_373; // @[SLR2.scala 126:62]
  wire  _T_374 = io_R_array_index_41_valid & io_R_array_index_41_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_375 = r_array_count_41 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_376 = r_array_count_41 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_41 = _T_374 ? _T_376 : r_array_count_41; // @[SLR2.scala 127:137]
  reg [63:0] _T_377; // @[SLR2.scala 125:20]
  reg [19:0] _T_378; // @[SLR2.scala 126:62]
  wire  _T_379 = io_R_array_index_42_valid & io_R_array_index_42_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_380 = r_array_count_42 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_381 = r_array_count_42 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_42 = _T_379 ? _T_381 : r_array_count_42; // @[SLR2.scala 127:137]
  reg [63:0] _T_382; // @[SLR2.scala 125:20]
  reg [19:0] _T_383; // @[SLR2.scala 126:62]
  wire  _T_384 = io_R_array_index_43_valid & io_R_array_index_43_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_385 = r_array_count_43 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_386 = r_array_count_43 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_43 = _T_384 ? _T_386 : r_array_count_43; // @[SLR2.scala 127:137]
  reg [63:0] _T_387; // @[SLR2.scala 125:20]
  reg [19:0] _T_388; // @[SLR2.scala 126:62]
  wire  _T_389 = io_R_array_index_44_valid & io_R_array_index_44_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_390 = r_array_count_44 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_391 = r_array_count_44 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_44 = _T_389 ? _T_391 : r_array_count_44; // @[SLR2.scala 127:137]
  reg [63:0] _T_392; // @[SLR2.scala 125:20]
  reg [19:0] _T_393; // @[SLR2.scala 126:62]
  wire  _T_394 = io_R_array_index_45_valid & io_R_array_index_45_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_395 = r_array_count_45 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_396 = r_array_count_45 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_45 = _T_394 ? _T_396 : r_array_count_45; // @[SLR2.scala 127:137]
  reg [63:0] _T_397; // @[SLR2.scala 125:20]
  reg [19:0] _T_398; // @[SLR2.scala 126:62]
  wire  _T_399 = io_R_array_index_46_valid & io_R_array_index_46_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_400 = r_array_count_46 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_401 = r_array_count_46 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_46 = _T_399 ? _T_401 : r_array_count_46; // @[SLR2.scala 127:137]
  reg [63:0] _T_402; // @[SLR2.scala 125:20]
  reg [19:0] _T_403; // @[SLR2.scala 126:62]
  wire  _T_404 = io_R_array_index_47_valid & io_R_array_index_47_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_405 = r_array_count_47 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_406 = r_array_count_47 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_47 = _T_404 ? _T_406 : r_array_count_47; // @[SLR2.scala 127:137]
  reg [63:0] _T_407; // @[SLR2.scala 125:20]
  reg [19:0] _T_408; // @[SLR2.scala 126:62]
  wire  _T_409 = io_R_array_index_48_valid & io_R_array_index_48_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_410 = r_array_count_48 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_411 = r_array_count_48 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_48 = _T_409 ? _T_411 : r_array_count_48; // @[SLR2.scala 127:137]
  reg [63:0] _T_412; // @[SLR2.scala 125:20]
  reg [19:0] _T_413; // @[SLR2.scala 126:62]
  wire  _T_414 = io_R_array_index_49_valid & io_R_array_index_49_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_415 = r_array_count_49 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_416 = r_array_count_49 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_49 = _T_414 ? _T_416 : r_array_count_49; // @[SLR2.scala 127:137]
  reg [63:0] _T_417; // @[SLR2.scala 125:20]
  reg [19:0] _T_418; // @[SLR2.scala 126:62]
  wire  _T_419 = io_R_array_index_50_valid & io_R_array_index_50_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_420 = r_array_count_50 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_421 = r_array_count_50 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_50 = _T_419 ? _T_421 : r_array_count_50; // @[SLR2.scala 127:137]
  reg [63:0] _T_422; // @[SLR2.scala 125:20]
  reg [19:0] _T_423; // @[SLR2.scala 126:62]
  wire  _T_424 = io_R_array_index_51_valid & io_R_array_index_51_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_425 = r_array_count_51 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_426 = r_array_count_51 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_51 = _T_424 ? _T_426 : r_array_count_51; // @[SLR2.scala 127:137]
  reg [63:0] _T_427; // @[SLR2.scala 125:20]
  reg [19:0] _T_428; // @[SLR2.scala 126:62]
  wire  _T_429 = io_R_array_index_52_valid & io_R_array_index_52_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_430 = r_array_count_52 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_431 = r_array_count_52 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_52 = _T_429 ? _T_431 : r_array_count_52; // @[SLR2.scala 127:137]
  reg [63:0] _T_432; // @[SLR2.scala 125:20]
  reg [19:0] _T_433; // @[SLR2.scala 126:62]
  wire  _T_434 = io_R_array_index_53_valid & io_R_array_index_53_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_435 = r_array_count_53 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_436 = r_array_count_53 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_53 = _T_434 ? _T_436 : r_array_count_53; // @[SLR2.scala 127:137]
  reg [63:0] _T_437; // @[SLR2.scala 125:20]
  reg [19:0] _T_438; // @[SLR2.scala 126:62]
  wire  _T_439 = io_R_array_index_54_valid & io_R_array_index_54_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_440 = r_array_count_54 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_441 = r_array_count_54 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_54 = _T_439 ? _T_441 : r_array_count_54; // @[SLR2.scala 127:137]
  reg [63:0] _T_442; // @[SLR2.scala 125:20]
  reg [19:0] _T_443; // @[SLR2.scala 126:62]
  wire  _T_444 = io_R_array_index_55_valid & io_R_array_index_55_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_445 = r_array_count_55 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_446 = r_array_count_55 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_55 = _T_444 ? _T_446 : r_array_count_55; // @[SLR2.scala 127:137]
  reg [63:0] _T_447; // @[SLR2.scala 125:20]
  reg [19:0] _T_448; // @[SLR2.scala 126:62]
  wire  _T_449 = io_R_array_index_56_valid & io_R_array_index_56_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_450 = r_array_count_56 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_451 = r_array_count_56 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_56 = _T_449 ? _T_451 : r_array_count_56; // @[SLR2.scala 127:137]
  reg [63:0] _T_452; // @[SLR2.scala 125:20]
  reg [19:0] _T_453; // @[SLR2.scala 126:62]
  wire  _T_454 = io_R_array_index_57_valid & io_R_array_index_57_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_455 = r_array_count_57 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_456 = r_array_count_57 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_57 = _T_454 ? _T_456 : r_array_count_57; // @[SLR2.scala 127:137]
  reg [63:0] _T_457; // @[SLR2.scala 125:20]
  reg [19:0] _T_458; // @[SLR2.scala 126:62]
  wire  _T_459 = io_R_array_index_58_valid & io_R_array_index_58_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_460 = r_array_count_58 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_461 = r_array_count_58 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_58 = _T_459 ? _T_461 : r_array_count_58; // @[SLR2.scala 127:137]
  reg [63:0] _T_462; // @[SLR2.scala 125:20]
  reg [19:0] _T_463; // @[SLR2.scala 126:62]
  wire  _T_464 = io_R_array_index_59_valid & io_R_array_index_59_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_465 = r_array_count_59 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_466 = r_array_count_59 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_59 = _T_464 ? _T_466 : r_array_count_59; // @[SLR2.scala 127:137]
  reg [63:0] _T_467; // @[SLR2.scala 125:20]
  reg [19:0] _T_468; // @[SLR2.scala 126:62]
  wire  _T_469 = io_R_array_index_60_valid & io_R_array_index_60_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_470 = r_array_count_60 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_471 = r_array_count_60 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_60 = _T_469 ? _T_471 : r_array_count_60; // @[SLR2.scala 127:137]
  reg [63:0] _T_472; // @[SLR2.scala 125:20]
  reg [19:0] _T_473; // @[SLR2.scala 126:62]
  wire  _T_474 = io_R_array_index_61_valid & io_R_array_index_61_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_475 = r_array_count_61 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_476 = r_array_count_61 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_61 = _T_474 ? _T_476 : r_array_count_61; // @[SLR2.scala 127:137]
  reg [63:0] _T_477; // @[SLR2.scala 125:20]
  reg [19:0] _T_478; // @[SLR2.scala 126:62]
  wire  _T_479 = io_R_array_index_62_valid & io_R_array_index_62_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_480 = r_array_count_62 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_481 = r_array_count_62 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_62 = _T_479 ? _T_481 : r_array_count_62; // @[SLR2.scala 127:137]
  reg [63:0] _T_482; // @[SLR2.scala 125:20]
  reg [19:0] _T_483; // @[SLR2.scala 126:62]
  wire  _T_484 = io_R_array_index_63_valid & io_R_array_index_63_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_485 = r_array_count_63 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_486 = r_array_count_63 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_63 = _T_484 ? _T_486 : r_array_count_63; // @[SLR2.scala 127:137]
  reg [63:0] _T_487; // @[SLR2.scala 125:20]
  reg [19:0] _T_488; // @[SLR2.scala 126:62]
  wire  _T_489 = io_R_array_index_64_valid & io_R_array_index_64_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_490 = r_array_count_64 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_491 = r_array_count_64 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_64 = _T_489 ? _T_491 : r_array_count_64; // @[SLR2.scala 127:137]
  reg [63:0] _T_492; // @[SLR2.scala 125:20]
  reg [19:0] _T_493; // @[SLR2.scala 126:62]
  wire  _T_494 = io_R_array_index_65_valid & io_R_array_index_65_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_495 = r_array_count_65 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_496 = r_array_count_65 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_65 = _T_494 ? _T_496 : r_array_count_65; // @[SLR2.scala 127:137]
  reg [63:0] _T_497; // @[SLR2.scala 125:20]
  reg [19:0] _T_498; // @[SLR2.scala 126:62]
  wire  _T_499 = io_R_array_index_66_valid & io_R_array_index_66_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_500 = r_array_count_66 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_501 = r_array_count_66 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_66 = _T_499 ? _T_501 : r_array_count_66; // @[SLR2.scala 127:137]
  reg [63:0] _T_502; // @[SLR2.scala 125:20]
  reg [19:0] _T_503; // @[SLR2.scala 126:62]
  wire  _T_504 = io_R_array_index_67_valid & io_R_array_index_67_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_505 = r_array_count_67 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_506 = r_array_count_67 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_67 = _T_504 ? _T_506 : r_array_count_67; // @[SLR2.scala 127:137]
  reg [63:0] _T_507; // @[SLR2.scala 125:20]
  reg [19:0] _T_508; // @[SLR2.scala 126:62]
  wire  _T_509 = io_R_array_index_68_valid & io_R_array_index_68_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_510 = r_array_count_68 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_511 = r_array_count_68 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_68 = _T_509 ? _T_511 : r_array_count_68; // @[SLR2.scala 127:137]
  reg [63:0] _T_512; // @[SLR2.scala 125:20]
  reg [19:0] _T_513; // @[SLR2.scala 126:62]
  wire  _T_514 = io_R_array_index_69_valid & io_R_array_index_69_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_515 = r_array_count_69 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_516 = r_array_count_69 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_69 = _T_514 ? _T_516 : r_array_count_69; // @[SLR2.scala 127:137]
  reg [63:0] _T_517; // @[SLR2.scala 125:20]
  reg [19:0] _T_518; // @[SLR2.scala 126:62]
  wire  _T_519 = io_R_array_index_70_valid & io_R_array_index_70_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_520 = r_array_count_70 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_521 = r_array_count_70 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_70 = _T_519 ? _T_521 : r_array_count_70; // @[SLR2.scala 127:137]
  reg [63:0] _T_522; // @[SLR2.scala 125:20]
  reg [19:0] _T_523; // @[SLR2.scala 126:62]
  wire  _T_524 = io_R_array_index_71_valid & io_R_array_index_71_ready; // @[SLR2.scala 127:76]
  wire [32:0] _T_525 = r_array_count_71 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _T_526 = r_array_count_71 + 32'h1; // @[SLR2.scala 127:239]
  wire [31:0] _GEN_71 = _T_524 ? _T_526 : r_array_count_71; // @[SLR2.scala 127:137]
  wire  _T = reset_reg_array_0; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_1 = reset_reg_array_1; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_2 = reset_reg_array_2; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_3 = reset_reg_array_3; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_4 = reset_reg_array_4; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_5 = reset_reg_array_5; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_6 = reset_reg_array_6; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_7 = reset_reg_array_7; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_8 = reset_reg_array_8; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_9 = reset_reg_array_9; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_10 = reset_reg_array_10; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_11 = reset_reg_array_11; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_12 = reset_reg_array_12; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_13 = reset_reg_array_13; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_14 = reset_reg_array_14; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_15 = reset_reg_array_15; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_16 = reset_reg_array_16; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire  _T_17 = reset_reg_array_17; // @[SLR2.scala 47:34 SLR2.scala 47:34]
  wire [31:0] _T_25_0 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_1 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_2 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_3 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_4 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_5 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_6 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_7 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_8 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_9 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_10 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_11 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_12 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_13 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_14 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_15 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_16 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_17 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_18 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_19 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_20 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_21 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_22 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_23 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_24 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_25 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_26 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_27 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_28 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_29 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_30 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_31 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_32 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_33 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_34 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_35 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_36 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_37 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_38 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_39 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_40 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_41 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_42 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_43 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_44 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_45 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_46 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_47 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_48 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_49 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_50 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_51 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_52 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_53 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_54 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_55 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_56 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_57 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_58 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_59 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_60 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_61 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_62 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_63 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_64 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_65 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_66 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_67 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_68 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_69 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_70 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  wire [31:0] _T_25_71 = 32'h0; // @[SLR2.scala 83:40 SLR2.scala 83:40]
  pipeline_14 pipeline ( // @[SLR2.scala 51:65]
    .clock(pipeline_clock),
    .reset(pipeline_reset),
    .io_frontier_flag(pipeline_io_frontier_flag),
    .io_p2_end(pipeline_io_p2_end),
    .io_start(pipeline_io_start),
    .io_start_init(pipeline_io_start_init),
    .io_end(pipeline_io_end),
    .io_last_iteration(pipeline_io_last_iteration),
    .io_init_bram(pipeline_io_init_bram),
    .io_p2_count(pipeline_io_p2_count),
    .io_frontier_pull_count(pipeline_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_io_p2_pull_count),
    .io_level(pipeline_io_level),
    .io_offsets_CSR_R_offset(pipeline_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_io_p2_out_3_bits),
    .io_node_num(pipeline_io_node_num),
    .io_push_or_pull(pipeline_io_push_or_pull),
    .io_root(pipeline_io_root),
    .io_R_array_index_0_ready(pipeline_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_io_R_array_index_3_bits),
    .io_p1_end(pipeline_io_p1_end),
    .io_uram_out_a_0(pipeline_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_io_uram_addr_a_3)
  );
  pipeline_15 pipeline_1 ( // @[SLR2.scala 51:65]
    .clock(pipeline_1_clock),
    .reset(pipeline_1_reset),
    .io_frontier_flag(pipeline_1_io_frontier_flag),
    .io_p2_end(pipeline_1_io_p2_end),
    .io_start(pipeline_1_io_start),
    .io_start_init(pipeline_1_io_start_init),
    .io_end(pipeline_1_io_end),
    .io_last_iteration(pipeline_1_io_last_iteration),
    .io_init_bram(pipeline_1_io_init_bram),
    .io_p2_count(pipeline_1_io_p2_count),
    .io_frontier_pull_count(pipeline_1_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_1_io_p2_pull_count),
    .io_level(pipeline_1_io_level),
    .io_offsets_CSR_R_offset(pipeline_1_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_1_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_1_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_1_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_1_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_1_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_1_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_1_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_1_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_1_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_1_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_1_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_1_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_1_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_1_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_1_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_1_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_1_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_1_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_1_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_1_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_1_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_1_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_1_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_1_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_1_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_1_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_1_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_1_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_1_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_1_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_1_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_1_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_1_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_1_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_1_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_1_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_1_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_1_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_1_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_1_io_p2_out_3_bits),
    .io_node_num(pipeline_1_io_node_num),
    .io_push_or_pull(pipeline_1_io_push_or_pull),
    .io_root(pipeline_1_io_root),
    .io_R_array_index_0_ready(pipeline_1_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_1_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_1_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_1_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_1_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_1_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_1_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_1_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_1_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_1_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_1_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_1_io_R_array_index_3_bits),
    .io_p1_end(pipeline_1_io_p1_end),
    .io_uram_out_a_0(pipeline_1_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_1_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_1_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_1_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_1_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_1_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_1_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_1_io_uram_addr_a_3)
  );
  pipeline_16 pipeline_2 ( // @[SLR2.scala 51:65]
    .clock(pipeline_2_clock),
    .reset(pipeline_2_reset),
    .io_frontier_flag(pipeline_2_io_frontier_flag),
    .io_p2_end(pipeline_2_io_p2_end),
    .io_start(pipeline_2_io_start),
    .io_start_init(pipeline_2_io_start_init),
    .io_end(pipeline_2_io_end),
    .io_last_iteration(pipeline_2_io_last_iteration),
    .io_init_bram(pipeline_2_io_init_bram),
    .io_p2_count(pipeline_2_io_p2_count),
    .io_frontier_pull_count(pipeline_2_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_2_io_p2_pull_count),
    .io_level(pipeline_2_io_level),
    .io_offsets_CSR_R_offset(pipeline_2_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_2_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_2_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_2_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_2_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_2_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_2_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_2_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_2_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_2_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_2_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_2_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_2_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_2_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_2_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_2_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_2_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_2_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_2_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_2_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_2_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_2_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_2_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_2_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_2_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_2_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_2_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_2_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_2_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_2_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_2_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_2_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_2_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_2_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_2_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_2_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_2_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_2_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_2_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_2_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_2_io_p2_out_3_bits),
    .io_node_num(pipeline_2_io_node_num),
    .io_push_or_pull(pipeline_2_io_push_or_pull),
    .io_root(pipeline_2_io_root),
    .io_R_array_index_0_ready(pipeline_2_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_2_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_2_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_2_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_2_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_2_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_2_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_2_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_2_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_2_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_2_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_2_io_R_array_index_3_bits),
    .io_p1_end(pipeline_2_io_p1_end),
    .io_uram_out_a_0(pipeline_2_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_2_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_2_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_2_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_2_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_2_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_2_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_2_io_uram_addr_a_3)
  );
  pipeline_17 pipeline_3 ( // @[SLR2.scala 51:65]
    .clock(pipeline_3_clock),
    .reset(pipeline_3_reset),
    .io_frontier_flag(pipeline_3_io_frontier_flag),
    .io_p2_end(pipeline_3_io_p2_end),
    .io_start(pipeline_3_io_start),
    .io_start_init(pipeline_3_io_start_init),
    .io_end(pipeline_3_io_end),
    .io_last_iteration(pipeline_3_io_last_iteration),
    .io_init_bram(pipeline_3_io_init_bram),
    .io_p2_count(pipeline_3_io_p2_count),
    .io_frontier_pull_count(pipeline_3_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_3_io_p2_pull_count),
    .io_level(pipeline_3_io_level),
    .io_offsets_CSR_R_offset(pipeline_3_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_3_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_3_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_3_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_3_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_3_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_3_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_3_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_3_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_3_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_3_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_3_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_3_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_3_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_3_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_3_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_3_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_3_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_3_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_3_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_3_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_3_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_3_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_3_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_3_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_3_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_3_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_3_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_3_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_3_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_3_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_3_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_3_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_3_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_3_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_3_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_3_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_3_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_3_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_3_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_3_io_p2_out_3_bits),
    .io_node_num(pipeline_3_io_node_num),
    .io_push_or_pull(pipeline_3_io_push_or_pull),
    .io_root(pipeline_3_io_root),
    .io_R_array_index_0_ready(pipeline_3_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_3_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_3_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_3_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_3_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_3_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_3_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_3_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_3_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_3_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_3_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_3_io_R_array_index_3_bits),
    .io_p1_end(pipeline_3_io_p1_end),
    .io_uram_out_a_0(pipeline_3_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_3_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_3_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_3_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_3_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_3_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_3_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_3_io_uram_addr_a_3)
  );
  pipeline_18 pipeline_4 ( // @[SLR2.scala 51:65]
    .clock(pipeline_4_clock),
    .reset(pipeline_4_reset),
    .io_frontier_flag(pipeline_4_io_frontier_flag),
    .io_p2_end(pipeline_4_io_p2_end),
    .io_start(pipeline_4_io_start),
    .io_start_init(pipeline_4_io_start_init),
    .io_end(pipeline_4_io_end),
    .io_last_iteration(pipeline_4_io_last_iteration),
    .io_init_bram(pipeline_4_io_init_bram),
    .io_p2_count(pipeline_4_io_p2_count),
    .io_frontier_pull_count(pipeline_4_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_4_io_p2_pull_count),
    .io_level(pipeline_4_io_level),
    .io_offsets_CSR_R_offset(pipeline_4_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_4_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_4_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_4_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_4_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_4_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_4_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_4_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_4_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_4_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_4_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_4_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_4_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_4_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_4_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_4_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_4_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_4_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_4_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_4_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_4_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_4_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_4_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_4_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_4_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_4_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_4_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_4_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_4_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_4_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_4_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_4_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_4_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_4_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_4_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_4_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_4_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_4_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_4_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_4_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_4_io_p2_out_3_bits),
    .io_node_num(pipeline_4_io_node_num),
    .io_push_or_pull(pipeline_4_io_push_or_pull),
    .io_root(pipeline_4_io_root),
    .io_R_array_index_0_ready(pipeline_4_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_4_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_4_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_4_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_4_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_4_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_4_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_4_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_4_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_4_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_4_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_4_io_R_array_index_3_bits),
    .io_p1_end(pipeline_4_io_p1_end),
    .io_uram_out_a_0(pipeline_4_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_4_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_4_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_4_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_4_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_4_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_4_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_4_io_uram_addr_a_3)
  );
  pipeline_19 pipeline_5 ( // @[SLR2.scala 51:65]
    .clock(pipeline_5_clock),
    .reset(pipeline_5_reset),
    .io_frontier_flag(pipeline_5_io_frontier_flag),
    .io_p2_end(pipeline_5_io_p2_end),
    .io_start(pipeline_5_io_start),
    .io_start_init(pipeline_5_io_start_init),
    .io_end(pipeline_5_io_end),
    .io_last_iteration(pipeline_5_io_last_iteration),
    .io_init_bram(pipeline_5_io_init_bram),
    .io_p2_count(pipeline_5_io_p2_count),
    .io_frontier_pull_count(pipeline_5_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_5_io_p2_pull_count),
    .io_level(pipeline_5_io_level),
    .io_offsets_CSR_R_offset(pipeline_5_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_5_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_5_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_5_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_5_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_5_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_5_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_5_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_5_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_5_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_5_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_5_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_5_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_5_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_5_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_5_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_5_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_5_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_5_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_5_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_5_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_5_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_5_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_5_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_5_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_5_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_5_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_5_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_5_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_5_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_5_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_5_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_5_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_5_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_5_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_5_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_5_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_5_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_5_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_5_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_5_io_p2_out_3_bits),
    .io_node_num(pipeline_5_io_node_num),
    .io_push_or_pull(pipeline_5_io_push_or_pull),
    .io_root(pipeline_5_io_root),
    .io_R_array_index_0_ready(pipeline_5_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_5_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_5_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_5_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_5_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_5_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_5_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_5_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_5_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_5_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_5_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_5_io_R_array_index_3_bits),
    .io_p1_end(pipeline_5_io_p1_end),
    .io_uram_out_a_0(pipeline_5_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_5_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_5_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_5_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_5_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_5_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_5_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_5_io_uram_addr_a_3)
  );
  pipeline_20 pipeline_6 ( // @[SLR2.scala 51:65]
    .clock(pipeline_6_clock),
    .reset(pipeline_6_reset),
    .io_frontier_flag(pipeline_6_io_frontier_flag),
    .io_p2_end(pipeline_6_io_p2_end),
    .io_start(pipeline_6_io_start),
    .io_start_init(pipeline_6_io_start_init),
    .io_end(pipeline_6_io_end),
    .io_last_iteration(pipeline_6_io_last_iteration),
    .io_init_bram(pipeline_6_io_init_bram),
    .io_p2_count(pipeline_6_io_p2_count),
    .io_frontier_pull_count(pipeline_6_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_6_io_p2_pull_count),
    .io_level(pipeline_6_io_level),
    .io_offsets_CSR_R_offset(pipeline_6_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_6_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_6_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_6_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_6_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_6_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_6_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_6_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_6_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_6_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_6_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_6_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_6_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_6_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_6_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_6_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_6_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_6_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_6_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_6_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_6_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_6_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_6_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_6_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_6_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_6_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_6_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_6_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_6_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_6_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_6_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_6_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_6_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_6_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_6_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_6_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_6_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_6_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_6_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_6_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_6_io_p2_out_3_bits),
    .io_node_num(pipeline_6_io_node_num),
    .io_push_or_pull(pipeline_6_io_push_or_pull),
    .io_root(pipeline_6_io_root),
    .io_R_array_index_0_ready(pipeline_6_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_6_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_6_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_6_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_6_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_6_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_6_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_6_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_6_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_6_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_6_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_6_io_R_array_index_3_bits),
    .io_p1_end(pipeline_6_io_p1_end),
    .io_uram_out_a_0(pipeline_6_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_6_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_6_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_6_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_6_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_6_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_6_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_6_io_uram_addr_a_3)
  );
  pipeline_21 pipeline_7 ( // @[SLR2.scala 51:65]
    .clock(pipeline_7_clock),
    .reset(pipeline_7_reset),
    .io_frontier_flag(pipeline_7_io_frontier_flag),
    .io_p2_end(pipeline_7_io_p2_end),
    .io_start(pipeline_7_io_start),
    .io_start_init(pipeline_7_io_start_init),
    .io_end(pipeline_7_io_end),
    .io_last_iteration(pipeline_7_io_last_iteration),
    .io_init_bram(pipeline_7_io_init_bram),
    .io_p2_count(pipeline_7_io_p2_count),
    .io_frontier_pull_count(pipeline_7_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_7_io_p2_pull_count),
    .io_level(pipeline_7_io_level),
    .io_offsets_CSR_R_offset(pipeline_7_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_7_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_7_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_7_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_7_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_7_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_7_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_7_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_7_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_7_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_7_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_7_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_7_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_7_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_7_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_7_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_7_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_7_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_7_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_7_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_7_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_7_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_7_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_7_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_7_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_7_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_7_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_7_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_7_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_7_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_7_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_7_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_7_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_7_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_7_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_7_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_7_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_7_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_7_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_7_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_7_io_p2_out_3_bits),
    .io_node_num(pipeline_7_io_node_num),
    .io_push_or_pull(pipeline_7_io_push_or_pull),
    .io_root(pipeline_7_io_root),
    .io_R_array_index_0_ready(pipeline_7_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_7_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_7_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_7_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_7_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_7_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_7_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_7_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_7_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_7_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_7_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_7_io_R_array_index_3_bits),
    .io_p1_end(pipeline_7_io_p1_end),
    .io_uram_out_a_0(pipeline_7_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_7_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_7_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_7_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_7_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_7_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_7_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_7_io_uram_addr_a_3)
  );
  pipeline_22 pipeline_8 ( // @[SLR2.scala 51:65]
    .clock(pipeline_8_clock),
    .reset(pipeline_8_reset),
    .io_frontier_flag(pipeline_8_io_frontier_flag),
    .io_p2_end(pipeline_8_io_p2_end),
    .io_start(pipeline_8_io_start),
    .io_start_init(pipeline_8_io_start_init),
    .io_end(pipeline_8_io_end),
    .io_last_iteration(pipeline_8_io_last_iteration),
    .io_init_bram(pipeline_8_io_init_bram),
    .io_p2_count(pipeline_8_io_p2_count),
    .io_frontier_pull_count(pipeline_8_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_8_io_p2_pull_count),
    .io_level(pipeline_8_io_level),
    .io_offsets_CSR_R_offset(pipeline_8_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_8_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_8_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_8_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_8_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_8_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_8_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_8_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_8_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_8_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_8_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_8_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_8_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_8_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_8_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_8_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_8_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_8_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_8_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_8_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_8_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_8_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_8_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_8_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_8_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_8_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_8_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_8_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_8_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_8_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_8_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_8_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_8_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_8_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_8_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_8_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_8_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_8_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_8_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_8_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_8_io_p2_out_3_bits),
    .io_node_num(pipeline_8_io_node_num),
    .io_push_or_pull(pipeline_8_io_push_or_pull),
    .io_root(pipeline_8_io_root),
    .io_R_array_index_0_ready(pipeline_8_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_8_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_8_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_8_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_8_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_8_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_8_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_8_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_8_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_8_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_8_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_8_io_R_array_index_3_bits),
    .io_p1_end(pipeline_8_io_p1_end),
    .io_uram_out_a_0(pipeline_8_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_8_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_8_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_8_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_8_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_8_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_8_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_8_io_uram_addr_a_3)
  );
  pipeline_23 pipeline_9 ( // @[SLR2.scala 51:65]
    .clock(pipeline_9_clock),
    .reset(pipeline_9_reset),
    .io_frontier_flag(pipeline_9_io_frontier_flag),
    .io_p2_end(pipeline_9_io_p2_end),
    .io_start(pipeline_9_io_start),
    .io_start_init(pipeline_9_io_start_init),
    .io_end(pipeline_9_io_end),
    .io_last_iteration(pipeline_9_io_last_iteration),
    .io_init_bram(pipeline_9_io_init_bram),
    .io_p2_count(pipeline_9_io_p2_count),
    .io_frontier_pull_count(pipeline_9_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_9_io_p2_pull_count),
    .io_level(pipeline_9_io_level),
    .io_offsets_CSR_R_offset(pipeline_9_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_9_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_9_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_9_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_9_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_9_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_9_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_9_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_9_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_9_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_9_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_9_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_9_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_9_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_9_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_9_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_9_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_9_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_9_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_9_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_9_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_9_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_9_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_9_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_9_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_9_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_9_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_9_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_9_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_9_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_9_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_9_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_9_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_9_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_9_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_9_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_9_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_9_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_9_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_9_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_9_io_p2_out_3_bits),
    .io_node_num(pipeline_9_io_node_num),
    .io_push_or_pull(pipeline_9_io_push_or_pull),
    .io_root(pipeline_9_io_root),
    .io_R_array_index_0_ready(pipeline_9_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_9_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_9_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_9_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_9_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_9_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_9_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_9_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_9_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_9_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_9_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_9_io_R_array_index_3_bits),
    .io_p1_end(pipeline_9_io_p1_end),
    .io_uram_out_a_0(pipeline_9_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_9_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_9_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_9_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_9_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_9_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_9_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_9_io_uram_addr_a_3)
  );
  pipeline_24 pipeline_10 ( // @[SLR2.scala 51:65]
    .clock(pipeline_10_clock),
    .reset(pipeline_10_reset),
    .io_frontier_flag(pipeline_10_io_frontier_flag),
    .io_p2_end(pipeline_10_io_p2_end),
    .io_start(pipeline_10_io_start),
    .io_start_init(pipeline_10_io_start_init),
    .io_end(pipeline_10_io_end),
    .io_last_iteration(pipeline_10_io_last_iteration),
    .io_init_bram(pipeline_10_io_init_bram),
    .io_p2_count(pipeline_10_io_p2_count),
    .io_frontier_pull_count(pipeline_10_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_10_io_p2_pull_count),
    .io_level(pipeline_10_io_level),
    .io_offsets_CSR_R_offset(pipeline_10_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_10_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_10_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_10_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_10_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_10_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_10_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_10_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_10_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_10_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_10_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_10_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_10_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_10_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_10_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_10_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_10_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_10_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_10_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_10_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_10_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_10_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_10_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_10_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_10_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_10_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_10_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_10_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_10_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_10_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_10_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_10_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_10_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_10_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_10_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_10_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_10_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_10_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_10_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_10_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_10_io_p2_out_3_bits),
    .io_node_num(pipeline_10_io_node_num),
    .io_push_or_pull(pipeline_10_io_push_or_pull),
    .io_root(pipeline_10_io_root),
    .io_R_array_index_0_ready(pipeline_10_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_10_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_10_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_10_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_10_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_10_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_10_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_10_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_10_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_10_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_10_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_10_io_R_array_index_3_bits),
    .io_p1_end(pipeline_10_io_p1_end),
    .io_uram_out_a_0(pipeline_10_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_10_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_10_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_10_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_10_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_10_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_10_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_10_io_uram_addr_a_3)
  );
  pipeline_25 pipeline_11 ( // @[SLR2.scala 51:65]
    .clock(pipeline_11_clock),
    .reset(pipeline_11_reset),
    .io_frontier_flag(pipeline_11_io_frontier_flag),
    .io_p2_end(pipeline_11_io_p2_end),
    .io_start(pipeline_11_io_start),
    .io_start_init(pipeline_11_io_start_init),
    .io_end(pipeline_11_io_end),
    .io_last_iteration(pipeline_11_io_last_iteration),
    .io_init_bram(pipeline_11_io_init_bram),
    .io_p2_count(pipeline_11_io_p2_count),
    .io_frontier_pull_count(pipeline_11_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_11_io_p2_pull_count),
    .io_level(pipeline_11_io_level),
    .io_offsets_CSR_R_offset(pipeline_11_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_11_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_11_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_11_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_11_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_11_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_11_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_11_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_11_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_11_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_11_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_11_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_11_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_11_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_11_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_11_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_11_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_11_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_11_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_11_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_11_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_11_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_11_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_11_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_11_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_11_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_11_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_11_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_11_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_11_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_11_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_11_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_11_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_11_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_11_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_11_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_11_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_11_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_11_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_11_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_11_io_p2_out_3_bits),
    .io_node_num(pipeline_11_io_node_num),
    .io_push_or_pull(pipeline_11_io_push_or_pull),
    .io_root(pipeline_11_io_root),
    .io_R_array_index_0_ready(pipeline_11_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_11_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_11_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_11_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_11_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_11_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_11_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_11_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_11_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_11_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_11_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_11_io_R_array_index_3_bits),
    .io_p1_end(pipeline_11_io_p1_end),
    .io_uram_out_a_0(pipeline_11_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_11_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_11_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_11_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_11_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_11_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_11_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_11_io_uram_addr_a_3)
  );
  pipeline_26 pipeline_12 ( // @[SLR2.scala 51:65]
    .clock(pipeline_12_clock),
    .reset(pipeline_12_reset),
    .io_frontier_flag(pipeline_12_io_frontier_flag),
    .io_p2_end(pipeline_12_io_p2_end),
    .io_start(pipeline_12_io_start),
    .io_start_init(pipeline_12_io_start_init),
    .io_end(pipeline_12_io_end),
    .io_last_iteration(pipeline_12_io_last_iteration),
    .io_init_bram(pipeline_12_io_init_bram),
    .io_p2_count(pipeline_12_io_p2_count),
    .io_frontier_pull_count(pipeline_12_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_12_io_p2_pull_count),
    .io_level(pipeline_12_io_level),
    .io_offsets_CSR_R_offset(pipeline_12_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_12_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_12_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_12_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_12_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_12_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_12_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_12_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_12_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_12_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_12_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_12_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_12_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_12_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_12_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_12_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_12_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_12_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_12_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_12_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_12_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_12_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_12_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_12_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_12_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_12_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_12_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_12_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_12_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_12_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_12_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_12_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_12_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_12_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_12_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_12_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_12_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_12_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_12_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_12_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_12_io_p2_out_3_bits),
    .io_node_num(pipeline_12_io_node_num),
    .io_push_or_pull(pipeline_12_io_push_or_pull),
    .io_root(pipeline_12_io_root),
    .io_R_array_index_0_ready(pipeline_12_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_12_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_12_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_12_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_12_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_12_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_12_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_12_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_12_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_12_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_12_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_12_io_R_array_index_3_bits),
    .io_p1_end(pipeline_12_io_p1_end),
    .io_uram_out_a_0(pipeline_12_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_12_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_12_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_12_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_12_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_12_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_12_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_12_io_uram_addr_a_3)
  );
  pipeline_27 pipeline_13 ( // @[SLR2.scala 51:65]
    .clock(pipeline_13_clock),
    .reset(pipeline_13_reset),
    .io_frontier_flag(pipeline_13_io_frontier_flag),
    .io_p2_end(pipeline_13_io_p2_end),
    .io_start(pipeline_13_io_start),
    .io_start_init(pipeline_13_io_start_init),
    .io_end(pipeline_13_io_end),
    .io_last_iteration(pipeline_13_io_last_iteration),
    .io_init_bram(pipeline_13_io_init_bram),
    .io_p2_count(pipeline_13_io_p2_count),
    .io_frontier_pull_count(pipeline_13_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_13_io_p2_pull_count),
    .io_level(pipeline_13_io_level),
    .io_offsets_CSR_R_offset(pipeline_13_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_13_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_13_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_13_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_13_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_13_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_13_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_13_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_13_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_13_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_13_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_13_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_13_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_13_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_13_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_13_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_13_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_13_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_13_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_13_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_13_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_13_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_13_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_13_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_13_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_13_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_13_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_13_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_13_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_13_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_13_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_13_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_13_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_13_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_13_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_13_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_13_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_13_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_13_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_13_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_13_io_p2_out_3_bits),
    .io_node_num(pipeline_13_io_node_num),
    .io_push_or_pull(pipeline_13_io_push_or_pull),
    .io_root(pipeline_13_io_root),
    .io_R_array_index_0_ready(pipeline_13_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_13_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_13_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_13_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_13_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_13_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_13_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_13_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_13_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_13_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_13_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_13_io_R_array_index_3_bits),
    .io_p1_end(pipeline_13_io_p1_end),
    .io_uram_out_a_0(pipeline_13_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_13_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_13_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_13_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_13_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_13_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_13_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_13_io_uram_addr_a_3)
  );
  pipeline_28 pipeline_14 ( // @[SLR2.scala 51:65]
    .clock(pipeline_14_clock),
    .reset(pipeline_14_reset),
    .io_frontier_flag(pipeline_14_io_frontier_flag),
    .io_p2_end(pipeline_14_io_p2_end),
    .io_start(pipeline_14_io_start),
    .io_start_init(pipeline_14_io_start_init),
    .io_end(pipeline_14_io_end),
    .io_last_iteration(pipeline_14_io_last_iteration),
    .io_init_bram(pipeline_14_io_init_bram),
    .io_p2_count(pipeline_14_io_p2_count),
    .io_frontier_pull_count(pipeline_14_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_14_io_p2_pull_count),
    .io_level(pipeline_14_io_level),
    .io_offsets_CSR_R_offset(pipeline_14_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_14_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_14_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_14_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_14_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_14_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_14_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_14_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_14_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_14_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_14_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_14_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_14_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_14_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_14_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_14_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_14_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_14_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_14_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_14_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_14_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_14_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_14_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_14_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_14_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_14_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_14_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_14_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_14_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_14_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_14_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_14_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_14_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_14_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_14_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_14_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_14_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_14_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_14_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_14_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_14_io_p2_out_3_bits),
    .io_node_num(pipeline_14_io_node_num),
    .io_push_or_pull(pipeline_14_io_push_or_pull),
    .io_root(pipeline_14_io_root),
    .io_R_array_index_0_ready(pipeline_14_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_14_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_14_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_14_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_14_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_14_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_14_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_14_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_14_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_14_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_14_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_14_io_R_array_index_3_bits),
    .io_p1_end(pipeline_14_io_p1_end),
    .io_uram_out_a_0(pipeline_14_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_14_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_14_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_14_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_14_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_14_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_14_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_14_io_uram_addr_a_3)
  );
  pipeline_29 pipeline_15 ( // @[SLR2.scala 51:65]
    .clock(pipeline_15_clock),
    .reset(pipeline_15_reset),
    .io_frontier_flag(pipeline_15_io_frontier_flag),
    .io_p2_end(pipeline_15_io_p2_end),
    .io_start(pipeline_15_io_start),
    .io_start_init(pipeline_15_io_start_init),
    .io_end(pipeline_15_io_end),
    .io_last_iteration(pipeline_15_io_last_iteration),
    .io_init_bram(pipeline_15_io_init_bram),
    .io_p2_count(pipeline_15_io_p2_count),
    .io_frontier_pull_count(pipeline_15_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_15_io_p2_pull_count),
    .io_level(pipeline_15_io_level),
    .io_offsets_CSR_R_offset(pipeline_15_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_15_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_15_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_15_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_15_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_15_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_15_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_15_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_15_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_15_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_15_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_15_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_15_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_15_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_15_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_15_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_15_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_15_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_15_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_15_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_15_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_15_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_15_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_15_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_15_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_15_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_15_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_15_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_15_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_15_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_15_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_15_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_15_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_15_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_15_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_15_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_15_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_15_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_15_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_15_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_15_io_p2_out_3_bits),
    .io_node_num(pipeline_15_io_node_num),
    .io_push_or_pull(pipeline_15_io_push_or_pull),
    .io_root(pipeline_15_io_root),
    .io_R_array_index_0_ready(pipeline_15_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_15_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_15_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_15_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_15_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_15_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_15_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_15_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_15_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_15_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_15_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_15_io_R_array_index_3_bits),
    .io_p1_end(pipeline_15_io_p1_end),
    .io_uram_out_a_0(pipeline_15_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_15_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_15_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_15_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_15_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_15_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_15_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_15_io_uram_addr_a_3)
  );
  pipeline_30 pipeline_16 ( // @[SLR2.scala 51:65]
    .clock(pipeline_16_clock),
    .reset(pipeline_16_reset),
    .io_frontier_flag(pipeline_16_io_frontier_flag),
    .io_p2_end(pipeline_16_io_p2_end),
    .io_start(pipeline_16_io_start),
    .io_start_init(pipeline_16_io_start_init),
    .io_end(pipeline_16_io_end),
    .io_last_iteration(pipeline_16_io_last_iteration),
    .io_init_bram(pipeline_16_io_init_bram),
    .io_p2_count(pipeline_16_io_p2_count),
    .io_frontier_pull_count(pipeline_16_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_16_io_p2_pull_count),
    .io_level(pipeline_16_io_level),
    .io_offsets_CSR_R_offset(pipeline_16_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_16_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_16_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_16_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_16_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_16_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_16_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_16_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_16_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_16_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_16_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_16_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_16_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_16_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_16_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_16_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_16_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_16_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_16_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_16_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_16_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_16_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_16_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_16_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_16_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_16_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_16_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_16_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_16_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_16_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_16_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_16_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_16_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_16_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_16_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_16_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_16_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_16_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_16_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_16_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_16_io_p2_out_3_bits),
    .io_node_num(pipeline_16_io_node_num),
    .io_push_or_pull(pipeline_16_io_push_or_pull),
    .io_root(pipeline_16_io_root),
    .io_R_array_index_0_ready(pipeline_16_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_16_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_16_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_16_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_16_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_16_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_16_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_16_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_16_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_16_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_16_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_16_io_R_array_index_3_bits),
    .io_p1_end(pipeline_16_io_p1_end),
    .io_uram_out_a_0(pipeline_16_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_16_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_16_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_16_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_16_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_16_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_16_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_16_io_uram_addr_a_3)
  );
  pipeline_31 pipeline_17 ( // @[SLR2.scala 51:65]
    .clock(pipeline_17_clock),
    .reset(pipeline_17_reset),
    .io_frontier_flag(pipeline_17_io_frontier_flag),
    .io_p2_end(pipeline_17_io_p2_end),
    .io_start(pipeline_17_io_start),
    .io_start_init(pipeline_17_io_start_init),
    .io_end(pipeline_17_io_end),
    .io_last_iteration(pipeline_17_io_last_iteration),
    .io_init_bram(pipeline_17_io_init_bram),
    .io_p2_count(pipeline_17_io_p2_count),
    .io_frontier_pull_count(pipeline_17_io_frontier_pull_count),
    .io_p2_pull_count(pipeline_17_io_p2_pull_count),
    .io_level(pipeline_17_io_level),
    .io_offsets_CSR_R_offset(pipeline_17_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(pipeline_17_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(pipeline_17_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(pipeline_17_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(pipeline_17_io_offsets_level_offset),
    .io_p2_in_0_ready(pipeline_17_io_p2_in_0_ready),
    .io_p2_in_0_valid(pipeline_17_io_p2_in_0_valid),
    .io_p2_in_0_bits(pipeline_17_io_p2_in_0_bits),
    .io_p2_in_1_ready(pipeline_17_io_p2_in_1_ready),
    .io_p2_in_1_valid(pipeline_17_io_p2_in_1_valid),
    .io_p2_in_1_bits(pipeline_17_io_p2_in_1_bits),
    .io_p2_in_2_ready(pipeline_17_io_p2_in_2_ready),
    .io_p2_in_2_valid(pipeline_17_io_p2_in_2_valid),
    .io_p2_in_2_bits(pipeline_17_io_p2_in_2_bits),
    .io_p2_in_3_ready(pipeline_17_io_p2_in_3_ready),
    .io_p2_in_3_valid(pipeline_17_io_p2_in_3_valid),
    .io_p2_in_3_bits(pipeline_17_io_p2_in_3_bits),
    .io_frontier_in_0_ready(pipeline_17_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(pipeline_17_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(pipeline_17_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(pipeline_17_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(pipeline_17_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(pipeline_17_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(pipeline_17_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(pipeline_17_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(pipeline_17_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(pipeline_17_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(pipeline_17_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(pipeline_17_io_frontier_in_3_bits),
    .io_p2_out_0_ready(pipeline_17_io_p2_out_0_ready),
    .io_p2_out_0_valid(pipeline_17_io_p2_out_0_valid),
    .io_p2_out_0_bits(pipeline_17_io_p2_out_0_bits),
    .io_p2_out_1_ready(pipeline_17_io_p2_out_1_ready),
    .io_p2_out_1_valid(pipeline_17_io_p2_out_1_valid),
    .io_p2_out_1_bits(pipeline_17_io_p2_out_1_bits),
    .io_p2_out_2_ready(pipeline_17_io_p2_out_2_ready),
    .io_p2_out_2_valid(pipeline_17_io_p2_out_2_valid),
    .io_p2_out_2_bits(pipeline_17_io_p2_out_2_bits),
    .io_p2_out_3_ready(pipeline_17_io_p2_out_3_ready),
    .io_p2_out_3_valid(pipeline_17_io_p2_out_3_valid),
    .io_p2_out_3_bits(pipeline_17_io_p2_out_3_bits),
    .io_node_num(pipeline_17_io_node_num),
    .io_push_or_pull(pipeline_17_io_push_or_pull),
    .io_root(pipeline_17_io_root),
    .io_R_array_index_0_ready(pipeline_17_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(pipeline_17_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(pipeline_17_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(pipeline_17_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(pipeline_17_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(pipeline_17_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(pipeline_17_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(pipeline_17_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(pipeline_17_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(pipeline_17_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(pipeline_17_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(pipeline_17_io_R_array_index_3_bits),
    .io_p1_end(pipeline_17_io_p1_end),
    .io_uram_out_a_0(pipeline_17_io_uram_out_a_0),
    .io_uram_out_a_1(pipeline_17_io_uram_out_a_1),
    .io_uram_out_a_2(pipeline_17_io_uram_out_a_2),
    .io_uram_out_a_3(pipeline_17_io_uram_out_a_3),
    .io_uram_addr_a_0(pipeline_17_io_uram_addr_a_0),
    .io_uram_addr_a_1(pipeline_17_io_uram_addr_a_1),
    .io_uram_addr_a_2(pipeline_17_io_uram_addr_a_2),
    .io_uram_addr_a_3(pipeline_17_io_uram_addr_a_3)
  );
  copy_slr2 copy_start ( // @[SLR2.scala 54:28]
    .clock(copy_start_clock),
    .reset(copy_start_reset),
    .io_in(copy_start_io_in),
    .io_out_0(copy_start_io_out_0),
    .io_out_1(copy_start_io_out_1),
    .io_out_2(copy_start_io_out_2),
    .io_out_3(copy_start_io_out_3),
    .io_out_4(copy_start_io_out_4),
    .io_out_5(copy_start_io_out_5),
    .io_out_6(copy_start_io_out_6),
    .io_out_7(copy_start_io_out_7),
    .io_out_8(copy_start_io_out_8),
    .io_out_9(copy_start_io_out_9),
    .io_out_10(copy_start_io_out_10),
    .io_out_11(copy_start_io_out_11),
    .io_out_12(copy_start_io_out_12),
    .io_out_13(copy_start_io_out_13),
    .io_out_14(copy_start_io_out_14),
    .io_out_15(copy_start_io_out_15),
    .io_out_16(copy_start_io_out_16),
    .io_out_17(copy_start_io_out_17)
  );
  copy_slr2 copy_frontier_flag ( // @[SLR2.scala 56:36]
    .clock(copy_frontier_flag_clock),
    .reset(copy_frontier_flag_reset),
    .io_in(copy_frontier_flag_io_in),
    .io_out_0(copy_frontier_flag_io_out_0),
    .io_out_1(copy_frontier_flag_io_out_1),
    .io_out_2(copy_frontier_flag_io_out_2),
    .io_out_3(copy_frontier_flag_io_out_3),
    .io_out_4(copy_frontier_flag_io_out_4),
    .io_out_5(copy_frontier_flag_io_out_5),
    .io_out_6(copy_frontier_flag_io_out_6),
    .io_out_7(copy_frontier_flag_io_out_7),
    .io_out_8(copy_frontier_flag_io_out_8),
    .io_out_9(copy_frontier_flag_io_out_9),
    .io_out_10(copy_frontier_flag_io_out_10),
    .io_out_11(copy_frontier_flag_io_out_11),
    .io_out_12(copy_frontier_flag_io_out_12),
    .io_out_13(copy_frontier_flag_io_out_13),
    .io_out_14(copy_frontier_flag_io_out_14),
    .io_out_15(copy_frontier_flag_io_out_15),
    .io_out_16(copy_frontier_flag_io_out_16),
    .io_out_17(copy_frontier_flag_io_out_17)
  );
  copy_slr2_2 copy_current_level ( // @[SLR2.scala 57:36]
    .clock(copy_current_level_clock),
    .reset(copy_current_level_reset),
    .io_in(copy_current_level_io_in),
    .io_out_0(copy_current_level_io_out_0),
    .io_out_1(copy_current_level_io_out_1),
    .io_out_2(copy_current_level_io_out_2),
    .io_out_3(copy_current_level_io_out_3),
    .io_out_4(copy_current_level_io_out_4),
    .io_out_5(copy_current_level_io_out_5),
    .io_out_6(copy_current_level_io_out_6),
    .io_out_7(copy_current_level_io_out_7),
    .io_out_8(copy_current_level_io_out_8),
    .io_out_9(copy_current_level_io_out_9),
    .io_out_10(copy_current_level_io_out_10),
    .io_out_11(copy_current_level_io_out_11),
    .io_out_12(copy_current_level_io_out_12),
    .io_out_13(copy_current_level_io_out_13),
    .io_out_14(copy_current_level_io_out_14),
    .io_out_15(copy_current_level_io_out_15),
    .io_out_16(copy_current_level_io_out_16),
    .io_out_17(copy_current_level_io_out_17)
  );
  copy_slr2 copy_p2_end ( // @[SLR2.scala 58:29]
    .clock(copy_p2_end_clock),
    .reset(copy_p2_end_reset),
    .io_in(copy_p2_end_io_in),
    .io_out_0(copy_p2_end_io_out_0),
    .io_out_1(copy_p2_end_io_out_1),
    .io_out_2(copy_p2_end_io_out_2),
    .io_out_3(copy_p2_end_io_out_3),
    .io_out_4(copy_p2_end_io_out_4),
    .io_out_5(copy_p2_end_io_out_5),
    .io_out_6(copy_p2_end_io_out_6),
    .io_out_7(copy_p2_end_io_out_7),
    .io_out_8(copy_p2_end_io_out_8),
    .io_out_9(copy_p2_end_io_out_9),
    .io_out_10(copy_p2_end_io_out_10),
    .io_out_11(copy_p2_end_io_out_11),
    .io_out_12(copy_p2_end_io_out_12),
    .io_out_13(copy_p2_end_io_out_13),
    .io_out_14(copy_p2_end_io_out_14),
    .io_out_15(copy_p2_end_io_out_15),
    .io_out_16(copy_p2_end_io_out_16),
    .io_out_17(copy_p2_end_io_out_17)
  );
  copy_slr2 copy_push_or_pull ( // @[SLR2.scala 59:35]
    .clock(copy_push_or_pull_clock),
    .reset(copy_push_or_pull_reset),
    .io_in(copy_push_or_pull_io_in),
    .io_out_0(copy_push_or_pull_io_out_0),
    .io_out_1(copy_push_or_pull_io_out_1),
    .io_out_2(copy_push_or_pull_io_out_2),
    .io_out_3(copy_push_or_pull_io_out_3),
    .io_out_4(copy_push_or_pull_io_out_4),
    .io_out_5(copy_push_or_pull_io_out_5),
    .io_out_6(copy_push_or_pull_io_out_6),
    .io_out_7(copy_push_or_pull_io_out_7),
    .io_out_8(copy_push_or_pull_io_out_8),
    .io_out_9(copy_push_or_pull_io_out_9),
    .io_out_10(copy_push_or_pull_io_out_10),
    .io_out_11(copy_push_or_pull_io_out_11),
    .io_out_12(copy_push_or_pull_io_out_12),
    .io_out_13(copy_push_or_pull_io_out_13),
    .io_out_14(copy_push_or_pull_io_out_14),
    .io_out_15(copy_push_or_pull_io_out_15),
    .io_out_16(copy_push_or_pull_io_out_16),
    .io_out_17(copy_push_or_pull_io_out_17)
  );
  copy_slr2_2 copy_node_num ( // @[SLR2.scala 60:31]
    .clock(copy_node_num_clock),
    .reset(copy_node_num_reset),
    .io_in(copy_node_num_io_in),
    .io_out_0(copy_node_num_io_out_0),
    .io_out_1(copy_node_num_io_out_1),
    .io_out_2(copy_node_num_io_out_2),
    .io_out_3(copy_node_num_io_out_3),
    .io_out_4(copy_node_num_io_out_4),
    .io_out_5(copy_node_num_io_out_5),
    .io_out_6(copy_node_num_io_out_6),
    .io_out_7(copy_node_num_io_out_7),
    .io_out_8(copy_node_num_io_out_8),
    .io_out_9(copy_node_num_io_out_9),
    .io_out_10(copy_node_num_io_out_10),
    .io_out_11(copy_node_num_io_out_11),
    .io_out_12(copy_node_num_io_out_12),
    .io_out_13(copy_node_num_io_out_13),
    .io_out_14(copy_node_num_io_out_14),
    .io_out_15(copy_node_num_io_out_15),
    .io_out_16(copy_node_num_io_out_16),
    .io_out_17(copy_node_num_io_out_17)
  );
  copy_slr2_2 copy_root ( // @[SLR2.scala 61:27]
    .clock(copy_root_clock),
    .reset(copy_root_reset),
    .io_in(copy_root_io_in),
    .io_out_0(copy_root_io_out_0),
    .io_out_1(copy_root_io_out_1),
    .io_out_2(copy_root_io_out_2),
    .io_out_3(copy_root_io_out_3),
    .io_out_4(copy_root_io_out_4),
    .io_out_5(copy_root_io_out_5),
    .io_out_6(copy_root_io_out_6),
    .io_out_7(copy_root_io_out_7),
    .io_out_8(copy_root_io_out_8),
    .io_out_9(copy_root_io_out_9),
    .io_out_10(copy_root_io_out_10),
    .io_out_11(copy_root_io_out_11),
    .io_out_12(copy_root_io_out_12),
    .io_out_13(copy_root_io_out_13),
    .io_out_14(copy_root_io_out_14),
    .io_out_15(copy_root_io_out_15),
    .io_out_16(copy_root_io_out_16),
    .io_out_17(copy_root_io_out_17)
  );
  copy_slr2_2 copy_offset_CSR_R_offset ( // @[SLR2.scala 72:42]
    .clock(copy_offset_CSR_R_offset_clock),
    .reset(copy_offset_CSR_R_offset_reset),
    .io_in(copy_offset_CSR_R_offset_io_in),
    .io_out_0(copy_offset_CSR_R_offset_io_out_0),
    .io_out_1(copy_offset_CSR_R_offset_io_out_1),
    .io_out_2(copy_offset_CSR_R_offset_io_out_2),
    .io_out_3(copy_offset_CSR_R_offset_io_out_3),
    .io_out_4(copy_offset_CSR_R_offset_io_out_4),
    .io_out_5(copy_offset_CSR_R_offset_io_out_5),
    .io_out_6(copy_offset_CSR_R_offset_io_out_6),
    .io_out_7(copy_offset_CSR_R_offset_io_out_7),
    .io_out_8(copy_offset_CSR_R_offset_io_out_8),
    .io_out_9(copy_offset_CSR_R_offset_io_out_9),
    .io_out_10(copy_offset_CSR_R_offset_io_out_10),
    .io_out_11(copy_offset_CSR_R_offset_io_out_11),
    .io_out_12(copy_offset_CSR_R_offset_io_out_12),
    .io_out_13(copy_offset_CSR_R_offset_io_out_13),
    .io_out_14(copy_offset_CSR_R_offset_io_out_14),
    .io_out_15(copy_offset_CSR_R_offset_io_out_15),
    .io_out_16(copy_offset_CSR_R_offset_io_out_16),
    .io_out_17(copy_offset_CSR_R_offset_io_out_17)
  );
  copy_slr2_2 copy_offset_CSR_C_offset ( // @[SLR2.scala 73:42]
    .clock(copy_offset_CSR_C_offset_clock),
    .reset(copy_offset_CSR_C_offset_reset),
    .io_in(copy_offset_CSR_C_offset_io_in),
    .io_out_0(copy_offset_CSR_C_offset_io_out_0),
    .io_out_1(copy_offset_CSR_C_offset_io_out_1),
    .io_out_2(copy_offset_CSR_C_offset_io_out_2),
    .io_out_3(copy_offset_CSR_C_offset_io_out_3),
    .io_out_4(copy_offset_CSR_C_offset_io_out_4),
    .io_out_5(copy_offset_CSR_C_offset_io_out_5),
    .io_out_6(copy_offset_CSR_C_offset_io_out_6),
    .io_out_7(copy_offset_CSR_C_offset_io_out_7),
    .io_out_8(copy_offset_CSR_C_offset_io_out_8),
    .io_out_9(copy_offset_CSR_C_offset_io_out_9),
    .io_out_10(copy_offset_CSR_C_offset_io_out_10),
    .io_out_11(copy_offset_CSR_C_offset_io_out_11),
    .io_out_12(copy_offset_CSR_C_offset_io_out_12),
    .io_out_13(copy_offset_CSR_C_offset_io_out_13),
    .io_out_14(copy_offset_CSR_C_offset_io_out_14),
    .io_out_15(copy_offset_CSR_C_offset_io_out_15),
    .io_out_16(copy_offset_CSR_C_offset_io_out_16),
    .io_out_17(copy_offset_CSR_C_offset_io_out_17)
  );
  copy_slr2_2 copy_offset_CSC_R_offset ( // @[SLR2.scala 74:42]
    .clock(copy_offset_CSC_R_offset_clock),
    .reset(copy_offset_CSC_R_offset_reset),
    .io_in(copy_offset_CSC_R_offset_io_in),
    .io_out_0(copy_offset_CSC_R_offset_io_out_0),
    .io_out_1(copy_offset_CSC_R_offset_io_out_1),
    .io_out_2(copy_offset_CSC_R_offset_io_out_2),
    .io_out_3(copy_offset_CSC_R_offset_io_out_3),
    .io_out_4(copy_offset_CSC_R_offset_io_out_4),
    .io_out_5(copy_offset_CSC_R_offset_io_out_5),
    .io_out_6(copy_offset_CSC_R_offset_io_out_6),
    .io_out_7(copy_offset_CSC_R_offset_io_out_7),
    .io_out_8(copy_offset_CSC_R_offset_io_out_8),
    .io_out_9(copy_offset_CSC_R_offset_io_out_9),
    .io_out_10(copy_offset_CSC_R_offset_io_out_10),
    .io_out_11(copy_offset_CSC_R_offset_io_out_11),
    .io_out_12(copy_offset_CSC_R_offset_io_out_12),
    .io_out_13(copy_offset_CSC_R_offset_io_out_13),
    .io_out_14(copy_offset_CSC_R_offset_io_out_14),
    .io_out_15(copy_offset_CSC_R_offset_io_out_15),
    .io_out_16(copy_offset_CSC_R_offset_io_out_16),
    .io_out_17(copy_offset_CSC_R_offset_io_out_17)
  );
  copy_slr2_2 copy_offset_CSC_C_offset ( // @[SLR2.scala 75:42]
    .clock(copy_offset_CSC_C_offset_clock),
    .reset(copy_offset_CSC_C_offset_reset),
    .io_in(copy_offset_CSC_C_offset_io_in),
    .io_out_0(copy_offset_CSC_C_offset_io_out_0),
    .io_out_1(copy_offset_CSC_C_offset_io_out_1),
    .io_out_2(copy_offset_CSC_C_offset_io_out_2),
    .io_out_3(copy_offset_CSC_C_offset_io_out_3),
    .io_out_4(copy_offset_CSC_C_offset_io_out_4),
    .io_out_5(copy_offset_CSC_C_offset_io_out_5),
    .io_out_6(copy_offset_CSC_C_offset_io_out_6),
    .io_out_7(copy_offset_CSC_C_offset_io_out_7),
    .io_out_8(copy_offset_CSC_C_offset_io_out_8),
    .io_out_9(copy_offset_CSC_C_offset_io_out_9),
    .io_out_10(copy_offset_CSC_C_offset_io_out_10),
    .io_out_11(copy_offset_CSC_C_offset_io_out_11),
    .io_out_12(copy_offset_CSC_C_offset_io_out_12),
    .io_out_13(copy_offset_CSC_C_offset_io_out_13),
    .io_out_14(copy_offset_CSC_C_offset_io_out_14),
    .io_out_15(copy_offset_CSC_C_offset_io_out_15),
    .io_out_16(copy_offset_CSC_C_offset_io_out_16),
    .io_out_17(copy_offset_CSC_C_offset_io_out_17)
  );
  copy_slr2_2 copy_offset_level_offset ( // @[SLR2.scala 76:42]
    .clock(copy_offset_level_offset_clock),
    .reset(copy_offset_level_offset_reset),
    .io_in(copy_offset_level_offset_io_in),
    .io_out_0(copy_offset_level_offset_io_out_0),
    .io_out_1(copy_offset_level_offset_io_out_1),
    .io_out_2(copy_offset_level_offset_io_out_2),
    .io_out_3(copy_offset_level_offset_io_out_3),
    .io_out_4(copy_offset_level_offset_io_out_4),
    .io_out_5(copy_offset_level_offset_io_out_5),
    .io_out_6(copy_offset_level_offset_io_out_6),
    .io_out_7(copy_offset_level_offset_io_out_7),
    .io_out_8(copy_offset_level_offset_io_out_8),
    .io_out_9(copy_offset_level_offset_io_out_9),
    .io_out_10(copy_offset_level_offset_io_out_10),
    .io_out_11(copy_offset_level_offset_io_out_11),
    .io_out_12(copy_offset_level_offset_io_out_12),
    .io_out_13(copy_offset_level_offset_io_out_13),
    .io_out_14(copy_offset_level_offset_io_out_14),
    .io_out_15(copy_offset_level_offset_io_out_15),
    .io_out_16(copy_offset_level_offset_io_out_16),
    .io_out_17(copy_offset_level_offset_io_out_17)
  );
  assign io_end_0 = pipeline_io_end; // @[SLR2.scala 89:19]
  assign io_end_1 = pipeline_1_io_end; // @[SLR2.scala 89:19]
  assign io_end_2 = pipeline_2_io_end; // @[SLR2.scala 89:19]
  assign io_end_3 = pipeline_3_io_end; // @[SLR2.scala 89:19]
  assign io_end_4 = pipeline_4_io_end; // @[SLR2.scala 89:19]
  assign io_end_5 = pipeline_5_io_end; // @[SLR2.scala 89:19]
  assign io_end_6 = pipeline_6_io_end; // @[SLR2.scala 89:19]
  assign io_end_7 = pipeline_7_io_end; // @[SLR2.scala 89:19]
  assign io_end_8 = pipeline_8_io_end; // @[SLR2.scala 89:19]
  assign io_end_9 = pipeline_9_io_end; // @[SLR2.scala 89:19]
  assign io_end_10 = pipeline_10_io_end; // @[SLR2.scala 89:19]
  assign io_end_11 = pipeline_11_io_end; // @[SLR2.scala 89:19]
  assign io_end_12 = pipeline_12_io_end; // @[SLR2.scala 89:19]
  assign io_end_13 = pipeline_13_io_end; // @[SLR2.scala 89:19]
  assign io_end_14 = pipeline_14_io_end; // @[SLR2.scala 89:19]
  assign io_end_15 = pipeline_15_io_end; // @[SLR2.scala 89:19]
  assign io_end_16 = pipeline_16_io_end; // @[SLR2.scala 89:19]
  assign io_end_17 = pipeline_17_io_end; // @[SLR2.scala 89:19]
  assign io_p2_count_0 = pipeline_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_1 = pipeline_1_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_2 = pipeline_2_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_3 = pipeline_3_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_4 = pipeline_4_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_5 = pipeline_5_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_6 = pipeline_6_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_7 = pipeline_7_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_8 = pipeline_8_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_9 = pipeline_9_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_10 = pipeline_10_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_11 = pipeline_11_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_12 = pipeline_12_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_13 = pipeline_13_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_14 = pipeline_14_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_15 = pipeline_15_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_16 = pipeline_16_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_count_17 = pipeline_17_io_p2_count; // @[SLR2.scala 90:24]
  assign io_p2_pull_count_0 = pipeline_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_1 = pipeline_1_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_2 = pipeline_2_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_3 = pipeline_3_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_4 = pipeline_4_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_5 = pipeline_5_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_6 = pipeline_6_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_7 = pipeline_7_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_8 = pipeline_8_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_9 = pipeline_9_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_10 = pipeline_10_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_11 = pipeline_11_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_12 = pipeline_12_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_13 = pipeline_13_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_14 = pipeline_14_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_15 = pipeline_15_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_16 = pipeline_16_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_p2_pull_count_17 = pipeline_17_io_p2_pull_count; // @[SLR2.scala 92:29]
  assign io_frontier_pull_count_0 = pipeline_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_1 = pipeline_1_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_2 = pipeline_2_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_3 = pipeline_3_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_4 = pipeline_4_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_5 = pipeline_5_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_6 = pipeline_6_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_7 = pipeline_7_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_8 = pipeline_8_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_9 = pipeline_9_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_10 = pipeline_10_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_11 = pipeline_11_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_12 = pipeline_12_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_13 = pipeline_13_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_14 = pipeline_14_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_15 = pipeline_15_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_16 = pipeline_16_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_frontier_pull_count_17 = pipeline_17_io_frontier_pull_count; // @[SLR2.scala 93:35]
  assign io_last_iteration_0 = pipeline_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_1 = pipeline_1_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_2 = pipeline_2_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_3 = pipeline_3_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_4 = pipeline_4_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_5 = pipeline_5_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_6 = pipeline_6_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_7 = pipeline_7_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_8 = pipeline_8_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_9 = pipeline_9_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_10 = pipeline_10_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_11 = pipeline_11_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_12 = pipeline_12_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_13 = pipeline_13_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_14 = pipeline_14_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_15 = pipeline_15_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_16 = pipeline_16_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_last_iteration_17 = pipeline_17_io_last_iteration; // @[SLR2.scala 94:30]
  assign io_init_bram_0 = pipeline_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_1 = pipeline_1_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_2 = pipeline_2_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_3 = pipeline_3_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_4 = pipeline_4_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_5 = pipeline_5_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_6 = pipeline_6_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_7 = pipeline_7_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_8 = pipeline_8_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_9 = pipeline_9_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_10 = pipeline_10_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_11 = pipeline_11_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_12 = pipeline_12_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_13 = pipeline_13_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_14 = pipeline_14_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_15 = pipeline_15_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_16 = pipeline_16_io_init_bram; // @[SLR2.scala 95:25]
  assign io_init_bram_17 = pipeline_17_io_init_bram; // @[SLR2.scala 95:25]
  assign io_p2_in_0_ready = pipeline_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_1_ready = pipeline_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_2_ready = pipeline_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_3_ready = pipeline_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_4_ready = pipeline_1_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_5_ready = pipeline_1_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_6_ready = pipeline_1_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_7_ready = pipeline_1_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_8_ready = pipeline_2_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_9_ready = pipeline_2_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_10_ready = pipeline_2_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_11_ready = pipeline_2_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_12_ready = pipeline_3_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_13_ready = pipeline_3_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_14_ready = pipeline_3_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_15_ready = pipeline_3_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_16_ready = pipeline_4_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_17_ready = pipeline_4_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_18_ready = pipeline_4_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_19_ready = pipeline_4_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_20_ready = pipeline_5_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_21_ready = pipeline_5_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_22_ready = pipeline_5_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_23_ready = pipeline_5_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_24_ready = pipeline_6_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_25_ready = pipeline_6_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_26_ready = pipeline_6_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_27_ready = pipeline_6_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_28_ready = pipeline_7_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_29_ready = pipeline_7_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_30_ready = pipeline_7_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_31_ready = pipeline_7_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_32_ready = pipeline_8_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_33_ready = pipeline_8_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_34_ready = pipeline_8_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_35_ready = pipeline_8_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_36_ready = pipeline_9_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_37_ready = pipeline_9_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_38_ready = pipeline_9_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_39_ready = pipeline_9_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_40_ready = pipeline_10_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_41_ready = pipeline_10_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_42_ready = pipeline_10_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_43_ready = pipeline_10_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_44_ready = pipeline_11_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_45_ready = pipeline_11_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_46_ready = pipeline_11_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_47_ready = pipeline_11_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_48_ready = pipeline_12_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_49_ready = pipeline_12_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_50_ready = pipeline_12_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_51_ready = pipeline_12_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_52_ready = pipeline_13_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_53_ready = pipeline_13_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_54_ready = pipeline_13_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_55_ready = pipeline_13_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_56_ready = pipeline_14_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_57_ready = pipeline_14_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_58_ready = pipeline_14_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_59_ready = pipeline_14_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_60_ready = pipeline_15_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_61_ready = pipeline_15_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_62_ready = pipeline_15_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_63_ready = pipeline_15_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_64_ready = pipeline_16_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_65_ready = pipeline_16_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_66_ready = pipeline_16_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_67_ready = pipeline_16_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_68_ready = pipeline_17_io_p2_in_0_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_69_ready = pipeline_17_io_p2_in_1_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_70_ready = pipeline_17_io_p2_in_2_ready; // @[SLR2.scala 120:52]
  assign io_p2_in_71_ready = pipeline_17_io_p2_in_3_ready; // @[SLR2.scala 120:52]
  assign io_frontier_in_0_ready = pipeline_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_1_ready = pipeline_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_2_ready = pipeline_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_3_ready = pipeline_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_4_ready = pipeline_1_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_5_ready = pipeline_1_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_6_ready = pipeline_1_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_7_ready = pipeline_1_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_8_ready = pipeline_2_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_9_ready = pipeline_2_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_10_ready = pipeline_2_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_11_ready = pipeline_2_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_12_ready = pipeline_3_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_13_ready = pipeline_3_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_14_ready = pipeline_3_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_15_ready = pipeline_3_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_16_ready = pipeline_4_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_17_ready = pipeline_4_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_18_ready = pipeline_4_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_19_ready = pipeline_4_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_20_ready = pipeline_5_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_21_ready = pipeline_5_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_22_ready = pipeline_5_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_23_ready = pipeline_5_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_24_ready = pipeline_6_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_25_ready = pipeline_6_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_26_ready = pipeline_6_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_27_ready = pipeline_6_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_28_ready = pipeline_7_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_29_ready = pipeline_7_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_30_ready = pipeline_7_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_31_ready = pipeline_7_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_32_ready = pipeline_8_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_33_ready = pipeline_8_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_34_ready = pipeline_8_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_35_ready = pipeline_8_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_36_ready = pipeline_9_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_37_ready = pipeline_9_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_38_ready = pipeline_9_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_39_ready = pipeline_9_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_40_ready = pipeline_10_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_41_ready = pipeline_10_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_42_ready = pipeline_10_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_43_ready = pipeline_10_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_44_ready = pipeline_11_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_45_ready = pipeline_11_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_46_ready = pipeline_11_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_47_ready = pipeline_11_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_48_ready = pipeline_12_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_49_ready = pipeline_12_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_50_ready = pipeline_12_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_51_ready = pipeline_12_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_52_ready = pipeline_13_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_53_ready = pipeline_13_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_54_ready = pipeline_13_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_55_ready = pipeline_13_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_56_ready = pipeline_14_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_57_ready = pipeline_14_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_58_ready = pipeline_14_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_59_ready = pipeline_14_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_60_ready = pipeline_15_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_61_ready = pipeline_15_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_62_ready = pipeline_15_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_63_ready = pipeline_15_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_64_ready = pipeline_16_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_65_ready = pipeline_16_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_66_ready = pipeline_16_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_67_ready = pipeline_16_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_68_ready = pipeline_17_io_frontier_in_0_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_69_ready = pipeline_17_io_frontier_in_1_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_70_ready = pipeline_17_io_frontier_in_2_ready; // @[SLR2.scala 122:52]
  assign io_frontier_in_71_ready = pipeline_17_io_frontier_in_3_ready; // @[SLR2.scala 122:52]
  assign io_p2_out_0_valid = pipeline_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_0_bits = pipeline_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_1_valid = pipeline_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_1_bits = pipeline_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_2_valid = pipeline_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_2_bits = pipeline_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_3_valid = pipeline_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_3_bits = pipeline_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_4_valid = pipeline_1_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_4_bits = pipeline_1_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_5_valid = pipeline_1_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_5_bits = pipeline_1_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_6_valid = pipeline_1_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_6_bits = pipeline_1_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_7_valid = pipeline_1_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_7_bits = pipeline_1_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_8_valid = pipeline_2_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_8_bits = pipeline_2_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_9_valid = pipeline_2_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_9_bits = pipeline_2_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_10_valid = pipeline_2_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_10_bits = pipeline_2_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_11_valid = pipeline_2_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_11_bits = pipeline_2_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_12_valid = pipeline_3_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_12_bits = pipeline_3_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_13_valid = pipeline_3_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_13_bits = pipeline_3_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_14_valid = pipeline_3_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_14_bits = pipeline_3_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_15_valid = pipeline_3_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_15_bits = pipeline_3_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_16_valid = pipeline_4_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_16_bits = pipeline_4_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_17_valid = pipeline_4_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_17_bits = pipeline_4_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_18_valid = pipeline_4_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_18_bits = pipeline_4_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_19_valid = pipeline_4_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_19_bits = pipeline_4_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_20_valid = pipeline_5_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_20_bits = pipeline_5_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_21_valid = pipeline_5_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_21_bits = pipeline_5_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_22_valid = pipeline_5_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_22_bits = pipeline_5_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_23_valid = pipeline_5_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_23_bits = pipeline_5_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_24_valid = pipeline_6_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_24_bits = pipeline_6_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_25_valid = pipeline_6_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_25_bits = pipeline_6_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_26_valid = pipeline_6_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_26_bits = pipeline_6_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_27_valid = pipeline_6_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_27_bits = pipeline_6_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_28_valid = pipeline_7_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_28_bits = pipeline_7_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_29_valid = pipeline_7_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_29_bits = pipeline_7_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_30_valid = pipeline_7_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_30_bits = pipeline_7_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_31_valid = pipeline_7_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_31_bits = pipeline_7_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_32_valid = pipeline_8_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_32_bits = pipeline_8_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_33_valid = pipeline_8_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_33_bits = pipeline_8_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_34_valid = pipeline_8_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_34_bits = pipeline_8_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_35_valid = pipeline_8_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_35_bits = pipeline_8_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_36_valid = pipeline_9_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_36_bits = pipeline_9_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_37_valid = pipeline_9_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_37_bits = pipeline_9_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_38_valid = pipeline_9_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_38_bits = pipeline_9_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_39_valid = pipeline_9_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_39_bits = pipeline_9_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_40_valid = pipeline_10_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_40_bits = pipeline_10_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_41_valid = pipeline_10_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_41_bits = pipeline_10_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_42_valid = pipeline_10_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_42_bits = pipeline_10_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_43_valid = pipeline_10_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_43_bits = pipeline_10_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_44_valid = pipeline_11_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_44_bits = pipeline_11_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_45_valid = pipeline_11_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_45_bits = pipeline_11_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_46_valid = pipeline_11_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_46_bits = pipeline_11_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_47_valid = pipeline_11_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_47_bits = pipeline_11_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_48_valid = pipeline_12_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_48_bits = pipeline_12_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_49_valid = pipeline_12_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_49_bits = pipeline_12_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_50_valid = pipeline_12_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_50_bits = pipeline_12_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_51_valid = pipeline_12_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_51_bits = pipeline_12_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_52_valid = pipeline_13_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_52_bits = pipeline_13_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_53_valid = pipeline_13_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_53_bits = pipeline_13_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_54_valid = pipeline_13_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_54_bits = pipeline_13_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_55_valid = pipeline_13_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_55_bits = pipeline_13_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_56_valid = pipeline_14_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_56_bits = pipeline_14_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_57_valid = pipeline_14_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_57_bits = pipeline_14_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_58_valid = pipeline_14_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_58_bits = pipeline_14_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_59_valid = pipeline_14_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_59_bits = pipeline_14_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_60_valid = pipeline_15_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_60_bits = pipeline_15_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_61_valid = pipeline_15_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_61_bits = pipeline_15_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_62_valid = pipeline_15_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_62_bits = pipeline_15_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_63_valid = pipeline_15_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_63_bits = pipeline_15_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_64_valid = pipeline_16_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_64_bits = pipeline_16_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_65_valid = pipeline_16_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_65_bits = pipeline_16_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_66_valid = pipeline_16_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_66_bits = pipeline_16_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_67_valid = pipeline_16_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_67_bits = pipeline_16_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_68_valid = pipeline_17_io_p2_out_0_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_68_bits = pipeline_17_io_p2_out_0_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_69_valid = pipeline_17_io_p2_out_1_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_69_bits = pipeline_17_io_p2_out_1_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_70_valid = pipeline_17_io_p2_out_2_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_70_bits = pipeline_17_io_p2_out_2_bits; // @[SLR2.scala 123:52]
  assign io_p2_out_71_valid = pipeline_17_io_p2_out_3_valid; // @[SLR2.scala 123:52]
  assign io_p2_out_71_bits = pipeline_17_io_p2_out_3_bits; // @[SLR2.scala 123:52]
  assign io_R_array_index_0_valid = pipeline_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_0_bits = pipeline_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_1_valid = pipeline_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_1_bits = pipeline_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_2_valid = pipeline_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_2_bits = pipeline_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_3_valid = pipeline_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_3_bits = pipeline_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_4_valid = pipeline_1_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_4_bits = pipeline_1_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_5_valid = pipeline_1_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_5_bits = pipeline_1_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_6_valid = pipeline_1_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_6_bits = pipeline_1_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_7_valid = pipeline_1_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_7_bits = pipeline_1_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_8_valid = pipeline_2_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_8_bits = pipeline_2_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_9_valid = pipeline_2_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_9_bits = pipeline_2_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_10_valid = pipeline_2_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_10_bits = pipeline_2_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_11_valid = pipeline_2_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_11_bits = pipeline_2_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_12_valid = pipeline_3_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_12_bits = pipeline_3_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_13_valid = pipeline_3_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_13_bits = pipeline_3_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_14_valid = pipeline_3_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_14_bits = pipeline_3_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_15_valid = pipeline_3_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_15_bits = pipeline_3_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_16_valid = pipeline_4_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_16_bits = pipeline_4_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_17_valid = pipeline_4_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_17_bits = pipeline_4_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_18_valid = pipeline_4_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_18_bits = pipeline_4_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_19_valid = pipeline_4_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_19_bits = pipeline_4_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_20_valid = pipeline_5_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_20_bits = pipeline_5_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_21_valid = pipeline_5_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_21_bits = pipeline_5_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_22_valid = pipeline_5_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_22_bits = pipeline_5_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_23_valid = pipeline_5_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_23_bits = pipeline_5_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_24_valid = pipeline_6_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_24_bits = pipeline_6_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_25_valid = pipeline_6_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_25_bits = pipeline_6_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_26_valid = pipeline_6_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_26_bits = pipeline_6_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_27_valid = pipeline_6_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_27_bits = pipeline_6_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_28_valid = pipeline_7_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_28_bits = pipeline_7_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_29_valid = pipeline_7_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_29_bits = pipeline_7_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_30_valid = pipeline_7_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_30_bits = pipeline_7_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_31_valid = pipeline_7_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_31_bits = pipeline_7_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_32_valid = pipeline_8_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_32_bits = pipeline_8_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_33_valid = pipeline_8_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_33_bits = pipeline_8_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_34_valid = pipeline_8_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_34_bits = pipeline_8_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_35_valid = pipeline_8_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_35_bits = pipeline_8_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_36_valid = pipeline_9_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_36_bits = pipeline_9_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_37_valid = pipeline_9_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_37_bits = pipeline_9_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_38_valid = pipeline_9_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_38_bits = pipeline_9_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_39_valid = pipeline_9_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_39_bits = pipeline_9_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_40_valid = pipeline_10_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_40_bits = pipeline_10_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_41_valid = pipeline_10_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_41_bits = pipeline_10_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_42_valid = pipeline_10_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_42_bits = pipeline_10_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_43_valid = pipeline_10_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_43_bits = pipeline_10_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_44_valid = pipeline_11_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_44_bits = pipeline_11_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_45_valid = pipeline_11_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_45_bits = pipeline_11_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_46_valid = pipeline_11_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_46_bits = pipeline_11_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_47_valid = pipeline_11_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_47_bits = pipeline_11_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_48_valid = pipeline_12_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_48_bits = pipeline_12_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_49_valid = pipeline_12_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_49_bits = pipeline_12_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_50_valid = pipeline_12_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_50_bits = pipeline_12_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_51_valid = pipeline_12_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_51_bits = pipeline_12_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_52_valid = pipeline_13_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_52_bits = pipeline_13_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_53_valid = pipeline_13_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_53_bits = pipeline_13_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_54_valid = pipeline_13_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_54_bits = pipeline_13_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_55_valid = pipeline_13_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_55_bits = pipeline_13_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_56_valid = pipeline_14_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_56_bits = pipeline_14_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_57_valid = pipeline_14_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_57_bits = pipeline_14_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_58_valid = pipeline_14_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_58_bits = pipeline_14_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_59_valid = pipeline_14_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_59_bits = pipeline_14_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_60_valid = pipeline_15_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_60_bits = pipeline_15_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_61_valid = pipeline_15_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_61_bits = pipeline_15_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_62_valid = pipeline_15_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_62_bits = pipeline_15_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_63_valid = pipeline_15_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_63_bits = pipeline_15_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_64_valid = pipeline_16_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_64_bits = pipeline_16_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_65_valid = pipeline_16_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_65_bits = pipeline_16_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_66_valid = pipeline_16_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_66_bits = pipeline_16_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_67_valid = pipeline_16_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_67_bits = pipeline_16_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_68_valid = pipeline_17_io_R_array_index_0_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_68_bits = pipeline_17_io_R_array_index_0_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_69_valid = pipeline_17_io_R_array_index_1_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_69_bits = pipeline_17_io_R_array_index_1_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_70_valid = pipeline_17_io_R_array_index_2_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_70_bits = pipeline_17_io_R_array_index_2_bits; // @[SLR2.scala 124:52]
  assign io_R_array_index_71_valid = pipeline_17_io_R_array_index_3_valid; // @[SLR2.scala 124:52]
  assign io_R_array_index_71_bits = pipeline_17_io_R_array_index_3_bits; // @[SLR2.scala 124:52]
  assign io_p1_end_0 = pipeline_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_1 = pipeline_1_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_2 = pipeline_2_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_3 = pipeline_3_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_4 = pipeline_4_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_5 = pipeline_5_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_6 = pipeline_6_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_7 = pipeline_7_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_8 = pipeline_8_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_9 = pipeline_9_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_10 = pipeline_10_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_11 = pipeline_11_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_12 = pipeline_12_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_13 = pipeline_13_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_14 = pipeline_14_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_15 = pipeline_15_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_16 = pipeline_16_io_p1_end; // @[SLR2.scala 116:37]
  assign io_p1_end_17 = pipeline_17_io_p1_end; // @[SLR2.scala 116:37]
  assign io_uram_out_a_0 = _T_167; // @[SLR2.scala 125:61]
  assign io_uram_out_a_1 = _T_172; // @[SLR2.scala 125:61]
  assign io_uram_out_a_2 = _T_177; // @[SLR2.scala 125:61]
  assign io_uram_out_a_3 = _T_182; // @[SLR2.scala 125:61]
  assign io_uram_out_a_4 = _T_187; // @[SLR2.scala 125:61]
  assign io_uram_out_a_5 = _T_192; // @[SLR2.scala 125:61]
  assign io_uram_out_a_6 = _T_197; // @[SLR2.scala 125:61]
  assign io_uram_out_a_7 = _T_202; // @[SLR2.scala 125:61]
  assign io_uram_out_a_8 = _T_207; // @[SLR2.scala 125:61]
  assign io_uram_out_a_9 = _T_212; // @[SLR2.scala 125:61]
  assign io_uram_out_a_10 = _T_217; // @[SLR2.scala 125:61]
  assign io_uram_out_a_11 = _T_222; // @[SLR2.scala 125:61]
  assign io_uram_out_a_12 = _T_227; // @[SLR2.scala 125:61]
  assign io_uram_out_a_13 = _T_232; // @[SLR2.scala 125:61]
  assign io_uram_out_a_14 = _T_237; // @[SLR2.scala 125:61]
  assign io_uram_out_a_15 = _T_242; // @[SLR2.scala 125:61]
  assign io_uram_out_a_16 = _T_247; // @[SLR2.scala 125:61]
  assign io_uram_out_a_17 = _T_252; // @[SLR2.scala 125:61]
  assign io_uram_out_a_18 = _T_257; // @[SLR2.scala 125:61]
  assign io_uram_out_a_19 = _T_262; // @[SLR2.scala 125:61]
  assign io_uram_out_a_20 = _T_267; // @[SLR2.scala 125:61]
  assign io_uram_out_a_21 = _T_272; // @[SLR2.scala 125:61]
  assign io_uram_out_a_22 = _T_277; // @[SLR2.scala 125:61]
  assign io_uram_out_a_23 = _T_282; // @[SLR2.scala 125:61]
  assign io_uram_out_a_24 = _T_287; // @[SLR2.scala 125:61]
  assign io_uram_out_a_25 = _T_292; // @[SLR2.scala 125:61]
  assign io_uram_out_a_26 = _T_297; // @[SLR2.scala 125:61]
  assign io_uram_out_a_27 = _T_302; // @[SLR2.scala 125:61]
  assign io_uram_out_a_28 = _T_307; // @[SLR2.scala 125:61]
  assign io_uram_out_a_29 = _T_312; // @[SLR2.scala 125:61]
  assign io_uram_out_a_30 = _T_317; // @[SLR2.scala 125:61]
  assign io_uram_out_a_31 = _T_322; // @[SLR2.scala 125:61]
  assign io_uram_out_a_32 = _T_327; // @[SLR2.scala 125:61]
  assign io_uram_out_a_33 = _T_332; // @[SLR2.scala 125:61]
  assign io_uram_out_a_34 = _T_337; // @[SLR2.scala 125:61]
  assign io_uram_out_a_35 = _T_342; // @[SLR2.scala 125:61]
  assign io_uram_out_a_36 = _T_347; // @[SLR2.scala 125:61]
  assign io_uram_out_a_37 = _T_352; // @[SLR2.scala 125:61]
  assign io_uram_out_a_38 = _T_357; // @[SLR2.scala 125:61]
  assign io_uram_out_a_39 = _T_362; // @[SLR2.scala 125:61]
  assign io_uram_out_a_40 = _T_367; // @[SLR2.scala 125:61]
  assign io_uram_out_a_41 = _T_372; // @[SLR2.scala 125:61]
  assign io_uram_out_a_42 = _T_377; // @[SLR2.scala 125:61]
  assign io_uram_out_a_43 = _T_382; // @[SLR2.scala 125:61]
  assign io_uram_out_a_44 = _T_387; // @[SLR2.scala 125:61]
  assign io_uram_out_a_45 = _T_392; // @[SLR2.scala 125:61]
  assign io_uram_out_a_46 = _T_397; // @[SLR2.scala 125:61]
  assign io_uram_out_a_47 = _T_402; // @[SLR2.scala 125:61]
  assign io_uram_out_a_48 = _T_407; // @[SLR2.scala 125:61]
  assign io_uram_out_a_49 = _T_412; // @[SLR2.scala 125:61]
  assign io_uram_out_a_50 = _T_417; // @[SLR2.scala 125:61]
  assign io_uram_out_a_51 = _T_422; // @[SLR2.scala 125:61]
  assign io_uram_out_a_52 = _T_427; // @[SLR2.scala 125:61]
  assign io_uram_out_a_53 = _T_432; // @[SLR2.scala 125:61]
  assign io_uram_out_a_54 = _T_437; // @[SLR2.scala 125:61]
  assign io_uram_out_a_55 = _T_442; // @[SLR2.scala 125:61]
  assign io_uram_out_a_56 = _T_447; // @[SLR2.scala 125:61]
  assign io_uram_out_a_57 = _T_452; // @[SLR2.scala 125:61]
  assign io_uram_out_a_58 = _T_457; // @[SLR2.scala 125:61]
  assign io_uram_out_a_59 = _T_462; // @[SLR2.scala 125:61]
  assign io_uram_out_a_60 = _T_467; // @[SLR2.scala 125:61]
  assign io_uram_out_a_61 = _T_472; // @[SLR2.scala 125:61]
  assign io_uram_out_a_62 = _T_477; // @[SLR2.scala 125:61]
  assign io_uram_out_a_63 = _T_482; // @[SLR2.scala 125:61]
  assign io_uram_out_a_64 = _T_487; // @[SLR2.scala 125:61]
  assign io_uram_out_a_65 = _T_492; // @[SLR2.scala 125:61]
  assign io_uram_out_a_66 = _T_497; // @[SLR2.scala 125:61]
  assign io_uram_out_a_67 = _T_502; // @[SLR2.scala 125:61]
  assign io_uram_out_a_68 = _T_507; // @[SLR2.scala 125:61]
  assign io_uram_out_a_69 = _T_512; // @[SLR2.scala 125:61]
  assign io_uram_out_a_70 = _T_517; // @[SLR2.scala 125:61]
  assign io_uram_out_a_71 = _T_522; // @[SLR2.scala 125:61]
  assign pipeline_clock = clock;
  assign pipeline_reset = reset_reg_array_0;
  assign pipeline_io_frontier_flag = copy_frontier_flag_io_out_0; // @[SLR2.scala 102:44]
  assign pipeline_io_p2_end = copy_p2_end_io_out_0; // @[SLR2.scala 100:37]
  assign pipeline_io_start = copy_start_io_out_0; // @[SLR2.scala 101:36]
  assign pipeline_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_io_level = copy_current_level_io_out_0; // @[SLR2.scala 103:36]
  assign pipeline_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_0; // @[SLR2.scala 104:51]
  assign pipeline_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_0; // @[SLR2.scala 105:51]
  assign pipeline_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_0; // @[SLR2.scala 106:51]
  assign pipeline_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_0; // @[SLR2.scala 107:51]
  assign pipeline_io_offsets_level_offset = copy_offset_level_offset_io_out_0; // @[SLR2.scala 108:51]
  assign pipeline_io_p2_in_0_valid = io_p2_in_0_valid; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_0_bits = io_p2_in_0_bits; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_1_valid = io_p2_in_1_valid; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_1_bits = io_p2_in_1_bits; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_2_valid = io_p2_in_2_valid; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_2_bits = io_p2_in_2_bits; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_3_valid = io_p2_in_3_valid; // @[SLR2.scala 120:52]
  assign pipeline_io_p2_in_3_bits = io_p2_in_3_bits; // @[SLR2.scala 120:52]
  assign pipeline_io_frontier_in_0_valid = io_frontier_in_0_valid; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_0_bits = io_frontier_in_0_bits; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_1_valid = io_frontier_in_1_valid; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_1_bits = io_frontier_in_1_bits; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_2_valid = io_frontier_in_2_valid; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_2_bits = io_frontier_in_2_bits; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_3_valid = io_frontier_in_3_valid; // @[SLR2.scala 122:52]
  assign pipeline_io_frontier_in_3_bits = io_frontier_in_3_bits; // @[SLR2.scala 122:52]
  assign pipeline_io_p2_out_0_ready = io_p2_out_0_ready; // @[SLR2.scala 123:52]
  assign pipeline_io_p2_out_1_ready = io_p2_out_1_ready; // @[SLR2.scala 123:52]
  assign pipeline_io_p2_out_2_ready = io_p2_out_2_ready; // @[SLR2.scala 123:52]
  assign pipeline_io_p2_out_3_ready = io_p2_out_3_ready; // @[SLR2.scala 123:52]
  assign pipeline_io_node_num = copy_node_num_io_out_0; // @[SLR2.scala 110:39]
  assign pipeline_io_push_or_pull = copy_push_or_pull_io_out_0; // @[SLR2.scala 112:43]
  assign pipeline_io_root = copy_root_io_out_0; // @[SLR2.scala 111:39]
  assign pipeline_io_R_array_index_0_ready = io_R_array_index_0_ready; // @[SLR2.scala 124:52]
  assign pipeline_io_R_array_index_1_ready = io_R_array_index_1_ready; // @[SLR2.scala 124:52]
  assign pipeline_io_R_array_index_2_ready = io_R_array_index_2_ready; // @[SLR2.scala 124:52]
  assign pipeline_io_R_array_index_3_ready = io_R_array_index_3_ready; // @[SLR2.scala 124:52]
  assign pipeline_io_uram_addr_a_0 = _T_168; // @[SLR2.scala 126:52]
  assign pipeline_io_uram_addr_a_1 = _T_173; // @[SLR2.scala 126:52]
  assign pipeline_io_uram_addr_a_2 = _T_178; // @[SLR2.scala 126:52]
  assign pipeline_io_uram_addr_a_3 = _T_183; // @[SLR2.scala 126:52]
  assign pipeline_1_clock = clock;
  assign pipeline_1_reset = reset_reg_array_1;
  assign pipeline_1_io_frontier_flag = copy_frontier_flag_io_out_1; // @[SLR2.scala 102:44]
  assign pipeline_1_io_p2_end = copy_p2_end_io_out_1; // @[SLR2.scala 100:37]
  assign pipeline_1_io_start = copy_start_io_out_1; // @[SLR2.scala 101:36]
  assign pipeline_1_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_1_io_level = copy_current_level_io_out_1; // @[SLR2.scala 103:36]
  assign pipeline_1_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_1; // @[SLR2.scala 104:51]
  assign pipeline_1_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_1; // @[SLR2.scala 105:51]
  assign pipeline_1_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_1; // @[SLR2.scala 106:51]
  assign pipeline_1_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_1; // @[SLR2.scala 107:51]
  assign pipeline_1_io_offsets_level_offset = copy_offset_level_offset_io_out_1; // @[SLR2.scala 108:51]
  assign pipeline_1_io_p2_in_0_valid = io_p2_in_4_valid; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_0_bits = io_p2_in_4_bits; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_1_valid = io_p2_in_5_valid; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_1_bits = io_p2_in_5_bits; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_2_valid = io_p2_in_6_valid; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_2_bits = io_p2_in_6_bits; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_3_valid = io_p2_in_7_valid; // @[SLR2.scala 120:52]
  assign pipeline_1_io_p2_in_3_bits = io_p2_in_7_bits; // @[SLR2.scala 120:52]
  assign pipeline_1_io_frontier_in_0_valid = io_frontier_in_4_valid; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_0_bits = io_frontier_in_4_bits; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_1_valid = io_frontier_in_5_valid; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_1_bits = io_frontier_in_5_bits; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_2_valid = io_frontier_in_6_valid; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_2_bits = io_frontier_in_6_bits; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_3_valid = io_frontier_in_7_valid; // @[SLR2.scala 122:52]
  assign pipeline_1_io_frontier_in_3_bits = io_frontier_in_7_bits; // @[SLR2.scala 122:52]
  assign pipeline_1_io_p2_out_0_ready = io_p2_out_4_ready; // @[SLR2.scala 123:52]
  assign pipeline_1_io_p2_out_1_ready = io_p2_out_5_ready; // @[SLR2.scala 123:52]
  assign pipeline_1_io_p2_out_2_ready = io_p2_out_6_ready; // @[SLR2.scala 123:52]
  assign pipeline_1_io_p2_out_3_ready = io_p2_out_7_ready; // @[SLR2.scala 123:52]
  assign pipeline_1_io_node_num = copy_node_num_io_out_1; // @[SLR2.scala 110:39]
  assign pipeline_1_io_push_or_pull = copy_push_or_pull_io_out_1; // @[SLR2.scala 112:43]
  assign pipeline_1_io_root = copy_root_io_out_1; // @[SLR2.scala 111:39]
  assign pipeline_1_io_R_array_index_0_ready = io_R_array_index_4_ready; // @[SLR2.scala 124:52]
  assign pipeline_1_io_R_array_index_1_ready = io_R_array_index_5_ready; // @[SLR2.scala 124:52]
  assign pipeline_1_io_R_array_index_2_ready = io_R_array_index_6_ready; // @[SLR2.scala 124:52]
  assign pipeline_1_io_R_array_index_3_ready = io_R_array_index_7_ready; // @[SLR2.scala 124:52]
  assign pipeline_1_io_uram_addr_a_0 = _T_188; // @[SLR2.scala 126:52]
  assign pipeline_1_io_uram_addr_a_1 = _T_193; // @[SLR2.scala 126:52]
  assign pipeline_1_io_uram_addr_a_2 = _T_198; // @[SLR2.scala 126:52]
  assign pipeline_1_io_uram_addr_a_3 = _T_203; // @[SLR2.scala 126:52]
  assign pipeline_2_clock = clock;
  assign pipeline_2_reset = reset_reg_array_2;
  assign pipeline_2_io_frontier_flag = copy_frontier_flag_io_out_2; // @[SLR2.scala 102:44]
  assign pipeline_2_io_p2_end = copy_p2_end_io_out_2; // @[SLR2.scala 100:37]
  assign pipeline_2_io_start = copy_start_io_out_2; // @[SLR2.scala 101:36]
  assign pipeline_2_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_2_io_level = copy_current_level_io_out_2; // @[SLR2.scala 103:36]
  assign pipeline_2_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_2; // @[SLR2.scala 104:51]
  assign pipeline_2_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_2; // @[SLR2.scala 105:51]
  assign pipeline_2_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_2; // @[SLR2.scala 106:51]
  assign pipeline_2_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_2; // @[SLR2.scala 107:51]
  assign pipeline_2_io_offsets_level_offset = copy_offset_level_offset_io_out_2; // @[SLR2.scala 108:51]
  assign pipeline_2_io_p2_in_0_valid = io_p2_in_8_valid; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_0_bits = io_p2_in_8_bits; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_1_valid = io_p2_in_9_valid; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_1_bits = io_p2_in_9_bits; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_2_valid = io_p2_in_10_valid; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_2_bits = io_p2_in_10_bits; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_3_valid = io_p2_in_11_valid; // @[SLR2.scala 120:52]
  assign pipeline_2_io_p2_in_3_bits = io_p2_in_11_bits; // @[SLR2.scala 120:52]
  assign pipeline_2_io_frontier_in_0_valid = io_frontier_in_8_valid; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_0_bits = io_frontier_in_8_bits; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_1_valid = io_frontier_in_9_valid; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_1_bits = io_frontier_in_9_bits; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_2_valid = io_frontier_in_10_valid; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_2_bits = io_frontier_in_10_bits; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_3_valid = io_frontier_in_11_valid; // @[SLR2.scala 122:52]
  assign pipeline_2_io_frontier_in_3_bits = io_frontier_in_11_bits; // @[SLR2.scala 122:52]
  assign pipeline_2_io_p2_out_0_ready = io_p2_out_8_ready; // @[SLR2.scala 123:52]
  assign pipeline_2_io_p2_out_1_ready = io_p2_out_9_ready; // @[SLR2.scala 123:52]
  assign pipeline_2_io_p2_out_2_ready = io_p2_out_10_ready; // @[SLR2.scala 123:52]
  assign pipeline_2_io_p2_out_3_ready = io_p2_out_11_ready; // @[SLR2.scala 123:52]
  assign pipeline_2_io_node_num = copy_node_num_io_out_2; // @[SLR2.scala 110:39]
  assign pipeline_2_io_push_or_pull = copy_push_or_pull_io_out_2; // @[SLR2.scala 112:43]
  assign pipeline_2_io_root = copy_root_io_out_2; // @[SLR2.scala 111:39]
  assign pipeline_2_io_R_array_index_0_ready = io_R_array_index_8_ready; // @[SLR2.scala 124:52]
  assign pipeline_2_io_R_array_index_1_ready = io_R_array_index_9_ready; // @[SLR2.scala 124:52]
  assign pipeline_2_io_R_array_index_2_ready = io_R_array_index_10_ready; // @[SLR2.scala 124:52]
  assign pipeline_2_io_R_array_index_3_ready = io_R_array_index_11_ready; // @[SLR2.scala 124:52]
  assign pipeline_2_io_uram_addr_a_0 = _T_208; // @[SLR2.scala 126:52]
  assign pipeline_2_io_uram_addr_a_1 = _T_213; // @[SLR2.scala 126:52]
  assign pipeline_2_io_uram_addr_a_2 = _T_218; // @[SLR2.scala 126:52]
  assign pipeline_2_io_uram_addr_a_3 = _T_223; // @[SLR2.scala 126:52]
  assign pipeline_3_clock = clock;
  assign pipeline_3_reset = reset_reg_array_3;
  assign pipeline_3_io_frontier_flag = copy_frontier_flag_io_out_3; // @[SLR2.scala 102:44]
  assign pipeline_3_io_p2_end = copy_p2_end_io_out_3; // @[SLR2.scala 100:37]
  assign pipeline_3_io_start = copy_start_io_out_3; // @[SLR2.scala 101:36]
  assign pipeline_3_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_3_io_level = copy_current_level_io_out_3; // @[SLR2.scala 103:36]
  assign pipeline_3_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_3; // @[SLR2.scala 104:51]
  assign pipeline_3_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_3; // @[SLR2.scala 105:51]
  assign pipeline_3_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_3; // @[SLR2.scala 106:51]
  assign pipeline_3_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_3; // @[SLR2.scala 107:51]
  assign pipeline_3_io_offsets_level_offset = copy_offset_level_offset_io_out_3; // @[SLR2.scala 108:51]
  assign pipeline_3_io_p2_in_0_valid = io_p2_in_12_valid; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_0_bits = io_p2_in_12_bits; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_1_valid = io_p2_in_13_valid; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_1_bits = io_p2_in_13_bits; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_2_valid = io_p2_in_14_valid; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_2_bits = io_p2_in_14_bits; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_3_valid = io_p2_in_15_valid; // @[SLR2.scala 120:52]
  assign pipeline_3_io_p2_in_3_bits = io_p2_in_15_bits; // @[SLR2.scala 120:52]
  assign pipeline_3_io_frontier_in_0_valid = io_frontier_in_12_valid; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_0_bits = io_frontier_in_12_bits; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_1_valid = io_frontier_in_13_valid; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_1_bits = io_frontier_in_13_bits; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_2_valid = io_frontier_in_14_valid; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_2_bits = io_frontier_in_14_bits; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_3_valid = io_frontier_in_15_valid; // @[SLR2.scala 122:52]
  assign pipeline_3_io_frontier_in_3_bits = io_frontier_in_15_bits; // @[SLR2.scala 122:52]
  assign pipeline_3_io_p2_out_0_ready = io_p2_out_12_ready; // @[SLR2.scala 123:52]
  assign pipeline_3_io_p2_out_1_ready = io_p2_out_13_ready; // @[SLR2.scala 123:52]
  assign pipeline_3_io_p2_out_2_ready = io_p2_out_14_ready; // @[SLR2.scala 123:52]
  assign pipeline_3_io_p2_out_3_ready = io_p2_out_15_ready; // @[SLR2.scala 123:52]
  assign pipeline_3_io_node_num = copy_node_num_io_out_3; // @[SLR2.scala 110:39]
  assign pipeline_3_io_push_or_pull = copy_push_or_pull_io_out_3; // @[SLR2.scala 112:43]
  assign pipeline_3_io_root = copy_root_io_out_3; // @[SLR2.scala 111:39]
  assign pipeline_3_io_R_array_index_0_ready = io_R_array_index_12_ready; // @[SLR2.scala 124:52]
  assign pipeline_3_io_R_array_index_1_ready = io_R_array_index_13_ready; // @[SLR2.scala 124:52]
  assign pipeline_3_io_R_array_index_2_ready = io_R_array_index_14_ready; // @[SLR2.scala 124:52]
  assign pipeline_3_io_R_array_index_3_ready = io_R_array_index_15_ready; // @[SLR2.scala 124:52]
  assign pipeline_3_io_uram_addr_a_0 = _T_228; // @[SLR2.scala 126:52]
  assign pipeline_3_io_uram_addr_a_1 = _T_233; // @[SLR2.scala 126:52]
  assign pipeline_3_io_uram_addr_a_2 = _T_238; // @[SLR2.scala 126:52]
  assign pipeline_3_io_uram_addr_a_3 = _T_243; // @[SLR2.scala 126:52]
  assign pipeline_4_clock = clock;
  assign pipeline_4_reset = reset_reg_array_4;
  assign pipeline_4_io_frontier_flag = copy_frontier_flag_io_out_4; // @[SLR2.scala 102:44]
  assign pipeline_4_io_p2_end = copy_p2_end_io_out_4; // @[SLR2.scala 100:37]
  assign pipeline_4_io_start = copy_start_io_out_4; // @[SLR2.scala 101:36]
  assign pipeline_4_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_4_io_level = copy_current_level_io_out_4; // @[SLR2.scala 103:36]
  assign pipeline_4_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_4; // @[SLR2.scala 104:51]
  assign pipeline_4_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_4; // @[SLR2.scala 105:51]
  assign pipeline_4_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_4; // @[SLR2.scala 106:51]
  assign pipeline_4_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_4; // @[SLR2.scala 107:51]
  assign pipeline_4_io_offsets_level_offset = copy_offset_level_offset_io_out_4; // @[SLR2.scala 108:51]
  assign pipeline_4_io_p2_in_0_valid = io_p2_in_16_valid; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_0_bits = io_p2_in_16_bits; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_1_valid = io_p2_in_17_valid; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_1_bits = io_p2_in_17_bits; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_2_valid = io_p2_in_18_valid; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_2_bits = io_p2_in_18_bits; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_3_valid = io_p2_in_19_valid; // @[SLR2.scala 120:52]
  assign pipeline_4_io_p2_in_3_bits = io_p2_in_19_bits; // @[SLR2.scala 120:52]
  assign pipeline_4_io_frontier_in_0_valid = io_frontier_in_16_valid; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_0_bits = io_frontier_in_16_bits; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_1_valid = io_frontier_in_17_valid; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_1_bits = io_frontier_in_17_bits; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_2_valid = io_frontier_in_18_valid; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_2_bits = io_frontier_in_18_bits; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_3_valid = io_frontier_in_19_valid; // @[SLR2.scala 122:52]
  assign pipeline_4_io_frontier_in_3_bits = io_frontier_in_19_bits; // @[SLR2.scala 122:52]
  assign pipeline_4_io_p2_out_0_ready = io_p2_out_16_ready; // @[SLR2.scala 123:52]
  assign pipeline_4_io_p2_out_1_ready = io_p2_out_17_ready; // @[SLR2.scala 123:52]
  assign pipeline_4_io_p2_out_2_ready = io_p2_out_18_ready; // @[SLR2.scala 123:52]
  assign pipeline_4_io_p2_out_3_ready = io_p2_out_19_ready; // @[SLR2.scala 123:52]
  assign pipeline_4_io_node_num = copy_node_num_io_out_4; // @[SLR2.scala 110:39]
  assign pipeline_4_io_push_or_pull = copy_push_or_pull_io_out_4; // @[SLR2.scala 112:43]
  assign pipeline_4_io_root = copy_root_io_out_4; // @[SLR2.scala 111:39]
  assign pipeline_4_io_R_array_index_0_ready = io_R_array_index_16_ready; // @[SLR2.scala 124:52]
  assign pipeline_4_io_R_array_index_1_ready = io_R_array_index_17_ready; // @[SLR2.scala 124:52]
  assign pipeline_4_io_R_array_index_2_ready = io_R_array_index_18_ready; // @[SLR2.scala 124:52]
  assign pipeline_4_io_R_array_index_3_ready = io_R_array_index_19_ready; // @[SLR2.scala 124:52]
  assign pipeline_4_io_uram_addr_a_0 = _T_248; // @[SLR2.scala 126:52]
  assign pipeline_4_io_uram_addr_a_1 = _T_253; // @[SLR2.scala 126:52]
  assign pipeline_4_io_uram_addr_a_2 = _T_258; // @[SLR2.scala 126:52]
  assign pipeline_4_io_uram_addr_a_3 = _T_263; // @[SLR2.scala 126:52]
  assign pipeline_5_clock = clock;
  assign pipeline_5_reset = reset_reg_array_5;
  assign pipeline_5_io_frontier_flag = copy_frontier_flag_io_out_5; // @[SLR2.scala 102:44]
  assign pipeline_5_io_p2_end = copy_p2_end_io_out_5; // @[SLR2.scala 100:37]
  assign pipeline_5_io_start = copy_start_io_out_5; // @[SLR2.scala 101:36]
  assign pipeline_5_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_5_io_level = copy_current_level_io_out_5; // @[SLR2.scala 103:36]
  assign pipeline_5_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_5; // @[SLR2.scala 104:51]
  assign pipeline_5_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_5; // @[SLR2.scala 105:51]
  assign pipeline_5_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_5; // @[SLR2.scala 106:51]
  assign pipeline_5_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_5; // @[SLR2.scala 107:51]
  assign pipeline_5_io_offsets_level_offset = copy_offset_level_offset_io_out_5; // @[SLR2.scala 108:51]
  assign pipeline_5_io_p2_in_0_valid = io_p2_in_20_valid; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_0_bits = io_p2_in_20_bits; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_1_valid = io_p2_in_21_valid; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_1_bits = io_p2_in_21_bits; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_2_valid = io_p2_in_22_valid; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_2_bits = io_p2_in_22_bits; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_3_valid = io_p2_in_23_valid; // @[SLR2.scala 120:52]
  assign pipeline_5_io_p2_in_3_bits = io_p2_in_23_bits; // @[SLR2.scala 120:52]
  assign pipeline_5_io_frontier_in_0_valid = io_frontier_in_20_valid; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_0_bits = io_frontier_in_20_bits; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_1_valid = io_frontier_in_21_valid; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_1_bits = io_frontier_in_21_bits; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_2_valid = io_frontier_in_22_valid; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_2_bits = io_frontier_in_22_bits; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_3_valid = io_frontier_in_23_valid; // @[SLR2.scala 122:52]
  assign pipeline_5_io_frontier_in_3_bits = io_frontier_in_23_bits; // @[SLR2.scala 122:52]
  assign pipeline_5_io_p2_out_0_ready = io_p2_out_20_ready; // @[SLR2.scala 123:52]
  assign pipeline_5_io_p2_out_1_ready = io_p2_out_21_ready; // @[SLR2.scala 123:52]
  assign pipeline_5_io_p2_out_2_ready = io_p2_out_22_ready; // @[SLR2.scala 123:52]
  assign pipeline_5_io_p2_out_3_ready = io_p2_out_23_ready; // @[SLR2.scala 123:52]
  assign pipeline_5_io_node_num = copy_node_num_io_out_5; // @[SLR2.scala 110:39]
  assign pipeline_5_io_push_or_pull = copy_push_or_pull_io_out_5; // @[SLR2.scala 112:43]
  assign pipeline_5_io_root = copy_root_io_out_5; // @[SLR2.scala 111:39]
  assign pipeline_5_io_R_array_index_0_ready = io_R_array_index_20_ready; // @[SLR2.scala 124:52]
  assign pipeline_5_io_R_array_index_1_ready = io_R_array_index_21_ready; // @[SLR2.scala 124:52]
  assign pipeline_5_io_R_array_index_2_ready = io_R_array_index_22_ready; // @[SLR2.scala 124:52]
  assign pipeline_5_io_R_array_index_3_ready = io_R_array_index_23_ready; // @[SLR2.scala 124:52]
  assign pipeline_5_io_uram_addr_a_0 = _T_268; // @[SLR2.scala 126:52]
  assign pipeline_5_io_uram_addr_a_1 = _T_273; // @[SLR2.scala 126:52]
  assign pipeline_5_io_uram_addr_a_2 = _T_278; // @[SLR2.scala 126:52]
  assign pipeline_5_io_uram_addr_a_3 = _T_283; // @[SLR2.scala 126:52]
  assign pipeline_6_clock = clock;
  assign pipeline_6_reset = reset_reg_array_6;
  assign pipeline_6_io_frontier_flag = copy_frontier_flag_io_out_6; // @[SLR2.scala 102:44]
  assign pipeline_6_io_p2_end = copy_p2_end_io_out_6; // @[SLR2.scala 100:37]
  assign pipeline_6_io_start = copy_start_io_out_6; // @[SLR2.scala 101:36]
  assign pipeline_6_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_6_io_level = copy_current_level_io_out_6; // @[SLR2.scala 103:36]
  assign pipeline_6_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_6; // @[SLR2.scala 104:51]
  assign pipeline_6_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_6; // @[SLR2.scala 105:51]
  assign pipeline_6_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_6; // @[SLR2.scala 106:51]
  assign pipeline_6_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_6; // @[SLR2.scala 107:51]
  assign pipeline_6_io_offsets_level_offset = copy_offset_level_offset_io_out_6; // @[SLR2.scala 108:51]
  assign pipeline_6_io_p2_in_0_valid = io_p2_in_24_valid; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_0_bits = io_p2_in_24_bits; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_1_valid = io_p2_in_25_valid; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_1_bits = io_p2_in_25_bits; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_2_valid = io_p2_in_26_valid; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_2_bits = io_p2_in_26_bits; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_3_valid = io_p2_in_27_valid; // @[SLR2.scala 120:52]
  assign pipeline_6_io_p2_in_3_bits = io_p2_in_27_bits; // @[SLR2.scala 120:52]
  assign pipeline_6_io_frontier_in_0_valid = io_frontier_in_24_valid; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_0_bits = io_frontier_in_24_bits; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_1_valid = io_frontier_in_25_valid; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_1_bits = io_frontier_in_25_bits; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_2_valid = io_frontier_in_26_valid; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_2_bits = io_frontier_in_26_bits; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_3_valid = io_frontier_in_27_valid; // @[SLR2.scala 122:52]
  assign pipeline_6_io_frontier_in_3_bits = io_frontier_in_27_bits; // @[SLR2.scala 122:52]
  assign pipeline_6_io_p2_out_0_ready = io_p2_out_24_ready; // @[SLR2.scala 123:52]
  assign pipeline_6_io_p2_out_1_ready = io_p2_out_25_ready; // @[SLR2.scala 123:52]
  assign pipeline_6_io_p2_out_2_ready = io_p2_out_26_ready; // @[SLR2.scala 123:52]
  assign pipeline_6_io_p2_out_3_ready = io_p2_out_27_ready; // @[SLR2.scala 123:52]
  assign pipeline_6_io_node_num = copy_node_num_io_out_6; // @[SLR2.scala 110:39]
  assign pipeline_6_io_push_or_pull = copy_push_or_pull_io_out_6; // @[SLR2.scala 112:43]
  assign pipeline_6_io_root = copy_root_io_out_6; // @[SLR2.scala 111:39]
  assign pipeline_6_io_R_array_index_0_ready = io_R_array_index_24_ready; // @[SLR2.scala 124:52]
  assign pipeline_6_io_R_array_index_1_ready = io_R_array_index_25_ready; // @[SLR2.scala 124:52]
  assign pipeline_6_io_R_array_index_2_ready = io_R_array_index_26_ready; // @[SLR2.scala 124:52]
  assign pipeline_6_io_R_array_index_3_ready = io_R_array_index_27_ready; // @[SLR2.scala 124:52]
  assign pipeline_6_io_uram_addr_a_0 = _T_288; // @[SLR2.scala 126:52]
  assign pipeline_6_io_uram_addr_a_1 = _T_293; // @[SLR2.scala 126:52]
  assign pipeline_6_io_uram_addr_a_2 = _T_298; // @[SLR2.scala 126:52]
  assign pipeline_6_io_uram_addr_a_3 = _T_303; // @[SLR2.scala 126:52]
  assign pipeline_7_clock = clock;
  assign pipeline_7_reset = reset_reg_array_7;
  assign pipeline_7_io_frontier_flag = copy_frontier_flag_io_out_7; // @[SLR2.scala 102:44]
  assign pipeline_7_io_p2_end = copy_p2_end_io_out_7; // @[SLR2.scala 100:37]
  assign pipeline_7_io_start = copy_start_io_out_7; // @[SLR2.scala 101:36]
  assign pipeline_7_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_7_io_level = copy_current_level_io_out_7; // @[SLR2.scala 103:36]
  assign pipeline_7_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_7; // @[SLR2.scala 104:51]
  assign pipeline_7_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_7; // @[SLR2.scala 105:51]
  assign pipeline_7_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_7; // @[SLR2.scala 106:51]
  assign pipeline_7_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_7; // @[SLR2.scala 107:51]
  assign pipeline_7_io_offsets_level_offset = copy_offset_level_offset_io_out_7; // @[SLR2.scala 108:51]
  assign pipeline_7_io_p2_in_0_valid = io_p2_in_28_valid; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_0_bits = io_p2_in_28_bits; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_1_valid = io_p2_in_29_valid; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_1_bits = io_p2_in_29_bits; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_2_valid = io_p2_in_30_valid; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_2_bits = io_p2_in_30_bits; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_3_valid = io_p2_in_31_valid; // @[SLR2.scala 120:52]
  assign pipeline_7_io_p2_in_3_bits = io_p2_in_31_bits; // @[SLR2.scala 120:52]
  assign pipeline_7_io_frontier_in_0_valid = io_frontier_in_28_valid; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_0_bits = io_frontier_in_28_bits; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_1_valid = io_frontier_in_29_valid; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_1_bits = io_frontier_in_29_bits; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_2_valid = io_frontier_in_30_valid; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_2_bits = io_frontier_in_30_bits; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_3_valid = io_frontier_in_31_valid; // @[SLR2.scala 122:52]
  assign pipeline_7_io_frontier_in_3_bits = io_frontier_in_31_bits; // @[SLR2.scala 122:52]
  assign pipeline_7_io_p2_out_0_ready = io_p2_out_28_ready; // @[SLR2.scala 123:52]
  assign pipeline_7_io_p2_out_1_ready = io_p2_out_29_ready; // @[SLR2.scala 123:52]
  assign pipeline_7_io_p2_out_2_ready = io_p2_out_30_ready; // @[SLR2.scala 123:52]
  assign pipeline_7_io_p2_out_3_ready = io_p2_out_31_ready; // @[SLR2.scala 123:52]
  assign pipeline_7_io_node_num = copy_node_num_io_out_7; // @[SLR2.scala 110:39]
  assign pipeline_7_io_push_or_pull = copy_push_or_pull_io_out_7; // @[SLR2.scala 112:43]
  assign pipeline_7_io_root = copy_root_io_out_7; // @[SLR2.scala 111:39]
  assign pipeline_7_io_R_array_index_0_ready = io_R_array_index_28_ready; // @[SLR2.scala 124:52]
  assign pipeline_7_io_R_array_index_1_ready = io_R_array_index_29_ready; // @[SLR2.scala 124:52]
  assign pipeline_7_io_R_array_index_2_ready = io_R_array_index_30_ready; // @[SLR2.scala 124:52]
  assign pipeline_7_io_R_array_index_3_ready = io_R_array_index_31_ready; // @[SLR2.scala 124:52]
  assign pipeline_7_io_uram_addr_a_0 = _T_308; // @[SLR2.scala 126:52]
  assign pipeline_7_io_uram_addr_a_1 = _T_313; // @[SLR2.scala 126:52]
  assign pipeline_7_io_uram_addr_a_2 = _T_318; // @[SLR2.scala 126:52]
  assign pipeline_7_io_uram_addr_a_3 = _T_323; // @[SLR2.scala 126:52]
  assign pipeline_8_clock = clock;
  assign pipeline_8_reset = reset_reg_array_8;
  assign pipeline_8_io_frontier_flag = copy_frontier_flag_io_out_8; // @[SLR2.scala 102:44]
  assign pipeline_8_io_p2_end = copy_p2_end_io_out_8; // @[SLR2.scala 100:37]
  assign pipeline_8_io_start = copy_start_io_out_8; // @[SLR2.scala 101:36]
  assign pipeline_8_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_8_io_level = copy_current_level_io_out_8; // @[SLR2.scala 103:36]
  assign pipeline_8_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_8; // @[SLR2.scala 104:51]
  assign pipeline_8_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_8; // @[SLR2.scala 105:51]
  assign pipeline_8_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_8; // @[SLR2.scala 106:51]
  assign pipeline_8_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_8; // @[SLR2.scala 107:51]
  assign pipeline_8_io_offsets_level_offset = copy_offset_level_offset_io_out_8; // @[SLR2.scala 108:51]
  assign pipeline_8_io_p2_in_0_valid = io_p2_in_32_valid; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_0_bits = io_p2_in_32_bits; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_1_valid = io_p2_in_33_valid; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_1_bits = io_p2_in_33_bits; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_2_valid = io_p2_in_34_valid; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_2_bits = io_p2_in_34_bits; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_3_valid = io_p2_in_35_valid; // @[SLR2.scala 120:52]
  assign pipeline_8_io_p2_in_3_bits = io_p2_in_35_bits; // @[SLR2.scala 120:52]
  assign pipeline_8_io_frontier_in_0_valid = io_frontier_in_32_valid; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_0_bits = io_frontier_in_32_bits; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_1_valid = io_frontier_in_33_valid; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_1_bits = io_frontier_in_33_bits; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_2_valid = io_frontier_in_34_valid; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_2_bits = io_frontier_in_34_bits; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_3_valid = io_frontier_in_35_valid; // @[SLR2.scala 122:52]
  assign pipeline_8_io_frontier_in_3_bits = io_frontier_in_35_bits; // @[SLR2.scala 122:52]
  assign pipeline_8_io_p2_out_0_ready = io_p2_out_32_ready; // @[SLR2.scala 123:52]
  assign pipeline_8_io_p2_out_1_ready = io_p2_out_33_ready; // @[SLR2.scala 123:52]
  assign pipeline_8_io_p2_out_2_ready = io_p2_out_34_ready; // @[SLR2.scala 123:52]
  assign pipeline_8_io_p2_out_3_ready = io_p2_out_35_ready; // @[SLR2.scala 123:52]
  assign pipeline_8_io_node_num = copy_node_num_io_out_8; // @[SLR2.scala 110:39]
  assign pipeline_8_io_push_or_pull = copy_push_or_pull_io_out_8; // @[SLR2.scala 112:43]
  assign pipeline_8_io_root = copy_root_io_out_8; // @[SLR2.scala 111:39]
  assign pipeline_8_io_R_array_index_0_ready = io_R_array_index_32_ready; // @[SLR2.scala 124:52]
  assign pipeline_8_io_R_array_index_1_ready = io_R_array_index_33_ready; // @[SLR2.scala 124:52]
  assign pipeline_8_io_R_array_index_2_ready = io_R_array_index_34_ready; // @[SLR2.scala 124:52]
  assign pipeline_8_io_R_array_index_3_ready = io_R_array_index_35_ready; // @[SLR2.scala 124:52]
  assign pipeline_8_io_uram_addr_a_0 = _T_328; // @[SLR2.scala 126:52]
  assign pipeline_8_io_uram_addr_a_1 = _T_333; // @[SLR2.scala 126:52]
  assign pipeline_8_io_uram_addr_a_2 = _T_338; // @[SLR2.scala 126:52]
  assign pipeline_8_io_uram_addr_a_3 = _T_343; // @[SLR2.scala 126:52]
  assign pipeline_9_clock = clock;
  assign pipeline_9_reset = reset_reg_array_9;
  assign pipeline_9_io_frontier_flag = copy_frontier_flag_io_out_9; // @[SLR2.scala 102:44]
  assign pipeline_9_io_p2_end = copy_p2_end_io_out_9; // @[SLR2.scala 100:37]
  assign pipeline_9_io_start = copy_start_io_out_9; // @[SLR2.scala 101:36]
  assign pipeline_9_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_9_io_level = copy_current_level_io_out_9; // @[SLR2.scala 103:36]
  assign pipeline_9_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_9; // @[SLR2.scala 104:51]
  assign pipeline_9_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_9; // @[SLR2.scala 105:51]
  assign pipeline_9_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_9; // @[SLR2.scala 106:51]
  assign pipeline_9_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_9; // @[SLR2.scala 107:51]
  assign pipeline_9_io_offsets_level_offset = copy_offset_level_offset_io_out_9; // @[SLR2.scala 108:51]
  assign pipeline_9_io_p2_in_0_valid = io_p2_in_36_valid; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_0_bits = io_p2_in_36_bits; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_1_valid = io_p2_in_37_valid; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_1_bits = io_p2_in_37_bits; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_2_valid = io_p2_in_38_valid; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_2_bits = io_p2_in_38_bits; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_3_valid = io_p2_in_39_valid; // @[SLR2.scala 120:52]
  assign pipeline_9_io_p2_in_3_bits = io_p2_in_39_bits; // @[SLR2.scala 120:52]
  assign pipeline_9_io_frontier_in_0_valid = io_frontier_in_36_valid; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_0_bits = io_frontier_in_36_bits; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_1_valid = io_frontier_in_37_valid; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_1_bits = io_frontier_in_37_bits; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_2_valid = io_frontier_in_38_valid; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_2_bits = io_frontier_in_38_bits; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_3_valid = io_frontier_in_39_valid; // @[SLR2.scala 122:52]
  assign pipeline_9_io_frontier_in_3_bits = io_frontier_in_39_bits; // @[SLR2.scala 122:52]
  assign pipeline_9_io_p2_out_0_ready = io_p2_out_36_ready; // @[SLR2.scala 123:52]
  assign pipeline_9_io_p2_out_1_ready = io_p2_out_37_ready; // @[SLR2.scala 123:52]
  assign pipeline_9_io_p2_out_2_ready = io_p2_out_38_ready; // @[SLR2.scala 123:52]
  assign pipeline_9_io_p2_out_3_ready = io_p2_out_39_ready; // @[SLR2.scala 123:52]
  assign pipeline_9_io_node_num = copy_node_num_io_out_9; // @[SLR2.scala 110:39]
  assign pipeline_9_io_push_or_pull = copy_push_or_pull_io_out_9; // @[SLR2.scala 112:43]
  assign pipeline_9_io_root = copy_root_io_out_9; // @[SLR2.scala 111:39]
  assign pipeline_9_io_R_array_index_0_ready = io_R_array_index_36_ready; // @[SLR2.scala 124:52]
  assign pipeline_9_io_R_array_index_1_ready = io_R_array_index_37_ready; // @[SLR2.scala 124:52]
  assign pipeline_9_io_R_array_index_2_ready = io_R_array_index_38_ready; // @[SLR2.scala 124:52]
  assign pipeline_9_io_R_array_index_3_ready = io_R_array_index_39_ready; // @[SLR2.scala 124:52]
  assign pipeline_9_io_uram_addr_a_0 = _T_348; // @[SLR2.scala 126:52]
  assign pipeline_9_io_uram_addr_a_1 = _T_353; // @[SLR2.scala 126:52]
  assign pipeline_9_io_uram_addr_a_2 = _T_358; // @[SLR2.scala 126:52]
  assign pipeline_9_io_uram_addr_a_3 = _T_363; // @[SLR2.scala 126:52]
  assign pipeline_10_clock = clock;
  assign pipeline_10_reset = reset_reg_array_10;
  assign pipeline_10_io_frontier_flag = copy_frontier_flag_io_out_10; // @[SLR2.scala 102:44]
  assign pipeline_10_io_p2_end = copy_p2_end_io_out_10; // @[SLR2.scala 100:37]
  assign pipeline_10_io_start = copy_start_io_out_10; // @[SLR2.scala 101:36]
  assign pipeline_10_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_10_io_level = copy_current_level_io_out_10; // @[SLR2.scala 103:36]
  assign pipeline_10_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_10; // @[SLR2.scala 104:51]
  assign pipeline_10_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_10; // @[SLR2.scala 105:51]
  assign pipeline_10_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_10; // @[SLR2.scala 106:51]
  assign pipeline_10_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_10; // @[SLR2.scala 107:51]
  assign pipeline_10_io_offsets_level_offset = copy_offset_level_offset_io_out_10; // @[SLR2.scala 108:51]
  assign pipeline_10_io_p2_in_0_valid = io_p2_in_40_valid; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_0_bits = io_p2_in_40_bits; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_1_valid = io_p2_in_41_valid; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_1_bits = io_p2_in_41_bits; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_2_valid = io_p2_in_42_valid; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_2_bits = io_p2_in_42_bits; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_3_valid = io_p2_in_43_valid; // @[SLR2.scala 120:52]
  assign pipeline_10_io_p2_in_3_bits = io_p2_in_43_bits; // @[SLR2.scala 120:52]
  assign pipeline_10_io_frontier_in_0_valid = io_frontier_in_40_valid; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_0_bits = io_frontier_in_40_bits; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_1_valid = io_frontier_in_41_valid; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_1_bits = io_frontier_in_41_bits; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_2_valid = io_frontier_in_42_valid; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_2_bits = io_frontier_in_42_bits; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_3_valid = io_frontier_in_43_valid; // @[SLR2.scala 122:52]
  assign pipeline_10_io_frontier_in_3_bits = io_frontier_in_43_bits; // @[SLR2.scala 122:52]
  assign pipeline_10_io_p2_out_0_ready = io_p2_out_40_ready; // @[SLR2.scala 123:52]
  assign pipeline_10_io_p2_out_1_ready = io_p2_out_41_ready; // @[SLR2.scala 123:52]
  assign pipeline_10_io_p2_out_2_ready = io_p2_out_42_ready; // @[SLR2.scala 123:52]
  assign pipeline_10_io_p2_out_3_ready = io_p2_out_43_ready; // @[SLR2.scala 123:52]
  assign pipeline_10_io_node_num = copy_node_num_io_out_10; // @[SLR2.scala 110:39]
  assign pipeline_10_io_push_or_pull = copy_push_or_pull_io_out_10; // @[SLR2.scala 112:43]
  assign pipeline_10_io_root = copy_root_io_out_10; // @[SLR2.scala 111:39]
  assign pipeline_10_io_R_array_index_0_ready = io_R_array_index_40_ready; // @[SLR2.scala 124:52]
  assign pipeline_10_io_R_array_index_1_ready = io_R_array_index_41_ready; // @[SLR2.scala 124:52]
  assign pipeline_10_io_R_array_index_2_ready = io_R_array_index_42_ready; // @[SLR2.scala 124:52]
  assign pipeline_10_io_R_array_index_3_ready = io_R_array_index_43_ready; // @[SLR2.scala 124:52]
  assign pipeline_10_io_uram_addr_a_0 = _T_368; // @[SLR2.scala 126:52]
  assign pipeline_10_io_uram_addr_a_1 = _T_373; // @[SLR2.scala 126:52]
  assign pipeline_10_io_uram_addr_a_2 = _T_378; // @[SLR2.scala 126:52]
  assign pipeline_10_io_uram_addr_a_3 = _T_383; // @[SLR2.scala 126:52]
  assign pipeline_11_clock = clock;
  assign pipeline_11_reset = reset_reg_array_11;
  assign pipeline_11_io_frontier_flag = copy_frontier_flag_io_out_11; // @[SLR2.scala 102:44]
  assign pipeline_11_io_p2_end = copy_p2_end_io_out_11; // @[SLR2.scala 100:37]
  assign pipeline_11_io_start = copy_start_io_out_11; // @[SLR2.scala 101:36]
  assign pipeline_11_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_11_io_level = copy_current_level_io_out_11; // @[SLR2.scala 103:36]
  assign pipeline_11_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_11; // @[SLR2.scala 104:51]
  assign pipeline_11_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_11; // @[SLR2.scala 105:51]
  assign pipeline_11_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_11; // @[SLR2.scala 106:51]
  assign pipeline_11_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_11; // @[SLR2.scala 107:51]
  assign pipeline_11_io_offsets_level_offset = copy_offset_level_offset_io_out_11; // @[SLR2.scala 108:51]
  assign pipeline_11_io_p2_in_0_valid = io_p2_in_44_valid; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_0_bits = io_p2_in_44_bits; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_1_valid = io_p2_in_45_valid; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_1_bits = io_p2_in_45_bits; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_2_valid = io_p2_in_46_valid; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_2_bits = io_p2_in_46_bits; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_3_valid = io_p2_in_47_valid; // @[SLR2.scala 120:52]
  assign pipeline_11_io_p2_in_3_bits = io_p2_in_47_bits; // @[SLR2.scala 120:52]
  assign pipeline_11_io_frontier_in_0_valid = io_frontier_in_44_valid; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_0_bits = io_frontier_in_44_bits; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_1_valid = io_frontier_in_45_valid; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_1_bits = io_frontier_in_45_bits; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_2_valid = io_frontier_in_46_valid; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_2_bits = io_frontier_in_46_bits; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_3_valid = io_frontier_in_47_valid; // @[SLR2.scala 122:52]
  assign pipeline_11_io_frontier_in_3_bits = io_frontier_in_47_bits; // @[SLR2.scala 122:52]
  assign pipeline_11_io_p2_out_0_ready = io_p2_out_44_ready; // @[SLR2.scala 123:52]
  assign pipeline_11_io_p2_out_1_ready = io_p2_out_45_ready; // @[SLR2.scala 123:52]
  assign pipeline_11_io_p2_out_2_ready = io_p2_out_46_ready; // @[SLR2.scala 123:52]
  assign pipeline_11_io_p2_out_3_ready = io_p2_out_47_ready; // @[SLR2.scala 123:52]
  assign pipeline_11_io_node_num = copy_node_num_io_out_11; // @[SLR2.scala 110:39]
  assign pipeline_11_io_push_or_pull = copy_push_or_pull_io_out_11; // @[SLR2.scala 112:43]
  assign pipeline_11_io_root = copy_root_io_out_11; // @[SLR2.scala 111:39]
  assign pipeline_11_io_R_array_index_0_ready = io_R_array_index_44_ready; // @[SLR2.scala 124:52]
  assign pipeline_11_io_R_array_index_1_ready = io_R_array_index_45_ready; // @[SLR2.scala 124:52]
  assign pipeline_11_io_R_array_index_2_ready = io_R_array_index_46_ready; // @[SLR2.scala 124:52]
  assign pipeline_11_io_R_array_index_3_ready = io_R_array_index_47_ready; // @[SLR2.scala 124:52]
  assign pipeline_11_io_uram_addr_a_0 = _T_388; // @[SLR2.scala 126:52]
  assign pipeline_11_io_uram_addr_a_1 = _T_393; // @[SLR2.scala 126:52]
  assign pipeline_11_io_uram_addr_a_2 = _T_398; // @[SLR2.scala 126:52]
  assign pipeline_11_io_uram_addr_a_3 = _T_403; // @[SLR2.scala 126:52]
  assign pipeline_12_clock = clock;
  assign pipeline_12_reset = reset_reg_array_12;
  assign pipeline_12_io_frontier_flag = copy_frontier_flag_io_out_12; // @[SLR2.scala 102:44]
  assign pipeline_12_io_p2_end = copy_p2_end_io_out_12; // @[SLR2.scala 100:37]
  assign pipeline_12_io_start = copy_start_io_out_12; // @[SLR2.scala 101:36]
  assign pipeline_12_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_12_io_level = copy_current_level_io_out_12; // @[SLR2.scala 103:36]
  assign pipeline_12_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_12; // @[SLR2.scala 104:51]
  assign pipeline_12_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_12; // @[SLR2.scala 105:51]
  assign pipeline_12_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_12; // @[SLR2.scala 106:51]
  assign pipeline_12_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_12; // @[SLR2.scala 107:51]
  assign pipeline_12_io_offsets_level_offset = copy_offset_level_offset_io_out_12; // @[SLR2.scala 108:51]
  assign pipeline_12_io_p2_in_0_valid = io_p2_in_48_valid; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_0_bits = io_p2_in_48_bits; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_1_valid = io_p2_in_49_valid; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_1_bits = io_p2_in_49_bits; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_2_valid = io_p2_in_50_valid; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_2_bits = io_p2_in_50_bits; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_3_valid = io_p2_in_51_valid; // @[SLR2.scala 120:52]
  assign pipeline_12_io_p2_in_3_bits = io_p2_in_51_bits; // @[SLR2.scala 120:52]
  assign pipeline_12_io_frontier_in_0_valid = io_frontier_in_48_valid; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_0_bits = io_frontier_in_48_bits; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_1_valid = io_frontier_in_49_valid; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_1_bits = io_frontier_in_49_bits; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_2_valid = io_frontier_in_50_valid; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_2_bits = io_frontier_in_50_bits; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_3_valid = io_frontier_in_51_valid; // @[SLR2.scala 122:52]
  assign pipeline_12_io_frontier_in_3_bits = io_frontier_in_51_bits; // @[SLR2.scala 122:52]
  assign pipeline_12_io_p2_out_0_ready = io_p2_out_48_ready; // @[SLR2.scala 123:52]
  assign pipeline_12_io_p2_out_1_ready = io_p2_out_49_ready; // @[SLR2.scala 123:52]
  assign pipeline_12_io_p2_out_2_ready = io_p2_out_50_ready; // @[SLR2.scala 123:52]
  assign pipeline_12_io_p2_out_3_ready = io_p2_out_51_ready; // @[SLR2.scala 123:52]
  assign pipeline_12_io_node_num = copy_node_num_io_out_12; // @[SLR2.scala 110:39]
  assign pipeline_12_io_push_or_pull = copy_push_or_pull_io_out_12; // @[SLR2.scala 112:43]
  assign pipeline_12_io_root = copy_root_io_out_12; // @[SLR2.scala 111:39]
  assign pipeline_12_io_R_array_index_0_ready = io_R_array_index_48_ready; // @[SLR2.scala 124:52]
  assign pipeline_12_io_R_array_index_1_ready = io_R_array_index_49_ready; // @[SLR2.scala 124:52]
  assign pipeline_12_io_R_array_index_2_ready = io_R_array_index_50_ready; // @[SLR2.scala 124:52]
  assign pipeline_12_io_R_array_index_3_ready = io_R_array_index_51_ready; // @[SLR2.scala 124:52]
  assign pipeline_12_io_uram_addr_a_0 = _T_408; // @[SLR2.scala 126:52]
  assign pipeline_12_io_uram_addr_a_1 = _T_413; // @[SLR2.scala 126:52]
  assign pipeline_12_io_uram_addr_a_2 = _T_418; // @[SLR2.scala 126:52]
  assign pipeline_12_io_uram_addr_a_3 = _T_423; // @[SLR2.scala 126:52]
  assign pipeline_13_clock = clock;
  assign pipeline_13_reset = reset_reg_array_13;
  assign pipeline_13_io_frontier_flag = copy_frontier_flag_io_out_13; // @[SLR2.scala 102:44]
  assign pipeline_13_io_p2_end = copy_p2_end_io_out_13; // @[SLR2.scala 100:37]
  assign pipeline_13_io_start = copy_start_io_out_13; // @[SLR2.scala 101:36]
  assign pipeline_13_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_13_io_level = copy_current_level_io_out_13; // @[SLR2.scala 103:36]
  assign pipeline_13_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_13; // @[SLR2.scala 104:51]
  assign pipeline_13_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_13; // @[SLR2.scala 105:51]
  assign pipeline_13_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_13; // @[SLR2.scala 106:51]
  assign pipeline_13_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_13; // @[SLR2.scala 107:51]
  assign pipeline_13_io_offsets_level_offset = copy_offset_level_offset_io_out_13; // @[SLR2.scala 108:51]
  assign pipeline_13_io_p2_in_0_valid = io_p2_in_52_valid; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_0_bits = io_p2_in_52_bits; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_1_valid = io_p2_in_53_valid; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_1_bits = io_p2_in_53_bits; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_2_valid = io_p2_in_54_valid; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_2_bits = io_p2_in_54_bits; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_3_valid = io_p2_in_55_valid; // @[SLR2.scala 120:52]
  assign pipeline_13_io_p2_in_3_bits = io_p2_in_55_bits; // @[SLR2.scala 120:52]
  assign pipeline_13_io_frontier_in_0_valid = io_frontier_in_52_valid; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_0_bits = io_frontier_in_52_bits; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_1_valid = io_frontier_in_53_valid; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_1_bits = io_frontier_in_53_bits; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_2_valid = io_frontier_in_54_valid; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_2_bits = io_frontier_in_54_bits; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_3_valid = io_frontier_in_55_valid; // @[SLR2.scala 122:52]
  assign pipeline_13_io_frontier_in_3_bits = io_frontier_in_55_bits; // @[SLR2.scala 122:52]
  assign pipeline_13_io_p2_out_0_ready = io_p2_out_52_ready; // @[SLR2.scala 123:52]
  assign pipeline_13_io_p2_out_1_ready = io_p2_out_53_ready; // @[SLR2.scala 123:52]
  assign pipeline_13_io_p2_out_2_ready = io_p2_out_54_ready; // @[SLR2.scala 123:52]
  assign pipeline_13_io_p2_out_3_ready = io_p2_out_55_ready; // @[SLR2.scala 123:52]
  assign pipeline_13_io_node_num = copy_node_num_io_out_13; // @[SLR2.scala 110:39]
  assign pipeline_13_io_push_or_pull = copy_push_or_pull_io_out_13; // @[SLR2.scala 112:43]
  assign pipeline_13_io_root = copy_root_io_out_13; // @[SLR2.scala 111:39]
  assign pipeline_13_io_R_array_index_0_ready = io_R_array_index_52_ready; // @[SLR2.scala 124:52]
  assign pipeline_13_io_R_array_index_1_ready = io_R_array_index_53_ready; // @[SLR2.scala 124:52]
  assign pipeline_13_io_R_array_index_2_ready = io_R_array_index_54_ready; // @[SLR2.scala 124:52]
  assign pipeline_13_io_R_array_index_3_ready = io_R_array_index_55_ready; // @[SLR2.scala 124:52]
  assign pipeline_13_io_uram_addr_a_0 = _T_428; // @[SLR2.scala 126:52]
  assign pipeline_13_io_uram_addr_a_1 = _T_433; // @[SLR2.scala 126:52]
  assign pipeline_13_io_uram_addr_a_2 = _T_438; // @[SLR2.scala 126:52]
  assign pipeline_13_io_uram_addr_a_3 = _T_443; // @[SLR2.scala 126:52]
  assign pipeline_14_clock = clock;
  assign pipeline_14_reset = reset_reg_array_14;
  assign pipeline_14_io_frontier_flag = copy_frontier_flag_io_out_14; // @[SLR2.scala 102:44]
  assign pipeline_14_io_p2_end = copy_p2_end_io_out_14; // @[SLR2.scala 100:37]
  assign pipeline_14_io_start = copy_start_io_out_14; // @[SLR2.scala 101:36]
  assign pipeline_14_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_14_io_level = copy_current_level_io_out_14; // @[SLR2.scala 103:36]
  assign pipeline_14_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_14; // @[SLR2.scala 104:51]
  assign pipeline_14_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_14; // @[SLR2.scala 105:51]
  assign pipeline_14_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_14; // @[SLR2.scala 106:51]
  assign pipeline_14_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_14; // @[SLR2.scala 107:51]
  assign pipeline_14_io_offsets_level_offset = copy_offset_level_offset_io_out_14; // @[SLR2.scala 108:51]
  assign pipeline_14_io_p2_in_0_valid = io_p2_in_56_valid; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_0_bits = io_p2_in_56_bits; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_1_valid = io_p2_in_57_valid; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_1_bits = io_p2_in_57_bits; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_2_valid = io_p2_in_58_valid; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_2_bits = io_p2_in_58_bits; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_3_valid = io_p2_in_59_valid; // @[SLR2.scala 120:52]
  assign pipeline_14_io_p2_in_3_bits = io_p2_in_59_bits; // @[SLR2.scala 120:52]
  assign pipeline_14_io_frontier_in_0_valid = io_frontier_in_56_valid; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_0_bits = io_frontier_in_56_bits; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_1_valid = io_frontier_in_57_valid; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_1_bits = io_frontier_in_57_bits; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_2_valid = io_frontier_in_58_valid; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_2_bits = io_frontier_in_58_bits; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_3_valid = io_frontier_in_59_valid; // @[SLR2.scala 122:52]
  assign pipeline_14_io_frontier_in_3_bits = io_frontier_in_59_bits; // @[SLR2.scala 122:52]
  assign pipeline_14_io_p2_out_0_ready = io_p2_out_56_ready; // @[SLR2.scala 123:52]
  assign pipeline_14_io_p2_out_1_ready = io_p2_out_57_ready; // @[SLR2.scala 123:52]
  assign pipeline_14_io_p2_out_2_ready = io_p2_out_58_ready; // @[SLR2.scala 123:52]
  assign pipeline_14_io_p2_out_3_ready = io_p2_out_59_ready; // @[SLR2.scala 123:52]
  assign pipeline_14_io_node_num = copy_node_num_io_out_14; // @[SLR2.scala 110:39]
  assign pipeline_14_io_push_or_pull = copy_push_or_pull_io_out_14; // @[SLR2.scala 112:43]
  assign pipeline_14_io_root = copy_root_io_out_14; // @[SLR2.scala 111:39]
  assign pipeline_14_io_R_array_index_0_ready = io_R_array_index_56_ready; // @[SLR2.scala 124:52]
  assign pipeline_14_io_R_array_index_1_ready = io_R_array_index_57_ready; // @[SLR2.scala 124:52]
  assign pipeline_14_io_R_array_index_2_ready = io_R_array_index_58_ready; // @[SLR2.scala 124:52]
  assign pipeline_14_io_R_array_index_3_ready = io_R_array_index_59_ready; // @[SLR2.scala 124:52]
  assign pipeline_14_io_uram_addr_a_0 = _T_448; // @[SLR2.scala 126:52]
  assign pipeline_14_io_uram_addr_a_1 = _T_453; // @[SLR2.scala 126:52]
  assign pipeline_14_io_uram_addr_a_2 = _T_458; // @[SLR2.scala 126:52]
  assign pipeline_14_io_uram_addr_a_3 = _T_463; // @[SLR2.scala 126:52]
  assign pipeline_15_clock = clock;
  assign pipeline_15_reset = reset_reg_array_15;
  assign pipeline_15_io_frontier_flag = copy_frontier_flag_io_out_15; // @[SLR2.scala 102:44]
  assign pipeline_15_io_p2_end = copy_p2_end_io_out_15; // @[SLR2.scala 100:37]
  assign pipeline_15_io_start = copy_start_io_out_15; // @[SLR2.scala 101:36]
  assign pipeline_15_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_15_io_level = copy_current_level_io_out_15; // @[SLR2.scala 103:36]
  assign pipeline_15_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_15; // @[SLR2.scala 104:51]
  assign pipeline_15_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_15; // @[SLR2.scala 105:51]
  assign pipeline_15_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_15; // @[SLR2.scala 106:51]
  assign pipeline_15_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_15; // @[SLR2.scala 107:51]
  assign pipeline_15_io_offsets_level_offset = copy_offset_level_offset_io_out_15; // @[SLR2.scala 108:51]
  assign pipeline_15_io_p2_in_0_valid = io_p2_in_60_valid; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_0_bits = io_p2_in_60_bits; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_1_valid = io_p2_in_61_valid; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_1_bits = io_p2_in_61_bits; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_2_valid = io_p2_in_62_valid; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_2_bits = io_p2_in_62_bits; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_3_valid = io_p2_in_63_valid; // @[SLR2.scala 120:52]
  assign pipeline_15_io_p2_in_3_bits = io_p2_in_63_bits; // @[SLR2.scala 120:52]
  assign pipeline_15_io_frontier_in_0_valid = io_frontier_in_60_valid; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_0_bits = io_frontier_in_60_bits; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_1_valid = io_frontier_in_61_valid; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_1_bits = io_frontier_in_61_bits; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_2_valid = io_frontier_in_62_valid; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_2_bits = io_frontier_in_62_bits; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_3_valid = io_frontier_in_63_valid; // @[SLR2.scala 122:52]
  assign pipeline_15_io_frontier_in_3_bits = io_frontier_in_63_bits; // @[SLR2.scala 122:52]
  assign pipeline_15_io_p2_out_0_ready = io_p2_out_60_ready; // @[SLR2.scala 123:52]
  assign pipeline_15_io_p2_out_1_ready = io_p2_out_61_ready; // @[SLR2.scala 123:52]
  assign pipeline_15_io_p2_out_2_ready = io_p2_out_62_ready; // @[SLR2.scala 123:52]
  assign pipeline_15_io_p2_out_3_ready = io_p2_out_63_ready; // @[SLR2.scala 123:52]
  assign pipeline_15_io_node_num = copy_node_num_io_out_15; // @[SLR2.scala 110:39]
  assign pipeline_15_io_push_or_pull = copy_push_or_pull_io_out_15; // @[SLR2.scala 112:43]
  assign pipeline_15_io_root = copy_root_io_out_15; // @[SLR2.scala 111:39]
  assign pipeline_15_io_R_array_index_0_ready = io_R_array_index_60_ready; // @[SLR2.scala 124:52]
  assign pipeline_15_io_R_array_index_1_ready = io_R_array_index_61_ready; // @[SLR2.scala 124:52]
  assign pipeline_15_io_R_array_index_2_ready = io_R_array_index_62_ready; // @[SLR2.scala 124:52]
  assign pipeline_15_io_R_array_index_3_ready = io_R_array_index_63_ready; // @[SLR2.scala 124:52]
  assign pipeline_15_io_uram_addr_a_0 = _T_468; // @[SLR2.scala 126:52]
  assign pipeline_15_io_uram_addr_a_1 = _T_473; // @[SLR2.scala 126:52]
  assign pipeline_15_io_uram_addr_a_2 = _T_478; // @[SLR2.scala 126:52]
  assign pipeline_15_io_uram_addr_a_3 = _T_483; // @[SLR2.scala 126:52]
  assign pipeline_16_clock = clock;
  assign pipeline_16_reset = reset_reg_array_16;
  assign pipeline_16_io_frontier_flag = copy_frontier_flag_io_out_16; // @[SLR2.scala 102:44]
  assign pipeline_16_io_p2_end = copy_p2_end_io_out_16; // @[SLR2.scala 100:37]
  assign pipeline_16_io_start = copy_start_io_out_16; // @[SLR2.scala 101:36]
  assign pipeline_16_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_16_io_level = copy_current_level_io_out_16; // @[SLR2.scala 103:36]
  assign pipeline_16_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_16; // @[SLR2.scala 104:51]
  assign pipeline_16_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_16; // @[SLR2.scala 105:51]
  assign pipeline_16_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_16; // @[SLR2.scala 106:51]
  assign pipeline_16_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_16; // @[SLR2.scala 107:51]
  assign pipeline_16_io_offsets_level_offset = copy_offset_level_offset_io_out_16; // @[SLR2.scala 108:51]
  assign pipeline_16_io_p2_in_0_valid = io_p2_in_64_valid; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_0_bits = io_p2_in_64_bits; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_1_valid = io_p2_in_65_valid; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_1_bits = io_p2_in_65_bits; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_2_valid = io_p2_in_66_valid; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_2_bits = io_p2_in_66_bits; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_3_valid = io_p2_in_67_valid; // @[SLR2.scala 120:52]
  assign pipeline_16_io_p2_in_3_bits = io_p2_in_67_bits; // @[SLR2.scala 120:52]
  assign pipeline_16_io_frontier_in_0_valid = io_frontier_in_64_valid; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_0_bits = io_frontier_in_64_bits; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_1_valid = io_frontier_in_65_valid; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_1_bits = io_frontier_in_65_bits; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_2_valid = io_frontier_in_66_valid; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_2_bits = io_frontier_in_66_bits; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_3_valid = io_frontier_in_67_valid; // @[SLR2.scala 122:52]
  assign pipeline_16_io_frontier_in_3_bits = io_frontier_in_67_bits; // @[SLR2.scala 122:52]
  assign pipeline_16_io_p2_out_0_ready = io_p2_out_64_ready; // @[SLR2.scala 123:52]
  assign pipeline_16_io_p2_out_1_ready = io_p2_out_65_ready; // @[SLR2.scala 123:52]
  assign pipeline_16_io_p2_out_2_ready = io_p2_out_66_ready; // @[SLR2.scala 123:52]
  assign pipeline_16_io_p2_out_3_ready = io_p2_out_67_ready; // @[SLR2.scala 123:52]
  assign pipeline_16_io_node_num = copy_node_num_io_out_16; // @[SLR2.scala 110:39]
  assign pipeline_16_io_push_or_pull = copy_push_or_pull_io_out_16; // @[SLR2.scala 112:43]
  assign pipeline_16_io_root = copy_root_io_out_16; // @[SLR2.scala 111:39]
  assign pipeline_16_io_R_array_index_0_ready = io_R_array_index_64_ready; // @[SLR2.scala 124:52]
  assign pipeline_16_io_R_array_index_1_ready = io_R_array_index_65_ready; // @[SLR2.scala 124:52]
  assign pipeline_16_io_R_array_index_2_ready = io_R_array_index_66_ready; // @[SLR2.scala 124:52]
  assign pipeline_16_io_R_array_index_3_ready = io_R_array_index_67_ready; // @[SLR2.scala 124:52]
  assign pipeline_16_io_uram_addr_a_0 = _T_488; // @[SLR2.scala 126:52]
  assign pipeline_16_io_uram_addr_a_1 = _T_493; // @[SLR2.scala 126:52]
  assign pipeline_16_io_uram_addr_a_2 = _T_498; // @[SLR2.scala 126:52]
  assign pipeline_16_io_uram_addr_a_3 = _T_503; // @[SLR2.scala 126:52]
  assign pipeline_17_clock = clock;
  assign pipeline_17_reset = reset_reg_array_17;
  assign pipeline_17_io_frontier_flag = copy_frontier_flag_io_out_17; // @[SLR2.scala 102:44]
  assign pipeline_17_io_p2_end = copy_p2_end_io_out_17; // @[SLR2.scala 100:37]
  assign pipeline_17_io_start = copy_start_io_out_17; // @[SLR2.scala 101:36]
  assign pipeline_17_io_start_init = io_start_init; // @[SLR2.scala 115:41]
  assign pipeline_17_io_level = copy_current_level_io_out_17; // @[SLR2.scala 103:36]
  assign pipeline_17_io_offsets_CSR_R_offset = copy_offset_CSR_R_offset_io_out_17; // @[SLR2.scala 104:51]
  assign pipeline_17_io_offsets_CSR_C_offset = copy_offset_CSR_C_offset_io_out_17; // @[SLR2.scala 105:51]
  assign pipeline_17_io_offsets_CSC_R_offset = copy_offset_CSC_R_offset_io_out_17; // @[SLR2.scala 106:51]
  assign pipeline_17_io_offsets_CSC_C_offset = copy_offset_CSC_C_offset_io_out_17; // @[SLR2.scala 107:51]
  assign pipeline_17_io_offsets_level_offset = copy_offset_level_offset_io_out_17; // @[SLR2.scala 108:51]
  assign pipeline_17_io_p2_in_0_valid = io_p2_in_68_valid; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_0_bits = io_p2_in_68_bits; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_1_valid = io_p2_in_69_valid; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_1_bits = io_p2_in_69_bits; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_2_valid = io_p2_in_70_valid; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_2_bits = io_p2_in_70_bits; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_3_valid = io_p2_in_71_valid; // @[SLR2.scala 120:52]
  assign pipeline_17_io_p2_in_3_bits = io_p2_in_71_bits; // @[SLR2.scala 120:52]
  assign pipeline_17_io_frontier_in_0_valid = io_frontier_in_68_valid; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_0_bits = io_frontier_in_68_bits; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_1_valid = io_frontier_in_69_valid; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_1_bits = io_frontier_in_69_bits; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_2_valid = io_frontier_in_70_valid; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_2_bits = io_frontier_in_70_bits; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_3_valid = io_frontier_in_71_valid; // @[SLR2.scala 122:52]
  assign pipeline_17_io_frontier_in_3_bits = io_frontier_in_71_bits; // @[SLR2.scala 122:52]
  assign pipeline_17_io_p2_out_0_ready = io_p2_out_68_ready; // @[SLR2.scala 123:52]
  assign pipeline_17_io_p2_out_1_ready = io_p2_out_69_ready; // @[SLR2.scala 123:52]
  assign pipeline_17_io_p2_out_2_ready = io_p2_out_70_ready; // @[SLR2.scala 123:52]
  assign pipeline_17_io_p2_out_3_ready = io_p2_out_71_ready; // @[SLR2.scala 123:52]
  assign pipeline_17_io_node_num = copy_node_num_io_out_17; // @[SLR2.scala 110:39]
  assign pipeline_17_io_push_or_pull = copy_push_or_pull_io_out_17; // @[SLR2.scala 112:43]
  assign pipeline_17_io_root = copy_root_io_out_17; // @[SLR2.scala 111:39]
  assign pipeline_17_io_R_array_index_0_ready = io_R_array_index_68_ready; // @[SLR2.scala 124:52]
  assign pipeline_17_io_R_array_index_1_ready = io_R_array_index_69_ready; // @[SLR2.scala 124:52]
  assign pipeline_17_io_R_array_index_2_ready = io_R_array_index_70_ready; // @[SLR2.scala 124:52]
  assign pipeline_17_io_R_array_index_3_ready = io_R_array_index_71_ready; // @[SLR2.scala 124:52]
  assign pipeline_17_io_uram_addr_a_0 = _T_508; // @[SLR2.scala 126:52]
  assign pipeline_17_io_uram_addr_a_1 = _T_513; // @[SLR2.scala 126:52]
  assign pipeline_17_io_uram_addr_a_2 = _T_518; // @[SLR2.scala 126:52]
  assign pipeline_17_io_uram_addr_a_3 = _T_523; // @[SLR2.scala 126:52]
  assign copy_start_clock = clock;
  assign copy_start_reset = reset;
  assign copy_start_io_in = io_start; // @[SLR2.scala 63:22]
  assign copy_frontier_flag_clock = clock;
  assign copy_frontier_flag_reset = reset;
  assign copy_frontier_flag_io_in = io_frontier_flag; // @[SLR2.scala 65:30]
  assign copy_current_level_clock = clock;
  assign copy_current_level_reset = reset;
  assign copy_current_level_io_in = io_level; // @[SLR2.scala 66:30]
  assign copy_p2_end_clock = clock;
  assign copy_p2_end_reset = reset;
  assign copy_p2_end_io_in = io_p2_end; // @[SLR2.scala 67:23]
  assign copy_push_or_pull_clock = clock;
  assign copy_push_or_pull_reset = reset;
  assign copy_push_or_pull_io_in = io_push_or_pull; // @[SLR2.scala 68:29]
  assign copy_node_num_clock = clock;
  assign copy_node_num_reset = reset;
  assign copy_node_num_io_in = _T_18; // @[SLR2.scala 69:25]
  assign copy_root_clock = clock;
  assign copy_root_reset = reset;
  assign copy_root_io_in = _T_19; // @[SLR2.scala 70:21]
  assign copy_offset_CSR_R_offset_clock = clock;
  assign copy_offset_CSR_R_offset_reset = reset;
  assign copy_offset_CSR_R_offset_io_in = _T_20; // @[SLR2.scala 77:36]
  assign copy_offset_CSR_C_offset_clock = clock;
  assign copy_offset_CSR_C_offset_reset = reset;
  assign copy_offset_CSR_C_offset_io_in = _T_21; // @[SLR2.scala 78:36]
  assign copy_offset_CSC_R_offset_clock = clock;
  assign copy_offset_CSC_R_offset_reset = reset;
  assign copy_offset_CSC_R_offset_io_in = _T_22; // @[SLR2.scala 79:36]
  assign copy_offset_CSC_C_offset_clock = clock;
  assign copy_offset_CSC_C_offset_reset = reset;
  assign copy_offset_CSC_C_offset_io_in = _T_23; // @[SLR2.scala 80:36]
  assign copy_offset_level_offset_clock = clock;
  assign copy_offset_level_offset_reset = reset;
  assign copy_offset_level_offset_io_in = _T_24; // @[SLR2.scala 81:36]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  reset_reg = _RAND_0[0:0];
  _RAND_1 = {1{`RANDOM}};
  reset_reg_array_0 = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  reset_reg_array_1 = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  reset_reg_array_2 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  reset_reg_array_3 = _RAND_4[0:0];
  _RAND_5 = {1{`RANDOM}};
  reset_reg_array_4 = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  reset_reg_array_5 = _RAND_6[0:0];
  _RAND_7 = {1{`RANDOM}};
  reset_reg_array_6 = _RAND_7[0:0];
  _RAND_8 = {1{`RANDOM}};
  reset_reg_array_7 = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  reset_reg_array_8 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  reset_reg_array_9 = _RAND_10[0:0];
  _RAND_11 = {1{`RANDOM}};
  reset_reg_array_10 = _RAND_11[0:0];
  _RAND_12 = {1{`RANDOM}};
  reset_reg_array_11 = _RAND_12[0:0];
  _RAND_13 = {1{`RANDOM}};
  reset_reg_array_12 = _RAND_13[0:0];
  _RAND_14 = {1{`RANDOM}};
  reset_reg_array_13 = _RAND_14[0:0];
  _RAND_15 = {1{`RANDOM}};
  reset_reg_array_14 = _RAND_15[0:0];
  _RAND_16 = {1{`RANDOM}};
  reset_reg_array_15 = _RAND_16[0:0];
  _RAND_17 = {1{`RANDOM}};
  reset_reg_array_16 = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  reset_reg_array_17 = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  _T_18 = _RAND_19[31:0];
  _RAND_20 = {1{`RANDOM}};
  _T_19 = _RAND_20[31:0];
  _RAND_21 = {1{`RANDOM}};
  _T_20 = _RAND_21[31:0];
  _RAND_22 = {1{`RANDOM}};
  _T_21 = _RAND_22[31:0];
  _RAND_23 = {1{`RANDOM}};
  _T_22 = _RAND_23[31:0];
  _RAND_24 = {1{`RANDOM}};
  _T_23 = _RAND_24[31:0];
  _RAND_25 = {1{`RANDOM}};
  _T_24 = _RAND_25[31:0];
  _RAND_26 = {1{`RANDOM}};
  r_array_count_0 = _RAND_26[31:0];
  _RAND_27 = {1{`RANDOM}};
  r_array_count_1 = _RAND_27[31:0];
  _RAND_28 = {1{`RANDOM}};
  r_array_count_2 = _RAND_28[31:0];
  _RAND_29 = {1{`RANDOM}};
  r_array_count_3 = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  r_array_count_4 = _RAND_30[31:0];
  _RAND_31 = {1{`RANDOM}};
  r_array_count_5 = _RAND_31[31:0];
  _RAND_32 = {1{`RANDOM}};
  r_array_count_6 = _RAND_32[31:0];
  _RAND_33 = {1{`RANDOM}};
  r_array_count_7 = _RAND_33[31:0];
  _RAND_34 = {1{`RANDOM}};
  r_array_count_8 = _RAND_34[31:0];
  _RAND_35 = {1{`RANDOM}};
  r_array_count_9 = _RAND_35[31:0];
  _RAND_36 = {1{`RANDOM}};
  r_array_count_10 = _RAND_36[31:0];
  _RAND_37 = {1{`RANDOM}};
  r_array_count_11 = _RAND_37[31:0];
  _RAND_38 = {1{`RANDOM}};
  r_array_count_12 = _RAND_38[31:0];
  _RAND_39 = {1{`RANDOM}};
  r_array_count_13 = _RAND_39[31:0];
  _RAND_40 = {1{`RANDOM}};
  r_array_count_14 = _RAND_40[31:0];
  _RAND_41 = {1{`RANDOM}};
  r_array_count_15 = _RAND_41[31:0];
  _RAND_42 = {1{`RANDOM}};
  r_array_count_16 = _RAND_42[31:0];
  _RAND_43 = {1{`RANDOM}};
  r_array_count_17 = _RAND_43[31:0];
  _RAND_44 = {1{`RANDOM}};
  r_array_count_18 = _RAND_44[31:0];
  _RAND_45 = {1{`RANDOM}};
  r_array_count_19 = _RAND_45[31:0];
  _RAND_46 = {1{`RANDOM}};
  r_array_count_20 = _RAND_46[31:0];
  _RAND_47 = {1{`RANDOM}};
  r_array_count_21 = _RAND_47[31:0];
  _RAND_48 = {1{`RANDOM}};
  r_array_count_22 = _RAND_48[31:0];
  _RAND_49 = {1{`RANDOM}};
  r_array_count_23 = _RAND_49[31:0];
  _RAND_50 = {1{`RANDOM}};
  r_array_count_24 = _RAND_50[31:0];
  _RAND_51 = {1{`RANDOM}};
  r_array_count_25 = _RAND_51[31:0];
  _RAND_52 = {1{`RANDOM}};
  r_array_count_26 = _RAND_52[31:0];
  _RAND_53 = {1{`RANDOM}};
  r_array_count_27 = _RAND_53[31:0];
  _RAND_54 = {1{`RANDOM}};
  r_array_count_28 = _RAND_54[31:0];
  _RAND_55 = {1{`RANDOM}};
  r_array_count_29 = _RAND_55[31:0];
  _RAND_56 = {1{`RANDOM}};
  r_array_count_30 = _RAND_56[31:0];
  _RAND_57 = {1{`RANDOM}};
  r_array_count_31 = _RAND_57[31:0];
  _RAND_58 = {1{`RANDOM}};
  r_array_count_32 = _RAND_58[31:0];
  _RAND_59 = {1{`RANDOM}};
  r_array_count_33 = _RAND_59[31:0];
  _RAND_60 = {1{`RANDOM}};
  r_array_count_34 = _RAND_60[31:0];
  _RAND_61 = {1{`RANDOM}};
  r_array_count_35 = _RAND_61[31:0];
  _RAND_62 = {1{`RANDOM}};
  r_array_count_36 = _RAND_62[31:0];
  _RAND_63 = {1{`RANDOM}};
  r_array_count_37 = _RAND_63[31:0];
  _RAND_64 = {1{`RANDOM}};
  r_array_count_38 = _RAND_64[31:0];
  _RAND_65 = {1{`RANDOM}};
  r_array_count_39 = _RAND_65[31:0];
  _RAND_66 = {1{`RANDOM}};
  r_array_count_40 = _RAND_66[31:0];
  _RAND_67 = {1{`RANDOM}};
  r_array_count_41 = _RAND_67[31:0];
  _RAND_68 = {1{`RANDOM}};
  r_array_count_42 = _RAND_68[31:0];
  _RAND_69 = {1{`RANDOM}};
  r_array_count_43 = _RAND_69[31:0];
  _RAND_70 = {1{`RANDOM}};
  r_array_count_44 = _RAND_70[31:0];
  _RAND_71 = {1{`RANDOM}};
  r_array_count_45 = _RAND_71[31:0];
  _RAND_72 = {1{`RANDOM}};
  r_array_count_46 = _RAND_72[31:0];
  _RAND_73 = {1{`RANDOM}};
  r_array_count_47 = _RAND_73[31:0];
  _RAND_74 = {1{`RANDOM}};
  r_array_count_48 = _RAND_74[31:0];
  _RAND_75 = {1{`RANDOM}};
  r_array_count_49 = _RAND_75[31:0];
  _RAND_76 = {1{`RANDOM}};
  r_array_count_50 = _RAND_76[31:0];
  _RAND_77 = {1{`RANDOM}};
  r_array_count_51 = _RAND_77[31:0];
  _RAND_78 = {1{`RANDOM}};
  r_array_count_52 = _RAND_78[31:0];
  _RAND_79 = {1{`RANDOM}};
  r_array_count_53 = _RAND_79[31:0];
  _RAND_80 = {1{`RANDOM}};
  r_array_count_54 = _RAND_80[31:0];
  _RAND_81 = {1{`RANDOM}};
  r_array_count_55 = _RAND_81[31:0];
  _RAND_82 = {1{`RANDOM}};
  r_array_count_56 = _RAND_82[31:0];
  _RAND_83 = {1{`RANDOM}};
  r_array_count_57 = _RAND_83[31:0];
  _RAND_84 = {1{`RANDOM}};
  r_array_count_58 = _RAND_84[31:0];
  _RAND_85 = {1{`RANDOM}};
  r_array_count_59 = _RAND_85[31:0];
  _RAND_86 = {1{`RANDOM}};
  r_array_count_60 = _RAND_86[31:0];
  _RAND_87 = {1{`RANDOM}};
  r_array_count_61 = _RAND_87[31:0];
  _RAND_88 = {1{`RANDOM}};
  r_array_count_62 = _RAND_88[31:0];
  _RAND_89 = {1{`RANDOM}};
  r_array_count_63 = _RAND_89[31:0];
  _RAND_90 = {1{`RANDOM}};
  r_array_count_64 = _RAND_90[31:0];
  _RAND_91 = {1{`RANDOM}};
  r_array_count_65 = _RAND_91[31:0];
  _RAND_92 = {1{`RANDOM}};
  r_array_count_66 = _RAND_92[31:0];
  _RAND_93 = {1{`RANDOM}};
  r_array_count_67 = _RAND_93[31:0];
  _RAND_94 = {1{`RANDOM}};
  r_array_count_68 = _RAND_94[31:0];
  _RAND_95 = {1{`RANDOM}};
  r_array_count_69 = _RAND_95[31:0];
  _RAND_96 = {1{`RANDOM}};
  r_array_count_70 = _RAND_96[31:0];
  _RAND_97 = {1{`RANDOM}};
  r_array_count_71 = _RAND_97[31:0];
  _RAND_98 = {2{`RANDOM}};
  _T_167 = _RAND_98[63:0];
  _RAND_99 = {1{`RANDOM}};
  _T_168 = _RAND_99[19:0];
  _RAND_100 = {2{`RANDOM}};
  _T_172 = _RAND_100[63:0];
  _RAND_101 = {1{`RANDOM}};
  _T_173 = _RAND_101[19:0];
  _RAND_102 = {2{`RANDOM}};
  _T_177 = _RAND_102[63:0];
  _RAND_103 = {1{`RANDOM}};
  _T_178 = _RAND_103[19:0];
  _RAND_104 = {2{`RANDOM}};
  _T_182 = _RAND_104[63:0];
  _RAND_105 = {1{`RANDOM}};
  _T_183 = _RAND_105[19:0];
  _RAND_106 = {2{`RANDOM}};
  _T_187 = _RAND_106[63:0];
  _RAND_107 = {1{`RANDOM}};
  _T_188 = _RAND_107[19:0];
  _RAND_108 = {2{`RANDOM}};
  _T_192 = _RAND_108[63:0];
  _RAND_109 = {1{`RANDOM}};
  _T_193 = _RAND_109[19:0];
  _RAND_110 = {2{`RANDOM}};
  _T_197 = _RAND_110[63:0];
  _RAND_111 = {1{`RANDOM}};
  _T_198 = _RAND_111[19:0];
  _RAND_112 = {2{`RANDOM}};
  _T_202 = _RAND_112[63:0];
  _RAND_113 = {1{`RANDOM}};
  _T_203 = _RAND_113[19:0];
  _RAND_114 = {2{`RANDOM}};
  _T_207 = _RAND_114[63:0];
  _RAND_115 = {1{`RANDOM}};
  _T_208 = _RAND_115[19:0];
  _RAND_116 = {2{`RANDOM}};
  _T_212 = _RAND_116[63:0];
  _RAND_117 = {1{`RANDOM}};
  _T_213 = _RAND_117[19:0];
  _RAND_118 = {2{`RANDOM}};
  _T_217 = _RAND_118[63:0];
  _RAND_119 = {1{`RANDOM}};
  _T_218 = _RAND_119[19:0];
  _RAND_120 = {2{`RANDOM}};
  _T_222 = _RAND_120[63:0];
  _RAND_121 = {1{`RANDOM}};
  _T_223 = _RAND_121[19:0];
  _RAND_122 = {2{`RANDOM}};
  _T_227 = _RAND_122[63:0];
  _RAND_123 = {1{`RANDOM}};
  _T_228 = _RAND_123[19:0];
  _RAND_124 = {2{`RANDOM}};
  _T_232 = _RAND_124[63:0];
  _RAND_125 = {1{`RANDOM}};
  _T_233 = _RAND_125[19:0];
  _RAND_126 = {2{`RANDOM}};
  _T_237 = _RAND_126[63:0];
  _RAND_127 = {1{`RANDOM}};
  _T_238 = _RAND_127[19:0];
  _RAND_128 = {2{`RANDOM}};
  _T_242 = _RAND_128[63:0];
  _RAND_129 = {1{`RANDOM}};
  _T_243 = _RAND_129[19:0];
  _RAND_130 = {2{`RANDOM}};
  _T_247 = _RAND_130[63:0];
  _RAND_131 = {1{`RANDOM}};
  _T_248 = _RAND_131[19:0];
  _RAND_132 = {2{`RANDOM}};
  _T_252 = _RAND_132[63:0];
  _RAND_133 = {1{`RANDOM}};
  _T_253 = _RAND_133[19:0];
  _RAND_134 = {2{`RANDOM}};
  _T_257 = _RAND_134[63:0];
  _RAND_135 = {1{`RANDOM}};
  _T_258 = _RAND_135[19:0];
  _RAND_136 = {2{`RANDOM}};
  _T_262 = _RAND_136[63:0];
  _RAND_137 = {1{`RANDOM}};
  _T_263 = _RAND_137[19:0];
  _RAND_138 = {2{`RANDOM}};
  _T_267 = _RAND_138[63:0];
  _RAND_139 = {1{`RANDOM}};
  _T_268 = _RAND_139[19:0];
  _RAND_140 = {2{`RANDOM}};
  _T_272 = _RAND_140[63:0];
  _RAND_141 = {1{`RANDOM}};
  _T_273 = _RAND_141[19:0];
  _RAND_142 = {2{`RANDOM}};
  _T_277 = _RAND_142[63:0];
  _RAND_143 = {1{`RANDOM}};
  _T_278 = _RAND_143[19:0];
  _RAND_144 = {2{`RANDOM}};
  _T_282 = _RAND_144[63:0];
  _RAND_145 = {1{`RANDOM}};
  _T_283 = _RAND_145[19:0];
  _RAND_146 = {2{`RANDOM}};
  _T_287 = _RAND_146[63:0];
  _RAND_147 = {1{`RANDOM}};
  _T_288 = _RAND_147[19:0];
  _RAND_148 = {2{`RANDOM}};
  _T_292 = _RAND_148[63:0];
  _RAND_149 = {1{`RANDOM}};
  _T_293 = _RAND_149[19:0];
  _RAND_150 = {2{`RANDOM}};
  _T_297 = _RAND_150[63:0];
  _RAND_151 = {1{`RANDOM}};
  _T_298 = _RAND_151[19:0];
  _RAND_152 = {2{`RANDOM}};
  _T_302 = _RAND_152[63:0];
  _RAND_153 = {1{`RANDOM}};
  _T_303 = _RAND_153[19:0];
  _RAND_154 = {2{`RANDOM}};
  _T_307 = _RAND_154[63:0];
  _RAND_155 = {1{`RANDOM}};
  _T_308 = _RAND_155[19:0];
  _RAND_156 = {2{`RANDOM}};
  _T_312 = _RAND_156[63:0];
  _RAND_157 = {1{`RANDOM}};
  _T_313 = _RAND_157[19:0];
  _RAND_158 = {2{`RANDOM}};
  _T_317 = _RAND_158[63:0];
  _RAND_159 = {1{`RANDOM}};
  _T_318 = _RAND_159[19:0];
  _RAND_160 = {2{`RANDOM}};
  _T_322 = _RAND_160[63:0];
  _RAND_161 = {1{`RANDOM}};
  _T_323 = _RAND_161[19:0];
  _RAND_162 = {2{`RANDOM}};
  _T_327 = _RAND_162[63:0];
  _RAND_163 = {1{`RANDOM}};
  _T_328 = _RAND_163[19:0];
  _RAND_164 = {2{`RANDOM}};
  _T_332 = _RAND_164[63:0];
  _RAND_165 = {1{`RANDOM}};
  _T_333 = _RAND_165[19:0];
  _RAND_166 = {2{`RANDOM}};
  _T_337 = _RAND_166[63:0];
  _RAND_167 = {1{`RANDOM}};
  _T_338 = _RAND_167[19:0];
  _RAND_168 = {2{`RANDOM}};
  _T_342 = _RAND_168[63:0];
  _RAND_169 = {1{`RANDOM}};
  _T_343 = _RAND_169[19:0];
  _RAND_170 = {2{`RANDOM}};
  _T_347 = _RAND_170[63:0];
  _RAND_171 = {1{`RANDOM}};
  _T_348 = _RAND_171[19:0];
  _RAND_172 = {2{`RANDOM}};
  _T_352 = _RAND_172[63:0];
  _RAND_173 = {1{`RANDOM}};
  _T_353 = _RAND_173[19:0];
  _RAND_174 = {2{`RANDOM}};
  _T_357 = _RAND_174[63:0];
  _RAND_175 = {1{`RANDOM}};
  _T_358 = _RAND_175[19:0];
  _RAND_176 = {2{`RANDOM}};
  _T_362 = _RAND_176[63:0];
  _RAND_177 = {1{`RANDOM}};
  _T_363 = _RAND_177[19:0];
  _RAND_178 = {2{`RANDOM}};
  _T_367 = _RAND_178[63:0];
  _RAND_179 = {1{`RANDOM}};
  _T_368 = _RAND_179[19:0];
  _RAND_180 = {2{`RANDOM}};
  _T_372 = _RAND_180[63:0];
  _RAND_181 = {1{`RANDOM}};
  _T_373 = _RAND_181[19:0];
  _RAND_182 = {2{`RANDOM}};
  _T_377 = _RAND_182[63:0];
  _RAND_183 = {1{`RANDOM}};
  _T_378 = _RAND_183[19:0];
  _RAND_184 = {2{`RANDOM}};
  _T_382 = _RAND_184[63:0];
  _RAND_185 = {1{`RANDOM}};
  _T_383 = _RAND_185[19:0];
  _RAND_186 = {2{`RANDOM}};
  _T_387 = _RAND_186[63:0];
  _RAND_187 = {1{`RANDOM}};
  _T_388 = _RAND_187[19:0];
  _RAND_188 = {2{`RANDOM}};
  _T_392 = _RAND_188[63:0];
  _RAND_189 = {1{`RANDOM}};
  _T_393 = _RAND_189[19:0];
  _RAND_190 = {2{`RANDOM}};
  _T_397 = _RAND_190[63:0];
  _RAND_191 = {1{`RANDOM}};
  _T_398 = _RAND_191[19:0];
  _RAND_192 = {2{`RANDOM}};
  _T_402 = _RAND_192[63:0];
  _RAND_193 = {1{`RANDOM}};
  _T_403 = _RAND_193[19:0];
  _RAND_194 = {2{`RANDOM}};
  _T_407 = _RAND_194[63:0];
  _RAND_195 = {1{`RANDOM}};
  _T_408 = _RAND_195[19:0];
  _RAND_196 = {2{`RANDOM}};
  _T_412 = _RAND_196[63:0];
  _RAND_197 = {1{`RANDOM}};
  _T_413 = _RAND_197[19:0];
  _RAND_198 = {2{`RANDOM}};
  _T_417 = _RAND_198[63:0];
  _RAND_199 = {1{`RANDOM}};
  _T_418 = _RAND_199[19:0];
  _RAND_200 = {2{`RANDOM}};
  _T_422 = _RAND_200[63:0];
  _RAND_201 = {1{`RANDOM}};
  _T_423 = _RAND_201[19:0];
  _RAND_202 = {2{`RANDOM}};
  _T_427 = _RAND_202[63:0];
  _RAND_203 = {1{`RANDOM}};
  _T_428 = _RAND_203[19:0];
  _RAND_204 = {2{`RANDOM}};
  _T_432 = _RAND_204[63:0];
  _RAND_205 = {1{`RANDOM}};
  _T_433 = _RAND_205[19:0];
  _RAND_206 = {2{`RANDOM}};
  _T_437 = _RAND_206[63:0];
  _RAND_207 = {1{`RANDOM}};
  _T_438 = _RAND_207[19:0];
  _RAND_208 = {2{`RANDOM}};
  _T_442 = _RAND_208[63:0];
  _RAND_209 = {1{`RANDOM}};
  _T_443 = _RAND_209[19:0];
  _RAND_210 = {2{`RANDOM}};
  _T_447 = _RAND_210[63:0];
  _RAND_211 = {1{`RANDOM}};
  _T_448 = _RAND_211[19:0];
  _RAND_212 = {2{`RANDOM}};
  _T_452 = _RAND_212[63:0];
  _RAND_213 = {1{`RANDOM}};
  _T_453 = _RAND_213[19:0];
  _RAND_214 = {2{`RANDOM}};
  _T_457 = _RAND_214[63:0];
  _RAND_215 = {1{`RANDOM}};
  _T_458 = _RAND_215[19:0];
  _RAND_216 = {2{`RANDOM}};
  _T_462 = _RAND_216[63:0];
  _RAND_217 = {1{`RANDOM}};
  _T_463 = _RAND_217[19:0];
  _RAND_218 = {2{`RANDOM}};
  _T_467 = _RAND_218[63:0];
  _RAND_219 = {1{`RANDOM}};
  _T_468 = _RAND_219[19:0];
  _RAND_220 = {2{`RANDOM}};
  _T_472 = _RAND_220[63:0];
  _RAND_221 = {1{`RANDOM}};
  _T_473 = _RAND_221[19:0];
  _RAND_222 = {2{`RANDOM}};
  _T_477 = _RAND_222[63:0];
  _RAND_223 = {1{`RANDOM}};
  _T_478 = _RAND_223[19:0];
  _RAND_224 = {2{`RANDOM}};
  _T_482 = _RAND_224[63:0];
  _RAND_225 = {1{`RANDOM}};
  _T_483 = _RAND_225[19:0];
  _RAND_226 = {2{`RANDOM}};
  _T_487 = _RAND_226[63:0];
  _RAND_227 = {1{`RANDOM}};
  _T_488 = _RAND_227[19:0];
  _RAND_228 = {2{`RANDOM}};
  _T_492 = _RAND_228[63:0];
  _RAND_229 = {1{`RANDOM}};
  _T_493 = _RAND_229[19:0];
  _RAND_230 = {2{`RANDOM}};
  _T_497 = _RAND_230[63:0];
  _RAND_231 = {1{`RANDOM}};
  _T_498 = _RAND_231[19:0];
  _RAND_232 = {2{`RANDOM}};
  _T_502 = _RAND_232[63:0];
  _RAND_233 = {1{`RANDOM}};
  _T_503 = _RAND_233[19:0];
  _RAND_234 = {2{`RANDOM}};
  _T_507 = _RAND_234[63:0];
  _RAND_235 = {1{`RANDOM}};
  _T_508 = _RAND_235[19:0];
  _RAND_236 = {2{`RANDOM}};
  _T_512 = _RAND_236[63:0];
  _RAND_237 = {1{`RANDOM}};
  _T_513 = _RAND_237[19:0];
  _RAND_238 = {2{`RANDOM}};
  _T_517 = _RAND_238[63:0];
  _RAND_239 = {1{`RANDOM}};
  _T_518 = _RAND_239[19:0];
  _RAND_240 = {2{`RANDOM}};
  _T_522 = _RAND_240[63:0];
  _RAND_241 = {1{`RANDOM}};
  _T_523 = _RAND_241[19:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    reset_reg <= reset;
    reset_reg_array_0 <= reset;
    reset_reg_array_1 <= reset;
    reset_reg_array_2 <= reset;
    reset_reg_array_3 <= reset;
    reset_reg_array_4 <= reset;
    reset_reg_array_5 <= reset;
    reset_reg_array_6 <= reset;
    reset_reg_array_7 <= reset;
    reset_reg_array_8 <= reset;
    reset_reg_array_9 <= reset;
    reset_reg_array_10 <= reset;
    reset_reg_array_11 <= reset;
    reset_reg_array_12 <= reset;
    reset_reg_array_13 <= reset;
    reset_reg_array_14 <= reset;
    reset_reg_array_15 <= reset;
    reset_reg_array_16 <= reset;
    reset_reg_array_17 <= reset;
    _T_18 <= io_node_num;
    _T_19 <= io_root;
    _T_20 <= io_offsets_CSR_R_offset;
    _T_21 <= io_offsets_CSR_C_offset;
    _T_22 <= io_offsets_CSC_R_offset;
    _T_23 <= io_offsets_CSC_C_offset;
    _T_24 <= io_offsets_level_offset;
    if (reset) begin
      r_array_count_0 <= 32'h0;
    end else if (_T_169) begin
      r_array_count_0 <= _T_171;
    end
    if (reset) begin
      r_array_count_1 <= 32'h0;
    end else if (_T_174) begin
      r_array_count_1 <= _T_176;
    end
    if (reset) begin
      r_array_count_2 <= 32'h0;
    end else if (_T_179) begin
      r_array_count_2 <= _T_181;
    end
    if (reset) begin
      r_array_count_3 <= 32'h0;
    end else if (_T_184) begin
      r_array_count_3 <= _T_186;
    end
    if (reset) begin
      r_array_count_4 <= 32'h0;
    end else if (_T_189) begin
      r_array_count_4 <= _T_191;
    end
    if (reset) begin
      r_array_count_5 <= 32'h0;
    end else if (_T_194) begin
      r_array_count_5 <= _T_196;
    end
    if (reset) begin
      r_array_count_6 <= 32'h0;
    end else if (_T_199) begin
      r_array_count_6 <= _T_201;
    end
    if (reset) begin
      r_array_count_7 <= 32'h0;
    end else if (_T_204) begin
      r_array_count_7 <= _T_206;
    end
    if (reset) begin
      r_array_count_8 <= 32'h0;
    end else if (_T_209) begin
      r_array_count_8 <= _T_211;
    end
    if (reset) begin
      r_array_count_9 <= 32'h0;
    end else if (_T_214) begin
      r_array_count_9 <= _T_216;
    end
    if (reset) begin
      r_array_count_10 <= 32'h0;
    end else if (_T_219) begin
      r_array_count_10 <= _T_221;
    end
    if (reset) begin
      r_array_count_11 <= 32'h0;
    end else if (_T_224) begin
      r_array_count_11 <= _T_226;
    end
    if (reset) begin
      r_array_count_12 <= 32'h0;
    end else if (_T_229) begin
      r_array_count_12 <= _T_231;
    end
    if (reset) begin
      r_array_count_13 <= 32'h0;
    end else if (_T_234) begin
      r_array_count_13 <= _T_236;
    end
    if (reset) begin
      r_array_count_14 <= 32'h0;
    end else if (_T_239) begin
      r_array_count_14 <= _T_241;
    end
    if (reset) begin
      r_array_count_15 <= 32'h0;
    end else if (_T_244) begin
      r_array_count_15 <= _T_246;
    end
    if (reset) begin
      r_array_count_16 <= 32'h0;
    end else if (_T_249) begin
      r_array_count_16 <= _T_251;
    end
    if (reset) begin
      r_array_count_17 <= 32'h0;
    end else if (_T_254) begin
      r_array_count_17 <= _T_256;
    end
    if (reset) begin
      r_array_count_18 <= 32'h0;
    end else if (_T_259) begin
      r_array_count_18 <= _T_261;
    end
    if (reset) begin
      r_array_count_19 <= 32'h0;
    end else if (_T_264) begin
      r_array_count_19 <= _T_266;
    end
    if (reset) begin
      r_array_count_20 <= 32'h0;
    end else if (_T_269) begin
      r_array_count_20 <= _T_271;
    end
    if (reset) begin
      r_array_count_21 <= 32'h0;
    end else if (_T_274) begin
      r_array_count_21 <= _T_276;
    end
    if (reset) begin
      r_array_count_22 <= 32'h0;
    end else if (_T_279) begin
      r_array_count_22 <= _T_281;
    end
    if (reset) begin
      r_array_count_23 <= 32'h0;
    end else if (_T_284) begin
      r_array_count_23 <= _T_286;
    end
    if (reset) begin
      r_array_count_24 <= 32'h0;
    end else if (_T_289) begin
      r_array_count_24 <= _T_291;
    end
    if (reset) begin
      r_array_count_25 <= 32'h0;
    end else if (_T_294) begin
      r_array_count_25 <= _T_296;
    end
    if (reset) begin
      r_array_count_26 <= 32'h0;
    end else if (_T_299) begin
      r_array_count_26 <= _T_301;
    end
    if (reset) begin
      r_array_count_27 <= 32'h0;
    end else if (_T_304) begin
      r_array_count_27 <= _T_306;
    end
    if (reset) begin
      r_array_count_28 <= 32'h0;
    end else if (_T_309) begin
      r_array_count_28 <= _T_311;
    end
    if (reset) begin
      r_array_count_29 <= 32'h0;
    end else if (_T_314) begin
      r_array_count_29 <= _T_316;
    end
    if (reset) begin
      r_array_count_30 <= 32'h0;
    end else if (_T_319) begin
      r_array_count_30 <= _T_321;
    end
    if (reset) begin
      r_array_count_31 <= 32'h0;
    end else if (_T_324) begin
      r_array_count_31 <= _T_326;
    end
    if (reset) begin
      r_array_count_32 <= 32'h0;
    end else if (_T_329) begin
      r_array_count_32 <= _T_331;
    end
    if (reset) begin
      r_array_count_33 <= 32'h0;
    end else if (_T_334) begin
      r_array_count_33 <= _T_336;
    end
    if (reset) begin
      r_array_count_34 <= 32'h0;
    end else if (_T_339) begin
      r_array_count_34 <= _T_341;
    end
    if (reset) begin
      r_array_count_35 <= 32'h0;
    end else if (_T_344) begin
      r_array_count_35 <= _T_346;
    end
    if (reset) begin
      r_array_count_36 <= 32'h0;
    end else if (_T_349) begin
      r_array_count_36 <= _T_351;
    end
    if (reset) begin
      r_array_count_37 <= 32'h0;
    end else if (_T_354) begin
      r_array_count_37 <= _T_356;
    end
    if (reset) begin
      r_array_count_38 <= 32'h0;
    end else if (_T_359) begin
      r_array_count_38 <= _T_361;
    end
    if (reset) begin
      r_array_count_39 <= 32'h0;
    end else if (_T_364) begin
      r_array_count_39 <= _T_366;
    end
    if (reset) begin
      r_array_count_40 <= 32'h0;
    end else if (_T_369) begin
      r_array_count_40 <= _T_371;
    end
    if (reset) begin
      r_array_count_41 <= 32'h0;
    end else if (_T_374) begin
      r_array_count_41 <= _T_376;
    end
    if (reset) begin
      r_array_count_42 <= 32'h0;
    end else if (_T_379) begin
      r_array_count_42 <= _T_381;
    end
    if (reset) begin
      r_array_count_43 <= 32'h0;
    end else if (_T_384) begin
      r_array_count_43 <= _T_386;
    end
    if (reset) begin
      r_array_count_44 <= 32'h0;
    end else if (_T_389) begin
      r_array_count_44 <= _T_391;
    end
    if (reset) begin
      r_array_count_45 <= 32'h0;
    end else if (_T_394) begin
      r_array_count_45 <= _T_396;
    end
    if (reset) begin
      r_array_count_46 <= 32'h0;
    end else if (_T_399) begin
      r_array_count_46 <= _T_401;
    end
    if (reset) begin
      r_array_count_47 <= 32'h0;
    end else if (_T_404) begin
      r_array_count_47 <= _T_406;
    end
    if (reset) begin
      r_array_count_48 <= 32'h0;
    end else if (_T_409) begin
      r_array_count_48 <= _T_411;
    end
    if (reset) begin
      r_array_count_49 <= 32'h0;
    end else if (_T_414) begin
      r_array_count_49 <= _T_416;
    end
    if (reset) begin
      r_array_count_50 <= 32'h0;
    end else if (_T_419) begin
      r_array_count_50 <= _T_421;
    end
    if (reset) begin
      r_array_count_51 <= 32'h0;
    end else if (_T_424) begin
      r_array_count_51 <= _T_426;
    end
    if (reset) begin
      r_array_count_52 <= 32'h0;
    end else if (_T_429) begin
      r_array_count_52 <= _T_431;
    end
    if (reset) begin
      r_array_count_53 <= 32'h0;
    end else if (_T_434) begin
      r_array_count_53 <= _T_436;
    end
    if (reset) begin
      r_array_count_54 <= 32'h0;
    end else if (_T_439) begin
      r_array_count_54 <= _T_441;
    end
    if (reset) begin
      r_array_count_55 <= 32'h0;
    end else if (_T_444) begin
      r_array_count_55 <= _T_446;
    end
    if (reset) begin
      r_array_count_56 <= 32'h0;
    end else if (_T_449) begin
      r_array_count_56 <= _T_451;
    end
    if (reset) begin
      r_array_count_57 <= 32'h0;
    end else if (_T_454) begin
      r_array_count_57 <= _T_456;
    end
    if (reset) begin
      r_array_count_58 <= 32'h0;
    end else if (_T_459) begin
      r_array_count_58 <= _T_461;
    end
    if (reset) begin
      r_array_count_59 <= 32'h0;
    end else if (_T_464) begin
      r_array_count_59 <= _T_466;
    end
    if (reset) begin
      r_array_count_60 <= 32'h0;
    end else if (_T_469) begin
      r_array_count_60 <= _T_471;
    end
    if (reset) begin
      r_array_count_61 <= 32'h0;
    end else if (_T_474) begin
      r_array_count_61 <= _T_476;
    end
    if (reset) begin
      r_array_count_62 <= 32'h0;
    end else if (_T_479) begin
      r_array_count_62 <= _T_481;
    end
    if (reset) begin
      r_array_count_63 <= 32'h0;
    end else if (_T_484) begin
      r_array_count_63 <= _T_486;
    end
    if (reset) begin
      r_array_count_64 <= 32'h0;
    end else if (_T_489) begin
      r_array_count_64 <= _T_491;
    end
    if (reset) begin
      r_array_count_65 <= 32'h0;
    end else if (_T_494) begin
      r_array_count_65 <= _T_496;
    end
    if (reset) begin
      r_array_count_66 <= 32'h0;
    end else if (_T_499) begin
      r_array_count_66 <= _T_501;
    end
    if (reset) begin
      r_array_count_67 <= 32'h0;
    end else if (_T_504) begin
      r_array_count_67 <= _T_506;
    end
    if (reset) begin
      r_array_count_68 <= 32'h0;
    end else if (_T_509) begin
      r_array_count_68 <= _T_511;
    end
    if (reset) begin
      r_array_count_69 <= 32'h0;
    end else if (_T_514) begin
      r_array_count_69 <= _T_516;
    end
    if (reset) begin
      r_array_count_70 <= 32'h0;
    end else if (_T_519) begin
      r_array_count_70 <= _T_521;
    end
    if (reset) begin
      r_array_count_71 <= 32'h0;
    end else if (_T_524) begin
      r_array_count_71 <= _T_526;
    end
    _T_167 <= pipeline_io_uram_out_a_0;
    _T_168 <= io_uram_addr_a_0;
    _T_172 <= pipeline_io_uram_out_a_1;
    _T_173 <= io_uram_addr_a_1;
    _T_177 <= pipeline_io_uram_out_a_2;
    _T_178 <= io_uram_addr_a_2;
    _T_182 <= pipeline_io_uram_out_a_3;
    _T_183 <= io_uram_addr_a_3;
    _T_187 <= pipeline_1_io_uram_out_a_0;
    _T_188 <= io_uram_addr_a_4;
    _T_192 <= pipeline_1_io_uram_out_a_1;
    _T_193 <= io_uram_addr_a_5;
    _T_197 <= pipeline_1_io_uram_out_a_2;
    _T_198 <= io_uram_addr_a_6;
    _T_202 <= pipeline_1_io_uram_out_a_3;
    _T_203 <= io_uram_addr_a_7;
    _T_207 <= pipeline_2_io_uram_out_a_0;
    _T_208 <= io_uram_addr_a_8;
    _T_212 <= pipeline_2_io_uram_out_a_1;
    _T_213 <= io_uram_addr_a_9;
    _T_217 <= pipeline_2_io_uram_out_a_2;
    _T_218 <= io_uram_addr_a_10;
    _T_222 <= pipeline_2_io_uram_out_a_3;
    _T_223 <= io_uram_addr_a_11;
    _T_227 <= pipeline_3_io_uram_out_a_0;
    _T_228 <= io_uram_addr_a_12;
    _T_232 <= pipeline_3_io_uram_out_a_1;
    _T_233 <= io_uram_addr_a_13;
    _T_237 <= pipeline_3_io_uram_out_a_2;
    _T_238 <= io_uram_addr_a_14;
    _T_242 <= pipeline_3_io_uram_out_a_3;
    _T_243 <= io_uram_addr_a_15;
    _T_247 <= pipeline_4_io_uram_out_a_0;
    _T_248 <= io_uram_addr_a_16;
    _T_252 <= pipeline_4_io_uram_out_a_1;
    _T_253 <= io_uram_addr_a_17;
    _T_257 <= pipeline_4_io_uram_out_a_2;
    _T_258 <= io_uram_addr_a_18;
    _T_262 <= pipeline_4_io_uram_out_a_3;
    _T_263 <= io_uram_addr_a_19;
    _T_267 <= pipeline_5_io_uram_out_a_0;
    _T_268 <= io_uram_addr_a_20;
    _T_272 <= pipeline_5_io_uram_out_a_1;
    _T_273 <= io_uram_addr_a_21;
    _T_277 <= pipeline_5_io_uram_out_a_2;
    _T_278 <= io_uram_addr_a_22;
    _T_282 <= pipeline_5_io_uram_out_a_3;
    _T_283 <= io_uram_addr_a_23;
    _T_287 <= pipeline_6_io_uram_out_a_0;
    _T_288 <= io_uram_addr_a_24;
    _T_292 <= pipeline_6_io_uram_out_a_1;
    _T_293 <= io_uram_addr_a_25;
    _T_297 <= pipeline_6_io_uram_out_a_2;
    _T_298 <= io_uram_addr_a_26;
    _T_302 <= pipeline_6_io_uram_out_a_3;
    _T_303 <= io_uram_addr_a_27;
    _T_307 <= pipeline_7_io_uram_out_a_0;
    _T_308 <= io_uram_addr_a_28;
    _T_312 <= pipeline_7_io_uram_out_a_1;
    _T_313 <= io_uram_addr_a_29;
    _T_317 <= pipeline_7_io_uram_out_a_2;
    _T_318 <= io_uram_addr_a_30;
    _T_322 <= pipeline_7_io_uram_out_a_3;
    _T_323 <= io_uram_addr_a_31;
    _T_327 <= pipeline_8_io_uram_out_a_0;
    _T_328 <= io_uram_addr_a_32;
    _T_332 <= pipeline_8_io_uram_out_a_1;
    _T_333 <= io_uram_addr_a_33;
    _T_337 <= pipeline_8_io_uram_out_a_2;
    _T_338 <= io_uram_addr_a_34;
    _T_342 <= pipeline_8_io_uram_out_a_3;
    _T_343 <= io_uram_addr_a_35;
    _T_347 <= pipeline_9_io_uram_out_a_0;
    _T_348 <= io_uram_addr_a_36;
    _T_352 <= pipeline_9_io_uram_out_a_1;
    _T_353 <= io_uram_addr_a_37;
    _T_357 <= pipeline_9_io_uram_out_a_2;
    _T_358 <= io_uram_addr_a_38;
    _T_362 <= pipeline_9_io_uram_out_a_3;
    _T_363 <= io_uram_addr_a_39;
    _T_367 <= pipeline_10_io_uram_out_a_0;
    _T_368 <= io_uram_addr_a_40;
    _T_372 <= pipeline_10_io_uram_out_a_1;
    _T_373 <= io_uram_addr_a_41;
    _T_377 <= pipeline_10_io_uram_out_a_2;
    _T_378 <= io_uram_addr_a_42;
    _T_382 <= pipeline_10_io_uram_out_a_3;
    _T_383 <= io_uram_addr_a_43;
    _T_387 <= pipeline_11_io_uram_out_a_0;
    _T_388 <= io_uram_addr_a_44;
    _T_392 <= pipeline_11_io_uram_out_a_1;
    _T_393 <= io_uram_addr_a_45;
    _T_397 <= pipeline_11_io_uram_out_a_2;
    _T_398 <= io_uram_addr_a_46;
    _T_402 <= pipeline_11_io_uram_out_a_3;
    _T_403 <= io_uram_addr_a_47;
    _T_407 <= pipeline_12_io_uram_out_a_0;
    _T_408 <= io_uram_addr_a_48;
    _T_412 <= pipeline_12_io_uram_out_a_1;
    _T_413 <= io_uram_addr_a_49;
    _T_417 <= pipeline_12_io_uram_out_a_2;
    _T_418 <= io_uram_addr_a_50;
    _T_422 <= pipeline_12_io_uram_out_a_3;
    _T_423 <= io_uram_addr_a_51;
    _T_427 <= pipeline_13_io_uram_out_a_0;
    _T_428 <= io_uram_addr_a_52;
    _T_432 <= pipeline_13_io_uram_out_a_1;
    _T_433 <= io_uram_addr_a_53;
    _T_437 <= pipeline_13_io_uram_out_a_2;
    _T_438 <= io_uram_addr_a_54;
    _T_442 <= pipeline_13_io_uram_out_a_3;
    _T_443 <= io_uram_addr_a_55;
    _T_447 <= pipeline_14_io_uram_out_a_0;
    _T_448 <= io_uram_addr_a_56;
    _T_452 <= pipeline_14_io_uram_out_a_1;
    _T_453 <= io_uram_addr_a_57;
    _T_457 <= pipeline_14_io_uram_out_a_2;
    _T_458 <= io_uram_addr_a_58;
    _T_462 <= pipeline_14_io_uram_out_a_3;
    _T_463 <= io_uram_addr_a_59;
    _T_467 <= pipeline_15_io_uram_out_a_0;
    _T_468 <= io_uram_addr_a_60;
    _T_472 <= pipeline_15_io_uram_out_a_1;
    _T_473 <= io_uram_addr_a_61;
    _T_477 <= pipeline_15_io_uram_out_a_2;
    _T_478 <= io_uram_addr_a_62;
    _T_482 <= pipeline_15_io_uram_out_a_3;
    _T_483 <= io_uram_addr_a_63;
    _T_487 <= pipeline_16_io_uram_out_a_0;
    _T_488 <= io_uram_addr_a_64;
    _T_492 <= pipeline_16_io_uram_out_a_1;
    _T_493 <= io_uram_addr_a_65;
    _T_497 <= pipeline_16_io_uram_out_a_2;
    _T_498 <= io_uram_addr_a_66;
    _T_502 <= pipeline_16_io_uram_out_a_3;
    _T_503 <= io_uram_addr_a_67;
    _T_507 <= pipeline_17_io_uram_out_a_0;
    _T_508 <= io_uram_addr_a_68;
    _T_512 <= pipeline_17_io_uram_out_a_1;
    _T_513 <= io_uram_addr_a_69;
    _T_517 <= pipeline_17_io_uram_out_a_2;
    _T_518 <= io_uram_addr_a_70;
    _T_522 <= pipeline_17_io_uram_out_a_3;
    _T_523 <= io_uram_addr_a_71;
  end
endmodule
module RRArbiter_160(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [47:0] io_out_bits,
  output [1:0]  io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = 2'h1 == io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = 2'h1 == io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_5 = 2'h1 == io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_6 = 2'h2 == io_chosen ? io_in_2_ready : _GEN_3; // @[Arbiter.scala 41:16]
  wire  _GEN_7 = 2'h2 == io_chosen ? io_in_2_valid : _GEN_4; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_8 = 2'h2 == io_chosen ? io_in_2_bits : _GEN_5; // @[Arbiter.scala 41:16]
  wire  _GEN_9 = 2'h3 == io_chosen ? io_in_3_ready : _GEN_6; // @[Arbiter.scala 41:16]
  wire  _GEN_10 = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_11 = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg [1:0] lastGrant; // @[Reg.scala 15:16]
  wire [1:0] _GEN_12 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 2'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_2 = 2'h2 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_3 = 2'h3 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  validMask_2 = io_in_2_valid & grantMask_2; // @[Arbiter.scala 68:75]
  wire  validMask_3 = io_in_3_valid & grantMask_3; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | validMask_2; // @[Arbiter.scala 31:68]
  wire  _T_3 = _T_2 | validMask_3; // @[Arbiter.scala 31:68]
  wire  _T_4 = _T_3 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_5 = _T_4 | io_in_1_valid; // @[Arbiter.scala 31:68]
  wire  _T_6 = _T_5 | io_in_2_valid; // @[Arbiter.scala 31:68]
  wire  _T_7 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_8 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_9 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_10 = ~_T_3; // @[Arbiter.scala 31:78]
  wire  _T_11 = ~_T_4; // @[Arbiter.scala 31:78]
  wire  _T_12 = ~_T_5; // @[Arbiter.scala 31:78]
  wire  _T_13 = ~_T_6; // @[Arbiter.scala 31:78]
  wire  _T_14 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_15 = _T_10; // @[Arbiter.scala 72:50]
  wire  _T_16 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_17 = grantMask_1 | _T_11; // @[Arbiter.scala 72:50]
  wire  _T_18 = _T_8 & grantMask_2; // @[Arbiter.scala 72:34]
  wire  _T_19 = _T_18 | _T_12; // @[Arbiter.scala 72:50]
  wire  _T_20 = _T_9 & grantMask_3; // @[Arbiter.scala 72:34]
  wire  _T_21 = _T_20 | _T_13; // @[Arbiter.scala 72:50]
  wire  _T_22 = _T_10 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_23 = _T_17 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_24 = _T_19 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_25 = _T_21 & io_out_ready; // @[Arbiter.scala 60:21]
  wire [1:0] _GEN_13 = io_in_2_valid ? 2'h2 : 2'h3; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_14 = io_in_1_valid ? 2'h1 : _GEN_13; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_15 = io_in_0_valid ? 2'h0 : _GEN_14; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_16 = validMask_3 ? 2'h3 : _GEN_15; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_17 = validMask_2 ? 2'h2 : _GEN_16; // @[Arbiter.scala 79:25]
  wire [1:0] choice = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_18 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 79:34 Arbiter.scala 79:34 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_9; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_10; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [47:0] _io_in_io_chosen_bits = _GEN_11; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_9; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_10; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [47:0] _io_in_io_chosen_0_bits = _GEN_11; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_10 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_17 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_2_ready = _T_19 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_3_ready = _T_21 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  assign io_out_bits = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[1:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module sub_crossbar(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_6 = _GEN_100[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_7 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_8 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [24:0] _T_9 = _T_8[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_8[24:0]; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_14 = _GEN_101[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_15 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_16 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [24:0] _T_17 = _T_16[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_16[24:0]; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_22 = _GEN_102[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_23 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_24 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [24:0] _T_25 = _T_24[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_24[24:0]; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_30 = _GEN_103[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_31 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_32 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [24:0] _T_33 = _T_32[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_32[24:0]; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_39 = _GEN_104[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_40 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_41 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [24:0] _T_42 = _T_8[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_8[24:0]; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_47 = _GEN_105[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_48 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_49 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [24:0] _T_50 = _T_16[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_16[24:0]; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_55 = _GEN_106[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_56 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_57 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [24:0] _T_58 = _T_24[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_24[24:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_63 = _GEN_107[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_64 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_65 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [24:0] _T_66 = _T_32[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_32[24:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_72 = _GEN_108[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_73 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_74 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [24:0] _T_75 = _T_8[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_8[24:0]; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_80 = _GEN_109[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_81 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_82 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [24:0] _T_83 = _T_16[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_16[24:0]; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_88 = _GEN_110[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_89 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_90 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [24:0] _T_91 = _T_24[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_24[24:0]; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_96 = _GEN_111[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_97 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_98 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [24:0] _T_99 = _T_32[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_32[24:0]; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_105 = _GEN_112[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_106 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_107 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [24:0] _T_108 = _T_8[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_8[24:0]; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_113 = _GEN_113[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_114 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_115 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [24:0] _T_116 = _T_16[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_16[24:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_121 = _GEN_114[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_122 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_123 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [24:0] _T_124 = _T_24[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_24[24:0]; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_129 = _GEN_115[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_130 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_131 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [24:0] _T_132 = _T_32[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_32[24:0]; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_1(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_6 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_7 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_8 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [26:0] _T_9 = _T_8[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_8[26:0]; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_14 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_15 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_16 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [26:0] _T_17 = _T_16[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_16[26:0]; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_22 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_23 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_24 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [26:0] _T_25 = _T_24[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_24[26:0]; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_30 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_31 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_32 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [26:0] _T_33 = _T_32[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_32[26:0]; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_39 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_40 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_41 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [26:0] _T_42 = _T_8[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_8[26:0]; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_47 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_48 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_49 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [26:0] _T_50 = _T_16[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_16[26:0]; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_24[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_24[26:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_32[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_32[26:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_72 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_73 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_74 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [26:0] _T_75 = _T_8[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_8[26:0]; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_80 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_81 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_82 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [26:0] _T_83 = _T_16[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_16[26:0]; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_88 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_89 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_90 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [26:0] _T_91 = _T_24[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_24[26:0]; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_96 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_97 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_98 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [26:0] _T_99 = _T_32[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_32[26:0]; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_105 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_106 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_107 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [26:0] _T_108 = _T_8[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_8[26:0]; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_16[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_16[26:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_121 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_122 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_123 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [26:0] _T_124 = _T_24[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_24[26:0]; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_129 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_130 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_131 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [26:0] _T_132 = _T_32[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_32[26:0]; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_2(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_8[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_8[28:0]; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_16[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_16[28:0]; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_24[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_24[28:0]; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_32[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_32[28:0]; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_8[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_8[28:0]; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_16[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_16[28:0]; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_24[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_24[28:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_32[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_32[28:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_8[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_8[28:0]; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_16[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_16[28:0]; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_24[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_24[28:0]; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_32[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_32[28:0]; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = {{1'd0}, _T_7}; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_8[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_8[28:0]; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = {{1'd0}, _T_15}; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_16[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_16[28:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = {{1'd0}, _T_23}; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_24[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_24[28:0]; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = {{1'd0}, _T_31}; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_32[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_32[28:0]; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_4(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_6 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_7 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_8 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_9 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_14 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_15 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_16 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_17 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_22 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_23 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_24 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_25 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_30 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_31 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_32 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_33 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_39 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_40 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_41 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_42 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_47 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_48 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_49 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_50 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_72 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_73 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_74 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_75 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_80 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_81 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_82 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_83 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_88 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_89 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_90 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_91 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_96 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_97 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_98 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_99 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_105 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_106 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_107 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_108 = _T_7 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_15 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_121 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_122 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_123 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_124 = _T_23 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_129 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_130 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_131 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_132 = _T_31 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_5(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_7(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_6 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_7 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_8 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_9 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_14 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_15 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_16 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_17 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_22 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_23 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_24 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_25 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_30 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_31 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_32 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_33 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_39 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_40 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_41 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_42 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_47 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_48 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_49 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_50 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_72 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_73 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_74 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_75 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_80 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_81 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_82 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_83 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_88 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_89 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_90 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_91 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_96 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_97 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_98 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_99 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_105 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_106 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_107 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_108 = _T_7 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_15 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_121 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_122 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_123 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_124 = _T_23 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_129 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_130 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_131 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_132 = _T_31 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_8(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_10(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_6 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_7 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_8 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_9 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_14 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_15 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_16 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_17 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_22 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_23 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_24 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_25 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_30 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_31 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_32 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_33 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_39 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_40 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_41 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_42 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_47 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_48 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_49 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_50 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_72 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_73 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_74 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_75 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_80 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_81 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_82 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_83 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_88 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_89 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_90 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_91 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_96 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_97 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_98 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_99 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_105 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_106 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_107 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_108 = _T_7 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_15 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_121 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_122 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_123 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_124 = _T_23 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_129 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_130 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_131 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_132 = _T_31 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_11(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_14(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_17(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_20(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_23(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_26(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_29(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_32(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_35(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_38(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_41(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_44(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_47(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_5 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_100 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_6 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_7 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_8 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_9 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_10 = _GEN_84 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_11 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_12 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_10 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_10 & _T_12; // @[crossbar.scala 262:136]
  wire [23:0] _T_13 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_101 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_14 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_15 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_16 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_17 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_18 = _GEN_84 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_19 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_20 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_18 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_18 ? _T_20 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _T_21 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_102 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_22 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_23 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_24 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_25 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_26 = _GEN_84 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_27 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_28 = ~fifo_cxb_48_3_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_6 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_26 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_26 ? _T_28 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _T_29 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_103 = fifo_cxb_48_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_30 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_31 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_32 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_33 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_6}; // @[crossbar.scala 262:68]
  wire  _T_34 = _GEN_84 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_35 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_36 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_9 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_34 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_34 ? _T_36 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_37 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_38 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_104 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_39 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_40 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_41 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_42 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_43 = _GEN_88 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_44 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_45 = ~fifo_cxb_48_6_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_21 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_43 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_43 & _T_45; // @[crossbar.scala 262:136]
  wire [23:0] _T_46 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_105 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_47 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_48 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_49 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_50 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_51 = _GEN_88 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_52 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_53 = ~fifo_cxb_48_7_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_24 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_51 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_51 ? _T_53 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _T_54 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_106 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_48_8_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_27 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_59 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_59 ? _T_61 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _T_62 = fifo_cxb_48_5_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_107 = fifo_cxb_48_5_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_39}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_88 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_48_9_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_30 = fifo_cxb_48_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_67 & _T_37; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_67 ? _T_69 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_37 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_37 & _GEN_22; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_37 & _GEN_25; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_37 & _GEN_28; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_37 & _GEN_31; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_70 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_71 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_108 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_72 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_73 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_74 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_75 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_76 = _GEN_92 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_77 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_78 = ~fifo_cxb_48_11_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_42 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_76 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_76 & _T_78; // @[crossbar.scala 262:136]
  wire [23:0] _T_79 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_109 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_80 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_81 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_82 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_83 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_84 = _GEN_92 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_85 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_86 = ~fifo_cxb_48_12_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_45 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_84 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_84 ? _T_86 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _T_87 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_110 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_88 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_89 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_90 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_91 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_92 = _GEN_92 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_93 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_94 = ~fifo_cxb_48_13_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_48 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_92 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_92 ? _T_94 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _T_95 = fifo_cxb_48_10_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_111 = fifo_cxb_48_10_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_96 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_97 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_98 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_99 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_72}; // @[crossbar.scala 262:68]
  wire  _T_100 = _GEN_92 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_101 = ~fifo_cxb_48_10_empty; // @[crossbar.scala 264:21]
  wire  _T_102 = ~fifo_cxb_48_14_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_51 = fifo_cxb_48_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_100 & _T_70; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_100 ? _T_102 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_70 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_70 & _GEN_43; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_70 & _GEN_46; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_70 & _GEN_49; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_70 & _GEN_52; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_103 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_104 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_112 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_105 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_106 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_107 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_108 = _T_7 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_109 = _GEN_96 == _T_9; // @[crossbar.scala 262:68]
  wire  _T_110 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_111 = ~fifo_cxb_48_16_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_63 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_109 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_109 & _T_111; // @[crossbar.scala 262:136]
  wire [23:0] _T_112 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_113 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_15 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_17; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_48_17_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_66 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_117 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_117 ? _T_119 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _T_120 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_114 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_121 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_122 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_123 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_124 = _T_23 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_125 = _GEN_96 == _T_25; // @[crossbar.scala 262:68]
  wire  _T_126 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_127 = ~fifo_cxb_48_18_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_69 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_125 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_125 ? _T_127 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _T_128 = fifo_cxb_48_15_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_115 = fifo_cxb_48_15_dout[47:24] % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_129 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_130 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_131 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_132 = _T_31 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_105}; // @[crossbar.scala 262:68]
  wire  _T_133 = _GEN_96 == _T_33; // @[crossbar.scala 262:68]
  wire  _T_134 = ~fifo_cxb_48_15_empty; // @[crossbar.scala 264:21]
  wire  _T_135 = ~fifo_cxb_48_19_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_72 = fifo_cxb_48_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_133 & _T_103; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_133 ? _T_135 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_103 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_103 & _GEN_64; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_103 & _GEN_67; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_103 & _GEN_70; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_103 & _GEN_73; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_136 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_137 = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:13]
  wire  _T_138 = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:13]
  wire  _T_139 = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:13]
  wire  _T_140 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_141 = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:13]
  wire  _T_142 = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:13]
  wire  _T_143 = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:13]
  wire  _T_144 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:13]
  wire  _T_145 = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:13]
  wire  _T_146 = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:13]
  wire  _T_147 = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:13]
  wire  _T_148 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_149 = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:13]
  wire  _T_150 = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:13]
  wire  _T_151 = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_160 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  RRArbiter_160 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_6_rst),
    .clk(fifo_cxb_48_6_clk),
    .din(fifo_cxb_48_6_din),
    .wr_en(fifo_cxb_48_6_wr_en),
    .rd_en(fifo_cxb_48_6_rd_en),
    .dout(fifo_cxb_48_6_dout),
    .full(fifo_cxb_48_6_full),
    .empty(fifo_cxb_48_6_empty)
  );
  fifo_cxb_48 fifo_cxb_48_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_7_rst),
    .clk(fifo_cxb_48_7_clk),
    .din(fifo_cxb_48_7_din),
    .wr_en(fifo_cxb_48_7_wr_en),
    .rd_en(fifo_cxb_48_7_rd_en),
    .dout(fifo_cxb_48_7_dout),
    .full(fifo_cxb_48_7_full),
    .empty(fifo_cxb_48_7_empty)
  );
  fifo_cxb_48 fifo_cxb_48_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_8_rst),
    .clk(fifo_cxb_48_8_clk),
    .din(fifo_cxb_48_8_din),
    .wr_en(fifo_cxb_48_8_wr_en),
    .rd_en(fifo_cxb_48_8_rd_en),
    .dout(fifo_cxb_48_8_dout),
    .full(fifo_cxb_48_8_full),
    .empty(fifo_cxb_48_8_empty)
  );
  fifo_cxb_48 fifo_cxb_48_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_9_rst),
    .clk(fifo_cxb_48_9_clk),
    .din(fifo_cxb_48_9_din),
    .wr_en(fifo_cxb_48_9_wr_en),
    .rd_en(fifo_cxb_48_9_rd_en),
    .dout(fifo_cxb_48_9_dout),
    .full(fifo_cxb_48_9_full),
    .empty(fifo_cxb_48_9_empty)
  );
  fifo_cxb_48 fifo_cxb_48_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_10_rst),
    .clk(fifo_cxb_48_10_clk),
    .din(fifo_cxb_48_10_din),
    .wr_en(fifo_cxb_48_10_wr_en),
    .rd_en(fifo_cxb_48_10_rd_en),
    .dout(fifo_cxb_48_10_dout),
    .full(fifo_cxb_48_10_full),
    .empty(fifo_cxb_48_10_empty)
  );
  RRArbiter_160 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_11_rst),
    .clk(fifo_cxb_48_11_clk),
    .din(fifo_cxb_48_11_din),
    .wr_en(fifo_cxb_48_11_wr_en),
    .rd_en(fifo_cxb_48_11_rd_en),
    .dout(fifo_cxb_48_11_dout),
    .full(fifo_cxb_48_11_full),
    .empty(fifo_cxb_48_11_empty)
  );
  fifo_cxb_48 fifo_cxb_48_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_12_rst),
    .clk(fifo_cxb_48_12_clk),
    .din(fifo_cxb_48_12_din),
    .wr_en(fifo_cxb_48_12_wr_en),
    .rd_en(fifo_cxb_48_12_rd_en),
    .dout(fifo_cxb_48_12_dout),
    .full(fifo_cxb_48_12_full),
    .empty(fifo_cxb_48_12_empty)
  );
  fifo_cxb_48 fifo_cxb_48_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_13_rst),
    .clk(fifo_cxb_48_13_clk),
    .din(fifo_cxb_48_13_din),
    .wr_en(fifo_cxb_48_13_wr_en),
    .rd_en(fifo_cxb_48_13_rd_en),
    .dout(fifo_cxb_48_13_dout),
    .full(fifo_cxb_48_13_full),
    .empty(fifo_cxb_48_13_empty)
  );
  fifo_cxb_48 fifo_cxb_48_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_14_rst),
    .clk(fifo_cxb_48_14_clk),
    .din(fifo_cxb_48_14_din),
    .wr_en(fifo_cxb_48_14_wr_en),
    .rd_en(fifo_cxb_48_14_rd_en),
    .dout(fifo_cxb_48_14_dout),
    .full(fifo_cxb_48_14_full),
    .empty(fifo_cxb_48_14_empty)
  );
  fifo_cxb_48 fifo_cxb_48_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_15_rst),
    .clk(fifo_cxb_48_15_clk),
    .din(fifo_cxb_48_15_din),
    .wr_en(fifo_cxb_48_15_wr_en),
    .rd_en(fifo_cxb_48_15_rd_en),
    .dout(fifo_cxb_48_15_dout),
    .full(fifo_cxb_48_15_full),
    .empty(fifo_cxb_48_15_empty)
  );
  RRArbiter_160 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_16_rst),
    .clk(fifo_cxb_48_16_clk),
    .din(fifo_cxb_48_16_din),
    .wr_en(fifo_cxb_48_16_wr_en),
    .rd_en(fifo_cxb_48_16_rd_en),
    .dout(fifo_cxb_48_16_dout),
    .full(fifo_cxb_48_16_full),
    .empty(fifo_cxb_48_16_empty)
  );
  fifo_cxb_48 fifo_cxb_48_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_17_rst),
    .clk(fifo_cxb_48_17_clk),
    .din(fifo_cxb_48_17_din),
    .wr_en(fifo_cxb_48_17_wr_en),
    .rd_en(fifo_cxb_48_17_rd_en),
    .dout(fifo_cxb_48_17_dout),
    .full(fifo_cxb_48_17_full),
    .empty(fifo_cxb_48_17_empty)
  );
  fifo_cxb_48 fifo_cxb_48_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_18_rst),
    .clk(fifo_cxb_48_18_clk),
    .din(fifo_cxb_48_18_din),
    .wr_en(fifo_cxb_48_18_wr_en),
    .rd_en(fifo_cxb_48_18_rd_en),
    .dout(fifo_cxb_48_18_dout),
    .full(fifo_cxb_48_18_full),
    .empty(fifo_cxb_48_18_empty)
  );
  fifo_cxb_48 fifo_cxb_48_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_19_rst),
    .clk(fifo_cxb_48_19_clk),
    .din(fifo_cxb_48_19_din),
    .wr_en(fifo_cxb_48_19_wr_en),
    .rd_en(fifo_cxb_48_19_rd_en),
    .dout(fifo_cxb_48_19_dout),
    .full(fifo_cxb_48_19_full),
    .empty(fifo_cxb_48_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_48_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_48_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_48_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_48_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_48_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_48_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_3_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_5_rd_en = _T_37 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_48_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_48_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_48_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_48_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_6_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_6_wr_en = _T_37 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_7_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_7_wr_en = _T_37 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_8_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_8_wr_en = _T_37 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_9_din = fifo_cxb_48_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_9_wr_en = _T_37 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_10_rd_en = _T_70 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_48_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_48_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_48_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_48_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_48_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_48_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_48_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_48_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_11_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_11_wr_en = _T_70 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_12_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_12_wr_en = _T_70 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_13_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_13_wr_en = _T_70 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_14_din = fifo_cxb_48_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_14_wr_en = _T_70 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_15_rd_en = _T_103 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_48_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_48_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_48_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_48_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_48_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_48_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_16_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_16_wr_en = _T_103 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_17_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_17_wr_en = _T_103 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_18_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_18_wr_en = _T_103 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_19_din = fifo_cxb_48_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_19_wr_en = _T_103 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module RRArbiter_544(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [47:0] io_out_bits,
  output        io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [47:0] _GEN_5 = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg  lastGrant; // @[Reg.scala 15:16]
  wire  _GEN_6 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 1'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_3 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_4 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_5 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_6 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_7 = _T_4; // @[Arbiter.scala 72:50]
  wire  _T_8 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_9 = grantMask_1 | _T_5; // @[Arbiter.scala 72:50]
  wire  _T_10 = _T_4 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_11 = _T_9 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _GEN_7 = io_in_0_valid ? 1'h0 : 1'h1; // @[Arbiter.scala 77:27]
  wire  choice = validMask_1 | _GEN_7; // @[Arbiter.scala 79:25]
  wire  _GEN_8 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_3; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_4; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [47:0] _io_in_io_chosen_bits = _GEN_5; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_3; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_4; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [47:0] _io_in_io_chosen_0_bits = _GEN_5; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_4 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_9 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  assign io_out_bits = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 | _GEN_7; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module sub_crossbar_96(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = {{1'd0}, _T_5}; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_6[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_6[30:0]; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_14[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_14[30:0]; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = {{1'd0}, _T_5}; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_6[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_6[30:0]; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_14[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_14[30:0]; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_97(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_98(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_99(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_100(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_101(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_102(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_103(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_104(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_105(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_106(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_107(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_108(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_109(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_110(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_111(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_112(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_113(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_114(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_115(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_116(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_117(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_118(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_119(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_120(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_121(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_122(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_123(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_124(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_125(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_126(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_127(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_128(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_129(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_130(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_131(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_132(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_133(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_134(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_135(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_136(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_137(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_138(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_139(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_140(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_141(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_142(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_143(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_144(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_145(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_146(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_147(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_148(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_149(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_150(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_151(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_152(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_153(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_154(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_155(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_156(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_157(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_158(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_159(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits
);
  wire  fifo_cxb_48_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_clk; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_rd_en; // @[crossbar.scala 230:38]
  wire [47:0] fifo_cxb_48_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_48_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [47:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_48_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_clk; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_rd_en; // @[crossbar.scala 233:47]
  wire [47:0] fifo_cxb_48_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_48_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_48_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_48_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_3 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_26 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_4 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_5 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_6 = _T_5 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_7 = _T_5 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_8 = _GEN_22 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_9 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_10 = ~fifo_cxb_48_1_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_0 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_8 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_8 & _T_10; // @[crossbar.scala 262:136]
  wire [23:0] _T_11 = fifo_cxb_48_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_27 = fifo_cxb_48_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_12 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_13 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_14 = _T_13 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_15 = _T_13 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_4}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_22 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_48_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_48_2_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_3 = fifo_cxb_48_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_19 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _T_20 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_28 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_21 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_22 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_23 = _T_5 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_24 = _T_5 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_25 = _GEN_24 == _T_7; // @[crossbar.scala 262:68]
  wire  _T_26 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_27 = ~fifo_cxb_48_4_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_11 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_25 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_25 & _T_27; // @[crossbar.scala 262:136]
  wire [23:0] _T_28 = fifo_cxb_48_3_dout[47:24]; // @[crossbar.scala 190:14]
  wire [23:0] _GEN_29 = fifo_cxb_48_3_dout[47:24] % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_29 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_30 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_31 = _T_13 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_32 = _T_13 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_21}; // @[crossbar.scala 262:68]
  wire  _T_33 = _GEN_24 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_34 = ~fifo_cxb_48_3_empty; // @[crossbar.scala 264:21]
  wire  _T_35 = ~fifo_cxb_48_5_full; // @[crossbar.scala 265:54]
  wire [47:0] _GEN_14 = fifo_cxb_48_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_33 & _T_19; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_33 ? _T_35 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_19 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_19 & _GEN_12; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_19 & _GEN_15; // @[crossbar.scala 258:45]
  wire [47:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_36 = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:13]
  wire  _T_37 = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:13]
  wire  _T_38 = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:13]
  wire  _T_39 = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_48 fifo_cxb_48 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_rst),
    .clk(fifo_cxb_48_clk),
    .din(fifo_cxb_48_din),
    .wr_en(fifo_cxb_48_wr_en),
    .rd_en(fifo_cxb_48_rd_en),
    .dout(fifo_cxb_48_dout),
    .full(fifo_cxb_48_full),
    .empty(fifo_cxb_48_empty)
  );
  RRArbiter_544 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_1_rst),
    .clk(fifo_cxb_48_1_clk),
    .din(fifo_cxb_48_1_din),
    .wr_en(fifo_cxb_48_1_wr_en),
    .rd_en(fifo_cxb_48_1_rd_en),
    .dout(fifo_cxb_48_1_dout),
    .full(fifo_cxb_48_1_full),
    .empty(fifo_cxb_48_1_empty)
  );
  fifo_cxb_48 fifo_cxb_48_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_2_rst),
    .clk(fifo_cxb_48_2_clk),
    .din(fifo_cxb_48_2_din),
    .wr_en(fifo_cxb_48_2_wr_en),
    .rd_en(fifo_cxb_48_2_rd_en),
    .dout(fifo_cxb_48_2_dout),
    .full(fifo_cxb_48_2_full),
    .empty(fifo_cxb_48_2_empty)
  );
  fifo_cxb_48 fifo_cxb_48_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_48_3_rst),
    .clk(fifo_cxb_48_3_clk),
    .din(fifo_cxb_48_3_din),
    .wr_en(fifo_cxb_48_3_wr_en),
    .rd_en(fifo_cxb_48_3_rd_en),
    .dout(fifo_cxb_48_3_dout),
    .full(fifo_cxb_48_3_full),
    .empty(fifo_cxb_48_3_empty)
  );
  RRArbiter_544 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_48 fifo_cxb_48_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_4_rst),
    .clk(fifo_cxb_48_4_clk),
    .din(fifo_cxb_48_4_din),
    .wr_en(fifo_cxb_48_4_wr_en),
    .rd_en(fifo_cxb_48_4_rd_en),
    .dout(fifo_cxb_48_4_dout),
    .full(fifo_cxb_48_4_full),
    .empty(fifo_cxb_48_4_empty)
  );
  fifo_cxb_48 fifo_cxb_48_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_48_5_rst),
    .clk(fifo_cxb_48_5_clk),
    .din(fifo_cxb_48_5_din),
    .wr_en(fifo_cxb_48_5_wr_en),
    .rd_en(fifo_cxb_48_5_rd_en),
    .dout(fifo_cxb_48_5_dout),
    .full(fifo_cxb_48_5_full),
    .empty(fifo_cxb_48_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_48_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_48_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_48_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_48_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_48_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_48_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_1_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_2_din = fifo_cxb_48_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_48_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_48_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_48_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_48_3_rd_en = _T_19 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_48_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_48_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_48_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_48_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_48_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_4_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_4_wr_en = _T_19 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_48_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_48_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_48_5_din = fifo_cxb_48_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_48_5_wr_en = _T_19 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_48_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module crossbar(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [47:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [47:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [47:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [47:0] io_in_3_bits,
  output        io_in_4_ready,
  input         io_in_4_valid,
  input  [47:0] io_in_4_bits,
  output        io_in_5_ready,
  input         io_in_5_valid,
  input  [47:0] io_in_5_bits,
  output        io_in_6_ready,
  input         io_in_6_valid,
  input  [47:0] io_in_6_bits,
  output        io_in_7_ready,
  input         io_in_7_valid,
  input  [47:0] io_in_7_bits,
  output        io_in_8_ready,
  input         io_in_8_valid,
  input  [47:0] io_in_8_bits,
  output        io_in_9_ready,
  input         io_in_9_valid,
  input  [47:0] io_in_9_bits,
  output        io_in_10_ready,
  input         io_in_10_valid,
  input  [47:0] io_in_10_bits,
  output        io_in_11_ready,
  input         io_in_11_valid,
  input  [47:0] io_in_11_bits,
  output        io_in_12_ready,
  input         io_in_12_valid,
  input  [47:0] io_in_12_bits,
  output        io_in_13_ready,
  input         io_in_13_valid,
  input  [47:0] io_in_13_bits,
  output        io_in_14_ready,
  input         io_in_14_valid,
  input  [47:0] io_in_14_bits,
  output        io_in_15_ready,
  input         io_in_15_valid,
  input  [47:0] io_in_15_bits,
  output        io_in_16_ready,
  input         io_in_16_valid,
  input  [47:0] io_in_16_bits,
  output        io_in_17_ready,
  input         io_in_17_valid,
  input  [47:0] io_in_17_bits,
  output        io_in_18_ready,
  input         io_in_18_valid,
  input  [47:0] io_in_18_bits,
  output        io_in_19_ready,
  input         io_in_19_valid,
  input  [47:0] io_in_19_bits,
  output        io_in_20_ready,
  input         io_in_20_valid,
  input  [47:0] io_in_20_bits,
  output        io_in_21_ready,
  input         io_in_21_valid,
  input  [47:0] io_in_21_bits,
  output        io_in_22_ready,
  input         io_in_22_valid,
  input  [47:0] io_in_22_bits,
  output        io_in_23_ready,
  input         io_in_23_valid,
  input  [47:0] io_in_23_bits,
  output        io_in_24_ready,
  input         io_in_24_valid,
  input  [47:0] io_in_24_bits,
  output        io_in_25_ready,
  input         io_in_25_valid,
  input  [47:0] io_in_25_bits,
  output        io_in_26_ready,
  input         io_in_26_valid,
  input  [47:0] io_in_26_bits,
  output        io_in_27_ready,
  input         io_in_27_valid,
  input  [47:0] io_in_27_bits,
  output        io_in_28_ready,
  input         io_in_28_valid,
  input  [47:0] io_in_28_bits,
  output        io_in_29_ready,
  input         io_in_29_valid,
  input  [47:0] io_in_29_bits,
  output        io_in_30_ready,
  input         io_in_30_valid,
  input  [47:0] io_in_30_bits,
  output        io_in_31_ready,
  input         io_in_31_valid,
  input  [47:0] io_in_31_bits,
  output        io_in_32_ready,
  input         io_in_32_valid,
  input  [47:0] io_in_32_bits,
  output        io_in_33_ready,
  input         io_in_33_valid,
  input  [47:0] io_in_33_bits,
  output        io_in_34_ready,
  input         io_in_34_valid,
  input  [47:0] io_in_34_bits,
  output        io_in_35_ready,
  input         io_in_35_valid,
  input  [47:0] io_in_35_bits,
  output        io_in_36_ready,
  input         io_in_36_valid,
  input  [47:0] io_in_36_bits,
  output        io_in_37_ready,
  input         io_in_37_valid,
  input  [47:0] io_in_37_bits,
  output        io_in_38_ready,
  input         io_in_38_valid,
  input  [47:0] io_in_38_bits,
  output        io_in_39_ready,
  input         io_in_39_valid,
  input  [47:0] io_in_39_bits,
  output        io_in_40_ready,
  input         io_in_40_valid,
  input  [47:0] io_in_40_bits,
  output        io_in_41_ready,
  input         io_in_41_valid,
  input  [47:0] io_in_41_bits,
  output        io_in_42_ready,
  input         io_in_42_valid,
  input  [47:0] io_in_42_bits,
  output        io_in_43_ready,
  input         io_in_43_valid,
  input  [47:0] io_in_43_bits,
  output        io_in_44_ready,
  input         io_in_44_valid,
  input  [47:0] io_in_44_bits,
  output        io_in_45_ready,
  input         io_in_45_valid,
  input  [47:0] io_in_45_bits,
  output        io_in_46_ready,
  input         io_in_46_valid,
  input  [47:0] io_in_46_bits,
  output        io_in_47_ready,
  input         io_in_47_valid,
  input  [47:0] io_in_47_bits,
  output        io_in_48_ready,
  input         io_in_48_valid,
  input  [47:0] io_in_48_bits,
  output        io_in_49_ready,
  input         io_in_49_valid,
  input  [47:0] io_in_49_bits,
  output        io_in_50_ready,
  input         io_in_50_valid,
  input  [47:0] io_in_50_bits,
  output        io_in_51_ready,
  input         io_in_51_valid,
  input  [47:0] io_in_51_bits,
  output        io_in_52_ready,
  input         io_in_52_valid,
  input  [47:0] io_in_52_bits,
  output        io_in_53_ready,
  input         io_in_53_valid,
  input  [47:0] io_in_53_bits,
  output        io_in_54_ready,
  input         io_in_54_valid,
  input  [47:0] io_in_54_bits,
  output        io_in_55_ready,
  input         io_in_55_valid,
  input  [47:0] io_in_55_bits,
  output        io_in_56_ready,
  input         io_in_56_valid,
  input  [47:0] io_in_56_bits,
  output        io_in_57_ready,
  input         io_in_57_valid,
  input  [47:0] io_in_57_bits,
  output        io_in_58_ready,
  input         io_in_58_valid,
  input  [47:0] io_in_58_bits,
  output        io_in_59_ready,
  input         io_in_59_valid,
  input  [47:0] io_in_59_bits,
  output        io_in_60_ready,
  input         io_in_60_valid,
  input  [47:0] io_in_60_bits,
  output        io_in_61_ready,
  input         io_in_61_valid,
  input  [47:0] io_in_61_bits,
  output        io_in_62_ready,
  input         io_in_62_valid,
  input  [47:0] io_in_62_bits,
  output        io_in_63_ready,
  input         io_in_63_valid,
  input  [47:0] io_in_63_bits,
  output        io_in_64_ready,
  input         io_in_64_valid,
  input  [47:0] io_in_64_bits,
  output        io_in_65_ready,
  input         io_in_65_valid,
  input  [47:0] io_in_65_bits,
  output        io_in_66_ready,
  input         io_in_66_valid,
  input  [47:0] io_in_66_bits,
  output        io_in_67_ready,
  input         io_in_67_valid,
  input  [47:0] io_in_67_bits,
  output        io_in_68_ready,
  input         io_in_68_valid,
  input  [47:0] io_in_68_bits,
  output        io_in_69_ready,
  input         io_in_69_valid,
  input  [47:0] io_in_69_bits,
  output        io_in_70_ready,
  input         io_in_70_valid,
  input  [47:0] io_in_70_bits,
  output        io_in_71_ready,
  input         io_in_71_valid,
  input  [47:0] io_in_71_bits,
  output        io_in_72_ready,
  input         io_in_72_valid,
  input  [47:0] io_in_72_bits,
  output        io_in_73_ready,
  input         io_in_73_valid,
  input  [47:0] io_in_73_bits,
  output        io_in_74_ready,
  input         io_in_74_valid,
  input  [47:0] io_in_74_bits,
  output        io_in_75_ready,
  input         io_in_75_valid,
  input  [47:0] io_in_75_bits,
  output        io_in_76_ready,
  input         io_in_76_valid,
  input  [47:0] io_in_76_bits,
  output        io_in_77_ready,
  input         io_in_77_valid,
  input  [47:0] io_in_77_bits,
  output        io_in_78_ready,
  input         io_in_78_valid,
  input  [47:0] io_in_78_bits,
  output        io_in_79_ready,
  input         io_in_79_valid,
  input  [47:0] io_in_79_bits,
  output        io_in_80_ready,
  input         io_in_80_valid,
  input  [47:0] io_in_80_bits,
  output        io_in_81_ready,
  input         io_in_81_valid,
  input  [47:0] io_in_81_bits,
  output        io_in_82_ready,
  input         io_in_82_valid,
  input  [47:0] io_in_82_bits,
  output        io_in_83_ready,
  input         io_in_83_valid,
  input  [47:0] io_in_83_bits,
  output        io_in_84_ready,
  input         io_in_84_valid,
  input  [47:0] io_in_84_bits,
  output        io_in_85_ready,
  input         io_in_85_valid,
  input  [47:0] io_in_85_bits,
  output        io_in_86_ready,
  input         io_in_86_valid,
  input  [47:0] io_in_86_bits,
  output        io_in_87_ready,
  input         io_in_87_valid,
  input  [47:0] io_in_87_bits,
  output        io_in_88_ready,
  input         io_in_88_valid,
  input  [47:0] io_in_88_bits,
  output        io_in_89_ready,
  input         io_in_89_valid,
  input  [47:0] io_in_89_bits,
  output        io_in_90_ready,
  input         io_in_90_valid,
  input  [47:0] io_in_90_bits,
  output        io_in_91_ready,
  input         io_in_91_valid,
  input  [47:0] io_in_91_bits,
  output        io_in_92_ready,
  input         io_in_92_valid,
  input  [47:0] io_in_92_bits,
  output        io_in_93_ready,
  input         io_in_93_valid,
  input  [47:0] io_in_93_bits,
  output        io_in_94_ready,
  input         io_in_94_valid,
  input  [47:0] io_in_94_bits,
  output        io_in_95_ready,
  input         io_in_95_valid,
  input  [47:0] io_in_95_bits,
  output        io_in_96_ready,
  input         io_in_96_valid,
  input  [47:0] io_in_96_bits,
  output        io_in_97_ready,
  input         io_in_97_valid,
  input  [47:0] io_in_97_bits,
  output        io_in_98_ready,
  input         io_in_98_valid,
  input  [47:0] io_in_98_bits,
  output        io_in_99_ready,
  input         io_in_99_valid,
  input  [47:0] io_in_99_bits,
  output        io_in_100_ready,
  input         io_in_100_valid,
  input  [47:0] io_in_100_bits,
  output        io_in_101_ready,
  input         io_in_101_valid,
  input  [47:0] io_in_101_bits,
  output        io_in_102_ready,
  input         io_in_102_valid,
  input  [47:0] io_in_102_bits,
  output        io_in_103_ready,
  input         io_in_103_valid,
  input  [47:0] io_in_103_bits,
  output        io_in_104_ready,
  input         io_in_104_valid,
  input  [47:0] io_in_104_bits,
  output        io_in_105_ready,
  input         io_in_105_valid,
  input  [47:0] io_in_105_bits,
  output        io_in_106_ready,
  input         io_in_106_valid,
  input  [47:0] io_in_106_bits,
  output        io_in_107_ready,
  input         io_in_107_valid,
  input  [47:0] io_in_107_bits,
  output        io_in_108_ready,
  input         io_in_108_valid,
  input  [47:0] io_in_108_bits,
  output        io_in_109_ready,
  input         io_in_109_valid,
  input  [47:0] io_in_109_bits,
  output        io_in_110_ready,
  input         io_in_110_valid,
  input  [47:0] io_in_110_bits,
  output        io_in_111_ready,
  input         io_in_111_valid,
  input  [47:0] io_in_111_bits,
  output        io_in_112_ready,
  input         io_in_112_valid,
  input  [47:0] io_in_112_bits,
  output        io_in_113_ready,
  input         io_in_113_valid,
  input  [47:0] io_in_113_bits,
  output        io_in_114_ready,
  input         io_in_114_valid,
  input  [47:0] io_in_114_bits,
  output        io_in_115_ready,
  input         io_in_115_valid,
  input  [47:0] io_in_115_bits,
  output        io_in_116_ready,
  input         io_in_116_valid,
  input  [47:0] io_in_116_bits,
  output        io_in_117_ready,
  input         io_in_117_valid,
  input  [47:0] io_in_117_bits,
  output        io_in_118_ready,
  input         io_in_118_valid,
  input  [47:0] io_in_118_bits,
  output        io_in_119_ready,
  input         io_in_119_valid,
  input  [47:0] io_in_119_bits,
  output        io_in_120_ready,
  input         io_in_120_valid,
  input  [47:0] io_in_120_bits,
  output        io_in_121_ready,
  input         io_in_121_valid,
  input  [47:0] io_in_121_bits,
  output        io_in_122_ready,
  input         io_in_122_valid,
  input  [47:0] io_in_122_bits,
  output        io_in_123_ready,
  input         io_in_123_valid,
  input  [47:0] io_in_123_bits,
  output        io_in_124_ready,
  input         io_in_124_valid,
  input  [47:0] io_in_124_bits,
  output        io_in_125_ready,
  input         io_in_125_valid,
  input  [47:0] io_in_125_bits,
  output        io_in_126_ready,
  input         io_in_126_valid,
  input  [47:0] io_in_126_bits,
  output        io_in_127_ready,
  input         io_in_127_valid,
  input  [47:0] io_in_127_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [47:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [47:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [47:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [47:0] io_out_3_bits,
  input         io_out_4_ready,
  output        io_out_4_valid,
  output [47:0] io_out_4_bits,
  input         io_out_5_ready,
  output        io_out_5_valid,
  output [47:0] io_out_5_bits,
  input         io_out_6_ready,
  output        io_out_6_valid,
  output [47:0] io_out_6_bits,
  input         io_out_7_ready,
  output        io_out_7_valid,
  output [47:0] io_out_7_bits,
  input         io_out_8_ready,
  output        io_out_8_valid,
  output [47:0] io_out_8_bits,
  input         io_out_9_ready,
  output        io_out_9_valid,
  output [47:0] io_out_9_bits,
  input         io_out_10_ready,
  output        io_out_10_valid,
  output [47:0] io_out_10_bits,
  input         io_out_11_ready,
  output        io_out_11_valid,
  output [47:0] io_out_11_bits,
  input         io_out_12_ready,
  output        io_out_12_valid,
  output [47:0] io_out_12_bits,
  input         io_out_13_ready,
  output        io_out_13_valid,
  output [47:0] io_out_13_bits,
  input         io_out_14_ready,
  output        io_out_14_valid,
  output [47:0] io_out_14_bits,
  input         io_out_15_ready,
  output        io_out_15_valid,
  output [47:0] io_out_15_bits,
  input         io_out_16_ready,
  output        io_out_16_valid,
  output [47:0] io_out_16_bits,
  input         io_out_17_ready,
  output        io_out_17_valid,
  output [47:0] io_out_17_bits,
  input         io_out_18_ready,
  output        io_out_18_valid,
  output [47:0] io_out_18_bits,
  input         io_out_19_ready,
  output        io_out_19_valid,
  output [47:0] io_out_19_bits,
  input         io_out_20_ready,
  output        io_out_20_valid,
  output [47:0] io_out_20_bits,
  input         io_out_21_ready,
  output        io_out_21_valid,
  output [47:0] io_out_21_bits,
  input         io_out_22_ready,
  output        io_out_22_valid,
  output [47:0] io_out_22_bits,
  input         io_out_23_ready,
  output        io_out_23_valid,
  output [47:0] io_out_23_bits,
  input         io_out_24_ready,
  output        io_out_24_valid,
  output [47:0] io_out_24_bits,
  input         io_out_25_ready,
  output        io_out_25_valid,
  output [47:0] io_out_25_bits,
  input         io_out_26_ready,
  output        io_out_26_valid,
  output [47:0] io_out_26_bits,
  input         io_out_27_ready,
  output        io_out_27_valid,
  output [47:0] io_out_27_bits,
  input         io_out_28_ready,
  output        io_out_28_valid,
  output [47:0] io_out_28_bits,
  input         io_out_29_ready,
  output        io_out_29_valid,
  output [47:0] io_out_29_bits,
  input         io_out_30_ready,
  output        io_out_30_valid,
  output [47:0] io_out_30_bits,
  input         io_out_31_ready,
  output        io_out_31_valid,
  output [47:0] io_out_31_bits,
  input         io_out_32_ready,
  output        io_out_32_valid,
  output [47:0] io_out_32_bits,
  input         io_out_33_ready,
  output        io_out_33_valid,
  output [47:0] io_out_33_bits,
  input         io_out_34_ready,
  output        io_out_34_valid,
  output [47:0] io_out_34_bits,
  input         io_out_35_ready,
  output        io_out_35_valid,
  output [47:0] io_out_35_bits,
  input         io_out_36_ready,
  output        io_out_36_valid,
  output [47:0] io_out_36_bits,
  input         io_out_37_ready,
  output        io_out_37_valid,
  output [47:0] io_out_37_bits,
  input         io_out_38_ready,
  output        io_out_38_valid,
  output [47:0] io_out_38_bits,
  input         io_out_39_ready,
  output        io_out_39_valid,
  output [47:0] io_out_39_bits,
  input         io_out_40_ready,
  output        io_out_40_valid,
  output [47:0] io_out_40_bits,
  input         io_out_41_ready,
  output        io_out_41_valid,
  output [47:0] io_out_41_bits,
  input         io_out_42_ready,
  output        io_out_42_valid,
  output [47:0] io_out_42_bits,
  input         io_out_43_ready,
  output        io_out_43_valid,
  output [47:0] io_out_43_bits,
  input         io_out_44_ready,
  output        io_out_44_valid,
  output [47:0] io_out_44_bits,
  input         io_out_45_ready,
  output        io_out_45_valid,
  output [47:0] io_out_45_bits,
  input         io_out_46_ready,
  output        io_out_46_valid,
  output [47:0] io_out_46_bits,
  input         io_out_47_ready,
  output        io_out_47_valid,
  output [47:0] io_out_47_bits,
  input         io_out_48_ready,
  output        io_out_48_valid,
  output [47:0] io_out_48_bits,
  input         io_out_49_ready,
  output        io_out_49_valid,
  output [47:0] io_out_49_bits,
  input         io_out_50_ready,
  output        io_out_50_valid,
  output [47:0] io_out_50_bits,
  input         io_out_51_ready,
  output        io_out_51_valid,
  output [47:0] io_out_51_bits,
  input         io_out_52_ready,
  output        io_out_52_valid,
  output [47:0] io_out_52_bits,
  input         io_out_53_ready,
  output        io_out_53_valid,
  output [47:0] io_out_53_bits,
  input         io_out_54_ready,
  output        io_out_54_valid,
  output [47:0] io_out_54_bits,
  input         io_out_55_ready,
  output        io_out_55_valid,
  output [47:0] io_out_55_bits,
  input         io_out_56_ready,
  output        io_out_56_valid,
  output [47:0] io_out_56_bits,
  input         io_out_57_ready,
  output        io_out_57_valid,
  output [47:0] io_out_57_bits,
  input         io_out_58_ready,
  output        io_out_58_valid,
  output [47:0] io_out_58_bits,
  input         io_out_59_ready,
  output        io_out_59_valid,
  output [47:0] io_out_59_bits,
  input         io_out_60_ready,
  output        io_out_60_valid,
  output [47:0] io_out_60_bits,
  input         io_out_61_ready,
  output        io_out_61_valid,
  output [47:0] io_out_61_bits,
  input         io_out_62_ready,
  output        io_out_62_valid,
  output [47:0] io_out_62_bits,
  input         io_out_63_ready,
  output        io_out_63_valid,
  output [47:0] io_out_63_bits,
  input         io_out_64_ready,
  output        io_out_64_valid,
  output [47:0] io_out_64_bits,
  input         io_out_65_ready,
  output        io_out_65_valid,
  output [47:0] io_out_65_bits,
  input         io_out_66_ready,
  output        io_out_66_valid,
  output [47:0] io_out_66_bits,
  input         io_out_67_ready,
  output        io_out_67_valid,
  output [47:0] io_out_67_bits,
  input         io_out_68_ready,
  output        io_out_68_valid,
  output [47:0] io_out_68_bits,
  input         io_out_69_ready,
  output        io_out_69_valid,
  output [47:0] io_out_69_bits,
  input         io_out_70_ready,
  output        io_out_70_valid,
  output [47:0] io_out_70_bits,
  input         io_out_71_ready,
  output        io_out_71_valid,
  output [47:0] io_out_71_bits,
  input         io_out_72_ready,
  output        io_out_72_valid,
  output [47:0] io_out_72_bits,
  input         io_out_73_ready,
  output        io_out_73_valid,
  output [47:0] io_out_73_bits,
  input         io_out_74_ready,
  output        io_out_74_valid,
  output [47:0] io_out_74_bits,
  input         io_out_75_ready,
  output        io_out_75_valid,
  output [47:0] io_out_75_bits,
  input         io_out_76_ready,
  output        io_out_76_valid,
  output [47:0] io_out_76_bits,
  input         io_out_77_ready,
  output        io_out_77_valid,
  output [47:0] io_out_77_bits,
  input         io_out_78_ready,
  output        io_out_78_valid,
  output [47:0] io_out_78_bits,
  input         io_out_79_ready,
  output        io_out_79_valid,
  output [47:0] io_out_79_bits,
  input         io_out_80_ready,
  output        io_out_80_valid,
  output [47:0] io_out_80_bits,
  input         io_out_81_ready,
  output        io_out_81_valid,
  output [47:0] io_out_81_bits,
  input         io_out_82_ready,
  output        io_out_82_valid,
  output [47:0] io_out_82_bits,
  input         io_out_83_ready,
  output        io_out_83_valid,
  output [47:0] io_out_83_bits,
  input         io_out_84_ready,
  output        io_out_84_valid,
  output [47:0] io_out_84_bits,
  input         io_out_85_ready,
  output        io_out_85_valid,
  output [47:0] io_out_85_bits,
  input         io_out_86_ready,
  output        io_out_86_valid,
  output [47:0] io_out_86_bits,
  input         io_out_87_ready,
  output        io_out_87_valid,
  output [47:0] io_out_87_bits,
  input         io_out_88_ready,
  output        io_out_88_valid,
  output [47:0] io_out_88_bits,
  input         io_out_89_ready,
  output        io_out_89_valid,
  output [47:0] io_out_89_bits,
  input         io_out_90_ready,
  output        io_out_90_valid,
  output [47:0] io_out_90_bits,
  input         io_out_91_ready,
  output        io_out_91_valid,
  output [47:0] io_out_91_bits,
  input         io_out_92_ready,
  output        io_out_92_valid,
  output [47:0] io_out_92_bits,
  input         io_out_93_ready,
  output        io_out_93_valid,
  output [47:0] io_out_93_bits,
  input         io_out_94_ready,
  output        io_out_94_valid,
  output [47:0] io_out_94_bits,
  input         io_out_95_ready,
  output        io_out_95_valid,
  output [47:0] io_out_95_bits,
  input         io_out_96_ready,
  output        io_out_96_valid,
  output [47:0] io_out_96_bits,
  input         io_out_97_ready,
  output        io_out_97_valid,
  output [47:0] io_out_97_bits,
  input         io_out_98_ready,
  output        io_out_98_valid,
  output [47:0] io_out_98_bits,
  input         io_out_99_ready,
  output        io_out_99_valid,
  output [47:0] io_out_99_bits,
  input         io_out_100_ready,
  output        io_out_100_valid,
  output [47:0] io_out_100_bits,
  input         io_out_101_ready,
  output        io_out_101_valid,
  output [47:0] io_out_101_bits,
  input         io_out_102_ready,
  output        io_out_102_valid,
  output [47:0] io_out_102_bits,
  input         io_out_103_ready,
  output        io_out_103_valid,
  output [47:0] io_out_103_bits,
  input         io_out_104_ready,
  output        io_out_104_valid,
  output [47:0] io_out_104_bits,
  input         io_out_105_ready,
  output        io_out_105_valid,
  output [47:0] io_out_105_bits,
  input         io_out_106_ready,
  output        io_out_106_valid,
  output [47:0] io_out_106_bits,
  input         io_out_107_ready,
  output        io_out_107_valid,
  output [47:0] io_out_107_bits,
  input         io_out_108_ready,
  output        io_out_108_valid,
  output [47:0] io_out_108_bits,
  input         io_out_109_ready,
  output        io_out_109_valid,
  output [47:0] io_out_109_bits,
  input         io_out_110_ready,
  output        io_out_110_valid,
  output [47:0] io_out_110_bits,
  input         io_out_111_ready,
  output        io_out_111_valid,
  output [47:0] io_out_111_bits,
  input         io_out_112_ready,
  output        io_out_112_valid,
  output [47:0] io_out_112_bits,
  input         io_out_113_ready,
  output        io_out_113_valid,
  output [47:0] io_out_113_bits,
  input         io_out_114_ready,
  output        io_out_114_valid,
  output [47:0] io_out_114_bits,
  input         io_out_115_ready,
  output        io_out_115_valid,
  output [47:0] io_out_115_bits,
  input         io_out_116_ready,
  output        io_out_116_valid,
  output [47:0] io_out_116_bits,
  input         io_out_117_ready,
  output        io_out_117_valid,
  output [47:0] io_out_117_bits,
  input         io_out_118_ready,
  output        io_out_118_valid,
  output [47:0] io_out_118_bits,
  input         io_out_119_ready,
  output        io_out_119_valid,
  output [47:0] io_out_119_bits,
  input         io_out_120_ready,
  output        io_out_120_valid,
  output [47:0] io_out_120_bits,
  input         io_out_121_ready,
  output        io_out_121_valid,
  output [47:0] io_out_121_bits,
  input         io_out_122_ready,
  output        io_out_122_valid,
  output [47:0] io_out_122_bits,
  input         io_out_123_ready,
  output        io_out_123_valid,
  output [47:0] io_out_123_bits,
  input         io_out_124_ready,
  output        io_out_124_valid,
  output [47:0] io_out_124_bits,
  input         io_out_125_ready,
  output        io_out_125_valid,
  output [47:0] io_out_125_bits,
  input         io_out_126_ready,
  output        io_out_126_valid,
  output [47:0] io_out_126_bits,
  input         io_out_127_ready,
  output        io_out_127_valid,
  output [47:0] io_out_127_bits
);
  wire  sub_crossbar_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_1_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_1_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_2_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_2_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_3_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_3_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_4_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_4_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_5_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_5_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_6_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_6_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_7_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_7_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_8_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_8_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_9_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_9_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_10_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_10_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_11_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_11_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_12_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_12_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_13_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_13_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_14_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_14_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_15_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_15_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_16_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_16_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_17_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_17_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_18_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_18_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_19_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_19_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_20_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_20_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_21_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_21_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_22_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_22_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_23_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_23_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_24_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_24_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_25_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_25_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_26_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_26_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_27_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_27_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_28_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_28_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_29_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_29_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_30_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_30_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_31_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_31_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_32_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_32_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_33_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_33_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_34_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_34_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_35_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_35_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_36_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_36_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_37_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_37_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_38_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_38_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_39_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_39_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_40_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_40_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_41_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_41_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_42_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_42_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_43_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_43_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_44_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_44_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_45_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_45_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_46_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_46_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_47_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_47_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_48_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_48_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_49_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_49_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_50_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_50_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_51_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_51_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_52_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_52_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_53_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_53_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_54_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_54_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_55_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_55_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_56_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_56_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_57_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_57_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_58_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_58_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_59_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_59_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_60_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_60_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_61_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_61_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_62_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_62_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_63_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_63_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_64_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_64_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_65_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_65_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_66_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_66_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_67_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_67_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_68_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_68_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_69_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_69_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_70_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_70_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_71_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_71_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_72_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_72_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_73_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_73_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_74_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_74_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_75_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_75_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_76_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_76_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_77_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_77_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_78_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_78_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_79_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_79_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_80_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_80_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_81_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_81_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_82_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_82_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_83_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_83_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_84_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_84_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_85_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_85_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_86_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_86_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_87_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_87_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_88_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_88_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_89_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_89_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_90_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_90_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_91_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_91_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_92_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_92_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_93_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [47:0] sub_crossbar_93_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_94_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [47:0] sub_crossbar_94_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_95_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [47:0] sub_crossbar_95_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_96_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_96_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_96_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_96_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_96_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_97_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_97_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_97_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_97_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_98_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_98_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_98_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_98_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_99_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_99_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_99_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_99_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_100_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_100_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_100_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_100_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_101_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_101_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_101_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_101_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_102_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_102_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_102_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_102_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_103_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_103_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_103_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_103_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_104_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_104_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_104_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_104_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_105_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_105_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_105_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_105_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_106_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_106_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_106_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_106_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_107_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_107_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_107_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_107_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_108_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_108_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_108_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_108_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_109_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_109_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_109_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_109_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_110_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_110_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_110_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_110_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_111_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_111_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_111_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_111_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_112_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_112_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_112_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_112_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_113_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_113_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_113_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_113_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_114_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_114_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_114_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_114_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_115_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_115_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_115_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_115_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_116_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_116_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_116_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_116_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_117_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_117_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_117_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_117_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_118_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_118_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_118_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_118_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_119_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_119_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_119_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_119_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_120_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_120_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_120_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_120_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_121_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_121_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_121_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_121_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_122_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_122_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_122_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_122_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_123_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_123_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_123_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_123_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_124_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_124_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_124_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_124_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_125_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_125_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_125_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_125_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_126_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_126_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_126_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_126_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_127_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_127_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_127_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_127_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_128_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_128_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_128_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_128_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_129_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_129_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_129_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_129_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_130_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_130_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_130_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_130_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_131_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_131_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_131_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_131_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_132_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_132_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_132_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_132_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_133_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_133_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_133_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_133_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_134_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_134_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_134_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_134_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_135_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_135_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_135_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_135_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_136_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_136_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_136_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_136_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_137_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_137_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_137_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_137_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_138_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_138_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_138_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_138_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_139_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_139_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_139_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_139_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_140_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_140_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_140_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_140_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_141_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_141_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_141_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_141_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_142_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_142_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_142_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_142_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_143_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_143_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_143_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_143_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_144_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_144_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_144_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_144_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_145_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_145_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_145_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_145_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_146_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_146_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_146_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_146_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_147_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_147_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_147_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_147_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_148_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_148_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_148_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_148_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_149_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_149_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_149_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_149_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_150_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_150_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_150_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_150_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_151_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_151_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_151_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_151_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_152_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_152_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_152_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_152_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_153_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_153_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_153_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_153_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_154_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_154_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_154_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_154_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_155_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_155_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_155_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_155_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_156_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_156_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_156_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_156_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_157_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_157_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_157_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_157_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_158_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_158_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_158_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_158_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_159_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_159_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_159_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [47:0] sub_crossbar_159_io_out_1_bits; // @[crossbar.scala 139:43]
  sub_crossbar sub_crossbar ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_clock),
    .reset(sub_crossbar_reset),
    .io_in_0_ready(sub_crossbar_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_1 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_1_clock),
    .reset(sub_crossbar_1_reset),
    .io_in_0_ready(sub_crossbar_1_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_1_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_1_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_1_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_1_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_1_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_1_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_1_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_1_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_1_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_1_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_1_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_1_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_1_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_1_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_1_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_1_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_1_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_1_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_1_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_1_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_1_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_1_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_1_io_out_3_bits)
  );
  sub_crossbar_2 sub_crossbar_2 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_2_clock),
    .reset(sub_crossbar_2_reset),
    .io_in_0_ready(sub_crossbar_2_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_2_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_2_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_2_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_2_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_2_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_2_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_2_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_2_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_2_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_2_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_2_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_2_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_2_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_2_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_2_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_2_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_2_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_2_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_2_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_2_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_2_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_2_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_2_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_3 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_3_clock),
    .reset(sub_crossbar_3_reset),
    .io_in_0_ready(sub_crossbar_3_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_3_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_3_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_3_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_3_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_3_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_3_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_3_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_3_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_3_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_3_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_3_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_3_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_3_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_3_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_3_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_3_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_3_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_3_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_3_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_3_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_3_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_3_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_3_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_4 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_4_clock),
    .reset(sub_crossbar_4_reset),
    .io_in_0_ready(sub_crossbar_4_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_4_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_4_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_4_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_4_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_4_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_4_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_4_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_4_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_4_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_4_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_4_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_4_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_4_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_4_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_4_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_4_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_4_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_4_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_4_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_4_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_4_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_4_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_4_io_out_3_bits)
  );
  sub_crossbar_5 sub_crossbar_5 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_5_clock),
    .reset(sub_crossbar_5_reset),
    .io_in_0_ready(sub_crossbar_5_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_5_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_5_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_5_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_5_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_5_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_5_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_5_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_5_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_5_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_5_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_5_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_5_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_5_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_5_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_5_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_5_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_5_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_5_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_5_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_5_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_5_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_5_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_5_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_6 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_6_clock),
    .reset(sub_crossbar_6_reset),
    .io_in_0_ready(sub_crossbar_6_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_6_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_6_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_6_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_6_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_6_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_6_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_6_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_6_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_6_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_6_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_6_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_6_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_6_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_6_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_6_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_6_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_6_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_6_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_6_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_6_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_6_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_6_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_6_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_7 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_7_clock),
    .reset(sub_crossbar_7_reset),
    .io_in_0_ready(sub_crossbar_7_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_7_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_7_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_7_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_7_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_7_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_7_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_7_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_7_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_7_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_7_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_7_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_7_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_7_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_7_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_7_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_7_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_7_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_7_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_7_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_7_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_7_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_7_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_7_io_out_3_bits)
  );
  sub_crossbar_8 sub_crossbar_8 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_8_clock),
    .reset(sub_crossbar_8_reset),
    .io_in_0_ready(sub_crossbar_8_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_8_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_8_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_8_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_8_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_8_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_8_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_8_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_8_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_8_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_8_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_8_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_8_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_8_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_8_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_8_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_8_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_8_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_8_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_8_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_8_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_8_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_8_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_8_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_9 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_9_clock),
    .reset(sub_crossbar_9_reset),
    .io_in_0_ready(sub_crossbar_9_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_9_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_9_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_9_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_9_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_9_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_9_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_9_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_9_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_9_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_9_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_9_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_9_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_9_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_9_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_9_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_9_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_9_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_9_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_9_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_9_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_9_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_9_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_9_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_10 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_10_clock),
    .reset(sub_crossbar_10_reset),
    .io_in_0_ready(sub_crossbar_10_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_10_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_10_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_10_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_10_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_10_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_10_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_10_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_10_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_10_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_10_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_10_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_10_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_10_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_10_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_10_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_10_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_10_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_10_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_10_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_10_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_10_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_10_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_10_io_out_3_bits)
  );
  sub_crossbar_11 sub_crossbar_11 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_11_clock),
    .reset(sub_crossbar_11_reset),
    .io_in_0_ready(sub_crossbar_11_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_11_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_11_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_11_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_11_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_11_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_11_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_11_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_11_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_11_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_11_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_11_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_11_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_11_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_11_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_11_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_11_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_11_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_11_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_11_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_11_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_11_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_11_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_11_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_12 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_12_clock),
    .reset(sub_crossbar_12_reset),
    .io_in_0_ready(sub_crossbar_12_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_12_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_12_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_12_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_12_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_12_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_12_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_12_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_12_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_12_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_12_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_12_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_12_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_12_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_12_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_12_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_12_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_12_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_12_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_12_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_12_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_12_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_12_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_12_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_13 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_13_clock),
    .reset(sub_crossbar_13_reset),
    .io_in_0_ready(sub_crossbar_13_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_13_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_13_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_13_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_13_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_13_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_13_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_13_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_13_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_13_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_13_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_13_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_13_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_13_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_13_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_13_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_13_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_13_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_13_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_13_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_13_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_13_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_13_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_13_io_out_3_bits)
  );
  sub_crossbar_14 sub_crossbar_14 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_14_clock),
    .reset(sub_crossbar_14_reset),
    .io_in_0_ready(sub_crossbar_14_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_14_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_14_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_14_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_14_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_14_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_14_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_14_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_14_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_14_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_14_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_14_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_14_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_14_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_14_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_14_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_14_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_14_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_14_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_14_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_14_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_14_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_14_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_14_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_15 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_15_clock),
    .reset(sub_crossbar_15_reset),
    .io_in_0_ready(sub_crossbar_15_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_15_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_15_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_15_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_15_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_15_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_15_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_15_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_15_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_15_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_15_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_15_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_15_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_15_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_15_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_15_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_15_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_15_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_15_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_15_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_15_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_15_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_15_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_15_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_16 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_16_clock),
    .reset(sub_crossbar_16_reset),
    .io_in_0_ready(sub_crossbar_16_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_16_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_16_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_16_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_16_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_16_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_16_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_16_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_16_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_16_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_16_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_16_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_16_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_16_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_16_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_16_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_16_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_16_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_16_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_16_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_16_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_16_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_16_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_16_io_out_3_bits)
  );
  sub_crossbar_17 sub_crossbar_17 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_17_clock),
    .reset(sub_crossbar_17_reset),
    .io_in_0_ready(sub_crossbar_17_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_17_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_17_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_17_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_17_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_17_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_17_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_17_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_17_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_17_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_17_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_17_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_17_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_17_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_17_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_17_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_17_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_17_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_17_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_17_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_17_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_17_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_17_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_17_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_18 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_18_clock),
    .reset(sub_crossbar_18_reset),
    .io_in_0_ready(sub_crossbar_18_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_18_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_18_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_18_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_18_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_18_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_18_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_18_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_18_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_18_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_18_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_18_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_18_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_18_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_18_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_18_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_18_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_18_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_18_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_18_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_18_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_18_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_18_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_18_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_19 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_19_clock),
    .reset(sub_crossbar_19_reset),
    .io_in_0_ready(sub_crossbar_19_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_19_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_19_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_19_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_19_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_19_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_19_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_19_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_19_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_19_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_19_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_19_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_19_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_19_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_19_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_19_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_19_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_19_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_19_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_19_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_19_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_19_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_19_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_19_io_out_3_bits)
  );
  sub_crossbar_20 sub_crossbar_20 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_20_clock),
    .reset(sub_crossbar_20_reset),
    .io_in_0_ready(sub_crossbar_20_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_20_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_20_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_20_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_20_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_20_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_20_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_20_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_20_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_20_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_20_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_20_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_20_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_20_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_20_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_20_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_20_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_20_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_20_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_20_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_20_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_20_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_20_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_20_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_21 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_21_clock),
    .reset(sub_crossbar_21_reset),
    .io_in_0_ready(sub_crossbar_21_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_21_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_21_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_21_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_21_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_21_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_21_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_21_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_21_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_21_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_21_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_21_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_21_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_21_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_21_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_21_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_21_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_21_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_21_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_21_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_21_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_21_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_21_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_21_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_22 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_22_clock),
    .reset(sub_crossbar_22_reset),
    .io_in_0_ready(sub_crossbar_22_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_22_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_22_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_22_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_22_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_22_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_22_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_22_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_22_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_22_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_22_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_22_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_22_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_22_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_22_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_22_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_22_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_22_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_22_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_22_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_22_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_22_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_22_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_22_io_out_3_bits)
  );
  sub_crossbar_23 sub_crossbar_23 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_23_clock),
    .reset(sub_crossbar_23_reset),
    .io_in_0_ready(sub_crossbar_23_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_23_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_23_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_23_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_23_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_23_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_23_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_23_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_23_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_23_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_23_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_23_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_23_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_23_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_23_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_23_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_23_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_23_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_23_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_23_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_23_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_23_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_23_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_23_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_24 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_24_clock),
    .reset(sub_crossbar_24_reset),
    .io_in_0_ready(sub_crossbar_24_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_24_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_24_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_24_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_24_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_24_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_24_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_24_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_24_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_24_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_24_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_24_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_24_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_24_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_24_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_24_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_24_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_24_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_24_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_24_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_24_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_24_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_24_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_24_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_25 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_25_clock),
    .reset(sub_crossbar_25_reset),
    .io_in_0_ready(sub_crossbar_25_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_25_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_25_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_25_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_25_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_25_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_25_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_25_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_25_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_25_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_25_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_25_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_25_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_25_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_25_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_25_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_25_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_25_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_25_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_25_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_25_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_25_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_25_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_25_io_out_3_bits)
  );
  sub_crossbar_26 sub_crossbar_26 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_26_clock),
    .reset(sub_crossbar_26_reset),
    .io_in_0_ready(sub_crossbar_26_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_26_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_26_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_26_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_26_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_26_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_26_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_26_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_26_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_26_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_26_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_26_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_26_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_26_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_26_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_26_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_26_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_26_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_26_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_26_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_26_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_26_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_26_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_26_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_27 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_27_clock),
    .reset(sub_crossbar_27_reset),
    .io_in_0_ready(sub_crossbar_27_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_27_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_27_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_27_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_27_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_27_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_27_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_27_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_27_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_27_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_27_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_27_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_27_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_27_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_27_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_27_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_27_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_27_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_27_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_27_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_27_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_27_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_27_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_27_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_28 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_28_clock),
    .reset(sub_crossbar_28_reset),
    .io_in_0_ready(sub_crossbar_28_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_28_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_28_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_28_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_28_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_28_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_28_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_28_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_28_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_28_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_28_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_28_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_28_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_28_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_28_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_28_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_28_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_28_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_28_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_28_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_28_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_28_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_28_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_28_io_out_3_bits)
  );
  sub_crossbar_29 sub_crossbar_29 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_29_clock),
    .reset(sub_crossbar_29_reset),
    .io_in_0_ready(sub_crossbar_29_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_29_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_29_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_29_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_29_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_29_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_29_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_29_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_29_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_29_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_29_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_29_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_29_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_29_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_29_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_29_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_29_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_29_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_29_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_29_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_29_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_29_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_29_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_29_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_30 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_30_clock),
    .reset(sub_crossbar_30_reset),
    .io_in_0_ready(sub_crossbar_30_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_30_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_30_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_30_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_30_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_30_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_30_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_30_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_30_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_30_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_30_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_30_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_30_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_30_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_30_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_30_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_30_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_30_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_30_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_30_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_30_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_30_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_30_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_30_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_31 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_31_clock),
    .reset(sub_crossbar_31_reset),
    .io_in_0_ready(sub_crossbar_31_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_31_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_31_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_31_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_31_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_31_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_31_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_31_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_31_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_31_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_31_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_31_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_31_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_31_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_31_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_31_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_31_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_31_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_31_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_31_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_31_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_31_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_31_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_31_io_out_3_bits)
  );
  sub_crossbar_32 sub_crossbar_32 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_32_clock),
    .reset(sub_crossbar_32_reset),
    .io_in_0_ready(sub_crossbar_32_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_32_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_32_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_32_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_32_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_32_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_32_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_32_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_32_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_32_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_32_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_32_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_32_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_32_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_32_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_32_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_32_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_32_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_32_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_32_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_32_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_32_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_32_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_32_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_33 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_33_clock),
    .reset(sub_crossbar_33_reset),
    .io_in_0_ready(sub_crossbar_33_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_33_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_33_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_33_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_33_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_33_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_33_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_33_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_33_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_33_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_33_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_33_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_33_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_33_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_33_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_33_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_33_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_33_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_33_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_33_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_33_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_33_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_33_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_33_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_34 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_34_clock),
    .reset(sub_crossbar_34_reset),
    .io_in_0_ready(sub_crossbar_34_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_34_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_34_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_34_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_34_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_34_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_34_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_34_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_34_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_34_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_34_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_34_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_34_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_34_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_34_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_34_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_34_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_34_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_34_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_34_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_34_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_34_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_34_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_34_io_out_3_bits)
  );
  sub_crossbar_35 sub_crossbar_35 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_35_clock),
    .reset(sub_crossbar_35_reset),
    .io_in_0_ready(sub_crossbar_35_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_35_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_35_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_35_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_35_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_35_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_35_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_35_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_35_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_35_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_35_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_35_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_35_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_35_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_35_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_35_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_35_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_35_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_35_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_35_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_35_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_35_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_35_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_35_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_36 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_36_clock),
    .reset(sub_crossbar_36_reset),
    .io_in_0_ready(sub_crossbar_36_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_36_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_36_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_36_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_36_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_36_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_36_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_36_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_36_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_36_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_36_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_36_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_36_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_36_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_36_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_36_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_36_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_36_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_36_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_36_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_36_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_36_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_36_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_36_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_37 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_37_clock),
    .reset(sub_crossbar_37_reset),
    .io_in_0_ready(sub_crossbar_37_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_37_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_37_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_37_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_37_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_37_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_37_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_37_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_37_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_37_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_37_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_37_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_37_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_37_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_37_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_37_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_37_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_37_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_37_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_37_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_37_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_37_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_37_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_37_io_out_3_bits)
  );
  sub_crossbar_38 sub_crossbar_38 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_38_clock),
    .reset(sub_crossbar_38_reset),
    .io_in_0_ready(sub_crossbar_38_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_38_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_38_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_38_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_38_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_38_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_38_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_38_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_38_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_38_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_38_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_38_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_38_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_38_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_38_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_38_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_38_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_38_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_38_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_38_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_38_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_38_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_38_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_38_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_39 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_39_clock),
    .reset(sub_crossbar_39_reset),
    .io_in_0_ready(sub_crossbar_39_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_39_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_39_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_39_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_39_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_39_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_39_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_39_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_39_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_39_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_39_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_39_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_39_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_39_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_39_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_39_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_39_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_39_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_39_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_39_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_39_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_39_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_39_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_39_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_40 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_40_clock),
    .reset(sub_crossbar_40_reset),
    .io_in_0_ready(sub_crossbar_40_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_40_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_40_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_40_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_40_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_40_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_40_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_40_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_40_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_40_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_40_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_40_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_40_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_40_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_40_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_40_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_40_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_40_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_40_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_40_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_40_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_40_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_40_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_40_io_out_3_bits)
  );
  sub_crossbar_41 sub_crossbar_41 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_41_clock),
    .reset(sub_crossbar_41_reset),
    .io_in_0_ready(sub_crossbar_41_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_41_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_41_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_41_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_41_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_41_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_41_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_41_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_41_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_41_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_41_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_41_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_41_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_41_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_41_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_41_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_41_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_41_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_41_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_41_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_41_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_41_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_41_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_41_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_42 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_42_clock),
    .reset(sub_crossbar_42_reset),
    .io_in_0_ready(sub_crossbar_42_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_42_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_42_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_42_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_42_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_42_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_42_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_42_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_42_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_42_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_42_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_42_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_42_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_42_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_42_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_42_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_42_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_42_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_42_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_42_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_42_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_42_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_42_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_42_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_43 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_43_clock),
    .reset(sub_crossbar_43_reset),
    .io_in_0_ready(sub_crossbar_43_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_43_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_43_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_43_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_43_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_43_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_43_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_43_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_43_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_43_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_43_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_43_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_43_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_43_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_43_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_43_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_43_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_43_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_43_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_43_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_43_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_43_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_43_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_43_io_out_3_bits)
  );
  sub_crossbar_44 sub_crossbar_44 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_44_clock),
    .reset(sub_crossbar_44_reset),
    .io_in_0_ready(sub_crossbar_44_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_44_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_44_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_44_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_44_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_44_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_44_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_44_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_44_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_44_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_44_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_44_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_44_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_44_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_44_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_44_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_44_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_44_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_44_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_44_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_44_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_44_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_44_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_44_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_45 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_45_clock),
    .reset(sub_crossbar_45_reset),
    .io_in_0_ready(sub_crossbar_45_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_45_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_45_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_45_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_45_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_45_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_45_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_45_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_45_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_45_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_45_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_45_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_45_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_45_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_45_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_45_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_45_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_45_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_45_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_45_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_45_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_45_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_45_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_45_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_46 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_46_clock),
    .reset(sub_crossbar_46_reset),
    .io_in_0_ready(sub_crossbar_46_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_46_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_46_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_46_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_46_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_46_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_46_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_46_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_46_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_46_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_46_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_46_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_46_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_46_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_46_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_46_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_46_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_46_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_46_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_46_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_46_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_46_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_46_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_46_io_out_3_bits)
  );
  sub_crossbar_47 sub_crossbar_47 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_47_clock),
    .reset(sub_crossbar_47_reset),
    .io_in_0_ready(sub_crossbar_47_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_47_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_47_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_47_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_47_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_47_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_47_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_47_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_47_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_47_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_47_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_47_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_47_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_47_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_47_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_47_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_47_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_47_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_47_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_47_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_47_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_47_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_47_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_47_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_48 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_48_clock),
    .reset(sub_crossbar_48_reset),
    .io_in_0_ready(sub_crossbar_48_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_48_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_48_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_48_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_48_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_48_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_48_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_48_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_48_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_48_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_48_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_48_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_48_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_48_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_48_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_48_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_48_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_48_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_48_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_48_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_48_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_48_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_48_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_48_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_49 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_49_clock),
    .reset(sub_crossbar_49_reset),
    .io_in_0_ready(sub_crossbar_49_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_49_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_49_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_49_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_49_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_49_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_49_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_49_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_49_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_49_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_49_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_49_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_49_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_49_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_49_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_49_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_49_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_49_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_49_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_49_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_49_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_49_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_49_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_49_io_out_3_bits)
  );
  sub_crossbar_2 sub_crossbar_50 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_50_clock),
    .reset(sub_crossbar_50_reset),
    .io_in_0_ready(sub_crossbar_50_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_50_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_50_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_50_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_50_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_50_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_50_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_50_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_50_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_50_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_50_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_50_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_50_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_50_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_50_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_50_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_50_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_50_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_50_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_50_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_50_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_50_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_50_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_50_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_51 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_51_clock),
    .reset(sub_crossbar_51_reset),
    .io_in_0_ready(sub_crossbar_51_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_51_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_51_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_51_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_51_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_51_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_51_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_51_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_51_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_51_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_51_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_51_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_51_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_51_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_51_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_51_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_51_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_51_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_51_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_51_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_51_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_51_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_51_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_51_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_52 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_52_clock),
    .reset(sub_crossbar_52_reset),
    .io_in_0_ready(sub_crossbar_52_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_52_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_52_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_52_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_52_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_52_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_52_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_52_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_52_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_52_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_52_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_52_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_52_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_52_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_52_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_52_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_52_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_52_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_52_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_52_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_52_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_52_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_52_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_52_io_out_3_bits)
  );
  sub_crossbar_5 sub_crossbar_53 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_53_clock),
    .reset(sub_crossbar_53_reset),
    .io_in_0_ready(sub_crossbar_53_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_53_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_53_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_53_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_53_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_53_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_53_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_53_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_53_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_53_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_53_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_53_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_53_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_53_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_53_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_53_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_53_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_53_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_53_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_53_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_53_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_53_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_53_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_53_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_54 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_54_clock),
    .reset(sub_crossbar_54_reset),
    .io_in_0_ready(sub_crossbar_54_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_54_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_54_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_54_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_54_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_54_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_54_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_54_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_54_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_54_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_54_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_54_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_54_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_54_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_54_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_54_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_54_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_54_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_54_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_54_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_54_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_54_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_54_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_54_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_55 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_55_clock),
    .reset(sub_crossbar_55_reset),
    .io_in_0_ready(sub_crossbar_55_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_55_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_55_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_55_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_55_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_55_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_55_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_55_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_55_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_55_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_55_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_55_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_55_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_55_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_55_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_55_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_55_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_55_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_55_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_55_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_55_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_55_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_55_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_55_io_out_3_bits)
  );
  sub_crossbar_8 sub_crossbar_56 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_56_clock),
    .reset(sub_crossbar_56_reset),
    .io_in_0_ready(sub_crossbar_56_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_56_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_56_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_56_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_56_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_56_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_56_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_56_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_56_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_56_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_56_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_56_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_56_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_56_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_56_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_56_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_56_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_56_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_56_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_56_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_56_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_56_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_56_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_56_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_57 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_57_clock),
    .reset(sub_crossbar_57_reset),
    .io_in_0_ready(sub_crossbar_57_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_57_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_57_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_57_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_57_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_57_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_57_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_57_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_57_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_57_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_57_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_57_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_57_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_57_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_57_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_57_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_57_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_57_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_57_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_57_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_57_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_57_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_57_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_57_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_58 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_58_clock),
    .reset(sub_crossbar_58_reset),
    .io_in_0_ready(sub_crossbar_58_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_58_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_58_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_58_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_58_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_58_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_58_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_58_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_58_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_58_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_58_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_58_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_58_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_58_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_58_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_58_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_58_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_58_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_58_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_58_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_58_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_58_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_58_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_58_io_out_3_bits)
  );
  sub_crossbar_11 sub_crossbar_59 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_59_clock),
    .reset(sub_crossbar_59_reset),
    .io_in_0_ready(sub_crossbar_59_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_59_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_59_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_59_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_59_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_59_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_59_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_59_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_59_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_59_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_59_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_59_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_59_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_59_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_59_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_59_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_59_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_59_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_59_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_59_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_59_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_59_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_59_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_59_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_60 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_60_clock),
    .reset(sub_crossbar_60_reset),
    .io_in_0_ready(sub_crossbar_60_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_60_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_60_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_60_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_60_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_60_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_60_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_60_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_60_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_60_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_60_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_60_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_60_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_60_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_60_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_60_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_60_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_60_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_60_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_60_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_60_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_60_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_60_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_60_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_61 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_61_clock),
    .reset(sub_crossbar_61_reset),
    .io_in_0_ready(sub_crossbar_61_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_61_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_61_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_61_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_61_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_61_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_61_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_61_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_61_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_61_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_61_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_61_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_61_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_61_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_61_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_61_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_61_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_61_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_61_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_61_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_61_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_61_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_61_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_61_io_out_3_bits)
  );
  sub_crossbar_14 sub_crossbar_62 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_62_clock),
    .reset(sub_crossbar_62_reset),
    .io_in_0_ready(sub_crossbar_62_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_62_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_62_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_62_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_62_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_62_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_62_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_62_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_62_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_62_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_62_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_62_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_62_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_62_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_62_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_62_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_62_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_62_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_62_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_62_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_62_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_62_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_62_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_62_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_63 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_63_clock),
    .reset(sub_crossbar_63_reset),
    .io_in_0_ready(sub_crossbar_63_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_63_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_63_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_63_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_63_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_63_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_63_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_63_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_63_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_63_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_63_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_63_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_63_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_63_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_63_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_63_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_63_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_63_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_63_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_63_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_63_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_63_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_63_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_63_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_64 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_64_clock),
    .reset(sub_crossbar_64_reset),
    .io_in_0_ready(sub_crossbar_64_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_64_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_64_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_64_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_64_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_64_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_64_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_64_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_64_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_64_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_64_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_64_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_64_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_64_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_64_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_64_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_64_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_64_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_64_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_64_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_64_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_64_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_64_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_64_io_out_3_bits)
  );
  sub_crossbar_17 sub_crossbar_65 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_65_clock),
    .reset(sub_crossbar_65_reset),
    .io_in_0_ready(sub_crossbar_65_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_65_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_65_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_65_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_65_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_65_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_65_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_65_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_65_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_65_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_65_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_65_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_65_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_65_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_65_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_65_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_65_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_65_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_65_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_65_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_65_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_65_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_65_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_65_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_66 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_66_clock),
    .reset(sub_crossbar_66_reset),
    .io_in_0_ready(sub_crossbar_66_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_66_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_66_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_66_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_66_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_66_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_66_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_66_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_66_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_66_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_66_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_66_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_66_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_66_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_66_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_66_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_66_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_66_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_66_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_66_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_66_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_66_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_66_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_66_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_67 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_67_clock),
    .reset(sub_crossbar_67_reset),
    .io_in_0_ready(sub_crossbar_67_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_67_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_67_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_67_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_67_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_67_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_67_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_67_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_67_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_67_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_67_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_67_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_67_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_67_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_67_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_67_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_67_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_67_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_67_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_67_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_67_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_67_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_67_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_67_io_out_3_bits)
  );
  sub_crossbar_20 sub_crossbar_68 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_68_clock),
    .reset(sub_crossbar_68_reset),
    .io_in_0_ready(sub_crossbar_68_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_68_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_68_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_68_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_68_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_68_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_68_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_68_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_68_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_68_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_68_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_68_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_68_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_68_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_68_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_68_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_68_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_68_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_68_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_68_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_68_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_68_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_68_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_68_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_69 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_69_clock),
    .reset(sub_crossbar_69_reset),
    .io_in_0_ready(sub_crossbar_69_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_69_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_69_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_69_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_69_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_69_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_69_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_69_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_69_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_69_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_69_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_69_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_69_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_69_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_69_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_69_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_69_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_69_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_69_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_69_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_69_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_69_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_69_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_69_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_70 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_70_clock),
    .reset(sub_crossbar_70_reset),
    .io_in_0_ready(sub_crossbar_70_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_70_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_70_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_70_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_70_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_70_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_70_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_70_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_70_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_70_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_70_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_70_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_70_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_70_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_70_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_70_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_70_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_70_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_70_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_70_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_70_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_70_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_70_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_70_io_out_3_bits)
  );
  sub_crossbar_23 sub_crossbar_71 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_71_clock),
    .reset(sub_crossbar_71_reset),
    .io_in_0_ready(sub_crossbar_71_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_71_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_71_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_71_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_71_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_71_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_71_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_71_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_71_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_71_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_71_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_71_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_71_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_71_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_71_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_71_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_71_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_71_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_71_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_71_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_71_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_71_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_71_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_71_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_72 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_72_clock),
    .reset(sub_crossbar_72_reset),
    .io_in_0_ready(sub_crossbar_72_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_72_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_72_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_72_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_72_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_72_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_72_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_72_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_72_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_72_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_72_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_72_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_72_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_72_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_72_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_72_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_72_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_72_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_72_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_72_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_72_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_72_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_72_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_72_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_73 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_73_clock),
    .reset(sub_crossbar_73_reset),
    .io_in_0_ready(sub_crossbar_73_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_73_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_73_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_73_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_73_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_73_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_73_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_73_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_73_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_73_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_73_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_73_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_73_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_73_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_73_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_73_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_73_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_73_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_73_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_73_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_73_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_73_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_73_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_73_io_out_3_bits)
  );
  sub_crossbar_26 sub_crossbar_74 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_74_clock),
    .reset(sub_crossbar_74_reset),
    .io_in_0_ready(sub_crossbar_74_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_74_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_74_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_74_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_74_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_74_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_74_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_74_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_74_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_74_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_74_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_74_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_74_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_74_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_74_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_74_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_74_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_74_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_74_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_74_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_74_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_74_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_74_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_74_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_75 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_75_clock),
    .reset(sub_crossbar_75_reset),
    .io_in_0_ready(sub_crossbar_75_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_75_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_75_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_75_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_75_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_75_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_75_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_75_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_75_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_75_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_75_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_75_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_75_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_75_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_75_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_75_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_75_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_75_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_75_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_75_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_75_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_75_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_75_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_75_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_76 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_76_clock),
    .reset(sub_crossbar_76_reset),
    .io_in_0_ready(sub_crossbar_76_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_76_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_76_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_76_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_76_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_76_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_76_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_76_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_76_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_76_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_76_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_76_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_76_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_76_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_76_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_76_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_76_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_76_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_76_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_76_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_76_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_76_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_76_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_76_io_out_3_bits)
  );
  sub_crossbar_29 sub_crossbar_77 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_77_clock),
    .reset(sub_crossbar_77_reset),
    .io_in_0_ready(sub_crossbar_77_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_77_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_77_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_77_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_77_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_77_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_77_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_77_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_77_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_77_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_77_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_77_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_77_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_77_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_77_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_77_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_77_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_77_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_77_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_77_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_77_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_77_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_77_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_77_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_78 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_78_clock),
    .reset(sub_crossbar_78_reset),
    .io_in_0_ready(sub_crossbar_78_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_78_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_78_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_78_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_78_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_78_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_78_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_78_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_78_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_78_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_78_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_78_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_78_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_78_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_78_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_78_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_78_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_78_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_78_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_78_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_78_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_78_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_78_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_78_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_79 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_79_clock),
    .reset(sub_crossbar_79_reset),
    .io_in_0_ready(sub_crossbar_79_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_79_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_79_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_79_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_79_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_79_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_79_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_79_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_79_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_79_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_79_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_79_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_79_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_79_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_79_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_79_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_79_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_79_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_79_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_79_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_79_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_79_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_79_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_79_io_out_3_bits)
  );
  sub_crossbar_32 sub_crossbar_80 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_80_clock),
    .reset(sub_crossbar_80_reset),
    .io_in_0_ready(sub_crossbar_80_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_80_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_80_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_80_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_80_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_80_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_80_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_80_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_80_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_80_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_80_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_80_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_80_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_80_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_80_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_80_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_80_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_80_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_80_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_80_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_80_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_80_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_80_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_80_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_81 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_81_clock),
    .reset(sub_crossbar_81_reset),
    .io_in_0_ready(sub_crossbar_81_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_81_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_81_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_81_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_81_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_81_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_81_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_81_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_81_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_81_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_81_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_81_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_81_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_81_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_81_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_81_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_81_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_81_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_81_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_81_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_81_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_81_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_81_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_81_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_82 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_82_clock),
    .reset(sub_crossbar_82_reset),
    .io_in_0_ready(sub_crossbar_82_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_82_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_82_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_82_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_82_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_82_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_82_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_82_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_82_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_82_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_82_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_82_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_82_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_82_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_82_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_82_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_82_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_82_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_82_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_82_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_82_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_82_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_82_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_82_io_out_3_bits)
  );
  sub_crossbar_35 sub_crossbar_83 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_83_clock),
    .reset(sub_crossbar_83_reset),
    .io_in_0_ready(sub_crossbar_83_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_83_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_83_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_83_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_83_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_83_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_83_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_83_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_83_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_83_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_83_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_83_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_83_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_83_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_83_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_83_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_83_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_83_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_83_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_83_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_83_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_83_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_83_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_83_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_84 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_84_clock),
    .reset(sub_crossbar_84_reset),
    .io_in_0_ready(sub_crossbar_84_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_84_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_84_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_84_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_84_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_84_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_84_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_84_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_84_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_84_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_84_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_84_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_84_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_84_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_84_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_84_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_84_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_84_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_84_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_84_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_84_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_84_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_84_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_84_io_out_3_bits)
  );
  sub_crossbar_1 sub_crossbar_85 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_85_clock),
    .reset(sub_crossbar_85_reset),
    .io_in_0_ready(sub_crossbar_85_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_85_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_85_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_85_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_85_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_85_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_85_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_85_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_85_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_85_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_85_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_85_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_85_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_85_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_85_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_85_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_85_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_85_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_85_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_85_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_85_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_85_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_85_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_85_io_out_3_bits)
  );
  sub_crossbar_38 sub_crossbar_86 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_86_clock),
    .reset(sub_crossbar_86_reset),
    .io_in_0_ready(sub_crossbar_86_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_86_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_86_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_86_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_86_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_86_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_86_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_86_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_86_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_86_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_86_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_86_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_86_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_86_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_86_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_86_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_86_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_86_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_86_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_86_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_86_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_86_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_86_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_86_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_87 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_87_clock),
    .reset(sub_crossbar_87_reset),
    .io_in_0_ready(sub_crossbar_87_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_87_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_87_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_87_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_87_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_87_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_87_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_87_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_87_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_87_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_87_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_87_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_87_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_87_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_87_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_87_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_87_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_87_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_87_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_87_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_87_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_87_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_87_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_87_io_out_3_bits)
  );
  sub_crossbar_4 sub_crossbar_88 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_88_clock),
    .reset(sub_crossbar_88_reset),
    .io_in_0_ready(sub_crossbar_88_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_88_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_88_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_88_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_88_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_88_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_88_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_88_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_88_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_88_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_88_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_88_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_88_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_88_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_88_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_88_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_88_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_88_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_88_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_88_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_88_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_88_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_88_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_88_io_out_3_bits)
  );
  sub_crossbar_41 sub_crossbar_89 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_89_clock),
    .reset(sub_crossbar_89_reset),
    .io_in_0_ready(sub_crossbar_89_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_89_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_89_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_89_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_89_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_89_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_89_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_89_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_89_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_89_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_89_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_89_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_89_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_89_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_89_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_89_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_89_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_89_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_89_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_89_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_89_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_89_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_89_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_89_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_90 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_90_clock),
    .reset(sub_crossbar_90_reset),
    .io_in_0_ready(sub_crossbar_90_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_90_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_90_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_90_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_90_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_90_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_90_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_90_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_90_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_90_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_90_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_90_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_90_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_90_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_90_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_90_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_90_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_90_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_90_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_90_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_90_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_90_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_90_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_90_io_out_3_bits)
  );
  sub_crossbar_7 sub_crossbar_91 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_91_clock),
    .reset(sub_crossbar_91_reset),
    .io_in_0_ready(sub_crossbar_91_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_91_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_91_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_91_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_91_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_91_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_91_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_91_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_91_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_91_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_91_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_91_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_91_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_91_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_91_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_91_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_91_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_91_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_91_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_91_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_91_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_91_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_91_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_91_io_out_3_bits)
  );
  sub_crossbar_44 sub_crossbar_92 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_92_clock),
    .reset(sub_crossbar_92_reset),
    .io_in_0_ready(sub_crossbar_92_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_92_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_92_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_92_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_92_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_92_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_92_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_92_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_92_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_92_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_92_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_92_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_92_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_92_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_92_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_92_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_92_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_92_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_92_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_92_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_92_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_92_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_92_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_92_io_out_3_bits)
  );
  sub_crossbar sub_crossbar_93 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_93_clock),
    .reset(sub_crossbar_93_reset),
    .io_in_0_ready(sub_crossbar_93_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_93_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_93_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_93_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_93_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_93_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_93_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_93_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_93_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_93_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_93_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_93_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_93_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_93_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_93_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_93_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_93_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_93_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_93_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_93_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_93_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_93_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_93_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_93_io_out_3_bits)
  );
  sub_crossbar_10 sub_crossbar_94 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_94_clock),
    .reset(sub_crossbar_94_reset),
    .io_in_0_ready(sub_crossbar_94_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_94_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_94_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_94_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_94_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_94_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_94_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_94_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_94_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_94_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_94_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_94_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_94_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_94_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_94_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_94_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_94_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_94_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_94_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_94_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_94_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_94_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_94_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_94_io_out_3_bits)
  );
  sub_crossbar_47 sub_crossbar_95 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_95_clock),
    .reset(sub_crossbar_95_reset),
    .io_in_0_ready(sub_crossbar_95_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_95_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_95_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_95_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_95_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_95_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_95_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_95_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_95_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_95_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_95_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_95_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_95_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_95_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_95_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_95_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_95_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_95_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_95_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_95_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_95_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_95_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_95_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_95_io_out_3_bits)
  );
  sub_crossbar_96 sub_crossbar_96 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_96_clock),
    .reset(sub_crossbar_96_reset),
    .io_in_0_ready(sub_crossbar_96_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_96_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_96_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_96_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_96_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_96_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_96_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_96_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_96_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_96_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_96_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_96_io_out_1_bits)
  );
  sub_crossbar_97 sub_crossbar_97 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_97_clock),
    .reset(sub_crossbar_97_reset),
    .io_in_0_ready(sub_crossbar_97_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_97_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_97_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_97_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_97_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_97_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_97_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_97_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_97_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_97_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_97_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_97_io_out_1_bits)
  );
  sub_crossbar_98 sub_crossbar_98 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_98_clock),
    .reset(sub_crossbar_98_reset),
    .io_in_0_ready(sub_crossbar_98_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_98_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_98_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_98_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_98_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_98_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_98_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_98_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_98_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_98_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_98_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_98_io_out_1_bits)
  );
  sub_crossbar_99 sub_crossbar_99 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_99_clock),
    .reset(sub_crossbar_99_reset),
    .io_in_0_ready(sub_crossbar_99_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_99_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_99_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_99_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_99_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_99_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_99_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_99_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_99_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_99_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_99_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_99_io_out_1_bits)
  );
  sub_crossbar_100 sub_crossbar_100 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_100_clock),
    .reset(sub_crossbar_100_reset),
    .io_in_0_ready(sub_crossbar_100_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_100_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_100_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_100_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_100_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_100_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_100_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_100_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_100_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_100_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_100_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_100_io_out_1_bits)
  );
  sub_crossbar_101 sub_crossbar_101 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_101_clock),
    .reset(sub_crossbar_101_reset),
    .io_in_0_ready(sub_crossbar_101_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_101_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_101_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_101_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_101_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_101_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_101_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_101_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_101_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_101_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_101_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_101_io_out_1_bits)
  );
  sub_crossbar_102 sub_crossbar_102 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_102_clock),
    .reset(sub_crossbar_102_reset),
    .io_in_0_ready(sub_crossbar_102_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_102_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_102_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_102_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_102_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_102_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_102_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_102_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_102_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_102_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_102_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_102_io_out_1_bits)
  );
  sub_crossbar_103 sub_crossbar_103 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_103_clock),
    .reset(sub_crossbar_103_reset),
    .io_in_0_ready(sub_crossbar_103_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_103_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_103_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_103_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_103_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_103_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_103_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_103_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_103_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_103_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_103_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_103_io_out_1_bits)
  );
  sub_crossbar_104 sub_crossbar_104 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_104_clock),
    .reset(sub_crossbar_104_reset),
    .io_in_0_ready(sub_crossbar_104_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_104_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_104_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_104_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_104_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_104_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_104_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_104_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_104_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_104_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_104_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_104_io_out_1_bits)
  );
  sub_crossbar_105 sub_crossbar_105 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_105_clock),
    .reset(sub_crossbar_105_reset),
    .io_in_0_ready(sub_crossbar_105_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_105_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_105_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_105_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_105_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_105_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_105_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_105_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_105_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_105_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_105_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_105_io_out_1_bits)
  );
  sub_crossbar_106 sub_crossbar_106 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_106_clock),
    .reset(sub_crossbar_106_reset),
    .io_in_0_ready(sub_crossbar_106_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_106_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_106_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_106_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_106_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_106_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_106_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_106_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_106_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_106_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_106_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_106_io_out_1_bits)
  );
  sub_crossbar_107 sub_crossbar_107 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_107_clock),
    .reset(sub_crossbar_107_reset),
    .io_in_0_ready(sub_crossbar_107_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_107_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_107_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_107_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_107_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_107_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_107_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_107_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_107_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_107_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_107_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_107_io_out_1_bits)
  );
  sub_crossbar_108 sub_crossbar_108 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_108_clock),
    .reset(sub_crossbar_108_reset),
    .io_in_0_ready(sub_crossbar_108_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_108_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_108_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_108_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_108_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_108_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_108_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_108_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_108_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_108_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_108_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_108_io_out_1_bits)
  );
  sub_crossbar_109 sub_crossbar_109 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_109_clock),
    .reset(sub_crossbar_109_reset),
    .io_in_0_ready(sub_crossbar_109_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_109_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_109_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_109_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_109_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_109_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_109_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_109_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_109_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_109_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_109_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_109_io_out_1_bits)
  );
  sub_crossbar_110 sub_crossbar_110 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_110_clock),
    .reset(sub_crossbar_110_reset),
    .io_in_0_ready(sub_crossbar_110_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_110_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_110_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_110_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_110_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_110_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_110_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_110_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_110_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_110_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_110_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_110_io_out_1_bits)
  );
  sub_crossbar_111 sub_crossbar_111 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_111_clock),
    .reset(sub_crossbar_111_reset),
    .io_in_0_ready(sub_crossbar_111_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_111_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_111_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_111_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_111_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_111_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_111_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_111_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_111_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_111_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_111_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_111_io_out_1_bits)
  );
  sub_crossbar_112 sub_crossbar_112 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_112_clock),
    .reset(sub_crossbar_112_reset),
    .io_in_0_ready(sub_crossbar_112_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_112_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_112_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_112_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_112_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_112_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_112_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_112_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_112_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_112_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_112_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_112_io_out_1_bits)
  );
  sub_crossbar_113 sub_crossbar_113 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_113_clock),
    .reset(sub_crossbar_113_reset),
    .io_in_0_ready(sub_crossbar_113_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_113_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_113_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_113_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_113_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_113_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_113_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_113_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_113_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_113_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_113_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_113_io_out_1_bits)
  );
  sub_crossbar_114 sub_crossbar_114 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_114_clock),
    .reset(sub_crossbar_114_reset),
    .io_in_0_ready(sub_crossbar_114_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_114_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_114_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_114_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_114_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_114_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_114_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_114_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_114_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_114_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_114_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_114_io_out_1_bits)
  );
  sub_crossbar_115 sub_crossbar_115 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_115_clock),
    .reset(sub_crossbar_115_reset),
    .io_in_0_ready(sub_crossbar_115_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_115_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_115_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_115_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_115_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_115_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_115_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_115_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_115_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_115_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_115_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_115_io_out_1_bits)
  );
  sub_crossbar_116 sub_crossbar_116 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_116_clock),
    .reset(sub_crossbar_116_reset),
    .io_in_0_ready(sub_crossbar_116_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_116_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_116_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_116_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_116_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_116_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_116_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_116_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_116_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_116_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_116_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_116_io_out_1_bits)
  );
  sub_crossbar_117 sub_crossbar_117 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_117_clock),
    .reset(sub_crossbar_117_reset),
    .io_in_0_ready(sub_crossbar_117_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_117_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_117_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_117_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_117_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_117_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_117_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_117_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_117_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_117_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_117_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_117_io_out_1_bits)
  );
  sub_crossbar_118 sub_crossbar_118 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_118_clock),
    .reset(sub_crossbar_118_reset),
    .io_in_0_ready(sub_crossbar_118_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_118_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_118_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_118_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_118_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_118_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_118_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_118_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_118_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_118_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_118_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_118_io_out_1_bits)
  );
  sub_crossbar_119 sub_crossbar_119 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_119_clock),
    .reset(sub_crossbar_119_reset),
    .io_in_0_ready(sub_crossbar_119_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_119_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_119_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_119_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_119_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_119_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_119_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_119_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_119_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_119_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_119_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_119_io_out_1_bits)
  );
  sub_crossbar_120 sub_crossbar_120 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_120_clock),
    .reset(sub_crossbar_120_reset),
    .io_in_0_ready(sub_crossbar_120_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_120_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_120_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_120_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_120_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_120_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_120_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_120_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_120_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_120_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_120_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_120_io_out_1_bits)
  );
  sub_crossbar_121 sub_crossbar_121 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_121_clock),
    .reset(sub_crossbar_121_reset),
    .io_in_0_ready(sub_crossbar_121_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_121_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_121_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_121_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_121_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_121_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_121_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_121_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_121_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_121_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_121_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_121_io_out_1_bits)
  );
  sub_crossbar_122 sub_crossbar_122 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_122_clock),
    .reset(sub_crossbar_122_reset),
    .io_in_0_ready(sub_crossbar_122_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_122_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_122_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_122_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_122_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_122_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_122_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_122_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_122_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_122_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_122_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_122_io_out_1_bits)
  );
  sub_crossbar_123 sub_crossbar_123 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_123_clock),
    .reset(sub_crossbar_123_reset),
    .io_in_0_ready(sub_crossbar_123_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_123_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_123_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_123_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_123_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_123_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_123_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_123_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_123_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_123_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_123_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_123_io_out_1_bits)
  );
  sub_crossbar_124 sub_crossbar_124 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_124_clock),
    .reset(sub_crossbar_124_reset),
    .io_in_0_ready(sub_crossbar_124_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_124_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_124_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_124_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_124_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_124_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_124_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_124_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_124_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_124_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_124_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_124_io_out_1_bits)
  );
  sub_crossbar_125 sub_crossbar_125 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_125_clock),
    .reset(sub_crossbar_125_reset),
    .io_in_0_ready(sub_crossbar_125_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_125_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_125_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_125_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_125_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_125_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_125_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_125_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_125_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_125_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_125_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_125_io_out_1_bits)
  );
  sub_crossbar_126 sub_crossbar_126 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_126_clock),
    .reset(sub_crossbar_126_reset),
    .io_in_0_ready(sub_crossbar_126_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_126_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_126_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_126_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_126_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_126_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_126_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_126_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_126_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_126_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_126_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_126_io_out_1_bits)
  );
  sub_crossbar_127 sub_crossbar_127 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_127_clock),
    .reset(sub_crossbar_127_reset),
    .io_in_0_ready(sub_crossbar_127_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_127_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_127_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_127_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_127_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_127_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_127_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_127_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_127_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_127_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_127_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_127_io_out_1_bits)
  );
  sub_crossbar_128 sub_crossbar_128 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_128_clock),
    .reset(sub_crossbar_128_reset),
    .io_in_0_ready(sub_crossbar_128_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_128_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_128_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_128_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_128_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_128_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_128_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_128_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_128_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_128_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_128_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_128_io_out_1_bits)
  );
  sub_crossbar_129 sub_crossbar_129 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_129_clock),
    .reset(sub_crossbar_129_reset),
    .io_in_0_ready(sub_crossbar_129_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_129_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_129_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_129_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_129_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_129_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_129_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_129_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_129_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_129_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_129_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_129_io_out_1_bits)
  );
  sub_crossbar_130 sub_crossbar_130 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_130_clock),
    .reset(sub_crossbar_130_reset),
    .io_in_0_ready(sub_crossbar_130_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_130_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_130_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_130_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_130_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_130_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_130_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_130_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_130_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_130_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_130_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_130_io_out_1_bits)
  );
  sub_crossbar_131 sub_crossbar_131 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_131_clock),
    .reset(sub_crossbar_131_reset),
    .io_in_0_ready(sub_crossbar_131_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_131_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_131_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_131_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_131_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_131_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_131_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_131_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_131_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_131_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_131_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_131_io_out_1_bits)
  );
  sub_crossbar_132 sub_crossbar_132 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_132_clock),
    .reset(sub_crossbar_132_reset),
    .io_in_0_ready(sub_crossbar_132_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_132_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_132_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_132_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_132_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_132_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_132_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_132_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_132_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_132_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_132_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_132_io_out_1_bits)
  );
  sub_crossbar_133 sub_crossbar_133 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_133_clock),
    .reset(sub_crossbar_133_reset),
    .io_in_0_ready(sub_crossbar_133_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_133_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_133_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_133_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_133_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_133_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_133_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_133_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_133_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_133_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_133_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_133_io_out_1_bits)
  );
  sub_crossbar_134 sub_crossbar_134 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_134_clock),
    .reset(sub_crossbar_134_reset),
    .io_in_0_ready(sub_crossbar_134_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_134_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_134_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_134_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_134_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_134_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_134_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_134_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_134_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_134_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_134_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_134_io_out_1_bits)
  );
  sub_crossbar_135 sub_crossbar_135 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_135_clock),
    .reset(sub_crossbar_135_reset),
    .io_in_0_ready(sub_crossbar_135_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_135_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_135_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_135_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_135_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_135_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_135_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_135_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_135_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_135_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_135_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_135_io_out_1_bits)
  );
  sub_crossbar_136 sub_crossbar_136 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_136_clock),
    .reset(sub_crossbar_136_reset),
    .io_in_0_ready(sub_crossbar_136_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_136_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_136_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_136_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_136_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_136_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_136_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_136_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_136_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_136_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_136_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_136_io_out_1_bits)
  );
  sub_crossbar_137 sub_crossbar_137 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_137_clock),
    .reset(sub_crossbar_137_reset),
    .io_in_0_ready(sub_crossbar_137_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_137_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_137_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_137_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_137_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_137_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_137_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_137_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_137_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_137_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_137_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_137_io_out_1_bits)
  );
  sub_crossbar_138 sub_crossbar_138 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_138_clock),
    .reset(sub_crossbar_138_reset),
    .io_in_0_ready(sub_crossbar_138_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_138_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_138_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_138_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_138_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_138_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_138_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_138_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_138_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_138_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_138_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_138_io_out_1_bits)
  );
  sub_crossbar_139 sub_crossbar_139 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_139_clock),
    .reset(sub_crossbar_139_reset),
    .io_in_0_ready(sub_crossbar_139_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_139_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_139_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_139_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_139_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_139_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_139_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_139_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_139_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_139_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_139_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_139_io_out_1_bits)
  );
  sub_crossbar_140 sub_crossbar_140 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_140_clock),
    .reset(sub_crossbar_140_reset),
    .io_in_0_ready(sub_crossbar_140_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_140_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_140_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_140_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_140_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_140_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_140_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_140_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_140_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_140_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_140_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_140_io_out_1_bits)
  );
  sub_crossbar_141 sub_crossbar_141 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_141_clock),
    .reset(sub_crossbar_141_reset),
    .io_in_0_ready(sub_crossbar_141_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_141_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_141_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_141_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_141_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_141_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_141_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_141_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_141_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_141_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_141_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_141_io_out_1_bits)
  );
  sub_crossbar_142 sub_crossbar_142 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_142_clock),
    .reset(sub_crossbar_142_reset),
    .io_in_0_ready(sub_crossbar_142_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_142_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_142_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_142_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_142_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_142_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_142_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_142_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_142_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_142_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_142_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_142_io_out_1_bits)
  );
  sub_crossbar_143 sub_crossbar_143 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_143_clock),
    .reset(sub_crossbar_143_reset),
    .io_in_0_ready(sub_crossbar_143_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_143_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_143_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_143_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_143_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_143_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_143_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_143_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_143_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_143_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_143_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_143_io_out_1_bits)
  );
  sub_crossbar_144 sub_crossbar_144 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_144_clock),
    .reset(sub_crossbar_144_reset),
    .io_in_0_ready(sub_crossbar_144_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_144_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_144_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_144_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_144_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_144_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_144_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_144_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_144_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_144_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_144_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_144_io_out_1_bits)
  );
  sub_crossbar_145 sub_crossbar_145 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_145_clock),
    .reset(sub_crossbar_145_reset),
    .io_in_0_ready(sub_crossbar_145_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_145_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_145_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_145_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_145_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_145_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_145_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_145_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_145_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_145_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_145_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_145_io_out_1_bits)
  );
  sub_crossbar_146 sub_crossbar_146 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_146_clock),
    .reset(sub_crossbar_146_reset),
    .io_in_0_ready(sub_crossbar_146_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_146_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_146_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_146_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_146_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_146_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_146_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_146_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_146_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_146_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_146_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_146_io_out_1_bits)
  );
  sub_crossbar_147 sub_crossbar_147 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_147_clock),
    .reset(sub_crossbar_147_reset),
    .io_in_0_ready(sub_crossbar_147_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_147_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_147_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_147_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_147_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_147_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_147_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_147_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_147_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_147_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_147_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_147_io_out_1_bits)
  );
  sub_crossbar_148 sub_crossbar_148 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_148_clock),
    .reset(sub_crossbar_148_reset),
    .io_in_0_ready(sub_crossbar_148_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_148_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_148_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_148_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_148_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_148_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_148_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_148_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_148_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_148_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_148_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_148_io_out_1_bits)
  );
  sub_crossbar_149 sub_crossbar_149 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_149_clock),
    .reset(sub_crossbar_149_reset),
    .io_in_0_ready(sub_crossbar_149_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_149_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_149_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_149_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_149_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_149_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_149_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_149_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_149_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_149_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_149_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_149_io_out_1_bits)
  );
  sub_crossbar_150 sub_crossbar_150 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_150_clock),
    .reset(sub_crossbar_150_reset),
    .io_in_0_ready(sub_crossbar_150_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_150_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_150_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_150_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_150_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_150_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_150_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_150_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_150_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_150_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_150_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_150_io_out_1_bits)
  );
  sub_crossbar_151 sub_crossbar_151 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_151_clock),
    .reset(sub_crossbar_151_reset),
    .io_in_0_ready(sub_crossbar_151_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_151_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_151_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_151_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_151_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_151_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_151_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_151_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_151_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_151_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_151_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_151_io_out_1_bits)
  );
  sub_crossbar_152 sub_crossbar_152 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_152_clock),
    .reset(sub_crossbar_152_reset),
    .io_in_0_ready(sub_crossbar_152_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_152_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_152_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_152_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_152_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_152_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_152_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_152_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_152_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_152_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_152_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_152_io_out_1_bits)
  );
  sub_crossbar_153 sub_crossbar_153 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_153_clock),
    .reset(sub_crossbar_153_reset),
    .io_in_0_ready(sub_crossbar_153_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_153_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_153_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_153_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_153_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_153_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_153_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_153_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_153_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_153_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_153_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_153_io_out_1_bits)
  );
  sub_crossbar_154 sub_crossbar_154 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_154_clock),
    .reset(sub_crossbar_154_reset),
    .io_in_0_ready(sub_crossbar_154_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_154_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_154_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_154_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_154_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_154_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_154_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_154_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_154_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_154_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_154_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_154_io_out_1_bits)
  );
  sub_crossbar_155 sub_crossbar_155 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_155_clock),
    .reset(sub_crossbar_155_reset),
    .io_in_0_ready(sub_crossbar_155_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_155_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_155_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_155_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_155_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_155_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_155_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_155_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_155_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_155_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_155_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_155_io_out_1_bits)
  );
  sub_crossbar_156 sub_crossbar_156 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_156_clock),
    .reset(sub_crossbar_156_reset),
    .io_in_0_ready(sub_crossbar_156_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_156_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_156_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_156_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_156_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_156_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_156_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_156_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_156_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_156_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_156_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_156_io_out_1_bits)
  );
  sub_crossbar_157 sub_crossbar_157 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_157_clock),
    .reset(sub_crossbar_157_reset),
    .io_in_0_ready(sub_crossbar_157_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_157_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_157_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_157_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_157_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_157_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_157_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_157_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_157_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_157_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_157_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_157_io_out_1_bits)
  );
  sub_crossbar_158 sub_crossbar_158 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_158_clock),
    .reset(sub_crossbar_158_reset),
    .io_in_0_ready(sub_crossbar_158_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_158_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_158_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_158_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_158_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_158_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_158_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_158_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_158_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_158_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_158_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_158_io_out_1_bits)
  );
  sub_crossbar_159 sub_crossbar_159 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_159_clock),
    .reset(sub_crossbar_159_reset),
    .io_in_0_ready(sub_crossbar_159_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_159_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_159_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_159_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_159_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_159_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_159_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_159_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_159_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_159_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_159_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_159_io_out_1_bits)
  );
  assign io_in_0_ready = sub_crossbar_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_1_ready = sub_crossbar_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_2_ready = sub_crossbar_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_3_ready = sub_crossbar_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_4_ready = sub_crossbar_3_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_5_ready = sub_crossbar_3_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_6_ready = sub_crossbar_3_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_7_ready = sub_crossbar_3_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_8_ready = sub_crossbar_6_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_9_ready = sub_crossbar_6_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_10_ready = sub_crossbar_6_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_11_ready = sub_crossbar_6_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_12_ready = sub_crossbar_9_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_13_ready = sub_crossbar_9_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_14_ready = sub_crossbar_9_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_15_ready = sub_crossbar_9_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_16_ready = sub_crossbar_12_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_17_ready = sub_crossbar_12_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_18_ready = sub_crossbar_12_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_19_ready = sub_crossbar_12_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_20_ready = sub_crossbar_15_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_21_ready = sub_crossbar_15_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_22_ready = sub_crossbar_15_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_23_ready = sub_crossbar_15_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_24_ready = sub_crossbar_18_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_25_ready = sub_crossbar_18_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_26_ready = sub_crossbar_18_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_27_ready = sub_crossbar_18_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_28_ready = sub_crossbar_21_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_29_ready = sub_crossbar_21_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_30_ready = sub_crossbar_21_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_31_ready = sub_crossbar_21_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_32_ready = sub_crossbar_24_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_33_ready = sub_crossbar_24_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_34_ready = sub_crossbar_24_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_35_ready = sub_crossbar_24_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_36_ready = sub_crossbar_27_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_37_ready = sub_crossbar_27_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_38_ready = sub_crossbar_27_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_39_ready = sub_crossbar_27_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_40_ready = sub_crossbar_30_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_41_ready = sub_crossbar_30_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_42_ready = sub_crossbar_30_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_43_ready = sub_crossbar_30_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_44_ready = sub_crossbar_33_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_45_ready = sub_crossbar_33_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_46_ready = sub_crossbar_33_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_47_ready = sub_crossbar_33_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_48_ready = sub_crossbar_36_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_49_ready = sub_crossbar_36_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_50_ready = sub_crossbar_36_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_51_ready = sub_crossbar_36_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_52_ready = sub_crossbar_39_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_53_ready = sub_crossbar_39_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_54_ready = sub_crossbar_39_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_55_ready = sub_crossbar_39_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_56_ready = sub_crossbar_42_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_57_ready = sub_crossbar_42_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_58_ready = sub_crossbar_42_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_59_ready = sub_crossbar_42_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_60_ready = sub_crossbar_45_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_61_ready = sub_crossbar_45_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_62_ready = sub_crossbar_45_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_63_ready = sub_crossbar_45_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_64_ready = sub_crossbar_48_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_65_ready = sub_crossbar_48_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_66_ready = sub_crossbar_48_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_67_ready = sub_crossbar_48_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_68_ready = sub_crossbar_51_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_69_ready = sub_crossbar_51_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_70_ready = sub_crossbar_51_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_71_ready = sub_crossbar_51_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_72_ready = sub_crossbar_54_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_73_ready = sub_crossbar_54_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_74_ready = sub_crossbar_54_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_75_ready = sub_crossbar_54_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_76_ready = sub_crossbar_57_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_77_ready = sub_crossbar_57_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_78_ready = sub_crossbar_57_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_79_ready = sub_crossbar_57_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_80_ready = sub_crossbar_60_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_81_ready = sub_crossbar_60_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_82_ready = sub_crossbar_60_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_83_ready = sub_crossbar_60_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_84_ready = sub_crossbar_63_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_85_ready = sub_crossbar_63_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_86_ready = sub_crossbar_63_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_87_ready = sub_crossbar_63_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_88_ready = sub_crossbar_66_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_89_ready = sub_crossbar_66_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_90_ready = sub_crossbar_66_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_91_ready = sub_crossbar_66_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_92_ready = sub_crossbar_69_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_93_ready = sub_crossbar_69_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_94_ready = sub_crossbar_69_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_95_ready = sub_crossbar_69_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_96_ready = sub_crossbar_72_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_97_ready = sub_crossbar_72_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_98_ready = sub_crossbar_72_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_99_ready = sub_crossbar_72_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_100_ready = sub_crossbar_75_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_101_ready = sub_crossbar_75_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_102_ready = sub_crossbar_75_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_103_ready = sub_crossbar_75_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_104_ready = sub_crossbar_78_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_105_ready = sub_crossbar_78_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_106_ready = sub_crossbar_78_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_107_ready = sub_crossbar_78_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_108_ready = sub_crossbar_81_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_109_ready = sub_crossbar_81_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_110_ready = sub_crossbar_81_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_111_ready = sub_crossbar_81_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_112_ready = sub_crossbar_84_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_113_ready = sub_crossbar_84_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_114_ready = sub_crossbar_84_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_115_ready = sub_crossbar_84_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_116_ready = sub_crossbar_87_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_117_ready = sub_crossbar_87_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_118_ready = sub_crossbar_87_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_119_ready = sub_crossbar_87_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_120_ready = sub_crossbar_90_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_121_ready = sub_crossbar_90_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_122_ready = sub_crossbar_90_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_123_ready = sub_crossbar_90_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_124_ready = sub_crossbar_93_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_125_ready = sub_crossbar_93_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_126_ready = sub_crossbar_93_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_127_ready = sub_crossbar_93_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_out_0_valid = sub_crossbar_96_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_0_bits = sub_crossbar_96_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_1_valid = sub_crossbar_97_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_1_bits = sub_crossbar_97_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_2_valid = sub_crossbar_98_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_2_bits = sub_crossbar_98_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_3_valid = sub_crossbar_99_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_3_bits = sub_crossbar_99_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_4_valid = sub_crossbar_100_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_4_bits = sub_crossbar_100_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_5_valid = sub_crossbar_101_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_5_bits = sub_crossbar_101_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_6_valid = sub_crossbar_102_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_6_bits = sub_crossbar_102_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_7_valid = sub_crossbar_103_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_7_bits = sub_crossbar_103_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_8_valid = sub_crossbar_104_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_8_bits = sub_crossbar_104_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_9_valid = sub_crossbar_105_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_9_bits = sub_crossbar_105_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_10_valid = sub_crossbar_106_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_10_bits = sub_crossbar_106_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_11_valid = sub_crossbar_107_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_11_bits = sub_crossbar_107_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_12_valid = sub_crossbar_108_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_12_bits = sub_crossbar_108_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_13_valid = sub_crossbar_109_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_13_bits = sub_crossbar_109_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_14_valid = sub_crossbar_110_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_14_bits = sub_crossbar_110_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_15_valid = sub_crossbar_111_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_15_bits = sub_crossbar_111_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_16_valid = sub_crossbar_112_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_16_bits = sub_crossbar_112_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_17_valid = sub_crossbar_113_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_17_bits = sub_crossbar_113_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_18_valid = sub_crossbar_114_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_18_bits = sub_crossbar_114_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_19_valid = sub_crossbar_115_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_19_bits = sub_crossbar_115_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_20_valid = sub_crossbar_116_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_20_bits = sub_crossbar_116_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_21_valid = sub_crossbar_117_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_21_bits = sub_crossbar_117_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_22_valid = sub_crossbar_118_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_22_bits = sub_crossbar_118_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_23_valid = sub_crossbar_119_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_23_bits = sub_crossbar_119_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_24_valid = sub_crossbar_120_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_24_bits = sub_crossbar_120_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_25_valid = sub_crossbar_121_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_25_bits = sub_crossbar_121_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_26_valid = sub_crossbar_122_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_26_bits = sub_crossbar_122_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_27_valid = sub_crossbar_123_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_27_bits = sub_crossbar_123_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_28_valid = sub_crossbar_124_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_28_bits = sub_crossbar_124_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_29_valid = sub_crossbar_125_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_29_bits = sub_crossbar_125_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_30_valid = sub_crossbar_126_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_30_bits = sub_crossbar_126_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_31_valid = sub_crossbar_127_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_31_bits = sub_crossbar_127_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_32_valid = sub_crossbar_128_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_32_bits = sub_crossbar_128_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_33_valid = sub_crossbar_129_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_33_bits = sub_crossbar_129_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_34_valid = sub_crossbar_130_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_34_bits = sub_crossbar_130_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_35_valid = sub_crossbar_131_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_35_bits = sub_crossbar_131_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_36_valid = sub_crossbar_132_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_36_bits = sub_crossbar_132_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_37_valid = sub_crossbar_133_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_37_bits = sub_crossbar_133_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_38_valid = sub_crossbar_134_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_38_bits = sub_crossbar_134_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_39_valid = sub_crossbar_135_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_39_bits = sub_crossbar_135_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_40_valid = sub_crossbar_136_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_40_bits = sub_crossbar_136_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_41_valid = sub_crossbar_137_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_41_bits = sub_crossbar_137_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_42_valid = sub_crossbar_138_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_42_bits = sub_crossbar_138_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_43_valid = sub_crossbar_139_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_43_bits = sub_crossbar_139_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_44_valid = sub_crossbar_140_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_44_bits = sub_crossbar_140_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_45_valid = sub_crossbar_141_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_45_bits = sub_crossbar_141_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_46_valid = sub_crossbar_142_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_46_bits = sub_crossbar_142_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_47_valid = sub_crossbar_143_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_47_bits = sub_crossbar_143_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_48_valid = sub_crossbar_144_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_48_bits = sub_crossbar_144_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_49_valid = sub_crossbar_145_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_49_bits = sub_crossbar_145_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_50_valid = sub_crossbar_146_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_50_bits = sub_crossbar_146_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_51_valid = sub_crossbar_147_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_51_bits = sub_crossbar_147_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_52_valid = sub_crossbar_148_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_52_bits = sub_crossbar_148_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_53_valid = sub_crossbar_149_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_53_bits = sub_crossbar_149_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_54_valid = sub_crossbar_150_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_54_bits = sub_crossbar_150_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_55_valid = sub_crossbar_151_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_55_bits = sub_crossbar_151_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_56_valid = sub_crossbar_152_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_56_bits = sub_crossbar_152_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_57_valid = sub_crossbar_153_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_57_bits = sub_crossbar_153_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_58_valid = sub_crossbar_154_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_58_bits = sub_crossbar_154_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_59_valid = sub_crossbar_155_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_59_bits = sub_crossbar_155_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_60_valid = sub_crossbar_156_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_60_bits = sub_crossbar_156_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_61_valid = sub_crossbar_157_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_61_bits = sub_crossbar_157_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_62_valid = sub_crossbar_158_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_62_bits = sub_crossbar_158_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_63_valid = sub_crossbar_159_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_63_bits = sub_crossbar_159_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_64_valid = sub_crossbar_96_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_64_bits = sub_crossbar_96_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_65_valid = sub_crossbar_97_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_65_bits = sub_crossbar_97_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_66_valid = sub_crossbar_98_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_66_bits = sub_crossbar_98_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_67_valid = sub_crossbar_99_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_67_bits = sub_crossbar_99_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_68_valid = sub_crossbar_100_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_68_bits = sub_crossbar_100_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_69_valid = sub_crossbar_101_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_69_bits = sub_crossbar_101_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_70_valid = sub_crossbar_102_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_70_bits = sub_crossbar_102_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_71_valid = sub_crossbar_103_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_71_bits = sub_crossbar_103_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_72_valid = sub_crossbar_104_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_72_bits = sub_crossbar_104_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_73_valid = sub_crossbar_105_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_73_bits = sub_crossbar_105_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_74_valid = sub_crossbar_106_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_74_bits = sub_crossbar_106_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_75_valid = sub_crossbar_107_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_75_bits = sub_crossbar_107_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_76_valid = sub_crossbar_108_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_76_bits = sub_crossbar_108_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_77_valid = sub_crossbar_109_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_77_bits = sub_crossbar_109_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_78_valid = sub_crossbar_110_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_78_bits = sub_crossbar_110_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_79_valid = sub_crossbar_111_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_79_bits = sub_crossbar_111_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_80_valid = sub_crossbar_112_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_80_bits = sub_crossbar_112_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_81_valid = sub_crossbar_113_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_81_bits = sub_crossbar_113_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_82_valid = sub_crossbar_114_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_82_bits = sub_crossbar_114_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_83_valid = sub_crossbar_115_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_83_bits = sub_crossbar_115_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_84_valid = sub_crossbar_116_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_84_bits = sub_crossbar_116_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_85_valid = sub_crossbar_117_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_85_bits = sub_crossbar_117_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_86_valid = sub_crossbar_118_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_86_bits = sub_crossbar_118_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_87_valid = sub_crossbar_119_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_87_bits = sub_crossbar_119_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_88_valid = sub_crossbar_120_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_88_bits = sub_crossbar_120_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_89_valid = sub_crossbar_121_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_89_bits = sub_crossbar_121_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_90_valid = sub_crossbar_122_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_90_bits = sub_crossbar_122_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_91_valid = sub_crossbar_123_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_91_bits = sub_crossbar_123_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_92_valid = sub_crossbar_124_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_92_bits = sub_crossbar_124_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_93_valid = sub_crossbar_125_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_93_bits = sub_crossbar_125_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_94_valid = sub_crossbar_126_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_94_bits = sub_crossbar_126_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_95_valid = sub_crossbar_127_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_95_bits = sub_crossbar_127_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_96_valid = sub_crossbar_128_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_96_bits = sub_crossbar_128_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_97_valid = sub_crossbar_129_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_97_bits = sub_crossbar_129_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_98_valid = sub_crossbar_130_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_98_bits = sub_crossbar_130_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_99_valid = sub_crossbar_131_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_99_bits = sub_crossbar_131_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_100_valid = sub_crossbar_132_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_100_bits = sub_crossbar_132_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_101_valid = sub_crossbar_133_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_101_bits = sub_crossbar_133_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_102_valid = sub_crossbar_134_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_102_bits = sub_crossbar_134_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_103_valid = sub_crossbar_135_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_103_bits = sub_crossbar_135_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_104_valid = sub_crossbar_136_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_104_bits = sub_crossbar_136_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_105_valid = sub_crossbar_137_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_105_bits = sub_crossbar_137_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_106_valid = sub_crossbar_138_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_106_bits = sub_crossbar_138_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_107_valid = sub_crossbar_139_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_107_bits = sub_crossbar_139_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_108_valid = sub_crossbar_140_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_108_bits = sub_crossbar_140_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_109_valid = sub_crossbar_141_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_109_bits = sub_crossbar_141_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_110_valid = sub_crossbar_142_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_110_bits = sub_crossbar_142_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_111_valid = sub_crossbar_143_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_111_bits = sub_crossbar_143_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_112_valid = sub_crossbar_144_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_112_bits = sub_crossbar_144_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_113_valid = sub_crossbar_145_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_113_bits = sub_crossbar_145_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_114_valid = sub_crossbar_146_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_114_bits = sub_crossbar_146_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_115_valid = sub_crossbar_147_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_115_bits = sub_crossbar_147_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_116_valid = sub_crossbar_148_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_116_bits = sub_crossbar_148_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_117_valid = sub_crossbar_149_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_117_bits = sub_crossbar_149_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_118_valid = sub_crossbar_150_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_118_bits = sub_crossbar_150_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_119_valid = sub_crossbar_151_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_119_bits = sub_crossbar_151_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_120_valid = sub_crossbar_152_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_120_bits = sub_crossbar_152_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_121_valid = sub_crossbar_153_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_121_bits = sub_crossbar_153_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_122_valid = sub_crossbar_154_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_122_bits = sub_crossbar_154_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_123_valid = sub_crossbar_155_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_123_bits = sub_crossbar_155_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_124_valid = sub_crossbar_156_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_124_bits = sub_crossbar_156_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_125_valid = sub_crossbar_157_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_125_bits = sub_crossbar_157_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_126_valid = sub_crossbar_158_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_126_bits = sub_crossbar_158_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_127_valid = sub_crossbar_159_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_127_bits = sub_crossbar_159_io_out_1_bits; // @[crossbar.scala 152:53]
  assign sub_crossbar_clock = clock;
  assign sub_crossbar_reset = reset;
  assign sub_crossbar_io_in_0_valid = io_in_0_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_0_bits = io_in_0_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_1_valid = io_in_1_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_1_bits = io_in_1_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_2_valid = io_in_2_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_2_bits = io_in_2_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_3_valid = io_in_3_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_3_bits = io_in_3_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_out_0_ready = sub_crossbar_1_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_1_ready = sub_crossbar_4_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_2_ready = sub_crossbar_7_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_3_ready = sub_crossbar_10_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_clock = clock;
  assign sub_crossbar_1_reset = reset;
  assign sub_crossbar_1_io_in_0_valid = sub_crossbar_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_0_bits = sub_crossbar_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_1_valid = sub_crossbar_3_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_1_bits = sub_crossbar_3_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_2_valid = sub_crossbar_6_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_2_bits = sub_crossbar_6_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_3_valid = sub_crossbar_9_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_3_bits = sub_crossbar_9_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_out_0_ready = sub_crossbar_2_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_1_ready = sub_crossbar_14_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_2_ready = sub_crossbar_26_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_3_ready = sub_crossbar_38_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_clock = clock;
  assign sub_crossbar_2_reset = reset;
  assign sub_crossbar_2_io_in_0_valid = sub_crossbar_1_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_0_bits = sub_crossbar_1_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_1_valid = sub_crossbar_13_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_1_bits = sub_crossbar_13_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_2_valid = sub_crossbar_25_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_2_bits = sub_crossbar_25_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_3_valid = sub_crossbar_37_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_3_bits = sub_crossbar_37_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_out_0_ready = sub_crossbar_96_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_1_ready = sub_crossbar_112_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_2_ready = sub_crossbar_128_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_3_ready = sub_crossbar_144_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_3_clock = clock;
  assign sub_crossbar_3_reset = reset;
  assign sub_crossbar_3_io_in_0_valid = io_in_4_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_0_bits = io_in_4_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_1_valid = io_in_5_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_1_bits = io_in_5_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_2_valid = io_in_6_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_2_bits = io_in_6_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_3_valid = io_in_7_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_3_bits = io_in_7_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_out_0_ready = sub_crossbar_1_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_1_ready = sub_crossbar_4_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_2_ready = sub_crossbar_7_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_3_ready = sub_crossbar_10_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_clock = clock;
  assign sub_crossbar_4_reset = reset;
  assign sub_crossbar_4_io_in_0_valid = sub_crossbar_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_0_bits = sub_crossbar_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_1_valid = sub_crossbar_3_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_1_bits = sub_crossbar_3_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_2_valid = sub_crossbar_6_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_2_bits = sub_crossbar_6_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_3_valid = sub_crossbar_9_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_3_bits = sub_crossbar_9_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_out_0_ready = sub_crossbar_5_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_1_ready = sub_crossbar_17_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_2_ready = sub_crossbar_29_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_3_ready = sub_crossbar_41_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_clock = clock;
  assign sub_crossbar_5_reset = reset;
  assign sub_crossbar_5_io_in_0_valid = sub_crossbar_4_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_0_bits = sub_crossbar_4_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_1_valid = sub_crossbar_16_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_1_bits = sub_crossbar_16_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_2_valid = sub_crossbar_28_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_2_bits = sub_crossbar_28_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_3_valid = sub_crossbar_40_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_3_bits = sub_crossbar_40_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_out_0_ready = sub_crossbar_97_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_1_ready = sub_crossbar_113_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_2_ready = sub_crossbar_129_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_3_ready = sub_crossbar_145_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_6_clock = clock;
  assign sub_crossbar_6_reset = reset;
  assign sub_crossbar_6_io_in_0_valid = io_in_8_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_0_bits = io_in_8_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_1_valid = io_in_9_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_1_bits = io_in_9_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_2_valid = io_in_10_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_2_bits = io_in_10_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_3_valid = io_in_11_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_3_bits = io_in_11_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_out_0_ready = sub_crossbar_1_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_1_ready = sub_crossbar_4_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_2_ready = sub_crossbar_7_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_3_ready = sub_crossbar_10_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_clock = clock;
  assign sub_crossbar_7_reset = reset;
  assign sub_crossbar_7_io_in_0_valid = sub_crossbar_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_0_bits = sub_crossbar_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_1_valid = sub_crossbar_3_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_1_bits = sub_crossbar_3_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_2_valid = sub_crossbar_6_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_2_bits = sub_crossbar_6_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_3_valid = sub_crossbar_9_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_3_bits = sub_crossbar_9_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_out_0_ready = sub_crossbar_8_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_1_ready = sub_crossbar_20_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_2_ready = sub_crossbar_32_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_3_ready = sub_crossbar_44_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_clock = clock;
  assign sub_crossbar_8_reset = reset;
  assign sub_crossbar_8_io_in_0_valid = sub_crossbar_7_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_0_bits = sub_crossbar_7_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_1_valid = sub_crossbar_19_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_1_bits = sub_crossbar_19_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_2_valid = sub_crossbar_31_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_2_bits = sub_crossbar_31_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_3_valid = sub_crossbar_43_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_3_bits = sub_crossbar_43_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_out_0_ready = sub_crossbar_98_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_1_ready = sub_crossbar_114_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_2_ready = sub_crossbar_130_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_3_ready = sub_crossbar_146_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_9_clock = clock;
  assign sub_crossbar_9_reset = reset;
  assign sub_crossbar_9_io_in_0_valid = io_in_12_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_0_bits = io_in_12_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_1_valid = io_in_13_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_1_bits = io_in_13_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_2_valid = io_in_14_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_2_bits = io_in_14_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_3_valid = io_in_15_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_3_bits = io_in_15_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_out_0_ready = sub_crossbar_1_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_1_ready = sub_crossbar_4_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_2_ready = sub_crossbar_7_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_3_ready = sub_crossbar_10_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_clock = clock;
  assign sub_crossbar_10_reset = reset;
  assign sub_crossbar_10_io_in_0_valid = sub_crossbar_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_0_bits = sub_crossbar_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_1_valid = sub_crossbar_3_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_1_bits = sub_crossbar_3_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_2_valid = sub_crossbar_6_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_2_bits = sub_crossbar_6_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_3_valid = sub_crossbar_9_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_3_bits = sub_crossbar_9_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_out_0_ready = sub_crossbar_11_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_1_ready = sub_crossbar_23_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_2_ready = sub_crossbar_35_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_3_ready = sub_crossbar_47_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_clock = clock;
  assign sub_crossbar_11_reset = reset;
  assign sub_crossbar_11_io_in_0_valid = sub_crossbar_10_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_0_bits = sub_crossbar_10_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_1_valid = sub_crossbar_22_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_1_bits = sub_crossbar_22_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_2_valid = sub_crossbar_34_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_2_bits = sub_crossbar_34_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_3_valid = sub_crossbar_46_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_3_bits = sub_crossbar_46_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_out_0_ready = sub_crossbar_99_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_1_ready = sub_crossbar_115_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_2_ready = sub_crossbar_131_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_3_ready = sub_crossbar_147_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_12_clock = clock;
  assign sub_crossbar_12_reset = reset;
  assign sub_crossbar_12_io_in_0_valid = io_in_16_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_0_bits = io_in_16_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_1_valid = io_in_17_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_1_bits = io_in_17_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_2_valid = io_in_18_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_2_bits = io_in_18_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_3_valid = io_in_19_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_3_bits = io_in_19_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_out_0_ready = sub_crossbar_13_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_1_ready = sub_crossbar_16_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_2_ready = sub_crossbar_19_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_3_ready = sub_crossbar_22_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_clock = clock;
  assign sub_crossbar_13_reset = reset;
  assign sub_crossbar_13_io_in_0_valid = sub_crossbar_12_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_0_bits = sub_crossbar_12_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_1_valid = sub_crossbar_15_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_1_bits = sub_crossbar_15_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_2_valid = sub_crossbar_18_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_2_bits = sub_crossbar_18_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_3_valid = sub_crossbar_21_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_3_bits = sub_crossbar_21_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_out_0_ready = sub_crossbar_2_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_1_ready = sub_crossbar_14_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_2_ready = sub_crossbar_26_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_3_ready = sub_crossbar_38_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_clock = clock;
  assign sub_crossbar_14_reset = reset;
  assign sub_crossbar_14_io_in_0_valid = sub_crossbar_1_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_0_bits = sub_crossbar_1_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_1_valid = sub_crossbar_13_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_1_bits = sub_crossbar_13_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_2_valid = sub_crossbar_25_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_2_bits = sub_crossbar_25_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_3_valid = sub_crossbar_37_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_3_bits = sub_crossbar_37_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_out_0_ready = sub_crossbar_100_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_1_ready = sub_crossbar_116_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_2_ready = sub_crossbar_132_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_3_ready = sub_crossbar_148_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_15_clock = clock;
  assign sub_crossbar_15_reset = reset;
  assign sub_crossbar_15_io_in_0_valid = io_in_20_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_0_bits = io_in_20_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_1_valid = io_in_21_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_1_bits = io_in_21_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_2_valid = io_in_22_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_2_bits = io_in_22_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_3_valid = io_in_23_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_3_bits = io_in_23_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_out_0_ready = sub_crossbar_13_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_1_ready = sub_crossbar_16_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_2_ready = sub_crossbar_19_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_3_ready = sub_crossbar_22_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_clock = clock;
  assign sub_crossbar_16_reset = reset;
  assign sub_crossbar_16_io_in_0_valid = sub_crossbar_12_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_0_bits = sub_crossbar_12_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_1_valid = sub_crossbar_15_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_1_bits = sub_crossbar_15_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_2_valid = sub_crossbar_18_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_2_bits = sub_crossbar_18_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_3_valid = sub_crossbar_21_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_3_bits = sub_crossbar_21_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_out_0_ready = sub_crossbar_5_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_1_ready = sub_crossbar_17_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_2_ready = sub_crossbar_29_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_3_ready = sub_crossbar_41_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_clock = clock;
  assign sub_crossbar_17_reset = reset;
  assign sub_crossbar_17_io_in_0_valid = sub_crossbar_4_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_0_bits = sub_crossbar_4_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_1_valid = sub_crossbar_16_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_1_bits = sub_crossbar_16_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_2_valid = sub_crossbar_28_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_2_bits = sub_crossbar_28_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_3_valid = sub_crossbar_40_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_3_bits = sub_crossbar_40_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_out_0_ready = sub_crossbar_101_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_1_ready = sub_crossbar_117_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_2_ready = sub_crossbar_133_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_3_ready = sub_crossbar_149_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_18_clock = clock;
  assign sub_crossbar_18_reset = reset;
  assign sub_crossbar_18_io_in_0_valid = io_in_24_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_0_bits = io_in_24_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_1_valid = io_in_25_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_1_bits = io_in_25_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_2_valid = io_in_26_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_2_bits = io_in_26_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_3_valid = io_in_27_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_3_bits = io_in_27_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_out_0_ready = sub_crossbar_13_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_1_ready = sub_crossbar_16_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_2_ready = sub_crossbar_19_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_3_ready = sub_crossbar_22_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_clock = clock;
  assign sub_crossbar_19_reset = reset;
  assign sub_crossbar_19_io_in_0_valid = sub_crossbar_12_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_0_bits = sub_crossbar_12_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_1_valid = sub_crossbar_15_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_1_bits = sub_crossbar_15_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_2_valid = sub_crossbar_18_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_2_bits = sub_crossbar_18_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_3_valid = sub_crossbar_21_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_3_bits = sub_crossbar_21_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_out_0_ready = sub_crossbar_8_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_1_ready = sub_crossbar_20_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_2_ready = sub_crossbar_32_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_3_ready = sub_crossbar_44_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_clock = clock;
  assign sub_crossbar_20_reset = reset;
  assign sub_crossbar_20_io_in_0_valid = sub_crossbar_7_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_0_bits = sub_crossbar_7_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_1_valid = sub_crossbar_19_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_1_bits = sub_crossbar_19_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_2_valid = sub_crossbar_31_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_2_bits = sub_crossbar_31_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_3_valid = sub_crossbar_43_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_3_bits = sub_crossbar_43_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_out_0_ready = sub_crossbar_102_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_1_ready = sub_crossbar_118_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_2_ready = sub_crossbar_134_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_3_ready = sub_crossbar_150_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_21_clock = clock;
  assign sub_crossbar_21_reset = reset;
  assign sub_crossbar_21_io_in_0_valid = io_in_28_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_0_bits = io_in_28_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_1_valid = io_in_29_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_1_bits = io_in_29_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_2_valid = io_in_30_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_2_bits = io_in_30_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_3_valid = io_in_31_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_3_bits = io_in_31_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_out_0_ready = sub_crossbar_13_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_1_ready = sub_crossbar_16_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_2_ready = sub_crossbar_19_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_3_ready = sub_crossbar_22_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_clock = clock;
  assign sub_crossbar_22_reset = reset;
  assign sub_crossbar_22_io_in_0_valid = sub_crossbar_12_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_0_bits = sub_crossbar_12_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_1_valid = sub_crossbar_15_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_1_bits = sub_crossbar_15_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_2_valid = sub_crossbar_18_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_2_bits = sub_crossbar_18_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_3_valid = sub_crossbar_21_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_3_bits = sub_crossbar_21_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_out_0_ready = sub_crossbar_11_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_1_ready = sub_crossbar_23_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_2_ready = sub_crossbar_35_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_3_ready = sub_crossbar_47_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_clock = clock;
  assign sub_crossbar_23_reset = reset;
  assign sub_crossbar_23_io_in_0_valid = sub_crossbar_10_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_0_bits = sub_crossbar_10_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_1_valid = sub_crossbar_22_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_1_bits = sub_crossbar_22_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_2_valid = sub_crossbar_34_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_2_bits = sub_crossbar_34_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_3_valid = sub_crossbar_46_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_3_bits = sub_crossbar_46_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_out_0_ready = sub_crossbar_103_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_1_ready = sub_crossbar_119_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_2_ready = sub_crossbar_135_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_3_ready = sub_crossbar_151_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_24_clock = clock;
  assign sub_crossbar_24_reset = reset;
  assign sub_crossbar_24_io_in_0_valid = io_in_32_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_0_bits = io_in_32_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_1_valid = io_in_33_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_1_bits = io_in_33_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_2_valid = io_in_34_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_2_bits = io_in_34_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_3_valid = io_in_35_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_3_bits = io_in_35_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_out_0_ready = sub_crossbar_25_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_1_ready = sub_crossbar_28_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_2_ready = sub_crossbar_31_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_3_ready = sub_crossbar_34_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_clock = clock;
  assign sub_crossbar_25_reset = reset;
  assign sub_crossbar_25_io_in_0_valid = sub_crossbar_24_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_0_bits = sub_crossbar_24_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_1_valid = sub_crossbar_27_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_1_bits = sub_crossbar_27_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_2_valid = sub_crossbar_30_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_2_bits = sub_crossbar_30_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_3_valid = sub_crossbar_33_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_3_bits = sub_crossbar_33_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_out_0_ready = sub_crossbar_2_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_1_ready = sub_crossbar_14_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_2_ready = sub_crossbar_26_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_3_ready = sub_crossbar_38_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_clock = clock;
  assign sub_crossbar_26_reset = reset;
  assign sub_crossbar_26_io_in_0_valid = sub_crossbar_1_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_0_bits = sub_crossbar_1_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_1_valid = sub_crossbar_13_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_1_bits = sub_crossbar_13_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_2_valid = sub_crossbar_25_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_2_bits = sub_crossbar_25_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_3_valid = sub_crossbar_37_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_3_bits = sub_crossbar_37_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_out_0_ready = sub_crossbar_104_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_1_ready = sub_crossbar_120_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_2_ready = sub_crossbar_136_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_3_ready = sub_crossbar_152_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_27_clock = clock;
  assign sub_crossbar_27_reset = reset;
  assign sub_crossbar_27_io_in_0_valid = io_in_36_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_0_bits = io_in_36_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_1_valid = io_in_37_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_1_bits = io_in_37_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_2_valid = io_in_38_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_2_bits = io_in_38_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_3_valid = io_in_39_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_3_bits = io_in_39_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_out_0_ready = sub_crossbar_25_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_1_ready = sub_crossbar_28_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_2_ready = sub_crossbar_31_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_3_ready = sub_crossbar_34_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_clock = clock;
  assign sub_crossbar_28_reset = reset;
  assign sub_crossbar_28_io_in_0_valid = sub_crossbar_24_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_0_bits = sub_crossbar_24_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_1_valid = sub_crossbar_27_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_1_bits = sub_crossbar_27_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_2_valid = sub_crossbar_30_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_2_bits = sub_crossbar_30_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_3_valid = sub_crossbar_33_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_3_bits = sub_crossbar_33_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_out_0_ready = sub_crossbar_5_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_1_ready = sub_crossbar_17_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_2_ready = sub_crossbar_29_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_3_ready = sub_crossbar_41_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_clock = clock;
  assign sub_crossbar_29_reset = reset;
  assign sub_crossbar_29_io_in_0_valid = sub_crossbar_4_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_0_bits = sub_crossbar_4_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_1_valid = sub_crossbar_16_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_1_bits = sub_crossbar_16_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_2_valid = sub_crossbar_28_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_2_bits = sub_crossbar_28_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_3_valid = sub_crossbar_40_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_3_bits = sub_crossbar_40_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_out_0_ready = sub_crossbar_105_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_1_ready = sub_crossbar_121_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_2_ready = sub_crossbar_137_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_3_ready = sub_crossbar_153_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_30_clock = clock;
  assign sub_crossbar_30_reset = reset;
  assign sub_crossbar_30_io_in_0_valid = io_in_40_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_0_bits = io_in_40_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_1_valid = io_in_41_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_1_bits = io_in_41_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_2_valid = io_in_42_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_2_bits = io_in_42_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_3_valid = io_in_43_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_3_bits = io_in_43_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_out_0_ready = sub_crossbar_25_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_1_ready = sub_crossbar_28_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_2_ready = sub_crossbar_31_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_3_ready = sub_crossbar_34_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_clock = clock;
  assign sub_crossbar_31_reset = reset;
  assign sub_crossbar_31_io_in_0_valid = sub_crossbar_24_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_0_bits = sub_crossbar_24_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_1_valid = sub_crossbar_27_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_1_bits = sub_crossbar_27_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_2_valid = sub_crossbar_30_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_2_bits = sub_crossbar_30_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_3_valid = sub_crossbar_33_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_3_bits = sub_crossbar_33_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_out_0_ready = sub_crossbar_8_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_1_ready = sub_crossbar_20_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_2_ready = sub_crossbar_32_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_3_ready = sub_crossbar_44_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_clock = clock;
  assign sub_crossbar_32_reset = reset;
  assign sub_crossbar_32_io_in_0_valid = sub_crossbar_7_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_0_bits = sub_crossbar_7_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_1_valid = sub_crossbar_19_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_1_bits = sub_crossbar_19_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_2_valid = sub_crossbar_31_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_2_bits = sub_crossbar_31_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_3_valid = sub_crossbar_43_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_3_bits = sub_crossbar_43_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_out_0_ready = sub_crossbar_106_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_1_ready = sub_crossbar_122_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_2_ready = sub_crossbar_138_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_3_ready = sub_crossbar_154_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_33_clock = clock;
  assign sub_crossbar_33_reset = reset;
  assign sub_crossbar_33_io_in_0_valid = io_in_44_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_0_bits = io_in_44_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_1_valid = io_in_45_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_1_bits = io_in_45_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_2_valid = io_in_46_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_2_bits = io_in_46_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_3_valid = io_in_47_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_3_bits = io_in_47_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_out_0_ready = sub_crossbar_25_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_1_ready = sub_crossbar_28_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_2_ready = sub_crossbar_31_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_3_ready = sub_crossbar_34_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_clock = clock;
  assign sub_crossbar_34_reset = reset;
  assign sub_crossbar_34_io_in_0_valid = sub_crossbar_24_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_0_bits = sub_crossbar_24_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_1_valid = sub_crossbar_27_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_1_bits = sub_crossbar_27_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_2_valid = sub_crossbar_30_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_2_bits = sub_crossbar_30_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_3_valid = sub_crossbar_33_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_3_bits = sub_crossbar_33_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_out_0_ready = sub_crossbar_11_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_1_ready = sub_crossbar_23_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_2_ready = sub_crossbar_35_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_3_ready = sub_crossbar_47_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_clock = clock;
  assign sub_crossbar_35_reset = reset;
  assign sub_crossbar_35_io_in_0_valid = sub_crossbar_10_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_0_bits = sub_crossbar_10_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_1_valid = sub_crossbar_22_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_1_bits = sub_crossbar_22_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_2_valid = sub_crossbar_34_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_2_bits = sub_crossbar_34_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_3_valid = sub_crossbar_46_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_3_bits = sub_crossbar_46_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_out_0_ready = sub_crossbar_107_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_1_ready = sub_crossbar_123_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_2_ready = sub_crossbar_139_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_3_ready = sub_crossbar_155_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_36_clock = clock;
  assign sub_crossbar_36_reset = reset;
  assign sub_crossbar_36_io_in_0_valid = io_in_48_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_0_bits = io_in_48_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_1_valid = io_in_49_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_1_bits = io_in_49_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_2_valid = io_in_50_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_2_bits = io_in_50_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_3_valid = io_in_51_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_3_bits = io_in_51_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_out_0_ready = sub_crossbar_37_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_1_ready = sub_crossbar_40_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_2_ready = sub_crossbar_43_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_3_ready = sub_crossbar_46_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_clock = clock;
  assign sub_crossbar_37_reset = reset;
  assign sub_crossbar_37_io_in_0_valid = sub_crossbar_36_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_0_bits = sub_crossbar_36_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_1_valid = sub_crossbar_39_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_1_bits = sub_crossbar_39_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_2_valid = sub_crossbar_42_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_2_bits = sub_crossbar_42_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_3_valid = sub_crossbar_45_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_3_bits = sub_crossbar_45_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_out_0_ready = sub_crossbar_2_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_1_ready = sub_crossbar_14_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_2_ready = sub_crossbar_26_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_3_ready = sub_crossbar_38_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_clock = clock;
  assign sub_crossbar_38_reset = reset;
  assign sub_crossbar_38_io_in_0_valid = sub_crossbar_1_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_0_bits = sub_crossbar_1_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_1_valid = sub_crossbar_13_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_1_bits = sub_crossbar_13_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_2_valid = sub_crossbar_25_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_2_bits = sub_crossbar_25_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_3_valid = sub_crossbar_37_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_3_bits = sub_crossbar_37_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_out_0_ready = sub_crossbar_108_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_1_ready = sub_crossbar_124_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_2_ready = sub_crossbar_140_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_3_ready = sub_crossbar_156_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_39_clock = clock;
  assign sub_crossbar_39_reset = reset;
  assign sub_crossbar_39_io_in_0_valid = io_in_52_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_0_bits = io_in_52_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_1_valid = io_in_53_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_1_bits = io_in_53_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_2_valid = io_in_54_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_2_bits = io_in_54_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_3_valid = io_in_55_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_3_bits = io_in_55_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_out_0_ready = sub_crossbar_37_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_1_ready = sub_crossbar_40_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_2_ready = sub_crossbar_43_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_3_ready = sub_crossbar_46_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_clock = clock;
  assign sub_crossbar_40_reset = reset;
  assign sub_crossbar_40_io_in_0_valid = sub_crossbar_36_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_0_bits = sub_crossbar_36_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_1_valid = sub_crossbar_39_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_1_bits = sub_crossbar_39_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_2_valid = sub_crossbar_42_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_2_bits = sub_crossbar_42_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_3_valid = sub_crossbar_45_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_3_bits = sub_crossbar_45_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_out_0_ready = sub_crossbar_5_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_1_ready = sub_crossbar_17_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_2_ready = sub_crossbar_29_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_3_ready = sub_crossbar_41_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_clock = clock;
  assign sub_crossbar_41_reset = reset;
  assign sub_crossbar_41_io_in_0_valid = sub_crossbar_4_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_0_bits = sub_crossbar_4_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_1_valid = sub_crossbar_16_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_1_bits = sub_crossbar_16_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_2_valid = sub_crossbar_28_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_2_bits = sub_crossbar_28_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_3_valid = sub_crossbar_40_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_3_bits = sub_crossbar_40_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_out_0_ready = sub_crossbar_109_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_1_ready = sub_crossbar_125_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_2_ready = sub_crossbar_141_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_3_ready = sub_crossbar_157_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_42_clock = clock;
  assign sub_crossbar_42_reset = reset;
  assign sub_crossbar_42_io_in_0_valid = io_in_56_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_0_bits = io_in_56_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_1_valid = io_in_57_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_1_bits = io_in_57_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_2_valid = io_in_58_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_2_bits = io_in_58_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_3_valid = io_in_59_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_3_bits = io_in_59_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_out_0_ready = sub_crossbar_37_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_1_ready = sub_crossbar_40_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_2_ready = sub_crossbar_43_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_3_ready = sub_crossbar_46_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_clock = clock;
  assign sub_crossbar_43_reset = reset;
  assign sub_crossbar_43_io_in_0_valid = sub_crossbar_36_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_0_bits = sub_crossbar_36_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_1_valid = sub_crossbar_39_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_1_bits = sub_crossbar_39_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_2_valid = sub_crossbar_42_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_2_bits = sub_crossbar_42_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_3_valid = sub_crossbar_45_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_3_bits = sub_crossbar_45_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_out_0_ready = sub_crossbar_8_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_1_ready = sub_crossbar_20_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_2_ready = sub_crossbar_32_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_3_ready = sub_crossbar_44_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_clock = clock;
  assign sub_crossbar_44_reset = reset;
  assign sub_crossbar_44_io_in_0_valid = sub_crossbar_7_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_0_bits = sub_crossbar_7_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_1_valid = sub_crossbar_19_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_1_bits = sub_crossbar_19_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_2_valid = sub_crossbar_31_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_2_bits = sub_crossbar_31_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_3_valid = sub_crossbar_43_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_3_bits = sub_crossbar_43_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_out_0_ready = sub_crossbar_110_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_1_ready = sub_crossbar_126_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_2_ready = sub_crossbar_142_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_3_ready = sub_crossbar_158_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_45_clock = clock;
  assign sub_crossbar_45_reset = reset;
  assign sub_crossbar_45_io_in_0_valid = io_in_60_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_0_bits = io_in_60_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_1_valid = io_in_61_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_1_bits = io_in_61_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_2_valid = io_in_62_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_2_bits = io_in_62_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_3_valid = io_in_63_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_3_bits = io_in_63_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_out_0_ready = sub_crossbar_37_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_1_ready = sub_crossbar_40_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_2_ready = sub_crossbar_43_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_3_ready = sub_crossbar_46_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_clock = clock;
  assign sub_crossbar_46_reset = reset;
  assign sub_crossbar_46_io_in_0_valid = sub_crossbar_36_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_0_bits = sub_crossbar_36_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_1_valid = sub_crossbar_39_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_1_bits = sub_crossbar_39_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_2_valid = sub_crossbar_42_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_2_bits = sub_crossbar_42_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_3_valid = sub_crossbar_45_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_3_bits = sub_crossbar_45_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_out_0_ready = sub_crossbar_11_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_1_ready = sub_crossbar_23_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_2_ready = sub_crossbar_35_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_3_ready = sub_crossbar_47_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_clock = clock;
  assign sub_crossbar_47_reset = reset;
  assign sub_crossbar_47_io_in_0_valid = sub_crossbar_10_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_0_bits = sub_crossbar_10_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_1_valid = sub_crossbar_22_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_1_bits = sub_crossbar_22_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_2_valid = sub_crossbar_34_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_2_bits = sub_crossbar_34_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_3_valid = sub_crossbar_46_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_3_bits = sub_crossbar_46_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_out_0_ready = sub_crossbar_111_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_1_ready = sub_crossbar_127_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_2_ready = sub_crossbar_143_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_3_ready = sub_crossbar_159_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_48_clock = clock;
  assign sub_crossbar_48_reset = reset;
  assign sub_crossbar_48_io_in_0_valid = io_in_64_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_0_bits = io_in_64_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_1_valid = io_in_65_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_1_bits = io_in_65_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_2_valid = io_in_66_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_2_bits = io_in_66_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_3_valid = io_in_67_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_3_bits = io_in_67_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_out_0_ready = sub_crossbar_49_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_1_ready = sub_crossbar_52_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_2_ready = sub_crossbar_55_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_3_ready = sub_crossbar_58_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_clock = clock;
  assign sub_crossbar_49_reset = reset;
  assign sub_crossbar_49_io_in_0_valid = sub_crossbar_48_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_0_bits = sub_crossbar_48_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_1_valid = sub_crossbar_51_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_1_bits = sub_crossbar_51_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_2_valid = sub_crossbar_54_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_2_bits = sub_crossbar_54_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_3_valid = sub_crossbar_57_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_3_bits = sub_crossbar_57_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_out_0_ready = sub_crossbar_50_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_1_ready = sub_crossbar_62_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_2_ready = sub_crossbar_74_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_3_ready = sub_crossbar_86_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_clock = clock;
  assign sub_crossbar_50_reset = reset;
  assign sub_crossbar_50_io_in_0_valid = sub_crossbar_49_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_0_bits = sub_crossbar_49_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_1_valid = sub_crossbar_61_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_1_bits = sub_crossbar_61_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_2_valid = sub_crossbar_73_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_2_bits = sub_crossbar_73_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_3_valid = sub_crossbar_85_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_3_bits = sub_crossbar_85_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_out_0_ready = sub_crossbar_96_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_1_ready = sub_crossbar_112_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_2_ready = sub_crossbar_128_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_3_ready = sub_crossbar_144_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_51_clock = clock;
  assign sub_crossbar_51_reset = reset;
  assign sub_crossbar_51_io_in_0_valid = io_in_68_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_0_bits = io_in_68_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_1_valid = io_in_69_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_1_bits = io_in_69_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_2_valid = io_in_70_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_2_bits = io_in_70_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_3_valid = io_in_71_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_3_bits = io_in_71_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_out_0_ready = sub_crossbar_49_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_1_ready = sub_crossbar_52_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_2_ready = sub_crossbar_55_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_3_ready = sub_crossbar_58_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_clock = clock;
  assign sub_crossbar_52_reset = reset;
  assign sub_crossbar_52_io_in_0_valid = sub_crossbar_48_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_0_bits = sub_crossbar_48_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_1_valid = sub_crossbar_51_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_1_bits = sub_crossbar_51_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_2_valid = sub_crossbar_54_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_2_bits = sub_crossbar_54_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_3_valid = sub_crossbar_57_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_3_bits = sub_crossbar_57_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_out_0_ready = sub_crossbar_53_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_1_ready = sub_crossbar_65_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_2_ready = sub_crossbar_77_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_3_ready = sub_crossbar_89_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_clock = clock;
  assign sub_crossbar_53_reset = reset;
  assign sub_crossbar_53_io_in_0_valid = sub_crossbar_52_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_0_bits = sub_crossbar_52_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_1_valid = sub_crossbar_64_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_1_bits = sub_crossbar_64_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_2_valid = sub_crossbar_76_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_2_bits = sub_crossbar_76_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_3_valid = sub_crossbar_88_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_3_bits = sub_crossbar_88_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_out_0_ready = sub_crossbar_97_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_1_ready = sub_crossbar_113_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_2_ready = sub_crossbar_129_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_3_ready = sub_crossbar_145_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_54_clock = clock;
  assign sub_crossbar_54_reset = reset;
  assign sub_crossbar_54_io_in_0_valid = io_in_72_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_0_bits = io_in_72_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_1_valid = io_in_73_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_1_bits = io_in_73_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_2_valid = io_in_74_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_2_bits = io_in_74_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_3_valid = io_in_75_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_3_bits = io_in_75_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_out_0_ready = sub_crossbar_49_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_1_ready = sub_crossbar_52_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_2_ready = sub_crossbar_55_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_3_ready = sub_crossbar_58_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_clock = clock;
  assign sub_crossbar_55_reset = reset;
  assign sub_crossbar_55_io_in_0_valid = sub_crossbar_48_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_0_bits = sub_crossbar_48_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_1_valid = sub_crossbar_51_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_1_bits = sub_crossbar_51_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_2_valid = sub_crossbar_54_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_2_bits = sub_crossbar_54_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_3_valid = sub_crossbar_57_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_3_bits = sub_crossbar_57_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_out_0_ready = sub_crossbar_56_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_1_ready = sub_crossbar_68_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_2_ready = sub_crossbar_80_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_3_ready = sub_crossbar_92_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_clock = clock;
  assign sub_crossbar_56_reset = reset;
  assign sub_crossbar_56_io_in_0_valid = sub_crossbar_55_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_0_bits = sub_crossbar_55_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_1_valid = sub_crossbar_67_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_1_bits = sub_crossbar_67_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_2_valid = sub_crossbar_79_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_2_bits = sub_crossbar_79_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_3_valid = sub_crossbar_91_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_3_bits = sub_crossbar_91_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_out_0_ready = sub_crossbar_98_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_1_ready = sub_crossbar_114_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_2_ready = sub_crossbar_130_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_3_ready = sub_crossbar_146_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_57_clock = clock;
  assign sub_crossbar_57_reset = reset;
  assign sub_crossbar_57_io_in_0_valid = io_in_76_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_0_bits = io_in_76_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_1_valid = io_in_77_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_1_bits = io_in_77_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_2_valid = io_in_78_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_2_bits = io_in_78_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_3_valid = io_in_79_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_3_bits = io_in_79_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_out_0_ready = sub_crossbar_49_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_1_ready = sub_crossbar_52_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_2_ready = sub_crossbar_55_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_3_ready = sub_crossbar_58_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_clock = clock;
  assign sub_crossbar_58_reset = reset;
  assign sub_crossbar_58_io_in_0_valid = sub_crossbar_48_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_0_bits = sub_crossbar_48_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_1_valid = sub_crossbar_51_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_1_bits = sub_crossbar_51_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_2_valid = sub_crossbar_54_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_2_bits = sub_crossbar_54_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_3_valid = sub_crossbar_57_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_3_bits = sub_crossbar_57_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_out_0_ready = sub_crossbar_59_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_1_ready = sub_crossbar_71_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_2_ready = sub_crossbar_83_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_3_ready = sub_crossbar_95_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_clock = clock;
  assign sub_crossbar_59_reset = reset;
  assign sub_crossbar_59_io_in_0_valid = sub_crossbar_58_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_0_bits = sub_crossbar_58_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_1_valid = sub_crossbar_70_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_1_bits = sub_crossbar_70_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_2_valid = sub_crossbar_82_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_2_bits = sub_crossbar_82_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_3_valid = sub_crossbar_94_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_3_bits = sub_crossbar_94_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_out_0_ready = sub_crossbar_99_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_1_ready = sub_crossbar_115_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_2_ready = sub_crossbar_131_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_3_ready = sub_crossbar_147_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_60_clock = clock;
  assign sub_crossbar_60_reset = reset;
  assign sub_crossbar_60_io_in_0_valid = io_in_80_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_0_bits = io_in_80_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_1_valid = io_in_81_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_1_bits = io_in_81_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_2_valid = io_in_82_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_2_bits = io_in_82_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_3_valid = io_in_83_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_3_bits = io_in_83_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_out_0_ready = sub_crossbar_61_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_1_ready = sub_crossbar_64_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_2_ready = sub_crossbar_67_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_3_ready = sub_crossbar_70_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_clock = clock;
  assign sub_crossbar_61_reset = reset;
  assign sub_crossbar_61_io_in_0_valid = sub_crossbar_60_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_0_bits = sub_crossbar_60_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_1_valid = sub_crossbar_63_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_1_bits = sub_crossbar_63_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_2_valid = sub_crossbar_66_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_2_bits = sub_crossbar_66_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_3_valid = sub_crossbar_69_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_3_bits = sub_crossbar_69_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_out_0_ready = sub_crossbar_50_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_1_ready = sub_crossbar_62_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_2_ready = sub_crossbar_74_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_3_ready = sub_crossbar_86_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_clock = clock;
  assign sub_crossbar_62_reset = reset;
  assign sub_crossbar_62_io_in_0_valid = sub_crossbar_49_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_0_bits = sub_crossbar_49_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_1_valid = sub_crossbar_61_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_1_bits = sub_crossbar_61_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_2_valid = sub_crossbar_73_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_2_bits = sub_crossbar_73_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_3_valid = sub_crossbar_85_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_3_bits = sub_crossbar_85_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_out_0_ready = sub_crossbar_100_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_1_ready = sub_crossbar_116_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_2_ready = sub_crossbar_132_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_3_ready = sub_crossbar_148_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_63_clock = clock;
  assign sub_crossbar_63_reset = reset;
  assign sub_crossbar_63_io_in_0_valid = io_in_84_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_0_bits = io_in_84_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_1_valid = io_in_85_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_1_bits = io_in_85_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_2_valid = io_in_86_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_2_bits = io_in_86_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_3_valid = io_in_87_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_3_bits = io_in_87_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_out_0_ready = sub_crossbar_61_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_1_ready = sub_crossbar_64_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_2_ready = sub_crossbar_67_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_3_ready = sub_crossbar_70_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_clock = clock;
  assign sub_crossbar_64_reset = reset;
  assign sub_crossbar_64_io_in_0_valid = sub_crossbar_60_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_0_bits = sub_crossbar_60_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_1_valid = sub_crossbar_63_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_1_bits = sub_crossbar_63_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_2_valid = sub_crossbar_66_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_2_bits = sub_crossbar_66_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_3_valid = sub_crossbar_69_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_3_bits = sub_crossbar_69_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_out_0_ready = sub_crossbar_53_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_1_ready = sub_crossbar_65_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_2_ready = sub_crossbar_77_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_3_ready = sub_crossbar_89_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_clock = clock;
  assign sub_crossbar_65_reset = reset;
  assign sub_crossbar_65_io_in_0_valid = sub_crossbar_52_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_0_bits = sub_crossbar_52_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_1_valid = sub_crossbar_64_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_1_bits = sub_crossbar_64_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_2_valid = sub_crossbar_76_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_2_bits = sub_crossbar_76_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_3_valid = sub_crossbar_88_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_3_bits = sub_crossbar_88_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_out_0_ready = sub_crossbar_101_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_1_ready = sub_crossbar_117_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_2_ready = sub_crossbar_133_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_3_ready = sub_crossbar_149_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_66_clock = clock;
  assign sub_crossbar_66_reset = reset;
  assign sub_crossbar_66_io_in_0_valid = io_in_88_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_0_bits = io_in_88_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_1_valid = io_in_89_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_1_bits = io_in_89_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_2_valid = io_in_90_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_2_bits = io_in_90_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_3_valid = io_in_91_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_3_bits = io_in_91_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_out_0_ready = sub_crossbar_61_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_1_ready = sub_crossbar_64_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_2_ready = sub_crossbar_67_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_3_ready = sub_crossbar_70_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_clock = clock;
  assign sub_crossbar_67_reset = reset;
  assign sub_crossbar_67_io_in_0_valid = sub_crossbar_60_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_0_bits = sub_crossbar_60_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_1_valid = sub_crossbar_63_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_1_bits = sub_crossbar_63_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_2_valid = sub_crossbar_66_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_2_bits = sub_crossbar_66_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_3_valid = sub_crossbar_69_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_3_bits = sub_crossbar_69_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_out_0_ready = sub_crossbar_56_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_1_ready = sub_crossbar_68_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_2_ready = sub_crossbar_80_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_3_ready = sub_crossbar_92_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_clock = clock;
  assign sub_crossbar_68_reset = reset;
  assign sub_crossbar_68_io_in_0_valid = sub_crossbar_55_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_0_bits = sub_crossbar_55_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_1_valid = sub_crossbar_67_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_1_bits = sub_crossbar_67_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_2_valid = sub_crossbar_79_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_2_bits = sub_crossbar_79_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_3_valid = sub_crossbar_91_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_3_bits = sub_crossbar_91_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_out_0_ready = sub_crossbar_102_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_1_ready = sub_crossbar_118_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_2_ready = sub_crossbar_134_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_3_ready = sub_crossbar_150_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_69_clock = clock;
  assign sub_crossbar_69_reset = reset;
  assign sub_crossbar_69_io_in_0_valid = io_in_92_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_0_bits = io_in_92_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_1_valid = io_in_93_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_1_bits = io_in_93_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_2_valid = io_in_94_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_2_bits = io_in_94_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_3_valid = io_in_95_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_3_bits = io_in_95_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_out_0_ready = sub_crossbar_61_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_1_ready = sub_crossbar_64_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_2_ready = sub_crossbar_67_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_3_ready = sub_crossbar_70_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_clock = clock;
  assign sub_crossbar_70_reset = reset;
  assign sub_crossbar_70_io_in_0_valid = sub_crossbar_60_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_0_bits = sub_crossbar_60_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_1_valid = sub_crossbar_63_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_1_bits = sub_crossbar_63_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_2_valid = sub_crossbar_66_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_2_bits = sub_crossbar_66_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_3_valid = sub_crossbar_69_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_3_bits = sub_crossbar_69_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_out_0_ready = sub_crossbar_59_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_1_ready = sub_crossbar_71_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_2_ready = sub_crossbar_83_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_3_ready = sub_crossbar_95_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_clock = clock;
  assign sub_crossbar_71_reset = reset;
  assign sub_crossbar_71_io_in_0_valid = sub_crossbar_58_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_0_bits = sub_crossbar_58_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_1_valid = sub_crossbar_70_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_1_bits = sub_crossbar_70_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_2_valid = sub_crossbar_82_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_2_bits = sub_crossbar_82_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_3_valid = sub_crossbar_94_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_3_bits = sub_crossbar_94_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_out_0_ready = sub_crossbar_103_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_1_ready = sub_crossbar_119_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_2_ready = sub_crossbar_135_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_3_ready = sub_crossbar_151_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_72_clock = clock;
  assign sub_crossbar_72_reset = reset;
  assign sub_crossbar_72_io_in_0_valid = io_in_96_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_0_bits = io_in_96_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_1_valid = io_in_97_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_1_bits = io_in_97_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_2_valid = io_in_98_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_2_bits = io_in_98_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_3_valid = io_in_99_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_3_bits = io_in_99_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_out_0_ready = sub_crossbar_73_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_1_ready = sub_crossbar_76_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_2_ready = sub_crossbar_79_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_3_ready = sub_crossbar_82_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_clock = clock;
  assign sub_crossbar_73_reset = reset;
  assign sub_crossbar_73_io_in_0_valid = sub_crossbar_72_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_0_bits = sub_crossbar_72_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_1_valid = sub_crossbar_75_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_1_bits = sub_crossbar_75_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_2_valid = sub_crossbar_78_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_2_bits = sub_crossbar_78_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_3_valid = sub_crossbar_81_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_3_bits = sub_crossbar_81_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_out_0_ready = sub_crossbar_50_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_1_ready = sub_crossbar_62_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_2_ready = sub_crossbar_74_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_3_ready = sub_crossbar_86_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_clock = clock;
  assign sub_crossbar_74_reset = reset;
  assign sub_crossbar_74_io_in_0_valid = sub_crossbar_49_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_0_bits = sub_crossbar_49_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_1_valid = sub_crossbar_61_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_1_bits = sub_crossbar_61_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_2_valid = sub_crossbar_73_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_2_bits = sub_crossbar_73_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_3_valid = sub_crossbar_85_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_3_bits = sub_crossbar_85_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_out_0_ready = sub_crossbar_104_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_1_ready = sub_crossbar_120_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_2_ready = sub_crossbar_136_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_3_ready = sub_crossbar_152_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_75_clock = clock;
  assign sub_crossbar_75_reset = reset;
  assign sub_crossbar_75_io_in_0_valid = io_in_100_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_0_bits = io_in_100_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_1_valid = io_in_101_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_1_bits = io_in_101_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_2_valid = io_in_102_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_2_bits = io_in_102_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_3_valid = io_in_103_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_3_bits = io_in_103_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_out_0_ready = sub_crossbar_73_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_1_ready = sub_crossbar_76_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_2_ready = sub_crossbar_79_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_3_ready = sub_crossbar_82_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_clock = clock;
  assign sub_crossbar_76_reset = reset;
  assign sub_crossbar_76_io_in_0_valid = sub_crossbar_72_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_0_bits = sub_crossbar_72_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_1_valid = sub_crossbar_75_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_1_bits = sub_crossbar_75_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_2_valid = sub_crossbar_78_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_2_bits = sub_crossbar_78_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_3_valid = sub_crossbar_81_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_3_bits = sub_crossbar_81_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_out_0_ready = sub_crossbar_53_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_1_ready = sub_crossbar_65_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_2_ready = sub_crossbar_77_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_3_ready = sub_crossbar_89_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_clock = clock;
  assign sub_crossbar_77_reset = reset;
  assign sub_crossbar_77_io_in_0_valid = sub_crossbar_52_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_0_bits = sub_crossbar_52_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_1_valid = sub_crossbar_64_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_1_bits = sub_crossbar_64_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_2_valid = sub_crossbar_76_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_2_bits = sub_crossbar_76_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_3_valid = sub_crossbar_88_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_3_bits = sub_crossbar_88_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_out_0_ready = sub_crossbar_105_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_1_ready = sub_crossbar_121_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_2_ready = sub_crossbar_137_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_3_ready = sub_crossbar_153_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_78_clock = clock;
  assign sub_crossbar_78_reset = reset;
  assign sub_crossbar_78_io_in_0_valid = io_in_104_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_0_bits = io_in_104_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_1_valid = io_in_105_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_1_bits = io_in_105_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_2_valid = io_in_106_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_2_bits = io_in_106_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_3_valid = io_in_107_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_3_bits = io_in_107_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_out_0_ready = sub_crossbar_73_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_1_ready = sub_crossbar_76_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_2_ready = sub_crossbar_79_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_3_ready = sub_crossbar_82_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_clock = clock;
  assign sub_crossbar_79_reset = reset;
  assign sub_crossbar_79_io_in_0_valid = sub_crossbar_72_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_0_bits = sub_crossbar_72_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_1_valid = sub_crossbar_75_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_1_bits = sub_crossbar_75_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_2_valid = sub_crossbar_78_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_2_bits = sub_crossbar_78_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_3_valid = sub_crossbar_81_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_3_bits = sub_crossbar_81_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_out_0_ready = sub_crossbar_56_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_1_ready = sub_crossbar_68_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_2_ready = sub_crossbar_80_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_3_ready = sub_crossbar_92_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_clock = clock;
  assign sub_crossbar_80_reset = reset;
  assign sub_crossbar_80_io_in_0_valid = sub_crossbar_55_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_0_bits = sub_crossbar_55_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_1_valid = sub_crossbar_67_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_1_bits = sub_crossbar_67_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_2_valid = sub_crossbar_79_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_2_bits = sub_crossbar_79_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_3_valid = sub_crossbar_91_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_3_bits = sub_crossbar_91_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_out_0_ready = sub_crossbar_106_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_1_ready = sub_crossbar_122_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_2_ready = sub_crossbar_138_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_3_ready = sub_crossbar_154_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_81_clock = clock;
  assign sub_crossbar_81_reset = reset;
  assign sub_crossbar_81_io_in_0_valid = io_in_108_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_0_bits = io_in_108_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_1_valid = io_in_109_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_1_bits = io_in_109_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_2_valid = io_in_110_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_2_bits = io_in_110_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_3_valid = io_in_111_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_3_bits = io_in_111_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_out_0_ready = sub_crossbar_73_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_1_ready = sub_crossbar_76_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_2_ready = sub_crossbar_79_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_3_ready = sub_crossbar_82_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_clock = clock;
  assign sub_crossbar_82_reset = reset;
  assign sub_crossbar_82_io_in_0_valid = sub_crossbar_72_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_0_bits = sub_crossbar_72_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_1_valid = sub_crossbar_75_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_1_bits = sub_crossbar_75_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_2_valid = sub_crossbar_78_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_2_bits = sub_crossbar_78_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_3_valid = sub_crossbar_81_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_3_bits = sub_crossbar_81_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_out_0_ready = sub_crossbar_59_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_1_ready = sub_crossbar_71_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_2_ready = sub_crossbar_83_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_3_ready = sub_crossbar_95_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_clock = clock;
  assign sub_crossbar_83_reset = reset;
  assign sub_crossbar_83_io_in_0_valid = sub_crossbar_58_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_0_bits = sub_crossbar_58_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_1_valid = sub_crossbar_70_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_1_bits = sub_crossbar_70_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_2_valid = sub_crossbar_82_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_2_bits = sub_crossbar_82_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_3_valid = sub_crossbar_94_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_3_bits = sub_crossbar_94_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_out_0_ready = sub_crossbar_107_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_1_ready = sub_crossbar_123_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_2_ready = sub_crossbar_139_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_3_ready = sub_crossbar_155_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_84_clock = clock;
  assign sub_crossbar_84_reset = reset;
  assign sub_crossbar_84_io_in_0_valid = io_in_112_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_0_bits = io_in_112_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_1_valid = io_in_113_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_1_bits = io_in_113_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_2_valid = io_in_114_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_2_bits = io_in_114_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_3_valid = io_in_115_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_3_bits = io_in_115_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_out_0_ready = sub_crossbar_85_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_1_ready = sub_crossbar_88_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_2_ready = sub_crossbar_91_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_3_ready = sub_crossbar_94_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_clock = clock;
  assign sub_crossbar_85_reset = reset;
  assign sub_crossbar_85_io_in_0_valid = sub_crossbar_84_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_0_bits = sub_crossbar_84_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_1_valid = sub_crossbar_87_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_1_bits = sub_crossbar_87_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_2_valid = sub_crossbar_90_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_2_bits = sub_crossbar_90_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_3_valid = sub_crossbar_93_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_3_bits = sub_crossbar_93_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_out_0_ready = sub_crossbar_50_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_1_ready = sub_crossbar_62_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_2_ready = sub_crossbar_74_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_3_ready = sub_crossbar_86_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_clock = clock;
  assign sub_crossbar_86_reset = reset;
  assign sub_crossbar_86_io_in_0_valid = sub_crossbar_49_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_0_bits = sub_crossbar_49_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_1_valid = sub_crossbar_61_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_1_bits = sub_crossbar_61_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_2_valid = sub_crossbar_73_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_2_bits = sub_crossbar_73_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_3_valid = sub_crossbar_85_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_3_bits = sub_crossbar_85_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_out_0_ready = sub_crossbar_108_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_1_ready = sub_crossbar_124_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_2_ready = sub_crossbar_140_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_3_ready = sub_crossbar_156_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_87_clock = clock;
  assign sub_crossbar_87_reset = reset;
  assign sub_crossbar_87_io_in_0_valid = io_in_116_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_0_bits = io_in_116_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_1_valid = io_in_117_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_1_bits = io_in_117_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_2_valid = io_in_118_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_2_bits = io_in_118_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_3_valid = io_in_119_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_3_bits = io_in_119_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_out_0_ready = sub_crossbar_85_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_1_ready = sub_crossbar_88_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_2_ready = sub_crossbar_91_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_3_ready = sub_crossbar_94_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_clock = clock;
  assign sub_crossbar_88_reset = reset;
  assign sub_crossbar_88_io_in_0_valid = sub_crossbar_84_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_0_bits = sub_crossbar_84_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_1_valid = sub_crossbar_87_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_1_bits = sub_crossbar_87_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_2_valid = sub_crossbar_90_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_2_bits = sub_crossbar_90_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_3_valid = sub_crossbar_93_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_3_bits = sub_crossbar_93_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_out_0_ready = sub_crossbar_53_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_1_ready = sub_crossbar_65_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_2_ready = sub_crossbar_77_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_3_ready = sub_crossbar_89_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_clock = clock;
  assign sub_crossbar_89_reset = reset;
  assign sub_crossbar_89_io_in_0_valid = sub_crossbar_52_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_0_bits = sub_crossbar_52_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_1_valid = sub_crossbar_64_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_1_bits = sub_crossbar_64_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_2_valid = sub_crossbar_76_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_2_bits = sub_crossbar_76_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_3_valid = sub_crossbar_88_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_3_bits = sub_crossbar_88_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_out_0_ready = sub_crossbar_109_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_1_ready = sub_crossbar_125_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_2_ready = sub_crossbar_141_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_3_ready = sub_crossbar_157_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_90_clock = clock;
  assign sub_crossbar_90_reset = reset;
  assign sub_crossbar_90_io_in_0_valid = io_in_120_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_0_bits = io_in_120_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_1_valid = io_in_121_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_1_bits = io_in_121_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_2_valid = io_in_122_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_2_bits = io_in_122_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_3_valid = io_in_123_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_3_bits = io_in_123_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_out_0_ready = sub_crossbar_85_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_1_ready = sub_crossbar_88_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_2_ready = sub_crossbar_91_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_3_ready = sub_crossbar_94_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_clock = clock;
  assign sub_crossbar_91_reset = reset;
  assign sub_crossbar_91_io_in_0_valid = sub_crossbar_84_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_0_bits = sub_crossbar_84_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_1_valid = sub_crossbar_87_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_1_bits = sub_crossbar_87_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_2_valid = sub_crossbar_90_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_2_bits = sub_crossbar_90_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_3_valid = sub_crossbar_93_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_3_bits = sub_crossbar_93_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_out_0_ready = sub_crossbar_56_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_1_ready = sub_crossbar_68_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_2_ready = sub_crossbar_80_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_3_ready = sub_crossbar_92_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_clock = clock;
  assign sub_crossbar_92_reset = reset;
  assign sub_crossbar_92_io_in_0_valid = sub_crossbar_55_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_0_bits = sub_crossbar_55_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_1_valid = sub_crossbar_67_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_1_bits = sub_crossbar_67_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_2_valid = sub_crossbar_79_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_2_bits = sub_crossbar_79_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_3_valid = sub_crossbar_91_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_3_bits = sub_crossbar_91_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_out_0_ready = sub_crossbar_110_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_1_ready = sub_crossbar_126_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_2_ready = sub_crossbar_142_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_3_ready = sub_crossbar_158_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_93_clock = clock;
  assign sub_crossbar_93_reset = reset;
  assign sub_crossbar_93_io_in_0_valid = io_in_124_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_0_bits = io_in_124_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_1_valid = io_in_125_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_1_bits = io_in_125_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_2_valid = io_in_126_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_2_bits = io_in_126_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_3_valid = io_in_127_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_3_bits = io_in_127_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_out_0_ready = sub_crossbar_85_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_1_ready = sub_crossbar_88_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_2_ready = sub_crossbar_91_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_3_ready = sub_crossbar_94_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_clock = clock;
  assign sub_crossbar_94_reset = reset;
  assign sub_crossbar_94_io_in_0_valid = sub_crossbar_84_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_0_bits = sub_crossbar_84_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_1_valid = sub_crossbar_87_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_1_bits = sub_crossbar_87_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_2_valid = sub_crossbar_90_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_2_bits = sub_crossbar_90_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_3_valid = sub_crossbar_93_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_3_bits = sub_crossbar_93_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_out_0_ready = sub_crossbar_59_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_1_ready = sub_crossbar_71_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_2_ready = sub_crossbar_83_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_3_ready = sub_crossbar_95_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_clock = clock;
  assign sub_crossbar_95_reset = reset;
  assign sub_crossbar_95_io_in_0_valid = sub_crossbar_58_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_0_bits = sub_crossbar_58_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_1_valid = sub_crossbar_70_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_1_bits = sub_crossbar_70_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_2_valid = sub_crossbar_82_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_2_bits = sub_crossbar_82_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_3_valid = sub_crossbar_94_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_3_bits = sub_crossbar_94_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_out_0_ready = sub_crossbar_111_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_1_ready = sub_crossbar_127_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_2_ready = sub_crossbar_143_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_3_ready = sub_crossbar_159_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_clock = clock;
  assign sub_crossbar_96_reset = reset;
  assign sub_crossbar_96_io_in_0_valid = sub_crossbar_2_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_0_bits = sub_crossbar_2_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_1_valid = sub_crossbar_50_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_1_bits = sub_crossbar_50_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_out_0_ready = io_out_0_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_96_io_out_1_ready = io_out_64_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_97_clock = clock;
  assign sub_crossbar_97_reset = reset;
  assign sub_crossbar_97_io_in_0_valid = sub_crossbar_5_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_0_bits = sub_crossbar_5_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_1_valid = sub_crossbar_53_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_1_bits = sub_crossbar_53_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_out_0_ready = io_out_1_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_97_io_out_1_ready = io_out_65_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_98_clock = clock;
  assign sub_crossbar_98_reset = reset;
  assign sub_crossbar_98_io_in_0_valid = sub_crossbar_8_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_0_bits = sub_crossbar_8_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_1_valid = sub_crossbar_56_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_1_bits = sub_crossbar_56_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_out_0_ready = io_out_2_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_98_io_out_1_ready = io_out_66_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_99_clock = clock;
  assign sub_crossbar_99_reset = reset;
  assign sub_crossbar_99_io_in_0_valid = sub_crossbar_11_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_0_bits = sub_crossbar_11_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_1_valid = sub_crossbar_59_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_1_bits = sub_crossbar_59_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_out_0_ready = io_out_3_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_99_io_out_1_ready = io_out_67_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_100_clock = clock;
  assign sub_crossbar_100_reset = reset;
  assign sub_crossbar_100_io_in_0_valid = sub_crossbar_14_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_0_bits = sub_crossbar_14_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_1_valid = sub_crossbar_62_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_1_bits = sub_crossbar_62_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_out_0_ready = io_out_4_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_100_io_out_1_ready = io_out_68_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_101_clock = clock;
  assign sub_crossbar_101_reset = reset;
  assign sub_crossbar_101_io_in_0_valid = sub_crossbar_17_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_0_bits = sub_crossbar_17_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_1_valid = sub_crossbar_65_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_1_bits = sub_crossbar_65_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_out_0_ready = io_out_5_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_101_io_out_1_ready = io_out_69_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_102_clock = clock;
  assign sub_crossbar_102_reset = reset;
  assign sub_crossbar_102_io_in_0_valid = sub_crossbar_20_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_0_bits = sub_crossbar_20_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_1_valid = sub_crossbar_68_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_1_bits = sub_crossbar_68_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_out_0_ready = io_out_6_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_102_io_out_1_ready = io_out_70_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_103_clock = clock;
  assign sub_crossbar_103_reset = reset;
  assign sub_crossbar_103_io_in_0_valid = sub_crossbar_23_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_0_bits = sub_crossbar_23_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_1_valid = sub_crossbar_71_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_1_bits = sub_crossbar_71_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_out_0_ready = io_out_7_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_103_io_out_1_ready = io_out_71_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_104_clock = clock;
  assign sub_crossbar_104_reset = reset;
  assign sub_crossbar_104_io_in_0_valid = sub_crossbar_26_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_0_bits = sub_crossbar_26_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_1_valid = sub_crossbar_74_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_1_bits = sub_crossbar_74_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_out_0_ready = io_out_8_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_104_io_out_1_ready = io_out_72_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_105_clock = clock;
  assign sub_crossbar_105_reset = reset;
  assign sub_crossbar_105_io_in_0_valid = sub_crossbar_29_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_0_bits = sub_crossbar_29_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_1_valid = sub_crossbar_77_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_1_bits = sub_crossbar_77_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_out_0_ready = io_out_9_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_105_io_out_1_ready = io_out_73_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_106_clock = clock;
  assign sub_crossbar_106_reset = reset;
  assign sub_crossbar_106_io_in_0_valid = sub_crossbar_32_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_0_bits = sub_crossbar_32_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_1_valid = sub_crossbar_80_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_1_bits = sub_crossbar_80_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_out_0_ready = io_out_10_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_106_io_out_1_ready = io_out_74_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_107_clock = clock;
  assign sub_crossbar_107_reset = reset;
  assign sub_crossbar_107_io_in_0_valid = sub_crossbar_35_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_0_bits = sub_crossbar_35_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_1_valid = sub_crossbar_83_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_1_bits = sub_crossbar_83_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_out_0_ready = io_out_11_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_107_io_out_1_ready = io_out_75_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_108_clock = clock;
  assign sub_crossbar_108_reset = reset;
  assign sub_crossbar_108_io_in_0_valid = sub_crossbar_38_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_0_bits = sub_crossbar_38_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_1_valid = sub_crossbar_86_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_1_bits = sub_crossbar_86_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_out_0_ready = io_out_12_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_108_io_out_1_ready = io_out_76_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_109_clock = clock;
  assign sub_crossbar_109_reset = reset;
  assign sub_crossbar_109_io_in_0_valid = sub_crossbar_41_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_0_bits = sub_crossbar_41_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_1_valid = sub_crossbar_89_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_1_bits = sub_crossbar_89_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_out_0_ready = io_out_13_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_109_io_out_1_ready = io_out_77_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_110_clock = clock;
  assign sub_crossbar_110_reset = reset;
  assign sub_crossbar_110_io_in_0_valid = sub_crossbar_44_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_0_bits = sub_crossbar_44_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_1_valid = sub_crossbar_92_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_1_bits = sub_crossbar_92_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_out_0_ready = io_out_14_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_110_io_out_1_ready = io_out_78_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_111_clock = clock;
  assign sub_crossbar_111_reset = reset;
  assign sub_crossbar_111_io_in_0_valid = sub_crossbar_47_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_0_bits = sub_crossbar_47_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_1_valid = sub_crossbar_95_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_1_bits = sub_crossbar_95_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_out_0_ready = io_out_15_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_111_io_out_1_ready = io_out_79_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_112_clock = clock;
  assign sub_crossbar_112_reset = reset;
  assign sub_crossbar_112_io_in_0_valid = sub_crossbar_2_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_0_bits = sub_crossbar_2_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_1_valid = sub_crossbar_50_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_1_bits = sub_crossbar_50_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_out_0_ready = io_out_16_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_112_io_out_1_ready = io_out_80_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_113_clock = clock;
  assign sub_crossbar_113_reset = reset;
  assign sub_crossbar_113_io_in_0_valid = sub_crossbar_5_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_0_bits = sub_crossbar_5_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_1_valid = sub_crossbar_53_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_1_bits = sub_crossbar_53_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_out_0_ready = io_out_17_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_113_io_out_1_ready = io_out_81_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_114_clock = clock;
  assign sub_crossbar_114_reset = reset;
  assign sub_crossbar_114_io_in_0_valid = sub_crossbar_8_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_0_bits = sub_crossbar_8_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_1_valid = sub_crossbar_56_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_1_bits = sub_crossbar_56_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_out_0_ready = io_out_18_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_114_io_out_1_ready = io_out_82_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_115_clock = clock;
  assign sub_crossbar_115_reset = reset;
  assign sub_crossbar_115_io_in_0_valid = sub_crossbar_11_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_0_bits = sub_crossbar_11_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_1_valid = sub_crossbar_59_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_1_bits = sub_crossbar_59_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_out_0_ready = io_out_19_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_115_io_out_1_ready = io_out_83_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_116_clock = clock;
  assign sub_crossbar_116_reset = reset;
  assign sub_crossbar_116_io_in_0_valid = sub_crossbar_14_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_0_bits = sub_crossbar_14_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_1_valid = sub_crossbar_62_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_1_bits = sub_crossbar_62_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_out_0_ready = io_out_20_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_116_io_out_1_ready = io_out_84_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_117_clock = clock;
  assign sub_crossbar_117_reset = reset;
  assign sub_crossbar_117_io_in_0_valid = sub_crossbar_17_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_0_bits = sub_crossbar_17_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_1_valid = sub_crossbar_65_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_1_bits = sub_crossbar_65_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_out_0_ready = io_out_21_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_117_io_out_1_ready = io_out_85_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_118_clock = clock;
  assign sub_crossbar_118_reset = reset;
  assign sub_crossbar_118_io_in_0_valid = sub_crossbar_20_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_0_bits = sub_crossbar_20_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_1_valid = sub_crossbar_68_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_1_bits = sub_crossbar_68_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_out_0_ready = io_out_22_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_118_io_out_1_ready = io_out_86_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_119_clock = clock;
  assign sub_crossbar_119_reset = reset;
  assign sub_crossbar_119_io_in_0_valid = sub_crossbar_23_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_0_bits = sub_crossbar_23_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_1_valid = sub_crossbar_71_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_1_bits = sub_crossbar_71_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_out_0_ready = io_out_23_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_119_io_out_1_ready = io_out_87_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_120_clock = clock;
  assign sub_crossbar_120_reset = reset;
  assign sub_crossbar_120_io_in_0_valid = sub_crossbar_26_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_0_bits = sub_crossbar_26_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_1_valid = sub_crossbar_74_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_1_bits = sub_crossbar_74_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_out_0_ready = io_out_24_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_120_io_out_1_ready = io_out_88_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_121_clock = clock;
  assign sub_crossbar_121_reset = reset;
  assign sub_crossbar_121_io_in_0_valid = sub_crossbar_29_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_0_bits = sub_crossbar_29_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_1_valid = sub_crossbar_77_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_1_bits = sub_crossbar_77_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_out_0_ready = io_out_25_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_121_io_out_1_ready = io_out_89_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_122_clock = clock;
  assign sub_crossbar_122_reset = reset;
  assign sub_crossbar_122_io_in_0_valid = sub_crossbar_32_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_0_bits = sub_crossbar_32_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_1_valid = sub_crossbar_80_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_1_bits = sub_crossbar_80_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_out_0_ready = io_out_26_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_122_io_out_1_ready = io_out_90_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_123_clock = clock;
  assign sub_crossbar_123_reset = reset;
  assign sub_crossbar_123_io_in_0_valid = sub_crossbar_35_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_0_bits = sub_crossbar_35_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_1_valid = sub_crossbar_83_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_1_bits = sub_crossbar_83_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_out_0_ready = io_out_27_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_123_io_out_1_ready = io_out_91_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_124_clock = clock;
  assign sub_crossbar_124_reset = reset;
  assign sub_crossbar_124_io_in_0_valid = sub_crossbar_38_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_0_bits = sub_crossbar_38_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_1_valid = sub_crossbar_86_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_1_bits = sub_crossbar_86_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_out_0_ready = io_out_28_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_124_io_out_1_ready = io_out_92_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_125_clock = clock;
  assign sub_crossbar_125_reset = reset;
  assign sub_crossbar_125_io_in_0_valid = sub_crossbar_41_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_0_bits = sub_crossbar_41_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_1_valid = sub_crossbar_89_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_1_bits = sub_crossbar_89_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_out_0_ready = io_out_29_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_125_io_out_1_ready = io_out_93_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_126_clock = clock;
  assign sub_crossbar_126_reset = reset;
  assign sub_crossbar_126_io_in_0_valid = sub_crossbar_44_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_0_bits = sub_crossbar_44_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_1_valid = sub_crossbar_92_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_1_bits = sub_crossbar_92_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_out_0_ready = io_out_30_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_126_io_out_1_ready = io_out_94_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_127_clock = clock;
  assign sub_crossbar_127_reset = reset;
  assign sub_crossbar_127_io_in_0_valid = sub_crossbar_47_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_0_bits = sub_crossbar_47_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_1_valid = sub_crossbar_95_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_1_bits = sub_crossbar_95_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_out_0_ready = io_out_31_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_127_io_out_1_ready = io_out_95_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_128_clock = clock;
  assign sub_crossbar_128_reset = reset;
  assign sub_crossbar_128_io_in_0_valid = sub_crossbar_2_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_0_bits = sub_crossbar_2_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_1_valid = sub_crossbar_50_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_1_bits = sub_crossbar_50_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_out_0_ready = io_out_32_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_128_io_out_1_ready = io_out_96_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_129_clock = clock;
  assign sub_crossbar_129_reset = reset;
  assign sub_crossbar_129_io_in_0_valid = sub_crossbar_5_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_0_bits = sub_crossbar_5_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_1_valid = sub_crossbar_53_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_1_bits = sub_crossbar_53_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_out_0_ready = io_out_33_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_129_io_out_1_ready = io_out_97_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_130_clock = clock;
  assign sub_crossbar_130_reset = reset;
  assign sub_crossbar_130_io_in_0_valid = sub_crossbar_8_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_0_bits = sub_crossbar_8_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_1_valid = sub_crossbar_56_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_1_bits = sub_crossbar_56_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_out_0_ready = io_out_34_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_130_io_out_1_ready = io_out_98_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_131_clock = clock;
  assign sub_crossbar_131_reset = reset;
  assign sub_crossbar_131_io_in_0_valid = sub_crossbar_11_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_0_bits = sub_crossbar_11_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_1_valid = sub_crossbar_59_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_1_bits = sub_crossbar_59_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_out_0_ready = io_out_35_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_131_io_out_1_ready = io_out_99_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_132_clock = clock;
  assign sub_crossbar_132_reset = reset;
  assign sub_crossbar_132_io_in_0_valid = sub_crossbar_14_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_0_bits = sub_crossbar_14_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_1_valid = sub_crossbar_62_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_1_bits = sub_crossbar_62_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_out_0_ready = io_out_36_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_132_io_out_1_ready = io_out_100_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_133_clock = clock;
  assign sub_crossbar_133_reset = reset;
  assign sub_crossbar_133_io_in_0_valid = sub_crossbar_17_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_0_bits = sub_crossbar_17_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_1_valid = sub_crossbar_65_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_1_bits = sub_crossbar_65_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_out_0_ready = io_out_37_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_133_io_out_1_ready = io_out_101_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_134_clock = clock;
  assign sub_crossbar_134_reset = reset;
  assign sub_crossbar_134_io_in_0_valid = sub_crossbar_20_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_0_bits = sub_crossbar_20_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_1_valid = sub_crossbar_68_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_1_bits = sub_crossbar_68_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_out_0_ready = io_out_38_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_134_io_out_1_ready = io_out_102_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_135_clock = clock;
  assign sub_crossbar_135_reset = reset;
  assign sub_crossbar_135_io_in_0_valid = sub_crossbar_23_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_0_bits = sub_crossbar_23_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_1_valid = sub_crossbar_71_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_1_bits = sub_crossbar_71_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_out_0_ready = io_out_39_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_135_io_out_1_ready = io_out_103_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_136_clock = clock;
  assign sub_crossbar_136_reset = reset;
  assign sub_crossbar_136_io_in_0_valid = sub_crossbar_26_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_0_bits = sub_crossbar_26_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_1_valid = sub_crossbar_74_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_1_bits = sub_crossbar_74_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_out_0_ready = io_out_40_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_136_io_out_1_ready = io_out_104_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_137_clock = clock;
  assign sub_crossbar_137_reset = reset;
  assign sub_crossbar_137_io_in_0_valid = sub_crossbar_29_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_0_bits = sub_crossbar_29_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_1_valid = sub_crossbar_77_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_1_bits = sub_crossbar_77_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_out_0_ready = io_out_41_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_137_io_out_1_ready = io_out_105_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_138_clock = clock;
  assign sub_crossbar_138_reset = reset;
  assign sub_crossbar_138_io_in_0_valid = sub_crossbar_32_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_0_bits = sub_crossbar_32_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_1_valid = sub_crossbar_80_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_1_bits = sub_crossbar_80_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_out_0_ready = io_out_42_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_138_io_out_1_ready = io_out_106_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_139_clock = clock;
  assign sub_crossbar_139_reset = reset;
  assign sub_crossbar_139_io_in_0_valid = sub_crossbar_35_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_0_bits = sub_crossbar_35_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_1_valid = sub_crossbar_83_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_1_bits = sub_crossbar_83_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_out_0_ready = io_out_43_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_139_io_out_1_ready = io_out_107_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_140_clock = clock;
  assign sub_crossbar_140_reset = reset;
  assign sub_crossbar_140_io_in_0_valid = sub_crossbar_38_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_0_bits = sub_crossbar_38_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_1_valid = sub_crossbar_86_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_1_bits = sub_crossbar_86_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_out_0_ready = io_out_44_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_140_io_out_1_ready = io_out_108_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_141_clock = clock;
  assign sub_crossbar_141_reset = reset;
  assign sub_crossbar_141_io_in_0_valid = sub_crossbar_41_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_0_bits = sub_crossbar_41_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_1_valid = sub_crossbar_89_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_1_bits = sub_crossbar_89_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_out_0_ready = io_out_45_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_141_io_out_1_ready = io_out_109_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_142_clock = clock;
  assign sub_crossbar_142_reset = reset;
  assign sub_crossbar_142_io_in_0_valid = sub_crossbar_44_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_0_bits = sub_crossbar_44_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_1_valid = sub_crossbar_92_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_1_bits = sub_crossbar_92_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_out_0_ready = io_out_46_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_142_io_out_1_ready = io_out_110_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_143_clock = clock;
  assign sub_crossbar_143_reset = reset;
  assign sub_crossbar_143_io_in_0_valid = sub_crossbar_47_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_0_bits = sub_crossbar_47_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_1_valid = sub_crossbar_95_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_1_bits = sub_crossbar_95_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_out_0_ready = io_out_47_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_143_io_out_1_ready = io_out_111_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_144_clock = clock;
  assign sub_crossbar_144_reset = reset;
  assign sub_crossbar_144_io_in_0_valid = sub_crossbar_2_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_0_bits = sub_crossbar_2_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_1_valid = sub_crossbar_50_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_1_bits = sub_crossbar_50_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_out_0_ready = io_out_48_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_144_io_out_1_ready = io_out_112_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_145_clock = clock;
  assign sub_crossbar_145_reset = reset;
  assign sub_crossbar_145_io_in_0_valid = sub_crossbar_5_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_0_bits = sub_crossbar_5_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_1_valid = sub_crossbar_53_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_1_bits = sub_crossbar_53_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_out_0_ready = io_out_49_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_145_io_out_1_ready = io_out_113_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_146_clock = clock;
  assign sub_crossbar_146_reset = reset;
  assign sub_crossbar_146_io_in_0_valid = sub_crossbar_8_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_0_bits = sub_crossbar_8_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_1_valid = sub_crossbar_56_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_1_bits = sub_crossbar_56_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_out_0_ready = io_out_50_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_146_io_out_1_ready = io_out_114_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_147_clock = clock;
  assign sub_crossbar_147_reset = reset;
  assign sub_crossbar_147_io_in_0_valid = sub_crossbar_11_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_0_bits = sub_crossbar_11_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_1_valid = sub_crossbar_59_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_1_bits = sub_crossbar_59_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_out_0_ready = io_out_51_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_147_io_out_1_ready = io_out_115_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_148_clock = clock;
  assign sub_crossbar_148_reset = reset;
  assign sub_crossbar_148_io_in_0_valid = sub_crossbar_14_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_0_bits = sub_crossbar_14_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_1_valid = sub_crossbar_62_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_1_bits = sub_crossbar_62_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_out_0_ready = io_out_52_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_148_io_out_1_ready = io_out_116_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_149_clock = clock;
  assign sub_crossbar_149_reset = reset;
  assign sub_crossbar_149_io_in_0_valid = sub_crossbar_17_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_0_bits = sub_crossbar_17_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_1_valid = sub_crossbar_65_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_1_bits = sub_crossbar_65_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_out_0_ready = io_out_53_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_149_io_out_1_ready = io_out_117_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_150_clock = clock;
  assign sub_crossbar_150_reset = reset;
  assign sub_crossbar_150_io_in_0_valid = sub_crossbar_20_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_0_bits = sub_crossbar_20_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_1_valid = sub_crossbar_68_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_1_bits = sub_crossbar_68_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_out_0_ready = io_out_54_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_150_io_out_1_ready = io_out_118_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_151_clock = clock;
  assign sub_crossbar_151_reset = reset;
  assign sub_crossbar_151_io_in_0_valid = sub_crossbar_23_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_0_bits = sub_crossbar_23_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_1_valid = sub_crossbar_71_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_1_bits = sub_crossbar_71_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_out_0_ready = io_out_55_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_151_io_out_1_ready = io_out_119_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_152_clock = clock;
  assign sub_crossbar_152_reset = reset;
  assign sub_crossbar_152_io_in_0_valid = sub_crossbar_26_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_0_bits = sub_crossbar_26_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_1_valid = sub_crossbar_74_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_1_bits = sub_crossbar_74_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_out_0_ready = io_out_56_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_152_io_out_1_ready = io_out_120_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_153_clock = clock;
  assign sub_crossbar_153_reset = reset;
  assign sub_crossbar_153_io_in_0_valid = sub_crossbar_29_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_0_bits = sub_crossbar_29_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_1_valid = sub_crossbar_77_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_1_bits = sub_crossbar_77_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_out_0_ready = io_out_57_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_153_io_out_1_ready = io_out_121_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_154_clock = clock;
  assign sub_crossbar_154_reset = reset;
  assign sub_crossbar_154_io_in_0_valid = sub_crossbar_32_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_0_bits = sub_crossbar_32_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_1_valid = sub_crossbar_80_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_1_bits = sub_crossbar_80_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_out_0_ready = io_out_58_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_154_io_out_1_ready = io_out_122_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_155_clock = clock;
  assign sub_crossbar_155_reset = reset;
  assign sub_crossbar_155_io_in_0_valid = sub_crossbar_35_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_0_bits = sub_crossbar_35_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_1_valid = sub_crossbar_83_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_1_bits = sub_crossbar_83_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_out_0_ready = io_out_59_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_155_io_out_1_ready = io_out_123_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_156_clock = clock;
  assign sub_crossbar_156_reset = reset;
  assign sub_crossbar_156_io_in_0_valid = sub_crossbar_38_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_0_bits = sub_crossbar_38_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_1_valid = sub_crossbar_86_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_1_bits = sub_crossbar_86_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_out_0_ready = io_out_60_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_156_io_out_1_ready = io_out_124_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_157_clock = clock;
  assign sub_crossbar_157_reset = reset;
  assign sub_crossbar_157_io_in_0_valid = sub_crossbar_41_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_0_bits = sub_crossbar_41_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_1_valid = sub_crossbar_89_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_1_bits = sub_crossbar_89_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_out_0_ready = io_out_61_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_157_io_out_1_ready = io_out_125_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_158_clock = clock;
  assign sub_crossbar_158_reset = reset;
  assign sub_crossbar_158_io_in_0_valid = sub_crossbar_44_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_0_bits = sub_crossbar_44_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_1_valid = sub_crossbar_92_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_1_bits = sub_crossbar_92_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_out_0_ready = io_out_62_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_158_io_out_1_ready = io_out_126_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_159_clock = clock;
  assign sub_crossbar_159_reset = reset;
  assign sub_crossbar_159_io_in_0_valid = sub_crossbar_47_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_0_bits = sub_crossbar_47_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_1_valid = sub_crossbar_95_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_1_bits = sub_crossbar_95_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_out_0_ready = io_out_63_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_159_io_out_1_ready = io_out_127_ready; // @[crossbar.scala 152:53]
endmodule
module RRArbiter_672(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [23:0] io_out_bits,
  output [1:0]  io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = 2'h1 == io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = 2'h1 == io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_5 = 2'h1 == io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_6 = 2'h2 == io_chosen ? io_in_2_ready : _GEN_3; // @[Arbiter.scala 41:16]
  wire  _GEN_7 = 2'h2 == io_chosen ? io_in_2_valid : _GEN_4; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_8 = 2'h2 == io_chosen ? io_in_2_bits : _GEN_5; // @[Arbiter.scala 41:16]
  wire  _GEN_9 = 2'h3 == io_chosen ? io_in_3_ready : _GEN_6; // @[Arbiter.scala 41:16]
  wire  _GEN_10 = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_11 = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg [1:0] lastGrant; // @[Reg.scala 15:16]
  wire [1:0] _GEN_12 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 2'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_2 = 2'h2 > lastGrant; // @[Arbiter.scala 67:49]
  wire  grantMask_3 = 2'h3 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  validMask_2 = io_in_2_valid & grantMask_2; // @[Arbiter.scala 68:75]
  wire  validMask_3 = io_in_3_valid & grantMask_3; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | validMask_2; // @[Arbiter.scala 31:68]
  wire  _T_3 = _T_2 | validMask_3; // @[Arbiter.scala 31:68]
  wire  _T_4 = _T_3 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_5 = _T_4 | io_in_1_valid; // @[Arbiter.scala 31:68]
  wire  _T_6 = _T_5 | io_in_2_valid; // @[Arbiter.scala 31:68]
  wire  _T_7 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_8 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_9 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_10 = ~_T_3; // @[Arbiter.scala 31:78]
  wire  _T_11 = ~_T_4; // @[Arbiter.scala 31:78]
  wire  _T_12 = ~_T_5; // @[Arbiter.scala 31:78]
  wire  _T_13 = ~_T_6; // @[Arbiter.scala 31:78]
  wire  _T_14 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_15 = _T_10; // @[Arbiter.scala 72:50]
  wire  _T_16 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_17 = grantMask_1 | _T_11; // @[Arbiter.scala 72:50]
  wire  _T_18 = _T_8 & grantMask_2; // @[Arbiter.scala 72:34]
  wire  _T_19 = _T_18 | _T_12; // @[Arbiter.scala 72:50]
  wire  _T_20 = _T_9 & grantMask_3; // @[Arbiter.scala 72:34]
  wire  _T_21 = _T_20 | _T_13; // @[Arbiter.scala 72:50]
  wire  _T_22 = _T_10 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_23 = _T_17 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_24 = _T_19 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_25 = _T_21 & io_out_ready; // @[Arbiter.scala 60:21]
  wire [1:0] _GEN_13 = io_in_2_valid ? 2'h2 : 2'h3; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_14 = io_in_1_valid ? 2'h1 : _GEN_13; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_15 = io_in_0_valid ? 2'h0 : _GEN_14; // @[Arbiter.scala 77:27]
  wire [1:0] _GEN_16 = validMask_3 ? 2'h3 : _GEN_15; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_17 = validMask_2 ? 2'h2 : _GEN_16; // @[Arbiter.scala 79:25]
  wire [1:0] choice = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 79:25]
  wire [1:0] _GEN_18 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 77:36 Arbiter.scala 79:34 Arbiter.scala 79:34 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_9; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_10; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [23:0] _io_in_io_chosen_bits = _GEN_11; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_9; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_10; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [23:0] _io_in_io_chosen_0_bits = _GEN_11; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_10 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_17 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_2_ready = _T_19 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_3_ready = _T_21 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = 2'h3 == io_chosen ? io_in_3_valid : _GEN_7; // @[Arbiter.scala 41:16]
  assign io_out_bits = 2'h3 == io_chosen ? io_in_3_bits : _GEN_8; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 ? 2'h1 : _GEN_17; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[1:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module sub_crossbar_160(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_5 = _GEN_100[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_6 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_7 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [24:0] _T_8 = _T_7[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_7[24:0]; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_12 = _GEN_101[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_13 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_14 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [24:0] _T_15 = _T_14[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_14[24:0]; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_19 = _GEN_102[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_20 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_21 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [24:0] _T_22 = _T_21[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_21[24:0]; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_26 = _GEN_103[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_27 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_28 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [24:0] _T_29 = _T_28[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_28[24:0]; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_34 = _GEN_104[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_35 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_36 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [24:0] _T_37 = _T_7[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_7[24:0]; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_41 = _GEN_105[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_42 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_43 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [24:0] _T_44 = _T_14[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_14[24:0]; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_48 = _GEN_106[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_49 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_50 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [24:0] _T_51 = _T_21[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_21[24:0]; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_55 = _GEN_107[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_56 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_57 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [24:0] _T_58 = _T_28[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_28[24:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_63 = _GEN_108[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_64 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_65 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [24:0] _T_66 = _T_7[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_7[24:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_70 = _GEN_109[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_71 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_72 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [24:0] _T_73 = _T_14[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_14[24:0]; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_77 = _GEN_110[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_78 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_79 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [24:0] _T_80 = _T_21[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_21[24:0]; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_84 = _GEN_111[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_85 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_86 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [24:0] _T_87 = _T_28[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_28[24:0]; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_92 = _GEN_112[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_93 = 24'h0 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_94 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [24:0] _T_95 = _T_7[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_7[24:0]; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_99 = _GEN_113[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_100 = 24'h1 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_101 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [24:0] _T_102 = _T_14[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_14[24:0]; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_106 = _GEN_114[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_107 = 24'h2 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_108 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [24:0] _T_109 = _T_21[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_21[24:0]; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h4; // @[crossbar.scala 262:57]
  wire [2:0] _T_113 = _GEN_115[2:0]; // @[crossbar.scala 262:57]
  wire [24:0] _T_114 = 24'h3 * 24'h1; // @[crossbar.scala 262:115]
  wire [25:0] _T_115 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [24:0] _T_116 = _T_28[24:0]; // @[crossbar.scala 262:124]
  wire [24:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_28[24:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_161(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_5 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_6 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_7 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [26:0] _T_8 = _T_7[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_7[26:0]; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_12 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_13 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_14 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [26:0] _T_15 = _T_14[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_14[26:0]; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_19 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_20 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_21 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [26:0] _T_22 = _T_21[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_21[26:0]; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_26 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_27 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_28 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [26:0] _T_29 = _T_28[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_28[26:0]; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_34 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_35 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_36 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [26:0] _T_37 = _T_7[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_7[26:0]; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_41 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_42 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_43 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [26:0] _T_44 = _T_14[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_14[26:0]; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_48 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_49 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_50 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [26:0] _T_51 = _T_21[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_21[26:0]; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_28[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_28[26:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_7[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_7[26:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_70 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_71 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_72 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [26:0] _T_73 = _T_14[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_14[26:0]; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_77 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_78 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_79 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [26:0] _T_80 = _T_21[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_21[26:0]; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_84 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_85 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_86 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [26:0] _T_87 = _T_28[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_28[26:0]; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_92 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_93 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_94 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [26:0] _T_95 = _T_7[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_7[26:0]; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_99 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_100 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_101 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [26:0] _T_102 = _T_14[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_14[26:0]; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_106 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_107 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_108 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [26:0] _T_109 = _T_21[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_21[26:0]; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_28[26:0]; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_28[26:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_162(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_7[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_7[28:0]; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_14[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_14[28:0]; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_21[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_21[28:0]; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_28[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_28[28:0]; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_7[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_7[28:0]; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_14[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_14[28:0]; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_21[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_21[28:0]; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_28[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_28[28:0]; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_7[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_7[28:0]; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_14[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_14[28:0]; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_21[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_21[28:0]; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_28[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_28[28:0]; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = {{1'd0}, _T_6}; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_7[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_7[28:0]; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = {{1'd0}, _T_13}; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_14[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_14[28:0]; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = {{1'd0}, _T_20}; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_21[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_21[28:0]; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = {{1'd0}, _T_27}; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_28[28:0]; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_28[28:0]; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_164(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_5 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_6 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_7 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_8 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_12 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_13 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_14 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_15 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_19 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_20 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_21 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_22 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_26 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_27 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_28 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_29 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_34 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_35 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_36 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_37 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_41 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_42 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_43 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_44 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_48 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_49 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_50 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_51 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_70 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_71 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_72 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_73 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_77 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_78 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_79 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_80 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_84 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_85 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_86 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_87 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_92 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_93 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_94 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_95 = _T_6 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_99 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_100 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_101 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_102 = _T_13 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_106 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_107 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_108 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_109 = _T_20 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_27 + 27'h1; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_165(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h1; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_167(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_5 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_6 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_7 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_8 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_12 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_13 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_14 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_15 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_19 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_20 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_21 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_22 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_26 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_27 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_28 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_29 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_34 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_35 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_36 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_37 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_41 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_42 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_43 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_44 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_48 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_49 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_50 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_51 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_70 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_71 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_72 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_73 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_77 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_78 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_79 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_80 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_84 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_85 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_86 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_87 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_92 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_93 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_94 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_95 = _T_6 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_99 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_100 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_101 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_102 = _T_13 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_106 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_107 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_108 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_109 = _T_20 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_27 + 27'h2; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_168(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h2; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_170(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_5 = _GEN_100[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_6 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_7 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_8 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_12 = _GEN_101[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_13 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_14 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_15 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_19 = _GEN_102[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_20 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_21 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_22 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_26 = _GEN_103[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_27 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_28 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_29 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_34 = _GEN_104[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_35 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_36 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_37 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_41 = _GEN_105[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_42 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_43 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_44 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_48 = _GEN_106[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_49 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_50 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_51 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_55 = _GEN_107[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_56 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_57 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_58 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_63 = _GEN_108[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_64 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_65 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_66 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_70 = _GEN_109[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_71 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_72 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_73 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_77 = _GEN_110[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_78 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_79 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_80 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_84 = _GEN_111[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_85 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_86 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_87 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_92 = _GEN_112[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_93 = 24'h0 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_94 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_95 = _T_6 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_99 = _GEN_113[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_100 = 24'h1 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_101 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_102 = _T_13 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_106 = _GEN_114[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_107 = 24'h2 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_108 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_109 = _T_20 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h10; // @[crossbar.scala 262:57]
  wire [4:0] _T_113 = _GEN_115[4:0]; // @[crossbar.scala 262:57]
  wire [26:0] _T_114 = 24'h3 * 24'h4; // @[crossbar.scala 262:115]
  wire [27:0] _T_115 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _T_116 = _T_27 + 27'h3; // @[crossbar.scala 262:124]
  wire [26:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_171(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h3; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_174(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h4; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_177(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h5; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_180(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h6; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_183(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h7; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_186(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h8; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_189(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'h9; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_192(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'ha; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_195(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'hb; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_198(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'hc; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_201(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'hd; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_204(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'he; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_207(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_6_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_6_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_6_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_7_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_7_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_8_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_8_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_9_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_9_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_10_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_10_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_10_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_2_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_2_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_2_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_2_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_11_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_11_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_11_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_12_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_12_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_13_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_13_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_14_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_14_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_15_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_15_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_15_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_3_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_2_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_2_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_in_3_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_in_3_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_3_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_3_io_out_bits; // @[crossbar.scala 231:39]
  wire [1:0] RRArbiter_3_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_16_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_16_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_16_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_17_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_17_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_18_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_18_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_19_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_19_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:9]
  wire  _T_3 = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:9]
  wire  _T_4 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_100 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_5 = _GEN_100[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_6 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_7 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_8 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_84 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_9 = _GEN_84 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_10 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_11 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_9 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_9 & _T_11; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_101 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_12 = _GEN_101[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_13 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_14 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_15 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_85 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_16 = _GEN_84 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_17 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_18 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_16 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_16 ? _T_18 : _GEN_2; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_102 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_19 = _GEN_102[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_20 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_21 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_22 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_86 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_23 = _GEN_84 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_24 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_25 = ~fifo_cxb_24_3_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_6 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_7 = _T_23 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_8 = _T_23 ? _T_25 : _GEN_5; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_103 = fifo_cxb_24_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_26 = _GEN_103[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_27 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_28 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_29 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_87 = {{22'd0}, _T_5}; // @[crossbar.scala 262:68]
  wire  _T_30 = _GEN_84 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_31 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_32 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_9 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_10 = _T_30 & _T_4; // @[crossbar.scala 262:136]
  wire  _GEN_11 = _T_30 ? _T_32 : _GEN_8; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_4 & _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_13 = _T_4 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_14 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_15 = _T_4 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_16 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_17 = _T_4 & _GEN_7; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_18 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_19 = _T_4 & _GEN_10; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_20 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_33 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_104 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_34 = _GEN_104[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_35 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_36 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_37 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_88 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_38 = _GEN_88 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_39 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_40 = ~fifo_cxb_24_6_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_21 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_22 = _T_38 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_23 = _T_38 & _T_40; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_105 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_41 = _GEN_105[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_42 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_43 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_44 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_89 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_45 = _GEN_88 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_46 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_47 = ~fifo_cxb_24_7_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_24 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_25 = _T_45 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_26 = _T_45 ? _T_47 : _GEN_23; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_106 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_48 = _GEN_106[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_49 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_50 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_51 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_90 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_52 = _GEN_88 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_53 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_54 = ~fifo_cxb_24_8_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_27 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_28 = _T_52 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_29 = _T_52 ? _T_54 : _GEN_26; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_107 = fifo_cxb_24_5_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_55 = _GEN_107[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_56 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_57 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_58 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_91 = {{22'd0}, _T_34}; // @[crossbar.scala 262:68]
  wire  _T_59 = _GEN_88 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_60 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 264:21]
  wire  _T_61 = ~fifo_cxb_24_9_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_30 = fifo_cxb_24_5_dout; // @[crossbar.scala 262:136]
  wire  _GEN_31 = _T_59 & _T_33; // @[crossbar.scala 262:136]
  wire  _GEN_32 = _T_59 ? _T_61 : _GEN_29; // @[crossbar.scala 262:136]
  wire  _GEN_33 = _T_33 & _GEN_32; // @[crossbar.scala 258:45]
  wire  _GEN_34 = _T_33 & _GEN_22; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_35 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_36 = _T_33 & _GEN_25; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_37 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_38 = _T_33 & _GEN_28; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_39 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _GEN_40 = _T_33 & _GEN_31; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_41 = _GEN_21; // @[crossbar.scala 258:45]
  wire  _T_62 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_108 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_63 = _GEN_108[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_64 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_65 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_66 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_92 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_67 = _GEN_92 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_68 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_69 = ~fifo_cxb_24_11_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_42 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_43 = _T_67 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_44 = _T_67 & _T_69; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_109 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_70 = _GEN_109[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_71 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_72 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_73 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_93 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_74 = _GEN_92 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_75 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_76 = ~fifo_cxb_24_12_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_45 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_46 = _T_74 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_47 = _T_74 ? _T_76 : _GEN_44; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_110 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_77 = _GEN_110[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_78 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_79 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_80 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_94 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_81 = _GEN_92 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_82 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_83 = ~fifo_cxb_24_13_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_48 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_49 = _T_81 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_50 = _T_81 ? _T_83 : _GEN_47; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_111 = fifo_cxb_24_10_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_84 = _GEN_111[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_85 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_86 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_87 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_95 = {{22'd0}, _T_63}; // @[crossbar.scala 262:68]
  wire  _T_88 = _GEN_92 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_89 = ~fifo_cxb_24_10_empty; // @[crossbar.scala 264:21]
  wire  _T_90 = ~fifo_cxb_24_14_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_51 = fifo_cxb_24_10_dout; // @[crossbar.scala 262:136]
  wire  _GEN_52 = _T_88 & _T_62; // @[crossbar.scala 262:136]
  wire  _GEN_53 = _T_88 ? _T_90 : _GEN_50; // @[crossbar.scala 262:136]
  wire  _GEN_54 = _T_62 & _GEN_53; // @[crossbar.scala 258:45]
  wire  _GEN_55 = _T_62 & _GEN_43; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_56 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_57 = _T_62 & _GEN_46; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_58 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_59 = _T_62 & _GEN_49; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_60 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _GEN_61 = _T_62 & _GEN_52; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_62 = _GEN_42; // @[crossbar.scala 258:45]
  wire  _T_91 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_112 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_92 = _GEN_112[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_93 = 24'h0 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_94 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_95 = _T_6 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_96 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_96 = _GEN_96 == _T_8; // @[crossbar.scala 262:68]
  wire  _T_97 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_98 = ~fifo_cxb_24_16_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_63 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_64 = _T_96 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_65 = _T_96 & _T_98; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_113 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_99 = _GEN_113[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_100 = 24'h1 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_101 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_102 = _T_13 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_97 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_103 = _GEN_96 == _T_15; // @[crossbar.scala 262:68]
  wire  _T_104 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_105 = ~fifo_cxb_24_17_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_66 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_67 = _T_103 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_68 = _T_103 ? _T_105 : _GEN_65; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_114 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_106 = _GEN_114[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_107 = 24'h2 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_108 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_109 = _T_20 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_98 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_110 = _GEN_96 == _T_22; // @[crossbar.scala 262:68]
  wire  _T_111 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_112 = ~fifo_cxb_24_18_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_69 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_70 = _T_110 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_71 = _T_110 ? _T_112 : _GEN_68; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_115 = fifo_cxb_24_15_dout % 24'h40; // @[crossbar.scala 262:57]
  wire [6:0] _T_113 = _GEN_115[6:0]; // @[crossbar.scala 262:57]
  wire [28:0] _T_114 = 24'h3 * 24'h10; // @[crossbar.scala 262:115]
  wire [29:0] _T_115 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _T_116 = _T_27 + 29'hf; // @[crossbar.scala 262:124]
  wire [28:0] _GEN_99 = {{22'd0}, _T_92}; // @[crossbar.scala 262:68]
  wire  _T_117 = _GEN_96 == _T_29; // @[crossbar.scala 262:68]
  wire  _T_118 = ~fifo_cxb_24_15_empty; // @[crossbar.scala 264:21]
  wire  _T_119 = ~fifo_cxb_24_19_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_72 = fifo_cxb_24_15_dout; // @[crossbar.scala 262:136]
  wire  _GEN_73 = _T_117 & _T_91; // @[crossbar.scala 262:136]
  wire  _GEN_74 = _T_117 ? _T_119 : _GEN_71; // @[crossbar.scala 262:136]
  wire  _GEN_75 = _T_91 & _GEN_74; // @[crossbar.scala 258:45]
  wire  _GEN_76 = _T_91 & _GEN_64; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_77 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_78 = _T_91 & _GEN_67; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_79 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_80 = _T_91 & _GEN_70; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_81 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _GEN_82 = _T_91 & _GEN_73; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_83 = _GEN_63; // @[crossbar.scala 258:45]
  wire  _T_120 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_121 = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:13]
  wire  _T_122 = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:13]
  wire  _T_123 = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:13]
  wire  _T_124 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_125 = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:13]
  wire  _T_126 = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:13]
  wire  _T_127 = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:13]
  wire  _T_128 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:13]
  wire  _T_129 = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:13]
  wire  _T_130 = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:13]
  wire  _T_131 = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:13]
  wire  _T_132 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_133 = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:13]
  wire  _T_134 = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:13]
  wire  _T_135 = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_672 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_in_2_ready(RRArbiter_io_in_2_ready),
    .io_in_2_valid(RRArbiter_io_in_2_valid),
    .io_in_2_bits(RRArbiter_io_in_2_bits),
    .io_in_3_ready(RRArbiter_io_in_3_ready),
    .io_in_3_valid(RRArbiter_io_in_3_valid),
    .io_in_3_bits(RRArbiter_io_in_3_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  RRArbiter_672 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_in_2_ready(RRArbiter_1_io_in_2_ready),
    .io_in_2_valid(RRArbiter_1_io_in_2_valid),
    .io_in_2_bits(RRArbiter_1_io_in_2_bits),
    .io_in_3_ready(RRArbiter_1_io_in_3_ready),
    .io_in_3_valid(RRArbiter_1_io_in_3_valid),
    .io_in_3_bits(RRArbiter_1_io_in_3_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_6 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_6_rst),
    .clk(fifo_cxb_24_6_clk),
    .din(fifo_cxb_24_6_din),
    .wr_en(fifo_cxb_24_6_wr_en),
    .rd_en(fifo_cxb_24_6_rd_en),
    .dout(fifo_cxb_24_6_dout),
    .full(fifo_cxb_24_6_full),
    .empty(fifo_cxb_24_6_empty)
  );
  fifo_cxb_24 fifo_cxb_24_7 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_7_rst),
    .clk(fifo_cxb_24_7_clk),
    .din(fifo_cxb_24_7_din),
    .wr_en(fifo_cxb_24_7_wr_en),
    .rd_en(fifo_cxb_24_7_rd_en),
    .dout(fifo_cxb_24_7_dout),
    .full(fifo_cxb_24_7_full),
    .empty(fifo_cxb_24_7_empty)
  );
  fifo_cxb_24 fifo_cxb_24_8 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_8_rst),
    .clk(fifo_cxb_24_8_clk),
    .din(fifo_cxb_24_8_din),
    .wr_en(fifo_cxb_24_8_wr_en),
    .rd_en(fifo_cxb_24_8_rd_en),
    .dout(fifo_cxb_24_8_dout),
    .full(fifo_cxb_24_8_full),
    .empty(fifo_cxb_24_8_empty)
  );
  fifo_cxb_24 fifo_cxb_24_9 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_9_rst),
    .clk(fifo_cxb_24_9_clk),
    .din(fifo_cxb_24_9_din),
    .wr_en(fifo_cxb_24_9_wr_en),
    .rd_en(fifo_cxb_24_9_rd_en),
    .dout(fifo_cxb_24_9_dout),
    .full(fifo_cxb_24_9_full),
    .empty(fifo_cxb_24_9_empty)
  );
  fifo_cxb_24 fifo_cxb_24_10 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_10_rst),
    .clk(fifo_cxb_24_10_clk),
    .din(fifo_cxb_24_10_din),
    .wr_en(fifo_cxb_24_10_wr_en),
    .rd_en(fifo_cxb_24_10_rd_en),
    .dout(fifo_cxb_24_10_dout),
    .full(fifo_cxb_24_10_full),
    .empty(fifo_cxb_24_10_empty)
  );
  RRArbiter_672 RRArbiter_2 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_2_clock),
    .reset(RRArbiter_2_reset),
    .io_in_0_ready(RRArbiter_2_io_in_0_ready),
    .io_in_0_valid(RRArbiter_2_io_in_0_valid),
    .io_in_0_bits(RRArbiter_2_io_in_0_bits),
    .io_in_1_ready(RRArbiter_2_io_in_1_ready),
    .io_in_1_valid(RRArbiter_2_io_in_1_valid),
    .io_in_1_bits(RRArbiter_2_io_in_1_bits),
    .io_in_2_ready(RRArbiter_2_io_in_2_ready),
    .io_in_2_valid(RRArbiter_2_io_in_2_valid),
    .io_in_2_bits(RRArbiter_2_io_in_2_bits),
    .io_in_3_ready(RRArbiter_2_io_in_3_ready),
    .io_in_3_valid(RRArbiter_2_io_in_3_valid),
    .io_in_3_bits(RRArbiter_2_io_in_3_bits),
    .io_out_ready(RRArbiter_2_io_out_ready),
    .io_out_valid(RRArbiter_2_io_out_valid),
    .io_out_bits(RRArbiter_2_io_out_bits),
    .io_chosen(RRArbiter_2_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_11 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_11_rst),
    .clk(fifo_cxb_24_11_clk),
    .din(fifo_cxb_24_11_din),
    .wr_en(fifo_cxb_24_11_wr_en),
    .rd_en(fifo_cxb_24_11_rd_en),
    .dout(fifo_cxb_24_11_dout),
    .full(fifo_cxb_24_11_full),
    .empty(fifo_cxb_24_11_empty)
  );
  fifo_cxb_24 fifo_cxb_24_12 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_12_rst),
    .clk(fifo_cxb_24_12_clk),
    .din(fifo_cxb_24_12_din),
    .wr_en(fifo_cxb_24_12_wr_en),
    .rd_en(fifo_cxb_24_12_rd_en),
    .dout(fifo_cxb_24_12_dout),
    .full(fifo_cxb_24_12_full),
    .empty(fifo_cxb_24_12_empty)
  );
  fifo_cxb_24 fifo_cxb_24_13 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_13_rst),
    .clk(fifo_cxb_24_13_clk),
    .din(fifo_cxb_24_13_din),
    .wr_en(fifo_cxb_24_13_wr_en),
    .rd_en(fifo_cxb_24_13_rd_en),
    .dout(fifo_cxb_24_13_dout),
    .full(fifo_cxb_24_13_full),
    .empty(fifo_cxb_24_13_empty)
  );
  fifo_cxb_24 fifo_cxb_24_14 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_14_rst),
    .clk(fifo_cxb_24_14_clk),
    .din(fifo_cxb_24_14_din),
    .wr_en(fifo_cxb_24_14_wr_en),
    .rd_en(fifo_cxb_24_14_rd_en),
    .dout(fifo_cxb_24_14_dout),
    .full(fifo_cxb_24_14_full),
    .empty(fifo_cxb_24_14_empty)
  );
  fifo_cxb_24 fifo_cxb_24_15 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_15_rst),
    .clk(fifo_cxb_24_15_clk),
    .din(fifo_cxb_24_15_din),
    .wr_en(fifo_cxb_24_15_wr_en),
    .rd_en(fifo_cxb_24_15_rd_en),
    .dout(fifo_cxb_24_15_dout),
    .full(fifo_cxb_24_15_full),
    .empty(fifo_cxb_24_15_empty)
  );
  RRArbiter_672 RRArbiter_3 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_3_clock),
    .reset(RRArbiter_3_reset),
    .io_in_0_ready(RRArbiter_3_io_in_0_ready),
    .io_in_0_valid(RRArbiter_3_io_in_0_valid),
    .io_in_0_bits(RRArbiter_3_io_in_0_bits),
    .io_in_1_ready(RRArbiter_3_io_in_1_ready),
    .io_in_1_valid(RRArbiter_3_io_in_1_valid),
    .io_in_1_bits(RRArbiter_3_io_in_1_bits),
    .io_in_2_ready(RRArbiter_3_io_in_2_ready),
    .io_in_2_valid(RRArbiter_3_io_in_2_valid),
    .io_in_2_bits(RRArbiter_3_io_in_2_bits),
    .io_in_3_ready(RRArbiter_3_io_in_3_ready),
    .io_in_3_valid(RRArbiter_3_io_in_3_valid),
    .io_in_3_bits(RRArbiter_3_io_in_3_bits),
    .io_out_ready(RRArbiter_3_io_out_ready),
    .io_out_valid(RRArbiter_3_io_out_valid),
    .io_out_bits(RRArbiter_3_io_out_bits),
    .io_chosen(RRArbiter_3_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_16 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_16_rst),
    .clk(fifo_cxb_24_16_clk),
    .din(fifo_cxb_24_16_din),
    .wr_en(fifo_cxb_24_16_wr_en),
    .rd_en(fifo_cxb_24_16_rd_en),
    .dout(fifo_cxb_24_16_dout),
    .full(fifo_cxb_24_16_full),
    .empty(fifo_cxb_24_16_empty)
  );
  fifo_cxb_24 fifo_cxb_24_17 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_17_rst),
    .clk(fifo_cxb_24_17_clk),
    .din(fifo_cxb_24_17_din),
    .wr_en(fifo_cxb_24_17_wr_en),
    .rd_en(fifo_cxb_24_17_rd_en),
    .dout(fifo_cxb_24_17_dout),
    .full(fifo_cxb_24_17_full),
    .empty(fifo_cxb_24_17_empty)
  );
  fifo_cxb_24 fifo_cxb_24_18 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_18_rst),
    .clk(fifo_cxb_24_18_clk),
    .din(fifo_cxb_24_18_din),
    .wr_en(fifo_cxb_24_18_wr_en),
    .rd_en(fifo_cxb_24_18_rd_en),
    .dout(fifo_cxb_24_18_dout),
    .full(fifo_cxb_24_18_full),
    .empty(fifo_cxb_24_18_empty)
  );
  fifo_cxb_24 fifo_cxb_24_19 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_19_rst),
    .clk(fifo_cxb_24_19_clk),
    .din(fifo_cxb_24_19_din),
    .wr_en(fifo_cxb_24_19_wr_en),
    .rd_en(fifo_cxb_24_19_rd_en),
    .dout(fifo_cxb_24_19_dout),
    .full(fifo_cxb_24_19_full),
    .empty(fifo_cxb_24_19_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_5_full; // @[crossbar.scala 243:45]
  assign io_in_2_ready = ~fifo_cxb_24_10_full; // @[crossbar.scala 243:45]
  assign io_in_3_ready = ~fifo_cxb_24_15_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_2_valid = RRArbiter_2_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_2_bits = RRArbiter_2_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_3_valid = RRArbiter_3_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_3_bits = RRArbiter_3_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_4 & _GEN_11; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_6_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_6_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_2_valid = ~fifo_cxb_24_11_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_2_bits = fifo_cxb_24_11_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_3_valid = ~fifo_cxb_24_16_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_3_bits = fifo_cxb_24_16_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_4 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_4 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_3_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_3_wr_en = _T_4 & _GEN_7; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_3_rd_en = RRArbiter_2_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_4 & _GEN_10; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_3_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_5_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_5_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_5_rd_en = _T_33 & _GEN_32; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_7_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_7_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_2_valid = ~fifo_cxb_24_12_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_2_bits = fifo_cxb_24_12_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_3_valid = ~fifo_cxb_24_17_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_3_bits = fifo_cxb_24_17_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_6_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_6_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_6_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_6_wr_en = _T_33 & _GEN_22; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_6_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_7_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_7_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_7_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_7_wr_en = _T_33 & _GEN_25; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_7_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_8_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_8_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_8_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_8_wr_en = _T_33 & _GEN_28; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_8_rd_en = RRArbiter_2_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_9_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_9_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_9_din = fifo_cxb_24_5_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_9_wr_en = _T_33 & _GEN_31; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_9_rd_en = RRArbiter_3_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_10_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_10_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_10_din = io_in_2_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_10_wr_en = io_in_2_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_10_rd_en = _T_62 & _GEN_53; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_2_clock = clock;
  assign RRArbiter_2_reset = reset;
  assign RRArbiter_2_io_in_0_valid = ~fifo_cxb_24_3_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_0_bits = fifo_cxb_24_3_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_1_valid = ~fifo_cxb_24_8_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_1_bits = fifo_cxb_24_8_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_2_valid = ~fifo_cxb_24_13_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_2_bits = fifo_cxb_24_13_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_in_3_valid = ~fifo_cxb_24_18_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_2_io_in_3_bits = fifo_cxb_24_18_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_2_io_out_ready = io_out_2_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_11_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_11_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_11_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_11_wr_en = _T_62 & _GEN_43; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_11_rd_en = RRArbiter_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_12_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_12_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_12_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_12_wr_en = _T_62 & _GEN_46; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_12_rd_en = RRArbiter_1_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_13_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_13_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_13_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_13_wr_en = _T_62 & _GEN_49; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_13_rd_en = RRArbiter_2_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_14_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_14_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_14_din = fifo_cxb_24_10_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_14_wr_en = _T_62 & _GEN_52; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_14_rd_en = RRArbiter_3_io_in_2_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_15_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_15_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_15_din = io_in_3_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_15_wr_en = io_in_3_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_15_rd_en = _T_91 & _GEN_74; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_3_clock = clock;
  assign RRArbiter_3_reset = reset;
  assign RRArbiter_3_io_in_0_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_0_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_1_valid = ~fifo_cxb_24_9_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_1_bits = fifo_cxb_24_9_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_2_valid = ~fifo_cxb_24_14_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_2_bits = fifo_cxb_24_14_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_in_3_valid = ~fifo_cxb_24_19_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_3_io_in_3_bits = fifo_cxb_24_19_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_3_io_out_ready = io_out_3_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_16_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_16_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_16_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_16_wr_en = _T_91 & _GEN_64; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_16_rd_en = RRArbiter_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_17_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_17_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_17_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_17_wr_en = _T_91 & _GEN_67; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_17_rd_en = RRArbiter_1_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_18_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_18_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_18_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_18_wr_en = _T_91 & _GEN_70; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_18_rd_en = RRArbiter_2_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_19_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_19_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_19_din = fifo_cxb_24_15_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_19_wr_en = _T_91 & _GEN_73; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_19_rd_en = RRArbiter_3_io_in_3_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module RRArbiter_1056(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_ready,
  output        io_out_valid,
  output [23:0] io_out_bits,
  output        io_chosen
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_REG_INIT
  wire  _GEN_0 = io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_1 = io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_2 = io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _GEN_3 = io_chosen ? io_in_1_ready : io_in_0_ready; // @[Arbiter.scala 41:16]
  wire  _GEN_4 = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  wire [23:0] _GEN_5 = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 41:16]
  wire  _T = io_out_ready & io_out_valid; // @[Decoupled.scala 40:37]
  reg  lastGrant; // @[Reg.scala 15:16]
  wire  _GEN_6 = _T ? io_chosen : lastGrant; // @[Reg.scala 16:19]
  wire  grantMask_0 = 1'h0; // @[Arbiter.scala 67:49]
  wire  grantMask_1 = 1'h1 > lastGrant; // @[Arbiter.scala 67:49]
  wire  validMask_0 = 1'h0; // @[Arbiter.scala 68:75]
  wire  validMask_1 = io_in_1_valid & grantMask_1; // @[Arbiter.scala 68:75]
  wire  _T_1 = validMask_1; // @[Arbiter.scala 31:68]
  wire  _T_2 = validMask_1 | io_in_0_valid; // @[Arbiter.scala 31:68]
  wire  _T_3 = 1'h1; // @[Arbiter.scala 31:78]
  wire  _T_4 = ~validMask_1; // @[Arbiter.scala 31:78]
  wire  _T_5 = ~_T_2; // @[Arbiter.scala 31:78]
  wire  _T_6 = 1'h0; // @[Arbiter.scala 72:34]
  wire  _T_7 = _T_4; // @[Arbiter.scala 72:50]
  wire  _T_8 = grantMask_1; // @[Arbiter.scala 72:34]
  wire  _T_9 = grantMask_1 | _T_5; // @[Arbiter.scala 72:50]
  wire  _T_10 = _T_4 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _T_11 = _T_9 & io_out_ready; // @[Arbiter.scala 60:21]
  wire  _GEN_7 = io_in_0_valid ? 1'h0 : 1'h1; // @[Arbiter.scala 77:27]
  wire  choice = validMask_1 | _GEN_7; // @[Arbiter.scala 79:25]
  wire  _GEN_8 = choice; // @[Arbiter.scala 77:36 Arbiter.scala 79:34]
  wire  _io_in_io_chosen_ready = _GEN_3; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_valid = _GEN_4; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire [23:0] _io_in_io_chosen_bits = _GEN_5; // @[Arbiter.scala 41:16 Arbiter.scala 41:16 Arbiter.scala 41:16]
  wire  _io_in_io_chosen_0_ready = _GEN_3; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire  _io_in_io_chosen_0_valid = _GEN_4; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  wire [23:0] _io_in_io_chosen_0_bits = _GEN_5; // @[Arbiter.scala 42:15 Arbiter.scala 42:15 Arbiter.scala 42:15]
  assign io_in_0_ready = _T_4 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_in_1_ready = _T_9 & io_out_ready; // @[Arbiter.scala 60:16]
  assign io_out_valid = io_chosen ? io_in_1_valid : io_in_0_valid; // @[Arbiter.scala 41:16]
  assign io_out_bits = io_chosen ? io_in_1_bits : io_in_0_bits; // @[Arbiter.scala 42:15]
  assign io_chosen = validMask_1 | _GEN_7; // @[Arbiter.scala 40:13]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
	lastGrant = 1'b0;
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  lastGrant = _RAND_0[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (_T) begin
      lastGrant <= io_chosen;
    end
  end
endmodule
module sub_crossbar_256(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = {{1'd0}, _T_4}; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_5[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_5[30:0]; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = {{1'd0}, _T_11}; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_12[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_12[30:0]; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = {{1'd0}, _T_4}; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_5[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_5[30:0]; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = {{1'd0}, _T_11}; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_12[30:0]; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_12[30:0]; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_257(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_258(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_259(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_260(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h4; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_261(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h5; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_262(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h6; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_263(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h7; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_264(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h8; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_265(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h9; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_266(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'ha; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_267(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'hb; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_268(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'hc; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_269(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'hd; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_270(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'he; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_271(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'hf; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_272(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h10; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_273(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h11; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_274(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h12; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_275(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h13; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_276(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h14; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_277(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h15; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_278(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h16; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_279(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h17; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_280(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h18; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_281(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h19; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_282(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_283(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_284(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_285(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_286(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_287(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h1f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_288(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h20; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_289(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h21; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_290(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h22; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_291(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h23; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_292(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h24; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_293(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h25; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_294(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h26; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_295(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h27; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_296(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h28; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_297(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h29; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_298(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_299(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_300(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_301(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_302(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_303(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h2f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_304(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h30; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_305(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h31; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_306(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h32; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_307(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h33; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_308(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h34; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_309(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h35; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_310(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h36; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_311(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h37; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_312(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h38; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_313(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h39; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_314(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3a; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_315(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3b; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_316(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3c; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_317(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3d; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_318(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3e; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module sub_crossbar_319(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits
);
  wire  fifo_cxb_24_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_1_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_1_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_1_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_2_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_2_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_3_rst; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_clk; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_din; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_wr_en; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_rd_en; // @[crossbar.scala 230:38]
  wire [23:0] fifo_cxb_24_3_dout; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_full; // @[crossbar.scala 230:38]
  wire  fifo_cxb_24_3_empty; // @[crossbar.scala 230:38]
  wire  RRArbiter_1_clock; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_reset; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_0_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_0_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_in_1_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_in_1_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_ready; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_out_valid; // @[crossbar.scala 231:39]
  wire [23:0] RRArbiter_1_io_out_bits; // @[crossbar.scala 231:39]
  wire  RRArbiter_1_io_chosen; // @[crossbar.scala 231:39]
  wire  fifo_cxb_24_4_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_4_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_4_empty; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rst; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_clk; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_din; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_wr_en; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_rd_en; // @[crossbar.scala 233:47]
  wire [23:0] fifo_cxb_24_5_dout; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_full; // @[crossbar.scala 233:47]
  wire  fifo_cxb_24_5_empty; // @[crossbar.scala 233:47]
  wire  _T = ~fifo_cxb_24_full; // @[crossbar.scala 243:9]
  wire  _T_1 = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:9]
  wire  _T_2 = ~fifo_cxb_24_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_26 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_3 = _GEN_26[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_4 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_5 = _T_4 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_6 = _T_4 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_22 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_7 = _GEN_22 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_8 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_9 = ~fifo_cxb_24_1_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_0 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_1 = _T_7 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_2 = _T_7 & _T_9; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_27 = fifo_cxb_24_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_10 = _GEN_27[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_11 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_12 = _T_11 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_13 = _T_11 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_23 = {{23'd0}, _T_3}; // @[crossbar.scala 262:68]
  wire  _T_14 = _GEN_22 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_15 = ~fifo_cxb_24_empty; // @[crossbar.scala 264:21]
  wire  _T_16 = ~fifo_cxb_24_2_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_3 = fifo_cxb_24_dout; // @[crossbar.scala 262:136]
  wire  _GEN_4 = _T_14 & _T_2; // @[crossbar.scala 262:136]
  wire  _GEN_5 = _T_14 ? _T_16 : _GEN_2; // @[crossbar.scala 262:136]
  wire  _GEN_6 = _T_2 & _GEN_5; // @[crossbar.scala 258:45]
  wire  _GEN_7 = _T_2 & _GEN_1; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_8 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _GEN_9 = _T_2 & _GEN_4; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_10 = _GEN_0; // @[crossbar.scala 258:45]
  wire  _T_17 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 258:14]
  wire [23:0] _GEN_28 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_18 = _GEN_28[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_19 = 24'h0 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_20 = _T_4 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_21 = _T_4 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_24 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_22 = _GEN_24 == _T_6; // @[crossbar.scala 262:68]
  wire  _T_23 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_24 = ~fifo_cxb_24_4_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_11 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_12 = _T_22 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_13 = _T_22 & _T_24; // @[crossbar.scala 262:136]
  wire [23:0] _GEN_29 = fifo_cxb_24_3_dout % 24'h80; // @[crossbar.scala 262:57]
  wire [7:0] _T_25 = _GEN_29[7:0]; // @[crossbar.scala 262:57]
  wire [30:0] _T_26 = 24'h1 * 24'h40; // @[crossbar.scala 262:115]
  wire [31:0] _T_27 = _T_11 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _T_28 = _T_11 + 31'h3f; // @[crossbar.scala 262:124]
  wire [30:0] _GEN_25 = {{23'd0}, _T_18}; // @[crossbar.scala 262:68]
  wire  _T_29 = _GEN_24 == _T_13; // @[crossbar.scala 262:68]
  wire  _T_30 = ~fifo_cxb_24_3_empty; // @[crossbar.scala 264:21]
  wire  _T_31 = ~fifo_cxb_24_5_full; // @[crossbar.scala 265:54]
  wire [23:0] _GEN_14 = fifo_cxb_24_3_dout; // @[crossbar.scala 262:136]
  wire  _GEN_15 = _T_29 & _T_17; // @[crossbar.scala 262:136]
  wire  _GEN_16 = _T_29 ? _T_31 : _GEN_13; // @[crossbar.scala 262:136]
  wire  _GEN_17 = _T_17 & _GEN_16; // @[crossbar.scala 258:45]
  wire  _GEN_18 = _T_17 & _GEN_12; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_19 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _GEN_20 = _T_17 & _GEN_15; // @[crossbar.scala 258:45]
  wire [23:0] _GEN_21 = _GEN_11; // @[crossbar.scala 258:45]
  wire  _T_32 = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:13]
  wire  _T_33 = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:13]
  wire  _T_34 = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:13]
  wire  _T_35 = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:13]
  fifo_cxb_24 fifo_cxb_24 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_rst),
    .clk(fifo_cxb_24_clk),
    .din(fifo_cxb_24_din),
    .wr_en(fifo_cxb_24_wr_en),
    .rd_en(fifo_cxb_24_rd_en),
    .dout(fifo_cxb_24_dout),
    .full(fifo_cxb_24_full),
    .empty(fifo_cxb_24_empty)
  );
  RRArbiter_1056 RRArbiter ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_clock),
    .reset(RRArbiter_reset),
    .io_in_0_ready(RRArbiter_io_in_0_ready),
    .io_in_0_valid(RRArbiter_io_in_0_valid),
    .io_in_0_bits(RRArbiter_io_in_0_bits),
    .io_in_1_ready(RRArbiter_io_in_1_ready),
    .io_in_1_valid(RRArbiter_io_in_1_valid),
    .io_in_1_bits(RRArbiter_io_in_1_bits),
    .io_out_ready(RRArbiter_io_out_ready),
    .io_out_valid(RRArbiter_io_out_valid),
    .io_out_bits(RRArbiter_io_out_bits),
    .io_chosen(RRArbiter_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_1 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_1_rst),
    .clk(fifo_cxb_24_1_clk),
    .din(fifo_cxb_24_1_din),
    .wr_en(fifo_cxb_24_1_wr_en),
    .rd_en(fifo_cxb_24_1_rd_en),
    .dout(fifo_cxb_24_1_dout),
    .full(fifo_cxb_24_1_full),
    .empty(fifo_cxb_24_1_empty)
  );
  fifo_cxb_24 fifo_cxb_24_2 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_2_rst),
    .clk(fifo_cxb_24_2_clk),
    .din(fifo_cxb_24_2_din),
    .wr_en(fifo_cxb_24_2_wr_en),
    .rd_en(fifo_cxb_24_2_rd_en),
    .dout(fifo_cxb_24_2_dout),
    .full(fifo_cxb_24_2_full),
    .empty(fifo_cxb_24_2_empty)
  );
  fifo_cxb_24 fifo_cxb_24_3 ( // @[crossbar.scala 230:38]
    .rst(fifo_cxb_24_3_rst),
    .clk(fifo_cxb_24_3_clk),
    .din(fifo_cxb_24_3_din),
    .wr_en(fifo_cxb_24_3_wr_en),
    .rd_en(fifo_cxb_24_3_rd_en),
    .dout(fifo_cxb_24_3_dout),
    .full(fifo_cxb_24_3_full),
    .empty(fifo_cxb_24_3_empty)
  );
  RRArbiter_1056 RRArbiter_1 ( // @[crossbar.scala 231:39]
    .clock(RRArbiter_1_clock),
    .reset(RRArbiter_1_reset),
    .io_in_0_ready(RRArbiter_1_io_in_0_ready),
    .io_in_0_valid(RRArbiter_1_io_in_0_valid),
    .io_in_0_bits(RRArbiter_1_io_in_0_bits),
    .io_in_1_ready(RRArbiter_1_io_in_1_ready),
    .io_in_1_valid(RRArbiter_1_io_in_1_valid),
    .io_in_1_bits(RRArbiter_1_io_in_1_bits),
    .io_out_ready(RRArbiter_1_io_out_ready),
    .io_out_valid(RRArbiter_1_io_out_valid),
    .io_out_bits(RRArbiter_1_io_out_bits),
    .io_chosen(RRArbiter_1_io_chosen)
  );
  fifo_cxb_24 fifo_cxb_24_4 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_4_rst),
    .clk(fifo_cxb_24_4_clk),
    .din(fifo_cxb_24_4_din),
    .wr_en(fifo_cxb_24_4_wr_en),
    .rd_en(fifo_cxb_24_4_rd_en),
    .dout(fifo_cxb_24_4_dout),
    .full(fifo_cxb_24_4_full),
    .empty(fifo_cxb_24_4_empty)
  );
  fifo_cxb_24 fifo_cxb_24_5 ( // @[crossbar.scala 233:47]
    .rst(fifo_cxb_24_5_rst),
    .clk(fifo_cxb_24_5_clk),
    .din(fifo_cxb_24_5_din),
    .wr_en(fifo_cxb_24_5_wr_en),
    .rd_en(fifo_cxb_24_5_rd_en),
    .dout(fifo_cxb_24_5_dout),
    .full(fifo_cxb_24_5_full),
    .empty(fifo_cxb_24_5_empty)
  );
  assign io_in_0_ready = ~fifo_cxb_24_full; // @[crossbar.scala 243:45]
  assign io_in_1_ready = ~fifo_cxb_24_3_full; // @[crossbar.scala 243:45]
  assign io_out_0_valid = RRArbiter_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_0_bits = RRArbiter_io_out_bits; // @[crossbar.scala 289:38]
  assign io_out_1_valid = RRArbiter_1_io_out_valid; // @[crossbar.scala 289:38]
  assign io_out_1_bits = RRArbiter_1_io_out_bits; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_din = io_in_0_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_wr_en = io_in_0_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_rd_en = _T_2 & _GEN_5; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_clock = clock;
  assign RRArbiter_reset = reset;
  assign RRArbiter_io_in_0_valid = ~fifo_cxb_24_1_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_0_bits = fifo_cxb_24_1_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_in_1_valid = ~fifo_cxb_24_4_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_io_in_1_bits = fifo_cxb_24_4_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_io_out_ready = io_out_0_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_1_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_1_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_1_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_1_wr_en = _T_2 & _GEN_1; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_1_rd_en = RRArbiter_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_2_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_2_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_2_din = fifo_cxb_24_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_2_wr_en = _T_2 & _GEN_4; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_2_rd_en = RRArbiter_1_io_in_0_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_3_rst = reset; // @[crossbar.scala 238:45]
  assign fifo_cxb_24_3_clk = clock; // @[crossbar.scala 239:45]
  assign fifo_cxb_24_3_din = io_in_1_bits; // @[crossbar.scala 240:45]
  assign fifo_cxb_24_3_wr_en = io_in_1_valid; // @[crossbar.scala 241:45]
  assign fifo_cxb_24_3_rd_en = _T_17 & _GEN_16; // @[crossbar.scala 242:45 crossbar.scala 259:43 crossbar.scala 265:51 crossbar.scala 265:51 crossbar.scala 274:43]
  assign RRArbiter_1_clock = clock;
  assign RRArbiter_1_reset = reset;
  assign RRArbiter_1_io_in_0_valid = ~fifo_cxb_24_2_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_0_bits = fifo_cxb_24_2_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_in_1_valid = ~fifo_cxb_24_5_empty; // @[crossbar.scala 283:51]
  assign RRArbiter_1_io_in_1_bits = fifo_cxb_24_5_dout; // @[crossbar.scala 282:49]
  assign RRArbiter_1_io_out_ready = io_out_1_ready; // @[crossbar.scala 289:38]
  assign fifo_cxb_24_4_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_4_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_4_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_4_wr_en = _T_17 & _GEN_12; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_4_rd_en = RRArbiter_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
  assign fifo_cxb_24_5_rst = reset; // @[crossbar.scala 247:54]
  assign fifo_cxb_24_5_clk = clock; // @[crossbar.scala 248:54]
  assign fifo_cxb_24_5_din = fifo_cxb_24_3_dout; // @[crossbar.scala 263:50]
  assign fifo_cxb_24_5_wr_en = _T_17 & _GEN_15; // @[crossbar.scala 250:54 crossbar.scala 261:52 crossbar.scala 264:52 crossbar.scala 267:56 crossbar.scala 272:52]
  assign fifo_cxb_24_5_rd_en = RRArbiter_1_io_in_1_ready; // @[crossbar.scala 251:54 crossbar.scala 281:50]
endmodule
module crossbar_1(
  input         clock,
  input         reset,
  output        io_in_0_ready,
  input         io_in_0_valid,
  input  [23:0] io_in_0_bits,
  output        io_in_1_ready,
  input         io_in_1_valid,
  input  [23:0] io_in_1_bits,
  output        io_in_2_ready,
  input         io_in_2_valid,
  input  [23:0] io_in_2_bits,
  output        io_in_3_ready,
  input         io_in_3_valid,
  input  [23:0] io_in_3_bits,
  output        io_in_4_ready,
  input         io_in_4_valid,
  input  [23:0] io_in_4_bits,
  output        io_in_5_ready,
  input         io_in_5_valid,
  input  [23:0] io_in_5_bits,
  output        io_in_6_ready,
  input         io_in_6_valid,
  input  [23:0] io_in_6_bits,
  output        io_in_7_ready,
  input         io_in_7_valid,
  input  [23:0] io_in_7_bits,
  output        io_in_8_ready,
  input         io_in_8_valid,
  input  [23:0] io_in_8_bits,
  output        io_in_9_ready,
  input         io_in_9_valid,
  input  [23:0] io_in_9_bits,
  output        io_in_10_ready,
  input         io_in_10_valid,
  input  [23:0] io_in_10_bits,
  output        io_in_11_ready,
  input         io_in_11_valid,
  input  [23:0] io_in_11_bits,
  output        io_in_12_ready,
  input         io_in_12_valid,
  input  [23:0] io_in_12_bits,
  output        io_in_13_ready,
  input         io_in_13_valid,
  input  [23:0] io_in_13_bits,
  output        io_in_14_ready,
  input         io_in_14_valid,
  input  [23:0] io_in_14_bits,
  output        io_in_15_ready,
  input         io_in_15_valid,
  input  [23:0] io_in_15_bits,
  output        io_in_16_ready,
  input         io_in_16_valid,
  input  [23:0] io_in_16_bits,
  output        io_in_17_ready,
  input         io_in_17_valid,
  input  [23:0] io_in_17_bits,
  output        io_in_18_ready,
  input         io_in_18_valid,
  input  [23:0] io_in_18_bits,
  output        io_in_19_ready,
  input         io_in_19_valid,
  input  [23:0] io_in_19_bits,
  output        io_in_20_ready,
  input         io_in_20_valid,
  input  [23:0] io_in_20_bits,
  output        io_in_21_ready,
  input         io_in_21_valid,
  input  [23:0] io_in_21_bits,
  output        io_in_22_ready,
  input         io_in_22_valid,
  input  [23:0] io_in_22_bits,
  output        io_in_23_ready,
  input         io_in_23_valid,
  input  [23:0] io_in_23_bits,
  output        io_in_24_ready,
  input         io_in_24_valid,
  input  [23:0] io_in_24_bits,
  output        io_in_25_ready,
  input         io_in_25_valid,
  input  [23:0] io_in_25_bits,
  output        io_in_26_ready,
  input         io_in_26_valid,
  input  [23:0] io_in_26_bits,
  output        io_in_27_ready,
  input         io_in_27_valid,
  input  [23:0] io_in_27_bits,
  output        io_in_28_ready,
  input         io_in_28_valid,
  input  [23:0] io_in_28_bits,
  output        io_in_29_ready,
  input         io_in_29_valid,
  input  [23:0] io_in_29_bits,
  output        io_in_30_ready,
  input         io_in_30_valid,
  input  [23:0] io_in_30_bits,
  output        io_in_31_ready,
  input         io_in_31_valid,
  input  [23:0] io_in_31_bits,
  output        io_in_32_ready,
  input         io_in_32_valid,
  input  [23:0] io_in_32_bits,
  output        io_in_33_ready,
  input         io_in_33_valid,
  input  [23:0] io_in_33_bits,
  output        io_in_34_ready,
  input         io_in_34_valid,
  input  [23:0] io_in_34_bits,
  output        io_in_35_ready,
  input         io_in_35_valid,
  input  [23:0] io_in_35_bits,
  output        io_in_36_ready,
  input         io_in_36_valid,
  input  [23:0] io_in_36_bits,
  output        io_in_37_ready,
  input         io_in_37_valid,
  input  [23:0] io_in_37_bits,
  output        io_in_38_ready,
  input         io_in_38_valid,
  input  [23:0] io_in_38_bits,
  output        io_in_39_ready,
  input         io_in_39_valid,
  input  [23:0] io_in_39_bits,
  output        io_in_40_ready,
  input         io_in_40_valid,
  input  [23:0] io_in_40_bits,
  output        io_in_41_ready,
  input         io_in_41_valid,
  input  [23:0] io_in_41_bits,
  output        io_in_42_ready,
  input         io_in_42_valid,
  input  [23:0] io_in_42_bits,
  output        io_in_43_ready,
  input         io_in_43_valid,
  input  [23:0] io_in_43_bits,
  output        io_in_44_ready,
  input         io_in_44_valid,
  input  [23:0] io_in_44_bits,
  output        io_in_45_ready,
  input         io_in_45_valid,
  input  [23:0] io_in_45_bits,
  output        io_in_46_ready,
  input         io_in_46_valid,
  input  [23:0] io_in_46_bits,
  output        io_in_47_ready,
  input         io_in_47_valid,
  input  [23:0] io_in_47_bits,
  output        io_in_48_ready,
  input         io_in_48_valid,
  input  [23:0] io_in_48_bits,
  output        io_in_49_ready,
  input         io_in_49_valid,
  input  [23:0] io_in_49_bits,
  output        io_in_50_ready,
  input         io_in_50_valid,
  input  [23:0] io_in_50_bits,
  output        io_in_51_ready,
  input         io_in_51_valid,
  input  [23:0] io_in_51_bits,
  output        io_in_52_ready,
  input         io_in_52_valid,
  input  [23:0] io_in_52_bits,
  output        io_in_53_ready,
  input         io_in_53_valid,
  input  [23:0] io_in_53_bits,
  output        io_in_54_ready,
  input         io_in_54_valid,
  input  [23:0] io_in_54_bits,
  output        io_in_55_ready,
  input         io_in_55_valid,
  input  [23:0] io_in_55_bits,
  output        io_in_56_ready,
  input         io_in_56_valid,
  input  [23:0] io_in_56_bits,
  output        io_in_57_ready,
  input         io_in_57_valid,
  input  [23:0] io_in_57_bits,
  output        io_in_58_ready,
  input         io_in_58_valid,
  input  [23:0] io_in_58_bits,
  output        io_in_59_ready,
  input         io_in_59_valid,
  input  [23:0] io_in_59_bits,
  output        io_in_60_ready,
  input         io_in_60_valid,
  input  [23:0] io_in_60_bits,
  output        io_in_61_ready,
  input         io_in_61_valid,
  input  [23:0] io_in_61_bits,
  output        io_in_62_ready,
  input         io_in_62_valid,
  input  [23:0] io_in_62_bits,
  output        io_in_63_ready,
  input         io_in_63_valid,
  input  [23:0] io_in_63_bits,
  output        io_in_64_ready,
  input         io_in_64_valid,
  input  [23:0] io_in_64_bits,
  output        io_in_65_ready,
  input         io_in_65_valid,
  input  [23:0] io_in_65_bits,
  output        io_in_66_ready,
  input         io_in_66_valid,
  input  [23:0] io_in_66_bits,
  output        io_in_67_ready,
  input         io_in_67_valid,
  input  [23:0] io_in_67_bits,
  output        io_in_68_ready,
  input         io_in_68_valid,
  input  [23:0] io_in_68_bits,
  output        io_in_69_ready,
  input         io_in_69_valid,
  input  [23:0] io_in_69_bits,
  output        io_in_70_ready,
  input         io_in_70_valid,
  input  [23:0] io_in_70_bits,
  output        io_in_71_ready,
  input         io_in_71_valid,
  input  [23:0] io_in_71_bits,
  output        io_in_72_ready,
  input         io_in_72_valid,
  input  [23:0] io_in_72_bits,
  output        io_in_73_ready,
  input         io_in_73_valid,
  input  [23:0] io_in_73_bits,
  output        io_in_74_ready,
  input         io_in_74_valid,
  input  [23:0] io_in_74_bits,
  output        io_in_75_ready,
  input         io_in_75_valid,
  input  [23:0] io_in_75_bits,
  output        io_in_76_ready,
  input         io_in_76_valid,
  input  [23:0] io_in_76_bits,
  output        io_in_77_ready,
  input         io_in_77_valid,
  input  [23:0] io_in_77_bits,
  output        io_in_78_ready,
  input         io_in_78_valid,
  input  [23:0] io_in_78_bits,
  output        io_in_79_ready,
  input         io_in_79_valid,
  input  [23:0] io_in_79_bits,
  output        io_in_80_ready,
  input         io_in_80_valid,
  input  [23:0] io_in_80_bits,
  output        io_in_81_ready,
  input         io_in_81_valid,
  input  [23:0] io_in_81_bits,
  output        io_in_82_ready,
  input         io_in_82_valid,
  input  [23:0] io_in_82_bits,
  output        io_in_83_ready,
  input         io_in_83_valid,
  input  [23:0] io_in_83_bits,
  output        io_in_84_ready,
  input         io_in_84_valid,
  input  [23:0] io_in_84_bits,
  output        io_in_85_ready,
  input         io_in_85_valid,
  input  [23:0] io_in_85_bits,
  output        io_in_86_ready,
  input         io_in_86_valid,
  input  [23:0] io_in_86_bits,
  output        io_in_87_ready,
  input         io_in_87_valid,
  input  [23:0] io_in_87_bits,
  output        io_in_88_ready,
  input         io_in_88_valid,
  input  [23:0] io_in_88_bits,
  output        io_in_89_ready,
  input         io_in_89_valid,
  input  [23:0] io_in_89_bits,
  output        io_in_90_ready,
  input         io_in_90_valid,
  input  [23:0] io_in_90_bits,
  output        io_in_91_ready,
  input         io_in_91_valid,
  input  [23:0] io_in_91_bits,
  output        io_in_92_ready,
  input         io_in_92_valid,
  input  [23:0] io_in_92_bits,
  output        io_in_93_ready,
  input         io_in_93_valid,
  input  [23:0] io_in_93_bits,
  output        io_in_94_ready,
  input         io_in_94_valid,
  input  [23:0] io_in_94_bits,
  output        io_in_95_ready,
  input         io_in_95_valid,
  input  [23:0] io_in_95_bits,
  output        io_in_96_ready,
  input         io_in_96_valid,
  input  [23:0] io_in_96_bits,
  output        io_in_97_ready,
  input         io_in_97_valid,
  input  [23:0] io_in_97_bits,
  output        io_in_98_ready,
  input         io_in_98_valid,
  input  [23:0] io_in_98_bits,
  output        io_in_99_ready,
  input         io_in_99_valid,
  input  [23:0] io_in_99_bits,
  output        io_in_100_ready,
  input         io_in_100_valid,
  input  [23:0] io_in_100_bits,
  output        io_in_101_ready,
  input         io_in_101_valid,
  input  [23:0] io_in_101_bits,
  output        io_in_102_ready,
  input         io_in_102_valid,
  input  [23:0] io_in_102_bits,
  output        io_in_103_ready,
  input         io_in_103_valid,
  input  [23:0] io_in_103_bits,
  output        io_in_104_ready,
  input         io_in_104_valid,
  input  [23:0] io_in_104_bits,
  output        io_in_105_ready,
  input         io_in_105_valid,
  input  [23:0] io_in_105_bits,
  output        io_in_106_ready,
  input         io_in_106_valid,
  input  [23:0] io_in_106_bits,
  output        io_in_107_ready,
  input         io_in_107_valid,
  input  [23:0] io_in_107_bits,
  output        io_in_108_ready,
  input         io_in_108_valid,
  input  [23:0] io_in_108_bits,
  output        io_in_109_ready,
  input         io_in_109_valid,
  input  [23:0] io_in_109_bits,
  output        io_in_110_ready,
  input         io_in_110_valid,
  input  [23:0] io_in_110_bits,
  output        io_in_111_ready,
  input         io_in_111_valid,
  input  [23:0] io_in_111_bits,
  output        io_in_112_ready,
  input         io_in_112_valid,
  input  [23:0] io_in_112_bits,
  output        io_in_113_ready,
  input         io_in_113_valid,
  input  [23:0] io_in_113_bits,
  output        io_in_114_ready,
  input         io_in_114_valid,
  input  [23:0] io_in_114_bits,
  output        io_in_115_ready,
  input         io_in_115_valid,
  input  [23:0] io_in_115_bits,
  output        io_in_116_ready,
  input         io_in_116_valid,
  input  [23:0] io_in_116_bits,
  output        io_in_117_ready,
  input         io_in_117_valid,
  input  [23:0] io_in_117_bits,
  output        io_in_118_ready,
  input         io_in_118_valid,
  input  [23:0] io_in_118_bits,
  output        io_in_119_ready,
  input         io_in_119_valid,
  input  [23:0] io_in_119_bits,
  output        io_in_120_ready,
  input         io_in_120_valid,
  input  [23:0] io_in_120_bits,
  output        io_in_121_ready,
  input         io_in_121_valid,
  input  [23:0] io_in_121_bits,
  output        io_in_122_ready,
  input         io_in_122_valid,
  input  [23:0] io_in_122_bits,
  output        io_in_123_ready,
  input         io_in_123_valid,
  input  [23:0] io_in_123_bits,
  output        io_in_124_ready,
  input         io_in_124_valid,
  input  [23:0] io_in_124_bits,
  output        io_in_125_ready,
  input         io_in_125_valid,
  input  [23:0] io_in_125_bits,
  output        io_in_126_ready,
  input         io_in_126_valid,
  input  [23:0] io_in_126_bits,
  output        io_in_127_ready,
  input         io_in_127_valid,
  input  [23:0] io_in_127_bits,
  input         io_out_0_ready,
  output        io_out_0_valid,
  output [23:0] io_out_0_bits,
  input         io_out_1_ready,
  output        io_out_1_valid,
  output [23:0] io_out_1_bits,
  input         io_out_2_ready,
  output        io_out_2_valid,
  output [23:0] io_out_2_bits,
  input         io_out_3_ready,
  output        io_out_3_valid,
  output [23:0] io_out_3_bits,
  input         io_out_4_ready,
  output        io_out_4_valid,
  output [23:0] io_out_4_bits,
  input         io_out_5_ready,
  output        io_out_5_valid,
  output [23:0] io_out_5_bits,
  input         io_out_6_ready,
  output        io_out_6_valid,
  output [23:0] io_out_6_bits,
  input         io_out_7_ready,
  output        io_out_7_valid,
  output [23:0] io_out_7_bits,
  input         io_out_8_ready,
  output        io_out_8_valid,
  output [23:0] io_out_8_bits,
  input         io_out_9_ready,
  output        io_out_9_valid,
  output [23:0] io_out_9_bits,
  input         io_out_10_ready,
  output        io_out_10_valid,
  output [23:0] io_out_10_bits,
  input         io_out_11_ready,
  output        io_out_11_valid,
  output [23:0] io_out_11_bits,
  input         io_out_12_ready,
  output        io_out_12_valid,
  output [23:0] io_out_12_bits,
  input         io_out_13_ready,
  output        io_out_13_valid,
  output [23:0] io_out_13_bits,
  input         io_out_14_ready,
  output        io_out_14_valid,
  output [23:0] io_out_14_bits,
  input         io_out_15_ready,
  output        io_out_15_valid,
  output [23:0] io_out_15_bits,
  input         io_out_16_ready,
  output        io_out_16_valid,
  output [23:0] io_out_16_bits,
  input         io_out_17_ready,
  output        io_out_17_valid,
  output [23:0] io_out_17_bits,
  input         io_out_18_ready,
  output        io_out_18_valid,
  output [23:0] io_out_18_bits,
  input         io_out_19_ready,
  output        io_out_19_valid,
  output [23:0] io_out_19_bits,
  input         io_out_20_ready,
  output        io_out_20_valid,
  output [23:0] io_out_20_bits,
  input         io_out_21_ready,
  output        io_out_21_valid,
  output [23:0] io_out_21_bits,
  input         io_out_22_ready,
  output        io_out_22_valid,
  output [23:0] io_out_22_bits,
  input         io_out_23_ready,
  output        io_out_23_valid,
  output [23:0] io_out_23_bits,
  input         io_out_24_ready,
  output        io_out_24_valid,
  output [23:0] io_out_24_bits,
  input         io_out_25_ready,
  output        io_out_25_valid,
  output [23:0] io_out_25_bits,
  input         io_out_26_ready,
  output        io_out_26_valid,
  output [23:0] io_out_26_bits,
  input         io_out_27_ready,
  output        io_out_27_valid,
  output [23:0] io_out_27_bits,
  input         io_out_28_ready,
  output        io_out_28_valid,
  output [23:0] io_out_28_bits,
  input         io_out_29_ready,
  output        io_out_29_valid,
  output [23:0] io_out_29_bits,
  input         io_out_30_ready,
  output        io_out_30_valid,
  output [23:0] io_out_30_bits,
  input         io_out_31_ready,
  output        io_out_31_valid,
  output [23:0] io_out_31_bits,
  input         io_out_32_ready,
  output        io_out_32_valid,
  output [23:0] io_out_32_bits,
  input         io_out_33_ready,
  output        io_out_33_valid,
  output [23:0] io_out_33_bits,
  input         io_out_34_ready,
  output        io_out_34_valid,
  output [23:0] io_out_34_bits,
  input         io_out_35_ready,
  output        io_out_35_valid,
  output [23:0] io_out_35_bits,
  input         io_out_36_ready,
  output        io_out_36_valid,
  output [23:0] io_out_36_bits,
  input         io_out_37_ready,
  output        io_out_37_valid,
  output [23:0] io_out_37_bits,
  input         io_out_38_ready,
  output        io_out_38_valid,
  output [23:0] io_out_38_bits,
  input         io_out_39_ready,
  output        io_out_39_valid,
  output [23:0] io_out_39_bits,
  input         io_out_40_ready,
  output        io_out_40_valid,
  output [23:0] io_out_40_bits,
  input         io_out_41_ready,
  output        io_out_41_valid,
  output [23:0] io_out_41_bits,
  input         io_out_42_ready,
  output        io_out_42_valid,
  output [23:0] io_out_42_bits,
  input         io_out_43_ready,
  output        io_out_43_valid,
  output [23:0] io_out_43_bits,
  input         io_out_44_ready,
  output        io_out_44_valid,
  output [23:0] io_out_44_bits,
  input         io_out_45_ready,
  output        io_out_45_valid,
  output [23:0] io_out_45_bits,
  input         io_out_46_ready,
  output        io_out_46_valid,
  output [23:0] io_out_46_bits,
  input         io_out_47_ready,
  output        io_out_47_valid,
  output [23:0] io_out_47_bits,
  input         io_out_48_ready,
  output        io_out_48_valid,
  output [23:0] io_out_48_bits,
  input         io_out_49_ready,
  output        io_out_49_valid,
  output [23:0] io_out_49_bits,
  input         io_out_50_ready,
  output        io_out_50_valid,
  output [23:0] io_out_50_bits,
  input         io_out_51_ready,
  output        io_out_51_valid,
  output [23:0] io_out_51_bits,
  input         io_out_52_ready,
  output        io_out_52_valid,
  output [23:0] io_out_52_bits,
  input         io_out_53_ready,
  output        io_out_53_valid,
  output [23:0] io_out_53_bits,
  input         io_out_54_ready,
  output        io_out_54_valid,
  output [23:0] io_out_54_bits,
  input         io_out_55_ready,
  output        io_out_55_valid,
  output [23:0] io_out_55_bits,
  input         io_out_56_ready,
  output        io_out_56_valid,
  output [23:0] io_out_56_bits,
  input         io_out_57_ready,
  output        io_out_57_valid,
  output [23:0] io_out_57_bits,
  input         io_out_58_ready,
  output        io_out_58_valid,
  output [23:0] io_out_58_bits,
  input         io_out_59_ready,
  output        io_out_59_valid,
  output [23:0] io_out_59_bits,
  input         io_out_60_ready,
  output        io_out_60_valid,
  output [23:0] io_out_60_bits,
  input         io_out_61_ready,
  output        io_out_61_valid,
  output [23:0] io_out_61_bits,
  input         io_out_62_ready,
  output        io_out_62_valid,
  output [23:0] io_out_62_bits,
  input         io_out_63_ready,
  output        io_out_63_valid,
  output [23:0] io_out_63_bits,
  input         io_out_64_ready,
  output        io_out_64_valid,
  output [23:0] io_out_64_bits,
  input         io_out_65_ready,
  output        io_out_65_valid,
  output [23:0] io_out_65_bits,
  input         io_out_66_ready,
  output        io_out_66_valid,
  output [23:0] io_out_66_bits,
  input         io_out_67_ready,
  output        io_out_67_valid,
  output [23:0] io_out_67_bits,
  input         io_out_68_ready,
  output        io_out_68_valid,
  output [23:0] io_out_68_bits,
  input         io_out_69_ready,
  output        io_out_69_valid,
  output [23:0] io_out_69_bits,
  input         io_out_70_ready,
  output        io_out_70_valid,
  output [23:0] io_out_70_bits,
  input         io_out_71_ready,
  output        io_out_71_valid,
  output [23:0] io_out_71_bits,
  input         io_out_72_ready,
  output        io_out_72_valid,
  output [23:0] io_out_72_bits,
  input         io_out_73_ready,
  output        io_out_73_valid,
  output [23:0] io_out_73_bits,
  input         io_out_74_ready,
  output        io_out_74_valid,
  output [23:0] io_out_74_bits,
  input         io_out_75_ready,
  output        io_out_75_valid,
  output [23:0] io_out_75_bits,
  input         io_out_76_ready,
  output        io_out_76_valid,
  output [23:0] io_out_76_bits,
  input         io_out_77_ready,
  output        io_out_77_valid,
  output [23:0] io_out_77_bits,
  input         io_out_78_ready,
  output        io_out_78_valid,
  output [23:0] io_out_78_bits,
  input         io_out_79_ready,
  output        io_out_79_valid,
  output [23:0] io_out_79_bits,
  input         io_out_80_ready,
  output        io_out_80_valid,
  output [23:0] io_out_80_bits,
  input         io_out_81_ready,
  output        io_out_81_valid,
  output [23:0] io_out_81_bits,
  input         io_out_82_ready,
  output        io_out_82_valid,
  output [23:0] io_out_82_bits,
  input         io_out_83_ready,
  output        io_out_83_valid,
  output [23:0] io_out_83_bits,
  input         io_out_84_ready,
  output        io_out_84_valid,
  output [23:0] io_out_84_bits,
  input         io_out_85_ready,
  output        io_out_85_valid,
  output [23:0] io_out_85_bits,
  input         io_out_86_ready,
  output        io_out_86_valid,
  output [23:0] io_out_86_bits,
  input         io_out_87_ready,
  output        io_out_87_valid,
  output [23:0] io_out_87_bits,
  input         io_out_88_ready,
  output        io_out_88_valid,
  output [23:0] io_out_88_bits,
  input         io_out_89_ready,
  output        io_out_89_valid,
  output [23:0] io_out_89_bits,
  input         io_out_90_ready,
  output        io_out_90_valid,
  output [23:0] io_out_90_bits,
  input         io_out_91_ready,
  output        io_out_91_valid,
  output [23:0] io_out_91_bits,
  input         io_out_92_ready,
  output        io_out_92_valid,
  output [23:0] io_out_92_bits,
  input         io_out_93_ready,
  output        io_out_93_valid,
  output [23:0] io_out_93_bits,
  input         io_out_94_ready,
  output        io_out_94_valid,
  output [23:0] io_out_94_bits,
  input         io_out_95_ready,
  output        io_out_95_valid,
  output [23:0] io_out_95_bits,
  input         io_out_96_ready,
  output        io_out_96_valid,
  output [23:0] io_out_96_bits,
  input         io_out_97_ready,
  output        io_out_97_valid,
  output [23:0] io_out_97_bits,
  input         io_out_98_ready,
  output        io_out_98_valid,
  output [23:0] io_out_98_bits,
  input         io_out_99_ready,
  output        io_out_99_valid,
  output [23:0] io_out_99_bits,
  input         io_out_100_ready,
  output        io_out_100_valid,
  output [23:0] io_out_100_bits,
  input         io_out_101_ready,
  output        io_out_101_valid,
  output [23:0] io_out_101_bits,
  input         io_out_102_ready,
  output        io_out_102_valid,
  output [23:0] io_out_102_bits,
  input         io_out_103_ready,
  output        io_out_103_valid,
  output [23:0] io_out_103_bits,
  input         io_out_104_ready,
  output        io_out_104_valid,
  output [23:0] io_out_104_bits,
  input         io_out_105_ready,
  output        io_out_105_valid,
  output [23:0] io_out_105_bits,
  input         io_out_106_ready,
  output        io_out_106_valid,
  output [23:0] io_out_106_bits,
  input         io_out_107_ready,
  output        io_out_107_valid,
  output [23:0] io_out_107_bits,
  input         io_out_108_ready,
  output        io_out_108_valid,
  output [23:0] io_out_108_bits,
  input         io_out_109_ready,
  output        io_out_109_valid,
  output [23:0] io_out_109_bits,
  input         io_out_110_ready,
  output        io_out_110_valid,
  output [23:0] io_out_110_bits,
  input         io_out_111_ready,
  output        io_out_111_valid,
  output [23:0] io_out_111_bits,
  input         io_out_112_ready,
  output        io_out_112_valid,
  output [23:0] io_out_112_bits,
  input         io_out_113_ready,
  output        io_out_113_valid,
  output [23:0] io_out_113_bits,
  input         io_out_114_ready,
  output        io_out_114_valid,
  output [23:0] io_out_114_bits,
  input         io_out_115_ready,
  output        io_out_115_valid,
  output [23:0] io_out_115_bits,
  input         io_out_116_ready,
  output        io_out_116_valid,
  output [23:0] io_out_116_bits,
  input         io_out_117_ready,
  output        io_out_117_valid,
  output [23:0] io_out_117_bits,
  input         io_out_118_ready,
  output        io_out_118_valid,
  output [23:0] io_out_118_bits,
  input         io_out_119_ready,
  output        io_out_119_valid,
  output [23:0] io_out_119_bits,
  input         io_out_120_ready,
  output        io_out_120_valid,
  output [23:0] io_out_120_bits,
  input         io_out_121_ready,
  output        io_out_121_valid,
  output [23:0] io_out_121_bits,
  input         io_out_122_ready,
  output        io_out_122_valid,
  output [23:0] io_out_122_bits,
  input         io_out_123_ready,
  output        io_out_123_valid,
  output [23:0] io_out_123_bits,
  input         io_out_124_ready,
  output        io_out_124_valid,
  output [23:0] io_out_124_bits,
  input         io_out_125_ready,
  output        io_out_125_valid,
  output [23:0] io_out_125_bits,
  input         io_out_126_ready,
  output        io_out_126_valid,
  output [23:0] io_out_126_bits,
  input         io_out_127_ready,
  output        io_out_127_valid,
  output [23:0] io_out_127_bits
);
  wire  sub_crossbar_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_1_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_1_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_1_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_2_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_2_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_2_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_3_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_3_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_3_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_4_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_4_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_4_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_5_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_5_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_5_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_6_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_6_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_6_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_7_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_7_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_7_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_8_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_8_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_8_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_9_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_9_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_9_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_10_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_10_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_10_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_11_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_11_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_11_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_12_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_12_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_12_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_13_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_13_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_13_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_14_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_14_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_14_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_15_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_15_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_15_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_16_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_16_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_16_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_17_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_17_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_17_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_18_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_18_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_18_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_19_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_19_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_19_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_20_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_20_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_20_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_21_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_21_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_21_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_22_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_22_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_22_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_23_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_23_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_23_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_24_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_24_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_24_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_25_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_25_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_25_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_26_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_26_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_26_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_27_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_27_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_27_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_28_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_28_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_28_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_29_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_29_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_29_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_30_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_30_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_30_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_31_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_31_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_31_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_32_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_32_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_32_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_33_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_33_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_33_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_34_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_34_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_34_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_35_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_35_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_35_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_36_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_36_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_36_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_37_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_37_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_37_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_38_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_38_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_38_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_39_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_39_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_39_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_40_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_40_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_40_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_41_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_41_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_41_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_42_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_42_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_42_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_43_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_43_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_43_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_44_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_44_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_44_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_45_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_45_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_45_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_46_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_46_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_46_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_47_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_47_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_47_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_48_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_48_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_48_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_49_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_49_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_49_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_50_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_50_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_50_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_51_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_51_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_51_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_52_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_52_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_52_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_53_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_53_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_53_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_54_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_54_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_54_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_55_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_55_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_55_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_56_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_56_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_56_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_57_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_57_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_57_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_58_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_58_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_58_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_59_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_59_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_59_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_60_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_60_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_60_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_61_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_61_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_61_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_62_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_62_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_62_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_63_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_63_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_63_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_64_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_64_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_64_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_65_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_65_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_65_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_66_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_66_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_66_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_67_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_67_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_67_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_68_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_68_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_68_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_69_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_69_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_69_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_70_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_70_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_70_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_71_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_71_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_71_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_72_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_72_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_72_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_73_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_73_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_73_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_74_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_74_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_74_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_75_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_75_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_75_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_76_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_76_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_76_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_77_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_77_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_77_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_78_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_78_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_78_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_79_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_79_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_79_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_80_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_80_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_80_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_81_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_81_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_81_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_82_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_82_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_82_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_83_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_83_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_83_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_84_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_84_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_84_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_85_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_85_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_85_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_86_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_86_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_86_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_87_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_87_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_87_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_88_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_88_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_88_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_89_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_89_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_89_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_90_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_90_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_90_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_91_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_91_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_91_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_92_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_92_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_92_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_93_clock; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_reset; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_in_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_in_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_in_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_in_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_in_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_0_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_0_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_out_0_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_1_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_1_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_out_1_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_2_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_2_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_out_2_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_3_ready; // @[crossbar.scala 134:42]
  wire  sub_crossbar_93_io_out_3_valid; // @[crossbar.scala 134:42]
  wire [23:0] sub_crossbar_93_io_out_3_bits; // @[crossbar.scala 134:42]
  wire  sub_crossbar_94_clock; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_reset; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_in_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_in_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_in_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_in_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_in_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_0_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_0_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_out_0_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_1_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_1_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_out_1_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_2_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_2_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_out_2_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_3_ready; // @[crossbar.scala 135:46]
  wire  sub_crossbar_94_io_out_3_valid; // @[crossbar.scala 135:46]
  wire [23:0] sub_crossbar_94_io_out_3_bits; // @[crossbar.scala 135:46]
  wire  sub_crossbar_95_clock; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_reset; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_in_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_in_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_in_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_in_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_in_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_0_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_0_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_out_0_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_1_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_1_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_out_1_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_2_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_2_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_out_2_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_3_ready; // @[crossbar.scala 136:45]
  wire  sub_crossbar_95_io_out_3_valid; // @[crossbar.scala 136:45]
  wire [23:0] sub_crossbar_95_io_out_3_bits; // @[crossbar.scala 136:45]
  wire  sub_crossbar_96_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_96_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_96_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_96_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_96_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_96_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_97_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_97_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_97_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_97_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_97_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_98_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_98_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_98_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_98_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_98_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_99_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_99_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_99_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_99_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_99_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_100_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_100_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_100_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_100_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_100_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_101_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_101_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_101_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_101_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_101_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_102_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_102_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_102_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_102_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_102_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_103_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_103_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_103_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_103_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_103_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_104_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_104_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_104_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_104_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_104_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_105_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_105_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_105_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_105_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_105_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_106_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_106_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_106_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_106_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_106_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_107_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_107_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_107_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_107_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_107_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_108_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_108_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_108_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_108_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_108_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_109_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_109_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_109_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_109_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_109_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_110_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_110_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_110_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_110_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_110_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_111_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_111_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_111_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_111_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_111_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_112_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_112_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_112_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_112_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_112_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_113_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_113_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_113_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_113_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_113_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_114_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_114_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_114_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_114_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_114_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_115_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_115_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_115_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_115_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_115_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_116_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_116_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_116_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_116_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_116_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_117_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_117_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_117_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_117_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_117_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_118_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_118_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_118_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_118_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_118_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_119_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_119_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_119_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_119_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_119_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_120_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_120_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_120_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_120_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_120_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_121_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_121_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_121_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_121_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_121_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_122_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_122_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_122_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_122_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_122_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_123_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_123_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_123_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_123_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_123_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_124_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_124_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_124_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_124_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_124_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_125_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_125_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_125_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_125_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_125_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_126_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_126_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_126_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_126_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_126_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_127_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_127_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_127_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_127_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_127_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_128_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_128_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_128_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_128_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_128_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_129_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_129_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_129_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_129_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_129_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_130_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_130_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_130_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_130_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_130_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_131_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_131_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_131_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_131_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_131_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_132_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_132_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_132_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_132_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_132_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_133_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_133_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_133_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_133_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_133_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_134_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_134_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_134_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_134_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_134_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_135_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_135_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_135_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_135_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_135_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_136_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_136_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_136_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_136_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_136_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_137_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_137_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_137_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_137_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_137_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_138_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_138_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_138_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_138_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_138_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_139_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_139_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_139_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_139_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_139_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_140_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_140_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_140_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_140_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_140_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_141_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_141_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_141_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_141_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_141_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_142_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_142_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_142_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_142_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_142_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_143_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_143_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_143_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_143_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_143_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_144_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_144_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_144_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_144_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_144_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_145_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_145_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_145_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_145_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_145_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_146_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_146_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_146_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_146_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_146_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_147_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_147_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_147_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_147_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_147_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_148_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_148_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_148_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_148_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_148_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_149_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_149_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_149_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_149_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_149_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_150_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_150_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_150_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_150_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_150_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_151_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_151_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_151_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_151_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_151_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_152_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_152_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_152_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_152_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_152_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_153_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_153_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_153_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_153_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_153_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_154_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_154_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_154_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_154_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_154_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_155_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_155_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_155_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_155_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_155_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_156_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_156_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_156_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_156_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_156_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_157_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_157_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_157_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_157_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_157_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_158_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_158_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_158_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_158_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_158_io_out_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_clock; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_reset; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_159_io_in_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_in_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_159_io_in_1_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_0_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_0_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_159_io_out_0_bits; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_1_ready; // @[crossbar.scala 139:43]
  wire  sub_crossbar_159_io_out_1_valid; // @[crossbar.scala 139:43]
  wire [23:0] sub_crossbar_159_io_out_1_bits; // @[crossbar.scala 139:43]
  sub_crossbar_160 sub_crossbar ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_clock),
    .reset(sub_crossbar_reset),
    .io_in_0_ready(sub_crossbar_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_1 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_1_clock),
    .reset(sub_crossbar_1_reset),
    .io_in_0_ready(sub_crossbar_1_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_1_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_1_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_1_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_1_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_1_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_1_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_1_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_1_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_1_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_1_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_1_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_1_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_1_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_1_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_1_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_1_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_1_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_1_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_1_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_1_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_1_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_1_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_1_io_out_3_bits)
  );
  sub_crossbar_162 sub_crossbar_2 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_2_clock),
    .reset(sub_crossbar_2_reset),
    .io_in_0_ready(sub_crossbar_2_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_2_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_2_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_2_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_2_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_2_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_2_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_2_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_2_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_2_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_2_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_2_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_2_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_2_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_2_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_2_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_2_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_2_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_2_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_2_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_2_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_2_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_2_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_2_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_3 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_3_clock),
    .reset(sub_crossbar_3_reset),
    .io_in_0_ready(sub_crossbar_3_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_3_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_3_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_3_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_3_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_3_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_3_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_3_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_3_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_3_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_3_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_3_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_3_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_3_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_3_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_3_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_3_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_3_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_3_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_3_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_3_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_3_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_3_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_3_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_4 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_4_clock),
    .reset(sub_crossbar_4_reset),
    .io_in_0_ready(sub_crossbar_4_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_4_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_4_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_4_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_4_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_4_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_4_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_4_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_4_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_4_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_4_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_4_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_4_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_4_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_4_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_4_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_4_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_4_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_4_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_4_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_4_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_4_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_4_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_4_io_out_3_bits)
  );
  sub_crossbar_165 sub_crossbar_5 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_5_clock),
    .reset(sub_crossbar_5_reset),
    .io_in_0_ready(sub_crossbar_5_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_5_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_5_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_5_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_5_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_5_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_5_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_5_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_5_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_5_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_5_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_5_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_5_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_5_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_5_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_5_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_5_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_5_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_5_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_5_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_5_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_5_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_5_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_5_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_6 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_6_clock),
    .reset(sub_crossbar_6_reset),
    .io_in_0_ready(sub_crossbar_6_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_6_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_6_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_6_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_6_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_6_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_6_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_6_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_6_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_6_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_6_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_6_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_6_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_6_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_6_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_6_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_6_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_6_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_6_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_6_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_6_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_6_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_6_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_6_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_7 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_7_clock),
    .reset(sub_crossbar_7_reset),
    .io_in_0_ready(sub_crossbar_7_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_7_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_7_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_7_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_7_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_7_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_7_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_7_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_7_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_7_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_7_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_7_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_7_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_7_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_7_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_7_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_7_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_7_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_7_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_7_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_7_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_7_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_7_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_7_io_out_3_bits)
  );
  sub_crossbar_168 sub_crossbar_8 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_8_clock),
    .reset(sub_crossbar_8_reset),
    .io_in_0_ready(sub_crossbar_8_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_8_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_8_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_8_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_8_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_8_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_8_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_8_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_8_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_8_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_8_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_8_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_8_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_8_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_8_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_8_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_8_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_8_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_8_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_8_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_8_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_8_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_8_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_8_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_9 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_9_clock),
    .reset(sub_crossbar_9_reset),
    .io_in_0_ready(sub_crossbar_9_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_9_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_9_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_9_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_9_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_9_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_9_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_9_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_9_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_9_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_9_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_9_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_9_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_9_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_9_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_9_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_9_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_9_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_9_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_9_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_9_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_9_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_9_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_9_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_10 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_10_clock),
    .reset(sub_crossbar_10_reset),
    .io_in_0_ready(sub_crossbar_10_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_10_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_10_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_10_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_10_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_10_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_10_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_10_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_10_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_10_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_10_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_10_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_10_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_10_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_10_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_10_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_10_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_10_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_10_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_10_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_10_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_10_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_10_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_10_io_out_3_bits)
  );
  sub_crossbar_171 sub_crossbar_11 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_11_clock),
    .reset(sub_crossbar_11_reset),
    .io_in_0_ready(sub_crossbar_11_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_11_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_11_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_11_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_11_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_11_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_11_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_11_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_11_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_11_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_11_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_11_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_11_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_11_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_11_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_11_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_11_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_11_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_11_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_11_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_11_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_11_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_11_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_11_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_12 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_12_clock),
    .reset(sub_crossbar_12_reset),
    .io_in_0_ready(sub_crossbar_12_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_12_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_12_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_12_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_12_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_12_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_12_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_12_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_12_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_12_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_12_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_12_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_12_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_12_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_12_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_12_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_12_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_12_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_12_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_12_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_12_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_12_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_12_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_12_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_13 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_13_clock),
    .reset(sub_crossbar_13_reset),
    .io_in_0_ready(sub_crossbar_13_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_13_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_13_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_13_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_13_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_13_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_13_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_13_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_13_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_13_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_13_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_13_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_13_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_13_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_13_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_13_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_13_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_13_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_13_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_13_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_13_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_13_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_13_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_13_io_out_3_bits)
  );
  sub_crossbar_174 sub_crossbar_14 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_14_clock),
    .reset(sub_crossbar_14_reset),
    .io_in_0_ready(sub_crossbar_14_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_14_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_14_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_14_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_14_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_14_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_14_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_14_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_14_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_14_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_14_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_14_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_14_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_14_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_14_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_14_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_14_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_14_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_14_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_14_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_14_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_14_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_14_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_14_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_15 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_15_clock),
    .reset(sub_crossbar_15_reset),
    .io_in_0_ready(sub_crossbar_15_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_15_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_15_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_15_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_15_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_15_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_15_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_15_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_15_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_15_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_15_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_15_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_15_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_15_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_15_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_15_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_15_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_15_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_15_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_15_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_15_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_15_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_15_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_15_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_16 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_16_clock),
    .reset(sub_crossbar_16_reset),
    .io_in_0_ready(sub_crossbar_16_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_16_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_16_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_16_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_16_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_16_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_16_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_16_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_16_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_16_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_16_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_16_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_16_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_16_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_16_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_16_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_16_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_16_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_16_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_16_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_16_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_16_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_16_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_16_io_out_3_bits)
  );
  sub_crossbar_177 sub_crossbar_17 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_17_clock),
    .reset(sub_crossbar_17_reset),
    .io_in_0_ready(sub_crossbar_17_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_17_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_17_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_17_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_17_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_17_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_17_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_17_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_17_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_17_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_17_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_17_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_17_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_17_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_17_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_17_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_17_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_17_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_17_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_17_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_17_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_17_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_17_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_17_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_18 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_18_clock),
    .reset(sub_crossbar_18_reset),
    .io_in_0_ready(sub_crossbar_18_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_18_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_18_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_18_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_18_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_18_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_18_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_18_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_18_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_18_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_18_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_18_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_18_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_18_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_18_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_18_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_18_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_18_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_18_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_18_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_18_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_18_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_18_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_18_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_19 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_19_clock),
    .reset(sub_crossbar_19_reset),
    .io_in_0_ready(sub_crossbar_19_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_19_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_19_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_19_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_19_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_19_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_19_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_19_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_19_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_19_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_19_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_19_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_19_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_19_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_19_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_19_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_19_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_19_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_19_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_19_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_19_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_19_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_19_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_19_io_out_3_bits)
  );
  sub_crossbar_180 sub_crossbar_20 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_20_clock),
    .reset(sub_crossbar_20_reset),
    .io_in_0_ready(sub_crossbar_20_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_20_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_20_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_20_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_20_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_20_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_20_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_20_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_20_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_20_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_20_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_20_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_20_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_20_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_20_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_20_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_20_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_20_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_20_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_20_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_20_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_20_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_20_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_20_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_21 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_21_clock),
    .reset(sub_crossbar_21_reset),
    .io_in_0_ready(sub_crossbar_21_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_21_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_21_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_21_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_21_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_21_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_21_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_21_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_21_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_21_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_21_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_21_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_21_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_21_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_21_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_21_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_21_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_21_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_21_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_21_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_21_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_21_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_21_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_21_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_22 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_22_clock),
    .reset(sub_crossbar_22_reset),
    .io_in_0_ready(sub_crossbar_22_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_22_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_22_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_22_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_22_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_22_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_22_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_22_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_22_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_22_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_22_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_22_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_22_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_22_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_22_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_22_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_22_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_22_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_22_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_22_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_22_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_22_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_22_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_22_io_out_3_bits)
  );
  sub_crossbar_183 sub_crossbar_23 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_23_clock),
    .reset(sub_crossbar_23_reset),
    .io_in_0_ready(sub_crossbar_23_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_23_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_23_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_23_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_23_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_23_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_23_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_23_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_23_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_23_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_23_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_23_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_23_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_23_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_23_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_23_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_23_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_23_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_23_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_23_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_23_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_23_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_23_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_23_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_24 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_24_clock),
    .reset(sub_crossbar_24_reset),
    .io_in_0_ready(sub_crossbar_24_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_24_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_24_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_24_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_24_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_24_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_24_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_24_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_24_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_24_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_24_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_24_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_24_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_24_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_24_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_24_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_24_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_24_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_24_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_24_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_24_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_24_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_24_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_24_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_25 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_25_clock),
    .reset(sub_crossbar_25_reset),
    .io_in_0_ready(sub_crossbar_25_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_25_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_25_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_25_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_25_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_25_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_25_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_25_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_25_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_25_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_25_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_25_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_25_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_25_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_25_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_25_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_25_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_25_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_25_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_25_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_25_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_25_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_25_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_25_io_out_3_bits)
  );
  sub_crossbar_186 sub_crossbar_26 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_26_clock),
    .reset(sub_crossbar_26_reset),
    .io_in_0_ready(sub_crossbar_26_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_26_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_26_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_26_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_26_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_26_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_26_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_26_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_26_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_26_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_26_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_26_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_26_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_26_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_26_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_26_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_26_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_26_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_26_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_26_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_26_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_26_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_26_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_26_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_27 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_27_clock),
    .reset(sub_crossbar_27_reset),
    .io_in_0_ready(sub_crossbar_27_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_27_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_27_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_27_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_27_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_27_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_27_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_27_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_27_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_27_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_27_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_27_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_27_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_27_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_27_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_27_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_27_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_27_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_27_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_27_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_27_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_27_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_27_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_27_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_28 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_28_clock),
    .reset(sub_crossbar_28_reset),
    .io_in_0_ready(sub_crossbar_28_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_28_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_28_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_28_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_28_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_28_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_28_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_28_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_28_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_28_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_28_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_28_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_28_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_28_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_28_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_28_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_28_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_28_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_28_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_28_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_28_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_28_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_28_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_28_io_out_3_bits)
  );
  sub_crossbar_189 sub_crossbar_29 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_29_clock),
    .reset(sub_crossbar_29_reset),
    .io_in_0_ready(sub_crossbar_29_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_29_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_29_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_29_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_29_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_29_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_29_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_29_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_29_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_29_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_29_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_29_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_29_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_29_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_29_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_29_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_29_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_29_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_29_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_29_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_29_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_29_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_29_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_29_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_30 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_30_clock),
    .reset(sub_crossbar_30_reset),
    .io_in_0_ready(sub_crossbar_30_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_30_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_30_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_30_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_30_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_30_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_30_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_30_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_30_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_30_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_30_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_30_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_30_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_30_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_30_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_30_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_30_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_30_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_30_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_30_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_30_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_30_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_30_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_30_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_31 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_31_clock),
    .reset(sub_crossbar_31_reset),
    .io_in_0_ready(sub_crossbar_31_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_31_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_31_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_31_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_31_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_31_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_31_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_31_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_31_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_31_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_31_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_31_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_31_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_31_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_31_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_31_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_31_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_31_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_31_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_31_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_31_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_31_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_31_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_31_io_out_3_bits)
  );
  sub_crossbar_192 sub_crossbar_32 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_32_clock),
    .reset(sub_crossbar_32_reset),
    .io_in_0_ready(sub_crossbar_32_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_32_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_32_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_32_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_32_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_32_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_32_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_32_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_32_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_32_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_32_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_32_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_32_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_32_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_32_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_32_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_32_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_32_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_32_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_32_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_32_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_32_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_32_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_32_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_33 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_33_clock),
    .reset(sub_crossbar_33_reset),
    .io_in_0_ready(sub_crossbar_33_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_33_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_33_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_33_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_33_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_33_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_33_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_33_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_33_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_33_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_33_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_33_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_33_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_33_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_33_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_33_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_33_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_33_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_33_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_33_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_33_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_33_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_33_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_33_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_34 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_34_clock),
    .reset(sub_crossbar_34_reset),
    .io_in_0_ready(sub_crossbar_34_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_34_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_34_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_34_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_34_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_34_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_34_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_34_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_34_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_34_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_34_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_34_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_34_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_34_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_34_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_34_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_34_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_34_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_34_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_34_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_34_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_34_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_34_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_34_io_out_3_bits)
  );
  sub_crossbar_195 sub_crossbar_35 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_35_clock),
    .reset(sub_crossbar_35_reset),
    .io_in_0_ready(sub_crossbar_35_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_35_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_35_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_35_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_35_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_35_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_35_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_35_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_35_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_35_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_35_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_35_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_35_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_35_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_35_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_35_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_35_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_35_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_35_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_35_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_35_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_35_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_35_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_35_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_36 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_36_clock),
    .reset(sub_crossbar_36_reset),
    .io_in_0_ready(sub_crossbar_36_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_36_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_36_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_36_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_36_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_36_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_36_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_36_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_36_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_36_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_36_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_36_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_36_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_36_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_36_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_36_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_36_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_36_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_36_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_36_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_36_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_36_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_36_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_36_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_37 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_37_clock),
    .reset(sub_crossbar_37_reset),
    .io_in_0_ready(sub_crossbar_37_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_37_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_37_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_37_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_37_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_37_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_37_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_37_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_37_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_37_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_37_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_37_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_37_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_37_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_37_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_37_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_37_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_37_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_37_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_37_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_37_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_37_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_37_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_37_io_out_3_bits)
  );
  sub_crossbar_198 sub_crossbar_38 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_38_clock),
    .reset(sub_crossbar_38_reset),
    .io_in_0_ready(sub_crossbar_38_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_38_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_38_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_38_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_38_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_38_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_38_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_38_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_38_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_38_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_38_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_38_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_38_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_38_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_38_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_38_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_38_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_38_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_38_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_38_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_38_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_38_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_38_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_38_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_39 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_39_clock),
    .reset(sub_crossbar_39_reset),
    .io_in_0_ready(sub_crossbar_39_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_39_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_39_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_39_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_39_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_39_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_39_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_39_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_39_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_39_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_39_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_39_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_39_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_39_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_39_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_39_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_39_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_39_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_39_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_39_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_39_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_39_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_39_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_39_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_40 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_40_clock),
    .reset(sub_crossbar_40_reset),
    .io_in_0_ready(sub_crossbar_40_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_40_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_40_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_40_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_40_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_40_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_40_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_40_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_40_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_40_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_40_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_40_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_40_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_40_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_40_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_40_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_40_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_40_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_40_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_40_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_40_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_40_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_40_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_40_io_out_3_bits)
  );
  sub_crossbar_201 sub_crossbar_41 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_41_clock),
    .reset(sub_crossbar_41_reset),
    .io_in_0_ready(sub_crossbar_41_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_41_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_41_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_41_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_41_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_41_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_41_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_41_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_41_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_41_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_41_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_41_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_41_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_41_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_41_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_41_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_41_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_41_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_41_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_41_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_41_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_41_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_41_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_41_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_42 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_42_clock),
    .reset(sub_crossbar_42_reset),
    .io_in_0_ready(sub_crossbar_42_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_42_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_42_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_42_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_42_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_42_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_42_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_42_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_42_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_42_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_42_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_42_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_42_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_42_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_42_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_42_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_42_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_42_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_42_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_42_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_42_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_42_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_42_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_42_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_43 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_43_clock),
    .reset(sub_crossbar_43_reset),
    .io_in_0_ready(sub_crossbar_43_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_43_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_43_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_43_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_43_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_43_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_43_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_43_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_43_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_43_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_43_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_43_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_43_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_43_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_43_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_43_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_43_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_43_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_43_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_43_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_43_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_43_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_43_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_43_io_out_3_bits)
  );
  sub_crossbar_204 sub_crossbar_44 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_44_clock),
    .reset(sub_crossbar_44_reset),
    .io_in_0_ready(sub_crossbar_44_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_44_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_44_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_44_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_44_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_44_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_44_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_44_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_44_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_44_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_44_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_44_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_44_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_44_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_44_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_44_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_44_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_44_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_44_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_44_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_44_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_44_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_44_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_44_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_45 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_45_clock),
    .reset(sub_crossbar_45_reset),
    .io_in_0_ready(sub_crossbar_45_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_45_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_45_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_45_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_45_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_45_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_45_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_45_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_45_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_45_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_45_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_45_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_45_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_45_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_45_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_45_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_45_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_45_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_45_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_45_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_45_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_45_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_45_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_45_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_46 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_46_clock),
    .reset(sub_crossbar_46_reset),
    .io_in_0_ready(sub_crossbar_46_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_46_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_46_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_46_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_46_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_46_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_46_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_46_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_46_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_46_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_46_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_46_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_46_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_46_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_46_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_46_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_46_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_46_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_46_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_46_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_46_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_46_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_46_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_46_io_out_3_bits)
  );
  sub_crossbar_207 sub_crossbar_47 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_47_clock),
    .reset(sub_crossbar_47_reset),
    .io_in_0_ready(sub_crossbar_47_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_47_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_47_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_47_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_47_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_47_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_47_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_47_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_47_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_47_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_47_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_47_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_47_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_47_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_47_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_47_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_47_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_47_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_47_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_47_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_47_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_47_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_47_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_47_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_48 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_48_clock),
    .reset(sub_crossbar_48_reset),
    .io_in_0_ready(sub_crossbar_48_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_48_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_48_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_48_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_48_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_48_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_48_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_48_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_48_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_48_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_48_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_48_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_48_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_48_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_48_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_48_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_48_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_48_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_48_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_48_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_48_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_48_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_48_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_48_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_49 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_49_clock),
    .reset(sub_crossbar_49_reset),
    .io_in_0_ready(sub_crossbar_49_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_49_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_49_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_49_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_49_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_49_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_49_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_49_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_49_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_49_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_49_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_49_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_49_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_49_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_49_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_49_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_49_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_49_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_49_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_49_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_49_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_49_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_49_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_49_io_out_3_bits)
  );
  sub_crossbar_162 sub_crossbar_50 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_50_clock),
    .reset(sub_crossbar_50_reset),
    .io_in_0_ready(sub_crossbar_50_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_50_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_50_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_50_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_50_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_50_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_50_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_50_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_50_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_50_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_50_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_50_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_50_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_50_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_50_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_50_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_50_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_50_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_50_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_50_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_50_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_50_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_50_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_50_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_51 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_51_clock),
    .reset(sub_crossbar_51_reset),
    .io_in_0_ready(sub_crossbar_51_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_51_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_51_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_51_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_51_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_51_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_51_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_51_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_51_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_51_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_51_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_51_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_51_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_51_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_51_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_51_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_51_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_51_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_51_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_51_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_51_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_51_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_51_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_51_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_52 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_52_clock),
    .reset(sub_crossbar_52_reset),
    .io_in_0_ready(sub_crossbar_52_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_52_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_52_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_52_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_52_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_52_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_52_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_52_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_52_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_52_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_52_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_52_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_52_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_52_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_52_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_52_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_52_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_52_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_52_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_52_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_52_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_52_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_52_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_52_io_out_3_bits)
  );
  sub_crossbar_165 sub_crossbar_53 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_53_clock),
    .reset(sub_crossbar_53_reset),
    .io_in_0_ready(sub_crossbar_53_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_53_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_53_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_53_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_53_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_53_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_53_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_53_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_53_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_53_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_53_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_53_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_53_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_53_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_53_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_53_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_53_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_53_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_53_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_53_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_53_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_53_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_53_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_53_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_54 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_54_clock),
    .reset(sub_crossbar_54_reset),
    .io_in_0_ready(sub_crossbar_54_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_54_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_54_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_54_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_54_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_54_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_54_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_54_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_54_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_54_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_54_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_54_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_54_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_54_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_54_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_54_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_54_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_54_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_54_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_54_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_54_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_54_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_54_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_54_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_55 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_55_clock),
    .reset(sub_crossbar_55_reset),
    .io_in_0_ready(sub_crossbar_55_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_55_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_55_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_55_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_55_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_55_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_55_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_55_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_55_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_55_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_55_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_55_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_55_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_55_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_55_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_55_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_55_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_55_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_55_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_55_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_55_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_55_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_55_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_55_io_out_3_bits)
  );
  sub_crossbar_168 sub_crossbar_56 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_56_clock),
    .reset(sub_crossbar_56_reset),
    .io_in_0_ready(sub_crossbar_56_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_56_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_56_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_56_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_56_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_56_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_56_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_56_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_56_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_56_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_56_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_56_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_56_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_56_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_56_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_56_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_56_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_56_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_56_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_56_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_56_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_56_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_56_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_56_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_57 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_57_clock),
    .reset(sub_crossbar_57_reset),
    .io_in_0_ready(sub_crossbar_57_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_57_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_57_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_57_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_57_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_57_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_57_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_57_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_57_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_57_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_57_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_57_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_57_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_57_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_57_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_57_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_57_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_57_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_57_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_57_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_57_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_57_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_57_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_57_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_58 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_58_clock),
    .reset(sub_crossbar_58_reset),
    .io_in_0_ready(sub_crossbar_58_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_58_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_58_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_58_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_58_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_58_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_58_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_58_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_58_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_58_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_58_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_58_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_58_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_58_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_58_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_58_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_58_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_58_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_58_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_58_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_58_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_58_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_58_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_58_io_out_3_bits)
  );
  sub_crossbar_171 sub_crossbar_59 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_59_clock),
    .reset(sub_crossbar_59_reset),
    .io_in_0_ready(sub_crossbar_59_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_59_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_59_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_59_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_59_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_59_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_59_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_59_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_59_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_59_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_59_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_59_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_59_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_59_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_59_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_59_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_59_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_59_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_59_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_59_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_59_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_59_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_59_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_59_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_60 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_60_clock),
    .reset(sub_crossbar_60_reset),
    .io_in_0_ready(sub_crossbar_60_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_60_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_60_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_60_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_60_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_60_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_60_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_60_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_60_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_60_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_60_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_60_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_60_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_60_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_60_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_60_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_60_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_60_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_60_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_60_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_60_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_60_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_60_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_60_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_61 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_61_clock),
    .reset(sub_crossbar_61_reset),
    .io_in_0_ready(sub_crossbar_61_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_61_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_61_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_61_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_61_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_61_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_61_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_61_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_61_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_61_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_61_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_61_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_61_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_61_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_61_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_61_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_61_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_61_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_61_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_61_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_61_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_61_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_61_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_61_io_out_3_bits)
  );
  sub_crossbar_174 sub_crossbar_62 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_62_clock),
    .reset(sub_crossbar_62_reset),
    .io_in_0_ready(sub_crossbar_62_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_62_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_62_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_62_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_62_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_62_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_62_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_62_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_62_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_62_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_62_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_62_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_62_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_62_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_62_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_62_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_62_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_62_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_62_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_62_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_62_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_62_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_62_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_62_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_63 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_63_clock),
    .reset(sub_crossbar_63_reset),
    .io_in_0_ready(sub_crossbar_63_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_63_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_63_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_63_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_63_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_63_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_63_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_63_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_63_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_63_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_63_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_63_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_63_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_63_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_63_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_63_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_63_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_63_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_63_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_63_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_63_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_63_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_63_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_63_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_64 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_64_clock),
    .reset(sub_crossbar_64_reset),
    .io_in_0_ready(sub_crossbar_64_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_64_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_64_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_64_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_64_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_64_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_64_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_64_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_64_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_64_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_64_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_64_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_64_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_64_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_64_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_64_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_64_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_64_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_64_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_64_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_64_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_64_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_64_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_64_io_out_3_bits)
  );
  sub_crossbar_177 sub_crossbar_65 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_65_clock),
    .reset(sub_crossbar_65_reset),
    .io_in_0_ready(sub_crossbar_65_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_65_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_65_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_65_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_65_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_65_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_65_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_65_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_65_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_65_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_65_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_65_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_65_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_65_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_65_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_65_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_65_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_65_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_65_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_65_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_65_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_65_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_65_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_65_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_66 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_66_clock),
    .reset(sub_crossbar_66_reset),
    .io_in_0_ready(sub_crossbar_66_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_66_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_66_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_66_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_66_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_66_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_66_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_66_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_66_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_66_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_66_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_66_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_66_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_66_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_66_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_66_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_66_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_66_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_66_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_66_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_66_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_66_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_66_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_66_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_67 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_67_clock),
    .reset(sub_crossbar_67_reset),
    .io_in_0_ready(sub_crossbar_67_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_67_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_67_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_67_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_67_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_67_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_67_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_67_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_67_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_67_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_67_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_67_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_67_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_67_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_67_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_67_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_67_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_67_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_67_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_67_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_67_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_67_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_67_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_67_io_out_3_bits)
  );
  sub_crossbar_180 sub_crossbar_68 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_68_clock),
    .reset(sub_crossbar_68_reset),
    .io_in_0_ready(sub_crossbar_68_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_68_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_68_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_68_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_68_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_68_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_68_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_68_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_68_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_68_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_68_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_68_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_68_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_68_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_68_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_68_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_68_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_68_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_68_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_68_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_68_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_68_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_68_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_68_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_69 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_69_clock),
    .reset(sub_crossbar_69_reset),
    .io_in_0_ready(sub_crossbar_69_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_69_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_69_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_69_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_69_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_69_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_69_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_69_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_69_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_69_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_69_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_69_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_69_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_69_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_69_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_69_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_69_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_69_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_69_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_69_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_69_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_69_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_69_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_69_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_70 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_70_clock),
    .reset(sub_crossbar_70_reset),
    .io_in_0_ready(sub_crossbar_70_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_70_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_70_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_70_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_70_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_70_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_70_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_70_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_70_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_70_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_70_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_70_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_70_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_70_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_70_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_70_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_70_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_70_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_70_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_70_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_70_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_70_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_70_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_70_io_out_3_bits)
  );
  sub_crossbar_183 sub_crossbar_71 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_71_clock),
    .reset(sub_crossbar_71_reset),
    .io_in_0_ready(sub_crossbar_71_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_71_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_71_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_71_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_71_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_71_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_71_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_71_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_71_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_71_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_71_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_71_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_71_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_71_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_71_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_71_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_71_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_71_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_71_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_71_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_71_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_71_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_71_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_71_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_72 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_72_clock),
    .reset(sub_crossbar_72_reset),
    .io_in_0_ready(sub_crossbar_72_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_72_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_72_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_72_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_72_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_72_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_72_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_72_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_72_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_72_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_72_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_72_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_72_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_72_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_72_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_72_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_72_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_72_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_72_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_72_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_72_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_72_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_72_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_72_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_73 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_73_clock),
    .reset(sub_crossbar_73_reset),
    .io_in_0_ready(sub_crossbar_73_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_73_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_73_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_73_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_73_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_73_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_73_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_73_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_73_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_73_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_73_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_73_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_73_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_73_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_73_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_73_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_73_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_73_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_73_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_73_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_73_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_73_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_73_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_73_io_out_3_bits)
  );
  sub_crossbar_186 sub_crossbar_74 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_74_clock),
    .reset(sub_crossbar_74_reset),
    .io_in_0_ready(sub_crossbar_74_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_74_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_74_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_74_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_74_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_74_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_74_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_74_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_74_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_74_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_74_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_74_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_74_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_74_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_74_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_74_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_74_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_74_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_74_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_74_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_74_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_74_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_74_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_74_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_75 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_75_clock),
    .reset(sub_crossbar_75_reset),
    .io_in_0_ready(sub_crossbar_75_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_75_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_75_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_75_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_75_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_75_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_75_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_75_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_75_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_75_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_75_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_75_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_75_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_75_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_75_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_75_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_75_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_75_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_75_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_75_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_75_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_75_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_75_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_75_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_76 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_76_clock),
    .reset(sub_crossbar_76_reset),
    .io_in_0_ready(sub_crossbar_76_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_76_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_76_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_76_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_76_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_76_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_76_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_76_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_76_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_76_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_76_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_76_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_76_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_76_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_76_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_76_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_76_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_76_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_76_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_76_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_76_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_76_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_76_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_76_io_out_3_bits)
  );
  sub_crossbar_189 sub_crossbar_77 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_77_clock),
    .reset(sub_crossbar_77_reset),
    .io_in_0_ready(sub_crossbar_77_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_77_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_77_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_77_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_77_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_77_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_77_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_77_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_77_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_77_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_77_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_77_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_77_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_77_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_77_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_77_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_77_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_77_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_77_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_77_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_77_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_77_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_77_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_77_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_78 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_78_clock),
    .reset(sub_crossbar_78_reset),
    .io_in_0_ready(sub_crossbar_78_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_78_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_78_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_78_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_78_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_78_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_78_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_78_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_78_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_78_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_78_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_78_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_78_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_78_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_78_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_78_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_78_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_78_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_78_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_78_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_78_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_78_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_78_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_78_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_79 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_79_clock),
    .reset(sub_crossbar_79_reset),
    .io_in_0_ready(sub_crossbar_79_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_79_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_79_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_79_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_79_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_79_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_79_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_79_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_79_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_79_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_79_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_79_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_79_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_79_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_79_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_79_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_79_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_79_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_79_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_79_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_79_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_79_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_79_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_79_io_out_3_bits)
  );
  sub_crossbar_192 sub_crossbar_80 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_80_clock),
    .reset(sub_crossbar_80_reset),
    .io_in_0_ready(sub_crossbar_80_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_80_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_80_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_80_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_80_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_80_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_80_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_80_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_80_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_80_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_80_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_80_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_80_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_80_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_80_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_80_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_80_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_80_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_80_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_80_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_80_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_80_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_80_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_80_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_81 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_81_clock),
    .reset(sub_crossbar_81_reset),
    .io_in_0_ready(sub_crossbar_81_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_81_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_81_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_81_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_81_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_81_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_81_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_81_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_81_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_81_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_81_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_81_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_81_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_81_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_81_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_81_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_81_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_81_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_81_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_81_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_81_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_81_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_81_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_81_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_82 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_82_clock),
    .reset(sub_crossbar_82_reset),
    .io_in_0_ready(sub_crossbar_82_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_82_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_82_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_82_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_82_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_82_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_82_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_82_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_82_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_82_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_82_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_82_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_82_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_82_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_82_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_82_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_82_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_82_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_82_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_82_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_82_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_82_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_82_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_82_io_out_3_bits)
  );
  sub_crossbar_195 sub_crossbar_83 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_83_clock),
    .reset(sub_crossbar_83_reset),
    .io_in_0_ready(sub_crossbar_83_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_83_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_83_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_83_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_83_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_83_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_83_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_83_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_83_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_83_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_83_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_83_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_83_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_83_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_83_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_83_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_83_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_83_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_83_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_83_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_83_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_83_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_83_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_83_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_84 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_84_clock),
    .reset(sub_crossbar_84_reset),
    .io_in_0_ready(sub_crossbar_84_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_84_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_84_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_84_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_84_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_84_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_84_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_84_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_84_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_84_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_84_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_84_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_84_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_84_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_84_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_84_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_84_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_84_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_84_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_84_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_84_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_84_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_84_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_84_io_out_3_bits)
  );
  sub_crossbar_161 sub_crossbar_85 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_85_clock),
    .reset(sub_crossbar_85_reset),
    .io_in_0_ready(sub_crossbar_85_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_85_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_85_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_85_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_85_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_85_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_85_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_85_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_85_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_85_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_85_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_85_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_85_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_85_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_85_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_85_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_85_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_85_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_85_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_85_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_85_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_85_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_85_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_85_io_out_3_bits)
  );
  sub_crossbar_198 sub_crossbar_86 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_86_clock),
    .reset(sub_crossbar_86_reset),
    .io_in_0_ready(sub_crossbar_86_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_86_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_86_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_86_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_86_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_86_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_86_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_86_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_86_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_86_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_86_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_86_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_86_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_86_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_86_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_86_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_86_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_86_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_86_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_86_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_86_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_86_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_86_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_86_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_87 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_87_clock),
    .reset(sub_crossbar_87_reset),
    .io_in_0_ready(sub_crossbar_87_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_87_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_87_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_87_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_87_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_87_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_87_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_87_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_87_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_87_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_87_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_87_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_87_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_87_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_87_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_87_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_87_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_87_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_87_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_87_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_87_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_87_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_87_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_87_io_out_3_bits)
  );
  sub_crossbar_164 sub_crossbar_88 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_88_clock),
    .reset(sub_crossbar_88_reset),
    .io_in_0_ready(sub_crossbar_88_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_88_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_88_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_88_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_88_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_88_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_88_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_88_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_88_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_88_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_88_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_88_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_88_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_88_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_88_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_88_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_88_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_88_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_88_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_88_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_88_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_88_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_88_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_88_io_out_3_bits)
  );
  sub_crossbar_201 sub_crossbar_89 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_89_clock),
    .reset(sub_crossbar_89_reset),
    .io_in_0_ready(sub_crossbar_89_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_89_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_89_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_89_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_89_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_89_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_89_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_89_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_89_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_89_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_89_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_89_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_89_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_89_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_89_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_89_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_89_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_89_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_89_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_89_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_89_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_89_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_89_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_89_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_90 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_90_clock),
    .reset(sub_crossbar_90_reset),
    .io_in_0_ready(sub_crossbar_90_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_90_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_90_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_90_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_90_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_90_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_90_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_90_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_90_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_90_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_90_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_90_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_90_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_90_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_90_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_90_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_90_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_90_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_90_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_90_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_90_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_90_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_90_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_90_io_out_3_bits)
  );
  sub_crossbar_167 sub_crossbar_91 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_91_clock),
    .reset(sub_crossbar_91_reset),
    .io_in_0_ready(sub_crossbar_91_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_91_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_91_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_91_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_91_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_91_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_91_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_91_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_91_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_91_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_91_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_91_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_91_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_91_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_91_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_91_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_91_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_91_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_91_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_91_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_91_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_91_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_91_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_91_io_out_3_bits)
  );
  sub_crossbar_204 sub_crossbar_92 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_92_clock),
    .reset(sub_crossbar_92_reset),
    .io_in_0_ready(sub_crossbar_92_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_92_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_92_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_92_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_92_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_92_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_92_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_92_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_92_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_92_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_92_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_92_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_92_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_92_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_92_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_92_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_92_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_92_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_92_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_92_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_92_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_92_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_92_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_92_io_out_3_bits)
  );
  sub_crossbar_160 sub_crossbar_93 ( // @[crossbar.scala 134:42]
    .clock(sub_crossbar_93_clock),
    .reset(sub_crossbar_93_reset),
    .io_in_0_ready(sub_crossbar_93_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_93_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_93_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_93_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_93_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_93_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_93_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_93_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_93_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_93_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_93_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_93_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_93_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_93_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_93_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_93_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_93_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_93_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_93_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_93_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_93_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_93_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_93_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_93_io_out_3_bits)
  );
  sub_crossbar_170 sub_crossbar_94 ( // @[crossbar.scala 135:46]
    .clock(sub_crossbar_94_clock),
    .reset(sub_crossbar_94_reset),
    .io_in_0_ready(sub_crossbar_94_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_94_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_94_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_94_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_94_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_94_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_94_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_94_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_94_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_94_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_94_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_94_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_94_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_94_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_94_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_94_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_94_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_94_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_94_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_94_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_94_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_94_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_94_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_94_io_out_3_bits)
  );
  sub_crossbar_207 sub_crossbar_95 ( // @[crossbar.scala 136:45]
    .clock(sub_crossbar_95_clock),
    .reset(sub_crossbar_95_reset),
    .io_in_0_ready(sub_crossbar_95_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_95_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_95_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_95_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_95_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_95_io_in_1_bits),
    .io_in_2_ready(sub_crossbar_95_io_in_2_ready),
    .io_in_2_valid(sub_crossbar_95_io_in_2_valid),
    .io_in_2_bits(sub_crossbar_95_io_in_2_bits),
    .io_in_3_ready(sub_crossbar_95_io_in_3_ready),
    .io_in_3_valid(sub_crossbar_95_io_in_3_valid),
    .io_in_3_bits(sub_crossbar_95_io_in_3_bits),
    .io_out_0_ready(sub_crossbar_95_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_95_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_95_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_95_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_95_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_95_io_out_1_bits),
    .io_out_2_ready(sub_crossbar_95_io_out_2_ready),
    .io_out_2_valid(sub_crossbar_95_io_out_2_valid),
    .io_out_2_bits(sub_crossbar_95_io_out_2_bits),
    .io_out_3_ready(sub_crossbar_95_io_out_3_ready),
    .io_out_3_valid(sub_crossbar_95_io_out_3_valid),
    .io_out_3_bits(sub_crossbar_95_io_out_3_bits)
  );
  sub_crossbar_256 sub_crossbar_96 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_96_clock),
    .reset(sub_crossbar_96_reset),
    .io_in_0_ready(sub_crossbar_96_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_96_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_96_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_96_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_96_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_96_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_96_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_96_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_96_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_96_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_96_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_96_io_out_1_bits)
  );
  sub_crossbar_257 sub_crossbar_97 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_97_clock),
    .reset(sub_crossbar_97_reset),
    .io_in_0_ready(sub_crossbar_97_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_97_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_97_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_97_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_97_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_97_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_97_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_97_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_97_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_97_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_97_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_97_io_out_1_bits)
  );
  sub_crossbar_258 sub_crossbar_98 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_98_clock),
    .reset(sub_crossbar_98_reset),
    .io_in_0_ready(sub_crossbar_98_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_98_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_98_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_98_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_98_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_98_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_98_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_98_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_98_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_98_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_98_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_98_io_out_1_bits)
  );
  sub_crossbar_259 sub_crossbar_99 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_99_clock),
    .reset(sub_crossbar_99_reset),
    .io_in_0_ready(sub_crossbar_99_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_99_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_99_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_99_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_99_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_99_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_99_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_99_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_99_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_99_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_99_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_99_io_out_1_bits)
  );
  sub_crossbar_260 sub_crossbar_100 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_100_clock),
    .reset(sub_crossbar_100_reset),
    .io_in_0_ready(sub_crossbar_100_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_100_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_100_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_100_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_100_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_100_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_100_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_100_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_100_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_100_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_100_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_100_io_out_1_bits)
  );
  sub_crossbar_261 sub_crossbar_101 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_101_clock),
    .reset(sub_crossbar_101_reset),
    .io_in_0_ready(sub_crossbar_101_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_101_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_101_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_101_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_101_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_101_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_101_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_101_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_101_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_101_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_101_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_101_io_out_1_bits)
  );
  sub_crossbar_262 sub_crossbar_102 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_102_clock),
    .reset(sub_crossbar_102_reset),
    .io_in_0_ready(sub_crossbar_102_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_102_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_102_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_102_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_102_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_102_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_102_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_102_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_102_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_102_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_102_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_102_io_out_1_bits)
  );
  sub_crossbar_263 sub_crossbar_103 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_103_clock),
    .reset(sub_crossbar_103_reset),
    .io_in_0_ready(sub_crossbar_103_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_103_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_103_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_103_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_103_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_103_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_103_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_103_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_103_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_103_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_103_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_103_io_out_1_bits)
  );
  sub_crossbar_264 sub_crossbar_104 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_104_clock),
    .reset(sub_crossbar_104_reset),
    .io_in_0_ready(sub_crossbar_104_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_104_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_104_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_104_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_104_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_104_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_104_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_104_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_104_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_104_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_104_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_104_io_out_1_bits)
  );
  sub_crossbar_265 sub_crossbar_105 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_105_clock),
    .reset(sub_crossbar_105_reset),
    .io_in_0_ready(sub_crossbar_105_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_105_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_105_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_105_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_105_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_105_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_105_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_105_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_105_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_105_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_105_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_105_io_out_1_bits)
  );
  sub_crossbar_266 sub_crossbar_106 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_106_clock),
    .reset(sub_crossbar_106_reset),
    .io_in_0_ready(sub_crossbar_106_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_106_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_106_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_106_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_106_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_106_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_106_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_106_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_106_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_106_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_106_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_106_io_out_1_bits)
  );
  sub_crossbar_267 sub_crossbar_107 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_107_clock),
    .reset(sub_crossbar_107_reset),
    .io_in_0_ready(sub_crossbar_107_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_107_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_107_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_107_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_107_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_107_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_107_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_107_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_107_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_107_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_107_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_107_io_out_1_bits)
  );
  sub_crossbar_268 sub_crossbar_108 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_108_clock),
    .reset(sub_crossbar_108_reset),
    .io_in_0_ready(sub_crossbar_108_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_108_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_108_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_108_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_108_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_108_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_108_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_108_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_108_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_108_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_108_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_108_io_out_1_bits)
  );
  sub_crossbar_269 sub_crossbar_109 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_109_clock),
    .reset(sub_crossbar_109_reset),
    .io_in_0_ready(sub_crossbar_109_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_109_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_109_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_109_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_109_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_109_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_109_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_109_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_109_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_109_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_109_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_109_io_out_1_bits)
  );
  sub_crossbar_270 sub_crossbar_110 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_110_clock),
    .reset(sub_crossbar_110_reset),
    .io_in_0_ready(sub_crossbar_110_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_110_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_110_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_110_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_110_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_110_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_110_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_110_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_110_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_110_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_110_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_110_io_out_1_bits)
  );
  sub_crossbar_271 sub_crossbar_111 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_111_clock),
    .reset(sub_crossbar_111_reset),
    .io_in_0_ready(sub_crossbar_111_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_111_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_111_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_111_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_111_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_111_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_111_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_111_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_111_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_111_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_111_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_111_io_out_1_bits)
  );
  sub_crossbar_272 sub_crossbar_112 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_112_clock),
    .reset(sub_crossbar_112_reset),
    .io_in_0_ready(sub_crossbar_112_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_112_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_112_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_112_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_112_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_112_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_112_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_112_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_112_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_112_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_112_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_112_io_out_1_bits)
  );
  sub_crossbar_273 sub_crossbar_113 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_113_clock),
    .reset(sub_crossbar_113_reset),
    .io_in_0_ready(sub_crossbar_113_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_113_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_113_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_113_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_113_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_113_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_113_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_113_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_113_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_113_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_113_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_113_io_out_1_bits)
  );
  sub_crossbar_274 sub_crossbar_114 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_114_clock),
    .reset(sub_crossbar_114_reset),
    .io_in_0_ready(sub_crossbar_114_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_114_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_114_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_114_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_114_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_114_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_114_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_114_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_114_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_114_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_114_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_114_io_out_1_bits)
  );
  sub_crossbar_275 sub_crossbar_115 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_115_clock),
    .reset(sub_crossbar_115_reset),
    .io_in_0_ready(sub_crossbar_115_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_115_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_115_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_115_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_115_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_115_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_115_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_115_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_115_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_115_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_115_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_115_io_out_1_bits)
  );
  sub_crossbar_276 sub_crossbar_116 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_116_clock),
    .reset(sub_crossbar_116_reset),
    .io_in_0_ready(sub_crossbar_116_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_116_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_116_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_116_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_116_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_116_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_116_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_116_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_116_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_116_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_116_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_116_io_out_1_bits)
  );
  sub_crossbar_277 sub_crossbar_117 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_117_clock),
    .reset(sub_crossbar_117_reset),
    .io_in_0_ready(sub_crossbar_117_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_117_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_117_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_117_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_117_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_117_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_117_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_117_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_117_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_117_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_117_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_117_io_out_1_bits)
  );
  sub_crossbar_278 sub_crossbar_118 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_118_clock),
    .reset(sub_crossbar_118_reset),
    .io_in_0_ready(sub_crossbar_118_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_118_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_118_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_118_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_118_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_118_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_118_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_118_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_118_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_118_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_118_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_118_io_out_1_bits)
  );
  sub_crossbar_279 sub_crossbar_119 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_119_clock),
    .reset(sub_crossbar_119_reset),
    .io_in_0_ready(sub_crossbar_119_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_119_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_119_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_119_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_119_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_119_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_119_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_119_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_119_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_119_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_119_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_119_io_out_1_bits)
  );
  sub_crossbar_280 sub_crossbar_120 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_120_clock),
    .reset(sub_crossbar_120_reset),
    .io_in_0_ready(sub_crossbar_120_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_120_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_120_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_120_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_120_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_120_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_120_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_120_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_120_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_120_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_120_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_120_io_out_1_bits)
  );
  sub_crossbar_281 sub_crossbar_121 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_121_clock),
    .reset(sub_crossbar_121_reset),
    .io_in_0_ready(sub_crossbar_121_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_121_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_121_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_121_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_121_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_121_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_121_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_121_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_121_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_121_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_121_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_121_io_out_1_bits)
  );
  sub_crossbar_282 sub_crossbar_122 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_122_clock),
    .reset(sub_crossbar_122_reset),
    .io_in_0_ready(sub_crossbar_122_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_122_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_122_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_122_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_122_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_122_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_122_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_122_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_122_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_122_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_122_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_122_io_out_1_bits)
  );
  sub_crossbar_283 sub_crossbar_123 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_123_clock),
    .reset(sub_crossbar_123_reset),
    .io_in_0_ready(sub_crossbar_123_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_123_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_123_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_123_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_123_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_123_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_123_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_123_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_123_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_123_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_123_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_123_io_out_1_bits)
  );
  sub_crossbar_284 sub_crossbar_124 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_124_clock),
    .reset(sub_crossbar_124_reset),
    .io_in_0_ready(sub_crossbar_124_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_124_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_124_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_124_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_124_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_124_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_124_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_124_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_124_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_124_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_124_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_124_io_out_1_bits)
  );
  sub_crossbar_285 sub_crossbar_125 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_125_clock),
    .reset(sub_crossbar_125_reset),
    .io_in_0_ready(sub_crossbar_125_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_125_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_125_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_125_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_125_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_125_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_125_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_125_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_125_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_125_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_125_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_125_io_out_1_bits)
  );
  sub_crossbar_286 sub_crossbar_126 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_126_clock),
    .reset(sub_crossbar_126_reset),
    .io_in_0_ready(sub_crossbar_126_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_126_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_126_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_126_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_126_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_126_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_126_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_126_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_126_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_126_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_126_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_126_io_out_1_bits)
  );
  sub_crossbar_287 sub_crossbar_127 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_127_clock),
    .reset(sub_crossbar_127_reset),
    .io_in_0_ready(sub_crossbar_127_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_127_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_127_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_127_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_127_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_127_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_127_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_127_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_127_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_127_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_127_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_127_io_out_1_bits)
  );
  sub_crossbar_288 sub_crossbar_128 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_128_clock),
    .reset(sub_crossbar_128_reset),
    .io_in_0_ready(sub_crossbar_128_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_128_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_128_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_128_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_128_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_128_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_128_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_128_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_128_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_128_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_128_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_128_io_out_1_bits)
  );
  sub_crossbar_289 sub_crossbar_129 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_129_clock),
    .reset(sub_crossbar_129_reset),
    .io_in_0_ready(sub_crossbar_129_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_129_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_129_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_129_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_129_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_129_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_129_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_129_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_129_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_129_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_129_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_129_io_out_1_bits)
  );
  sub_crossbar_290 sub_crossbar_130 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_130_clock),
    .reset(sub_crossbar_130_reset),
    .io_in_0_ready(sub_crossbar_130_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_130_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_130_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_130_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_130_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_130_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_130_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_130_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_130_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_130_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_130_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_130_io_out_1_bits)
  );
  sub_crossbar_291 sub_crossbar_131 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_131_clock),
    .reset(sub_crossbar_131_reset),
    .io_in_0_ready(sub_crossbar_131_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_131_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_131_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_131_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_131_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_131_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_131_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_131_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_131_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_131_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_131_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_131_io_out_1_bits)
  );
  sub_crossbar_292 sub_crossbar_132 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_132_clock),
    .reset(sub_crossbar_132_reset),
    .io_in_0_ready(sub_crossbar_132_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_132_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_132_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_132_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_132_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_132_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_132_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_132_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_132_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_132_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_132_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_132_io_out_1_bits)
  );
  sub_crossbar_293 sub_crossbar_133 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_133_clock),
    .reset(sub_crossbar_133_reset),
    .io_in_0_ready(sub_crossbar_133_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_133_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_133_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_133_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_133_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_133_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_133_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_133_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_133_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_133_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_133_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_133_io_out_1_bits)
  );
  sub_crossbar_294 sub_crossbar_134 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_134_clock),
    .reset(sub_crossbar_134_reset),
    .io_in_0_ready(sub_crossbar_134_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_134_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_134_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_134_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_134_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_134_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_134_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_134_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_134_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_134_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_134_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_134_io_out_1_bits)
  );
  sub_crossbar_295 sub_crossbar_135 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_135_clock),
    .reset(sub_crossbar_135_reset),
    .io_in_0_ready(sub_crossbar_135_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_135_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_135_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_135_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_135_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_135_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_135_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_135_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_135_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_135_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_135_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_135_io_out_1_bits)
  );
  sub_crossbar_296 sub_crossbar_136 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_136_clock),
    .reset(sub_crossbar_136_reset),
    .io_in_0_ready(sub_crossbar_136_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_136_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_136_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_136_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_136_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_136_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_136_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_136_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_136_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_136_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_136_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_136_io_out_1_bits)
  );
  sub_crossbar_297 sub_crossbar_137 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_137_clock),
    .reset(sub_crossbar_137_reset),
    .io_in_0_ready(sub_crossbar_137_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_137_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_137_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_137_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_137_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_137_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_137_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_137_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_137_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_137_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_137_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_137_io_out_1_bits)
  );
  sub_crossbar_298 sub_crossbar_138 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_138_clock),
    .reset(sub_crossbar_138_reset),
    .io_in_0_ready(sub_crossbar_138_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_138_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_138_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_138_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_138_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_138_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_138_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_138_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_138_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_138_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_138_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_138_io_out_1_bits)
  );
  sub_crossbar_299 sub_crossbar_139 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_139_clock),
    .reset(sub_crossbar_139_reset),
    .io_in_0_ready(sub_crossbar_139_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_139_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_139_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_139_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_139_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_139_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_139_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_139_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_139_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_139_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_139_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_139_io_out_1_bits)
  );
  sub_crossbar_300 sub_crossbar_140 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_140_clock),
    .reset(sub_crossbar_140_reset),
    .io_in_0_ready(sub_crossbar_140_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_140_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_140_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_140_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_140_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_140_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_140_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_140_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_140_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_140_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_140_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_140_io_out_1_bits)
  );
  sub_crossbar_301 sub_crossbar_141 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_141_clock),
    .reset(sub_crossbar_141_reset),
    .io_in_0_ready(sub_crossbar_141_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_141_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_141_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_141_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_141_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_141_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_141_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_141_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_141_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_141_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_141_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_141_io_out_1_bits)
  );
  sub_crossbar_302 sub_crossbar_142 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_142_clock),
    .reset(sub_crossbar_142_reset),
    .io_in_0_ready(sub_crossbar_142_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_142_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_142_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_142_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_142_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_142_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_142_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_142_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_142_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_142_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_142_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_142_io_out_1_bits)
  );
  sub_crossbar_303 sub_crossbar_143 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_143_clock),
    .reset(sub_crossbar_143_reset),
    .io_in_0_ready(sub_crossbar_143_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_143_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_143_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_143_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_143_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_143_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_143_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_143_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_143_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_143_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_143_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_143_io_out_1_bits)
  );
  sub_crossbar_304 sub_crossbar_144 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_144_clock),
    .reset(sub_crossbar_144_reset),
    .io_in_0_ready(sub_crossbar_144_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_144_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_144_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_144_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_144_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_144_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_144_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_144_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_144_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_144_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_144_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_144_io_out_1_bits)
  );
  sub_crossbar_305 sub_crossbar_145 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_145_clock),
    .reset(sub_crossbar_145_reset),
    .io_in_0_ready(sub_crossbar_145_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_145_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_145_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_145_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_145_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_145_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_145_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_145_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_145_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_145_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_145_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_145_io_out_1_bits)
  );
  sub_crossbar_306 sub_crossbar_146 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_146_clock),
    .reset(sub_crossbar_146_reset),
    .io_in_0_ready(sub_crossbar_146_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_146_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_146_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_146_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_146_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_146_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_146_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_146_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_146_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_146_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_146_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_146_io_out_1_bits)
  );
  sub_crossbar_307 sub_crossbar_147 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_147_clock),
    .reset(sub_crossbar_147_reset),
    .io_in_0_ready(sub_crossbar_147_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_147_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_147_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_147_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_147_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_147_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_147_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_147_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_147_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_147_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_147_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_147_io_out_1_bits)
  );
  sub_crossbar_308 sub_crossbar_148 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_148_clock),
    .reset(sub_crossbar_148_reset),
    .io_in_0_ready(sub_crossbar_148_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_148_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_148_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_148_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_148_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_148_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_148_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_148_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_148_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_148_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_148_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_148_io_out_1_bits)
  );
  sub_crossbar_309 sub_crossbar_149 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_149_clock),
    .reset(sub_crossbar_149_reset),
    .io_in_0_ready(sub_crossbar_149_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_149_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_149_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_149_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_149_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_149_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_149_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_149_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_149_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_149_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_149_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_149_io_out_1_bits)
  );
  sub_crossbar_310 sub_crossbar_150 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_150_clock),
    .reset(sub_crossbar_150_reset),
    .io_in_0_ready(sub_crossbar_150_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_150_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_150_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_150_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_150_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_150_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_150_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_150_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_150_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_150_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_150_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_150_io_out_1_bits)
  );
  sub_crossbar_311 sub_crossbar_151 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_151_clock),
    .reset(sub_crossbar_151_reset),
    .io_in_0_ready(sub_crossbar_151_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_151_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_151_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_151_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_151_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_151_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_151_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_151_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_151_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_151_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_151_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_151_io_out_1_bits)
  );
  sub_crossbar_312 sub_crossbar_152 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_152_clock),
    .reset(sub_crossbar_152_reset),
    .io_in_0_ready(sub_crossbar_152_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_152_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_152_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_152_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_152_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_152_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_152_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_152_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_152_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_152_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_152_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_152_io_out_1_bits)
  );
  sub_crossbar_313 sub_crossbar_153 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_153_clock),
    .reset(sub_crossbar_153_reset),
    .io_in_0_ready(sub_crossbar_153_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_153_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_153_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_153_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_153_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_153_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_153_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_153_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_153_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_153_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_153_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_153_io_out_1_bits)
  );
  sub_crossbar_314 sub_crossbar_154 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_154_clock),
    .reset(sub_crossbar_154_reset),
    .io_in_0_ready(sub_crossbar_154_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_154_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_154_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_154_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_154_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_154_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_154_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_154_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_154_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_154_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_154_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_154_io_out_1_bits)
  );
  sub_crossbar_315 sub_crossbar_155 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_155_clock),
    .reset(sub_crossbar_155_reset),
    .io_in_0_ready(sub_crossbar_155_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_155_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_155_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_155_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_155_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_155_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_155_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_155_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_155_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_155_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_155_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_155_io_out_1_bits)
  );
  sub_crossbar_316 sub_crossbar_156 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_156_clock),
    .reset(sub_crossbar_156_reset),
    .io_in_0_ready(sub_crossbar_156_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_156_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_156_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_156_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_156_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_156_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_156_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_156_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_156_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_156_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_156_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_156_io_out_1_bits)
  );
  sub_crossbar_317 sub_crossbar_157 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_157_clock),
    .reset(sub_crossbar_157_reset),
    .io_in_0_ready(sub_crossbar_157_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_157_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_157_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_157_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_157_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_157_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_157_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_157_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_157_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_157_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_157_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_157_io_out_1_bits)
  );
  sub_crossbar_318 sub_crossbar_158 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_158_clock),
    .reset(sub_crossbar_158_reset),
    .io_in_0_ready(sub_crossbar_158_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_158_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_158_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_158_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_158_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_158_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_158_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_158_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_158_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_158_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_158_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_158_io_out_1_bits)
  );
  sub_crossbar_319 sub_crossbar_159 ( // @[crossbar.scala 139:43]
    .clock(sub_crossbar_159_clock),
    .reset(sub_crossbar_159_reset),
    .io_in_0_ready(sub_crossbar_159_io_in_0_ready),
    .io_in_0_valid(sub_crossbar_159_io_in_0_valid),
    .io_in_0_bits(sub_crossbar_159_io_in_0_bits),
    .io_in_1_ready(sub_crossbar_159_io_in_1_ready),
    .io_in_1_valid(sub_crossbar_159_io_in_1_valid),
    .io_in_1_bits(sub_crossbar_159_io_in_1_bits),
    .io_out_0_ready(sub_crossbar_159_io_out_0_ready),
    .io_out_0_valid(sub_crossbar_159_io_out_0_valid),
    .io_out_0_bits(sub_crossbar_159_io_out_0_bits),
    .io_out_1_ready(sub_crossbar_159_io_out_1_ready),
    .io_out_1_valid(sub_crossbar_159_io_out_1_valid),
    .io_out_1_bits(sub_crossbar_159_io_out_1_bits)
  );
  assign io_in_0_ready = sub_crossbar_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_1_ready = sub_crossbar_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_2_ready = sub_crossbar_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_3_ready = sub_crossbar_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_4_ready = sub_crossbar_3_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_5_ready = sub_crossbar_3_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_6_ready = sub_crossbar_3_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_7_ready = sub_crossbar_3_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_8_ready = sub_crossbar_6_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_9_ready = sub_crossbar_6_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_10_ready = sub_crossbar_6_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_11_ready = sub_crossbar_6_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_12_ready = sub_crossbar_9_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_13_ready = sub_crossbar_9_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_14_ready = sub_crossbar_9_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_15_ready = sub_crossbar_9_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_16_ready = sub_crossbar_12_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_17_ready = sub_crossbar_12_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_18_ready = sub_crossbar_12_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_19_ready = sub_crossbar_12_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_20_ready = sub_crossbar_15_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_21_ready = sub_crossbar_15_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_22_ready = sub_crossbar_15_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_23_ready = sub_crossbar_15_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_24_ready = sub_crossbar_18_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_25_ready = sub_crossbar_18_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_26_ready = sub_crossbar_18_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_27_ready = sub_crossbar_18_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_28_ready = sub_crossbar_21_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_29_ready = sub_crossbar_21_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_30_ready = sub_crossbar_21_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_31_ready = sub_crossbar_21_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_32_ready = sub_crossbar_24_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_33_ready = sub_crossbar_24_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_34_ready = sub_crossbar_24_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_35_ready = sub_crossbar_24_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_36_ready = sub_crossbar_27_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_37_ready = sub_crossbar_27_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_38_ready = sub_crossbar_27_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_39_ready = sub_crossbar_27_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_40_ready = sub_crossbar_30_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_41_ready = sub_crossbar_30_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_42_ready = sub_crossbar_30_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_43_ready = sub_crossbar_30_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_44_ready = sub_crossbar_33_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_45_ready = sub_crossbar_33_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_46_ready = sub_crossbar_33_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_47_ready = sub_crossbar_33_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_48_ready = sub_crossbar_36_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_49_ready = sub_crossbar_36_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_50_ready = sub_crossbar_36_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_51_ready = sub_crossbar_36_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_52_ready = sub_crossbar_39_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_53_ready = sub_crossbar_39_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_54_ready = sub_crossbar_39_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_55_ready = sub_crossbar_39_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_56_ready = sub_crossbar_42_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_57_ready = sub_crossbar_42_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_58_ready = sub_crossbar_42_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_59_ready = sub_crossbar_42_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_60_ready = sub_crossbar_45_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_61_ready = sub_crossbar_45_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_62_ready = sub_crossbar_45_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_63_ready = sub_crossbar_45_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_64_ready = sub_crossbar_48_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_65_ready = sub_crossbar_48_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_66_ready = sub_crossbar_48_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_67_ready = sub_crossbar_48_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_68_ready = sub_crossbar_51_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_69_ready = sub_crossbar_51_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_70_ready = sub_crossbar_51_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_71_ready = sub_crossbar_51_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_72_ready = sub_crossbar_54_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_73_ready = sub_crossbar_54_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_74_ready = sub_crossbar_54_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_75_ready = sub_crossbar_54_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_76_ready = sub_crossbar_57_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_77_ready = sub_crossbar_57_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_78_ready = sub_crossbar_57_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_79_ready = sub_crossbar_57_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_80_ready = sub_crossbar_60_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_81_ready = sub_crossbar_60_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_82_ready = sub_crossbar_60_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_83_ready = sub_crossbar_60_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_84_ready = sub_crossbar_63_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_85_ready = sub_crossbar_63_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_86_ready = sub_crossbar_63_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_87_ready = sub_crossbar_63_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_88_ready = sub_crossbar_66_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_89_ready = sub_crossbar_66_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_90_ready = sub_crossbar_66_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_91_ready = sub_crossbar_66_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_92_ready = sub_crossbar_69_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_93_ready = sub_crossbar_69_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_94_ready = sub_crossbar_69_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_95_ready = sub_crossbar_69_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_96_ready = sub_crossbar_72_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_97_ready = sub_crossbar_72_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_98_ready = sub_crossbar_72_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_99_ready = sub_crossbar_72_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_100_ready = sub_crossbar_75_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_101_ready = sub_crossbar_75_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_102_ready = sub_crossbar_75_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_103_ready = sub_crossbar_75_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_104_ready = sub_crossbar_78_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_105_ready = sub_crossbar_78_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_106_ready = sub_crossbar_78_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_107_ready = sub_crossbar_78_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_108_ready = sub_crossbar_81_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_109_ready = sub_crossbar_81_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_110_ready = sub_crossbar_81_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_111_ready = sub_crossbar_81_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_112_ready = sub_crossbar_84_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_113_ready = sub_crossbar_84_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_114_ready = sub_crossbar_84_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_115_ready = sub_crossbar_84_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_116_ready = sub_crossbar_87_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_117_ready = sub_crossbar_87_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_118_ready = sub_crossbar_87_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_119_ready = sub_crossbar_87_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_120_ready = sub_crossbar_90_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_121_ready = sub_crossbar_90_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_122_ready = sub_crossbar_90_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_123_ready = sub_crossbar_90_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_in_124_ready = sub_crossbar_93_io_in_0_ready; // @[crossbar.scala 143:53]
  assign io_in_125_ready = sub_crossbar_93_io_in_1_ready; // @[crossbar.scala 143:53]
  assign io_in_126_ready = sub_crossbar_93_io_in_2_ready; // @[crossbar.scala 143:53]
  assign io_in_127_ready = sub_crossbar_93_io_in_3_ready; // @[crossbar.scala 143:53]
  assign io_out_0_valid = sub_crossbar_96_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_0_bits = sub_crossbar_96_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_1_valid = sub_crossbar_97_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_1_bits = sub_crossbar_97_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_2_valid = sub_crossbar_98_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_2_bits = sub_crossbar_98_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_3_valid = sub_crossbar_99_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_3_bits = sub_crossbar_99_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_4_valid = sub_crossbar_100_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_4_bits = sub_crossbar_100_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_5_valid = sub_crossbar_101_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_5_bits = sub_crossbar_101_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_6_valid = sub_crossbar_102_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_6_bits = sub_crossbar_102_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_7_valid = sub_crossbar_103_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_7_bits = sub_crossbar_103_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_8_valid = sub_crossbar_104_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_8_bits = sub_crossbar_104_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_9_valid = sub_crossbar_105_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_9_bits = sub_crossbar_105_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_10_valid = sub_crossbar_106_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_10_bits = sub_crossbar_106_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_11_valid = sub_crossbar_107_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_11_bits = sub_crossbar_107_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_12_valid = sub_crossbar_108_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_12_bits = sub_crossbar_108_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_13_valid = sub_crossbar_109_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_13_bits = sub_crossbar_109_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_14_valid = sub_crossbar_110_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_14_bits = sub_crossbar_110_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_15_valid = sub_crossbar_111_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_15_bits = sub_crossbar_111_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_16_valid = sub_crossbar_112_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_16_bits = sub_crossbar_112_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_17_valid = sub_crossbar_113_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_17_bits = sub_crossbar_113_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_18_valid = sub_crossbar_114_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_18_bits = sub_crossbar_114_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_19_valid = sub_crossbar_115_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_19_bits = sub_crossbar_115_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_20_valid = sub_crossbar_116_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_20_bits = sub_crossbar_116_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_21_valid = sub_crossbar_117_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_21_bits = sub_crossbar_117_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_22_valid = sub_crossbar_118_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_22_bits = sub_crossbar_118_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_23_valid = sub_crossbar_119_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_23_bits = sub_crossbar_119_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_24_valid = sub_crossbar_120_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_24_bits = sub_crossbar_120_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_25_valid = sub_crossbar_121_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_25_bits = sub_crossbar_121_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_26_valid = sub_crossbar_122_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_26_bits = sub_crossbar_122_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_27_valid = sub_crossbar_123_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_27_bits = sub_crossbar_123_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_28_valid = sub_crossbar_124_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_28_bits = sub_crossbar_124_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_29_valid = sub_crossbar_125_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_29_bits = sub_crossbar_125_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_30_valid = sub_crossbar_126_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_30_bits = sub_crossbar_126_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_31_valid = sub_crossbar_127_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_31_bits = sub_crossbar_127_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_32_valid = sub_crossbar_128_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_32_bits = sub_crossbar_128_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_33_valid = sub_crossbar_129_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_33_bits = sub_crossbar_129_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_34_valid = sub_crossbar_130_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_34_bits = sub_crossbar_130_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_35_valid = sub_crossbar_131_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_35_bits = sub_crossbar_131_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_36_valid = sub_crossbar_132_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_36_bits = sub_crossbar_132_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_37_valid = sub_crossbar_133_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_37_bits = sub_crossbar_133_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_38_valid = sub_crossbar_134_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_38_bits = sub_crossbar_134_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_39_valid = sub_crossbar_135_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_39_bits = sub_crossbar_135_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_40_valid = sub_crossbar_136_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_40_bits = sub_crossbar_136_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_41_valid = sub_crossbar_137_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_41_bits = sub_crossbar_137_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_42_valid = sub_crossbar_138_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_42_bits = sub_crossbar_138_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_43_valid = sub_crossbar_139_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_43_bits = sub_crossbar_139_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_44_valid = sub_crossbar_140_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_44_bits = sub_crossbar_140_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_45_valid = sub_crossbar_141_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_45_bits = sub_crossbar_141_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_46_valid = sub_crossbar_142_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_46_bits = sub_crossbar_142_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_47_valid = sub_crossbar_143_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_47_bits = sub_crossbar_143_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_48_valid = sub_crossbar_144_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_48_bits = sub_crossbar_144_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_49_valid = sub_crossbar_145_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_49_bits = sub_crossbar_145_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_50_valid = sub_crossbar_146_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_50_bits = sub_crossbar_146_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_51_valid = sub_crossbar_147_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_51_bits = sub_crossbar_147_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_52_valid = sub_crossbar_148_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_52_bits = sub_crossbar_148_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_53_valid = sub_crossbar_149_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_53_bits = sub_crossbar_149_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_54_valid = sub_crossbar_150_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_54_bits = sub_crossbar_150_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_55_valid = sub_crossbar_151_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_55_bits = sub_crossbar_151_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_56_valid = sub_crossbar_152_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_56_bits = sub_crossbar_152_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_57_valid = sub_crossbar_153_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_57_bits = sub_crossbar_153_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_58_valid = sub_crossbar_154_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_58_bits = sub_crossbar_154_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_59_valid = sub_crossbar_155_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_59_bits = sub_crossbar_155_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_60_valid = sub_crossbar_156_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_60_bits = sub_crossbar_156_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_61_valid = sub_crossbar_157_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_61_bits = sub_crossbar_157_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_62_valid = sub_crossbar_158_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_62_bits = sub_crossbar_158_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_63_valid = sub_crossbar_159_io_out_0_valid; // @[crossbar.scala 152:53]
  assign io_out_63_bits = sub_crossbar_159_io_out_0_bits; // @[crossbar.scala 152:53]
  assign io_out_64_valid = sub_crossbar_96_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_64_bits = sub_crossbar_96_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_65_valid = sub_crossbar_97_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_65_bits = sub_crossbar_97_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_66_valid = sub_crossbar_98_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_66_bits = sub_crossbar_98_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_67_valid = sub_crossbar_99_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_67_bits = sub_crossbar_99_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_68_valid = sub_crossbar_100_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_68_bits = sub_crossbar_100_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_69_valid = sub_crossbar_101_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_69_bits = sub_crossbar_101_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_70_valid = sub_crossbar_102_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_70_bits = sub_crossbar_102_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_71_valid = sub_crossbar_103_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_71_bits = sub_crossbar_103_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_72_valid = sub_crossbar_104_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_72_bits = sub_crossbar_104_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_73_valid = sub_crossbar_105_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_73_bits = sub_crossbar_105_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_74_valid = sub_crossbar_106_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_74_bits = sub_crossbar_106_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_75_valid = sub_crossbar_107_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_75_bits = sub_crossbar_107_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_76_valid = sub_crossbar_108_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_76_bits = sub_crossbar_108_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_77_valid = sub_crossbar_109_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_77_bits = sub_crossbar_109_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_78_valid = sub_crossbar_110_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_78_bits = sub_crossbar_110_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_79_valid = sub_crossbar_111_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_79_bits = sub_crossbar_111_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_80_valid = sub_crossbar_112_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_80_bits = sub_crossbar_112_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_81_valid = sub_crossbar_113_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_81_bits = sub_crossbar_113_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_82_valid = sub_crossbar_114_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_82_bits = sub_crossbar_114_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_83_valid = sub_crossbar_115_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_83_bits = sub_crossbar_115_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_84_valid = sub_crossbar_116_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_84_bits = sub_crossbar_116_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_85_valid = sub_crossbar_117_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_85_bits = sub_crossbar_117_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_86_valid = sub_crossbar_118_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_86_bits = sub_crossbar_118_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_87_valid = sub_crossbar_119_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_87_bits = sub_crossbar_119_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_88_valid = sub_crossbar_120_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_88_bits = sub_crossbar_120_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_89_valid = sub_crossbar_121_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_89_bits = sub_crossbar_121_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_90_valid = sub_crossbar_122_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_90_bits = sub_crossbar_122_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_91_valid = sub_crossbar_123_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_91_bits = sub_crossbar_123_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_92_valid = sub_crossbar_124_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_92_bits = sub_crossbar_124_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_93_valid = sub_crossbar_125_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_93_bits = sub_crossbar_125_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_94_valid = sub_crossbar_126_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_94_bits = sub_crossbar_126_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_95_valid = sub_crossbar_127_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_95_bits = sub_crossbar_127_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_96_valid = sub_crossbar_128_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_96_bits = sub_crossbar_128_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_97_valid = sub_crossbar_129_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_97_bits = sub_crossbar_129_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_98_valid = sub_crossbar_130_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_98_bits = sub_crossbar_130_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_99_valid = sub_crossbar_131_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_99_bits = sub_crossbar_131_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_100_valid = sub_crossbar_132_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_100_bits = sub_crossbar_132_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_101_valid = sub_crossbar_133_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_101_bits = sub_crossbar_133_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_102_valid = sub_crossbar_134_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_102_bits = sub_crossbar_134_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_103_valid = sub_crossbar_135_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_103_bits = sub_crossbar_135_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_104_valid = sub_crossbar_136_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_104_bits = sub_crossbar_136_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_105_valid = sub_crossbar_137_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_105_bits = sub_crossbar_137_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_106_valid = sub_crossbar_138_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_106_bits = sub_crossbar_138_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_107_valid = sub_crossbar_139_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_107_bits = sub_crossbar_139_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_108_valid = sub_crossbar_140_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_108_bits = sub_crossbar_140_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_109_valid = sub_crossbar_141_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_109_bits = sub_crossbar_141_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_110_valid = sub_crossbar_142_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_110_bits = sub_crossbar_142_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_111_valid = sub_crossbar_143_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_111_bits = sub_crossbar_143_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_112_valid = sub_crossbar_144_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_112_bits = sub_crossbar_144_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_113_valid = sub_crossbar_145_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_113_bits = sub_crossbar_145_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_114_valid = sub_crossbar_146_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_114_bits = sub_crossbar_146_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_115_valid = sub_crossbar_147_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_115_bits = sub_crossbar_147_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_116_valid = sub_crossbar_148_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_116_bits = sub_crossbar_148_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_117_valid = sub_crossbar_149_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_117_bits = sub_crossbar_149_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_118_valid = sub_crossbar_150_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_118_bits = sub_crossbar_150_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_119_valid = sub_crossbar_151_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_119_bits = sub_crossbar_151_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_120_valid = sub_crossbar_152_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_120_bits = sub_crossbar_152_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_121_valid = sub_crossbar_153_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_121_bits = sub_crossbar_153_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_122_valid = sub_crossbar_154_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_122_bits = sub_crossbar_154_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_123_valid = sub_crossbar_155_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_123_bits = sub_crossbar_155_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_124_valid = sub_crossbar_156_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_124_bits = sub_crossbar_156_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_125_valid = sub_crossbar_157_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_125_bits = sub_crossbar_157_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_126_valid = sub_crossbar_158_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_126_bits = sub_crossbar_158_io_out_1_bits; // @[crossbar.scala 152:53]
  assign io_out_127_valid = sub_crossbar_159_io_out_1_valid; // @[crossbar.scala 152:53]
  assign io_out_127_bits = sub_crossbar_159_io_out_1_bits; // @[crossbar.scala 152:53]
  assign sub_crossbar_clock = clock;
  assign sub_crossbar_reset = reset;
  assign sub_crossbar_io_in_0_valid = io_in_0_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_0_bits = io_in_0_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_1_valid = io_in_1_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_1_bits = io_in_1_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_2_valid = io_in_2_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_2_bits = io_in_2_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_3_valid = io_in_3_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_in_3_bits = io_in_3_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_io_out_0_ready = sub_crossbar_1_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_1_ready = sub_crossbar_4_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_2_ready = sub_crossbar_7_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_io_out_3_ready = sub_crossbar_10_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_clock = clock;
  assign sub_crossbar_1_reset = reset;
  assign sub_crossbar_1_io_in_0_valid = sub_crossbar_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_0_bits = sub_crossbar_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_1_valid = sub_crossbar_3_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_1_bits = sub_crossbar_3_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_2_valid = sub_crossbar_6_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_2_bits = sub_crossbar_6_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_3_valid = sub_crossbar_9_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_in_3_bits = sub_crossbar_9_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_1_io_out_0_ready = sub_crossbar_2_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_1_ready = sub_crossbar_14_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_2_ready = sub_crossbar_26_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_1_io_out_3_ready = sub_crossbar_38_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_clock = clock;
  assign sub_crossbar_2_reset = reset;
  assign sub_crossbar_2_io_in_0_valid = sub_crossbar_1_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_0_bits = sub_crossbar_1_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_1_valid = sub_crossbar_13_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_1_bits = sub_crossbar_13_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_2_valid = sub_crossbar_25_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_2_bits = sub_crossbar_25_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_3_valid = sub_crossbar_37_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_in_3_bits = sub_crossbar_37_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_2_io_out_0_ready = sub_crossbar_96_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_1_ready = sub_crossbar_112_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_2_ready = sub_crossbar_128_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_2_io_out_3_ready = sub_crossbar_144_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_3_clock = clock;
  assign sub_crossbar_3_reset = reset;
  assign sub_crossbar_3_io_in_0_valid = io_in_4_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_0_bits = io_in_4_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_1_valid = io_in_5_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_1_bits = io_in_5_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_2_valid = io_in_6_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_2_bits = io_in_6_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_3_valid = io_in_7_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_in_3_bits = io_in_7_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_3_io_out_0_ready = sub_crossbar_1_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_1_ready = sub_crossbar_4_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_2_ready = sub_crossbar_7_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_3_io_out_3_ready = sub_crossbar_10_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_clock = clock;
  assign sub_crossbar_4_reset = reset;
  assign sub_crossbar_4_io_in_0_valid = sub_crossbar_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_0_bits = sub_crossbar_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_1_valid = sub_crossbar_3_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_1_bits = sub_crossbar_3_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_2_valid = sub_crossbar_6_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_2_bits = sub_crossbar_6_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_3_valid = sub_crossbar_9_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_in_3_bits = sub_crossbar_9_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_4_io_out_0_ready = sub_crossbar_5_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_1_ready = sub_crossbar_17_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_2_ready = sub_crossbar_29_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_4_io_out_3_ready = sub_crossbar_41_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_clock = clock;
  assign sub_crossbar_5_reset = reset;
  assign sub_crossbar_5_io_in_0_valid = sub_crossbar_4_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_0_bits = sub_crossbar_4_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_1_valid = sub_crossbar_16_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_1_bits = sub_crossbar_16_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_2_valid = sub_crossbar_28_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_2_bits = sub_crossbar_28_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_3_valid = sub_crossbar_40_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_in_3_bits = sub_crossbar_40_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_5_io_out_0_ready = sub_crossbar_97_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_1_ready = sub_crossbar_113_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_2_ready = sub_crossbar_129_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_5_io_out_3_ready = sub_crossbar_145_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_6_clock = clock;
  assign sub_crossbar_6_reset = reset;
  assign sub_crossbar_6_io_in_0_valid = io_in_8_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_0_bits = io_in_8_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_1_valid = io_in_9_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_1_bits = io_in_9_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_2_valid = io_in_10_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_2_bits = io_in_10_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_3_valid = io_in_11_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_in_3_bits = io_in_11_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_6_io_out_0_ready = sub_crossbar_1_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_1_ready = sub_crossbar_4_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_2_ready = sub_crossbar_7_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_6_io_out_3_ready = sub_crossbar_10_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_clock = clock;
  assign sub_crossbar_7_reset = reset;
  assign sub_crossbar_7_io_in_0_valid = sub_crossbar_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_0_bits = sub_crossbar_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_1_valid = sub_crossbar_3_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_1_bits = sub_crossbar_3_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_2_valid = sub_crossbar_6_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_2_bits = sub_crossbar_6_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_3_valid = sub_crossbar_9_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_in_3_bits = sub_crossbar_9_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_7_io_out_0_ready = sub_crossbar_8_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_1_ready = sub_crossbar_20_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_2_ready = sub_crossbar_32_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_7_io_out_3_ready = sub_crossbar_44_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_clock = clock;
  assign sub_crossbar_8_reset = reset;
  assign sub_crossbar_8_io_in_0_valid = sub_crossbar_7_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_0_bits = sub_crossbar_7_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_1_valid = sub_crossbar_19_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_1_bits = sub_crossbar_19_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_2_valid = sub_crossbar_31_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_2_bits = sub_crossbar_31_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_3_valid = sub_crossbar_43_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_in_3_bits = sub_crossbar_43_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_8_io_out_0_ready = sub_crossbar_98_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_1_ready = sub_crossbar_114_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_2_ready = sub_crossbar_130_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_8_io_out_3_ready = sub_crossbar_146_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_9_clock = clock;
  assign sub_crossbar_9_reset = reset;
  assign sub_crossbar_9_io_in_0_valid = io_in_12_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_0_bits = io_in_12_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_1_valid = io_in_13_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_1_bits = io_in_13_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_2_valid = io_in_14_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_2_bits = io_in_14_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_3_valid = io_in_15_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_in_3_bits = io_in_15_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_9_io_out_0_ready = sub_crossbar_1_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_1_ready = sub_crossbar_4_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_2_ready = sub_crossbar_7_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_9_io_out_3_ready = sub_crossbar_10_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_clock = clock;
  assign sub_crossbar_10_reset = reset;
  assign sub_crossbar_10_io_in_0_valid = sub_crossbar_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_0_bits = sub_crossbar_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_1_valid = sub_crossbar_3_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_1_bits = sub_crossbar_3_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_2_valid = sub_crossbar_6_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_2_bits = sub_crossbar_6_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_3_valid = sub_crossbar_9_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_in_3_bits = sub_crossbar_9_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_10_io_out_0_ready = sub_crossbar_11_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_1_ready = sub_crossbar_23_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_2_ready = sub_crossbar_35_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_10_io_out_3_ready = sub_crossbar_47_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_clock = clock;
  assign sub_crossbar_11_reset = reset;
  assign sub_crossbar_11_io_in_0_valid = sub_crossbar_10_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_0_bits = sub_crossbar_10_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_1_valid = sub_crossbar_22_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_1_bits = sub_crossbar_22_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_2_valid = sub_crossbar_34_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_2_bits = sub_crossbar_34_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_3_valid = sub_crossbar_46_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_in_3_bits = sub_crossbar_46_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_11_io_out_0_ready = sub_crossbar_99_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_1_ready = sub_crossbar_115_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_2_ready = sub_crossbar_131_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_11_io_out_3_ready = sub_crossbar_147_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_12_clock = clock;
  assign sub_crossbar_12_reset = reset;
  assign sub_crossbar_12_io_in_0_valid = io_in_16_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_0_bits = io_in_16_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_1_valid = io_in_17_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_1_bits = io_in_17_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_2_valid = io_in_18_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_2_bits = io_in_18_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_3_valid = io_in_19_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_in_3_bits = io_in_19_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_12_io_out_0_ready = sub_crossbar_13_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_1_ready = sub_crossbar_16_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_2_ready = sub_crossbar_19_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_12_io_out_3_ready = sub_crossbar_22_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_clock = clock;
  assign sub_crossbar_13_reset = reset;
  assign sub_crossbar_13_io_in_0_valid = sub_crossbar_12_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_0_bits = sub_crossbar_12_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_1_valid = sub_crossbar_15_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_1_bits = sub_crossbar_15_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_2_valid = sub_crossbar_18_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_2_bits = sub_crossbar_18_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_3_valid = sub_crossbar_21_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_in_3_bits = sub_crossbar_21_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_13_io_out_0_ready = sub_crossbar_2_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_1_ready = sub_crossbar_14_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_2_ready = sub_crossbar_26_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_13_io_out_3_ready = sub_crossbar_38_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_clock = clock;
  assign sub_crossbar_14_reset = reset;
  assign sub_crossbar_14_io_in_0_valid = sub_crossbar_1_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_0_bits = sub_crossbar_1_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_1_valid = sub_crossbar_13_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_1_bits = sub_crossbar_13_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_2_valid = sub_crossbar_25_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_2_bits = sub_crossbar_25_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_3_valid = sub_crossbar_37_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_in_3_bits = sub_crossbar_37_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_14_io_out_0_ready = sub_crossbar_100_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_1_ready = sub_crossbar_116_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_2_ready = sub_crossbar_132_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_14_io_out_3_ready = sub_crossbar_148_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_15_clock = clock;
  assign sub_crossbar_15_reset = reset;
  assign sub_crossbar_15_io_in_0_valid = io_in_20_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_0_bits = io_in_20_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_1_valid = io_in_21_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_1_bits = io_in_21_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_2_valid = io_in_22_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_2_bits = io_in_22_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_3_valid = io_in_23_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_in_3_bits = io_in_23_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_15_io_out_0_ready = sub_crossbar_13_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_1_ready = sub_crossbar_16_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_2_ready = sub_crossbar_19_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_15_io_out_3_ready = sub_crossbar_22_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_clock = clock;
  assign sub_crossbar_16_reset = reset;
  assign sub_crossbar_16_io_in_0_valid = sub_crossbar_12_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_0_bits = sub_crossbar_12_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_1_valid = sub_crossbar_15_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_1_bits = sub_crossbar_15_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_2_valid = sub_crossbar_18_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_2_bits = sub_crossbar_18_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_3_valid = sub_crossbar_21_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_in_3_bits = sub_crossbar_21_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_16_io_out_0_ready = sub_crossbar_5_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_1_ready = sub_crossbar_17_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_2_ready = sub_crossbar_29_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_16_io_out_3_ready = sub_crossbar_41_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_clock = clock;
  assign sub_crossbar_17_reset = reset;
  assign sub_crossbar_17_io_in_0_valid = sub_crossbar_4_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_0_bits = sub_crossbar_4_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_1_valid = sub_crossbar_16_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_1_bits = sub_crossbar_16_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_2_valid = sub_crossbar_28_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_2_bits = sub_crossbar_28_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_3_valid = sub_crossbar_40_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_in_3_bits = sub_crossbar_40_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_17_io_out_0_ready = sub_crossbar_101_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_1_ready = sub_crossbar_117_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_2_ready = sub_crossbar_133_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_17_io_out_3_ready = sub_crossbar_149_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_18_clock = clock;
  assign sub_crossbar_18_reset = reset;
  assign sub_crossbar_18_io_in_0_valid = io_in_24_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_0_bits = io_in_24_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_1_valid = io_in_25_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_1_bits = io_in_25_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_2_valid = io_in_26_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_2_bits = io_in_26_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_3_valid = io_in_27_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_in_3_bits = io_in_27_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_18_io_out_0_ready = sub_crossbar_13_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_1_ready = sub_crossbar_16_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_2_ready = sub_crossbar_19_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_18_io_out_3_ready = sub_crossbar_22_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_clock = clock;
  assign sub_crossbar_19_reset = reset;
  assign sub_crossbar_19_io_in_0_valid = sub_crossbar_12_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_0_bits = sub_crossbar_12_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_1_valid = sub_crossbar_15_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_1_bits = sub_crossbar_15_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_2_valid = sub_crossbar_18_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_2_bits = sub_crossbar_18_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_3_valid = sub_crossbar_21_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_in_3_bits = sub_crossbar_21_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_19_io_out_0_ready = sub_crossbar_8_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_1_ready = sub_crossbar_20_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_2_ready = sub_crossbar_32_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_19_io_out_3_ready = sub_crossbar_44_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_clock = clock;
  assign sub_crossbar_20_reset = reset;
  assign sub_crossbar_20_io_in_0_valid = sub_crossbar_7_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_0_bits = sub_crossbar_7_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_1_valid = sub_crossbar_19_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_1_bits = sub_crossbar_19_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_2_valid = sub_crossbar_31_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_2_bits = sub_crossbar_31_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_3_valid = sub_crossbar_43_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_in_3_bits = sub_crossbar_43_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_20_io_out_0_ready = sub_crossbar_102_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_1_ready = sub_crossbar_118_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_2_ready = sub_crossbar_134_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_20_io_out_3_ready = sub_crossbar_150_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_21_clock = clock;
  assign sub_crossbar_21_reset = reset;
  assign sub_crossbar_21_io_in_0_valid = io_in_28_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_0_bits = io_in_28_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_1_valid = io_in_29_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_1_bits = io_in_29_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_2_valid = io_in_30_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_2_bits = io_in_30_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_3_valid = io_in_31_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_in_3_bits = io_in_31_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_21_io_out_0_ready = sub_crossbar_13_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_1_ready = sub_crossbar_16_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_2_ready = sub_crossbar_19_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_21_io_out_3_ready = sub_crossbar_22_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_clock = clock;
  assign sub_crossbar_22_reset = reset;
  assign sub_crossbar_22_io_in_0_valid = sub_crossbar_12_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_0_bits = sub_crossbar_12_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_1_valid = sub_crossbar_15_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_1_bits = sub_crossbar_15_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_2_valid = sub_crossbar_18_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_2_bits = sub_crossbar_18_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_3_valid = sub_crossbar_21_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_in_3_bits = sub_crossbar_21_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_22_io_out_0_ready = sub_crossbar_11_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_1_ready = sub_crossbar_23_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_2_ready = sub_crossbar_35_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_22_io_out_3_ready = sub_crossbar_47_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_clock = clock;
  assign sub_crossbar_23_reset = reset;
  assign sub_crossbar_23_io_in_0_valid = sub_crossbar_10_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_0_bits = sub_crossbar_10_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_1_valid = sub_crossbar_22_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_1_bits = sub_crossbar_22_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_2_valid = sub_crossbar_34_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_2_bits = sub_crossbar_34_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_3_valid = sub_crossbar_46_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_in_3_bits = sub_crossbar_46_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_23_io_out_0_ready = sub_crossbar_103_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_1_ready = sub_crossbar_119_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_2_ready = sub_crossbar_135_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_23_io_out_3_ready = sub_crossbar_151_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_24_clock = clock;
  assign sub_crossbar_24_reset = reset;
  assign sub_crossbar_24_io_in_0_valid = io_in_32_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_0_bits = io_in_32_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_1_valid = io_in_33_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_1_bits = io_in_33_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_2_valid = io_in_34_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_2_bits = io_in_34_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_3_valid = io_in_35_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_in_3_bits = io_in_35_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_24_io_out_0_ready = sub_crossbar_25_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_1_ready = sub_crossbar_28_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_2_ready = sub_crossbar_31_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_24_io_out_3_ready = sub_crossbar_34_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_clock = clock;
  assign sub_crossbar_25_reset = reset;
  assign sub_crossbar_25_io_in_0_valid = sub_crossbar_24_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_0_bits = sub_crossbar_24_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_1_valid = sub_crossbar_27_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_1_bits = sub_crossbar_27_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_2_valid = sub_crossbar_30_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_2_bits = sub_crossbar_30_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_3_valid = sub_crossbar_33_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_in_3_bits = sub_crossbar_33_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_25_io_out_0_ready = sub_crossbar_2_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_1_ready = sub_crossbar_14_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_2_ready = sub_crossbar_26_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_25_io_out_3_ready = sub_crossbar_38_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_clock = clock;
  assign sub_crossbar_26_reset = reset;
  assign sub_crossbar_26_io_in_0_valid = sub_crossbar_1_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_0_bits = sub_crossbar_1_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_1_valid = sub_crossbar_13_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_1_bits = sub_crossbar_13_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_2_valid = sub_crossbar_25_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_2_bits = sub_crossbar_25_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_3_valid = sub_crossbar_37_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_in_3_bits = sub_crossbar_37_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_26_io_out_0_ready = sub_crossbar_104_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_1_ready = sub_crossbar_120_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_2_ready = sub_crossbar_136_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_26_io_out_3_ready = sub_crossbar_152_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_27_clock = clock;
  assign sub_crossbar_27_reset = reset;
  assign sub_crossbar_27_io_in_0_valid = io_in_36_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_0_bits = io_in_36_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_1_valid = io_in_37_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_1_bits = io_in_37_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_2_valid = io_in_38_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_2_bits = io_in_38_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_3_valid = io_in_39_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_in_3_bits = io_in_39_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_27_io_out_0_ready = sub_crossbar_25_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_1_ready = sub_crossbar_28_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_2_ready = sub_crossbar_31_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_27_io_out_3_ready = sub_crossbar_34_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_clock = clock;
  assign sub_crossbar_28_reset = reset;
  assign sub_crossbar_28_io_in_0_valid = sub_crossbar_24_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_0_bits = sub_crossbar_24_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_1_valid = sub_crossbar_27_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_1_bits = sub_crossbar_27_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_2_valid = sub_crossbar_30_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_2_bits = sub_crossbar_30_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_3_valid = sub_crossbar_33_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_in_3_bits = sub_crossbar_33_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_28_io_out_0_ready = sub_crossbar_5_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_1_ready = sub_crossbar_17_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_2_ready = sub_crossbar_29_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_28_io_out_3_ready = sub_crossbar_41_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_clock = clock;
  assign sub_crossbar_29_reset = reset;
  assign sub_crossbar_29_io_in_0_valid = sub_crossbar_4_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_0_bits = sub_crossbar_4_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_1_valid = sub_crossbar_16_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_1_bits = sub_crossbar_16_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_2_valid = sub_crossbar_28_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_2_bits = sub_crossbar_28_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_3_valid = sub_crossbar_40_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_in_3_bits = sub_crossbar_40_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_29_io_out_0_ready = sub_crossbar_105_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_1_ready = sub_crossbar_121_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_2_ready = sub_crossbar_137_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_29_io_out_3_ready = sub_crossbar_153_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_30_clock = clock;
  assign sub_crossbar_30_reset = reset;
  assign sub_crossbar_30_io_in_0_valid = io_in_40_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_0_bits = io_in_40_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_1_valid = io_in_41_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_1_bits = io_in_41_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_2_valid = io_in_42_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_2_bits = io_in_42_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_3_valid = io_in_43_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_in_3_bits = io_in_43_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_30_io_out_0_ready = sub_crossbar_25_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_1_ready = sub_crossbar_28_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_2_ready = sub_crossbar_31_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_30_io_out_3_ready = sub_crossbar_34_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_clock = clock;
  assign sub_crossbar_31_reset = reset;
  assign sub_crossbar_31_io_in_0_valid = sub_crossbar_24_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_0_bits = sub_crossbar_24_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_1_valid = sub_crossbar_27_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_1_bits = sub_crossbar_27_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_2_valid = sub_crossbar_30_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_2_bits = sub_crossbar_30_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_3_valid = sub_crossbar_33_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_in_3_bits = sub_crossbar_33_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_31_io_out_0_ready = sub_crossbar_8_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_1_ready = sub_crossbar_20_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_2_ready = sub_crossbar_32_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_31_io_out_3_ready = sub_crossbar_44_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_clock = clock;
  assign sub_crossbar_32_reset = reset;
  assign sub_crossbar_32_io_in_0_valid = sub_crossbar_7_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_0_bits = sub_crossbar_7_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_1_valid = sub_crossbar_19_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_1_bits = sub_crossbar_19_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_2_valid = sub_crossbar_31_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_2_bits = sub_crossbar_31_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_3_valid = sub_crossbar_43_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_in_3_bits = sub_crossbar_43_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_32_io_out_0_ready = sub_crossbar_106_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_1_ready = sub_crossbar_122_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_2_ready = sub_crossbar_138_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_32_io_out_3_ready = sub_crossbar_154_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_33_clock = clock;
  assign sub_crossbar_33_reset = reset;
  assign sub_crossbar_33_io_in_0_valid = io_in_44_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_0_bits = io_in_44_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_1_valid = io_in_45_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_1_bits = io_in_45_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_2_valid = io_in_46_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_2_bits = io_in_46_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_3_valid = io_in_47_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_in_3_bits = io_in_47_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_33_io_out_0_ready = sub_crossbar_25_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_1_ready = sub_crossbar_28_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_2_ready = sub_crossbar_31_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_33_io_out_3_ready = sub_crossbar_34_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_clock = clock;
  assign sub_crossbar_34_reset = reset;
  assign sub_crossbar_34_io_in_0_valid = sub_crossbar_24_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_0_bits = sub_crossbar_24_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_1_valid = sub_crossbar_27_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_1_bits = sub_crossbar_27_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_2_valid = sub_crossbar_30_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_2_bits = sub_crossbar_30_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_3_valid = sub_crossbar_33_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_in_3_bits = sub_crossbar_33_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_34_io_out_0_ready = sub_crossbar_11_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_1_ready = sub_crossbar_23_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_2_ready = sub_crossbar_35_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_34_io_out_3_ready = sub_crossbar_47_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_clock = clock;
  assign sub_crossbar_35_reset = reset;
  assign sub_crossbar_35_io_in_0_valid = sub_crossbar_10_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_0_bits = sub_crossbar_10_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_1_valid = sub_crossbar_22_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_1_bits = sub_crossbar_22_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_2_valid = sub_crossbar_34_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_2_bits = sub_crossbar_34_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_3_valid = sub_crossbar_46_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_in_3_bits = sub_crossbar_46_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_35_io_out_0_ready = sub_crossbar_107_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_1_ready = sub_crossbar_123_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_2_ready = sub_crossbar_139_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_35_io_out_3_ready = sub_crossbar_155_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_36_clock = clock;
  assign sub_crossbar_36_reset = reset;
  assign sub_crossbar_36_io_in_0_valid = io_in_48_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_0_bits = io_in_48_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_1_valid = io_in_49_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_1_bits = io_in_49_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_2_valid = io_in_50_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_2_bits = io_in_50_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_3_valid = io_in_51_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_in_3_bits = io_in_51_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_36_io_out_0_ready = sub_crossbar_37_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_1_ready = sub_crossbar_40_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_2_ready = sub_crossbar_43_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_36_io_out_3_ready = sub_crossbar_46_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_clock = clock;
  assign sub_crossbar_37_reset = reset;
  assign sub_crossbar_37_io_in_0_valid = sub_crossbar_36_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_0_bits = sub_crossbar_36_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_1_valid = sub_crossbar_39_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_1_bits = sub_crossbar_39_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_2_valid = sub_crossbar_42_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_2_bits = sub_crossbar_42_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_3_valid = sub_crossbar_45_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_in_3_bits = sub_crossbar_45_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_37_io_out_0_ready = sub_crossbar_2_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_1_ready = sub_crossbar_14_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_2_ready = sub_crossbar_26_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_37_io_out_3_ready = sub_crossbar_38_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_clock = clock;
  assign sub_crossbar_38_reset = reset;
  assign sub_crossbar_38_io_in_0_valid = sub_crossbar_1_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_0_bits = sub_crossbar_1_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_1_valid = sub_crossbar_13_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_1_bits = sub_crossbar_13_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_2_valid = sub_crossbar_25_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_2_bits = sub_crossbar_25_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_3_valid = sub_crossbar_37_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_in_3_bits = sub_crossbar_37_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_38_io_out_0_ready = sub_crossbar_108_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_1_ready = sub_crossbar_124_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_2_ready = sub_crossbar_140_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_38_io_out_3_ready = sub_crossbar_156_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_39_clock = clock;
  assign sub_crossbar_39_reset = reset;
  assign sub_crossbar_39_io_in_0_valid = io_in_52_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_0_bits = io_in_52_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_1_valid = io_in_53_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_1_bits = io_in_53_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_2_valid = io_in_54_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_2_bits = io_in_54_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_3_valid = io_in_55_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_in_3_bits = io_in_55_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_39_io_out_0_ready = sub_crossbar_37_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_1_ready = sub_crossbar_40_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_2_ready = sub_crossbar_43_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_39_io_out_3_ready = sub_crossbar_46_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_clock = clock;
  assign sub_crossbar_40_reset = reset;
  assign sub_crossbar_40_io_in_0_valid = sub_crossbar_36_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_0_bits = sub_crossbar_36_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_1_valid = sub_crossbar_39_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_1_bits = sub_crossbar_39_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_2_valid = sub_crossbar_42_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_2_bits = sub_crossbar_42_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_3_valid = sub_crossbar_45_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_in_3_bits = sub_crossbar_45_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_40_io_out_0_ready = sub_crossbar_5_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_1_ready = sub_crossbar_17_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_2_ready = sub_crossbar_29_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_40_io_out_3_ready = sub_crossbar_41_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_clock = clock;
  assign sub_crossbar_41_reset = reset;
  assign sub_crossbar_41_io_in_0_valid = sub_crossbar_4_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_0_bits = sub_crossbar_4_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_1_valid = sub_crossbar_16_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_1_bits = sub_crossbar_16_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_2_valid = sub_crossbar_28_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_2_bits = sub_crossbar_28_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_3_valid = sub_crossbar_40_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_in_3_bits = sub_crossbar_40_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_41_io_out_0_ready = sub_crossbar_109_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_1_ready = sub_crossbar_125_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_2_ready = sub_crossbar_141_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_41_io_out_3_ready = sub_crossbar_157_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_42_clock = clock;
  assign sub_crossbar_42_reset = reset;
  assign sub_crossbar_42_io_in_0_valid = io_in_56_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_0_bits = io_in_56_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_1_valid = io_in_57_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_1_bits = io_in_57_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_2_valid = io_in_58_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_2_bits = io_in_58_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_3_valid = io_in_59_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_in_3_bits = io_in_59_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_42_io_out_0_ready = sub_crossbar_37_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_1_ready = sub_crossbar_40_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_2_ready = sub_crossbar_43_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_42_io_out_3_ready = sub_crossbar_46_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_clock = clock;
  assign sub_crossbar_43_reset = reset;
  assign sub_crossbar_43_io_in_0_valid = sub_crossbar_36_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_0_bits = sub_crossbar_36_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_1_valid = sub_crossbar_39_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_1_bits = sub_crossbar_39_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_2_valid = sub_crossbar_42_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_2_bits = sub_crossbar_42_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_3_valid = sub_crossbar_45_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_in_3_bits = sub_crossbar_45_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_43_io_out_0_ready = sub_crossbar_8_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_1_ready = sub_crossbar_20_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_2_ready = sub_crossbar_32_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_43_io_out_3_ready = sub_crossbar_44_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_clock = clock;
  assign sub_crossbar_44_reset = reset;
  assign sub_crossbar_44_io_in_0_valid = sub_crossbar_7_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_0_bits = sub_crossbar_7_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_1_valid = sub_crossbar_19_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_1_bits = sub_crossbar_19_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_2_valid = sub_crossbar_31_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_2_bits = sub_crossbar_31_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_3_valid = sub_crossbar_43_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_in_3_bits = sub_crossbar_43_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_44_io_out_0_ready = sub_crossbar_110_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_1_ready = sub_crossbar_126_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_2_ready = sub_crossbar_142_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_44_io_out_3_ready = sub_crossbar_158_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_45_clock = clock;
  assign sub_crossbar_45_reset = reset;
  assign sub_crossbar_45_io_in_0_valid = io_in_60_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_0_bits = io_in_60_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_1_valid = io_in_61_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_1_bits = io_in_61_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_2_valid = io_in_62_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_2_bits = io_in_62_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_3_valid = io_in_63_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_in_3_bits = io_in_63_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_45_io_out_0_ready = sub_crossbar_37_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_1_ready = sub_crossbar_40_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_2_ready = sub_crossbar_43_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_45_io_out_3_ready = sub_crossbar_46_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_clock = clock;
  assign sub_crossbar_46_reset = reset;
  assign sub_crossbar_46_io_in_0_valid = sub_crossbar_36_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_0_bits = sub_crossbar_36_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_1_valid = sub_crossbar_39_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_1_bits = sub_crossbar_39_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_2_valid = sub_crossbar_42_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_2_bits = sub_crossbar_42_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_3_valid = sub_crossbar_45_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_in_3_bits = sub_crossbar_45_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_46_io_out_0_ready = sub_crossbar_11_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_1_ready = sub_crossbar_23_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_2_ready = sub_crossbar_35_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_46_io_out_3_ready = sub_crossbar_47_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_clock = clock;
  assign sub_crossbar_47_reset = reset;
  assign sub_crossbar_47_io_in_0_valid = sub_crossbar_10_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_0_bits = sub_crossbar_10_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_1_valid = sub_crossbar_22_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_1_bits = sub_crossbar_22_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_2_valid = sub_crossbar_34_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_2_bits = sub_crossbar_34_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_3_valid = sub_crossbar_46_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_in_3_bits = sub_crossbar_46_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_47_io_out_0_ready = sub_crossbar_111_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_1_ready = sub_crossbar_127_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_2_ready = sub_crossbar_143_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_47_io_out_3_ready = sub_crossbar_159_io_in_0_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_48_clock = clock;
  assign sub_crossbar_48_reset = reset;
  assign sub_crossbar_48_io_in_0_valid = io_in_64_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_0_bits = io_in_64_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_1_valid = io_in_65_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_1_bits = io_in_65_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_2_valid = io_in_66_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_2_bits = io_in_66_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_3_valid = io_in_67_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_in_3_bits = io_in_67_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_48_io_out_0_ready = sub_crossbar_49_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_1_ready = sub_crossbar_52_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_2_ready = sub_crossbar_55_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_48_io_out_3_ready = sub_crossbar_58_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_clock = clock;
  assign sub_crossbar_49_reset = reset;
  assign sub_crossbar_49_io_in_0_valid = sub_crossbar_48_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_0_bits = sub_crossbar_48_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_1_valid = sub_crossbar_51_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_1_bits = sub_crossbar_51_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_2_valid = sub_crossbar_54_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_2_bits = sub_crossbar_54_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_3_valid = sub_crossbar_57_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_in_3_bits = sub_crossbar_57_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_49_io_out_0_ready = sub_crossbar_50_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_1_ready = sub_crossbar_62_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_2_ready = sub_crossbar_74_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_49_io_out_3_ready = sub_crossbar_86_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_clock = clock;
  assign sub_crossbar_50_reset = reset;
  assign sub_crossbar_50_io_in_0_valid = sub_crossbar_49_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_0_bits = sub_crossbar_49_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_1_valid = sub_crossbar_61_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_1_bits = sub_crossbar_61_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_2_valid = sub_crossbar_73_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_2_bits = sub_crossbar_73_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_3_valid = sub_crossbar_85_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_in_3_bits = sub_crossbar_85_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_50_io_out_0_ready = sub_crossbar_96_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_1_ready = sub_crossbar_112_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_2_ready = sub_crossbar_128_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_50_io_out_3_ready = sub_crossbar_144_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_51_clock = clock;
  assign sub_crossbar_51_reset = reset;
  assign sub_crossbar_51_io_in_0_valid = io_in_68_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_0_bits = io_in_68_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_1_valid = io_in_69_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_1_bits = io_in_69_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_2_valid = io_in_70_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_2_bits = io_in_70_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_3_valid = io_in_71_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_in_3_bits = io_in_71_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_51_io_out_0_ready = sub_crossbar_49_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_1_ready = sub_crossbar_52_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_2_ready = sub_crossbar_55_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_51_io_out_3_ready = sub_crossbar_58_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_clock = clock;
  assign sub_crossbar_52_reset = reset;
  assign sub_crossbar_52_io_in_0_valid = sub_crossbar_48_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_0_bits = sub_crossbar_48_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_1_valid = sub_crossbar_51_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_1_bits = sub_crossbar_51_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_2_valid = sub_crossbar_54_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_2_bits = sub_crossbar_54_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_3_valid = sub_crossbar_57_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_in_3_bits = sub_crossbar_57_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_52_io_out_0_ready = sub_crossbar_53_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_1_ready = sub_crossbar_65_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_2_ready = sub_crossbar_77_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_52_io_out_3_ready = sub_crossbar_89_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_clock = clock;
  assign sub_crossbar_53_reset = reset;
  assign sub_crossbar_53_io_in_0_valid = sub_crossbar_52_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_0_bits = sub_crossbar_52_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_1_valid = sub_crossbar_64_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_1_bits = sub_crossbar_64_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_2_valid = sub_crossbar_76_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_2_bits = sub_crossbar_76_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_3_valid = sub_crossbar_88_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_in_3_bits = sub_crossbar_88_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_53_io_out_0_ready = sub_crossbar_97_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_1_ready = sub_crossbar_113_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_2_ready = sub_crossbar_129_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_53_io_out_3_ready = sub_crossbar_145_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_54_clock = clock;
  assign sub_crossbar_54_reset = reset;
  assign sub_crossbar_54_io_in_0_valid = io_in_72_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_0_bits = io_in_72_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_1_valid = io_in_73_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_1_bits = io_in_73_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_2_valid = io_in_74_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_2_bits = io_in_74_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_3_valid = io_in_75_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_in_3_bits = io_in_75_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_54_io_out_0_ready = sub_crossbar_49_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_1_ready = sub_crossbar_52_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_2_ready = sub_crossbar_55_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_54_io_out_3_ready = sub_crossbar_58_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_clock = clock;
  assign sub_crossbar_55_reset = reset;
  assign sub_crossbar_55_io_in_0_valid = sub_crossbar_48_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_0_bits = sub_crossbar_48_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_1_valid = sub_crossbar_51_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_1_bits = sub_crossbar_51_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_2_valid = sub_crossbar_54_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_2_bits = sub_crossbar_54_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_3_valid = sub_crossbar_57_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_in_3_bits = sub_crossbar_57_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_55_io_out_0_ready = sub_crossbar_56_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_1_ready = sub_crossbar_68_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_2_ready = sub_crossbar_80_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_55_io_out_3_ready = sub_crossbar_92_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_clock = clock;
  assign sub_crossbar_56_reset = reset;
  assign sub_crossbar_56_io_in_0_valid = sub_crossbar_55_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_0_bits = sub_crossbar_55_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_1_valid = sub_crossbar_67_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_1_bits = sub_crossbar_67_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_2_valid = sub_crossbar_79_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_2_bits = sub_crossbar_79_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_3_valid = sub_crossbar_91_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_in_3_bits = sub_crossbar_91_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_56_io_out_0_ready = sub_crossbar_98_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_1_ready = sub_crossbar_114_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_2_ready = sub_crossbar_130_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_56_io_out_3_ready = sub_crossbar_146_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_57_clock = clock;
  assign sub_crossbar_57_reset = reset;
  assign sub_crossbar_57_io_in_0_valid = io_in_76_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_0_bits = io_in_76_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_1_valid = io_in_77_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_1_bits = io_in_77_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_2_valid = io_in_78_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_2_bits = io_in_78_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_3_valid = io_in_79_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_in_3_bits = io_in_79_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_57_io_out_0_ready = sub_crossbar_49_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_1_ready = sub_crossbar_52_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_2_ready = sub_crossbar_55_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_57_io_out_3_ready = sub_crossbar_58_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_clock = clock;
  assign sub_crossbar_58_reset = reset;
  assign sub_crossbar_58_io_in_0_valid = sub_crossbar_48_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_0_bits = sub_crossbar_48_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_1_valid = sub_crossbar_51_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_1_bits = sub_crossbar_51_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_2_valid = sub_crossbar_54_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_2_bits = sub_crossbar_54_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_3_valid = sub_crossbar_57_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_in_3_bits = sub_crossbar_57_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_58_io_out_0_ready = sub_crossbar_59_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_1_ready = sub_crossbar_71_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_2_ready = sub_crossbar_83_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_58_io_out_3_ready = sub_crossbar_95_io_in_0_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_clock = clock;
  assign sub_crossbar_59_reset = reset;
  assign sub_crossbar_59_io_in_0_valid = sub_crossbar_58_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_0_bits = sub_crossbar_58_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_1_valid = sub_crossbar_70_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_1_bits = sub_crossbar_70_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_2_valid = sub_crossbar_82_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_2_bits = sub_crossbar_82_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_3_valid = sub_crossbar_94_io_out_0_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_in_3_bits = sub_crossbar_94_io_out_0_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_59_io_out_0_ready = sub_crossbar_99_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_1_ready = sub_crossbar_115_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_2_ready = sub_crossbar_131_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_59_io_out_3_ready = sub_crossbar_147_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_60_clock = clock;
  assign sub_crossbar_60_reset = reset;
  assign sub_crossbar_60_io_in_0_valid = io_in_80_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_0_bits = io_in_80_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_1_valid = io_in_81_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_1_bits = io_in_81_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_2_valid = io_in_82_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_2_bits = io_in_82_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_3_valid = io_in_83_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_in_3_bits = io_in_83_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_60_io_out_0_ready = sub_crossbar_61_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_1_ready = sub_crossbar_64_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_2_ready = sub_crossbar_67_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_60_io_out_3_ready = sub_crossbar_70_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_clock = clock;
  assign sub_crossbar_61_reset = reset;
  assign sub_crossbar_61_io_in_0_valid = sub_crossbar_60_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_0_bits = sub_crossbar_60_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_1_valid = sub_crossbar_63_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_1_bits = sub_crossbar_63_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_2_valid = sub_crossbar_66_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_2_bits = sub_crossbar_66_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_3_valid = sub_crossbar_69_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_in_3_bits = sub_crossbar_69_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_61_io_out_0_ready = sub_crossbar_50_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_1_ready = sub_crossbar_62_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_2_ready = sub_crossbar_74_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_61_io_out_3_ready = sub_crossbar_86_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_clock = clock;
  assign sub_crossbar_62_reset = reset;
  assign sub_crossbar_62_io_in_0_valid = sub_crossbar_49_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_0_bits = sub_crossbar_49_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_1_valid = sub_crossbar_61_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_1_bits = sub_crossbar_61_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_2_valid = sub_crossbar_73_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_2_bits = sub_crossbar_73_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_3_valid = sub_crossbar_85_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_in_3_bits = sub_crossbar_85_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_62_io_out_0_ready = sub_crossbar_100_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_1_ready = sub_crossbar_116_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_2_ready = sub_crossbar_132_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_62_io_out_3_ready = sub_crossbar_148_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_63_clock = clock;
  assign sub_crossbar_63_reset = reset;
  assign sub_crossbar_63_io_in_0_valid = io_in_84_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_0_bits = io_in_84_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_1_valid = io_in_85_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_1_bits = io_in_85_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_2_valid = io_in_86_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_2_bits = io_in_86_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_3_valid = io_in_87_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_in_3_bits = io_in_87_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_63_io_out_0_ready = sub_crossbar_61_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_1_ready = sub_crossbar_64_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_2_ready = sub_crossbar_67_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_63_io_out_3_ready = sub_crossbar_70_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_clock = clock;
  assign sub_crossbar_64_reset = reset;
  assign sub_crossbar_64_io_in_0_valid = sub_crossbar_60_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_0_bits = sub_crossbar_60_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_1_valid = sub_crossbar_63_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_1_bits = sub_crossbar_63_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_2_valid = sub_crossbar_66_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_2_bits = sub_crossbar_66_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_3_valid = sub_crossbar_69_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_in_3_bits = sub_crossbar_69_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_64_io_out_0_ready = sub_crossbar_53_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_1_ready = sub_crossbar_65_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_2_ready = sub_crossbar_77_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_64_io_out_3_ready = sub_crossbar_89_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_clock = clock;
  assign sub_crossbar_65_reset = reset;
  assign sub_crossbar_65_io_in_0_valid = sub_crossbar_52_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_0_bits = sub_crossbar_52_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_1_valid = sub_crossbar_64_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_1_bits = sub_crossbar_64_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_2_valid = sub_crossbar_76_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_2_bits = sub_crossbar_76_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_3_valid = sub_crossbar_88_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_in_3_bits = sub_crossbar_88_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_65_io_out_0_ready = sub_crossbar_101_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_1_ready = sub_crossbar_117_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_2_ready = sub_crossbar_133_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_65_io_out_3_ready = sub_crossbar_149_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_66_clock = clock;
  assign sub_crossbar_66_reset = reset;
  assign sub_crossbar_66_io_in_0_valid = io_in_88_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_0_bits = io_in_88_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_1_valid = io_in_89_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_1_bits = io_in_89_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_2_valid = io_in_90_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_2_bits = io_in_90_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_3_valid = io_in_91_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_in_3_bits = io_in_91_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_66_io_out_0_ready = sub_crossbar_61_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_1_ready = sub_crossbar_64_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_2_ready = sub_crossbar_67_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_66_io_out_3_ready = sub_crossbar_70_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_clock = clock;
  assign sub_crossbar_67_reset = reset;
  assign sub_crossbar_67_io_in_0_valid = sub_crossbar_60_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_0_bits = sub_crossbar_60_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_1_valid = sub_crossbar_63_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_1_bits = sub_crossbar_63_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_2_valid = sub_crossbar_66_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_2_bits = sub_crossbar_66_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_3_valid = sub_crossbar_69_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_in_3_bits = sub_crossbar_69_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_67_io_out_0_ready = sub_crossbar_56_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_1_ready = sub_crossbar_68_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_2_ready = sub_crossbar_80_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_67_io_out_3_ready = sub_crossbar_92_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_clock = clock;
  assign sub_crossbar_68_reset = reset;
  assign sub_crossbar_68_io_in_0_valid = sub_crossbar_55_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_0_bits = sub_crossbar_55_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_1_valid = sub_crossbar_67_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_1_bits = sub_crossbar_67_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_2_valid = sub_crossbar_79_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_2_bits = sub_crossbar_79_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_3_valid = sub_crossbar_91_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_in_3_bits = sub_crossbar_91_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_68_io_out_0_ready = sub_crossbar_102_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_1_ready = sub_crossbar_118_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_2_ready = sub_crossbar_134_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_68_io_out_3_ready = sub_crossbar_150_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_69_clock = clock;
  assign sub_crossbar_69_reset = reset;
  assign sub_crossbar_69_io_in_0_valid = io_in_92_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_0_bits = io_in_92_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_1_valid = io_in_93_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_1_bits = io_in_93_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_2_valid = io_in_94_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_2_bits = io_in_94_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_3_valid = io_in_95_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_in_3_bits = io_in_95_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_69_io_out_0_ready = sub_crossbar_61_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_1_ready = sub_crossbar_64_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_2_ready = sub_crossbar_67_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_69_io_out_3_ready = sub_crossbar_70_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_clock = clock;
  assign sub_crossbar_70_reset = reset;
  assign sub_crossbar_70_io_in_0_valid = sub_crossbar_60_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_0_bits = sub_crossbar_60_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_1_valid = sub_crossbar_63_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_1_bits = sub_crossbar_63_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_2_valid = sub_crossbar_66_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_2_bits = sub_crossbar_66_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_3_valid = sub_crossbar_69_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_in_3_bits = sub_crossbar_69_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_70_io_out_0_ready = sub_crossbar_59_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_1_ready = sub_crossbar_71_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_2_ready = sub_crossbar_83_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_70_io_out_3_ready = sub_crossbar_95_io_in_1_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_clock = clock;
  assign sub_crossbar_71_reset = reset;
  assign sub_crossbar_71_io_in_0_valid = sub_crossbar_58_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_0_bits = sub_crossbar_58_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_1_valid = sub_crossbar_70_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_1_bits = sub_crossbar_70_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_2_valid = sub_crossbar_82_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_2_bits = sub_crossbar_82_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_3_valid = sub_crossbar_94_io_out_1_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_in_3_bits = sub_crossbar_94_io_out_1_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_71_io_out_0_ready = sub_crossbar_103_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_1_ready = sub_crossbar_119_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_2_ready = sub_crossbar_135_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_71_io_out_3_ready = sub_crossbar_151_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_72_clock = clock;
  assign sub_crossbar_72_reset = reset;
  assign sub_crossbar_72_io_in_0_valid = io_in_96_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_0_bits = io_in_96_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_1_valid = io_in_97_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_1_bits = io_in_97_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_2_valid = io_in_98_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_2_bits = io_in_98_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_3_valid = io_in_99_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_in_3_bits = io_in_99_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_72_io_out_0_ready = sub_crossbar_73_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_1_ready = sub_crossbar_76_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_2_ready = sub_crossbar_79_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_72_io_out_3_ready = sub_crossbar_82_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_clock = clock;
  assign sub_crossbar_73_reset = reset;
  assign sub_crossbar_73_io_in_0_valid = sub_crossbar_72_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_0_bits = sub_crossbar_72_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_1_valid = sub_crossbar_75_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_1_bits = sub_crossbar_75_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_2_valid = sub_crossbar_78_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_2_bits = sub_crossbar_78_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_3_valid = sub_crossbar_81_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_in_3_bits = sub_crossbar_81_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_73_io_out_0_ready = sub_crossbar_50_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_1_ready = sub_crossbar_62_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_2_ready = sub_crossbar_74_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_73_io_out_3_ready = sub_crossbar_86_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_clock = clock;
  assign sub_crossbar_74_reset = reset;
  assign sub_crossbar_74_io_in_0_valid = sub_crossbar_49_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_0_bits = sub_crossbar_49_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_1_valid = sub_crossbar_61_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_1_bits = sub_crossbar_61_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_2_valid = sub_crossbar_73_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_2_bits = sub_crossbar_73_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_3_valid = sub_crossbar_85_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_in_3_bits = sub_crossbar_85_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_74_io_out_0_ready = sub_crossbar_104_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_1_ready = sub_crossbar_120_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_2_ready = sub_crossbar_136_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_74_io_out_3_ready = sub_crossbar_152_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_75_clock = clock;
  assign sub_crossbar_75_reset = reset;
  assign sub_crossbar_75_io_in_0_valid = io_in_100_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_0_bits = io_in_100_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_1_valid = io_in_101_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_1_bits = io_in_101_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_2_valid = io_in_102_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_2_bits = io_in_102_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_3_valid = io_in_103_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_in_3_bits = io_in_103_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_75_io_out_0_ready = sub_crossbar_73_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_1_ready = sub_crossbar_76_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_2_ready = sub_crossbar_79_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_75_io_out_3_ready = sub_crossbar_82_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_clock = clock;
  assign sub_crossbar_76_reset = reset;
  assign sub_crossbar_76_io_in_0_valid = sub_crossbar_72_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_0_bits = sub_crossbar_72_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_1_valid = sub_crossbar_75_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_1_bits = sub_crossbar_75_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_2_valid = sub_crossbar_78_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_2_bits = sub_crossbar_78_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_3_valid = sub_crossbar_81_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_in_3_bits = sub_crossbar_81_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_76_io_out_0_ready = sub_crossbar_53_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_1_ready = sub_crossbar_65_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_2_ready = sub_crossbar_77_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_76_io_out_3_ready = sub_crossbar_89_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_clock = clock;
  assign sub_crossbar_77_reset = reset;
  assign sub_crossbar_77_io_in_0_valid = sub_crossbar_52_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_0_bits = sub_crossbar_52_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_1_valid = sub_crossbar_64_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_1_bits = sub_crossbar_64_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_2_valid = sub_crossbar_76_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_2_bits = sub_crossbar_76_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_3_valid = sub_crossbar_88_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_in_3_bits = sub_crossbar_88_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_77_io_out_0_ready = sub_crossbar_105_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_1_ready = sub_crossbar_121_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_2_ready = sub_crossbar_137_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_77_io_out_3_ready = sub_crossbar_153_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_78_clock = clock;
  assign sub_crossbar_78_reset = reset;
  assign sub_crossbar_78_io_in_0_valid = io_in_104_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_0_bits = io_in_104_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_1_valid = io_in_105_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_1_bits = io_in_105_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_2_valid = io_in_106_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_2_bits = io_in_106_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_3_valid = io_in_107_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_in_3_bits = io_in_107_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_78_io_out_0_ready = sub_crossbar_73_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_1_ready = sub_crossbar_76_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_2_ready = sub_crossbar_79_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_78_io_out_3_ready = sub_crossbar_82_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_clock = clock;
  assign sub_crossbar_79_reset = reset;
  assign sub_crossbar_79_io_in_0_valid = sub_crossbar_72_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_0_bits = sub_crossbar_72_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_1_valid = sub_crossbar_75_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_1_bits = sub_crossbar_75_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_2_valid = sub_crossbar_78_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_2_bits = sub_crossbar_78_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_3_valid = sub_crossbar_81_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_in_3_bits = sub_crossbar_81_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_79_io_out_0_ready = sub_crossbar_56_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_1_ready = sub_crossbar_68_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_2_ready = sub_crossbar_80_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_79_io_out_3_ready = sub_crossbar_92_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_clock = clock;
  assign sub_crossbar_80_reset = reset;
  assign sub_crossbar_80_io_in_0_valid = sub_crossbar_55_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_0_bits = sub_crossbar_55_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_1_valid = sub_crossbar_67_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_1_bits = sub_crossbar_67_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_2_valid = sub_crossbar_79_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_2_bits = sub_crossbar_79_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_3_valid = sub_crossbar_91_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_in_3_bits = sub_crossbar_91_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_80_io_out_0_ready = sub_crossbar_106_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_1_ready = sub_crossbar_122_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_2_ready = sub_crossbar_138_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_80_io_out_3_ready = sub_crossbar_154_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_81_clock = clock;
  assign sub_crossbar_81_reset = reset;
  assign sub_crossbar_81_io_in_0_valid = io_in_108_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_0_bits = io_in_108_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_1_valid = io_in_109_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_1_bits = io_in_109_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_2_valid = io_in_110_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_2_bits = io_in_110_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_3_valid = io_in_111_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_in_3_bits = io_in_111_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_81_io_out_0_ready = sub_crossbar_73_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_1_ready = sub_crossbar_76_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_2_ready = sub_crossbar_79_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_81_io_out_3_ready = sub_crossbar_82_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_clock = clock;
  assign sub_crossbar_82_reset = reset;
  assign sub_crossbar_82_io_in_0_valid = sub_crossbar_72_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_0_bits = sub_crossbar_72_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_1_valid = sub_crossbar_75_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_1_bits = sub_crossbar_75_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_2_valid = sub_crossbar_78_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_2_bits = sub_crossbar_78_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_3_valid = sub_crossbar_81_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_in_3_bits = sub_crossbar_81_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_82_io_out_0_ready = sub_crossbar_59_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_1_ready = sub_crossbar_71_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_2_ready = sub_crossbar_83_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_82_io_out_3_ready = sub_crossbar_95_io_in_2_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_clock = clock;
  assign sub_crossbar_83_reset = reset;
  assign sub_crossbar_83_io_in_0_valid = sub_crossbar_58_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_0_bits = sub_crossbar_58_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_1_valid = sub_crossbar_70_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_1_bits = sub_crossbar_70_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_2_valid = sub_crossbar_82_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_2_bits = sub_crossbar_82_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_3_valid = sub_crossbar_94_io_out_2_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_in_3_bits = sub_crossbar_94_io_out_2_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_83_io_out_0_ready = sub_crossbar_107_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_1_ready = sub_crossbar_123_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_2_ready = sub_crossbar_139_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_83_io_out_3_ready = sub_crossbar_155_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_84_clock = clock;
  assign sub_crossbar_84_reset = reset;
  assign sub_crossbar_84_io_in_0_valid = io_in_112_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_0_bits = io_in_112_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_1_valid = io_in_113_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_1_bits = io_in_113_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_2_valid = io_in_114_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_2_bits = io_in_114_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_3_valid = io_in_115_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_in_3_bits = io_in_115_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_84_io_out_0_ready = sub_crossbar_85_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_1_ready = sub_crossbar_88_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_2_ready = sub_crossbar_91_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_84_io_out_3_ready = sub_crossbar_94_io_in_0_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_clock = clock;
  assign sub_crossbar_85_reset = reset;
  assign sub_crossbar_85_io_in_0_valid = sub_crossbar_84_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_0_bits = sub_crossbar_84_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_1_valid = sub_crossbar_87_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_1_bits = sub_crossbar_87_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_2_valid = sub_crossbar_90_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_2_bits = sub_crossbar_90_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_3_valid = sub_crossbar_93_io_out_0_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_in_3_bits = sub_crossbar_93_io_out_0_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_85_io_out_0_ready = sub_crossbar_50_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_1_ready = sub_crossbar_62_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_2_ready = sub_crossbar_74_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_85_io_out_3_ready = sub_crossbar_86_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_clock = clock;
  assign sub_crossbar_86_reset = reset;
  assign sub_crossbar_86_io_in_0_valid = sub_crossbar_49_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_0_bits = sub_crossbar_49_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_1_valid = sub_crossbar_61_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_1_bits = sub_crossbar_61_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_2_valid = sub_crossbar_73_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_2_bits = sub_crossbar_73_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_3_valid = sub_crossbar_85_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_in_3_bits = sub_crossbar_85_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_86_io_out_0_ready = sub_crossbar_108_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_1_ready = sub_crossbar_124_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_2_ready = sub_crossbar_140_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_86_io_out_3_ready = sub_crossbar_156_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_87_clock = clock;
  assign sub_crossbar_87_reset = reset;
  assign sub_crossbar_87_io_in_0_valid = io_in_116_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_0_bits = io_in_116_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_1_valid = io_in_117_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_1_bits = io_in_117_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_2_valid = io_in_118_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_2_bits = io_in_118_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_3_valid = io_in_119_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_in_3_bits = io_in_119_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_87_io_out_0_ready = sub_crossbar_85_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_1_ready = sub_crossbar_88_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_2_ready = sub_crossbar_91_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_87_io_out_3_ready = sub_crossbar_94_io_in_1_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_clock = clock;
  assign sub_crossbar_88_reset = reset;
  assign sub_crossbar_88_io_in_0_valid = sub_crossbar_84_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_0_bits = sub_crossbar_84_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_1_valid = sub_crossbar_87_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_1_bits = sub_crossbar_87_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_2_valid = sub_crossbar_90_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_2_bits = sub_crossbar_90_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_3_valid = sub_crossbar_93_io_out_1_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_in_3_bits = sub_crossbar_93_io_out_1_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_88_io_out_0_ready = sub_crossbar_53_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_1_ready = sub_crossbar_65_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_2_ready = sub_crossbar_77_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_88_io_out_3_ready = sub_crossbar_89_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_clock = clock;
  assign sub_crossbar_89_reset = reset;
  assign sub_crossbar_89_io_in_0_valid = sub_crossbar_52_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_0_bits = sub_crossbar_52_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_1_valid = sub_crossbar_64_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_1_bits = sub_crossbar_64_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_2_valid = sub_crossbar_76_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_2_bits = sub_crossbar_76_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_3_valid = sub_crossbar_88_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_in_3_bits = sub_crossbar_88_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_89_io_out_0_ready = sub_crossbar_109_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_1_ready = sub_crossbar_125_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_2_ready = sub_crossbar_141_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_89_io_out_3_ready = sub_crossbar_157_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_90_clock = clock;
  assign sub_crossbar_90_reset = reset;
  assign sub_crossbar_90_io_in_0_valid = io_in_120_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_0_bits = io_in_120_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_1_valid = io_in_121_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_1_bits = io_in_121_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_2_valid = io_in_122_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_2_bits = io_in_122_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_3_valid = io_in_123_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_in_3_bits = io_in_123_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_90_io_out_0_ready = sub_crossbar_85_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_1_ready = sub_crossbar_88_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_2_ready = sub_crossbar_91_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_90_io_out_3_ready = sub_crossbar_94_io_in_2_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_clock = clock;
  assign sub_crossbar_91_reset = reset;
  assign sub_crossbar_91_io_in_0_valid = sub_crossbar_84_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_0_bits = sub_crossbar_84_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_1_valid = sub_crossbar_87_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_1_bits = sub_crossbar_87_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_2_valid = sub_crossbar_90_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_2_bits = sub_crossbar_90_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_3_valid = sub_crossbar_93_io_out_2_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_in_3_bits = sub_crossbar_93_io_out_2_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_91_io_out_0_ready = sub_crossbar_56_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_1_ready = sub_crossbar_68_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_2_ready = sub_crossbar_80_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_91_io_out_3_ready = sub_crossbar_92_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_clock = clock;
  assign sub_crossbar_92_reset = reset;
  assign sub_crossbar_92_io_in_0_valid = sub_crossbar_55_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_0_bits = sub_crossbar_55_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_1_valid = sub_crossbar_67_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_1_bits = sub_crossbar_67_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_2_valid = sub_crossbar_79_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_2_bits = sub_crossbar_79_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_3_valid = sub_crossbar_91_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_in_3_bits = sub_crossbar_91_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_92_io_out_0_ready = sub_crossbar_110_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_1_ready = sub_crossbar_126_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_2_ready = sub_crossbar_142_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_92_io_out_3_ready = sub_crossbar_158_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_93_clock = clock;
  assign sub_crossbar_93_reset = reset;
  assign sub_crossbar_93_io_in_0_valid = io_in_124_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_0_bits = io_in_124_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_1_valid = io_in_125_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_1_bits = io_in_125_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_2_valid = io_in_126_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_2_bits = io_in_126_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_3_valid = io_in_127_valid; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_in_3_bits = io_in_127_bits; // @[crossbar.scala 143:53]
  assign sub_crossbar_93_io_out_0_ready = sub_crossbar_85_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_1_ready = sub_crossbar_88_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_2_ready = sub_crossbar_91_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_93_io_out_3_ready = sub_crossbar_94_io_in_3_ready; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_clock = clock;
  assign sub_crossbar_94_reset = reset;
  assign sub_crossbar_94_io_in_0_valid = sub_crossbar_84_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_0_bits = sub_crossbar_84_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_1_valid = sub_crossbar_87_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_1_bits = sub_crossbar_87_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_2_valid = sub_crossbar_90_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_2_bits = sub_crossbar_90_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_3_valid = sub_crossbar_93_io_out_3_valid; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_in_3_bits = sub_crossbar_93_io_out_3_bits; // @[crossbar.scala 144:53]
  assign sub_crossbar_94_io_out_0_ready = sub_crossbar_59_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_1_ready = sub_crossbar_71_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_2_ready = sub_crossbar_83_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_94_io_out_3_ready = sub_crossbar_95_io_in_3_ready; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_clock = clock;
  assign sub_crossbar_95_reset = reset;
  assign sub_crossbar_95_io_in_0_valid = sub_crossbar_58_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_0_bits = sub_crossbar_58_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_1_valid = sub_crossbar_70_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_1_bits = sub_crossbar_70_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_2_valid = sub_crossbar_82_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_2_bits = sub_crossbar_82_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_3_valid = sub_crossbar_94_io_out_3_valid; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_in_3_bits = sub_crossbar_94_io_out_3_bits; // @[crossbar.scala 145:53]
  assign sub_crossbar_95_io_out_0_ready = sub_crossbar_111_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_1_ready = sub_crossbar_127_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_2_ready = sub_crossbar_143_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_95_io_out_3_ready = sub_crossbar_159_io_in_1_ready; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_clock = clock;
  assign sub_crossbar_96_reset = reset;
  assign sub_crossbar_96_io_in_0_valid = sub_crossbar_2_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_0_bits = sub_crossbar_2_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_1_valid = sub_crossbar_50_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_in_1_bits = sub_crossbar_50_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_96_io_out_0_ready = io_out_0_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_96_io_out_1_ready = io_out_64_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_97_clock = clock;
  assign sub_crossbar_97_reset = reset;
  assign sub_crossbar_97_io_in_0_valid = sub_crossbar_5_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_0_bits = sub_crossbar_5_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_1_valid = sub_crossbar_53_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_in_1_bits = sub_crossbar_53_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_97_io_out_0_ready = io_out_1_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_97_io_out_1_ready = io_out_65_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_98_clock = clock;
  assign sub_crossbar_98_reset = reset;
  assign sub_crossbar_98_io_in_0_valid = sub_crossbar_8_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_0_bits = sub_crossbar_8_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_1_valid = sub_crossbar_56_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_in_1_bits = sub_crossbar_56_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_98_io_out_0_ready = io_out_2_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_98_io_out_1_ready = io_out_66_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_99_clock = clock;
  assign sub_crossbar_99_reset = reset;
  assign sub_crossbar_99_io_in_0_valid = sub_crossbar_11_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_0_bits = sub_crossbar_11_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_1_valid = sub_crossbar_59_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_in_1_bits = sub_crossbar_59_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_99_io_out_0_ready = io_out_3_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_99_io_out_1_ready = io_out_67_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_100_clock = clock;
  assign sub_crossbar_100_reset = reset;
  assign sub_crossbar_100_io_in_0_valid = sub_crossbar_14_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_0_bits = sub_crossbar_14_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_1_valid = sub_crossbar_62_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_in_1_bits = sub_crossbar_62_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_100_io_out_0_ready = io_out_4_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_100_io_out_1_ready = io_out_68_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_101_clock = clock;
  assign sub_crossbar_101_reset = reset;
  assign sub_crossbar_101_io_in_0_valid = sub_crossbar_17_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_0_bits = sub_crossbar_17_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_1_valid = sub_crossbar_65_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_in_1_bits = sub_crossbar_65_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_101_io_out_0_ready = io_out_5_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_101_io_out_1_ready = io_out_69_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_102_clock = clock;
  assign sub_crossbar_102_reset = reset;
  assign sub_crossbar_102_io_in_0_valid = sub_crossbar_20_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_0_bits = sub_crossbar_20_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_1_valid = sub_crossbar_68_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_in_1_bits = sub_crossbar_68_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_102_io_out_0_ready = io_out_6_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_102_io_out_1_ready = io_out_70_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_103_clock = clock;
  assign sub_crossbar_103_reset = reset;
  assign sub_crossbar_103_io_in_0_valid = sub_crossbar_23_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_0_bits = sub_crossbar_23_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_1_valid = sub_crossbar_71_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_in_1_bits = sub_crossbar_71_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_103_io_out_0_ready = io_out_7_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_103_io_out_1_ready = io_out_71_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_104_clock = clock;
  assign sub_crossbar_104_reset = reset;
  assign sub_crossbar_104_io_in_0_valid = sub_crossbar_26_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_0_bits = sub_crossbar_26_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_1_valid = sub_crossbar_74_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_in_1_bits = sub_crossbar_74_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_104_io_out_0_ready = io_out_8_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_104_io_out_1_ready = io_out_72_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_105_clock = clock;
  assign sub_crossbar_105_reset = reset;
  assign sub_crossbar_105_io_in_0_valid = sub_crossbar_29_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_0_bits = sub_crossbar_29_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_1_valid = sub_crossbar_77_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_in_1_bits = sub_crossbar_77_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_105_io_out_0_ready = io_out_9_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_105_io_out_1_ready = io_out_73_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_106_clock = clock;
  assign sub_crossbar_106_reset = reset;
  assign sub_crossbar_106_io_in_0_valid = sub_crossbar_32_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_0_bits = sub_crossbar_32_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_1_valid = sub_crossbar_80_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_in_1_bits = sub_crossbar_80_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_106_io_out_0_ready = io_out_10_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_106_io_out_1_ready = io_out_74_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_107_clock = clock;
  assign sub_crossbar_107_reset = reset;
  assign sub_crossbar_107_io_in_0_valid = sub_crossbar_35_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_0_bits = sub_crossbar_35_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_1_valid = sub_crossbar_83_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_in_1_bits = sub_crossbar_83_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_107_io_out_0_ready = io_out_11_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_107_io_out_1_ready = io_out_75_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_108_clock = clock;
  assign sub_crossbar_108_reset = reset;
  assign sub_crossbar_108_io_in_0_valid = sub_crossbar_38_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_0_bits = sub_crossbar_38_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_1_valid = sub_crossbar_86_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_in_1_bits = sub_crossbar_86_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_108_io_out_0_ready = io_out_12_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_108_io_out_1_ready = io_out_76_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_109_clock = clock;
  assign sub_crossbar_109_reset = reset;
  assign sub_crossbar_109_io_in_0_valid = sub_crossbar_41_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_0_bits = sub_crossbar_41_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_1_valid = sub_crossbar_89_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_in_1_bits = sub_crossbar_89_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_109_io_out_0_ready = io_out_13_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_109_io_out_1_ready = io_out_77_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_110_clock = clock;
  assign sub_crossbar_110_reset = reset;
  assign sub_crossbar_110_io_in_0_valid = sub_crossbar_44_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_0_bits = sub_crossbar_44_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_1_valid = sub_crossbar_92_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_in_1_bits = sub_crossbar_92_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_110_io_out_0_ready = io_out_14_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_110_io_out_1_ready = io_out_78_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_111_clock = clock;
  assign sub_crossbar_111_reset = reset;
  assign sub_crossbar_111_io_in_0_valid = sub_crossbar_47_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_0_bits = sub_crossbar_47_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_1_valid = sub_crossbar_95_io_out_0_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_in_1_bits = sub_crossbar_95_io_out_0_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_111_io_out_0_ready = io_out_15_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_111_io_out_1_ready = io_out_79_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_112_clock = clock;
  assign sub_crossbar_112_reset = reset;
  assign sub_crossbar_112_io_in_0_valid = sub_crossbar_2_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_0_bits = sub_crossbar_2_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_1_valid = sub_crossbar_50_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_in_1_bits = sub_crossbar_50_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_112_io_out_0_ready = io_out_16_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_112_io_out_1_ready = io_out_80_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_113_clock = clock;
  assign sub_crossbar_113_reset = reset;
  assign sub_crossbar_113_io_in_0_valid = sub_crossbar_5_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_0_bits = sub_crossbar_5_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_1_valid = sub_crossbar_53_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_in_1_bits = sub_crossbar_53_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_113_io_out_0_ready = io_out_17_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_113_io_out_1_ready = io_out_81_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_114_clock = clock;
  assign sub_crossbar_114_reset = reset;
  assign sub_crossbar_114_io_in_0_valid = sub_crossbar_8_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_0_bits = sub_crossbar_8_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_1_valid = sub_crossbar_56_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_in_1_bits = sub_crossbar_56_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_114_io_out_0_ready = io_out_18_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_114_io_out_1_ready = io_out_82_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_115_clock = clock;
  assign sub_crossbar_115_reset = reset;
  assign sub_crossbar_115_io_in_0_valid = sub_crossbar_11_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_0_bits = sub_crossbar_11_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_1_valid = sub_crossbar_59_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_in_1_bits = sub_crossbar_59_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_115_io_out_0_ready = io_out_19_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_115_io_out_1_ready = io_out_83_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_116_clock = clock;
  assign sub_crossbar_116_reset = reset;
  assign sub_crossbar_116_io_in_0_valid = sub_crossbar_14_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_0_bits = sub_crossbar_14_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_1_valid = sub_crossbar_62_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_in_1_bits = sub_crossbar_62_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_116_io_out_0_ready = io_out_20_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_116_io_out_1_ready = io_out_84_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_117_clock = clock;
  assign sub_crossbar_117_reset = reset;
  assign sub_crossbar_117_io_in_0_valid = sub_crossbar_17_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_0_bits = sub_crossbar_17_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_1_valid = sub_crossbar_65_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_in_1_bits = sub_crossbar_65_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_117_io_out_0_ready = io_out_21_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_117_io_out_1_ready = io_out_85_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_118_clock = clock;
  assign sub_crossbar_118_reset = reset;
  assign sub_crossbar_118_io_in_0_valid = sub_crossbar_20_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_0_bits = sub_crossbar_20_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_1_valid = sub_crossbar_68_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_in_1_bits = sub_crossbar_68_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_118_io_out_0_ready = io_out_22_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_118_io_out_1_ready = io_out_86_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_119_clock = clock;
  assign sub_crossbar_119_reset = reset;
  assign sub_crossbar_119_io_in_0_valid = sub_crossbar_23_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_0_bits = sub_crossbar_23_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_1_valid = sub_crossbar_71_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_in_1_bits = sub_crossbar_71_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_119_io_out_0_ready = io_out_23_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_119_io_out_1_ready = io_out_87_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_120_clock = clock;
  assign sub_crossbar_120_reset = reset;
  assign sub_crossbar_120_io_in_0_valid = sub_crossbar_26_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_0_bits = sub_crossbar_26_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_1_valid = sub_crossbar_74_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_in_1_bits = sub_crossbar_74_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_120_io_out_0_ready = io_out_24_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_120_io_out_1_ready = io_out_88_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_121_clock = clock;
  assign sub_crossbar_121_reset = reset;
  assign sub_crossbar_121_io_in_0_valid = sub_crossbar_29_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_0_bits = sub_crossbar_29_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_1_valid = sub_crossbar_77_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_in_1_bits = sub_crossbar_77_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_121_io_out_0_ready = io_out_25_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_121_io_out_1_ready = io_out_89_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_122_clock = clock;
  assign sub_crossbar_122_reset = reset;
  assign sub_crossbar_122_io_in_0_valid = sub_crossbar_32_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_0_bits = sub_crossbar_32_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_1_valid = sub_crossbar_80_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_in_1_bits = sub_crossbar_80_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_122_io_out_0_ready = io_out_26_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_122_io_out_1_ready = io_out_90_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_123_clock = clock;
  assign sub_crossbar_123_reset = reset;
  assign sub_crossbar_123_io_in_0_valid = sub_crossbar_35_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_0_bits = sub_crossbar_35_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_1_valid = sub_crossbar_83_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_in_1_bits = sub_crossbar_83_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_123_io_out_0_ready = io_out_27_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_123_io_out_1_ready = io_out_91_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_124_clock = clock;
  assign sub_crossbar_124_reset = reset;
  assign sub_crossbar_124_io_in_0_valid = sub_crossbar_38_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_0_bits = sub_crossbar_38_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_1_valid = sub_crossbar_86_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_in_1_bits = sub_crossbar_86_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_124_io_out_0_ready = io_out_28_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_124_io_out_1_ready = io_out_92_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_125_clock = clock;
  assign sub_crossbar_125_reset = reset;
  assign sub_crossbar_125_io_in_0_valid = sub_crossbar_41_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_0_bits = sub_crossbar_41_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_1_valid = sub_crossbar_89_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_in_1_bits = sub_crossbar_89_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_125_io_out_0_ready = io_out_29_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_125_io_out_1_ready = io_out_93_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_126_clock = clock;
  assign sub_crossbar_126_reset = reset;
  assign sub_crossbar_126_io_in_0_valid = sub_crossbar_44_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_0_bits = sub_crossbar_44_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_1_valid = sub_crossbar_92_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_in_1_bits = sub_crossbar_92_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_126_io_out_0_ready = io_out_30_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_126_io_out_1_ready = io_out_94_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_127_clock = clock;
  assign sub_crossbar_127_reset = reset;
  assign sub_crossbar_127_io_in_0_valid = sub_crossbar_47_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_0_bits = sub_crossbar_47_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_1_valid = sub_crossbar_95_io_out_1_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_in_1_bits = sub_crossbar_95_io_out_1_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_127_io_out_0_ready = io_out_31_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_127_io_out_1_ready = io_out_95_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_128_clock = clock;
  assign sub_crossbar_128_reset = reset;
  assign sub_crossbar_128_io_in_0_valid = sub_crossbar_2_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_0_bits = sub_crossbar_2_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_1_valid = sub_crossbar_50_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_in_1_bits = sub_crossbar_50_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_128_io_out_0_ready = io_out_32_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_128_io_out_1_ready = io_out_96_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_129_clock = clock;
  assign sub_crossbar_129_reset = reset;
  assign sub_crossbar_129_io_in_0_valid = sub_crossbar_5_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_0_bits = sub_crossbar_5_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_1_valid = sub_crossbar_53_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_in_1_bits = sub_crossbar_53_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_129_io_out_0_ready = io_out_33_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_129_io_out_1_ready = io_out_97_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_130_clock = clock;
  assign sub_crossbar_130_reset = reset;
  assign sub_crossbar_130_io_in_0_valid = sub_crossbar_8_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_0_bits = sub_crossbar_8_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_1_valid = sub_crossbar_56_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_in_1_bits = sub_crossbar_56_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_130_io_out_0_ready = io_out_34_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_130_io_out_1_ready = io_out_98_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_131_clock = clock;
  assign sub_crossbar_131_reset = reset;
  assign sub_crossbar_131_io_in_0_valid = sub_crossbar_11_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_0_bits = sub_crossbar_11_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_1_valid = sub_crossbar_59_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_in_1_bits = sub_crossbar_59_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_131_io_out_0_ready = io_out_35_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_131_io_out_1_ready = io_out_99_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_132_clock = clock;
  assign sub_crossbar_132_reset = reset;
  assign sub_crossbar_132_io_in_0_valid = sub_crossbar_14_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_0_bits = sub_crossbar_14_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_1_valid = sub_crossbar_62_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_in_1_bits = sub_crossbar_62_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_132_io_out_0_ready = io_out_36_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_132_io_out_1_ready = io_out_100_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_133_clock = clock;
  assign sub_crossbar_133_reset = reset;
  assign sub_crossbar_133_io_in_0_valid = sub_crossbar_17_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_0_bits = sub_crossbar_17_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_1_valid = sub_crossbar_65_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_in_1_bits = sub_crossbar_65_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_133_io_out_0_ready = io_out_37_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_133_io_out_1_ready = io_out_101_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_134_clock = clock;
  assign sub_crossbar_134_reset = reset;
  assign sub_crossbar_134_io_in_0_valid = sub_crossbar_20_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_0_bits = sub_crossbar_20_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_1_valid = sub_crossbar_68_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_in_1_bits = sub_crossbar_68_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_134_io_out_0_ready = io_out_38_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_134_io_out_1_ready = io_out_102_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_135_clock = clock;
  assign sub_crossbar_135_reset = reset;
  assign sub_crossbar_135_io_in_0_valid = sub_crossbar_23_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_0_bits = sub_crossbar_23_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_1_valid = sub_crossbar_71_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_in_1_bits = sub_crossbar_71_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_135_io_out_0_ready = io_out_39_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_135_io_out_1_ready = io_out_103_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_136_clock = clock;
  assign sub_crossbar_136_reset = reset;
  assign sub_crossbar_136_io_in_0_valid = sub_crossbar_26_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_0_bits = sub_crossbar_26_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_1_valid = sub_crossbar_74_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_in_1_bits = sub_crossbar_74_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_136_io_out_0_ready = io_out_40_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_136_io_out_1_ready = io_out_104_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_137_clock = clock;
  assign sub_crossbar_137_reset = reset;
  assign sub_crossbar_137_io_in_0_valid = sub_crossbar_29_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_0_bits = sub_crossbar_29_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_1_valid = sub_crossbar_77_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_in_1_bits = sub_crossbar_77_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_137_io_out_0_ready = io_out_41_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_137_io_out_1_ready = io_out_105_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_138_clock = clock;
  assign sub_crossbar_138_reset = reset;
  assign sub_crossbar_138_io_in_0_valid = sub_crossbar_32_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_0_bits = sub_crossbar_32_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_1_valid = sub_crossbar_80_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_in_1_bits = sub_crossbar_80_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_138_io_out_0_ready = io_out_42_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_138_io_out_1_ready = io_out_106_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_139_clock = clock;
  assign sub_crossbar_139_reset = reset;
  assign sub_crossbar_139_io_in_0_valid = sub_crossbar_35_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_0_bits = sub_crossbar_35_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_1_valid = sub_crossbar_83_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_in_1_bits = sub_crossbar_83_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_139_io_out_0_ready = io_out_43_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_139_io_out_1_ready = io_out_107_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_140_clock = clock;
  assign sub_crossbar_140_reset = reset;
  assign sub_crossbar_140_io_in_0_valid = sub_crossbar_38_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_0_bits = sub_crossbar_38_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_1_valid = sub_crossbar_86_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_in_1_bits = sub_crossbar_86_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_140_io_out_0_ready = io_out_44_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_140_io_out_1_ready = io_out_108_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_141_clock = clock;
  assign sub_crossbar_141_reset = reset;
  assign sub_crossbar_141_io_in_0_valid = sub_crossbar_41_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_0_bits = sub_crossbar_41_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_1_valid = sub_crossbar_89_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_in_1_bits = sub_crossbar_89_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_141_io_out_0_ready = io_out_45_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_141_io_out_1_ready = io_out_109_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_142_clock = clock;
  assign sub_crossbar_142_reset = reset;
  assign sub_crossbar_142_io_in_0_valid = sub_crossbar_44_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_0_bits = sub_crossbar_44_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_1_valid = sub_crossbar_92_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_in_1_bits = sub_crossbar_92_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_142_io_out_0_ready = io_out_46_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_142_io_out_1_ready = io_out_110_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_143_clock = clock;
  assign sub_crossbar_143_reset = reset;
  assign sub_crossbar_143_io_in_0_valid = sub_crossbar_47_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_0_bits = sub_crossbar_47_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_1_valid = sub_crossbar_95_io_out_2_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_in_1_bits = sub_crossbar_95_io_out_2_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_143_io_out_0_ready = io_out_47_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_143_io_out_1_ready = io_out_111_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_144_clock = clock;
  assign sub_crossbar_144_reset = reset;
  assign sub_crossbar_144_io_in_0_valid = sub_crossbar_2_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_0_bits = sub_crossbar_2_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_1_valid = sub_crossbar_50_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_in_1_bits = sub_crossbar_50_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_144_io_out_0_ready = io_out_48_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_144_io_out_1_ready = io_out_112_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_145_clock = clock;
  assign sub_crossbar_145_reset = reset;
  assign sub_crossbar_145_io_in_0_valid = sub_crossbar_5_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_0_bits = sub_crossbar_5_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_1_valid = sub_crossbar_53_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_in_1_bits = sub_crossbar_53_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_145_io_out_0_ready = io_out_49_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_145_io_out_1_ready = io_out_113_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_146_clock = clock;
  assign sub_crossbar_146_reset = reset;
  assign sub_crossbar_146_io_in_0_valid = sub_crossbar_8_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_0_bits = sub_crossbar_8_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_1_valid = sub_crossbar_56_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_in_1_bits = sub_crossbar_56_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_146_io_out_0_ready = io_out_50_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_146_io_out_1_ready = io_out_114_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_147_clock = clock;
  assign sub_crossbar_147_reset = reset;
  assign sub_crossbar_147_io_in_0_valid = sub_crossbar_11_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_0_bits = sub_crossbar_11_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_1_valid = sub_crossbar_59_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_in_1_bits = sub_crossbar_59_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_147_io_out_0_ready = io_out_51_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_147_io_out_1_ready = io_out_115_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_148_clock = clock;
  assign sub_crossbar_148_reset = reset;
  assign sub_crossbar_148_io_in_0_valid = sub_crossbar_14_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_0_bits = sub_crossbar_14_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_1_valid = sub_crossbar_62_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_in_1_bits = sub_crossbar_62_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_148_io_out_0_ready = io_out_52_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_148_io_out_1_ready = io_out_116_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_149_clock = clock;
  assign sub_crossbar_149_reset = reset;
  assign sub_crossbar_149_io_in_0_valid = sub_crossbar_17_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_0_bits = sub_crossbar_17_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_1_valid = sub_crossbar_65_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_in_1_bits = sub_crossbar_65_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_149_io_out_0_ready = io_out_53_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_149_io_out_1_ready = io_out_117_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_150_clock = clock;
  assign sub_crossbar_150_reset = reset;
  assign sub_crossbar_150_io_in_0_valid = sub_crossbar_20_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_0_bits = sub_crossbar_20_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_1_valid = sub_crossbar_68_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_in_1_bits = sub_crossbar_68_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_150_io_out_0_ready = io_out_54_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_150_io_out_1_ready = io_out_118_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_151_clock = clock;
  assign sub_crossbar_151_reset = reset;
  assign sub_crossbar_151_io_in_0_valid = sub_crossbar_23_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_0_bits = sub_crossbar_23_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_1_valid = sub_crossbar_71_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_in_1_bits = sub_crossbar_71_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_151_io_out_0_ready = io_out_55_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_151_io_out_1_ready = io_out_119_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_152_clock = clock;
  assign sub_crossbar_152_reset = reset;
  assign sub_crossbar_152_io_in_0_valid = sub_crossbar_26_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_0_bits = sub_crossbar_26_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_1_valid = sub_crossbar_74_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_in_1_bits = sub_crossbar_74_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_152_io_out_0_ready = io_out_56_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_152_io_out_1_ready = io_out_120_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_153_clock = clock;
  assign sub_crossbar_153_reset = reset;
  assign sub_crossbar_153_io_in_0_valid = sub_crossbar_29_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_0_bits = sub_crossbar_29_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_1_valid = sub_crossbar_77_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_in_1_bits = sub_crossbar_77_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_153_io_out_0_ready = io_out_57_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_153_io_out_1_ready = io_out_121_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_154_clock = clock;
  assign sub_crossbar_154_reset = reset;
  assign sub_crossbar_154_io_in_0_valid = sub_crossbar_32_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_0_bits = sub_crossbar_32_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_1_valid = sub_crossbar_80_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_in_1_bits = sub_crossbar_80_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_154_io_out_0_ready = io_out_58_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_154_io_out_1_ready = io_out_122_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_155_clock = clock;
  assign sub_crossbar_155_reset = reset;
  assign sub_crossbar_155_io_in_0_valid = sub_crossbar_35_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_0_bits = sub_crossbar_35_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_1_valid = sub_crossbar_83_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_in_1_bits = sub_crossbar_83_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_155_io_out_0_ready = io_out_59_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_155_io_out_1_ready = io_out_123_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_156_clock = clock;
  assign sub_crossbar_156_reset = reset;
  assign sub_crossbar_156_io_in_0_valid = sub_crossbar_38_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_0_bits = sub_crossbar_38_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_1_valid = sub_crossbar_86_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_in_1_bits = sub_crossbar_86_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_156_io_out_0_ready = io_out_60_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_156_io_out_1_ready = io_out_124_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_157_clock = clock;
  assign sub_crossbar_157_reset = reset;
  assign sub_crossbar_157_io_in_0_valid = sub_crossbar_41_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_0_bits = sub_crossbar_41_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_1_valid = sub_crossbar_89_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_in_1_bits = sub_crossbar_89_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_157_io_out_0_ready = io_out_61_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_157_io_out_1_ready = io_out_125_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_158_clock = clock;
  assign sub_crossbar_158_reset = reset;
  assign sub_crossbar_158_io_in_0_valid = sub_crossbar_44_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_0_bits = sub_crossbar_44_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_1_valid = sub_crossbar_92_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_in_1_bits = sub_crossbar_92_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_158_io_out_0_ready = io_out_62_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_158_io_out_1_ready = io_out_126_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_159_clock = clock;
  assign sub_crossbar_159_reset = reset;
  assign sub_crossbar_159_io_in_0_valid = sub_crossbar_47_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_0_bits = sub_crossbar_47_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_1_valid = sub_crossbar_95_io_out_3_valid; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_in_1_bits = sub_crossbar_95_io_out_3_bits; // @[crossbar.scala 146:53]
  assign sub_crossbar_159_io_out_0_ready = io_out_63_ready; // @[crossbar.scala 152:53]
  assign sub_crossbar_159_io_out_1_ready = io_out_127_ready; // @[crossbar.scala 152:53]
endmodule
module q_R_array_index_slr0(
  input         clock,
  input         reset,
  output        io_enq_ready,
  input         io_enq_valid,
  input  [31:0] io_enq_bits,
  input         io_deq_ready,
  output        io_deq_valid,
  output [31:0] io_deq_bits,
  output [3:0]  io_count
);
`ifdef RANDOMIZE_MEM_INIT
  reg [31:0] _RAND_0;
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
`endif // RANDOMIZE_REG_INIT
  reg [31:0] ram [0:7]; // @[Queue.scala 56:18]
  wire [31:0] ram__T_16_data; // @[Queue.scala 56:18]
  wire [2:0] ram__T_16_addr; // @[Queue.scala 56:18]
  wire [31:0] ram__T_3_data; // @[Queue.scala 56:18]
  wire [2:0] ram__T_3_addr; // @[Queue.scala 56:18]
  wire  ram__T_3_mask; // @[Queue.scala 56:18]
  wire  ram__T_3_en; // @[Queue.scala 56:18]
  reg [2:0] value; // @[Counter.scala 29:33]
  reg [2:0] value_1; // @[Counter.scala 29:33]
  reg  maybe_full; // @[Queue.scala 59:29]
  wire  ptr_match = value == value_1; // @[Queue.scala 61:35]
  wire  _T = ~maybe_full; // @[Queue.scala 62:30]
  wire  empty = ptr_match & _T; // @[Queue.scala 62:27]
  wire  full = ptr_match & maybe_full; // @[Queue.scala 63:26]
  wire  do_enq = io_enq_ready & io_enq_valid; // @[Decoupled.scala 40:37]
  wire  do_deq = io_deq_ready & io_deq_valid; // @[Decoupled.scala 40:37]
  wire  _T_4 = value == 3'h7; // @[Counter.scala 38:24]
  wire [3:0] _T_5 = value + 3'h1; // @[Counter.scala 39:22]
  wire [2:0] _T_6 = value + 3'h1; // @[Counter.scala 39:22]
  wire  _T_1 = do_enq;
  wire [2:0] _GEN_0 = value; // @[Queue.scala 67:19]
  wire  _GEN_1 = clock; // @[Queue.scala 67:19]
  wire  _GEN_2 = do_enq; // @[Queue.scala 67:19]
  wire  _GEN_3 = 1'h1; // @[Queue.scala 67:19]
  wire [31:0] _GEN_4 = io_enq_bits; // @[Queue.scala 67:19]
  wire [2:0] _GEN_5 = do_enq ? _T_6 : value; // @[Queue.scala 67:19]
  wire  _T_7 = value_1 == 3'h7; // @[Counter.scala 38:24]
  wire [3:0] _T_8 = value_1 + 3'h1; // @[Counter.scala 39:22]
  wire [2:0] _T_9 = value_1 + 3'h1; // @[Counter.scala 39:22]
  wire  _T_2 = do_deq;
  wire [2:0] _GEN_6 = do_deq ? _T_9 : value_1; // @[Queue.scala 71:19]
  wire  _T_10 = do_enq != do_deq; // @[Queue.scala 74:18]
  wire  _GEN_7 = _T_10 ? do_enq : maybe_full; // @[Queue.scala 74:30]
  wire  _T_11 = ~empty; // @[Queue.scala 78:21]
  wire [4:0] _T_12 = 4'h8 - 4'h1; // @[Queue.scala 79:50]
  wire [3:0] _T_13 = 4'h8 - 4'h1; // @[Queue.scala 79:50]
  wire  _T_14 = io_count < _T_13; // @[Queue.scala 79:38]
  reg  _T_15; // @[Queue.scala 79:28]
  wire [3:0] _T_17 = value - value_1; // @[Queue.scala 95:34]
  wire [2:0] ptr_diff = value - value_1; // @[Queue.scala 95:34]
  wire  _T_18 = maybe_full & ptr_match; // @[Queue.scala 97:36]
  wire [3:0] _T_19 = _T_18 ? 4'h8 : 4'h0; // @[Queue.scala 97:24]
  wire [3:0] _GEN_8 = {{1'd0}, ptr_diff}; // @[Queue.scala 97:66]
  wire [3:0] _T_20 = _T_19 | _GEN_8; // @[Queue.scala 97:66]
  wire [3:0] _GEN_9 = {{1'd0}, ptr_diff}; // @[Queue.scala 97:18]
  assign ram__T_16_addr = value_1;
  assign ram__T_16_data = ram[ram__T_16_addr]; // @[Queue.scala 56:18]
  assign ram__T_3_data = io_enq_bits;
  assign ram__T_3_addr = value;
  assign ram__T_3_mask = 1'h1;
  assign ram__T_3_en = io_enq_ready & io_enq_valid;
  assign io_enq_ready = _T_15; // @[Queue.scala 79:18]
  assign io_deq_valid = ~empty; // @[Queue.scala 78:18]
  assign io_deq_bits = ram__T_16_data; // @[Queue.scala 80:17]
  assign io_count = _T_19 | _GEN_8; // @[Queue.scala 97:18]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_MEM_INIT
  _RAND_0 = {1{`RANDOM}};
  for (initvar = 0; initvar < 8; initvar = initvar+1)
    ram[initvar] = _RAND_0[31:0];
`endif // RANDOMIZE_MEM_INIT
`ifdef RANDOMIZE_REG_INIT
  _RAND_1 = {1{`RANDOM}};
  value = _RAND_1[2:0];
  _RAND_2 = {1{`RANDOM}};
  value_1 = _RAND_2[2:0];
  _RAND_3 = {1{`RANDOM}};
  maybe_full = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  _T_15 = _RAND_4[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if(ram__T_3_en & ram__T_3_mask) begin
      ram[ram__T_3_addr] <= ram__T_3_data; // @[Queue.scala 56:18]
    end
    if (reset) begin
      value <= 3'h0;
    end else if (do_enq) begin
      value <= _T_6;
    end
    if (reset) begin
      value_1 <= 3'h0;
    end else if (do_deq) begin
      value_1 <= _T_9;
    end
    if (reset) begin
      maybe_full <= 1'h0;
    end else if (_T_10) begin
      maybe_full <= do_enq;
    end
    _T_15 <= io_count < _T_13;
  end
endmodule
module Top(
  input          clock,
  input          reset,
  input          io_ap_start_pulse,
  output         io_ap_done,
  input          io_hbm_0_writeAddr_ready,
  output         io_hbm_0_writeAddr_valid,
  output [63:0]  io_hbm_0_writeAddr_bits_addr,
  output [7:0]   io_hbm_0_writeAddr_bits_len,
  output [5:0]   io_hbm_0_writeAddr_bits_id,
  input          io_hbm_0_writeData_ready,
  output         io_hbm_0_writeData_valid,
  output [255:0] io_hbm_0_writeData_bits_data,
  output [31:0]  io_hbm_0_writeData_bits_strb,
  output         io_hbm_0_writeData_bits_last,
  output         io_hbm_0_writeResp_ready,
  input          io_hbm_0_writeResp_valid,
  input  [5:0]   io_hbm_0_writeResp_bits_id,
  input  [1:0]   io_hbm_0_writeResp_bits_resp,
  input          io_hbm_0_readAddr_ready,
  output         io_hbm_0_readAddr_valid,
  output [63:0]  io_hbm_0_readAddr_bits_addr,
  output [7:0]   io_hbm_0_readAddr_bits_len,
  output [5:0]   io_hbm_0_readAddr_bits_id,
  output         io_hbm_0_readData_ready,
  input          io_hbm_0_readData_valid,
  input  [255:0] io_hbm_0_readData_bits_data,
  input  [5:0]   io_hbm_0_readData_bits_id,
  input          io_hbm_0_readData_bits_last,
  input  [1:0]   io_hbm_0_readData_bits_resp,
  input          io_hbm_1_writeAddr_ready,
  output         io_hbm_1_writeAddr_valid,
  output [63:0]  io_hbm_1_writeAddr_bits_addr,
  output [7:0]   io_hbm_1_writeAddr_bits_len,
  output [5:0]   io_hbm_1_writeAddr_bits_id,
  input          io_hbm_1_writeData_ready,
  output         io_hbm_1_writeData_valid,
  output [255:0] io_hbm_1_writeData_bits_data,
  output [31:0]  io_hbm_1_writeData_bits_strb,
  output         io_hbm_1_writeData_bits_last,
  output         io_hbm_1_writeResp_ready,
  input          io_hbm_1_writeResp_valid,
  input  [5:0]   io_hbm_1_writeResp_bits_id,
  input  [1:0]   io_hbm_1_writeResp_bits_resp,
  input          io_hbm_1_readAddr_ready,
  output         io_hbm_1_readAddr_valid,
  output [63:0]  io_hbm_1_readAddr_bits_addr,
  output [7:0]   io_hbm_1_readAddr_bits_len,
  output [5:0]   io_hbm_1_readAddr_bits_id,
  output         io_hbm_1_readData_ready,
  input          io_hbm_1_readData_valid,
  input  [255:0] io_hbm_1_readData_bits_data,
  input  [5:0]   io_hbm_1_readData_bits_id,
  input          io_hbm_1_readData_bits_last,
  input  [1:0]   io_hbm_1_readData_bits_resp,
  input          io_hbm_2_writeAddr_ready,
  output         io_hbm_2_writeAddr_valid,
  output [63:0]  io_hbm_2_writeAddr_bits_addr,
  output [7:0]   io_hbm_2_writeAddr_bits_len,
  output [5:0]   io_hbm_2_writeAddr_bits_id,
  input          io_hbm_2_writeData_ready,
  output         io_hbm_2_writeData_valid,
  output [255:0] io_hbm_2_writeData_bits_data,
  output [31:0]  io_hbm_2_writeData_bits_strb,
  output         io_hbm_2_writeData_bits_last,
  output         io_hbm_2_writeResp_ready,
  input          io_hbm_2_writeResp_valid,
  input  [5:0]   io_hbm_2_writeResp_bits_id,
  input  [1:0]   io_hbm_2_writeResp_bits_resp,
  input          io_hbm_2_readAddr_ready,
  output         io_hbm_2_readAddr_valid,
  output [63:0]  io_hbm_2_readAddr_bits_addr,
  output [7:0]   io_hbm_2_readAddr_bits_len,
  output [5:0]   io_hbm_2_readAddr_bits_id,
  output         io_hbm_2_readData_ready,
  input          io_hbm_2_readData_valid,
  input  [255:0] io_hbm_2_readData_bits_data,
  input  [5:0]   io_hbm_2_readData_bits_id,
  input          io_hbm_2_readData_bits_last,
  input  [1:0]   io_hbm_2_readData_bits_resp,
  input          io_hbm_3_writeAddr_ready,
  output         io_hbm_3_writeAddr_valid,
  output [63:0]  io_hbm_3_writeAddr_bits_addr,
  output [7:0]   io_hbm_3_writeAddr_bits_len,
  output [5:0]   io_hbm_3_writeAddr_bits_id,
  input          io_hbm_3_writeData_ready,
  output         io_hbm_3_writeData_valid,
  output [255:0] io_hbm_3_writeData_bits_data,
  output [31:0]  io_hbm_3_writeData_bits_strb,
  output         io_hbm_3_writeData_bits_last,
  output         io_hbm_3_writeResp_ready,
  input          io_hbm_3_writeResp_valid,
  input  [5:0]   io_hbm_3_writeResp_bits_id,
  input  [1:0]   io_hbm_3_writeResp_bits_resp,
  input          io_hbm_3_readAddr_ready,
  output         io_hbm_3_readAddr_valid,
  output [63:0]  io_hbm_3_readAddr_bits_addr,
  output [7:0]   io_hbm_3_readAddr_bits_len,
  output [5:0]   io_hbm_3_readAddr_bits_id,
  output         io_hbm_3_readData_ready,
  input          io_hbm_3_readData_valid,
  input  [255:0] io_hbm_3_readData_bits_data,
  input  [5:0]   io_hbm_3_readData_bits_id,
  input          io_hbm_3_readData_bits_last,
  input  [1:0]   io_hbm_3_readData_bits_resp,
  input          io_hbm_4_writeAddr_ready,
  output         io_hbm_4_writeAddr_valid,
  output [63:0]  io_hbm_4_writeAddr_bits_addr,
  output [7:0]   io_hbm_4_writeAddr_bits_len,
  output [5:0]   io_hbm_4_writeAddr_bits_id,
  input          io_hbm_4_writeData_ready,
  output         io_hbm_4_writeData_valid,
  output [255:0] io_hbm_4_writeData_bits_data,
  output [31:0]  io_hbm_4_writeData_bits_strb,
  output         io_hbm_4_writeData_bits_last,
  output         io_hbm_4_writeResp_ready,
  input          io_hbm_4_writeResp_valid,
  input  [5:0]   io_hbm_4_writeResp_bits_id,
  input  [1:0]   io_hbm_4_writeResp_bits_resp,
  input          io_hbm_4_readAddr_ready,
  output         io_hbm_4_readAddr_valid,
  output [63:0]  io_hbm_4_readAddr_bits_addr,
  output [7:0]   io_hbm_4_readAddr_bits_len,
  output [5:0]   io_hbm_4_readAddr_bits_id,
  output         io_hbm_4_readData_ready,
  input          io_hbm_4_readData_valid,
  input  [255:0] io_hbm_4_readData_bits_data,
  input  [5:0]   io_hbm_4_readData_bits_id,
  input          io_hbm_4_readData_bits_last,
  input  [1:0]   io_hbm_4_readData_bits_resp,
  input          io_hbm_5_writeAddr_ready,
  output         io_hbm_5_writeAddr_valid,
  output [63:0]  io_hbm_5_writeAddr_bits_addr,
  output [7:0]   io_hbm_5_writeAddr_bits_len,
  output [5:0]   io_hbm_5_writeAddr_bits_id,
  input          io_hbm_5_writeData_ready,
  output         io_hbm_5_writeData_valid,
  output [255:0] io_hbm_5_writeData_bits_data,
  output [31:0]  io_hbm_5_writeData_bits_strb,
  output         io_hbm_5_writeData_bits_last,
  output         io_hbm_5_writeResp_ready,
  input          io_hbm_5_writeResp_valid,
  input  [5:0]   io_hbm_5_writeResp_bits_id,
  input  [1:0]   io_hbm_5_writeResp_bits_resp,
  input          io_hbm_5_readAddr_ready,
  output         io_hbm_5_readAddr_valid,
  output [63:0]  io_hbm_5_readAddr_bits_addr,
  output [7:0]   io_hbm_5_readAddr_bits_len,
  output [5:0]   io_hbm_5_readAddr_bits_id,
  output         io_hbm_5_readData_ready,
  input          io_hbm_5_readData_valid,
  input  [255:0] io_hbm_5_readData_bits_data,
  input  [5:0]   io_hbm_5_readData_bits_id,
  input          io_hbm_5_readData_bits_last,
  input  [1:0]   io_hbm_5_readData_bits_resp,
  input          io_hbm_6_writeAddr_ready,
  output         io_hbm_6_writeAddr_valid,
  output [63:0]  io_hbm_6_writeAddr_bits_addr,
  output [7:0]   io_hbm_6_writeAddr_bits_len,
  output [5:0]   io_hbm_6_writeAddr_bits_id,
  input          io_hbm_6_writeData_ready,
  output         io_hbm_6_writeData_valid,
  output [255:0] io_hbm_6_writeData_bits_data,
  output [31:0]  io_hbm_6_writeData_bits_strb,
  output         io_hbm_6_writeData_bits_last,
  output         io_hbm_6_writeResp_ready,
  input          io_hbm_6_writeResp_valid,
  input  [5:0]   io_hbm_6_writeResp_bits_id,
  input  [1:0]   io_hbm_6_writeResp_bits_resp,
  input          io_hbm_6_readAddr_ready,
  output         io_hbm_6_readAddr_valid,
  output [63:0]  io_hbm_6_readAddr_bits_addr,
  output [7:0]   io_hbm_6_readAddr_bits_len,
  output [5:0]   io_hbm_6_readAddr_bits_id,
  output         io_hbm_6_readData_ready,
  input          io_hbm_6_readData_valid,
  input  [255:0] io_hbm_6_readData_bits_data,
  input  [5:0]   io_hbm_6_readData_bits_id,
  input          io_hbm_6_readData_bits_last,
  input  [1:0]   io_hbm_6_readData_bits_resp,
  input          io_hbm_7_writeAddr_ready,
  output         io_hbm_7_writeAddr_valid,
  output [63:0]  io_hbm_7_writeAddr_bits_addr,
  output [7:0]   io_hbm_7_writeAddr_bits_len,
  output [5:0]   io_hbm_7_writeAddr_bits_id,
  input          io_hbm_7_writeData_ready,
  output         io_hbm_7_writeData_valid,
  output [255:0] io_hbm_7_writeData_bits_data,
  output [31:0]  io_hbm_7_writeData_bits_strb,
  output         io_hbm_7_writeData_bits_last,
  output         io_hbm_7_writeResp_ready,
  input          io_hbm_7_writeResp_valid,
  input  [5:0]   io_hbm_7_writeResp_bits_id,
  input  [1:0]   io_hbm_7_writeResp_bits_resp,
  input          io_hbm_7_readAddr_ready,
  output         io_hbm_7_readAddr_valid,
  output [63:0]  io_hbm_7_readAddr_bits_addr,
  output [7:0]   io_hbm_7_readAddr_bits_len,
  output [5:0]   io_hbm_7_readAddr_bits_id,
  output         io_hbm_7_readData_ready,
  input          io_hbm_7_readData_valid,
  input  [255:0] io_hbm_7_readData_bits_data,
  input  [5:0]   io_hbm_7_readData_bits_id,
  input          io_hbm_7_readData_bits_last,
  input  [1:0]   io_hbm_7_readData_bits_resp,
  input          io_hbm_8_writeAddr_ready,
  output         io_hbm_8_writeAddr_valid,
  output [63:0]  io_hbm_8_writeAddr_bits_addr,
  output [7:0]   io_hbm_8_writeAddr_bits_len,
  output [5:0]   io_hbm_8_writeAddr_bits_id,
  input          io_hbm_8_writeData_ready,
  output         io_hbm_8_writeData_valid,
  output [255:0] io_hbm_8_writeData_bits_data,
  output [31:0]  io_hbm_8_writeData_bits_strb,
  output         io_hbm_8_writeData_bits_last,
  output         io_hbm_8_writeResp_ready,
  input          io_hbm_8_writeResp_valid,
  input  [5:0]   io_hbm_8_writeResp_bits_id,
  input  [1:0]   io_hbm_8_writeResp_bits_resp,
  input          io_hbm_8_readAddr_ready,
  output         io_hbm_8_readAddr_valid,
  output [63:0]  io_hbm_8_readAddr_bits_addr,
  output [7:0]   io_hbm_8_readAddr_bits_len,
  output [5:0]   io_hbm_8_readAddr_bits_id,
  output         io_hbm_8_readData_ready,
  input          io_hbm_8_readData_valid,
  input  [255:0] io_hbm_8_readData_bits_data,
  input  [5:0]   io_hbm_8_readData_bits_id,
  input          io_hbm_8_readData_bits_last,
  input  [1:0]   io_hbm_8_readData_bits_resp,
  input          io_hbm_9_writeAddr_ready,
  output         io_hbm_9_writeAddr_valid,
  output [63:0]  io_hbm_9_writeAddr_bits_addr,
  output [7:0]   io_hbm_9_writeAddr_bits_len,
  output [5:0]   io_hbm_9_writeAddr_bits_id,
  input          io_hbm_9_writeData_ready,
  output         io_hbm_9_writeData_valid,
  output [255:0] io_hbm_9_writeData_bits_data,
  output [31:0]  io_hbm_9_writeData_bits_strb,
  output         io_hbm_9_writeData_bits_last,
  output         io_hbm_9_writeResp_ready,
  input          io_hbm_9_writeResp_valid,
  input  [5:0]   io_hbm_9_writeResp_bits_id,
  input  [1:0]   io_hbm_9_writeResp_bits_resp,
  input          io_hbm_9_readAddr_ready,
  output         io_hbm_9_readAddr_valid,
  output [63:0]  io_hbm_9_readAddr_bits_addr,
  output [7:0]   io_hbm_9_readAddr_bits_len,
  output [5:0]   io_hbm_9_readAddr_bits_id,
  output         io_hbm_9_readData_ready,
  input          io_hbm_9_readData_valid,
  input  [255:0] io_hbm_9_readData_bits_data,
  input  [5:0]   io_hbm_9_readData_bits_id,
  input          io_hbm_9_readData_bits_last,
  input  [1:0]   io_hbm_9_readData_bits_resp,
  input          io_hbm_10_writeAddr_ready,
  output         io_hbm_10_writeAddr_valid,
  output [63:0]  io_hbm_10_writeAddr_bits_addr,
  output [7:0]   io_hbm_10_writeAddr_bits_len,
  output [5:0]   io_hbm_10_writeAddr_bits_id,
  input          io_hbm_10_writeData_ready,
  output         io_hbm_10_writeData_valid,
  output [255:0] io_hbm_10_writeData_bits_data,
  output [31:0]  io_hbm_10_writeData_bits_strb,
  output         io_hbm_10_writeData_bits_last,
  output         io_hbm_10_writeResp_ready,
  input          io_hbm_10_writeResp_valid,
  input  [5:0]   io_hbm_10_writeResp_bits_id,
  input  [1:0]   io_hbm_10_writeResp_bits_resp,
  input          io_hbm_10_readAddr_ready,
  output         io_hbm_10_readAddr_valid,
  output [63:0]  io_hbm_10_readAddr_bits_addr,
  output [7:0]   io_hbm_10_readAddr_bits_len,
  output [5:0]   io_hbm_10_readAddr_bits_id,
  output         io_hbm_10_readData_ready,
  input          io_hbm_10_readData_valid,
  input  [255:0] io_hbm_10_readData_bits_data,
  input  [5:0]   io_hbm_10_readData_bits_id,
  input          io_hbm_10_readData_bits_last,
  input  [1:0]   io_hbm_10_readData_bits_resp,
  input          io_hbm_11_writeAddr_ready,
  output         io_hbm_11_writeAddr_valid,
  output [63:0]  io_hbm_11_writeAddr_bits_addr,
  output [7:0]   io_hbm_11_writeAddr_bits_len,
  output [5:0]   io_hbm_11_writeAddr_bits_id,
  input          io_hbm_11_writeData_ready,
  output         io_hbm_11_writeData_valid,
  output [255:0] io_hbm_11_writeData_bits_data,
  output [31:0]  io_hbm_11_writeData_bits_strb,
  output         io_hbm_11_writeData_bits_last,
  output         io_hbm_11_writeResp_ready,
  input          io_hbm_11_writeResp_valid,
  input  [5:0]   io_hbm_11_writeResp_bits_id,
  input  [1:0]   io_hbm_11_writeResp_bits_resp,
  input          io_hbm_11_readAddr_ready,
  output         io_hbm_11_readAddr_valid,
  output [63:0]  io_hbm_11_readAddr_bits_addr,
  output [7:0]   io_hbm_11_readAddr_bits_len,
  output [5:0]   io_hbm_11_readAddr_bits_id,
  output         io_hbm_11_readData_ready,
  input          io_hbm_11_readData_valid,
  input  [255:0] io_hbm_11_readData_bits_data,
  input  [5:0]   io_hbm_11_readData_bits_id,
  input          io_hbm_11_readData_bits_last,
  input  [1:0]   io_hbm_11_readData_bits_resp,
  input          io_hbm_12_writeAddr_ready,
  output         io_hbm_12_writeAddr_valid,
  output [63:0]  io_hbm_12_writeAddr_bits_addr,
  output [7:0]   io_hbm_12_writeAddr_bits_len,
  output [5:0]   io_hbm_12_writeAddr_bits_id,
  input          io_hbm_12_writeData_ready,
  output         io_hbm_12_writeData_valid,
  output [255:0] io_hbm_12_writeData_bits_data,
  output [31:0]  io_hbm_12_writeData_bits_strb,
  output         io_hbm_12_writeData_bits_last,
  output         io_hbm_12_writeResp_ready,
  input          io_hbm_12_writeResp_valid,
  input  [5:0]   io_hbm_12_writeResp_bits_id,
  input  [1:0]   io_hbm_12_writeResp_bits_resp,
  input          io_hbm_12_readAddr_ready,
  output         io_hbm_12_readAddr_valid,
  output [63:0]  io_hbm_12_readAddr_bits_addr,
  output [7:0]   io_hbm_12_readAddr_bits_len,
  output [5:0]   io_hbm_12_readAddr_bits_id,
  output         io_hbm_12_readData_ready,
  input          io_hbm_12_readData_valid,
  input  [255:0] io_hbm_12_readData_bits_data,
  input  [5:0]   io_hbm_12_readData_bits_id,
  input          io_hbm_12_readData_bits_last,
  input  [1:0]   io_hbm_12_readData_bits_resp,
  input          io_hbm_13_writeAddr_ready,
  output         io_hbm_13_writeAddr_valid,
  output [63:0]  io_hbm_13_writeAddr_bits_addr,
  output [7:0]   io_hbm_13_writeAddr_bits_len,
  output [5:0]   io_hbm_13_writeAddr_bits_id,
  input          io_hbm_13_writeData_ready,
  output         io_hbm_13_writeData_valid,
  output [255:0] io_hbm_13_writeData_bits_data,
  output [31:0]  io_hbm_13_writeData_bits_strb,
  output         io_hbm_13_writeData_bits_last,
  output         io_hbm_13_writeResp_ready,
  input          io_hbm_13_writeResp_valid,
  input  [5:0]   io_hbm_13_writeResp_bits_id,
  input  [1:0]   io_hbm_13_writeResp_bits_resp,
  input          io_hbm_13_readAddr_ready,
  output         io_hbm_13_readAddr_valid,
  output [63:0]  io_hbm_13_readAddr_bits_addr,
  output [7:0]   io_hbm_13_readAddr_bits_len,
  output [5:0]   io_hbm_13_readAddr_bits_id,
  output         io_hbm_13_readData_ready,
  input          io_hbm_13_readData_valid,
  input  [255:0] io_hbm_13_readData_bits_data,
  input  [5:0]   io_hbm_13_readData_bits_id,
  input          io_hbm_13_readData_bits_last,
  input  [1:0]   io_hbm_13_readData_bits_resp,
  input          io_hbm_14_writeAddr_ready,
  output         io_hbm_14_writeAddr_valid,
  output [63:0]  io_hbm_14_writeAddr_bits_addr,
  output [7:0]   io_hbm_14_writeAddr_bits_len,
  output [5:0]   io_hbm_14_writeAddr_bits_id,
  input          io_hbm_14_writeData_ready,
  output         io_hbm_14_writeData_valid,
  output [255:0] io_hbm_14_writeData_bits_data,
  output [31:0]  io_hbm_14_writeData_bits_strb,
  output         io_hbm_14_writeData_bits_last,
  output         io_hbm_14_writeResp_ready,
  input          io_hbm_14_writeResp_valid,
  input  [5:0]   io_hbm_14_writeResp_bits_id,
  input  [1:0]   io_hbm_14_writeResp_bits_resp,
  input          io_hbm_14_readAddr_ready,
  output         io_hbm_14_readAddr_valid,
  output [63:0]  io_hbm_14_readAddr_bits_addr,
  output [7:0]   io_hbm_14_readAddr_bits_len,
  output [5:0]   io_hbm_14_readAddr_bits_id,
  output         io_hbm_14_readData_ready,
  input          io_hbm_14_readData_valid,
  input  [255:0] io_hbm_14_readData_bits_data,
  input  [5:0]   io_hbm_14_readData_bits_id,
  input          io_hbm_14_readData_bits_last,
  input  [1:0]   io_hbm_14_readData_bits_resp,
  input          io_hbm_15_writeAddr_ready,
  output         io_hbm_15_writeAddr_valid,
  output [63:0]  io_hbm_15_writeAddr_bits_addr,
  output [7:0]   io_hbm_15_writeAddr_bits_len,
  output [5:0]   io_hbm_15_writeAddr_bits_id,
  input          io_hbm_15_writeData_ready,
  output         io_hbm_15_writeData_valid,
  output [255:0] io_hbm_15_writeData_bits_data,
  output [31:0]  io_hbm_15_writeData_bits_strb,
  output         io_hbm_15_writeData_bits_last,
  output         io_hbm_15_writeResp_ready,
  input          io_hbm_15_writeResp_valid,
  input  [5:0]   io_hbm_15_writeResp_bits_id,
  input  [1:0]   io_hbm_15_writeResp_bits_resp,
  input          io_hbm_15_readAddr_ready,
  output         io_hbm_15_readAddr_valid,
  output [63:0]  io_hbm_15_readAddr_bits_addr,
  output [7:0]   io_hbm_15_readAddr_bits_len,
  output [5:0]   io_hbm_15_readAddr_bits_id,
  output         io_hbm_15_readData_ready,
  input          io_hbm_15_readData_valid,
  input  [255:0] io_hbm_15_readData_bits_data,
  input  [5:0]   io_hbm_15_readData_bits_id,
  input          io_hbm_15_readData_bits_last,
  input  [1:0]   io_hbm_15_readData_bits_resp,
  input          io_hbm_16_writeAddr_ready,
  output         io_hbm_16_writeAddr_valid,
  output [63:0]  io_hbm_16_writeAddr_bits_addr,
  output [7:0]   io_hbm_16_writeAddr_bits_len,
  output [5:0]   io_hbm_16_writeAddr_bits_id,
  input          io_hbm_16_writeData_ready,
  output         io_hbm_16_writeData_valid,
  output [255:0] io_hbm_16_writeData_bits_data,
  output [31:0]  io_hbm_16_writeData_bits_strb,
  output         io_hbm_16_writeData_bits_last,
  output         io_hbm_16_writeResp_ready,
  input          io_hbm_16_writeResp_valid,
  input  [5:0]   io_hbm_16_writeResp_bits_id,
  input  [1:0]   io_hbm_16_writeResp_bits_resp,
  input          io_hbm_16_readAddr_ready,
  output         io_hbm_16_readAddr_valid,
  output [63:0]  io_hbm_16_readAddr_bits_addr,
  output [7:0]   io_hbm_16_readAddr_bits_len,
  output [5:0]   io_hbm_16_readAddr_bits_id,
  output         io_hbm_16_readData_ready,
  input          io_hbm_16_readData_valid,
  input  [255:0] io_hbm_16_readData_bits_data,
  input  [5:0]   io_hbm_16_readData_bits_id,
  input          io_hbm_16_readData_bits_last,
  input  [1:0]   io_hbm_16_readData_bits_resp,
  input          io_hbm_17_writeAddr_ready,
  output         io_hbm_17_writeAddr_valid,
  output [63:0]  io_hbm_17_writeAddr_bits_addr,
  output [7:0]   io_hbm_17_writeAddr_bits_len,
  output [5:0]   io_hbm_17_writeAddr_bits_id,
  input          io_hbm_17_writeData_ready,
  output         io_hbm_17_writeData_valid,
  output [255:0] io_hbm_17_writeData_bits_data,
  output [31:0]  io_hbm_17_writeData_bits_strb,
  output         io_hbm_17_writeData_bits_last,
  output         io_hbm_17_writeResp_ready,
  input          io_hbm_17_writeResp_valid,
  input  [5:0]   io_hbm_17_writeResp_bits_id,
  input  [1:0]   io_hbm_17_writeResp_bits_resp,
  input          io_hbm_17_readAddr_ready,
  output         io_hbm_17_readAddr_valid,
  output [63:0]  io_hbm_17_readAddr_bits_addr,
  output [7:0]   io_hbm_17_readAddr_bits_len,
  output [5:0]   io_hbm_17_readAddr_bits_id,
  output         io_hbm_17_readData_ready,
  input          io_hbm_17_readData_valid,
  input  [255:0] io_hbm_17_readData_bits_data,
  input  [5:0]   io_hbm_17_readData_bits_id,
  input          io_hbm_17_readData_bits_last,
  input  [1:0]   io_hbm_17_readData_bits_resp,
  input          io_hbm_18_writeAddr_ready,
  output         io_hbm_18_writeAddr_valid,
  output [63:0]  io_hbm_18_writeAddr_bits_addr,
  output [7:0]   io_hbm_18_writeAddr_bits_len,
  output [5:0]   io_hbm_18_writeAddr_bits_id,
  input          io_hbm_18_writeData_ready,
  output         io_hbm_18_writeData_valid,
  output [255:0] io_hbm_18_writeData_bits_data,
  output [31:0]  io_hbm_18_writeData_bits_strb,
  output         io_hbm_18_writeData_bits_last,
  output         io_hbm_18_writeResp_ready,
  input          io_hbm_18_writeResp_valid,
  input  [5:0]   io_hbm_18_writeResp_bits_id,
  input  [1:0]   io_hbm_18_writeResp_bits_resp,
  input          io_hbm_18_readAddr_ready,
  output         io_hbm_18_readAddr_valid,
  output [63:0]  io_hbm_18_readAddr_bits_addr,
  output [7:0]   io_hbm_18_readAddr_bits_len,
  output [5:0]   io_hbm_18_readAddr_bits_id,
  output         io_hbm_18_readData_ready,
  input          io_hbm_18_readData_valid,
  input  [255:0] io_hbm_18_readData_bits_data,
  input  [5:0]   io_hbm_18_readData_bits_id,
  input          io_hbm_18_readData_bits_last,
  input  [1:0]   io_hbm_18_readData_bits_resp,
  input          io_hbm_19_writeAddr_ready,
  output         io_hbm_19_writeAddr_valid,
  output [63:0]  io_hbm_19_writeAddr_bits_addr,
  output [7:0]   io_hbm_19_writeAddr_bits_len,
  output [5:0]   io_hbm_19_writeAddr_bits_id,
  input          io_hbm_19_writeData_ready,
  output         io_hbm_19_writeData_valid,
  output [255:0] io_hbm_19_writeData_bits_data,
  output [31:0]  io_hbm_19_writeData_bits_strb,
  output         io_hbm_19_writeData_bits_last,
  output         io_hbm_19_writeResp_ready,
  input          io_hbm_19_writeResp_valid,
  input  [5:0]   io_hbm_19_writeResp_bits_id,
  input  [1:0]   io_hbm_19_writeResp_bits_resp,
  input          io_hbm_19_readAddr_ready,
  output         io_hbm_19_readAddr_valid,
  output [63:0]  io_hbm_19_readAddr_bits_addr,
  output [7:0]   io_hbm_19_readAddr_bits_len,
  output [5:0]   io_hbm_19_readAddr_bits_id,
  output         io_hbm_19_readData_ready,
  input          io_hbm_19_readData_valid,
  input  [255:0] io_hbm_19_readData_bits_data,
  input  [5:0]   io_hbm_19_readData_bits_id,
  input          io_hbm_19_readData_bits_last,
  input  [1:0]   io_hbm_19_readData_bits_resp,
  input          io_hbm_20_writeAddr_ready,
  output         io_hbm_20_writeAddr_valid,
  output [63:0]  io_hbm_20_writeAddr_bits_addr,
  output [7:0]   io_hbm_20_writeAddr_bits_len,
  output [5:0]   io_hbm_20_writeAddr_bits_id,
  input          io_hbm_20_writeData_ready,
  output         io_hbm_20_writeData_valid,
  output [255:0] io_hbm_20_writeData_bits_data,
  output [31:0]  io_hbm_20_writeData_bits_strb,
  output         io_hbm_20_writeData_bits_last,
  output         io_hbm_20_writeResp_ready,
  input          io_hbm_20_writeResp_valid,
  input  [5:0]   io_hbm_20_writeResp_bits_id,
  input  [1:0]   io_hbm_20_writeResp_bits_resp,
  input          io_hbm_20_readAddr_ready,
  output         io_hbm_20_readAddr_valid,
  output [63:0]  io_hbm_20_readAddr_bits_addr,
  output [7:0]   io_hbm_20_readAddr_bits_len,
  output [5:0]   io_hbm_20_readAddr_bits_id,
  output         io_hbm_20_readData_ready,
  input          io_hbm_20_readData_valid,
  input  [255:0] io_hbm_20_readData_bits_data,
  input  [5:0]   io_hbm_20_readData_bits_id,
  input          io_hbm_20_readData_bits_last,
  input  [1:0]   io_hbm_20_readData_bits_resp,
  input          io_hbm_21_writeAddr_ready,
  output         io_hbm_21_writeAddr_valid,
  output [63:0]  io_hbm_21_writeAddr_bits_addr,
  output [7:0]   io_hbm_21_writeAddr_bits_len,
  output [5:0]   io_hbm_21_writeAddr_bits_id,
  input          io_hbm_21_writeData_ready,
  output         io_hbm_21_writeData_valid,
  output [255:0] io_hbm_21_writeData_bits_data,
  output [31:0]  io_hbm_21_writeData_bits_strb,
  output         io_hbm_21_writeData_bits_last,
  output         io_hbm_21_writeResp_ready,
  input          io_hbm_21_writeResp_valid,
  input  [5:0]   io_hbm_21_writeResp_bits_id,
  input  [1:0]   io_hbm_21_writeResp_bits_resp,
  input          io_hbm_21_readAddr_ready,
  output         io_hbm_21_readAddr_valid,
  output [63:0]  io_hbm_21_readAddr_bits_addr,
  output [7:0]   io_hbm_21_readAddr_bits_len,
  output [5:0]   io_hbm_21_readAddr_bits_id,
  output         io_hbm_21_readData_ready,
  input          io_hbm_21_readData_valid,
  input  [255:0] io_hbm_21_readData_bits_data,
  input  [5:0]   io_hbm_21_readData_bits_id,
  input          io_hbm_21_readData_bits_last,
  input  [1:0]   io_hbm_21_readData_bits_resp,
  input          io_hbm_22_writeAddr_ready,
  output         io_hbm_22_writeAddr_valid,
  output [63:0]  io_hbm_22_writeAddr_bits_addr,
  output [7:0]   io_hbm_22_writeAddr_bits_len,
  output [5:0]   io_hbm_22_writeAddr_bits_id,
  input          io_hbm_22_writeData_ready,
  output         io_hbm_22_writeData_valid,
  output [255:0] io_hbm_22_writeData_bits_data,
  output [31:0]  io_hbm_22_writeData_bits_strb,
  output         io_hbm_22_writeData_bits_last,
  output         io_hbm_22_writeResp_ready,
  input          io_hbm_22_writeResp_valid,
  input  [5:0]   io_hbm_22_writeResp_bits_id,
  input  [1:0]   io_hbm_22_writeResp_bits_resp,
  input          io_hbm_22_readAddr_ready,
  output         io_hbm_22_readAddr_valid,
  output [63:0]  io_hbm_22_readAddr_bits_addr,
  output [7:0]   io_hbm_22_readAddr_bits_len,
  output [5:0]   io_hbm_22_readAddr_bits_id,
  output         io_hbm_22_readData_ready,
  input          io_hbm_22_readData_valid,
  input  [255:0] io_hbm_22_readData_bits_data,
  input  [5:0]   io_hbm_22_readData_bits_id,
  input          io_hbm_22_readData_bits_last,
  input  [1:0]   io_hbm_22_readData_bits_resp,
  input          io_hbm_23_writeAddr_ready,
  output         io_hbm_23_writeAddr_valid,
  output [63:0]  io_hbm_23_writeAddr_bits_addr,
  output [7:0]   io_hbm_23_writeAddr_bits_len,
  output [5:0]   io_hbm_23_writeAddr_bits_id,
  input          io_hbm_23_writeData_ready,
  output         io_hbm_23_writeData_valid,
  output [255:0] io_hbm_23_writeData_bits_data,
  output [31:0]  io_hbm_23_writeData_bits_strb,
  output         io_hbm_23_writeData_bits_last,
  output         io_hbm_23_writeResp_ready,
  input          io_hbm_23_writeResp_valid,
  input  [5:0]   io_hbm_23_writeResp_bits_id,
  input  [1:0]   io_hbm_23_writeResp_bits_resp,
  input          io_hbm_23_readAddr_ready,
  output         io_hbm_23_readAddr_valid,
  output [63:0]  io_hbm_23_readAddr_bits_addr,
  output [7:0]   io_hbm_23_readAddr_bits_len,
  output [5:0]   io_hbm_23_readAddr_bits_id,
  output         io_hbm_23_readData_ready,
  input          io_hbm_23_readData_valid,
  input  [255:0] io_hbm_23_readData_bits_data,
  input  [5:0]   io_hbm_23_readData_bits_id,
  input          io_hbm_23_readData_bits_last,
  input  [1:0]   io_hbm_23_readData_bits_resp,
  input          io_hbm_24_writeAddr_ready,
  output         io_hbm_24_writeAddr_valid,
  output [63:0]  io_hbm_24_writeAddr_bits_addr,
  output [7:0]   io_hbm_24_writeAddr_bits_len,
  output [5:0]   io_hbm_24_writeAddr_bits_id,
  input          io_hbm_24_writeData_ready,
  output         io_hbm_24_writeData_valid,
  output [255:0] io_hbm_24_writeData_bits_data,
  output [31:0]  io_hbm_24_writeData_bits_strb,
  output         io_hbm_24_writeData_bits_last,
  output         io_hbm_24_writeResp_ready,
  input          io_hbm_24_writeResp_valid,
  input  [5:0]   io_hbm_24_writeResp_bits_id,
  input  [1:0]   io_hbm_24_writeResp_bits_resp,
  input          io_hbm_24_readAddr_ready,
  output         io_hbm_24_readAddr_valid,
  output [63:0]  io_hbm_24_readAddr_bits_addr,
  output [7:0]   io_hbm_24_readAddr_bits_len,
  output [5:0]   io_hbm_24_readAddr_bits_id,
  output         io_hbm_24_readData_ready,
  input          io_hbm_24_readData_valid,
  input  [255:0] io_hbm_24_readData_bits_data,
  input  [5:0]   io_hbm_24_readData_bits_id,
  input          io_hbm_24_readData_bits_last,
  input  [1:0]   io_hbm_24_readData_bits_resp,
  input          io_hbm_25_writeAddr_ready,
  output         io_hbm_25_writeAddr_valid,
  output [63:0]  io_hbm_25_writeAddr_bits_addr,
  output [7:0]   io_hbm_25_writeAddr_bits_len,
  output [5:0]   io_hbm_25_writeAddr_bits_id,
  input          io_hbm_25_writeData_ready,
  output         io_hbm_25_writeData_valid,
  output [255:0] io_hbm_25_writeData_bits_data,
  output [31:0]  io_hbm_25_writeData_bits_strb,
  output         io_hbm_25_writeData_bits_last,
  output         io_hbm_25_writeResp_ready,
  input          io_hbm_25_writeResp_valid,
  input  [5:0]   io_hbm_25_writeResp_bits_id,
  input  [1:0]   io_hbm_25_writeResp_bits_resp,
  input          io_hbm_25_readAddr_ready,
  output         io_hbm_25_readAddr_valid,
  output [63:0]  io_hbm_25_readAddr_bits_addr,
  output [7:0]   io_hbm_25_readAddr_bits_len,
  output [5:0]   io_hbm_25_readAddr_bits_id,
  output         io_hbm_25_readData_ready,
  input          io_hbm_25_readData_valid,
  input  [255:0] io_hbm_25_readData_bits_data,
  input  [5:0]   io_hbm_25_readData_bits_id,
  input          io_hbm_25_readData_bits_last,
  input  [1:0]   io_hbm_25_readData_bits_resp,
  input          io_hbm_26_writeAddr_ready,
  output         io_hbm_26_writeAddr_valid,
  output [63:0]  io_hbm_26_writeAddr_bits_addr,
  output [7:0]   io_hbm_26_writeAddr_bits_len,
  output [5:0]   io_hbm_26_writeAddr_bits_id,
  input          io_hbm_26_writeData_ready,
  output         io_hbm_26_writeData_valid,
  output [255:0] io_hbm_26_writeData_bits_data,
  output [31:0]  io_hbm_26_writeData_bits_strb,
  output         io_hbm_26_writeData_bits_last,
  output         io_hbm_26_writeResp_ready,
  input          io_hbm_26_writeResp_valid,
  input  [5:0]   io_hbm_26_writeResp_bits_id,
  input  [1:0]   io_hbm_26_writeResp_bits_resp,
  input          io_hbm_26_readAddr_ready,
  output         io_hbm_26_readAddr_valid,
  output [63:0]  io_hbm_26_readAddr_bits_addr,
  output [7:0]   io_hbm_26_readAddr_bits_len,
  output [5:0]   io_hbm_26_readAddr_bits_id,
  output         io_hbm_26_readData_ready,
  input          io_hbm_26_readData_valid,
  input  [255:0] io_hbm_26_readData_bits_data,
  input  [5:0]   io_hbm_26_readData_bits_id,
  input          io_hbm_26_readData_bits_last,
  input  [1:0]   io_hbm_26_readData_bits_resp,
  input          io_hbm_27_writeAddr_ready,
  output         io_hbm_27_writeAddr_valid,
  output [63:0]  io_hbm_27_writeAddr_bits_addr,
  output [7:0]   io_hbm_27_writeAddr_bits_len,
  output [5:0]   io_hbm_27_writeAddr_bits_id,
  input          io_hbm_27_writeData_ready,
  output         io_hbm_27_writeData_valid,
  output [255:0] io_hbm_27_writeData_bits_data,
  output [31:0]  io_hbm_27_writeData_bits_strb,
  output         io_hbm_27_writeData_bits_last,
  output         io_hbm_27_writeResp_ready,
  input          io_hbm_27_writeResp_valid,
  input  [5:0]   io_hbm_27_writeResp_bits_id,
  input  [1:0]   io_hbm_27_writeResp_bits_resp,
  input          io_hbm_27_readAddr_ready,
  output         io_hbm_27_readAddr_valid,
  output [63:0]  io_hbm_27_readAddr_bits_addr,
  output [7:0]   io_hbm_27_readAddr_bits_len,
  output [5:0]   io_hbm_27_readAddr_bits_id,
  output         io_hbm_27_readData_ready,
  input          io_hbm_27_readData_valid,
  input  [255:0] io_hbm_27_readData_bits_data,
  input  [5:0]   io_hbm_27_readData_bits_id,
  input          io_hbm_27_readData_bits_last,
  input  [1:0]   io_hbm_27_readData_bits_resp,
  input          io_hbm_28_writeAddr_ready,
  output         io_hbm_28_writeAddr_valid,
  output [63:0]  io_hbm_28_writeAddr_bits_addr,
  output [7:0]   io_hbm_28_writeAddr_bits_len,
  output [5:0]   io_hbm_28_writeAddr_bits_id,
  input          io_hbm_28_writeData_ready,
  output         io_hbm_28_writeData_valid,
  output [255:0] io_hbm_28_writeData_bits_data,
  output [31:0]  io_hbm_28_writeData_bits_strb,
  output         io_hbm_28_writeData_bits_last,
  output         io_hbm_28_writeResp_ready,
  input          io_hbm_28_writeResp_valid,
  input  [5:0]   io_hbm_28_writeResp_bits_id,
  input  [1:0]   io_hbm_28_writeResp_bits_resp,
  input          io_hbm_28_readAddr_ready,
  output         io_hbm_28_readAddr_valid,
  output [63:0]  io_hbm_28_readAddr_bits_addr,
  output [7:0]   io_hbm_28_readAddr_bits_len,
  output [5:0]   io_hbm_28_readAddr_bits_id,
  output         io_hbm_28_readData_ready,
  input          io_hbm_28_readData_valid,
  input  [255:0] io_hbm_28_readData_bits_data,
  input  [5:0]   io_hbm_28_readData_bits_id,
  input          io_hbm_28_readData_bits_last,
  input  [1:0]   io_hbm_28_readData_bits_resp,
  input          io_hbm_29_writeAddr_ready,
  output         io_hbm_29_writeAddr_valid,
  output [63:0]  io_hbm_29_writeAddr_bits_addr,
  output [7:0]   io_hbm_29_writeAddr_bits_len,
  output [5:0]   io_hbm_29_writeAddr_bits_id,
  input          io_hbm_29_writeData_ready,
  output         io_hbm_29_writeData_valid,
  output [255:0] io_hbm_29_writeData_bits_data,
  output [31:0]  io_hbm_29_writeData_bits_strb,
  output         io_hbm_29_writeData_bits_last,
  output         io_hbm_29_writeResp_ready,
  input          io_hbm_29_writeResp_valid,
  input  [5:0]   io_hbm_29_writeResp_bits_id,
  input  [1:0]   io_hbm_29_writeResp_bits_resp,
  input          io_hbm_29_readAddr_ready,
  output         io_hbm_29_readAddr_valid,
  output [63:0]  io_hbm_29_readAddr_bits_addr,
  output [7:0]   io_hbm_29_readAddr_bits_len,
  output [5:0]   io_hbm_29_readAddr_bits_id,
  output         io_hbm_29_readData_ready,
  input          io_hbm_29_readData_valid,
  input  [255:0] io_hbm_29_readData_bits_data,
  input  [5:0]   io_hbm_29_readData_bits_id,
  input          io_hbm_29_readData_bits_last,
  input  [1:0]   io_hbm_29_readData_bits_resp,
  input          io_hbm_30_writeAddr_ready,
  output         io_hbm_30_writeAddr_valid,
  output [63:0]  io_hbm_30_writeAddr_bits_addr,
  output [7:0]   io_hbm_30_writeAddr_bits_len,
  output [5:0]   io_hbm_30_writeAddr_bits_id,
  input          io_hbm_30_writeData_ready,
  output         io_hbm_30_writeData_valid,
  output [255:0] io_hbm_30_writeData_bits_data,
  output [31:0]  io_hbm_30_writeData_bits_strb,
  output         io_hbm_30_writeData_bits_last,
  output         io_hbm_30_writeResp_ready,
  input          io_hbm_30_writeResp_valid,
  input  [5:0]   io_hbm_30_writeResp_bits_id,
  input  [1:0]   io_hbm_30_writeResp_bits_resp,
  input          io_hbm_30_readAddr_ready,
  output         io_hbm_30_readAddr_valid,
  output [63:0]  io_hbm_30_readAddr_bits_addr,
  output [7:0]   io_hbm_30_readAddr_bits_len,
  output [5:0]   io_hbm_30_readAddr_bits_id,
  output         io_hbm_30_readData_ready,
  input          io_hbm_30_readData_valid,
  input  [255:0] io_hbm_30_readData_bits_data,
  input  [5:0]   io_hbm_30_readData_bits_id,
  input          io_hbm_30_readData_bits_last,
  input  [1:0]   io_hbm_30_readData_bits_resp,
  input          io_hbm_31_writeAddr_ready,
  output         io_hbm_31_writeAddr_valid,
  output [63:0]  io_hbm_31_writeAddr_bits_addr,
  output [7:0]   io_hbm_31_writeAddr_bits_len,
  output [5:0]   io_hbm_31_writeAddr_bits_id,
  input          io_hbm_31_writeData_ready,
  output         io_hbm_31_writeData_valid,
  output [255:0] io_hbm_31_writeData_bits_data,
  output [31:0]  io_hbm_31_writeData_bits_strb,
  output         io_hbm_31_writeData_bits_last,
  output         io_hbm_31_writeResp_ready,
  input          io_hbm_31_writeResp_valid,
  input  [5:0]   io_hbm_31_writeResp_bits_id,
  input  [1:0]   io_hbm_31_writeResp_bits_resp,
  input          io_hbm_31_readAddr_ready,
  output         io_hbm_31_readAddr_valid,
  output [63:0]  io_hbm_31_readAddr_bits_addr,
  output [7:0]   io_hbm_31_readAddr_bits_len,
  output [5:0]   io_hbm_31_readAddr_bits_id,
  output         io_hbm_31_readData_ready,
  input          io_hbm_31_readData_valid,
  input  [255:0] io_hbm_31_readData_bits_data,
  input  [5:0]   io_hbm_31_readData_bits_id,
  input          io_hbm_31_readData_bits_last,
  input  [1:0]   io_hbm_31_readData_bits_resp,
  input  [31:0]  io_offsets_CSR_R_offset,
  input  [31:0]  io_offsets_CSR_C_offset,
  input  [31:0]  io_offsets_CSC_R_offset,
  input  [31:0]  io_offsets_CSC_C_offset,
  input  [31:0]  io_offsets_level_offset,
  input  [31:0]  io_levels_push_to_pull_level,
  input  [31:0]  io_levels_pull_to_push_level,
  input  [31:0]  io_node_num,
  input          io_mem_clock,
  input          io_reset_h,
  input  [31:0]  io_root
);
`ifdef RANDOMIZE_REG_INIT
  reg [31:0] _RAND_0;
  reg [31:0] _RAND_1;
  reg [31:0] _RAND_2;
  reg [31:0] _RAND_3;
  reg [31:0] _RAND_4;
  reg [31:0] _RAND_5;
  reg [31:0] _RAND_6;
  reg [31:0] _RAND_7;
  reg [31:0] _RAND_8;
  reg [31:0] _RAND_9;
  reg [31:0] _RAND_10;
  reg [31:0] _RAND_11;
  reg [31:0] _RAND_12;
  reg [31:0] _RAND_13;
  reg [31:0] _RAND_14;
  reg [31:0] _RAND_15;
  reg [31:0] _RAND_16;
  reg [31:0] _RAND_17;
  reg [31:0] _RAND_18;
  reg [31:0] _RAND_19;
  reg [31:0] _RAND_20;
  reg [31:0] _RAND_21;
  reg [31:0] _RAND_22;
  reg [31:0] _RAND_23;
  reg [31:0] _RAND_24;
  reg [31:0] _RAND_25;
  reg [31:0] _RAND_26;
  reg [31:0] _RAND_27;
  reg [31:0] _RAND_28;
  reg [31:0] _RAND_29;
  reg [31:0] _RAND_30;
  reg [31:0] _RAND_31;
  reg [31:0] _RAND_32;
  reg [31:0] _RAND_33;
  reg [31:0] _RAND_34;
  reg [31:0] _RAND_35;
  reg [31:0] _RAND_36;
  reg [31:0] _RAND_37;
  reg [31:0] _RAND_38;
  reg [31:0] _RAND_39;
  reg [31:0] _RAND_40;
  reg [31:0] _RAND_41;
  reg [31:0] _RAND_42;
  reg [31:0] _RAND_43;
  reg [31:0] _RAND_44;
  reg [31:0] _RAND_45;
  reg [31:0] _RAND_46;
  reg [31:0] _RAND_47;
  reg [31:0] _RAND_48;
  reg [31:0] _RAND_49;
  reg [31:0] _RAND_50;
  reg [31:0] _RAND_51;
  reg [31:0] _RAND_52;
  reg [31:0] _RAND_53;
  reg [31:0] _RAND_54;
  reg [31:0] _RAND_55;
  reg [31:0] _RAND_56;
  reg [31:0] _RAND_57;
  reg [31:0] _RAND_58;
  reg [31:0] _RAND_59;
  reg [31:0] _RAND_60;
  reg [31:0] _RAND_61;
  reg [31:0] _RAND_62;
  reg [31:0] _RAND_63;
  reg [31:0] _RAND_64;
  reg [31:0] _RAND_65;
  reg [31:0] _RAND_66;
  reg [31:0] _RAND_67;
  reg [31:0] _RAND_68;
  reg [31:0] _RAND_69;
  reg [31:0] _RAND_70;
  reg [31:0] _RAND_71;
  reg [31:0] _RAND_72;
  reg [31:0] _RAND_73;
  reg [31:0] _RAND_74;
  reg [31:0] _RAND_75;
  reg [31:0] _RAND_76;
  reg [31:0] _RAND_77;
  reg [31:0] _RAND_78;
  reg [31:0] _RAND_79;
  reg [31:0] _RAND_80;
  reg [31:0] _RAND_81;
  reg [31:0] _RAND_82;
  reg [31:0] _RAND_83;
  reg [31:0] _RAND_84;
  reg [31:0] _RAND_85;
  reg [31:0] _RAND_86;
  reg [31:0] _RAND_87;
  reg [31:0] _RAND_88;
  reg [31:0] _RAND_89;
  reg [31:0] _RAND_90;
  reg [31:0] _RAND_91;
  reg [31:0] _RAND_92;
  reg [31:0] _RAND_93;
  reg [31:0] _RAND_94;
  reg [31:0] _RAND_95;
  reg [31:0] _RAND_96;
  reg [31:0] _RAND_97;
  reg [31:0] _RAND_98;
  reg [31:0] _RAND_99;
  reg [31:0] _RAND_100;
  reg [31:0] _RAND_101;
  reg [31:0] _RAND_102;
  reg [31:0] _RAND_103;
  reg [31:0] _RAND_104;
  reg [31:0] _RAND_105;
  reg [31:0] _RAND_106;
  reg [31:0] _RAND_107;
  reg [31:0] _RAND_108;
  reg [31:0] _RAND_109;
  reg [31:0] _RAND_110;
  reg [31:0] _RAND_111;
  reg [31:0] _RAND_112;
  reg [31:0] _RAND_113;
  reg [31:0] _RAND_114;
  reg [31:0] _RAND_115;
  reg [31:0] _RAND_116;
  reg [31:0] _RAND_117;
  reg [31:0] _RAND_118;
  reg [31:0] _RAND_119;
  reg [31:0] _RAND_120;
  reg [31:0] _RAND_121;
  reg [31:0] _RAND_122;
  reg [31:0] _RAND_123;
  reg [31:0] _RAND_124;
  reg [31:0] _RAND_125;
  reg [31:0] _RAND_126;
  reg [31:0] _RAND_127;
  reg [31:0] _RAND_128;
  reg [31:0] _RAND_129;
  reg [31:0] _RAND_130;
  reg [31:0] _RAND_131;
  reg [31:0] _RAND_132;
  reg [31:0] _RAND_133;
  reg [31:0] _RAND_134;
  reg [31:0] _RAND_135;
  reg [31:0] _RAND_136;
  reg [31:0] _RAND_137;
  reg [31:0] _RAND_138;
  reg [31:0] _RAND_139;
  reg [31:0] _RAND_140;
  reg [31:0] _RAND_141;
  reg [31:0] _RAND_142;
  reg [31:0] _RAND_143;
  reg [31:0] _RAND_144;
  reg [31:0] _RAND_145;
  reg [31:0] _RAND_146;
  reg [31:0] _RAND_147;
  reg [31:0] _RAND_148;
  reg [31:0] _RAND_149;
  reg [31:0] _RAND_150;
  reg [31:0] _RAND_151;
  reg [31:0] _RAND_152;
  reg [31:0] _RAND_153;
  reg [31:0] _RAND_154;
  reg [31:0] _RAND_155;
  reg [31:0] _RAND_156;
  reg [31:0] _RAND_157;
  reg [31:0] _RAND_158;
  reg [31:0] _RAND_159;
  reg [31:0] _RAND_160;
  reg [31:0] _RAND_161;
  reg [31:0] _RAND_162;
  reg [31:0] _RAND_163;
  reg [31:0] _RAND_164;
  reg [31:0] _RAND_165;
  reg [31:0] _RAND_166;
  reg [31:0] _RAND_167;
  reg [31:0] _RAND_168;
  reg [31:0] _RAND_169;
  reg [31:0] _RAND_170;
  reg [31:0] _RAND_171;
  reg [31:0] _RAND_172;
  reg [31:0] _RAND_173;
  reg [31:0] _RAND_174;
  reg [31:0] _RAND_175;
  reg [31:0] _RAND_176;
  reg [31:0] _RAND_177;
  reg [31:0] _RAND_178;
  reg [31:0] _RAND_179;
  reg [31:0] _RAND_180;
  reg [31:0] _RAND_181;
  reg [31:0] _RAND_182;
  reg [31:0] _RAND_183;
  reg [31:0] _RAND_184;
  reg [31:0] _RAND_185;
  reg [31:0] _RAND_186;
  reg [31:0] _RAND_187;
  reg [31:0] _RAND_188;
  reg [31:0] _RAND_189;
  reg [31:0] _RAND_190;
  reg [31:0] _RAND_191;
  reg [31:0] _RAND_192;
  reg [31:0] _RAND_193;
  reg [31:0] _RAND_194;
  reg [31:0] _RAND_195;
  reg [31:0] _RAND_196;
  reg [31:0] _RAND_197;
  reg [31:0] _RAND_198;
  reg [31:0] _RAND_199;
  reg [31:0] _RAND_200;
  reg [31:0] _RAND_201;
  reg [31:0] _RAND_202;
  reg [31:0] _RAND_203;
  reg [31:0] _RAND_204;
  reg [31:0] _RAND_205;
  reg [31:0] _RAND_206;
  reg [31:0] _RAND_207;
  reg [31:0] _RAND_208;
  reg [31:0] _RAND_209;
  reg [31:0] _RAND_210;
  reg [31:0] _RAND_211;
  reg [31:0] _RAND_212;
  reg [31:0] _RAND_213;
  reg [31:0] _RAND_214;
  reg [31:0] _RAND_215;
  reg [31:0] _RAND_216;
  reg [31:0] _RAND_217;
  reg [31:0] _RAND_218;
  reg [31:0] _RAND_219;
  reg [31:0] _RAND_220;
  reg [31:0] _RAND_221;
  reg [31:0] _RAND_222;
  reg [31:0] _RAND_223;
  reg [31:0] _RAND_224;
  reg [31:0] _RAND_225;
  reg [31:0] _RAND_226;
  reg [31:0] _RAND_227;
  reg [31:0] _RAND_228;
  reg [31:0] _RAND_229;
  reg [31:0] _RAND_230;
  reg [31:0] _RAND_231;
  reg [31:0] _RAND_232;
  reg [31:0] _RAND_233;
  reg [31:0] _RAND_234;
  reg [31:0] _RAND_235;
  reg [31:0] _RAND_236;
  reg [31:0] _RAND_237;
  reg [31:0] _RAND_238;
  reg [31:0] _RAND_239;
  reg [31:0] _RAND_240;
  reg [31:0] _RAND_241;
  reg [31:0] _RAND_242;
  reg [31:0] _RAND_243;
  reg [31:0] _RAND_244;
  reg [31:0] _RAND_245;
  reg [31:0] _RAND_246;
  reg [31:0] _RAND_247;
  reg [31:0] _RAND_248;
  reg [31:0] _RAND_249;
  reg [31:0] _RAND_250;
  reg [31:0] _RAND_251;
  reg [31:0] _RAND_252;
  reg [31:0] _RAND_253;
  reg [31:0] _RAND_254;
  reg [31:0] _RAND_255;
  reg [31:0] _RAND_256;
  reg [31:0] _RAND_257;
  reg [31:0] _RAND_258;
  reg [31:0] _RAND_259;
  reg [31:0] _RAND_260;
  reg [31:0] _RAND_261;
  reg [31:0] _RAND_262;
  reg [31:0] _RAND_263;
  reg [31:0] _RAND_264;
  reg [31:0] _RAND_265;
  reg [31:0] _RAND_266;
  reg [31:0] _RAND_267;
  reg [31:0] _RAND_268;
  reg [31:0] _RAND_269;
  reg [31:0] _RAND_270;
  reg [31:0] _RAND_271;
  reg [31:0] _RAND_272;
  reg [31:0] _RAND_273;
  reg [31:0] _RAND_274;
  reg [31:0] _RAND_275;
  reg [31:0] _RAND_276;
  reg [31:0] _RAND_277;
  reg [31:0] _RAND_278;
  reg [31:0] _RAND_279;
  reg [31:0] _RAND_280;
  reg [31:0] _RAND_281;
  reg [31:0] _RAND_282;
  reg [31:0] _RAND_283;
  reg [31:0] _RAND_284;
  reg [31:0] _RAND_285;
  reg [31:0] _RAND_286;
  reg [31:0] _RAND_287;
  reg [31:0] _RAND_288;
  reg [31:0] _RAND_289;
  reg [31:0] _RAND_290;
  reg [31:0] _RAND_291;
  reg [31:0] _RAND_292;
  reg [31:0] _RAND_293;
  reg [31:0] _RAND_294;
  reg [31:0] _RAND_295;
  reg [31:0] _RAND_296;
  reg [31:0] _RAND_297;
  reg [31:0] _RAND_298;
  reg [31:0] _RAND_299;
  reg [31:0] _RAND_300;
  reg [31:0] _RAND_301;
  reg [31:0] _RAND_302;
  reg [31:0] _RAND_303;
  reg [31:0] _RAND_304;
  reg [31:0] _RAND_305;
  reg [31:0] _RAND_306;
  reg [31:0] _RAND_307;
  reg [31:0] _RAND_308;
  reg [31:0] _RAND_309;
  reg [31:0] _RAND_310;
  reg [31:0] _RAND_311;
  reg [31:0] _RAND_312;
  reg [31:0] _RAND_313;
  reg [31:0] _RAND_314;
  reg [31:0] _RAND_315;
  reg [31:0] _RAND_316;
  reg [31:0] _RAND_317;
  reg [31:0] _RAND_318;
  reg [31:0] _RAND_319;
  reg [31:0] _RAND_320;
  reg [31:0] _RAND_321;
  reg [31:0] _RAND_322;
  reg [31:0] _RAND_323;
  reg [31:0] _RAND_324;
  reg [31:0] _RAND_325;
  reg [31:0] _RAND_326;
  reg [31:0] _RAND_327;
  reg [63:0] _RAND_328;
  reg [63:0] _RAND_329;
  reg [63:0] _RAND_330;
  reg [63:0] _RAND_331;
  reg [63:0] _RAND_332;
  reg [63:0] _RAND_333;
  reg [63:0] _RAND_334;
  reg [63:0] _RAND_335;
  reg [63:0] _RAND_336;
  reg [63:0] _RAND_337;
  reg [63:0] _RAND_338;
  reg [63:0] _RAND_339;
  reg [63:0] _RAND_340;
  reg [63:0] _RAND_341;
  reg [63:0] _RAND_342;
  reg [63:0] _RAND_343;
  reg [63:0] _RAND_344;
  reg [63:0] _RAND_345;
  reg [63:0] _RAND_346;
  reg [63:0] _RAND_347;
  reg [63:0] _RAND_348;
  reg [63:0] _RAND_349;
  reg [63:0] _RAND_350;
  reg [63:0] _RAND_351;
  reg [63:0] _RAND_352;
  reg [63:0] _RAND_353;
  reg [63:0] _RAND_354;
  reg [63:0] _RAND_355;
  reg [63:0] _RAND_356;
  reg [63:0] _RAND_357;
  reg [63:0] _RAND_358;
  reg [63:0] _RAND_359;
  reg [63:0] _RAND_360;
  reg [63:0] _RAND_361;
  reg [63:0] _RAND_362;
  reg [63:0] _RAND_363;
  reg [63:0] _RAND_364;
  reg [63:0] _RAND_365;
  reg [63:0] _RAND_366;
  reg [63:0] _RAND_367;
  reg [63:0] _RAND_368;
  reg [63:0] _RAND_369;
  reg [63:0] _RAND_370;
  reg [63:0] _RAND_371;
  reg [63:0] _RAND_372;
  reg [63:0] _RAND_373;
  reg [63:0] _RAND_374;
  reg [63:0] _RAND_375;
  reg [63:0] _RAND_376;
  reg [63:0] _RAND_377;
  reg [63:0] _RAND_378;
  reg [63:0] _RAND_379;
  reg [63:0] _RAND_380;
  reg [63:0] _RAND_381;
  reg [63:0] _RAND_382;
  reg [63:0] _RAND_383;
  reg [63:0] _RAND_384;
  reg [63:0] _RAND_385;
  reg [63:0] _RAND_386;
  reg [63:0] _RAND_387;
  reg [63:0] _RAND_388;
  reg [63:0] _RAND_389;
  reg [63:0] _RAND_390;
  reg [63:0] _RAND_391;
  reg [63:0] _RAND_392;
  reg [63:0] _RAND_393;
  reg [63:0] _RAND_394;
  reg [63:0] _RAND_395;
  reg [63:0] _RAND_396;
  reg [63:0] _RAND_397;
  reg [63:0] _RAND_398;
  reg [63:0] _RAND_399;
  reg [63:0] _RAND_400;
  reg [63:0] _RAND_401;
  reg [63:0] _RAND_402;
  reg [63:0] _RAND_403;
  reg [63:0] _RAND_404;
  reg [63:0] _RAND_405;
  reg [63:0] _RAND_406;
  reg [63:0] _RAND_407;
  reg [63:0] _RAND_408;
  reg [63:0] _RAND_409;
  reg [63:0] _RAND_410;
  reg [63:0] _RAND_411;
  reg [63:0] _RAND_412;
  reg [63:0] _RAND_413;
  reg [63:0] _RAND_414;
  reg [63:0] _RAND_415;
  reg [63:0] _RAND_416;
  reg [63:0] _RAND_417;
  reg [63:0] _RAND_418;
  reg [63:0] _RAND_419;
  reg [63:0] _RAND_420;
  reg [63:0] _RAND_421;
  reg [63:0] _RAND_422;
  reg [63:0] _RAND_423;
  reg [63:0] _RAND_424;
  reg [63:0] _RAND_425;
  reg [63:0] _RAND_426;
  reg [63:0] _RAND_427;
  reg [63:0] _RAND_428;
  reg [63:0] _RAND_429;
  reg [63:0] _RAND_430;
  reg [63:0] _RAND_431;
  reg [63:0] _RAND_432;
  reg [63:0] _RAND_433;
  reg [63:0] _RAND_434;
  reg [63:0] _RAND_435;
  reg [63:0] _RAND_436;
  reg [63:0] _RAND_437;
  reg [63:0] _RAND_438;
  reg [63:0] _RAND_439;
  reg [63:0] _RAND_440;
  reg [63:0] _RAND_441;
  reg [63:0] _RAND_442;
  reg [63:0] _RAND_443;
  reg [63:0] _RAND_444;
  reg [63:0] _RAND_445;
  reg [63:0] _RAND_446;
  reg [63:0] _RAND_447;
  reg [63:0] _RAND_448;
  reg [63:0] _RAND_449;
  reg [63:0] _RAND_450;
  reg [63:0] _RAND_451;
  reg [63:0] _RAND_452;
  reg [63:0] _RAND_453;
  reg [63:0] _RAND_454;
  reg [63:0] _RAND_455;
  reg [63:0] _RAND_456;
  reg [63:0] _RAND_457;
  reg [63:0] _RAND_458;
  reg [63:0] _RAND_459;
  reg [63:0] _RAND_460;
  reg [63:0] _RAND_461;
  reg [63:0] _RAND_462;
  reg [63:0] _RAND_463;
  reg [63:0] _RAND_464;
  reg [63:0] _RAND_465;
  reg [63:0] _RAND_466;
  reg [63:0] _RAND_467;
  reg [63:0] _RAND_468;
  reg [63:0] _RAND_469;
  reg [63:0] _RAND_470;
  reg [63:0] _RAND_471;
  reg [63:0] _RAND_472;
  reg [63:0] _RAND_473;
  reg [63:0] _RAND_474;
  reg [63:0] _RAND_475;
  reg [63:0] _RAND_476;
  reg [63:0] _RAND_477;
  reg [63:0] _RAND_478;
  reg [63:0] _RAND_479;
  reg [63:0] _RAND_480;
  reg [63:0] _RAND_481;
  reg [63:0] _RAND_482;
  reg [63:0] _RAND_483;
  reg [63:0] _RAND_484;
  reg [63:0] _RAND_485;
  reg [63:0] _RAND_486;
  reg [63:0] _RAND_487;
  reg [63:0] _RAND_488;
  reg [63:0] _RAND_489;
  reg [63:0] _RAND_490;
  reg [63:0] _RAND_491;
  reg [63:0] _RAND_492;
  reg [63:0] _RAND_493;
  reg [63:0] _RAND_494;
  reg [63:0] _RAND_495;
  reg [63:0] _RAND_496;
  reg [63:0] _RAND_497;
  reg [63:0] _RAND_498;
  reg [63:0] _RAND_499;
  reg [63:0] _RAND_500;
  reg [63:0] _RAND_501;
  reg [63:0] _RAND_502;
  reg [63:0] _RAND_503;
  reg [63:0] _RAND_504;
  reg [63:0] _RAND_505;
  reg [63:0] _RAND_506;
  reg [63:0] _RAND_507;
  reg [63:0] _RAND_508;
  reg [63:0] _RAND_509;
  reg [63:0] _RAND_510;
  reg [63:0] _RAND_511;
  reg [63:0] _RAND_512;
  reg [63:0] _RAND_513;
  reg [63:0] _RAND_514;
  reg [63:0] _RAND_515;
  reg [63:0] _RAND_516;
  reg [63:0] _RAND_517;
  reg [63:0] _RAND_518;
  reg [63:0] _RAND_519;
  reg [63:0] _RAND_520;
  reg [63:0] _RAND_521;
  reg [63:0] _RAND_522;
  reg [63:0] _RAND_523;
  reg [63:0] _RAND_524;
  reg [63:0] _RAND_525;
  reg [63:0] _RAND_526;
  reg [63:0] _RAND_527;
  reg [63:0] _RAND_528;
  reg [63:0] _RAND_529;
  reg [63:0] _RAND_530;
  reg [63:0] _RAND_531;
  reg [63:0] _RAND_532;
  reg [63:0] _RAND_533;
  reg [63:0] _RAND_534;
  reg [63:0] _RAND_535;
  reg [63:0] _RAND_536;
  reg [63:0] _RAND_537;
  reg [63:0] _RAND_538;
  reg [63:0] _RAND_539;
  reg [63:0] _RAND_540;
  reg [63:0] _RAND_541;
  reg [63:0] _RAND_542;
  reg [63:0] _RAND_543;
  reg [63:0] _RAND_544;
  reg [63:0] _RAND_545;
  reg [63:0] _RAND_546;
  reg [63:0] _RAND_547;
  reg [63:0] _RAND_548;
  reg [63:0] _RAND_549;
  reg [63:0] _RAND_550;
  reg [63:0] _RAND_551;
  reg [63:0] _RAND_552;
  reg [63:0] _RAND_553;
  reg [63:0] _RAND_554;
  reg [63:0] _RAND_555;
  reg [63:0] _RAND_556;
  reg [63:0] _RAND_557;
  reg [63:0] _RAND_558;
  reg [63:0] _RAND_559;
  reg [63:0] _RAND_560;
  reg [63:0] _RAND_561;
  reg [63:0] _RAND_562;
  reg [63:0] _RAND_563;
  reg [63:0] _RAND_564;
  reg [63:0] _RAND_565;
  reg [63:0] _RAND_566;
  reg [63:0] _RAND_567;
  reg [63:0] _RAND_568;
  reg [63:0] _RAND_569;
  reg [63:0] _RAND_570;
  reg [63:0] _RAND_571;
  reg [63:0] _RAND_572;
  reg [63:0] _RAND_573;
  reg [63:0] _RAND_574;
  reg [63:0] _RAND_575;
  reg [63:0] _RAND_576;
  reg [63:0] _RAND_577;
  reg [63:0] _RAND_578;
  reg [63:0] _RAND_579;
  reg [63:0] _RAND_580;
  reg [63:0] _RAND_581;
  reg [63:0] _RAND_582;
  reg [63:0] _RAND_583;
  reg [63:0] _RAND_584;
  reg [63:0] _RAND_585;
  reg [63:0] _RAND_586;
  reg [63:0] _RAND_587;
  reg [63:0] _RAND_588;
  reg [63:0] _RAND_589;
  reg [63:0] _RAND_590;
  reg [63:0] _RAND_591;
  reg [63:0] _RAND_592;
  reg [63:0] _RAND_593;
  reg [63:0] _RAND_594;
  reg [63:0] _RAND_595;
  reg [63:0] _RAND_596;
  reg [63:0] _RAND_597;
  reg [63:0] _RAND_598;
  reg [63:0] _RAND_599;
  reg [63:0] _RAND_600;
  reg [63:0] _RAND_601;
  reg [63:0] _RAND_602;
  reg [63:0] _RAND_603;
  reg [63:0] _RAND_604;
  reg [63:0] _RAND_605;
  reg [63:0] _RAND_606;
  reg [63:0] _RAND_607;
  reg [63:0] _RAND_608;
  reg [63:0] _RAND_609;
  reg [63:0] _RAND_610;
  reg [63:0] _RAND_611;
  reg [63:0] _RAND_612;
  reg [63:0] _RAND_613;
  reg [63:0] _RAND_614;
  reg [63:0] _RAND_615;
  reg [63:0] _RAND_616;
  reg [63:0] _RAND_617;
  reg [63:0] _RAND_618;
  reg [63:0] _RAND_619;
  reg [63:0] _RAND_620;
  reg [63:0] _RAND_621;
  reg [63:0] _RAND_622;
  reg [63:0] _RAND_623;
  reg [63:0] _RAND_624;
  reg [63:0] _RAND_625;
  reg [63:0] _RAND_626;
  reg [63:0] _RAND_627;
  reg [63:0] _RAND_628;
  reg [63:0] _RAND_629;
  reg [63:0] _RAND_630;
  reg [63:0] _RAND_631;
  reg [63:0] _RAND_632;
  reg [63:0] _RAND_633;
  reg [63:0] _RAND_634;
  reg [63:0] _RAND_635;
  reg [63:0] _RAND_636;
  reg [63:0] _RAND_637;
  reg [63:0] _RAND_638;
  reg [63:0] _RAND_639;
  reg [63:0] _RAND_640;
  reg [63:0] _RAND_641;
  reg [63:0] _RAND_642;
  reg [63:0] _RAND_643;
  reg [63:0] _RAND_644;
  reg [63:0] _RAND_645;
  reg [63:0] _RAND_646;
  reg [63:0] _RAND_647;
  reg [63:0] _RAND_648;
  reg [63:0] _RAND_649;
  reg [63:0] _RAND_650;
  reg [63:0] _RAND_651;
  reg [63:0] _RAND_652;
  reg [63:0] _RAND_653;
  reg [63:0] _RAND_654;
  reg [63:0] _RAND_655;
  reg [63:0] _RAND_656;
  reg [63:0] _RAND_657;
  reg [63:0] _RAND_658;
  reg [63:0] _RAND_659;
  reg [63:0] _RAND_660;
  reg [63:0] _RAND_661;
  reg [63:0] _RAND_662;
  reg [63:0] _RAND_663;
  reg [31:0] _RAND_664;
  reg [31:0] _RAND_665;
  reg [31:0] _RAND_666;
  reg [31:0] _RAND_667;
  reg [31:0] _RAND_668;
  reg [31:0] _RAND_669;
  reg [31:0] _RAND_670;
  reg [31:0] _RAND_671;
  reg [31:0] _RAND_672;
  reg [31:0] _RAND_673;
  reg [31:0] _RAND_674;
  reg [31:0] _RAND_675;
  reg [31:0] _RAND_676;
  reg [31:0] _RAND_677;
  reg [31:0] _RAND_678;
  reg [31:0] _RAND_679;
  reg [31:0] _RAND_680;
  reg [31:0] _RAND_681;
  reg [31:0] _RAND_682;
  reg [31:0] _RAND_683;
  reg [31:0] _RAND_684;
  reg [31:0] _RAND_685;
  reg [31:0] _RAND_686;
  reg [31:0] _RAND_687;
  reg [31:0] _RAND_688;
  reg [31:0] _RAND_689;
  reg [31:0] _RAND_690;
  reg [31:0] _RAND_691;
  reg [31:0] _RAND_692;
  reg [31:0] _RAND_693;
  reg [31:0] _RAND_694;
  reg [31:0] _RAND_695;
  reg [31:0] _RAND_696;
  reg [31:0] _RAND_697;
  reg [31:0] _RAND_698;
  reg [31:0] _RAND_699;
  reg [31:0] _RAND_700;
  reg [31:0] _RAND_701;
  reg [31:0] _RAND_702;
  reg [31:0] _RAND_703;
  reg [31:0] _RAND_704;
  reg [31:0] _RAND_705;
  reg [31:0] _RAND_706;
  reg [31:0] _RAND_707;
  reg [31:0] _RAND_708;
  reg [31:0] _RAND_709;
  reg [31:0] _RAND_710;
  reg [31:0] _RAND_711;
  reg [31:0] _RAND_712;
  reg [31:0] _RAND_713;
  reg [31:0] _RAND_714;
  reg [31:0] _RAND_715;
  reg [31:0] _RAND_716;
  reg [31:0] _RAND_717;
  reg [31:0] _RAND_718;
  reg [31:0] _RAND_719;
  reg [31:0] _RAND_720;
  reg [31:0] _RAND_721;
  reg [31:0] _RAND_722;
  reg [31:0] _RAND_723;
  reg [31:0] _RAND_724;
  reg [31:0] _RAND_725;
  reg [31:0] _RAND_726;
  reg [31:0] _RAND_727;
  reg [31:0] _RAND_728;
  reg [31:0] _RAND_729;
  reg [31:0] _RAND_730;
  reg [31:0] _RAND_731;
  reg [31:0] _RAND_732;
  reg [31:0] _RAND_733;
  reg [31:0] _RAND_734;
  reg [31:0] _RAND_735;
  reg [31:0] _RAND_736;
  reg [31:0] _RAND_737;
  reg [31:0] _RAND_738;
  reg [31:0] _RAND_739;
  reg [31:0] _RAND_740;
  reg [31:0] _RAND_741;
  reg [31:0] _RAND_742;
  reg [31:0] _RAND_743;
  reg [31:0] _RAND_744;
  reg [31:0] _RAND_745;
  reg [31:0] _RAND_746;
  reg [31:0] _RAND_747;
  reg [31:0] _RAND_748;
  reg [31:0] _RAND_749;
  reg [31:0] _RAND_750;
  reg [31:0] _RAND_751;
  reg [31:0] _RAND_752;
  reg [31:0] _RAND_753;
  reg [31:0] _RAND_754;
  reg [31:0] _RAND_755;
  reg [31:0] _RAND_756;
  reg [31:0] _RAND_757;
  reg [31:0] _RAND_758;
  reg [31:0] _RAND_759;
  reg [31:0] _RAND_760;
  reg [31:0] _RAND_761;
  reg [31:0] _RAND_762;
  reg [31:0] _RAND_763;
  reg [31:0] _RAND_764;
  reg [31:0] _RAND_765;
  reg [31:0] _RAND_766;
  reg [31:0] _RAND_767;
  reg [31:0] _RAND_768;
  reg [31:0] _RAND_769;
  reg [31:0] _RAND_770;
  reg [31:0] _RAND_771;
  reg [31:0] _RAND_772;
  reg [31:0] _RAND_773;
  reg [31:0] _RAND_774;
  reg [31:0] _RAND_775;
  reg [31:0] _RAND_776;
  reg [31:0] _RAND_777;
  reg [31:0] _RAND_778;
  reg [31:0] _RAND_779;
  reg [31:0] _RAND_780;
  reg [31:0] _RAND_781;
  reg [31:0] _RAND_782;
  reg [31:0] _RAND_783;
  reg [31:0] _RAND_784;
  reg [31:0] _RAND_785;
  reg [31:0] _RAND_786;
  reg [31:0] _RAND_787;
  reg [31:0] _RAND_788;
  reg [31:0] _RAND_789;
  reg [31:0] _RAND_790;
  reg [31:0] _RAND_791;
  reg [31:0] _RAND_792;
  reg [31:0] _RAND_793;
  reg [31:0] _RAND_794;
  reg [31:0] _RAND_795;
  reg [31:0] _RAND_796;
  reg [31:0] _RAND_797;
  reg [31:0] _RAND_798;
  reg [31:0] _RAND_799;
  reg [31:0] _RAND_800;
  reg [31:0] _RAND_801;
  reg [31:0] _RAND_802;
  reg [31:0] _RAND_803;
  reg [31:0] _RAND_804;
  reg [31:0] _RAND_805;
  reg [31:0] _RAND_806;
  reg [31:0] _RAND_807;
  reg [31:0] _RAND_808;
  reg [31:0] _RAND_809;
  reg [31:0] _RAND_810;
  reg [31:0] _RAND_811;
  reg [31:0] _RAND_812;
  reg [31:0] _RAND_813;
  reg [31:0] _RAND_814;
  reg [31:0] _RAND_815;
  reg [31:0] _RAND_816;
  reg [31:0] _RAND_817;
  reg [31:0] _RAND_818;
  reg [31:0] _RAND_819;
  reg [31:0] _RAND_820;
  reg [31:0] _RAND_821;
  reg [31:0] _RAND_822;
  reg [31:0] _RAND_823;
  reg [31:0] _RAND_824;
  reg [31:0] _RAND_825;
  reg [31:0] _RAND_826;
  reg [31:0] _RAND_827;
  reg [31:0] _RAND_828;
  reg [31:0] _RAND_829;
  reg [31:0] _RAND_830;
  reg [31:0] _RAND_831;
  reg [31:0] _RAND_832;
  reg [31:0] _RAND_833;
  reg [31:0] _RAND_834;
  reg [31:0] _RAND_835;
  reg [31:0] _RAND_836;
  reg [31:0] _RAND_837;
  reg [31:0] _RAND_838;
  reg [31:0] _RAND_839;
  reg [31:0] _RAND_840;
  reg [31:0] _RAND_841;
  reg [31:0] _RAND_842;
  reg [31:0] _RAND_843;
  reg [31:0] _RAND_844;
  reg [31:0] _RAND_845;
  reg [31:0] _RAND_846;
  reg [31:0] _RAND_847;
  reg [31:0] _RAND_848;
  reg [31:0] _RAND_849;
  reg [31:0] _RAND_850;
  reg [31:0] _RAND_851;
  reg [31:0] _RAND_852;
  reg [31:0] _RAND_853;
  reg [31:0] _RAND_854;
  reg [31:0] _RAND_855;
  reg [31:0] _RAND_856;
  reg [31:0] _RAND_857;
  reg [31:0] _RAND_858;
  reg [31:0] _RAND_859;
  reg [31:0] _RAND_860;
  reg [31:0] _RAND_861;
  reg [31:0] _RAND_862;
  reg [31:0] _RAND_863;
  reg [31:0] _RAND_864;
  reg [31:0] _RAND_865;
  reg [31:0] _RAND_866;
  reg [31:0] _RAND_867;
  reg [31:0] _RAND_868;
  reg [31:0] _RAND_869;
  reg [31:0] _RAND_870;
  reg [31:0] _RAND_871;
  reg [31:0] _RAND_872;
  reg [31:0] _RAND_873;
  reg [31:0] _RAND_874;
  reg [31:0] _RAND_875;
  reg [31:0] _RAND_876;
  reg [31:0] _RAND_877;
  reg [31:0] _RAND_878;
  reg [31:0] _RAND_879;
  reg [31:0] _RAND_880;
  reg [31:0] _RAND_881;
  reg [31:0] _RAND_882;
  reg [31:0] _RAND_883;
  reg [31:0] _RAND_884;
  reg [31:0] _RAND_885;
  reg [63:0] _RAND_886;
  reg [63:0] _RAND_887;
  reg [63:0] _RAND_888;
  reg [63:0] _RAND_889;
  reg [63:0] _RAND_890;
  reg [63:0] _RAND_891;
  reg [63:0] _RAND_892;
  reg [63:0] _RAND_893;
  reg [63:0] _RAND_894;
  reg [63:0] _RAND_895;
  reg [63:0] _RAND_896;
  reg [63:0] _RAND_897;
  reg [63:0] _RAND_898;
  reg [63:0] _RAND_899;
  reg [63:0] _RAND_900;
  reg [63:0] _RAND_901;
  reg [63:0] _RAND_902;
  reg [63:0] _RAND_903;
  reg [63:0] _RAND_904;
  reg [63:0] _RAND_905;
  reg [63:0] _RAND_906;
  reg [63:0] _RAND_907;
  reg [63:0] _RAND_908;
  reg [63:0] _RAND_909;
  reg [63:0] _RAND_910;
  reg [63:0] _RAND_911;
  reg [63:0] _RAND_912;
  reg [63:0] _RAND_913;
  reg [63:0] _RAND_914;
  reg [63:0] _RAND_915;
  reg [63:0] _RAND_916;
  reg [63:0] _RAND_917;
  reg [63:0] _RAND_918;
  reg [63:0] _RAND_919;
  reg [63:0] _RAND_920;
  reg [63:0] _RAND_921;
  reg [63:0] _RAND_922;
  reg [63:0] _RAND_923;
  reg [63:0] _RAND_924;
  reg [63:0] _RAND_925;
  reg [63:0] _RAND_926;
  reg [63:0] _RAND_927;
  reg [63:0] _RAND_928;
  reg [63:0] _RAND_929;
  reg [63:0] _RAND_930;
  reg [63:0] _RAND_931;
  reg [63:0] _RAND_932;
  reg [63:0] _RAND_933;
  reg [63:0] _RAND_934;
  reg [63:0] _RAND_935;
  reg [63:0] _RAND_936;
  reg [63:0] _RAND_937;
  reg [63:0] _RAND_938;
  reg [63:0] _RAND_939;
  reg [63:0] _RAND_940;
  reg [63:0] _RAND_941;
  reg [63:0] _RAND_942;
  reg [63:0] _RAND_943;
  reg [63:0] _RAND_944;
  reg [63:0] _RAND_945;
  reg [63:0] _RAND_946;
  reg [63:0] _RAND_947;
  reg [63:0] _RAND_948;
  reg [63:0] _RAND_949;
  reg [63:0] _RAND_950;
  reg [63:0] _RAND_951;
  reg [63:0] _RAND_952;
  reg [63:0] _RAND_953;
  reg [63:0] _RAND_954;
  reg [63:0] _RAND_955;
  reg [63:0] _RAND_956;
  reg [63:0] _RAND_957;
  reg [63:0] _RAND_958;
  reg [63:0] _RAND_959;
  reg [63:0] _RAND_960;
  reg [63:0] _RAND_961;
  reg [63:0] _RAND_962;
  reg [63:0] _RAND_963;
  reg [63:0] _RAND_964;
  reg [63:0] _RAND_965;
  reg [63:0] _RAND_966;
  reg [63:0] _RAND_967;
  reg [63:0] _RAND_968;
  reg [63:0] _RAND_969;
  reg [63:0] _RAND_970;
  reg [63:0] _RAND_971;
  reg [63:0] _RAND_972;
  reg [63:0] _RAND_973;
  reg [63:0] _RAND_974;
  reg [63:0] _RAND_975;
  reg [63:0] _RAND_976;
  reg [63:0] _RAND_977;
  reg [63:0] _RAND_978;
  reg [63:0] _RAND_979;
  reg [63:0] _RAND_980;
  reg [63:0] _RAND_981;
  reg [63:0] _RAND_982;
  reg [63:0] _RAND_983;
  reg [63:0] _RAND_984;
  reg [63:0] _RAND_985;
  reg [63:0] _RAND_986;
  reg [63:0] _RAND_987;
  reg [63:0] _RAND_988;
  reg [63:0] _RAND_989;
  reg [63:0] _RAND_990;
  reg [63:0] _RAND_991;
  reg [63:0] _RAND_992;
  reg [63:0] _RAND_993;
  reg [63:0] _RAND_994;
  reg [63:0] _RAND_995;
  reg [63:0] _RAND_996;
  reg [63:0] _RAND_997;
  reg [63:0] _RAND_998;
  reg [63:0] _RAND_999;
  reg [63:0] _RAND_1000;
  reg [63:0] _RAND_1001;
  reg [63:0] _RAND_1002;
  reg [63:0] _RAND_1003;
  reg [63:0] _RAND_1004;
  reg [63:0] _RAND_1005;
  reg [63:0] _RAND_1006;
  reg [63:0] _RAND_1007;
  reg [63:0] _RAND_1008;
  reg [63:0] _RAND_1009;
  reg [63:0] _RAND_1010;
  reg [63:0] _RAND_1011;
  reg [63:0] _RAND_1012;
  reg [63:0] _RAND_1013;
  reg [63:0] _RAND_1014;
  reg [63:0] _RAND_1015;
  reg [63:0] _RAND_1016;
  reg [63:0] _RAND_1017;
  reg [63:0] _RAND_1018;
  reg [63:0] _RAND_1019;
  reg [63:0] _RAND_1020;
  reg [63:0] _RAND_1021;
  reg [63:0] _RAND_1022;
  reg [63:0] _RAND_1023;
  reg [63:0] _RAND_1024;
  reg [63:0] _RAND_1025;
  reg [63:0] _RAND_1026;
  reg [63:0] _RAND_1027;
  reg [63:0] _RAND_1028;
  reg [63:0] _RAND_1029;
  reg [63:0] _RAND_1030;
  reg [63:0] _RAND_1031;
  reg [63:0] _RAND_1032;
  reg [63:0] _RAND_1033;
  reg [63:0] _RAND_1034;
  reg [63:0] _RAND_1035;
  reg [63:0] _RAND_1036;
  reg [63:0] _RAND_1037;
  reg [63:0] _RAND_1038;
  reg [63:0] _RAND_1039;
  reg [63:0] _RAND_1040;
  reg [63:0] _RAND_1041;
  reg [63:0] _RAND_1042;
  reg [63:0] _RAND_1043;
  reg [63:0] _RAND_1044;
  reg [63:0] _RAND_1045;
  reg [63:0] _RAND_1046;
  reg [63:0] _RAND_1047;
  reg [63:0] _RAND_1048;
  reg [63:0] _RAND_1049;
  reg [63:0] _RAND_1050;
  reg [63:0] _RAND_1051;
  reg [63:0] _RAND_1052;
  reg [63:0] _RAND_1053;
  reg [63:0] _RAND_1054;
  reg [63:0] _RAND_1055;
  reg [63:0] _RAND_1056;
  reg [63:0] _RAND_1057;
  reg [63:0] _RAND_1058;
  reg [63:0] _RAND_1059;
  reg [63:0] _RAND_1060;
  reg [63:0] _RAND_1061;
  reg [63:0] _RAND_1062;
  reg [63:0] _RAND_1063;
  reg [63:0] _RAND_1064;
  reg [63:0] _RAND_1065;
  reg [63:0] _RAND_1066;
  reg [63:0] _RAND_1067;
  reg [63:0] _RAND_1068;
  reg [63:0] _RAND_1069;
  reg [63:0] _RAND_1070;
  reg [63:0] _RAND_1071;
  reg [63:0] _RAND_1072;
  reg [63:0] _RAND_1073;
  reg [63:0] _RAND_1074;
  reg [63:0] _RAND_1075;
  reg [63:0] _RAND_1076;
  reg [63:0] _RAND_1077;
  reg [63:0] _RAND_1078;
  reg [63:0] _RAND_1079;
  reg [63:0] _RAND_1080;
  reg [63:0] _RAND_1081;
  reg [63:0] _RAND_1082;
  reg [63:0] _RAND_1083;
  reg [63:0] _RAND_1084;
  reg [63:0] _RAND_1085;
  reg [63:0] _RAND_1086;
  reg [63:0] _RAND_1087;
  reg [63:0] _RAND_1088;
  reg [63:0] _RAND_1089;
  reg [63:0] _RAND_1090;
  reg [63:0] _RAND_1091;
  reg [63:0] _RAND_1092;
  reg [63:0] _RAND_1093;
  reg [63:0] _RAND_1094;
  reg [63:0] _RAND_1095;
  reg [63:0] _RAND_1096;
  reg [63:0] _RAND_1097;
  reg [63:0] _RAND_1098;
  reg [63:0] _RAND_1099;
  reg [63:0] _RAND_1100;
  reg [63:0] _RAND_1101;
  reg [63:0] _RAND_1102;
  reg [63:0] _RAND_1103;
  reg [63:0] _RAND_1104;
  reg [63:0] _RAND_1105;
  reg [63:0] _RAND_1106;
  reg [63:0] _RAND_1107;
  reg [63:0] _RAND_1108;
  reg [63:0] _RAND_1109;
  reg [63:0] _RAND_1110;
  reg [63:0] _RAND_1111;
  reg [63:0] _RAND_1112;
  reg [63:0] _RAND_1113;
  reg [63:0] _RAND_1114;
  reg [63:0] _RAND_1115;
  reg [63:0] _RAND_1116;
  reg [63:0] _RAND_1117;
  reg [63:0] _RAND_1118;
  reg [63:0] _RAND_1119;
  reg [63:0] _RAND_1120;
  reg [63:0] _RAND_1121;
  reg [63:0] _RAND_1122;
  reg [63:0] _RAND_1123;
  reg [63:0] _RAND_1124;
  reg [63:0] _RAND_1125;
  reg [63:0] _RAND_1126;
  reg [63:0] _RAND_1127;
  reg [63:0] _RAND_1128;
  reg [63:0] _RAND_1129;
  reg [63:0] _RAND_1130;
  reg [63:0] _RAND_1131;
  reg [63:0] _RAND_1132;
  reg [63:0] _RAND_1133;
  reg [63:0] _RAND_1134;
  reg [63:0] _RAND_1135;
  reg [63:0] _RAND_1136;
  reg [63:0] _RAND_1137;
  reg [63:0] _RAND_1138;
  reg [63:0] _RAND_1139;
  reg [63:0] _RAND_1140;
  reg [63:0] _RAND_1141;
  reg [63:0] _RAND_1142;
  reg [63:0] _RAND_1143;
  reg [63:0] _RAND_1144;
  reg [63:0] _RAND_1145;
  reg [63:0] _RAND_1146;
  reg [63:0] _RAND_1147;
  reg [63:0] _RAND_1148;
  reg [63:0] _RAND_1149;
  reg [63:0] _RAND_1150;
  reg [63:0] _RAND_1151;
  reg [63:0] _RAND_1152;
  reg [63:0] _RAND_1153;
  reg [63:0] _RAND_1154;
  reg [63:0] _RAND_1155;
  reg [63:0] _RAND_1156;
  reg [63:0] _RAND_1157;
  reg [63:0] _RAND_1158;
  reg [63:0] _RAND_1159;
  reg [63:0] _RAND_1160;
  reg [63:0] _RAND_1161;
  reg [63:0] _RAND_1162;
  reg [63:0] _RAND_1163;
  reg [63:0] _RAND_1164;
  reg [63:0] _RAND_1165;
  reg [63:0] _RAND_1166;
  reg [63:0] _RAND_1167;
  reg [63:0] _RAND_1168;
  reg [63:0] _RAND_1169;
  reg [63:0] _RAND_1170;
  reg [63:0] _RAND_1171;
  reg [63:0] _RAND_1172;
  reg [63:0] _RAND_1173;
  reg [63:0] _RAND_1174;
  reg [63:0] _RAND_1175;
  reg [63:0] _RAND_1176;
  reg [63:0] _RAND_1177;
  reg [63:0] _RAND_1178;
  reg [63:0] _RAND_1179;
  reg [63:0] _RAND_1180;
  reg [63:0] _RAND_1181;
  reg [63:0] _RAND_1182;
  reg [63:0] _RAND_1183;
  reg [63:0] _RAND_1184;
  reg [63:0] _RAND_1185;
  reg [63:0] _RAND_1186;
  reg [63:0] _RAND_1187;
  reg [63:0] _RAND_1188;
  reg [63:0] _RAND_1189;
  reg [63:0] _RAND_1190;
  reg [63:0] _RAND_1191;
  reg [63:0] _RAND_1192;
  reg [63:0] _RAND_1193;
  reg [63:0] _RAND_1194;
  reg [63:0] _RAND_1195;
  reg [63:0] _RAND_1196;
  reg [63:0] _RAND_1197;
  reg [63:0] _RAND_1198;
  reg [63:0] _RAND_1199;
  reg [63:0] _RAND_1200;
  reg [63:0] _RAND_1201;
  reg [63:0] _RAND_1202;
  reg [63:0] _RAND_1203;
  reg [63:0] _RAND_1204;
  reg [63:0] _RAND_1205;
  reg [63:0] _RAND_1206;
  reg [63:0] _RAND_1207;
  reg [63:0] _RAND_1208;
  reg [63:0] _RAND_1209;
  reg [63:0] _RAND_1210;
  reg [63:0] _RAND_1211;
  reg [63:0] _RAND_1212;
  reg [63:0] _RAND_1213;
  reg [63:0] _RAND_1214;
  reg [63:0] _RAND_1215;
  reg [63:0] _RAND_1216;
  reg [63:0] _RAND_1217;
  reg [63:0] _RAND_1218;
  reg [63:0] _RAND_1219;
  reg [63:0] _RAND_1220;
  reg [63:0] _RAND_1221;
  reg [63:0] _RAND_1222;
  reg [63:0] _RAND_1223;
  reg [63:0] _RAND_1224;
  reg [63:0] _RAND_1225;
  reg [63:0] _RAND_1226;
  reg [63:0] _RAND_1227;
  reg [63:0] _RAND_1228;
  reg [63:0] _RAND_1229;
  reg [63:0] _RAND_1230;
  reg [63:0] _RAND_1231;
  reg [63:0] _RAND_1232;
  reg [63:0] _RAND_1233;
  reg [63:0] _RAND_1234;
  reg [63:0] _RAND_1235;
  reg [63:0] _RAND_1236;
  reg [63:0] _RAND_1237;
  reg [63:0] _RAND_1238;
  reg [63:0] _RAND_1239;
  reg [63:0] _RAND_1240;
  reg [63:0] _RAND_1241;
  reg [63:0] _RAND_1242;
  reg [63:0] _RAND_1243;
  reg [63:0] _RAND_1244;
  reg [63:0] _RAND_1245;
  reg [63:0] _RAND_1246;
  reg [63:0] _RAND_1247;
  reg [63:0] _RAND_1248;
  reg [63:0] _RAND_1249;
  reg [63:0] _RAND_1250;
  reg [63:0] _RAND_1251;
  reg [63:0] _RAND_1252;
  reg [63:0] _RAND_1253;
  reg [63:0] _RAND_1254;
  reg [63:0] _RAND_1255;
  reg [63:0] _RAND_1256;
  reg [63:0] _RAND_1257;
  reg [63:0] _RAND_1258;
  reg [63:0] _RAND_1259;
  reg [63:0] _RAND_1260;
  reg [63:0] _RAND_1261;
  reg [63:0] _RAND_1262;
  reg [63:0] _RAND_1263;
  reg [63:0] _RAND_1264;
  reg [63:0] _RAND_1265;
  reg [63:0] _RAND_1266;
  reg [63:0] _RAND_1267;
  reg [63:0] _RAND_1268;
  reg [63:0] _RAND_1269;
  reg [63:0] _RAND_1270;
  reg [63:0] _RAND_1271;
  reg [63:0] _RAND_1272;
  reg [63:0] _RAND_1273;
  reg [63:0] _RAND_1274;
  reg [63:0] _RAND_1275;
  reg [63:0] _RAND_1276;
  reg [63:0] _RAND_1277;
  reg [63:0] _RAND_1278;
  reg [63:0] _RAND_1279;
  reg [63:0] _RAND_1280;
  reg [63:0] _RAND_1281;
  reg [63:0] _RAND_1282;
  reg [63:0] _RAND_1283;
  reg [63:0] _RAND_1284;
  reg [63:0] _RAND_1285;
  reg [63:0] _RAND_1286;
  reg [63:0] _RAND_1287;
  reg [63:0] _RAND_1288;
  reg [63:0] _RAND_1289;
  reg [63:0] _RAND_1290;
  reg [63:0] _RAND_1291;
  reg [63:0] _RAND_1292;
  reg [63:0] _RAND_1293;
  reg [63:0] _RAND_1294;
  reg [63:0] _RAND_1295;
  reg [63:0] _RAND_1296;
  reg [63:0] _RAND_1297;
  reg [63:0] _RAND_1298;
  reg [63:0] _RAND_1299;
  reg [63:0] _RAND_1300;
  reg [63:0] _RAND_1301;
  reg [63:0] _RAND_1302;
  reg [63:0] _RAND_1303;
  reg [63:0] _RAND_1304;
  reg [63:0] _RAND_1305;
  reg [63:0] _RAND_1306;
  reg [63:0] _RAND_1307;
  reg [63:0] _RAND_1308;
  reg [63:0] _RAND_1309;
  reg [63:0] _RAND_1310;
  reg [63:0] _RAND_1311;
  reg [63:0] _RAND_1312;
  reg [63:0] _RAND_1313;
  reg [63:0] _RAND_1314;
  reg [63:0] _RAND_1315;
  reg [63:0] _RAND_1316;
  reg [63:0] _RAND_1317;
  reg [31:0] _RAND_1318;
  reg [31:0] _RAND_1319;
  reg [31:0] _RAND_1320;
  reg [31:0] _RAND_1321;
  reg [31:0] _RAND_1322;
  reg [31:0] _RAND_1323;
  reg [31:0] _RAND_1324;
  reg [31:0] _RAND_1325;
  reg [31:0] _RAND_1326;
  reg [31:0] _RAND_1327;
  reg [31:0] _RAND_1328;
  reg [31:0] _RAND_1329;
  reg [31:0] _RAND_1330;
  reg [31:0] _RAND_1331;
  reg [31:0] _RAND_1332;
  reg [31:0] _RAND_1333;
  reg [31:0] _RAND_1334;
  reg [31:0] _RAND_1335;
  reg [31:0] _RAND_1336;
  reg [31:0] _RAND_1337;
  reg [31:0] _RAND_1338;
  reg [31:0] _RAND_1339;
  reg [31:0] _RAND_1340;
  reg [31:0] _RAND_1341;
  reg [31:0] _RAND_1342;
  reg [31:0] _RAND_1343;
  reg [31:0] _RAND_1344;
  reg [31:0] _RAND_1345;
  reg [31:0] _RAND_1346;
  reg [31:0] _RAND_1347;
  reg [31:0] _RAND_1348;
  reg [31:0] _RAND_1349;
  reg [31:0] _RAND_1350;
  reg [31:0] _RAND_1351;
  reg [31:0] _RAND_1352;
  reg [31:0] _RAND_1353;
  reg [31:0] _RAND_1354;
  reg [31:0] _RAND_1355;
  reg [31:0] _RAND_1356;
  reg [31:0] _RAND_1357;
  reg [31:0] _RAND_1358;
  reg [31:0] _RAND_1359;
  reg [31:0] _RAND_1360;
  reg [31:0] _RAND_1361;
  reg [31:0] _RAND_1362;
  reg [31:0] _RAND_1363;
  reg [31:0] _RAND_1364;
  reg [31:0] _RAND_1365;
  reg [31:0] _RAND_1366;
  reg [31:0] _RAND_1367;
  reg [31:0] _RAND_1368;
  reg [31:0] _RAND_1369;
  reg [31:0] _RAND_1370;
  reg [31:0] _RAND_1371;
  reg [31:0] _RAND_1372;
  reg [31:0] _RAND_1373;
  reg [31:0] _RAND_1374;
  reg [31:0] _RAND_1375;
  reg [31:0] _RAND_1376;
  reg [31:0] _RAND_1377;
  reg [31:0] _RAND_1378;
  reg [31:0] _RAND_1379;
  reg [31:0] _RAND_1380;
  reg [31:0] _RAND_1381;
  reg [31:0] _RAND_1382;
  reg [31:0] _RAND_1383;
  reg [31:0] _RAND_1384;
  reg [31:0] _RAND_1385;
  reg [31:0] _RAND_1386;
  reg [31:0] _RAND_1387;
  reg [31:0] _RAND_1388;
  reg [31:0] _RAND_1389;
  reg [31:0] _RAND_1390;
  reg [31:0] _RAND_1391;
  reg [31:0] _RAND_1392;
  reg [31:0] _RAND_1393;
  reg [31:0] _RAND_1394;
  reg [31:0] _RAND_1395;
  reg [31:0] _RAND_1396;
  reg [31:0] _RAND_1397;
  reg [31:0] _RAND_1398;
  reg [31:0] _RAND_1399;
  reg [31:0] _RAND_1400;
  reg [31:0] _RAND_1401;
  reg [31:0] _RAND_1402;
  reg [31:0] _RAND_1403;
  reg [31:0] _RAND_1404;
  reg [31:0] _RAND_1405;
  reg [31:0] _RAND_1406;
  reg [31:0] _RAND_1407;
  reg [31:0] _RAND_1408;
  reg [31:0] _RAND_1409;
  reg [31:0] _RAND_1410;
  reg [31:0] _RAND_1411;
  reg [31:0] _RAND_1412;
  reg [31:0] _RAND_1413;
  reg [31:0] _RAND_1414;
  reg [31:0] _RAND_1415;
  reg [31:0] _RAND_1416;
  reg [31:0] _RAND_1417;
  reg [31:0] _RAND_1418;
  reg [31:0] _RAND_1419;
  reg [31:0] _RAND_1420;
  reg [31:0] _RAND_1421;
  reg [31:0] _RAND_1422;
  reg [31:0] _RAND_1423;
  reg [31:0] _RAND_1424;
  reg [31:0] _RAND_1425;
  reg [31:0] _RAND_1426;
  reg [31:0] _RAND_1427;
  reg [31:0] _RAND_1428;
  reg [31:0] _RAND_1429;
  reg [31:0] _RAND_1430;
  reg [31:0] _RAND_1431;
  reg [31:0] _RAND_1432;
  reg [31:0] _RAND_1433;
  reg [31:0] _RAND_1434;
  reg [31:0] _RAND_1435;
  reg [31:0] _RAND_1436;
  reg [31:0] _RAND_1437;
  reg [31:0] _RAND_1438;
  reg [31:0] _RAND_1439;
  reg [31:0] _RAND_1440;
  reg [31:0] _RAND_1441;
  reg [31:0] _RAND_1442;
  reg [31:0] _RAND_1443;
  reg [31:0] _RAND_1444;
  reg [31:0] _RAND_1445;
  reg [31:0] _RAND_1446;
  reg [31:0] _RAND_1447;
  reg [31:0] _RAND_1448;
  reg [31:0] _RAND_1449;
  reg [31:0] _RAND_1450;
  reg [31:0] _RAND_1451;
  reg [31:0] _RAND_1452;
  reg [31:0] _RAND_1453;
  reg [31:0] _RAND_1454;
  reg [31:0] _RAND_1455;
  reg [31:0] _RAND_1456;
  reg [31:0] _RAND_1457;
  reg [31:0] _RAND_1458;
  reg [31:0] _RAND_1459;
  reg [31:0] _RAND_1460;
  reg [31:0] _RAND_1461;
  reg [31:0] _RAND_1462;
  reg [31:0] _RAND_1463;
  reg [31:0] _RAND_1464;
  reg [31:0] _RAND_1465;
  reg [31:0] _RAND_1466;
  reg [31:0] _RAND_1467;
  reg [31:0] _RAND_1468;
  reg [31:0] _RAND_1469;
  reg [31:0] _RAND_1470;
  reg [31:0] _RAND_1471;
  reg [31:0] _RAND_1472;
  reg [31:0] _RAND_1473;
  reg [31:0] _RAND_1474;
  reg [31:0] _RAND_1475;
  reg [31:0] _RAND_1476;
  reg [31:0] _RAND_1477;
  reg [31:0] _RAND_1478;
  reg [31:0] _RAND_1479;
  reg [31:0] _RAND_1480;
  reg [31:0] _RAND_1481;
  reg [31:0] _RAND_1482;
  reg [31:0] _RAND_1483;
  reg [31:0] _RAND_1484;
  reg [31:0] _RAND_1485;
  reg [31:0] _RAND_1486;
  reg [31:0] _RAND_1487;
  reg [31:0] _RAND_1488;
  reg [31:0] _RAND_1489;
  reg [31:0] _RAND_1490;
  reg [31:0] _RAND_1491;
  reg [31:0] _RAND_1492;
  reg [31:0] _RAND_1493;
  reg [31:0] _RAND_1494;
  reg [31:0] _RAND_1495;
  reg [31:0] _RAND_1496;
  reg [31:0] _RAND_1497;
  reg [31:0] _RAND_1498;
  reg [31:0] _RAND_1499;
  reg [31:0] _RAND_1500;
  reg [31:0] _RAND_1501;
  reg [31:0] _RAND_1502;
  reg [31:0] _RAND_1503;
  reg [31:0] _RAND_1504;
  reg [31:0] _RAND_1505;
  reg [31:0] _RAND_1506;
  reg [31:0] _RAND_1507;
  reg [31:0] _RAND_1508;
  reg [31:0] _RAND_1509;
  reg [31:0] _RAND_1510;
  reg [31:0] _RAND_1511;
  reg [31:0] _RAND_1512;
  reg [31:0] _RAND_1513;
  reg [31:0] _RAND_1514;
  reg [31:0] _RAND_1515;
  reg [31:0] _RAND_1516;
  reg [31:0] _RAND_1517;
  reg [31:0] _RAND_1518;
  reg [31:0] _RAND_1519;
  reg [31:0] _RAND_1520;
  reg [31:0] _RAND_1521;
  reg [31:0] _RAND_1522;
  reg [31:0] _RAND_1523;
  reg [31:0] _RAND_1524;
  reg [31:0] _RAND_1525;
  reg [31:0] _RAND_1526;
  reg [31:0] _RAND_1527;
  reg [31:0] _RAND_1528;
  reg [31:0] _RAND_1529;
  reg [31:0] _RAND_1530;
  reg [31:0] _RAND_1531;
  reg [31:0] _RAND_1532;
  reg [31:0] _RAND_1533;
  reg [31:0] _RAND_1534;
  reg [31:0] _RAND_1535;
  reg [31:0] _RAND_1536;
  reg [31:0] _RAND_1537;
  reg [31:0] _RAND_1538;
  reg [31:0] _RAND_1539;
  reg [31:0] _RAND_1540;
  reg [31:0] _RAND_1541;
  reg [31:0] _RAND_1542;
  reg [31:0] _RAND_1543;
  reg [31:0] _RAND_1544;
  reg [31:0] _RAND_1545;
  reg [31:0] _RAND_1546;
  reg [31:0] _RAND_1547;
  reg [31:0] _RAND_1548;
  reg [31:0] _RAND_1549;
  reg [31:0] _RAND_1550;
  reg [31:0] _RAND_1551;
  reg [31:0] _RAND_1552;
  reg [31:0] _RAND_1553;
  reg [31:0] _RAND_1554;
  reg [31:0] _RAND_1555;
  reg [31:0] _RAND_1556;
  reg [31:0] _RAND_1557;
  reg [31:0] _RAND_1558;
  reg [31:0] _RAND_1559;
  reg [31:0] _RAND_1560;
  reg [31:0] _RAND_1561;
  reg [31:0] _RAND_1562;
  reg [31:0] _RAND_1563;
  reg [31:0] _RAND_1564;
  reg [31:0] _RAND_1565;
  reg [31:0] _RAND_1566;
  reg [31:0] _RAND_1567;
  reg [31:0] _RAND_1568;
  reg [31:0] _RAND_1569;
  reg [31:0] _RAND_1570;
  reg [31:0] _RAND_1571;
  reg [31:0] _RAND_1572;
  reg [31:0] _RAND_1573;
  reg [31:0] _RAND_1574;
  reg [31:0] _RAND_1575;
  reg [31:0] _RAND_1576;
  reg [31:0] _RAND_1577;
  reg [31:0] _RAND_1578;
  reg [31:0] _RAND_1579;
  reg [31:0] _RAND_1580;
  reg [31:0] _RAND_1581;
  reg [31:0] _RAND_1582;
  reg [31:0] _RAND_1583;
  reg [31:0] _RAND_1584;
  reg [31:0] _RAND_1585;
  reg [31:0] _RAND_1586;
  reg [31:0] _RAND_1587;
  reg [31:0] _RAND_1588;
  reg [31:0] _RAND_1589;
  reg [31:0] _RAND_1590;
  reg [31:0] _RAND_1591;
  reg [31:0] _RAND_1592;
  reg [31:0] _RAND_1593;
  reg [31:0] _RAND_1594;
  reg [31:0] _RAND_1595;
  reg [31:0] _RAND_1596;
  reg [31:0] _RAND_1597;
  reg [31:0] _RAND_1598;
  reg [31:0] _RAND_1599;
  reg [31:0] _RAND_1600;
  reg [31:0] _RAND_1601;
  reg [31:0] _RAND_1602;
  reg [31:0] _RAND_1603;
  reg [31:0] _RAND_1604;
  reg [31:0] _RAND_1605;
  reg [31:0] _RAND_1606;
  reg [31:0] _RAND_1607;
  reg [31:0] _RAND_1608;
  reg [31:0] _RAND_1609;
  reg [31:0] _RAND_1610;
  reg [31:0] _RAND_1611;
  reg [31:0] _RAND_1612;
  reg [31:0] _RAND_1613;
  reg [31:0] _RAND_1614;
  reg [31:0] _RAND_1615;
  reg [31:0] _RAND_1616;
  reg [31:0] _RAND_1617;
  reg [31:0] _RAND_1618;
  reg [31:0] _RAND_1619;
  reg [31:0] _RAND_1620;
  reg [31:0] _RAND_1621;
  reg [31:0] _RAND_1622;
  reg [31:0] _RAND_1623;
  reg [31:0] _RAND_1624;
  reg [31:0] _RAND_1625;
  reg [31:0] _RAND_1626;
  reg [31:0] _RAND_1627;
  reg [31:0] _RAND_1628;
  reg [31:0] _RAND_1629;
  reg [31:0] _RAND_1630;
  reg [31:0] _RAND_1631;
  reg [31:0] _RAND_1632;
  reg [31:0] _RAND_1633;
  reg [31:0] _RAND_1634;
  reg [31:0] _RAND_1635;
  reg [31:0] _RAND_1636;
  reg [31:0] _RAND_1637;
  reg [31:0] _RAND_1638;
  reg [31:0] _RAND_1639;
  reg [31:0] _RAND_1640;
  reg [31:0] _RAND_1641;
  reg [31:0] _RAND_1642;
  reg [31:0] _RAND_1643;
  reg [31:0] _RAND_1644;
  reg [31:0] _RAND_1645;
  reg [31:0] _RAND_1646;
  reg [31:0] _RAND_1647;
  reg [31:0] _RAND_1648;
  reg [31:0] _RAND_1649;
  reg [31:0] _RAND_1650;
  reg [31:0] _RAND_1651;
  reg [31:0] _RAND_1652;
  reg [31:0] _RAND_1653;
  reg [31:0] _RAND_1654;
  reg [31:0] _RAND_1655;
  reg [31:0] _RAND_1656;
  reg [31:0] _RAND_1657;
  reg [31:0] _RAND_1658;
  reg [31:0] _RAND_1659;
  reg [31:0] _RAND_1660;
  reg [31:0] _RAND_1661;
  reg [31:0] _RAND_1662;
  reg [31:0] _RAND_1663;
  reg [31:0] _RAND_1664;
  reg [31:0] _RAND_1665;
  reg [31:0] _RAND_1666;
  reg [31:0] _RAND_1667;
  reg [31:0] _RAND_1668;
  reg [31:0] _RAND_1669;
  reg [31:0] _RAND_1670;
  reg [31:0] _RAND_1671;
  reg [31:0] _RAND_1672;
  reg [31:0] _RAND_1673;
  reg [31:0] _RAND_1674;
  reg [31:0] _RAND_1675;
  reg [31:0] _RAND_1676;
  reg [31:0] _RAND_1677;
  reg [31:0] _RAND_1678;
  reg [31:0] _RAND_1679;
  reg [31:0] _RAND_1680;
  reg [31:0] _RAND_1681;
  reg [31:0] _RAND_1682;
  reg [31:0] _RAND_1683;
  reg [31:0] _RAND_1684;
  reg [31:0] _RAND_1685;
  reg [31:0] _RAND_1686;
  reg [31:0] _RAND_1687;
  reg [31:0] _RAND_1688;
  reg [31:0] _RAND_1689;
  reg [31:0] _RAND_1690;
  reg [31:0] _RAND_1691;
  reg [31:0] _RAND_1692;
  reg [31:0] _RAND_1693;
  reg [31:0] _RAND_1694;
  reg [31:0] _RAND_1695;
  reg [31:0] _RAND_1696;
  reg [31:0] _RAND_1697;
  reg [31:0] _RAND_1698;
  reg [31:0] _RAND_1699;
  reg [31:0] _RAND_1700;
  reg [31:0] _RAND_1701;
  reg [31:0] _RAND_1702;
  reg [31:0] _RAND_1703;
  reg [31:0] _RAND_1704;
  reg [31:0] _RAND_1705;
  reg [31:0] _RAND_1706;
  reg [31:0] _RAND_1707;
  reg [31:0] _RAND_1708;
  reg [31:0] _RAND_1709;
  reg [31:0] _RAND_1710;
  reg [31:0] _RAND_1711;
  reg [31:0] _RAND_1712;
  reg [31:0] _RAND_1713;
  reg [31:0] _RAND_1714;
  reg [31:0] _RAND_1715;
  reg [31:0] _RAND_1716;
  reg [31:0] _RAND_1717;
  reg [31:0] _RAND_1718;
  reg [31:0] _RAND_1719;
  reg [31:0] _RAND_1720;
  reg [31:0] _RAND_1721;
  reg [31:0] _RAND_1722;
  reg [31:0] _RAND_1723;
  reg [31:0] _RAND_1724;
  reg [31:0] _RAND_1725;
  reg [31:0] _RAND_1726;
  reg [31:0] _RAND_1727;
  reg [31:0] _RAND_1728;
  reg [31:0] _RAND_1729;
  reg [31:0] _RAND_1730;
  reg [31:0] _RAND_1731;
  reg [31:0] _RAND_1732;
  reg [31:0] _RAND_1733;
`endif // RANDOMIZE_REG_INIT
  wire  master_clock; // @[Top-slr.scala 48:24]
  wire  master_reset; // @[Top-slr.scala 48:24]
  wire  master_io_global_start; // @[Top-slr.scala 48:24]
  wire  master_io_global_finish; // @[Top-slr.scala 48:24]
  wire  master_io_start; // @[Top-slr.scala 48:24]
  wire  master_io_frontier_flag; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_current_level; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_0; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_1; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_2; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_3; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_4; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_5; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_6; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_7; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_8; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_9; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_10; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_11; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_12; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_13; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_14; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_15; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_16; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_17; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_18; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_19; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_20; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_21; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_22; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_23; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_24; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_25; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_26; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_27; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_28; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_29; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_30; // @[Top-slr.scala 48:24]
  wire  master_io_mem_end_31; // @[Top-slr.scala 48:24]
  wire  master_io_p2_end; // @[Top-slr.scala 48:24]
  wire  master_io_end_0; // @[Top-slr.scala 48:24]
  wire  master_io_end_1; // @[Top-slr.scala 48:24]
  wire  master_io_end_2; // @[Top-slr.scala 48:24]
  wire  master_io_end_3; // @[Top-slr.scala 48:24]
  wire  master_io_end_4; // @[Top-slr.scala 48:24]
  wire  master_io_end_5; // @[Top-slr.scala 48:24]
  wire  master_io_end_6; // @[Top-slr.scala 48:24]
  wire  master_io_end_7; // @[Top-slr.scala 48:24]
  wire  master_io_end_8; // @[Top-slr.scala 48:24]
  wire  master_io_end_9; // @[Top-slr.scala 48:24]
  wire  master_io_end_10; // @[Top-slr.scala 48:24]
  wire  master_io_end_11; // @[Top-slr.scala 48:24]
  wire  master_io_end_12; // @[Top-slr.scala 48:24]
  wire  master_io_end_13; // @[Top-slr.scala 48:24]
  wire  master_io_end_14; // @[Top-slr.scala 48:24]
  wire  master_io_end_15; // @[Top-slr.scala 48:24]
  wire  master_io_end_16; // @[Top-slr.scala 48:24]
  wire  master_io_end_17; // @[Top-slr.scala 48:24]
  wire  master_io_end_18; // @[Top-slr.scala 48:24]
  wire  master_io_end_19; // @[Top-slr.scala 48:24]
  wire  master_io_end_20; // @[Top-slr.scala 48:24]
  wire  master_io_end_21; // @[Top-slr.scala 48:24]
  wire  master_io_end_22; // @[Top-slr.scala 48:24]
  wire  master_io_end_23; // @[Top-slr.scala 48:24]
  wire  master_io_end_24; // @[Top-slr.scala 48:24]
  wire  master_io_end_25; // @[Top-slr.scala 48:24]
  wire  master_io_end_26; // @[Top-slr.scala 48:24]
  wire  master_io_end_27; // @[Top-slr.scala 48:24]
  wire  master_io_end_28; // @[Top-slr.scala 48:24]
  wire  master_io_end_29; // @[Top-slr.scala 48:24]
  wire  master_io_end_30; // @[Top-slr.scala 48:24]
  wire  master_io_end_31; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_0; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_1; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_2; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_3; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_4; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_5; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_6; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_7; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_8; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_9; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_10; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_11; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_12; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_13; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_14; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_15; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_16; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_17; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_18; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_19; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_20; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_21; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_22; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_23; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_24; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_25; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_26; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_27; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_28; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_29; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_30; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_count_31; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_0; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_1; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_2; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_3; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_4; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_5; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_6; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_7; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_8; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_9; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_10; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_11; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_12; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_13; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_14; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_15; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_16; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_17; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_18; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_19; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_20; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_21; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_22; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_23; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_24; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_25; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_26; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_27; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_28; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_29; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_30; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_mem_count_31; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_0; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_1; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_2; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_3; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_4; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_5; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_6; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_7; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_8; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_9; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_10; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_11; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_12; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_13; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_14; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_15; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_16; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_17; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_18; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_19; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_20; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_21; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_22; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_23; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_24; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_25; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_26; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_27; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_28; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_29; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_30; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_frontier_pull_count_31; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_0; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_1; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_2; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_3; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_4; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_5; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_6; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_7; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_8; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_9; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_10; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_11; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_12; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_13; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_14; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_15; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_16; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_17; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_18; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_19; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_20; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_21; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_22; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_23; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_24; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_25; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_26; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_27; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_28; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_29; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_30; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_p2_pull_count_31; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_0; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_1; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_2; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_3; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_4; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_5; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_6; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_7; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_8; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_9; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_10; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_11; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_12; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_13; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_14; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_15; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_16; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_17; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_18; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_19; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_20; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_21; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_22; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_23; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_24; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_25; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_26; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_27; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_28; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_29; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_30; // @[Top-slr.scala 48:24]
  wire  master_io_last_iteration_state_31; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_levels_push_to_pull_level; // @[Top-slr.scala 48:24]
  wire [31:0] master_io_levels_pull_to_push_level; // @[Top-slr.scala 48:24]
  wire  master_io_push_or_pull; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_0; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_1; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_2; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_3; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_4; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_5; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_6; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_7; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_8; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_9; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_10; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_11; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_12; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_13; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_14; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_15; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_16; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_17; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_18; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_19; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_20; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_21; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_22; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_23; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_24; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_25; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_26; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_27; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_28; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_29; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_30; // @[Top-slr.scala 48:24]
  wire  master_io_init_bram_31; // @[Top-slr.scala 48:24]
  wire  SLR0_Mem_clock; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_reset; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_level; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_kernel_count; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_clock; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_reset_h; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_master_finish; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_node_num; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_push_or_pull_state; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_offsets_CSR_R_offset; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_offsets_CSR_C_offset; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_offsets_CSC_R_offset; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_offsets_CSC_C_offset; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_offsets_level_offset; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_0_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_0_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_0_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_1_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_1_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_1_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_2_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_2_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_2_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_3_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_3_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_3_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_4_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_4_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_4_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_5_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_5_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_5_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_6_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_6_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_6_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_7_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_7_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_7_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_8_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_8_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_8_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_9_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_9_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_9_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_10_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_10_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_10_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_11_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_11_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_11_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_12_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_12_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_12_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_13_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_13_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_13_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_14_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_14_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_14_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_15_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_15_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_15_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_16_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_16_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_16_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_17_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_17_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_17_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_18_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_18_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_18_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_19_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_19_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_19_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_20_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_20_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_20_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_21_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_21_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_21_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_22_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_22_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_22_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_23_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_23_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_23_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_24_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_24_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_24_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_25_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_25_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_25_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_26_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_26_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_26_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_27_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_27_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_27_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_28_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_28_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_28_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_29_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_29_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_29_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_30_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_30_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_30_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_31_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_31_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_31_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_32_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_32_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_32_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_33_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_33_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_33_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_34_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_34_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_34_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_35_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_35_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_35_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_36_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_36_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_36_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_37_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_37_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_37_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_38_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_38_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_38_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_39_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_39_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_39_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_40_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_40_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_40_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_41_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_41_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_41_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_42_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_42_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_42_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_43_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_43_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_43_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_44_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_44_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_44_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_45_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_45_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_45_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_46_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_46_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_46_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_47_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_47_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_47_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_48_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_48_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_48_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_49_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_49_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_49_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_50_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_50_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_50_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_51_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_51_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_51_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_52_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_52_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_52_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_53_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_53_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_53_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_54_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_54_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_54_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_55_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_55_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_55_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_56_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_56_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_56_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_57_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_57_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_57_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_58_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_58_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_58_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_59_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_59_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_59_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_60_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_60_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_60_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_61_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_61_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_61_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_62_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_62_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_62_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_63_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_63_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_63_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_64_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_64_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_64_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_65_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_65_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_65_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_66_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_66_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_66_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_67_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_67_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_67_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_68_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_68_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_68_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_69_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_69_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_69_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_70_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_70_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_70_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_71_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_71_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_71_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_72_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_72_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_72_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_73_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_73_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_73_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_74_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_74_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_74_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_75_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_75_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_75_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_76_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_76_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_76_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_77_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_77_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_77_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_78_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_78_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_78_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_79_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_79_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_79_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_80_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_80_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_80_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_81_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_81_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_81_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_82_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_82_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_82_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_83_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_83_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_83_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_84_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_84_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_84_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_85_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_85_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_85_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_86_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_86_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_86_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_87_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_87_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_87_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_88_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_88_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_88_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_89_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_89_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_89_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_90_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_90_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_90_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_91_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_91_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_91_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_92_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_92_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_92_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_93_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_93_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_93_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_94_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_94_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_94_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_95_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_95_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_95_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_96_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_96_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_96_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_97_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_97_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_97_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_98_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_98_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_98_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_99_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_99_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_99_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_100_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_100_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_100_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_101_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_101_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_101_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_102_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_102_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_102_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_103_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_103_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_103_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_104_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_104_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_104_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_105_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_105_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_105_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_106_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_106_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_106_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_107_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_107_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_107_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_108_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_108_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_108_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_109_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_109_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_109_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_110_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_110_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_110_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_111_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_111_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_111_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_112_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_112_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_112_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_113_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_113_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_113_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_114_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_114_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_114_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_115_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_115_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_115_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_116_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_116_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_116_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_117_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_117_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_117_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_118_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_118_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_118_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_119_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_119_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_119_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_120_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_120_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_120_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_121_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_121_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_121_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_122_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_122_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_122_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_123_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_123_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_123_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_124_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_124_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_124_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_125_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_125_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_125_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_126_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_126_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_126_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_127_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_R_array_index_127_valid; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_R_array_index_127_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_0; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_1; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_2; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_3; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_4; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_5; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_6; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_7; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_8; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_9; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_10; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_11; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_12; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_13; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_14; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_15; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_16; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_17; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_18; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_19; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_20; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_21; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_22; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_23; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_24; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_25; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_26; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_27; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_28; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_29; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_30; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_p1_end_31; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_0; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_1; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_2; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_3; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_4; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_5; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_6; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_7; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_8; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_9; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_10; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_11; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_12; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_13; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_14; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_15; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_16; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_17; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_18; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_19; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_20; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_21; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_22; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_23; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_24; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_25; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_26; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_27; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_28; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_29; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_30; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_31; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_32; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_33; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_34; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_35; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_36; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_37; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_38; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_39; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_40; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_41; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_42; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_43; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_44; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_45; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_46; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_47; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_48; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_49; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_50; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_51; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_52; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_53; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_54; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_55; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_56; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_57; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_58; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_59; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_60; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_61; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_62; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_63; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_64; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_65; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_66; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_67; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_68; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_69; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_70; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_71; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_72; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_73; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_74; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_75; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_76; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_77; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_78; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_79; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_80; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_81; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_82; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_83; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_84; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_85; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_86; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_87; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_88; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_89; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_90; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_91; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_92; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_93; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_94; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_95; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_96; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_97; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_98; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_99; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_100; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_101; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_102; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_103; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_104; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_105; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_106; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_107; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_108; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_109; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_110; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_111; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_112; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_113; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_114; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_115; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_116; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_117; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_118; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_119; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_120; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_121; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_122; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_123; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_124; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_125; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_126; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_uram_out_a_127; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_0; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_1; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_2; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_3; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_4; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_5; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_6; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_7; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_8; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_9; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_10; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_11; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_12; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_13; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_14; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_15; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_16; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_17; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_18; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_19; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_20; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_21; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_22; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_23; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_24; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_25; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_26; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_27; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_28; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_29; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_30; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_neighbour_cnt_31; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_0; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_1; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_2; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_3; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_4; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_5; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_6; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_7; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_8; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_9; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_10; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_11; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_12; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_13; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_14; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_15; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_16; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_17; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_18; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_19; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_20; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_21; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_22; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_23; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_24; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_25; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_26; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_27; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_28; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_29; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_30; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_mem_end_31; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_0_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_0_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_0_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_1_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_1_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_1_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_2_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_2_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_2_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_3_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_3_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_3_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_4_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_4_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_4_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_5_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_5_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_5_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_6_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_6_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_6_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_7_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_7_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_7_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_8_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_8_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_8_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_9_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_9_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_9_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_10_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_10_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_10_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_11_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_11_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_11_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_12_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_12_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_12_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_13_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_13_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_13_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_14_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_14_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_14_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_15_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_15_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_15_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_16_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_16_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_16_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_17_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_17_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_17_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_18_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_18_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_18_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_19_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_19_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_19_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_20_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_20_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_20_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_21_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_21_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_21_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_22_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_22_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_22_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_23_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_23_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_23_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_24_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_24_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_24_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_25_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_25_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_25_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_26_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_26_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_26_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_27_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_27_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_27_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_28_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_28_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_28_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_29_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_29_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_29_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_30_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_30_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_30_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_31_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_31_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_31_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_32_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_32_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_32_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_33_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_33_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_33_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_34_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_34_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_34_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_35_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_35_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_35_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_36_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_36_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_36_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_37_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_37_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_37_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_38_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_38_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_38_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_39_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_39_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_39_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_40_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_40_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_40_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_41_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_41_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_41_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_42_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_42_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_42_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_43_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_43_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_43_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_44_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_44_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_44_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_45_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_45_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_45_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_46_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_46_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_46_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_47_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_47_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_47_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_48_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_48_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_48_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_49_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_49_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_49_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_50_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_50_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_50_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_51_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_51_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_51_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_52_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_52_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_52_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_53_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_53_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_53_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_54_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_54_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_54_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_55_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_55_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_55_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_56_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_56_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_56_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_57_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_57_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_57_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_58_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_58_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_58_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_59_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_59_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_59_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_60_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_60_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_60_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_61_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_61_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_61_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_62_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_62_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_62_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_63_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_63_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_63_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_64_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_64_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_64_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_65_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_65_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_65_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_66_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_66_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_66_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_67_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_67_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_67_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_68_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_68_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_68_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_69_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_69_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_69_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_70_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_70_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_70_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_71_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_71_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_71_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_72_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_72_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_72_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_73_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_73_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_73_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_74_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_74_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_74_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_75_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_75_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_75_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_76_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_76_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_76_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_77_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_77_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_77_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_78_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_78_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_78_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_79_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_79_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_79_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_80_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_80_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_80_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_81_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_81_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_81_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_82_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_82_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_82_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_83_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_83_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_83_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_84_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_84_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_84_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_85_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_85_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_85_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_86_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_86_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_86_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_87_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_87_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_87_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_88_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_88_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_88_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_89_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_89_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_89_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_90_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_90_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_90_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_91_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_91_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_91_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_92_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_92_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_92_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_93_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_93_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_93_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_94_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_94_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_94_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_95_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_95_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_95_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_96_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_96_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_96_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_97_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_97_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_97_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_98_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_98_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_98_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_99_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_99_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_99_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_100_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_100_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_100_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_101_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_101_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_101_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_102_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_102_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_102_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_103_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_103_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_103_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_104_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_104_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_104_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_105_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_105_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_105_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_106_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_106_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_106_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_107_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_107_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_107_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_108_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_108_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_108_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_109_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_109_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_109_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_110_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_110_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_110_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_111_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_111_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_111_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_112_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_112_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_112_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_113_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_113_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_113_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_114_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_114_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_114_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_115_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_115_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_115_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_116_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_116_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_116_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_117_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_117_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_117_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_118_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_118_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_118_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_119_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_119_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_119_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_120_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_120_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_120_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_121_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_121_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_121_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_122_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_122_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_122_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_123_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_123_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_123_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_124_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_124_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_124_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_125_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_125_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_125_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_126_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_126_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_126_bits; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_127_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_neighbours_127_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_neighbours_127_bits; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_0; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_1; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_2; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_3; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_4; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_5; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_6; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_7; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_8; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_9; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_10; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_11; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_12; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_13; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_14; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_15; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_16; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_17; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_18; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_19; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_20; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_21; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_22; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_23; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_24; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_25; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_26; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_27; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_28; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_29; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_30; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_31; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_32; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_33; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_34; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_35; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_36; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_37; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_38; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_39; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_40; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_41; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_42; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_43; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_44; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_45; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_46; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_47; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_48; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_49; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_50; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_51; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_52; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_53; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_54; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_55; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_56; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_57; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_58; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_59; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_60; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_61; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_62; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_63; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_64; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_65; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_66; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_67; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_68; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_69; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_70; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_71; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_72; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_73; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_74; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_75; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_76; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_77; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_78; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_79; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_80; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_81; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_82; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_83; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_84; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_85; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_86; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_87; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_88; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_89; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_90; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_91; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_92; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_93; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_94; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_95; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_96; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_97; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_98; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_99; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_100; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_101; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_102; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_103; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_104; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_105; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_106; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_107; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_108; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_109; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_110; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_111; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_112; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_113; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_114; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_115; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_116; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_117; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_118; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_119; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_120; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_121; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_122; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_123; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_124; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_125; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_126; // @[Top-slr.scala 49:26]
  wire [19:0] SLR0_Mem_io_uram_addr_a_127; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_0; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_1; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_2; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_3; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_4; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_5; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_6; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_7; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_8; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_9; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_10; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_11; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_12; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_13; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_14; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_15; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_16; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_17; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_18; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_19; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_20; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_21; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_22; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_23; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_24; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_25; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_26; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_27; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_28; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_29; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_30; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_write_finish_31; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_0_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_0_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_0_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_0_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_0_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_0_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_0_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_0_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_0_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_0_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_0_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_0_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_0_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_0_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_1_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_1_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_1_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_1_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_1_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_1_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_1_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_1_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_1_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_1_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_1_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_1_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_1_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_1_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_2_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_2_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_2_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_2_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_2_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_2_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_2_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_2_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_2_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_2_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_2_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_2_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_2_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_2_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_3_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_3_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_3_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_3_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_3_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_3_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_3_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_3_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_3_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_3_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_3_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_3_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_3_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_3_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_4_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_4_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_4_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_4_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_4_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_4_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_4_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_4_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_4_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_4_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_4_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_4_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_4_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_4_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_5_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_5_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_5_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_5_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_5_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_5_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_5_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_5_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_5_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_5_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_5_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_5_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_5_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_5_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_6_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_6_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_6_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_6_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_6_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_6_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_6_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_6_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_6_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_6_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_6_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_6_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_6_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_6_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_7_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_7_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_7_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_7_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_7_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_7_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_7_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_7_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_7_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_7_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_7_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_7_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_7_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_7_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_8_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_8_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_8_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_8_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_8_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_8_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_8_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_8_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_8_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_8_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_8_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_8_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_8_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_8_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_9_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_9_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_9_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_9_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_9_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_9_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_9_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_9_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_9_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_9_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_9_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_9_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_9_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_9_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_10_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_10_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_10_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_10_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_10_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_10_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_10_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_10_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_10_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_10_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_10_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_10_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_10_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_10_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_11_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_11_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_11_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_11_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_11_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_11_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_11_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_11_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_11_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_11_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_11_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_11_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_11_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_11_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_12_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_12_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_12_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_12_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_12_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_12_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_12_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_12_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_12_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_12_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_12_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_12_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_12_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_12_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_13_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_13_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_13_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_13_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_13_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_13_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_13_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_13_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_13_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_13_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_13_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_13_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_13_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_13_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_14_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_14_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_14_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_14_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_14_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_14_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_14_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_14_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_14_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_14_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_14_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_14_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_14_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_14_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_15_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_15_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_15_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_15_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_15_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_15_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_15_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_15_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_15_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_15_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_15_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_15_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_15_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_15_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_16_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_16_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_16_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_16_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_16_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_16_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_16_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_16_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_16_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_16_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_16_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_16_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_16_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_16_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_17_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_17_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_17_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_17_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_17_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_17_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_17_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_17_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_17_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_17_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_17_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_17_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_17_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_17_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_18_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_18_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_18_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_18_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_18_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_18_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_18_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_18_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_18_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_18_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_18_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_18_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_18_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_18_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_19_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_19_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_19_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_19_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_19_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_19_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_19_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_19_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_19_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_19_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_19_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_19_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_19_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_19_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_20_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_20_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_20_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_20_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_20_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_20_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_20_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_20_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_20_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_20_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_20_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_20_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_20_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_20_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_21_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_21_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_21_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_21_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_21_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_21_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_21_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_21_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_21_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_21_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_21_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_21_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_21_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_21_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_22_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_22_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_22_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_22_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_22_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_22_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_22_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_22_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_22_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_22_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_22_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_22_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_22_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_22_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_23_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_23_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_23_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_23_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_23_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_23_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_23_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_23_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_23_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_23_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_23_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_23_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_23_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_23_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_24_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_24_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_24_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_24_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_24_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_24_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_24_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_24_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_24_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_24_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_24_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_24_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_24_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_24_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_25_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_25_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_25_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_25_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_25_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_25_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_25_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_25_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_25_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_25_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_25_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_25_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_25_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_25_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_26_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_26_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_26_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_26_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_26_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_26_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_26_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_26_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_26_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_26_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_26_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_26_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_26_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_26_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_27_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_27_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_27_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_27_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_27_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_27_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_27_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_27_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_27_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_27_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_27_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_27_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_27_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_27_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_28_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_28_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_28_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_28_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_28_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_28_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_28_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_28_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_28_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_28_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_28_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_28_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_28_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_28_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_29_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_29_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_29_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_29_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_29_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_29_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_29_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_29_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_29_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_29_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_29_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_29_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_29_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_29_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_30_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_30_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_30_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_30_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_30_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_30_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_30_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_30_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_30_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_30_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_30_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_30_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_30_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_30_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_31_writeAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_31_writeAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_31_writeAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_31_writeData_bits_data; // @[Top-slr.scala 49:26]
  wire [31:0] SLR0_Mem_io_HBM_interface_31_writeData_bits_strb; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeData_bits_last; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeResp_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_writeResp_valid; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_31_writeResp_bits_id; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_31_writeResp_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_readAddr_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_readAddr_valid; // @[Top-slr.scala 49:26]
  wire [63:0] SLR0_Mem_io_HBM_interface_31_readAddr_bits_addr; // @[Top-slr.scala 49:26]
  wire [7:0] SLR0_Mem_io_HBM_interface_31_readAddr_bits_len; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_31_readAddr_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_readData_ready; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_readData_valid; // @[Top-slr.scala 49:26]
  wire [255:0] SLR0_Mem_io_HBM_interface_31_readData_bits_data; // @[Top-slr.scala 49:26]
  wire [5:0] SLR0_Mem_io_HBM_interface_31_readData_bits_id; // @[Top-slr.scala 49:26]
  wire  SLR0_Mem_io_HBM_interface_31_readData_bits_last; // @[Top-slr.scala 49:26]
  wire [1:0] SLR0_Mem_io_HBM_interface_31_readData_bits_resp; // @[Top-slr.scala 49:26]
  wire  SLR1_clock; // @[Top-slr.scala 51:22]
  wire  SLR1_reset; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_end; // @[Top-slr.scala 51:22]
  wire  SLR1_io_start; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_flag; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_level; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_offsets_CSR_R_offset; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_offsets_CSR_C_offset; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_offsets_CSC_R_offset; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_offsets_CSC_C_offset; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_offsets_level_offset; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_node_num; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_root; // @[Top-slr.scala 51:22]
  wire  SLR1_io_push_or_pull; // @[Top-slr.scala 51:22]
  wire  SLR1_io_start_init; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_0; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_1; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_2; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_3; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_4; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_5; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_6; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_7; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_8; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_9; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_10; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_11; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_12; // @[Top-slr.scala 51:22]
  wire  SLR1_io_end_13; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_0; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_1; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_2; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_3; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_4; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_5; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_6; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_7; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_8; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_9; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_10; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_11; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_12; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_count_13; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_0; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_1; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_2; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_3; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_4; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_5; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_6; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_7; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_8; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_9; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_10; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_11; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_12; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_pull_count_13; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_0; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_1; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_2; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_3; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_4; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_5; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_6; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_7; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_8; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_9; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_10; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_11; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_12; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_pull_count_13; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_0; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_1; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_2; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_3; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_4; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_5; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_6; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_7; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_8; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_9; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_10; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_11; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_12; // @[Top-slr.scala 51:22]
  wire  SLR1_io_last_iteration_13; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_0; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_1; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_2; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_3; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_4; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_5; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_6; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_7; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_8; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_9; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_10; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_11; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_12; // @[Top-slr.scala 51:22]
  wire  SLR1_io_init_bram_13; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_0_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_0_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_0_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_1_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_1_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_1_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_2_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_2_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_2_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_3_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_3_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_3_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_4_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_4_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_4_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_5_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_5_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_5_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_6_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_6_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_6_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_7_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_7_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_7_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_8_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_8_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_8_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_9_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_9_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_9_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_10_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_10_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_10_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_11_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_11_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_11_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_12_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_12_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_12_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_13_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_13_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_13_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_14_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_14_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_14_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_15_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_15_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_15_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_16_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_16_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_16_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_17_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_17_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_17_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_18_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_18_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_18_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_19_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_19_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_19_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_20_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_20_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_20_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_21_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_21_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_21_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_22_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_22_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_22_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_23_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_23_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_23_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_24_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_24_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_24_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_25_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_25_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_25_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_26_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_26_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_26_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_27_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_27_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_27_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_28_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_28_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_28_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_29_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_29_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_29_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_30_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_30_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_30_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_31_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_31_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_31_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_32_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_32_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_32_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_33_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_33_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_33_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_34_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_34_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_34_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_35_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_35_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_35_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_36_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_36_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_36_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_37_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_37_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_37_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_38_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_38_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_38_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_39_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_39_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_39_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_40_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_40_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_40_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_41_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_41_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_41_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_42_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_42_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_42_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_43_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_43_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_43_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_44_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_44_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_44_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_45_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_45_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_45_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_46_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_46_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_46_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_47_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_47_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_47_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_48_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_48_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_48_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_49_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_49_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_49_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_50_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_50_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_50_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_51_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_51_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_51_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_52_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_52_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_52_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_53_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_53_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_53_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_54_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_54_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_54_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_55_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_in_55_valid; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_p2_in_55_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_0_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_0_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_0_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_1_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_1_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_1_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_2_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_2_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_2_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_3_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_3_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_3_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_4_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_4_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_4_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_5_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_5_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_5_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_6_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_6_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_6_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_7_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_7_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_7_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_8_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_8_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_8_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_9_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_9_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_9_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_10_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_10_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_10_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_11_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_11_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_11_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_12_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_12_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_12_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_13_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_13_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_13_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_14_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_14_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_14_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_15_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_15_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_15_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_16_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_16_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_16_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_17_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_17_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_17_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_18_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_18_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_18_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_19_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_19_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_19_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_20_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_20_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_20_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_21_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_21_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_21_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_22_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_22_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_22_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_23_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_23_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_23_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_24_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_24_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_24_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_25_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_25_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_25_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_26_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_26_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_26_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_27_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_27_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_27_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_28_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_28_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_28_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_29_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_29_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_29_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_30_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_30_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_30_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_31_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_31_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_31_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_32_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_32_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_32_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_33_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_33_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_33_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_34_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_34_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_34_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_35_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_35_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_35_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_36_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_36_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_36_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_37_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_37_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_37_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_38_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_38_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_38_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_39_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_39_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_39_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_40_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_40_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_40_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_41_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_41_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_41_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_42_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_42_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_42_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_43_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_43_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_43_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_44_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_44_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_44_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_45_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_45_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_45_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_46_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_46_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_46_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_47_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_47_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_47_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_48_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_48_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_48_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_49_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_49_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_49_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_50_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_50_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_50_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_51_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_51_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_51_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_52_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_52_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_52_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_53_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_53_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_53_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_54_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_54_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_54_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_55_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_frontier_in_55_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_frontier_in_55_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_0_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_0_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_0_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_1_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_1_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_1_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_2_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_2_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_2_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_3_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_3_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_3_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_4_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_4_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_4_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_5_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_5_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_5_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_6_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_6_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_6_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_7_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_7_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_7_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_8_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_8_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_8_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_9_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_9_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_9_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_10_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_10_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_10_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_11_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_11_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_11_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_12_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_12_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_12_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_13_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_13_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_13_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_14_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_14_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_14_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_15_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_15_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_15_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_16_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_16_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_16_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_17_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_17_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_17_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_18_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_18_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_18_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_19_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_19_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_19_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_20_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_20_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_20_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_21_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_21_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_21_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_22_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_22_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_22_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_23_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_23_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_23_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_24_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_24_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_24_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_25_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_25_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_25_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_26_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_26_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_26_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_27_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_27_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_27_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_28_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_28_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_28_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_29_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_29_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_29_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_30_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_30_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_30_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_31_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_31_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_31_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_32_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_32_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_32_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_33_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_33_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_33_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_34_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_34_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_34_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_35_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_35_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_35_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_36_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_36_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_36_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_37_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_37_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_37_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_38_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_38_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_38_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_39_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_39_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_39_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_40_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_40_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_40_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_41_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_41_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_41_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_42_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_42_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_42_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_43_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_43_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_43_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_44_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_44_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_44_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_45_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_45_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_45_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_46_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_46_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_46_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_47_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_47_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_47_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_48_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_48_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_48_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_49_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_49_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_49_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_50_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_50_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_50_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_51_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_51_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_51_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_52_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_52_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_52_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_53_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_53_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_53_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_54_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_54_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_54_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_55_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p2_out_55_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_p2_out_55_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_0_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_0_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_0_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_1_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_1_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_1_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_2_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_2_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_2_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_3_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_3_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_3_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_4_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_4_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_4_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_5_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_5_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_5_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_6_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_6_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_6_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_7_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_7_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_7_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_8_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_8_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_8_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_9_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_9_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_9_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_10_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_10_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_10_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_11_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_11_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_11_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_12_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_12_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_12_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_13_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_13_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_13_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_14_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_14_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_14_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_15_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_15_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_15_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_16_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_16_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_16_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_17_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_17_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_17_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_18_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_18_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_18_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_19_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_19_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_19_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_20_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_20_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_20_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_21_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_21_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_21_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_22_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_22_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_22_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_23_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_23_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_23_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_24_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_24_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_24_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_25_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_25_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_25_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_26_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_26_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_26_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_27_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_27_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_27_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_28_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_28_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_28_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_29_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_29_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_29_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_30_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_30_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_30_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_31_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_31_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_31_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_32_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_32_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_32_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_33_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_33_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_33_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_34_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_34_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_34_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_35_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_35_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_35_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_36_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_36_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_36_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_37_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_37_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_37_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_38_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_38_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_38_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_39_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_39_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_39_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_40_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_40_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_40_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_41_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_41_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_41_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_42_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_42_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_42_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_43_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_43_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_43_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_44_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_44_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_44_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_45_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_45_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_45_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_46_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_46_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_46_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_47_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_47_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_47_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_48_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_48_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_48_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_49_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_49_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_49_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_50_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_50_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_50_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_51_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_51_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_51_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_52_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_52_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_52_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_53_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_53_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_53_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_54_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_54_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_54_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_55_ready; // @[Top-slr.scala 51:22]
  wire  SLR1_io_R_array_index_55_valid; // @[Top-slr.scala 51:22]
  wire [31:0] SLR1_io_R_array_index_55_bits; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_0; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_1; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_2; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_3; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_4; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_5; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_6; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_7; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_8; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_9; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_10; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_11; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_12; // @[Top-slr.scala 51:22]
  wire  SLR1_io_p1_end_13; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_0; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_1; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_2; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_3; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_4; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_5; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_6; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_7; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_8; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_9; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_10; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_11; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_12; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_13; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_14; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_15; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_16; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_17; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_18; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_19; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_20; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_21; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_22; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_23; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_24; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_25; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_26; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_27; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_28; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_29; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_30; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_31; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_32; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_33; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_34; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_35; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_36; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_37; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_38; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_39; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_40; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_41; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_42; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_43; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_44; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_45; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_46; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_47; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_48; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_49; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_50; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_51; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_52; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_53; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_54; // @[Top-slr.scala 51:22]
  wire [63:0] SLR1_io_uram_out_a_55; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_0; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_1; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_2; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_3; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_4; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_5; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_6; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_7; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_8; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_9; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_10; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_11; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_12; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_13; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_14; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_15; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_16; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_17; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_18; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_19; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_20; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_21; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_22; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_23; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_24; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_25; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_26; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_27; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_28; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_29; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_30; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_31; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_32; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_33; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_34; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_35; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_36; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_37; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_38; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_39; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_40; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_41; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_42; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_43; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_44; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_45; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_46; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_47; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_48; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_49; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_50; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_51; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_52; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_53; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_54; // @[Top-slr.scala 51:22]
  wire [19:0] SLR1_io_uram_addr_a_55; // @[Top-slr.scala 51:22]
  wire  SLR2_clock; // @[Top-slr.scala 52:23]
  wire  SLR2_reset; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_end; // @[Top-slr.scala 52:23]
  wire  SLR2_io_start; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_flag; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_level; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_offsets_CSR_R_offset; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_offsets_CSR_C_offset; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_offsets_CSC_R_offset; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_offsets_CSC_C_offset; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_offsets_level_offset; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_node_num; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_root; // @[Top-slr.scala 52:23]
  wire  SLR2_io_push_or_pull; // @[Top-slr.scala 52:23]
  wire  SLR2_io_start_init; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_0; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_1; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_2; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_3; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_4; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_5; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_6; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_7; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_8; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_9; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_10; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_11; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_12; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_13; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_14; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_15; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_16; // @[Top-slr.scala 52:23]
  wire  SLR2_io_end_17; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_0; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_1; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_2; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_3; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_4; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_5; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_6; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_7; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_8; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_9; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_10; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_11; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_12; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_13; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_14; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_15; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_16; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_count_17; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_0; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_1; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_2; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_3; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_4; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_5; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_6; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_7; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_8; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_9; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_10; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_11; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_12; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_13; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_14; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_15; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_16; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_pull_count_17; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_0; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_1; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_2; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_3; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_4; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_5; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_6; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_7; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_8; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_9; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_10; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_11; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_12; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_13; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_14; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_15; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_16; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_pull_count_17; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_0; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_1; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_2; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_3; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_4; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_5; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_6; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_7; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_8; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_9; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_10; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_11; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_12; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_13; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_14; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_15; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_16; // @[Top-slr.scala 52:23]
  wire  SLR2_io_last_iteration_17; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_0; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_1; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_2; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_3; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_4; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_5; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_6; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_7; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_8; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_9; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_10; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_11; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_12; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_13; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_14; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_15; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_16; // @[Top-slr.scala 52:23]
  wire  SLR2_io_init_bram_17; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_0_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_0_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_0_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_1_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_1_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_1_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_2_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_2_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_2_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_3_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_3_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_3_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_4_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_4_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_4_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_5_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_5_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_5_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_6_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_6_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_6_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_7_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_7_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_7_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_8_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_8_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_8_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_9_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_9_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_9_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_10_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_10_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_10_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_11_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_11_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_11_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_12_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_12_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_12_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_13_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_13_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_13_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_14_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_14_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_14_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_15_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_15_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_15_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_16_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_16_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_16_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_17_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_17_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_17_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_18_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_18_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_18_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_19_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_19_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_19_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_20_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_20_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_20_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_21_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_21_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_21_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_22_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_22_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_22_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_23_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_23_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_23_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_24_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_24_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_24_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_25_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_25_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_25_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_26_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_26_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_26_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_27_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_27_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_27_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_28_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_28_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_28_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_29_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_29_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_29_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_30_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_30_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_30_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_31_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_31_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_31_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_32_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_32_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_32_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_33_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_33_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_33_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_34_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_34_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_34_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_35_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_35_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_35_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_36_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_36_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_36_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_37_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_37_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_37_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_38_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_38_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_38_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_39_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_39_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_39_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_40_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_40_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_40_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_41_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_41_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_41_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_42_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_42_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_42_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_43_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_43_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_43_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_44_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_44_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_44_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_45_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_45_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_45_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_46_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_46_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_46_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_47_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_47_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_47_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_48_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_48_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_48_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_49_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_49_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_49_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_50_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_50_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_50_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_51_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_51_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_51_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_52_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_52_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_52_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_53_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_53_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_53_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_54_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_54_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_54_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_55_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_55_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_55_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_56_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_56_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_56_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_57_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_57_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_57_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_58_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_58_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_58_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_59_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_59_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_59_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_60_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_60_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_60_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_61_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_61_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_61_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_62_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_62_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_62_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_63_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_63_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_63_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_64_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_64_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_64_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_65_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_65_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_65_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_66_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_66_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_66_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_67_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_67_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_67_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_68_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_68_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_68_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_69_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_69_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_69_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_70_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_70_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_70_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_71_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_in_71_valid; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_p2_in_71_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_0_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_0_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_0_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_1_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_1_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_1_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_2_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_2_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_2_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_3_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_3_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_3_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_4_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_4_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_4_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_5_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_5_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_5_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_6_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_6_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_6_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_7_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_7_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_7_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_8_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_8_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_8_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_9_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_9_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_9_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_10_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_10_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_10_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_11_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_11_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_11_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_12_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_12_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_12_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_13_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_13_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_13_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_14_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_14_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_14_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_15_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_15_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_15_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_16_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_16_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_16_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_17_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_17_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_17_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_18_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_18_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_18_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_19_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_19_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_19_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_20_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_20_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_20_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_21_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_21_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_21_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_22_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_22_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_22_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_23_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_23_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_23_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_24_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_24_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_24_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_25_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_25_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_25_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_26_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_26_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_26_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_27_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_27_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_27_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_28_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_28_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_28_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_29_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_29_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_29_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_30_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_30_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_30_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_31_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_31_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_31_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_32_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_32_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_32_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_33_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_33_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_33_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_34_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_34_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_34_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_35_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_35_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_35_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_36_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_36_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_36_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_37_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_37_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_37_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_38_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_38_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_38_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_39_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_39_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_39_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_40_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_40_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_40_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_41_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_41_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_41_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_42_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_42_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_42_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_43_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_43_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_43_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_44_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_44_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_44_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_45_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_45_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_45_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_46_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_46_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_46_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_47_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_47_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_47_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_48_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_48_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_48_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_49_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_49_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_49_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_50_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_50_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_50_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_51_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_51_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_51_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_52_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_52_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_52_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_53_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_53_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_53_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_54_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_54_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_54_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_55_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_55_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_55_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_56_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_56_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_56_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_57_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_57_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_57_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_58_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_58_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_58_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_59_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_59_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_59_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_60_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_60_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_60_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_61_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_61_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_61_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_62_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_62_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_62_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_63_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_63_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_63_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_64_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_64_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_64_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_65_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_65_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_65_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_66_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_66_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_66_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_67_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_67_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_67_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_68_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_68_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_68_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_69_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_69_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_69_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_70_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_70_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_70_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_71_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_frontier_in_71_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_frontier_in_71_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_0_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_0_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_0_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_1_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_1_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_1_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_2_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_2_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_2_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_3_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_3_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_3_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_4_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_4_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_4_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_5_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_5_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_5_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_6_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_6_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_6_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_7_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_7_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_7_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_8_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_8_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_8_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_9_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_9_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_9_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_10_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_10_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_10_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_11_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_11_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_11_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_12_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_12_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_12_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_13_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_13_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_13_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_14_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_14_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_14_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_15_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_15_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_15_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_16_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_16_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_16_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_17_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_17_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_17_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_18_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_18_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_18_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_19_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_19_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_19_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_20_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_20_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_20_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_21_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_21_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_21_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_22_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_22_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_22_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_23_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_23_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_23_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_24_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_24_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_24_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_25_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_25_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_25_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_26_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_26_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_26_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_27_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_27_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_27_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_28_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_28_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_28_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_29_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_29_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_29_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_30_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_30_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_30_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_31_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_31_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_31_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_32_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_32_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_32_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_33_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_33_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_33_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_34_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_34_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_34_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_35_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_35_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_35_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_36_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_36_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_36_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_37_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_37_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_37_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_38_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_38_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_38_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_39_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_39_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_39_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_40_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_40_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_40_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_41_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_41_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_41_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_42_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_42_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_42_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_43_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_43_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_43_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_44_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_44_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_44_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_45_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_45_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_45_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_46_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_46_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_46_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_47_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_47_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_47_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_48_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_48_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_48_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_49_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_49_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_49_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_50_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_50_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_50_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_51_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_51_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_51_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_52_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_52_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_52_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_53_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_53_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_53_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_54_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_54_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_54_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_55_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_55_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_55_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_56_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_56_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_56_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_57_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_57_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_57_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_58_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_58_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_58_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_59_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_59_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_59_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_60_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_60_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_60_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_61_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_61_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_61_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_62_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_62_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_62_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_63_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_63_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_63_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_64_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_64_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_64_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_65_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_65_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_65_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_66_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_66_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_66_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_67_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_67_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_67_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_68_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_68_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_68_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_69_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_69_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_69_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_70_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_70_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_70_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_71_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p2_out_71_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_p2_out_71_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_0_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_0_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_0_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_1_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_1_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_1_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_2_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_2_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_2_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_3_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_3_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_3_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_4_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_4_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_4_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_5_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_5_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_5_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_6_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_6_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_6_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_7_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_7_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_7_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_8_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_8_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_8_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_9_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_9_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_9_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_10_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_10_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_10_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_11_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_11_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_11_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_12_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_12_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_12_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_13_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_13_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_13_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_14_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_14_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_14_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_15_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_15_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_15_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_16_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_16_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_16_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_17_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_17_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_17_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_18_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_18_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_18_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_19_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_19_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_19_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_20_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_20_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_20_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_21_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_21_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_21_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_22_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_22_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_22_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_23_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_23_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_23_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_24_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_24_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_24_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_25_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_25_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_25_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_26_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_26_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_26_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_27_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_27_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_27_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_28_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_28_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_28_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_29_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_29_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_29_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_30_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_30_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_30_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_31_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_31_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_31_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_32_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_32_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_32_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_33_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_33_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_33_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_34_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_34_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_34_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_35_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_35_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_35_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_36_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_36_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_36_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_37_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_37_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_37_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_38_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_38_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_38_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_39_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_39_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_39_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_40_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_40_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_40_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_41_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_41_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_41_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_42_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_42_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_42_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_43_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_43_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_43_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_44_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_44_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_44_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_45_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_45_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_45_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_46_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_46_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_46_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_47_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_47_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_47_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_48_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_48_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_48_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_49_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_49_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_49_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_50_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_50_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_50_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_51_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_51_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_51_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_52_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_52_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_52_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_53_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_53_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_53_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_54_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_54_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_54_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_55_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_55_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_55_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_56_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_56_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_56_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_57_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_57_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_57_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_58_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_58_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_58_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_59_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_59_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_59_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_60_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_60_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_60_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_61_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_61_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_61_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_62_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_62_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_62_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_63_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_63_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_63_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_64_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_64_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_64_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_65_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_65_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_65_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_66_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_66_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_66_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_67_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_67_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_67_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_68_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_68_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_68_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_69_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_69_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_69_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_70_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_70_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_70_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_71_ready; // @[Top-slr.scala 52:23]
  wire  SLR2_io_R_array_index_71_valid; // @[Top-slr.scala 52:23]
  wire [31:0] SLR2_io_R_array_index_71_bits; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_0; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_1; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_2; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_3; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_4; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_5; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_6; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_7; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_8; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_9; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_10; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_11; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_12; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_13; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_14; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_15; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_16; // @[Top-slr.scala 52:23]
  wire  SLR2_io_p1_end_17; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_0; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_1; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_2; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_3; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_4; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_5; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_6; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_7; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_8; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_9; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_10; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_11; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_12; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_13; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_14; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_15; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_16; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_17; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_18; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_19; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_20; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_21; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_22; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_23; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_24; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_25; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_26; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_27; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_28; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_29; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_30; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_31; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_32; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_33; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_34; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_35; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_36; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_37; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_38; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_39; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_40; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_41; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_42; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_43; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_44; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_45; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_46; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_47; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_48; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_49; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_50; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_51; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_52; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_53; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_54; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_55; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_56; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_57; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_58; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_59; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_60; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_61; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_62; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_63; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_64; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_65; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_66; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_67; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_68; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_69; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_70; // @[Top-slr.scala 52:23]
  wire [63:0] SLR2_io_uram_out_a_71; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_0; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_1; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_2; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_3; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_4; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_5; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_6; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_7; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_8; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_9; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_10; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_11; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_12; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_13; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_14; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_15; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_16; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_17; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_18; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_19; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_20; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_21; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_22; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_23; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_24; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_25; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_26; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_27; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_28; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_29; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_30; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_31; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_32; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_33; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_34; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_35; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_36; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_37; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_38; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_39; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_40; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_41; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_42; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_43; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_44; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_45; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_46; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_47; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_48; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_49; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_50; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_51; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_52; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_53; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_54; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_55; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_56; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_57; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_58; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_59; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_60; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_61; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_62; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_63; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_64; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_65; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_66; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_67; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_68; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_69; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_70; // @[Top-slr.scala 52:23]
  wire [19:0] SLR2_io_uram_addr_a_71; // @[Top-slr.scala 52:23]
  wire  crossbar_array_mem_clock; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_reset; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_0_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_0_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_0_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_1_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_1_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_1_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_2_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_2_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_2_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_3_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_3_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_3_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_4_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_4_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_4_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_5_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_5_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_5_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_6_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_6_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_6_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_7_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_7_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_7_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_8_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_8_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_8_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_9_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_9_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_9_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_10_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_10_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_10_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_11_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_11_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_11_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_12_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_12_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_12_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_13_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_13_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_13_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_14_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_14_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_14_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_15_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_15_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_15_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_16_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_16_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_16_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_17_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_17_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_17_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_18_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_18_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_18_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_19_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_19_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_19_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_20_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_20_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_20_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_21_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_21_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_21_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_22_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_22_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_22_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_23_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_23_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_23_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_24_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_24_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_24_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_25_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_25_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_25_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_26_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_26_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_26_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_27_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_27_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_27_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_28_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_28_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_28_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_29_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_29_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_29_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_30_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_30_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_30_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_31_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_31_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_31_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_32_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_32_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_32_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_33_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_33_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_33_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_34_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_34_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_34_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_35_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_35_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_35_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_36_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_36_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_36_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_37_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_37_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_37_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_38_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_38_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_38_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_39_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_39_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_39_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_40_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_40_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_40_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_41_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_41_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_41_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_42_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_42_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_42_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_43_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_43_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_43_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_44_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_44_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_44_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_45_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_45_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_45_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_46_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_46_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_46_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_47_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_47_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_47_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_48_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_48_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_48_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_49_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_49_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_49_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_50_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_50_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_50_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_51_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_51_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_51_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_52_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_52_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_52_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_53_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_53_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_53_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_54_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_54_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_54_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_55_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_55_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_55_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_56_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_56_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_56_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_57_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_57_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_57_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_58_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_58_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_58_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_59_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_59_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_59_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_60_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_60_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_60_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_61_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_61_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_61_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_62_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_62_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_62_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_63_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_63_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_63_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_64_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_64_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_64_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_65_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_65_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_65_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_66_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_66_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_66_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_67_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_67_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_67_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_68_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_68_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_68_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_69_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_69_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_69_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_70_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_70_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_70_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_71_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_71_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_71_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_72_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_72_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_72_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_73_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_73_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_73_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_74_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_74_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_74_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_75_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_75_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_75_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_76_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_76_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_76_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_77_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_77_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_77_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_78_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_78_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_78_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_79_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_79_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_79_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_80_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_80_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_80_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_81_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_81_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_81_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_82_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_82_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_82_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_83_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_83_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_83_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_84_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_84_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_84_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_85_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_85_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_85_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_86_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_86_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_86_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_87_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_87_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_87_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_88_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_88_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_88_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_89_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_89_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_89_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_90_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_90_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_90_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_91_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_91_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_91_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_92_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_92_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_92_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_93_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_93_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_93_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_94_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_94_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_94_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_95_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_95_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_95_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_96_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_96_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_96_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_97_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_97_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_97_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_98_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_98_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_98_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_99_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_99_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_99_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_100_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_100_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_100_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_101_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_101_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_101_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_102_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_102_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_102_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_103_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_103_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_103_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_104_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_104_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_104_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_105_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_105_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_105_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_106_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_106_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_106_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_107_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_107_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_107_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_108_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_108_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_108_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_109_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_109_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_109_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_110_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_110_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_110_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_111_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_111_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_111_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_112_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_112_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_112_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_113_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_113_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_113_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_114_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_114_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_114_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_115_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_115_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_115_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_116_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_116_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_116_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_117_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_117_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_117_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_118_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_118_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_118_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_119_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_119_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_119_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_120_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_120_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_120_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_121_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_121_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_121_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_122_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_122_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_122_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_123_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_123_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_123_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_124_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_124_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_124_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_125_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_125_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_125_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_126_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_126_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_126_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_127_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_in_127_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_in_127_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_0_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_0_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_0_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_1_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_1_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_1_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_2_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_2_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_2_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_3_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_3_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_3_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_4_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_4_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_4_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_5_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_5_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_5_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_6_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_6_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_6_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_7_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_7_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_7_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_8_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_8_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_8_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_9_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_9_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_9_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_10_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_10_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_10_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_11_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_11_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_11_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_12_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_12_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_12_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_13_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_13_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_13_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_14_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_14_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_14_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_15_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_15_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_15_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_16_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_16_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_16_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_17_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_17_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_17_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_18_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_18_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_18_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_19_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_19_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_19_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_20_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_20_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_20_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_21_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_21_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_21_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_22_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_22_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_22_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_23_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_23_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_23_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_24_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_24_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_24_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_25_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_25_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_25_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_26_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_26_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_26_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_27_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_27_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_27_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_28_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_28_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_28_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_29_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_29_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_29_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_30_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_30_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_30_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_31_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_31_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_31_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_32_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_32_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_32_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_33_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_33_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_33_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_34_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_34_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_34_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_35_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_35_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_35_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_36_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_36_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_36_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_37_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_37_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_37_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_38_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_38_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_38_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_39_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_39_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_39_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_40_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_40_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_40_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_41_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_41_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_41_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_42_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_42_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_42_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_43_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_43_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_43_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_44_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_44_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_44_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_45_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_45_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_45_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_46_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_46_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_46_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_47_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_47_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_47_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_48_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_48_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_48_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_49_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_49_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_49_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_50_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_50_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_50_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_51_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_51_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_51_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_52_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_52_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_52_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_53_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_53_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_53_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_54_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_54_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_54_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_55_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_55_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_55_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_56_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_56_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_56_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_57_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_57_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_57_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_58_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_58_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_58_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_59_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_59_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_59_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_60_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_60_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_60_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_61_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_61_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_61_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_62_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_62_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_62_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_63_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_63_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_63_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_64_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_64_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_64_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_65_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_65_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_65_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_66_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_66_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_66_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_67_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_67_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_67_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_68_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_68_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_68_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_69_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_69_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_69_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_70_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_70_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_70_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_71_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_71_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_71_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_72_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_72_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_72_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_73_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_73_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_73_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_74_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_74_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_74_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_75_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_75_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_75_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_76_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_76_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_76_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_77_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_77_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_77_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_78_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_78_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_78_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_79_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_79_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_79_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_80_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_80_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_80_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_81_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_81_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_81_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_82_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_82_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_82_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_83_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_83_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_83_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_84_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_84_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_84_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_85_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_85_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_85_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_86_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_86_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_86_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_87_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_87_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_87_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_88_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_88_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_88_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_89_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_89_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_89_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_90_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_90_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_90_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_91_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_91_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_91_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_92_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_92_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_92_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_93_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_93_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_93_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_94_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_94_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_94_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_95_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_95_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_95_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_96_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_96_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_96_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_97_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_97_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_97_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_98_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_98_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_98_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_99_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_99_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_99_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_100_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_100_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_100_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_101_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_101_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_101_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_102_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_102_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_102_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_103_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_103_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_103_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_104_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_104_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_104_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_105_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_105_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_105_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_106_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_106_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_106_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_107_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_107_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_107_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_108_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_108_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_108_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_109_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_109_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_109_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_110_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_110_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_110_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_111_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_111_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_111_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_112_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_112_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_112_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_113_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_113_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_113_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_114_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_114_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_114_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_115_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_115_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_115_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_116_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_116_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_116_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_117_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_117_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_117_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_118_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_118_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_118_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_119_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_119_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_119_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_120_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_120_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_120_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_121_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_121_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_121_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_122_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_122_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_122_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_123_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_123_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_123_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_124_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_124_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_124_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_125_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_125_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_125_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_126_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_126_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_126_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_127_ready; // @[Top-slr.scala 53:36]
  wire  crossbar_array_mem_io_out_127_valid; // @[Top-slr.scala 53:36]
  wire [47:0] crossbar_array_mem_io_out_127_bits; // @[Top-slr.scala 53:36]
  wire  crossbar_array_visit_clock; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_reset; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_0_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_0_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_0_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_1_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_1_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_1_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_2_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_2_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_2_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_3_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_3_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_3_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_4_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_4_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_4_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_5_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_5_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_5_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_6_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_6_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_6_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_7_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_7_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_7_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_8_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_8_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_8_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_9_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_9_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_9_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_10_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_10_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_10_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_11_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_11_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_11_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_12_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_12_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_12_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_13_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_13_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_13_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_14_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_14_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_14_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_15_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_15_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_15_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_16_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_16_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_16_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_17_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_17_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_17_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_18_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_18_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_18_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_19_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_19_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_19_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_20_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_20_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_20_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_21_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_21_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_21_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_22_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_22_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_22_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_23_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_23_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_23_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_24_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_24_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_24_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_25_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_25_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_25_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_26_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_26_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_26_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_27_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_27_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_27_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_28_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_28_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_28_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_29_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_29_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_29_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_30_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_30_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_30_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_31_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_31_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_31_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_32_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_32_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_32_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_33_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_33_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_33_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_34_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_34_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_34_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_35_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_35_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_35_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_36_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_36_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_36_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_37_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_37_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_37_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_38_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_38_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_38_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_39_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_39_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_39_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_40_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_40_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_40_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_41_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_41_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_41_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_42_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_42_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_42_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_43_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_43_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_43_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_44_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_44_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_44_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_45_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_45_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_45_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_46_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_46_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_46_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_47_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_47_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_47_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_48_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_48_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_48_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_49_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_49_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_49_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_50_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_50_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_50_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_51_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_51_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_51_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_52_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_52_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_52_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_53_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_53_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_53_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_54_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_54_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_54_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_55_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_55_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_55_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_56_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_56_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_56_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_57_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_57_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_57_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_58_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_58_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_58_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_59_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_59_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_59_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_60_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_60_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_60_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_61_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_61_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_61_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_62_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_62_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_62_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_63_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_63_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_63_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_64_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_64_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_64_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_65_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_65_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_65_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_66_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_66_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_66_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_67_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_67_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_67_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_68_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_68_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_68_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_69_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_69_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_69_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_70_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_70_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_70_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_71_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_71_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_71_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_72_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_72_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_72_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_73_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_73_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_73_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_74_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_74_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_74_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_75_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_75_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_75_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_76_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_76_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_76_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_77_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_77_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_77_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_78_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_78_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_78_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_79_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_79_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_79_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_80_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_80_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_80_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_81_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_81_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_81_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_82_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_82_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_82_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_83_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_83_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_83_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_84_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_84_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_84_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_85_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_85_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_85_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_86_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_86_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_86_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_87_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_87_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_87_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_88_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_88_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_88_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_89_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_89_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_89_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_90_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_90_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_90_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_91_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_91_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_91_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_92_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_92_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_92_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_93_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_93_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_93_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_94_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_94_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_94_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_95_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_95_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_95_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_96_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_96_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_96_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_97_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_97_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_97_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_98_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_98_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_98_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_99_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_99_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_99_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_100_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_100_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_100_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_101_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_101_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_101_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_102_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_102_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_102_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_103_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_103_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_103_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_104_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_104_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_104_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_105_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_105_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_105_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_106_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_106_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_106_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_107_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_107_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_107_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_108_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_108_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_108_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_109_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_109_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_109_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_110_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_110_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_110_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_111_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_111_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_111_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_112_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_112_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_112_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_113_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_113_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_113_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_114_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_114_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_114_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_115_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_115_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_115_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_116_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_116_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_116_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_117_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_117_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_117_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_118_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_118_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_118_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_119_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_119_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_119_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_120_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_120_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_120_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_121_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_121_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_121_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_122_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_122_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_122_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_123_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_123_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_123_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_124_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_124_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_124_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_125_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_125_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_125_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_126_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_126_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_126_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_127_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_in_127_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_in_127_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_0_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_0_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_0_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_1_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_1_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_1_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_2_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_2_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_2_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_3_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_3_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_3_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_4_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_4_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_4_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_5_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_5_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_5_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_6_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_6_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_6_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_7_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_7_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_7_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_8_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_8_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_8_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_9_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_9_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_9_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_10_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_10_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_10_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_11_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_11_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_11_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_12_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_12_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_12_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_13_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_13_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_13_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_14_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_14_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_14_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_15_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_15_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_15_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_16_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_16_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_16_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_17_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_17_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_17_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_18_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_18_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_18_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_19_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_19_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_19_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_20_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_20_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_20_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_21_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_21_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_21_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_22_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_22_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_22_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_23_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_23_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_23_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_24_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_24_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_24_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_25_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_25_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_25_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_26_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_26_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_26_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_27_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_27_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_27_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_28_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_28_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_28_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_29_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_29_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_29_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_30_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_30_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_30_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_31_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_31_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_31_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_32_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_32_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_32_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_33_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_33_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_33_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_34_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_34_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_34_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_35_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_35_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_35_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_36_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_36_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_36_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_37_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_37_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_37_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_38_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_38_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_38_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_39_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_39_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_39_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_40_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_40_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_40_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_41_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_41_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_41_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_42_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_42_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_42_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_43_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_43_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_43_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_44_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_44_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_44_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_45_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_45_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_45_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_46_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_46_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_46_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_47_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_47_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_47_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_48_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_48_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_48_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_49_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_49_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_49_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_50_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_50_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_50_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_51_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_51_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_51_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_52_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_52_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_52_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_53_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_53_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_53_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_54_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_54_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_54_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_55_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_55_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_55_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_56_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_56_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_56_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_57_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_57_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_57_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_58_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_58_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_58_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_59_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_59_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_59_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_60_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_60_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_60_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_61_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_61_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_61_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_62_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_62_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_62_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_63_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_63_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_63_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_64_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_64_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_64_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_65_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_65_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_65_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_66_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_66_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_66_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_67_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_67_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_67_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_68_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_68_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_68_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_69_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_69_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_69_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_70_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_70_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_70_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_71_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_71_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_71_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_72_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_72_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_72_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_73_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_73_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_73_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_74_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_74_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_74_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_75_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_75_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_75_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_76_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_76_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_76_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_77_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_77_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_77_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_78_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_78_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_78_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_79_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_79_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_79_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_80_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_80_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_80_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_81_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_81_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_81_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_82_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_82_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_82_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_83_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_83_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_83_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_84_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_84_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_84_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_85_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_85_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_85_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_86_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_86_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_86_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_87_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_87_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_87_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_88_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_88_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_88_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_89_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_89_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_89_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_90_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_90_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_90_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_91_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_91_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_91_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_92_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_92_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_92_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_93_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_93_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_93_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_94_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_94_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_94_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_95_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_95_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_95_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_96_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_96_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_96_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_97_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_97_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_97_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_98_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_98_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_98_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_99_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_99_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_99_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_100_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_100_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_100_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_101_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_101_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_101_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_102_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_102_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_102_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_103_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_103_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_103_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_104_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_104_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_104_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_105_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_105_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_105_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_106_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_106_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_106_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_107_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_107_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_107_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_108_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_108_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_108_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_109_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_109_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_109_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_110_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_110_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_110_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_111_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_111_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_111_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_112_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_112_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_112_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_113_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_113_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_113_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_114_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_114_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_114_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_115_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_115_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_115_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_116_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_116_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_116_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_117_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_117_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_117_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_118_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_118_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_118_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_119_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_119_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_119_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_120_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_120_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_120_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_121_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_121_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_121_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_122_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_122_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_122_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_123_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_123_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_123_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_124_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_124_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_124_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_125_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_125_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_125_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_126_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_126_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_126_bits; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_127_ready; // @[Top-slr.scala 54:38]
  wire  crossbar_array_visit_io_out_127_valid; // @[Top-slr.scala 54:38]
  wire [23:0] crossbar_array_visit_io_out_127_bits; // @[Top-slr.scala 54:38]
  wire  R_array_index_01_slr0_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_1_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_1_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_1_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_1_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_1_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_1_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_1_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_1_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_1_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_1_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_1_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_1_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_1_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_1_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_1_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_1_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_1_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_1_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_1_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_1_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_1_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_1_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_1_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_1_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_1_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_2_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_2_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_2_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_2_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_2_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_2_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_2_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_2_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_2_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_2_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_2_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_2_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_2_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_2_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_2_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_2_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_2_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_2_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_2_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_2_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_2_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_2_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_2_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_2_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_2_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_3_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_3_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_3_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_3_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_3_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_3_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_3_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_3_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_3_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_3_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_3_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_3_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_3_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_3_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_3_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_3_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_3_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_3_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_3_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_3_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_3_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_3_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_3_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_3_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_3_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_4_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_4_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_4_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_4_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_4_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_4_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_4_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_4_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_4_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_4_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_4_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_4_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_4_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_4_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_4_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_4_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_4_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_4_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_4_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_4_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_4_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_4_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_4_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_4_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_4_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_5_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_5_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_5_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_5_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_5_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_5_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_5_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_5_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_5_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_5_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_5_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_5_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_5_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_5_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_5_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_5_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_5_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_5_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_5_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_5_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_5_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_5_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_5_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_5_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_5_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_6_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_6_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_6_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_6_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_6_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_6_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_6_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_6_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_6_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_6_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_6_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_6_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_6_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_6_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_6_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_6_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_6_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_6_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_6_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_6_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_6_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_6_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_6_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_6_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_6_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_7_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_7_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_7_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_7_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_7_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_7_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_7_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_7_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_7_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_7_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_7_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_7_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_7_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_7_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_7_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_7_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_7_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_7_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_7_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_7_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_7_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_7_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_7_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_7_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_7_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_8_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_8_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_8_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_8_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_8_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_8_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_8_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_8_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_8_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_8_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_8_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_8_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_8_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_8_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_8_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_8_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_8_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_8_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_8_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_8_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_8_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_8_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_8_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_8_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_8_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_9_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_9_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_9_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_9_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_9_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_9_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_9_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_9_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_9_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_9_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_9_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_9_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_9_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_9_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_9_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_9_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_9_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_9_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_9_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_9_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_9_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_9_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_9_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_9_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_9_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_10_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_10_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_10_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_10_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_10_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_10_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_10_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_10_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_10_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_10_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_10_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_10_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_10_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_10_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_10_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_10_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_10_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_10_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_10_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_10_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_10_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_10_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_10_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_10_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_10_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_11_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_11_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_11_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_11_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_11_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_11_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_11_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_11_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_11_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_11_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_11_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_11_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_11_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_11_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_11_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_11_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_11_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_11_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_11_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_11_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_11_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_11_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_11_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_11_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_11_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_12_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_12_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_12_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_12_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_12_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_12_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_12_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_12_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_12_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_12_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_12_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_12_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_12_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_12_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_12_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_12_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_12_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_12_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_12_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_12_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_12_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_12_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_12_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_12_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_12_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_13_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_13_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_13_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_13_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_13_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_13_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_13_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_13_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_13_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_13_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_13_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_13_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_13_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_13_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_13_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_13_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_13_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_13_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_13_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_13_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_13_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_13_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_13_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_13_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_13_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_14_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_14_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_14_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_14_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_14_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_14_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_14_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_14_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_14_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_14_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_14_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_14_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_14_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_14_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_14_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_14_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_14_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_14_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_14_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_14_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_14_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_14_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_14_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_14_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_14_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_15_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_15_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_15_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_15_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_15_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_15_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_15_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_15_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_15_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_15_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_15_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_15_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_15_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_15_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_15_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_15_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_15_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_15_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_15_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_15_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_15_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_15_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_15_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_15_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_15_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_16_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_16_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_16_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_16_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_16_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_16_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_16_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_16_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_16_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_16_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_16_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_16_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_16_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_16_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_16_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_16_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_16_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_16_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_16_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_16_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_16_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_16_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_16_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_16_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_16_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_17_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_17_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_17_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_17_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_17_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_17_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_17_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_17_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_17_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_17_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_17_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_17_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_17_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_17_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_17_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_17_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_17_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_17_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_17_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_17_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_17_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_17_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_17_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_17_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_17_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_18_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_18_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_18_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_18_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_18_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_18_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_18_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_18_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_18_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_18_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_18_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_18_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_18_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_18_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_18_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_18_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_18_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_18_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_18_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_18_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_18_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_18_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_18_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_18_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_18_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_19_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_19_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_19_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_19_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_19_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_19_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_19_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_19_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_19_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_19_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_19_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_19_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_19_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_19_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_19_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_19_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_19_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_19_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_19_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_19_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_19_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_19_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_19_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_19_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_19_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_20_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_20_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_20_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_20_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_20_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_20_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_20_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_20_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_20_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_20_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_20_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_20_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_20_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_20_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_20_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_20_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_20_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_20_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_20_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_20_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_20_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_20_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_20_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_20_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_20_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_21_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_21_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_21_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_21_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_21_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_21_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_21_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_21_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_21_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_21_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_21_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_21_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_21_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_21_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_21_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_21_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_21_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_21_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_21_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_21_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_21_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_21_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_21_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_21_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_21_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_22_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_22_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_22_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_22_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_22_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_22_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_22_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_22_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_22_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_22_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_22_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_22_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_22_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_22_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_22_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_22_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_22_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_22_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_22_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_22_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_22_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_22_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_22_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_22_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_22_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_23_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_23_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_23_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_23_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_23_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_23_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_23_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_23_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_23_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_23_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_23_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_23_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_23_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_23_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_23_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_23_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_23_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_23_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_23_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_23_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_23_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_23_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_23_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_23_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_23_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_24_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_24_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_24_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_24_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_24_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_24_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_24_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_24_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_24_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_24_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_24_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_24_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_24_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_24_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_24_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_24_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_24_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_24_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_24_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_24_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_24_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_24_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_24_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_24_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_24_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_25_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_25_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_25_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_25_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_25_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_25_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_25_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_25_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_25_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_25_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_25_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_25_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_25_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_25_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_25_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_25_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_25_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_25_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_25_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_25_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_25_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_25_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_25_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_25_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_25_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_26_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_26_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_26_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_26_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_26_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_26_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_26_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_26_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_26_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_26_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_26_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_26_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_26_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_26_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_26_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_26_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_26_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_26_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_26_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_26_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_26_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_26_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_26_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_26_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_26_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_27_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_27_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_27_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_27_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_27_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_27_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_27_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_27_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_27_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_27_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_27_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_27_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_27_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_27_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_27_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_27_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_27_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_27_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_27_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_27_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_27_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_27_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_27_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_27_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_27_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_28_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_28_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_28_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_28_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_28_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_28_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_28_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_28_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_28_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_28_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_28_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_28_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_28_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_28_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_28_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_28_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_28_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_28_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_28_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_28_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_28_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_28_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_28_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_28_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_28_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_29_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_29_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_29_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_29_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_29_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_29_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_29_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_29_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_29_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_29_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_29_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_29_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_29_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_29_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_29_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_29_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_29_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_29_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_29_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_29_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_29_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_29_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_29_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_29_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_29_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_30_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_30_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_30_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_30_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_30_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_30_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_30_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_30_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_30_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_30_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_30_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_30_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_30_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_30_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_30_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_30_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_30_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_30_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_30_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_30_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_30_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_30_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_30_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_30_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_30_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_31_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_31_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_31_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_31_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_31_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_31_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_31_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_31_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_31_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_31_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_31_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_31_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_31_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_31_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_31_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_31_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_31_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_31_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_31_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_31_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_31_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_31_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_31_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_31_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_31_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_32_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_32_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_32_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_32_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_32_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_32_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_32_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_32_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_32_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_32_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_32_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_32_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_32_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_32_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_32_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_32_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_32_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_32_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_32_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_32_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_32_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_32_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_32_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_32_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_32_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_33_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_33_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_33_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_33_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_33_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_33_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_33_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_33_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_33_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_33_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_33_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_33_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_33_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_33_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_33_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_33_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_33_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_33_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_33_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_33_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_33_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_33_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_33_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_33_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_33_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_34_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_34_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_34_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_34_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_34_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_34_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_34_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_34_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_34_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_34_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_34_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_34_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_34_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_34_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_34_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_34_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_34_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_34_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_34_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_34_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_34_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_34_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_34_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_34_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_34_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_35_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_35_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_35_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_35_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_35_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_35_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_35_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_35_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_35_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_35_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_35_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_35_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_35_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_35_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_35_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_35_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_35_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_35_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_35_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_35_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_35_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_35_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_35_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_35_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_35_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_36_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_36_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_36_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_36_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_36_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_36_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_36_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_36_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_36_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_36_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_36_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_36_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_36_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_36_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_36_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_36_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_36_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_36_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_36_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_36_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_36_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_36_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_36_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_36_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_36_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_37_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_37_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_37_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_37_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_37_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_37_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_37_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_37_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_37_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_37_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_37_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_37_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_37_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_37_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_37_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_37_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_37_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_37_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_37_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_37_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_37_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_37_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_37_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_37_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_37_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_38_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_38_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_38_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_38_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_38_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_38_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_38_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_38_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_38_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_38_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_38_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_38_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_38_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_38_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_38_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_38_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_38_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_38_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_38_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_38_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_38_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_38_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_38_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_38_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_38_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_39_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_39_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_39_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_39_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_39_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_39_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_39_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_39_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_39_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_39_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_39_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_39_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_39_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_39_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_39_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_39_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_39_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_39_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_39_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_39_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_39_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_39_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_39_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_39_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_39_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_40_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_40_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_40_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_40_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_40_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_40_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_40_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_40_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_40_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_40_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_40_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_40_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_40_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_40_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_40_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_40_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_40_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_40_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_40_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_40_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_40_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_40_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_40_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_40_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_40_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_41_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_41_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_41_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_41_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_41_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_41_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_41_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_41_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_41_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_41_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_41_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_41_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_41_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_41_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_41_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_41_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_41_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_41_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_41_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_41_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_41_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_41_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_41_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_41_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_41_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_42_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_42_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_42_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_42_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_42_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_42_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_42_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_42_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_42_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_42_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_42_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_42_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_42_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_42_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_42_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_42_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_42_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_42_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_42_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_42_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_42_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_42_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_42_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_42_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_42_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_43_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_43_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_43_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_43_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_43_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_43_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_43_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_43_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_43_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_43_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_43_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_43_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_43_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_43_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_43_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_43_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_43_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_43_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_43_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_43_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_43_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_43_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_43_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_43_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_43_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_44_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_44_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_44_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_44_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_44_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_44_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_44_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_44_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_44_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_44_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_44_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_44_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_44_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_44_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_44_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_44_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_44_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_44_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_44_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_44_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_44_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_44_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_44_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_44_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_44_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_45_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_45_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_45_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_45_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_45_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_45_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_45_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_45_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_45_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_45_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_45_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_45_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_45_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_45_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_45_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_45_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_45_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_45_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_45_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_45_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_45_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_45_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_45_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_45_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_45_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_46_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_46_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_46_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_46_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_46_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_46_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_46_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_46_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_46_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_46_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_46_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_46_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_46_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_46_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_46_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_46_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_46_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_46_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_46_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_46_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_46_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_46_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_46_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_46_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_46_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_47_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_47_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_47_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_47_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_47_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_47_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_47_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_47_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_47_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_47_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_47_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_47_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_47_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_47_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_47_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_47_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_47_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_47_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_47_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_47_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_47_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_47_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_47_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_47_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_47_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_48_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_48_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_48_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_48_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_48_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_48_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_48_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_48_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_48_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_48_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_48_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_48_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_48_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_48_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_48_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_48_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_48_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_48_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_48_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_48_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_48_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_48_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_48_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_48_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_48_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_49_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_49_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_49_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_49_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_49_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_49_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_49_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_49_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_49_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_49_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_49_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_49_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_49_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_49_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_49_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_49_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_49_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_49_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_49_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_49_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_49_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_49_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_49_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_49_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_49_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_50_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_50_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_50_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_50_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_50_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_50_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_50_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_50_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_50_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_50_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_50_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_50_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_50_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_50_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_50_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_50_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_50_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_50_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_50_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_50_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_50_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_50_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_50_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_50_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_50_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_51_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_51_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_51_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_51_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_51_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_51_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_51_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_51_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_51_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_51_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_51_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_51_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_51_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_51_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_51_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_51_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_51_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_51_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_51_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_51_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_51_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_51_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_51_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_51_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_51_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_52_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_52_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_52_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_52_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_52_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_52_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_52_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_52_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_52_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_52_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_52_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_52_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_52_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_52_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_52_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_52_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_52_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_52_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_52_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_52_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_52_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_52_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_52_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_52_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_52_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_53_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_53_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_53_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_53_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_53_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_53_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_53_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_53_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_53_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_53_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_53_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_53_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_53_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_53_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_53_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_53_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_53_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_53_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_53_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_53_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_53_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_53_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_53_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_53_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_53_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_54_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_54_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_54_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_54_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_54_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_54_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_54_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_54_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_54_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_54_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_54_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_54_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_54_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_54_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_54_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_54_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_54_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_54_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_54_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_54_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_54_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_54_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_54_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_54_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_54_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_01_slr0_55_clock; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_55_reset; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_55_enq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_55_enq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_55_enq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_55_deq_valid; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr0_55_deq_ready; // @[Top-slr.scala 271:42]
  wire [31:0] R_array_index_01_slr0_55_deq_bits; // @[Top-slr.scala 271:42]
  wire  R_array_index_01_slr1_55_clock; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_55_reset; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_55_enq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_55_enq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_55_enq_bits; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_55_deq_valid; // @[Top-slr.scala 272:42]
  wire  R_array_index_01_slr1_55_deq_ready; // @[Top-slr.scala 272:42]
  wire [31:0] R_array_index_01_slr1_55_deq_bits; // @[Top-slr.scala 272:42]
  wire  q_R_array_index_slr0_55_clock; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_55_reset; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_55_io_enq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_55_io_enq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_55_io_enq_bits; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_55_io_deq_ready; // @[Top-slr.scala 273:44]
  wire  q_R_array_index_slr0_55_io_deq_valid; // @[Top-slr.scala 273:44]
  wire [31:0] q_R_array_index_slr0_55_io_deq_bits; // @[Top-slr.scala 273:44]
  wire [3:0] q_R_array_index_slr0_55_io_count; // @[Top-slr.scala 273:44]
  wire  R_array_index_02_slr0_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_56_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_56_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_56_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_56_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_56_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_56_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_56_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_56_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_56_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_1_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_1_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_1_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_1_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_1_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_1_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_1_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_1_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_1_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_1_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_1_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_1_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_1_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_1_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_1_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_1_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_1_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_1_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_1_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_1_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_1_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_1_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_1_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_1_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_57_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_57_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_57_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_57_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_57_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_57_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_57_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_57_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_57_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_2_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_2_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_2_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_2_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_2_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_2_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_2_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_2_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_2_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_2_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_2_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_2_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_2_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_2_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_2_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_2_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_2_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_2_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_2_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_2_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_2_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_2_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_2_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_2_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_58_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_58_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_58_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_58_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_58_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_58_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_58_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_58_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_58_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_3_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_3_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_3_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_3_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_3_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_3_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_3_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_3_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_3_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_3_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_3_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_3_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_3_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_3_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_3_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_3_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_3_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_3_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_3_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_3_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_3_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_3_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_3_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_3_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_59_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_59_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_59_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_59_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_59_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_59_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_59_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_59_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_59_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_4_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_4_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_4_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_4_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_4_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_4_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_4_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_4_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_4_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_4_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_4_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_4_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_4_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_4_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_4_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_4_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_4_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_4_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_4_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_4_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_4_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_4_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_4_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_4_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_60_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_60_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_60_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_60_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_60_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_60_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_60_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_60_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_60_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_5_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_5_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_5_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_5_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_5_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_5_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_5_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_5_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_5_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_5_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_5_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_5_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_5_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_5_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_5_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_5_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_5_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_5_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_5_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_5_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_5_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_5_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_5_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_5_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_61_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_61_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_61_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_61_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_61_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_61_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_61_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_61_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_61_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_6_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_6_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_6_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_6_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_6_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_6_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_6_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_6_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_6_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_6_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_6_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_6_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_6_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_6_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_6_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_6_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_6_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_6_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_6_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_6_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_6_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_6_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_6_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_6_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_62_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_62_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_62_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_62_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_62_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_62_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_62_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_62_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_62_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_7_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_7_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_7_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_7_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_7_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_7_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_7_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_7_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_7_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_7_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_7_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_7_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_7_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_7_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_7_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_7_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_7_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_7_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_7_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_7_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_7_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_7_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_7_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_7_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_63_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_63_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_63_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_63_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_63_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_63_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_63_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_63_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_63_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_8_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_8_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_8_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_8_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_8_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_8_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_8_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_8_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_8_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_8_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_8_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_8_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_8_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_8_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_8_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_8_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_8_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_8_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_8_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_8_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_8_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_8_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_8_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_8_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_64_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_64_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_64_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_64_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_64_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_64_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_64_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_64_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_64_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_9_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_9_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_9_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_9_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_9_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_9_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_9_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_9_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_9_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_9_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_9_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_9_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_9_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_9_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_9_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_9_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_9_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_9_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_9_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_9_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_9_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_9_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_9_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_9_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_65_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_65_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_65_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_65_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_65_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_65_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_65_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_65_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_65_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_10_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_10_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_10_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_10_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_10_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_10_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_10_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_10_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_10_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_10_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_10_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_10_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_10_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_10_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_10_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_10_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_10_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_10_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_10_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_10_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_10_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_10_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_10_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_10_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_66_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_66_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_66_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_66_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_66_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_66_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_66_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_66_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_66_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_11_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_11_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_11_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_11_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_11_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_11_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_11_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_11_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_11_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_11_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_11_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_11_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_11_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_11_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_11_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_11_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_11_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_11_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_11_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_11_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_11_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_11_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_11_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_11_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_67_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_67_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_67_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_67_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_67_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_67_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_67_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_67_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_67_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_12_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_12_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_12_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_12_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_12_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_12_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_12_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_12_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_12_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_12_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_12_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_12_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_12_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_12_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_12_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_12_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_12_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_12_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_12_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_12_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_12_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_12_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_12_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_12_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_68_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_68_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_68_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_68_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_68_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_68_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_68_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_68_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_68_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_13_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_13_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_13_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_13_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_13_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_13_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_13_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_13_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_13_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_13_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_13_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_13_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_13_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_13_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_13_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_13_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_13_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_13_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_13_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_13_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_13_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_13_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_13_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_13_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_69_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_69_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_69_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_69_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_69_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_69_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_69_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_69_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_69_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_14_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_14_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_14_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_14_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_14_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_14_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_14_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_14_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_14_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_14_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_14_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_14_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_14_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_14_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_14_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_14_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_14_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_14_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_14_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_14_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_14_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_14_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_14_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_14_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_70_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_70_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_70_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_70_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_70_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_70_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_70_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_70_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_70_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_15_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_15_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_15_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_15_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_15_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_15_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_15_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_15_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_15_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_15_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_15_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_15_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_15_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_15_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_15_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_15_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_15_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_15_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_15_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_15_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_15_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_15_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_15_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_15_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_71_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_71_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_71_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_71_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_71_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_71_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_71_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_71_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_71_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_16_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_16_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_16_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_16_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_16_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_16_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_16_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_16_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_16_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_16_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_16_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_16_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_16_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_16_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_16_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_16_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_16_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_16_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_16_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_16_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_16_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_16_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_16_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_16_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_72_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_72_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_72_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_72_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_72_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_72_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_72_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_72_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_72_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_17_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_17_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_17_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_17_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_17_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_17_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_17_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_17_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_17_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_17_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_17_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_17_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_17_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_17_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_17_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_17_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_17_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_17_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_17_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_17_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_17_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_17_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_17_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_17_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_73_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_73_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_73_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_73_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_73_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_73_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_73_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_73_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_73_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_18_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_18_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_18_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_18_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_18_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_18_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_18_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_18_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_18_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_18_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_18_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_18_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_18_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_18_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_18_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_18_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_18_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_18_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_18_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_18_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_18_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_18_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_18_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_18_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_74_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_74_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_74_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_74_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_74_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_74_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_74_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_74_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_74_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_19_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_19_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_19_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_19_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_19_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_19_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_19_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_19_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_19_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_19_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_19_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_19_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_19_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_19_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_19_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_19_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_19_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_19_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_19_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_19_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_19_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_19_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_19_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_19_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_75_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_75_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_75_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_75_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_75_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_75_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_75_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_75_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_75_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_20_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_20_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_20_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_20_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_20_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_20_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_20_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_20_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_20_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_20_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_20_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_20_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_20_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_20_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_20_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_20_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_20_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_20_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_20_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_20_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_20_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_20_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_20_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_20_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_76_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_76_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_76_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_76_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_76_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_76_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_76_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_76_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_76_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_21_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_21_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_21_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_21_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_21_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_21_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_21_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_21_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_21_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_21_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_21_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_21_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_21_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_21_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_21_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_21_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_21_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_21_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_21_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_21_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_21_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_21_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_21_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_21_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_77_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_77_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_77_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_77_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_77_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_77_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_77_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_77_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_77_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_22_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_22_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_22_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_22_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_22_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_22_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_22_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_22_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_22_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_22_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_22_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_22_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_22_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_22_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_22_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_22_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_22_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_22_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_22_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_22_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_22_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_22_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_22_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_22_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_78_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_78_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_78_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_78_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_78_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_78_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_78_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_78_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_78_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_23_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_23_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_23_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_23_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_23_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_23_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_23_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_23_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_23_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_23_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_23_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_23_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_23_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_23_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_23_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_23_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_23_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_23_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_23_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_23_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_23_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_23_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_23_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_23_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_79_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_79_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_79_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_79_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_79_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_79_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_79_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_79_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_79_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_24_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_24_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_24_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_24_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_24_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_24_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_24_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_24_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_24_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_24_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_24_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_24_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_24_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_24_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_24_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_24_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_24_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_24_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_24_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_24_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_24_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_24_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_24_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_24_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_80_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_80_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_80_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_80_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_80_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_80_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_80_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_80_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_80_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_25_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_25_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_25_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_25_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_25_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_25_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_25_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_25_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_25_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_25_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_25_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_25_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_25_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_25_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_25_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_25_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_25_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_25_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_25_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_25_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_25_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_25_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_25_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_25_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_81_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_81_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_81_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_81_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_81_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_81_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_81_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_81_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_81_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_26_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_26_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_26_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_26_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_26_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_26_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_26_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_26_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_26_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_26_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_26_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_26_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_26_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_26_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_26_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_26_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_26_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_26_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_26_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_26_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_26_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_26_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_26_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_26_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_82_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_82_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_82_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_82_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_82_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_82_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_82_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_82_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_82_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_27_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_27_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_27_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_27_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_27_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_27_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_27_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_27_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_27_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_27_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_27_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_27_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_27_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_27_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_27_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_27_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_27_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_27_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_27_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_27_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_27_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_27_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_27_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_27_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_83_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_83_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_83_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_83_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_83_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_83_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_83_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_83_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_83_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_28_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_28_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_28_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_28_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_28_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_28_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_28_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_28_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_28_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_28_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_28_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_28_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_28_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_28_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_28_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_28_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_28_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_28_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_28_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_28_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_28_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_28_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_28_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_28_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_84_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_84_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_84_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_84_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_84_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_84_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_84_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_84_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_84_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_29_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_29_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_29_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_29_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_29_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_29_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_29_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_29_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_29_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_29_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_29_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_29_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_29_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_29_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_29_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_29_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_29_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_29_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_29_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_29_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_29_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_29_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_29_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_29_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_85_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_85_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_85_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_85_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_85_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_85_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_85_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_85_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_85_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_30_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_30_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_30_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_30_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_30_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_30_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_30_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_30_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_30_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_30_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_30_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_30_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_30_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_30_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_30_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_30_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_30_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_30_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_30_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_30_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_30_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_30_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_30_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_30_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_86_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_86_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_86_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_86_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_86_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_86_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_86_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_86_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_86_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_31_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_31_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_31_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_31_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_31_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_31_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_31_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_31_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_31_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_31_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_31_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_31_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_31_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_31_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_31_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_31_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_31_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_31_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_31_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_31_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_31_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_31_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_31_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_31_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_87_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_87_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_87_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_87_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_87_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_87_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_87_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_87_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_87_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_32_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_32_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_32_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_32_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_32_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_32_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_32_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_32_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_32_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_32_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_32_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_32_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_32_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_32_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_32_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_32_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_32_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_32_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_32_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_32_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_32_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_32_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_32_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_32_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_88_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_88_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_88_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_88_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_88_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_88_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_88_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_88_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_88_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_33_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_33_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_33_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_33_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_33_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_33_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_33_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_33_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_33_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_33_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_33_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_33_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_33_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_33_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_33_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_33_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_33_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_33_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_33_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_33_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_33_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_33_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_33_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_33_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_89_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_89_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_89_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_89_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_89_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_89_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_89_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_89_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_89_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_34_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_34_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_34_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_34_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_34_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_34_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_34_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_34_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_34_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_34_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_34_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_34_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_34_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_34_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_34_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_34_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_34_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_34_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_34_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_34_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_34_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_34_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_34_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_34_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_90_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_90_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_90_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_90_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_90_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_90_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_90_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_90_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_90_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_35_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_35_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_35_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_35_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_35_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_35_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_35_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_35_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_35_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_35_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_35_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_35_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_35_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_35_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_35_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_35_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_35_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_35_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_35_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_35_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_35_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_35_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_35_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_35_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_91_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_91_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_91_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_91_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_91_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_91_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_91_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_91_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_91_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_36_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_36_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_36_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_36_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_36_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_36_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_36_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_36_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_36_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_36_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_36_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_36_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_36_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_36_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_36_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_36_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_36_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_36_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_36_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_36_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_36_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_36_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_36_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_36_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_92_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_92_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_92_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_92_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_92_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_92_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_92_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_92_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_92_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_37_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_37_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_37_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_37_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_37_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_37_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_37_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_37_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_37_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_37_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_37_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_37_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_37_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_37_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_37_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_37_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_37_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_37_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_37_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_37_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_37_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_37_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_37_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_37_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_93_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_93_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_93_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_93_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_93_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_93_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_93_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_93_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_93_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_38_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_38_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_38_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_38_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_38_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_38_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_38_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_38_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_38_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_38_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_38_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_38_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_38_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_38_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_38_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_38_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_38_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_38_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_38_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_38_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_38_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_38_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_38_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_38_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_94_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_94_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_94_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_94_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_94_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_94_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_94_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_94_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_94_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_39_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_39_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_39_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_39_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_39_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_39_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_39_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_39_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_39_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_39_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_39_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_39_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_39_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_39_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_39_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_39_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_39_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_39_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_39_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_39_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_39_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_39_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_39_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_39_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_95_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_95_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_95_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_95_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_95_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_95_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_95_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_95_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_95_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_40_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_40_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_40_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_40_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_40_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_40_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_40_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_40_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_40_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_40_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_40_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_40_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_40_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_40_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_40_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_40_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_40_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_40_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_40_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_40_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_40_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_40_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_40_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_40_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_96_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_96_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_96_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_96_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_96_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_96_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_96_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_96_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_96_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_41_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_41_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_41_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_41_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_41_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_41_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_41_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_41_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_41_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_41_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_41_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_41_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_41_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_41_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_41_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_41_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_41_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_41_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_41_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_41_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_41_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_41_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_41_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_41_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_97_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_97_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_97_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_97_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_97_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_97_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_97_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_97_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_97_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_42_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_42_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_42_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_42_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_42_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_42_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_42_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_42_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_42_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_42_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_42_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_42_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_42_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_42_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_42_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_42_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_42_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_42_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_42_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_42_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_42_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_42_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_42_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_42_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_98_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_98_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_98_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_98_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_98_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_98_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_98_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_98_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_98_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_43_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_43_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_43_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_43_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_43_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_43_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_43_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_43_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_43_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_43_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_43_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_43_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_43_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_43_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_43_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_43_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_43_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_43_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_43_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_43_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_43_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_43_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_43_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_43_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_99_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_99_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_99_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_99_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_99_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_99_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_99_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_99_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_99_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_44_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_44_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_44_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_44_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_44_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_44_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_44_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_44_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_44_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_44_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_44_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_44_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_44_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_44_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_44_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_44_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_44_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_44_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_44_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_44_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_44_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_44_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_44_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_44_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_100_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_100_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_100_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_100_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_100_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_100_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_100_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_100_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_100_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_45_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_45_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_45_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_45_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_45_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_45_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_45_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_45_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_45_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_45_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_45_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_45_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_45_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_45_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_45_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_45_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_45_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_45_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_45_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_45_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_45_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_45_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_45_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_45_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_101_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_101_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_101_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_101_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_101_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_101_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_101_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_101_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_101_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_46_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_46_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_46_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_46_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_46_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_46_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_46_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_46_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_46_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_46_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_46_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_46_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_46_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_46_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_46_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_46_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_46_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_46_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_46_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_46_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_46_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_46_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_46_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_46_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_102_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_102_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_102_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_102_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_102_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_102_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_102_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_102_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_102_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_47_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_47_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_47_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_47_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_47_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_47_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_47_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_47_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_47_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_47_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_47_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_47_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_47_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_47_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_47_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_47_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_47_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_47_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_47_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_47_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_47_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_47_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_47_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_47_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_103_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_103_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_103_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_103_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_103_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_103_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_103_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_103_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_103_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_48_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_48_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_48_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_48_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_48_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_48_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_48_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_48_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_48_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_48_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_48_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_48_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_48_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_48_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_48_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_48_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_48_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_48_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_48_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_48_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_48_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_48_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_48_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_48_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_104_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_104_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_104_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_104_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_104_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_104_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_104_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_104_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_104_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_49_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_49_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_49_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_49_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_49_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_49_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_49_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_49_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_49_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_49_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_49_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_49_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_49_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_49_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_49_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_49_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_49_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_49_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_49_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_49_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_49_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_49_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_49_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_49_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_105_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_105_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_105_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_105_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_105_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_105_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_105_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_105_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_105_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_50_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_50_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_50_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_50_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_50_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_50_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_50_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_50_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_50_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_50_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_50_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_50_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_50_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_50_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_50_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_50_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_50_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_50_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_50_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_50_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_50_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_50_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_50_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_50_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_106_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_106_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_106_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_106_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_106_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_106_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_106_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_106_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_106_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_51_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_51_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_51_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_51_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_51_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_51_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_51_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_51_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_51_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_51_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_51_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_51_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_51_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_51_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_51_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_51_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_51_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_51_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_51_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_51_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_51_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_51_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_51_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_51_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_107_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_107_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_107_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_107_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_107_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_107_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_107_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_107_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_107_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_52_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_52_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_52_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_52_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_52_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_52_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_52_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_52_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_52_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_52_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_52_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_52_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_52_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_52_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_52_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_52_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_52_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_52_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_52_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_52_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_52_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_52_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_52_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_52_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_108_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_108_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_108_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_108_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_108_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_108_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_108_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_108_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_108_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_53_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_53_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_53_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_53_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_53_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_53_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_53_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_53_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_53_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_53_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_53_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_53_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_53_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_53_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_53_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_53_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_53_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_53_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_53_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_53_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_53_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_53_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_53_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_53_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_109_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_109_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_109_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_109_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_109_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_109_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_109_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_109_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_109_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_54_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_54_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_54_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_54_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_54_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_54_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_54_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_54_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_54_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_54_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_54_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_54_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_54_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_54_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_54_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_54_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_54_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_54_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_54_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_54_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_54_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_54_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_54_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_54_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_110_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_110_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_110_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_110_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_110_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_110_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_110_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_110_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_110_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_55_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_55_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_55_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_55_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_55_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_55_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_55_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_55_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_55_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_55_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_55_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_55_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_55_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_55_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_55_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_55_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_55_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_55_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_55_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_55_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_55_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_55_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_55_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_55_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_111_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_111_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_111_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_111_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_111_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_111_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_111_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_111_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_111_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_56_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_56_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_56_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_56_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_56_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_56_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_56_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_56_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_56_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_56_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_56_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_56_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_56_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_56_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_56_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_56_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_56_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_56_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_56_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_56_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_56_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_56_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_56_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_56_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_112_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_112_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_112_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_112_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_112_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_112_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_112_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_112_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_112_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_57_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_57_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_57_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_57_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_57_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_57_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_57_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_57_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_57_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_57_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_57_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_57_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_57_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_57_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_57_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_57_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_57_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_57_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_57_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_57_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_57_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_57_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_57_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_57_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_113_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_113_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_113_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_113_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_113_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_113_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_113_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_113_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_113_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_58_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_58_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_58_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_58_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_58_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_58_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_58_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_58_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_58_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_58_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_58_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_58_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_58_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_58_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_58_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_58_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_58_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_58_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_58_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_58_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_58_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_58_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_58_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_58_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_114_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_114_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_114_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_114_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_114_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_114_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_114_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_114_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_114_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_59_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_59_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_59_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_59_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_59_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_59_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_59_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_59_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_59_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_59_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_59_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_59_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_59_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_59_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_59_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_59_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_59_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_59_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_59_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_59_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_59_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_59_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_59_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_59_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_115_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_115_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_115_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_115_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_115_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_115_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_115_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_115_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_115_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_60_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_60_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_60_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_60_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_60_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_60_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_60_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_60_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_60_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_60_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_60_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_60_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_60_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_60_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_60_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_60_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_60_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_60_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_60_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_60_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_60_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_60_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_60_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_60_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_116_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_116_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_116_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_116_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_116_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_116_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_116_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_116_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_116_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_61_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_61_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_61_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_61_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_61_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_61_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_61_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_61_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_61_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_61_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_61_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_61_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_61_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_61_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_61_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_61_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_61_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_61_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_61_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_61_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_61_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_61_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_61_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_61_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_117_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_117_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_117_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_117_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_117_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_117_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_117_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_117_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_117_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_62_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_62_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_62_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_62_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_62_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_62_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_62_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_62_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_62_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_62_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_62_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_62_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_62_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_62_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_62_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_62_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_62_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_62_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_62_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_62_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_62_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_62_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_62_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_62_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_118_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_118_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_118_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_118_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_118_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_118_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_118_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_118_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_118_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_63_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_63_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_63_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_63_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_63_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_63_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_63_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_63_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_63_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_63_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_63_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_63_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_63_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_63_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_63_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_63_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_63_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_63_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_63_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_63_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_63_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_63_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_63_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_63_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_119_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_119_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_119_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_119_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_119_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_119_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_119_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_119_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_119_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_64_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_64_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_64_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_64_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_64_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_64_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_64_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_64_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_64_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_64_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_64_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_64_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_64_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_64_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_64_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_64_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_64_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_64_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_64_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_64_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_64_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_64_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_64_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_64_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_120_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_120_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_120_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_120_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_120_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_120_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_120_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_120_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_120_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_65_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_65_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_65_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_65_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_65_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_65_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_65_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_65_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_65_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_65_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_65_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_65_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_65_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_65_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_65_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_65_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_65_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_65_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_65_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_65_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_65_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_65_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_65_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_65_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_121_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_121_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_121_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_121_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_121_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_121_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_121_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_121_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_121_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_66_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_66_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_66_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_66_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_66_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_66_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_66_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_66_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_66_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_66_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_66_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_66_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_66_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_66_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_66_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_66_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_66_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_66_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_66_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_66_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_66_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_66_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_66_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_66_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_122_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_122_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_122_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_122_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_122_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_122_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_122_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_122_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_122_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_67_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_67_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_67_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_67_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_67_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_67_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_67_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_67_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_67_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_67_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_67_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_67_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_67_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_67_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_67_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_67_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_67_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_67_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_67_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_67_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_67_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_67_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_67_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_67_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_123_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_123_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_123_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_123_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_123_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_123_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_123_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_123_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_123_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_68_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_68_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_68_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_68_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_68_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_68_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_68_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_68_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_68_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_68_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_68_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_68_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_68_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_68_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_68_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_68_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_68_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_68_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_68_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_68_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_68_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_68_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_68_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_68_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_124_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_124_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_124_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_124_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_124_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_124_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_124_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_124_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_124_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_69_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_69_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_69_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_69_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_69_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_69_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_69_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_69_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_69_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_69_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_69_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_69_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_69_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_69_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_69_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_69_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_69_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_69_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_69_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_69_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_69_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_69_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_69_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_69_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_125_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_125_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_125_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_125_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_125_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_125_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_125_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_125_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_125_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_70_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_70_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_70_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_70_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_70_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_70_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_70_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_70_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_70_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_70_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_70_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_70_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_70_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_70_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_70_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_70_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_70_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_70_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_70_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_70_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_70_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_70_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_70_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_70_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_126_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_126_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_126_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_126_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_126_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_126_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_126_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_126_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_126_io_count; // @[Top-slr.scala 374:44]
  wire  R_array_index_02_slr0_71_clock; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_71_reset; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_71_enq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_71_enq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_71_enq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_71_deq_valid; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr0_71_deq_ready; // @[Top-slr.scala 363:42]
  wire [31:0] R_array_index_02_slr0_71_deq_bits; // @[Top-slr.scala 363:42]
  wire  R_array_index_02_slr1_71_clock; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_71_reset; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_71_enq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_71_enq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_71_enq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_71_deq_valid; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr1_71_deq_ready; // @[Top-slr.scala 364:42]
  wire [31:0] R_array_index_02_slr1_71_deq_bits; // @[Top-slr.scala 364:42]
  wire  R_array_index_02_slr2_71_clock; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_71_reset; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_71_enq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_71_enq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_71_enq_bits; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_71_deq_valid; // @[Top-slr.scala 365:42]
  wire  R_array_index_02_slr2_71_deq_ready; // @[Top-slr.scala 365:42]
  wire [31:0] R_array_index_02_slr2_71_deq_bits; // @[Top-slr.scala 365:42]
  wire  q_R_array_index_slr0_127_clock; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_127_reset; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_127_io_enq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_127_io_enq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_127_io_enq_bits; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_127_io_deq_ready; // @[Top-slr.scala 374:44]
  wire  q_R_array_index_slr0_127_io_deq_valid; // @[Top-slr.scala 374:44]
  wire [31:0] q_R_array_index_slr0_127_io_deq_bits; // @[Top-slr.scala 374:44]
  wire [3:0] q_R_array_index_slr0_127_io_count; // @[Top-slr.scala 374:44]
  reg [31:0] kernel_count; // @[Top-slr.scala 69:31]
  wire [32:0] _T = kernel_count + 32'h1; // @[Top-slr.scala 70:34]
  wire [31:0] _T_1 = kernel_count + 32'h1; // @[Top-slr.scala 70:34]
  reg  start_r; // @[Top-slr.scala 71:26]
  wire  _T_2 = ~start_r; // @[Top-slr.scala 72:43]
  wire  start_pulse = io_ap_start_pulse & _T_2; // @[Top-slr.scala 72:41]
  reg  start_state; // @[Top-slr.scala 74:30]
  reg  _T_3; // @[Top-slr.scala 78:23]
  wire  _GEN_0 = _T_3 ? 1'h0 : start_state; // @[Top-slr.scala 78:49]
  wire [31:0] _GEN_1 = start_pulse ? 32'h0 : _T_1; // @[Top-slr.scala 75:22]
  wire  _GEN_2 = start_pulse | _GEN_0; // @[Top-slr.scala 75:22]
  reg [7:0] master_finish_count; // @[Top-slr.scala 87:38]
  wire  _T_4 = SLR0_Mem_io_write_finish_0 & SLR0_Mem_io_write_finish_1; // @[Top-slr.scala 88:64]
  wire  _T_5 = _T_4 & SLR0_Mem_io_write_finish_2; // @[Top-slr.scala 88:64]
  wire  _T_6 = _T_5 & SLR0_Mem_io_write_finish_3; // @[Top-slr.scala 88:64]
  wire  _T_7 = _T_6 & SLR0_Mem_io_write_finish_4; // @[Top-slr.scala 88:64]
  wire  _T_8 = _T_7 & SLR0_Mem_io_write_finish_5; // @[Top-slr.scala 88:64]
  wire  _T_9 = _T_8 & SLR0_Mem_io_write_finish_6; // @[Top-slr.scala 88:64]
  wire  _T_10 = _T_9 & SLR0_Mem_io_write_finish_7; // @[Top-slr.scala 88:64]
  wire  _T_11 = _T_10 & SLR0_Mem_io_write_finish_8; // @[Top-slr.scala 88:64]
  wire  _T_12 = _T_11 & SLR0_Mem_io_write_finish_9; // @[Top-slr.scala 88:64]
  wire  _T_13 = _T_12 & SLR0_Mem_io_write_finish_10; // @[Top-slr.scala 88:64]
  wire  _T_14 = _T_13 & SLR0_Mem_io_write_finish_11; // @[Top-slr.scala 88:64]
  wire  _T_15 = _T_14 & SLR0_Mem_io_write_finish_12; // @[Top-slr.scala 88:64]
  wire  _T_16 = _T_15 & SLR0_Mem_io_write_finish_13; // @[Top-slr.scala 88:64]
  wire  _T_17 = _T_16 & SLR0_Mem_io_write_finish_14; // @[Top-slr.scala 88:64]
  wire  _T_18 = _T_17 & SLR0_Mem_io_write_finish_15; // @[Top-slr.scala 88:64]
  wire  _T_19 = _T_18 & SLR0_Mem_io_write_finish_16; // @[Top-slr.scala 88:64]
  wire  _T_20 = _T_19 & SLR0_Mem_io_write_finish_17; // @[Top-slr.scala 88:64]
  wire  _T_21 = _T_20 & SLR0_Mem_io_write_finish_18; // @[Top-slr.scala 88:64]
  wire  _T_22 = _T_21 & SLR0_Mem_io_write_finish_19; // @[Top-slr.scala 88:64]
  wire  _T_23 = _T_22 & SLR0_Mem_io_write_finish_20; // @[Top-slr.scala 88:64]
  wire  _T_24 = _T_23 & SLR0_Mem_io_write_finish_21; // @[Top-slr.scala 88:64]
  wire  _T_25 = _T_24 & SLR0_Mem_io_write_finish_22; // @[Top-slr.scala 88:64]
  wire  _T_26 = _T_25 & SLR0_Mem_io_write_finish_23; // @[Top-slr.scala 88:64]
  wire  _T_27 = _T_26 & SLR0_Mem_io_write_finish_24; // @[Top-slr.scala 88:64]
  wire  _T_28 = _T_27 & SLR0_Mem_io_write_finish_25; // @[Top-slr.scala 88:64]
  wire  _T_29 = _T_28 & SLR0_Mem_io_write_finish_26; // @[Top-slr.scala 88:64]
  wire  _T_30 = _T_29 & SLR0_Mem_io_write_finish_27; // @[Top-slr.scala 88:64]
  wire  _T_31 = _T_30 & SLR0_Mem_io_write_finish_28; // @[Top-slr.scala 88:64]
  wire  _T_32 = _T_31 & SLR0_Mem_io_write_finish_29; // @[Top-slr.scala 88:64]
  wire  _T_33 = _T_32 & SLR0_Mem_io_write_finish_30; // @[Top-slr.scala 88:64]
  wire  _T_34 = _T_33 & SLR0_Mem_io_write_finish_31; // @[Top-slr.scala 88:64]
  reg  global_write_finish; // @[Top-slr.scala 88:38]
  wire  _T_35 = master_finish_count < 8'hd2; // @[Top-slr.scala 90:53]
  wire  _T_36 = global_write_finish & _T_35; // @[Top-slr.scala 90:30]
  wire [8:0] _T_37 = master_finish_count + 8'h1; // @[Top-slr.scala 91:52]
  wire [7:0] _T_38 = master_finish_count + 8'h1; // @[Top-slr.scala 91:52]
  wire [7:0] _GEN_3 = _T_36 ? _T_38 : master_finish_count; // @[Top-slr.scala 90:61]
  wire  _T_39 = master_finish_count >= 8'hc8; // @[Top-slr.scala 94:29]
  wire  _GEN_4 = _T_39; // @[Top-slr.scala 94:37]
  reg [31:0] node_num_0_r; // @[Top-slr.scala 104:31]
  reg [31:0] current_level_0_r; // @[Top-slr.scala 106:36]
  reg  push_or_pull_0_r; // @[Top-slr.scala 108:35]
  reg  _T_40; // @[Top-slr.scala 115:48]
  reg [31:0] _T_41_CSR_R_offset; // @[Top-slr.scala 118:48]
  reg [31:0] _T_41_CSR_C_offset; // @[Top-slr.scala 118:48]
  reg [31:0] _T_41_CSC_R_offset; // @[Top-slr.scala 118:48]
  reg [31:0] _T_41_CSC_C_offset; // @[Top-slr.scala 118:48]
  reg [31:0] _T_41_level_offset; // @[Top-slr.scala 118:48]
  reg [31:0] node_num_1_r; // @[Top-slr.scala 131:31]
  reg [31:0] current_level_1_r; // @[Top-slr.scala 133:36]
  reg  push_or_pull_1_r; // @[Top-slr.scala 135:35]
  reg  frontier_flag_1_r; // @[Top-slr.scala 137:36]
  reg  start_1_r; // @[Top-slr.scala 139:28]
  reg  p2_end_1_r; // @[Top-slr.scala 141:29]
  reg [31:0] _T_42_CSR_R_offset; // @[Top-slr.scala 148:44]
  reg [31:0] _T_42_CSR_C_offset; // @[Top-slr.scala 148:44]
  reg [31:0] _T_42_CSC_R_offset; // @[Top-slr.scala 148:44]
  reg [31:0] _T_42_CSC_C_offset; // @[Top-slr.scala 148:44]
  reg [31:0] _T_42_level_offset; // @[Top-slr.scala 148:44]
  reg [31:0] _T_43; // @[Top-slr.scala 150:44]
  reg  _T_44; // @[Top-slr.scala 152:44]
  reg [31:0] node_num_2_r; // @[Top-slr.scala 154:31]
  reg [31:0] current_level_2_r; // @[Top-slr.scala 156:36]
  reg  push_or_pull_2_r; // @[Top-slr.scala 158:35]
  reg  frontier_flag_2_r; // @[Top-slr.scala 160:36]
  reg  start_2_r; // @[Top-slr.scala 162:28]
  reg  p2_end_2_r; // @[Top-slr.scala 164:29]
  reg [31:0] _T_45_CSR_R_offset; // @[Top-slr.scala 171:44]
  reg [31:0] _T_45_CSR_C_offset; // @[Top-slr.scala 171:44]
  reg [31:0] _T_45_CSC_R_offset; // @[Top-slr.scala 171:44]
  reg [31:0] _T_45_CSC_C_offset; // @[Top-slr.scala 171:44]
  reg [31:0] _T_45_level_offset; // @[Top-slr.scala 171:44]
  reg [31:0] _T_46; // @[Top-slr.scala 173:44]
  reg  _T_47; // @[Top-slr.scala 175:44]
  reg [31:0] _T_48_push_to_pull_level; // @[Top-slr.scala 180:32]
  reg [31:0] _T_48_pull_to_push_level; // @[Top-slr.scala 180:32]
  reg  _T_49; // @[Top-slr.scala 187:23]
  wire  _GEN_5 = _T_49 ? 1'h0 : _GEN_2; // @[Top-slr.scala 187:49]
  wire [31:0] _GEN_6 = start_pulse ? 32'h0 : _GEN_1; // @[Top-slr.scala 184:22]
  wire  _GEN_7 = start_pulse | _GEN_5; // @[Top-slr.scala 184:22]
  reg  _T_50; // @[Top-slr.scala 192:55]
  reg [31:0] _T_51; // @[Top-slr.scala 193:55]
  reg  _T_52; // @[Top-slr.scala 192:55]
  reg [31:0] _T_53; // @[Top-slr.scala 193:55]
  reg  _T_54; // @[Top-slr.scala 192:55]
  reg [31:0] _T_55; // @[Top-slr.scala 193:55]
  reg  _T_56; // @[Top-slr.scala 192:55]
  reg [31:0] _T_57; // @[Top-slr.scala 193:55]
  reg  _T_58; // @[Top-slr.scala 192:55]
  reg [31:0] _T_59; // @[Top-slr.scala 193:55]
  reg  _T_60; // @[Top-slr.scala 192:55]
  reg [31:0] _T_61; // @[Top-slr.scala 193:55]
  reg  _T_62; // @[Top-slr.scala 192:55]
  reg [31:0] _T_63; // @[Top-slr.scala 193:55]
  reg  _T_64; // @[Top-slr.scala 192:55]
  reg [31:0] _T_65; // @[Top-slr.scala 193:55]
  reg  _T_66; // @[Top-slr.scala 192:55]
  reg [31:0] _T_67; // @[Top-slr.scala 193:55]
  reg  _T_68; // @[Top-slr.scala 192:55]
  reg [31:0] _T_69; // @[Top-slr.scala 193:55]
  reg  _T_70; // @[Top-slr.scala 192:55]
  reg [31:0] _T_71; // @[Top-slr.scala 193:55]
  reg  _T_72; // @[Top-slr.scala 192:55]
  reg [31:0] _T_73; // @[Top-slr.scala 193:55]
  reg  _T_74; // @[Top-slr.scala 192:55]
  reg [31:0] _T_75; // @[Top-slr.scala 193:55]
  reg  _T_76; // @[Top-slr.scala 192:55]
  reg [31:0] _T_77; // @[Top-slr.scala 193:55]
  reg  _T_78; // @[Top-slr.scala 192:55]
  reg [31:0] _T_79; // @[Top-slr.scala 193:55]
  reg  _T_80; // @[Top-slr.scala 192:55]
  reg [31:0] _T_81; // @[Top-slr.scala 193:55]
  reg  _T_82; // @[Top-slr.scala 192:55]
  reg [31:0] _T_83; // @[Top-slr.scala 193:55]
  reg  _T_84; // @[Top-slr.scala 192:55]
  reg [31:0] _T_85; // @[Top-slr.scala 193:55]
  reg  _T_86; // @[Top-slr.scala 192:55]
  reg [31:0] _T_87; // @[Top-slr.scala 193:55]
  reg  _T_88; // @[Top-slr.scala 192:55]
  reg [31:0] _T_89; // @[Top-slr.scala 193:55]
  reg  _T_90; // @[Top-slr.scala 192:55]
  reg [31:0] _T_91; // @[Top-slr.scala 193:55]
  reg  _T_92; // @[Top-slr.scala 192:55]
  reg [31:0] _T_93; // @[Top-slr.scala 193:55]
  reg  _T_94; // @[Top-slr.scala 192:55]
  reg [31:0] _T_95; // @[Top-slr.scala 193:55]
  reg  _T_96; // @[Top-slr.scala 192:55]
  reg [31:0] _T_97; // @[Top-slr.scala 193:55]
  reg  _T_98; // @[Top-slr.scala 192:55]
  reg [31:0] _T_99; // @[Top-slr.scala 193:55]
  reg  _T_100; // @[Top-slr.scala 192:55]
  reg [31:0] _T_101; // @[Top-slr.scala 193:55]
  reg  _T_102; // @[Top-slr.scala 192:55]
  reg [31:0] _T_103; // @[Top-slr.scala 193:55]
  reg  _T_104; // @[Top-slr.scala 192:55]
  reg [31:0] _T_105; // @[Top-slr.scala 193:55]
  reg  _T_106; // @[Top-slr.scala 192:55]
  reg [31:0] _T_107; // @[Top-slr.scala 193:55]
  reg  _T_108; // @[Top-slr.scala 192:55]
  reg [31:0] _T_109; // @[Top-slr.scala 193:55]
  reg  _T_110; // @[Top-slr.scala 192:55]
  reg [31:0] _T_111; // @[Top-slr.scala 193:55]
  reg  _T_112; // @[Top-slr.scala 192:55]
  reg [31:0] _T_113; // @[Top-slr.scala 193:55]
  reg  _T_114; // @[Top-slr.scala 206:79]
  reg [31:0] _T_115; // @[Top-slr.scala 207:79]
  reg [31:0] _T_116; // @[Top-slr.scala 208:79]
  reg [31:0] _T_117; // @[Top-slr.scala 209:79]
  reg  _T_118; // @[Top-slr.scala 210:79]
  reg  _T_119; // @[Top-slr.scala 211:79]
  reg  _T_120; // @[Top-slr.scala 206:79]
  reg [31:0] _T_121; // @[Top-slr.scala 207:79]
  reg [31:0] _T_122; // @[Top-slr.scala 208:79]
  reg [31:0] _T_123; // @[Top-slr.scala 209:79]
  reg  _T_124; // @[Top-slr.scala 210:79]
  reg  _T_125; // @[Top-slr.scala 211:79]
  reg  _T_126; // @[Top-slr.scala 206:79]
  reg [31:0] _T_127; // @[Top-slr.scala 207:79]
  reg [31:0] _T_128; // @[Top-slr.scala 208:79]
  reg [31:0] _T_129; // @[Top-slr.scala 209:79]
  reg  _T_130; // @[Top-slr.scala 210:79]
  reg  _T_131; // @[Top-slr.scala 211:79]
  reg  _T_132; // @[Top-slr.scala 206:79]
  reg [31:0] _T_133; // @[Top-slr.scala 207:79]
  reg [31:0] _T_134; // @[Top-slr.scala 208:79]
  reg [31:0] _T_135; // @[Top-slr.scala 209:79]
  reg  _T_136; // @[Top-slr.scala 210:79]
  reg  _T_137; // @[Top-slr.scala 211:79]
  reg  _T_138; // @[Top-slr.scala 206:79]
  reg [31:0] _T_139; // @[Top-slr.scala 207:79]
  reg [31:0] _T_140; // @[Top-slr.scala 208:79]
  reg [31:0] _T_141; // @[Top-slr.scala 209:79]
  reg  _T_142; // @[Top-slr.scala 210:79]
  reg  _T_143; // @[Top-slr.scala 211:79]
  reg  _T_144; // @[Top-slr.scala 206:79]
  reg [31:0] _T_145; // @[Top-slr.scala 207:79]
  reg [31:0] _T_146; // @[Top-slr.scala 208:79]
  reg [31:0] _T_147; // @[Top-slr.scala 209:79]
  reg  _T_148; // @[Top-slr.scala 210:79]
  reg  _T_149; // @[Top-slr.scala 211:79]
  reg  _T_150; // @[Top-slr.scala 206:79]
  reg [31:0] _T_151; // @[Top-slr.scala 207:79]
  reg [31:0] _T_152; // @[Top-slr.scala 208:79]
  reg [31:0] _T_153; // @[Top-slr.scala 209:79]
  reg  _T_154; // @[Top-slr.scala 210:79]
  reg  _T_155; // @[Top-slr.scala 211:79]
  reg  _T_156; // @[Top-slr.scala 206:79]
  reg [31:0] _T_157; // @[Top-slr.scala 207:79]
  reg [31:0] _T_158; // @[Top-slr.scala 208:79]
  reg [31:0] _T_159; // @[Top-slr.scala 209:79]
  reg  _T_160; // @[Top-slr.scala 210:79]
  reg  _T_161; // @[Top-slr.scala 211:79]
  reg  _T_162; // @[Top-slr.scala 206:79]
  reg [31:0] _T_163; // @[Top-slr.scala 207:79]
  reg [31:0] _T_164; // @[Top-slr.scala 208:79]
  reg [31:0] _T_165; // @[Top-slr.scala 209:79]
  reg  _T_166; // @[Top-slr.scala 210:79]
  reg  _T_167; // @[Top-slr.scala 211:79]
  reg  _T_168; // @[Top-slr.scala 206:79]
  reg [31:0] _T_169; // @[Top-slr.scala 207:79]
  reg [31:0] _T_170; // @[Top-slr.scala 208:79]
  reg [31:0] _T_171; // @[Top-slr.scala 209:79]
  reg  _T_172; // @[Top-slr.scala 210:79]
  reg  _T_173; // @[Top-slr.scala 211:79]
  reg  _T_174; // @[Top-slr.scala 206:79]
  reg [31:0] _T_175; // @[Top-slr.scala 207:79]
  reg [31:0] _T_176; // @[Top-slr.scala 208:79]
  reg [31:0] _T_177; // @[Top-slr.scala 209:79]
  reg  _T_178; // @[Top-slr.scala 210:79]
  reg  _T_179; // @[Top-slr.scala 211:79]
  reg  _T_180; // @[Top-slr.scala 206:79]
  reg [31:0] _T_181; // @[Top-slr.scala 207:79]
  reg [31:0] _T_182; // @[Top-slr.scala 208:79]
  reg [31:0] _T_183; // @[Top-slr.scala 209:79]
  reg  _T_184; // @[Top-slr.scala 210:79]
  reg  _T_185; // @[Top-slr.scala 211:79]
  reg  _T_186; // @[Top-slr.scala 206:79]
  reg [31:0] _T_187; // @[Top-slr.scala 207:79]
  reg [31:0] _T_188; // @[Top-slr.scala 208:79]
  reg [31:0] _T_189; // @[Top-slr.scala 209:79]
  reg  _T_190; // @[Top-slr.scala 210:79]
  reg  _T_191; // @[Top-slr.scala 211:79]
  reg  _T_192; // @[Top-slr.scala 206:79]
  reg [31:0] _T_193; // @[Top-slr.scala 207:79]
  reg [31:0] _T_194; // @[Top-slr.scala 208:79]
  reg [31:0] _T_195; // @[Top-slr.scala 209:79]
  reg  _T_196; // @[Top-slr.scala 210:79]
  reg  _T_197; // @[Top-slr.scala 211:79]
  reg  _T_198; // @[Top-slr.scala 214:103]
  reg [31:0] _T_199; // @[Top-slr.scala 215:103]
  reg [31:0] _T_200; // @[Top-slr.scala 216:103]
  reg [31:0] _T_201; // @[Top-slr.scala 217:103]
  reg  _T_202; // @[Top-slr.scala 218:103]
  reg  _T_203; // @[Top-slr.scala 219:103]
  reg  _T_204; // @[Top-slr.scala 214:103]
  reg [31:0] _T_205; // @[Top-slr.scala 215:103]
  reg [31:0] _T_206; // @[Top-slr.scala 216:103]
  reg [31:0] _T_207; // @[Top-slr.scala 217:103]
  reg  _T_208; // @[Top-slr.scala 218:103]
  reg  _T_209; // @[Top-slr.scala 219:103]
  reg  _T_210; // @[Top-slr.scala 214:103]
  reg [31:0] _T_211; // @[Top-slr.scala 215:103]
  reg [31:0] _T_212; // @[Top-slr.scala 216:103]
  reg [31:0] _T_213; // @[Top-slr.scala 217:103]
  reg  _T_214; // @[Top-slr.scala 218:103]
  reg  _T_215; // @[Top-slr.scala 219:103]
  reg  _T_216; // @[Top-slr.scala 214:103]
  reg [31:0] _T_217; // @[Top-slr.scala 215:103]
  reg [31:0] _T_218; // @[Top-slr.scala 216:103]
  reg [31:0] _T_219; // @[Top-slr.scala 217:103]
  reg  _T_220; // @[Top-slr.scala 218:103]
  reg  _T_221; // @[Top-slr.scala 219:103]
  reg  _T_222; // @[Top-slr.scala 214:103]
  reg [31:0] _T_223; // @[Top-slr.scala 215:103]
  reg [31:0] _T_224; // @[Top-slr.scala 216:103]
  reg [31:0] _T_225; // @[Top-slr.scala 217:103]
  reg  _T_226; // @[Top-slr.scala 218:103]
  reg  _T_227; // @[Top-slr.scala 219:103]
  reg  _T_228; // @[Top-slr.scala 214:103]
  reg [31:0] _T_229; // @[Top-slr.scala 215:103]
  reg [31:0] _T_230; // @[Top-slr.scala 216:103]
  reg [31:0] _T_231; // @[Top-slr.scala 217:103]
  reg  _T_232; // @[Top-slr.scala 218:103]
  reg  _T_233; // @[Top-slr.scala 219:103]
  reg  _T_234; // @[Top-slr.scala 214:103]
  reg [31:0] _T_235; // @[Top-slr.scala 215:103]
  reg [31:0] _T_236; // @[Top-slr.scala 216:103]
  reg [31:0] _T_237; // @[Top-slr.scala 217:103]
  reg  _T_238; // @[Top-slr.scala 218:103]
  reg  _T_239; // @[Top-slr.scala 219:103]
  reg  _T_240; // @[Top-slr.scala 214:103]
  reg [31:0] _T_241; // @[Top-slr.scala 215:103]
  reg [31:0] _T_242; // @[Top-slr.scala 216:103]
  reg [31:0] _T_243; // @[Top-slr.scala 217:103]
  reg  _T_244; // @[Top-slr.scala 218:103]
  reg  _T_245; // @[Top-slr.scala 219:103]
  reg  _T_246; // @[Top-slr.scala 214:103]
  reg [31:0] _T_247; // @[Top-slr.scala 215:103]
  reg [31:0] _T_248; // @[Top-slr.scala 216:103]
  reg [31:0] _T_249; // @[Top-slr.scala 217:103]
  reg  _T_250; // @[Top-slr.scala 218:103]
  reg  _T_251; // @[Top-slr.scala 219:103]
  reg  _T_252; // @[Top-slr.scala 214:103]
  reg [31:0] _T_253; // @[Top-slr.scala 215:103]
  reg [31:0] _T_254; // @[Top-slr.scala 216:103]
  reg [31:0] _T_255; // @[Top-slr.scala 217:103]
  reg  _T_256; // @[Top-slr.scala 218:103]
  reg  _T_257; // @[Top-slr.scala 219:103]
  reg  _T_258; // @[Top-slr.scala 214:103]
  reg [31:0] _T_259; // @[Top-slr.scala 215:103]
  reg [31:0] _T_260; // @[Top-slr.scala 216:103]
  reg [31:0] _T_261; // @[Top-slr.scala 217:103]
  reg  _T_262; // @[Top-slr.scala 218:103]
  reg  _T_263; // @[Top-slr.scala 219:103]
  reg  _T_264; // @[Top-slr.scala 214:103]
  reg [31:0] _T_265; // @[Top-slr.scala 215:103]
  reg [31:0] _T_266; // @[Top-slr.scala 216:103]
  reg [31:0] _T_267; // @[Top-slr.scala 217:103]
  reg  _T_268; // @[Top-slr.scala 218:103]
  reg  _T_269; // @[Top-slr.scala 219:103]
  reg  _T_270; // @[Top-slr.scala 214:103]
  reg [31:0] _T_271; // @[Top-slr.scala 215:103]
  reg [31:0] _T_272; // @[Top-slr.scala 216:103]
  reg [31:0] _T_273; // @[Top-slr.scala 217:103]
  reg  _T_274; // @[Top-slr.scala 218:103]
  reg  _T_275; // @[Top-slr.scala 219:103]
  reg  _T_276; // @[Top-slr.scala 214:103]
  reg [31:0] _T_277; // @[Top-slr.scala 215:103]
  reg [31:0] _T_278; // @[Top-slr.scala 216:103]
  reg [31:0] _T_279; // @[Top-slr.scala 217:103]
  reg  _T_280; // @[Top-slr.scala 218:103]
  reg  _T_281; // @[Top-slr.scala 219:103]
  reg  _T_282; // @[Top-slr.scala 214:103]
  reg [31:0] _T_283; // @[Top-slr.scala 215:103]
  reg [31:0] _T_284; // @[Top-slr.scala 216:103]
  reg [31:0] _T_285; // @[Top-slr.scala 217:103]
  reg  _T_286; // @[Top-slr.scala 218:103]
  reg  _T_287; // @[Top-slr.scala 219:103]
  reg  _T_288; // @[Top-slr.scala 214:103]
  reg [31:0] _T_289; // @[Top-slr.scala 215:103]
  reg [31:0] _T_290; // @[Top-slr.scala 216:103]
  reg [31:0] _T_291; // @[Top-slr.scala 217:103]
  reg  _T_292; // @[Top-slr.scala 218:103]
  reg  _T_293; // @[Top-slr.scala 219:103]
  reg  _T_294; // @[Top-slr.scala 214:103]
  reg [31:0] _T_295; // @[Top-slr.scala 215:103]
  reg [31:0] _T_296; // @[Top-slr.scala 216:103]
  reg [31:0] _T_297; // @[Top-slr.scala 217:103]
  reg  _T_298; // @[Top-slr.scala 218:103]
  reg  _T_299; // @[Top-slr.scala 219:103]
  reg  _T_300; // @[Top-slr.scala 214:103]
  reg [31:0] _T_301; // @[Top-slr.scala 215:103]
  reg [31:0] _T_302; // @[Top-slr.scala 216:103]
  reg [31:0] _T_303; // @[Top-slr.scala 217:103]
  reg  _T_304; // @[Top-slr.scala 218:103]
  reg  _T_305; // @[Top-slr.scala 219:103]
  reg  p1_end_q_01_slr0_0; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_1; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_2; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_3; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_4; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_5; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_6; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_7; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_8; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_9; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_10; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_11; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_12; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr0_13; // @[Top-slr.scala 237:35]
  reg  p1_end_q_01_slr1_0; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_1; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_2; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_3; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_4; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_5; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_6; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_7; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_8; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_9; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_10; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_11; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_12; // @[Top-slr.scala 238:35]
  reg  p1_end_q_01_slr1_13; // @[Top-slr.scala 238:35]
  reg [63:0] uram_out_a_01_slr0_1_0; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_1; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_2; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_3; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_4; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_5; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_6; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_7; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_8; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_9; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_10; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_11; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_12; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_13; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_14; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_15; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_16; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_17; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_18; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_19; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_20; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_21; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_22; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_23; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_24; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_25; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_26; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_27; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_28; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_29; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_30; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_31; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_32; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_33; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_34; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_35; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_36; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_37; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_38; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_39; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_40; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_41; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_42; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_43; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_44; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_45; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_46; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_47; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_48; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_49; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_50; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_51; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_52; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_53; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_54; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_1_55; // @[Top-slr.scala 247:39]
  reg [63:0] uram_out_a_01_slr0_2_0; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_1; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_2; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_3; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_4; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_5; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_6; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_7; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_8; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_9; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_10; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_11; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_12; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_13; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_14; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_15; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_16; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_17; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_18; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_19; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_20; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_21; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_22; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_23; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_24; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_25; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_26; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_27; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_28; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_29; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_30; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_31; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_32; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_33; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_34; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_35; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_36; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_37; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_38; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_39; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_40; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_41; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_42; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_43; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_44; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_45; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_46; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_47; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_48; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_49; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_50; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_51; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_52; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_53; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_54; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr0_2_55; // @[Top-slr.scala 248:39]
  reg [63:0] uram_out_a_01_slr1_0; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_1; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_2; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_3; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_4; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_5; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_6; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_7; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_8; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_9; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_10; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_11; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_12; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_13; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_14; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_15; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_16; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_17; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_18; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_19; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_20; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_21; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_22; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_23; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_24; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_25; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_26; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_27; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_28; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_29; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_30; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_31; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_32; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_33; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_34; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_35; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_36; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_37; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_38; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_39; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_40; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_41; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_42; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_43; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_44; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_45; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_46; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_47; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_48; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_49; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_50; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_51; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_52; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_53; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_54; // @[Top-slr.scala 249:37]
  reg [63:0] uram_out_a_01_slr1_55; // @[Top-slr.scala 249:37]
  reg [63:0] uram_addr_a_01_slr0_1_0; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_1; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_2; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_3; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_4; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_5; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_6; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_7; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_8; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_9; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_10; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_11; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_12; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_13; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_14; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_15; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_16; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_17; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_18; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_19; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_20; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_21; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_22; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_23; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_24; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_25; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_26; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_27; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_28; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_29; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_30; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_31; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_32; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_33; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_34; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_35; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_36; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_37; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_38; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_39; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_40; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_41; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_42; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_43; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_44; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_45; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_46; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_47; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_48; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_49; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_50; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_51; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_52; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_53; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_54; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_1_55; // @[Top-slr.scala 250:40]
  reg [63:0] uram_addr_a_01_slr0_2_0; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_1; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_2; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_3; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_4; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_5; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_6; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_7; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_8; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_9; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_10; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_11; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_12; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_13; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_14; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_15; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_16; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_17; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_18; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_19; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_20; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_21; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_22; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_23; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_24; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_25; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_26; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_27; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_28; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_29; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_30; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_31; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_32; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_33; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_34; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_35; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_36; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_37; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_38; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_39; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_40; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_41; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_42; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_43; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_44; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_45; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_46; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_47; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_48; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_49; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_50; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_51; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_52; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_53; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_54; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr0_2_55; // @[Top-slr.scala 251:40]
  reg [63:0] uram_addr_a_01_slr1_0; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_1; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_2; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_3; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_4; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_5; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_6; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_7; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_8; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_9; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_10; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_11; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_12; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_13; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_14; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_15; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_16; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_17; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_18; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_19; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_20; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_21; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_22; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_23; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_24; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_25; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_26; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_27; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_28; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_29; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_30; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_31; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_32; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_33; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_34; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_35; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_36; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_37; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_38; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_39; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_40; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_41; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_42; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_43; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_44; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_45; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_46; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_47; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_48; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_49; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_50; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_51; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_52; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_53; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_54; // @[Top-slr.scala 252:38]
  reg [63:0] uram_addr_a_01_slr1_55; // @[Top-slr.scala 252:38]
  reg  _T_314; // @[Top-slr.scala 288:57]
  reg  _T_315; // @[Top-slr.scala 292:59]
  wire [4:0] _T_316 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_317 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_318 = q_R_array_index_slr0_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_319; // @[Top-slr.scala 288:57]
  reg  _T_320; // @[Top-slr.scala 292:59]
  wire [4:0] _T_321 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_322 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_323 = q_R_array_index_slr0_1_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_324; // @[Top-slr.scala 288:57]
  reg  _T_325; // @[Top-slr.scala 292:59]
  wire [4:0] _T_326 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_327 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_328 = q_R_array_index_slr0_2_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_329; // @[Top-slr.scala 288:57]
  reg  _T_330; // @[Top-slr.scala 292:59]
  wire [4:0] _T_331 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_332 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_333 = q_R_array_index_slr0_3_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_334; // @[Top-slr.scala 288:57]
  reg  _T_335; // @[Top-slr.scala 292:59]
  wire [4:0] _T_336 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_337 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_338 = q_R_array_index_slr0_4_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_339; // @[Top-slr.scala 288:57]
  reg  _T_340; // @[Top-slr.scala 292:59]
  wire [4:0] _T_341 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_342 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_343 = q_R_array_index_slr0_5_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_344; // @[Top-slr.scala 288:57]
  reg  _T_345; // @[Top-slr.scala 292:59]
  wire [4:0] _T_346 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_347 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_348 = q_R_array_index_slr0_6_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_349; // @[Top-slr.scala 288:57]
  reg  _T_350; // @[Top-slr.scala 292:59]
  wire [4:0] _T_351 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_352 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_353 = q_R_array_index_slr0_7_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_354; // @[Top-slr.scala 288:57]
  reg  _T_355; // @[Top-slr.scala 292:59]
  wire [4:0] _T_356 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_357 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_358 = q_R_array_index_slr0_8_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_359; // @[Top-slr.scala 288:57]
  reg  _T_360; // @[Top-slr.scala 292:59]
  wire [4:0] _T_361 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_362 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_363 = q_R_array_index_slr0_9_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_364; // @[Top-slr.scala 288:57]
  reg  _T_365; // @[Top-slr.scala 292:59]
  wire [4:0] _T_366 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_367 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_368 = q_R_array_index_slr0_10_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_369; // @[Top-slr.scala 288:57]
  reg  _T_370; // @[Top-slr.scala 292:59]
  wire [4:0] _T_371 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_372 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_373 = q_R_array_index_slr0_11_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_374; // @[Top-slr.scala 288:57]
  reg  _T_375; // @[Top-slr.scala 292:59]
  wire [4:0] _T_376 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_377 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_378 = q_R_array_index_slr0_12_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_379; // @[Top-slr.scala 288:57]
  reg  _T_380; // @[Top-slr.scala 292:59]
  wire [4:0] _T_381 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_382 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_383 = q_R_array_index_slr0_13_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_384; // @[Top-slr.scala 288:57]
  reg  _T_385; // @[Top-slr.scala 292:59]
  wire [4:0] _T_386 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_387 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_388 = q_R_array_index_slr0_14_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_389; // @[Top-slr.scala 288:57]
  reg  _T_390; // @[Top-slr.scala 292:59]
  wire [4:0] _T_391 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_392 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_393 = q_R_array_index_slr0_15_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_394; // @[Top-slr.scala 288:57]
  reg  _T_395; // @[Top-slr.scala 292:59]
  wire [4:0] _T_396 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_397 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_398 = q_R_array_index_slr0_16_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_399; // @[Top-slr.scala 288:57]
  reg  _T_400; // @[Top-slr.scala 292:59]
  wire [4:0] _T_401 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_402 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_403 = q_R_array_index_slr0_17_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_404; // @[Top-slr.scala 288:57]
  reg  _T_405; // @[Top-slr.scala 292:59]
  wire [4:0] _T_406 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_407 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_408 = q_R_array_index_slr0_18_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_409; // @[Top-slr.scala 288:57]
  reg  _T_410; // @[Top-slr.scala 292:59]
  wire [4:0] _T_411 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_412 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_413 = q_R_array_index_slr0_19_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_414; // @[Top-slr.scala 288:57]
  reg  _T_415; // @[Top-slr.scala 292:59]
  wire [4:0] _T_416 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_417 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_418 = q_R_array_index_slr0_20_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_419; // @[Top-slr.scala 288:57]
  reg  _T_420; // @[Top-slr.scala 292:59]
  wire [4:0] _T_421 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_422 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_423 = q_R_array_index_slr0_21_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_424; // @[Top-slr.scala 288:57]
  reg  _T_425; // @[Top-slr.scala 292:59]
  wire [4:0] _T_426 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_427 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_428 = q_R_array_index_slr0_22_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_429; // @[Top-slr.scala 288:57]
  reg  _T_430; // @[Top-slr.scala 292:59]
  wire [4:0] _T_431 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_432 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_433 = q_R_array_index_slr0_23_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_434; // @[Top-slr.scala 288:57]
  reg  _T_435; // @[Top-slr.scala 292:59]
  wire [4:0] _T_436 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_437 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_438 = q_R_array_index_slr0_24_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_439; // @[Top-slr.scala 288:57]
  reg  _T_440; // @[Top-slr.scala 292:59]
  wire [4:0] _T_441 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_442 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_443 = q_R_array_index_slr0_25_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_444; // @[Top-slr.scala 288:57]
  reg  _T_445; // @[Top-slr.scala 292:59]
  wire [4:0] _T_446 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_447 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_448 = q_R_array_index_slr0_26_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_449; // @[Top-slr.scala 288:57]
  reg  _T_450; // @[Top-slr.scala 292:59]
  wire [4:0] _T_451 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_452 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_453 = q_R_array_index_slr0_27_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_454; // @[Top-slr.scala 288:57]
  reg  _T_455; // @[Top-slr.scala 292:59]
  wire [4:0] _T_456 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_457 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_458 = q_R_array_index_slr0_28_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_459; // @[Top-slr.scala 288:57]
  reg  _T_460; // @[Top-slr.scala 292:59]
  wire [4:0] _T_461 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_462 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_463 = q_R_array_index_slr0_29_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_464; // @[Top-slr.scala 288:57]
  reg  _T_465; // @[Top-slr.scala 292:59]
  wire [4:0] _T_466 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_467 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_468 = q_R_array_index_slr0_30_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_469; // @[Top-slr.scala 288:57]
  reg  _T_470; // @[Top-slr.scala 292:59]
  wire [4:0] _T_471 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_472 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_473 = q_R_array_index_slr0_31_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_474; // @[Top-slr.scala 288:57]
  reg  _T_475; // @[Top-slr.scala 292:59]
  wire [4:0] _T_476 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_477 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_478 = q_R_array_index_slr0_32_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_479; // @[Top-slr.scala 288:57]
  reg  _T_480; // @[Top-slr.scala 292:59]
  wire [4:0] _T_481 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_482 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_483 = q_R_array_index_slr0_33_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_484; // @[Top-slr.scala 288:57]
  reg  _T_485; // @[Top-slr.scala 292:59]
  wire [4:0] _T_486 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_487 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_488 = q_R_array_index_slr0_34_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_489; // @[Top-slr.scala 288:57]
  reg  _T_490; // @[Top-slr.scala 292:59]
  wire [4:0] _T_491 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_492 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_493 = q_R_array_index_slr0_35_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_494; // @[Top-slr.scala 288:57]
  reg  _T_495; // @[Top-slr.scala 292:59]
  wire [4:0] _T_496 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_497 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_498 = q_R_array_index_slr0_36_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_499; // @[Top-slr.scala 288:57]
  reg  _T_500; // @[Top-slr.scala 292:59]
  wire [4:0] _T_501 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_502 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_503 = q_R_array_index_slr0_37_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_504; // @[Top-slr.scala 288:57]
  reg  _T_505; // @[Top-slr.scala 292:59]
  wire [4:0] _T_506 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_507 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_508 = q_R_array_index_slr0_38_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_509; // @[Top-slr.scala 288:57]
  reg  _T_510; // @[Top-slr.scala 292:59]
  wire [4:0] _T_511 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_512 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_513 = q_R_array_index_slr0_39_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_514; // @[Top-slr.scala 288:57]
  reg  _T_515; // @[Top-slr.scala 292:59]
  wire [4:0] _T_516 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_517 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_518 = q_R_array_index_slr0_40_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_519; // @[Top-slr.scala 288:57]
  reg  _T_520; // @[Top-slr.scala 292:59]
  wire [4:0] _T_521 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_522 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_523 = q_R_array_index_slr0_41_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_524; // @[Top-slr.scala 288:57]
  reg  _T_525; // @[Top-slr.scala 292:59]
  wire [4:0] _T_526 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_527 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_528 = q_R_array_index_slr0_42_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_529; // @[Top-slr.scala 288:57]
  reg  _T_530; // @[Top-slr.scala 292:59]
  wire [4:0] _T_531 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_532 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_533 = q_R_array_index_slr0_43_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_534; // @[Top-slr.scala 288:57]
  reg  _T_535; // @[Top-slr.scala 292:59]
  wire [4:0] _T_536 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_537 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_538 = q_R_array_index_slr0_44_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_539; // @[Top-slr.scala 288:57]
  reg  _T_540; // @[Top-slr.scala 292:59]
  wire [4:0] _T_541 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_542 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_543 = q_R_array_index_slr0_45_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_544; // @[Top-slr.scala 288:57]
  reg  _T_545; // @[Top-slr.scala 292:59]
  wire [4:0] _T_546 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_547 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_548 = q_R_array_index_slr0_46_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_549; // @[Top-slr.scala 288:57]
  reg  _T_550; // @[Top-slr.scala 292:59]
  wire [4:0] _T_551 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_552 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_553 = q_R_array_index_slr0_47_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_554; // @[Top-slr.scala 288:57]
  reg  _T_555; // @[Top-slr.scala 292:59]
  wire [4:0] _T_556 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_557 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_558 = q_R_array_index_slr0_48_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_559; // @[Top-slr.scala 288:57]
  reg  _T_560; // @[Top-slr.scala 292:59]
  wire [4:0] _T_561 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_562 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_563 = q_R_array_index_slr0_49_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_564; // @[Top-slr.scala 288:57]
  reg  _T_565; // @[Top-slr.scala 292:59]
  wire [4:0] _T_566 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_567 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_568 = q_R_array_index_slr0_50_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_569; // @[Top-slr.scala 288:57]
  reg  _T_570; // @[Top-slr.scala 292:59]
  wire [4:0] _T_571 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_572 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_573 = q_R_array_index_slr0_51_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_574; // @[Top-slr.scala 288:57]
  reg  _T_575; // @[Top-slr.scala 292:59]
  wire [4:0] _T_576 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_577 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_578 = q_R_array_index_slr0_52_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_579; // @[Top-slr.scala 288:57]
  reg  _T_580; // @[Top-slr.scala 292:59]
  wire [4:0] _T_581 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_582 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_583 = q_R_array_index_slr0_53_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_584; // @[Top-slr.scala 288:57]
  reg  _T_585; // @[Top-slr.scala 292:59]
  wire [4:0] _T_586 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_587 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_588 = q_R_array_index_slr0_54_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg  _T_589; // @[Top-slr.scala 288:57]
  reg  _T_590; // @[Top-slr.scala 292:59]
  wire [4:0] _T_591 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire [3:0] _T_592 = 4'h8 - 4'h1; // @[Top-slr.scala 293:69]
  wire  _T_593 = q_R_array_index_slr0_55_io_count < _T_317; // @[Top-slr.scala 293:46]
  reg [31:0] r_array_count__0; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__1; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__2; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__3; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__4; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__5; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__6; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__7; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__8; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__9; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__10; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__11; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__12; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__13; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__14; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__15; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__16; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__17; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__18; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__19; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__20; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__21; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__22; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__23; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__24; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__25; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__26; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__27; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__28; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__29; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__30; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__31; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__32; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__33; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__34; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__35; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__36; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__37; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__38; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__39; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__40; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__41; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__42; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__43; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__44; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__45; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__46; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__47; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__48; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__49; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__50; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__51; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__52; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__53; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__54; // @[Top-slr.scala 307:32]
  reg [31:0] r_array_count__55; // @[Top-slr.scala 307:32]
  wire [32:0] _T_595 = r_array_count__0 + r_array_count__1; // @[Top-slr.scala 308:53]
  wire [31:0] _T_596 = r_array_count__0 + r_array_count__1; // @[Top-slr.scala 308:53]
  wire [32:0] _T_597 = _T_596 + r_array_count__2; // @[Top-slr.scala 308:53]
  wire [31:0] _T_598 = _T_596 + r_array_count__2; // @[Top-slr.scala 308:53]
  wire [32:0] _T_599 = _T_598 + r_array_count__3; // @[Top-slr.scala 308:53]
  wire [31:0] _T_600 = _T_598 + r_array_count__3; // @[Top-slr.scala 308:53]
  wire [32:0] _T_601 = _T_600 + r_array_count__4; // @[Top-slr.scala 308:53]
  wire [31:0] _T_602 = _T_600 + r_array_count__4; // @[Top-slr.scala 308:53]
  wire [32:0] _T_603 = _T_602 + r_array_count__5; // @[Top-slr.scala 308:53]
  wire [31:0] _T_604 = _T_602 + r_array_count__5; // @[Top-slr.scala 308:53]
  wire [32:0] _T_605 = _T_604 + r_array_count__6; // @[Top-slr.scala 308:53]
  wire [31:0] _T_606 = _T_604 + r_array_count__6; // @[Top-slr.scala 308:53]
  wire [32:0] _T_607 = _T_606 + r_array_count__7; // @[Top-slr.scala 308:53]
  wire [31:0] _T_608 = _T_606 + r_array_count__7; // @[Top-slr.scala 308:53]
  wire [32:0] _T_609 = _T_608 + r_array_count__8; // @[Top-slr.scala 308:53]
  wire [31:0] _T_610 = _T_608 + r_array_count__8; // @[Top-slr.scala 308:53]
  wire [32:0] _T_611 = _T_610 + r_array_count__9; // @[Top-slr.scala 308:53]
  wire [31:0] _T_612 = _T_610 + r_array_count__9; // @[Top-slr.scala 308:53]
  wire [32:0] _T_613 = _T_612 + r_array_count__10; // @[Top-slr.scala 308:53]
  wire [31:0] _T_614 = _T_612 + r_array_count__10; // @[Top-slr.scala 308:53]
  wire [32:0] _T_615 = _T_614 + r_array_count__11; // @[Top-slr.scala 308:53]
  wire [31:0] _T_616 = _T_614 + r_array_count__11; // @[Top-slr.scala 308:53]
  wire [32:0] _T_617 = _T_616 + r_array_count__12; // @[Top-slr.scala 308:53]
  wire [31:0] _T_618 = _T_616 + r_array_count__12; // @[Top-slr.scala 308:53]
  wire [32:0] _T_619 = _T_618 + r_array_count__13; // @[Top-slr.scala 308:53]
  wire [31:0] _T_620 = _T_618 + r_array_count__13; // @[Top-slr.scala 308:53]
  wire [32:0] _T_621 = _T_620 + r_array_count__14; // @[Top-slr.scala 308:53]
  wire [31:0] _T_622 = _T_620 + r_array_count__14; // @[Top-slr.scala 308:53]
  wire [32:0] _T_623 = _T_622 + r_array_count__15; // @[Top-slr.scala 308:53]
  wire [31:0] _T_624 = _T_622 + r_array_count__15; // @[Top-slr.scala 308:53]
  wire [32:0] _T_625 = _T_624 + r_array_count__16; // @[Top-slr.scala 308:53]
  wire [31:0] _T_626 = _T_624 + r_array_count__16; // @[Top-slr.scala 308:53]
  wire [32:0] _T_627 = _T_626 + r_array_count__17; // @[Top-slr.scala 308:53]
  wire [31:0] _T_628 = _T_626 + r_array_count__17; // @[Top-slr.scala 308:53]
  wire [32:0] _T_629 = _T_628 + r_array_count__18; // @[Top-slr.scala 308:53]
  wire [31:0] _T_630 = _T_628 + r_array_count__18; // @[Top-slr.scala 308:53]
  wire [32:0] _T_631 = _T_630 + r_array_count__19; // @[Top-slr.scala 308:53]
  wire [31:0] _T_632 = _T_630 + r_array_count__19; // @[Top-slr.scala 308:53]
  wire [32:0] _T_633 = _T_632 + r_array_count__20; // @[Top-slr.scala 308:53]
  wire [31:0] _T_634 = _T_632 + r_array_count__20; // @[Top-slr.scala 308:53]
  wire [32:0] _T_635 = _T_634 + r_array_count__21; // @[Top-slr.scala 308:53]
  wire [31:0] _T_636 = _T_634 + r_array_count__21; // @[Top-slr.scala 308:53]
  wire [32:0] _T_637 = _T_636 + r_array_count__22; // @[Top-slr.scala 308:53]
  wire [31:0] _T_638 = _T_636 + r_array_count__22; // @[Top-slr.scala 308:53]
  wire [32:0] _T_639 = _T_638 + r_array_count__23; // @[Top-slr.scala 308:53]
  wire [31:0] _T_640 = _T_638 + r_array_count__23; // @[Top-slr.scala 308:53]
  wire [32:0] _T_641 = _T_640 + r_array_count__24; // @[Top-slr.scala 308:53]
  wire [31:0] _T_642 = _T_640 + r_array_count__24; // @[Top-slr.scala 308:53]
  wire [32:0] _T_643 = _T_642 + r_array_count__25; // @[Top-slr.scala 308:53]
  wire [31:0] _T_644 = _T_642 + r_array_count__25; // @[Top-slr.scala 308:53]
  wire [32:0] _T_645 = _T_644 + r_array_count__26; // @[Top-slr.scala 308:53]
  wire [31:0] _T_646 = _T_644 + r_array_count__26; // @[Top-slr.scala 308:53]
  wire [32:0] _T_647 = _T_646 + r_array_count__27; // @[Top-slr.scala 308:53]
  wire [31:0] _T_648 = _T_646 + r_array_count__27; // @[Top-slr.scala 308:53]
  wire [32:0] _T_649 = _T_648 + r_array_count__28; // @[Top-slr.scala 308:53]
  wire [31:0] _T_650 = _T_648 + r_array_count__28; // @[Top-slr.scala 308:53]
  wire [32:0] _T_651 = _T_650 + r_array_count__29; // @[Top-slr.scala 308:53]
  wire [31:0] _T_652 = _T_650 + r_array_count__29; // @[Top-slr.scala 308:53]
  wire [32:0] _T_653 = _T_652 + r_array_count__30; // @[Top-slr.scala 308:53]
  wire [31:0] _T_654 = _T_652 + r_array_count__30; // @[Top-slr.scala 308:53]
  wire [32:0] _T_655 = _T_654 + r_array_count__31; // @[Top-slr.scala 308:53]
  wire [31:0] _T_656 = _T_654 + r_array_count__31; // @[Top-slr.scala 308:53]
  wire [32:0] _T_657 = _T_656 + r_array_count__32; // @[Top-slr.scala 308:53]
  wire [31:0] _T_658 = _T_656 + r_array_count__32; // @[Top-slr.scala 308:53]
  wire [32:0] _T_659 = _T_658 + r_array_count__33; // @[Top-slr.scala 308:53]
  wire [31:0] _T_660 = _T_658 + r_array_count__33; // @[Top-slr.scala 308:53]
  wire [32:0] _T_661 = _T_660 + r_array_count__34; // @[Top-slr.scala 308:53]
  wire [31:0] _T_662 = _T_660 + r_array_count__34; // @[Top-slr.scala 308:53]
  wire [32:0] _T_663 = _T_662 + r_array_count__35; // @[Top-slr.scala 308:53]
  wire [31:0] _T_664 = _T_662 + r_array_count__35; // @[Top-slr.scala 308:53]
  wire [32:0] _T_665 = _T_664 + r_array_count__36; // @[Top-slr.scala 308:53]
  wire [31:0] _T_666 = _T_664 + r_array_count__36; // @[Top-slr.scala 308:53]
  wire [32:0] _T_667 = _T_666 + r_array_count__37; // @[Top-slr.scala 308:53]
  wire [31:0] _T_668 = _T_666 + r_array_count__37; // @[Top-slr.scala 308:53]
  wire [32:0] _T_669 = _T_668 + r_array_count__38; // @[Top-slr.scala 308:53]
  wire [31:0] _T_670 = _T_668 + r_array_count__38; // @[Top-slr.scala 308:53]
  wire [32:0] _T_671 = _T_670 + r_array_count__39; // @[Top-slr.scala 308:53]
  wire [31:0] _T_672 = _T_670 + r_array_count__39; // @[Top-slr.scala 308:53]
  wire [32:0] _T_673 = _T_672 + r_array_count__40; // @[Top-slr.scala 308:53]
  wire [31:0] _T_674 = _T_672 + r_array_count__40; // @[Top-slr.scala 308:53]
  wire [32:0] _T_675 = _T_674 + r_array_count__41; // @[Top-slr.scala 308:53]
  wire [31:0] _T_676 = _T_674 + r_array_count__41; // @[Top-slr.scala 308:53]
  wire [32:0] _T_677 = _T_676 + r_array_count__42; // @[Top-slr.scala 308:53]
  wire [31:0] _T_678 = _T_676 + r_array_count__42; // @[Top-slr.scala 308:53]
  wire [32:0] _T_679 = _T_678 + r_array_count__43; // @[Top-slr.scala 308:53]
  wire [31:0] _T_680 = _T_678 + r_array_count__43; // @[Top-slr.scala 308:53]
  wire [32:0] _T_681 = _T_680 + r_array_count__44; // @[Top-slr.scala 308:53]
  wire [31:0] _T_682 = _T_680 + r_array_count__44; // @[Top-slr.scala 308:53]
  wire [32:0] _T_683 = _T_682 + r_array_count__45; // @[Top-slr.scala 308:53]
  wire [31:0] _T_684 = _T_682 + r_array_count__45; // @[Top-slr.scala 308:53]
  wire [32:0] _T_685 = _T_684 + r_array_count__46; // @[Top-slr.scala 308:53]
  wire [31:0] _T_686 = _T_684 + r_array_count__46; // @[Top-slr.scala 308:53]
  wire [32:0] _T_687 = _T_686 + r_array_count__47; // @[Top-slr.scala 308:53]
  wire [31:0] _T_688 = _T_686 + r_array_count__47; // @[Top-slr.scala 308:53]
  wire [32:0] _T_689 = _T_688 + r_array_count__48; // @[Top-slr.scala 308:53]
  wire [31:0] _T_690 = _T_688 + r_array_count__48; // @[Top-slr.scala 308:53]
  wire [32:0] _T_691 = _T_690 + r_array_count__49; // @[Top-slr.scala 308:53]
  wire [31:0] _T_692 = _T_690 + r_array_count__49; // @[Top-slr.scala 308:53]
  wire [32:0] _T_693 = _T_692 + r_array_count__50; // @[Top-slr.scala 308:53]
  wire [31:0] _T_694 = _T_692 + r_array_count__50; // @[Top-slr.scala 308:53]
  wire [32:0] _T_695 = _T_694 + r_array_count__51; // @[Top-slr.scala 308:53]
  wire [31:0] _T_696 = _T_694 + r_array_count__51; // @[Top-slr.scala 308:53]
  wire [32:0] _T_697 = _T_696 + r_array_count__52; // @[Top-slr.scala 308:53]
  wire [31:0] _T_698 = _T_696 + r_array_count__52; // @[Top-slr.scala 308:53]
  wire [32:0] _T_699 = _T_698 + r_array_count__53; // @[Top-slr.scala 308:53]
  wire [31:0] _T_700 = _T_698 + r_array_count__53; // @[Top-slr.scala 308:53]
  wire [32:0] _T_701 = _T_700 + r_array_count__54; // @[Top-slr.scala 308:53]
  wire [31:0] _T_702 = _T_700 + r_array_count__54; // @[Top-slr.scala 308:53]
  wire [32:0] _T_703 = _T_702 + r_array_count__55; // @[Top-slr.scala 308:53]
  wire [31:0] r_array_count_total = _T_702 + r_array_count__55; // @[Top-slr.scala 308:53]
  wire  _T_704 = SLR0_Mem_io_R_array_index_0_valid & SLR0_Mem_io_R_array_index_0_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_705 = r_array_count__0 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_706 = r_array_count__0 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_8 = _T_704 ? _T_706 : r_array_count__0; // @[Top-slr.scala 310:191]
  wire  _T_707 = SLR0_Mem_io_R_array_index_1_valid & SLR0_Mem_io_R_array_index_1_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_708 = r_array_count__1 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_709 = r_array_count__1 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_9 = _T_707 ? _T_709 : r_array_count__1; // @[Top-slr.scala 310:191]
  wire  _T_710 = SLR0_Mem_io_R_array_index_2_valid & SLR0_Mem_io_R_array_index_2_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_711 = r_array_count__2 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_712 = r_array_count__2 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_10 = _T_710 ? _T_712 : r_array_count__2; // @[Top-slr.scala 310:191]
  wire  _T_713 = SLR0_Mem_io_R_array_index_3_valid & SLR0_Mem_io_R_array_index_3_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_714 = r_array_count__3 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_715 = r_array_count__3 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_11 = _T_713 ? _T_715 : r_array_count__3; // @[Top-slr.scala 310:191]
  wire  _T_716 = SLR0_Mem_io_R_array_index_4_valid & SLR0_Mem_io_R_array_index_4_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_717 = r_array_count__4 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_718 = r_array_count__4 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_12 = _T_716 ? _T_718 : r_array_count__4; // @[Top-slr.scala 310:191]
  wire  _T_719 = SLR0_Mem_io_R_array_index_5_valid & SLR0_Mem_io_R_array_index_5_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_720 = r_array_count__5 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_721 = r_array_count__5 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_13 = _T_719 ? _T_721 : r_array_count__5; // @[Top-slr.scala 310:191]
  wire  _T_722 = SLR0_Mem_io_R_array_index_6_valid & SLR0_Mem_io_R_array_index_6_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_723 = r_array_count__6 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_724 = r_array_count__6 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_14 = _T_722 ? _T_724 : r_array_count__6; // @[Top-slr.scala 310:191]
  wire  _T_725 = SLR0_Mem_io_R_array_index_7_valid & SLR0_Mem_io_R_array_index_7_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_726 = r_array_count__7 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_727 = r_array_count__7 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_15 = _T_725 ? _T_727 : r_array_count__7; // @[Top-slr.scala 310:191]
  wire  _T_728 = SLR0_Mem_io_R_array_index_8_valid & SLR0_Mem_io_R_array_index_8_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_729 = r_array_count__8 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_730 = r_array_count__8 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_16 = _T_728 ? _T_730 : r_array_count__8; // @[Top-slr.scala 310:191]
  wire  _T_731 = SLR0_Mem_io_R_array_index_9_valid & SLR0_Mem_io_R_array_index_9_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_732 = r_array_count__9 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_733 = r_array_count__9 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_17 = _T_731 ? _T_733 : r_array_count__9; // @[Top-slr.scala 310:191]
  wire  _T_734 = SLR0_Mem_io_R_array_index_10_valid & SLR0_Mem_io_R_array_index_10_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_735 = r_array_count__10 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_736 = r_array_count__10 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_18 = _T_734 ? _T_736 : r_array_count__10; // @[Top-slr.scala 310:191]
  wire  _T_737 = SLR0_Mem_io_R_array_index_11_valid & SLR0_Mem_io_R_array_index_11_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_738 = r_array_count__11 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_739 = r_array_count__11 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_19 = _T_737 ? _T_739 : r_array_count__11; // @[Top-slr.scala 310:191]
  wire  _T_740 = SLR0_Mem_io_R_array_index_12_valid & SLR0_Mem_io_R_array_index_12_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_741 = r_array_count__12 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_742 = r_array_count__12 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_20 = _T_740 ? _T_742 : r_array_count__12; // @[Top-slr.scala 310:191]
  wire  _T_743 = SLR0_Mem_io_R_array_index_13_valid & SLR0_Mem_io_R_array_index_13_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_744 = r_array_count__13 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_745 = r_array_count__13 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_21 = _T_743 ? _T_745 : r_array_count__13; // @[Top-slr.scala 310:191]
  wire  _T_746 = SLR0_Mem_io_R_array_index_14_valid & SLR0_Mem_io_R_array_index_14_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_747 = r_array_count__14 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_748 = r_array_count__14 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_22 = _T_746 ? _T_748 : r_array_count__14; // @[Top-slr.scala 310:191]
  wire  _T_749 = SLR0_Mem_io_R_array_index_15_valid & SLR0_Mem_io_R_array_index_15_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_750 = r_array_count__15 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_751 = r_array_count__15 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_23 = _T_749 ? _T_751 : r_array_count__15; // @[Top-slr.scala 310:191]
  wire  _T_752 = SLR0_Mem_io_R_array_index_16_valid & SLR0_Mem_io_R_array_index_16_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_753 = r_array_count__16 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_754 = r_array_count__16 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_24 = _T_752 ? _T_754 : r_array_count__16; // @[Top-slr.scala 310:191]
  wire  _T_755 = SLR0_Mem_io_R_array_index_17_valid & SLR0_Mem_io_R_array_index_17_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_756 = r_array_count__17 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_757 = r_array_count__17 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_25 = _T_755 ? _T_757 : r_array_count__17; // @[Top-slr.scala 310:191]
  wire  _T_758 = SLR0_Mem_io_R_array_index_18_valid & SLR0_Mem_io_R_array_index_18_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_759 = r_array_count__18 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_760 = r_array_count__18 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_26 = _T_758 ? _T_760 : r_array_count__18; // @[Top-slr.scala 310:191]
  wire  _T_761 = SLR0_Mem_io_R_array_index_19_valid & SLR0_Mem_io_R_array_index_19_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_762 = r_array_count__19 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_763 = r_array_count__19 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_27 = _T_761 ? _T_763 : r_array_count__19; // @[Top-slr.scala 310:191]
  wire  _T_764 = SLR0_Mem_io_R_array_index_20_valid & SLR0_Mem_io_R_array_index_20_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_765 = r_array_count__20 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_766 = r_array_count__20 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_28 = _T_764 ? _T_766 : r_array_count__20; // @[Top-slr.scala 310:191]
  wire  _T_767 = SLR0_Mem_io_R_array_index_21_valid & SLR0_Mem_io_R_array_index_21_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_768 = r_array_count__21 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_769 = r_array_count__21 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_29 = _T_767 ? _T_769 : r_array_count__21; // @[Top-slr.scala 310:191]
  wire  _T_770 = SLR0_Mem_io_R_array_index_22_valid & SLR0_Mem_io_R_array_index_22_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_771 = r_array_count__22 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_772 = r_array_count__22 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_30 = _T_770 ? _T_772 : r_array_count__22; // @[Top-slr.scala 310:191]
  wire  _T_773 = SLR0_Mem_io_R_array_index_23_valid & SLR0_Mem_io_R_array_index_23_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_774 = r_array_count__23 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_775 = r_array_count__23 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_31 = _T_773 ? _T_775 : r_array_count__23; // @[Top-slr.scala 310:191]
  wire  _T_776 = SLR0_Mem_io_R_array_index_24_valid & SLR0_Mem_io_R_array_index_24_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_777 = r_array_count__24 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_778 = r_array_count__24 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_32 = _T_776 ? _T_778 : r_array_count__24; // @[Top-slr.scala 310:191]
  wire  _T_779 = SLR0_Mem_io_R_array_index_25_valid & SLR0_Mem_io_R_array_index_25_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_780 = r_array_count__25 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_781 = r_array_count__25 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_33 = _T_779 ? _T_781 : r_array_count__25; // @[Top-slr.scala 310:191]
  wire  _T_782 = SLR0_Mem_io_R_array_index_26_valid & SLR0_Mem_io_R_array_index_26_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_783 = r_array_count__26 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_784 = r_array_count__26 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_34 = _T_782 ? _T_784 : r_array_count__26; // @[Top-slr.scala 310:191]
  wire  _T_785 = SLR0_Mem_io_R_array_index_27_valid & SLR0_Mem_io_R_array_index_27_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_786 = r_array_count__27 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_787 = r_array_count__27 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_35 = _T_785 ? _T_787 : r_array_count__27; // @[Top-slr.scala 310:191]
  wire  _T_788 = SLR0_Mem_io_R_array_index_28_valid & SLR0_Mem_io_R_array_index_28_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_789 = r_array_count__28 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_790 = r_array_count__28 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_36 = _T_788 ? _T_790 : r_array_count__28; // @[Top-slr.scala 310:191]
  wire  _T_791 = SLR0_Mem_io_R_array_index_29_valid & SLR0_Mem_io_R_array_index_29_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_792 = r_array_count__29 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_793 = r_array_count__29 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_37 = _T_791 ? _T_793 : r_array_count__29; // @[Top-slr.scala 310:191]
  wire  _T_794 = SLR0_Mem_io_R_array_index_30_valid & SLR0_Mem_io_R_array_index_30_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_795 = r_array_count__30 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_796 = r_array_count__30 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_38 = _T_794 ? _T_796 : r_array_count__30; // @[Top-slr.scala 310:191]
  wire  _T_797 = SLR0_Mem_io_R_array_index_31_valid & SLR0_Mem_io_R_array_index_31_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_798 = r_array_count__31 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_799 = r_array_count__31 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_39 = _T_797 ? _T_799 : r_array_count__31; // @[Top-slr.scala 310:191]
  wire  _T_800 = SLR0_Mem_io_R_array_index_32_valid & SLR0_Mem_io_R_array_index_32_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_801 = r_array_count__32 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_802 = r_array_count__32 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_40 = _T_800 ? _T_802 : r_array_count__32; // @[Top-slr.scala 310:191]
  wire  _T_803 = SLR0_Mem_io_R_array_index_33_valid & SLR0_Mem_io_R_array_index_33_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_804 = r_array_count__33 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_805 = r_array_count__33 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_41 = _T_803 ? _T_805 : r_array_count__33; // @[Top-slr.scala 310:191]
  wire  _T_806 = SLR0_Mem_io_R_array_index_34_valid & SLR0_Mem_io_R_array_index_34_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_807 = r_array_count__34 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_808 = r_array_count__34 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_42 = _T_806 ? _T_808 : r_array_count__34; // @[Top-slr.scala 310:191]
  wire  _T_809 = SLR0_Mem_io_R_array_index_35_valid & SLR0_Mem_io_R_array_index_35_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_810 = r_array_count__35 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_811 = r_array_count__35 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_43 = _T_809 ? _T_811 : r_array_count__35; // @[Top-slr.scala 310:191]
  wire  _T_812 = SLR0_Mem_io_R_array_index_36_valid & SLR0_Mem_io_R_array_index_36_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_813 = r_array_count__36 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_814 = r_array_count__36 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_44 = _T_812 ? _T_814 : r_array_count__36; // @[Top-slr.scala 310:191]
  wire  _T_815 = SLR0_Mem_io_R_array_index_37_valid & SLR0_Mem_io_R_array_index_37_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_816 = r_array_count__37 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_817 = r_array_count__37 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_45 = _T_815 ? _T_817 : r_array_count__37; // @[Top-slr.scala 310:191]
  wire  _T_818 = SLR0_Mem_io_R_array_index_38_valid & SLR0_Mem_io_R_array_index_38_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_819 = r_array_count__38 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_820 = r_array_count__38 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_46 = _T_818 ? _T_820 : r_array_count__38; // @[Top-slr.scala 310:191]
  wire  _T_821 = SLR0_Mem_io_R_array_index_39_valid & SLR0_Mem_io_R_array_index_39_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_822 = r_array_count__39 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_823 = r_array_count__39 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_47 = _T_821 ? _T_823 : r_array_count__39; // @[Top-slr.scala 310:191]
  wire  _T_824 = SLR0_Mem_io_R_array_index_40_valid & SLR0_Mem_io_R_array_index_40_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_825 = r_array_count__40 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_826 = r_array_count__40 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_48 = _T_824 ? _T_826 : r_array_count__40; // @[Top-slr.scala 310:191]
  wire  _T_827 = SLR0_Mem_io_R_array_index_41_valid & SLR0_Mem_io_R_array_index_41_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_828 = r_array_count__41 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_829 = r_array_count__41 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_49 = _T_827 ? _T_829 : r_array_count__41; // @[Top-slr.scala 310:191]
  wire  _T_830 = SLR0_Mem_io_R_array_index_42_valid & SLR0_Mem_io_R_array_index_42_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_831 = r_array_count__42 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_832 = r_array_count__42 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_50 = _T_830 ? _T_832 : r_array_count__42; // @[Top-slr.scala 310:191]
  wire  _T_833 = SLR0_Mem_io_R_array_index_43_valid & SLR0_Mem_io_R_array_index_43_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_834 = r_array_count__43 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_835 = r_array_count__43 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_51 = _T_833 ? _T_835 : r_array_count__43; // @[Top-slr.scala 310:191]
  wire  _T_836 = SLR0_Mem_io_R_array_index_44_valid & SLR0_Mem_io_R_array_index_44_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_837 = r_array_count__44 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_838 = r_array_count__44 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_52 = _T_836 ? _T_838 : r_array_count__44; // @[Top-slr.scala 310:191]
  wire  _T_839 = SLR0_Mem_io_R_array_index_45_valid & SLR0_Mem_io_R_array_index_45_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_840 = r_array_count__45 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_841 = r_array_count__45 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_53 = _T_839 ? _T_841 : r_array_count__45; // @[Top-slr.scala 310:191]
  wire  _T_842 = SLR0_Mem_io_R_array_index_46_valid & SLR0_Mem_io_R_array_index_46_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_843 = r_array_count__46 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_844 = r_array_count__46 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_54 = _T_842 ? _T_844 : r_array_count__46; // @[Top-slr.scala 310:191]
  wire  _T_845 = SLR0_Mem_io_R_array_index_47_valid & SLR0_Mem_io_R_array_index_47_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_846 = r_array_count__47 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_847 = r_array_count__47 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_55 = _T_845 ? _T_847 : r_array_count__47; // @[Top-slr.scala 310:191]
  wire  _T_848 = SLR0_Mem_io_R_array_index_48_valid & SLR0_Mem_io_R_array_index_48_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_849 = r_array_count__48 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_850 = r_array_count__48 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_56 = _T_848 ? _T_850 : r_array_count__48; // @[Top-slr.scala 310:191]
  wire  _T_851 = SLR0_Mem_io_R_array_index_49_valid & SLR0_Mem_io_R_array_index_49_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_852 = r_array_count__49 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_853 = r_array_count__49 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_57 = _T_851 ? _T_853 : r_array_count__49; // @[Top-slr.scala 310:191]
  wire  _T_854 = SLR0_Mem_io_R_array_index_50_valid & SLR0_Mem_io_R_array_index_50_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_855 = r_array_count__50 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_856 = r_array_count__50 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_58 = _T_854 ? _T_856 : r_array_count__50; // @[Top-slr.scala 310:191]
  wire  _T_857 = SLR0_Mem_io_R_array_index_51_valid & SLR0_Mem_io_R_array_index_51_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_858 = r_array_count__51 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_859 = r_array_count__51 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_59 = _T_857 ? _T_859 : r_array_count__51; // @[Top-slr.scala 310:191]
  wire  _T_860 = SLR0_Mem_io_R_array_index_52_valid & SLR0_Mem_io_R_array_index_52_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_861 = r_array_count__52 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_862 = r_array_count__52 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_60 = _T_860 ? _T_862 : r_array_count__52; // @[Top-slr.scala 310:191]
  wire  _T_863 = SLR0_Mem_io_R_array_index_53_valid & SLR0_Mem_io_R_array_index_53_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_864 = r_array_count__53 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_865 = r_array_count__53 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_61 = _T_863 ? _T_865 : r_array_count__53; // @[Top-slr.scala 310:191]
  wire  _T_866 = SLR0_Mem_io_R_array_index_54_valid & SLR0_Mem_io_R_array_index_54_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_867 = r_array_count__54 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_868 = r_array_count__54 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_62 = _T_866 ? _T_868 : r_array_count__54; // @[Top-slr.scala 310:191]
  wire  _T_869 = SLR0_Mem_io_R_array_index_55_valid & SLR0_Mem_io_R_array_index_55_ready; // @[Top-slr.scala 310:101]
  wire [32:0] _T_870 = r_array_count__55 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _T_871 = r_array_count__55 + 32'h1; // @[Top-slr.scala 311:50]
  wire [31:0] _GEN_63 = _T_869 ? _T_871 : r_array_count__55; // @[Top-slr.scala 310:191]
  reg  p1_end_q_02_slr0_0; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_1; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_2; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_3; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_4; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_5; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_6; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_7; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_8; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_9; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_10; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_11; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_12; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_13; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_14; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_15; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_16; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr0_17; // @[Top-slr.scala 326:35]
  reg  p1_end_q_02_slr1_0; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_1; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_2; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_3; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_4; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_5; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_6; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_7; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_8; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_9; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_10; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_11; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_12; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_13; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_14; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_15; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_16; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr1_17; // @[Top-slr.scala 327:35]
  reg  p1_end_q_02_slr2_0; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_1; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_2; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_3; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_4; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_5; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_6; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_7; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_8; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_9; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_10; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_11; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_12; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_13; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_14; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_15; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_16; // @[Top-slr.scala 328:35]
  reg  p1_end_q_02_slr2_17; // @[Top-slr.scala 328:35]
  reg [63:0] uram_out_a_02_slr0_0; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_1; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_2; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_3; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_4; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_5; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_6; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_7; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_8; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_9; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_10; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_11; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_12; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_13; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_14; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_15; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_16; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_17; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_18; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_19; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_20; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_21; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_22; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_23; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_24; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_25; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_26; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_27; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_28; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_29; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_30; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_31; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_32; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_33; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_34; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_35; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_36; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_37; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_38; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_39; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_40; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_41; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_42; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_43; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_44; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_45; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_46; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_47; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_48; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_49; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_50; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_51; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_52; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_53; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_54; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_55; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_56; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_57; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_58; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_59; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_60; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_61; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_62; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_63; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_64; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_65; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_66; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_67; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_68; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_69; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_70; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr0_71; // @[Top-slr.scala 338:37]
  reg [63:0] uram_out_a_02_slr1_0; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_1; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_2; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_3; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_4; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_5; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_6; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_7; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_8; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_9; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_10; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_11; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_12; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_13; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_14; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_15; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_16; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_17; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_18; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_19; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_20; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_21; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_22; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_23; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_24; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_25; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_26; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_27; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_28; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_29; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_30; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_31; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_32; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_33; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_34; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_35; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_36; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_37; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_38; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_39; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_40; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_41; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_42; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_43; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_44; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_45; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_46; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_47; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_48; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_49; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_50; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_51; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_52; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_53; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_54; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_55; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_56; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_57; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_58; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_59; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_60; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_61; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_62; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_63; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_64; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_65; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_66; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_67; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_68; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_69; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_70; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr1_71; // @[Top-slr.scala 339:37]
  reg [63:0] uram_out_a_02_slr2_0; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_1; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_2; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_3; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_4; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_5; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_6; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_7; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_8; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_9; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_10; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_11; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_12; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_13; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_14; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_15; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_16; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_17; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_18; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_19; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_20; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_21; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_22; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_23; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_24; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_25; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_26; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_27; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_28; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_29; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_30; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_31; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_32; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_33; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_34; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_35; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_36; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_37; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_38; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_39; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_40; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_41; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_42; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_43; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_44; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_45; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_46; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_47; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_48; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_49; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_50; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_51; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_52; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_53; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_54; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_55; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_56; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_57; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_58; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_59; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_60; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_61; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_62; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_63; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_64; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_65; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_66; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_67; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_68; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_69; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_70; // @[Top-slr.scala 340:37]
  reg [63:0] uram_out_a_02_slr2_71; // @[Top-slr.scala 340:37]
  reg [63:0] uram_addr_a_02_slr0_0; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_1; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_2; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_3; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_4; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_5; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_6; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_7; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_8; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_9; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_10; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_11; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_12; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_13; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_14; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_15; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_16; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_17; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_18; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_19; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_20; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_21; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_22; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_23; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_24; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_25; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_26; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_27; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_28; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_29; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_30; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_31; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_32; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_33; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_34; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_35; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_36; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_37; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_38; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_39; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_40; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_41; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_42; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_43; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_44; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_45; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_46; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_47; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_48; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_49; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_50; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_51; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_52; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_53; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_54; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_55; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_56; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_57; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_58; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_59; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_60; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_61; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_62; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_63; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_64; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_65; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_66; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_67; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_68; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_69; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_70; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr0_71; // @[Top-slr.scala 341:38]
  reg [63:0] uram_addr_a_02_slr1_0; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_1; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_2; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_3; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_4; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_5; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_6; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_7; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_8; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_9; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_10; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_11; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_12; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_13; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_14; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_15; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_16; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_17; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_18; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_19; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_20; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_21; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_22; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_23; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_24; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_25; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_26; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_27; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_28; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_29; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_30; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_31; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_32; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_33; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_34; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_35; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_36; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_37; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_38; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_39; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_40; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_41; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_42; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_43; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_44; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_45; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_46; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_47; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_48; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_49; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_50; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_51; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_52; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_53; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_54; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_55; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_56; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_57; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_58; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_59; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_60; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_61; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_62; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_63; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_64; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_65; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_66; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_67; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_68; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_69; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_70; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr1_71; // @[Top-slr.scala 342:38]
  reg [63:0] uram_addr_a_02_slr2_0; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_1; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_2; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_3; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_4; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_5; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_6; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_7; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_8; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_9; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_10; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_11; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_12; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_13; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_14; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_15; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_16; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_17; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_18; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_19; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_20; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_21; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_22; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_23; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_24; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_25; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_26; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_27; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_28; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_29; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_30; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_31; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_32; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_33; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_34; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_35; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_36; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_37; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_38; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_39; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_40; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_41; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_42; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_43; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_44; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_45; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_46; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_47; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_48; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_49; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_50; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_51; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_52; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_53; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_54; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_55; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_56; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_57; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_58; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_59; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_60; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_61; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_62; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_63; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_64; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_65; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_66; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_67; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_68; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_69; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_70; // @[Top-slr.scala 343:38]
  reg [63:0] uram_addr_a_02_slr2_71; // @[Top-slr.scala 343:38]
  reg  _T_881; // @[Top-slr.scala 382:57]
  reg  _T_882; // @[Top-slr.scala 386:57]
  reg  _T_883; // @[Top-slr.scala 390:59]
  wire [4:0] _T_884 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_885 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_886 = q_R_array_index_slr0_56_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_887; // @[Top-slr.scala 382:57]
  reg  _T_888; // @[Top-slr.scala 386:57]
  reg  _T_889; // @[Top-slr.scala 390:59]
  wire [4:0] _T_890 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_891 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_892 = q_R_array_index_slr0_57_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_893; // @[Top-slr.scala 382:57]
  reg  _T_894; // @[Top-slr.scala 386:57]
  reg  _T_895; // @[Top-slr.scala 390:59]
  wire [4:0] _T_896 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_897 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_898 = q_R_array_index_slr0_58_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_899; // @[Top-slr.scala 382:57]
  reg  _T_900; // @[Top-slr.scala 386:57]
  reg  _T_901; // @[Top-slr.scala 390:59]
  wire [4:0] _T_902 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_903 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_904 = q_R_array_index_slr0_59_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_905; // @[Top-slr.scala 382:57]
  reg  _T_906; // @[Top-slr.scala 386:57]
  reg  _T_907; // @[Top-slr.scala 390:59]
  wire [4:0] _T_908 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_909 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_910 = q_R_array_index_slr0_60_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_911; // @[Top-slr.scala 382:57]
  reg  _T_912; // @[Top-slr.scala 386:57]
  reg  _T_913; // @[Top-slr.scala 390:59]
  wire [4:0] _T_914 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_915 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_916 = q_R_array_index_slr0_61_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_917; // @[Top-slr.scala 382:57]
  reg  _T_918; // @[Top-slr.scala 386:57]
  reg  _T_919; // @[Top-slr.scala 390:59]
  wire [4:0] _T_920 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_921 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_922 = q_R_array_index_slr0_62_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_923; // @[Top-slr.scala 382:57]
  reg  _T_924; // @[Top-slr.scala 386:57]
  reg  _T_925; // @[Top-slr.scala 390:59]
  wire [4:0] _T_926 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_927 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_928 = q_R_array_index_slr0_63_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_929; // @[Top-slr.scala 382:57]
  reg  _T_930; // @[Top-slr.scala 386:57]
  reg  _T_931; // @[Top-slr.scala 390:59]
  wire [4:0] _T_932 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_933 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_934 = q_R_array_index_slr0_64_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_935; // @[Top-slr.scala 382:57]
  reg  _T_936; // @[Top-slr.scala 386:57]
  reg  _T_937; // @[Top-slr.scala 390:59]
  wire [4:0] _T_938 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_939 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_940 = q_R_array_index_slr0_65_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_941; // @[Top-slr.scala 382:57]
  reg  _T_942; // @[Top-slr.scala 386:57]
  reg  _T_943; // @[Top-slr.scala 390:59]
  wire [4:0] _T_944 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_945 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_946 = q_R_array_index_slr0_66_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_947; // @[Top-slr.scala 382:57]
  reg  _T_948; // @[Top-slr.scala 386:57]
  reg  _T_949; // @[Top-slr.scala 390:59]
  wire [4:0] _T_950 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_951 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_952 = q_R_array_index_slr0_67_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_953; // @[Top-slr.scala 382:57]
  reg  _T_954; // @[Top-slr.scala 386:57]
  reg  _T_955; // @[Top-slr.scala 390:59]
  wire [4:0] _T_956 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_957 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_958 = q_R_array_index_slr0_68_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_959; // @[Top-slr.scala 382:57]
  reg  _T_960; // @[Top-slr.scala 386:57]
  reg  _T_961; // @[Top-slr.scala 390:59]
  wire [4:0] _T_962 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_963 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_964 = q_R_array_index_slr0_69_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_965; // @[Top-slr.scala 382:57]
  reg  _T_966; // @[Top-slr.scala 386:57]
  reg  _T_967; // @[Top-slr.scala 390:59]
  wire [4:0] _T_968 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_969 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_970 = q_R_array_index_slr0_70_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_971; // @[Top-slr.scala 382:57]
  reg  _T_972; // @[Top-slr.scala 386:57]
  reg  _T_973; // @[Top-slr.scala 390:59]
  wire [4:0] _T_974 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_975 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_976 = q_R_array_index_slr0_71_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_977; // @[Top-slr.scala 382:57]
  reg  _T_978; // @[Top-slr.scala 386:57]
  reg  _T_979; // @[Top-slr.scala 390:59]
  wire [4:0] _T_980 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_981 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_982 = q_R_array_index_slr0_72_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_983; // @[Top-slr.scala 382:57]
  reg  _T_984; // @[Top-slr.scala 386:57]
  reg  _T_985; // @[Top-slr.scala 390:59]
  wire [4:0] _T_986 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_987 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_988 = q_R_array_index_slr0_73_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_989; // @[Top-slr.scala 382:57]
  reg  _T_990; // @[Top-slr.scala 386:57]
  reg  _T_991; // @[Top-slr.scala 390:59]
  wire [4:0] _T_992 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_993 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_994 = q_R_array_index_slr0_74_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_995; // @[Top-slr.scala 382:57]
  reg  _T_996; // @[Top-slr.scala 386:57]
  reg  _T_997; // @[Top-slr.scala 390:59]
  wire [4:0] _T_998 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_999 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1000 = q_R_array_index_slr0_75_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1001; // @[Top-slr.scala 382:57]
  reg  _T_1002; // @[Top-slr.scala 386:57]
  reg  _T_1003; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1004 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1005 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1006 = q_R_array_index_slr0_76_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1007; // @[Top-slr.scala 382:57]
  reg  _T_1008; // @[Top-slr.scala 386:57]
  reg  _T_1009; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1010 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1011 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1012 = q_R_array_index_slr0_77_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1013; // @[Top-slr.scala 382:57]
  reg  _T_1014; // @[Top-slr.scala 386:57]
  reg  _T_1015; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1016 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1017 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1018 = q_R_array_index_slr0_78_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1019; // @[Top-slr.scala 382:57]
  reg  _T_1020; // @[Top-slr.scala 386:57]
  reg  _T_1021; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1022 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1023 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1024 = q_R_array_index_slr0_79_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1025; // @[Top-slr.scala 382:57]
  reg  _T_1026; // @[Top-slr.scala 386:57]
  reg  _T_1027; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1028 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1029 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1030 = q_R_array_index_slr0_80_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1031; // @[Top-slr.scala 382:57]
  reg  _T_1032; // @[Top-slr.scala 386:57]
  reg  _T_1033; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1034 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1035 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1036 = q_R_array_index_slr0_81_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1037; // @[Top-slr.scala 382:57]
  reg  _T_1038; // @[Top-slr.scala 386:57]
  reg  _T_1039; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1040 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1041 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1042 = q_R_array_index_slr0_82_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1043; // @[Top-slr.scala 382:57]
  reg  _T_1044; // @[Top-slr.scala 386:57]
  reg  _T_1045; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1046 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1047 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1048 = q_R_array_index_slr0_83_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1049; // @[Top-slr.scala 382:57]
  reg  _T_1050; // @[Top-slr.scala 386:57]
  reg  _T_1051; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1052 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1053 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1054 = q_R_array_index_slr0_84_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1055; // @[Top-slr.scala 382:57]
  reg  _T_1056; // @[Top-slr.scala 386:57]
  reg  _T_1057; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1058 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1059 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1060 = q_R_array_index_slr0_85_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1061; // @[Top-slr.scala 382:57]
  reg  _T_1062; // @[Top-slr.scala 386:57]
  reg  _T_1063; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1064 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1065 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1066 = q_R_array_index_slr0_86_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1067; // @[Top-slr.scala 382:57]
  reg  _T_1068; // @[Top-slr.scala 386:57]
  reg  _T_1069; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1070 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1071 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1072 = q_R_array_index_slr0_87_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1073; // @[Top-slr.scala 382:57]
  reg  _T_1074; // @[Top-slr.scala 386:57]
  reg  _T_1075; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1076 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1077 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1078 = q_R_array_index_slr0_88_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1079; // @[Top-slr.scala 382:57]
  reg  _T_1080; // @[Top-slr.scala 386:57]
  reg  _T_1081; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1082 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1083 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1084 = q_R_array_index_slr0_89_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1085; // @[Top-slr.scala 382:57]
  reg  _T_1086; // @[Top-slr.scala 386:57]
  reg  _T_1087; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1088 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1089 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1090 = q_R_array_index_slr0_90_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1091; // @[Top-slr.scala 382:57]
  reg  _T_1092; // @[Top-slr.scala 386:57]
  reg  _T_1093; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1094 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1095 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1096 = q_R_array_index_slr0_91_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1097; // @[Top-slr.scala 382:57]
  reg  _T_1098; // @[Top-slr.scala 386:57]
  reg  _T_1099; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1100 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1101 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1102 = q_R_array_index_slr0_92_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1103; // @[Top-slr.scala 382:57]
  reg  _T_1104; // @[Top-slr.scala 386:57]
  reg  _T_1105; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1106 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1107 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1108 = q_R_array_index_slr0_93_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1109; // @[Top-slr.scala 382:57]
  reg  _T_1110; // @[Top-slr.scala 386:57]
  reg  _T_1111; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1112 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1113 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1114 = q_R_array_index_slr0_94_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1115; // @[Top-slr.scala 382:57]
  reg  _T_1116; // @[Top-slr.scala 386:57]
  reg  _T_1117; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1118 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1119 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1120 = q_R_array_index_slr0_95_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1121; // @[Top-slr.scala 382:57]
  reg  _T_1122; // @[Top-slr.scala 386:57]
  reg  _T_1123; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1124 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1125 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1126 = q_R_array_index_slr0_96_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1127; // @[Top-slr.scala 382:57]
  reg  _T_1128; // @[Top-slr.scala 386:57]
  reg  _T_1129; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1130 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1131 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1132 = q_R_array_index_slr0_97_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1133; // @[Top-slr.scala 382:57]
  reg  _T_1134; // @[Top-slr.scala 386:57]
  reg  _T_1135; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1136 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1137 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1138 = q_R_array_index_slr0_98_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1139; // @[Top-slr.scala 382:57]
  reg  _T_1140; // @[Top-slr.scala 386:57]
  reg  _T_1141; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1142 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1143 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1144 = q_R_array_index_slr0_99_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1145; // @[Top-slr.scala 382:57]
  reg  _T_1146; // @[Top-slr.scala 386:57]
  reg  _T_1147; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1148 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1149 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1150 = q_R_array_index_slr0_100_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1151; // @[Top-slr.scala 382:57]
  reg  _T_1152; // @[Top-slr.scala 386:57]
  reg  _T_1153; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1154 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1155 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1156 = q_R_array_index_slr0_101_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1157; // @[Top-slr.scala 382:57]
  reg  _T_1158; // @[Top-slr.scala 386:57]
  reg  _T_1159; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1160 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1161 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1162 = q_R_array_index_slr0_102_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1163; // @[Top-slr.scala 382:57]
  reg  _T_1164; // @[Top-slr.scala 386:57]
  reg  _T_1165; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1166 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1167 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1168 = q_R_array_index_slr0_103_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1169; // @[Top-slr.scala 382:57]
  reg  _T_1170; // @[Top-slr.scala 386:57]
  reg  _T_1171; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1172 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1173 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1174 = q_R_array_index_slr0_104_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1175; // @[Top-slr.scala 382:57]
  reg  _T_1176; // @[Top-slr.scala 386:57]
  reg  _T_1177; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1178 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1179 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1180 = q_R_array_index_slr0_105_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1181; // @[Top-slr.scala 382:57]
  reg  _T_1182; // @[Top-slr.scala 386:57]
  reg  _T_1183; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1184 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1185 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1186 = q_R_array_index_slr0_106_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1187; // @[Top-slr.scala 382:57]
  reg  _T_1188; // @[Top-slr.scala 386:57]
  reg  _T_1189; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1190 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1191 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1192 = q_R_array_index_slr0_107_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1193; // @[Top-slr.scala 382:57]
  reg  _T_1194; // @[Top-slr.scala 386:57]
  reg  _T_1195; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1196 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1197 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1198 = q_R_array_index_slr0_108_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1199; // @[Top-slr.scala 382:57]
  reg  _T_1200; // @[Top-slr.scala 386:57]
  reg  _T_1201; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1202 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1203 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1204 = q_R_array_index_slr0_109_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1205; // @[Top-slr.scala 382:57]
  reg  _T_1206; // @[Top-slr.scala 386:57]
  reg  _T_1207; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1208 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1209 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1210 = q_R_array_index_slr0_110_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1211; // @[Top-slr.scala 382:57]
  reg  _T_1212; // @[Top-slr.scala 386:57]
  reg  _T_1213; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1214 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1215 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1216 = q_R_array_index_slr0_111_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1217; // @[Top-slr.scala 382:57]
  reg  _T_1218; // @[Top-slr.scala 386:57]
  reg  _T_1219; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1220 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1221 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1222 = q_R_array_index_slr0_112_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1223; // @[Top-slr.scala 382:57]
  reg  _T_1224; // @[Top-slr.scala 386:57]
  reg  _T_1225; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1226 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1227 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1228 = q_R_array_index_slr0_113_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1229; // @[Top-slr.scala 382:57]
  reg  _T_1230; // @[Top-slr.scala 386:57]
  reg  _T_1231; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1232 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1233 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1234 = q_R_array_index_slr0_114_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1235; // @[Top-slr.scala 382:57]
  reg  _T_1236; // @[Top-slr.scala 386:57]
  reg  _T_1237; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1238 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1239 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1240 = q_R_array_index_slr0_115_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1241; // @[Top-slr.scala 382:57]
  reg  _T_1242; // @[Top-slr.scala 386:57]
  reg  _T_1243; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1244 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1245 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1246 = q_R_array_index_slr0_116_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1247; // @[Top-slr.scala 382:57]
  reg  _T_1248; // @[Top-slr.scala 386:57]
  reg  _T_1249; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1250 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1251 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1252 = q_R_array_index_slr0_117_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1253; // @[Top-slr.scala 382:57]
  reg  _T_1254; // @[Top-slr.scala 386:57]
  reg  _T_1255; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1256 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1257 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1258 = q_R_array_index_slr0_118_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1259; // @[Top-slr.scala 382:57]
  reg  _T_1260; // @[Top-slr.scala 386:57]
  reg  _T_1261; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1262 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1263 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1264 = q_R_array_index_slr0_119_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1265; // @[Top-slr.scala 382:57]
  reg  _T_1266; // @[Top-slr.scala 386:57]
  reg  _T_1267; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1268 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1269 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1270 = q_R_array_index_slr0_120_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1271; // @[Top-slr.scala 382:57]
  reg  _T_1272; // @[Top-slr.scala 386:57]
  reg  _T_1273; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1274 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1275 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1276 = q_R_array_index_slr0_121_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1277; // @[Top-slr.scala 382:57]
  reg  _T_1278; // @[Top-slr.scala 386:57]
  reg  _T_1279; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1280 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1281 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1282 = q_R_array_index_slr0_122_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1283; // @[Top-slr.scala 382:57]
  reg  _T_1284; // @[Top-slr.scala 386:57]
  reg  _T_1285; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1286 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1287 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1288 = q_R_array_index_slr0_123_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1289; // @[Top-slr.scala 382:57]
  reg  _T_1290; // @[Top-slr.scala 386:57]
  reg  _T_1291; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1292 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1293 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1294 = q_R_array_index_slr0_124_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1295; // @[Top-slr.scala 382:57]
  reg  _T_1296; // @[Top-slr.scala 386:57]
  reg  _T_1297; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1298 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1299 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1300 = q_R_array_index_slr0_125_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1301; // @[Top-slr.scala 382:57]
  reg  _T_1302; // @[Top-slr.scala 386:57]
  reg  _T_1303; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1304 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1305 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1306 = q_R_array_index_slr0_126_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg  _T_1307; // @[Top-slr.scala 382:57]
  reg  _T_1308; // @[Top-slr.scala 386:57]
  reg  _T_1309; // @[Top-slr.scala 390:59]
  wire [4:0] _T_1310 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire [3:0] _T_1311 = 4'h8 - 4'h1; // @[Top-slr.scala 391:69]
  wire  _T_1312 = q_R_array_index_slr0_127_io_count < _T_317; // @[Top-slr.scala 391:46]
  reg [31:0] r_array_count_2_0; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_1; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_2; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_3; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_4; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_5; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_6; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_7; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_8; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_9; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_10; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_11; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_12; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_13; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_14; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_15; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_16; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_17; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_18; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_19; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_20; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_21; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_22; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_23; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_24; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_25; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_26; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_27; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_28; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_29; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_30; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_31; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_32; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_33; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_34; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_35; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_36; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_37; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_38; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_39; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_40; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_41; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_42; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_43; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_44; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_45; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_46; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_47; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_48; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_49; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_50; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_51; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_52; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_53; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_54; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_55; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_56; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_57; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_58; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_59; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_60; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_61; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_62; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_63; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_64; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_65; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_66; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_67; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_68; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_69; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_70; // @[Top-slr.scala 401:34]
  reg [31:0] r_array_count_2_71; // @[Top-slr.scala 401:34]
  wire [32:0] _T_1314 = r_array_count_2_0 + r_array_count_2_1; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1315 = r_array_count_2_0 + r_array_count_2_1; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1316 = _T_1315 + r_array_count_2_2; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1317 = _T_1315 + r_array_count_2_2; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1318 = _T_1317 + r_array_count_2_3; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1319 = _T_1317 + r_array_count_2_3; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1320 = _T_1319 + r_array_count_2_4; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1321 = _T_1319 + r_array_count_2_4; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1322 = _T_1321 + r_array_count_2_5; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1323 = _T_1321 + r_array_count_2_5; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1324 = _T_1323 + r_array_count_2_6; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1325 = _T_1323 + r_array_count_2_6; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1326 = _T_1325 + r_array_count_2_7; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1327 = _T_1325 + r_array_count_2_7; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1328 = _T_1327 + r_array_count_2_8; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1329 = _T_1327 + r_array_count_2_8; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1330 = _T_1329 + r_array_count_2_9; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1331 = _T_1329 + r_array_count_2_9; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1332 = _T_1331 + r_array_count_2_10; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1333 = _T_1331 + r_array_count_2_10; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1334 = _T_1333 + r_array_count_2_11; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1335 = _T_1333 + r_array_count_2_11; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1336 = _T_1335 + r_array_count_2_12; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1337 = _T_1335 + r_array_count_2_12; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1338 = _T_1337 + r_array_count_2_13; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1339 = _T_1337 + r_array_count_2_13; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1340 = _T_1339 + r_array_count_2_14; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1341 = _T_1339 + r_array_count_2_14; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1342 = _T_1341 + r_array_count_2_15; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1343 = _T_1341 + r_array_count_2_15; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1344 = _T_1343 + r_array_count_2_16; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1345 = _T_1343 + r_array_count_2_16; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1346 = _T_1345 + r_array_count_2_17; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1347 = _T_1345 + r_array_count_2_17; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1348 = _T_1347 + r_array_count_2_18; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1349 = _T_1347 + r_array_count_2_18; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1350 = _T_1349 + r_array_count_2_19; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1351 = _T_1349 + r_array_count_2_19; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1352 = _T_1351 + r_array_count_2_20; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1353 = _T_1351 + r_array_count_2_20; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1354 = _T_1353 + r_array_count_2_21; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1355 = _T_1353 + r_array_count_2_21; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1356 = _T_1355 + r_array_count_2_22; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1357 = _T_1355 + r_array_count_2_22; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1358 = _T_1357 + r_array_count_2_23; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1359 = _T_1357 + r_array_count_2_23; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1360 = _T_1359 + r_array_count_2_24; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1361 = _T_1359 + r_array_count_2_24; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1362 = _T_1361 + r_array_count_2_25; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1363 = _T_1361 + r_array_count_2_25; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1364 = _T_1363 + r_array_count_2_26; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1365 = _T_1363 + r_array_count_2_26; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1366 = _T_1365 + r_array_count_2_27; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1367 = _T_1365 + r_array_count_2_27; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1368 = _T_1367 + r_array_count_2_28; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1369 = _T_1367 + r_array_count_2_28; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1370 = _T_1369 + r_array_count_2_29; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1371 = _T_1369 + r_array_count_2_29; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1372 = _T_1371 + r_array_count_2_30; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1373 = _T_1371 + r_array_count_2_30; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1374 = _T_1373 + r_array_count_2_31; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1375 = _T_1373 + r_array_count_2_31; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1376 = _T_1375 + r_array_count_2_32; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1377 = _T_1375 + r_array_count_2_32; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1378 = _T_1377 + r_array_count_2_33; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1379 = _T_1377 + r_array_count_2_33; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1380 = _T_1379 + r_array_count_2_34; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1381 = _T_1379 + r_array_count_2_34; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1382 = _T_1381 + r_array_count_2_35; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1383 = _T_1381 + r_array_count_2_35; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1384 = _T_1383 + r_array_count_2_36; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1385 = _T_1383 + r_array_count_2_36; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1386 = _T_1385 + r_array_count_2_37; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1387 = _T_1385 + r_array_count_2_37; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1388 = _T_1387 + r_array_count_2_38; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1389 = _T_1387 + r_array_count_2_38; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1390 = _T_1389 + r_array_count_2_39; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1391 = _T_1389 + r_array_count_2_39; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1392 = _T_1391 + r_array_count_2_40; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1393 = _T_1391 + r_array_count_2_40; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1394 = _T_1393 + r_array_count_2_41; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1395 = _T_1393 + r_array_count_2_41; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1396 = _T_1395 + r_array_count_2_42; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1397 = _T_1395 + r_array_count_2_42; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1398 = _T_1397 + r_array_count_2_43; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1399 = _T_1397 + r_array_count_2_43; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1400 = _T_1399 + r_array_count_2_44; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1401 = _T_1399 + r_array_count_2_44; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1402 = _T_1401 + r_array_count_2_45; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1403 = _T_1401 + r_array_count_2_45; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1404 = _T_1403 + r_array_count_2_46; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1405 = _T_1403 + r_array_count_2_46; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1406 = _T_1405 + r_array_count_2_47; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1407 = _T_1405 + r_array_count_2_47; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1408 = _T_1407 + r_array_count_2_48; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1409 = _T_1407 + r_array_count_2_48; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1410 = _T_1409 + r_array_count_2_49; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1411 = _T_1409 + r_array_count_2_49; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1412 = _T_1411 + r_array_count_2_50; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1413 = _T_1411 + r_array_count_2_50; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1414 = _T_1413 + r_array_count_2_51; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1415 = _T_1413 + r_array_count_2_51; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1416 = _T_1415 + r_array_count_2_52; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1417 = _T_1415 + r_array_count_2_52; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1418 = _T_1417 + r_array_count_2_53; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1419 = _T_1417 + r_array_count_2_53; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1420 = _T_1419 + r_array_count_2_54; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1421 = _T_1419 + r_array_count_2_54; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1422 = _T_1421 + r_array_count_2_55; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1423 = _T_1421 + r_array_count_2_55; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1424 = _T_1423 + r_array_count_2_56; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1425 = _T_1423 + r_array_count_2_56; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1426 = _T_1425 + r_array_count_2_57; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1427 = _T_1425 + r_array_count_2_57; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1428 = _T_1427 + r_array_count_2_58; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1429 = _T_1427 + r_array_count_2_58; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1430 = _T_1429 + r_array_count_2_59; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1431 = _T_1429 + r_array_count_2_59; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1432 = _T_1431 + r_array_count_2_60; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1433 = _T_1431 + r_array_count_2_60; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1434 = _T_1433 + r_array_count_2_61; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1435 = _T_1433 + r_array_count_2_61; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1436 = _T_1435 + r_array_count_2_62; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1437 = _T_1435 + r_array_count_2_62; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1438 = _T_1437 + r_array_count_2_63; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1439 = _T_1437 + r_array_count_2_63; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1440 = _T_1439 + r_array_count_2_64; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1441 = _T_1439 + r_array_count_2_64; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1442 = _T_1441 + r_array_count_2_65; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1443 = _T_1441 + r_array_count_2_65; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1444 = _T_1443 + r_array_count_2_66; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1445 = _T_1443 + r_array_count_2_66; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1446 = _T_1445 + r_array_count_2_67; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1447 = _T_1445 + r_array_count_2_67; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1448 = _T_1447 + r_array_count_2_68; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1449 = _T_1447 + r_array_count_2_68; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1450 = _T_1449 + r_array_count_2_69; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1451 = _T_1449 + r_array_count_2_69; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1452 = _T_1451 + r_array_count_2_70; // @[Top-slr.scala 402:57]
  wire [31:0] _T_1453 = _T_1451 + r_array_count_2_70; // @[Top-slr.scala 402:57]
  wire [32:0] _T_1454 = _T_1453 + r_array_count_2_71; // @[Top-slr.scala 402:57]
  wire [31:0] r_array_count_total_2 = _T_1453 + r_array_count_2_71; // @[Top-slr.scala 402:57]
  wire  _T_1455 = SLR0_Mem_io_R_array_index_56_valid & SLR0_Mem_io_R_array_index_56_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1456 = r_array_count_2_0 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1457 = r_array_count_2_0 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_64 = _T_1455 ? _T_1457 : r_array_count_2_0; // @[Top-slr.scala 404:243]
  wire  _T_1458 = SLR0_Mem_io_R_array_index_57_valid & SLR0_Mem_io_R_array_index_57_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1459 = r_array_count_2_1 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1460 = r_array_count_2_1 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_65 = _T_1458 ? _T_1460 : r_array_count_2_1; // @[Top-slr.scala 404:243]
  wire  _T_1461 = SLR0_Mem_io_R_array_index_58_valid & SLR0_Mem_io_R_array_index_58_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1462 = r_array_count_2_2 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1463 = r_array_count_2_2 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_66 = _T_1461 ? _T_1463 : r_array_count_2_2; // @[Top-slr.scala 404:243]
  wire  _T_1464 = SLR0_Mem_io_R_array_index_59_valid & SLR0_Mem_io_R_array_index_59_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1465 = r_array_count_2_3 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1466 = r_array_count_2_3 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_67 = _T_1464 ? _T_1466 : r_array_count_2_3; // @[Top-slr.scala 404:243]
  wire  _T_1467 = SLR0_Mem_io_R_array_index_60_valid & SLR0_Mem_io_R_array_index_60_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1468 = r_array_count_2_4 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1469 = r_array_count_2_4 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_68 = _T_1467 ? _T_1469 : r_array_count_2_4; // @[Top-slr.scala 404:243]
  wire  _T_1470 = SLR0_Mem_io_R_array_index_61_valid & SLR0_Mem_io_R_array_index_61_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1471 = r_array_count_2_5 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1472 = r_array_count_2_5 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_69 = _T_1470 ? _T_1472 : r_array_count_2_5; // @[Top-slr.scala 404:243]
  wire  _T_1473 = SLR0_Mem_io_R_array_index_62_valid & SLR0_Mem_io_R_array_index_62_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1474 = r_array_count_2_6 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1475 = r_array_count_2_6 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_70 = _T_1473 ? _T_1475 : r_array_count_2_6; // @[Top-slr.scala 404:243]
  wire  _T_1476 = SLR0_Mem_io_R_array_index_63_valid & SLR0_Mem_io_R_array_index_63_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1477 = r_array_count_2_7 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1478 = r_array_count_2_7 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_71 = _T_1476 ? _T_1478 : r_array_count_2_7; // @[Top-slr.scala 404:243]
  wire  _T_1479 = SLR0_Mem_io_R_array_index_64_valid & SLR0_Mem_io_R_array_index_64_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1480 = r_array_count_2_8 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1481 = r_array_count_2_8 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_72 = _T_1479 ? _T_1481 : r_array_count_2_8; // @[Top-slr.scala 404:243]
  wire  _T_1482 = SLR0_Mem_io_R_array_index_65_valid & SLR0_Mem_io_R_array_index_65_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1483 = r_array_count_2_9 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1484 = r_array_count_2_9 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_73 = _T_1482 ? _T_1484 : r_array_count_2_9; // @[Top-slr.scala 404:243]
  wire  _T_1485 = SLR0_Mem_io_R_array_index_66_valid & SLR0_Mem_io_R_array_index_66_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1486 = r_array_count_2_10 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1487 = r_array_count_2_10 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_74 = _T_1485 ? _T_1487 : r_array_count_2_10; // @[Top-slr.scala 404:243]
  wire  _T_1488 = SLR0_Mem_io_R_array_index_67_valid & SLR0_Mem_io_R_array_index_67_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1489 = r_array_count_2_11 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1490 = r_array_count_2_11 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_75 = _T_1488 ? _T_1490 : r_array_count_2_11; // @[Top-slr.scala 404:243]
  wire  _T_1491 = SLR0_Mem_io_R_array_index_68_valid & SLR0_Mem_io_R_array_index_68_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1492 = r_array_count_2_12 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1493 = r_array_count_2_12 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_76 = _T_1491 ? _T_1493 : r_array_count_2_12; // @[Top-slr.scala 404:243]
  wire  _T_1494 = SLR0_Mem_io_R_array_index_69_valid & SLR0_Mem_io_R_array_index_69_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1495 = r_array_count_2_13 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1496 = r_array_count_2_13 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_77 = _T_1494 ? _T_1496 : r_array_count_2_13; // @[Top-slr.scala 404:243]
  wire  _T_1497 = SLR0_Mem_io_R_array_index_70_valid & SLR0_Mem_io_R_array_index_70_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1498 = r_array_count_2_14 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1499 = r_array_count_2_14 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_78 = _T_1497 ? _T_1499 : r_array_count_2_14; // @[Top-slr.scala 404:243]
  wire  _T_1500 = SLR0_Mem_io_R_array_index_71_valid & SLR0_Mem_io_R_array_index_71_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1501 = r_array_count_2_15 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1502 = r_array_count_2_15 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_79 = _T_1500 ? _T_1502 : r_array_count_2_15; // @[Top-slr.scala 404:243]
  wire  _T_1503 = SLR0_Mem_io_R_array_index_72_valid & SLR0_Mem_io_R_array_index_72_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1504 = r_array_count_2_16 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1505 = r_array_count_2_16 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_80 = _T_1503 ? _T_1505 : r_array_count_2_16; // @[Top-slr.scala 404:243]
  wire  _T_1506 = SLR0_Mem_io_R_array_index_73_valid & SLR0_Mem_io_R_array_index_73_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1507 = r_array_count_2_17 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1508 = r_array_count_2_17 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_81 = _T_1506 ? _T_1508 : r_array_count_2_17; // @[Top-slr.scala 404:243]
  wire  _T_1509 = SLR0_Mem_io_R_array_index_74_valid & SLR0_Mem_io_R_array_index_74_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1510 = r_array_count_2_18 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1511 = r_array_count_2_18 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_82 = _T_1509 ? _T_1511 : r_array_count_2_18; // @[Top-slr.scala 404:243]
  wire  _T_1512 = SLR0_Mem_io_R_array_index_75_valid & SLR0_Mem_io_R_array_index_75_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1513 = r_array_count_2_19 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1514 = r_array_count_2_19 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_83 = _T_1512 ? _T_1514 : r_array_count_2_19; // @[Top-slr.scala 404:243]
  wire  _T_1515 = SLR0_Mem_io_R_array_index_76_valid & SLR0_Mem_io_R_array_index_76_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1516 = r_array_count_2_20 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1517 = r_array_count_2_20 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_84 = _T_1515 ? _T_1517 : r_array_count_2_20; // @[Top-slr.scala 404:243]
  wire  _T_1518 = SLR0_Mem_io_R_array_index_77_valid & SLR0_Mem_io_R_array_index_77_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1519 = r_array_count_2_21 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1520 = r_array_count_2_21 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_85 = _T_1518 ? _T_1520 : r_array_count_2_21; // @[Top-slr.scala 404:243]
  wire  _T_1521 = SLR0_Mem_io_R_array_index_78_valid & SLR0_Mem_io_R_array_index_78_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1522 = r_array_count_2_22 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1523 = r_array_count_2_22 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_86 = _T_1521 ? _T_1523 : r_array_count_2_22; // @[Top-slr.scala 404:243]
  wire  _T_1524 = SLR0_Mem_io_R_array_index_79_valid & SLR0_Mem_io_R_array_index_79_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1525 = r_array_count_2_23 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1526 = r_array_count_2_23 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_87 = _T_1524 ? _T_1526 : r_array_count_2_23; // @[Top-slr.scala 404:243]
  wire  _T_1527 = SLR0_Mem_io_R_array_index_80_valid & SLR0_Mem_io_R_array_index_80_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1528 = r_array_count_2_24 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1529 = r_array_count_2_24 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_88 = _T_1527 ? _T_1529 : r_array_count_2_24; // @[Top-slr.scala 404:243]
  wire  _T_1530 = SLR0_Mem_io_R_array_index_81_valid & SLR0_Mem_io_R_array_index_81_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1531 = r_array_count_2_25 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1532 = r_array_count_2_25 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_89 = _T_1530 ? _T_1532 : r_array_count_2_25; // @[Top-slr.scala 404:243]
  wire  _T_1533 = SLR0_Mem_io_R_array_index_82_valid & SLR0_Mem_io_R_array_index_82_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1534 = r_array_count_2_26 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1535 = r_array_count_2_26 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_90 = _T_1533 ? _T_1535 : r_array_count_2_26; // @[Top-slr.scala 404:243]
  wire  _T_1536 = SLR0_Mem_io_R_array_index_83_valid & SLR0_Mem_io_R_array_index_83_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1537 = r_array_count_2_27 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1538 = r_array_count_2_27 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_91 = _T_1536 ? _T_1538 : r_array_count_2_27; // @[Top-slr.scala 404:243]
  wire  _T_1539 = SLR0_Mem_io_R_array_index_84_valid & SLR0_Mem_io_R_array_index_84_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1540 = r_array_count_2_28 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1541 = r_array_count_2_28 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_92 = _T_1539 ? _T_1541 : r_array_count_2_28; // @[Top-slr.scala 404:243]
  wire  _T_1542 = SLR0_Mem_io_R_array_index_85_valid & SLR0_Mem_io_R_array_index_85_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1543 = r_array_count_2_29 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1544 = r_array_count_2_29 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_93 = _T_1542 ? _T_1544 : r_array_count_2_29; // @[Top-slr.scala 404:243]
  wire  _T_1545 = SLR0_Mem_io_R_array_index_86_valid & SLR0_Mem_io_R_array_index_86_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1546 = r_array_count_2_30 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1547 = r_array_count_2_30 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_94 = _T_1545 ? _T_1547 : r_array_count_2_30; // @[Top-slr.scala 404:243]
  wire  _T_1548 = SLR0_Mem_io_R_array_index_87_valid & SLR0_Mem_io_R_array_index_87_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1549 = r_array_count_2_31 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1550 = r_array_count_2_31 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_95 = _T_1548 ? _T_1550 : r_array_count_2_31; // @[Top-slr.scala 404:243]
  wire  _T_1551 = SLR0_Mem_io_R_array_index_88_valid & SLR0_Mem_io_R_array_index_88_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1552 = r_array_count_2_32 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1553 = r_array_count_2_32 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_96 = _T_1551 ? _T_1553 : r_array_count_2_32; // @[Top-slr.scala 404:243]
  wire  _T_1554 = SLR0_Mem_io_R_array_index_89_valid & SLR0_Mem_io_R_array_index_89_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1555 = r_array_count_2_33 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1556 = r_array_count_2_33 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_97 = _T_1554 ? _T_1556 : r_array_count_2_33; // @[Top-slr.scala 404:243]
  wire  _T_1557 = SLR0_Mem_io_R_array_index_90_valid & SLR0_Mem_io_R_array_index_90_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1558 = r_array_count_2_34 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1559 = r_array_count_2_34 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_98 = _T_1557 ? _T_1559 : r_array_count_2_34; // @[Top-slr.scala 404:243]
  wire  _T_1560 = SLR0_Mem_io_R_array_index_91_valid & SLR0_Mem_io_R_array_index_91_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1561 = r_array_count_2_35 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1562 = r_array_count_2_35 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_99 = _T_1560 ? _T_1562 : r_array_count_2_35; // @[Top-slr.scala 404:243]
  wire  _T_1563 = SLR0_Mem_io_R_array_index_92_valid & SLR0_Mem_io_R_array_index_92_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1564 = r_array_count_2_36 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1565 = r_array_count_2_36 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_100 = _T_1563 ? _T_1565 : r_array_count_2_36; // @[Top-slr.scala 404:243]
  wire  _T_1566 = SLR0_Mem_io_R_array_index_93_valid & SLR0_Mem_io_R_array_index_93_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1567 = r_array_count_2_37 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1568 = r_array_count_2_37 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_101 = _T_1566 ? _T_1568 : r_array_count_2_37; // @[Top-slr.scala 404:243]
  wire  _T_1569 = SLR0_Mem_io_R_array_index_94_valid & SLR0_Mem_io_R_array_index_94_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1570 = r_array_count_2_38 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1571 = r_array_count_2_38 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_102 = _T_1569 ? _T_1571 : r_array_count_2_38; // @[Top-slr.scala 404:243]
  wire  _T_1572 = SLR0_Mem_io_R_array_index_95_valid & SLR0_Mem_io_R_array_index_95_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1573 = r_array_count_2_39 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1574 = r_array_count_2_39 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_103 = _T_1572 ? _T_1574 : r_array_count_2_39; // @[Top-slr.scala 404:243]
  wire  _T_1575 = SLR0_Mem_io_R_array_index_96_valid & SLR0_Mem_io_R_array_index_96_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1576 = r_array_count_2_40 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1577 = r_array_count_2_40 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_104 = _T_1575 ? _T_1577 : r_array_count_2_40; // @[Top-slr.scala 404:243]
  wire  _T_1578 = SLR0_Mem_io_R_array_index_97_valid & SLR0_Mem_io_R_array_index_97_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1579 = r_array_count_2_41 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1580 = r_array_count_2_41 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_105 = _T_1578 ? _T_1580 : r_array_count_2_41; // @[Top-slr.scala 404:243]
  wire  _T_1581 = SLR0_Mem_io_R_array_index_98_valid & SLR0_Mem_io_R_array_index_98_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1582 = r_array_count_2_42 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1583 = r_array_count_2_42 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_106 = _T_1581 ? _T_1583 : r_array_count_2_42; // @[Top-slr.scala 404:243]
  wire  _T_1584 = SLR0_Mem_io_R_array_index_99_valid & SLR0_Mem_io_R_array_index_99_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1585 = r_array_count_2_43 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1586 = r_array_count_2_43 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_107 = _T_1584 ? _T_1586 : r_array_count_2_43; // @[Top-slr.scala 404:243]
  wire  _T_1587 = SLR0_Mem_io_R_array_index_100_valid & SLR0_Mem_io_R_array_index_100_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1588 = r_array_count_2_44 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1589 = r_array_count_2_44 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_108 = _T_1587 ? _T_1589 : r_array_count_2_44; // @[Top-slr.scala 404:243]
  wire  _T_1590 = SLR0_Mem_io_R_array_index_101_valid & SLR0_Mem_io_R_array_index_101_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1591 = r_array_count_2_45 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1592 = r_array_count_2_45 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_109 = _T_1590 ? _T_1592 : r_array_count_2_45; // @[Top-slr.scala 404:243]
  wire  _T_1593 = SLR0_Mem_io_R_array_index_102_valid & SLR0_Mem_io_R_array_index_102_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1594 = r_array_count_2_46 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1595 = r_array_count_2_46 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_110 = _T_1593 ? _T_1595 : r_array_count_2_46; // @[Top-slr.scala 404:243]
  wire  _T_1596 = SLR0_Mem_io_R_array_index_103_valid & SLR0_Mem_io_R_array_index_103_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1597 = r_array_count_2_47 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1598 = r_array_count_2_47 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_111 = _T_1596 ? _T_1598 : r_array_count_2_47; // @[Top-slr.scala 404:243]
  wire  _T_1599 = SLR0_Mem_io_R_array_index_104_valid & SLR0_Mem_io_R_array_index_104_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1600 = r_array_count_2_48 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1601 = r_array_count_2_48 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_112 = _T_1599 ? _T_1601 : r_array_count_2_48; // @[Top-slr.scala 404:243]
  wire  _T_1602 = SLR0_Mem_io_R_array_index_105_valid & SLR0_Mem_io_R_array_index_105_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1603 = r_array_count_2_49 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1604 = r_array_count_2_49 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_113 = _T_1602 ? _T_1604 : r_array_count_2_49; // @[Top-slr.scala 404:243]
  wire  _T_1605 = SLR0_Mem_io_R_array_index_106_valid & SLR0_Mem_io_R_array_index_106_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1606 = r_array_count_2_50 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1607 = r_array_count_2_50 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_114 = _T_1605 ? _T_1607 : r_array_count_2_50; // @[Top-slr.scala 404:243]
  wire  _T_1608 = SLR0_Mem_io_R_array_index_107_valid & SLR0_Mem_io_R_array_index_107_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1609 = r_array_count_2_51 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1610 = r_array_count_2_51 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_115 = _T_1608 ? _T_1610 : r_array_count_2_51; // @[Top-slr.scala 404:243]
  wire  _T_1611 = SLR0_Mem_io_R_array_index_108_valid & SLR0_Mem_io_R_array_index_108_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1612 = r_array_count_2_52 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1613 = r_array_count_2_52 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_116 = _T_1611 ? _T_1613 : r_array_count_2_52; // @[Top-slr.scala 404:243]
  wire  _T_1614 = SLR0_Mem_io_R_array_index_109_valid & SLR0_Mem_io_R_array_index_109_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1615 = r_array_count_2_53 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1616 = r_array_count_2_53 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_117 = _T_1614 ? _T_1616 : r_array_count_2_53; // @[Top-slr.scala 404:243]
  wire  _T_1617 = SLR0_Mem_io_R_array_index_110_valid & SLR0_Mem_io_R_array_index_110_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1618 = r_array_count_2_54 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1619 = r_array_count_2_54 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_118 = _T_1617 ? _T_1619 : r_array_count_2_54; // @[Top-slr.scala 404:243]
  wire  _T_1620 = SLR0_Mem_io_R_array_index_111_valid & SLR0_Mem_io_R_array_index_111_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1621 = r_array_count_2_55 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1622 = r_array_count_2_55 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_119 = _T_1620 ? _T_1622 : r_array_count_2_55; // @[Top-slr.scala 404:243]
  wire  _T_1623 = SLR0_Mem_io_R_array_index_112_valid & SLR0_Mem_io_R_array_index_112_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1624 = r_array_count_2_56 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1625 = r_array_count_2_56 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_120 = _T_1623 ? _T_1625 : r_array_count_2_56; // @[Top-slr.scala 404:243]
  wire  _T_1626 = SLR0_Mem_io_R_array_index_113_valid & SLR0_Mem_io_R_array_index_113_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1627 = r_array_count_2_57 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1628 = r_array_count_2_57 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_121 = _T_1626 ? _T_1628 : r_array_count_2_57; // @[Top-slr.scala 404:243]
  wire  _T_1629 = SLR0_Mem_io_R_array_index_114_valid & SLR0_Mem_io_R_array_index_114_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1630 = r_array_count_2_58 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1631 = r_array_count_2_58 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_122 = _T_1629 ? _T_1631 : r_array_count_2_58; // @[Top-slr.scala 404:243]
  wire  _T_1632 = SLR0_Mem_io_R_array_index_115_valid & SLR0_Mem_io_R_array_index_115_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1633 = r_array_count_2_59 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1634 = r_array_count_2_59 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_123 = _T_1632 ? _T_1634 : r_array_count_2_59; // @[Top-slr.scala 404:243]
  wire  _T_1635 = SLR0_Mem_io_R_array_index_116_valid & SLR0_Mem_io_R_array_index_116_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1636 = r_array_count_2_60 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1637 = r_array_count_2_60 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_124 = _T_1635 ? _T_1637 : r_array_count_2_60; // @[Top-slr.scala 404:243]
  wire  _T_1638 = SLR0_Mem_io_R_array_index_117_valid & SLR0_Mem_io_R_array_index_117_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1639 = r_array_count_2_61 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1640 = r_array_count_2_61 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_125 = _T_1638 ? _T_1640 : r_array_count_2_61; // @[Top-slr.scala 404:243]
  wire  _T_1641 = SLR0_Mem_io_R_array_index_118_valid & SLR0_Mem_io_R_array_index_118_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1642 = r_array_count_2_62 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1643 = r_array_count_2_62 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_126 = _T_1641 ? _T_1643 : r_array_count_2_62; // @[Top-slr.scala 404:243]
  wire  _T_1644 = SLR0_Mem_io_R_array_index_119_valid & SLR0_Mem_io_R_array_index_119_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1645 = r_array_count_2_63 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1646 = r_array_count_2_63 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_127 = _T_1644 ? _T_1646 : r_array_count_2_63; // @[Top-slr.scala 404:243]
  wire  _T_1647 = SLR0_Mem_io_R_array_index_120_valid & SLR0_Mem_io_R_array_index_120_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1648 = r_array_count_2_64 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1649 = r_array_count_2_64 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_128 = _T_1647 ? _T_1649 : r_array_count_2_64; // @[Top-slr.scala 404:243]
  wire  _T_1650 = SLR0_Mem_io_R_array_index_121_valid & SLR0_Mem_io_R_array_index_121_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1651 = r_array_count_2_65 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1652 = r_array_count_2_65 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_129 = _T_1650 ? _T_1652 : r_array_count_2_65; // @[Top-slr.scala 404:243]
  wire  _T_1653 = SLR0_Mem_io_R_array_index_122_valid & SLR0_Mem_io_R_array_index_122_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1654 = r_array_count_2_66 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1655 = r_array_count_2_66 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_130 = _T_1653 ? _T_1655 : r_array_count_2_66; // @[Top-slr.scala 404:243]
  wire  _T_1656 = SLR0_Mem_io_R_array_index_123_valid & SLR0_Mem_io_R_array_index_123_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1657 = r_array_count_2_67 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1658 = r_array_count_2_67 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_131 = _T_1656 ? _T_1658 : r_array_count_2_67; // @[Top-slr.scala 404:243]
  wire  _T_1659 = SLR0_Mem_io_R_array_index_124_valid & SLR0_Mem_io_R_array_index_124_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1660 = r_array_count_2_68 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1661 = r_array_count_2_68 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_132 = _T_1659 ? _T_1661 : r_array_count_2_68; // @[Top-slr.scala 404:243]
  wire  _T_1662 = SLR0_Mem_io_R_array_index_125_valid & SLR0_Mem_io_R_array_index_125_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1663 = r_array_count_2_69 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1664 = r_array_count_2_69 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_133 = _T_1662 ? _T_1664 : r_array_count_2_69; // @[Top-slr.scala 404:243]
  wire  _T_1665 = SLR0_Mem_io_R_array_index_126_valid & SLR0_Mem_io_R_array_index_126_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1666 = r_array_count_2_70 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1667 = r_array_count_2_70 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_134 = _T_1665 ? _T_1667 : r_array_count_2_70; // @[Top-slr.scala 404:243]
  wire  _T_1668 = SLR0_Mem_io_R_array_index_127_valid & SLR0_Mem_io_R_array_index_127_ready; // @[Top-slr.scala 404:127]
  wire [32:0] _T_1669 = r_array_count_2_71 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _T_1670 = r_array_count_2_71 + 32'h1; // @[Top-slr.scala 405:54]
  wire [31:0] _GEN_135 = _T_1668 ? _T_1670 : r_array_count_2_71; // @[Top-slr.scala 404:243]
  reg  _T_1671; // @[Top-slr.scala 466:25]
  wire  _T_1672 = ~_T_1671; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_136 = SLR1_io_p2_out_0_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_137 = _T_1672 ? 1'h0 : SLR1_io_p2_out_0_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_138 = SLR1_io_frontier_in_0_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_139 = _T_1672 ? SLR1_io_p2_out_0_bits : {{8'd0}, crossbar_array_visit_io_out_0_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_140 = _T_1672 ? SLR1_io_p2_out_0_valid : crossbar_array_visit_io_out_0_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_141 = _T_1672 ? SLR1_io_frontier_in_0_ready : crossbar_array_visit_io_in_0_ready; // @[Top-slr.scala 466:58]
  reg  _T_1673; // @[Top-slr.scala 466:25]
  wire  _T_1674 = ~_T_1673; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_142 = SLR1_io_p2_out_1_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_143 = _T_1674 ? 1'h0 : SLR1_io_p2_out_1_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_144 = SLR1_io_frontier_in_1_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_145 = _T_1674 ? SLR1_io_p2_out_1_bits : {{8'd0}, crossbar_array_visit_io_out_32_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_146 = _T_1674 ? SLR1_io_p2_out_1_valid : crossbar_array_visit_io_out_32_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_147 = _T_1674 ? SLR1_io_frontier_in_1_ready : crossbar_array_visit_io_in_32_ready; // @[Top-slr.scala 466:58]
  reg  _T_1675; // @[Top-slr.scala 466:25]
  wire  _T_1676 = ~_T_1675; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_148 = SLR1_io_p2_out_2_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_149 = _T_1676 ? 1'h0 : SLR1_io_p2_out_2_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_150 = SLR1_io_frontier_in_2_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_151 = _T_1676 ? SLR1_io_p2_out_2_bits : {{8'd0}, crossbar_array_visit_io_out_64_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_152 = _T_1676 ? SLR1_io_p2_out_2_valid : crossbar_array_visit_io_out_64_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_153 = _T_1676 ? SLR1_io_frontier_in_2_ready : crossbar_array_visit_io_in_64_ready; // @[Top-slr.scala 466:58]
  reg  _T_1677; // @[Top-slr.scala 466:25]
  wire  _T_1678 = ~_T_1677; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_154 = SLR1_io_p2_out_3_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_155 = _T_1678 ? 1'h0 : SLR1_io_p2_out_3_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_156 = SLR1_io_frontier_in_3_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_157 = _T_1678 ? SLR1_io_p2_out_3_bits : {{8'd0}, crossbar_array_visit_io_out_96_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_158 = _T_1678 ? SLR1_io_p2_out_3_valid : crossbar_array_visit_io_out_96_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_159 = _T_1678 ? SLR1_io_frontier_in_3_ready : crossbar_array_visit_io_in_96_ready; // @[Top-slr.scala 466:58]
  reg  _T_1679; // @[Top-slr.scala 466:25]
  wire  _T_1680 = ~_T_1679; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_160 = SLR1_io_p2_out_4_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_161 = _T_1680 ? 1'h0 : SLR1_io_p2_out_4_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_162 = SLR1_io_frontier_in_4_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_163 = _T_1680 ? SLR1_io_p2_out_4_bits : {{8'd0}, crossbar_array_visit_io_out_1_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_164 = _T_1680 ? SLR1_io_p2_out_4_valid : crossbar_array_visit_io_out_1_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_165 = _T_1680 ? SLR1_io_frontier_in_4_ready : crossbar_array_visit_io_in_1_ready; // @[Top-slr.scala 466:58]
  reg  _T_1681; // @[Top-slr.scala 466:25]
  wire  _T_1682 = ~_T_1681; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_166 = SLR1_io_p2_out_5_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_167 = _T_1682 ? 1'h0 : SLR1_io_p2_out_5_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_168 = SLR1_io_frontier_in_5_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_169 = _T_1682 ? SLR1_io_p2_out_5_bits : {{8'd0}, crossbar_array_visit_io_out_33_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_170 = _T_1682 ? SLR1_io_p2_out_5_valid : crossbar_array_visit_io_out_33_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_171 = _T_1682 ? SLR1_io_frontier_in_5_ready : crossbar_array_visit_io_in_33_ready; // @[Top-slr.scala 466:58]
  reg  _T_1683; // @[Top-slr.scala 466:25]
  wire  _T_1684 = ~_T_1683; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_172 = SLR1_io_p2_out_6_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_173 = _T_1684 ? 1'h0 : SLR1_io_p2_out_6_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_174 = SLR1_io_frontier_in_6_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_175 = _T_1684 ? SLR1_io_p2_out_6_bits : {{8'd0}, crossbar_array_visit_io_out_65_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_176 = _T_1684 ? SLR1_io_p2_out_6_valid : crossbar_array_visit_io_out_65_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_177 = _T_1684 ? SLR1_io_frontier_in_6_ready : crossbar_array_visit_io_in_65_ready; // @[Top-slr.scala 466:58]
  reg  _T_1685; // @[Top-slr.scala 466:25]
  wire  _T_1686 = ~_T_1685; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_178 = SLR1_io_p2_out_7_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_179 = _T_1686 ? 1'h0 : SLR1_io_p2_out_7_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_180 = SLR1_io_frontier_in_7_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_181 = _T_1686 ? SLR1_io_p2_out_7_bits : {{8'd0}, crossbar_array_visit_io_out_97_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_182 = _T_1686 ? SLR1_io_p2_out_7_valid : crossbar_array_visit_io_out_97_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_183 = _T_1686 ? SLR1_io_frontier_in_7_ready : crossbar_array_visit_io_in_97_ready; // @[Top-slr.scala 466:58]
  reg  _T_1687; // @[Top-slr.scala 466:25]
  wire  _T_1688 = ~_T_1687; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_184 = SLR1_io_p2_out_8_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_185 = _T_1688 ? 1'h0 : SLR1_io_p2_out_8_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_186 = SLR1_io_frontier_in_8_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_187 = _T_1688 ? SLR1_io_p2_out_8_bits : {{8'd0}, crossbar_array_visit_io_out_2_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_188 = _T_1688 ? SLR1_io_p2_out_8_valid : crossbar_array_visit_io_out_2_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_189 = _T_1688 ? SLR1_io_frontier_in_8_ready : crossbar_array_visit_io_in_2_ready; // @[Top-slr.scala 466:58]
  reg  _T_1689; // @[Top-slr.scala 466:25]
  wire  _T_1690 = ~_T_1689; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_190 = SLR1_io_p2_out_9_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_191 = _T_1690 ? 1'h0 : SLR1_io_p2_out_9_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_192 = SLR1_io_frontier_in_9_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_193 = _T_1690 ? SLR1_io_p2_out_9_bits : {{8'd0}, crossbar_array_visit_io_out_34_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_194 = _T_1690 ? SLR1_io_p2_out_9_valid : crossbar_array_visit_io_out_34_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_195 = _T_1690 ? SLR1_io_frontier_in_9_ready : crossbar_array_visit_io_in_34_ready; // @[Top-slr.scala 466:58]
  reg  _T_1691; // @[Top-slr.scala 466:25]
  wire  _T_1692 = ~_T_1691; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_196 = SLR1_io_p2_out_10_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_197 = _T_1692 ? 1'h0 : SLR1_io_p2_out_10_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_198 = SLR1_io_frontier_in_10_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_199 = _T_1692 ? SLR1_io_p2_out_10_bits : {{8'd0}, crossbar_array_visit_io_out_66_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_200 = _T_1692 ? SLR1_io_p2_out_10_valid : crossbar_array_visit_io_out_66_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_201 = _T_1692 ? SLR1_io_frontier_in_10_ready : crossbar_array_visit_io_in_66_ready; // @[Top-slr.scala 466:58]
  reg  _T_1693; // @[Top-slr.scala 466:25]
  wire  _T_1694 = ~_T_1693; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_202 = SLR1_io_p2_out_11_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_203 = _T_1694 ? 1'h0 : SLR1_io_p2_out_11_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_204 = SLR1_io_frontier_in_11_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_205 = _T_1694 ? SLR1_io_p2_out_11_bits : {{8'd0}, crossbar_array_visit_io_out_98_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_206 = _T_1694 ? SLR1_io_p2_out_11_valid : crossbar_array_visit_io_out_98_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_207 = _T_1694 ? SLR1_io_frontier_in_11_ready : crossbar_array_visit_io_in_98_ready; // @[Top-slr.scala 466:58]
  reg  _T_1695; // @[Top-slr.scala 466:25]
  wire  _T_1696 = ~_T_1695; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_208 = SLR1_io_p2_out_12_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_209 = _T_1696 ? 1'h0 : SLR1_io_p2_out_12_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_210 = SLR1_io_frontier_in_12_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_211 = _T_1696 ? SLR1_io_p2_out_12_bits : {{8'd0}, crossbar_array_visit_io_out_3_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_212 = _T_1696 ? SLR1_io_p2_out_12_valid : crossbar_array_visit_io_out_3_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_213 = _T_1696 ? SLR1_io_frontier_in_12_ready : crossbar_array_visit_io_in_3_ready; // @[Top-slr.scala 466:58]
  reg  _T_1697; // @[Top-slr.scala 466:25]
  wire  _T_1698 = ~_T_1697; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_214 = SLR1_io_p2_out_13_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_215 = _T_1698 ? 1'h0 : SLR1_io_p2_out_13_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_216 = SLR1_io_frontier_in_13_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_217 = _T_1698 ? SLR1_io_p2_out_13_bits : {{8'd0}, crossbar_array_visit_io_out_35_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_218 = _T_1698 ? SLR1_io_p2_out_13_valid : crossbar_array_visit_io_out_35_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_219 = _T_1698 ? SLR1_io_frontier_in_13_ready : crossbar_array_visit_io_in_35_ready; // @[Top-slr.scala 466:58]
  reg  _T_1699; // @[Top-slr.scala 466:25]
  wire  _T_1700 = ~_T_1699; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_220 = SLR1_io_p2_out_14_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_221 = _T_1700 ? 1'h0 : SLR1_io_p2_out_14_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_222 = SLR1_io_frontier_in_14_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_223 = _T_1700 ? SLR1_io_p2_out_14_bits : {{8'd0}, crossbar_array_visit_io_out_67_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_224 = _T_1700 ? SLR1_io_p2_out_14_valid : crossbar_array_visit_io_out_67_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_225 = _T_1700 ? SLR1_io_frontier_in_14_ready : crossbar_array_visit_io_in_67_ready; // @[Top-slr.scala 466:58]
  reg  _T_1701; // @[Top-slr.scala 466:25]
  wire  _T_1702 = ~_T_1701; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_226 = SLR1_io_p2_out_15_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_227 = _T_1702 ? 1'h0 : SLR1_io_p2_out_15_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_228 = SLR1_io_frontier_in_15_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_229 = _T_1702 ? SLR1_io_p2_out_15_bits : {{8'd0}, crossbar_array_visit_io_out_99_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_230 = _T_1702 ? SLR1_io_p2_out_15_valid : crossbar_array_visit_io_out_99_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_231 = _T_1702 ? SLR1_io_frontier_in_15_ready : crossbar_array_visit_io_in_99_ready; // @[Top-slr.scala 466:58]
  reg  _T_1703; // @[Top-slr.scala 466:25]
  wire  _T_1704 = ~_T_1703; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_232 = SLR1_io_p2_out_16_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_233 = _T_1704 ? 1'h0 : SLR1_io_p2_out_16_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_234 = SLR1_io_frontier_in_16_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_235 = _T_1704 ? SLR1_io_p2_out_16_bits : {{8'd0}, crossbar_array_visit_io_out_4_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_236 = _T_1704 ? SLR1_io_p2_out_16_valid : crossbar_array_visit_io_out_4_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_237 = _T_1704 ? SLR1_io_frontier_in_16_ready : crossbar_array_visit_io_in_4_ready; // @[Top-slr.scala 466:58]
  reg  _T_1705; // @[Top-slr.scala 466:25]
  wire  _T_1706 = ~_T_1705; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_238 = SLR1_io_p2_out_17_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_239 = _T_1706 ? 1'h0 : SLR1_io_p2_out_17_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_240 = SLR1_io_frontier_in_17_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_241 = _T_1706 ? SLR1_io_p2_out_17_bits : {{8'd0}, crossbar_array_visit_io_out_36_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_242 = _T_1706 ? SLR1_io_p2_out_17_valid : crossbar_array_visit_io_out_36_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_243 = _T_1706 ? SLR1_io_frontier_in_17_ready : crossbar_array_visit_io_in_36_ready; // @[Top-slr.scala 466:58]
  reg  _T_1707; // @[Top-slr.scala 466:25]
  wire  _T_1708 = ~_T_1707; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_244 = SLR1_io_p2_out_18_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_245 = _T_1708 ? 1'h0 : SLR1_io_p2_out_18_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_246 = SLR1_io_frontier_in_18_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_247 = _T_1708 ? SLR1_io_p2_out_18_bits : {{8'd0}, crossbar_array_visit_io_out_68_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_248 = _T_1708 ? SLR1_io_p2_out_18_valid : crossbar_array_visit_io_out_68_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_249 = _T_1708 ? SLR1_io_frontier_in_18_ready : crossbar_array_visit_io_in_68_ready; // @[Top-slr.scala 466:58]
  reg  _T_1709; // @[Top-slr.scala 466:25]
  wire  _T_1710 = ~_T_1709; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_250 = SLR1_io_p2_out_19_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_251 = _T_1710 ? 1'h0 : SLR1_io_p2_out_19_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_252 = SLR1_io_frontier_in_19_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_253 = _T_1710 ? SLR1_io_p2_out_19_bits : {{8'd0}, crossbar_array_visit_io_out_100_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_254 = _T_1710 ? SLR1_io_p2_out_19_valid : crossbar_array_visit_io_out_100_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_255 = _T_1710 ? SLR1_io_frontier_in_19_ready : crossbar_array_visit_io_in_100_ready; // @[Top-slr.scala 466:58]
  reg  _T_1711; // @[Top-slr.scala 466:25]
  wire  _T_1712 = ~_T_1711; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_256 = SLR1_io_p2_out_20_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_257 = _T_1712 ? 1'h0 : SLR1_io_p2_out_20_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_258 = SLR1_io_frontier_in_20_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_259 = _T_1712 ? SLR1_io_p2_out_20_bits : {{8'd0}, crossbar_array_visit_io_out_5_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_260 = _T_1712 ? SLR1_io_p2_out_20_valid : crossbar_array_visit_io_out_5_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_261 = _T_1712 ? SLR1_io_frontier_in_20_ready : crossbar_array_visit_io_in_5_ready; // @[Top-slr.scala 466:58]
  reg  _T_1713; // @[Top-slr.scala 466:25]
  wire  _T_1714 = ~_T_1713; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_262 = SLR1_io_p2_out_21_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_263 = _T_1714 ? 1'h0 : SLR1_io_p2_out_21_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_264 = SLR1_io_frontier_in_21_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_265 = _T_1714 ? SLR1_io_p2_out_21_bits : {{8'd0}, crossbar_array_visit_io_out_37_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_266 = _T_1714 ? SLR1_io_p2_out_21_valid : crossbar_array_visit_io_out_37_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_267 = _T_1714 ? SLR1_io_frontier_in_21_ready : crossbar_array_visit_io_in_37_ready; // @[Top-slr.scala 466:58]
  reg  _T_1715; // @[Top-slr.scala 466:25]
  wire  _T_1716 = ~_T_1715; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_268 = SLR1_io_p2_out_22_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_269 = _T_1716 ? 1'h0 : SLR1_io_p2_out_22_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_270 = SLR1_io_frontier_in_22_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_271 = _T_1716 ? SLR1_io_p2_out_22_bits : {{8'd0}, crossbar_array_visit_io_out_69_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_272 = _T_1716 ? SLR1_io_p2_out_22_valid : crossbar_array_visit_io_out_69_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_273 = _T_1716 ? SLR1_io_frontier_in_22_ready : crossbar_array_visit_io_in_69_ready; // @[Top-slr.scala 466:58]
  reg  _T_1717; // @[Top-slr.scala 466:25]
  wire  _T_1718 = ~_T_1717; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_274 = SLR1_io_p2_out_23_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_275 = _T_1718 ? 1'h0 : SLR1_io_p2_out_23_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_276 = SLR1_io_frontier_in_23_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_277 = _T_1718 ? SLR1_io_p2_out_23_bits : {{8'd0}, crossbar_array_visit_io_out_101_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_278 = _T_1718 ? SLR1_io_p2_out_23_valid : crossbar_array_visit_io_out_101_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_279 = _T_1718 ? SLR1_io_frontier_in_23_ready : crossbar_array_visit_io_in_101_ready; // @[Top-slr.scala 466:58]
  reg  _T_1719; // @[Top-slr.scala 466:25]
  wire  _T_1720 = ~_T_1719; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_280 = SLR1_io_p2_out_24_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_281 = _T_1720 ? 1'h0 : SLR1_io_p2_out_24_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_282 = SLR1_io_frontier_in_24_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_283 = _T_1720 ? SLR1_io_p2_out_24_bits : {{8'd0}, crossbar_array_visit_io_out_6_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_284 = _T_1720 ? SLR1_io_p2_out_24_valid : crossbar_array_visit_io_out_6_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_285 = _T_1720 ? SLR1_io_frontier_in_24_ready : crossbar_array_visit_io_in_6_ready; // @[Top-slr.scala 466:58]
  reg  _T_1721; // @[Top-slr.scala 466:25]
  wire  _T_1722 = ~_T_1721; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_286 = SLR1_io_p2_out_25_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_287 = _T_1722 ? 1'h0 : SLR1_io_p2_out_25_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_288 = SLR1_io_frontier_in_25_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_289 = _T_1722 ? SLR1_io_p2_out_25_bits : {{8'd0}, crossbar_array_visit_io_out_38_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_290 = _T_1722 ? SLR1_io_p2_out_25_valid : crossbar_array_visit_io_out_38_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_291 = _T_1722 ? SLR1_io_frontier_in_25_ready : crossbar_array_visit_io_in_38_ready; // @[Top-slr.scala 466:58]
  reg  _T_1723; // @[Top-slr.scala 466:25]
  wire  _T_1724 = ~_T_1723; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_292 = SLR1_io_p2_out_26_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_293 = _T_1724 ? 1'h0 : SLR1_io_p2_out_26_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_294 = SLR1_io_frontier_in_26_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_295 = _T_1724 ? SLR1_io_p2_out_26_bits : {{8'd0}, crossbar_array_visit_io_out_70_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_296 = _T_1724 ? SLR1_io_p2_out_26_valid : crossbar_array_visit_io_out_70_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_297 = _T_1724 ? SLR1_io_frontier_in_26_ready : crossbar_array_visit_io_in_70_ready; // @[Top-slr.scala 466:58]
  reg  _T_1725; // @[Top-slr.scala 466:25]
  wire  _T_1726 = ~_T_1725; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_298 = SLR1_io_p2_out_27_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_299 = _T_1726 ? 1'h0 : SLR1_io_p2_out_27_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_300 = SLR1_io_frontier_in_27_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_301 = _T_1726 ? SLR1_io_p2_out_27_bits : {{8'd0}, crossbar_array_visit_io_out_102_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_302 = _T_1726 ? SLR1_io_p2_out_27_valid : crossbar_array_visit_io_out_102_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_303 = _T_1726 ? SLR1_io_frontier_in_27_ready : crossbar_array_visit_io_in_102_ready; // @[Top-slr.scala 466:58]
  reg  _T_1727; // @[Top-slr.scala 466:25]
  wire  _T_1728 = ~_T_1727; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_304 = SLR1_io_p2_out_28_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_305 = _T_1728 ? 1'h0 : SLR1_io_p2_out_28_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_306 = SLR1_io_frontier_in_28_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_307 = _T_1728 ? SLR1_io_p2_out_28_bits : {{8'd0}, crossbar_array_visit_io_out_7_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_308 = _T_1728 ? SLR1_io_p2_out_28_valid : crossbar_array_visit_io_out_7_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_309 = _T_1728 ? SLR1_io_frontier_in_28_ready : crossbar_array_visit_io_in_7_ready; // @[Top-slr.scala 466:58]
  reg  _T_1729; // @[Top-slr.scala 466:25]
  wire  _T_1730 = ~_T_1729; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_310 = SLR1_io_p2_out_29_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_311 = _T_1730 ? 1'h0 : SLR1_io_p2_out_29_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_312 = SLR1_io_frontier_in_29_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_313 = _T_1730 ? SLR1_io_p2_out_29_bits : {{8'd0}, crossbar_array_visit_io_out_39_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_314 = _T_1730 ? SLR1_io_p2_out_29_valid : crossbar_array_visit_io_out_39_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_315 = _T_1730 ? SLR1_io_frontier_in_29_ready : crossbar_array_visit_io_in_39_ready; // @[Top-slr.scala 466:58]
  reg  _T_1731; // @[Top-slr.scala 466:25]
  wire  _T_1732 = ~_T_1731; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_316 = SLR1_io_p2_out_30_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_317 = _T_1732 ? 1'h0 : SLR1_io_p2_out_30_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_318 = SLR1_io_frontier_in_30_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_319 = _T_1732 ? SLR1_io_p2_out_30_bits : {{8'd0}, crossbar_array_visit_io_out_71_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_320 = _T_1732 ? SLR1_io_p2_out_30_valid : crossbar_array_visit_io_out_71_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_321 = _T_1732 ? SLR1_io_frontier_in_30_ready : crossbar_array_visit_io_in_71_ready; // @[Top-slr.scala 466:58]
  reg  _T_1733; // @[Top-slr.scala 466:25]
  wire  _T_1734 = ~_T_1733; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_322 = SLR1_io_p2_out_31_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_323 = _T_1734 ? 1'h0 : SLR1_io_p2_out_31_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_324 = SLR1_io_frontier_in_31_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_325 = _T_1734 ? SLR1_io_p2_out_31_bits : {{8'd0}, crossbar_array_visit_io_out_103_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_326 = _T_1734 ? SLR1_io_p2_out_31_valid : crossbar_array_visit_io_out_103_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_327 = _T_1734 ? SLR1_io_frontier_in_31_ready : crossbar_array_visit_io_in_103_ready; // @[Top-slr.scala 466:58]
  reg  _T_1735; // @[Top-slr.scala 466:25]
  wire  _T_1736 = ~_T_1735; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_328 = SLR1_io_p2_out_32_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_329 = _T_1736 ? 1'h0 : SLR1_io_p2_out_32_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_330 = SLR1_io_frontier_in_32_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_331 = _T_1736 ? SLR1_io_p2_out_32_bits : {{8'd0}, crossbar_array_visit_io_out_8_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_332 = _T_1736 ? SLR1_io_p2_out_32_valid : crossbar_array_visit_io_out_8_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_333 = _T_1736 ? SLR1_io_frontier_in_32_ready : crossbar_array_visit_io_in_8_ready; // @[Top-slr.scala 466:58]
  reg  _T_1737; // @[Top-slr.scala 466:25]
  wire  _T_1738 = ~_T_1737; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_334 = SLR1_io_p2_out_33_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_335 = _T_1738 ? 1'h0 : SLR1_io_p2_out_33_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_336 = SLR1_io_frontier_in_33_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_337 = _T_1738 ? SLR1_io_p2_out_33_bits : {{8'd0}, crossbar_array_visit_io_out_40_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_338 = _T_1738 ? SLR1_io_p2_out_33_valid : crossbar_array_visit_io_out_40_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_339 = _T_1738 ? SLR1_io_frontier_in_33_ready : crossbar_array_visit_io_in_40_ready; // @[Top-slr.scala 466:58]
  reg  _T_1739; // @[Top-slr.scala 466:25]
  wire  _T_1740 = ~_T_1739; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_340 = SLR1_io_p2_out_34_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_341 = _T_1740 ? 1'h0 : SLR1_io_p2_out_34_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_342 = SLR1_io_frontier_in_34_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_343 = _T_1740 ? SLR1_io_p2_out_34_bits : {{8'd0}, crossbar_array_visit_io_out_72_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_344 = _T_1740 ? SLR1_io_p2_out_34_valid : crossbar_array_visit_io_out_72_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_345 = _T_1740 ? SLR1_io_frontier_in_34_ready : crossbar_array_visit_io_in_72_ready; // @[Top-slr.scala 466:58]
  reg  _T_1741; // @[Top-slr.scala 466:25]
  wire  _T_1742 = ~_T_1741; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_346 = SLR1_io_p2_out_35_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_347 = _T_1742 ? 1'h0 : SLR1_io_p2_out_35_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_348 = SLR1_io_frontier_in_35_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_349 = _T_1742 ? SLR1_io_p2_out_35_bits : {{8'd0}, crossbar_array_visit_io_out_104_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_350 = _T_1742 ? SLR1_io_p2_out_35_valid : crossbar_array_visit_io_out_104_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_351 = _T_1742 ? SLR1_io_frontier_in_35_ready : crossbar_array_visit_io_in_104_ready; // @[Top-slr.scala 466:58]
  reg  _T_1743; // @[Top-slr.scala 466:25]
  wire  _T_1744 = ~_T_1743; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_352 = SLR1_io_p2_out_36_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_353 = _T_1744 ? 1'h0 : SLR1_io_p2_out_36_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_354 = SLR1_io_frontier_in_36_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_355 = _T_1744 ? SLR1_io_p2_out_36_bits : {{8'd0}, crossbar_array_visit_io_out_9_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_356 = _T_1744 ? SLR1_io_p2_out_36_valid : crossbar_array_visit_io_out_9_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_357 = _T_1744 ? SLR1_io_frontier_in_36_ready : crossbar_array_visit_io_in_9_ready; // @[Top-slr.scala 466:58]
  reg  _T_1745; // @[Top-slr.scala 466:25]
  wire  _T_1746 = ~_T_1745; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_358 = SLR1_io_p2_out_37_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_359 = _T_1746 ? 1'h0 : SLR1_io_p2_out_37_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_360 = SLR1_io_frontier_in_37_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_361 = _T_1746 ? SLR1_io_p2_out_37_bits : {{8'd0}, crossbar_array_visit_io_out_41_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_362 = _T_1746 ? SLR1_io_p2_out_37_valid : crossbar_array_visit_io_out_41_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_363 = _T_1746 ? SLR1_io_frontier_in_37_ready : crossbar_array_visit_io_in_41_ready; // @[Top-slr.scala 466:58]
  reg  _T_1747; // @[Top-slr.scala 466:25]
  wire  _T_1748 = ~_T_1747; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_364 = SLR1_io_p2_out_38_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_365 = _T_1748 ? 1'h0 : SLR1_io_p2_out_38_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_366 = SLR1_io_frontier_in_38_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_367 = _T_1748 ? SLR1_io_p2_out_38_bits : {{8'd0}, crossbar_array_visit_io_out_73_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_368 = _T_1748 ? SLR1_io_p2_out_38_valid : crossbar_array_visit_io_out_73_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_369 = _T_1748 ? SLR1_io_frontier_in_38_ready : crossbar_array_visit_io_in_73_ready; // @[Top-slr.scala 466:58]
  reg  _T_1749; // @[Top-slr.scala 466:25]
  wire  _T_1750 = ~_T_1749; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_370 = SLR1_io_p2_out_39_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_371 = _T_1750 ? 1'h0 : SLR1_io_p2_out_39_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_372 = SLR1_io_frontier_in_39_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_373 = _T_1750 ? SLR1_io_p2_out_39_bits : {{8'd0}, crossbar_array_visit_io_out_105_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_374 = _T_1750 ? SLR1_io_p2_out_39_valid : crossbar_array_visit_io_out_105_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_375 = _T_1750 ? SLR1_io_frontier_in_39_ready : crossbar_array_visit_io_in_105_ready; // @[Top-slr.scala 466:58]
  reg  _T_1751; // @[Top-slr.scala 466:25]
  wire  _T_1752 = ~_T_1751; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_376 = SLR1_io_p2_out_40_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_377 = _T_1752 ? 1'h0 : SLR1_io_p2_out_40_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_378 = SLR1_io_frontier_in_40_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_379 = _T_1752 ? SLR1_io_p2_out_40_bits : {{8'd0}, crossbar_array_visit_io_out_10_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_380 = _T_1752 ? SLR1_io_p2_out_40_valid : crossbar_array_visit_io_out_10_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_381 = _T_1752 ? SLR1_io_frontier_in_40_ready : crossbar_array_visit_io_in_10_ready; // @[Top-slr.scala 466:58]
  reg  _T_1753; // @[Top-slr.scala 466:25]
  wire  _T_1754 = ~_T_1753; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_382 = SLR1_io_p2_out_41_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_383 = _T_1754 ? 1'h0 : SLR1_io_p2_out_41_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_384 = SLR1_io_frontier_in_41_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_385 = _T_1754 ? SLR1_io_p2_out_41_bits : {{8'd0}, crossbar_array_visit_io_out_42_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_386 = _T_1754 ? SLR1_io_p2_out_41_valid : crossbar_array_visit_io_out_42_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_387 = _T_1754 ? SLR1_io_frontier_in_41_ready : crossbar_array_visit_io_in_42_ready; // @[Top-slr.scala 466:58]
  reg  _T_1755; // @[Top-slr.scala 466:25]
  wire  _T_1756 = ~_T_1755; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_388 = SLR1_io_p2_out_42_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_389 = _T_1756 ? 1'h0 : SLR1_io_p2_out_42_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_390 = SLR1_io_frontier_in_42_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_391 = _T_1756 ? SLR1_io_p2_out_42_bits : {{8'd0}, crossbar_array_visit_io_out_74_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_392 = _T_1756 ? SLR1_io_p2_out_42_valid : crossbar_array_visit_io_out_74_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_393 = _T_1756 ? SLR1_io_frontier_in_42_ready : crossbar_array_visit_io_in_74_ready; // @[Top-slr.scala 466:58]
  reg  _T_1757; // @[Top-slr.scala 466:25]
  wire  _T_1758 = ~_T_1757; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_394 = SLR1_io_p2_out_43_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_395 = _T_1758 ? 1'h0 : SLR1_io_p2_out_43_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_396 = SLR1_io_frontier_in_43_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_397 = _T_1758 ? SLR1_io_p2_out_43_bits : {{8'd0}, crossbar_array_visit_io_out_106_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_398 = _T_1758 ? SLR1_io_p2_out_43_valid : crossbar_array_visit_io_out_106_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_399 = _T_1758 ? SLR1_io_frontier_in_43_ready : crossbar_array_visit_io_in_106_ready; // @[Top-slr.scala 466:58]
  reg  _T_1759; // @[Top-slr.scala 466:25]
  wire  _T_1760 = ~_T_1759; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_400 = SLR1_io_p2_out_44_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_401 = _T_1760 ? 1'h0 : SLR1_io_p2_out_44_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_402 = SLR1_io_frontier_in_44_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_403 = _T_1760 ? SLR1_io_p2_out_44_bits : {{8'd0}, crossbar_array_visit_io_out_11_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_404 = _T_1760 ? SLR1_io_p2_out_44_valid : crossbar_array_visit_io_out_11_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_405 = _T_1760 ? SLR1_io_frontier_in_44_ready : crossbar_array_visit_io_in_11_ready; // @[Top-slr.scala 466:58]
  reg  _T_1761; // @[Top-slr.scala 466:25]
  wire  _T_1762 = ~_T_1761; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_406 = SLR1_io_p2_out_45_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_407 = _T_1762 ? 1'h0 : SLR1_io_p2_out_45_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_408 = SLR1_io_frontier_in_45_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_409 = _T_1762 ? SLR1_io_p2_out_45_bits : {{8'd0}, crossbar_array_visit_io_out_43_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_410 = _T_1762 ? SLR1_io_p2_out_45_valid : crossbar_array_visit_io_out_43_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_411 = _T_1762 ? SLR1_io_frontier_in_45_ready : crossbar_array_visit_io_in_43_ready; // @[Top-slr.scala 466:58]
  reg  _T_1763; // @[Top-slr.scala 466:25]
  wire  _T_1764 = ~_T_1763; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_412 = SLR1_io_p2_out_46_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_413 = _T_1764 ? 1'h0 : SLR1_io_p2_out_46_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_414 = SLR1_io_frontier_in_46_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_415 = _T_1764 ? SLR1_io_p2_out_46_bits : {{8'd0}, crossbar_array_visit_io_out_75_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_416 = _T_1764 ? SLR1_io_p2_out_46_valid : crossbar_array_visit_io_out_75_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_417 = _T_1764 ? SLR1_io_frontier_in_46_ready : crossbar_array_visit_io_in_75_ready; // @[Top-slr.scala 466:58]
  reg  _T_1765; // @[Top-slr.scala 466:25]
  wire  _T_1766 = ~_T_1765; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_418 = SLR1_io_p2_out_47_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_419 = _T_1766 ? 1'h0 : SLR1_io_p2_out_47_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_420 = SLR1_io_frontier_in_47_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_421 = _T_1766 ? SLR1_io_p2_out_47_bits : {{8'd0}, crossbar_array_visit_io_out_107_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_422 = _T_1766 ? SLR1_io_p2_out_47_valid : crossbar_array_visit_io_out_107_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_423 = _T_1766 ? SLR1_io_frontier_in_47_ready : crossbar_array_visit_io_in_107_ready; // @[Top-slr.scala 466:58]
  reg  _T_1767; // @[Top-slr.scala 466:25]
  wire  _T_1768 = ~_T_1767; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_424 = SLR1_io_p2_out_48_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_425 = _T_1768 ? 1'h0 : SLR1_io_p2_out_48_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_426 = SLR1_io_frontier_in_48_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_427 = _T_1768 ? SLR1_io_p2_out_48_bits : {{8'd0}, crossbar_array_visit_io_out_12_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_428 = _T_1768 ? SLR1_io_p2_out_48_valid : crossbar_array_visit_io_out_12_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_429 = _T_1768 ? SLR1_io_frontier_in_48_ready : crossbar_array_visit_io_in_12_ready; // @[Top-slr.scala 466:58]
  reg  _T_1769; // @[Top-slr.scala 466:25]
  wire  _T_1770 = ~_T_1769; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_430 = SLR1_io_p2_out_49_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_431 = _T_1770 ? 1'h0 : SLR1_io_p2_out_49_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_432 = SLR1_io_frontier_in_49_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_433 = _T_1770 ? SLR1_io_p2_out_49_bits : {{8'd0}, crossbar_array_visit_io_out_44_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_434 = _T_1770 ? SLR1_io_p2_out_49_valid : crossbar_array_visit_io_out_44_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_435 = _T_1770 ? SLR1_io_frontier_in_49_ready : crossbar_array_visit_io_in_44_ready; // @[Top-slr.scala 466:58]
  reg  _T_1771; // @[Top-slr.scala 466:25]
  wire  _T_1772 = ~_T_1771; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_436 = SLR1_io_p2_out_50_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_437 = _T_1772 ? 1'h0 : SLR1_io_p2_out_50_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_438 = SLR1_io_frontier_in_50_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_439 = _T_1772 ? SLR1_io_p2_out_50_bits : {{8'd0}, crossbar_array_visit_io_out_76_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_440 = _T_1772 ? SLR1_io_p2_out_50_valid : crossbar_array_visit_io_out_76_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_441 = _T_1772 ? SLR1_io_frontier_in_50_ready : crossbar_array_visit_io_in_76_ready; // @[Top-slr.scala 466:58]
  reg  _T_1773; // @[Top-slr.scala 466:25]
  wire  _T_1774 = ~_T_1773; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_442 = SLR1_io_p2_out_51_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_443 = _T_1774 ? 1'h0 : SLR1_io_p2_out_51_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_444 = SLR1_io_frontier_in_51_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_445 = _T_1774 ? SLR1_io_p2_out_51_bits : {{8'd0}, crossbar_array_visit_io_out_108_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_446 = _T_1774 ? SLR1_io_p2_out_51_valid : crossbar_array_visit_io_out_108_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_447 = _T_1774 ? SLR1_io_frontier_in_51_ready : crossbar_array_visit_io_in_108_ready; // @[Top-slr.scala 466:58]
  reg  _T_1775; // @[Top-slr.scala 466:25]
  wire  _T_1776 = ~_T_1775; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_448 = SLR1_io_p2_out_52_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_449 = _T_1776 ? 1'h0 : SLR1_io_p2_out_52_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_450 = SLR1_io_frontier_in_52_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_451 = _T_1776 ? SLR1_io_p2_out_52_bits : {{8'd0}, crossbar_array_visit_io_out_13_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_452 = _T_1776 ? SLR1_io_p2_out_52_valid : crossbar_array_visit_io_out_13_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_453 = _T_1776 ? SLR1_io_frontier_in_52_ready : crossbar_array_visit_io_in_13_ready; // @[Top-slr.scala 466:58]
  reg  _T_1777; // @[Top-slr.scala 466:25]
  wire  _T_1778 = ~_T_1777; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_454 = SLR1_io_p2_out_53_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_455 = _T_1778 ? 1'h0 : SLR1_io_p2_out_53_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_456 = SLR1_io_frontier_in_53_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_457 = _T_1778 ? SLR1_io_p2_out_53_bits : {{8'd0}, crossbar_array_visit_io_out_45_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_458 = _T_1778 ? SLR1_io_p2_out_53_valid : crossbar_array_visit_io_out_45_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_459 = _T_1778 ? SLR1_io_frontier_in_53_ready : crossbar_array_visit_io_in_45_ready; // @[Top-slr.scala 466:58]
  reg  _T_1779; // @[Top-slr.scala 466:25]
  wire  _T_1780 = ~_T_1779; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_460 = SLR1_io_p2_out_54_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_461 = _T_1780 ? 1'h0 : SLR1_io_p2_out_54_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_462 = SLR1_io_frontier_in_54_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_463 = _T_1780 ? SLR1_io_p2_out_54_bits : {{8'd0}, crossbar_array_visit_io_out_77_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_464 = _T_1780 ? SLR1_io_p2_out_54_valid : crossbar_array_visit_io_out_77_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_465 = _T_1780 ? SLR1_io_frontier_in_54_ready : crossbar_array_visit_io_in_77_ready; // @[Top-slr.scala 466:58]
  reg  _T_1781; // @[Top-slr.scala 466:25]
  wire  _T_1782 = ~_T_1781; // @[Top-slr.scala 466:50]
  wire [31:0] _GEN_466 = SLR1_io_p2_out_55_bits; // @[Top-slr.scala 466:58]
  wire  _GEN_467 = _T_1782 ? 1'h0 : SLR1_io_p2_out_55_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_468 = SLR1_io_frontier_in_55_ready; // @[Top-slr.scala 466:58]
  wire [31:0] _GEN_469 = _T_1782 ? SLR1_io_p2_out_55_bits : {{8'd0}, crossbar_array_visit_io_out_109_bits}; // @[Top-slr.scala 466:58]
  wire  _GEN_470 = _T_1782 ? SLR1_io_p2_out_55_valid : crossbar_array_visit_io_out_109_valid; // @[Top-slr.scala 466:58]
  wire  _GEN_471 = _T_1782 ? SLR1_io_frontier_in_55_ready : crossbar_array_visit_io_in_109_ready; // @[Top-slr.scala 466:58]
  reg  _T_1783; // @[Top-slr.scala 496:25]
  wire  _T_1784 = ~_T_1783; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_472 = SLR2_io_p2_out_0_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_473 = _T_1784 ? 1'h0 : SLR2_io_p2_out_0_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_474 = SLR2_io_frontier_in_0_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_475 = _T_1784 ? SLR2_io_p2_out_0_bits : {{8'd0}, crossbar_array_visit_io_out_14_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_476 = _T_1784 ? SLR2_io_p2_out_0_valid : crossbar_array_visit_io_out_14_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_477 = _T_1784 ? SLR2_io_frontier_in_0_ready : crossbar_array_visit_io_in_14_ready; // @[Top-slr.scala 496:58]
  reg  _T_1785; // @[Top-slr.scala 496:25]
  wire  _T_1786 = ~_T_1785; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_478 = SLR2_io_p2_out_1_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_479 = _T_1786 ? 1'h0 : SLR2_io_p2_out_1_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_480 = SLR2_io_frontier_in_1_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_481 = _T_1786 ? SLR2_io_p2_out_1_bits : {{8'd0}, crossbar_array_visit_io_out_46_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_482 = _T_1786 ? SLR2_io_p2_out_1_valid : crossbar_array_visit_io_out_46_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_483 = _T_1786 ? SLR2_io_frontier_in_1_ready : crossbar_array_visit_io_in_46_ready; // @[Top-slr.scala 496:58]
  reg  _T_1787; // @[Top-slr.scala 496:25]
  wire  _T_1788 = ~_T_1787; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_484 = SLR2_io_p2_out_2_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_485 = _T_1788 ? 1'h0 : SLR2_io_p2_out_2_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_486 = SLR2_io_frontier_in_2_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_487 = _T_1788 ? SLR2_io_p2_out_2_bits : {{8'd0}, crossbar_array_visit_io_out_78_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_488 = _T_1788 ? SLR2_io_p2_out_2_valid : crossbar_array_visit_io_out_78_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_489 = _T_1788 ? SLR2_io_frontier_in_2_ready : crossbar_array_visit_io_in_78_ready; // @[Top-slr.scala 496:58]
  reg  _T_1789; // @[Top-slr.scala 496:25]
  wire  _T_1790 = ~_T_1789; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_490 = SLR2_io_p2_out_3_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_491 = _T_1790 ? 1'h0 : SLR2_io_p2_out_3_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_492 = SLR2_io_frontier_in_3_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_493 = _T_1790 ? SLR2_io_p2_out_3_bits : {{8'd0}, crossbar_array_visit_io_out_110_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_494 = _T_1790 ? SLR2_io_p2_out_3_valid : crossbar_array_visit_io_out_110_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_495 = _T_1790 ? SLR2_io_frontier_in_3_ready : crossbar_array_visit_io_in_110_ready; // @[Top-slr.scala 496:58]
  reg  _T_1791; // @[Top-slr.scala 496:25]
  wire  _T_1792 = ~_T_1791; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_496 = SLR2_io_p2_out_4_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_497 = _T_1792 ? 1'h0 : SLR2_io_p2_out_4_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_498 = SLR2_io_frontier_in_4_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_499 = _T_1792 ? SLR2_io_p2_out_4_bits : {{8'd0}, crossbar_array_visit_io_out_15_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_500 = _T_1792 ? SLR2_io_p2_out_4_valid : crossbar_array_visit_io_out_15_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_501 = _T_1792 ? SLR2_io_frontier_in_4_ready : crossbar_array_visit_io_in_15_ready; // @[Top-slr.scala 496:58]
  reg  _T_1793; // @[Top-slr.scala 496:25]
  wire  _T_1794 = ~_T_1793; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_502 = SLR2_io_p2_out_5_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_503 = _T_1794 ? 1'h0 : SLR2_io_p2_out_5_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_504 = SLR2_io_frontier_in_5_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_505 = _T_1794 ? SLR2_io_p2_out_5_bits : {{8'd0}, crossbar_array_visit_io_out_47_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_506 = _T_1794 ? SLR2_io_p2_out_5_valid : crossbar_array_visit_io_out_47_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_507 = _T_1794 ? SLR2_io_frontier_in_5_ready : crossbar_array_visit_io_in_47_ready; // @[Top-slr.scala 496:58]
  reg  _T_1795; // @[Top-slr.scala 496:25]
  wire  _T_1796 = ~_T_1795; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_508 = SLR2_io_p2_out_6_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_509 = _T_1796 ? 1'h0 : SLR2_io_p2_out_6_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_510 = SLR2_io_frontier_in_6_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_511 = _T_1796 ? SLR2_io_p2_out_6_bits : {{8'd0}, crossbar_array_visit_io_out_79_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_512 = _T_1796 ? SLR2_io_p2_out_6_valid : crossbar_array_visit_io_out_79_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_513 = _T_1796 ? SLR2_io_frontier_in_6_ready : crossbar_array_visit_io_in_79_ready; // @[Top-slr.scala 496:58]
  reg  _T_1797; // @[Top-slr.scala 496:25]
  wire  _T_1798 = ~_T_1797; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_514 = SLR2_io_p2_out_7_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_515 = _T_1798 ? 1'h0 : SLR2_io_p2_out_7_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_516 = SLR2_io_frontier_in_7_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_517 = _T_1798 ? SLR2_io_p2_out_7_bits : {{8'd0}, crossbar_array_visit_io_out_111_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_518 = _T_1798 ? SLR2_io_p2_out_7_valid : crossbar_array_visit_io_out_111_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_519 = _T_1798 ? SLR2_io_frontier_in_7_ready : crossbar_array_visit_io_in_111_ready; // @[Top-slr.scala 496:58]
  reg  _T_1799; // @[Top-slr.scala 496:25]
  wire  _T_1800 = ~_T_1799; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_520 = SLR2_io_p2_out_8_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_521 = _T_1800 ? 1'h0 : SLR2_io_p2_out_8_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_522 = SLR2_io_frontier_in_8_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_523 = _T_1800 ? SLR2_io_p2_out_8_bits : {{8'd0}, crossbar_array_visit_io_out_16_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_524 = _T_1800 ? SLR2_io_p2_out_8_valid : crossbar_array_visit_io_out_16_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_525 = _T_1800 ? SLR2_io_frontier_in_8_ready : crossbar_array_visit_io_in_16_ready; // @[Top-slr.scala 496:58]
  reg  _T_1801; // @[Top-slr.scala 496:25]
  wire  _T_1802 = ~_T_1801; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_526 = SLR2_io_p2_out_9_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_527 = _T_1802 ? 1'h0 : SLR2_io_p2_out_9_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_528 = SLR2_io_frontier_in_9_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_529 = _T_1802 ? SLR2_io_p2_out_9_bits : {{8'd0}, crossbar_array_visit_io_out_48_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_530 = _T_1802 ? SLR2_io_p2_out_9_valid : crossbar_array_visit_io_out_48_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_531 = _T_1802 ? SLR2_io_frontier_in_9_ready : crossbar_array_visit_io_in_48_ready; // @[Top-slr.scala 496:58]
  reg  _T_1803; // @[Top-slr.scala 496:25]
  wire  _T_1804 = ~_T_1803; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_532 = SLR2_io_p2_out_10_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_533 = _T_1804 ? 1'h0 : SLR2_io_p2_out_10_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_534 = SLR2_io_frontier_in_10_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_535 = _T_1804 ? SLR2_io_p2_out_10_bits : {{8'd0}, crossbar_array_visit_io_out_80_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_536 = _T_1804 ? SLR2_io_p2_out_10_valid : crossbar_array_visit_io_out_80_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_537 = _T_1804 ? SLR2_io_frontier_in_10_ready : crossbar_array_visit_io_in_80_ready; // @[Top-slr.scala 496:58]
  reg  _T_1805; // @[Top-slr.scala 496:25]
  wire  _T_1806 = ~_T_1805; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_538 = SLR2_io_p2_out_11_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_539 = _T_1806 ? 1'h0 : SLR2_io_p2_out_11_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_540 = SLR2_io_frontier_in_11_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_541 = _T_1806 ? SLR2_io_p2_out_11_bits : {{8'd0}, crossbar_array_visit_io_out_112_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_542 = _T_1806 ? SLR2_io_p2_out_11_valid : crossbar_array_visit_io_out_112_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_543 = _T_1806 ? SLR2_io_frontier_in_11_ready : crossbar_array_visit_io_in_112_ready; // @[Top-slr.scala 496:58]
  reg  _T_1807; // @[Top-slr.scala 496:25]
  wire  _T_1808 = ~_T_1807; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_544 = SLR2_io_p2_out_12_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_545 = _T_1808 ? 1'h0 : SLR2_io_p2_out_12_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_546 = SLR2_io_frontier_in_12_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_547 = _T_1808 ? SLR2_io_p2_out_12_bits : {{8'd0}, crossbar_array_visit_io_out_17_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_548 = _T_1808 ? SLR2_io_p2_out_12_valid : crossbar_array_visit_io_out_17_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_549 = _T_1808 ? SLR2_io_frontier_in_12_ready : crossbar_array_visit_io_in_17_ready; // @[Top-slr.scala 496:58]
  reg  _T_1809; // @[Top-slr.scala 496:25]
  wire  _T_1810 = ~_T_1809; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_550 = SLR2_io_p2_out_13_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_551 = _T_1810 ? 1'h0 : SLR2_io_p2_out_13_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_552 = SLR2_io_frontier_in_13_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_553 = _T_1810 ? SLR2_io_p2_out_13_bits : {{8'd0}, crossbar_array_visit_io_out_49_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_554 = _T_1810 ? SLR2_io_p2_out_13_valid : crossbar_array_visit_io_out_49_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_555 = _T_1810 ? SLR2_io_frontier_in_13_ready : crossbar_array_visit_io_in_49_ready; // @[Top-slr.scala 496:58]
  reg  _T_1811; // @[Top-slr.scala 496:25]
  wire  _T_1812 = ~_T_1811; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_556 = SLR2_io_p2_out_14_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_557 = _T_1812 ? 1'h0 : SLR2_io_p2_out_14_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_558 = SLR2_io_frontier_in_14_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_559 = _T_1812 ? SLR2_io_p2_out_14_bits : {{8'd0}, crossbar_array_visit_io_out_81_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_560 = _T_1812 ? SLR2_io_p2_out_14_valid : crossbar_array_visit_io_out_81_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_561 = _T_1812 ? SLR2_io_frontier_in_14_ready : crossbar_array_visit_io_in_81_ready; // @[Top-slr.scala 496:58]
  reg  _T_1813; // @[Top-slr.scala 496:25]
  wire  _T_1814 = ~_T_1813; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_562 = SLR2_io_p2_out_15_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_563 = _T_1814 ? 1'h0 : SLR2_io_p2_out_15_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_564 = SLR2_io_frontier_in_15_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_565 = _T_1814 ? SLR2_io_p2_out_15_bits : {{8'd0}, crossbar_array_visit_io_out_113_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_566 = _T_1814 ? SLR2_io_p2_out_15_valid : crossbar_array_visit_io_out_113_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_567 = _T_1814 ? SLR2_io_frontier_in_15_ready : crossbar_array_visit_io_in_113_ready; // @[Top-slr.scala 496:58]
  reg  _T_1815; // @[Top-slr.scala 496:25]
  wire  _T_1816 = ~_T_1815; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_568 = SLR2_io_p2_out_16_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_569 = _T_1816 ? 1'h0 : SLR2_io_p2_out_16_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_570 = SLR2_io_frontier_in_16_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_571 = _T_1816 ? SLR2_io_p2_out_16_bits : {{8'd0}, crossbar_array_visit_io_out_18_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_572 = _T_1816 ? SLR2_io_p2_out_16_valid : crossbar_array_visit_io_out_18_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_573 = _T_1816 ? SLR2_io_frontier_in_16_ready : crossbar_array_visit_io_in_18_ready; // @[Top-slr.scala 496:58]
  reg  _T_1817; // @[Top-slr.scala 496:25]
  wire  _T_1818 = ~_T_1817; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_574 = SLR2_io_p2_out_17_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_575 = _T_1818 ? 1'h0 : SLR2_io_p2_out_17_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_576 = SLR2_io_frontier_in_17_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_577 = _T_1818 ? SLR2_io_p2_out_17_bits : {{8'd0}, crossbar_array_visit_io_out_50_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_578 = _T_1818 ? SLR2_io_p2_out_17_valid : crossbar_array_visit_io_out_50_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_579 = _T_1818 ? SLR2_io_frontier_in_17_ready : crossbar_array_visit_io_in_50_ready; // @[Top-slr.scala 496:58]
  reg  _T_1819; // @[Top-slr.scala 496:25]
  wire  _T_1820 = ~_T_1819; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_580 = SLR2_io_p2_out_18_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_581 = _T_1820 ? 1'h0 : SLR2_io_p2_out_18_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_582 = SLR2_io_frontier_in_18_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_583 = _T_1820 ? SLR2_io_p2_out_18_bits : {{8'd0}, crossbar_array_visit_io_out_82_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_584 = _T_1820 ? SLR2_io_p2_out_18_valid : crossbar_array_visit_io_out_82_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_585 = _T_1820 ? SLR2_io_frontier_in_18_ready : crossbar_array_visit_io_in_82_ready; // @[Top-slr.scala 496:58]
  reg  _T_1821; // @[Top-slr.scala 496:25]
  wire  _T_1822 = ~_T_1821; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_586 = SLR2_io_p2_out_19_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_587 = _T_1822 ? 1'h0 : SLR2_io_p2_out_19_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_588 = SLR2_io_frontier_in_19_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_589 = _T_1822 ? SLR2_io_p2_out_19_bits : {{8'd0}, crossbar_array_visit_io_out_114_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_590 = _T_1822 ? SLR2_io_p2_out_19_valid : crossbar_array_visit_io_out_114_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_591 = _T_1822 ? SLR2_io_frontier_in_19_ready : crossbar_array_visit_io_in_114_ready; // @[Top-slr.scala 496:58]
  reg  _T_1823; // @[Top-slr.scala 496:25]
  wire  _T_1824 = ~_T_1823; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_592 = SLR2_io_p2_out_20_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_593 = _T_1824 ? 1'h0 : SLR2_io_p2_out_20_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_594 = SLR2_io_frontier_in_20_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_595 = _T_1824 ? SLR2_io_p2_out_20_bits : {{8'd0}, crossbar_array_visit_io_out_19_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_596 = _T_1824 ? SLR2_io_p2_out_20_valid : crossbar_array_visit_io_out_19_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_597 = _T_1824 ? SLR2_io_frontier_in_20_ready : crossbar_array_visit_io_in_19_ready; // @[Top-slr.scala 496:58]
  reg  _T_1825; // @[Top-slr.scala 496:25]
  wire  _T_1826 = ~_T_1825; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_598 = SLR2_io_p2_out_21_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_599 = _T_1826 ? 1'h0 : SLR2_io_p2_out_21_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_600 = SLR2_io_frontier_in_21_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_601 = _T_1826 ? SLR2_io_p2_out_21_bits : {{8'd0}, crossbar_array_visit_io_out_51_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_602 = _T_1826 ? SLR2_io_p2_out_21_valid : crossbar_array_visit_io_out_51_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_603 = _T_1826 ? SLR2_io_frontier_in_21_ready : crossbar_array_visit_io_in_51_ready; // @[Top-slr.scala 496:58]
  reg  _T_1827; // @[Top-slr.scala 496:25]
  wire  _T_1828 = ~_T_1827; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_604 = SLR2_io_p2_out_22_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_605 = _T_1828 ? 1'h0 : SLR2_io_p2_out_22_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_606 = SLR2_io_frontier_in_22_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_607 = _T_1828 ? SLR2_io_p2_out_22_bits : {{8'd0}, crossbar_array_visit_io_out_83_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_608 = _T_1828 ? SLR2_io_p2_out_22_valid : crossbar_array_visit_io_out_83_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_609 = _T_1828 ? SLR2_io_frontier_in_22_ready : crossbar_array_visit_io_in_83_ready; // @[Top-slr.scala 496:58]
  reg  _T_1829; // @[Top-slr.scala 496:25]
  wire  _T_1830 = ~_T_1829; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_610 = SLR2_io_p2_out_23_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_611 = _T_1830 ? 1'h0 : SLR2_io_p2_out_23_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_612 = SLR2_io_frontier_in_23_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_613 = _T_1830 ? SLR2_io_p2_out_23_bits : {{8'd0}, crossbar_array_visit_io_out_115_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_614 = _T_1830 ? SLR2_io_p2_out_23_valid : crossbar_array_visit_io_out_115_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_615 = _T_1830 ? SLR2_io_frontier_in_23_ready : crossbar_array_visit_io_in_115_ready; // @[Top-slr.scala 496:58]
  reg  _T_1831; // @[Top-slr.scala 496:25]
  wire  _T_1832 = ~_T_1831; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_616 = SLR2_io_p2_out_24_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_617 = _T_1832 ? 1'h0 : SLR2_io_p2_out_24_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_618 = SLR2_io_frontier_in_24_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_619 = _T_1832 ? SLR2_io_p2_out_24_bits : {{8'd0}, crossbar_array_visit_io_out_20_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_620 = _T_1832 ? SLR2_io_p2_out_24_valid : crossbar_array_visit_io_out_20_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_621 = _T_1832 ? SLR2_io_frontier_in_24_ready : crossbar_array_visit_io_in_20_ready; // @[Top-slr.scala 496:58]
  reg  _T_1833; // @[Top-slr.scala 496:25]
  wire  _T_1834 = ~_T_1833; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_622 = SLR2_io_p2_out_25_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_623 = _T_1834 ? 1'h0 : SLR2_io_p2_out_25_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_624 = SLR2_io_frontier_in_25_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_625 = _T_1834 ? SLR2_io_p2_out_25_bits : {{8'd0}, crossbar_array_visit_io_out_52_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_626 = _T_1834 ? SLR2_io_p2_out_25_valid : crossbar_array_visit_io_out_52_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_627 = _T_1834 ? SLR2_io_frontier_in_25_ready : crossbar_array_visit_io_in_52_ready; // @[Top-slr.scala 496:58]
  reg  _T_1835; // @[Top-slr.scala 496:25]
  wire  _T_1836 = ~_T_1835; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_628 = SLR2_io_p2_out_26_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_629 = _T_1836 ? 1'h0 : SLR2_io_p2_out_26_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_630 = SLR2_io_frontier_in_26_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_631 = _T_1836 ? SLR2_io_p2_out_26_bits : {{8'd0}, crossbar_array_visit_io_out_84_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_632 = _T_1836 ? SLR2_io_p2_out_26_valid : crossbar_array_visit_io_out_84_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_633 = _T_1836 ? SLR2_io_frontier_in_26_ready : crossbar_array_visit_io_in_84_ready; // @[Top-slr.scala 496:58]
  reg  _T_1837; // @[Top-slr.scala 496:25]
  wire  _T_1838 = ~_T_1837; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_634 = SLR2_io_p2_out_27_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_635 = _T_1838 ? 1'h0 : SLR2_io_p2_out_27_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_636 = SLR2_io_frontier_in_27_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_637 = _T_1838 ? SLR2_io_p2_out_27_bits : {{8'd0}, crossbar_array_visit_io_out_116_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_638 = _T_1838 ? SLR2_io_p2_out_27_valid : crossbar_array_visit_io_out_116_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_639 = _T_1838 ? SLR2_io_frontier_in_27_ready : crossbar_array_visit_io_in_116_ready; // @[Top-slr.scala 496:58]
  reg  _T_1839; // @[Top-slr.scala 496:25]
  wire  _T_1840 = ~_T_1839; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_640 = SLR2_io_p2_out_28_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_641 = _T_1840 ? 1'h0 : SLR2_io_p2_out_28_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_642 = SLR2_io_frontier_in_28_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_643 = _T_1840 ? SLR2_io_p2_out_28_bits : {{8'd0}, crossbar_array_visit_io_out_21_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_644 = _T_1840 ? SLR2_io_p2_out_28_valid : crossbar_array_visit_io_out_21_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_645 = _T_1840 ? SLR2_io_frontier_in_28_ready : crossbar_array_visit_io_in_21_ready; // @[Top-slr.scala 496:58]
  reg  _T_1841; // @[Top-slr.scala 496:25]
  wire  _T_1842 = ~_T_1841; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_646 = SLR2_io_p2_out_29_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_647 = _T_1842 ? 1'h0 : SLR2_io_p2_out_29_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_648 = SLR2_io_frontier_in_29_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_649 = _T_1842 ? SLR2_io_p2_out_29_bits : {{8'd0}, crossbar_array_visit_io_out_53_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_650 = _T_1842 ? SLR2_io_p2_out_29_valid : crossbar_array_visit_io_out_53_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_651 = _T_1842 ? SLR2_io_frontier_in_29_ready : crossbar_array_visit_io_in_53_ready; // @[Top-slr.scala 496:58]
  reg  _T_1843; // @[Top-slr.scala 496:25]
  wire  _T_1844 = ~_T_1843; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_652 = SLR2_io_p2_out_30_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_653 = _T_1844 ? 1'h0 : SLR2_io_p2_out_30_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_654 = SLR2_io_frontier_in_30_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_655 = _T_1844 ? SLR2_io_p2_out_30_bits : {{8'd0}, crossbar_array_visit_io_out_85_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_656 = _T_1844 ? SLR2_io_p2_out_30_valid : crossbar_array_visit_io_out_85_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_657 = _T_1844 ? SLR2_io_frontier_in_30_ready : crossbar_array_visit_io_in_85_ready; // @[Top-slr.scala 496:58]
  reg  _T_1845; // @[Top-slr.scala 496:25]
  wire  _T_1846 = ~_T_1845; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_658 = SLR2_io_p2_out_31_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_659 = _T_1846 ? 1'h0 : SLR2_io_p2_out_31_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_660 = SLR2_io_frontier_in_31_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_661 = _T_1846 ? SLR2_io_p2_out_31_bits : {{8'd0}, crossbar_array_visit_io_out_117_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_662 = _T_1846 ? SLR2_io_p2_out_31_valid : crossbar_array_visit_io_out_117_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_663 = _T_1846 ? SLR2_io_frontier_in_31_ready : crossbar_array_visit_io_in_117_ready; // @[Top-slr.scala 496:58]
  reg  _T_1847; // @[Top-slr.scala 496:25]
  wire  _T_1848 = ~_T_1847; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_664 = SLR2_io_p2_out_32_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_665 = _T_1848 ? 1'h0 : SLR2_io_p2_out_32_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_666 = SLR2_io_frontier_in_32_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_667 = _T_1848 ? SLR2_io_p2_out_32_bits : {{8'd0}, crossbar_array_visit_io_out_22_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_668 = _T_1848 ? SLR2_io_p2_out_32_valid : crossbar_array_visit_io_out_22_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_669 = _T_1848 ? SLR2_io_frontier_in_32_ready : crossbar_array_visit_io_in_22_ready; // @[Top-slr.scala 496:58]
  reg  _T_1849; // @[Top-slr.scala 496:25]
  wire  _T_1850 = ~_T_1849; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_670 = SLR2_io_p2_out_33_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_671 = _T_1850 ? 1'h0 : SLR2_io_p2_out_33_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_672 = SLR2_io_frontier_in_33_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_673 = _T_1850 ? SLR2_io_p2_out_33_bits : {{8'd0}, crossbar_array_visit_io_out_54_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_674 = _T_1850 ? SLR2_io_p2_out_33_valid : crossbar_array_visit_io_out_54_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_675 = _T_1850 ? SLR2_io_frontier_in_33_ready : crossbar_array_visit_io_in_54_ready; // @[Top-slr.scala 496:58]
  reg  _T_1851; // @[Top-slr.scala 496:25]
  wire  _T_1852 = ~_T_1851; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_676 = SLR2_io_p2_out_34_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_677 = _T_1852 ? 1'h0 : SLR2_io_p2_out_34_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_678 = SLR2_io_frontier_in_34_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_679 = _T_1852 ? SLR2_io_p2_out_34_bits : {{8'd0}, crossbar_array_visit_io_out_86_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_680 = _T_1852 ? SLR2_io_p2_out_34_valid : crossbar_array_visit_io_out_86_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_681 = _T_1852 ? SLR2_io_frontier_in_34_ready : crossbar_array_visit_io_in_86_ready; // @[Top-slr.scala 496:58]
  reg  _T_1853; // @[Top-slr.scala 496:25]
  wire  _T_1854 = ~_T_1853; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_682 = SLR2_io_p2_out_35_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_683 = _T_1854 ? 1'h0 : SLR2_io_p2_out_35_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_684 = SLR2_io_frontier_in_35_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_685 = _T_1854 ? SLR2_io_p2_out_35_bits : {{8'd0}, crossbar_array_visit_io_out_118_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_686 = _T_1854 ? SLR2_io_p2_out_35_valid : crossbar_array_visit_io_out_118_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_687 = _T_1854 ? SLR2_io_frontier_in_35_ready : crossbar_array_visit_io_in_118_ready; // @[Top-slr.scala 496:58]
  reg  _T_1855; // @[Top-slr.scala 496:25]
  wire  _T_1856 = ~_T_1855; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_688 = SLR2_io_p2_out_36_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_689 = _T_1856 ? 1'h0 : SLR2_io_p2_out_36_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_690 = SLR2_io_frontier_in_36_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_691 = _T_1856 ? SLR2_io_p2_out_36_bits : {{8'd0}, crossbar_array_visit_io_out_23_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_692 = _T_1856 ? SLR2_io_p2_out_36_valid : crossbar_array_visit_io_out_23_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_693 = _T_1856 ? SLR2_io_frontier_in_36_ready : crossbar_array_visit_io_in_23_ready; // @[Top-slr.scala 496:58]
  reg  _T_1857; // @[Top-slr.scala 496:25]
  wire  _T_1858 = ~_T_1857; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_694 = SLR2_io_p2_out_37_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_695 = _T_1858 ? 1'h0 : SLR2_io_p2_out_37_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_696 = SLR2_io_frontier_in_37_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_697 = _T_1858 ? SLR2_io_p2_out_37_bits : {{8'd0}, crossbar_array_visit_io_out_55_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_698 = _T_1858 ? SLR2_io_p2_out_37_valid : crossbar_array_visit_io_out_55_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_699 = _T_1858 ? SLR2_io_frontier_in_37_ready : crossbar_array_visit_io_in_55_ready; // @[Top-slr.scala 496:58]
  reg  _T_1859; // @[Top-slr.scala 496:25]
  wire  _T_1860 = ~_T_1859; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_700 = SLR2_io_p2_out_38_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_701 = _T_1860 ? 1'h0 : SLR2_io_p2_out_38_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_702 = SLR2_io_frontier_in_38_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_703 = _T_1860 ? SLR2_io_p2_out_38_bits : {{8'd0}, crossbar_array_visit_io_out_87_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_704 = _T_1860 ? SLR2_io_p2_out_38_valid : crossbar_array_visit_io_out_87_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_705 = _T_1860 ? SLR2_io_frontier_in_38_ready : crossbar_array_visit_io_in_87_ready; // @[Top-slr.scala 496:58]
  reg  _T_1861; // @[Top-slr.scala 496:25]
  wire  _T_1862 = ~_T_1861; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_706 = SLR2_io_p2_out_39_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_707 = _T_1862 ? 1'h0 : SLR2_io_p2_out_39_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_708 = SLR2_io_frontier_in_39_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_709 = _T_1862 ? SLR2_io_p2_out_39_bits : {{8'd0}, crossbar_array_visit_io_out_119_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_710 = _T_1862 ? SLR2_io_p2_out_39_valid : crossbar_array_visit_io_out_119_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_711 = _T_1862 ? SLR2_io_frontier_in_39_ready : crossbar_array_visit_io_in_119_ready; // @[Top-slr.scala 496:58]
  reg  _T_1863; // @[Top-slr.scala 496:25]
  wire  _T_1864 = ~_T_1863; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_712 = SLR2_io_p2_out_40_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_713 = _T_1864 ? 1'h0 : SLR2_io_p2_out_40_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_714 = SLR2_io_frontier_in_40_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_715 = _T_1864 ? SLR2_io_p2_out_40_bits : {{8'd0}, crossbar_array_visit_io_out_24_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_716 = _T_1864 ? SLR2_io_p2_out_40_valid : crossbar_array_visit_io_out_24_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_717 = _T_1864 ? SLR2_io_frontier_in_40_ready : crossbar_array_visit_io_in_24_ready; // @[Top-slr.scala 496:58]
  reg  _T_1865; // @[Top-slr.scala 496:25]
  wire  _T_1866 = ~_T_1865; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_718 = SLR2_io_p2_out_41_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_719 = _T_1866 ? 1'h0 : SLR2_io_p2_out_41_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_720 = SLR2_io_frontier_in_41_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_721 = _T_1866 ? SLR2_io_p2_out_41_bits : {{8'd0}, crossbar_array_visit_io_out_56_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_722 = _T_1866 ? SLR2_io_p2_out_41_valid : crossbar_array_visit_io_out_56_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_723 = _T_1866 ? SLR2_io_frontier_in_41_ready : crossbar_array_visit_io_in_56_ready; // @[Top-slr.scala 496:58]
  reg  _T_1867; // @[Top-slr.scala 496:25]
  wire  _T_1868 = ~_T_1867; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_724 = SLR2_io_p2_out_42_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_725 = _T_1868 ? 1'h0 : SLR2_io_p2_out_42_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_726 = SLR2_io_frontier_in_42_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_727 = _T_1868 ? SLR2_io_p2_out_42_bits : {{8'd0}, crossbar_array_visit_io_out_88_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_728 = _T_1868 ? SLR2_io_p2_out_42_valid : crossbar_array_visit_io_out_88_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_729 = _T_1868 ? SLR2_io_frontier_in_42_ready : crossbar_array_visit_io_in_88_ready; // @[Top-slr.scala 496:58]
  reg  _T_1869; // @[Top-slr.scala 496:25]
  wire  _T_1870 = ~_T_1869; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_730 = SLR2_io_p2_out_43_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_731 = _T_1870 ? 1'h0 : SLR2_io_p2_out_43_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_732 = SLR2_io_frontier_in_43_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_733 = _T_1870 ? SLR2_io_p2_out_43_bits : {{8'd0}, crossbar_array_visit_io_out_120_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_734 = _T_1870 ? SLR2_io_p2_out_43_valid : crossbar_array_visit_io_out_120_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_735 = _T_1870 ? SLR2_io_frontier_in_43_ready : crossbar_array_visit_io_in_120_ready; // @[Top-slr.scala 496:58]
  reg  _T_1871; // @[Top-slr.scala 496:25]
  wire  _T_1872 = ~_T_1871; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_736 = SLR2_io_p2_out_44_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_737 = _T_1872 ? 1'h0 : SLR2_io_p2_out_44_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_738 = SLR2_io_frontier_in_44_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_739 = _T_1872 ? SLR2_io_p2_out_44_bits : {{8'd0}, crossbar_array_visit_io_out_25_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_740 = _T_1872 ? SLR2_io_p2_out_44_valid : crossbar_array_visit_io_out_25_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_741 = _T_1872 ? SLR2_io_frontier_in_44_ready : crossbar_array_visit_io_in_25_ready; // @[Top-slr.scala 496:58]
  reg  _T_1873; // @[Top-slr.scala 496:25]
  wire  _T_1874 = ~_T_1873; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_742 = SLR2_io_p2_out_45_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_743 = _T_1874 ? 1'h0 : SLR2_io_p2_out_45_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_744 = SLR2_io_frontier_in_45_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_745 = _T_1874 ? SLR2_io_p2_out_45_bits : {{8'd0}, crossbar_array_visit_io_out_57_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_746 = _T_1874 ? SLR2_io_p2_out_45_valid : crossbar_array_visit_io_out_57_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_747 = _T_1874 ? SLR2_io_frontier_in_45_ready : crossbar_array_visit_io_in_57_ready; // @[Top-slr.scala 496:58]
  reg  _T_1875; // @[Top-slr.scala 496:25]
  wire  _T_1876 = ~_T_1875; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_748 = SLR2_io_p2_out_46_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_749 = _T_1876 ? 1'h0 : SLR2_io_p2_out_46_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_750 = SLR2_io_frontier_in_46_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_751 = _T_1876 ? SLR2_io_p2_out_46_bits : {{8'd0}, crossbar_array_visit_io_out_89_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_752 = _T_1876 ? SLR2_io_p2_out_46_valid : crossbar_array_visit_io_out_89_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_753 = _T_1876 ? SLR2_io_frontier_in_46_ready : crossbar_array_visit_io_in_89_ready; // @[Top-slr.scala 496:58]
  reg  _T_1877; // @[Top-slr.scala 496:25]
  wire  _T_1878 = ~_T_1877; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_754 = SLR2_io_p2_out_47_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_755 = _T_1878 ? 1'h0 : SLR2_io_p2_out_47_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_756 = SLR2_io_frontier_in_47_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_757 = _T_1878 ? SLR2_io_p2_out_47_bits : {{8'd0}, crossbar_array_visit_io_out_121_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_758 = _T_1878 ? SLR2_io_p2_out_47_valid : crossbar_array_visit_io_out_121_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_759 = _T_1878 ? SLR2_io_frontier_in_47_ready : crossbar_array_visit_io_in_121_ready; // @[Top-slr.scala 496:58]
  reg  _T_1879; // @[Top-slr.scala 496:25]
  wire  _T_1880 = ~_T_1879; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_760 = SLR2_io_p2_out_48_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_761 = _T_1880 ? 1'h0 : SLR2_io_p2_out_48_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_762 = SLR2_io_frontier_in_48_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_763 = _T_1880 ? SLR2_io_p2_out_48_bits : {{8'd0}, crossbar_array_visit_io_out_26_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_764 = _T_1880 ? SLR2_io_p2_out_48_valid : crossbar_array_visit_io_out_26_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_765 = _T_1880 ? SLR2_io_frontier_in_48_ready : crossbar_array_visit_io_in_26_ready; // @[Top-slr.scala 496:58]
  reg  _T_1881; // @[Top-slr.scala 496:25]
  wire  _T_1882 = ~_T_1881; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_766 = SLR2_io_p2_out_49_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_767 = _T_1882 ? 1'h0 : SLR2_io_p2_out_49_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_768 = SLR2_io_frontier_in_49_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_769 = _T_1882 ? SLR2_io_p2_out_49_bits : {{8'd0}, crossbar_array_visit_io_out_58_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_770 = _T_1882 ? SLR2_io_p2_out_49_valid : crossbar_array_visit_io_out_58_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_771 = _T_1882 ? SLR2_io_frontier_in_49_ready : crossbar_array_visit_io_in_58_ready; // @[Top-slr.scala 496:58]
  reg  _T_1883; // @[Top-slr.scala 496:25]
  wire  _T_1884 = ~_T_1883; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_772 = SLR2_io_p2_out_50_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_773 = _T_1884 ? 1'h0 : SLR2_io_p2_out_50_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_774 = SLR2_io_frontier_in_50_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_775 = _T_1884 ? SLR2_io_p2_out_50_bits : {{8'd0}, crossbar_array_visit_io_out_90_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_776 = _T_1884 ? SLR2_io_p2_out_50_valid : crossbar_array_visit_io_out_90_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_777 = _T_1884 ? SLR2_io_frontier_in_50_ready : crossbar_array_visit_io_in_90_ready; // @[Top-slr.scala 496:58]
  reg  _T_1885; // @[Top-slr.scala 496:25]
  wire  _T_1886 = ~_T_1885; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_778 = SLR2_io_p2_out_51_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_779 = _T_1886 ? 1'h0 : SLR2_io_p2_out_51_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_780 = SLR2_io_frontier_in_51_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_781 = _T_1886 ? SLR2_io_p2_out_51_bits : {{8'd0}, crossbar_array_visit_io_out_122_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_782 = _T_1886 ? SLR2_io_p2_out_51_valid : crossbar_array_visit_io_out_122_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_783 = _T_1886 ? SLR2_io_frontier_in_51_ready : crossbar_array_visit_io_in_122_ready; // @[Top-slr.scala 496:58]
  reg  _T_1887; // @[Top-slr.scala 496:25]
  wire  _T_1888 = ~_T_1887; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_784 = SLR2_io_p2_out_52_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_785 = _T_1888 ? 1'h0 : SLR2_io_p2_out_52_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_786 = SLR2_io_frontier_in_52_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_787 = _T_1888 ? SLR2_io_p2_out_52_bits : {{8'd0}, crossbar_array_visit_io_out_27_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_788 = _T_1888 ? SLR2_io_p2_out_52_valid : crossbar_array_visit_io_out_27_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_789 = _T_1888 ? SLR2_io_frontier_in_52_ready : crossbar_array_visit_io_in_27_ready; // @[Top-slr.scala 496:58]
  reg  _T_1889; // @[Top-slr.scala 496:25]
  wire  _T_1890 = ~_T_1889; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_790 = SLR2_io_p2_out_53_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_791 = _T_1890 ? 1'h0 : SLR2_io_p2_out_53_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_792 = SLR2_io_frontier_in_53_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_793 = _T_1890 ? SLR2_io_p2_out_53_bits : {{8'd0}, crossbar_array_visit_io_out_59_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_794 = _T_1890 ? SLR2_io_p2_out_53_valid : crossbar_array_visit_io_out_59_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_795 = _T_1890 ? SLR2_io_frontier_in_53_ready : crossbar_array_visit_io_in_59_ready; // @[Top-slr.scala 496:58]
  reg  _T_1891; // @[Top-slr.scala 496:25]
  wire  _T_1892 = ~_T_1891; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_796 = SLR2_io_p2_out_54_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_797 = _T_1892 ? 1'h0 : SLR2_io_p2_out_54_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_798 = SLR2_io_frontier_in_54_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_799 = _T_1892 ? SLR2_io_p2_out_54_bits : {{8'd0}, crossbar_array_visit_io_out_91_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_800 = _T_1892 ? SLR2_io_p2_out_54_valid : crossbar_array_visit_io_out_91_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_801 = _T_1892 ? SLR2_io_frontier_in_54_ready : crossbar_array_visit_io_in_91_ready; // @[Top-slr.scala 496:58]
  reg  _T_1893; // @[Top-slr.scala 496:25]
  wire  _T_1894 = ~_T_1893; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_802 = SLR2_io_p2_out_55_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_803 = _T_1894 ? 1'h0 : SLR2_io_p2_out_55_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_804 = SLR2_io_frontier_in_55_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_805 = _T_1894 ? SLR2_io_p2_out_55_bits : {{8'd0}, crossbar_array_visit_io_out_123_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_806 = _T_1894 ? SLR2_io_p2_out_55_valid : crossbar_array_visit_io_out_123_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_807 = _T_1894 ? SLR2_io_frontier_in_55_ready : crossbar_array_visit_io_in_123_ready; // @[Top-slr.scala 496:58]
  reg  _T_1895; // @[Top-slr.scala 496:25]
  wire  _T_1896 = ~_T_1895; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_808 = SLR2_io_p2_out_56_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_809 = _T_1896 ? 1'h0 : SLR2_io_p2_out_56_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_810 = SLR2_io_frontier_in_56_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_811 = _T_1896 ? SLR2_io_p2_out_56_bits : {{8'd0}, crossbar_array_visit_io_out_28_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_812 = _T_1896 ? SLR2_io_p2_out_56_valid : crossbar_array_visit_io_out_28_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_813 = _T_1896 ? SLR2_io_frontier_in_56_ready : crossbar_array_visit_io_in_28_ready; // @[Top-slr.scala 496:58]
  reg  _T_1897; // @[Top-slr.scala 496:25]
  wire  _T_1898 = ~_T_1897; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_814 = SLR2_io_p2_out_57_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_815 = _T_1898 ? 1'h0 : SLR2_io_p2_out_57_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_816 = SLR2_io_frontier_in_57_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_817 = _T_1898 ? SLR2_io_p2_out_57_bits : {{8'd0}, crossbar_array_visit_io_out_60_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_818 = _T_1898 ? SLR2_io_p2_out_57_valid : crossbar_array_visit_io_out_60_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_819 = _T_1898 ? SLR2_io_frontier_in_57_ready : crossbar_array_visit_io_in_60_ready; // @[Top-slr.scala 496:58]
  reg  _T_1899; // @[Top-slr.scala 496:25]
  wire  _T_1900 = ~_T_1899; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_820 = SLR2_io_p2_out_58_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_821 = _T_1900 ? 1'h0 : SLR2_io_p2_out_58_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_822 = SLR2_io_frontier_in_58_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_823 = _T_1900 ? SLR2_io_p2_out_58_bits : {{8'd0}, crossbar_array_visit_io_out_92_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_824 = _T_1900 ? SLR2_io_p2_out_58_valid : crossbar_array_visit_io_out_92_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_825 = _T_1900 ? SLR2_io_frontier_in_58_ready : crossbar_array_visit_io_in_92_ready; // @[Top-slr.scala 496:58]
  reg  _T_1901; // @[Top-slr.scala 496:25]
  wire  _T_1902 = ~_T_1901; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_826 = SLR2_io_p2_out_59_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_827 = _T_1902 ? 1'h0 : SLR2_io_p2_out_59_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_828 = SLR2_io_frontier_in_59_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_829 = _T_1902 ? SLR2_io_p2_out_59_bits : {{8'd0}, crossbar_array_visit_io_out_124_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_830 = _T_1902 ? SLR2_io_p2_out_59_valid : crossbar_array_visit_io_out_124_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_831 = _T_1902 ? SLR2_io_frontier_in_59_ready : crossbar_array_visit_io_in_124_ready; // @[Top-slr.scala 496:58]
  reg  _T_1903; // @[Top-slr.scala 496:25]
  wire  _T_1904 = ~_T_1903; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_832 = SLR2_io_p2_out_60_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_833 = _T_1904 ? 1'h0 : SLR2_io_p2_out_60_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_834 = SLR2_io_frontier_in_60_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_835 = _T_1904 ? SLR2_io_p2_out_60_bits : {{8'd0}, crossbar_array_visit_io_out_29_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_836 = _T_1904 ? SLR2_io_p2_out_60_valid : crossbar_array_visit_io_out_29_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_837 = _T_1904 ? SLR2_io_frontier_in_60_ready : crossbar_array_visit_io_in_29_ready; // @[Top-slr.scala 496:58]
  reg  _T_1905; // @[Top-slr.scala 496:25]
  wire  _T_1906 = ~_T_1905; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_838 = SLR2_io_p2_out_61_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_839 = _T_1906 ? 1'h0 : SLR2_io_p2_out_61_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_840 = SLR2_io_frontier_in_61_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_841 = _T_1906 ? SLR2_io_p2_out_61_bits : {{8'd0}, crossbar_array_visit_io_out_61_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_842 = _T_1906 ? SLR2_io_p2_out_61_valid : crossbar_array_visit_io_out_61_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_843 = _T_1906 ? SLR2_io_frontier_in_61_ready : crossbar_array_visit_io_in_61_ready; // @[Top-slr.scala 496:58]
  reg  _T_1907; // @[Top-slr.scala 496:25]
  wire  _T_1908 = ~_T_1907; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_844 = SLR2_io_p2_out_62_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_845 = _T_1908 ? 1'h0 : SLR2_io_p2_out_62_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_846 = SLR2_io_frontier_in_62_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_847 = _T_1908 ? SLR2_io_p2_out_62_bits : {{8'd0}, crossbar_array_visit_io_out_93_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_848 = _T_1908 ? SLR2_io_p2_out_62_valid : crossbar_array_visit_io_out_93_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_849 = _T_1908 ? SLR2_io_frontier_in_62_ready : crossbar_array_visit_io_in_93_ready; // @[Top-slr.scala 496:58]
  reg  _T_1909; // @[Top-slr.scala 496:25]
  wire  _T_1910 = ~_T_1909; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_850 = SLR2_io_p2_out_63_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_851 = _T_1910 ? 1'h0 : SLR2_io_p2_out_63_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_852 = SLR2_io_frontier_in_63_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_853 = _T_1910 ? SLR2_io_p2_out_63_bits : {{8'd0}, crossbar_array_visit_io_out_125_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_854 = _T_1910 ? SLR2_io_p2_out_63_valid : crossbar_array_visit_io_out_125_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_855 = _T_1910 ? SLR2_io_frontier_in_63_ready : crossbar_array_visit_io_in_125_ready; // @[Top-slr.scala 496:58]
  reg  _T_1911; // @[Top-slr.scala 496:25]
  wire  _T_1912 = ~_T_1911; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_856 = SLR2_io_p2_out_64_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_857 = _T_1912 ? 1'h0 : SLR2_io_p2_out_64_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_858 = SLR2_io_frontier_in_64_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_859 = _T_1912 ? SLR2_io_p2_out_64_bits : {{8'd0}, crossbar_array_visit_io_out_30_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_860 = _T_1912 ? SLR2_io_p2_out_64_valid : crossbar_array_visit_io_out_30_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_861 = _T_1912 ? SLR2_io_frontier_in_64_ready : crossbar_array_visit_io_in_30_ready; // @[Top-slr.scala 496:58]
  reg  _T_1913; // @[Top-slr.scala 496:25]
  wire  _T_1914 = ~_T_1913; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_862 = SLR2_io_p2_out_65_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_863 = _T_1914 ? 1'h0 : SLR2_io_p2_out_65_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_864 = SLR2_io_frontier_in_65_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_865 = _T_1914 ? SLR2_io_p2_out_65_bits : {{8'd0}, crossbar_array_visit_io_out_62_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_866 = _T_1914 ? SLR2_io_p2_out_65_valid : crossbar_array_visit_io_out_62_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_867 = _T_1914 ? SLR2_io_frontier_in_65_ready : crossbar_array_visit_io_in_62_ready; // @[Top-slr.scala 496:58]
  reg  _T_1915; // @[Top-slr.scala 496:25]
  wire  _T_1916 = ~_T_1915; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_868 = SLR2_io_p2_out_66_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_869 = _T_1916 ? 1'h0 : SLR2_io_p2_out_66_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_870 = SLR2_io_frontier_in_66_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_871 = _T_1916 ? SLR2_io_p2_out_66_bits : {{8'd0}, crossbar_array_visit_io_out_94_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_872 = _T_1916 ? SLR2_io_p2_out_66_valid : crossbar_array_visit_io_out_94_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_873 = _T_1916 ? SLR2_io_frontier_in_66_ready : crossbar_array_visit_io_in_94_ready; // @[Top-slr.scala 496:58]
  reg  _T_1917; // @[Top-slr.scala 496:25]
  wire  _T_1918 = ~_T_1917; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_874 = SLR2_io_p2_out_67_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_875 = _T_1918 ? 1'h0 : SLR2_io_p2_out_67_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_876 = SLR2_io_frontier_in_67_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_877 = _T_1918 ? SLR2_io_p2_out_67_bits : {{8'd0}, crossbar_array_visit_io_out_126_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_878 = _T_1918 ? SLR2_io_p2_out_67_valid : crossbar_array_visit_io_out_126_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_879 = _T_1918 ? SLR2_io_frontier_in_67_ready : crossbar_array_visit_io_in_126_ready; // @[Top-slr.scala 496:58]
  reg  _T_1919; // @[Top-slr.scala 496:25]
  wire  _T_1920 = ~_T_1919; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_880 = SLR2_io_p2_out_68_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_881 = _T_1920 ? 1'h0 : SLR2_io_p2_out_68_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_882 = SLR2_io_frontier_in_68_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_883 = _T_1920 ? SLR2_io_p2_out_68_bits : {{8'd0}, crossbar_array_visit_io_out_31_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_884 = _T_1920 ? SLR2_io_p2_out_68_valid : crossbar_array_visit_io_out_31_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_885 = _T_1920 ? SLR2_io_frontier_in_68_ready : crossbar_array_visit_io_in_31_ready; // @[Top-slr.scala 496:58]
  reg  _T_1921; // @[Top-slr.scala 496:25]
  wire  _T_1922 = ~_T_1921; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_886 = SLR2_io_p2_out_69_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_887 = _T_1922 ? 1'h0 : SLR2_io_p2_out_69_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_888 = SLR2_io_frontier_in_69_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_889 = _T_1922 ? SLR2_io_p2_out_69_bits : {{8'd0}, crossbar_array_visit_io_out_63_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_890 = _T_1922 ? SLR2_io_p2_out_69_valid : crossbar_array_visit_io_out_63_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_891 = _T_1922 ? SLR2_io_frontier_in_69_ready : crossbar_array_visit_io_in_63_ready; // @[Top-slr.scala 496:58]
  reg  _T_1923; // @[Top-slr.scala 496:25]
  wire  _T_1924 = ~_T_1923; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_892 = SLR2_io_p2_out_70_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_893 = _T_1924 ? 1'h0 : SLR2_io_p2_out_70_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_894 = SLR2_io_frontier_in_70_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_895 = _T_1924 ? SLR2_io_p2_out_70_bits : {{8'd0}, crossbar_array_visit_io_out_95_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_896 = _T_1924 ? SLR2_io_p2_out_70_valid : crossbar_array_visit_io_out_95_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_897 = _T_1924 ? SLR2_io_frontier_in_70_ready : crossbar_array_visit_io_in_95_ready; // @[Top-slr.scala 496:58]
  reg  _T_1925; // @[Top-slr.scala 496:25]
  wire  _T_1926 = ~_T_1925; // @[Top-slr.scala 496:50]
  wire [31:0] _GEN_898 = SLR2_io_p2_out_71_bits; // @[Top-slr.scala 496:58]
  wire  _GEN_899 = _T_1926 ? 1'h0 : SLR2_io_p2_out_71_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_900 = SLR2_io_frontier_in_71_ready; // @[Top-slr.scala 496:58]
  wire [31:0] _GEN_901 = _T_1926 ? SLR2_io_p2_out_71_bits : {{8'd0}, crossbar_array_visit_io_out_127_bits}; // @[Top-slr.scala 496:58]
  wire  _GEN_902 = _T_1926 ? SLR2_io_p2_out_71_valid : crossbar_array_visit_io_out_127_valid; // @[Top-slr.scala 496:58]
  wire  _GEN_903 = _T_1926 ? SLR2_io_frontier_in_71_ready : crossbar_array_visit_io_in_127_ready; // @[Top-slr.scala 496:58]
  wire  _T_306_0 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_1 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_2 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_3 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_4 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_5 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_6 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_7 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_8 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_9 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_10 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_11 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_12 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_306_13 = 1'h0; // @[Top-slr.scala 237:43 Top-slr.scala 237:43]
  wire  _T_307_0 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_1 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_2 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_3 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_4 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_5 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_6 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_7 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_8 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_9 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_10 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_11 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_12 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire  _T_307_13 = 1'h0; // @[Top-slr.scala 238:43 Top-slr.scala 238:43]
  wire [63:0] _T_308_0 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_1 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_2 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_3 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_4 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_5 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_6 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_7 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_8 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_9 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_10 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_11 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_12 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_13 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_14 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_15 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_16 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_17 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_18 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_19 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_20 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_21 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_22 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_23 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_24 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_25 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_26 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_27 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_28 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_29 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_30 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_31 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_32 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_33 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_34 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_35 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_36 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_37 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_38 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_39 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_40 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_41 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_42 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_43 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_44 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_45 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_46 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_47 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_48 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_49 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_50 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_51 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_52 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_53 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_54 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_308_55 = 64'h0; // @[Top-slr.scala 247:47 Top-slr.scala 247:47]
  wire [63:0] _T_309_0 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_1 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_2 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_3 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_4 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_5 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_6 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_7 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_8 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_9 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_10 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_11 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_12 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_13 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_14 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_15 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_16 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_17 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_18 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_19 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_20 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_21 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_22 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_23 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_24 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_25 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_26 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_27 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_28 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_29 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_30 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_31 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_32 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_33 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_34 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_35 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_36 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_37 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_38 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_39 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_40 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_41 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_42 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_43 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_44 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_45 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_46 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_47 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_48 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_49 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_50 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_51 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_52 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_53 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_54 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_309_55 = 64'h0; // @[Top-slr.scala 248:47 Top-slr.scala 248:47]
  wire [63:0] _T_310_0 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_1 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_2 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_3 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_4 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_5 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_6 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_7 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_8 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_9 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_10 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_11 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_12 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_13 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_14 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_15 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_16 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_17 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_18 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_19 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_20 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_21 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_22 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_23 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_24 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_25 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_26 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_27 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_28 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_29 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_30 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_31 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_32 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_33 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_34 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_35 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_36 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_37 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_38 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_39 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_40 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_41 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_42 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_43 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_44 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_45 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_46 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_47 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_48 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_49 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_50 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_51 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_52 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_53 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_54 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_310_55 = 64'h0; // @[Top-slr.scala 249:45 Top-slr.scala 249:45]
  wire [63:0] _T_311_0 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_1 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_2 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_3 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_4 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_5 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_6 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_7 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_8 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_9 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_10 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_11 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_12 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_13 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_14 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_15 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_16 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_17 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_18 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_19 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_20 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_21 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_22 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_23 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_24 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_25 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_26 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_27 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_28 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_29 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_30 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_31 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_32 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_33 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_34 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_35 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_36 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_37 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_38 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_39 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_40 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_41 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_42 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_43 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_44 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_45 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_46 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_47 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_48 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_49 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_50 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_51 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_52 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_53 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_54 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_311_55 = 64'h0; // @[Top-slr.scala 250:48 Top-slr.scala 250:48]
  wire [63:0] _T_312_0 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_1 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_2 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_3 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_4 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_5 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_6 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_7 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_8 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_9 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_10 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_11 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_12 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_13 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_14 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_15 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_16 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_17 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_18 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_19 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_20 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_21 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_22 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_23 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_24 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_25 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_26 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_27 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_28 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_29 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_30 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_31 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_32 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_33 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_34 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_35 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_36 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_37 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_38 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_39 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_40 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_41 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_42 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_43 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_44 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_45 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_46 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_47 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_48 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_49 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_50 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_51 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_52 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_53 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_54 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_312_55 = 64'h0; // @[Top-slr.scala 251:48 Top-slr.scala 251:48]
  wire [63:0] _T_313_0 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_1 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_2 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_3 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_4 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_5 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_6 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_7 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_8 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_9 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_10 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_11 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_12 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_13 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_14 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_15 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_16 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_17 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_18 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_19 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_20 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_21 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_22 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_23 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_24 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_25 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_26 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_27 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_28 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_29 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_30 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_31 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_32 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_33 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_34 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_35 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_36 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_37 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_38 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_39 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_40 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_41 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_42 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_43 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_44 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_45 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_46 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_47 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_48 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_49 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_50 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_51 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_52 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_53 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_54 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [63:0] _T_313_55 = 64'h0; // @[Top-slr.scala 252:46 Top-slr.scala 252:46]
  wire [31:0] _T_594_0 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_1 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_2 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_3 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_4 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_5 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_6 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_7 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_8 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_9 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_10 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_11 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_12 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_13 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_14 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_15 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_16 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_17 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_18 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_19 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_20 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_21 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_22 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_23 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_24 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_25 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_26 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_27 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_28 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_29 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_30 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_31 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_32 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_33 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_34 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_35 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_36 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_37 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_38 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_39 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_40 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_41 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_42 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_43 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_44 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_45 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_46 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_47 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_48 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_49 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_50 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_51 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_52 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_53 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_54 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire [31:0] _T_594_55 = 32'h0; // @[Top-slr.scala 307:40 Top-slr.scala 307:40]
  wire  _T_872_0 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_1 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_2 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_3 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_4 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_5 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_6 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_7 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_8 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_9 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_10 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_11 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_12 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_13 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_14 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_15 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_16 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_872_17 = 1'h0; // @[Top-slr.scala 326:43 Top-slr.scala 326:43]
  wire  _T_873_0 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_1 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_2 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_3 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_4 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_5 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_6 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_7 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_8 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_9 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_10 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_11 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_12 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_13 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_14 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_15 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_16 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_873_17 = 1'h0; // @[Top-slr.scala 327:43 Top-slr.scala 327:43]
  wire  _T_874_0 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_1 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_2 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_3 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_4 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_5 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_6 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_7 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_8 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_9 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_10 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_11 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_12 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_13 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_14 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_15 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_16 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire  _T_874_17 = 1'h0; // @[Top-slr.scala 328:43 Top-slr.scala 328:43]
  wire [63:0] _T_875_0 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_1 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_2 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_3 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_4 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_5 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_6 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_7 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_8 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_9 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_10 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_11 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_12 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_13 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_14 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_15 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_16 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_17 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_18 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_19 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_20 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_21 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_22 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_23 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_24 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_25 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_26 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_27 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_28 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_29 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_30 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_31 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_32 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_33 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_34 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_35 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_36 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_37 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_38 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_39 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_40 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_41 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_42 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_43 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_44 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_45 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_46 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_47 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_48 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_49 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_50 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_51 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_52 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_53 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_54 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_55 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_56 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_57 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_58 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_59 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_60 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_61 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_62 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_63 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_64 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_65 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_66 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_67 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_68 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_69 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_70 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_875_71 = 64'h0; // @[Top-slr.scala 338:45 Top-slr.scala 338:45]
  wire [63:0] _T_876_0 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_1 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_2 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_3 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_4 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_5 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_6 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_7 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_8 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_9 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_10 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_11 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_12 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_13 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_14 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_15 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_16 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_17 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_18 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_19 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_20 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_21 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_22 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_23 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_24 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_25 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_26 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_27 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_28 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_29 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_30 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_31 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_32 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_33 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_34 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_35 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_36 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_37 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_38 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_39 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_40 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_41 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_42 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_43 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_44 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_45 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_46 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_47 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_48 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_49 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_50 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_51 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_52 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_53 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_54 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_55 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_56 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_57 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_58 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_59 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_60 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_61 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_62 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_63 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_64 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_65 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_66 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_67 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_68 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_69 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_70 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_876_71 = 64'h0; // @[Top-slr.scala 339:45 Top-slr.scala 339:45]
  wire [63:0] _T_877_0 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_1 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_2 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_3 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_4 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_5 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_6 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_7 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_8 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_9 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_10 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_11 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_12 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_13 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_14 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_15 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_16 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_17 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_18 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_19 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_20 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_21 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_22 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_23 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_24 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_25 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_26 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_27 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_28 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_29 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_30 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_31 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_32 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_33 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_34 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_35 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_36 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_37 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_38 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_39 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_40 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_41 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_42 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_43 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_44 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_45 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_46 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_47 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_48 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_49 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_50 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_51 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_52 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_53 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_54 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_55 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_56 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_57 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_58 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_59 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_60 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_61 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_62 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_63 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_64 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_65 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_66 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_67 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_68 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_69 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_70 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_877_71 = 64'h0; // @[Top-slr.scala 340:45 Top-slr.scala 340:45]
  wire [63:0] _T_878_0 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_1 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_2 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_3 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_4 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_5 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_6 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_7 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_8 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_9 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_10 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_11 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_12 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_13 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_14 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_15 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_16 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_17 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_18 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_19 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_20 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_21 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_22 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_23 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_24 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_25 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_26 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_27 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_28 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_29 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_30 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_31 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_32 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_33 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_34 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_35 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_36 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_37 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_38 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_39 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_40 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_41 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_42 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_43 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_44 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_45 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_46 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_47 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_48 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_49 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_50 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_51 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_52 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_53 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_54 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_55 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_56 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_57 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_58 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_59 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_60 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_61 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_62 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_63 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_64 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_65 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_66 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_67 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_68 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_69 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_70 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_878_71 = 64'h0; // @[Top-slr.scala 341:46 Top-slr.scala 341:46]
  wire [63:0] _T_879_0 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_1 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_2 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_3 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_4 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_5 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_6 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_7 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_8 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_9 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_10 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_11 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_12 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_13 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_14 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_15 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_16 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_17 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_18 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_19 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_20 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_21 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_22 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_23 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_24 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_25 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_26 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_27 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_28 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_29 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_30 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_31 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_32 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_33 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_34 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_35 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_36 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_37 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_38 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_39 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_40 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_41 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_42 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_43 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_44 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_45 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_46 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_47 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_48 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_49 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_50 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_51 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_52 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_53 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_54 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_55 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_56 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_57 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_58 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_59 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_60 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_61 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_62 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_63 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_64 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_65 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_66 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_67 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_68 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_69 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_70 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_879_71 = 64'h0; // @[Top-slr.scala 342:46 Top-slr.scala 342:46]
  wire [63:0] _T_880_0 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_1 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_2 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_3 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_4 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_5 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_6 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_7 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_8 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_9 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_10 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_11 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_12 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_13 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_14 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_15 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_16 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_17 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_18 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_19 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_20 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_21 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_22 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_23 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_24 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_25 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_26 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_27 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_28 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_29 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_30 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_31 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_32 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_33 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_34 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_35 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_36 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_37 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_38 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_39 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_40 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_41 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_42 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_43 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_44 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_45 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_46 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_47 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_48 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_49 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_50 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_51 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_52 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_53 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_54 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_55 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_56 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_57 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_58 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_59 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_60 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_61 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_62 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_63 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_64 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_65 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_66 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_67 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_68 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_69 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_70 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [63:0] _T_880_71 = 64'h0; // @[Top-slr.scala 343:46 Top-slr.scala 343:46]
  wire [31:0] _T_1313_0 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_1 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_2 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_3 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_4 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_5 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_6 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_7 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_8 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_9 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_10 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_11 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_12 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_13 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_14 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_15 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_16 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_17 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_18 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_19 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_20 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_21 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_22 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_23 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_24 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_25 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_26 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_27 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_28 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_29 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_30 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_31 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_32 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_33 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_34 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_35 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_36 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_37 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_38 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_39 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_40 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_41 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_42 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_43 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_44 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_45 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_46 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_47 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_48 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_49 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_50 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_51 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_52 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_53 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_54 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_55 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_56 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_57 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_58 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_59 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_60 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_61 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_62 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_63 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_64 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_65 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_66 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_67 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_68 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_69 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_70 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  wire [31:0] _T_1313_71 = 32'h0; // @[Top-slr.scala 401:42 Top-slr.scala 401:42]
  master master ( // @[Top-slr.scala 48:24]
    .clock(master_clock),
    .reset(master_reset),
    .io_global_start(master_io_global_start),
    .io_global_finish(master_io_global_finish),
    .io_start(master_io_start),
    .io_frontier_flag(master_io_frontier_flag),
    .io_current_level(master_io_current_level),
    .io_mem_end_0(master_io_mem_end_0),
    .io_mem_end_1(master_io_mem_end_1),
    .io_mem_end_2(master_io_mem_end_2),
    .io_mem_end_3(master_io_mem_end_3),
    .io_mem_end_4(master_io_mem_end_4),
    .io_mem_end_5(master_io_mem_end_5),
    .io_mem_end_6(master_io_mem_end_6),
    .io_mem_end_7(master_io_mem_end_7),
    .io_mem_end_8(master_io_mem_end_8),
    .io_mem_end_9(master_io_mem_end_9),
    .io_mem_end_10(master_io_mem_end_10),
    .io_mem_end_11(master_io_mem_end_11),
    .io_mem_end_12(master_io_mem_end_12),
    .io_mem_end_13(master_io_mem_end_13),
    .io_mem_end_14(master_io_mem_end_14),
    .io_mem_end_15(master_io_mem_end_15),
    .io_mem_end_16(master_io_mem_end_16),
    .io_mem_end_17(master_io_mem_end_17),
    .io_mem_end_18(master_io_mem_end_18),
    .io_mem_end_19(master_io_mem_end_19),
    .io_mem_end_20(master_io_mem_end_20),
    .io_mem_end_21(master_io_mem_end_21),
    .io_mem_end_22(master_io_mem_end_22),
    .io_mem_end_23(master_io_mem_end_23),
    .io_mem_end_24(master_io_mem_end_24),
    .io_mem_end_25(master_io_mem_end_25),
    .io_mem_end_26(master_io_mem_end_26),
    .io_mem_end_27(master_io_mem_end_27),
    .io_mem_end_28(master_io_mem_end_28),
    .io_mem_end_29(master_io_mem_end_29),
    .io_mem_end_30(master_io_mem_end_30),
    .io_mem_end_31(master_io_mem_end_31),
    .io_p2_end(master_io_p2_end),
    .io_end_0(master_io_end_0),
    .io_end_1(master_io_end_1),
    .io_end_2(master_io_end_2),
    .io_end_3(master_io_end_3),
    .io_end_4(master_io_end_4),
    .io_end_5(master_io_end_5),
    .io_end_6(master_io_end_6),
    .io_end_7(master_io_end_7),
    .io_end_8(master_io_end_8),
    .io_end_9(master_io_end_9),
    .io_end_10(master_io_end_10),
    .io_end_11(master_io_end_11),
    .io_end_12(master_io_end_12),
    .io_end_13(master_io_end_13),
    .io_end_14(master_io_end_14),
    .io_end_15(master_io_end_15),
    .io_end_16(master_io_end_16),
    .io_end_17(master_io_end_17),
    .io_end_18(master_io_end_18),
    .io_end_19(master_io_end_19),
    .io_end_20(master_io_end_20),
    .io_end_21(master_io_end_21),
    .io_end_22(master_io_end_22),
    .io_end_23(master_io_end_23),
    .io_end_24(master_io_end_24),
    .io_end_25(master_io_end_25),
    .io_end_26(master_io_end_26),
    .io_end_27(master_io_end_27),
    .io_end_28(master_io_end_28),
    .io_end_29(master_io_end_29),
    .io_end_30(master_io_end_30),
    .io_end_31(master_io_end_31),
    .io_p2_count_0(master_io_p2_count_0),
    .io_p2_count_1(master_io_p2_count_1),
    .io_p2_count_2(master_io_p2_count_2),
    .io_p2_count_3(master_io_p2_count_3),
    .io_p2_count_4(master_io_p2_count_4),
    .io_p2_count_5(master_io_p2_count_5),
    .io_p2_count_6(master_io_p2_count_6),
    .io_p2_count_7(master_io_p2_count_7),
    .io_p2_count_8(master_io_p2_count_8),
    .io_p2_count_9(master_io_p2_count_9),
    .io_p2_count_10(master_io_p2_count_10),
    .io_p2_count_11(master_io_p2_count_11),
    .io_p2_count_12(master_io_p2_count_12),
    .io_p2_count_13(master_io_p2_count_13),
    .io_p2_count_14(master_io_p2_count_14),
    .io_p2_count_15(master_io_p2_count_15),
    .io_p2_count_16(master_io_p2_count_16),
    .io_p2_count_17(master_io_p2_count_17),
    .io_p2_count_18(master_io_p2_count_18),
    .io_p2_count_19(master_io_p2_count_19),
    .io_p2_count_20(master_io_p2_count_20),
    .io_p2_count_21(master_io_p2_count_21),
    .io_p2_count_22(master_io_p2_count_22),
    .io_p2_count_23(master_io_p2_count_23),
    .io_p2_count_24(master_io_p2_count_24),
    .io_p2_count_25(master_io_p2_count_25),
    .io_p2_count_26(master_io_p2_count_26),
    .io_p2_count_27(master_io_p2_count_27),
    .io_p2_count_28(master_io_p2_count_28),
    .io_p2_count_29(master_io_p2_count_29),
    .io_p2_count_30(master_io_p2_count_30),
    .io_p2_count_31(master_io_p2_count_31),
    .io_mem_count_0(master_io_mem_count_0),
    .io_mem_count_1(master_io_mem_count_1),
    .io_mem_count_2(master_io_mem_count_2),
    .io_mem_count_3(master_io_mem_count_3),
    .io_mem_count_4(master_io_mem_count_4),
    .io_mem_count_5(master_io_mem_count_5),
    .io_mem_count_6(master_io_mem_count_6),
    .io_mem_count_7(master_io_mem_count_7),
    .io_mem_count_8(master_io_mem_count_8),
    .io_mem_count_9(master_io_mem_count_9),
    .io_mem_count_10(master_io_mem_count_10),
    .io_mem_count_11(master_io_mem_count_11),
    .io_mem_count_12(master_io_mem_count_12),
    .io_mem_count_13(master_io_mem_count_13),
    .io_mem_count_14(master_io_mem_count_14),
    .io_mem_count_15(master_io_mem_count_15),
    .io_mem_count_16(master_io_mem_count_16),
    .io_mem_count_17(master_io_mem_count_17),
    .io_mem_count_18(master_io_mem_count_18),
    .io_mem_count_19(master_io_mem_count_19),
    .io_mem_count_20(master_io_mem_count_20),
    .io_mem_count_21(master_io_mem_count_21),
    .io_mem_count_22(master_io_mem_count_22),
    .io_mem_count_23(master_io_mem_count_23),
    .io_mem_count_24(master_io_mem_count_24),
    .io_mem_count_25(master_io_mem_count_25),
    .io_mem_count_26(master_io_mem_count_26),
    .io_mem_count_27(master_io_mem_count_27),
    .io_mem_count_28(master_io_mem_count_28),
    .io_mem_count_29(master_io_mem_count_29),
    .io_mem_count_30(master_io_mem_count_30),
    .io_mem_count_31(master_io_mem_count_31),
    .io_frontier_pull_count_0(master_io_frontier_pull_count_0),
    .io_frontier_pull_count_1(master_io_frontier_pull_count_1),
    .io_frontier_pull_count_2(master_io_frontier_pull_count_2),
    .io_frontier_pull_count_3(master_io_frontier_pull_count_3),
    .io_frontier_pull_count_4(master_io_frontier_pull_count_4),
    .io_frontier_pull_count_5(master_io_frontier_pull_count_5),
    .io_frontier_pull_count_6(master_io_frontier_pull_count_6),
    .io_frontier_pull_count_7(master_io_frontier_pull_count_7),
    .io_frontier_pull_count_8(master_io_frontier_pull_count_8),
    .io_frontier_pull_count_9(master_io_frontier_pull_count_9),
    .io_frontier_pull_count_10(master_io_frontier_pull_count_10),
    .io_frontier_pull_count_11(master_io_frontier_pull_count_11),
    .io_frontier_pull_count_12(master_io_frontier_pull_count_12),
    .io_frontier_pull_count_13(master_io_frontier_pull_count_13),
    .io_frontier_pull_count_14(master_io_frontier_pull_count_14),
    .io_frontier_pull_count_15(master_io_frontier_pull_count_15),
    .io_frontier_pull_count_16(master_io_frontier_pull_count_16),
    .io_frontier_pull_count_17(master_io_frontier_pull_count_17),
    .io_frontier_pull_count_18(master_io_frontier_pull_count_18),
    .io_frontier_pull_count_19(master_io_frontier_pull_count_19),
    .io_frontier_pull_count_20(master_io_frontier_pull_count_20),
    .io_frontier_pull_count_21(master_io_frontier_pull_count_21),
    .io_frontier_pull_count_22(master_io_frontier_pull_count_22),
    .io_frontier_pull_count_23(master_io_frontier_pull_count_23),
    .io_frontier_pull_count_24(master_io_frontier_pull_count_24),
    .io_frontier_pull_count_25(master_io_frontier_pull_count_25),
    .io_frontier_pull_count_26(master_io_frontier_pull_count_26),
    .io_frontier_pull_count_27(master_io_frontier_pull_count_27),
    .io_frontier_pull_count_28(master_io_frontier_pull_count_28),
    .io_frontier_pull_count_29(master_io_frontier_pull_count_29),
    .io_frontier_pull_count_30(master_io_frontier_pull_count_30),
    .io_frontier_pull_count_31(master_io_frontier_pull_count_31),
    .io_p2_pull_count_0(master_io_p2_pull_count_0),
    .io_p2_pull_count_1(master_io_p2_pull_count_1),
    .io_p2_pull_count_2(master_io_p2_pull_count_2),
    .io_p2_pull_count_3(master_io_p2_pull_count_3),
    .io_p2_pull_count_4(master_io_p2_pull_count_4),
    .io_p2_pull_count_5(master_io_p2_pull_count_5),
    .io_p2_pull_count_6(master_io_p2_pull_count_6),
    .io_p2_pull_count_7(master_io_p2_pull_count_7),
    .io_p2_pull_count_8(master_io_p2_pull_count_8),
    .io_p2_pull_count_9(master_io_p2_pull_count_9),
    .io_p2_pull_count_10(master_io_p2_pull_count_10),
    .io_p2_pull_count_11(master_io_p2_pull_count_11),
    .io_p2_pull_count_12(master_io_p2_pull_count_12),
    .io_p2_pull_count_13(master_io_p2_pull_count_13),
    .io_p2_pull_count_14(master_io_p2_pull_count_14),
    .io_p2_pull_count_15(master_io_p2_pull_count_15),
    .io_p2_pull_count_16(master_io_p2_pull_count_16),
    .io_p2_pull_count_17(master_io_p2_pull_count_17),
    .io_p2_pull_count_18(master_io_p2_pull_count_18),
    .io_p2_pull_count_19(master_io_p2_pull_count_19),
    .io_p2_pull_count_20(master_io_p2_pull_count_20),
    .io_p2_pull_count_21(master_io_p2_pull_count_21),
    .io_p2_pull_count_22(master_io_p2_pull_count_22),
    .io_p2_pull_count_23(master_io_p2_pull_count_23),
    .io_p2_pull_count_24(master_io_p2_pull_count_24),
    .io_p2_pull_count_25(master_io_p2_pull_count_25),
    .io_p2_pull_count_26(master_io_p2_pull_count_26),
    .io_p2_pull_count_27(master_io_p2_pull_count_27),
    .io_p2_pull_count_28(master_io_p2_pull_count_28),
    .io_p2_pull_count_29(master_io_p2_pull_count_29),
    .io_p2_pull_count_30(master_io_p2_pull_count_30),
    .io_p2_pull_count_31(master_io_p2_pull_count_31),
    .io_last_iteration_state_0(master_io_last_iteration_state_0),
    .io_last_iteration_state_1(master_io_last_iteration_state_1),
    .io_last_iteration_state_2(master_io_last_iteration_state_2),
    .io_last_iteration_state_3(master_io_last_iteration_state_3),
    .io_last_iteration_state_4(master_io_last_iteration_state_4),
    .io_last_iteration_state_5(master_io_last_iteration_state_5),
    .io_last_iteration_state_6(master_io_last_iteration_state_6),
    .io_last_iteration_state_7(master_io_last_iteration_state_7),
    .io_last_iteration_state_8(master_io_last_iteration_state_8),
    .io_last_iteration_state_9(master_io_last_iteration_state_9),
    .io_last_iteration_state_10(master_io_last_iteration_state_10),
    .io_last_iteration_state_11(master_io_last_iteration_state_11),
    .io_last_iteration_state_12(master_io_last_iteration_state_12),
    .io_last_iteration_state_13(master_io_last_iteration_state_13),
    .io_last_iteration_state_14(master_io_last_iteration_state_14),
    .io_last_iteration_state_15(master_io_last_iteration_state_15),
    .io_last_iteration_state_16(master_io_last_iteration_state_16),
    .io_last_iteration_state_17(master_io_last_iteration_state_17),
    .io_last_iteration_state_18(master_io_last_iteration_state_18),
    .io_last_iteration_state_19(master_io_last_iteration_state_19),
    .io_last_iteration_state_20(master_io_last_iteration_state_20),
    .io_last_iteration_state_21(master_io_last_iteration_state_21),
    .io_last_iteration_state_22(master_io_last_iteration_state_22),
    .io_last_iteration_state_23(master_io_last_iteration_state_23),
    .io_last_iteration_state_24(master_io_last_iteration_state_24),
    .io_last_iteration_state_25(master_io_last_iteration_state_25),
    .io_last_iteration_state_26(master_io_last_iteration_state_26),
    .io_last_iteration_state_27(master_io_last_iteration_state_27),
    .io_last_iteration_state_28(master_io_last_iteration_state_28),
    .io_last_iteration_state_29(master_io_last_iteration_state_29),
    .io_last_iteration_state_30(master_io_last_iteration_state_30),
    .io_last_iteration_state_31(master_io_last_iteration_state_31),
    .io_levels_push_to_pull_level(master_io_levels_push_to_pull_level),
    .io_levels_pull_to_push_level(master_io_levels_pull_to_push_level),
    .io_push_or_pull(master_io_push_or_pull),
    .io_init_bram_0(master_io_init_bram_0),
    .io_init_bram_1(master_io_init_bram_1),
    .io_init_bram_2(master_io_init_bram_2),
    .io_init_bram_3(master_io_init_bram_3),
    .io_init_bram_4(master_io_init_bram_4),
    .io_init_bram_5(master_io_init_bram_5),
    .io_init_bram_6(master_io_init_bram_6),
    .io_init_bram_7(master_io_init_bram_7),
    .io_init_bram_8(master_io_init_bram_8),
    .io_init_bram_9(master_io_init_bram_9),
    .io_init_bram_10(master_io_init_bram_10),
    .io_init_bram_11(master_io_init_bram_11),
    .io_init_bram_12(master_io_init_bram_12),
    .io_init_bram_13(master_io_init_bram_13),
    .io_init_bram_14(master_io_init_bram_14),
    .io_init_bram_15(master_io_init_bram_15),
    .io_init_bram_16(master_io_init_bram_16),
    .io_init_bram_17(master_io_init_bram_17),
    .io_init_bram_18(master_io_init_bram_18),
    .io_init_bram_19(master_io_init_bram_19),
    .io_init_bram_20(master_io_init_bram_20),
    .io_init_bram_21(master_io_init_bram_21),
    .io_init_bram_22(master_io_init_bram_22),
    .io_init_bram_23(master_io_init_bram_23),
    .io_init_bram_24(master_io_init_bram_24),
    .io_init_bram_25(master_io_init_bram_25),
    .io_init_bram_26(master_io_init_bram_26),
    .io_init_bram_27(master_io_init_bram_27),
    .io_init_bram_28(master_io_init_bram_28),
    .io_init_bram_29(master_io_init_bram_29),
    .io_init_bram_30(master_io_init_bram_30),
    .io_init_bram_31(master_io_init_bram_31)
  );
  SLR0_Mem SLR0_Mem ( // @[Top-slr.scala 49:26]
    .clock(SLR0_Mem_clock),
    .reset(SLR0_Mem_reset),
    .io_level(SLR0_Mem_io_level),
    .io_kernel_count(SLR0_Mem_io_kernel_count),
    .io_mem_clock(SLR0_Mem_io_mem_clock),
    .io_reset_h(SLR0_Mem_io_reset_h),
    .io_master_finish(SLR0_Mem_io_master_finish),
    .io_node_num(SLR0_Mem_io_node_num),
    .io_push_or_pull_state(SLR0_Mem_io_push_or_pull_state),
    .io_offsets_CSR_R_offset(SLR0_Mem_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(SLR0_Mem_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(SLR0_Mem_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(SLR0_Mem_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(SLR0_Mem_io_offsets_level_offset),
    .io_R_array_index_0_ready(SLR0_Mem_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(SLR0_Mem_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(SLR0_Mem_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(SLR0_Mem_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(SLR0_Mem_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(SLR0_Mem_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(SLR0_Mem_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(SLR0_Mem_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(SLR0_Mem_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(SLR0_Mem_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(SLR0_Mem_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(SLR0_Mem_io_R_array_index_3_bits),
    .io_R_array_index_4_ready(SLR0_Mem_io_R_array_index_4_ready),
    .io_R_array_index_4_valid(SLR0_Mem_io_R_array_index_4_valid),
    .io_R_array_index_4_bits(SLR0_Mem_io_R_array_index_4_bits),
    .io_R_array_index_5_ready(SLR0_Mem_io_R_array_index_5_ready),
    .io_R_array_index_5_valid(SLR0_Mem_io_R_array_index_5_valid),
    .io_R_array_index_5_bits(SLR0_Mem_io_R_array_index_5_bits),
    .io_R_array_index_6_ready(SLR0_Mem_io_R_array_index_6_ready),
    .io_R_array_index_6_valid(SLR0_Mem_io_R_array_index_6_valid),
    .io_R_array_index_6_bits(SLR0_Mem_io_R_array_index_6_bits),
    .io_R_array_index_7_ready(SLR0_Mem_io_R_array_index_7_ready),
    .io_R_array_index_7_valid(SLR0_Mem_io_R_array_index_7_valid),
    .io_R_array_index_7_bits(SLR0_Mem_io_R_array_index_7_bits),
    .io_R_array_index_8_ready(SLR0_Mem_io_R_array_index_8_ready),
    .io_R_array_index_8_valid(SLR0_Mem_io_R_array_index_8_valid),
    .io_R_array_index_8_bits(SLR0_Mem_io_R_array_index_8_bits),
    .io_R_array_index_9_ready(SLR0_Mem_io_R_array_index_9_ready),
    .io_R_array_index_9_valid(SLR0_Mem_io_R_array_index_9_valid),
    .io_R_array_index_9_bits(SLR0_Mem_io_R_array_index_9_bits),
    .io_R_array_index_10_ready(SLR0_Mem_io_R_array_index_10_ready),
    .io_R_array_index_10_valid(SLR0_Mem_io_R_array_index_10_valid),
    .io_R_array_index_10_bits(SLR0_Mem_io_R_array_index_10_bits),
    .io_R_array_index_11_ready(SLR0_Mem_io_R_array_index_11_ready),
    .io_R_array_index_11_valid(SLR0_Mem_io_R_array_index_11_valid),
    .io_R_array_index_11_bits(SLR0_Mem_io_R_array_index_11_bits),
    .io_R_array_index_12_ready(SLR0_Mem_io_R_array_index_12_ready),
    .io_R_array_index_12_valid(SLR0_Mem_io_R_array_index_12_valid),
    .io_R_array_index_12_bits(SLR0_Mem_io_R_array_index_12_bits),
    .io_R_array_index_13_ready(SLR0_Mem_io_R_array_index_13_ready),
    .io_R_array_index_13_valid(SLR0_Mem_io_R_array_index_13_valid),
    .io_R_array_index_13_bits(SLR0_Mem_io_R_array_index_13_bits),
    .io_R_array_index_14_ready(SLR0_Mem_io_R_array_index_14_ready),
    .io_R_array_index_14_valid(SLR0_Mem_io_R_array_index_14_valid),
    .io_R_array_index_14_bits(SLR0_Mem_io_R_array_index_14_bits),
    .io_R_array_index_15_ready(SLR0_Mem_io_R_array_index_15_ready),
    .io_R_array_index_15_valid(SLR0_Mem_io_R_array_index_15_valid),
    .io_R_array_index_15_bits(SLR0_Mem_io_R_array_index_15_bits),
    .io_R_array_index_16_ready(SLR0_Mem_io_R_array_index_16_ready),
    .io_R_array_index_16_valid(SLR0_Mem_io_R_array_index_16_valid),
    .io_R_array_index_16_bits(SLR0_Mem_io_R_array_index_16_bits),
    .io_R_array_index_17_ready(SLR0_Mem_io_R_array_index_17_ready),
    .io_R_array_index_17_valid(SLR0_Mem_io_R_array_index_17_valid),
    .io_R_array_index_17_bits(SLR0_Mem_io_R_array_index_17_bits),
    .io_R_array_index_18_ready(SLR0_Mem_io_R_array_index_18_ready),
    .io_R_array_index_18_valid(SLR0_Mem_io_R_array_index_18_valid),
    .io_R_array_index_18_bits(SLR0_Mem_io_R_array_index_18_bits),
    .io_R_array_index_19_ready(SLR0_Mem_io_R_array_index_19_ready),
    .io_R_array_index_19_valid(SLR0_Mem_io_R_array_index_19_valid),
    .io_R_array_index_19_bits(SLR0_Mem_io_R_array_index_19_bits),
    .io_R_array_index_20_ready(SLR0_Mem_io_R_array_index_20_ready),
    .io_R_array_index_20_valid(SLR0_Mem_io_R_array_index_20_valid),
    .io_R_array_index_20_bits(SLR0_Mem_io_R_array_index_20_bits),
    .io_R_array_index_21_ready(SLR0_Mem_io_R_array_index_21_ready),
    .io_R_array_index_21_valid(SLR0_Mem_io_R_array_index_21_valid),
    .io_R_array_index_21_bits(SLR0_Mem_io_R_array_index_21_bits),
    .io_R_array_index_22_ready(SLR0_Mem_io_R_array_index_22_ready),
    .io_R_array_index_22_valid(SLR0_Mem_io_R_array_index_22_valid),
    .io_R_array_index_22_bits(SLR0_Mem_io_R_array_index_22_bits),
    .io_R_array_index_23_ready(SLR0_Mem_io_R_array_index_23_ready),
    .io_R_array_index_23_valid(SLR0_Mem_io_R_array_index_23_valid),
    .io_R_array_index_23_bits(SLR0_Mem_io_R_array_index_23_bits),
    .io_R_array_index_24_ready(SLR0_Mem_io_R_array_index_24_ready),
    .io_R_array_index_24_valid(SLR0_Mem_io_R_array_index_24_valid),
    .io_R_array_index_24_bits(SLR0_Mem_io_R_array_index_24_bits),
    .io_R_array_index_25_ready(SLR0_Mem_io_R_array_index_25_ready),
    .io_R_array_index_25_valid(SLR0_Mem_io_R_array_index_25_valid),
    .io_R_array_index_25_bits(SLR0_Mem_io_R_array_index_25_bits),
    .io_R_array_index_26_ready(SLR0_Mem_io_R_array_index_26_ready),
    .io_R_array_index_26_valid(SLR0_Mem_io_R_array_index_26_valid),
    .io_R_array_index_26_bits(SLR0_Mem_io_R_array_index_26_bits),
    .io_R_array_index_27_ready(SLR0_Mem_io_R_array_index_27_ready),
    .io_R_array_index_27_valid(SLR0_Mem_io_R_array_index_27_valid),
    .io_R_array_index_27_bits(SLR0_Mem_io_R_array_index_27_bits),
    .io_R_array_index_28_ready(SLR0_Mem_io_R_array_index_28_ready),
    .io_R_array_index_28_valid(SLR0_Mem_io_R_array_index_28_valid),
    .io_R_array_index_28_bits(SLR0_Mem_io_R_array_index_28_bits),
    .io_R_array_index_29_ready(SLR0_Mem_io_R_array_index_29_ready),
    .io_R_array_index_29_valid(SLR0_Mem_io_R_array_index_29_valid),
    .io_R_array_index_29_bits(SLR0_Mem_io_R_array_index_29_bits),
    .io_R_array_index_30_ready(SLR0_Mem_io_R_array_index_30_ready),
    .io_R_array_index_30_valid(SLR0_Mem_io_R_array_index_30_valid),
    .io_R_array_index_30_bits(SLR0_Mem_io_R_array_index_30_bits),
    .io_R_array_index_31_ready(SLR0_Mem_io_R_array_index_31_ready),
    .io_R_array_index_31_valid(SLR0_Mem_io_R_array_index_31_valid),
    .io_R_array_index_31_bits(SLR0_Mem_io_R_array_index_31_bits),
    .io_R_array_index_32_ready(SLR0_Mem_io_R_array_index_32_ready),
    .io_R_array_index_32_valid(SLR0_Mem_io_R_array_index_32_valid),
    .io_R_array_index_32_bits(SLR0_Mem_io_R_array_index_32_bits),
    .io_R_array_index_33_ready(SLR0_Mem_io_R_array_index_33_ready),
    .io_R_array_index_33_valid(SLR0_Mem_io_R_array_index_33_valid),
    .io_R_array_index_33_bits(SLR0_Mem_io_R_array_index_33_bits),
    .io_R_array_index_34_ready(SLR0_Mem_io_R_array_index_34_ready),
    .io_R_array_index_34_valid(SLR0_Mem_io_R_array_index_34_valid),
    .io_R_array_index_34_bits(SLR0_Mem_io_R_array_index_34_bits),
    .io_R_array_index_35_ready(SLR0_Mem_io_R_array_index_35_ready),
    .io_R_array_index_35_valid(SLR0_Mem_io_R_array_index_35_valid),
    .io_R_array_index_35_bits(SLR0_Mem_io_R_array_index_35_bits),
    .io_R_array_index_36_ready(SLR0_Mem_io_R_array_index_36_ready),
    .io_R_array_index_36_valid(SLR0_Mem_io_R_array_index_36_valid),
    .io_R_array_index_36_bits(SLR0_Mem_io_R_array_index_36_bits),
    .io_R_array_index_37_ready(SLR0_Mem_io_R_array_index_37_ready),
    .io_R_array_index_37_valid(SLR0_Mem_io_R_array_index_37_valid),
    .io_R_array_index_37_bits(SLR0_Mem_io_R_array_index_37_bits),
    .io_R_array_index_38_ready(SLR0_Mem_io_R_array_index_38_ready),
    .io_R_array_index_38_valid(SLR0_Mem_io_R_array_index_38_valid),
    .io_R_array_index_38_bits(SLR0_Mem_io_R_array_index_38_bits),
    .io_R_array_index_39_ready(SLR0_Mem_io_R_array_index_39_ready),
    .io_R_array_index_39_valid(SLR0_Mem_io_R_array_index_39_valid),
    .io_R_array_index_39_bits(SLR0_Mem_io_R_array_index_39_bits),
    .io_R_array_index_40_ready(SLR0_Mem_io_R_array_index_40_ready),
    .io_R_array_index_40_valid(SLR0_Mem_io_R_array_index_40_valid),
    .io_R_array_index_40_bits(SLR0_Mem_io_R_array_index_40_bits),
    .io_R_array_index_41_ready(SLR0_Mem_io_R_array_index_41_ready),
    .io_R_array_index_41_valid(SLR0_Mem_io_R_array_index_41_valid),
    .io_R_array_index_41_bits(SLR0_Mem_io_R_array_index_41_bits),
    .io_R_array_index_42_ready(SLR0_Mem_io_R_array_index_42_ready),
    .io_R_array_index_42_valid(SLR0_Mem_io_R_array_index_42_valid),
    .io_R_array_index_42_bits(SLR0_Mem_io_R_array_index_42_bits),
    .io_R_array_index_43_ready(SLR0_Mem_io_R_array_index_43_ready),
    .io_R_array_index_43_valid(SLR0_Mem_io_R_array_index_43_valid),
    .io_R_array_index_43_bits(SLR0_Mem_io_R_array_index_43_bits),
    .io_R_array_index_44_ready(SLR0_Mem_io_R_array_index_44_ready),
    .io_R_array_index_44_valid(SLR0_Mem_io_R_array_index_44_valid),
    .io_R_array_index_44_bits(SLR0_Mem_io_R_array_index_44_bits),
    .io_R_array_index_45_ready(SLR0_Mem_io_R_array_index_45_ready),
    .io_R_array_index_45_valid(SLR0_Mem_io_R_array_index_45_valid),
    .io_R_array_index_45_bits(SLR0_Mem_io_R_array_index_45_bits),
    .io_R_array_index_46_ready(SLR0_Mem_io_R_array_index_46_ready),
    .io_R_array_index_46_valid(SLR0_Mem_io_R_array_index_46_valid),
    .io_R_array_index_46_bits(SLR0_Mem_io_R_array_index_46_bits),
    .io_R_array_index_47_ready(SLR0_Mem_io_R_array_index_47_ready),
    .io_R_array_index_47_valid(SLR0_Mem_io_R_array_index_47_valid),
    .io_R_array_index_47_bits(SLR0_Mem_io_R_array_index_47_bits),
    .io_R_array_index_48_ready(SLR0_Mem_io_R_array_index_48_ready),
    .io_R_array_index_48_valid(SLR0_Mem_io_R_array_index_48_valid),
    .io_R_array_index_48_bits(SLR0_Mem_io_R_array_index_48_bits),
    .io_R_array_index_49_ready(SLR0_Mem_io_R_array_index_49_ready),
    .io_R_array_index_49_valid(SLR0_Mem_io_R_array_index_49_valid),
    .io_R_array_index_49_bits(SLR0_Mem_io_R_array_index_49_bits),
    .io_R_array_index_50_ready(SLR0_Mem_io_R_array_index_50_ready),
    .io_R_array_index_50_valid(SLR0_Mem_io_R_array_index_50_valid),
    .io_R_array_index_50_bits(SLR0_Mem_io_R_array_index_50_bits),
    .io_R_array_index_51_ready(SLR0_Mem_io_R_array_index_51_ready),
    .io_R_array_index_51_valid(SLR0_Mem_io_R_array_index_51_valid),
    .io_R_array_index_51_bits(SLR0_Mem_io_R_array_index_51_bits),
    .io_R_array_index_52_ready(SLR0_Mem_io_R_array_index_52_ready),
    .io_R_array_index_52_valid(SLR0_Mem_io_R_array_index_52_valid),
    .io_R_array_index_52_bits(SLR0_Mem_io_R_array_index_52_bits),
    .io_R_array_index_53_ready(SLR0_Mem_io_R_array_index_53_ready),
    .io_R_array_index_53_valid(SLR0_Mem_io_R_array_index_53_valid),
    .io_R_array_index_53_bits(SLR0_Mem_io_R_array_index_53_bits),
    .io_R_array_index_54_ready(SLR0_Mem_io_R_array_index_54_ready),
    .io_R_array_index_54_valid(SLR0_Mem_io_R_array_index_54_valid),
    .io_R_array_index_54_bits(SLR0_Mem_io_R_array_index_54_bits),
    .io_R_array_index_55_ready(SLR0_Mem_io_R_array_index_55_ready),
    .io_R_array_index_55_valid(SLR0_Mem_io_R_array_index_55_valid),
    .io_R_array_index_55_bits(SLR0_Mem_io_R_array_index_55_bits),
    .io_R_array_index_56_ready(SLR0_Mem_io_R_array_index_56_ready),
    .io_R_array_index_56_valid(SLR0_Mem_io_R_array_index_56_valid),
    .io_R_array_index_56_bits(SLR0_Mem_io_R_array_index_56_bits),
    .io_R_array_index_57_ready(SLR0_Mem_io_R_array_index_57_ready),
    .io_R_array_index_57_valid(SLR0_Mem_io_R_array_index_57_valid),
    .io_R_array_index_57_bits(SLR0_Mem_io_R_array_index_57_bits),
    .io_R_array_index_58_ready(SLR0_Mem_io_R_array_index_58_ready),
    .io_R_array_index_58_valid(SLR0_Mem_io_R_array_index_58_valid),
    .io_R_array_index_58_bits(SLR0_Mem_io_R_array_index_58_bits),
    .io_R_array_index_59_ready(SLR0_Mem_io_R_array_index_59_ready),
    .io_R_array_index_59_valid(SLR0_Mem_io_R_array_index_59_valid),
    .io_R_array_index_59_bits(SLR0_Mem_io_R_array_index_59_bits),
    .io_R_array_index_60_ready(SLR0_Mem_io_R_array_index_60_ready),
    .io_R_array_index_60_valid(SLR0_Mem_io_R_array_index_60_valid),
    .io_R_array_index_60_bits(SLR0_Mem_io_R_array_index_60_bits),
    .io_R_array_index_61_ready(SLR0_Mem_io_R_array_index_61_ready),
    .io_R_array_index_61_valid(SLR0_Mem_io_R_array_index_61_valid),
    .io_R_array_index_61_bits(SLR0_Mem_io_R_array_index_61_bits),
    .io_R_array_index_62_ready(SLR0_Mem_io_R_array_index_62_ready),
    .io_R_array_index_62_valid(SLR0_Mem_io_R_array_index_62_valid),
    .io_R_array_index_62_bits(SLR0_Mem_io_R_array_index_62_bits),
    .io_R_array_index_63_ready(SLR0_Mem_io_R_array_index_63_ready),
    .io_R_array_index_63_valid(SLR0_Mem_io_R_array_index_63_valid),
    .io_R_array_index_63_bits(SLR0_Mem_io_R_array_index_63_bits),
    .io_R_array_index_64_ready(SLR0_Mem_io_R_array_index_64_ready),
    .io_R_array_index_64_valid(SLR0_Mem_io_R_array_index_64_valid),
    .io_R_array_index_64_bits(SLR0_Mem_io_R_array_index_64_bits),
    .io_R_array_index_65_ready(SLR0_Mem_io_R_array_index_65_ready),
    .io_R_array_index_65_valid(SLR0_Mem_io_R_array_index_65_valid),
    .io_R_array_index_65_bits(SLR0_Mem_io_R_array_index_65_bits),
    .io_R_array_index_66_ready(SLR0_Mem_io_R_array_index_66_ready),
    .io_R_array_index_66_valid(SLR0_Mem_io_R_array_index_66_valid),
    .io_R_array_index_66_bits(SLR0_Mem_io_R_array_index_66_bits),
    .io_R_array_index_67_ready(SLR0_Mem_io_R_array_index_67_ready),
    .io_R_array_index_67_valid(SLR0_Mem_io_R_array_index_67_valid),
    .io_R_array_index_67_bits(SLR0_Mem_io_R_array_index_67_bits),
    .io_R_array_index_68_ready(SLR0_Mem_io_R_array_index_68_ready),
    .io_R_array_index_68_valid(SLR0_Mem_io_R_array_index_68_valid),
    .io_R_array_index_68_bits(SLR0_Mem_io_R_array_index_68_bits),
    .io_R_array_index_69_ready(SLR0_Mem_io_R_array_index_69_ready),
    .io_R_array_index_69_valid(SLR0_Mem_io_R_array_index_69_valid),
    .io_R_array_index_69_bits(SLR0_Mem_io_R_array_index_69_bits),
    .io_R_array_index_70_ready(SLR0_Mem_io_R_array_index_70_ready),
    .io_R_array_index_70_valid(SLR0_Mem_io_R_array_index_70_valid),
    .io_R_array_index_70_bits(SLR0_Mem_io_R_array_index_70_bits),
    .io_R_array_index_71_ready(SLR0_Mem_io_R_array_index_71_ready),
    .io_R_array_index_71_valid(SLR0_Mem_io_R_array_index_71_valid),
    .io_R_array_index_71_bits(SLR0_Mem_io_R_array_index_71_bits),
    .io_R_array_index_72_ready(SLR0_Mem_io_R_array_index_72_ready),
    .io_R_array_index_72_valid(SLR0_Mem_io_R_array_index_72_valid),
    .io_R_array_index_72_bits(SLR0_Mem_io_R_array_index_72_bits),
    .io_R_array_index_73_ready(SLR0_Mem_io_R_array_index_73_ready),
    .io_R_array_index_73_valid(SLR0_Mem_io_R_array_index_73_valid),
    .io_R_array_index_73_bits(SLR0_Mem_io_R_array_index_73_bits),
    .io_R_array_index_74_ready(SLR0_Mem_io_R_array_index_74_ready),
    .io_R_array_index_74_valid(SLR0_Mem_io_R_array_index_74_valid),
    .io_R_array_index_74_bits(SLR0_Mem_io_R_array_index_74_bits),
    .io_R_array_index_75_ready(SLR0_Mem_io_R_array_index_75_ready),
    .io_R_array_index_75_valid(SLR0_Mem_io_R_array_index_75_valid),
    .io_R_array_index_75_bits(SLR0_Mem_io_R_array_index_75_bits),
    .io_R_array_index_76_ready(SLR0_Mem_io_R_array_index_76_ready),
    .io_R_array_index_76_valid(SLR0_Mem_io_R_array_index_76_valid),
    .io_R_array_index_76_bits(SLR0_Mem_io_R_array_index_76_bits),
    .io_R_array_index_77_ready(SLR0_Mem_io_R_array_index_77_ready),
    .io_R_array_index_77_valid(SLR0_Mem_io_R_array_index_77_valid),
    .io_R_array_index_77_bits(SLR0_Mem_io_R_array_index_77_bits),
    .io_R_array_index_78_ready(SLR0_Mem_io_R_array_index_78_ready),
    .io_R_array_index_78_valid(SLR0_Mem_io_R_array_index_78_valid),
    .io_R_array_index_78_bits(SLR0_Mem_io_R_array_index_78_bits),
    .io_R_array_index_79_ready(SLR0_Mem_io_R_array_index_79_ready),
    .io_R_array_index_79_valid(SLR0_Mem_io_R_array_index_79_valid),
    .io_R_array_index_79_bits(SLR0_Mem_io_R_array_index_79_bits),
    .io_R_array_index_80_ready(SLR0_Mem_io_R_array_index_80_ready),
    .io_R_array_index_80_valid(SLR0_Mem_io_R_array_index_80_valid),
    .io_R_array_index_80_bits(SLR0_Mem_io_R_array_index_80_bits),
    .io_R_array_index_81_ready(SLR0_Mem_io_R_array_index_81_ready),
    .io_R_array_index_81_valid(SLR0_Mem_io_R_array_index_81_valid),
    .io_R_array_index_81_bits(SLR0_Mem_io_R_array_index_81_bits),
    .io_R_array_index_82_ready(SLR0_Mem_io_R_array_index_82_ready),
    .io_R_array_index_82_valid(SLR0_Mem_io_R_array_index_82_valid),
    .io_R_array_index_82_bits(SLR0_Mem_io_R_array_index_82_bits),
    .io_R_array_index_83_ready(SLR0_Mem_io_R_array_index_83_ready),
    .io_R_array_index_83_valid(SLR0_Mem_io_R_array_index_83_valid),
    .io_R_array_index_83_bits(SLR0_Mem_io_R_array_index_83_bits),
    .io_R_array_index_84_ready(SLR0_Mem_io_R_array_index_84_ready),
    .io_R_array_index_84_valid(SLR0_Mem_io_R_array_index_84_valid),
    .io_R_array_index_84_bits(SLR0_Mem_io_R_array_index_84_bits),
    .io_R_array_index_85_ready(SLR0_Mem_io_R_array_index_85_ready),
    .io_R_array_index_85_valid(SLR0_Mem_io_R_array_index_85_valid),
    .io_R_array_index_85_bits(SLR0_Mem_io_R_array_index_85_bits),
    .io_R_array_index_86_ready(SLR0_Mem_io_R_array_index_86_ready),
    .io_R_array_index_86_valid(SLR0_Mem_io_R_array_index_86_valid),
    .io_R_array_index_86_bits(SLR0_Mem_io_R_array_index_86_bits),
    .io_R_array_index_87_ready(SLR0_Mem_io_R_array_index_87_ready),
    .io_R_array_index_87_valid(SLR0_Mem_io_R_array_index_87_valid),
    .io_R_array_index_87_bits(SLR0_Mem_io_R_array_index_87_bits),
    .io_R_array_index_88_ready(SLR0_Mem_io_R_array_index_88_ready),
    .io_R_array_index_88_valid(SLR0_Mem_io_R_array_index_88_valid),
    .io_R_array_index_88_bits(SLR0_Mem_io_R_array_index_88_bits),
    .io_R_array_index_89_ready(SLR0_Mem_io_R_array_index_89_ready),
    .io_R_array_index_89_valid(SLR0_Mem_io_R_array_index_89_valid),
    .io_R_array_index_89_bits(SLR0_Mem_io_R_array_index_89_bits),
    .io_R_array_index_90_ready(SLR0_Mem_io_R_array_index_90_ready),
    .io_R_array_index_90_valid(SLR0_Mem_io_R_array_index_90_valid),
    .io_R_array_index_90_bits(SLR0_Mem_io_R_array_index_90_bits),
    .io_R_array_index_91_ready(SLR0_Mem_io_R_array_index_91_ready),
    .io_R_array_index_91_valid(SLR0_Mem_io_R_array_index_91_valid),
    .io_R_array_index_91_bits(SLR0_Mem_io_R_array_index_91_bits),
    .io_R_array_index_92_ready(SLR0_Mem_io_R_array_index_92_ready),
    .io_R_array_index_92_valid(SLR0_Mem_io_R_array_index_92_valid),
    .io_R_array_index_92_bits(SLR0_Mem_io_R_array_index_92_bits),
    .io_R_array_index_93_ready(SLR0_Mem_io_R_array_index_93_ready),
    .io_R_array_index_93_valid(SLR0_Mem_io_R_array_index_93_valid),
    .io_R_array_index_93_bits(SLR0_Mem_io_R_array_index_93_bits),
    .io_R_array_index_94_ready(SLR0_Mem_io_R_array_index_94_ready),
    .io_R_array_index_94_valid(SLR0_Mem_io_R_array_index_94_valid),
    .io_R_array_index_94_bits(SLR0_Mem_io_R_array_index_94_bits),
    .io_R_array_index_95_ready(SLR0_Mem_io_R_array_index_95_ready),
    .io_R_array_index_95_valid(SLR0_Mem_io_R_array_index_95_valid),
    .io_R_array_index_95_bits(SLR0_Mem_io_R_array_index_95_bits),
    .io_R_array_index_96_ready(SLR0_Mem_io_R_array_index_96_ready),
    .io_R_array_index_96_valid(SLR0_Mem_io_R_array_index_96_valid),
    .io_R_array_index_96_bits(SLR0_Mem_io_R_array_index_96_bits),
    .io_R_array_index_97_ready(SLR0_Mem_io_R_array_index_97_ready),
    .io_R_array_index_97_valid(SLR0_Mem_io_R_array_index_97_valid),
    .io_R_array_index_97_bits(SLR0_Mem_io_R_array_index_97_bits),
    .io_R_array_index_98_ready(SLR0_Mem_io_R_array_index_98_ready),
    .io_R_array_index_98_valid(SLR0_Mem_io_R_array_index_98_valid),
    .io_R_array_index_98_bits(SLR0_Mem_io_R_array_index_98_bits),
    .io_R_array_index_99_ready(SLR0_Mem_io_R_array_index_99_ready),
    .io_R_array_index_99_valid(SLR0_Mem_io_R_array_index_99_valid),
    .io_R_array_index_99_bits(SLR0_Mem_io_R_array_index_99_bits),
    .io_R_array_index_100_ready(SLR0_Mem_io_R_array_index_100_ready),
    .io_R_array_index_100_valid(SLR0_Mem_io_R_array_index_100_valid),
    .io_R_array_index_100_bits(SLR0_Mem_io_R_array_index_100_bits),
    .io_R_array_index_101_ready(SLR0_Mem_io_R_array_index_101_ready),
    .io_R_array_index_101_valid(SLR0_Mem_io_R_array_index_101_valid),
    .io_R_array_index_101_bits(SLR0_Mem_io_R_array_index_101_bits),
    .io_R_array_index_102_ready(SLR0_Mem_io_R_array_index_102_ready),
    .io_R_array_index_102_valid(SLR0_Mem_io_R_array_index_102_valid),
    .io_R_array_index_102_bits(SLR0_Mem_io_R_array_index_102_bits),
    .io_R_array_index_103_ready(SLR0_Mem_io_R_array_index_103_ready),
    .io_R_array_index_103_valid(SLR0_Mem_io_R_array_index_103_valid),
    .io_R_array_index_103_bits(SLR0_Mem_io_R_array_index_103_bits),
    .io_R_array_index_104_ready(SLR0_Mem_io_R_array_index_104_ready),
    .io_R_array_index_104_valid(SLR0_Mem_io_R_array_index_104_valid),
    .io_R_array_index_104_bits(SLR0_Mem_io_R_array_index_104_bits),
    .io_R_array_index_105_ready(SLR0_Mem_io_R_array_index_105_ready),
    .io_R_array_index_105_valid(SLR0_Mem_io_R_array_index_105_valid),
    .io_R_array_index_105_bits(SLR0_Mem_io_R_array_index_105_bits),
    .io_R_array_index_106_ready(SLR0_Mem_io_R_array_index_106_ready),
    .io_R_array_index_106_valid(SLR0_Mem_io_R_array_index_106_valid),
    .io_R_array_index_106_bits(SLR0_Mem_io_R_array_index_106_bits),
    .io_R_array_index_107_ready(SLR0_Mem_io_R_array_index_107_ready),
    .io_R_array_index_107_valid(SLR0_Mem_io_R_array_index_107_valid),
    .io_R_array_index_107_bits(SLR0_Mem_io_R_array_index_107_bits),
    .io_R_array_index_108_ready(SLR0_Mem_io_R_array_index_108_ready),
    .io_R_array_index_108_valid(SLR0_Mem_io_R_array_index_108_valid),
    .io_R_array_index_108_bits(SLR0_Mem_io_R_array_index_108_bits),
    .io_R_array_index_109_ready(SLR0_Mem_io_R_array_index_109_ready),
    .io_R_array_index_109_valid(SLR0_Mem_io_R_array_index_109_valid),
    .io_R_array_index_109_bits(SLR0_Mem_io_R_array_index_109_bits),
    .io_R_array_index_110_ready(SLR0_Mem_io_R_array_index_110_ready),
    .io_R_array_index_110_valid(SLR0_Mem_io_R_array_index_110_valid),
    .io_R_array_index_110_bits(SLR0_Mem_io_R_array_index_110_bits),
    .io_R_array_index_111_ready(SLR0_Mem_io_R_array_index_111_ready),
    .io_R_array_index_111_valid(SLR0_Mem_io_R_array_index_111_valid),
    .io_R_array_index_111_bits(SLR0_Mem_io_R_array_index_111_bits),
    .io_R_array_index_112_ready(SLR0_Mem_io_R_array_index_112_ready),
    .io_R_array_index_112_valid(SLR0_Mem_io_R_array_index_112_valid),
    .io_R_array_index_112_bits(SLR0_Mem_io_R_array_index_112_bits),
    .io_R_array_index_113_ready(SLR0_Mem_io_R_array_index_113_ready),
    .io_R_array_index_113_valid(SLR0_Mem_io_R_array_index_113_valid),
    .io_R_array_index_113_bits(SLR0_Mem_io_R_array_index_113_bits),
    .io_R_array_index_114_ready(SLR0_Mem_io_R_array_index_114_ready),
    .io_R_array_index_114_valid(SLR0_Mem_io_R_array_index_114_valid),
    .io_R_array_index_114_bits(SLR0_Mem_io_R_array_index_114_bits),
    .io_R_array_index_115_ready(SLR0_Mem_io_R_array_index_115_ready),
    .io_R_array_index_115_valid(SLR0_Mem_io_R_array_index_115_valid),
    .io_R_array_index_115_bits(SLR0_Mem_io_R_array_index_115_bits),
    .io_R_array_index_116_ready(SLR0_Mem_io_R_array_index_116_ready),
    .io_R_array_index_116_valid(SLR0_Mem_io_R_array_index_116_valid),
    .io_R_array_index_116_bits(SLR0_Mem_io_R_array_index_116_bits),
    .io_R_array_index_117_ready(SLR0_Mem_io_R_array_index_117_ready),
    .io_R_array_index_117_valid(SLR0_Mem_io_R_array_index_117_valid),
    .io_R_array_index_117_bits(SLR0_Mem_io_R_array_index_117_bits),
    .io_R_array_index_118_ready(SLR0_Mem_io_R_array_index_118_ready),
    .io_R_array_index_118_valid(SLR0_Mem_io_R_array_index_118_valid),
    .io_R_array_index_118_bits(SLR0_Mem_io_R_array_index_118_bits),
    .io_R_array_index_119_ready(SLR0_Mem_io_R_array_index_119_ready),
    .io_R_array_index_119_valid(SLR0_Mem_io_R_array_index_119_valid),
    .io_R_array_index_119_bits(SLR0_Mem_io_R_array_index_119_bits),
    .io_R_array_index_120_ready(SLR0_Mem_io_R_array_index_120_ready),
    .io_R_array_index_120_valid(SLR0_Mem_io_R_array_index_120_valid),
    .io_R_array_index_120_bits(SLR0_Mem_io_R_array_index_120_bits),
    .io_R_array_index_121_ready(SLR0_Mem_io_R_array_index_121_ready),
    .io_R_array_index_121_valid(SLR0_Mem_io_R_array_index_121_valid),
    .io_R_array_index_121_bits(SLR0_Mem_io_R_array_index_121_bits),
    .io_R_array_index_122_ready(SLR0_Mem_io_R_array_index_122_ready),
    .io_R_array_index_122_valid(SLR0_Mem_io_R_array_index_122_valid),
    .io_R_array_index_122_bits(SLR0_Mem_io_R_array_index_122_bits),
    .io_R_array_index_123_ready(SLR0_Mem_io_R_array_index_123_ready),
    .io_R_array_index_123_valid(SLR0_Mem_io_R_array_index_123_valid),
    .io_R_array_index_123_bits(SLR0_Mem_io_R_array_index_123_bits),
    .io_R_array_index_124_ready(SLR0_Mem_io_R_array_index_124_ready),
    .io_R_array_index_124_valid(SLR0_Mem_io_R_array_index_124_valid),
    .io_R_array_index_124_bits(SLR0_Mem_io_R_array_index_124_bits),
    .io_R_array_index_125_ready(SLR0_Mem_io_R_array_index_125_ready),
    .io_R_array_index_125_valid(SLR0_Mem_io_R_array_index_125_valid),
    .io_R_array_index_125_bits(SLR0_Mem_io_R_array_index_125_bits),
    .io_R_array_index_126_ready(SLR0_Mem_io_R_array_index_126_ready),
    .io_R_array_index_126_valid(SLR0_Mem_io_R_array_index_126_valid),
    .io_R_array_index_126_bits(SLR0_Mem_io_R_array_index_126_bits),
    .io_R_array_index_127_ready(SLR0_Mem_io_R_array_index_127_ready),
    .io_R_array_index_127_valid(SLR0_Mem_io_R_array_index_127_valid),
    .io_R_array_index_127_bits(SLR0_Mem_io_R_array_index_127_bits),
    .io_p1_end_0(SLR0_Mem_io_p1_end_0),
    .io_p1_end_1(SLR0_Mem_io_p1_end_1),
    .io_p1_end_2(SLR0_Mem_io_p1_end_2),
    .io_p1_end_3(SLR0_Mem_io_p1_end_3),
    .io_p1_end_4(SLR0_Mem_io_p1_end_4),
    .io_p1_end_5(SLR0_Mem_io_p1_end_5),
    .io_p1_end_6(SLR0_Mem_io_p1_end_6),
    .io_p1_end_7(SLR0_Mem_io_p1_end_7),
    .io_p1_end_8(SLR0_Mem_io_p1_end_8),
    .io_p1_end_9(SLR0_Mem_io_p1_end_9),
    .io_p1_end_10(SLR0_Mem_io_p1_end_10),
    .io_p1_end_11(SLR0_Mem_io_p1_end_11),
    .io_p1_end_12(SLR0_Mem_io_p1_end_12),
    .io_p1_end_13(SLR0_Mem_io_p1_end_13),
    .io_p1_end_14(SLR0_Mem_io_p1_end_14),
    .io_p1_end_15(SLR0_Mem_io_p1_end_15),
    .io_p1_end_16(SLR0_Mem_io_p1_end_16),
    .io_p1_end_17(SLR0_Mem_io_p1_end_17),
    .io_p1_end_18(SLR0_Mem_io_p1_end_18),
    .io_p1_end_19(SLR0_Mem_io_p1_end_19),
    .io_p1_end_20(SLR0_Mem_io_p1_end_20),
    .io_p1_end_21(SLR0_Mem_io_p1_end_21),
    .io_p1_end_22(SLR0_Mem_io_p1_end_22),
    .io_p1_end_23(SLR0_Mem_io_p1_end_23),
    .io_p1_end_24(SLR0_Mem_io_p1_end_24),
    .io_p1_end_25(SLR0_Mem_io_p1_end_25),
    .io_p1_end_26(SLR0_Mem_io_p1_end_26),
    .io_p1_end_27(SLR0_Mem_io_p1_end_27),
    .io_p1_end_28(SLR0_Mem_io_p1_end_28),
    .io_p1_end_29(SLR0_Mem_io_p1_end_29),
    .io_p1_end_30(SLR0_Mem_io_p1_end_30),
    .io_p1_end_31(SLR0_Mem_io_p1_end_31),
    .io_uram_out_a_0(SLR0_Mem_io_uram_out_a_0),
    .io_uram_out_a_1(SLR0_Mem_io_uram_out_a_1),
    .io_uram_out_a_2(SLR0_Mem_io_uram_out_a_2),
    .io_uram_out_a_3(SLR0_Mem_io_uram_out_a_3),
    .io_uram_out_a_4(SLR0_Mem_io_uram_out_a_4),
    .io_uram_out_a_5(SLR0_Mem_io_uram_out_a_5),
    .io_uram_out_a_6(SLR0_Mem_io_uram_out_a_6),
    .io_uram_out_a_7(SLR0_Mem_io_uram_out_a_7),
    .io_uram_out_a_8(SLR0_Mem_io_uram_out_a_8),
    .io_uram_out_a_9(SLR0_Mem_io_uram_out_a_9),
    .io_uram_out_a_10(SLR0_Mem_io_uram_out_a_10),
    .io_uram_out_a_11(SLR0_Mem_io_uram_out_a_11),
    .io_uram_out_a_12(SLR0_Mem_io_uram_out_a_12),
    .io_uram_out_a_13(SLR0_Mem_io_uram_out_a_13),
    .io_uram_out_a_14(SLR0_Mem_io_uram_out_a_14),
    .io_uram_out_a_15(SLR0_Mem_io_uram_out_a_15),
    .io_uram_out_a_16(SLR0_Mem_io_uram_out_a_16),
    .io_uram_out_a_17(SLR0_Mem_io_uram_out_a_17),
    .io_uram_out_a_18(SLR0_Mem_io_uram_out_a_18),
    .io_uram_out_a_19(SLR0_Mem_io_uram_out_a_19),
    .io_uram_out_a_20(SLR0_Mem_io_uram_out_a_20),
    .io_uram_out_a_21(SLR0_Mem_io_uram_out_a_21),
    .io_uram_out_a_22(SLR0_Mem_io_uram_out_a_22),
    .io_uram_out_a_23(SLR0_Mem_io_uram_out_a_23),
    .io_uram_out_a_24(SLR0_Mem_io_uram_out_a_24),
    .io_uram_out_a_25(SLR0_Mem_io_uram_out_a_25),
    .io_uram_out_a_26(SLR0_Mem_io_uram_out_a_26),
    .io_uram_out_a_27(SLR0_Mem_io_uram_out_a_27),
    .io_uram_out_a_28(SLR0_Mem_io_uram_out_a_28),
    .io_uram_out_a_29(SLR0_Mem_io_uram_out_a_29),
    .io_uram_out_a_30(SLR0_Mem_io_uram_out_a_30),
    .io_uram_out_a_31(SLR0_Mem_io_uram_out_a_31),
    .io_uram_out_a_32(SLR0_Mem_io_uram_out_a_32),
    .io_uram_out_a_33(SLR0_Mem_io_uram_out_a_33),
    .io_uram_out_a_34(SLR0_Mem_io_uram_out_a_34),
    .io_uram_out_a_35(SLR0_Mem_io_uram_out_a_35),
    .io_uram_out_a_36(SLR0_Mem_io_uram_out_a_36),
    .io_uram_out_a_37(SLR0_Mem_io_uram_out_a_37),
    .io_uram_out_a_38(SLR0_Mem_io_uram_out_a_38),
    .io_uram_out_a_39(SLR0_Mem_io_uram_out_a_39),
    .io_uram_out_a_40(SLR0_Mem_io_uram_out_a_40),
    .io_uram_out_a_41(SLR0_Mem_io_uram_out_a_41),
    .io_uram_out_a_42(SLR0_Mem_io_uram_out_a_42),
    .io_uram_out_a_43(SLR0_Mem_io_uram_out_a_43),
    .io_uram_out_a_44(SLR0_Mem_io_uram_out_a_44),
    .io_uram_out_a_45(SLR0_Mem_io_uram_out_a_45),
    .io_uram_out_a_46(SLR0_Mem_io_uram_out_a_46),
    .io_uram_out_a_47(SLR0_Mem_io_uram_out_a_47),
    .io_uram_out_a_48(SLR0_Mem_io_uram_out_a_48),
    .io_uram_out_a_49(SLR0_Mem_io_uram_out_a_49),
    .io_uram_out_a_50(SLR0_Mem_io_uram_out_a_50),
    .io_uram_out_a_51(SLR0_Mem_io_uram_out_a_51),
    .io_uram_out_a_52(SLR0_Mem_io_uram_out_a_52),
    .io_uram_out_a_53(SLR0_Mem_io_uram_out_a_53),
    .io_uram_out_a_54(SLR0_Mem_io_uram_out_a_54),
    .io_uram_out_a_55(SLR0_Mem_io_uram_out_a_55),
    .io_uram_out_a_56(SLR0_Mem_io_uram_out_a_56),
    .io_uram_out_a_57(SLR0_Mem_io_uram_out_a_57),
    .io_uram_out_a_58(SLR0_Mem_io_uram_out_a_58),
    .io_uram_out_a_59(SLR0_Mem_io_uram_out_a_59),
    .io_uram_out_a_60(SLR0_Mem_io_uram_out_a_60),
    .io_uram_out_a_61(SLR0_Mem_io_uram_out_a_61),
    .io_uram_out_a_62(SLR0_Mem_io_uram_out_a_62),
    .io_uram_out_a_63(SLR0_Mem_io_uram_out_a_63),
    .io_uram_out_a_64(SLR0_Mem_io_uram_out_a_64),
    .io_uram_out_a_65(SLR0_Mem_io_uram_out_a_65),
    .io_uram_out_a_66(SLR0_Mem_io_uram_out_a_66),
    .io_uram_out_a_67(SLR0_Mem_io_uram_out_a_67),
    .io_uram_out_a_68(SLR0_Mem_io_uram_out_a_68),
    .io_uram_out_a_69(SLR0_Mem_io_uram_out_a_69),
    .io_uram_out_a_70(SLR0_Mem_io_uram_out_a_70),
    .io_uram_out_a_71(SLR0_Mem_io_uram_out_a_71),
    .io_uram_out_a_72(SLR0_Mem_io_uram_out_a_72),
    .io_uram_out_a_73(SLR0_Mem_io_uram_out_a_73),
    .io_uram_out_a_74(SLR0_Mem_io_uram_out_a_74),
    .io_uram_out_a_75(SLR0_Mem_io_uram_out_a_75),
    .io_uram_out_a_76(SLR0_Mem_io_uram_out_a_76),
    .io_uram_out_a_77(SLR0_Mem_io_uram_out_a_77),
    .io_uram_out_a_78(SLR0_Mem_io_uram_out_a_78),
    .io_uram_out_a_79(SLR0_Mem_io_uram_out_a_79),
    .io_uram_out_a_80(SLR0_Mem_io_uram_out_a_80),
    .io_uram_out_a_81(SLR0_Mem_io_uram_out_a_81),
    .io_uram_out_a_82(SLR0_Mem_io_uram_out_a_82),
    .io_uram_out_a_83(SLR0_Mem_io_uram_out_a_83),
    .io_uram_out_a_84(SLR0_Mem_io_uram_out_a_84),
    .io_uram_out_a_85(SLR0_Mem_io_uram_out_a_85),
    .io_uram_out_a_86(SLR0_Mem_io_uram_out_a_86),
    .io_uram_out_a_87(SLR0_Mem_io_uram_out_a_87),
    .io_uram_out_a_88(SLR0_Mem_io_uram_out_a_88),
    .io_uram_out_a_89(SLR0_Mem_io_uram_out_a_89),
    .io_uram_out_a_90(SLR0_Mem_io_uram_out_a_90),
    .io_uram_out_a_91(SLR0_Mem_io_uram_out_a_91),
    .io_uram_out_a_92(SLR0_Mem_io_uram_out_a_92),
    .io_uram_out_a_93(SLR0_Mem_io_uram_out_a_93),
    .io_uram_out_a_94(SLR0_Mem_io_uram_out_a_94),
    .io_uram_out_a_95(SLR0_Mem_io_uram_out_a_95),
    .io_uram_out_a_96(SLR0_Mem_io_uram_out_a_96),
    .io_uram_out_a_97(SLR0_Mem_io_uram_out_a_97),
    .io_uram_out_a_98(SLR0_Mem_io_uram_out_a_98),
    .io_uram_out_a_99(SLR0_Mem_io_uram_out_a_99),
    .io_uram_out_a_100(SLR0_Mem_io_uram_out_a_100),
    .io_uram_out_a_101(SLR0_Mem_io_uram_out_a_101),
    .io_uram_out_a_102(SLR0_Mem_io_uram_out_a_102),
    .io_uram_out_a_103(SLR0_Mem_io_uram_out_a_103),
    .io_uram_out_a_104(SLR0_Mem_io_uram_out_a_104),
    .io_uram_out_a_105(SLR0_Mem_io_uram_out_a_105),
    .io_uram_out_a_106(SLR0_Mem_io_uram_out_a_106),
    .io_uram_out_a_107(SLR0_Mem_io_uram_out_a_107),
    .io_uram_out_a_108(SLR0_Mem_io_uram_out_a_108),
    .io_uram_out_a_109(SLR0_Mem_io_uram_out_a_109),
    .io_uram_out_a_110(SLR0_Mem_io_uram_out_a_110),
    .io_uram_out_a_111(SLR0_Mem_io_uram_out_a_111),
    .io_uram_out_a_112(SLR0_Mem_io_uram_out_a_112),
    .io_uram_out_a_113(SLR0_Mem_io_uram_out_a_113),
    .io_uram_out_a_114(SLR0_Mem_io_uram_out_a_114),
    .io_uram_out_a_115(SLR0_Mem_io_uram_out_a_115),
    .io_uram_out_a_116(SLR0_Mem_io_uram_out_a_116),
    .io_uram_out_a_117(SLR0_Mem_io_uram_out_a_117),
    .io_uram_out_a_118(SLR0_Mem_io_uram_out_a_118),
    .io_uram_out_a_119(SLR0_Mem_io_uram_out_a_119),
    .io_uram_out_a_120(SLR0_Mem_io_uram_out_a_120),
    .io_uram_out_a_121(SLR0_Mem_io_uram_out_a_121),
    .io_uram_out_a_122(SLR0_Mem_io_uram_out_a_122),
    .io_uram_out_a_123(SLR0_Mem_io_uram_out_a_123),
    .io_uram_out_a_124(SLR0_Mem_io_uram_out_a_124),
    .io_uram_out_a_125(SLR0_Mem_io_uram_out_a_125),
    .io_uram_out_a_126(SLR0_Mem_io_uram_out_a_126),
    .io_uram_out_a_127(SLR0_Mem_io_uram_out_a_127),
    .io_neighbour_cnt_0(SLR0_Mem_io_neighbour_cnt_0),
    .io_neighbour_cnt_1(SLR0_Mem_io_neighbour_cnt_1),
    .io_neighbour_cnt_2(SLR0_Mem_io_neighbour_cnt_2),
    .io_neighbour_cnt_3(SLR0_Mem_io_neighbour_cnt_3),
    .io_neighbour_cnt_4(SLR0_Mem_io_neighbour_cnt_4),
    .io_neighbour_cnt_5(SLR0_Mem_io_neighbour_cnt_5),
    .io_neighbour_cnt_6(SLR0_Mem_io_neighbour_cnt_6),
    .io_neighbour_cnt_7(SLR0_Mem_io_neighbour_cnt_7),
    .io_neighbour_cnt_8(SLR0_Mem_io_neighbour_cnt_8),
    .io_neighbour_cnt_9(SLR0_Mem_io_neighbour_cnt_9),
    .io_neighbour_cnt_10(SLR0_Mem_io_neighbour_cnt_10),
    .io_neighbour_cnt_11(SLR0_Mem_io_neighbour_cnt_11),
    .io_neighbour_cnt_12(SLR0_Mem_io_neighbour_cnt_12),
    .io_neighbour_cnt_13(SLR0_Mem_io_neighbour_cnt_13),
    .io_neighbour_cnt_14(SLR0_Mem_io_neighbour_cnt_14),
    .io_neighbour_cnt_15(SLR0_Mem_io_neighbour_cnt_15),
    .io_neighbour_cnt_16(SLR0_Mem_io_neighbour_cnt_16),
    .io_neighbour_cnt_17(SLR0_Mem_io_neighbour_cnt_17),
    .io_neighbour_cnt_18(SLR0_Mem_io_neighbour_cnt_18),
    .io_neighbour_cnt_19(SLR0_Mem_io_neighbour_cnt_19),
    .io_neighbour_cnt_20(SLR0_Mem_io_neighbour_cnt_20),
    .io_neighbour_cnt_21(SLR0_Mem_io_neighbour_cnt_21),
    .io_neighbour_cnt_22(SLR0_Mem_io_neighbour_cnt_22),
    .io_neighbour_cnt_23(SLR0_Mem_io_neighbour_cnt_23),
    .io_neighbour_cnt_24(SLR0_Mem_io_neighbour_cnt_24),
    .io_neighbour_cnt_25(SLR0_Mem_io_neighbour_cnt_25),
    .io_neighbour_cnt_26(SLR0_Mem_io_neighbour_cnt_26),
    .io_neighbour_cnt_27(SLR0_Mem_io_neighbour_cnt_27),
    .io_neighbour_cnt_28(SLR0_Mem_io_neighbour_cnt_28),
    .io_neighbour_cnt_29(SLR0_Mem_io_neighbour_cnt_29),
    .io_neighbour_cnt_30(SLR0_Mem_io_neighbour_cnt_30),
    .io_neighbour_cnt_31(SLR0_Mem_io_neighbour_cnt_31),
    .io_mem_end_0(SLR0_Mem_io_mem_end_0),
    .io_mem_end_1(SLR0_Mem_io_mem_end_1),
    .io_mem_end_2(SLR0_Mem_io_mem_end_2),
    .io_mem_end_3(SLR0_Mem_io_mem_end_3),
    .io_mem_end_4(SLR0_Mem_io_mem_end_4),
    .io_mem_end_5(SLR0_Mem_io_mem_end_5),
    .io_mem_end_6(SLR0_Mem_io_mem_end_6),
    .io_mem_end_7(SLR0_Mem_io_mem_end_7),
    .io_mem_end_8(SLR0_Mem_io_mem_end_8),
    .io_mem_end_9(SLR0_Mem_io_mem_end_9),
    .io_mem_end_10(SLR0_Mem_io_mem_end_10),
    .io_mem_end_11(SLR0_Mem_io_mem_end_11),
    .io_mem_end_12(SLR0_Mem_io_mem_end_12),
    .io_mem_end_13(SLR0_Mem_io_mem_end_13),
    .io_mem_end_14(SLR0_Mem_io_mem_end_14),
    .io_mem_end_15(SLR0_Mem_io_mem_end_15),
    .io_mem_end_16(SLR0_Mem_io_mem_end_16),
    .io_mem_end_17(SLR0_Mem_io_mem_end_17),
    .io_mem_end_18(SLR0_Mem_io_mem_end_18),
    .io_mem_end_19(SLR0_Mem_io_mem_end_19),
    .io_mem_end_20(SLR0_Mem_io_mem_end_20),
    .io_mem_end_21(SLR0_Mem_io_mem_end_21),
    .io_mem_end_22(SLR0_Mem_io_mem_end_22),
    .io_mem_end_23(SLR0_Mem_io_mem_end_23),
    .io_mem_end_24(SLR0_Mem_io_mem_end_24),
    .io_mem_end_25(SLR0_Mem_io_mem_end_25),
    .io_mem_end_26(SLR0_Mem_io_mem_end_26),
    .io_mem_end_27(SLR0_Mem_io_mem_end_27),
    .io_mem_end_28(SLR0_Mem_io_mem_end_28),
    .io_mem_end_29(SLR0_Mem_io_mem_end_29),
    .io_mem_end_30(SLR0_Mem_io_mem_end_30),
    .io_mem_end_31(SLR0_Mem_io_mem_end_31),
    .io_neighbours_0_ready(SLR0_Mem_io_neighbours_0_ready),
    .io_neighbours_0_valid(SLR0_Mem_io_neighbours_0_valid),
    .io_neighbours_0_bits(SLR0_Mem_io_neighbours_0_bits),
    .io_neighbours_1_ready(SLR0_Mem_io_neighbours_1_ready),
    .io_neighbours_1_valid(SLR0_Mem_io_neighbours_1_valid),
    .io_neighbours_1_bits(SLR0_Mem_io_neighbours_1_bits),
    .io_neighbours_2_ready(SLR0_Mem_io_neighbours_2_ready),
    .io_neighbours_2_valid(SLR0_Mem_io_neighbours_2_valid),
    .io_neighbours_2_bits(SLR0_Mem_io_neighbours_2_bits),
    .io_neighbours_3_ready(SLR0_Mem_io_neighbours_3_ready),
    .io_neighbours_3_valid(SLR0_Mem_io_neighbours_3_valid),
    .io_neighbours_3_bits(SLR0_Mem_io_neighbours_3_bits),
    .io_neighbours_4_ready(SLR0_Mem_io_neighbours_4_ready),
    .io_neighbours_4_valid(SLR0_Mem_io_neighbours_4_valid),
    .io_neighbours_4_bits(SLR0_Mem_io_neighbours_4_bits),
    .io_neighbours_5_ready(SLR0_Mem_io_neighbours_5_ready),
    .io_neighbours_5_valid(SLR0_Mem_io_neighbours_5_valid),
    .io_neighbours_5_bits(SLR0_Mem_io_neighbours_5_bits),
    .io_neighbours_6_ready(SLR0_Mem_io_neighbours_6_ready),
    .io_neighbours_6_valid(SLR0_Mem_io_neighbours_6_valid),
    .io_neighbours_6_bits(SLR0_Mem_io_neighbours_6_bits),
    .io_neighbours_7_ready(SLR0_Mem_io_neighbours_7_ready),
    .io_neighbours_7_valid(SLR0_Mem_io_neighbours_7_valid),
    .io_neighbours_7_bits(SLR0_Mem_io_neighbours_7_bits),
    .io_neighbours_8_ready(SLR0_Mem_io_neighbours_8_ready),
    .io_neighbours_8_valid(SLR0_Mem_io_neighbours_8_valid),
    .io_neighbours_8_bits(SLR0_Mem_io_neighbours_8_bits),
    .io_neighbours_9_ready(SLR0_Mem_io_neighbours_9_ready),
    .io_neighbours_9_valid(SLR0_Mem_io_neighbours_9_valid),
    .io_neighbours_9_bits(SLR0_Mem_io_neighbours_9_bits),
    .io_neighbours_10_ready(SLR0_Mem_io_neighbours_10_ready),
    .io_neighbours_10_valid(SLR0_Mem_io_neighbours_10_valid),
    .io_neighbours_10_bits(SLR0_Mem_io_neighbours_10_bits),
    .io_neighbours_11_ready(SLR0_Mem_io_neighbours_11_ready),
    .io_neighbours_11_valid(SLR0_Mem_io_neighbours_11_valid),
    .io_neighbours_11_bits(SLR0_Mem_io_neighbours_11_bits),
    .io_neighbours_12_ready(SLR0_Mem_io_neighbours_12_ready),
    .io_neighbours_12_valid(SLR0_Mem_io_neighbours_12_valid),
    .io_neighbours_12_bits(SLR0_Mem_io_neighbours_12_bits),
    .io_neighbours_13_ready(SLR0_Mem_io_neighbours_13_ready),
    .io_neighbours_13_valid(SLR0_Mem_io_neighbours_13_valid),
    .io_neighbours_13_bits(SLR0_Mem_io_neighbours_13_bits),
    .io_neighbours_14_ready(SLR0_Mem_io_neighbours_14_ready),
    .io_neighbours_14_valid(SLR0_Mem_io_neighbours_14_valid),
    .io_neighbours_14_bits(SLR0_Mem_io_neighbours_14_bits),
    .io_neighbours_15_ready(SLR0_Mem_io_neighbours_15_ready),
    .io_neighbours_15_valid(SLR0_Mem_io_neighbours_15_valid),
    .io_neighbours_15_bits(SLR0_Mem_io_neighbours_15_bits),
    .io_neighbours_16_ready(SLR0_Mem_io_neighbours_16_ready),
    .io_neighbours_16_valid(SLR0_Mem_io_neighbours_16_valid),
    .io_neighbours_16_bits(SLR0_Mem_io_neighbours_16_bits),
    .io_neighbours_17_ready(SLR0_Mem_io_neighbours_17_ready),
    .io_neighbours_17_valid(SLR0_Mem_io_neighbours_17_valid),
    .io_neighbours_17_bits(SLR0_Mem_io_neighbours_17_bits),
    .io_neighbours_18_ready(SLR0_Mem_io_neighbours_18_ready),
    .io_neighbours_18_valid(SLR0_Mem_io_neighbours_18_valid),
    .io_neighbours_18_bits(SLR0_Mem_io_neighbours_18_bits),
    .io_neighbours_19_ready(SLR0_Mem_io_neighbours_19_ready),
    .io_neighbours_19_valid(SLR0_Mem_io_neighbours_19_valid),
    .io_neighbours_19_bits(SLR0_Mem_io_neighbours_19_bits),
    .io_neighbours_20_ready(SLR0_Mem_io_neighbours_20_ready),
    .io_neighbours_20_valid(SLR0_Mem_io_neighbours_20_valid),
    .io_neighbours_20_bits(SLR0_Mem_io_neighbours_20_bits),
    .io_neighbours_21_ready(SLR0_Mem_io_neighbours_21_ready),
    .io_neighbours_21_valid(SLR0_Mem_io_neighbours_21_valid),
    .io_neighbours_21_bits(SLR0_Mem_io_neighbours_21_bits),
    .io_neighbours_22_ready(SLR0_Mem_io_neighbours_22_ready),
    .io_neighbours_22_valid(SLR0_Mem_io_neighbours_22_valid),
    .io_neighbours_22_bits(SLR0_Mem_io_neighbours_22_bits),
    .io_neighbours_23_ready(SLR0_Mem_io_neighbours_23_ready),
    .io_neighbours_23_valid(SLR0_Mem_io_neighbours_23_valid),
    .io_neighbours_23_bits(SLR0_Mem_io_neighbours_23_bits),
    .io_neighbours_24_ready(SLR0_Mem_io_neighbours_24_ready),
    .io_neighbours_24_valid(SLR0_Mem_io_neighbours_24_valid),
    .io_neighbours_24_bits(SLR0_Mem_io_neighbours_24_bits),
    .io_neighbours_25_ready(SLR0_Mem_io_neighbours_25_ready),
    .io_neighbours_25_valid(SLR0_Mem_io_neighbours_25_valid),
    .io_neighbours_25_bits(SLR0_Mem_io_neighbours_25_bits),
    .io_neighbours_26_ready(SLR0_Mem_io_neighbours_26_ready),
    .io_neighbours_26_valid(SLR0_Mem_io_neighbours_26_valid),
    .io_neighbours_26_bits(SLR0_Mem_io_neighbours_26_bits),
    .io_neighbours_27_ready(SLR0_Mem_io_neighbours_27_ready),
    .io_neighbours_27_valid(SLR0_Mem_io_neighbours_27_valid),
    .io_neighbours_27_bits(SLR0_Mem_io_neighbours_27_bits),
    .io_neighbours_28_ready(SLR0_Mem_io_neighbours_28_ready),
    .io_neighbours_28_valid(SLR0_Mem_io_neighbours_28_valid),
    .io_neighbours_28_bits(SLR0_Mem_io_neighbours_28_bits),
    .io_neighbours_29_ready(SLR0_Mem_io_neighbours_29_ready),
    .io_neighbours_29_valid(SLR0_Mem_io_neighbours_29_valid),
    .io_neighbours_29_bits(SLR0_Mem_io_neighbours_29_bits),
    .io_neighbours_30_ready(SLR0_Mem_io_neighbours_30_ready),
    .io_neighbours_30_valid(SLR0_Mem_io_neighbours_30_valid),
    .io_neighbours_30_bits(SLR0_Mem_io_neighbours_30_bits),
    .io_neighbours_31_ready(SLR0_Mem_io_neighbours_31_ready),
    .io_neighbours_31_valid(SLR0_Mem_io_neighbours_31_valid),
    .io_neighbours_31_bits(SLR0_Mem_io_neighbours_31_bits),
    .io_neighbours_32_ready(SLR0_Mem_io_neighbours_32_ready),
    .io_neighbours_32_valid(SLR0_Mem_io_neighbours_32_valid),
    .io_neighbours_32_bits(SLR0_Mem_io_neighbours_32_bits),
    .io_neighbours_33_ready(SLR0_Mem_io_neighbours_33_ready),
    .io_neighbours_33_valid(SLR0_Mem_io_neighbours_33_valid),
    .io_neighbours_33_bits(SLR0_Mem_io_neighbours_33_bits),
    .io_neighbours_34_ready(SLR0_Mem_io_neighbours_34_ready),
    .io_neighbours_34_valid(SLR0_Mem_io_neighbours_34_valid),
    .io_neighbours_34_bits(SLR0_Mem_io_neighbours_34_bits),
    .io_neighbours_35_ready(SLR0_Mem_io_neighbours_35_ready),
    .io_neighbours_35_valid(SLR0_Mem_io_neighbours_35_valid),
    .io_neighbours_35_bits(SLR0_Mem_io_neighbours_35_bits),
    .io_neighbours_36_ready(SLR0_Mem_io_neighbours_36_ready),
    .io_neighbours_36_valid(SLR0_Mem_io_neighbours_36_valid),
    .io_neighbours_36_bits(SLR0_Mem_io_neighbours_36_bits),
    .io_neighbours_37_ready(SLR0_Mem_io_neighbours_37_ready),
    .io_neighbours_37_valid(SLR0_Mem_io_neighbours_37_valid),
    .io_neighbours_37_bits(SLR0_Mem_io_neighbours_37_bits),
    .io_neighbours_38_ready(SLR0_Mem_io_neighbours_38_ready),
    .io_neighbours_38_valid(SLR0_Mem_io_neighbours_38_valid),
    .io_neighbours_38_bits(SLR0_Mem_io_neighbours_38_bits),
    .io_neighbours_39_ready(SLR0_Mem_io_neighbours_39_ready),
    .io_neighbours_39_valid(SLR0_Mem_io_neighbours_39_valid),
    .io_neighbours_39_bits(SLR0_Mem_io_neighbours_39_bits),
    .io_neighbours_40_ready(SLR0_Mem_io_neighbours_40_ready),
    .io_neighbours_40_valid(SLR0_Mem_io_neighbours_40_valid),
    .io_neighbours_40_bits(SLR0_Mem_io_neighbours_40_bits),
    .io_neighbours_41_ready(SLR0_Mem_io_neighbours_41_ready),
    .io_neighbours_41_valid(SLR0_Mem_io_neighbours_41_valid),
    .io_neighbours_41_bits(SLR0_Mem_io_neighbours_41_bits),
    .io_neighbours_42_ready(SLR0_Mem_io_neighbours_42_ready),
    .io_neighbours_42_valid(SLR0_Mem_io_neighbours_42_valid),
    .io_neighbours_42_bits(SLR0_Mem_io_neighbours_42_bits),
    .io_neighbours_43_ready(SLR0_Mem_io_neighbours_43_ready),
    .io_neighbours_43_valid(SLR0_Mem_io_neighbours_43_valid),
    .io_neighbours_43_bits(SLR0_Mem_io_neighbours_43_bits),
    .io_neighbours_44_ready(SLR0_Mem_io_neighbours_44_ready),
    .io_neighbours_44_valid(SLR0_Mem_io_neighbours_44_valid),
    .io_neighbours_44_bits(SLR0_Mem_io_neighbours_44_bits),
    .io_neighbours_45_ready(SLR0_Mem_io_neighbours_45_ready),
    .io_neighbours_45_valid(SLR0_Mem_io_neighbours_45_valid),
    .io_neighbours_45_bits(SLR0_Mem_io_neighbours_45_bits),
    .io_neighbours_46_ready(SLR0_Mem_io_neighbours_46_ready),
    .io_neighbours_46_valid(SLR0_Mem_io_neighbours_46_valid),
    .io_neighbours_46_bits(SLR0_Mem_io_neighbours_46_bits),
    .io_neighbours_47_ready(SLR0_Mem_io_neighbours_47_ready),
    .io_neighbours_47_valid(SLR0_Mem_io_neighbours_47_valid),
    .io_neighbours_47_bits(SLR0_Mem_io_neighbours_47_bits),
    .io_neighbours_48_ready(SLR0_Mem_io_neighbours_48_ready),
    .io_neighbours_48_valid(SLR0_Mem_io_neighbours_48_valid),
    .io_neighbours_48_bits(SLR0_Mem_io_neighbours_48_bits),
    .io_neighbours_49_ready(SLR0_Mem_io_neighbours_49_ready),
    .io_neighbours_49_valid(SLR0_Mem_io_neighbours_49_valid),
    .io_neighbours_49_bits(SLR0_Mem_io_neighbours_49_bits),
    .io_neighbours_50_ready(SLR0_Mem_io_neighbours_50_ready),
    .io_neighbours_50_valid(SLR0_Mem_io_neighbours_50_valid),
    .io_neighbours_50_bits(SLR0_Mem_io_neighbours_50_bits),
    .io_neighbours_51_ready(SLR0_Mem_io_neighbours_51_ready),
    .io_neighbours_51_valid(SLR0_Mem_io_neighbours_51_valid),
    .io_neighbours_51_bits(SLR0_Mem_io_neighbours_51_bits),
    .io_neighbours_52_ready(SLR0_Mem_io_neighbours_52_ready),
    .io_neighbours_52_valid(SLR0_Mem_io_neighbours_52_valid),
    .io_neighbours_52_bits(SLR0_Mem_io_neighbours_52_bits),
    .io_neighbours_53_ready(SLR0_Mem_io_neighbours_53_ready),
    .io_neighbours_53_valid(SLR0_Mem_io_neighbours_53_valid),
    .io_neighbours_53_bits(SLR0_Mem_io_neighbours_53_bits),
    .io_neighbours_54_ready(SLR0_Mem_io_neighbours_54_ready),
    .io_neighbours_54_valid(SLR0_Mem_io_neighbours_54_valid),
    .io_neighbours_54_bits(SLR0_Mem_io_neighbours_54_bits),
    .io_neighbours_55_ready(SLR0_Mem_io_neighbours_55_ready),
    .io_neighbours_55_valid(SLR0_Mem_io_neighbours_55_valid),
    .io_neighbours_55_bits(SLR0_Mem_io_neighbours_55_bits),
    .io_neighbours_56_ready(SLR0_Mem_io_neighbours_56_ready),
    .io_neighbours_56_valid(SLR0_Mem_io_neighbours_56_valid),
    .io_neighbours_56_bits(SLR0_Mem_io_neighbours_56_bits),
    .io_neighbours_57_ready(SLR0_Mem_io_neighbours_57_ready),
    .io_neighbours_57_valid(SLR0_Mem_io_neighbours_57_valid),
    .io_neighbours_57_bits(SLR0_Mem_io_neighbours_57_bits),
    .io_neighbours_58_ready(SLR0_Mem_io_neighbours_58_ready),
    .io_neighbours_58_valid(SLR0_Mem_io_neighbours_58_valid),
    .io_neighbours_58_bits(SLR0_Mem_io_neighbours_58_bits),
    .io_neighbours_59_ready(SLR0_Mem_io_neighbours_59_ready),
    .io_neighbours_59_valid(SLR0_Mem_io_neighbours_59_valid),
    .io_neighbours_59_bits(SLR0_Mem_io_neighbours_59_bits),
    .io_neighbours_60_ready(SLR0_Mem_io_neighbours_60_ready),
    .io_neighbours_60_valid(SLR0_Mem_io_neighbours_60_valid),
    .io_neighbours_60_bits(SLR0_Mem_io_neighbours_60_bits),
    .io_neighbours_61_ready(SLR0_Mem_io_neighbours_61_ready),
    .io_neighbours_61_valid(SLR0_Mem_io_neighbours_61_valid),
    .io_neighbours_61_bits(SLR0_Mem_io_neighbours_61_bits),
    .io_neighbours_62_ready(SLR0_Mem_io_neighbours_62_ready),
    .io_neighbours_62_valid(SLR0_Mem_io_neighbours_62_valid),
    .io_neighbours_62_bits(SLR0_Mem_io_neighbours_62_bits),
    .io_neighbours_63_ready(SLR0_Mem_io_neighbours_63_ready),
    .io_neighbours_63_valid(SLR0_Mem_io_neighbours_63_valid),
    .io_neighbours_63_bits(SLR0_Mem_io_neighbours_63_bits),
    .io_neighbours_64_ready(SLR0_Mem_io_neighbours_64_ready),
    .io_neighbours_64_valid(SLR0_Mem_io_neighbours_64_valid),
    .io_neighbours_64_bits(SLR0_Mem_io_neighbours_64_bits),
    .io_neighbours_65_ready(SLR0_Mem_io_neighbours_65_ready),
    .io_neighbours_65_valid(SLR0_Mem_io_neighbours_65_valid),
    .io_neighbours_65_bits(SLR0_Mem_io_neighbours_65_bits),
    .io_neighbours_66_ready(SLR0_Mem_io_neighbours_66_ready),
    .io_neighbours_66_valid(SLR0_Mem_io_neighbours_66_valid),
    .io_neighbours_66_bits(SLR0_Mem_io_neighbours_66_bits),
    .io_neighbours_67_ready(SLR0_Mem_io_neighbours_67_ready),
    .io_neighbours_67_valid(SLR0_Mem_io_neighbours_67_valid),
    .io_neighbours_67_bits(SLR0_Mem_io_neighbours_67_bits),
    .io_neighbours_68_ready(SLR0_Mem_io_neighbours_68_ready),
    .io_neighbours_68_valid(SLR0_Mem_io_neighbours_68_valid),
    .io_neighbours_68_bits(SLR0_Mem_io_neighbours_68_bits),
    .io_neighbours_69_ready(SLR0_Mem_io_neighbours_69_ready),
    .io_neighbours_69_valid(SLR0_Mem_io_neighbours_69_valid),
    .io_neighbours_69_bits(SLR0_Mem_io_neighbours_69_bits),
    .io_neighbours_70_ready(SLR0_Mem_io_neighbours_70_ready),
    .io_neighbours_70_valid(SLR0_Mem_io_neighbours_70_valid),
    .io_neighbours_70_bits(SLR0_Mem_io_neighbours_70_bits),
    .io_neighbours_71_ready(SLR0_Mem_io_neighbours_71_ready),
    .io_neighbours_71_valid(SLR0_Mem_io_neighbours_71_valid),
    .io_neighbours_71_bits(SLR0_Mem_io_neighbours_71_bits),
    .io_neighbours_72_ready(SLR0_Mem_io_neighbours_72_ready),
    .io_neighbours_72_valid(SLR0_Mem_io_neighbours_72_valid),
    .io_neighbours_72_bits(SLR0_Mem_io_neighbours_72_bits),
    .io_neighbours_73_ready(SLR0_Mem_io_neighbours_73_ready),
    .io_neighbours_73_valid(SLR0_Mem_io_neighbours_73_valid),
    .io_neighbours_73_bits(SLR0_Mem_io_neighbours_73_bits),
    .io_neighbours_74_ready(SLR0_Mem_io_neighbours_74_ready),
    .io_neighbours_74_valid(SLR0_Mem_io_neighbours_74_valid),
    .io_neighbours_74_bits(SLR0_Mem_io_neighbours_74_bits),
    .io_neighbours_75_ready(SLR0_Mem_io_neighbours_75_ready),
    .io_neighbours_75_valid(SLR0_Mem_io_neighbours_75_valid),
    .io_neighbours_75_bits(SLR0_Mem_io_neighbours_75_bits),
    .io_neighbours_76_ready(SLR0_Mem_io_neighbours_76_ready),
    .io_neighbours_76_valid(SLR0_Mem_io_neighbours_76_valid),
    .io_neighbours_76_bits(SLR0_Mem_io_neighbours_76_bits),
    .io_neighbours_77_ready(SLR0_Mem_io_neighbours_77_ready),
    .io_neighbours_77_valid(SLR0_Mem_io_neighbours_77_valid),
    .io_neighbours_77_bits(SLR0_Mem_io_neighbours_77_bits),
    .io_neighbours_78_ready(SLR0_Mem_io_neighbours_78_ready),
    .io_neighbours_78_valid(SLR0_Mem_io_neighbours_78_valid),
    .io_neighbours_78_bits(SLR0_Mem_io_neighbours_78_bits),
    .io_neighbours_79_ready(SLR0_Mem_io_neighbours_79_ready),
    .io_neighbours_79_valid(SLR0_Mem_io_neighbours_79_valid),
    .io_neighbours_79_bits(SLR0_Mem_io_neighbours_79_bits),
    .io_neighbours_80_ready(SLR0_Mem_io_neighbours_80_ready),
    .io_neighbours_80_valid(SLR0_Mem_io_neighbours_80_valid),
    .io_neighbours_80_bits(SLR0_Mem_io_neighbours_80_bits),
    .io_neighbours_81_ready(SLR0_Mem_io_neighbours_81_ready),
    .io_neighbours_81_valid(SLR0_Mem_io_neighbours_81_valid),
    .io_neighbours_81_bits(SLR0_Mem_io_neighbours_81_bits),
    .io_neighbours_82_ready(SLR0_Mem_io_neighbours_82_ready),
    .io_neighbours_82_valid(SLR0_Mem_io_neighbours_82_valid),
    .io_neighbours_82_bits(SLR0_Mem_io_neighbours_82_bits),
    .io_neighbours_83_ready(SLR0_Mem_io_neighbours_83_ready),
    .io_neighbours_83_valid(SLR0_Mem_io_neighbours_83_valid),
    .io_neighbours_83_bits(SLR0_Mem_io_neighbours_83_bits),
    .io_neighbours_84_ready(SLR0_Mem_io_neighbours_84_ready),
    .io_neighbours_84_valid(SLR0_Mem_io_neighbours_84_valid),
    .io_neighbours_84_bits(SLR0_Mem_io_neighbours_84_bits),
    .io_neighbours_85_ready(SLR0_Mem_io_neighbours_85_ready),
    .io_neighbours_85_valid(SLR0_Mem_io_neighbours_85_valid),
    .io_neighbours_85_bits(SLR0_Mem_io_neighbours_85_bits),
    .io_neighbours_86_ready(SLR0_Mem_io_neighbours_86_ready),
    .io_neighbours_86_valid(SLR0_Mem_io_neighbours_86_valid),
    .io_neighbours_86_bits(SLR0_Mem_io_neighbours_86_bits),
    .io_neighbours_87_ready(SLR0_Mem_io_neighbours_87_ready),
    .io_neighbours_87_valid(SLR0_Mem_io_neighbours_87_valid),
    .io_neighbours_87_bits(SLR0_Mem_io_neighbours_87_bits),
    .io_neighbours_88_ready(SLR0_Mem_io_neighbours_88_ready),
    .io_neighbours_88_valid(SLR0_Mem_io_neighbours_88_valid),
    .io_neighbours_88_bits(SLR0_Mem_io_neighbours_88_bits),
    .io_neighbours_89_ready(SLR0_Mem_io_neighbours_89_ready),
    .io_neighbours_89_valid(SLR0_Mem_io_neighbours_89_valid),
    .io_neighbours_89_bits(SLR0_Mem_io_neighbours_89_bits),
    .io_neighbours_90_ready(SLR0_Mem_io_neighbours_90_ready),
    .io_neighbours_90_valid(SLR0_Mem_io_neighbours_90_valid),
    .io_neighbours_90_bits(SLR0_Mem_io_neighbours_90_bits),
    .io_neighbours_91_ready(SLR0_Mem_io_neighbours_91_ready),
    .io_neighbours_91_valid(SLR0_Mem_io_neighbours_91_valid),
    .io_neighbours_91_bits(SLR0_Mem_io_neighbours_91_bits),
    .io_neighbours_92_ready(SLR0_Mem_io_neighbours_92_ready),
    .io_neighbours_92_valid(SLR0_Mem_io_neighbours_92_valid),
    .io_neighbours_92_bits(SLR0_Mem_io_neighbours_92_bits),
    .io_neighbours_93_ready(SLR0_Mem_io_neighbours_93_ready),
    .io_neighbours_93_valid(SLR0_Mem_io_neighbours_93_valid),
    .io_neighbours_93_bits(SLR0_Mem_io_neighbours_93_bits),
    .io_neighbours_94_ready(SLR0_Mem_io_neighbours_94_ready),
    .io_neighbours_94_valid(SLR0_Mem_io_neighbours_94_valid),
    .io_neighbours_94_bits(SLR0_Mem_io_neighbours_94_bits),
    .io_neighbours_95_ready(SLR0_Mem_io_neighbours_95_ready),
    .io_neighbours_95_valid(SLR0_Mem_io_neighbours_95_valid),
    .io_neighbours_95_bits(SLR0_Mem_io_neighbours_95_bits),
    .io_neighbours_96_ready(SLR0_Mem_io_neighbours_96_ready),
    .io_neighbours_96_valid(SLR0_Mem_io_neighbours_96_valid),
    .io_neighbours_96_bits(SLR0_Mem_io_neighbours_96_bits),
    .io_neighbours_97_ready(SLR0_Mem_io_neighbours_97_ready),
    .io_neighbours_97_valid(SLR0_Mem_io_neighbours_97_valid),
    .io_neighbours_97_bits(SLR0_Mem_io_neighbours_97_bits),
    .io_neighbours_98_ready(SLR0_Mem_io_neighbours_98_ready),
    .io_neighbours_98_valid(SLR0_Mem_io_neighbours_98_valid),
    .io_neighbours_98_bits(SLR0_Mem_io_neighbours_98_bits),
    .io_neighbours_99_ready(SLR0_Mem_io_neighbours_99_ready),
    .io_neighbours_99_valid(SLR0_Mem_io_neighbours_99_valid),
    .io_neighbours_99_bits(SLR0_Mem_io_neighbours_99_bits),
    .io_neighbours_100_ready(SLR0_Mem_io_neighbours_100_ready),
    .io_neighbours_100_valid(SLR0_Mem_io_neighbours_100_valid),
    .io_neighbours_100_bits(SLR0_Mem_io_neighbours_100_bits),
    .io_neighbours_101_ready(SLR0_Mem_io_neighbours_101_ready),
    .io_neighbours_101_valid(SLR0_Mem_io_neighbours_101_valid),
    .io_neighbours_101_bits(SLR0_Mem_io_neighbours_101_bits),
    .io_neighbours_102_ready(SLR0_Mem_io_neighbours_102_ready),
    .io_neighbours_102_valid(SLR0_Mem_io_neighbours_102_valid),
    .io_neighbours_102_bits(SLR0_Mem_io_neighbours_102_bits),
    .io_neighbours_103_ready(SLR0_Mem_io_neighbours_103_ready),
    .io_neighbours_103_valid(SLR0_Mem_io_neighbours_103_valid),
    .io_neighbours_103_bits(SLR0_Mem_io_neighbours_103_bits),
    .io_neighbours_104_ready(SLR0_Mem_io_neighbours_104_ready),
    .io_neighbours_104_valid(SLR0_Mem_io_neighbours_104_valid),
    .io_neighbours_104_bits(SLR0_Mem_io_neighbours_104_bits),
    .io_neighbours_105_ready(SLR0_Mem_io_neighbours_105_ready),
    .io_neighbours_105_valid(SLR0_Mem_io_neighbours_105_valid),
    .io_neighbours_105_bits(SLR0_Mem_io_neighbours_105_bits),
    .io_neighbours_106_ready(SLR0_Mem_io_neighbours_106_ready),
    .io_neighbours_106_valid(SLR0_Mem_io_neighbours_106_valid),
    .io_neighbours_106_bits(SLR0_Mem_io_neighbours_106_bits),
    .io_neighbours_107_ready(SLR0_Mem_io_neighbours_107_ready),
    .io_neighbours_107_valid(SLR0_Mem_io_neighbours_107_valid),
    .io_neighbours_107_bits(SLR0_Mem_io_neighbours_107_bits),
    .io_neighbours_108_ready(SLR0_Mem_io_neighbours_108_ready),
    .io_neighbours_108_valid(SLR0_Mem_io_neighbours_108_valid),
    .io_neighbours_108_bits(SLR0_Mem_io_neighbours_108_bits),
    .io_neighbours_109_ready(SLR0_Mem_io_neighbours_109_ready),
    .io_neighbours_109_valid(SLR0_Mem_io_neighbours_109_valid),
    .io_neighbours_109_bits(SLR0_Mem_io_neighbours_109_bits),
    .io_neighbours_110_ready(SLR0_Mem_io_neighbours_110_ready),
    .io_neighbours_110_valid(SLR0_Mem_io_neighbours_110_valid),
    .io_neighbours_110_bits(SLR0_Mem_io_neighbours_110_bits),
    .io_neighbours_111_ready(SLR0_Mem_io_neighbours_111_ready),
    .io_neighbours_111_valid(SLR0_Mem_io_neighbours_111_valid),
    .io_neighbours_111_bits(SLR0_Mem_io_neighbours_111_bits),
    .io_neighbours_112_ready(SLR0_Mem_io_neighbours_112_ready),
    .io_neighbours_112_valid(SLR0_Mem_io_neighbours_112_valid),
    .io_neighbours_112_bits(SLR0_Mem_io_neighbours_112_bits),
    .io_neighbours_113_ready(SLR0_Mem_io_neighbours_113_ready),
    .io_neighbours_113_valid(SLR0_Mem_io_neighbours_113_valid),
    .io_neighbours_113_bits(SLR0_Mem_io_neighbours_113_bits),
    .io_neighbours_114_ready(SLR0_Mem_io_neighbours_114_ready),
    .io_neighbours_114_valid(SLR0_Mem_io_neighbours_114_valid),
    .io_neighbours_114_bits(SLR0_Mem_io_neighbours_114_bits),
    .io_neighbours_115_ready(SLR0_Mem_io_neighbours_115_ready),
    .io_neighbours_115_valid(SLR0_Mem_io_neighbours_115_valid),
    .io_neighbours_115_bits(SLR0_Mem_io_neighbours_115_bits),
    .io_neighbours_116_ready(SLR0_Mem_io_neighbours_116_ready),
    .io_neighbours_116_valid(SLR0_Mem_io_neighbours_116_valid),
    .io_neighbours_116_bits(SLR0_Mem_io_neighbours_116_bits),
    .io_neighbours_117_ready(SLR0_Mem_io_neighbours_117_ready),
    .io_neighbours_117_valid(SLR0_Mem_io_neighbours_117_valid),
    .io_neighbours_117_bits(SLR0_Mem_io_neighbours_117_bits),
    .io_neighbours_118_ready(SLR0_Mem_io_neighbours_118_ready),
    .io_neighbours_118_valid(SLR0_Mem_io_neighbours_118_valid),
    .io_neighbours_118_bits(SLR0_Mem_io_neighbours_118_bits),
    .io_neighbours_119_ready(SLR0_Mem_io_neighbours_119_ready),
    .io_neighbours_119_valid(SLR0_Mem_io_neighbours_119_valid),
    .io_neighbours_119_bits(SLR0_Mem_io_neighbours_119_bits),
    .io_neighbours_120_ready(SLR0_Mem_io_neighbours_120_ready),
    .io_neighbours_120_valid(SLR0_Mem_io_neighbours_120_valid),
    .io_neighbours_120_bits(SLR0_Mem_io_neighbours_120_bits),
    .io_neighbours_121_ready(SLR0_Mem_io_neighbours_121_ready),
    .io_neighbours_121_valid(SLR0_Mem_io_neighbours_121_valid),
    .io_neighbours_121_bits(SLR0_Mem_io_neighbours_121_bits),
    .io_neighbours_122_ready(SLR0_Mem_io_neighbours_122_ready),
    .io_neighbours_122_valid(SLR0_Mem_io_neighbours_122_valid),
    .io_neighbours_122_bits(SLR0_Mem_io_neighbours_122_bits),
    .io_neighbours_123_ready(SLR0_Mem_io_neighbours_123_ready),
    .io_neighbours_123_valid(SLR0_Mem_io_neighbours_123_valid),
    .io_neighbours_123_bits(SLR0_Mem_io_neighbours_123_bits),
    .io_neighbours_124_ready(SLR0_Mem_io_neighbours_124_ready),
    .io_neighbours_124_valid(SLR0_Mem_io_neighbours_124_valid),
    .io_neighbours_124_bits(SLR0_Mem_io_neighbours_124_bits),
    .io_neighbours_125_ready(SLR0_Mem_io_neighbours_125_ready),
    .io_neighbours_125_valid(SLR0_Mem_io_neighbours_125_valid),
    .io_neighbours_125_bits(SLR0_Mem_io_neighbours_125_bits),
    .io_neighbours_126_ready(SLR0_Mem_io_neighbours_126_ready),
    .io_neighbours_126_valid(SLR0_Mem_io_neighbours_126_valid),
    .io_neighbours_126_bits(SLR0_Mem_io_neighbours_126_bits),
    .io_neighbours_127_ready(SLR0_Mem_io_neighbours_127_ready),
    .io_neighbours_127_valid(SLR0_Mem_io_neighbours_127_valid),
    .io_neighbours_127_bits(SLR0_Mem_io_neighbours_127_bits),
    .io_uram_addr_a_0(SLR0_Mem_io_uram_addr_a_0),
    .io_uram_addr_a_1(SLR0_Mem_io_uram_addr_a_1),
    .io_uram_addr_a_2(SLR0_Mem_io_uram_addr_a_2),
    .io_uram_addr_a_3(SLR0_Mem_io_uram_addr_a_3),
    .io_uram_addr_a_4(SLR0_Mem_io_uram_addr_a_4),
    .io_uram_addr_a_5(SLR0_Mem_io_uram_addr_a_5),
    .io_uram_addr_a_6(SLR0_Mem_io_uram_addr_a_6),
    .io_uram_addr_a_7(SLR0_Mem_io_uram_addr_a_7),
    .io_uram_addr_a_8(SLR0_Mem_io_uram_addr_a_8),
    .io_uram_addr_a_9(SLR0_Mem_io_uram_addr_a_9),
    .io_uram_addr_a_10(SLR0_Mem_io_uram_addr_a_10),
    .io_uram_addr_a_11(SLR0_Mem_io_uram_addr_a_11),
    .io_uram_addr_a_12(SLR0_Mem_io_uram_addr_a_12),
    .io_uram_addr_a_13(SLR0_Mem_io_uram_addr_a_13),
    .io_uram_addr_a_14(SLR0_Mem_io_uram_addr_a_14),
    .io_uram_addr_a_15(SLR0_Mem_io_uram_addr_a_15),
    .io_uram_addr_a_16(SLR0_Mem_io_uram_addr_a_16),
    .io_uram_addr_a_17(SLR0_Mem_io_uram_addr_a_17),
    .io_uram_addr_a_18(SLR0_Mem_io_uram_addr_a_18),
    .io_uram_addr_a_19(SLR0_Mem_io_uram_addr_a_19),
    .io_uram_addr_a_20(SLR0_Mem_io_uram_addr_a_20),
    .io_uram_addr_a_21(SLR0_Mem_io_uram_addr_a_21),
    .io_uram_addr_a_22(SLR0_Mem_io_uram_addr_a_22),
    .io_uram_addr_a_23(SLR0_Mem_io_uram_addr_a_23),
    .io_uram_addr_a_24(SLR0_Mem_io_uram_addr_a_24),
    .io_uram_addr_a_25(SLR0_Mem_io_uram_addr_a_25),
    .io_uram_addr_a_26(SLR0_Mem_io_uram_addr_a_26),
    .io_uram_addr_a_27(SLR0_Mem_io_uram_addr_a_27),
    .io_uram_addr_a_28(SLR0_Mem_io_uram_addr_a_28),
    .io_uram_addr_a_29(SLR0_Mem_io_uram_addr_a_29),
    .io_uram_addr_a_30(SLR0_Mem_io_uram_addr_a_30),
    .io_uram_addr_a_31(SLR0_Mem_io_uram_addr_a_31),
    .io_uram_addr_a_32(SLR0_Mem_io_uram_addr_a_32),
    .io_uram_addr_a_33(SLR0_Mem_io_uram_addr_a_33),
    .io_uram_addr_a_34(SLR0_Mem_io_uram_addr_a_34),
    .io_uram_addr_a_35(SLR0_Mem_io_uram_addr_a_35),
    .io_uram_addr_a_36(SLR0_Mem_io_uram_addr_a_36),
    .io_uram_addr_a_37(SLR0_Mem_io_uram_addr_a_37),
    .io_uram_addr_a_38(SLR0_Mem_io_uram_addr_a_38),
    .io_uram_addr_a_39(SLR0_Mem_io_uram_addr_a_39),
    .io_uram_addr_a_40(SLR0_Mem_io_uram_addr_a_40),
    .io_uram_addr_a_41(SLR0_Mem_io_uram_addr_a_41),
    .io_uram_addr_a_42(SLR0_Mem_io_uram_addr_a_42),
    .io_uram_addr_a_43(SLR0_Mem_io_uram_addr_a_43),
    .io_uram_addr_a_44(SLR0_Mem_io_uram_addr_a_44),
    .io_uram_addr_a_45(SLR0_Mem_io_uram_addr_a_45),
    .io_uram_addr_a_46(SLR0_Mem_io_uram_addr_a_46),
    .io_uram_addr_a_47(SLR0_Mem_io_uram_addr_a_47),
    .io_uram_addr_a_48(SLR0_Mem_io_uram_addr_a_48),
    .io_uram_addr_a_49(SLR0_Mem_io_uram_addr_a_49),
    .io_uram_addr_a_50(SLR0_Mem_io_uram_addr_a_50),
    .io_uram_addr_a_51(SLR0_Mem_io_uram_addr_a_51),
    .io_uram_addr_a_52(SLR0_Mem_io_uram_addr_a_52),
    .io_uram_addr_a_53(SLR0_Mem_io_uram_addr_a_53),
    .io_uram_addr_a_54(SLR0_Mem_io_uram_addr_a_54),
    .io_uram_addr_a_55(SLR0_Mem_io_uram_addr_a_55),
    .io_uram_addr_a_56(SLR0_Mem_io_uram_addr_a_56),
    .io_uram_addr_a_57(SLR0_Mem_io_uram_addr_a_57),
    .io_uram_addr_a_58(SLR0_Mem_io_uram_addr_a_58),
    .io_uram_addr_a_59(SLR0_Mem_io_uram_addr_a_59),
    .io_uram_addr_a_60(SLR0_Mem_io_uram_addr_a_60),
    .io_uram_addr_a_61(SLR0_Mem_io_uram_addr_a_61),
    .io_uram_addr_a_62(SLR0_Mem_io_uram_addr_a_62),
    .io_uram_addr_a_63(SLR0_Mem_io_uram_addr_a_63),
    .io_uram_addr_a_64(SLR0_Mem_io_uram_addr_a_64),
    .io_uram_addr_a_65(SLR0_Mem_io_uram_addr_a_65),
    .io_uram_addr_a_66(SLR0_Mem_io_uram_addr_a_66),
    .io_uram_addr_a_67(SLR0_Mem_io_uram_addr_a_67),
    .io_uram_addr_a_68(SLR0_Mem_io_uram_addr_a_68),
    .io_uram_addr_a_69(SLR0_Mem_io_uram_addr_a_69),
    .io_uram_addr_a_70(SLR0_Mem_io_uram_addr_a_70),
    .io_uram_addr_a_71(SLR0_Mem_io_uram_addr_a_71),
    .io_uram_addr_a_72(SLR0_Mem_io_uram_addr_a_72),
    .io_uram_addr_a_73(SLR0_Mem_io_uram_addr_a_73),
    .io_uram_addr_a_74(SLR0_Mem_io_uram_addr_a_74),
    .io_uram_addr_a_75(SLR0_Mem_io_uram_addr_a_75),
    .io_uram_addr_a_76(SLR0_Mem_io_uram_addr_a_76),
    .io_uram_addr_a_77(SLR0_Mem_io_uram_addr_a_77),
    .io_uram_addr_a_78(SLR0_Mem_io_uram_addr_a_78),
    .io_uram_addr_a_79(SLR0_Mem_io_uram_addr_a_79),
    .io_uram_addr_a_80(SLR0_Mem_io_uram_addr_a_80),
    .io_uram_addr_a_81(SLR0_Mem_io_uram_addr_a_81),
    .io_uram_addr_a_82(SLR0_Mem_io_uram_addr_a_82),
    .io_uram_addr_a_83(SLR0_Mem_io_uram_addr_a_83),
    .io_uram_addr_a_84(SLR0_Mem_io_uram_addr_a_84),
    .io_uram_addr_a_85(SLR0_Mem_io_uram_addr_a_85),
    .io_uram_addr_a_86(SLR0_Mem_io_uram_addr_a_86),
    .io_uram_addr_a_87(SLR0_Mem_io_uram_addr_a_87),
    .io_uram_addr_a_88(SLR0_Mem_io_uram_addr_a_88),
    .io_uram_addr_a_89(SLR0_Mem_io_uram_addr_a_89),
    .io_uram_addr_a_90(SLR0_Mem_io_uram_addr_a_90),
    .io_uram_addr_a_91(SLR0_Mem_io_uram_addr_a_91),
    .io_uram_addr_a_92(SLR0_Mem_io_uram_addr_a_92),
    .io_uram_addr_a_93(SLR0_Mem_io_uram_addr_a_93),
    .io_uram_addr_a_94(SLR0_Mem_io_uram_addr_a_94),
    .io_uram_addr_a_95(SLR0_Mem_io_uram_addr_a_95),
    .io_uram_addr_a_96(SLR0_Mem_io_uram_addr_a_96),
    .io_uram_addr_a_97(SLR0_Mem_io_uram_addr_a_97),
    .io_uram_addr_a_98(SLR0_Mem_io_uram_addr_a_98),
    .io_uram_addr_a_99(SLR0_Mem_io_uram_addr_a_99),
    .io_uram_addr_a_100(SLR0_Mem_io_uram_addr_a_100),
    .io_uram_addr_a_101(SLR0_Mem_io_uram_addr_a_101),
    .io_uram_addr_a_102(SLR0_Mem_io_uram_addr_a_102),
    .io_uram_addr_a_103(SLR0_Mem_io_uram_addr_a_103),
    .io_uram_addr_a_104(SLR0_Mem_io_uram_addr_a_104),
    .io_uram_addr_a_105(SLR0_Mem_io_uram_addr_a_105),
    .io_uram_addr_a_106(SLR0_Mem_io_uram_addr_a_106),
    .io_uram_addr_a_107(SLR0_Mem_io_uram_addr_a_107),
    .io_uram_addr_a_108(SLR0_Mem_io_uram_addr_a_108),
    .io_uram_addr_a_109(SLR0_Mem_io_uram_addr_a_109),
    .io_uram_addr_a_110(SLR0_Mem_io_uram_addr_a_110),
    .io_uram_addr_a_111(SLR0_Mem_io_uram_addr_a_111),
    .io_uram_addr_a_112(SLR0_Mem_io_uram_addr_a_112),
    .io_uram_addr_a_113(SLR0_Mem_io_uram_addr_a_113),
    .io_uram_addr_a_114(SLR0_Mem_io_uram_addr_a_114),
    .io_uram_addr_a_115(SLR0_Mem_io_uram_addr_a_115),
    .io_uram_addr_a_116(SLR0_Mem_io_uram_addr_a_116),
    .io_uram_addr_a_117(SLR0_Mem_io_uram_addr_a_117),
    .io_uram_addr_a_118(SLR0_Mem_io_uram_addr_a_118),
    .io_uram_addr_a_119(SLR0_Mem_io_uram_addr_a_119),
    .io_uram_addr_a_120(SLR0_Mem_io_uram_addr_a_120),
    .io_uram_addr_a_121(SLR0_Mem_io_uram_addr_a_121),
    .io_uram_addr_a_122(SLR0_Mem_io_uram_addr_a_122),
    .io_uram_addr_a_123(SLR0_Mem_io_uram_addr_a_123),
    .io_uram_addr_a_124(SLR0_Mem_io_uram_addr_a_124),
    .io_uram_addr_a_125(SLR0_Mem_io_uram_addr_a_125),
    .io_uram_addr_a_126(SLR0_Mem_io_uram_addr_a_126),
    .io_uram_addr_a_127(SLR0_Mem_io_uram_addr_a_127),
    .io_write_finish_0(SLR0_Mem_io_write_finish_0),
    .io_write_finish_1(SLR0_Mem_io_write_finish_1),
    .io_write_finish_2(SLR0_Mem_io_write_finish_2),
    .io_write_finish_3(SLR0_Mem_io_write_finish_3),
    .io_write_finish_4(SLR0_Mem_io_write_finish_4),
    .io_write_finish_5(SLR0_Mem_io_write_finish_5),
    .io_write_finish_6(SLR0_Mem_io_write_finish_6),
    .io_write_finish_7(SLR0_Mem_io_write_finish_7),
    .io_write_finish_8(SLR0_Mem_io_write_finish_8),
    .io_write_finish_9(SLR0_Mem_io_write_finish_9),
    .io_write_finish_10(SLR0_Mem_io_write_finish_10),
    .io_write_finish_11(SLR0_Mem_io_write_finish_11),
    .io_write_finish_12(SLR0_Mem_io_write_finish_12),
    .io_write_finish_13(SLR0_Mem_io_write_finish_13),
    .io_write_finish_14(SLR0_Mem_io_write_finish_14),
    .io_write_finish_15(SLR0_Mem_io_write_finish_15),
    .io_write_finish_16(SLR0_Mem_io_write_finish_16),
    .io_write_finish_17(SLR0_Mem_io_write_finish_17),
    .io_write_finish_18(SLR0_Mem_io_write_finish_18),
    .io_write_finish_19(SLR0_Mem_io_write_finish_19),
    .io_write_finish_20(SLR0_Mem_io_write_finish_20),
    .io_write_finish_21(SLR0_Mem_io_write_finish_21),
    .io_write_finish_22(SLR0_Mem_io_write_finish_22),
    .io_write_finish_23(SLR0_Mem_io_write_finish_23),
    .io_write_finish_24(SLR0_Mem_io_write_finish_24),
    .io_write_finish_25(SLR0_Mem_io_write_finish_25),
    .io_write_finish_26(SLR0_Mem_io_write_finish_26),
    .io_write_finish_27(SLR0_Mem_io_write_finish_27),
    .io_write_finish_28(SLR0_Mem_io_write_finish_28),
    .io_write_finish_29(SLR0_Mem_io_write_finish_29),
    .io_write_finish_30(SLR0_Mem_io_write_finish_30),
    .io_write_finish_31(SLR0_Mem_io_write_finish_31),
    .io_HBM_interface_0_writeAddr_ready(SLR0_Mem_io_HBM_interface_0_writeAddr_ready),
    .io_HBM_interface_0_writeAddr_valid(SLR0_Mem_io_HBM_interface_0_writeAddr_valid),
    .io_HBM_interface_0_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_0_writeAddr_bits_addr),
    .io_HBM_interface_0_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_0_writeAddr_bits_len),
    .io_HBM_interface_0_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_0_writeAddr_bits_id),
    .io_HBM_interface_0_writeData_ready(SLR0_Mem_io_HBM_interface_0_writeData_ready),
    .io_HBM_interface_0_writeData_valid(SLR0_Mem_io_HBM_interface_0_writeData_valid),
    .io_HBM_interface_0_writeData_bits_data(SLR0_Mem_io_HBM_interface_0_writeData_bits_data),
    .io_HBM_interface_0_writeData_bits_strb(SLR0_Mem_io_HBM_interface_0_writeData_bits_strb),
    .io_HBM_interface_0_writeData_bits_last(SLR0_Mem_io_HBM_interface_0_writeData_bits_last),
    .io_HBM_interface_0_writeResp_ready(SLR0_Mem_io_HBM_interface_0_writeResp_ready),
    .io_HBM_interface_0_writeResp_valid(SLR0_Mem_io_HBM_interface_0_writeResp_valid),
    .io_HBM_interface_0_writeResp_bits_id(SLR0_Mem_io_HBM_interface_0_writeResp_bits_id),
    .io_HBM_interface_0_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_0_writeResp_bits_resp),
    .io_HBM_interface_0_readAddr_ready(SLR0_Mem_io_HBM_interface_0_readAddr_ready),
    .io_HBM_interface_0_readAddr_valid(SLR0_Mem_io_HBM_interface_0_readAddr_valid),
    .io_HBM_interface_0_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_0_readAddr_bits_addr),
    .io_HBM_interface_0_readAddr_bits_len(SLR0_Mem_io_HBM_interface_0_readAddr_bits_len),
    .io_HBM_interface_0_readAddr_bits_id(SLR0_Mem_io_HBM_interface_0_readAddr_bits_id),
    .io_HBM_interface_0_readData_ready(SLR0_Mem_io_HBM_interface_0_readData_ready),
    .io_HBM_interface_0_readData_valid(SLR0_Mem_io_HBM_interface_0_readData_valid),
    .io_HBM_interface_0_readData_bits_data(SLR0_Mem_io_HBM_interface_0_readData_bits_data),
    .io_HBM_interface_0_readData_bits_id(SLR0_Mem_io_HBM_interface_0_readData_bits_id),
    .io_HBM_interface_0_readData_bits_last(SLR0_Mem_io_HBM_interface_0_readData_bits_last),
    .io_HBM_interface_0_readData_bits_resp(SLR0_Mem_io_HBM_interface_0_readData_bits_resp),
    .io_HBM_interface_1_writeAddr_ready(SLR0_Mem_io_HBM_interface_1_writeAddr_ready),
    .io_HBM_interface_1_writeAddr_valid(SLR0_Mem_io_HBM_interface_1_writeAddr_valid),
    .io_HBM_interface_1_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_1_writeAddr_bits_addr),
    .io_HBM_interface_1_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_1_writeAddr_bits_len),
    .io_HBM_interface_1_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_1_writeAddr_bits_id),
    .io_HBM_interface_1_writeData_ready(SLR0_Mem_io_HBM_interface_1_writeData_ready),
    .io_HBM_interface_1_writeData_valid(SLR0_Mem_io_HBM_interface_1_writeData_valid),
    .io_HBM_interface_1_writeData_bits_data(SLR0_Mem_io_HBM_interface_1_writeData_bits_data),
    .io_HBM_interface_1_writeData_bits_strb(SLR0_Mem_io_HBM_interface_1_writeData_bits_strb),
    .io_HBM_interface_1_writeData_bits_last(SLR0_Mem_io_HBM_interface_1_writeData_bits_last),
    .io_HBM_interface_1_writeResp_ready(SLR0_Mem_io_HBM_interface_1_writeResp_ready),
    .io_HBM_interface_1_writeResp_valid(SLR0_Mem_io_HBM_interface_1_writeResp_valid),
    .io_HBM_interface_1_writeResp_bits_id(SLR0_Mem_io_HBM_interface_1_writeResp_bits_id),
    .io_HBM_interface_1_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_1_writeResp_bits_resp),
    .io_HBM_interface_1_readAddr_ready(SLR0_Mem_io_HBM_interface_1_readAddr_ready),
    .io_HBM_interface_1_readAddr_valid(SLR0_Mem_io_HBM_interface_1_readAddr_valid),
    .io_HBM_interface_1_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_1_readAddr_bits_addr),
    .io_HBM_interface_1_readAddr_bits_len(SLR0_Mem_io_HBM_interface_1_readAddr_bits_len),
    .io_HBM_interface_1_readAddr_bits_id(SLR0_Mem_io_HBM_interface_1_readAddr_bits_id),
    .io_HBM_interface_1_readData_ready(SLR0_Mem_io_HBM_interface_1_readData_ready),
    .io_HBM_interface_1_readData_valid(SLR0_Mem_io_HBM_interface_1_readData_valid),
    .io_HBM_interface_1_readData_bits_data(SLR0_Mem_io_HBM_interface_1_readData_bits_data),
    .io_HBM_interface_1_readData_bits_id(SLR0_Mem_io_HBM_interface_1_readData_bits_id),
    .io_HBM_interface_1_readData_bits_last(SLR0_Mem_io_HBM_interface_1_readData_bits_last),
    .io_HBM_interface_1_readData_bits_resp(SLR0_Mem_io_HBM_interface_1_readData_bits_resp),
    .io_HBM_interface_2_writeAddr_ready(SLR0_Mem_io_HBM_interface_2_writeAddr_ready),
    .io_HBM_interface_2_writeAddr_valid(SLR0_Mem_io_HBM_interface_2_writeAddr_valid),
    .io_HBM_interface_2_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_2_writeAddr_bits_addr),
    .io_HBM_interface_2_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_2_writeAddr_bits_len),
    .io_HBM_interface_2_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_2_writeAddr_bits_id),
    .io_HBM_interface_2_writeData_ready(SLR0_Mem_io_HBM_interface_2_writeData_ready),
    .io_HBM_interface_2_writeData_valid(SLR0_Mem_io_HBM_interface_2_writeData_valid),
    .io_HBM_interface_2_writeData_bits_data(SLR0_Mem_io_HBM_interface_2_writeData_bits_data),
    .io_HBM_interface_2_writeData_bits_strb(SLR0_Mem_io_HBM_interface_2_writeData_bits_strb),
    .io_HBM_interface_2_writeData_bits_last(SLR0_Mem_io_HBM_interface_2_writeData_bits_last),
    .io_HBM_interface_2_writeResp_ready(SLR0_Mem_io_HBM_interface_2_writeResp_ready),
    .io_HBM_interface_2_writeResp_valid(SLR0_Mem_io_HBM_interface_2_writeResp_valid),
    .io_HBM_interface_2_writeResp_bits_id(SLR0_Mem_io_HBM_interface_2_writeResp_bits_id),
    .io_HBM_interface_2_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_2_writeResp_bits_resp),
    .io_HBM_interface_2_readAddr_ready(SLR0_Mem_io_HBM_interface_2_readAddr_ready),
    .io_HBM_interface_2_readAddr_valid(SLR0_Mem_io_HBM_interface_2_readAddr_valid),
    .io_HBM_interface_2_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_2_readAddr_bits_addr),
    .io_HBM_interface_2_readAddr_bits_len(SLR0_Mem_io_HBM_interface_2_readAddr_bits_len),
    .io_HBM_interface_2_readAddr_bits_id(SLR0_Mem_io_HBM_interface_2_readAddr_bits_id),
    .io_HBM_interface_2_readData_ready(SLR0_Mem_io_HBM_interface_2_readData_ready),
    .io_HBM_interface_2_readData_valid(SLR0_Mem_io_HBM_interface_2_readData_valid),
    .io_HBM_interface_2_readData_bits_data(SLR0_Mem_io_HBM_interface_2_readData_bits_data),
    .io_HBM_interface_2_readData_bits_id(SLR0_Mem_io_HBM_interface_2_readData_bits_id),
    .io_HBM_interface_2_readData_bits_last(SLR0_Mem_io_HBM_interface_2_readData_bits_last),
    .io_HBM_interface_2_readData_bits_resp(SLR0_Mem_io_HBM_interface_2_readData_bits_resp),
    .io_HBM_interface_3_writeAddr_ready(SLR0_Mem_io_HBM_interface_3_writeAddr_ready),
    .io_HBM_interface_3_writeAddr_valid(SLR0_Mem_io_HBM_interface_3_writeAddr_valid),
    .io_HBM_interface_3_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_3_writeAddr_bits_addr),
    .io_HBM_interface_3_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_3_writeAddr_bits_len),
    .io_HBM_interface_3_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_3_writeAddr_bits_id),
    .io_HBM_interface_3_writeData_ready(SLR0_Mem_io_HBM_interface_3_writeData_ready),
    .io_HBM_interface_3_writeData_valid(SLR0_Mem_io_HBM_interface_3_writeData_valid),
    .io_HBM_interface_3_writeData_bits_data(SLR0_Mem_io_HBM_interface_3_writeData_bits_data),
    .io_HBM_interface_3_writeData_bits_strb(SLR0_Mem_io_HBM_interface_3_writeData_bits_strb),
    .io_HBM_interface_3_writeData_bits_last(SLR0_Mem_io_HBM_interface_3_writeData_bits_last),
    .io_HBM_interface_3_writeResp_ready(SLR0_Mem_io_HBM_interface_3_writeResp_ready),
    .io_HBM_interface_3_writeResp_valid(SLR0_Mem_io_HBM_interface_3_writeResp_valid),
    .io_HBM_interface_3_writeResp_bits_id(SLR0_Mem_io_HBM_interface_3_writeResp_bits_id),
    .io_HBM_interface_3_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_3_writeResp_bits_resp),
    .io_HBM_interface_3_readAddr_ready(SLR0_Mem_io_HBM_interface_3_readAddr_ready),
    .io_HBM_interface_3_readAddr_valid(SLR0_Mem_io_HBM_interface_3_readAddr_valid),
    .io_HBM_interface_3_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_3_readAddr_bits_addr),
    .io_HBM_interface_3_readAddr_bits_len(SLR0_Mem_io_HBM_interface_3_readAddr_bits_len),
    .io_HBM_interface_3_readAddr_bits_id(SLR0_Mem_io_HBM_interface_3_readAddr_bits_id),
    .io_HBM_interface_3_readData_ready(SLR0_Mem_io_HBM_interface_3_readData_ready),
    .io_HBM_interface_3_readData_valid(SLR0_Mem_io_HBM_interface_3_readData_valid),
    .io_HBM_interface_3_readData_bits_data(SLR0_Mem_io_HBM_interface_3_readData_bits_data),
    .io_HBM_interface_3_readData_bits_id(SLR0_Mem_io_HBM_interface_3_readData_bits_id),
    .io_HBM_interface_3_readData_bits_last(SLR0_Mem_io_HBM_interface_3_readData_bits_last),
    .io_HBM_interface_3_readData_bits_resp(SLR0_Mem_io_HBM_interface_3_readData_bits_resp),
    .io_HBM_interface_4_writeAddr_ready(SLR0_Mem_io_HBM_interface_4_writeAddr_ready),
    .io_HBM_interface_4_writeAddr_valid(SLR0_Mem_io_HBM_interface_4_writeAddr_valid),
    .io_HBM_interface_4_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_4_writeAddr_bits_addr),
    .io_HBM_interface_4_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_4_writeAddr_bits_len),
    .io_HBM_interface_4_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_4_writeAddr_bits_id),
    .io_HBM_interface_4_writeData_ready(SLR0_Mem_io_HBM_interface_4_writeData_ready),
    .io_HBM_interface_4_writeData_valid(SLR0_Mem_io_HBM_interface_4_writeData_valid),
    .io_HBM_interface_4_writeData_bits_data(SLR0_Mem_io_HBM_interface_4_writeData_bits_data),
    .io_HBM_interface_4_writeData_bits_strb(SLR0_Mem_io_HBM_interface_4_writeData_bits_strb),
    .io_HBM_interface_4_writeData_bits_last(SLR0_Mem_io_HBM_interface_4_writeData_bits_last),
    .io_HBM_interface_4_writeResp_ready(SLR0_Mem_io_HBM_interface_4_writeResp_ready),
    .io_HBM_interface_4_writeResp_valid(SLR0_Mem_io_HBM_interface_4_writeResp_valid),
    .io_HBM_interface_4_writeResp_bits_id(SLR0_Mem_io_HBM_interface_4_writeResp_bits_id),
    .io_HBM_interface_4_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_4_writeResp_bits_resp),
    .io_HBM_interface_4_readAddr_ready(SLR0_Mem_io_HBM_interface_4_readAddr_ready),
    .io_HBM_interface_4_readAddr_valid(SLR0_Mem_io_HBM_interface_4_readAddr_valid),
    .io_HBM_interface_4_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_4_readAddr_bits_addr),
    .io_HBM_interface_4_readAddr_bits_len(SLR0_Mem_io_HBM_interface_4_readAddr_bits_len),
    .io_HBM_interface_4_readAddr_bits_id(SLR0_Mem_io_HBM_interface_4_readAddr_bits_id),
    .io_HBM_interface_4_readData_ready(SLR0_Mem_io_HBM_interface_4_readData_ready),
    .io_HBM_interface_4_readData_valid(SLR0_Mem_io_HBM_interface_4_readData_valid),
    .io_HBM_interface_4_readData_bits_data(SLR0_Mem_io_HBM_interface_4_readData_bits_data),
    .io_HBM_interface_4_readData_bits_id(SLR0_Mem_io_HBM_interface_4_readData_bits_id),
    .io_HBM_interface_4_readData_bits_last(SLR0_Mem_io_HBM_interface_4_readData_bits_last),
    .io_HBM_interface_4_readData_bits_resp(SLR0_Mem_io_HBM_interface_4_readData_bits_resp),
    .io_HBM_interface_5_writeAddr_ready(SLR0_Mem_io_HBM_interface_5_writeAddr_ready),
    .io_HBM_interface_5_writeAddr_valid(SLR0_Mem_io_HBM_interface_5_writeAddr_valid),
    .io_HBM_interface_5_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_5_writeAddr_bits_addr),
    .io_HBM_interface_5_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_5_writeAddr_bits_len),
    .io_HBM_interface_5_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_5_writeAddr_bits_id),
    .io_HBM_interface_5_writeData_ready(SLR0_Mem_io_HBM_interface_5_writeData_ready),
    .io_HBM_interface_5_writeData_valid(SLR0_Mem_io_HBM_interface_5_writeData_valid),
    .io_HBM_interface_5_writeData_bits_data(SLR0_Mem_io_HBM_interface_5_writeData_bits_data),
    .io_HBM_interface_5_writeData_bits_strb(SLR0_Mem_io_HBM_interface_5_writeData_bits_strb),
    .io_HBM_interface_5_writeData_bits_last(SLR0_Mem_io_HBM_interface_5_writeData_bits_last),
    .io_HBM_interface_5_writeResp_ready(SLR0_Mem_io_HBM_interface_5_writeResp_ready),
    .io_HBM_interface_5_writeResp_valid(SLR0_Mem_io_HBM_interface_5_writeResp_valid),
    .io_HBM_interface_5_writeResp_bits_id(SLR0_Mem_io_HBM_interface_5_writeResp_bits_id),
    .io_HBM_interface_5_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_5_writeResp_bits_resp),
    .io_HBM_interface_5_readAddr_ready(SLR0_Mem_io_HBM_interface_5_readAddr_ready),
    .io_HBM_interface_5_readAddr_valid(SLR0_Mem_io_HBM_interface_5_readAddr_valid),
    .io_HBM_interface_5_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_5_readAddr_bits_addr),
    .io_HBM_interface_5_readAddr_bits_len(SLR0_Mem_io_HBM_interface_5_readAddr_bits_len),
    .io_HBM_interface_5_readAddr_bits_id(SLR0_Mem_io_HBM_interface_5_readAddr_bits_id),
    .io_HBM_interface_5_readData_ready(SLR0_Mem_io_HBM_interface_5_readData_ready),
    .io_HBM_interface_5_readData_valid(SLR0_Mem_io_HBM_interface_5_readData_valid),
    .io_HBM_interface_5_readData_bits_data(SLR0_Mem_io_HBM_interface_5_readData_bits_data),
    .io_HBM_interface_5_readData_bits_id(SLR0_Mem_io_HBM_interface_5_readData_bits_id),
    .io_HBM_interface_5_readData_bits_last(SLR0_Mem_io_HBM_interface_5_readData_bits_last),
    .io_HBM_interface_5_readData_bits_resp(SLR0_Mem_io_HBM_interface_5_readData_bits_resp),
    .io_HBM_interface_6_writeAddr_ready(SLR0_Mem_io_HBM_interface_6_writeAddr_ready),
    .io_HBM_interface_6_writeAddr_valid(SLR0_Mem_io_HBM_interface_6_writeAddr_valid),
    .io_HBM_interface_6_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_6_writeAddr_bits_addr),
    .io_HBM_interface_6_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_6_writeAddr_bits_len),
    .io_HBM_interface_6_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_6_writeAddr_bits_id),
    .io_HBM_interface_6_writeData_ready(SLR0_Mem_io_HBM_interface_6_writeData_ready),
    .io_HBM_interface_6_writeData_valid(SLR0_Mem_io_HBM_interface_6_writeData_valid),
    .io_HBM_interface_6_writeData_bits_data(SLR0_Mem_io_HBM_interface_6_writeData_bits_data),
    .io_HBM_interface_6_writeData_bits_strb(SLR0_Mem_io_HBM_interface_6_writeData_bits_strb),
    .io_HBM_interface_6_writeData_bits_last(SLR0_Mem_io_HBM_interface_6_writeData_bits_last),
    .io_HBM_interface_6_writeResp_ready(SLR0_Mem_io_HBM_interface_6_writeResp_ready),
    .io_HBM_interface_6_writeResp_valid(SLR0_Mem_io_HBM_interface_6_writeResp_valid),
    .io_HBM_interface_6_writeResp_bits_id(SLR0_Mem_io_HBM_interface_6_writeResp_bits_id),
    .io_HBM_interface_6_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_6_writeResp_bits_resp),
    .io_HBM_interface_6_readAddr_ready(SLR0_Mem_io_HBM_interface_6_readAddr_ready),
    .io_HBM_interface_6_readAddr_valid(SLR0_Mem_io_HBM_interface_6_readAddr_valid),
    .io_HBM_interface_6_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_6_readAddr_bits_addr),
    .io_HBM_interface_6_readAddr_bits_len(SLR0_Mem_io_HBM_interface_6_readAddr_bits_len),
    .io_HBM_interface_6_readAddr_bits_id(SLR0_Mem_io_HBM_interface_6_readAddr_bits_id),
    .io_HBM_interface_6_readData_ready(SLR0_Mem_io_HBM_interface_6_readData_ready),
    .io_HBM_interface_6_readData_valid(SLR0_Mem_io_HBM_interface_6_readData_valid),
    .io_HBM_interface_6_readData_bits_data(SLR0_Mem_io_HBM_interface_6_readData_bits_data),
    .io_HBM_interface_6_readData_bits_id(SLR0_Mem_io_HBM_interface_6_readData_bits_id),
    .io_HBM_interface_6_readData_bits_last(SLR0_Mem_io_HBM_interface_6_readData_bits_last),
    .io_HBM_interface_6_readData_bits_resp(SLR0_Mem_io_HBM_interface_6_readData_bits_resp),
    .io_HBM_interface_7_writeAddr_ready(SLR0_Mem_io_HBM_interface_7_writeAddr_ready),
    .io_HBM_interface_7_writeAddr_valid(SLR0_Mem_io_HBM_interface_7_writeAddr_valid),
    .io_HBM_interface_7_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_7_writeAddr_bits_addr),
    .io_HBM_interface_7_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_7_writeAddr_bits_len),
    .io_HBM_interface_7_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_7_writeAddr_bits_id),
    .io_HBM_interface_7_writeData_ready(SLR0_Mem_io_HBM_interface_7_writeData_ready),
    .io_HBM_interface_7_writeData_valid(SLR0_Mem_io_HBM_interface_7_writeData_valid),
    .io_HBM_interface_7_writeData_bits_data(SLR0_Mem_io_HBM_interface_7_writeData_bits_data),
    .io_HBM_interface_7_writeData_bits_strb(SLR0_Mem_io_HBM_interface_7_writeData_bits_strb),
    .io_HBM_interface_7_writeData_bits_last(SLR0_Mem_io_HBM_interface_7_writeData_bits_last),
    .io_HBM_interface_7_writeResp_ready(SLR0_Mem_io_HBM_interface_7_writeResp_ready),
    .io_HBM_interface_7_writeResp_valid(SLR0_Mem_io_HBM_interface_7_writeResp_valid),
    .io_HBM_interface_7_writeResp_bits_id(SLR0_Mem_io_HBM_interface_7_writeResp_bits_id),
    .io_HBM_interface_7_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_7_writeResp_bits_resp),
    .io_HBM_interface_7_readAddr_ready(SLR0_Mem_io_HBM_interface_7_readAddr_ready),
    .io_HBM_interface_7_readAddr_valid(SLR0_Mem_io_HBM_interface_7_readAddr_valid),
    .io_HBM_interface_7_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_7_readAddr_bits_addr),
    .io_HBM_interface_7_readAddr_bits_len(SLR0_Mem_io_HBM_interface_7_readAddr_bits_len),
    .io_HBM_interface_7_readAddr_bits_id(SLR0_Mem_io_HBM_interface_7_readAddr_bits_id),
    .io_HBM_interface_7_readData_ready(SLR0_Mem_io_HBM_interface_7_readData_ready),
    .io_HBM_interface_7_readData_valid(SLR0_Mem_io_HBM_interface_7_readData_valid),
    .io_HBM_interface_7_readData_bits_data(SLR0_Mem_io_HBM_interface_7_readData_bits_data),
    .io_HBM_interface_7_readData_bits_id(SLR0_Mem_io_HBM_interface_7_readData_bits_id),
    .io_HBM_interface_7_readData_bits_last(SLR0_Mem_io_HBM_interface_7_readData_bits_last),
    .io_HBM_interface_7_readData_bits_resp(SLR0_Mem_io_HBM_interface_7_readData_bits_resp),
    .io_HBM_interface_8_writeAddr_ready(SLR0_Mem_io_HBM_interface_8_writeAddr_ready),
    .io_HBM_interface_8_writeAddr_valid(SLR0_Mem_io_HBM_interface_8_writeAddr_valid),
    .io_HBM_interface_8_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_8_writeAddr_bits_addr),
    .io_HBM_interface_8_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_8_writeAddr_bits_len),
    .io_HBM_interface_8_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_8_writeAddr_bits_id),
    .io_HBM_interface_8_writeData_ready(SLR0_Mem_io_HBM_interface_8_writeData_ready),
    .io_HBM_interface_8_writeData_valid(SLR0_Mem_io_HBM_interface_8_writeData_valid),
    .io_HBM_interface_8_writeData_bits_data(SLR0_Mem_io_HBM_interface_8_writeData_bits_data),
    .io_HBM_interface_8_writeData_bits_strb(SLR0_Mem_io_HBM_interface_8_writeData_bits_strb),
    .io_HBM_interface_8_writeData_bits_last(SLR0_Mem_io_HBM_interface_8_writeData_bits_last),
    .io_HBM_interface_8_writeResp_ready(SLR0_Mem_io_HBM_interface_8_writeResp_ready),
    .io_HBM_interface_8_writeResp_valid(SLR0_Mem_io_HBM_interface_8_writeResp_valid),
    .io_HBM_interface_8_writeResp_bits_id(SLR0_Mem_io_HBM_interface_8_writeResp_bits_id),
    .io_HBM_interface_8_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_8_writeResp_bits_resp),
    .io_HBM_interface_8_readAddr_ready(SLR0_Mem_io_HBM_interface_8_readAddr_ready),
    .io_HBM_interface_8_readAddr_valid(SLR0_Mem_io_HBM_interface_8_readAddr_valid),
    .io_HBM_interface_8_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_8_readAddr_bits_addr),
    .io_HBM_interface_8_readAddr_bits_len(SLR0_Mem_io_HBM_interface_8_readAddr_bits_len),
    .io_HBM_interface_8_readAddr_bits_id(SLR0_Mem_io_HBM_interface_8_readAddr_bits_id),
    .io_HBM_interface_8_readData_ready(SLR0_Mem_io_HBM_interface_8_readData_ready),
    .io_HBM_interface_8_readData_valid(SLR0_Mem_io_HBM_interface_8_readData_valid),
    .io_HBM_interface_8_readData_bits_data(SLR0_Mem_io_HBM_interface_8_readData_bits_data),
    .io_HBM_interface_8_readData_bits_id(SLR0_Mem_io_HBM_interface_8_readData_bits_id),
    .io_HBM_interface_8_readData_bits_last(SLR0_Mem_io_HBM_interface_8_readData_bits_last),
    .io_HBM_interface_8_readData_bits_resp(SLR0_Mem_io_HBM_interface_8_readData_bits_resp),
    .io_HBM_interface_9_writeAddr_ready(SLR0_Mem_io_HBM_interface_9_writeAddr_ready),
    .io_HBM_interface_9_writeAddr_valid(SLR0_Mem_io_HBM_interface_9_writeAddr_valid),
    .io_HBM_interface_9_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_9_writeAddr_bits_addr),
    .io_HBM_interface_9_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_9_writeAddr_bits_len),
    .io_HBM_interface_9_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_9_writeAddr_bits_id),
    .io_HBM_interface_9_writeData_ready(SLR0_Mem_io_HBM_interface_9_writeData_ready),
    .io_HBM_interface_9_writeData_valid(SLR0_Mem_io_HBM_interface_9_writeData_valid),
    .io_HBM_interface_9_writeData_bits_data(SLR0_Mem_io_HBM_interface_9_writeData_bits_data),
    .io_HBM_interface_9_writeData_bits_strb(SLR0_Mem_io_HBM_interface_9_writeData_bits_strb),
    .io_HBM_interface_9_writeData_bits_last(SLR0_Mem_io_HBM_interface_9_writeData_bits_last),
    .io_HBM_interface_9_writeResp_ready(SLR0_Mem_io_HBM_interface_9_writeResp_ready),
    .io_HBM_interface_9_writeResp_valid(SLR0_Mem_io_HBM_interface_9_writeResp_valid),
    .io_HBM_interface_9_writeResp_bits_id(SLR0_Mem_io_HBM_interface_9_writeResp_bits_id),
    .io_HBM_interface_9_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_9_writeResp_bits_resp),
    .io_HBM_interface_9_readAddr_ready(SLR0_Mem_io_HBM_interface_9_readAddr_ready),
    .io_HBM_interface_9_readAddr_valid(SLR0_Mem_io_HBM_interface_9_readAddr_valid),
    .io_HBM_interface_9_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_9_readAddr_bits_addr),
    .io_HBM_interface_9_readAddr_bits_len(SLR0_Mem_io_HBM_interface_9_readAddr_bits_len),
    .io_HBM_interface_9_readAddr_bits_id(SLR0_Mem_io_HBM_interface_9_readAddr_bits_id),
    .io_HBM_interface_9_readData_ready(SLR0_Mem_io_HBM_interface_9_readData_ready),
    .io_HBM_interface_9_readData_valid(SLR0_Mem_io_HBM_interface_9_readData_valid),
    .io_HBM_interface_9_readData_bits_data(SLR0_Mem_io_HBM_interface_9_readData_bits_data),
    .io_HBM_interface_9_readData_bits_id(SLR0_Mem_io_HBM_interface_9_readData_bits_id),
    .io_HBM_interface_9_readData_bits_last(SLR0_Mem_io_HBM_interface_9_readData_bits_last),
    .io_HBM_interface_9_readData_bits_resp(SLR0_Mem_io_HBM_interface_9_readData_bits_resp),
    .io_HBM_interface_10_writeAddr_ready(SLR0_Mem_io_HBM_interface_10_writeAddr_ready),
    .io_HBM_interface_10_writeAddr_valid(SLR0_Mem_io_HBM_interface_10_writeAddr_valid),
    .io_HBM_interface_10_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_10_writeAddr_bits_addr),
    .io_HBM_interface_10_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_10_writeAddr_bits_len),
    .io_HBM_interface_10_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_10_writeAddr_bits_id),
    .io_HBM_interface_10_writeData_ready(SLR0_Mem_io_HBM_interface_10_writeData_ready),
    .io_HBM_interface_10_writeData_valid(SLR0_Mem_io_HBM_interface_10_writeData_valid),
    .io_HBM_interface_10_writeData_bits_data(SLR0_Mem_io_HBM_interface_10_writeData_bits_data),
    .io_HBM_interface_10_writeData_bits_strb(SLR0_Mem_io_HBM_interface_10_writeData_bits_strb),
    .io_HBM_interface_10_writeData_bits_last(SLR0_Mem_io_HBM_interface_10_writeData_bits_last),
    .io_HBM_interface_10_writeResp_ready(SLR0_Mem_io_HBM_interface_10_writeResp_ready),
    .io_HBM_interface_10_writeResp_valid(SLR0_Mem_io_HBM_interface_10_writeResp_valid),
    .io_HBM_interface_10_writeResp_bits_id(SLR0_Mem_io_HBM_interface_10_writeResp_bits_id),
    .io_HBM_interface_10_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_10_writeResp_bits_resp),
    .io_HBM_interface_10_readAddr_ready(SLR0_Mem_io_HBM_interface_10_readAddr_ready),
    .io_HBM_interface_10_readAddr_valid(SLR0_Mem_io_HBM_interface_10_readAddr_valid),
    .io_HBM_interface_10_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_10_readAddr_bits_addr),
    .io_HBM_interface_10_readAddr_bits_len(SLR0_Mem_io_HBM_interface_10_readAddr_bits_len),
    .io_HBM_interface_10_readAddr_bits_id(SLR0_Mem_io_HBM_interface_10_readAddr_bits_id),
    .io_HBM_interface_10_readData_ready(SLR0_Mem_io_HBM_interface_10_readData_ready),
    .io_HBM_interface_10_readData_valid(SLR0_Mem_io_HBM_interface_10_readData_valid),
    .io_HBM_interface_10_readData_bits_data(SLR0_Mem_io_HBM_interface_10_readData_bits_data),
    .io_HBM_interface_10_readData_bits_id(SLR0_Mem_io_HBM_interface_10_readData_bits_id),
    .io_HBM_interface_10_readData_bits_last(SLR0_Mem_io_HBM_interface_10_readData_bits_last),
    .io_HBM_interface_10_readData_bits_resp(SLR0_Mem_io_HBM_interface_10_readData_bits_resp),
    .io_HBM_interface_11_writeAddr_ready(SLR0_Mem_io_HBM_interface_11_writeAddr_ready),
    .io_HBM_interface_11_writeAddr_valid(SLR0_Mem_io_HBM_interface_11_writeAddr_valid),
    .io_HBM_interface_11_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_11_writeAddr_bits_addr),
    .io_HBM_interface_11_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_11_writeAddr_bits_len),
    .io_HBM_interface_11_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_11_writeAddr_bits_id),
    .io_HBM_interface_11_writeData_ready(SLR0_Mem_io_HBM_interface_11_writeData_ready),
    .io_HBM_interface_11_writeData_valid(SLR0_Mem_io_HBM_interface_11_writeData_valid),
    .io_HBM_interface_11_writeData_bits_data(SLR0_Mem_io_HBM_interface_11_writeData_bits_data),
    .io_HBM_interface_11_writeData_bits_strb(SLR0_Mem_io_HBM_interface_11_writeData_bits_strb),
    .io_HBM_interface_11_writeData_bits_last(SLR0_Mem_io_HBM_interface_11_writeData_bits_last),
    .io_HBM_interface_11_writeResp_ready(SLR0_Mem_io_HBM_interface_11_writeResp_ready),
    .io_HBM_interface_11_writeResp_valid(SLR0_Mem_io_HBM_interface_11_writeResp_valid),
    .io_HBM_interface_11_writeResp_bits_id(SLR0_Mem_io_HBM_interface_11_writeResp_bits_id),
    .io_HBM_interface_11_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_11_writeResp_bits_resp),
    .io_HBM_interface_11_readAddr_ready(SLR0_Mem_io_HBM_interface_11_readAddr_ready),
    .io_HBM_interface_11_readAddr_valid(SLR0_Mem_io_HBM_interface_11_readAddr_valid),
    .io_HBM_interface_11_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_11_readAddr_bits_addr),
    .io_HBM_interface_11_readAddr_bits_len(SLR0_Mem_io_HBM_interface_11_readAddr_bits_len),
    .io_HBM_interface_11_readAddr_bits_id(SLR0_Mem_io_HBM_interface_11_readAddr_bits_id),
    .io_HBM_interface_11_readData_ready(SLR0_Mem_io_HBM_interface_11_readData_ready),
    .io_HBM_interface_11_readData_valid(SLR0_Mem_io_HBM_interface_11_readData_valid),
    .io_HBM_interface_11_readData_bits_data(SLR0_Mem_io_HBM_interface_11_readData_bits_data),
    .io_HBM_interface_11_readData_bits_id(SLR0_Mem_io_HBM_interface_11_readData_bits_id),
    .io_HBM_interface_11_readData_bits_last(SLR0_Mem_io_HBM_interface_11_readData_bits_last),
    .io_HBM_interface_11_readData_bits_resp(SLR0_Mem_io_HBM_interface_11_readData_bits_resp),
    .io_HBM_interface_12_writeAddr_ready(SLR0_Mem_io_HBM_interface_12_writeAddr_ready),
    .io_HBM_interface_12_writeAddr_valid(SLR0_Mem_io_HBM_interface_12_writeAddr_valid),
    .io_HBM_interface_12_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_12_writeAddr_bits_addr),
    .io_HBM_interface_12_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_12_writeAddr_bits_len),
    .io_HBM_interface_12_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_12_writeAddr_bits_id),
    .io_HBM_interface_12_writeData_ready(SLR0_Mem_io_HBM_interface_12_writeData_ready),
    .io_HBM_interface_12_writeData_valid(SLR0_Mem_io_HBM_interface_12_writeData_valid),
    .io_HBM_interface_12_writeData_bits_data(SLR0_Mem_io_HBM_interface_12_writeData_bits_data),
    .io_HBM_interface_12_writeData_bits_strb(SLR0_Mem_io_HBM_interface_12_writeData_bits_strb),
    .io_HBM_interface_12_writeData_bits_last(SLR0_Mem_io_HBM_interface_12_writeData_bits_last),
    .io_HBM_interface_12_writeResp_ready(SLR0_Mem_io_HBM_interface_12_writeResp_ready),
    .io_HBM_interface_12_writeResp_valid(SLR0_Mem_io_HBM_interface_12_writeResp_valid),
    .io_HBM_interface_12_writeResp_bits_id(SLR0_Mem_io_HBM_interface_12_writeResp_bits_id),
    .io_HBM_interface_12_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_12_writeResp_bits_resp),
    .io_HBM_interface_12_readAddr_ready(SLR0_Mem_io_HBM_interface_12_readAddr_ready),
    .io_HBM_interface_12_readAddr_valid(SLR0_Mem_io_HBM_interface_12_readAddr_valid),
    .io_HBM_interface_12_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_12_readAddr_bits_addr),
    .io_HBM_interface_12_readAddr_bits_len(SLR0_Mem_io_HBM_interface_12_readAddr_bits_len),
    .io_HBM_interface_12_readAddr_bits_id(SLR0_Mem_io_HBM_interface_12_readAddr_bits_id),
    .io_HBM_interface_12_readData_ready(SLR0_Mem_io_HBM_interface_12_readData_ready),
    .io_HBM_interface_12_readData_valid(SLR0_Mem_io_HBM_interface_12_readData_valid),
    .io_HBM_interface_12_readData_bits_data(SLR0_Mem_io_HBM_interface_12_readData_bits_data),
    .io_HBM_interface_12_readData_bits_id(SLR0_Mem_io_HBM_interface_12_readData_bits_id),
    .io_HBM_interface_12_readData_bits_last(SLR0_Mem_io_HBM_interface_12_readData_bits_last),
    .io_HBM_interface_12_readData_bits_resp(SLR0_Mem_io_HBM_interface_12_readData_bits_resp),
    .io_HBM_interface_13_writeAddr_ready(SLR0_Mem_io_HBM_interface_13_writeAddr_ready),
    .io_HBM_interface_13_writeAddr_valid(SLR0_Mem_io_HBM_interface_13_writeAddr_valid),
    .io_HBM_interface_13_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_13_writeAddr_bits_addr),
    .io_HBM_interface_13_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_13_writeAddr_bits_len),
    .io_HBM_interface_13_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_13_writeAddr_bits_id),
    .io_HBM_interface_13_writeData_ready(SLR0_Mem_io_HBM_interface_13_writeData_ready),
    .io_HBM_interface_13_writeData_valid(SLR0_Mem_io_HBM_interface_13_writeData_valid),
    .io_HBM_interface_13_writeData_bits_data(SLR0_Mem_io_HBM_interface_13_writeData_bits_data),
    .io_HBM_interface_13_writeData_bits_strb(SLR0_Mem_io_HBM_interface_13_writeData_bits_strb),
    .io_HBM_interface_13_writeData_bits_last(SLR0_Mem_io_HBM_interface_13_writeData_bits_last),
    .io_HBM_interface_13_writeResp_ready(SLR0_Mem_io_HBM_interface_13_writeResp_ready),
    .io_HBM_interface_13_writeResp_valid(SLR0_Mem_io_HBM_interface_13_writeResp_valid),
    .io_HBM_interface_13_writeResp_bits_id(SLR0_Mem_io_HBM_interface_13_writeResp_bits_id),
    .io_HBM_interface_13_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_13_writeResp_bits_resp),
    .io_HBM_interface_13_readAddr_ready(SLR0_Mem_io_HBM_interface_13_readAddr_ready),
    .io_HBM_interface_13_readAddr_valid(SLR0_Mem_io_HBM_interface_13_readAddr_valid),
    .io_HBM_interface_13_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_13_readAddr_bits_addr),
    .io_HBM_interface_13_readAddr_bits_len(SLR0_Mem_io_HBM_interface_13_readAddr_bits_len),
    .io_HBM_interface_13_readAddr_bits_id(SLR0_Mem_io_HBM_interface_13_readAddr_bits_id),
    .io_HBM_interface_13_readData_ready(SLR0_Mem_io_HBM_interface_13_readData_ready),
    .io_HBM_interface_13_readData_valid(SLR0_Mem_io_HBM_interface_13_readData_valid),
    .io_HBM_interface_13_readData_bits_data(SLR0_Mem_io_HBM_interface_13_readData_bits_data),
    .io_HBM_interface_13_readData_bits_id(SLR0_Mem_io_HBM_interface_13_readData_bits_id),
    .io_HBM_interface_13_readData_bits_last(SLR0_Mem_io_HBM_interface_13_readData_bits_last),
    .io_HBM_interface_13_readData_bits_resp(SLR0_Mem_io_HBM_interface_13_readData_bits_resp),
    .io_HBM_interface_14_writeAddr_ready(SLR0_Mem_io_HBM_interface_14_writeAddr_ready),
    .io_HBM_interface_14_writeAddr_valid(SLR0_Mem_io_HBM_interface_14_writeAddr_valid),
    .io_HBM_interface_14_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_14_writeAddr_bits_addr),
    .io_HBM_interface_14_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_14_writeAddr_bits_len),
    .io_HBM_interface_14_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_14_writeAddr_bits_id),
    .io_HBM_interface_14_writeData_ready(SLR0_Mem_io_HBM_interface_14_writeData_ready),
    .io_HBM_interface_14_writeData_valid(SLR0_Mem_io_HBM_interface_14_writeData_valid),
    .io_HBM_interface_14_writeData_bits_data(SLR0_Mem_io_HBM_interface_14_writeData_bits_data),
    .io_HBM_interface_14_writeData_bits_strb(SLR0_Mem_io_HBM_interface_14_writeData_bits_strb),
    .io_HBM_interface_14_writeData_bits_last(SLR0_Mem_io_HBM_interface_14_writeData_bits_last),
    .io_HBM_interface_14_writeResp_ready(SLR0_Mem_io_HBM_interface_14_writeResp_ready),
    .io_HBM_interface_14_writeResp_valid(SLR0_Mem_io_HBM_interface_14_writeResp_valid),
    .io_HBM_interface_14_writeResp_bits_id(SLR0_Mem_io_HBM_interface_14_writeResp_bits_id),
    .io_HBM_interface_14_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_14_writeResp_bits_resp),
    .io_HBM_interface_14_readAddr_ready(SLR0_Mem_io_HBM_interface_14_readAddr_ready),
    .io_HBM_interface_14_readAddr_valid(SLR0_Mem_io_HBM_interface_14_readAddr_valid),
    .io_HBM_interface_14_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_14_readAddr_bits_addr),
    .io_HBM_interface_14_readAddr_bits_len(SLR0_Mem_io_HBM_interface_14_readAddr_bits_len),
    .io_HBM_interface_14_readAddr_bits_id(SLR0_Mem_io_HBM_interface_14_readAddr_bits_id),
    .io_HBM_interface_14_readData_ready(SLR0_Mem_io_HBM_interface_14_readData_ready),
    .io_HBM_interface_14_readData_valid(SLR0_Mem_io_HBM_interface_14_readData_valid),
    .io_HBM_interface_14_readData_bits_data(SLR0_Mem_io_HBM_interface_14_readData_bits_data),
    .io_HBM_interface_14_readData_bits_id(SLR0_Mem_io_HBM_interface_14_readData_bits_id),
    .io_HBM_interface_14_readData_bits_last(SLR0_Mem_io_HBM_interface_14_readData_bits_last),
    .io_HBM_interface_14_readData_bits_resp(SLR0_Mem_io_HBM_interface_14_readData_bits_resp),
    .io_HBM_interface_15_writeAddr_ready(SLR0_Mem_io_HBM_interface_15_writeAddr_ready),
    .io_HBM_interface_15_writeAddr_valid(SLR0_Mem_io_HBM_interface_15_writeAddr_valid),
    .io_HBM_interface_15_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_15_writeAddr_bits_addr),
    .io_HBM_interface_15_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_15_writeAddr_bits_len),
    .io_HBM_interface_15_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_15_writeAddr_bits_id),
    .io_HBM_interface_15_writeData_ready(SLR0_Mem_io_HBM_interface_15_writeData_ready),
    .io_HBM_interface_15_writeData_valid(SLR0_Mem_io_HBM_interface_15_writeData_valid),
    .io_HBM_interface_15_writeData_bits_data(SLR0_Mem_io_HBM_interface_15_writeData_bits_data),
    .io_HBM_interface_15_writeData_bits_strb(SLR0_Mem_io_HBM_interface_15_writeData_bits_strb),
    .io_HBM_interface_15_writeData_bits_last(SLR0_Mem_io_HBM_interface_15_writeData_bits_last),
    .io_HBM_interface_15_writeResp_ready(SLR0_Mem_io_HBM_interface_15_writeResp_ready),
    .io_HBM_interface_15_writeResp_valid(SLR0_Mem_io_HBM_interface_15_writeResp_valid),
    .io_HBM_interface_15_writeResp_bits_id(SLR0_Mem_io_HBM_interface_15_writeResp_bits_id),
    .io_HBM_interface_15_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_15_writeResp_bits_resp),
    .io_HBM_interface_15_readAddr_ready(SLR0_Mem_io_HBM_interface_15_readAddr_ready),
    .io_HBM_interface_15_readAddr_valid(SLR0_Mem_io_HBM_interface_15_readAddr_valid),
    .io_HBM_interface_15_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_15_readAddr_bits_addr),
    .io_HBM_interface_15_readAddr_bits_len(SLR0_Mem_io_HBM_interface_15_readAddr_bits_len),
    .io_HBM_interface_15_readAddr_bits_id(SLR0_Mem_io_HBM_interface_15_readAddr_bits_id),
    .io_HBM_interface_15_readData_ready(SLR0_Mem_io_HBM_interface_15_readData_ready),
    .io_HBM_interface_15_readData_valid(SLR0_Mem_io_HBM_interface_15_readData_valid),
    .io_HBM_interface_15_readData_bits_data(SLR0_Mem_io_HBM_interface_15_readData_bits_data),
    .io_HBM_interface_15_readData_bits_id(SLR0_Mem_io_HBM_interface_15_readData_bits_id),
    .io_HBM_interface_15_readData_bits_last(SLR0_Mem_io_HBM_interface_15_readData_bits_last),
    .io_HBM_interface_15_readData_bits_resp(SLR0_Mem_io_HBM_interface_15_readData_bits_resp),
    .io_HBM_interface_16_writeAddr_ready(SLR0_Mem_io_HBM_interface_16_writeAddr_ready),
    .io_HBM_interface_16_writeAddr_valid(SLR0_Mem_io_HBM_interface_16_writeAddr_valid),
    .io_HBM_interface_16_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_16_writeAddr_bits_addr),
    .io_HBM_interface_16_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_16_writeAddr_bits_len),
    .io_HBM_interface_16_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_16_writeAddr_bits_id),
    .io_HBM_interface_16_writeData_ready(SLR0_Mem_io_HBM_interface_16_writeData_ready),
    .io_HBM_interface_16_writeData_valid(SLR0_Mem_io_HBM_interface_16_writeData_valid),
    .io_HBM_interface_16_writeData_bits_data(SLR0_Mem_io_HBM_interface_16_writeData_bits_data),
    .io_HBM_interface_16_writeData_bits_strb(SLR0_Mem_io_HBM_interface_16_writeData_bits_strb),
    .io_HBM_interface_16_writeData_bits_last(SLR0_Mem_io_HBM_interface_16_writeData_bits_last),
    .io_HBM_interface_16_writeResp_ready(SLR0_Mem_io_HBM_interface_16_writeResp_ready),
    .io_HBM_interface_16_writeResp_valid(SLR0_Mem_io_HBM_interface_16_writeResp_valid),
    .io_HBM_interface_16_writeResp_bits_id(SLR0_Mem_io_HBM_interface_16_writeResp_bits_id),
    .io_HBM_interface_16_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_16_writeResp_bits_resp),
    .io_HBM_interface_16_readAddr_ready(SLR0_Mem_io_HBM_interface_16_readAddr_ready),
    .io_HBM_interface_16_readAddr_valid(SLR0_Mem_io_HBM_interface_16_readAddr_valid),
    .io_HBM_interface_16_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_16_readAddr_bits_addr),
    .io_HBM_interface_16_readAddr_bits_len(SLR0_Mem_io_HBM_interface_16_readAddr_bits_len),
    .io_HBM_interface_16_readAddr_bits_id(SLR0_Mem_io_HBM_interface_16_readAddr_bits_id),
    .io_HBM_interface_16_readData_ready(SLR0_Mem_io_HBM_interface_16_readData_ready),
    .io_HBM_interface_16_readData_valid(SLR0_Mem_io_HBM_interface_16_readData_valid),
    .io_HBM_interface_16_readData_bits_data(SLR0_Mem_io_HBM_interface_16_readData_bits_data),
    .io_HBM_interface_16_readData_bits_id(SLR0_Mem_io_HBM_interface_16_readData_bits_id),
    .io_HBM_interface_16_readData_bits_last(SLR0_Mem_io_HBM_interface_16_readData_bits_last),
    .io_HBM_interface_16_readData_bits_resp(SLR0_Mem_io_HBM_interface_16_readData_bits_resp),
    .io_HBM_interface_17_writeAddr_ready(SLR0_Mem_io_HBM_interface_17_writeAddr_ready),
    .io_HBM_interface_17_writeAddr_valid(SLR0_Mem_io_HBM_interface_17_writeAddr_valid),
    .io_HBM_interface_17_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_17_writeAddr_bits_addr),
    .io_HBM_interface_17_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_17_writeAddr_bits_len),
    .io_HBM_interface_17_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_17_writeAddr_bits_id),
    .io_HBM_interface_17_writeData_ready(SLR0_Mem_io_HBM_interface_17_writeData_ready),
    .io_HBM_interface_17_writeData_valid(SLR0_Mem_io_HBM_interface_17_writeData_valid),
    .io_HBM_interface_17_writeData_bits_data(SLR0_Mem_io_HBM_interface_17_writeData_bits_data),
    .io_HBM_interface_17_writeData_bits_strb(SLR0_Mem_io_HBM_interface_17_writeData_bits_strb),
    .io_HBM_interface_17_writeData_bits_last(SLR0_Mem_io_HBM_interface_17_writeData_bits_last),
    .io_HBM_interface_17_writeResp_ready(SLR0_Mem_io_HBM_interface_17_writeResp_ready),
    .io_HBM_interface_17_writeResp_valid(SLR0_Mem_io_HBM_interface_17_writeResp_valid),
    .io_HBM_interface_17_writeResp_bits_id(SLR0_Mem_io_HBM_interface_17_writeResp_bits_id),
    .io_HBM_interface_17_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_17_writeResp_bits_resp),
    .io_HBM_interface_17_readAddr_ready(SLR0_Mem_io_HBM_interface_17_readAddr_ready),
    .io_HBM_interface_17_readAddr_valid(SLR0_Mem_io_HBM_interface_17_readAddr_valid),
    .io_HBM_interface_17_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_17_readAddr_bits_addr),
    .io_HBM_interface_17_readAddr_bits_len(SLR0_Mem_io_HBM_interface_17_readAddr_bits_len),
    .io_HBM_interface_17_readAddr_bits_id(SLR0_Mem_io_HBM_interface_17_readAddr_bits_id),
    .io_HBM_interface_17_readData_ready(SLR0_Mem_io_HBM_interface_17_readData_ready),
    .io_HBM_interface_17_readData_valid(SLR0_Mem_io_HBM_interface_17_readData_valid),
    .io_HBM_interface_17_readData_bits_data(SLR0_Mem_io_HBM_interface_17_readData_bits_data),
    .io_HBM_interface_17_readData_bits_id(SLR0_Mem_io_HBM_interface_17_readData_bits_id),
    .io_HBM_interface_17_readData_bits_last(SLR0_Mem_io_HBM_interface_17_readData_bits_last),
    .io_HBM_interface_17_readData_bits_resp(SLR0_Mem_io_HBM_interface_17_readData_bits_resp),
    .io_HBM_interface_18_writeAddr_ready(SLR0_Mem_io_HBM_interface_18_writeAddr_ready),
    .io_HBM_interface_18_writeAddr_valid(SLR0_Mem_io_HBM_interface_18_writeAddr_valid),
    .io_HBM_interface_18_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_18_writeAddr_bits_addr),
    .io_HBM_interface_18_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_18_writeAddr_bits_len),
    .io_HBM_interface_18_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_18_writeAddr_bits_id),
    .io_HBM_interface_18_writeData_ready(SLR0_Mem_io_HBM_interface_18_writeData_ready),
    .io_HBM_interface_18_writeData_valid(SLR0_Mem_io_HBM_interface_18_writeData_valid),
    .io_HBM_interface_18_writeData_bits_data(SLR0_Mem_io_HBM_interface_18_writeData_bits_data),
    .io_HBM_interface_18_writeData_bits_strb(SLR0_Mem_io_HBM_interface_18_writeData_bits_strb),
    .io_HBM_interface_18_writeData_bits_last(SLR0_Mem_io_HBM_interface_18_writeData_bits_last),
    .io_HBM_interface_18_writeResp_ready(SLR0_Mem_io_HBM_interface_18_writeResp_ready),
    .io_HBM_interface_18_writeResp_valid(SLR0_Mem_io_HBM_interface_18_writeResp_valid),
    .io_HBM_interface_18_writeResp_bits_id(SLR0_Mem_io_HBM_interface_18_writeResp_bits_id),
    .io_HBM_interface_18_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_18_writeResp_bits_resp),
    .io_HBM_interface_18_readAddr_ready(SLR0_Mem_io_HBM_interface_18_readAddr_ready),
    .io_HBM_interface_18_readAddr_valid(SLR0_Mem_io_HBM_interface_18_readAddr_valid),
    .io_HBM_interface_18_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_18_readAddr_bits_addr),
    .io_HBM_interface_18_readAddr_bits_len(SLR0_Mem_io_HBM_interface_18_readAddr_bits_len),
    .io_HBM_interface_18_readAddr_bits_id(SLR0_Mem_io_HBM_interface_18_readAddr_bits_id),
    .io_HBM_interface_18_readData_ready(SLR0_Mem_io_HBM_interface_18_readData_ready),
    .io_HBM_interface_18_readData_valid(SLR0_Mem_io_HBM_interface_18_readData_valid),
    .io_HBM_interface_18_readData_bits_data(SLR0_Mem_io_HBM_interface_18_readData_bits_data),
    .io_HBM_interface_18_readData_bits_id(SLR0_Mem_io_HBM_interface_18_readData_bits_id),
    .io_HBM_interface_18_readData_bits_last(SLR0_Mem_io_HBM_interface_18_readData_bits_last),
    .io_HBM_interface_18_readData_bits_resp(SLR0_Mem_io_HBM_interface_18_readData_bits_resp),
    .io_HBM_interface_19_writeAddr_ready(SLR0_Mem_io_HBM_interface_19_writeAddr_ready),
    .io_HBM_interface_19_writeAddr_valid(SLR0_Mem_io_HBM_interface_19_writeAddr_valid),
    .io_HBM_interface_19_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_19_writeAddr_bits_addr),
    .io_HBM_interface_19_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_19_writeAddr_bits_len),
    .io_HBM_interface_19_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_19_writeAddr_bits_id),
    .io_HBM_interface_19_writeData_ready(SLR0_Mem_io_HBM_interface_19_writeData_ready),
    .io_HBM_interface_19_writeData_valid(SLR0_Mem_io_HBM_interface_19_writeData_valid),
    .io_HBM_interface_19_writeData_bits_data(SLR0_Mem_io_HBM_interface_19_writeData_bits_data),
    .io_HBM_interface_19_writeData_bits_strb(SLR0_Mem_io_HBM_interface_19_writeData_bits_strb),
    .io_HBM_interface_19_writeData_bits_last(SLR0_Mem_io_HBM_interface_19_writeData_bits_last),
    .io_HBM_interface_19_writeResp_ready(SLR0_Mem_io_HBM_interface_19_writeResp_ready),
    .io_HBM_interface_19_writeResp_valid(SLR0_Mem_io_HBM_interface_19_writeResp_valid),
    .io_HBM_interface_19_writeResp_bits_id(SLR0_Mem_io_HBM_interface_19_writeResp_bits_id),
    .io_HBM_interface_19_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_19_writeResp_bits_resp),
    .io_HBM_interface_19_readAddr_ready(SLR0_Mem_io_HBM_interface_19_readAddr_ready),
    .io_HBM_interface_19_readAddr_valid(SLR0_Mem_io_HBM_interface_19_readAddr_valid),
    .io_HBM_interface_19_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_19_readAddr_bits_addr),
    .io_HBM_interface_19_readAddr_bits_len(SLR0_Mem_io_HBM_interface_19_readAddr_bits_len),
    .io_HBM_interface_19_readAddr_bits_id(SLR0_Mem_io_HBM_interface_19_readAddr_bits_id),
    .io_HBM_interface_19_readData_ready(SLR0_Mem_io_HBM_interface_19_readData_ready),
    .io_HBM_interface_19_readData_valid(SLR0_Mem_io_HBM_interface_19_readData_valid),
    .io_HBM_interface_19_readData_bits_data(SLR0_Mem_io_HBM_interface_19_readData_bits_data),
    .io_HBM_interface_19_readData_bits_id(SLR0_Mem_io_HBM_interface_19_readData_bits_id),
    .io_HBM_interface_19_readData_bits_last(SLR0_Mem_io_HBM_interface_19_readData_bits_last),
    .io_HBM_interface_19_readData_bits_resp(SLR0_Mem_io_HBM_interface_19_readData_bits_resp),
    .io_HBM_interface_20_writeAddr_ready(SLR0_Mem_io_HBM_interface_20_writeAddr_ready),
    .io_HBM_interface_20_writeAddr_valid(SLR0_Mem_io_HBM_interface_20_writeAddr_valid),
    .io_HBM_interface_20_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_20_writeAddr_bits_addr),
    .io_HBM_interface_20_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_20_writeAddr_bits_len),
    .io_HBM_interface_20_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_20_writeAddr_bits_id),
    .io_HBM_interface_20_writeData_ready(SLR0_Mem_io_HBM_interface_20_writeData_ready),
    .io_HBM_interface_20_writeData_valid(SLR0_Mem_io_HBM_interface_20_writeData_valid),
    .io_HBM_interface_20_writeData_bits_data(SLR0_Mem_io_HBM_interface_20_writeData_bits_data),
    .io_HBM_interface_20_writeData_bits_strb(SLR0_Mem_io_HBM_interface_20_writeData_bits_strb),
    .io_HBM_interface_20_writeData_bits_last(SLR0_Mem_io_HBM_interface_20_writeData_bits_last),
    .io_HBM_interface_20_writeResp_ready(SLR0_Mem_io_HBM_interface_20_writeResp_ready),
    .io_HBM_interface_20_writeResp_valid(SLR0_Mem_io_HBM_interface_20_writeResp_valid),
    .io_HBM_interface_20_writeResp_bits_id(SLR0_Mem_io_HBM_interface_20_writeResp_bits_id),
    .io_HBM_interface_20_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_20_writeResp_bits_resp),
    .io_HBM_interface_20_readAddr_ready(SLR0_Mem_io_HBM_interface_20_readAddr_ready),
    .io_HBM_interface_20_readAddr_valid(SLR0_Mem_io_HBM_interface_20_readAddr_valid),
    .io_HBM_interface_20_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_20_readAddr_bits_addr),
    .io_HBM_interface_20_readAddr_bits_len(SLR0_Mem_io_HBM_interface_20_readAddr_bits_len),
    .io_HBM_interface_20_readAddr_bits_id(SLR0_Mem_io_HBM_interface_20_readAddr_bits_id),
    .io_HBM_interface_20_readData_ready(SLR0_Mem_io_HBM_interface_20_readData_ready),
    .io_HBM_interface_20_readData_valid(SLR0_Mem_io_HBM_interface_20_readData_valid),
    .io_HBM_interface_20_readData_bits_data(SLR0_Mem_io_HBM_interface_20_readData_bits_data),
    .io_HBM_interface_20_readData_bits_id(SLR0_Mem_io_HBM_interface_20_readData_bits_id),
    .io_HBM_interface_20_readData_bits_last(SLR0_Mem_io_HBM_interface_20_readData_bits_last),
    .io_HBM_interface_20_readData_bits_resp(SLR0_Mem_io_HBM_interface_20_readData_bits_resp),
    .io_HBM_interface_21_writeAddr_ready(SLR0_Mem_io_HBM_interface_21_writeAddr_ready),
    .io_HBM_interface_21_writeAddr_valid(SLR0_Mem_io_HBM_interface_21_writeAddr_valid),
    .io_HBM_interface_21_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_21_writeAddr_bits_addr),
    .io_HBM_interface_21_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_21_writeAddr_bits_len),
    .io_HBM_interface_21_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_21_writeAddr_bits_id),
    .io_HBM_interface_21_writeData_ready(SLR0_Mem_io_HBM_interface_21_writeData_ready),
    .io_HBM_interface_21_writeData_valid(SLR0_Mem_io_HBM_interface_21_writeData_valid),
    .io_HBM_interface_21_writeData_bits_data(SLR0_Mem_io_HBM_interface_21_writeData_bits_data),
    .io_HBM_interface_21_writeData_bits_strb(SLR0_Mem_io_HBM_interface_21_writeData_bits_strb),
    .io_HBM_interface_21_writeData_bits_last(SLR0_Mem_io_HBM_interface_21_writeData_bits_last),
    .io_HBM_interface_21_writeResp_ready(SLR0_Mem_io_HBM_interface_21_writeResp_ready),
    .io_HBM_interface_21_writeResp_valid(SLR0_Mem_io_HBM_interface_21_writeResp_valid),
    .io_HBM_interface_21_writeResp_bits_id(SLR0_Mem_io_HBM_interface_21_writeResp_bits_id),
    .io_HBM_interface_21_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_21_writeResp_bits_resp),
    .io_HBM_interface_21_readAddr_ready(SLR0_Mem_io_HBM_interface_21_readAddr_ready),
    .io_HBM_interface_21_readAddr_valid(SLR0_Mem_io_HBM_interface_21_readAddr_valid),
    .io_HBM_interface_21_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_21_readAddr_bits_addr),
    .io_HBM_interface_21_readAddr_bits_len(SLR0_Mem_io_HBM_interface_21_readAddr_bits_len),
    .io_HBM_interface_21_readAddr_bits_id(SLR0_Mem_io_HBM_interface_21_readAddr_bits_id),
    .io_HBM_interface_21_readData_ready(SLR0_Mem_io_HBM_interface_21_readData_ready),
    .io_HBM_interface_21_readData_valid(SLR0_Mem_io_HBM_interface_21_readData_valid),
    .io_HBM_interface_21_readData_bits_data(SLR0_Mem_io_HBM_interface_21_readData_bits_data),
    .io_HBM_interface_21_readData_bits_id(SLR0_Mem_io_HBM_interface_21_readData_bits_id),
    .io_HBM_interface_21_readData_bits_last(SLR0_Mem_io_HBM_interface_21_readData_bits_last),
    .io_HBM_interface_21_readData_bits_resp(SLR0_Mem_io_HBM_interface_21_readData_bits_resp),
    .io_HBM_interface_22_writeAddr_ready(SLR0_Mem_io_HBM_interface_22_writeAddr_ready),
    .io_HBM_interface_22_writeAddr_valid(SLR0_Mem_io_HBM_interface_22_writeAddr_valid),
    .io_HBM_interface_22_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_22_writeAddr_bits_addr),
    .io_HBM_interface_22_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_22_writeAddr_bits_len),
    .io_HBM_interface_22_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_22_writeAddr_bits_id),
    .io_HBM_interface_22_writeData_ready(SLR0_Mem_io_HBM_interface_22_writeData_ready),
    .io_HBM_interface_22_writeData_valid(SLR0_Mem_io_HBM_interface_22_writeData_valid),
    .io_HBM_interface_22_writeData_bits_data(SLR0_Mem_io_HBM_interface_22_writeData_bits_data),
    .io_HBM_interface_22_writeData_bits_strb(SLR0_Mem_io_HBM_interface_22_writeData_bits_strb),
    .io_HBM_interface_22_writeData_bits_last(SLR0_Mem_io_HBM_interface_22_writeData_bits_last),
    .io_HBM_interface_22_writeResp_ready(SLR0_Mem_io_HBM_interface_22_writeResp_ready),
    .io_HBM_interface_22_writeResp_valid(SLR0_Mem_io_HBM_interface_22_writeResp_valid),
    .io_HBM_interface_22_writeResp_bits_id(SLR0_Mem_io_HBM_interface_22_writeResp_bits_id),
    .io_HBM_interface_22_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_22_writeResp_bits_resp),
    .io_HBM_interface_22_readAddr_ready(SLR0_Mem_io_HBM_interface_22_readAddr_ready),
    .io_HBM_interface_22_readAddr_valid(SLR0_Mem_io_HBM_interface_22_readAddr_valid),
    .io_HBM_interface_22_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_22_readAddr_bits_addr),
    .io_HBM_interface_22_readAddr_bits_len(SLR0_Mem_io_HBM_interface_22_readAddr_bits_len),
    .io_HBM_interface_22_readAddr_bits_id(SLR0_Mem_io_HBM_interface_22_readAddr_bits_id),
    .io_HBM_interface_22_readData_ready(SLR0_Mem_io_HBM_interface_22_readData_ready),
    .io_HBM_interface_22_readData_valid(SLR0_Mem_io_HBM_interface_22_readData_valid),
    .io_HBM_interface_22_readData_bits_data(SLR0_Mem_io_HBM_interface_22_readData_bits_data),
    .io_HBM_interface_22_readData_bits_id(SLR0_Mem_io_HBM_interface_22_readData_bits_id),
    .io_HBM_interface_22_readData_bits_last(SLR0_Mem_io_HBM_interface_22_readData_bits_last),
    .io_HBM_interface_22_readData_bits_resp(SLR0_Mem_io_HBM_interface_22_readData_bits_resp),
    .io_HBM_interface_23_writeAddr_ready(SLR0_Mem_io_HBM_interface_23_writeAddr_ready),
    .io_HBM_interface_23_writeAddr_valid(SLR0_Mem_io_HBM_interface_23_writeAddr_valid),
    .io_HBM_interface_23_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_23_writeAddr_bits_addr),
    .io_HBM_interface_23_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_23_writeAddr_bits_len),
    .io_HBM_interface_23_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_23_writeAddr_bits_id),
    .io_HBM_interface_23_writeData_ready(SLR0_Mem_io_HBM_interface_23_writeData_ready),
    .io_HBM_interface_23_writeData_valid(SLR0_Mem_io_HBM_interface_23_writeData_valid),
    .io_HBM_interface_23_writeData_bits_data(SLR0_Mem_io_HBM_interface_23_writeData_bits_data),
    .io_HBM_interface_23_writeData_bits_strb(SLR0_Mem_io_HBM_interface_23_writeData_bits_strb),
    .io_HBM_interface_23_writeData_bits_last(SLR0_Mem_io_HBM_interface_23_writeData_bits_last),
    .io_HBM_interface_23_writeResp_ready(SLR0_Mem_io_HBM_interface_23_writeResp_ready),
    .io_HBM_interface_23_writeResp_valid(SLR0_Mem_io_HBM_interface_23_writeResp_valid),
    .io_HBM_interface_23_writeResp_bits_id(SLR0_Mem_io_HBM_interface_23_writeResp_bits_id),
    .io_HBM_interface_23_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_23_writeResp_bits_resp),
    .io_HBM_interface_23_readAddr_ready(SLR0_Mem_io_HBM_interface_23_readAddr_ready),
    .io_HBM_interface_23_readAddr_valid(SLR0_Mem_io_HBM_interface_23_readAddr_valid),
    .io_HBM_interface_23_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_23_readAddr_bits_addr),
    .io_HBM_interface_23_readAddr_bits_len(SLR0_Mem_io_HBM_interface_23_readAddr_bits_len),
    .io_HBM_interface_23_readAddr_bits_id(SLR0_Mem_io_HBM_interface_23_readAddr_bits_id),
    .io_HBM_interface_23_readData_ready(SLR0_Mem_io_HBM_interface_23_readData_ready),
    .io_HBM_interface_23_readData_valid(SLR0_Mem_io_HBM_interface_23_readData_valid),
    .io_HBM_interface_23_readData_bits_data(SLR0_Mem_io_HBM_interface_23_readData_bits_data),
    .io_HBM_interface_23_readData_bits_id(SLR0_Mem_io_HBM_interface_23_readData_bits_id),
    .io_HBM_interface_23_readData_bits_last(SLR0_Mem_io_HBM_interface_23_readData_bits_last),
    .io_HBM_interface_23_readData_bits_resp(SLR0_Mem_io_HBM_interface_23_readData_bits_resp),
    .io_HBM_interface_24_writeAddr_ready(SLR0_Mem_io_HBM_interface_24_writeAddr_ready),
    .io_HBM_interface_24_writeAddr_valid(SLR0_Mem_io_HBM_interface_24_writeAddr_valid),
    .io_HBM_interface_24_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_24_writeAddr_bits_addr),
    .io_HBM_interface_24_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_24_writeAddr_bits_len),
    .io_HBM_interface_24_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_24_writeAddr_bits_id),
    .io_HBM_interface_24_writeData_ready(SLR0_Mem_io_HBM_interface_24_writeData_ready),
    .io_HBM_interface_24_writeData_valid(SLR0_Mem_io_HBM_interface_24_writeData_valid),
    .io_HBM_interface_24_writeData_bits_data(SLR0_Mem_io_HBM_interface_24_writeData_bits_data),
    .io_HBM_interface_24_writeData_bits_strb(SLR0_Mem_io_HBM_interface_24_writeData_bits_strb),
    .io_HBM_interface_24_writeData_bits_last(SLR0_Mem_io_HBM_interface_24_writeData_bits_last),
    .io_HBM_interface_24_writeResp_ready(SLR0_Mem_io_HBM_interface_24_writeResp_ready),
    .io_HBM_interface_24_writeResp_valid(SLR0_Mem_io_HBM_interface_24_writeResp_valid),
    .io_HBM_interface_24_writeResp_bits_id(SLR0_Mem_io_HBM_interface_24_writeResp_bits_id),
    .io_HBM_interface_24_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_24_writeResp_bits_resp),
    .io_HBM_interface_24_readAddr_ready(SLR0_Mem_io_HBM_interface_24_readAddr_ready),
    .io_HBM_interface_24_readAddr_valid(SLR0_Mem_io_HBM_interface_24_readAddr_valid),
    .io_HBM_interface_24_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_24_readAddr_bits_addr),
    .io_HBM_interface_24_readAddr_bits_len(SLR0_Mem_io_HBM_interface_24_readAddr_bits_len),
    .io_HBM_interface_24_readAddr_bits_id(SLR0_Mem_io_HBM_interface_24_readAddr_bits_id),
    .io_HBM_interface_24_readData_ready(SLR0_Mem_io_HBM_interface_24_readData_ready),
    .io_HBM_interface_24_readData_valid(SLR0_Mem_io_HBM_interface_24_readData_valid),
    .io_HBM_interface_24_readData_bits_data(SLR0_Mem_io_HBM_interface_24_readData_bits_data),
    .io_HBM_interface_24_readData_bits_id(SLR0_Mem_io_HBM_interface_24_readData_bits_id),
    .io_HBM_interface_24_readData_bits_last(SLR0_Mem_io_HBM_interface_24_readData_bits_last),
    .io_HBM_interface_24_readData_bits_resp(SLR0_Mem_io_HBM_interface_24_readData_bits_resp),
    .io_HBM_interface_25_writeAddr_ready(SLR0_Mem_io_HBM_interface_25_writeAddr_ready),
    .io_HBM_interface_25_writeAddr_valid(SLR0_Mem_io_HBM_interface_25_writeAddr_valid),
    .io_HBM_interface_25_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_25_writeAddr_bits_addr),
    .io_HBM_interface_25_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_25_writeAddr_bits_len),
    .io_HBM_interface_25_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_25_writeAddr_bits_id),
    .io_HBM_interface_25_writeData_ready(SLR0_Mem_io_HBM_interface_25_writeData_ready),
    .io_HBM_interface_25_writeData_valid(SLR0_Mem_io_HBM_interface_25_writeData_valid),
    .io_HBM_interface_25_writeData_bits_data(SLR0_Mem_io_HBM_interface_25_writeData_bits_data),
    .io_HBM_interface_25_writeData_bits_strb(SLR0_Mem_io_HBM_interface_25_writeData_bits_strb),
    .io_HBM_interface_25_writeData_bits_last(SLR0_Mem_io_HBM_interface_25_writeData_bits_last),
    .io_HBM_interface_25_writeResp_ready(SLR0_Mem_io_HBM_interface_25_writeResp_ready),
    .io_HBM_interface_25_writeResp_valid(SLR0_Mem_io_HBM_interface_25_writeResp_valid),
    .io_HBM_interface_25_writeResp_bits_id(SLR0_Mem_io_HBM_interface_25_writeResp_bits_id),
    .io_HBM_interface_25_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_25_writeResp_bits_resp),
    .io_HBM_interface_25_readAddr_ready(SLR0_Mem_io_HBM_interface_25_readAddr_ready),
    .io_HBM_interface_25_readAddr_valid(SLR0_Mem_io_HBM_interface_25_readAddr_valid),
    .io_HBM_interface_25_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_25_readAddr_bits_addr),
    .io_HBM_interface_25_readAddr_bits_len(SLR0_Mem_io_HBM_interface_25_readAddr_bits_len),
    .io_HBM_interface_25_readAddr_bits_id(SLR0_Mem_io_HBM_interface_25_readAddr_bits_id),
    .io_HBM_interface_25_readData_ready(SLR0_Mem_io_HBM_interface_25_readData_ready),
    .io_HBM_interface_25_readData_valid(SLR0_Mem_io_HBM_interface_25_readData_valid),
    .io_HBM_interface_25_readData_bits_data(SLR0_Mem_io_HBM_interface_25_readData_bits_data),
    .io_HBM_interface_25_readData_bits_id(SLR0_Mem_io_HBM_interface_25_readData_bits_id),
    .io_HBM_interface_25_readData_bits_last(SLR0_Mem_io_HBM_interface_25_readData_bits_last),
    .io_HBM_interface_25_readData_bits_resp(SLR0_Mem_io_HBM_interface_25_readData_bits_resp),
    .io_HBM_interface_26_writeAddr_ready(SLR0_Mem_io_HBM_interface_26_writeAddr_ready),
    .io_HBM_interface_26_writeAddr_valid(SLR0_Mem_io_HBM_interface_26_writeAddr_valid),
    .io_HBM_interface_26_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_26_writeAddr_bits_addr),
    .io_HBM_interface_26_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_26_writeAddr_bits_len),
    .io_HBM_interface_26_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_26_writeAddr_bits_id),
    .io_HBM_interface_26_writeData_ready(SLR0_Mem_io_HBM_interface_26_writeData_ready),
    .io_HBM_interface_26_writeData_valid(SLR0_Mem_io_HBM_interface_26_writeData_valid),
    .io_HBM_interface_26_writeData_bits_data(SLR0_Mem_io_HBM_interface_26_writeData_bits_data),
    .io_HBM_interface_26_writeData_bits_strb(SLR0_Mem_io_HBM_interface_26_writeData_bits_strb),
    .io_HBM_interface_26_writeData_bits_last(SLR0_Mem_io_HBM_interface_26_writeData_bits_last),
    .io_HBM_interface_26_writeResp_ready(SLR0_Mem_io_HBM_interface_26_writeResp_ready),
    .io_HBM_interface_26_writeResp_valid(SLR0_Mem_io_HBM_interface_26_writeResp_valid),
    .io_HBM_interface_26_writeResp_bits_id(SLR0_Mem_io_HBM_interface_26_writeResp_bits_id),
    .io_HBM_interface_26_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_26_writeResp_bits_resp),
    .io_HBM_interface_26_readAddr_ready(SLR0_Mem_io_HBM_interface_26_readAddr_ready),
    .io_HBM_interface_26_readAddr_valid(SLR0_Mem_io_HBM_interface_26_readAddr_valid),
    .io_HBM_interface_26_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_26_readAddr_bits_addr),
    .io_HBM_interface_26_readAddr_bits_len(SLR0_Mem_io_HBM_interface_26_readAddr_bits_len),
    .io_HBM_interface_26_readAddr_bits_id(SLR0_Mem_io_HBM_interface_26_readAddr_bits_id),
    .io_HBM_interface_26_readData_ready(SLR0_Mem_io_HBM_interface_26_readData_ready),
    .io_HBM_interface_26_readData_valid(SLR0_Mem_io_HBM_interface_26_readData_valid),
    .io_HBM_interface_26_readData_bits_data(SLR0_Mem_io_HBM_interface_26_readData_bits_data),
    .io_HBM_interface_26_readData_bits_id(SLR0_Mem_io_HBM_interface_26_readData_bits_id),
    .io_HBM_interface_26_readData_bits_last(SLR0_Mem_io_HBM_interface_26_readData_bits_last),
    .io_HBM_interface_26_readData_bits_resp(SLR0_Mem_io_HBM_interface_26_readData_bits_resp),
    .io_HBM_interface_27_writeAddr_ready(SLR0_Mem_io_HBM_interface_27_writeAddr_ready),
    .io_HBM_interface_27_writeAddr_valid(SLR0_Mem_io_HBM_interface_27_writeAddr_valid),
    .io_HBM_interface_27_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_27_writeAddr_bits_addr),
    .io_HBM_interface_27_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_27_writeAddr_bits_len),
    .io_HBM_interface_27_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_27_writeAddr_bits_id),
    .io_HBM_interface_27_writeData_ready(SLR0_Mem_io_HBM_interface_27_writeData_ready),
    .io_HBM_interface_27_writeData_valid(SLR0_Mem_io_HBM_interface_27_writeData_valid),
    .io_HBM_interface_27_writeData_bits_data(SLR0_Mem_io_HBM_interface_27_writeData_bits_data),
    .io_HBM_interface_27_writeData_bits_strb(SLR0_Mem_io_HBM_interface_27_writeData_bits_strb),
    .io_HBM_interface_27_writeData_bits_last(SLR0_Mem_io_HBM_interface_27_writeData_bits_last),
    .io_HBM_interface_27_writeResp_ready(SLR0_Mem_io_HBM_interface_27_writeResp_ready),
    .io_HBM_interface_27_writeResp_valid(SLR0_Mem_io_HBM_interface_27_writeResp_valid),
    .io_HBM_interface_27_writeResp_bits_id(SLR0_Mem_io_HBM_interface_27_writeResp_bits_id),
    .io_HBM_interface_27_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_27_writeResp_bits_resp),
    .io_HBM_interface_27_readAddr_ready(SLR0_Mem_io_HBM_interface_27_readAddr_ready),
    .io_HBM_interface_27_readAddr_valid(SLR0_Mem_io_HBM_interface_27_readAddr_valid),
    .io_HBM_interface_27_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_27_readAddr_bits_addr),
    .io_HBM_interface_27_readAddr_bits_len(SLR0_Mem_io_HBM_interface_27_readAddr_bits_len),
    .io_HBM_interface_27_readAddr_bits_id(SLR0_Mem_io_HBM_interface_27_readAddr_bits_id),
    .io_HBM_interface_27_readData_ready(SLR0_Mem_io_HBM_interface_27_readData_ready),
    .io_HBM_interface_27_readData_valid(SLR0_Mem_io_HBM_interface_27_readData_valid),
    .io_HBM_interface_27_readData_bits_data(SLR0_Mem_io_HBM_interface_27_readData_bits_data),
    .io_HBM_interface_27_readData_bits_id(SLR0_Mem_io_HBM_interface_27_readData_bits_id),
    .io_HBM_interface_27_readData_bits_last(SLR0_Mem_io_HBM_interface_27_readData_bits_last),
    .io_HBM_interface_27_readData_bits_resp(SLR0_Mem_io_HBM_interface_27_readData_bits_resp),
    .io_HBM_interface_28_writeAddr_ready(SLR0_Mem_io_HBM_interface_28_writeAddr_ready),
    .io_HBM_interface_28_writeAddr_valid(SLR0_Mem_io_HBM_interface_28_writeAddr_valid),
    .io_HBM_interface_28_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_28_writeAddr_bits_addr),
    .io_HBM_interface_28_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_28_writeAddr_bits_len),
    .io_HBM_interface_28_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_28_writeAddr_bits_id),
    .io_HBM_interface_28_writeData_ready(SLR0_Mem_io_HBM_interface_28_writeData_ready),
    .io_HBM_interface_28_writeData_valid(SLR0_Mem_io_HBM_interface_28_writeData_valid),
    .io_HBM_interface_28_writeData_bits_data(SLR0_Mem_io_HBM_interface_28_writeData_bits_data),
    .io_HBM_interface_28_writeData_bits_strb(SLR0_Mem_io_HBM_interface_28_writeData_bits_strb),
    .io_HBM_interface_28_writeData_bits_last(SLR0_Mem_io_HBM_interface_28_writeData_bits_last),
    .io_HBM_interface_28_writeResp_ready(SLR0_Mem_io_HBM_interface_28_writeResp_ready),
    .io_HBM_interface_28_writeResp_valid(SLR0_Mem_io_HBM_interface_28_writeResp_valid),
    .io_HBM_interface_28_writeResp_bits_id(SLR0_Mem_io_HBM_interface_28_writeResp_bits_id),
    .io_HBM_interface_28_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_28_writeResp_bits_resp),
    .io_HBM_interface_28_readAddr_ready(SLR0_Mem_io_HBM_interface_28_readAddr_ready),
    .io_HBM_interface_28_readAddr_valid(SLR0_Mem_io_HBM_interface_28_readAddr_valid),
    .io_HBM_interface_28_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_28_readAddr_bits_addr),
    .io_HBM_interface_28_readAddr_bits_len(SLR0_Mem_io_HBM_interface_28_readAddr_bits_len),
    .io_HBM_interface_28_readAddr_bits_id(SLR0_Mem_io_HBM_interface_28_readAddr_bits_id),
    .io_HBM_interface_28_readData_ready(SLR0_Mem_io_HBM_interface_28_readData_ready),
    .io_HBM_interface_28_readData_valid(SLR0_Mem_io_HBM_interface_28_readData_valid),
    .io_HBM_interface_28_readData_bits_data(SLR0_Mem_io_HBM_interface_28_readData_bits_data),
    .io_HBM_interface_28_readData_bits_id(SLR0_Mem_io_HBM_interface_28_readData_bits_id),
    .io_HBM_interface_28_readData_bits_last(SLR0_Mem_io_HBM_interface_28_readData_bits_last),
    .io_HBM_interface_28_readData_bits_resp(SLR0_Mem_io_HBM_interface_28_readData_bits_resp),
    .io_HBM_interface_29_writeAddr_ready(SLR0_Mem_io_HBM_interface_29_writeAddr_ready),
    .io_HBM_interface_29_writeAddr_valid(SLR0_Mem_io_HBM_interface_29_writeAddr_valid),
    .io_HBM_interface_29_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_29_writeAddr_bits_addr),
    .io_HBM_interface_29_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_29_writeAddr_bits_len),
    .io_HBM_interface_29_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_29_writeAddr_bits_id),
    .io_HBM_interface_29_writeData_ready(SLR0_Mem_io_HBM_interface_29_writeData_ready),
    .io_HBM_interface_29_writeData_valid(SLR0_Mem_io_HBM_interface_29_writeData_valid),
    .io_HBM_interface_29_writeData_bits_data(SLR0_Mem_io_HBM_interface_29_writeData_bits_data),
    .io_HBM_interface_29_writeData_bits_strb(SLR0_Mem_io_HBM_interface_29_writeData_bits_strb),
    .io_HBM_interface_29_writeData_bits_last(SLR0_Mem_io_HBM_interface_29_writeData_bits_last),
    .io_HBM_interface_29_writeResp_ready(SLR0_Mem_io_HBM_interface_29_writeResp_ready),
    .io_HBM_interface_29_writeResp_valid(SLR0_Mem_io_HBM_interface_29_writeResp_valid),
    .io_HBM_interface_29_writeResp_bits_id(SLR0_Mem_io_HBM_interface_29_writeResp_bits_id),
    .io_HBM_interface_29_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_29_writeResp_bits_resp),
    .io_HBM_interface_29_readAddr_ready(SLR0_Mem_io_HBM_interface_29_readAddr_ready),
    .io_HBM_interface_29_readAddr_valid(SLR0_Mem_io_HBM_interface_29_readAddr_valid),
    .io_HBM_interface_29_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_29_readAddr_bits_addr),
    .io_HBM_interface_29_readAddr_bits_len(SLR0_Mem_io_HBM_interface_29_readAddr_bits_len),
    .io_HBM_interface_29_readAddr_bits_id(SLR0_Mem_io_HBM_interface_29_readAddr_bits_id),
    .io_HBM_interface_29_readData_ready(SLR0_Mem_io_HBM_interface_29_readData_ready),
    .io_HBM_interface_29_readData_valid(SLR0_Mem_io_HBM_interface_29_readData_valid),
    .io_HBM_interface_29_readData_bits_data(SLR0_Mem_io_HBM_interface_29_readData_bits_data),
    .io_HBM_interface_29_readData_bits_id(SLR0_Mem_io_HBM_interface_29_readData_bits_id),
    .io_HBM_interface_29_readData_bits_last(SLR0_Mem_io_HBM_interface_29_readData_bits_last),
    .io_HBM_interface_29_readData_bits_resp(SLR0_Mem_io_HBM_interface_29_readData_bits_resp),
    .io_HBM_interface_30_writeAddr_ready(SLR0_Mem_io_HBM_interface_30_writeAddr_ready),
    .io_HBM_interface_30_writeAddr_valid(SLR0_Mem_io_HBM_interface_30_writeAddr_valid),
    .io_HBM_interface_30_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_30_writeAddr_bits_addr),
    .io_HBM_interface_30_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_30_writeAddr_bits_len),
    .io_HBM_interface_30_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_30_writeAddr_bits_id),
    .io_HBM_interface_30_writeData_ready(SLR0_Mem_io_HBM_interface_30_writeData_ready),
    .io_HBM_interface_30_writeData_valid(SLR0_Mem_io_HBM_interface_30_writeData_valid),
    .io_HBM_interface_30_writeData_bits_data(SLR0_Mem_io_HBM_interface_30_writeData_bits_data),
    .io_HBM_interface_30_writeData_bits_strb(SLR0_Mem_io_HBM_interface_30_writeData_bits_strb),
    .io_HBM_interface_30_writeData_bits_last(SLR0_Mem_io_HBM_interface_30_writeData_bits_last),
    .io_HBM_interface_30_writeResp_ready(SLR0_Mem_io_HBM_interface_30_writeResp_ready),
    .io_HBM_interface_30_writeResp_valid(SLR0_Mem_io_HBM_interface_30_writeResp_valid),
    .io_HBM_interface_30_writeResp_bits_id(SLR0_Mem_io_HBM_interface_30_writeResp_bits_id),
    .io_HBM_interface_30_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_30_writeResp_bits_resp),
    .io_HBM_interface_30_readAddr_ready(SLR0_Mem_io_HBM_interface_30_readAddr_ready),
    .io_HBM_interface_30_readAddr_valid(SLR0_Mem_io_HBM_interface_30_readAddr_valid),
    .io_HBM_interface_30_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_30_readAddr_bits_addr),
    .io_HBM_interface_30_readAddr_bits_len(SLR0_Mem_io_HBM_interface_30_readAddr_bits_len),
    .io_HBM_interface_30_readAddr_bits_id(SLR0_Mem_io_HBM_interface_30_readAddr_bits_id),
    .io_HBM_interface_30_readData_ready(SLR0_Mem_io_HBM_interface_30_readData_ready),
    .io_HBM_interface_30_readData_valid(SLR0_Mem_io_HBM_interface_30_readData_valid),
    .io_HBM_interface_30_readData_bits_data(SLR0_Mem_io_HBM_interface_30_readData_bits_data),
    .io_HBM_interface_30_readData_bits_id(SLR0_Mem_io_HBM_interface_30_readData_bits_id),
    .io_HBM_interface_30_readData_bits_last(SLR0_Mem_io_HBM_interface_30_readData_bits_last),
    .io_HBM_interface_30_readData_bits_resp(SLR0_Mem_io_HBM_interface_30_readData_bits_resp),
    .io_HBM_interface_31_writeAddr_ready(SLR0_Mem_io_HBM_interface_31_writeAddr_ready),
    .io_HBM_interface_31_writeAddr_valid(SLR0_Mem_io_HBM_interface_31_writeAddr_valid),
    .io_HBM_interface_31_writeAddr_bits_addr(SLR0_Mem_io_HBM_interface_31_writeAddr_bits_addr),
    .io_HBM_interface_31_writeAddr_bits_len(SLR0_Mem_io_HBM_interface_31_writeAddr_bits_len),
    .io_HBM_interface_31_writeAddr_bits_id(SLR0_Mem_io_HBM_interface_31_writeAddr_bits_id),
    .io_HBM_interface_31_writeData_ready(SLR0_Mem_io_HBM_interface_31_writeData_ready),
    .io_HBM_interface_31_writeData_valid(SLR0_Mem_io_HBM_interface_31_writeData_valid),
    .io_HBM_interface_31_writeData_bits_data(SLR0_Mem_io_HBM_interface_31_writeData_bits_data),
    .io_HBM_interface_31_writeData_bits_strb(SLR0_Mem_io_HBM_interface_31_writeData_bits_strb),
    .io_HBM_interface_31_writeData_bits_last(SLR0_Mem_io_HBM_interface_31_writeData_bits_last),
    .io_HBM_interface_31_writeResp_ready(SLR0_Mem_io_HBM_interface_31_writeResp_ready),
    .io_HBM_interface_31_writeResp_valid(SLR0_Mem_io_HBM_interface_31_writeResp_valid),
    .io_HBM_interface_31_writeResp_bits_id(SLR0_Mem_io_HBM_interface_31_writeResp_bits_id),
    .io_HBM_interface_31_writeResp_bits_resp(SLR0_Mem_io_HBM_interface_31_writeResp_bits_resp),
    .io_HBM_interface_31_readAddr_ready(SLR0_Mem_io_HBM_interface_31_readAddr_ready),
    .io_HBM_interface_31_readAddr_valid(SLR0_Mem_io_HBM_interface_31_readAddr_valid),
    .io_HBM_interface_31_readAddr_bits_addr(SLR0_Mem_io_HBM_interface_31_readAddr_bits_addr),
    .io_HBM_interface_31_readAddr_bits_len(SLR0_Mem_io_HBM_interface_31_readAddr_bits_len),
    .io_HBM_interface_31_readAddr_bits_id(SLR0_Mem_io_HBM_interface_31_readAddr_bits_id),
    .io_HBM_interface_31_readData_ready(SLR0_Mem_io_HBM_interface_31_readData_ready),
    .io_HBM_interface_31_readData_valid(SLR0_Mem_io_HBM_interface_31_readData_valid),
    .io_HBM_interface_31_readData_bits_data(SLR0_Mem_io_HBM_interface_31_readData_bits_data),
    .io_HBM_interface_31_readData_bits_id(SLR0_Mem_io_HBM_interface_31_readData_bits_id),
    .io_HBM_interface_31_readData_bits_last(SLR0_Mem_io_HBM_interface_31_readData_bits_last),
    .io_HBM_interface_31_readData_bits_resp(SLR0_Mem_io_HBM_interface_31_readData_bits_resp)
  );
  SLR1 SLR1 ( // @[Top-slr.scala 51:22]
    .clock(SLR1_clock),
    .reset(SLR1_reset),
    .io_p2_end(SLR1_io_p2_end),
    .io_start(SLR1_io_start),
    .io_frontier_flag(SLR1_io_frontier_flag),
    .io_level(SLR1_io_level),
    .io_offsets_CSR_R_offset(SLR1_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(SLR1_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(SLR1_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(SLR1_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(SLR1_io_offsets_level_offset),
    .io_node_num(SLR1_io_node_num),
    .io_root(SLR1_io_root),
    .io_push_or_pull(SLR1_io_push_or_pull),
    .io_start_init(SLR1_io_start_init),
    .io_end_0(SLR1_io_end_0),
    .io_end_1(SLR1_io_end_1),
    .io_end_2(SLR1_io_end_2),
    .io_end_3(SLR1_io_end_3),
    .io_end_4(SLR1_io_end_4),
    .io_end_5(SLR1_io_end_5),
    .io_end_6(SLR1_io_end_6),
    .io_end_7(SLR1_io_end_7),
    .io_end_8(SLR1_io_end_8),
    .io_end_9(SLR1_io_end_9),
    .io_end_10(SLR1_io_end_10),
    .io_end_11(SLR1_io_end_11),
    .io_end_12(SLR1_io_end_12),
    .io_end_13(SLR1_io_end_13),
    .io_p2_count_0(SLR1_io_p2_count_0),
    .io_p2_count_1(SLR1_io_p2_count_1),
    .io_p2_count_2(SLR1_io_p2_count_2),
    .io_p2_count_3(SLR1_io_p2_count_3),
    .io_p2_count_4(SLR1_io_p2_count_4),
    .io_p2_count_5(SLR1_io_p2_count_5),
    .io_p2_count_6(SLR1_io_p2_count_6),
    .io_p2_count_7(SLR1_io_p2_count_7),
    .io_p2_count_8(SLR1_io_p2_count_8),
    .io_p2_count_9(SLR1_io_p2_count_9),
    .io_p2_count_10(SLR1_io_p2_count_10),
    .io_p2_count_11(SLR1_io_p2_count_11),
    .io_p2_count_12(SLR1_io_p2_count_12),
    .io_p2_count_13(SLR1_io_p2_count_13),
    .io_p2_pull_count_0(SLR1_io_p2_pull_count_0),
    .io_p2_pull_count_1(SLR1_io_p2_pull_count_1),
    .io_p2_pull_count_2(SLR1_io_p2_pull_count_2),
    .io_p2_pull_count_3(SLR1_io_p2_pull_count_3),
    .io_p2_pull_count_4(SLR1_io_p2_pull_count_4),
    .io_p2_pull_count_5(SLR1_io_p2_pull_count_5),
    .io_p2_pull_count_6(SLR1_io_p2_pull_count_6),
    .io_p2_pull_count_7(SLR1_io_p2_pull_count_7),
    .io_p2_pull_count_8(SLR1_io_p2_pull_count_8),
    .io_p2_pull_count_9(SLR1_io_p2_pull_count_9),
    .io_p2_pull_count_10(SLR1_io_p2_pull_count_10),
    .io_p2_pull_count_11(SLR1_io_p2_pull_count_11),
    .io_p2_pull_count_12(SLR1_io_p2_pull_count_12),
    .io_p2_pull_count_13(SLR1_io_p2_pull_count_13),
    .io_frontier_pull_count_0(SLR1_io_frontier_pull_count_0),
    .io_frontier_pull_count_1(SLR1_io_frontier_pull_count_1),
    .io_frontier_pull_count_2(SLR1_io_frontier_pull_count_2),
    .io_frontier_pull_count_3(SLR1_io_frontier_pull_count_3),
    .io_frontier_pull_count_4(SLR1_io_frontier_pull_count_4),
    .io_frontier_pull_count_5(SLR1_io_frontier_pull_count_5),
    .io_frontier_pull_count_6(SLR1_io_frontier_pull_count_6),
    .io_frontier_pull_count_7(SLR1_io_frontier_pull_count_7),
    .io_frontier_pull_count_8(SLR1_io_frontier_pull_count_8),
    .io_frontier_pull_count_9(SLR1_io_frontier_pull_count_9),
    .io_frontier_pull_count_10(SLR1_io_frontier_pull_count_10),
    .io_frontier_pull_count_11(SLR1_io_frontier_pull_count_11),
    .io_frontier_pull_count_12(SLR1_io_frontier_pull_count_12),
    .io_frontier_pull_count_13(SLR1_io_frontier_pull_count_13),
    .io_last_iteration_0(SLR1_io_last_iteration_0),
    .io_last_iteration_1(SLR1_io_last_iteration_1),
    .io_last_iteration_2(SLR1_io_last_iteration_2),
    .io_last_iteration_3(SLR1_io_last_iteration_3),
    .io_last_iteration_4(SLR1_io_last_iteration_4),
    .io_last_iteration_5(SLR1_io_last_iteration_5),
    .io_last_iteration_6(SLR1_io_last_iteration_6),
    .io_last_iteration_7(SLR1_io_last_iteration_7),
    .io_last_iteration_8(SLR1_io_last_iteration_8),
    .io_last_iteration_9(SLR1_io_last_iteration_9),
    .io_last_iteration_10(SLR1_io_last_iteration_10),
    .io_last_iteration_11(SLR1_io_last_iteration_11),
    .io_last_iteration_12(SLR1_io_last_iteration_12),
    .io_last_iteration_13(SLR1_io_last_iteration_13),
    .io_init_bram_0(SLR1_io_init_bram_0),
    .io_init_bram_1(SLR1_io_init_bram_1),
    .io_init_bram_2(SLR1_io_init_bram_2),
    .io_init_bram_3(SLR1_io_init_bram_3),
    .io_init_bram_4(SLR1_io_init_bram_4),
    .io_init_bram_5(SLR1_io_init_bram_5),
    .io_init_bram_6(SLR1_io_init_bram_6),
    .io_init_bram_7(SLR1_io_init_bram_7),
    .io_init_bram_8(SLR1_io_init_bram_8),
    .io_init_bram_9(SLR1_io_init_bram_9),
    .io_init_bram_10(SLR1_io_init_bram_10),
    .io_init_bram_11(SLR1_io_init_bram_11),
    .io_init_bram_12(SLR1_io_init_bram_12),
    .io_init_bram_13(SLR1_io_init_bram_13),
    .io_p2_in_0_ready(SLR1_io_p2_in_0_ready),
    .io_p2_in_0_valid(SLR1_io_p2_in_0_valid),
    .io_p2_in_0_bits(SLR1_io_p2_in_0_bits),
    .io_p2_in_1_ready(SLR1_io_p2_in_1_ready),
    .io_p2_in_1_valid(SLR1_io_p2_in_1_valid),
    .io_p2_in_1_bits(SLR1_io_p2_in_1_bits),
    .io_p2_in_2_ready(SLR1_io_p2_in_2_ready),
    .io_p2_in_2_valid(SLR1_io_p2_in_2_valid),
    .io_p2_in_2_bits(SLR1_io_p2_in_2_bits),
    .io_p2_in_3_ready(SLR1_io_p2_in_3_ready),
    .io_p2_in_3_valid(SLR1_io_p2_in_3_valid),
    .io_p2_in_3_bits(SLR1_io_p2_in_3_bits),
    .io_p2_in_4_ready(SLR1_io_p2_in_4_ready),
    .io_p2_in_4_valid(SLR1_io_p2_in_4_valid),
    .io_p2_in_4_bits(SLR1_io_p2_in_4_bits),
    .io_p2_in_5_ready(SLR1_io_p2_in_5_ready),
    .io_p2_in_5_valid(SLR1_io_p2_in_5_valid),
    .io_p2_in_5_bits(SLR1_io_p2_in_5_bits),
    .io_p2_in_6_ready(SLR1_io_p2_in_6_ready),
    .io_p2_in_6_valid(SLR1_io_p2_in_6_valid),
    .io_p2_in_6_bits(SLR1_io_p2_in_6_bits),
    .io_p2_in_7_ready(SLR1_io_p2_in_7_ready),
    .io_p2_in_7_valid(SLR1_io_p2_in_7_valid),
    .io_p2_in_7_bits(SLR1_io_p2_in_7_bits),
    .io_p2_in_8_ready(SLR1_io_p2_in_8_ready),
    .io_p2_in_8_valid(SLR1_io_p2_in_8_valid),
    .io_p2_in_8_bits(SLR1_io_p2_in_8_bits),
    .io_p2_in_9_ready(SLR1_io_p2_in_9_ready),
    .io_p2_in_9_valid(SLR1_io_p2_in_9_valid),
    .io_p2_in_9_bits(SLR1_io_p2_in_9_bits),
    .io_p2_in_10_ready(SLR1_io_p2_in_10_ready),
    .io_p2_in_10_valid(SLR1_io_p2_in_10_valid),
    .io_p2_in_10_bits(SLR1_io_p2_in_10_bits),
    .io_p2_in_11_ready(SLR1_io_p2_in_11_ready),
    .io_p2_in_11_valid(SLR1_io_p2_in_11_valid),
    .io_p2_in_11_bits(SLR1_io_p2_in_11_bits),
    .io_p2_in_12_ready(SLR1_io_p2_in_12_ready),
    .io_p2_in_12_valid(SLR1_io_p2_in_12_valid),
    .io_p2_in_12_bits(SLR1_io_p2_in_12_bits),
    .io_p2_in_13_ready(SLR1_io_p2_in_13_ready),
    .io_p2_in_13_valid(SLR1_io_p2_in_13_valid),
    .io_p2_in_13_bits(SLR1_io_p2_in_13_bits),
    .io_p2_in_14_ready(SLR1_io_p2_in_14_ready),
    .io_p2_in_14_valid(SLR1_io_p2_in_14_valid),
    .io_p2_in_14_bits(SLR1_io_p2_in_14_bits),
    .io_p2_in_15_ready(SLR1_io_p2_in_15_ready),
    .io_p2_in_15_valid(SLR1_io_p2_in_15_valid),
    .io_p2_in_15_bits(SLR1_io_p2_in_15_bits),
    .io_p2_in_16_ready(SLR1_io_p2_in_16_ready),
    .io_p2_in_16_valid(SLR1_io_p2_in_16_valid),
    .io_p2_in_16_bits(SLR1_io_p2_in_16_bits),
    .io_p2_in_17_ready(SLR1_io_p2_in_17_ready),
    .io_p2_in_17_valid(SLR1_io_p2_in_17_valid),
    .io_p2_in_17_bits(SLR1_io_p2_in_17_bits),
    .io_p2_in_18_ready(SLR1_io_p2_in_18_ready),
    .io_p2_in_18_valid(SLR1_io_p2_in_18_valid),
    .io_p2_in_18_bits(SLR1_io_p2_in_18_bits),
    .io_p2_in_19_ready(SLR1_io_p2_in_19_ready),
    .io_p2_in_19_valid(SLR1_io_p2_in_19_valid),
    .io_p2_in_19_bits(SLR1_io_p2_in_19_bits),
    .io_p2_in_20_ready(SLR1_io_p2_in_20_ready),
    .io_p2_in_20_valid(SLR1_io_p2_in_20_valid),
    .io_p2_in_20_bits(SLR1_io_p2_in_20_bits),
    .io_p2_in_21_ready(SLR1_io_p2_in_21_ready),
    .io_p2_in_21_valid(SLR1_io_p2_in_21_valid),
    .io_p2_in_21_bits(SLR1_io_p2_in_21_bits),
    .io_p2_in_22_ready(SLR1_io_p2_in_22_ready),
    .io_p2_in_22_valid(SLR1_io_p2_in_22_valid),
    .io_p2_in_22_bits(SLR1_io_p2_in_22_bits),
    .io_p2_in_23_ready(SLR1_io_p2_in_23_ready),
    .io_p2_in_23_valid(SLR1_io_p2_in_23_valid),
    .io_p2_in_23_bits(SLR1_io_p2_in_23_bits),
    .io_p2_in_24_ready(SLR1_io_p2_in_24_ready),
    .io_p2_in_24_valid(SLR1_io_p2_in_24_valid),
    .io_p2_in_24_bits(SLR1_io_p2_in_24_bits),
    .io_p2_in_25_ready(SLR1_io_p2_in_25_ready),
    .io_p2_in_25_valid(SLR1_io_p2_in_25_valid),
    .io_p2_in_25_bits(SLR1_io_p2_in_25_bits),
    .io_p2_in_26_ready(SLR1_io_p2_in_26_ready),
    .io_p2_in_26_valid(SLR1_io_p2_in_26_valid),
    .io_p2_in_26_bits(SLR1_io_p2_in_26_bits),
    .io_p2_in_27_ready(SLR1_io_p2_in_27_ready),
    .io_p2_in_27_valid(SLR1_io_p2_in_27_valid),
    .io_p2_in_27_bits(SLR1_io_p2_in_27_bits),
    .io_p2_in_28_ready(SLR1_io_p2_in_28_ready),
    .io_p2_in_28_valid(SLR1_io_p2_in_28_valid),
    .io_p2_in_28_bits(SLR1_io_p2_in_28_bits),
    .io_p2_in_29_ready(SLR1_io_p2_in_29_ready),
    .io_p2_in_29_valid(SLR1_io_p2_in_29_valid),
    .io_p2_in_29_bits(SLR1_io_p2_in_29_bits),
    .io_p2_in_30_ready(SLR1_io_p2_in_30_ready),
    .io_p2_in_30_valid(SLR1_io_p2_in_30_valid),
    .io_p2_in_30_bits(SLR1_io_p2_in_30_bits),
    .io_p2_in_31_ready(SLR1_io_p2_in_31_ready),
    .io_p2_in_31_valid(SLR1_io_p2_in_31_valid),
    .io_p2_in_31_bits(SLR1_io_p2_in_31_bits),
    .io_p2_in_32_ready(SLR1_io_p2_in_32_ready),
    .io_p2_in_32_valid(SLR1_io_p2_in_32_valid),
    .io_p2_in_32_bits(SLR1_io_p2_in_32_bits),
    .io_p2_in_33_ready(SLR1_io_p2_in_33_ready),
    .io_p2_in_33_valid(SLR1_io_p2_in_33_valid),
    .io_p2_in_33_bits(SLR1_io_p2_in_33_bits),
    .io_p2_in_34_ready(SLR1_io_p2_in_34_ready),
    .io_p2_in_34_valid(SLR1_io_p2_in_34_valid),
    .io_p2_in_34_bits(SLR1_io_p2_in_34_bits),
    .io_p2_in_35_ready(SLR1_io_p2_in_35_ready),
    .io_p2_in_35_valid(SLR1_io_p2_in_35_valid),
    .io_p2_in_35_bits(SLR1_io_p2_in_35_bits),
    .io_p2_in_36_ready(SLR1_io_p2_in_36_ready),
    .io_p2_in_36_valid(SLR1_io_p2_in_36_valid),
    .io_p2_in_36_bits(SLR1_io_p2_in_36_bits),
    .io_p2_in_37_ready(SLR1_io_p2_in_37_ready),
    .io_p2_in_37_valid(SLR1_io_p2_in_37_valid),
    .io_p2_in_37_bits(SLR1_io_p2_in_37_bits),
    .io_p2_in_38_ready(SLR1_io_p2_in_38_ready),
    .io_p2_in_38_valid(SLR1_io_p2_in_38_valid),
    .io_p2_in_38_bits(SLR1_io_p2_in_38_bits),
    .io_p2_in_39_ready(SLR1_io_p2_in_39_ready),
    .io_p2_in_39_valid(SLR1_io_p2_in_39_valid),
    .io_p2_in_39_bits(SLR1_io_p2_in_39_bits),
    .io_p2_in_40_ready(SLR1_io_p2_in_40_ready),
    .io_p2_in_40_valid(SLR1_io_p2_in_40_valid),
    .io_p2_in_40_bits(SLR1_io_p2_in_40_bits),
    .io_p2_in_41_ready(SLR1_io_p2_in_41_ready),
    .io_p2_in_41_valid(SLR1_io_p2_in_41_valid),
    .io_p2_in_41_bits(SLR1_io_p2_in_41_bits),
    .io_p2_in_42_ready(SLR1_io_p2_in_42_ready),
    .io_p2_in_42_valid(SLR1_io_p2_in_42_valid),
    .io_p2_in_42_bits(SLR1_io_p2_in_42_bits),
    .io_p2_in_43_ready(SLR1_io_p2_in_43_ready),
    .io_p2_in_43_valid(SLR1_io_p2_in_43_valid),
    .io_p2_in_43_bits(SLR1_io_p2_in_43_bits),
    .io_p2_in_44_ready(SLR1_io_p2_in_44_ready),
    .io_p2_in_44_valid(SLR1_io_p2_in_44_valid),
    .io_p2_in_44_bits(SLR1_io_p2_in_44_bits),
    .io_p2_in_45_ready(SLR1_io_p2_in_45_ready),
    .io_p2_in_45_valid(SLR1_io_p2_in_45_valid),
    .io_p2_in_45_bits(SLR1_io_p2_in_45_bits),
    .io_p2_in_46_ready(SLR1_io_p2_in_46_ready),
    .io_p2_in_46_valid(SLR1_io_p2_in_46_valid),
    .io_p2_in_46_bits(SLR1_io_p2_in_46_bits),
    .io_p2_in_47_ready(SLR1_io_p2_in_47_ready),
    .io_p2_in_47_valid(SLR1_io_p2_in_47_valid),
    .io_p2_in_47_bits(SLR1_io_p2_in_47_bits),
    .io_p2_in_48_ready(SLR1_io_p2_in_48_ready),
    .io_p2_in_48_valid(SLR1_io_p2_in_48_valid),
    .io_p2_in_48_bits(SLR1_io_p2_in_48_bits),
    .io_p2_in_49_ready(SLR1_io_p2_in_49_ready),
    .io_p2_in_49_valid(SLR1_io_p2_in_49_valid),
    .io_p2_in_49_bits(SLR1_io_p2_in_49_bits),
    .io_p2_in_50_ready(SLR1_io_p2_in_50_ready),
    .io_p2_in_50_valid(SLR1_io_p2_in_50_valid),
    .io_p2_in_50_bits(SLR1_io_p2_in_50_bits),
    .io_p2_in_51_ready(SLR1_io_p2_in_51_ready),
    .io_p2_in_51_valid(SLR1_io_p2_in_51_valid),
    .io_p2_in_51_bits(SLR1_io_p2_in_51_bits),
    .io_p2_in_52_ready(SLR1_io_p2_in_52_ready),
    .io_p2_in_52_valid(SLR1_io_p2_in_52_valid),
    .io_p2_in_52_bits(SLR1_io_p2_in_52_bits),
    .io_p2_in_53_ready(SLR1_io_p2_in_53_ready),
    .io_p2_in_53_valid(SLR1_io_p2_in_53_valid),
    .io_p2_in_53_bits(SLR1_io_p2_in_53_bits),
    .io_p2_in_54_ready(SLR1_io_p2_in_54_ready),
    .io_p2_in_54_valid(SLR1_io_p2_in_54_valid),
    .io_p2_in_54_bits(SLR1_io_p2_in_54_bits),
    .io_p2_in_55_ready(SLR1_io_p2_in_55_ready),
    .io_p2_in_55_valid(SLR1_io_p2_in_55_valid),
    .io_p2_in_55_bits(SLR1_io_p2_in_55_bits),
    .io_frontier_in_0_ready(SLR1_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(SLR1_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(SLR1_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(SLR1_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(SLR1_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(SLR1_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(SLR1_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(SLR1_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(SLR1_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(SLR1_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(SLR1_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(SLR1_io_frontier_in_3_bits),
    .io_frontier_in_4_ready(SLR1_io_frontier_in_4_ready),
    .io_frontier_in_4_valid(SLR1_io_frontier_in_4_valid),
    .io_frontier_in_4_bits(SLR1_io_frontier_in_4_bits),
    .io_frontier_in_5_ready(SLR1_io_frontier_in_5_ready),
    .io_frontier_in_5_valid(SLR1_io_frontier_in_5_valid),
    .io_frontier_in_5_bits(SLR1_io_frontier_in_5_bits),
    .io_frontier_in_6_ready(SLR1_io_frontier_in_6_ready),
    .io_frontier_in_6_valid(SLR1_io_frontier_in_6_valid),
    .io_frontier_in_6_bits(SLR1_io_frontier_in_6_bits),
    .io_frontier_in_7_ready(SLR1_io_frontier_in_7_ready),
    .io_frontier_in_7_valid(SLR1_io_frontier_in_7_valid),
    .io_frontier_in_7_bits(SLR1_io_frontier_in_7_bits),
    .io_frontier_in_8_ready(SLR1_io_frontier_in_8_ready),
    .io_frontier_in_8_valid(SLR1_io_frontier_in_8_valid),
    .io_frontier_in_8_bits(SLR1_io_frontier_in_8_bits),
    .io_frontier_in_9_ready(SLR1_io_frontier_in_9_ready),
    .io_frontier_in_9_valid(SLR1_io_frontier_in_9_valid),
    .io_frontier_in_9_bits(SLR1_io_frontier_in_9_bits),
    .io_frontier_in_10_ready(SLR1_io_frontier_in_10_ready),
    .io_frontier_in_10_valid(SLR1_io_frontier_in_10_valid),
    .io_frontier_in_10_bits(SLR1_io_frontier_in_10_bits),
    .io_frontier_in_11_ready(SLR1_io_frontier_in_11_ready),
    .io_frontier_in_11_valid(SLR1_io_frontier_in_11_valid),
    .io_frontier_in_11_bits(SLR1_io_frontier_in_11_bits),
    .io_frontier_in_12_ready(SLR1_io_frontier_in_12_ready),
    .io_frontier_in_12_valid(SLR1_io_frontier_in_12_valid),
    .io_frontier_in_12_bits(SLR1_io_frontier_in_12_bits),
    .io_frontier_in_13_ready(SLR1_io_frontier_in_13_ready),
    .io_frontier_in_13_valid(SLR1_io_frontier_in_13_valid),
    .io_frontier_in_13_bits(SLR1_io_frontier_in_13_bits),
    .io_frontier_in_14_ready(SLR1_io_frontier_in_14_ready),
    .io_frontier_in_14_valid(SLR1_io_frontier_in_14_valid),
    .io_frontier_in_14_bits(SLR1_io_frontier_in_14_bits),
    .io_frontier_in_15_ready(SLR1_io_frontier_in_15_ready),
    .io_frontier_in_15_valid(SLR1_io_frontier_in_15_valid),
    .io_frontier_in_15_bits(SLR1_io_frontier_in_15_bits),
    .io_frontier_in_16_ready(SLR1_io_frontier_in_16_ready),
    .io_frontier_in_16_valid(SLR1_io_frontier_in_16_valid),
    .io_frontier_in_16_bits(SLR1_io_frontier_in_16_bits),
    .io_frontier_in_17_ready(SLR1_io_frontier_in_17_ready),
    .io_frontier_in_17_valid(SLR1_io_frontier_in_17_valid),
    .io_frontier_in_17_bits(SLR1_io_frontier_in_17_bits),
    .io_frontier_in_18_ready(SLR1_io_frontier_in_18_ready),
    .io_frontier_in_18_valid(SLR1_io_frontier_in_18_valid),
    .io_frontier_in_18_bits(SLR1_io_frontier_in_18_bits),
    .io_frontier_in_19_ready(SLR1_io_frontier_in_19_ready),
    .io_frontier_in_19_valid(SLR1_io_frontier_in_19_valid),
    .io_frontier_in_19_bits(SLR1_io_frontier_in_19_bits),
    .io_frontier_in_20_ready(SLR1_io_frontier_in_20_ready),
    .io_frontier_in_20_valid(SLR1_io_frontier_in_20_valid),
    .io_frontier_in_20_bits(SLR1_io_frontier_in_20_bits),
    .io_frontier_in_21_ready(SLR1_io_frontier_in_21_ready),
    .io_frontier_in_21_valid(SLR1_io_frontier_in_21_valid),
    .io_frontier_in_21_bits(SLR1_io_frontier_in_21_bits),
    .io_frontier_in_22_ready(SLR1_io_frontier_in_22_ready),
    .io_frontier_in_22_valid(SLR1_io_frontier_in_22_valid),
    .io_frontier_in_22_bits(SLR1_io_frontier_in_22_bits),
    .io_frontier_in_23_ready(SLR1_io_frontier_in_23_ready),
    .io_frontier_in_23_valid(SLR1_io_frontier_in_23_valid),
    .io_frontier_in_23_bits(SLR1_io_frontier_in_23_bits),
    .io_frontier_in_24_ready(SLR1_io_frontier_in_24_ready),
    .io_frontier_in_24_valid(SLR1_io_frontier_in_24_valid),
    .io_frontier_in_24_bits(SLR1_io_frontier_in_24_bits),
    .io_frontier_in_25_ready(SLR1_io_frontier_in_25_ready),
    .io_frontier_in_25_valid(SLR1_io_frontier_in_25_valid),
    .io_frontier_in_25_bits(SLR1_io_frontier_in_25_bits),
    .io_frontier_in_26_ready(SLR1_io_frontier_in_26_ready),
    .io_frontier_in_26_valid(SLR1_io_frontier_in_26_valid),
    .io_frontier_in_26_bits(SLR1_io_frontier_in_26_bits),
    .io_frontier_in_27_ready(SLR1_io_frontier_in_27_ready),
    .io_frontier_in_27_valid(SLR1_io_frontier_in_27_valid),
    .io_frontier_in_27_bits(SLR1_io_frontier_in_27_bits),
    .io_frontier_in_28_ready(SLR1_io_frontier_in_28_ready),
    .io_frontier_in_28_valid(SLR1_io_frontier_in_28_valid),
    .io_frontier_in_28_bits(SLR1_io_frontier_in_28_bits),
    .io_frontier_in_29_ready(SLR1_io_frontier_in_29_ready),
    .io_frontier_in_29_valid(SLR1_io_frontier_in_29_valid),
    .io_frontier_in_29_bits(SLR1_io_frontier_in_29_bits),
    .io_frontier_in_30_ready(SLR1_io_frontier_in_30_ready),
    .io_frontier_in_30_valid(SLR1_io_frontier_in_30_valid),
    .io_frontier_in_30_bits(SLR1_io_frontier_in_30_bits),
    .io_frontier_in_31_ready(SLR1_io_frontier_in_31_ready),
    .io_frontier_in_31_valid(SLR1_io_frontier_in_31_valid),
    .io_frontier_in_31_bits(SLR1_io_frontier_in_31_bits),
    .io_frontier_in_32_ready(SLR1_io_frontier_in_32_ready),
    .io_frontier_in_32_valid(SLR1_io_frontier_in_32_valid),
    .io_frontier_in_32_bits(SLR1_io_frontier_in_32_bits),
    .io_frontier_in_33_ready(SLR1_io_frontier_in_33_ready),
    .io_frontier_in_33_valid(SLR1_io_frontier_in_33_valid),
    .io_frontier_in_33_bits(SLR1_io_frontier_in_33_bits),
    .io_frontier_in_34_ready(SLR1_io_frontier_in_34_ready),
    .io_frontier_in_34_valid(SLR1_io_frontier_in_34_valid),
    .io_frontier_in_34_bits(SLR1_io_frontier_in_34_bits),
    .io_frontier_in_35_ready(SLR1_io_frontier_in_35_ready),
    .io_frontier_in_35_valid(SLR1_io_frontier_in_35_valid),
    .io_frontier_in_35_bits(SLR1_io_frontier_in_35_bits),
    .io_frontier_in_36_ready(SLR1_io_frontier_in_36_ready),
    .io_frontier_in_36_valid(SLR1_io_frontier_in_36_valid),
    .io_frontier_in_36_bits(SLR1_io_frontier_in_36_bits),
    .io_frontier_in_37_ready(SLR1_io_frontier_in_37_ready),
    .io_frontier_in_37_valid(SLR1_io_frontier_in_37_valid),
    .io_frontier_in_37_bits(SLR1_io_frontier_in_37_bits),
    .io_frontier_in_38_ready(SLR1_io_frontier_in_38_ready),
    .io_frontier_in_38_valid(SLR1_io_frontier_in_38_valid),
    .io_frontier_in_38_bits(SLR1_io_frontier_in_38_bits),
    .io_frontier_in_39_ready(SLR1_io_frontier_in_39_ready),
    .io_frontier_in_39_valid(SLR1_io_frontier_in_39_valid),
    .io_frontier_in_39_bits(SLR1_io_frontier_in_39_bits),
    .io_frontier_in_40_ready(SLR1_io_frontier_in_40_ready),
    .io_frontier_in_40_valid(SLR1_io_frontier_in_40_valid),
    .io_frontier_in_40_bits(SLR1_io_frontier_in_40_bits),
    .io_frontier_in_41_ready(SLR1_io_frontier_in_41_ready),
    .io_frontier_in_41_valid(SLR1_io_frontier_in_41_valid),
    .io_frontier_in_41_bits(SLR1_io_frontier_in_41_bits),
    .io_frontier_in_42_ready(SLR1_io_frontier_in_42_ready),
    .io_frontier_in_42_valid(SLR1_io_frontier_in_42_valid),
    .io_frontier_in_42_bits(SLR1_io_frontier_in_42_bits),
    .io_frontier_in_43_ready(SLR1_io_frontier_in_43_ready),
    .io_frontier_in_43_valid(SLR1_io_frontier_in_43_valid),
    .io_frontier_in_43_bits(SLR1_io_frontier_in_43_bits),
    .io_frontier_in_44_ready(SLR1_io_frontier_in_44_ready),
    .io_frontier_in_44_valid(SLR1_io_frontier_in_44_valid),
    .io_frontier_in_44_bits(SLR1_io_frontier_in_44_bits),
    .io_frontier_in_45_ready(SLR1_io_frontier_in_45_ready),
    .io_frontier_in_45_valid(SLR1_io_frontier_in_45_valid),
    .io_frontier_in_45_bits(SLR1_io_frontier_in_45_bits),
    .io_frontier_in_46_ready(SLR1_io_frontier_in_46_ready),
    .io_frontier_in_46_valid(SLR1_io_frontier_in_46_valid),
    .io_frontier_in_46_bits(SLR1_io_frontier_in_46_bits),
    .io_frontier_in_47_ready(SLR1_io_frontier_in_47_ready),
    .io_frontier_in_47_valid(SLR1_io_frontier_in_47_valid),
    .io_frontier_in_47_bits(SLR1_io_frontier_in_47_bits),
    .io_frontier_in_48_ready(SLR1_io_frontier_in_48_ready),
    .io_frontier_in_48_valid(SLR1_io_frontier_in_48_valid),
    .io_frontier_in_48_bits(SLR1_io_frontier_in_48_bits),
    .io_frontier_in_49_ready(SLR1_io_frontier_in_49_ready),
    .io_frontier_in_49_valid(SLR1_io_frontier_in_49_valid),
    .io_frontier_in_49_bits(SLR1_io_frontier_in_49_bits),
    .io_frontier_in_50_ready(SLR1_io_frontier_in_50_ready),
    .io_frontier_in_50_valid(SLR1_io_frontier_in_50_valid),
    .io_frontier_in_50_bits(SLR1_io_frontier_in_50_bits),
    .io_frontier_in_51_ready(SLR1_io_frontier_in_51_ready),
    .io_frontier_in_51_valid(SLR1_io_frontier_in_51_valid),
    .io_frontier_in_51_bits(SLR1_io_frontier_in_51_bits),
    .io_frontier_in_52_ready(SLR1_io_frontier_in_52_ready),
    .io_frontier_in_52_valid(SLR1_io_frontier_in_52_valid),
    .io_frontier_in_52_bits(SLR1_io_frontier_in_52_bits),
    .io_frontier_in_53_ready(SLR1_io_frontier_in_53_ready),
    .io_frontier_in_53_valid(SLR1_io_frontier_in_53_valid),
    .io_frontier_in_53_bits(SLR1_io_frontier_in_53_bits),
    .io_frontier_in_54_ready(SLR1_io_frontier_in_54_ready),
    .io_frontier_in_54_valid(SLR1_io_frontier_in_54_valid),
    .io_frontier_in_54_bits(SLR1_io_frontier_in_54_bits),
    .io_frontier_in_55_ready(SLR1_io_frontier_in_55_ready),
    .io_frontier_in_55_valid(SLR1_io_frontier_in_55_valid),
    .io_frontier_in_55_bits(SLR1_io_frontier_in_55_bits),
    .io_p2_out_0_ready(SLR1_io_p2_out_0_ready),
    .io_p2_out_0_valid(SLR1_io_p2_out_0_valid),
    .io_p2_out_0_bits(SLR1_io_p2_out_0_bits),
    .io_p2_out_1_ready(SLR1_io_p2_out_1_ready),
    .io_p2_out_1_valid(SLR1_io_p2_out_1_valid),
    .io_p2_out_1_bits(SLR1_io_p2_out_1_bits),
    .io_p2_out_2_ready(SLR1_io_p2_out_2_ready),
    .io_p2_out_2_valid(SLR1_io_p2_out_2_valid),
    .io_p2_out_2_bits(SLR1_io_p2_out_2_bits),
    .io_p2_out_3_ready(SLR1_io_p2_out_3_ready),
    .io_p2_out_3_valid(SLR1_io_p2_out_3_valid),
    .io_p2_out_3_bits(SLR1_io_p2_out_3_bits),
    .io_p2_out_4_ready(SLR1_io_p2_out_4_ready),
    .io_p2_out_4_valid(SLR1_io_p2_out_4_valid),
    .io_p2_out_4_bits(SLR1_io_p2_out_4_bits),
    .io_p2_out_5_ready(SLR1_io_p2_out_5_ready),
    .io_p2_out_5_valid(SLR1_io_p2_out_5_valid),
    .io_p2_out_5_bits(SLR1_io_p2_out_5_bits),
    .io_p2_out_6_ready(SLR1_io_p2_out_6_ready),
    .io_p2_out_6_valid(SLR1_io_p2_out_6_valid),
    .io_p2_out_6_bits(SLR1_io_p2_out_6_bits),
    .io_p2_out_7_ready(SLR1_io_p2_out_7_ready),
    .io_p2_out_7_valid(SLR1_io_p2_out_7_valid),
    .io_p2_out_7_bits(SLR1_io_p2_out_7_bits),
    .io_p2_out_8_ready(SLR1_io_p2_out_8_ready),
    .io_p2_out_8_valid(SLR1_io_p2_out_8_valid),
    .io_p2_out_8_bits(SLR1_io_p2_out_8_bits),
    .io_p2_out_9_ready(SLR1_io_p2_out_9_ready),
    .io_p2_out_9_valid(SLR1_io_p2_out_9_valid),
    .io_p2_out_9_bits(SLR1_io_p2_out_9_bits),
    .io_p2_out_10_ready(SLR1_io_p2_out_10_ready),
    .io_p2_out_10_valid(SLR1_io_p2_out_10_valid),
    .io_p2_out_10_bits(SLR1_io_p2_out_10_bits),
    .io_p2_out_11_ready(SLR1_io_p2_out_11_ready),
    .io_p2_out_11_valid(SLR1_io_p2_out_11_valid),
    .io_p2_out_11_bits(SLR1_io_p2_out_11_bits),
    .io_p2_out_12_ready(SLR1_io_p2_out_12_ready),
    .io_p2_out_12_valid(SLR1_io_p2_out_12_valid),
    .io_p2_out_12_bits(SLR1_io_p2_out_12_bits),
    .io_p2_out_13_ready(SLR1_io_p2_out_13_ready),
    .io_p2_out_13_valid(SLR1_io_p2_out_13_valid),
    .io_p2_out_13_bits(SLR1_io_p2_out_13_bits),
    .io_p2_out_14_ready(SLR1_io_p2_out_14_ready),
    .io_p2_out_14_valid(SLR1_io_p2_out_14_valid),
    .io_p2_out_14_bits(SLR1_io_p2_out_14_bits),
    .io_p2_out_15_ready(SLR1_io_p2_out_15_ready),
    .io_p2_out_15_valid(SLR1_io_p2_out_15_valid),
    .io_p2_out_15_bits(SLR1_io_p2_out_15_bits),
    .io_p2_out_16_ready(SLR1_io_p2_out_16_ready),
    .io_p2_out_16_valid(SLR1_io_p2_out_16_valid),
    .io_p2_out_16_bits(SLR1_io_p2_out_16_bits),
    .io_p2_out_17_ready(SLR1_io_p2_out_17_ready),
    .io_p2_out_17_valid(SLR1_io_p2_out_17_valid),
    .io_p2_out_17_bits(SLR1_io_p2_out_17_bits),
    .io_p2_out_18_ready(SLR1_io_p2_out_18_ready),
    .io_p2_out_18_valid(SLR1_io_p2_out_18_valid),
    .io_p2_out_18_bits(SLR1_io_p2_out_18_bits),
    .io_p2_out_19_ready(SLR1_io_p2_out_19_ready),
    .io_p2_out_19_valid(SLR1_io_p2_out_19_valid),
    .io_p2_out_19_bits(SLR1_io_p2_out_19_bits),
    .io_p2_out_20_ready(SLR1_io_p2_out_20_ready),
    .io_p2_out_20_valid(SLR1_io_p2_out_20_valid),
    .io_p2_out_20_bits(SLR1_io_p2_out_20_bits),
    .io_p2_out_21_ready(SLR1_io_p2_out_21_ready),
    .io_p2_out_21_valid(SLR1_io_p2_out_21_valid),
    .io_p2_out_21_bits(SLR1_io_p2_out_21_bits),
    .io_p2_out_22_ready(SLR1_io_p2_out_22_ready),
    .io_p2_out_22_valid(SLR1_io_p2_out_22_valid),
    .io_p2_out_22_bits(SLR1_io_p2_out_22_bits),
    .io_p2_out_23_ready(SLR1_io_p2_out_23_ready),
    .io_p2_out_23_valid(SLR1_io_p2_out_23_valid),
    .io_p2_out_23_bits(SLR1_io_p2_out_23_bits),
    .io_p2_out_24_ready(SLR1_io_p2_out_24_ready),
    .io_p2_out_24_valid(SLR1_io_p2_out_24_valid),
    .io_p2_out_24_bits(SLR1_io_p2_out_24_bits),
    .io_p2_out_25_ready(SLR1_io_p2_out_25_ready),
    .io_p2_out_25_valid(SLR1_io_p2_out_25_valid),
    .io_p2_out_25_bits(SLR1_io_p2_out_25_bits),
    .io_p2_out_26_ready(SLR1_io_p2_out_26_ready),
    .io_p2_out_26_valid(SLR1_io_p2_out_26_valid),
    .io_p2_out_26_bits(SLR1_io_p2_out_26_bits),
    .io_p2_out_27_ready(SLR1_io_p2_out_27_ready),
    .io_p2_out_27_valid(SLR1_io_p2_out_27_valid),
    .io_p2_out_27_bits(SLR1_io_p2_out_27_bits),
    .io_p2_out_28_ready(SLR1_io_p2_out_28_ready),
    .io_p2_out_28_valid(SLR1_io_p2_out_28_valid),
    .io_p2_out_28_bits(SLR1_io_p2_out_28_bits),
    .io_p2_out_29_ready(SLR1_io_p2_out_29_ready),
    .io_p2_out_29_valid(SLR1_io_p2_out_29_valid),
    .io_p2_out_29_bits(SLR1_io_p2_out_29_bits),
    .io_p2_out_30_ready(SLR1_io_p2_out_30_ready),
    .io_p2_out_30_valid(SLR1_io_p2_out_30_valid),
    .io_p2_out_30_bits(SLR1_io_p2_out_30_bits),
    .io_p2_out_31_ready(SLR1_io_p2_out_31_ready),
    .io_p2_out_31_valid(SLR1_io_p2_out_31_valid),
    .io_p2_out_31_bits(SLR1_io_p2_out_31_bits),
    .io_p2_out_32_ready(SLR1_io_p2_out_32_ready),
    .io_p2_out_32_valid(SLR1_io_p2_out_32_valid),
    .io_p2_out_32_bits(SLR1_io_p2_out_32_bits),
    .io_p2_out_33_ready(SLR1_io_p2_out_33_ready),
    .io_p2_out_33_valid(SLR1_io_p2_out_33_valid),
    .io_p2_out_33_bits(SLR1_io_p2_out_33_bits),
    .io_p2_out_34_ready(SLR1_io_p2_out_34_ready),
    .io_p2_out_34_valid(SLR1_io_p2_out_34_valid),
    .io_p2_out_34_bits(SLR1_io_p2_out_34_bits),
    .io_p2_out_35_ready(SLR1_io_p2_out_35_ready),
    .io_p2_out_35_valid(SLR1_io_p2_out_35_valid),
    .io_p2_out_35_bits(SLR1_io_p2_out_35_bits),
    .io_p2_out_36_ready(SLR1_io_p2_out_36_ready),
    .io_p2_out_36_valid(SLR1_io_p2_out_36_valid),
    .io_p2_out_36_bits(SLR1_io_p2_out_36_bits),
    .io_p2_out_37_ready(SLR1_io_p2_out_37_ready),
    .io_p2_out_37_valid(SLR1_io_p2_out_37_valid),
    .io_p2_out_37_bits(SLR1_io_p2_out_37_bits),
    .io_p2_out_38_ready(SLR1_io_p2_out_38_ready),
    .io_p2_out_38_valid(SLR1_io_p2_out_38_valid),
    .io_p2_out_38_bits(SLR1_io_p2_out_38_bits),
    .io_p2_out_39_ready(SLR1_io_p2_out_39_ready),
    .io_p2_out_39_valid(SLR1_io_p2_out_39_valid),
    .io_p2_out_39_bits(SLR1_io_p2_out_39_bits),
    .io_p2_out_40_ready(SLR1_io_p2_out_40_ready),
    .io_p2_out_40_valid(SLR1_io_p2_out_40_valid),
    .io_p2_out_40_bits(SLR1_io_p2_out_40_bits),
    .io_p2_out_41_ready(SLR1_io_p2_out_41_ready),
    .io_p2_out_41_valid(SLR1_io_p2_out_41_valid),
    .io_p2_out_41_bits(SLR1_io_p2_out_41_bits),
    .io_p2_out_42_ready(SLR1_io_p2_out_42_ready),
    .io_p2_out_42_valid(SLR1_io_p2_out_42_valid),
    .io_p2_out_42_bits(SLR1_io_p2_out_42_bits),
    .io_p2_out_43_ready(SLR1_io_p2_out_43_ready),
    .io_p2_out_43_valid(SLR1_io_p2_out_43_valid),
    .io_p2_out_43_bits(SLR1_io_p2_out_43_bits),
    .io_p2_out_44_ready(SLR1_io_p2_out_44_ready),
    .io_p2_out_44_valid(SLR1_io_p2_out_44_valid),
    .io_p2_out_44_bits(SLR1_io_p2_out_44_bits),
    .io_p2_out_45_ready(SLR1_io_p2_out_45_ready),
    .io_p2_out_45_valid(SLR1_io_p2_out_45_valid),
    .io_p2_out_45_bits(SLR1_io_p2_out_45_bits),
    .io_p2_out_46_ready(SLR1_io_p2_out_46_ready),
    .io_p2_out_46_valid(SLR1_io_p2_out_46_valid),
    .io_p2_out_46_bits(SLR1_io_p2_out_46_bits),
    .io_p2_out_47_ready(SLR1_io_p2_out_47_ready),
    .io_p2_out_47_valid(SLR1_io_p2_out_47_valid),
    .io_p2_out_47_bits(SLR1_io_p2_out_47_bits),
    .io_p2_out_48_ready(SLR1_io_p2_out_48_ready),
    .io_p2_out_48_valid(SLR1_io_p2_out_48_valid),
    .io_p2_out_48_bits(SLR1_io_p2_out_48_bits),
    .io_p2_out_49_ready(SLR1_io_p2_out_49_ready),
    .io_p2_out_49_valid(SLR1_io_p2_out_49_valid),
    .io_p2_out_49_bits(SLR1_io_p2_out_49_bits),
    .io_p2_out_50_ready(SLR1_io_p2_out_50_ready),
    .io_p2_out_50_valid(SLR1_io_p2_out_50_valid),
    .io_p2_out_50_bits(SLR1_io_p2_out_50_bits),
    .io_p2_out_51_ready(SLR1_io_p2_out_51_ready),
    .io_p2_out_51_valid(SLR1_io_p2_out_51_valid),
    .io_p2_out_51_bits(SLR1_io_p2_out_51_bits),
    .io_p2_out_52_ready(SLR1_io_p2_out_52_ready),
    .io_p2_out_52_valid(SLR1_io_p2_out_52_valid),
    .io_p2_out_52_bits(SLR1_io_p2_out_52_bits),
    .io_p2_out_53_ready(SLR1_io_p2_out_53_ready),
    .io_p2_out_53_valid(SLR1_io_p2_out_53_valid),
    .io_p2_out_53_bits(SLR1_io_p2_out_53_bits),
    .io_p2_out_54_ready(SLR1_io_p2_out_54_ready),
    .io_p2_out_54_valid(SLR1_io_p2_out_54_valid),
    .io_p2_out_54_bits(SLR1_io_p2_out_54_bits),
    .io_p2_out_55_ready(SLR1_io_p2_out_55_ready),
    .io_p2_out_55_valid(SLR1_io_p2_out_55_valid),
    .io_p2_out_55_bits(SLR1_io_p2_out_55_bits),
    .io_R_array_index_0_ready(SLR1_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(SLR1_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(SLR1_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(SLR1_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(SLR1_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(SLR1_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(SLR1_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(SLR1_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(SLR1_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(SLR1_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(SLR1_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(SLR1_io_R_array_index_3_bits),
    .io_R_array_index_4_ready(SLR1_io_R_array_index_4_ready),
    .io_R_array_index_4_valid(SLR1_io_R_array_index_4_valid),
    .io_R_array_index_4_bits(SLR1_io_R_array_index_4_bits),
    .io_R_array_index_5_ready(SLR1_io_R_array_index_5_ready),
    .io_R_array_index_5_valid(SLR1_io_R_array_index_5_valid),
    .io_R_array_index_5_bits(SLR1_io_R_array_index_5_bits),
    .io_R_array_index_6_ready(SLR1_io_R_array_index_6_ready),
    .io_R_array_index_6_valid(SLR1_io_R_array_index_6_valid),
    .io_R_array_index_6_bits(SLR1_io_R_array_index_6_bits),
    .io_R_array_index_7_ready(SLR1_io_R_array_index_7_ready),
    .io_R_array_index_7_valid(SLR1_io_R_array_index_7_valid),
    .io_R_array_index_7_bits(SLR1_io_R_array_index_7_bits),
    .io_R_array_index_8_ready(SLR1_io_R_array_index_8_ready),
    .io_R_array_index_8_valid(SLR1_io_R_array_index_8_valid),
    .io_R_array_index_8_bits(SLR1_io_R_array_index_8_bits),
    .io_R_array_index_9_ready(SLR1_io_R_array_index_9_ready),
    .io_R_array_index_9_valid(SLR1_io_R_array_index_9_valid),
    .io_R_array_index_9_bits(SLR1_io_R_array_index_9_bits),
    .io_R_array_index_10_ready(SLR1_io_R_array_index_10_ready),
    .io_R_array_index_10_valid(SLR1_io_R_array_index_10_valid),
    .io_R_array_index_10_bits(SLR1_io_R_array_index_10_bits),
    .io_R_array_index_11_ready(SLR1_io_R_array_index_11_ready),
    .io_R_array_index_11_valid(SLR1_io_R_array_index_11_valid),
    .io_R_array_index_11_bits(SLR1_io_R_array_index_11_bits),
    .io_R_array_index_12_ready(SLR1_io_R_array_index_12_ready),
    .io_R_array_index_12_valid(SLR1_io_R_array_index_12_valid),
    .io_R_array_index_12_bits(SLR1_io_R_array_index_12_bits),
    .io_R_array_index_13_ready(SLR1_io_R_array_index_13_ready),
    .io_R_array_index_13_valid(SLR1_io_R_array_index_13_valid),
    .io_R_array_index_13_bits(SLR1_io_R_array_index_13_bits),
    .io_R_array_index_14_ready(SLR1_io_R_array_index_14_ready),
    .io_R_array_index_14_valid(SLR1_io_R_array_index_14_valid),
    .io_R_array_index_14_bits(SLR1_io_R_array_index_14_bits),
    .io_R_array_index_15_ready(SLR1_io_R_array_index_15_ready),
    .io_R_array_index_15_valid(SLR1_io_R_array_index_15_valid),
    .io_R_array_index_15_bits(SLR1_io_R_array_index_15_bits),
    .io_R_array_index_16_ready(SLR1_io_R_array_index_16_ready),
    .io_R_array_index_16_valid(SLR1_io_R_array_index_16_valid),
    .io_R_array_index_16_bits(SLR1_io_R_array_index_16_bits),
    .io_R_array_index_17_ready(SLR1_io_R_array_index_17_ready),
    .io_R_array_index_17_valid(SLR1_io_R_array_index_17_valid),
    .io_R_array_index_17_bits(SLR1_io_R_array_index_17_bits),
    .io_R_array_index_18_ready(SLR1_io_R_array_index_18_ready),
    .io_R_array_index_18_valid(SLR1_io_R_array_index_18_valid),
    .io_R_array_index_18_bits(SLR1_io_R_array_index_18_bits),
    .io_R_array_index_19_ready(SLR1_io_R_array_index_19_ready),
    .io_R_array_index_19_valid(SLR1_io_R_array_index_19_valid),
    .io_R_array_index_19_bits(SLR1_io_R_array_index_19_bits),
    .io_R_array_index_20_ready(SLR1_io_R_array_index_20_ready),
    .io_R_array_index_20_valid(SLR1_io_R_array_index_20_valid),
    .io_R_array_index_20_bits(SLR1_io_R_array_index_20_bits),
    .io_R_array_index_21_ready(SLR1_io_R_array_index_21_ready),
    .io_R_array_index_21_valid(SLR1_io_R_array_index_21_valid),
    .io_R_array_index_21_bits(SLR1_io_R_array_index_21_bits),
    .io_R_array_index_22_ready(SLR1_io_R_array_index_22_ready),
    .io_R_array_index_22_valid(SLR1_io_R_array_index_22_valid),
    .io_R_array_index_22_bits(SLR1_io_R_array_index_22_bits),
    .io_R_array_index_23_ready(SLR1_io_R_array_index_23_ready),
    .io_R_array_index_23_valid(SLR1_io_R_array_index_23_valid),
    .io_R_array_index_23_bits(SLR1_io_R_array_index_23_bits),
    .io_R_array_index_24_ready(SLR1_io_R_array_index_24_ready),
    .io_R_array_index_24_valid(SLR1_io_R_array_index_24_valid),
    .io_R_array_index_24_bits(SLR1_io_R_array_index_24_bits),
    .io_R_array_index_25_ready(SLR1_io_R_array_index_25_ready),
    .io_R_array_index_25_valid(SLR1_io_R_array_index_25_valid),
    .io_R_array_index_25_bits(SLR1_io_R_array_index_25_bits),
    .io_R_array_index_26_ready(SLR1_io_R_array_index_26_ready),
    .io_R_array_index_26_valid(SLR1_io_R_array_index_26_valid),
    .io_R_array_index_26_bits(SLR1_io_R_array_index_26_bits),
    .io_R_array_index_27_ready(SLR1_io_R_array_index_27_ready),
    .io_R_array_index_27_valid(SLR1_io_R_array_index_27_valid),
    .io_R_array_index_27_bits(SLR1_io_R_array_index_27_bits),
    .io_R_array_index_28_ready(SLR1_io_R_array_index_28_ready),
    .io_R_array_index_28_valid(SLR1_io_R_array_index_28_valid),
    .io_R_array_index_28_bits(SLR1_io_R_array_index_28_bits),
    .io_R_array_index_29_ready(SLR1_io_R_array_index_29_ready),
    .io_R_array_index_29_valid(SLR1_io_R_array_index_29_valid),
    .io_R_array_index_29_bits(SLR1_io_R_array_index_29_bits),
    .io_R_array_index_30_ready(SLR1_io_R_array_index_30_ready),
    .io_R_array_index_30_valid(SLR1_io_R_array_index_30_valid),
    .io_R_array_index_30_bits(SLR1_io_R_array_index_30_bits),
    .io_R_array_index_31_ready(SLR1_io_R_array_index_31_ready),
    .io_R_array_index_31_valid(SLR1_io_R_array_index_31_valid),
    .io_R_array_index_31_bits(SLR1_io_R_array_index_31_bits),
    .io_R_array_index_32_ready(SLR1_io_R_array_index_32_ready),
    .io_R_array_index_32_valid(SLR1_io_R_array_index_32_valid),
    .io_R_array_index_32_bits(SLR1_io_R_array_index_32_bits),
    .io_R_array_index_33_ready(SLR1_io_R_array_index_33_ready),
    .io_R_array_index_33_valid(SLR1_io_R_array_index_33_valid),
    .io_R_array_index_33_bits(SLR1_io_R_array_index_33_bits),
    .io_R_array_index_34_ready(SLR1_io_R_array_index_34_ready),
    .io_R_array_index_34_valid(SLR1_io_R_array_index_34_valid),
    .io_R_array_index_34_bits(SLR1_io_R_array_index_34_bits),
    .io_R_array_index_35_ready(SLR1_io_R_array_index_35_ready),
    .io_R_array_index_35_valid(SLR1_io_R_array_index_35_valid),
    .io_R_array_index_35_bits(SLR1_io_R_array_index_35_bits),
    .io_R_array_index_36_ready(SLR1_io_R_array_index_36_ready),
    .io_R_array_index_36_valid(SLR1_io_R_array_index_36_valid),
    .io_R_array_index_36_bits(SLR1_io_R_array_index_36_bits),
    .io_R_array_index_37_ready(SLR1_io_R_array_index_37_ready),
    .io_R_array_index_37_valid(SLR1_io_R_array_index_37_valid),
    .io_R_array_index_37_bits(SLR1_io_R_array_index_37_bits),
    .io_R_array_index_38_ready(SLR1_io_R_array_index_38_ready),
    .io_R_array_index_38_valid(SLR1_io_R_array_index_38_valid),
    .io_R_array_index_38_bits(SLR1_io_R_array_index_38_bits),
    .io_R_array_index_39_ready(SLR1_io_R_array_index_39_ready),
    .io_R_array_index_39_valid(SLR1_io_R_array_index_39_valid),
    .io_R_array_index_39_bits(SLR1_io_R_array_index_39_bits),
    .io_R_array_index_40_ready(SLR1_io_R_array_index_40_ready),
    .io_R_array_index_40_valid(SLR1_io_R_array_index_40_valid),
    .io_R_array_index_40_bits(SLR1_io_R_array_index_40_bits),
    .io_R_array_index_41_ready(SLR1_io_R_array_index_41_ready),
    .io_R_array_index_41_valid(SLR1_io_R_array_index_41_valid),
    .io_R_array_index_41_bits(SLR1_io_R_array_index_41_bits),
    .io_R_array_index_42_ready(SLR1_io_R_array_index_42_ready),
    .io_R_array_index_42_valid(SLR1_io_R_array_index_42_valid),
    .io_R_array_index_42_bits(SLR1_io_R_array_index_42_bits),
    .io_R_array_index_43_ready(SLR1_io_R_array_index_43_ready),
    .io_R_array_index_43_valid(SLR1_io_R_array_index_43_valid),
    .io_R_array_index_43_bits(SLR1_io_R_array_index_43_bits),
    .io_R_array_index_44_ready(SLR1_io_R_array_index_44_ready),
    .io_R_array_index_44_valid(SLR1_io_R_array_index_44_valid),
    .io_R_array_index_44_bits(SLR1_io_R_array_index_44_bits),
    .io_R_array_index_45_ready(SLR1_io_R_array_index_45_ready),
    .io_R_array_index_45_valid(SLR1_io_R_array_index_45_valid),
    .io_R_array_index_45_bits(SLR1_io_R_array_index_45_bits),
    .io_R_array_index_46_ready(SLR1_io_R_array_index_46_ready),
    .io_R_array_index_46_valid(SLR1_io_R_array_index_46_valid),
    .io_R_array_index_46_bits(SLR1_io_R_array_index_46_bits),
    .io_R_array_index_47_ready(SLR1_io_R_array_index_47_ready),
    .io_R_array_index_47_valid(SLR1_io_R_array_index_47_valid),
    .io_R_array_index_47_bits(SLR1_io_R_array_index_47_bits),
    .io_R_array_index_48_ready(SLR1_io_R_array_index_48_ready),
    .io_R_array_index_48_valid(SLR1_io_R_array_index_48_valid),
    .io_R_array_index_48_bits(SLR1_io_R_array_index_48_bits),
    .io_R_array_index_49_ready(SLR1_io_R_array_index_49_ready),
    .io_R_array_index_49_valid(SLR1_io_R_array_index_49_valid),
    .io_R_array_index_49_bits(SLR1_io_R_array_index_49_bits),
    .io_R_array_index_50_ready(SLR1_io_R_array_index_50_ready),
    .io_R_array_index_50_valid(SLR1_io_R_array_index_50_valid),
    .io_R_array_index_50_bits(SLR1_io_R_array_index_50_bits),
    .io_R_array_index_51_ready(SLR1_io_R_array_index_51_ready),
    .io_R_array_index_51_valid(SLR1_io_R_array_index_51_valid),
    .io_R_array_index_51_bits(SLR1_io_R_array_index_51_bits),
    .io_R_array_index_52_ready(SLR1_io_R_array_index_52_ready),
    .io_R_array_index_52_valid(SLR1_io_R_array_index_52_valid),
    .io_R_array_index_52_bits(SLR1_io_R_array_index_52_bits),
    .io_R_array_index_53_ready(SLR1_io_R_array_index_53_ready),
    .io_R_array_index_53_valid(SLR1_io_R_array_index_53_valid),
    .io_R_array_index_53_bits(SLR1_io_R_array_index_53_bits),
    .io_R_array_index_54_ready(SLR1_io_R_array_index_54_ready),
    .io_R_array_index_54_valid(SLR1_io_R_array_index_54_valid),
    .io_R_array_index_54_bits(SLR1_io_R_array_index_54_bits),
    .io_R_array_index_55_ready(SLR1_io_R_array_index_55_ready),
    .io_R_array_index_55_valid(SLR1_io_R_array_index_55_valid),
    .io_R_array_index_55_bits(SLR1_io_R_array_index_55_bits),
    .io_p1_end_0(SLR1_io_p1_end_0),
    .io_p1_end_1(SLR1_io_p1_end_1),
    .io_p1_end_2(SLR1_io_p1_end_2),
    .io_p1_end_3(SLR1_io_p1_end_3),
    .io_p1_end_4(SLR1_io_p1_end_4),
    .io_p1_end_5(SLR1_io_p1_end_5),
    .io_p1_end_6(SLR1_io_p1_end_6),
    .io_p1_end_7(SLR1_io_p1_end_7),
    .io_p1_end_8(SLR1_io_p1_end_8),
    .io_p1_end_9(SLR1_io_p1_end_9),
    .io_p1_end_10(SLR1_io_p1_end_10),
    .io_p1_end_11(SLR1_io_p1_end_11),
    .io_p1_end_12(SLR1_io_p1_end_12),
    .io_p1_end_13(SLR1_io_p1_end_13),
    .io_uram_out_a_0(SLR1_io_uram_out_a_0),
    .io_uram_out_a_1(SLR1_io_uram_out_a_1),
    .io_uram_out_a_2(SLR1_io_uram_out_a_2),
    .io_uram_out_a_3(SLR1_io_uram_out_a_3),
    .io_uram_out_a_4(SLR1_io_uram_out_a_4),
    .io_uram_out_a_5(SLR1_io_uram_out_a_5),
    .io_uram_out_a_6(SLR1_io_uram_out_a_6),
    .io_uram_out_a_7(SLR1_io_uram_out_a_7),
    .io_uram_out_a_8(SLR1_io_uram_out_a_8),
    .io_uram_out_a_9(SLR1_io_uram_out_a_9),
    .io_uram_out_a_10(SLR1_io_uram_out_a_10),
    .io_uram_out_a_11(SLR1_io_uram_out_a_11),
    .io_uram_out_a_12(SLR1_io_uram_out_a_12),
    .io_uram_out_a_13(SLR1_io_uram_out_a_13),
    .io_uram_out_a_14(SLR1_io_uram_out_a_14),
    .io_uram_out_a_15(SLR1_io_uram_out_a_15),
    .io_uram_out_a_16(SLR1_io_uram_out_a_16),
    .io_uram_out_a_17(SLR1_io_uram_out_a_17),
    .io_uram_out_a_18(SLR1_io_uram_out_a_18),
    .io_uram_out_a_19(SLR1_io_uram_out_a_19),
    .io_uram_out_a_20(SLR1_io_uram_out_a_20),
    .io_uram_out_a_21(SLR1_io_uram_out_a_21),
    .io_uram_out_a_22(SLR1_io_uram_out_a_22),
    .io_uram_out_a_23(SLR1_io_uram_out_a_23),
    .io_uram_out_a_24(SLR1_io_uram_out_a_24),
    .io_uram_out_a_25(SLR1_io_uram_out_a_25),
    .io_uram_out_a_26(SLR1_io_uram_out_a_26),
    .io_uram_out_a_27(SLR1_io_uram_out_a_27),
    .io_uram_out_a_28(SLR1_io_uram_out_a_28),
    .io_uram_out_a_29(SLR1_io_uram_out_a_29),
    .io_uram_out_a_30(SLR1_io_uram_out_a_30),
    .io_uram_out_a_31(SLR1_io_uram_out_a_31),
    .io_uram_out_a_32(SLR1_io_uram_out_a_32),
    .io_uram_out_a_33(SLR1_io_uram_out_a_33),
    .io_uram_out_a_34(SLR1_io_uram_out_a_34),
    .io_uram_out_a_35(SLR1_io_uram_out_a_35),
    .io_uram_out_a_36(SLR1_io_uram_out_a_36),
    .io_uram_out_a_37(SLR1_io_uram_out_a_37),
    .io_uram_out_a_38(SLR1_io_uram_out_a_38),
    .io_uram_out_a_39(SLR1_io_uram_out_a_39),
    .io_uram_out_a_40(SLR1_io_uram_out_a_40),
    .io_uram_out_a_41(SLR1_io_uram_out_a_41),
    .io_uram_out_a_42(SLR1_io_uram_out_a_42),
    .io_uram_out_a_43(SLR1_io_uram_out_a_43),
    .io_uram_out_a_44(SLR1_io_uram_out_a_44),
    .io_uram_out_a_45(SLR1_io_uram_out_a_45),
    .io_uram_out_a_46(SLR1_io_uram_out_a_46),
    .io_uram_out_a_47(SLR1_io_uram_out_a_47),
    .io_uram_out_a_48(SLR1_io_uram_out_a_48),
    .io_uram_out_a_49(SLR1_io_uram_out_a_49),
    .io_uram_out_a_50(SLR1_io_uram_out_a_50),
    .io_uram_out_a_51(SLR1_io_uram_out_a_51),
    .io_uram_out_a_52(SLR1_io_uram_out_a_52),
    .io_uram_out_a_53(SLR1_io_uram_out_a_53),
    .io_uram_out_a_54(SLR1_io_uram_out_a_54),
    .io_uram_out_a_55(SLR1_io_uram_out_a_55),
    .io_uram_addr_a_0(SLR1_io_uram_addr_a_0),
    .io_uram_addr_a_1(SLR1_io_uram_addr_a_1),
    .io_uram_addr_a_2(SLR1_io_uram_addr_a_2),
    .io_uram_addr_a_3(SLR1_io_uram_addr_a_3),
    .io_uram_addr_a_4(SLR1_io_uram_addr_a_4),
    .io_uram_addr_a_5(SLR1_io_uram_addr_a_5),
    .io_uram_addr_a_6(SLR1_io_uram_addr_a_6),
    .io_uram_addr_a_7(SLR1_io_uram_addr_a_7),
    .io_uram_addr_a_8(SLR1_io_uram_addr_a_8),
    .io_uram_addr_a_9(SLR1_io_uram_addr_a_9),
    .io_uram_addr_a_10(SLR1_io_uram_addr_a_10),
    .io_uram_addr_a_11(SLR1_io_uram_addr_a_11),
    .io_uram_addr_a_12(SLR1_io_uram_addr_a_12),
    .io_uram_addr_a_13(SLR1_io_uram_addr_a_13),
    .io_uram_addr_a_14(SLR1_io_uram_addr_a_14),
    .io_uram_addr_a_15(SLR1_io_uram_addr_a_15),
    .io_uram_addr_a_16(SLR1_io_uram_addr_a_16),
    .io_uram_addr_a_17(SLR1_io_uram_addr_a_17),
    .io_uram_addr_a_18(SLR1_io_uram_addr_a_18),
    .io_uram_addr_a_19(SLR1_io_uram_addr_a_19),
    .io_uram_addr_a_20(SLR1_io_uram_addr_a_20),
    .io_uram_addr_a_21(SLR1_io_uram_addr_a_21),
    .io_uram_addr_a_22(SLR1_io_uram_addr_a_22),
    .io_uram_addr_a_23(SLR1_io_uram_addr_a_23),
    .io_uram_addr_a_24(SLR1_io_uram_addr_a_24),
    .io_uram_addr_a_25(SLR1_io_uram_addr_a_25),
    .io_uram_addr_a_26(SLR1_io_uram_addr_a_26),
    .io_uram_addr_a_27(SLR1_io_uram_addr_a_27),
    .io_uram_addr_a_28(SLR1_io_uram_addr_a_28),
    .io_uram_addr_a_29(SLR1_io_uram_addr_a_29),
    .io_uram_addr_a_30(SLR1_io_uram_addr_a_30),
    .io_uram_addr_a_31(SLR1_io_uram_addr_a_31),
    .io_uram_addr_a_32(SLR1_io_uram_addr_a_32),
    .io_uram_addr_a_33(SLR1_io_uram_addr_a_33),
    .io_uram_addr_a_34(SLR1_io_uram_addr_a_34),
    .io_uram_addr_a_35(SLR1_io_uram_addr_a_35),
    .io_uram_addr_a_36(SLR1_io_uram_addr_a_36),
    .io_uram_addr_a_37(SLR1_io_uram_addr_a_37),
    .io_uram_addr_a_38(SLR1_io_uram_addr_a_38),
    .io_uram_addr_a_39(SLR1_io_uram_addr_a_39),
    .io_uram_addr_a_40(SLR1_io_uram_addr_a_40),
    .io_uram_addr_a_41(SLR1_io_uram_addr_a_41),
    .io_uram_addr_a_42(SLR1_io_uram_addr_a_42),
    .io_uram_addr_a_43(SLR1_io_uram_addr_a_43),
    .io_uram_addr_a_44(SLR1_io_uram_addr_a_44),
    .io_uram_addr_a_45(SLR1_io_uram_addr_a_45),
    .io_uram_addr_a_46(SLR1_io_uram_addr_a_46),
    .io_uram_addr_a_47(SLR1_io_uram_addr_a_47),
    .io_uram_addr_a_48(SLR1_io_uram_addr_a_48),
    .io_uram_addr_a_49(SLR1_io_uram_addr_a_49),
    .io_uram_addr_a_50(SLR1_io_uram_addr_a_50),
    .io_uram_addr_a_51(SLR1_io_uram_addr_a_51),
    .io_uram_addr_a_52(SLR1_io_uram_addr_a_52),
    .io_uram_addr_a_53(SLR1_io_uram_addr_a_53),
    .io_uram_addr_a_54(SLR1_io_uram_addr_a_54),
    .io_uram_addr_a_55(SLR1_io_uram_addr_a_55)
  );
  SLR2 SLR2 ( // @[Top-slr.scala 52:23]
    .clock(SLR2_clock),
    .reset(SLR2_reset),
    .io_p2_end(SLR2_io_p2_end),
    .io_start(SLR2_io_start),
    .io_frontier_flag(SLR2_io_frontier_flag),
    .io_level(SLR2_io_level),
    .io_offsets_CSR_R_offset(SLR2_io_offsets_CSR_R_offset),
    .io_offsets_CSR_C_offset(SLR2_io_offsets_CSR_C_offset),
    .io_offsets_CSC_R_offset(SLR2_io_offsets_CSC_R_offset),
    .io_offsets_CSC_C_offset(SLR2_io_offsets_CSC_C_offset),
    .io_offsets_level_offset(SLR2_io_offsets_level_offset),
    .io_node_num(SLR2_io_node_num),
    .io_root(SLR2_io_root),
    .io_push_or_pull(SLR2_io_push_or_pull),
    .io_start_init(SLR2_io_start_init),
    .io_end_0(SLR2_io_end_0),
    .io_end_1(SLR2_io_end_1),
    .io_end_2(SLR2_io_end_2),
    .io_end_3(SLR2_io_end_3),
    .io_end_4(SLR2_io_end_4),
    .io_end_5(SLR2_io_end_5),
    .io_end_6(SLR2_io_end_6),
    .io_end_7(SLR2_io_end_7),
    .io_end_8(SLR2_io_end_8),
    .io_end_9(SLR2_io_end_9),
    .io_end_10(SLR2_io_end_10),
    .io_end_11(SLR2_io_end_11),
    .io_end_12(SLR2_io_end_12),
    .io_end_13(SLR2_io_end_13),
    .io_end_14(SLR2_io_end_14),
    .io_end_15(SLR2_io_end_15),
    .io_end_16(SLR2_io_end_16),
    .io_end_17(SLR2_io_end_17),
    .io_p2_count_0(SLR2_io_p2_count_0),
    .io_p2_count_1(SLR2_io_p2_count_1),
    .io_p2_count_2(SLR2_io_p2_count_2),
    .io_p2_count_3(SLR2_io_p2_count_3),
    .io_p2_count_4(SLR2_io_p2_count_4),
    .io_p2_count_5(SLR2_io_p2_count_5),
    .io_p2_count_6(SLR2_io_p2_count_6),
    .io_p2_count_7(SLR2_io_p2_count_7),
    .io_p2_count_8(SLR2_io_p2_count_8),
    .io_p2_count_9(SLR2_io_p2_count_9),
    .io_p2_count_10(SLR2_io_p2_count_10),
    .io_p2_count_11(SLR2_io_p2_count_11),
    .io_p2_count_12(SLR2_io_p2_count_12),
    .io_p2_count_13(SLR2_io_p2_count_13),
    .io_p2_count_14(SLR2_io_p2_count_14),
    .io_p2_count_15(SLR2_io_p2_count_15),
    .io_p2_count_16(SLR2_io_p2_count_16),
    .io_p2_count_17(SLR2_io_p2_count_17),
    .io_p2_pull_count_0(SLR2_io_p2_pull_count_0),
    .io_p2_pull_count_1(SLR2_io_p2_pull_count_1),
    .io_p2_pull_count_2(SLR2_io_p2_pull_count_2),
    .io_p2_pull_count_3(SLR2_io_p2_pull_count_3),
    .io_p2_pull_count_4(SLR2_io_p2_pull_count_4),
    .io_p2_pull_count_5(SLR2_io_p2_pull_count_5),
    .io_p2_pull_count_6(SLR2_io_p2_pull_count_6),
    .io_p2_pull_count_7(SLR2_io_p2_pull_count_7),
    .io_p2_pull_count_8(SLR2_io_p2_pull_count_8),
    .io_p2_pull_count_9(SLR2_io_p2_pull_count_9),
    .io_p2_pull_count_10(SLR2_io_p2_pull_count_10),
    .io_p2_pull_count_11(SLR2_io_p2_pull_count_11),
    .io_p2_pull_count_12(SLR2_io_p2_pull_count_12),
    .io_p2_pull_count_13(SLR2_io_p2_pull_count_13),
    .io_p2_pull_count_14(SLR2_io_p2_pull_count_14),
    .io_p2_pull_count_15(SLR2_io_p2_pull_count_15),
    .io_p2_pull_count_16(SLR2_io_p2_pull_count_16),
    .io_p2_pull_count_17(SLR2_io_p2_pull_count_17),
    .io_frontier_pull_count_0(SLR2_io_frontier_pull_count_0),
    .io_frontier_pull_count_1(SLR2_io_frontier_pull_count_1),
    .io_frontier_pull_count_2(SLR2_io_frontier_pull_count_2),
    .io_frontier_pull_count_3(SLR2_io_frontier_pull_count_3),
    .io_frontier_pull_count_4(SLR2_io_frontier_pull_count_4),
    .io_frontier_pull_count_5(SLR2_io_frontier_pull_count_5),
    .io_frontier_pull_count_6(SLR2_io_frontier_pull_count_6),
    .io_frontier_pull_count_7(SLR2_io_frontier_pull_count_7),
    .io_frontier_pull_count_8(SLR2_io_frontier_pull_count_8),
    .io_frontier_pull_count_9(SLR2_io_frontier_pull_count_9),
    .io_frontier_pull_count_10(SLR2_io_frontier_pull_count_10),
    .io_frontier_pull_count_11(SLR2_io_frontier_pull_count_11),
    .io_frontier_pull_count_12(SLR2_io_frontier_pull_count_12),
    .io_frontier_pull_count_13(SLR2_io_frontier_pull_count_13),
    .io_frontier_pull_count_14(SLR2_io_frontier_pull_count_14),
    .io_frontier_pull_count_15(SLR2_io_frontier_pull_count_15),
    .io_frontier_pull_count_16(SLR2_io_frontier_pull_count_16),
    .io_frontier_pull_count_17(SLR2_io_frontier_pull_count_17),
    .io_last_iteration_0(SLR2_io_last_iteration_0),
    .io_last_iteration_1(SLR2_io_last_iteration_1),
    .io_last_iteration_2(SLR2_io_last_iteration_2),
    .io_last_iteration_3(SLR2_io_last_iteration_3),
    .io_last_iteration_4(SLR2_io_last_iteration_4),
    .io_last_iteration_5(SLR2_io_last_iteration_5),
    .io_last_iteration_6(SLR2_io_last_iteration_6),
    .io_last_iteration_7(SLR2_io_last_iteration_7),
    .io_last_iteration_8(SLR2_io_last_iteration_8),
    .io_last_iteration_9(SLR2_io_last_iteration_9),
    .io_last_iteration_10(SLR2_io_last_iteration_10),
    .io_last_iteration_11(SLR2_io_last_iteration_11),
    .io_last_iteration_12(SLR2_io_last_iteration_12),
    .io_last_iteration_13(SLR2_io_last_iteration_13),
    .io_last_iteration_14(SLR2_io_last_iteration_14),
    .io_last_iteration_15(SLR2_io_last_iteration_15),
    .io_last_iteration_16(SLR2_io_last_iteration_16),
    .io_last_iteration_17(SLR2_io_last_iteration_17),
    .io_init_bram_0(SLR2_io_init_bram_0),
    .io_init_bram_1(SLR2_io_init_bram_1),
    .io_init_bram_2(SLR2_io_init_bram_2),
    .io_init_bram_3(SLR2_io_init_bram_3),
    .io_init_bram_4(SLR2_io_init_bram_4),
    .io_init_bram_5(SLR2_io_init_bram_5),
    .io_init_bram_6(SLR2_io_init_bram_6),
    .io_init_bram_7(SLR2_io_init_bram_7),
    .io_init_bram_8(SLR2_io_init_bram_8),
    .io_init_bram_9(SLR2_io_init_bram_9),
    .io_init_bram_10(SLR2_io_init_bram_10),
    .io_init_bram_11(SLR2_io_init_bram_11),
    .io_init_bram_12(SLR2_io_init_bram_12),
    .io_init_bram_13(SLR2_io_init_bram_13),
    .io_init_bram_14(SLR2_io_init_bram_14),
    .io_init_bram_15(SLR2_io_init_bram_15),
    .io_init_bram_16(SLR2_io_init_bram_16),
    .io_init_bram_17(SLR2_io_init_bram_17),
    .io_p2_in_0_ready(SLR2_io_p2_in_0_ready),
    .io_p2_in_0_valid(SLR2_io_p2_in_0_valid),
    .io_p2_in_0_bits(SLR2_io_p2_in_0_bits),
    .io_p2_in_1_ready(SLR2_io_p2_in_1_ready),
    .io_p2_in_1_valid(SLR2_io_p2_in_1_valid),
    .io_p2_in_1_bits(SLR2_io_p2_in_1_bits),
    .io_p2_in_2_ready(SLR2_io_p2_in_2_ready),
    .io_p2_in_2_valid(SLR2_io_p2_in_2_valid),
    .io_p2_in_2_bits(SLR2_io_p2_in_2_bits),
    .io_p2_in_3_ready(SLR2_io_p2_in_3_ready),
    .io_p2_in_3_valid(SLR2_io_p2_in_3_valid),
    .io_p2_in_3_bits(SLR2_io_p2_in_3_bits),
    .io_p2_in_4_ready(SLR2_io_p2_in_4_ready),
    .io_p2_in_4_valid(SLR2_io_p2_in_4_valid),
    .io_p2_in_4_bits(SLR2_io_p2_in_4_bits),
    .io_p2_in_5_ready(SLR2_io_p2_in_5_ready),
    .io_p2_in_5_valid(SLR2_io_p2_in_5_valid),
    .io_p2_in_5_bits(SLR2_io_p2_in_5_bits),
    .io_p2_in_6_ready(SLR2_io_p2_in_6_ready),
    .io_p2_in_6_valid(SLR2_io_p2_in_6_valid),
    .io_p2_in_6_bits(SLR2_io_p2_in_6_bits),
    .io_p2_in_7_ready(SLR2_io_p2_in_7_ready),
    .io_p2_in_7_valid(SLR2_io_p2_in_7_valid),
    .io_p2_in_7_bits(SLR2_io_p2_in_7_bits),
    .io_p2_in_8_ready(SLR2_io_p2_in_8_ready),
    .io_p2_in_8_valid(SLR2_io_p2_in_8_valid),
    .io_p2_in_8_bits(SLR2_io_p2_in_8_bits),
    .io_p2_in_9_ready(SLR2_io_p2_in_9_ready),
    .io_p2_in_9_valid(SLR2_io_p2_in_9_valid),
    .io_p2_in_9_bits(SLR2_io_p2_in_9_bits),
    .io_p2_in_10_ready(SLR2_io_p2_in_10_ready),
    .io_p2_in_10_valid(SLR2_io_p2_in_10_valid),
    .io_p2_in_10_bits(SLR2_io_p2_in_10_bits),
    .io_p2_in_11_ready(SLR2_io_p2_in_11_ready),
    .io_p2_in_11_valid(SLR2_io_p2_in_11_valid),
    .io_p2_in_11_bits(SLR2_io_p2_in_11_bits),
    .io_p2_in_12_ready(SLR2_io_p2_in_12_ready),
    .io_p2_in_12_valid(SLR2_io_p2_in_12_valid),
    .io_p2_in_12_bits(SLR2_io_p2_in_12_bits),
    .io_p2_in_13_ready(SLR2_io_p2_in_13_ready),
    .io_p2_in_13_valid(SLR2_io_p2_in_13_valid),
    .io_p2_in_13_bits(SLR2_io_p2_in_13_bits),
    .io_p2_in_14_ready(SLR2_io_p2_in_14_ready),
    .io_p2_in_14_valid(SLR2_io_p2_in_14_valid),
    .io_p2_in_14_bits(SLR2_io_p2_in_14_bits),
    .io_p2_in_15_ready(SLR2_io_p2_in_15_ready),
    .io_p2_in_15_valid(SLR2_io_p2_in_15_valid),
    .io_p2_in_15_bits(SLR2_io_p2_in_15_bits),
    .io_p2_in_16_ready(SLR2_io_p2_in_16_ready),
    .io_p2_in_16_valid(SLR2_io_p2_in_16_valid),
    .io_p2_in_16_bits(SLR2_io_p2_in_16_bits),
    .io_p2_in_17_ready(SLR2_io_p2_in_17_ready),
    .io_p2_in_17_valid(SLR2_io_p2_in_17_valid),
    .io_p2_in_17_bits(SLR2_io_p2_in_17_bits),
    .io_p2_in_18_ready(SLR2_io_p2_in_18_ready),
    .io_p2_in_18_valid(SLR2_io_p2_in_18_valid),
    .io_p2_in_18_bits(SLR2_io_p2_in_18_bits),
    .io_p2_in_19_ready(SLR2_io_p2_in_19_ready),
    .io_p2_in_19_valid(SLR2_io_p2_in_19_valid),
    .io_p2_in_19_bits(SLR2_io_p2_in_19_bits),
    .io_p2_in_20_ready(SLR2_io_p2_in_20_ready),
    .io_p2_in_20_valid(SLR2_io_p2_in_20_valid),
    .io_p2_in_20_bits(SLR2_io_p2_in_20_bits),
    .io_p2_in_21_ready(SLR2_io_p2_in_21_ready),
    .io_p2_in_21_valid(SLR2_io_p2_in_21_valid),
    .io_p2_in_21_bits(SLR2_io_p2_in_21_bits),
    .io_p2_in_22_ready(SLR2_io_p2_in_22_ready),
    .io_p2_in_22_valid(SLR2_io_p2_in_22_valid),
    .io_p2_in_22_bits(SLR2_io_p2_in_22_bits),
    .io_p2_in_23_ready(SLR2_io_p2_in_23_ready),
    .io_p2_in_23_valid(SLR2_io_p2_in_23_valid),
    .io_p2_in_23_bits(SLR2_io_p2_in_23_bits),
    .io_p2_in_24_ready(SLR2_io_p2_in_24_ready),
    .io_p2_in_24_valid(SLR2_io_p2_in_24_valid),
    .io_p2_in_24_bits(SLR2_io_p2_in_24_bits),
    .io_p2_in_25_ready(SLR2_io_p2_in_25_ready),
    .io_p2_in_25_valid(SLR2_io_p2_in_25_valid),
    .io_p2_in_25_bits(SLR2_io_p2_in_25_bits),
    .io_p2_in_26_ready(SLR2_io_p2_in_26_ready),
    .io_p2_in_26_valid(SLR2_io_p2_in_26_valid),
    .io_p2_in_26_bits(SLR2_io_p2_in_26_bits),
    .io_p2_in_27_ready(SLR2_io_p2_in_27_ready),
    .io_p2_in_27_valid(SLR2_io_p2_in_27_valid),
    .io_p2_in_27_bits(SLR2_io_p2_in_27_bits),
    .io_p2_in_28_ready(SLR2_io_p2_in_28_ready),
    .io_p2_in_28_valid(SLR2_io_p2_in_28_valid),
    .io_p2_in_28_bits(SLR2_io_p2_in_28_bits),
    .io_p2_in_29_ready(SLR2_io_p2_in_29_ready),
    .io_p2_in_29_valid(SLR2_io_p2_in_29_valid),
    .io_p2_in_29_bits(SLR2_io_p2_in_29_bits),
    .io_p2_in_30_ready(SLR2_io_p2_in_30_ready),
    .io_p2_in_30_valid(SLR2_io_p2_in_30_valid),
    .io_p2_in_30_bits(SLR2_io_p2_in_30_bits),
    .io_p2_in_31_ready(SLR2_io_p2_in_31_ready),
    .io_p2_in_31_valid(SLR2_io_p2_in_31_valid),
    .io_p2_in_31_bits(SLR2_io_p2_in_31_bits),
    .io_p2_in_32_ready(SLR2_io_p2_in_32_ready),
    .io_p2_in_32_valid(SLR2_io_p2_in_32_valid),
    .io_p2_in_32_bits(SLR2_io_p2_in_32_bits),
    .io_p2_in_33_ready(SLR2_io_p2_in_33_ready),
    .io_p2_in_33_valid(SLR2_io_p2_in_33_valid),
    .io_p2_in_33_bits(SLR2_io_p2_in_33_bits),
    .io_p2_in_34_ready(SLR2_io_p2_in_34_ready),
    .io_p2_in_34_valid(SLR2_io_p2_in_34_valid),
    .io_p2_in_34_bits(SLR2_io_p2_in_34_bits),
    .io_p2_in_35_ready(SLR2_io_p2_in_35_ready),
    .io_p2_in_35_valid(SLR2_io_p2_in_35_valid),
    .io_p2_in_35_bits(SLR2_io_p2_in_35_bits),
    .io_p2_in_36_ready(SLR2_io_p2_in_36_ready),
    .io_p2_in_36_valid(SLR2_io_p2_in_36_valid),
    .io_p2_in_36_bits(SLR2_io_p2_in_36_bits),
    .io_p2_in_37_ready(SLR2_io_p2_in_37_ready),
    .io_p2_in_37_valid(SLR2_io_p2_in_37_valid),
    .io_p2_in_37_bits(SLR2_io_p2_in_37_bits),
    .io_p2_in_38_ready(SLR2_io_p2_in_38_ready),
    .io_p2_in_38_valid(SLR2_io_p2_in_38_valid),
    .io_p2_in_38_bits(SLR2_io_p2_in_38_bits),
    .io_p2_in_39_ready(SLR2_io_p2_in_39_ready),
    .io_p2_in_39_valid(SLR2_io_p2_in_39_valid),
    .io_p2_in_39_bits(SLR2_io_p2_in_39_bits),
    .io_p2_in_40_ready(SLR2_io_p2_in_40_ready),
    .io_p2_in_40_valid(SLR2_io_p2_in_40_valid),
    .io_p2_in_40_bits(SLR2_io_p2_in_40_bits),
    .io_p2_in_41_ready(SLR2_io_p2_in_41_ready),
    .io_p2_in_41_valid(SLR2_io_p2_in_41_valid),
    .io_p2_in_41_bits(SLR2_io_p2_in_41_bits),
    .io_p2_in_42_ready(SLR2_io_p2_in_42_ready),
    .io_p2_in_42_valid(SLR2_io_p2_in_42_valid),
    .io_p2_in_42_bits(SLR2_io_p2_in_42_bits),
    .io_p2_in_43_ready(SLR2_io_p2_in_43_ready),
    .io_p2_in_43_valid(SLR2_io_p2_in_43_valid),
    .io_p2_in_43_bits(SLR2_io_p2_in_43_bits),
    .io_p2_in_44_ready(SLR2_io_p2_in_44_ready),
    .io_p2_in_44_valid(SLR2_io_p2_in_44_valid),
    .io_p2_in_44_bits(SLR2_io_p2_in_44_bits),
    .io_p2_in_45_ready(SLR2_io_p2_in_45_ready),
    .io_p2_in_45_valid(SLR2_io_p2_in_45_valid),
    .io_p2_in_45_bits(SLR2_io_p2_in_45_bits),
    .io_p2_in_46_ready(SLR2_io_p2_in_46_ready),
    .io_p2_in_46_valid(SLR2_io_p2_in_46_valid),
    .io_p2_in_46_bits(SLR2_io_p2_in_46_bits),
    .io_p2_in_47_ready(SLR2_io_p2_in_47_ready),
    .io_p2_in_47_valid(SLR2_io_p2_in_47_valid),
    .io_p2_in_47_bits(SLR2_io_p2_in_47_bits),
    .io_p2_in_48_ready(SLR2_io_p2_in_48_ready),
    .io_p2_in_48_valid(SLR2_io_p2_in_48_valid),
    .io_p2_in_48_bits(SLR2_io_p2_in_48_bits),
    .io_p2_in_49_ready(SLR2_io_p2_in_49_ready),
    .io_p2_in_49_valid(SLR2_io_p2_in_49_valid),
    .io_p2_in_49_bits(SLR2_io_p2_in_49_bits),
    .io_p2_in_50_ready(SLR2_io_p2_in_50_ready),
    .io_p2_in_50_valid(SLR2_io_p2_in_50_valid),
    .io_p2_in_50_bits(SLR2_io_p2_in_50_bits),
    .io_p2_in_51_ready(SLR2_io_p2_in_51_ready),
    .io_p2_in_51_valid(SLR2_io_p2_in_51_valid),
    .io_p2_in_51_bits(SLR2_io_p2_in_51_bits),
    .io_p2_in_52_ready(SLR2_io_p2_in_52_ready),
    .io_p2_in_52_valid(SLR2_io_p2_in_52_valid),
    .io_p2_in_52_bits(SLR2_io_p2_in_52_bits),
    .io_p2_in_53_ready(SLR2_io_p2_in_53_ready),
    .io_p2_in_53_valid(SLR2_io_p2_in_53_valid),
    .io_p2_in_53_bits(SLR2_io_p2_in_53_bits),
    .io_p2_in_54_ready(SLR2_io_p2_in_54_ready),
    .io_p2_in_54_valid(SLR2_io_p2_in_54_valid),
    .io_p2_in_54_bits(SLR2_io_p2_in_54_bits),
    .io_p2_in_55_ready(SLR2_io_p2_in_55_ready),
    .io_p2_in_55_valid(SLR2_io_p2_in_55_valid),
    .io_p2_in_55_bits(SLR2_io_p2_in_55_bits),
    .io_p2_in_56_ready(SLR2_io_p2_in_56_ready),
    .io_p2_in_56_valid(SLR2_io_p2_in_56_valid),
    .io_p2_in_56_bits(SLR2_io_p2_in_56_bits),
    .io_p2_in_57_ready(SLR2_io_p2_in_57_ready),
    .io_p2_in_57_valid(SLR2_io_p2_in_57_valid),
    .io_p2_in_57_bits(SLR2_io_p2_in_57_bits),
    .io_p2_in_58_ready(SLR2_io_p2_in_58_ready),
    .io_p2_in_58_valid(SLR2_io_p2_in_58_valid),
    .io_p2_in_58_bits(SLR2_io_p2_in_58_bits),
    .io_p2_in_59_ready(SLR2_io_p2_in_59_ready),
    .io_p2_in_59_valid(SLR2_io_p2_in_59_valid),
    .io_p2_in_59_bits(SLR2_io_p2_in_59_bits),
    .io_p2_in_60_ready(SLR2_io_p2_in_60_ready),
    .io_p2_in_60_valid(SLR2_io_p2_in_60_valid),
    .io_p2_in_60_bits(SLR2_io_p2_in_60_bits),
    .io_p2_in_61_ready(SLR2_io_p2_in_61_ready),
    .io_p2_in_61_valid(SLR2_io_p2_in_61_valid),
    .io_p2_in_61_bits(SLR2_io_p2_in_61_bits),
    .io_p2_in_62_ready(SLR2_io_p2_in_62_ready),
    .io_p2_in_62_valid(SLR2_io_p2_in_62_valid),
    .io_p2_in_62_bits(SLR2_io_p2_in_62_bits),
    .io_p2_in_63_ready(SLR2_io_p2_in_63_ready),
    .io_p2_in_63_valid(SLR2_io_p2_in_63_valid),
    .io_p2_in_63_bits(SLR2_io_p2_in_63_bits),
    .io_p2_in_64_ready(SLR2_io_p2_in_64_ready),
    .io_p2_in_64_valid(SLR2_io_p2_in_64_valid),
    .io_p2_in_64_bits(SLR2_io_p2_in_64_bits),
    .io_p2_in_65_ready(SLR2_io_p2_in_65_ready),
    .io_p2_in_65_valid(SLR2_io_p2_in_65_valid),
    .io_p2_in_65_bits(SLR2_io_p2_in_65_bits),
    .io_p2_in_66_ready(SLR2_io_p2_in_66_ready),
    .io_p2_in_66_valid(SLR2_io_p2_in_66_valid),
    .io_p2_in_66_bits(SLR2_io_p2_in_66_bits),
    .io_p2_in_67_ready(SLR2_io_p2_in_67_ready),
    .io_p2_in_67_valid(SLR2_io_p2_in_67_valid),
    .io_p2_in_67_bits(SLR2_io_p2_in_67_bits),
    .io_p2_in_68_ready(SLR2_io_p2_in_68_ready),
    .io_p2_in_68_valid(SLR2_io_p2_in_68_valid),
    .io_p2_in_68_bits(SLR2_io_p2_in_68_bits),
    .io_p2_in_69_ready(SLR2_io_p2_in_69_ready),
    .io_p2_in_69_valid(SLR2_io_p2_in_69_valid),
    .io_p2_in_69_bits(SLR2_io_p2_in_69_bits),
    .io_p2_in_70_ready(SLR2_io_p2_in_70_ready),
    .io_p2_in_70_valid(SLR2_io_p2_in_70_valid),
    .io_p2_in_70_bits(SLR2_io_p2_in_70_bits),
    .io_p2_in_71_ready(SLR2_io_p2_in_71_ready),
    .io_p2_in_71_valid(SLR2_io_p2_in_71_valid),
    .io_p2_in_71_bits(SLR2_io_p2_in_71_bits),
    .io_frontier_in_0_ready(SLR2_io_frontier_in_0_ready),
    .io_frontier_in_0_valid(SLR2_io_frontier_in_0_valid),
    .io_frontier_in_0_bits(SLR2_io_frontier_in_0_bits),
    .io_frontier_in_1_ready(SLR2_io_frontier_in_1_ready),
    .io_frontier_in_1_valid(SLR2_io_frontier_in_1_valid),
    .io_frontier_in_1_bits(SLR2_io_frontier_in_1_bits),
    .io_frontier_in_2_ready(SLR2_io_frontier_in_2_ready),
    .io_frontier_in_2_valid(SLR2_io_frontier_in_2_valid),
    .io_frontier_in_2_bits(SLR2_io_frontier_in_2_bits),
    .io_frontier_in_3_ready(SLR2_io_frontier_in_3_ready),
    .io_frontier_in_3_valid(SLR2_io_frontier_in_3_valid),
    .io_frontier_in_3_bits(SLR2_io_frontier_in_3_bits),
    .io_frontier_in_4_ready(SLR2_io_frontier_in_4_ready),
    .io_frontier_in_4_valid(SLR2_io_frontier_in_4_valid),
    .io_frontier_in_4_bits(SLR2_io_frontier_in_4_bits),
    .io_frontier_in_5_ready(SLR2_io_frontier_in_5_ready),
    .io_frontier_in_5_valid(SLR2_io_frontier_in_5_valid),
    .io_frontier_in_5_bits(SLR2_io_frontier_in_5_bits),
    .io_frontier_in_6_ready(SLR2_io_frontier_in_6_ready),
    .io_frontier_in_6_valid(SLR2_io_frontier_in_6_valid),
    .io_frontier_in_6_bits(SLR2_io_frontier_in_6_bits),
    .io_frontier_in_7_ready(SLR2_io_frontier_in_7_ready),
    .io_frontier_in_7_valid(SLR2_io_frontier_in_7_valid),
    .io_frontier_in_7_bits(SLR2_io_frontier_in_7_bits),
    .io_frontier_in_8_ready(SLR2_io_frontier_in_8_ready),
    .io_frontier_in_8_valid(SLR2_io_frontier_in_8_valid),
    .io_frontier_in_8_bits(SLR2_io_frontier_in_8_bits),
    .io_frontier_in_9_ready(SLR2_io_frontier_in_9_ready),
    .io_frontier_in_9_valid(SLR2_io_frontier_in_9_valid),
    .io_frontier_in_9_bits(SLR2_io_frontier_in_9_bits),
    .io_frontier_in_10_ready(SLR2_io_frontier_in_10_ready),
    .io_frontier_in_10_valid(SLR2_io_frontier_in_10_valid),
    .io_frontier_in_10_bits(SLR2_io_frontier_in_10_bits),
    .io_frontier_in_11_ready(SLR2_io_frontier_in_11_ready),
    .io_frontier_in_11_valid(SLR2_io_frontier_in_11_valid),
    .io_frontier_in_11_bits(SLR2_io_frontier_in_11_bits),
    .io_frontier_in_12_ready(SLR2_io_frontier_in_12_ready),
    .io_frontier_in_12_valid(SLR2_io_frontier_in_12_valid),
    .io_frontier_in_12_bits(SLR2_io_frontier_in_12_bits),
    .io_frontier_in_13_ready(SLR2_io_frontier_in_13_ready),
    .io_frontier_in_13_valid(SLR2_io_frontier_in_13_valid),
    .io_frontier_in_13_bits(SLR2_io_frontier_in_13_bits),
    .io_frontier_in_14_ready(SLR2_io_frontier_in_14_ready),
    .io_frontier_in_14_valid(SLR2_io_frontier_in_14_valid),
    .io_frontier_in_14_bits(SLR2_io_frontier_in_14_bits),
    .io_frontier_in_15_ready(SLR2_io_frontier_in_15_ready),
    .io_frontier_in_15_valid(SLR2_io_frontier_in_15_valid),
    .io_frontier_in_15_bits(SLR2_io_frontier_in_15_bits),
    .io_frontier_in_16_ready(SLR2_io_frontier_in_16_ready),
    .io_frontier_in_16_valid(SLR2_io_frontier_in_16_valid),
    .io_frontier_in_16_bits(SLR2_io_frontier_in_16_bits),
    .io_frontier_in_17_ready(SLR2_io_frontier_in_17_ready),
    .io_frontier_in_17_valid(SLR2_io_frontier_in_17_valid),
    .io_frontier_in_17_bits(SLR2_io_frontier_in_17_bits),
    .io_frontier_in_18_ready(SLR2_io_frontier_in_18_ready),
    .io_frontier_in_18_valid(SLR2_io_frontier_in_18_valid),
    .io_frontier_in_18_bits(SLR2_io_frontier_in_18_bits),
    .io_frontier_in_19_ready(SLR2_io_frontier_in_19_ready),
    .io_frontier_in_19_valid(SLR2_io_frontier_in_19_valid),
    .io_frontier_in_19_bits(SLR2_io_frontier_in_19_bits),
    .io_frontier_in_20_ready(SLR2_io_frontier_in_20_ready),
    .io_frontier_in_20_valid(SLR2_io_frontier_in_20_valid),
    .io_frontier_in_20_bits(SLR2_io_frontier_in_20_bits),
    .io_frontier_in_21_ready(SLR2_io_frontier_in_21_ready),
    .io_frontier_in_21_valid(SLR2_io_frontier_in_21_valid),
    .io_frontier_in_21_bits(SLR2_io_frontier_in_21_bits),
    .io_frontier_in_22_ready(SLR2_io_frontier_in_22_ready),
    .io_frontier_in_22_valid(SLR2_io_frontier_in_22_valid),
    .io_frontier_in_22_bits(SLR2_io_frontier_in_22_bits),
    .io_frontier_in_23_ready(SLR2_io_frontier_in_23_ready),
    .io_frontier_in_23_valid(SLR2_io_frontier_in_23_valid),
    .io_frontier_in_23_bits(SLR2_io_frontier_in_23_bits),
    .io_frontier_in_24_ready(SLR2_io_frontier_in_24_ready),
    .io_frontier_in_24_valid(SLR2_io_frontier_in_24_valid),
    .io_frontier_in_24_bits(SLR2_io_frontier_in_24_bits),
    .io_frontier_in_25_ready(SLR2_io_frontier_in_25_ready),
    .io_frontier_in_25_valid(SLR2_io_frontier_in_25_valid),
    .io_frontier_in_25_bits(SLR2_io_frontier_in_25_bits),
    .io_frontier_in_26_ready(SLR2_io_frontier_in_26_ready),
    .io_frontier_in_26_valid(SLR2_io_frontier_in_26_valid),
    .io_frontier_in_26_bits(SLR2_io_frontier_in_26_bits),
    .io_frontier_in_27_ready(SLR2_io_frontier_in_27_ready),
    .io_frontier_in_27_valid(SLR2_io_frontier_in_27_valid),
    .io_frontier_in_27_bits(SLR2_io_frontier_in_27_bits),
    .io_frontier_in_28_ready(SLR2_io_frontier_in_28_ready),
    .io_frontier_in_28_valid(SLR2_io_frontier_in_28_valid),
    .io_frontier_in_28_bits(SLR2_io_frontier_in_28_bits),
    .io_frontier_in_29_ready(SLR2_io_frontier_in_29_ready),
    .io_frontier_in_29_valid(SLR2_io_frontier_in_29_valid),
    .io_frontier_in_29_bits(SLR2_io_frontier_in_29_bits),
    .io_frontier_in_30_ready(SLR2_io_frontier_in_30_ready),
    .io_frontier_in_30_valid(SLR2_io_frontier_in_30_valid),
    .io_frontier_in_30_bits(SLR2_io_frontier_in_30_bits),
    .io_frontier_in_31_ready(SLR2_io_frontier_in_31_ready),
    .io_frontier_in_31_valid(SLR2_io_frontier_in_31_valid),
    .io_frontier_in_31_bits(SLR2_io_frontier_in_31_bits),
    .io_frontier_in_32_ready(SLR2_io_frontier_in_32_ready),
    .io_frontier_in_32_valid(SLR2_io_frontier_in_32_valid),
    .io_frontier_in_32_bits(SLR2_io_frontier_in_32_bits),
    .io_frontier_in_33_ready(SLR2_io_frontier_in_33_ready),
    .io_frontier_in_33_valid(SLR2_io_frontier_in_33_valid),
    .io_frontier_in_33_bits(SLR2_io_frontier_in_33_bits),
    .io_frontier_in_34_ready(SLR2_io_frontier_in_34_ready),
    .io_frontier_in_34_valid(SLR2_io_frontier_in_34_valid),
    .io_frontier_in_34_bits(SLR2_io_frontier_in_34_bits),
    .io_frontier_in_35_ready(SLR2_io_frontier_in_35_ready),
    .io_frontier_in_35_valid(SLR2_io_frontier_in_35_valid),
    .io_frontier_in_35_bits(SLR2_io_frontier_in_35_bits),
    .io_frontier_in_36_ready(SLR2_io_frontier_in_36_ready),
    .io_frontier_in_36_valid(SLR2_io_frontier_in_36_valid),
    .io_frontier_in_36_bits(SLR2_io_frontier_in_36_bits),
    .io_frontier_in_37_ready(SLR2_io_frontier_in_37_ready),
    .io_frontier_in_37_valid(SLR2_io_frontier_in_37_valid),
    .io_frontier_in_37_bits(SLR2_io_frontier_in_37_bits),
    .io_frontier_in_38_ready(SLR2_io_frontier_in_38_ready),
    .io_frontier_in_38_valid(SLR2_io_frontier_in_38_valid),
    .io_frontier_in_38_bits(SLR2_io_frontier_in_38_bits),
    .io_frontier_in_39_ready(SLR2_io_frontier_in_39_ready),
    .io_frontier_in_39_valid(SLR2_io_frontier_in_39_valid),
    .io_frontier_in_39_bits(SLR2_io_frontier_in_39_bits),
    .io_frontier_in_40_ready(SLR2_io_frontier_in_40_ready),
    .io_frontier_in_40_valid(SLR2_io_frontier_in_40_valid),
    .io_frontier_in_40_bits(SLR2_io_frontier_in_40_bits),
    .io_frontier_in_41_ready(SLR2_io_frontier_in_41_ready),
    .io_frontier_in_41_valid(SLR2_io_frontier_in_41_valid),
    .io_frontier_in_41_bits(SLR2_io_frontier_in_41_bits),
    .io_frontier_in_42_ready(SLR2_io_frontier_in_42_ready),
    .io_frontier_in_42_valid(SLR2_io_frontier_in_42_valid),
    .io_frontier_in_42_bits(SLR2_io_frontier_in_42_bits),
    .io_frontier_in_43_ready(SLR2_io_frontier_in_43_ready),
    .io_frontier_in_43_valid(SLR2_io_frontier_in_43_valid),
    .io_frontier_in_43_bits(SLR2_io_frontier_in_43_bits),
    .io_frontier_in_44_ready(SLR2_io_frontier_in_44_ready),
    .io_frontier_in_44_valid(SLR2_io_frontier_in_44_valid),
    .io_frontier_in_44_bits(SLR2_io_frontier_in_44_bits),
    .io_frontier_in_45_ready(SLR2_io_frontier_in_45_ready),
    .io_frontier_in_45_valid(SLR2_io_frontier_in_45_valid),
    .io_frontier_in_45_bits(SLR2_io_frontier_in_45_bits),
    .io_frontier_in_46_ready(SLR2_io_frontier_in_46_ready),
    .io_frontier_in_46_valid(SLR2_io_frontier_in_46_valid),
    .io_frontier_in_46_bits(SLR2_io_frontier_in_46_bits),
    .io_frontier_in_47_ready(SLR2_io_frontier_in_47_ready),
    .io_frontier_in_47_valid(SLR2_io_frontier_in_47_valid),
    .io_frontier_in_47_bits(SLR2_io_frontier_in_47_bits),
    .io_frontier_in_48_ready(SLR2_io_frontier_in_48_ready),
    .io_frontier_in_48_valid(SLR2_io_frontier_in_48_valid),
    .io_frontier_in_48_bits(SLR2_io_frontier_in_48_bits),
    .io_frontier_in_49_ready(SLR2_io_frontier_in_49_ready),
    .io_frontier_in_49_valid(SLR2_io_frontier_in_49_valid),
    .io_frontier_in_49_bits(SLR2_io_frontier_in_49_bits),
    .io_frontier_in_50_ready(SLR2_io_frontier_in_50_ready),
    .io_frontier_in_50_valid(SLR2_io_frontier_in_50_valid),
    .io_frontier_in_50_bits(SLR2_io_frontier_in_50_bits),
    .io_frontier_in_51_ready(SLR2_io_frontier_in_51_ready),
    .io_frontier_in_51_valid(SLR2_io_frontier_in_51_valid),
    .io_frontier_in_51_bits(SLR2_io_frontier_in_51_bits),
    .io_frontier_in_52_ready(SLR2_io_frontier_in_52_ready),
    .io_frontier_in_52_valid(SLR2_io_frontier_in_52_valid),
    .io_frontier_in_52_bits(SLR2_io_frontier_in_52_bits),
    .io_frontier_in_53_ready(SLR2_io_frontier_in_53_ready),
    .io_frontier_in_53_valid(SLR2_io_frontier_in_53_valid),
    .io_frontier_in_53_bits(SLR2_io_frontier_in_53_bits),
    .io_frontier_in_54_ready(SLR2_io_frontier_in_54_ready),
    .io_frontier_in_54_valid(SLR2_io_frontier_in_54_valid),
    .io_frontier_in_54_bits(SLR2_io_frontier_in_54_bits),
    .io_frontier_in_55_ready(SLR2_io_frontier_in_55_ready),
    .io_frontier_in_55_valid(SLR2_io_frontier_in_55_valid),
    .io_frontier_in_55_bits(SLR2_io_frontier_in_55_bits),
    .io_frontier_in_56_ready(SLR2_io_frontier_in_56_ready),
    .io_frontier_in_56_valid(SLR2_io_frontier_in_56_valid),
    .io_frontier_in_56_bits(SLR2_io_frontier_in_56_bits),
    .io_frontier_in_57_ready(SLR2_io_frontier_in_57_ready),
    .io_frontier_in_57_valid(SLR2_io_frontier_in_57_valid),
    .io_frontier_in_57_bits(SLR2_io_frontier_in_57_bits),
    .io_frontier_in_58_ready(SLR2_io_frontier_in_58_ready),
    .io_frontier_in_58_valid(SLR2_io_frontier_in_58_valid),
    .io_frontier_in_58_bits(SLR2_io_frontier_in_58_bits),
    .io_frontier_in_59_ready(SLR2_io_frontier_in_59_ready),
    .io_frontier_in_59_valid(SLR2_io_frontier_in_59_valid),
    .io_frontier_in_59_bits(SLR2_io_frontier_in_59_bits),
    .io_frontier_in_60_ready(SLR2_io_frontier_in_60_ready),
    .io_frontier_in_60_valid(SLR2_io_frontier_in_60_valid),
    .io_frontier_in_60_bits(SLR2_io_frontier_in_60_bits),
    .io_frontier_in_61_ready(SLR2_io_frontier_in_61_ready),
    .io_frontier_in_61_valid(SLR2_io_frontier_in_61_valid),
    .io_frontier_in_61_bits(SLR2_io_frontier_in_61_bits),
    .io_frontier_in_62_ready(SLR2_io_frontier_in_62_ready),
    .io_frontier_in_62_valid(SLR2_io_frontier_in_62_valid),
    .io_frontier_in_62_bits(SLR2_io_frontier_in_62_bits),
    .io_frontier_in_63_ready(SLR2_io_frontier_in_63_ready),
    .io_frontier_in_63_valid(SLR2_io_frontier_in_63_valid),
    .io_frontier_in_63_bits(SLR2_io_frontier_in_63_bits),
    .io_frontier_in_64_ready(SLR2_io_frontier_in_64_ready),
    .io_frontier_in_64_valid(SLR2_io_frontier_in_64_valid),
    .io_frontier_in_64_bits(SLR2_io_frontier_in_64_bits),
    .io_frontier_in_65_ready(SLR2_io_frontier_in_65_ready),
    .io_frontier_in_65_valid(SLR2_io_frontier_in_65_valid),
    .io_frontier_in_65_bits(SLR2_io_frontier_in_65_bits),
    .io_frontier_in_66_ready(SLR2_io_frontier_in_66_ready),
    .io_frontier_in_66_valid(SLR2_io_frontier_in_66_valid),
    .io_frontier_in_66_bits(SLR2_io_frontier_in_66_bits),
    .io_frontier_in_67_ready(SLR2_io_frontier_in_67_ready),
    .io_frontier_in_67_valid(SLR2_io_frontier_in_67_valid),
    .io_frontier_in_67_bits(SLR2_io_frontier_in_67_bits),
    .io_frontier_in_68_ready(SLR2_io_frontier_in_68_ready),
    .io_frontier_in_68_valid(SLR2_io_frontier_in_68_valid),
    .io_frontier_in_68_bits(SLR2_io_frontier_in_68_bits),
    .io_frontier_in_69_ready(SLR2_io_frontier_in_69_ready),
    .io_frontier_in_69_valid(SLR2_io_frontier_in_69_valid),
    .io_frontier_in_69_bits(SLR2_io_frontier_in_69_bits),
    .io_frontier_in_70_ready(SLR2_io_frontier_in_70_ready),
    .io_frontier_in_70_valid(SLR2_io_frontier_in_70_valid),
    .io_frontier_in_70_bits(SLR2_io_frontier_in_70_bits),
    .io_frontier_in_71_ready(SLR2_io_frontier_in_71_ready),
    .io_frontier_in_71_valid(SLR2_io_frontier_in_71_valid),
    .io_frontier_in_71_bits(SLR2_io_frontier_in_71_bits),
    .io_p2_out_0_ready(SLR2_io_p2_out_0_ready),
    .io_p2_out_0_valid(SLR2_io_p2_out_0_valid),
    .io_p2_out_0_bits(SLR2_io_p2_out_0_bits),
    .io_p2_out_1_ready(SLR2_io_p2_out_1_ready),
    .io_p2_out_1_valid(SLR2_io_p2_out_1_valid),
    .io_p2_out_1_bits(SLR2_io_p2_out_1_bits),
    .io_p2_out_2_ready(SLR2_io_p2_out_2_ready),
    .io_p2_out_2_valid(SLR2_io_p2_out_2_valid),
    .io_p2_out_2_bits(SLR2_io_p2_out_2_bits),
    .io_p2_out_3_ready(SLR2_io_p2_out_3_ready),
    .io_p2_out_3_valid(SLR2_io_p2_out_3_valid),
    .io_p2_out_3_bits(SLR2_io_p2_out_3_bits),
    .io_p2_out_4_ready(SLR2_io_p2_out_4_ready),
    .io_p2_out_4_valid(SLR2_io_p2_out_4_valid),
    .io_p2_out_4_bits(SLR2_io_p2_out_4_bits),
    .io_p2_out_5_ready(SLR2_io_p2_out_5_ready),
    .io_p2_out_5_valid(SLR2_io_p2_out_5_valid),
    .io_p2_out_5_bits(SLR2_io_p2_out_5_bits),
    .io_p2_out_6_ready(SLR2_io_p2_out_6_ready),
    .io_p2_out_6_valid(SLR2_io_p2_out_6_valid),
    .io_p2_out_6_bits(SLR2_io_p2_out_6_bits),
    .io_p2_out_7_ready(SLR2_io_p2_out_7_ready),
    .io_p2_out_7_valid(SLR2_io_p2_out_7_valid),
    .io_p2_out_7_bits(SLR2_io_p2_out_7_bits),
    .io_p2_out_8_ready(SLR2_io_p2_out_8_ready),
    .io_p2_out_8_valid(SLR2_io_p2_out_8_valid),
    .io_p2_out_8_bits(SLR2_io_p2_out_8_bits),
    .io_p2_out_9_ready(SLR2_io_p2_out_9_ready),
    .io_p2_out_9_valid(SLR2_io_p2_out_9_valid),
    .io_p2_out_9_bits(SLR2_io_p2_out_9_bits),
    .io_p2_out_10_ready(SLR2_io_p2_out_10_ready),
    .io_p2_out_10_valid(SLR2_io_p2_out_10_valid),
    .io_p2_out_10_bits(SLR2_io_p2_out_10_bits),
    .io_p2_out_11_ready(SLR2_io_p2_out_11_ready),
    .io_p2_out_11_valid(SLR2_io_p2_out_11_valid),
    .io_p2_out_11_bits(SLR2_io_p2_out_11_bits),
    .io_p2_out_12_ready(SLR2_io_p2_out_12_ready),
    .io_p2_out_12_valid(SLR2_io_p2_out_12_valid),
    .io_p2_out_12_bits(SLR2_io_p2_out_12_bits),
    .io_p2_out_13_ready(SLR2_io_p2_out_13_ready),
    .io_p2_out_13_valid(SLR2_io_p2_out_13_valid),
    .io_p2_out_13_bits(SLR2_io_p2_out_13_bits),
    .io_p2_out_14_ready(SLR2_io_p2_out_14_ready),
    .io_p2_out_14_valid(SLR2_io_p2_out_14_valid),
    .io_p2_out_14_bits(SLR2_io_p2_out_14_bits),
    .io_p2_out_15_ready(SLR2_io_p2_out_15_ready),
    .io_p2_out_15_valid(SLR2_io_p2_out_15_valid),
    .io_p2_out_15_bits(SLR2_io_p2_out_15_bits),
    .io_p2_out_16_ready(SLR2_io_p2_out_16_ready),
    .io_p2_out_16_valid(SLR2_io_p2_out_16_valid),
    .io_p2_out_16_bits(SLR2_io_p2_out_16_bits),
    .io_p2_out_17_ready(SLR2_io_p2_out_17_ready),
    .io_p2_out_17_valid(SLR2_io_p2_out_17_valid),
    .io_p2_out_17_bits(SLR2_io_p2_out_17_bits),
    .io_p2_out_18_ready(SLR2_io_p2_out_18_ready),
    .io_p2_out_18_valid(SLR2_io_p2_out_18_valid),
    .io_p2_out_18_bits(SLR2_io_p2_out_18_bits),
    .io_p2_out_19_ready(SLR2_io_p2_out_19_ready),
    .io_p2_out_19_valid(SLR2_io_p2_out_19_valid),
    .io_p2_out_19_bits(SLR2_io_p2_out_19_bits),
    .io_p2_out_20_ready(SLR2_io_p2_out_20_ready),
    .io_p2_out_20_valid(SLR2_io_p2_out_20_valid),
    .io_p2_out_20_bits(SLR2_io_p2_out_20_bits),
    .io_p2_out_21_ready(SLR2_io_p2_out_21_ready),
    .io_p2_out_21_valid(SLR2_io_p2_out_21_valid),
    .io_p2_out_21_bits(SLR2_io_p2_out_21_bits),
    .io_p2_out_22_ready(SLR2_io_p2_out_22_ready),
    .io_p2_out_22_valid(SLR2_io_p2_out_22_valid),
    .io_p2_out_22_bits(SLR2_io_p2_out_22_bits),
    .io_p2_out_23_ready(SLR2_io_p2_out_23_ready),
    .io_p2_out_23_valid(SLR2_io_p2_out_23_valid),
    .io_p2_out_23_bits(SLR2_io_p2_out_23_bits),
    .io_p2_out_24_ready(SLR2_io_p2_out_24_ready),
    .io_p2_out_24_valid(SLR2_io_p2_out_24_valid),
    .io_p2_out_24_bits(SLR2_io_p2_out_24_bits),
    .io_p2_out_25_ready(SLR2_io_p2_out_25_ready),
    .io_p2_out_25_valid(SLR2_io_p2_out_25_valid),
    .io_p2_out_25_bits(SLR2_io_p2_out_25_bits),
    .io_p2_out_26_ready(SLR2_io_p2_out_26_ready),
    .io_p2_out_26_valid(SLR2_io_p2_out_26_valid),
    .io_p2_out_26_bits(SLR2_io_p2_out_26_bits),
    .io_p2_out_27_ready(SLR2_io_p2_out_27_ready),
    .io_p2_out_27_valid(SLR2_io_p2_out_27_valid),
    .io_p2_out_27_bits(SLR2_io_p2_out_27_bits),
    .io_p2_out_28_ready(SLR2_io_p2_out_28_ready),
    .io_p2_out_28_valid(SLR2_io_p2_out_28_valid),
    .io_p2_out_28_bits(SLR2_io_p2_out_28_bits),
    .io_p2_out_29_ready(SLR2_io_p2_out_29_ready),
    .io_p2_out_29_valid(SLR2_io_p2_out_29_valid),
    .io_p2_out_29_bits(SLR2_io_p2_out_29_bits),
    .io_p2_out_30_ready(SLR2_io_p2_out_30_ready),
    .io_p2_out_30_valid(SLR2_io_p2_out_30_valid),
    .io_p2_out_30_bits(SLR2_io_p2_out_30_bits),
    .io_p2_out_31_ready(SLR2_io_p2_out_31_ready),
    .io_p2_out_31_valid(SLR2_io_p2_out_31_valid),
    .io_p2_out_31_bits(SLR2_io_p2_out_31_bits),
    .io_p2_out_32_ready(SLR2_io_p2_out_32_ready),
    .io_p2_out_32_valid(SLR2_io_p2_out_32_valid),
    .io_p2_out_32_bits(SLR2_io_p2_out_32_bits),
    .io_p2_out_33_ready(SLR2_io_p2_out_33_ready),
    .io_p2_out_33_valid(SLR2_io_p2_out_33_valid),
    .io_p2_out_33_bits(SLR2_io_p2_out_33_bits),
    .io_p2_out_34_ready(SLR2_io_p2_out_34_ready),
    .io_p2_out_34_valid(SLR2_io_p2_out_34_valid),
    .io_p2_out_34_bits(SLR2_io_p2_out_34_bits),
    .io_p2_out_35_ready(SLR2_io_p2_out_35_ready),
    .io_p2_out_35_valid(SLR2_io_p2_out_35_valid),
    .io_p2_out_35_bits(SLR2_io_p2_out_35_bits),
    .io_p2_out_36_ready(SLR2_io_p2_out_36_ready),
    .io_p2_out_36_valid(SLR2_io_p2_out_36_valid),
    .io_p2_out_36_bits(SLR2_io_p2_out_36_bits),
    .io_p2_out_37_ready(SLR2_io_p2_out_37_ready),
    .io_p2_out_37_valid(SLR2_io_p2_out_37_valid),
    .io_p2_out_37_bits(SLR2_io_p2_out_37_bits),
    .io_p2_out_38_ready(SLR2_io_p2_out_38_ready),
    .io_p2_out_38_valid(SLR2_io_p2_out_38_valid),
    .io_p2_out_38_bits(SLR2_io_p2_out_38_bits),
    .io_p2_out_39_ready(SLR2_io_p2_out_39_ready),
    .io_p2_out_39_valid(SLR2_io_p2_out_39_valid),
    .io_p2_out_39_bits(SLR2_io_p2_out_39_bits),
    .io_p2_out_40_ready(SLR2_io_p2_out_40_ready),
    .io_p2_out_40_valid(SLR2_io_p2_out_40_valid),
    .io_p2_out_40_bits(SLR2_io_p2_out_40_bits),
    .io_p2_out_41_ready(SLR2_io_p2_out_41_ready),
    .io_p2_out_41_valid(SLR2_io_p2_out_41_valid),
    .io_p2_out_41_bits(SLR2_io_p2_out_41_bits),
    .io_p2_out_42_ready(SLR2_io_p2_out_42_ready),
    .io_p2_out_42_valid(SLR2_io_p2_out_42_valid),
    .io_p2_out_42_bits(SLR2_io_p2_out_42_bits),
    .io_p2_out_43_ready(SLR2_io_p2_out_43_ready),
    .io_p2_out_43_valid(SLR2_io_p2_out_43_valid),
    .io_p2_out_43_bits(SLR2_io_p2_out_43_bits),
    .io_p2_out_44_ready(SLR2_io_p2_out_44_ready),
    .io_p2_out_44_valid(SLR2_io_p2_out_44_valid),
    .io_p2_out_44_bits(SLR2_io_p2_out_44_bits),
    .io_p2_out_45_ready(SLR2_io_p2_out_45_ready),
    .io_p2_out_45_valid(SLR2_io_p2_out_45_valid),
    .io_p2_out_45_bits(SLR2_io_p2_out_45_bits),
    .io_p2_out_46_ready(SLR2_io_p2_out_46_ready),
    .io_p2_out_46_valid(SLR2_io_p2_out_46_valid),
    .io_p2_out_46_bits(SLR2_io_p2_out_46_bits),
    .io_p2_out_47_ready(SLR2_io_p2_out_47_ready),
    .io_p2_out_47_valid(SLR2_io_p2_out_47_valid),
    .io_p2_out_47_bits(SLR2_io_p2_out_47_bits),
    .io_p2_out_48_ready(SLR2_io_p2_out_48_ready),
    .io_p2_out_48_valid(SLR2_io_p2_out_48_valid),
    .io_p2_out_48_bits(SLR2_io_p2_out_48_bits),
    .io_p2_out_49_ready(SLR2_io_p2_out_49_ready),
    .io_p2_out_49_valid(SLR2_io_p2_out_49_valid),
    .io_p2_out_49_bits(SLR2_io_p2_out_49_bits),
    .io_p2_out_50_ready(SLR2_io_p2_out_50_ready),
    .io_p2_out_50_valid(SLR2_io_p2_out_50_valid),
    .io_p2_out_50_bits(SLR2_io_p2_out_50_bits),
    .io_p2_out_51_ready(SLR2_io_p2_out_51_ready),
    .io_p2_out_51_valid(SLR2_io_p2_out_51_valid),
    .io_p2_out_51_bits(SLR2_io_p2_out_51_bits),
    .io_p2_out_52_ready(SLR2_io_p2_out_52_ready),
    .io_p2_out_52_valid(SLR2_io_p2_out_52_valid),
    .io_p2_out_52_bits(SLR2_io_p2_out_52_bits),
    .io_p2_out_53_ready(SLR2_io_p2_out_53_ready),
    .io_p2_out_53_valid(SLR2_io_p2_out_53_valid),
    .io_p2_out_53_bits(SLR2_io_p2_out_53_bits),
    .io_p2_out_54_ready(SLR2_io_p2_out_54_ready),
    .io_p2_out_54_valid(SLR2_io_p2_out_54_valid),
    .io_p2_out_54_bits(SLR2_io_p2_out_54_bits),
    .io_p2_out_55_ready(SLR2_io_p2_out_55_ready),
    .io_p2_out_55_valid(SLR2_io_p2_out_55_valid),
    .io_p2_out_55_bits(SLR2_io_p2_out_55_bits),
    .io_p2_out_56_ready(SLR2_io_p2_out_56_ready),
    .io_p2_out_56_valid(SLR2_io_p2_out_56_valid),
    .io_p2_out_56_bits(SLR2_io_p2_out_56_bits),
    .io_p2_out_57_ready(SLR2_io_p2_out_57_ready),
    .io_p2_out_57_valid(SLR2_io_p2_out_57_valid),
    .io_p2_out_57_bits(SLR2_io_p2_out_57_bits),
    .io_p2_out_58_ready(SLR2_io_p2_out_58_ready),
    .io_p2_out_58_valid(SLR2_io_p2_out_58_valid),
    .io_p2_out_58_bits(SLR2_io_p2_out_58_bits),
    .io_p2_out_59_ready(SLR2_io_p2_out_59_ready),
    .io_p2_out_59_valid(SLR2_io_p2_out_59_valid),
    .io_p2_out_59_bits(SLR2_io_p2_out_59_bits),
    .io_p2_out_60_ready(SLR2_io_p2_out_60_ready),
    .io_p2_out_60_valid(SLR2_io_p2_out_60_valid),
    .io_p2_out_60_bits(SLR2_io_p2_out_60_bits),
    .io_p2_out_61_ready(SLR2_io_p2_out_61_ready),
    .io_p2_out_61_valid(SLR2_io_p2_out_61_valid),
    .io_p2_out_61_bits(SLR2_io_p2_out_61_bits),
    .io_p2_out_62_ready(SLR2_io_p2_out_62_ready),
    .io_p2_out_62_valid(SLR2_io_p2_out_62_valid),
    .io_p2_out_62_bits(SLR2_io_p2_out_62_bits),
    .io_p2_out_63_ready(SLR2_io_p2_out_63_ready),
    .io_p2_out_63_valid(SLR2_io_p2_out_63_valid),
    .io_p2_out_63_bits(SLR2_io_p2_out_63_bits),
    .io_p2_out_64_ready(SLR2_io_p2_out_64_ready),
    .io_p2_out_64_valid(SLR2_io_p2_out_64_valid),
    .io_p2_out_64_bits(SLR2_io_p2_out_64_bits),
    .io_p2_out_65_ready(SLR2_io_p2_out_65_ready),
    .io_p2_out_65_valid(SLR2_io_p2_out_65_valid),
    .io_p2_out_65_bits(SLR2_io_p2_out_65_bits),
    .io_p2_out_66_ready(SLR2_io_p2_out_66_ready),
    .io_p2_out_66_valid(SLR2_io_p2_out_66_valid),
    .io_p2_out_66_bits(SLR2_io_p2_out_66_bits),
    .io_p2_out_67_ready(SLR2_io_p2_out_67_ready),
    .io_p2_out_67_valid(SLR2_io_p2_out_67_valid),
    .io_p2_out_67_bits(SLR2_io_p2_out_67_bits),
    .io_p2_out_68_ready(SLR2_io_p2_out_68_ready),
    .io_p2_out_68_valid(SLR2_io_p2_out_68_valid),
    .io_p2_out_68_bits(SLR2_io_p2_out_68_bits),
    .io_p2_out_69_ready(SLR2_io_p2_out_69_ready),
    .io_p2_out_69_valid(SLR2_io_p2_out_69_valid),
    .io_p2_out_69_bits(SLR2_io_p2_out_69_bits),
    .io_p2_out_70_ready(SLR2_io_p2_out_70_ready),
    .io_p2_out_70_valid(SLR2_io_p2_out_70_valid),
    .io_p2_out_70_bits(SLR2_io_p2_out_70_bits),
    .io_p2_out_71_ready(SLR2_io_p2_out_71_ready),
    .io_p2_out_71_valid(SLR2_io_p2_out_71_valid),
    .io_p2_out_71_bits(SLR2_io_p2_out_71_bits),
    .io_R_array_index_0_ready(SLR2_io_R_array_index_0_ready),
    .io_R_array_index_0_valid(SLR2_io_R_array_index_0_valid),
    .io_R_array_index_0_bits(SLR2_io_R_array_index_0_bits),
    .io_R_array_index_1_ready(SLR2_io_R_array_index_1_ready),
    .io_R_array_index_1_valid(SLR2_io_R_array_index_1_valid),
    .io_R_array_index_1_bits(SLR2_io_R_array_index_1_bits),
    .io_R_array_index_2_ready(SLR2_io_R_array_index_2_ready),
    .io_R_array_index_2_valid(SLR2_io_R_array_index_2_valid),
    .io_R_array_index_2_bits(SLR2_io_R_array_index_2_bits),
    .io_R_array_index_3_ready(SLR2_io_R_array_index_3_ready),
    .io_R_array_index_3_valid(SLR2_io_R_array_index_3_valid),
    .io_R_array_index_3_bits(SLR2_io_R_array_index_3_bits),
    .io_R_array_index_4_ready(SLR2_io_R_array_index_4_ready),
    .io_R_array_index_4_valid(SLR2_io_R_array_index_4_valid),
    .io_R_array_index_4_bits(SLR2_io_R_array_index_4_bits),
    .io_R_array_index_5_ready(SLR2_io_R_array_index_5_ready),
    .io_R_array_index_5_valid(SLR2_io_R_array_index_5_valid),
    .io_R_array_index_5_bits(SLR2_io_R_array_index_5_bits),
    .io_R_array_index_6_ready(SLR2_io_R_array_index_6_ready),
    .io_R_array_index_6_valid(SLR2_io_R_array_index_6_valid),
    .io_R_array_index_6_bits(SLR2_io_R_array_index_6_bits),
    .io_R_array_index_7_ready(SLR2_io_R_array_index_7_ready),
    .io_R_array_index_7_valid(SLR2_io_R_array_index_7_valid),
    .io_R_array_index_7_bits(SLR2_io_R_array_index_7_bits),
    .io_R_array_index_8_ready(SLR2_io_R_array_index_8_ready),
    .io_R_array_index_8_valid(SLR2_io_R_array_index_8_valid),
    .io_R_array_index_8_bits(SLR2_io_R_array_index_8_bits),
    .io_R_array_index_9_ready(SLR2_io_R_array_index_9_ready),
    .io_R_array_index_9_valid(SLR2_io_R_array_index_9_valid),
    .io_R_array_index_9_bits(SLR2_io_R_array_index_9_bits),
    .io_R_array_index_10_ready(SLR2_io_R_array_index_10_ready),
    .io_R_array_index_10_valid(SLR2_io_R_array_index_10_valid),
    .io_R_array_index_10_bits(SLR2_io_R_array_index_10_bits),
    .io_R_array_index_11_ready(SLR2_io_R_array_index_11_ready),
    .io_R_array_index_11_valid(SLR2_io_R_array_index_11_valid),
    .io_R_array_index_11_bits(SLR2_io_R_array_index_11_bits),
    .io_R_array_index_12_ready(SLR2_io_R_array_index_12_ready),
    .io_R_array_index_12_valid(SLR2_io_R_array_index_12_valid),
    .io_R_array_index_12_bits(SLR2_io_R_array_index_12_bits),
    .io_R_array_index_13_ready(SLR2_io_R_array_index_13_ready),
    .io_R_array_index_13_valid(SLR2_io_R_array_index_13_valid),
    .io_R_array_index_13_bits(SLR2_io_R_array_index_13_bits),
    .io_R_array_index_14_ready(SLR2_io_R_array_index_14_ready),
    .io_R_array_index_14_valid(SLR2_io_R_array_index_14_valid),
    .io_R_array_index_14_bits(SLR2_io_R_array_index_14_bits),
    .io_R_array_index_15_ready(SLR2_io_R_array_index_15_ready),
    .io_R_array_index_15_valid(SLR2_io_R_array_index_15_valid),
    .io_R_array_index_15_bits(SLR2_io_R_array_index_15_bits),
    .io_R_array_index_16_ready(SLR2_io_R_array_index_16_ready),
    .io_R_array_index_16_valid(SLR2_io_R_array_index_16_valid),
    .io_R_array_index_16_bits(SLR2_io_R_array_index_16_bits),
    .io_R_array_index_17_ready(SLR2_io_R_array_index_17_ready),
    .io_R_array_index_17_valid(SLR2_io_R_array_index_17_valid),
    .io_R_array_index_17_bits(SLR2_io_R_array_index_17_bits),
    .io_R_array_index_18_ready(SLR2_io_R_array_index_18_ready),
    .io_R_array_index_18_valid(SLR2_io_R_array_index_18_valid),
    .io_R_array_index_18_bits(SLR2_io_R_array_index_18_bits),
    .io_R_array_index_19_ready(SLR2_io_R_array_index_19_ready),
    .io_R_array_index_19_valid(SLR2_io_R_array_index_19_valid),
    .io_R_array_index_19_bits(SLR2_io_R_array_index_19_bits),
    .io_R_array_index_20_ready(SLR2_io_R_array_index_20_ready),
    .io_R_array_index_20_valid(SLR2_io_R_array_index_20_valid),
    .io_R_array_index_20_bits(SLR2_io_R_array_index_20_bits),
    .io_R_array_index_21_ready(SLR2_io_R_array_index_21_ready),
    .io_R_array_index_21_valid(SLR2_io_R_array_index_21_valid),
    .io_R_array_index_21_bits(SLR2_io_R_array_index_21_bits),
    .io_R_array_index_22_ready(SLR2_io_R_array_index_22_ready),
    .io_R_array_index_22_valid(SLR2_io_R_array_index_22_valid),
    .io_R_array_index_22_bits(SLR2_io_R_array_index_22_bits),
    .io_R_array_index_23_ready(SLR2_io_R_array_index_23_ready),
    .io_R_array_index_23_valid(SLR2_io_R_array_index_23_valid),
    .io_R_array_index_23_bits(SLR2_io_R_array_index_23_bits),
    .io_R_array_index_24_ready(SLR2_io_R_array_index_24_ready),
    .io_R_array_index_24_valid(SLR2_io_R_array_index_24_valid),
    .io_R_array_index_24_bits(SLR2_io_R_array_index_24_bits),
    .io_R_array_index_25_ready(SLR2_io_R_array_index_25_ready),
    .io_R_array_index_25_valid(SLR2_io_R_array_index_25_valid),
    .io_R_array_index_25_bits(SLR2_io_R_array_index_25_bits),
    .io_R_array_index_26_ready(SLR2_io_R_array_index_26_ready),
    .io_R_array_index_26_valid(SLR2_io_R_array_index_26_valid),
    .io_R_array_index_26_bits(SLR2_io_R_array_index_26_bits),
    .io_R_array_index_27_ready(SLR2_io_R_array_index_27_ready),
    .io_R_array_index_27_valid(SLR2_io_R_array_index_27_valid),
    .io_R_array_index_27_bits(SLR2_io_R_array_index_27_bits),
    .io_R_array_index_28_ready(SLR2_io_R_array_index_28_ready),
    .io_R_array_index_28_valid(SLR2_io_R_array_index_28_valid),
    .io_R_array_index_28_bits(SLR2_io_R_array_index_28_bits),
    .io_R_array_index_29_ready(SLR2_io_R_array_index_29_ready),
    .io_R_array_index_29_valid(SLR2_io_R_array_index_29_valid),
    .io_R_array_index_29_bits(SLR2_io_R_array_index_29_bits),
    .io_R_array_index_30_ready(SLR2_io_R_array_index_30_ready),
    .io_R_array_index_30_valid(SLR2_io_R_array_index_30_valid),
    .io_R_array_index_30_bits(SLR2_io_R_array_index_30_bits),
    .io_R_array_index_31_ready(SLR2_io_R_array_index_31_ready),
    .io_R_array_index_31_valid(SLR2_io_R_array_index_31_valid),
    .io_R_array_index_31_bits(SLR2_io_R_array_index_31_bits),
    .io_R_array_index_32_ready(SLR2_io_R_array_index_32_ready),
    .io_R_array_index_32_valid(SLR2_io_R_array_index_32_valid),
    .io_R_array_index_32_bits(SLR2_io_R_array_index_32_bits),
    .io_R_array_index_33_ready(SLR2_io_R_array_index_33_ready),
    .io_R_array_index_33_valid(SLR2_io_R_array_index_33_valid),
    .io_R_array_index_33_bits(SLR2_io_R_array_index_33_bits),
    .io_R_array_index_34_ready(SLR2_io_R_array_index_34_ready),
    .io_R_array_index_34_valid(SLR2_io_R_array_index_34_valid),
    .io_R_array_index_34_bits(SLR2_io_R_array_index_34_bits),
    .io_R_array_index_35_ready(SLR2_io_R_array_index_35_ready),
    .io_R_array_index_35_valid(SLR2_io_R_array_index_35_valid),
    .io_R_array_index_35_bits(SLR2_io_R_array_index_35_bits),
    .io_R_array_index_36_ready(SLR2_io_R_array_index_36_ready),
    .io_R_array_index_36_valid(SLR2_io_R_array_index_36_valid),
    .io_R_array_index_36_bits(SLR2_io_R_array_index_36_bits),
    .io_R_array_index_37_ready(SLR2_io_R_array_index_37_ready),
    .io_R_array_index_37_valid(SLR2_io_R_array_index_37_valid),
    .io_R_array_index_37_bits(SLR2_io_R_array_index_37_bits),
    .io_R_array_index_38_ready(SLR2_io_R_array_index_38_ready),
    .io_R_array_index_38_valid(SLR2_io_R_array_index_38_valid),
    .io_R_array_index_38_bits(SLR2_io_R_array_index_38_bits),
    .io_R_array_index_39_ready(SLR2_io_R_array_index_39_ready),
    .io_R_array_index_39_valid(SLR2_io_R_array_index_39_valid),
    .io_R_array_index_39_bits(SLR2_io_R_array_index_39_bits),
    .io_R_array_index_40_ready(SLR2_io_R_array_index_40_ready),
    .io_R_array_index_40_valid(SLR2_io_R_array_index_40_valid),
    .io_R_array_index_40_bits(SLR2_io_R_array_index_40_bits),
    .io_R_array_index_41_ready(SLR2_io_R_array_index_41_ready),
    .io_R_array_index_41_valid(SLR2_io_R_array_index_41_valid),
    .io_R_array_index_41_bits(SLR2_io_R_array_index_41_bits),
    .io_R_array_index_42_ready(SLR2_io_R_array_index_42_ready),
    .io_R_array_index_42_valid(SLR2_io_R_array_index_42_valid),
    .io_R_array_index_42_bits(SLR2_io_R_array_index_42_bits),
    .io_R_array_index_43_ready(SLR2_io_R_array_index_43_ready),
    .io_R_array_index_43_valid(SLR2_io_R_array_index_43_valid),
    .io_R_array_index_43_bits(SLR2_io_R_array_index_43_bits),
    .io_R_array_index_44_ready(SLR2_io_R_array_index_44_ready),
    .io_R_array_index_44_valid(SLR2_io_R_array_index_44_valid),
    .io_R_array_index_44_bits(SLR2_io_R_array_index_44_bits),
    .io_R_array_index_45_ready(SLR2_io_R_array_index_45_ready),
    .io_R_array_index_45_valid(SLR2_io_R_array_index_45_valid),
    .io_R_array_index_45_bits(SLR2_io_R_array_index_45_bits),
    .io_R_array_index_46_ready(SLR2_io_R_array_index_46_ready),
    .io_R_array_index_46_valid(SLR2_io_R_array_index_46_valid),
    .io_R_array_index_46_bits(SLR2_io_R_array_index_46_bits),
    .io_R_array_index_47_ready(SLR2_io_R_array_index_47_ready),
    .io_R_array_index_47_valid(SLR2_io_R_array_index_47_valid),
    .io_R_array_index_47_bits(SLR2_io_R_array_index_47_bits),
    .io_R_array_index_48_ready(SLR2_io_R_array_index_48_ready),
    .io_R_array_index_48_valid(SLR2_io_R_array_index_48_valid),
    .io_R_array_index_48_bits(SLR2_io_R_array_index_48_bits),
    .io_R_array_index_49_ready(SLR2_io_R_array_index_49_ready),
    .io_R_array_index_49_valid(SLR2_io_R_array_index_49_valid),
    .io_R_array_index_49_bits(SLR2_io_R_array_index_49_bits),
    .io_R_array_index_50_ready(SLR2_io_R_array_index_50_ready),
    .io_R_array_index_50_valid(SLR2_io_R_array_index_50_valid),
    .io_R_array_index_50_bits(SLR2_io_R_array_index_50_bits),
    .io_R_array_index_51_ready(SLR2_io_R_array_index_51_ready),
    .io_R_array_index_51_valid(SLR2_io_R_array_index_51_valid),
    .io_R_array_index_51_bits(SLR2_io_R_array_index_51_bits),
    .io_R_array_index_52_ready(SLR2_io_R_array_index_52_ready),
    .io_R_array_index_52_valid(SLR2_io_R_array_index_52_valid),
    .io_R_array_index_52_bits(SLR2_io_R_array_index_52_bits),
    .io_R_array_index_53_ready(SLR2_io_R_array_index_53_ready),
    .io_R_array_index_53_valid(SLR2_io_R_array_index_53_valid),
    .io_R_array_index_53_bits(SLR2_io_R_array_index_53_bits),
    .io_R_array_index_54_ready(SLR2_io_R_array_index_54_ready),
    .io_R_array_index_54_valid(SLR2_io_R_array_index_54_valid),
    .io_R_array_index_54_bits(SLR2_io_R_array_index_54_bits),
    .io_R_array_index_55_ready(SLR2_io_R_array_index_55_ready),
    .io_R_array_index_55_valid(SLR2_io_R_array_index_55_valid),
    .io_R_array_index_55_bits(SLR2_io_R_array_index_55_bits),
    .io_R_array_index_56_ready(SLR2_io_R_array_index_56_ready),
    .io_R_array_index_56_valid(SLR2_io_R_array_index_56_valid),
    .io_R_array_index_56_bits(SLR2_io_R_array_index_56_bits),
    .io_R_array_index_57_ready(SLR2_io_R_array_index_57_ready),
    .io_R_array_index_57_valid(SLR2_io_R_array_index_57_valid),
    .io_R_array_index_57_bits(SLR2_io_R_array_index_57_bits),
    .io_R_array_index_58_ready(SLR2_io_R_array_index_58_ready),
    .io_R_array_index_58_valid(SLR2_io_R_array_index_58_valid),
    .io_R_array_index_58_bits(SLR2_io_R_array_index_58_bits),
    .io_R_array_index_59_ready(SLR2_io_R_array_index_59_ready),
    .io_R_array_index_59_valid(SLR2_io_R_array_index_59_valid),
    .io_R_array_index_59_bits(SLR2_io_R_array_index_59_bits),
    .io_R_array_index_60_ready(SLR2_io_R_array_index_60_ready),
    .io_R_array_index_60_valid(SLR2_io_R_array_index_60_valid),
    .io_R_array_index_60_bits(SLR2_io_R_array_index_60_bits),
    .io_R_array_index_61_ready(SLR2_io_R_array_index_61_ready),
    .io_R_array_index_61_valid(SLR2_io_R_array_index_61_valid),
    .io_R_array_index_61_bits(SLR2_io_R_array_index_61_bits),
    .io_R_array_index_62_ready(SLR2_io_R_array_index_62_ready),
    .io_R_array_index_62_valid(SLR2_io_R_array_index_62_valid),
    .io_R_array_index_62_bits(SLR2_io_R_array_index_62_bits),
    .io_R_array_index_63_ready(SLR2_io_R_array_index_63_ready),
    .io_R_array_index_63_valid(SLR2_io_R_array_index_63_valid),
    .io_R_array_index_63_bits(SLR2_io_R_array_index_63_bits),
    .io_R_array_index_64_ready(SLR2_io_R_array_index_64_ready),
    .io_R_array_index_64_valid(SLR2_io_R_array_index_64_valid),
    .io_R_array_index_64_bits(SLR2_io_R_array_index_64_bits),
    .io_R_array_index_65_ready(SLR2_io_R_array_index_65_ready),
    .io_R_array_index_65_valid(SLR2_io_R_array_index_65_valid),
    .io_R_array_index_65_bits(SLR2_io_R_array_index_65_bits),
    .io_R_array_index_66_ready(SLR2_io_R_array_index_66_ready),
    .io_R_array_index_66_valid(SLR2_io_R_array_index_66_valid),
    .io_R_array_index_66_bits(SLR2_io_R_array_index_66_bits),
    .io_R_array_index_67_ready(SLR2_io_R_array_index_67_ready),
    .io_R_array_index_67_valid(SLR2_io_R_array_index_67_valid),
    .io_R_array_index_67_bits(SLR2_io_R_array_index_67_bits),
    .io_R_array_index_68_ready(SLR2_io_R_array_index_68_ready),
    .io_R_array_index_68_valid(SLR2_io_R_array_index_68_valid),
    .io_R_array_index_68_bits(SLR2_io_R_array_index_68_bits),
    .io_R_array_index_69_ready(SLR2_io_R_array_index_69_ready),
    .io_R_array_index_69_valid(SLR2_io_R_array_index_69_valid),
    .io_R_array_index_69_bits(SLR2_io_R_array_index_69_bits),
    .io_R_array_index_70_ready(SLR2_io_R_array_index_70_ready),
    .io_R_array_index_70_valid(SLR2_io_R_array_index_70_valid),
    .io_R_array_index_70_bits(SLR2_io_R_array_index_70_bits),
    .io_R_array_index_71_ready(SLR2_io_R_array_index_71_ready),
    .io_R_array_index_71_valid(SLR2_io_R_array_index_71_valid),
    .io_R_array_index_71_bits(SLR2_io_R_array_index_71_bits),
    .io_p1_end_0(SLR2_io_p1_end_0),
    .io_p1_end_1(SLR2_io_p1_end_1),
    .io_p1_end_2(SLR2_io_p1_end_2),
    .io_p1_end_3(SLR2_io_p1_end_3),
    .io_p1_end_4(SLR2_io_p1_end_4),
    .io_p1_end_5(SLR2_io_p1_end_5),
    .io_p1_end_6(SLR2_io_p1_end_6),
    .io_p1_end_7(SLR2_io_p1_end_7),
    .io_p1_end_8(SLR2_io_p1_end_8),
    .io_p1_end_9(SLR2_io_p1_end_9),
    .io_p1_end_10(SLR2_io_p1_end_10),
    .io_p1_end_11(SLR2_io_p1_end_11),
    .io_p1_end_12(SLR2_io_p1_end_12),
    .io_p1_end_13(SLR2_io_p1_end_13),
    .io_p1_end_14(SLR2_io_p1_end_14),
    .io_p1_end_15(SLR2_io_p1_end_15),
    .io_p1_end_16(SLR2_io_p1_end_16),
    .io_p1_end_17(SLR2_io_p1_end_17),
    .io_uram_out_a_0(SLR2_io_uram_out_a_0),
    .io_uram_out_a_1(SLR2_io_uram_out_a_1),
    .io_uram_out_a_2(SLR2_io_uram_out_a_2),
    .io_uram_out_a_3(SLR2_io_uram_out_a_3),
    .io_uram_out_a_4(SLR2_io_uram_out_a_4),
    .io_uram_out_a_5(SLR2_io_uram_out_a_5),
    .io_uram_out_a_6(SLR2_io_uram_out_a_6),
    .io_uram_out_a_7(SLR2_io_uram_out_a_7),
    .io_uram_out_a_8(SLR2_io_uram_out_a_8),
    .io_uram_out_a_9(SLR2_io_uram_out_a_9),
    .io_uram_out_a_10(SLR2_io_uram_out_a_10),
    .io_uram_out_a_11(SLR2_io_uram_out_a_11),
    .io_uram_out_a_12(SLR2_io_uram_out_a_12),
    .io_uram_out_a_13(SLR2_io_uram_out_a_13),
    .io_uram_out_a_14(SLR2_io_uram_out_a_14),
    .io_uram_out_a_15(SLR2_io_uram_out_a_15),
    .io_uram_out_a_16(SLR2_io_uram_out_a_16),
    .io_uram_out_a_17(SLR2_io_uram_out_a_17),
    .io_uram_out_a_18(SLR2_io_uram_out_a_18),
    .io_uram_out_a_19(SLR2_io_uram_out_a_19),
    .io_uram_out_a_20(SLR2_io_uram_out_a_20),
    .io_uram_out_a_21(SLR2_io_uram_out_a_21),
    .io_uram_out_a_22(SLR2_io_uram_out_a_22),
    .io_uram_out_a_23(SLR2_io_uram_out_a_23),
    .io_uram_out_a_24(SLR2_io_uram_out_a_24),
    .io_uram_out_a_25(SLR2_io_uram_out_a_25),
    .io_uram_out_a_26(SLR2_io_uram_out_a_26),
    .io_uram_out_a_27(SLR2_io_uram_out_a_27),
    .io_uram_out_a_28(SLR2_io_uram_out_a_28),
    .io_uram_out_a_29(SLR2_io_uram_out_a_29),
    .io_uram_out_a_30(SLR2_io_uram_out_a_30),
    .io_uram_out_a_31(SLR2_io_uram_out_a_31),
    .io_uram_out_a_32(SLR2_io_uram_out_a_32),
    .io_uram_out_a_33(SLR2_io_uram_out_a_33),
    .io_uram_out_a_34(SLR2_io_uram_out_a_34),
    .io_uram_out_a_35(SLR2_io_uram_out_a_35),
    .io_uram_out_a_36(SLR2_io_uram_out_a_36),
    .io_uram_out_a_37(SLR2_io_uram_out_a_37),
    .io_uram_out_a_38(SLR2_io_uram_out_a_38),
    .io_uram_out_a_39(SLR2_io_uram_out_a_39),
    .io_uram_out_a_40(SLR2_io_uram_out_a_40),
    .io_uram_out_a_41(SLR2_io_uram_out_a_41),
    .io_uram_out_a_42(SLR2_io_uram_out_a_42),
    .io_uram_out_a_43(SLR2_io_uram_out_a_43),
    .io_uram_out_a_44(SLR2_io_uram_out_a_44),
    .io_uram_out_a_45(SLR2_io_uram_out_a_45),
    .io_uram_out_a_46(SLR2_io_uram_out_a_46),
    .io_uram_out_a_47(SLR2_io_uram_out_a_47),
    .io_uram_out_a_48(SLR2_io_uram_out_a_48),
    .io_uram_out_a_49(SLR2_io_uram_out_a_49),
    .io_uram_out_a_50(SLR2_io_uram_out_a_50),
    .io_uram_out_a_51(SLR2_io_uram_out_a_51),
    .io_uram_out_a_52(SLR2_io_uram_out_a_52),
    .io_uram_out_a_53(SLR2_io_uram_out_a_53),
    .io_uram_out_a_54(SLR2_io_uram_out_a_54),
    .io_uram_out_a_55(SLR2_io_uram_out_a_55),
    .io_uram_out_a_56(SLR2_io_uram_out_a_56),
    .io_uram_out_a_57(SLR2_io_uram_out_a_57),
    .io_uram_out_a_58(SLR2_io_uram_out_a_58),
    .io_uram_out_a_59(SLR2_io_uram_out_a_59),
    .io_uram_out_a_60(SLR2_io_uram_out_a_60),
    .io_uram_out_a_61(SLR2_io_uram_out_a_61),
    .io_uram_out_a_62(SLR2_io_uram_out_a_62),
    .io_uram_out_a_63(SLR2_io_uram_out_a_63),
    .io_uram_out_a_64(SLR2_io_uram_out_a_64),
    .io_uram_out_a_65(SLR2_io_uram_out_a_65),
    .io_uram_out_a_66(SLR2_io_uram_out_a_66),
    .io_uram_out_a_67(SLR2_io_uram_out_a_67),
    .io_uram_out_a_68(SLR2_io_uram_out_a_68),
    .io_uram_out_a_69(SLR2_io_uram_out_a_69),
    .io_uram_out_a_70(SLR2_io_uram_out_a_70),
    .io_uram_out_a_71(SLR2_io_uram_out_a_71),
    .io_uram_addr_a_0(SLR2_io_uram_addr_a_0),
    .io_uram_addr_a_1(SLR2_io_uram_addr_a_1),
    .io_uram_addr_a_2(SLR2_io_uram_addr_a_2),
    .io_uram_addr_a_3(SLR2_io_uram_addr_a_3),
    .io_uram_addr_a_4(SLR2_io_uram_addr_a_4),
    .io_uram_addr_a_5(SLR2_io_uram_addr_a_5),
    .io_uram_addr_a_6(SLR2_io_uram_addr_a_6),
    .io_uram_addr_a_7(SLR2_io_uram_addr_a_7),
    .io_uram_addr_a_8(SLR2_io_uram_addr_a_8),
    .io_uram_addr_a_9(SLR2_io_uram_addr_a_9),
    .io_uram_addr_a_10(SLR2_io_uram_addr_a_10),
    .io_uram_addr_a_11(SLR2_io_uram_addr_a_11),
    .io_uram_addr_a_12(SLR2_io_uram_addr_a_12),
    .io_uram_addr_a_13(SLR2_io_uram_addr_a_13),
    .io_uram_addr_a_14(SLR2_io_uram_addr_a_14),
    .io_uram_addr_a_15(SLR2_io_uram_addr_a_15),
    .io_uram_addr_a_16(SLR2_io_uram_addr_a_16),
    .io_uram_addr_a_17(SLR2_io_uram_addr_a_17),
    .io_uram_addr_a_18(SLR2_io_uram_addr_a_18),
    .io_uram_addr_a_19(SLR2_io_uram_addr_a_19),
    .io_uram_addr_a_20(SLR2_io_uram_addr_a_20),
    .io_uram_addr_a_21(SLR2_io_uram_addr_a_21),
    .io_uram_addr_a_22(SLR2_io_uram_addr_a_22),
    .io_uram_addr_a_23(SLR2_io_uram_addr_a_23),
    .io_uram_addr_a_24(SLR2_io_uram_addr_a_24),
    .io_uram_addr_a_25(SLR2_io_uram_addr_a_25),
    .io_uram_addr_a_26(SLR2_io_uram_addr_a_26),
    .io_uram_addr_a_27(SLR2_io_uram_addr_a_27),
    .io_uram_addr_a_28(SLR2_io_uram_addr_a_28),
    .io_uram_addr_a_29(SLR2_io_uram_addr_a_29),
    .io_uram_addr_a_30(SLR2_io_uram_addr_a_30),
    .io_uram_addr_a_31(SLR2_io_uram_addr_a_31),
    .io_uram_addr_a_32(SLR2_io_uram_addr_a_32),
    .io_uram_addr_a_33(SLR2_io_uram_addr_a_33),
    .io_uram_addr_a_34(SLR2_io_uram_addr_a_34),
    .io_uram_addr_a_35(SLR2_io_uram_addr_a_35),
    .io_uram_addr_a_36(SLR2_io_uram_addr_a_36),
    .io_uram_addr_a_37(SLR2_io_uram_addr_a_37),
    .io_uram_addr_a_38(SLR2_io_uram_addr_a_38),
    .io_uram_addr_a_39(SLR2_io_uram_addr_a_39),
    .io_uram_addr_a_40(SLR2_io_uram_addr_a_40),
    .io_uram_addr_a_41(SLR2_io_uram_addr_a_41),
    .io_uram_addr_a_42(SLR2_io_uram_addr_a_42),
    .io_uram_addr_a_43(SLR2_io_uram_addr_a_43),
    .io_uram_addr_a_44(SLR2_io_uram_addr_a_44),
    .io_uram_addr_a_45(SLR2_io_uram_addr_a_45),
    .io_uram_addr_a_46(SLR2_io_uram_addr_a_46),
    .io_uram_addr_a_47(SLR2_io_uram_addr_a_47),
    .io_uram_addr_a_48(SLR2_io_uram_addr_a_48),
    .io_uram_addr_a_49(SLR2_io_uram_addr_a_49),
    .io_uram_addr_a_50(SLR2_io_uram_addr_a_50),
    .io_uram_addr_a_51(SLR2_io_uram_addr_a_51),
    .io_uram_addr_a_52(SLR2_io_uram_addr_a_52),
    .io_uram_addr_a_53(SLR2_io_uram_addr_a_53),
    .io_uram_addr_a_54(SLR2_io_uram_addr_a_54),
    .io_uram_addr_a_55(SLR2_io_uram_addr_a_55),
    .io_uram_addr_a_56(SLR2_io_uram_addr_a_56),
    .io_uram_addr_a_57(SLR2_io_uram_addr_a_57),
    .io_uram_addr_a_58(SLR2_io_uram_addr_a_58),
    .io_uram_addr_a_59(SLR2_io_uram_addr_a_59),
    .io_uram_addr_a_60(SLR2_io_uram_addr_a_60),
    .io_uram_addr_a_61(SLR2_io_uram_addr_a_61),
    .io_uram_addr_a_62(SLR2_io_uram_addr_a_62),
    .io_uram_addr_a_63(SLR2_io_uram_addr_a_63),
    .io_uram_addr_a_64(SLR2_io_uram_addr_a_64),
    .io_uram_addr_a_65(SLR2_io_uram_addr_a_65),
    .io_uram_addr_a_66(SLR2_io_uram_addr_a_66),
    .io_uram_addr_a_67(SLR2_io_uram_addr_a_67),
    .io_uram_addr_a_68(SLR2_io_uram_addr_a_68),
    .io_uram_addr_a_69(SLR2_io_uram_addr_a_69),
    .io_uram_addr_a_70(SLR2_io_uram_addr_a_70),
    .io_uram_addr_a_71(SLR2_io_uram_addr_a_71)
  );
  crossbar crossbar_array_mem ( // @[Top-slr.scala 53:36]
    .clock(crossbar_array_mem_clock),
    .reset(crossbar_array_mem_reset),
    .io_in_0_ready(crossbar_array_mem_io_in_0_ready),
    .io_in_0_valid(crossbar_array_mem_io_in_0_valid),
    .io_in_0_bits(crossbar_array_mem_io_in_0_bits),
    .io_in_1_ready(crossbar_array_mem_io_in_1_ready),
    .io_in_1_valid(crossbar_array_mem_io_in_1_valid),
    .io_in_1_bits(crossbar_array_mem_io_in_1_bits),
    .io_in_2_ready(crossbar_array_mem_io_in_2_ready),
    .io_in_2_valid(crossbar_array_mem_io_in_2_valid),
    .io_in_2_bits(crossbar_array_mem_io_in_2_bits),
    .io_in_3_ready(crossbar_array_mem_io_in_3_ready),
    .io_in_3_valid(crossbar_array_mem_io_in_3_valid),
    .io_in_3_bits(crossbar_array_mem_io_in_3_bits),
    .io_in_4_ready(crossbar_array_mem_io_in_4_ready),
    .io_in_4_valid(crossbar_array_mem_io_in_4_valid),
    .io_in_4_bits(crossbar_array_mem_io_in_4_bits),
    .io_in_5_ready(crossbar_array_mem_io_in_5_ready),
    .io_in_5_valid(crossbar_array_mem_io_in_5_valid),
    .io_in_5_bits(crossbar_array_mem_io_in_5_bits),
    .io_in_6_ready(crossbar_array_mem_io_in_6_ready),
    .io_in_6_valid(crossbar_array_mem_io_in_6_valid),
    .io_in_6_bits(crossbar_array_mem_io_in_6_bits),
    .io_in_7_ready(crossbar_array_mem_io_in_7_ready),
    .io_in_7_valid(crossbar_array_mem_io_in_7_valid),
    .io_in_7_bits(crossbar_array_mem_io_in_7_bits),
    .io_in_8_ready(crossbar_array_mem_io_in_8_ready),
    .io_in_8_valid(crossbar_array_mem_io_in_8_valid),
    .io_in_8_bits(crossbar_array_mem_io_in_8_bits),
    .io_in_9_ready(crossbar_array_mem_io_in_9_ready),
    .io_in_9_valid(crossbar_array_mem_io_in_9_valid),
    .io_in_9_bits(crossbar_array_mem_io_in_9_bits),
    .io_in_10_ready(crossbar_array_mem_io_in_10_ready),
    .io_in_10_valid(crossbar_array_mem_io_in_10_valid),
    .io_in_10_bits(crossbar_array_mem_io_in_10_bits),
    .io_in_11_ready(crossbar_array_mem_io_in_11_ready),
    .io_in_11_valid(crossbar_array_mem_io_in_11_valid),
    .io_in_11_bits(crossbar_array_mem_io_in_11_bits),
    .io_in_12_ready(crossbar_array_mem_io_in_12_ready),
    .io_in_12_valid(crossbar_array_mem_io_in_12_valid),
    .io_in_12_bits(crossbar_array_mem_io_in_12_bits),
    .io_in_13_ready(crossbar_array_mem_io_in_13_ready),
    .io_in_13_valid(crossbar_array_mem_io_in_13_valid),
    .io_in_13_bits(crossbar_array_mem_io_in_13_bits),
    .io_in_14_ready(crossbar_array_mem_io_in_14_ready),
    .io_in_14_valid(crossbar_array_mem_io_in_14_valid),
    .io_in_14_bits(crossbar_array_mem_io_in_14_bits),
    .io_in_15_ready(crossbar_array_mem_io_in_15_ready),
    .io_in_15_valid(crossbar_array_mem_io_in_15_valid),
    .io_in_15_bits(crossbar_array_mem_io_in_15_bits),
    .io_in_16_ready(crossbar_array_mem_io_in_16_ready),
    .io_in_16_valid(crossbar_array_mem_io_in_16_valid),
    .io_in_16_bits(crossbar_array_mem_io_in_16_bits),
    .io_in_17_ready(crossbar_array_mem_io_in_17_ready),
    .io_in_17_valid(crossbar_array_mem_io_in_17_valid),
    .io_in_17_bits(crossbar_array_mem_io_in_17_bits),
    .io_in_18_ready(crossbar_array_mem_io_in_18_ready),
    .io_in_18_valid(crossbar_array_mem_io_in_18_valid),
    .io_in_18_bits(crossbar_array_mem_io_in_18_bits),
    .io_in_19_ready(crossbar_array_mem_io_in_19_ready),
    .io_in_19_valid(crossbar_array_mem_io_in_19_valid),
    .io_in_19_bits(crossbar_array_mem_io_in_19_bits),
    .io_in_20_ready(crossbar_array_mem_io_in_20_ready),
    .io_in_20_valid(crossbar_array_mem_io_in_20_valid),
    .io_in_20_bits(crossbar_array_mem_io_in_20_bits),
    .io_in_21_ready(crossbar_array_mem_io_in_21_ready),
    .io_in_21_valid(crossbar_array_mem_io_in_21_valid),
    .io_in_21_bits(crossbar_array_mem_io_in_21_bits),
    .io_in_22_ready(crossbar_array_mem_io_in_22_ready),
    .io_in_22_valid(crossbar_array_mem_io_in_22_valid),
    .io_in_22_bits(crossbar_array_mem_io_in_22_bits),
    .io_in_23_ready(crossbar_array_mem_io_in_23_ready),
    .io_in_23_valid(crossbar_array_mem_io_in_23_valid),
    .io_in_23_bits(crossbar_array_mem_io_in_23_bits),
    .io_in_24_ready(crossbar_array_mem_io_in_24_ready),
    .io_in_24_valid(crossbar_array_mem_io_in_24_valid),
    .io_in_24_bits(crossbar_array_mem_io_in_24_bits),
    .io_in_25_ready(crossbar_array_mem_io_in_25_ready),
    .io_in_25_valid(crossbar_array_mem_io_in_25_valid),
    .io_in_25_bits(crossbar_array_mem_io_in_25_bits),
    .io_in_26_ready(crossbar_array_mem_io_in_26_ready),
    .io_in_26_valid(crossbar_array_mem_io_in_26_valid),
    .io_in_26_bits(crossbar_array_mem_io_in_26_bits),
    .io_in_27_ready(crossbar_array_mem_io_in_27_ready),
    .io_in_27_valid(crossbar_array_mem_io_in_27_valid),
    .io_in_27_bits(crossbar_array_mem_io_in_27_bits),
    .io_in_28_ready(crossbar_array_mem_io_in_28_ready),
    .io_in_28_valid(crossbar_array_mem_io_in_28_valid),
    .io_in_28_bits(crossbar_array_mem_io_in_28_bits),
    .io_in_29_ready(crossbar_array_mem_io_in_29_ready),
    .io_in_29_valid(crossbar_array_mem_io_in_29_valid),
    .io_in_29_bits(crossbar_array_mem_io_in_29_bits),
    .io_in_30_ready(crossbar_array_mem_io_in_30_ready),
    .io_in_30_valid(crossbar_array_mem_io_in_30_valid),
    .io_in_30_bits(crossbar_array_mem_io_in_30_bits),
    .io_in_31_ready(crossbar_array_mem_io_in_31_ready),
    .io_in_31_valid(crossbar_array_mem_io_in_31_valid),
    .io_in_31_bits(crossbar_array_mem_io_in_31_bits),
    .io_in_32_ready(crossbar_array_mem_io_in_32_ready),
    .io_in_32_valid(crossbar_array_mem_io_in_32_valid),
    .io_in_32_bits(crossbar_array_mem_io_in_32_bits),
    .io_in_33_ready(crossbar_array_mem_io_in_33_ready),
    .io_in_33_valid(crossbar_array_mem_io_in_33_valid),
    .io_in_33_bits(crossbar_array_mem_io_in_33_bits),
    .io_in_34_ready(crossbar_array_mem_io_in_34_ready),
    .io_in_34_valid(crossbar_array_mem_io_in_34_valid),
    .io_in_34_bits(crossbar_array_mem_io_in_34_bits),
    .io_in_35_ready(crossbar_array_mem_io_in_35_ready),
    .io_in_35_valid(crossbar_array_mem_io_in_35_valid),
    .io_in_35_bits(crossbar_array_mem_io_in_35_bits),
    .io_in_36_ready(crossbar_array_mem_io_in_36_ready),
    .io_in_36_valid(crossbar_array_mem_io_in_36_valid),
    .io_in_36_bits(crossbar_array_mem_io_in_36_bits),
    .io_in_37_ready(crossbar_array_mem_io_in_37_ready),
    .io_in_37_valid(crossbar_array_mem_io_in_37_valid),
    .io_in_37_bits(crossbar_array_mem_io_in_37_bits),
    .io_in_38_ready(crossbar_array_mem_io_in_38_ready),
    .io_in_38_valid(crossbar_array_mem_io_in_38_valid),
    .io_in_38_bits(crossbar_array_mem_io_in_38_bits),
    .io_in_39_ready(crossbar_array_mem_io_in_39_ready),
    .io_in_39_valid(crossbar_array_mem_io_in_39_valid),
    .io_in_39_bits(crossbar_array_mem_io_in_39_bits),
    .io_in_40_ready(crossbar_array_mem_io_in_40_ready),
    .io_in_40_valid(crossbar_array_mem_io_in_40_valid),
    .io_in_40_bits(crossbar_array_mem_io_in_40_bits),
    .io_in_41_ready(crossbar_array_mem_io_in_41_ready),
    .io_in_41_valid(crossbar_array_mem_io_in_41_valid),
    .io_in_41_bits(crossbar_array_mem_io_in_41_bits),
    .io_in_42_ready(crossbar_array_mem_io_in_42_ready),
    .io_in_42_valid(crossbar_array_mem_io_in_42_valid),
    .io_in_42_bits(crossbar_array_mem_io_in_42_bits),
    .io_in_43_ready(crossbar_array_mem_io_in_43_ready),
    .io_in_43_valid(crossbar_array_mem_io_in_43_valid),
    .io_in_43_bits(crossbar_array_mem_io_in_43_bits),
    .io_in_44_ready(crossbar_array_mem_io_in_44_ready),
    .io_in_44_valid(crossbar_array_mem_io_in_44_valid),
    .io_in_44_bits(crossbar_array_mem_io_in_44_bits),
    .io_in_45_ready(crossbar_array_mem_io_in_45_ready),
    .io_in_45_valid(crossbar_array_mem_io_in_45_valid),
    .io_in_45_bits(crossbar_array_mem_io_in_45_bits),
    .io_in_46_ready(crossbar_array_mem_io_in_46_ready),
    .io_in_46_valid(crossbar_array_mem_io_in_46_valid),
    .io_in_46_bits(crossbar_array_mem_io_in_46_bits),
    .io_in_47_ready(crossbar_array_mem_io_in_47_ready),
    .io_in_47_valid(crossbar_array_mem_io_in_47_valid),
    .io_in_47_bits(crossbar_array_mem_io_in_47_bits),
    .io_in_48_ready(crossbar_array_mem_io_in_48_ready),
    .io_in_48_valid(crossbar_array_mem_io_in_48_valid),
    .io_in_48_bits(crossbar_array_mem_io_in_48_bits),
    .io_in_49_ready(crossbar_array_mem_io_in_49_ready),
    .io_in_49_valid(crossbar_array_mem_io_in_49_valid),
    .io_in_49_bits(crossbar_array_mem_io_in_49_bits),
    .io_in_50_ready(crossbar_array_mem_io_in_50_ready),
    .io_in_50_valid(crossbar_array_mem_io_in_50_valid),
    .io_in_50_bits(crossbar_array_mem_io_in_50_bits),
    .io_in_51_ready(crossbar_array_mem_io_in_51_ready),
    .io_in_51_valid(crossbar_array_mem_io_in_51_valid),
    .io_in_51_bits(crossbar_array_mem_io_in_51_bits),
    .io_in_52_ready(crossbar_array_mem_io_in_52_ready),
    .io_in_52_valid(crossbar_array_mem_io_in_52_valid),
    .io_in_52_bits(crossbar_array_mem_io_in_52_bits),
    .io_in_53_ready(crossbar_array_mem_io_in_53_ready),
    .io_in_53_valid(crossbar_array_mem_io_in_53_valid),
    .io_in_53_bits(crossbar_array_mem_io_in_53_bits),
    .io_in_54_ready(crossbar_array_mem_io_in_54_ready),
    .io_in_54_valid(crossbar_array_mem_io_in_54_valid),
    .io_in_54_bits(crossbar_array_mem_io_in_54_bits),
    .io_in_55_ready(crossbar_array_mem_io_in_55_ready),
    .io_in_55_valid(crossbar_array_mem_io_in_55_valid),
    .io_in_55_bits(crossbar_array_mem_io_in_55_bits),
    .io_in_56_ready(crossbar_array_mem_io_in_56_ready),
    .io_in_56_valid(crossbar_array_mem_io_in_56_valid),
    .io_in_56_bits(crossbar_array_mem_io_in_56_bits),
    .io_in_57_ready(crossbar_array_mem_io_in_57_ready),
    .io_in_57_valid(crossbar_array_mem_io_in_57_valid),
    .io_in_57_bits(crossbar_array_mem_io_in_57_bits),
    .io_in_58_ready(crossbar_array_mem_io_in_58_ready),
    .io_in_58_valid(crossbar_array_mem_io_in_58_valid),
    .io_in_58_bits(crossbar_array_mem_io_in_58_bits),
    .io_in_59_ready(crossbar_array_mem_io_in_59_ready),
    .io_in_59_valid(crossbar_array_mem_io_in_59_valid),
    .io_in_59_bits(crossbar_array_mem_io_in_59_bits),
    .io_in_60_ready(crossbar_array_mem_io_in_60_ready),
    .io_in_60_valid(crossbar_array_mem_io_in_60_valid),
    .io_in_60_bits(crossbar_array_mem_io_in_60_bits),
    .io_in_61_ready(crossbar_array_mem_io_in_61_ready),
    .io_in_61_valid(crossbar_array_mem_io_in_61_valid),
    .io_in_61_bits(crossbar_array_mem_io_in_61_bits),
    .io_in_62_ready(crossbar_array_mem_io_in_62_ready),
    .io_in_62_valid(crossbar_array_mem_io_in_62_valid),
    .io_in_62_bits(crossbar_array_mem_io_in_62_bits),
    .io_in_63_ready(crossbar_array_mem_io_in_63_ready),
    .io_in_63_valid(crossbar_array_mem_io_in_63_valid),
    .io_in_63_bits(crossbar_array_mem_io_in_63_bits),
    .io_in_64_ready(crossbar_array_mem_io_in_64_ready),
    .io_in_64_valid(crossbar_array_mem_io_in_64_valid),
    .io_in_64_bits(crossbar_array_mem_io_in_64_bits),
    .io_in_65_ready(crossbar_array_mem_io_in_65_ready),
    .io_in_65_valid(crossbar_array_mem_io_in_65_valid),
    .io_in_65_bits(crossbar_array_mem_io_in_65_bits),
    .io_in_66_ready(crossbar_array_mem_io_in_66_ready),
    .io_in_66_valid(crossbar_array_mem_io_in_66_valid),
    .io_in_66_bits(crossbar_array_mem_io_in_66_bits),
    .io_in_67_ready(crossbar_array_mem_io_in_67_ready),
    .io_in_67_valid(crossbar_array_mem_io_in_67_valid),
    .io_in_67_bits(crossbar_array_mem_io_in_67_bits),
    .io_in_68_ready(crossbar_array_mem_io_in_68_ready),
    .io_in_68_valid(crossbar_array_mem_io_in_68_valid),
    .io_in_68_bits(crossbar_array_mem_io_in_68_bits),
    .io_in_69_ready(crossbar_array_mem_io_in_69_ready),
    .io_in_69_valid(crossbar_array_mem_io_in_69_valid),
    .io_in_69_bits(crossbar_array_mem_io_in_69_bits),
    .io_in_70_ready(crossbar_array_mem_io_in_70_ready),
    .io_in_70_valid(crossbar_array_mem_io_in_70_valid),
    .io_in_70_bits(crossbar_array_mem_io_in_70_bits),
    .io_in_71_ready(crossbar_array_mem_io_in_71_ready),
    .io_in_71_valid(crossbar_array_mem_io_in_71_valid),
    .io_in_71_bits(crossbar_array_mem_io_in_71_bits),
    .io_in_72_ready(crossbar_array_mem_io_in_72_ready),
    .io_in_72_valid(crossbar_array_mem_io_in_72_valid),
    .io_in_72_bits(crossbar_array_mem_io_in_72_bits),
    .io_in_73_ready(crossbar_array_mem_io_in_73_ready),
    .io_in_73_valid(crossbar_array_mem_io_in_73_valid),
    .io_in_73_bits(crossbar_array_mem_io_in_73_bits),
    .io_in_74_ready(crossbar_array_mem_io_in_74_ready),
    .io_in_74_valid(crossbar_array_mem_io_in_74_valid),
    .io_in_74_bits(crossbar_array_mem_io_in_74_bits),
    .io_in_75_ready(crossbar_array_mem_io_in_75_ready),
    .io_in_75_valid(crossbar_array_mem_io_in_75_valid),
    .io_in_75_bits(crossbar_array_mem_io_in_75_bits),
    .io_in_76_ready(crossbar_array_mem_io_in_76_ready),
    .io_in_76_valid(crossbar_array_mem_io_in_76_valid),
    .io_in_76_bits(crossbar_array_mem_io_in_76_bits),
    .io_in_77_ready(crossbar_array_mem_io_in_77_ready),
    .io_in_77_valid(crossbar_array_mem_io_in_77_valid),
    .io_in_77_bits(crossbar_array_mem_io_in_77_bits),
    .io_in_78_ready(crossbar_array_mem_io_in_78_ready),
    .io_in_78_valid(crossbar_array_mem_io_in_78_valid),
    .io_in_78_bits(crossbar_array_mem_io_in_78_bits),
    .io_in_79_ready(crossbar_array_mem_io_in_79_ready),
    .io_in_79_valid(crossbar_array_mem_io_in_79_valid),
    .io_in_79_bits(crossbar_array_mem_io_in_79_bits),
    .io_in_80_ready(crossbar_array_mem_io_in_80_ready),
    .io_in_80_valid(crossbar_array_mem_io_in_80_valid),
    .io_in_80_bits(crossbar_array_mem_io_in_80_bits),
    .io_in_81_ready(crossbar_array_mem_io_in_81_ready),
    .io_in_81_valid(crossbar_array_mem_io_in_81_valid),
    .io_in_81_bits(crossbar_array_mem_io_in_81_bits),
    .io_in_82_ready(crossbar_array_mem_io_in_82_ready),
    .io_in_82_valid(crossbar_array_mem_io_in_82_valid),
    .io_in_82_bits(crossbar_array_mem_io_in_82_bits),
    .io_in_83_ready(crossbar_array_mem_io_in_83_ready),
    .io_in_83_valid(crossbar_array_mem_io_in_83_valid),
    .io_in_83_bits(crossbar_array_mem_io_in_83_bits),
    .io_in_84_ready(crossbar_array_mem_io_in_84_ready),
    .io_in_84_valid(crossbar_array_mem_io_in_84_valid),
    .io_in_84_bits(crossbar_array_mem_io_in_84_bits),
    .io_in_85_ready(crossbar_array_mem_io_in_85_ready),
    .io_in_85_valid(crossbar_array_mem_io_in_85_valid),
    .io_in_85_bits(crossbar_array_mem_io_in_85_bits),
    .io_in_86_ready(crossbar_array_mem_io_in_86_ready),
    .io_in_86_valid(crossbar_array_mem_io_in_86_valid),
    .io_in_86_bits(crossbar_array_mem_io_in_86_bits),
    .io_in_87_ready(crossbar_array_mem_io_in_87_ready),
    .io_in_87_valid(crossbar_array_mem_io_in_87_valid),
    .io_in_87_bits(crossbar_array_mem_io_in_87_bits),
    .io_in_88_ready(crossbar_array_mem_io_in_88_ready),
    .io_in_88_valid(crossbar_array_mem_io_in_88_valid),
    .io_in_88_bits(crossbar_array_mem_io_in_88_bits),
    .io_in_89_ready(crossbar_array_mem_io_in_89_ready),
    .io_in_89_valid(crossbar_array_mem_io_in_89_valid),
    .io_in_89_bits(crossbar_array_mem_io_in_89_bits),
    .io_in_90_ready(crossbar_array_mem_io_in_90_ready),
    .io_in_90_valid(crossbar_array_mem_io_in_90_valid),
    .io_in_90_bits(crossbar_array_mem_io_in_90_bits),
    .io_in_91_ready(crossbar_array_mem_io_in_91_ready),
    .io_in_91_valid(crossbar_array_mem_io_in_91_valid),
    .io_in_91_bits(crossbar_array_mem_io_in_91_bits),
    .io_in_92_ready(crossbar_array_mem_io_in_92_ready),
    .io_in_92_valid(crossbar_array_mem_io_in_92_valid),
    .io_in_92_bits(crossbar_array_mem_io_in_92_bits),
    .io_in_93_ready(crossbar_array_mem_io_in_93_ready),
    .io_in_93_valid(crossbar_array_mem_io_in_93_valid),
    .io_in_93_bits(crossbar_array_mem_io_in_93_bits),
    .io_in_94_ready(crossbar_array_mem_io_in_94_ready),
    .io_in_94_valid(crossbar_array_mem_io_in_94_valid),
    .io_in_94_bits(crossbar_array_mem_io_in_94_bits),
    .io_in_95_ready(crossbar_array_mem_io_in_95_ready),
    .io_in_95_valid(crossbar_array_mem_io_in_95_valid),
    .io_in_95_bits(crossbar_array_mem_io_in_95_bits),
    .io_in_96_ready(crossbar_array_mem_io_in_96_ready),
    .io_in_96_valid(crossbar_array_mem_io_in_96_valid),
    .io_in_96_bits(crossbar_array_mem_io_in_96_bits),
    .io_in_97_ready(crossbar_array_mem_io_in_97_ready),
    .io_in_97_valid(crossbar_array_mem_io_in_97_valid),
    .io_in_97_bits(crossbar_array_mem_io_in_97_bits),
    .io_in_98_ready(crossbar_array_mem_io_in_98_ready),
    .io_in_98_valid(crossbar_array_mem_io_in_98_valid),
    .io_in_98_bits(crossbar_array_mem_io_in_98_bits),
    .io_in_99_ready(crossbar_array_mem_io_in_99_ready),
    .io_in_99_valid(crossbar_array_mem_io_in_99_valid),
    .io_in_99_bits(crossbar_array_mem_io_in_99_bits),
    .io_in_100_ready(crossbar_array_mem_io_in_100_ready),
    .io_in_100_valid(crossbar_array_mem_io_in_100_valid),
    .io_in_100_bits(crossbar_array_mem_io_in_100_bits),
    .io_in_101_ready(crossbar_array_mem_io_in_101_ready),
    .io_in_101_valid(crossbar_array_mem_io_in_101_valid),
    .io_in_101_bits(crossbar_array_mem_io_in_101_bits),
    .io_in_102_ready(crossbar_array_mem_io_in_102_ready),
    .io_in_102_valid(crossbar_array_mem_io_in_102_valid),
    .io_in_102_bits(crossbar_array_mem_io_in_102_bits),
    .io_in_103_ready(crossbar_array_mem_io_in_103_ready),
    .io_in_103_valid(crossbar_array_mem_io_in_103_valid),
    .io_in_103_bits(crossbar_array_mem_io_in_103_bits),
    .io_in_104_ready(crossbar_array_mem_io_in_104_ready),
    .io_in_104_valid(crossbar_array_mem_io_in_104_valid),
    .io_in_104_bits(crossbar_array_mem_io_in_104_bits),
    .io_in_105_ready(crossbar_array_mem_io_in_105_ready),
    .io_in_105_valid(crossbar_array_mem_io_in_105_valid),
    .io_in_105_bits(crossbar_array_mem_io_in_105_bits),
    .io_in_106_ready(crossbar_array_mem_io_in_106_ready),
    .io_in_106_valid(crossbar_array_mem_io_in_106_valid),
    .io_in_106_bits(crossbar_array_mem_io_in_106_bits),
    .io_in_107_ready(crossbar_array_mem_io_in_107_ready),
    .io_in_107_valid(crossbar_array_mem_io_in_107_valid),
    .io_in_107_bits(crossbar_array_mem_io_in_107_bits),
    .io_in_108_ready(crossbar_array_mem_io_in_108_ready),
    .io_in_108_valid(crossbar_array_mem_io_in_108_valid),
    .io_in_108_bits(crossbar_array_mem_io_in_108_bits),
    .io_in_109_ready(crossbar_array_mem_io_in_109_ready),
    .io_in_109_valid(crossbar_array_mem_io_in_109_valid),
    .io_in_109_bits(crossbar_array_mem_io_in_109_bits),
    .io_in_110_ready(crossbar_array_mem_io_in_110_ready),
    .io_in_110_valid(crossbar_array_mem_io_in_110_valid),
    .io_in_110_bits(crossbar_array_mem_io_in_110_bits),
    .io_in_111_ready(crossbar_array_mem_io_in_111_ready),
    .io_in_111_valid(crossbar_array_mem_io_in_111_valid),
    .io_in_111_bits(crossbar_array_mem_io_in_111_bits),
    .io_in_112_ready(crossbar_array_mem_io_in_112_ready),
    .io_in_112_valid(crossbar_array_mem_io_in_112_valid),
    .io_in_112_bits(crossbar_array_mem_io_in_112_bits),
    .io_in_113_ready(crossbar_array_mem_io_in_113_ready),
    .io_in_113_valid(crossbar_array_mem_io_in_113_valid),
    .io_in_113_bits(crossbar_array_mem_io_in_113_bits),
    .io_in_114_ready(crossbar_array_mem_io_in_114_ready),
    .io_in_114_valid(crossbar_array_mem_io_in_114_valid),
    .io_in_114_bits(crossbar_array_mem_io_in_114_bits),
    .io_in_115_ready(crossbar_array_mem_io_in_115_ready),
    .io_in_115_valid(crossbar_array_mem_io_in_115_valid),
    .io_in_115_bits(crossbar_array_mem_io_in_115_bits),
    .io_in_116_ready(crossbar_array_mem_io_in_116_ready),
    .io_in_116_valid(crossbar_array_mem_io_in_116_valid),
    .io_in_116_bits(crossbar_array_mem_io_in_116_bits),
    .io_in_117_ready(crossbar_array_mem_io_in_117_ready),
    .io_in_117_valid(crossbar_array_mem_io_in_117_valid),
    .io_in_117_bits(crossbar_array_mem_io_in_117_bits),
    .io_in_118_ready(crossbar_array_mem_io_in_118_ready),
    .io_in_118_valid(crossbar_array_mem_io_in_118_valid),
    .io_in_118_bits(crossbar_array_mem_io_in_118_bits),
    .io_in_119_ready(crossbar_array_mem_io_in_119_ready),
    .io_in_119_valid(crossbar_array_mem_io_in_119_valid),
    .io_in_119_bits(crossbar_array_mem_io_in_119_bits),
    .io_in_120_ready(crossbar_array_mem_io_in_120_ready),
    .io_in_120_valid(crossbar_array_mem_io_in_120_valid),
    .io_in_120_bits(crossbar_array_mem_io_in_120_bits),
    .io_in_121_ready(crossbar_array_mem_io_in_121_ready),
    .io_in_121_valid(crossbar_array_mem_io_in_121_valid),
    .io_in_121_bits(crossbar_array_mem_io_in_121_bits),
    .io_in_122_ready(crossbar_array_mem_io_in_122_ready),
    .io_in_122_valid(crossbar_array_mem_io_in_122_valid),
    .io_in_122_bits(crossbar_array_mem_io_in_122_bits),
    .io_in_123_ready(crossbar_array_mem_io_in_123_ready),
    .io_in_123_valid(crossbar_array_mem_io_in_123_valid),
    .io_in_123_bits(crossbar_array_mem_io_in_123_bits),
    .io_in_124_ready(crossbar_array_mem_io_in_124_ready),
    .io_in_124_valid(crossbar_array_mem_io_in_124_valid),
    .io_in_124_bits(crossbar_array_mem_io_in_124_bits),
    .io_in_125_ready(crossbar_array_mem_io_in_125_ready),
    .io_in_125_valid(crossbar_array_mem_io_in_125_valid),
    .io_in_125_bits(crossbar_array_mem_io_in_125_bits),
    .io_in_126_ready(crossbar_array_mem_io_in_126_ready),
    .io_in_126_valid(crossbar_array_mem_io_in_126_valid),
    .io_in_126_bits(crossbar_array_mem_io_in_126_bits),
    .io_in_127_ready(crossbar_array_mem_io_in_127_ready),
    .io_in_127_valid(crossbar_array_mem_io_in_127_valid),
    .io_in_127_bits(crossbar_array_mem_io_in_127_bits),
    .io_out_0_ready(crossbar_array_mem_io_out_0_ready),
    .io_out_0_valid(crossbar_array_mem_io_out_0_valid),
    .io_out_0_bits(crossbar_array_mem_io_out_0_bits),
    .io_out_1_ready(crossbar_array_mem_io_out_1_ready),
    .io_out_1_valid(crossbar_array_mem_io_out_1_valid),
    .io_out_1_bits(crossbar_array_mem_io_out_1_bits),
    .io_out_2_ready(crossbar_array_mem_io_out_2_ready),
    .io_out_2_valid(crossbar_array_mem_io_out_2_valid),
    .io_out_2_bits(crossbar_array_mem_io_out_2_bits),
    .io_out_3_ready(crossbar_array_mem_io_out_3_ready),
    .io_out_3_valid(crossbar_array_mem_io_out_3_valid),
    .io_out_3_bits(crossbar_array_mem_io_out_3_bits),
    .io_out_4_ready(crossbar_array_mem_io_out_4_ready),
    .io_out_4_valid(crossbar_array_mem_io_out_4_valid),
    .io_out_4_bits(crossbar_array_mem_io_out_4_bits),
    .io_out_5_ready(crossbar_array_mem_io_out_5_ready),
    .io_out_5_valid(crossbar_array_mem_io_out_5_valid),
    .io_out_5_bits(crossbar_array_mem_io_out_5_bits),
    .io_out_6_ready(crossbar_array_mem_io_out_6_ready),
    .io_out_6_valid(crossbar_array_mem_io_out_6_valid),
    .io_out_6_bits(crossbar_array_mem_io_out_6_bits),
    .io_out_7_ready(crossbar_array_mem_io_out_7_ready),
    .io_out_7_valid(crossbar_array_mem_io_out_7_valid),
    .io_out_7_bits(crossbar_array_mem_io_out_7_bits),
    .io_out_8_ready(crossbar_array_mem_io_out_8_ready),
    .io_out_8_valid(crossbar_array_mem_io_out_8_valid),
    .io_out_8_bits(crossbar_array_mem_io_out_8_bits),
    .io_out_9_ready(crossbar_array_mem_io_out_9_ready),
    .io_out_9_valid(crossbar_array_mem_io_out_9_valid),
    .io_out_9_bits(crossbar_array_mem_io_out_9_bits),
    .io_out_10_ready(crossbar_array_mem_io_out_10_ready),
    .io_out_10_valid(crossbar_array_mem_io_out_10_valid),
    .io_out_10_bits(crossbar_array_mem_io_out_10_bits),
    .io_out_11_ready(crossbar_array_mem_io_out_11_ready),
    .io_out_11_valid(crossbar_array_mem_io_out_11_valid),
    .io_out_11_bits(crossbar_array_mem_io_out_11_bits),
    .io_out_12_ready(crossbar_array_mem_io_out_12_ready),
    .io_out_12_valid(crossbar_array_mem_io_out_12_valid),
    .io_out_12_bits(crossbar_array_mem_io_out_12_bits),
    .io_out_13_ready(crossbar_array_mem_io_out_13_ready),
    .io_out_13_valid(crossbar_array_mem_io_out_13_valid),
    .io_out_13_bits(crossbar_array_mem_io_out_13_bits),
    .io_out_14_ready(crossbar_array_mem_io_out_14_ready),
    .io_out_14_valid(crossbar_array_mem_io_out_14_valid),
    .io_out_14_bits(crossbar_array_mem_io_out_14_bits),
    .io_out_15_ready(crossbar_array_mem_io_out_15_ready),
    .io_out_15_valid(crossbar_array_mem_io_out_15_valid),
    .io_out_15_bits(crossbar_array_mem_io_out_15_bits),
    .io_out_16_ready(crossbar_array_mem_io_out_16_ready),
    .io_out_16_valid(crossbar_array_mem_io_out_16_valid),
    .io_out_16_bits(crossbar_array_mem_io_out_16_bits),
    .io_out_17_ready(crossbar_array_mem_io_out_17_ready),
    .io_out_17_valid(crossbar_array_mem_io_out_17_valid),
    .io_out_17_bits(crossbar_array_mem_io_out_17_bits),
    .io_out_18_ready(crossbar_array_mem_io_out_18_ready),
    .io_out_18_valid(crossbar_array_mem_io_out_18_valid),
    .io_out_18_bits(crossbar_array_mem_io_out_18_bits),
    .io_out_19_ready(crossbar_array_mem_io_out_19_ready),
    .io_out_19_valid(crossbar_array_mem_io_out_19_valid),
    .io_out_19_bits(crossbar_array_mem_io_out_19_bits),
    .io_out_20_ready(crossbar_array_mem_io_out_20_ready),
    .io_out_20_valid(crossbar_array_mem_io_out_20_valid),
    .io_out_20_bits(crossbar_array_mem_io_out_20_bits),
    .io_out_21_ready(crossbar_array_mem_io_out_21_ready),
    .io_out_21_valid(crossbar_array_mem_io_out_21_valid),
    .io_out_21_bits(crossbar_array_mem_io_out_21_bits),
    .io_out_22_ready(crossbar_array_mem_io_out_22_ready),
    .io_out_22_valid(crossbar_array_mem_io_out_22_valid),
    .io_out_22_bits(crossbar_array_mem_io_out_22_bits),
    .io_out_23_ready(crossbar_array_mem_io_out_23_ready),
    .io_out_23_valid(crossbar_array_mem_io_out_23_valid),
    .io_out_23_bits(crossbar_array_mem_io_out_23_bits),
    .io_out_24_ready(crossbar_array_mem_io_out_24_ready),
    .io_out_24_valid(crossbar_array_mem_io_out_24_valid),
    .io_out_24_bits(crossbar_array_mem_io_out_24_bits),
    .io_out_25_ready(crossbar_array_mem_io_out_25_ready),
    .io_out_25_valid(crossbar_array_mem_io_out_25_valid),
    .io_out_25_bits(crossbar_array_mem_io_out_25_bits),
    .io_out_26_ready(crossbar_array_mem_io_out_26_ready),
    .io_out_26_valid(crossbar_array_mem_io_out_26_valid),
    .io_out_26_bits(crossbar_array_mem_io_out_26_bits),
    .io_out_27_ready(crossbar_array_mem_io_out_27_ready),
    .io_out_27_valid(crossbar_array_mem_io_out_27_valid),
    .io_out_27_bits(crossbar_array_mem_io_out_27_bits),
    .io_out_28_ready(crossbar_array_mem_io_out_28_ready),
    .io_out_28_valid(crossbar_array_mem_io_out_28_valid),
    .io_out_28_bits(crossbar_array_mem_io_out_28_bits),
    .io_out_29_ready(crossbar_array_mem_io_out_29_ready),
    .io_out_29_valid(crossbar_array_mem_io_out_29_valid),
    .io_out_29_bits(crossbar_array_mem_io_out_29_bits),
    .io_out_30_ready(crossbar_array_mem_io_out_30_ready),
    .io_out_30_valid(crossbar_array_mem_io_out_30_valid),
    .io_out_30_bits(crossbar_array_mem_io_out_30_bits),
    .io_out_31_ready(crossbar_array_mem_io_out_31_ready),
    .io_out_31_valid(crossbar_array_mem_io_out_31_valid),
    .io_out_31_bits(crossbar_array_mem_io_out_31_bits),
    .io_out_32_ready(crossbar_array_mem_io_out_32_ready),
    .io_out_32_valid(crossbar_array_mem_io_out_32_valid),
    .io_out_32_bits(crossbar_array_mem_io_out_32_bits),
    .io_out_33_ready(crossbar_array_mem_io_out_33_ready),
    .io_out_33_valid(crossbar_array_mem_io_out_33_valid),
    .io_out_33_bits(crossbar_array_mem_io_out_33_bits),
    .io_out_34_ready(crossbar_array_mem_io_out_34_ready),
    .io_out_34_valid(crossbar_array_mem_io_out_34_valid),
    .io_out_34_bits(crossbar_array_mem_io_out_34_bits),
    .io_out_35_ready(crossbar_array_mem_io_out_35_ready),
    .io_out_35_valid(crossbar_array_mem_io_out_35_valid),
    .io_out_35_bits(crossbar_array_mem_io_out_35_bits),
    .io_out_36_ready(crossbar_array_mem_io_out_36_ready),
    .io_out_36_valid(crossbar_array_mem_io_out_36_valid),
    .io_out_36_bits(crossbar_array_mem_io_out_36_bits),
    .io_out_37_ready(crossbar_array_mem_io_out_37_ready),
    .io_out_37_valid(crossbar_array_mem_io_out_37_valid),
    .io_out_37_bits(crossbar_array_mem_io_out_37_bits),
    .io_out_38_ready(crossbar_array_mem_io_out_38_ready),
    .io_out_38_valid(crossbar_array_mem_io_out_38_valid),
    .io_out_38_bits(crossbar_array_mem_io_out_38_bits),
    .io_out_39_ready(crossbar_array_mem_io_out_39_ready),
    .io_out_39_valid(crossbar_array_mem_io_out_39_valid),
    .io_out_39_bits(crossbar_array_mem_io_out_39_bits),
    .io_out_40_ready(crossbar_array_mem_io_out_40_ready),
    .io_out_40_valid(crossbar_array_mem_io_out_40_valid),
    .io_out_40_bits(crossbar_array_mem_io_out_40_bits),
    .io_out_41_ready(crossbar_array_mem_io_out_41_ready),
    .io_out_41_valid(crossbar_array_mem_io_out_41_valid),
    .io_out_41_bits(crossbar_array_mem_io_out_41_bits),
    .io_out_42_ready(crossbar_array_mem_io_out_42_ready),
    .io_out_42_valid(crossbar_array_mem_io_out_42_valid),
    .io_out_42_bits(crossbar_array_mem_io_out_42_bits),
    .io_out_43_ready(crossbar_array_mem_io_out_43_ready),
    .io_out_43_valid(crossbar_array_mem_io_out_43_valid),
    .io_out_43_bits(crossbar_array_mem_io_out_43_bits),
    .io_out_44_ready(crossbar_array_mem_io_out_44_ready),
    .io_out_44_valid(crossbar_array_mem_io_out_44_valid),
    .io_out_44_bits(crossbar_array_mem_io_out_44_bits),
    .io_out_45_ready(crossbar_array_mem_io_out_45_ready),
    .io_out_45_valid(crossbar_array_mem_io_out_45_valid),
    .io_out_45_bits(crossbar_array_mem_io_out_45_bits),
    .io_out_46_ready(crossbar_array_mem_io_out_46_ready),
    .io_out_46_valid(crossbar_array_mem_io_out_46_valid),
    .io_out_46_bits(crossbar_array_mem_io_out_46_bits),
    .io_out_47_ready(crossbar_array_mem_io_out_47_ready),
    .io_out_47_valid(crossbar_array_mem_io_out_47_valid),
    .io_out_47_bits(crossbar_array_mem_io_out_47_bits),
    .io_out_48_ready(crossbar_array_mem_io_out_48_ready),
    .io_out_48_valid(crossbar_array_mem_io_out_48_valid),
    .io_out_48_bits(crossbar_array_mem_io_out_48_bits),
    .io_out_49_ready(crossbar_array_mem_io_out_49_ready),
    .io_out_49_valid(crossbar_array_mem_io_out_49_valid),
    .io_out_49_bits(crossbar_array_mem_io_out_49_bits),
    .io_out_50_ready(crossbar_array_mem_io_out_50_ready),
    .io_out_50_valid(crossbar_array_mem_io_out_50_valid),
    .io_out_50_bits(crossbar_array_mem_io_out_50_bits),
    .io_out_51_ready(crossbar_array_mem_io_out_51_ready),
    .io_out_51_valid(crossbar_array_mem_io_out_51_valid),
    .io_out_51_bits(crossbar_array_mem_io_out_51_bits),
    .io_out_52_ready(crossbar_array_mem_io_out_52_ready),
    .io_out_52_valid(crossbar_array_mem_io_out_52_valid),
    .io_out_52_bits(crossbar_array_mem_io_out_52_bits),
    .io_out_53_ready(crossbar_array_mem_io_out_53_ready),
    .io_out_53_valid(crossbar_array_mem_io_out_53_valid),
    .io_out_53_bits(crossbar_array_mem_io_out_53_bits),
    .io_out_54_ready(crossbar_array_mem_io_out_54_ready),
    .io_out_54_valid(crossbar_array_mem_io_out_54_valid),
    .io_out_54_bits(crossbar_array_mem_io_out_54_bits),
    .io_out_55_ready(crossbar_array_mem_io_out_55_ready),
    .io_out_55_valid(crossbar_array_mem_io_out_55_valid),
    .io_out_55_bits(crossbar_array_mem_io_out_55_bits),
    .io_out_56_ready(crossbar_array_mem_io_out_56_ready),
    .io_out_56_valid(crossbar_array_mem_io_out_56_valid),
    .io_out_56_bits(crossbar_array_mem_io_out_56_bits),
    .io_out_57_ready(crossbar_array_mem_io_out_57_ready),
    .io_out_57_valid(crossbar_array_mem_io_out_57_valid),
    .io_out_57_bits(crossbar_array_mem_io_out_57_bits),
    .io_out_58_ready(crossbar_array_mem_io_out_58_ready),
    .io_out_58_valid(crossbar_array_mem_io_out_58_valid),
    .io_out_58_bits(crossbar_array_mem_io_out_58_bits),
    .io_out_59_ready(crossbar_array_mem_io_out_59_ready),
    .io_out_59_valid(crossbar_array_mem_io_out_59_valid),
    .io_out_59_bits(crossbar_array_mem_io_out_59_bits),
    .io_out_60_ready(crossbar_array_mem_io_out_60_ready),
    .io_out_60_valid(crossbar_array_mem_io_out_60_valid),
    .io_out_60_bits(crossbar_array_mem_io_out_60_bits),
    .io_out_61_ready(crossbar_array_mem_io_out_61_ready),
    .io_out_61_valid(crossbar_array_mem_io_out_61_valid),
    .io_out_61_bits(crossbar_array_mem_io_out_61_bits),
    .io_out_62_ready(crossbar_array_mem_io_out_62_ready),
    .io_out_62_valid(crossbar_array_mem_io_out_62_valid),
    .io_out_62_bits(crossbar_array_mem_io_out_62_bits),
    .io_out_63_ready(crossbar_array_mem_io_out_63_ready),
    .io_out_63_valid(crossbar_array_mem_io_out_63_valid),
    .io_out_63_bits(crossbar_array_mem_io_out_63_bits),
    .io_out_64_ready(crossbar_array_mem_io_out_64_ready),
    .io_out_64_valid(crossbar_array_mem_io_out_64_valid),
    .io_out_64_bits(crossbar_array_mem_io_out_64_bits),
    .io_out_65_ready(crossbar_array_mem_io_out_65_ready),
    .io_out_65_valid(crossbar_array_mem_io_out_65_valid),
    .io_out_65_bits(crossbar_array_mem_io_out_65_bits),
    .io_out_66_ready(crossbar_array_mem_io_out_66_ready),
    .io_out_66_valid(crossbar_array_mem_io_out_66_valid),
    .io_out_66_bits(crossbar_array_mem_io_out_66_bits),
    .io_out_67_ready(crossbar_array_mem_io_out_67_ready),
    .io_out_67_valid(crossbar_array_mem_io_out_67_valid),
    .io_out_67_bits(crossbar_array_mem_io_out_67_bits),
    .io_out_68_ready(crossbar_array_mem_io_out_68_ready),
    .io_out_68_valid(crossbar_array_mem_io_out_68_valid),
    .io_out_68_bits(crossbar_array_mem_io_out_68_bits),
    .io_out_69_ready(crossbar_array_mem_io_out_69_ready),
    .io_out_69_valid(crossbar_array_mem_io_out_69_valid),
    .io_out_69_bits(crossbar_array_mem_io_out_69_bits),
    .io_out_70_ready(crossbar_array_mem_io_out_70_ready),
    .io_out_70_valid(crossbar_array_mem_io_out_70_valid),
    .io_out_70_bits(crossbar_array_mem_io_out_70_bits),
    .io_out_71_ready(crossbar_array_mem_io_out_71_ready),
    .io_out_71_valid(crossbar_array_mem_io_out_71_valid),
    .io_out_71_bits(crossbar_array_mem_io_out_71_bits),
    .io_out_72_ready(crossbar_array_mem_io_out_72_ready),
    .io_out_72_valid(crossbar_array_mem_io_out_72_valid),
    .io_out_72_bits(crossbar_array_mem_io_out_72_bits),
    .io_out_73_ready(crossbar_array_mem_io_out_73_ready),
    .io_out_73_valid(crossbar_array_mem_io_out_73_valid),
    .io_out_73_bits(crossbar_array_mem_io_out_73_bits),
    .io_out_74_ready(crossbar_array_mem_io_out_74_ready),
    .io_out_74_valid(crossbar_array_mem_io_out_74_valid),
    .io_out_74_bits(crossbar_array_mem_io_out_74_bits),
    .io_out_75_ready(crossbar_array_mem_io_out_75_ready),
    .io_out_75_valid(crossbar_array_mem_io_out_75_valid),
    .io_out_75_bits(crossbar_array_mem_io_out_75_bits),
    .io_out_76_ready(crossbar_array_mem_io_out_76_ready),
    .io_out_76_valid(crossbar_array_mem_io_out_76_valid),
    .io_out_76_bits(crossbar_array_mem_io_out_76_bits),
    .io_out_77_ready(crossbar_array_mem_io_out_77_ready),
    .io_out_77_valid(crossbar_array_mem_io_out_77_valid),
    .io_out_77_bits(crossbar_array_mem_io_out_77_bits),
    .io_out_78_ready(crossbar_array_mem_io_out_78_ready),
    .io_out_78_valid(crossbar_array_mem_io_out_78_valid),
    .io_out_78_bits(crossbar_array_mem_io_out_78_bits),
    .io_out_79_ready(crossbar_array_mem_io_out_79_ready),
    .io_out_79_valid(crossbar_array_mem_io_out_79_valid),
    .io_out_79_bits(crossbar_array_mem_io_out_79_bits),
    .io_out_80_ready(crossbar_array_mem_io_out_80_ready),
    .io_out_80_valid(crossbar_array_mem_io_out_80_valid),
    .io_out_80_bits(crossbar_array_mem_io_out_80_bits),
    .io_out_81_ready(crossbar_array_mem_io_out_81_ready),
    .io_out_81_valid(crossbar_array_mem_io_out_81_valid),
    .io_out_81_bits(crossbar_array_mem_io_out_81_bits),
    .io_out_82_ready(crossbar_array_mem_io_out_82_ready),
    .io_out_82_valid(crossbar_array_mem_io_out_82_valid),
    .io_out_82_bits(crossbar_array_mem_io_out_82_bits),
    .io_out_83_ready(crossbar_array_mem_io_out_83_ready),
    .io_out_83_valid(crossbar_array_mem_io_out_83_valid),
    .io_out_83_bits(crossbar_array_mem_io_out_83_bits),
    .io_out_84_ready(crossbar_array_mem_io_out_84_ready),
    .io_out_84_valid(crossbar_array_mem_io_out_84_valid),
    .io_out_84_bits(crossbar_array_mem_io_out_84_bits),
    .io_out_85_ready(crossbar_array_mem_io_out_85_ready),
    .io_out_85_valid(crossbar_array_mem_io_out_85_valid),
    .io_out_85_bits(crossbar_array_mem_io_out_85_bits),
    .io_out_86_ready(crossbar_array_mem_io_out_86_ready),
    .io_out_86_valid(crossbar_array_mem_io_out_86_valid),
    .io_out_86_bits(crossbar_array_mem_io_out_86_bits),
    .io_out_87_ready(crossbar_array_mem_io_out_87_ready),
    .io_out_87_valid(crossbar_array_mem_io_out_87_valid),
    .io_out_87_bits(crossbar_array_mem_io_out_87_bits),
    .io_out_88_ready(crossbar_array_mem_io_out_88_ready),
    .io_out_88_valid(crossbar_array_mem_io_out_88_valid),
    .io_out_88_bits(crossbar_array_mem_io_out_88_bits),
    .io_out_89_ready(crossbar_array_mem_io_out_89_ready),
    .io_out_89_valid(crossbar_array_mem_io_out_89_valid),
    .io_out_89_bits(crossbar_array_mem_io_out_89_bits),
    .io_out_90_ready(crossbar_array_mem_io_out_90_ready),
    .io_out_90_valid(crossbar_array_mem_io_out_90_valid),
    .io_out_90_bits(crossbar_array_mem_io_out_90_bits),
    .io_out_91_ready(crossbar_array_mem_io_out_91_ready),
    .io_out_91_valid(crossbar_array_mem_io_out_91_valid),
    .io_out_91_bits(crossbar_array_mem_io_out_91_bits),
    .io_out_92_ready(crossbar_array_mem_io_out_92_ready),
    .io_out_92_valid(crossbar_array_mem_io_out_92_valid),
    .io_out_92_bits(crossbar_array_mem_io_out_92_bits),
    .io_out_93_ready(crossbar_array_mem_io_out_93_ready),
    .io_out_93_valid(crossbar_array_mem_io_out_93_valid),
    .io_out_93_bits(crossbar_array_mem_io_out_93_bits),
    .io_out_94_ready(crossbar_array_mem_io_out_94_ready),
    .io_out_94_valid(crossbar_array_mem_io_out_94_valid),
    .io_out_94_bits(crossbar_array_mem_io_out_94_bits),
    .io_out_95_ready(crossbar_array_mem_io_out_95_ready),
    .io_out_95_valid(crossbar_array_mem_io_out_95_valid),
    .io_out_95_bits(crossbar_array_mem_io_out_95_bits),
    .io_out_96_ready(crossbar_array_mem_io_out_96_ready),
    .io_out_96_valid(crossbar_array_mem_io_out_96_valid),
    .io_out_96_bits(crossbar_array_mem_io_out_96_bits),
    .io_out_97_ready(crossbar_array_mem_io_out_97_ready),
    .io_out_97_valid(crossbar_array_mem_io_out_97_valid),
    .io_out_97_bits(crossbar_array_mem_io_out_97_bits),
    .io_out_98_ready(crossbar_array_mem_io_out_98_ready),
    .io_out_98_valid(crossbar_array_mem_io_out_98_valid),
    .io_out_98_bits(crossbar_array_mem_io_out_98_bits),
    .io_out_99_ready(crossbar_array_mem_io_out_99_ready),
    .io_out_99_valid(crossbar_array_mem_io_out_99_valid),
    .io_out_99_bits(crossbar_array_mem_io_out_99_bits),
    .io_out_100_ready(crossbar_array_mem_io_out_100_ready),
    .io_out_100_valid(crossbar_array_mem_io_out_100_valid),
    .io_out_100_bits(crossbar_array_mem_io_out_100_bits),
    .io_out_101_ready(crossbar_array_mem_io_out_101_ready),
    .io_out_101_valid(crossbar_array_mem_io_out_101_valid),
    .io_out_101_bits(crossbar_array_mem_io_out_101_bits),
    .io_out_102_ready(crossbar_array_mem_io_out_102_ready),
    .io_out_102_valid(crossbar_array_mem_io_out_102_valid),
    .io_out_102_bits(crossbar_array_mem_io_out_102_bits),
    .io_out_103_ready(crossbar_array_mem_io_out_103_ready),
    .io_out_103_valid(crossbar_array_mem_io_out_103_valid),
    .io_out_103_bits(crossbar_array_mem_io_out_103_bits),
    .io_out_104_ready(crossbar_array_mem_io_out_104_ready),
    .io_out_104_valid(crossbar_array_mem_io_out_104_valid),
    .io_out_104_bits(crossbar_array_mem_io_out_104_bits),
    .io_out_105_ready(crossbar_array_mem_io_out_105_ready),
    .io_out_105_valid(crossbar_array_mem_io_out_105_valid),
    .io_out_105_bits(crossbar_array_mem_io_out_105_bits),
    .io_out_106_ready(crossbar_array_mem_io_out_106_ready),
    .io_out_106_valid(crossbar_array_mem_io_out_106_valid),
    .io_out_106_bits(crossbar_array_mem_io_out_106_bits),
    .io_out_107_ready(crossbar_array_mem_io_out_107_ready),
    .io_out_107_valid(crossbar_array_mem_io_out_107_valid),
    .io_out_107_bits(crossbar_array_mem_io_out_107_bits),
    .io_out_108_ready(crossbar_array_mem_io_out_108_ready),
    .io_out_108_valid(crossbar_array_mem_io_out_108_valid),
    .io_out_108_bits(crossbar_array_mem_io_out_108_bits),
    .io_out_109_ready(crossbar_array_mem_io_out_109_ready),
    .io_out_109_valid(crossbar_array_mem_io_out_109_valid),
    .io_out_109_bits(crossbar_array_mem_io_out_109_bits),
    .io_out_110_ready(crossbar_array_mem_io_out_110_ready),
    .io_out_110_valid(crossbar_array_mem_io_out_110_valid),
    .io_out_110_bits(crossbar_array_mem_io_out_110_bits),
    .io_out_111_ready(crossbar_array_mem_io_out_111_ready),
    .io_out_111_valid(crossbar_array_mem_io_out_111_valid),
    .io_out_111_bits(crossbar_array_mem_io_out_111_bits),
    .io_out_112_ready(crossbar_array_mem_io_out_112_ready),
    .io_out_112_valid(crossbar_array_mem_io_out_112_valid),
    .io_out_112_bits(crossbar_array_mem_io_out_112_bits),
    .io_out_113_ready(crossbar_array_mem_io_out_113_ready),
    .io_out_113_valid(crossbar_array_mem_io_out_113_valid),
    .io_out_113_bits(crossbar_array_mem_io_out_113_bits),
    .io_out_114_ready(crossbar_array_mem_io_out_114_ready),
    .io_out_114_valid(crossbar_array_mem_io_out_114_valid),
    .io_out_114_bits(crossbar_array_mem_io_out_114_bits),
    .io_out_115_ready(crossbar_array_mem_io_out_115_ready),
    .io_out_115_valid(crossbar_array_mem_io_out_115_valid),
    .io_out_115_bits(crossbar_array_mem_io_out_115_bits),
    .io_out_116_ready(crossbar_array_mem_io_out_116_ready),
    .io_out_116_valid(crossbar_array_mem_io_out_116_valid),
    .io_out_116_bits(crossbar_array_mem_io_out_116_bits),
    .io_out_117_ready(crossbar_array_mem_io_out_117_ready),
    .io_out_117_valid(crossbar_array_mem_io_out_117_valid),
    .io_out_117_bits(crossbar_array_mem_io_out_117_bits),
    .io_out_118_ready(crossbar_array_mem_io_out_118_ready),
    .io_out_118_valid(crossbar_array_mem_io_out_118_valid),
    .io_out_118_bits(crossbar_array_mem_io_out_118_bits),
    .io_out_119_ready(crossbar_array_mem_io_out_119_ready),
    .io_out_119_valid(crossbar_array_mem_io_out_119_valid),
    .io_out_119_bits(crossbar_array_mem_io_out_119_bits),
    .io_out_120_ready(crossbar_array_mem_io_out_120_ready),
    .io_out_120_valid(crossbar_array_mem_io_out_120_valid),
    .io_out_120_bits(crossbar_array_mem_io_out_120_bits),
    .io_out_121_ready(crossbar_array_mem_io_out_121_ready),
    .io_out_121_valid(crossbar_array_mem_io_out_121_valid),
    .io_out_121_bits(crossbar_array_mem_io_out_121_bits),
    .io_out_122_ready(crossbar_array_mem_io_out_122_ready),
    .io_out_122_valid(crossbar_array_mem_io_out_122_valid),
    .io_out_122_bits(crossbar_array_mem_io_out_122_bits),
    .io_out_123_ready(crossbar_array_mem_io_out_123_ready),
    .io_out_123_valid(crossbar_array_mem_io_out_123_valid),
    .io_out_123_bits(crossbar_array_mem_io_out_123_bits),
    .io_out_124_ready(crossbar_array_mem_io_out_124_ready),
    .io_out_124_valid(crossbar_array_mem_io_out_124_valid),
    .io_out_124_bits(crossbar_array_mem_io_out_124_bits),
    .io_out_125_ready(crossbar_array_mem_io_out_125_ready),
    .io_out_125_valid(crossbar_array_mem_io_out_125_valid),
    .io_out_125_bits(crossbar_array_mem_io_out_125_bits),
    .io_out_126_ready(crossbar_array_mem_io_out_126_ready),
    .io_out_126_valid(crossbar_array_mem_io_out_126_valid),
    .io_out_126_bits(crossbar_array_mem_io_out_126_bits),
    .io_out_127_ready(crossbar_array_mem_io_out_127_ready),
    .io_out_127_valid(crossbar_array_mem_io_out_127_valid),
    .io_out_127_bits(crossbar_array_mem_io_out_127_bits)
  );
  crossbar_1 crossbar_array_visit ( // @[Top-slr.scala 54:38]
    .clock(crossbar_array_visit_clock),
    .reset(crossbar_array_visit_reset),
    .io_in_0_ready(crossbar_array_visit_io_in_0_ready),
    .io_in_0_valid(crossbar_array_visit_io_in_0_valid),
    .io_in_0_bits(crossbar_array_visit_io_in_0_bits),
    .io_in_1_ready(crossbar_array_visit_io_in_1_ready),
    .io_in_1_valid(crossbar_array_visit_io_in_1_valid),
    .io_in_1_bits(crossbar_array_visit_io_in_1_bits),
    .io_in_2_ready(crossbar_array_visit_io_in_2_ready),
    .io_in_2_valid(crossbar_array_visit_io_in_2_valid),
    .io_in_2_bits(crossbar_array_visit_io_in_2_bits),
    .io_in_3_ready(crossbar_array_visit_io_in_3_ready),
    .io_in_3_valid(crossbar_array_visit_io_in_3_valid),
    .io_in_3_bits(crossbar_array_visit_io_in_3_bits),
    .io_in_4_ready(crossbar_array_visit_io_in_4_ready),
    .io_in_4_valid(crossbar_array_visit_io_in_4_valid),
    .io_in_4_bits(crossbar_array_visit_io_in_4_bits),
    .io_in_5_ready(crossbar_array_visit_io_in_5_ready),
    .io_in_5_valid(crossbar_array_visit_io_in_5_valid),
    .io_in_5_bits(crossbar_array_visit_io_in_5_bits),
    .io_in_6_ready(crossbar_array_visit_io_in_6_ready),
    .io_in_6_valid(crossbar_array_visit_io_in_6_valid),
    .io_in_6_bits(crossbar_array_visit_io_in_6_bits),
    .io_in_7_ready(crossbar_array_visit_io_in_7_ready),
    .io_in_7_valid(crossbar_array_visit_io_in_7_valid),
    .io_in_7_bits(crossbar_array_visit_io_in_7_bits),
    .io_in_8_ready(crossbar_array_visit_io_in_8_ready),
    .io_in_8_valid(crossbar_array_visit_io_in_8_valid),
    .io_in_8_bits(crossbar_array_visit_io_in_8_bits),
    .io_in_9_ready(crossbar_array_visit_io_in_9_ready),
    .io_in_9_valid(crossbar_array_visit_io_in_9_valid),
    .io_in_9_bits(crossbar_array_visit_io_in_9_bits),
    .io_in_10_ready(crossbar_array_visit_io_in_10_ready),
    .io_in_10_valid(crossbar_array_visit_io_in_10_valid),
    .io_in_10_bits(crossbar_array_visit_io_in_10_bits),
    .io_in_11_ready(crossbar_array_visit_io_in_11_ready),
    .io_in_11_valid(crossbar_array_visit_io_in_11_valid),
    .io_in_11_bits(crossbar_array_visit_io_in_11_bits),
    .io_in_12_ready(crossbar_array_visit_io_in_12_ready),
    .io_in_12_valid(crossbar_array_visit_io_in_12_valid),
    .io_in_12_bits(crossbar_array_visit_io_in_12_bits),
    .io_in_13_ready(crossbar_array_visit_io_in_13_ready),
    .io_in_13_valid(crossbar_array_visit_io_in_13_valid),
    .io_in_13_bits(crossbar_array_visit_io_in_13_bits),
    .io_in_14_ready(crossbar_array_visit_io_in_14_ready),
    .io_in_14_valid(crossbar_array_visit_io_in_14_valid),
    .io_in_14_bits(crossbar_array_visit_io_in_14_bits),
    .io_in_15_ready(crossbar_array_visit_io_in_15_ready),
    .io_in_15_valid(crossbar_array_visit_io_in_15_valid),
    .io_in_15_bits(crossbar_array_visit_io_in_15_bits),
    .io_in_16_ready(crossbar_array_visit_io_in_16_ready),
    .io_in_16_valid(crossbar_array_visit_io_in_16_valid),
    .io_in_16_bits(crossbar_array_visit_io_in_16_bits),
    .io_in_17_ready(crossbar_array_visit_io_in_17_ready),
    .io_in_17_valid(crossbar_array_visit_io_in_17_valid),
    .io_in_17_bits(crossbar_array_visit_io_in_17_bits),
    .io_in_18_ready(crossbar_array_visit_io_in_18_ready),
    .io_in_18_valid(crossbar_array_visit_io_in_18_valid),
    .io_in_18_bits(crossbar_array_visit_io_in_18_bits),
    .io_in_19_ready(crossbar_array_visit_io_in_19_ready),
    .io_in_19_valid(crossbar_array_visit_io_in_19_valid),
    .io_in_19_bits(crossbar_array_visit_io_in_19_bits),
    .io_in_20_ready(crossbar_array_visit_io_in_20_ready),
    .io_in_20_valid(crossbar_array_visit_io_in_20_valid),
    .io_in_20_bits(crossbar_array_visit_io_in_20_bits),
    .io_in_21_ready(crossbar_array_visit_io_in_21_ready),
    .io_in_21_valid(crossbar_array_visit_io_in_21_valid),
    .io_in_21_bits(crossbar_array_visit_io_in_21_bits),
    .io_in_22_ready(crossbar_array_visit_io_in_22_ready),
    .io_in_22_valid(crossbar_array_visit_io_in_22_valid),
    .io_in_22_bits(crossbar_array_visit_io_in_22_bits),
    .io_in_23_ready(crossbar_array_visit_io_in_23_ready),
    .io_in_23_valid(crossbar_array_visit_io_in_23_valid),
    .io_in_23_bits(crossbar_array_visit_io_in_23_bits),
    .io_in_24_ready(crossbar_array_visit_io_in_24_ready),
    .io_in_24_valid(crossbar_array_visit_io_in_24_valid),
    .io_in_24_bits(crossbar_array_visit_io_in_24_bits),
    .io_in_25_ready(crossbar_array_visit_io_in_25_ready),
    .io_in_25_valid(crossbar_array_visit_io_in_25_valid),
    .io_in_25_bits(crossbar_array_visit_io_in_25_bits),
    .io_in_26_ready(crossbar_array_visit_io_in_26_ready),
    .io_in_26_valid(crossbar_array_visit_io_in_26_valid),
    .io_in_26_bits(crossbar_array_visit_io_in_26_bits),
    .io_in_27_ready(crossbar_array_visit_io_in_27_ready),
    .io_in_27_valid(crossbar_array_visit_io_in_27_valid),
    .io_in_27_bits(crossbar_array_visit_io_in_27_bits),
    .io_in_28_ready(crossbar_array_visit_io_in_28_ready),
    .io_in_28_valid(crossbar_array_visit_io_in_28_valid),
    .io_in_28_bits(crossbar_array_visit_io_in_28_bits),
    .io_in_29_ready(crossbar_array_visit_io_in_29_ready),
    .io_in_29_valid(crossbar_array_visit_io_in_29_valid),
    .io_in_29_bits(crossbar_array_visit_io_in_29_bits),
    .io_in_30_ready(crossbar_array_visit_io_in_30_ready),
    .io_in_30_valid(crossbar_array_visit_io_in_30_valid),
    .io_in_30_bits(crossbar_array_visit_io_in_30_bits),
    .io_in_31_ready(crossbar_array_visit_io_in_31_ready),
    .io_in_31_valid(crossbar_array_visit_io_in_31_valid),
    .io_in_31_bits(crossbar_array_visit_io_in_31_bits),
    .io_in_32_ready(crossbar_array_visit_io_in_32_ready),
    .io_in_32_valid(crossbar_array_visit_io_in_32_valid),
    .io_in_32_bits(crossbar_array_visit_io_in_32_bits),
    .io_in_33_ready(crossbar_array_visit_io_in_33_ready),
    .io_in_33_valid(crossbar_array_visit_io_in_33_valid),
    .io_in_33_bits(crossbar_array_visit_io_in_33_bits),
    .io_in_34_ready(crossbar_array_visit_io_in_34_ready),
    .io_in_34_valid(crossbar_array_visit_io_in_34_valid),
    .io_in_34_bits(crossbar_array_visit_io_in_34_bits),
    .io_in_35_ready(crossbar_array_visit_io_in_35_ready),
    .io_in_35_valid(crossbar_array_visit_io_in_35_valid),
    .io_in_35_bits(crossbar_array_visit_io_in_35_bits),
    .io_in_36_ready(crossbar_array_visit_io_in_36_ready),
    .io_in_36_valid(crossbar_array_visit_io_in_36_valid),
    .io_in_36_bits(crossbar_array_visit_io_in_36_bits),
    .io_in_37_ready(crossbar_array_visit_io_in_37_ready),
    .io_in_37_valid(crossbar_array_visit_io_in_37_valid),
    .io_in_37_bits(crossbar_array_visit_io_in_37_bits),
    .io_in_38_ready(crossbar_array_visit_io_in_38_ready),
    .io_in_38_valid(crossbar_array_visit_io_in_38_valid),
    .io_in_38_bits(crossbar_array_visit_io_in_38_bits),
    .io_in_39_ready(crossbar_array_visit_io_in_39_ready),
    .io_in_39_valid(crossbar_array_visit_io_in_39_valid),
    .io_in_39_bits(crossbar_array_visit_io_in_39_bits),
    .io_in_40_ready(crossbar_array_visit_io_in_40_ready),
    .io_in_40_valid(crossbar_array_visit_io_in_40_valid),
    .io_in_40_bits(crossbar_array_visit_io_in_40_bits),
    .io_in_41_ready(crossbar_array_visit_io_in_41_ready),
    .io_in_41_valid(crossbar_array_visit_io_in_41_valid),
    .io_in_41_bits(crossbar_array_visit_io_in_41_bits),
    .io_in_42_ready(crossbar_array_visit_io_in_42_ready),
    .io_in_42_valid(crossbar_array_visit_io_in_42_valid),
    .io_in_42_bits(crossbar_array_visit_io_in_42_bits),
    .io_in_43_ready(crossbar_array_visit_io_in_43_ready),
    .io_in_43_valid(crossbar_array_visit_io_in_43_valid),
    .io_in_43_bits(crossbar_array_visit_io_in_43_bits),
    .io_in_44_ready(crossbar_array_visit_io_in_44_ready),
    .io_in_44_valid(crossbar_array_visit_io_in_44_valid),
    .io_in_44_bits(crossbar_array_visit_io_in_44_bits),
    .io_in_45_ready(crossbar_array_visit_io_in_45_ready),
    .io_in_45_valid(crossbar_array_visit_io_in_45_valid),
    .io_in_45_bits(crossbar_array_visit_io_in_45_bits),
    .io_in_46_ready(crossbar_array_visit_io_in_46_ready),
    .io_in_46_valid(crossbar_array_visit_io_in_46_valid),
    .io_in_46_bits(crossbar_array_visit_io_in_46_bits),
    .io_in_47_ready(crossbar_array_visit_io_in_47_ready),
    .io_in_47_valid(crossbar_array_visit_io_in_47_valid),
    .io_in_47_bits(crossbar_array_visit_io_in_47_bits),
    .io_in_48_ready(crossbar_array_visit_io_in_48_ready),
    .io_in_48_valid(crossbar_array_visit_io_in_48_valid),
    .io_in_48_bits(crossbar_array_visit_io_in_48_bits),
    .io_in_49_ready(crossbar_array_visit_io_in_49_ready),
    .io_in_49_valid(crossbar_array_visit_io_in_49_valid),
    .io_in_49_bits(crossbar_array_visit_io_in_49_bits),
    .io_in_50_ready(crossbar_array_visit_io_in_50_ready),
    .io_in_50_valid(crossbar_array_visit_io_in_50_valid),
    .io_in_50_bits(crossbar_array_visit_io_in_50_bits),
    .io_in_51_ready(crossbar_array_visit_io_in_51_ready),
    .io_in_51_valid(crossbar_array_visit_io_in_51_valid),
    .io_in_51_bits(crossbar_array_visit_io_in_51_bits),
    .io_in_52_ready(crossbar_array_visit_io_in_52_ready),
    .io_in_52_valid(crossbar_array_visit_io_in_52_valid),
    .io_in_52_bits(crossbar_array_visit_io_in_52_bits),
    .io_in_53_ready(crossbar_array_visit_io_in_53_ready),
    .io_in_53_valid(crossbar_array_visit_io_in_53_valid),
    .io_in_53_bits(crossbar_array_visit_io_in_53_bits),
    .io_in_54_ready(crossbar_array_visit_io_in_54_ready),
    .io_in_54_valid(crossbar_array_visit_io_in_54_valid),
    .io_in_54_bits(crossbar_array_visit_io_in_54_bits),
    .io_in_55_ready(crossbar_array_visit_io_in_55_ready),
    .io_in_55_valid(crossbar_array_visit_io_in_55_valid),
    .io_in_55_bits(crossbar_array_visit_io_in_55_bits),
    .io_in_56_ready(crossbar_array_visit_io_in_56_ready),
    .io_in_56_valid(crossbar_array_visit_io_in_56_valid),
    .io_in_56_bits(crossbar_array_visit_io_in_56_bits),
    .io_in_57_ready(crossbar_array_visit_io_in_57_ready),
    .io_in_57_valid(crossbar_array_visit_io_in_57_valid),
    .io_in_57_bits(crossbar_array_visit_io_in_57_bits),
    .io_in_58_ready(crossbar_array_visit_io_in_58_ready),
    .io_in_58_valid(crossbar_array_visit_io_in_58_valid),
    .io_in_58_bits(crossbar_array_visit_io_in_58_bits),
    .io_in_59_ready(crossbar_array_visit_io_in_59_ready),
    .io_in_59_valid(crossbar_array_visit_io_in_59_valid),
    .io_in_59_bits(crossbar_array_visit_io_in_59_bits),
    .io_in_60_ready(crossbar_array_visit_io_in_60_ready),
    .io_in_60_valid(crossbar_array_visit_io_in_60_valid),
    .io_in_60_bits(crossbar_array_visit_io_in_60_bits),
    .io_in_61_ready(crossbar_array_visit_io_in_61_ready),
    .io_in_61_valid(crossbar_array_visit_io_in_61_valid),
    .io_in_61_bits(crossbar_array_visit_io_in_61_bits),
    .io_in_62_ready(crossbar_array_visit_io_in_62_ready),
    .io_in_62_valid(crossbar_array_visit_io_in_62_valid),
    .io_in_62_bits(crossbar_array_visit_io_in_62_bits),
    .io_in_63_ready(crossbar_array_visit_io_in_63_ready),
    .io_in_63_valid(crossbar_array_visit_io_in_63_valid),
    .io_in_63_bits(crossbar_array_visit_io_in_63_bits),
    .io_in_64_ready(crossbar_array_visit_io_in_64_ready),
    .io_in_64_valid(crossbar_array_visit_io_in_64_valid),
    .io_in_64_bits(crossbar_array_visit_io_in_64_bits),
    .io_in_65_ready(crossbar_array_visit_io_in_65_ready),
    .io_in_65_valid(crossbar_array_visit_io_in_65_valid),
    .io_in_65_bits(crossbar_array_visit_io_in_65_bits),
    .io_in_66_ready(crossbar_array_visit_io_in_66_ready),
    .io_in_66_valid(crossbar_array_visit_io_in_66_valid),
    .io_in_66_bits(crossbar_array_visit_io_in_66_bits),
    .io_in_67_ready(crossbar_array_visit_io_in_67_ready),
    .io_in_67_valid(crossbar_array_visit_io_in_67_valid),
    .io_in_67_bits(crossbar_array_visit_io_in_67_bits),
    .io_in_68_ready(crossbar_array_visit_io_in_68_ready),
    .io_in_68_valid(crossbar_array_visit_io_in_68_valid),
    .io_in_68_bits(crossbar_array_visit_io_in_68_bits),
    .io_in_69_ready(crossbar_array_visit_io_in_69_ready),
    .io_in_69_valid(crossbar_array_visit_io_in_69_valid),
    .io_in_69_bits(crossbar_array_visit_io_in_69_bits),
    .io_in_70_ready(crossbar_array_visit_io_in_70_ready),
    .io_in_70_valid(crossbar_array_visit_io_in_70_valid),
    .io_in_70_bits(crossbar_array_visit_io_in_70_bits),
    .io_in_71_ready(crossbar_array_visit_io_in_71_ready),
    .io_in_71_valid(crossbar_array_visit_io_in_71_valid),
    .io_in_71_bits(crossbar_array_visit_io_in_71_bits),
    .io_in_72_ready(crossbar_array_visit_io_in_72_ready),
    .io_in_72_valid(crossbar_array_visit_io_in_72_valid),
    .io_in_72_bits(crossbar_array_visit_io_in_72_bits),
    .io_in_73_ready(crossbar_array_visit_io_in_73_ready),
    .io_in_73_valid(crossbar_array_visit_io_in_73_valid),
    .io_in_73_bits(crossbar_array_visit_io_in_73_bits),
    .io_in_74_ready(crossbar_array_visit_io_in_74_ready),
    .io_in_74_valid(crossbar_array_visit_io_in_74_valid),
    .io_in_74_bits(crossbar_array_visit_io_in_74_bits),
    .io_in_75_ready(crossbar_array_visit_io_in_75_ready),
    .io_in_75_valid(crossbar_array_visit_io_in_75_valid),
    .io_in_75_bits(crossbar_array_visit_io_in_75_bits),
    .io_in_76_ready(crossbar_array_visit_io_in_76_ready),
    .io_in_76_valid(crossbar_array_visit_io_in_76_valid),
    .io_in_76_bits(crossbar_array_visit_io_in_76_bits),
    .io_in_77_ready(crossbar_array_visit_io_in_77_ready),
    .io_in_77_valid(crossbar_array_visit_io_in_77_valid),
    .io_in_77_bits(crossbar_array_visit_io_in_77_bits),
    .io_in_78_ready(crossbar_array_visit_io_in_78_ready),
    .io_in_78_valid(crossbar_array_visit_io_in_78_valid),
    .io_in_78_bits(crossbar_array_visit_io_in_78_bits),
    .io_in_79_ready(crossbar_array_visit_io_in_79_ready),
    .io_in_79_valid(crossbar_array_visit_io_in_79_valid),
    .io_in_79_bits(crossbar_array_visit_io_in_79_bits),
    .io_in_80_ready(crossbar_array_visit_io_in_80_ready),
    .io_in_80_valid(crossbar_array_visit_io_in_80_valid),
    .io_in_80_bits(crossbar_array_visit_io_in_80_bits),
    .io_in_81_ready(crossbar_array_visit_io_in_81_ready),
    .io_in_81_valid(crossbar_array_visit_io_in_81_valid),
    .io_in_81_bits(crossbar_array_visit_io_in_81_bits),
    .io_in_82_ready(crossbar_array_visit_io_in_82_ready),
    .io_in_82_valid(crossbar_array_visit_io_in_82_valid),
    .io_in_82_bits(crossbar_array_visit_io_in_82_bits),
    .io_in_83_ready(crossbar_array_visit_io_in_83_ready),
    .io_in_83_valid(crossbar_array_visit_io_in_83_valid),
    .io_in_83_bits(crossbar_array_visit_io_in_83_bits),
    .io_in_84_ready(crossbar_array_visit_io_in_84_ready),
    .io_in_84_valid(crossbar_array_visit_io_in_84_valid),
    .io_in_84_bits(crossbar_array_visit_io_in_84_bits),
    .io_in_85_ready(crossbar_array_visit_io_in_85_ready),
    .io_in_85_valid(crossbar_array_visit_io_in_85_valid),
    .io_in_85_bits(crossbar_array_visit_io_in_85_bits),
    .io_in_86_ready(crossbar_array_visit_io_in_86_ready),
    .io_in_86_valid(crossbar_array_visit_io_in_86_valid),
    .io_in_86_bits(crossbar_array_visit_io_in_86_bits),
    .io_in_87_ready(crossbar_array_visit_io_in_87_ready),
    .io_in_87_valid(crossbar_array_visit_io_in_87_valid),
    .io_in_87_bits(crossbar_array_visit_io_in_87_bits),
    .io_in_88_ready(crossbar_array_visit_io_in_88_ready),
    .io_in_88_valid(crossbar_array_visit_io_in_88_valid),
    .io_in_88_bits(crossbar_array_visit_io_in_88_bits),
    .io_in_89_ready(crossbar_array_visit_io_in_89_ready),
    .io_in_89_valid(crossbar_array_visit_io_in_89_valid),
    .io_in_89_bits(crossbar_array_visit_io_in_89_bits),
    .io_in_90_ready(crossbar_array_visit_io_in_90_ready),
    .io_in_90_valid(crossbar_array_visit_io_in_90_valid),
    .io_in_90_bits(crossbar_array_visit_io_in_90_bits),
    .io_in_91_ready(crossbar_array_visit_io_in_91_ready),
    .io_in_91_valid(crossbar_array_visit_io_in_91_valid),
    .io_in_91_bits(crossbar_array_visit_io_in_91_bits),
    .io_in_92_ready(crossbar_array_visit_io_in_92_ready),
    .io_in_92_valid(crossbar_array_visit_io_in_92_valid),
    .io_in_92_bits(crossbar_array_visit_io_in_92_bits),
    .io_in_93_ready(crossbar_array_visit_io_in_93_ready),
    .io_in_93_valid(crossbar_array_visit_io_in_93_valid),
    .io_in_93_bits(crossbar_array_visit_io_in_93_bits),
    .io_in_94_ready(crossbar_array_visit_io_in_94_ready),
    .io_in_94_valid(crossbar_array_visit_io_in_94_valid),
    .io_in_94_bits(crossbar_array_visit_io_in_94_bits),
    .io_in_95_ready(crossbar_array_visit_io_in_95_ready),
    .io_in_95_valid(crossbar_array_visit_io_in_95_valid),
    .io_in_95_bits(crossbar_array_visit_io_in_95_bits),
    .io_in_96_ready(crossbar_array_visit_io_in_96_ready),
    .io_in_96_valid(crossbar_array_visit_io_in_96_valid),
    .io_in_96_bits(crossbar_array_visit_io_in_96_bits),
    .io_in_97_ready(crossbar_array_visit_io_in_97_ready),
    .io_in_97_valid(crossbar_array_visit_io_in_97_valid),
    .io_in_97_bits(crossbar_array_visit_io_in_97_bits),
    .io_in_98_ready(crossbar_array_visit_io_in_98_ready),
    .io_in_98_valid(crossbar_array_visit_io_in_98_valid),
    .io_in_98_bits(crossbar_array_visit_io_in_98_bits),
    .io_in_99_ready(crossbar_array_visit_io_in_99_ready),
    .io_in_99_valid(crossbar_array_visit_io_in_99_valid),
    .io_in_99_bits(crossbar_array_visit_io_in_99_bits),
    .io_in_100_ready(crossbar_array_visit_io_in_100_ready),
    .io_in_100_valid(crossbar_array_visit_io_in_100_valid),
    .io_in_100_bits(crossbar_array_visit_io_in_100_bits),
    .io_in_101_ready(crossbar_array_visit_io_in_101_ready),
    .io_in_101_valid(crossbar_array_visit_io_in_101_valid),
    .io_in_101_bits(crossbar_array_visit_io_in_101_bits),
    .io_in_102_ready(crossbar_array_visit_io_in_102_ready),
    .io_in_102_valid(crossbar_array_visit_io_in_102_valid),
    .io_in_102_bits(crossbar_array_visit_io_in_102_bits),
    .io_in_103_ready(crossbar_array_visit_io_in_103_ready),
    .io_in_103_valid(crossbar_array_visit_io_in_103_valid),
    .io_in_103_bits(crossbar_array_visit_io_in_103_bits),
    .io_in_104_ready(crossbar_array_visit_io_in_104_ready),
    .io_in_104_valid(crossbar_array_visit_io_in_104_valid),
    .io_in_104_bits(crossbar_array_visit_io_in_104_bits),
    .io_in_105_ready(crossbar_array_visit_io_in_105_ready),
    .io_in_105_valid(crossbar_array_visit_io_in_105_valid),
    .io_in_105_bits(crossbar_array_visit_io_in_105_bits),
    .io_in_106_ready(crossbar_array_visit_io_in_106_ready),
    .io_in_106_valid(crossbar_array_visit_io_in_106_valid),
    .io_in_106_bits(crossbar_array_visit_io_in_106_bits),
    .io_in_107_ready(crossbar_array_visit_io_in_107_ready),
    .io_in_107_valid(crossbar_array_visit_io_in_107_valid),
    .io_in_107_bits(crossbar_array_visit_io_in_107_bits),
    .io_in_108_ready(crossbar_array_visit_io_in_108_ready),
    .io_in_108_valid(crossbar_array_visit_io_in_108_valid),
    .io_in_108_bits(crossbar_array_visit_io_in_108_bits),
    .io_in_109_ready(crossbar_array_visit_io_in_109_ready),
    .io_in_109_valid(crossbar_array_visit_io_in_109_valid),
    .io_in_109_bits(crossbar_array_visit_io_in_109_bits),
    .io_in_110_ready(crossbar_array_visit_io_in_110_ready),
    .io_in_110_valid(crossbar_array_visit_io_in_110_valid),
    .io_in_110_bits(crossbar_array_visit_io_in_110_bits),
    .io_in_111_ready(crossbar_array_visit_io_in_111_ready),
    .io_in_111_valid(crossbar_array_visit_io_in_111_valid),
    .io_in_111_bits(crossbar_array_visit_io_in_111_bits),
    .io_in_112_ready(crossbar_array_visit_io_in_112_ready),
    .io_in_112_valid(crossbar_array_visit_io_in_112_valid),
    .io_in_112_bits(crossbar_array_visit_io_in_112_bits),
    .io_in_113_ready(crossbar_array_visit_io_in_113_ready),
    .io_in_113_valid(crossbar_array_visit_io_in_113_valid),
    .io_in_113_bits(crossbar_array_visit_io_in_113_bits),
    .io_in_114_ready(crossbar_array_visit_io_in_114_ready),
    .io_in_114_valid(crossbar_array_visit_io_in_114_valid),
    .io_in_114_bits(crossbar_array_visit_io_in_114_bits),
    .io_in_115_ready(crossbar_array_visit_io_in_115_ready),
    .io_in_115_valid(crossbar_array_visit_io_in_115_valid),
    .io_in_115_bits(crossbar_array_visit_io_in_115_bits),
    .io_in_116_ready(crossbar_array_visit_io_in_116_ready),
    .io_in_116_valid(crossbar_array_visit_io_in_116_valid),
    .io_in_116_bits(crossbar_array_visit_io_in_116_bits),
    .io_in_117_ready(crossbar_array_visit_io_in_117_ready),
    .io_in_117_valid(crossbar_array_visit_io_in_117_valid),
    .io_in_117_bits(crossbar_array_visit_io_in_117_bits),
    .io_in_118_ready(crossbar_array_visit_io_in_118_ready),
    .io_in_118_valid(crossbar_array_visit_io_in_118_valid),
    .io_in_118_bits(crossbar_array_visit_io_in_118_bits),
    .io_in_119_ready(crossbar_array_visit_io_in_119_ready),
    .io_in_119_valid(crossbar_array_visit_io_in_119_valid),
    .io_in_119_bits(crossbar_array_visit_io_in_119_bits),
    .io_in_120_ready(crossbar_array_visit_io_in_120_ready),
    .io_in_120_valid(crossbar_array_visit_io_in_120_valid),
    .io_in_120_bits(crossbar_array_visit_io_in_120_bits),
    .io_in_121_ready(crossbar_array_visit_io_in_121_ready),
    .io_in_121_valid(crossbar_array_visit_io_in_121_valid),
    .io_in_121_bits(crossbar_array_visit_io_in_121_bits),
    .io_in_122_ready(crossbar_array_visit_io_in_122_ready),
    .io_in_122_valid(crossbar_array_visit_io_in_122_valid),
    .io_in_122_bits(crossbar_array_visit_io_in_122_bits),
    .io_in_123_ready(crossbar_array_visit_io_in_123_ready),
    .io_in_123_valid(crossbar_array_visit_io_in_123_valid),
    .io_in_123_bits(crossbar_array_visit_io_in_123_bits),
    .io_in_124_ready(crossbar_array_visit_io_in_124_ready),
    .io_in_124_valid(crossbar_array_visit_io_in_124_valid),
    .io_in_124_bits(crossbar_array_visit_io_in_124_bits),
    .io_in_125_ready(crossbar_array_visit_io_in_125_ready),
    .io_in_125_valid(crossbar_array_visit_io_in_125_valid),
    .io_in_125_bits(crossbar_array_visit_io_in_125_bits),
    .io_in_126_ready(crossbar_array_visit_io_in_126_ready),
    .io_in_126_valid(crossbar_array_visit_io_in_126_valid),
    .io_in_126_bits(crossbar_array_visit_io_in_126_bits),
    .io_in_127_ready(crossbar_array_visit_io_in_127_ready),
    .io_in_127_valid(crossbar_array_visit_io_in_127_valid),
    .io_in_127_bits(crossbar_array_visit_io_in_127_bits),
    .io_out_0_ready(crossbar_array_visit_io_out_0_ready),
    .io_out_0_valid(crossbar_array_visit_io_out_0_valid),
    .io_out_0_bits(crossbar_array_visit_io_out_0_bits),
    .io_out_1_ready(crossbar_array_visit_io_out_1_ready),
    .io_out_1_valid(crossbar_array_visit_io_out_1_valid),
    .io_out_1_bits(crossbar_array_visit_io_out_1_bits),
    .io_out_2_ready(crossbar_array_visit_io_out_2_ready),
    .io_out_2_valid(crossbar_array_visit_io_out_2_valid),
    .io_out_2_bits(crossbar_array_visit_io_out_2_bits),
    .io_out_3_ready(crossbar_array_visit_io_out_3_ready),
    .io_out_3_valid(crossbar_array_visit_io_out_3_valid),
    .io_out_3_bits(crossbar_array_visit_io_out_3_bits),
    .io_out_4_ready(crossbar_array_visit_io_out_4_ready),
    .io_out_4_valid(crossbar_array_visit_io_out_4_valid),
    .io_out_4_bits(crossbar_array_visit_io_out_4_bits),
    .io_out_5_ready(crossbar_array_visit_io_out_5_ready),
    .io_out_5_valid(crossbar_array_visit_io_out_5_valid),
    .io_out_5_bits(crossbar_array_visit_io_out_5_bits),
    .io_out_6_ready(crossbar_array_visit_io_out_6_ready),
    .io_out_6_valid(crossbar_array_visit_io_out_6_valid),
    .io_out_6_bits(crossbar_array_visit_io_out_6_bits),
    .io_out_7_ready(crossbar_array_visit_io_out_7_ready),
    .io_out_7_valid(crossbar_array_visit_io_out_7_valid),
    .io_out_7_bits(crossbar_array_visit_io_out_7_bits),
    .io_out_8_ready(crossbar_array_visit_io_out_8_ready),
    .io_out_8_valid(crossbar_array_visit_io_out_8_valid),
    .io_out_8_bits(crossbar_array_visit_io_out_8_bits),
    .io_out_9_ready(crossbar_array_visit_io_out_9_ready),
    .io_out_9_valid(crossbar_array_visit_io_out_9_valid),
    .io_out_9_bits(crossbar_array_visit_io_out_9_bits),
    .io_out_10_ready(crossbar_array_visit_io_out_10_ready),
    .io_out_10_valid(crossbar_array_visit_io_out_10_valid),
    .io_out_10_bits(crossbar_array_visit_io_out_10_bits),
    .io_out_11_ready(crossbar_array_visit_io_out_11_ready),
    .io_out_11_valid(crossbar_array_visit_io_out_11_valid),
    .io_out_11_bits(crossbar_array_visit_io_out_11_bits),
    .io_out_12_ready(crossbar_array_visit_io_out_12_ready),
    .io_out_12_valid(crossbar_array_visit_io_out_12_valid),
    .io_out_12_bits(crossbar_array_visit_io_out_12_bits),
    .io_out_13_ready(crossbar_array_visit_io_out_13_ready),
    .io_out_13_valid(crossbar_array_visit_io_out_13_valid),
    .io_out_13_bits(crossbar_array_visit_io_out_13_bits),
    .io_out_14_ready(crossbar_array_visit_io_out_14_ready),
    .io_out_14_valid(crossbar_array_visit_io_out_14_valid),
    .io_out_14_bits(crossbar_array_visit_io_out_14_bits),
    .io_out_15_ready(crossbar_array_visit_io_out_15_ready),
    .io_out_15_valid(crossbar_array_visit_io_out_15_valid),
    .io_out_15_bits(crossbar_array_visit_io_out_15_bits),
    .io_out_16_ready(crossbar_array_visit_io_out_16_ready),
    .io_out_16_valid(crossbar_array_visit_io_out_16_valid),
    .io_out_16_bits(crossbar_array_visit_io_out_16_bits),
    .io_out_17_ready(crossbar_array_visit_io_out_17_ready),
    .io_out_17_valid(crossbar_array_visit_io_out_17_valid),
    .io_out_17_bits(crossbar_array_visit_io_out_17_bits),
    .io_out_18_ready(crossbar_array_visit_io_out_18_ready),
    .io_out_18_valid(crossbar_array_visit_io_out_18_valid),
    .io_out_18_bits(crossbar_array_visit_io_out_18_bits),
    .io_out_19_ready(crossbar_array_visit_io_out_19_ready),
    .io_out_19_valid(crossbar_array_visit_io_out_19_valid),
    .io_out_19_bits(crossbar_array_visit_io_out_19_bits),
    .io_out_20_ready(crossbar_array_visit_io_out_20_ready),
    .io_out_20_valid(crossbar_array_visit_io_out_20_valid),
    .io_out_20_bits(crossbar_array_visit_io_out_20_bits),
    .io_out_21_ready(crossbar_array_visit_io_out_21_ready),
    .io_out_21_valid(crossbar_array_visit_io_out_21_valid),
    .io_out_21_bits(crossbar_array_visit_io_out_21_bits),
    .io_out_22_ready(crossbar_array_visit_io_out_22_ready),
    .io_out_22_valid(crossbar_array_visit_io_out_22_valid),
    .io_out_22_bits(crossbar_array_visit_io_out_22_bits),
    .io_out_23_ready(crossbar_array_visit_io_out_23_ready),
    .io_out_23_valid(crossbar_array_visit_io_out_23_valid),
    .io_out_23_bits(crossbar_array_visit_io_out_23_bits),
    .io_out_24_ready(crossbar_array_visit_io_out_24_ready),
    .io_out_24_valid(crossbar_array_visit_io_out_24_valid),
    .io_out_24_bits(crossbar_array_visit_io_out_24_bits),
    .io_out_25_ready(crossbar_array_visit_io_out_25_ready),
    .io_out_25_valid(crossbar_array_visit_io_out_25_valid),
    .io_out_25_bits(crossbar_array_visit_io_out_25_bits),
    .io_out_26_ready(crossbar_array_visit_io_out_26_ready),
    .io_out_26_valid(crossbar_array_visit_io_out_26_valid),
    .io_out_26_bits(crossbar_array_visit_io_out_26_bits),
    .io_out_27_ready(crossbar_array_visit_io_out_27_ready),
    .io_out_27_valid(crossbar_array_visit_io_out_27_valid),
    .io_out_27_bits(crossbar_array_visit_io_out_27_bits),
    .io_out_28_ready(crossbar_array_visit_io_out_28_ready),
    .io_out_28_valid(crossbar_array_visit_io_out_28_valid),
    .io_out_28_bits(crossbar_array_visit_io_out_28_bits),
    .io_out_29_ready(crossbar_array_visit_io_out_29_ready),
    .io_out_29_valid(crossbar_array_visit_io_out_29_valid),
    .io_out_29_bits(crossbar_array_visit_io_out_29_bits),
    .io_out_30_ready(crossbar_array_visit_io_out_30_ready),
    .io_out_30_valid(crossbar_array_visit_io_out_30_valid),
    .io_out_30_bits(crossbar_array_visit_io_out_30_bits),
    .io_out_31_ready(crossbar_array_visit_io_out_31_ready),
    .io_out_31_valid(crossbar_array_visit_io_out_31_valid),
    .io_out_31_bits(crossbar_array_visit_io_out_31_bits),
    .io_out_32_ready(crossbar_array_visit_io_out_32_ready),
    .io_out_32_valid(crossbar_array_visit_io_out_32_valid),
    .io_out_32_bits(crossbar_array_visit_io_out_32_bits),
    .io_out_33_ready(crossbar_array_visit_io_out_33_ready),
    .io_out_33_valid(crossbar_array_visit_io_out_33_valid),
    .io_out_33_bits(crossbar_array_visit_io_out_33_bits),
    .io_out_34_ready(crossbar_array_visit_io_out_34_ready),
    .io_out_34_valid(crossbar_array_visit_io_out_34_valid),
    .io_out_34_bits(crossbar_array_visit_io_out_34_bits),
    .io_out_35_ready(crossbar_array_visit_io_out_35_ready),
    .io_out_35_valid(crossbar_array_visit_io_out_35_valid),
    .io_out_35_bits(crossbar_array_visit_io_out_35_bits),
    .io_out_36_ready(crossbar_array_visit_io_out_36_ready),
    .io_out_36_valid(crossbar_array_visit_io_out_36_valid),
    .io_out_36_bits(crossbar_array_visit_io_out_36_bits),
    .io_out_37_ready(crossbar_array_visit_io_out_37_ready),
    .io_out_37_valid(crossbar_array_visit_io_out_37_valid),
    .io_out_37_bits(crossbar_array_visit_io_out_37_bits),
    .io_out_38_ready(crossbar_array_visit_io_out_38_ready),
    .io_out_38_valid(crossbar_array_visit_io_out_38_valid),
    .io_out_38_bits(crossbar_array_visit_io_out_38_bits),
    .io_out_39_ready(crossbar_array_visit_io_out_39_ready),
    .io_out_39_valid(crossbar_array_visit_io_out_39_valid),
    .io_out_39_bits(crossbar_array_visit_io_out_39_bits),
    .io_out_40_ready(crossbar_array_visit_io_out_40_ready),
    .io_out_40_valid(crossbar_array_visit_io_out_40_valid),
    .io_out_40_bits(crossbar_array_visit_io_out_40_bits),
    .io_out_41_ready(crossbar_array_visit_io_out_41_ready),
    .io_out_41_valid(crossbar_array_visit_io_out_41_valid),
    .io_out_41_bits(crossbar_array_visit_io_out_41_bits),
    .io_out_42_ready(crossbar_array_visit_io_out_42_ready),
    .io_out_42_valid(crossbar_array_visit_io_out_42_valid),
    .io_out_42_bits(crossbar_array_visit_io_out_42_bits),
    .io_out_43_ready(crossbar_array_visit_io_out_43_ready),
    .io_out_43_valid(crossbar_array_visit_io_out_43_valid),
    .io_out_43_bits(crossbar_array_visit_io_out_43_bits),
    .io_out_44_ready(crossbar_array_visit_io_out_44_ready),
    .io_out_44_valid(crossbar_array_visit_io_out_44_valid),
    .io_out_44_bits(crossbar_array_visit_io_out_44_bits),
    .io_out_45_ready(crossbar_array_visit_io_out_45_ready),
    .io_out_45_valid(crossbar_array_visit_io_out_45_valid),
    .io_out_45_bits(crossbar_array_visit_io_out_45_bits),
    .io_out_46_ready(crossbar_array_visit_io_out_46_ready),
    .io_out_46_valid(crossbar_array_visit_io_out_46_valid),
    .io_out_46_bits(crossbar_array_visit_io_out_46_bits),
    .io_out_47_ready(crossbar_array_visit_io_out_47_ready),
    .io_out_47_valid(crossbar_array_visit_io_out_47_valid),
    .io_out_47_bits(crossbar_array_visit_io_out_47_bits),
    .io_out_48_ready(crossbar_array_visit_io_out_48_ready),
    .io_out_48_valid(crossbar_array_visit_io_out_48_valid),
    .io_out_48_bits(crossbar_array_visit_io_out_48_bits),
    .io_out_49_ready(crossbar_array_visit_io_out_49_ready),
    .io_out_49_valid(crossbar_array_visit_io_out_49_valid),
    .io_out_49_bits(crossbar_array_visit_io_out_49_bits),
    .io_out_50_ready(crossbar_array_visit_io_out_50_ready),
    .io_out_50_valid(crossbar_array_visit_io_out_50_valid),
    .io_out_50_bits(crossbar_array_visit_io_out_50_bits),
    .io_out_51_ready(crossbar_array_visit_io_out_51_ready),
    .io_out_51_valid(crossbar_array_visit_io_out_51_valid),
    .io_out_51_bits(crossbar_array_visit_io_out_51_bits),
    .io_out_52_ready(crossbar_array_visit_io_out_52_ready),
    .io_out_52_valid(crossbar_array_visit_io_out_52_valid),
    .io_out_52_bits(crossbar_array_visit_io_out_52_bits),
    .io_out_53_ready(crossbar_array_visit_io_out_53_ready),
    .io_out_53_valid(crossbar_array_visit_io_out_53_valid),
    .io_out_53_bits(crossbar_array_visit_io_out_53_bits),
    .io_out_54_ready(crossbar_array_visit_io_out_54_ready),
    .io_out_54_valid(crossbar_array_visit_io_out_54_valid),
    .io_out_54_bits(crossbar_array_visit_io_out_54_bits),
    .io_out_55_ready(crossbar_array_visit_io_out_55_ready),
    .io_out_55_valid(crossbar_array_visit_io_out_55_valid),
    .io_out_55_bits(crossbar_array_visit_io_out_55_bits),
    .io_out_56_ready(crossbar_array_visit_io_out_56_ready),
    .io_out_56_valid(crossbar_array_visit_io_out_56_valid),
    .io_out_56_bits(crossbar_array_visit_io_out_56_bits),
    .io_out_57_ready(crossbar_array_visit_io_out_57_ready),
    .io_out_57_valid(crossbar_array_visit_io_out_57_valid),
    .io_out_57_bits(crossbar_array_visit_io_out_57_bits),
    .io_out_58_ready(crossbar_array_visit_io_out_58_ready),
    .io_out_58_valid(crossbar_array_visit_io_out_58_valid),
    .io_out_58_bits(crossbar_array_visit_io_out_58_bits),
    .io_out_59_ready(crossbar_array_visit_io_out_59_ready),
    .io_out_59_valid(crossbar_array_visit_io_out_59_valid),
    .io_out_59_bits(crossbar_array_visit_io_out_59_bits),
    .io_out_60_ready(crossbar_array_visit_io_out_60_ready),
    .io_out_60_valid(crossbar_array_visit_io_out_60_valid),
    .io_out_60_bits(crossbar_array_visit_io_out_60_bits),
    .io_out_61_ready(crossbar_array_visit_io_out_61_ready),
    .io_out_61_valid(crossbar_array_visit_io_out_61_valid),
    .io_out_61_bits(crossbar_array_visit_io_out_61_bits),
    .io_out_62_ready(crossbar_array_visit_io_out_62_ready),
    .io_out_62_valid(crossbar_array_visit_io_out_62_valid),
    .io_out_62_bits(crossbar_array_visit_io_out_62_bits),
    .io_out_63_ready(crossbar_array_visit_io_out_63_ready),
    .io_out_63_valid(crossbar_array_visit_io_out_63_valid),
    .io_out_63_bits(crossbar_array_visit_io_out_63_bits),
    .io_out_64_ready(crossbar_array_visit_io_out_64_ready),
    .io_out_64_valid(crossbar_array_visit_io_out_64_valid),
    .io_out_64_bits(crossbar_array_visit_io_out_64_bits),
    .io_out_65_ready(crossbar_array_visit_io_out_65_ready),
    .io_out_65_valid(crossbar_array_visit_io_out_65_valid),
    .io_out_65_bits(crossbar_array_visit_io_out_65_bits),
    .io_out_66_ready(crossbar_array_visit_io_out_66_ready),
    .io_out_66_valid(crossbar_array_visit_io_out_66_valid),
    .io_out_66_bits(crossbar_array_visit_io_out_66_bits),
    .io_out_67_ready(crossbar_array_visit_io_out_67_ready),
    .io_out_67_valid(crossbar_array_visit_io_out_67_valid),
    .io_out_67_bits(crossbar_array_visit_io_out_67_bits),
    .io_out_68_ready(crossbar_array_visit_io_out_68_ready),
    .io_out_68_valid(crossbar_array_visit_io_out_68_valid),
    .io_out_68_bits(crossbar_array_visit_io_out_68_bits),
    .io_out_69_ready(crossbar_array_visit_io_out_69_ready),
    .io_out_69_valid(crossbar_array_visit_io_out_69_valid),
    .io_out_69_bits(crossbar_array_visit_io_out_69_bits),
    .io_out_70_ready(crossbar_array_visit_io_out_70_ready),
    .io_out_70_valid(crossbar_array_visit_io_out_70_valid),
    .io_out_70_bits(crossbar_array_visit_io_out_70_bits),
    .io_out_71_ready(crossbar_array_visit_io_out_71_ready),
    .io_out_71_valid(crossbar_array_visit_io_out_71_valid),
    .io_out_71_bits(crossbar_array_visit_io_out_71_bits),
    .io_out_72_ready(crossbar_array_visit_io_out_72_ready),
    .io_out_72_valid(crossbar_array_visit_io_out_72_valid),
    .io_out_72_bits(crossbar_array_visit_io_out_72_bits),
    .io_out_73_ready(crossbar_array_visit_io_out_73_ready),
    .io_out_73_valid(crossbar_array_visit_io_out_73_valid),
    .io_out_73_bits(crossbar_array_visit_io_out_73_bits),
    .io_out_74_ready(crossbar_array_visit_io_out_74_ready),
    .io_out_74_valid(crossbar_array_visit_io_out_74_valid),
    .io_out_74_bits(crossbar_array_visit_io_out_74_bits),
    .io_out_75_ready(crossbar_array_visit_io_out_75_ready),
    .io_out_75_valid(crossbar_array_visit_io_out_75_valid),
    .io_out_75_bits(crossbar_array_visit_io_out_75_bits),
    .io_out_76_ready(crossbar_array_visit_io_out_76_ready),
    .io_out_76_valid(crossbar_array_visit_io_out_76_valid),
    .io_out_76_bits(crossbar_array_visit_io_out_76_bits),
    .io_out_77_ready(crossbar_array_visit_io_out_77_ready),
    .io_out_77_valid(crossbar_array_visit_io_out_77_valid),
    .io_out_77_bits(crossbar_array_visit_io_out_77_bits),
    .io_out_78_ready(crossbar_array_visit_io_out_78_ready),
    .io_out_78_valid(crossbar_array_visit_io_out_78_valid),
    .io_out_78_bits(crossbar_array_visit_io_out_78_bits),
    .io_out_79_ready(crossbar_array_visit_io_out_79_ready),
    .io_out_79_valid(crossbar_array_visit_io_out_79_valid),
    .io_out_79_bits(crossbar_array_visit_io_out_79_bits),
    .io_out_80_ready(crossbar_array_visit_io_out_80_ready),
    .io_out_80_valid(crossbar_array_visit_io_out_80_valid),
    .io_out_80_bits(crossbar_array_visit_io_out_80_bits),
    .io_out_81_ready(crossbar_array_visit_io_out_81_ready),
    .io_out_81_valid(crossbar_array_visit_io_out_81_valid),
    .io_out_81_bits(crossbar_array_visit_io_out_81_bits),
    .io_out_82_ready(crossbar_array_visit_io_out_82_ready),
    .io_out_82_valid(crossbar_array_visit_io_out_82_valid),
    .io_out_82_bits(crossbar_array_visit_io_out_82_bits),
    .io_out_83_ready(crossbar_array_visit_io_out_83_ready),
    .io_out_83_valid(crossbar_array_visit_io_out_83_valid),
    .io_out_83_bits(crossbar_array_visit_io_out_83_bits),
    .io_out_84_ready(crossbar_array_visit_io_out_84_ready),
    .io_out_84_valid(crossbar_array_visit_io_out_84_valid),
    .io_out_84_bits(crossbar_array_visit_io_out_84_bits),
    .io_out_85_ready(crossbar_array_visit_io_out_85_ready),
    .io_out_85_valid(crossbar_array_visit_io_out_85_valid),
    .io_out_85_bits(crossbar_array_visit_io_out_85_bits),
    .io_out_86_ready(crossbar_array_visit_io_out_86_ready),
    .io_out_86_valid(crossbar_array_visit_io_out_86_valid),
    .io_out_86_bits(crossbar_array_visit_io_out_86_bits),
    .io_out_87_ready(crossbar_array_visit_io_out_87_ready),
    .io_out_87_valid(crossbar_array_visit_io_out_87_valid),
    .io_out_87_bits(crossbar_array_visit_io_out_87_bits),
    .io_out_88_ready(crossbar_array_visit_io_out_88_ready),
    .io_out_88_valid(crossbar_array_visit_io_out_88_valid),
    .io_out_88_bits(crossbar_array_visit_io_out_88_bits),
    .io_out_89_ready(crossbar_array_visit_io_out_89_ready),
    .io_out_89_valid(crossbar_array_visit_io_out_89_valid),
    .io_out_89_bits(crossbar_array_visit_io_out_89_bits),
    .io_out_90_ready(crossbar_array_visit_io_out_90_ready),
    .io_out_90_valid(crossbar_array_visit_io_out_90_valid),
    .io_out_90_bits(crossbar_array_visit_io_out_90_bits),
    .io_out_91_ready(crossbar_array_visit_io_out_91_ready),
    .io_out_91_valid(crossbar_array_visit_io_out_91_valid),
    .io_out_91_bits(crossbar_array_visit_io_out_91_bits),
    .io_out_92_ready(crossbar_array_visit_io_out_92_ready),
    .io_out_92_valid(crossbar_array_visit_io_out_92_valid),
    .io_out_92_bits(crossbar_array_visit_io_out_92_bits),
    .io_out_93_ready(crossbar_array_visit_io_out_93_ready),
    .io_out_93_valid(crossbar_array_visit_io_out_93_valid),
    .io_out_93_bits(crossbar_array_visit_io_out_93_bits),
    .io_out_94_ready(crossbar_array_visit_io_out_94_ready),
    .io_out_94_valid(crossbar_array_visit_io_out_94_valid),
    .io_out_94_bits(crossbar_array_visit_io_out_94_bits),
    .io_out_95_ready(crossbar_array_visit_io_out_95_ready),
    .io_out_95_valid(crossbar_array_visit_io_out_95_valid),
    .io_out_95_bits(crossbar_array_visit_io_out_95_bits),
    .io_out_96_ready(crossbar_array_visit_io_out_96_ready),
    .io_out_96_valid(crossbar_array_visit_io_out_96_valid),
    .io_out_96_bits(crossbar_array_visit_io_out_96_bits),
    .io_out_97_ready(crossbar_array_visit_io_out_97_ready),
    .io_out_97_valid(crossbar_array_visit_io_out_97_valid),
    .io_out_97_bits(crossbar_array_visit_io_out_97_bits),
    .io_out_98_ready(crossbar_array_visit_io_out_98_ready),
    .io_out_98_valid(crossbar_array_visit_io_out_98_valid),
    .io_out_98_bits(crossbar_array_visit_io_out_98_bits),
    .io_out_99_ready(crossbar_array_visit_io_out_99_ready),
    .io_out_99_valid(crossbar_array_visit_io_out_99_valid),
    .io_out_99_bits(crossbar_array_visit_io_out_99_bits),
    .io_out_100_ready(crossbar_array_visit_io_out_100_ready),
    .io_out_100_valid(crossbar_array_visit_io_out_100_valid),
    .io_out_100_bits(crossbar_array_visit_io_out_100_bits),
    .io_out_101_ready(crossbar_array_visit_io_out_101_ready),
    .io_out_101_valid(crossbar_array_visit_io_out_101_valid),
    .io_out_101_bits(crossbar_array_visit_io_out_101_bits),
    .io_out_102_ready(crossbar_array_visit_io_out_102_ready),
    .io_out_102_valid(crossbar_array_visit_io_out_102_valid),
    .io_out_102_bits(crossbar_array_visit_io_out_102_bits),
    .io_out_103_ready(crossbar_array_visit_io_out_103_ready),
    .io_out_103_valid(crossbar_array_visit_io_out_103_valid),
    .io_out_103_bits(crossbar_array_visit_io_out_103_bits),
    .io_out_104_ready(crossbar_array_visit_io_out_104_ready),
    .io_out_104_valid(crossbar_array_visit_io_out_104_valid),
    .io_out_104_bits(crossbar_array_visit_io_out_104_bits),
    .io_out_105_ready(crossbar_array_visit_io_out_105_ready),
    .io_out_105_valid(crossbar_array_visit_io_out_105_valid),
    .io_out_105_bits(crossbar_array_visit_io_out_105_bits),
    .io_out_106_ready(crossbar_array_visit_io_out_106_ready),
    .io_out_106_valid(crossbar_array_visit_io_out_106_valid),
    .io_out_106_bits(crossbar_array_visit_io_out_106_bits),
    .io_out_107_ready(crossbar_array_visit_io_out_107_ready),
    .io_out_107_valid(crossbar_array_visit_io_out_107_valid),
    .io_out_107_bits(crossbar_array_visit_io_out_107_bits),
    .io_out_108_ready(crossbar_array_visit_io_out_108_ready),
    .io_out_108_valid(crossbar_array_visit_io_out_108_valid),
    .io_out_108_bits(crossbar_array_visit_io_out_108_bits),
    .io_out_109_ready(crossbar_array_visit_io_out_109_ready),
    .io_out_109_valid(crossbar_array_visit_io_out_109_valid),
    .io_out_109_bits(crossbar_array_visit_io_out_109_bits),
    .io_out_110_ready(crossbar_array_visit_io_out_110_ready),
    .io_out_110_valid(crossbar_array_visit_io_out_110_valid),
    .io_out_110_bits(crossbar_array_visit_io_out_110_bits),
    .io_out_111_ready(crossbar_array_visit_io_out_111_ready),
    .io_out_111_valid(crossbar_array_visit_io_out_111_valid),
    .io_out_111_bits(crossbar_array_visit_io_out_111_bits),
    .io_out_112_ready(crossbar_array_visit_io_out_112_ready),
    .io_out_112_valid(crossbar_array_visit_io_out_112_valid),
    .io_out_112_bits(crossbar_array_visit_io_out_112_bits),
    .io_out_113_ready(crossbar_array_visit_io_out_113_ready),
    .io_out_113_valid(crossbar_array_visit_io_out_113_valid),
    .io_out_113_bits(crossbar_array_visit_io_out_113_bits),
    .io_out_114_ready(crossbar_array_visit_io_out_114_ready),
    .io_out_114_valid(crossbar_array_visit_io_out_114_valid),
    .io_out_114_bits(crossbar_array_visit_io_out_114_bits),
    .io_out_115_ready(crossbar_array_visit_io_out_115_ready),
    .io_out_115_valid(crossbar_array_visit_io_out_115_valid),
    .io_out_115_bits(crossbar_array_visit_io_out_115_bits),
    .io_out_116_ready(crossbar_array_visit_io_out_116_ready),
    .io_out_116_valid(crossbar_array_visit_io_out_116_valid),
    .io_out_116_bits(crossbar_array_visit_io_out_116_bits),
    .io_out_117_ready(crossbar_array_visit_io_out_117_ready),
    .io_out_117_valid(crossbar_array_visit_io_out_117_valid),
    .io_out_117_bits(crossbar_array_visit_io_out_117_bits),
    .io_out_118_ready(crossbar_array_visit_io_out_118_ready),
    .io_out_118_valid(crossbar_array_visit_io_out_118_valid),
    .io_out_118_bits(crossbar_array_visit_io_out_118_bits),
    .io_out_119_ready(crossbar_array_visit_io_out_119_ready),
    .io_out_119_valid(crossbar_array_visit_io_out_119_valid),
    .io_out_119_bits(crossbar_array_visit_io_out_119_bits),
    .io_out_120_ready(crossbar_array_visit_io_out_120_ready),
    .io_out_120_valid(crossbar_array_visit_io_out_120_valid),
    .io_out_120_bits(crossbar_array_visit_io_out_120_bits),
    .io_out_121_ready(crossbar_array_visit_io_out_121_ready),
    .io_out_121_valid(crossbar_array_visit_io_out_121_valid),
    .io_out_121_bits(crossbar_array_visit_io_out_121_bits),
    .io_out_122_ready(crossbar_array_visit_io_out_122_ready),
    .io_out_122_valid(crossbar_array_visit_io_out_122_valid),
    .io_out_122_bits(crossbar_array_visit_io_out_122_bits),
    .io_out_123_ready(crossbar_array_visit_io_out_123_ready),
    .io_out_123_valid(crossbar_array_visit_io_out_123_valid),
    .io_out_123_bits(crossbar_array_visit_io_out_123_bits),
    .io_out_124_ready(crossbar_array_visit_io_out_124_ready),
    .io_out_124_valid(crossbar_array_visit_io_out_124_valid),
    .io_out_124_bits(crossbar_array_visit_io_out_124_bits),
    .io_out_125_ready(crossbar_array_visit_io_out_125_ready),
    .io_out_125_valid(crossbar_array_visit_io_out_125_valid),
    .io_out_125_bits(crossbar_array_visit_io_out_125_bits),
    .io_out_126_ready(crossbar_array_visit_io_out_126_ready),
    .io_out_126_valid(crossbar_array_visit_io_out_126_valid),
    .io_out_126_bits(crossbar_array_visit_io_out_126_bits),
    .io_out_127_ready(crossbar_array_visit_io_out_127_ready),
    .io_out_127_valid(crossbar_array_visit_io_out_127_valid),
    .io_out_127_bits(crossbar_array_visit_io_out_127_bits)
  );
  R_array_index_01_slr0 R_array_index_01_slr0 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_clock),
    .reset(R_array_index_01_slr0_reset),
    .enq_valid(R_array_index_01_slr0_enq_valid),
    .enq_ready(R_array_index_01_slr0_enq_ready),
    .enq_bits(R_array_index_01_slr0_enq_bits),
    .deq_valid(R_array_index_01_slr0_deq_valid),
    .deq_ready(R_array_index_01_slr0_deq_ready),
    .deq_bits(R_array_index_01_slr0_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_clock),
    .reset(R_array_index_01_slr1_reset),
    .enq_valid(R_array_index_01_slr1_enq_valid),
    .enq_ready(R_array_index_01_slr1_enq_ready),
    .enq_bits(R_array_index_01_slr1_enq_bits),
    .deq_valid(R_array_index_01_slr1_deq_valid),
    .deq_ready(R_array_index_01_slr1_deq_ready),
    .deq_bits(R_array_index_01_slr1_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_clock),
    .reset(q_R_array_index_slr0_reset),
    .io_enq_ready(q_R_array_index_slr0_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_io_deq_bits),
    .io_count(q_R_array_index_slr0_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_1 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_1_clock),
    .reset(R_array_index_01_slr0_1_reset),
    .enq_valid(R_array_index_01_slr0_1_enq_valid),
    .enq_ready(R_array_index_01_slr0_1_enq_ready),
    .enq_bits(R_array_index_01_slr0_1_enq_bits),
    .deq_valid(R_array_index_01_slr0_1_deq_valid),
    .deq_ready(R_array_index_01_slr0_1_deq_ready),
    .deq_bits(R_array_index_01_slr0_1_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_1 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_1_clock),
    .reset(R_array_index_01_slr1_1_reset),
    .enq_valid(R_array_index_01_slr1_1_enq_valid),
    .enq_ready(R_array_index_01_slr1_1_enq_ready),
    .enq_bits(R_array_index_01_slr1_1_enq_bits),
    .deq_valid(R_array_index_01_slr1_1_deq_valid),
    .deq_ready(R_array_index_01_slr1_1_deq_ready),
    .deq_bits(R_array_index_01_slr1_1_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_1 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_1_clock),
    .reset(q_R_array_index_slr0_1_reset),
    .io_enq_ready(q_R_array_index_slr0_1_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_1_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_1_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_1_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_1_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_1_io_deq_bits),
    .io_count(q_R_array_index_slr0_1_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_2 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_2_clock),
    .reset(R_array_index_01_slr0_2_reset),
    .enq_valid(R_array_index_01_slr0_2_enq_valid),
    .enq_ready(R_array_index_01_slr0_2_enq_ready),
    .enq_bits(R_array_index_01_slr0_2_enq_bits),
    .deq_valid(R_array_index_01_slr0_2_deq_valid),
    .deq_ready(R_array_index_01_slr0_2_deq_ready),
    .deq_bits(R_array_index_01_slr0_2_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_2 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_2_clock),
    .reset(R_array_index_01_slr1_2_reset),
    .enq_valid(R_array_index_01_slr1_2_enq_valid),
    .enq_ready(R_array_index_01_slr1_2_enq_ready),
    .enq_bits(R_array_index_01_slr1_2_enq_bits),
    .deq_valid(R_array_index_01_slr1_2_deq_valid),
    .deq_ready(R_array_index_01_slr1_2_deq_ready),
    .deq_bits(R_array_index_01_slr1_2_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_2 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_2_clock),
    .reset(q_R_array_index_slr0_2_reset),
    .io_enq_ready(q_R_array_index_slr0_2_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_2_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_2_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_2_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_2_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_2_io_deq_bits),
    .io_count(q_R_array_index_slr0_2_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_3 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_3_clock),
    .reset(R_array_index_01_slr0_3_reset),
    .enq_valid(R_array_index_01_slr0_3_enq_valid),
    .enq_ready(R_array_index_01_slr0_3_enq_ready),
    .enq_bits(R_array_index_01_slr0_3_enq_bits),
    .deq_valid(R_array_index_01_slr0_3_deq_valid),
    .deq_ready(R_array_index_01_slr0_3_deq_ready),
    .deq_bits(R_array_index_01_slr0_3_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_3 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_3_clock),
    .reset(R_array_index_01_slr1_3_reset),
    .enq_valid(R_array_index_01_slr1_3_enq_valid),
    .enq_ready(R_array_index_01_slr1_3_enq_ready),
    .enq_bits(R_array_index_01_slr1_3_enq_bits),
    .deq_valid(R_array_index_01_slr1_3_deq_valid),
    .deq_ready(R_array_index_01_slr1_3_deq_ready),
    .deq_bits(R_array_index_01_slr1_3_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_3 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_3_clock),
    .reset(q_R_array_index_slr0_3_reset),
    .io_enq_ready(q_R_array_index_slr0_3_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_3_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_3_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_3_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_3_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_3_io_deq_bits),
    .io_count(q_R_array_index_slr0_3_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_4 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_4_clock),
    .reset(R_array_index_01_slr0_4_reset),
    .enq_valid(R_array_index_01_slr0_4_enq_valid),
    .enq_ready(R_array_index_01_slr0_4_enq_ready),
    .enq_bits(R_array_index_01_slr0_4_enq_bits),
    .deq_valid(R_array_index_01_slr0_4_deq_valid),
    .deq_ready(R_array_index_01_slr0_4_deq_ready),
    .deq_bits(R_array_index_01_slr0_4_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_4 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_4_clock),
    .reset(R_array_index_01_slr1_4_reset),
    .enq_valid(R_array_index_01_slr1_4_enq_valid),
    .enq_ready(R_array_index_01_slr1_4_enq_ready),
    .enq_bits(R_array_index_01_slr1_4_enq_bits),
    .deq_valid(R_array_index_01_slr1_4_deq_valid),
    .deq_ready(R_array_index_01_slr1_4_deq_ready),
    .deq_bits(R_array_index_01_slr1_4_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_4 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_4_clock),
    .reset(q_R_array_index_slr0_4_reset),
    .io_enq_ready(q_R_array_index_slr0_4_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_4_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_4_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_4_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_4_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_4_io_deq_bits),
    .io_count(q_R_array_index_slr0_4_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_5 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_5_clock),
    .reset(R_array_index_01_slr0_5_reset),
    .enq_valid(R_array_index_01_slr0_5_enq_valid),
    .enq_ready(R_array_index_01_slr0_5_enq_ready),
    .enq_bits(R_array_index_01_slr0_5_enq_bits),
    .deq_valid(R_array_index_01_slr0_5_deq_valid),
    .deq_ready(R_array_index_01_slr0_5_deq_ready),
    .deq_bits(R_array_index_01_slr0_5_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_5 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_5_clock),
    .reset(R_array_index_01_slr1_5_reset),
    .enq_valid(R_array_index_01_slr1_5_enq_valid),
    .enq_ready(R_array_index_01_slr1_5_enq_ready),
    .enq_bits(R_array_index_01_slr1_5_enq_bits),
    .deq_valid(R_array_index_01_slr1_5_deq_valid),
    .deq_ready(R_array_index_01_slr1_5_deq_ready),
    .deq_bits(R_array_index_01_slr1_5_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_5 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_5_clock),
    .reset(q_R_array_index_slr0_5_reset),
    .io_enq_ready(q_R_array_index_slr0_5_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_5_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_5_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_5_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_5_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_5_io_deq_bits),
    .io_count(q_R_array_index_slr0_5_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_6 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_6_clock),
    .reset(R_array_index_01_slr0_6_reset),
    .enq_valid(R_array_index_01_slr0_6_enq_valid),
    .enq_ready(R_array_index_01_slr0_6_enq_ready),
    .enq_bits(R_array_index_01_slr0_6_enq_bits),
    .deq_valid(R_array_index_01_slr0_6_deq_valid),
    .deq_ready(R_array_index_01_slr0_6_deq_ready),
    .deq_bits(R_array_index_01_slr0_6_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_6 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_6_clock),
    .reset(R_array_index_01_slr1_6_reset),
    .enq_valid(R_array_index_01_slr1_6_enq_valid),
    .enq_ready(R_array_index_01_slr1_6_enq_ready),
    .enq_bits(R_array_index_01_slr1_6_enq_bits),
    .deq_valid(R_array_index_01_slr1_6_deq_valid),
    .deq_ready(R_array_index_01_slr1_6_deq_ready),
    .deq_bits(R_array_index_01_slr1_6_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_6 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_6_clock),
    .reset(q_R_array_index_slr0_6_reset),
    .io_enq_ready(q_R_array_index_slr0_6_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_6_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_6_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_6_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_6_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_6_io_deq_bits),
    .io_count(q_R_array_index_slr0_6_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_7 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_7_clock),
    .reset(R_array_index_01_slr0_7_reset),
    .enq_valid(R_array_index_01_slr0_7_enq_valid),
    .enq_ready(R_array_index_01_slr0_7_enq_ready),
    .enq_bits(R_array_index_01_slr0_7_enq_bits),
    .deq_valid(R_array_index_01_slr0_7_deq_valid),
    .deq_ready(R_array_index_01_slr0_7_deq_ready),
    .deq_bits(R_array_index_01_slr0_7_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_7 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_7_clock),
    .reset(R_array_index_01_slr1_7_reset),
    .enq_valid(R_array_index_01_slr1_7_enq_valid),
    .enq_ready(R_array_index_01_slr1_7_enq_ready),
    .enq_bits(R_array_index_01_slr1_7_enq_bits),
    .deq_valid(R_array_index_01_slr1_7_deq_valid),
    .deq_ready(R_array_index_01_slr1_7_deq_ready),
    .deq_bits(R_array_index_01_slr1_7_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_7 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_7_clock),
    .reset(q_R_array_index_slr0_7_reset),
    .io_enq_ready(q_R_array_index_slr0_7_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_7_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_7_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_7_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_7_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_7_io_deq_bits),
    .io_count(q_R_array_index_slr0_7_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_8 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_8_clock),
    .reset(R_array_index_01_slr0_8_reset),
    .enq_valid(R_array_index_01_slr0_8_enq_valid),
    .enq_ready(R_array_index_01_slr0_8_enq_ready),
    .enq_bits(R_array_index_01_slr0_8_enq_bits),
    .deq_valid(R_array_index_01_slr0_8_deq_valid),
    .deq_ready(R_array_index_01_slr0_8_deq_ready),
    .deq_bits(R_array_index_01_slr0_8_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_8 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_8_clock),
    .reset(R_array_index_01_slr1_8_reset),
    .enq_valid(R_array_index_01_slr1_8_enq_valid),
    .enq_ready(R_array_index_01_slr1_8_enq_ready),
    .enq_bits(R_array_index_01_slr1_8_enq_bits),
    .deq_valid(R_array_index_01_slr1_8_deq_valid),
    .deq_ready(R_array_index_01_slr1_8_deq_ready),
    .deq_bits(R_array_index_01_slr1_8_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_8 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_8_clock),
    .reset(q_R_array_index_slr0_8_reset),
    .io_enq_ready(q_R_array_index_slr0_8_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_8_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_8_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_8_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_8_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_8_io_deq_bits),
    .io_count(q_R_array_index_slr0_8_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_9 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_9_clock),
    .reset(R_array_index_01_slr0_9_reset),
    .enq_valid(R_array_index_01_slr0_9_enq_valid),
    .enq_ready(R_array_index_01_slr0_9_enq_ready),
    .enq_bits(R_array_index_01_slr0_9_enq_bits),
    .deq_valid(R_array_index_01_slr0_9_deq_valid),
    .deq_ready(R_array_index_01_slr0_9_deq_ready),
    .deq_bits(R_array_index_01_slr0_9_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_9 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_9_clock),
    .reset(R_array_index_01_slr1_9_reset),
    .enq_valid(R_array_index_01_slr1_9_enq_valid),
    .enq_ready(R_array_index_01_slr1_9_enq_ready),
    .enq_bits(R_array_index_01_slr1_9_enq_bits),
    .deq_valid(R_array_index_01_slr1_9_deq_valid),
    .deq_ready(R_array_index_01_slr1_9_deq_ready),
    .deq_bits(R_array_index_01_slr1_9_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_9 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_9_clock),
    .reset(q_R_array_index_slr0_9_reset),
    .io_enq_ready(q_R_array_index_slr0_9_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_9_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_9_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_9_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_9_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_9_io_deq_bits),
    .io_count(q_R_array_index_slr0_9_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_10 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_10_clock),
    .reset(R_array_index_01_slr0_10_reset),
    .enq_valid(R_array_index_01_slr0_10_enq_valid),
    .enq_ready(R_array_index_01_slr0_10_enq_ready),
    .enq_bits(R_array_index_01_slr0_10_enq_bits),
    .deq_valid(R_array_index_01_slr0_10_deq_valid),
    .deq_ready(R_array_index_01_slr0_10_deq_ready),
    .deq_bits(R_array_index_01_slr0_10_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_10 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_10_clock),
    .reset(R_array_index_01_slr1_10_reset),
    .enq_valid(R_array_index_01_slr1_10_enq_valid),
    .enq_ready(R_array_index_01_slr1_10_enq_ready),
    .enq_bits(R_array_index_01_slr1_10_enq_bits),
    .deq_valid(R_array_index_01_slr1_10_deq_valid),
    .deq_ready(R_array_index_01_slr1_10_deq_ready),
    .deq_bits(R_array_index_01_slr1_10_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_10 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_10_clock),
    .reset(q_R_array_index_slr0_10_reset),
    .io_enq_ready(q_R_array_index_slr0_10_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_10_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_10_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_10_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_10_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_10_io_deq_bits),
    .io_count(q_R_array_index_slr0_10_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_11 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_11_clock),
    .reset(R_array_index_01_slr0_11_reset),
    .enq_valid(R_array_index_01_slr0_11_enq_valid),
    .enq_ready(R_array_index_01_slr0_11_enq_ready),
    .enq_bits(R_array_index_01_slr0_11_enq_bits),
    .deq_valid(R_array_index_01_slr0_11_deq_valid),
    .deq_ready(R_array_index_01_slr0_11_deq_ready),
    .deq_bits(R_array_index_01_slr0_11_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_11 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_11_clock),
    .reset(R_array_index_01_slr1_11_reset),
    .enq_valid(R_array_index_01_slr1_11_enq_valid),
    .enq_ready(R_array_index_01_slr1_11_enq_ready),
    .enq_bits(R_array_index_01_slr1_11_enq_bits),
    .deq_valid(R_array_index_01_slr1_11_deq_valid),
    .deq_ready(R_array_index_01_slr1_11_deq_ready),
    .deq_bits(R_array_index_01_slr1_11_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_11 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_11_clock),
    .reset(q_R_array_index_slr0_11_reset),
    .io_enq_ready(q_R_array_index_slr0_11_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_11_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_11_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_11_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_11_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_11_io_deq_bits),
    .io_count(q_R_array_index_slr0_11_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_12 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_12_clock),
    .reset(R_array_index_01_slr0_12_reset),
    .enq_valid(R_array_index_01_slr0_12_enq_valid),
    .enq_ready(R_array_index_01_slr0_12_enq_ready),
    .enq_bits(R_array_index_01_slr0_12_enq_bits),
    .deq_valid(R_array_index_01_slr0_12_deq_valid),
    .deq_ready(R_array_index_01_slr0_12_deq_ready),
    .deq_bits(R_array_index_01_slr0_12_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_12 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_12_clock),
    .reset(R_array_index_01_slr1_12_reset),
    .enq_valid(R_array_index_01_slr1_12_enq_valid),
    .enq_ready(R_array_index_01_slr1_12_enq_ready),
    .enq_bits(R_array_index_01_slr1_12_enq_bits),
    .deq_valid(R_array_index_01_slr1_12_deq_valid),
    .deq_ready(R_array_index_01_slr1_12_deq_ready),
    .deq_bits(R_array_index_01_slr1_12_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_12 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_12_clock),
    .reset(q_R_array_index_slr0_12_reset),
    .io_enq_ready(q_R_array_index_slr0_12_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_12_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_12_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_12_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_12_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_12_io_deq_bits),
    .io_count(q_R_array_index_slr0_12_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_13 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_13_clock),
    .reset(R_array_index_01_slr0_13_reset),
    .enq_valid(R_array_index_01_slr0_13_enq_valid),
    .enq_ready(R_array_index_01_slr0_13_enq_ready),
    .enq_bits(R_array_index_01_slr0_13_enq_bits),
    .deq_valid(R_array_index_01_slr0_13_deq_valid),
    .deq_ready(R_array_index_01_slr0_13_deq_ready),
    .deq_bits(R_array_index_01_slr0_13_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_13 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_13_clock),
    .reset(R_array_index_01_slr1_13_reset),
    .enq_valid(R_array_index_01_slr1_13_enq_valid),
    .enq_ready(R_array_index_01_slr1_13_enq_ready),
    .enq_bits(R_array_index_01_slr1_13_enq_bits),
    .deq_valid(R_array_index_01_slr1_13_deq_valid),
    .deq_ready(R_array_index_01_slr1_13_deq_ready),
    .deq_bits(R_array_index_01_slr1_13_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_13 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_13_clock),
    .reset(q_R_array_index_slr0_13_reset),
    .io_enq_ready(q_R_array_index_slr0_13_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_13_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_13_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_13_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_13_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_13_io_deq_bits),
    .io_count(q_R_array_index_slr0_13_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_14 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_14_clock),
    .reset(R_array_index_01_slr0_14_reset),
    .enq_valid(R_array_index_01_slr0_14_enq_valid),
    .enq_ready(R_array_index_01_slr0_14_enq_ready),
    .enq_bits(R_array_index_01_slr0_14_enq_bits),
    .deq_valid(R_array_index_01_slr0_14_deq_valid),
    .deq_ready(R_array_index_01_slr0_14_deq_ready),
    .deq_bits(R_array_index_01_slr0_14_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_14 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_14_clock),
    .reset(R_array_index_01_slr1_14_reset),
    .enq_valid(R_array_index_01_slr1_14_enq_valid),
    .enq_ready(R_array_index_01_slr1_14_enq_ready),
    .enq_bits(R_array_index_01_slr1_14_enq_bits),
    .deq_valid(R_array_index_01_slr1_14_deq_valid),
    .deq_ready(R_array_index_01_slr1_14_deq_ready),
    .deq_bits(R_array_index_01_slr1_14_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_14 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_14_clock),
    .reset(q_R_array_index_slr0_14_reset),
    .io_enq_ready(q_R_array_index_slr0_14_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_14_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_14_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_14_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_14_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_14_io_deq_bits),
    .io_count(q_R_array_index_slr0_14_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_15 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_15_clock),
    .reset(R_array_index_01_slr0_15_reset),
    .enq_valid(R_array_index_01_slr0_15_enq_valid),
    .enq_ready(R_array_index_01_slr0_15_enq_ready),
    .enq_bits(R_array_index_01_slr0_15_enq_bits),
    .deq_valid(R_array_index_01_slr0_15_deq_valid),
    .deq_ready(R_array_index_01_slr0_15_deq_ready),
    .deq_bits(R_array_index_01_slr0_15_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_15 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_15_clock),
    .reset(R_array_index_01_slr1_15_reset),
    .enq_valid(R_array_index_01_slr1_15_enq_valid),
    .enq_ready(R_array_index_01_slr1_15_enq_ready),
    .enq_bits(R_array_index_01_slr1_15_enq_bits),
    .deq_valid(R_array_index_01_slr1_15_deq_valid),
    .deq_ready(R_array_index_01_slr1_15_deq_ready),
    .deq_bits(R_array_index_01_slr1_15_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_15 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_15_clock),
    .reset(q_R_array_index_slr0_15_reset),
    .io_enq_ready(q_R_array_index_slr0_15_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_15_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_15_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_15_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_15_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_15_io_deq_bits),
    .io_count(q_R_array_index_slr0_15_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_16 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_16_clock),
    .reset(R_array_index_01_slr0_16_reset),
    .enq_valid(R_array_index_01_slr0_16_enq_valid),
    .enq_ready(R_array_index_01_slr0_16_enq_ready),
    .enq_bits(R_array_index_01_slr0_16_enq_bits),
    .deq_valid(R_array_index_01_slr0_16_deq_valid),
    .deq_ready(R_array_index_01_slr0_16_deq_ready),
    .deq_bits(R_array_index_01_slr0_16_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_16 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_16_clock),
    .reset(R_array_index_01_slr1_16_reset),
    .enq_valid(R_array_index_01_slr1_16_enq_valid),
    .enq_ready(R_array_index_01_slr1_16_enq_ready),
    .enq_bits(R_array_index_01_slr1_16_enq_bits),
    .deq_valid(R_array_index_01_slr1_16_deq_valid),
    .deq_ready(R_array_index_01_slr1_16_deq_ready),
    .deq_bits(R_array_index_01_slr1_16_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_16 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_16_clock),
    .reset(q_R_array_index_slr0_16_reset),
    .io_enq_ready(q_R_array_index_slr0_16_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_16_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_16_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_16_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_16_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_16_io_deq_bits),
    .io_count(q_R_array_index_slr0_16_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_17 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_17_clock),
    .reset(R_array_index_01_slr0_17_reset),
    .enq_valid(R_array_index_01_slr0_17_enq_valid),
    .enq_ready(R_array_index_01_slr0_17_enq_ready),
    .enq_bits(R_array_index_01_slr0_17_enq_bits),
    .deq_valid(R_array_index_01_slr0_17_deq_valid),
    .deq_ready(R_array_index_01_slr0_17_deq_ready),
    .deq_bits(R_array_index_01_slr0_17_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_17 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_17_clock),
    .reset(R_array_index_01_slr1_17_reset),
    .enq_valid(R_array_index_01_slr1_17_enq_valid),
    .enq_ready(R_array_index_01_slr1_17_enq_ready),
    .enq_bits(R_array_index_01_slr1_17_enq_bits),
    .deq_valid(R_array_index_01_slr1_17_deq_valid),
    .deq_ready(R_array_index_01_slr1_17_deq_ready),
    .deq_bits(R_array_index_01_slr1_17_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_17 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_17_clock),
    .reset(q_R_array_index_slr0_17_reset),
    .io_enq_ready(q_R_array_index_slr0_17_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_17_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_17_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_17_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_17_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_17_io_deq_bits),
    .io_count(q_R_array_index_slr0_17_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_18 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_18_clock),
    .reset(R_array_index_01_slr0_18_reset),
    .enq_valid(R_array_index_01_slr0_18_enq_valid),
    .enq_ready(R_array_index_01_slr0_18_enq_ready),
    .enq_bits(R_array_index_01_slr0_18_enq_bits),
    .deq_valid(R_array_index_01_slr0_18_deq_valid),
    .deq_ready(R_array_index_01_slr0_18_deq_ready),
    .deq_bits(R_array_index_01_slr0_18_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_18 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_18_clock),
    .reset(R_array_index_01_slr1_18_reset),
    .enq_valid(R_array_index_01_slr1_18_enq_valid),
    .enq_ready(R_array_index_01_slr1_18_enq_ready),
    .enq_bits(R_array_index_01_slr1_18_enq_bits),
    .deq_valid(R_array_index_01_slr1_18_deq_valid),
    .deq_ready(R_array_index_01_slr1_18_deq_ready),
    .deq_bits(R_array_index_01_slr1_18_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_18 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_18_clock),
    .reset(q_R_array_index_slr0_18_reset),
    .io_enq_ready(q_R_array_index_slr0_18_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_18_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_18_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_18_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_18_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_18_io_deq_bits),
    .io_count(q_R_array_index_slr0_18_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_19 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_19_clock),
    .reset(R_array_index_01_slr0_19_reset),
    .enq_valid(R_array_index_01_slr0_19_enq_valid),
    .enq_ready(R_array_index_01_slr0_19_enq_ready),
    .enq_bits(R_array_index_01_slr0_19_enq_bits),
    .deq_valid(R_array_index_01_slr0_19_deq_valid),
    .deq_ready(R_array_index_01_slr0_19_deq_ready),
    .deq_bits(R_array_index_01_slr0_19_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_19 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_19_clock),
    .reset(R_array_index_01_slr1_19_reset),
    .enq_valid(R_array_index_01_slr1_19_enq_valid),
    .enq_ready(R_array_index_01_slr1_19_enq_ready),
    .enq_bits(R_array_index_01_slr1_19_enq_bits),
    .deq_valid(R_array_index_01_slr1_19_deq_valid),
    .deq_ready(R_array_index_01_slr1_19_deq_ready),
    .deq_bits(R_array_index_01_slr1_19_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_19 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_19_clock),
    .reset(q_R_array_index_slr0_19_reset),
    .io_enq_ready(q_R_array_index_slr0_19_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_19_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_19_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_19_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_19_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_19_io_deq_bits),
    .io_count(q_R_array_index_slr0_19_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_20 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_20_clock),
    .reset(R_array_index_01_slr0_20_reset),
    .enq_valid(R_array_index_01_slr0_20_enq_valid),
    .enq_ready(R_array_index_01_slr0_20_enq_ready),
    .enq_bits(R_array_index_01_slr0_20_enq_bits),
    .deq_valid(R_array_index_01_slr0_20_deq_valid),
    .deq_ready(R_array_index_01_slr0_20_deq_ready),
    .deq_bits(R_array_index_01_slr0_20_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_20 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_20_clock),
    .reset(R_array_index_01_slr1_20_reset),
    .enq_valid(R_array_index_01_slr1_20_enq_valid),
    .enq_ready(R_array_index_01_slr1_20_enq_ready),
    .enq_bits(R_array_index_01_slr1_20_enq_bits),
    .deq_valid(R_array_index_01_slr1_20_deq_valid),
    .deq_ready(R_array_index_01_slr1_20_deq_ready),
    .deq_bits(R_array_index_01_slr1_20_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_20 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_20_clock),
    .reset(q_R_array_index_slr0_20_reset),
    .io_enq_ready(q_R_array_index_slr0_20_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_20_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_20_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_20_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_20_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_20_io_deq_bits),
    .io_count(q_R_array_index_slr0_20_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_21 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_21_clock),
    .reset(R_array_index_01_slr0_21_reset),
    .enq_valid(R_array_index_01_slr0_21_enq_valid),
    .enq_ready(R_array_index_01_slr0_21_enq_ready),
    .enq_bits(R_array_index_01_slr0_21_enq_bits),
    .deq_valid(R_array_index_01_slr0_21_deq_valid),
    .deq_ready(R_array_index_01_slr0_21_deq_ready),
    .deq_bits(R_array_index_01_slr0_21_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_21 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_21_clock),
    .reset(R_array_index_01_slr1_21_reset),
    .enq_valid(R_array_index_01_slr1_21_enq_valid),
    .enq_ready(R_array_index_01_slr1_21_enq_ready),
    .enq_bits(R_array_index_01_slr1_21_enq_bits),
    .deq_valid(R_array_index_01_slr1_21_deq_valid),
    .deq_ready(R_array_index_01_slr1_21_deq_ready),
    .deq_bits(R_array_index_01_slr1_21_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_21 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_21_clock),
    .reset(q_R_array_index_slr0_21_reset),
    .io_enq_ready(q_R_array_index_slr0_21_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_21_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_21_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_21_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_21_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_21_io_deq_bits),
    .io_count(q_R_array_index_slr0_21_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_22 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_22_clock),
    .reset(R_array_index_01_slr0_22_reset),
    .enq_valid(R_array_index_01_slr0_22_enq_valid),
    .enq_ready(R_array_index_01_slr0_22_enq_ready),
    .enq_bits(R_array_index_01_slr0_22_enq_bits),
    .deq_valid(R_array_index_01_slr0_22_deq_valid),
    .deq_ready(R_array_index_01_slr0_22_deq_ready),
    .deq_bits(R_array_index_01_slr0_22_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_22 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_22_clock),
    .reset(R_array_index_01_slr1_22_reset),
    .enq_valid(R_array_index_01_slr1_22_enq_valid),
    .enq_ready(R_array_index_01_slr1_22_enq_ready),
    .enq_bits(R_array_index_01_slr1_22_enq_bits),
    .deq_valid(R_array_index_01_slr1_22_deq_valid),
    .deq_ready(R_array_index_01_slr1_22_deq_ready),
    .deq_bits(R_array_index_01_slr1_22_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_22 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_22_clock),
    .reset(q_R_array_index_slr0_22_reset),
    .io_enq_ready(q_R_array_index_slr0_22_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_22_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_22_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_22_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_22_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_22_io_deq_bits),
    .io_count(q_R_array_index_slr0_22_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_23 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_23_clock),
    .reset(R_array_index_01_slr0_23_reset),
    .enq_valid(R_array_index_01_slr0_23_enq_valid),
    .enq_ready(R_array_index_01_slr0_23_enq_ready),
    .enq_bits(R_array_index_01_slr0_23_enq_bits),
    .deq_valid(R_array_index_01_slr0_23_deq_valid),
    .deq_ready(R_array_index_01_slr0_23_deq_ready),
    .deq_bits(R_array_index_01_slr0_23_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_23 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_23_clock),
    .reset(R_array_index_01_slr1_23_reset),
    .enq_valid(R_array_index_01_slr1_23_enq_valid),
    .enq_ready(R_array_index_01_slr1_23_enq_ready),
    .enq_bits(R_array_index_01_slr1_23_enq_bits),
    .deq_valid(R_array_index_01_slr1_23_deq_valid),
    .deq_ready(R_array_index_01_slr1_23_deq_ready),
    .deq_bits(R_array_index_01_slr1_23_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_23 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_23_clock),
    .reset(q_R_array_index_slr0_23_reset),
    .io_enq_ready(q_R_array_index_slr0_23_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_23_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_23_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_23_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_23_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_23_io_deq_bits),
    .io_count(q_R_array_index_slr0_23_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_24 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_24_clock),
    .reset(R_array_index_01_slr0_24_reset),
    .enq_valid(R_array_index_01_slr0_24_enq_valid),
    .enq_ready(R_array_index_01_slr0_24_enq_ready),
    .enq_bits(R_array_index_01_slr0_24_enq_bits),
    .deq_valid(R_array_index_01_slr0_24_deq_valid),
    .deq_ready(R_array_index_01_slr0_24_deq_ready),
    .deq_bits(R_array_index_01_slr0_24_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_24 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_24_clock),
    .reset(R_array_index_01_slr1_24_reset),
    .enq_valid(R_array_index_01_slr1_24_enq_valid),
    .enq_ready(R_array_index_01_slr1_24_enq_ready),
    .enq_bits(R_array_index_01_slr1_24_enq_bits),
    .deq_valid(R_array_index_01_slr1_24_deq_valid),
    .deq_ready(R_array_index_01_slr1_24_deq_ready),
    .deq_bits(R_array_index_01_slr1_24_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_24 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_24_clock),
    .reset(q_R_array_index_slr0_24_reset),
    .io_enq_ready(q_R_array_index_slr0_24_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_24_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_24_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_24_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_24_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_24_io_deq_bits),
    .io_count(q_R_array_index_slr0_24_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_25 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_25_clock),
    .reset(R_array_index_01_slr0_25_reset),
    .enq_valid(R_array_index_01_slr0_25_enq_valid),
    .enq_ready(R_array_index_01_slr0_25_enq_ready),
    .enq_bits(R_array_index_01_slr0_25_enq_bits),
    .deq_valid(R_array_index_01_slr0_25_deq_valid),
    .deq_ready(R_array_index_01_slr0_25_deq_ready),
    .deq_bits(R_array_index_01_slr0_25_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_25 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_25_clock),
    .reset(R_array_index_01_slr1_25_reset),
    .enq_valid(R_array_index_01_slr1_25_enq_valid),
    .enq_ready(R_array_index_01_slr1_25_enq_ready),
    .enq_bits(R_array_index_01_slr1_25_enq_bits),
    .deq_valid(R_array_index_01_slr1_25_deq_valid),
    .deq_ready(R_array_index_01_slr1_25_deq_ready),
    .deq_bits(R_array_index_01_slr1_25_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_25 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_25_clock),
    .reset(q_R_array_index_slr0_25_reset),
    .io_enq_ready(q_R_array_index_slr0_25_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_25_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_25_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_25_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_25_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_25_io_deq_bits),
    .io_count(q_R_array_index_slr0_25_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_26 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_26_clock),
    .reset(R_array_index_01_slr0_26_reset),
    .enq_valid(R_array_index_01_slr0_26_enq_valid),
    .enq_ready(R_array_index_01_slr0_26_enq_ready),
    .enq_bits(R_array_index_01_slr0_26_enq_bits),
    .deq_valid(R_array_index_01_slr0_26_deq_valid),
    .deq_ready(R_array_index_01_slr0_26_deq_ready),
    .deq_bits(R_array_index_01_slr0_26_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_26 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_26_clock),
    .reset(R_array_index_01_slr1_26_reset),
    .enq_valid(R_array_index_01_slr1_26_enq_valid),
    .enq_ready(R_array_index_01_slr1_26_enq_ready),
    .enq_bits(R_array_index_01_slr1_26_enq_bits),
    .deq_valid(R_array_index_01_slr1_26_deq_valid),
    .deq_ready(R_array_index_01_slr1_26_deq_ready),
    .deq_bits(R_array_index_01_slr1_26_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_26 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_26_clock),
    .reset(q_R_array_index_slr0_26_reset),
    .io_enq_ready(q_R_array_index_slr0_26_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_26_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_26_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_26_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_26_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_26_io_deq_bits),
    .io_count(q_R_array_index_slr0_26_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_27 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_27_clock),
    .reset(R_array_index_01_slr0_27_reset),
    .enq_valid(R_array_index_01_slr0_27_enq_valid),
    .enq_ready(R_array_index_01_slr0_27_enq_ready),
    .enq_bits(R_array_index_01_slr0_27_enq_bits),
    .deq_valid(R_array_index_01_slr0_27_deq_valid),
    .deq_ready(R_array_index_01_slr0_27_deq_ready),
    .deq_bits(R_array_index_01_slr0_27_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_27 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_27_clock),
    .reset(R_array_index_01_slr1_27_reset),
    .enq_valid(R_array_index_01_slr1_27_enq_valid),
    .enq_ready(R_array_index_01_slr1_27_enq_ready),
    .enq_bits(R_array_index_01_slr1_27_enq_bits),
    .deq_valid(R_array_index_01_slr1_27_deq_valid),
    .deq_ready(R_array_index_01_slr1_27_deq_ready),
    .deq_bits(R_array_index_01_slr1_27_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_27 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_27_clock),
    .reset(q_R_array_index_slr0_27_reset),
    .io_enq_ready(q_R_array_index_slr0_27_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_27_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_27_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_27_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_27_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_27_io_deq_bits),
    .io_count(q_R_array_index_slr0_27_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_28 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_28_clock),
    .reset(R_array_index_01_slr0_28_reset),
    .enq_valid(R_array_index_01_slr0_28_enq_valid),
    .enq_ready(R_array_index_01_slr0_28_enq_ready),
    .enq_bits(R_array_index_01_slr0_28_enq_bits),
    .deq_valid(R_array_index_01_slr0_28_deq_valid),
    .deq_ready(R_array_index_01_slr0_28_deq_ready),
    .deq_bits(R_array_index_01_slr0_28_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_28 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_28_clock),
    .reset(R_array_index_01_slr1_28_reset),
    .enq_valid(R_array_index_01_slr1_28_enq_valid),
    .enq_ready(R_array_index_01_slr1_28_enq_ready),
    .enq_bits(R_array_index_01_slr1_28_enq_bits),
    .deq_valid(R_array_index_01_slr1_28_deq_valid),
    .deq_ready(R_array_index_01_slr1_28_deq_ready),
    .deq_bits(R_array_index_01_slr1_28_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_28 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_28_clock),
    .reset(q_R_array_index_slr0_28_reset),
    .io_enq_ready(q_R_array_index_slr0_28_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_28_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_28_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_28_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_28_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_28_io_deq_bits),
    .io_count(q_R_array_index_slr0_28_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_29 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_29_clock),
    .reset(R_array_index_01_slr0_29_reset),
    .enq_valid(R_array_index_01_slr0_29_enq_valid),
    .enq_ready(R_array_index_01_slr0_29_enq_ready),
    .enq_bits(R_array_index_01_slr0_29_enq_bits),
    .deq_valid(R_array_index_01_slr0_29_deq_valid),
    .deq_ready(R_array_index_01_slr0_29_deq_ready),
    .deq_bits(R_array_index_01_slr0_29_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_29 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_29_clock),
    .reset(R_array_index_01_slr1_29_reset),
    .enq_valid(R_array_index_01_slr1_29_enq_valid),
    .enq_ready(R_array_index_01_slr1_29_enq_ready),
    .enq_bits(R_array_index_01_slr1_29_enq_bits),
    .deq_valid(R_array_index_01_slr1_29_deq_valid),
    .deq_ready(R_array_index_01_slr1_29_deq_ready),
    .deq_bits(R_array_index_01_slr1_29_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_29 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_29_clock),
    .reset(q_R_array_index_slr0_29_reset),
    .io_enq_ready(q_R_array_index_slr0_29_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_29_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_29_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_29_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_29_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_29_io_deq_bits),
    .io_count(q_R_array_index_slr0_29_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_30 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_30_clock),
    .reset(R_array_index_01_slr0_30_reset),
    .enq_valid(R_array_index_01_slr0_30_enq_valid),
    .enq_ready(R_array_index_01_slr0_30_enq_ready),
    .enq_bits(R_array_index_01_slr0_30_enq_bits),
    .deq_valid(R_array_index_01_slr0_30_deq_valid),
    .deq_ready(R_array_index_01_slr0_30_deq_ready),
    .deq_bits(R_array_index_01_slr0_30_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_30 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_30_clock),
    .reset(R_array_index_01_slr1_30_reset),
    .enq_valid(R_array_index_01_slr1_30_enq_valid),
    .enq_ready(R_array_index_01_slr1_30_enq_ready),
    .enq_bits(R_array_index_01_slr1_30_enq_bits),
    .deq_valid(R_array_index_01_slr1_30_deq_valid),
    .deq_ready(R_array_index_01_slr1_30_deq_ready),
    .deq_bits(R_array_index_01_slr1_30_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_30 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_30_clock),
    .reset(q_R_array_index_slr0_30_reset),
    .io_enq_ready(q_R_array_index_slr0_30_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_30_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_30_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_30_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_30_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_30_io_deq_bits),
    .io_count(q_R_array_index_slr0_30_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_31 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_31_clock),
    .reset(R_array_index_01_slr0_31_reset),
    .enq_valid(R_array_index_01_slr0_31_enq_valid),
    .enq_ready(R_array_index_01_slr0_31_enq_ready),
    .enq_bits(R_array_index_01_slr0_31_enq_bits),
    .deq_valid(R_array_index_01_slr0_31_deq_valid),
    .deq_ready(R_array_index_01_slr0_31_deq_ready),
    .deq_bits(R_array_index_01_slr0_31_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_31 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_31_clock),
    .reset(R_array_index_01_slr1_31_reset),
    .enq_valid(R_array_index_01_slr1_31_enq_valid),
    .enq_ready(R_array_index_01_slr1_31_enq_ready),
    .enq_bits(R_array_index_01_slr1_31_enq_bits),
    .deq_valid(R_array_index_01_slr1_31_deq_valid),
    .deq_ready(R_array_index_01_slr1_31_deq_ready),
    .deq_bits(R_array_index_01_slr1_31_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_31 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_31_clock),
    .reset(q_R_array_index_slr0_31_reset),
    .io_enq_ready(q_R_array_index_slr0_31_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_31_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_31_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_31_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_31_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_31_io_deq_bits),
    .io_count(q_R_array_index_slr0_31_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_32 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_32_clock),
    .reset(R_array_index_01_slr0_32_reset),
    .enq_valid(R_array_index_01_slr0_32_enq_valid),
    .enq_ready(R_array_index_01_slr0_32_enq_ready),
    .enq_bits(R_array_index_01_slr0_32_enq_bits),
    .deq_valid(R_array_index_01_slr0_32_deq_valid),
    .deq_ready(R_array_index_01_slr0_32_deq_ready),
    .deq_bits(R_array_index_01_slr0_32_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_32 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_32_clock),
    .reset(R_array_index_01_slr1_32_reset),
    .enq_valid(R_array_index_01_slr1_32_enq_valid),
    .enq_ready(R_array_index_01_slr1_32_enq_ready),
    .enq_bits(R_array_index_01_slr1_32_enq_bits),
    .deq_valid(R_array_index_01_slr1_32_deq_valid),
    .deq_ready(R_array_index_01_slr1_32_deq_ready),
    .deq_bits(R_array_index_01_slr1_32_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_32 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_32_clock),
    .reset(q_R_array_index_slr0_32_reset),
    .io_enq_ready(q_R_array_index_slr0_32_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_32_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_32_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_32_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_32_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_32_io_deq_bits),
    .io_count(q_R_array_index_slr0_32_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_33 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_33_clock),
    .reset(R_array_index_01_slr0_33_reset),
    .enq_valid(R_array_index_01_slr0_33_enq_valid),
    .enq_ready(R_array_index_01_slr0_33_enq_ready),
    .enq_bits(R_array_index_01_slr0_33_enq_bits),
    .deq_valid(R_array_index_01_slr0_33_deq_valid),
    .deq_ready(R_array_index_01_slr0_33_deq_ready),
    .deq_bits(R_array_index_01_slr0_33_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_33 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_33_clock),
    .reset(R_array_index_01_slr1_33_reset),
    .enq_valid(R_array_index_01_slr1_33_enq_valid),
    .enq_ready(R_array_index_01_slr1_33_enq_ready),
    .enq_bits(R_array_index_01_slr1_33_enq_bits),
    .deq_valid(R_array_index_01_slr1_33_deq_valid),
    .deq_ready(R_array_index_01_slr1_33_deq_ready),
    .deq_bits(R_array_index_01_slr1_33_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_33 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_33_clock),
    .reset(q_R_array_index_slr0_33_reset),
    .io_enq_ready(q_R_array_index_slr0_33_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_33_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_33_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_33_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_33_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_33_io_deq_bits),
    .io_count(q_R_array_index_slr0_33_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_34 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_34_clock),
    .reset(R_array_index_01_slr0_34_reset),
    .enq_valid(R_array_index_01_slr0_34_enq_valid),
    .enq_ready(R_array_index_01_slr0_34_enq_ready),
    .enq_bits(R_array_index_01_slr0_34_enq_bits),
    .deq_valid(R_array_index_01_slr0_34_deq_valid),
    .deq_ready(R_array_index_01_slr0_34_deq_ready),
    .deq_bits(R_array_index_01_slr0_34_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_34 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_34_clock),
    .reset(R_array_index_01_slr1_34_reset),
    .enq_valid(R_array_index_01_slr1_34_enq_valid),
    .enq_ready(R_array_index_01_slr1_34_enq_ready),
    .enq_bits(R_array_index_01_slr1_34_enq_bits),
    .deq_valid(R_array_index_01_slr1_34_deq_valid),
    .deq_ready(R_array_index_01_slr1_34_deq_ready),
    .deq_bits(R_array_index_01_slr1_34_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_34 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_34_clock),
    .reset(q_R_array_index_slr0_34_reset),
    .io_enq_ready(q_R_array_index_slr0_34_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_34_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_34_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_34_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_34_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_34_io_deq_bits),
    .io_count(q_R_array_index_slr0_34_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_35 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_35_clock),
    .reset(R_array_index_01_slr0_35_reset),
    .enq_valid(R_array_index_01_slr0_35_enq_valid),
    .enq_ready(R_array_index_01_slr0_35_enq_ready),
    .enq_bits(R_array_index_01_slr0_35_enq_bits),
    .deq_valid(R_array_index_01_slr0_35_deq_valid),
    .deq_ready(R_array_index_01_slr0_35_deq_ready),
    .deq_bits(R_array_index_01_slr0_35_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_35 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_35_clock),
    .reset(R_array_index_01_slr1_35_reset),
    .enq_valid(R_array_index_01_slr1_35_enq_valid),
    .enq_ready(R_array_index_01_slr1_35_enq_ready),
    .enq_bits(R_array_index_01_slr1_35_enq_bits),
    .deq_valid(R_array_index_01_slr1_35_deq_valid),
    .deq_ready(R_array_index_01_slr1_35_deq_ready),
    .deq_bits(R_array_index_01_slr1_35_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_35 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_35_clock),
    .reset(q_R_array_index_slr0_35_reset),
    .io_enq_ready(q_R_array_index_slr0_35_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_35_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_35_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_35_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_35_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_35_io_deq_bits),
    .io_count(q_R_array_index_slr0_35_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_36 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_36_clock),
    .reset(R_array_index_01_slr0_36_reset),
    .enq_valid(R_array_index_01_slr0_36_enq_valid),
    .enq_ready(R_array_index_01_slr0_36_enq_ready),
    .enq_bits(R_array_index_01_slr0_36_enq_bits),
    .deq_valid(R_array_index_01_slr0_36_deq_valid),
    .deq_ready(R_array_index_01_slr0_36_deq_ready),
    .deq_bits(R_array_index_01_slr0_36_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_36 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_36_clock),
    .reset(R_array_index_01_slr1_36_reset),
    .enq_valid(R_array_index_01_slr1_36_enq_valid),
    .enq_ready(R_array_index_01_slr1_36_enq_ready),
    .enq_bits(R_array_index_01_slr1_36_enq_bits),
    .deq_valid(R_array_index_01_slr1_36_deq_valid),
    .deq_ready(R_array_index_01_slr1_36_deq_ready),
    .deq_bits(R_array_index_01_slr1_36_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_36 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_36_clock),
    .reset(q_R_array_index_slr0_36_reset),
    .io_enq_ready(q_R_array_index_slr0_36_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_36_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_36_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_36_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_36_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_36_io_deq_bits),
    .io_count(q_R_array_index_slr0_36_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_37 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_37_clock),
    .reset(R_array_index_01_slr0_37_reset),
    .enq_valid(R_array_index_01_slr0_37_enq_valid),
    .enq_ready(R_array_index_01_slr0_37_enq_ready),
    .enq_bits(R_array_index_01_slr0_37_enq_bits),
    .deq_valid(R_array_index_01_slr0_37_deq_valid),
    .deq_ready(R_array_index_01_slr0_37_deq_ready),
    .deq_bits(R_array_index_01_slr0_37_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_37 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_37_clock),
    .reset(R_array_index_01_slr1_37_reset),
    .enq_valid(R_array_index_01_slr1_37_enq_valid),
    .enq_ready(R_array_index_01_slr1_37_enq_ready),
    .enq_bits(R_array_index_01_slr1_37_enq_bits),
    .deq_valid(R_array_index_01_slr1_37_deq_valid),
    .deq_ready(R_array_index_01_slr1_37_deq_ready),
    .deq_bits(R_array_index_01_slr1_37_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_37 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_37_clock),
    .reset(q_R_array_index_slr0_37_reset),
    .io_enq_ready(q_R_array_index_slr0_37_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_37_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_37_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_37_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_37_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_37_io_deq_bits),
    .io_count(q_R_array_index_slr0_37_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_38 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_38_clock),
    .reset(R_array_index_01_slr0_38_reset),
    .enq_valid(R_array_index_01_slr0_38_enq_valid),
    .enq_ready(R_array_index_01_slr0_38_enq_ready),
    .enq_bits(R_array_index_01_slr0_38_enq_bits),
    .deq_valid(R_array_index_01_slr0_38_deq_valid),
    .deq_ready(R_array_index_01_slr0_38_deq_ready),
    .deq_bits(R_array_index_01_slr0_38_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_38 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_38_clock),
    .reset(R_array_index_01_slr1_38_reset),
    .enq_valid(R_array_index_01_slr1_38_enq_valid),
    .enq_ready(R_array_index_01_slr1_38_enq_ready),
    .enq_bits(R_array_index_01_slr1_38_enq_bits),
    .deq_valid(R_array_index_01_slr1_38_deq_valid),
    .deq_ready(R_array_index_01_slr1_38_deq_ready),
    .deq_bits(R_array_index_01_slr1_38_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_38 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_38_clock),
    .reset(q_R_array_index_slr0_38_reset),
    .io_enq_ready(q_R_array_index_slr0_38_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_38_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_38_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_38_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_38_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_38_io_deq_bits),
    .io_count(q_R_array_index_slr0_38_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_39 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_39_clock),
    .reset(R_array_index_01_slr0_39_reset),
    .enq_valid(R_array_index_01_slr0_39_enq_valid),
    .enq_ready(R_array_index_01_slr0_39_enq_ready),
    .enq_bits(R_array_index_01_slr0_39_enq_bits),
    .deq_valid(R_array_index_01_slr0_39_deq_valid),
    .deq_ready(R_array_index_01_slr0_39_deq_ready),
    .deq_bits(R_array_index_01_slr0_39_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_39 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_39_clock),
    .reset(R_array_index_01_slr1_39_reset),
    .enq_valid(R_array_index_01_slr1_39_enq_valid),
    .enq_ready(R_array_index_01_slr1_39_enq_ready),
    .enq_bits(R_array_index_01_slr1_39_enq_bits),
    .deq_valid(R_array_index_01_slr1_39_deq_valid),
    .deq_ready(R_array_index_01_slr1_39_deq_ready),
    .deq_bits(R_array_index_01_slr1_39_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_39 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_39_clock),
    .reset(q_R_array_index_slr0_39_reset),
    .io_enq_ready(q_R_array_index_slr0_39_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_39_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_39_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_39_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_39_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_39_io_deq_bits),
    .io_count(q_R_array_index_slr0_39_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_40 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_40_clock),
    .reset(R_array_index_01_slr0_40_reset),
    .enq_valid(R_array_index_01_slr0_40_enq_valid),
    .enq_ready(R_array_index_01_slr0_40_enq_ready),
    .enq_bits(R_array_index_01_slr0_40_enq_bits),
    .deq_valid(R_array_index_01_slr0_40_deq_valid),
    .deq_ready(R_array_index_01_slr0_40_deq_ready),
    .deq_bits(R_array_index_01_slr0_40_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_40 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_40_clock),
    .reset(R_array_index_01_slr1_40_reset),
    .enq_valid(R_array_index_01_slr1_40_enq_valid),
    .enq_ready(R_array_index_01_slr1_40_enq_ready),
    .enq_bits(R_array_index_01_slr1_40_enq_bits),
    .deq_valid(R_array_index_01_slr1_40_deq_valid),
    .deq_ready(R_array_index_01_slr1_40_deq_ready),
    .deq_bits(R_array_index_01_slr1_40_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_40 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_40_clock),
    .reset(q_R_array_index_slr0_40_reset),
    .io_enq_ready(q_R_array_index_slr0_40_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_40_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_40_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_40_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_40_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_40_io_deq_bits),
    .io_count(q_R_array_index_slr0_40_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_41 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_41_clock),
    .reset(R_array_index_01_slr0_41_reset),
    .enq_valid(R_array_index_01_slr0_41_enq_valid),
    .enq_ready(R_array_index_01_slr0_41_enq_ready),
    .enq_bits(R_array_index_01_slr0_41_enq_bits),
    .deq_valid(R_array_index_01_slr0_41_deq_valid),
    .deq_ready(R_array_index_01_slr0_41_deq_ready),
    .deq_bits(R_array_index_01_slr0_41_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_41 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_41_clock),
    .reset(R_array_index_01_slr1_41_reset),
    .enq_valid(R_array_index_01_slr1_41_enq_valid),
    .enq_ready(R_array_index_01_slr1_41_enq_ready),
    .enq_bits(R_array_index_01_slr1_41_enq_bits),
    .deq_valid(R_array_index_01_slr1_41_deq_valid),
    .deq_ready(R_array_index_01_slr1_41_deq_ready),
    .deq_bits(R_array_index_01_slr1_41_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_41 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_41_clock),
    .reset(q_R_array_index_slr0_41_reset),
    .io_enq_ready(q_R_array_index_slr0_41_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_41_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_41_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_41_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_41_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_41_io_deq_bits),
    .io_count(q_R_array_index_slr0_41_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_42 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_42_clock),
    .reset(R_array_index_01_slr0_42_reset),
    .enq_valid(R_array_index_01_slr0_42_enq_valid),
    .enq_ready(R_array_index_01_slr0_42_enq_ready),
    .enq_bits(R_array_index_01_slr0_42_enq_bits),
    .deq_valid(R_array_index_01_slr0_42_deq_valid),
    .deq_ready(R_array_index_01_slr0_42_deq_ready),
    .deq_bits(R_array_index_01_slr0_42_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_42 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_42_clock),
    .reset(R_array_index_01_slr1_42_reset),
    .enq_valid(R_array_index_01_slr1_42_enq_valid),
    .enq_ready(R_array_index_01_slr1_42_enq_ready),
    .enq_bits(R_array_index_01_slr1_42_enq_bits),
    .deq_valid(R_array_index_01_slr1_42_deq_valid),
    .deq_ready(R_array_index_01_slr1_42_deq_ready),
    .deq_bits(R_array_index_01_slr1_42_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_42 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_42_clock),
    .reset(q_R_array_index_slr0_42_reset),
    .io_enq_ready(q_R_array_index_slr0_42_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_42_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_42_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_42_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_42_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_42_io_deq_bits),
    .io_count(q_R_array_index_slr0_42_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_43 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_43_clock),
    .reset(R_array_index_01_slr0_43_reset),
    .enq_valid(R_array_index_01_slr0_43_enq_valid),
    .enq_ready(R_array_index_01_slr0_43_enq_ready),
    .enq_bits(R_array_index_01_slr0_43_enq_bits),
    .deq_valid(R_array_index_01_slr0_43_deq_valid),
    .deq_ready(R_array_index_01_slr0_43_deq_ready),
    .deq_bits(R_array_index_01_slr0_43_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_43 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_43_clock),
    .reset(R_array_index_01_slr1_43_reset),
    .enq_valid(R_array_index_01_slr1_43_enq_valid),
    .enq_ready(R_array_index_01_slr1_43_enq_ready),
    .enq_bits(R_array_index_01_slr1_43_enq_bits),
    .deq_valid(R_array_index_01_slr1_43_deq_valid),
    .deq_ready(R_array_index_01_slr1_43_deq_ready),
    .deq_bits(R_array_index_01_slr1_43_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_43 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_43_clock),
    .reset(q_R_array_index_slr0_43_reset),
    .io_enq_ready(q_R_array_index_slr0_43_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_43_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_43_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_43_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_43_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_43_io_deq_bits),
    .io_count(q_R_array_index_slr0_43_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_44 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_44_clock),
    .reset(R_array_index_01_slr0_44_reset),
    .enq_valid(R_array_index_01_slr0_44_enq_valid),
    .enq_ready(R_array_index_01_slr0_44_enq_ready),
    .enq_bits(R_array_index_01_slr0_44_enq_bits),
    .deq_valid(R_array_index_01_slr0_44_deq_valid),
    .deq_ready(R_array_index_01_slr0_44_deq_ready),
    .deq_bits(R_array_index_01_slr0_44_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_44 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_44_clock),
    .reset(R_array_index_01_slr1_44_reset),
    .enq_valid(R_array_index_01_slr1_44_enq_valid),
    .enq_ready(R_array_index_01_slr1_44_enq_ready),
    .enq_bits(R_array_index_01_slr1_44_enq_bits),
    .deq_valid(R_array_index_01_slr1_44_deq_valid),
    .deq_ready(R_array_index_01_slr1_44_deq_ready),
    .deq_bits(R_array_index_01_slr1_44_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_44 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_44_clock),
    .reset(q_R_array_index_slr0_44_reset),
    .io_enq_ready(q_R_array_index_slr0_44_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_44_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_44_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_44_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_44_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_44_io_deq_bits),
    .io_count(q_R_array_index_slr0_44_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_45 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_45_clock),
    .reset(R_array_index_01_slr0_45_reset),
    .enq_valid(R_array_index_01_slr0_45_enq_valid),
    .enq_ready(R_array_index_01_slr0_45_enq_ready),
    .enq_bits(R_array_index_01_slr0_45_enq_bits),
    .deq_valid(R_array_index_01_slr0_45_deq_valid),
    .deq_ready(R_array_index_01_slr0_45_deq_ready),
    .deq_bits(R_array_index_01_slr0_45_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_45 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_45_clock),
    .reset(R_array_index_01_slr1_45_reset),
    .enq_valid(R_array_index_01_slr1_45_enq_valid),
    .enq_ready(R_array_index_01_slr1_45_enq_ready),
    .enq_bits(R_array_index_01_slr1_45_enq_bits),
    .deq_valid(R_array_index_01_slr1_45_deq_valid),
    .deq_ready(R_array_index_01_slr1_45_deq_ready),
    .deq_bits(R_array_index_01_slr1_45_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_45 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_45_clock),
    .reset(q_R_array_index_slr0_45_reset),
    .io_enq_ready(q_R_array_index_slr0_45_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_45_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_45_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_45_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_45_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_45_io_deq_bits),
    .io_count(q_R_array_index_slr0_45_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_46 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_46_clock),
    .reset(R_array_index_01_slr0_46_reset),
    .enq_valid(R_array_index_01_slr0_46_enq_valid),
    .enq_ready(R_array_index_01_slr0_46_enq_ready),
    .enq_bits(R_array_index_01_slr0_46_enq_bits),
    .deq_valid(R_array_index_01_slr0_46_deq_valid),
    .deq_ready(R_array_index_01_slr0_46_deq_ready),
    .deq_bits(R_array_index_01_slr0_46_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_46 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_46_clock),
    .reset(R_array_index_01_slr1_46_reset),
    .enq_valid(R_array_index_01_slr1_46_enq_valid),
    .enq_ready(R_array_index_01_slr1_46_enq_ready),
    .enq_bits(R_array_index_01_slr1_46_enq_bits),
    .deq_valid(R_array_index_01_slr1_46_deq_valid),
    .deq_ready(R_array_index_01_slr1_46_deq_ready),
    .deq_bits(R_array_index_01_slr1_46_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_46 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_46_clock),
    .reset(q_R_array_index_slr0_46_reset),
    .io_enq_ready(q_R_array_index_slr0_46_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_46_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_46_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_46_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_46_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_46_io_deq_bits),
    .io_count(q_R_array_index_slr0_46_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_47 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_47_clock),
    .reset(R_array_index_01_slr0_47_reset),
    .enq_valid(R_array_index_01_slr0_47_enq_valid),
    .enq_ready(R_array_index_01_slr0_47_enq_ready),
    .enq_bits(R_array_index_01_slr0_47_enq_bits),
    .deq_valid(R_array_index_01_slr0_47_deq_valid),
    .deq_ready(R_array_index_01_slr0_47_deq_ready),
    .deq_bits(R_array_index_01_slr0_47_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_47 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_47_clock),
    .reset(R_array_index_01_slr1_47_reset),
    .enq_valid(R_array_index_01_slr1_47_enq_valid),
    .enq_ready(R_array_index_01_slr1_47_enq_ready),
    .enq_bits(R_array_index_01_slr1_47_enq_bits),
    .deq_valid(R_array_index_01_slr1_47_deq_valid),
    .deq_ready(R_array_index_01_slr1_47_deq_ready),
    .deq_bits(R_array_index_01_slr1_47_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_47 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_47_clock),
    .reset(q_R_array_index_slr0_47_reset),
    .io_enq_ready(q_R_array_index_slr0_47_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_47_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_47_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_47_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_47_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_47_io_deq_bits),
    .io_count(q_R_array_index_slr0_47_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_48 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_48_clock),
    .reset(R_array_index_01_slr0_48_reset),
    .enq_valid(R_array_index_01_slr0_48_enq_valid),
    .enq_ready(R_array_index_01_slr0_48_enq_ready),
    .enq_bits(R_array_index_01_slr0_48_enq_bits),
    .deq_valid(R_array_index_01_slr0_48_deq_valid),
    .deq_ready(R_array_index_01_slr0_48_deq_ready),
    .deq_bits(R_array_index_01_slr0_48_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_48 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_48_clock),
    .reset(R_array_index_01_slr1_48_reset),
    .enq_valid(R_array_index_01_slr1_48_enq_valid),
    .enq_ready(R_array_index_01_slr1_48_enq_ready),
    .enq_bits(R_array_index_01_slr1_48_enq_bits),
    .deq_valid(R_array_index_01_slr1_48_deq_valid),
    .deq_ready(R_array_index_01_slr1_48_deq_ready),
    .deq_bits(R_array_index_01_slr1_48_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_48 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_48_clock),
    .reset(q_R_array_index_slr0_48_reset),
    .io_enq_ready(q_R_array_index_slr0_48_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_48_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_48_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_48_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_48_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_48_io_deq_bits),
    .io_count(q_R_array_index_slr0_48_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_49 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_49_clock),
    .reset(R_array_index_01_slr0_49_reset),
    .enq_valid(R_array_index_01_slr0_49_enq_valid),
    .enq_ready(R_array_index_01_slr0_49_enq_ready),
    .enq_bits(R_array_index_01_slr0_49_enq_bits),
    .deq_valid(R_array_index_01_slr0_49_deq_valid),
    .deq_ready(R_array_index_01_slr0_49_deq_ready),
    .deq_bits(R_array_index_01_slr0_49_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_49 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_49_clock),
    .reset(R_array_index_01_slr1_49_reset),
    .enq_valid(R_array_index_01_slr1_49_enq_valid),
    .enq_ready(R_array_index_01_slr1_49_enq_ready),
    .enq_bits(R_array_index_01_slr1_49_enq_bits),
    .deq_valid(R_array_index_01_slr1_49_deq_valid),
    .deq_ready(R_array_index_01_slr1_49_deq_ready),
    .deq_bits(R_array_index_01_slr1_49_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_49 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_49_clock),
    .reset(q_R_array_index_slr0_49_reset),
    .io_enq_ready(q_R_array_index_slr0_49_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_49_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_49_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_49_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_49_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_49_io_deq_bits),
    .io_count(q_R_array_index_slr0_49_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_50 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_50_clock),
    .reset(R_array_index_01_slr0_50_reset),
    .enq_valid(R_array_index_01_slr0_50_enq_valid),
    .enq_ready(R_array_index_01_slr0_50_enq_ready),
    .enq_bits(R_array_index_01_slr0_50_enq_bits),
    .deq_valid(R_array_index_01_slr0_50_deq_valid),
    .deq_ready(R_array_index_01_slr0_50_deq_ready),
    .deq_bits(R_array_index_01_slr0_50_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_50 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_50_clock),
    .reset(R_array_index_01_slr1_50_reset),
    .enq_valid(R_array_index_01_slr1_50_enq_valid),
    .enq_ready(R_array_index_01_slr1_50_enq_ready),
    .enq_bits(R_array_index_01_slr1_50_enq_bits),
    .deq_valid(R_array_index_01_slr1_50_deq_valid),
    .deq_ready(R_array_index_01_slr1_50_deq_ready),
    .deq_bits(R_array_index_01_slr1_50_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_50 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_50_clock),
    .reset(q_R_array_index_slr0_50_reset),
    .io_enq_ready(q_R_array_index_slr0_50_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_50_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_50_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_50_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_50_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_50_io_deq_bits),
    .io_count(q_R_array_index_slr0_50_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_51 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_51_clock),
    .reset(R_array_index_01_slr0_51_reset),
    .enq_valid(R_array_index_01_slr0_51_enq_valid),
    .enq_ready(R_array_index_01_slr0_51_enq_ready),
    .enq_bits(R_array_index_01_slr0_51_enq_bits),
    .deq_valid(R_array_index_01_slr0_51_deq_valid),
    .deq_ready(R_array_index_01_slr0_51_deq_ready),
    .deq_bits(R_array_index_01_slr0_51_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_51 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_51_clock),
    .reset(R_array_index_01_slr1_51_reset),
    .enq_valid(R_array_index_01_slr1_51_enq_valid),
    .enq_ready(R_array_index_01_slr1_51_enq_ready),
    .enq_bits(R_array_index_01_slr1_51_enq_bits),
    .deq_valid(R_array_index_01_slr1_51_deq_valid),
    .deq_ready(R_array_index_01_slr1_51_deq_ready),
    .deq_bits(R_array_index_01_slr1_51_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_51 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_51_clock),
    .reset(q_R_array_index_slr0_51_reset),
    .io_enq_ready(q_R_array_index_slr0_51_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_51_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_51_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_51_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_51_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_51_io_deq_bits),
    .io_count(q_R_array_index_slr0_51_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_52 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_52_clock),
    .reset(R_array_index_01_slr0_52_reset),
    .enq_valid(R_array_index_01_slr0_52_enq_valid),
    .enq_ready(R_array_index_01_slr0_52_enq_ready),
    .enq_bits(R_array_index_01_slr0_52_enq_bits),
    .deq_valid(R_array_index_01_slr0_52_deq_valid),
    .deq_ready(R_array_index_01_slr0_52_deq_ready),
    .deq_bits(R_array_index_01_slr0_52_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_52 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_52_clock),
    .reset(R_array_index_01_slr1_52_reset),
    .enq_valid(R_array_index_01_slr1_52_enq_valid),
    .enq_ready(R_array_index_01_slr1_52_enq_ready),
    .enq_bits(R_array_index_01_slr1_52_enq_bits),
    .deq_valid(R_array_index_01_slr1_52_deq_valid),
    .deq_ready(R_array_index_01_slr1_52_deq_ready),
    .deq_bits(R_array_index_01_slr1_52_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_52 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_52_clock),
    .reset(q_R_array_index_slr0_52_reset),
    .io_enq_ready(q_R_array_index_slr0_52_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_52_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_52_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_52_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_52_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_52_io_deq_bits),
    .io_count(q_R_array_index_slr0_52_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_53 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_53_clock),
    .reset(R_array_index_01_slr0_53_reset),
    .enq_valid(R_array_index_01_slr0_53_enq_valid),
    .enq_ready(R_array_index_01_slr0_53_enq_ready),
    .enq_bits(R_array_index_01_slr0_53_enq_bits),
    .deq_valid(R_array_index_01_slr0_53_deq_valid),
    .deq_ready(R_array_index_01_slr0_53_deq_ready),
    .deq_bits(R_array_index_01_slr0_53_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_53 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_53_clock),
    .reset(R_array_index_01_slr1_53_reset),
    .enq_valid(R_array_index_01_slr1_53_enq_valid),
    .enq_ready(R_array_index_01_slr1_53_enq_ready),
    .enq_bits(R_array_index_01_slr1_53_enq_bits),
    .deq_valid(R_array_index_01_slr1_53_deq_valid),
    .deq_ready(R_array_index_01_slr1_53_deq_ready),
    .deq_bits(R_array_index_01_slr1_53_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_53 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_53_clock),
    .reset(q_R_array_index_slr0_53_reset),
    .io_enq_ready(q_R_array_index_slr0_53_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_53_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_53_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_53_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_53_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_53_io_deq_bits),
    .io_count(q_R_array_index_slr0_53_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_54 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_54_clock),
    .reset(R_array_index_01_slr0_54_reset),
    .enq_valid(R_array_index_01_slr0_54_enq_valid),
    .enq_ready(R_array_index_01_slr0_54_enq_ready),
    .enq_bits(R_array_index_01_slr0_54_enq_bits),
    .deq_valid(R_array_index_01_slr0_54_deq_valid),
    .deq_ready(R_array_index_01_slr0_54_deq_ready),
    .deq_bits(R_array_index_01_slr0_54_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_54 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_54_clock),
    .reset(R_array_index_01_slr1_54_reset),
    .enq_valid(R_array_index_01_slr1_54_enq_valid),
    .enq_ready(R_array_index_01_slr1_54_enq_ready),
    .enq_bits(R_array_index_01_slr1_54_enq_bits),
    .deq_valid(R_array_index_01_slr1_54_deq_valid),
    .deq_ready(R_array_index_01_slr1_54_deq_ready),
    .deq_bits(R_array_index_01_slr1_54_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_54 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_54_clock),
    .reset(q_R_array_index_slr0_54_reset),
    .io_enq_ready(q_R_array_index_slr0_54_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_54_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_54_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_54_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_54_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_54_io_deq_bits),
    .io_count(q_R_array_index_slr0_54_io_count)
  );
  R_array_index_01_slr0 R_array_index_01_slr0_55 ( // @[Top-slr.scala 271:42]
    .clock(R_array_index_01_slr0_55_clock),
    .reset(R_array_index_01_slr0_55_reset),
    .enq_valid(R_array_index_01_slr0_55_enq_valid),
    .enq_ready(R_array_index_01_slr0_55_enq_ready),
    .enq_bits(R_array_index_01_slr0_55_enq_bits),
    .deq_valid(R_array_index_01_slr0_55_deq_valid),
    .deq_ready(R_array_index_01_slr0_55_deq_ready),
    .deq_bits(R_array_index_01_slr0_55_deq_bits)
  );
  R_array_index_01_slr1 R_array_index_01_slr1_55 ( // @[Top-slr.scala 272:42]
    .clock(R_array_index_01_slr1_55_clock),
    .reset(R_array_index_01_slr1_55_reset),
    .enq_valid(R_array_index_01_slr1_55_enq_valid),
    .enq_ready(R_array_index_01_slr1_55_enq_ready),
    .enq_bits(R_array_index_01_slr1_55_enq_bits),
    .deq_valid(R_array_index_01_slr1_55_deq_valid),
    .deq_ready(R_array_index_01_slr1_55_deq_ready),
    .deq_bits(R_array_index_01_slr1_55_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_55 ( // @[Top-slr.scala 273:44]
    .clock(q_R_array_index_slr0_55_clock),
    .reset(q_R_array_index_slr0_55_reset),
    .io_enq_ready(q_R_array_index_slr0_55_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_55_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_55_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_55_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_55_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_55_io_deq_bits),
    .io_count(q_R_array_index_slr0_55_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_clock),
    .reset(R_array_index_02_slr0_reset),
    .enq_valid(R_array_index_02_slr0_enq_valid),
    .enq_ready(R_array_index_02_slr0_enq_ready),
    .enq_bits(R_array_index_02_slr0_enq_bits),
    .deq_valid(R_array_index_02_slr0_deq_valid),
    .deq_ready(R_array_index_02_slr0_deq_ready),
    .deq_bits(R_array_index_02_slr0_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_clock),
    .reset(R_array_index_02_slr1_reset),
    .enq_valid(R_array_index_02_slr1_enq_valid),
    .enq_ready(R_array_index_02_slr1_enq_ready),
    .enq_bits(R_array_index_02_slr1_enq_bits),
    .deq_valid(R_array_index_02_slr1_deq_valid),
    .deq_ready(R_array_index_02_slr1_deq_ready),
    .deq_bits(R_array_index_02_slr1_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_clock),
    .reset(R_array_index_02_slr2_reset),
    .enq_valid(R_array_index_02_slr2_enq_valid),
    .enq_ready(R_array_index_02_slr2_enq_ready),
    .enq_bits(R_array_index_02_slr2_enq_bits),
    .deq_valid(R_array_index_02_slr2_deq_valid),
    .deq_ready(R_array_index_02_slr2_deq_ready),
    .deq_bits(R_array_index_02_slr2_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_56 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_56_clock),
    .reset(q_R_array_index_slr0_56_reset),
    .io_enq_ready(q_R_array_index_slr0_56_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_56_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_56_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_56_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_56_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_56_io_deq_bits),
    .io_count(q_R_array_index_slr0_56_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_1 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_1_clock),
    .reset(R_array_index_02_slr0_1_reset),
    .enq_valid(R_array_index_02_slr0_1_enq_valid),
    .enq_ready(R_array_index_02_slr0_1_enq_ready),
    .enq_bits(R_array_index_02_slr0_1_enq_bits),
    .deq_valid(R_array_index_02_slr0_1_deq_valid),
    .deq_ready(R_array_index_02_slr0_1_deq_ready),
    .deq_bits(R_array_index_02_slr0_1_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_1 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_1_clock),
    .reset(R_array_index_02_slr1_1_reset),
    .enq_valid(R_array_index_02_slr1_1_enq_valid),
    .enq_ready(R_array_index_02_slr1_1_enq_ready),
    .enq_bits(R_array_index_02_slr1_1_enq_bits),
    .deq_valid(R_array_index_02_slr1_1_deq_valid),
    .deq_ready(R_array_index_02_slr1_1_deq_ready),
    .deq_bits(R_array_index_02_slr1_1_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_1 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_1_clock),
    .reset(R_array_index_02_slr2_1_reset),
    .enq_valid(R_array_index_02_slr2_1_enq_valid),
    .enq_ready(R_array_index_02_slr2_1_enq_ready),
    .enq_bits(R_array_index_02_slr2_1_enq_bits),
    .deq_valid(R_array_index_02_slr2_1_deq_valid),
    .deq_ready(R_array_index_02_slr2_1_deq_ready),
    .deq_bits(R_array_index_02_slr2_1_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_57 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_57_clock),
    .reset(q_R_array_index_slr0_57_reset),
    .io_enq_ready(q_R_array_index_slr0_57_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_57_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_57_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_57_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_57_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_57_io_deq_bits),
    .io_count(q_R_array_index_slr0_57_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_2 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_2_clock),
    .reset(R_array_index_02_slr0_2_reset),
    .enq_valid(R_array_index_02_slr0_2_enq_valid),
    .enq_ready(R_array_index_02_slr0_2_enq_ready),
    .enq_bits(R_array_index_02_slr0_2_enq_bits),
    .deq_valid(R_array_index_02_slr0_2_deq_valid),
    .deq_ready(R_array_index_02_slr0_2_deq_ready),
    .deq_bits(R_array_index_02_slr0_2_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_2 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_2_clock),
    .reset(R_array_index_02_slr1_2_reset),
    .enq_valid(R_array_index_02_slr1_2_enq_valid),
    .enq_ready(R_array_index_02_slr1_2_enq_ready),
    .enq_bits(R_array_index_02_slr1_2_enq_bits),
    .deq_valid(R_array_index_02_slr1_2_deq_valid),
    .deq_ready(R_array_index_02_slr1_2_deq_ready),
    .deq_bits(R_array_index_02_slr1_2_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_2 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_2_clock),
    .reset(R_array_index_02_slr2_2_reset),
    .enq_valid(R_array_index_02_slr2_2_enq_valid),
    .enq_ready(R_array_index_02_slr2_2_enq_ready),
    .enq_bits(R_array_index_02_slr2_2_enq_bits),
    .deq_valid(R_array_index_02_slr2_2_deq_valid),
    .deq_ready(R_array_index_02_slr2_2_deq_ready),
    .deq_bits(R_array_index_02_slr2_2_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_58 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_58_clock),
    .reset(q_R_array_index_slr0_58_reset),
    .io_enq_ready(q_R_array_index_slr0_58_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_58_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_58_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_58_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_58_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_58_io_deq_bits),
    .io_count(q_R_array_index_slr0_58_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_3 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_3_clock),
    .reset(R_array_index_02_slr0_3_reset),
    .enq_valid(R_array_index_02_slr0_3_enq_valid),
    .enq_ready(R_array_index_02_slr0_3_enq_ready),
    .enq_bits(R_array_index_02_slr0_3_enq_bits),
    .deq_valid(R_array_index_02_slr0_3_deq_valid),
    .deq_ready(R_array_index_02_slr0_3_deq_ready),
    .deq_bits(R_array_index_02_slr0_3_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_3 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_3_clock),
    .reset(R_array_index_02_slr1_3_reset),
    .enq_valid(R_array_index_02_slr1_3_enq_valid),
    .enq_ready(R_array_index_02_slr1_3_enq_ready),
    .enq_bits(R_array_index_02_slr1_3_enq_bits),
    .deq_valid(R_array_index_02_slr1_3_deq_valid),
    .deq_ready(R_array_index_02_slr1_3_deq_ready),
    .deq_bits(R_array_index_02_slr1_3_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_3 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_3_clock),
    .reset(R_array_index_02_slr2_3_reset),
    .enq_valid(R_array_index_02_slr2_3_enq_valid),
    .enq_ready(R_array_index_02_slr2_3_enq_ready),
    .enq_bits(R_array_index_02_slr2_3_enq_bits),
    .deq_valid(R_array_index_02_slr2_3_deq_valid),
    .deq_ready(R_array_index_02_slr2_3_deq_ready),
    .deq_bits(R_array_index_02_slr2_3_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_59 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_59_clock),
    .reset(q_R_array_index_slr0_59_reset),
    .io_enq_ready(q_R_array_index_slr0_59_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_59_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_59_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_59_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_59_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_59_io_deq_bits),
    .io_count(q_R_array_index_slr0_59_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_4 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_4_clock),
    .reset(R_array_index_02_slr0_4_reset),
    .enq_valid(R_array_index_02_slr0_4_enq_valid),
    .enq_ready(R_array_index_02_slr0_4_enq_ready),
    .enq_bits(R_array_index_02_slr0_4_enq_bits),
    .deq_valid(R_array_index_02_slr0_4_deq_valid),
    .deq_ready(R_array_index_02_slr0_4_deq_ready),
    .deq_bits(R_array_index_02_slr0_4_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_4 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_4_clock),
    .reset(R_array_index_02_slr1_4_reset),
    .enq_valid(R_array_index_02_slr1_4_enq_valid),
    .enq_ready(R_array_index_02_slr1_4_enq_ready),
    .enq_bits(R_array_index_02_slr1_4_enq_bits),
    .deq_valid(R_array_index_02_slr1_4_deq_valid),
    .deq_ready(R_array_index_02_slr1_4_deq_ready),
    .deq_bits(R_array_index_02_slr1_4_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_4 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_4_clock),
    .reset(R_array_index_02_slr2_4_reset),
    .enq_valid(R_array_index_02_slr2_4_enq_valid),
    .enq_ready(R_array_index_02_slr2_4_enq_ready),
    .enq_bits(R_array_index_02_slr2_4_enq_bits),
    .deq_valid(R_array_index_02_slr2_4_deq_valid),
    .deq_ready(R_array_index_02_slr2_4_deq_ready),
    .deq_bits(R_array_index_02_slr2_4_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_60 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_60_clock),
    .reset(q_R_array_index_slr0_60_reset),
    .io_enq_ready(q_R_array_index_slr0_60_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_60_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_60_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_60_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_60_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_60_io_deq_bits),
    .io_count(q_R_array_index_slr0_60_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_5 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_5_clock),
    .reset(R_array_index_02_slr0_5_reset),
    .enq_valid(R_array_index_02_slr0_5_enq_valid),
    .enq_ready(R_array_index_02_slr0_5_enq_ready),
    .enq_bits(R_array_index_02_slr0_5_enq_bits),
    .deq_valid(R_array_index_02_slr0_5_deq_valid),
    .deq_ready(R_array_index_02_slr0_5_deq_ready),
    .deq_bits(R_array_index_02_slr0_5_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_5 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_5_clock),
    .reset(R_array_index_02_slr1_5_reset),
    .enq_valid(R_array_index_02_slr1_5_enq_valid),
    .enq_ready(R_array_index_02_slr1_5_enq_ready),
    .enq_bits(R_array_index_02_slr1_5_enq_bits),
    .deq_valid(R_array_index_02_slr1_5_deq_valid),
    .deq_ready(R_array_index_02_slr1_5_deq_ready),
    .deq_bits(R_array_index_02_slr1_5_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_5 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_5_clock),
    .reset(R_array_index_02_slr2_5_reset),
    .enq_valid(R_array_index_02_slr2_5_enq_valid),
    .enq_ready(R_array_index_02_slr2_5_enq_ready),
    .enq_bits(R_array_index_02_slr2_5_enq_bits),
    .deq_valid(R_array_index_02_slr2_5_deq_valid),
    .deq_ready(R_array_index_02_slr2_5_deq_ready),
    .deq_bits(R_array_index_02_slr2_5_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_61 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_61_clock),
    .reset(q_R_array_index_slr0_61_reset),
    .io_enq_ready(q_R_array_index_slr0_61_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_61_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_61_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_61_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_61_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_61_io_deq_bits),
    .io_count(q_R_array_index_slr0_61_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_6 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_6_clock),
    .reset(R_array_index_02_slr0_6_reset),
    .enq_valid(R_array_index_02_slr0_6_enq_valid),
    .enq_ready(R_array_index_02_slr0_6_enq_ready),
    .enq_bits(R_array_index_02_slr0_6_enq_bits),
    .deq_valid(R_array_index_02_slr0_6_deq_valid),
    .deq_ready(R_array_index_02_slr0_6_deq_ready),
    .deq_bits(R_array_index_02_slr0_6_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_6 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_6_clock),
    .reset(R_array_index_02_slr1_6_reset),
    .enq_valid(R_array_index_02_slr1_6_enq_valid),
    .enq_ready(R_array_index_02_slr1_6_enq_ready),
    .enq_bits(R_array_index_02_slr1_6_enq_bits),
    .deq_valid(R_array_index_02_slr1_6_deq_valid),
    .deq_ready(R_array_index_02_slr1_6_deq_ready),
    .deq_bits(R_array_index_02_slr1_6_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_6 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_6_clock),
    .reset(R_array_index_02_slr2_6_reset),
    .enq_valid(R_array_index_02_slr2_6_enq_valid),
    .enq_ready(R_array_index_02_slr2_6_enq_ready),
    .enq_bits(R_array_index_02_slr2_6_enq_bits),
    .deq_valid(R_array_index_02_slr2_6_deq_valid),
    .deq_ready(R_array_index_02_slr2_6_deq_ready),
    .deq_bits(R_array_index_02_slr2_6_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_62 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_62_clock),
    .reset(q_R_array_index_slr0_62_reset),
    .io_enq_ready(q_R_array_index_slr0_62_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_62_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_62_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_62_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_62_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_62_io_deq_bits),
    .io_count(q_R_array_index_slr0_62_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_7 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_7_clock),
    .reset(R_array_index_02_slr0_7_reset),
    .enq_valid(R_array_index_02_slr0_7_enq_valid),
    .enq_ready(R_array_index_02_slr0_7_enq_ready),
    .enq_bits(R_array_index_02_slr0_7_enq_bits),
    .deq_valid(R_array_index_02_slr0_7_deq_valid),
    .deq_ready(R_array_index_02_slr0_7_deq_ready),
    .deq_bits(R_array_index_02_slr0_7_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_7 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_7_clock),
    .reset(R_array_index_02_slr1_7_reset),
    .enq_valid(R_array_index_02_slr1_7_enq_valid),
    .enq_ready(R_array_index_02_slr1_7_enq_ready),
    .enq_bits(R_array_index_02_slr1_7_enq_bits),
    .deq_valid(R_array_index_02_slr1_7_deq_valid),
    .deq_ready(R_array_index_02_slr1_7_deq_ready),
    .deq_bits(R_array_index_02_slr1_7_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_7 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_7_clock),
    .reset(R_array_index_02_slr2_7_reset),
    .enq_valid(R_array_index_02_slr2_7_enq_valid),
    .enq_ready(R_array_index_02_slr2_7_enq_ready),
    .enq_bits(R_array_index_02_slr2_7_enq_bits),
    .deq_valid(R_array_index_02_slr2_7_deq_valid),
    .deq_ready(R_array_index_02_slr2_7_deq_ready),
    .deq_bits(R_array_index_02_slr2_7_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_63 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_63_clock),
    .reset(q_R_array_index_slr0_63_reset),
    .io_enq_ready(q_R_array_index_slr0_63_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_63_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_63_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_63_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_63_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_63_io_deq_bits),
    .io_count(q_R_array_index_slr0_63_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_8 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_8_clock),
    .reset(R_array_index_02_slr0_8_reset),
    .enq_valid(R_array_index_02_slr0_8_enq_valid),
    .enq_ready(R_array_index_02_slr0_8_enq_ready),
    .enq_bits(R_array_index_02_slr0_8_enq_bits),
    .deq_valid(R_array_index_02_slr0_8_deq_valid),
    .deq_ready(R_array_index_02_slr0_8_deq_ready),
    .deq_bits(R_array_index_02_slr0_8_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_8 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_8_clock),
    .reset(R_array_index_02_slr1_8_reset),
    .enq_valid(R_array_index_02_slr1_8_enq_valid),
    .enq_ready(R_array_index_02_slr1_8_enq_ready),
    .enq_bits(R_array_index_02_slr1_8_enq_bits),
    .deq_valid(R_array_index_02_slr1_8_deq_valid),
    .deq_ready(R_array_index_02_slr1_8_deq_ready),
    .deq_bits(R_array_index_02_slr1_8_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_8 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_8_clock),
    .reset(R_array_index_02_slr2_8_reset),
    .enq_valid(R_array_index_02_slr2_8_enq_valid),
    .enq_ready(R_array_index_02_slr2_8_enq_ready),
    .enq_bits(R_array_index_02_slr2_8_enq_bits),
    .deq_valid(R_array_index_02_slr2_8_deq_valid),
    .deq_ready(R_array_index_02_slr2_8_deq_ready),
    .deq_bits(R_array_index_02_slr2_8_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_64 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_64_clock),
    .reset(q_R_array_index_slr0_64_reset),
    .io_enq_ready(q_R_array_index_slr0_64_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_64_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_64_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_64_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_64_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_64_io_deq_bits),
    .io_count(q_R_array_index_slr0_64_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_9 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_9_clock),
    .reset(R_array_index_02_slr0_9_reset),
    .enq_valid(R_array_index_02_slr0_9_enq_valid),
    .enq_ready(R_array_index_02_slr0_9_enq_ready),
    .enq_bits(R_array_index_02_slr0_9_enq_bits),
    .deq_valid(R_array_index_02_slr0_9_deq_valid),
    .deq_ready(R_array_index_02_slr0_9_deq_ready),
    .deq_bits(R_array_index_02_slr0_9_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_9 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_9_clock),
    .reset(R_array_index_02_slr1_9_reset),
    .enq_valid(R_array_index_02_slr1_9_enq_valid),
    .enq_ready(R_array_index_02_slr1_9_enq_ready),
    .enq_bits(R_array_index_02_slr1_9_enq_bits),
    .deq_valid(R_array_index_02_slr1_9_deq_valid),
    .deq_ready(R_array_index_02_slr1_9_deq_ready),
    .deq_bits(R_array_index_02_slr1_9_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_9 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_9_clock),
    .reset(R_array_index_02_slr2_9_reset),
    .enq_valid(R_array_index_02_slr2_9_enq_valid),
    .enq_ready(R_array_index_02_slr2_9_enq_ready),
    .enq_bits(R_array_index_02_slr2_9_enq_bits),
    .deq_valid(R_array_index_02_slr2_9_deq_valid),
    .deq_ready(R_array_index_02_slr2_9_deq_ready),
    .deq_bits(R_array_index_02_slr2_9_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_65 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_65_clock),
    .reset(q_R_array_index_slr0_65_reset),
    .io_enq_ready(q_R_array_index_slr0_65_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_65_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_65_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_65_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_65_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_65_io_deq_bits),
    .io_count(q_R_array_index_slr0_65_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_10 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_10_clock),
    .reset(R_array_index_02_slr0_10_reset),
    .enq_valid(R_array_index_02_slr0_10_enq_valid),
    .enq_ready(R_array_index_02_slr0_10_enq_ready),
    .enq_bits(R_array_index_02_slr0_10_enq_bits),
    .deq_valid(R_array_index_02_slr0_10_deq_valid),
    .deq_ready(R_array_index_02_slr0_10_deq_ready),
    .deq_bits(R_array_index_02_slr0_10_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_10 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_10_clock),
    .reset(R_array_index_02_slr1_10_reset),
    .enq_valid(R_array_index_02_slr1_10_enq_valid),
    .enq_ready(R_array_index_02_slr1_10_enq_ready),
    .enq_bits(R_array_index_02_slr1_10_enq_bits),
    .deq_valid(R_array_index_02_slr1_10_deq_valid),
    .deq_ready(R_array_index_02_slr1_10_deq_ready),
    .deq_bits(R_array_index_02_slr1_10_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_10 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_10_clock),
    .reset(R_array_index_02_slr2_10_reset),
    .enq_valid(R_array_index_02_slr2_10_enq_valid),
    .enq_ready(R_array_index_02_slr2_10_enq_ready),
    .enq_bits(R_array_index_02_slr2_10_enq_bits),
    .deq_valid(R_array_index_02_slr2_10_deq_valid),
    .deq_ready(R_array_index_02_slr2_10_deq_ready),
    .deq_bits(R_array_index_02_slr2_10_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_66 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_66_clock),
    .reset(q_R_array_index_slr0_66_reset),
    .io_enq_ready(q_R_array_index_slr0_66_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_66_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_66_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_66_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_66_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_66_io_deq_bits),
    .io_count(q_R_array_index_slr0_66_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_11 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_11_clock),
    .reset(R_array_index_02_slr0_11_reset),
    .enq_valid(R_array_index_02_slr0_11_enq_valid),
    .enq_ready(R_array_index_02_slr0_11_enq_ready),
    .enq_bits(R_array_index_02_slr0_11_enq_bits),
    .deq_valid(R_array_index_02_slr0_11_deq_valid),
    .deq_ready(R_array_index_02_slr0_11_deq_ready),
    .deq_bits(R_array_index_02_slr0_11_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_11 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_11_clock),
    .reset(R_array_index_02_slr1_11_reset),
    .enq_valid(R_array_index_02_slr1_11_enq_valid),
    .enq_ready(R_array_index_02_slr1_11_enq_ready),
    .enq_bits(R_array_index_02_slr1_11_enq_bits),
    .deq_valid(R_array_index_02_slr1_11_deq_valid),
    .deq_ready(R_array_index_02_slr1_11_deq_ready),
    .deq_bits(R_array_index_02_slr1_11_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_11 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_11_clock),
    .reset(R_array_index_02_slr2_11_reset),
    .enq_valid(R_array_index_02_slr2_11_enq_valid),
    .enq_ready(R_array_index_02_slr2_11_enq_ready),
    .enq_bits(R_array_index_02_slr2_11_enq_bits),
    .deq_valid(R_array_index_02_slr2_11_deq_valid),
    .deq_ready(R_array_index_02_slr2_11_deq_ready),
    .deq_bits(R_array_index_02_slr2_11_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_67 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_67_clock),
    .reset(q_R_array_index_slr0_67_reset),
    .io_enq_ready(q_R_array_index_slr0_67_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_67_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_67_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_67_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_67_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_67_io_deq_bits),
    .io_count(q_R_array_index_slr0_67_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_12 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_12_clock),
    .reset(R_array_index_02_slr0_12_reset),
    .enq_valid(R_array_index_02_slr0_12_enq_valid),
    .enq_ready(R_array_index_02_slr0_12_enq_ready),
    .enq_bits(R_array_index_02_slr0_12_enq_bits),
    .deq_valid(R_array_index_02_slr0_12_deq_valid),
    .deq_ready(R_array_index_02_slr0_12_deq_ready),
    .deq_bits(R_array_index_02_slr0_12_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_12 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_12_clock),
    .reset(R_array_index_02_slr1_12_reset),
    .enq_valid(R_array_index_02_slr1_12_enq_valid),
    .enq_ready(R_array_index_02_slr1_12_enq_ready),
    .enq_bits(R_array_index_02_slr1_12_enq_bits),
    .deq_valid(R_array_index_02_slr1_12_deq_valid),
    .deq_ready(R_array_index_02_slr1_12_deq_ready),
    .deq_bits(R_array_index_02_slr1_12_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_12 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_12_clock),
    .reset(R_array_index_02_slr2_12_reset),
    .enq_valid(R_array_index_02_slr2_12_enq_valid),
    .enq_ready(R_array_index_02_slr2_12_enq_ready),
    .enq_bits(R_array_index_02_slr2_12_enq_bits),
    .deq_valid(R_array_index_02_slr2_12_deq_valid),
    .deq_ready(R_array_index_02_slr2_12_deq_ready),
    .deq_bits(R_array_index_02_slr2_12_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_68 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_68_clock),
    .reset(q_R_array_index_slr0_68_reset),
    .io_enq_ready(q_R_array_index_slr0_68_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_68_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_68_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_68_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_68_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_68_io_deq_bits),
    .io_count(q_R_array_index_slr0_68_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_13 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_13_clock),
    .reset(R_array_index_02_slr0_13_reset),
    .enq_valid(R_array_index_02_slr0_13_enq_valid),
    .enq_ready(R_array_index_02_slr0_13_enq_ready),
    .enq_bits(R_array_index_02_slr0_13_enq_bits),
    .deq_valid(R_array_index_02_slr0_13_deq_valid),
    .deq_ready(R_array_index_02_slr0_13_deq_ready),
    .deq_bits(R_array_index_02_slr0_13_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_13 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_13_clock),
    .reset(R_array_index_02_slr1_13_reset),
    .enq_valid(R_array_index_02_slr1_13_enq_valid),
    .enq_ready(R_array_index_02_slr1_13_enq_ready),
    .enq_bits(R_array_index_02_slr1_13_enq_bits),
    .deq_valid(R_array_index_02_slr1_13_deq_valid),
    .deq_ready(R_array_index_02_slr1_13_deq_ready),
    .deq_bits(R_array_index_02_slr1_13_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_13 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_13_clock),
    .reset(R_array_index_02_slr2_13_reset),
    .enq_valid(R_array_index_02_slr2_13_enq_valid),
    .enq_ready(R_array_index_02_slr2_13_enq_ready),
    .enq_bits(R_array_index_02_slr2_13_enq_bits),
    .deq_valid(R_array_index_02_slr2_13_deq_valid),
    .deq_ready(R_array_index_02_slr2_13_deq_ready),
    .deq_bits(R_array_index_02_slr2_13_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_69 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_69_clock),
    .reset(q_R_array_index_slr0_69_reset),
    .io_enq_ready(q_R_array_index_slr0_69_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_69_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_69_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_69_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_69_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_69_io_deq_bits),
    .io_count(q_R_array_index_slr0_69_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_14 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_14_clock),
    .reset(R_array_index_02_slr0_14_reset),
    .enq_valid(R_array_index_02_slr0_14_enq_valid),
    .enq_ready(R_array_index_02_slr0_14_enq_ready),
    .enq_bits(R_array_index_02_slr0_14_enq_bits),
    .deq_valid(R_array_index_02_slr0_14_deq_valid),
    .deq_ready(R_array_index_02_slr0_14_deq_ready),
    .deq_bits(R_array_index_02_slr0_14_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_14 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_14_clock),
    .reset(R_array_index_02_slr1_14_reset),
    .enq_valid(R_array_index_02_slr1_14_enq_valid),
    .enq_ready(R_array_index_02_slr1_14_enq_ready),
    .enq_bits(R_array_index_02_slr1_14_enq_bits),
    .deq_valid(R_array_index_02_slr1_14_deq_valid),
    .deq_ready(R_array_index_02_slr1_14_deq_ready),
    .deq_bits(R_array_index_02_slr1_14_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_14 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_14_clock),
    .reset(R_array_index_02_slr2_14_reset),
    .enq_valid(R_array_index_02_slr2_14_enq_valid),
    .enq_ready(R_array_index_02_slr2_14_enq_ready),
    .enq_bits(R_array_index_02_slr2_14_enq_bits),
    .deq_valid(R_array_index_02_slr2_14_deq_valid),
    .deq_ready(R_array_index_02_slr2_14_deq_ready),
    .deq_bits(R_array_index_02_slr2_14_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_70 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_70_clock),
    .reset(q_R_array_index_slr0_70_reset),
    .io_enq_ready(q_R_array_index_slr0_70_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_70_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_70_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_70_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_70_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_70_io_deq_bits),
    .io_count(q_R_array_index_slr0_70_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_15 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_15_clock),
    .reset(R_array_index_02_slr0_15_reset),
    .enq_valid(R_array_index_02_slr0_15_enq_valid),
    .enq_ready(R_array_index_02_slr0_15_enq_ready),
    .enq_bits(R_array_index_02_slr0_15_enq_bits),
    .deq_valid(R_array_index_02_slr0_15_deq_valid),
    .deq_ready(R_array_index_02_slr0_15_deq_ready),
    .deq_bits(R_array_index_02_slr0_15_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_15 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_15_clock),
    .reset(R_array_index_02_slr1_15_reset),
    .enq_valid(R_array_index_02_slr1_15_enq_valid),
    .enq_ready(R_array_index_02_slr1_15_enq_ready),
    .enq_bits(R_array_index_02_slr1_15_enq_bits),
    .deq_valid(R_array_index_02_slr1_15_deq_valid),
    .deq_ready(R_array_index_02_slr1_15_deq_ready),
    .deq_bits(R_array_index_02_slr1_15_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_15 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_15_clock),
    .reset(R_array_index_02_slr2_15_reset),
    .enq_valid(R_array_index_02_slr2_15_enq_valid),
    .enq_ready(R_array_index_02_slr2_15_enq_ready),
    .enq_bits(R_array_index_02_slr2_15_enq_bits),
    .deq_valid(R_array_index_02_slr2_15_deq_valid),
    .deq_ready(R_array_index_02_slr2_15_deq_ready),
    .deq_bits(R_array_index_02_slr2_15_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_71 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_71_clock),
    .reset(q_R_array_index_slr0_71_reset),
    .io_enq_ready(q_R_array_index_slr0_71_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_71_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_71_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_71_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_71_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_71_io_deq_bits),
    .io_count(q_R_array_index_slr0_71_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_16 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_16_clock),
    .reset(R_array_index_02_slr0_16_reset),
    .enq_valid(R_array_index_02_slr0_16_enq_valid),
    .enq_ready(R_array_index_02_slr0_16_enq_ready),
    .enq_bits(R_array_index_02_slr0_16_enq_bits),
    .deq_valid(R_array_index_02_slr0_16_deq_valid),
    .deq_ready(R_array_index_02_slr0_16_deq_ready),
    .deq_bits(R_array_index_02_slr0_16_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_16 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_16_clock),
    .reset(R_array_index_02_slr1_16_reset),
    .enq_valid(R_array_index_02_slr1_16_enq_valid),
    .enq_ready(R_array_index_02_slr1_16_enq_ready),
    .enq_bits(R_array_index_02_slr1_16_enq_bits),
    .deq_valid(R_array_index_02_slr1_16_deq_valid),
    .deq_ready(R_array_index_02_slr1_16_deq_ready),
    .deq_bits(R_array_index_02_slr1_16_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_16 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_16_clock),
    .reset(R_array_index_02_slr2_16_reset),
    .enq_valid(R_array_index_02_slr2_16_enq_valid),
    .enq_ready(R_array_index_02_slr2_16_enq_ready),
    .enq_bits(R_array_index_02_slr2_16_enq_bits),
    .deq_valid(R_array_index_02_slr2_16_deq_valid),
    .deq_ready(R_array_index_02_slr2_16_deq_ready),
    .deq_bits(R_array_index_02_slr2_16_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_72 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_72_clock),
    .reset(q_R_array_index_slr0_72_reset),
    .io_enq_ready(q_R_array_index_slr0_72_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_72_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_72_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_72_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_72_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_72_io_deq_bits),
    .io_count(q_R_array_index_slr0_72_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_17 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_17_clock),
    .reset(R_array_index_02_slr0_17_reset),
    .enq_valid(R_array_index_02_slr0_17_enq_valid),
    .enq_ready(R_array_index_02_slr0_17_enq_ready),
    .enq_bits(R_array_index_02_slr0_17_enq_bits),
    .deq_valid(R_array_index_02_slr0_17_deq_valid),
    .deq_ready(R_array_index_02_slr0_17_deq_ready),
    .deq_bits(R_array_index_02_slr0_17_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_17 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_17_clock),
    .reset(R_array_index_02_slr1_17_reset),
    .enq_valid(R_array_index_02_slr1_17_enq_valid),
    .enq_ready(R_array_index_02_slr1_17_enq_ready),
    .enq_bits(R_array_index_02_slr1_17_enq_bits),
    .deq_valid(R_array_index_02_slr1_17_deq_valid),
    .deq_ready(R_array_index_02_slr1_17_deq_ready),
    .deq_bits(R_array_index_02_slr1_17_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_17 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_17_clock),
    .reset(R_array_index_02_slr2_17_reset),
    .enq_valid(R_array_index_02_slr2_17_enq_valid),
    .enq_ready(R_array_index_02_slr2_17_enq_ready),
    .enq_bits(R_array_index_02_slr2_17_enq_bits),
    .deq_valid(R_array_index_02_slr2_17_deq_valid),
    .deq_ready(R_array_index_02_slr2_17_deq_ready),
    .deq_bits(R_array_index_02_slr2_17_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_73 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_73_clock),
    .reset(q_R_array_index_slr0_73_reset),
    .io_enq_ready(q_R_array_index_slr0_73_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_73_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_73_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_73_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_73_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_73_io_deq_bits),
    .io_count(q_R_array_index_slr0_73_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_18 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_18_clock),
    .reset(R_array_index_02_slr0_18_reset),
    .enq_valid(R_array_index_02_slr0_18_enq_valid),
    .enq_ready(R_array_index_02_slr0_18_enq_ready),
    .enq_bits(R_array_index_02_slr0_18_enq_bits),
    .deq_valid(R_array_index_02_slr0_18_deq_valid),
    .deq_ready(R_array_index_02_slr0_18_deq_ready),
    .deq_bits(R_array_index_02_slr0_18_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_18 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_18_clock),
    .reset(R_array_index_02_slr1_18_reset),
    .enq_valid(R_array_index_02_slr1_18_enq_valid),
    .enq_ready(R_array_index_02_slr1_18_enq_ready),
    .enq_bits(R_array_index_02_slr1_18_enq_bits),
    .deq_valid(R_array_index_02_slr1_18_deq_valid),
    .deq_ready(R_array_index_02_slr1_18_deq_ready),
    .deq_bits(R_array_index_02_slr1_18_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_18 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_18_clock),
    .reset(R_array_index_02_slr2_18_reset),
    .enq_valid(R_array_index_02_slr2_18_enq_valid),
    .enq_ready(R_array_index_02_slr2_18_enq_ready),
    .enq_bits(R_array_index_02_slr2_18_enq_bits),
    .deq_valid(R_array_index_02_slr2_18_deq_valid),
    .deq_ready(R_array_index_02_slr2_18_deq_ready),
    .deq_bits(R_array_index_02_slr2_18_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_74 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_74_clock),
    .reset(q_R_array_index_slr0_74_reset),
    .io_enq_ready(q_R_array_index_slr0_74_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_74_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_74_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_74_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_74_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_74_io_deq_bits),
    .io_count(q_R_array_index_slr0_74_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_19 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_19_clock),
    .reset(R_array_index_02_slr0_19_reset),
    .enq_valid(R_array_index_02_slr0_19_enq_valid),
    .enq_ready(R_array_index_02_slr0_19_enq_ready),
    .enq_bits(R_array_index_02_slr0_19_enq_bits),
    .deq_valid(R_array_index_02_slr0_19_deq_valid),
    .deq_ready(R_array_index_02_slr0_19_deq_ready),
    .deq_bits(R_array_index_02_slr0_19_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_19 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_19_clock),
    .reset(R_array_index_02_slr1_19_reset),
    .enq_valid(R_array_index_02_slr1_19_enq_valid),
    .enq_ready(R_array_index_02_slr1_19_enq_ready),
    .enq_bits(R_array_index_02_slr1_19_enq_bits),
    .deq_valid(R_array_index_02_slr1_19_deq_valid),
    .deq_ready(R_array_index_02_slr1_19_deq_ready),
    .deq_bits(R_array_index_02_slr1_19_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_19 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_19_clock),
    .reset(R_array_index_02_slr2_19_reset),
    .enq_valid(R_array_index_02_slr2_19_enq_valid),
    .enq_ready(R_array_index_02_slr2_19_enq_ready),
    .enq_bits(R_array_index_02_slr2_19_enq_bits),
    .deq_valid(R_array_index_02_slr2_19_deq_valid),
    .deq_ready(R_array_index_02_slr2_19_deq_ready),
    .deq_bits(R_array_index_02_slr2_19_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_75 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_75_clock),
    .reset(q_R_array_index_slr0_75_reset),
    .io_enq_ready(q_R_array_index_slr0_75_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_75_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_75_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_75_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_75_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_75_io_deq_bits),
    .io_count(q_R_array_index_slr0_75_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_20 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_20_clock),
    .reset(R_array_index_02_slr0_20_reset),
    .enq_valid(R_array_index_02_slr0_20_enq_valid),
    .enq_ready(R_array_index_02_slr0_20_enq_ready),
    .enq_bits(R_array_index_02_slr0_20_enq_bits),
    .deq_valid(R_array_index_02_slr0_20_deq_valid),
    .deq_ready(R_array_index_02_slr0_20_deq_ready),
    .deq_bits(R_array_index_02_slr0_20_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_20 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_20_clock),
    .reset(R_array_index_02_slr1_20_reset),
    .enq_valid(R_array_index_02_slr1_20_enq_valid),
    .enq_ready(R_array_index_02_slr1_20_enq_ready),
    .enq_bits(R_array_index_02_slr1_20_enq_bits),
    .deq_valid(R_array_index_02_slr1_20_deq_valid),
    .deq_ready(R_array_index_02_slr1_20_deq_ready),
    .deq_bits(R_array_index_02_slr1_20_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_20 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_20_clock),
    .reset(R_array_index_02_slr2_20_reset),
    .enq_valid(R_array_index_02_slr2_20_enq_valid),
    .enq_ready(R_array_index_02_slr2_20_enq_ready),
    .enq_bits(R_array_index_02_slr2_20_enq_bits),
    .deq_valid(R_array_index_02_slr2_20_deq_valid),
    .deq_ready(R_array_index_02_slr2_20_deq_ready),
    .deq_bits(R_array_index_02_slr2_20_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_76 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_76_clock),
    .reset(q_R_array_index_slr0_76_reset),
    .io_enq_ready(q_R_array_index_slr0_76_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_76_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_76_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_76_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_76_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_76_io_deq_bits),
    .io_count(q_R_array_index_slr0_76_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_21 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_21_clock),
    .reset(R_array_index_02_slr0_21_reset),
    .enq_valid(R_array_index_02_slr0_21_enq_valid),
    .enq_ready(R_array_index_02_slr0_21_enq_ready),
    .enq_bits(R_array_index_02_slr0_21_enq_bits),
    .deq_valid(R_array_index_02_slr0_21_deq_valid),
    .deq_ready(R_array_index_02_slr0_21_deq_ready),
    .deq_bits(R_array_index_02_slr0_21_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_21 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_21_clock),
    .reset(R_array_index_02_slr1_21_reset),
    .enq_valid(R_array_index_02_slr1_21_enq_valid),
    .enq_ready(R_array_index_02_slr1_21_enq_ready),
    .enq_bits(R_array_index_02_slr1_21_enq_bits),
    .deq_valid(R_array_index_02_slr1_21_deq_valid),
    .deq_ready(R_array_index_02_slr1_21_deq_ready),
    .deq_bits(R_array_index_02_slr1_21_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_21 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_21_clock),
    .reset(R_array_index_02_slr2_21_reset),
    .enq_valid(R_array_index_02_slr2_21_enq_valid),
    .enq_ready(R_array_index_02_slr2_21_enq_ready),
    .enq_bits(R_array_index_02_slr2_21_enq_bits),
    .deq_valid(R_array_index_02_slr2_21_deq_valid),
    .deq_ready(R_array_index_02_slr2_21_deq_ready),
    .deq_bits(R_array_index_02_slr2_21_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_77 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_77_clock),
    .reset(q_R_array_index_slr0_77_reset),
    .io_enq_ready(q_R_array_index_slr0_77_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_77_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_77_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_77_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_77_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_77_io_deq_bits),
    .io_count(q_R_array_index_slr0_77_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_22 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_22_clock),
    .reset(R_array_index_02_slr0_22_reset),
    .enq_valid(R_array_index_02_slr0_22_enq_valid),
    .enq_ready(R_array_index_02_slr0_22_enq_ready),
    .enq_bits(R_array_index_02_slr0_22_enq_bits),
    .deq_valid(R_array_index_02_slr0_22_deq_valid),
    .deq_ready(R_array_index_02_slr0_22_deq_ready),
    .deq_bits(R_array_index_02_slr0_22_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_22 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_22_clock),
    .reset(R_array_index_02_slr1_22_reset),
    .enq_valid(R_array_index_02_slr1_22_enq_valid),
    .enq_ready(R_array_index_02_slr1_22_enq_ready),
    .enq_bits(R_array_index_02_slr1_22_enq_bits),
    .deq_valid(R_array_index_02_slr1_22_deq_valid),
    .deq_ready(R_array_index_02_slr1_22_deq_ready),
    .deq_bits(R_array_index_02_slr1_22_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_22 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_22_clock),
    .reset(R_array_index_02_slr2_22_reset),
    .enq_valid(R_array_index_02_slr2_22_enq_valid),
    .enq_ready(R_array_index_02_slr2_22_enq_ready),
    .enq_bits(R_array_index_02_slr2_22_enq_bits),
    .deq_valid(R_array_index_02_slr2_22_deq_valid),
    .deq_ready(R_array_index_02_slr2_22_deq_ready),
    .deq_bits(R_array_index_02_slr2_22_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_78 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_78_clock),
    .reset(q_R_array_index_slr0_78_reset),
    .io_enq_ready(q_R_array_index_slr0_78_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_78_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_78_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_78_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_78_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_78_io_deq_bits),
    .io_count(q_R_array_index_slr0_78_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_23 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_23_clock),
    .reset(R_array_index_02_slr0_23_reset),
    .enq_valid(R_array_index_02_slr0_23_enq_valid),
    .enq_ready(R_array_index_02_slr0_23_enq_ready),
    .enq_bits(R_array_index_02_slr0_23_enq_bits),
    .deq_valid(R_array_index_02_slr0_23_deq_valid),
    .deq_ready(R_array_index_02_slr0_23_deq_ready),
    .deq_bits(R_array_index_02_slr0_23_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_23 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_23_clock),
    .reset(R_array_index_02_slr1_23_reset),
    .enq_valid(R_array_index_02_slr1_23_enq_valid),
    .enq_ready(R_array_index_02_slr1_23_enq_ready),
    .enq_bits(R_array_index_02_slr1_23_enq_bits),
    .deq_valid(R_array_index_02_slr1_23_deq_valid),
    .deq_ready(R_array_index_02_slr1_23_deq_ready),
    .deq_bits(R_array_index_02_slr1_23_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_23 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_23_clock),
    .reset(R_array_index_02_slr2_23_reset),
    .enq_valid(R_array_index_02_slr2_23_enq_valid),
    .enq_ready(R_array_index_02_slr2_23_enq_ready),
    .enq_bits(R_array_index_02_slr2_23_enq_bits),
    .deq_valid(R_array_index_02_slr2_23_deq_valid),
    .deq_ready(R_array_index_02_slr2_23_deq_ready),
    .deq_bits(R_array_index_02_slr2_23_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_79 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_79_clock),
    .reset(q_R_array_index_slr0_79_reset),
    .io_enq_ready(q_R_array_index_slr0_79_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_79_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_79_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_79_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_79_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_79_io_deq_bits),
    .io_count(q_R_array_index_slr0_79_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_24 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_24_clock),
    .reset(R_array_index_02_slr0_24_reset),
    .enq_valid(R_array_index_02_slr0_24_enq_valid),
    .enq_ready(R_array_index_02_slr0_24_enq_ready),
    .enq_bits(R_array_index_02_slr0_24_enq_bits),
    .deq_valid(R_array_index_02_slr0_24_deq_valid),
    .deq_ready(R_array_index_02_slr0_24_deq_ready),
    .deq_bits(R_array_index_02_slr0_24_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_24 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_24_clock),
    .reset(R_array_index_02_slr1_24_reset),
    .enq_valid(R_array_index_02_slr1_24_enq_valid),
    .enq_ready(R_array_index_02_slr1_24_enq_ready),
    .enq_bits(R_array_index_02_slr1_24_enq_bits),
    .deq_valid(R_array_index_02_slr1_24_deq_valid),
    .deq_ready(R_array_index_02_slr1_24_deq_ready),
    .deq_bits(R_array_index_02_slr1_24_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_24 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_24_clock),
    .reset(R_array_index_02_slr2_24_reset),
    .enq_valid(R_array_index_02_slr2_24_enq_valid),
    .enq_ready(R_array_index_02_slr2_24_enq_ready),
    .enq_bits(R_array_index_02_slr2_24_enq_bits),
    .deq_valid(R_array_index_02_slr2_24_deq_valid),
    .deq_ready(R_array_index_02_slr2_24_deq_ready),
    .deq_bits(R_array_index_02_slr2_24_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_80 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_80_clock),
    .reset(q_R_array_index_slr0_80_reset),
    .io_enq_ready(q_R_array_index_slr0_80_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_80_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_80_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_80_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_80_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_80_io_deq_bits),
    .io_count(q_R_array_index_slr0_80_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_25 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_25_clock),
    .reset(R_array_index_02_slr0_25_reset),
    .enq_valid(R_array_index_02_slr0_25_enq_valid),
    .enq_ready(R_array_index_02_slr0_25_enq_ready),
    .enq_bits(R_array_index_02_slr0_25_enq_bits),
    .deq_valid(R_array_index_02_slr0_25_deq_valid),
    .deq_ready(R_array_index_02_slr0_25_deq_ready),
    .deq_bits(R_array_index_02_slr0_25_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_25 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_25_clock),
    .reset(R_array_index_02_slr1_25_reset),
    .enq_valid(R_array_index_02_slr1_25_enq_valid),
    .enq_ready(R_array_index_02_slr1_25_enq_ready),
    .enq_bits(R_array_index_02_slr1_25_enq_bits),
    .deq_valid(R_array_index_02_slr1_25_deq_valid),
    .deq_ready(R_array_index_02_slr1_25_deq_ready),
    .deq_bits(R_array_index_02_slr1_25_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_25 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_25_clock),
    .reset(R_array_index_02_slr2_25_reset),
    .enq_valid(R_array_index_02_slr2_25_enq_valid),
    .enq_ready(R_array_index_02_slr2_25_enq_ready),
    .enq_bits(R_array_index_02_slr2_25_enq_bits),
    .deq_valid(R_array_index_02_slr2_25_deq_valid),
    .deq_ready(R_array_index_02_slr2_25_deq_ready),
    .deq_bits(R_array_index_02_slr2_25_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_81 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_81_clock),
    .reset(q_R_array_index_slr0_81_reset),
    .io_enq_ready(q_R_array_index_slr0_81_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_81_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_81_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_81_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_81_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_81_io_deq_bits),
    .io_count(q_R_array_index_slr0_81_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_26 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_26_clock),
    .reset(R_array_index_02_slr0_26_reset),
    .enq_valid(R_array_index_02_slr0_26_enq_valid),
    .enq_ready(R_array_index_02_slr0_26_enq_ready),
    .enq_bits(R_array_index_02_slr0_26_enq_bits),
    .deq_valid(R_array_index_02_slr0_26_deq_valid),
    .deq_ready(R_array_index_02_slr0_26_deq_ready),
    .deq_bits(R_array_index_02_slr0_26_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_26 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_26_clock),
    .reset(R_array_index_02_slr1_26_reset),
    .enq_valid(R_array_index_02_slr1_26_enq_valid),
    .enq_ready(R_array_index_02_slr1_26_enq_ready),
    .enq_bits(R_array_index_02_slr1_26_enq_bits),
    .deq_valid(R_array_index_02_slr1_26_deq_valid),
    .deq_ready(R_array_index_02_slr1_26_deq_ready),
    .deq_bits(R_array_index_02_slr1_26_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_26 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_26_clock),
    .reset(R_array_index_02_slr2_26_reset),
    .enq_valid(R_array_index_02_slr2_26_enq_valid),
    .enq_ready(R_array_index_02_slr2_26_enq_ready),
    .enq_bits(R_array_index_02_slr2_26_enq_bits),
    .deq_valid(R_array_index_02_slr2_26_deq_valid),
    .deq_ready(R_array_index_02_slr2_26_deq_ready),
    .deq_bits(R_array_index_02_slr2_26_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_82 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_82_clock),
    .reset(q_R_array_index_slr0_82_reset),
    .io_enq_ready(q_R_array_index_slr0_82_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_82_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_82_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_82_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_82_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_82_io_deq_bits),
    .io_count(q_R_array_index_slr0_82_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_27 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_27_clock),
    .reset(R_array_index_02_slr0_27_reset),
    .enq_valid(R_array_index_02_slr0_27_enq_valid),
    .enq_ready(R_array_index_02_slr0_27_enq_ready),
    .enq_bits(R_array_index_02_slr0_27_enq_bits),
    .deq_valid(R_array_index_02_slr0_27_deq_valid),
    .deq_ready(R_array_index_02_slr0_27_deq_ready),
    .deq_bits(R_array_index_02_slr0_27_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_27 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_27_clock),
    .reset(R_array_index_02_slr1_27_reset),
    .enq_valid(R_array_index_02_slr1_27_enq_valid),
    .enq_ready(R_array_index_02_slr1_27_enq_ready),
    .enq_bits(R_array_index_02_slr1_27_enq_bits),
    .deq_valid(R_array_index_02_slr1_27_deq_valid),
    .deq_ready(R_array_index_02_slr1_27_deq_ready),
    .deq_bits(R_array_index_02_slr1_27_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_27 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_27_clock),
    .reset(R_array_index_02_slr2_27_reset),
    .enq_valid(R_array_index_02_slr2_27_enq_valid),
    .enq_ready(R_array_index_02_slr2_27_enq_ready),
    .enq_bits(R_array_index_02_slr2_27_enq_bits),
    .deq_valid(R_array_index_02_slr2_27_deq_valid),
    .deq_ready(R_array_index_02_slr2_27_deq_ready),
    .deq_bits(R_array_index_02_slr2_27_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_83 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_83_clock),
    .reset(q_R_array_index_slr0_83_reset),
    .io_enq_ready(q_R_array_index_slr0_83_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_83_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_83_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_83_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_83_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_83_io_deq_bits),
    .io_count(q_R_array_index_slr0_83_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_28 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_28_clock),
    .reset(R_array_index_02_slr0_28_reset),
    .enq_valid(R_array_index_02_slr0_28_enq_valid),
    .enq_ready(R_array_index_02_slr0_28_enq_ready),
    .enq_bits(R_array_index_02_slr0_28_enq_bits),
    .deq_valid(R_array_index_02_slr0_28_deq_valid),
    .deq_ready(R_array_index_02_slr0_28_deq_ready),
    .deq_bits(R_array_index_02_slr0_28_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_28 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_28_clock),
    .reset(R_array_index_02_slr1_28_reset),
    .enq_valid(R_array_index_02_slr1_28_enq_valid),
    .enq_ready(R_array_index_02_slr1_28_enq_ready),
    .enq_bits(R_array_index_02_slr1_28_enq_bits),
    .deq_valid(R_array_index_02_slr1_28_deq_valid),
    .deq_ready(R_array_index_02_slr1_28_deq_ready),
    .deq_bits(R_array_index_02_slr1_28_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_28 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_28_clock),
    .reset(R_array_index_02_slr2_28_reset),
    .enq_valid(R_array_index_02_slr2_28_enq_valid),
    .enq_ready(R_array_index_02_slr2_28_enq_ready),
    .enq_bits(R_array_index_02_slr2_28_enq_bits),
    .deq_valid(R_array_index_02_slr2_28_deq_valid),
    .deq_ready(R_array_index_02_slr2_28_deq_ready),
    .deq_bits(R_array_index_02_slr2_28_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_84 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_84_clock),
    .reset(q_R_array_index_slr0_84_reset),
    .io_enq_ready(q_R_array_index_slr0_84_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_84_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_84_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_84_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_84_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_84_io_deq_bits),
    .io_count(q_R_array_index_slr0_84_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_29 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_29_clock),
    .reset(R_array_index_02_slr0_29_reset),
    .enq_valid(R_array_index_02_slr0_29_enq_valid),
    .enq_ready(R_array_index_02_slr0_29_enq_ready),
    .enq_bits(R_array_index_02_slr0_29_enq_bits),
    .deq_valid(R_array_index_02_slr0_29_deq_valid),
    .deq_ready(R_array_index_02_slr0_29_deq_ready),
    .deq_bits(R_array_index_02_slr0_29_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_29 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_29_clock),
    .reset(R_array_index_02_slr1_29_reset),
    .enq_valid(R_array_index_02_slr1_29_enq_valid),
    .enq_ready(R_array_index_02_slr1_29_enq_ready),
    .enq_bits(R_array_index_02_slr1_29_enq_bits),
    .deq_valid(R_array_index_02_slr1_29_deq_valid),
    .deq_ready(R_array_index_02_slr1_29_deq_ready),
    .deq_bits(R_array_index_02_slr1_29_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_29 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_29_clock),
    .reset(R_array_index_02_slr2_29_reset),
    .enq_valid(R_array_index_02_slr2_29_enq_valid),
    .enq_ready(R_array_index_02_slr2_29_enq_ready),
    .enq_bits(R_array_index_02_slr2_29_enq_bits),
    .deq_valid(R_array_index_02_slr2_29_deq_valid),
    .deq_ready(R_array_index_02_slr2_29_deq_ready),
    .deq_bits(R_array_index_02_slr2_29_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_85 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_85_clock),
    .reset(q_R_array_index_slr0_85_reset),
    .io_enq_ready(q_R_array_index_slr0_85_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_85_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_85_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_85_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_85_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_85_io_deq_bits),
    .io_count(q_R_array_index_slr0_85_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_30 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_30_clock),
    .reset(R_array_index_02_slr0_30_reset),
    .enq_valid(R_array_index_02_slr0_30_enq_valid),
    .enq_ready(R_array_index_02_slr0_30_enq_ready),
    .enq_bits(R_array_index_02_slr0_30_enq_bits),
    .deq_valid(R_array_index_02_slr0_30_deq_valid),
    .deq_ready(R_array_index_02_slr0_30_deq_ready),
    .deq_bits(R_array_index_02_slr0_30_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_30 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_30_clock),
    .reset(R_array_index_02_slr1_30_reset),
    .enq_valid(R_array_index_02_slr1_30_enq_valid),
    .enq_ready(R_array_index_02_slr1_30_enq_ready),
    .enq_bits(R_array_index_02_slr1_30_enq_bits),
    .deq_valid(R_array_index_02_slr1_30_deq_valid),
    .deq_ready(R_array_index_02_slr1_30_deq_ready),
    .deq_bits(R_array_index_02_slr1_30_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_30 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_30_clock),
    .reset(R_array_index_02_slr2_30_reset),
    .enq_valid(R_array_index_02_slr2_30_enq_valid),
    .enq_ready(R_array_index_02_slr2_30_enq_ready),
    .enq_bits(R_array_index_02_slr2_30_enq_bits),
    .deq_valid(R_array_index_02_slr2_30_deq_valid),
    .deq_ready(R_array_index_02_slr2_30_deq_ready),
    .deq_bits(R_array_index_02_slr2_30_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_86 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_86_clock),
    .reset(q_R_array_index_slr0_86_reset),
    .io_enq_ready(q_R_array_index_slr0_86_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_86_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_86_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_86_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_86_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_86_io_deq_bits),
    .io_count(q_R_array_index_slr0_86_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_31 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_31_clock),
    .reset(R_array_index_02_slr0_31_reset),
    .enq_valid(R_array_index_02_slr0_31_enq_valid),
    .enq_ready(R_array_index_02_slr0_31_enq_ready),
    .enq_bits(R_array_index_02_slr0_31_enq_bits),
    .deq_valid(R_array_index_02_slr0_31_deq_valid),
    .deq_ready(R_array_index_02_slr0_31_deq_ready),
    .deq_bits(R_array_index_02_slr0_31_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_31 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_31_clock),
    .reset(R_array_index_02_slr1_31_reset),
    .enq_valid(R_array_index_02_slr1_31_enq_valid),
    .enq_ready(R_array_index_02_slr1_31_enq_ready),
    .enq_bits(R_array_index_02_slr1_31_enq_bits),
    .deq_valid(R_array_index_02_slr1_31_deq_valid),
    .deq_ready(R_array_index_02_slr1_31_deq_ready),
    .deq_bits(R_array_index_02_slr1_31_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_31 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_31_clock),
    .reset(R_array_index_02_slr2_31_reset),
    .enq_valid(R_array_index_02_slr2_31_enq_valid),
    .enq_ready(R_array_index_02_slr2_31_enq_ready),
    .enq_bits(R_array_index_02_slr2_31_enq_bits),
    .deq_valid(R_array_index_02_slr2_31_deq_valid),
    .deq_ready(R_array_index_02_slr2_31_deq_ready),
    .deq_bits(R_array_index_02_slr2_31_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_87 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_87_clock),
    .reset(q_R_array_index_slr0_87_reset),
    .io_enq_ready(q_R_array_index_slr0_87_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_87_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_87_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_87_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_87_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_87_io_deq_bits),
    .io_count(q_R_array_index_slr0_87_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_32 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_32_clock),
    .reset(R_array_index_02_slr0_32_reset),
    .enq_valid(R_array_index_02_slr0_32_enq_valid),
    .enq_ready(R_array_index_02_slr0_32_enq_ready),
    .enq_bits(R_array_index_02_slr0_32_enq_bits),
    .deq_valid(R_array_index_02_slr0_32_deq_valid),
    .deq_ready(R_array_index_02_slr0_32_deq_ready),
    .deq_bits(R_array_index_02_slr0_32_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_32 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_32_clock),
    .reset(R_array_index_02_slr1_32_reset),
    .enq_valid(R_array_index_02_slr1_32_enq_valid),
    .enq_ready(R_array_index_02_slr1_32_enq_ready),
    .enq_bits(R_array_index_02_slr1_32_enq_bits),
    .deq_valid(R_array_index_02_slr1_32_deq_valid),
    .deq_ready(R_array_index_02_slr1_32_deq_ready),
    .deq_bits(R_array_index_02_slr1_32_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_32 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_32_clock),
    .reset(R_array_index_02_slr2_32_reset),
    .enq_valid(R_array_index_02_slr2_32_enq_valid),
    .enq_ready(R_array_index_02_slr2_32_enq_ready),
    .enq_bits(R_array_index_02_slr2_32_enq_bits),
    .deq_valid(R_array_index_02_slr2_32_deq_valid),
    .deq_ready(R_array_index_02_slr2_32_deq_ready),
    .deq_bits(R_array_index_02_slr2_32_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_88 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_88_clock),
    .reset(q_R_array_index_slr0_88_reset),
    .io_enq_ready(q_R_array_index_slr0_88_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_88_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_88_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_88_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_88_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_88_io_deq_bits),
    .io_count(q_R_array_index_slr0_88_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_33 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_33_clock),
    .reset(R_array_index_02_slr0_33_reset),
    .enq_valid(R_array_index_02_slr0_33_enq_valid),
    .enq_ready(R_array_index_02_slr0_33_enq_ready),
    .enq_bits(R_array_index_02_slr0_33_enq_bits),
    .deq_valid(R_array_index_02_slr0_33_deq_valid),
    .deq_ready(R_array_index_02_slr0_33_deq_ready),
    .deq_bits(R_array_index_02_slr0_33_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_33 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_33_clock),
    .reset(R_array_index_02_slr1_33_reset),
    .enq_valid(R_array_index_02_slr1_33_enq_valid),
    .enq_ready(R_array_index_02_slr1_33_enq_ready),
    .enq_bits(R_array_index_02_slr1_33_enq_bits),
    .deq_valid(R_array_index_02_slr1_33_deq_valid),
    .deq_ready(R_array_index_02_slr1_33_deq_ready),
    .deq_bits(R_array_index_02_slr1_33_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_33 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_33_clock),
    .reset(R_array_index_02_slr2_33_reset),
    .enq_valid(R_array_index_02_slr2_33_enq_valid),
    .enq_ready(R_array_index_02_slr2_33_enq_ready),
    .enq_bits(R_array_index_02_slr2_33_enq_bits),
    .deq_valid(R_array_index_02_slr2_33_deq_valid),
    .deq_ready(R_array_index_02_slr2_33_deq_ready),
    .deq_bits(R_array_index_02_slr2_33_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_89 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_89_clock),
    .reset(q_R_array_index_slr0_89_reset),
    .io_enq_ready(q_R_array_index_slr0_89_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_89_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_89_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_89_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_89_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_89_io_deq_bits),
    .io_count(q_R_array_index_slr0_89_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_34 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_34_clock),
    .reset(R_array_index_02_slr0_34_reset),
    .enq_valid(R_array_index_02_slr0_34_enq_valid),
    .enq_ready(R_array_index_02_slr0_34_enq_ready),
    .enq_bits(R_array_index_02_slr0_34_enq_bits),
    .deq_valid(R_array_index_02_slr0_34_deq_valid),
    .deq_ready(R_array_index_02_slr0_34_deq_ready),
    .deq_bits(R_array_index_02_slr0_34_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_34 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_34_clock),
    .reset(R_array_index_02_slr1_34_reset),
    .enq_valid(R_array_index_02_slr1_34_enq_valid),
    .enq_ready(R_array_index_02_slr1_34_enq_ready),
    .enq_bits(R_array_index_02_slr1_34_enq_bits),
    .deq_valid(R_array_index_02_slr1_34_deq_valid),
    .deq_ready(R_array_index_02_slr1_34_deq_ready),
    .deq_bits(R_array_index_02_slr1_34_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_34 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_34_clock),
    .reset(R_array_index_02_slr2_34_reset),
    .enq_valid(R_array_index_02_slr2_34_enq_valid),
    .enq_ready(R_array_index_02_slr2_34_enq_ready),
    .enq_bits(R_array_index_02_slr2_34_enq_bits),
    .deq_valid(R_array_index_02_slr2_34_deq_valid),
    .deq_ready(R_array_index_02_slr2_34_deq_ready),
    .deq_bits(R_array_index_02_slr2_34_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_90 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_90_clock),
    .reset(q_R_array_index_slr0_90_reset),
    .io_enq_ready(q_R_array_index_slr0_90_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_90_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_90_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_90_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_90_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_90_io_deq_bits),
    .io_count(q_R_array_index_slr0_90_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_35 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_35_clock),
    .reset(R_array_index_02_slr0_35_reset),
    .enq_valid(R_array_index_02_slr0_35_enq_valid),
    .enq_ready(R_array_index_02_slr0_35_enq_ready),
    .enq_bits(R_array_index_02_slr0_35_enq_bits),
    .deq_valid(R_array_index_02_slr0_35_deq_valid),
    .deq_ready(R_array_index_02_slr0_35_deq_ready),
    .deq_bits(R_array_index_02_slr0_35_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_35 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_35_clock),
    .reset(R_array_index_02_slr1_35_reset),
    .enq_valid(R_array_index_02_slr1_35_enq_valid),
    .enq_ready(R_array_index_02_slr1_35_enq_ready),
    .enq_bits(R_array_index_02_slr1_35_enq_bits),
    .deq_valid(R_array_index_02_slr1_35_deq_valid),
    .deq_ready(R_array_index_02_slr1_35_deq_ready),
    .deq_bits(R_array_index_02_slr1_35_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_35 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_35_clock),
    .reset(R_array_index_02_slr2_35_reset),
    .enq_valid(R_array_index_02_slr2_35_enq_valid),
    .enq_ready(R_array_index_02_slr2_35_enq_ready),
    .enq_bits(R_array_index_02_slr2_35_enq_bits),
    .deq_valid(R_array_index_02_slr2_35_deq_valid),
    .deq_ready(R_array_index_02_slr2_35_deq_ready),
    .deq_bits(R_array_index_02_slr2_35_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_91 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_91_clock),
    .reset(q_R_array_index_slr0_91_reset),
    .io_enq_ready(q_R_array_index_slr0_91_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_91_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_91_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_91_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_91_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_91_io_deq_bits),
    .io_count(q_R_array_index_slr0_91_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_36 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_36_clock),
    .reset(R_array_index_02_slr0_36_reset),
    .enq_valid(R_array_index_02_slr0_36_enq_valid),
    .enq_ready(R_array_index_02_slr0_36_enq_ready),
    .enq_bits(R_array_index_02_slr0_36_enq_bits),
    .deq_valid(R_array_index_02_slr0_36_deq_valid),
    .deq_ready(R_array_index_02_slr0_36_deq_ready),
    .deq_bits(R_array_index_02_slr0_36_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_36 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_36_clock),
    .reset(R_array_index_02_slr1_36_reset),
    .enq_valid(R_array_index_02_slr1_36_enq_valid),
    .enq_ready(R_array_index_02_slr1_36_enq_ready),
    .enq_bits(R_array_index_02_slr1_36_enq_bits),
    .deq_valid(R_array_index_02_slr1_36_deq_valid),
    .deq_ready(R_array_index_02_slr1_36_deq_ready),
    .deq_bits(R_array_index_02_slr1_36_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_36 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_36_clock),
    .reset(R_array_index_02_slr2_36_reset),
    .enq_valid(R_array_index_02_slr2_36_enq_valid),
    .enq_ready(R_array_index_02_slr2_36_enq_ready),
    .enq_bits(R_array_index_02_slr2_36_enq_bits),
    .deq_valid(R_array_index_02_slr2_36_deq_valid),
    .deq_ready(R_array_index_02_slr2_36_deq_ready),
    .deq_bits(R_array_index_02_slr2_36_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_92 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_92_clock),
    .reset(q_R_array_index_slr0_92_reset),
    .io_enq_ready(q_R_array_index_slr0_92_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_92_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_92_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_92_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_92_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_92_io_deq_bits),
    .io_count(q_R_array_index_slr0_92_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_37 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_37_clock),
    .reset(R_array_index_02_slr0_37_reset),
    .enq_valid(R_array_index_02_slr0_37_enq_valid),
    .enq_ready(R_array_index_02_slr0_37_enq_ready),
    .enq_bits(R_array_index_02_slr0_37_enq_bits),
    .deq_valid(R_array_index_02_slr0_37_deq_valid),
    .deq_ready(R_array_index_02_slr0_37_deq_ready),
    .deq_bits(R_array_index_02_slr0_37_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_37 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_37_clock),
    .reset(R_array_index_02_slr1_37_reset),
    .enq_valid(R_array_index_02_slr1_37_enq_valid),
    .enq_ready(R_array_index_02_slr1_37_enq_ready),
    .enq_bits(R_array_index_02_slr1_37_enq_bits),
    .deq_valid(R_array_index_02_slr1_37_deq_valid),
    .deq_ready(R_array_index_02_slr1_37_deq_ready),
    .deq_bits(R_array_index_02_slr1_37_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_37 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_37_clock),
    .reset(R_array_index_02_slr2_37_reset),
    .enq_valid(R_array_index_02_slr2_37_enq_valid),
    .enq_ready(R_array_index_02_slr2_37_enq_ready),
    .enq_bits(R_array_index_02_slr2_37_enq_bits),
    .deq_valid(R_array_index_02_slr2_37_deq_valid),
    .deq_ready(R_array_index_02_slr2_37_deq_ready),
    .deq_bits(R_array_index_02_slr2_37_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_93 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_93_clock),
    .reset(q_R_array_index_slr0_93_reset),
    .io_enq_ready(q_R_array_index_slr0_93_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_93_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_93_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_93_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_93_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_93_io_deq_bits),
    .io_count(q_R_array_index_slr0_93_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_38 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_38_clock),
    .reset(R_array_index_02_slr0_38_reset),
    .enq_valid(R_array_index_02_slr0_38_enq_valid),
    .enq_ready(R_array_index_02_slr0_38_enq_ready),
    .enq_bits(R_array_index_02_slr0_38_enq_bits),
    .deq_valid(R_array_index_02_slr0_38_deq_valid),
    .deq_ready(R_array_index_02_slr0_38_deq_ready),
    .deq_bits(R_array_index_02_slr0_38_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_38 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_38_clock),
    .reset(R_array_index_02_slr1_38_reset),
    .enq_valid(R_array_index_02_slr1_38_enq_valid),
    .enq_ready(R_array_index_02_slr1_38_enq_ready),
    .enq_bits(R_array_index_02_slr1_38_enq_bits),
    .deq_valid(R_array_index_02_slr1_38_deq_valid),
    .deq_ready(R_array_index_02_slr1_38_deq_ready),
    .deq_bits(R_array_index_02_slr1_38_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_38 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_38_clock),
    .reset(R_array_index_02_slr2_38_reset),
    .enq_valid(R_array_index_02_slr2_38_enq_valid),
    .enq_ready(R_array_index_02_slr2_38_enq_ready),
    .enq_bits(R_array_index_02_slr2_38_enq_bits),
    .deq_valid(R_array_index_02_slr2_38_deq_valid),
    .deq_ready(R_array_index_02_slr2_38_deq_ready),
    .deq_bits(R_array_index_02_slr2_38_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_94 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_94_clock),
    .reset(q_R_array_index_slr0_94_reset),
    .io_enq_ready(q_R_array_index_slr0_94_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_94_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_94_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_94_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_94_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_94_io_deq_bits),
    .io_count(q_R_array_index_slr0_94_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_39 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_39_clock),
    .reset(R_array_index_02_slr0_39_reset),
    .enq_valid(R_array_index_02_slr0_39_enq_valid),
    .enq_ready(R_array_index_02_slr0_39_enq_ready),
    .enq_bits(R_array_index_02_slr0_39_enq_bits),
    .deq_valid(R_array_index_02_slr0_39_deq_valid),
    .deq_ready(R_array_index_02_slr0_39_deq_ready),
    .deq_bits(R_array_index_02_slr0_39_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_39 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_39_clock),
    .reset(R_array_index_02_slr1_39_reset),
    .enq_valid(R_array_index_02_slr1_39_enq_valid),
    .enq_ready(R_array_index_02_slr1_39_enq_ready),
    .enq_bits(R_array_index_02_slr1_39_enq_bits),
    .deq_valid(R_array_index_02_slr1_39_deq_valid),
    .deq_ready(R_array_index_02_slr1_39_deq_ready),
    .deq_bits(R_array_index_02_slr1_39_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_39 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_39_clock),
    .reset(R_array_index_02_slr2_39_reset),
    .enq_valid(R_array_index_02_slr2_39_enq_valid),
    .enq_ready(R_array_index_02_slr2_39_enq_ready),
    .enq_bits(R_array_index_02_slr2_39_enq_bits),
    .deq_valid(R_array_index_02_slr2_39_deq_valid),
    .deq_ready(R_array_index_02_slr2_39_deq_ready),
    .deq_bits(R_array_index_02_slr2_39_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_95 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_95_clock),
    .reset(q_R_array_index_slr0_95_reset),
    .io_enq_ready(q_R_array_index_slr0_95_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_95_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_95_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_95_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_95_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_95_io_deq_bits),
    .io_count(q_R_array_index_slr0_95_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_40 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_40_clock),
    .reset(R_array_index_02_slr0_40_reset),
    .enq_valid(R_array_index_02_slr0_40_enq_valid),
    .enq_ready(R_array_index_02_slr0_40_enq_ready),
    .enq_bits(R_array_index_02_slr0_40_enq_bits),
    .deq_valid(R_array_index_02_slr0_40_deq_valid),
    .deq_ready(R_array_index_02_slr0_40_deq_ready),
    .deq_bits(R_array_index_02_slr0_40_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_40 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_40_clock),
    .reset(R_array_index_02_slr1_40_reset),
    .enq_valid(R_array_index_02_slr1_40_enq_valid),
    .enq_ready(R_array_index_02_slr1_40_enq_ready),
    .enq_bits(R_array_index_02_slr1_40_enq_bits),
    .deq_valid(R_array_index_02_slr1_40_deq_valid),
    .deq_ready(R_array_index_02_slr1_40_deq_ready),
    .deq_bits(R_array_index_02_slr1_40_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_40 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_40_clock),
    .reset(R_array_index_02_slr2_40_reset),
    .enq_valid(R_array_index_02_slr2_40_enq_valid),
    .enq_ready(R_array_index_02_slr2_40_enq_ready),
    .enq_bits(R_array_index_02_slr2_40_enq_bits),
    .deq_valid(R_array_index_02_slr2_40_deq_valid),
    .deq_ready(R_array_index_02_slr2_40_deq_ready),
    .deq_bits(R_array_index_02_slr2_40_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_96 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_96_clock),
    .reset(q_R_array_index_slr0_96_reset),
    .io_enq_ready(q_R_array_index_slr0_96_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_96_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_96_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_96_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_96_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_96_io_deq_bits),
    .io_count(q_R_array_index_slr0_96_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_41 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_41_clock),
    .reset(R_array_index_02_slr0_41_reset),
    .enq_valid(R_array_index_02_slr0_41_enq_valid),
    .enq_ready(R_array_index_02_slr0_41_enq_ready),
    .enq_bits(R_array_index_02_slr0_41_enq_bits),
    .deq_valid(R_array_index_02_slr0_41_deq_valid),
    .deq_ready(R_array_index_02_slr0_41_deq_ready),
    .deq_bits(R_array_index_02_slr0_41_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_41 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_41_clock),
    .reset(R_array_index_02_slr1_41_reset),
    .enq_valid(R_array_index_02_slr1_41_enq_valid),
    .enq_ready(R_array_index_02_slr1_41_enq_ready),
    .enq_bits(R_array_index_02_slr1_41_enq_bits),
    .deq_valid(R_array_index_02_slr1_41_deq_valid),
    .deq_ready(R_array_index_02_slr1_41_deq_ready),
    .deq_bits(R_array_index_02_slr1_41_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_41 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_41_clock),
    .reset(R_array_index_02_slr2_41_reset),
    .enq_valid(R_array_index_02_slr2_41_enq_valid),
    .enq_ready(R_array_index_02_slr2_41_enq_ready),
    .enq_bits(R_array_index_02_slr2_41_enq_bits),
    .deq_valid(R_array_index_02_slr2_41_deq_valid),
    .deq_ready(R_array_index_02_slr2_41_deq_ready),
    .deq_bits(R_array_index_02_slr2_41_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_97 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_97_clock),
    .reset(q_R_array_index_slr0_97_reset),
    .io_enq_ready(q_R_array_index_slr0_97_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_97_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_97_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_97_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_97_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_97_io_deq_bits),
    .io_count(q_R_array_index_slr0_97_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_42 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_42_clock),
    .reset(R_array_index_02_slr0_42_reset),
    .enq_valid(R_array_index_02_slr0_42_enq_valid),
    .enq_ready(R_array_index_02_slr0_42_enq_ready),
    .enq_bits(R_array_index_02_slr0_42_enq_bits),
    .deq_valid(R_array_index_02_slr0_42_deq_valid),
    .deq_ready(R_array_index_02_slr0_42_deq_ready),
    .deq_bits(R_array_index_02_slr0_42_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_42 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_42_clock),
    .reset(R_array_index_02_slr1_42_reset),
    .enq_valid(R_array_index_02_slr1_42_enq_valid),
    .enq_ready(R_array_index_02_slr1_42_enq_ready),
    .enq_bits(R_array_index_02_slr1_42_enq_bits),
    .deq_valid(R_array_index_02_slr1_42_deq_valid),
    .deq_ready(R_array_index_02_slr1_42_deq_ready),
    .deq_bits(R_array_index_02_slr1_42_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_42 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_42_clock),
    .reset(R_array_index_02_slr2_42_reset),
    .enq_valid(R_array_index_02_slr2_42_enq_valid),
    .enq_ready(R_array_index_02_slr2_42_enq_ready),
    .enq_bits(R_array_index_02_slr2_42_enq_bits),
    .deq_valid(R_array_index_02_slr2_42_deq_valid),
    .deq_ready(R_array_index_02_slr2_42_deq_ready),
    .deq_bits(R_array_index_02_slr2_42_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_98 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_98_clock),
    .reset(q_R_array_index_slr0_98_reset),
    .io_enq_ready(q_R_array_index_slr0_98_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_98_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_98_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_98_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_98_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_98_io_deq_bits),
    .io_count(q_R_array_index_slr0_98_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_43 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_43_clock),
    .reset(R_array_index_02_slr0_43_reset),
    .enq_valid(R_array_index_02_slr0_43_enq_valid),
    .enq_ready(R_array_index_02_slr0_43_enq_ready),
    .enq_bits(R_array_index_02_slr0_43_enq_bits),
    .deq_valid(R_array_index_02_slr0_43_deq_valid),
    .deq_ready(R_array_index_02_slr0_43_deq_ready),
    .deq_bits(R_array_index_02_slr0_43_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_43 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_43_clock),
    .reset(R_array_index_02_slr1_43_reset),
    .enq_valid(R_array_index_02_slr1_43_enq_valid),
    .enq_ready(R_array_index_02_slr1_43_enq_ready),
    .enq_bits(R_array_index_02_slr1_43_enq_bits),
    .deq_valid(R_array_index_02_slr1_43_deq_valid),
    .deq_ready(R_array_index_02_slr1_43_deq_ready),
    .deq_bits(R_array_index_02_slr1_43_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_43 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_43_clock),
    .reset(R_array_index_02_slr2_43_reset),
    .enq_valid(R_array_index_02_slr2_43_enq_valid),
    .enq_ready(R_array_index_02_slr2_43_enq_ready),
    .enq_bits(R_array_index_02_slr2_43_enq_bits),
    .deq_valid(R_array_index_02_slr2_43_deq_valid),
    .deq_ready(R_array_index_02_slr2_43_deq_ready),
    .deq_bits(R_array_index_02_slr2_43_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_99 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_99_clock),
    .reset(q_R_array_index_slr0_99_reset),
    .io_enq_ready(q_R_array_index_slr0_99_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_99_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_99_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_99_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_99_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_99_io_deq_bits),
    .io_count(q_R_array_index_slr0_99_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_44 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_44_clock),
    .reset(R_array_index_02_slr0_44_reset),
    .enq_valid(R_array_index_02_slr0_44_enq_valid),
    .enq_ready(R_array_index_02_slr0_44_enq_ready),
    .enq_bits(R_array_index_02_slr0_44_enq_bits),
    .deq_valid(R_array_index_02_slr0_44_deq_valid),
    .deq_ready(R_array_index_02_slr0_44_deq_ready),
    .deq_bits(R_array_index_02_slr0_44_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_44 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_44_clock),
    .reset(R_array_index_02_slr1_44_reset),
    .enq_valid(R_array_index_02_slr1_44_enq_valid),
    .enq_ready(R_array_index_02_slr1_44_enq_ready),
    .enq_bits(R_array_index_02_slr1_44_enq_bits),
    .deq_valid(R_array_index_02_slr1_44_deq_valid),
    .deq_ready(R_array_index_02_slr1_44_deq_ready),
    .deq_bits(R_array_index_02_slr1_44_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_44 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_44_clock),
    .reset(R_array_index_02_slr2_44_reset),
    .enq_valid(R_array_index_02_slr2_44_enq_valid),
    .enq_ready(R_array_index_02_slr2_44_enq_ready),
    .enq_bits(R_array_index_02_slr2_44_enq_bits),
    .deq_valid(R_array_index_02_slr2_44_deq_valid),
    .deq_ready(R_array_index_02_slr2_44_deq_ready),
    .deq_bits(R_array_index_02_slr2_44_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_100 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_100_clock),
    .reset(q_R_array_index_slr0_100_reset),
    .io_enq_ready(q_R_array_index_slr0_100_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_100_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_100_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_100_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_100_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_100_io_deq_bits),
    .io_count(q_R_array_index_slr0_100_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_45 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_45_clock),
    .reset(R_array_index_02_slr0_45_reset),
    .enq_valid(R_array_index_02_slr0_45_enq_valid),
    .enq_ready(R_array_index_02_slr0_45_enq_ready),
    .enq_bits(R_array_index_02_slr0_45_enq_bits),
    .deq_valid(R_array_index_02_slr0_45_deq_valid),
    .deq_ready(R_array_index_02_slr0_45_deq_ready),
    .deq_bits(R_array_index_02_slr0_45_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_45 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_45_clock),
    .reset(R_array_index_02_slr1_45_reset),
    .enq_valid(R_array_index_02_slr1_45_enq_valid),
    .enq_ready(R_array_index_02_slr1_45_enq_ready),
    .enq_bits(R_array_index_02_slr1_45_enq_bits),
    .deq_valid(R_array_index_02_slr1_45_deq_valid),
    .deq_ready(R_array_index_02_slr1_45_deq_ready),
    .deq_bits(R_array_index_02_slr1_45_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_45 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_45_clock),
    .reset(R_array_index_02_slr2_45_reset),
    .enq_valid(R_array_index_02_slr2_45_enq_valid),
    .enq_ready(R_array_index_02_slr2_45_enq_ready),
    .enq_bits(R_array_index_02_slr2_45_enq_bits),
    .deq_valid(R_array_index_02_slr2_45_deq_valid),
    .deq_ready(R_array_index_02_slr2_45_deq_ready),
    .deq_bits(R_array_index_02_slr2_45_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_101 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_101_clock),
    .reset(q_R_array_index_slr0_101_reset),
    .io_enq_ready(q_R_array_index_slr0_101_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_101_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_101_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_101_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_101_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_101_io_deq_bits),
    .io_count(q_R_array_index_slr0_101_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_46 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_46_clock),
    .reset(R_array_index_02_slr0_46_reset),
    .enq_valid(R_array_index_02_slr0_46_enq_valid),
    .enq_ready(R_array_index_02_slr0_46_enq_ready),
    .enq_bits(R_array_index_02_slr0_46_enq_bits),
    .deq_valid(R_array_index_02_slr0_46_deq_valid),
    .deq_ready(R_array_index_02_slr0_46_deq_ready),
    .deq_bits(R_array_index_02_slr0_46_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_46 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_46_clock),
    .reset(R_array_index_02_slr1_46_reset),
    .enq_valid(R_array_index_02_slr1_46_enq_valid),
    .enq_ready(R_array_index_02_slr1_46_enq_ready),
    .enq_bits(R_array_index_02_slr1_46_enq_bits),
    .deq_valid(R_array_index_02_slr1_46_deq_valid),
    .deq_ready(R_array_index_02_slr1_46_deq_ready),
    .deq_bits(R_array_index_02_slr1_46_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_46 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_46_clock),
    .reset(R_array_index_02_slr2_46_reset),
    .enq_valid(R_array_index_02_slr2_46_enq_valid),
    .enq_ready(R_array_index_02_slr2_46_enq_ready),
    .enq_bits(R_array_index_02_slr2_46_enq_bits),
    .deq_valid(R_array_index_02_slr2_46_deq_valid),
    .deq_ready(R_array_index_02_slr2_46_deq_ready),
    .deq_bits(R_array_index_02_slr2_46_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_102 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_102_clock),
    .reset(q_R_array_index_slr0_102_reset),
    .io_enq_ready(q_R_array_index_slr0_102_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_102_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_102_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_102_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_102_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_102_io_deq_bits),
    .io_count(q_R_array_index_slr0_102_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_47 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_47_clock),
    .reset(R_array_index_02_slr0_47_reset),
    .enq_valid(R_array_index_02_slr0_47_enq_valid),
    .enq_ready(R_array_index_02_slr0_47_enq_ready),
    .enq_bits(R_array_index_02_slr0_47_enq_bits),
    .deq_valid(R_array_index_02_slr0_47_deq_valid),
    .deq_ready(R_array_index_02_slr0_47_deq_ready),
    .deq_bits(R_array_index_02_slr0_47_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_47 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_47_clock),
    .reset(R_array_index_02_slr1_47_reset),
    .enq_valid(R_array_index_02_slr1_47_enq_valid),
    .enq_ready(R_array_index_02_slr1_47_enq_ready),
    .enq_bits(R_array_index_02_slr1_47_enq_bits),
    .deq_valid(R_array_index_02_slr1_47_deq_valid),
    .deq_ready(R_array_index_02_slr1_47_deq_ready),
    .deq_bits(R_array_index_02_slr1_47_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_47 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_47_clock),
    .reset(R_array_index_02_slr2_47_reset),
    .enq_valid(R_array_index_02_slr2_47_enq_valid),
    .enq_ready(R_array_index_02_slr2_47_enq_ready),
    .enq_bits(R_array_index_02_slr2_47_enq_bits),
    .deq_valid(R_array_index_02_slr2_47_deq_valid),
    .deq_ready(R_array_index_02_slr2_47_deq_ready),
    .deq_bits(R_array_index_02_slr2_47_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_103 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_103_clock),
    .reset(q_R_array_index_slr0_103_reset),
    .io_enq_ready(q_R_array_index_slr0_103_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_103_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_103_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_103_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_103_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_103_io_deq_bits),
    .io_count(q_R_array_index_slr0_103_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_48 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_48_clock),
    .reset(R_array_index_02_slr0_48_reset),
    .enq_valid(R_array_index_02_slr0_48_enq_valid),
    .enq_ready(R_array_index_02_slr0_48_enq_ready),
    .enq_bits(R_array_index_02_slr0_48_enq_bits),
    .deq_valid(R_array_index_02_slr0_48_deq_valid),
    .deq_ready(R_array_index_02_slr0_48_deq_ready),
    .deq_bits(R_array_index_02_slr0_48_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_48 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_48_clock),
    .reset(R_array_index_02_slr1_48_reset),
    .enq_valid(R_array_index_02_slr1_48_enq_valid),
    .enq_ready(R_array_index_02_slr1_48_enq_ready),
    .enq_bits(R_array_index_02_slr1_48_enq_bits),
    .deq_valid(R_array_index_02_slr1_48_deq_valid),
    .deq_ready(R_array_index_02_slr1_48_deq_ready),
    .deq_bits(R_array_index_02_slr1_48_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_48 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_48_clock),
    .reset(R_array_index_02_slr2_48_reset),
    .enq_valid(R_array_index_02_slr2_48_enq_valid),
    .enq_ready(R_array_index_02_slr2_48_enq_ready),
    .enq_bits(R_array_index_02_slr2_48_enq_bits),
    .deq_valid(R_array_index_02_slr2_48_deq_valid),
    .deq_ready(R_array_index_02_slr2_48_deq_ready),
    .deq_bits(R_array_index_02_slr2_48_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_104 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_104_clock),
    .reset(q_R_array_index_slr0_104_reset),
    .io_enq_ready(q_R_array_index_slr0_104_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_104_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_104_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_104_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_104_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_104_io_deq_bits),
    .io_count(q_R_array_index_slr0_104_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_49 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_49_clock),
    .reset(R_array_index_02_slr0_49_reset),
    .enq_valid(R_array_index_02_slr0_49_enq_valid),
    .enq_ready(R_array_index_02_slr0_49_enq_ready),
    .enq_bits(R_array_index_02_slr0_49_enq_bits),
    .deq_valid(R_array_index_02_slr0_49_deq_valid),
    .deq_ready(R_array_index_02_slr0_49_deq_ready),
    .deq_bits(R_array_index_02_slr0_49_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_49 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_49_clock),
    .reset(R_array_index_02_slr1_49_reset),
    .enq_valid(R_array_index_02_slr1_49_enq_valid),
    .enq_ready(R_array_index_02_slr1_49_enq_ready),
    .enq_bits(R_array_index_02_slr1_49_enq_bits),
    .deq_valid(R_array_index_02_slr1_49_deq_valid),
    .deq_ready(R_array_index_02_slr1_49_deq_ready),
    .deq_bits(R_array_index_02_slr1_49_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_49 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_49_clock),
    .reset(R_array_index_02_slr2_49_reset),
    .enq_valid(R_array_index_02_slr2_49_enq_valid),
    .enq_ready(R_array_index_02_slr2_49_enq_ready),
    .enq_bits(R_array_index_02_slr2_49_enq_bits),
    .deq_valid(R_array_index_02_slr2_49_deq_valid),
    .deq_ready(R_array_index_02_slr2_49_deq_ready),
    .deq_bits(R_array_index_02_slr2_49_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_105 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_105_clock),
    .reset(q_R_array_index_slr0_105_reset),
    .io_enq_ready(q_R_array_index_slr0_105_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_105_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_105_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_105_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_105_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_105_io_deq_bits),
    .io_count(q_R_array_index_slr0_105_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_50 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_50_clock),
    .reset(R_array_index_02_slr0_50_reset),
    .enq_valid(R_array_index_02_slr0_50_enq_valid),
    .enq_ready(R_array_index_02_slr0_50_enq_ready),
    .enq_bits(R_array_index_02_slr0_50_enq_bits),
    .deq_valid(R_array_index_02_slr0_50_deq_valid),
    .deq_ready(R_array_index_02_slr0_50_deq_ready),
    .deq_bits(R_array_index_02_slr0_50_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_50 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_50_clock),
    .reset(R_array_index_02_slr1_50_reset),
    .enq_valid(R_array_index_02_slr1_50_enq_valid),
    .enq_ready(R_array_index_02_slr1_50_enq_ready),
    .enq_bits(R_array_index_02_slr1_50_enq_bits),
    .deq_valid(R_array_index_02_slr1_50_deq_valid),
    .deq_ready(R_array_index_02_slr1_50_deq_ready),
    .deq_bits(R_array_index_02_slr1_50_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_50 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_50_clock),
    .reset(R_array_index_02_slr2_50_reset),
    .enq_valid(R_array_index_02_slr2_50_enq_valid),
    .enq_ready(R_array_index_02_slr2_50_enq_ready),
    .enq_bits(R_array_index_02_slr2_50_enq_bits),
    .deq_valid(R_array_index_02_slr2_50_deq_valid),
    .deq_ready(R_array_index_02_slr2_50_deq_ready),
    .deq_bits(R_array_index_02_slr2_50_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_106 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_106_clock),
    .reset(q_R_array_index_slr0_106_reset),
    .io_enq_ready(q_R_array_index_slr0_106_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_106_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_106_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_106_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_106_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_106_io_deq_bits),
    .io_count(q_R_array_index_slr0_106_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_51 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_51_clock),
    .reset(R_array_index_02_slr0_51_reset),
    .enq_valid(R_array_index_02_slr0_51_enq_valid),
    .enq_ready(R_array_index_02_slr0_51_enq_ready),
    .enq_bits(R_array_index_02_slr0_51_enq_bits),
    .deq_valid(R_array_index_02_slr0_51_deq_valid),
    .deq_ready(R_array_index_02_slr0_51_deq_ready),
    .deq_bits(R_array_index_02_slr0_51_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_51 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_51_clock),
    .reset(R_array_index_02_slr1_51_reset),
    .enq_valid(R_array_index_02_slr1_51_enq_valid),
    .enq_ready(R_array_index_02_slr1_51_enq_ready),
    .enq_bits(R_array_index_02_slr1_51_enq_bits),
    .deq_valid(R_array_index_02_slr1_51_deq_valid),
    .deq_ready(R_array_index_02_slr1_51_deq_ready),
    .deq_bits(R_array_index_02_slr1_51_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_51 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_51_clock),
    .reset(R_array_index_02_slr2_51_reset),
    .enq_valid(R_array_index_02_slr2_51_enq_valid),
    .enq_ready(R_array_index_02_slr2_51_enq_ready),
    .enq_bits(R_array_index_02_slr2_51_enq_bits),
    .deq_valid(R_array_index_02_slr2_51_deq_valid),
    .deq_ready(R_array_index_02_slr2_51_deq_ready),
    .deq_bits(R_array_index_02_slr2_51_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_107 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_107_clock),
    .reset(q_R_array_index_slr0_107_reset),
    .io_enq_ready(q_R_array_index_slr0_107_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_107_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_107_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_107_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_107_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_107_io_deq_bits),
    .io_count(q_R_array_index_slr0_107_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_52 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_52_clock),
    .reset(R_array_index_02_slr0_52_reset),
    .enq_valid(R_array_index_02_slr0_52_enq_valid),
    .enq_ready(R_array_index_02_slr0_52_enq_ready),
    .enq_bits(R_array_index_02_slr0_52_enq_bits),
    .deq_valid(R_array_index_02_slr0_52_deq_valid),
    .deq_ready(R_array_index_02_slr0_52_deq_ready),
    .deq_bits(R_array_index_02_slr0_52_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_52 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_52_clock),
    .reset(R_array_index_02_slr1_52_reset),
    .enq_valid(R_array_index_02_slr1_52_enq_valid),
    .enq_ready(R_array_index_02_slr1_52_enq_ready),
    .enq_bits(R_array_index_02_slr1_52_enq_bits),
    .deq_valid(R_array_index_02_slr1_52_deq_valid),
    .deq_ready(R_array_index_02_slr1_52_deq_ready),
    .deq_bits(R_array_index_02_slr1_52_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_52 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_52_clock),
    .reset(R_array_index_02_slr2_52_reset),
    .enq_valid(R_array_index_02_slr2_52_enq_valid),
    .enq_ready(R_array_index_02_slr2_52_enq_ready),
    .enq_bits(R_array_index_02_slr2_52_enq_bits),
    .deq_valid(R_array_index_02_slr2_52_deq_valid),
    .deq_ready(R_array_index_02_slr2_52_deq_ready),
    .deq_bits(R_array_index_02_slr2_52_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_108 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_108_clock),
    .reset(q_R_array_index_slr0_108_reset),
    .io_enq_ready(q_R_array_index_slr0_108_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_108_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_108_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_108_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_108_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_108_io_deq_bits),
    .io_count(q_R_array_index_slr0_108_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_53 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_53_clock),
    .reset(R_array_index_02_slr0_53_reset),
    .enq_valid(R_array_index_02_slr0_53_enq_valid),
    .enq_ready(R_array_index_02_slr0_53_enq_ready),
    .enq_bits(R_array_index_02_slr0_53_enq_bits),
    .deq_valid(R_array_index_02_slr0_53_deq_valid),
    .deq_ready(R_array_index_02_slr0_53_deq_ready),
    .deq_bits(R_array_index_02_slr0_53_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_53 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_53_clock),
    .reset(R_array_index_02_slr1_53_reset),
    .enq_valid(R_array_index_02_slr1_53_enq_valid),
    .enq_ready(R_array_index_02_slr1_53_enq_ready),
    .enq_bits(R_array_index_02_slr1_53_enq_bits),
    .deq_valid(R_array_index_02_slr1_53_deq_valid),
    .deq_ready(R_array_index_02_slr1_53_deq_ready),
    .deq_bits(R_array_index_02_slr1_53_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_53 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_53_clock),
    .reset(R_array_index_02_slr2_53_reset),
    .enq_valid(R_array_index_02_slr2_53_enq_valid),
    .enq_ready(R_array_index_02_slr2_53_enq_ready),
    .enq_bits(R_array_index_02_slr2_53_enq_bits),
    .deq_valid(R_array_index_02_slr2_53_deq_valid),
    .deq_ready(R_array_index_02_slr2_53_deq_ready),
    .deq_bits(R_array_index_02_slr2_53_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_109 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_109_clock),
    .reset(q_R_array_index_slr0_109_reset),
    .io_enq_ready(q_R_array_index_slr0_109_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_109_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_109_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_109_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_109_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_109_io_deq_bits),
    .io_count(q_R_array_index_slr0_109_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_54 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_54_clock),
    .reset(R_array_index_02_slr0_54_reset),
    .enq_valid(R_array_index_02_slr0_54_enq_valid),
    .enq_ready(R_array_index_02_slr0_54_enq_ready),
    .enq_bits(R_array_index_02_slr0_54_enq_bits),
    .deq_valid(R_array_index_02_slr0_54_deq_valid),
    .deq_ready(R_array_index_02_slr0_54_deq_ready),
    .deq_bits(R_array_index_02_slr0_54_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_54 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_54_clock),
    .reset(R_array_index_02_slr1_54_reset),
    .enq_valid(R_array_index_02_slr1_54_enq_valid),
    .enq_ready(R_array_index_02_slr1_54_enq_ready),
    .enq_bits(R_array_index_02_slr1_54_enq_bits),
    .deq_valid(R_array_index_02_slr1_54_deq_valid),
    .deq_ready(R_array_index_02_slr1_54_deq_ready),
    .deq_bits(R_array_index_02_slr1_54_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_54 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_54_clock),
    .reset(R_array_index_02_slr2_54_reset),
    .enq_valid(R_array_index_02_slr2_54_enq_valid),
    .enq_ready(R_array_index_02_slr2_54_enq_ready),
    .enq_bits(R_array_index_02_slr2_54_enq_bits),
    .deq_valid(R_array_index_02_slr2_54_deq_valid),
    .deq_ready(R_array_index_02_slr2_54_deq_ready),
    .deq_bits(R_array_index_02_slr2_54_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_110 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_110_clock),
    .reset(q_R_array_index_slr0_110_reset),
    .io_enq_ready(q_R_array_index_slr0_110_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_110_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_110_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_110_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_110_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_110_io_deq_bits),
    .io_count(q_R_array_index_slr0_110_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_55 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_55_clock),
    .reset(R_array_index_02_slr0_55_reset),
    .enq_valid(R_array_index_02_slr0_55_enq_valid),
    .enq_ready(R_array_index_02_slr0_55_enq_ready),
    .enq_bits(R_array_index_02_slr0_55_enq_bits),
    .deq_valid(R_array_index_02_slr0_55_deq_valid),
    .deq_ready(R_array_index_02_slr0_55_deq_ready),
    .deq_bits(R_array_index_02_slr0_55_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_55 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_55_clock),
    .reset(R_array_index_02_slr1_55_reset),
    .enq_valid(R_array_index_02_slr1_55_enq_valid),
    .enq_ready(R_array_index_02_slr1_55_enq_ready),
    .enq_bits(R_array_index_02_slr1_55_enq_bits),
    .deq_valid(R_array_index_02_slr1_55_deq_valid),
    .deq_ready(R_array_index_02_slr1_55_deq_ready),
    .deq_bits(R_array_index_02_slr1_55_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_55 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_55_clock),
    .reset(R_array_index_02_slr2_55_reset),
    .enq_valid(R_array_index_02_slr2_55_enq_valid),
    .enq_ready(R_array_index_02_slr2_55_enq_ready),
    .enq_bits(R_array_index_02_slr2_55_enq_bits),
    .deq_valid(R_array_index_02_slr2_55_deq_valid),
    .deq_ready(R_array_index_02_slr2_55_deq_ready),
    .deq_bits(R_array_index_02_slr2_55_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_111 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_111_clock),
    .reset(q_R_array_index_slr0_111_reset),
    .io_enq_ready(q_R_array_index_slr0_111_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_111_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_111_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_111_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_111_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_111_io_deq_bits),
    .io_count(q_R_array_index_slr0_111_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_56 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_56_clock),
    .reset(R_array_index_02_slr0_56_reset),
    .enq_valid(R_array_index_02_slr0_56_enq_valid),
    .enq_ready(R_array_index_02_slr0_56_enq_ready),
    .enq_bits(R_array_index_02_slr0_56_enq_bits),
    .deq_valid(R_array_index_02_slr0_56_deq_valid),
    .deq_ready(R_array_index_02_slr0_56_deq_ready),
    .deq_bits(R_array_index_02_slr0_56_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_56 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_56_clock),
    .reset(R_array_index_02_slr1_56_reset),
    .enq_valid(R_array_index_02_slr1_56_enq_valid),
    .enq_ready(R_array_index_02_slr1_56_enq_ready),
    .enq_bits(R_array_index_02_slr1_56_enq_bits),
    .deq_valid(R_array_index_02_slr1_56_deq_valid),
    .deq_ready(R_array_index_02_slr1_56_deq_ready),
    .deq_bits(R_array_index_02_slr1_56_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_56 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_56_clock),
    .reset(R_array_index_02_slr2_56_reset),
    .enq_valid(R_array_index_02_slr2_56_enq_valid),
    .enq_ready(R_array_index_02_slr2_56_enq_ready),
    .enq_bits(R_array_index_02_slr2_56_enq_bits),
    .deq_valid(R_array_index_02_slr2_56_deq_valid),
    .deq_ready(R_array_index_02_slr2_56_deq_ready),
    .deq_bits(R_array_index_02_slr2_56_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_112 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_112_clock),
    .reset(q_R_array_index_slr0_112_reset),
    .io_enq_ready(q_R_array_index_slr0_112_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_112_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_112_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_112_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_112_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_112_io_deq_bits),
    .io_count(q_R_array_index_slr0_112_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_57 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_57_clock),
    .reset(R_array_index_02_slr0_57_reset),
    .enq_valid(R_array_index_02_slr0_57_enq_valid),
    .enq_ready(R_array_index_02_slr0_57_enq_ready),
    .enq_bits(R_array_index_02_slr0_57_enq_bits),
    .deq_valid(R_array_index_02_slr0_57_deq_valid),
    .deq_ready(R_array_index_02_slr0_57_deq_ready),
    .deq_bits(R_array_index_02_slr0_57_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_57 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_57_clock),
    .reset(R_array_index_02_slr1_57_reset),
    .enq_valid(R_array_index_02_slr1_57_enq_valid),
    .enq_ready(R_array_index_02_slr1_57_enq_ready),
    .enq_bits(R_array_index_02_slr1_57_enq_bits),
    .deq_valid(R_array_index_02_slr1_57_deq_valid),
    .deq_ready(R_array_index_02_slr1_57_deq_ready),
    .deq_bits(R_array_index_02_slr1_57_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_57 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_57_clock),
    .reset(R_array_index_02_slr2_57_reset),
    .enq_valid(R_array_index_02_slr2_57_enq_valid),
    .enq_ready(R_array_index_02_slr2_57_enq_ready),
    .enq_bits(R_array_index_02_slr2_57_enq_bits),
    .deq_valid(R_array_index_02_slr2_57_deq_valid),
    .deq_ready(R_array_index_02_slr2_57_deq_ready),
    .deq_bits(R_array_index_02_slr2_57_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_113 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_113_clock),
    .reset(q_R_array_index_slr0_113_reset),
    .io_enq_ready(q_R_array_index_slr0_113_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_113_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_113_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_113_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_113_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_113_io_deq_bits),
    .io_count(q_R_array_index_slr0_113_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_58 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_58_clock),
    .reset(R_array_index_02_slr0_58_reset),
    .enq_valid(R_array_index_02_slr0_58_enq_valid),
    .enq_ready(R_array_index_02_slr0_58_enq_ready),
    .enq_bits(R_array_index_02_slr0_58_enq_bits),
    .deq_valid(R_array_index_02_slr0_58_deq_valid),
    .deq_ready(R_array_index_02_slr0_58_deq_ready),
    .deq_bits(R_array_index_02_slr0_58_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_58 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_58_clock),
    .reset(R_array_index_02_slr1_58_reset),
    .enq_valid(R_array_index_02_slr1_58_enq_valid),
    .enq_ready(R_array_index_02_slr1_58_enq_ready),
    .enq_bits(R_array_index_02_slr1_58_enq_bits),
    .deq_valid(R_array_index_02_slr1_58_deq_valid),
    .deq_ready(R_array_index_02_slr1_58_deq_ready),
    .deq_bits(R_array_index_02_slr1_58_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_58 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_58_clock),
    .reset(R_array_index_02_slr2_58_reset),
    .enq_valid(R_array_index_02_slr2_58_enq_valid),
    .enq_ready(R_array_index_02_slr2_58_enq_ready),
    .enq_bits(R_array_index_02_slr2_58_enq_bits),
    .deq_valid(R_array_index_02_slr2_58_deq_valid),
    .deq_ready(R_array_index_02_slr2_58_deq_ready),
    .deq_bits(R_array_index_02_slr2_58_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_114 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_114_clock),
    .reset(q_R_array_index_slr0_114_reset),
    .io_enq_ready(q_R_array_index_slr0_114_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_114_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_114_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_114_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_114_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_114_io_deq_bits),
    .io_count(q_R_array_index_slr0_114_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_59 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_59_clock),
    .reset(R_array_index_02_slr0_59_reset),
    .enq_valid(R_array_index_02_slr0_59_enq_valid),
    .enq_ready(R_array_index_02_slr0_59_enq_ready),
    .enq_bits(R_array_index_02_slr0_59_enq_bits),
    .deq_valid(R_array_index_02_slr0_59_deq_valid),
    .deq_ready(R_array_index_02_slr0_59_deq_ready),
    .deq_bits(R_array_index_02_slr0_59_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_59 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_59_clock),
    .reset(R_array_index_02_slr1_59_reset),
    .enq_valid(R_array_index_02_slr1_59_enq_valid),
    .enq_ready(R_array_index_02_slr1_59_enq_ready),
    .enq_bits(R_array_index_02_slr1_59_enq_bits),
    .deq_valid(R_array_index_02_slr1_59_deq_valid),
    .deq_ready(R_array_index_02_slr1_59_deq_ready),
    .deq_bits(R_array_index_02_slr1_59_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_59 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_59_clock),
    .reset(R_array_index_02_slr2_59_reset),
    .enq_valid(R_array_index_02_slr2_59_enq_valid),
    .enq_ready(R_array_index_02_slr2_59_enq_ready),
    .enq_bits(R_array_index_02_slr2_59_enq_bits),
    .deq_valid(R_array_index_02_slr2_59_deq_valid),
    .deq_ready(R_array_index_02_slr2_59_deq_ready),
    .deq_bits(R_array_index_02_slr2_59_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_115 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_115_clock),
    .reset(q_R_array_index_slr0_115_reset),
    .io_enq_ready(q_R_array_index_slr0_115_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_115_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_115_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_115_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_115_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_115_io_deq_bits),
    .io_count(q_R_array_index_slr0_115_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_60 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_60_clock),
    .reset(R_array_index_02_slr0_60_reset),
    .enq_valid(R_array_index_02_slr0_60_enq_valid),
    .enq_ready(R_array_index_02_slr0_60_enq_ready),
    .enq_bits(R_array_index_02_slr0_60_enq_bits),
    .deq_valid(R_array_index_02_slr0_60_deq_valid),
    .deq_ready(R_array_index_02_slr0_60_deq_ready),
    .deq_bits(R_array_index_02_slr0_60_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_60 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_60_clock),
    .reset(R_array_index_02_slr1_60_reset),
    .enq_valid(R_array_index_02_slr1_60_enq_valid),
    .enq_ready(R_array_index_02_slr1_60_enq_ready),
    .enq_bits(R_array_index_02_slr1_60_enq_bits),
    .deq_valid(R_array_index_02_slr1_60_deq_valid),
    .deq_ready(R_array_index_02_slr1_60_deq_ready),
    .deq_bits(R_array_index_02_slr1_60_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_60 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_60_clock),
    .reset(R_array_index_02_slr2_60_reset),
    .enq_valid(R_array_index_02_slr2_60_enq_valid),
    .enq_ready(R_array_index_02_slr2_60_enq_ready),
    .enq_bits(R_array_index_02_slr2_60_enq_bits),
    .deq_valid(R_array_index_02_slr2_60_deq_valid),
    .deq_ready(R_array_index_02_slr2_60_deq_ready),
    .deq_bits(R_array_index_02_slr2_60_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_116 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_116_clock),
    .reset(q_R_array_index_slr0_116_reset),
    .io_enq_ready(q_R_array_index_slr0_116_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_116_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_116_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_116_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_116_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_116_io_deq_bits),
    .io_count(q_R_array_index_slr0_116_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_61 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_61_clock),
    .reset(R_array_index_02_slr0_61_reset),
    .enq_valid(R_array_index_02_slr0_61_enq_valid),
    .enq_ready(R_array_index_02_slr0_61_enq_ready),
    .enq_bits(R_array_index_02_slr0_61_enq_bits),
    .deq_valid(R_array_index_02_slr0_61_deq_valid),
    .deq_ready(R_array_index_02_slr0_61_deq_ready),
    .deq_bits(R_array_index_02_slr0_61_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_61 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_61_clock),
    .reset(R_array_index_02_slr1_61_reset),
    .enq_valid(R_array_index_02_slr1_61_enq_valid),
    .enq_ready(R_array_index_02_slr1_61_enq_ready),
    .enq_bits(R_array_index_02_slr1_61_enq_bits),
    .deq_valid(R_array_index_02_slr1_61_deq_valid),
    .deq_ready(R_array_index_02_slr1_61_deq_ready),
    .deq_bits(R_array_index_02_slr1_61_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_61 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_61_clock),
    .reset(R_array_index_02_slr2_61_reset),
    .enq_valid(R_array_index_02_slr2_61_enq_valid),
    .enq_ready(R_array_index_02_slr2_61_enq_ready),
    .enq_bits(R_array_index_02_slr2_61_enq_bits),
    .deq_valid(R_array_index_02_slr2_61_deq_valid),
    .deq_ready(R_array_index_02_slr2_61_deq_ready),
    .deq_bits(R_array_index_02_slr2_61_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_117 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_117_clock),
    .reset(q_R_array_index_slr0_117_reset),
    .io_enq_ready(q_R_array_index_slr0_117_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_117_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_117_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_117_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_117_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_117_io_deq_bits),
    .io_count(q_R_array_index_slr0_117_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_62 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_62_clock),
    .reset(R_array_index_02_slr0_62_reset),
    .enq_valid(R_array_index_02_slr0_62_enq_valid),
    .enq_ready(R_array_index_02_slr0_62_enq_ready),
    .enq_bits(R_array_index_02_slr0_62_enq_bits),
    .deq_valid(R_array_index_02_slr0_62_deq_valid),
    .deq_ready(R_array_index_02_slr0_62_deq_ready),
    .deq_bits(R_array_index_02_slr0_62_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_62 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_62_clock),
    .reset(R_array_index_02_slr1_62_reset),
    .enq_valid(R_array_index_02_slr1_62_enq_valid),
    .enq_ready(R_array_index_02_slr1_62_enq_ready),
    .enq_bits(R_array_index_02_slr1_62_enq_bits),
    .deq_valid(R_array_index_02_slr1_62_deq_valid),
    .deq_ready(R_array_index_02_slr1_62_deq_ready),
    .deq_bits(R_array_index_02_slr1_62_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_62 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_62_clock),
    .reset(R_array_index_02_slr2_62_reset),
    .enq_valid(R_array_index_02_slr2_62_enq_valid),
    .enq_ready(R_array_index_02_slr2_62_enq_ready),
    .enq_bits(R_array_index_02_slr2_62_enq_bits),
    .deq_valid(R_array_index_02_slr2_62_deq_valid),
    .deq_ready(R_array_index_02_slr2_62_deq_ready),
    .deq_bits(R_array_index_02_slr2_62_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_118 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_118_clock),
    .reset(q_R_array_index_slr0_118_reset),
    .io_enq_ready(q_R_array_index_slr0_118_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_118_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_118_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_118_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_118_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_118_io_deq_bits),
    .io_count(q_R_array_index_slr0_118_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_63 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_63_clock),
    .reset(R_array_index_02_slr0_63_reset),
    .enq_valid(R_array_index_02_slr0_63_enq_valid),
    .enq_ready(R_array_index_02_slr0_63_enq_ready),
    .enq_bits(R_array_index_02_slr0_63_enq_bits),
    .deq_valid(R_array_index_02_slr0_63_deq_valid),
    .deq_ready(R_array_index_02_slr0_63_deq_ready),
    .deq_bits(R_array_index_02_slr0_63_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_63 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_63_clock),
    .reset(R_array_index_02_slr1_63_reset),
    .enq_valid(R_array_index_02_slr1_63_enq_valid),
    .enq_ready(R_array_index_02_slr1_63_enq_ready),
    .enq_bits(R_array_index_02_slr1_63_enq_bits),
    .deq_valid(R_array_index_02_slr1_63_deq_valid),
    .deq_ready(R_array_index_02_slr1_63_deq_ready),
    .deq_bits(R_array_index_02_slr1_63_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_63 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_63_clock),
    .reset(R_array_index_02_slr2_63_reset),
    .enq_valid(R_array_index_02_slr2_63_enq_valid),
    .enq_ready(R_array_index_02_slr2_63_enq_ready),
    .enq_bits(R_array_index_02_slr2_63_enq_bits),
    .deq_valid(R_array_index_02_slr2_63_deq_valid),
    .deq_ready(R_array_index_02_slr2_63_deq_ready),
    .deq_bits(R_array_index_02_slr2_63_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_119 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_119_clock),
    .reset(q_R_array_index_slr0_119_reset),
    .io_enq_ready(q_R_array_index_slr0_119_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_119_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_119_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_119_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_119_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_119_io_deq_bits),
    .io_count(q_R_array_index_slr0_119_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_64 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_64_clock),
    .reset(R_array_index_02_slr0_64_reset),
    .enq_valid(R_array_index_02_slr0_64_enq_valid),
    .enq_ready(R_array_index_02_slr0_64_enq_ready),
    .enq_bits(R_array_index_02_slr0_64_enq_bits),
    .deq_valid(R_array_index_02_slr0_64_deq_valid),
    .deq_ready(R_array_index_02_slr0_64_deq_ready),
    .deq_bits(R_array_index_02_slr0_64_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_64 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_64_clock),
    .reset(R_array_index_02_slr1_64_reset),
    .enq_valid(R_array_index_02_slr1_64_enq_valid),
    .enq_ready(R_array_index_02_slr1_64_enq_ready),
    .enq_bits(R_array_index_02_slr1_64_enq_bits),
    .deq_valid(R_array_index_02_slr1_64_deq_valid),
    .deq_ready(R_array_index_02_slr1_64_deq_ready),
    .deq_bits(R_array_index_02_slr1_64_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_64 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_64_clock),
    .reset(R_array_index_02_slr2_64_reset),
    .enq_valid(R_array_index_02_slr2_64_enq_valid),
    .enq_ready(R_array_index_02_slr2_64_enq_ready),
    .enq_bits(R_array_index_02_slr2_64_enq_bits),
    .deq_valid(R_array_index_02_slr2_64_deq_valid),
    .deq_ready(R_array_index_02_slr2_64_deq_ready),
    .deq_bits(R_array_index_02_slr2_64_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_120 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_120_clock),
    .reset(q_R_array_index_slr0_120_reset),
    .io_enq_ready(q_R_array_index_slr0_120_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_120_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_120_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_120_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_120_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_120_io_deq_bits),
    .io_count(q_R_array_index_slr0_120_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_65 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_65_clock),
    .reset(R_array_index_02_slr0_65_reset),
    .enq_valid(R_array_index_02_slr0_65_enq_valid),
    .enq_ready(R_array_index_02_slr0_65_enq_ready),
    .enq_bits(R_array_index_02_slr0_65_enq_bits),
    .deq_valid(R_array_index_02_slr0_65_deq_valid),
    .deq_ready(R_array_index_02_slr0_65_deq_ready),
    .deq_bits(R_array_index_02_slr0_65_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_65 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_65_clock),
    .reset(R_array_index_02_slr1_65_reset),
    .enq_valid(R_array_index_02_slr1_65_enq_valid),
    .enq_ready(R_array_index_02_slr1_65_enq_ready),
    .enq_bits(R_array_index_02_slr1_65_enq_bits),
    .deq_valid(R_array_index_02_slr1_65_deq_valid),
    .deq_ready(R_array_index_02_slr1_65_deq_ready),
    .deq_bits(R_array_index_02_slr1_65_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_65 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_65_clock),
    .reset(R_array_index_02_slr2_65_reset),
    .enq_valid(R_array_index_02_slr2_65_enq_valid),
    .enq_ready(R_array_index_02_slr2_65_enq_ready),
    .enq_bits(R_array_index_02_slr2_65_enq_bits),
    .deq_valid(R_array_index_02_slr2_65_deq_valid),
    .deq_ready(R_array_index_02_slr2_65_deq_ready),
    .deq_bits(R_array_index_02_slr2_65_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_121 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_121_clock),
    .reset(q_R_array_index_slr0_121_reset),
    .io_enq_ready(q_R_array_index_slr0_121_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_121_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_121_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_121_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_121_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_121_io_deq_bits),
    .io_count(q_R_array_index_slr0_121_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_66 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_66_clock),
    .reset(R_array_index_02_slr0_66_reset),
    .enq_valid(R_array_index_02_slr0_66_enq_valid),
    .enq_ready(R_array_index_02_slr0_66_enq_ready),
    .enq_bits(R_array_index_02_slr0_66_enq_bits),
    .deq_valid(R_array_index_02_slr0_66_deq_valid),
    .deq_ready(R_array_index_02_slr0_66_deq_ready),
    .deq_bits(R_array_index_02_slr0_66_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_66 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_66_clock),
    .reset(R_array_index_02_slr1_66_reset),
    .enq_valid(R_array_index_02_slr1_66_enq_valid),
    .enq_ready(R_array_index_02_slr1_66_enq_ready),
    .enq_bits(R_array_index_02_slr1_66_enq_bits),
    .deq_valid(R_array_index_02_slr1_66_deq_valid),
    .deq_ready(R_array_index_02_slr1_66_deq_ready),
    .deq_bits(R_array_index_02_slr1_66_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_66 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_66_clock),
    .reset(R_array_index_02_slr2_66_reset),
    .enq_valid(R_array_index_02_slr2_66_enq_valid),
    .enq_ready(R_array_index_02_slr2_66_enq_ready),
    .enq_bits(R_array_index_02_slr2_66_enq_bits),
    .deq_valid(R_array_index_02_slr2_66_deq_valid),
    .deq_ready(R_array_index_02_slr2_66_deq_ready),
    .deq_bits(R_array_index_02_slr2_66_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_122 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_122_clock),
    .reset(q_R_array_index_slr0_122_reset),
    .io_enq_ready(q_R_array_index_slr0_122_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_122_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_122_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_122_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_122_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_122_io_deq_bits),
    .io_count(q_R_array_index_slr0_122_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_67 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_67_clock),
    .reset(R_array_index_02_slr0_67_reset),
    .enq_valid(R_array_index_02_slr0_67_enq_valid),
    .enq_ready(R_array_index_02_slr0_67_enq_ready),
    .enq_bits(R_array_index_02_slr0_67_enq_bits),
    .deq_valid(R_array_index_02_slr0_67_deq_valid),
    .deq_ready(R_array_index_02_slr0_67_deq_ready),
    .deq_bits(R_array_index_02_slr0_67_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_67 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_67_clock),
    .reset(R_array_index_02_slr1_67_reset),
    .enq_valid(R_array_index_02_slr1_67_enq_valid),
    .enq_ready(R_array_index_02_slr1_67_enq_ready),
    .enq_bits(R_array_index_02_slr1_67_enq_bits),
    .deq_valid(R_array_index_02_slr1_67_deq_valid),
    .deq_ready(R_array_index_02_slr1_67_deq_ready),
    .deq_bits(R_array_index_02_slr1_67_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_67 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_67_clock),
    .reset(R_array_index_02_slr2_67_reset),
    .enq_valid(R_array_index_02_slr2_67_enq_valid),
    .enq_ready(R_array_index_02_slr2_67_enq_ready),
    .enq_bits(R_array_index_02_slr2_67_enq_bits),
    .deq_valid(R_array_index_02_slr2_67_deq_valid),
    .deq_ready(R_array_index_02_slr2_67_deq_ready),
    .deq_bits(R_array_index_02_slr2_67_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_123 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_123_clock),
    .reset(q_R_array_index_slr0_123_reset),
    .io_enq_ready(q_R_array_index_slr0_123_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_123_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_123_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_123_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_123_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_123_io_deq_bits),
    .io_count(q_R_array_index_slr0_123_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_68 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_68_clock),
    .reset(R_array_index_02_slr0_68_reset),
    .enq_valid(R_array_index_02_slr0_68_enq_valid),
    .enq_ready(R_array_index_02_slr0_68_enq_ready),
    .enq_bits(R_array_index_02_slr0_68_enq_bits),
    .deq_valid(R_array_index_02_slr0_68_deq_valid),
    .deq_ready(R_array_index_02_slr0_68_deq_ready),
    .deq_bits(R_array_index_02_slr0_68_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_68 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_68_clock),
    .reset(R_array_index_02_slr1_68_reset),
    .enq_valid(R_array_index_02_slr1_68_enq_valid),
    .enq_ready(R_array_index_02_slr1_68_enq_ready),
    .enq_bits(R_array_index_02_slr1_68_enq_bits),
    .deq_valid(R_array_index_02_slr1_68_deq_valid),
    .deq_ready(R_array_index_02_slr1_68_deq_ready),
    .deq_bits(R_array_index_02_slr1_68_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_68 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_68_clock),
    .reset(R_array_index_02_slr2_68_reset),
    .enq_valid(R_array_index_02_slr2_68_enq_valid),
    .enq_ready(R_array_index_02_slr2_68_enq_ready),
    .enq_bits(R_array_index_02_slr2_68_enq_bits),
    .deq_valid(R_array_index_02_slr2_68_deq_valid),
    .deq_ready(R_array_index_02_slr2_68_deq_ready),
    .deq_bits(R_array_index_02_slr2_68_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_124 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_124_clock),
    .reset(q_R_array_index_slr0_124_reset),
    .io_enq_ready(q_R_array_index_slr0_124_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_124_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_124_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_124_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_124_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_124_io_deq_bits),
    .io_count(q_R_array_index_slr0_124_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_69 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_69_clock),
    .reset(R_array_index_02_slr0_69_reset),
    .enq_valid(R_array_index_02_slr0_69_enq_valid),
    .enq_ready(R_array_index_02_slr0_69_enq_ready),
    .enq_bits(R_array_index_02_slr0_69_enq_bits),
    .deq_valid(R_array_index_02_slr0_69_deq_valid),
    .deq_ready(R_array_index_02_slr0_69_deq_ready),
    .deq_bits(R_array_index_02_slr0_69_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_69 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_69_clock),
    .reset(R_array_index_02_slr1_69_reset),
    .enq_valid(R_array_index_02_slr1_69_enq_valid),
    .enq_ready(R_array_index_02_slr1_69_enq_ready),
    .enq_bits(R_array_index_02_slr1_69_enq_bits),
    .deq_valid(R_array_index_02_slr1_69_deq_valid),
    .deq_ready(R_array_index_02_slr1_69_deq_ready),
    .deq_bits(R_array_index_02_slr1_69_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_69 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_69_clock),
    .reset(R_array_index_02_slr2_69_reset),
    .enq_valid(R_array_index_02_slr2_69_enq_valid),
    .enq_ready(R_array_index_02_slr2_69_enq_ready),
    .enq_bits(R_array_index_02_slr2_69_enq_bits),
    .deq_valid(R_array_index_02_slr2_69_deq_valid),
    .deq_ready(R_array_index_02_slr2_69_deq_ready),
    .deq_bits(R_array_index_02_slr2_69_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_125 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_125_clock),
    .reset(q_R_array_index_slr0_125_reset),
    .io_enq_ready(q_R_array_index_slr0_125_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_125_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_125_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_125_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_125_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_125_io_deq_bits),
    .io_count(q_R_array_index_slr0_125_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_70 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_70_clock),
    .reset(R_array_index_02_slr0_70_reset),
    .enq_valid(R_array_index_02_slr0_70_enq_valid),
    .enq_ready(R_array_index_02_slr0_70_enq_ready),
    .enq_bits(R_array_index_02_slr0_70_enq_bits),
    .deq_valid(R_array_index_02_slr0_70_deq_valid),
    .deq_ready(R_array_index_02_slr0_70_deq_ready),
    .deq_bits(R_array_index_02_slr0_70_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_70 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_70_clock),
    .reset(R_array_index_02_slr1_70_reset),
    .enq_valid(R_array_index_02_slr1_70_enq_valid),
    .enq_ready(R_array_index_02_slr1_70_enq_ready),
    .enq_bits(R_array_index_02_slr1_70_enq_bits),
    .deq_valid(R_array_index_02_slr1_70_deq_valid),
    .deq_ready(R_array_index_02_slr1_70_deq_ready),
    .deq_bits(R_array_index_02_slr1_70_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_70 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_70_clock),
    .reset(R_array_index_02_slr2_70_reset),
    .enq_valid(R_array_index_02_slr2_70_enq_valid),
    .enq_ready(R_array_index_02_slr2_70_enq_ready),
    .enq_bits(R_array_index_02_slr2_70_enq_bits),
    .deq_valid(R_array_index_02_slr2_70_deq_valid),
    .deq_ready(R_array_index_02_slr2_70_deq_ready),
    .deq_bits(R_array_index_02_slr2_70_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_126 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_126_clock),
    .reset(q_R_array_index_slr0_126_reset),
    .io_enq_ready(q_R_array_index_slr0_126_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_126_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_126_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_126_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_126_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_126_io_deq_bits),
    .io_count(q_R_array_index_slr0_126_io_count)
  );
  R_array_index_02_slr0 R_array_index_02_slr0_71 ( // @[Top-slr.scala 363:42]
    .clock(R_array_index_02_slr0_71_clock),
    .reset(R_array_index_02_slr0_71_reset),
    .enq_valid(R_array_index_02_slr0_71_enq_valid),
    .enq_ready(R_array_index_02_slr0_71_enq_ready),
    .enq_bits(R_array_index_02_slr0_71_enq_bits),
    .deq_valid(R_array_index_02_slr0_71_deq_valid),
    .deq_ready(R_array_index_02_slr0_71_deq_ready),
    .deq_bits(R_array_index_02_slr0_71_deq_bits)
  );
  R_array_index_02_slr1 R_array_index_02_slr1_71 ( // @[Top-slr.scala 364:42]
    .clock(R_array_index_02_slr1_71_clock),
    .reset(R_array_index_02_slr1_71_reset),
    .enq_valid(R_array_index_02_slr1_71_enq_valid),
    .enq_ready(R_array_index_02_slr1_71_enq_ready),
    .enq_bits(R_array_index_02_slr1_71_enq_bits),
    .deq_valid(R_array_index_02_slr1_71_deq_valid),
    .deq_ready(R_array_index_02_slr1_71_deq_ready),
    .deq_bits(R_array_index_02_slr1_71_deq_bits)
  );
  R_array_index_02_slr2 R_array_index_02_slr2_71 ( // @[Top-slr.scala 365:42]
    .clock(R_array_index_02_slr2_71_clock),
    .reset(R_array_index_02_slr2_71_reset),
    .enq_valid(R_array_index_02_slr2_71_enq_valid),
    .enq_ready(R_array_index_02_slr2_71_enq_ready),
    .enq_bits(R_array_index_02_slr2_71_enq_bits),
    .deq_valid(R_array_index_02_slr2_71_deq_valid),
    .deq_ready(R_array_index_02_slr2_71_deq_ready),
    .deq_bits(R_array_index_02_slr2_71_deq_bits)
  );
  q_R_array_index_slr0 q_R_array_index_slr0_127 ( // @[Top-slr.scala 374:44]
    .clock(q_R_array_index_slr0_127_clock),
    .reset(q_R_array_index_slr0_127_reset),
    .io_enq_ready(q_R_array_index_slr0_127_io_enq_ready),
    .io_enq_valid(q_R_array_index_slr0_127_io_enq_valid),
    .io_enq_bits(q_R_array_index_slr0_127_io_enq_bits),
    .io_deq_ready(q_R_array_index_slr0_127_io_deq_ready),
    .io_deq_valid(q_R_array_index_slr0_127_io_deq_valid),
    .io_deq_bits(q_R_array_index_slr0_127_io_deq_bits),
    .io_count(q_R_array_index_slr0_127_io_count)
  );
  assign io_ap_done = master_finish_count >= 8'hc8; // @[Top-slr.scala 95:20 Top-slr.scala 97:20]
  assign io_hbm_0_writeAddr_valid = SLR0_Mem_io_HBM_interface_0_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_0_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_0_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_0_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeData_valid = SLR0_Mem_io_HBM_interface_0_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeData_bits_data = SLR0_Mem_io_HBM_interface_0_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeData_bits_strb = SLR0_Mem_io_HBM_interface_0_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeData_bits_last = SLR0_Mem_io_HBM_interface_0_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_0_writeResp_ready = SLR0_Mem_io_HBM_interface_0_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_0_readAddr_valid = SLR0_Mem_io_HBM_interface_0_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_0_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_0_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_0_readAddr_bits_len = SLR0_Mem_io_HBM_interface_0_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_0_readAddr_bits_id = SLR0_Mem_io_HBM_interface_0_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_0_readData_ready = SLR0_Mem_io_HBM_interface_0_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeAddr_valid = SLR0_Mem_io_HBM_interface_1_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_1_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_1_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_1_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeData_valid = SLR0_Mem_io_HBM_interface_1_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeData_bits_data = SLR0_Mem_io_HBM_interface_1_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeData_bits_strb = SLR0_Mem_io_HBM_interface_1_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeData_bits_last = SLR0_Mem_io_HBM_interface_1_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_1_writeResp_ready = SLR0_Mem_io_HBM_interface_1_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_1_readAddr_valid = SLR0_Mem_io_HBM_interface_1_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_1_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_1_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_1_readAddr_bits_len = SLR0_Mem_io_HBM_interface_1_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_1_readAddr_bits_id = SLR0_Mem_io_HBM_interface_1_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_1_readData_ready = SLR0_Mem_io_HBM_interface_1_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeAddr_valid = SLR0_Mem_io_HBM_interface_2_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_2_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_2_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_2_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeData_valid = SLR0_Mem_io_HBM_interface_2_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeData_bits_data = SLR0_Mem_io_HBM_interface_2_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeData_bits_strb = SLR0_Mem_io_HBM_interface_2_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeData_bits_last = SLR0_Mem_io_HBM_interface_2_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_2_writeResp_ready = SLR0_Mem_io_HBM_interface_2_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_2_readAddr_valid = SLR0_Mem_io_HBM_interface_2_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_2_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_2_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_2_readAddr_bits_len = SLR0_Mem_io_HBM_interface_2_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_2_readAddr_bits_id = SLR0_Mem_io_HBM_interface_2_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_2_readData_ready = SLR0_Mem_io_HBM_interface_2_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeAddr_valid = SLR0_Mem_io_HBM_interface_3_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_3_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_3_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_3_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeData_valid = SLR0_Mem_io_HBM_interface_3_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeData_bits_data = SLR0_Mem_io_HBM_interface_3_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeData_bits_strb = SLR0_Mem_io_HBM_interface_3_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeData_bits_last = SLR0_Mem_io_HBM_interface_3_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_3_writeResp_ready = SLR0_Mem_io_HBM_interface_3_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_3_readAddr_valid = SLR0_Mem_io_HBM_interface_3_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_3_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_3_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_3_readAddr_bits_len = SLR0_Mem_io_HBM_interface_3_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_3_readAddr_bits_id = SLR0_Mem_io_HBM_interface_3_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_3_readData_ready = SLR0_Mem_io_HBM_interface_3_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeAddr_valid = SLR0_Mem_io_HBM_interface_4_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_4_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_4_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_4_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeData_valid = SLR0_Mem_io_HBM_interface_4_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeData_bits_data = SLR0_Mem_io_HBM_interface_4_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeData_bits_strb = SLR0_Mem_io_HBM_interface_4_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeData_bits_last = SLR0_Mem_io_HBM_interface_4_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_4_writeResp_ready = SLR0_Mem_io_HBM_interface_4_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_4_readAddr_valid = SLR0_Mem_io_HBM_interface_4_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_4_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_4_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_4_readAddr_bits_len = SLR0_Mem_io_HBM_interface_4_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_4_readAddr_bits_id = SLR0_Mem_io_HBM_interface_4_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_4_readData_ready = SLR0_Mem_io_HBM_interface_4_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeAddr_valid = SLR0_Mem_io_HBM_interface_5_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_5_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_5_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_5_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeData_valid = SLR0_Mem_io_HBM_interface_5_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeData_bits_data = SLR0_Mem_io_HBM_interface_5_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeData_bits_strb = SLR0_Mem_io_HBM_interface_5_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeData_bits_last = SLR0_Mem_io_HBM_interface_5_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_5_writeResp_ready = SLR0_Mem_io_HBM_interface_5_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_5_readAddr_valid = SLR0_Mem_io_HBM_interface_5_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_5_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_5_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_5_readAddr_bits_len = SLR0_Mem_io_HBM_interface_5_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_5_readAddr_bits_id = SLR0_Mem_io_HBM_interface_5_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_5_readData_ready = SLR0_Mem_io_HBM_interface_5_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeAddr_valid = SLR0_Mem_io_HBM_interface_6_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_6_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_6_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_6_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeData_valid = SLR0_Mem_io_HBM_interface_6_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeData_bits_data = SLR0_Mem_io_HBM_interface_6_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeData_bits_strb = SLR0_Mem_io_HBM_interface_6_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeData_bits_last = SLR0_Mem_io_HBM_interface_6_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_6_writeResp_ready = SLR0_Mem_io_HBM_interface_6_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_6_readAddr_valid = SLR0_Mem_io_HBM_interface_6_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_6_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_6_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_6_readAddr_bits_len = SLR0_Mem_io_HBM_interface_6_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_6_readAddr_bits_id = SLR0_Mem_io_HBM_interface_6_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_6_readData_ready = SLR0_Mem_io_HBM_interface_6_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeAddr_valid = SLR0_Mem_io_HBM_interface_7_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_7_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_7_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_7_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeData_valid = SLR0_Mem_io_HBM_interface_7_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeData_bits_data = SLR0_Mem_io_HBM_interface_7_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeData_bits_strb = SLR0_Mem_io_HBM_interface_7_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeData_bits_last = SLR0_Mem_io_HBM_interface_7_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_7_writeResp_ready = SLR0_Mem_io_HBM_interface_7_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_7_readAddr_valid = SLR0_Mem_io_HBM_interface_7_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_7_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_7_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_7_readAddr_bits_len = SLR0_Mem_io_HBM_interface_7_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_7_readAddr_bits_id = SLR0_Mem_io_HBM_interface_7_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_7_readData_ready = SLR0_Mem_io_HBM_interface_7_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeAddr_valid = SLR0_Mem_io_HBM_interface_8_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_8_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_8_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_8_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeData_valid = SLR0_Mem_io_HBM_interface_8_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeData_bits_data = SLR0_Mem_io_HBM_interface_8_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeData_bits_strb = SLR0_Mem_io_HBM_interface_8_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeData_bits_last = SLR0_Mem_io_HBM_interface_8_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_8_writeResp_ready = SLR0_Mem_io_HBM_interface_8_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_8_readAddr_valid = SLR0_Mem_io_HBM_interface_8_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_8_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_8_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_8_readAddr_bits_len = SLR0_Mem_io_HBM_interface_8_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_8_readAddr_bits_id = SLR0_Mem_io_HBM_interface_8_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_8_readData_ready = SLR0_Mem_io_HBM_interface_8_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeAddr_valid = SLR0_Mem_io_HBM_interface_9_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_9_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_9_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_9_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeData_valid = SLR0_Mem_io_HBM_interface_9_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeData_bits_data = SLR0_Mem_io_HBM_interface_9_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeData_bits_strb = SLR0_Mem_io_HBM_interface_9_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeData_bits_last = SLR0_Mem_io_HBM_interface_9_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_9_writeResp_ready = SLR0_Mem_io_HBM_interface_9_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_9_readAddr_valid = SLR0_Mem_io_HBM_interface_9_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_9_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_9_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_9_readAddr_bits_len = SLR0_Mem_io_HBM_interface_9_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_9_readAddr_bits_id = SLR0_Mem_io_HBM_interface_9_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_9_readData_ready = SLR0_Mem_io_HBM_interface_9_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeAddr_valid = SLR0_Mem_io_HBM_interface_10_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_10_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_10_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_10_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeData_valid = SLR0_Mem_io_HBM_interface_10_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeData_bits_data = SLR0_Mem_io_HBM_interface_10_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeData_bits_strb = SLR0_Mem_io_HBM_interface_10_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeData_bits_last = SLR0_Mem_io_HBM_interface_10_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_10_writeResp_ready = SLR0_Mem_io_HBM_interface_10_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_10_readAddr_valid = SLR0_Mem_io_HBM_interface_10_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_10_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_10_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_10_readAddr_bits_len = SLR0_Mem_io_HBM_interface_10_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_10_readAddr_bits_id = SLR0_Mem_io_HBM_interface_10_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_10_readData_ready = SLR0_Mem_io_HBM_interface_10_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeAddr_valid = SLR0_Mem_io_HBM_interface_11_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_11_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_11_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_11_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeData_valid = SLR0_Mem_io_HBM_interface_11_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeData_bits_data = SLR0_Mem_io_HBM_interface_11_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeData_bits_strb = SLR0_Mem_io_HBM_interface_11_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeData_bits_last = SLR0_Mem_io_HBM_interface_11_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_11_writeResp_ready = SLR0_Mem_io_HBM_interface_11_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_11_readAddr_valid = SLR0_Mem_io_HBM_interface_11_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_11_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_11_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_11_readAddr_bits_len = SLR0_Mem_io_HBM_interface_11_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_11_readAddr_bits_id = SLR0_Mem_io_HBM_interface_11_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_11_readData_ready = SLR0_Mem_io_HBM_interface_11_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeAddr_valid = SLR0_Mem_io_HBM_interface_12_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_12_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_12_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_12_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeData_valid = SLR0_Mem_io_HBM_interface_12_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeData_bits_data = SLR0_Mem_io_HBM_interface_12_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeData_bits_strb = SLR0_Mem_io_HBM_interface_12_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeData_bits_last = SLR0_Mem_io_HBM_interface_12_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_12_writeResp_ready = SLR0_Mem_io_HBM_interface_12_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_12_readAddr_valid = SLR0_Mem_io_HBM_interface_12_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_12_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_12_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_12_readAddr_bits_len = SLR0_Mem_io_HBM_interface_12_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_12_readAddr_bits_id = SLR0_Mem_io_HBM_interface_12_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_12_readData_ready = SLR0_Mem_io_HBM_interface_12_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeAddr_valid = SLR0_Mem_io_HBM_interface_13_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_13_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_13_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_13_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeData_valid = SLR0_Mem_io_HBM_interface_13_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeData_bits_data = SLR0_Mem_io_HBM_interface_13_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeData_bits_strb = SLR0_Mem_io_HBM_interface_13_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeData_bits_last = SLR0_Mem_io_HBM_interface_13_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_13_writeResp_ready = SLR0_Mem_io_HBM_interface_13_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_13_readAddr_valid = SLR0_Mem_io_HBM_interface_13_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_13_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_13_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_13_readAddr_bits_len = SLR0_Mem_io_HBM_interface_13_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_13_readAddr_bits_id = SLR0_Mem_io_HBM_interface_13_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_13_readData_ready = SLR0_Mem_io_HBM_interface_13_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeAddr_valid = SLR0_Mem_io_HBM_interface_14_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_14_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_14_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_14_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeData_valid = SLR0_Mem_io_HBM_interface_14_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeData_bits_data = SLR0_Mem_io_HBM_interface_14_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeData_bits_strb = SLR0_Mem_io_HBM_interface_14_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeData_bits_last = SLR0_Mem_io_HBM_interface_14_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_14_writeResp_ready = SLR0_Mem_io_HBM_interface_14_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_14_readAddr_valid = SLR0_Mem_io_HBM_interface_14_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_14_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_14_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_14_readAddr_bits_len = SLR0_Mem_io_HBM_interface_14_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_14_readAddr_bits_id = SLR0_Mem_io_HBM_interface_14_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_14_readData_ready = SLR0_Mem_io_HBM_interface_14_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeAddr_valid = SLR0_Mem_io_HBM_interface_15_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_15_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_15_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_15_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeData_valid = SLR0_Mem_io_HBM_interface_15_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeData_bits_data = SLR0_Mem_io_HBM_interface_15_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeData_bits_strb = SLR0_Mem_io_HBM_interface_15_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeData_bits_last = SLR0_Mem_io_HBM_interface_15_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_15_writeResp_ready = SLR0_Mem_io_HBM_interface_15_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_15_readAddr_valid = SLR0_Mem_io_HBM_interface_15_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_15_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_15_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_15_readAddr_bits_len = SLR0_Mem_io_HBM_interface_15_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_15_readAddr_bits_id = SLR0_Mem_io_HBM_interface_15_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_15_readData_ready = SLR0_Mem_io_HBM_interface_15_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeAddr_valid = SLR0_Mem_io_HBM_interface_16_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_16_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_16_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_16_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeData_valid = SLR0_Mem_io_HBM_interface_16_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeData_bits_data = SLR0_Mem_io_HBM_interface_16_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeData_bits_strb = SLR0_Mem_io_HBM_interface_16_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeData_bits_last = SLR0_Mem_io_HBM_interface_16_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_16_writeResp_ready = SLR0_Mem_io_HBM_interface_16_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_16_readAddr_valid = SLR0_Mem_io_HBM_interface_16_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_16_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_16_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_16_readAddr_bits_len = SLR0_Mem_io_HBM_interface_16_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_16_readAddr_bits_id = SLR0_Mem_io_HBM_interface_16_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_16_readData_ready = SLR0_Mem_io_HBM_interface_16_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeAddr_valid = SLR0_Mem_io_HBM_interface_17_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_17_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_17_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_17_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeData_valid = SLR0_Mem_io_HBM_interface_17_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeData_bits_data = SLR0_Mem_io_HBM_interface_17_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeData_bits_strb = SLR0_Mem_io_HBM_interface_17_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeData_bits_last = SLR0_Mem_io_HBM_interface_17_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_17_writeResp_ready = SLR0_Mem_io_HBM_interface_17_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_17_readAddr_valid = SLR0_Mem_io_HBM_interface_17_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_17_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_17_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_17_readAddr_bits_len = SLR0_Mem_io_HBM_interface_17_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_17_readAddr_bits_id = SLR0_Mem_io_HBM_interface_17_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_17_readData_ready = SLR0_Mem_io_HBM_interface_17_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeAddr_valid = SLR0_Mem_io_HBM_interface_18_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_18_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_18_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_18_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeData_valid = SLR0_Mem_io_HBM_interface_18_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeData_bits_data = SLR0_Mem_io_HBM_interface_18_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeData_bits_strb = SLR0_Mem_io_HBM_interface_18_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeData_bits_last = SLR0_Mem_io_HBM_interface_18_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_18_writeResp_ready = SLR0_Mem_io_HBM_interface_18_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_18_readAddr_valid = SLR0_Mem_io_HBM_interface_18_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_18_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_18_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_18_readAddr_bits_len = SLR0_Mem_io_HBM_interface_18_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_18_readAddr_bits_id = SLR0_Mem_io_HBM_interface_18_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_18_readData_ready = SLR0_Mem_io_HBM_interface_18_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeAddr_valid = SLR0_Mem_io_HBM_interface_19_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_19_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_19_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_19_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeData_valid = SLR0_Mem_io_HBM_interface_19_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeData_bits_data = SLR0_Mem_io_HBM_interface_19_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeData_bits_strb = SLR0_Mem_io_HBM_interface_19_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeData_bits_last = SLR0_Mem_io_HBM_interface_19_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_19_writeResp_ready = SLR0_Mem_io_HBM_interface_19_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_19_readAddr_valid = SLR0_Mem_io_HBM_interface_19_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_19_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_19_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_19_readAddr_bits_len = SLR0_Mem_io_HBM_interface_19_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_19_readAddr_bits_id = SLR0_Mem_io_HBM_interface_19_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_19_readData_ready = SLR0_Mem_io_HBM_interface_19_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeAddr_valid = SLR0_Mem_io_HBM_interface_20_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_20_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_20_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_20_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeData_valid = SLR0_Mem_io_HBM_interface_20_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeData_bits_data = SLR0_Mem_io_HBM_interface_20_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeData_bits_strb = SLR0_Mem_io_HBM_interface_20_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeData_bits_last = SLR0_Mem_io_HBM_interface_20_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_20_writeResp_ready = SLR0_Mem_io_HBM_interface_20_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_20_readAddr_valid = SLR0_Mem_io_HBM_interface_20_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_20_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_20_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_20_readAddr_bits_len = SLR0_Mem_io_HBM_interface_20_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_20_readAddr_bits_id = SLR0_Mem_io_HBM_interface_20_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_20_readData_ready = SLR0_Mem_io_HBM_interface_20_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeAddr_valid = SLR0_Mem_io_HBM_interface_21_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_21_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_21_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_21_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeData_valid = SLR0_Mem_io_HBM_interface_21_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeData_bits_data = SLR0_Mem_io_HBM_interface_21_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeData_bits_strb = SLR0_Mem_io_HBM_interface_21_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeData_bits_last = SLR0_Mem_io_HBM_interface_21_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_21_writeResp_ready = SLR0_Mem_io_HBM_interface_21_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_21_readAddr_valid = SLR0_Mem_io_HBM_interface_21_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_21_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_21_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_21_readAddr_bits_len = SLR0_Mem_io_HBM_interface_21_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_21_readAddr_bits_id = SLR0_Mem_io_HBM_interface_21_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_21_readData_ready = SLR0_Mem_io_HBM_interface_21_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeAddr_valid = SLR0_Mem_io_HBM_interface_22_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_22_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_22_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_22_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeData_valid = SLR0_Mem_io_HBM_interface_22_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeData_bits_data = SLR0_Mem_io_HBM_interface_22_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeData_bits_strb = SLR0_Mem_io_HBM_interface_22_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeData_bits_last = SLR0_Mem_io_HBM_interface_22_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_22_writeResp_ready = SLR0_Mem_io_HBM_interface_22_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_22_readAddr_valid = SLR0_Mem_io_HBM_interface_22_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_22_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_22_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_22_readAddr_bits_len = SLR0_Mem_io_HBM_interface_22_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_22_readAddr_bits_id = SLR0_Mem_io_HBM_interface_22_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_22_readData_ready = SLR0_Mem_io_HBM_interface_22_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeAddr_valid = SLR0_Mem_io_HBM_interface_23_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_23_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_23_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_23_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeData_valid = SLR0_Mem_io_HBM_interface_23_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeData_bits_data = SLR0_Mem_io_HBM_interface_23_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeData_bits_strb = SLR0_Mem_io_HBM_interface_23_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeData_bits_last = SLR0_Mem_io_HBM_interface_23_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_23_writeResp_ready = SLR0_Mem_io_HBM_interface_23_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_23_readAddr_valid = SLR0_Mem_io_HBM_interface_23_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_23_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_23_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_23_readAddr_bits_len = SLR0_Mem_io_HBM_interface_23_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_23_readAddr_bits_id = SLR0_Mem_io_HBM_interface_23_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_23_readData_ready = SLR0_Mem_io_HBM_interface_23_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeAddr_valid = SLR0_Mem_io_HBM_interface_24_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_24_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_24_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_24_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeData_valid = SLR0_Mem_io_HBM_interface_24_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeData_bits_data = SLR0_Mem_io_HBM_interface_24_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeData_bits_strb = SLR0_Mem_io_HBM_interface_24_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeData_bits_last = SLR0_Mem_io_HBM_interface_24_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_24_writeResp_ready = SLR0_Mem_io_HBM_interface_24_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_24_readAddr_valid = SLR0_Mem_io_HBM_interface_24_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_24_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_24_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_24_readAddr_bits_len = SLR0_Mem_io_HBM_interface_24_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_24_readAddr_bits_id = SLR0_Mem_io_HBM_interface_24_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_24_readData_ready = SLR0_Mem_io_HBM_interface_24_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeAddr_valid = SLR0_Mem_io_HBM_interface_25_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_25_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_25_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_25_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeData_valid = SLR0_Mem_io_HBM_interface_25_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeData_bits_data = SLR0_Mem_io_HBM_interface_25_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeData_bits_strb = SLR0_Mem_io_HBM_interface_25_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeData_bits_last = SLR0_Mem_io_HBM_interface_25_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_25_writeResp_ready = SLR0_Mem_io_HBM_interface_25_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_25_readAddr_valid = SLR0_Mem_io_HBM_interface_25_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_25_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_25_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_25_readAddr_bits_len = SLR0_Mem_io_HBM_interface_25_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_25_readAddr_bits_id = SLR0_Mem_io_HBM_interface_25_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_25_readData_ready = SLR0_Mem_io_HBM_interface_25_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeAddr_valid = SLR0_Mem_io_HBM_interface_26_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_26_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_26_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_26_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeData_valid = SLR0_Mem_io_HBM_interface_26_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeData_bits_data = SLR0_Mem_io_HBM_interface_26_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeData_bits_strb = SLR0_Mem_io_HBM_interface_26_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeData_bits_last = SLR0_Mem_io_HBM_interface_26_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_26_writeResp_ready = SLR0_Mem_io_HBM_interface_26_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_26_readAddr_valid = SLR0_Mem_io_HBM_interface_26_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_26_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_26_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_26_readAddr_bits_len = SLR0_Mem_io_HBM_interface_26_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_26_readAddr_bits_id = SLR0_Mem_io_HBM_interface_26_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_26_readData_ready = SLR0_Mem_io_HBM_interface_26_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeAddr_valid = SLR0_Mem_io_HBM_interface_27_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_27_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_27_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_27_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeData_valid = SLR0_Mem_io_HBM_interface_27_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeData_bits_data = SLR0_Mem_io_HBM_interface_27_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeData_bits_strb = SLR0_Mem_io_HBM_interface_27_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeData_bits_last = SLR0_Mem_io_HBM_interface_27_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_27_writeResp_ready = SLR0_Mem_io_HBM_interface_27_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_27_readAddr_valid = SLR0_Mem_io_HBM_interface_27_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_27_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_27_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_27_readAddr_bits_len = SLR0_Mem_io_HBM_interface_27_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_27_readAddr_bits_id = SLR0_Mem_io_HBM_interface_27_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_27_readData_ready = SLR0_Mem_io_HBM_interface_27_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeAddr_valid = SLR0_Mem_io_HBM_interface_28_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_28_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_28_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_28_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeData_valid = SLR0_Mem_io_HBM_interface_28_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeData_bits_data = SLR0_Mem_io_HBM_interface_28_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeData_bits_strb = SLR0_Mem_io_HBM_interface_28_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeData_bits_last = SLR0_Mem_io_HBM_interface_28_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_28_writeResp_ready = SLR0_Mem_io_HBM_interface_28_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_28_readAddr_valid = SLR0_Mem_io_HBM_interface_28_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_28_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_28_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_28_readAddr_bits_len = SLR0_Mem_io_HBM_interface_28_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_28_readAddr_bits_id = SLR0_Mem_io_HBM_interface_28_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_28_readData_ready = SLR0_Mem_io_HBM_interface_28_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeAddr_valid = SLR0_Mem_io_HBM_interface_29_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_29_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_29_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_29_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeData_valid = SLR0_Mem_io_HBM_interface_29_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeData_bits_data = SLR0_Mem_io_HBM_interface_29_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeData_bits_strb = SLR0_Mem_io_HBM_interface_29_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeData_bits_last = SLR0_Mem_io_HBM_interface_29_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_29_writeResp_ready = SLR0_Mem_io_HBM_interface_29_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_29_readAddr_valid = SLR0_Mem_io_HBM_interface_29_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_29_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_29_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_29_readAddr_bits_len = SLR0_Mem_io_HBM_interface_29_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_29_readAddr_bits_id = SLR0_Mem_io_HBM_interface_29_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_29_readData_ready = SLR0_Mem_io_HBM_interface_29_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeAddr_valid = SLR0_Mem_io_HBM_interface_30_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_30_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_30_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_30_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeData_valid = SLR0_Mem_io_HBM_interface_30_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeData_bits_data = SLR0_Mem_io_HBM_interface_30_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeData_bits_strb = SLR0_Mem_io_HBM_interface_30_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeData_bits_last = SLR0_Mem_io_HBM_interface_30_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_30_writeResp_ready = SLR0_Mem_io_HBM_interface_30_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_30_readAddr_valid = SLR0_Mem_io_HBM_interface_30_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_30_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_30_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_30_readAddr_bits_len = SLR0_Mem_io_HBM_interface_30_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_30_readAddr_bits_id = SLR0_Mem_io_HBM_interface_30_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_30_readData_ready = SLR0_Mem_io_HBM_interface_30_readData_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeAddr_valid = SLR0_Mem_io_HBM_interface_31_writeAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeAddr_bits_addr = SLR0_Mem_io_HBM_interface_31_writeAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeAddr_bits_len = SLR0_Mem_io_HBM_interface_31_writeAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeAddr_bits_id = SLR0_Mem_io_HBM_interface_31_writeAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeData_valid = SLR0_Mem_io_HBM_interface_31_writeData_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeData_bits_data = SLR0_Mem_io_HBM_interface_31_writeData_bits_data; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeData_bits_strb = SLR0_Mem_io_HBM_interface_31_writeData_bits_strb; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeData_bits_last = SLR0_Mem_io_HBM_interface_31_writeData_bits_last; // @[Top-slr.scala 119:38]
  assign io_hbm_31_writeResp_ready = SLR0_Mem_io_HBM_interface_31_writeResp_ready; // @[Top-slr.scala 119:38]
  assign io_hbm_31_readAddr_valid = SLR0_Mem_io_HBM_interface_31_readAddr_valid; // @[Top-slr.scala 119:38]
  assign io_hbm_31_readAddr_bits_addr = SLR0_Mem_io_HBM_interface_31_readAddr_bits_addr; // @[Top-slr.scala 119:38]
  assign io_hbm_31_readAddr_bits_len = SLR0_Mem_io_HBM_interface_31_readAddr_bits_len; // @[Top-slr.scala 119:38]
  assign io_hbm_31_readAddr_bits_id = SLR0_Mem_io_HBM_interface_31_readAddr_bits_id; // @[Top-slr.scala 119:38]
  assign io_hbm_31_readData_ready = SLR0_Mem_io_HBM_interface_31_readData_ready; // @[Top-slr.scala 119:38]
  assign master_clock = clock;
  assign master_reset = reset;
  assign master_io_global_start = start_state; // @[Top-slr.scala 182:28]
  assign master_io_mem_end_0 = _T_50; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_1 = _T_52; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_2 = _T_54; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_3 = _T_56; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_4 = _T_58; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_5 = _T_60; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_6 = _T_62; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_7 = _T_64; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_8 = _T_66; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_9 = _T_68; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_10 = _T_70; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_11 = _T_72; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_12 = _T_74; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_13 = _T_76; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_14 = _T_78; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_15 = _T_80; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_16 = _T_82; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_17 = _T_84; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_18 = _T_86; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_19 = _T_88; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_20 = _T_90; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_21 = _T_92; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_22 = _T_94; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_23 = _T_96; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_24 = _T_98; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_25 = _T_100; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_26 = _T_102; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_27 = _T_104; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_28 = _T_106; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_29 = _T_108; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_30 = _T_110; // @[Top-slr.scala 192:45]
  assign master_io_mem_end_31 = _T_112; // @[Top-slr.scala 192:45]
  assign master_io_end_0 = _T_114; // @[Top-slr.scala 206:69]
  assign master_io_end_1 = _T_120; // @[Top-slr.scala 206:69]
  assign master_io_end_2 = _T_126; // @[Top-slr.scala 206:69]
  assign master_io_end_3 = _T_132; // @[Top-slr.scala 206:69]
  assign master_io_end_4 = _T_138; // @[Top-slr.scala 206:69]
  assign master_io_end_5 = _T_144; // @[Top-slr.scala 206:69]
  assign master_io_end_6 = _T_150; // @[Top-slr.scala 206:69]
  assign master_io_end_7 = _T_156; // @[Top-slr.scala 206:69]
  assign master_io_end_8 = _T_162; // @[Top-slr.scala 206:69]
  assign master_io_end_9 = _T_168; // @[Top-slr.scala 206:69]
  assign master_io_end_10 = _T_174; // @[Top-slr.scala 206:69]
  assign master_io_end_11 = _T_180; // @[Top-slr.scala 206:69]
  assign master_io_end_12 = _T_186; // @[Top-slr.scala 206:69]
  assign master_io_end_13 = _T_192; // @[Top-slr.scala 206:69]
  assign master_io_end_14 = _T_198; // @[Top-slr.scala 214:93]
  assign master_io_end_15 = _T_204; // @[Top-slr.scala 214:93]
  assign master_io_end_16 = _T_210; // @[Top-slr.scala 214:93]
  assign master_io_end_17 = _T_216; // @[Top-slr.scala 214:93]
  assign master_io_end_18 = _T_222; // @[Top-slr.scala 214:93]
  assign master_io_end_19 = _T_228; // @[Top-slr.scala 214:93]
  assign master_io_end_20 = _T_234; // @[Top-slr.scala 214:93]
  assign master_io_end_21 = _T_240; // @[Top-slr.scala 214:93]
  assign master_io_end_22 = _T_246; // @[Top-slr.scala 214:93]
  assign master_io_end_23 = _T_252; // @[Top-slr.scala 214:93]
  assign master_io_end_24 = _T_258; // @[Top-slr.scala 214:93]
  assign master_io_end_25 = _T_264; // @[Top-slr.scala 214:93]
  assign master_io_end_26 = _T_270; // @[Top-slr.scala 214:93]
  assign master_io_end_27 = _T_276; // @[Top-slr.scala 214:93]
  assign master_io_end_28 = _T_282; // @[Top-slr.scala 214:93]
  assign master_io_end_29 = _T_288; // @[Top-slr.scala 214:93]
  assign master_io_end_30 = _T_294; // @[Top-slr.scala 214:93]
  assign master_io_end_31 = _T_300; // @[Top-slr.scala 214:93]
  assign master_io_p2_count_0 = _T_115; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_1 = _T_121; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_2 = _T_127; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_3 = _T_133; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_4 = _T_139; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_5 = _T_145; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_6 = _T_151; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_7 = _T_157; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_8 = _T_163; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_9 = _T_169; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_10 = _T_175; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_11 = _T_181; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_12 = _T_187; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_13 = _T_193; // @[Top-slr.scala 207:69]
  assign master_io_p2_count_14 = _T_199; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_15 = _T_205; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_16 = _T_211; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_17 = _T_217; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_18 = _T_223; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_19 = _T_229; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_20 = _T_235; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_21 = _T_241; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_22 = _T_247; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_23 = _T_253; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_24 = _T_259; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_25 = _T_265; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_26 = _T_271; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_27 = _T_277; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_28 = _T_283; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_29 = _T_289; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_30 = _T_295; // @[Top-slr.scala 215:93]
  assign master_io_p2_count_31 = _T_301; // @[Top-slr.scala 215:93]
  assign master_io_mem_count_0 = _T_51; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_1 = _T_53; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_2 = _T_55; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_3 = _T_57; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_4 = _T_59; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_5 = _T_61; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_6 = _T_63; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_7 = _T_65; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_8 = _T_67; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_9 = _T_69; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_10 = _T_71; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_11 = _T_73; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_12 = _T_75; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_13 = _T_77; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_14 = _T_79; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_15 = _T_81; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_16 = _T_83; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_17 = _T_85; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_18 = _T_87; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_19 = _T_89; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_20 = _T_91; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_21 = _T_93; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_22 = _T_95; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_23 = _T_97; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_24 = _T_99; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_25 = _T_101; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_26 = _T_103; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_27 = _T_105; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_28 = _T_107; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_29 = _T_109; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_30 = _T_111; // @[Top-slr.scala 193:45]
  assign master_io_mem_count_31 = _T_113; // @[Top-slr.scala 193:45]
  assign master_io_frontier_pull_count_0 = _T_117; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_1 = _T_123; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_2 = _T_129; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_3 = _T_135; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_4 = _T_141; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_5 = _T_147; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_6 = _T_153; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_7 = _T_159; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_8 = _T_165; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_9 = _T_171; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_10 = _T_177; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_11 = _T_183; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_12 = _T_189; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_13 = _T_195; // @[Top-slr.scala 209:69]
  assign master_io_frontier_pull_count_14 = _T_201; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_15 = _T_207; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_16 = _T_213; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_17 = _T_219; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_18 = _T_225; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_19 = _T_231; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_20 = _T_237; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_21 = _T_243; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_22 = _T_249; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_23 = _T_255; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_24 = _T_261; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_25 = _T_267; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_26 = _T_273; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_27 = _T_279; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_28 = _T_285; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_29 = _T_291; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_30 = _T_297; // @[Top-slr.scala 217:93]
  assign master_io_frontier_pull_count_31 = _T_303; // @[Top-slr.scala 217:93]
  assign master_io_p2_pull_count_0 = _T_116; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_1 = _T_122; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_2 = _T_128; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_3 = _T_134; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_4 = _T_140; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_5 = _T_146; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_6 = _T_152; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_7 = _T_158; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_8 = _T_164; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_9 = _T_170; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_10 = _T_176; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_11 = _T_182; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_12 = _T_188; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_13 = _T_194; // @[Top-slr.scala 208:69]
  assign master_io_p2_pull_count_14 = _T_200; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_15 = _T_206; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_16 = _T_212; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_17 = _T_218; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_18 = _T_224; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_19 = _T_230; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_20 = _T_236; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_21 = _T_242; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_22 = _T_248; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_23 = _T_254; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_24 = _T_260; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_25 = _T_266; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_26 = _T_272; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_27 = _T_278; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_28 = _T_284; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_29 = _T_290; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_30 = _T_296; // @[Top-slr.scala 216:93]
  assign master_io_p2_pull_count_31 = _T_302; // @[Top-slr.scala 216:93]
  assign master_io_last_iteration_state_0 = _T_118; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_1 = _T_124; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_2 = _T_130; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_3 = _T_136; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_4 = _T_142; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_5 = _T_148; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_6 = _T_154; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_7 = _T_160; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_8 = _T_166; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_9 = _T_172; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_10 = _T_178; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_11 = _T_184; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_12 = _T_190; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_13 = _T_196; // @[Top-slr.scala 210:69]
  assign master_io_last_iteration_state_14 = _T_202; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_15 = _T_208; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_16 = _T_214; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_17 = _T_220; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_18 = _T_226; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_19 = _T_232; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_20 = _T_238; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_21 = _T_244; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_22 = _T_250; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_23 = _T_256; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_24 = _T_262; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_25 = _T_268; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_26 = _T_274; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_27 = _T_280; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_28 = _T_286; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_29 = _T_292; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_30 = _T_298; // @[Top-slr.scala 218:93]
  assign master_io_last_iteration_state_31 = _T_304; // @[Top-slr.scala 218:93]
  assign master_io_levels_push_to_pull_level = _T_48_push_to_pull_level; // @[Top-slr.scala 180:22]
  assign master_io_levels_pull_to_push_level = _T_48_pull_to_push_level; // @[Top-slr.scala 180:22]
  assign master_io_init_bram_0 = _T_119; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_1 = _T_125; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_2 = _T_131; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_3 = _T_137; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_4 = _T_143; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_5 = _T_149; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_6 = _T_155; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_7 = _T_161; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_8 = _T_167; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_9 = _T_173; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_10 = _T_179; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_11 = _T_185; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_12 = _T_191; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_13 = _T_197; // @[Top-slr.scala 211:69]
  assign master_io_init_bram_14 = _T_203; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_15 = _T_209; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_16 = _T_215; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_17 = _T_221; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_18 = _T_227; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_19 = _T_233; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_20 = _T_239; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_21 = _T_245; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_22 = _T_251; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_23 = _T_257; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_24 = _T_263; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_25 = _T_269; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_26 = _T_275; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_27 = _T_281; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_28 = _T_287; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_29 = _T_293; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_30 = _T_299; // @[Top-slr.scala 219:93]
  assign master_io_init_bram_31 = _T_305; // @[Top-slr.scala 219:93]
  assign SLR0_Mem_clock = clock;
  assign SLR0_Mem_reset = reset;
  assign SLR0_Mem_io_level = current_level_0_r; // @[Top-slr.scala 111:38]
  assign SLR0_Mem_io_kernel_count = kernel_count; // @[Top-slr.scala 112:38]
  assign SLR0_Mem_io_mem_clock = io_mem_clock; // @[Top-slr.scala 113:38]
  assign SLR0_Mem_io_reset_h = io_reset_h; // @[Top-slr.scala 114:38]
  assign SLR0_Mem_io_master_finish = _T_40; // @[Top-slr.scala 115:38]
  assign SLR0_Mem_io_node_num = node_num_0_r; // @[Top-slr.scala 116:38]
  assign SLR0_Mem_io_push_or_pull_state = push_or_pull_0_r; // @[Top-slr.scala 117:38]
  assign SLR0_Mem_io_offsets_CSR_R_offset = _T_41_CSR_R_offset; // @[Top-slr.scala 118:38]
  assign SLR0_Mem_io_offsets_CSR_C_offset = _T_41_CSR_C_offset; // @[Top-slr.scala 118:38]
  assign SLR0_Mem_io_offsets_CSC_R_offset = _T_41_CSC_R_offset; // @[Top-slr.scala 118:38]
  assign SLR0_Mem_io_offsets_CSC_C_offset = _T_41_CSC_C_offset; // @[Top-slr.scala 118:38]
  assign SLR0_Mem_io_offsets_level_offset = _T_41_level_offset; // @[Top-slr.scala 118:38]
  assign SLR0_Mem_io_R_array_index_0_valid = q_R_array_index_slr0_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_0_bits = q_R_array_index_slr0_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_1_valid = q_R_array_index_slr0_1_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_1_bits = q_R_array_index_slr0_1_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_2_valid = q_R_array_index_slr0_2_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_2_bits = q_R_array_index_slr0_2_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_3_valid = q_R_array_index_slr0_3_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_3_bits = q_R_array_index_slr0_3_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_4_valid = q_R_array_index_slr0_4_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_4_bits = q_R_array_index_slr0_4_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_5_valid = q_R_array_index_slr0_5_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_5_bits = q_R_array_index_slr0_5_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_6_valid = q_R_array_index_slr0_6_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_6_bits = q_R_array_index_slr0_6_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_7_valid = q_R_array_index_slr0_7_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_7_bits = q_R_array_index_slr0_7_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_8_valid = q_R_array_index_slr0_8_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_8_bits = q_R_array_index_slr0_8_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_9_valid = q_R_array_index_slr0_9_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_9_bits = q_R_array_index_slr0_9_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_10_valid = q_R_array_index_slr0_10_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_10_bits = q_R_array_index_slr0_10_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_11_valid = q_R_array_index_slr0_11_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_11_bits = q_R_array_index_slr0_11_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_12_valid = q_R_array_index_slr0_12_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_12_bits = q_R_array_index_slr0_12_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_13_valid = q_R_array_index_slr0_13_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_13_bits = q_R_array_index_slr0_13_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_14_valid = q_R_array_index_slr0_14_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_14_bits = q_R_array_index_slr0_14_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_15_valid = q_R_array_index_slr0_15_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_15_bits = q_R_array_index_slr0_15_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_16_valid = q_R_array_index_slr0_16_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_16_bits = q_R_array_index_slr0_16_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_17_valid = q_R_array_index_slr0_17_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_17_bits = q_R_array_index_slr0_17_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_18_valid = q_R_array_index_slr0_18_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_18_bits = q_R_array_index_slr0_18_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_19_valid = q_R_array_index_slr0_19_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_19_bits = q_R_array_index_slr0_19_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_20_valid = q_R_array_index_slr0_20_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_20_bits = q_R_array_index_slr0_20_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_21_valid = q_R_array_index_slr0_21_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_21_bits = q_R_array_index_slr0_21_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_22_valid = q_R_array_index_slr0_22_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_22_bits = q_R_array_index_slr0_22_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_23_valid = q_R_array_index_slr0_23_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_23_bits = q_R_array_index_slr0_23_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_24_valid = q_R_array_index_slr0_24_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_24_bits = q_R_array_index_slr0_24_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_25_valid = q_R_array_index_slr0_25_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_25_bits = q_R_array_index_slr0_25_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_26_valid = q_R_array_index_slr0_26_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_26_bits = q_R_array_index_slr0_26_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_27_valid = q_R_array_index_slr0_27_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_27_bits = q_R_array_index_slr0_27_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_28_valid = q_R_array_index_slr0_28_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_28_bits = q_R_array_index_slr0_28_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_29_valid = q_R_array_index_slr0_29_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_29_bits = q_R_array_index_slr0_29_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_30_valid = q_R_array_index_slr0_30_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_30_bits = q_R_array_index_slr0_30_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_31_valid = q_R_array_index_slr0_31_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_31_bits = q_R_array_index_slr0_31_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_32_valid = q_R_array_index_slr0_32_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_32_bits = q_R_array_index_slr0_32_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_33_valid = q_R_array_index_slr0_33_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_33_bits = q_R_array_index_slr0_33_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_34_valid = q_R_array_index_slr0_34_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_34_bits = q_R_array_index_slr0_34_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_35_valid = q_R_array_index_slr0_35_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_35_bits = q_R_array_index_slr0_35_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_36_valid = q_R_array_index_slr0_36_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_36_bits = q_R_array_index_slr0_36_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_37_valid = q_R_array_index_slr0_37_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_37_bits = q_R_array_index_slr0_37_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_38_valid = q_R_array_index_slr0_38_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_38_bits = q_R_array_index_slr0_38_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_39_valid = q_R_array_index_slr0_39_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_39_bits = q_R_array_index_slr0_39_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_40_valid = q_R_array_index_slr0_40_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_40_bits = q_R_array_index_slr0_40_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_41_valid = q_R_array_index_slr0_41_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_41_bits = q_R_array_index_slr0_41_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_42_valid = q_R_array_index_slr0_42_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_42_bits = q_R_array_index_slr0_42_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_43_valid = q_R_array_index_slr0_43_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_43_bits = q_R_array_index_slr0_43_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_44_valid = q_R_array_index_slr0_44_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_44_bits = q_R_array_index_slr0_44_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_45_valid = q_R_array_index_slr0_45_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_45_bits = q_R_array_index_slr0_45_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_46_valid = q_R_array_index_slr0_46_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_46_bits = q_R_array_index_slr0_46_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_47_valid = q_R_array_index_slr0_47_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_47_bits = q_R_array_index_slr0_47_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_48_valid = q_R_array_index_slr0_48_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_48_bits = q_R_array_index_slr0_48_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_49_valid = q_R_array_index_slr0_49_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_49_bits = q_R_array_index_slr0_49_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_50_valid = q_R_array_index_slr0_50_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_50_bits = q_R_array_index_slr0_50_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_51_valid = q_R_array_index_slr0_51_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_51_bits = q_R_array_index_slr0_51_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_52_valid = q_R_array_index_slr0_52_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_52_bits = q_R_array_index_slr0_52_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_53_valid = q_R_array_index_slr0_53_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_53_bits = q_R_array_index_slr0_53_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_54_valid = q_R_array_index_slr0_54_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_54_bits = q_R_array_index_slr0_54_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_55_valid = q_R_array_index_slr0_55_io_deq_valid; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_55_bits = q_R_array_index_slr0_55_io_deq_bits; // @[Top-slr.scala 296:90]
  assign SLR0_Mem_io_R_array_index_56_valid = q_R_array_index_slr0_56_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_56_bits = q_R_array_index_slr0_56_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_57_valid = q_R_array_index_slr0_57_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_57_bits = q_R_array_index_slr0_57_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_58_valid = q_R_array_index_slr0_58_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_58_bits = q_R_array_index_slr0_58_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_59_valid = q_R_array_index_slr0_59_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_59_bits = q_R_array_index_slr0_59_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_60_valid = q_R_array_index_slr0_60_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_60_bits = q_R_array_index_slr0_60_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_61_valid = q_R_array_index_slr0_61_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_61_bits = q_R_array_index_slr0_61_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_62_valid = q_R_array_index_slr0_62_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_62_bits = q_R_array_index_slr0_62_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_63_valid = q_R_array_index_slr0_63_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_63_bits = q_R_array_index_slr0_63_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_64_valid = q_R_array_index_slr0_64_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_64_bits = q_R_array_index_slr0_64_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_65_valid = q_R_array_index_slr0_65_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_65_bits = q_R_array_index_slr0_65_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_66_valid = q_R_array_index_slr0_66_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_66_bits = q_R_array_index_slr0_66_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_67_valid = q_R_array_index_slr0_67_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_67_bits = q_R_array_index_slr0_67_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_68_valid = q_R_array_index_slr0_68_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_68_bits = q_R_array_index_slr0_68_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_69_valid = q_R_array_index_slr0_69_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_69_bits = q_R_array_index_slr0_69_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_70_valid = q_R_array_index_slr0_70_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_70_bits = q_R_array_index_slr0_70_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_71_valid = q_R_array_index_slr0_71_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_71_bits = q_R_array_index_slr0_71_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_72_valid = q_R_array_index_slr0_72_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_72_bits = q_R_array_index_slr0_72_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_73_valid = q_R_array_index_slr0_73_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_73_bits = q_R_array_index_slr0_73_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_74_valid = q_R_array_index_slr0_74_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_74_bits = q_R_array_index_slr0_74_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_75_valid = q_R_array_index_slr0_75_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_75_bits = q_R_array_index_slr0_75_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_76_valid = q_R_array_index_slr0_76_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_76_bits = q_R_array_index_slr0_76_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_77_valid = q_R_array_index_slr0_77_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_77_bits = q_R_array_index_slr0_77_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_78_valid = q_R_array_index_slr0_78_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_78_bits = q_R_array_index_slr0_78_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_79_valid = q_R_array_index_slr0_79_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_79_bits = q_R_array_index_slr0_79_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_80_valid = q_R_array_index_slr0_80_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_80_bits = q_R_array_index_slr0_80_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_81_valid = q_R_array_index_slr0_81_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_81_bits = q_R_array_index_slr0_81_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_82_valid = q_R_array_index_slr0_82_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_82_bits = q_R_array_index_slr0_82_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_83_valid = q_R_array_index_slr0_83_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_83_bits = q_R_array_index_slr0_83_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_84_valid = q_R_array_index_slr0_84_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_84_bits = q_R_array_index_slr0_84_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_85_valid = q_R_array_index_slr0_85_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_85_bits = q_R_array_index_slr0_85_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_86_valid = q_R_array_index_slr0_86_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_86_bits = q_R_array_index_slr0_86_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_87_valid = q_R_array_index_slr0_87_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_87_bits = q_R_array_index_slr0_87_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_88_valid = q_R_array_index_slr0_88_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_88_bits = q_R_array_index_slr0_88_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_89_valid = q_R_array_index_slr0_89_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_89_bits = q_R_array_index_slr0_89_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_90_valid = q_R_array_index_slr0_90_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_90_bits = q_R_array_index_slr0_90_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_91_valid = q_R_array_index_slr0_91_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_91_bits = q_R_array_index_slr0_91_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_92_valid = q_R_array_index_slr0_92_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_92_bits = q_R_array_index_slr0_92_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_93_valid = q_R_array_index_slr0_93_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_93_bits = q_R_array_index_slr0_93_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_94_valid = q_R_array_index_slr0_94_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_94_bits = q_R_array_index_slr0_94_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_95_valid = q_R_array_index_slr0_95_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_95_bits = q_R_array_index_slr0_95_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_96_valid = q_R_array_index_slr0_96_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_96_bits = q_R_array_index_slr0_96_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_97_valid = q_R_array_index_slr0_97_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_97_bits = q_R_array_index_slr0_97_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_98_valid = q_R_array_index_slr0_98_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_98_bits = q_R_array_index_slr0_98_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_99_valid = q_R_array_index_slr0_99_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_99_bits = q_R_array_index_slr0_99_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_100_valid = q_R_array_index_slr0_100_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_100_bits = q_R_array_index_slr0_100_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_101_valid = q_R_array_index_slr0_101_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_101_bits = q_R_array_index_slr0_101_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_102_valid = q_R_array_index_slr0_102_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_102_bits = q_R_array_index_slr0_102_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_103_valid = q_R_array_index_slr0_103_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_103_bits = q_R_array_index_slr0_103_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_104_valid = q_R_array_index_slr0_104_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_104_bits = q_R_array_index_slr0_104_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_105_valid = q_R_array_index_slr0_105_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_105_bits = q_R_array_index_slr0_105_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_106_valid = q_R_array_index_slr0_106_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_106_bits = q_R_array_index_slr0_106_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_107_valid = q_R_array_index_slr0_107_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_107_bits = q_R_array_index_slr0_107_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_108_valid = q_R_array_index_slr0_108_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_108_bits = q_R_array_index_slr0_108_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_109_valid = q_R_array_index_slr0_109_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_109_bits = q_R_array_index_slr0_109_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_110_valid = q_R_array_index_slr0_110_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_110_bits = q_R_array_index_slr0_110_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_111_valid = q_R_array_index_slr0_111_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_111_bits = q_R_array_index_slr0_111_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_112_valid = q_R_array_index_slr0_112_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_112_bits = q_R_array_index_slr0_112_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_113_valid = q_R_array_index_slr0_113_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_113_bits = q_R_array_index_slr0_113_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_114_valid = q_R_array_index_slr0_114_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_114_bits = q_R_array_index_slr0_114_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_115_valid = q_R_array_index_slr0_115_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_115_bits = q_R_array_index_slr0_115_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_116_valid = q_R_array_index_slr0_116_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_116_bits = q_R_array_index_slr0_116_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_117_valid = q_R_array_index_slr0_117_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_117_bits = q_R_array_index_slr0_117_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_118_valid = q_R_array_index_slr0_118_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_118_bits = q_R_array_index_slr0_118_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_119_valid = q_R_array_index_slr0_119_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_119_bits = q_R_array_index_slr0_119_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_120_valid = q_R_array_index_slr0_120_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_120_bits = q_R_array_index_slr0_120_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_121_valid = q_R_array_index_slr0_121_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_121_bits = q_R_array_index_slr0_121_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_122_valid = q_R_array_index_slr0_122_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_122_bits = q_R_array_index_slr0_122_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_123_valid = q_R_array_index_slr0_123_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_123_bits = q_R_array_index_slr0_123_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_124_valid = q_R_array_index_slr0_124_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_124_bits = q_R_array_index_slr0_124_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_125_valid = q_R_array_index_slr0_125_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_125_bits = q_R_array_index_slr0_125_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_126_valid = q_R_array_index_slr0_126_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_126_bits = q_R_array_index_slr0_126_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_127_valid = q_R_array_index_slr0_127_io_deq_valid; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_R_array_index_127_bits = q_R_array_index_slr0_127_io_deq_bits; // @[Top-slr.scala 394:116]
  assign SLR0_Mem_io_p1_end_0 = p1_end_q_01_slr0_0; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_1 = p1_end_q_01_slr0_1; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_2 = p1_end_q_01_slr0_2; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_3 = p1_end_q_01_slr0_3; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_4 = p1_end_q_01_slr0_4; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_5 = p1_end_q_01_slr0_5; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_6 = p1_end_q_01_slr0_6; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_7 = p1_end_q_01_slr0_7; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_8 = p1_end_q_01_slr0_8; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_9 = p1_end_q_01_slr0_9; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_10 = p1_end_q_01_slr0_10; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_11 = p1_end_q_01_slr0_11; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_12 = p1_end_q_01_slr0_12; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_13 = p1_end_q_01_slr0_13; // @[Top-slr.scala 243:55]
  assign SLR0_Mem_io_p1_end_14 = p1_end_q_02_slr0_0; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_15 = p1_end_q_02_slr0_1; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_16 = p1_end_q_02_slr0_2; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_17 = p1_end_q_02_slr0_3; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_18 = p1_end_q_02_slr0_4; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_19 = p1_end_q_02_slr0_5; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_20 = p1_end_q_02_slr0_6; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_21 = p1_end_q_02_slr0_7; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_22 = p1_end_q_02_slr0_8; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_23 = p1_end_q_02_slr0_9; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_24 = p1_end_q_02_slr0_10; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_25 = p1_end_q_02_slr0_11; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_26 = p1_end_q_02_slr0_12; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_27 = p1_end_q_02_slr0_13; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_28 = p1_end_q_02_slr0_14; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_29 = p1_end_q_02_slr0_15; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_30 = p1_end_q_02_slr0_16; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_p1_end_31 = p1_end_q_02_slr0_17; // @[Top-slr.scala 334:79]
  assign SLR0_Mem_io_uram_out_a_0 = uram_out_a_01_slr0_1_0; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_1 = uram_out_a_01_slr0_1_1; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_2 = uram_out_a_01_slr0_1_2; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_3 = uram_out_a_01_slr0_1_3; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_4 = uram_out_a_01_slr0_1_4; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_5 = uram_out_a_01_slr0_1_5; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_6 = uram_out_a_01_slr0_1_6; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_7 = uram_out_a_01_slr0_1_7; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_8 = uram_out_a_01_slr0_1_8; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_9 = uram_out_a_01_slr0_1_9; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_10 = uram_out_a_01_slr0_1_10; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_11 = uram_out_a_01_slr0_1_11; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_12 = uram_out_a_01_slr0_1_12; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_13 = uram_out_a_01_slr0_1_13; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_14 = uram_out_a_01_slr0_1_14; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_15 = uram_out_a_01_slr0_1_15; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_16 = uram_out_a_01_slr0_1_16; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_17 = uram_out_a_01_slr0_1_17; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_18 = uram_out_a_01_slr0_1_18; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_19 = uram_out_a_01_slr0_1_19; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_20 = uram_out_a_01_slr0_1_20; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_21 = uram_out_a_01_slr0_1_21; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_22 = uram_out_a_01_slr0_1_22; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_23 = uram_out_a_01_slr0_1_23; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_24 = uram_out_a_01_slr0_1_24; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_25 = uram_out_a_01_slr0_1_25; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_26 = uram_out_a_01_slr0_1_26; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_27 = uram_out_a_01_slr0_1_27; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_28 = uram_out_a_01_slr0_1_28; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_29 = uram_out_a_01_slr0_1_29; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_30 = uram_out_a_01_slr0_1_30; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_31 = uram_out_a_01_slr0_1_31; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_32 = uram_out_a_01_slr0_1_32; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_33 = uram_out_a_01_slr0_1_33; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_34 = uram_out_a_01_slr0_1_34; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_35 = uram_out_a_01_slr0_1_35; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_36 = uram_out_a_01_slr0_1_36; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_37 = uram_out_a_01_slr0_1_37; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_38 = uram_out_a_01_slr0_1_38; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_39 = uram_out_a_01_slr0_1_39; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_40 = uram_out_a_01_slr0_1_40; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_41 = uram_out_a_01_slr0_1_41; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_42 = uram_out_a_01_slr0_1_42; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_43 = uram_out_a_01_slr0_1_43; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_44 = uram_out_a_01_slr0_1_44; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_45 = uram_out_a_01_slr0_1_45; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_46 = uram_out_a_01_slr0_1_46; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_47 = uram_out_a_01_slr0_1_47; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_48 = uram_out_a_01_slr0_1_48; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_49 = uram_out_a_01_slr0_1_49; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_50 = uram_out_a_01_slr0_1_50; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_51 = uram_out_a_01_slr0_1_51; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_52 = uram_out_a_01_slr0_1_52; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_53 = uram_out_a_01_slr0_1_53; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_54 = uram_out_a_01_slr0_1_54; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_55 = uram_out_a_01_slr0_1_55; // @[Top-slr.scala 258:87]
  assign SLR0_Mem_io_uram_out_a_56 = uram_out_a_02_slr0_0; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_57 = uram_out_a_02_slr0_1; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_58 = uram_out_a_02_slr0_2; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_59 = uram_out_a_02_slr0_3; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_60 = uram_out_a_02_slr0_4; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_61 = uram_out_a_02_slr0_5; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_62 = uram_out_a_02_slr0_6; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_63 = uram_out_a_02_slr0_7; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_64 = uram_out_a_02_slr0_8; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_65 = uram_out_a_02_slr0_9; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_66 = uram_out_a_02_slr0_10; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_67 = uram_out_a_02_slr0_11; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_68 = uram_out_a_02_slr0_12; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_69 = uram_out_a_02_slr0_13; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_70 = uram_out_a_02_slr0_14; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_71 = uram_out_a_02_slr0_15; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_72 = uram_out_a_02_slr0_16; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_73 = uram_out_a_02_slr0_17; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_74 = uram_out_a_02_slr0_18; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_75 = uram_out_a_02_slr0_19; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_76 = uram_out_a_02_slr0_20; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_77 = uram_out_a_02_slr0_21; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_78 = uram_out_a_02_slr0_22; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_79 = uram_out_a_02_slr0_23; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_80 = uram_out_a_02_slr0_24; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_81 = uram_out_a_02_slr0_25; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_82 = uram_out_a_02_slr0_26; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_83 = uram_out_a_02_slr0_27; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_84 = uram_out_a_02_slr0_28; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_85 = uram_out_a_02_slr0_29; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_86 = uram_out_a_02_slr0_30; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_87 = uram_out_a_02_slr0_31; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_88 = uram_out_a_02_slr0_32; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_89 = uram_out_a_02_slr0_33; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_90 = uram_out_a_02_slr0_34; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_91 = uram_out_a_02_slr0_35; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_92 = uram_out_a_02_slr0_36; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_93 = uram_out_a_02_slr0_37; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_94 = uram_out_a_02_slr0_38; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_95 = uram_out_a_02_slr0_39; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_96 = uram_out_a_02_slr0_40; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_97 = uram_out_a_02_slr0_41; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_98 = uram_out_a_02_slr0_42; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_99 = uram_out_a_02_slr0_43; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_100 = uram_out_a_02_slr0_44; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_101 = uram_out_a_02_slr0_45; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_102 = uram_out_a_02_slr0_46; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_103 = uram_out_a_02_slr0_47; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_104 = uram_out_a_02_slr0_48; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_105 = uram_out_a_02_slr0_49; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_106 = uram_out_a_02_slr0_50; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_107 = uram_out_a_02_slr0_51; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_108 = uram_out_a_02_slr0_52; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_109 = uram_out_a_02_slr0_53; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_110 = uram_out_a_02_slr0_54; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_111 = uram_out_a_02_slr0_55; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_112 = uram_out_a_02_slr0_56; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_113 = uram_out_a_02_slr0_57; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_114 = uram_out_a_02_slr0_58; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_115 = uram_out_a_02_slr0_59; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_116 = uram_out_a_02_slr0_60; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_117 = uram_out_a_02_slr0_61; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_118 = uram_out_a_02_slr0_62; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_119 = uram_out_a_02_slr0_63; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_120 = uram_out_a_02_slr0_64; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_121 = uram_out_a_02_slr0_65; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_122 = uram_out_a_02_slr0_66; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_123 = uram_out_a_02_slr0_67; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_124 = uram_out_a_02_slr0_68; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_125 = uram_out_a_02_slr0_69; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_126 = uram_out_a_02_slr0_70; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_uram_out_a_127 = uram_out_a_02_slr0_71; // @[Top-slr.scala 349:113]
  assign SLR0_Mem_io_neighbours_0_ready = crossbar_array_mem_io_in_0_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_1_ready = crossbar_array_mem_io_in_1_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_2_ready = crossbar_array_mem_io_in_2_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_3_ready = crossbar_array_mem_io_in_3_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_4_ready = crossbar_array_mem_io_in_4_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_5_ready = crossbar_array_mem_io_in_5_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_6_ready = crossbar_array_mem_io_in_6_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_7_ready = crossbar_array_mem_io_in_7_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_8_ready = crossbar_array_mem_io_in_8_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_9_ready = crossbar_array_mem_io_in_9_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_10_ready = crossbar_array_mem_io_in_10_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_11_ready = crossbar_array_mem_io_in_11_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_12_ready = crossbar_array_mem_io_in_12_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_13_ready = crossbar_array_mem_io_in_13_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_14_ready = crossbar_array_mem_io_in_14_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_15_ready = crossbar_array_mem_io_in_15_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_16_ready = crossbar_array_mem_io_in_16_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_17_ready = crossbar_array_mem_io_in_17_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_18_ready = crossbar_array_mem_io_in_18_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_19_ready = crossbar_array_mem_io_in_19_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_20_ready = crossbar_array_mem_io_in_20_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_21_ready = crossbar_array_mem_io_in_21_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_22_ready = crossbar_array_mem_io_in_22_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_23_ready = crossbar_array_mem_io_in_23_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_24_ready = crossbar_array_mem_io_in_24_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_25_ready = crossbar_array_mem_io_in_25_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_26_ready = crossbar_array_mem_io_in_26_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_27_ready = crossbar_array_mem_io_in_27_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_28_ready = crossbar_array_mem_io_in_28_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_29_ready = crossbar_array_mem_io_in_29_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_30_ready = crossbar_array_mem_io_in_30_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_31_ready = crossbar_array_mem_io_in_31_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_32_ready = crossbar_array_mem_io_in_32_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_33_ready = crossbar_array_mem_io_in_33_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_34_ready = crossbar_array_mem_io_in_34_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_35_ready = crossbar_array_mem_io_in_35_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_36_ready = crossbar_array_mem_io_in_36_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_37_ready = crossbar_array_mem_io_in_37_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_38_ready = crossbar_array_mem_io_in_38_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_39_ready = crossbar_array_mem_io_in_39_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_40_ready = crossbar_array_mem_io_in_40_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_41_ready = crossbar_array_mem_io_in_41_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_42_ready = crossbar_array_mem_io_in_42_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_43_ready = crossbar_array_mem_io_in_43_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_44_ready = crossbar_array_mem_io_in_44_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_45_ready = crossbar_array_mem_io_in_45_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_46_ready = crossbar_array_mem_io_in_46_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_47_ready = crossbar_array_mem_io_in_47_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_48_ready = crossbar_array_mem_io_in_48_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_49_ready = crossbar_array_mem_io_in_49_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_50_ready = crossbar_array_mem_io_in_50_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_51_ready = crossbar_array_mem_io_in_51_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_52_ready = crossbar_array_mem_io_in_52_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_53_ready = crossbar_array_mem_io_in_53_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_54_ready = crossbar_array_mem_io_in_54_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_55_ready = crossbar_array_mem_io_in_55_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_56_ready = crossbar_array_mem_io_in_56_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_57_ready = crossbar_array_mem_io_in_57_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_58_ready = crossbar_array_mem_io_in_58_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_59_ready = crossbar_array_mem_io_in_59_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_60_ready = crossbar_array_mem_io_in_60_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_61_ready = crossbar_array_mem_io_in_61_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_62_ready = crossbar_array_mem_io_in_62_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_63_ready = crossbar_array_mem_io_in_63_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_64_ready = crossbar_array_mem_io_in_64_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_65_ready = crossbar_array_mem_io_in_65_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_66_ready = crossbar_array_mem_io_in_66_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_67_ready = crossbar_array_mem_io_in_67_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_68_ready = crossbar_array_mem_io_in_68_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_69_ready = crossbar_array_mem_io_in_69_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_70_ready = crossbar_array_mem_io_in_70_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_71_ready = crossbar_array_mem_io_in_71_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_72_ready = crossbar_array_mem_io_in_72_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_73_ready = crossbar_array_mem_io_in_73_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_74_ready = crossbar_array_mem_io_in_74_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_75_ready = crossbar_array_mem_io_in_75_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_76_ready = crossbar_array_mem_io_in_76_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_77_ready = crossbar_array_mem_io_in_77_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_78_ready = crossbar_array_mem_io_in_78_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_79_ready = crossbar_array_mem_io_in_79_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_80_ready = crossbar_array_mem_io_in_80_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_81_ready = crossbar_array_mem_io_in_81_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_82_ready = crossbar_array_mem_io_in_82_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_83_ready = crossbar_array_mem_io_in_83_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_84_ready = crossbar_array_mem_io_in_84_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_85_ready = crossbar_array_mem_io_in_85_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_86_ready = crossbar_array_mem_io_in_86_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_87_ready = crossbar_array_mem_io_in_87_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_88_ready = crossbar_array_mem_io_in_88_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_89_ready = crossbar_array_mem_io_in_89_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_90_ready = crossbar_array_mem_io_in_90_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_91_ready = crossbar_array_mem_io_in_91_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_92_ready = crossbar_array_mem_io_in_92_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_93_ready = crossbar_array_mem_io_in_93_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_94_ready = crossbar_array_mem_io_in_94_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_95_ready = crossbar_array_mem_io_in_95_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_96_ready = crossbar_array_mem_io_in_96_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_97_ready = crossbar_array_mem_io_in_97_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_98_ready = crossbar_array_mem_io_in_98_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_99_ready = crossbar_array_mem_io_in_99_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_100_ready = crossbar_array_mem_io_in_100_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_101_ready = crossbar_array_mem_io_in_101_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_102_ready = crossbar_array_mem_io_in_102_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_103_ready = crossbar_array_mem_io_in_103_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_104_ready = crossbar_array_mem_io_in_104_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_105_ready = crossbar_array_mem_io_in_105_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_106_ready = crossbar_array_mem_io_in_106_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_107_ready = crossbar_array_mem_io_in_107_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_108_ready = crossbar_array_mem_io_in_108_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_109_ready = crossbar_array_mem_io_in_109_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_110_ready = crossbar_array_mem_io_in_110_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_111_ready = crossbar_array_mem_io_in_111_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_112_ready = crossbar_array_mem_io_in_112_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_113_ready = crossbar_array_mem_io_in_113_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_114_ready = crossbar_array_mem_io_in_114_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_115_ready = crossbar_array_mem_io_in_115_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_116_ready = crossbar_array_mem_io_in_116_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_117_ready = crossbar_array_mem_io_in_117_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_118_ready = crossbar_array_mem_io_in_118_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_119_ready = crossbar_array_mem_io_in_119_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_120_ready = crossbar_array_mem_io_in_120_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_121_ready = crossbar_array_mem_io_in_121_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_122_ready = crossbar_array_mem_io_in_122_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_123_ready = crossbar_array_mem_io_in_123_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_124_ready = crossbar_array_mem_io_in_124_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_125_ready = crossbar_array_mem_io_in_125_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_126_ready = crossbar_array_mem_io_in_126_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_neighbours_127_ready = crossbar_array_mem_io_in_127_ready; // @[Top-slr.scala 424:38]
  assign SLR0_Mem_io_HBM_interface_0_writeAddr_ready = io_hbm_0_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_writeData_ready = io_hbm_0_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_writeResp_valid = io_hbm_0_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_writeResp_bits_id = io_hbm_0_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_writeResp_bits_resp = io_hbm_0_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readAddr_ready = io_hbm_0_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readData_valid = io_hbm_0_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readData_bits_data = io_hbm_0_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readData_bits_id = io_hbm_0_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readData_bits_last = io_hbm_0_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_0_readData_bits_resp = io_hbm_0_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_writeAddr_ready = io_hbm_1_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_writeData_ready = io_hbm_1_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_writeResp_valid = io_hbm_1_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_writeResp_bits_id = io_hbm_1_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_writeResp_bits_resp = io_hbm_1_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readAddr_ready = io_hbm_1_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readData_valid = io_hbm_1_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readData_bits_data = io_hbm_1_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readData_bits_id = io_hbm_1_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readData_bits_last = io_hbm_1_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_1_readData_bits_resp = io_hbm_1_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_writeAddr_ready = io_hbm_2_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_writeData_ready = io_hbm_2_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_writeResp_valid = io_hbm_2_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_writeResp_bits_id = io_hbm_2_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_writeResp_bits_resp = io_hbm_2_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readAddr_ready = io_hbm_2_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readData_valid = io_hbm_2_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readData_bits_data = io_hbm_2_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readData_bits_id = io_hbm_2_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readData_bits_last = io_hbm_2_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_2_readData_bits_resp = io_hbm_2_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_writeAddr_ready = io_hbm_3_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_writeData_ready = io_hbm_3_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_writeResp_valid = io_hbm_3_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_writeResp_bits_id = io_hbm_3_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_writeResp_bits_resp = io_hbm_3_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readAddr_ready = io_hbm_3_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readData_valid = io_hbm_3_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readData_bits_data = io_hbm_3_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readData_bits_id = io_hbm_3_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readData_bits_last = io_hbm_3_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_3_readData_bits_resp = io_hbm_3_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_writeAddr_ready = io_hbm_4_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_writeData_ready = io_hbm_4_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_writeResp_valid = io_hbm_4_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_writeResp_bits_id = io_hbm_4_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_writeResp_bits_resp = io_hbm_4_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readAddr_ready = io_hbm_4_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readData_valid = io_hbm_4_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readData_bits_data = io_hbm_4_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readData_bits_id = io_hbm_4_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readData_bits_last = io_hbm_4_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_4_readData_bits_resp = io_hbm_4_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_writeAddr_ready = io_hbm_5_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_writeData_ready = io_hbm_5_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_writeResp_valid = io_hbm_5_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_writeResp_bits_id = io_hbm_5_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_writeResp_bits_resp = io_hbm_5_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readAddr_ready = io_hbm_5_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readData_valid = io_hbm_5_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readData_bits_data = io_hbm_5_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readData_bits_id = io_hbm_5_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readData_bits_last = io_hbm_5_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_5_readData_bits_resp = io_hbm_5_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_writeAddr_ready = io_hbm_6_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_writeData_ready = io_hbm_6_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_writeResp_valid = io_hbm_6_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_writeResp_bits_id = io_hbm_6_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_writeResp_bits_resp = io_hbm_6_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readAddr_ready = io_hbm_6_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readData_valid = io_hbm_6_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readData_bits_data = io_hbm_6_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readData_bits_id = io_hbm_6_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readData_bits_last = io_hbm_6_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_6_readData_bits_resp = io_hbm_6_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_writeAddr_ready = io_hbm_7_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_writeData_ready = io_hbm_7_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_writeResp_valid = io_hbm_7_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_writeResp_bits_id = io_hbm_7_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_writeResp_bits_resp = io_hbm_7_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readAddr_ready = io_hbm_7_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readData_valid = io_hbm_7_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readData_bits_data = io_hbm_7_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readData_bits_id = io_hbm_7_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readData_bits_last = io_hbm_7_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_7_readData_bits_resp = io_hbm_7_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_writeAddr_ready = io_hbm_8_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_writeData_ready = io_hbm_8_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_writeResp_valid = io_hbm_8_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_writeResp_bits_id = io_hbm_8_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_writeResp_bits_resp = io_hbm_8_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readAddr_ready = io_hbm_8_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readData_valid = io_hbm_8_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readData_bits_data = io_hbm_8_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readData_bits_id = io_hbm_8_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readData_bits_last = io_hbm_8_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_8_readData_bits_resp = io_hbm_8_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_writeAddr_ready = io_hbm_9_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_writeData_ready = io_hbm_9_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_writeResp_valid = io_hbm_9_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_writeResp_bits_id = io_hbm_9_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_writeResp_bits_resp = io_hbm_9_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readAddr_ready = io_hbm_9_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readData_valid = io_hbm_9_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readData_bits_data = io_hbm_9_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readData_bits_id = io_hbm_9_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readData_bits_last = io_hbm_9_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_9_readData_bits_resp = io_hbm_9_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_writeAddr_ready = io_hbm_10_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_writeData_ready = io_hbm_10_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_writeResp_valid = io_hbm_10_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_writeResp_bits_id = io_hbm_10_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_writeResp_bits_resp = io_hbm_10_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readAddr_ready = io_hbm_10_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readData_valid = io_hbm_10_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readData_bits_data = io_hbm_10_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readData_bits_id = io_hbm_10_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readData_bits_last = io_hbm_10_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_10_readData_bits_resp = io_hbm_10_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_writeAddr_ready = io_hbm_11_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_writeData_ready = io_hbm_11_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_writeResp_valid = io_hbm_11_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_writeResp_bits_id = io_hbm_11_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_writeResp_bits_resp = io_hbm_11_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readAddr_ready = io_hbm_11_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readData_valid = io_hbm_11_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readData_bits_data = io_hbm_11_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readData_bits_id = io_hbm_11_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readData_bits_last = io_hbm_11_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_11_readData_bits_resp = io_hbm_11_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_writeAddr_ready = io_hbm_12_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_writeData_ready = io_hbm_12_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_writeResp_valid = io_hbm_12_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_writeResp_bits_id = io_hbm_12_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_writeResp_bits_resp = io_hbm_12_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readAddr_ready = io_hbm_12_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readData_valid = io_hbm_12_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readData_bits_data = io_hbm_12_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readData_bits_id = io_hbm_12_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readData_bits_last = io_hbm_12_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_12_readData_bits_resp = io_hbm_12_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_writeAddr_ready = io_hbm_13_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_writeData_ready = io_hbm_13_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_writeResp_valid = io_hbm_13_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_writeResp_bits_id = io_hbm_13_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_writeResp_bits_resp = io_hbm_13_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readAddr_ready = io_hbm_13_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readData_valid = io_hbm_13_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readData_bits_data = io_hbm_13_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readData_bits_id = io_hbm_13_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readData_bits_last = io_hbm_13_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_13_readData_bits_resp = io_hbm_13_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_writeAddr_ready = io_hbm_14_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_writeData_ready = io_hbm_14_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_writeResp_valid = io_hbm_14_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_writeResp_bits_id = io_hbm_14_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_writeResp_bits_resp = io_hbm_14_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readAddr_ready = io_hbm_14_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readData_valid = io_hbm_14_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readData_bits_data = io_hbm_14_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readData_bits_id = io_hbm_14_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readData_bits_last = io_hbm_14_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_14_readData_bits_resp = io_hbm_14_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_writeAddr_ready = io_hbm_15_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_writeData_ready = io_hbm_15_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_writeResp_valid = io_hbm_15_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_writeResp_bits_id = io_hbm_15_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_writeResp_bits_resp = io_hbm_15_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readAddr_ready = io_hbm_15_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readData_valid = io_hbm_15_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readData_bits_data = io_hbm_15_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readData_bits_id = io_hbm_15_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readData_bits_last = io_hbm_15_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_15_readData_bits_resp = io_hbm_15_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_writeAddr_ready = io_hbm_16_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_writeData_ready = io_hbm_16_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_writeResp_valid = io_hbm_16_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_writeResp_bits_id = io_hbm_16_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_writeResp_bits_resp = io_hbm_16_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readAddr_ready = io_hbm_16_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readData_valid = io_hbm_16_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readData_bits_data = io_hbm_16_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readData_bits_id = io_hbm_16_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readData_bits_last = io_hbm_16_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_16_readData_bits_resp = io_hbm_16_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_writeAddr_ready = io_hbm_17_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_writeData_ready = io_hbm_17_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_writeResp_valid = io_hbm_17_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_writeResp_bits_id = io_hbm_17_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_writeResp_bits_resp = io_hbm_17_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readAddr_ready = io_hbm_17_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readData_valid = io_hbm_17_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readData_bits_data = io_hbm_17_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readData_bits_id = io_hbm_17_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readData_bits_last = io_hbm_17_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_17_readData_bits_resp = io_hbm_17_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_writeAddr_ready = io_hbm_18_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_writeData_ready = io_hbm_18_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_writeResp_valid = io_hbm_18_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_writeResp_bits_id = io_hbm_18_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_writeResp_bits_resp = io_hbm_18_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readAddr_ready = io_hbm_18_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readData_valid = io_hbm_18_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readData_bits_data = io_hbm_18_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readData_bits_id = io_hbm_18_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readData_bits_last = io_hbm_18_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_18_readData_bits_resp = io_hbm_18_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_writeAddr_ready = io_hbm_19_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_writeData_ready = io_hbm_19_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_writeResp_valid = io_hbm_19_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_writeResp_bits_id = io_hbm_19_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_writeResp_bits_resp = io_hbm_19_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readAddr_ready = io_hbm_19_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readData_valid = io_hbm_19_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readData_bits_data = io_hbm_19_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readData_bits_id = io_hbm_19_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readData_bits_last = io_hbm_19_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_19_readData_bits_resp = io_hbm_19_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_writeAddr_ready = io_hbm_20_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_writeData_ready = io_hbm_20_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_writeResp_valid = io_hbm_20_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_writeResp_bits_id = io_hbm_20_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_writeResp_bits_resp = io_hbm_20_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readAddr_ready = io_hbm_20_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readData_valid = io_hbm_20_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readData_bits_data = io_hbm_20_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readData_bits_id = io_hbm_20_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readData_bits_last = io_hbm_20_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_20_readData_bits_resp = io_hbm_20_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_writeAddr_ready = io_hbm_21_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_writeData_ready = io_hbm_21_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_writeResp_valid = io_hbm_21_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_writeResp_bits_id = io_hbm_21_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_writeResp_bits_resp = io_hbm_21_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readAddr_ready = io_hbm_21_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readData_valid = io_hbm_21_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readData_bits_data = io_hbm_21_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readData_bits_id = io_hbm_21_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readData_bits_last = io_hbm_21_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_21_readData_bits_resp = io_hbm_21_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_writeAddr_ready = io_hbm_22_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_writeData_ready = io_hbm_22_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_writeResp_valid = io_hbm_22_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_writeResp_bits_id = io_hbm_22_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_writeResp_bits_resp = io_hbm_22_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readAddr_ready = io_hbm_22_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readData_valid = io_hbm_22_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readData_bits_data = io_hbm_22_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readData_bits_id = io_hbm_22_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readData_bits_last = io_hbm_22_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_22_readData_bits_resp = io_hbm_22_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_writeAddr_ready = io_hbm_23_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_writeData_ready = io_hbm_23_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_writeResp_valid = io_hbm_23_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_writeResp_bits_id = io_hbm_23_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_writeResp_bits_resp = io_hbm_23_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readAddr_ready = io_hbm_23_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readData_valid = io_hbm_23_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readData_bits_data = io_hbm_23_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readData_bits_id = io_hbm_23_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readData_bits_last = io_hbm_23_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_23_readData_bits_resp = io_hbm_23_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_writeAddr_ready = io_hbm_24_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_writeData_ready = io_hbm_24_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_writeResp_valid = io_hbm_24_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_writeResp_bits_id = io_hbm_24_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_writeResp_bits_resp = io_hbm_24_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readAddr_ready = io_hbm_24_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readData_valid = io_hbm_24_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readData_bits_data = io_hbm_24_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readData_bits_id = io_hbm_24_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readData_bits_last = io_hbm_24_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_24_readData_bits_resp = io_hbm_24_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_writeAddr_ready = io_hbm_25_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_writeData_ready = io_hbm_25_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_writeResp_valid = io_hbm_25_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_writeResp_bits_id = io_hbm_25_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_writeResp_bits_resp = io_hbm_25_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readAddr_ready = io_hbm_25_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readData_valid = io_hbm_25_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readData_bits_data = io_hbm_25_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readData_bits_id = io_hbm_25_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readData_bits_last = io_hbm_25_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_25_readData_bits_resp = io_hbm_25_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_writeAddr_ready = io_hbm_26_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_writeData_ready = io_hbm_26_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_writeResp_valid = io_hbm_26_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_writeResp_bits_id = io_hbm_26_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_writeResp_bits_resp = io_hbm_26_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readAddr_ready = io_hbm_26_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readData_valid = io_hbm_26_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readData_bits_data = io_hbm_26_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readData_bits_id = io_hbm_26_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readData_bits_last = io_hbm_26_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_26_readData_bits_resp = io_hbm_26_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_writeAddr_ready = io_hbm_27_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_writeData_ready = io_hbm_27_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_writeResp_valid = io_hbm_27_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_writeResp_bits_id = io_hbm_27_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_writeResp_bits_resp = io_hbm_27_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readAddr_ready = io_hbm_27_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readData_valid = io_hbm_27_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readData_bits_data = io_hbm_27_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readData_bits_id = io_hbm_27_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readData_bits_last = io_hbm_27_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_27_readData_bits_resp = io_hbm_27_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_writeAddr_ready = io_hbm_28_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_writeData_ready = io_hbm_28_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_writeResp_valid = io_hbm_28_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_writeResp_bits_id = io_hbm_28_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_writeResp_bits_resp = io_hbm_28_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readAddr_ready = io_hbm_28_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readData_valid = io_hbm_28_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readData_bits_data = io_hbm_28_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readData_bits_id = io_hbm_28_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readData_bits_last = io_hbm_28_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_28_readData_bits_resp = io_hbm_28_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_writeAddr_ready = io_hbm_29_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_writeData_ready = io_hbm_29_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_writeResp_valid = io_hbm_29_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_writeResp_bits_id = io_hbm_29_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_writeResp_bits_resp = io_hbm_29_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readAddr_ready = io_hbm_29_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readData_valid = io_hbm_29_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readData_bits_data = io_hbm_29_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readData_bits_id = io_hbm_29_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readData_bits_last = io_hbm_29_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_29_readData_bits_resp = io_hbm_29_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_writeAddr_ready = io_hbm_30_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_writeData_ready = io_hbm_30_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_writeResp_valid = io_hbm_30_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_writeResp_bits_id = io_hbm_30_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_writeResp_bits_resp = io_hbm_30_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readAddr_ready = io_hbm_30_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readData_valid = io_hbm_30_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readData_bits_data = io_hbm_30_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readData_bits_id = io_hbm_30_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readData_bits_last = io_hbm_30_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_30_readData_bits_resp = io_hbm_30_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_writeAddr_ready = io_hbm_31_writeAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_writeData_ready = io_hbm_31_writeData_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_writeResp_valid = io_hbm_31_writeResp_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_writeResp_bits_id = io_hbm_31_writeResp_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_writeResp_bits_resp = io_hbm_31_writeResp_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readAddr_ready = io_hbm_31_readAddr_ready; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readData_valid = io_hbm_31_readData_valid; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readData_bits_data = io_hbm_31_readData_bits_data; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readData_bits_id = io_hbm_31_readData_bits_id; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readData_bits_last = io_hbm_31_readData_bits_last; // @[Top-slr.scala 119:38]
  assign SLR0_Mem_io_HBM_interface_31_readData_bits_resp = io_hbm_31_readData_bits_resp; // @[Top-slr.scala 119:38]
  assign SLR1_clock = clock;
  assign SLR1_reset = reset;
  assign SLR1_io_p2_end = p2_end_1_r; // @[Top-slr.scala 144:34]
  assign SLR1_io_start = start_1_r; // @[Top-slr.scala 145:34]
  assign SLR1_io_frontier_flag = frontier_flag_1_r; // @[Top-slr.scala 146:34]
  assign SLR1_io_level = current_level_1_r; // @[Top-slr.scala 147:34]
  assign SLR1_io_offsets_CSR_R_offset = _T_42_CSR_R_offset; // @[Top-slr.scala 148:34]
  assign SLR1_io_offsets_CSR_C_offset = _T_42_CSR_C_offset; // @[Top-slr.scala 148:34]
  assign SLR1_io_offsets_CSC_R_offset = _T_42_CSC_R_offset; // @[Top-slr.scala 148:34]
  assign SLR1_io_offsets_CSC_C_offset = _T_42_CSC_C_offset; // @[Top-slr.scala 148:34]
  assign SLR1_io_offsets_level_offset = _T_42_level_offset; // @[Top-slr.scala 148:34]
  assign SLR1_io_node_num = node_num_1_r; // @[Top-slr.scala 149:34]
  assign SLR1_io_root = _T_43; // @[Top-slr.scala 150:34]
  assign SLR1_io_push_or_pull = push_or_pull_1_r; // @[Top-slr.scala 151:34]
  assign SLR1_io_start_init = _T_44; // @[Top-slr.scala 152:34]
  assign SLR1_io_p2_in_0_valid = crossbar_array_mem_io_out_0_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_0_bits = {{16'd0}, crossbar_array_mem_io_out_0_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_1_valid = crossbar_array_mem_io_out_32_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_1_bits = {{16'd0}, crossbar_array_mem_io_out_32_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_2_valid = crossbar_array_mem_io_out_64_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_2_bits = {{16'd0}, crossbar_array_mem_io_out_64_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_3_valid = crossbar_array_mem_io_out_96_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_3_bits = {{16'd0}, crossbar_array_mem_io_out_96_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_4_valid = crossbar_array_mem_io_out_1_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_4_bits = {{16'd0}, crossbar_array_mem_io_out_1_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_5_valid = crossbar_array_mem_io_out_33_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_5_bits = {{16'd0}, crossbar_array_mem_io_out_33_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_6_valid = crossbar_array_mem_io_out_65_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_6_bits = {{16'd0}, crossbar_array_mem_io_out_65_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_7_valid = crossbar_array_mem_io_out_97_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_7_bits = {{16'd0}, crossbar_array_mem_io_out_97_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_8_valid = crossbar_array_mem_io_out_2_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_8_bits = {{16'd0}, crossbar_array_mem_io_out_2_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_9_valid = crossbar_array_mem_io_out_34_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_9_bits = {{16'd0}, crossbar_array_mem_io_out_34_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_10_valid = crossbar_array_mem_io_out_66_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_10_bits = {{16'd0}, crossbar_array_mem_io_out_66_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_11_valid = crossbar_array_mem_io_out_98_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_11_bits = {{16'd0}, crossbar_array_mem_io_out_98_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_12_valid = crossbar_array_mem_io_out_3_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_12_bits = {{16'd0}, crossbar_array_mem_io_out_3_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_13_valid = crossbar_array_mem_io_out_35_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_13_bits = {{16'd0}, crossbar_array_mem_io_out_35_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_14_valid = crossbar_array_mem_io_out_67_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_14_bits = {{16'd0}, crossbar_array_mem_io_out_67_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_15_valid = crossbar_array_mem_io_out_99_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_15_bits = {{16'd0}, crossbar_array_mem_io_out_99_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_16_valid = crossbar_array_mem_io_out_4_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_16_bits = {{16'd0}, crossbar_array_mem_io_out_4_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_17_valid = crossbar_array_mem_io_out_36_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_17_bits = {{16'd0}, crossbar_array_mem_io_out_36_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_18_valid = crossbar_array_mem_io_out_68_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_18_bits = {{16'd0}, crossbar_array_mem_io_out_68_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_19_valid = crossbar_array_mem_io_out_100_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_19_bits = {{16'd0}, crossbar_array_mem_io_out_100_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_20_valid = crossbar_array_mem_io_out_5_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_20_bits = {{16'd0}, crossbar_array_mem_io_out_5_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_21_valid = crossbar_array_mem_io_out_37_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_21_bits = {{16'd0}, crossbar_array_mem_io_out_37_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_22_valid = crossbar_array_mem_io_out_69_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_22_bits = {{16'd0}, crossbar_array_mem_io_out_69_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_23_valid = crossbar_array_mem_io_out_101_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_23_bits = {{16'd0}, crossbar_array_mem_io_out_101_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_24_valid = crossbar_array_mem_io_out_6_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_24_bits = {{16'd0}, crossbar_array_mem_io_out_6_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_25_valid = crossbar_array_mem_io_out_38_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_25_bits = {{16'd0}, crossbar_array_mem_io_out_38_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_26_valid = crossbar_array_mem_io_out_70_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_26_bits = {{16'd0}, crossbar_array_mem_io_out_70_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_27_valid = crossbar_array_mem_io_out_102_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_27_bits = {{16'd0}, crossbar_array_mem_io_out_102_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_28_valid = crossbar_array_mem_io_out_7_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_28_bits = {{16'd0}, crossbar_array_mem_io_out_7_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_29_valid = crossbar_array_mem_io_out_39_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_29_bits = {{16'd0}, crossbar_array_mem_io_out_39_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_30_valid = crossbar_array_mem_io_out_71_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_30_bits = {{16'd0}, crossbar_array_mem_io_out_71_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_31_valid = crossbar_array_mem_io_out_103_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_31_bits = {{16'd0}, crossbar_array_mem_io_out_103_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_32_valid = crossbar_array_mem_io_out_8_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_32_bits = {{16'd0}, crossbar_array_mem_io_out_8_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_33_valid = crossbar_array_mem_io_out_40_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_33_bits = {{16'd0}, crossbar_array_mem_io_out_40_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_34_valid = crossbar_array_mem_io_out_72_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_34_bits = {{16'd0}, crossbar_array_mem_io_out_72_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_35_valid = crossbar_array_mem_io_out_104_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_35_bits = {{16'd0}, crossbar_array_mem_io_out_104_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_36_valid = crossbar_array_mem_io_out_9_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_36_bits = {{16'd0}, crossbar_array_mem_io_out_9_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_37_valid = crossbar_array_mem_io_out_41_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_37_bits = {{16'd0}, crossbar_array_mem_io_out_41_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_38_valid = crossbar_array_mem_io_out_73_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_38_bits = {{16'd0}, crossbar_array_mem_io_out_73_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_39_valid = crossbar_array_mem_io_out_105_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_39_bits = {{16'd0}, crossbar_array_mem_io_out_105_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_40_valid = crossbar_array_mem_io_out_10_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_40_bits = {{16'd0}, crossbar_array_mem_io_out_10_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_41_valid = crossbar_array_mem_io_out_42_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_41_bits = {{16'd0}, crossbar_array_mem_io_out_42_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_42_valid = crossbar_array_mem_io_out_74_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_42_bits = {{16'd0}, crossbar_array_mem_io_out_74_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_43_valid = crossbar_array_mem_io_out_106_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_43_bits = {{16'd0}, crossbar_array_mem_io_out_106_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_44_valid = crossbar_array_mem_io_out_11_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_44_bits = {{16'd0}, crossbar_array_mem_io_out_11_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_45_valid = crossbar_array_mem_io_out_43_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_45_bits = {{16'd0}, crossbar_array_mem_io_out_43_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_46_valid = crossbar_array_mem_io_out_75_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_46_bits = {{16'd0}, crossbar_array_mem_io_out_75_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_47_valid = crossbar_array_mem_io_out_107_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_47_bits = {{16'd0}, crossbar_array_mem_io_out_107_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_48_valid = crossbar_array_mem_io_out_12_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_48_bits = {{16'd0}, crossbar_array_mem_io_out_12_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_49_valid = crossbar_array_mem_io_out_44_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_49_bits = {{16'd0}, crossbar_array_mem_io_out_44_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_50_valid = crossbar_array_mem_io_out_76_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_50_bits = {{16'd0}, crossbar_array_mem_io_out_76_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_51_valid = crossbar_array_mem_io_out_108_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_51_bits = {{16'd0}, crossbar_array_mem_io_out_108_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_52_valid = crossbar_array_mem_io_out_13_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_52_bits = {{16'd0}, crossbar_array_mem_io_out_13_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_53_valid = crossbar_array_mem_io_out_45_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_53_bits = {{16'd0}, crossbar_array_mem_io_out_45_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_54_valid = crossbar_array_mem_io_out_77_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_54_bits = {{16'd0}, crossbar_array_mem_io_out_77_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_55_valid = crossbar_array_mem_io_out_109_valid; // @[Top-slr.scala 465:66]
  assign SLR1_io_p2_in_55_bits = {{16'd0}, crossbar_array_mem_io_out_109_bits}; // @[Top-slr.scala 465:66]
  assign SLR1_io_frontier_in_0_valid = _T_1672 ? SLR1_io_p2_out_0_valid : crossbar_array_visit_io_out_0_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_0_bits = _T_1672 ? SLR1_io_p2_out_0_bits : {{8'd0}, crossbar_array_visit_io_out_0_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_1_valid = _T_1674 ? SLR1_io_p2_out_1_valid : crossbar_array_visit_io_out_32_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_1_bits = _T_1674 ? SLR1_io_p2_out_1_bits : {{8'd0}, crossbar_array_visit_io_out_32_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_2_valid = _T_1676 ? SLR1_io_p2_out_2_valid : crossbar_array_visit_io_out_64_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_2_bits = _T_1676 ? SLR1_io_p2_out_2_bits : {{8'd0}, crossbar_array_visit_io_out_64_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_3_valid = _T_1678 ? SLR1_io_p2_out_3_valid : crossbar_array_visit_io_out_96_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_3_bits = _T_1678 ? SLR1_io_p2_out_3_bits : {{8'd0}, crossbar_array_visit_io_out_96_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_4_valid = _T_1680 ? SLR1_io_p2_out_4_valid : crossbar_array_visit_io_out_1_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_4_bits = _T_1680 ? SLR1_io_p2_out_4_bits : {{8'd0}, crossbar_array_visit_io_out_1_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_5_valid = _T_1682 ? SLR1_io_p2_out_5_valid : crossbar_array_visit_io_out_33_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_5_bits = _T_1682 ? SLR1_io_p2_out_5_bits : {{8'd0}, crossbar_array_visit_io_out_33_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_6_valid = _T_1684 ? SLR1_io_p2_out_6_valid : crossbar_array_visit_io_out_65_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_6_bits = _T_1684 ? SLR1_io_p2_out_6_bits : {{8'd0}, crossbar_array_visit_io_out_65_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_7_valid = _T_1686 ? SLR1_io_p2_out_7_valid : crossbar_array_visit_io_out_97_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_7_bits = _T_1686 ? SLR1_io_p2_out_7_bits : {{8'd0}, crossbar_array_visit_io_out_97_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_8_valid = _T_1688 ? SLR1_io_p2_out_8_valid : crossbar_array_visit_io_out_2_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_8_bits = _T_1688 ? SLR1_io_p2_out_8_bits : {{8'd0}, crossbar_array_visit_io_out_2_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_9_valid = _T_1690 ? SLR1_io_p2_out_9_valid : crossbar_array_visit_io_out_34_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_9_bits = _T_1690 ? SLR1_io_p2_out_9_bits : {{8'd0}, crossbar_array_visit_io_out_34_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_10_valid = _T_1692 ? SLR1_io_p2_out_10_valid : crossbar_array_visit_io_out_66_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_10_bits = _T_1692 ? SLR1_io_p2_out_10_bits : {{8'd0}, crossbar_array_visit_io_out_66_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_11_valid = _T_1694 ? SLR1_io_p2_out_11_valid : crossbar_array_visit_io_out_98_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_11_bits = _T_1694 ? SLR1_io_p2_out_11_bits : {{8'd0}, crossbar_array_visit_io_out_98_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_12_valid = _T_1696 ? SLR1_io_p2_out_12_valid : crossbar_array_visit_io_out_3_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_12_bits = _T_1696 ? SLR1_io_p2_out_12_bits : {{8'd0}, crossbar_array_visit_io_out_3_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_13_valid = _T_1698 ? SLR1_io_p2_out_13_valid : crossbar_array_visit_io_out_35_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_13_bits = _T_1698 ? SLR1_io_p2_out_13_bits : {{8'd0}, crossbar_array_visit_io_out_35_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_14_valid = _T_1700 ? SLR1_io_p2_out_14_valid : crossbar_array_visit_io_out_67_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_14_bits = _T_1700 ? SLR1_io_p2_out_14_bits : {{8'd0}, crossbar_array_visit_io_out_67_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_15_valid = _T_1702 ? SLR1_io_p2_out_15_valid : crossbar_array_visit_io_out_99_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_15_bits = _T_1702 ? SLR1_io_p2_out_15_bits : {{8'd0}, crossbar_array_visit_io_out_99_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_16_valid = _T_1704 ? SLR1_io_p2_out_16_valid : crossbar_array_visit_io_out_4_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_16_bits = _T_1704 ? SLR1_io_p2_out_16_bits : {{8'd0}, crossbar_array_visit_io_out_4_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_17_valid = _T_1706 ? SLR1_io_p2_out_17_valid : crossbar_array_visit_io_out_36_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_17_bits = _T_1706 ? SLR1_io_p2_out_17_bits : {{8'd0}, crossbar_array_visit_io_out_36_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_18_valid = _T_1708 ? SLR1_io_p2_out_18_valid : crossbar_array_visit_io_out_68_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_18_bits = _T_1708 ? SLR1_io_p2_out_18_bits : {{8'd0}, crossbar_array_visit_io_out_68_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_19_valid = _T_1710 ? SLR1_io_p2_out_19_valid : crossbar_array_visit_io_out_100_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_19_bits = _T_1710 ? SLR1_io_p2_out_19_bits : {{8'd0}, crossbar_array_visit_io_out_100_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_20_valid = _T_1712 ? SLR1_io_p2_out_20_valid : crossbar_array_visit_io_out_5_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_20_bits = _T_1712 ? SLR1_io_p2_out_20_bits : {{8'd0}, crossbar_array_visit_io_out_5_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_21_valid = _T_1714 ? SLR1_io_p2_out_21_valid : crossbar_array_visit_io_out_37_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_21_bits = _T_1714 ? SLR1_io_p2_out_21_bits : {{8'd0}, crossbar_array_visit_io_out_37_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_22_valid = _T_1716 ? SLR1_io_p2_out_22_valid : crossbar_array_visit_io_out_69_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_22_bits = _T_1716 ? SLR1_io_p2_out_22_bits : {{8'd0}, crossbar_array_visit_io_out_69_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_23_valid = _T_1718 ? SLR1_io_p2_out_23_valid : crossbar_array_visit_io_out_101_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_23_bits = _T_1718 ? SLR1_io_p2_out_23_bits : {{8'd0}, crossbar_array_visit_io_out_101_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_24_valid = _T_1720 ? SLR1_io_p2_out_24_valid : crossbar_array_visit_io_out_6_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_24_bits = _T_1720 ? SLR1_io_p2_out_24_bits : {{8'd0}, crossbar_array_visit_io_out_6_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_25_valid = _T_1722 ? SLR1_io_p2_out_25_valid : crossbar_array_visit_io_out_38_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_25_bits = _T_1722 ? SLR1_io_p2_out_25_bits : {{8'd0}, crossbar_array_visit_io_out_38_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_26_valid = _T_1724 ? SLR1_io_p2_out_26_valid : crossbar_array_visit_io_out_70_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_26_bits = _T_1724 ? SLR1_io_p2_out_26_bits : {{8'd0}, crossbar_array_visit_io_out_70_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_27_valid = _T_1726 ? SLR1_io_p2_out_27_valid : crossbar_array_visit_io_out_102_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_27_bits = _T_1726 ? SLR1_io_p2_out_27_bits : {{8'd0}, crossbar_array_visit_io_out_102_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_28_valid = _T_1728 ? SLR1_io_p2_out_28_valid : crossbar_array_visit_io_out_7_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_28_bits = _T_1728 ? SLR1_io_p2_out_28_bits : {{8'd0}, crossbar_array_visit_io_out_7_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_29_valid = _T_1730 ? SLR1_io_p2_out_29_valid : crossbar_array_visit_io_out_39_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_29_bits = _T_1730 ? SLR1_io_p2_out_29_bits : {{8'd0}, crossbar_array_visit_io_out_39_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_30_valid = _T_1732 ? SLR1_io_p2_out_30_valid : crossbar_array_visit_io_out_71_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_30_bits = _T_1732 ? SLR1_io_p2_out_30_bits : {{8'd0}, crossbar_array_visit_io_out_71_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_31_valid = _T_1734 ? SLR1_io_p2_out_31_valid : crossbar_array_visit_io_out_103_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_31_bits = _T_1734 ? SLR1_io_p2_out_31_bits : {{8'd0}, crossbar_array_visit_io_out_103_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_32_valid = _T_1736 ? SLR1_io_p2_out_32_valid : crossbar_array_visit_io_out_8_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_32_bits = _T_1736 ? SLR1_io_p2_out_32_bits : {{8'd0}, crossbar_array_visit_io_out_8_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_33_valid = _T_1738 ? SLR1_io_p2_out_33_valid : crossbar_array_visit_io_out_40_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_33_bits = _T_1738 ? SLR1_io_p2_out_33_bits : {{8'd0}, crossbar_array_visit_io_out_40_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_34_valid = _T_1740 ? SLR1_io_p2_out_34_valid : crossbar_array_visit_io_out_72_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_34_bits = _T_1740 ? SLR1_io_p2_out_34_bits : {{8'd0}, crossbar_array_visit_io_out_72_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_35_valid = _T_1742 ? SLR1_io_p2_out_35_valid : crossbar_array_visit_io_out_104_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_35_bits = _T_1742 ? SLR1_io_p2_out_35_bits : {{8'd0}, crossbar_array_visit_io_out_104_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_36_valid = _T_1744 ? SLR1_io_p2_out_36_valid : crossbar_array_visit_io_out_9_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_36_bits = _T_1744 ? SLR1_io_p2_out_36_bits : {{8'd0}, crossbar_array_visit_io_out_9_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_37_valid = _T_1746 ? SLR1_io_p2_out_37_valid : crossbar_array_visit_io_out_41_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_37_bits = _T_1746 ? SLR1_io_p2_out_37_bits : {{8'd0}, crossbar_array_visit_io_out_41_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_38_valid = _T_1748 ? SLR1_io_p2_out_38_valid : crossbar_array_visit_io_out_73_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_38_bits = _T_1748 ? SLR1_io_p2_out_38_bits : {{8'd0}, crossbar_array_visit_io_out_73_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_39_valid = _T_1750 ? SLR1_io_p2_out_39_valid : crossbar_array_visit_io_out_105_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_39_bits = _T_1750 ? SLR1_io_p2_out_39_bits : {{8'd0}, crossbar_array_visit_io_out_105_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_40_valid = _T_1752 ? SLR1_io_p2_out_40_valid : crossbar_array_visit_io_out_10_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_40_bits = _T_1752 ? SLR1_io_p2_out_40_bits : {{8'd0}, crossbar_array_visit_io_out_10_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_41_valid = _T_1754 ? SLR1_io_p2_out_41_valid : crossbar_array_visit_io_out_42_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_41_bits = _T_1754 ? SLR1_io_p2_out_41_bits : {{8'd0}, crossbar_array_visit_io_out_42_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_42_valid = _T_1756 ? SLR1_io_p2_out_42_valid : crossbar_array_visit_io_out_74_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_42_bits = _T_1756 ? SLR1_io_p2_out_42_bits : {{8'd0}, crossbar_array_visit_io_out_74_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_43_valid = _T_1758 ? SLR1_io_p2_out_43_valid : crossbar_array_visit_io_out_106_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_43_bits = _T_1758 ? SLR1_io_p2_out_43_bits : {{8'd0}, crossbar_array_visit_io_out_106_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_44_valid = _T_1760 ? SLR1_io_p2_out_44_valid : crossbar_array_visit_io_out_11_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_44_bits = _T_1760 ? SLR1_io_p2_out_44_bits : {{8'd0}, crossbar_array_visit_io_out_11_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_45_valid = _T_1762 ? SLR1_io_p2_out_45_valid : crossbar_array_visit_io_out_43_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_45_bits = _T_1762 ? SLR1_io_p2_out_45_bits : {{8'd0}, crossbar_array_visit_io_out_43_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_46_valid = _T_1764 ? SLR1_io_p2_out_46_valid : crossbar_array_visit_io_out_75_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_46_bits = _T_1764 ? SLR1_io_p2_out_46_bits : {{8'd0}, crossbar_array_visit_io_out_75_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_47_valid = _T_1766 ? SLR1_io_p2_out_47_valid : crossbar_array_visit_io_out_107_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_47_bits = _T_1766 ? SLR1_io_p2_out_47_bits : {{8'd0}, crossbar_array_visit_io_out_107_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_48_valid = _T_1768 ? SLR1_io_p2_out_48_valid : crossbar_array_visit_io_out_12_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_48_bits = _T_1768 ? SLR1_io_p2_out_48_bits : {{8'd0}, crossbar_array_visit_io_out_12_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_49_valid = _T_1770 ? SLR1_io_p2_out_49_valid : crossbar_array_visit_io_out_44_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_49_bits = _T_1770 ? SLR1_io_p2_out_49_bits : {{8'd0}, crossbar_array_visit_io_out_44_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_50_valid = _T_1772 ? SLR1_io_p2_out_50_valid : crossbar_array_visit_io_out_76_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_50_bits = _T_1772 ? SLR1_io_p2_out_50_bits : {{8'd0}, crossbar_array_visit_io_out_76_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_51_valid = _T_1774 ? SLR1_io_p2_out_51_valid : crossbar_array_visit_io_out_108_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_51_bits = _T_1774 ? SLR1_io_p2_out_51_bits : {{8'd0}, crossbar_array_visit_io_out_108_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_52_valid = _T_1776 ? SLR1_io_p2_out_52_valid : crossbar_array_visit_io_out_13_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_52_bits = _T_1776 ? SLR1_io_p2_out_52_bits : {{8'd0}, crossbar_array_visit_io_out_13_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_53_valid = _T_1778 ? SLR1_io_p2_out_53_valid : crossbar_array_visit_io_out_45_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_53_bits = _T_1778 ? SLR1_io_p2_out_53_bits : {{8'd0}, crossbar_array_visit_io_out_45_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_54_valid = _T_1780 ? SLR1_io_p2_out_54_valid : crossbar_array_visit_io_out_77_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_54_bits = _T_1780 ? SLR1_io_p2_out_54_bits : {{8'd0}, crossbar_array_visit_io_out_77_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_55_valid = _T_1782 ? SLR1_io_p2_out_55_valid : crossbar_array_visit_io_out_109_valid; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_frontier_in_55_bits = _T_1782 ? SLR1_io_p2_out_55_bits : {{8'd0}, crossbar_array_visit_io_out_109_bits}; // @[Top-slr.scala 470:96 Top-slr.scala 474:71]
  assign SLR1_io_p2_out_0_ready = _T_1672 ? SLR1_io_frontier_in_0_ready : crossbar_array_visit_io_in_0_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_1_ready = _T_1674 ? SLR1_io_frontier_in_1_ready : crossbar_array_visit_io_in_32_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_2_ready = _T_1676 ? SLR1_io_frontier_in_2_ready : crossbar_array_visit_io_in_64_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_3_ready = _T_1678 ? SLR1_io_frontier_in_3_ready : crossbar_array_visit_io_in_96_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_4_ready = _T_1680 ? SLR1_io_frontier_in_4_ready : crossbar_array_visit_io_in_1_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_5_ready = _T_1682 ? SLR1_io_frontier_in_5_ready : crossbar_array_visit_io_in_33_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_6_ready = _T_1684 ? SLR1_io_frontier_in_6_ready : crossbar_array_visit_io_in_65_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_7_ready = _T_1686 ? SLR1_io_frontier_in_7_ready : crossbar_array_visit_io_in_97_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_8_ready = _T_1688 ? SLR1_io_frontier_in_8_ready : crossbar_array_visit_io_in_2_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_9_ready = _T_1690 ? SLR1_io_frontier_in_9_ready : crossbar_array_visit_io_in_34_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_10_ready = _T_1692 ? SLR1_io_frontier_in_10_ready : crossbar_array_visit_io_in_66_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_11_ready = _T_1694 ? SLR1_io_frontier_in_11_ready : crossbar_array_visit_io_in_98_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_12_ready = _T_1696 ? SLR1_io_frontier_in_12_ready : crossbar_array_visit_io_in_3_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_13_ready = _T_1698 ? SLR1_io_frontier_in_13_ready : crossbar_array_visit_io_in_35_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_14_ready = _T_1700 ? SLR1_io_frontier_in_14_ready : crossbar_array_visit_io_in_67_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_15_ready = _T_1702 ? SLR1_io_frontier_in_15_ready : crossbar_array_visit_io_in_99_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_16_ready = _T_1704 ? SLR1_io_frontier_in_16_ready : crossbar_array_visit_io_in_4_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_17_ready = _T_1706 ? SLR1_io_frontier_in_17_ready : crossbar_array_visit_io_in_36_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_18_ready = _T_1708 ? SLR1_io_frontier_in_18_ready : crossbar_array_visit_io_in_68_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_19_ready = _T_1710 ? SLR1_io_frontier_in_19_ready : crossbar_array_visit_io_in_100_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_20_ready = _T_1712 ? SLR1_io_frontier_in_20_ready : crossbar_array_visit_io_in_5_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_21_ready = _T_1714 ? SLR1_io_frontier_in_21_ready : crossbar_array_visit_io_in_37_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_22_ready = _T_1716 ? SLR1_io_frontier_in_22_ready : crossbar_array_visit_io_in_69_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_23_ready = _T_1718 ? SLR1_io_frontier_in_23_ready : crossbar_array_visit_io_in_101_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_24_ready = _T_1720 ? SLR1_io_frontier_in_24_ready : crossbar_array_visit_io_in_6_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_25_ready = _T_1722 ? SLR1_io_frontier_in_25_ready : crossbar_array_visit_io_in_38_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_26_ready = _T_1724 ? SLR1_io_frontier_in_26_ready : crossbar_array_visit_io_in_70_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_27_ready = _T_1726 ? SLR1_io_frontier_in_27_ready : crossbar_array_visit_io_in_102_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_28_ready = _T_1728 ? SLR1_io_frontier_in_28_ready : crossbar_array_visit_io_in_7_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_29_ready = _T_1730 ? SLR1_io_frontier_in_29_ready : crossbar_array_visit_io_in_39_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_30_ready = _T_1732 ? SLR1_io_frontier_in_30_ready : crossbar_array_visit_io_in_71_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_31_ready = _T_1734 ? SLR1_io_frontier_in_31_ready : crossbar_array_visit_io_in_103_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_32_ready = _T_1736 ? SLR1_io_frontier_in_32_ready : crossbar_array_visit_io_in_8_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_33_ready = _T_1738 ? SLR1_io_frontier_in_33_ready : crossbar_array_visit_io_in_40_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_34_ready = _T_1740 ? SLR1_io_frontier_in_34_ready : crossbar_array_visit_io_in_72_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_35_ready = _T_1742 ? SLR1_io_frontier_in_35_ready : crossbar_array_visit_io_in_104_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_36_ready = _T_1744 ? SLR1_io_frontier_in_36_ready : crossbar_array_visit_io_in_9_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_37_ready = _T_1746 ? SLR1_io_frontier_in_37_ready : crossbar_array_visit_io_in_41_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_38_ready = _T_1748 ? SLR1_io_frontier_in_38_ready : crossbar_array_visit_io_in_73_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_39_ready = _T_1750 ? SLR1_io_frontier_in_39_ready : crossbar_array_visit_io_in_105_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_40_ready = _T_1752 ? SLR1_io_frontier_in_40_ready : crossbar_array_visit_io_in_10_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_41_ready = _T_1754 ? SLR1_io_frontier_in_41_ready : crossbar_array_visit_io_in_42_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_42_ready = _T_1756 ? SLR1_io_frontier_in_42_ready : crossbar_array_visit_io_in_74_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_43_ready = _T_1758 ? SLR1_io_frontier_in_43_ready : crossbar_array_visit_io_in_106_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_44_ready = _T_1760 ? SLR1_io_frontier_in_44_ready : crossbar_array_visit_io_in_11_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_45_ready = _T_1762 ? SLR1_io_frontier_in_45_ready : crossbar_array_visit_io_in_43_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_46_ready = _T_1764 ? SLR1_io_frontier_in_46_ready : crossbar_array_visit_io_in_75_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_47_ready = _T_1766 ? SLR1_io_frontier_in_47_ready : crossbar_array_visit_io_in_107_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_48_ready = _T_1768 ? SLR1_io_frontier_in_48_ready : crossbar_array_visit_io_in_12_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_49_ready = _T_1770 ? SLR1_io_frontier_in_49_ready : crossbar_array_visit_io_in_44_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_50_ready = _T_1772 ? SLR1_io_frontier_in_50_ready : crossbar_array_visit_io_in_76_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_51_ready = _T_1774 ? SLR1_io_frontier_in_51_ready : crossbar_array_visit_io_in_108_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_52_ready = _T_1776 ? SLR1_io_frontier_in_52_ready : crossbar_array_visit_io_in_13_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_53_ready = _T_1778 ? SLR1_io_frontier_in_53_ready : crossbar_array_visit_io_in_45_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_54_ready = _T_1780 ? SLR1_io_frontier_in_54_ready : crossbar_array_visit_io_in_77_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_p2_out_55_ready = _T_1782 ? SLR1_io_frontier_in_55_ready : crossbar_array_visit_io_in_109_ready; // @[Top-slr.scala 470:96 Top-slr.scala 473:71]
  assign SLR1_io_R_array_index_0_ready = R_array_index_01_slr1_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_1_ready = R_array_index_01_slr1_1_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_2_ready = R_array_index_01_slr1_2_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_3_ready = R_array_index_01_slr1_3_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_4_ready = R_array_index_01_slr1_4_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_5_ready = R_array_index_01_slr1_5_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_6_ready = R_array_index_01_slr1_6_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_7_ready = R_array_index_01_slr1_7_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_8_ready = R_array_index_01_slr1_8_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_9_ready = R_array_index_01_slr1_9_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_10_ready = R_array_index_01_slr1_10_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_11_ready = R_array_index_01_slr1_11_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_12_ready = R_array_index_01_slr1_12_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_13_ready = R_array_index_01_slr1_13_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_14_ready = R_array_index_01_slr1_14_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_15_ready = R_array_index_01_slr1_15_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_16_ready = R_array_index_01_slr1_16_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_17_ready = R_array_index_01_slr1_17_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_18_ready = R_array_index_01_slr1_18_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_19_ready = R_array_index_01_slr1_19_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_20_ready = R_array_index_01_slr1_20_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_21_ready = R_array_index_01_slr1_21_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_22_ready = R_array_index_01_slr1_22_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_23_ready = R_array_index_01_slr1_23_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_24_ready = R_array_index_01_slr1_24_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_25_ready = R_array_index_01_slr1_25_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_26_ready = R_array_index_01_slr1_26_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_27_ready = R_array_index_01_slr1_27_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_28_ready = R_array_index_01_slr1_28_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_29_ready = R_array_index_01_slr1_29_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_30_ready = R_array_index_01_slr1_30_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_31_ready = R_array_index_01_slr1_31_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_32_ready = R_array_index_01_slr1_32_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_33_ready = R_array_index_01_slr1_33_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_34_ready = R_array_index_01_slr1_34_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_35_ready = R_array_index_01_slr1_35_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_36_ready = R_array_index_01_slr1_36_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_37_ready = R_array_index_01_slr1_37_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_38_ready = R_array_index_01_slr1_38_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_39_ready = R_array_index_01_slr1_39_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_40_ready = R_array_index_01_slr1_40_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_41_ready = R_array_index_01_slr1_41_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_42_ready = R_array_index_01_slr1_42_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_43_ready = R_array_index_01_slr1_43_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_44_ready = R_array_index_01_slr1_44_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_45_ready = R_array_index_01_slr1_45_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_46_ready = R_array_index_01_slr1_46_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_47_ready = R_array_index_01_slr1_47_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_48_ready = R_array_index_01_slr1_48_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_49_ready = R_array_index_01_slr1_49_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_50_ready = R_array_index_01_slr1_50_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_51_ready = R_array_index_01_slr1_51_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_52_ready = R_array_index_01_slr1_52_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_53_ready = R_array_index_01_slr1_53_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_54_ready = R_array_index_01_slr1_54_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_R_array_index_55_ready = R_array_index_01_slr1_55_enq_ready; // @[Top-slr.scala 285:47]
  assign SLR1_io_uram_addr_a_0 = uram_addr_a_01_slr1_0[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_1 = uram_addr_a_01_slr1_1[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_2 = uram_addr_a_01_slr1_2[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_3 = uram_addr_a_01_slr1_3[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_4 = uram_addr_a_01_slr1_4[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_5 = uram_addr_a_01_slr1_5[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_6 = uram_addr_a_01_slr1_6[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_7 = uram_addr_a_01_slr1_7[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_8 = uram_addr_a_01_slr1_8[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_9 = uram_addr_a_01_slr1_9[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_10 = uram_addr_a_01_slr1_10[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_11 = uram_addr_a_01_slr1_11[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_12 = uram_addr_a_01_slr1_12[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_13 = uram_addr_a_01_slr1_13[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_14 = uram_addr_a_01_slr1_14[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_15 = uram_addr_a_01_slr1_15[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_16 = uram_addr_a_01_slr1_16[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_17 = uram_addr_a_01_slr1_17[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_18 = uram_addr_a_01_slr1_18[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_19 = uram_addr_a_01_slr1_19[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_20 = uram_addr_a_01_slr1_20[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_21 = uram_addr_a_01_slr1_21[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_22 = uram_addr_a_01_slr1_22[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_23 = uram_addr_a_01_slr1_23[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_24 = uram_addr_a_01_slr1_24[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_25 = uram_addr_a_01_slr1_25[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_26 = uram_addr_a_01_slr1_26[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_27 = uram_addr_a_01_slr1_27[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_28 = uram_addr_a_01_slr1_28[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_29 = uram_addr_a_01_slr1_29[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_30 = uram_addr_a_01_slr1_30[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_31 = uram_addr_a_01_slr1_31[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_32 = uram_addr_a_01_slr1_32[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_33 = uram_addr_a_01_slr1_33[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_34 = uram_addr_a_01_slr1_34[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_35 = uram_addr_a_01_slr1_35[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_36 = uram_addr_a_01_slr1_36[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_37 = uram_addr_a_01_slr1_37[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_38 = uram_addr_a_01_slr1_38[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_39 = uram_addr_a_01_slr1_39[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_40 = uram_addr_a_01_slr1_40[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_41 = uram_addr_a_01_slr1_41[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_42 = uram_addr_a_01_slr1_42[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_43 = uram_addr_a_01_slr1_43[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_44 = uram_addr_a_01_slr1_44[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_45 = uram_addr_a_01_slr1_45[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_46 = uram_addr_a_01_slr1_46[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_47 = uram_addr_a_01_slr1_47[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_48 = uram_addr_a_01_slr1_48[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_49 = uram_addr_a_01_slr1_49[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_50 = uram_addr_a_01_slr1_50[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_51 = uram_addr_a_01_slr1_51[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_52 = uram_addr_a_01_slr1_52[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_53 = uram_addr_a_01_slr1_53[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_54 = uram_addr_a_01_slr1_54[19:0]; // @[Top-slr.scala 263:33]
  assign SLR1_io_uram_addr_a_55 = uram_addr_a_01_slr1_55[19:0]; // @[Top-slr.scala 263:33]
  assign SLR2_clock = clock;
  assign SLR2_reset = reset;
  assign SLR2_io_p2_end = p2_end_2_r; // @[Top-slr.scala 167:34]
  assign SLR2_io_start = start_2_r; // @[Top-slr.scala 168:34]
  assign SLR2_io_frontier_flag = frontier_flag_2_r; // @[Top-slr.scala 169:34]
  assign SLR2_io_level = current_level_2_r; // @[Top-slr.scala 170:34]
  assign SLR2_io_offsets_CSR_R_offset = _T_45_CSR_R_offset; // @[Top-slr.scala 171:34]
  assign SLR2_io_offsets_CSR_C_offset = _T_45_CSR_C_offset; // @[Top-slr.scala 171:34]
  assign SLR2_io_offsets_CSC_R_offset = _T_45_CSC_R_offset; // @[Top-slr.scala 171:34]
  assign SLR2_io_offsets_CSC_C_offset = _T_45_CSC_C_offset; // @[Top-slr.scala 171:34]
  assign SLR2_io_offsets_level_offset = _T_45_level_offset; // @[Top-slr.scala 171:34]
  assign SLR2_io_node_num = node_num_2_r; // @[Top-slr.scala 172:34]
  assign SLR2_io_root = _T_46; // @[Top-slr.scala 173:34]
  assign SLR2_io_push_or_pull = push_or_pull_2_r; // @[Top-slr.scala 174:34]
  assign SLR2_io_start_init = _T_47; // @[Top-slr.scala 175:34]
  assign SLR2_io_p2_in_0_valid = crossbar_array_mem_io_out_14_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_0_bits = {{16'd0}, crossbar_array_mem_io_out_14_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_1_valid = crossbar_array_mem_io_out_46_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_1_bits = {{16'd0}, crossbar_array_mem_io_out_46_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_2_valid = crossbar_array_mem_io_out_78_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_2_bits = {{16'd0}, crossbar_array_mem_io_out_78_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_3_valid = crossbar_array_mem_io_out_110_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_3_bits = {{16'd0}, crossbar_array_mem_io_out_110_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_4_valid = crossbar_array_mem_io_out_15_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_4_bits = {{16'd0}, crossbar_array_mem_io_out_15_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_5_valid = crossbar_array_mem_io_out_47_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_5_bits = {{16'd0}, crossbar_array_mem_io_out_47_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_6_valid = crossbar_array_mem_io_out_79_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_6_bits = {{16'd0}, crossbar_array_mem_io_out_79_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_7_valid = crossbar_array_mem_io_out_111_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_7_bits = {{16'd0}, crossbar_array_mem_io_out_111_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_8_valid = crossbar_array_mem_io_out_16_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_8_bits = {{16'd0}, crossbar_array_mem_io_out_16_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_9_valid = crossbar_array_mem_io_out_48_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_9_bits = {{16'd0}, crossbar_array_mem_io_out_48_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_10_valid = crossbar_array_mem_io_out_80_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_10_bits = {{16'd0}, crossbar_array_mem_io_out_80_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_11_valid = crossbar_array_mem_io_out_112_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_11_bits = {{16'd0}, crossbar_array_mem_io_out_112_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_12_valid = crossbar_array_mem_io_out_17_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_12_bits = {{16'd0}, crossbar_array_mem_io_out_17_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_13_valid = crossbar_array_mem_io_out_49_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_13_bits = {{16'd0}, crossbar_array_mem_io_out_49_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_14_valid = crossbar_array_mem_io_out_81_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_14_bits = {{16'd0}, crossbar_array_mem_io_out_81_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_15_valid = crossbar_array_mem_io_out_113_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_15_bits = {{16'd0}, crossbar_array_mem_io_out_113_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_16_valid = crossbar_array_mem_io_out_18_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_16_bits = {{16'd0}, crossbar_array_mem_io_out_18_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_17_valid = crossbar_array_mem_io_out_50_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_17_bits = {{16'd0}, crossbar_array_mem_io_out_50_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_18_valid = crossbar_array_mem_io_out_82_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_18_bits = {{16'd0}, crossbar_array_mem_io_out_82_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_19_valid = crossbar_array_mem_io_out_114_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_19_bits = {{16'd0}, crossbar_array_mem_io_out_114_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_20_valid = crossbar_array_mem_io_out_19_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_20_bits = {{16'd0}, crossbar_array_mem_io_out_19_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_21_valid = crossbar_array_mem_io_out_51_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_21_bits = {{16'd0}, crossbar_array_mem_io_out_51_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_22_valid = crossbar_array_mem_io_out_83_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_22_bits = {{16'd0}, crossbar_array_mem_io_out_83_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_23_valid = crossbar_array_mem_io_out_115_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_23_bits = {{16'd0}, crossbar_array_mem_io_out_115_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_24_valid = crossbar_array_mem_io_out_20_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_24_bits = {{16'd0}, crossbar_array_mem_io_out_20_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_25_valid = crossbar_array_mem_io_out_52_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_25_bits = {{16'd0}, crossbar_array_mem_io_out_52_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_26_valid = crossbar_array_mem_io_out_84_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_26_bits = {{16'd0}, crossbar_array_mem_io_out_84_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_27_valid = crossbar_array_mem_io_out_116_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_27_bits = {{16'd0}, crossbar_array_mem_io_out_116_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_28_valid = crossbar_array_mem_io_out_21_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_28_bits = {{16'd0}, crossbar_array_mem_io_out_21_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_29_valid = crossbar_array_mem_io_out_53_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_29_bits = {{16'd0}, crossbar_array_mem_io_out_53_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_30_valid = crossbar_array_mem_io_out_85_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_30_bits = {{16'd0}, crossbar_array_mem_io_out_85_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_31_valid = crossbar_array_mem_io_out_117_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_31_bits = {{16'd0}, crossbar_array_mem_io_out_117_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_32_valid = crossbar_array_mem_io_out_22_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_32_bits = {{16'd0}, crossbar_array_mem_io_out_22_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_33_valid = crossbar_array_mem_io_out_54_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_33_bits = {{16'd0}, crossbar_array_mem_io_out_54_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_34_valid = crossbar_array_mem_io_out_86_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_34_bits = {{16'd0}, crossbar_array_mem_io_out_86_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_35_valid = crossbar_array_mem_io_out_118_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_35_bits = {{16'd0}, crossbar_array_mem_io_out_118_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_36_valid = crossbar_array_mem_io_out_23_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_36_bits = {{16'd0}, crossbar_array_mem_io_out_23_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_37_valid = crossbar_array_mem_io_out_55_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_37_bits = {{16'd0}, crossbar_array_mem_io_out_55_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_38_valid = crossbar_array_mem_io_out_87_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_38_bits = {{16'd0}, crossbar_array_mem_io_out_87_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_39_valid = crossbar_array_mem_io_out_119_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_39_bits = {{16'd0}, crossbar_array_mem_io_out_119_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_40_valid = crossbar_array_mem_io_out_24_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_40_bits = {{16'd0}, crossbar_array_mem_io_out_24_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_41_valid = crossbar_array_mem_io_out_56_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_41_bits = {{16'd0}, crossbar_array_mem_io_out_56_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_42_valid = crossbar_array_mem_io_out_88_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_42_bits = {{16'd0}, crossbar_array_mem_io_out_88_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_43_valid = crossbar_array_mem_io_out_120_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_43_bits = {{16'd0}, crossbar_array_mem_io_out_120_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_44_valid = crossbar_array_mem_io_out_25_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_44_bits = {{16'd0}, crossbar_array_mem_io_out_25_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_45_valid = crossbar_array_mem_io_out_57_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_45_bits = {{16'd0}, crossbar_array_mem_io_out_57_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_46_valid = crossbar_array_mem_io_out_89_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_46_bits = {{16'd0}, crossbar_array_mem_io_out_89_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_47_valid = crossbar_array_mem_io_out_121_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_47_bits = {{16'd0}, crossbar_array_mem_io_out_121_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_48_valid = crossbar_array_mem_io_out_26_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_48_bits = {{16'd0}, crossbar_array_mem_io_out_26_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_49_valid = crossbar_array_mem_io_out_58_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_49_bits = {{16'd0}, crossbar_array_mem_io_out_58_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_50_valid = crossbar_array_mem_io_out_90_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_50_bits = {{16'd0}, crossbar_array_mem_io_out_90_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_51_valid = crossbar_array_mem_io_out_122_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_51_bits = {{16'd0}, crossbar_array_mem_io_out_122_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_52_valid = crossbar_array_mem_io_out_27_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_52_bits = {{16'd0}, crossbar_array_mem_io_out_27_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_53_valid = crossbar_array_mem_io_out_59_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_53_bits = {{16'd0}, crossbar_array_mem_io_out_59_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_54_valid = crossbar_array_mem_io_out_91_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_54_bits = {{16'd0}, crossbar_array_mem_io_out_91_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_55_valid = crossbar_array_mem_io_out_123_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_55_bits = {{16'd0}, crossbar_array_mem_io_out_123_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_56_valid = crossbar_array_mem_io_out_28_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_56_bits = {{16'd0}, crossbar_array_mem_io_out_28_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_57_valid = crossbar_array_mem_io_out_60_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_57_bits = {{16'd0}, crossbar_array_mem_io_out_60_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_58_valid = crossbar_array_mem_io_out_92_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_58_bits = {{16'd0}, crossbar_array_mem_io_out_92_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_59_valid = crossbar_array_mem_io_out_124_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_59_bits = {{16'd0}, crossbar_array_mem_io_out_124_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_60_valid = crossbar_array_mem_io_out_29_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_60_bits = {{16'd0}, crossbar_array_mem_io_out_29_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_61_valid = crossbar_array_mem_io_out_61_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_61_bits = {{16'd0}, crossbar_array_mem_io_out_61_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_62_valid = crossbar_array_mem_io_out_93_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_62_bits = {{16'd0}, crossbar_array_mem_io_out_93_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_63_valid = crossbar_array_mem_io_out_125_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_63_bits = {{16'd0}, crossbar_array_mem_io_out_125_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_64_valid = crossbar_array_mem_io_out_30_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_64_bits = {{16'd0}, crossbar_array_mem_io_out_30_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_65_valid = crossbar_array_mem_io_out_62_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_65_bits = {{16'd0}, crossbar_array_mem_io_out_62_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_66_valid = crossbar_array_mem_io_out_94_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_66_bits = {{16'd0}, crossbar_array_mem_io_out_94_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_67_valid = crossbar_array_mem_io_out_126_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_67_bits = {{16'd0}, crossbar_array_mem_io_out_126_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_68_valid = crossbar_array_mem_io_out_31_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_68_bits = {{16'd0}, crossbar_array_mem_io_out_31_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_69_valid = crossbar_array_mem_io_out_63_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_69_bits = {{16'd0}, crossbar_array_mem_io_out_63_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_70_valid = crossbar_array_mem_io_out_95_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_70_bits = {{16'd0}, crossbar_array_mem_io_out_95_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_71_valid = crossbar_array_mem_io_out_127_valid; // @[Top-slr.scala 495:66]
  assign SLR2_io_p2_in_71_bits = {{16'd0}, crossbar_array_mem_io_out_127_bits}; // @[Top-slr.scala 495:66]
  assign SLR2_io_frontier_in_0_valid = _T_1784 ? SLR2_io_p2_out_0_valid : crossbar_array_visit_io_out_14_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_0_bits = _T_1784 ? SLR2_io_p2_out_0_bits : {{8'd0}, crossbar_array_visit_io_out_14_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_1_valid = _T_1786 ? SLR2_io_p2_out_1_valid : crossbar_array_visit_io_out_46_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_1_bits = _T_1786 ? SLR2_io_p2_out_1_bits : {{8'd0}, crossbar_array_visit_io_out_46_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_2_valid = _T_1788 ? SLR2_io_p2_out_2_valid : crossbar_array_visit_io_out_78_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_2_bits = _T_1788 ? SLR2_io_p2_out_2_bits : {{8'd0}, crossbar_array_visit_io_out_78_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_3_valid = _T_1790 ? SLR2_io_p2_out_3_valid : crossbar_array_visit_io_out_110_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_3_bits = _T_1790 ? SLR2_io_p2_out_3_bits : {{8'd0}, crossbar_array_visit_io_out_110_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_4_valid = _T_1792 ? SLR2_io_p2_out_4_valid : crossbar_array_visit_io_out_15_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_4_bits = _T_1792 ? SLR2_io_p2_out_4_bits : {{8'd0}, crossbar_array_visit_io_out_15_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_5_valid = _T_1794 ? SLR2_io_p2_out_5_valid : crossbar_array_visit_io_out_47_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_5_bits = _T_1794 ? SLR2_io_p2_out_5_bits : {{8'd0}, crossbar_array_visit_io_out_47_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_6_valid = _T_1796 ? SLR2_io_p2_out_6_valid : crossbar_array_visit_io_out_79_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_6_bits = _T_1796 ? SLR2_io_p2_out_6_bits : {{8'd0}, crossbar_array_visit_io_out_79_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_7_valid = _T_1798 ? SLR2_io_p2_out_7_valid : crossbar_array_visit_io_out_111_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_7_bits = _T_1798 ? SLR2_io_p2_out_7_bits : {{8'd0}, crossbar_array_visit_io_out_111_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_8_valid = _T_1800 ? SLR2_io_p2_out_8_valid : crossbar_array_visit_io_out_16_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_8_bits = _T_1800 ? SLR2_io_p2_out_8_bits : {{8'd0}, crossbar_array_visit_io_out_16_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_9_valid = _T_1802 ? SLR2_io_p2_out_9_valid : crossbar_array_visit_io_out_48_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_9_bits = _T_1802 ? SLR2_io_p2_out_9_bits : {{8'd0}, crossbar_array_visit_io_out_48_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_10_valid = _T_1804 ? SLR2_io_p2_out_10_valid : crossbar_array_visit_io_out_80_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_10_bits = _T_1804 ? SLR2_io_p2_out_10_bits : {{8'd0}, crossbar_array_visit_io_out_80_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_11_valid = _T_1806 ? SLR2_io_p2_out_11_valid : crossbar_array_visit_io_out_112_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_11_bits = _T_1806 ? SLR2_io_p2_out_11_bits : {{8'd0}, crossbar_array_visit_io_out_112_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_12_valid = _T_1808 ? SLR2_io_p2_out_12_valid : crossbar_array_visit_io_out_17_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_12_bits = _T_1808 ? SLR2_io_p2_out_12_bits : {{8'd0}, crossbar_array_visit_io_out_17_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_13_valid = _T_1810 ? SLR2_io_p2_out_13_valid : crossbar_array_visit_io_out_49_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_13_bits = _T_1810 ? SLR2_io_p2_out_13_bits : {{8'd0}, crossbar_array_visit_io_out_49_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_14_valid = _T_1812 ? SLR2_io_p2_out_14_valid : crossbar_array_visit_io_out_81_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_14_bits = _T_1812 ? SLR2_io_p2_out_14_bits : {{8'd0}, crossbar_array_visit_io_out_81_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_15_valid = _T_1814 ? SLR2_io_p2_out_15_valid : crossbar_array_visit_io_out_113_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_15_bits = _T_1814 ? SLR2_io_p2_out_15_bits : {{8'd0}, crossbar_array_visit_io_out_113_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_16_valid = _T_1816 ? SLR2_io_p2_out_16_valid : crossbar_array_visit_io_out_18_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_16_bits = _T_1816 ? SLR2_io_p2_out_16_bits : {{8'd0}, crossbar_array_visit_io_out_18_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_17_valid = _T_1818 ? SLR2_io_p2_out_17_valid : crossbar_array_visit_io_out_50_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_17_bits = _T_1818 ? SLR2_io_p2_out_17_bits : {{8'd0}, crossbar_array_visit_io_out_50_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_18_valid = _T_1820 ? SLR2_io_p2_out_18_valid : crossbar_array_visit_io_out_82_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_18_bits = _T_1820 ? SLR2_io_p2_out_18_bits : {{8'd0}, crossbar_array_visit_io_out_82_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_19_valid = _T_1822 ? SLR2_io_p2_out_19_valid : crossbar_array_visit_io_out_114_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_19_bits = _T_1822 ? SLR2_io_p2_out_19_bits : {{8'd0}, crossbar_array_visit_io_out_114_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_20_valid = _T_1824 ? SLR2_io_p2_out_20_valid : crossbar_array_visit_io_out_19_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_20_bits = _T_1824 ? SLR2_io_p2_out_20_bits : {{8'd0}, crossbar_array_visit_io_out_19_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_21_valid = _T_1826 ? SLR2_io_p2_out_21_valid : crossbar_array_visit_io_out_51_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_21_bits = _T_1826 ? SLR2_io_p2_out_21_bits : {{8'd0}, crossbar_array_visit_io_out_51_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_22_valid = _T_1828 ? SLR2_io_p2_out_22_valid : crossbar_array_visit_io_out_83_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_22_bits = _T_1828 ? SLR2_io_p2_out_22_bits : {{8'd0}, crossbar_array_visit_io_out_83_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_23_valid = _T_1830 ? SLR2_io_p2_out_23_valid : crossbar_array_visit_io_out_115_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_23_bits = _T_1830 ? SLR2_io_p2_out_23_bits : {{8'd0}, crossbar_array_visit_io_out_115_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_24_valid = _T_1832 ? SLR2_io_p2_out_24_valid : crossbar_array_visit_io_out_20_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_24_bits = _T_1832 ? SLR2_io_p2_out_24_bits : {{8'd0}, crossbar_array_visit_io_out_20_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_25_valid = _T_1834 ? SLR2_io_p2_out_25_valid : crossbar_array_visit_io_out_52_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_25_bits = _T_1834 ? SLR2_io_p2_out_25_bits : {{8'd0}, crossbar_array_visit_io_out_52_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_26_valid = _T_1836 ? SLR2_io_p2_out_26_valid : crossbar_array_visit_io_out_84_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_26_bits = _T_1836 ? SLR2_io_p2_out_26_bits : {{8'd0}, crossbar_array_visit_io_out_84_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_27_valid = _T_1838 ? SLR2_io_p2_out_27_valid : crossbar_array_visit_io_out_116_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_27_bits = _T_1838 ? SLR2_io_p2_out_27_bits : {{8'd0}, crossbar_array_visit_io_out_116_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_28_valid = _T_1840 ? SLR2_io_p2_out_28_valid : crossbar_array_visit_io_out_21_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_28_bits = _T_1840 ? SLR2_io_p2_out_28_bits : {{8'd0}, crossbar_array_visit_io_out_21_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_29_valid = _T_1842 ? SLR2_io_p2_out_29_valid : crossbar_array_visit_io_out_53_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_29_bits = _T_1842 ? SLR2_io_p2_out_29_bits : {{8'd0}, crossbar_array_visit_io_out_53_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_30_valid = _T_1844 ? SLR2_io_p2_out_30_valid : crossbar_array_visit_io_out_85_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_30_bits = _T_1844 ? SLR2_io_p2_out_30_bits : {{8'd0}, crossbar_array_visit_io_out_85_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_31_valid = _T_1846 ? SLR2_io_p2_out_31_valid : crossbar_array_visit_io_out_117_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_31_bits = _T_1846 ? SLR2_io_p2_out_31_bits : {{8'd0}, crossbar_array_visit_io_out_117_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_32_valid = _T_1848 ? SLR2_io_p2_out_32_valid : crossbar_array_visit_io_out_22_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_32_bits = _T_1848 ? SLR2_io_p2_out_32_bits : {{8'd0}, crossbar_array_visit_io_out_22_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_33_valid = _T_1850 ? SLR2_io_p2_out_33_valid : crossbar_array_visit_io_out_54_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_33_bits = _T_1850 ? SLR2_io_p2_out_33_bits : {{8'd0}, crossbar_array_visit_io_out_54_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_34_valid = _T_1852 ? SLR2_io_p2_out_34_valid : crossbar_array_visit_io_out_86_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_34_bits = _T_1852 ? SLR2_io_p2_out_34_bits : {{8'd0}, crossbar_array_visit_io_out_86_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_35_valid = _T_1854 ? SLR2_io_p2_out_35_valid : crossbar_array_visit_io_out_118_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_35_bits = _T_1854 ? SLR2_io_p2_out_35_bits : {{8'd0}, crossbar_array_visit_io_out_118_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_36_valid = _T_1856 ? SLR2_io_p2_out_36_valid : crossbar_array_visit_io_out_23_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_36_bits = _T_1856 ? SLR2_io_p2_out_36_bits : {{8'd0}, crossbar_array_visit_io_out_23_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_37_valid = _T_1858 ? SLR2_io_p2_out_37_valid : crossbar_array_visit_io_out_55_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_37_bits = _T_1858 ? SLR2_io_p2_out_37_bits : {{8'd0}, crossbar_array_visit_io_out_55_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_38_valid = _T_1860 ? SLR2_io_p2_out_38_valid : crossbar_array_visit_io_out_87_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_38_bits = _T_1860 ? SLR2_io_p2_out_38_bits : {{8'd0}, crossbar_array_visit_io_out_87_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_39_valid = _T_1862 ? SLR2_io_p2_out_39_valid : crossbar_array_visit_io_out_119_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_39_bits = _T_1862 ? SLR2_io_p2_out_39_bits : {{8'd0}, crossbar_array_visit_io_out_119_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_40_valid = _T_1864 ? SLR2_io_p2_out_40_valid : crossbar_array_visit_io_out_24_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_40_bits = _T_1864 ? SLR2_io_p2_out_40_bits : {{8'd0}, crossbar_array_visit_io_out_24_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_41_valid = _T_1866 ? SLR2_io_p2_out_41_valid : crossbar_array_visit_io_out_56_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_41_bits = _T_1866 ? SLR2_io_p2_out_41_bits : {{8'd0}, crossbar_array_visit_io_out_56_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_42_valid = _T_1868 ? SLR2_io_p2_out_42_valid : crossbar_array_visit_io_out_88_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_42_bits = _T_1868 ? SLR2_io_p2_out_42_bits : {{8'd0}, crossbar_array_visit_io_out_88_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_43_valid = _T_1870 ? SLR2_io_p2_out_43_valid : crossbar_array_visit_io_out_120_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_43_bits = _T_1870 ? SLR2_io_p2_out_43_bits : {{8'd0}, crossbar_array_visit_io_out_120_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_44_valid = _T_1872 ? SLR2_io_p2_out_44_valid : crossbar_array_visit_io_out_25_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_44_bits = _T_1872 ? SLR2_io_p2_out_44_bits : {{8'd0}, crossbar_array_visit_io_out_25_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_45_valid = _T_1874 ? SLR2_io_p2_out_45_valid : crossbar_array_visit_io_out_57_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_45_bits = _T_1874 ? SLR2_io_p2_out_45_bits : {{8'd0}, crossbar_array_visit_io_out_57_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_46_valid = _T_1876 ? SLR2_io_p2_out_46_valid : crossbar_array_visit_io_out_89_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_46_bits = _T_1876 ? SLR2_io_p2_out_46_bits : {{8'd0}, crossbar_array_visit_io_out_89_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_47_valid = _T_1878 ? SLR2_io_p2_out_47_valid : crossbar_array_visit_io_out_121_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_47_bits = _T_1878 ? SLR2_io_p2_out_47_bits : {{8'd0}, crossbar_array_visit_io_out_121_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_48_valid = _T_1880 ? SLR2_io_p2_out_48_valid : crossbar_array_visit_io_out_26_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_48_bits = _T_1880 ? SLR2_io_p2_out_48_bits : {{8'd0}, crossbar_array_visit_io_out_26_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_49_valid = _T_1882 ? SLR2_io_p2_out_49_valid : crossbar_array_visit_io_out_58_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_49_bits = _T_1882 ? SLR2_io_p2_out_49_bits : {{8'd0}, crossbar_array_visit_io_out_58_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_50_valid = _T_1884 ? SLR2_io_p2_out_50_valid : crossbar_array_visit_io_out_90_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_50_bits = _T_1884 ? SLR2_io_p2_out_50_bits : {{8'd0}, crossbar_array_visit_io_out_90_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_51_valid = _T_1886 ? SLR2_io_p2_out_51_valid : crossbar_array_visit_io_out_122_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_51_bits = _T_1886 ? SLR2_io_p2_out_51_bits : {{8'd0}, crossbar_array_visit_io_out_122_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_52_valid = _T_1888 ? SLR2_io_p2_out_52_valid : crossbar_array_visit_io_out_27_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_52_bits = _T_1888 ? SLR2_io_p2_out_52_bits : {{8'd0}, crossbar_array_visit_io_out_27_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_53_valid = _T_1890 ? SLR2_io_p2_out_53_valid : crossbar_array_visit_io_out_59_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_53_bits = _T_1890 ? SLR2_io_p2_out_53_bits : {{8'd0}, crossbar_array_visit_io_out_59_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_54_valid = _T_1892 ? SLR2_io_p2_out_54_valid : crossbar_array_visit_io_out_91_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_54_bits = _T_1892 ? SLR2_io_p2_out_54_bits : {{8'd0}, crossbar_array_visit_io_out_91_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_55_valid = _T_1894 ? SLR2_io_p2_out_55_valid : crossbar_array_visit_io_out_123_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_55_bits = _T_1894 ? SLR2_io_p2_out_55_bits : {{8'd0}, crossbar_array_visit_io_out_123_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_56_valid = _T_1896 ? SLR2_io_p2_out_56_valid : crossbar_array_visit_io_out_28_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_56_bits = _T_1896 ? SLR2_io_p2_out_56_bits : {{8'd0}, crossbar_array_visit_io_out_28_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_57_valid = _T_1898 ? SLR2_io_p2_out_57_valid : crossbar_array_visit_io_out_60_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_57_bits = _T_1898 ? SLR2_io_p2_out_57_bits : {{8'd0}, crossbar_array_visit_io_out_60_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_58_valid = _T_1900 ? SLR2_io_p2_out_58_valid : crossbar_array_visit_io_out_92_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_58_bits = _T_1900 ? SLR2_io_p2_out_58_bits : {{8'd0}, crossbar_array_visit_io_out_92_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_59_valid = _T_1902 ? SLR2_io_p2_out_59_valid : crossbar_array_visit_io_out_124_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_59_bits = _T_1902 ? SLR2_io_p2_out_59_bits : {{8'd0}, crossbar_array_visit_io_out_124_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_60_valid = _T_1904 ? SLR2_io_p2_out_60_valid : crossbar_array_visit_io_out_29_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_60_bits = _T_1904 ? SLR2_io_p2_out_60_bits : {{8'd0}, crossbar_array_visit_io_out_29_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_61_valid = _T_1906 ? SLR2_io_p2_out_61_valid : crossbar_array_visit_io_out_61_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_61_bits = _T_1906 ? SLR2_io_p2_out_61_bits : {{8'd0}, crossbar_array_visit_io_out_61_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_62_valid = _T_1908 ? SLR2_io_p2_out_62_valid : crossbar_array_visit_io_out_93_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_62_bits = _T_1908 ? SLR2_io_p2_out_62_bits : {{8'd0}, crossbar_array_visit_io_out_93_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_63_valid = _T_1910 ? SLR2_io_p2_out_63_valid : crossbar_array_visit_io_out_125_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_63_bits = _T_1910 ? SLR2_io_p2_out_63_bits : {{8'd0}, crossbar_array_visit_io_out_125_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_64_valid = _T_1912 ? SLR2_io_p2_out_64_valid : crossbar_array_visit_io_out_30_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_64_bits = _T_1912 ? SLR2_io_p2_out_64_bits : {{8'd0}, crossbar_array_visit_io_out_30_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_65_valid = _T_1914 ? SLR2_io_p2_out_65_valid : crossbar_array_visit_io_out_62_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_65_bits = _T_1914 ? SLR2_io_p2_out_65_bits : {{8'd0}, crossbar_array_visit_io_out_62_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_66_valid = _T_1916 ? SLR2_io_p2_out_66_valid : crossbar_array_visit_io_out_94_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_66_bits = _T_1916 ? SLR2_io_p2_out_66_bits : {{8'd0}, crossbar_array_visit_io_out_94_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_67_valid = _T_1918 ? SLR2_io_p2_out_67_valid : crossbar_array_visit_io_out_126_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_67_bits = _T_1918 ? SLR2_io_p2_out_67_bits : {{8'd0}, crossbar_array_visit_io_out_126_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_68_valid = _T_1920 ? SLR2_io_p2_out_68_valid : crossbar_array_visit_io_out_31_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_68_bits = _T_1920 ? SLR2_io_p2_out_68_bits : {{8'd0}, crossbar_array_visit_io_out_31_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_69_valid = _T_1922 ? SLR2_io_p2_out_69_valid : crossbar_array_visit_io_out_63_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_69_bits = _T_1922 ? SLR2_io_p2_out_69_bits : {{8'd0}, crossbar_array_visit_io_out_63_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_70_valid = _T_1924 ? SLR2_io_p2_out_70_valid : crossbar_array_visit_io_out_95_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_70_bits = _T_1924 ? SLR2_io_p2_out_70_bits : {{8'd0}, crossbar_array_visit_io_out_95_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_71_valid = _T_1926 ? SLR2_io_p2_out_71_valid : crossbar_array_visit_io_out_127_valid; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_frontier_in_71_bits = _T_1926 ? SLR2_io_p2_out_71_bits : {{8'd0}, crossbar_array_visit_io_out_127_bits}; // @[Top-slr.scala 500:120 Top-slr.scala 504:71]
  assign SLR2_io_p2_out_0_ready = _T_1784 ? SLR2_io_frontier_in_0_ready : crossbar_array_visit_io_in_14_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_1_ready = _T_1786 ? SLR2_io_frontier_in_1_ready : crossbar_array_visit_io_in_46_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_2_ready = _T_1788 ? SLR2_io_frontier_in_2_ready : crossbar_array_visit_io_in_78_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_3_ready = _T_1790 ? SLR2_io_frontier_in_3_ready : crossbar_array_visit_io_in_110_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_4_ready = _T_1792 ? SLR2_io_frontier_in_4_ready : crossbar_array_visit_io_in_15_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_5_ready = _T_1794 ? SLR2_io_frontier_in_5_ready : crossbar_array_visit_io_in_47_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_6_ready = _T_1796 ? SLR2_io_frontier_in_6_ready : crossbar_array_visit_io_in_79_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_7_ready = _T_1798 ? SLR2_io_frontier_in_7_ready : crossbar_array_visit_io_in_111_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_8_ready = _T_1800 ? SLR2_io_frontier_in_8_ready : crossbar_array_visit_io_in_16_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_9_ready = _T_1802 ? SLR2_io_frontier_in_9_ready : crossbar_array_visit_io_in_48_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_10_ready = _T_1804 ? SLR2_io_frontier_in_10_ready : crossbar_array_visit_io_in_80_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_11_ready = _T_1806 ? SLR2_io_frontier_in_11_ready : crossbar_array_visit_io_in_112_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_12_ready = _T_1808 ? SLR2_io_frontier_in_12_ready : crossbar_array_visit_io_in_17_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_13_ready = _T_1810 ? SLR2_io_frontier_in_13_ready : crossbar_array_visit_io_in_49_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_14_ready = _T_1812 ? SLR2_io_frontier_in_14_ready : crossbar_array_visit_io_in_81_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_15_ready = _T_1814 ? SLR2_io_frontier_in_15_ready : crossbar_array_visit_io_in_113_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_16_ready = _T_1816 ? SLR2_io_frontier_in_16_ready : crossbar_array_visit_io_in_18_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_17_ready = _T_1818 ? SLR2_io_frontier_in_17_ready : crossbar_array_visit_io_in_50_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_18_ready = _T_1820 ? SLR2_io_frontier_in_18_ready : crossbar_array_visit_io_in_82_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_19_ready = _T_1822 ? SLR2_io_frontier_in_19_ready : crossbar_array_visit_io_in_114_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_20_ready = _T_1824 ? SLR2_io_frontier_in_20_ready : crossbar_array_visit_io_in_19_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_21_ready = _T_1826 ? SLR2_io_frontier_in_21_ready : crossbar_array_visit_io_in_51_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_22_ready = _T_1828 ? SLR2_io_frontier_in_22_ready : crossbar_array_visit_io_in_83_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_23_ready = _T_1830 ? SLR2_io_frontier_in_23_ready : crossbar_array_visit_io_in_115_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_24_ready = _T_1832 ? SLR2_io_frontier_in_24_ready : crossbar_array_visit_io_in_20_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_25_ready = _T_1834 ? SLR2_io_frontier_in_25_ready : crossbar_array_visit_io_in_52_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_26_ready = _T_1836 ? SLR2_io_frontier_in_26_ready : crossbar_array_visit_io_in_84_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_27_ready = _T_1838 ? SLR2_io_frontier_in_27_ready : crossbar_array_visit_io_in_116_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_28_ready = _T_1840 ? SLR2_io_frontier_in_28_ready : crossbar_array_visit_io_in_21_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_29_ready = _T_1842 ? SLR2_io_frontier_in_29_ready : crossbar_array_visit_io_in_53_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_30_ready = _T_1844 ? SLR2_io_frontier_in_30_ready : crossbar_array_visit_io_in_85_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_31_ready = _T_1846 ? SLR2_io_frontier_in_31_ready : crossbar_array_visit_io_in_117_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_32_ready = _T_1848 ? SLR2_io_frontier_in_32_ready : crossbar_array_visit_io_in_22_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_33_ready = _T_1850 ? SLR2_io_frontier_in_33_ready : crossbar_array_visit_io_in_54_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_34_ready = _T_1852 ? SLR2_io_frontier_in_34_ready : crossbar_array_visit_io_in_86_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_35_ready = _T_1854 ? SLR2_io_frontier_in_35_ready : crossbar_array_visit_io_in_118_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_36_ready = _T_1856 ? SLR2_io_frontier_in_36_ready : crossbar_array_visit_io_in_23_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_37_ready = _T_1858 ? SLR2_io_frontier_in_37_ready : crossbar_array_visit_io_in_55_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_38_ready = _T_1860 ? SLR2_io_frontier_in_38_ready : crossbar_array_visit_io_in_87_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_39_ready = _T_1862 ? SLR2_io_frontier_in_39_ready : crossbar_array_visit_io_in_119_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_40_ready = _T_1864 ? SLR2_io_frontier_in_40_ready : crossbar_array_visit_io_in_24_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_41_ready = _T_1866 ? SLR2_io_frontier_in_41_ready : crossbar_array_visit_io_in_56_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_42_ready = _T_1868 ? SLR2_io_frontier_in_42_ready : crossbar_array_visit_io_in_88_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_43_ready = _T_1870 ? SLR2_io_frontier_in_43_ready : crossbar_array_visit_io_in_120_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_44_ready = _T_1872 ? SLR2_io_frontier_in_44_ready : crossbar_array_visit_io_in_25_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_45_ready = _T_1874 ? SLR2_io_frontier_in_45_ready : crossbar_array_visit_io_in_57_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_46_ready = _T_1876 ? SLR2_io_frontier_in_46_ready : crossbar_array_visit_io_in_89_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_47_ready = _T_1878 ? SLR2_io_frontier_in_47_ready : crossbar_array_visit_io_in_121_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_48_ready = _T_1880 ? SLR2_io_frontier_in_48_ready : crossbar_array_visit_io_in_26_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_49_ready = _T_1882 ? SLR2_io_frontier_in_49_ready : crossbar_array_visit_io_in_58_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_50_ready = _T_1884 ? SLR2_io_frontier_in_50_ready : crossbar_array_visit_io_in_90_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_51_ready = _T_1886 ? SLR2_io_frontier_in_51_ready : crossbar_array_visit_io_in_122_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_52_ready = _T_1888 ? SLR2_io_frontier_in_52_ready : crossbar_array_visit_io_in_27_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_53_ready = _T_1890 ? SLR2_io_frontier_in_53_ready : crossbar_array_visit_io_in_59_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_54_ready = _T_1892 ? SLR2_io_frontier_in_54_ready : crossbar_array_visit_io_in_91_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_55_ready = _T_1894 ? SLR2_io_frontier_in_55_ready : crossbar_array_visit_io_in_123_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_56_ready = _T_1896 ? SLR2_io_frontier_in_56_ready : crossbar_array_visit_io_in_28_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_57_ready = _T_1898 ? SLR2_io_frontier_in_57_ready : crossbar_array_visit_io_in_60_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_58_ready = _T_1900 ? SLR2_io_frontier_in_58_ready : crossbar_array_visit_io_in_92_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_59_ready = _T_1902 ? SLR2_io_frontier_in_59_ready : crossbar_array_visit_io_in_124_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_60_ready = _T_1904 ? SLR2_io_frontier_in_60_ready : crossbar_array_visit_io_in_29_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_61_ready = _T_1906 ? SLR2_io_frontier_in_61_ready : crossbar_array_visit_io_in_61_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_62_ready = _T_1908 ? SLR2_io_frontier_in_62_ready : crossbar_array_visit_io_in_93_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_63_ready = _T_1910 ? SLR2_io_frontier_in_63_ready : crossbar_array_visit_io_in_125_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_64_ready = _T_1912 ? SLR2_io_frontier_in_64_ready : crossbar_array_visit_io_in_30_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_65_ready = _T_1914 ? SLR2_io_frontier_in_65_ready : crossbar_array_visit_io_in_62_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_66_ready = _T_1916 ? SLR2_io_frontier_in_66_ready : crossbar_array_visit_io_in_94_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_67_ready = _T_1918 ? SLR2_io_frontier_in_67_ready : crossbar_array_visit_io_in_126_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_68_ready = _T_1920 ? SLR2_io_frontier_in_68_ready : crossbar_array_visit_io_in_31_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_69_ready = _T_1922 ? SLR2_io_frontier_in_69_ready : crossbar_array_visit_io_in_63_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_70_ready = _T_1924 ? SLR2_io_frontier_in_70_ready : crossbar_array_visit_io_in_95_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_p2_out_71_ready = _T_1926 ? SLR2_io_frontier_in_71_ready : crossbar_array_visit_io_in_127_ready; // @[Top-slr.scala 500:120 Top-slr.scala 503:71]
  assign SLR2_io_R_array_index_0_ready = R_array_index_02_slr2_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_1_ready = R_array_index_02_slr2_1_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_2_ready = R_array_index_02_slr2_2_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_3_ready = R_array_index_02_slr2_3_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_4_ready = R_array_index_02_slr2_4_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_5_ready = R_array_index_02_slr2_5_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_6_ready = R_array_index_02_slr2_6_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_7_ready = R_array_index_02_slr2_7_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_8_ready = R_array_index_02_slr2_8_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_9_ready = R_array_index_02_slr2_9_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_10_ready = R_array_index_02_slr2_10_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_11_ready = R_array_index_02_slr2_11_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_12_ready = R_array_index_02_slr2_12_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_13_ready = R_array_index_02_slr2_13_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_14_ready = R_array_index_02_slr2_14_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_15_ready = R_array_index_02_slr2_15_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_16_ready = R_array_index_02_slr2_16_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_17_ready = R_array_index_02_slr2_17_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_18_ready = R_array_index_02_slr2_18_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_19_ready = R_array_index_02_slr2_19_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_20_ready = R_array_index_02_slr2_20_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_21_ready = R_array_index_02_slr2_21_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_22_ready = R_array_index_02_slr2_22_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_23_ready = R_array_index_02_slr2_23_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_24_ready = R_array_index_02_slr2_24_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_25_ready = R_array_index_02_slr2_25_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_26_ready = R_array_index_02_slr2_26_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_27_ready = R_array_index_02_slr2_27_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_28_ready = R_array_index_02_slr2_28_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_29_ready = R_array_index_02_slr2_29_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_30_ready = R_array_index_02_slr2_30_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_31_ready = R_array_index_02_slr2_31_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_32_ready = R_array_index_02_slr2_32_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_33_ready = R_array_index_02_slr2_33_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_34_ready = R_array_index_02_slr2_34_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_35_ready = R_array_index_02_slr2_35_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_36_ready = R_array_index_02_slr2_36_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_37_ready = R_array_index_02_slr2_37_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_38_ready = R_array_index_02_slr2_38_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_39_ready = R_array_index_02_slr2_39_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_40_ready = R_array_index_02_slr2_40_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_41_ready = R_array_index_02_slr2_41_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_42_ready = R_array_index_02_slr2_42_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_43_ready = R_array_index_02_slr2_43_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_44_ready = R_array_index_02_slr2_44_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_45_ready = R_array_index_02_slr2_45_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_46_ready = R_array_index_02_slr2_46_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_47_ready = R_array_index_02_slr2_47_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_48_ready = R_array_index_02_slr2_48_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_49_ready = R_array_index_02_slr2_49_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_50_ready = R_array_index_02_slr2_50_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_51_ready = R_array_index_02_slr2_51_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_52_ready = R_array_index_02_slr2_52_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_53_ready = R_array_index_02_slr2_53_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_54_ready = R_array_index_02_slr2_54_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_55_ready = R_array_index_02_slr2_55_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_56_ready = R_array_index_02_slr2_56_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_57_ready = R_array_index_02_slr2_57_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_58_ready = R_array_index_02_slr2_58_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_59_ready = R_array_index_02_slr2_59_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_60_ready = R_array_index_02_slr2_60_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_61_ready = R_array_index_02_slr2_61_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_62_ready = R_array_index_02_slr2_62_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_63_ready = R_array_index_02_slr2_63_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_64_ready = R_array_index_02_slr2_64_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_65_ready = R_array_index_02_slr2_65_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_66_ready = R_array_index_02_slr2_66_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_67_ready = R_array_index_02_slr2_67_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_68_ready = R_array_index_02_slr2_68_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_69_ready = R_array_index_02_slr2_69_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_70_ready = R_array_index_02_slr2_70_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_R_array_index_71_ready = R_array_index_02_slr2_71_enq_ready; // @[Top-slr.scala 379:47]
  assign SLR2_io_uram_addr_a_0 = uram_addr_a_02_slr2_0[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_1 = uram_addr_a_02_slr2_1[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_2 = uram_addr_a_02_slr2_2[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_3 = uram_addr_a_02_slr2_3[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_4 = uram_addr_a_02_slr2_4[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_5 = uram_addr_a_02_slr2_5[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_6 = uram_addr_a_02_slr2_6[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_7 = uram_addr_a_02_slr2_7[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_8 = uram_addr_a_02_slr2_8[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_9 = uram_addr_a_02_slr2_9[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_10 = uram_addr_a_02_slr2_10[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_11 = uram_addr_a_02_slr2_11[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_12 = uram_addr_a_02_slr2_12[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_13 = uram_addr_a_02_slr2_13[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_14 = uram_addr_a_02_slr2_14[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_15 = uram_addr_a_02_slr2_15[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_16 = uram_addr_a_02_slr2_16[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_17 = uram_addr_a_02_slr2_17[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_18 = uram_addr_a_02_slr2_18[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_19 = uram_addr_a_02_slr2_19[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_20 = uram_addr_a_02_slr2_20[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_21 = uram_addr_a_02_slr2_21[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_22 = uram_addr_a_02_slr2_22[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_23 = uram_addr_a_02_slr2_23[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_24 = uram_addr_a_02_slr2_24[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_25 = uram_addr_a_02_slr2_25[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_26 = uram_addr_a_02_slr2_26[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_27 = uram_addr_a_02_slr2_27[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_28 = uram_addr_a_02_slr2_28[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_29 = uram_addr_a_02_slr2_29[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_30 = uram_addr_a_02_slr2_30[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_31 = uram_addr_a_02_slr2_31[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_32 = uram_addr_a_02_slr2_32[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_33 = uram_addr_a_02_slr2_33[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_34 = uram_addr_a_02_slr2_34[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_35 = uram_addr_a_02_slr2_35[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_36 = uram_addr_a_02_slr2_36[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_37 = uram_addr_a_02_slr2_37[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_38 = uram_addr_a_02_slr2_38[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_39 = uram_addr_a_02_slr2_39[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_40 = uram_addr_a_02_slr2_40[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_41 = uram_addr_a_02_slr2_41[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_42 = uram_addr_a_02_slr2_42[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_43 = uram_addr_a_02_slr2_43[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_44 = uram_addr_a_02_slr2_44[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_45 = uram_addr_a_02_slr2_45[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_46 = uram_addr_a_02_slr2_46[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_47 = uram_addr_a_02_slr2_47[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_48 = uram_addr_a_02_slr2_48[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_49 = uram_addr_a_02_slr2_49[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_50 = uram_addr_a_02_slr2_50[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_51 = uram_addr_a_02_slr2_51[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_52 = uram_addr_a_02_slr2_52[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_53 = uram_addr_a_02_slr2_53[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_54 = uram_addr_a_02_slr2_54[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_55 = uram_addr_a_02_slr2_55[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_56 = uram_addr_a_02_slr2_56[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_57 = uram_addr_a_02_slr2_57[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_58 = uram_addr_a_02_slr2_58[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_59 = uram_addr_a_02_slr2_59[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_60 = uram_addr_a_02_slr2_60[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_61 = uram_addr_a_02_slr2_61[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_62 = uram_addr_a_02_slr2_62[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_63 = uram_addr_a_02_slr2_63[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_64 = uram_addr_a_02_slr2_64[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_65 = uram_addr_a_02_slr2_65[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_66 = uram_addr_a_02_slr2_66[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_67 = uram_addr_a_02_slr2_67[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_68 = uram_addr_a_02_slr2_68[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_69 = uram_addr_a_02_slr2_69[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_70 = uram_addr_a_02_slr2_70[19:0]; // @[Top-slr.scala 354:32]
  assign SLR2_io_uram_addr_a_71 = uram_addr_a_02_slr2_71[19:0]; // @[Top-slr.scala 354:32]
  assign crossbar_array_mem_clock = clock;
  assign crossbar_array_mem_reset = reset;
  assign crossbar_array_mem_io_in_0_valid = SLR0_Mem_io_neighbours_0_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_0_bits = SLR0_Mem_io_neighbours_0_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_1_valid = SLR0_Mem_io_neighbours_1_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_1_bits = SLR0_Mem_io_neighbours_1_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_2_valid = SLR0_Mem_io_neighbours_2_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_2_bits = SLR0_Mem_io_neighbours_2_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_3_valid = SLR0_Mem_io_neighbours_3_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_3_bits = SLR0_Mem_io_neighbours_3_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_4_valid = SLR0_Mem_io_neighbours_4_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_4_bits = SLR0_Mem_io_neighbours_4_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_5_valid = SLR0_Mem_io_neighbours_5_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_5_bits = SLR0_Mem_io_neighbours_5_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_6_valid = SLR0_Mem_io_neighbours_6_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_6_bits = SLR0_Mem_io_neighbours_6_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_7_valid = SLR0_Mem_io_neighbours_7_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_7_bits = SLR0_Mem_io_neighbours_7_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_8_valid = SLR0_Mem_io_neighbours_8_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_8_bits = SLR0_Mem_io_neighbours_8_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_9_valid = SLR0_Mem_io_neighbours_9_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_9_bits = SLR0_Mem_io_neighbours_9_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_10_valid = SLR0_Mem_io_neighbours_10_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_10_bits = SLR0_Mem_io_neighbours_10_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_11_valid = SLR0_Mem_io_neighbours_11_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_11_bits = SLR0_Mem_io_neighbours_11_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_12_valid = SLR0_Mem_io_neighbours_12_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_12_bits = SLR0_Mem_io_neighbours_12_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_13_valid = SLR0_Mem_io_neighbours_13_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_13_bits = SLR0_Mem_io_neighbours_13_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_14_valid = SLR0_Mem_io_neighbours_14_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_14_bits = SLR0_Mem_io_neighbours_14_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_15_valid = SLR0_Mem_io_neighbours_15_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_15_bits = SLR0_Mem_io_neighbours_15_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_16_valid = SLR0_Mem_io_neighbours_16_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_16_bits = SLR0_Mem_io_neighbours_16_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_17_valid = SLR0_Mem_io_neighbours_17_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_17_bits = SLR0_Mem_io_neighbours_17_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_18_valid = SLR0_Mem_io_neighbours_18_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_18_bits = SLR0_Mem_io_neighbours_18_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_19_valid = SLR0_Mem_io_neighbours_19_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_19_bits = SLR0_Mem_io_neighbours_19_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_20_valid = SLR0_Mem_io_neighbours_20_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_20_bits = SLR0_Mem_io_neighbours_20_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_21_valid = SLR0_Mem_io_neighbours_21_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_21_bits = SLR0_Mem_io_neighbours_21_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_22_valid = SLR0_Mem_io_neighbours_22_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_22_bits = SLR0_Mem_io_neighbours_22_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_23_valid = SLR0_Mem_io_neighbours_23_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_23_bits = SLR0_Mem_io_neighbours_23_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_24_valid = SLR0_Mem_io_neighbours_24_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_24_bits = SLR0_Mem_io_neighbours_24_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_25_valid = SLR0_Mem_io_neighbours_25_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_25_bits = SLR0_Mem_io_neighbours_25_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_26_valid = SLR0_Mem_io_neighbours_26_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_26_bits = SLR0_Mem_io_neighbours_26_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_27_valid = SLR0_Mem_io_neighbours_27_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_27_bits = SLR0_Mem_io_neighbours_27_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_28_valid = SLR0_Mem_io_neighbours_28_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_28_bits = SLR0_Mem_io_neighbours_28_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_29_valid = SLR0_Mem_io_neighbours_29_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_29_bits = SLR0_Mem_io_neighbours_29_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_30_valid = SLR0_Mem_io_neighbours_30_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_30_bits = SLR0_Mem_io_neighbours_30_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_31_valid = SLR0_Mem_io_neighbours_31_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_31_bits = SLR0_Mem_io_neighbours_31_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_32_valid = SLR0_Mem_io_neighbours_32_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_32_bits = SLR0_Mem_io_neighbours_32_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_33_valid = SLR0_Mem_io_neighbours_33_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_33_bits = SLR0_Mem_io_neighbours_33_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_34_valid = SLR0_Mem_io_neighbours_34_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_34_bits = SLR0_Mem_io_neighbours_34_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_35_valid = SLR0_Mem_io_neighbours_35_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_35_bits = SLR0_Mem_io_neighbours_35_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_36_valid = SLR0_Mem_io_neighbours_36_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_36_bits = SLR0_Mem_io_neighbours_36_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_37_valid = SLR0_Mem_io_neighbours_37_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_37_bits = SLR0_Mem_io_neighbours_37_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_38_valid = SLR0_Mem_io_neighbours_38_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_38_bits = SLR0_Mem_io_neighbours_38_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_39_valid = SLR0_Mem_io_neighbours_39_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_39_bits = SLR0_Mem_io_neighbours_39_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_40_valid = SLR0_Mem_io_neighbours_40_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_40_bits = SLR0_Mem_io_neighbours_40_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_41_valid = SLR0_Mem_io_neighbours_41_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_41_bits = SLR0_Mem_io_neighbours_41_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_42_valid = SLR0_Mem_io_neighbours_42_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_42_bits = SLR0_Mem_io_neighbours_42_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_43_valid = SLR0_Mem_io_neighbours_43_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_43_bits = SLR0_Mem_io_neighbours_43_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_44_valid = SLR0_Mem_io_neighbours_44_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_44_bits = SLR0_Mem_io_neighbours_44_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_45_valid = SLR0_Mem_io_neighbours_45_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_45_bits = SLR0_Mem_io_neighbours_45_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_46_valid = SLR0_Mem_io_neighbours_46_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_46_bits = SLR0_Mem_io_neighbours_46_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_47_valid = SLR0_Mem_io_neighbours_47_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_47_bits = SLR0_Mem_io_neighbours_47_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_48_valid = SLR0_Mem_io_neighbours_48_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_48_bits = SLR0_Mem_io_neighbours_48_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_49_valid = SLR0_Mem_io_neighbours_49_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_49_bits = SLR0_Mem_io_neighbours_49_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_50_valid = SLR0_Mem_io_neighbours_50_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_50_bits = SLR0_Mem_io_neighbours_50_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_51_valid = SLR0_Mem_io_neighbours_51_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_51_bits = SLR0_Mem_io_neighbours_51_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_52_valid = SLR0_Mem_io_neighbours_52_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_52_bits = SLR0_Mem_io_neighbours_52_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_53_valid = SLR0_Mem_io_neighbours_53_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_53_bits = SLR0_Mem_io_neighbours_53_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_54_valid = SLR0_Mem_io_neighbours_54_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_54_bits = SLR0_Mem_io_neighbours_54_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_55_valid = SLR0_Mem_io_neighbours_55_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_55_bits = SLR0_Mem_io_neighbours_55_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_56_valid = SLR0_Mem_io_neighbours_56_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_56_bits = SLR0_Mem_io_neighbours_56_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_57_valid = SLR0_Mem_io_neighbours_57_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_57_bits = SLR0_Mem_io_neighbours_57_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_58_valid = SLR0_Mem_io_neighbours_58_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_58_bits = SLR0_Mem_io_neighbours_58_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_59_valid = SLR0_Mem_io_neighbours_59_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_59_bits = SLR0_Mem_io_neighbours_59_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_60_valid = SLR0_Mem_io_neighbours_60_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_60_bits = SLR0_Mem_io_neighbours_60_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_61_valid = SLR0_Mem_io_neighbours_61_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_61_bits = SLR0_Mem_io_neighbours_61_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_62_valid = SLR0_Mem_io_neighbours_62_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_62_bits = SLR0_Mem_io_neighbours_62_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_63_valid = SLR0_Mem_io_neighbours_63_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_63_bits = SLR0_Mem_io_neighbours_63_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_64_valid = SLR0_Mem_io_neighbours_64_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_64_bits = SLR0_Mem_io_neighbours_64_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_65_valid = SLR0_Mem_io_neighbours_65_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_65_bits = SLR0_Mem_io_neighbours_65_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_66_valid = SLR0_Mem_io_neighbours_66_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_66_bits = SLR0_Mem_io_neighbours_66_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_67_valid = SLR0_Mem_io_neighbours_67_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_67_bits = SLR0_Mem_io_neighbours_67_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_68_valid = SLR0_Mem_io_neighbours_68_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_68_bits = SLR0_Mem_io_neighbours_68_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_69_valid = SLR0_Mem_io_neighbours_69_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_69_bits = SLR0_Mem_io_neighbours_69_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_70_valid = SLR0_Mem_io_neighbours_70_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_70_bits = SLR0_Mem_io_neighbours_70_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_71_valid = SLR0_Mem_io_neighbours_71_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_71_bits = SLR0_Mem_io_neighbours_71_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_72_valid = SLR0_Mem_io_neighbours_72_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_72_bits = SLR0_Mem_io_neighbours_72_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_73_valid = SLR0_Mem_io_neighbours_73_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_73_bits = SLR0_Mem_io_neighbours_73_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_74_valid = SLR0_Mem_io_neighbours_74_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_74_bits = SLR0_Mem_io_neighbours_74_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_75_valid = SLR0_Mem_io_neighbours_75_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_75_bits = SLR0_Mem_io_neighbours_75_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_76_valid = SLR0_Mem_io_neighbours_76_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_76_bits = SLR0_Mem_io_neighbours_76_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_77_valid = SLR0_Mem_io_neighbours_77_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_77_bits = SLR0_Mem_io_neighbours_77_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_78_valid = SLR0_Mem_io_neighbours_78_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_78_bits = SLR0_Mem_io_neighbours_78_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_79_valid = SLR0_Mem_io_neighbours_79_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_79_bits = SLR0_Mem_io_neighbours_79_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_80_valid = SLR0_Mem_io_neighbours_80_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_80_bits = SLR0_Mem_io_neighbours_80_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_81_valid = SLR0_Mem_io_neighbours_81_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_81_bits = SLR0_Mem_io_neighbours_81_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_82_valid = SLR0_Mem_io_neighbours_82_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_82_bits = SLR0_Mem_io_neighbours_82_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_83_valid = SLR0_Mem_io_neighbours_83_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_83_bits = SLR0_Mem_io_neighbours_83_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_84_valid = SLR0_Mem_io_neighbours_84_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_84_bits = SLR0_Mem_io_neighbours_84_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_85_valid = SLR0_Mem_io_neighbours_85_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_85_bits = SLR0_Mem_io_neighbours_85_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_86_valid = SLR0_Mem_io_neighbours_86_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_86_bits = SLR0_Mem_io_neighbours_86_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_87_valid = SLR0_Mem_io_neighbours_87_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_87_bits = SLR0_Mem_io_neighbours_87_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_88_valid = SLR0_Mem_io_neighbours_88_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_88_bits = SLR0_Mem_io_neighbours_88_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_89_valid = SLR0_Mem_io_neighbours_89_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_89_bits = SLR0_Mem_io_neighbours_89_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_90_valid = SLR0_Mem_io_neighbours_90_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_90_bits = SLR0_Mem_io_neighbours_90_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_91_valid = SLR0_Mem_io_neighbours_91_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_91_bits = SLR0_Mem_io_neighbours_91_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_92_valid = SLR0_Mem_io_neighbours_92_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_92_bits = SLR0_Mem_io_neighbours_92_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_93_valid = SLR0_Mem_io_neighbours_93_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_93_bits = SLR0_Mem_io_neighbours_93_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_94_valid = SLR0_Mem_io_neighbours_94_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_94_bits = SLR0_Mem_io_neighbours_94_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_95_valid = SLR0_Mem_io_neighbours_95_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_95_bits = SLR0_Mem_io_neighbours_95_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_96_valid = SLR0_Mem_io_neighbours_96_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_96_bits = SLR0_Mem_io_neighbours_96_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_97_valid = SLR0_Mem_io_neighbours_97_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_97_bits = SLR0_Mem_io_neighbours_97_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_98_valid = SLR0_Mem_io_neighbours_98_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_98_bits = SLR0_Mem_io_neighbours_98_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_99_valid = SLR0_Mem_io_neighbours_99_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_99_bits = SLR0_Mem_io_neighbours_99_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_100_valid = SLR0_Mem_io_neighbours_100_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_100_bits = SLR0_Mem_io_neighbours_100_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_101_valid = SLR0_Mem_io_neighbours_101_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_101_bits = SLR0_Mem_io_neighbours_101_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_102_valid = SLR0_Mem_io_neighbours_102_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_102_bits = SLR0_Mem_io_neighbours_102_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_103_valid = SLR0_Mem_io_neighbours_103_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_103_bits = SLR0_Mem_io_neighbours_103_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_104_valid = SLR0_Mem_io_neighbours_104_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_104_bits = SLR0_Mem_io_neighbours_104_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_105_valid = SLR0_Mem_io_neighbours_105_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_105_bits = SLR0_Mem_io_neighbours_105_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_106_valid = SLR0_Mem_io_neighbours_106_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_106_bits = SLR0_Mem_io_neighbours_106_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_107_valid = SLR0_Mem_io_neighbours_107_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_107_bits = SLR0_Mem_io_neighbours_107_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_108_valid = SLR0_Mem_io_neighbours_108_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_108_bits = SLR0_Mem_io_neighbours_108_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_109_valid = SLR0_Mem_io_neighbours_109_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_109_bits = SLR0_Mem_io_neighbours_109_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_110_valid = SLR0_Mem_io_neighbours_110_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_110_bits = SLR0_Mem_io_neighbours_110_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_111_valid = SLR0_Mem_io_neighbours_111_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_111_bits = SLR0_Mem_io_neighbours_111_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_112_valid = SLR0_Mem_io_neighbours_112_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_112_bits = SLR0_Mem_io_neighbours_112_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_113_valid = SLR0_Mem_io_neighbours_113_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_113_bits = SLR0_Mem_io_neighbours_113_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_114_valid = SLR0_Mem_io_neighbours_114_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_114_bits = SLR0_Mem_io_neighbours_114_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_115_valid = SLR0_Mem_io_neighbours_115_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_115_bits = SLR0_Mem_io_neighbours_115_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_116_valid = SLR0_Mem_io_neighbours_116_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_116_bits = SLR0_Mem_io_neighbours_116_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_117_valid = SLR0_Mem_io_neighbours_117_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_117_bits = SLR0_Mem_io_neighbours_117_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_118_valid = SLR0_Mem_io_neighbours_118_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_118_bits = SLR0_Mem_io_neighbours_118_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_119_valid = SLR0_Mem_io_neighbours_119_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_119_bits = SLR0_Mem_io_neighbours_119_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_120_valid = SLR0_Mem_io_neighbours_120_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_120_bits = SLR0_Mem_io_neighbours_120_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_121_valid = SLR0_Mem_io_neighbours_121_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_121_bits = SLR0_Mem_io_neighbours_121_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_122_valid = SLR0_Mem_io_neighbours_122_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_122_bits = SLR0_Mem_io_neighbours_122_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_123_valid = SLR0_Mem_io_neighbours_123_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_123_bits = SLR0_Mem_io_neighbours_123_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_124_valid = SLR0_Mem_io_neighbours_124_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_124_bits = SLR0_Mem_io_neighbours_124_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_125_valid = SLR0_Mem_io_neighbours_125_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_125_bits = SLR0_Mem_io_neighbours_125_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_126_valid = SLR0_Mem_io_neighbours_126_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_126_bits = SLR0_Mem_io_neighbours_126_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_127_valid = SLR0_Mem_io_neighbours_127_valid; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_in_127_bits = SLR0_Mem_io_neighbours_127_bits[47:0]; // @[Top-slr.scala 424:38]
  assign crossbar_array_mem_io_out_0_ready = SLR1_io_p2_in_0_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_1_ready = SLR1_io_p2_in_4_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_2_ready = SLR1_io_p2_in_8_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_3_ready = SLR1_io_p2_in_12_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_4_ready = SLR1_io_p2_in_16_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_5_ready = SLR1_io_p2_in_20_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_6_ready = SLR1_io_p2_in_24_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_7_ready = SLR1_io_p2_in_28_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_8_ready = SLR1_io_p2_in_32_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_9_ready = SLR1_io_p2_in_36_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_10_ready = SLR1_io_p2_in_40_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_11_ready = SLR1_io_p2_in_44_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_12_ready = SLR1_io_p2_in_48_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_13_ready = SLR1_io_p2_in_52_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_14_ready = SLR2_io_p2_in_0_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_15_ready = SLR2_io_p2_in_4_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_16_ready = SLR2_io_p2_in_8_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_17_ready = SLR2_io_p2_in_12_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_18_ready = SLR2_io_p2_in_16_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_19_ready = SLR2_io_p2_in_20_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_20_ready = SLR2_io_p2_in_24_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_21_ready = SLR2_io_p2_in_28_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_22_ready = SLR2_io_p2_in_32_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_23_ready = SLR2_io_p2_in_36_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_24_ready = SLR2_io_p2_in_40_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_25_ready = SLR2_io_p2_in_44_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_26_ready = SLR2_io_p2_in_48_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_27_ready = SLR2_io_p2_in_52_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_28_ready = SLR2_io_p2_in_56_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_29_ready = SLR2_io_p2_in_60_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_30_ready = SLR2_io_p2_in_64_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_31_ready = SLR2_io_p2_in_68_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_32_ready = SLR1_io_p2_in_1_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_33_ready = SLR1_io_p2_in_5_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_34_ready = SLR1_io_p2_in_9_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_35_ready = SLR1_io_p2_in_13_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_36_ready = SLR1_io_p2_in_17_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_37_ready = SLR1_io_p2_in_21_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_38_ready = SLR1_io_p2_in_25_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_39_ready = SLR1_io_p2_in_29_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_40_ready = SLR1_io_p2_in_33_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_41_ready = SLR1_io_p2_in_37_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_42_ready = SLR1_io_p2_in_41_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_43_ready = SLR1_io_p2_in_45_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_44_ready = SLR1_io_p2_in_49_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_45_ready = SLR1_io_p2_in_53_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_46_ready = SLR2_io_p2_in_1_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_47_ready = SLR2_io_p2_in_5_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_48_ready = SLR2_io_p2_in_9_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_49_ready = SLR2_io_p2_in_13_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_50_ready = SLR2_io_p2_in_17_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_51_ready = SLR2_io_p2_in_21_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_52_ready = SLR2_io_p2_in_25_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_53_ready = SLR2_io_p2_in_29_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_54_ready = SLR2_io_p2_in_33_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_55_ready = SLR2_io_p2_in_37_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_56_ready = SLR2_io_p2_in_41_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_57_ready = SLR2_io_p2_in_45_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_58_ready = SLR2_io_p2_in_49_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_59_ready = SLR2_io_p2_in_53_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_60_ready = SLR2_io_p2_in_57_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_61_ready = SLR2_io_p2_in_61_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_62_ready = SLR2_io_p2_in_65_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_63_ready = SLR2_io_p2_in_69_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_64_ready = SLR1_io_p2_in_2_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_65_ready = SLR1_io_p2_in_6_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_66_ready = SLR1_io_p2_in_10_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_67_ready = SLR1_io_p2_in_14_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_68_ready = SLR1_io_p2_in_18_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_69_ready = SLR1_io_p2_in_22_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_70_ready = SLR1_io_p2_in_26_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_71_ready = SLR1_io_p2_in_30_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_72_ready = SLR1_io_p2_in_34_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_73_ready = SLR1_io_p2_in_38_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_74_ready = SLR1_io_p2_in_42_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_75_ready = SLR1_io_p2_in_46_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_76_ready = SLR1_io_p2_in_50_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_77_ready = SLR1_io_p2_in_54_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_78_ready = SLR2_io_p2_in_2_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_79_ready = SLR2_io_p2_in_6_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_80_ready = SLR2_io_p2_in_10_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_81_ready = SLR2_io_p2_in_14_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_82_ready = SLR2_io_p2_in_18_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_83_ready = SLR2_io_p2_in_22_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_84_ready = SLR2_io_p2_in_26_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_85_ready = SLR2_io_p2_in_30_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_86_ready = SLR2_io_p2_in_34_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_87_ready = SLR2_io_p2_in_38_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_88_ready = SLR2_io_p2_in_42_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_89_ready = SLR2_io_p2_in_46_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_90_ready = SLR2_io_p2_in_50_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_91_ready = SLR2_io_p2_in_54_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_92_ready = SLR2_io_p2_in_58_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_93_ready = SLR2_io_p2_in_62_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_94_ready = SLR2_io_p2_in_66_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_95_ready = SLR2_io_p2_in_70_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_96_ready = SLR1_io_p2_in_3_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_97_ready = SLR1_io_p2_in_7_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_98_ready = SLR1_io_p2_in_11_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_99_ready = SLR1_io_p2_in_15_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_100_ready = SLR1_io_p2_in_19_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_101_ready = SLR1_io_p2_in_23_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_102_ready = SLR1_io_p2_in_27_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_103_ready = SLR1_io_p2_in_31_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_104_ready = SLR1_io_p2_in_35_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_105_ready = SLR1_io_p2_in_39_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_106_ready = SLR1_io_p2_in_43_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_107_ready = SLR1_io_p2_in_47_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_108_ready = SLR1_io_p2_in_51_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_109_ready = SLR1_io_p2_in_55_ready; // @[Top-slr.scala 465:66]
  assign crossbar_array_mem_io_out_110_ready = SLR2_io_p2_in_3_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_111_ready = SLR2_io_p2_in_7_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_112_ready = SLR2_io_p2_in_11_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_113_ready = SLR2_io_p2_in_15_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_114_ready = SLR2_io_p2_in_19_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_115_ready = SLR2_io_p2_in_23_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_116_ready = SLR2_io_p2_in_27_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_117_ready = SLR2_io_p2_in_31_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_118_ready = SLR2_io_p2_in_35_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_119_ready = SLR2_io_p2_in_39_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_120_ready = SLR2_io_p2_in_43_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_121_ready = SLR2_io_p2_in_47_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_122_ready = SLR2_io_p2_in_51_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_123_ready = SLR2_io_p2_in_55_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_124_ready = SLR2_io_p2_in_59_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_125_ready = SLR2_io_p2_in_63_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_126_ready = SLR2_io_p2_in_67_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_mem_io_out_127_ready = SLR2_io_p2_in_71_ready; // @[Top-slr.scala 495:66]
  assign crossbar_array_visit_clock = clock;
  assign crossbar_array_visit_reset = reset;
  assign crossbar_array_visit_io_in_0_valid = _T_1672 ? 1'h0 : SLR1_io_p2_out_0_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_0_bits = _GEN_136[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_1_valid = _T_1680 ? 1'h0 : SLR1_io_p2_out_4_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_1_bits = _GEN_160[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_2_valid = _T_1688 ? 1'h0 : SLR1_io_p2_out_8_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_2_bits = _GEN_184[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_3_valid = _T_1696 ? 1'h0 : SLR1_io_p2_out_12_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_3_bits = _GEN_208[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_4_valid = _T_1704 ? 1'h0 : SLR1_io_p2_out_16_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_4_bits = _GEN_232[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_5_valid = _T_1712 ? 1'h0 : SLR1_io_p2_out_20_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_5_bits = _GEN_256[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_6_valid = _T_1720 ? 1'h0 : SLR1_io_p2_out_24_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_6_bits = _GEN_280[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_7_valid = _T_1728 ? 1'h0 : SLR1_io_p2_out_28_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_7_bits = _GEN_304[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_8_valid = _T_1736 ? 1'h0 : SLR1_io_p2_out_32_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_8_bits = _GEN_328[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_9_valid = _T_1744 ? 1'h0 : SLR1_io_p2_out_36_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_9_bits = _GEN_352[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_10_valid = _T_1752 ? 1'h0 : SLR1_io_p2_out_40_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_10_bits = _GEN_376[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_11_valid = _T_1760 ? 1'h0 : SLR1_io_p2_out_44_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_11_bits = _GEN_400[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_12_valid = _T_1768 ? 1'h0 : SLR1_io_p2_out_48_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_12_bits = _GEN_424[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_13_valid = _T_1776 ? 1'h0 : SLR1_io_p2_out_52_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_13_bits = _GEN_448[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_14_valid = _T_1784 ? 1'h0 : SLR2_io_p2_out_0_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_14_bits = _GEN_472[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_15_valid = _T_1792 ? 1'h0 : SLR2_io_p2_out_4_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_15_bits = _GEN_496[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_16_valid = _T_1800 ? 1'h0 : SLR2_io_p2_out_8_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_16_bits = _GEN_520[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_17_valid = _T_1808 ? 1'h0 : SLR2_io_p2_out_12_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_17_bits = _GEN_544[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_18_valid = _T_1816 ? 1'h0 : SLR2_io_p2_out_16_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_18_bits = _GEN_568[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_19_valid = _T_1824 ? 1'h0 : SLR2_io_p2_out_20_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_19_bits = _GEN_592[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_20_valid = _T_1832 ? 1'h0 : SLR2_io_p2_out_24_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_20_bits = _GEN_616[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_21_valid = _T_1840 ? 1'h0 : SLR2_io_p2_out_28_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_21_bits = _GEN_640[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_22_valid = _T_1848 ? 1'h0 : SLR2_io_p2_out_32_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_22_bits = _GEN_664[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_23_valid = _T_1856 ? 1'h0 : SLR2_io_p2_out_36_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_23_bits = _GEN_688[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_24_valid = _T_1864 ? 1'h0 : SLR2_io_p2_out_40_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_24_bits = _GEN_712[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_25_valid = _T_1872 ? 1'h0 : SLR2_io_p2_out_44_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_25_bits = _GEN_736[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_26_valid = _T_1880 ? 1'h0 : SLR2_io_p2_out_48_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_26_bits = _GEN_760[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_27_valid = _T_1888 ? 1'h0 : SLR2_io_p2_out_52_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_27_bits = _GEN_784[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_28_valid = _T_1896 ? 1'h0 : SLR2_io_p2_out_56_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_28_bits = _GEN_808[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_29_valid = _T_1904 ? 1'h0 : SLR2_io_p2_out_60_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_29_bits = _GEN_832[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_30_valid = _T_1912 ? 1'h0 : SLR2_io_p2_out_64_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_30_bits = _GEN_856[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_31_valid = _T_1920 ? 1'h0 : SLR2_io_p2_out_68_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_31_bits = _GEN_880[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_32_valid = _T_1674 ? 1'h0 : SLR1_io_p2_out_1_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_32_bits = _GEN_142[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_33_valid = _T_1682 ? 1'h0 : SLR1_io_p2_out_5_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_33_bits = _GEN_166[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_34_valid = _T_1690 ? 1'h0 : SLR1_io_p2_out_9_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_34_bits = _GEN_190[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_35_valid = _T_1698 ? 1'h0 : SLR1_io_p2_out_13_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_35_bits = _GEN_214[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_36_valid = _T_1706 ? 1'h0 : SLR1_io_p2_out_17_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_36_bits = _GEN_238[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_37_valid = _T_1714 ? 1'h0 : SLR1_io_p2_out_21_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_37_bits = _GEN_262[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_38_valid = _T_1722 ? 1'h0 : SLR1_io_p2_out_25_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_38_bits = _GEN_286[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_39_valid = _T_1730 ? 1'h0 : SLR1_io_p2_out_29_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_39_bits = _GEN_310[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_40_valid = _T_1738 ? 1'h0 : SLR1_io_p2_out_33_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_40_bits = _GEN_334[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_41_valid = _T_1746 ? 1'h0 : SLR1_io_p2_out_37_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_41_bits = _GEN_358[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_42_valid = _T_1754 ? 1'h0 : SLR1_io_p2_out_41_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_42_bits = _GEN_382[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_43_valid = _T_1762 ? 1'h0 : SLR1_io_p2_out_45_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_43_bits = _GEN_406[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_44_valid = _T_1770 ? 1'h0 : SLR1_io_p2_out_49_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_44_bits = _GEN_430[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_45_valid = _T_1778 ? 1'h0 : SLR1_io_p2_out_53_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_45_bits = _GEN_454[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_46_valid = _T_1786 ? 1'h0 : SLR2_io_p2_out_1_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_46_bits = _GEN_478[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_47_valid = _T_1794 ? 1'h0 : SLR2_io_p2_out_5_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_47_bits = _GEN_502[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_48_valid = _T_1802 ? 1'h0 : SLR2_io_p2_out_9_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_48_bits = _GEN_526[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_49_valid = _T_1810 ? 1'h0 : SLR2_io_p2_out_13_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_49_bits = _GEN_550[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_50_valid = _T_1818 ? 1'h0 : SLR2_io_p2_out_17_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_50_bits = _GEN_574[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_51_valid = _T_1826 ? 1'h0 : SLR2_io_p2_out_21_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_51_bits = _GEN_598[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_52_valid = _T_1834 ? 1'h0 : SLR2_io_p2_out_25_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_52_bits = _GEN_622[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_53_valid = _T_1842 ? 1'h0 : SLR2_io_p2_out_29_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_53_bits = _GEN_646[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_54_valid = _T_1850 ? 1'h0 : SLR2_io_p2_out_33_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_54_bits = _GEN_670[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_55_valid = _T_1858 ? 1'h0 : SLR2_io_p2_out_37_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_55_bits = _GEN_694[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_56_valid = _T_1866 ? 1'h0 : SLR2_io_p2_out_41_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_56_bits = _GEN_718[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_57_valid = _T_1874 ? 1'h0 : SLR2_io_p2_out_45_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_57_bits = _GEN_742[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_58_valid = _T_1882 ? 1'h0 : SLR2_io_p2_out_49_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_58_bits = _GEN_766[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_59_valid = _T_1890 ? 1'h0 : SLR2_io_p2_out_53_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_59_bits = _GEN_790[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_60_valid = _T_1898 ? 1'h0 : SLR2_io_p2_out_57_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_60_bits = _GEN_814[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_61_valid = _T_1906 ? 1'h0 : SLR2_io_p2_out_61_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_61_bits = _GEN_838[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_62_valid = _T_1914 ? 1'h0 : SLR2_io_p2_out_65_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_62_bits = _GEN_862[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_63_valid = _T_1922 ? 1'h0 : SLR2_io_p2_out_69_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_63_bits = _GEN_886[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_64_valid = _T_1676 ? 1'h0 : SLR1_io_p2_out_2_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_64_bits = _GEN_148[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_65_valid = _T_1684 ? 1'h0 : SLR1_io_p2_out_6_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_65_bits = _GEN_172[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_66_valid = _T_1692 ? 1'h0 : SLR1_io_p2_out_10_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_66_bits = _GEN_196[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_67_valid = _T_1700 ? 1'h0 : SLR1_io_p2_out_14_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_67_bits = _GEN_220[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_68_valid = _T_1708 ? 1'h0 : SLR1_io_p2_out_18_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_68_bits = _GEN_244[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_69_valid = _T_1716 ? 1'h0 : SLR1_io_p2_out_22_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_69_bits = _GEN_268[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_70_valid = _T_1724 ? 1'h0 : SLR1_io_p2_out_26_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_70_bits = _GEN_292[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_71_valid = _T_1732 ? 1'h0 : SLR1_io_p2_out_30_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_71_bits = _GEN_316[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_72_valid = _T_1740 ? 1'h0 : SLR1_io_p2_out_34_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_72_bits = _GEN_340[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_73_valid = _T_1748 ? 1'h0 : SLR1_io_p2_out_38_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_73_bits = _GEN_364[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_74_valid = _T_1756 ? 1'h0 : SLR1_io_p2_out_42_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_74_bits = _GEN_388[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_75_valid = _T_1764 ? 1'h0 : SLR1_io_p2_out_46_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_75_bits = _GEN_412[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_76_valid = _T_1772 ? 1'h0 : SLR1_io_p2_out_50_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_76_bits = _GEN_436[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_77_valid = _T_1780 ? 1'h0 : SLR1_io_p2_out_54_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_77_bits = _GEN_460[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_78_valid = _T_1788 ? 1'h0 : SLR2_io_p2_out_2_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_78_bits = _GEN_484[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_79_valid = _T_1796 ? 1'h0 : SLR2_io_p2_out_6_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_79_bits = _GEN_508[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_80_valid = _T_1804 ? 1'h0 : SLR2_io_p2_out_10_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_80_bits = _GEN_532[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_81_valid = _T_1812 ? 1'h0 : SLR2_io_p2_out_14_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_81_bits = _GEN_556[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_82_valid = _T_1820 ? 1'h0 : SLR2_io_p2_out_18_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_82_bits = _GEN_580[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_83_valid = _T_1828 ? 1'h0 : SLR2_io_p2_out_22_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_83_bits = _GEN_604[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_84_valid = _T_1836 ? 1'h0 : SLR2_io_p2_out_26_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_84_bits = _GEN_628[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_85_valid = _T_1844 ? 1'h0 : SLR2_io_p2_out_30_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_85_bits = _GEN_652[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_86_valid = _T_1852 ? 1'h0 : SLR2_io_p2_out_34_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_86_bits = _GEN_676[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_87_valid = _T_1860 ? 1'h0 : SLR2_io_p2_out_38_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_87_bits = _GEN_700[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_88_valid = _T_1868 ? 1'h0 : SLR2_io_p2_out_42_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_88_bits = _GEN_724[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_89_valid = _T_1876 ? 1'h0 : SLR2_io_p2_out_46_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_89_bits = _GEN_748[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_90_valid = _T_1884 ? 1'h0 : SLR2_io_p2_out_50_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_90_bits = _GEN_772[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_91_valid = _T_1892 ? 1'h0 : SLR2_io_p2_out_54_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_91_bits = _GEN_796[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_92_valid = _T_1900 ? 1'h0 : SLR2_io_p2_out_58_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_92_bits = _GEN_820[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_93_valid = _T_1908 ? 1'h0 : SLR2_io_p2_out_62_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_93_bits = _GEN_844[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_94_valid = _T_1916 ? 1'h0 : SLR2_io_p2_out_66_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_94_bits = _GEN_868[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_95_valid = _T_1924 ? 1'h0 : SLR2_io_p2_out_70_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_95_bits = _GEN_892[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_96_valid = _T_1678 ? 1'h0 : SLR1_io_p2_out_3_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_96_bits = _GEN_154[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_97_valid = _T_1686 ? 1'h0 : SLR1_io_p2_out_7_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_97_bits = _GEN_178[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_98_valid = _T_1694 ? 1'h0 : SLR1_io_p2_out_11_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_98_bits = _GEN_202[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_99_valid = _T_1702 ? 1'h0 : SLR1_io_p2_out_15_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_99_bits = _GEN_226[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_100_valid = _T_1710 ? 1'h0 : SLR1_io_p2_out_19_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_100_bits = _GEN_250[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_101_valid = _T_1718 ? 1'h0 : SLR1_io_p2_out_23_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_101_bits = _GEN_274[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_102_valid = _T_1726 ? 1'h0 : SLR1_io_p2_out_27_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_102_bits = _GEN_298[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_103_valid = _T_1734 ? 1'h0 : SLR1_io_p2_out_31_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_103_bits = _GEN_322[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_104_valid = _T_1742 ? 1'h0 : SLR1_io_p2_out_35_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_104_bits = _GEN_346[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_105_valid = _T_1750 ? 1'h0 : SLR1_io_p2_out_39_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_105_bits = _GEN_370[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_106_valid = _T_1758 ? 1'h0 : SLR1_io_p2_out_43_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_106_bits = _GEN_394[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_107_valid = _T_1766 ? 1'h0 : SLR1_io_p2_out_47_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_107_bits = _GEN_418[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_108_valid = _T_1774 ? 1'h0 : SLR1_io_p2_out_51_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_108_bits = _GEN_442[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_109_valid = _T_1782 ? 1'h0 : SLR1_io_p2_out_55_valid; // @[Top-slr.scala 469:76 Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_109_bits = _GEN_466[23:0]; // @[Top-slr.scala 473:71]
  assign crossbar_array_visit_io_in_110_valid = _T_1790 ? 1'h0 : SLR2_io_p2_out_3_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_110_bits = _GEN_490[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_111_valid = _T_1798 ? 1'h0 : SLR2_io_p2_out_7_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_111_bits = _GEN_514[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_112_valid = _T_1806 ? 1'h0 : SLR2_io_p2_out_11_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_112_bits = _GEN_538[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_113_valid = _T_1814 ? 1'h0 : SLR2_io_p2_out_15_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_113_bits = _GEN_562[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_114_valid = _T_1822 ? 1'h0 : SLR2_io_p2_out_19_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_114_bits = _GEN_586[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_115_valid = _T_1830 ? 1'h0 : SLR2_io_p2_out_23_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_115_bits = _GEN_610[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_116_valid = _T_1838 ? 1'h0 : SLR2_io_p2_out_27_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_116_bits = _GEN_634[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_117_valid = _T_1846 ? 1'h0 : SLR2_io_p2_out_31_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_117_bits = _GEN_658[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_118_valid = _T_1854 ? 1'h0 : SLR2_io_p2_out_35_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_118_bits = _GEN_682[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_119_valid = _T_1862 ? 1'h0 : SLR2_io_p2_out_39_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_119_bits = _GEN_706[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_120_valid = _T_1870 ? 1'h0 : SLR2_io_p2_out_43_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_120_bits = _GEN_730[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_121_valid = _T_1878 ? 1'h0 : SLR2_io_p2_out_47_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_121_bits = _GEN_754[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_122_valid = _T_1886 ? 1'h0 : SLR2_io_p2_out_51_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_122_bits = _GEN_778[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_123_valid = _T_1894 ? 1'h0 : SLR2_io_p2_out_55_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_123_bits = _GEN_802[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_124_valid = _T_1902 ? 1'h0 : SLR2_io_p2_out_59_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_124_bits = _GEN_826[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_125_valid = _T_1910 ? 1'h0 : SLR2_io_p2_out_63_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_125_bits = _GEN_850[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_126_valid = _T_1918 ? 1'h0 : SLR2_io_p2_out_67_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_126_bits = _GEN_874[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_127_valid = _T_1926 ? 1'h0 : SLR2_io_p2_out_71_valid; // @[Top-slr.scala 499:76 Top-slr.scala 503:71]
  assign crossbar_array_visit_io_in_127_bits = _GEN_898[23:0]; // @[Top-slr.scala 503:71]
  assign crossbar_array_visit_io_out_0_ready = SLR1_io_frontier_in_0_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_1_ready = SLR1_io_frontier_in_4_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_2_ready = SLR1_io_frontier_in_8_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_3_ready = SLR1_io_frontier_in_12_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_4_ready = SLR1_io_frontier_in_16_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_5_ready = SLR1_io_frontier_in_20_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_6_ready = SLR1_io_frontier_in_24_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_7_ready = SLR1_io_frontier_in_28_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_8_ready = SLR1_io_frontier_in_32_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_9_ready = SLR1_io_frontier_in_36_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_10_ready = SLR1_io_frontier_in_40_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_11_ready = SLR1_io_frontier_in_44_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_12_ready = SLR1_io_frontier_in_48_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_13_ready = SLR1_io_frontier_in_52_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_14_ready = SLR2_io_frontier_in_0_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_15_ready = SLR2_io_frontier_in_4_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_16_ready = SLR2_io_frontier_in_8_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_17_ready = SLR2_io_frontier_in_12_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_18_ready = SLR2_io_frontier_in_16_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_19_ready = SLR2_io_frontier_in_20_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_20_ready = SLR2_io_frontier_in_24_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_21_ready = SLR2_io_frontier_in_28_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_22_ready = SLR2_io_frontier_in_32_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_23_ready = SLR2_io_frontier_in_36_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_24_ready = SLR2_io_frontier_in_40_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_25_ready = SLR2_io_frontier_in_44_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_26_ready = SLR2_io_frontier_in_48_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_27_ready = SLR2_io_frontier_in_52_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_28_ready = SLR2_io_frontier_in_56_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_29_ready = SLR2_io_frontier_in_60_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_30_ready = SLR2_io_frontier_in_64_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_31_ready = SLR2_io_frontier_in_68_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_32_ready = SLR1_io_frontier_in_1_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_33_ready = SLR1_io_frontier_in_5_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_34_ready = SLR1_io_frontier_in_9_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_35_ready = SLR1_io_frontier_in_13_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_36_ready = SLR1_io_frontier_in_17_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_37_ready = SLR1_io_frontier_in_21_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_38_ready = SLR1_io_frontier_in_25_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_39_ready = SLR1_io_frontier_in_29_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_40_ready = SLR1_io_frontier_in_33_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_41_ready = SLR1_io_frontier_in_37_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_42_ready = SLR1_io_frontier_in_41_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_43_ready = SLR1_io_frontier_in_45_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_44_ready = SLR1_io_frontier_in_49_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_45_ready = SLR1_io_frontier_in_53_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_46_ready = SLR2_io_frontier_in_1_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_47_ready = SLR2_io_frontier_in_5_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_48_ready = SLR2_io_frontier_in_9_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_49_ready = SLR2_io_frontier_in_13_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_50_ready = SLR2_io_frontier_in_17_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_51_ready = SLR2_io_frontier_in_21_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_52_ready = SLR2_io_frontier_in_25_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_53_ready = SLR2_io_frontier_in_29_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_54_ready = SLR2_io_frontier_in_33_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_55_ready = SLR2_io_frontier_in_37_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_56_ready = SLR2_io_frontier_in_41_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_57_ready = SLR2_io_frontier_in_45_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_58_ready = SLR2_io_frontier_in_49_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_59_ready = SLR2_io_frontier_in_53_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_60_ready = SLR2_io_frontier_in_57_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_61_ready = SLR2_io_frontier_in_61_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_62_ready = SLR2_io_frontier_in_65_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_63_ready = SLR2_io_frontier_in_69_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_64_ready = SLR1_io_frontier_in_2_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_65_ready = SLR1_io_frontier_in_6_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_66_ready = SLR1_io_frontier_in_10_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_67_ready = SLR1_io_frontier_in_14_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_68_ready = SLR1_io_frontier_in_18_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_69_ready = SLR1_io_frontier_in_22_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_70_ready = SLR1_io_frontier_in_26_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_71_ready = SLR1_io_frontier_in_30_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_72_ready = SLR1_io_frontier_in_34_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_73_ready = SLR1_io_frontier_in_38_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_74_ready = SLR1_io_frontier_in_42_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_75_ready = SLR1_io_frontier_in_46_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_76_ready = SLR1_io_frontier_in_50_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_77_ready = SLR1_io_frontier_in_54_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_78_ready = SLR2_io_frontier_in_2_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_79_ready = SLR2_io_frontier_in_6_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_80_ready = SLR2_io_frontier_in_10_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_81_ready = SLR2_io_frontier_in_14_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_82_ready = SLR2_io_frontier_in_18_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_83_ready = SLR2_io_frontier_in_22_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_84_ready = SLR2_io_frontier_in_26_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_85_ready = SLR2_io_frontier_in_30_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_86_ready = SLR2_io_frontier_in_34_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_87_ready = SLR2_io_frontier_in_38_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_88_ready = SLR2_io_frontier_in_42_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_89_ready = SLR2_io_frontier_in_46_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_90_ready = SLR2_io_frontier_in_50_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_91_ready = SLR2_io_frontier_in_54_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_92_ready = SLR2_io_frontier_in_58_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_93_ready = SLR2_io_frontier_in_62_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_94_ready = SLR2_io_frontier_in_66_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_95_ready = SLR2_io_frontier_in_70_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_96_ready = SLR1_io_frontier_in_3_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_97_ready = SLR1_io_frontier_in_7_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_98_ready = SLR1_io_frontier_in_11_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_99_ready = SLR1_io_frontier_in_15_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_100_ready = SLR1_io_frontier_in_19_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_101_ready = SLR1_io_frontier_in_23_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_102_ready = SLR1_io_frontier_in_27_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_103_ready = SLR1_io_frontier_in_31_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_104_ready = SLR1_io_frontier_in_35_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_105_ready = SLR1_io_frontier_in_39_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_106_ready = SLR1_io_frontier_in_43_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_107_ready = SLR1_io_frontier_in_47_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_108_ready = SLR1_io_frontier_in_51_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_109_ready = SLR1_io_frontier_in_55_ready; // @[Top-slr.scala 474:71]
  assign crossbar_array_visit_io_out_110_ready = SLR2_io_frontier_in_3_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_111_ready = SLR2_io_frontier_in_7_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_112_ready = SLR2_io_frontier_in_11_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_113_ready = SLR2_io_frontier_in_15_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_114_ready = SLR2_io_frontier_in_19_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_115_ready = SLR2_io_frontier_in_23_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_116_ready = SLR2_io_frontier_in_27_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_117_ready = SLR2_io_frontier_in_31_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_118_ready = SLR2_io_frontier_in_35_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_119_ready = SLR2_io_frontier_in_39_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_120_ready = SLR2_io_frontier_in_43_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_121_ready = SLR2_io_frontier_in_47_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_122_ready = SLR2_io_frontier_in_51_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_123_ready = SLR2_io_frontier_in_55_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_124_ready = SLR2_io_frontier_in_59_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_125_ready = SLR2_io_frontier_in_63_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_126_ready = SLR2_io_frontier_in_67_ready; // @[Top-slr.scala 504:71]
  assign crossbar_array_visit_io_out_127_ready = SLR2_io_frontier_in_71_ready; // @[Top-slr.scala 504:71]
  assign R_array_index_01_slr0_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_enq_valid = _T_314; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_enq_bits = R_array_index_01_slr1_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_deq_ready = q_R_array_index_slr0_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_enq_valid = SLR1_io_R_array_index_0_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_enq_bits = SLR1_io_R_array_index_0_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_deq_ready = R_array_index_01_slr0_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_clock = clock;
  assign q_R_array_index_slr0_reset = reset;
  assign q_R_array_index_slr0_io_enq_valid = _T_315; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_io_enq_bits = R_array_index_01_slr0_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_io_deq_ready = SLR0_Mem_io_R_array_index_0_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_1_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_1_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_1_enq_valid = _T_319; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_1_enq_bits = R_array_index_01_slr1_1_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_1_deq_ready = q_R_array_index_slr0_1_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_1_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_1_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_1_enq_valid = SLR1_io_R_array_index_1_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_1_enq_bits = SLR1_io_R_array_index_1_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_1_deq_ready = R_array_index_01_slr0_1_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_1_clock = clock;
  assign q_R_array_index_slr0_1_reset = reset;
  assign q_R_array_index_slr0_1_io_enq_valid = _T_320; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_1_io_enq_bits = R_array_index_01_slr0_1_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_1_io_deq_ready = SLR0_Mem_io_R_array_index_1_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_2_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_2_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_2_enq_valid = _T_324; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_2_enq_bits = R_array_index_01_slr1_2_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_2_deq_ready = q_R_array_index_slr0_2_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_2_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_2_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_2_enq_valid = SLR1_io_R_array_index_2_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_2_enq_bits = SLR1_io_R_array_index_2_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_2_deq_ready = R_array_index_01_slr0_2_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_2_clock = clock;
  assign q_R_array_index_slr0_2_reset = reset;
  assign q_R_array_index_slr0_2_io_enq_valid = _T_325; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_2_io_enq_bits = R_array_index_01_slr0_2_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_2_io_deq_ready = SLR0_Mem_io_R_array_index_2_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_3_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_3_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_3_enq_valid = _T_329; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_3_enq_bits = R_array_index_01_slr1_3_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_3_deq_ready = q_R_array_index_slr0_3_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_3_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_3_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_3_enq_valid = SLR1_io_R_array_index_3_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_3_enq_bits = SLR1_io_R_array_index_3_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_3_deq_ready = R_array_index_01_slr0_3_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_3_clock = clock;
  assign q_R_array_index_slr0_3_reset = reset;
  assign q_R_array_index_slr0_3_io_enq_valid = _T_330; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_3_io_enq_bits = R_array_index_01_slr0_3_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_3_io_deq_ready = SLR0_Mem_io_R_array_index_3_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_4_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_4_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_4_enq_valid = _T_334; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_4_enq_bits = R_array_index_01_slr1_4_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_4_deq_ready = q_R_array_index_slr0_4_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_4_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_4_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_4_enq_valid = SLR1_io_R_array_index_4_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_4_enq_bits = SLR1_io_R_array_index_4_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_4_deq_ready = R_array_index_01_slr0_4_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_4_clock = clock;
  assign q_R_array_index_slr0_4_reset = reset;
  assign q_R_array_index_slr0_4_io_enq_valid = _T_335; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_4_io_enq_bits = R_array_index_01_slr0_4_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_4_io_deq_ready = SLR0_Mem_io_R_array_index_4_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_5_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_5_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_5_enq_valid = _T_339; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_5_enq_bits = R_array_index_01_slr1_5_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_5_deq_ready = q_R_array_index_slr0_5_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_5_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_5_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_5_enq_valid = SLR1_io_R_array_index_5_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_5_enq_bits = SLR1_io_R_array_index_5_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_5_deq_ready = R_array_index_01_slr0_5_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_5_clock = clock;
  assign q_R_array_index_slr0_5_reset = reset;
  assign q_R_array_index_slr0_5_io_enq_valid = _T_340; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_5_io_enq_bits = R_array_index_01_slr0_5_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_5_io_deq_ready = SLR0_Mem_io_R_array_index_5_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_6_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_6_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_6_enq_valid = _T_344; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_6_enq_bits = R_array_index_01_slr1_6_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_6_deq_ready = q_R_array_index_slr0_6_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_6_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_6_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_6_enq_valid = SLR1_io_R_array_index_6_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_6_enq_bits = SLR1_io_R_array_index_6_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_6_deq_ready = R_array_index_01_slr0_6_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_6_clock = clock;
  assign q_R_array_index_slr0_6_reset = reset;
  assign q_R_array_index_slr0_6_io_enq_valid = _T_345; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_6_io_enq_bits = R_array_index_01_slr0_6_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_6_io_deq_ready = SLR0_Mem_io_R_array_index_6_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_7_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_7_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_7_enq_valid = _T_349; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_7_enq_bits = R_array_index_01_slr1_7_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_7_deq_ready = q_R_array_index_slr0_7_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_7_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_7_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_7_enq_valid = SLR1_io_R_array_index_7_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_7_enq_bits = SLR1_io_R_array_index_7_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_7_deq_ready = R_array_index_01_slr0_7_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_7_clock = clock;
  assign q_R_array_index_slr0_7_reset = reset;
  assign q_R_array_index_slr0_7_io_enq_valid = _T_350; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_7_io_enq_bits = R_array_index_01_slr0_7_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_7_io_deq_ready = SLR0_Mem_io_R_array_index_7_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_8_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_8_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_8_enq_valid = _T_354; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_8_enq_bits = R_array_index_01_slr1_8_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_8_deq_ready = q_R_array_index_slr0_8_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_8_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_8_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_8_enq_valid = SLR1_io_R_array_index_8_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_8_enq_bits = SLR1_io_R_array_index_8_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_8_deq_ready = R_array_index_01_slr0_8_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_8_clock = clock;
  assign q_R_array_index_slr0_8_reset = reset;
  assign q_R_array_index_slr0_8_io_enq_valid = _T_355; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_8_io_enq_bits = R_array_index_01_slr0_8_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_8_io_deq_ready = SLR0_Mem_io_R_array_index_8_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_9_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_9_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_9_enq_valid = _T_359; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_9_enq_bits = R_array_index_01_slr1_9_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_9_deq_ready = q_R_array_index_slr0_9_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_9_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_9_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_9_enq_valid = SLR1_io_R_array_index_9_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_9_enq_bits = SLR1_io_R_array_index_9_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_9_deq_ready = R_array_index_01_slr0_9_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_9_clock = clock;
  assign q_R_array_index_slr0_9_reset = reset;
  assign q_R_array_index_slr0_9_io_enq_valid = _T_360; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_9_io_enq_bits = R_array_index_01_slr0_9_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_9_io_deq_ready = SLR0_Mem_io_R_array_index_9_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_10_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_10_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_10_enq_valid = _T_364; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_10_enq_bits = R_array_index_01_slr1_10_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_10_deq_ready = q_R_array_index_slr0_10_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_10_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_10_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_10_enq_valid = SLR1_io_R_array_index_10_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_10_enq_bits = SLR1_io_R_array_index_10_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_10_deq_ready = R_array_index_01_slr0_10_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_10_clock = clock;
  assign q_R_array_index_slr0_10_reset = reset;
  assign q_R_array_index_slr0_10_io_enq_valid = _T_365; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_10_io_enq_bits = R_array_index_01_slr0_10_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_10_io_deq_ready = SLR0_Mem_io_R_array_index_10_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_11_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_11_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_11_enq_valid = _T_369; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_11_enq_bits = R_array_index_01_slr1_11_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_11_deq_ready = q_R_array_index_slr0_11_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_11_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_11_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_11_enq_valid = SLR1_io_R_array_index_11_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_11_enq_bits = SLR1_io_R_array_index_11_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_11_deq_ready = R_array_index_01_slr0_11_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_11_clock = clock;
  assign q_R_array_index_slr0_11_reset = reset;
  assign q_R_array_index_slr0_11_io_enq_valid = _T_370; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_11_io_enq_bits = R_array_index_01_slr0_11_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_11_io_deq_ready = SLR0_Mem_io_R_array_index_11_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_12_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_12_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_12_enq_valid = _T_374; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_12_enq_bits = R_array_index_01_slr1_12_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_12_deq_ready = q_R_array_index_slr0_12_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_12_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_12_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_12_enq_valid = SLR1_io_R_array_index_12_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_12_enq_bits = SLR1_io_R_array_index_12_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_12_deq_ready = R_array_index_01_slr0_12_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_12_clock = clock;
  assign q_R_array_index_slr0_12_reset = reset;
  assign q_R_array_index_slr0_12_io_enq_valid = _T_375; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_12_io_enq_bits = R_array_index_01_slr0_12_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_12_io_deq_ready = SLR0_Mem_io_R_array_index_12_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_13_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_13_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_13_enq_valid = _T_379; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_13_enq_bits = R_array_index_01_slr1_13_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_13_deq_ready = q_R_array_index_slr0_13_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_13_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_13_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_13_enq_valid = SLR1_io_R_array_index_13_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_13_enq_bits = SLR1_io_R_array_index_13_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_13_deq_ready = R_array_index_01_slr0_13_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_13_clock = clock;
  assign q_R_array_index_slr0_13_reset = reset;
  assign q_R_array_index_slr0_13_io_enq_valid = _T_380; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_13_io_enq_bits = R_array_index_01_slr0_13_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_13_io_deq_ready = SLR0_Mem_io_R_array_index_13_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_14_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_14_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_14_enq_valid = _T_384; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_14_enq_bits = R_array_index_01_slr1_14_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_14_deq_ready = q_R_array_index_slr0_14_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_14_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_14_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_14_enq_valid = SLR1_io_R_array_index_14_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_14_enq_bits = SLR1_io_R_array_index_14_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_14_deq_ready = R_array_index_01_slr0_14_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_14_clock = clock;
  assign q_R_array_index_slr0_14_reset = reset;
  assign q_R_array_index_slr0_14_io_enq_valid = _T_385; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_14_io_enq_bits = R_array_index_01_slr0_14_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_14_io_deq_ready = SLR0_Mem_io_R_array_index_14_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_15_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_15_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_15_enq_valid = _T_389; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_15_enq_bits = R_array_index_01_slr1_15_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_15_deq_ready = q_R_array_index_slr0_15_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_15_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_15_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_15_enq_valid = SLR1_io_R_array_index_15_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_15_enq_bits = SLR1_io_R_array_index_15_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_15_deq_ready = R_array_index_01_slr0_15_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_15_clock = clock;
  assign q_R_array_index_slr0_15_reset = reset;
  assign q_R_array_index_slr0_15_io_enq_valid = _T_390; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_15_io_enq_bits = R_array_index_01_slr0_15_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_15_io_deq_ready = SLR0_Mem_io_R_array_index_15_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_16_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_16_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_16_enq_valid = _T_394; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_16_enq_bits = R_array_index_01_slr1_16_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_16_deq_ready = q_R_array_index_slr0_16_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_16_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_16_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_16_enq_valid = SLR1_io_R_array_index_16_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_16_enq_bits = SLR1_io_R_array_index_16_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_16_deq_ready = R_array_index_01_slr0_16_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_16_clock = clock;
  assign q_R_array_index_slr0_16_reset = reset;
  assign q_R_array_index_slr0_16_io_enq_valid = _T_395; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_16_io_enq_bits = R_array_index_01_slr0_16_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_16_io_deq_ready = SLR0_Mem_io_R_array_index_16_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_17_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_17_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_17_enq_valid = _T_399; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_17_enq_bits = R_array_index_01_slr1_17_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_17_deq_ready = q_R_array_index_slr0_17_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_17_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_17_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_17_enq_valid = SLR1_io_R_array_index_17_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_17_enq_bits = SLR1_io_R_array_index_17_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_17_deq_ready = R_array_index_01_slr0_17_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_17_clock = clock;
  assign q_R_array_index_slr0_17_reset = reset;
  assign q_R_array_index_slr0_17_io_enq_valid = _T_400; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_17_io_enq_bits = R_array_index_01_slr0_17_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_17_io_deq_ready = SLR0_Mem_io_R_array_index_17_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_18_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_18_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_18_enq_valid = _T_404; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_18_enq_bits = R_array_index_01_slr1_18_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_18_deq_ready = q_R_array_index_slr0_18_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_18_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_18_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_18_enq_valid = SLR1_io_R_array_index_18_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_18_enq_bits = SLR1_io_R_array_index_18_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_18_deq_ready = R_array_index_01_slr0_18_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_18_clock = clock;
  assign q_R_array_index_slr0_18_reset = reset;
  assign q_R_array_index_slr0_18_io_enq_valid = _T_405; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_18_io_enq_bits = R_array_index_01_slr0_18_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_18_io_deq_ready = SLR0_Mem_io_R_array_index_18_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_19_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_19_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_19_enq_valid = _T_409; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_19_enq_bits = R_array_index_01_slr1_19_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_19_deq_ready = q_R_array_index_slr0_19_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_19_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_19_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_19_enq_valid = SLR1_io_R_array_index_19_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_19_enq_bits = SLR1_io_R_array_index_19_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_19_deq_ready = R_array_index_01_slr0_19_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_19_clock = clock;
  assign q_R_array_index_slr0_19_reset = reset;
  assign q_R_array_index_slr0_19_io_enq_valid = _T_410; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_19_io_enq_bits = R_array_index_01_slr0_19_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_19_io_deq_ready = SLR0_Mem_io_R_array_index_19_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_20_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_20_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_20_enq_valid = _T_414; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_20_enq_bits = R_array_index_01_slr1_20_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_20_deq_ready = q_R_array_index_slr0_20_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_20_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_20_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_20_enq_valid = SLR1_io_R_array_index_20_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_20_enq_bits = SLR1_io_R_array_index_20_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_20_deq_ready = R_array_index_01_slr0_20_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_20_clock = clock;
  assign q_R_array_index_slr0_20_reset = reset;
  assign q_R_array_index_slr0_20_io_enq_valid = _T_415; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_20_io_enq_bits = R_array_index_01_slr0_20_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_20_io_deq_ready = SLR0_Mem_io_R_array_index_20_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_21_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_21_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_21_enq_valid = _T_419; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_21_enq_bits = R_array_index_01_slr1_21_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_21_deq_ready = q_R_array_index_slr0_21_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_21_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_21_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_21_enq_valid = SLR1_io_R_array_index_21_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_21_enq_bits = SLR1_io_R_array_index_21_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_21_deq_ready = R_array_index_01_slr0_21_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_21_clock = clock;
  assign q_R_array_index_slr0_21_reset = reset;
  assign q_R_array_index_slr0_21_io_enq_valid = _T_420; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_21_io_enq_bits = R_array_index_01_slr0_21_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_21_io_deq_ready = SLR0_Mem_io_R_array_index_21_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_22_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_22_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_22_enq_valid = _T_424; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_22_enq_bits = R_array_index_01_slr1_22_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_22_deq_ready = q_R_array_index_slr0_22_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_22_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_22_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_22_enq_valid = SLR1_io_R_array_index_22_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_22_enq_bits = SLR1_io_R_array_index_22_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_22_deq_ready = R_array_index_01_slr0_22_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_22_clock = clock;
  assign q_R_array_index_slr0_22_reset = reset;
  assign q_R_array_index_slr0_22_io_enq_valid = _T_425; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_22_io_enq_bits = R_array_index_01_slr0_22_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_22_io_deq_ready = SLR0_Mem_io_R_array_index_22_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_23_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_23_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_23_enq_valid = _T_429; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_23_enq_bits = R_array_index_01_slr1_23_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_23_deq_ready = q_R_array_index_slr0_23_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_23_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_23_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_23_enq_valid = SLR1_io_R_array_index_23_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_23_enq_bits = SLR1_io_R_array_index_23_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_23_deq_ready = R_array_index_01_slr0_23_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_23_clock = clock;
  assign q_R_array_index_slr0_23_reset = reset;
  assign q_R_array_index_slr0_23_io_enq_valid = _T_430; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_23_io_enq_bits = R_array_index_01_slr0_23_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_23_io_deq_ready = SLR0_Mem_io_R_array_index_23_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_24_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_24_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_24_enq_valid = _T_434; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_24_enq_bits = R_array_index_01_slr1_24_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_24_deq_ready = q_R_array_index_slr0_24_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_24_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_24_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_24_enq_valid = SLR1_io_R_array_index_24_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_24_enq_bits = SLR1_io_R_array_index_24_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_24_deq_ready = R_array_index_01_slr0_24_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_24_clock = clock;
  assign q_R_array_index_slr0_24_reset = reset;
  assign q_R_array_index_slr0_24_io_enq_valid = _T_435; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_24_io_enq_bits = R_array_index_01_slr0_24_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_24_io_deq_ready = SLR0_Mem_io_R_array_index_24_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_25_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_25_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_25_enq_valid = _T_439; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_25_enq_bits = R_array_index_01_slr1_25_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_25_deq_ready = q_R_array_index_slr0_25_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_25_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_25_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_25_enq_valid = SLR1_io_R_array_index_25_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_25_enq_bits = SLR1_io_R_array_index_25_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_25_deq_ready = R_array_index_01_slr0_25_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_25_clock = clock;
  assign q_R_array_index_slr0_25_reset = reset;
  assign q_R_array_index_slr0_25_io_enq_valid = _T_440; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_25_io_enq_bits = R_array_index_01_slr0_25_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_25_io_deq_ready = SLR0_Mem_io_R_array_index_25_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_26_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_26_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_26_enq_valid = _T_444; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_26_enq_bits = R_array_index_01_slr1_26_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_26_deq_ready = q_R_array_index_slr0_26_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_26_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_26_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_26_enq_valid = SLR1_io_R_array_index_26_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_26_enq_bits = SLR1_io_R_array_index_26_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_26_deq_ready = R_array_index_01_slr0_26_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_26_clock = clock;
  assign q_R_array_index_slr0_26_reset = reset;
  assign q_R_array_index_slr0_26_io_enq_valid = _T_445; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_26_io_enq_bits = R_array_index_01_slr0_26_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_26_io_deq_ready = SLR0_Mem_io_R_array_index_26_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_27_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_27_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_27_enq_valid = _T_449; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_27_enq_bits = R_array_index_01_slr1_27_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_27_deq_ready = q_R_array_index_slr0_27_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_27_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_27_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_27_enq_valid = SLR1_io_R_array_index_27_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_27_enq_bits = SLR1_io_R_array_index_27_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_27_deq_ready = R_array_index_01_slr0_27_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_27_clock = clock;
  assign q_R_array_index_slr0_27_reset = reset;
  assign q_R_array_index_slr0_27_io_enq_valid = _T_450; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_27_io_enq_bits = R_array_index_01_slr0_27_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_27_io_deq_ready = SLR0_Mem_io_R_array_index_27_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_28_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_28_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_28_enq_valid = _T_454; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_28_enq_bits = R_array_index_01_slr1_28_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_28_deq_ready = q_R_array_index_slr0_28_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_28_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_28_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_28_enq_valid = SLR1_io_R_array_index_28_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_28_enq_bits = SLR1_io_R_array_index_28_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_28_deq_ready = R_array_index_01_slr0_28_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_28_clock = clock;
  assign q_R_array_index_slr0_28_reset = reset;
  assign q_R_array_index_slr0_28_io_enq_valid = _T_455; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_28_io_enq_bits = R_array_index_01_slr0_28_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_28_io_deq_ready = SLR0_Mem_io_R_array_index_28_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_29_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_29_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_29_enq_valid = _T_459; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_29_enq_bits = R_array_index_01_slr1_29_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_29_deq_ready = q_R_array_index_slr0_29_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_29_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_29_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_29_enq_valid = SLR1_io_R_array_index_29_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_29_enq_bits = SLR1_io_R_array_index_29_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_29_deq_ready = R_array_index_01_slr0_29_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_29_clock = clock;
  assign q_R_array_index_slr0_29_reset = reset;
  assign q_R_array_index_slr0_29_io_enq_valid = _T_460; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_29_io_enq_bits = R_array_index_01_slr0_29_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_29_io_deq_ready = SLR0_Mem_io_R_array_index_29_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_30_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_30_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_30_enq_valid = _T_464; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_30_enq_bits = R_array_index_01_slr1_30_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_30_deq_ready = q_R_array_index_slr0_30_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_30_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_30_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_30_enq_valid = SLR1_io_R_array_index_30_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_30_enq_bits = SLR1_io_R_array_index_30_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_30_deq_ready = R_array_index_01_slr0_30_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_30_clock = clock;
  assign q_R_array_index_slr0_30_reset = reset;
  assign q_R_array_index_slr0_30_io_enq_valid = _T_465; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_30_io_enq_bits = R_array_index_01_slr0_30_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_30_io_deq_ready = SLR0_Mem_io_R_array_index_30_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_31_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_31_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_31_enq_valid = _T_469; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_31_enq_bits = R_array_index_01_slr1_31_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_31_deq_ready = q_R_array_index_slr0_31_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_31_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_31_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_31_enq_valid = SLR1_io_R_array_index_31_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_31_enq_bits = SLR1_io_R_array_index_31_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_31_deq_ready = R_array_index_01_slr0_31_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_31_clock = clock;
  assign q_R_array_index_slr0_31_reset = reset;
  assign q_R_array_index_slr0_31_io_enq_valid = _T_470; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_31_io_enq_bits = R_array_index_01_slr0_31_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_31_io_deq_ready = SLR0_Mem_io_R_array_index_31_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_32_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_32_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_32_enq_valid = _T_474; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_32_enq_bits = R_array_index_01_slr1_32_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_32_deq_ready = q_R_array_index_slr0_32_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_32_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_32_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_32_enq_valid = SLR1_io_R_array_index_32_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_32_enq_bits = SLR1_io_R_array_index_32_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_32_deq_ready = R_array_index_01_slr0_32_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_32_clock = clock;
  assign q_R_array_index_slr0_32_reset = reset;
  assign q_R_array_index_slr0_32_io_enq_valid = _T_475; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_32_io_enq_bits = R_array_index_01_slr0_32_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_32_io_deq_ready = SLR0_Mem_io_R_array_index_32_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_33_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_33_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_33_enq_valid = _T_479; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_33_enq_bits = R_array_index_01_slr1_33_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_33_deq_ready = q_R_array_index_slr0_33_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_33_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_33_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_33_enq_valid = SLR1_io_R_array_index_33_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_33_enq_bits = SLR1_io_R_array_index_33_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_33_deq_ready = R_array_index_01_slr0_33_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_33_clock = clock;
  assign q_R_array_index_slr0_33_reset = reset;
  assign q_R_array_index_slr0_33_io_enq_valid = _T_480; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_33_io_enq_bits = R_array_index_01_slr0_33_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_33_io_deq_ready = SLR0_Mem_io_R_array_index_33_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_34_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_34_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_34_enq_valid = _T_484; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_34_enq_bits = R_array_index_01_slr1_34_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_34_deq_ready = q_R_array_index_slr0_34_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_34_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_34_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_34_enq_valid = SLR1_io_R_array_index_34_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_34_enq_bits = SLR1_io_R_array_index_34_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_34_deq_ready = R_array_index_01_slr0_34_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_34_clock = clock;
  assign q_R_array_index_slr0_34_reset = reset;
  assign q_R_array_index_slr0_34_io_enq_valid = _T_485; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_34_io_enq_bits = R_array_index_01_slr0_34_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_34_io_deq_ready = SLR0_Mem_io_R_array_index_34_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_35_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_35_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_35_enq_valid = _T_489; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_35_enq_bits = R_array_index_01_slr1_35_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_35_deq_ready = q_R_array_index_slr0_35_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_35_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_35_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_35_enq_valid = SLR1_io_R_array_index_35_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_35_enq_bits = SLR1_io_R_array_index_35_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_35_deq_ready = R_array_index_01_slr0_35_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_35_clock = clock;
  assign q_R_array_index_slr0_35_reset = reset;
  assign q_R_array_index_slr0_35_io_enq_valid = _T_490; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_35_io_enq_bits = R_array_index_01_slr0_35_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_35_io_deq_ready = SLR0_Mem_io_R_array_index_35_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_36_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_36_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_36_enq_valid = _T_494; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_36_enq_bits = R_array_index_01_slr1_36_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_36_deq_ready = q_R_array_index_slr0_36_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_36_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_36_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_36_enq_valid = SLR1_io_R_array_index_36_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_36_enq_bits = SLR1_io_R_array_index_36_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_36_deq_ready = R_array_index_01_slr0_36_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_36_clock = clock;
  assign q_R_array_index_slr0_36_reset = reset;
  assign q_R_array_index_slr0_36_io_enq_valid = _T_495; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_36_io_enq_bits = R_array_index_01_slr0_36_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_36_io_deq_ready = SLR0_Mem_io_R_array_index_36_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_37_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_37_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_37_enq_valid = _T_499; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_37_enq_bits = R_array_index_01_slr1_37_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_37_deq_ready = q_R_array_index_slr0_37_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_37_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_37_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_37_enq_valid = SLR1_io_R_array_index_37_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_37_enq_bits = SLR1_io_R_array_index_37_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_37_deq_ready = R_array_index_01_slr0_37_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_37_clock = clock;
  assign q_R_array_index_slr0_37_reset = reset;
  assign q_R_array_index_slr0_37_io_enq_valid = _T_500; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_37_io_enq_bits = R_array_index_01_slr0_37_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_37_io_deq_ready = SLR0_Mem_io_R_array_index_37_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_38_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_38_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_38_enq_valid = _T_504; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_38_enq_bits = R_array_index_01_slr1_38_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_38_deq_ready = q_R_array_index_slr0_38_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_38_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_38_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_38_enq_valid = SLR1_io_R_array_index_38_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_38_enq_bits = SLR1_io_R_array_index_38_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_38_deq_ready = R_array_index_01_slr0_38_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_38_clock = clock;
  assign q_R_array_index_slr0_38_reset = reset;
  assign q_R_array_index_slr0_38_io_enq_valid = _T_505; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_38_io_enq_bits = R_array_index_01_slr0_38_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_38_io_deq_ready = SLR0_Mem_io_R_array_index_38_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_39_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_39_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_39_enq_valid = _T_509; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_39_enq_bits = R_array_index_01_slr1_39_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_39_deq_ready = q_R_array_index_slr0_39_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_39_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_39_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_39_enq_valid = SLR1_io_R_array_index_39_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_39_enq_bits = SLR1_io_R_array_index_39_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_39_deq_ready = R_array_index_01_slr0_39_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_39_clock = clock;
  assign q_R_array_index_slr0_39_reset = reset;
  assign q_R_array_index_slr0_39_io_enq_valid = _T_510; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_39_io_enq_bits = R_array_index_01_slr0_39_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_39_io_deq_ready = SLR0_Mem_io_R_array_index_39_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_40_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_40_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_40_enq_valid = _T_514; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_40_enq_bits = R_array_index_01_slr1_40_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_40_deq_ready = q_R_array_index_slr0_40_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_40_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_40_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_40_enq_valid = SLR1_io_R_array_index_40_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_40_enq_bits = SLR1_io_R_array_index_40_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_40_deq_ready = R_array_index_01_slr0_40_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_40_clock = clock;
  assign q_R_array_index_slr0_40_reset = reset;
  assign q_R_array_index_slr0_40_io_enq_valid = _T_515; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_40_io_enq_bits = R_array_index_01_slr0_40_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_40_io_deq_ready = SLR0_Mem_io_R_array_index_40_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_41_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_41_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_41_enq_valid = _T_519; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_41_enq_bits = R_array_index_01_slr1_41_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_41_deq_ready = q_R_array_index_slr0_41_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_41_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_41_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_41_enq_valid = SLR1_io_R_array_index_41_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_41_enq_bits = SLR1_io_R_array_index_41_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_41_deq_ready = R_array_index_01_slr0_41_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_41_clock = clock;
  assign q_R_array_index_slr0_41_reset = reset;
  assign q_R_array_index_slr0_41_io_enq_valid = _T_520; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_41_io_enq_bits = R_array_index_01_slr0_41_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_41_io_deq_ready = SLR0_Mem_io_R_array_index_41_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_42_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_42_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_42_enq_valid = _T_524; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_42_enq_bits = R_array_index_01_slr1_42_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_42_deq_ready = q_R_array_index_slr0_42_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_42_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_42_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_42_enq_valid = SLR1_io_R_array_index_42_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_42_enq_bits = SLR1_io_R_array_index_42_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_42_deq_ready = R_array_index_01_slr0_42_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_42_clock = clock;
  assign q_R_array_index_slr0_42_reset = reset;
  assign q_R_array_index_slr0_42_io_enq_valid = _T_525; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_42_io_enq_bits = R_array_index_01_slr0_42_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_42_io_deq_ready = SLR0_Mem_io_R_array_index_42_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_43_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_43_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_43_enq_valid = _T_529; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_43_enq_bits = R_array_index_01_slr1_43_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_43_deq_ready = q_R_array_index_slr0_43_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_43_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_43_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_43_enq_valid = SLR1_io_R_array_index_43_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_43_enq_bits = SLR1_io_R_array_index_43_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_43_deq_ready = R_array_index_01_slr0_43_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_43_clock = clock;
  assign q_R_array_index_slr0_43_reset = reset;
  assign q_R_array_index_slr0_43_io_enq_valid = _T_530; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_43_io_enq_bits = R_array_index_01_slr0_43_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_43_io_deq_ready = SLR0_Mem_io_R_array_index_43_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_44_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_44_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_44_enq_valid = _T_534; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_44_enq_bits = R_array_index_01_slr1_44_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_44_deq_ready = q_R_array_index_slr0_44_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_44_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_44_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_44_enq_valid = SLR1_io_R_array_index_44_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_44_enq_bits = SLR1_io_R_array_index_44_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_44_deq_ready = R_array_index_01_slr0_44_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_44_clock = clock;
  assign q_R_array_index_slr0_44_reset = reset;
  assign q_R_array_index_slr0_44_io_enq_valid = _T_535; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_44_io_enq_bits = R_array_index_01_slr0_44_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_44_io_deq_ready = SLR0_Mem_io_R_array_index_44_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_45_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_45_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_45_enq_valid = _T_539; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_45_enq_bits = R_array_index_01_slr1_45_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_45_deq_ready = q_R_array_index_slr0_45_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_45_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_45_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_45_enq_valid = SLR1_io_R_array_index_45_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_45_enq_bits = SLR1_io_R_array_index_45_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_45_deq_ready = R_array_index_01_slr0_45_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_45_clock = clock;
  assign q_R_array_index_slr0_45_reset = reset;
  assign q_R_array_index_slr0_45_io_enq_valid = _T_540; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_45_io_enq_bits = R_array_index_01_slr0_45_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_45_io_deq_ready = SLR0_Mem_io_R_array_index_45_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_46_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_46_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_46_enq_valid = _T_544; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_46_enq_bits = R_array_index_01_slr1_46_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_46_deq_ready = q_R_array_index_slr0_46_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_46_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_46_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_46_enq_valid = SLR1_io_R_array_index_46_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_46_enq_bits = SLR1_io_R_array_index_46_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_46_deq_ready = R_array_index_01_slr0_46_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_46_clock = clock;
  assign q_R_array_index_slr0_46_reset = reset;
  assign q_R_array_index_slr0_46_io_enq_valid = _T_545; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_46_io_enq_bits = R_array_index_01_slr0_46_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_46_io_deq_ready = SLR0_Mem_io_R_array_index_46_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_47_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_47_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_47_enq_valid = _T_549; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_47_enq_bits = R_array_index_01_slr1_47_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_47_deq_ready = q_R_array_index_slr0_47_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_47_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_47_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_47_enq_valid = SLR1_io_R_array_index_47_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_47_enq_bits = SLR1_io_R_array_index_47_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_47_deq_ready = R_array_index_01_slr0_47_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_47_clock = clock;
  assign q_R_array_index_slr0_47_reset = reset;
  assign q_R_array_index_slr0_47_io_enq_valid = _T_550; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_47_io_enq_bits = R_array_index_01_slr0_47_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_47_io_deq_ready = SLR0_Mem_io_R_array_index_47_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_48_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_48_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_48_enq_valid = _T_554; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_48_enq_bits = R_array_index_01_slr1_48_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_48_deq_ready = q_R_array_index_slr0_48_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_48_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_48_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_48_enq_valid = SLR1_io_R_array_index_48_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_48_enq_bits = SLR1_io_R_array_index_48_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_48_deq_ready = R_array_index_01_slr0_48_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_48_clock = clock;
  assign q_R_array_index_slr0_48_reset = reset;
  assign q_R_array_index_slr0_48_io_enq_valid = _T_555; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_48_io_enq_bits = R_array_index_01_slr0_48_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_48_io_deq_ready = SLR0_Mem_io_R_array_index_48_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_49_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_49_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_49_enq_valid = _T_559; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_49_enq_bits = R_array_index_01_slr1_49_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_49_deq_ready = q_R_array_index_slr0_49_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_49_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_49_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_49_enq_valid = SLR1_io_R_array_index_49_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_49_enq_bits = SLR1_io_R_array_index_49_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_49_deq_ready = R_array_index_01_slr0_49_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_49_clock = clock;
  assign q_R_array_index_slr0_49_reset = reset;
  assign q_R_array_index_slr0_49_io_enq_valid = _T_560; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_49_io_enq_bits = R_array_index_01_slr0_49_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_49_io_deq_ready = SLR0_Mem_io_R_array_index_49_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_50_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_50_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_50_enq_valid = _T_564; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_50_enq_bits = R_array_index_01_slr1_50_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_50_deq_ready = q_R_array_index_slr0_50_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_50_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_50_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_50_enq_valid = SLR1_io_R_array_index_50_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_50_enq_bits = SLR1_io_R_array_index_50_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_50_deq_ready = R_array_index_01_slr0_50_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_50_clock = clock;
  assign q_R_array_index_slr0_50_reset = reset;
  assign q_R_array_index_slr0_50_io_enq_valid = _T_565; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_50_io_enq_bits = R_array_index_01_slr0_50_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_50_io_deq_ready = SLR0_Mem_io_R_array_index_50_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_51_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_51_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_51_enq_valid = _T_569; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_51_enq_bits = R_array_index_01_slr1_51_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_51_deq_ready = q_R_array_index_slr0_51_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_51_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_51_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_51_enq_valid = SLR1_io_R_array_index_51_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_51_enq_bits = SLR1_io_R_array_index_51_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_51_deq_ready = R_array_index_01_slr0_51_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_51_clock = clock;
  assign q_R_array_index_slr0_51_reset = reset;
  assign q_R_array_index_slr0_51_io_enq_valid = _T_570; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_51_io_enq_bits = R_array_index_01_slr0_51_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_51_io_deq_ready = SLR0_Mem_io_R_array_index_51_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_52_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_52_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_52_enq_valid = _T_574; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_52_enq_bits = R_array_index_01_slr1_52_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_52_deq_ready = q_R_array_index_slr0_52_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_52_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_52_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_52_enq_valid = SLR1_io_R_array_index_52_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_52_enq_bits = SLR1_io_R_array_index_52_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_52_deq_ready = R_array_index_01_slr0_52_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_52_clock = clock;
  assign q_R_array_index_slr0_52_reset = reset;
  assign q_R_array_index_slr0_52_io_enq_valid = _T_575; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_52_io_enq_bits = R_array_index_01_slr0_52_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_52_io_deq_ready = SLR0_Mem_io_R_array_index_52_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_53_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_53_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_53_enq_valid = _T_579; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_53_enq_bits = R_array_index_01_slr1_53_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_53_deq_ready = q_R_array_index_slr0_53_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_53_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_53_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_53_enq_valid = SLR1_io_R_array_index_53_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_53_enq_bits = SLR1_io_R_array_index_53_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_53_deq_ready = R_array_index_01_slr0_53_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_53_clock = clock;
  assign q_R_array_index_slr0_53_reset = reset;
  assign q_R_array_index_slr0_53_io_enq_valid = _T_580; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_53_io_enq_bits = R_array_index_01_slr0_53_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_53_io_deq_ready = SLR0_Mem_io_R_array_index_53_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_54_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_54_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_54_enq_valid = _T_584; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_54_enq_bits = R_array_index_01_slr1_54_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_54_deq_ready = q_R_array_index_slr0_54_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_54_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_54_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_54_enq_valid = SLR1_io_R_array_index_54_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_54_enq_bits = SLR1_io_R_array_index_54_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_54_deq_ready = R_array_index_01_slr0_54_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_54_clock = clock;
  assign q_R_array_index_slr0_54_reset = reset;
  assign q_R_array_index_slr0_54_io_enq_valid = _T_585; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_54_io_enq_bits = R_array_index_01_slr0_54_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_54_io_deq_ready = SLR0_Mem_io_R_array_index_54_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_01_slr0_55_clock = clock; // @[Top-slr.scala 276:43]
  assign R_array_index_01_slr0_55_reset = reset; // @[Top-slr.scala 278:43]
  assign R_array_index_01_slr0_55_enq_valid = _T_589; // @[Top-slr.scala 288:47]
  assign R_array_index_01_slr0_55_enq_bits = R_array_index_01_slr1_55_deq_bits; // @[Top-slr.scala 290:47]
  assign R_array_index_01_slr0_55_deq_ready = q_R_array_index_slr0_55_io_count < _T_317; // @[Top-slr.scala 293:77]
  assign R_array_index_01_slr1_55_clock = clock; // @[Top-slr.scala 277:43]
  assign R_array_index_01_slr1_55_reset = reset; // @[Top-slr.scala 279:43]
  assign R_array_index_01_slr1_55_enq_valid = SLR1_io_R_array_index_55_valid; // @[Top-slr.scala 284:47]
  assign R_array_index_01_slr1_55_enq_bits = SLR1_io_R_array_index_55_bits; // @[Top-slr.scala 286:47]
  assign R_array_index_01_slr1_55_deq_ready = R_array_index_01_slr0_55_enq_ready; // @[Top-slr.scala 289:47]
  assign q_R_array_index_slr0_55_clock = clock;
  assign q_R_array_index_slr0_55_reset = reset;
  assign q_R_array_index_slr0_55_io_enq_valid = _T_590; // @[Top-slr.scala 292:49]
  assign q_R_array_index_slr0_55_io_enq_bits = R_array_index_01_slr0_55_deq_bits; // @[Top-slr.scala 294:49]
  assign q_R_array_index_slr0_55_io_deq_ready = SLR0_Mem_io_R_array_index_55_ready; // @[Top-slr.scala 296:90]
  assign R_array_index_02_slr0_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_enq_valid = _T_882; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_enq_bits = R_array_index_02_slr1_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_deq_ready = q_R_array_index_slr0_56_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_enq_valid = _T_881; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_enq_bits = R_array_index_02_slr2_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_deq_ready = R_array_index_02_slr0_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_enq_valid = SLR2_io_R_array_index_0_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_enq_bits = SLR2_io_R_array_index_0_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_deq_ready = R_array_index_02_slr1_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_56_clock = clock;
  assign q_R_array_index_slr0_56_reset = reset;
  assign q_R_array_index_slr0_56_io_enq_valid = _T_883; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_56_io_enq_bits = R_array_index_02_slr0_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_56_io_deq_ready = SLR0_Mem_io_R_array_index_56_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_1_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_1_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_1_enq_valid = _T_888; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_1_enq_bits = R_array_index_02_slr1_1_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_1_deq_ready = q_R_array_index_slr0_57_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_1_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_1_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_1_enq_valid = _T_887; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_1_enq_bits = R_array_index_02_slr2_1_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_1_deq_ready = R_array_index_02_slr0_1_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_1_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_1_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_1_enq_valid = SLR2_io_R_array_index_1_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_1_enq_bits = SLR2_io_R_array_index_1_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_1_deq_ready = R_array_index_02_slr1_1_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_57_clock = clock;
  assign q_R_array_index_slr0_57_reset = reset;
  assign q_R_array_index_slr0_57_io_enq_valid = _T_889; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_57_io_enq_bits = R_array_index_02_slr0_1_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_57_io_deq_ready = SLR0_Mem_io_R_array_index_57_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_2_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_2_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_2_enq_valid = _T_894; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_2_enq_bits = R_array_index_02_slr1_2_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_2_deq_ready = q_R_array_index_slr0_58_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_2_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_2_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_2_enq_valid = _T_893; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_2_enq_bits = R_array_index_02_slr2_2_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_2_deq_ready = R_array_index_02_slr0_2_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_2_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_2_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_2_enq_valid = SLR2_io_R_array_index_2_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_2_enq_bits = SLR2_io_R_array_index_2_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_2_deq_ready = R_array_index_02_slr1_2_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_58_clock = clock;
  assign q_R_array_index_slr0_58_reset = reset;
  assign q_R_array_index_slr0_58_io_enq_valid = _T_895; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_58_io_enq_bits = R_array_index_02_slr0_2_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_58_io_deq_ready = SLR0_Mem_io_R_array_index_58_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_3_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_3_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_3_enq_valid = _T_900; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_3_enq_bits = R_array_index_02_slr1_3_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_3_deq_ready = q_R_array_index_slr0_59_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_3_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_3_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_3_enq_valid = _T_899; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_3_enq_bits = R_array_index_02_slr2_3_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_3_deq_ready = R_array_index_02_slr0_3_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_3_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_3_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_3_enq_valid = SLR2_io_R_array_index_3_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_3_enq_bits = SLR2_io_R_array_index_3_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_3_deq_ready = R_array_index_02_slr1_3_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_59_clock = clock;
  assign q_R_array_index_slr0_59_reset = reset;
  assign q_R_array_index_slr0_59_io_enq_valid = _T_901; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_59_io_enq_bits = R_array_index_02_slr0_3_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_59_io_deq_ready = SLR0_Mem_io_R_array_index_59_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_4_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_4_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_4_enq_valid = _T_906; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_4_enq_bits = R_array_index_02_slr1_4_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_4_deq_ready = q_R_array_index_slr0_60_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_4_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_4_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_4_enq_valid = _T_905; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_4_enq_bits = R_array_index_02_slr2_4_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_4_deq_ready = R_array_index_02_slr0_4_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_4_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_4_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_4_enq_valid = SLR2_io_R_array_index_4_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_4_enq_bits = SLR2_io_R_array_index_4_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_4_deq_ready = R_array_index_02_slr1_4_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_60_clock = clock;
  assign q_R_array_index_slr0_60_reset = reset;
  assign q_R_array_index_slr0_60_io_enq_valid = _T_907; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_60_io_enq_bits = R_array_index_02_slr0_4_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_60_io_deq_ready = SLR0_Mem_io_R_array_index_60_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_5_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_5_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_5_enq_valid = _T_912; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_5_enq_bits = R_array_index_02_slr1_5_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_5_deq_ready = q_R_array_index_slr0_61_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_5_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_5_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_5_enq_valid = _T_911; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_5_enq_bits = R_array_index_02_slr2_5_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_5_deq_ready = R_array_index_02_slr0_5_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_5_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_5_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_5_enq_valid = SLR2_io_R_array_index_5_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_5_enq_bits = SLR2_io_R_array_index_5_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_5_deq_ready = R_array_index_02_slr1_5_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_61_clock = clock;
  assign q_R_array_index_slr0_61_reset = reset;
  assign q_R_array_index_slr0_61_io_enq_valid = _T_913; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_61_io_enq_bits = R_array_index_02_slr0_5_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_61_io_deq_ready = SLR0_Mem_io_R_array_index_61_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_6_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_6_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_6_enq_valid = _T_918; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_6_enq_bits = R_array_index_02_slr1_6_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_6_deq_ready = q_R_array_index_slr0_62_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_6_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_6_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_6_enq_valid = _T_917; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_6_enq_bits = R_array_index_02_slr2_6_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_6_deq_ready = R_array_index_02_slr0_6_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_6_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_6_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_6_enq_valid = SLR2_io_R_array_index_6_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_6_enq_bits = SLR2_io_R_array_index_6_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_6_deq_ready = R_array_index_02_slr1_6_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_62_clock = clock;
  assign q_R_array_index_slr0_62_reset = reset;
  assign q_R_array_index_slr0_62_io_enq_valid = _T_919; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_62_io_enq_bits = R_array_index_02_slr0_6_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_62_io_deq_ready = SLR0_Mem_io_R_array_index_62_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_7_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_7_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_7_enq_valid = _T_924; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_7_enq_bits = R_array_index_02_slr1_7_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_7_deq_ready = q_R_array_index_slr0_63_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_7_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_7_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_7_enq_valid = _T_923; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_7_enq_bits = R_array_index_02_slr2_7_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_7_deq_ready = R_array_index_02_slr0_7_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_7_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_7_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_7_enq_valid = SLR2_io_R_array_index_7_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_7_enq_bits = SLR2_io_R_array_index_7_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_7_deq_ready = R_array_index_02_slr1_7_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_63_clock = clock;
  assign q_R_array_index_slr0_63_reset = reset;
  assign q_R_array_index_slr0_63_io_enq_valid = _T_925; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_63_io_enq_bits = R_array_index_02_slr0_7_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_63_io_deq_ready = SLR0_Mem_io_R_array_index_63_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_8_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_8_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_8_enq_valid = _T_930; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_8_enq_bits = R_array_index_02_slr1_8_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_8_deq_ready = q_R_array_index_slr0_64_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_8_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_8_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_8_enq_valid = _T_929; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_8_enq_bits = R_array_index_02_slr2_8_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_8_deq_ready = R_array_index_02_slr0_8_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_8_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_8_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_8_enq_valid = SLR2_io_R_array_index_8_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_8_enq_bits = SLR2_io_R_array_index_8_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_8_deq_ready = R_array_index_02_slr1_8_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_64_clock = clock;
  assign q_R_array_index_slr0_64_reset = reset;
  assign q_R_array_index_slr0_64_io_enq_valid = _T_931; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_64_io_enq_bits = R_array_index_02_slr0_8_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_64_io_deq_ready = SLR0_Mem_io_R_array_index_64_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_9_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_9_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_9_enq_valid = _T_936; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_9_enq_bits = R_array_index_02_slr1_9_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_9_deq_ready = q_R_array_index_slr0_65_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_9_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_9_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_9_enq_valid = _T_935; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_9_enq_bits = R_array_index_02_slr2_9_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_9_deq_ready = R_array_index_02_slr0_9_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_9_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_9_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_9_enq_valid = SLR2_io_R_array_index_9_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_9_enq_bits = SLR2_io_R_array_index_9_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_9_deq_ready = R_array_index_02_slr1_9_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_65_clock = clock;
  assign q_R_array_index_slr0_65_reset = reset;
  assign q_R_array_index_slr0_65_io_enq_valid = _T_937; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_65_io_enq_bits = R_array_index_02_slr0_9_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_65_io_deq_ready = SLR0_Mem_io_R_array_index_65_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_10_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_10_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_10_enq_valid = _T_942; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_10_enq_bits = R_array_index_02_slr1_10_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_10_deq_ready = q_R_array_index_slr0_66_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_10_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_10_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_10_enq_valid = _T_941; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_10_enq_bits = R_array_index_02_slr2_10_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_10_deq_ready = R_array_index_02_slr0_10_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_10_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_10_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_10_enq_valid = SLR2_io_R_array_index_10_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_10_enq_bits = SLR2_io_R_array_index_10_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_10_deq_ready = R_array_index_02_slr1_10_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_66_clock = clock;
  assign q_R_array_index_slr0_66_reset = reset;
  assign q_R_array_index_slr0_66_io_enq_valid = _T_943; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_66_io_enq_bits = R_array_index_02_slr0_10_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_66_io_deq_ready = SLR0_Mem_io_R_array_index_66_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_11_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_11_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_11_enq_valid = _T_948; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_11_enq_bits = R_array_index_02_slr1_11_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_11_deq_ready = q_R_array_index_slr0_67_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_11_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_11_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_11_enq_valid = _T_947; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_11_enq_bits = R_array_index_02_slr2_11_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_11_deq_ready = R_array_index_02_slr0_11_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_11_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_11_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_11_enq_valid = SLR2_io_R_array_index_11_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_11_enq_bits = SLR2_io_R_array_index_11_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_11_deq_ready = R_array_index_02_slr1_11_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_67_clock = clock;
  assign q_R_array_index_slr0_67_reset = reset;
  assign q_R_array_index_slr0_67_io_enq_valid = _T_949; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_67_io_enq_bits = R_array_index_02_slr0_11_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_67_io_deq_ready = SLR0_Mem_io_R_array_index_67_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_12_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_12_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_12_enq_valid = _T_954; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_12_enq_bits = R_array_index_02_slr1_12_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_12_deq_ready = q_R_array_index_slr0_68_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_12_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_12_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_12_enq_valid = _T_953; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_12_enq_bits = R_array_index_02_slr2_12_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_12_deq_ready = R_array_index_02_slr0_12_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_12_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_12_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_12_enq_valid = SLR2_io_R_array_index_12_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_12_enq_bits = SLR2_io_R_array_index_12_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_12_deq_ready = R_array_index_02_slr1_12_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_68_clock = clock;
  assign q_R_array_index_slr0_68_reset = reset;
  assign q_R_array_index_slr0_68_io_enq_valid = _T_955; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_68_io_enq_bits = R_array_index_02_slr0_12_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_68_io_deq_ready = SLR0_Mem_io_R_array_index_68_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_13_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_13_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_13_enq_valid = _T_960; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_13_enq_bits = R_array_index_02_slr1_13_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_13_deq_ready = q_R_array_index_slr0_69_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_13_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_13_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_13_enq_valid = _T_959; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_13_enq_bits = R_array_index_02_slr2_13_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_13_deq_ready = R_array_index_02_slr0_13_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_13_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_13_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_13_enq_valid = SLR2_io_R_array_index_13_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_13_enq_bits = SLR2_io_R_array_index_13_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_13_deq_ready = R_array_index_02_slr1_13_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_69_clock = clock;
  assign q_R_array_index_slr0_69_reset = reset;
  assign q_R_array_index_slr0_69_io_enq_valid = _T_961; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_69_io_enq_bits = R_array_index_02_slr0_13_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_69_io_deq_ready = SLR0_Mem_io_R_array_index_69_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_14_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_14_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_14_enq_valid = _T_966; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_14_enq_bits = R_array_index_02_slr1_14_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_14_deq_ready = q_R_array_index_slr0_70_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_14_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_14_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_14_enq_valid = _T_965; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_14_enq_bits = R_array_index_02_slr2_14_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_14_deq_ready = R_array_index_02_slr0_14_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_14_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_14_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_14_enq_valid = SLR2_io_R_array_index_14_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_14_enq_bits = SLR2_io_R_array_index_14_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_14_deq_ready = R_array_index_02_slr1_14_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_70_clock = clock;
  assign q_R_array_index_slr0_70_reset = reset;
  assign q_R_array_index_slr0_70_io_enq_valid = _T_967; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_70_io_enq_bits = R_array_index_02_slr0_14_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_70_io_deq_ready = SLR0_Mem_io_R_array_index_70_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_15_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_15_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_15_enq_valid = _T_972; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_15_enq_bits = R_array_index_02_slr1_15_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_15_deq_ready = q_R_array_index_slr0_71_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_15_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_15_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_15_enq_valid = _T_971; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_15_enq_bits = R_array_index_02_slr2_15_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_15_deq_ready = R_array_index_02_slr0_15_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_15_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_15_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_15_enq_valid = SLR2_io_R_array_index_15_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_15_enq_bits = SLR2_io_R_array_index_15_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_15_deq_ready = R_array_index_02_slr1_15_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_71_clock = clock;
  assign q_R_array_index_slr0_71_reset = reset;
  assign q_R_array_index_slr0_71_io_enq_valid = _T_973; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_71_io_enq_bits = R_array_index_02_slr0_15_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_71_io_deq_ready = SLR0_Mem_io_R_array_index_71_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_16_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_16_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_16_enq_valid = _T_978; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_16_enq_bits = R_array_index_02_slr1_16_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_16_deq_ready = q_R_array_index_slr0_72_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_16_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_16_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_16_enq_valid = _T_977; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_16_enq_bits = R_array_index_02_slr2_16_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_16_deq_ready = R_array_index_02_slr0_16_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_16_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_16_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_16_enq_valid = SLR2_io_R_array_index_16_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_16_enq_bits = SLR2_io_R_array_index_16_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_16_deq_ready = R_array_index_02_slr1_16_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_72_clock = clock;
  assign q_R_array_index_slr0_72_reset = reset;
  assign q_R_array_index_slr0_72_io_enq_valid = _T_979; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_72_io_enq_bits = R_array_index_02_slr0_16_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_72_io_deq_ready = SLR0_Mem_io_R_array_index_72_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_17_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_17_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_17_enq_valid = _T_984; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_17_enq_bits = R_array_index_02_slr1_17_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_17_deq_ready = q_R_array_index_slr0_73_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_17_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_17_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_17_enq_valid = _T_983; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_17_enq_bits = R_array_index_02_slr2_17_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_17_deq_ready = R_array_index_02_slr0_17_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_17_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_17_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_17_enq_valid = SLR2_io_R_array_index_17_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_17_enq_bits = SLR2_io_R_array_index_17_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_17_deq_ready = R_array_index_02_slr1_17_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_73_clock = clock;
  assign q_R_array_index_slr0_73_reset = reset;
  assign q_R_array_index_slr0_73_io_enq_valid = _T_985; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_73_io_enq_bits = R_array_index_02_slr0_17_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_73_io_deq_ready = SLR0_Mem_io_R_array_index_73_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_18_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_18_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_18_enq_valid = _T_990; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_18_enq_bits = R_array_index_02_slr1_18_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_18_deq_ready = q_R_array_index_slr0_74_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_18_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_18_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_18_enq_valid = _T_989; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_18_enq_bits = R_array_index_02_slr2_18_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_18_deq_ready = R_array_index_02_slr0_18_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_18_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_18_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_18_enq_valid = SLR2_io_R_array_index_18_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_18_enq_bits = SLR2_io_R_array_index_18_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_18_deq_ready = R_array_index_02_slr1_18_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_74_clock = clock;
  assign q_R_array_index_slr0_74_reset = reset;
  assign q_R_array_index_slr0_74_io_enq_valid = _T_991; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_74_io_enq_bits = R_array_index_02_slr0_18_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_74_io_deq_ready = SLR0_Mem_io_R_array_index_74_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_19_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_19_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_19_enq_valid = _T_996; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_19_enq_bits = R_array_index_02_slr1_19_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_19_deq_ready = q_R_array_index_slr0_75_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_19_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_19_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_19_enq_valid = _T_995; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_19_enq_bits = R_array_index_02_slr2_19_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_19_deq_ready = R_array_index_02_slr0_19_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_19_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_19_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_19_enq_valid = SLR2_io_R_array_index_19_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_19_enq_bits = SLR2_io_R_array_index_19_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_19_deq_ready = R_array_index_02_slr1_19_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_75_clock = clock;
  assign q_R_array_index_slr0_75_reset = reset;
  assign q_R_array_index_slr0_75_io_enq_valid = _T_997; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_75_io_enq_bits = R_array_index_02_slr0_19_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_75_io_deq_ready = SLR0_Mem_io_R_array_index_75_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_20_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_20_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_20_enq_valid = _T_1002; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_20_enq_bits = R_array_index_02_slr1_20_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_20_deq_ready = q_R_array_index_slr0_76_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_20_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_20_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_20_enq_valid = _T_1001; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_20_enq_bits = R_array_index_02_slr2_20_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_20_deq_ready = R_array_index_02_slr0_20_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_20_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_20_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_20_enq_valid = SLR2_io_R_array_index_20_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_20_enq_bits = SLR2_io_R_array_index_20_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_20_deq_ready = R_array_index_02_slr1_20_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_76_clock = clock;
  assign q_R_array_index_slr0_76_reset = reset;
  assign q_R_array_index_slr0_76_io_enq_valid = _T_1003; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_76_io_enq_bits = R_array_index_02_slr0_20_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_76_io_deq_ready = SLR0_Mem_io_R_array_index_76_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_21_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_21_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_21_enq_valid = _T_1008; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_21_enq_bits = R_array_index_02_slr1_21_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_21_deq_ready = q_R_array_index_slr0_77_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_21_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_21_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_21_enq_valid = _T_1007; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_21_enq_bits = R_array_index_02_slr2_21_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_21_deq_ready = R_array_index_02_slr0_21_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_21_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_21_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_21_enq_valid = SLR2_io_R_array_index_21_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_21_enq_bits = SLR2_io_R_array_index_21_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_21_deq_ready = R_array_index_02_slr1_21_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_77_clock = clock;
  assign q_R_array_index_slr0_77_reset = reset;
  assign q_R_array_index_slr0_77_io_enq_valid = _T_1009; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_77_io_enq_bits = R_array_index_02_slr0_21_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_77_io_deq_ready = SLR0_Mem_io_R_array_index_77_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_22_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_22_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_22_enq_valid = _T_1014; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_22_enq_bits = R_array_index_02_slr1_22_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_22_deq_ready = q_R_array_index_slr0_78_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_22_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_22_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_22_enq_valid = _T_1013; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_22_enq_bits = R_array_index_02_slr2_22_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_22_deq_ready = R_array_index_02_slr0_22_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_22_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_22_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_22_enq_valid = SLR2_io_R_array_index_22_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_22_enq_bits = SLR2_io_R_array_index_22_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_22_deq_ready = R_array_index_02_slr1_22_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_78_clock = clock;
  assign q_R_array_index_slr0_78_reset = reset;
  assign q_R_array_index_slr0_78_io_enq_valid = _T_1015; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_78_io_enq_bits = R_array_index_02_slr0_22_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_78_io_deq_ready = SLR0_Mem_io_R_array_index_78_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_23_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_23_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_23_enq_valid = _T_1020; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_23_enq_bits = R_array_index_02_slr1_23_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_23_deq_ready = q_R_array_index_slr0_79_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_23_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_23_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_23_enq_valid = _T_1019; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_23_enq_bits = R_array_index_02_slr2_23_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_23_deq_ready = R_array_index_02_slr0_23_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_23_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_23_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_23_enq_valid = SLR2_io_R_array_index_23_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_23_enq_bits = SLR2_io_R_array_index_23_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_23_deq_ready = R_array_index_02_slr1_23_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_79_clock = clock;
  assign q_R_array_index_slr0_79_reset = reset;
  assign q_R_array_index_slr0_79_io_enq_valid = _T_1021; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_79_io_enq_bits = R_array_index_02_slr0_23_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_79_io_deq_ready = SLR0_Mem_io_R_array_index_79_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_24_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_24_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_24_enq_valid = _T_1026; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_24_enq_bits = R_array_index_02_slr1_24_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_24_deq_ready = q_R_array_index_slr0_80_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_24_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_24_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_24_enq_valid = _T_1025; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_24_enq_bits = R_array_index_02_slr2_24_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_24_deq_ready = R_array_index_02_slr0_24_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_24_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_24_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_24_enq_valid = SLR2_io_R_array_index_24_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_24_enq_bits = SLR2_io_R_array_index_24_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_24_deq_ready = R_array_index_02_slr1_24_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_80_clock = clock;
  assign q_R_array_index_slr0_80_reset = reset;
  assign q_R_array_index_slr0_80_io_enq_valid = _T_1027; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_80_io_enq_bits = R_array_index_02_slr0_24_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_80_io_deq_ready = SLR0_Mem_io_R_array_index_80_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_25_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_25_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_25_enq_valid = _T_1032; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_25_enq_bits = R_array_index_02_slr1_25_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_25_deq_ready = q_R_array_index_slr0_81_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_25_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_25_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_25_enq_valid = _T_1031; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_25_enq_bits = R_array_index_02_slr2_25_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_25_deq_ready = R_array_index_02_slr0_25_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_25_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_25_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_25_enq_valid = SLR2_io_R_array_index_25_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_25_enq_bits = SLR2_io_R_array_index_25_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_25_deq_ready = R_array_index_02_slr1_25_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_81_clock = clock;
  assign q_R_array_index_slr0_81_reset = reset;
  assign q_R_array_index_slr0_81_io_enq_valid = _T_1033; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_81_io_enq_bits = R_array_index_02_slr0_25_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_81_io_deq_ready = SLR0_Mem_io_R_array_index_81_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_26_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_26_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_26_enq_valid = _T_1038; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_26_enq_bits = R_array_index_02_slr1_26_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_26_deq_ready = q_R_array_index_slr0_82_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_26_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_26_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_26_enq_valid = _T_1037; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_26_enq_bits = R_array_index_02_slr2_26_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_26_deq_ready = R_array_index_02_slr0_26_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_26_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_26_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_26_enq_valid = SLR2_io_R_array_index_26_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_26_enq_bits = SLR2_io_R_array_index_26_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_26_deq_ready = R_array_index_02_slr1_26_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_82_clock = clock;
  assign q_R_array_index_slr0_82_reset = reset;
  assign q_R_array_index_slr0_82_io_enq_valid = _T_1039; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_82_io_enq_bits = R_array_index_02_slr0_26_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_82_io_deq_ready = SLR0_Mem_io_R_array_index_82_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_27_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_27_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_27_enq_valid = _T_1044; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_27_enq_bits = R_array_index_02_slr1_27_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_27_deq_ready = q_R_array_index_slr0_83_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_27_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_27_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_27_enq_valid = _T_1043; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_27_enq_bits = R_array_index_02_slr2_27_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_27_deq_ready = R_array_index_02_slr0_27_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_27_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_27_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_27_enq_valid = SLR2_io_R_array_index_27_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_27_enq_bits = SLR2_io_R_array_index_27_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_27_deq_ready = R_array_index_02_slr1_27_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_83_clock = clock;
  assign q_R_array_index_slr0_83_reset = reset;
  assign q_R_array_index_slr0_83_io_enq_valid = _T_1045; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_83_io_enq_bits = R_array_index_02_slr0_27_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_83_io_deq_ready = SLR0_Mem_io_R_array_index_83_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_28_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_28_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_28_enq_valid = _T_1050; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_28_enq_bits = R_array_index_02_slr1_28_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_28_deq_ready = q_R_array_index_slr0_84_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_28_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_28_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_28_enq_valid = _T_1049; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_28_enq_bits = R_array_index_02_slr2_28_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_28_deq_ready = R_array_index_02_slr0_28_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_28_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_28_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_28_enq_valid = SLR2_io_R_array_index_28_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_28_enq_bits = SLR2_io_R_array_index_28_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_28_deq_ready = R_array_index_02_slr1_28_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_84_clock = clock;
  assign q_R_array_index_slr0_84_reset = reset;
  assign q_R_array_index_slr0_84_io_enq_valid = _T_1051; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_84_io_enq_bits = R_array_index_02_slr0_28_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_84_io_deq_ready = SLR0_Mem_io_R_array_index_84_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_29_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_29_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_29_enq_valid = _T_1056; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_29_enq_bits = R_array_index_02_slr1_29_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_29_deq_ready = q_R_array_index_slr0_85_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_29_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_29_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_29_enq_valid = _T_1055; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_29_enq_bits = R_array_index_02_slr2_29_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_29_deq_ready = R_array_index_02_slr0_29_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_29_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_29_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_29_enq_valid = SLR2_io_R_array_index_29_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_29_enq_bits = SLR2_io_R_array_index_29_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_29_deq_ready = R_array_index_02_slr1_29_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_85_clock = clock;
  assign q_R_array_index_slr0_85_reset = reset;
  assign q_R_array_index_slr0_85_io_enq_valid = _T_1057; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_85_io_enq_bits = R_array_index_02_slr0_29_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_85_io_deq_ready = SLR0_Mem_io_R_array_index_85_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_30_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_30_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_30_enq_valid = _T_1062; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_30_enq_bits = R_array_index_02_slr1_30_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_30_deq_ready = q_R_array_index_slr0_86_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_30_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_30_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_30_enq_valid = _T_1061; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_30_enq_bits = R_array_index_02_slr2_30_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_30_deq_ready = R_array_index_02_slr0_30_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_30_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_30_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_30_enq_valid = SLR2_io_R_array_index_30_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_30_enq_bits = SLR2_io_R_array_index_30_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_30_deq_ready = R_array_index_02_slr1_30_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_86_clock = clock;
  assign q_R_array_index_slr0_86_reset = reset;
  assign q_R_array_index_slr0_86_io_enq_valid = _T_1063; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_86_io_enq_bits = R_array_index_02_slr0_30_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_86_io_deq_ready = SLR0_Mem_io_R_array_index_86_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_31_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_31_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_31_enq_valid = _T_1068; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_31_enq_bits = R_array_index_02_slr1_31_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_31_deq_ready = q_R_array_index_slr0_87_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_31_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_31_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_31_enq_valid = _T_1067; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_31_enq_bits = R_array_index_02_slr2_31_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_31_deq_ready = R_array_index_02_slr0_31_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_31_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_31_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_31_enq_valid = SLR2_io_R_array_index_31_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_31_enq_bits = SLR2_io_R_array_index_31_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_31_deq_ready = R_array_index_02_slr1_31_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_87_clock = clock;
  assign q_R_array_index_slr0_87_reset = reset;
  assign q_R_array_index_slr0_87_io_enq_valid = _T_1069; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_87_io_enq_bits = R_array_index_02_slr0_31_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_87_io_deq_ready = SLR0_Mem_io_R_array_index_87_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_32_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_32_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_32_enq_valid = _T_1074; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_32_enq_bits = R_array_index_02_slr1_32_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_32_deq_ready = q_R_array_index_slr0_88_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_32_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_32_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_32_enq_valid = _T_1073; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_32_enq_bits = R_array_index_02_slr2_32_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_32_deq_ready = R_array_index_02_slr0_32_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_32_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_32_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_32_enq_valid = SLR2_io_R_array_index_32_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_32_enq_bits = SLR2_io_R_array_index_32_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_32_deq_ready = R_array_index_02_slr1_32_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_88_clock = clock;
  assign q_R_array_index_slr0_88_reset = reset;
  assign q_R_array_index_slr0_88_io_enq_valid = _T_1075; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_88_io_enq_bits = R_array_index_02_slr0_32_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_88_io_deq_ready = SLR0_Mem_io_R_array_index_88_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_33_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_33_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_33_enq_valid = _T_1080; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_33_enq_bits = R_array_index_02_slr1_33_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_33_deq_ready = q_R_array_index_slr0_89_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_33_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_33_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_33_enq_valid = _T_1079; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_33_enq_bits = R_array_index_02_slr2_33_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_33_deq_ready = R_array_index_02_slr0_33_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_33_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_33_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_33_enq_valid = SLR2_io_R_array_index_33_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_33_enq_bits = SLR2_io_R_array_index_33_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_33_deq_ready = R_array_index_02_slr1_33_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_89_clock = clock;
  assign q_R_array_index_slr0_89_reset = reset;
  assign q_R_array_index_slr0_89_io_enq_valid = _T_1081; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_89_io_enq_bits = R_array_index_02_slr0_33_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_89_io_deq_ready = SLR0_Mem_io_R_array_index_89_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_34_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_34_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_34_enq_valid = _T_1086; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_34_enq_bits = R_array_index_02_slr1_34_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_34_deq_ready = q_R_array_index_slr0_90_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_34_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_34_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_34_enq_valid = _T_1085; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_34_enq_bits = R_array_index_02_slr2_34_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_34_deq_ready = R_array_index_02_slr0_34_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_34_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_34_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_34_enq_valid = SLR2_io_R_array_index_34_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_34_enq_bits = SLR2_io_R_array_index_34_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_34_deq_ready = R_array_index_02_slr1_34_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_90_clock = clock;
  assign q_R_array_index_slr0_90_reset = reset;
  assign q_R_array_index_slr0_90_io_enq_valid = _T_1087; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_90_io_enq_bits = R_array_index_02_slr0_34_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_90_io_deq_ready = SLR0_Mem_io_R_array_index_90_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_35_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_35_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_35_enq_valid = _T_1092; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_35_enq_bits = R_array_index_02_slr1_35_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_35_deq_ready = q_R_array_index_slr0_91_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_35_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_35_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_35_enq_valid = _T_1091; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_35_enq_bits = R_array_index_02_slr2_35_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_35_deq_ready = R_array_index_02_slr0_35_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_35_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_35_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_35_enq_valid = SLR2_io_R_array_index_35_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_35_enq_bits = SLR2_io_R_array_index_35_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_35_deq_ready = R_array_index_02_slr1_35_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_91_clock = clock;
  assign q_R_array_index_slr0_91_reset = reset;
  assign q_R_array_index_slr0_91_io_enq_valid = _T_1093; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_91_io_enq_bits = R_array_index_02_slr0_35_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_91_io_deq_ready = SLR0_Mem_io_R_array_index_91_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_36_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_36_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_36_enq_valid = _T_1098; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_36_enq_bits = R_array_index_02_slr1_36_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_36_deq_ready = q_R_array_index_slr0_92_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_36_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_36_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_36_enq_valid = _T_1097; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_36_enq_bits = R_array_index_02_slr2_36_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_36_deq_ready = R_array_index_02_slr0_36_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_36_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_36_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_36_enq_valid = SLR2_io_R_array_index_36_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_36_enq_bits = SLR2_io_R_array_index_36_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_36_deq_ready = R_array_index_02_slr1_36_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_92_clock = clock;
  assign q_R_array_index_slr0_92_reset = reset;
  assign q_R_array_index_slr0_92_io_enq_valid = _T_1099; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_92_io_enq_bits = R_array_index_02_slr0_36_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_92_io_deq_ready = SLR0_Mem_io_R_array_index_92_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_37_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_37_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_37_enq_valid = _T_1104; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_37_enq_bits = R_array_index_02_slr1_37_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_37_deq_ready = q_R_array_index_slr0_93_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_37_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_37_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_37_enq_valid = _T_1103; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_37_enq_bits = R_array_index_02_slr2_37_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_37_deq_ready = R_array_index_02_slr0_37_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_37_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_37_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_37_enq_valid = SLR2_io_R_array_index_37_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_37_enq_bits = SLR2_io_R_array_index_37_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_37_deq_ready = R_array_index_02_slr1_37_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_93_clock = clock;
  assign q_R_array_index_slr0_93_reset = reset;
  assign q_R_array_index_slr0_93_io_enq_valid = _T_1105; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_93_io_enq_bits = R_array_index_02_slr0_37_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_93_io_deq_ready = SLR0_Mem_io_R_array_index_93_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_38_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_38_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_38_enq_valid = _T_1110; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_38_enq_bits = R_array_index_02_slr1_38_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_38_deq_ready = q_R_array_index_slr0_94_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_38_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_38_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_38_enq_valid = _T_1109; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_38_enq_bits = R_array_index_02_slr2_38_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_38_deq_ready = R_array_index_02_slr0_38_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_38_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_38_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_38_enq_valid = SLR2_io_R_array_index_38_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_38_enq_bits = SLR2_io_R_array_index_38_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_38_deq_ready = R_array_index_02_slr1_38_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_94_clock = clock;
  assign q_R_array_index_slr0_94_reset = reset;
  assign q_R_array_index_slr0_94_io_enq_valid = _T_1111; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_94_io_enq_bits = R_array_index_02_slr0_38_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_94_io_deq_ready = SLR0_Mem_io_R_array_index_94_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_39_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_39_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_39_enq_valid = _T_1116; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_39_enq_bits = R_array_index_02_slr1_39_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_39_deq_ready = q_R_array_index_slr0_95_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_39_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_39_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_39_enq_valid = _T_1115; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_39_enq_bits = R_array_index_02_slr2_39_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_39_deq_ready = R_array_index_02_slr0_39_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_39_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_39_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_39_enq_valid = SLR2_io_R_array_index_39_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_39_enq_bits = SLR2_io_R_array_index_39_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_39_deq_ready = R_array_index_02_slr1_39_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_95_clock = clock;
  assign q_R_array_index_slr0_95_reset = reset;
  assign q_R_array_index_slr0_95_io_enq_valid = _T_1117; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_95_io_enq_bits = R_array_index_02_slr0_39_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_95_io_deq_ready = SLR0_Mem_io_R_array_index_95_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_40_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_40_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_40_enq_valid = _T_1122; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_40_enq_bits = R_array_index_02_slr1_40_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_40_deq_ready = q_R_array_index_slr0_96_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_40_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_40_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_40_enq_valid = _T_1121; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_40_enq_bits = R_array_index_02_slr2_40_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_40_deq_ready = R_array_index_02_slr0_40_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_40_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_40_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_40_enq_valid = SLR2_io_R_array_index_40_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_40_enq_bits = SLR2_io_R_array_index_40_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_40_deq_ready = R_array_index_02_slr1_40_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_96_clock = clock;
  assign q_R_array_index_slr0_96_reset = reset;
  assign q_R_array_index_slr0_96_io_enq_valid = _T_1123; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_96_io_enq_bits = R_array_index_02_slr0_40_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_96_io_deq_ready = SLR0_Mem_io_R_array_index_96_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_41_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_41_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_41_enq_valid = _T_1128; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_41_enq_bits = R_array_index_02_slr1_41_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_41_deq_ready = q_R_array_index_slr0_97_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_41_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_41_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_41_enq_valid = _T_1127; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_41_enq_bits = R_array_index_02_slr2_41_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_41_deq_ready = R_array_index_02_slr0_41_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_41_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_41_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_41_enq_valid = SLR2_io_R_array_index_41_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_41_enq_bits = SLR2_io_R_array_index_41_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_41_deq_ready = R_array_index_02_slr1_41_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_97_clock = clock;
  assign q_R_array_index_slr0_97_reset = reset;
  assign q_R_array_index_slr0_97_io_enq_valid = _T_1129; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_97_io_enq_bits = R_array_index_02_slr0_41_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_97_io_deq_ready = SLR0_Mem_io_R_array_index_97_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_42_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_42_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_42_enq_valid = _T_1134; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_42_enq_bits = R_array_index_02_slr1_42_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_42_deq_ready = q_R_array_index_slr0_98_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_42_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_42_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_42_enq_valid = _T_1133; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_42_enq_bits = R_array_index_02_slr2_42_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_42_deq_ready = R_array_index_02_slr0_42_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_42_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_42_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_42_enq_valid = SLR2_io_R_array_index_42_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_42_enq_bits = SLR2_io_R_array_index_42_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_42_deq_ready = R_array_index_02_slr1_42_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_98_clock = clock;
  assign q_R_array_index_slr0_98_reset = reset;
  assign q_R_array_index_slr0_98_io_enq_valid = _T_1135; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_98_io_enq_bits = R_array_index_02_slr0_42_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_98_io_deq_ready = SLR0_Mem_io_R_array_index_98_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_43_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_43_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_43_enq_valid = _T_1140; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_43_enq_bits = R_array_index_02_slr1_43_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_43_deq_ready = q_R_array_index_slr0_99_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_43_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_43_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_43_enq_valid = _T_1139; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_43_enq_bits = R_array_index_02_slr2_43_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_43_deq_ready = R_array_index_02_slr0_43_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_43_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_43_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_43_enq_valid = SLR2_io_R_array_index_43_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_43_enq_bits = SLR2_io_R_array_index_43_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_43_deq_ready = R_array_index_02_slr1_43_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_99_clock = clock;
  assign q_R_array_index_slr0_99_reset = reset;
  assign q_R_array_index_slr0_99_io_enq_valid = _T_1141; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_99_io_enq_bits = R_array_index_02_slr0_43_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_99_io_deq_ready = SLR0_Mem_io_R_array_index_99_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_44_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_44_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_44_enq_valid = _T_1146; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_44_enq_bits = R_array_index_02_slr1_44_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_44_deq_ready = q_R_array_index_slr0_100_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_44_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_44_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_44_enq_valid = _T_1145; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_44_enq_bits = R_array_index_02_slr2_44_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_44_deq_ready = R_array_index_02_slr0_44_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_44_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_44_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_44_enq_valid = SLR2_io_R_array_index_44_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_44_enq_bits = SLR2_io_R_array_index_44_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_44_deq_ready = R_array_index_02_slr1_44_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_100_clock = clock;
  assign q_R_array_index_slr0_100_reset = reset;
  assign q_R_array_index_slr0_100_io_enq_valid = _T_1147; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_100_io_enq_bits = R_array_index_02_slr0_44_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_100_io_deq_ready = SLR0_Mem_io_R_array_index_100_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_45_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_45_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_45_enq_valid = _T_1152; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_45_enq_bits = R_array_index_02_slr1_45_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_45_deq_ready = q_R_array_index_slr0_101_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_45_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_45_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_45_enq_valid = _T_1151; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_45_enq_bits = R_array_index_02_slr2_45_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_45_deq_ready = R_array_index_02_slr0_45_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_45_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_45_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_45_enq_valid = SLR2_io_R_array_index_45_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_45_enq_bits = SLR2_io_R_array_index_45_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_45_deq_ready = R_array_index_02_slr1_45_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_101_clock = clock;
  assign q_R_array_index_slr0_101_reset = reset;
  assign q_R_array_index_slr0_101_io_enq_valid = _T_1153; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_101_io_enq_bits = R_array_index_02_slr0_45_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_101_io_deq_ready = SLR0_Mem_io_R_array_index_101_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_46_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_46_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_46_enq_valid = _T_1158; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_46_enq_bits = R_array_index_02_slr1_46_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_46_deq_ready = q_R_array_index_slr0_102_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_46_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_46_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_46_enq_valid = _T_1157; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_46_enq_bits = R_array_index_02_slr2_46_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_46_deq_ready = R_array_index_02_slr0_46_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_46_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_46_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_46_enq_valid = SLR2_io_R_array_index_46_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_46_enq_bits = SLR2_io_R_array_index_46_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_46_deq_ready = R_array_index_02_slr1_46_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_102_clock = clock;
  assign q_R_array_index_slr0_102_reset = reset;
  assign q_R_array_index_slr0_102_io_enq_valid = _T_1159; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_102_io_enq_bits = R_array_index_02_slr0_46_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_102_io_deq_ready = SLR0_Mem_io_R_array_index_102_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_47_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_47_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_47_enq_valid = _T_1164; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_47_enq_bits = R_array_index_02_slr1_47_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_47_deq_ready = q_R_array_index_slr0_103_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_47_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_47_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_47_enq_valid = _T_1163; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_47_enq_bits = R_array_index_02_slr2_47_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_47_deq_ready = R_array_index_02_slr0_47_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_47_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_47_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_47_enq_valid = SLR2_io_R_array_index_47_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_47_enq_bits = SLR2_io_R_array_index_47_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_47_deq_ready = R_array_index_02_slr1_47_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_103_clock = clock;
  assign q_R_array_index_slr0_103_reset = reset;
  assign q_R_array_index_slr0_103_io_enq_valid = _T_1165; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_103_io_enq_bits = R_array_index_02_slr0_47_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_103_io_deq_ready = SLR0_Mem_io_R_array_index_103_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_48_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_48_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_48_enq_valid = _T_1170; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_48_enq_bits = R_array_index_02_slr1_48_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_48_deq_ready = q_R_array_index_slr0_104_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_48_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_48_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_48_enq_valid = _T_1169; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_48_enq_bits = R_array_index_02_slr2_48_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_48_deq_ready = R_array_index_02_slr0_48_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_48_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_48_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_48_enq_valid = SLR2_io_R_array_index_48_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_48_enq_bits = SLR2_io_R_array_index_48_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_48_deq_ready = R_array_index_02_slr1_48_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_104_clock = clock;
  assign q_R_array_index_slr0_104_reset = reset;
  assign q_R_array_index_slr0_104_io_enq_valid = _T_1171; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_104_io_enq_bits = R_array_index_02_slr0_48_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_104_io_deq_ready = SLR0_Mem_io_R_array_index_104_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_49_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_49_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_49_enq_valid = _T_1176; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_49_enq_bits = R_array_index_02_slr1_49_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_49_deq_ready = q_R_array_index_slr0_105_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_49_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_49_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_49_enq_valid = _T_1175; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_49_enq_bits = R_array_index_02_slr2_49_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_49_deq_ready = R_array_index_02_slr0_49_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_49_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_49_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_49_enq_valid = SLR2_io_R_array_index_49_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_49_enq_bits = SLR2_io_R_array_index_49_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_49_deq_ready = R_array_index_02_slr1_49_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_105_clock = clock;
  assign q_R_array_index_slr0_105_reset = reset;
  assign q_R_array_index_slr0_105_io_enq_valid = _T_1177; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_105_io_enq_bits = R_array_index_02_slr0_49_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_105_io_deq_ready = SLR0_Mem_io_R_array_index_105_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_50_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_50_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_50_enq_valid = _T_1182; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_50_enq_bits = R_array_index_02_slr1_50_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_50_deq_ready = q_R_array_index_slr0_106_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_50_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_50_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_50_enq_valid = _T_1181; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_50_enq_bits = R_array_index_02_slr2_50_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_50_deq_ready = R_array_index_02_slr0_50_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_50_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_50_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_50_enq_valid = SLR2_io_R_array_index_50_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_50_enq_bits = SLR2_io_R_array_index_50_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_50_deq_ready = R_array_index_02_slr1_50_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_106_clock = clock;
  assign q_R_array_index_slr0_106_reset = reset;
  assign q_R_array_index_slr0_106_io_enq_valid = _T_1183; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_106_io_enq_bits = R_array_index_02_slr0_50_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_106_io_deq_ready = SLR0_Mem_io_R_array_index_106_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_51_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_51_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_51_enq_valid = _T_1188; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_51_enq_bits = R_array_index_02_slr1_51_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_51_deq_ready = q_R_array_index_slr0_107_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_51_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_51_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_51_enq_valid = _T_1187; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_51_enq_bits = R_array_index_02_slr2_51_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_51_deq_ready = R_array_index_02_slr0_51_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_51_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_51_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_51_enq_valid = SLR2_io_R_array_index_51_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_51_enq_bits = SLR2_io_R_array_index_51_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_51_deq_ready = R_array_index_02_slr1_51_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_107_clock = clock;
  assign q_R_array_index_slr0_107_reset = reset;
  assign q_R_array_index_slr0_107_io_enq_valid = _T_1189; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_107_io_enq_bits = R_array_index_02_slr0_51_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_107_io_deq_ready = SLR0_Mem_io_R_array_index_107_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_52_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_52_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_52_enq_valid = _T_1194; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_52_enq_bits = R_array_index_02_slr1_52_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_52_deq_ready = q_R_array_index_slr0_108_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_52_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_52_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_52_enq_valid = _T_1193; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_52_enq_bits = R_array_index_02_slr2_52_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_52_deq_ready = R_array_index_02_slr0_52_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_52_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_52_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_52_enq_valid = SLR2_io_R_array_index_52_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_52_enq_bits = SLR2_io_R_array_index_52_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_52_deq_ready = R_array_index_02_slr1_52_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_108_clock = clock;
  assign q_R_array_index_slr0_108_reset = reset;
  assign q_R_array_index_slr0_108_io_enq_valid = _T_1195; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_108_io_enq_bits = R_array_index_02_slr0_52_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_108_io_deq_ready = SLR0_Mem_io_R_array_index_108_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_53_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_53_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_53_enq_valid = _T_1200; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_53_enq_bits = R_array_index_02_slr1_53_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_53_deq_ready = q_R_array_index_slr0_109_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_53_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_53_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_53_enq_valid = _T_1199; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_53_enq_bits = R_array_index_02_slr2_53_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_53_deq_ready = R_array_index_02_slr0_53_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_53_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_53_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_53_enq_valid = SLR2_io_R_array_index_53_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_53_enq_bits = SLR2_io_R_array_index_53_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_53_deq_ready = R_array_index_02_slr1_53_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_109_clock = clock;
  assign q_R_array_index_slr0_109_reset = reset;
  assign q_R_array_index_slr0_109_io_enq_valid = _T_1201; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_109_io_enq_bits = R_array_index_02_slr0_53_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_109_io_deq_ready = SLR0_Mem_io_R_array_index_109_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_54_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_54_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_54_enq_valid = _T_1206; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_54_enq_bits = R_array_index_02_slr1_54_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_54_deq_ready = q_R_array_index_slr0_110_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_54_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_54_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_54_enq_valid = _T_1205; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_54_enq_bits = R_array_index_02_slr2_54_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_54_deq_ready = R_array_index_02_slr0_54_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_54_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_54_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_54_enq_valid = SLR2_io_R_array_index_54_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_54_enq_bits = SLR2_io_R_array_index_54_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_54_deq_ready = R_array_index_02_slr1_54_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_110_clock = clock;
  assign q_R_array_index_slr0_110_reset = reset;
  assign q_R_array_index_slr0_110_io_enq_valid = _T_1207; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_110_io_enq_bits = R_array_index_02_slr0_54_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_110_io_deq_ready = SLR0_Mem_io_R_array_index_110_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_55_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_55_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_55_enq_valid = _T_1212; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_55_enq_bits = R_array_index_02_slr1_55_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_55_deq_ready = q_R_array_index_slr0_111_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_55_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_55_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_55_enq_valid = _T_1211; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_55_enq_bits = R_array_index_02_slr2_55_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_55_deq_ready = R_array_index_02_slr0_55_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_55_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_55_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_55_enq_valid = SLR2_io_R_array_index_55_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_55_enq_bits = SLR2_io_R_array_index_55_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_55_deq_ready = R_array_index_02_slr1_55_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_111_clock = clock;
  assign q_R_array_index_slr0_111_reset = reset;
  assign q_R_array_index_slr0_111_io_enq_valid = _T_1213; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_111_io_enq_bits = R_array_index_02_slr0_55_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_111_io_deq_ready = SLR0_Mem_io_R_array_index_111_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_56_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_56_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_56_enq_valid = _T_1218; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_56_enq_bits = R_array_index_02_slr1_56_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_56_deq_ready = q_R_array_index_slr0_112_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_56_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_56_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_56_enq_valid = _T_1217; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_56_enq_bits = R_array_index_02_slr2_56_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_56_deq_ready = R_array_index_02_slr0_56_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_56_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_56_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_56_enq_valid = SLR2_io_R_array_index_56_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_56_enq_bits = SLR2_io_R_array_index_56_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_56_deq_ready = R_array_index_02_slr1_56_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_112_clock = clock;
  assign q_R_array_index_slr0_112_reset = reset;
  assign q_R_array_index_slr0_112_io_enq_valid = _T_1219; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_112_io_enq_bits = R_array_index_02_slr0_56_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_112_io_deq_ready = SLR0_Mem_io_R_array_index_112_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_57_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_57_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_57_enq_valid = _T_1224; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_57_enq_bits = R_array_index_02_slr1_57_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_57_deq_ready = q_R_array_index_slr0_113_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_57_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_57_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_57_enq_valid = _T_1223; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_57_enq_bits = R_array_index_02_slr2_57_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_57_deq_ready = R_array_index_02_slr0_57_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_57_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_57_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_57_enq_valid = SLR2_io_R_array_index_57_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_57_enq_bits = SLR2_io_R_array_index_57_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_57_deq_ready = R_array_index_02_slr1_57_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_113_clock = clock;
  assign q_R_array_index_slr0_113_reset = reset;
  assign q_R_array_index_slr0_113_io_enq_valid = _T_1225; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_113_io_enq_bits = R_array_index_02_slr0_57_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_113_io_deq_ready = SLR0_Mem_io_R_array_index_113_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_58_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_58_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_58_enq_valid = _T_1230; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_58_enq_bits = R_array_index_02_slr1_58_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_58_deq_ready = q_R_array_index_slr0_114_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_58_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_58_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_58_enq_valid = _T_1229; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_58_enq_bits = R_array_index_02_slr2_58_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_58_deq_ready = R_array_index_02_slr0_58_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_58_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_58_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_58_enq_valid = SLR2_io_R_array_index_58_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_58_enq_bits = SLR2_io_R_array_index_58_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_58_deq_ready = R_array_index_02_slr1_58_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_114_clock = clock;
  assign q_R_array_index_slr0_114_reset = reset;
  assign q_R_array_index_slr0_114_io_enq_valid = _T_1231; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_114_io_enq_bits = R_array_index_02_slr0_58_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_114_io_deq_ready = SLR0_Mem_io_R_array_index_114_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_59_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_59_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_59_enq_valid = _T_1236; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_59_enq_bits = R_array_index_02_slr1_59_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_59_deq_ready = q_R_array_index_slr0_115_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_59_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_59_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_59_enq_valid = _T_1235; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_59_enq_bits = R_array_index_02_slr2_59_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_59_deq_ready = R_array_index_02_slr0_59_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_59_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_59_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_59_enq_valid = SLR2_io_R_array_index_59_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_59_enq_bits = SLR2_io_R_array_index_59_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_59_deq_ready = R_array_index_02_slr1_59_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_115_clock = clock;
  assign q_R_array_index_slr0_115_reset = reset;
  assign q_R_array_index_slr0_115_io_enq_valid = _T_1237; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_115_io_enq_bits = R_array_index_02_slr0_59_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_115_io_deq_ready = SLR0_Mem_io_R_array_index_115_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_60_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_60_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_60_enq_valid = _T_1242; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_60_enq_bits = R_array_index_02_slr1_60_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_60_deq_ready = q_R_array_index_slr0_116_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_60_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_60_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_60_enq_valid = _T_1241; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_60_enq_bits = R_array_index_02_slr2_60_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_60_deq_ready = R_array_index_02_slr0_60_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_60_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_60_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_60_enq_valid = SLR2_io_R_array_index_60_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_60_enq_bits = SLR2_io_R_array_index_60_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_60_deq_ready = R_array_index_02_slr1_60_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_116_clock = clock;
  assign q_R_array_index_slr0_116_reset = reset;
  assign q_R_array_index_slr0_116_io_enq_valid = _T_1243; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_116_io_enq_bits = R_array_index_02_slr0_60_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_116_io_deq_ready = SLR0_Mem_io_R_array_index_116_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_61_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_61_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_61_enq_valid = _T_1248; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_61_enq_bits = R_array_index_02_slr1_61_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_61_deq_ready = q_R_array_index_slr0_117_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_61_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_61_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_61_enq_valid = _T_1247; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_61_enq_bits = R_array_index_02_slr2_61_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_61_deq_ready = R_array_index_02_slr0_61_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_61_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_61_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_61_enq_valid = SLR2_io_R_array_index_61_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_61_enq_bits = SLR2_io_R_array_index_61_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_61_deq_ready = R_array_index_02_slr1_61_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_117_clock = clock;
  assign q_R_array_index_slr0_117_reset = reset;
  assign q_R_array_index_slr0_117_io_enq_valid = _T_1249; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_117_io_enq_bits = R_array_index_02_slr0_61_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_117_io_deq_ready = SLR0_Mem_io_R_array_index_117_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_62_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_62_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_62_enq_valid = _T_1254; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_62_enq_bits = R_array_index_02_slr1_62_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_62_deq_ready = q_R_array_index_slr0_118_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_62_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_62_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_62_enq_valid = _T_1253; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_62_enq_bits = R_array_index_02_slr2_62_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_62_deq_ready = R_array_index_02_slr0_62_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_62_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_62_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_62_enq_valid = SLR2_io_R_array_index_62_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_62_enq_bits = SLR2_io_R_array_index_62_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_62_deq_ready = R_array_index_02_slr1_62_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_118_clock = clock;
  assign q_R_array_index_slr0_118_reset = reset;
  assign q_R_array_index_slr0_118_io_enq_valid = _T_1255; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_118_io_enq_bits = R_array_index_02_slr0_62_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_118_io_deq_ready = SLR0_Mem_io_R_array_index_118_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_63_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_63_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_63_enq_valid = _T_1260; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_63_enq_bits = R_array_index_02_slr1_63_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_63_deq_ready = q_R_array_index_slr0_119_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_63_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_63_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_63_enq_valid = _T_1259; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_63_enq_bits = R_array_index_02_slr2_63_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_63_deq_ready = R_array_index_02_slr0_63_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_63_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_63_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_63_enq_valid = SLR2_io_R_array_index_63_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_63_enq_bits = SLR2_io_R_array_index_63_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_63_deq_ready = R_array_index_02_slr1_63_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_119_clock = clock;
  assign q_R_array_index_slr0_119_reset = reset;
  assign q_R_array_index_slr0_119_io_enq_valid = _T_1261; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_119_io_enq_bits = R_array_index_02_slr0_63_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_119_io_deq_ready = SLR0_Mem_io_R_array_index_119_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_64_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_64_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_64_enq_valid = _T_1266; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_64_enq_bits = R_array_index_02_slr1_64_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_64_deq_ready = q_R_array_index_slr0_120_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_64_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_64_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_64_enq_valid = _T_1265; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_64_enq_bits = R_array_index_02_slr2_64_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_64_deq_ready = R_array_index_02_slr0_64_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_64_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_64_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_64_enq_valid = SLR2_io_R_array_index_64_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_64_enq_bits = SLR2_io_R_array_index_64_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_64_deq_ready = R_array_index_02_slr1_64_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_120_clock = clock;
  assign q_R_array_index_slr0_120_reset = reset;
  assign q_R_array_index_slr0_120_io_enq_valid = _T_1267; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_120_io_enq_bits = R_array_index_02_slr0_64_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_120_io_deq_ready = SLR0_Mem_io_R_array_index_120_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_65_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_65_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_65_enq_valid = _T_1272; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_65_enq_bits = R_array_index_02_slr1_65_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_65_deq_ready = q_R_array_index_slr0_121_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_65_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_65_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_65_enq_valid = _T_1271; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_65_enq_bits = R_array_index_02_slr2_65_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_65_deq_ready = R_array_index_02_slr0_65_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_65_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_65_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_65_enq_valid = SLR2_io_R_array_index_65_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_65_enq_bits = SLR2_io_R_array_index_65_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_65_deq_ready = R_array_index_02_slr1_65_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_121_clock = clock;
  assign q_R_array_index_slr0_121_reset = reset;
  assign q_R_array_index_slr0_121_io_enq_valid = _T_1273; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_121_io_enq_bits = R_array_index_02_slr0_65_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_121_io_deq_ready = SLR0_Mem_io_R_array_index_121_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_66_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_66_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_66_enq_valid = _T_1278; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_66_enq_bits = R_array_index_02_slr1_66_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_66_deq_ready = q_R_array_index_slr0_122_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_66_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_66_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_66_enq_valid = _T_1277; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_66_enq_bits = R_array_index_02_slr2_66_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_66_deq_ready = R_array_index_02_slr0_66_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_66_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_66_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_66_enq_valid = SLR2_io_R_array_index_66_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_66_enq_bits = SLR2_io_R_array_index_66_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_66_deq_ready = R_array_index_02_slr1_66_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_122_clock = clock;
  assign q_R_array_index_slr0_122_reset = reset;
  assign q_R_array_index_slr0_122_io_enq_valid = _T_1279; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_122_io_enq_bits = R_array_index_02_slr0_66_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_122_io_deq_ready = SLR0_Mem_io_R_array_index_122_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_67_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_67_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_67_enq_valid = _T_1284; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_67_enq_bits = R_array_index_02_slr1_67_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_67_deq_ready = q_R_array_index_slr0_123_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_67_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_67_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_67_enq_valid = _T_1283; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_67_enq_bits = R_array_index_02_slr2_67_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_67_deq_ready = R_array_index_02_slr0_67_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_67_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_67_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_67_enq_valid = SLR2_io_R_array_index_67_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_67_enq_bits = SLR2_io_R_array_index_67_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_67_deq_ready = R_array_index_02_slr1_67_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_123_clock = clock;
  assign q_R_array_index_slr0_123_reset = reset;
  assign q_R_array_index_slr0_123_io_enq_valid = _T_1285; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_123_io_enq_bits = R_array_index_02_slr0_67_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_123_io_deq_ready = SLR0_Mem_io_R_array_index_123_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_68_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_68_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_68_enq_valid = _T_1290; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_68_enq_bits = R_array_index_02_slr1_68_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_68_deq_ready = q_R_array_index_slr0_124_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_68_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_68_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_68_enq_valid = _T_1289; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_68_enq_bits = R_array_index_02_slr2_68_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_68_deq_ready = R_array_index_02_slr0_68_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_68_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_68_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_68_enq_valid = SLR2_io_R_array_index_68_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_68_enq_bits = SLR2_io_R_array_index_68_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_68_deq_ready = R_array_index_02_slr1_68_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_124_clock = clock;
  assign q_R_array_index_slr0_124_reset = reset;
  assign q_R_array_index_slr0_124_io_enq_valid = _T_1291; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_124_io_enq_bits = R_array_index_02_slr0_68_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_124_io_deq_ready = SLR0_Mem_io_R_array_index_124_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_69_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_69_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_69_enq_valid = _T_1296; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_69_enq_bits = R_array_index_02_slr1_69_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_69_deq_ready = q_R_array_index_slr0_125_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_69_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_69_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_69_enq_valid = _T_1295; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_69_enq_bits = R_array_index_02_slr2_69_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_69_deq_ready = R_array_index_02_slr0_69_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_69_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_69_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_69_enq_valid = SLR2_io_R_array_index_69_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_69_enq_bits = SLR2_io_R_array_index_69_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_69_deq_ready = R_array_index_02_slr1_69_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_125_clock = clock;
  assign q_R_array_index_slr0_125_reset = reset;
  assign q_R_array_index_slr0_125_io_enq_valid = _T_1297; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_125_io_enq_bits = R_array_index_02_slr0_69_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_125_io_deq_ready = SLR0_Mem_io_R_array_index_125_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_70_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_70_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_70_enq_valid = _T_1302; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_70_enq_bits = R_array_index_02_slr1_70_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_70_deq_ready = q_R_array_index_slr0_126_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_70_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_70_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_70_enq_valid = _T_1301; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_70_enq_bits = R_array_index_02_slr2_70_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_70_deq_ready = R_array_index_02_slr0_70_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_70_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_70_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_70_enq_valid = SLR2_io_R_array_index_70_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_70_enq_bits = SLR2_io_R_array_index_70_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_70_deq_ready = R_array_index_02_slr1_70_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_126_clock = clock;
  assign q_R_array_index_slr0_126_reset = reset;
  assign q_R_array_index_slr0_126_io_enq_valid = _T_1303; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_126_io_enq_bits = R_array_index_02_slr0_70_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_126_io_deq_ready = SLR0_Mem_io_R_array_index_126_ready; // @[Top-slr.scala 394:116]
  assign R_array_index_02_slr0_71_clock = clock; // @[Top-slr.scala 367:43]
  assign R_array_index_02_slr0_71_reset = reset; // @[Top-slr.scala 370:43]
  assign R_array_index_02_slr0_71_enq_valid = _T_1308; // @[Top-slr.scala 386:47]
  assign R_array_index_02_slr0_71_enq_bits = R_array_index_02_slr1_71_deq_bits; // @[Top-slr.scala 388:47]
  assign R_array_index_02_slr0_71_deq_ready = q_R_array_index_slr0_127_io_count < _T_317; // @[Top-slr.scala 391:76]
  assign R_array_index_02_slr1_71_clock = clock; // @[Top-slr.scala 368:43]
  assign R_array_index_02_slr1_71_reset = reset; // @[Top-slr.scala 371:43]
  assign R_array_index_02_slr1_71_enq_valid = _T_1307; // @[Top-slr.scala 382:47]
  assign R_array_index_02_slr1_71_enq_bits = R_array_index_02_slr2_71_deq_bits; // @[Top-slr.scala 384:47]
  assign R_array_index_02_slr1_71_deq_ready = R_array_index_02_slr0_71_enq_ready; // @[Top-slr.scala 387:47]
  assign R_array_index_02_slr2_71_clock = clock; // @[Top-slr.scala 369:43]
  assign R_array_index_02_slr2_71_reset = reset; // @[Top-slr.scala 372:43]
  assign R_array_index_02_slr2_71_enq_valid = SLR2_io_R_array_index_71_valid; // @[Top-slr.scala 378:47]
  assign R_array_index_02_slr2_71_enq_bits = SLR2_io_R_array_index_71_bits; // @[Top-slr.scala 380:47]
  assign R_array_index_02_slr2_71_deq_ready = R_array_index_02_slr1_71_enq_ready; // @[Top-slr.scala 383:47]
  assign q_R_array_index_slr0_127_clock = clock;
  assign q_R_array_index_slr0_127_reset = reset;
  assign q_R_array_index_slr0_127_io_enq_valid = _T_1309; // @[Top-slr.scala 390:49]
  assign q_R_array_index_slr0_127_io_enq_bits = R_array_index_02_slr0_71_deq_bits; // @[Top-slr.scala 392:49]
  assign q_R_array_index_slr0_127_io_deq_ready = SLR0_Mem_io_R_array_index_127_ready; // @[Top-slr.scala 394:116]
`ifdef RANDOMIZE_GARBAGE_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_INVALID_ASSIGN
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_REG_INIT
`define RANDOMIZE
`endif
`ifdef RANDOMIZE_MEM_INIT
`define RANDOMIZE
`endif
`ifndef RANDOM
`define RANDOM $random
`endif
`ifdef RANDOMIZE_MEM_INIT
  integer initvar;
`endif
`ifndef SYNTHESIS
`ifdef FIRRTL_BEFORE_INITIAL
`FIRRTL_BEFORE_INITIAL
`endif
initial begin
  `ifdef RANDOMIZE
    `ifdef INIT_RANDOM
      `INIT_RANDOM
    `endif
    `ifndef VERILATOR
      `ifdef RANDOMIZE_DELAY
        #`RANDOMIZE_DELAY begin end
      `else
        #0.002 begin end
      `endif
    `endif
`ifdef RANDOMIZE_REG_INIT
  _RAND_0 = {1{`RANDOM}};
  kernel_count = _RAND_0[31:0];
  _RAND_1 = {1{`RANDOM}};
  start_r = _RAND_1[0:0];
  _RAND_2 = {1{`RANDOM}};
  start_state = _RAND_2[0:0];
  _RAND_3 = {1{`RANDOM}};
  _T_3 = _RAND_3[0:0];
  _RAND_4 = {1{`RANDOM}};
  master_finish_count = _RAND_4[7:0];
  _RAND_5 = {1{`RANDOM}};
  global_write_finish = _RAND_5[0:0];
  _RAND_6 = {1{`RANDOM}};
  node_num_0_r = _RAND_6[31:0];
  _RAND_7 = {1{`RANDOM}};
  current_level_0_r = _RAND_7[31:0];
  _RAND_8 = {1{`RANDOM}};
  push_or_pull_0_r = _RAND_8[0:0];
  _RAND_9 = {1{`RANDOM}};
  _T_40 = _RAND_9[0:0];
  _RAND_10 = {1{`RANDOM}};
  _T_41_CSR_R_offset = _RAND_10[31:0];
  _RAND_11 = {1{`RANDOM}};
  _T_41_CSR_C_offset = _RAND_11[31:0];
  _RAND_12 = {1{`RANDOM}};
  _T_41_CSC_R_offset = _RAND_12[31:0];
  _RAND_13 = {1{`RANDOM}};
  _T_41_CSC_C_offset = _RAND_13[31:0];
  _RAND_14 = {1{`RANDOM}};
  _T_41_level_offset = _RAND_14[31:0];
  _RAND_15 = {1{`RANDOM}};
  node_num_1_r = _RAND_15[31:0];
  _RAND_16 = {1{`RANDOM}};
  current_level_1_r = _RAND_16[31:0];
  _RAND_17 = {1{`RANDOM}};
  push_or_pull_1_r = _RAND_17[0:0];
  _RAND_18 = {1{`RANDOM}};
  frontier_flag_1_r = _RAND_18[0:0];
  _RAND_19 = {1{`RANDOM}};
  start_1_r = _RAND_19[0:0];
  _RAND_20 = {1{`RANDOM}};
  p2_end_1_r = _RAND_20[0:0];
  _RAND_21 = {1{`RANDOM}};
  _T_42_CSR_R_offset = _RAND_21[31:0];
  _RAND_22 = {1{`RANDOM}};
  _T_42_CSR_C_offset = _RAND_22[31:0];
  _RAND_23 = {1{`RANDOM}};
  _T_42_CSC_R_offset = _RAND_23[31:0];
  _RAND_24 = {1{`RANDOM}};
  _T_42_CSC_C_offset = _RAND_24[31:0];
  _RAND_25 = {1{`RANDOM}};
  _T_42_level_offset = _RAND_25[31:0];
  _RAND_26 = {1{`RANDOM}};
  _T_43 = _RAND_26[31:0];
  _RAND_27 = {1{`RANDOM}};
  _T_44 = _RAND_27[0:0];
  _RAND_28 = {1{`RANDOM}};
  node_num_2_r = _RAND_28[31:0];
  _RAND_29 = {1{`RANDOM}};
  current_level_2_r = _RAND_29[31:0];
  _RAND_30 = {1{`RANDOM}};
  push_or_pull_2_r = _RAND_30[0:0];
  _RAND_31 = {1{`RANDOM}};
  frontier_flag_2_r = _RAND_31[0:0];
  _RAND_32 = {1{`RANDOM}};
  start_2_r = _RAND_32[0:0];
  _RAND_33 = {1{`RANDOM}};
  p2_end_2_r = _RAND_33[0:0];
  _RAND_34 = {1{`RANDOM}};
  _T_45_CSR_R_offset = _RAND_34[31:0];
  _RAND_35 = {1{`RANDOM}};
  _T_45_CSR_C_offset = _RAND_35[31:0];
  _RAND_36 = {1{`RANDOM}};
  _T_45_CSC_R_offset = _RAND_36[31:0];
  _RAND_37 = {1{`RANDOM}};
  _T_45_CSC_C_offset = _RAND_37[31:0];
  _RAND_38 = {1{`RANDOM}};
  _T_45_level_offset = _RAND_38[31:0];
  _RAND_39 = {1{`RANDOM}};
  _T_46 = _RAND_39[31:0];
  _RAND_40 = {1{`RANDOM}};
  _T_47 = _RAND_40[0:0];
  _RAND_41 = {1{`RANDOM}};
  _T_48_push_to_pull_level = _RAND_41[31:0];
  _RAND_42 = {1{`RANDOM}};
  _T_48_pull_to_push_level = _RAND_42[31:0];
  _RAND_43 = {1{`RANDOM}};
  _T_49 = _RAND_43[0:0];
  _RAND_44 = {1{`RANDOM}};
  _T_50 = _RAND_44[0:0];
  _RAND_45 = {1{`RANDOM}};
  _T_51 = _RAND_45[31:0];
  _RAND_46 = {1{`RANDOM}};
  _T_52 = _RAND_46[0:0];
  _RAND_47 = {1{`RANDOM}};
  _T_53 = _RAND_47[31:0];
  _RAND_48 = {1{`RANDOM}};
  _T_54 = _RAND_48[0:0];
  _RAND_49 = {1{`RANDOM}};
  _T_55 = _RAND_49[31:0];
  _RAND_50 = {1{`RANDOM}};
  _T_56 = _RAND_50[0:0];
  _RAND_51 = {1{`RANDOM}};
  _T_57 = _RAND_51[31:0];
  _RAND_52 = {1{`RANDOM}};
  _T_58 = _RAND_52[0:0];
  _RAND_53 = {1{`RANDOM}};
  _T_59 = _RAND_53[31:0];
  _RAND_54 = {1{`RANDOM}};
  _T_60 = _RAND_54[0:0];
  _RAND_55 = {1{`RANDOM}};
  _T_61 = _RAND_55[31:0];
  _RAND_56 = {1{`RANDOM}};
  _T_62 = _RAND_56[0:0];
  _RAND_57 = {1{`RANDOM}};
  _T_63 = _RAND_57[31:0];
  _RAND_58 = {1{`RANDOM}};
  _T_64 = _RAND_58[0:0];
  _RAND_59 = {1{`RANDOM}};
  _T_65 = _RAND_59[31:0];
  _RAND_60 = {1{`RANDOM}};
  _T_66 = _RAND_60[0:0];
  _RAND_61 = {1{`RANDOM}};
  _T_67 = _RAND_61[31:0];
  _RAND_62 = {1{`RANDOM}};
  _T_68 = _RAND_62[0:0];
  _RAND_63 = {1{`RANDOM}};
  _T_69 = _RAND_63[31:0];
  _RAND_64 = {1{`RANDOM}};
  _T_70 = _RAND_64[0:0];
  _RAND_65 = {1{`RANDOM}};
  _T_71 = _RAND_65[31:0];
  _RAND_66 = {1{`RANDOM}};
  _T_72 = _RAND_66[0:0];
  _RAND_67 = {1{`RANDOM}};
  _T_73 = _RAND_67[31:0];
  _RAND_68 = {1{`RANDOM}};
  _T_74 = _RAND_68[0:0];
  _RAND_69 = {1{`RANDOM}};
  _T_75 = _RAND_69[31:0];
  _RAND_70 = {1{`RANDOM}};
  _T_76 = _RAND_70[0:0];
  _RAND_71 = {1{`RANDOM}};
  _T_77 = _RAND_71[31:0];
  _RAND_72 = {1{`RANDOM}};
  _T_78 = _RAND_72[0:0];
  _RAND_73 = {1{`RANDOM}};
  _T_79 = _RAND_73[31:0];
  _RAND_74 = {1{`RANDOM}};
  _T_80 = _RAND_74[0:0];
  _RAND_75 = {1{`RANDOM}};
  _T_81 = _RAND_75[31:0];
  _RAND_76 = {1{`RANDOM}};
  _T_82 = _RAND_76[0:0];
  _RAND_77 = {1{`RANDOM}};
  _T_83 = _RAND_77[31:0];
  _RAND_78 = {1{`RANDOM}};
  _T_84 = _RAND_78[0:0];
  _RAND_79 = {1{`RANDOM}};
  _T_85 = _RAND_79[31:0];
  _RAND_80 = {1{`RANDOM}};
  _T_86 = _RAND_80[0:0];
  _RAND_81 = {1{`RANDOM}};
  _T_87 = _RAND_81[31:0];
  _RAND_82 = {1{`RANDOM}};
  _T_88 = _RAND_82[0:0];
  _RAND_83 = {1{`RANDOM}};
  _T_89 = _RAND_83[31:0];
  _RAND_84 = {1{`RANDOM}};
  _T_90 = _RAND_84[0:0];
  _RAND_85 = {1{`RANDOM}};
  _T_91 = _RAND_85[31:0];
  _RAND_86 = {1{`RANDOM}};
  _T_92 = _RAND_86[0:0];
  _RAND_87 = {1{`RANDOM}};
  _T_93 = _RAND_87[31:0];
  _RAND_88 = {1{`RANDOM}};
  _T_94 = _RAND_88[0:0];
  _RAND_89 = {1{`RANDOM}};
  _T_95 = _RAND_89[31:0];
  _RAND_90 = {1{`RANDOM}};
  _T_96 = _RAND_90[0:0];
  _RAND_91 = {1{`RANDOM}};
  _T_97 = _RAND_91[31:0];
  _RAND_92 = {1{`RANDOM}};
  _T_98 = _RAND_92[0:0];
  _RAND_93 = {1{`RANDOM}};
  _T_99 = _RAND_93[31:0];
  _RAND_94 = {1{`RANDOM}};
  _T_100 = _RAND_94[0:0];
  _RAND_95 = {1{`RANDOM}};
  _T_101 = _RAND_95[31:0];
  _RAND_96 = {1{`RANDOM}};
  _T_102 = _RAND_96[0:0];
  _RAND_97 = {1{`RANDOM}};
  _T_103 = _RAND_97[31:0];
  _RAND_98 = {1{`RANDOM}};
  _T_104 = _RAND_98[0:0];
  _RAND_99 = {1{`RANDOM}};
  _T_105 = _RAND_99[31:0];
  _RAND_100 = {1{`RANDOM}};
  _T_106 = _RAND_100[0:0];
  _RAND_101 = {1{`RANDOM}};
  _T_107 = _RAND_101[31:0];
  _RAND_102 = {1{`RANDOM}};
  _T_108 = _RAND_102[0:0];
  _RAND_103 = {1{`RANDOM}};
  _T_109 = _RAND_103[31:0];
  _RAND_104 = {1{`RANDOM}};
  _T_110 = _RAND_104[0:0];
  _RAND_105 = {1{`RANDOM}};
  _T_111 = _RAND_105[31:0];
  _RAND_106 = {1{`RANDOM}};
  _T_112 = _RAND_106[0:0];
  _RAND_107 = {1{`RANDOM}};
  _T_113 = _RAND_107[31:0];
  _RAND_108 = {1{`RANDOM}};
  _T_114 = _RAND_108[0:0];
  _RAND_109 = {1{`RANDOM}};
  _T_115 = _RAND_109[31:0];
  _RAND_110 = {1{`RANDOM}};
  _T_116 = _RAND_110[31:0];
  _RAND_111 = {1{`RANDOM}};
  _T_117 = _RAND_111[31:0];
  _RAND_112 = {1{`RANDOM}};
  _T_118 = _RAND_112[0:0];
  _RAND_113 = {1{`RANDOM}};
  _T_119 = _RAND_113[0:0];
  _RAND_114 = {1{`RANDOM}};
  _T_120 = _RAND_114[0:0];
  _RAND_115 = {1{`RANDOM}};
  _T_121 = _RAND_115[31:0];
  _RAND_116 = {1{`RANDOM}};
  _T_122 = _RAND_116[31:0];
  _RAND_117 = {1{`RANDOM}};
  _T_123 = _RAND_117[31:0];
  _RAND_118 = {1{`RANDOM}};
  _T_124 = _RAND_118[0:0];
  _RAND_119 = {1{`RANDOM}};
  _T_125 = _RAND_119[0:0];
  _RAND_120 = {1{`RANDOM}};
  _T_126 = _RAND_120[0:0];
  _RAND_121 = {1{`RANDOM}};
  _T_127 = _RAND_121[31:0];
  _RAND_122 = {1{`RANDOM}};
  _T_128 = _RAND_122[31:0];
  _RAND_123 = {1{`RANDOM}};
  _T_129 = _RAND_123[31:0];
  _RAND_124 = {1{`RANDOM}};
  _T_130 = _RAND_124[0:0];
  _RAND_125 = {1{`RANDOM}};
  _T_131 = _RAND_125[0:0];
  _RAND_126 = {1{`RANDOM}};
  _T_132 = _RAND_126[0:0];
  _RAND_127 = {1{`RANDOM}};
  _T_133 = _RAND_127[31:0];
  _RAND_128 = {1{`RANDOM}};
  _T_134 = _RAND_128[31:0];
  _RAND_129 = {1{`RANDOM}};
  _T_135 = _RAND_129[31:0];
  _RAND_130 = {1{`RANDOM}};
  _T_136 = _RAND_130[0:0];
  _RAND_131 = {1{`RANDOM}};
  _T_137 = _RAND_131[0:0];
  _RAND_132 = {1{`RANDOM}};
  _T_138 = _RAND_132[0:0];
  _RAND_133 = {1{`RANDOM}};
  _T_139 = _RAND_133[31:0];
  _RAND_134 = {1{`RANDOM}};
  _T_140 = _RAND_134[31:0];
  _RAND_135 = {1{`RANDOM}};
  _T_141 = _RAND_135[31:0];
  _RAND_136 = {1{`RANDOM}};
  _T_142 = _RAND_136[0:0];
  _RAND_137 = {1{`RANDOM}};
  _T_143 = _RAND_137[0:0];
  _RAND_138 = {1{`RANDOM}};
  _T_144 = _RAND_138[0:0];
  _RAND_139 = {1{`RANDOM}};
  _T_145 = _RAND_139[31:0];
  _RAND_140 = {1{`RANDOM}};
  _T_146 = _RAND_140[31:0];
  _RAND_141 = {1{`RANDOM}};
  _T_147 = _RAND_141[31:0];
  _RAND_142 = {1{`RANDOM}};
  _T_148 = _RAND_142[0:0];
  _RAND_143 = {1{`RANDOM}};
  _T_149 = _RAND_143[0:0];
  _RAND_144 = {1{`RANDOM}};
  _T_150 = _RAND_144[0:0];
  _RAND_145 = {1{`RANDOM}};
  _T_151 = _RAND_145[31:0];
  _RAND_146 = {1{`RANDOM}};
  _T_152 = _RAND_146[31:0];
  _RAND_147 = {1{`RANDOM}};
  _T_153 = _RAND_147[31:0];
  _RAND_148 = {1{`RANDOM}};
  _T_154 = _RAND_148[0:0];
  _RAND_149 = {1{`RANDOM}};
  _T_155 = _RAND_149[0:0];
  _RAND_150 = {1{`RANDOM}};
  _T_156 = _RAND_150[0:0];
  _RAND_151 = {1{`RANDOM}};
  _T_157 = _RAND_151[31:0];
  _RAND_152 = {1{`RANDOM}};
  _T_158 = _RAND_152[31:0];
  _RAND_153 = {1{`RANDOM}};
  _T_159 = _RAND_153[31:0];
  _RAND_154 = {1{`RANDOM}};
  _T_160 = _RAND_154[0:0];
  _RAND_155 = {1{`RANDOM}};
  _T_161 = _RAND_155[0:0];
  _RAND_156 = {1{`RANDOM}};
  _T_162 = _RAND_156[0:0];
  _RAND_157 = {1{`RANDOM}};
  _T_163 = _RAND_157[31:0];
  _RAND_158 = {1{`RANDOM}};
  _T_164 = _RAND_158[31:0];
  _RAND_159 = {1{`RANDOM}};
  _T_165 = _RAND_159[31:0];
  _RAND_160 = {1{`RANDOM}};
  _T_166 = _RAND_160[0:0];
  _RAND_161 = {1{`RANDOM}};
  _T_167 = _RAND_161[0:0];
  _RAND_162 = {1{`RANDOM}};
  _T_168 = _RAND_162[0:0];
  _RAND_163 = {1{`RANDOM}};
  _T_169 = _RAND_163[31:0];
  _RAND_164 = {1{`RANDOM}};
  _T_170 = _RAND_164[31:0];
  _RAND_165 = {1{`RANDOM}};
  _T_171 = _RAND_165[31:0];
  _RAND_166 = {1{`RANDOM}};
  _T_172 = _RAND_166[0:0];
  _RAND_167 = {1{`RANDOM}};
  _T_173 = _RAND_167[0:0];
  _RAND_168 = {1{`RANDOM}};
  _T_174 = _RAND_168[0:0];
  _RAND_169 = {1{`RANDOM}};
  _T_175 = _RAND_169[31:0];
  _RAND_170 = {1{`RANDOM}};
  _T_176 = _RAND_170[31:0];
  _RAND_171 = {1{`RANDOM}};
  _T_177 = _RAND_171[31:0];
  _RAND_172 = {1{`RANDOM}};
  _T_178 = _RAND_172[0:0];
  _RAND_173 = {1{`RANDOM}};
  _T_179 = _RAND_173[0:0];
  _RAND_174 = {1{`RANDOM}};
  _T_180 = _RAND_174[0:0];
  _RAND_175 = {1{`RANDOM}};
  _T_181 = _RAND_175[31:0];
  _RAND_176 = {1{`RANDOM}};
  _T_182 = _RAND_176[31:0];
  _RAND_177 = {1{`RANDOM}};
  _T_183 = _RAND_177[31:0];
  _RAND_178 = {1{`RANDOM}};
  _T_184 = _RAND_178[0:0];
  _RAND_179 = {1{`RANDOM}};
  _T_185 = _RAND_179[0:0];
  _RAND_180 = {1{`RANDOM}};
  _T_186 = _RAND_180[0:0];
  _RAND_181 = {1{`RANDOM}};
  _T_187 = _RAND_181[31:0];
  _RAND_182 = {1{`RANDOM}};
  _T_188 = _RAND_182[31:0];
  _RAND_183 = {1{`RANDOM}};
  _T_189 = _RAND_183[31:0];
  _RAND_184 = {1{`RANDOM}};
  _T_190 = _RAND_184[0:0];
  _RAND_185 = {1{`RANDOM}};
  _T_191 = _RAND_185[0:0];
  _RAND_186 = {1{`RANDOM}};
  _T_192 = _RAND_186[0:0];
  _RAND_187 = {1{`RANDOM}};
  _T_193 = _RAND_187[31:0];
  _RAND_188 = {1{`RANDOM}};
  _T_194 = _RAND_188[31:0];
  _RAND_189 = {1{`RANDOM}};
  _T_195 = _RAND_189[31:0];
  _RAND_190 = {1{`RANDOM}};
  _T_196 = _RAND_190[0:0];
  _RAND_191 = {1{`RANDOM}};
  _T_197 = _RAND_191[0:0];
  _RAND_192 = {1{`RANDOM}};
  _T_198 = _RAND_192[0:0];
  _RAND_193 = {1{`RANDOM}};
  _T_199 = _RAND_193[31:0];
  _RAND_194 = {1{`RANDOM}};
  _T_200 = _RAND_194[31:0];
  _RAND_195 = {1{`RANDOM}};
  _T_201 = _RAND_195[31:0];
  _RAND_196 = {1{`RANDOM}};
  _T_202 = _RAND_196[0:0];
  _RAND_197 = {1{`RANDOM}};
  _T_203 = _RAND_197[0:0];
  _RAND_198 = {1{`RANDOM}};
  _T_204 = _RAND_198[0:0];
  _RAND_199 = {1{`RANDOM}};
  _T_205 = _RAND_199[31:0];
  _RAND_200 = {1{`RANDOM}};
  _T_206 = _RAND_200[31:0];
  _RAND_201 = {1{`RANDOM}};
  _T_207 = _RAND_201[31:0];
  _RAND_202 = {1{`RANDOM}};
  _T_208 = _RAND_202[0:0];
  _RAND_203 = {1{`RANDOM}};
  _T_209 = _RAND_203[0:0];
  _RAND_204 = {1{`RANDOM}};
  _T_210 = _RAND_204[0:0];
  _RAND_205 = {1{`RANDOM}};
  _T_211 = _RAND_205[31:0];
  _RAND_206 = {1{`RANDOM}};
  _T_212 = _RAND_206[31:0];
  _RAND_207 = {1{`RANDOM}};
  _T_213 = _RAND_207[31:0];
  _RAND_208 = {1{`RANDOM}};
  _T_214 = _RAND_208[0:0];
  _RAND_209 = {1{`RANDOM}};
  _T_215 = _RAND_209[0:0];
  _RAND_210 = {1{`RANDOM}};
  _T_216 = _RAND_210[0:0];
  _RAND_211 = {1{`RANDOM}};
  _T_217 = _RAND_211[31:0];
  _RAND_212 = {1{`RANDOM}};
  _T_218 = _RAND_212[31:0];
  _RAND_213 = {1{`RANDOM}};
  _T_219 = _RAND_213[31:0];
  _RAND_214 = {1{`RANDOM}};
  _T_220 = _RAND_214[0:0];
  _RAND_215 = {1{`RANDOM}};
  _T_221 = _RAND_215[0:0];
  _RAND_216 = {1{`RANDOM}};
  _T_222 = _RAND_216[0:0];
  _RAND_217 = {1{`RANDOM}};
  _T_223 = _RAND_217[31:0];
  _RAND_218 = {1{`RANDOM}};
  _T_224 = _RAND_218[31:0];
  _RAND_219 = {1{`RANDOM}};
  _T_225 = _RAND_219[31:0];
  _RAND_220 = {1{`RANDOM}};
  _T_226 = _RAND_220[0:0];
  _RAND_221 = {1{`RANDOM}};
  _T_227 = _RAND_221[0:0];
  _RAND_222 = {1{`RANDOM}};
  _T_228 = _RAND_222[0:0];
  _RAND_223 = {1{`RANDOM}};
  _T_229 = _RAND_223[31:0];
  _RAND_224 = {1{`RANDOM}};
  _T_230 = _RAND_224[31:0];
  _RAND_225 = {1{`RANDOM}};
  _T_231 = _RAND_225[31:0];
  _RAND_226 = {1{`RANDOM}};
  _T_232 = _RAND_226[0:0];
  _RAND_227 = {1{`RANDOM}};
  _T_233 = _RAND_227[0:0];
  _RAND_228 = {1{`RANDOM}};
  _T_234 = _RAND_228[0:0];
  _RAND_229 = {1{`RANDOM}};
  _T_235 = _RAND_229[31:0];
  _RAND_230 = {1{`RANDOM}};
  _T_236 = _RAND_230[31:0];
  _RAND_231 = {1{`RANDOM}};
  _T_237 = _RAND_231[31:0];
  _RAND_232 = {1{`RANDOM}};
  _T_238 = _RAND_232[0:0];
  _RAND_233 = {1{`RANDOM}};
  _T_239 = _RAND_233[0:0];
  _RAND_234 = {1{`RANDOM}};
  _T_240 = _RAND_234[0:0];
  _RAND_235 = {1{`RANDOM}};
  _T_241 = _RAND_235[31:0];
  _RAND_236 = {1{`RANDOM}};
  _T_242 = _RAND_236[31:0];
  _RAND_237 = {1{`RANDOM}};
  _T_243 = _RAND_237[31:0];
  _RAND_238 = {1{`RANDOM}};
  _T_244 = _RAND_238[0:0];
  _RAND_239 = {1{`RANDOM}};
  _T_245 = _RAND_239[0:0];
  _RAND_240 = {1{`RANDOM}};
  _T_246 = _RAND_240[0:0];
  _RAND_241 = {1{`RANDOM}};
  _T_247 = _RAND_241[31:0];
  _RAND_242 = {1{`RANDOM}};
  _T_248 = _RAND_242[31:0];
  _RAND_243 = {1{`RANDOM}};
  _T_249 = _RAND_243[31:0];
  _RAND_244 = {1{`RANDOM}};
  _T_250 = _RAND_244[0:0];
  _RAND_245 = {1{`RANDOM}};
  _T_251 = _RAND_245[0:0];
  _RAND_246 = {1{`RANDOM}};
  _T_252 = _RAND_246[0:0];
  _RAND_247 = {1{`RANDOM}};
  _T_253 = _RAND_247[31:0];
  _RAND_248 = {1{`RANDOM}};
  _T_254 = _RAND_248[31:0];
  _RAND_249 = {1{`RANDOM}};
  _T_255 = _RAND_249[31:0];
  _RAND_250 = {1{`RANDOM}};
  _T_256 = _RAND_250[0:0];
  _RAND_251 = {1{`RANDOM}};
  _T_257 = _RAND_251[0:0];
  _RAND_252 = {1{`RANDOM}};
  _T_258 = _RAND_252[0:0];
  _RAND_253 = {1{`RANDOM}};
  _T_259 = _RAND_253[31:0];
  _RAND_254 = {1{`RANDOM}};
  _T_260 = _RAND_254[31:0];
  _RAND_255 = {1{`RANDOM}};
  _T_261 = _RAND_255[31:0];
  _RAND_256 = {1{`RANDOM}};
  _T_262 = _RAND_256[0:0];
  _RAND_257 = {1{`RANDOM}};
  _T_263 = _RAND_257[0:0];
  _RAND_258 = {1{`RANDOM}};
  _T_264 = _RAND_258[0:0];
  _RAND_259 = {1{`RANDOM}};
  _T_265 = _RAND_259[31:0];
  _RAND_260 = {1{`RANDOM}};
  _T_266 = _RAND_260[31:0];
  _RAND_261 = {1{`RANDOM}};
  _T_267 = _RAND_261[31:0];
  _RAND_262 = {1{`RANDOM}};
  _T_268 = _RAND_262[0:0];
  _RAND_263 = {1{`RANDOM}};
  _T_269 = _RAND_263[0:0];
  _RAND_264 = {1{`RANDOM}};
  _T_270 = _RAND_264[0:0];
  _RAND_265 = {1{`RANDOM}};
  _T_271 = _RAND_265[31:0];
  _RAND_266 = {1{`RANDOM}};
  _T_272 = _RAND_266[31:0];
  _RAND_267 = {1{`RANDOM}};
  _T_273 = _RAND_267[31:0];
  _RAND_268 = {1{`RANDOM}};
  _T_274 = _RAND_268[0:0];
  _RAND_269 = {1{`RANDOM}};
  _T_275 = _RAND_269[0:0];
  _RAND_270 = {1{`RANDOM}};
  _T_276 = _RAND_270[0:0];
  _RAND_271 = {1{`RANDOM}};
  _T_277 = _RAND_271[31:0];
  _RAND_272 = {1{`RANDOM}};
  _T_278 = _RAND_272[31:0];
  _RAND_273 = {1{`RANDOM}};
  _T_279 = _RAND_273[31:0];
  _RAND_274 = {1{`RANDOM}};
  _T_280 = _RAND_274[0:0];
  _RAND_275 = {1{`RANDOM}};
  _T_281 = _RAND_275[0:0];
  _RAND_276 = {1{`RANDOM}};
  _T_282 = _RAND_276[0:0];
  _RAND_277 = {1{`RANDOM}};
  _T_283 = _RAND_277[31:0];
  _RAND_278 = {1{`RANDOM}};
  _T_284 = _RAND_278[31:0];
  _RAND_279 = {1{`RANDOM}};
  _T_285 = _RAND_279[31:0];
  _RAND_280 = {1{`RANDOM}};
  _T_286 = _RAND_280[0:0];
  _RAND_281 = {1{`RANDOM}};
  _T_287 = _RAND_281[0:0];
  _RAND_282 = {1{`RANDOM}};
  _T_288 = _RAND_282[0:0];
  _RAND_283 = {1{`RANDOM}};
  _T_289 = _RAND_283[31:0];
  _RAND_284 = {1{`RANDOM}};
  _T_290 = _RAND_284[31:0];
  _RAND_285 = {1{`RANDOM}};
  _T_291 = _RAND_285[31:0];
  _RAND_286 = {1{`RANDOM}};
  _T_292 = _RAND_286[0:0];
  _RAND_287 = {1{`RANDOM}};
  _T_293 = _RAND_287[0:0];
  _RAND_288 = {1{`RANDOM}};
  _T_294 = _RAND_288[0:0];
  _RAND_289 = {1{`RANDOM}};
  _T_295 = _RAND_289[31:0];
  _RAND_290 = {1{`RANDOM}};
  _T_296 = _RAND_290[31:0];
  _RAND_291 = {1{`RANDOM}};
  _T_297 = _RAND_291[31:0];
  _RAND_292 = {1{`RANDOM}};
  _T_298 = _RAND_292[0:0];
  _RAND_293 = {1{`RANDOM}};
  _T_299 = _RAND_293[0:0];
  _RAND_294 = {1{`RANDOM}};
  _T_300 = _RAND_294[0:0];
  _RAND_295 = {1{`RANDOM}};
  _T_301 = _RAND_295[31:0];
  _RAND_296 = {1{`RANDOM}};
  _T_302 = _RAND_296[31:0];
  _RAND_297 = {1{`RANDOM}};
  _T_303 = _RAND_297[31:0];
  _RAND_298 = {1{`RANDOM}};
  _T_304 = _RAND_298[0:0];
  _RAND_299 = {1{`RANDOM}};
  _T_305 = _RAND_299[0:0];
  _RAND_300 = {1{`RANDOM}};
  p1_end_q_01_slr0_0 = _RAND_300[0:0];
  _RAND_301 = {1{`RANDOM}};
  p1_end_q_01_slr0_1 = _RAND_301[0:0];
  _RAND_302 = {1{`RANDOM}};
  p1_end_q_01_slr0_2 = _RAND_302[0:0];
  _RAND_303 = {1{`RANDOM}};
  p1_end_q_01_slr0_3 = _RAND_303[0:0];
  _RAND_304 = {1{`RANDOM}};
  p1_end_q_01_slr0_4 = _RAND_304[0:0];
  _RAND_305 = {1{`RANDOM}};
  p1_end_q_01_slr0_5 = _RAND_305[0:0];
  _RAND_306 = {1{`RANDOM}};
  p1_end_q_01_slr0_6 = _RAND_306[0:0];
  _RAND_307 = {1{`RANDOM}};
  p1_end_q_01_slr0_7 = _RAND_307[0:0];
  _RAND_308 = {1{`RANDOM}};
  p1_end_q_01_slr0_8 = _RAND_308[0:0];
  _RAND_309 = {1{`RANDOM}};
  p1_end_q_01_slr0_9 = _RAND_309[0:0];
  _RAND_310 = {1{`RANDOM}};
  p1_end_q_01_slr0_10 = _RAND_310[0:0];
  _RAND_311 = {1{`RANDOM}};
  p1_end_q_01_slr0_11 = _RAND_311[0:0];
  _RAND_312 = {1{`RANDOM}};
  p1_end_q_01_slr0_12 = _RAND_312[0:0];
  _RAND_313 = {1{`RANDOM}};
  p1_end_q_01_slr0_13 = _RAND_313[0:0];
  _RAND_314 = {1{`RANDOM}};
  p1_end_q_01_slr1_0 = _RAND_314[0:0];
  _RAND_315 = {1{`RANDOM}};
  p1_end_q_01_slr1_1 = _RAND_315[0:0];
  _RAND_316 = {1{`RANDOM}};
  p1_end_q_01_slr1_2 = _RAND_316[0:0];
  _RAND_317 = {1{`RANDOM}};
  p1_end_q_01_slr1_3 = _RAND_317[0:0];
  _RAND_318 = {1{`RANDOM}};
  p1_end_q_01_slr1_4 = _RAND_318[0:0];
  _RAND_319 = {1{`RANDOM}};
  p1_end_q_01_slr1_5 = _RAND_319[0:0];
  _RAND_320 = {1{`RANDOM}};
  p1_end_q_01_slr1_6 = _RAND_320[0:0];
  _RAND_321 = {1{`RANDOM}};
  p1_end_q_01_slr1_7 = _RAND_321[0:0];
  _RAND_322 = {1{`RANDOM}};
  p1_end_q_01_slr1_8 = _RAND_322[0:0];
  _RAND_323 = {1{`RANDOM}};
  p1_end_q_01_slr1_9 = _RAND_323[0:0];
  _RAND_324 = {1{`RANDOM}};
  p1_end_q_01_slr1_10 = _RAND_324[0:0];
  _RAND_325 = {1{`RANDOM}};
  p1_end_q_01_slr1_11 = _RAND_325[0:0];
  _RAND_326 = {1{`RANDOM}};
  p1_end_q_01_slr1_12 = _RAND_326[0:0];
  _RAND_327 = {1{`RANDOM}};
  p1_end_q_01_slr1_13 = _RAND_327[0:0];
  _RAND_328 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_0 = _RAND_328[63:0];
  _RAND_329 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_1 = _RAND_329[63:0];
  _RAND_330 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_2 = _RAND_330[63:0];
  _RAND_331 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_3 = _RAND_331[63:0];
  _RAND_332 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_4 = _RAND_332[63:0];
  _RAND_333 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_5 = _RAND_333[63:0];
  _RAND_334 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_6 = _RAND_334[63:0];
  _RAND_335 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_7 = _RAND_335[63:0];
  _RAND_336 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_8 = _RAND_336[63:0];
  _RAND_337 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_9 = _RAND_337[63:0];
  _RAND_338 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_10 = _RAND_338[63:0];
  _RAND_339 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_11 = _RAND_339[63:0];
  _RAND_340 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_12 = _RAND_340[63:0];
  _RAND_341 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_13 = _RAND_341[63:0];
  _RAND_342 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_14 = _RAND_342[63:0];
  _RAND_343 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_15 = _RAND_343[63:0];
  _RAND_344 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_16 = _RAND_344[63:0];
  _RAND_345 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_17 = _RAND_345[63:0];
  _RAND_346 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_18 = _RAND_346[63:0];
  _RAND_347 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_19 = _RAND_347[63:0];
  _RAND_348 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_20 = _RAND_348[63:0];
  _RAND_349 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_21 = _RAND_349[63:0];
  _RAND_350 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_22 = _RAND_350[63:0];
  _RAND_351 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_23 = _RAND_351[63:0];
  _RAND_352 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_24 = _RAND_352[63:0];
  _RAND_353 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_25 = _RAND_353[63:0];
  _RAND_354 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_26 = _RAND_354[63:0];
  _RAND_355 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_27 = _RAND_355[63:0];
  _RAND_356 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_28 = _RAND_356[63:0];
  _RAND_357 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_29 = _RAND_357[63:0];
  _RAND_358 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_30 = _RAND_358[63:0];
  _RAND_359 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_31 = _RAND_359[63:0];
  _RAND_360 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_32 = _RAND_360[63:0];
  _RAND_361 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_33 = _RAND_361[63:0];
  _RAND_362 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_34 = _RAND_362[63:0];
  _RAND_363 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_35 = _RAND_363[63:0];
  _RAND_364 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_36 = _RAND_364[63:0];
  _RAND_365 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_37 = _RAND_365[63:0];
  _RAND_366 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_38 = _RAND_366[63:0];
  _RAND_367 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_39 = _RAND_367[63:0];
  _RAND_368 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_40 = _RAND_368[63:0];
  _RAND_369 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_41 = _RAND_369[63:0];
  _RAND_370 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_42 = _RAND_370[63:0];
  _RAND_371 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_43 = _RAND_371[63:0];
  _RAND_372 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_44 = _RAND_372[63:0];
  _RAND_373 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_45 = _RAND_373[63:0];
  _RAND_374 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_46 = _RAND_374[63:0];
  _RAND_375 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_47 = _RAND_375[63:0];
  _RAND_376 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_48 = _RAND_376[63:0];
  _RAND_377 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_49 = _RAND_377[63:0];
  _RAND_378 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_50 = _RAND_378[63:0];
  _RAND_379 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_51 = _RAND_379[63:0];
  _RAND_380 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_52 = _RAND_380[63:0];
  _RAND_381 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_53 = _RAND_381[63:0];
  _RAND_382 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_54 = _RAND_382[63:0];
  _RAND_383 = {2{`RANDOM}};
  uram_out_a_01_slr0_1_55 = _RAND_383[63:0];
  _RAND_384 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_0 = _RAND_384[63:0];
  _RAND_385 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_1 = _RAND_385[63:0];
  _RAND_386 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_2 = _RAND_386[63:0];
  _RAND_387 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_3 = _RAND_387[63:0];
  _RAND_388 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_4 = _RAND_388[63:0];
  _RAND_389 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_5 = _RAND_389[63:0];
  _RAND_390 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_6 = _RAND_390[63:0];
  _RAND_391 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_7 = _RAND_391[63:0];
  _RAND_392 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_8 = _RAND_392[63:0];
  _RAND_393 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_9 = _RAND_393[63:0];
  _RAND_394 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_10 = _RAND_394[63:0];
  _RAND_395 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_11 = _RAND_395[63:0];
  _RAND_396 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_12 = _RAND_396[63:0];
  _RAND_397 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_13 = _RAND_397[63:0];
  _RAND_398 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_14 = _RAND_398[63:0];
  _RAND_399 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_15 = _RAND_399[63:0];
  _RAND_400 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_16 = _RAND_400[63:0];
  _RAND_401 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_17 = _RAND_401[63:0];
  _RAND_402 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_18 = _RAND_402[63:0];
  _RAND_403 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_19 = _RAND_403[63:0];
  _RAND_404 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_20 = _RAND_404[63:0];
  _RAND_405 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_21 = _RAND_405[63:0];
  _RAND_406 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_22 = _RAND_406[63:0];
  _RAND_407 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_23 = _RAND_407[63:0];
  _RAND_408 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_24 = _RAND_408[63:0];
  _RAND_409 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_25 = _RAND_409[63:0];
  _RAND_410 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_26 = _RAND_410[63:0];
  _RAND_411 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_27 = _RAND_411[63:0];
  _RAND_412 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_28 = _RAND_412[63:0];
  _RAND_413 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_29 = _RAND_413[63:0];
  _RAND_414 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_30 = _RAND_414[63:0];
  _RAND_415 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_31 = _RAND_415[63:0];
  _RAND_416 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_32 = _RAND_416[63:0];
  _RAND_417 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_33 = _RAND_417[63:0];
  _RAND_418 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_34 = _RAND_418[63:0];
  _RAND_419 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_35 = _RAND_419[63:0];
  _RAND_420 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_36 = _RAND_420[63:0];
  _RAND_421 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_37 = _RAND_421[63:0];
  _RAND_422 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_38 = _RAND_422[63:0];
  _RAND_423 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_39 = _RAND_423[63:0];
  _RAND_424 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_40 = _RAND_424[63:0];
  _RAND_425 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_41 = _RAND_425[63:0];
  _RAND_426 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_42 = _RAND_426[63:0];
  _RAND_427 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_43 = _RAND_427[63:0];
  _RAND_428 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_44 = _RAND_428[63:0];
  _RAND_429 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_45 = _RAND_429[63:0];
  _RAND_430 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_46 = _RAND_430[63:0];
  _RAND_431 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_47 = _RAND_431[63:0];
  _RAND_432 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_48 = _RAND_432[63:0];
  _RAND_433 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_49 = _RAND_433[63:0];
  _RAND_434 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_50 = _RAND_434[63:0];
  _RAND_435 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_51 = _RAND_435[63:0];
  _RAND_436 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_52 = _RAND_436[63:0];
  _RAND_437 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_53 = _RAND_437[63:0];
  _RAND_438 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_54 = _RAND_438[63:0];
  _RAND_439 = {2{`RANDOM}};
  uram_out_a_01_slr0_2_55 = _RAND_439[63:0];
  _RAND_440 = {2{`RANDOM}};
  uram_out_a_01_slr1_0 = _RAND_440[63:0];
  _RAND_441 = {2{`RANDOM}};
  uram_out_a_01_slr1_1 = _RAND_441[63:0];
  _RAND_442 = {2{`RANDOM}};
  uram_out_a_01_slr1_2 = _RAND_442[63:0];
  _RAND_443 = {2{`RANDOM}};
  uram_out_a_01_slr1_3 = _RAND_443[63:0];
  _RAND_444 = {2{`RANDOM}};
  uram_out_a_01_slr1_4 = _RAND_444[63:0];
  _RAND_445 = {2{`RANDOM}};
  uram_out_a_01_slr1_5 = _RAND_445[63:0];
  _RAND_446 = {2{`RANDOM}};
  uram_out_a_01_slr1_6 = _RAND_446[63:0];
  _RAND_447 = {2{`RANDOM}};
  uram_out_a_01_slr1_7 = _RAND_447[63:0];
  _RAND_448 = {2{`RANDOM}};
  uram_out_a_01_slr1_8 = _RAND_448[63:0];
  _RAND_449 = {2{`RANDOM}};
  uram_out_a_01_slr1_9 = _RAND_449[63:0];
  _RAND_450 = {2{`RANDOM}};
  uram_out_a_01_slr1_10 = _RAND_450[63:0];
  _RAND_451 = {2{`RANDOM}};
  uram_out_a_01_slr1_11 = _RAND_451[63:0];
  _RAND_452 = {2{`RANDOM}};
  uram_out_a_01_slr1_12 = _RAND_452[63:0];
  _RAND_453 = {2{`RANDOM}};
  uram_out_a_01_slr1_13 = _RAND_453[63:0];
  _RAND_454 = {2{`RANDOM}};
  uram_out_a_01_slr1_14 = _RAND_454[63:0];
  _RAND_455 = {2{`RANDOM}};
  uram_out_a_01_slr1_15 = _RAND_455[63:0];
  _RAND_456 = {2{`RANDOM}};
  uram_out_a_01_slr1_16 = _RAND_456[63:0];
  _RAND_457 = {2{`RANDOM}};
  uram_out_a_01_slr1_17 = _RAND_457[63:0];
  _RAND_458 = {2{`RANDOM}};
  uram_out_a_01_slr1_18 = _RAND_458[63:0];
  _RAND_459 = {2{`RANDOM}};
  uram_out_a_01_slr1_19 = _RAND_459[63:0];
  _RAND_460 = {2{`RANDOM}};
  uram_out_a_01_slr1_20 = _RAND_460[63:0];
  _RAND_461 = {2{`RANDOM}};
  uram_out_a_01_slr1_21 = _RAND_461[63:0];
  _RAND_462 = {2{`RANDOM}};
  uram_out_a_01_slr1_22 = _RAND_462[63:0];
  _RAND_463 = {2{`RANDOM}};
  uram_out_a_01_slr1_23 = _RAND_463[63:0];
  _RAND_464 = {2{`RANDOM}};
  uram_out_a_01_slr1_24 = _RAND_464[63:0];
  _RAND_465 = {2{`RANDOM}};
  uram_out_a_01_slr1_25 = _RAND_465[63:0];
  _RAND_466 = {2{`RANDOM}};
  uram_out_a_01_slr1_26 = _RAND_466[63:0];
  _RAND_467 = {2{`RANDOM}};
  uram_out_a_01_slr1_27 = _RAND_467[63:0];
  _RAND_468 = {2{`RANDOM}};
  uram_out_a_01_slr1_28 = _RAND_468[63:0];
  _RAND_469 = {2{`RANDOM}};
  uram_out_a_01_slr1_29 = _RAND_469[63:0];
  _RAND_470 = {2{`RANDOM}};
  uram_out_a_01_slr1_30 = _RAND_470[63:0];
  _RAND_471 = {2{`RANDOM}};
  uram_out_a_01_slr1_31 = _RAND_471[63:0];
  _RAND_472 = {2{`RANDOM}};
  uram_out_a_01_slr1_32 = _RAND_472[63:0];
  _RAND_473 = {2{`RANDOM}};
  uram_out_a_01_slr1_33 = _RAND_473[63:0];
  _RAND_474 = {2{`RANDOM}};
  uram_out_a_01_slr1_34 = _RAND_474[63:0];
  _RAND_475 = {2{`RANDOM}};
  uram_out_a_01_slr1_35 = _RAND_475[63:0];
  _RAND_476 = {2{`RANDOM}};
  uram_out_a_01_slr1_36 = _RAND_476[63:0];
  _RAND_477 = {2{`RANDOM}};
  uram_out_a_01_slr1_37 = _RAND_477[63:0];
  _RAND_478 = {2{`RANDOM}};
  uram_out_a_01_slr1_38 = _RAND_478[63:0];
  _RAND_479 = {2{`RANDOM}};
  uram_out_a_01_slr1_39 = _RAND_479[63:0];
  _RAND_480 = {2{`RANDOM}};
  uram_out_a_01_slr1_40 = _RAND_480[63:0];
  _RAND_481 = {2{`RANDOM}};
  uram_out_a_01_slr1_41 = _RAND_481[63:0];
  _RAND_482 = {2{`RANDOM}};
  uram_out_a_01_slr1_42 = _RAND_482[63:0];
  _RAND_483 = {2{`RANDOM}};
  uram_out_a_01_slr1_43 = _RAND_483[63:0];
  _RAND_484 = {2{`RANDOM}};
  uram_out_a_01_slr1_44 = _RAND_484[63:0];
  _RAND_485 = {2{`RANDOM}};
  uram_out_a_01_slr1_45 = _RAND_485[63:0];
  _RAND_486 = {2{`RANDOM}};
  uram_out_a_01_slr1_46 = _RAND_486[63:0];
  _RAND_487 = {2{`RANDOM}};
  uram_out_a_01_slr1_47 = _RAND_487[63:0];
  _RAND_488 = {2{`RANDOM}};
  uram_out_a_01_slr1_48 = _RAND_488[63:0];
  _RAND_489 = {2{`RANDOM}};
  uram_out_a_01_slr1_49 = _RAND_489[63:0];
  _RAND_490 = {2{`RANDOM}};
  uram_out_a_01_slr1_50 = _RAND_490[63:0];
  _RAND_491 = {2{`RANDOM}};
  uram_out_a_01_slr1_51 = _RAND_491[63:0];
  _RAND_492 = {2{`RANDOM}};
  uram_out_a_01_slr1_52 = _RAND_492[63:0];
  _RAND_493 = {2{`RANDOM}};
  uram_out_a_01_slr1_53 = _RAND_493[63:0];
  _RAND_494 = {2{`RANDOM}};
  uram_out_a_01_slr1_54 = _RAND_494[63:0];
  _RAND_495 = {2{`RANDOM}};
  uram_out_a_01_slr1_55 = _RAND_495[63:0];
  _RAND_496 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_0 = _RAND_496[63:0];
  _RAND_497 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_1 = _RAND_497[63:0];
  _RAND_498 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_2 = _RAND_498[63:0];
  _RAND_499 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_3 = _RAND_499[63:0];
  _RAND_500 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_4 = _RAND_500[63:0];
  _RAND_501 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_5 = _RAND_501[63:0];
  _RAND_502 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_6 = _RAND_502[63:0];
  _RAND_503 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_7 = _RAND_503[63:0];
  _RAND_504 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_8 = _RAND_504[63:0];
  _RAND_505 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_9 = _RAND_505[63:0];
  _RAND_506 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_10 = _RAND_506[63:0];
  _RAND_507 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_11 = _RAND_507[63:0];
  _RAND_508 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_12 = _RAND_508[63:0];
  _RAND_509 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_13 = _RAND_509[63:0];
  _RAND_510 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_14 = _RAND_510[63:0];
  _RAND_511 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_15 = _RAND_511[63:0];
  _RAND_512 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_16 = _RAND_512[63:0];
  _RAND_513 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_17 = _RAND_513[63:0];
  _RAND_514 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_18 = _RAND_514[63:0];
  _RAND_515 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_19 = _RAND_515[63:0];
  _RAND_516 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_20 = _RAND_516[63:0];
  _RAND_517 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_21 = _RAND_517[63:0];
  _RAND_518 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_22 = _RAND_518[63:0];
  _RAND_519 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_23 = _RAND_519[63:0];
  _RAND_520 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_24 = _RAND_520[63:0];
  _RAND_521 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_25 = _RAND_521[63:0];
  _RAND_522 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_26 = _RAND_522[63:0];
  _RAND_523 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_27 = _RAND_523[63:0];
  _RAND_524 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_28 = _RAND_524[63:0];
  _RAND_525 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_29 = _RAND_525[63:0];
  _RAND_526 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_30 = _RAND_526[63:0];
  _RAND_527 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_31 = _RAND_527[63:0];
  _RAND_528 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_32 = _RAND_528[63:0];
  _RAND_529 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_33 = _RAND_529[63:0];
  _RAND_530 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_34 = _RAND_530[63:0];
  _RAND_531 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_35 = _RAND_531[63:0];
  _RAND_532 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_36 = _RAND_532[63:0];
  _RAND_533 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_37 = _RAND_533[63:0];
  _RAND_534 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_38 = _RAND_534[63:0];
  _RAND_535 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_39 = _RAND_535[63:0];
  _RAND_536 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_40 = _RAND_536[63:0];
  _RAND_537 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_41 = _RAND_537[63:0];
  _RAND_538 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_42 = _RAND_538[63:0];
  _RAND_539 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_43 = _RAND_539[63:0];
  _RAND_540 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_44 = _RAND_540[63:0];
  _RAND_541 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_45 = _RAND_541[63:0];
  _RAND_542 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_46 = _RAND_542[63:0];
  _RAND_543 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_47 = _RAND_543[63:0];
  _RAND_544 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_48 = _RAND_544[63:0];
  _RAND_545 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_49 = _RAND_545[63:0];
  _RAND_546 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_50 = _RAND_546[63:0];
  _RAND_547 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_51 = _RAND_547[63:0];
  _RAND_548 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_52 = _RAND_548[63:0];
  _RAND_549 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_53 = _RAND_549[63:0];
  _RAND_550 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_54 = _RAND_550[63:0];
  _RAND_551 = {2{`RANDOM}};
  uram_addr_a_01_slr0_1_55 = _RAND_551[63:0];
  _RAND_552 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_0 = _RAND_552[63:0];
  _RAND_553 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_1 = _RAND_553[63:0];
  _RAND_554 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_2 = _RAND_554[63:0];
  _RAND_555 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_3 = _RAND_555[63:0];
  _RAND_556 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_4 = _RAND_556[63:0];
  _RAND_557 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_5 = _RAND_557[63:0];
  _RAND_558 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_6 = _RAND_558[63:0];
  _RAND_559 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_7 = _RAND_559[63:0];
  _RAND_560 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_8 = _RAND_560[63:0];
  _RAND_561 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_9 = _RAND_561[63:0];
  _RAND_562 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_10 = _RAND_562[63:0];
  _RAND_563 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_11 = _RAND_563[63:0];
  _RAND_564 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_12 = _RAND_564[63:0];
  _RAND_565 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_13 = _RAND_565[63:0];
  _RAND_566 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_14 = _RAND_566[63:0];
  _RAND_567 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_15 = _RAND_567[63:0];
  _RAND_568 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_16 = _RAND_568[63:0];
  _RAND_569 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_17 = _RAND_569[63:0];
  _RAND_570 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_18 = _RAND_570[63:0];
  _RAND_571 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_19 = _RAND_571[63:0];
  _RAND_572 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_20 = _RAND_572[63:0];
  _RAND_573 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_21 = _RAND_573[63:0];
  _RAND_574 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_22 = _RAND_574[63:0];
  _RAND_575 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_23 = _RAND_575[63:0];
  _RAND_576 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_24 = _RAND_576[63:0];
  _RAND_577 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_25 = _RAND_577[63:0];
  _RAND_578 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_26 = _RAND_578[63:0];
  _RAND_579 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_27 = _RAND_579[63:0];
  _RAND_580 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_28 = _RAND_580[63:0];
  _RAND_581 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_29 = _RAND_581[63:0];
  _RAND_582 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_30 = _RAND_582[63:0];
  _RAND_583 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_31 = _RAND_583[63:0];
  _RAND_584 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_32 = _RAND_584[63:0];
  _RAND_585 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_33 = _RAND_585[63:0];
  _RAND_586 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_34 = _RAND_586[63:0];
  _RAND_587 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_35 = _RAND_587[63:0];
  _RAND_588 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_36 = _RAND_588[63:0];
  _RAND_589 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_37 = _RAND_589[63:0];
  _RAND_590 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_38 = _RAND_590[63:0];
  _RAND_591 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_39 = _RAND_591[63:0];
  _RAND_592 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_40 = _RAND_592[63:0];
  _RAND_593 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_41 = _RAND_593[63:0];
  _RAND_594 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_42 = _RAND_594[63:0];
  _RAND_595 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_43 = _RAND_595[63:0];
  _RAND_596 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_44 = _RAND_596[63:0];
  _RAND_597 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_45 = _RAND_597[63:0];
  _RAND_598 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_46 = _RAND_598[63:0];
  _RAND_599 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_47 = _RAND_599[63:0];
  _RAND_600 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_48 = _RAND_600[63:0];
  _RAND_601 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_49 = _RAND_601[63:0];
  _RAND_602 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_50 = _RAND_602[63:0];
  _RAND_603 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_51 = _RAND_603[63:0];
  _RAND_604 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_52 = _RAND_604[63:0];
  _RAND_605 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_53 = _RAND_605[63:0];
  _RAND_606 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_54 = _RAND_606[63:0];
  _RAND_607 = {2{`RANDOM}};
  uram_addr_a_01_slr0_2_55 = _RAND_607[63:0];
  _RAND_608 = {2{`RANDOM}};
  uram_addr_a_01_slr1_0 = _RAND_608[63:0];
  _RAND_609 = {2{`RANDOM}};
  uram_addr_a_01_slr1_1 = _RAND_609[63:0];
  _RAND_610 = {2{`RANDOM}};
  uram_addr_a_01_slr1_2 = _RAND_610[63:0];
  _RAND_611 = {2{`RANDOM}};
  uram_addr_a_01_slr1_3 = _RAND_611[63:0];
  _RAND_612 = {2{`RANDOM}};
  uram_addr_a_01_slr1_4 = _RAND_612[63:0];
  _RAND_613 = {2{`RANDOM}};
  uram_addr_a_01_slr1_5 = _RAND_613[63:0];
  _RAND_614 = {2{`RANDOM}};
  uram_addr_a_01_slr1_6 = _RAND_614[63:0];
  _RAND_615 = {2{`RANDOM}};
  uram_addr_a_01_slr1_7 = _RAND_615[63:0];
  _RAND_616 = {2{`RANDOM}};
  uram_addr_a_01_slr1_8 = _RAND_616[63:0];
  _RAND_617 = {2{`RANDOM}};
  uram_addr_a_01_slr1_9 = _RAND_617[63:0];
  _RAND_618 = {2{`RANDOM}};
  uram_addr_a_01_slr1_10 = _RAND_618[63:0];
  _RAND_619 = {2{`RANDOM}};
  uram_addr_a_01_slr1_11 = _RAND_619[63:0];
  _RAND_620 = {2{`RANDOM}};
  uram_addr_a_01_slr1_12 = _RAND_620[63:0];
  _RAND_621 = {2{`RANDOM}};
  uram_addr_a_01_slr1_13 = _RAND_621[63:0];
  _RAND_622 = {2{`RANDOM}};
  uram_addr_a_01_slr1_14 = _RAND_622[63:0];
  _RAND_623 = {2{`RANDOM}};
  uram_addr_a_01_slr1_15 = _RAND_623[63:0];
  _RAND_624 = {2{`RANDOM}};
  uram_addr_a_01_slr1_16 = _RAND_624[63:0];
  _RAND_625 = {2{`RANDOM}};
  uram_addr_a_01_slr1_17 = _RAND_625[63:0];
  _RAND_626 = {2{`RANDOM}};
  uram_addr_a_01_slr1_18 = _RAND_626[63:0];
  _RAND_627 = {2{`RANDOM}};
  uram_addr_a_01_slr1_19 = _RAND_627[63:0];
  _RAND_628 = {2{`RANDOM}};
  uram_addr_a_01_slr1_20 = _RAND_628[63:0];
  _RAND_629 = {2{`RANDOM}};
  uram_addr_a_01_slr1_21 = _RAND_629[63:0];
  _RAND_630 = {2{`RANDOM}};
  uram_addr_a_01_slr1_22 = _RAND_630[63:0];
  _RAND_631 = {2{`RANDOM}};
  uram_addr_a_01_slr1_23 = _RAND_631[63:0];
  _RAND_632 = {2{`RANDOM}};
  uram_addr_a_01_slr1_24 = _RAND_632[63:0];
  _RAND_633 = {2{`RANDOM}};
  uram_addr_a_01_slr1_25 = _RAND_633[63:0];
  _RAND_634 = {2{`RANDOM}};
  uram_addr_a_01_slr1_26 = _RAND_634[63:0];
  _RAND_635 = {2{`RANDOM}};
  uram_addr_a_01_slr1_27 = _RAND_635[63:0];
  _RAND_636 = {2{`RANDOM}};
  uram_addr_a_01_slr1_28 = _RAND_636[63:0];
  _RAND_637 = {2{`RANDOM}};
  uram_addr_a_01_slr1_29 = _RAND_637[63:0];
  _RAND_638 = {2{`RANDOM}};
  uram_addr_a_01_slr1_30 = _RAND_638[63:0];
  _RAND_639 = {2{`RANDOM}};
  uram_addr_a_01_slr1_31 = _RAND_639[63:0];
  _RAND_640 = {2{`RANDOM}};
  uram_addr_a_01_slr1_32 = _RAND_640[63:0];
  _RAND_641 = {2{`RANDOM}};
  uram_addr_a_01_slr1_33 = _RAND_641[63:0];
  _RAND_642 = {2{`RANDOM}};
  uram_addr_a_01_slr1_34 = _RAND_642[63:0];
  _RAND_643 = {2{`RANDOM}};
  uram_addr_a_01_slr1_35 = _RAND_643[63:0];
  _RAND_644 = {2{`RANDOM}};
  uram_addr_a_01_slr1_36 = _RAND_644[63:0];
  _RAND_645 = {2{`RANDOM}};
  uram_addr_a_01_slr1_37 = _RAND_645[63:0];
  _RAND_646 = {2{`RANDOM}};
  uram_addr_a_01_slr1_38 = _RAND_646[63:0];
  _RAND_647 = {2{`RANDOM}};
  uram_addr_a_01_slr1_39 = _RAND_647[63:0];
  _RAND_648 = {2{`RANDOM}};
  uram_addr_a_01_slr1_40 = _RAND_648[63:0];
  _RAND_649 = {2{`RANDOM}};
  uram_addr_a_01_slr1_41 = _RAND_649[63:0];
  _RAND_650 = {2{`RANDOM}};
  uram_addr_a_01_slr1_42 = _RAND_650[63:0];
  _RAND_651 = {2{`RANDOM}};
  uram_addr_a_01_slr1_43 = _RAND_651[63:0];
  _RAND_652 = {2{`RANDOM}};
  uram_addr_a_01_slr1_44 = _RAND_652[63:0];
  _RAND_653 = {2{`RANDOM}};
  uram_addr_a_01_slr1_45 = _RAND_653[63:0];
  _RAND_654 = {2{`RANDOM}};
  uram_addr_a_01_slr1_46 = _RAND_654[63:0];
  _RAND_655 = {2{`RANDOM}};
  uram_addr_a_01_slr1_47 = _RAND_655[63:0];
  _RAND_656 = {2{`RANDOM}};
  uram_addr_a_01_slr1_48 = _RAND_656[63:0];
  _RAND_657 = {2{`RANDOM}};
  uram_addr_a_01_slr1_49 = _RAND_657[63:0];
  _RAND_658 = {2{`RANDOM}};
  uram_addr_a_01_slr1_50 = _RAND_658[63:0];
  _RAND_659 = {2{`RANDOM}};
  uram_addr_a_01_slr1_51 = _RAND_659[63:0];
  _RAND_660 = {2{`RANDOM}};
  uram_addr_a_01_slr1_52 = _RAND_660[63:0];
  _RAND_661 = {2{`RANDOM}};
  uram_addr_a_01_slr1_53 = _RAND_661[63:0];
  _RAND_662 = {2{`RANDOM}};
  uram_addr_a_01_slr1_54 = _RAND_662[63:0];
  _RAND_663 = {2{`RANDOM}};
  uram_addr_a_01_slr1_55 = _RAND_663[63:0];
  _RAND_664 = {1{`RANDOM}};
  _T_314 = _RAND_664[0:0];
  _RAND_665 = {1{`RANDOM}};
  _T_315 = _RAND_665[0:0];
  _RAND_666 = {1{`RANDOM}};
  _T_319 = _RAND_666[0:0];
  _RAND_667 = {1{`RANDOM}};
  _T_320 = _RAND_667[0:0];
  _RAND_668 = {1{`RANDOM}};
  _T_324 = _RAND_668[0:0];
  _RAND_669 = {1{`RANDOM}};
  _T_325 = _RAND_669[0:0];
  _RAND_670 = {1{`RANDOM}};
  _T_329 = _RAND_670[0:0];
  _RAND_671 = {1{`RANDOM}};
  _T_330 = _RAND_671[0:0];
  _RAND_672 = {1{`RANDOM}};
  _T_334 = _RAND_672[0:0];
  _RAND_673 = {1{`RANDOM}};
  _T_335 = _RAND_673[0:0];
  _RAND_674 = {1{`RANDOM}};
  _T_339 = _RAND_674[0:0];
  _RAND_675 = {1{`RANDOM}};
  _T_340 = _RAND_675[0:0];
  _RAND_676 = {1{`RANDOM}};
  _T_344 = _RAND_676[0:0];
  _RAND_677 = {1{`RANDOM}};
  _T_345 = _RAND_677[0:0];
  _RAND_678 = {1{`RANDOM}};
  _T_349 = _RAND_678[0:0];
  _RAND_679 = {1{`RANDOM}};
  _T_350 = _RAND_679[0:0];
  _RAND_680 = {1{`RANDOM}};
  _T_354 = _RAND_680[0:0];
  _RAND_681 = {1{`RANDOM}};
  _T_355 = _RAND_681[0:0];
  _RAND_682 = {1{`RANDOM}};
  _T_359 = _RAND_682[0:0];
  _RAND_683 = {1{`RANDOM}};
  _T_360 = _RAND_683[0:0];
  _RAND_684 = {1{`RANDOM}};
  _T_364 = _RAND_684[0:0];
  _RAND_685 = {1{`RANDOM}};
  _T_365 = _RAND_685[0:0];
  _RAND_686 = {1{`RANDOM}};
  _T_369 = _RAND_686[0:0];
  _RAND_687 = {1{`RANDOM}};
  _T_370 = _RAND_687[0:0];
  _RAND_688 = {1{`RANDOM}};
  _T_374 = _RAND_688[0:0];
  _RAND_689 = {1{`RANDOM}};
  _T_375 = _RAND_689[0:0];
  _RAND_690 = {1{`RANDOM}};
  _T_379 = _RAND_690[0:0];
  _RAND_691 = {1{`RANDOM}};
  _T_380 = _RAND_691[0:0];
  _RAND_692 = {1{`RANDOM}};
  _T_384 = _RAND_692[0:0];
  _RAND_693 = {1{`RANDOM}};
  _T_385 = _RAND_693[0:0];
  _RAND_694 = {1{`RANDOM}};
  _T_389 = _RAND_694[0:0];
  _RAND_695 = {1{`RANDOM}};
  _T_390 = _RAND_695[0:0];
  _RAND_696 = {1{`RANDOM}};
  _T_394 = _RAND_696[0:0];
  _RAND_697 = {1{`RANDOM}};
  _T_395 = _RAND_697[0:0];
  _RAND_698 = {1{`RANDOM}};
  _T_399 = _RAND_698[0:0];
  _RAND_699 = {1{`RANDOM}};
  _T_400 = _RAND_699[0:0];
  _RAND_700 = {1{`RANDOM}};
  _T_404 = _RAND_700[0:0];
  _RAND_701 = {1{`RANDOM}};
  _T_405 = _RAND_701[0:0];
  _RAND_702 = {1{`RANDOM}};
  _T_409 = _RAND_702[0:0];
  _RAND_703 = {1{`RANDOM}};
  _T_410 = _RAND_703[0:0];
  _RAND_704 = {1{`RANDOM}};
  _T_414 = _RAND_704[0:0];
  _RAND_705 = {1{`RANDOM}};
  _T_415 = _RAND_705[0:0];
  _RAND_706 = {1{`RANDOM}};
  _T_419 = _RAND_706[0:0];
  _RAND_707 = {1{`RANDOM}};
  _T_420 = _RAND_707[0:0];
  _RAND_708 = {1{`RANDOM}};
  _T_424 = _RAND_708[0:0];
  _RAND_709 = {1{`RANDOM}};
  _T_425 = _RAND_709[0:0];
  _RAND_710 = {1{`RANDOM}};
  _T_429 = _RAND_710[0:0];
  _RAND_711 = {1{`RANDOM}};
  _T_430 = _RAND_711[0:0];
  _RAND_712 = {1{`RANDOM}};
  _T_434 = _RAND_712[0:0];
  _RAND_713 = {1{`RANDOM}};
  _T_435 = _RAND_713[0:0];
  _RAND_714 = {1{`RANDOM}};
  _T_439 = _RAND_714[0:0];
  _RAND_715 = {1{`RANDOM}};
  _T_440 = _RAND_715[0:0];
  _RAND_716 = {1{`RANDOM}};
  _T_444 = _RAND_716[0:0];
  _RAND_717 = {1{`RANDOM}};
  _T_445 = _RAND_717[0:0];
  _RAND_718 = {1{`RANDOM}};
  _T_449 = _RAND_718[0:0];
  _RAND_719 = {1{`RANDOM}};
  _T_450 = _RAND_719[0:0];
  _RAND_720 = {1{`RANDOM}};
  _T_454 = _RAND_720[0:0];
  _RAND_721 = {1{`RANDOM}};
  _T_455 = _RAND_721[0:0];
  _RAND_722 = {1{`RANDOM}};
  _T_459 = _RAND_722[0:0];
  _RAND_723 = {1{`RANDOM}};
  _T_460 = _RAND_723[0:0];
  _RAND_724 = {1{`RANDOM}};
  _T_464 = _RAND_724[0:0];
  _RAND_725 = {1{`RANDOM}};
  _T_465 = _RAND_725[0:0];
  _RAND_726 = {1{`RANDOM}};
  _T_469 = _RAND_726[0:0];
  _RAND_727 = {1{`RANDOM}};
  _T_470 = _RAND_727[0:0];
  _RAND_728 = {1{`RANDOM}};
  _T_474 = _RAND_728[0:0];
  _RAND_729 = {1{`RANDOM}};
  _T_475 = _RAND_729[0:0];
  _RAND_730 = {1{`RANDOM}};
  _T_479 = _RAND_730[0:0];
  _RAND_731 = {1{`RANDOM}};
  _T_480 = _RAND_731[0:0];
  _RAND_732 = {1{`RANDOM}};
  _T_484 = _RAND_732[0:0];
  _RAND_733 = {1{`RANDOM}};
  _T_485 = _RAND_733[0:0];
  _RAND_734 = {1{`RANDOM}};
  _T_489 = _RAND_734[0:0];
  _RAND_735 = {1{`RANDOM}};
  _T_490 = _RAND_735[0:0];
  _RAND_736 = {1{`RANDOM}};
  _T_494 = _RAND_736[0:0];
  _RAND_737 = {1{`RANDOM}};
  _T_495 = _RAND_737[0:0];
  _RAND_738 = {1{`RANDOM}};
  _T_499 = _RAND_738[0:0];
  _RAND_739 = {1{`RANDOM}};
  _T_500 = _RAND_739[0:0];
  _RAND_740 = {1{`RANDOM}};
  _T_504 = _RAND_740[0:0];
  _RAND_741 = {1{`RANDOM}};
  _T_505 = _RAND_741[0:0];
  _RAND_742 = {1{`RANDOM}};
  _T_509 = _RAND_742[0:0];
  _RAND_743 = {1{`RANDOM}};
  _T_510 = _RAND_743[0:0];
  _RAND_744 = {1{`RANDOM}};
  _T_514 = _RAND_744[0:0];
  _RAND_745 = {1{`RANDOM}};
  _T_515 = _RAND_745[0:0];
  _RAND_746 = {1{`RANDOM}};
  _T_519 = _RAND_746[0:0];
  _RAND_747 = {1{`RANDOM}};
  _T_520 = _RAND_747[0:0];
  _RAND_748 = {1{`RANDOM}};
  _T_524 = _RAND_748[0:0];
  _RAND_749 = {1{`RANDOM}};
  _T_525 = _RAND_749[0:0];
  _RAND_750 = {1{`RANDOM}};
  _T_529 = _RAND_750[0:0];
  _RAND_751 = {1{`RANDOM}};
  _T_530 = _RAND_751[0:0];
  _RAND_752 = {1{`RANDOM}};
  _T_534 = _RAND_752[0:0];
  _RAND_753 = {1{`RANDOM}};
  _T_535 = _RAND_753[0:0];
  _RAND_754 = {1{`RANDOM}};
  _T_539 = _RAND_754[0:0];
  _RAND_755 = {1{`RANDOM}};
  _T_540 = _RAND_755[0:0];
  _RAND_756 = {1{`RANDOM}};
  _T_544 = _RAND_756[0:0];
  _RAND_757 = {1{`RANDOM}};
  _T_545 = _RAND_757[0:0];
  _RAND_758 = {1{`RANDOM}};
  _T_549 = _RAND_758[0:0];
  _RAND_759 = {1{`RANDOM}};
  _T_550 = _RAND_759[0:0];
  _RAND_760 = {1{`RANDOM}};
  _T_554 = _RAND_760[0:0];
  _RAND_761 = {1{`RANDOM}};
  _T_555 = _RAND_761[0:0];
  _RAND_762 = {1{`RANDOM}};
  _T_559 = _RAND_762[0:0];
  _RAND_763 = {1{`RANDOM}};
  _T_560 = _RAND_763[0:0];
  _RAND_764 = {1{`RANDOM}};
  _T_564 = _RAND_764[0:0];
  _RAND_765 = {1{`RANDOM}};
  _T_565 = _RAND_765[0:0];
  _RAND_766 = {1{`RANDOM}};
  _T_569 = _RAND_766[0:0];
  _RAND_767 = {1{`RANDOM}};
  _T_570 = _RAND_767[0:0];
  _RAND_768 = {1{`RANDOM}};
  _T_574 = _RAND_768[0:0];
  _RAND_769 = {1{`RANDOM}};
  _T_575 = _RAND_769[0:0];
  _RAND_770 = {1{`RANDOM}};
  _T_579 = _RAND_770[0:0];
  _RAND_771 = {1{`RANDOM}};
  _T_580 = _RAND_771[0:0];
  _RAND_772 = {1{`RANDOM}};
  _T_584 = _RAND_772[0:0];
  _RAND_773 = {1{`RANDOM}};
  _T_585 = _RAND_773[0:0];
  _RAND_774 = {1{`RANDOM}};
  _T_589 = _RAND_774[0:0];
  _RAND_775 = {1{`RANDOM}};
  _T_590 = _RAND_775[0:0];
  _RAND_776 = {1{`RANDOM}};
  r_array_count__0 = _RAND_776[31:0];
  _RAND_777 = {1{`RANDOM}};
  r_array_count__1 = _RAND_777[31:0];
  _RAND_778 = {1{`RANDOM}};
  r_array_count__2 = _RAND_778[31:0];
  _RAND_779 = {1{`RANDOM}};
  r_array_count__3 = _RAND_779[31:0];
  _RAND_780 = {1{`RANDOM}};
  r_array_count__4 = _RAND_780[31:0];
  _RAND_781 = {1{`RANDOM}};
  r_array_count__5 = _RAND_781[31:0];
  _RAND_782 = {1{`RANDOM}};
  r_array_count__6 = _RAND_782[31:0];
  _RAND_783 = {1{`RANDOM}};
  r_array_count__7 = _RAND_783[31:0];
  _RAND_784 = {1{`RANDOM}};
  r_array_count__8 = _RAND_784[31:0];
  _RAND_785 = {1{`RANDOM}};
  r_array_count__9 = _RAND_785[31:0];
  _RAND_786 = {1{`RANDOM}};
  r_array_count__10 = _RAND_786[31:0];
  _RAND_787 = {1{`RANDOM}};
  r_array_count__11 = _RAND_787[31:0];
  _RAND_788 = {1{`RANDOM}};
  r_array_count__12 = _RAND_788[31:0];
  _RAND_789 = {1{`RANDOM}};
  r_array_count__13 = _RAND_789[31:0];
  _RAND_790 = {1{`RANDOM}};
  r_array_count__14 = _RAND_790[31:0];
  _RAND_791 = {1{`RANDOM}};
  r_array_count__15 = _RAND_791[31:0];
  _RAND_792 = {1{`RANDOM}};
  r_array_count__16 = _RAND_792[31:0];
  _RAND_793 = {1{`RANDOM}};
  r_array_count__17 = _RAND_793[31:0];
  _RAND_794 = {1{`RANDOM}};
  r_array_count__18 = _RAND_794[31:0];
  _RAND_795 = {1{`RANDOM}};
  r_array_count__19 = _RAND_795[31:0];
  _RAND_796 = {1{`RANDOM}};
  r_array_count__20 = _RAND_796[31:0];
  _RAND_797 = {1{`RANDOM}};
  r_array_count__21 = _RAND_797[31:0];
  _RAND_798 = {1{`RANDOM}};
  r_array_count__22 = _RAND_798[31:0];
  _RAND_799 = {1{`RANDOM}};
  r_array_count__23 = _RAND_799[31:0];
  _RAND_800 = {1{`RANDOM}};
  r_array_count__24 = _RAND_800[31:0];
  _RAND_801 = {1{`RANDOM}};
  r_array_count__25 = _RAND_801[31:0];
  _RAND_802 = {1{`RANDOM}};
  r_array_count__26 = _RAND_802[31:0];
  _RAND_803 = {1{`RANDOM}};
  r_array_count__27 = _RAND_803[31:0];
  _RAND_804 = {1{`RANDOM}};
  r_array_count__28 = _RAND_804[31:0];
  _RAND_805 = {1{`RANDOM}};
  r_array_count__29 = _RAND_805[31:0];
  _RAND_806 = {1{`RANDOM}};
  r_array_count__30 = _RAND_806[31:0];
  _RAND_807 = {1{`RANDOM}};
  r_array_count__31 = _RAND_807[31:0];
  _RAND_808 = {1{`RANDOM}};
  r_array_count__32 = _RAND_808[31:0];
  _RAND_809 = {1{`RANDOM}};
  r_array_count__33 = _RAND_809[31:0];
  _RAND_810 = {1{`RANDOM}};
  r_array_count__34 = _RAND_810[31:0];
  _RAND_811 = {1{`RANDOM}};
  r_array_count__35 = _RAND_811[31:0];
  _RAND_812 = {1{`RANDOM}};
  r_array_count__36 = _RAND_812[31:0];
  _RAND_813 = {1{`RANDOM}};
  r_array_count__37 = _RAND_813[31:0];
  _RAND_814 = {1{`RANDOM}};
  r_array_count__38 = _RAND_814[31:0];
  _RAND_815 = {1{`RANDOM}};
  r_array_count__39 = _RAND_815[31:0];
  _RAND_816 = {1{`RANDOM}};
  r_array_count__40 = _RAND_816[31:0];
  _RAND_817 = {1{`RANDOM}};
  r_array_count__41 = _RAND_817[31:0];
  _RAND_818 = {1{`RANDOM}};
  r_array_count__42 = _RAND_818[31:0];
  _RAND_819 = {1{`RANDOM}};
  r_array_count__43 = _RAND_819[31:0];
  _RAND_820 = {1{`RANDOM}};
  r_array_count__44 = _RAND_820[31:0];
  _RAND_821 = {1{`RANDOM}};
  r_array_count__45 = _RAND_821[31:0];
  _RAND_822 = {1{`RANDOM}};
  r_array_count__46 = _RAND_822[31:0];
  _RAND_823 = {1{`RANDOM}};
  r_array_count__47 = _RAND_823[31:0];
  _RAND_824 = {1{`RANDOM}};
  r_array_count__48 = _RAND_824[31:0];
  _RAND_825 = {1{`RANDOM}};
  r_array_count__49 = _RAND_825[31:0];
  _RAND_826 = {1{`RANDOM}};
  r_array_count__50 = _RAND_826[31:0];
  _RAND_827 = {1{`RANDOM}};
  r_array_count__51 = _RAND_827[31:0];
  _RAND_828 = {1{`RANDOM}};
  r_array_count__52 = _RAND_828[31:0];
  _RAND_829 = {1{`RANDOM}};
  r_array_count__53 = _RAND_829[31:0];
  _RAND_830 = {1{`RANDOM}};
  r_array_count__54 = _RAND_830[31:0];
  _RAND_831 = {1{`RANDOM}};
  r_array_count__55 = _RAND_831[31:0];
  _RAND_832 = {1{`RANDOM}};
  p1_end_q_02_slr0_0 = _RAND_832[0:0];
  _RAND_833 = {1{`RANDOM}};
  p1_end_q_02_slr0_1 = _RAND_833[0:0];
  _RAND_834 = {1{`RANDOM}};
  p1_end_q_02_slr0_2 = _RAND_834[0:0];
  _RAND_835 = {1{`RANDOM}};
  p1_end_q_02_slr0_3 = _RAND_835[0:0];
  _RAND_836 = {1{`RANDOM}};
  p1_end_q_02_slr0_4 = _RAND_836[0:0];
  _RAND_837 = {1{`RANDOM}};
  p1_end_q_02_slr0_5 = _RAND_837[0:0];
  _RAND_838 = {1{`RANDOM}};
  p1_end_q_02_slr0_6 = _RAND_838[0:0];
  _RAND_839 = {1{`RANDOM}};
  p1_end_q_02_slr0_7 = _RAND_839[0:0];
  _RAND_840 = {1{`RANDOM}};
  p1_end_q_02_slr0_8 = _RAND_840[0:0];
  _RAND_841 = {1{`RANDOM}};
  p1_end_q_02_slr0_9 = _RAND_841[0:0];
  _RAND_842 = {1{`RANDOM}};
  p1_end_q_02_slr0_10 = _RAND_842[0:0];
  _RAND_843 = {1{`RANDOM}};
  p1_end_q_02_slr0_11 = _RAND_843[0:0];
  _RAND_844 = {1{`RANDOM}};
  p1_end_q_02_slr0_12 = _RAND_844[0:0];
  _RAND_845 = {1{`RANDOM}};
  p1_end_q_02_slr0_13 = _RAND_845[0:0];
  _RAND_846 = {1{`RANDOM}};
  p1_end_q_02_slr0_14 = _RAND_846[0:0];
  _RAND_847 = {1{`RANDOM}};
  p1_end_q_02_slr0_15 = _RAND_847[0:0];
  _RAND_848 = {1{`RANDOM}};
  p1_end_q_02_slr0_16 = _RAND_848[0:0];
  _RAND_849 = {1{`RANDOM}};
  p1_end_q_02_slr0_17 = _RAND_849[0:0];
  _RAND_850 = {1{`RANDOM}};
  p1_end_q_02_slr1_0 = _RAND_850[0:0];
  _RAND_851 = {1{`RANDOM}};
  p1_end_q_02_slr1_1 = _RAND_851[0:0];
  _RAND_852 = {1{`RANDOM}};
  p1_end_q_02_slr1_2 = _RAND_852[0:0];
  _RAND_853 = {1{`RANDOM}};
  p1_end_q_02_slr1_3 = _RAND_853[0:0];
  _RAND_854 = {1{`RANDOM}};
  p1_end_q_02_slr1_4 = _RAND_854[0:0];
  _RAND_855 = {1{`RANDOM}};
  p1_end_q_02_slr1_5 = _RAND_855[0:0];
  _RAND_856 = {1{`RANDOM}};
  p1_end_q_02_slr1_6 = _RAND_856[0:0];
  _RAND_857 = {1{`RANDOM}};
  p1_end_q_02_slr1_7 = _RAND_857[0:0];
  _RAND_858 = {1{`RANDOM}};
  p1_end_q_02_slr1_8 = _RAND_858[0:0];
  _RAND_859 = {1{`RANDOM}};
  p1_end_q_02_slr1_9 = _RAND_859[0:0];
  _RAND_860 = {1{`RANDOM}};
  p1_end_q_02_slr1_10 = _RAND_860[0:0];
  _RAND_861 = {1{`RANDOM}};
  p1_end_q_02_slr1_11 = _RAND_861[0:0];
  _RAND_862 = {1{`RANDOM}};
  p1_end_q_02_slr1_12 = _RAND_862[0:0];
  _RAND_863 = {1{`RANDOM}};
  p1_end_q_02_slr1_13 = _RAND_863[0:0];
  _RAND_864 = {1{`RANDOM}};
  p1_end_q_02_slr1_14 = _RAND_864[0:0];
  _RAND_865 = {1{`RANDOM}};
  p1_end_q_02_slr1_15 = _RAND_865[0:0];
  _RAND_866 = {1{`RANDOM}};
  p1_end_q_02_slr1_16 = _RAND_866[0:0];
  _RAND_867 = {1{`RANDOM}};
  p1_end_q_02_slr1_17 = _RAND_867[0:0];
  _RAND_868 = {1{`RANDOM}};
  p1_end_q_02_slr2_0 = _RAND_868[0:0];
  _RAND_869 = {1{`RANDOM}};
  p1_end_q_02_slr2_1 = _RAND_869[0:0];
  _RAND_870 = {1{`RANDOM}};
  p1_end_q_02_slr2_2 = _RAND_870[0:0];
  _RAND_871 = {1{`RANDOM}};
  p1_end_q_02_slr2_3 = _RAND_871[0:0];
  _RAND_872 = {1{`RANDOM}};
  p1_end_q_02_slr2_4 = _RAND_872[0:0];
  _RAND_873 = {1{`RANDOM}};
  p1_end_q_02_slr2_5 = _RAND_873[0:0];
  _RAND_874 = {1{`RANDOM}};
  p1_end_q_02_slr2_6 = _RAND_874[0:0];
  _RAND_875 = {1{`RANDOM}};
  p1_end_q_02_slr2_7 = _RAND_875[0:0];
  _RAND_876 = {1{`RANDOM}};
  p1_end_q_02_slr2_8 = _RAND_876[0:0];
  _RAND_877 = {1{`RANDOM}};
  p1_end_q_02_slr2_9 = _RAND_877[0:0];
  _RAND_878 = {1{`RANDOM}};
  p1_end_q_02_slr2_10 = _RAND_878[0:0];
  _RAND_879 = {1{`RANDOM}};
  p1_end_q_02_slr2_11 = _RAND_879[0:0];
  _RAND_880 = {1{`RANDOM}};
  p1_end_q_02_slr2_12 = _RAND_880[0:0];
  _RAND_881 = {1{`RANDOM}};
  p1_end_q_02_slr2_13 = _RAND_881[0:0];
  _RAND_882 = {1{`RANDOM}};
  p1_end_q_02_slr2_14 = _RAND_882[0:0];
  _RAND_883 = {1{`RANDOM}};
  p1_end_q_02_slr2_15 = _RAND_883[0:0];
  _RAND_884 = {1{`RANDOM}};
  p1_end_q_02_slr2_16 = _RAND_884[0:0];
  _RAND_885 = {1{`RANDOM}};
  p1_end_q_02_slr2_17 = _RAND_885[0:0];
  _RAND_886 = {2{`RANDOM}};
  uram_out_a_02_slr0_0 = _RAND_886[63:0];
  _RAND_887 = {2{`RANDOM}};
  uram_out_a_02_slr0_1 = _RAND_887[63:0];
  _RAND_888 = {2{`RANDOM}};
  uram_out_a_02_slr0_2 = _RAND_888[63:0];
  _RAND_889 = {2{`RANDOM}};
  uram_out_a_02_slr0_3 = _RAND_889[63:0];
  _RAND_890 = {2{`RANDOM}};
  uram_out_a_02_slr0_4 = _RAND_890[63:0];
  _RAND_891 = {2{`RANDOM}};
  uram_out_a_02_slr0_5 = _RAND_891[63:0];
  _RAND_892 = {2{`RANDOM}};
  uram_out_a_02_slr0_6 = _RAND_892[63:0];
  _RAND_893 = {2{`RANDOM}};
  uram_out_a_02_slr0_7 = _RAND_893[63:0];
  _RAND_894 = {2{`RANDOM}};
  uram_out_a_02_slr0_8 = _RAND_894[63:0];
  _RAND_895 = {2{`RANDOM}};
  uram_out_a_02_slr0_9 = _RAND_895[63:0];
  _RAND_896 = {2{`RANDOM}};
  uram_out_a_02_slr0_10 = _RAND_896[63:0];
  _RAND_897 = {2{`RANDOM}};
  uram_out_a_02_slr0_11 = _RAND_897[63:0];
  _RAND_898 = {2{`RANDOM}};
  uram_out_a_02_slr0_12 = _RAND_898[63:0];
  _RAND_899 = {2{`RANDOM}};
  uram_out_a_02_slr0_13 = _RAND_899[63:0];
  _RAND_900 = {2{`RANDOM}};
  uram_out_a_02_slr0_14 = _RAND_900[63:0];
  _RAND_901 = {2{`RANDOM}};
  uram_out_a_02_slr0_15 = _RAND_901[63:0];
  _RAND_902 = {2{`RANDOM}};
  uram_out_a_02_slr0_16 = _RAND_902[63:0];
  _RAND_903 = {2{`RANDOM}};
  uram_out_a_02_slr0_17 = _RAND_903[63:0];
  _RAND_904 = {2{`RANDOM}};
  uram_out_a_02_slr0_18 = _RAND_904[63:0];
  _RAND_905 = {2{`RANDOM}};
  uram_out_a_02_slr0_19 = _RAND_905[63:0];
  _RAND_906 = {2{`RANDOM}};
  uram_out_a_02_slr0_20 = _RAND_906[63:0];
  _RAND_907 = {2{`RANDOM}};
  uram_out_a_02_slr0_21 = _RAND_907[63:0];
  _RAND_908 = {2{`RANDOM}};
  uram_out_a_02_slr0_22 = _RAND_908[63:0];
  _RAND_909 = {2{`RANDOM}};
  uram_out_a_02_slr0_23 = _RAND_909[63:0];
  _RAND_910 = {2{`RANDOM}};
  uram_out_a_02_slr0_24 = _RAND_910[63:0];
  _RAND_911 = {2{`RANDOM}};
  uram_out_a_02_slr0_25 = _RAND_911[63:0];
  _RAND_912 = {2{`RANDOM}};
  uram_out_a_02_slr0_26 = _RAND_912[63:0];
  _RAND_913 = {2{`RANDOM}};
  uram_out_a_02_slr0_27 = _RAND_913[63:0];
  _RAND_914 = {2{`RANDOM}};
  uram_out_a_02_slr0_28 = _RAND_914[63:0];
  _RAND_915 = {2{`RANDOM}};
  uram_out_a_02_slr0_29 = _RAND_915[63:0];
  _RAND_916 = {2{`RANDOM}};
  uram_out_a_02_slr0_30 = _RAND_916[63:0];
  _RAND_917 = {2{`RANDOM}};
  uram_out_a_02_slr0_31 = _RAND_917[63:0];
  _RAND_918 = {2{`RANDOM}};
  uram_out_a_02_slr0_32 = _RAND_918[63:0];
  _RAND_919 = {2{`RANDOM}};
  uram_out_a_02_slr0_33 = _RAND_919[63:0];
  _RAND_920 = {2{`RANDOM}};
  uram_out_a_02_slr0_34 = _RAND_920[63:0];
  _RAND_921 = {2{`RANDOM}};
  uram_out_a_02_slr0_35 = _RAND_921[63:0];
  _RAND_922 = {2{`RANDOM}};
  uram_out_a_02_slr0_36 = _RAND_922[63:0];
  _RAND_923 = {2{`RANDOM}};
  uram_out_a_02_slr0_37 = _RAND_923[63:0];
  _RAND_924 = {2{`RANDOM}};
  uram_out_a_02_slr0_38 = _RAND_924[63:0];
  _RAND_925 = {2{`RANDOM}};
  uram_out_a_02_slr0_39 = _RAND_925[63:0];
  _RAND_926 = {2{`RANDOM}};
  uram_out_a_02_slr0_40 = _RAND_926[63:0];
  _RAND_927 = {2{`RANDOM}};
  uram_out_a_02_slr0_41 = _RAND_927[63:0];
  _RAND_928 = {2{`RANDOM}};
  uram_out_a_02_slr0_42 = _RAND_928[63:0];
  _RAND_929 = {2{`RANDOM}};
  uram_out_a_02_slr0_43 = _RAND_929[63:0];
  _RAND_930 = {2{`RANDOM}};
  uram_out_a_02_slr0_44 = _RAND_930[63:0];
  _RAND_931 = {2{`RANDOM}};
  uram_out_a_02_slr0_45 = _RAND_931[63:0];
  _RAND_932 = {2{`RANDOM}};
  uram_out_a_02_slr0_46 = _RAND_932[63:0];
  _RAND_933 = {2{`RANDOM}};
  uram_out_a_02_slr0_47 = _RAND_933[63:0];
  _RAND_934 = {2{`RANDOM}};
  uram_out_a_02_slr0_48 = _RAND_934[63:0];
  _RAND_935 = {2{`RANDOM}};
  uram_out_a_02_slr0_49 = _RAND_935[63:0];
  _RAND_936 = {2{`RANDOM}};
  uram_out_a_02_slr0_50 = _RAND_936[63:0];
  _RAND_937 = {2{`RANDOM}};
  uram_out_a_02_slr0_51 = _RAND_937[63:0];
  _RAND_938 = {2{`RANDOM}};
  uram_out_a_02_slr0_52 = _RAND_938[63:0];
  _RAND_939 = {2{`RANDOM}};
  uram_out_a_02_slr0_53 = _RAND_939[63:0];
  _RAND_940 = {2{`RANDOM}};
  uram_out_a_02_slr0_54 = _RAND_940[63:0];
  _RAND_941 = {2{`RANDOM}};
  uram_out_a_02_slr0_55 = _RAND_941[63:0];
  _RAND_942 = {2{`RANDOM}};
  uram_out_a_02_slr0_56 = _RAND_942[63:0];
  _RAND_943 = {2{`RANDOM}};
  uram_out_a_02_slr0_57 = _RAND_943[63:0];
  _RAND_944 = {2{`RANDOM}};
  uram_out_a_02_slr0_58 = _RAND_944[63:0];
  _RAND_945 = {2{`RANDOM}};
  uram_out_a_02_slr0_59 = _RAND_945[63:0];
  _RAND_946 = {2{`RANDOM}};
  uram_out_a_02_slr0_60 = _RAND_946[63:0];
  _RAND_947 = {2{`RANDOM}};
  uram_out_a_02_slr0_61 = _RAND_947[63:0];
  _RAND_948 = {2{`RANDOM}};
  uram_out_a_02_slr0_62 = _RAND_948[63:0];
  _RAND_949 = {2{`RANDOM}};
  uram_out_a_02_slr0_63 = _RAND_949[63:0];
  _RAND_950 = {2{`RANDOM}};
  uram_out_a_02_slr0_64 = _RAND_950[63:0];
  _RAND_951 = {2{`RANDOM}};
  uram_out_a_02_slr0_65 = _RAND_951[63:0];
  _RAND_952 = {2{`RANDOM}};
  uram_out_a_02_slr0_66 = _RAND_952[63:0];
  _RAND_953 = {2{`RANDOM}};
  uram_out_a_02_slr0_67 = _RAND_953[63:0];
  _RAND_954 = {2{`RANDOM}};
  uram_out_a_02_slr0_68 = _RAND_954[63:0];
  _RAND_955 = {2{`RANDOM}};
  uram_out_a_02_slr0_69 = _RAND_955[63:0];
  _RAND_956 = {2{`RANDOM}};
  uram_out_a_02_slr0_70 = _RAND_956[63:0];
  _RAND_957 = {2{`RANDOM}};
  uram_out_a_02_slr0_71 = _RAND_957[63:0];
  _RAND_958 = {2{`RANDOM}};
  uram_out_a_02_slr1_0 = _RAND_958[63:0];
  _RAND_959 = {2{`RANDOM}};
  uram_out_a_02_slr1_1 = _RAND_959[63:0];
  _RAND_960 = {2{`RANDOM}};
  uram_out_a_02_slr1_2 = _RAND_960[63:0];
  _RAND_961 = {2{`RANDOM}};
  uram_out_a_02_slr1_3 = _RAND_961[63:0];
  _RAND_962 = {2{`RANDOM}};
  uram_out_a_02_slr1_4 = _RAND_962[63:0];
  _RAND_963 = {2{`RANDOM}};
  uram_out_a_02_slr1_5 = _RAND_963[63:0];
  _RAND_964 = {2{`RANDOM}};
  uram_out_a_02_slr1_6 = _RAND_964[63:0];
  _RAND_965 = {2{`RANDOM}};
  uram_out_a_02_slr1_7 = _RAND_965[63:0];
  _RAND_966 = {2{`RANDOM}};
  uram_out_a_02_slr1_8 = _RAND_966[63:0];
  _RAND_967 = {2{`RANDOM}};
  uram_out_a_02_slr1_9 = _RAND_967[63:0];
  _RAND_968 = {2{`RANDOM}};
  uram_out_a_02_slr1_10 = _RAND_968[63:0];
  _RAND_969 = {2{`RANDOM}};
  uram_out_a_02_slr1_11 = _RAND_969[63:0];
  _RAND_970 = {2{`RANDOM}};
  uram_out_a_02_slr1_12 = _RAND_970[63:0];
  _RAND_971 = {2{`RANDOM}};
  uram_out_a_02_slr1_13 = _RAND_971[63:0];
  _RAND_972 = {2{`RANDOM}};
  uram_out_a_02_slr1_14 = _RAND_972[63:0];
  _RAND_973 = {2{`RANDOM}};
  uram_out_a_02_slr1_15 = _RAND_973[63:0];
  _RAND_974 = {2{`RANDOM}};
  uram_out_a_02_slr1_16 = _RAND_974[63:0];
  _RAND_975 = {2{`RANDOM}};
  uram_out_a_02_slr1_17 = _RAND_975[63:0];
  _RAND_976 = {2{`RANDOM}};
  uram_out_a_02_slr1_18 = _RAND_976[63:0];
  _RAND_977 = {2{`RANDOM}};
  uram_out_a_02_slr1_19 = _RAND_977[63:0];
  _RAND_978 = {2{`RANDOM}};
  uram_out_a_02_slr1_20 = _RAND_978[63:0];
  _RAND_979 = {2{`RANDOM}};
  uram_out_a_02_slr1_21 = _RAND_979[63:0];
  _RAND_980 = {2{`RANDOM}};
  uram_out_a_02_slr1_22 = _RAND_980[63:0];
  _RAND_981 = {2{`RANDOM}};
  uram_out_a_02_slr1_23 = _RAND_981[63:0];
  _RAND_982 = {2{`RANDOM}};
  uram_out_a_02_slr1_24 = _RAND_982[63:0];
  _RAND_983 = {2{`RANDOM}};
  uram_out_a_02_slr1_25 = _RAND_983[63:0];
  _RAND_984 = {2{`RANDOM}};
  uram_out_a_02_slr1_26 = _RAND_984[63:0];
  _RAND_985 = {2{`RANDOM}};
  uram_out_a_02_slr1_27 = _RAND_985[63:0];
  _RAND_986 = {2{`RANDOM}};
  uram_out_a_02_slr1_28 = _RAND_986[63:0];
  _RAND_987 = {2{`RANDOM}};
  uram_out_a_02_slr1_29 = _RAND_987[63:0];
  _RAND_988 = {2{`RANDOM}};
  uram_out_a_02_slr1_30 = _RAND_988[63:0];
  _RAND_989 = {2{`RANDOM}};
  uram_out_a_02_slr1_31 = _RAND_989[63:0];
  _RAND_990 = {2{`RANDOM}};
  uram_out_a_02_slr1_32 = _RAND_990[63:0];
  _RAND_991 = {2{`RANDOM}};
  uram_out_a_02_slr1_33 = _RAND_991[63:0];
  _RAND_992 = {2{`RANDOM}};
  uram_out_a_02_slr1_34 = _RAND_992[63:0];
  _RAND_993 = {2{`RANDOM}};
  uram_out_a_02_slr1_35 = _RAND_993[63:0];
  _RAND_994 = {2{`RANDOM}};
  uram_out_a_02_slr1_36 = _RAND_994[63:0];
  _RAND_995 = {2{`RANDOM}};
  uram_out_a_02_slr1_37 = _RAND_995[63:0];
  _RAND_996 = {2{`RANDOM}};
  uram_out_a_02_slr1_38 = _RAND_996[63:0];
  _RAND_997 = {2{`RANDOM}};
  uram_out_a_02_slr1_39 = _RAND_997[63:0];
  _RAND_998 = {2{`RANDOM}};
  uram_out_a_02_slr1_40 = _RAND_998[63:0];
  _RAND_999 = {2{`RANDOM}};
  uram_out_a_02_slr1_41 = _RAND_999[63:0];
  _RAND_1000 = {2{`RANDOM}};
  uram_out_a_02_slr1_42 = _RAND_1000[63:0];
  _RAND_1001 = {2{`RANDOM}};
  uram_out_a_02_slr1_43 = _RAND_1001[63:0];
  _RAND_1002 = {2{`RANDOM}};
  uram_out_a_02_slr1_44 = _RAND_1002[63:0];
  _RAND_1003 = {2{`RANDOM}};
  uram_out_a_02_slr1_45 = _RAND_1003[63:0];
  _RAND_1004 = {2{`RANDOM}};
  uram_out_a_02_slr1_46 = _RAND_1004[63:0];
  _RAND_1005 = {2{`RANDOM}};
  uram_out_a_02_slr1_47 = _RAND_1005[63:0];
  _RAND_1006 = {2{`RANDOM}};
  uram_out_a_02_slr1_48 = _RAND_1006[63:0];
  _RAND_1007 = {2{`RANDOM}};
  uram_out_a_02_slr1_49 = _RAND_1007[63:0];
  _RAND_1008 = {2{`RANDOM}};
  uram_out_a_02_slr1_50 = _RAND_1008[63:0];
  _RAND_1009 = {2{`RANDOM}};
  uram_out_a_02_slr1_51 = _RAND_1009[63:0];
  _RAND_1010 = {2{`RANDOM}};
  uram_out_a_02_slr1_52 = _RAND_1010[63:0];
  _RAND_1011 = {2{`RANDOM}};
  uram_out_a_02_slr1_53 = _RAND_1011[63:0];
  _RAND_1012 = {2{`RANDOM}};
  uram_out_a_02_slr1_54 = _RAND_1012[63:0];
  _RAND_1013 = {2{`RANDOM}};
  uram_out_a_02_slr1_55 = _RAND_1013[63:0];
  _RAND_1014 = {2{`RANDOM}};
  uram_out_a_02_slr1_56 = _RAND_1014[63:0];
  _RAND_1015 = {2{`RANDOM}};
  uram_out_a_02_slr1_57 = _RAND_1015[63:0];
  _RAND_1016 = {2{`RANDOM}};
  uram_out_a_02_slr1_58 = _RAND_1016[63:0];
  _RAND_1017 = {2{`RANDOM}};
  uram_out_a_02_slr1_59 = _RAND_1017[63:0];
  _RAND_1018 = {2{`RANDOM}};
  uram_out_a_02_slr1_60 = _RAND_1018[63:0];
  _RAND_1019 = {2{`RANDOM}};
  uram_out_a_02_slr1_61 = _RAND_1019[63:0];
  _RAND_1020 = {2{`RANDOM}};
  uram_out_a_02_slr1_62 = _RAND_1020[63:0];
  _RAND_1021 = {2{`RANDOM}};
  uram_out_a_02_slr1_63 = _RAND_1021[63:0];
  _RAND_1022 = {2{`RANDOM}};
  uram_out_a_02_slr1_64 = _RAND_1022[63:0];
  _RAND_1023 = {2{`RANDOM}};
  uram_out_a_02_slr1_65 = _RAND_1023[63:0];
  _RAND_1024 = {2{`RANDOM}};
  uram_out_a_02_slr1_66 = _RAND_1024[63:0];
  _RAND_1025 = {2{`RANDOM}};
  uram_out_a_02_slr1_67 = _RAND_1025[63:0];
  _RAND_1026 = {2{`RANDOM}};
  uram_out_a_02_slr1_68 = _RAND_1026[63:0];
  _RAND_1027 = {2{`RANDOM}};
  uram_out_a_02_slr1_69 = _RAND_1027[63:0];
  _RAND_1028 = {2{`RANDOM}};
  uram_out_a_02_slr1_70 = _RAND_1028[63:0];
  _RAND_1029 = {2{`RANDOM}};
  uram_out_a_02_slr1_71 = _RAND_1029[63:0];
  _RAND_1030 = {2{`RANDOM}};
  uram_out_a_02_slr2_0 = _RAND_1030[63:0];
  _RAND_1031 = {2{`RANDOM}};
  uram_out_a_02_slr2_1 = _RAND_1031[63:0];
  _RAND_1032 = {2{`RANDOM}};
  uram_out_a_02_slr2_2 = _RAND_1032[63:0];
  _RAND_1033 = {2{`RANDOM}};
  uram_out_a_02_slr2_3 = _RAND_1033[63:0];
  _RAND_1034 = {2{`RANDOM}};
  uram_out_a_02_slr2_4 = _RAND_1034[63:0];
  _RAND_1035 = {2{`RANDOM}};
  uram_out_a_02_slr2_5 = _RAND_1035[63:0];
  _RAND_1036 = {2{`RANDOM}};
  uram_out_a_02_slr2_6 = _RAND_1036[63:0];
  _RAND_1037 = {2{`RANDOM}};
  uram_out_a_02_slr2_7 = _RAND_1037[63:0];
  _RAND_1038 = {2{`RANDOM}};
  uram_out_a_02_slr2_8 = _RAND_1038[63:0];
  _RAND_1039 = {2{`RANDOM}};
  uram_out_a_02_slr2_9 = _RAND_1039[63:0];
  _RAND_1040 = {2{`RANDOM}};
  uram_out_a_02_slr2_10 = _RAND_1040[63:0];
  _RAND_1041 = {2{`RANDOM}};
  uram_out_a_02_slr2_11 = _RAND_1041[63:0];
  _RAND_1042 = {2{`RANDOM}};
  uram_out_a_02_slr2_12 = _RAND_1042[63:0];
  _RAND_1043 = {2{`RANDOM}};
  uram_out_a_02_slr2_13 = _RAND_1043[63:0];
  _RAND_1044 = {2{`RANDOM}};
  uram_out_a_02_slr2_14 = _RAND_1044[63:0];
  _RAND_1045 = {2{`RANDOM}};
  uram_out_a_02_slr2_15 = _RAND_1045[63:0];
  _RAND_1046 = {2{`RANDOM}};
  uram_out_a_02_slr2_16 = _RAND_1046[63:0];
  _RAND_1047 = {2{`RANDOM}};
  uram_out_a_02_slr2_17 = _RAND_1047[63:0];
  _RAND_1048 = {2{`RANDOM}};
  uram_out_a_02_slr2_18 = _RAND_1048[63:0];
  _RAND_1049 = {2{`RANDOM}};
  uram_out_a_02_slr2_19 = _RAND_1049[63:0];
  _RAND_1050 = {2{`RANDOM}};
  uram_out_a_02_slr2_20 = _RAND_1050[63:0];
  _RAND_1051 = {2{`RANDOM}};
  uram_out_a_02_slr2_21 = _RAND_1051[63:0];
  _RAND_1052 = {2{`RANDOM}};
  uram_out_a_02_slr2_22 = _RAND_1052[63:0];
  _RAND_1053 = {2{`RANDOM}};
  uram_out_a_02_slr2_23 = _RAND_1053[63:0];
  _RAND_1054 = {2{`RANDOM}};
  uram_out_a_02_slr2_24 = _RAND_1054[63:0];
  _RAND_1055 = {2{`RANDOM}};
  uram_out_a_02_slr2_25 = _RAND_1055[63:0];
  _RAND_1056 = {2{`RANDOM}};
  uram_out_a_02_slr2_26 = _RAND_1056[63:0];
  _RAND_1057 = {2{`RANDOM}};
  uram_out_a_02_slr2_27 = _RAND_1057[63:0];
  _RAND_1058 = {2{`RANDOM}};
  uram_out_a_02_slr2_28 = _RAND_1058[63:0];
  _RAND_1059 = {2{`RANDOM}};
  uram_out_a_02_slr2_29 = _RAND_1059[63:0];
  _RAND_1060 = {2{`RANDOM}};
  uram_out_a_02_slr2_30 = _RAND_1060[63:0];
  _RAND_1061 = {2{`RANDOM}};
  uram_out_a_02_slr2_31 = _RAND_1061[63:0];
  _RAND_1062 = {2{`RANDOM}};
  uram_out_a_02_slr2_32 = _RAND_1062[63:0];
  _RAND_1063 = {2{`RANDOM}};
  uram_out_a_02_slr2_33 = _RAND_1063[63:0];
  _RAND_1064 = {2{`RANDOM}};
  uram_out_a_02_slr2_34 = _RAND_1064[63:0];
  _RAND_1065 = {2{`RANDOM}};
  uram_out_a_02_slr2_35 = _RAND_1065[63:0];
  _RAND_1066 = {2{`RANDOM}};
  uram_out_a_02_slr2_36 = _RAND_1066[63:0];
  _RAND_1067 = {2{`RANDOM}};
  uram_out_a_02_slr2_37 = _RAND_1067[63:0];
  _RAND_1068 = {2{`RANDOM}};
  uram_out_a_02_slr2_38 = _RAND_1068[63:0];
  _RAND_1069 = {2{`RANDOM}};
  uram_out_a_02_slr2_39 = _RAND_1069[63:0];
  _RAND_1070 = {2{`RANDOM}};
  uram_out_a_02_slr2_40 = _RAND_1070[63:0];
  _RAND_1071 = {2{`RANDOM}};
  uram_out_a_02_slr2_41 = _RAND_1071[63:0];
  _RAND_1072 = {2{`RANDOM}};
  uram_out_a_02_slr2_42 = _RAND_1072[63:0];
  _RAND_1073 = {2{`RANDOM}};
  uram_out_a_02_slr2_43 = _RAND_1073[63:0];
  _RAND_1074 = {2{`RANDOM}};
  uram_out_a_02_slr2_44 = _RAND_1074[63:0];
  _RAND_1075 = {2{`RANDOM}};
  uram_out_a_02_slr2_45 = _RAND_1075[63:0];
  _RAND_1076 = {2{`RANDOM}};
  uram_out_a_02_slr2_46 = _RAND_1076[63:0];
  _RAND_1077 = {2{`RANDOM}};
  uram_out_a_02_slr2_47 = _RAND_1077[63:0];
  _RAND_1078 = {2{`RANDOM}};
  uram_out_a_02_slr2_48 = _RAND_1078[63:0];
  _RAND_1079 = {2{`RANDOM}};
  uram_out_a_02_slr2_49 = _RAND_1079[63:0];
  _RAND_1080 = {2{`RANDOM}};
  uram_out_a_02_slr2_50 = _RAND_1080[63:0];
  _RAND_1081 = {2{`RANDOM}};
  uram_out_a_02_slr2_51 = _RAND_1081[63:0];
  _RAND_1082 = {2{`RANDOM}};
  uram_out_a_02_slr2_52 = _RAND_1082[63:0];
  _RAND_1083 = {2{`RANDOM}};
  uram_out_a_02_slr2_53 = _RAND_1083[63:0];
  _RAND_1084 = {2{`RANDOM}};
  uram_out_a_02_slr2_54 = _RAND_1084[63:0];
  _RAND_1085 = {2{`RANDOM}};
  uram_out_a_02_slr2_55 = _RAND_1085[63:0];
  _RAND_1086 = {2{`RANDOM}};
  uram_out_a_02_slr2_56 = _RAND_1086[63:0];
  _RAND_1087 = {2{`RANDOM}};
  uram_out_a_02_slr2_57 = _RAND_1087[63:0];
  _RAND_1088 = {2{`RANDOM}};
  uram_out_a_02_slr2_58 = _RAND_1088[63:0];
  _RAND_1089 = {2{`RANDOM}};
  uram_out_a_02_slr2_59 = _RAND_1089[63:0];
  _RAND_1090 = {2{`RANDOM}};
  uram_out_a_02_slr2_60 = _RAND_1090[63:0];
  _RAND_1091 = {2{`RANDOM}};
  uram_out_a_02_slr2_61 = _RAND_1091[63:0];
  _RAND_1092 = {2{`RANDOM}};
  uram_out_a_02_slr2_62 = _RAND_1092[63:0];
  _RAND_1093 = {2{`RANDOM}};
  uram_out_a_02_slr2_63 = _RAND_1093[63:0];
  _RAND_1094 = {2{`RANDOM}};
  uram_out_a_02_slr2_64 = _RAND_1094[63:0];
  _RAND_1095 = {2{`RANDOM}};
  uram_out_a_02_slr2_65 = _RAND_1095[63:0];
  _RAND_1096 = {2{`RANDOM}};
  uram_out_a_02_slr2_66 = _RAND_1096[63:0];
  _RAND_1097 = {2{`RANDOM}};
  uram_out_a_02_slr2_67 = _RAND_1097[63:0];
  _RAND_1098 = {2{`RANDOM}};
  uram_out_a_02_slr2_68 = _RAND_1098[63:0];
  _RAND_1099 = {2{`RANDOM}};
  uram_out_a_02_slr2_69 = _RAND_1099[63:0];
  _RAND_1100 = {2{`RANDOM}};
  uram_out_a_02_slr2_70 = _RAND_1100[63:0];
  _RAND_1101 = {2{`RANDOM}};
  uram_out_a_02_slr2_71 = _RAND_1101[63:0];
  _RAND_1102 = {2{`RANDOM}};
  uram_addr_a_02_slr0_0 = _RAND_1102[63:0];
  _RAND_1103 = {2{`RANDOM}};
  uram_addr_a_02_slr0_1 = _RAND_1103[63:0];
  _RAND_1104 = {2{`RANDOM}};
  uram_addr_a_02_slr0_2 = _RAND_1104[63:0];
  _RAND_1105 = {2{`RANDOM}};
  uram_addr_a_02_slr0_3 = _RAND_1105[63:0];
  _RAND_1106 = {2{`RANDOM}};
  uram_addr_a_02_slr0_4 = _RAND_1106[63:0];
  _RAND_1107 = {2{`RANDOM}};
  uram_addr_a_02_slr0_5 = _RAND_1107[63:0];
  _RAND_1108 = {2{`RANDOM}};
  uram_addr_a_02_slr0_6 = _RAND_1108[63:0];
  _RAND_1109 = {2{`RANDOM}};
  uram_addr_a_02_slr0_7 = _RAND_1109[63:0];
  _RAND_1110 = {2{`RANDOM}};
  uram_addr_a_02_slr0_8 = _RAND_1110[63:0];
  _RAND_1111 = {2{`RANDOM}};
  uram_addr_a_02_slr0_9 = _RAND_1111[63:0];
  _RAND_1112 = {2{`RANDOM}};
  uram_addr_a_02_slr0_10 = _RAND_1112[63:0];
  _RAND_1113 = {2{`RANDOM}};
  uram_addr_a_02_slr0_11 = _RAND_1113[63:0];
  _RAND_1114 = {2{`RANDOM}};
  uram_addr_a_02_slr0_12 = _RAND_1114[63:0];
  _RAND_1115 = {2{`RANDOM}};
  uram_addr_a_02_slr0_13 = _RAND_1115[63:0];
  _RAND_1116 = {2{`RANDOM}};
  uram_addr_a_02_slr0_14 = _RAND_1116[63:0];
  _RAND_1117 = {2{`RANDOM}};
  uram_addr_a_02_slr0_15 = _RAND_1117[63:0];
  _RAND_1118 = {2{`RANDOM}};
  uram_addr_a_02_slr0_16 = _RAND_1118[63:0];
  _RAND_1119 = {2{`RANDOM}};
  uram_addr_a_02_slr0_17 = _RAND_1119[63:0];
  _RAND_1120 = {2{`RANDOM}};
  uram_addr_a_02_slr0_18 = _RAND_1120[63:0];
  _RAND_1121 = {2{`RANDOM}};
  uram_addr_a_02_slr0_19 = _RAND_1121[63:0];
  _RAND_1122 = {2{`RANDOM}};
  uram_addr_a_02_slr0_20 = _RAND_1122[63:0];
  _RAND_1123 = {2{`RANDOM}};
  uram_addr_a_02_slr0_21 = _RAND_1123[63:0];
  _RAND_1124 = {2{`RANDOM}};
  uram_addr_a_02_slr0_22 = _RAND_1124[63:0];
  _RAND_1125 = {2{`RANDOM}};
  uram_addr_a_02_slr0_23 = _RAND_1125[63:0];
  _RAND_1126 = {2{`RANDOM}};
  uram_addr_a_02_slr0_24 = _RAND_1126[63:0];
  _RAND_1127 = {2{`RANDOM}};
  uram_addr_a_02_slr0_25 = _RAND_1127[63:0];
  _RAND_1128 = {2{`RANDOM}};
  uram_addr_a_02_slr0_26 = _RAND_1128[63:0];
  _RAND_1129 = {2{`RANDOM}};
  uram_addr_a_02_slr0_27 = _RAND_1129[63:0];
  _RAND_1130 = {2{`RANDOM}};
  uram_addr_a_02_slr0_28 = _RAND_1130[63:0];
  _RAND_1131 = {2{`RANDOM}};
  uram_addr_a_02_slr0_29 = _RAND_1131[63:0];
  _RAND_1132 = {2{`RANDOM}};
  uram_addr_a_02_slr0_30 = _RAND_1132[63:0];
  _RAND_1133 = {2{`RANDOM}};
  uram_addr_a_02_slr0_31 = _RAND_1133[63:0];
  _RAND_1134 = {2{`RANDOM}};
  uram_addr_a_02_slr0_32 = _RAND_1134[63:0];
  _RAND_1135 = {2{`RANDOM}};
  uram_addr_a_02_slr0_33 = _RAND_1135[63:0];
  _RAND_1136 = {2{`RANDOM}};
  uram_addr_a_02_slr0_34 = _RAND_1136[63:0];
  _RAND_1137 = {2{`RANDOM}};
  uram_addr_a_02_slr0_35 = _RAND_1137[63:0];
  _RAND_1138 = {2{`RANDOM}};
  uram_addr_a_02_slr0_36 = _RAND_1138[63:0];
  _RAND_1139 = {2{`RANDOM}};
  uram_addr_a_02_slr0_37 = _RAND_1139[63:0];
  _RAND_1140 = {2{`RANDOM}};
  uram_addr_a_02_slr0_38 = _RAND_1140[63:0];
  _RAND_1141 = {2{`RANDOM}};
  uram_addr_a_02_slr0_39 = _RAND_1141[63:0];
  _RAND_1142 = {2{`RANDOM}};
  uram_addr_a_02_slr0_40 = _RAND_1142[63:0];
  _RAND_1143 = {2{`RANDOM}};
  uram_addr_a_02_slr0_41 = _RAND_1143[63:0];
  _RAND_1144 = {2{`RANDOM}};
  uram_addr_a_02_slr0_42 = _RAND_1144[63:0];
  _RAND_1145 = {2{`RANDOM}};
  uram_addr_a_02_slr0_43 = _RAND_1145[63:0];
  _RAND_1146 = {2{`RANDOM}};
  uram_addr_a_02_slr0_44 = _RAND_1146[63:0];
  _RAND_1147 = {2{`RANDOM}};
  uram_addr_a_02_slr0_45 = _RAND_1147[63:0];
  _RAND_1148 = {2{`RANDOM}};
  uram_addr_a_02_slr0_46 = _RAND_1148[63:0];
  _RAND_1149 = {2{`RANDOM}};
  uram_addr_a_02_slr0_47 = _RAND_1149[63:0];
  _RAND_1150 = {2{`RANDOM}};
  uram_addr_a_02_slr0_48 = _RAND_1150[63:0];
  _RAND_1151 = {2{`RANDOM}};
  uram_addr_a_02_slr0_49 = _RAND_1151[63:0];
  _RAND_1152 = {2{`RANDOM}};
  uram_addr_a_02_slr0_50 = _RAND_1152[63:0];
  _RAND_1153 = {2{`RANDOM}};
  uram_addr_a_02_slr0_51 = _RAND_1153[63:0];
  _RAND_1154 = {2{`RANDOM}};
  uram_addr_a_02_slr0_52 = _RAND_1154[63:0];
  _RAND_1155 = {2{`RANDOM}};
  uram_addr_a_02_slr0_53 = _RAND_1155[63:0];
  _RAND_1156 = {2{`RANDOM}};
  uram_addr_a_02_slr0_54 = _RAND_1156[63:0];
  _RAND_1157 = {2{`RANDOM}};
  uram_addr_a_02_slr0_55 = _RAND_1157[63:0];
  _RAND_1158 = {2{`RANDOM}};
  uram_addr_a_02_slr0_56 = _RAND_1158[63:0];
  _RAND_1159 = {2{`RANDOM}};
  uram_addr_a_02_slr0_57 = _RAND_1159[63:0];
  _RAND_1160 = {2{`RANDOM}};
  uram_addr_a_02_slr0_58 = _RAND_1160[63:0];
  _RAND_1161 = {2{`RANDOM}};
  uram_addr_a_02_slr0_59 = _RAND_1161[63:0];
  _RAND_1162 = {2{`RANDOM}};
  uram_addr_a_02_slr0_60 = _RAND_1162[63:0];
  _RAND_1163 = {2{`RANDOM}};
  uram_addr_a_02_slr0_61 = _RAND_1163[63:0];
  _RAND_1164 = {2{`RANDOM}};
  uram_addr_a_02_slr0_62 = _RAND_1164[63:0];
  _RAND_1165 = {2{`RANDOM}};
  uram_addr_a_02_slr0_63 = _RAND_1165[63:0];
  _RAND_1166 = {2{`RANDOM}};
  uram_addr_a_02_slr0_64 = _RAND_1166[63:0];
  _RAND_1167 = {2{`RANDOM}};
  uram_addr_a_02_slr0_65 = _RAND_1167[63:0];
  _RAND_1168 = {2{`RANDOM}};
  uram_addr_a_02_slr0_66 = _RAND_1168[63:0];
  _RAND_1169 = {2{`RANDOM}};
  uram_addr_a_02_slr0_67 = _RAND_1169[63:0];
  _RAND_1170 = {2{`RANDOM}};
  uram_addr_a_02_slr0_68 = _RAND_1170[63:0];
  _RAND_1171 = {2{`RANDOM}};
  uram_addr_a_02_slr0_69 = _RAND_1171[63:0];
  _RAND_1172 = {2{`RANDOM}};
  uram_addr_a_02_slr0_70 = _RAND_1172[63:0];
  _RAND_1173 = {2{`RANDOM}};
  uram_addr_a_02_slr0_71 = _RAND_1173[63:0];
  _RAND_1174 = {2{`RANDOM}};
  uram_addr_a_02_slr1_0 = _RAND_1174[63:0];
  _RAND_1175 = {2{`RANDOM}};
  uram_addr_a_02_slr1_1 = _RAND_1175[63:0];
  _RAND_1176 = {2{`RANDOM}};
  uram_addr_a_02_slr1_2 = _RAND_1176[63:0];
  _RAND_1177 = {2{`RANDOM}};
  uram_addr_a_02_slr1_3 = _RAND_1177[63:0];
  _RAND_1178 = {2{`RANDOM}};
  uram_addr_a_02_slr1_4 = _RAND_1178[63:0];
  _RAND_1179 = {2{`RANDOM}};
  uram_addr_a_02_slr1_5 = _RAND_1179[63:0];
  _RAND_1180 = {2{`RANDOM}};
  uram_addr_a_02_slr1_6 = _RAND_1180[63:0];
  _RAND_1181 = {2{`RANDOM}};
  uram_addr_a_02_slr1_7 = _RAND_1181[63:0];
  _RAND_1182 = {2{`RANDOM}};
  uram_addr_a_02_slr1_8 = _RAND_1182[63:0];
  _RAND_1183 = {2{`RANDOM}};
  uram_addr_a_02_slr1_9 = _RAND_1183[63:0];
  _RAND_1184 = {2{`RANDOM}};
  uram_addr_a_02_slr1_10 = _RAND_1184[63:0];
  _RAND_1185 = {2{`RANDOM}};
  uram_addr_a_02_slr1_11 = _RAND_1185[63:0];
  _RAND_1186 = {2{`RANDOM}};
  uram_addr_a_02_slr1_12 = _RAND_1186[63:0];
  _RAND_1187 = {2{`RANDOM}};
  uram_addr_a_02_slr1_13 = _RAND_1187[63:0];
  _RAND_1188 = {2{`RANDOM}};
  uram_addr_a_02_slr1_14 = _RAND_1188[63:0];
  _RAND_1189 = {2{`RANDOM}};
  uram_addr_a_02_slr1_15 = _RAND_1189[63:0];
  _RAND_1190 = {2{`RANDOM}};
  uram_addr_a_02_slr1_16 = _RAND_1190[63:0];
  _RAND_1191 = {2{`RANDOM}};
  uram_addr_a_02_slr1_17 = _RAND_1191[63:0];
  _RAND_1192 = {2{`RANDOM}};
  uram_addr_a_02_slr1_18 = _RAND_1192[63:0];
  _RAND_1193 = {2{`RANDOM}};
  uram_addr_a_02_slr1_19 = _RAND_1193[63:0];
  _RAND_1194 = {2{`RANDOM}};
  uram_addr_a_02_slr1_20 = _RAND_1194[63:0];
  _RAND_1195 = {2{`RANDOM}};
  uram_addr_a_02_slr1_21 = _RAND_1195[63:0];
  _RAND_1196 = {2{`RANDOM}};
  uram_addr_a_02_slr1_22 = _RAND_1196[63:0];
  _RAND_1197 = {2{`RANDOM}};
  uram_addr_a_02_slr1_23 = _RAND_1197[63:0];
  _RAND_1198 = {2{`RANDOM}};
  uram_addr_a_02_slr1_24 = _RAND_1198[63:0];
  _RAND_1199 = {2{`RANDOM}};
  uram_addr_a_02_slr1_25 = _RAND_1199[63:0];
  _RAND_1200 = {2{`RANDOM}};
  uram_addr_a_02_slr1_26 = _RAND_1200[63:0];
  _RAND_1201 = {2{`RANDOM}};
  uram_addr_a_02_slr1_27 = _RAND_1201[63:0];
  _RAND_1202 = {2{`RANDOM}};
  uram_addr_a_02_slr1_28 = _RAND_1202[63:0];
  _RAND_1203 = {2{`RANDOM}};
  uram_addr_a_02_slr1_29 = _RAND_1203[63:0];
  _RAND_1204 = {2{`RANDOM}};
  uram_addr_a_02_slr1_30 = _RAND_1204[63:0];
  _RAND_1205 = {2{`RANDOM}};
  uram_addr_a_02_slr1_31 = _RAND_1205[63:0];
  _RAND_1206 = {2{`RANDOM}};
  uram_addr_a_02_slr1_32 = _RAND_1206[63:0];
  _RAND_1207 = {2{`RANDOM}};
  uram_addr_a_02_slr1_33 = _RAND_1207[63:0];
  _RAND_1208 = {2{`RANDOM}};
  uram_addr_a_02_slr1_34 = _RAND_1208[63:0];
  _RAND_1209 = {2{`RANDOM}};
  uram_addr_a_02_slr1_35 = _RAND_1209[63:0];
  _RAND_1210 = {2{`RANDOM}};
  uram_addr_a_02_slr1_36 = _RAND_1210[63:0];
  _RAND_1211 = {2{`RANDOM}};
  uram_addr_a_02_slr1_37 = _RAND_1211[63:0];
  _RAND_1212 = {2{`RANDOM}};
  uram_addr_a_02_slr1_38 = _RAND_1212[63:0];
  _RAND_1213 = {2{`RANDOM}};
  uram_addr_a_02_slr1_39 = _RAND_1213[63:0];
  _RAND_1214 = {2{`RANDOM}};
  uram_addr_a_02_slr1_40 = _RAND_1214[63:0];
  _RAND_1215 = {2{`RANDOM}};
  uram_addr_a_02_slr1_41 = _RAND_1215[63:0];
  _RAND_1216 = {2{`RANDOM}};
  uram_addr_a_02_slr1_42 = _RAND_1216[63:0];
  _RAND_1217 = {2{`RANDOM}};
  uram_addr_a_02_slr1_43 = _RAND_1217[63:0];
  _RAND_1218 = {2{`RANDOM}};
  uram_addr_a_02_slr1_44 = _RAND_1218[63:0];
  _RAND_1219 = {2{`RANDOM}};
  uram_addr_a_02_slr1_45 = _RAND_1219[63:0];
  _RAND_1220 = {2{`RANDOM}};
  uram_addr_a_02_slr1_46 = _RAND_1220[63:0];
  _RAND_1221 = {2{`RANDOM}};
  uram_addr_a_02_slr1_47 = _RAND_1221[63:0];
  _RAND_1222 = {2{`RANDOM}};
  uram_addr_a_02_slr1_48 = _RAND_1222[63:0];
  _RAND_1223 = {2{`RANDOM}};
  uram_addr_a_02_slr1_49 = _RAND_1223[63:0];
  _RAND_1224 = {2{`RANDOM}};
  uram_addr_a_02_slr1_50 = _RAND_1224[63:0];
  _RAND_1225 = {2{`RANDOM}};
  uram_addr_a_02_slr1_51 = _RAND_1225[63:0];
  _RAND_1226 = {2{`RANDOM}};
  uram_addr_a_02_slr1_52 = _RAND_1226[63:0];
  _RAND_1227 = {2{`RANDOM}};
  uram_addr_a_02_slr1_53 = _RAND_1227[63:0];
  _RAND_1228 = {2{`RANDOM}};
  uram_addr_a_02_slr1_54 = _RAND_1228[63:0];
  _RAND_1229 = {2{`RANDOM}};
  uram_addr_a_02_slr1_55 = _RAND_1229[63:0];
  _RAND_1230 = {2{`RANDOM}};
  uram_addr_a_02_slr1_56 = _RAND_1230[63:0];
  _RAND_1231 = {2{`RANDOM}};
  uram_addr_a_02_slr1_57 = _RAND_1231[63:0];
  _RAND_1232 = {2{`RANDOM}};
  uram_addr_a_02_slr1_58 = _RAND_1232[63:0];
  _RAND_1233 = {2{`RANDOM}};
  uram_addr_a_02_slr1_59 = _RAND_1233[63:0];
  _RAND_1234 = {2{`RANDOM}};
  uram_addr_a_02_slr1_60 = _RAND_1234[63:0];
  _RAND_1235 = {2{`RANDOM}};
  uram_addr_a_02_slr1_61 = _RAND_1235[63:0];
  _RAND_1236 = {2{`RANDOM}};
  uram_addr_a_02_slr1_62 = _RAND_1236[63:0];
  _RAND_1237 = {2{`RANDOM}};
  uram_addr_a_02_slr1_63 = _RAND_1237[63:0];
  _RAND_1238 = {2{`RANDOM}};
  uram_addr_a_02_slr1_64 = _RAND_1238[63:0];
  _RAND_1239 = {2{`RANDOM}};
  uram_addr_a_02_slr1_65 = _RAND_1239[63:0];
  _RAND_1240 = {2{`RANDOM}};
  uram_addr_a_02_slr1_66 = _RAND_1240[63:0];
  _RAND_1241 = {2{`RANDOM}};
  uram_addr_a_02_slr1_67 = _RAND_1241[63:0];
  _RAND_1242 = {2{`RANDOM}};
  uram_addr_a_02_slr1_68 = _RAND_1242[63:0];
  _RAND_1243 = {2{`RANDOM}};
  uram_addr_a_02_slr1_69 = _RAND_1243[63:0];
  _RAND_1244 = {2{`RANDOM}};
  uram_addr_a_02_slr1_70 = _RAND_1244[63:0];
  _RAND_1245 = {2{`RANDOM}};
  uram_addr_a_02_slr1_71 = _RAND_1245[63:0];
  _RAND_1246 = {2{`RANDOM}};
  uram_addr_a_02_slr2_0 = _RAND_1246[63:0];
  _RAND_1247 = {2{`RANDOM}};
  uram_addr_a_02_slr2_1 = _RAND_1247[63:0];
  _RAND_1248 = {2{`RANDOM}};
  uram_addr_a_02_slr2_2 = _RAND_1248[63:0];
  _RAND_1249 = {2{`RANDOM}};
  uram_addr_a_02_slr2_3 = _RAND_1249[63:0];
  _RAND_1250 = {2{`RANDOM}};
  uram_addr_a_02_slr2_4 = _RAND_1250[63:0];
  _RAND_1251 = {2{`RANDOM}};
  uram_addr_a_02_slr2_5 = _RAND_1251[63:0];
  _RAND_1252 = {2{`RANDOM}};
  uram_addr_a_02_slr2_6 = _RAND_1252[63:0];
  _RAND_1253 = {2{`RANDOM}};
  uram_addr_a_02_slr2_7 = _RAND_1253[63:0];
  _RAND_1254 = {2{`RANDOM}};
  uram_addr_a_02_slr2_8 = _RAND_1254[63:0];
  _RAND_1255 = {2{`RANDOM}};
  uram_addr_a_02_slr2_9 = _RAND_1255[63:0];
  _RAND_1256 = {2{`RANDOM}};
  uram_addr_a_02_slr2_10 = _RAND_1256[63:0];
  _RAND_1257 = {2{`RANDOM}};
  uram_addr_a_02_slr2_11 = _RAND_1257[63:0];
  _RAND_1258 = {2{`RANDOM}};
  uram_addr_a_02_slr2_12 = _RAND_1258[63:0];
  _RAND_1259 = {2{`RANDOM}};
  uram_addr_a_02_slr2_13 = _RAND_1259[63:0];
  _RAND_1260 = {2{`RANDOM}};
  uram_addr_a_02_slr2_14 = _RAND_1260[63:0];
  _RAND_1261 = {2{`RANDOM}};
  uram_addr_a_02_slr2_15 = _RAND_1261[63:0];
  _RAND_1262 = {2{`RANDOM}};
  uram_addr_a_02_slr2_16 = _RAND_1262[63:0];
  _RAND_1263 = {2{`RANDOM}};
  uram_addr_a_02_slr2_17 = _RAND_1263[63:0];
  _RAND_1264 = {2{`RANDOM}};
  uram_addr_a_02_slr2_18 = _RAND_1264[63:0];
  _RAND_1265 = {2{`RANDOM}};
  uram_addr_a_02_slr2_19 = _RAND_1265[63:0];
  _RAND_1266 = {2{`RANDOM}};
  uram_addr_a_02_slr2_20 = _RAND_1266[63:0];
  _RAND_1267 = {2{`RANDOM}};
  uram_addr_a_02_slr2_21 = _RAND_1267[63:0];
  _RAND_1268 = {2{`RANDOM}};
  uram_addr_a_02_slr2_22 = _RAND_1268[63:0];
  _RAND_1269 = {2{`RANDOM}};
  uram_addr_a_02_slr2_23 = _RAND_1269[63:0];
  _RAND_1270 = {2{`RANDOM}};
  uram_addr_a_02_slr2_24 = _RAND_1270[63:0];
  _RAND_1271 = {2{`RANDOM}};
  uram_addr_a_02_slr2_25 = _RAND_1271[63:0];
  _RAND_1272 = {2{`RANDOM}};
  uram_addr_a_02_slr2_26 = _RAND_1272[63:0];
  _RAND_1273 = {2{`RANDOM}};
  uram_addr_a_02_slr2_27 = _RAND_1273[63:0];
  _RAND_1274 = {2{`RANDOM}};
  uram_addr_a_02_slr2_28 = _RAND_1274[63:0];
  _RAND_1275 = {2{`RANDOM}};
  uram_addr_a_02_slr2_29 = _RAND_1275[63:0];
  _RAND_1276 = {2{`RANDOM}};
  uram_addr_a_02_slr2_30 = _RAND_1276[63:0];
  _RAND_1277 = {2{`RANDOM}};
  uram_addr_a_02_slr2_31 = _RAND_1277[63:0];
  _RAND_1278 = {2{`RANDOM}};
  uram_addr_a_02_slr2_32 = _RAND_1278[63:0];
  _RAND_1279 = {2{`RANDOM}};
  uram_addr_a_02_slr2_33 = _RAND_1279[63:0];
  _RAND_1280 = {2{`RANDOM}};
  uram_addr_a_02_slr2_34 = _RAND_1280[63:0];
  _RAND_1281 = {2{`RANDOM}};
  uram_addr_a_02_slr2_35 = _RAND_1281[63:0];
  _RAND_1282 = {2{`RANDOM}};
  uram_addr_a_02_slr2_36 = _RAND_1282[63:0];
  _RAND_1283 = {2{`RANDOM}};
  uram_addr_a_02_slr2_37 = _RAND_1283[63:0];
  _RAND_1284 = {2{`RANDOM}};
  uram_addr_a_02_slr2_38 = _RAND_1284[63:0];
  _RAND_1285 = {2{`RANDOM}};
  uram_addr_a_02_slr2_39 = _RAND_1285[63:0];
  _RAND_1286 = {2{`RANDOM}};
  uram_addr_a_02_slr2_40 = _RAND_1286[63:0];
  _RAND_1287 = {2{`RANDOM}};
  uram_addr_a_02_slr2_41 = _RAND_1287[63:0];
  _RAND_1288 = {2{`RANDOM}};
  uram_addr_a_02_slr2_42 = _RAND_1288[63:0];
  _RAND_1289 = {2{`RANDOM}};
  uram_addr_a_02_slr2_43 = _RAND_1289[63:0];
  _RAND_1290 = {2{`RANDOM}};
  uram_addr_a_02_slr2_44 = _RAND_1290[63:0];
  _RAND_1291 = {2{`RANDOM}};
  uram_addr_a_02_slr2_45 = _RAND_1291[63:0];
  _RAND_1292 = {2{`RANDOM}};
  uram_addr_a_02_slr2_46 = _RAND_1292[63:0];
  _RAND_1293 = {2{`RANDOM}};
  uram_addr_a_02_slr2_47 = _RAND_1293[63:0];
  _RAND_1294 = {2{`RANDOM}};
  uram_addr_a_02_slr2_48 = _RAND_1294[63:0];
  _RAND_1295 = {2{`RANDOM}};
  uram_addr_a_02_slr2_49 = _RAND_1295[63:0];
  _RAND_1296 = {2{`RANDOM}};
  uram_addr_a_02_slr2_50 = _RAND_1296[63:0];
  _RAND_1297 = {2{`RANDOM}};
  uram_addr_a_02_slr2_51 = _RAND_1297[63:0];
  _RAND_1298 = {2{`RANDOM}};
  uram_addr_a_02_slr2_52 = _RAND_1298[63:0];
  _RAND_1299 = {2{`RANDOM}};
  uram_addr_a_02_slr2_53 = _RAND_1299[63:0];
  _RAND_1300 = {2{`RANDOM}};
  uram_addr_a_02_slr2_54 = _RAND_1300[63:0];
  _RAND_1301 = {2{`RANDOM}};
  uram_addr_a_02_slr2_55 = _RAND_1301[63:0];
  _RAND_1302 = {2{`RANDOM}};
  uram_addr_a_02_slr2_56 = _RAND_1302[63:0];
  _RAND_1303 = {2{`RANDOM}};
  uram_addr_a_02_slr2_57 = _RAND_1303[63:0];
  _RAND_1304 = {2{`RANDOM}};
  uram_addr_a_02_slr2_58 = _RAND_1304[63:0];
  _RAND_1305 = {2{`RANDOM}};
  uram_addr_a_02_slr2_59 = _RAND_1305[63:0];
  _RAND_1306 = {2{`RANDOM}};
  uram_addr_a_02_slr2_60 = _RAND_1306[63:0];
  _RAND_1307 = {2{`RANDOM}};
  uram_addr_a_02_slr2_61 = _RAND_1307[63:0];
  _RAND_1308 = {2{`RANDOM}};
  uram_addr_a_02_slr2_62 = _RAND_1308[63:0];
  _RAND_1309 = {2{`RANDOM}};
  uram_addr_a_02_slr2_63 = _RAND_1309[63:0];
  _RAND_1310 = {2{`RANDOM}};
  uram_addr_a_02_slr2_64 = _RAND_1310[63:0];
  _RAND_1311 = {2{`RANDOM}};
  uram_addr_a_02_slr2_65 = _RAND_1311[63:0];
  _RAND_1312 = {2{`RANDOM}};
  uram_addr_a_02_slr2_66 = _RAND_1312[63:0];
  _RAND_1313 = {2{`RANDOM}};
  uram_addr_a_02_slr2_67 = _RAND_1313[63:0];
  _RAND_1314 = {2{`RANDOM}};
  uram_addr_a_02_slr2_68 = _RAND_1314[63:0];
  _RAND_1315 = {2{`RANDOM}};
  uram_addr_a_02_slr2_69 = _RAND_1315[63:0];
  _RAND_1316 = {2{`RANDOM}};
  uram_addr_a_02_slr2_70 = _RAND_1316[63:0];
  _RAND_1317 = {2{`RANDOM}};
  uram_addr_a_02_slr2_71 = _RAND_1317[63:0];
  _RAND_1318 = {1{`RANDOM}};
  _T_881 = _RAND_1318[0:0];
  _RAND_1319 = {1{`RANDOM}};
  _T_882 = _RAND_1319[0:0];
  _RAND_1320 = {1{`RANDOM}};
  _T_883 = _RAND_1320[0:0];
  _RAND_1321 = {1{`RANDOM}};
  _T_887 = _RAND_1321[0:0];
  _RAND_1322 = {1{`RANDOM}};
  _T_888 = _RAND_1322[0:0];
  _RAND_1323 = {1{`RANDOM}};
  _T_889 = _RAND_1323[0:0];
  _RAND_1324 = {1{`RANDOM}};
  _T_893 = _RAND_1324[0:0];
  _RAND_1325 = {1{`RANDOM}};
  _T_894 = _RAND_1325[0:0];
  _RAND_1326 = {1{`RANDOM}};
  _T_895 = _RAND_1326[0:0];
  _RAND_1327 = {1{`RANDOM}};
  _T_899 = _RAND_1327[0:0];
  _RAND_1328 = {1{`RANDOM}};
  _T_900 = _RAND_1328[0:0];
  _RAND_1329 = {1{`RANDOM}};
  _T_901 = _RAND_1329[0:0];
  _RAND_1330 = {1{`RANDOM}};
  _T_905 = _RAND_1330[0:0];
  _RAND_1331 = {1{`RANDOM}};
  _T_906 = _RAND_1331[0:0];
  _RAND_1332 = {1{`RANDOM}};
  _T_907 = _RAND_1332[0:0];
  _RAND_1333 = {1{`RANDOM}};
  _T_911 = _RAND_1333[0:0];
  _RAND_1334 = {1{`RANDOM}};
  _T_912 = _RAND_1334[0:0];
  _RAND_1335 = {1{`RANDOM}};
  _T_913 = _RAND_1335[0:0];
  _RAND_1336 = {1{`RANDOM}};
  _T_917 = _RAND_1336[0:0];
  _RAND_1337 = {1{`RANDOM}};
  _T_918 = _RAND_1337[0:0];
  _RAND_1338 = {1{`RANDOM}};
  _T_919 = _RAND_1338[0:0];
  _RAND_1339 = {1{`RANDOM}};
  _T_923 = _RAND_1339[0:0];
  _RAND_1340 = {1{`RANDOM}};
  _T_924 = _RAND_1340[0:0];
  _RAND_1341 = {1{`RANDOM}};
  _T_925 = _RAND_1341[0:0];
  _RAND_1342 = {1{`RANDOM}};
  _T_929 = _RAND_1342[0:0];
  _RAND_1343 = {1{`RANDOM}};
  _T_930 = _RAND_1343[0:0];
  _RAND_1344 = {1{`RANDOM}};
  _T_931 = _RAND_1344[0:0];
  _RAND_1345 = {1{`RANDOM}};
  _T_935 = _RAND_1345[0:0];
  _RAND_1346 = {1{`RANDOM}};
  _T_936 = _RAND_1346[0:0];
  _RAND_1347 = {1{`RANDOM}};
  _T_937 = _RAND_1347[0:0];
  _RAND_1348 = {1{`RANDOM}};
  _T_941 = _RAND_1348[0:0];
  _RAND_1349 = {1{`RANDOM}};
  _T_942 = _RAND_1349[0:0];
  _RAND_1350 = {1{`RANDOM}};
  _T_943 = _RAND_1350[0:0];
  _RAND_1351 = {1{`RANDOM}};
  _T_947 = _RAND_1351[0:0];
  _RAND_1352 = {1{`RANDOM}};
  _T_948 = _RAND_1352[0:0];
  _RAND_1353 = {1{`RANDOM}};
  _T_949 = _RAND_1353[0:0];
  _RAND_1354 = {1{`RANDOM}};
  _T_953 = _RAND_1354[0:0];
  _RAND_1355 = {1{`RANDOM}};
  _T_954 = _RAND_1355[0:0];
  _RAND_1356 = {1{`RANDOM}};
  _T_955 = _RAND_1356[0:0];
  _RAND_1357 = {1{`RANDOM}};
  _T_959 = _RAND_1357[0:0];
  _RAND_1358 = {1{`RANDOM}};
  _T_960 = _RAND_1358[0:0];
  _RAND_1359 = {1{`RANDOM}};
  _T_961 = _RAND_1359[0:0];
  _RAND_1360 = {1{`RANDOM}};
  _T_965 = _RAND_1360[0:0];
  _RAND_1361 = {1{`RANDOM}};
  _T_966 = _RAND_1361[0:0];
  _RAND_1362 = {1{`RANDOM}};
  _T_967 = _RAND_1362[0:0];
  _RAND_1363 = {1{`RANDOM}};
  _T_971 = _RAND_1363[0:0];
  _RAND_1364 = {1{`RANDOM}};
  _T_972 = _RAND_1364[0:0];
  _RAND_1365 = {1{`RANDOM}};
  _T_973 = _RAND_1365[0:0];
  _RAND_1366 = {1{`RANDOM}};
  _T_977 = _RAND_1366[0:0];
  _RAND_1367 = {1{`RANDOM}};
  _T_978 = _RAND_1367[0:0];
  _RAND_1368 = {1{`RANDOM}};
  _T_979 = _RAND_1368[0:0];
  _RAND_1369 = {1{`RANDOM}};
  _T_983 = _RAND_1369[0:0];
  _RAND_1370 = {1{`RANDOM}};
  _T_984 = _RAND_1370[0:0];
  _RAND_1371 = {1{`RANDOM}};
  _T_985 = _RAND_1371[0:0];
  _RAND_1372 = {1{`RANDOM}};
  _T_989 = _RAND_1372[0:0];
  _RAND_1373 = {1{`RANDOM}};
  _T_990 = _RAND_1373[0:0];
  _RAND_1374 = {1{`RANDOM}};
  _T_991 = _RAND_1374[0:0];
  _RAND_1375 = {1{`RANDOM}};
  _T_995 = _RAND_1375[0:0];
  _RAND_1376 = {1{`RANDOM}};
  _T_996 = _RAND_1376[0:0];
  _RAND_1377 = {1{`RANDOM}};
  _T_997 = _RAND_1377[0:0];
  _RAND_1378 = {1{`RANDOM}};
  _T_1001 = _RAND_1378[0:0];
  _RAND_1379 = {1{`RANDOM}};
  _T_1002 = _RAND_1379[0:0];
  _RAND_1380 = {1{`RANDOM}};
  _T_1003 = _RAND_1380[0:0];
  _RAND_1381 = {1{`RANDOM}};
  _T_1007 = _RAND_1381[0:0];
  _RAND_1382 = {1{`RANDOM}};
  _T_1008 = _RAND_1382[0:0];
  _RAND_1383 = {1{`RANDOM}};
  _T_1009 = _RAND_1383[0:0];
  _RAND_1384 = {1{`RANDOM}};
  _T_1013 = _RAND_1384[0:0];
  _RAND_1385 = {1{`RANDOM}};
  _T_1014 = _RAND_1385[0:0];
  _RAND_1386 = {1{`RANDOM}};
  _T_1015 = _RAND_1386[0:0];
  _RAND_1387 = {1{`RANDOM}};
  _T_1019 = _RAND_1387[0:0];
  _RAND_1388 = {1{`RANDOM}};
  _T_1020 = _RAND_1388[0:0];
  _RAND_1389 = {1{`RANDOM}};
  _T_1021 = _RAND_1389[0:0];
  _RAND_1390 = {1{`RANDOM}};
  _T_1025 = _RAND_1390[0:0];
  _RAND_1391 = {1{`RANDOM}};
  _T_1026 = _RAND_1391[0:0];
  _RAND_1392 = {1{`RANDOM}};
  _T_1027 = _RAND_1392[0:0];
  _RAND_1393 = {1{`RANDOM}};
  _T_1031 = _RAND_1393[0:0];
  _RAND_1394 = {1{`RANDOM}};
  _T_1032 = _RAND_1394[0:0];
  _RAND_1395 = {1{`RANDOM}};
  _T_1033 = _RAND_1395[0:0];
  _RAND_1396 = {1{`RANDOM}};
  _T_1037 = _RAND_1396[0:0];
  _RAND_1397 = {1{`RANDOM}};
  _T_1038 = _RAND_1397[0:0];
  _RAND_1398 = {1{`RANDOM}};
  _T_1039 = _RAND_1398[0:0];
  _RAND_1399 = {1{`RANDOM}};
  _T_1043 = _RAND_1399[0:0];
  _RAND_1400 = {1{`RANDOM}};
  _T_1044 = _RAND_1400[0:0];
  _RAND_1401 = {1{`RANDOM}};
  _T_1045 = _RAND_1401[0:0];
  _RAND_1402 = {1{`RANDOM}};
  _T_1049 = _RAND_1402[0:0];
  _RAND_1403 = {1{`RANDOM}};
  _T_1050 = _RAND_1403[0:0];
  _RAND_1404 = {1{`RANDOM}};
  _T_1051 = _RAND_1404[0:0];
  _RAND_1405 = {1{`RANDOM}};
  _T_1055 = _RAND_1405[0:0];
  _RAND_1406 = {1{`RANDOM}};
  _T_1056 = _RAND_1406[0:0];
  _RAND_1407 = {1{`RANDOM}};
  _T_1057 = _RAND_1407[0:0];
  _RAND_1408 = {1{`RANDOM}};
  _T_1061 = _RAND_1408[0:0];
  _RAND_1409 = {1{`RANDOM}};
  _T_1062 = _RAND_1409[0:0];
  _RAND_1410 = {1{`RANDOM}};
  _T_1063 = _RAND_1410[0:0];
  _RAND_1411 = {1{`RANDOM}};
  _T_1067 = _RAND_1411[0:0];
  _RAND_1412 = {1{`RANDOM}};
  _T_1068 = _RAND_1412[0:0];
  _RAND_1413 = {1{`RANDOM}};
  _T_1069 = _RAND_1413[0:0];
  _RAND_1414 = {1{`RANDOM}};
  _T_1073 = _RAND_1414[0:0];
  _RAND_1415 = {1{`RANDOM}};
  _T_1074 = _RAND_1415[0:0];
  _RAND_1416 = {1{`RANDOM}};
  _T_1075 = _RAND_1416[0:0];
  _RAND_1417 = {1{`RANDOM}};
  _T_1079 = _RAND_1417[0:0];
  _RAND_1418 = {1{`RANDOM}};
  _T_1080 = _RAND_1418[0:0];
  _RAND_1419 = {1{`RANDOM}};
  _T_1081 = _RAND_1419[0:0];
  _RAND_1420 = {1{`RANDOM}};
  _T_1085 = _RAND_1420[0:0];
  _RAND_1421 = {1{`RANDOM}};
  _T_1086 = _RAND_1421[0:0];
  _RAND_1422 = {1{`RANDOM}};
  _T_1087 = _RAND_1422[0:0];
  _RAND_1423 = {1{`RANDOM}};
  _T_1091 = _RAND_1423[0:0];
  _RAND_1424 = {1{`RANDOM}};
  _T_1092 = _RAND_1424[0:0];
  _RAND_1425 = {1{`RANDOM}};
  _T_1093 = _RAND_1425[0:0];
  _RAND_1426 = {1{`RANDOM}};
  _T_1097 = _RAND_1426[0:0];
  _RAND_1427 = {1{`RANDOM}};
  _T_1098 = _RAND_1427[0:0];
  _RAND_1428 = {1{`RANDOM}};
  _T_1099 = _RAND_1428[0:0];
  _RAND_1429 = {1{`RANDOM}};
  _T_1103 = _RAND_1429[0:0];
  _RAND_1430 = {1{`RANDOM}};
  _T_1104 = _RAND_1430[0:0];
  _RAND_1431 = {1{`RANDOM}};
  _T_1105 = _RAND_1431[0:0];
  _RAND_1432 = {1{`RANDOM}};
  _T_1109 = _RAND_1432[0:0];
  _RAND_1433 = {1{`RANDOM}};
  _T_1110 = _RAND_1433[0:0];
  _RAND_1434 = {1{`RANDOM}};
  _T_1111 = _RAND_1434[0:0];
  _RAND_1435 = {1{`RANDOM}};
  _T_1115 = _RAND_1435[0:0];
  _RAND_1436 = {1{`RANDOM}};
  _T_1116 = _RAND_1436[0:0];
  _RAND_1437 = {1{`RANDOM}};
  _T_1117 = _RAND_1437[0:0];
  _RAND_1438 = {1{`RANDOM}};
  _T_1121 = _RAND_1438[0:0];
  _RAND_1439 = {1{`RANDOM}};
  _T_1122 = _RAND_1439[0:0];
  _RAND_1440 = {1{`RANDOM}};
  _T_1123 = _RAND_1440[0:0];
  _RAND_1441 = {1{`RANDOM}};
  _T_1127 = _RAND_1441[0:0];
  _RAND_1442 = {1{`RANDOM}};
  _T_1128 = _RAND_1442[0:0];
  _RAND_1443 = {1{`RANDOM}};
  _T_1129 = _RAND_1443[0:0];
  _RAND_1444 = {1{`RANDOM}};
  _T_1133 = _RAND_1444[0:0];
  _RAND_1445 = {1{`RANDOM}};
  _T_1134 = _RAND_1445[0:0];
  _RAND_1446 = {1{`RANDOM}};
  _T_1135 = _RAND_1446[0:0];
  _RAND_1447 = {1{`RANDOM}};
  _T_1139 = _RAND_1447[0:0];
  _RAND_1448 = {1{`RANDOM}};
  _T_1140 = _RAND_1448[0:0];
  _RAND_1449 = {1{`RANDOM}};
  _T_1141 = _RAND_1449[0:0];
  _RAND_1450 = {1{`RANDOM}};
  _T_1145 = _RAND_1450[0:0];
  _RAND_1451 = {1{`RANDOM}};
  _T_1146 = _RAND_1451[0:0];
  _RAND_1452 = {1{`RANDOM}};
  _T_1147 = _RAND_1452[0:0];
  _RAND_1453 = {1{`RANDOM}};
  _T_1151 = _RAND_1453[0:0];
  _RAND_1454 = {1{`RANDOM}};
  _T_1152 = _RAND_1454[0:0];
  _RAND_1455 = {1{`RANDOM}};
  _T_1153 = _RAND_1455[0:0];
  _RAND_1456 = {1{`RANDOM}};
  _T_1157 = _RAND_1456[0:0];
  _RAND_1457 = {1{`RANDOM}};
  _T_1158 = _RAND_1457[0:0];
  _RAND_1458 = {1{`RANDOM}};
  _T_1159 = _RAND_1458[0:0];
  _RAND_1459 = {1{`RANDOM}};
  _T_1163 = _RAND_1459[0:0];
  _RAND_1460 = {1{`RANDOM}};
  _T_1164 = _RAND_1460[0:0];
  _RAND_1461 = {1{`RANDOM}};
  _T_1165 = _RAND_1461[0:0];
  _RAND_1462 = {1{`RANDOM}};
  _T_1169 = _RAND_1462[0:0];
  _RAND_1463 = {1{`RANDOM}};
  _T_1170 = _RAND_1463[0:0];
  _RAND_1464 = {1{`RANDOM}};
  _T_1171 = _RAND_1464[0:0];
  _RAND_1465 = {1{`RANDOM}};
  _T_1175 = _RAND_1465[0:0];
  _RAND_1466 = {1{`RANDOM}};
  _T_1176 = _RAND_1466[0:0];
  _RAND_1467 = {1{`RANDOM}};
  _T_1177 = _RAND_1467[0:0];
  _RAND_1468 = {1{`RANDOM}};
  _T_1181 = _RAND_1468[0:0];
  _RAND_1469 = {1{`RANDOM}};
  _T_1182 = _RAND_1469[0:0];
  _RAND_1470 = {1{`RANDOM}};
  _T_1183 = _RAND_1470[0:0];
  _RAND_1471 = {1{`RANDOM}};
  _T_1187 = _RAND_1471[0:0];
  _RAND_1472 = {1{`RANDOM}};
  _T_1188 = _RAND_1472[0:0];
  _RAND_1473 = {1{`RANDOM}};
  _T_1189 = _RAND_1473[0:0];
  _RAND_1474 = {1{`RANDOM}};
  _T_1193 = _RAND_1474[0:0];
  _RAND_1475 = {1{`RANDOM}};
  _T_1194 = _RAND_1475[0:0];
  _RAND_1476 = {1{`RANDOM}};
  _T_1195 = _RAND_1476[0:0];
  _RAND_1477 = {1{`RANDOM}};
  _T_1199 = _RAND_1477[0:0];
  _RAND_1478 = {1{`RANDOM}};
  _T_1200 = _RAND_1478[0:0];
  _RAND_1479 = {1{`RANDOM}};
  _T_1201 = _RAND_1479[0:0];
  _RAND_1480 = {1{`RANDOM}};
  _T_1205 = _RAND_1480[0:0];
  _RAND_1481 = {1{`RANDOM}};
  _T_1206 = _RAND_1481[0:0];
  _RAND_1482 = {1{`RANDOM}};
  _T_1207 = _RAND_1482[0:0];
  _RAND_1483 = {1{`RANDOM}};
  _T_1211 = _RAND_1483[0:0];
  _RAND_1484 = {1{`RANDOM}};
  _T_1212 = _RAND_1484[0:0];
  _RAND_1485 = {1{`RANDOM}};
  _T_1213 = _RAND_1485[0:0];
  _RAND_1486 = {1{`RANDOM}};
  _T_1217 = _RAND_1486[0:0];
  _RAND_1487 = {1{`RANDOM}};
  _T_1218 = _RAND_1487[0:0];
  _RAND_1488 = {1{`RANDOM}};
  _T_1219 = _RAND_1488[0:0];
  _RAND_1489 = {1{`RANDOM}};
  _T_1223 = _RAND_1489[0:0];
  _RAND_1490 = {1{`RANDOM}};
  _T_1224 = _RAND_1490[0:0];
  _RAND_1491 = {1{`RANDOM}};
  _T_1225 = _RAND_1491[0:0];
  _RAND_1492 = {1{`RANDOM}};
  _T_1229 = _RAND_1492[0:0];
  _RAND_1493 = {1{`RANDOM}};
  _T_1230 = _RAND_1493[0:0];
  _RAND_1494 = {1{`RANDOM}};
  _T_1231 = _RAND_1494[0:0];
  _RAND_1495 = {1{`RANDOM}};
  _T_1235 = _RAND_1495[0:0];
  _RAND_1496 = {1{`RANDOM}};
  _T_1236 = _RAND_1496[0:0];
  _RAND_1497 = {1{`RANDOM}};
  _T_1237 = _RAND_1497[0:0];
  _RAND_1498 = {1{`RANDOM}};
  _T_1241 = _RAND_1498[0:0];
  _RAND_1499 = {1{`RANDOM}};
  _T_1242 = _RAND_1499[0:0];
  _RAND_1500 = {1{`RANDOM}};
  _T_1243 = _RAND_1500[0:0];
  _RAND_1501 = {1{`RANDOM}};
  _T_1247 = _RAND_1501[0:0];
  _RAND_1502 = {1{`RANDOM}};
  _T_1248 = _RAND_1502[0:0];
  _RAND_1503 = {1{`RANDOM}};
  _T_1249 = _RAND_1503[0:0];
  _RAND_1504 = {1{`RANDOM}};
  _T_1253 = _RAND_1504[0:0];
  _RAND_1505 = {1{`RANDOM}};
  _T_1254 = _RAND_1505[0:0];
  _RAND_1506 = {1{`RANDOM}};
  _T_1255 = _RAND_1506[0:0];
  _RAND_1507 = {1{`RANDOM}};
  _T_1259 = _RAND_1507[0:0];
  _RAND_1508 = {1{`RANDOM}};
  _T_1260 = _RAND_1508[0:0];
  _RAND_1509 = {1{`RANDOM}};
  _T_1261 = _RAND_1509[0:0];
  _RAND_1510 = {1{`RANDOM}};
  _T_1265 = _RAND_1510[0:0];
  _RAND_1511 = {1{`RANDOM}};
  _T_1266 = _RAND_1511[0:0];
  _RAND_1512 = {1{`RANDOM}};
  _T_1267 = _RAND_1512[0:0];
  _RAND_1513 = {1{`RANDOM}};
  _T_1271 = _RAND_1513[0:0];
  _RAND_1514 = {1{`RANDOM}};
  _T_1272 = _RAND_1514[0:0];
  _RAND_1515 = {1{`RANDOM}};
  _T_1273 = _RAND_1515[0:0];
  _RAND_1516 = {1{`RANDOM}};
  _T_1277 = _RAND_1516[0:0];
  _RAND_1517 = {1{`RANDOM}};
  _T_1278 = _RAND_1517[0:0];
  _RAND_1518 = {1{`RANDOM}};
  _T_1279 = _RAND_1518[0:0];
  _RAND_1519 = {1{`RANDOM}};
  _T_1283 = _RAND_1519[0:0];
  _RAND_1520 = {1{`RANDOM}};
  _T_1284 = _RAND_1520[0:0];
  _RAND_1521 = {1{`RANDOM}};
  _T_1285 = _RAND_1521[0:0];
  _RAND_1522 = {1{`RANDOM}};
  _T_1289 = _RAND_1522[0:0];
  _RAND_1523 = {1{`RANDOM}};
  _T_1290 = _RAND_1523[0:0];
  _RAND_1524 = {1{`RANDOM}};
  _T_1291 = _RAND_1524[0:0];
  _RAND_1525 = {1{`RANDOM}};
  _T_1295 = _RAND_1525[0:0];
  _RAND_1526 = {1{`RANDOM}};
  _T_1296 = _RAND_1526[0:0];
  _RAND_1527 = {1{`RANDOM}};
  _T_1297 = _RAND_1527[0:0];
  _RAND_1528 = {1{`RANDOM}};
  _T_1301 = _RAND_1528[0:0];
  _RAND_1529 = {1{`RANDOM}};
  _T_1302 = _RAND_1529[0:0];
  _RAND_1530 = {1{`RANDOM}};
  _T_1303 = _RAND_1530[0:0];
  _RAND_1531 = {1{`RANDOM}};
  _T_1307 = _RAND_1531[0:0];
  _RAND_1532 = {1{`RANDOM}};
  _T_1308 = _RAND_1532[0:0];
  _RAND_1533 = {1{`RANDOM}};
  _T_1309 = _RAND_1533[0:0];
  _RAND_1534 = {1{`RANDOM}};
  r_array_count_2_0 = _RAND_1534[31:0];
  _RAND_1535 = {1{`RANDOM}};
  r_array_count_2_1 = _RAND_1535[31:0];
  _RAND_1536 = {1{`RANDOM}};
  r_array_count_2_2 = _RAND_1536[31:0];
  _RAND_1537 = {1{`RANDOM}};
  r_array_count_2_3 = _RAND_1537[31:0];
  _RAND_1538 = {1{`RANDOM}};
  r_array_count_2_4 = _RAND_1538[31:0];
  _RAND_1539 = {1{`RANDOM}};
  r_array_count_2_5 = _RAND_1539[31:0];
  _RAND_1540 = {1{`RANDOM}};
  r_array_count_2_6 = _RAND_1540[31:0];
  _RAND_1541 = {1{`RANDOM}};
  r_array_count_2_7 = _RAND_1541[31:0];
  _RAND_1542 = {1{`RANDOM}};
  r_array_count_2_8 = _RAND_1542[31:0];
  _RAND_1543 = {1{`RANDOM}};
  r_array_count_2_9 = _RAND_1543[31:0];
  _RAND_1544 = {1{`RANDOM}};
  r_array_count_2_10 = _RAND_1544[31:0];
  _RAND_1545 = {1{`RANDOM}};
  r_array_count_2_11 = _RAND_1545[31:0];
  _RAND_1546 = {1{`RANDOM}};
  r_array_count_2_12 = _RAND_1546[31:0];
  _RAND_1547 = {1{`RANDOM}};
  r_array_count_2_13 = _RAND_1547[31:0];
  _RAND_1548 = {1{`RANDOM}};
  r_array_count_2_14 = _RAND_1548[31:0];
  _RAND_1549 = {1{`RANDOM}};
  r_array_count_2_15 = _RAND_1549[31:0];
  _RAND_1550 = {1{`RANDOM}};
  r_array_count_2_16 = _RAND_1550[31:0];
  _RAND_1551 = {1{`RANDOM}};
  r_array_count_2_17 = _RAND_1551[31:0];
  _RAND_1552 = {1{`RANDOM}};
  r_array_count_2_18 = _RAND_1552[31:0];
  _RAND_1553 = {1{`RANDOM}};
  r_array_count_2_19 = _RAND_1553[31:0];
  _RAND_1554 = {1{`RANDOM}};
  r_array_count_2_20 = _RAND_1554[31:0];
  _RAND_1555 = {1{`RANDOM}};
  r_array_count_2_21 = _RAND_1555[31:0];
  _RAND_1556 = {1{`RANDOM}};
  r_array_count_2_22 = _RAND_1556[31:0];
  _RAND_1557 = {1{`RANDOM}};
  r_array_count_2_23 = _RAND_1557[31:0];
  _RAND_1558 = {1{`RANDOM}};
  r_array_count_2_24 = _RAND_1558[31:0];
  _RAND_1559 = {1{`RANDOM}};
  r_array_count_2_25 = _RAND_1559[31:0];
  _RAND_1560 = {1{`RANDOM}};
  r_array_count_2_26 = _RAND_1560[31:0];
  _RAND_1561 = {1{`RANDOM}};
  r_array_count_2_27 = _RAND_1561[31:0];
  _RAND_1562 = {1{`RANDOM}};
  r_array_count_2_28 = _RAND_1562[31:0];
  _RAND_1563 = {1{`RANDOM}};
  r_array_count_2_29 = _RAND_1563[31:0];
  _RAND_1564 = {1{`RANDOM}};
  r_array_count_2_30 = _RAND_1564[31:0];
  _RAND_1565 = {1{`RANDOM}};
  r_array_count_2_31 = _RAND_1565[31:0];
  _RAND_1566 = {1{`RANDOM}};
  r_array_count_2_32 = _RAND_1566[31:0];
  _RAND_1567 = {1{`RANDOM}};
  r_array_count_2_33 = _RAND_1567[31:0];
  _RAND_1568 = {1{`RANDOM}};
  r_array_count_2_34 = _RAND_1568[31:0];
  _RAND_1569 = {1{`RANDOM}};
  r_array_count_2_35 = _RAND_1569[31:0];
  _RAND_1570 = {1{`RANDOM}};
  r_array_count_2_36 = _RAND_1570[31:0];
  _RAND_1571 = {1{`RANDOM}};
  r_array_count_2_37 = _RAND_1571[31:0];
  _RAND_1572 = {1{`RANDOM}};
  r_array_count_2_38 = _RAND_1572[31:0];
  _RAND_1573 = {1{`RANDOM}};
  r_array_count_2_39 = _RAND_1573[31:0];
  _RAND_1574 = {1{`RANDOM}};
  r_array_count_2_40 = _RAND_1574[31:0];
  _RAND_1575 = {1{`RANDOM}};
  r_array_count_2_41 = _RAND_1575[31:0];
  _RAND_1576 = {1{`RANDOM}};
  r_array_count_2_42 = _RAND_1576[31:0];
  _RAND_1577 = {1{`RANDOM}};
  r_array_count_2_43 = _RAND_1577[31:0];
  _RAND_1578 = {1{`RANDOM}};
  r_array_count_2_44 = _RAND_1578[31:0];
  _RAND_1579 = {1{`RANDOM}};
  r_array_count_2_45 = _RAND_1579[31:0];
  _RAND_1580 = {1{`RANDOM}};
  r_array_count_2_46 = _RAND_1580[31:0];
  _RAND_1581 = {1{`RANDOM}};
  r_array_count_2_47 = _RAND_1581[31:0];
  _RAND_1582 = {1{`RANDOM}};
  r_array_count_2_48 = _RAND_1582[31:0];
  _RAND_1583 = {1{`RANDOM}};
  r_array_count_2_49 = _RAND_1583[31:0];
  _RAND_1584 = {1{`RANDOM}};
  r_array_count_2_50 = _RAND_1584[31:0];
  _RAND_1585 = {1{`RANDOM}};
  r_array_count_2_51 = _RAND_1585[31:0];
  _RAND_1586 = {1{`RANDOM}};
  r_array_count_2_52 = _RAND_1586[31:0];
  _RAND_1587 = {1{`RANDOM}};
  r_array_count_2_53 = _RAND_1587[31:0];
  _RAND_1588 = {1{`RANDOM}};
  r_array_count_2_54 = _RAND_1588[31:0];
  _RAND_1589 = {1{`RANDOM}};
  r_array_count_2_55 = _RAND_1589[31:0];
  _RAND_1590 = {1{`RANDOM}};
  r_array_count_2_56 = _RAND_1590[31:0];
  _RAND_1591 = {1{`RANDOM}};
  r_array_count_2_57 = _RAND_1591[31:0];
  _RAND_1592 = {1{`RANDOM}};
  r_array_count_2_58 = _RAND_1592[31:0];
  _RAND_1593 = {1{`RANDOM}};
  r_array_count_2_59 = _RAND_1593[31:0];
  _RAND_1594 = {1{`RANDOM}};
  r_array_count_2_60 = _RAND_1594[31:0];
  _RAND_1595 = {1{`RANDOM}};
  r_array_count_2_61 = _RAND_1595[31:0];
  _RAND_1596 = {1{`RANDOM}};
  r_array_count_2_62 = _RAND_1596[31:0];
  _RAND_1597 = {1{`RANDOM}};
  r_array_count_2_63 = _RAND_1597[31:0];
  _RAND_1598 = {1{`RANDOM}};
  r_array_count_2_64 = _RAND_1598[31:0];
  _RAND_1599 = {1{`RANDOM}};
  r_array_count_2_65 = _RAND_1599[31:0];
  _RAND_1600 = {1{`RANDOM}};
  r_array_count_2_66 = _RAND_1600[31:0];
  _RAND_1601 = {1{`RANDOM}};
  r_array_count_2_67 = _RAND_1601[31:0];
  _RAND_1602 = {1{`RANDOM}};
  r_array_count_2_68 = _RAND_1602[31:0];
  _RAND_1603 = {1{`RANDOM}};
  r_array_count_2_69 = _RAND_1603[31:0];
  _RAND_1604 = {1{`RANDOM}};
  r_array_count_2_70 = _RAND_1604[31:0];
  _RAND_1605 = {1{`RANDOM}};
  r_array_count_2_71 = _RAND_1605[31:0];
  _RAND_1606 = {1{`RANDOM}};
  _T_1671 = _RAND_1606[0:0];
  _RAND_1607 = {1{`RANDOM}};
  _T_1673 = _RAND_1607[0:0];
  _RAND_1608 = {1{`RANDOM}};
  _T_1675 = _RAND_1608[0:0];
  _RAND_1609 = {1{`RANDOM}};
  _T_1677 = _RAND_1609[0:0];
  _RAND_1610 = {1{`RANDOM}};
  _T_1679 = _RAND_1610[0:0];
  _RAND_1611 = {1{`RANDOM}};
  _T_1681 = _RAND_1611[0:0];
  _RAND_1612 = {1{`RANDOM}};
  _T_1683 = _RAND_1612[0:0];
  _RAND_1613 = {1{`RANDOM}};
  _T_1685 = _RAND_1613[0:0];
  _RAND_1614 = {1{`RANDOM}};
  _T_1687 = _RAND_1614[0:0];
  _RAND_1615 = {1{`RANDOM}};
  _T_1689 = _RAND_1615[0:0];
  _RAND_1616 = {1{`RANDOM}};
  _T_1691 = _RAND_1616[0:0];
  _RAND_1617 = {1{`RANDOM}};
  _T_1693 = _RAND_1617[0:0];
  _RAND_1618 = {1{`RANDOM}};
  _T_1695 = _RAND_1618[0:0];
  _RAND_1619 = {1{`RANDOM}};
  _T_1697 = _RAND_1619[0:0];
  _RAND_1620 = {1{`RANDOM}};
  _T_1699 = _RAND_1620[0:0];
  _RAND_1621 = {1{`RANDOM}};
  _T_1701 = _RAND_1621[0:0];
  _RAND_1622 = {1{`RANDOM}};
  _T_1703 = _RAND_1622[0:0];
  _RAND_1623 = {1{`RANDOM}};
  _T_1705 = _RAND_1623[0:0];
  _RAND_1624 = {1{`RANDOM}};
  _T_1707 = _RAND_1624[0:0];
  _RAND_1625 = {1{`RANDOM}};
  _T_1709 = _RAND_1625[0:0];
  _RAND_1626 = {1{`RANDOM}};
  _T_1711 = _RAND_1626[0:0];
  _RAND_1627 = {1{`RANDOM}};
  _T_1713 = _RAND_1627[0:0];
  _RAND_1628 = {1{`RANDOM}};
  _T_1715 = _RAND_1628[0:0];
  _RAND_1629 = {1{`RANDOM}};
  _T_1717 = _RAND_1629[0:0];
  _RAND_1630 = {1{`RANDOM}};
  _T_1719 = _RAND_1630[0:0];
  _RAND_1631 = {1{`RANDOM}};
  _T_1721 = _RAND_1631[0:0];
  _RAND_1632 = {1{`RANDOM}};
  _T_1723 = _RAND_1632[0:0];
  _RAND_1633 = {1{`RANDOM}};
  _T_1725 = _RAND_1633[0:0];
  _RAND_1634 = {1{`RANDOM}};
  _T_1727 = _RAND_1634[0:0];
  _RAND_1635 = {1{`RANDOM}};
  _T_1729 = _RAND_1635[0:0];
  _RAND_1636 = {1{`RANDOM}};
  _T_1731 = _RAND_1636[0:0];
  _RAND_1637 = {1{`RANDOM}};
  _T_1733 = _RAND_1637[0:0];
  _RAND_1638 = {1{`RANDOM}};
  _T_1735 = _RAND_1638[0:0];
  _RAND_1639 = {1{`RANDOM}};
  _T_1737 = _RAND_1639[0:0];
  _RAND_1640 = {1{`RANDOM}};
  _T_1739 = _RAND_1640[0:0];
  _RAND_1641 = {1{`RANDOM}};
  _T_1741 = _RAND_1641[0:0];
  _RAND_1642 = {1{`RANDOM}};
  _T_1743 = _RAND_1642[0:0];
  _RAND_1643 = {1{`RANDOM}};
  _T_1745 = _RAND_1643[0:0];
  _RAND_1644 = {1{`RANDOM}};
  _T_1747 = _RAND_1644[0:0];
  _RAND_1645 = {1{`RANDOM}};
  _T_1749 = _RAND_1645[0:0];
  _RAND_1646 = {1{`RANDOM}};
  _T_1751 = _RAND_1646[0:0];
  _RAND_1647 = {1{`RANDOM}};
  _T_1753 = _RAND_1647[0:0];
  _RAND_1648 = {1{`RANDOM}};
  _T_1755 = _RAND_1648[0:0];
  _RAND_1649 = {1{`RANDOM}};
  _T_1757 = _RAND_1649[0:0];
  _RAND_1650 = {1{`RANDOM}};
  _T_1759 = _RAND_1650[0:0];
  _RAND_1651 = {1{`RANDOM}};
  _T_1761 = _RAND_1651[0:0];
  _RAND_1652 = {1{`RANDOM}};
  _T_1763 = _RAND_1652[0:0];
  _RAND_1653 = {1{`RANDOM}};
  _T_1765 = _RAND_1653[0:0];
  _RAND_1654 = {1{`RANDOM}};
  _T_1767 = _RAND_1654[0:0];
  _RAND_1655 = {1{`RANDOM}};
  _T_1769 = _RAND_1655[0:0];
  _RAND_1656 = {1{`RANDOM}};
  _T_1771 = _RAND_1656[0:0];
  _RAND_1657 = {1{`RANDOM}};
  _T_1773 = _RAND_1657[0:0];
  _RAND_1658 = {1{`RANDOM}};
  _T_1775 = _RAND_1658[0:0];
  _RAND_1659 = {1{`RANDOM}};
  _T_1777 = _RAND_1659[0:0];
  _RAND_1660 = {1{`RANDOM}};
  _T_1779 = _RAND_1660[0:0];
  _RAND_1661 = {1{`RANDOM}};
  _T_1781 = _RAND_1661[0:0];
  _RAND_1662 = {1{`RANDOM}};
  _T_1783 = _RAND_1662[0:0];
  _RAND_1663 = {1{`RANDOM}};
  _T_1785 = _RAND_1663[0:0];
  _RAND_1664 = {1{`RANDOM}};
  _T_1787 = _RAND_1664[0:0];
  _RAND_1665 = {1{`RANDOM}};
  _T_1789 = _RAND_1665[0:0];
  _RAND_1666 = {1{`RANDOM}};
  _T_1791 = _RAND_1666[0:0];
  _RAND_1667 = {1{`RANDOM}};
  _T_1793 = _RAND_1667[0:0];
  _RAND_1668 = {1{`RANDOM}};
  _T_1795 = _RAND_1668[0:0];
  _RAND_1669 = {1{`RANDOM}};
  _T_1797 = _RAND_1669[0:0];
  _RAND_1670 = {1{`RANDOM}};
  _T_1799 = _RAND_1670[0:0];
  _RAND_1671 = {1{`RANDOM}};
  _T_1801 = _RAND_1671[0:0];
  _RAND_1672 = {1{`RANDOM}};
  _T_1803 = _RAND_1672[0:0];
  _RAND_1673 = {1{`RANDOM}};
  _T_1805 = _RAND_1673[0:0];
  _RAND_1674 = {1{`RANDOM}};
  _T_1807 = _RAND_1674[0:0];
  _RAND_1675 = {1{`RANDOM}};
  _T_1809 = _RAND_1675[0:0];
  _RAND_1676 = {1{`RANDOM}};
  _T_1811 = _RAND_1676[0:0];
  _RAND_1677 = {1{`RANDOM}};
  _T_1813 = _RAND_1677[0:0];
  _RAND_1678 = {1{`RANDOM}};
  _T_1815 = _RAND_1678[0:0];
  _RAND_1679 = {1{`RANDOM}};
  _T_1817 = _RAND_1679[0:0];
  _RAND_1680 = {1{`RANDOM}};
  _T_1819 = _RAND_1680[0:0];
  _RAND_1681 = {1{`RANDOM}};
  _T_1821 = _RAND_1681[0:0];
  _RAND_1682 = {1{`RANDOM}};
  _T_1823 = _RAND_1682[0:0];
  _RAND_1683 = {1{`RANDOM}};
  _T_1825 = _RAND_1683[0:0];
  _RAND_1684 = {1{`RANDOM}};
  _T_1827 = _RAND_1684[0:0];
  _RAND_1685 = {1{`RANDOM}};
  _T_1829 = _RAND_1685[0:0];
  _RAND_1686 = {1{`RANDOM}};
  _T_1831 = _RAND_1686[0:0];
  _RAND_1687 = {1{`RANDOM}};
  _T_1833 = _RAND_1687[0:0];
  _RAND_1688 = {1{`RANDOM}};
  _T_1835 = _RAND_1688[0:0];
  _RAND_1689 = {1{`RANDOM}};
  _T_1837 = _RAND_1689[0:0];
  _RAND_1690 = {1{`RANDOM}};
  _T_1839 = _RAND_1690[0:0];
  _RAND_1691 = {1{`RANDOM}};
  _T_1841 = _RAND_1691[0:0];
  _RAND_1692 = {1{`RANDOM}};
  _T_1843 = _RAND_1692[0:0];
  _RAND_1693 = {1{`RANDOM}};
  _T_1845 = _RAND_1693[0:0];
  _RAND_1694 = {1{`RANDOM}};
  _T_1847 = _RAND_1694[0:0];
  _RAND_1695 = {1{`RANDOM}};
  _T_1849 = _RAND_1695[0:0];
  _RAND_1696 = {1{`RANDOM}};
  _T_1851 = _RAND_1696[0:0];
  _RAND_1697 = {1{`RANDOM}};
  _T_1853 = _RAND_1697[0:0];
  _RAND_1698 = {1{`RANDOM}};
  _T_1855 = _RAND_1698[0:0];
  _RAND_1699 = {1{`RANDOM}};
  _T_1857 = _RAND_1699[0:0];
  _RAND_1700 = {1{`RANDOM}};
  _T_1859 = _RAND_1700[0:0];
  _RAND_1701 = {1{`RANDOM}};
  _T_1861 = _RAND_1701[0:0];
  _RAND_1702 = {1{`RANDOM}};
  _T_1863 = _RAND_1702[0:0];
  _RAND_1703 = {1{`RANDOM}};
  _T_1865 = _RAND_1703[0:0];
  _RAND_1704 = {1{`RANDOM}};
  _T_1867 = _RAND_1704[0:0];
  _RAND_1705 = {1{`RANDOM}};
  _T_1869 = _RAND_1705[0:0];
  _RAND_1706 = {1{`RANDOM}};
  _T_1871 = _RAND_1706[0:0];
  _RAND_1707 = {1{`RANDOM}};
  _T_1873 = _RAND_1707[0:0];
  _RAND_1708 = {1{`RANDOM}};
  _T_1875 = _RAND_1708[0:0];
  _RAND_1709 = {1{`RANDOM}};
  _T_1877 = _RAND_1709[0:0];
  _RAND_1710 = {1{`RANDOM}};
  _T_1879 = _RAND_1710[0:0];
  _RAND_1711 = {1{`RANDOM}};
  _T_1881 = _RAND_1711[0:0];
  _RAND_1712 = {1{`RANDOM}};
  _T_1883 = _RAND_1712[0:0];
  _RAND_1713 = {1{`RANDOM}};
  _T_1885 = _RAND_1713[0:0];
  _RAND_1714 = {1{`RANDOM}};
  _T_1887 = _RAND_1714[0:0];
  _RAND_1715 = {1{`RANDOM}};
  _T_1889 = _RAND_1715[0:0];
  _RAND_1716 = {1{`RANDOM}};
  _T_1891 = _RAND_1716[0:0];
  _RAND_1717 = {1{`RANDOM}};
  _T_1893 = _RAND_1717[0:0];
  _RAND_1718 = {1{`RANDOM}};
  _T_1895 = _RAND_1718[0:0];
  _RAND_1719 = {1{`RANDOM}};
  _T_1897 = _RAND_1719[0:0];
  _RAND_1720 = {1{`RANDOM}};
  _T_1899 = _RAND_1720[0:0];
  _RAND_1721 = {1{`RANDOM}};
  _T_1901 = _RAND_1721[0:0];
  _RAND_1722 = {1{`RANDOM}};
  _T_1903 = _RAND_1722[0:0];
  _RAND_1723 = {1{`RANDOM}};
  _T_1905 = _RAND_1723[0:0];
  _RAND_1724 = {1{`RANDOM}};
  _T_1907 = _RAND_1724[0:0];
  _RAND_1725 = {1{`RANDOM}};
  _T_1909 = _RAND_1725[0:0];
  _RAND_1726 = {1{`RANDOM}};
  _T_1911 = _RAND_1726[0:0];
  _RAND_1727 = {1{`RANDOM}};
  _T_1913 = _RAND_1727[0:0];
  _RAND_1728 = {1{`RANDOM}};
  _T_1915 = _RAND_1728[0:0];
  _RAND_1729 = {1{`RANDOM}};
  _T_1917 = _RAND_1729[0:0];
  _RAND_1730 = {1{`RANDOM}};
  _T_1919 = _RAND_1730[0:0];
  _RAND_1731 = {1{`RANDOM}};
  _T_1921 = _RAND_1731[0:0];
  _RAND_1732 = {1{`RANDOM}};
  _T_1923 = _RAND_1732[0:0];
  _RAND_1733 = {1{`RANDOM}};
  _T_1925 = _RAND_1733[0:0];
`endif // RANDOMIZE_REG_INIT
  `endif // RANDOMIZE
end // initial
`ifdef FIRRTL_AFTER_INITIAL
`FIRRTL_AFTER_INITIAL
`endif
`endif // SYNTHESIS
  always @(posedge clock) begin
    if (reset) begin
      kernel_count <= 32'h0;
    end else if (start_pulse) begin
      kernel_count <= 32'h0;
    end else if (start_pulse) begin
      kernel_count <= 32'h0;
    end else begin
      kernel_count <= _T_1;
    end
    start_r <= io_ap_start_pulse;
    if (reset) begin
      start_state <= 1'h0;
    end else begin
      start_state <= _GEN_7;
    end
    _T_3 <= master_io_global_finish;
    if (reset) begin
      master_finish_count <= 8'h0;
    end else if (_T_36) begin
      master_finish_count <= _T_38;
    end
    global_write_finish <= _T_33 & SLR0_Mem_io_write_finish_31;
    if (reset) begin
      node_num_0_r <= 32'h0;
    end else begin
      node_num_0_r <= io_node_num;
    end
    if (reset) begin
      current_level_0_r <= 32'h0;
    end else begin
      current_level_0_r <= master_io_current_level;
    end
    if (reset) begin
      push_or_pull_0_r <= 1'h0;
    end else begin
      push_or_pull_0_r <= master_io_push_or_pull;
    end
    _T_40 <= master_io_global_finish;
    _T_41_CSR_R_offset <= io_offsets_CSR_R_offset;
    _T_41_CSR_C_offset <= io_offsets_CSR_C_offset;
    _T_41_CSC_R_offset <= io_offsets_CSC_R_offset;
    _T_41_CSC_C_offset <= io_offsets_CSC_C_offset;
    _T_41_level_offset <= io_offsets_level_offset;
    if (reset) begin
      node_num_1_r <= 32'h0;
    end else begin
      node_num_1_r <= io_node_num;
    end
    if (reset) begin
      current_level_1_r <= 32'h0;
    end else begin
      current_level_1_r <= master_io_current_level;
    end
    if (reset) begin
      push_or_pull_1_r <= 1'h0;
    end else begin
      push_or_pull_1_r <= master_io_push_or_pull;
    end
    if (reset) begin
      frontier_flag_1_r <= 1'h0;
    end else begin
      frontier_flag_1_r <= master_io_frontier_flag;
    end
    if (reset) begin
      start_1_r <= 1'h0;
    end else begin
      start_1_r <= master_io_start;
    end
    if (reset) begin
      p2_end_1_r <= 1'h0;
    end else begin
      p2_end_1_r <= master_io_p2_end;
    end
    _T_42_CSR_R_offset <= io_offsets_CSR_R_offset;
    _T_42_CSR_C_offset <= io_offsets_CSR_C_offset;
    _T_42_CSC_R_offset <= io_offsets_CSC_R_offset;
    _T_42_CSC_C_offset <= io_offsets_CSC_C_offset;
    _T_42_level_offset <= io_offsets_level_offset;
    _T_43 <= io_root;
    _T_44 <= start_state;
    if (reset) begin
      node_num_2_r <= 32'h0;
    end else begin
      node_num_2_r <= io_node_num;
    end
    if (reset) begin
      current_level_2_r <= 32'h0;
    end else begin
      current_level_2_r <= master_io_current_level;
    end
    if (reset) begin
      push_or_pull_2_r <= 1'h0;
    end else begin
      push_or_pull_2_r <= master_io_push_or_pull;
    end
    if (reset) begin
      frontier_flag_2_r <= 1'h0;
    end else begin
      frontier_flag_2_r <= master_io_frontier_flag;
    end
    if (reset) begin
      start_2_r <= 1'h0;
    end else begin
      start_2_r <= master_io_start;
    end
    if (reset) begin
      p2_end_2_r <= 1'h0;
    end else begin
      p2_end_2_r <= master_io_p2_end;
    end
    _T_45_CSR_R_offset <= io_offsets_CSR_R_offset;
    _T_45_CSR_C_offset <= io_offsets_CSR_C_offset;
    _T_45_CSC_R_offset <= io_offsets_CSC_R_offset;
    _T_45_CSC_C_offset <= io_offsets_CSC_C_offset;
    _T_45_level_offset <= io_offsets_level_offset;
    _T_46 <= io_root;
    _T_47 <= start_state;
    _T_48_push_to_pull_level <= io_levels_push_to_pull_level;
    _T_48_pull_to_push_level <= io_levels_pull_to_push_level;
    _T_49 <= master_io_global_finish;
    _T_50 <= SLR0_Mem_io_mem_end_0;
    _T_51 <= SLR0_Mem_io_neighbour_cnt_0;
    _T_52 <= SLR0_Mem_io_mem_end_1;
    _T_53 <= SLR0_Mem_io_neighbour_cnt_1;
    _T_54 <= SLR0_Mem_io_mem_end_2;
    _T_55 <= SLR0_Mem_io_neighbour_cnt_2;
    _T_56 <= SLR0_Mem_io_mem_end_3;
    _T_57 <= SLR0_Mem_io_neighbour_cnt_3;
    _T_58 <= SLR0_Mem_io_mem_end_4;
    _T_59 <= SLR0_Mem_io_neighbour_cnt_4;
    _T_60 <= SLR0_Mem_io_mem_end_5;
    _T_61 <= SLR0_Mem_io_neighbour_cnt_5;
    _T_62 <= SLR0_Mem_io_mem_end_6;
    _T_63 <= SLR0_Mem_io_neighbour_cnt_6;
    _T_64 <= SLR0_Mem_io_mem_end_7;
    _T_65 <= SLR0_Mem_io_neighbour_cnt_7;
    _T_66 <= SLR0_Mem_io_mem_end_8;
    _T_67 <= SLR0_Mem_io_neighbour_cnt_8;
    _T_68 <= SLR0_Mem_io_mem_end_9;
    _T_69 <= SLR0_Mem_io_neighbour_cnt_9;
    _T_70 <= SLR0_Mem_io_mem_end_10;
    _T_71 <= SLR0_Mem_io_neighbour_cnt_10;
    _T_72 <= SLR0_Mem_io_mem_end_11;
    _T_73 <= SLR0_Mem_io_neighbour_cnt_11;
    _T_74 <= SLR0_Mem_io_mem_end_12;
    _T_75 <= SLR0_Mem_io_neighbour_cnt_12;
    _T_76 <= SLR0_Mem_io_mem_end_13;
    _T_77 <= SLR0_Mem_io_neighbour_cnt_13;
    _T_78 <= SLR0_Mem_io_mem_end_14;
    _T_79 <= SLR0_Mem_io_neighbour_cnt_14;
    _T_80 <= SLR0_Mem_io_mem_end_15;
    _T_81 <= SLR0_Mem_io_neighbour_cnt_15;
    _T_82 <= SLR0_Mem_io_mem_end_16;
    _T_83 <= SLR0_Mem_io_neighbour_cnt_16;
    _T_84 <= SLR0_Mem_io_mem_end_17;
    _T_85 <= SLR0_Mem_io_neighbour_cnt_17;
    _T_86 <= SLR0_Mem_io_mem_end_18;
    _T_87 <= SLR0_Mem_io_neighbour_cnt_18;
    _T_88 <= SLR0_Mem_io_mem_end_19;
    _T_89 <= SLR0_Mem_io_neighbour_cnt_19;
    _T_90 <= SLR0_Mem_io_mem_end_20;
    _T_91 <= SLR0_Mem_io_neighbour_cnt_20;
    _T_92 <= SLR0_Mem_io_mem_end_21;
    _T_93 <= SLR0_Mem_io_neighbour_cnt_21;
    _T_94 <= SLR0_Mem_io_mem_end_22;
    _T_95 <= SLR0_Mem_io_neighbour_cnt_22;
    _T_96 <= SLR0_Mem_io_mem_end_23;
    _T_97 <= SLR0_Mem_io_neighbour_cnt_23;
    _T_98 <= SLR0_Mem_io_mem_end_24;
    _T_99 <= SLR0_Mem_io_neighbour_cnt_24;
    _T_100 <= SLR0_Mem_io_mem_end_25;
    _T_101 <= SLR0_Mem_io_neighbour_cnt_25;
    _T_102 <= SLR0_Mem_io_mem_end_26;
    _T_103 <= SLR0_Mem_io_neighbour_cnt_26;
    _T_104 <= SLR0_Mem_io_mem_end_27;
    _T_105 <= SLR0_Mem_io_neighbour_cnt_27;
    _T_106 <= SLR0_Mem_io_mem_end_28;
    _T_107 <= SLR0_Mem_io_neighbour_cnt_28;
    _T_108 <= SLR0_Mem_io_mem_end_29;
    _T_109 <= SLR0_Mem_io_neighbour_cnt_29;
    _T_110 <= SLR0_Mem_io_mem_end_30;
    _T_111 <= SLR0_Mem_io_neighbour_cnt_30;
    _T_112 <= SLR0_Mem_io_mem_end_31;
    _T_113 <= SLR0_Mem_io_neighbour_cnt_31;
    _T_114 <= SLR1_io_end_0;
    _T_115 <= SLR1_io_p2_count_0;
    _T_116 <= SLR1_io_p2_pull_count_0;
    _T_117 <= SLR1_io_frontier_pull_count_0;
    _T_118 <= SLR1_io_last_iteration_0;
    _T_119 <= SLR1_io_init_bram_0;
    _T_120 <= SLR1_io_end_1;
    _T_121 <= SLR1_io_p2_count_1;
    _T_122 <= SLR1_io_p2_pull_count_1;
    _T_123 <= SLR1_io_frontier_pull_count_1;
    _T_124 <= SLR1_io_last_iteration_1;
    _T_125 <= SLR1_io_init_bram_1;
    _T_126 <= SLR1_io_end_2;
    _T_127 <= SLR1_io_p2_count_2;
    _T_128 <= SLR1_io_p2_pull_count_2;
    _T_129 <= SLR1_io_frontier_pull_count_2;
    _T_130 <= SLR1_io_last_iteration_2;
    _T_131 <= SLR1_io_init_bram_2;
    _T_132 <= SLR1_io_end_3;
    _T_133 <= SLR1_io_p2_count_3;
    _T_134 <= SLR1_io_p2_pull_count_3;
    _T_135 <= SLR1_io_frontier_pull_count_3;
    _T_136 <= SLR1_io_last_iteration_3;
    _T_137 <= SLR1_io_init_bram_3;
    _T_138 <= SLR1_io_end_4;
    _T_139 <= SLR1_io_p2_count_4;
    _T_140 <= SLR1_io_p2_pull_count_4;
    _T_141 <= SLR1_io_frontier_pull_count_4;
    _T_142 <= SLR1_io_last_iteration_4;
    _T_143 <= SLR1_io_init_bram_4;
    _T_144 <= SLR1_io_end_5;
    _T_145 <= SLR1_io_p2_count_5;
    _T_146 <= SLR1_io_p2_pull_count_5;
    _T_147 <= SLR1_io_frontier_pull_count_5;
    _T_148 <= SLR1_io_last_iteration_5;
    _T_149 <= SLR1_io_init_bram_5;
    _T_150 <= SLR1_io_end_6;
    _T_151 <= SLR1_io_p2_count_6;
    _T_152 <= SLR1_io_p2_pull_count_6;
    _T_153 <= SLR1_io_frontier_pull_count_6;
    _T_154 <= SLR1_io_last_iteration_6;
    _T_155 <= SLR1_io_init_bram_6;
    _T_156 <= SLR1_io_end_7;
    _T_157 <= SLR1_io_p2_count_7;
    _T_158 <= SLR1_io_p2_pull_count_7;
    _T_159 <= SLR1_io_frontier_pull_count_7;
    _T_160 <= SLR1_io_last_iteration_7;
    _T_161 <= SLR1_io_init_bram_7;
    _T_162 <= SLR1_io_end_8;
    _T_163 <= SLR1_io_p2_count_8;
    _T_164 <= SLR1_io_p2_pull_count_8;
    _T_165 <= SLR1_io_frontier_pull_count_8;
    _T_166 <= SLR1_io_last_iteration_8;
    _T_167 <= SLR1_io_init_bram_8;
    _T_168 <= SLR1_io_end_9;
    _T_169 <= SLR1_io_p2_count_9;
    _T_170 <= SLR1_io_p2_pull_count_9;
    _T_171 <= SLR1_io_frontier_pull_count_9;
    _T_172 <= SLR1_io_last_iteration_9;
    _T_173 <= SLR1_io_init_bram_9;
    _T_174 <= SLR1_io_end_10;
    _T_175 <= SLR1_io_p2_count_10;
    _T_176 <= SLR1_io_p2_pull_count_10;
    _T_177 <= SLR1_io_frontier_pull_count_10;
    _T_178 <= SLR1_io_last_iteration_10;
    _T_179 <= SLR1_io_init_bram_10;
    _T_180 <= SLR1_io_end_11;
    _T_181 <= SLR1_io_p2_count_11;
    _T_182 <= SLR1_io_p2_pull_count_11;
    _T_183 <= SLR1_io_frontier_pull_count_11;
    _T_184 <= SLR1_io_last_iteration_11;
    _T_185 <= SLR1_io_init_bram_11;
    _T_186 <= SLR1_io_end_12;
    _T_187 <= SLR1_io_p2_count_12;
    _T_188 <= SLR1_io_p2_pull_count_12;
    _T_189 <= SLR1_io_frontier_pull_count_12;
    _T_190 <= SLR1_io_last_iteration_12;
    _T_191 <= SLR1_io_init_bram_12;
    _T_192 <= SLR1_io_end_13;
    _T_193 <= SLR1_io_p2_count_13;
    _T_194 <= SLR1_io_p2_pull_count_13;
    _T_195 <= SLR1_io_frontier_pull_count_13;
    _T_196 <= SLR1_io_last_iteration_13;
    _T_197 <= SLR1_io_init_bram_13;
    _T_198 <= SLR2_io_end_0;
    _T_199 <= SLR2_io_p2_count_0;
    _T_200 <= SLR2_io_p2_pull_count_0;
    _T_201 <= SLR2_io_frontier_pull_count_0;
    _T_202 <= SLR2_io_last_iteration_0;
    _T_203 <= SLR2_io_init_bram_0;
    _T_204 <= SLR2_io_end_1;
    _T_205 <= SLR2_io_p2_count_1;
    _T_206 <= SLR2_io_p2_pull_count_1;
    _T_207 <= SLR2_io_frontier_pull_count_1;
    _T_208 <= SLR2_io_last_iteration_1;
    _T_209 <= SLR2_io_init_bram_1;
    _T_210 <= SLR2_io_end_2;
    _T_211 <= SLR2_io_p2_count_2;
    _T_212 <= SLR2_io_p2_pull_count_2;
    _T_213 <= SLR2_io_frontier_pull_count_2;
    _T_214 <= SLR2_io_last_iteration_2;
    _T_215 <= SLR2_io_init_bram_2;
    _T_216 <= SLR2_io_end_3;
    _T_217 <= SLR2_io_p2_count_3;
    _T_218 <= SLR2_io_p2_pull_count_3;
    _T_219 <= SLR2_io_frontier_pull_count_3;
    _T_220 <= SLR2_io_last_iteration_3;
    _T_221 <= SLR2_io_init_bram_3;
    _T_222 <= SLR2_io_end_4;
    _T_223 <= SLR2_io_p2_count_4;
    _T_224 <= SLR2_io_p2_pull_count_4;
    _T_225 <= SLR2_io_frontier_pull_count_4;
    _T_226 <= SLR2_io_last_iteration_4;
    _T_227 <= SLR2_io_init_bram_4;
    _T_228 <= SLR2_io_end_5;
    _T_229 <= SLR2_io_p2_count_5;
    _T_230 <= SLR2_io_p2_pull_count_5;
    _T_231 <= SLR2_io_frontier_pull_count_5;
    _T_232 <= SLR2_io_last_iteration_5;
    _T_233 <= SLR2_io_init_bram_5;
    _T_234 <= SLR2_io_end_6;
    _T_235 <= SLR2_io_p2_count_6;
    _T_236 <= SLR2_io_p2_pull_count_6;
    _T_237 <= SLR2_io_frontier_pull_count_6;
    _T_238 <= SLR2_io_last_iteration_6;
    _T_239 <= SLR2_io_init_bram_6;
    _T_240 <= SLR2_io_end_7;
    _T_241 <= SLR2_io_p2_count_7;
    _T_242 <= SLR2_io_p2_pull_count_7;
    _T_243 <= SLR2_io_frontier_pull_count_7;
    _T_244 <= SLR2_io_last_iteration_7;
    _T_245 <= SLR2_io_init_bram_7;
    _T_246 <= SLR2_io_end_8;
    _T_247 <= SLR2_io_p2_count_8;
    _T_248 <= SLR2_io_p2_pull_count_8;
    _T_249 <= SLR2_io_frontier_pull_count_8;
    _T_250 <= SLR2_io_last_iteration_8;
    _T_251 <= SLR2_io_init_bram_8;
    _T_252 <= SLR2_io_end_9;
    _T_253 <= SLR2_io_p2_count_9;
    _T_254 <= SLR2_io_p2_pull_count_9;
    _T_255 <= SLR2_io_frontier_pull_count_9;
    _T_256 <= SLR2_io_last_iteration_9;
    _T_257 <= SLR2_io_init_bram_9;
    _T_258 <= SLR2_io_end_10;
    _T_259 <= SLR2_io_p2_count_10;
    _T_260 <= SLR2_io_p2_pull_count_10;
    _T_261 <= SLR2_io_frontier_pull_count_10;
    _T_262 <= SLR2_io_last_iteration_10;
    _T_263 <= SLR2_io_init_bram_10;
    _T_264 <= SLR2_io_end_11;
    _T_265 <= SLR2_io_p2_count_11;
    _T_266 <= SLR2_io_p2_pull_count_11;
    _T_267 <= SLR2_io_frontier_pull_count_11;
    _T_268 <= SLR2_io_last_iteration_11;
    _T_269 <= SLR2_io_init_bram_11;
    _T_270 <= SLR2_io_end_12;
    _T_271 <= SLR2_io_p2_count_12;
    _T_272 <= SLR2_io_p2_pull_count_12;
    _T_273 <= SLR2_io_frontier_pull_count_12;
    _T_274 <= SLR2_io_last_iteration_12;
    _T_275 <= SLR2_io_init_bram_12;
    _T_276 <= SLR2_io_end_13;
    _T_277 <= SLR2_io_p2_count_13;
    _T_278 <= SLR2_io_p2_pull_count_13;
    _T_279 <= SLR2_io_frontier_pull_count_13;
    _T_280 <= SLR2_io_last_iteration_13;
    _T_281 <= SLR2_io_init_bram_13;
    _T_282 <= SLR2_io_end_14;
    _T_283 <= SLR2_io_p2_count_14;
    _T_284 <= SLR2_io_p2_pull_count_14;
    _T_285 <= SLR2_io_frontier_pull_count_14;
    _T_286 <= SLR2_io_last_iteration_14;
    _T_287 <= SLR2_io_init_bram_14;
    _T_288 <= SLR2_io_end_15;
    _T_289 <= SLR2_io_p2_count_15;
    _T_290 <= SLR2_io_p2_pull_count_15;
    _T_291 <= SLR2_io_frontier_pull_count_15;
    _T_292 <= SLR2_io_last_iteration_15;
    _T_293 <= SLR2_io_init_bram_15;
    _T_294 <= SLR2_io_end_16;
    _T_295 <= SLR2_io_p2_count_16;
    _T_296 <= SLR2_io_p2_pull_count_16;
    _T_297 <= SLR2_io_frontier_pull_count_16;
    _T_298 <= SLR2_io_last_iteration_16;
    _T_299 <= SLR2_io_init_bram_16;
    _T_300 <= SLR2_io_end_17;
    _T_301 <= SLR2_io_p2_count_17;
    _T_302 <= SLR2_io_p2_pull_count_17;
    _T_303 <= SLR2_io_frontier_pull_count_17;
    _T_304 <= SLR2_io_last_iteration_17;
    _T_305 <= SLR2_io_init_bram_17;
    if (reset) begin
      p1_end_q_01_slr0_0 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_0 <= p1_end_q_01_slr1_0;
    end
    if (reset) begin
      p1_end_q_01_slr0_1 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_1 <= p1_end_q_01_slr1_1;
    end
    if (reset) begin
      p1_end_q_01_slr0_2 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_2 <= p1_end_q_01_slr1_2;
    end
    if (reset) begin
      p1_end_q_01_slr0_3 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_3 <= p1_end_q_01_slr1_3;
    end
    if (reset) begin
      p1_end_q_01_slr0_4 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_4 <= p1_end_q_01_slr1_4;
    end
    if (reset) begin
      p1_end_q_01_slr0_5 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_5 <= p1_end_q_01_slr1_5;
    end
    if (reset) begin
      p1_end_q_01_slr0_6 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_6 <= p1_end_q_01_slr1_6;
    end
    if (reset) begin
      p1_end_q_01_slr0_7 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_7 <= p1_end_q_01_slr1_7;
    end
    if (reset) begin
      p1_end_q_01_slr0_8 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_8 <= p1_end_q_01_slr1_8;
    end
    if (reset) begin
      p1_end_q_01_slr0_9 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_9 <= p1_end_q_01_slr1_9;
    end
    if (reset) begin
      p1_end_q_01_slr0_10 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_10 <= p1_end_q_01_slr1_10;
    end
    if (reset) begin
      p1_end_q_01_slr0_11 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_11 <= p1_end_q_01_slr1_11;
    end
    if (reset) begin
      p1_end_q_01_slr0_12 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_12 <= p1_end_q_01_slr1_12;
    end
    if (reset) begin
      p1_end_q_01_slr0_13 <= 1'h0;
    end else begin
      p1_end_q_01_slr0_13 <= p1_end_q_01_slr1_13;
    end
    if (reset) begin
      p1_end_q_01_slr1_0 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_0 <= SLR1_io_p1_end_0;
    end
    if (reset) begin
      p1_end_q_01_slr1_1 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_1 <= SLR1_io_p1_end_1;
    end
    if (reset) begin
      p1_end_q_01_slr1_2 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_2 <= SLR1_io_p1_end_2;
    end
    if (reset) begin
      p1_end_q_01_slr1_3 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_3 <= SLR1_io_p1_end_3;
    end
    if (reset) begin
      p1_end_q_01_slr1_4 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_4 <= SLR1_io_p1_end_4;
    end
    if (reset) begin
      p1_end_q_01_slr1_5 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_5 <= SLR1_io_p1_end_5;
    end
    if (reset) begin
      p1_end_q_01_slr1_6 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_6 <= SLR1_io_p1_end_6;
    end
    if (reset) begin
      p1_end_q_01_slr1_7 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_7 <= SLR1_io_p1_end_7;
    end
    if (reset) begin
      p1_end_q_01_slr1_8 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_8 <= SLR1_io_p1_end_8;
    end
    if (reset) begin
      p1_end_q_01_slr1_9 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_9 <= SLR1_io_p1_end_9;
    end
    if (reset) begin
      p1_end_q_01_slr1_10 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_10 <= SLR1_io_p1_end_10;
    end
    if (reset) begin
      p1_end_q_01_slr1_11 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_11 <= SLR1_io_p1_end_11;
    end
    if (reset) begin
      p1_end_q_01_slr1_12 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_12 <= SLR1_io_p1_end_12;
    end
    if (reset) begin
      p1_end_q_01_slr1_13 <= 1'h0;
    end else begin
      p1_end_q_01_slr1_13 <= SLR1_io_p1_end_13;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_0 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_0 <= uram_out_a_01_slr0_2_0;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_1 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_1 <= uram_out_a_01_slr0_2_1;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_2 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_2 <= uram_out_a_01_slr0_2_2;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_3 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_3 <= uram_out_a_01_slr0_2_3;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_4 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_4 <= uram_out_a_01_slr0_2_4;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_5 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_5 <= uram_out_a_01_slr0_2_5;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_6 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_6 <= uram_out_a_01_slr0_2_6;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_7 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_7 <= uram_out_a_01_slr0_2_7;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_8 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_8 <= uram_out_a_01_slr0_2_8;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_9 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_9 <= uram_out_a_01_slr0_2_9;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_10 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_10 <= uram_out_a_01_slr0_2_10;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_11 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_11 <= uram_out_a_01_slr0_2_11;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_12 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_12 <= uram_out_a_01_slr0_2_12;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_13 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_13 <= uram_out_a_01_slr0_2_13;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_14 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_14 <= uram_out_a_01_slr0_2_14;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_15 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_15 <= uram_out_a_01_slr0_2_15;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_16 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_16 <= uram_out_a_01_slr0_2_16;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_17 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_17 <= uram_out_a_01_slr0_2_17;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_18 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_18 <= uram_out_a_01_slr0_2_18;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_19 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_19 <= uram_out_a_01_slr0_2_19;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_20 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_20 <= uram_out_a_01_slr0_2_20;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_21 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_21 <= uram_out_a_01_slr0_2_21;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_22 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_22 <= uram_out_a_01_slr0_2_22;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_23 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_23 <= uram_out_a_01_slr0_2_23;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_24 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_24 <= uram_out_a_01_slr0_2_24;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_25 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_25 <= uram_out_a_01_slr0_2_25;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_26 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_26 <= uram_out_a_01_slr0_2_26;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_27 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_27 <= uram_out_a_01_slr0_2_27;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_28 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_28 <= uram_out_a_01_slr0_2_28;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_29 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_29 <= uram_out_a_01_slr0_2_29;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_30 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_30 <= uram_out_a_01_slr0_2_30;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_31 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_31 <= uram_out_a_01_slr0_2_31;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_32 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_32 <= uram_out_a_01_slr0_2_32;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_33 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_33 <= uram_out_a_01_slr0_2_33;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_34 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_34 <= uram_out_a_01_slr0_2_34;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_35 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_35 <= uram_out_a_01_slr0_2_35;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_36 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_36 <= uram_out_a_01_slr0_2_36;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_37 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_37 <= uram_out_a_01_slr0_2_37;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_38 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_38 <= uram_out_a_01_slr0_2_38;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_39 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_39 <= uram_out_a_01_slr0_2_39;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_40 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_40 <= uram_out_a_01_slr0_2_40;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_41 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_41 <= uram_out_a_01_slr0_2_41;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_42 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_42 <= uram_out_a_01_slr0_2_42;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_43 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_43 <= uram_out_a_01_slr0_2_43;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_44 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_44 <= uram_out_a_01_slr0_2_44;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_45 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_45 <= uram_out_a_01_slr0_2_45;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_46 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_46 <= uram_out_a_01_slr0_2_46;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_47 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_47 <= uram_out_a_01_slr0_2_47;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_48 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_48 <= uram_out_a_01_slr0_2_48;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_49 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_49 <= uram_out_a_01_slr0_2_49;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_50 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_50 <= uram_out_a_01_slr0_2_50;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_51 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_51 <= uram_out_a_01_slr0_2_51;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_52 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_52 <= uram_out_a_01_slr0_2_52;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_53 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_53 <= uram_out_a_01_slr0_2_53;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_54 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_54 <= uram_out_a_01_slr0_2_54;
    end
    if (reset) begin
      uram_out_a_01_slr0_1_55 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_1_55 <= uram_out_a_01_slr0_2_55;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_0 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_0 <= uram_out_a_01_slr1_0;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_1 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_1 <= uram_out_a_01_slr1_1;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_2 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_2 <= uram_out_a_01_slr1_2;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_3 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_3 <= uram_out_a_01_slr1_3;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_4 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_4 <= uram_out_a_01_slr1_4;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_5 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_5 <= uram_out_a_01_slr1_5;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_6 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_6 <= uram_out_a_01_slr1_6;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_7 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_7 <= uram_out_a_01_slr1_7;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_8 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_8 <= uram_out_a_01_slr1_8;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_9 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_9 <= uram_out_a_01_slr1_9;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_10 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_10 <= uram_out_a_01_slr1_10;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_11 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_11 <= uram_out_a_01_slr1_11;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_12 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_12 <= uram_out_a_01_slr1_12;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_13 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_13 <= uram_out_a_01_slr1_13;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_14 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_14 <= uram_out_a_01_slr1_14;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_15 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_15 <= uram_out_a_01_slr1_15;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_16 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_16 <= uram_out_a_01_slr1_16;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_17 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_17 <= uram_out_a_01_slr1_17;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_18 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_18 <= uram_out_a_01_slr1_18;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_19 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_19 <= uram_out_a_01_slr1_19;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_20 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_20 <= uram_out_a_01_slr1_20;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_21 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_21 <= uram_out_a_01_slr1_21;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_22 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_22 <= uram_out_a_01_slr1_22;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_23 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_23 <= uram_out_a_01_slr1_23;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_24 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_24 <= uram_out_a_01_slr1_24;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_25 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_25 <= uram_out_a_01_slr1_25;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_26 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_26 <= uram_out_a_01_slr1_26;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_27 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_27 <= uram_out_a_01_slr1_27;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_28 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_28 <= uram_out_a_01_slr1_28;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_29 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_29 <= uram_out_a_01_slr1_29;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_30 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_30 <= uram_out_a_01_slr1_30;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_31 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_31 <= uram_out_a_01_slr1_31;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_32 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_32 <= uram_out_a_01_slr1_32;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_33 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_33 <= uram_out_a_01_slr1_33;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_34 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_34 <= uram_out_a_01_slr1_34;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_35 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_35 <= uram_out_a_01_slr1_35;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_36 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_36 <= uram_out_a_01_slr1_36;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_37 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_37 <= uram_out_a_01_slr1_37;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_38 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_38 <= uram_out_a_01_slr1_38;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_39 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_39 <= uram_out_a_01_slr1_39;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_40 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_40 <= uram_out_a_01_slr1_40;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_41 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_41 <= uram_out_a_01_slr1_41;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_42 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_42 <= uram_out_a_01_slr1_42;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_43 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_43 <= uram_out_a_01_slr1_43;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_44 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_44 <= uram_out_a_01_slr1_44;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_45 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_45 <= uram_out_a_01_slr1_45;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_46 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_46 <= uram_out_a_01_slr1_46;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_47 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_47 <= uram_out_a_01_slr1_47;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_48 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_48 <= uram_out_a_01_slr1_48;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_49 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_49 <= uram_out_a_01_slr1_49;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_50 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_50 <= uram_out_a_01_slr1_50;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_51 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_51 <= uram_out_a_01_slr1_51;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_52 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_52 <= uram_out_a_01_slr1_52;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_53 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_53 <= uram_out_a_01_slr1_53;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_54 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_54 <= uram_out_a_01_slr1_54;
    end
    if (reset) begin
      uram_out_a_01_slr0_2_55 <= 64'h0;
    end else begin
      uram_out_a_01_slr0_2_55 <= uram_out_a_01_slr1_55;
    end
    if (reset) begin
      uram_out_a_01_slr1_0 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_0 <= SLR1_io_uram_out_a_0;
    end
    if (reset) begin
      uram_out_a_01_slr1_1 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_1 <= SLR1_io_uram_out_a_1;
    end
    if (reset) begin
      uram_out_a_01_slr1_2 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_2 <= SLR1_io_uram_out_a_2;
    end
    if (reset) begin
      uram_out_a_01_slr1_3 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_3 <= SLR1_io_uram_out_a_3;
    end
    if (reset) begin
      uram_out_a_01_slr1_4 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_4 <= SLR1_io_uram_out_a_4;
    end
    if (reset) begin
      uram_out_a_01_slr1_5 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_5 <= SLR1_io_uram_out_a_5;
    end
    if (reset) begin
      uram_out_a_01_slr1_6 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_6 <= SLR1_io_uram_out_a_6;
    end
    if (reset) begin
      uram_out_a_01_slr1_7 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_7 <= SLR1_io_uram_out_a_7;
    end
    if (reset) begin
      uram_out_a_01_slr1_8 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_8 <= SLR1_io_uram_out_a_8;
    end
    if (reset) begin
      uram_out_a_01_slr1_9 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_9 <= SLR1_io_uram_out_a_9;
    end
    if (reset) begin
      uram_out_a_01_slr1_10 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_10 <= SLR1_io_uram_out_a_10;
    end
    if (reset) begin
      uram_out_a_01_slr1_11 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_11 <= SLR1_io_uram_out_a_11;
    end
    if (reset) begin
      uram_out_a_01_slr1_12 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_12 <= SLR1_io_uram_out_a_12;
    end
    if (reset) begin
      uram_out_a_01_slr1_13 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_13 <= SLR1_io_uram_out_a_13;
    end
    if (reset) begin
      uram_out_a_01_slr1_14 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_14 <= SLR1_io_uram_out_a_14;
    end
    if (reset) begin
      uram_out_a_01_slr1_15 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_15 <= SLR1_io_uram_out_a_15;
    end
    if (reset) begin
      uram_out_a_01_slr1_16 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_16 <= SLR1_io_uram_out_a_16;
    end
    if (reset) begin
      uram_out_a_01_slr1_17 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_17 <= SLR1_io_uram_out_a_17;
    end
    if (reset) begin
      uram_out_a_01_slr1_18 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_18 <= SLR1_io_uram_out_a_18;
    end
    if (reset) begin
      uram_out_a_01_slr1_19 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_19 <= SLR1_io_uram_out_a_19;
    end
    if (reset) begin
      uram_out_a_01_slr1_20 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_20 <= SLR1_io_uram_out_a_20;
    end
    if (reset) begin
      uram_out_a_01_slr1_21 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_21 <= SLR1_io_uram_out_a_21;
    end
    if (reset) begin
      uram_out_a_01_slr1_22 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_22 <= SLR1_io_uram_out_a_22;
    end
    if (reset) begin
      uram_out_a_01_slr1_23 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_23 <= SLR1_io_uram_out_a_23;
    end
    if (reset) begin
      uram_out_a_01_slr1_24 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_24 <= SLR1_io_uram_out_a_24;
    end
    if (reset) begin
      uram_out_a_01_slr1_25 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_25 <= SLR1_io_uram_out_a_25;
    end
    if (reset) begin
      uram_out_a_01_slr1_26 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_26 <= SLR1_io_uram_out_a_26;
    end
    if (reset) begin
      uram_out_a_01_slr1_27 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_27 <= SLR1_io_uram_out_a_27;
    end
    if (reset) begin
      uram_out_a_01_slr1_28 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_28 <= SLR1_io_uram_out_a_28;
    end
    if (reset) begin
      uram_out_a_01_slr1_29 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_29 <= SLR1_io_uram_out_a_29;
    end
    if (reset) begin
      uram_out_a_01_slr1_30 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_30 <= SLR1_io_uram_out_a_30;
    end
    if (reset) begin
      uram_out_a_01_slr1_31 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_31 <= SLR1_io_uram_out_a_31;
    end
    if (reset) begin
      uram_out_a_01_slr1_32 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_32 <= SLR1_io_uram_out_a_32;
    end
    if (reset) begin
      uram_out_a_01_slr1_33 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_33 <= SLR1_io_uram_out_a_33;
    end
    if (reset) begin
      uram_out_a_01_slr1_34 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_34 <= SLR1_io_uram_out_a_34;
    end
    if (reset) begin
      uram_out_a_01_slr1_35 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_35 <= SLR1_io_uram_out_a_35;
    end
    if (reset) begin
      uram_out_a_01_slr1_36 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_36 <= SLR1_io_uram_out_a_36;
    end
    if (reset) begin
      uram_out_a_01_slr1_37 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_37 <= SLR1_io_uram_out_a_37;
    end
    if (reset) begin
      uram_out_a_01_slr1_38 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_38 <= SLR1_io_uram_out_a_38;
    end
    if (reset) begin
      uram_out_a_01_slr1_39 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_39 <= SLR1_io_uram_out_a_39;
    end
    if (reset) begin
      uram_out_a_01_slr1_40 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_40 <= SLR1_io_uram_out_a_40;
    end
    if (reset) begin
      uram_out_a_01_slr1_41 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_41 <= SLR1_io_uram_out_a_41;
    end
    if (reset) begin
      uram_out_a_01_slr1_42 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_42 <= SLR1_io_uram_out_a_42;
    end
    if (reset) begin
      uram_out_a_01_slr1_43 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_43 <= SLR1_io_uram_out_a_43;
    end
    if (reset) begin
      uram_out_a_01_slr1_44 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_44 <= SLR1_io_uram_out_a_44;
    end
    if (reset) begin
      uram_out_a_01_slr1_45 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_45 <= SLR1_io_uram_out_a_45;
    end
    if (reset) begin
      uram_out_a_01_slr1_46 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_46 <= SLR1_io_uram_out_a_46;
    end
    if (reset) begin
      uram_out_a_01_slr1_47 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_47 <= SLR1_io_uram_out_a_47;
    end
    if (reset) begin
      uram_out_a_01_slr1_48 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_48 <= SLR1_io_uram_out_a_48;
    end
    if (reset) begin
      uram_out_a_01_slr1_49 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_49 <= SLR1_io_uram_out_a_49;
    end
    if (reset) begin
      uram_out_a_01_slr1_50 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_50 <= SLR1_io_uram_out_a_50;
    end
    if (reset) begin
      uram_out_a_01_slr1_51 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_51 <= SLR1_io_uram_out_a_51;
    end
    if (reset) begin
      uram_out_a_01_slr1_52 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_52 <= SLR1_io_uram_out_a_52;
    end
    if (reset) begin
      uram_out_a_01_slr1_53 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_53 <= SLR1_io_uram_out_a_53;
    end
    if (reset) begin
      uram_out_a_01_slr1_54 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_54 <= SLR1_io_uram_out_a_54;
    end
    if (reset) begin
      uram_out_a_01_slr1_55 <= 64'h0;
    end else begin
      uram_out_a_01_slr1_55 <= SLR1_io_uram_out_a_55;
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_0 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_0 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_0};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_1 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_1 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_1};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_2 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_2 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_2};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_3 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_3 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_3};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_4 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_4 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_4};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_5 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_5 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_5};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_6 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_6 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_6};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_7 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_7 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_7};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_8 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_8 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_8};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_9 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_9 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_9};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_10 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_10 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_10};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_11 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_11 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_11};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_12 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_12 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_12};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_13 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_13 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_13};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_14 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_14 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_14};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_15 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_15 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_15};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_16 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_16 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_16};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_17 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_17 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_17};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_18 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_18 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_18};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_19 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_19 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_19};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_20 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_20 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_20};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_21 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_21 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_21};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_22 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_22 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_22};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_23 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_23 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_23};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_24 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_24 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_24};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_25 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_25 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_25};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_26 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_26 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_26};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_27 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_27 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_27};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_28 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_28 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_28};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_29 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_29 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_29};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_30 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_30 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_30};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_31 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_31 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_31};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_32 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_32 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_32};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_33 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_33 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_33};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_34 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_34 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_34};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_35 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_35 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_35};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_36 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_36 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_36};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_37 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_37 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_37};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_38 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_38 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_38};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_39 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_39 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_39};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_40 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_40 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_40};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_41 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_41 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_41};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_42 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_42 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_42};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_43 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_43 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_43};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_44 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_44 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_44};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_45 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_45 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_45};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_46 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_46 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_46};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_47 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_47 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_47};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_48 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_48 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_48};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_49 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_49 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_49};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_50 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_50 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_50};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_51 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_51 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_51};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_52 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_52 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_52};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_53 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_53 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_53};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_54 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_54 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_54};
    end
    if (reset) begin
      uram_addr_a_01_slr0_1_55 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_1_55 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_55};
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_0 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_0 <= uram_addr_a_01_slr0_1_0;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_1 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_1 <= uram_addr_a_01_slr0_1_1;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_2 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_2 <= uram_addr_a_01_slr0_1_2;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_3 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_3 <= uram_addr_a_01_slr0_1_3;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_4 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_4 <= uram_addr_a_01_slr0_1_4;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_5 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_5 <= uram_addr_a_01_slr0_1_5;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_6 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_6 <= uram_addr_a_01_slr0_1_6;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_7 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_7 <= uram_addr_a_01_slr0_1_7;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_8 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_8 <= uram_addr_a_01_slr0_1_8;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_9 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_9 <= uram_addr_a_01_slr0_1_9;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_10 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_10 <= uram_addr_a_01_slr0_1_10;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_11 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_11 <= uram_addr_a_01_slr0_1_11;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_12 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_12 <= uram_addr_a_01_slr0_1_12;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_13 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_13 <= uram_addr_a_01_slr0_1_13;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_14 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_14 <= uram_addr_a_01_slr0_1_14;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_15 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_15 <= uram_addr_a_01_slr0_1_15;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_16 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_16 <= uram_addr_a_01_slr0_1_16;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_17 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_17 <= uram_addr_a_01_slr0_1_17;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_18 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_18 <= uram_addr_a_01_slr0_1_18;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_19 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_19 <= uram_addr_a_01_slr0_1_19;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_20 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_20 <= uram_addr_a_01_slr0_1_20;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_21 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_21 <= uram_addr_a_01_slr0_1_21;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_22 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_22 <= uram_addr_a_01_slr0_1_22;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_23 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_23 <= uram_addr_a_01_slr0_1_23;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_24 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_24 <= uram_addr_a_01_slr0_1_24;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_25 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_25 <= uram_addr_a_01_slr0_1_25;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_26 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_26 <= uram_addr_a_01_slr0_1_26;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_27 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_27 <= uram_addr_a_01_slr0_1_27;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_28 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_28 <= uram_addr_a_01_slr0_1_28;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_29 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_29 <= uram_addr_a_01_slr0_1_29;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_30 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_30 <= uram_addr_a_01_slr0_1_30;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_31 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_31 <= uram_addr_a_01_slr0_1_31;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_32 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_32 <= uram_addr_a_01_slr0_1_32;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_33 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_33 <= uram_addr_a_01_slr0_1_33;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_34 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_34 <= uram_addr_a_01_slr0_1_34;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_35 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_35 <= uram_addr_a_01_slr0_1_35;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_36 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_36 <= uram_addr_a_01_slr0_1_36;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_37 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_37 <= uram_addr_a_01_slr0_1_37;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_38 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_38 <= uram_addr_a_01_slr0_1_38;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_39 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_39 <= uram_addr_a_01_slr0_1_39;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_40 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_40 <= uram_addr_a_01_slr0_1_40;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_41 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_41 <= uram_addr_a_01_slr0_1_41;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_42 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_42 <= uram_addr_a_01_slr0_1_42;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_43 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_43 <= uram_addr_a_01_slr0_1_43;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_44 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_44 <= uram_addr_a_01_slr0_1_44;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_45 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_45 <= uram_addr_a_01_slr0_1_45;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_46 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_46 <= uram_addr_a_01_slr0_1_46;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_47 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_47 <= uram_addr_a_01_slr0_1_47;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_48 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_48 <= uram_addr_a_01_slr0_1_48;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_49 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_49 <= uram_addr_a_01_slr0_1_49;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_50 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_50 <= uram_addr_a_01_slr0_1_50;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_51 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_51 <= uram_addr_a_01_slr0_1_51;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_52 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_52 <= uram_addr_a_01_slr0_1_52;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_53 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_53 <= uram_addr_a_01_slr0_1_53;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_54 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_54 <= uram_addr_a_01_slr0_1_54;
    end
    if (reset) begin
      uram_addr_a_01_slr0_2_55 <= 64'h0;
    end else begin
      uram_addr_a_01_slr0_2_55 <= uram_addr_a_01_slr0_1_55;
    end
    if (reset) begin
      uram_addr_a_01_slr1_0 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_0 <= uram_addr_a_01_slr0_2_0;
    end
    if (reset) begin
      uram_addr_a_01_slr1_1 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_1 <= uram_addr_a_01_slr0_2_1;
    end
    if (reset) begin
      uram_addr_a_01_slr1_2 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_2 <= uram_addr_a_01_slr0_2_2;
    end
    if (reset) begin
      uram_addr_a_01_slr1_3 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_3 <= uram_addr_a_01_slr0_2_3;
    end
    if (reset) begin
      uram_addr_a_01_slr1_4 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_4 <= uram_addr_a_01_slr0_2_4;
    end
    if (reset) begin
      uram_addr_a_01_slr1_5 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_5 <= uram_addr_a_01_slr0_2_5;
    end
    if (reset) begin
      uram_addr_a_01_slr1_6 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_6 <= uram_addr_a_01_slr0_2_6;
    end
    if (reset) begin
      uram_addr_a_01_slr1_7 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_7 <= uram_addr_a_01_slr0_2_7;
    end
    if (reset) begin
      uram_addr_a_01_slr1_8 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_8 <= uram_addr_a_01_slr0_2_8;
    end
    if (reset) begin
      uram_addr_a_01_slr1_9 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_9 <= uram_addr_a_01_slr0_2_9;
    end
    if (reset) begin
      uram_addr_a_01_slr1_10 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_10 <= uram_addr_a_01_slr0_2_10;
    end
    if (reset) begin
      uram_addr_a_01_slr1_11 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_11 <= uram_addr_a_01_slr0_2_11;
    end
    if (reset) begin
      uram_addr_a_01_slr1_12 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_12 <= uram_addr_a_01_slr0_2_12;
    end
    if (reset) begin
      uram_addr_a_01_slr1_13 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_13 <= uram_addr_a_01_slr0_2_13;
    end
    if (reset) begin
      uram_addr_a_01_slr1_14 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_14 <= uram_addr_a_01_slr0_2_14;
    end
    if (reset) begin
      uram_addr_a_01_slr1_15 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_15 <= uram_addr_a_01_slr0_2_15;
    end
    if (reset) begin
      uram_addr_a_01_slr1_16 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_16 <= uram_addr_a_01_slr0_2_16;
    end
    if (reset) begin
      uram_addr_a_01_slr1_17 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_17 <= uram_addr_a_01_slr0_2_17;
    end
    if (reset) begin
      uram_addr_a_01_slr1_18 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_18 <= uram_addr_a_01_slr0_2_18;
    end
    if (reset) begin
      uram_addr_a_01_slr1_19 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_19 <= uram_addr_a_01_slr0_2_19;
    end
    if (reset) begin
      uram_addr_a_01_slr1_20 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_20 <= uram_addr_a_01_slr0_2_20;
    end
    if (reset) begin
      uram_addr_a_01_slr1_21 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_21 <= uram_addr_a_01_slr0_2_21;
    end
    if (reset) begin
      uram_addr_a_01_slr1_22 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_22 <= uram_addr_a_01_slr0_2_22;
    end
    if (reset) begin
      uram_addr_a_01_slr1_23 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_23 <= uram_addr_a_01_slr0_2_23;
    end
    if (reset) begin
      uram_addr_a_01_slr1_24 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_24 <= uram_addr_a_01_slr0_2_24;
    end
    if (reset) begin
      uram_addr_a_01_slr1_25 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_25 <= uram_addr_a_01_slr0_2_25;
    end
    if (reset) begin
      uram_addr_a_01_slr1_26 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_26 <= uram_addr_a_01_slr0_2_26;
    end
    if (reset) begin
      uram_addr_a_01_slr1_27 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_27 <= uram_addr_a_01_slr0_2_27;
    end
    if (reset) begin
      uram_addr_a_01_slr1_28 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_28 <= uram_addr_a_01_slr0_2_28;
    end
    if (reset) begin
      uram_addr_a_01_slr1_29 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_29 <= uram_addr_a_01_slr0_2_29;
    end
    if (reset) begin
      uram_addr_a_01_slr1_30 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_30 <= uram_addr_a_01_slr0_2_30;
    end
    if (reset) begin
      uram_addr_a_01_slr1_31 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_31 <= uram_addr_a_01_slr0_2_31;
    end
    if (reset) begin
      uram_addr_a_01_slr1_32 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_32 <= uram_addr_a_01_slr0_2_32;
    end
    if (reset) begin
      uram_addr_a_01_slr1_33 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_33 <= uram_addr_a_01_slr0_2_33;
    end
    if (reset) begin
      uram_addr_a_01_slr1_34 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_34 <= uram_addr_a_01_slr0_2_34;
    end
    if (reset) begin
      uram_addr_a_01_slr1_35 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_35 <= uram_addr_a_01_slr0_2_35;
    end
    if (reset) begin
      uram_addr_a_01_slr1_36 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_36 <= uram_addr_a_01_slr0_2_36;
    end
    if (reset) begin
      uram_addr_a_01_slr1_37 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_37 <= uram_addr_a_01_slr0_2_37;
    end
    if (reset) begin
      uram_addr_a_01_slr1_38 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_38 <= uram_addr_a_01_slr0_2_38;
    end
    if (reset) begin
      uram_addr_a_01_slr1_39 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_39 <= uram_addr_a_01_slr0_2_39;
    end
    if (reset) begin
      uram_addr_a_01_slr1_40 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_40 <= uram_addr_a_01_slr0_2_40;
    end
    if (reset) begin
      uram_addr_a_01_slr1_41 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_41 <= uram_addr_a_01_slr0_2_41;
    end
    if (reset) begin
      uram_addr_a_01_slr1_42 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_42 <= uram_addr_a_01_slr0_2_42;
    end
    if (reset) begin
      uram_addr_a_01_slr1_43 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_43 <= uram_addr_a_01_slr0_2_43;
    end
    if (reset) begin
      uram_addr_a_01_slr1_44 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_44 <= uram_addr_a_01_slr0_2_44;
    end
    if (reset) begin
      uram_addr_a_01_slr1_45 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_45 <= uram_addr_a_01_slr0_2_45;
    end
    if (reset) begin
      uram_addr_a_01_slr1_46 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_46 <= uram_addr_a_01_slr0_2_46;
    end
    if (reset) begin
      uram_addr_a_01_slr1_47 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_47 <= uram_addr_a_01_slr0_2_47;
    end
    if (reset) begin
      uram_addr_a_01_slr1_48 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_48 <= uram_addr_a_01_slr0_2_48;
    end
    if (reset) begin
      uram_addr_a_01_slr1_49 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_49 <= uram_addr_a_01_slr0_2_49;
    end
    if (reset) begin
      uram_addr_a_01_slr1_50 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_50 <= uram_addr_a_01_slr0_2_50;
    end
    if (reset) begin
      uram_addr_a_01_slr1_51 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_51 <= uram_addr_a_01_slr0_2_51;
    end
    if (reset) begin
      uram_addr_a_01_slr1_52 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_52 <= uram_addr_a_01_slr0_2_52;
    end
    if (reset) begin
      uram_addr_a_01_slr1_53 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_53 <= uram_addr_a_01_slr0_2_53;
    end
    if (reset) begin
      uram_addr_a_01_slr1_54 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_54 <= uram_addr_a_01_slr0_2_54;
    end
    if (reset) begin
      uram_addr_a_01_slr1_55 <= 64'h0;
    end else begin
      uram_addr_a_01_slr1_55 <= uram_addr_a_01_slr0_2_55;
    end
    _T_314 <= R_array_index_01_slr1_deq_valid;
    _T_315 <= R_array_index_01_slr0_deq_valid;
    _T_319 <= R_array_index_01_slr1_1_deq_valid;
    _T_320 <= R_array_index_01_slr0_1_deq_valid;
    _T_324 <= R_array_index_01_slr1_2_deq_valid;
    _T_325 <= R_array_index_01_slr0_2_deq_valid;
    _T_329 <= R_array_index_01_slr1_3_deq_valid;
    _T_330 <= R_array_index_01_slr0_3_deq_valid;
    _T_334 <= R_array_index_01_slr1_4_deq_valid;
    _T_335 <= R_array_index_01_slr0_4_deq_valid;
    _T_339 <= R_array_index_01_slr1_5_deq_valid;
    _T_340 <= R_array_index_01_slr0_5_deq_valid;
    _T_344 <= R_array_index_01_slr1_6_deq_valid;
    _T_345 <= R_array_index_01_slr0_6_deq_valid;
    _T_349 <= R_array_index_01_slr1_7_deq_valid;
    _T_350 <= R_array_index_01_slr0_7_deq_valid;
    _T_354 <= R_array_index_01_slr1_8_deq_valid;
    _T_355 <= R_array_index_01_slr0_8_deq_valid;
    _T_359 <= R_array_index_01_slr1_9_deq_valid;
    _T_360 <= R_array_index_01_slr0_9_deq_valid;
    _T_364 <= R_array_index_01_slr1_10_deq_valid;
    _T_365 <= R_array_index_01_slr0_10_deq_valid;
    _T_369 <= R_array_index_01_slr1_11_deq_valid;
    _T_370 <= R_array_index_01_slr0_11_deq_valid;
    _T_374 <= R_array_index_01_slr1_12_deq_valid;
    _T_375 <= R_array_index_01_slr0_12_deq_valid;
    _T_379 <= R_array_index_01_slr1_13_deq_valid;
    _T_380 <= R_array_index_01_slr0_13_deq_valid;
    _T_384 <= R_array_index_01_slr1_14_deq_valid;
    _T_385 <= R_array_index_01_slr0_14_deq_valid;
    _T_389 <= R_array_index_01_slr1_15_deq_valid;
    _T_390 <= R_array_index_01_slr0_15_deq_valid;
    _T_394 <= R_array_index_01_slr1_16_deq_valid;
    _T_395 <= R_array_index_01_slr0_16_deq_valid;
    _T_399 <= R_array_index_01_slr1_17_deq_valid;
    _T_400 <= R_array_index_01_slr0_17_deq_valid;
    _T_404 <= R_array_index_01_slr1_18_deq_valid;
    _T_405 <= R_array_index_01_slr0_18_deq_valid;
    _T_409 <= R_array_index_01_slr1_19_deq_valid;
    _T_410 <= R_array_index_01_slr0_19_deq_valid;
    _T_414 <= R_array_index_01_slr1_20_deq_valid;
    _T_415 <= R_array_index_01_slr0_20_deq_valid;
    _T_419 <= R_array_index_01_slr1_21_deq_valid;
    _T_420 <= R_array_index_01_slr0_21_deq_valid;
    _T_424 <= R_array_index_01_slr1_22_deq_valid;
    _T_425 <= R_array_index_01_slr0_22_deq_valid;
    _T_429 <= R_array_index_01_slr1_23_deq_valid;
    _T_430 <= R_array_index_01_slr0_23_deq_valid;
    _T_434 <= R_array_index_01_slr1_24_deq_valid;
    _T_435 <= R_array_index_01_slr0_24_deq_valid;
    _T_439 <= R_array_index_01_slr1_25_deq_valid;
    _T_440 <= R_array_index_01_slr0_25_deq_valid;
    _T_444 <= R_array_index_01_slr1_26_deq_valid;
    _T_445 <= R_array_index_01_slr0_26_deq_valid;
    _T_449 <= R_array_index_01_slr1_27_deq_valid;
    _T_450 <= R_array_index_01_slr0_27_deq_valid;
    _T_454 <= R_array_index_01_slr1_28_deq_valid;
    _T_455 <= R_array_index_01_slr0_28_deq_valid;
    _T_459 <= R_array_index_01_slr1_29_deq_valid;
    _T_460 <= R_array_index_01_slr0_29_deq_valid;
    _T_464 <= R_array_index_01_slr1_30_deq_valid;
    _T_465 <= R_array_index_01_slr0_30_deq_valid;
    _T_469 <= R_array_index_01_slr1_31_deq_valid;
    _T_470 <= R_array_index_01_slr0_31_deq_valid;
    _T_474 <= R_array_index_01_slr1_32_deq_valid;
    _T_475 <= R_array_index_01_slr0_32_deq_valid;
    _T_479 <= R_array_index_01_slr1_33_deq_valid;
    _T_480 <= R_array_index_01_slr0_33_deq_valid;
    _T_484 <= R_array_index_01_slr1_34_deq_valid;
    _T_485 <= R_array_index_01_slr0_34_deq_valid;
    _T_489 <= R_array_index_01_slr1_35_deq_valid;
    _T_490 <= R_array_index_01_slr0_35_deq_valid;
    _T_494 <= R_array_index_01_slr1_36_deq_valid;
    _T_495 <= R_array_index_01_slr0_36_deq_valid;
    _T_499 <= R_array_index_01_slr1_37_deq_valid;
    _T_500 <= R_array_index_01_slr0_37_deq_valid;
    _T_504 <= R_array_index_01_slr1_38_deq_valid;
    _T_505 <= R_array_index_01_slr0_38_deq_valid;
    _T_509 <= R_array_index_01_slr1_39_deq_valid;
    _T_510 <= R_array_index_01_slr0_39_deq_valid;
    _T_514 <= R_array_index_01_slr1_40_deq_valid;
    _T_515 <= R_array_index_01_slr0_40_deq_valid;
    _T_519 <= R_array_index_01_slr1_41_deq_valid;
    _T_520 <= R_array_index_01_slr0_41_deq_valid;
    _T_524 <= R_array_index_01_slr1_42_deq_valid;
    _T_525 <= R_array_index_01_slr0_42_deq_valid;
    _T_529 <= R_array_index_01_slr1_43_deq_valid;
    _T_530 <= R_array_index_01_slr0_43_deq_valid;
    _T_534 <= R_array_index_01_slr1_44_deq_valid;
    _T_535 <= R_array_index_01_slr0_44_deq_valid;
    _T_539 <= R_array_index_01_slr1_45_deq_valid;
    _T_540 <= R_array_index_01_slr0_45_deq_valid;
    _T_544 <= R_array_index_01_slr1_46_deq_valid;
    _T_545 <= R_array_index_01_slr0_46_deq_valid;
    _T_549 <= R_array_index_01_slr1_47_deq_valid;
    _T_550 <= R_array_index_01_slr0_47_deq_valid;
    _T_554 <= R_array_index_01_slr1_48_deq_valid;
    _T_555 <= R_array_index_01_slr0_48_deq_valid;
    _T_559 <= R_array_index_01_slr1_49_deq_valid;
    _T_560 <= R_array_index_01_slr0_49_deq_valid;
    _T_564 <= R_array_index_01_slr1_50_deq_valid;
    _T_565 <= R_array_index_01_slr0_50_deq_valid;
    _T_569 <= R_array_index_01_slr1_51_deq_valid;
    _T_570 <= R_array_index_01_slr0_51_deq_valid;
    _T_574 <= R_array_index_01_slr1_52_deq_valid;
    _T_575 <= R_array_index_01_slr0_52_deq_valid;
    _T_579 <= R_array_index_01_slr1_53_deq_valid;
    _T_580 <= R_array_index_01_slr0_53_deq_valid;
    _T_584 <= R_array_index_01_slr1_54_deq_valid;
    _T_585 <= R_array_index_01_slr0_54_deq_valid;
    _T_589 <= R_array_index_01_slr1_55_deq_valid;
    _T_590 <= R_array_index_01_slr0_55_deq_valid;
    if (reset) begin
      r_array_count__0 <= 32'h0;
    end else if (_T_704) begin
      r_array_count__0 <= _T_706;
    end
    if (reset) begin
      r_array_count__1 <= 32'h0;
    end else if (_T_707) begin
      r_array_count__1 <= _T_709;
    end
    if (reset) begin
      r_array_count__2 <= 32'h0;
    end else if (_T_710) begin
      r_array_count__2 <= _T_712;
    end
    if (reset) begin
      r_array_count__3 <= 32'h0;
    end else if (_T_713) begin
      r_array_count__3 <= _T_715;
    end
    if (reset) begin
      r_array_count__4 <= 32'h0;
    end else if (_T_716) begin
      r_array_count__4 <= _T_718;
    end
    if (reset) begin
      r_array_count__5 <= 32'h0;
    end else if (_T_719) begin
      r_array_count__5 <= _T_721;
    end
    if (reset) begin
      r_array_count__6 <= 32'h0;
    end else if (_T_722) begin
      r_array_count__6 <= _T_724;
    end
    if (reset) begin
      r_array_count__7 <= 32'h0;
    end else if (_T_725) begin
      r_array_count__7 <= _T_727;
    end
    if (reset) begin
      r_array_count__8 <= 32'h0;
    end else if (_T_728) begin
      r_array_count__8 <= _T_730;
    end
    if (reset) begin
      r_array_count__9 <= 32'h0;
    end else if (_T_731) begin
      r_array_count__9 <= _T_733;
    end
    if (reset) begin
      r_array_count__10 <= 32'h0;
    end else if (_T_734) begin
      r_array_count__10 <= _T_736;
    end
    if (reset) begin
      r_array_count__11 <= 32'h0;
    end else if (_T_737) begin
      r_array_count__11 <= _T_739;
    end
    if (reset) begin
      r_array_count__12 <= 32'h0;
    end else if (_T_740) begin
      r_array_count__12 <= _T_742;
    end
    if (reset) begin
      r_array_count__13 <= 32'h0;
    end else if (_T_743) begin
      r_array_count__13 <= _T_745;
    end
    if (reset) begin
      r_array_count__14 <= 32'h0;
    end else if (_T_746) begin
      r_array_count__14 <= _T_748;
    end
    if (reset) begin
      r_array_count__15 <= 32'h0;
    end else if (_T_749) begin
      r_array_count__15 <= _T_751;
    end
    if (reset) begin
      r_array_count__16 <= 32'h0;
    end else if (_T_752) begin
      r_array_count__16 <= _T_754;
    end
    if (reset) begin
      r_array_count__17 <= 32'h0;
    end else if (_T_755) begin
      r_array_count__17 <= _T_757;
    end
    if (reset) begin
      r_array_count__18 <= 32'h0;
    end else if (_T_758) begin
      r_array_count__18 <= _T_760;
    end
    if (reset) begin
      r_array_count__19 <= 32'h0;
    end else if (_T_761) begin
      r_array_count__19 <= _T_763;
    end
    if (reset) begin
      r_array_count__20 <= 32'h0;
    end else if (_T_764) begin
      r_array_count__20 <= _T_766;
    end
    if (reset) begin
      r_array_count__21 <= 32'h0;
    end else if (_T_767) begin
      r_array_count__21 <= _T_769;
    end
    if (reset) begin
      r_array_count__22 <= 32'h0;
    end else if (_T_770) begin
      r_array_count__22 <= _T_772;
    end
    if (reset) begin
      r_array_count__23 <= 32'h0;
    end else if (_T_773) begin
      r_array_count__23 <= _T_775;
    end
    if (reset) begin
      r_array_count__24 <= 32'h0;
    end else if (_T_776) begin
      r_array_count__24 <= _T_778;
    end
    if (reset) begin
      r_array_count__25 <= 32'h0;
    end else if (_T_779) begin
      r_array_count__25 <= _T_781;
    end
    if (reset) begin
      r_array_count__26 <= 32'h0;
    end else if (_T_782) begin
      r_array_count__26 <= _T_784;
    end
    if (reset) begin
      r_array_count__27 <= 32'h0;
    end else if (_T_785) begin
      r_array_count__27 <= _T_787;
    end
    if (reset) begin
      r_array_count__28 <= 32'h0;
    end else if (_T_788) begin
      r_array_count__28 <= _T_790;
    end
    if (reset) begin
      r_array_count__29 <= 32'h0;
    end else if (_T_791) begin
      r_array_count__29 <= _T_793;
    end
    if (reset) begin
      r_array_count__30 <= 32'h0;
    end else if (_T_794) begin
      r_array_count__30 <= _T_796;
    end
    if (reset) begin
      r_array_count__31 <= 32'h0;
    end else if (_T_797) begin
      r_array_count__31 <= _T_799;
    end
    if (reset) begin
      r_array_count__32 <= 32'h0;
    end else if (_T_800) begin
      r_array_count__32 <= _T_802;
    end
    if (reset) begin
      r_array_count__33 <= 32'h0;
    end else if (_T_803) begin
      r_array_count__33 <= _T_805;
    end
    if (reset) begin
      r_array_count__34 <= 32'h0;
    end else if (_T_806) begin
      r_array_count__34 <= _T_808;
    end
    if (reset) begin
      r_array_count__35 <= 32'h0;
    end else if (_T_809) begin
      r_array_count__35 <= _T_811;
    end
    if (reset) begin
      r_array_count__36 <= 32'h0;
    end else if (_T_812) begin
      r_array_count__36 <= _T_814;
    end
    if (reset) begin
      r_array_count__37 <= 32'h0;
    end else if (_T_815) begin
      r_array_count__37 <= _T_817;
    end
    if (reset) begin
      r_array_count__38 <= 32'h0;
    end else if (_T_818) begin
      r_array_count__38 <= _T_820;
    end
    if (reset) begin
      r_array_count__39 <= 32'h0;
    end else if (_T_821) begin
      r_array_count__39 <= _T_823;
    end
    if (reset) begin
      r_array_count__40 <= 32'h0;
    end else if (_T_824) begin
      r_array_count__40 <= _T_826;
    end
    if (reset) begin
      r_array_count__41 <= 32'h0;
    end else if (_T_827) begin
      r_array_count__41 <= _T_829;
    end
    if (reset) begin
      r_array_count__42 <= 32'h0;
    end else if (_T_830) begin
      r_array_count__42 <= _T_832;
    end
    if (reset) begin
      r_array_count__43 <= 32'h0;
    end else if (_T_833) begin
      r_array_count__43 <= _T_835;
    end
    if (reset) begin
      r_array_count__44 <= 32'h0;
    end else if (_T_836) begin
      r_array_count__44 <= _T_838;
    end
    if (reset) begin
      r_array_count__45 <= 32'h0;
    end else if (_T_839) begin
      r_array_count__45 <= _T_841;
    end
    if (reset) begin
      r_array_count__46 <= 32'h0;
    end else if (_T_842) begin
      r_array_count__46 <= _T_844;
    end
    if (reset) begin
      r_array_count__47 <= 32'h0;
    end else if (_T_845) begin
      r_array_count__47 <= _T_847;
    end
    if (reset) begin
      r_array_count__48 <= 32'h0;
    end else if (_T_848) begin
      r_array_count__48 <= _T_850;
    end
    if (reset) begin
      r_array_count__49 <= 32'h0;
    end else if (_T_851) begin
      r_array_count__49 <= _T_853;
    end
    if (reset) begin
      r_array_count__50 <= 32'h0;
    end else if (_T_854) begin
      r_array_count__50 <= _T_856;
    end
    if (reset) begin
      r_array_count__51 <= 32'h0;
    end else if (_T_857) begin
      r_array_count__51 <= _T_859;
    end
    if (reset) begin
      r_array_count__52 <= 32'h0;
    end else if (_T_860) begin
      r_array_count__52 <= _T_862;
    end
    if (reset) begin
      r_array_count__53 <= 32'h0;
    end else if (_T_863) begin
      r_array_count__53 <= _T_865;
    end
    if (reset) begin
      r_array_count__54 <= 32'h0;
    end else if (_T_866) begin
      r_array_count__54 <= _T_868;
    end
    if (reset) begin
      r_array_count__55 <= 32'h0;
    end else if (_T_869) begin
      r_array_count__55 <= _T_871;
    end
    if (reset) begin
      p1_end_q_02_slr0_0 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_0 <= p1_end_q_02_slr1_0;
    end
    if (reset) begin
      p1_end_q_02_slr0_1 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_1 <= p1_end_q_02_slr1_1;
    end
    if (reset) begin
      p1_end_q_02_slr0_2 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_2 <= p1_end_q_02_slr1_2;
    end
    if (reset) begin
      p1_end_q_02_slr0_3 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_3 <= p1_end_q_02_slr1_3;
    end
    if (reset) begin
      p1_end_q_02_slr0_4 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_4 <= p1_end_q_02_slr1_4;
    end
    if (reset) begin
      p1_end_q_02_slr0_5 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_5 <= p1_end_q_02_slr1_5;
    end
    if (reset) begin
      p1_end_q_02_slr0_6 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_6 <= p1_end_q_02_slr1_6;
    end
    if (reset) begin
      p1_end_q_02_slr0_7 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_7 <= p1_end_q_02_slr1_7;
    end
    if (reset) begin
      p1_end_q_02_slr0_8 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_8 <= p1_end_q_02_slr1_8;
    end
    if (reset) begin
      p1_end_q_02_slr0_9 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_9 <= p1_end_q_02_slr1_9;
    end
    if (reset) begin
      p1_end_q_02_slr0_10 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_10 <= p1_end_q_02_slr1_10;
    end
    if (reset) begin
      p1_end_q_02_slr0_11 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_11 <= p1_end_q_02_slr1_11;
    end
    if (reset) begin
      p1_end_q_02_slr0_12 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_12 <= p1_end_q_02_slr1_12;
    end
    if (reset) begin
      p1_end_q_02_slr0_13 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_13 <= p1_end_q_02_slr1_13;
    end
    if (reset) begin
      p1_end_q_02_slr0_14 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_14 <= p1_end_q_02_slr1_14;
    end
    if (reset) begin
      p1_end_q_02_slr0_15 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_15 <= p1_end_q_02_slr1_15;
    end
    if (reset) begin
      p1_end_q_02_slr0_16 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_16 <= p1_end_q_02_slr1_16;
    end
    if (reset) begin
      p1_end_q_02_slr0_17 <= 1'h0;
    end else begin
      p1_end_q_02_slr0_17 <= p1_end_q_02_slr1_17;
    end
    if (reset) begin
      p1_end_q_02_slr1_0 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_0 <= p1_end_q_02_slr2_0;
    end
    if (reset) begin
      p1_end_q_02_slr1_1 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_1 <= p1_end_q_02_slr2_1;
    end
    if (reset) begin
      p1_end_q_02_slr1_2 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_2 <= p1_end_q_02_slr2_2;
    end
    if (reset) begin
      p1_end_q_02_slr1_3 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_3 <= p1_end_q_02_slr2_3;
    end
    if (reset) begin
      p1_end_q_02_slr1_4 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_4 <= p1_end_q_02_slr2_4;
    end
    if (reset) begin
      p1_end_q_02_slr1_5 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_5 <= p1_end_q_02_slr2_5;
    end
    if (reset) begin
      p1_end_q_02_slr1_6 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_6 <= p1_end_q_02_slr2_6;
    end
    if (reset) begin
      p1_end_q_02_slr1_7 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_7 <= p1_end_q_02_slr2_7;
    end
    if (reset) begin
      p1_end_q_02_slr1_8 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_8 <= p1_end_q_02_slr2_8;
    end
    if (reset) begin
      p1_end_q_02_slr1_9 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_9 <= p1_end_q_02_slr2_9;
    end
    if (reset) begin
      p1_end_q_02_slr1_10 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_10 <= p1_end_q_02_slr2_10;
    end
    if (reset) begin
      p1_end_q_02_slr1_11 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_11 <= p1_end_q_02_slr2_11;
    end
    if (reset) begin
      p1_end_q_02_slr1_12 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_12 <= p1_end_q_02_slr2_12;
    end
    if (reset) begin
      p1_end_q_02_slr1_13 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_13 <= p1_end_q_02_slr2_13;
    end
    if (reset) begin
      p1_end_q_02_slr1_14 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_14 <= p1_end_q_02_slr2_14;
    end
    if (reset) begin
      p1_end_q_02_slr1_15 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_15 <= p1_end_q_02_slr2_15;
    end
    if (reset) begin
      p1_end_q_02_slr1_16 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_16 <= p1_end_q_02_slr2_16;
    end
    if (reset) begin
      p1_end_q_02_slr1_17 <= 1'h0;
    end else begin
      p1_end_q_02_slr1_17 <= p1_end_q_02_slr2_17;
    end
    if (reset) begin
      p1_end_q_02_slr2_0 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_0 <= SLR2_io_p1_end_0;
    end
    if (reset) begin
      p1_end_q_02_slr2_1 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_1 <= SLR2_io_p1_end_1;
    end
    if (reset) begin
      p1_end_q_02_slr2_2 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_2 <= SLR2_io_p1_end_2;
    end
    if (reset) begin
      p1_end_q_02_slr2_3 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_3 <= SLR2_io_p1_end_3;
    end
    if (reset) begin
      p1_end_q_02_slr2_4 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_4 <= SLR2_io_p1_end_4;
    end
    if (reset) begin
      p1_end_q_02_slr2_5 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_5 <= SLR2_io_p1_end_5;
    end
    if (reset) begin
      p1_end_q_02_slr2_6 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_6 <= SLR2_io_p1_end_6;
    end
    if (reset) begin
      p1_end_q_02_slr2_7 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_7 <= SLR2_io_p1_end_7;
    end
    if (reset) begin
      p1_end_q_02_slr2_8 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_8 <= SLR2_io_p1_end_8;
    end
    if (reset) begin
      p1_end_q_02_slr2_9 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_9 <= SLR2_io_p1_end_9;
    end
    if (reset) begin
      p1_end_q_02_slr2_10 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_10 <= SLR2_io_p1_end_10;
    end
    if (reset) begin
      p1_end_q_02_slr2_11 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_11 <= SLR2_io_p1_end_11;
    end
    if (reset) begin
      p1_end_q_02_slr2_12 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_12 <= SLR2_io_p1_end_12;
    end
    if (reset) begin
      p1_end_q_02_slr2_13 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_13 <= SLR2_io_p1_end_13;
    end
    if (reset) begin
      p1_end_q_02_slr2_14 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_14 <= SLR2_io_p1_end_14;
    end
    if (reset) begin
      p1_end_q_02_slr2_15 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_15 <= SLR2_io_p1_end_15;
    end
    if (reset) begin
      p1_end_q_02_slr2_16 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_16 <= SLR2_io_p1_end_16;
    end
    if (reset) begin
      p1_end_q_02_slr2_17 <= 1'h0;
    end else begin
      p1_end_q_02_slr2_17 <= SLR2_io_p1_end_17;
    end
    if (reset) begin
      uram_out_a_02_slr0_0 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_0 <= uram_out_a_02_slr1_0;
    end
    if (reset) begin
      uram_out_a_02_slr0_1 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_1 <= uram_out_a_02_slr1_1;
    end
    if (reset) begin
      uram_out_a_02_slr0_2 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_2 <= uram_out_a_02_slr1_2;
    end
    if (reset) begin
      uram_out_a_02_slr0_3 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_3 <= uram_out_a_02_slr1_3;
    end
    if (reset) begin
      uram_out_a_02_slr0_4 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_4 <= uram_out_a_02_slr1_4;
    end
    if (reset) begin
      uram_out_a_02_slr0_5 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_5 <= uram_out_a_02_slr1_5;
    end
    if (reset) begin
      uram_out_a_02_slr0_6 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_6 <= uram_out_a_02_slr1_6;
    end
    if (reset) begin
      uram_out_a_02_slr0_7 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_7 <= uram_out_a_02_slr1_7;
    end
    if (reset) begin
      uram_out_a_02_slr0_8 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_8 <= uram_out_a_02_slr1_8;
    end
    if (reset) begin
      uram_out_a_02_slr0_9 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_9 <= uram_out_a_02_slr1_9;
    end
    if (reset) begin
      uram_out_a_02_slr0_10 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_10 <= uram_out_a_02_slr1_10;
    end
    if (reset) begin
      uram_out_a_02_slr0_11 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_11 <= uram_out_a_02_slr1_11;
    end
    if (reset) begin
      uram_out_a_02_slr0_12 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_12 <= uram_out_a_02_slr1_12;
    end
    if (reset) begin
      uram_out_a_02_slr0_13 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_13 <= uram_out_a_02_slr1_13;
    end
    if (reset) begin
      uram_out_a_02_slr0_14 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_14 <= uram_out_a_02_slr1_14;
    end
    if (reset) begin
      uram_out_a_02_slr0_15 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_15 <= uram_out_a_02_slr1_15;
    end
    if (reset) begin
      uram_out_a_02_slr0_16 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_16 <= uram_out_a_02_slr1_16;
    end
    if (reset) begin
      uram_out_a_02_slr0_17 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_17 <= uram_out_a_02_slr1_17;
    end
    if (reset) begin
      uram_out_a_02_slr0_18 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_18 <= uram_out_a_02_slr1_18;
    end
    if (reset) begin
      uram_out_a_02_slr0_19 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_19 <= uram_out_a_02_slr1_19;
    end
    if (reset) begin
      uram_out_a_02_slr0_20 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_20 <= uram_out_a_02_slr1_20;
    end
    if (reset) begin
      uram_out_a_02_slr0_21 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_21 <= uram_out_a_02_slr1_21;
    end
    if (reset) begin
      uram_out_a_02_slr0_22 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_22 <= uram_out_a_02_slr1_22;
    end
    if (reset) begin
      uram_out_a_02_slr0_23 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_23 <= uram_out_a_02_slr1_23;
    end
    if (reset) begin
      uram_out_a_02_slr0_24 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_24 <= uram_out_a_02_slr1_24;
    end
    if (reset) begin
      uram_out_a_02_slr0_25 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_25 <= uram_out_a_02_slr1_25;
    end
    if (reset) begin
      uram_out_a_02_slr0_26 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_26 <= uram_out_a_02_slr1_26;
    end
    if (reset) begin
      uram_out_a_02_slr0_27 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_27 <= uram_out_a_02_slr1_27;
    end
    if (reset) begin
      uram_out_a_02_slr0_28 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_28 <= uram_out_a_02_slr1_28;
    end
    if (reset) begin
      uram_out_a_02_slr0_29 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_29 <= uram_out_a_02_slr1_29;
    end
    if (reset) begin
      uram_out_a_02_slr0_30 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_30 <= uram_out_a_02_slr1_30;
    end
    if (reset) begin
      uram_out_a_02_slr0_31 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_31 <= uram_out_a_02_slr1_31;
    end
    if (reset) begin
      uram_out_a_02_slr0_32 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_32 <= uram_out_a_02_slr1_32;
    end
    if (reset) begin
      uram_out_a_02_slr0_33 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_33 <= uram_out_a_02_slr1_33;
    end
    if (reset) begin
      uram_out_a_02_slr0_34 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_34 <= uram_out_a_02_slr1_34;
    end
    if (reset) begin
      uram_out_a_02_slr0_35 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_35 <= uram_out_a_02_slr1_35;
    end
    if (reset) begin
      uram_out_a_02_slr0_36 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_36 <= uram_out_a_02_slr1_36;
    end
    if (reset) begin
      uram_out_a_02_slr0_37 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_37 <= uram_out_a_02_slr1_37;
    end
    if (reset) begin
      uram_out_a_02_slr0_38 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_38 <= uram_out_a_02_slr1_38;
    end
    if (reset) begin
      uram_out_a_02_slr0_39 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_39 <= uram_out_a_02_slr1_39;
    end
    if (reset) begin
      uram_out_a_02_slr0_40 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_40 <= uram_out_a_02_slr1_40;
    end
    if (reset) begin
      uram_out_a_02_slr0_41 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_41 <= uram_out_a_02_slr1_41;
    end
    if (reset) begin
      uram_out_a_02_slr0_42 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_42 <= uram_out_a_02_slr1_42;
    end
    if (reset) begin
      uram_out_a_02_slr0_43 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_43 <= uram_out_a_02_slr1_43;
    end
    if (reset) begin
      uram_out_a_02_slr0_44 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_44 <= uram_out_a_02_slr1_44;
    end
    if (reset) begin
      uram_out_a_02_slr0_45 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_45 <= uram_out_a_02_slr1_45;
    end
    if (reset) begin
      uram_out_a_02_slr0_46 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_46 <= uram_out_a_02_slr1_46;
    end
    if (reset) begin
      uram_out_a_02_slr0_47 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_47 <= uram_out_a_02_slr1_47;
    end
    if (reset) begin
      uram_out_a_02_slr0_48 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_48 <= uram_out_a_02_slr1_48;
    end
    if (reset) begin
      uram_out_a_02_slr0_49 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_49 <= uram_out_a_02_slr1_49;
    end
    if (reset) begin
      uram_out_a_02_slr0_50 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_50 <= uram_out_a_02_slr1_50;
    end
    if (reset) begin
      uram_out_a_02_slr0_51 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_51 <= uram_out_a_02_slr1_51;
    end
    if (reset) begin
      uram_out_a_02_slr0_52 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_52 <= uram_out_a_02_slr1_52;
    end
    if (reset) begin
      uram_out_a_02_slr0_53 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_53 <= uram_out_a_02_slr1_53;
    end
    if (reset) begin
      uram_out_a_02_slr0_54 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_54 <= uram_out_a_02_slr1_54;
    end
    if (reset) begin
      uram_out_a_02_slr0_55 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_55 <= uram_out_a_02_slr1_55;
    end
    if (reset) begin
      uram_out_a_02_slr0_56 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_56 <= uram_out_a_02_slr1_56;
    end
    if (reset) begin
      uram_out_a_02_slr0_57 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_57 <= uram_out_a_02_slr1_57;
    end
    if (reset) begin
      uram_out_a_02_slr0_58 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_58 <= uram_out_a_02_slr1_58;
    end
    if (reset) begin
      uram_out_a_02_slr0_59 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_59 <= uram_out_a_02_slr1_59;
    end
    if (reset) begin
      uram_out_a_02_slr0_60 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_60 <= uram_out_a_02_slr1_60;
    end
    if (reset) begin
      uram_out_a_02_slr0_61 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_61 <= uram_out_a_02_slr1_61;
    end
    if (reset) begin
      uram_out_a_02_slr0_62 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_62 <= uram_out_a_02_slr1_62;
    end
    if (reset) begin
      uram_out_a_02_slr0_63 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_63 <= uram_out_a_02_slr1_63;
    end
    if (reset) begin
      uram_out_a_02_slr0_64 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_64 <= uram_out_a_02_slr1_64;
    end
    if (reset) begin
      uram_out_a_02_slr0_65 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_65 <= uram_out_a_02_slr1_65;
    end
    if (reset) begin
      uram_out_a_02_slr0_66 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_66 <= uram_out_a_02_slr1_66;
    end
    if (reset) begin
      uram_out_a_02_slr0_67 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_67 <= uram_out_a_02_slr1_67;
    end
    if (reset) begin
      uram_out_a_02_slr0_68 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_68 <= uram_out_a_02_slr1_68;
    end
    if (reset) begin
      uram_out_a_02_slr0_69 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_69 <= uram_out_a_02_slr1_69;
    end
    if (reset) begin
      uram_out_a_02_slr0_70 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_70 <= uram_out_a_02_slr1_70;
    end
    if (reset) begin
      uram_out_a_02_slr0_71 <= 64'h0;
    end else begin
      uram_out_a_02_slr0_71 <= uram_out_a_02_slr1_71;
    end
    if (reset) begin
      uram_out_a_02_slr1_0 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_0 <= uram_out_a_02_slr2_0;
    end
    if (reset) begin
      uram_out_a_02_slr1_1 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_1 <= uram_out_a_02_slr2_1;
    end
    if (reset) begin
      uram_out_a_02_slr1_2 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_2 <= uram_out_a_02_slr2_2;
    end
    if (reset) begin
      uram_out_a_02_slr1_3 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_3 <= uram_out_a_02_slr2_3;
    end
    if (reset) begin
      uram_out_a_02_slr1_4 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_4 <= uram_out_a_02_slr2_4;
    end
    if (reset) begin
      uram_out_a_02_slr1_5 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_5 <= uram_out_a_02_slr2_5;
    end
    if (reset) begin
      uram_out_a_02_slr1_6 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_6 <= uram_out_a_02_slr2_6;
    end
    if (reset) begin
      uram_out_a_02_slr1_7 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_7 <= uram_out_a_02_slr2_7;
    end
    if (reset) begin
      uram_out_a_02_slr1_8 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_8 <= uram_out_a_02_slr2_8;
    end
    if (reset) begin
      uram_out_a_02_slr1_9 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_9 <= uram_out_a_02_slr2_9;
    end
    if (reset) begin
      uram_out_a_02_slr1_10 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_10 <= uram_out_a_02_slr2_10;
    end
    if (reset) begin
      uram_out_a_02_slr1_11 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_11 <= uram_out_a_02_slr2_11;
    end
    if (reset) begin
      uram_out_a_02_slr1_12 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_12 <= uram_out_a_02_slr2_12;
    end
    if (reset) begin
      uram_out_a_02_slr1_13 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_13 <= uram_out_a_02_slr2_13;
    end
    if (reset) begin
      uram_out_a_02_slr1_14 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_14 <= uram_out_a_02_slr2_14;
    end
    if (reset) begin
      uram_out_a_02_slr1_15 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_15 <= uram_out_a_02_slr2_15;
    end
    if (reset) begin
      uram_out_a_02_slr1_16 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_16 <= uram_out_a_02_slr2_16;
    end
    if (reset) begin
      uram_out_a_02_slr1_17 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_17 <= uram_out_a_02_slr2_17;
    end
    if (reset) begin
      uram_out_a_02_slr1_18 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_18 <= uram_out_a_02_slr2_18;
    end
    if (reset) begin
      uram_out_a_02_slr1_19 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_19 <= uram_out_a_02_slr2_19;
    end
    if (reset) begin
      uram_out_a_02_slr1_20 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_20 <= uram_out_a_02_slr2_20;
    end
    if (reset) begin
      uram_out_a_02_slr1_21 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_21 <= uram_out_a_02_slr2_21;
    end
    if (reset) begin
      uram_out_a_02_slr1_22 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_22 <= uram_out_a_02_slr2_22;
    end
    if (reset) begin
      uram_out_a_02_slr1_23 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_23 <= uram_out_a_02_slr2_23;
    end
    if (reset) begin
      uram_out_a_02_slr1_24 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_24 <= uram_out_a_02_slr2_24;
    end
    if (reset) begin
      uram_out_a_02_slr1_25 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_25 <= uram_out_a_02_slr2_25;
    end
    if (reset) begin
      uram_out_a_02_slr1_26 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_26 <= uram_out_a_02_slr2_26;
    end
    if (reset) begin
      uram_out_a_02_slr1_27 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_27 <= uram_out_a_02_slr2_27;
    end
    if (reset) begin
      uram_out_a_02_slr1_28 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_28 <= uram_out_a_02_slr2_28;
    end
    if (reset) begin
      uram_out_a_02_slr1_29 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_29 <= uram_out_a_02_slr2_29;
    end
    if (reset) begin
      uram_out_a_02_slr1_30 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_30 <= uram_out_a_02_slr2_30;
    end
    if (reset) begin
      uram_out_a_02_slr1_31 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_31 <= uram_out_a_02_slr2_31;
    end
    if (reset) begin
      uram_out_a_02_slr1_32 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_32 <= uram_out_a_02_slr2_32;
    end
    if (reset) begin
      uram_out_a_02_slr1_33 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_33 <= uram_out_a_02_slr2_33;
    end
    if (reset) begin
      uram_out_a_02_slr1_34 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_34 <= uram_out_a_02_slr2_34;
    end
    if (reset) begin
      uram_out_a_02_slr1_35 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_35 <= uram_out_a_02_slr2_35;
    end
    if (reset) begin
      uram_out_a_02_slr1_36 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_36 <= uram_out_a_02_slr2_36;
    end
    if (reset) begin
      uram_out_a_02_slr1_37 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_37 <= uram_out_a_02_slr2_37;
    end
    if (reset) begin
      uram_out_a_02_slr1_38 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_38 <= uram_out_a_02_slr2_38;
    end
    if (reset) begin
      uram_out_a_02_slr1_39 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_39 <= uram_out_a_02_slr2_39;
    end
    if (reset) begin
      uram_out_a_02_slr1_40 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_40 <= uram_out_a_02_slr2_40;
    end
    if (reset) begin
      uram_out_a_02_slr1_41 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_41 <= uram_out_a_02_slr2_41;
    end
    if (reset) begin
      uram_out_a_02_slr1_42 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_42 <= uram_out_a_02_slr2_42;
    end
    if (reset) begin
      uram_out_a_02_slr1_43 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_43 <= uram_out_a_02_slr2_43;
    end
    if (reset) begin
      uram_out_a_02_slr1_44 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_44 <= uram_out_a_02_slr2_44;
    end
    if (reset) begin
      uram_out_a_02_slr1_45 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_45 <= uram_out_a_02_slr2_45;
    end
    if (reset) begin
      uram_out_a_02_slr1_46 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_46 <= uram_out_a_02_slr2_46;
    end
    if (reset) begin
      uram_out_a_02_slr1_47 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_47 <= uram_out_a_02_slr2_47;
    end
    if (reset) begin
      uram_out_a_02_slr1_48 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_48 <= uram_out_a_02_slr2_48;
    end
    if (reset) begin
      uram_out_a_02_slr1_49 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_49 <= uram_out_a_02_slr2_49;
    end
    if (reset) begin
      uram_out_a_02_slr1_50 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_50 <= uram_out_a_02_slr2_50;
    end
    if (reset) begin
      uram_out_a_02_slr1_51 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_51 <= uram_out_a_02_slr2_51;
    end
    if (reset) begin
      uram_out_a_02_slr1_52 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_52 <= uram_out_a_02_slr2_52;
    end
    if (reset) begin
      uram_out_a_02_slr1_53 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_53 <= uram_out_a_02_slr2_53;
    end
    if (reset) begin
      uram_out_a_02_slr1_54 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_54 <= uram_out_a_02_slr2_54;
    end
    if (reset) begin
      uram_out_a_02_slr1_55 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_55 <= uram_out_a_02_slr2_55;
    end
    if (reset) begin
      uram_out_a_02_slr1_56 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_56 <= uram_out_a_02_slr2_56;
    end
    if (reset) begin
      uram_out_a_02_slr1_57 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_57 <= uram_out_a_02_slr2_57;
    end
    if (reset) begin
      uram_out_a_02_slr1_58 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_58 <= uram_out_a_02_slr2_58;
    end
    if (reset) begin
      uram_out_a_02_slr1_59 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_59 <= uram_out_a_02_slr2_59;
    end
    if (reset) begin
      uram_out_a_02_slr1_60 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_60 <= uram_out_a_02_slr2_60;
    end
    if (reset) begin
      uram_out_a_02_slr1_61 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_61 <= uram_out_a_02_slr2_61;
    end
    if (reset) begin
      uram_out_a_02_slr1_62 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_62 <= uram_out_a_02_slr2_62;
    end
    if (reset) begin
      uram_out_a_02_slr1_63 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_63 <= uram_out_a_02_slr2_63;
    end
    if (reset) begin
      uram_out_a_02_slr1_64 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_64 <= uram_out_a_02_slr2_64;
    end
    if (reset) begin
      uram_out_a_02_slr1_65 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_65 <= uram_out_a_02_slr2_65;
    end
    if (reset) begin
      uram_out_a_02_slr1_66 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_66 <= uram_out_a_02_slr2_66;
    end
    if (reset) begin
      uram_out_a_02_slr1_67 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_67 <= uram_out_a_02_slr2_67;
    end
    if (reset) begin
      uram_out_a_02_slr1_68 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_68 <= uram_out_a_02_slr2_68;
    end
    if (reset) begin
      uram_out_a_02_slr1_69 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_69 <= uram_out_a_02_slr2_69;
    end
    if (reset) begin
      uram_out_a_02_slr1_70 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_70 <= uram_out_a_02_slr2_70;
    end
    if (reset) begin
      uram_out_a_02_slr1_71 <= 64'h0;
    end else begin
      uram_out_a_02_slr1_71 <= uram_out_a_02_slr2_71;
    end
    if (reset) begin
      uram_out_a_02_slr2_0 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_0 <= SLR2_io_uram_out_a_0;
    end
    if (reset) begin
      uram_out_a_02_slr2_1 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_1 <= SLR2_io_uram_out_a_1;
    end
    if (reset) begin
      uram_out_a_02_slr2_2 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_2 <= SLR2_io_uram_out_a_2;
    end
    if (reset) begin
      uram_out_a_02_slr2_3 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_3 <= SLR2_io_uram_out_a_3;
    end
    if (reset) begin
      uram_out_a_02_slr2_4 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_4 <= SLR2_io_uram_out_a_4;
    end
    if (reset) begin
      uram_out_a_02_slr2_5 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_5 <= SLR2_io_uram_out_a_5;
    end
    if (reset) begin
      uram_out_a_02_slr2_6 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_6 <= SLR2_io_uram_out_a_6;
    end
    if (reset) begin
      uram_out_a_02_slr2_7 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_7 <= SLR2_io_uram_out_a_7;
    end
    if (reset) begin
      uram_out_a_02_slr2_8 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_8 <= SLR2_io_uram_out_a_8;
    end
    if (reset) begin
      uram_out_a_02_slr2_9 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_9 <= SLR2_io_uram_out_a_9;
    end
    if (reset) begin
      uram_out_a_02_slr2_10 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_10 <= SLR2_io_uram_out_a_10;
    end
    if (reset) begin
      uram_out_a_02_slr2_11 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_11 <= SLR2_io_uram_out_a_11;
    end
    if (reset) begin
      uram_out_a_02_slr2_12 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_12 <= SLR2_io_uram_out_a_12;
    end
    if (reset) begin
      uram_out_a_02_slr2_13 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_13 <= SLR2_io_uram_out_a_13;
    end
    if (reset) begin
      uram_out_a_02_slr2_14 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_14 <= SLR2_io_uram_out_a_14;
    end
    if (reset) begin
      uram_out_a_02_slr2_15 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_15 <= SLR2_io_uram_out_a_15;
    end
    if (reset) begin
      uram_out_a_02_slr2_16 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_16 <= SLR2_io_uram_out_a_16;
    end
    if (reset) begin
      uram_out_a_02_slr2_17 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_17 <= SLR2_io_uram_out_a_17;
    end
    if (reset) begin
      uram_out_a_02_slr2_18 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_18 <= SLR2_io_uram_out_a_18;
    end
    if (reset) begin
      uram_out_a_02_slr2_19 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_19 <= SLR2_io_uram_out_a_19;
    end
    if (reset) begin
      uram_out_a_02_slr2_20 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_20 <= SLR2_io_uram_out_a_20;
    end
    if (reset) begin
      uram_out_a_02_slr2_21 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_21 <= SLR2_io_uram_out_a_21;
    end
    if (reset) begin
      uram_out_a_02_slr2_22 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_22 <= SLR2_io_uram_out_a_22;
    end
    if (reset) begin
      uram_out_a_02_slr2_23 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_23 <= SLR2_io_uram_out_a_23;
    end
    if (reset) begin
      uram_out_a_02_slr2_24 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_24 <= SLR2_io_uram_out_a_24;
    end
    if (reset) begin
      uram_out_a_02_slr2_25 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_25 <= SLR2_io_uram_out_a_25;
    end
    if (reset) begin
      uram_out_a_02_slr2_26 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_26 <= SLR2_io_uram_out_a_26;
    end
    if (reset) begin
      uram_out_a_02_slr2_27 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_27 <= SLR2_io_uram_out_a_27;
    end
    if (reset) begin
      uram_out_a_02_slr2_28 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_28 <= SLR2_io_uram_out_a_28;
    end
    if (reset) begin
      uram_out_a_02_slr2_29 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_29 <= SLR2_io_uram_out_a_29;
    end
    if (reset) begin
      uram_out_a_02_slr2_30 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_30 <= SLR2_io_uram_out_a_30;
    end
    if (reset) begin
      uram_out_a_02_slr2_31 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_31 <= SLR2_io_uram_out_a_31;
    end
    if (reset) begin
      uram_out_a_02_slr2_32 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_32 <= SLR2_io_uram_out_a_32;
    end
    if (reset) begin
      uram_out_a_02_slr2_33 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_33 <= SLR2_io_uram_out_a_33;
    end
    if (reset) begin
      uram_out_a_02_slr2_34 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_34 <= SLR2_io_uram_out_a_34;
    end
    if (reset) begin
      uram_out_a_02_slr2_35 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_35 <= SLR2_io_uram_out_a_35;
    end
    if (reset) begin
      uram_out_a_02_slr2_36 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_36 <= SLR2_io_uram_out_a_36;
    end
    if (reset) begin
      uram_out_a_02_slr2_37 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_37 <= SLR2_io_uram_out_a_37;
    end
    if (reset) begin
      uram_out_a_02_slr2_38 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_38 <= SLR2_io_uram_out_a_38;
    end
    if (reset) begin
      uram_out_a_02_slr2_39 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_39 <= SLR2_io_uram_out_a_39;
    end
    if (reset) begin
      uram_out_a_02_slr2_40 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_40 <= SLR2_io_uram_out_a_40;
    end
    if (reset) begin
      uram_out_a_02_slr2_41 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_41 <= SLR2_io_uram_out_a_41;
    end
    if (reset) begin
      uram_out_a_02_slr2_42 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_42 <= SLR2_io_uram_out_a_42;
    end
    if (reset) begin
      uram_out_a_02_slr2_43 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_43 <= SLR2_io_uram_out_a_43;
    end
    if (reset) begin
      uram_out_a_02_slr2_44 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_44 <= SLR2_io_uram_out_a_44;
    end
    if (reset) begin
      uram_out_a_02_slr2_45 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_45 <= SLR2_io_uram_out_a_45;
    end
    if (reset) begin
      uram_out_a_02_slr2_46 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_46 <= SLR2_io_uram_out_a_46;
    end
    if (reset) begin
      uram_out_a_02_slr2_47 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_47 <= SLR2_io_uram_out_a_47;
    end
    if (reset) begin
      uram_out_a_02_slr2_48 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_48 <= SLR2_io_uram_out_a_48;
    end
    if (reset) begin
      uram_out_a_02_slr2_49 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_49 <= SLR2_io_uram_out_a_49;
    end
    if (reset) begin
      uram_out_a_02_slr2_50 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_50 <= SLR2_io_uram_out_a_50;
    end
    if (reset) begin
      uram_out_a_02_slr2_51 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_51 <= SLR2_io_uram_out_a_51;
    end
    if (reset) begin
      uram_out_a_02_slr2_52 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_52 <= SLR2_io_uram_out_a_52;
    end
    if (reset) begin
      uram_out_a_02_slr2_53 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_53 <= SLR2_io_uram_out_a_53;
    end
    if (reset) begin
      uram_out_a_02_slr2_54 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_54 <= SLR2_io_uram_out_a_54;
    end
    if (reset) begin
      uram_out_a_02_slr2_55 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_55 <= SLR2_io_uram_out_a_55;
    end
    if (reset) begin
      uram_out_a_02_slr2_56 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_56 <= SLR2_io_uram_out_a_56;
    end
    if (reset) begin
      uram_out_a_02_slr2_57 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_57 <= SLR2_io_uram_out_a_57;
    end
    if (reset) begin
      uram_out_a_02_slr2_58 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_58 <= SLR2_io_uram_out_a_58;
    end
    if (reset) begin
      uram_out_a_02_slr2_59 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_59 <= SLR2_io_uram_out_a_59;
    end
    if (reset) begin
      uram_out_a_02_slr2_60 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_60 <= SLR2_io_uram_out_a_60;
    end
    if (reset) begin
      uram_out_a_02_slr2_61 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_61 <= SLR2_io_uram_out_a_61;
    end
    if (reset) begin
      uram_out_a_02_slr2_62 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_62 <= SLR2_io_uram_out_a_62;
    end
    if (reset) begin
      uram_out_a_02_slr2_63 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_63 <= SLR2_io_uram_out_a_63;
    end
    if (reset) begin
      uram_out_a_02_slr2_64 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_64 <= SLR2_io_uram_out_a_64;
    end
    if (reset) begin
      uram_out_a_02_slr2_65 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_65 <= SLR2_io_uram_out_a_65;
    end
    if (reset) begin
      uram_out_a_02_slr2_66 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_66 <= SLR2_io_uram_out_a_66;
    end
    if (reset) begin
      uram_out_a_02_slr2_67 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_67 <= SLR2_io_uram_out_a_67;
    end
    if (reset) begin
      uram_out_a_02_slr2_68 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_68 <= SLR2_io_uram_out_a_68;
    end
    if (reset) begin
      uram_out_a_02_slr2_69 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_69 <= SLR2_io_uram_out_a_69;
    end
    if (reset) begin
      uram_out_a_02_slr2_70 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_70 <= SLR2_io_uram_out_a_70;
    end
    if (reset) begin
      uram_out_a_02_slr2_71 <= 64'h0;
    end else begin
      uram_out_a_02_slr2_71 <= SLR2_io_uram_out_a_71;
    end
    if (reset) begin
      uram_addr_a_02_slr0_0 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_0 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_56};
    end
    if (reset) begin
      uram_addr_a_02_slr0_1 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_1 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_57};
    end
    if (reset) begin
      uram_addr_a_02_slr0_2 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_2 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_58};
    end
    if (reset) begin
      uram_addr_a_02_slr0_3 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_3 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_59};
    end
    if (reset) begin
      uram_addr_a_02_slr0_4 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_4 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_60};
    end
    if (reset) begin
      uram_addr_a_02_slr0_5 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_5 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_61};
    end
    if (reset) begin
      uram_addr_a_02_slr0_6 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_6 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_62};
    end
    if (reset) begin
      uram_addr_a_02_slr0_7 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_7 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_63};
    end
    if (reset) begin
      uram_addr_a_02_slr0_8 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_8 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_64};
    end
    if (reset) begin
      uram_addr_a_02_slr0_9 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_9 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_65};
    end
    if (reset) begin
      uram_addr_a_02_slr0_10 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_10 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_66};
    end
    if (reset) begin
      uram_addr_a_02_slr0_11 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_11 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_67};
    end
    if (reset) begin
      uram_addr_a_02_slr0_12 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_12 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_68};
    end
    if (reset) begin
      uram_addr_a_02_slr0_13 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_13 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_69};
    end
    if (reset) begin
      uram_addr_a_02_slr0_14 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_14 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_70};
    end
    if (reset) begin
      uram_addr_a_02_slr0_15 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_15 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_71};
    end
    if (reset) begin
      uram_addr_a_02_slr0_16 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_16 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_72};
    end
    if (reset) begin
      uram_addr_a_02_slr0_17 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_17 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_73};
    end
    if (reset) begin
      uram_addr_a_02_slr0_18 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_18 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_74};
    end
    if (reset) begin
      uram_addr_a_02_slr0_19 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_19 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_75};
    end
    if (reset) begin
      uram_addr_a_02_slr0_20 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_20 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_76};
    end
    if (reset) begin
      uram_addr_a_02_slr0_21 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_21 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_77};
    end
    if (reset) begin
      uram_addr_a_02_slr0_22 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_22 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_78};
    end
    if (reset) begin
      uram_addr_a_02_slr0_23 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_23 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_79};
    end
    if (reset) begin
      uram_addr_a_02_slr0_24 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_24 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_80};
    end
    if (reset) begin
      uram_addr_a_02_slr0_25 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_25 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_81};
    end
    if (reset) begin
      uram_addr_a_02_slr0_26 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_26 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_82};
    end
    if (reset) begin
      uram_addr_a_02_slr0_27 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_27 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_83};
    end
    if (reset) begin
      uram_addr_a_02_slr0_28 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_28 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_84};
    end
    if (reset) begin
      uram_addr_a_02_slr0_29 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_29 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_85};
    end
    if (reset) begin
      uram_addr_a_02_slr0_30 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_30 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_86};
    end
    if (reset) begin
      uram_addr_a_02_slr0_31 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_31 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_87};
    end
    if (reset) begin
      uram_addr_a_02_slr0_32 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_32 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_88};
    end
    if (reset) begin
      uram_addr_a_02_slr0_33 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_33 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_89};
    end
    if (reset) begin
      uram_addr_a_02_slr0_34 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_34 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_90};
    end
    if (reset) begin
      uram_addr_a_02_slr0_35 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_35 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_91};
    end
    if (reset) begin
      uram_addr_a_02_slr0_36 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_36 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_92};
    end
    if (reset) begin
      uram_addr_a_02_slr0_37 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_37 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_93};
    end
    if (reset) begin
      uram_addr_a_02_slr0_38 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_38 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_94};
    end
    if (reset) begin
      uram_addr_a_02_slr0_39 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_39 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_95};
    end
    if (reset) begin
      uram_addr_a_02_slr0_40 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_40 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_96};
    end
    if (reset) begin
      uram_addr_a_02_slr0_41 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_41 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_97};
    end
    if (reset) begin
      uram_addr_a_02_slr0_42 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_42 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_98};
    end
    if (reset) begin
      uram_addr_a_02_slr0_43 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_43 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_99};
    end
    if (reset) begin
      uram_addr_a_02_slr0_44 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_44 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_100};
    end
    if (reset) begin
      uram_addr_a_02_slr0_45 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_45 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_101};
    end
    if (reset) begin
      uram_addr_a_02_slr0_46 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_46 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_102};
    end
    if (reset) begin
      uram_addr_a_02_slr0_47 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_47 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_103};
    end
    if (reset) begin
      uram_addr_a_02_slr0_48 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_48 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_104};
    end
    if (reset) begin
      uram_addr_a_02_slr0_49 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_49 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_105};
    end
    if (reset) begin
      uram_addr_a_02_slr0_50 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_50 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_106};
    end
    if (reset) begin
      uram_addr_a_02_slr0_51 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_51 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_107};
    end
    if (reset) begin
      uram_addr_a_02_slr0_52 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_52 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_108};
    end
    if (reset) begin
      uram_addr_a_02_slr0_53 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_53 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_109};
    end
    if (reset) begin
      uram_addr_a_02_slr0_54 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_54 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_110};
    end
    if (reset) begin
      uram_addr_a_02_slr0_55 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_55 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_111};
    end
    if (reset) begin
      uram_addr_a_02_slr0_56 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_56 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_112};
    end
    if (reset) begin
      uram_addr_a_02_slr0_57 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_57 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_113};
    end
    if (reset) begin
      uram_addr_a_02_slr0_58 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_58 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_114};
    end
    if (reset) begin
      uram_addr_a_02_slr0_59 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_59 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_115};
    end
    if (reset) begin
      uram_addr_a_02_slr0_60 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_60 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_116};
    end
    if (reset) begin
      uram_addr_a_02_slr0_61 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_61 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_117};
    end
    if (reset) begin
      uram_addr_a_02_slr0_62 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_62 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_118};
    end
    if (reset) begin
      uram_addr_a_02_slr0_63 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_63 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_119};
    end
    if (reset) begin
      uram_addr_a_02_slr0_64 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_64 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_120};
    end
    if (reset) begin
      uram_addr_a_02_slr0_65 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_65 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_121};
    end
    if (reset) begin
      uram_addr_a_02_slr0_66 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_66 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_122};
    end
    if (reset) begin
      uram_addr_a_02_slr0_67 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_67 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_123};
    end
    if (reset) begin
      uram_addr_a_02_slr0_68 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_68 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_124};
    end
    if (reset) begin
      uram_addr_a_02_slr0_69 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_69 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_125};
    end
    if (reset) begin
      uram_addr_a_02_slr0_70 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_70 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_126};
    end
    if (reset) begin
      uram_addr_a_02_slr0_71 <= 64'h0;
    end else begin
      uram_addr_a_02_slr0_71 <= {{44'd0}, SLR0_Mem_io_uram_addr_a_127};
    end
    if (reset) begin
      uram_addr_a_02_slr1_0 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_0 <= uram_addr_a_02_slr0_0;
    end
    if (reset) begin
      uram_addr_a_02_slr1_1 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_1 <= uram_addr_a_02_slr0_1;
    end
    if (reset) begin
      uram_addr_a_02_slr1_2 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_2 <= uram_addr_a_02_slr0_2;
    end
    if (reset) begin
      uram_addr_a_02_slr1_3 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_3 <= uram_addr_a_02_slr0_3;
    end
    if (reset) begin
      uram_addr_a_02_slr1_4 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_4 <= uram_addr_a_02_slr0_4;
    end
    if (reset) begin
      uram_addr_a_02_slr1_5 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_5 <= uram_addr_a_02_slr0_5;
    end
    if (reset) begin
      uram_addr_a_02_slr1_6 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_6 <= uram_addr_a_02_slr0_6;
    end
    if (reset) begin
      uram_addr_a_02_slr1_7 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_7 <= uram_addr_a_02_slr0_7;
    end
    if (reset) begin
      uram_addr_a_02_slr1_8 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_8 <= uram_addr_a_02_slr0_8;
    end
    if (reset) begin
      uram_addr_a_02_slr1_9 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_9 <= uram_addr_a_02_slr0_9;
    end
    if (reset) begin
      uram_addr_a_02_slr1_10 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_10 <= uram_addr_a_02_slr0_10;
    end
    if (reset) begin
      uram_addr_a_02_slr1_11 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_11 <= uram_addr_a_02_slr0_11;
    end
    if (reset) begin
      uram_addr_a_02_slr1_12 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_12 <= uram_addr_a_02_slr0_12;
    end
    if (reset) begin
      uram_addr_a_02_slr1_13 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_13 <= uram_addr_a_02_slr0_13;
    end
    if (reset) begin
      uram_addr_a_02_slr1_14 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_14 <= uram_addr_a_02_slr0_14;
    end
    if (reset) begin
      uram_addr_a_02_slr1_15 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_15 <= uram_addr_a_02_slr0_15;
    end
    if (reset) begin
      uram_addr_a_02_slr1_16 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_16 <= uram_addr_a_02_slr0_16;
    end
    if (reset) begin
      uram_addr_a_02_slr1_17 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_17 <= uram_addr_a_02_slr0_17;
    end
    if (reset) begin
      uram_addr_a_02_slr1_18 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_18 <= uram_addr_a_02_slr0_18;
    end
    if (reset) begin
      uram_addr_a_02_slr1_19 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_19 <= uram_addr_a_02_slr0_19;
    end
    if (reset) begin
      uram_addr_a_02_slr1_20 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_20 <= uram_addr_a_02_slr0_20;
    end
    if (reset) begin
      uram_addr_a_02_slr1_21 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_21 <= uram_addr_a_02_slr0_21;
    end
    if (reset) begin
      uram_addr_a_02_slr1_22 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_22 <= uram_addr_a_02_slr0_22;
    end
    if (reset) begin
      uram_addr_a_02_slr1_23 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_23 <= uram_addr_a_02_slr0_23;
    end
    if (reset) begin
      uram_addr_a_02_slr1_24 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_24 <= uram_addr_a_02_slr0_24;
    end
    if (reset) begin
      uram_addr_a_02_slr1_25 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_25 <= uram_addr_a_02_slr0_25;
    end
    if (reset) begin
      uram_addr_a_02_slr1_26 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_26 <= uram_addr_a_02_slr0_26;
    end
    if (reset) begin
      uram_addr_a_02_slr1_27 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_27 <= uram_addr_a_02_slr0_27;
    end
    if (reset) begin
      uram_addr_a_02_slr1_28 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_28 <= uram_addr_a_02_slr0_28;
    end
    if (reset) begin
      uram_addr_a_02_slr1_29 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_29 <= uram_addr_a_02_slr0_29;
    end
    if (reset) begin
      uram_addr_a_02_slr1_30 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_30 <= uram_addr_a_02_slr0_30;
    end
    if (reset) begin
      uram_addr_a_02_slr1_31 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_31 <= uram_addr_a_02_slr0_31;
    end
    if (reset) begin
      uram_addr_a_02_slr1_32 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_32 <= uram_addr_a_02_slr0_32;
    end
    if (reset) begin
      uram_addr_a_02_slr1_33 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_33 <= uram_addr_a_02_slr0_33;
    end
    if (reset) begin
      uram_addr_a_02_slr1_34 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_34 <= uram_addr_a_02_slr0_34;
    end
    if (reset) begin
      uram_addr_a_02_slr1_35 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_35 <= uram_addr_a_02_slr0_35;
    end
    if (reset) begin
      uram_addr_a_02_slr1_36 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_36 <= uram_addr_a_02_slr0_36;
    end
    if (reset) begin
      uram_addr_a_02_slr1_37 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_37 <= uram_addr_a_02_slr0_37;
    end
    if (reset) begin
      uram_addr_a_02_slr1_38 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_38 <= uram_addr_a_02_slr0_38;
    end
    if (reset) begin
      uram_addr_a_02_slr1_39 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_39 <= uram_addr_a_02_slr0_39;
    end
    if (reset) begin
      uram_addr_a_02_slr1_40 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_40 <= uram_addr_a_02_slr0_40;
    end
    if (reset) begin
      uram_addr_a_02_slr1_41 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_41 <= uram_addr_a_02_slr0_41;
    end
    if (reset) begin
      uram_addr_a_02_slr1_42 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_42 <= uram_addr_a_02_slr0_42;
    end
    if (reset) begin
      uram_addr_a_02_slr1_43 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_43 <= uram_addr_a_02_slr0_43;
    end
    if (reset) begin
      uram_addr_a_02_slr1_44 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_44 <= uram_addr_a_02_slr0_44;
    end
    if (reset) begin
      uram_addr_a_02_slr1_45 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_45 <= uram_addr_a_02_slr0_45;
    end
    if (reset) begin
      uram_addr_a_02_slr1_46 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_46 <= uram_addr_a_02_slr0_46;
    end
    if (reset) begin
      uram_addr_a_02_slr1_47 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_47 <= uram_addr_a_02_slr0_47;
    end
    if (reset) begin
      uram_addr_a_02_slr1_48 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_48 <= uram_addr_a_02_slr0_48;
    end
    if (reset) begin
      uram_addr_a_02_slr1_49 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_49 <= uram_addr_a_02_slr0_49;
    end
    if (reset) begin
      uram_addr_a_02_slr1_50 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_50 <= uram_addr_a_02_slr0_50;
    end
    if (reset) begin
      uram_addr_a_02_slr1_51 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_51 <= uram_addr_a_02_slr0_51;
    end
    if (reset) begin
      uram_addr_a_02_slr1_52 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_52 <= uram_addr_a_02_slr0_52;
    end
    if (reset) begin
      uram_addr_a_02_slr1_53 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_53 <= uram_addr_a_02_slr0_53;
    end
    if (reset) begin
      uram_addr_a_02_slr1_54 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_54 <= uram_addr_a_02_slr0_54;
    end
    if (reset) begin
      uram_addr_a_02_slr1_55 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_55 <= uram_addr_a_02_slr0_55;
    end
    if (reset) begin
      uram_addr_a_02_slr1_56 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_56 <= uram_addr_a_02_slr0_56;
    end
    if (reset) begin
      uram_addr_a_02_slr1_57 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_57 <= uram_addr_a_02_slr0_57;
    end
    if (reset) begin
      uram_addr_a_02_slr1_58 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_58 <= uram_addr_a_02_slr0_58;
    end
    if (reset) begin
      uram_addr_a_02_slr1_59 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_59 <= uram_addr_a_02_slr0_59;
    end
    if (reset) begin
      uram_addr_a_02_slr1_60 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_60 <= uram_addr_a_02_slr0_60;
    end
    if (reset) begin
      uram_addr_a_02_slr1_61 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_61 <= uram_addr_a_02_slr0_61;
    end
    if (reset) begin
      uram_addr_a_02_slr1_62 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_62 <= uram_addr_a_02_slr0_62;
    end
    if (reset) begin
      uram_addr_a_02_slr1_63 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_63 <= uram_addr_a_02_slr0_63;
    end
    if (reset) begin
      uram_addr_a_02_slr1_64 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_64 <= uram_addr_a_02_slr0_64;
    end
    if (reset) begin
      uram_addr_a_02_slr1_65 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_65 <= uram_addr_a_02_slr0_65;
    end
    if (reset) begin
      uram_addr_a_02_slr1_66 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_66 <= uram_addr_a_02_slr0_66;
    end
    if (reset) begin
      uram_addr_a_02_slr1_67 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_67 <= uram_addr_a_02_slr0_67;
    end
    if (reset) begin
      uram_addr_a_02_slr1_68 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_68 <= uram_addr_a_02_slr0_68;
    end
    if (reset) begin
      uram_addr_a_02_slr1_69 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_69 <= uram_addr_a_02_slr0_69;
    end
    if (reset) begin
      uram_addr_a_02_slr1_70 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_70 <= uram_addr_a_02_slr0_70;
    end
    if (reset) begin
      uram_addr_a_02_slr1_71 <= 64'h0;
    end else begin
      uram_addr_a_02_slr1_71 <= uram_addr_a_02_slr0_71;
    end
    if (reset) begin
      uram_addr_a_02_slr2_0 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_0 <= uram_addr_a_02_slr1_0;
    end
    if (reset) begin
      uram_addr_a_02_slr2_1 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_1 <= uram_addr_a_02_slr1_1;
    end
    if (reset) begin
      uram_addr_a_02_slr2_2 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_2 <= uram_addr_a_02_slr1_2;
    end
    if (reset) begin
      uram_addr_a_02_slr2_3 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_3 <= uram_addr_a_02_slr1_3;
    end
    if (reset) begin
      uram_addr_a_02_slr2_4 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_4 <= uram_addr_a_02_slr1_4;
    end
    if (reset) begin
      uram_addr_a_02_slr2_5 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_5 <= uram_addr_a_02_slr1_5;
    end
    if (reset) begin
      uram_addr_a_02_slr2_6 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_6 <= uram_addr_a_02_slr1_6;
    end
    if (reset) begin
      uram_addr_a_02_slr2_7 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_7 <= uram_addr_a_02_slr1_7;
    end
    if (reset) begin
      uram_addr_a_02_slr2_8 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_8 <= uram_addr_a_02_slr1_8;
    end
    if (reset) begin
      uram_addr_a_02_slr2_9 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_9 <= uram_addr_a_02_slr1_9;
    end
    if (reset) begin
      uram_addr_a_02_slr2_10 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_10 <= uram_addr_a_02_slr1_10;
    end
    if (reset) begin
      uram_addr_a_02_slr2_11 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_11 <= uram_addr_a_02_slr1_11;
    end
    if (reset) begin
      uram_addr_a_02_slr2_12 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_12 <= uram_addr_a_02_slr1_12;
    end
    if (reset) begin
      uram_addr_a_02_slr2_13 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_13 <= uram_addr_a_02_slr1_13;
    end
    if (reset) begin
      uram_addr_a_02_slr2_14 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_14 <= uram_addr_a_02_slr1_14;
    end
    if (reset) begin
      uram_addr_a_02_slr2_15 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_15 <= uram_addr_a_02_slr1_15;
    end
    if (reset) begin
      uram_addr_a_02_slr2_16 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_16 <= uram_addr_a_02_slr1_16;
    end
    if (reset) begin
      uram_addr_a_02_slr2_17 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_17 <= uram_addr_a_02_slr1_17;
    end
    if (reset) begin
      uram_addr_a_02_slr2_18 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_18 <= uram_addr_a_02_slr1_18;
    end
    if (reset) begin
      uram_addr_a_02_slr2_19 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_19 <= uram_addr_a_02_slr1_19;
    end
    if (reset) begin
      uram_addr_a_02_slr2_20 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_20 <= uram_addr_a_02_slr1_20;
    end
    if (reset) begin
      uram_addr_a_02_slr2_21 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_21 <= uram_addr_a_02_slr1_21;
    end
    if (reset) begin
      uram_addr_a_02_slr2_22 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_22 <= uram_addr_a_02_slr1_22;
    end
    if (reset) begin
      uram_addr_a_02_slr2_23 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_23 <= uram_addr_a_02_slr1_23;
    end
    if (reset) begin
      uram_addr_a_02_slr2_24 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_24 <= uram_addr_a_02_slr1_24;
    end
    if (reset) begin
      uram_addr_a_02_slr2_25 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_25 <= uram_addr_a_02_slr1_25;
    end
    if (reset) begin
      uram_addr_a_02_slr2_26 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_26 <= uram_addr_a_02_slr1_26;
    end
    if (reset) begin
      uram_addr_a_02_slr2_27 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_27 <= uram_addr_a_02_slr1_27;
    end
    if (reset) begin
      uram_addr_a_02_slr2_28 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_28 <= uram_addr_a_02_slr1_28;
    end
    if (reset) begin
      uram_addr_a_02_slr2_29 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_29 <= uram_addr_a_02_slr1_29;
    end
    if (reset) begin
      uram_addr_a_02_slr2_30 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_30 <= uram_addr_a_02_slr1_30;
    end
    if (reset) begin
      uram_addr_a_02_slr2_31 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_31 <= uram_addr_a_02_slr1_31;
    end
    if (reset) begin
      uram_addr_a_02_slr2_32 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_32 <= uram_addr_a_02_slr1_32;
    end
    if (reset) begin
      uram_addr_a_02_slr2_33 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_33 <= uram_addr_a_02_slr1_33;
    end
    if (reset) begin
      uram_addr_a_02_slr2_34 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_34 <= uram_addr_a_02_slr1_34;
    end
    if (reset) begin
      uram_addr_a_02_slr2_35 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_35 <= uram_addr_a_02_slr1_35;
    end
    if (reset) begin
      uram_addr_a_02_slr2_36 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_36 <= uram_addr_a_02_slr1_36;
    end
    if (reset) begin
      uram_addr_a_02_slr2_37 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_37 <= uram_addr_a_02_slr1_37;
    end
    if (reset) begin
      uram_addr_a_02_slr2_38 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_38 <= uram_addr_a_02_slr1_38;
    end
    if (reset) begin
      uram_addr_a_02_slr2_39 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_39 <= uram_addr_a_02_slr1_39;
    end
    if (reset) begin
      uram_addr_a_02_slr2_40 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_40 <= uram_addr_a_02_slr1_40;
    end
    if (reset) begin
      uram_addr_a_02_slr2_41 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_41 <= uram_addr_a_02_slr1_41;
    end
    if (reset) begin
      uram_addr_a_02_slr2_42 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_42 <= uram_addr_a_02_slr1_42;
    end
    if (reset) begin
      uram_addr_a_02_slr2_43 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_43 <= uram_addr_a_02_slr1_43;
    end
    if (reset) begin
      uram_addr_a_02_slr2_44 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_44 <= uram_addr_a_02_slr1_44;
    end
    if (reset) begin
      uram_addr_a_02_slr2_45 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_45 <= uram_addr_a_02_slr1_45;
    end
    if (reset) begin
      uram_addr_a_02_slr2_46 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_46 <= uram_addr_a_02_slr1_46;
    end
    if (reset) begin
      uram_addr_a_02_slr2_47 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_47 <= uram_addr_a_02_slr1_47;
    end
    if (reset) begin
      uram_addr_a_02_slr2_48 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_48 <= uram_addr_a_02_slr1_48;
    end
    if (reset) begin
      uram_addr_a_02_slr2_49 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_49 <= uram_addr_a_02_slr1_49;
    end
    if (reset) begin
      uram_addr_a_02_slr2_50 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_50 <= uram_addr_a_02_slr1_50;
    end
    if (reset) begin
      uram_addr_a_02_slr2_51 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_51 <= uram_addr_a_02_slr1_51;
    end
    if (reset) begin
      uram_addr_a_02_slr2_52 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_52 <= uram_addr_a_02_slr1_52;
    end
    if (reset) begin
      uram_addr_a_02_slr2_53 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_53 <= uram_addr_a_02_slr1_53;
    end
    if (reset) begin
      uram_addr_a_02_slr2_54 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_54 <= uram_addr_a_02_slr1_54;
    end
    if (reset) begin
      uram_addr_a_02_slr2_55 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_55 <= uram_addr_a_02_slr1_55;
    end
    if (reset) begin
      uram_addr_a_02_slr2_56 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_56 <= uram_addr_a_02_slr1_56;
    end
    if (reset) begin
      uram_addr_a_02_slr2_57 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_57 <= uram_addr_a_02_slr1_57;
    end
    if (reset) begin
      uram_addr_a_02_slr2_58 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_58 <= uram_addr_a_02_slr1_58;
    end
    if (reset) begin
      uram_addr_a_02_slr2_59 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_59 <= uram_addr_a_02_slr1_59;
    end
    if (reset) begin
      uram_addr_a_02_slr2_60 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_60 <= uram_addr_a_02_slr1_60;
    end
    if (reset) begin
      uram_addr_a_02_slr2_61 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_61 <= uram_addr_a_02_slr1_61;
    end
    if (reset) begin
      uram_addr_a_02_slr2_62 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_62 <= uram_addr_a_02_slr1_62;
    end
    if (reset) begin
      uram_addr_a_02_slr2_63 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_63 <= uram_addr_a_02_slr1_63;
    end
    if (reset) begin
      uram_addr_a_02_slr2_64 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_64 <= uram_addr_a_02_slr1_64;
    end
    if (reset) begin
      uram_addr_a_02_slr2_65 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_65 <= uram_addr_a_02_slr1_65;
    end
    if (reset) begin
      uram_addr_a_02_slr2_66 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_66 <= uram_addr_a_02_slr1_66;
    end
    if (reset) begin
      uram_addr_a_02_slr2_67 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_67 <= uram_addr_a_02_slr1_67;
    end
    if (reset) begin
      uram_addr_a_02_slr2_68 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_68 <= uram_addr_a_02_slr1_68;
    end
    if (reset) begin
      uram_addr_a_02_slr2_69 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_69 <= uram_addr_a_02_slr1_69;
    end
    if (reset) begin
      uram_addr_a_02_slr2_70 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_70 <= uram_addr_a_02_slr1_70;
    end
    if (reset) begin
      uram_addr_a_02_slr2_71 <= 64'h0;
    end else begin
      uram_addr_a_02_slr2_71 <= uram_addr_a_02_slr1_71;
    end
    _T_881 <= R_array_index_02_slr2_deq_valid;
    _T_882 <= R_array_index_02_slr1_deq_valid;
    _T_883 <= R_array_index_02_slr0_deq_valid;
    _T_887 <= R_array_index_02_slr2_1_deq_valid;
    _T_888 <= R_array_index_02_slr1_1_deq_valid;
    _T_889 <= R_array_index_02_slr0_1_deq_valid;
    _T_893 <= R_array_index_02_slr2_2_deq_valid;
    _T_894 <= R_array_index_02_slr1_2_deq_valid;
    _T_895 <= R_array_index_02_slr0_2_deq_valid;
    _T_899 <= R_array_index_02_slr2_3_deq_valid;
    _T_900 <= R_array_index_02_slr1_3_deq_valid;
    _T_901 <= R_array_index_02_slr0_3_deq_valid;
    _T_905 <= R_array_index_02_slr2_4_deq_valid;
    _T_906 <= R_array_index_02_slr1_4_deq_valid;
    _T_907 <= R_array_index_02_slr0_4_deq_valid;
    _T_911 <= R_array_index_02_slr2_5_deq_valid;
    _T_912 <= R_array_index_02_slr1_5_deq_valid;
    _T_913 <= R_array_index_02_slr0_5_deq_valid;
    _T_917 <= R_array_index_02_slr2_6_deq_valid;
    _T_918 <= R_array_index_02_slr1_6_deq_valid;
    _T_919 <= R_array_index_02_slr0_6_deq_valid;
    _T_923 <= R_array_index_02_slr2_7_deq_valid;
    _T_924 <= R_array_index_02_slr1_7_deq_valid;
    _T_925 <= R_array_index_02_slr0_7_deq_valid;
    _T_929 <= R_array_index_02_slr2_8_deq_valid;
    _T_930 <= R_array_index_02_slr1_8_deq_valid;
    _T_931 <= R_array_index_02_slr0_8_deq_valid;
    _T_935 <= R_array_index_02_slr2_9_deq_valid;
    _T_936 <= R_array_index_02_slr1_9_deq_valid;
    _T_937 <= R_array_index_02_slr0_9_deq_valid;
    _T_941 <= R_array_index_02_slr2_10_deq_valid;
    _T_942 <= R_array_index_02_slr1_10_deq_valid;
    _T_943 <= R_array_index_02_slr0_10_deq_valid;
    _T_947 <= R_array_index_02_slr2_11_deq_valid;
    _T_948 <= R_array_index_02_slr1_11_deq_valid;
    _T_949 <= R_array_index_02_slr0_11_deq_valid;
    _T_953 <= R_array_index_02_slr2_12_deq_valid;
    _T_954 <= R_array_index_02_slr1_12_deq_valid;
    _T_955 <= R_array_index_02_slr0_12_deq_valid;
    _T_959 <= R_array_index_02_slr2_13_deq_valid;
    _T_960 <= R_array_index_02_slr1_13_deq_valid;
    _T_961 <= R_array_index_02_slr0_13_deq_valid;
    _T_965 <= R_array_index_02_slr2_14_deq_valid;
    _T_966 <= R_array_index_02_slr1_14_deq_valid;
    _T_967 <= R_array_index_02_slr0_14_deq_valid;
    _T_971 <= R_array_index_02_slr2_15_deq_valid;
    _T_972 <= R_array_index_02_slr1_15_deq_valid;
    _T_973 <= R_array_index_02_slr0_15_deq_valid;
    _T_977 <= R_array_index_02_slr2_16_deq_valid;
    _T_978 <= R_array_index_02_slr1_16_deq_valid;
    _T_979 <= R_array_index_02_slr0_16_deq_valid;
    _T_983 <= R_array_index_02_slr2_17_deq_valid;
    _T_984 <= R_array_index_02_slr1_17_deq_valid;
    _T_985 <= R_array_index_02_slr0_17_deq_valid;
    _T_989 <= R_array_index_02_slr2_18_deq_valid;
    _T_990 <= R_array_index_02_slr1_18_deq_valid;
    _T_991 <= R_array_index_02_slr0_18_deq_valid;
    _T_995 <= R_array_index_02_slr2_19_deq_valid;
    _T_996 <= R_array_index_02_slr1_19_deq_valid;
    _T_997 <= R_array_index_02_slr0_19_deq_valid;
    _T_1001 <= R_array_index_02_slr2_20_deq_valid;
    _T_1002 <= R_array_index_02_slr1_20_deq_valid;
    _T_1003 <= R_array_index_02_slr0_20_deq_valid;
    _T_1007 <= R_array_index_02_slr2_21_deq_valid;
    _T_1008 <= R_array_index_02_slr1_21_deq_valid;
    _T_1009 <= R_array_index_02_slr0_21_deq_valid;
    _T_1013 <= R_array_index_02_slr2_22_deq_valid;
    _T_1014 <= R_array_index_02_slr1_22_deq_valid;
    _T_1015 <= R_array_index_02_slr0_22_deq_valid;
    _T_1019 <= R_array_index_02_slr2_23_deq_valid;
    _T_1020 <= R_array_index_02_slr1_23_deq_valid;
    _T_1021 <= R_array_index_02_slr0_23_deq_valid;
    _T_1025 <= R_array_index_02_slr2_24_deq_valid;
    _T_1026 <= R_array_index_02_slr1_24_deq_valid;
    _T_1027 <= R_array_index_02_slr0_24_deq_valid;
    _T_1031 <= R_array_index_02_slr2_25_deq_valid;
    _T_1032 <= R_array_index_02_slr1_25_deq_valid;
    _T_1033 <= R_array_index_02_slr0_25_deq_valid;
    _T_1037 <= R_array_index_02_slr2_26_deq_valid;
    _T_1038 <= R_array_index_02_slr1_26_deq_valid;
    _T_1039 <= R_array_index_02_slr0_26_deq_valid;
    _T_1043 <= R_array_index_02_slr2_27_deq_valid;
    _T_1044 <= R_array_index_02_slr1_27_deq_valid;
    _T_1045 <= R_array_index_02_slr0_27_deq_valid;
    _T_1049 <= R_array_index_02_slr2_28_deq_valid;
    _T_1050 <= R_array_index_02_slr1_28_deq_valid;
    _T_1051 <= R_array_index_02_slr0_28_deq_valid;
    _T_1055 <= R_array_index_02_slr2_29_deq_valid;
    _T_1056 <= R_array_index_02_slr1_29_deq_valid;
    _T_1057 <= R_array_index_02_slr0_29_deq_valid;
    _T_1061 <= R_array_index_02_slr2_30_deq_valid;
    _T_1062 <= R_array_index_02_slr1_30_deq_valid;
    _T_1063 <= R_array_index_02_slr0_30_deq_valid;
    _T_1067 <= R_array_index_02_slr2_31_deq_valid;
    _T_1068 <= R_array_index_02_slr1_31_deq_valid;
    _T_1069 <= R_array_index_02_slr0_31_deq_valid;
    _T_1073 <= R_array_index_02_slr2_32_deq_valid;
    _T_1074 <= R_array_index_02_slr1_32_deq_valid;
    _T_1075 <= R_array_index_02_slr0_32_deq_valid;
    _T_1079 <= R_array_index_02_slr2_33_deq_valid;
    _T_1080 <= R_array_index_02_slr1_33_deq_valid;
    _T_1081 <= R_array_index_02_slr0_33_deq_valid;
    _T_1085 <= R_array_index_02_slr2_34_deq_valid;
    _T_1086 <= R_array_index_02_slr1_34_deq_valid;
    _T_1087 <= R_array_index_02_slr0_34_deq_valid;
    _T_1091 <= R_array_index_02_slr2_35_deq_valid;
    _T_1092 <= R_array_index_02_slr1_35_deq_valid;
    _T_1093 <= R_array_index_02_slr0_35_deq_valid;
    _T_1097 <= R_array_index_02_slr2_36_deq_valid;
    _T_1098 <= R_array_index_02_slr1_36_deq_valid;
    _T_1099 <= R_array_index_02_slr0_36_deq_valid;
    _T_1103 <= R_array_index_02_slr2_37_deq_valid;
    _T_1104 <= R_array_index_02_slr1_37_deq_valid;
    _T_1105 <= R_array_index_02_slr0_37_deq_valid;
    _T_1109 <= R_array_index_02_slr2_38_deq_valid;
    _T_1110 <= R_array_index_02_slr1_38_deq_valid;
    _T_1111 <= R_array_index_02_slr0_38_deq_valid;
    _T_1115 <= R_array_index_02_slr2_39_deq_valid;
    _T_1116 <= R_array_index_02_slr1_39_deq_valid;
    _T_1117 <= R_array_index_02_slr0_39_deq_valid;
    _T_1121 <= R_array_index_02_slr2_40_deq_valid;
    _T_1122 <= R_array_index_02_slr1_40_deq_valid;
    _T_1123 <= R_array_index_02_slr0_40_deq_valid;
    _T_1127 <= R_array_index_02_slr2_41_deq_valid;
    _T_1128 <= R_array_index_02_slr1_41_deq_valid;
    _T_1129 <= R_array_index_02_slr0_41_deq_valid;
    _T_1133 <= R_array_index_02_slr2_42_deq_valid;
    _T_1134 <= R_array_index_02_slr1_42_deq_valid;
    _T_1135 <= R_array_index_02_slr0_42_deq_valid;
    _T_1139 <= R_array_index_02_slr2_43_deq_valid;
    _T_1140 <= R_array_index_02_slr1_43_deq_valid;
    _T_1141 <= R_array_index_02_slr0_43_deq_valid;
    _T_1145 <= R_array_index_02_slr2_44_deq_valid;
    _T_1146 <= R_array_index_02_slr1_44_deq_valid;
    _T_1147 <= R_array_index_02_slr0_44_deq_valid;
    _T_1151 <= R_array_index_02_slr2_45_deq_valid;
    _T_1152 <= R_array_index_02_slr1_45_deq_valid;
    _T_1153 <= R_array_index_02_slr0_45_deq_valid;
    _T_1157 <= R_array_index_02_slr2_46_deq_valid;
    _T_1158 <= R_array_index_02_slr1_46_deq_valid;
    _T_1159 <= R_array_index_02_slr0_46_deq_valid;
    _T_1163 <= R_array_index_02_slr2_47_deq_valid;
    _T_1164 <= R_array_index_02_slr1_47_deq_valid;
    _T_1165 <= R_array_index_02_slr0_47_deq_valid;
    _T_1169 <= R_array_index_02_slr2_48_deq_valid;
    _T_1170 <= R_array_index_02_slr1_48_deq_valid;
    _T_1171 <= R_array_index_02_slr0_48_deq_valid;
    _T_1175 <= R_array_index_02_slr2_49_deq_valid;
    _T_1176 <= R_array_index_02_slr1_49_deq_valid;
    _T_1177 <= R_array_index_02_slr0_49_deq_valid;
    _T_1181 <= R_array_index_02_slr2_50_deq_valid;
    _T_1182 <= R_array_index_02_slr1_50_deq_valid;
    _T_1183 <= R_array_index_02_slr0_50_deq_valid;
    _T_1187 <= R_array_index_02_slr2_51_deq_valid;
    _T_1188 <= R_array_index_02_slr1_51_deq_valid;
    _T_1189 <= R_array_index_02_slr0_51_deq_valid;
    _T_1193 <= R_array_index_02_slr2_52_deq_valid;
    _T_1194 <= R_array_index_02_slr1_52_deq_valid;
    _T_1195 <= R_array_index_02_slr0_52_deq_valid;
    _T_1199 <= R_array_index_02_slr2_53_deq_valid;
    _T_1200 <= R_array_index_02_slr1_53_deq_valid;
    _T_1201 <= R_array_index_02_slr0_53_deq_valid;
    _T_1205 <= R_array_index_02_slr2_54_deq_valid;
    _T_1206 <= R_array_index_02_slr1_54_deq_valid;
    _T_1207 <= R_array_index_02_slr0_54_deq_valid;
    _T_1211 <= R_array_index_02_slr2_55_deq_valid;
    _T_1212 <= R_array_index_02_slr1_55_deq_valid;
    _T_1213 <= R_array_index_02_slr0_55_deq_valid;
    _T_1217 <= R_array_index_02_slr2_56_deq_valid;
    _T_1218 <= R_array_index_02_slr1_56_deq_valid;
    _T_1219 <= R_array_index_02_slr0_56_deq_valid;
    _T_1223 <= R_array_index_02_slr2_57_deq_valid;
    _T_1224 <= R_array_index_02_slr1_57_deq_valid;
    _T_1225 <= R_array_index_02_slr0_57_deq_valid;
    _T_1229 <= R_array_index_02_slr2_58_deq_valid;
    _T_1230 <= R_array_index_02_slr1_58_deq_valid;
    _T_1231 <= R_array_index_02_slr0_58_deq_valid;
    _T_1235 <= R_array_index_02_slr2_59_deq_valid;
    _T_1236 <= R_array_index_02_slr1_59_deq_valid;
    _T_1237 <= R_array_index_02_slr0_59_deq_valid;
    _T_1241 <= R_array_index_02_slr2_60_deq_valid;
    _T_1242 <= R_array_index_02_slr1_60_deq_valid;
    _T_1243 <= R_array_index_02_slr0_60_deq_valid;
    _T_1247 <= R_array_index_02_slr2_61_deq_valid;
    _T_1248 <= R_array_index_02_slr1_61_deq_valid;
    _T_1249 <= R_array_index_02_slr0_61_deq_valid;
    _T_1253 <= R_array_index_02_slr2_62_deq_valid;
    _T_1254 <= R_array_index_02_slr1_62_deq_valid;
    _T_1255 <= R_array_index_02_slr0_62_deq_valid;
    _T_1259 <= R_array_index_02_slr2_63_deq_valid;
    _T_1260 <= R_array_index_02_slr1_63_deq_valid;
    _T_1261 <= R_array_index_02_slr0_63_deq_valid;
    _T_1265 <= R_array_index_02_slr2_64_deq_valid;
    _T_1266 <= R_array_index_02_slr1_64_deq_valid;
    _T_1267 <= R_array_index_02_slr0_64_deq_valid;
    _T_1271 <= R_array_index_02_slr2_65_deq_valid;
    _T_1272 <= R_array_index_02_slr1_65_deq_valid;
    _T_1273 <= R_array_index_02_slr0_65_deq_valid;
    _T_1277 <= R_array_index_02_slr2_66_deq_valid;
    _T_1278 <= R_array_index_02_slr1_66_deq_valid;
    _T_1279 <= R_array_index_02_slr0_66_deq_valid;
    _T_1283 <= R_array_index_02_slr2_67_deq_valid;
    _T_1284 <= R_array_index_02_slr1_67_deq_valid;
    _T_1285 <= R_array_index_02_slr0_67_deq_valid;
    _T_1289 <= R_array_index_02_slr2_68_deq_valid;
    _T_1290 <= R_array_index_02_slr1_68_deq_valid;
    _T_1291 <= R_array_index_02_slr0_68_deq_valid;
    _T_1295 <= R_array_index_02_slr2_69_deq_valid;
    _T_1296 <= R_array_index_02_slr1_69_deq_valid;
    _T_1297 <= R_array_index_02_slr0_69_deq_valid;
    _T_1301 <= R_array_index_02_slr2_70_deq_valid;
    _T_1302 <= R_array_index_02_slr1_70_deq_valid;
    _T_1303 <= R_array_index_02_slr0_70_deq_valid;
    _T_1307 <= R_array_index_02_slr2_71_deq_valid;
    _T_1308 <= R_array_index_02_slr1_71_deq_valid;
    _T_1309 <= R_array_index_02_slr0_71_deq_valid;
    if (reset) begin
      r_array_count_2_0 <= 32'h0;
    end else if (_T_1455) begin
      r_array_count_2_0 <= _T_1457;
    end
    if (reset) begin
      r_array_count_2_1 <= 32'h0;
    end else if (_T_1458) begin
      r_array_count_2_1 <= _T_1460;
    end
    if (reset) begin
      r_array_count_2_2 <= 32'h0;
    end else if (_T_1461) begin
      r_array_count_2_2 <= _T_1463;
    end
    if (reset) begin
      r_array_count_2_3 <= 32'h0;
    end else if (_T_1464) begin
      r_array_count_2_3 <= _T_1466;
    end
    if (reset) begin
      r_array_count_2_4 <= 32'h0;
    end else if (_T_1467) begin
      r_array_count_2_4 <= _T_1469;
    end
    if (reset) begin
      r_array_count_2_5 <= 32'h0;
    end else if (_T_1470) begin
      r_array_count_2_5 <= _T_1472;
    end
    if (reset) begin
      r_array_count_2_6 <= 32'h0;
    end else if (_T_1473) begin
      r_array_count_2_6 <= _T_1475;
    end
    if (reset) begin
      r_array_count_2_7 <= 32'h0;
    end else if (_T_1476) begin
      r_array_count_2_7 <= _T_1478;
    end
    if (reset) begin
      r_array_count_2_8 <= 32'h0;
    end else if (_T_1479) begin
      r_array_count_2_8 <= _T_1481;
    end
    if (reset) begin
      r_array_count_2_9 <= 32'h0;
    end else if (_T_1482) begin
      r_array_count_2_9 <= _T_1484;
    end
    if (reset) begin
      r_array_count_2_10 <= 32'h0;
    end else if (_T_1485) begin
      r_array_count_2_10 <= _T_1487;
    end
    if (reset) begin
      r_array_count_2_11 <= 32'h0;
    end else if (_T_1488) begin
      r_array_count_2_11 <= _T_1490;
    end
    if (reset) begin
      r_array_count_2_12 <= 32'h0;
    end else if (_T_1491) begin
      r_array_count_2_12 <= _T_1493;
    end
    if (reset) begin
      r_array_count_2_13 <= 32'h0;
    end else if (_T_1494) begin
      r_array_count_2_13 <= _T_1496;
    end
    if (reset) begin
      r_array_count_2_14 <= 32'h0;
    end else if (_T_1497) begin
      r_array_count_2_14 <= _T_1499;
    end
    if (reset) begin
      r_array_count_2_15 <= 32'h0;
    end else if (_T_1500) begin
      r_array_count_2_15 <= _T_1502;
    end
    if (reset) begin
      r_array_count_2_16 <= 32'h0;
    end else if (_T_1503) begin
      r_array_count_2_16 <= _T_1505;
    end
    if (reset) begin
      r_array_count_2_17 <= 32'h0;
    end else if (_T_1506) begin
      r_array_count_2_17 <= _T_1508;
    end
    if (reset) begin
      r_array_count_2_18 <= 32'h0;
    end else if (_T_1509) begin
      r_array_count_2_18 <= _T_1511;
    end
    if (reset) begin
      r_array_count_2_19 <= 32'h0;
    end else if (_T_1512) begin
      r_array_count_2_19 <= _T_1514;
    end
    if (reset) begin
      r_array_count_2_20 <= 32'h0;
    end else if (_T_1515) begin
      r_array_count_2_20 <= _T_1517;
    end
    if (reset) begin
      r_array_count_2_21 <= 32'h0;
    end else if (_T_1518) begin
      r_array_count_2_21 <= _T_1520;
    end
    if (reset) begin
      r_array_count_2_22 <= 32'h0;
    end else if (_T_1521) begin
      r_array_count_2_22 <= _T_1523;
    end
    if (reset) begin
      r_array_count_2_23 <= 32'h0;
    end else if (_T_1524) begin
      r_array_count_2_23 <= _T_1526;
    end
    if (reset) begin
      r_array_count_2_24 <= 32'h0;
    end else if (_T_1527) begin
      r_array_count_2_24 <= _T_1529;
    end
    if (reset) begin
      r_array_count_2_25 <= 32'h0;
    end else if (_T_1530) begin
      r_array_count_2_25 <= _T_1532;
    end
    if (reset) begin
      r_array_count_2_26 <= 32'h0;
    end else if (_T_1533) begin
      r_array_count_2_26 <= _T_1535;
    end
    if (reset) begin
      r_array_count_2_27 <= 32'h0;
    end else if (_T_1536) begin
      r_array_count_2_27 <= _T_1538;
    end
    if (reset) begin
      r_array_count_2_28 <= 32'h0;
    end else if (_T_1539) begin
      r_array_count_2_28 <= _T_1541;
    end
    if (reset) begin
      r_array_count_2_29 <= 32'h0;
    end else if (_T_1542) begin
      r_array_count_2_29 <= _T_1544;
    end
    if (reset) begin
      r_array_count_2_30 <= 32'h0;
    end else if (_T_1545) begin
      r_array_count_2_30 <= _T_1547;
    end
    if (reset) begin
      r_array_count_2_31 <= 32'h0;
    end else if (_T_1548) begin
      r_array_count_2_31 <= _T_1550;
    end
    if (reset) begin
      r_array_count_2_32 <= 32'h0;
    end else if (_T_1551) begin
      r_array_count_2_32 <= _T_1553;
    end
    if (reset) begin
      r_array_count_2_33 <= 32'h0;
    end else if (_T_1554) begin
      r_array_count_2_33 <= _T_1556;
    end
    if (reset) begin
      r_array_count_2_34 <= 32'h0;
    end else if (_T_1557) begin
      r_array_count_2_34 <= _T_1559;
    end
    if (reset) begin
      r_array_count_2_35 <= 32'h0;
    end else if (_T_1560) begin
      r_array_count_2_35 <= _T_1562;
    end
    if (reset) begin
      r_array_count_2_36 <= 32'h0;
    end else if (_T_1563) begin
      r_array_count_2_36 <= _T_1565;
    end
    if (reset) begin
      r_array_count_2_37 <= 32'h0;
    end else if (_T_1566) begin
      r_array_count_2_37 <= _T_1568;
    end
    if (reset) begin
      r_array_count_2_38 <= 32'h0;
    end else if (_T_1569) begin
      r_array_count_2_38 <= _T_1571;
    end
    if (reset) begin
      r_array_count_2_39 <= 32'h0;
    end else if (_T_1572) begin
      r_array_count_2_39 <= _T_1574;
    end
    if (reset) begin
      r_array_count_2_40 <= 32'h0;
    end else if (_T_1575) begin
      r_array_count_2_40 <= _T_1577;
    end
    if (reset) begin
      r_array_count_2_41 <= 32'h0;
    end else if (_T_1578) begin
      r_array_count_2_41 <= _T_1580;
    end
    if (reset) begin
      r_array_count_2_42 <= 32'h0;
    end else if (_T_1581) begin
      r_array_count_2_42 <= _T_1583;
    end
    if (reset) begin
      r_array_count_2_43 <= 32'h0;
    end else if (_T_1584) begin
      r_array_count_2_43 <= _T_1586;
    end
    if (reset) begin
      r_array_count_2_44 <= 32'h0;
    end else if (_T_1587) begin
      r_array_count_2_44 <= _T_1589;
    end
    if (reset) begin
      r_array_count_2_45 <= 32'h0;
    end else if (_T_1590) begin
      r_array_count_2_45 <= _T_1592;
    end
    if (reset) begin
      r_array_count_2_46 <= 32'h0;
    end else if (_T_1593) begin
      r_array_count_2_46 <= _T_1595;
    end
    if (reset) begin
      r_array_count_2_47 <= 32'h0;
    end else if (_T_1596) begin
      r_array_count_2_47 <= _T_1598;
    end
    if (reset) begin
      r_array_count_2_48 <= 32'h0;
    end else if (_T_1599) begin
      r_array_count_2_48 <= _T_1601;
    end
    if (reset) begin
      r_array_count_2_49 <= 32'h0;
    end else if (_T_1602) begin
      r_array_count_2_49 <= _T_1604;
    end
    if (reset) begin
      r_array_count_2_50 <= 32'h0;
    end else if (_T_1605) begin
      r_array_count_2_50 <= _T_1607;
    end
    if (reset) begin
      r_array_count_2_51 <= 32'h0;
    end else if (_T_1608) begin
      r_array_count_2_51 <= _T_1610;
    end
    if (reset) begin
      r_array_count_2_52 <= 32'h0;
    end else if (_T_1611) begin
      r_array_count_2_52 <= _T_1613;
    end
    if (reset) begin
      r_array_count_2_53 <= 32'h0;
    end else if (_T_1614) begin
      r_array_count_2_53 <= _T_1616;
    end
    if (reset) begin
      r_array_count_2_54 <= 32'h0;
    end else if (_T_1617) begin
      r_array_count_2_54 <= _T_1619;
    end
    if (reset) begin
      r_array_count_2_55 <= 32'h0;
    end else if (_T_1620) begin
      r_array_count_2_55 <= _T_1622;
    end
    if (reset) begin
      r_array_count_2_56 <= 32'h0;
    end else if (_T_1623) begin
      r_array_count_2_56 <= _T_1625;
    end
    if (reset) begin
      r_array_count_2_57 <= 32'h0;
    end else if (_T_1626) begin
      r_array_count_2_57 <= _T_1628;
    end
    if (reset) begin
      r_array_count_2_58 <= 32'h0;
    end else if (_T_1629) begin
      r_array_count_2_58 <= _T_1631;
    end
    if (reset) begin
      r_array_count_2_59 <= 32'h0;
    end else if (_T_1632) begin
      r_array_count_2_59 <= _T_1634;
    end
    if (reset) begin
      r_array_count_2_60 <= 32'h0;
    end else if (_T_1635) begin
      r_array_count_2_60 <= _T_1637;
    end
    if (reset) begin
      r_array_count_2_61 <= 32'h0;
    end else if (_T_1638) begin
      r_array_count_2_61 <= _T_1640;
    end
    if (reset) begin
      r_array_count_2_62 <= 32'h0;
    end else if (_T_1641) begin
      r_array_count_2_62 <= _T_1643;
    end
    if (reset) begin
      r_array_count_2_63 <= 32'h0;
    end else if (_T_1644) begin
      r_array_count_2_63 <= _T_1646;
    end
    if (reset) begin
      r_array_count_2_64 <= 32'h0;
    end else if (_T_1647) begin
      r_array_count_2_64 <= _T_1649;
    end
    if (reset) begin
      r_array_count_2_65 <= 32'h0;
    end else if (_T_1650) begin
      r_array_count_2_65 <= _T_1652;
    end
    if (reset) begin
      r_array_count_2_66 <= 32'h0;
    end else if (_T_1653) begin
      r_array_count_2_66 <= _T_1655;
    end
    if (reset) begin
      r_array_count_2_67 <= 32'h0;
    end else if (_T_1656) begin
      r_array_count_2_67 <= _T_1658;
    end
    if (reset) begin
      r_array_count_2_68 <= 32'h0;
    end else if (_T_1659) begin
      r_array_count_2_68 <= _T_1661;
    end
    if (reset) begin
      r_array_count_2_69 <= 32'h0;
    end else if (_T_1662) begin
      r_array_count_2_69 <= _T_1664;
    end
    if (reset) begin
      r_array_count_2_70 <= 32'h0;
    end else if (_T_1665) begin
      r_array_count_2_70 <= _T_1667;
    end
    if (reset) begin
      r_array_count_2_71 <= 32'h0;
    end else if (_T_1668) begin
      r_array_count_2_71 <= _T_1670;
    end
    _T_1671 <= master_io_push_or_pull;
    _T_1673 <= master_io_push_or_pull;
    _T_1675 <= master_io_push_or_pull;
    _T_1677 <= master_io_push_or_pull;
    _T_1679 <= master_io_push_or_pull;
    _T_1681 <= master_io_push_or_pull;
    _T_1683 <= master_io_push_or_pull;
    _T_1685 <= master_io_push_or_pull;
    _T_1687 <= master_io_push_or_pull;
    _T_1689 <= master_io_push_or_pull;
    _T_1691 <= master_io_push_or_pull;
    _T_1693 <= master_io_push_or_pull;
    _T_1695 <= master_io_push_or_pull;
    _T_1697 <= master_io_push_or_pull;
    _T_1699 <= master_io_push_or_pull;
    _T_1701 <= master_io_push_or_pull;
    _T_1703 <= master_io_push_or_pull;
    _T_1705 <= master_io_push_or_pull;
    _T_1707 <= master_io_push_or_pull;
    _T_1709 <= master_io_push_or_pull;
    _T_1711 <= master_io_push_or_pull;
    _T_1713 <= master_io_push_or_pull;
    _T_1715 <= master_io_push_or_pull;
    _T_1717 <= master_io_push_or_pull;
    _T_1719 <= master_io_push_or_pull;
    _T_1721 <= master_io_push_or_pull;
    _T_1723 <= master_io_push_or_pull;
    _T_1725 <= master_io_push_or_pull;
    _T_1727 <= master_io_push_or_pull;
    _T_1729 <= master_io_push_or_pull;
    _T_1731 <= master_io_push_or_pull;
    _T_1733 <= master_io_push_or_pull;
    _T_1735 <= master_io_push_or_pull;
    _T_1737 <= master_io_push_or_pull;
    _T_1739 <= master_io_push_or_pull;
    _T_1741 <= master_io_push_or_pull;
    _T_1743 <= master_io_push_or_pull;
    _T_1745 <= master_io_push_or_pull;
    _T_1747 <= master_io_push_or_pull;
    _T_1749 <= master_io_push_or_pull;
    _T_1751 <= master_io_push_or_pull;
    _T_1753 <= master_io_push_or_pull;
    _T_1755 <= master_io_push_or_pull;
    _T_1757 <= master_io_push_or_pull;
    _T_1759 <= master_io_push_or_pull;
    _T_1761 <= master_io_push_or_pull;
    _T_1763 <= master_io_push_or_pull;
    _T_1765 <= master_io_push_or_pull;
    _T_1767 <= master_io_push_or_pull;
    _T_1769 <= master_io_push_or_pull;
    _T_1771 <= master_io_push_or_pull;
    _T_1773 <= master_io_push_or_pull;
    _T_1775 <= master_io_push_or_pull;
    _T_1777 <= master_io_push_or_pull;
    _T_1779 <= master_io_push_or_pull;
    _T_1781 <= master_io_push_or_pull;
    _T_1783 <= master_io_push_or_pull;
    _T_1785 <= master_io_push_or_pull;
    _T_1787 <= master_io_push_or_pull;
    _T_1789 <= master_io_push_or_pull;
    _T_1791 <= master_io_push_or_pull;
    _T_1793 <= master_io_push_or_pull;
    _T_1795 <= master_io_push_or_pull;
    _T_1797 <= master_io_push_or_pull;
    _T_1799 <= master_io_push_or_pull;
    _T_1801 <= master_io_push_or_pull;
    _T_1803 <= master_io_push_or_pull;
    _T_1805 <= master_io_push_or_pull;
    _T_1807 <= master_io_push_or_pull;
    _T_1809 <= master_io_push_or_pull;
    _T_1811 <= master_io_push_or_pull;
    _T_1813 <= master_io_push_or_pull;
    _T_1815 <= master_io_push_or_pull;
    _T_1817 <= master_io_push_or_pull;
    _T_1819 <= master_io_push_or_pull;
    _T_1821 <= master_io_push_or_pull;
    _T_1823 <= master_io_push_or_pull;
    _T_1825 <= master_io_push_or_pull;
    _T_1827 <= master_io_push_or_pull;
    _T_1829 <= master_io_push_or_pull;
    _T_1831 <= master_io_push_or_pull;
    _T_1833 <= master_io_push_or_pull;
    _T_1835 <= master_io_push_or_pull;
    _T_1837 <= master_io_push_or_pull;
    _T_1839 <= master_io_push_or_pull;
    _T_1841 <= master_io_push_or_pull;
    _T_1843 <= master_io_push_or_pull;
    _T_1845 <= master_io_push_or_pull;
    _T_1847 <= master_io_push_or_pull;
    _T_1849 <= master_io_push_or_pull;
    _T_1851 <= master_io_push_or_pull;
    _T_1853 <= master_io_push_or_pull;
    _T_1855 <= master_io_push_or_pull;
    _T_1857 <= master_io_push_or_pull;
    _T_1859 <= master_io_push_or_pull;
    _T_1861 <= master_io_push_or_pull;
    _T_1863 <= master_io_push_or_pull;
    _T_1865 <= master_io_push_or_pull;
    _T_1867 <= master_io_push_or_pull;
    _T_1869 <= master_io_push_or_pull;
    _T_1871 <= master_io_push_or_pull;
    _T_1873 <= master_io_push_or_pull;
    _T_1875 <= master_io_push_or_pull;
    _T_1877 <= master_io_push_or_pull;
    _T_1879 <= master_io_push_or_pull;
    _T_1881 <= master_io_push_or_pull;
    _T_1883 <= master_io_push_or_pull;
    _T_1885 <= master_io_push_or_pull;
    _T_1887 <= master_io_push_or_pull;
    _T_1889 <= master_io_push_or_pull;
    _T_1891 <= master_io_push_or_pull;
    _T_1893 <= master_io_push_or_pull;
    _T_1895 <= master_io_push_or_pull;
    _T_1897 <= master_io_push_or_pull;
    _T_1899 <= master_io_push_or_pull;
    _T_1901 <= master_io_push_or_pull;
    _T_1903 <= master_io_push_or_pull;
    _T_1905 <= master_io_push_or_pull;
    _T_1907 <= master_io_push_or_pull;
    _T_1909 <= master_io_push_or_pull;
    _T_1911 <= master_io_push_or_pull;
    _T_1913 <= master_io_push_or_pull;
    _T_1915 <= master_io_push_or_pull;
    _T_1917 <= master_io_push_or_pull;
    _T_1919 <= master_io_push_or_pull;
    _T_1921 <= master_io_push_or_pull;
    _T_1923 <= master_io_push_or_pull;
    _T_1925 <= master_io_push_or_pull;
  end
endmodule
